%------------------------------------------------------------------------------
% File     : VBT00011^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem Automation 00192_006240
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0027_Automation_00192_006240 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 6191 (1949 unt; 726 typ;   0 def)
%            Number of atoms       : 15972 (6451 equ;   7 cnn)
%            Maximal formula atoms :   28 (   2 avg)
%            Number of connectives : 105654 (1477   ~; 178   |;1035   &;95938   @)
%                                         (   0 <=>;7026  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   34 (   7 avg)
%            Number of types       :   11 (  10 usr)
%            Number of type conns  : 4545 (4545   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  720 ( 716 usr;  11 con; 0-8 aty)
%            Number of variables   : 19239 (1584   ^16510   !; 392   ?;19239   :)
%                                         ( 753  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 15:59:54.263
%------------------------------------------------------------------------------
% Could-be-implicit typings (22)
thf(ty_t_Heap__Time__Monad_OHeap,type,
    heap_Time_Heap: $tType > $tType ).

thf(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Heap_Oheap_Oheap__ext,type,
    heap_ext: $tType > $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Multiset_Omultiset,type,
    multiset: $tType > $tType ).

thf(ty_t_Typerep_Otyperep,type,
    typerep: $tType ).

thf(ty_t_Assertions_Oassn,type,
    assn: $tType ).

thf(ty_t_Predicate_Opred,type,
    pred: $tType > $tType ).

thf(ty_t_Predicate_Oseq,type,
    seq: $tType > $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Heap_Oarray,type,
    array: $tType > $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Heap_Oref,type,
    ref: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (704)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Heap_Oheap,type,
    heap: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Otimes,type,
    times: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Oinf,type,
    inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__lattice,type,
    finite_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Array__Time_Oalloc,type,
    array_alloc: 
      !>[A: $tType] : ( ( list @ A ) > ( heap_ext @ product_unit ) > ( product_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) ) ) ).

thf(sy_c_Array__Time_Ofreeze,type,
    array_freeze: 
      !>[A: $tType] : ( ( array @ A ) > ( heap_Time_Heap @ ( list @ A ) ) ) ).

thf(sy_c_Array__Time_Oget,type,
    array_get: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( array @ A ) > ( list @ A ) ) ).

thf(sy_c_Array__Time_Olen,type,
    array_len: 
      !>[A: $tType] : ( ( array @ A ) > ( heap_Time_Heap @ nat ) ) ).

thf(sy_c_Array__Time_Olength,type,
    array_length: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( array @ A ) > nat ) ).

thf(sy_c_Array__Time_Omake,type,
    array_make: 
      !>[A: $tType] : ( nat > ( nat > A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Onew,type,
    array_new: 
      !>[A: $tType] : ( nat > A > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Onth,type,
    array_nth: 
      !>[A: $tType] : ( ( array @ A ) > nat > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Array__Time_Oof__list,type,
    array_of_list: 
      !>[A: $tType] : ( ( list @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Opresent,type,
    array_present: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( array @ A ) > $o ) ).

thf(sy_c_Array__Time_Oset,type,
    array_set: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Array__Time_Oupd,type,
    array_upd: 
      !>[A: $tType] : ( nat > A > ( array @ A ) > ( heap_Time_Heap @ ( array @ A ) ) ) ).

thf(sy_c_Array__Time_Oupdate,type,
    array_update: 
      !>[A: $tType] : ( ( array @ A ) > nat > A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Assertions_Oassn_OAbs__assn,type,
    abs_assn: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > assn ).

thf(sy_c_Assertions_Oassn_ORep__assn,type,
    rep_assn: assn > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oentails,type,
    entails: assn > assn > $o ).

thf(sy_c_Assertions_Oentailst,type,
    entailst: assn > assn > $o ).

thf(sy_c_Assertions_Oex__assn,type,
    ex_assn: 
      !>[A: $tType] : ( ( A > assn ) > assn ) ).

thf(sy_c_Assertions_Oin__range,type,
    in_range: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oin__range__rel,type,
    in_range_rel: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Ois__pure__assn,type,
    is_pure_assn: assn > $o ).

thf(sy_c_Assertions_Oone__assn__raw,type,
    one_assn_raw: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oone__assn__raw__rel,type,
    one_assn_raw_rel: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Oprecise,type,
    precise: 
      !>[A: $tType,B: $tType] : ( ( A > B > assn ) > $o ) ).

thf(sy_c_Assertions_Oproper,type,
    proper: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > $o ).

thf(sy_c_Assertions_Opure__assn,type,
    pure_assn: $o > assn ).

thf(sy_c_Assertions_Opure__assn__raw,type,
    pure_assn_raw: 
      !>[A: $tType,B: $tType] : ( $o > ( product_prod @ A @ ( set @ B ) ) > $o ) ).

thf(sy_c_Assertions_Opure__assn__raw__rel,type,
    pure_assn_raw_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) > ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) > $o ) ).

thf(sy_c_Assertions_OrelH,type,
    relH: ( set @ nat ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > $o ).

thf(sy_c_Assertions_Osnga__assn,type,
    snga_assn: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > assn ) ).

thf(sy_c_Assertions_Osnga__assn__raw,type,
    snga_assn_raw: 
      !>[A: $tType] : ( ( array @ A ) > ( list @ A ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) ).

thf(sy_c_Assertions_Osnga__assn__raw__rel,type,
    snga_assn_raw_rel: 
      !>[A: $tType] : ( ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ) ).

thf(sy_c_Assertions_Osngr__assn,type,
    sngr_assn: 
      !>[A: $tType] : ( ( ref @ A ) > A > assn ) ).

thf(sy_c_Assertions_Osngr__assn__raw,type,
    sngr_assn_raw: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) ).

thf(sy_c_Assertions_Osngr__assn__raw__rel,type,
    sngr_assn_raw_rel: 
      !>[A: $tType] : ( ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ) ).

thf(sy_c_Assertions_Otimes__assn__raw,type,
    times_assn_raw: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Otimes__assn__raw__rel,type,
    times_assn_raw_rel: ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ).

thf(sy_c_Assertions_Owand__assn,type,
    wand_assn: assn > assn > assn ).

thf(sy_c_Assertions_Owand__raw,type,
    wand_raw: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ).

thf(sy_c_Assertions_Owand__raw__rel,type,
    wand_raw_rel: ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) > $o ).

thf(sy_c_Automation_OFI,type,
    fi: ( list @ ( product_prod @ assn @ assn ) ) > assn > assn > assn > assn > assn > $o ).

thf(sy_c_Automation_OFI__QUERY,type,
    fI_QUERY: assn > assn > assn > $o ).

thf(sy_c_Automation_OFI__RESULT,type,
    fI_RESULT: ( list @ ( product_prod @ assn @ assn ) ) > assn > assn > assn > $o ).

thf(sy_c_Automation_OSLN,type,
    sln: assn ).

thf(sy_c_BNF__Cardinal__Order__Relation_Ocard__of,type,
    bNF_Ca6860139660246222851ard_of: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_Ocard__order__on,type,
    bNF_Ca8970107618336181345der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_BNF__Def_OGrp,type,
    bNF_Grp: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > A > B > $o ) ).

thf(sy_c_BNF__Def_Oeq__onp,type,
    bNF_eq_onp: 
      !>[A: $tType] : ( ( A > $o ) > A > A > $o ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Def_Orel__set,type,
    bNF_rel_set: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OShift,type,
    bNF_Greatest_Shift: 
      !>[A: $tType] : ( ( set @ ( list @ A ) ) > A > ( set @ ( list @ A ) ) ) ).

thf(sy_c_BNF__Greatest__Fixpoint_OSucc,type,
    bNF_Greatest_Succ: 
      !>[A: $tType] : ( ( set @ ( list @ A ) ) > ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordIso,type,
    bNF_Wellorder_ordIso: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordLeq,type,
    bNF_Wellorder_ordLeq: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OordLess,type,
    bNF_We4044943003108391690rdLess: 
      !>[A: $tType,A2: $tType] : ( set @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A2 @ A2 ) ) ) ) ).

thf(sy_c_BNF__Wellorder__Embedding_Oembed,type,
    bNF_Wellorder_embed: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_OembedS,type,
    bNF_Wellorder_embedS: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_BNF__Wellorder__Embedding_Oiso,type,
    bNF_Wellorder_iso: 
      !>[A: $tType,A2: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A2 @ A2 ) ) > ( A > A2 ) > $o ) ).

thf(sy_c_Basic__BNFs_Opred__fun,type,
    basic_pred_fun: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Basic__BNFs_Opred__prod,type,
    basic_pred_prod: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( B > $o ) > ( product_prod @ A @ B ) > $o ) ).

thf(sy_c_Basic__BNFs_Orel__prod,type,
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( A > B > $o ) > ( C > D > $o ) > ( product_prod @ A @ C ) > ( product_prod @ B @ D ) > $o ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_OPos,type,
    code_Pos: num > code_integer ).

thf(sy_c_Code__Numeral_OSuc,type,
    code_Suc: code_natural > code_natural ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odup,type,
    code_dup: code_integer > code_integer ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__nat,type,
    code_integer_of_nat: nat > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

thf(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: int > code_integer > $o ).

thf(sy_c_Code__Numeral_Opcr__natural,type,
    code_pcr_natural: nat > code_natural > $o ).

thf(sy_c_Code__Numeral_Osub,type,
    code_sub: num > num > code_integer ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,
    condit8047198070973881523_above: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,
    condit8119078960628432327_below: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Equiv__Relations_Oequiv,type,
    equiv_equiv: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Equiv__Relations_Oquotient,type,
    equiv_quotient: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem,type,
    finite_comp_fun_idem: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( set @ A ) > A ) ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabel__semigroup,type,
    abel_semigroup: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Oabel__semigroup__axioms,type,
    abel_s757365448890700780axioms: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Ocomm__monoid__axioms,type,
    comm_monoid_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set,type,
    groups778175481326437816id_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set_OF,type,
    groups_comm_monoid_F: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__list,type,
    groups_monoid_list: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( ( A > $o ) > $o ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_Heap_Oaddr__of__array,type,
    addr_of_array: 
      !>[A: $tType] : ( ( array @ A ) > nat ) ).

thf(sy_c_Heap_Oaddr__of__ref,type,
    addr_of_ref: 
      !>[A: $tType] : ( ( ref @ A ) > nat ) ).

thf(sy_c_Heap_Oarray_OArray,type,
    array2: 
      !>[A: $tType] : ( nat > ( array @ A ) ) ).

thf(sy_c_Heap_Oheap_Oarrays,type,
    arrays: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > typerep > nat > ( list @ nat ) ) ).

thf(sy_c_Heap_Oheap_Olim,type,
    lim: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > nat ) ).

thf(sy_c_Heap_Oheap_Olim__update,type,
    lim_update: 
      !>[Z: $tType] : ( ( nat > nat ) > ( heap_ext @ Z ) > ( heap_ext @ Z ) ) ).

thf(sy_c_Heap_Oheap_Orefs,type,
    refs: 
      !>[Z: $tType] : ( ( heap_ext @ Z ) > typerep > nat > nat ) ).

thf(sy_c_Heap_Oref_ORef,type,
    ref2: 
      !>[A: $tType] : ( nat > ( ref @ A ) ) ).

thf(sy_c_Heap__Time__Monad_OHeap_OHeap,type,
    heap_Time_Heap2: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Oassert,type,
    heap_Time_assert: 
      !>[A: $tType] : ( ( A > $o ) > A > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Obind,type,
    heap_Time_bind: 
      !>[A: $tType,B: $tType] : ( ( heap_Time_Heap @ A ) > ( A > ( heap_Time_Heap @ B ) ) > ( heap_Time_Heap @ B ) ) ).

thf(sy_c_Heap__Time__Monad_Oeffect,type,
    heap_Time_effect: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) > A > nat > $o ) ).

thf(sy_c_Heap__Time__Monad_Oexecute,type,
    heap_Time_execute: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) ) ).

thf(sy_c_Heap__Time__Monad_Oguard,type,
    heap_Time_guard: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > $o ) > ( ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Oheap,type,
    heap_Time_heap: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Oreturn,type,
    heap_Time_return: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Osuccess,type,
    heap_Time_success: 
      !>[A: $tType] : ( ( heap_Time_Heap @ A ) > ( heap_ext @ product_unit ) > $o ) ).

thf(sy_c_Heap__Time__Monad_Otap,type,
    heap_Time_tap: 
      !>[A: $tType] : ( ( ( heap_ext @ product_unit ) > A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Heap__Time__Monad_Owait,type,
    heap_Time_wait: nat > ( heap_Time_Heap @ product_unit ) ).

thf(sy_c_Hoare__Triple_Ohoare__triple,type,
    hoare_hoare_triple: 
      !>[A: $tType] : ( assn > ( heap_Time_Heap @ A ) > ( A > assn ) > $o ) ).

thf(sy_c_Hoare__Triple_Onew__addrs,type,
    hoare_new_addrs: ( heap_ext @ product_unit ) > ( set @ nat ) > ( heap_ext @ product_unit ) > ( set @ nat ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_OPos,type,
    pos: num > int ).

thf(sy_c_Int_Odup,type,
    dup: int > int ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Int_Osub,type,
    sub: num > num > int ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice,type,
    semilattice: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__axioms,type,
    semilattice_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__order__axioms,type,
    semila6385135966242565138axioms: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_List_OBleast,type,
    bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_OListMem,type,
    listMem: 
      !>[A: $tType] : ( A > ( list @ A ) > $o ) ).

thf(sy_c_List_Oabort__Bleast,type,
    abort_Bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_Oall__interval__int,type,
    all_interval_int: ( int > $o ) > int > int > $o ).

thf(sy_c_List_Oall__interval__nat,type,
    all_interval_nat: ( nat > $o ) > nat > nat > $o ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( list @ A ) ) > ( product_prod @ ( A > B ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ocan__select,type,
    can_select: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odistinct__adj,type,
    distinct_adj: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofolding__insort__key__axioms,type,
    foldin3648464208017769352axioms: 
      !>[B: $tType,A: $tType] : ( ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( B > A > B ) > B > ( list @ A ) > B ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ogen__length,type,
    gen_length: 
      !>[A: $tType] : ( nat > ( list @ A ) > nat ) ).

thf(sy_c_List_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osort__key,type,
    linorder_sort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olinorder__class_Ostable__sort__key,type,
    linord3483353639454293061rt_key: 
      !>[B: $tType,A: $tType] : ( ( ( B > A ) > ( list @ B ) > ( list @ B ) ) > $o ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Olist__all,type,
    list_all: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( C > ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__ex,type,
    list_ex: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist__ex1,type,
    list_ex1: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Olistsp,type,
    listsp: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__project,type,
    map_project: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_List_Omap__tailrec,type,
    map_tailrec: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__tailrec__rev,type,
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Omap__tailrec__rev__rel,type,
    map_tailrec_rev_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) ).

thf(sy_c_List_Omaps,type,
    maps: 
      !>[A: $tType,B: $tType] : ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( ( list @ ( A > nat ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_List_Omember,type,
    member: 
      !>[A: $tType] : ( ( list @ A ) > A > $o ) ).

thf(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Onull,type,
    null: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Oord_Olexordp,type,
    lexordp2: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oord_Olexordp__eq,type,
    lexordp_eq: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oord__class_Olexordp__eq,type,
    ord_lexordp_eq: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Osuccessively,type,
    successively: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osuccessively__rel,type,
    successively_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Othose,type,
    those: 
      !>[A: $tType] : ( ( list @ ( option @ A ) ) > ( option @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__add,type,
    map_add: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( A > ( option @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Misc_Ofilter__rev,type,
    filter_rev: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Ofilter__rev__aux,type,
    filter_rev_aux: 
      !>[A: $tType] : ( ( list @ A ) > ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Olist__all__zip,type,
    list_all_zip: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_Misc_Olist__all__zip__rel,type,
    list_all_zip_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) ).

thf(sy_c_Misc_Olist__collect__set,type,
    list_collect_set: 
      !>[B: $tType,A: $tType] : ( ( B > ( set @ A ) ) > ( list @ B ) > ( set @ A ) ) ).

thf(sy_c_Misc_Omerge,type,
    merge: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omerge__list,type,
    merge_list: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omerge__list__rel,type,
    merge_list_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) > ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Omerge__rel,type,
    merge_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Omergesort__by__rel,type,
    mergesort_by_rel: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__merge,type,
    merges9089515139780605204_merge: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__merge__rel,type,
    merges2244889521215249637ge_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Omergesort__by__rel__rel,type,
    mergesort_by_rel_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Omergesort__by__rel__split,type,
    merges295452479951948502_split: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_Misc_Omergesort__by__rel__split__rel,type,
    merges7066485432131860899it_rel: 
      !>[A: $tType] : ( ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) > ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Omergesort__remdups,type,
    mergesort_remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Opartition__rev,type,
    partition_rev: 
      !>[A: $tType] : ( ( A > $o ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_Misc_Opartition__rev__rel,type,
    partition_rev_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) > ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Oquicksort__by__rel,type,
    quicksort_by_rel: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Oquicksort__by__rel__rel,type,
    quicksort_by_rel_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) > $o ) ).

thf(sy_c_Misc_Orel__restrict,type,
    rel_restrict: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Misc_Orevg,type,
    revg: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Orevg__rel,type,
    revg_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Misc_Oslice,type,
    slice: 
      !>[A: $tType] : ( nat > nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Misc_Ozipf,type,
    zipf: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( list @ A ) > ( list @ B ) > ( list @ C ) ) ).

thf(sy_c_Misc_Ozipf__rel,type,
    zipf_rel: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) ).

thf(sy_c_Multiset_Oadd__mset,type,
    add_mset: 
      !>[A: $tType] : ( A > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Ocomm__monoid__add__class_Osum__mset,type,
    comm_m7189776963980413722m_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ocomm__monoid__mset,type,
    comm_monoid_mset: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Multiset_Ocomm__monoid__mset_OF,type,
    comm_monoid_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ocomm__monoid__mult__class_Oprod__mset,type,
    comm_m9189036328036947845d_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > A ) ).

thf(sy_c_Multiset_Ofold__mset,type,
    fold_mset: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( multiset @ A ) > B ) ).

thf(sy_c_Multiset_Oimage__mset,type,
    image_mset: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( multiset @ A ) > ( multiset @ B ) ) ).

thf(sy_c_Multiset_Ointer__mset,type,
    inter_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Olinorder__class_Opart,type,
    linorder_part: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > ( product_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) ) ) ).

thf(sy_c_Multiset_Olinorder__class_Osorted__list__of__multiset,type,
    linord6283353356039996273ltiset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( list @ A ) ) ).

thf(sy_c_Multiset_Omset,type,
    mset: 
      !>[A: $tType] : ( ( list @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Omset__set,type,
    mset_set: 
      !>[B: $tType] : ( ( set @ B ) > ( multiset @ B ) ) ).

thf(sy_c_Multiset_Omultiset_Ocount,type,
    count: 
      !>[A: $tType] : ( ( multiset @ A ) > A > nat ) ).

thf(sy_c_Multiset_Opcr__multiset,type,
    pcr_multiset: 
      !>[C: $tType,B: $tType] : ( ( C > B > $o ) > ( C > nat ) > ( multiset @ B ) > $o ) ).

thf(sy_c_Multiset_Oreplicate__mset,type,
    replicate_mset: 
      !>[A: $tType] : ( nat > A > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Oset__mset,type,
    set_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( set @ A ) ) ).

thf(sy_c_Multiset_Osubset__eq__mset__impl,type,
    subset_eq_mset_impl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( option @ $o ) ) ).

thf(sy_c_Multiset_Osubset__eq__mset__impl__rel,type,
    subset751672762298770561pl_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_Multiset_Osubseteq__mset,type,
    subseteq_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > $o ) ).

thf(sy_c_Multiset_Ounion__mset,type,
    union_mset: 
      !>[A: $tType] : ( ( multiset @ A ) > ( multiset @ A ) > ( multiset @ A ) ) ).

thf(sy_c_Multiset_Owcount,type,
    wcount: 
      !>[A: $tType] : ( ( A > nat ) > ( multiset @ A ) > A > nat ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Onat__of__num,type,
    nat_of_num: num > nat ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Orel__option,type,
    rel_option: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( option @ A ) > ( option @ B ) > $o ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Order__Relation_OAboveS,type,
    order_AboveS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Oabove,type,
    order_above: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Olinear__order__on,type,
    order_679001287576687338der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Oofilter,type,
    order_ofilter: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) > $o ) ).

thf(sy_c_Order__Relation_Opartial__order__on,type,
    order_7125193373082350890der_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Opreorder__on,type,
    order_preorder_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Order__Relation_Ounder,type,
    order_under: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder_Omono,type,
    mono: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Partial__Function_Ofun__lub,type,
    partial_fun_lub: 
      !>[C: $tType,B: $tType,A: $tType] : ( ( ( set @ C ) > B ) > ( set @ ( A > C ) ) > A > B ) ).

thf(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) ).

thf(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( A > ( A > A > A ) > A > nat > A ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Predicate_OSeq,type,
    seq2: 
      !>[A: $tType] : ( ( product_unit > ( seq @ A ) ) > ( pred @ A ) ) ).

thf(sy_c_Predicate_Oiterate__upto,type,
    iterate_upto: 
      !>[A: $tType] : ( ( code_natural > A ) > code_natural > code_natural > ( pred @ A ) ) ).

thf(sy_c_Predicate_Oiterate__upto__rel,type,
    iterate_upto_rel: 
      !>[A: $tType] : ( ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) > ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) > $o ) ).

thf(sy_c_Predicate_Oseq_OEmpty,type,
    empty: 
      !>[A: $tType] : ( seq @ A ) ).

thf(sy_c_Predicate_Oseq_OInsert,type,
    insert2: 
      !>[A: $tType] : ( A > ( pred @ A ) > ( seq @ A ) ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_OUnity,type,
    product_Unity: product_unit ).

thf(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Quicksort_Olinorder__class_Oquicksort,type,
    linorder_quicksort: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_Quicksort_Olinorder__class_Oquicksort__rel,type,
    linord6200660962353139674rt_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_Random_Oinc__shift,type,
    inc_shift: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( code_natural > ( B > A > ( product_prod @ B @ A ) ) > B > A > ( product_prod @ B @ A ) ) ).

thf(sy_c_Random_Oiterate__rel,type,
    iterate_rel: 
      !>[B: $tType,A: $tType] : ( ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) > ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) > $o ) ).

thf(sy_c_Random_Olog,type,
    log: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Olog__rel,type,
    log_rel: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ code_natural ) > $o ).

thf(sy_c_Random_Ominus__shift,type,
    minus_shift: code_natural > code_natural > code_natural > code_natural ).

thf(sy_c_Random_Onext,type,
    next: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > code_natural > A ) ).

thf(sy_c_Random_Orange,type,
    range: code_natural > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Oselect,type,
    select: 
      !>[A: $tType] : ( ( list @ A ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Ref__Time_Oalloc,type,
    ref_alloc: 
      !>[A: $tType] : ( A > ( heap_ext @ product_unit ) > ( product_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) ) ) ).

thf(sy_c_Ref__Time_Oget,type,
    ref_get: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( ref @ A ) > A ) ).

thf(sy_c_Ref__Time_Olookup,type,
    ref_lookup: 
      !>[A: $tType] : ( ( ref @ A ) > ( heap_Time_Heap @ A ) ) ).

thf(sy_c_Ref__Time_Opresent,type,
    ref_present: 
      !>[A: $tType] : ( ( heap_ext @ product_unit ) > ( ref @ A ) > $o ) ).

thf(sy_c_Ref__Time_Oref,type,
    ref_ref: 
      !>[A: $tType] : ( A > ( heap_Time_Heap @ ( ref @ A ) ) ) ).

thf(sy_c_Ref__Time_Oset,type,
    ref_set: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( heap_ext @ product_unit ) > ( heap_ext @ product_unit ) ) ).

thf(sy_c_Ref__Time_Oupdate,type,
    ref_update: 
      !>[A: $tType] : ( ( ref @ A ) > A > ( heap_Time_Heap @ product_unit ) ) ).

thf(sy_c_Refine__Imp__Hol_Oassert_H,type,
    refine_Imp_assert: $o > ( heap_Time_Heap @ product_unit ) ).

thf(sy_c_Relation_ODomain,type,
    domain: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Relation_ODomainp,type,
    domainp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > A > $o ) ).

thf(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Relation_OId,type,
    id2: 
      !>[A: $tType] : ( set @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_OImage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Relation_ORange,type,
    range2: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Relation_ORangep,type,
    rangep: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > B > $o ) ).

thf(sy_c_Relation_Oantisym,type,
    antisym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oasym,type,
    asym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Oconverse,type,
    converse: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ A ) ) ) ).

thf(sy_c_Relation_Oconversep,type,
    conversep: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > B > A > $o ) ).

thf(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Relation_Orelcompp,type,
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) ).

thf(sy_c_Relation_Osingle__valued,type,
    single_valued: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > $o ) ).

thf(sy_c_Relation_Osym,type,
    sym: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Ototal__on,type,
    total_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Otrans,type,
    trans: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Set_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Oimage,type,
    image2: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert3: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Ois__empty,type,
    is_empty: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Set_Ois__singleton,type,
    is_singleton: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Syntax__Match_Oac__operator,type,
    syntax_ac_operator: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Syntax__Match_Osyntax__fo__nomatch,type,
    syntax7388354845996824322omatch: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_Syntax__Match_Osyntax__nomatch,type,
    syntax2379306206330768139omatch: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Obi__unique,type,
    bi_unique: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Oleft__unique,type,
    left_unique: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transfer_Oright__total,type,
    right_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Typedef_Otype__definition,type,
    type_definition: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Oless__than,type,
    less_than: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Wellfounded_OwfP,type,
    wfP: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_member,type,
    member2: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_F,type,
    f: assn ).

thf(sy_v_P,type,
    p: assn ).

thf(sy_v_Q,type,
    q: assn ).

% Relevant facts (4858)
thf(fact_0_assms,axiom,
    fi @ ( nil @ ( product_prod @ assn @ assn ) ) @ ( times_times @ assn @ sln @ p ) @ ( times_times @ assn @ sln @ q ) @ sln @ sln @ f ).

% assms
thf(fact_1_FI__QUERY__def,axiom,
    ( fI_QUERY
    = ( ^ [P: assn,Q: assn,F: assn] : ( entails @ P @ ( times_times @ assn @ Q @ F ) ) ) ) ).

% FI_QUERY_def
thf(fact_2_assn__aci_I10_J,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( ( times_times @ assn @ ( times_times @ assn @ A3 @ B2 ) @ C2 )
      = ( times_times @ assn @ ( times_times @ assn @ A3 @ C2 ) @ B2 ) ) ).

% assn_aci(10)
thf(fact_3_star__aci_I3_J,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( ( times_times @ assn @ A3 @ ( times_times @ assn @ B2 @ C2 ) )
      = ( times_times @ assn @ B2 @ ( times_times @ assn @ A3 @ C2 ) ) ) ).

% star_aci(3)
thf(fact_4_star__aci_I2_J,axiom,
    ( ( times_times @ assn )
    = ( ^ [A4: assn,B3: assn] : ( times_times @ assn @ B3 @ A4 ) ) ) ).

% star_aci(2)
thf(fact_5_SLN__left,axiom,
    ! [P2: assn] :
      ( ( times_times @ assn @ sln @ P2 )
      = P2 ) ).

% SLN_left
thf(fact_6_SLN__right,axiom,
    ! [P2: assn] :
      ( ( times_times @ assn @ P2 @ sln )
      = P2 ) ).

% SLN_right
thf(fact_7_is__entails,axiom,
    ! [P2: assn,Q2: assn] :
      ( ( entails @ P2 @ Q2 )
     => ( entails @ P2 @ Q2 ) ) ).

% is_entails
thf(fact_8_star__assoc,axiom,
    ! [A3: assn,B2: assn,C2: assn] :
      ( ( times_times @ assn @ ( times_times @ assn @ A3 @ B2 ) @ C2 )
      = ( times_times @ assn @ A3 @ ( times_times @ assn @ B2 @ C2 ) ) ) ).

% star_assoc
thf(fact_9_ent__star__mono,axiom,
    ! [P2: assn,P3: assn,Q2: assn,Q3: assn] :
      ( ( entails @ P2 @ P3 )
     => ( ( entails @ Q2 @ Q3 )
       => ( entails @ ( times_times @ assn @ P2 @ Q2 ) @ ( times_times @ assn @ P3 @ Q3 ) ) ) ) ).

% ent_star_mono
thf(fact_10_ent__iffI,axiom,
    ! [A5: assn,B4: assn] :
      ( ( entails @ A5 @ B4 )
     => ( ( entails @ B4 @ A5 )
       => ( A5 = B4 ) ) ) ).

% ent_iffI
thf(fact_11_ent__refl,axiom,
    ! [P2: assn] : ( entails @ P2 @ P2 ) ).

% ent_refl
thf(fact_12_ent__trans,axiom,
    ! [P2: assn,Q2: assn,R: assn] :
      ( ( entails @ P2 @ Q2 )
     => ( ( entails @ Q2 @ R )
       => ( entails @ P2 @ R ) ) ) ).

% ent_trans
thf(fact_13_assn__times__comm,axiom,
    ( ( times_times @ assn )
    = ( ^ [P: assn,Q: assn] : ( times_times @ assn @ Q @ P ) ) ) ).

% assn_times_comm
thf(fact_14_assn__times__assoc,axiom,
    ! [P2: assn,Q2: assn,R: assn] :
      ( ( times_times @ assn @ ( times_times @ assn @ P2 @ Q2 ) @ R )
      = ( times_times @ assn @ P2 @ ( times_times @ assn @ Q2 @ R ) ) ) ).

% assn_times_assoc
thf(fact_15_mult_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.right_assoc
thf(fact_16_mult_Oright__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% mult.right_commute
thf(fact_17_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_18_ab__semigroup__mult__class_Omult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ B3 @ A4 ) ) ) ) ).

% ab_semigroup_mult_class.mult.commute
thf(fact_19_ab__semigroup__mult__class_Omult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) )
          = ( times_times @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult.left_commute
thf(fact_20_ent__wandI,axiom,
    ! [Q2: assn,P2: assn,R: assn] :
      ( ( entails @ ( times_times @ assn @ Q2 @ P2 ) @ R )
     => ( entails @ P2 @ ( wand_assn @ Q2 @ R ) ) ) ).

% ent_wandI
thf(fact_21_ent__mp,axiom,
    ! [P2: assn,Q2: assn] : ( entails @ ( times_times @ assn @ P2 @ ( wand_assn @ P2 @ Q2 ) ) @ Q2 ) ).

% ent_mp
thf(fact_22_list__ex1__simps_I1_J,axiom,
    ! [A: $tType,P2: A > $o] :
      ~ ( list_ex1 @ A @ P2 @ ( nil @ A ) ) ).

% list_ex1_simps(1)
thf(fact_23_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_24_is__pure__assn__starI,axiom,
    ! [A3: assn,B2: assn] :
      ( ( is_pure_assn @ A3 )
     => ( ( is_pure_assn @ B2 )
       => ( is_pure_assn @ ( times_times @ assn @ A3 @ B2 ) ) ) ) ).

% is_pure_assn_starI
thf(fact_25_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) ).

% bind_simps(1)
thf(fact_26_member__rec_I2_J,axiom,
    ! [A: $tType,Y: A] :
      ~ ( member @ A @ ( nil @ A ) @ Y ) ).

% member_rec(2)
thf(fact_27_mult_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [X: A,Y: A,A3: A,B2: A] :
          ( ( syntax7388354845996824322omatch @ A @ A @ ( times_times @ A @ X @ Y ) @ A3 )
         => ( ( times_times @ A @ A3 @ B2 )
            = ( times_times @ A @ B2 @ A3 ) ) ) ) ).

% mult.safe_commute
thf(fact_28_assn__aci_I11_J,axiom,
    ! [X: assn,Y: assn,A3: assn,B2: assn] :
      ( ( syntax7388354845996824322omatch @ assn @ assn @ ( times_times @ assn @ X @ Y ) @ A3 )
     => ( ( times_times @ assn @ A3 @ B2 )
        = ( times_times @ assn @ B2 @ A3 ) ) ) ).

% assn_aci(11)
thf(fact_29_ent__pure__pre__iff,axiom,
    ! [P2: assn,B2: $o,Q2: assn] :
      ( ( entails @ ( times_times @ assn @ P2 @ ( pure_assn @ B2 ) ) @ Q2 )
      = ( B2
       => ( entails @ P2 @ Q2 ) ) ) ).

% ent_pure_pre_iff
thf(fact_30_gen__length__code_I1_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( gen_length @ A @ N @ ( nil @ A ) )
      = N ) ).

% gen_length_code(1)
thf(fact_31_maps__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( maps @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% maps_simps(2)
thf(fact_32_pure__assn__eq__conv,axiom,
    ! [P2: $o,Q2: $o] :
      ( ( ( pure_assn @ P2 )
        = ( pure_assn @ Q2 ) )
      = ( P2 = Q2 ) ) ).

% pure_assn_eq_conv
thf(fact_33_merge__pure__star,axiom,
    ! [A3: $o,B2: $o] :
      ( ( times_times @ assn @ ( pure_assn @ A3 ) @ ( pure_assn @ B2 ) )
      = ( pure_assn
        @ ( A3
          & B2 ) ) ) ).

% merge_pure_star
thf(fact_34_is__pure__assn__pure,axiom,
    ! [P2: $o] : ( is_pure_assn @ ( pure_assn @ P2 ) ) ).

% is_pure_assn_pure
thf(fact_35_is__pure__assn__def,axiom,
    ( is_pure_assn
    = ( ^ [A4: assn] :
        ? [P: $o] :
          ( A4
          = ( pure_assn @ P ) ) ) ) ).

% is_pure_assn_def
thf(fact_36_is__pure__assnE,axiom,
    ! [A3: assn] :
      ( ( is_pure_assn @ A3 )
     => ~ ! [P4: $o] :
            ( A3
           != ( pure_assn @ P4 ) ) ) ).

% is_pure_assnE
thf(fact_37_syntax__fo__nomatch__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( syntax7388354845996824322omatch @ A @ B )
      = ( ^ [Pat: A,Obj: B] : $true ) ) ).

% syntax_fo_nomatch_def
thf(fact_38_ent__pure__post__iff,axiom,
    ! [P2: assn,Q2: assn,B2: $o] :
      ( ( entails @ P2 @ ( times_times @ assn @ Q2 @ ( pure_assn @ B2 ) ) )
      = ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( rep_assn @ P2 @ H )
           => B2 )
        & ( entails @ P2 @ Q2 ) ) ) ).

% ent_pure_post_iff
thf(fact_39_ent__pure__pre__iff__sng,axiom,
    ! [B2: $o,Q2: assn] :
      ( ( entails @ ( pure_assn @ B2 ) @ Q2 )
      = ( B2
       => ( entails @ ( one_one @ assn ) @ Q2 ) ) ) ).

% ent_pure_pre_iff_sng
thf(fact_40_ac__operator_Osafe__commute,axiom,
    ! [A: $tType,F2: A > A > A,X: A,Y: A,A3: A,B2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( syntax7388354845996824322omatch @ A @ A @ ( F2 @ X @ Y ) @ A3 )
       => ( ( F2 @ A3 @ B2 )
          = ( F2 @ B2 @ A3 ) ) ) ) ).

% ac_operator.safe_commute
thf(fact_41_and__extract__pure__left__ctx__iff,axiom,
    ! [P2: assn,B2: $o,Q2: assn] :
      ( ( inf_inf @ assn @ ( times_times @ assn @ P2 @ ( pure_assn @ B2 ) ) @ Q2 )
      = ( times_times @ assn @ ( inf_inf @ assn @ P2 @ Q2 ) @ ( pure_assn @ B2 ) ) ) ).

% and_extract_pure_left_ctx_iff
thf(fact_42_and__extract__pure__right__ctx__iff,axiom,
    ! [P2: assn,Q2: assn,B2: $o] :
      ( ( inf_inf @ assn @ P2 @ ( times_times @ assn @ Q2 @ ( pure_assn @ B2 ) ) )
      = ( times_times @ assn @ ( inf_inf @ assn @ P2 @ Q2 ) @ ( pure_assn @ B2 ) ) ) ).

% and_extract_pure_right_ctx_iff
thf(fact_43_null__rec_I2_J,axiom,
    ! [B: $tType] : ( null @ B @ ( nil @ B ) ) ).

% null_rec(2)
thf(fact_44_mem__Collect__eq,axiom,
    ! [A: $tType,A3: A,P2: A > $o] :
      ( ( member2 @ A @ A3 @ ( collect @ A @ P2 ) )
      = ( P2 @ A3 ) ) ).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( collect @ A
        @ ^ [X2: A] : ( member2 @ A @ X2 @ A5 ) )
      = A5 ) ).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,
    ! [A: $tType,P2: A > $o,Q2: A > $o] :
      ( ! [X3: A] :
          ( ( P2 @ X3 )
          = ( Q2 @ X3 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q2 ) ) ) ).

% Collect_cong
thf(fact_47_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G @ X3 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_48_eq__Nil__null,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
      = ( null @ A @ Xs ) ) ).

% eq_Nil_null
thf(fact_49_zip__Nil,axiom,
    ! [B: $tType,A: $tType,Ys: list @ B] :
      ( ( zip @ A @ B @ ( nil @ A ) @ Ys )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip_Nil
thf(fact_50_Nil__eq__zip__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( nil @ ( product_prod @ A @ B ) )
        = ( zip @ A @ B @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% Nil_eq_zip_iff
thf(fact_51_zip__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( zip @ A @ B @ Xs @ Ys )
        = ( nil @ ( product_prod @ A @ B ) ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% zip_eq_Nil_iff
thf(fact_52_mod__pure__star__dist,axiom,
    ! [P2: assn,B2: $o,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P2 @ ( pure_assn @ B2 ) ) @ H2 )
      = ( ( rep_assn @ P2 @ H2 )
        & B2 ) ) ).

% mod_pure_star_dist
thf(fact_53_list__ex__simps_I2_J,axiom,
    ! [A: $tType,P2: A > $o] :
      ~ ( list_ex @ A @ P2 @ ( nil @ A ) ) ).

% list_ex_simps(2)
thf(fact_54_Rep__assn__inject,axiom,
    ! [X: assn,Y: assn] :
      ( ( ( rep_assn @ X )
        = ( rep_assn @ Y ) )
      = ( X = Y ) ) ).

% Rep_assn_inject
thf(fact_55_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A3 )
          = A3 ) ) ).

% mult_1
thf(fact_56_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% mult.right_neutral
thf(fact_57_merge__pure__and,axiom,
    ! [A3: $o,B2: $o] :
      ( ( inf_inf @ assn @ ( pure_assn @ A3 ) @ ( pure_assn @ B2 ) )
      = ( pure_assn
        @ ( A3
          & B2 ) ) ) ).

% merge_pure_and
thf(fact_58_pure__true,axiom,
    ( ( pure_assn @ $true )
    = ( one_one @ assn ) ) ).

% pure_true
thf(fact_59_pure__assn__eq__emp__iff,axiom,
    ! [P2: $o] :
      ( ( ( pure_assn @ P2 )
        = ( one_one @ assn ) )
      = P2 ) ).

% pure_assn_eq_emp_iff
thf(fact_60_ent__pure__post__iff__sng,axiom,
    ! [P2: assn,B2: $o] :
      ( ( entails @ P2 @ ( pure_assn @ B2 ) )
      = ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( rep_assn @ P2 @ H )
           => B2 )
        & ( entails @ P2 @ ( one_one @ assn ) ) ) ) ).

% ent_pure_post_iff_sng
thf(fact_61_and__extract__pure__right__iff,axiom,
    ! [P2: assn,B2: $o] :
      ( ( inf_inf @ assn @ P2 @ ( pure_assn @ B2 ) )
      = ( times_times @ assn @ ( inf_inf @ assn @ ( one_one @ assn ) @ P2 ) @ ( pure_assn @ B2 ) ) ) ).

% and_extract_pure_right_iff
thf(fact_62_and__extract__pure__left__iff,axiom,
    ! [B2: $o,Q2: assn] :
      ( ( inf_inf @ assn @ ( pure_assn @ B2 ) @ Q2 )
      = ( times_times @ assn @ ( inf_inf @ assn @ ( one_one @ assn ) @ Q2 ) @ ( pure_assn @ B2 ) ) ) ).

% and_extract_pure_left_iff
thf(fact_63_norm__assertion__simps_I14_J,axiom,
    ! [X: assn,Y: assn,Z2: assn] :
      ( ( inf_inf @ assn @ ( inf_inf @ assn @ X @ Y ) @ Z2 )
      = ( inf_inf @ assn @ X @ ( inf_inf @ assn @ Y @ Z2 ) ) ) ).

% norm_assertion_simps(14)
thf(fact_64_norm__assertion__simps_I31_J,axiom,
    ! [X: assn] :
      ( ( inf_inf @ assn @ X @ X )
      = X ) ).

% norm_assertion_simps(31)
thf(fact_65_assn__aci_I1_J,axiom,
    ( ( inf_inf @ assn )
    = ( ^ [X2: assn,Y2: assn] : ( inf_inf @ assn @ Y2 @ X2 ) ) ) ).

% assn_aci(1)
thf(fact_66_assn__aci_I3_J,axiom,
    ! [X: assn,Y: assn,Z2: assn] :
      ( ( inf_inf @ assn @ X @ ( inf_inf @ assn @ Y @ Z2 ) )
      = ( inf_inf @ assn @ Y @ ( inf_inf @ assn @ X @ Z2 ) ) ) ).

% assn_aci(3)
thf(fact_67_assn__aci_I4_J,axiom,
    ! [X: assn,Y: assn] :
      ( ( inf_inf @ assn @ X @ ( inf_inf @ assn @ X @ Y ) )
      = ( inf_inf @ assn @ X @ Y ) ) ).

% assn_aci(4)
thf(fact_68_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_69_mod__and__dist,axiom,
    ! [P2: assn,Q2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( inf_inf @ assn @ P2 @ Q2 ) @ H2 )
      = ( ( rep_assn @ P2 @ H2 )
        & ( rep_assn @ Q2 @ H2 ) ) ) ).

% mod_and_dist
thf(fact_70_ac__operator__def,axiom,
    ! [A: $tType] :
      ( ( syntax_ac_operator @ A )
      = ( ^ [F3: A > A > A] :
            ( ! [A4: A,B3: A,C3: A] :
                ( ( F3 @ ( F3 @ A4 @ B3 ) @ C3 )
                = ( F3 @ A4 @ ( F3 @ B3 @ C3 ) ) )
            & ! [A4: A,B3: A] :
                ( ( F3 @ A4 @ B3 )
                = ( F3 @ B3 @ A4 ) ) ) ) ) ).

% ac_operator_def
thf(fact_71_ac__operator_Oright__commute,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ ( F2 @ A3 @ B2 ) @ C2 )
        = ( F2 @ ( F2 @ A3 @ C2 ) @ B2 ) ) ) ).

% ac_operator.right_commute
thf(fact_72_ac__operator_Oleft__commute,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ A3 @ ( F2 @ B2 @ C2 ) )
        = ( F2 @ B2 @ ( F2 @ A3 @ C2 ) ) ) ) ).

% ac_operator.left_commute
thf(fact_73_ac__operator_Oright__assoc,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ ( F2 @ A3 @ B2 ) @ C2 )
        = ( F2 @ A3 @ ( F2 @ B2 @ C2 ) ) ) ) ).

% ac_operator.right_assoc
thf(fact_74_ac__operator_Oleft__assoc,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A,C2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ A3 @ ( F2 @ B2 @ C2 ) )
        = ( F2 @ ( F2 @ A3 @ B2 ) @ C2 ) ) ) ).

% ac_operator.left_assoc
thf(fact_75_ac__operator_Ocommute,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A] :
      ( ( syntax_ac_operator @ A @ F2 )
     => ( ( F2 @ A3 @ B2 )
        = ( F2 @ B2 @ A3 ) ) ) ).

% ac_operator.commute
thf(fact_76_ac__operator_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A6: A,B5: A,C4: A] :
          ( ( F2 @ ( F2 @ A6 @ B5 ) @ C4 )
          = ( F2 @ A6 @ ( F2 @ B5 @ C4 ) ) )
     => ( ! [A6: A,B5: A] :
            ( ( F2 @ A6 @ B5 )
            = ( F2 @ B5 @ A6 ) )
       => ( syntax_ac_operator @ A @ F2 ) ) ) ).

% ac_operator.intro
thf(fact_77_mod__starE,axiom,
    ! [A3: assn,B2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A3 @ B2 ) @ H2 )
     => ~ ( ? [X_1: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : ( rep_assn @ A3 @ X_1 )
         => ! [H_2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ~ ( rep_assn @ B2 @ H_2 ) ) ) ).

% mod_starE
thf(fact_78_mod__starD,axiom,
    ! [A5: assn,B4: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A5 @ B4 ) @ H2 )
     => ? [H1: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),H22: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ A5 @ H1 )
          & ( rep_assn @ B4 @ H22 ) ) ) ).

% mod_starD
thf(fact_79_entails__def,axiom,
    ( entails
    = ( ^ [P: assn,Q: assn] :
        ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P @ H )
         => ( rep_assn @ Q @ H ) ) ) ) ).

% entails_def
thf(fact_80_entailsI,axiom,
    ! [P2: assn,Q2: assn] :
      ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P2 @ H3 )
         => ( rep_assn @ Q2 @ H3 ) )
     => ( entails @ P2 @ Q2 ) ) ).

% entailsI
thf(fact_81_entailsD,axiom,
    ! [P2: assn,Q2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( entails @ P2 @ Q2 )
     => ( ( rep_assn @ P2 @ H2 )
       => ( rep_assn @ Q2 @ H2 ) ) ) ).

% entailsD
thf(fact_82_ent__fwd,axiom,
    ! [P2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Q2: assn] :
      ( ( rep_assn @ P2 @ H2 )
     => ( ( entails @ P2 @ Q2 )
       => ( rep_assn @ Q2 @ H2 ) ) ) ).

% ent_fwd
thf(fact_83_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% mult.comm_neutral
thf(fact_84_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A3 )
          = A3 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_85_ent__conjE2,axiom,
    ! [B4: assn,C5: assn,A5: assn] :
      ( ( entails @ B4 @ C5 )
     => ( entails @ ( inf_inf @ assn @ A5 @ B4 ) @ C5 ) ) ).

% ent_conjE2
thf(fact_86_ent__conjE1,axiom,
    ! [A5: assn,C5: assn,B4: assn] :
      ( ( entails @ A5 @ C5 )
     => ( entails @ ( inf_inf @ assn @ A5 @ B4 ) @ C5 ) ) ).

% ent_conjE1
thf(fact_87_ent__conjI,axiom,
    ! [A5: assn,B4: assn,C5: assn] :
      ( ( entails @ A5 @ B4 )
     => ( ( entails @ A5 @ C5 )
       => ( entails @ A5 @ ( inf_inf @ assn @ B4 @ C5 ) ) ) ) ).

% ent_conjI
thf(fact_88_assn__one__left,axiom,
    ! [P2: assn] :
      ( ( times_times @ assn @ ( one_one @ assn ) @ P2 )
      = P2 ) ).

% assn_one_left
thf(fact_89_norm__assertion__simps_I1_J,axiom,
    ! [A3: assn] :
      ( ( times_times @ assn @ ( one_one @ assn ) @ A3 )
      = A3 ) ).

% norm_assertion_simps(1)
thf(fact_90_norm__assertion__simps_I2_J,axiom,
    ! [A3: assn] :
      ( ( times_times @ assn @ A3 @ ( one_one @ assn ) )
      = A3 ) ).

% norm_assertion_simps(2)
thf(fact_91_is__pure__assn__basic__simps_I2_J,axiom,
    is_pure_assn @ ( one_one @ assn ) ).

% is_pure_assn_basic_simps(2)
thf(fact_92_SLN__def,axiom,
    ( sln
    = ( one_one @ assn ) ) ).

% SLN_def
thf(fact_93_mult_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( syntax_ac_operator @ A @ ( times_times @ A ) ) ) ).

% mult.ac_operator_axioms
thf(fact_94_zip_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A] :
      ( ( zip @ A @ B @ Xs @ ( nil @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip.simps(1)
thf(fact_95_inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( inf_inf @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% inf_apply
thf(fact_96_inf__right__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Y )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_right_idem
thf(fact_97_inf_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A3 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A3 @ B2 ) ) ) ).

% inf.right_idem
thf(fact_98_inf__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_left_idem
thf(fact_99_inf_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ A @ A3 @ ( inf_inf @ A @ A3 @ B2 ) )
          = ( inf_inf @ A @ A3 @ B2 ) ) ) ).

% inf.left_idem
thf(fact_100_inf__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) ).

% inf_idem
thf(fact_101_inf_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A] :
          ( ( inf_inf @ A @ A3 @ A3 )
          = A3 ) ) ).

% inf.idem
thf(fact_102_precise__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( precise @ A @ B )
      = ( ^ [R2: A > B > assn] :
          ! [A4: A,A7: A,H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),P5: B,F: assn,F4: assn] :
            ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R2 @ A4 @ P5 ) @ F ) @ ( times_times @ assn @ ( R2 @ A7 @ P5 ) @ F4 ) ) @ H )
           => ( A4 = A7 ) ) ) ) ).

% precise_def
thf(fact_103_preciseI,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn] :
      ( ! [A6: A,A8: A,H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),P6: B,F5: assn,F6: assn] :
          ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R @ A6 @ P6 ) @ F5 ) @ ( times_times @ assn @ ( R @ A8 @ P6 ) @ F6 ) ) @ H3 )
         => ( A6 = A8 ) )
     => ( precise @ A @ B @ R ) ) ).

% preciseI
thf(fact_104_preciseD,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,A3: A,P7: B,F7: assn,A9: A,F8: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( precise @ A @ B @ R )
     => ( ( rep_assn @ ( inf_inf @ assn @ ( times_times @ assn @ ( R @ A3 @ P7 ) @ F7 ) @ ( times_times @ assn @ ( R @ A9 @ P7 ) @ F8 ) ) @ H2 )
       => ( A3 = A9 ) ) ) ).

% preciseD
thf(fact_105_preciseD_H,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,A3: A,P7: B,F7: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),A9: A,F8: assn] :
      ( ( precise @ A @ B @ R )
     => ( ( rep_assn @ ( times_times @ assn @ ( R @ A3 @ P7 ) @ F7 ) @ H2 )
       => ( ( rep_assn @ ( times_times @ assn @ ( R @ A9 @ P7 ) @ F8 ) @ H2 )
         => ( A3 = A9 ) ) ) ) ).

% preciseD'
thf(fact_106_inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( inf_inf @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% inf_fun_def
thf(fact_107_inf__sup__aci_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_sup_aci(4)
thf(fact_108_inf__sup__aci_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% inf_sup_aci(3)
thf(fact_109_inf__sup__aci_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ).

% inf_sup_aci(2)
thf(fact_110_inf__sup__aci_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y2: A] : ( inf_inf @ A @ Y2 @ X2 ) ) ) ) ).

% inf_sup_aci(1)
thf(fact_111_inf_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 )
          = ( inf_inf @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.assoc
thf(fact_112_inf__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ).

% inf_assoc
thf(fact_113_inf_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [A4: A,B3: A] : ( inf_inf @ A @ B3 @ A4 ) ) ) ) ).

% inf.commute
thf(fact_114_inf__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y2: A] : ( inf_inf @ A @ Y2 @ X2 ) ) ) ) ).

% inf_commute
thf(fact_115_inf_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A3 @ C2 ) )
          = ( inf_inf @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.left_commute
thf(fact_116_inf__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% inf_left_commute
thf(fact_117_boolean__algebra__cancel_Oinf1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: A,K: A,A3: A,B2: A] :
          ( ( A5
            = ( inf_inf @ A @ K @ A3 ) )
         => ( ( inf_inf @ A @ A5 @ B2 )
            = ( inf_inf @ A @ K @ ( inf_inf @ A @ A3 @ B2 ) ) ) ) ) ).

% boolean_algebra_cancel.inf1
thf(fact_118_boolean__algebra__cancel_Oinf2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B4: A,K: A,B2: A,A3: A] :
          ( ( B4
            = ( inf_inf @ A @ K @ B2 ) )
         => ( ( inf_inf @ A @ A3 @ B4 )
            = ( inf_inf @ A @ K @ ( inf_inf @ A @ A3 @ B2 ) ) ) ) ) ).

% boolean_algebra_cancel.inf2
thf(fact_119_mult_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.monoid_axioms
thf(fact_120_ent__false__iff,axiom,
    ! [P2: assn] :
      ( ( entails @ P2 @ ( bot_bot @ assn ) )
      = ( ! [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ~ ( rep_assn @ P2 @ H ) ) ) ).

% ent_false_iff
thf(fact_121_mult_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( comm_monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.comm_monoid_axioms
thf(fact_122_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_123_splice__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% splice_Nil2
thf(fact_124_split__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( splice @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% split_Nil_iff
thf(fact_125_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_126_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( enumerate @ A @ N @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_127_mod__star__trueI,axiom,
    ! [P2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ P2 @ H2 )
     => ( rep_assn @ ( times_times @ assn @ P2 @ ( top_top @ assn ) ) @ H2 ) ) ).

% mod_star_trueI
thf(fact_128_mod__star__trueE,axiom,
    ! [P2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P2 @ ( top_top @ assn ) ) @ H2 )
     => ~ ! [H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ~ ( rep_assn @ P2 @ H4 ) ) ).

% mod_star_trueE
thf(fact_129_boolean__algebra_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_zero_right
thf(fact_130_boolean__algebra_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_zero_left
thf(fact_131_inf__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_right
thf(fact_132_inf__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_left
thf(fact_133_inf__top_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A] :
          ( ( inf_inf @ A @ A3 @ ( top_top @ A ) )
          = A3 ) ) ).

% inf_top.right_neutral
thf(fact_134_inf__top_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A,B2: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ A3 @ B2 ) )
          = ( ( A3
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.neutr_eq_iff
thf(fact_135_inf__top_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ A3 )
          = A3 ) ) ).

% inf_top.left_neutral
thf(fact_136_inf__top_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A3: A,B2: A] :
          ( ( ( inf_inf @ A @ A3 @ B2 )
            = ( top_top @ A ) )
          = ( ( A3
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.eq_neutr_iff
thf(fact_137_top__eq__inf__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ X @ Y ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% top_eq_inf_iff
thf(fact_138_inf__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% inf_eq_top_iff
thf(fact_139_inf__top__right,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% inf_top_right
thf(fact_140_inf__top__left,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% inf_top_left
thf(fact_141_merge__true__star,axiom,
    ( ( times_times @ assn @ ( top_top @ assn ) @ ( top_top @ assn ) )
    = ( top_top @ assn ) ) ).

% merge_true_star
thf(fact_142_star__false__right,axiom,
    ! [P2: assn] :
      ( ( times_times @ assn @ P2 @ ( bot_bot @ assn ) )
      = ( bot_bot @ assn ) ) ).

% star_false_right
thf(fact_143_star__false__left,axiom,
    ! [P2: assn] :
      ( ( times_times @ assn @ ( bot_bot @ assn ) @ P2 )
      = ( bot_bot @ assn ) ) ).

% star_false_left
thf(fact_144_pure__false,axiom,
    ( ( pure_assn @ $false )
    = ( bot_bot @ assn ) ) ).

% pure_false
thf(fact_145_pure__assn__eq__false__iff,axiom,
    ! [P2: $o] :
      ( ( ( pure_assn @ P2 )
        = ( bot_bot @ assn ) )
      = ( ~ P2 ) ) ).

% pure_assn_eq_false_iff
thf(fact_146_assn__basic__inequalities_I1_J,axiom,
    ( top_top @ assn )
 != ( one_one @ assn ) ).

% assn_basic_inequalities(1)
thf(fact_147_assn__basic__inequalities_I5_J,axiom,
    ( top_top @ assn )
 != ( bot_bot @ assn ) ).

% assn_basic_inequalities(5)
thf(fact_148_assn__basic__inequalities_I3_J,axiom,
    ( bot_bot @ assn )
 != ( one_one @ assn ) ).

% assn_basic_inequalities(3)
thf(fact_149_monoid_Oleft__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A3: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( ( F2 @ Z2 @ A3 )
        = A3 ) ) ).

% monoid.left_neutral
thf(fact_150_monoid_Oright__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A3: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( ( F2 @ A3 @ Z2 )
        = A3 ) ) ).

% monoid.right_neutral
thf(fact_151_comm__monoid_Ocomm__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,A3: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( ( F2 @ A3 @ Z2 )
        = A3 ) ) ).

% comm_monoid.comm_neutral
thf(fact_152_inf__top_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( comm_monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.comm_monoid_axioms
thf(fact_153_boolean__algebra_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% boolean_algebra.conj_one_right
thf(fact_154_inf__top_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.monoid_axioms
thf(fact_155_merge__true__star__ctx,axiom,
    ! [P2: assn] :
      ( ( times_times @ assn @ ( top_top @ assn ) @ ( times_times @ assn @ ( top_top @ assn ) @ P2 ) )
      = ( times_times @ assn @ ( top_top @ assn ) @ P2 ) ) ).

% merge_true_star_ctx
thf(fact_156_mod__false,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ~ ( rep_assn @ ( bot_bot @ assn ) @ H2 ) ).

% mod_false
thf(fact_157_ent__false,axiom,
    ! [P2: assn] : ( entails @ ( bot_bot @ assn ) @ P2 ) ).

% ent_false
thf(fact_158_ent__true,axiom,
    ! [P2: assn] : ( entails @ P2 @ ( top_top @ assn ) ) ).

% ent_true
thf(fact_159_norm__assertion__simps_I9_J,axiom,
    ! [X: assn] :
      ( ( inf_inf @ assn @ ( bot_bot @ assn ) @ X )
      = ( bot_bot @ assn ) ) ).

% norm_assertion_simps(9)
thf(fact_160_norm__assertion__simps_I10_J,axiom,
    ! [X: assn] :
      ( ( inf_inf @ assn @ X @ ( bot_bot @ assn ) )
      = ( bot_bot @ assn ) ) ).

% norm_assertion_simps(10)
thf(fact_161_norm__assertion__simps_I3_J,axiom,
    ! [X: assn] :
      ( ( inf_inf @ assn @ ( top_top @ assn ) @ X )
      = X ) ).

% norm_assertion_simps(3)
thf(fact_162_norm__assertion__simps_I4_J,axiom,
    ! [X: assn] :
      ( ( inf_inf @ assn @ X @ ( top_top @ assn ) )
      = X ) ).

% norm_assertion_simps(4)
thf(fact_163_is__pure__assn__basic__simps_I1_J,axiom,
    is_pure_assn @ ( bot_bot @ assn ) ).

% is_pure_assn_basic_simps(1)
thf(fact_164_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_165_splice_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( splice @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% splice.simps(1)
thf(fact_166_sngr__same__false,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P7: ref @ A,X: A,Y: A] :
          ( ( times_times @ assn @ ( sngr_assn @ A @ P7 @ X ) @ ( sngr_assn @ A @ P7 @ Y ) )
          = ( bot_bot @ assn ) ) ) ).

% sngr_same_false
thf(fact_167_snga__same__false,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P7: array @ A,X: list @ A,Y: list @ A] :
          ( ( times_times @ assn @ ( snga_assn @ A @ P7 @ X ) @ ( snga_assn @ A @ P7 @ Y ) )
          = ( bot_bot @ assn ) ) ) ).

% snga_same_false
thf(fact_168_entt__def__true,axiom,
    ( entailst
    = ( ^ [P: assn,Q: assn] : ( entails @ ( times_times @ assn @ P @ ( top_top @ assn ) ) @ ( times_times @ assn @ Q @ ( top_top @ assn ) ) ) ) ) ).

% entt_def_true
thf(fact_169_entailst__def,axiom,
    ( entailst
    = ( ^ [A10: assn,B6: assn] : ( entails @ A10 @ ( times_times @ assn @ B6 @ ( top_top @ assn ) ) ) ) ) ).

% entailst_def
thf(fact_170_enttI__true,axiom,
    ! [P2: assn,Q2: assn] :
      ( ( entails @ ( times_times @ assn @ P2 @ ( top_top @ assn ) ) @ ( times_times @ assn @ Q2 @ ( top_top @ assn ) ) )
     => ( entailst @ P2 @ Q2 ) ) ).

% enttI_true
thf(fact_171_enttI,axiom,
    ! [A5: assn,B4: assn] :
      ( ( entails @ A5 @ ( times_times @ assn @ B4 @ ( top_top @ assn ) ) )
     => ( entailst @ A5 @ B4 ) ) ).

% enttI
thf(fact_172_enttD,axiom,
    ! [A5: assn,B4: assn] :
      ( ( entailst @ A5 @ B4 )
     => ( entails @ A5 @ ( times_times @ assn @ B4 @ ( top_top @ assn ) ) ) ) ).

% enttD
thf(fact_173_entt__star__true__simp_I2_J,axiom,
    ! [A5: assn,B4: assn] :
      ( ( entailst @ ( times_times @ assn @ A5 @ ( top_top @ assn ) ) @ B4 )
      = ( entailst @ A5 @ B4 ) ) ).

% entt_star_true_simp(2)
thf(fact_174_entt__star__true__simp_I1_J,axiom,
    ! [A5: assn,B4: assn] :
      ( ( entailst @ A5 @ ( times_times @ assn @ B4 @ ( top_top @ assn ) ) )
      = ( entailst @ A5 @ B4 ) ) ).

% entt_star_true_simp(1)
thf(fact_175_monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( monoid_axioms @ A @ F2 @ Z2 ) ) ).

% monoid.axioms(2)
thf(fact_176_comm__monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( comm_monoid_axioms @ A @ F2 @ Z2 ) ) ).

% comm_monoid.axioms(2)
thf(fact_177_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semilattice_neutr @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.semilattice_neutr_axioms
thf(fact_178_entt__refl,axiom,
    ! [A5: assn] : ( entailst @ A5 @ A5 ) ).

% entt_refl
thf(fact_179_entt__true,axiom,
    ! [A5: assn] : ( entailst @ A5 @ ( top_top @ assn ) ) ).

% entt_true
thf(fact_180_entt__emp,axiom,
    ! [A5: assn] : ( entailst @ A5 @ ( one_one @ assn ) ) ).

% entt_emp
thf(fact_181_entt__trans,axiom,
    ! [A5: assn,B4: assn,C5: assn] :
      ( ( entailst @ A5 @ B4 )
     => ( ( entailst @ B4 @ C5 )
       => ( entailst @ A5 @ C5 ) ) ) ).

% entt_trans
thf(fact_182_monoid__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ! [A6: A] :
          ( ( F2 @ Z2 @ A6 )
          = A6 )
     => ( ! [A6: A] :
            ( ( F2 @ A6 @ Z2 )
            = A6 )
       => ( monoid_axioms @ A @ F2 @ Z2 ) ) ) ).

% monoid_axioms.intro
thf(fact_183_comm__monoid__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ! [A6: A] :
          ( ( F2 @ A6 @ Z2 )
          = A6 )
     => ( comm_monoid_axioms @ A @ F2 @ Z2 ) ) ).

% comm_monoid_axioms.intro
thf(fact_184_monoid__axioms__def,axiom,
    ! [A: $tType] :
      ( ( monoid_axioms @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ! [A4: A] :
                ( ( F3 @ Z3 @ A4 )
                = A4 )
            & ! [A4: A] :
                ( ( F3 @ A4 @ Z3 )
                = A4 ) ) ) ) ).

% monoid_axioms_def
thf(fact_185_comm__monoid__axioms__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_axioms @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
          ! [A4: A] :
            ( ( F3 @ A4 @ Z3 )
            = A4 ) ) ) ).

% comm_monoid_axioms_def
thf(fact_186_entt__frame__fwd,axiom,
    ! [P2: assn,Q2: assn,A5: assn,F7: assn,B4: assn] :
      ( ( entailst @ P2 @ Q2 )
     => ( ( entailst @ A5 @ ( times_times @ assn @ P2 @ F7 ) )
       => ( ( entailst @ ( times_times @ assn @ Q2 @ F7 ) @ B4 )
         => ( entailst @ A5 @ B4 ) ) ) ) ).

% entt_frame_fwd
thf(fact_187_entt__star__mono,axiom,
    ! [A5: assn,B4: assn,C5: assn,D2: assn] :
      ( ( entailst @ A5 @ B4 )
     => ( ( entailst @ C5 @ D2 )
       => ( entailst @ ( times_times @ assn @ A5 @ C5 ) @ ( times_times @ assn @ B4 @ D2 ) ) ) ) ).

% entt_star_mono
thf(fact_188_ent__imp__entt,axiom,
    ! [P2: assn,Q2: assn] :
      ( ( entails @ P2 @ Q2 )
     => ( entailst @ P2 @ Q2 ) ) ).

% ent_imp_entt
thf(fact_189_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semilattice_neutr @ A @ F2 @ Z2 )
     => ( comm_monoid @ A @ F2 @ Z2 ) ) ).

% semilattice_neutr.axioms(2)
thf(fact_190_monoid__def,axiom,
    ! [A: $tType] :
      ( ( monoid @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( semigroup @ A @ F3 )
            & ( monoid_axioms @ A @ F3 @ Z3 ) ) ) ) ).

% monoid_def
thf(fact_191_monoid_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semigroup @ A @ F2 )
     => ( ( monoid_axioms @ A @ F2 @ Z2 )
       => ( monoid @ A @ F2 @ Z2 ) ) ) ).

% monoid.intro
thf(fact_192_comm__monoid__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( abel_semigroup @ A @ F3 )
            & ( comm_monoid_axioms @ A @ F3 @ Z3 ) ) ) ) ).

% comm_monoid_def
thf(fact_193_comm__monoid_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( comm_monoid_axioms @ A @ F2 @ Z2 )
       => ( comm_monoid @ A @ F2 @ Z2 ) ) ) ).

% comm_monoid.intro
thf(fact_194_semilattice__neutr__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_neutr @ A )
      = ( ^ [F3: A > A > A,Z3: A] :
            ( ( semilattice @ A @ F3 )
            & ( comm_monoid @ A @ F3 @ Z3 ) ) ) ) ).

% semilattice_neutr_def
thf(fact_195_semilattice__neutr_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( comm_monoid @ A @ F2 @ Z2 )
       => ( semilattice_neutr @ A @ F2 @ Z2 ) ) ) ).

% semilattice_neutr.intro
thf(fact_196_mod__h__bot__iff_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P7: ref @ A,X: A,H2: heap_ext @ product_unit] :
          ~ ( rep_assn @ ( sngr_assn @ A @ P7 @ X ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_iff(3)
thf(fact_197_mod__true,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( top_top @ assn ) @ H2 )
      = ( in_range @ H2 ) ) ).

% mod_true
thf(fact_198_mod__h__bot__iff_I4_J,axiom,
    ! [B: $tType] :
      ( ( heap @ B )
     => ! [Q4: array @ B,Y: list @ B,H2: heap_ext @ product_unit] :
          ~ ( rep_assn @ ( snga_assn @ B @ Q4 @ Y ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_iff(4)
thf(fact_199_mod__h__bot__iff_I6_J,axiom,
    ! [P2: assn,Q2: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( inf_inf @ assn @ P2 @ Q2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        & ( rep_assn @ Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(6)
thf(fact_200_mod__h__bot__iff_I1_J,axiom,
    ! [B2: $o,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( pure_assn @ B2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = B2 ) ).

% mod_h_bot_iff(1)
thf(fact_201_in__range__empty,axiom,
    ! [H2: heap_ext @ product_unit] : ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% in_range_empty
thf(fact_202_mod__h__bot__iff_I5_J,axiom,
    ! [P2: assn,Q2: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( times_times @ assn @ P2 @ Q2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        & ( rep_assn @ Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(5)
thf(fact_203_semilattice_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semilattice @ A @ F2 )
     => ( abel_semigroup @ A @ F2 ) ) ).

% semilattice.axioms(1)
thf(fact_204_semilattice_Oidem,axiom,
    ! [A: $tType,F2: A > A > A,A3: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( F2 @ A3 @ A3 )
        = A3 ) ) ).

% semilattice.idem
thf(fact_205_semilattice_Oleft__idem,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( F2 @ A3 @ ( F2 @ A3 @ B2 ) )
        = ( F2 @ A3 @ B2 ) ) ) ).

% semilattice.left_idem
thf(fact_206_semilattice_Oright__idem,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A] :
      ( ( semilattice @ A @ F2 )
     => ( ( F2 @ ( F2 @ A3 @ B2 ) @ B2 )
        = ( F2 @ A3 @ B2 ) ) ) ).

% semilattice.right_idem
thf(fact_207_abel__semigroup_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( semigroup @ A @ F2 ) ) ).

% abel_semigroup.axioms(1)
thf(fact_208_semigroup_Oassoc,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A,C2: A] :
      ( ( semigroup @ A @ F2 )
     => ( ( F2 @ ( F2 @ A3 @ B2 ) @ C2 )
        = ( F2 @ A3 @ ( F2 @ B2 @ C2 ) ) ) ) ).

% semigroup.assoc
thf(fact_209_semigroup_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A6: A,B5: A,C4: A] :
          ( ( F2 @ ( F2 @ A6 @ B5 ) @ C4 )
          = ( F2 @ A6 @ ( F2 @ B5 @ C4 ) ) )
     => ( semigroup @ A @ F2 ) ) ).

% semigroup.intro
thf(fact_210_one__assn__raw_Ocases,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
          ( X
         != ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ).

% one_assn_raw.cases
thf(fact_211_abel__semigroup_Ocommute,axiom,
    ! [A: $tType,F2: A > A > A,A3: A,B2: A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( F2 @ A3 @ B2 )
        = ( F2 @ B2 @ A3 ) ) ) ).

% abel_semigroup.commute
thf(fact_212_abel__semigroup_Oleft__commute,axiom,
    ! [A: $tType,F2: A > A > A,B2: A,A3: A,C2: A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( F2 @ B2 @ ( F2 @ A3 @ C2 ) )
        = ( F2 @ A3 @ ( F2 @ B2 @ C2 ) ) ) ) ).

% abel_semigroup.left_commute
thf(fact_213_semigroup__def,axiom,
    ! [A: $tType] :
      ( ( semigroup @ A )
      = ( ^ [F3: A > A > A] :
          ! [A4: A,B3: A,C3: A] :
            ( ( F3 @ ( F3 @ A4 @ B3 ) @ C3 )
            = ( F3 @ A4 @ ( F3 @ B3 @ C3 ) ) ) ) ) ).

% semigroup_def
thf(fact_214_mod__h__bot__indep,axiom,
    ! [P2: assn,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mod_h_bot_indep
thf(fact_215_mult_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( abel_semigroup @ A @ ( times_times @ A ) ) ) ).

% mult.abel_semigroup_axioms
thf(fact_216_models__in__range,axiom,
    ! [P2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ P2 @ H2 )
     => ( in_range @ H2 ) ) ).

% models_in_range
thf(fact_217_inf_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( abel_semigroup @ A @ ( inf_inf @ A ) ) ) ).

% inf.abel_semigroup_axioms
thf(fact_218_mult_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ( semigroup @ A @ ( times_times @ A ) ) ) ).

% mult.semigroup_axioms
thf(fact_219_inf_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semilattice @ A @ ( inf_inf @ A ) ) ) ).

% inf.semilattice_axioms
thf(fact_220_inf_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semigroup @ A @ ( inf_inf @ A ) ) ) ).

% inf.semigroup_axioms
thf(fact_221_comm__monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( comm_monoid @ A @ F2 @ Z2 )
     => ( abel_semigroup @ A @ F2 ) ) ).

% comm_monoid.axioms(1)
thf(fact_222_monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( monoid @ A @ F2 @ Z2 )
     => ( semigroup @ A @ F2 ) ) ).

% monoid.axioms(1)
thf(fact_223_semilattice__neutr_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( semilattice_neutr @ A @ F2 @ Z2 )
     => ( semilattice @ A @ F2 ) ) ).

% semilattice_neutr.axioms(1)
thf(fact_224_mod__h__bot__iff_I2_J,axiom,
    ! [H2: heap_ext @ product_unit] : ( rep_assn @ ( top_top @ assn ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_h_bot_iff(2)
thf(fact_225_mod__emp__simp,axiom,
    ! [H2: heap_ext @ product_unit] : ( rep_assn @ ( one_one @ assn ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_emp_simp
thf(fact_226_abel__semigroup_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semigroup @ A @ F2 )
     => ( ( abel_s757365448890700780axioms @ A @ F2 )
       => ( abel_semigroup @ A @ F2 ) ) ) ).

% abel_semigroup.intro
thf(fact_227_abel__semigroup__def,axiom,
    ! [A: $tType] :
      ( ( abel_semigroup @ A )
      = ( ^ [F3: A > A > A] :
            ( ( semigroup @ A @ F3 )
            & ( abel_s757365448890700780axioms @ A @ F3 ) ) ) ) ).

% abel_semigroup_def
thf(fact_228_semilattice_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( ( semilattice_axioms @ A @ F2 )
       => ( semilattice @ A @ F2 ) ) ) ).

% semilattice.intro
thf(fact_229_semilattice__def,axiom,
    ! [A: $tType] :
      ( ( semilattice @ A )
      = ( ^ [F3: A > A > A] :
            ( ( abel_semigroup @ A @ F3 )
            & ( semilattice_axioms @ A @ F3 ) ) ) ) ).

% semilattice_def
thf(fact_230_pure__assn__raw_Oelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ~ ( pure_assn_raw @ A @ B @ X @ Xa )
     => ~ ! [H3: A,As: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) )
           => ( ( As
                = ( bot_bot @ ( set @ B ) ) )
              & X ) ) ) ).

% pure_assn_raw.elims(3)
thf(fact_231_pure__assn__raw_Oelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ( pure_assn_raw @ A @ B @ X @ Xa )
     => ~ ! [H3: A,As: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) )
           => ~ ( ( As
                  = ( bot_bot @ ( set @ B ) ) )
                & X ) ) ) ).

% pure_assn_raw.elims(2)
thf(fact_232_pure__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: $o,Xa: product_prod @ A @ ( set @ B ),Y: $o] :
      ( ( ( pure_assn_raw @ A @ B @ X @ Xa )
        = Y )
     => ~ ! [H3: A,As: set @ B] :
            ( ( Xa
              = ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) )
           => ( Y
              = ( ~ ( ( As
                      = ( bot_bot @ ( set @ B ) ) )
                    & X ) ) ) ) ) ).

% pure_assn_raw.elims(1)
thf(fact_233_pure__assn__raw_Osimps,axiom,
    ! [A: $tType,B: $tType,B2: $o,H2: A,As2: set @ B] :
      ( ( pure_assn_raw @ A @ B @ B2 @ ( product_Pair @ A @ ( set @ B ) @ H2 @ As2 ) )
      = ( ( As2
          = ( bot_bot @ ( set @ B ) ) )
        & B2 ) ) ).

% pure_assn_raw.simps
thf(fact_234_mod__star__conv,axiom,
    ! [A5: assn,B4: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ A5 @ B4 ) @ H2 )
      = ( ? [Hr: heap_ext @ product_unit,As1: set @ nat,As22: set @ nat] :
            ( ( H2
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) ) )
            & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
              = ( bot_bot @ ( set @ nat ) ) )
            & ( rep_assn @ A5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ As1 ) )
            & ( rep_assn @ B4 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ Hr @ As22 ) ) ) ) ) ).

% mod_star_conv
thf(fact_235_star__assnI,axiom,
    ! [P2: assn,H2: heap_ext @ product_unit,As2: set @ nat,Q2: assn,As3: set @ nat] :
      ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
     => ( ( rep_assn @ Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) )
       => ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As3 )
            = ( bot_bot @ ( set @ nat ) ) )
         => ( rep_assn @ ( times_times @ assn @ P2 @ Q2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( sup_sup @ ( set @ nat ) @ As2 @ As3 ) ) ) ) ) ) ).

% star_assnI
thf(fact_236_one__assn__raw_Oelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( one_assn_raw @ X )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( As
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% one_assn_raw.elims(3)
thf(fact_237_sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( sup_sup @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% sup_apply
thf(fact_238_sup_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A3 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.right_idem
thf(fact_239_sup__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_left_idem
thf(fact_240_sup_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( sup_sup @ A @ A3 @ ( sup_sup @ A @ A3 @ B2 ) )
          = ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.left_idem
thf(fact_241_sup__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) ).

% sup_idem
thf(fact_242_sup_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A] :
          ( ( sup_sup @ A @ A3 @ A3 )
          = A3 ) ) ).

% sup.idem
thf(fact_243_sup__bot_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A] :
          ( ( sup_sup @ A @ A3 @ ( bot_bot @ A ) )
          = A3 ) ) ).

% sup_bot.right_neutral
thf(fact_244_sup__bot_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ A3 @ B2 ) )
          = ( ( A3
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.neutr_eq_iff
thf(fact_245_sup__bot_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A3 )
          = A3 ) ) ).

% sup_bot.left_neutral
thf(fact_246_sup__bot_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A3: A,B2: A] :
          ( ( ( sup_sup @ A @ A3 @ B2 )
            = ( bot_bot @ A ) )
          = ( ( A3
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.eq_neutr_iff
thf(fact_247_sup__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_eq_bot_iff
thf(fact_248_bot__eq__sup__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% bot_eq_sup_iff
thf(fact_249_sup__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% sup_bot_right
thf(fact_250_sup__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% sup_bot_left
thf(fact_251_sup__top__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% sup_top_right
thf(fact_252_sup__top__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% sup_top_left
thf(fact_253_inf__sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) ).

% inf_sup_absorb
thf(fact_254_sup__inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) ).

% sup_inf_absorb
thf(fact_255_in__range__dist__union,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat,As3: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( sup_sup @ ( set @ nat ) @ As2 @ As3 ) ) )
      = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
        & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) ) ) ) ).

% in_range_dist_union
thf(fact_256_sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( sup_sup @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% sup_fun_def
thf(fact_257_sup__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% sup_left_commute
thf(fact_258_sup_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( sup_sup @ A @ B2 @ ( sup_sup @ A @ A3 @ C2 ) )
          = ( sup_sup @ A @ A3 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.left_commute
thf(fact_259_sup__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y2: A] : ( sup_sup @ A @ Y2 @ X2 ) ) ) ) ).

% sup_commute
thf(fact_260_sup_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [A4: A,B3: A] : ( sup_sup @ A @ B3 @ A4 ) ) ) ) ).

% sup.commute
thf(fact_261_sup__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% sup_assoc
thf(fact_262_sup_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A3 @ B2 ) @ C2 )
          = ( sup_sup @ A @ A3 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.assoc
thf(fact_263_inf__sup__aci_I5_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y2: A] : ( sup_sup @ A @ Y2 @ X2 ) ) ) ) ).

% inf_sup_aci(5)
thf(fact_264_inf__sup__aci_I6_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% inf_sup_aci(6)
thf(fact_265_inf__sup__aci_I7_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% inf_sup_aci(7)
thf(fact_266_inf__sup__aci_I8_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_aci(8)
thf(fact_267_semilattice__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A6: A] :
          ( ( F2 @ A6 @ A6 )
          = A6 )
     => ( semilattice_axioms @ A @ F2 ) ) ).

% semilattice_axioms.intro
thf(fact_268_semilattice__axioms__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_axioms @ A )
      = ( ^ [F3: A > A > A] :
          ! [A4: A] :
            ( ( F3 @ A4 @ A4 )
            = A4 ) ) ) ).

% semilattice_axioms_def
thf(fact_269_abel__semigroup__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A6: A,B5: A] :
          ( ( F2 @ A6 @ B5 )
          = ( F2 @ B5 @ A6 ) )
     => ( abel_s757365448890700780axioms @ A @ F2 ) ) ).

% abel_semigroup_axioms.intro
thf(fact_270_abel__semigroup__axioms__def,axiom,
    ! [A: $tType] :
      ( ( abel_s757365448890700780axioms @ A )
      = ( ^ [F3: A > A > A] :
          ! [A4: A,B3: A] :
            ( ( F3 @ A4 @ B3 )
            = ( F3 @ B3 @ A4 ) ) ) ) ).

% abel_semigroup_axioms_def
thf(fact_271_distrib__imp1,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ! [X3: A,Y3: A,Z4: A] :
              ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y3 @ Z4 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y3 ) @ ( inf_inf @ A @ X3 @ Z4 ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ) ).

% distrib_imp1
thf(fact_272_distrib__imp2,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ! [X3: A,Y3: A,Z4: A] :
              ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y3 @ Z4 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y3 ) @ ( sup_sup @ A @ X3 @ Z4 ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ) ).

% distrib_imp2
thf(fact_273_inf__sup__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% inf_sup_distrib1
thf(fact_274_inf__sup__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z2 @ X ) ) ) ) ).

% inf_sup_distrib2
thf(fact_275_sup__inf__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% sup_inf_distrib1
thf(fact_276_sup__inf__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z2 ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z2 @ X ) ) ) ) ).

% sup_inf_distrib2
thf(fact_277_boolean__algebra_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) ) ) ).

% boolean_algebra.conj_disj_distrib
thf(fact_278_boolean__algebra_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% boolean_algebra.disj_conj_distrib
thf(fact_279_boolean__algebra_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z2 @ X ) ) ) ) ).

% boolean_algebra.conj_disj_distrib2
thf(fact_280_boolean__algebra_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z2 ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z2 @ X ) ) ) ) ).

% boolean_algebra.disj_conj_distrib2
thf(fact_281_sup_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( abel_semigroup @ A @ ( sup_sup @ A ) ) ) ).

% sup.abel_semigroup_axioms
thf(fact_282_sup_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semilattice @ A @ ( sup_sup @ A ) ) ) ).

% sup.semilattice_axioms
thf(fact_283_sup_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semigroup @ A @ ( sup_sup @ A ) ) ) ).

% sup.semigroup_axioms
thf(fact_284_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( comm_monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.comm_monoid_axioms
thf(fact_285_sup__bot_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.monoid_axioms
thf(fact_286_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semilattice_neutr @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.semilattice_neutr_axioms
thf(fact_287_boolean__algebra_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [A3: A,X: A,Y: A] :
          ( ( ( inf_inf @ A @ A3 @ X )
            = ( bot_bot @ A ) )
         => ( ( ( sup_sup @ A @ A3 @ X )
              = ( top_top @ A ) )
           => ( ( ( inf_inf @ A @ A3 @ Y )
                = ( bot_bot @ A ) )
             => ( ( ( sup_sup @ A @ A3 @ Y )
                  = ( top_top @ A ) )
               => ( X = Y ) ) ) ) ) ) ).

% boolean_algebra.complement_unique
thf(fact_288_abel__semigroup_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( abel_semigroup @ A @ F2 )
     => ( abel_s757365448890700780axioms @ A @ F2 ) ) ).

% abel_semigroup.axioms(2)
thf(fact_289_semilattice_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semilattice @ A @ F2 )
     => ( semilattice_axioms @ A @ F2 ) ) ).

% semilattice.axioms(2)
thf(fact_290_one__assn__raw_Osimps,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( one_assn_raw @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( As2
        = ( bot_bot @ ( set @ nat ) ) ) ) ).

% one_assn_raw.simps
thf(fact_291_one__assn__raw_Oelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( one_assn_raw @ X )
        = Y )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( Y
              = ( ( As
                 != ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.elims(1)
thf(fact_292_one__assn__raw_Oelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( one_assn_raw @ X )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( As
             != ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% one_assn_raw.elims(2)
thf(fact_293_Int__Un__eq_I4_J,axiom,
    ! [A: $tType,T: set @ A,S: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ T @ ( inf_inf @ ( set @ A ) @ S @ T ) )
      = T ) ).

% Int_Un_eq(4)
thf(fact_294_Int__Un__eq_I3_J,axiom,
    ! [A: $tType,S: set @ A,T: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ S @ ( inf_inf @ ( set @ A ) @ S @ T ) )
      = S ) ).

% Int_Un_eq(3)
thf(fact_295_Int__Un__eq_I2_J,axiom,
    ! [A: $tType,S: set @ A,T: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S @ T ) @ T )
      = T ) ).

% Int_Un_eq(2)
thf(fact_296_Int__Un__eq_I1_J,axiom,
    ! [A: $tType,S: set @ A,T: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S @ T ) @ S )
      = S ) ).

% Int_Un_eq(1)
thf(fact_297_Un__Int__eq_I4_J,axiom,
    ! [A: $tType,T: set @ A,S: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ T @ ( sup_sup @ ( set @ A ) @ S @ T ) )
      = T ) ).

% Un_Int_eq(4)
thf(fact_298_Un__Int__eq_I3_J,axiom,
    ! [A: $tType,S: set @ A,T: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ S @ ( sup_sup @ ( set @ A ) @ S @ T ) )
      = S ) ).

% Un_Int_eq(3)
thf(fact_299_Un__Int__eq_I2_J,axiom,
    ! [A: $tType,S: set @ A,T: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ S @ T ) @ T )
      = T ) ).

% Un_Int_eq(2)
thf(fact_300_Un__Int__eq_I1_J,axiom,
    ! [A: $tType,S: set @ A,T: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ S @ T ) @ S )
      = S ) ).

% Un_Int_eq(1)
thf(fact_301_wand__assnI,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat,Q2: assn,R: assn] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
     => ( ! [H4: heap_ext @ product_unit,As4: set @ nat] :
            ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As4 )
              = ( bot_bot @ ( set @ nat ) ) )
           => ( ( relH @ As2 @ H2 @ H4 )
             => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As2 ) )
               => ( ( rep_assn @ Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As4 ) )
                 => ( rep_assn @ R @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ ( sup_sup @ ( set @ nat ) @ As2 @ As4 ) ) ) ) ) ) )
       => ( rep_assn @ ( wand_assn @ Q2 @ R ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ) ).

% wand_assnI
thf(fact_302_IntI,axiom,
    ! [A: $tType,C2: A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ C2 @ A5 )
     => ( ( member2 @ A @ C2 @ B4 )
       => ( member2 @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% IntI
thf(fact_303_Int__iff,axiom,
    ! [A: $tType,C2: A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
      = ( ( member2 @ A @ C2 @ A5 )
        & ( member2 @ A @ C2 @ B4 ) ) ) ).

% Int_iff
thf(fact_304_Int__UNIV,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( top_top @ ( set @ A ) ) )
      = ( ( A5
          = ( top_top @ ( set @ A ) ) )
        & ( B4
          = ( top_top @ ( set @ A ) ) ) ) ) ).

% Int_UNIV
thf(fact_305_mod__or__dist,axiom,
    ! [P2: assn,Q2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( sup_sup @ assn @ P2 @ Q2 ) @ H2 )
      = ( ( rep_assn @ P2 @ H2 )
        | ( rep_assn @ Q2 @ H2 ) ) ) ).

% mod_or_dist
thf(fact_306_merge__pure__or,axiom,
    ! [A3: $o,B2: $o] :
      ( ( sup_sup @ assn @ ( pure_assn @ A3 ) @ ( pure_assn @ B2 ) )
      = ( pure_assn
        @ ( A3
          | B2 ) ) ) ).

% merge_pure_or
thf(fact_307_relH__dist__union,axiom,
    ! [As2: set @ nat,As3: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ ( sup_sup @ ( set @ nat ) @ As2 @ As3 ) @ H2 @ H5 )
      = ( ( relH @ As2 @ H2 @ H5 )
        & ( relH @ As3 @ H2 @ H5 ) ) ) ).

% relH_dist_union
thf(fact_308_mod__h__bot__iff_I7_J,axiom,
    ! [P2: assn,Q2: assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( sup_sup @ assn @ P2 @ Q2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        | ( rep_assn @ Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(7)
thf(fact_309_relH__sym,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( relH @ As2 @ H5 @ H2 ) ) ).

% relH_sym
thf(fact_310_relH__trans,axiom,
    ! [As2: set @ nat,H12: heap_ext @ product_unit,H23: heap_ext @ product_unit,H32: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H12 @ H23 )
     => ( ( relH @ As2 @ H23 @ H32 )
       => ( relH @ As2 @ H12 @ H32 ) ) ) ).

% relH_trans
thf(fact_311_star__or__dist2,axiom,
    ! [C5: assn,A5: assn,B4: assn] :
      ( ( times_times @ assn @ C5 @ ( sup_sup @ assn @ A5 @ B4 ) )
      = ( sup_sup @ assn @ ( times_times @ assn @ C5 @ A5 ) @ ( times_times @ assn @ C5 @ B4 ) ) ) ).

% star_or_dist2
thf(fact_312_star__or__dist1,axiom,
    ! [A5: assn,B4: assn,C5: assn] :
      ( ( times_times @ assn @ ( sup_sup @ assn @ A5 @ B4 ) @ C5 )
      = ( sup_sup @ assn @ ( times_times @ assn @ A5 @ C5 ) @ ( times_times @ assn @ B4 @ C5 ) ) ) ).

% star_or_dist1
thf(fact_313_ent__disjI2__direct,axiom,
    ! [B4: assn,A5: assn] : ( entails @ B4 @ ( sup_sup @ assn @ A5 @ B4 ) ) ).

% ent_disjI2_direct
thf(fact_314_ent__disjI1__direct,axiom,
    ! [A5: assn,B4: assn] : ( entails @ A5 @ ( sup_sup @ assn @ A5 @ B4 ) ) ).

% ent_disjI1_direct
thf(fact_315_ent__disjI2_H,axiom,
    ! [A5: assn,C5: assn,B4: assn] :
      ( ( entails @ A5 @ C5 )
     => ( entails @ A5 @ ( sup_sup @ assn @ B4 @ C5 ) ) ) ).

% ent_disjI2'
thf(fact_316_ent__disjI1_H,axiom,
    ! [A5: assn,B4: assn,C5: assn] :
      ( ( entails @ A5 @ B4 )
     => ( entails @ A5 @ ( sup_sup @ assn @ B4 @ C5 ) ) ) ).

% ent_disjI1'
thf(fact_317_ent__disjI2,axiom,
    ! [P2: assn,Q2: assn,R: assn] :
      ( ( entails @ ( sup_sup @ assn @ P2 @ Q2 ) @ R )
     => ( entails @ Q2 @ R ) ) ).

% ent_disjI2
thf(fact_318_ent__disjI1,axiom,
    ! [P2: assn,Q2: assn,R: assn] :
      ( ( entails @ ( sup_sup @ assn @ P2 @ Q2 ) @ R )
     => ( entails @ P2 @ R ) ) ).

% ent_disjI1
thf(fact_319_ent__disjE,axiom,
    ! [A5: assn,C5: assn,B4: assn] :
      ( ( entails @ A5 @ C5 )
     => ( ( entails @ B4 @ C5 )
       => ( entails @ ( sup_sup @ assn @ A5 @ B4 ) @ C5 ) ) ) ).

% ent_disjE
thf(fact_320_entt__disjE,axiom,
    ! [A5: assn,M: assn,B4: assn] :
      ( ( entailst @ A5 @ M )
     => ( ( entailst @ B4 @ M )
       => ( entailst @ ( sup_sup @ assn @ A5 @ B4 ) @ M ) ) ) ).

% entt_disjE
thf(fact_321_entt__disjD1,axiom,
    ! [A5: assn,B4: assn,C5: assn] :
      ( ( entailst @ ( sup_sup @ assn @ A5 @ B4 ) @ C5 )
     => ( entailst @ A5 @ C5 ) ) ).

% entt_disjD1
thf(fact_322_entt__disjD2,axiom,
    ! [A5: assn,B4: assn,C5: assn] :
      ( ( entailst @ ( sup_sup @ assn @ A5 @ B4 ) @ C5 )
     => ( entailst @ B4 @ C5 ) ) ).

% entt_disjD2
thf(fact_323_entt__disjI1_H,axiom,
    ! [A5: assn,B4: assn,C5: assn] :
      ( ( entailst @ A5 @ B4 )
     => ( entailst @ A5 @ ( sup_sup @ assn @ B4 @ C5 ) ) ) ).

% entt_disjI1'
thf(fact_324_entt__disjI2_H,axiom,
    ! [A5: assn,C5: assn,B4: assn] :
      ( ( entailst @ A5 @ C5 )
     => ( entailst @ A5 @ ( sup_sup @ assn @ B4 @ C5 ) ) ) ).

% entt_disjI2'
thf(fact_325_entt__disjI1__direct,axiom,
    ! [A5: assn,B4: assn] : ( entailst @ A5 @ ( sup_sup @ assn @ A5 @ B4 ) ) ).

% entt_disjI1_direct
thf(fact_326_entt__disjI2__direct,axiom,
    ! [B4: assn,A5: assn] : ( entailst @ B4 @ ( sup_sup @ assn @ A5 @ B4 ) ) ).

% entt_disjI2_direct
thf(fact_327_norm__assertion__simps_I11_J,axiom,
    ! [X: assn] :
      ( ( sup_sup @ assn @ ( top_top @ assn ) @ X )
      = ( top_top @ assn ) ) ).

% norm_assertion_simps(11)
thf(fact_328_norm__assertion__simps_I12_J,axiom,
    ! [X: assn] :
      ( ( sup_sup @ assn @ X @ ( top_top @ assn ) )
      = ( top_top @ assn ) ) ).

% norm_assertion_simps(12)
thf(fact_329_norm__assertion__simps_I5_J,axiom,
    ! [X: assn] :
      ( ( sup_sup @ assn @ ( bot_bot @ assn ) @ X )
      = X ) ).

% norm_assertion_simps(5)
thf(fact_330_norm__assertion__simps_I6_J,axiom,
    ! [X: assn] :
      ( ( sup_sup @ assn @ X @ ( bot_bot @ assn ) )
      = X ) ).

% norm_assertion_simps(6)
thf(fact_331_mod__relH,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,P2: assn] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
        = ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ) ).

% mod_relH
thf(fact_332_relH__in__rangeI_I2_J,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ).

% relH_in_rangeI(2)
thf(fact_333_relH__in__rangeI_I1_J,axiom,
    ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( relH @ As2 @ H2 @ H5 )
     => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ).

% relH_in_rangeI(1)
thf(fact_334_relH__refl,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
     => ( relH @ As2 @ H2 @ H2 ) ) ).

% relH_refl
thf(fact_335_Int__UNIV__right,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( top_top @ ( set @ A ) ) )
      = A5 ) ).

% Int_UNIV_right
thf(fact_336_Int__UNIV__left,axiom,
    ! [A: $tType,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B4 )
      = B4 ) ).

% Int_UNIV_left
thf(fact_337_Int__left__commute,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( inf_inf @ ( set @ A ) @ B4 @ ( inf_inf @ ( set @ A ) @ A5 @ C5 ) ) ) ).

% Int_left_commute
thf(fact_338_Int__left__absorb,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ).

% Int_left_absorb
thf(fact_339_Int__commute,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A10: set @ A,B6: set @ A] : ( inf_inf @ ( set @ A ) @ B6 @ A10 ) ) ) ).

% Int_commute
thf(fact_340_Int__absorb,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ A5 )
      = A5 ) ).

% Int_absorb
thf(fact_341_Int__assoc,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ C5 )
      = ( inf_inf @ ( set @ A ) @ A5 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Int_assoc
thf(fact_342_IntD2,axiom,
    ! [A: $tType,C2: A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
     => ( member2 @ A @ C2 @ B4 ) ) ).

% IntD2
thf(fact_343_IntD1,axiom,
    ! [A: $tType,C2: A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
     => ( member2 @ A @ C2 @ A5 ) ) ).

% IntD1
thf(fact_344_IntE,axiom,
    ! [A: $tType,C2: A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
     => ~ ( ( member2 @ A @ C2 @ A5 )
         => ~ ( member2 @ A @ C2 @ B4 ) ) ) ).

% IntE
thf(fact_345_disjoint__iff__not__equal,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ A5 )
           => ! [Y2: A] :
                ( ( member2 @ A @ Y2 @ B4 )
               => ( X2 != Y2 ) ) ) ) ) ).

% disjoint_iff_not_equal
thf(fact_346_Int__empty__right,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_empty_right
thf(fact_347_Int__empty__left,axiom,
    ! [A: $tType,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B4 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_empty_left
thf(fact_348_disjoint__iff,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ A5 )
           => ~ ( member2 @ A @ X2 @ B4 ) ) ) ) ).

% disjoint_iff
thf(fact_349_Int__emptyI,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ A5 )
         => ~ ( member2 @ A @ X3 @ B4 ) )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% Int_emptyI
thf(fact_350_Un__Int__distrib2,axiom,
    ! [A: $tType,B4: set @ A,C5: set @ A,A5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) @ A5 )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B4 @ A5 ) @ ( sup_sup @ ( set @ A ) @ C5 @ A5 ) ) ) ).

% Un_Int_distrib2
thf(fact_351_Int__Un__distrib2,axiom,
    ! [A: $tType,B4: set @ A,C5: set @ A,A5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) @ A5 )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B4 @ A5 ) @ ( inf_inf @ ( set @ A ) @ C5 @ A5 ) ) ) ).

% Int_Un_distrib2
thf(fact_352_Un__Int__distrib,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A5 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) @ ( sup_sup @ ( set @ A ) @ A5 @ C5 ) ) ) ).

% Un_Int_distrib
thf(fact_353_Int__Un__distrib,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ ( inf_inf @ ( set @ A ) @ A5 @ C5 ) ) ) ).

% Int_Un_distrib
thf(fact_354_Un__Int__crazy,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) @ ( inf_inf @ ( set @ A ) @ C5 @ A5 ) )
      = ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) ) @ ( sup_sup @ ( set @ A ) @ C5 @ A5 ) ) ) ).

% Un_Int_crazy
thf(fact_355_wand__raw_Oelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( wand_raw @ X @ Xa @ Xb )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
              & ! [H4: heap_ext @ product_unit,As4: set @ nat] :
                  ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As4 )
                      = ( bot_bot @ ( set @ nat ) ) )
                    & ( relH @ As @ H3 @ H4 )
                    & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                    & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As4 ) ) )
                 => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ ( sup_sup @ ( set @ nat ) @ As @ As4 ) ) ) ) ) ) ) ).

% wand_raw.elims(3)
thf(fact_356_wand__raw_Oelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( wand_raw @ X @ Xa @ Xb )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                & ! [H6: heap_ext @ product_unit,As5: set @ nat] :
                    ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As5 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( relH @ As @ H3 @ H6 )
                      & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As ) )
                      & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As5 ) ) )
                   => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ ( sup_sup @ ( set @ nat ) @ As @ As5 ) ) ) ) ) ) ) ).

% wand_raw.elims(2)
thf(fact_357_wand__raw_Oelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( wand_raw @ X @ Xa @ Xb )
        = Y )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( Y
              = ( ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                    & ! [H7: heap_ext @ product_unit,As6: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As6 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As @ H3 @ H7 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As ) )
                          & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As6 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As @ As6 ) ) ) ) ) ) ) ) ) ).

% wand_raw.elims(1)
thf(fact_358_wand__raw_Osimps,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( wand_raw @ P2 @ Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
        & ! [H7: heap_ext @ product_unit,As6: set @ nat] :
            ( ( ( ( inf_inf @ ( set @ nat ) @ As2 @ As6 )
                = ( bot_bot @ ( set @ nat ) ) )
              & ( relH @ As2 @ H2 @ H7 )
              & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As2 ) )
              & ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As6 ) ) )
           => ( Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As2 @ As6 ) ) ) ) ) ) ).

% wand_raw.simps
thf(fact_359_times__assn__raw_Oelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( times_assn_raw @ X @ Xa @ Xb )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ? [As12: set @ nat,As23: set @ nat] :
                ( ( As
                  = ( sup_sup @ ( set @ nat ) @ As12 @ As23 ) )
                & ( ( inf_inf @ ( set @ nat ) @ As12 @ As23 )
                  = ( bot_bot @ ( set @ nat ) ) )
                & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As12 ) )
                & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As23 ) ) ) ) ) ).

% times_assn_raw.elims(3)
thf(fact_360_times__assn__raw_Oelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( times_assn_raw @ X @ Xa @ Xb )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ~ ? [As13: set @ nat,As24: set @ nat] :
                  ( ( As
                    = ( sup_sup @ ( set @ nat ) @ As13 @ As24 ) )
                  & ( ( inf_inf @ ( set @ nat ) @ As13 @ As24 )
                    = ( bot_bot @ ( set @ nat ) ) )
                  & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As13 ) )
                  & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As24 ) ) ) ) ) ).

% times_assn_raw.elims(2)
thf(fact_361_times__assn__raw_Oelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( times_assn_raw @ X @ Xa @ Xb )
        = Y )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( Xb
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( Y
              = ( ~ ? [As1: set @ nat,As22: set @ nat] :
                      ( ( As
                        = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
                      & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As1 ) )
                      & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As22 ) ) ) ) ) ) ) ).

% times_assn_raw.elims(1)
thf(fact_362_times__assn__raw_Osimps,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( times_assn_raw @ P2 @ Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( ? [As1: set @ nat,As22: set @ nat] :
            ( ( As2
              = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
            & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
              = ( bot_bot @ ( set @ nat ) ) )
            & ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As1 ) )
            & ( Q2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As22 ) ) ) ) ) ).

% times_assn_raw.simps
thf(fact_363_disjointI,axiom,
    ! [A: $tType,A3: set @ A,B2: set @ A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ A3 )
         => ~ ( member2 @ A @ X3 @ B2 ) )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjointI
thf(fact_364_boolean__algebra__class_Oboolean__algebra_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
         => ( ( ( sup_sup @ A @ X @ Y )
              = ( top_top @ A ) )
           => ( ( uminus_uminus @ A @ X )
              = Y ) ) ) ) ).

% boolean_algebra_class.boolean_algebra.compl_unique
thf(fact_365_properI,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ! [As: set @ nat,H3: heap_ext @ product_unit] :
          ( ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
         => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) )
     => ( ! [As: set @ nat,H3: heap_ext @ product_unit,H4: heap_ext @ product_unit] :
            ( ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( ( relH @ As @ H3 @ H4 )
             => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
               => ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) ) ) ) )
       => ( proper @ P2 ) ) ) ).

% properI
thf(fact_366_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A3 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_367_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A3 ) )
          = A3 ) ) ).

% add.inverse_inverse
thf(fact_368_uminus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A10: A > B,X2: A] : ( uminus_uminus @ B @ ( A10 @ X2 ) ) ) ) ) ).

% uminus_apply
thf(fact_369_pure__assn__proper,axiom,
    ! [B2: $o] : ( proper @ ( pure_assn_raw @ ( heap_ext @ product_unit ) @ nat @ B2 ) ) ).

% pure_assn_proper
thf(fact_370_Compl__disjoint,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ A5 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_disjoint
thf(fact_371_Compl__disjoint2,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A5 ) @ A5 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Compl_disjoint2
thf(fact_372_mod__not__dist,axiom,
    ! [P2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( uminus_uminus @ assn @ P2 ) @ H2 )
      = ( ( in_range @ H2 )
        & ~ ( rep_assn @ P2 @ H2 ) ) ) ).

% mod_not_dist
thf(fact_373_bool__assn__proper_I1_J,axiom,
    proper @ in_range ).

% bool_assn_proper(1)
thf(fact_374_times__assn__proper,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P2 )
     => ( ( proper @ Q2 )
       => ( proper @ ( times_assn_raw @ P2 @ Q2 ) ) ) ) ).

% times_assn_proper
thf(fact_375_wand__proper,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] : ( proper @ ( wand_raw @ P2 @ Q2 ) ) ).

% wand_proper
thf(fact_376_one__assn__proper,axiom,
    proper @ one_assn_raw ).

% one_assn_proper
thf(fact_377_inf__compl__bot__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ ( inf_inf @ A @ X @ Y ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_left1
thf(fact_378_inf__compl__bot__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ Y ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_left2
thf(fact_379_inf__compl__bot__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ ( uminus_uminus @ A @ X ) ) )
          = ( bot_bot @ A ) ) ) ).

% inf_compl_bot_right
thf(fact_380_boolean__algebra_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ X )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_cancel_left
thf(fact_381_boolean__algebra_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( uminus_uminus @ A @ X ) )
          = ( bot_bot @ A ) ) ) ).

% boolean_algebra.conj_cancel_right
thf(fact_382_boolean__algebra_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( inf_inf @ A @ X @ Y ) )
          = ( sup_sup @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% boolean_algebra.de_Morgan_conj
thf(fact_383_boolean__algebra_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( sup_sup @ A @ X @ Y ) )
          = ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% boolean_algebra.de_Morgan_disj
thf(fact_384_assn__aci_I8_J,axiom,
    ! [X: assn,Y: assn] :
      ( ( sup_sup @ assn @ X @ ( sup_sup @ assn @ X @ Y ) )
      = ( sup_sup @ assn @ X @ Y ) ) ).

% assn_aci(8)
thf(fact_385_assn__aci_I7_J,axiom,
    ! [X: assn,Y: assn,Z2: assn] :
      ( ( sup_sup @ assn @ X @ ( sup_sup @ assn @ Y @ Z2 ) )
      = ( sup_sup @ assn @ Y @ ( sup_sup @ assn @ X @ Z2 ) ) ) ).

% assn_aci(7)
thf(fact_386_assn__aci_I5_J,axiom,
    ( ( sup_sup @ assn )
    = ( ^ [X2: assn,Y2: assn] : ( sup_sup @ assn @ Y2 @ X2 ) ) ) ).

% assn_aci(5)
thf(fact_387_norm__assertion__simps_I32_J,axiom,
    ! [X: assn] :
      ( ( sup_sup @ assn @ X @ X )
      = X ) ).

% norm_assertion_simps(32)
thf(fact_388_norm__assertion__simps_I15_J,axiom,
    ! [X: assn,Y: assn,Z2: assn] :
      ( ( sup_sup @ assn @ ( sup_sup @ assn @ X @ Y ) @ Z2 )
      = ( sup_sup @ assn @ X @ ( sup_sup @ assn @ Y @ Z2 ) ) ) ).

% norm_assertion_simps(15)
thf(fact_389_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A3 ) ) ) ).

% minus_equation_iff
thf(fact_390_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% equation_minus_iff
thf(fact_391_fun__Compl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A10: A > B,X2: A] : ( uminus_uminus @ B @ ( A10 @ X2 ) ) ) ) ) ).

% fun_Compl_def
thf(fact_392_Rep__assn__induct,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,P2: ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) > $o] :
      ( ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ! [X3: assn] : ( P2 @ ( rep_assn @ X3 ) )
       => ( P2 @ Y ) ) ) ).

% Rep_assn_induct
thf(fact_393_Rep__assn__cases,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ~ ! [X3: assn] :
            ( Y
           != ( rep_assn @ X3 ) ) ) ).

% Rep_assn_cases
thf(fact_394_Rep__assn,axiom,
    ! [X: assn] : ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( rep_assn @ X ) @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ) ).

% Rep_assn
thf(fact_395_inf__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ A3 ) @ ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ B2 ) )
          = ( bot_bot @ A ) ) ) ).

% inf_cancel_left1
thf(fact_396_inf__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ A3 ) @ ( inf_inf @ A @ X @ B2 ) )
          = ( bot_bot @ A ) ) ) ).

% inf_cancel_left2
thf(fact_397_Compl__Un,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A5 ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) ) ) ).

% Compl_Un
thf(fact_398_Compl__Int,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A5 ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) ) ) ).

% Compl_Int
thf(fact_399_properD1,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( proper @ P2 )
     => ( ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ) ).

% properD1
thf(fact_400_proper__iff,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit] :
      ( ( proper @ P2 )
     => ( ( relH @ As2 @ H2 @ H5 )
       => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) )
         => ( ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
            = ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ) ) ) ).

% proper_iff
thf(fact_401_proper__def,axiom,
    ( proper
    = ( ^ [P: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
        ! [H: heap_ext @ product_unit,H7: heap_ext @ product_unit,As7: set @ nat] :
          ( ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
           => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) ) )
          & ( ( ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
              & ( relH @ As7 @ H @ H7 )
              & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As7 ) ) )
           => ( P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As7 ) ) ) ) ) ) ).

% proper_def
thf(fact_402_properD2,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H2: heap_ext @ product_unit,As2: set @ nat,H5: heap_ext @ product_unit] :
      ( ( proper @ P2 )
     => ( ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ( ( relH @ As2 @ H2 @ H5 )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) )
           => ( P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H5 @ As2 ) ) ) ) ) ) ).

% properD2
thf(fact_403_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z2 )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1
thf(fact_404_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1_right
thf(fact_405_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_406_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A3 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_407_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_408_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_409_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_410_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ A3 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A3 = B2 )
            | ( A3
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_411_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( times_times @ A @ A3 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_412_boolean__algebra_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( inf_inf @ A ) @ ( sup_sup @ A ) @ ( uminus_uminus @ A ) @ ( bot_bot @ A ) @ ( top_top @ A ) ) ) ).

% boolean_algebra.abstract_boolean_algebra_axioms
thf(fact_413_wand__assn__def,axiom,
    ( wand_assn
    = ( ^ [P: assn,Q: assn] : ( abs_assn @ ( wand_raw @ ( rep_assn @ P ) @ ( rep_assn @ Q ) ) ) ) ) ).

% wand_assn_def
thf(fact_414_Rep__assn__inverse,axiom,
    ! [X: assn] :
      ( ( abs_assn @ ( rep_assn @ X ) )
      = X ) ).

% Rep_assn_inverse
thf(fact_415_Abs__assn__eqI_I2_J,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Pr: assn] :
      ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( P2 @ H3 )
          = ( rep_assn @ Pr @ H3 ) )
     => ( Pr
        = ( abs_assn @ P2 ) ) ) ).

% Abs_assn_eqI(2)
thf(fact_416_Abs__assn__eqI_I1_J,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Pr: assn] :
      ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( P2 @ H3 )
          = ( rep_assn @ Pr @ H3 ) )
     => ( ( abs_assn @ P2 )
        = Pr ) ) ).

% Abs_assn_eqI(1)
thf(fact_417_pure__assn__def,axiom,
    ( pure_assn
    = ( ^ [B3: $o] : ( abs_assn @ ( pure_assn_raw @ ( heap_ext @ product_unit ) @ nat @ B3 ) ) ) ) ).

% pure_assn_def
thf(fact_418_Abs__assn__cases,axiom,
    ! [X: assn] :
      ~ ! [Y3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
          ( ( X
            = ( abs_assn @ Y3 ) )
         => ~ ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y3 @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ) ) ).

% Abs_assn_cases
thf(fact_419_Abs__assn__induct,axiom,
    ! [P2: assn > $o,X: assn] :
      ( ! [Y3: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
          ( ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y3 @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
         => ( P2 @ ( abs_assn @ Y3 ) ) )
     => ( P2 @ X ) ) ).

% Abs_assn_induct
thf(fact_420_Abs__assn__inject,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ X @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
       => ( ( ( abs_assn @ X )
            = ( abs_assn @ Y ) )
          = ( X = Y ) ) ) ) ).

% Abs_assn_inject
thf(fact_421_Abs__assn__inverse,axiom,
    ! [Y: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( member2 @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ Y @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) )
     => ( ( rep_assn @ ( abs_assn @ Y ) )
        = Y ) ) ).

% Abs_assn_inverse
thf(fact_422_top__assn__def,axiom,
    ( ( top_top @ assn )
    = ( abs_assn @ in_range ) ) ).

% top_assn_def
thf(fact_423_one__assn__def,axiom,
    ( ( one_one @ assn )
    = ( abs_assn @ one_assn_raw ) ) ).

% one_assn_def
thf(fact_424_times__assn__def,axiom,
    ( ( times_times @ assn )
    = ( ^ [P: assn,Q: assn] : ( abs_assn @ ( times_assn_raw @ ( rep_assn @ P ) @ ( rep_assn @ Q ) ) ) ) ) ).

% times_assn_def
thf(fact_425_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_426_sngr__assn__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( sngr_assn @ A )
        = ( ^ [R3: ref @ A,X2: A] : ( abs_assn @ ( sngr_assn_raw @ A @ R3 @ X2 ) ) ) ) ) ).

% sngr_assn_def
thf(fact_427_snga__assn__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( snga_assn @ A )
        = ( ^ [R3: array @ A,A4: list @ A] : ( abs_assn @ ( snga_assn_raw @ A @ R3 @ A4 ) ) ) ) ) ).

% snga_assn_def
thf(fact_428_list__collect__set__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( set @ A )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( nil @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% list_collect_set_simps(1)
thf(fact_429_mod__pure,axiom,
    ! [B2: $o,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( pure_assn @ B2 ) @ H2 )
      = ( ( ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 )
          = ( bot_bot @ ( set @ nat ) ) )
        & B2 ) ) ).

% mod_pure
thf(fact_430_snga__assn__proper,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: array @ A,X: list @ A] : ( proper @ ( snga_assn_raw @ A @ R4 @ X ) ) ) ).

% snga_assn_proper
thf(fact_431_sngr__assn__proper,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,X: A] : ( proper @ ( sngr_assn_raw @ A @ R4 @ X ) ) ) ).

% sngr_assn_proper
thf(fact_432_type__definition__assn,axiom,
    type_definition @ assn @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ rep_assn @ abs_assn @ ( collect @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ proper ) ).

% type_definition_assn
thf(fact_433_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_434_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_435_UNIV__coset,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( coset @ A @ ( nil @ A ) ) ) ).

% UNIV_coset
thf(fact_436_mod__emp,axiom,
    ! [H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( one_one @ assn ) @ H2 )
      = ( ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 )
        = ( bot_bot @ ( set @ nat ) ) ) ) ).

% mod_emp
thf(fact_437_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_438_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( nil @ A ) )
            = ( A5
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_439_list__collect__set__map__simps_I1_J,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > ( set @ A ),X: C > B] :
      ( ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ ( nil @ C ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% list_collect_set_map_simps(1)
thf(fact_440_nths__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( nths @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_441_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_442_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ B4 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_443_in__measures_I1_J,axiom,
    ! [A: $tType,X: A,Y: A] :
      ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( nil @ ( A > nat ) ) ) ) ).

% in_measures(1)
thf(fact_444_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P7: A,Q4: A,R4: A] :
          ( ( ord_less_eq @ A @ P7 @ ( sup_sup @ A @ Q4 @ R4 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P7 @ ( uminus_uminus @ A @ Q4 ) ) @ R4 ) ) ) ).

% sup_neg_inf
thf(fact_445_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% shunt2
thf(fact_446_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z2 ) ) ) ) ).

% shunt1
thf(fact_447_relH__def,axiom,
    ( relH
    = ( ^ [As7: set @ nat,H: heap_ext @ product_unit,H7: heap_ext @ product_unit] :
          ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As7 ) )
          & ! [T2: typerep,X2: nat] :
              ( ( member2 @ nat @ X2 @ As7 )
             => ( ( ( refs @ product_unit @ H @ T2 @ X2 )
                  = ( refs @ product_unit @ H7 @ T2 @ X2 ) )
                & ( ( arrays @ product_unit @ H @ T2 @ X2 )
                  = ( arrays @ product_unit @ H7 @ T2 @ X2 ) ) ) ) ) ) ) ).

% relH_def
thf(fact_448_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_449_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_450_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A3 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_451_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A3
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_452_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_453_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_454_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_455_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_456_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A3 ) )
          = ( ( zero_zero @ A )
            = A3 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_457_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_458_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( A3
            = ( uminus_uminus @ A @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_459_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = A3 )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_460_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_461_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% le_inf_iff
thf(fact_462_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            & ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% le_sup_iff
thf(fact_463_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% sup.bounded_iff
thf(fact_464_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_465_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_466_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: list @ A] :
      ( ( ( map @ A @ B @ F2 @ A3 )
        = ( nil @ B ) )
      = ( A3
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_467_Int__subset__iff,axiom,
    ! [A: $tType,C5: set @ A,A5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C5 @ A5 )
        & ( ord_less_eq @ ( set @ A ) @ C5 @ B4 ) ) ) ).

% Int_subset_iff
thf(fact_468_nths__nil,axiom,
    ! [A: $tType,A5: set @ nat] :
      ( ( nths @ A @ ( nil @ A ) @ A5 )
      = ( nil @ A ) ) ).

% nths_nil
thf(fact_469_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_470_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_le_0_iff_le
thf(fact_471_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_472_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_473_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A3: A,C2: A] :
          ( ( ( times_times @ A @ A3 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_474_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_475_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A3: A] :
          ( ( ( times_times @ A @ C2 @ A3 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A3
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_476_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_477_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ A5 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_478_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_479_nths__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,I: set @ nat] :
      ( ( nths @ A @ ( map @ B @ A @ F2 @ Xs ) @ I )
      = ( map @ B @ A @ F2 @ ( nths @ B @ Xs @ I ) ) ) ).

% nths_map
thf(fact_480_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_481_times__assn__raw_Ocases,axiom,
    ! [X: product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
      ~ ! [P4: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q5: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,H3: heap_ext @ product_unit,As: set @ nat] :
          ( X
         != ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ P4 @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Q5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ).

% times_assn_raw.cases
thf(fact_482_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_483_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_484_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_485_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_486_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_487_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_488_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_489_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_490_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_491_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_492_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_493_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_494_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_495_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_496_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ A3 ) ) ) ).

% zero_le_square
thf(fact_497_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_498_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_499_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_500_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_501_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_502_sngr__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
          ~ ! [R5: ref @ A,X3: A,H3: heap_ext @ product_unit,As: set @ nat] :
              ( X
             != ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ R5 @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ).

% sngr_assn_raw.cases
thf(fact_503_snga__assn__raw_Ocases,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) )] :
          ~ ! [R5: array @ A,X3: list @ A,H3: heap_ext @ product_unit,As: set @ nat] :
              ( X
             != ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ R5 @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ X3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ).

% snga_assn_raw.cases
thf(fact_504_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ A3 ) ) ) ) ).

% mult_left_le
thf(fact_505_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_506_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_507_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_508_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_509_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_510_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_511_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_512_pure__assn__raw_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ $o @ ( product_prod @ A @ ( set @ B ) )] :
      ~ ! [B5: $o,H3: A,As: set @ B] :
          ( X
         != ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ B5 @ ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) ) ) ).

% pure_assn_raw.cases
thf(fact_513_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% le_minus_iff
thf(fact_514_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A3 ) ) ) ).

% minus_le_iff
thf(fact_515_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% le_imp_neg_le
thf(fact_516_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_517_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_518_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_519_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_520_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_521_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ A3 ) ) ).

% inf.cobounded1
thf(fact_522_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( inf_inf @ A @ A4 @ B3 ) ) ) ) ) ).

% inf.order_iff
thf(fact_523_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Z2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) ) ) ) ).

% inf_greatest
thf(fact_524_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_525_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A3 @ B2 )
             => ~ ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_526_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( inf_inf @ A @ X @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_527_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( inf_inf @ A @ X @ Y )
            = X ) ) ) ).

% inf_absorb1
thf(fact_528_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_529_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% inf.absorb1
thf(fact_530_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( inf_inf @ A @ X2 @ Y2 )
              = X2 ) ) ) ) ).

% le_iff_inf
thf(fact_531_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y3 ) @ X3 )
         => ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y3 ) @ Y3 )
           => ( ! [X3: A,Y3: A,Z4: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ( ord_less_eq @ A @ X3 @ Z4 )
                   => ( ord_less_eq @ A @ X3 @ ( F2 @ Y3 @ Z4 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_532_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( inf_inf @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% inf.orderI
thf(fact_533_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( A3
            = ( inf_inf @ A @ A3 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_534_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_535_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_536_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D3 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A3 @ B2 ) @ ( inf_inf @ A @ C2 @ D3 ) ) ) ) ) ).

% inf_mono
thf(fact_537_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A3 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A3 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_538_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A3 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A3 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_539_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_540_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_le1
thf(fact_541_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_542_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_543_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_544_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_545_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A3 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_546_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_547_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge1
thf(fact_548_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge2
thf(fact_549_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A3 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_550_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_551_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,D3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ( ord_less_eq @ A @ D3 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D3 ) @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_552_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B2 ) @ ( sup_sup @ A @ C2 @ D3 ) ) ) ) ) ).

% sup_mono
thf(fact_553_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z2 ) @ X ) ) ) ) ).

% sup_least
thf(fact_554_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( sup_sup @ A @ X2 @ Y2 )
              = Y2 ) ) ) ) ).

% le_iff_sup
thf(fact_555_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( A3
            = ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_556_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( sup_sup @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% sup.orderI
thf(fact_557_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ X3 @ ( F2 @ X3 @ Y3 ) )
         => ( ! [X3: A,Y3: A] : ( ord_less_eq @ A @ Y3 @ ( F2 @ X3 @ Y3 ) )
           => ( ! [X3: A,Y3: A,Z4: A] :
                  ( ( ord_less_eq @ A @ Y3 @ X3 )
                 => ( ( ord_less_eq @ A @ Z4 @ X3 )
                   => ( ord_less_eq @ A @ ( F2 @ Y3 @ Z4 ) @ X3 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_558_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% sup.absorb1
thf(fact_559_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_560_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) ).

% sup_absorb1
thf(fact_561_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_562_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A3 )
             => ~ ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% sup.boundedE
thf(fact_563_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ A3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% sup.boundedI
thf(fact_564_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% sup.order_iff
thf(fact_565_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ A3 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_566_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_567_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_568_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_569_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_570_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_571_Int__Collect__mono,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,P2: A > $o,Q2: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ A5 )
           => ( ( P2 @ X3 )
             => ( Q2 @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ ( collect @ A @ P2 ) ) @ ( inf_inf @ ( set @ A ) @ B4 @ ( collect @ A @ Q2 ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_572_Int__greatest,axiom,
    ! [A: $tType,C5: set @ A,A5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ C5 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ C5 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% Int_greatest
thf(fact_573_Int__absorb2,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = A5 ) ) ).

% Int_absorb2
thf(fact_574_Int__absorb1,axiom,
    ! [A: $tType,B4: set @ A,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A5 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = B4 ) ) ).

% Int_absorb1
thf(fact_575_Int__lower2,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ B4 ) ).

% Int_lower2
thf(fact_576_Int__lower1,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ A5 ) ).

% Int_lower1
thf(fact_577_Int__mono,axiom,
    ! [A: $tType,A5: set @ A,C5: set @ A,B4: set @ A,D2: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ D2 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ ( inf_inf @ ( set @ A ) @ C5 @ D2 ) ) ) ) ).

% Int_mono
thf(fact_578_inter__eq__subsetI,axiom,
    ! [A: $tType,S: set @ A,S2: set @ A,A5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S @ S2 )
     => ( ( ( inf_inf @ ( set @ A ) @ A5 @ S2 )
          = ( inf_inf @ ( set @ A ) @ B4 @ S2 ) )
       => ( ( inf_inf @ ( set @ A ) @ A5 @ S )
          = ( inf_inf @ ( set @ A ) @ B4 @ S ) ) ) ) ).

% inter_eq_subsetI
thf(fact_579_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A3 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A3 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_580_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A3 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A3 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_581_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A3 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_582_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A3
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_583_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A3
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_584_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_585_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate1 @ B @ Xs ) ) ) ).

% rotate1_map
thf(fact_586_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A5 )
            = ( linord4507533701916653071of_set @ A @ B4 ) )
         => ( ( finite_finite @ A @ A5 )
           => ( ( finite_finite @ A @ B4 )
             => ( A5 = B4 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_587_less__eq__assn__def,axiom,
    ( ( ord_less_eq @ assn )
    = ( ^ [A4: assn,B3: assn] :
          ( A4
          = ( inf_inf @ assn @ A4 @ B3 ) ) ) ) ).

% less_eq_assn_def
thf(fact_588_relH__subset,axiom,
    ! [Bs: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,As2: set @ nat] :
      ( ( relH @ Bs @ H2 @ H5 )
     => ( ( ord_less_eq @ ( set @ nat ) @ As2 @ Bs )
       => ( relH @ As2 @ H2 @ H5 ) ) ) ).

% relH_subset
thf(fact_589_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_590_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_591_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z2 ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z2 ) ) ) ) ).

% distrib_inf_le
thf(fact_592_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z2 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% distrib_sup_le
thf(fact_593_disjoint__mono,axiom,
    ! [A: $tType,A3: set @ A,A9: set @ A,B2: set @ A,B7: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ A9 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ B7 )
       => ( ( ( inf_inf @ ( set @ A ) @ A9 @ B7 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% disjoint_mono
thf(fact_594_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ C5 )
        = ( inf_inf @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C5 @ A5 ) ) ).

% Un_Int_assoc_eq
thf(fact_595_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_596_in__range__subset,axiom,
    ! [As2: set @ nat,As3: set @ nat,H2: heap_ext @ product_unit] :
      ( ( ord_less_eq @ ( set @ nat ) @ As2 @ As3 )
     => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As3 ) )
       => ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) ) ) ) ).

% in_range_subset
thf(fact_597_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_598_finite__Int,axiom,
    ! [A: $tType,F7: set @ A,G3: set @ A] :
      ( ( ( finite_finite @ A @ F7 )
        | ( finite_finite @ A @ G3 ) )
     => ( finite_finite @ A @ ( inf_inf @ ( set @ A ) @ F7 @ G3 ) ) ) ).

% finite_Int
thf(fact_599_wand__raw_Opelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( wand_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
               => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                  & ! [H4: heap_ext @ product_unit,As4: set @ nat] :
                      ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As4 )
                          = ( bot_bot @ ( set @ nat ) ) )
                        & ( relH @ As @ H3 @ H4 )
                        & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As ) )
                        & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ As4 ) ) )
                     => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ ( sup_sup @ ( set @ nat ) @ As @ As4 ) ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(3)
thf(fact_600_wand__raw_Opelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( wand_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
               => ~ ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                    & ! [H6: heap_ext @ product_unit,As5: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As5 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As @ H3 @ H6 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As ) )
                          & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ As5 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ ( sup_sup @ ( set @ nat ) @ As @ As5 ) ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(2)
thf(fact_601_wand__raw_Opelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( wand_raw @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( Y
                  = ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                    & ! [H7: heap_ext @ product_unit,As6: set @ nat] :
                        ( ( ( ( inf_inf @ ( set @ nat ) @ As @ As6 )
                            = ( bot_bot @ ( set @ nat ) ) )
                          & ( relH @ As @ H3 @ H7 )
                          & ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As ) )
                          & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ As6 ) ) )
                       => ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( sup_sup @ ( set @ nat ) @ As @ As6 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ wand_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ) ) ) ).

% wand_raw.pelims(1)
thf(fact_602_mod__star__trueE_H,axiom,
    ! [P2: assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( times_times @ assn @ P2 @ ( top_top @ assn ) ) @ H2 )
     => ~ ! [H4: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( ( product_fst @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 )
              = ( product_fst @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 ) )
           => ( ( ord_less_eq @ ( set @ nat ) @ ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 ) @ ( product_snd @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 ) )
             => ~ ( rep_assn @ P2 @ H4 ) ) ) ) ).

% mod_star_trueE'
thf(fact_603_map__eq__map__tailrec,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map @ A @ B )
      = ( map_tailrec @ A @ B ) ) ).

% map_eq_map_tailrec
thf(fact_604_list__collect__set__map__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > ( set @ A ),X: C > B,A3: C] :
      ( ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ ( cons @ C @ A3 @ ( nil @ C ) ) ) )
      = ( F2 @ ( X @ A3 ) ) ) ).

% list_collect_set_map_simps(2)
thf(fact_605_times__assn__raw_Opelims_I1_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( times_assn_raw @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( Y
                  = ( ? [As1: set @ nat,As22: set @ nat] :
                        ( ( As
                          = ( sup_sup @ ( set @ nat ) @ As1 @ As22 ) )
                        & ( ( inf_inf @ ( set @ nat ) @ As1 @ As22 )
                          = ( bot_bot @ ( set @ nat ) ) )
                        & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As1 ) )
                        & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As22 ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(1)
thf(fact_606_times__assn__raw_Opelims_I2_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( times_assn_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
               => ~ ? [As13: set @ nat,As24: set @ nat] :
                      ( ( As
                        = ( sup_sup @ ( set @ nat ) @ As13 @ As24 ) )
                      & ( ( inf_inf @ ( set @ nat ) @ As13 @ As24 )
                        = ( bot_bot @ ( set @ nat ) ) )
                      & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As13 ) )
                      & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As24 ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(2)
thf(fact_607_times__assn__raw_Opelims_I3_J,axiom,
    ! [X: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xa: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( times_assn_raw @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( Xb
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ times_assn_raw_rel @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
               => ? [As12: set @ nat,As23: set @ nat] :
                    ( ( As
                      = ( sup_sup @ ( set @ nat ) @ As12 @ As23 ) )
                    & ( ( inf_inf @ ( set @ nat ) @ As12 @ As23 )
                      = ( bot_bot @ ( set @ nat ) ) )
                    & ( X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As12 ) )
                    & ( Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As23 ) ) ) ) ) ) ) ).

% times_assn_raw.pelims(3)
thf(fact_608_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_609_list_Oinject,axiom,
    ! [A: $tType,X21: A,X22: list @ A,Y21: A,Y22: list @ A] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) ).

% list.inject
thf(fact_610_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_611_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_612_list__ex__simps_I1_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( list_ex @ A @ P2 @ ( cons @ A @ X @ Xs ) )
      = ( ( P2 @ X )
        | ( list_ex @ A @ P2 @ Xs ) ) ) ).

% list_ex_simps(1)
thf(fact_613_in__measures_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat,Fs: list @ ( A > nat )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y ) )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) ) ) ) ) ).

% in_measures(2)
thf(fact_614_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_0_iff_less
thf(fact_615_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_616_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% neg_less_pos
thf(fact_617_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_618_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_Cons_Cons
thf(fact_619_zip__map__fst__snd,axiom,
    ! [B: $tType,A: $tType,Zs: list @ ( product_prod @ A @ B )] :
      ( ( zip @ A @ B @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs ) @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs ) )
      = Zs ) ).

% zip_map_fst_snd
thf(fact_620_nths__singleton,axiom,
    ! [A: $tType,A5: set @ nat,X: A] :
      ( ( ( member2 @ nat @ ( zero_zero @ nat ) @ A5 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A5 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member2 @ nat @ ( zero_zero @ nat ) @ A5 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A5 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_621_list__collect__set__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( set @ A ),A3: B] :
      ( ( list_collect_set @ B @ A @ F2 @ ( cons @ B @ A3 @ ( nil @ B ) ) )
      = ( F2 @ A3 ) ) ).

% list_collect_set_simps(2)
thf(fact_622_less__assn__def,axiom,
    ( ( ord_less @ assn )
    = ( ^ [A4: assn,B3: assn] :
          ( ( ord_less_eq @ assn @ A4 @ B3 )
          & ( A4 != B3 ) ) ) ) ).

% less_assn_def
thf(fact_623_not__Cons__self2,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) ).

% not_Cons_self2
thf(fact_624_transpose_Ocases,axiom,
    ! [A: $tType,X: list @ ( list @ A )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: list @ ( list @ A )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ! [X3: A,Xs2: list @ A,Xss: list @ ( list @ A )] :
              ( X
             != ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) ) ) ) ).

% transpose.cases
thf(fact_625_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Xy: product_prod @ A @ B,Xys: list @ ( product_prod @ A @ B )] :
      ( ( ( zip @ A @ B @ Xs @ Ys )
        = ( cons @ ( product_prod @ A @ B ) @ Xy @ Xys ) )
     => ~ ! [X3: A,Xs3: list @ A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Xs3 ) )
           => ! [Y3: B,Ys2: list @ B] :
                ( ( Ys
                  = ( cons @ B @ Y3 @ Ys2 ) )
               => ( ( Xy
                    = ( product_Pair @ A @ B @ X3 @ Y3 ) )
                 => ( Xys
                   != ( zip @ A @ B @ Xs3 @ Ys2 ) ) ) ) ) ) ).

% zip_eq_ConsE
thf(fact_626_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys ) )
       => ( Xs = Ys ) ) ) ).

% pair_list_eqI
thf(fact_627_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_628_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M2: A,N: A] :
          ( ( ord_less @ A @ M2 @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_629_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_630_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_631_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_632_neq__NilE,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( L
       != ( nil @ A ) )
     => ~ ! [X3: A,Xs2: list @ A] :
            ( L
           != ( cons @ A @ X3 @ Xs2 ) ) ) ).

% neq_NilE
thf(fact_633_list__2pre__induct,axiom,
    ! [A: $tType,B: $tType,P2: ( list @ A ) > ( list @ B ) > $o,W1: list @ A,W2: list @ B] :
      ( ( P2 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [E: A,W12: list @ A,W22: list @ B] :
            ( ( P2 @ W12 @ W22 )
           => ( P2 @ ( cons @ A @ E @ W12 ) @ W22 ) )
       => ( ! [E: B,W13: list @ A,W23: list @ B] :
              ( ( P2 @ W13 @ W23 )
             => ( P2 @ W13 @ ( cons @ B @ E @ W23 ) ) )
         => ( P2 @ W1 @ W2 ) ) ) ) ).

% list_2pre_induct
thf(fact_634_list__induct__first2,axiom,
    ! [A: $tType,P2: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P2 @ ( nil @ A ) )
     => ( ! [X3: A] : ( P2 @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X1: A,X23: A,Xs2: list @ A] :
              ( ( P2 @ Xs2 )
             => ( P2 @ ( cons @ A @ X1 @ ( cons @ A @ X23 @ Xs2 ) ) ) )
         => ( P2 @ Xs ) ) ) ) ).

% list_induct_first2
thf(fact_635_mergesort__by__rel__merge__induct,axiom,
    ! [A: $tType,B: $tType,P2: ( list @ A ) > ( list @ B ) > $o,R: A > B > $o,Xs: list @ A,Ys: list @ B] :
      ( ! [Xs2: list @ A] : ( P2 @ Xs2 @ ( nil @ B ) )
     => ( ! [X_1: list @ B] : ( P2 @ ( nil @ A ) @ X_1 )
       => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B] :
              ( ( R @ X3 @ Y3 )
             => ( ( P2 @ Xs2 @ ( cons @ B @ Y3 @ Ys3 ) )
               => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys3 ) ) ) )
         => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B] :
                ( ~ ( R @ X3 @ Y3 )
               => ( ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 )
                 => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys3 ) ) ) )
           => ( P2 @ Xs @ Ys ) ) ) ) ) ).

% mergesort_by_rel_merge_induct
thf(fact_636_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) ).

% list.distinct(1)
thf(fact_637_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X21: A,X22: list @ A] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_638_list_Oexhaust,axiom,
    ! [A: $tType,Y: list @ A] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ! [X212: A,X222: list @ A] :
            ( Y
           != ( cons @ A @ X212 @ X222 ) ) ) ).

% list.exhaust
thf(fact_639_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A] :
          ( ! [X3: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X3 @ Xs2 ) )
         => ( X
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_640_remdups__adj_Ocases,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( X
           != ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_641_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
         != ( nil @ A ) ) )
      = ( ? [Y2: A,Ys4: list @ A] :
            ( Xs
            = ( cons @ A @ Y2 @ Ys4 ) ) ) ) ).

% neq_Nil_conv
thf(fact_642_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P2: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys: list @ B] :
      ( ( P2 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: list @ A] : ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y3: B,Ys3: list @ B] : ( P2 @ ( nil @ A ) @ ( cons @ B @ Y3 @ Ys3 ) )
         => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B] :
                ( ( P2 @ Xs2 @ Ys3 )
               => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys3 ) ) )
           => ( P2 @ Xs @ Ys ) ) ) ) ) ).

% list_induct2'
thf(fact_643_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P2: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] : ( P2 @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P2 @ Xs2 )
               => ( P2 @ ( cons @ A @ X3 @ Xs2 ) ) ) )
         => ( P2 @ Xs ) ) ) ) ).

% list_nonempty_induct
thf(fact_644_merge_Ocases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ! [L2: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ L2 ) )
         => ( ! [V: A,Va: list @ A] :
                ( X
               != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ V @ Va ) @ ( nil @ A ) ) )
           => ~ ! [X1: A,L1: list @ A,X23: A,L2: list @ A] :
                  ( X
                 != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X23 @ L2 ) ) ) ) ) ) ).

% merge.cases
thf(fact_645_shuffles_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys3: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys3 ) )
     => ( ! [Xs2: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
       => ~ ! [X3: A,Xs2: list @ A,Y3: A,Ys3: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys3 ) ) ) ) ) ).

% shuffles.cases
thf(fact_646_successively_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P4: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P4 @ ( nil @ A ) ) )
     => ( ! [P4: A > A > $o,X3: A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P4 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
       => ~ ! [P4: A > A > $o,X3: A,Y3: A,Xs2: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P4 @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ).

% successively.cases
thf(fact_647_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P4: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P4 @ ( nil @ A ) ) )
     => ~ ! [P4: A > A > $o,X3: A,Ys3: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P4 @ ( cons @ A @ X3 @ Ys3 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_648_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F9: A > B,X3: A] :
              ( X
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F9 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
         => ( ! [F9: A > B,X3: A,Y3: A,Zs2: list @ A] :
                ( X
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F9 @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Zs2 ) ) ) )
           => ~ ! [A6: A > B] :
                  ( X
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A6 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_649_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F9: A > B,Bs2: list @ B] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F9 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F9: A > B,A6: A,As: list @ A,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F9 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_650_mergesort__by__rel__split_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A )] :
      ( ! [Xs1: list @ A,Xs22: list @ A] :
          ( X
         != ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) @ ( nil @ A ) ) )
     => ( ! [Xs1: list @ A,Xs22: list @ A,X3: A] :
            ( X
           != ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
       => ~ ! [Xs1: list @ A,Xs22: list @ A,X1: A,X23: A,Xs2: list @ A] :
              ( X
             != ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) @ ( cons @ A @ X1 @ ( cons @ A @ X23 @ Xs2 ) ) ) ) ) ) ).

% mergesort_by_rel_split.cases
thf(fact_651_mergesort__by__rel__merge_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )] :
      ( ! [R6: A > A > $o,X3: A,Xs2: list @ A,Y3: A,Ys3: list @ A] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R6 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys3 ) ) ) )
     => ( ! [R6: A > A > $o,Xs2: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R6 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) ) )
       => ~ ! [R6: A > A > $o,V: A,Va: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R6 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( cons @ A @ V @ Va ) ) ) ) ) ) ).

% mergesort_by_rel_merge.cases
thf(fact_652_quicksort__by__rel_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )] :
      ( ! [R6: A > A > $o,Sl: list @ A] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R6 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( nil @ A ) ) ) )
     => ~ ! [R6: A > A > $o,Sl: list @ A,X3: A,Xs2: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R6 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( cons @ A @ X3 @ Xs2 ) ) ) ) ) ).

% quicksort_by_rel.cases
thf(fact_653_partition__rev_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) )] :
      ( ! [P4: A > $o,Yes: list @ A,No: list @ A] :
          ( X
         != ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ P4 @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( nil @ A ) ) ) )
     => ~ ! [P4: A > $o,Yes: list @ A,No: list @ A,X3: A,Xs2: list @ A] :
            ( X
           != ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ P4 @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( cons @ A @ X3 @ Xs2 ) ) ) ) ) ).

% partition_rev.cases
thf(fact_654_list__all__zip_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [P4: A > B > $o] :
          ( X
         != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P4 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) )
     => ( ! [P4: A > B > $o,A6: A,As: list @ A,B5: B,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P4 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ ( cons @ B @ B5 @ Bs2 ) ) ) )
       => ( ! [P4: A > B > $o,V: A,Va: list @ A] :
              ( X
             != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P4 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V @ Va ) @ ( nil @ B ) ) ) )
         => ~ ! [P4: A > B > $o,V: B,Va: list @ B] :
                ( X
               != ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ P4 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V @ Va ) ) ) ) ) ) ) ).

% list_all_zip.cases
thf(fact_655_zipf_Ocases,axiom,
    ! [C: $tType,A: $tType,B: $tType,X: product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F9: A > B > C] :
          ( X
         != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F9 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) )
     => ( ! [F9: A > B > C,A6: A,As: list @ A,B5: B,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F9 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ ( cons @ B @ B5 @ Bs2 ) ) ) )
       => ( ! [A6: A > B > C,V: A,Va: list @ A] :
              ( X
             != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ A6 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V @ Va ) @ ( nil @ B ) ) ) )
         => ~ ! [A6: A > B > C,V: B,Va: list @ B] :
                ( X
               != ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ A6 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V @ Va ) ) ) ) ) ) ) ).

% zipf.cases
thf(fact_656_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A3 ) ) ) ).

% minus_less_iff
thf(fact_657_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% less_minus_iff
thf(fact_658_measures__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ).

% measures_less
thf(fact_659_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,X: A,B2: A] :
          ( ( ord_less @ A @ A3 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_660_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A3: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_661_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% inf.absorb3
thf(fact_662_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( inf_inf @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_663_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A3 @ B2 )
             => ~ ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_664_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( inf_inf @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_665_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_666_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_667_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_668_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A3 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_669_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( A4
                = ( sup_sup @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_670_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less @ A @ B2 @ A3 )
             => ~ ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_671_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_672_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( sup_sup @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% sup.absorb3
thf(fact_673_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A3: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_674_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A3: A,B2: A] :
          ( ( ord_less @ A @ X @ A3 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A3 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_675_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Y: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ? [Z3: B,Zs3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Z3 @ Zs3 ) )
            & ( ( F2 @ Z3 )
              = Y )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_676_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
      = ( ? [Z3: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z3 @ Zs3 ) )
            & ( X
              = ( F2 @ Z3 ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_677_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: B > A,Xs: list @ B,Y: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ? [Z4: B,Zs2: list @ B] :
          ( ( Xs
            = ( cons @ B @ Z4 @ Zs2 ) )
          & ( ( F2 @ Z4 )
            = Y )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys ) ) ) ).

% map_eq_Cons_D
thf(fact_678_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ? [Z4: B,Zs2: list @ B] :
          ( ( Ys
            = ( cons @ B @ Z4 @ Zs2 ) )
          & ( X
            = ( F2 @ Z4 ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_679_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X21: A,X22: list @ A] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X22 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X22 ) ) ) ).

% list.simps(9)
thf(fact_680_splice_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( cons @ A @ X @ ( splice @ A @ Ys @ Xs ) ) ) ).

% splice.simps(2)
thf(fact_681_null__rec_I1_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ~ ( null @ A @ ( cons @ A @ X @ Xs ) ) ).

% null_rec(1)
thf(fact_682_member__rec_I1_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ( member @ A @ ( cons @ A @ X @ Xs ) @ Y )
      = ( ( X = Y )
        | ( member @ A @ Xs @ Y ) ) ) ).

% member_rec(1)
thf(fact_683_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_684_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A3 @ A3 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_685_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_686_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_687_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_688_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_689_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_690_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_691_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_692_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A3 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_693_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_694_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_695_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_696_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_697_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_698_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_699_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_700_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_701_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_702_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_703_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_704_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_705_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M2: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M2 @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_706_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_707_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_708_splice_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ~ ! [X3: A,Xs2: list @ A] :
              ( ( X
                = ( cons @ A @ X3 @ Xs2 ) )
             => ( Y
               != ( cons @ A @ X3 @ ( splice @ A @ Xa @ Xs2 ) ) ) ) ) ) ).

% splice.elims
thf(fact_709_measures__lesseq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) )
       => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ) ).

% measures_lesseq
thf(fact_710_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_711_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_712_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_713_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_714_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_715_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_716_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_717_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_718_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_719_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_720_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_721_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_722_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_723_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_724_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_725_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_726_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_727_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_728_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A3 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_729_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_730_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_731_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_732_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A3 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A3 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A3 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_733_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [Z4: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z4 )
             => ( ( ord_less @ A @ Z4 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z4 @ X ) @ Y ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_734_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_735_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X ) @ ( times_times @ A @ Z2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_736_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ Z2 ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_737_quicksort_Ocases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ A] :
          ( ( X
           != ( nil @ A ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( X
               != ( cons @ A @ X3 @ Xs2 ) ) ) ) ).

% quicksort.cases
thf(fact_738_subset__eq__mset__impl_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys3: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys3 ) )
     => ~ ! [X3: A,Xs2: list @ A,Ys3: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 ) ) ) ).

% subset_eq_mset_impl.cases
thf(fact_739_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_740_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_741_insert__Nil,axiom,
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% insert_Nil
thf(fact_742_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A3: A,Y: A,U: A,V2: A] :
          ( ( ord_less @ A @ X @ A3 )
         => ( ( ord_less @ A @ Y @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A3 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_743_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_744_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_745_map__snd__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = Xs ) ).

% map_snd_enumerate
thf(fact_746_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_747_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_748_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% add.right_neutral
thf(fact_749_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A3 @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_750_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A3: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = A3 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_751_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = A3 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_752_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ B2 @ A3 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_753_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ A3 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_754_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_755_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_756_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% add_0
thf(fact_757_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_758_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_759_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ A3 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_760_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( plus_plus @ A @ A3 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_761_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_762_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_763_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_764_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_765_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_766_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ B2 @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_767_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_768_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_769_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_770_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_771_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_772_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( plus_plus @ A @ B2 @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_773_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_774_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_775_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ A3 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_776_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_777_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_778_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_779_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( sgn_sgn @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_780_nat__geq__1__eq__neqz,axiom,
    ! [X: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ X )
      = ( ( X
         != ( zero_zero @ nat ) ) ) ) ).

% nat_geq_1_eq_neqz
thf(fact_781_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( ( ( F2 @ A3 @ B2 )
          = Z2 )
        = ( ( A3 = Z2 )
          & ( B2 = Z2 ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
thf(fact_782_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( ( Z2
          = ( F2 @ A3 @ B2 ) )
        = ( ( A3 = Z2 )
          & ( B2 = Z2 ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
thf(fact_783_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( I2 = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I2 @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_784_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: A,K: A,A3: A,B2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( plus_plus @ A @ A5 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_785_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: A,K: A,B2: A,A3: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A3 @ B4 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_786_add_Oright__assoc,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.right_assoc
thf(fact_787_add_Oright__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% add.right_commute
thf(fact_788_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_789_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_790_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_791_ab__semigroup__add__class_Oadd_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ B3 @ A4 ) ) ) ) ).

% ab_semigroup_add_class.add.commute
thf(fact_792_ab__semigroup__add__class_Oadd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add.left_commute
thf(fact_793_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ A3 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_794_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A3 )
            = ( plus_plus @ A @ C2 @ A3 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_795_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_796_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( I2 = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_797_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_798_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_mono
thf(fact_799_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_800_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ~ ! [C4: A] :
                ( B2
               != ( plus_plus @ A @ A3 @ C4 ) ) ) ) ).

% less_eqE
thf(fact_801_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_802_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
            ? [C3: A] :
              ( B3
              = ( plus_plus @ A @ A4 @ C3 ) ) ) ) ) ).

% le_iff_add
thf(fact_803_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_804_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_805_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_806_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% add.comm_neutral
thf(fact_807_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) ).

% add.group_left_neutral
thf(fact_808_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_809_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( I2 = J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_810_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_811_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_strict_mono
thf(fact_812_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_813_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_814_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_815_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A3 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_816_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,E2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ E2 ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_817_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_818_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_819_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_820_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_821_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_822_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: A,K: A,A3: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( uminus_uminus @ A @ A5 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_823_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_824_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_825_add_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( abel_semigroup @ A @ ( plus_plus @ A ) ) ) ).

% add.abel_semigroup_axioms
thf(fact_826_add_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ( semigroup @ A @ ( plus_plus @ A ) ) ) ).

% add.semigroup_axioms
thf(fact_827_add_Oac__operator__axioms,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( syntax_ac_operator @ A @ ( plus_plus @ A ) ) ) ).

% add.ac_operator_axioms
thf(fact_828_add_Osafe__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [X: A,Y: A,A3: A,B2: A] :
          ( ( syntax7388354845996824322omatch @ A @ A @ ( plus_plus @ A @ X @ Y ) @ A3 )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ B2 @ A3 ) ) ) ) ).

% add.safe_commute
thf(fact_829_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_830_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_831_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_832_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_833_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_834_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_835_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_836_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_837_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_838_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_839_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_840_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D3 )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ D3 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_841_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_842_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_843_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ~ ! [C4: A] :
                ( ( B2
                  = ( plus_plus @ A @ A3 @ C4 ) )
               => ( C4
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_844_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_845_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_846_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A] : ( ord_less @ A @ A3 @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_847_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% add_eq_0_iff
thf(fact_848_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_849_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A3 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_850_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_851_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B2 )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_852_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_853_add_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( comm_monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.comm_monoid_axioms
thf(fact_854_add_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.monoid_axioms
thf(fact_855_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( semilattice_neutr @ A @ F2 @ Z2 ) ) ).

% semilattice_neutr_order.axioms(1)
thf(fact_856_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_857_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_858_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_859_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_860_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A3 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_861_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_862_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A3 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_863_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_864_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_865_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_866_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% sgn_1_pos
thf(fact_867_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A3: A,Y: A,U: A,V2: A] :
          ( ( ord_less_eq @ A @ X @ A3 )
         => ( ( ord_less_eq @ A @ Y @ A3 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A3 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_868_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X2: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_869_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( sgn_sgn @ A @ A3 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_870_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_871_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_872_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_873_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_874_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_875_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R4: A,A3: A,B2: A,C2: A,D3: A] :
          ( ( R4
           != ( zero_zero @ A ) )
         => ( ( ( A3 = B2 )
              & ( C2 != D3 ) )
           => ( ( plus_plus @ A @ A3 @ ( times_times @ A @ R4 @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R4 @ D3 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_876_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_877_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_878_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ( A3 != B2 )
            & ( C2 != D3 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A3 @ D3 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_879_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y: A,X: A,Z2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y ) @ ( times_times @ A @ X @ Z2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z2 ) @ ( times_times @ A @ X @ Y ) ) )
          = ( ( W = X )
            | ( Y = Z2 ) ) ) ) ).

% crossproduct_eq
thf(fact_880_nat__1__eq__mult__iff,axiom,
    ! [M2: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M2 @ N ) )
      = ( ( M2
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_881_nat__mult__eq__1__iff,axiom,
    ! [M2: nat,N: nat] :
      ( ( ( times_times @ nat @ M2 @ N )
        = ( one_one @ nat ) )
      = ( ( M2
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_882_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_883_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_884_mult__eq__self__implies__10,axiom,
    ! [M2: nat,N: nat] :
      ( ( M2
        = ( times_times @ nat @ M2 @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M2
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_885_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_886_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M2 ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M2 ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_887_remove__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remove @ A @ X @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( insert @ A @ X @ Xs ) ) ) ).

% remove_code(2)
thf(fact_888_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_889_part__code_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Pivot: A] :
          ( ( linorder_part @ B @ A @ F2 @ Pivot @ ( nil @ B ) )
          = ( product_Pair @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( nil @ B ) @ ( product_Pair @ ( list @ B ) @ ( list @ B ) @ ( nil @ B ) @ ( nil @ B ) ) ) ) ) ).

% part_code(1)
thf(fact_890_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_891_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_892_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_893_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_894_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_895_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_896_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_897_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% div_by_1
thf(fact_898_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_899_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( one_one @ nat ) )
          = A3 ) ) ).

% power_one_right
thf(fact_900_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_901_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_902_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_903_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_904_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_905_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ B2 )
            = A3 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_906_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ A3 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_907_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_908_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_909_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( A3
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_910_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ A3 )
            = ( one_one @ A ) )
          = ( ( A3
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_911_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( ( A3
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A3 @ A3 )
              = ( zero_zero @ A ) ) )
          & ( ( A3
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A3 @ A3 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_912_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ A3 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_913_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A3 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_914_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_915_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ A3 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_916_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ( power_power @ A @ A3 @ M2 )
              = ( power_power @ A @ A3 @ N ) )
            = ( M2 = N ) ) ) ) ).

% power_inject_exp
thf(fact_917_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_918_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( divide_divide @ A @ A3 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A3 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_919_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_920_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_921_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_922_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_923_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_924_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A3 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_925_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A3 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_926_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_927_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_928_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_929_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less @ nat @ X @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_930_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A3 ) )
          = A3 ) ) ).

% left_minus_one_mult_self
thf(fact_931_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_932_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_933_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_934_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_935_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_936_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M2 ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M2 ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_937_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less_eq @ nat @ X @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_938_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_one_over
thf(fact_939_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M2: nat,N: nat] :
          ( ( power_power @ A @ A3 @ ( plus_plus @ nat @ M2 @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ M2 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_add
thf(fact_940_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_941_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A3 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_942_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ A3 )
          = ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_commutes
thf(fact_943_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_944_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ).

% divide_divide_times_eq
thf(fact_945_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z2: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_946_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% one_le_power
thf(fact_947_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_948_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A3
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A3 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_949_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A3 )
            = ( B2
              = ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_950_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A3 @ C2 )
              = B2 )
           => ( A3
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_951_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A3 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A3 ) ) ) ) ).

% divide_eq_imp
thf(fact_952_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_953_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A3 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_954_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y )
                = ( divide_divide @ A @ W @ Z2 ) )
              = ( ( times_times @ A @ X @ Z2 )
                = ( times_times @ A @ W @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_955_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = ( one_one @ A ) )
            = ( A3 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_956_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_957_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_958_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_959_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_960_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_961_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_962_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_963_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_964_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_965_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_966_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_967_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_968_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_969_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_970_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_971_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_972_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A3 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_973_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less @ A @ B2 @ A3 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A3 @ B2 ) )
            | ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_974_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_add_eq_iff
thf(fact_975_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% add_divide_eq_iff
thf(fact_976_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_977_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_978_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_979_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_980_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_981_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N2: nat,A3: A] :
          ( ( ord_less @ nat @ N @ N2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ A3 @ N2 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_982_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ A @ ( power_power @ A @ A3 @ M2 ) @ ( power_power @ A @ A3 @ N ) )
           => ( ord_less @ nat @ M2 @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_983_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_minus
thf(fact_984_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N2: nat,A3: A] :
          ( ( ord_less_eq @ nat @ N @ N2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N ) @ ( power_power @ A @ A3 @ N2 ) ) ) ) ) ).

% power_increasing
thf(fact_985_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ A3 @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_986_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_987_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A3 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_988_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A3 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_989_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A3 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A3 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_990_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_991_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( ( divide_divide @ A @ A3 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A3
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_992_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_993_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_994_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ Y ) @ X )
           => ( ord_less_eq @ A @ Z2 @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_995_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z2 @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_996_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_997_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_998_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_999_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1000_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A3 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1001_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1002_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1003_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A3 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ A3 @ B2 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A3 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1004_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A3 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
              & ( ord_less_eq @ A @ B2 @ A3 ) )
            | ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A3 @ B2 ) )
            | ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1005_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N2: nat,A3: A] :
          ( ( ord_less @ nat @ N @ N2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A3 @ N2 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1006_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N2: nat,A3: A] :
          ( ( ord_less_eq @ nat @ N @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ N2 ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_1007_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,M2: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A3 @ M2 ) @ ( power_power @ A @ A3 @ N ) )
           => ( ord_less_eq @ nat @ M2 @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_1008_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_1009_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1010_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1011_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1012_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1013_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A3 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1014_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1015_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_1016_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1017_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1018_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1019_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1020_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A3 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1021_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_1022_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A3 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_1023_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_1024_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_1025_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A3 ) ) ) ).

% div_minus1_right
thf(fact_1026_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_1027_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_1028_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_1029_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ A3 @ ( one_one @ A ) )
          = A3 ) ) ).

% bits_div_by_1
thf(fact_1030_div__less__dividend,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M2 @ N ) @ M2 ) ) ) ).

% div_less_dividend
thf(fact_1031_div__eq__dividend__iff,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( ( divide_divide @ nat @ M2 @ N )
          = M2 )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1032_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1033_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1034_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_minus'
thf(fact_1035_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1036_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1037_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs @ Y ) @ ( one_one @ nat ) ) ) )
      & ( ( X != Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( count_list @ A @ Xs @ Y ) ) ) ) ).

% count_list.simps(2)
thf(fact_1038_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,C2: A,A3: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_1039_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,A3: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A3 )
         => ( ( times_times @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_1040_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A3: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A3 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_1041_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A3: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_1042_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A3 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A3 )
            = ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_1043_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A10: A > B,B6: A > B,X2: A] : ( minus_minus @ B @ ( A10 @ X2 ) @ ( B6 @ X2 ) ) ) ) ) ).

% minus_apply
thf(fact_1044_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_1045_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% diff_0_right
thf(fact_1046_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A3 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_1047_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) ).

% diff_zero
thf(fact_1048_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ A3 @ A3 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_1049_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V2: num,W: num,Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) @ Z2 ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_1050_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_1051_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% add_diff_cancel
thf(fact_1052_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% diff_add_cancel
thf(fact_1053_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A3 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A3 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1054_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ A3 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1055_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A3 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1056_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ B2 )
          = A3 ) ) ).

% add_diff_cancel_right'
thf(fact_1057_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A3 ) ) ) ).

% minus_diff_eq
thf(fact_1058_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M2: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ M2 ) ) @ ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M2 @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_1059_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,M2: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ M2 ) ) @ ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M2 @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_1060_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_1061_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( ord_less @ A @ B2 @ A3 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_1062_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1063_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1064_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A3: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_1065_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_1066_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1067_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A3: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1068_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A3 )
          = ( uminus_uminus @ A @ A3 ) ) ) ).

% diff_0
thf(fact_1069_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1070_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1071_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1072_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A3 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1073_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A3 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1074_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A3 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_1075_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_1076_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A3 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_1077_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_1078_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1079_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A3 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_1080_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_1081_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A3 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1082_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A3 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1083_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A3 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1084_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( A3
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1085_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A3: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A3 )
          = ( ord_less @ A @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1086_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,W: num] :
          ( ( ord_less @ A @ A3 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A3 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1087_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A10: A > B,B6: A > B,X2: A] : ( minus_minus @ B @ ( A10 @ X2 ) @ ( B6 @ X2 ) ) ) ) ) ).

% fun_diff_def
thf(fact_1088_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( A3 = B2 )
            = ( C2 = D3 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_1089_cancel__ab__semigroup__add__class_Odiff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A3 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% cancel_ab_semigroup_add_class.diff_right_commute
thf(fact_1090_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,D3: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ D3 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ) ).

% diff_mono
thf(fact_1091_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_1092_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_1093_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D3 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_1094_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( minus_minus @ A @ A4 @ B3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_1095_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,D3: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_less @ A @ D3 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_1096_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( ord_less @ A @ A3 @ B2 )
            = ( ord_less @ A @ C2 @ D3 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_1097_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_1098_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_1099_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: A,K: A,A3: A,B2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A3 ) )
         => ( ( minus_minus @ A @ A5 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1100_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = C2 )
          = ( A3
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1101_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( A3
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A3 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1102_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1103_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1104_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1105_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1106_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A3 )
         => ( C2
            = ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1107_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A3 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1108_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_1109_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A3 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A3 ) @ ( times_times @ A @ C2 @ A3 ) ) ) ) ).

% left_diff_distrib'
thf(fact_1110_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_1111_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_1112_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A3: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A3 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1113_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,C2: A,A3: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_1114_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,A3: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A3 )
         => ( ( times_times @ A @ A3 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_1115_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1116_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1117_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A3 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1118_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1119_ordered__cancel__comm__monoid__diff__class_Odiff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add
thf(fact_1120_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% le_add_diff
thf(fact_1121_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1122_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1123_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A3 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1124_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1125_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A3 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1126_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A3 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A3 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1127_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( plus_plus @ A @ A3 @ ( minus_minus @ A @ B2 @ A3 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1128_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A3 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A3 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1129_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1130_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A3 @ B2 ) @ C2 )
          = ( ord_less @ A @ A3 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1131_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E2 ) @ C2 )
            = D3 ) ) ) ).

% eq_add_iff1
thf(fact_1132_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E2 ) @ D3 ) ) ) ) ).

% eq_add_iff2
thf(fact_1133_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X: A,Y: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ A @ X @ Y ) ) ) ) ).

% square_diff_square_factored
thf(fact_1134_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1135_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1136_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B4: A,K: A,B2: A,A3: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A3 @ B4 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1137_diff__eq,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( minus_minus @ A )
        = ( ^ [X2: A,Y2: A] : ( inf_inf @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% diff_eq
thf(fact_1138_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_1139_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_1140_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_1141_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1142_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1143_le__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E2 ) @ C2 ) @ D3 ) ) ) ).

% le_add_iff1
thf(fact_1144_le__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E2 ) @ D3 ) ) ) ) ).

% le_add_iff2
thf(fact_1145_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A3 @ B2 ) @ E2 ) @ C2 ) @ D3 ) ) ) ).

% less_add_iff1
thf(fact_1146_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A3: A,E2: A,C2: A,B2: A,D3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A3 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D3 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A3 ) @ E2 ) @ D3 ) ) ) ) ).

% less_add_iff2
thf(fact_1147_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1148_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1149_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y @ Z2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ Y ) @ Z2 ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1150_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1151_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A3 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A3 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A3 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1152_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1153_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1154_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1155_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M2 ) ) ) ).

% neg_one_le_numeral
thf(fact_1156_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1157_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_1158_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_1159_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1160_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1161_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1162_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M2 ) ) ) ).

% neg_one_less_numeral
thf(fact_1163_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1164_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X2: A] : ( minus_minus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_1165_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1166_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z2: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1167_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1168_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A3 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A3 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1169_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A3: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A3 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1170_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_1171_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_1172_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_1173_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_1174_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_1175_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N3 @ ( times_times @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1176_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V2: A,R4: A,S3: A] :
          ( ( ord_less_eq @ A @ U @ V2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R4 )
           => ( ( ord_less_eq @ A @ R4 @ S3 )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R4 @ ( minus_minus @ A @ V2 @ U ) ) @ S3 ) ) @ V2 ) ) ) ) ) ).

% scaling_mono
thf(fact_1177_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_1178_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_1179_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_1180_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_1181_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,N: nat,M2: nat] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M2 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A3 @ M2 ) @ ( power_power @ A @ A3 @ N ) )
                = ( power_power @ A @ A3 @ ( minus_minus @ nat @ M2 @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M2 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A3 @ M2 ) @ ( power_power @ A @ A3 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1182_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P5: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P5 @ ( power_power @ A @ P5 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1183_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(170)
thf(fact_1184_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(171)
thf(fact_1185_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W ) ) @ Y ) ) ) ).

% semiring_norm(172)
thf(fact_1186_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1187_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1188_slice__Cons,axiom,
    ! [A: $tType,Begin: nat,End: nat,X: A,Xs: list @ A] :
      ( ( ( ( Begin
            = ( zero_zero @ nat ) )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ End ) )
       => ( ( slice @ A @ Begin @ End @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( slice @ A @ Begin @ ( minus_minus @ nat @ End @ ( one_one @ nat ) ) @ Xs ) ) ) )
      & ( ~ ( ( Begin
              = ( zero_zero @ nat ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ End ) )
       => ( ( slice @ A @ Begin @ End @ ( cons @ A @ X @ Xs ) )
          = ( slice @ A @ ( minus_minus @ nat @ Begin @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ End @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% slice_Cons
thf(fact_1189_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P2: A > $o,D2: A,Q2: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P2 @ X3 )
              = ( P2 @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D2 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q2 @ X3 )
                = ( Q2 @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D2 ) ) ) )
           => ! [X4: A,K3: A] :
                ( ( ( P2 @ X4 )
                  & ( Q2 @ X4 ) )
                = ( ( P2 @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) )
                  & ( Q2 @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1190_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P2: A > $o,D2: A,Q2: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P2 @ X3 )
              = ( P2 @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D2 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q2 @ X3 )
                = ( Q2 @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D2 ) ) ) )
           => ! [X4: A,K3: A] :
                ( ( ( P2 @ X4 )
                  | ( Q2 @ X4 ) )
                = ( ( P2 @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) )
                  | ( Q2 @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1191_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_1192_Diff__disjoint,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B4 @ A5 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_disjoint
thf(fact_1193_inter__compl__diff__conv,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ A5 @ B4 ) ) ).

% inter_compl_diff_conv
thf(fact_1194_Diff__Compl,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ).

% Diff_Compl
thf(fact_1195_slice__Nil,axiom,
    ! [A: $tType,Begin: nat,End: nat] :
      ( ( slice @ A @ Begin @ End @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% slice_Nil
thf(fact_1196_slice__eq__bounds__empty,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( slice @ A @ I2 @ I2 @ Xs )
      = ( nil @ A ) ) ).

% slice_eq_bounds_empty
thf(fact_1197_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M2 ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_1198_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_1199_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M2 ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_1200_Int__Diff,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ C5 )
      = ( inf_inf @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Int_Diff
thf(fact_1201_Diff__Int2,axiom,
    ! [A: $tType,A5: set @ A,C5: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ C5 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ C5 ) @ B4 ) ) ).

% Diff_Int2
thf(fact_1202_Diff__Diff__Int,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ).

% Diff_Diff_Int
thf(fact_1203_Diff__Int__distrib,axiom,
    ! [A: $tType,C5: set @ A,A5: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ C5 @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ C5 @ A5 ) @ ( inf_inf @ ( set @ A ) @ C5 @ B4 ) ) ) ).

% Diff_Int_distrib
thf(fact_1204_Diff__Int__distrib2,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) @ C5 )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ C5 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Diff_Int_distrib2
thf(fact_1205_disjoint__alt__simp3,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) @ A5 )
      = ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_alt_simp3
thf(fact_1206_disjoint__alt__simp1,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A5 @ B4 )
        = A5 )
      = ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% disjoint_alt_simp1
thf(fact_1207_disjoint__alt__simp2,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ B4 )
         != A5 ) )
      = ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_alt_simp2
thf(fact_1208_Diff__triv,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( minus_minus @ ( set @ A ) @ A5 @ B4 )
        = A5 ) ) ).

% Diff_triv
thf(fact_1209_Int__Diff__disjoint,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_Diff_disjoint
thf(fact_1210_Diff__Un,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) )
      = ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A5 @ C5 ) ) ) ).

% Diff_Un
thf(fact_1211_Diff__Int,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A5 @ C5 ) ) ) ).

% Diff_Int
thf(fact_1212_Int__Diff__Un,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) )
      = A5 ) ).

% Int_Diff_Un
thf(fact_1213_Un__Diff__Int,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
      = A5 ) ).

% Un_Diff_Int
thf(fact_1214_minus__assn__def,axiom,
    ( ( minus_minus @ assn )
    = ( ^ [A4: assn,B3: assn] : ( inf_inf @ assn @ A4 @ ( uminus_uminus @ assn @ B3 ) ) ) ) ).

% minus_assn_def
thf(fact_1215_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_1216_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M2 @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1217_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1218_power_Opower__eq__if,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( ^ [One: A,Times: A > A > A,P5: A,M3: nat] :
            ( if @ A
            @ ( M3
              = ( zero_zero @ nat ) )
            @ One
            @ ( Times @ P5 @ ( power2 @ A @ One @ Times @ P5 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% power.power_eq_if
thf(fact_1219_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_1220_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_1221_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_1222_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M2 != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1223_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) )
          = ( ( M2 != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1224_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_1225_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_1226_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_1227_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_1228_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ N ) )
      = ( nth @ A @ Xs @ N ) ) ).

% nth_Cons_Suc
thf(fact_1229_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_1230_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X ) @ ( enumerate @ B @ ( suc @ N ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_1231_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_1232_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_1233_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1234_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1235_Suc__diff,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M2 )
       => ( ( suc @ ( minus_minus @ nat @ N @ M2 ) )
          = ( minus_minus @ nat @ N @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ).

% Suc_diff
thf(fact_1236_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs: list @ A,V2: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_1237_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ A3 @ ( power_power @ A @ A3 @ N ) ) ) ) ).

% power_Suc
thf(fact_1238_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A3 @ N ) @ A3 ) ) ) ).

% power_Suc2
thf(fact_1239_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_1240_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N3: nat] : ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_1241_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_1242_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_1243_diff__Suc__eq__diff__pred,axiom,
    ! [M2: nat,N: nat] :
      ( ( minus_minus @ nat @ M2 @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1244_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ A3 @ ( numeral_numeral @ A @ one2 ) )
          = A3 ) ) ).

% mult_numeral_1_right
thf(fact_1245_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A3 )
          = A3 ) ) ).

% mult_numeral_1
thf(fact_1246_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_1247_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_1248_gen__length__code_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs: list @ B] :
      ( ( gen_length @ B @ N @ ( cons @ B @ X @ Xs ) )
      = ( gen_length @ B @ ( suc @ N ) @ Xs ) ) ).

% gen_length_code(2)
thf(fact_1249_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A3 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_1250_nat__induct__non__zero,axiom,
    ! [N: nat,P2: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P2 @ ( one_one @ nat ) )
       => ( ! [N4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N4 )
             => ( ( P2 @ N4 )
               => ( P2 @ ( suc @ N4 ) ) ) )
         => ( P2 @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_1251_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_1252_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_1253_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_1254_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = X ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_1255_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A3 @ ( suc @ N ) ) @ A3 ) ) ) ) ).

% power_Suc_le_self
thf(fact_1256_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A3 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_1257_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M2 ) @ N )
        = ( minus_minus @ nat @ M2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1258_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1259_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N3
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% add_eq_if
thf(fact_1260_Suc__n__minus__m__eq,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ M2 )
       => ( ( suc @ ( minus_minus @ nat @ N @ M2 ) )
          = ( minus_minus @ nat @ N @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ).

% Suc_n_minus_m_eq
thf(fact_1261_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A,N: nat] :
      ( ( X != Y )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = Y )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_1262_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_1263_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1264_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_1265_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_1266_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% diff_numeral_special(8)
thf(fact_1267_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_1268_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M2 @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_1269_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_1270_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_1271_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_1272_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M2 @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_1273_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_1274_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_1275_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_1276_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1277_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1278_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1279_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1280_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_1281_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M2 @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_1282_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_1283_pos__zdiv__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( divide_divide @ int @ B2 @ A3 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_1284_neg__zdiv__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ A3 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A3 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_1285_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_1286_int__bit__induct,axiom,
    ! [P2: int > $o,K: int] :
      ( ( P2 @ ( zero_zero @ int ) )
     => ( ( P2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P2 @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P2 @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P2 @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P2 @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_1287_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ A3 @ ( plus_plus @ A @ A3 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_1288_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2_right
thf(fact_1289_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2
thf(fact_1290_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A3 @ A3 ) ) ) ).

% power2_eq_square
thf(fact_1291_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_1292_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_1293_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_1294_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A3: A] :
          ( ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A3
              = ( one_one @ A ) )
            | ( A3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_1295_nat__induct2,axiom,
    ! [P2: nat > $o,N: nat] :
      ( ( P2 @ ( zero_zero @ nat ) )
     => ( ( P2 @ ( one_one @ nat ) )
       => ( ! [N4: nat] :
              ( ( P2 @ N4 )
             => ( P2 @ ( plus_plus @ nat @ N4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P2 @ N ) ) ) ) ).

% nat_induct2
thf(fact_1296_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_1297_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_1298_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A3 ) @ N ) )
          = ( power_power @ A @ A3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_1299_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A,N: nat] :
          ( ( power_power @ A @ A3 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A3 @ ( power_power @ A @ ( power_power @ A @ A3 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_1300_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N4: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N4 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N4 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_1301_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N4: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N4 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N4 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_1302_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R4: A,Q4: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R4 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R4 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R4 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R4 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q4 @ R4 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R4 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_1303_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_1304_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_1305_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1306_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1307_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1308_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,M2: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M2 )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M2 @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1309_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1310_nat__dvd__1__iff__1,axiom,
    ! [M2: nat] :
      ( ( dvd_dvd @ nat @ M2 @ ( one_one @ nat ) )
      = ( M2
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1311_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A3 ) @ ( times_times @ A @ C2 @ A3 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1312_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( times_times @ A @ A3 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1313_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1314_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1315_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1316_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A3 ) @ B2 ) )
          = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1317_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1318_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_1319_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A3 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_1320_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_1321_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_1322_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_1323_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A3 ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_1324_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_1325_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_1326_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1327_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ A3 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1328_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1329_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1330_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
            = A3 ) ) ) ).

% unit_div_1_div_1
thf(fact_1331_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A3 ) @ A3 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1332_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A3 ) )
            = ( divide_divide @ A @ B2 @ A3 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1333_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A] :
          ( ( modulo_modulo @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1334_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_1335_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1336_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_1337_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_1338_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1339_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_1340_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_1341_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1342_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1343_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1344_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1345_mod2__gr__0,axiom,
    ! [M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_1346_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_1347_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1348_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1349_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1350_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1351_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A3 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1352_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1353_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1354_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_1355_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1356_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1357_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1358_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1359_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1360_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A3: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A3 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A3 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A3 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A3 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1361_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A3: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A3 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A3 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A3 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A3 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A3 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1362_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A3 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1363_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_1364_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_1365_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_1366_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_1367_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,A9: A,B2: A,B7: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ A9 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B7 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A9 @ B7 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_1368_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A3 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_1369_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] : ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ A3 ) ) ) ).

% dvd_triv_right
thf(fact_1370_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1371_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D3 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1372_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A] : ( dvd_dvd @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1373_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A3 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1374_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1375_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ C2 )
         => ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1376_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B3: A,A4: A] :
            ? [K4: A] :
              ( A4
              = ( times_times @ A @ B3 @ K4 ) ) ) ) ) ).

% dvd_def
thf(fact_1377_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A3: A,B2: A,K: A] :
          ( ( A3
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% dvdI
thf(fact_1378_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ~ ! [K2: A] :
                ( A3
               != ( times_times @ A @ B2 @ K2 ) ) ) ) ).

% dvdE
thf(fact_1379_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1380_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A3 ) ) ) ).

% unit_imp_dvd
thf(fact_1381_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A3 ) ) ).

% one_dvd
thf(fact_1382_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
          = ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1383_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A3 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D4: A] :
                ( B2
               != ( plus_plus @ A @ A3 @ ( times_times @ A @ C2 @ D4 ) ) ) ) ) ).

% mod_eqE
thf(fact_1384_pos__zmod__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A3 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A3 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1385_neg__zmod__mult__2,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ int @ A3 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A3 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1386_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1387_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A3 )
              = ( times_times @ A @ C2 @ A3 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1388_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A3 @ B2 )
              = ( times_times @ A @ A3 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1389_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1390_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1391_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1392_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1393_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1394_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A3 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1395_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1396_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( divide_divide @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1397_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A3 )
         => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1398_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1399_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,D3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A3 )
         => ( ( dvd_dvd @ A @ D3 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ ( divide_divide @ A @ C2 @ D3 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ D3 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1400_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1401_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A3 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1402_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A3 )
              = ( divide_divide @ A @ C2 @ A3 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1403_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1404_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
           => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1405_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A3 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_1406_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A3 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_1407_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( A3
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_1408_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = A3 ) ) ).

% div_mult_mod_eq
thf(fact_1409_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) )
          = A3 ) ) ).

% mod_div_mult_eq
thf(fact_1410_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) )
          = A3 ) ) ).

% mod_mult_div_eq
thf(fact_1411_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A3: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = A3 ) ) ).

% mult_div_mod_eq
thf(fact_1412_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A3 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_1413_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1414_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1415_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( modulo_modulo @ A @ A3 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1416_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A3: A,B2: A] :
          ( ( minus_minus @ A @ A3 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A3 @ B2 ) ) )
          = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1417_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P2: A > $o,L: A] :
          ( ( ? [X2: A] : ( P2 @ ( times_times @ A @ L @ X2 ) ) )
          = ( ? [X2: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X2 @ ( zero_zero @ A ) ) )
                & ( P2 @ X2 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1418_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ~ ( ( A3
               != ( zero_zero @ A ) )
             => ! [C4: A] :
                  ( B2
                 != ( times_times @ A @ A3 @ C4 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1419_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D3: A,D2: A,T3: A] :
          ( ( dvd_dvd @ A @ D3 @ D2 )
         => ! [X4: A,K3: A] :
              ( ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ X4 @ T3 ) )
              = ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) @ T3 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1420_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D3: A,D2: A,T3: A] :
          ( ( dvd_dvd @ A @ D3 @ D2 )
         => ! [X4: A,K3: A] :
              ( ( ~ ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ X4 @ T3 ) ) )
              = ( ~ ( dvd_dvd @ A @ D3 @ ( plus_plus @ A @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D2 ) ) @ T3 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1421_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A3 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A3 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A3 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1422_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1423_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1424_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A,D3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A3 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D3 )
               => ( ( ( divide_divide @ A @ B2 @ A3 )
                    = ( divide_divide @ A @ D3 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A3 @ D3 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1425_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = ( zero_zero @ A ) )
            = ( A3
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1426_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1427_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A3 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1428_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1429_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A3 )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1430_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A3
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A3 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1431_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A3 @ B2 )
              = C2 )
            = ( A3
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1432_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A3 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1433_power__dvd__imp__le,axiom,
    ! [I2: nat,M2: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I2 @ M2 ) @ ( power_power @ nat @ I2 @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I2 )
       => ( ord_less_eq @ nat @ M2 @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_1434_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ~ ( ( A3
               != ( zero_zero @ A ) )
             => ! [B5: A] :
                  ( ( B5
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B5 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A3 )
                        = B5 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B5 )
                          = A3 )
                       => ( ( ( times_times @ A @ A3 @ B5 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A3 )
                           != ( times_times @ A @ C2 @ B5 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1435_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ A3 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1436_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A3 @ ( times_times @ A @ B2 @ A3 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1437_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ~ ! [B5: A] :
                ( A3
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B5 ) ) ) ) ).

% evenE
thf(fact_1438_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1439_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M2: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ X @ N ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M2 @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1440_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N ) ) ) ) ).

% dvd_power
thf(fact_1441_dvd__mult__cancel2,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M2 ) @ M2 )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1442_dvd__mult__cancel1,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M2 @ N ) @ M2 )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1443_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_1444_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_1445_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A3 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1446_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A3 ) ) ) ).

% even_two_times_div_two
thf(fact_1447_Suc__times__mod__eq,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M2 )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M2 @ N ) ) @ M2 )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_1448_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_1449_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ~ ! [B5: A] :
                ( A3
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B5 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1450_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_1451_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A3 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_1452_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat,A3: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1453_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
                = ( modulo_modulo @ A @ X @ M2 ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M2 ) @ M2 ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_1454_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A3 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1455_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M2 @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_1456_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M2 @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_1457_zle__add1__eq__le,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z2 ) ) ).

% zle_add1_eq_le
thf(fact_1458_verit__le__mono__div,axiom,
    ! [A5: nat,B4: nat,N: nat] :
      ( ( ord_less @ nat @ A5 @ B4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A5 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B4 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B4 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_1459_verit__le__mono__div__int,axiom,
    ! [A5: int,B4: int,N: int] :
      ( ( ord_less @ int @ A5 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A5 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B4 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B4 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1460_zle__diff1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% zle_diff1_eq
thf(fact_1461_one__div__minus__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% one_div_minus_numeral
thf(fact_1462_minus__one__div__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_div_numeral
thf(fact_1463_one__mod__minus__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_1464_minus__one__mod__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_1465_int__less__induct,axiom,
    ! [I2: int,K: int,P2: int > $o] :
      ( ( ord_less @ int @ I2 @ K )
     => ( ( P2 @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ I3 @ K )
             => ( ( P2 @ I3 )
               => ( P2 @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P2 @ I2 ) ) ) ) ).

% int_less_induct
thf(fact_1466_int__le__induct,axiom,
    ! [I2: int,K: int,P2: int > $o] :
      ( ( ord_less_eq @ int @ I2 @ K )
     => ( ( P2 @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P2 @ I3 )
               => ( P2 @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P2 @ I2 ) ) ) ) ).

% int_le_induct
thf(fact_1467_zless__add1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z2 )
        | ( W = Z2 ) ) ) ).

% zless_add1_eq
thf(fact_1468_int__gr__induct,axiom,
    ! [K: int,I2: int,P2: int > $o] :
      ( ( ord_less @ int @ K @ I2 )
     => ( ( P2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ K @ I3 )
             => ( ( P2 @ I3 )
               => ( P2 @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P2 @ I2 ) ) ) ) ).

% int_gr_induct
thf(fact_1469_int__one__le__iff__zero__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% int_one_le_iff_zero_less
thf(fact_1470_pos__zmult__eq__1__iff,axiom,
    ! [M2: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M2 )
     => ( ( ( times_times @ int @ M2 @ N )
          = ( one_one @ int ) )
        = ( ( M2
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1471_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I4: int] :
          ( if @ int
          @ ( I4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_1472_odd__nonzero,axiom,
    ! [Z2: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1473_odd__less__0__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1474_int__ge__induct,axiom,
    ! [K: int,I2: int,P2: int > $o] :
      ( ( ord_less_eq @ int @ K @ I2 )
     => ( ( P2 @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ K @ I3 )
             => ( ( P2 @ I3 )
               => ( P2 @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P2 @ I2 ) ) ) ) ).

% int_ge_induct
thf(fact_1475_add1__zle__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% add1_zle_eq
thf(fact_1476_zless__imp__add1__zle,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ Z2 )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 ) ) ).

% zless_imp_add1_zle
thf(fact_1477_int__induct,axiom,
    ! [P2: int > $o,K: int,I2: int] :
      ( ( P2 @ K )
     => ( ! [I3: int] :
            ( ( ord_less_eq @ int @ K @ I3 )
           => ( ( P2 @ I3 )
             => ( P2 @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P2 @ I3 )
               => ( P2 @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P2 @ I2 ) ) ) ) ).

% int_induct
thf(fact_1478_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M2: int,N: int] :
      ( ( ( times_times @ int @ M2 @ N )
        = ( one_one @ int ) )
     => ( ( M2
          = ( one_one @ int ) )
        | ( M2
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1479_zmult__eq__1__iff,axiom,
    ! [M2: int,N: int] :
      ( ( ( times_times @ int @ M2 @ N )
        = ( one_one @ int ) )
      = ( ( ( M2
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1480_le__imp__0__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% le_imp_0_less
thf(fact_1481_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_1482_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A4: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1483_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q4: int,R4: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A3 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q4 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R4 ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1484_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A3: int,Q4: int,R4: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q4 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R4 ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1485_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1486_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1487_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1488_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1489_zminus1__lemma,axiom,
    ! [A3: int,B2: int,Q4: int,R4: int] :
      ( ( eucl_rel_int @ A3 @ B2 @ ( product_Pair @ int @ int @ Q4 @ R4 ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A3 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R4
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q4 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q4 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R4
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R4 ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_1490_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_1491_divmod__BitM__2__eq,axiom,
    ! [M2: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M2 ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_1492_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A3 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1493_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A4: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_1494_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K4: int,L3: int] :
          ( if @ int
          @ ( ( K4
              = ( zero_zero @ int ) )
            | ( L3
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L3
            @ ( if @ int
              @ ( L3
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K4
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_1495_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1496_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I4: int,J2: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J2 @ I4 ) @ Js @ ( upto_aux @ I4 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) @ ( cons @ int @ J2 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_1497_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_1498_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1499_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P2: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P2 )
            = ( one_one @ A ) )
          = P2 ) ) ).

% of_bool_eq_1_iff
thf(fact_1500_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_1501_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P2: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P2 ) @ ( one_one @ A ) )
          = ( ~ P2 ) ) ) ).

% of_bool_less_one_iff
thf(fact_1502_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A3 )
          = A3 ) ) ).

% and.left_neutral
thf(fact_1503_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A3 ) ) ).

% and.right_neutral
thf(fact_1504_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_1505_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P2: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P2 )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P2 ) ) ) ) ).

% of_bool_not_iff
thf(fact_1506_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_1507_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_1508_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_1509_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_1510_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( sgn_sgn @ A @ A3 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_1511_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_1512_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_1513_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(3)
thf(fact_1514_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_1515_and__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_1516_and__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_1517_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_1518_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(6)
thf(fact_1519_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(4)
thf(fact_1520_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A3 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_1521_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_1522_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_1523_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_1524_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_1525_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_1526_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1527_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1528_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_1529_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_1530_zmod__numeral__Bit1,axiom,
    ! [V2: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_1531_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_1532_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P2: $o,Q2: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P2
              & Q2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P2 ) @ ( zero_neq_one_of_bool @ A @ Q2 ) ) ) ) ).

% of_bool_conj
thf(fact_1533_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A3
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_1534_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P2: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P2 ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1535_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P5: $o] : ( if @ A @ P5 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1536_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P2: A > $o,P7: $o] :
          ( ( P2 @ ( zero_neq_one_of_bool @ A @ P7 ) )
          = ( ( P7
             => ( P2 @ ( one_one @ A ) ) )
            & ( ~ P7
             => ( P2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1537_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P2: A > $o,P7: $o] :
          ( ( P2 @ ( zero_neq_one_of_bool @ A @ P7 ) )
          = ( ~ ( ( P7
                  & ~ ( P2 @ ( one_one @ A ) ) )
                | ( ~ P7
                  & ~ ( P2 @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1538_and_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( comm_monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.comm_monoid_axioms
thf(fact_1539_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_1540_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_1541_and_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.monoid_axioms
thf(fact_1542_and_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( semilattice_neutr @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.semilattice_neutr_axioms
thf(fact_1543_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_1544_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A3: A] :
          ( ( power_power @ A @ A3 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A3 @ A3 ) @ A3 ) ) ) ).

% power3_eq_cube
thf(fact_1545_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_1546_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_1547_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_1548_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_1549_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A3 )
          = ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_1550_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_1551_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_1552_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P2: A > $o,A3: A] :
          ( ! [A6: A] :
              ( ( ( divide_divide @ A @ A6 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A6 )
             => ( P2 @ A6 ) )
         => ( ! [A6: A,B5: $o] :
                ( ( P2 @ A6 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B5 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A6 )
                 => ( P2 @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B5 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) ) ) )
           => ( P2 @ A3 ) ) ) ) ).

% bits_induct
thf(fact_1553_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_1554_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M2 @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ).

% exp_mod_exp
thf(fact_1555_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_1556_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_1557_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A3: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A3 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_1558_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_1559_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A3 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A3 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_1560_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M2 ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M2 @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_1561_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_1562_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_1563_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_1564_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K4: int,L3: int] :
          ( if @ int
          @ ( ( member2 @ int @ K4 @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member2 @ int @ L3 @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K4 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K4 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L3 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_1565_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( ( ( member2 @ int @ X @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member2 @ int @ Xa @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member2 @ int @ X @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member2 @ int @ Xa @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_1566_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_1567_upto__rec__numeral_I4_J,axiom,
    ! [M2: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_1568_upto__rec__numeral_I3_J,axiom,
    ! [M2: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_1569_Int__insert__right__if1,axiom,
    ! [A: $tType,A3: A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ A3 @ A5 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ ( insert3 @ A @ A3 @ B4 ) )
        = ( insert3 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% Int_insert_right_if1
thf(fact_1570_Int__insert__right__if0,axiom,
    ! [A: $tType,A3: A,A5: set @ A,B4: set @ A] :
      ( ~ ( member2 @ A @ A3 @ A5 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ ( insert3 @ A @ A3 @ B4 ) )
        = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ).

% Int_insert_right_if0
thf(fact_1571_insert__inter__insert,axiom,
    ! [A: $tType,A3: A,A5: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( insert3 @ A @ A3 @ A5 ) @ ( insert3 @ A @ A3 @ B4 ) )
      = ( insert3 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ).

% insert_inter_insert
thf(fact_1572_Int__insert__left__if1,axiom,
    ! [A: $tType,A3: A,C5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ A3 @ C5 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert3 @ A @ A3 @ B4 ) @ C5 )
        = ( insert3 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) ) ).

% Int_insert_left_if1
thf(fact_1573_Int__insert__left__if0,axiom,
    ! [A: $tType,A3: A,C5: set @ A,B4: set @ A] :
      ( ~ ( member2 @ A @ A3 @ C5 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert3 @ A @ A3 @ B4 ) @ C5 )
        = ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Int_insert_left_if0
thf(fact_1574_insert__disjoint_I1_J,axiom,
    ! [A: $tType,A3: A,A5: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( insert3 @ A @ A3 @ A5 ) @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member2 @ A @ A3 @ B4 )
        & ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% insert_disjoint(1)
thf(fact_1575_insert__disjoint_I2_J,axiom,
    ! [A: $tType,A3: A,A5: set @ A,B4: set @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ ( insert3 @ A @ A3 @ A5 ) @ B4 ) )
      = ( ~ ( member2 @ A @ A3 @ B4 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% insert_disjoint(2)
thf(fact_1576_disjoint__insert_I1_J,axiom,
    ! [A: $tType,B4: set @ A,A3: A,A5: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ B4 @ ( insert3 @ A @ A3 @ A5 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member2 @ A @ A3 @ B4 )
        & ( ( inf_inf @ ( set @ A ) @ B4 @ A5 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjoint_insert(1)
thf(fact_1577_disjoint__insert_I2_J,axiom,
    ! [A: $tType,A5: set @ A,B2: A,B4: set @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ A5 @ ( insert3 @ A @ B2 @ B4 ) ) )
      = ( ~ ( member2 @ A @ B2 @ A5 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% disjoint_insert(2)
thf(fact_1578_upto__Nil,axiom,
    ! [I2: int,J: int] :
      ( ( ( upto @ I2 @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil
thf(fact_1579_upto__Nil2,axiom,
    ! [I2: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I2 @ J ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil2
thf(fact_1580_upto__empty,axiom,
    ! [J: int,I2: int] :
      ( ( ord_less @ int @ J @ I2 )
     => ( ( upto @ I2 @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_1581_upto__single,axiom,
    ! [I2: int] :
      ( ( upto @ I2 @ I2 )
      = ( cons @ int @ I2 @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_1582_and__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_1583_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_1584_upto__rec__numeral_I1_J,axiom,
    ! [M2: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M2 ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_1585_upto__rec__numeral_I2_J,axiom,
    ! [M2: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M2 ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_1586_Int__insert__right,axiom,
    ! [A: $tType,A3: A,A5: set @ A,B4: set @ A] :
      ( ( ( member2 @ A @ A3 @ A5 )
       => ( ( inf_inf @ ( set @ A ) @ A5 @ ( insert3 @ A @ A3 @ B4 ) )
          = ( insert3 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) )
      & ( ~ ( member2 @ A @ A3 @ A5 )
       => ( ( inf_inf @ ( set @ A ) @ A5 @ ( insert3 @ A @ A3 @ B4 ) )
          = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% Int_insert_right
thf(fact_1587_Int__insert__left,axiom,
    ! [A: $tType,A3: A,C5: set @ A,B4: set @ A] :
      ( ( ( member2 @ A @ A3 @ C5 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert3 @ A @ A3 @ B4 ) @ C5 )
          = ( insert3 @ A @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) )
      & ( ~ ( member2 @ A @ A3 @ C5 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert3 @ A @ A3 @ B4 ) @ C5 )
          = ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) ) ).

% Int_insert_left
thf(fact_1588_upto__code,axiom,
    ( upto
    = ( ^ [I4: int,J2: int] : ( upto_aux @ I4 @ J2 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_1589_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K4: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K4 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_1590_upto_Oelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_1591_upto_Osimps,axiom,
    ( upto
    = ( ^ [I4: int,J2: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I4 @ J2 ) @ ( cons @ int @ I4 @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J2 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_1592_upto__rec1,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_1593_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_1594_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member2 @ int @ K @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member2 @ int @ L @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member2 @ int @ K @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member2 @ int @ L @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_1595_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ( member2 @ int @ X @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member2 @ int @ Xa @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member2 @ int @ X @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member2 @ int @ Xa @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_1596_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_1597_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_1598_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_1599_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_1600_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% xor_one_eq
thf(fact_1601_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A3 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% one_xor_eq
thf(fact_1602_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_1603_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_1604_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_1605_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% xor_numerals(1)
thf(fact_1606_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y ) ) ) ) ).

% xor_numerals(2)
thf(fact_1607_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_1608_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_1609_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_1610_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M3: nat,N3: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N3 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_1611_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( bit_se5824344971392196577ns_xor @ int @ K4 @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_1612_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se5824344971392196577ns_xor @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_1613_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_1614_mask__half__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_1615_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_1616_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N3: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_1617_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N3: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_1618_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P2: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K2: int,L4: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L4 ) )
           => ( ( ~ ( ( member2 @ int @ K2 @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member2 @ int @ L4 @ ( insert3 @ int @ ( zero_zero @ int ) @ ( insert3 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P2 @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P2 @ K2 @ L4 ) ) )
       => ( P2 @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_1619_upto_Opsimps,axiom,
    ! [I2: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J ) )
     => ( ( ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_1620_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_1621_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P2: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I3: int,J3: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J3 ) )
           => ( ( ( ord_less_eq @ int @ I3 @ J3 )
               => ( P2 @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) )
             => ( P2 @ I3 @ J3 ) ) )
       => ( P2 @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_1622_nat0__intermed__int__val,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_1623_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_1624_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_1625_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_1626_and__not__numerals_I8_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_1627_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_idempotent
thf(fact_1628_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_1629_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ( abs_abs @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_1630_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_1631_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_1632_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ A3 ) )
          = ( times_times @ A @ A3 @ A3 ) ) ) ).

% abs_mult_self_eq
thf(fact_1633_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_1634_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A3 ) )
          = ( abs_abs @ A @ A3 ) ) ) ).

% abs_minus_cancel
thf(fact_1635_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( abs_abs @ A @ A3 )
            = A3 ) ) ) ).

% abs_of_nonneg
thf(fact_1636_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ A3 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 ) ) ) ).

% abs_le_self_iff
thf(fact_1637_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_1638_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A3 ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_1639_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_1640_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_1641_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_1642_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_1643_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A3 )
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% abs_of_nonpos
thf(fact_1644_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_1645_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_1646_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(2)
thf(fact_1647_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_1648_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_1649_or__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_1650_or__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_1651_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_1652_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_1653_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_1654_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_1655_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_1656_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_1657_zabs__less__one__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z2 ) @ ( one_one @ int ) )
      = ( Z2
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_1658_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% or_numerals(3)
thf(fact_1659_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_1660_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(1)
thf(fact_1661_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_1662_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_1663_or__minus__minus__numerals,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_1664_and__minus__minus__numerals,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_1665_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_1666_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_1667_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ A3 @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_self
thf(fact_1668_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_1669_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_1670_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ).

% abs_minus_commute
thf(fact_1671_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M3: nat,N3: nat] : ( bit_se1065995026697491101ons_or @ nat @ N3 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_1672_or__not__numerals_I4_J,axiom,
    ! [M2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_1673_or__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(2)
thf(fact_1674_or__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(3)
thf(fact_1675_or__not__numerals_I7_J,axiom,
    ! [M2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_1676_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_1677_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_zero
thf(fact_1678_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A3 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_1679_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( abs_abs @ A @ A3 )
            = A3 ) ) ) ).

% abs_of_pos
thf(fact_1680_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A3 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_1681_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A3 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_1682_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_1683_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_1684_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A,C2: A,B2: A,D3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A3 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D3 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D3 ) ) ) ) ) ).

% abs_mult_less
thf(fact_1685_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_1686_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_1687_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A3 ) @ B2 )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_1688_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ ( abs_abs @ A @ A3 ) ) ) ).

% abs_ge_minus_self
thf(fact_1689_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K4: A] : ( times_times @ A @ K4 @ ( sgn_sgn @ A @ K4 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_1690_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( sgn_sgn @ A @ A3 ) )
          = A3 ) ) ).

% abs_mult_sgn
thf(fact_1691_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A3 ) @ ( abs_abs @ A @ A3 ) )
          = A3 ) ) ).

% sgn_mult_abs
thf(fact_1692_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) ).

% mult_sgn_abs
thf(fact_1693_abs__zmult__eq__1,axiom,
    ! [M2: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M2 @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M2 )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_1694_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( bit_se1065995026697491101ons_or @ int @ K4 @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_1695_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_1696_or__not__numerals_I5_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_1697_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_1698_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_1699_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
              | ( ord_less_eq @ A @ A3 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_1700_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A3 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_1701_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A3 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_1702_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( plus_plus @ A @ C2 @ D3 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A3 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D3 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_1703_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ A3 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A3 )
            = ( uminus_uminus @ A @ A3 ) ) ) ) ).

% abs_of_neg
thf(fact_1704_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( ( A3
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A3
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A3 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_1705_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_1706_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_1707_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A4: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_1708_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K4: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K4 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_1709_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_1710_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_1711_or__not__numerals_I8_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_1712_or__not__numerals_I9_J,axiom,
    ! [M2: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_1713_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N3: nat,K4: int] : ( bit_se5824344872417868541ns_and @ int @ K4 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_1714_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_1715_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A3 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A3 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A3 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_1716_and__not__numerals_I4_J,axiom,
    ! [M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M2 ) ) ) ).

% and_not_numerals(4)
thf(fact_1717_and__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_1718_zdvd__mult__cancel1,axiom,
    ! [M2: int,N: int] :
      ( ( M2
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M2 @ N ) @ M2 )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_1719_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_1720_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_1721_and__not__numerals_I7_J,axiom,
    ! [M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M2 ) ) ) ).

% and_not_numerals(7)
thf(fact_1722_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_1723_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K4: int,L3: int] :
          ( if @ int
          @ ( K4
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L3 )
          @ ( if @ int
            @ ( L3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K4 )
            @ ( if @ int
              @ ( K4
                = ( zero_zero @ int ) )
              @ L3
              @ ( if @ int
                @ ( L3
                  = ( zero_zero @ int ) )
                @ K4
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_1724_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_1725_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_1726_nat__intermed__int__val,axiom,
    ! [M2: nat,N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ( ord_less_eq @ nat @ M2 @ I3 )
            & ( ord_less @ nat @ I3 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M2 @ N )
       => ( ( ord_less_eq @ int @ ( F2 @ M2 ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
           => ? [I3: nat] :
                ( ( ord_less_eq @ nat @ M2 @ I3 )
                & ( ord_less_eq @ nat @ I3 @ N )
                & ( ( F2 @ I3 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_1727_decr__lemma,axiom,
    ! [D3: int,X: int,Z2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D3 ) ) @ Z2 ) ) ).

% decr_lemma
thf(fact_1728_incr__lemma,axiom,
    ! [D3: int,Z2: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ord_less @ int @ Z2 @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D3 ) ) ) ) ).

% incr_lemma
thf(fact_1729_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A3 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% or_one_eq
thf(fact_1730_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A3 )
          = ( plus_plus @ A @ A3 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) ) ) ) ) ).

% one_or_eq
thf(fact_1731_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_1732_nat__ivt__aux,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_1733_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_1734_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K4: int,L3: int] :
          ( if @ int
          @ ( ( K4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K4
              = ( zero_zero @ int ) )
            @ L3
            @ ( if @ int
              @ ( L3
                = ( zero_zero @ int ) )
              @ K4
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_1735_or__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_1736_or__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_1737_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_1738_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N3: nat,A4: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ A4
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_1739_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ( ( ( N3
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
              & ( ( N3
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_1740_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ! [J3: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A3 @ ( suc @ J3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A3 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_1741_max_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A3 @ B2 ) @ B2 )
          = ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.right_idem
thf(fact_1742_max_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_max @ A @ A3 @ ( ord_max @ A @ A3 @ B2 ) )
          = ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.left_idem
thf(fact_1743_max_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A] :
          ( ( ord_max @ A @ A3 @ A3 )
          = A3 ) ) ).

% max.idem
thf(fact_1744_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            & ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% max.bounded_iff
thf(fact_1745_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_1746_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% max.absorb1
thf(fact_1747_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) ).

% length_map
thf(fact_1748_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            & ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% max_less_iff_conj
thf(fact_1749_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_1750_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_max @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% max.absorb3
thf(fact_1751_drop__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_1752_zip__eq__zip__same__len,axiom,
    ! [A: $tType,B: $tType,A3: list @ A,B2: list @ B,A9: list @ A,B7: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ A3 )
        = ( size_size @ ( list @ B ) @ B2 ) )
     => ( ( ( size_size @ ( list @ A ) @ A9 )
          = ( size_size @ ( list @ B ) @ B7 ) )
       => ( ( ( zip @ A @ B @ A3 @ B2 )
            = ( zip @ A @ B @ A9 @ B7 ) )
          = ( ( A3 = A9 )
            & ( B2 = B7 ) ) ) ) ) ).

% zip_eq_zip_same_len
thf(fact_1753_length__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_enumerate
thf(fact_1754_length__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate1
thf(fact_1755_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_1756_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_1757_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_1758_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_1759_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_1760_length__splice,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( splice @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_splice
thf(fact_1761_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_1762_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_1763_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs ) @ N )
        = ( F2 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% nth_map
thf(fact_1764_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_1765_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
        = Xs ) ) ).

% map_fst_zip
thf(fact_1766_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
        = Ys ) ) ).

% map_snd_zip
thf(fact_1767_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_1768_length__ge__1__conv,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ L ) )
      = ( ( L
         != ( nil @ A ) ) ) ) ).

% length_ge_1_conv
thf(fact_1769_nth__zip,axiom,
    ! [A: $tType,B: $tType,I2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I2 ) @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ).

% nth_zip
thf(fact_1770_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs != Ys ) ) ).

% neq_if_length_neq
thf(fact_1771_Ex__list__of__length,axiom,
    ! [A: $tType,N: nat] :
    ? [Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs2 )
      = N ) ).

% Ex_list_of_length
thf(fact_1772_max_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_max @ A @ B2 @ ( ord_max @ A @ A3 @ C2 ) )
          = ( ord_max @ A @ A3 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.left_commute
thf(fact_1773_max_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B3: A] : ( ord_max @ A @ B3 @ A4 ) ) ) ) ).

% max.commute
thf(fact_1774_max_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A3 @ B2 ) @ C2 )
          = ( ord_max @ A @ A3 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.assoc
thf(fact_1775_pair__list__split,axiom,
    ! [A: $tType,B: $tType,L: list @ ( product_prod @ A @ B )] :
      ~ ! [L1: list @ A,L2: list @ B] :
          ( ( L
            = ( zip @ A @ B @ L1 @ L2 ) )
         => ( ( ( size_size @ ( list @ A ) @ L1 )
              = ( size_size @ ( list @ B ) @ L2 ) )
           => ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ L )
             != ( size_size @ ( list @ B ) @ L2 ) ) ) ) ).

% pair_list_split
thf(fact_1776_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N3 @ A4 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_1777_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_1778_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_1779_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% max.absorb_iff2
thf(fact_1780_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% max.absorb_iff1
thf(fact_1781_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less_eq @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less_eq @ A @ Z2 @ X )
            | ( ord_less_eq @ A @ Z2 @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_1782_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_1783_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ A3 @ ( ord_max @ A @ A3 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_1784_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( ord_max @ A @ A4 @ B3 ) ) ) ) ) ).

% max.order_iff
thf(fact_1785_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ A3 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 ) ) ) ) ).

% max.boundedI
thf(fact_1786_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A3 )
             => ~ ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) ).

% max.boundedE
thf(fact_1787_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( ord_max @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A3 ) ) ) ).

% max.orderI
thf(fact_1788_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( A3
            = ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_1789_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,D3: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ( ord_less_eq @ A @ D3 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D3 ) @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_1790_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A3: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_1791_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A3 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_1792_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( A4
                = ( ord_max @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_1793_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
         => ~ ( ( ord_less @ A @ B2 @ A3 )
             => ~ ( ord_less @ A @ C2 @ A3 ) ) ) ) ).

% max.strict_boundedE
thf(fact_1794_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            | ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% less_max_iff_disj
thf(fact_1795_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y @ Z2 ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% max_add_distrib_right
thf(fact_1796_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% max_add_distrib_left
thf(fact_1797_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y ) @ Z2 )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% max_diff_distrib_left
thf(fact_1798_sup__max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% sup_max
thf(fact_1799_length__induct,axiom,
    ! [A: $tType,P2: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs2: list @ A] :
          ( ! [Ys5: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys5 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P2 @ Ys5 ) )
         => ( P2 @ Xs2 ) )
     => ( P2 @ Xs ) ) ).

% length_induct
thf(fact_1800_finite__maxlen,axiom,
    ! [A: $tType,M: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M )
     => ? [N4: nat] :
        ! [X4: list @ A] :
          ( ( member2 @ ( list @ A ) @ X4 @ M )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X4 ) @ N4 ) ) ) ).

% finite_maxlen
thf(fact_1801_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs: list @ B,G: C > A,Ys: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ C @ A @ G @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) ).

% map_eq_imp_length_eq
thf(fact_1802_max_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( abel_semigroup @ A @ ( ord_max @ A ) ) ) ).

% max.abel_semigroup_axioms
thf(fact_1803_zip__inj,axiom,
    ! [A: $tType,B: $tType,A3: list @ A,B2: list @ B,A9: list @ A,B7: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ A3 )
        = ( size_size @ ( list @ B ) @ B2 ) )
     => ( ( ( size_size @ ( list @ A ) @ A9 )
          = ( size_size @ ( list @ B ) @ B7 ) )
       => ( ( ( zip @ A @ B @ A3 @ B2 )
            = ( zip @ A @ B @ A9 @ B7 ) )
         => ( ( A3 = A9 )
            & ( B2 = B7 ) ) ) ) ) ).

% zip_inj
thf(fact_1804_max_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice @ A @ ( ord_max @ A ) ) ) ).

% max.semilattice_axioms
thf(fact_1805_max_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_max @ A ) ) ) ).

% max.semigroup_axioms
thf(fact_1806_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_1807_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_1808_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_1809_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,Ws: list @ D,P2: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P2 @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B,Z4: C,Zs2: list @ C,W3: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ B ) @ Ys3 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys3 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P2 @ Xs2 @ Ys3 @ Zs2 @ Ws2 )
                       => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys3 ) @ ( cons @ C @ Z4 @ Zs2 ) @ ( cons @ D @ W3 @ Ws2 ) ) ) ) ) )
             => ( P2 @ Xs @ Ys @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_1810_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,P2: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P2 @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B,Z4: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = ( size_size @ ( list @ B ) @ Ys3 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys3 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P2 @ Xs2 @ Ys3 @ Zs2 )
                   => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys3 ) @ ( cons @ C @ Z4 @ Zs2 ) ) ) ) )
           => ( P2 @ Xs @ Ys @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_1811_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P2: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P2 @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = ( size_size @ ( list @ B ) @ Ys3 ) )
             => ( ( P2 @ Xs2 @ Ys3 )
               => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys3 ) ) ) )
         => ( P2 @ Xs @ Ys ) ) ) ) ).

% list_induct2
thf(fact_1812_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y2: A,Ys4: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y2 @ Ys4 ) )
            & ( ( size_size @ ( list @ A ) @ Ys4 )
              = N ) ) ) ) ).

% length_Suc_conv
thf(fact_1813_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y2: A,Ys4: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y2 @ Ys4 ) )
            & ( ( size_size @ ( list @ A ) @ Ys4 )
              = N ) ) ) ) ).

% Suc_length_conv
thf(fact_1814_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_1815_len__greater__imp__nonempty,axiom,
    ! [A: $tType,X: nat,L: list @ A] :
      ( ( ord_less @ nat @ X @ ( size_size @ ( list @ A ) @ L ) )
     => ( L
       != ( nil @ A ) ) ) ).

% len_greater_imp_nonempty
thf(fact_1816_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs
       != ( cons @ A @ X @ Ys ) ) ) ).

% impossible_Cons
thf(fact_1817_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y4: list @ A,Z5: list @ A] : ( Y4 = Z5 ) )
      = ( ^ [Xs4: list @ A,Ys4: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs4 )
              = ( size_size @ ( list @ A ) @ Ys4 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs4 ) )
               => ( ( nth @ A @ Xs4 @ I4 )
                  = ( nth @ A @ Ys4 @ I4 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_1818_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P2: nat > A > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ K )
           => ? [X5: A] : ( P2 @ I4 @ X5 ) ) )
      = ( ? [Xs4: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs4 )
              = K )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K )
               => ( P2 @ I4 @ ( nth @ A @ Xs4 @ I4 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_1819_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I3 )
              = ( nth @ A @ Ys @ I3 ) ) )
       => ( Xs = Ys ) ) ) ).

% nth_equalityI
thf(fact_1820_nths__all,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( member2 @ nat @ I3 @ I ) )
     => ( ( nths @ A @ Xs @ I )
        = Xs ) ) ).

% nths_all
thf(fact_1821_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_1822_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_1823_length__code,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( gen_length @ A @ ( zero_zero @ nat ) ) ) ).

% length_code
thf(fact_1824_gen__length__def,axiom,
    ! [A: $tType] :
      ( ( gen_length @ A )
      = ( ^ [N3: nat,Xs4: list @ A] : ( plus_plus @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs4 ) ) ) ) ).

% gen_length_def
thf(fact_1825_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff'
thf(fact_1826_length__compl__induct,axiom,
    ! [A: $tType,P2: ( list @ A ) > $o,L: list @ A] :
      ( ( P2 @ ( nil @ A ) )
     => ( ! [E: A,L4: list @ A] :
            ( ! [Ll: list @ A] :
                ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ll ) @ ( size_size @ ( list @ A ) @ L4 ) )
               => ( P2 @ Ll ) )
           => ( P2 @ ( cons @ A @ E @ L4 ) ) )
       => ( P2 @ L ) ) ) ).

% length_compl_induct
thf(fact_1827_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X2: A,Ys4: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Ys4 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys4 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_1828_list__decomp__1,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ L )
        = ( one_one @ nat ) )
     => ? [A6: A] :
          ( L
          = ( cons @ A @ A6 @ ( nil @ A ) ) ) ) ).

% list_decomp_1
thf(fact_1829_list__ex__length,axiom,
    ! [A: $tType] :
      ( ( list_ex @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] :
          ? [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs4 ) )
            & ( P @ ( nth @ A @ Xs4 @ N3 ) ) ) ) ) ).

% list_ex_length
thf(fact_1830_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A3: A,N: nat] :
          ( ( divide_divide @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_1831_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_1832_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_1833_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N ) ) ).

% bit_minus_int_iff
thf(fact_1834_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ ( product_prod @ A @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( zip @ A @ B @ Xs @ Ys )
          = Zs )
        = ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs )
            = Xs )
          & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs )
            = Ys ) ) ) ) ).

% zip_eq_conv
thf(fact_1835_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N4: nat] :
          ( ! [M4: nat] :
              ( ( ord_less_eq @ nat @ N4 @ M4 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M4 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N4 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N4 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N4 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N4 ) ) ) ) ) ).

% int_bit_bound
thf(fact_1836_list__decomp__2,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ L )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ? [A6: A,B5: A] :
          ( L
          = ( cons @ A @ A6 @ ( cons @ A @ B5 @ ( nil @ A ) ) ) ) ) ).

% list_decomp_2
thf(fact_1837_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_1838_nth__enumerate__eq,axiom,
    ! [A: $tType,M2: nat,Xs: list @ A,N: nat] :
      ( ( ord_less @ nat @ M2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ M2 )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M2 ) @ ( nth @ A @ Xs @ M2 ) ) ) ) ).

% nth_enumerate_eq
thf(fact_1839_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_1840_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_1841_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N3 @ A4 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N3 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N3 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_1842_in__set__enumerate__eq,axiom,
    ! [A: $tType,P7: product_prod @ nat @ A,N: nat,Xs: list @ A] :
      ( ( member2 @ ( product_prod @ nat @ A ) @ P7 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P7 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P7 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P7 ) @ N ) )
          = ( product_snd @ nat @ A @ P7 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_1843_sorted__in__between,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: nat,J: nat,L: list @ A,X: A] :
          ( ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ I2 )
         => ( ( ord_less @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ L ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
               => ( ( ord_less_eq @ A @ ( nth @ A @ L @ I2 ) @ X )
                 => ( ( ord_less @ A @ X @ ( nth @ A @ L @ J ) )
                   => ~ ! [K2: nat] :
                          ( ( ord_less_eq @ nat @ I2 @ K2 )
                         => ( ( ord_less @ nat @ K2 @ J )
                           => ( ( ord_less_eq @ A @ ( nth @ A @ L @ K2 ) @ X )
                             => ~ ( ord_less @ A @ X @ ( nth @ A @ L @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% sorted_in_between
thf(fact_1844_Cons__lenlex__iff,axiom,
    ! [A: $tType,M2: A,Ms: list @ A,N: A,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M2 @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R4 ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M2 @ N ) @ R4 ) )
        | ( ( M2 = N )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R4 ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_1845_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( lex @ A @ R4 ) )
      = ( ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X = Y )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R4 ) ) ) ) ) ).

% Cons_in_lex
thf(fact_1846_nat__numeral__diff__1,axiom,
    ! [V2: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V2 ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_1847_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_1848_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list @ A] : ( finite_finite @ A @ ( set2 @ A @ Xs ) ) ).

% List.finite_set
thf(fact_1849_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,G: B > A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ G @ Xs ) )
      = ( ! [X2: B] :
            ( ( member2 @ B @ X2 @ ( set2 @ B @ Xs ) )
           => ( ( F2 @ X2 )
              = ( G @ X2 ) ) ) ) ) ).

% map_eq_conv
thf(fact_1850_set__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate1
thf(fact_1851_in__set__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = Xs ) ) ).

% in_set_insert
thf(fact_1852_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_1853_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_1854_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X22 ) )
      = ( insert3 @ A @ X21 @ ( set2 @ A @ X22 ) ) ) ).

% list.simps(15)
thf(fact_1855_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A5 ) )
            = A5 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_1856_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R4 ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_1857_not__in__set__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = ( cons @ A @ X @ Xs ) ) ) ).

% not_in_set_insert
thf(fact_1858_List_Oset__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( insert @ A @ X @ Xs ) )
      = ( insert3 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% List.set_insert
thf(fact_1859_count__notin,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_1860_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_1861_length__upto,axiom,
    ! [I2: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I2 @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I2 ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_1862_one__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ).

% one_less_nat_eq
thf(fact_1863_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys )
           => ( ( ( set2 @ A @ Ys )
                = ( set2 @ A @ Xs ) )
             => ( Ys = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_1864_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > A > $o,Q2: A > A > $o] :
      ( ! [X3: A,Y3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( P2 @ X3 @ Y3 )
             => ( Q2 @ X3 @ Y3 ) ) ) )
     => ( ( sorted_wrt @ A @ P2 @ Xs )
       => ( sorted_wrt @ A @ Q2 @ Xs ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_1865_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_1866_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_1867_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set2 @ A @ Ys ) )
               => ( ord_less @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_1868_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member2 @ B @ Y @ ( set2 @ B @ Ys ) ) ) ).

% set_zip_rightD
thf(fact_1869_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_zip_leftD
thf(fact_1870_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ~ ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
         => ~ ( member2 @ B @ Y @ ( set2 @ B @ Ys ) ) ) ) ).

% in_set_zipE
thf(fact_1871_zip__same,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs @ Xs ) ) )
      = ( ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) )
        & ( A3 = B2 ) ) ) ).

% zip_same
thf(fact_1872_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P2: A > A > $o] : ( sorted_wrt @ A @ P2 @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_1873_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y: A,X22: list @ A,X21: A] :
      ( ( member2 @ A @ Y @ ( set2 @ A @ X22 ) )
     => ( member2 @ A @ Y @ ( set2 @ A @ ( cons @ A @ X21 @ X22 ) ) ) ) ).

% list.set_intros(2)
thf(fact_1874_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] : ( member2 @ A @ X21 @ ( set2 @ A @ ( cons @ A @ X21 @ X22 ) ) ) ).

% list.set_intros(1)
thf(fact_1875_list_Oset__cases,axiom,
    ! [A: $tType,E2: A,A3: list @ A] :
      ( ( member2 @ A @ E2 @ ( set2 @ A @ A3 ) )
     => ( ! [Z22: list @ A] :
            ( A3
           != ( cons @ A @ E2 @ Z22 ) )
       => ~ ! [Z1: A,Z22: list @ A] :
              ( ( A3
                = ( cons @ A @ Z1 @ Z22 ) )
             => ~ ( member2 @ A @ E2 @ ( set2 @ A @ Z22 ) ) ) ) ) ).

% list.set_cases
thf(fact_1876_set__ConsD,axiom,
    ! [A: $tType,Y: A,X: A,Xs: list @ A] :
      ( ( member2 @ A @ Y @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
     => ( ( Y = X )
        | ( member2 @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) ).

% set_ConsD
thf(fact_1877_finite__list,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [Xs2: list @ A] :
          ( ( set2 @ A @ Xs2 )
          = A5 ) ) ).

% finite_list
thf(fact_1878_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B4 )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( member2 @ A @ X2 @ B4 ) ) ) ) ).

% subset_code(1)
thf(fact_1879_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Ya: list @ A,F2: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ! [Z4: A] :
            ( ( member2 @ A @ Z4 @ ( set2 @ A @ Ya ) )
           => ( ( F2 @ Z4 )
              = ( G @ Z4 ) ) )
       => ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ G @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_1880_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X: list @ A,F2: A > B,G: A > B] :
      ( ! [Z4: A] :
          ( ( member2 @ A @ Z4 @ ( set2 @ A @ X ) )
         => ( ( F2 @ Z4 )
            = ( G @ Z4 ) ) )
     => ( ( map @ A @ B @ F2 @ X )
        = ( map @ A @ B @ G @ X ) ) ) ).

% list.map_cong0
thf(fact_1881_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Xa: list @ A,F2: A > B,Fa: A > B] :
      ( ! [Z4: A,Za: A] :
          ( ( member2 @ A @ Z4 @ ( set2 @ A @ X ) )
         => ( ( member2 @ A @ Za @ ( set2 @ A @ Xa ) )
           => ( ( ( F2 @ Z4 )
                = ( Fa @ Za ) )
             => ( Z4 = Za ) ) ) )
     => ( ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ Fa @ Xa ) )
       => ( X = Xa ) ) ) ).

% list.inj_map_strong
thf(fact_1882_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B,G: A > B] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = ( G @ X3 ) ) )
     => ( ( map @ A @ B @ F2 @ Xs )
        = ( map @ A @ B @ G @ Xs ) ) ) ).

% map_ext
thf(fact_1883_map__idI,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = X3 ) )
     => ( ( map @ A @ A @ F2 @ Xs )
        = Xs ) ) ).

% map_idI
thf(fact_1884_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > B,G: A > B] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( F2 @ X3 )
              = ( G @ X3 ) ) )
       => ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ G @ Ys ) ) ) ) ).

% map_cong
thf(fact_1885_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,F2: A > B] :
      ( ( ? [Xs4: list @ A] :
            ( Ys
            = ( map @ A @ B @ F2 @ Xs4 ) ) )
      = ( ! [X2: B] :
            ( ( member2 @ B @ X2 @ ( set2 @ B @ Ys ) )
           => ? [Y2: A] :
                ( X2
                = ( F2 @ Y2 ) ) ) ) ) ).

% ex_map_conv
thf(fact_1886_in__set__nthsD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I: set @ nat] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_nthsD
thf(fact_1887_notin__set__nthsI,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I: set @ nat] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member2 @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I ) ) ) ) ).

% notin_set_nthsI
thf(fact_1888_list__ex__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,F2: A > $o,G: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( F2 @ X3 )
              = ( G @ X3 ) ) )
       => ( ( list_ex @ A @ F2 @ Xs )
          = ( list_ex @ A @ G @ Ys ) ) ) ) ).

% list_ex_cong
thf(fact_1889_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ~ ! [Y3: B] :
              ~ ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_1890_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Y: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member2 @ B @ Y @ ( set2 @ B @ Ys ) )
       => ~ ! [X3: A] :
              ~ ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_1891_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_1892_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > ( list @ B ),G: A > ( list @ B )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( ( F2 @ X3 )
              = ( G @ X3 ) ) )
       => ( ( bind @ A @ B @ Xs @ F2 )
          = ( bind @ A @ B @ Ys @ G ) ) ) ) ).

% list_bind_cong
thf(fact_1893_list__ex1__iff,axiom,
    ! [A: $tType] :
      ( ( list_ex1 @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] :
          ? [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs4 ) )
            & ( P @ X2 )
            & ! [Y2: A] :
                ( ( ( member2 @ A @ Y2 @ ( set2 @ A @ Xs4 ) )
                  & ( P @ Y2 ) )
               => ( Y2 = X2 ) ) ) ) ) ).

% list_ex1_iff
thf(fact_1894_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_1895_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_1896_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_1897_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_1898_sorted__wrt1,axiom,
    ! [A: $tType,P2: A > A > $o,X: A] : ( sorted_wrt @ A @ P2 @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_1899_in__set__member,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
      = ( member @ A @ Xs @ X ) ) ).

% in_set_member
thf(fact_1900_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I2 @ ( nth @ nat @ Ns @ I2 ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_1901_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_1902_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_1903_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs @ I ) ) ) ) ).

% sorted_nths
thf(fact_1904_sorted__upto,axiom,
    ! [M2: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M2 @ N ) ) ).

% sorted_upto
thf(fact_1905_sorted__wrt__upto,axiom,
    ! [I2: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I2 @ J ) ) ).

% sorted_wrt_upto
thf(fact_1906_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_1907_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_1908_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% set_subset_Cons
thf(fact_1909_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_1910_set__nths__subset,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs @ I ) ) @ ( set2 @ A @ Xs ) ) ).

% set_nths_subset
thf(fact_1911_subset__code_I2_J,axiom,
    ! [B: $tType,A5: set @ B,Ys: list @ B] :
      ( ( ord_less_eq @ ( set @ B ) @ A5 @ ( coset @ B @ Ys ) )
      = ( ! [X2: B] :
            ( ( member2 @ B @ X2 @ ( set2 @ B @ Ys ) )
           => ~ ( member2 @ B @ X2 @ A5 ) ) ) ) ).

% subset_code(2)
thf(fact_1912_List_Oinsert__def,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X2: A,Xs4: list @ A] : ( if @ ( list @ A ) @ ( member2 @ A @ X2 @ ( set2 @ A @ Xs4 ) ) @ Xs4 @ ( cons @ A @ X2 @ Xs4 ) ) ) ) ).

% List.insert_def
thf(fact_1913_compl__coset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( coset @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% compl_coset
thf(fact_1914_coset__def,axiom,
    ! [A: $tType] :
      ( ( coset @ A )
      = ( ^ [Xs4: list @ A] : ( uminus_uminus @ ( set @ A ) @ ( set2 @ A @ Xs4 ) ) ) ) ).

% coset_def
thf(fact_1915_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_1916_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A,I2: nat,J: nat] :
      ( ( sorted_wrt @ A @ P2 @ Xs )
     => ( ( ord_less @ nat @ I2 @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P2 @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_1917_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P: A > A > $o,Xs4: list @ A] :
          ! [I4: nat,J2: nat] :
            ( ( ord_less @ nat @ I4 @ J2 )
           => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs4 ) )
             => ( P @ ( nth @ A @ Xs4 @ I4 ) @ ( nth @ A @ Xs4 @ J2 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_1918_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P2 @ Xs ) ) ).

% sorted_wrt01
thf(fact_1919_mergesort__by__rel__split_Osimps_I1_J,axiom,
    ! [A: $tType,Xs12: list @ A,Xs23: list @ A] :
      ( ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs12 @ Xs23 ) @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs12 @ Xs23 ) ) ).

% mergesort_by_rel_split.simps(1)
thf(fact_1920_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_1921_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) @ ( lex @ A @ R4 ) ) ).

% Nil_notin_lex
thf(fact_1922_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R4 ) ) ).

% Nil2_notin_lex
thf(fact_1923_lenlex__irreflexive,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X3: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R4 )
     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R4 ) ) ) ).

% lenlex_irreflexive
thf(fact_1924_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_1925_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R4 ) ) ).

% Nil_lenlex_iff2
thf(fact_1926_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member2 @ A @ ( nth @ A @ Xs @ N ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_1927_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P2: A > $o] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X3 ) )
       => ( P2 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% list_ball_nth
thf(fact_1928_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I4 )
              = X ) ) ) ) ).

% in_set_conv_nth
thf(fact_1929_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o,X: A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P2 @ ( nth @ A @ Xs @ I3 ) ) )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( P2 @ X ) ) ) ).

% all_nth_imp_all_set
thf(fact_1930_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X2 ) ) )
      = ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P2 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_1931_subset__code_I3_J,axiom,
    ! [C: $tType] :
      ~ ( ord_less_eq @ ( set @ C ) @ ( coset @ C @ ( nil @ C ) ) @ ( set2 @ C @ ( nil @ C ) ) ) ).

% subset_code(3)
thf(fact_1932_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J2: nat] :
                ( ( ord_less @ nat @ I4 @ J2 )
               => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J2 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_1933_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_1934_mergesort__by__rel__split_Osimps_I2_J,axiom,
    ! [A: $tType,Xs12: list @ A,Xs23: list @ A,X: A] :
      ( ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs12 @ Xs23 ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs12 ) @ Xs23 ) ) ).

% mergesort_by_rel_split.simps(2)
thf(fact_1935_mergesort__by__rel__split_Oelims,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A ),Xa: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( merges295452479951948502_split @ A @ X @ Xa )
        = Y )
     => ( ! [Xs1: list @ A,Xs22: list @ A] :
            ( ( X
              = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) )
           => ( ( Xa
                = ( nil @ A ) )
             => ( Y
               != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) ) ) )
       => ( ! [Xs1: list @ A,Xs22: list @ A] :
              ( ( X
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) )
             => ! [X3: A] :
                  ( ( Xa
                    = ( cons @ A @ X3 @ ( nil @ A ) ) )
                 => ( Y
                   != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs1 ) @ Xs22 ) ) ) )
         => ~ ! [Xs1: list @ A,Xs22: list @ A] :
                ( ( X
                  = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) )
               => ! [X1: A,X23: A,Xs2: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X1 @ ( cons @ A @ X23 @ Xs2 ) ) )
                   => ( Y
                     != ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X1 @ Xs1 ) @ ( cons @ A @ X23 @ Xs22 ) ) @ Xs2 ) ) ) ) ) ) ) ).

% mergesort_by_rel_split.elims
thf(fact_1936_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_1937_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R4 ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_1938_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_1939_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J2 )
               => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J2 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_1940_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( suc @ ( nat2 @ Z2 ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_1941_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
            = X )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_1942_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_1943_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_1944_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P7: product_prod @ A @ B,Xs: list @ A,Ys: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ P7 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
      = ( ? [N3: nat] :
            ( ( ( nth @ A @ Xs @ N3 )
              = ( product_fst @ A @ B @ P7 ) )
            & ( ( nth @ B @ Ys @ N3 )
              = ( product_snd @ A @ B @ P7 ) )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ).

% in_set_zip
thf(fact_1945_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_1946_set__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_union
thf(fact_1947_is__empty__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( is_empty @ A @ ( set2 @ A @ Xs ) )
      = ( null @ A @ Xs ) ) ).

% is_empty_set
thf(fact_1948_can__select__set__list__ex1,axiom,
    ! [A: $tType,P2: A > $o,A5: list @ A] :
      ( ( can_select @ A @ P2 @ ( set2 @ A @ A5 ) )
      = ( list_ex1 @ A @ P2 @ A5 ) ) ).

% can_select_set_list_ex1
thf(fact_1949_mergesort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: A > A > $o,A1: list @ A,P2: ( A > A > $o ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [R6: A > A > $o,Xs2: list @ A] :
            ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ R6 @ Xs2 ) )
           => ( ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
               => ( P2 @ R6 @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs2 ) ) ) )
             => ( ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                 => ( P2 @ R6 @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs2 ) ) ) )
               => ( P2 @ R6 @ Xs2 ) ) ) )
       => ( P2 @ A0 @ A1 ) ) ) ).

% mergesort_by_rel.pinduct
thf(fact_1950_the__elem__set,axiom,
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% the_elem_set
thf(fact_1951_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_1952_mergesort__by__rel_Osimps,axiom,
    ! [A: $tType] :
      ( ( mergesort_by_rel @ A )
      = ( ^ [R2: A > A > $o,Xs4: list @ A] : ( if @ ( list @ A ) @ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Xs4 @ ( merges9089515139780605204_merge @ A @ R2 @ ( mergesort_by_rel @ A @ R2 @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs4 ) ) ) @ ( mergesort_by_rel @ A @ R2 @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs4 ) ) ) ) ) ) ) ).

% mergesort_by_rel.simps
thf(fact_1953_mergesort__by__rel__simps_I1_J,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( mergesort_by_rel @ A @ R @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% mergesort_by_rel_simps(1)
thf(fact_1954_removeAll__id,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X @ Xs )
        = Xs ) ) ).

% removeAll_id
thf(fact_1955_mergesort__by__rel__merge__simps_I3_J,axiom,
    ! [A: $tType,R: A > A > $o,Ys: list @ A] :
      ( ( merges9089515139780605204_merge @ A @ R @ ( nil @ A ) @ Ys )
      = Ys ) ).

% mergesort_by_rel_merge_simps(3)
thf(fact_1956_mergesort__by__rel__simps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,X: A] :
      ( ( mergesort_by_rel @ A @ R @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% mergesort_by_rel_simps(2)
thf(fact_1957_can__select__def,axiom,
    ! [A: $tType] :
      ( ( can_select @ A )
      = ( ^ [P: A > $o,A10: set @ A] :
          ? [X2: A] :
            ( ( member2 @ A @ X2 @ A10 )
            & ( P @ X2 )
            & ! [Y2: A] :
                ( ( ( member2 @ A @ Y2 @ A10 )
                  & ( P @ Y2 ) )
               => ( Y2 = X2 ) ) ) ) ) ).

% can_select_def
thf(fact_1958_subseqs__refl,axiom,
    ! [A: $tType,Xs: list @ A] : ( member2 @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs_refl
thf(fact_1959_mergesort__by__rel__merge__simps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,Xs: list @ A] :
      ( ( merges9089515139780605204_merge @ A @ R @ Xs @ ( nil @ A ) )
      = Xs ) ).

% mergesort_by_rel_merge_simps(2)
thf(fact_1960_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( removeAll @ A @ X @ Xs ) ) )
      & ( ( X != Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( removeAll @ A @ X @ Xs ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_1961_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( removeAll @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_1962_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y: A,Ys: list @ A,Xs: list @ A] :
      ( ( member2 @ ( list @ A ) @ ( cons @ A @ Y @ Ys ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( member2 @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_1963_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list @ A,N: nat,Xs: list @ A] :
      ( ( member2 @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N ) ) ).

% length_n_lists_elem
thf(fact_1964_mergesort__by__rel__merge_Osimps_I3_J,axiom,
    ! [A: $tType,R: A > A > $o,V2: A,Va2: list @ A] :
      ( ( merges9089515139780605204_merge @ A @ R @ ( nil @ A ) @ ( cons @ A @ V2 @ Va2 ) )
      = ( cons @ A @ V2 @ Va2 ) ) ).

% mergesort_by_rel_merge.simps(3)
thf(fact_1965_mergesort__by__rel__merge_Oelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( merges9089515139780605204_merge @ A @ X @ Xa @ Xb )
        = Y )
     => ( ! [X3: A,Xs2: list @ A] :
            ( ( Xa
              = ( cons @ A @ X3 @ Xs2 ) )
           => ! [Y3: A,Ys3: list @ A] :
                ( ( Xb
                  = ( cons @ A @ Y3 @ Ys3 ) )
               => ~ ( ( ( X @ X3 @ Y3 )
                     => ( Y
                        = ( cons @ A @ X3 @ ( merges9089515139780605204_merge @ A @ X @ Xs2 @ ( cons @ A @ Y3 @ Ys3 ) ) ) ) )
                    & ( ~ ( X @ X3 @ Y3 )
                     => ( Y
                        = ( cons @ A @ Y3 @ ( merges9089515139780605204_merge @ A @ X @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 ) ) ) ) ) ) )
       => ( ( ( Xb
              = ( nil @ A ) )
           => ( Y != Xa ) )
         => ~ ( ( Xa
                = ( nil @ A ) )
             => ! [V: A,Va: list @ A] :
                  ( ( Xb
                    = ( cons @ A @ V @ Va ) )
                 => ( Y
                   != ( cons @ A @ V @ Va ) ) ) ) ) ) ) ).

% mergesort_by_rel_merge.elims
thf(fact_1966_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_1967_insert__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( insert3 @ A @ X @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% insert_code(2)
thf(fact_1968_remove__code_I1_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remove @ A @ X @ ( set2 @ A @ Xs ) )
      = ( set2 @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% remove_code(1)
thf(fact_1969_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list @ A,Xss2: list @ ( list @ A )] :
      ( ( member2 @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss2 ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss2 ) ) ) ).

% in_set_product_lists_length
thf(fact_1970_mergesort__by__rel_Opsimps,axiom,
    ! [A: $tType,R: A > A > $o,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ R @ Xs ) )
     => ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( ( mergesort_by_rel @ A @ R @ Xs )
            = Xs ) )
        & ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( ( mergesort_by_rel @ A @ R @ Xs )
            = ( merges9089515139780605204_merge @ A @ R @ ( mergesort_by_rel @ A @ R @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs ) ) ) @ ( mergesort_by_rel @ A @ R @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xs ) ) ) ) ) ) ) ) ).

% mergesort_by_rel.psimps
thf(fact_1971_mergesort__by__rel_Opelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: list @ A] :
      ( ( ( mergesort_by_rel @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ~ ( ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
               => ( Y = Xa ) )
              & ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
               => ( Y
                  = ( merges9089515139780605204_merge @ A @ X @ ( mergesort_by_rel @ A @ X @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) @ ( mergesort_by_rel @ A @ X @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( mergesort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) ) ) ) ) ).

% mergesort_by_rel.pelims
thf(fact_1972_length__removeAll__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_1973_mergesort__by__rel_Oelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: list @ A] :
      ( ( ( mergesort_by_rel @ A @ X @ Xa )
        = Y )
     => ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( Y = Xa ) )
        & ( ~ ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xa ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         => ( Y
            = ( merges9089515139780605204_merge @ A @ X @ ( mergesort_by_rel @ A @ X @ ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) @ ( mergesort_by_rel @ A @ X @ ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) @ Xa ) ) ) ) ) ) ) ) ).

% mergesort_by_rel.elims
thf(fact_1974_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) )
      = ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% map_fst_enumerate
thf(fact_1975_upto__rec2,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_1976_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B8: A,C6: A] :
              ( ( A3
                = ( times_times @ A @ B8 @ C6 ) )
              & ( dvd_dvd @ A @ B8 @ B2 )
              & ( dvd_dvd @ A @ C6 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1977_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P7: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ P7 @ ( times_times @ A @ A3 @ B2 ) )
         => ~ ! [X3: A,Y3: A] :
                ( ( P7
                  = ( times_times @ A @ X3 @ Y3 ) )
               => ( ( dvd_dvd @ A @ X3 @ A3 )
                 => ~ ( dvd_dvd @ A @ Y3 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1978_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_1979_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_1980_normalize__denom__zero,axiom,
    ! [P7: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P7 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_1981_append_Oassoc,axiom,
    ! [A: $tType,A3: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A3 @ B2 ) @ C2 )
      = ( append @ A @ A3 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_1982_append__assoc,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) ).

% append_assoc
thf(fact_1983_append__same__eq,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) ).

% append_same_eq
thf(fact_1984_same__append__eq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) ).

% same_append_eq
thf(fact_1985_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_1986_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_1987_self__append__conv2,axiom,
    ! [A: $tType,Y: list @ A,Xs: list @ A] :
      ( ( Y
        = ( append @ A @ Xs @ Y ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_1988_append__self__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_1989_self__append__conv,axiom,
    ! [A: $tType,Y: list @ A,Ys: list @ A] :
      ( ( Y
        = ( append @ A @ Y @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_1990_append__self__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_1991_append__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% append_Nil2
thf(fact_1992_append_Oright__neutral,axiom,
    ! [A: $tType,A3: list @ A] :
      ( ( append @ A @ A3 @ ( nil @ A ) )
      = A3 ) ).

% append.right_neutral
thf(fact_1993_empty__append__eq__id,axiom,
    ! [A: $tType] :
      ( ( append @ A @ ( nil @ A ) )
      = ( ^ [X2: list @ A] : X2 ) ) ).

% empty_append_eq_id
thf(fact_1994_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_1995_map__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys ) ) ) ).

% map_append
thf(fact_1996_upt__conv__Nil,axiom,
    ! [J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( upt @ I2 @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_1997_removeAll__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( removeAll @ A @ X @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( removeAll @ A @ X @ Xs ) @ ( removeAll @ A @ X @ Ys ) ) ) ).

% removeAll_append
thf(fact_1998_list__ex__append,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( list_ex @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
      = ( ( list_ex @ A @ P2 @ Xs )
        | ( list_ex @ A @ P2 @ Ys ) ) ) ).

% list_ex_append
thf(fact_1999_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X = Y ) ) ) ).

% append1_eq_conv
thf(fact_2000_list__ee__eq__leel_I1_J,axiom,
    ! [A: $tType,E1: A,E22: A,L12: list @ A,E12: A,E23: A,L22: list @ A] :
      ( ( ( cons @ A @ E1 @ ( cons @ A @ E22 @ ( nil @ A ) ) )
        = ( append @ A @ L12 @ ( cons @ A @ E12 @ ( cons @ A @ E23 @ L22 ) ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E1 = E12 )
        & ( E22 = E23 )
        & ( L22
          = ( nil @ A ) ) ) ) ).

% list_ee_eq_leel(1)
thf(fact_2001_list__ee__eq__leel_I2_J,axiom,
    ! [A: $tType,L12: list @ A,E12: A,E23: A,L22: list @ A,E1: A,E22: A] :
      ( ( ( append @ A @ L12 @ ( cons @ A @ E12 @ ( cons @ A @ E23 @ L22 ) ) )
        = ( cons @ A @ E1 @ ( cons @ A @ E22 @ ( nil @ A ) ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E1 = E12 )
        & ( E22 = E23 )
        & ( L22
          = ( nil @ A ) ) ) ) ).

% list_ee_eq_leel(2)
thf(fact_2002_list__se__match_I1_J,axiom,
    ! [A: $tType,L12: list @ A,L22: list @ A,A3: A] :
      ( ( L12
       != ( nil @ A ) )
     => ( ( ( append @ A @ L12 @ L22 )
          = ( cons @ A @ A3 @ ( nil @ A ) ) )
        = ( ( L12
            = ( cons @ A @ A3 @ ( nil @ A ) ) )
          & ( L22
            = ( nil @ A ) ) ) ) ) ).

% list_se_match(1)
thf(fact_2003_list__se__match_I2_J,axiom,
    ! [A: $tType,L22: list @ A,L12: list @ A,A3: A] :
      ( ( L22
       != ( nil @ A ) )
     => ( ( ( append @ A @ L12 @ L22 )
          = ( cons @ A @ A3 @ ( nil @ A ) ) )
        = ( ( L12
            = ( nil @ A ) )
          & ( L22
            = ( cons @ A @ A3 @ ( nil @ A ) ) ) ) ) ) ).

% list_se_match(2)
thf(fact_2004_list__se__match_I3_J,axiom,
    ! [A: $tType,L12: list @ A,A3: A,L22: list @ A] :
      ( ( L12
       != ( nil @ A ) )
     => ( ( ( cons @ A @ A3 @ ( nil @ A ) )
          = ( append @ A @ L12 @ L22 ) )
        = ( ( L12
            = ( cons @ A @ A3 @ ( nil @ A ) ) )
          & ( L22
            = ( nil @ A ) ) ) ) ) ).

% list_se_match(3)
thf(fact_2005_list__se__match_I4_J,axiom,
    ! [A: $tType,L22: list @ A,A3: A,L12: list @ A] :
      ( ( L22
       != ( nil @ A ) )
     => ( ( ( cons @ A @ A3 @ ( nil @ A ) )
          = ( append @ A @ L12 @ L22 ) )
        = ( ( L12
            = ( nil @ A ) )
          & ( L22
            = ( cons @ A @ A3 @ ( nil @ A ) ) ) ) ) ) ).

% list_se_match(4)
thf(fact_2006_list__e__eq__lel_I1_J,axiom,
    ! [A: $tType,E2: A,L12: list @ A,E3: A,L22: list @ A] :
      ( ( ( cons @ A @ E2 @ ( nil @ A ) )
        = ( append @ A @ L12 @ ( cons @ A @ E3 @ L22 ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E3 = E2 )
        & ( L22
          = ( nil @ A ) ) ) ) ).

% list_e_eq_lel(1)
thf(fact_2007_list__e__eq__lel_I2_J,axiom,
    ! [A: $tType,L12: list @ A,E3: A,L22: list @ A,E2: A] :
      ( ( ( append @ A @ L12 @ ( cons @ A @ E3 @ L22 ) )
        = ( cons @ A @ E2 @ ( nil @ A ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E3 = E2 )
        & ( L22
          = ( nil @ A ) ) ) ) ).

% list_e_eq_lel(2)
thf(fact_2008_length__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_2009_upt__eq__Nil__conv,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( upt @ I2 @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I2 ) ) ) ).

% upt_eq_Nil_conv
thf(fact_2010_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Us: list @ B,Ys: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Us ) @ ( zip @ A @ B @ Ys @ Vs ) ) ) ) ).

% zip_append
thf(fact_2011_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_2012_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: B,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) ).

% bind_simps(2)
thf(fact_2013_length__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I2 @ J ) )
      = ( minus_minus @ nat @ J @ I2 ) ) ).

% length_upt
thf(fact_2014_nth__append__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% nth_append_length
thf(fact_2015_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,N: nat] :
      ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
      = ( nth @ A @ Ys @ N ) ) ).

% nth_append_length_plus
thf(fact_2016_upt__rec__numeral,axiom,
    ! [M2: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_2017_nth__upt,axiom,
    ! [I2: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I2 @ J ) @ K )
        = ( plus_plus @ nat @ I2 @ K ) ) ) ).

% nth_upt
thf(fact_2018_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_2019_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_2020_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_2021_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_2022_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_2023_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_2024_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_2025_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_2026_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_2027_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V2 ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_2028_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Xs12: list @ A,Zs: list @ A,Ys: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs @ Xs12 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs12 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_2029_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,Ts: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_2030_append_Osemigroup__axioms,axiom,
    ! [A: $tType] : ( semigroup @ ( list @ A ) @ ( append @ A ) ) ).

% append.semigroup_axioms
thf(fact_2031_upt__0,axiom,
    ! [I2: nat] :
      ( ( upt @ I2 @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_2032_map__Suc__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M2 @ N ) )
      = ( upt @ ( suc @ M2 ) @ ( suc @ N ) ) ) ).

% map_Suc_upt
thf(fact_2033_upt__conv__Cons__Cons,axiom,
    ! [M2: nat,N: nat,Ns: list @ nat,Q4: nat] :
      ( ( ( cons @ nat @ M2 @ ( cons @ nat @ N @ Ns ) )
        = ( upt @ M2 @ Q4 ) )
      = ( ( cons @ nat @ N @ Ns )
        = ( upt @ ( suc @ M2 ) @ Q4 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_2034_append__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( append @ A @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( cons @ A @ X @ ( append @ A @ Xs @ Ys ) ) ) ).

% append_Cons
thf(fact_2035_Cons__eq__appendI,axiom,
    ! [A: $tType,X: A,Xs12: list @ A,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs12 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs12 @ Zs ) )
       => ( ( cons @ A @ X @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_2036_append_Omonoid__axioms,axiom,
    ! [A: $tType] : ( monoid @ ( list @ A ) @ ( append @ A ) @ ( nil @ A ) ) ).

% append.monoid_axioms
thf(fact_2037_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) ).

% eq_Nil_appendI
thf(fact_2038_append_Oleft__neutral,axiom,
    ! [A: $tType,A3: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A3 )
      = A3 ) ).

% append.left_neutral
thf(fact_2039_append__Nil,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% append_Nil
thf(fact_2040_List_Oappend__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ A,Zs: list @ A,F2: B > A,Xs: list @ B] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs2 ) ) ) ) ) ).

% List.append_eq_map_conv
thf(fact_2041_List_Omap__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs2 ) ) ) ) ) ).

% List.map_eq_append_conv
thf(fact_2042_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N @ ( append @ A @ Xs @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ ( enumerate @ A @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_2043_upt__conv__Cons,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( upt @ I2 @ J )
        = ( cons @ nat @ I2 @ ( upt @ ( suc @ I2 ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_2044_upt__rec,axiom,
    ( upt
    = ( ^ [I4: nat,J2: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I4 @ J2 ) @ ( cons @ nat @ I4 @ ( upt @ ( suc @ I4 ) @ J2 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_2045_rev__induct,axiom,
    ! [A: $tType,P2: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P2 @ ( nil @ A ) )
     => ( ! [X3: A,Xs2: list @ A] :
            ( ( P2 @ Xs2 )
           => ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
       => ( P2 @ Xs ) ) ) ).

% rev_induct
thf(fact_2046_rev__exhaust,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ! [Ys3: list @ A,Y3: A] :
            ( Xs
           != ( append @ A @ Ys3 @ ( cons @ A @ Y3 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_2047_Cons__eq__append__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs )
            = Zs ) )
        | ? [Ys6: list @ A] :
            ( ( ( cons @ A @ X @ Ys6 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys6 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_2048_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,X: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs ) ) )
        | ? [Ys6: list @ A] :
            ( ( Ys
              = ( cons @ A @ X @ Ys6 ) )
            & ( ( append @ A @ Ys6 @ Zs )
              = Xs ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_2049_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P2: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] : ( P2 @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P2 @ Xs2 )
               => ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
         => ( P2 @ Xs ) ) ) ) ).

% rev_nonempty_induct
thf(fact_2050_list__append__eq__Cons__cases,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,X: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X @ Xs ) )
     => ( ( ( Ys
            = ( nil @ A ) )
         => ( Zs
           != ( cons @ A @ X @ Xs ) ) )
       => ~ ! [Ys2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X @ Ys2 ) )
             => ( ( append @ A @ Ys2 @ Zs )
               != Xs ) ) ) ) ).

% list_append_eq_Cons_cases
thf(fact_2051_list__Cons__eq__append__cases,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( ( Ys
            = ( nil @ A ) )
         => ( Zs
           != ( cons @ A @ X @ Xs ) ) )
       => ~ ! [Ys2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X @ Ys2 ) )
             => ( ( append @ A @ Ys2 @ Zs )
               != Xs ) ) ) ) ).

% list_Cons_eq_append_cases
thf(fact_2052_rev__nonempty__induct2_H,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P2: ( list @ A ) > ( list @ B ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ! [X3: A,Y3: B] : ( P2 @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( cons @ B @ Y3 @ ( nil @ B ) ) )
         => ( ! [X3: A,Xs2: list @ A,Y3: B] :
                ( ( Xs2
                 != ( nil @ A ) )
               => ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) @ ( cons @ B @ Y3 @ ( nil @ B ) ) ) )
           => ( ! [X3: A,Y3: B,Ys3: list @ B] :
                  ( ( Ys3
                   != ( nil @ B ) )
                 => ( P2 @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y3 @ ( nil @ B ) ) ) ) )
             => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B] :
                    ( ( P2 @ Xs2 @ Ys3 )
                   => ( ( Xs2
                       != ( nil @ A ) )
                     => ( ( Ys3
                         != ( nil @ B ) )
                       => ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y3 @ ( nil @ B ) ) ) ) ) ) )
               => ( P2 @ Xs @ Ys ) ) ) ) ) ) ) ).

% rev_nonempty_induct2'
thf(fact_2053_neq__Nil__rev__conv,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( ( L
         != ( nil @ A ) ) )
      = ( ? [Xs4: list @ A,X2: A] :
            ( L
            = ( append @ A @ Xs4 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ) ).

% neq_Nil_rev_conv
thf(fact_2054_rev__induct2_H,axiom,
    ! [A: $tType,B: $tType,P2: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys: list @ B] :
      ( ( P2 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: list @ A] : ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) @ ( nil @ B ) )
       => ( ! [Y3: B,Ys3: list @ B] : ( P2 @ ( nil @ A ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y3 @ ( nil @ B ) ) ) )
         => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B] :
                ( ( P2 @ Xs2 @ Ys3 )
               => ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y3 @ ( nil @ B ) ) ) ) )
           => ( P2 @ Xs @ Ys ) ) ) ) ) ).

% rev_induct2'
thf(fact_2055_neq__Nil__revE,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( L
       != ( nil @ A ) )
     => ~ ! [Ll2: list @ A,E: A] :
            ( L
           != ( append @ A @ Ll2 @ ( cons @ A @ E @ ( nil @ A ) ) ) ) ) ).

% neq_Nil_revE
thf(fact_2056_split__list,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys3: list @ A,Zs2: list @ A] :
          ( Xs
          = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs2 ) ) ) ) ).

% split_list
thf(fact_2057_split__list__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys3: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member2 @ A @ X @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_2058_split__list__prop,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P2 @ X4 ) )
     => ? [Ys3: list @ A,X3: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P2 @ X3 ) ) ) ).

% split_list_prop
thf(fact_2059_split__list__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys3: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member2 @ A @ X @ ( set2 @ A @ Ys3 ) ) ) ) ).

% split_list_first
thf(fact_2060_split__list__propE,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P2 @ X4 ) )
     => ~ ! [Ys3: list @ A,X3: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ~ ( P2 @ X3 ) ) ) ).

% split_list_propE
thf(fact_2061_append__Cons__eq__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,Xs5: list @ A,Ys7: list @ A] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( member2 @ A @ X @ ( set2 @ A @ Ys ) )
       => ( ( ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) )
            = ( append @ A @ Xs5 @ ( cons @ A @ X @ Ys7 ) ) )
          = ( ( Xs = Xs5 )
            & ( Ys = Ys7 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_2062_in__set__conv__decomp,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys4: list @ A,Zs3: list @ A] :
            ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_2063_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P2 @ X4 ) )
     => ? [Ys3: list @ A,X3: A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P2 @ X3 )
          & ! [Xa2: A] :
              ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Zs2 ) )
             => ~ ( P2 @ Xa2 ) ) ) ) ).

% split_list_last_prop
thf(fact_2064_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P2 @ X4 ) )
     => ? [Ys3: list @ A,X3: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P2 @ X3 )
          & ! [Xa2: A] :
              ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Ys3 ) )
             => ~ ( P2 @ Xa2 ) ) ) ) ).

% split_list_first_prop
thf(fact_2065_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P2 @ X4 ) )
     => ~ ! [Ys3: list @ A,X3: A,Zs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ( ( P2 @ X3 )
             => ~ ! [Xa2: A] :
                    ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P2 @ Xa2 ) ) ) ) ) ).

% split_list_last_propE
thf(fact_2066_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P2 @ X4 ) )
     => ~ ! [Ys3: list @ A,X3: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ( ( P2 @ X3 )
             => ~ ! [Xa2: A] :
                    ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Ys3 ) )
                   => ~ ( P2 @ Xa2 ) ) ) ) ) ).

% split_list_first_propE
thf(fact_2067_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys4: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member2 @ A @ X @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_2068_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys4: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member2 @ A @ X @ ( set2 @ A @ Ys4 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_2069_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( ? [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P2 @ X2 ) ) )
      = ( ? [Ys4: list @ A,X2: A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ( P2 @ X2 )
            & ! [Y2: A] :
                ( ( member2 @ A @ Y2 @ ( set2 @ A @ Zs3 ) )
               => ~ ( P2 @ Y2 ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_2070_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( ? [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P2 @ X2 ) ) )
      = ( ? [Ys4: list @ A,X2: A] :
            ( ? [Zs3: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ( P2 @ X2 )
            & ! [Y2: A] :
                ( ( member2 @ A @ Y2 @ ( set2 @ A @ Ys4 ) )
               => ~ ( P2 @ Y2 ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_2071_sorted__wrt__append,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
      = ( ( sorted_wrt @ A @ P2 @ Xs )
        & ( sorted_wrt @ A @ P2 @ Ys )
        & ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ! [Y2: A] :
                ( ( member2 @ A @ Y2 @ ( set2 @ A @ Ys ) )
               => ( P2 @ X2 @ Y2 ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_2072_sorted__wrt__upt,axiom,
    ! [M2: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M2 @ N ) ) ).

% sorted_wrt_upt
thf(fact_2073_sorted__upt,axiom,
    ! [M2: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M2 @ N ) ) ).

% sorted_upt
thf(fact_2074_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R4 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R4 ) ) ) ).

% lex_append_leftI
thf(fact_2075_maps__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( list @ A ),X: B,Xs: list @ B] :
      ( ( maps @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
      = ( append @ A @ ( F2 @ X ) @ ( maps @ B @ A @ F2 @ Xs ) ) ) ).

% maps_simps(1)
thf(fact_2076_upt__eq__Cons__conv,axiom,
    ! [I2: nat,J: nat,X: nat,Xs: list @ nat] :
      ( ( ( upt @ I2 @ J )
        = ( cons @ nat @ X @ Xs ) )
      = ( ( ord_less @ nat @ I2 @ J )
        & ( I2 = X )
        & ( ( upt @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) @ J )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_2077_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I4: int,J2: int] : ( append @ int @ ( upto @ I4 @ J2 ) ) ) ) ).

% upto_aux_def
thf(fact_2078_same__length__different,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs != Ys )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ? [Pre: list @ A,X3: A,Xs3: list @ A,Y3: A,Ys2: list @ A] :
            ( ( X3 != Y3 )
            & ( Xs
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ Xs3 ) ) )
            & ( Ys
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ Ys2 ) ) ) ) ) ) ).

% same_length_different
thf(fact_2079_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
               => ! [Y2: A] :
                    ( ( member2 @ A @ Y2 @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ) ).

% sorted_append
thf(fact_2080_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N3: nat,Xs4: list @ A] : ( zip @ nat @ A @ ( upt @ N3 @ ( plus_plus @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs4 ) ) ) @ Xs4 ) ) ) ).

% enumerate_eq_zip
thf(fact_2081_lex__append__leftD,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R4 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R4 ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R4 ) ) ) ) ).

% lex_append_leftD
thf(fact_2082_lex__append__left__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R4 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R4 ) )
        = ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R4 ) ) ) ) ).

% lex_append_left_iff
thf(fact_2083_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_2084_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R4 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R4 ) ) ) ) ).

% lex_append_rightI
thf(fact_2085_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys ) ) @ ( lenlex @ A @ R ) ) ) ) ).

% lenlex_append1
thf(fact_2086_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A3 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A3 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_2087_nth__map__upt,axiom,
    ! [A: $tType,I2: nat,N: nat,M2: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ N @ M2 ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M2 @ N ) ) @ I2 )
        = ( F2 @ ( plus_plus @ nat @ M2 @ I2 ) ) ) ) ).

% nth_map_upt
thf(fact_2088_length__Suc__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Ys4: list @ A,Y2: A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys4 )
              = N ) ) ) ) ).

% length_Suc_rev_conv
thf(fact_2089_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y2: A,Ys4: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys4 )
              = N ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_2090_length__compl__rev__induct,axiom,
    ! [A: $tType,P2: ( list @ A ) > $o,L: list @ A] :
      ( ( P2 @ ( nil @ A ) )
     => ( ! [L4: list @ A,E: A] :
            ( ! [Ll: list @ A] :
                ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ll ) @ ( size_size @ ( list @ A ) @ L4 ) )
               => ( P2 @ Ll ) )
           => ( P2 @ ( append @ A @ L4 @ ( cons @ A @ E @ ( nil @ A ) ) ) ) )
       => ( P2 @ L ) ) ) ).

% length_compl_rev_induct
thf(fact_2091_nth__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N )
          = ( nth @ A @ Xs @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_2092_upto__split2,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_2093_upto__split1,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_2094_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,M2: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N @ M2 ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I3 )
              = ( F2 @ ( plus_plus @ nat @ M2 @ I3 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M2 @ N ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_2095_sorted__append__bigger,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X3: A] :
                ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X3 @ Y ) )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_append_bigger
thf(fact_2096_upto__split3,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_2097_length__append__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_append_singleton
thf(fact_2098_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_2099_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_2100_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_2101_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_2102_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_2103_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_2104_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_2105_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_2106_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_2107_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_2108_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_2109_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_2110_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V2 ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_2111_upt__Suc__append,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_2112_upt__Suc,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_2113_upt__add__eq__append,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_2114_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ Ys ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ).

% product.simps(2)
thf(fact_2115_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_2116_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_2117_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A3 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_2118_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_2119_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X2: nat,Y2: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y2
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Y2 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_2120_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_2121_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_2122_SuccI,axiom,
    ! [A: $tType,Kl: list @ A,K: A,Kl2: set @ ( list @ A )] :
      ( ( member2 @ ( list @ A ) @ ( append @ A @ Kl @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl2 )
     => ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl2 @ Kl ) ) ) ).

% SuccI
thf(fact_2123_SuccD,axiom,
    ! [A: $tType,K: A,Kl2: set @ ( list @ A ),Kl: list @ A] :
      ( ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl2 @ Kl ) )
     => ( member2 @ ( list @ A ) @ ( append @ A @ Kl @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl2 ) ) ).

% SuccD
thf(fact_2124_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P7: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P7 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) @ P7 ) ) ) ).

% ceiling_divide_lower
thf(fact_2125_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M2 @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_2126_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2127_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2128_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2129_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_2130_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( one_one @ A ) )
          = ( Z2
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_2131_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z2 ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_mult
thf(fact_2132_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_2133_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M2 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M2 ) ) ) ) ).

% of_nat_Suc
thf(fact_2134_nth__upto,axiom,
    ! [I2: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I2 @ J ) @ K )
        = ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_2135_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_2136_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_le_iff
thf(fact_2137_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_2138_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_less_iff
thf(fact_2139_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_2140_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2141_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,M2: nat,N: nat] :
          ( ( divide_divide @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_2142_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_2143_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_2144_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_2145_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N4: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N4 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2146_int__ops_I4_J,axiom,
    ! [A3: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A3 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2147_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2148_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2149_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_2150_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_2151_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_2152_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_2153_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z4: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z4 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z4 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_2154_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X3 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) ) )
          & ! [Y5: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y5 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y5 @ ( one_one @ int ) ) ) ) )
             => ( Y5 = X3 ) ) ) ) ).

% floor_exists1
thf(fact_2155_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,M2: nat,N: nat] :
          ( ( modulo_modulo @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A3 @ ( semiring_1_of_nat @ A @ M2 ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2156_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X2: A] :
              ( if @ int
              @ ( X2
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X2 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_2157_Suc__as__int,axiom,
    ( suc
    = ( ^ [A4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_2158_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2159_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N ) ) ) ).

% round_unique'
thf(fact_2160_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P2: int > $o,T3: A] :
          ( ( P2 @ ( archim6421214686448440834_floor @ A @ T3 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I4 ) @ T3 )
                  & ( ord_less @ A @ T3 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) ) )
               => ( P2 @ I4 ) ) ) ) ) ).

% floor_split
thf(fact_2161_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A3: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A3 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A3 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A3 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_2162_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z2 ) ) ) ) ).

% floor_unique
thf(fact_2163_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N4: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N4 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_2164_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P2: int > $o,T3: A] :
          ( ( P2 @ ( archimedean_ceiling @ A @ T3 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) @ T3 )
                  & ( ord_less_eq @ A @ T3 @ ( ring_1_of_int @ A @ I4 ) ) )
               => ( P2 @ I4 ) ) ) ) ) ).

% ceiling_split
thf(fact_2165_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A3: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A3 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A3 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A3 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_2166_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z2 ) ) ) ) ).

% ceiling_unique
thf(fact_2167_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_2168_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_2169_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_2170_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_2171_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y ) ) ) ) ).

% round_unique
thf(fact_2172_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_2173_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_2174_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_2175_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_2176_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X2 ) ) @ ( archimedean_ceiling @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ) ).

% round_altdef
thf(fact_2177_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P7: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P7 @ Q4 ) ) ) @ Q4 ) @ P7 ) ) ) ).

% floor_divide_lower
thf(fact_2178_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P7: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less_eq @ A @ P7 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P7 @ Q4 ) ) ) @ Q4 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_2179_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q4: A,P7: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q4 )
         => ( ord_less @ A @ P7 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P7 @ Q4 ) ) ) @ ( one_one @ A ) ) @ Q4 ) ) ) ) ).

% floor_divide_upper
thf(fact_2180_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_2181_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_2182_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_2183_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_2184_empty__Shift,axiom,
    ! [A: $tType,Kl2: set @ ( list @ A ),K: A] :
      ( ( member2 @ ( list @ A ) @ ( nil @ A ) @ Kl2 )
     => ( ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl2 @ ( nil @ A ) ) )
       => ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( bNF_Greatest_Shift @ A @ Kl2 @ K ) ) ) ) ).

% empty_Shift
thf(fact_2185_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A3: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A3 )
         => ( ( member2 @ B @ A3 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A3 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A3 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_2186_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A3: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A3 )
         => ( ( member2 @ B @ A3 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A3 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A3 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_2187_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( one_one @ nat ) )
          = A3 ) ) ).

% pochhammer_1
thf(fact_2188_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2189_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A3: A,B2: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( member2 @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member2 @ A @ ( times_times @ A @ A3 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_2190_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member2 @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_2191_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2192_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ A3 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_2193_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ A3 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_2194_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A3 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A3 @ N ) @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2195_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_2196_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat,M2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( plus_plus @ nat @ N @ M2 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ M2 ) ) ) ) ).

% pochhammer_product'
thf(fact_2197_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A3: A] :
          ( ( member2 @ A @ A3 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A3 ) @ A3 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_2198_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member2 @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_2199_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member2 @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_2200_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( member2 @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member2 @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_2201_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M2: nat,N: nat,Z2: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z2 @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ M2 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_2202_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member2 @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member2 @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_2203_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R4: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R4 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R4 ) @ K ) )
          = ( times_times @ A @ R4 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R4 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_2204_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A3: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A3 )
          = ( ( member2 @ A @ ( minus_minus @ A @ X @ A3 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
            & ( ord_less @ A @ A3 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_2205_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_2206_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A3 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_2207_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M2: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M2 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_2208_nth__step__trancl,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A ),N: nat,M2: nat] :
      ( ! [N4: nat] :
          ( ( ord_less @ nat @ N4 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ ( suc @ N4 ) ) @ ( nth @ A @ Xs @ N4 ) ) @ R ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ M2 @ N )
         => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N ) @ ( nth @ A @ Xs @ M2 ) ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% nth_step_trancl
thf(fact_2209_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ ( suc @ I2 ) @ Xs )
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_2210_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,M2: nat] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate @ A @ M2 @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M2 @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate
thf(fact_2211_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( cons @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set_nonempty
thf(fact_2212_min_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A] :
          ( ( ord_min @ A @ A3 @ A3 )
          = A3 ) ) ).

% min.idem
thf(fact_2213_min_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_min @ A @ A3 @ ( ord_min @ A @ A3 @ B2 ) )
          = ( ord_min @ A @ A3 @ B2 ) ) ) ).

% min.left_idem
thf(fact_2214_min_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A3 @ B2 ) @ B2 )
          = ( ord_min @ A @ A3 @ B2 ) ) ) ).

% min.right_idem
thf(fact_2215_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% min.absorb1
thf(fact_2216_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_2217_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B2 )
            & ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_2218_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ A3 @ B2 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = A3 ) ) ) ).

% min.absorb3
thf(fact_2219_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ A3 )
         => ( ( ord_min @ A @ A3 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_2220_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_min @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z2 @ X )
            & ( ord_less @ A @ Z2 @ Y ) ) ) ) ).

% min_less_iff_conj
thf(fact_2221_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A3: A] :
          ( ( gbinomial @ A @ A3 @ ( one_one @ nat ) )
          = A3 ) ) ).

% gbinomial_1
thf(fact_2222_rotate__is__Nil__conv,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( rotate @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate_is_Nil_conv
thf(fact_2223_set__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate @ A @ N @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate
thf(fact_2224_length__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate @ A @ N @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate
thf(fact_2225_take__take,axiom,
    ! [A: $tType,N: nat,M2: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( take @ A @ M2 @ Xs ) )
      = ( take @ A @ ( ord_min @ nat @ N @ M2 ) @ Xs ) ) ).

% take_take
thf(fact_2226_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_2227_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_2228_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_2229_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_2230_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ N @ Xs ) ) ) ).

% take_Suc_Cons
thf(fact_2231_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs4: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_2232_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_2233_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N @ Xs ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_2234_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_2235_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A3: A] :
          ( ( gbinomial @ A @ A3 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_2236_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = Xs )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% take_all_iff
thf(fact_2237_take__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( take @ A @ N @ Xs )
        = Xs ) ) ).

% take_all
thf(fact_2238_take__upt,axiom,
    ! [I2: nat,M2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ M2 ) @ N )
     => ( ( take @ nat @ M2 @ ( upt @ I2 @ N ) )
        = ( upt @ I2 @ ( plus_plus @ nat @ I2 @ M2 ) ) ) ) ).

% take_upt
thf(fact_2239_nth__take,axiom,
    ! [A: $tType,I2: nat,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ N )
     => ( ( nth @ A @ ( take @ A @ N @ Xs ) @ I2 )
        = ( nth @ A @ Xs @ I2 ) ) ) ).

% nth_take
thf(fact_2240_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_2241_length__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( take @ A @ N @ Xs ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_take
thf(fact_2242_rotate__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ ( suc @ N ) @ Xs )
      = ( rotate1 @ A @ ( rotate @ A @ N @ Xs ) ) ) ).

% rotate_Suc
thf(fact_2243_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_2244_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_2245_take__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( take @ A @ N @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( take @ A @ N @ Xs ) @ ( take @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% take_append
thf(fact_2246_rotate__length01,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_length01
thf(fact_2247_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_id
thf(fact_2248_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_zip
thf(fact_2249_take__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% take_Cons_numeral
thf(fact_2250_take__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys: list @ B] :
      ( ( take @ ( product_prod @ A @ B ) @ N @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( take @ A @ N @ Xs ) @ ( take @ B @ N @ Ys ) ) ) ).

% take_zip
thf(fact_2251_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_2252_min_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 )
          = ( ord_min @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.assoc
thf(fact_2253_min_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B3: A] : ( ord_min @ A @ B3 @ A4 ) ) ) ) ).

% min.commute
thf(fact_2254_min_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_min @ A @ B2 @ ( ord_min @ A @ A3 @ C2 ) )
          = ( ord_min @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.left_commute
thf(fact_2255_take__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ! [I3: nat] :
          ( ( take @ A @ I3 @ Xs )
          = ( take @ A @ I3 @ Ys ) )
     => ( Xs = Ys ) ) ).

% take_equalityI
thf(fact_2256_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P2: ( list @ ( product_prod @ A @ B ) ) > $o] :
      ( ! [Zs2: list @ A,Ws2: list @ B,N4: nat] :
          ( ( ( size_size @ ( list @ A ) @ Zs2 )
            = ( size_size @ ( list @ B ) @ Ws2 ) )
         => ( ( N4
              = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
           => ( ( Zs2
                = ( take @ A @ N4 @ Xs ) )
             => ( ( Ws2
                  = ( take @ B @ N4 @ Ys ) )
               => ( P2 @ ( zip @ A @ B @ Zs2 @ Ws2 ) ) ) ) ) )
     => ( P2 @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_obtain_same_length
thf(fact_2257_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A,D3: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D3 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ ( ord_min @ A @ C2 @ D3 ) ) ) ) ) ).

% min.mono
thf(fact_2258_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( A3
            = ( ord_min @ A @ A3 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_2259_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
            = ( ord_min @ A @ A3 @ B2 ) )
         => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ).

% min.orderI
thf(fact_2260_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A3 @ B2 )
             => ~ ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_2261_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ A3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_2262_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( ord_min @ A @ A4 @ B3 ) ) ) ) ) ).

% min.order_iff
thf(fact_2263_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ A3 ) ) ).

% min.cobounded1
thf(fact_2264_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_2265_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% min.absorb_iff1
thf(fact_2266_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% min.absorb_iff2
thf(fact_2267_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_2268_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_2269_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            | ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) ).

% min_le_iff_disj
thf(fact_2270_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            | ( ord_less @ A @ Y @ Z2 ) ) ) ) ).

% min_less_iff_disj
thf(fact_2271_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A3 @ B2 )
             => ~ ( ord_less @ A @ A3 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_2272_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( ord_min @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_2273_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A3 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_2274_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A3 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_2275_take__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( take @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% take_Nil
thf(fact_2276_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y @ Z2 ) ) ) ) ).

% min_add_distrib_left
thf(fact_2277_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y @ Z2 ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% min_add_distrib_right
thf(fact_2278_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y ) @ Z2 )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y @ Z2 ) ) ) ) ).

% min_diff_distrib_left
thf(fact_2279_in__set__takeD,axiom,
    ! [A: $tType,X: A,N: nat,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_takeD
thf(fact_2280_inf__min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% inf_min
thf(fact_2281_take__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( take @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( take @ B @ N @ Xs ) ) ) ).

% take_map
thf(fact_2282_sorted__wrt__take,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( take @ A @ N @ Xs ) ) ) ).

% sorted_wrt_take
thf(fact_2283_max__min__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ B2 @ C2 ) @ A3 )
          = ( ord_min @ A @ ( ord_max @ A @ B2 @ A3 ) @ ( ord_max @ A @ C2 @ A3 ) ) ) ) ).

% max_min_distrib1
thf(fact_2284_max__min__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_max @ A @ A3 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ord_min @ A @ ( ord_max @ A @ A3 @ B2 ) @ ( ord_max @ A @ A3 @ C2 ) ) ) ) ).

% max_min_distrib2
thf(fact_2285_min__max__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( ord_min @ A @ ( ord_max @ A @ B2 @ C2 ) @ A3 )
          = ( ord_max @ A @ ( ord_min @ A @ B2 @ A3 ) @ ( ord_min @ A @ C2 @ A3 ) ) ) ) ).

% min_max_distrib1
thf(fact_2286_min__max__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_min @ A @ A3 @ ( ord_max @ A @ B2 @ C2 ) )
          = ( ord_max @ A @ ( ord_min @ A @ A3 @ B2 ) @ ( ord_min @ A @ A3 @ C2 ) ) ) ) ).

% min_max_distrib2
thf(fact_2287_min_Oabel__semigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( abel_semigroup @ A @ ( ord_min @ A ) ) ) ).

% min.abel_semigroup_axioms
thf(fact_2288_min_Osemilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice @ A @ ( ord_min @ A ) ) ) ).

% min.semilattice_axioms
thf(fact_2289_min_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_min @ A ) ) ) ).

% min.semigroup_axioms
thf(fact_2290_rotate__rotate,axiom,
    ! [A: $tType,M2: nat,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ M2 @ ( rotate @ A @ N @ Xs ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M2 @ N ) @ Xs ) ) ).

% rotate_rotate
thf(fact_2291_rotate__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( rotate @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate @ B @ N @ Xs ) ) ) ).

% rotate_map
thf(fact_2292_rotate1__rotate__swap,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate1 @ A @ ( rotate @ A @ N @ Xs ) )
      = ( rotate @ A @ N @ ( rotate1 @ A @ Xs ) ) ) ).

% rotate1_rotate_swap
thf(fact_2293_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) @ Xs ) ) ).

% map_fst_zip_take
thf(fact_2294_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ B,Ys: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ B ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ Ys ) ) ).

% map_snd_zip_take
thf(fact_2295_take__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs )
      = ( nil @ A ) ) ).

% take_0
thf(fact_2296_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_take_subset
thf(fact_2297_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N @ Xs ) ) ) ) ).

% sorted_take
thf(fact_2298_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_2299_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_2300_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A3 @ K ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_2301_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_2302_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_2303_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_2304_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K4: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K4 ) ) @ ( one_one @ A ) ) @ K4 ) @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_2305_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A4 ) @ K4 ) ) @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_2306_rotate__append,axiom,
    ! [A: $tType,L: list @ A,Q4: list @ A] :
      ( ( rotate @ A @ ( size_size @ ( list @ A ) @ L ) @ ( append @ A @ L @ Q4 ) )
      = ( append @ A @ Q4 @ L ) ) ).

% rotate_append
thf(fact_2307_rotate__conv__mod,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N3: nat,Xs4: list @ A] : ( rotate @ A @ ( modulo_modulo @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs4 ) ) @ Xs4 ) ) ) ).

% rotate_conv_mod
thf(fact_2308_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ A3 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_2309_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A3 @ K ) )
          = ( times_times @ A @ A3 @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_2310_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ A3 @ ( gbinomial @ A @ A3 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_2311_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ A3 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_2312_set__take__subset__set__take,axiom,
    ! [A: $tType,M2: nat,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ M2 @ N )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M2 @ Xs ) ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) ) ) ).

% set_take_subset_set_take
thf(fact_2313_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_2314_dvd__fact,axiom,
    ! [M2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M2 )
     => ( ( ord_less_eq @ nat @ M2 @ N )
       => ( dvd_dvd @ nat @ M2 @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% dvd_fact
thf(fact_2315_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A3 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_2316_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A3 @ ( suc @ K ) ) )
          = ( times_times @ A @ A3 @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_2317_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M2: nat,A3: A] :
          ( ( ord_less_eq @ nat @ K @ M2 )
         => ( ( times_times @ A @ ( gbinomial @ A @ A3 @ M2 ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M2 ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M2 @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_2318_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P7: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P7 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P7 ) @ ( times_times @ A @ Y @ P7 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P7 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P7 ) @ ( times_times @ A @ Y @ P7 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_2319_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P7: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P7 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P7 ) @ ( times_times @ A @ Y @ P7 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P7 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P7 ) @ ( times_times @ A @ Y @ P7 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_2320_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P7: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ P7 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P7 @ X ) @ ( times_times @ A @ P7 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ P7 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P7 @ X ) @ ( times_times @ A @ P7 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_2321_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P7: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ P7 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P7 @ X ) @ ( times_times @ A @ P7 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P7 )
           => ( ( times_times @ A @ P7 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P7 @ X ) @ ( times_times @ A @ P7 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_2322_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ K )
             => ( ( nth @ A @ Xs @ I3 )
                = ( nth @ A @ Ys @ I3 ) ) )
         => ( ( take @ A @ K @ Xs )
            = ( take @ A @ K @ Ys ) ) ) ) ) ).

% nth_take_lemma
thf(fact_2323_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A3 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_2324_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_2325_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K4 ) @ A4 ) @ ( one_one @ A ) ) @ K4 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_2326_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_2327_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2328_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ) ).

% take_Cons'
thf(fact_2329_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A3 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_2330_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A3 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_2331_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R4 ) )
     => ~ ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys ) )
             => ( ( ( take @ A @ I3 @ Xs )
                  = ( take @ A @ I3 @ Ys ) )
               => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Ys @ I3 ) ) @ R4 ) ) ) ) ) ).

% lex_take_index
thf(fact_2332_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_2333_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_2334_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_2335_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_2336_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X ) @ Y )
            = X ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) ) )
            & ( ( take @ A @ I4 @ X )
              = ( take @ A @ I4 @ Y ) )
            & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X @ I4 ) @ ( nth @ A @ Y @ I4 ) ) @ R4 ) ) ) ) ).

% lexord_take_index_conv
thf(fact_2337_last__take__nth__conv,axiom,
    ! [A: $tType,N: nat,L: list @ A] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ L ) )
     => ( ( N
         != ( zero_zero @ nat ) )
       => ( ( last @ A @ ( take @ A @ N @ L ) )
          = ( nth @ A @ L @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% last_take_nth_conv
thf(fact_2338_complete__linorder__inf__min,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% complete_linorder_inf_min
thf(fact_2339_choose__two,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_2340_min__list__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( min_list @ A @ Xs )
            = ( lattic643756798350308766er_Min @ A @ ( set2 @ A @ Xs ) ) ) ) ) ).

% min_list_Min
thf(fact_2341_binomial__n__n,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ N )
      = ( one_one @ nat ) ) ).

% binomial_n_n
thf(fact_2342_Misc_Olast__in__set,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( L
       != ( nil @ A ) )
     => ( member2 @ A @ ( last @ A @ L ) @ ( set2 @ A @ L ) ) ) ).

% Misc.last_in_set
thf(fact_2343_List_Olast__in__set,axiom,
    ! [A: $tType,As2: list @ A] :
      ( ( As2
       != ( nil @ A ) )
     => ( member2 @ A @ ( last @ A @ As2 ) @ ( set2 @ A @ As2 ) ) ) ).

% List.last_in_set
thf(fact_2344_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_2345_last__appendR,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Ys ) ) ) ).

% last_appendR
thf(fact_2346_last__appendL,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( Ys
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Xs ) ) ) ).

% last_appendL
thf(fact_2347_last__snoc,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% last_snoc
thf(fact_2348_last__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( last @ nat @ ( upt @ I2 @ J ) )
        = ( minus_minus @ nat @ J @ ( one_one @ nat ) ) ) ) ).

% last_upt
thf(fact_2349_lexord__cons__cons,axiom,
    ! [A: $tType,A3: A,X: list @ A,B2: A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A3 @ X ) @ ( cons @ A @ B2 @ Y ) ) @ ( lexord @ A @ R4 ) )
      = ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
        | ( ( A3 = B2 )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_2350_lexord__Nil__left,axiom,
    ! [A: $tType,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y ) @ ( lexord @ A @ R4 ) )
      = ( ? [A4: A,X2: list @ A] :
            ( Y
            = ( cons @ A @ A4 @ X2 ) ) ) ) ).

% lexord_Nil_left
thf(fact_2351_choose__one,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( one_one @ nat ) )
      = N ) ).

% choose_one
thf(fact_2352_last__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ B ) @ Ys ) )
         => ( ( last @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
            = ( product_Pair @ A @ B @ ( last @ A @ Xs ) @ ( last @ B @ Ys ) ) ) ) ) ) ).

% last_zip
thf(fact_2353_last__ConsR,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_ConsR
thf(fact_2354_last__ConsL,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = X ) ) ).

% last_ConsL
thf(fact_2355_last_Osimps,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = X ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) ).

% last.simps
thf(fact_2356_last__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( last @ A @ Xs ) ) ) ) ).

% last_map
thf(fact_2357_last__append,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Ys ) ) ) ) ).

% last_append
thf(fact_2358_longest__common__suffix,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
    ? [Ss: list @ A,Xs3: list @ A,Ys2: list @ A] :
      ( ( Xs
        = ( append @ A @ Xs3 @ Ss ) )
      & ( Ys
        = ( append @ A @ Ys2 @ Ss ) )
      & ( ( Xs3
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ A ) )
        | ( ( last @ A @ Xs3 )
         != ( last @ A @ Ys2 ) ) ) ) ).

% longest_common_suffix
thf(fact_2359_lexord__irreflexive,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X3: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R4 )
     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_irreflexive
thf(fact_2360_lexord__linear,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: list @ A,Y: list @ A] :
      ( ! [A6: A,B5: A] :
          ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ B5 ) @ R4 )
          | ( A6 = B5 )
          | ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ A6 ) @ R4 ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
        | ( X = Y )
        | ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ X ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_linear
thf(fact_2361_lexord__Nil__right,axiom,
    ! [A: $tType,X: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) @ ( lexord @ A @ R4 ) ) ).

% lexord_Nil_right
thf(fact_2362_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V2: list @ A,R4: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R4 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_append_leftI
thf(fact_2363_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N @ K ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_2364_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A ),Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A,Y3: A,Z4: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y3 ) @ R4 )
           => ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z4 ) @ R4 )
             => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Z4 ) @ R4 ) ) ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R4 ) )
       => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R4 ) )
         => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( lexord @ A @ R4 ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_2365_lexord__append__leftD,axiom,
    ! [A: $tType,X: list @ A,U: list @ A,V2: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R4 ) )
     => ( ! [A6: A] :
            ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ A6 ) @ R4 )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_append_leftD
thf(fact_2366_lexord__append__rightI,axiom,
    ! [A: $tType,Y: list @ A,X: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ? [B9: A,Z6: list @ A] :
          ( Y
          = ( cons @ A @ B9 @ Z6 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( append @ A @ X @ Y ) ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_append_rightI
thf(fact_2367_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs: list @ A,Ys: list @ A,Qs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R4 ) )
     => ( ( Xs != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R4 ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_2368_binomial__absorption,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N @ ( suc @ K ) ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_2369_lexord__lex,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lex @ A @ R4 ) )
      = ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
        & ( ( size_size @ ( list @ A ) @ X )
          = ( size_size @ ( list @ A ) @ Y ) ) ) ) ).

% lexord_lex
thf(fact_2370_lexord__append__left__rightI,axiom,
    ! [A: $tType,A3: A,B2: A,R4: set @ ( product_prod @ A @ A ),U: list @ A,X: list @ A,Y: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A3 @ X ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y ) ) ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_append_left_rightI
thf(fact_2371_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R4 ) )
      = ( ? [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R4 ) )
        | ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_2372_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R4: set @ ( product_prod @ A @ A ),V2: list @ A,Z2: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R4 ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V2 ) @ ( append @ A @ W @ Z2 ) ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_sufI
thf(fact_2373_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_2374_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_2375_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F3: nat > A > A,A4: nat,B3: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B3 @ A4 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F3 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B3 @ ( F3 @ A4 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_2376_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y )
     => ( ( ( ord_less @ nat @ Xb @ Xa )
         => ( Y = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb @ Xa )
         => ( Y
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_2377_last__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ Xs )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ) ) ).

% last_conv_nth
thf(fact_2378_binomial__code,axiom,
    ( binomial
    = ( ^ [N3: nat,K4: nat] : ( if @ nat @ ( ord_less @ nat @ N3 @ K4 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K4 ) ) @ ( binomial @ N3 @ ( minus_minus @ nat @ N3 @ K4 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N3 @ K4 ) @ ( one_one @ nat ) ) @ N3 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K4 ) ) ) ) ) ) ).

% binomial_code
thf(fact_2379_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_2380_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2381_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2382_drop__last__conv,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( L
       != ( nil @ A ) )
     => ( ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ L ) @ ( suc @ ( zero_zero @ nat ) ) ) @ L )
        = ( cons @ A @ ( last @ A @ L ) @ ( nil @ A ) ) ) ) ).

% drop_last_conv
thf(fact_2383_take__update__last,axiom,
    ! [A: $tType,N: nat,List: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ List ) )
     => ( ( list_update @ A @ ( take @ A @ ( suc @ N ) @ List ) @ N @ X )
        = ( append @ A @ ( take @ A @ N @ List ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% take_update_last
thf(fact_2384_id__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( Xs
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_2385_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ ( suc @ I2 ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I2 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_2386_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_2387_lenlex__append2,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( irrefl @ A @ R )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys ) ) @ ( lenlex @ A @ R ) )
        = ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lenlex @ A @ R ) ) ) ) ).

% lenlex_append2
thf(fact_2388_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A,Y: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I2 @ Y )
      = ( list_update @ A @ Xs @ I2 @ Y ) ) ).

% list_update_overwrite
thf(fact_2389_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X2: list @ A] : X2 ) ) ).

% drop0
thf(fact_2390_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X: A] :
      ( ( ( list_update @ A @ Xs @ K @ X )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_2391_drop__upt,axiom,
    ! [M2: nat,I2: nat,J: nat] :
      ( ( drop @ nat @ M2 @ ( upt @ I2 @ J ) )
      = ( upt @ ( plus_plus @ nat @ I2 @ M2 ) @ J ) ) ).

% drop_upt
thf(fact_2392_length__list__update,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs @ I2 @ X ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_list_update
thf(fact_2393_drop__drop,axiom,
    ! [A: $tType,N: nat,M2: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( drop @ A @ M2 @ Xs ) )
      = ( drop @ A @ ( plus_plus @ nat @ N @ M2 ) @ Xs ) ) ).

% drop_drop
thf(fact_2394_list__update__id,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ I2 ) )
      = Xs ) ).

% list_update_id
thf(fact_2395_nth__list__update__neq,axiom,
    ! [A: $tType,I2: nat,J: nat,Xs: list @ A,X: A] :
      ( ( I2 != J )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% nth_list_update_neq
thf(fact_2396_in__set__remove1,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list @ A] :
      ( ( A3 != B2 )
     => ( ( member2 @ A @ A3 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs ) ) )
        = ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) ) ) ) ).

% in_set_remove1
thf(fact_2397_take__update__swap,axiom,
    ! [A: $tType,M2: nat,Xs: list @ A,N: nat,X: A] :
      ( ( take @ A @ M2 @ ( list_update @ A @ Xs @ N @ X ) )
      = ( list_update @ A @ ( take @ A @ M2 @ Xs ) @ N @ X ) ) ).

% take_update_swap
thf(fact_2398_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ N @ Xs ) ) ).

% drop_Suc_Cons
thf(fact_2399_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 )
     => ( ( list_update @ A @ Xs @ I2 @ X )
        = Xs ) ) ).

% list_update_beyond
thf(fact_2400_length__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_drop
thf(fact_2401_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M2: nat,Xs: list @ A,Y: A] :
      ( ( ord_less_eq @ nat @ N @ M2 )
     => ( ( take @ A @ N @ ( list_update @ A @ Xs @ M2 @ Y ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_update_cancel
thf(fact_2402_drop__update__cancel,axiom,
    ! [A: $tType,N: nat,M2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ M2 )
     => ( ( drop @ A @ M2 @ ( list_update @ A @ Xs @ N @ X ) )
        = ( drop @ A @ M2 @ Xs ) ) ) ).

% drop_update_cancel
thf(fact_2403_append__take__drop__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( drop @ A @ N @ Xs ) )
      = Xs ) ).

% append_take_drop_id
thf(fact_2404_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N @ Xs ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil2
thf(fact_2405_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil
thf(fact_2406_drop__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_2407_list__update__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A] :
      ( ( list_update @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) @ Y )
      = ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) ).

% list_update_length
thf(fact_2408_drop__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A] :
      ( ( drop @ A @ N @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( drop @ A @ N @ Xs ) @ ( drop @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% drop_append
thf(fact_2409_nth__list__update__eq,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I2 )
        = X ) ) ).

% nth_list_update_eq
thf(fact_2410_last__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( last @ A @ ( drop @ A @ N @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_drop
thf(fact_2411_Int__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A3 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D3 ) )
          = ( set_or5935395276787703475ssThan @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D3 ) ) ) ) ).

% Int_greaterThanLessThan
thf(fact_2412_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R4 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R4 ) )
        = ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R4 ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_2413_set__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I2 ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_2414_drop__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ).

% drop_Cons_numeral
thf(fact_2415_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I2: nat] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( drop @ A @ N @ Xs ) @ I2 )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ N @ I2 ) ) ) ) ).

% nth_drop
thf(fact_2416_lexord__irrefl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R ) ) ) ).

% lexord_irrefl
thf(fact_2417_drop__update__swap,axiom,
    ! [A: $tType,M2: nat,N: nat,Xs: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ M2 @ N )
     => ( ( drop @ A @ M2 @ ( list_update @ A @ Xs @ N @ X ) )
        = ( list_update @ A @ ( drop @ A @ M2 @ Xs ) @ ( minus_minus @ nat @ N @ M2 ) @ X ) ) ) ).

% drop_update_swap
thf(fact_2418_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I2: nat,X: A,Ys: list @ B,Y: B] :
      ( ( zip @ A @ B @ ( list_update @ A @ Xs @ I2 @ X ) @ ( list_update @ B @ Ys @ I2 @ Y ) )
      = ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_update
thf(fact_2419_drop__zip,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys: list @ B] :
      ( ( drop @ ( product_prod @ A @ B ) @ N @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( drop @ A @ N @ Xs ) @ ( drop @ B @ N @ Ys ) ) ) ).

% drop_zip
thf(fact_2420_remove1__commute,axiom,
    ! [A: $tType,X: A,Y: A,Zs: list @ A] :
      ( ( remove1 @ A @ X @ ( remove1 @ A @ Y @ Zs ) )
      = ( remove1 @ A @ Y @ ( remove1 @ A @ X @ Zs ) ) ) ).

% remove1_commute
thf(fact_2421_list__update__swap,axiom,
    ! [A: $tType,I2: nat,I5: nat,Xs: list @ A,X: A,X6: A] :
      ( ( I2 != I5 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I5 @ X6 )
        = ( list_update @ A @ ( list_update @ A @ Xs @ I5 @ X6 ) @ I2 @ X ) ) ) ).

% list_update_swap
thf(fact_2422_irrefl__lex,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R4 )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R4 ) ) ) ).

% irrefl_lex
thf(fact_2423_drop__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( drop @ A @ N @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% drop_Nil
thf(fact_2424_drop__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs )
      = Xs ) ).

% drop_0
thf(fact_2425_in__set__dropD,axiom,
    ! [A: $tType,X: A,N: nat,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_dropD
thf(fact_2426_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I2: nat,V2: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ V2 )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_2427_list__update__code_I1_J,axiom,
    ! [A: $tType,I2: nat,Y: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ Y )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_2428_drop__map,axiom,
    ! [A: $tType,B: $tType,N: nat,F2: B > A,Xs: list @ B] :
      ( ( drop @ A @ N @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( drop @ B @ N @ Xs ) ) ) ).

% drop_map
thf(fact_2429_map__update,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,K: nat,Y: B] :
      ( ( map @ B @ A @ F2 @ ( list_update @ B @ Xs @ K @ Y ) )
      = ( list_update @ A @ ( map @ B @ A @ F2 @ Xs ) @ K @ ( F2 @ Y ) ) ) ).

% map_update
thf(fact_2430_sorted__wrt__drop,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( drop @ A @ N @ Xs ) ) ) ).

% sorted_wrt_drop
thf(fact_2431_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = Xs ) )
      & ( ( X != Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( remove1 @ A @ X @ Xs ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_2432_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remove1 @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_2433_remove1__idem,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( remove1 @ A @ X @ Xs )
        = Xs ) ) ).

% remove1_idem
thf(fact_2434_notin__set__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member2 @ A @ X @ ( set2 @ A @ ( remove1 @ A @ Y @ Xs ) ) ) ) ).

% notin_set_remove1
thf(fact_2435_update__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,I2: nat,Xy: product_prod @ A @ B] :
      ( ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 @ Xy )
      = ( zip @ A @ B @ ( list_update @ A @ Xs @ I2 @ ( product_fst @ A @ B @ Xy ) ) @ ( list_update @ B @ Ys @ I2 @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% update_zip
thf(fact_2436_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_drop_subset
thf(fact_2437_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) @ Y )
      = ( cons @ A @ Y @ Xs ) ) ).

% list_update_code(2)
thf(fact_2438_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I2: nat,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ I2 ) @ Y )
      = ( cons @ A @ X @ ( list_update @ A @ Xs @ I2 @ Y ) ) ) ).

% list_update_code(3)
thf(fact_2439_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N @ Xs ) ) ) ) ).

% sorted_drop
thf(fact_2440_nth__via__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ( ( nth @ A @ Xs @ N )
        = Y ) ) ).

% nth_via_drop
thf(fact_2441_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A,X: A,I2: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
     => ( ( member2 @ A @ X @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I2 @ X ) ) @ A5 ) ) ) ).

% set_update_subsetI
thf(fact_2442_take__drop,axiom,
    ! [A: $tType,N: nat,M2: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( drop @ A @ M2 @ Xs ) )
      = ( drop @ A @ M2 @ ( take @ A @ ( plus_plus @ nat @ N @ M2 ) @ Xs ) ) ) ).

% take_drop
thf(fact_2443_drop__take,axiom,
    ! [A: $tType,N: nat,M2: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( take @ A @ M2 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ M2 @ N ) @ ( drop @ A @ N @ Xs ) ) ) ).

% drop_take
thf(fact_2444_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N3: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N3 ) @ M3 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_2445_set__remove1__subset,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_remove1_subset
thf(fact_2446_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A3 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_2447_remove1__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( remove1 @ A @ X @ Xs ) @ Ys ) ) )
      & ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( remove1 @ A @ X @ Ys ) ) ) ) ) ).

% remove1_append
thf(fact_2448_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,A3: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ Xs @ I2 @ A3 )
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ A3 @ ( drop @ A @ ( suc @ I2 ) @ Xs ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_2449_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ M2 )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M2 @ Xs ) ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_2450_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I2 @ X ) ) @ ( insert3 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_update_subset_insert
thf(fact_2451_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member2 @ A @ X @ ( set2 @ A @ ( list_update @ A @ Xs @ N @ X ) ) ) ) ).

% set_update_memI
thf(fact_2452_list__update__append1,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ I2 @ X )
        = ( append @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ Ys ) ) ) ).

% list_update_append1
thf(fact_2453_nth__list__update,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I2 = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
            = X ) )
        & ( ( I2 != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
            = ( nth @ A @ Xs @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_2454_list__update__same__conv,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I2 @ X )
          = Xs )
        = ( ( nth @ A @ Xs @ I2 )
          = X ) ) ) ).

% list_update_same_conv
thf(fact_2455_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Zs )
      = ( ( Xs
          = ( take @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) )
        & ( Ys
          = ( drop @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% append_eq_conv_conj
thf(fact_2456_take__add,axiom,
    ! [A: $tType,I2: nat,J: nat,Xs: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I2 @ J ) @ Xs )
      = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( take @ A @ J @ ( drop @ A @ I2 @ Xs ) ) ) ) ).

% take_add
thf(fact_2457_lexl__not__refl,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( irrefl @ A @ R4 )
     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ X ) @ ( lex @ A @ R4 ) ) ) ).

% lexl_not_refl
thf(fact_2458_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_2459_remove1__split,axiom,
    ! [A: $tType,A3: A,Xs: list @ A,Ys: list @ A] :
      ( ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) )
     => ( ( ( remove1 @ A @ A3 @ Xs )
          = Ys )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs
                = ( append @ A @ Ls @ ( cons @ A @ A3 @ Rs ) ) )
              & ~ ( member2 @ A @ A3 @ ( set2 @ A @ Ls ) )
              & ( Ys
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_2460_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_2461_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( drop @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% drop_Cons'
thf(fact_2462_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N @ X )
          = ( append @ A @ ( list_update @ A @ Xs @ N @ X ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N @ X )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_2463_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_2464_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs ) )
        = ( drop @ A @ I2 @ Xs ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_2465_length__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_remove1
thf(fact_2466_last__list__update,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( ( K
            = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = X ) )
        & ( ( K
           != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = ( last @ A @ Xs ) ) ) ) ) ).

% last_list_update
thf(fact_2467_rotate__drop__take,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N3: nat,Xs4: list @ A] : ( append @ A @ ( drop @ A @ ( modulo_modulo @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs4 ) ) @ Xs4 ) @ ( take @ A @ ( modulo_modulo @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs4 ) ) @ Xs4 ) ) ) ) ).

% rotate_drop_take
thf(fact_2468_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ B] :
      ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ ( take @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) @ ( zip @ A @ B @ Ys @ ( drop @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% zip_append1
thf(fact_2469_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( append @ B @ Ys @ Zs ) )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) @ Ys ) @ ( zip @ A @ B @ ( drop @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) @ Zs ) ) ) ).

% zip_append2
thf(fact_2470_butlast__upd__last__eq,axiom,
    ! [A: $tType,L: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ L ) )
     => ( ( list_update @ A @ ( butlast @ A @ L ) @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ L ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ X )
        = ( append @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ L ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ L ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% butlast_upd_last_eq
thf(fact_2471_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N @ Xs ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_hd_drop
thf(fact_2472_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N @ X ) )
          = ( insert3 @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert3 @ A @ ( nth @ A @ Xs @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_2473_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ I2 ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I2 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_2474_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_2475_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_2476_hd__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( hd @ nat @ ( upt @ I2 @ J ) )
        = I2 ) ) ).

% hd_upt
thf(fact_2477_distinct__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate @ A @ N @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rotate
thf(fact_2478_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct1_rotate
thf(fact_2479_distinct__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct @ A @ ( insert @ A @ X @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_insert
thf(fact_2480_distinct__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys ) )
      = ( distinct @ A @ Ys ) ) ).

% distinct_union
thf(fact_2481_hd__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_append2
thf(fact_2482_Int__atMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ A3 ) @ ( set_ord_atMost @ A @ B2 ) )
          = ( set_ord_atMost @ A @ ( ord_min @ A @ A3 @ B2 ) ) ) ) ).

% Int_atMost
thf(fact_2483_nths__upt__eq__take,axiom,
    ! [A: $tType,L: list @ A,N: nat] :
      ( ( nths @ A @ L @ ( set_ord_lessThan @ nat @ N ) )
      = ( take @ A @ N @ L ) ) ).

% nths_upt_eq_take
thf(fact_2484_butlast__snoc,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = Xs ) ).

% butlast_snoc
thf(fact_2485_hd__take,axiom,
    ! [A: $tType,J: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J )
     => ( ( hd @ A @ ( take @ A @ J @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_take
thf(fact_2486_length__butlast,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_butlast
thf(fact_2487_Int__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D3 ) ) ) ) ).

% Int_greaterThanAtMost
thf(fact_2488_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_2489_distinct__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I2 ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_2490_append__butlast__last__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) ).

% append_butlast_last_id
thf(fact_2491_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_2492_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ B @ Ys )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ) ).

% distinct_product
thf(fact_2493_distinct__butlast,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( butlast @ A @ Xs ) ) ) ).

% distinct_butlast
thf(fact_2494_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( distinct @ A @ Xs ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_2495_distinct__zipI2,axiom,
    ! [B: $tType,A: $tType,Ys: list @ A,Xs: list @ B] :
      ( ( distinct @ A @ Ys )
     => ( distinct @ ( product_prod @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys ) ) ) ).

% distinct_zipI2
thf(fact_2496_distinct__zipI1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% distinct_zipI1
thf(fact_2497_ivl__disj__int__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(3)
thf(fact_2498_distinct__length__2__or__more,axiom,
    ! [A: $tType,A3: A,B2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A3 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A3 != B2 )
        & ( distinct @ A @ ( cons @ A @ A3 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_2499_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% distinct_set_subseqs
thf(fact_2500_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_2501_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X22 ) )
      = X21 ) ).

% list.sel(1)
thf(fact_2502_distinct__take,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( take @ A @ I2 @ Xs ) ) ) ).

% distinct_take
thf(fact_2503_distinct__upt,axiom,
    ! [I2: nat,J: nat] : ( distinct @ nat @ ( upt @ I2 @ J ) ) ).

% distinct_upt
thf(fact_2504_distinct__drop,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( drop @ A @ I2 @ Xs ) ) ) ).

% distinct_drop
thf(fact_2505_distinct__product__lists,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ! [X3: list @ A] :
          ( ( member2 @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xss2 ) )
         => ( distinct @ A @ X3 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss2 ) ) ) ).

% distinct_product_lists
thf(fact_2506_distinct__upto,axiom,
    ! [I2: int,J: int] : ( distinct @ int @ ( upto @ I2 @ J ) ) ).

% distinct_upto
thf(fact_2507_butlast_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% butlast.simps(1)
thf(fact_2508_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_2509_distinct__remove1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( remove1 @ A @ X @ Xs ) ) ) ).

% distinct_remove1
thf(fact_2510_in__set__butlastD,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_butlastD
thf(fact_2511_distinct__nthsI,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( nths @ A @ Xs @ I ) ) ) ).

% distinct_nthsI
thf(fact_2512_map__butlast,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( butlast @ B @ Xs ) )
      = ( butlast @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_butlast
thf(fact_2513_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_removeAll
thf(fact_2514_distinct__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ).

% distinct_enumerate
thf(fact_2515_drop__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( butlast @ A @ Xs ) )
      = ( butlast @ A @ ( drop @ A @ N @ Xs ) ) ) ).

% drop_butlast
thf(fact_2516_hd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ( hd @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
          = ( product_Pair @ A @ B @ ( hd @ A @ Xs ) @ ( hd @ B @ Ys ) ) ) ) ) ).

% hd_zip
thf(fact_2517_hd__last__singletonI,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( ( hd @ A @ Xs )
          = ( last @ A @ Xs ) )
       => ( ( distinct @ A @ Xs )
         => ( Xs
            = ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ) ).

% hd_last_singletonI
thf(fact_2518_hd__butlast,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( butlast @ A @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_butlast
thf(fact_2519_distinct__singleton,axiom,
    ! [A: $tType,X: A] : ( distinct @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_2520_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X @ Xs ) )
      = ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) ).

% distinct.simps(2)
thf(fact_2521_finite__distinct__list,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [Xs2: list @ A] :
          ( ( ( set2 @ A @ Xs2 )
            = A5 )
          & ( distinct @ A @ Xs2 ) ) ) ).

% finite_distinct_list
thf(fact_2522_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% atLeast_upt
thf(fact_2523_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A3: list @ A] :
      ( ( A3
       != ( nil @ A ) )
     => ( member2 @ A @ ( hd @ A @ A3 ) @ ( set2 @ A @ A3 ) ) ) ).

% list.set_sel(1)
thf(fact_2524_hd__in__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member2 @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) ).

% hd_in_set
thf(fact_2525_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A3: list @ A,F2: A > B] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A3 ) )
        = ( F2 @ ( hd @ A @ A3 ) ) ) ) ).

% list.map_sel(1)
thf(fact_2526_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( hd @ A @ Xs ) ) ) ) ).

% hd_map
thf(fact_2527_hd__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Xs ) ) ) ) ).

% hd_append
thf(fact_2528_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
    ? [Ps: list @ A,Xs3: list @ A,Ys2: list @ A] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs3 ) )
      & ( Ys
        = ( append @ A @ Ps @ Ys2 ) )
      & ( ( Xs3
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs3 )
         != ( hd @ A @ Ys2 ) ) ) ) ).

% longest_common_prefix
thf(fact_2529_hd__Nil__eq__last,axiom,
    ! [A: $tType] :
      ( ( hd @ A @ ( nil @ A ) )
      = ( last @ A @ ( nil @ A ) ) ) ).

% hd_Nil_eq_last
thf(fact_2530_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N3: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N3 ) @ ( suc @ M3 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_2531_ivl__disj__int__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or3652927894154168847AtMost @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(6)
thf(fact_2532_butlast_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( butlast @ A @ Xs ) ) ) ) ) ).

% butlast.simps(2)
thf(fact_2533_butlast__append,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys ) ) ) ) ) ).

% butlast_append
thf(fact_2534_in__set__butlast__appendI,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( ( member2 @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
        | ( member2 @ A @ X @ ( set2 @ A @ ( butlast @ A @ Ys ) ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ ( butlast @ A @ ( append @ A @ Xs @ Ys ) ) ) ) ) ).

% in_set_butlast_appendI
thf(fact_2535_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ Xs )
        = ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_remove1_removeAll
thf(fact_2536_greaterThan__Int__greaterThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A3 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( set_ord_lessThan @ A @ ( ord_min @ A @ A3 @ B2 ) ) ) ) ).

% greaterThan_Int_greaterThan
thf(fact_2537_subseqs__distinctD,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( member2 @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( ( distinct @ A @ Xs )
       => ( distinct @ A @ Ys ) ) ) ).

% subseqs_distinctD
thf(fact_2538_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_2539_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs2: list @ A,Ys3: list @ A,Zs2: list @ A,Y3: A] :
          ( Ws
          = ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ ( append @ A @ Ys3 @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_2540_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As2: list @ A] :
      ( ( ~ ( distinct @ A @ As2 ) )
      = ( ? [Xs4: list @ A,Y2: A,Ys4: list @ A] :
            ( ( member2 @ A @ Y2 @ ( set2 @ A @ Xs4 ) )
            & ( distinct @ A @ Xs4 )
            & ( As2
              = ( append @ A @ Xs4 @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_2541_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_2542_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N3 ) ) ) ) ) ).

% atMost_upto
thf(fact_2543_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,J: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I2 )
              = ( nth @ A @ Xs @ J ) )
            = ( I2 = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_2544_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs4: list @ A] :
          ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs4 ) )
           => ! [J2: nat] :
                ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs4 ) )
               => ( ( I4 != J2 )
                 => ( ( nth @ A @ Xs4 @ I4 )
                   != ( nth @ A @ Xs4 @ J2 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_2545_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_2546_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A3 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D3 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A3 )
            | ( ord_less_eq @ A @ D3 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D3 @ A3 ) ) ) ) ).

% Ioc_disjoint
thf(fact_2547_butlast__subset,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( butlast @ A @ Xs ) ) @ A5 ) ) ) ).

% butlast_subset
thf(fact_2548_butlast__eq__consE,axiom,
    ! [A: $tType,L: list @ A,X: A,Xs: list @ A] :
      ( ( ( butlast @ A @ L )
        = ( cons @ A @ X @ Xs ) )
     => ~ ! [Xl: A] :
            ( L
           != ( cons @ A @ X @ ( append @ A @ Xs @ ( cons @ A @ Xl @ ( nil @ A ) ) ) ) ) ) ).

% butlast_eq_consE
thf(fact_2549_butlast__eq__cons__conv,axiom,
    ! [A: $tType,L: list @ A,X: A,Xs: list @ A] :
      ( ( ( butlast @ A @ L )
        = ( cons @ A @ X @ Xs ) )
      = ( ? [Xl2: A] :
            ( L
            = ( cons @ A @ X @ ( append @ A @ Xs @ ( cons @ A @ Xl2 @ ( nil @ A ) ) ) ) ) ) ) ).

% butlast_eq_cons_conv
thf(fact_2550_sorted__butlast,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( butlast @ A @ Xs ) ) ) ) ) ).

% sorted_butlast
thf(fact_2551_nth__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs ) ) )
     => ( ( nth @ A @ ( butlast @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ N ) ) ) ).

% nth_butlast
thf(fact_2552_ivl__disj__int__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or5935395276787703475ssThan @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(2)
thf(fact_2553_take__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ N @ ( butlast @ A @ Xs ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_butlast
thf(fact_2554_ivl__disj__int__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(1)
thf(fact_2555_butlast__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( butlast @ nat @ ( upt @ M2 @ N ) )
      = ( upt @ M2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% butlast_upt
thf(fact_2556_not__distinct__split__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ~ ( distinct @ A @ Xs )
     => ~ ! [Y3: A,Ys3: list @ A] :
            ( ( distinct @ A @ Ys3 )
           => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Ys3 ) )
             => ! [Zs2: list @ A] :
                  ( Xs
                 != ( append @ A @ Ys3 @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_split_distinct
thf(fact_2557_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ? [X3: list @ A] :
              ( ( ( set2 @ A @ X3 )
                = A5 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X3 )
              & ( distinct @ A @ X3 )
              & ! [Y5: list @ A] :
                  ( ( ( ( set2 @ A @ Y5 )
                      = A5 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y5 )
                    & ( distinct @ A @ Y5 ) )
                 => ( Y5 = X3 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_2558_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ? [X3: nat] :
            ( ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X3 )
              = X )
            & ! [Y5: nat] :
                ( ( ( ord_less @ nat @ Y5 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y5 )
                    = X ) )
               => ( Y5 = X3 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_2559_sorted__hd__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ! [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ ( hd @ A @ Xs ) @ X4 ) ) ) ) ) ).

% sorted_hd_min
thf(fact_2560_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_2561_hd__drop__conv__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( drop @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ N ) ) ) ).

% hd_drop_conv_nth
thf(fact_2562_sorted__hd__last,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
         => ( ( L
             != ( nil @ A ) )
           => ( ord_less_eq @ A @ ( hd @ A @ L ) @ ( last @ A @ L ) ) ) ) ) ).

% sorted_hd_last
thf(fact_2563_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_2564_snoc__eq__iff__butlast_H,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A,X: A] :
      ( ( Ys
        = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( ( Ys
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys )
          = Xs )
        & ( ( last @ A @ Ys )
          = X ) ) ) ).

% snoc_eq_iff_butlast'
thf(fact_2565_snoc__eq__iff__butlast,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = Ys )
      = ( ( Ys
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys )
          = Xs )
        & ( ( last @ A @ Ys )
          = X ) ) ) ).

% snoc_eq_iff_butlast
thf(fact_2566_butlast__conv__take,axiom,
    ! [A: $tType] :
      ( ( butlast @ A )
      = ( ^ [Xs4: list @ A] : ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) @ ( one_one @ nat ) ) @ Xs4 ) ) ) ).

% butlast_conv_take
thf(fact_2567_butlast__list__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,X: A] :
      ( ( ( K
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs @ K @ X ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( K
         != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs @ K @ X ) )
          = ( list_update @ A @ ( butlast @ A @ Xs ) @ K @ X ) ) ) ) ).

% butlast_list_update
thf(fact_2568_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_2569_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I4: int,J2: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_2570_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rotate @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_rotate_conv_nth
thf(fact_2571_butlast__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( butlast @ A @ ( take @ A @ N @ Xs ) )
        = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% butlast_take
thf(fact_2572_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A3: A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member2 @ A @ A3 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert3 @ A @ ( nth @ A @ Xs @ I2 ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I2 @ A3 ) ) ) ) ).

% distinct_list_update
thf(fact_2573_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I2: nat,J: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I2 @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_2574_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
      = ( ? [Y2: A,N3: nat] :
            ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N3 ) @ Y2 ) @ R4 )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys
              = ( list_update @ A @ Xs @ N3 @ Y2 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_2575_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys4: list @ A] :
            ( ( member2 @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys4 ) )
        & ! [Ys4: list @ A,Zs3: list @ A] :
            ( ( ( member2 @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member2 @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys4 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_2576_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,L: list @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A5 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A5 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A5 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_2577_zipf__zip,axiom,
    ! [A: $tType,B: $tType,L12: list @ A,L22: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ L12 )
        = ( size_size @ ( list @ B ) @ L22 ) )
     => ( ( zipf @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ L12 @ L22 )
        = ( zip @ A @ B @ L12 @ L22 ) ) ) ).

% zipf_zip
thf(fact_2578_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_2579_cppi,axiom,
    ! [D2: int,P2: int > $o,P3: int > $o,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ? [Z6: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ Z6 @ X3 )
           => ( ( P2 @ X3 )
              = ( P3 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                 => ! [Xb2: int] :
                      ( ( member2 @ int @ Xb2 @ A5 )
                     => ( X3
                       != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P2 @ X3 )
               => ( P2 @ ( plus_plus @ int @ X3 @ D2 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P3 @ X3 )
                = ( P3 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
           => ( ( ? [X5: int] : ( P2 @ X5 ) )
              = ( ? [X2: int] :
                    ( ( member2 @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                    & ( P3 @ X2 ) )
                | ? [X2: int] :
                    ( ( member2 @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                    & ? [Y2: int] :
                        ( ( member2 @ int @ Y2 @ A5 )
                        & ( P2 @ ( minus_minus @ int @ Y2 @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_2580_card__UNIV__unit,axiom,
    ( ( finite_card @ product_unit @ ( top_top @ ( set @ product_unit ) ) )
    = ( one_one @ nat ) ) ).

% card_UNIV_unit
thf(fact_2581_concat__append,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs @ Ys ) )
      = ( append @ A @ ( concat @ A @ Xs ) @ ( concat @ A @ Ys ) ) ) ).

% concat_append
thf(fact_2582_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) )
          = ( finite_card @ A @ A5 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_2583_rat__one__code,axiom,
    ( ( quotient_of @ ( one_one @ rat ) )
    = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% rat_one_code
thf(fact_2584_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss2 )
        = ( nil @ A ) )
      = ( ! [X2: list @ A] :
            ( ( member2 @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss2 ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_2585_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss2 ) )
      = ( ! [X2: list @ A] :
            ( ( member2 @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss2 ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_2586_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R4 ) )
      = ( ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
          & ( Xs = Ys ) )
        | ( ( X = Y )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_2587_Int__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D3 ) ) ) ) ).

% Int_atLeastAtMost
thf(fact_2588_Int__atLeastAtMostL1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_ord_atMost @ A @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ A3 @ ( ord_min @ A @ B2 @ D3 ) ) ) ) ).

% Int_atLeastAtMostL1
thf(fact_2589_Int__atLeastAtMostR1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ C2 @ ( ord_min @ A @ B2 @ D3 ) ) ) ) ).

% Int_atLeastAtMostR1
thf(fact_2590_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_2591_card__Diff__insert,axiom,
    ! [A: $tType,A3: A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ A @ A3 @ A5 )
     => ( ~ ( member2 @ A @ A3 @ B4 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ A3 @ B4 ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) ) @ ( one_one @ nat ) ) ) ) ) ).

% card_Diff_insert
thf(fact_2592_card__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or1337092689740270186AtMost @ int @ L @ U ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ U @ L ) @ ( one_one @ int ) ) ) ) ).

% card_atLeastAtMost_int
thf(fact_2593_quotient__of__number_I4_J,axiom,
    ( ( quotient_of @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
    = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(4)
thf(fact_2594_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_2595_card__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or5935395276787703475ssThan @ int @ L @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ ( plus_plus @ int @ L @ ( one_one @ int ) ) ) ) ) ).

% card_greaterThanLessThan_int
thf(fact_2596_listrel1__mono,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R4 ) @ ( listrel1 @ A @ S3 ) ) ) ).

% listrel1_mono
thf(fact_2597_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A4: rat] :
          ( if @ rat
          @ ( A4
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A4 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_2598_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or3652927894154168847AtMost @ int @ L @ U ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
thf(fact_2599_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J2: int] : ( set2 @ int @ ( upto @ I4 @ J2 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_2600_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( concat @ B @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) ) ) ).

% map_concat
thf(fact_2601_List_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind @ A @ B )
      = ( ^ [Xs4: list @ A,F3: A > ( list @ B )] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F3 @ Xs4 ) ) ) ) ).

% List.bind_def
thf(fact_2602_maps__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( maps @ A @ B )
      = ( ^ [F3: A > ( list @ B ),Xs4: list @ A] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F3 @ Xs4 ) ) ) ) ).

% maps_def
thf(fact_2603_concat__map__maps,axiom,
    ! [A: $tType,B: $tType,F2: B > ( list @ A ),Xs: list @ B] :
      ( ( concat @ A @ ( map @ B @ ( list @ A ) @ F2 @ Xs ) )
      = ( maps @ B @ A @ F2 @ Xs ) ) ).

% concat_map_maps
thf(fact_2604_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_2605_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X: list @ A,Xs: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X @ Xs ) )
      = ( append @ A @ X @ ( concat @ A @ Xs ) ) ) ).

% concat.simps(2)
thf(fact_2606_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel1I2
thf(fact_2607_zipf_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B > C] :
      ( ( zipf @ A @ B @ C @ F2 @ ( nil @ A ) @ ( nil @ B ) )
      = ( nil @ C ) ) ).

% zipf.simps(1)
thf(fact_2608_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R4 ) ) ).

% not_Nil_listrel1
thf(fact_2609_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R4 ) ) ).

% not_listrel1_Nil
thf(fact_2610_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_2611_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R4 ) ) ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R4 ) ) ) ).

% append_listrel1I
thf(fact_2612_ivl__disj__int__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(4)
thf(fact_2613_ivl__disj__int__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or3652927894154168847AtMost @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(8)
thf(fact_2614_ivl__disj__int__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(5)
thf(fact_2615_ivl__disj__int__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or5935395276787703475ssThan @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(4)
thf(fact_2616_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_2617_card__1__singletonE,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ( finite_card @ A @ A5 )
        = ( one_one @ nat ) )
     => ~ ! [X3: A] :
            ( A5
           != ( insert3 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_2618_card__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( distinct @ A @ Xs ) ) ).

% card_distinct
thf(fact_2619_distinct__card,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% distinct_card
thf(fact_2620_bset_I1_J,axiom,
    ! [D2: int,B4: set @ int,P2: int > $o,Q2: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P2 @ X3 )
           => ( P2 @ ( minus_minus @ int @ X3 @ D2 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q2 @ X3 )
             => ( Q2 @ ( minus_minus @ int @ X3 @ D2 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P2 @ X4 )
                & ( Q2 @ X4 ) )
             => ( ( P2 @ ( minus_minus @ int @ X4 @ D2 ) )
                & ( Q2 @ ( minus_minus @ int @ X4 @ D2 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_2621_bset_I2_J,axiom,
    ! [D2: int,B4: set @ int,P2: int > $o,Q2: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P2 @ X3 )
           => ( P2 @ ( minus_minus @ int @ X3 @ D2 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q2 @ X3 )
             => ( Q2 @ ( minus_minus @ int @ X3 @ D2 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P2 @ X4 )
                | ( Q2 @ X4 ) )
             => ( ( P2 @ ( minus_minus @ int @ X4 @ D2 ) )
                | ( Q2 @ ( minus_minus @ int @ X4 @ D2 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_2622_aset_I1_J,axiom,
    ! [D2: int,A5: set @ int,P2: int > $o,Q2: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ A5 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P2 @ X3 )
           => ( P2 @ ( plus_plus @ int @ X3 @ D2 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ A5 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q2 @ X3 )
             => ( Q2 @ ( plus_plus @ int @ X3 @ D2 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ A5 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P2 @ X4 )
                & ( Q2 @ X4 ) )
             => ( ( P2 @ ( plus_plus @ int @ X4 @ D2 ) )
                & ( Q2 @ ( plus_plus @ int @ X4 @ D2 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_2623_aset_I2_J,axiom,
    ! [D2: int,A5: set @ int,P2: int > $o,Q2: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb2: int] :
                  ( ( member2 @ int @ Xb2 @ A5 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P2 @ X3 )
           => ( P2 @ ( plus_plus @ int @ X3 @ D2 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb2: int] :
                    ( ( member2 @ int @ Xb2 @ A5 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q2 @ X3 )
             => ( Q2 @ ( plus_plus @ int @ X3 @ D2 ) ) ) )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ A5 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P2 @ X4 )
                | ( Q2 @ X4 ) )
             => ( ( P2 @ ( plus_plus @ int @ X4 @ D2 ) )
                | ( Q2 @ ( plus_plus @ int @ X4 @ D2 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_2624_listrel1I1,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Xs ) ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel1I1
thf(fact_2625_Cons__listrel1E1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( ! [Y3: A] :
            ( ( Ys
              = ( cons @ A @ Y3 @ Xs ) )
           => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R4 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X @ Zs2 ) )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_2626_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R4 ) )
     => ( ! [X3: A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Ys ) )
           => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y ) @ R4 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y @ Zs2 ) )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_2627_concat__eq__appendD,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss2 )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( Xss2
         != ( nil @ ( list @ A ) ) )
       => ? [Xss1: list @ ( list @ A ),Xs2: list @ A,Xs3: list @ A,Xss22: list @ ( list @ A )] :
            ( ( Xss2
              = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs2 @ Xs3 ) @ Xss22 ) ) )
            & ( Ys
              = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs2 ) )
            & ( Zs
              = ( append @ A @ Xs3 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_2628_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I4: int,J2: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J2 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_2629_hd__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( Xs
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_concat
thf(fact_2630_card__1__singletonI,axiom,
    ! [A: $tType,S: set @ A,X: A] :
      ( ( finite_finite @ A @ S )
     => ( ( ( finite_card @ A @ S )
          = ( one_one @ nat ) )
       => ( ( member2 @ A @ X @ S )
         => ( S
            = ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_1_singletonI
thf(fact_2631_card__Un__Int,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B4 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_2632_card__Diff__subset__Int,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ) ).

% card_Diff_subset_Int
thf(fact_2633_bset_I9_J,axiom,
    ! [D3: int,D2: int,B4: set @ int,T3: int] :
      ( ( dvd_dvd @ int @ D3 @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T3 ) )
           => ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( minus_minus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ) ).

% bset(9)
thf(fact_2634_bset_I10_J,axiom,
    ! [D3: int,D2: int,B4: set @ int,T3: int] :
      ( ( dvd_dvd @ int @ D3 @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T3 ) )
           => ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( minus_minus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ) ).

% bset(10)
thf(fact_2635_aset_I9_J,axiom,
    ! [D3: int,D2: int,A5: set @ int,T3: int] :
      ( ( dvd_dvd @ int @ D3 @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ A5 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T3 ) )
           => ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( plus_plus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ) ).

% aset(9)
thf(fact_2636_aset_I10_J,axiom,
    ! [D3: int,D2: int,A5: set @ int,T3: int] :
      ( ( dvd_dvd @ int @ D3 @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ A5 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ X4 @ T3 ) )
           => ~ ( dvd_dvd @ int @ D3 @ ( plus_plus @ int @ ( plus_plus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ) ).

% aset(10)
thf(fact_2637_atLeastAtMostPlus1__int__conv,axiom,
    ! [M2: int,N: int] :
      ( ( ord_less_eq @ int @ M2 @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M2 @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
        = ( insert3 @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N ) @ ( set_or1337092689740270186AtMost @ int @ M2 @ N ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_2638_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss2 )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Xss2
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss2
           != ( nil @ ( list @ A ) ) )
         => ? [Xss12: list @ ( list @ A ),Xs4: list @ A,Xs6: list @ A,Xss23: list @ ( list @ A )] :
              ( ( Xss2
                = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs4 @ Xs6 ) @ Xss23 ) ) )
              & ( Ys
                = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs4 ) )
              & ( Zs
                = ( append @ A @ Xs6 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_2639_listrel1I,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y @ Vs ) ) )
         => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% listrel1I
thf(fact_2640_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ~ ! [X3: A,Y3: A] :
            ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y3 ) @ R4 )
           => ! [Us3: list @ A,Vs3: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us3 @ ( cons @ A @ X3 @ Vs3 ) ) )
               => ( Ys
                 != ( append @ A @ Us3 @ ( cons @ A @ Y3 @ Vs3 ) ) ) ) ) ) ).

% listrel1E
thf(fact_2641_card__Un__disjoint,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_2642_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ~ ! [L4: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L4 )
               => ( ( ( set2 @ A @ L4 )
                    = A5 )
                 => ( ( size_size @ ( list @ A ) @ L4 )
                   != ( finite_card @ A @ A5 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_2643_card__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A5: set @ A] :
      ( ( ( member2 @ A @ X @ A5 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member2 @ A @ X @ A5 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A5 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_2644_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A5: set @ A] :
      ( ( member2 @ A @ X @ A5 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_2645_periodic__finite__ex,axiom,
    ! [D3: int,P2: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ! [X3: int,K2: int] :
            ( ( P2 @ X3 )
            = ( P2 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D3 ) ) ) )
       => ( ( ? [X5: int] : ( P2 @ X5 ) )
          = ( ? [X2: int] :
                ( ( member2 @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                & ( P2 @ X2 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_2646_aset_I7_J,axiom,
    ! [D2: int,A5: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ A5 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T3 @ X4 )
           => ( ord_less @ int @ T3 @ ( plus_plus @ int @ X4 @ D2 ) ) ) ) ) ).

% aset(7)
thf(fact_2647_aset_I5_J,axiom,
    ! [D2: int,T3: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ T3 @ A5 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ A5 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X4 @ T3 )
             => ( ord_less @ int @ ( plus_plus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ) ).

% aset(5)
thf(fact_2648_aset_I4_J,axiom,
    ! [D2: int,T3: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ T3 @ A5 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ A5 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 != T3 )
             => ( ( plus_plus @ int @ X4 @ D2 )
               != T3 ) ) ) ) ) ).

% aset(4)
thf(fact_2649_aset_I3_J,axiom,
    ! [D2: int,T3: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ ( plus_plus @ int @ T3 @ ( one_one @ int ) ) @ A5 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ A5 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 = T3 )
             => ( ( plus_plus @ int @ X4 @ D2 )
                = T3 ) ) ) ) ) ).

% aset(3)
thf(fact_2650_bset_I7_J,axiom,
    ! [D2: int,T3: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ T3 @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T3 @ X4 )
             => ( ord_less @ int @ T3 @ ( minus_minus @ int @ X4 @ D2 ) ) ) ) ) ) ).

% bset(7)
thf(fact_2651_bset_I5_J,axiom,
    ! [D2: int,B4: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X4 @ T3 )
           => ( ord_less @ int @ ( minus_minus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ).

% bset(5)
thf(fact_2652_bset_I4_J,axiom,
    ! [D2: int,T3: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ T3 @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 != T3 )
             => ( ( minus_minus @ int @ X4 @ D2 )
               != T3 ) ) ) ) ) ).

% bset(4)
thf(fact_2653_bset_I3_J,axiom,
    ! [D2: int,T3: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ ( minus_minus @ int @ T3 @ ( one_one @ int ) ) @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X4 = T3 )
             => ( ( minus_minus @ int @ X4 @ D2 )
                = T3 ) ) ) ) ) ).

% bset(3)
thf(fact_2654_rat__sgn__code,axiom,
    ! [P7: rat] :
      ( ( quotient_of @ ( sgn_sgn @ rat @ P7 ) )
      = ( product_Pair @ int @ int @ ( sgn_sgn @ int @ ( product_fst @ int @ int @ ( quotient_of @ P7 ) ) ) @ ( one_one @ int ) ) ) ).

% rat_sgn_code
thf(fact_2655_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J2: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J2 @ I4 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert3 @ int @ I4 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J2 ) ) ) ) ) ).

% simp_from_to
thf(fact_2656_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R4 ) )
      = ( ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
          & ( X = Y ) )
        | ( ( Xs = Ys )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_2657_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys3: list @ A] :
            ( ( member2 @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
       => ( ! [Ys3: list @ A,Zs2: list @ A] :
              ( ( member2 @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member2 @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys3 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_2658_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert3 @ A @ X @ Y ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_2659_aset_I8_J,axiom,
    ! [D2: int,A5: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ A5 )
                 => ( X4
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T3 @ X4 )
           => ( ord_less_eq @ int @ T3 @ ( plus_plus @ int @ X4 @ D2 ) ) ) ) ) ).

% aset(8)
thf(fact_2660_aset_I6_J,axiom,
    ! [D2: int,T3: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ ( plus_plus @ int @ T3 @ ( one_one @ int ) ) @ A5 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ A5 )
                   => ( X4
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X4 @ T3 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ) ).

% aset(6)
thf(fact_2661_bset_I8_J,axiom,
    ! [D2: int,T3: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ( member2 @ int @ ( minus_minus @ int @ T3 @ ( one_one @ int ) ) @ B4 )
       => ! [X4: int] :
            ( ! [Xa3: int] :
                ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
               => ! [Xb3: int] :
                    ( ( member2 @ int @ Xb3 @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T3 @ X4 )
             => ( ord_less_eq @ int @ T3 @ ( minus_minus @ int @ X4 @ D2 ) ) ) ) ) ) ).

% bset(8)
thf(fact_2662_bset_I6_J,axiom,
    ! [D2: int,B4: set @ int,T3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ! [X4: int] :
          ( ! [Xa3: int] :
              ( ( member2 @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
             => ! [Xb3: int] :
                  ( ( member2 @ int @ Xb3 @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X4 @ T3 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X4 @ D2 ) @ T3 ) ) ) ) ).

% bset(6)
thf(fact_2663_cpmi,axiom,
    ! [D2: int,P2: int > $o,P3: int > $o,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ? [Z6: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ X3 @ Z6 )
           => ( ( P2 @ X3 )
              = ( P3 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member2 @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                 => ! [Xb2: int] :
                      ( ( member2 @ int @ Xb2 @ B4 )
                     => ( X3
                       != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P2 @ X3 )
               => ( P2 @ ( minus_minus @ int @ X3 @ D2 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P3 @ X3 )
                = ( P3 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
           => ( ( ? [X5: int] : ( P2 @ X5 ) )
              = ( ? [X2: int] :
                    ( ( member2 @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                    & ( P3 @ X2 ) )
                | ? [X2: int] :
                    ( ( member2 @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                    & ? [Y2: int] :
                        ( ( member2 @ int @ Y2 @ B4 )
                        & ( P2 @ ( plus_plus @ int @ Y2 @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_2664_quotient__of__int,axiom,
    ! [A3: int] :
      ( ( quotient_of @ ( of_int @ A3 ) )
      = ( product_Pair @ int @ int @ A3 @ ( one_one @ int ) ) ) ).

% quotient_of_int
thf(fact_2665_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% trancl_set_ntrancl
thf(fact_2666_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( ( finite_finite @ B @ A5 )
         => ~ ! [L4: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L4 ) )
               => ( ( ( set2 @ B @ L4 )
                    = A5 )
                 => ( ( size_size @ ( list @ B ) @ L4 )
                   != ( finite_card @ B @ A5 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_2667_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_2668_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_2669_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_2670_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_2671_splice__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( member2 @ ( list @ A ) @ ( splice @ A @ Xs @ Ys ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% splice_in_shuffles
thf(fact_2672_finite__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( finite_finite @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% finite_shuffles
thf(fact_2673_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs4: list @ A,Ys4: list @ A] : ( shuffles @ A @ Ys4 @ Xs4 ) ) ) ).

% shuffles_commutes
thf(fact_2674_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z2: A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member2 @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Z2 @ Ys ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_2675_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z2: A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member2 @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z2 @ Xs ) @ Ys ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_2676_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert3 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_2677_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert3 @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_2678_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( Ys
          = ( nil @ A ) )
       => ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_2679_all__nat__less,axiom,
    ! [N: nat,P2: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
           => ( P2 @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member2 @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P2 @ X2 ) ) ) ) ).

% all_nat_less
thf(fact_2680_ex__nat__less,axiom,
    ! [N: nat,P2: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
            & ( P2 @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member2 @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P2 @ X2 ) ) ) ) ).

% ex_nat_less
thf(fact_2681_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( ( Zs = Xs )
         => ( Ys
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys )
           => ( Xs
             != ( nil @ A ) ) )
         => ( ! [X3: A,Xs3: list @ A] :
                ( ( Xs
                  = ( cons @ A @ X3 @ Xs3 ) )
               => ! [Z4: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z4 @ Zs4 ) )
                   => ( ( X3 = Z4 )
                     => ~ ( member2 @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs3 @ Ys ) ) ) ) )
           => ~ ! [Y3: A,Ys2: list @ A] :
                  ( ( Ys
                    = ( cons @ A @ Y3 @ Ys2 ) )
                 => ! [Z4: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z4 @ Zs4 ) )
                     => ( ( Y3 = Z4 )
                       => ~ ( member2 @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs @ Ys2 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_2682_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_2683_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ) ).

% set_shuffles
thf(fact_2684_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
       => ( distinct @ B @ Xs ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_2685_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N3: nat,M3: nat] : ( set2 @ nat @ ( upt @ N3 @ ( suc @ M3 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_2686_Frct__code__post_I3_J,axiom,
    ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) )
    = ( one_one @ rat ) ) ).

% Frct_code_post(3)
thf(fact_2687_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_2688_finite__trancl__ntranl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R )
     => ( ( transitive_trancl @ A @ R )
        = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ R ) @ ( one_one @ nat ) ) @ R ) ) ) ).

% finite_trancl_ntranl
thf(fact_2689_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( ( finite_finite @ B @ A5 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L ) )
              & ( ( set2 @ B @ L )
                = A5 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A5 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_2690_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert3 @ B @ X @ A5 ) @ S )
       => ( ( finite_finite @ B @ A5 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert3 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_2691_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs ) @ S )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( distinct @ B @ Xs )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( set2 @ B @ Xs ) )
              = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_2692_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( ( finite_finite @ B @ A5 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 )
              = ( nil @ B ) )
            = ( A5
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_2693_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_2694_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_2695_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_2696_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B,B4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( ( ord_less_eq @ ( set @ B ) @ B4 @ S )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ B4 ) )
           => ( ( finite_finite @ B @ A5 )
             => ( ( finite_finite @ B @ B4 )
               => ( A5 = B4 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_2697_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( ( finite_finite @ B @ A5 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) )
            = A5 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_2698_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) )
          = ( finite_card @ B @ A5 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_2699_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_2700_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_2701_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert3 @ B @ X @ A5 ) @ S )
       => ( ( finite_finite @ B @ A5 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert3 @ B @ X @ A5 ) )
            = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert3 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_2702_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert3 @ B @ X @ A5 ) @ S )
       => ( ( finite_finite @ B @ A5 )
         => ( ~ ( member2 @ B @ X @ A5 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert3 @ B @ X @ A5 ) )
              = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_2703_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert3 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_2704_lists__empty,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert3 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% lists_empty
thf(fact_2705_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs @ N3 ) @ ( nth @ B @ Ys @ N3 ) ) @ R4 ) ) ) ) ).

% listrel_iff_nth
thf(fact_2706_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_2707_Cons__in__lists__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,A5: set @ A] :
      ( ( member2 @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( lists @ A @ A5 ) )
      = ( ( member2 @ A @ X @ A5 )
        & ( member2 @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) ) ) ) ).

% Cons_in_lists_iff
thf(fact_2708_in__listsI,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( member2 @ A @ X3 @ A5 ) )
     => ( member2 @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) ) ) ).

% in_listsI
thf(fact_2709_lists__Int__eq,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( lists @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ A5 ) @ ( lists @ A @ B4 ) ) ) ).

% lists_Int_eq
thf(fact_2710_append__in__lists__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,A5: set @ A] :
      ( ( member2 @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( lists @ A @ A5 ) )
      = ( ( member2 @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
        & ( member2 @ ( list @ A ) @ Ys @ ( lists @ A @ A5 ) ) ) ) ).

% append_in_lists_conv
thf(fact_2711_lists__UNIV,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% lists_UNIV
thf(fact_2712_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_2713_listsE,axiom,
    ! [A: $tType,X: A,L: list @ A,A5: set @ A] :
      ( ( member2 @ ( list @ A ) @ ( cons @ A @ X @ L ) @ ( lists @ A @ A5 ) )
     => ~ ( ( member2 @ A @ X @ A5 )
         => ~ ( member2 @ ( list @ A ) @ L @ ( lists @ A @ A5 ) ) ) ) ).

% listsE
thf(fact_2714_lists_OCons,axiom,
    ! [A: $tType,A3: A,A5: set @ A,L: list @ A] :
      ( ( member2 @ A @ A3 @ A5 )
     => ( ( member2 @ ( list @ A ) @ L @ ( lists @ A @ A5 ) )
       => ( member2 @ ( list @ A ) @ ( cons @ A @ A3 @ L ) @ ( lists @ A @ A5 ) ) ) ) ).

% lists.Cons
thf(fact_2715_lists_ONil,axiom,
    ! [A: $tType,A5: set @ A] : ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( lists @ A @ A5 ) ) ).

% lists.Nil
thf(fact_2716_lists__mono,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( lists @ A @ A5 ) @ ( lists @ A @ B4 ) ) ) ).

% lists_mono
thf(fact_2717_in__lists__conv__set,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( member2 @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( member2 @ A @ X2 @ A5 ) ) ) ) ).

% in_lists_conv_set
thf(fact_2718_in__listsD,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( member2 @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
     => ! [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
         => ( member2 @ A @ X4 @ A5 ) ) ) ).

% in_listsD
thf(fact_2719_lists__IntI,axiom,
    ! [A: $tType,L: list @ A,A5: set @ A,B4: set @ A] :
      ( ( member2 @ ( list @ A ) @ L @ ( lists @ A @ A5 ) )
     => ( ( member2 @ ( list @ A ) @ L @ ( lists @ A @ B4 ) )
       => ( member2 @ ( list @ A ) @ L @ ( lists @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ) ).

% lists_IntI
thf(fact_2720_lists_Osimps,axiom,
    ! [A: $tType,A3: list @ A,A5: set @ A] :
      ( ( member2 @ ( list @ A ) @ A3 @ ( lists @ A @ A5 ) )
      = ( ( A3
          = ( nil @ A ) )
        | ? [A4: A,L3: list @ A] :
            ( ( A3
              = ( cons @ A @ A4 @ L3 ) )
            & ( member2 @ A @ A4 @ A5 )
            & ( member2 @ ( list @ A ) @ L3 @ ( lists @ A @ A5 ) ) ) ) ) ).

% lists.simps
thf(fact_2721_lists_Ocases,axiom,
    ! [A: $tType,A3: list @ A,A5: set @ A] :
      ( ( member2 @ ( list @ A ) @ A3 @ ( lists @ A @ A5 ) )
     => ( ( A3
         != ( nil @ A ) )
       => ~ ! [A6: A,L4: list @ A] :
              ( ( A3
                = ( cons @ A @ A6 @ L4 ) )
             => ( ( member2 @ A @ A6 @ A5 )
               => ~ ( member2 @ ( list @ A ) @ L4 @ ( lists @ A @ A5 ) ) ) ) ) ) ).

% lists.cases
thf(fact_2722_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( nil @ B ) ) @ ( listrel @ A @ B @ R4 ) )
     => ( Xs
        = ( nil @ A ) ) ) ).

% listrel_Nil2
thf(fact_2723_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs ) @ ( listrel @ A @ B @ R4 ) )
     => ( Xs
        = ( nil @ B ) ) ) ).

% listrel_Nil1
thf(fact_2724_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R4 ) ) ).

% listrel.Nil
thf(fact_2725_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% listrel_eq_len
thf(fact_2726_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R4 @ S3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( listrel @ A @ B @ R4 ) @ ( listrel @ A @ B @ S3 ) ) ) ).

% listrel_mono
thf(fact_2727_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R4 ) )
     => ~ ! [X3: A,Xs2: list @ A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Xs2 ) )
           => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y ) @ R4 )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ).

% listrel_Cons2
thf(fact_2728_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y: A,Ys: list @ A,Xs: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y @ Ys ) @ Xs ) @ ( listrel @ A @ B @ R4 ) )
     => ~ ! [Y3: B,Ys3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Y3 @ Ys3 ) )
           => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Y3 ) @ R4 )
             => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys @ Ys3 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ).

% listrel_Cons1
thf(fact_2729_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,R4: set @ ( product_prod @ A @ B ),Xs: list @ A,Ys: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ R4 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R4 ) ) ) ) ).

% listrel.Cons
thf(fact_2730_one__rat__def,axiom,
    ( ( one_one @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ) ).

% one_rat_def
thf(fact_2731_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R4 ) )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X3: A,Y3: B,Xs2: list @ A] :
              ( ( A1
                = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Ys3: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y3 @ Ys3 ) )
                 => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ R4 )
                   => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys3 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ) ) ).

% listrel.cases
thf(fact_2732_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R4 ) )
      = ( ( ( A1
            = ( nil @ A ) )
          & ( A22
            = ( nil @ B ) ) )
        | ? [X2: A,Y2: B,Xs4: list @ A,Ys4: list @ B] :
            ( ( A1
              = ( cons @ A @ X2 @ Xs4 ) )
            & ( A22
              = ( cons @ B @ Y2 @ Ys4 ) )
            & ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R4 )
            & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs4 @ Ys4 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ) ).

% listrel.simps
thf(fact_2733_listrel1__subset__listrel,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R7 )
     => ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R7 )
       => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R4 ) @ ( listrel @ A @ A @ R7 ) ) ) ) ).

% listrel1_subset_listrel
thf(fact_2734_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_2735_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y )
               => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y )
               => ( ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_2736_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_2737_sorted__insort__insert__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs ) ) ) ) ) ).

% sorted_insort_insert_key
thf(fact_2738_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J ) @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_2739_inj__on__rev,axiom,
    ! [A: $tType,A5: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A5 ) ).

% inj_on_rev
thf(fact_2740_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) ).

% rev_rev_ident
thf(fact_2741_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) ).

% rev_is_rev_conv
thf(fact_2742_op__conc__empty__img__id,axiom,
    ! [A: $tType,L5: set @ ( list @ A )] :
      ( ( image2 @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ ( nil @ A ) ) @ L5 )
      = L5 ) ).

% op_conc_empty_img_id
thf(fact_2743_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_2744_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_2745_set__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rev
thf(fact_2746_length__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rev
thf(fact_2747_rev__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) ).

% rev_append
thf(fact_2748_length__concat__rev,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) ) ) ).

% length_concat_rev
thf(fact_2749_distinct__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rev
thf(fact_2750_list__ex__rev,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( list_ex @ A @ P2 @ ( rev @ A @ Xs ) )
      = ( list_ex @ A @ P2 @ Xs ) ) ).

% list_ex_rev
thf(fact_2751_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,V2: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F2 @ V2 ) )
      = ( image2 @ A @ B @ F2 @ ( set2 @ A @ V2 ) ) ) ).

% list.set_map
thf(fact_2752_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_map_eq_map
thf(fact_2753_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_2754_singleton__rev__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( cons @ A @ X @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( ( cons @ A @ X @ ( nil @ A ) )
        = Xs ) ) ).

% singleton_rev_conv
thf(fact_2755_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A3: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A3 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_2756_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_2757_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_2758_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_2759_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D3: A,A3: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D3 )
         => ( ( image2 @ A @ A @ ( times_times @ A @ D3 ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D3 @ A3 ) @ ( times_times @ A @ D3 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_2760_lists__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( lists @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
      = ( image2 @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( lists @ B @ A5 ) ) ) ).

% lists_image
thf(fact_2761_inj__on__Cons1,axiom,
    ! [A: $tType,X: A,A5: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ A5 ) ).

% inj_on_Cons1
thf(fact_2762_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( zip @ A @ B @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys ) )
        = ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ).

% zip_rev
thf(fact_2763_rev__swap,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) ).

% rev_swap
thf(fact_2764_insort__insert__key__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( member2 @ A @ ( F2 @ X ) @ ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
         => ( ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs )
            = Xs ) ) ) ).

% insort_insert_key_triv
thf(fact_2765_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_2766_rev__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs ) ) ) ) ).

% rev_concat
thf(fact_2767_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs ) ) ) ).

% rev_map
thf(fact_2768_listrel__refl__on,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ A5 @ R4 )
     => ( refl_on @ ( list @ A ) @ ( lists @ A @ A5 ) @ ( listrel @ A @ A @ R4 ) ) ) ).

% listrel_refl_on
thf(fact_2769_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( inj_on @ B @ A @ F2 @ S ) ) ).

% folding_insort_key.inj_on
thf(fact_2770_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_2771_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: A,A5: set @ A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A3 ) @ A5 ) ) ) ).

% inj_on_mult
thf(fact_2772_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( Xs = Ys ) ) ) ).

% map_injective
thf(fact_2773_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,B4: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image2 @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( image2 @ B @ A @ F2 @ A5 ) @ ( image2 @ B @ A @ F2 @ B4 ) ) ) ).

% image_Int_subset
thf(fact_2774_image__set,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
      = ( set2 @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% image_set
thf(fact_2775_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ) ) ).

% shuffles.simps(3)
thf(fact_2776_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_2777_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_2778_hd__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( rev @ A @ Xs ) )
      = ( last @ A @ Xs ) ) ).

% hd_rev
thf(fact_2779_last__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( last @ A @ ( rev @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% last_rev
thf(fact_2780_distinct__insort__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,X: B] :
          ( ( distinct @ B @ Xs )
         => ( distinct @ B @ ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs ) ) ) ) ).

% distinct_insort_insert
thf(fact_2781_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_2782_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_on_map_eq_map
thf(fact_2783_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
       => ( Xs = Ys ) ) ) ).

% map_inj_on
thf(fact_2784_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( ( distinct @ B @ Xs )
        & ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) ) ) ).

% distinct_map
thf(fact_2785_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj
thf(fact_2786_nths__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N @ Xs ) @ I )
      = ( nths @ A @ Xs @ ( image2 @ nat @ nat @ ( plus_plus @ nat @ N ) @ I ) ) ) ).

% nths_drop
thf(fact_2787_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X3: nat] :
            ( ( member2 @ nat @ X3 @ I )
           => ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I ) ) ) ).

% inj_on_nth
thf(fact_2788_take__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% take_rev
thf(fact_2789_rev__take,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( rev @ A @ ( take @ A @ I2 @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_take
thf(fact_2790_rev__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I2 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_drop
thf(fact_2791_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ) ).

% drop_rev
thf(fact_2792_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert3 @ A @ X @ ( set2 @ A @ Xs ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_2793_rotate__rev,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( rotate @ A @ N @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) @ Xs ) ) ) ).

% rotate_rev
thf(fact_2794_image__Suc__atMost,axiom,
    ! [N: nat] :
      ( ( image2 @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N ) ) ) ).

% image_Suc_atMost
thf(fact_2795_image__Suc__lessThan,axiom,
    ! [N: nat] :
      ( ( image2 @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ).

% image_Suc_lessThan
thf(fact_2796_one__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( one_one @ rat ) ).

% one_rat.transfer
thf(fact_2797_subset__subseqs,axiom,
    ! [A: $tType,X7: set @ A,Xs: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X7 @ ( set2 @ A @ Xs ) )
     => ( member2 @ ( set @ A ) @ X7 @ ( image2 @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ) ).

% subset_subseqs
thf(fact_2798_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_2799_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y ) ) ) ).

% rev_update
thf(fact_2800_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I4 ) ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_2801_shuffles_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( insert3 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             != ( insert3 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ! [Y3: A,Ys3: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ Y3 @ Ys3 ) )
                   => ( Y
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y3 @ Ys3 ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_2802_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J2 )
               => ( ( ord_less @ nat @ J2 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J2 ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_2803_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
      = ( ( inj_on @ A @ B @ F2 @ A5 )
        & ( inj_on @ A @ B @ F2 @ B4 )
        & ( ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) ) @ ( image2 @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B4 @ A5 ) ) )
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% inj_on_Un
thf(fact_2804_image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( image2 @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
        = ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A5 ) @ ( image2 @ A @ B @ F2 @ B4 ) ) ) ) ).

% image_Int
thf(fact_2805_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C5: set @ A,A5: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ C5 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
         => ( ( image2 @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
            = ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A5 ) @ ( image2 @ A @ B @ F2 @ B4 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_2806_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,S3: set @ A,T3: set @ A] :
          ( ( image2 @ A @ A @ ( plus_plus @ A @ A3 ) @ ( inf_inf @ ( set @ A ) @ S3 @ T3 ) )
          = ( inf_inf @ ( set @ A ) @ ( image2 @ A @ A @ ( plus_plus @ A @ A3 ) @ S3 ) @ ( image2 @ A @ A @ ( plus_plus @ A @ A3 ) @ T3 ) ) ) ) ).

% translation_Int
thf(fact_2807_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = Y ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_2808_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_2809_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Xs: list @ B,Ys: list @ B,A3: A] :
      ( ( foldr @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) @ A3 )
      = ( foldr @ B @ A @ F2 @ Xs @ ( foldr @ B @ A @ F2 @ Ys @ A3 ) ) ) ).

% foldr_append
thf(fact_2810_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: A,L: list @ B,K: list @ B,F2: B > A > A,G: B > A > A] :
      ( ( A3 = B2 )
     => ( ( L = K )
       => ( ! [A6: A,X3: B] :
              ( ( member2 @ B @ X3 @ ( set2 @ B @ L ) )
             => ( ( F2 @ X3 @ A6 )
                = ( G @ X3 @ A6 ) ) )
         => ( ( foldr @ B @ A @ F2 @ L @ A3 )
            = ( foldr @ B @ A @ G @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_2811_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_2812_Misc_Ofoldr__Cons,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( foldr @ A @ ( list @ A ) @ ( cons @ A ) @ Xs @ ( nil @ A ) )
      = Xs ) ).

% Misc.foldr_Cons
thf(fact_2813_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
      = ( transpose @ A @ Xss2 ) ) ).

% transpose.simps(2)
thf(fact_2814_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( transpose @ B @ Xs ) ) ) ).

% transpose_map_map
thf(fact_2815_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_2816_transpose__empty,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X2: list @ A] :
            ( ( member2 @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_2817_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_2818_inj__on__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B4: set @ A] :
      ( ( ( inj_on @ A @ B @ F2 @ A5 )
        | ( inj_on @ A @ B @ F2 @ B4 ) )
     => ( inj_on @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ).

% inj_on_Int
thf(fact_2819_length__product__lists,axiom,
    ! [B: $tType,Xss2: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss2 ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss2 ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_2820_map__tailrec__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_tailrec @ A @ B )
      = ( ^ [F3: A > B,As7: list @ A] : ( rev @ B @ ( map_tailrec_rev @ A @ B @ F3 @ As7 @ ( nil @ B ) ) ) ) ) ).

% map_tailrec_def
thf(fact_2821_refl__on__Int,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A ),B4: set @ A,S3: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ A5 @ R4 )
     => ( ( refl_on @ A @ B4 @ S3 )
       => ( refl_on @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S3 ) ) ) ) ).

% refl_on_Int
thf(fact_2822_f__arg__min__list__f,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( F2 @ ( arg_min_list @ A @ B @ F2 @ Xs ) )
            = ( lattic643756798350308766er_Min @ B @ ( image2 @ A @ B @ F2 @ ( set2 @ A @ Xs ) ) ) ) ) ) ).

% f_arg_min_list_f
thf(fact_2823_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( image2 @ nat @ A @ ( nth @ A @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs ) ) ) ) ).

% nth_image
thf(fact_2824_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A5 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ A5 ) ) ).

% inj_on_mapI
thf(fact_2825_sorted__list__of__set__range,axiom,
    ! [M2: nat,N: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) )
      = ( upt @ M2 @ N ) ) ).

% sorted_list_of_set_range
thf(fact_2826_Int__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A3 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D3 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( ord_max @ A @ A3 @ C2 ) @ ( ord_min @ A @ B2 @ D3 ) ) ) ) ).

% Int_atLeastLessThan
thf(fact_2827_ex__nat__less__eq,axiom,
    ! [N: nat,P2: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
            & ( P2 @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member2 @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P2 @ X2 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_2828_all__nat__less__eq,axiom,
    ! [N: nat,P2: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
           => ( P2 @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member2 @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P2 @ X2 ) ) ) ) ).

% all_nat_less_eq
thf(fact_2829_ivl__disj__int__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(3)
thf(fact_2830_insert__partition,axiom,
    ! [A: $tType,X: set @ A,F7: set @ ( set @ A )] :
      ( ~ ( member2 @ ( set @ A ) @ X @ F7 )
     => ( ! [X3: set @ A] :
            ( ( member2 @ ( set @ A ) @ X3 @ ( insert3 @ ( set @ A ) @ X @ F7 ) )
           => ! [Xa3: set @ A] :
                ( ( member2 @ ( set @ A ) @ Xa3 @ ( insert3 @ ( set @ A ) @ X @ F7 ) )
               => ( ( X3 != Xa3 )
                 => ( ( inf_inf @ ( set @ A ) @ X3 @ Xa3 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ X @ ( complete_Sup_Sup @ ( set @ A ) @ F7 ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% insert_partition
thf(fact_2831_Union__disjoint,axiom,
    ! [A: $tType,C5: set @ ( set @ A ),A5: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) @ A5 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: set @ A] :
            ( ( member2 @ ( set @ A ) @ X2 @ C5 )
           => ( ( inf_inf @ ( set @ A ) @ X2 @ A5 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Union_disjoint
thf(fact_2832_map__tailrec__rev_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: A,As2: list @ A,Bs: list @ B] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( cons @ A @ A3 @ As2 ) @ Bs )
      = ( map_tailrec_rev @ A @ B @ F2 @ As2 @ ( cons @ B @ ( F2 @ A3 ) @ Bs ) ) ) ).

% map_tailrec_rev.simps(2)
thf(fact_2833_Union__Int__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B4: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A5 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) ) ) ).

% Union_Int_subset
thf(fact_2834_map__tailrec__rev_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B,Bs: list @ B] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( nil @ A ) @ Bs )
      = Bs ) ).

% map_tailrec_rev.simps(1)
thf(fact_2835_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I4: nat,J2: nat] : ( set2 @ nat @ ( upt @ I4 @ J2 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_2836_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_2837_ivl__disj__int__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(7)
thf(fact_2838_ivl__disj__int__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(2)
thf(fact_2839_ivl__disj__int__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_two(1)
thf(fact_2840_arg__min__list_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( nil @ A ) ) )
          = X ) ) ).

% arg_min_list.simps(1)
thf(fact_2841_map__tailrec__rev_Oelims,axiom,
    ! [A: $tType,B: $tType,X: A > B,Xa: list @ A,Xb: list @ B,Y: list @ B] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Y != Xb ) )
       => ~ ! [A6: A,As: list @ A] :
              ( ( Xa
                = ( cons @ A @ A6 @ As ) )
             => ( Y
               != ( map_tailrec_rev @ A @ B @ X @ As @ ( cons @ B @ ( X @ A6 ) @ Xb ) ) ) ) ) ) ).

% map_tailrec_rev.elims
thf(fact_2842_arg__min__list__in,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( member2 @ A @ ( arg_min_list @ A @ B @ F2 @ Xs ) @ ( set2 @ A @ Xs ) ) ) ) ).

% arg_min_list_in
thf(fact_2843_card__partition,axiom,
    ! [A: $tType,C5: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C5 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) )
       => ( ! [C4: set @ A] :
              ( ( member2 @ ( set @ A ) @ C4 @ C5 )
             => ( ( finite_card @ A @ C4 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member2 @ ( set @ A ) @ C1 @ C5 )
               => ( ( member2 @ ( set @ A ) @ C22 @ C5 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C5 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_2844_dvd__partition,axiom,
    ! [A: $tType,C5: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) )
     => ( ! [X3: set @ A] :
            ( ( member2 @ ( set @ A ) @ X3 @ C5 )
           => ( dvd_dvd @ nat @ K @ ( finite_card @ A @ X3 ) ) )
       => ( ! [X3: set @ A] :
              ( ( member2 @ ( set @ A ) @ X3 @ C5 )
             => ! [Xa3: set @ A] :
                  ( ( member2 @ ( set @ A ) @ Xa3 @ C5 )
                 => ( ( X3 != Xa3 )
                   => ( ( inf_inf @ ( set @ A ) @ X3 @ Xa3 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( dvd_dvd @ nat @ K @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) ) ) ) ) ) ).

% dvd_partition
thf(fact_2845_map__tailrec__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_tailrec_rev @ B @ A )
      = ( ^ [F3: B > A,As7: list @ B] : ( append @ A @ ( rev @ A @ ( map @ B @ A @ F3 @ As7 ) ) ) ) ) ).

% map_tailrec_rev
thf(fact_2846_inf__Sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: A,B4: set @ A] :
          ( ( inf_inf @ A @ A3 @ ( complete_Sup_Sup @ A @ B4 ) )
          = ( complete_Sup_Sup @ A @ ( image2 @ A @ A @ ( inf_inf @ A @ A3 ) @ B4 ) ) ) ) ).

% inf_Sup
thf(fact_2847_Sup__inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B4: set @ A,A3: A] :
          ( ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B4 ) @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ B4 )
               => ( ( inf_inf @ A @ X2 @ A3 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_inf_eq_bot_iff
thf(fact_2848_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A3: A,Xs: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ ( append @ B @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A3 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_2849_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A3: A,X: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ ( cons @ B @ X @ Xs ) )
          = ( plus_plus @ A @ ( F2 @ X ) @ ( times_times @ A @ A3 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_2850_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_2851_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A3: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A3 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_2852_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_2853_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_2854_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M2: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_2855_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M2: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_2856_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,P7: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( ord_less_eq @ nat @ N @ P7 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P7 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ P7 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_2857_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ L @ ( plus_plus @ int @ U @ ( one_one @ int ) ) )
      = ( set_or1337092689740270186AtMost @ int @ L @ U ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
thf(fact_2858_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or5935395276787703475ssThan @ int @ L @ U ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
thf(fact_2859_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_2860_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_2861_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_2862_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_2863_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_2864_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A3 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A3 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_2865_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_2866_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( G @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_2867_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I4: int,J2: int] : ( set2 @ int @ ( upto @ I4 @ ( minus_minus @ int @ J2 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_2868_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M2: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_2869_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A,P7: nat] :
          ( ( ord_less_eq @ nat @ M2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ N @ P7 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P7 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_2870_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ~ ( member2 @ B @ X @ A5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert3 @ B @ X @ A5 ) )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) ) ) ) ) ) ).

% prod.insert
thf(fact_2871_prod__eq__1__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A5 )
          = ( one_one @ nat ) )
        = ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ A5 )
             => ( ( F2 @ X2 )
                = ( one_one @ nat ) ) ) ) ) ) ).

% prod_eq_1_iff
thf(fact_2872_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_2873_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_2874_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A5: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_2875_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A5: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
           != ( one_one @ A ) )
         => ~ ! [A6: B] :
                ( ( member2 @ B @ A6 @ A5 )
               => ( ( G @ A6 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_2876_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G: B > A] :
          ( ! [X3: B] :
              ( ( member2 @ B @ X3 @ A5 )
             => ( ( G @ X3 )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_2877_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member2 @ B @ X3 @ A5 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_ge_1
thf(fact_2878_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member2 @ B @ X3 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) )
                & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_2879_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R: A > A > $o,S: set @ B,H2: B > A,G: B > A] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( ( R @ X1 @ X23 )
                  & ( R @ Y1 @ Y23 ) )
               => ( R @ ( times_times @ A @ X1 @ Y1 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S )
             => ( ! [X3: B] :
                    ( ( member2 @ B @ X3 @ S )
                   => ( R @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S ) ) ) ) ) ) ) ).

% prod.related
thf(fact_2880_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ( member2 @ B @ X @ A5 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert3 @ B @ X @ A5 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) ) )
            & ( ~ ( member2 @ B @ X @ A5 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert3 @ B @ X @ A5 ) )
                = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_2881_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T4: set @ C,S: set @ B,I2: C > B,J: B > C,T: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T4 )
           => ( ! [A6: B] :
                  ( ( member2 @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S @ S2 ) )
                 => ( ( I2 @ ( J @ A6 ) )
                    = A6 ) )
             => ( ! [A6: B] :
                    ( ( member2 @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S @ S2 ) )
                   => ( member2 @ C @ ( J @ A6 ) @ ( minus_minus @ ( set @ C ) @ T @ T4 ) ) )
               => ( ! [B5: C] :
                      ( ( member2 @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T @ T4 ) )
                     => ( ( J @ ( I2 @ B5 ) )
                        = B5 ) )
                 => ( ! [B5: C] :
                        ( ( member2 @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T @ T4 ) )
                       => ( member2 @ B @ ( I2 @ B5 ) @ ( minus_minus @ ( set @ B ) @ S @ S2 ) ) )
                   => ( ! [A6: B] :
                          ( ( member2 @ B @ A6 @ S2 )
                         => ( ( G @ A6 )
                            = ( one_one @ A ) ) )
                     => ( ! [B5: C] :
                            ( ( member2 @ C @ B5 @ T4 )
                           => ( ( H2 @ B5 )
                              = ( one_one @ A ) ) )
                       => ( ! [A6: B] :
                              ( ( member2 @ B @ A6 @ S )
                             => ( ( H2 @ ( J @ A6 ) )
                                = ( G @ A6 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_2882_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I: set @ A,I2: A,F2: A > B] :
          ( ( finite_finite @ A @ I )
         => ( ( member2 @ A @ I2 @ I )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) )
             => ( ! [I3: A] :
                    ( ( member2 @ A @ I3 @ I )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_2883_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I )
         => ( ( I
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I3: A] :
                  ( ( member2 @ A @ I3 @ I )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I ) ) ) ) ) ) ).

% less_1_prod
thf(fact_2884_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ B,A5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A5 )
         => ( ( finite_finite @ B @ A5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_2885_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T: set @ B,S: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member2 @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_2886_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
                 => ( ( H2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member2 @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_2887_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_2888_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_2889_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C5: set @ B,A5: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A6: B] :
                    ( ( member2 @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C5 @ A5 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member2 @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H2 @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C5 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B4 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_2890_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C5: set @ B,A5: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A6: B] :
                    ( ( member2 @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C5 @ A5 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member2 @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H2 @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B4 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C5 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_2891_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_2892_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_2893_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T )
         => ( ( finite_finite @ B @ S )
           => ( ! [I3: B] :
                  ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
                 => ( ( H2 @ I3 )
                    = ( one_one @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S @ T ) )
                   => ( ( G @ I3 )
                      = ( one_one @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member2 @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S @ T ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_2894_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert3 @ B @ X @ A5 ) )
            = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert3 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_2895_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( member2 @ B @ X @ A5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A5 )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert3 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_2896_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_2897_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A5 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_2898_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A5 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_2899_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B4: set @ A,A5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
           => ( ! [B5: A] :
                  ( ( member2 @ A @ B5 @ ( minus_minus @ ( set @ A ) @ B4 @ A5 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B5 ) ) )
             => ( ! [A6: A] :
                    ( ( member2 @ A @ A6 @ A5 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A6 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B4 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_2900_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A,N: A,K: nat] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A5 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_2901_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K4: nat] : ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K4 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_2902_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A5: set @ A,K: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A5 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs4: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs4 )
                    = K )
                  & ( distinct @ A @ Xs4 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_2903_rev__split__conv,axiom,
    ! [A: $tType,L: list @ A] :
      ( ( L
       != ( nil @ A ) )
     => ( ( append @ A @ ( rev @ A @ ( tl @ A @ L ) ) @ ( cons @ A @ ( hd @ A @ L ) @ ( nil @ A ) ) )
        = ( rev @ A @ L ) ) ) ).

% rev_split_conv
thf(fact_2904_shuffles_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( insert3 @ ( list @ A ) @ Xa @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ( ( ( Xa
                = ( nil @ A ) )
             => ( ( Y
                  = ( insert3 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
           => ~ ! [X3: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y3: A,Ys3: list @ A] :
                      ( ( Xa
                        = ( cons @ A @ Y3 @ Ys3 ) )
                     => ( ( Y
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y3 @ Ys3 ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y3 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys3 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_2905_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A5: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A5 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs4: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs4 )
                  = K )
                & ( distinct @ A @ Xs4 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_2906_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2 )
      = ( ^ [Xs4: list @ A] : Xs4 ) ) ).

% map_ident
thf(fact_2907_bool__assn__proper_I4_J,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P2 )
     => ( ( proper @ Q2 )
       => ( proper
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( P2 @ H )
              & ( Q2 @ H ) ) ) ) ) ).

% bool_assn_proper(4)
thf(fact_2908_bool__assn__proper_I3_J,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o,Q2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P2 )
     => ( ( proper @ Q2 )
       => ( proper
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( P2 @ H )
              | ( Q2 @ H ) ) ) ) ) ).

% bool_assn_proper(3)
thf(fact_2909_bool__assn__proper_I2_J,axiom,
    ( proper
    @ ^ [Uu2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : $false ) ).

% bool_assn_proper(2)
thf(fact_2910_tl__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( tl @ nat @ ( upt @ M2 @ N ) )
      = ( upt @ ( suc @ M2 ) @ N ) ) ).

% tl_upt
thf(fact_2911_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu2: B] : ( one_one @ A )
            @ A5 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_2912_bool__assn__proper_I5_J,axiom,
    ! [P2: ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ( proper @ P2 )
     => ( proper
        @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
            ( ( in_range @ H )
            & ~ ( P2 @ H ) ) ) ) ).

% bool_assn_proper(5)
thf(fact_2913_tl__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys ) ) ) ).

% tl_append2
thf(fact_2914_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,A3: B,B2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S )
                = ( B2 @ A3 ) ) )
            & ( ~ ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_2915_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,A3: B,B2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( A3 = K4 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S )
                = ( B2 @ A3 ) ) )
            & ( ~ ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( A3 = K4 ) @ ( B2 @ K4 ) @ ( one_one @ A ) )
                  @ S )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_2916_butlast__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( butlast @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( tl @ A @ Xs ) ) ) ).

% butlast_rev
thf(fact_2917_if__image__distrib,axiom,
    ! [A: $tType,B: $tType,P2: B > $o,F2: B > A,G: B > A,S: set @ B] :
      ( ( image2 @ B @ A
        @ ^ [X2: B] : ( if @ A @ ( P2 @ X2 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ S )
      = ( sup_sup @ ( set @ A ) @ ( image2 @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ S @ ( collect @ B @ P2 ) ) )
        @ ( image2 @ B @ A @ G
          @ ( inf_inf @ ( set @ B ) @ S
            @ ( collect @ B
              @ ^ [X2: B] :
                  ~ ( P2 @ X2 ) ) ) ) ) ) ).

% if_image_distrib
thf(fact_2918_precise__extr__pure_I2_J,axiom,
    ! [B: $tType,A: $tType,R: A > B > assn,P2: $o] :
      ( ( precise @ A @ B
        @ ^ [X2: A,Y2: B] : ( times_times @ assn @ ( R @ X2 @ Y2 ) @ ( pure_assn @ P2 ) ) )
      = ( P2
       => ( precise @ A @ B @ R ) ) ) ).

% precise_extr_pure(2)
thf(fact_2919_precise__extr__pure_I1_J,axiom,
    ! [B: $tType,A: $tType,P2: $o,R: A > B > assn] :
      ( ( precise @ A @ B
        @ ^ [X2: A,Y2: B] : ( times_times @ assn @ ( pure_assn @ P2 ) @ ( R @ X2 @ Y2 ) ) )
      = ( P2
       => ( precise @ A @ B @ R ) ) ) ).

% precise_extr_pure(1)
thf(fact_2920_length__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_2921_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) ).

% hd_Cons_tl
thf(fact_2922_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_2923_in__hd__or__tl__conv,axiom,
    ! [A: $tType,L: list @ A,X: A] :
      ( ( L
       != ( nil @ A ) )
     => ( ( ( X
            = ( hd @ A @ L ) )
          | ( member2 @ A @ X @ ( set2 @ A @ ( tl @ A @ L ) ) ) )
        = ( member2 @ A @ X @ ( set2 @ A @ L ) ) ) ) ).

% in_hd_or_tl_conv
thf(fact_2924_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X2: B] : ( cons @ A @ ( F2 @ X2 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F2 @ Xs ) ) ).

% concat_map_singleton
thf(fact_2925_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_2926_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs4: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs4 )
                = N )
              & ( distinct @ A @ Xs4 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_2927_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A5 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A5 ) ) ) ) ).

% prod.distrib
thf(fact_2928_sngr__prec,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( precise @ A @ ( ref @ A )
        @ ^ [X2: A,P5: ref @ A] : ( sngr_assn @ A @ P5 @ X2 ) ) ) ).

% sngr_prec
thf(fact_2929_snga__prec,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( precise @ ( list @ A ) @ ( array @ A )
        @ ^ [X2: list @ A,P5: array @ A] : ( snga_assn @ A @ P5 @ X2 ) ) ) ).

% snga_prec
thf(fact_2930_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu2: A,Uv: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_2931_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_2932_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X2: A] : X2 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_2933_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R @ ( map @ B @ A @ F2 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X2: B,Y2: B] : ( R @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_2934_list_Omap__ident,axiom,
    ! [A: $tType,T3: list @ A] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2
        @ T3 )
      = T3 ) ).

% list.map_ident
thf(fact_2935_sorted__wrt__rev,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P2 @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X2: A,Y2: A] : ( P2 @ Y2 @ X2 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_2936_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X2: A] : X2
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_2937_insort__insert__triv,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs )
            = Xs ) ) ) ).

% insort_insert_triv
thf(fact_2938_inf__Int__eq,axiom,
    ! [A: $tType,R: set @ A,S: set @ A] :
      ( ( inf_inf @ ( A > $o )
        @ ^ [X2: A] : ( member2 @ A @ X2 @ R )
        @ ^ [X2: A] : ( member2 @ A @ X2 @ S ) )
      = ( ^ [X2: A] : ( member2 @ A @ X2 @ ( inf_inf @ ( set @ A ) @ R @ S ) ) ) ) ).

% inf_Int_eq
thf(fact_2939_Int__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A10: set @ A,B6: set @ A] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member2 @ A @ X2 @ A10 )
                & ( member2 @ A @ X2 @ B6 ) ) ) ) ) ).

% Int_def
thf(fact_2940_Int__Collect,axiom,
    ! [A: $tType,X: A,A5: set @ A,P2: A > $o] :
      ( ( member2 @ A @ X @ ( inf_inf @ ( set @ A ) @ A5 @ ( collect @ A @ P2 ) ) )
      = ( ( member2 @ A @ X @ A5 )
        & ( P2 @ X ) ) ) ).

% Int_Collect
thf(fact_2941_inf__set__def,axiom,
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A10: set @ A,B6: set @ A] :
            ( collect @ A
            @ ( inf_inf @ ( A > $o )
              @ ^ [X2: A] : ( member2 @ A @ X2 @ A10 )
              @ ^ [X2: A] : ( member2 @ A @ X2 @ B6 ) ) ) ) ) ).

% inf_set_def
thf(fact_2942_Collect__conj__eq,axiom,
    ! [A: $tType,P2: A > $o,Q2: A > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( P2 @ X2 )
            & ( Q2 @ X2 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( collect @ A @ P2 ) @ ( collect @ A @ Q2 ) ) ) ).

% Collect_conj_eq
thf(fact_2943_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X2: A,Y2: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
        @ ^ [X2: A,Y2: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S ) )
      = ( ^ [X2: A,Y2: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) ) ) ).

% inf_Int_eq2
thf(fact_2944_Int__Union2,axiom,
    ! [A: $tType,B4: set @ ( set @ A ),A5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) @ A5 )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ ( set @ A ) @ ( set @ A )
          @ ^ [C7: set @ A] : ( inf_inf @ ( set @ A ) @ C7 @ A5 )
          @ B4 ) ) ) ).

% Int_Union2
thf(fact_2945_Int__Union,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 ) @ B4 ) ) ) ).

% Int_Union
thf(fact_2946_bot__assn__def,axiom,
    ( ( bot_bot @ assn )
    = ( abs_assn
      @ ^ [Uu2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] : $false ) ) ).

% bot_assn_def
thf(fact_2947_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X22: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X22 ) )
      = X22 ) ).

% list.sel(3)
thf(fact_2948_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_2949_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_tl
thf(fact_2950_distinct__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( tl @ A @ Xs ) ) ) ).

% distinct_tl
thf(fact_2951_tl__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( drop @ A @ N @ Xs ) )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% tl_drop
thf(fact_2952_butlast__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( butlast @ A @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( butlast @ A @ Xs ) ) ) ).

% butlast_tl
thf(fact_2953_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member2 @ B @ I4 @ I )
                  & ( ( X @ I4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member2 @ B @ I4 @ I )
                    & ( ( Y @ I4 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member2 @ B @ I4 @ I )
                    & ( ( times_times @ A @ ( X @ I4 ) @ ( Y @ I4 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_2954_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,S3: set @ A,T3: set @ A] :
          ( ( image2 @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A3 )
            @ ( inf_inf @ ( set @ A ) @ S3 @ T3 ) )
          = ( inf_inf @ ( set @ A )
            @ ( image2 @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A3 )
              @ S3 )
            @ ( image2 @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A3 )
              @ T3 ) ) ) ) ).

% translation_subtract_Int
thf(fact_2955_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F2: B > A,B4: set @ B,A3: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ B4 ) ) @ A3 )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [B3: B] : ( inf_inf @ A @ ( F2 @ B3 ) @ A3 )
              @ B4 ) ) ) ) ).

% SUP_inf
thf(fact_2956_Sup__inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B4: set @ A,A3: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B4 ) @ A3 )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ A @ A
              @ ^ [B3: A] : ( inf_inf @ A @ B3 @ A3 )
              @ B4 ) ) ) ) ).

% Sup_inf
thf(fact_2957_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: A,F2: B > A,B4: set @ B] :
          ( ( inf_inf @ A @ A3 @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ B4 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [B3: B] : ( inf_inf @ A @ A3 @ ( F2 @ B3 ) )
              @ B4 ) ) ) ) ).

% inf_SUP
thf(fact_2958_SUP__inf__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F2: B > A,A5: set @ B,G: C > A,B4: set @ C] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image2 @ C @ A @ G @ B4 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image2 @ B @ A
              @ ^ [A4: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image2 @ C @ A
                    @ ^ [B3: C] : ( inf_inf @ A @ ( F2 @ A4 ) @ ( G @ B3 ) )
                    @ B4 ) )
              @ A5 ) ) ) ) ).

% SUP_inf_distrib2
thf(fact_2959_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G: B > A,P2: B > $o] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member2 @ B @ X2 @ A5 )
                    & ( P2 @ X2 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P2 @ X2 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A5 ) ) ) ) ).

% prod.inter_filter
thf(fact_2960_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X2: B,Y2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_2961_Int__UN__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType,A5: B > ( set @ A ),I: set @ B,B4: C > ( set @ A ),J4: set @ C] :
      ( ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A5 @ I ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ C @ ( set @ A ) @ B4 @ J4 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I4: B] :
              ( complete_Sup_Sup @ ( set @ A )
              @ ( image2 @ C @ ( set @ A )
                @ ^ [J2: C] : ( inf_inf @ ( set @ A ) @ ( A5 @ I4 ) @ ( B4 @ J2 ) )
                @ J4 ) )
          @ I ) ) ) ).

% Int_UN_distrib2
thf(fact_2962_Int__UN__distrib,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,A5: B > ( set @ A ),I: set @ B] :
      ( ( inf_inf @ ( set @ A ) @ B4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A5 @ I ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I4: B] : ( inf_inf @ ( set @ A ) @ B4 @ ( A5 @ I4 ) )
          @ I ) ) ) ).

% Int_UN_distrib
thf(fact_2963_UN__extend__simps_I4_J,axiom,
    ! [H8: $tType,G4: $tType,A5: G4 > ( set @ H8 ),C5: set @ G4,B4: set @ H8] :
      ( ( inf_inf @ ( set @ H8 ) @ ( complete_Sup_Sup @ ( set @ H8 ) @ ( image2 @ G4 @ ( set @ H8 ) @ A5 @ C5 ) ) @ B4 )
      = ( complete_Sup_Sup @ ( set @ H8 )
        @ ( image2 @ G4 @ ( set @ H8 )
          @ ^ [X2: G4] : ( inf_inf @ ( set @ H8 ) @ ( A5 @ X2 ) @ B4 )
          @ C5 ) ) ) ).

% UN_extend_simps(4)
thf(fact_2964_UN__extend__simps_I5_J,axiom,
    ! [I6: $tType,J5: $tType,A5: set @ I6,B4: J5 > ( set @ I6 ),C5: set @ J5] :
      ( ( inf_inf @ ( set @ I6 ) @ A5 @ ( complete_Sup_Sup @ ( set @ I6 ) @ ( image2 @ J5 @ ( set @ I6 ) @ B4 @ C5 ) ) )
      = ( complete_Sup_Sup @ ( set @ I6 )
        @ ( image2 @ J5 @ ( set @ I6 )
          @ ^ [X2: J5] : ( inf_inf @ ( set @ I6 ) @ A5 @ ( B4 @ X2 ) )
          @ C5 ) ) ) ).

% UN_extend_simps(5)
thf(fact_2965_lists__eq__set,axiom,
    ! [A: $tType] :
      ( ( lists @ A )
      = ( ^ [A10: set @ A] :
            ( collect @ ( list @ A )
            @ ^ [Xs4: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A10 ) ) ) ) ).

% lists_eq_set
thf(fact_2966_length__nths,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs @ I ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( member2 @ nat @ I4 @ I ) ) ) ) ) ).

% length_nths
thf(fact_2967_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( zip @ A @ A @ Xs @ Xs )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
        @ Xs ) ) ).

% zip_same_conv_map
thf(fact_2968_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N3: nat,Xs4: list @ A] : ( nths @ A @ Xs4 @ ( collect @ nat @ ( ord_less_eq @ nat @ N3 ) ) ) ) ) ).

% drop_eq_nths
thf(fact_2969_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A,Y: A,Zs: list @ A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( if @ A @ ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) @ X @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% arg_min_list.simps(2)
thf(fact_2970_set__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( set2 @ A
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) )
          = ( insert3 @ A @ X @ ( set2 @ A @ Xs ) ) ) ) ).

% set_insort_insert
thf(fact_2971_sorted__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,X: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) ) ) ) ).

% sorted_insort_insert
thf(fact_2972_sup__assn__def,axiom,
    ( ( sup_sup @ assn )
    = ( ^ [P: assn,Q: assn] :
          ( abs_assn
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( rep_assn @ P @ H )
              | ( rep_assn @ Q @ H ) ) ) ) ) ).

% sup_assn_def
thf(fact_2973_inf__assn__def,axiom,
    ( ( inf_inf @ assn )
    = ( ^ [P: assn,Q: assn] :
          ( abs_assn
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( rep_assn @ P @ H )
              & ( rep_assn @ Q @ H ) ) ) ) ) ).

% inf_assn_def
thf(fact_2974_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs4: list @ A,Ys4: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys4 )
              @ Xs4 ) ) ) ) ).

% product_concat_map
thf(fact_2975_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_2976_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_2977_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z2 @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_2978_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( member2 @ B @ X2 @ B4 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A5 ) ) ) ) ).

% prod.inter_restrict
thf(fact_2979_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A5
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( G @ X2 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A5 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_2980_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X2: A] : X2 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_2981_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P2: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys3: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys3 ) )
           => ( P2 @ ( nil @ A ) @ Ys3 ) )
       => ( ! [Xs2: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
             => ( P2 @ Xs2 @ ( nil @ A ) ) )
         => ( ! [X3: A,Xs2: list @ A,Y3: A,Ys3: list @ A] :
                ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys3 ) ) )
               => ( ( P2 @ Xs2 @ ( cons @ A @ Y3 @ Ys3 ) )
                 => ( ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 )
                   => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys3 ) ) ) ) )
           => ( P2 @ A0 @ A1 ) ) ) ) ) ).

% shuffles.pinduct
thf(fact_2982_nths__append,axiom,
    ! [A: $tType,L: list @ A,L6: list @ A,A5: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L @ L6 ) @ A5 )
      = ( append @ A @ ( nths @ A @ L @ A5 )
        @ ( nths @ A @ L6
          @ ( collect @ nat
            @ ^ [J2: nat] : ( member2 @ nat @ ( plus_plus @ nat @ J2 @ ( size_size @ ( list @ A ) @ L ) ) @ A5 ) ) ) ) ) ).

% nths_append
thf(fact_2983_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs4: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_2984_Succ__def,axiom,
    ! [A: $tType] :
      ( ( bNF_Greatest_Succ @ A )
      = ( ^ [Kl3: set @ ( list @ A ),Kl4: list @ A] :
            ( collect @ A
            @ ^ [K4: A] : ( member2 @ ( list @ A ) @ ( append @ A @ Kl4 @ ( cons @ A @ K4 @ ( nil @ A ) ) ) @ Kl3 ) ) ) ) ).

% Succ_def
thf(fact_2985_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F2 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( set2 @ A @ ( F2 @ X2 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_2986_tl__obtain__elem,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( ( tl @ A @ Xs )
          = ( nil @ A ) )
       => ~ ! [E: A] :
              ( Xs
             != ( cons @ A @ E @ ( nil @ A ) ) ) ) ) ).

% tl_obtain_elem
thf(fact_2987_tl__Nil,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X2: A] :
            ( Xs
            = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_2988_Nil__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X2: A] :
            ( Xs
            = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_2989_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys4: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y2: A] : ( cons @ A @ Y2 @ Ys4 )
              @ Xs )
          @ ( n_lists @ A @ N @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_2990_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A3: list @ A,X: A] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( member2 @ A @ X @ ( set2 @ A @ ( tl @ A @ A3 ) ) )
       => ( member2 @ A @ X @ ( set2 @ A @ A3 ) ) ) ) ).

% list.set_sel(2)
thf(fact_2991_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A3: list @ A,F2: A > B] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A3 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A3 ) ) ) ) ).

% list.map_sel(2)
thf(fact_2992_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F2: nat > A,M2: nat] :
      ( ( enumerate @ A @ N @ ( map @ nat @ A @ F2 @ ( upt @ N @ M2 ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K4: nat] : ( product_Pair @ nat @ A @ K4 @ ( F2 @ K4 ) )
        @ ( upt @ N @ M2 ) ) ) ).

% enumerate_map_upt
thf(fact_2993_map__add__upt,axiom,
    ! [N: nat,M2: nat] :
      ( ( map @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ I4 @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M2 ) )
      = ( upt @ N @ ( plus_plus @ nat @ M2 @ N ) ) ) ).

% map_add_upt
thf(fact_2994_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_2995_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss2: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss2 ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X2: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( product_lists @ A @ Xss2 ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_2996_take__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( take @ A @ N @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_tl
thf(fact_2997_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ Xs )
      = ( drop @ A @ N @ ( tl @ A @ Xs ) ) ) ).

% drop_Suc
thf(fact_2998_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List2: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) ).

% list.expand
thf(fact_2999_tl__last,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
       != ( nil @ A ) )
     => ( ( last @ A @ Xs )
        = ( last @ A @ ( tl @ A @ Xs ) ) ) ) ).

% tl_last
thf(fact_3000_last__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( ( tl @ A @ Xs )
         != ( nil @ A ) ) )
     => ( ( last @ A @ ( tl @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_tl
thf(fact_3001_inj__on__disjoint__Un,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,G: A > B,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( inj_on @ A @ B @ G @ B4 )
       => ( ( ( inf_inf @ ( set @ B ) @ ( image2 @ A @ B @ F2 @ A5 ) @ ( image2 @ A @ B @ G @ B4 ) )
            = ( bot_bot @ ( set @ B ) ) )
         => ( inj_on @ A @ B
            @ ^ [X2: A] : ( if @ B @ ( member2 @ A @ X2 @ A5 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) ) ) ) ) ).

% inj_on_disjoint_Un
thf(fact_3002_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M2 )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_3003_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,P2: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P2 @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A5 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P2 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P2 ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_3004_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_3005_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_3006_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_3007_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_3008_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I4: nat] : ( F2 @ ( suc @ I4 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_3009_finite__lists__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs4: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 )
              & ( ( size_size @ ( list @ A ) @ Xs4 )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_3010_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_3011_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A4: A,Xs4: list @ B] :
              ( foldr @ B @ A
              @ ^ [X2: B,B3: A] : ( plus_plus @ A @ ( F3 @ X2 ) @ ( times_times @ A @ A4 @ B3 ) )
              @ Xs4
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_3012_uminus__assn__def,axiom,
    ( ( uminus_uminus @ assn )
    = ( ^ [P: assn] :
          ( abs_assn
          @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ( ( in_range @ H )
              & ~ ( rep_assn @ P @ H ) ) ) ) ) ).

% uminus_assn_def
thf(fact_3013_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A3: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A3 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( times_times @ A @ ( F2 @ A4 ) )
            @ A3
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_3014_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X2: nat] : X2
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod
thf(fact_3015_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys4: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys4 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_3016_map__decr__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M2 ) @ ( suc @ N ) ) )
      = ( upt @ M2 @ N ) ) ).

% map_decr_upt
thf(fact_3017_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,A3: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                  @ S )
                = ( times_times @ A @ ( B2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S @ ( insert3 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ ( C2 @ K4 ) )
                  @ S )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S @ ( insert3 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_3018_prod_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,A5: B > ( set @ C ),G: C > A] :
          ( ( finite_finite @ B @ I )
         => ( ! [X3: B] :
                ( ( member2 @ B @ X3 @ I )
               => ( finite_finite @ C @ ( A5 @ X3 ) ) )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ I )
                 => ! [Xa3: B] :
                      ( ( member2 @ B @ Xa3 @ I )
                     => ( ( X3 != Xa3 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A5 @ X3 ) @ ( A5 @ Xa3 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A5 @ I ) ) )
                = ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [X2: B] : ( groups7121269368397514597t_prod @ C @ A @ G @ ( A5 @ X2 ) )
                  @ I ) ) ) ) ) ) ).

% prod.UNION_disjoint
thf(fact_3019_nths__Cons,axiom,
    ! [A: $tType,X: A,L: list @ A,A5: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L ) @ A5 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member2 @ nat @ ( zero_zero @ nat ) @ A5 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J2: nat] : ( member2 @ nat @ ( suc @ J2 ) @ A5 ) ) ) ) ) ).

% nths_Cons
thf(fact_3020_UN__le__eq__Un0,axiom,
    ! [A: $tType,M: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ M @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ nat @ ( set @ A ) @ M @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_3021_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_3022_finite__lists__length__le,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs4: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_3023_lists__of__len__fin2,axiom,
    ! [A: $tType,P2: set @ A,N: nat] :
      ( ( finite_finite @ A @ P2 )
     => ( finite_finite @ ( list @ A )
        @ ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ P2 )
          @ ( collect @ ( list @ A )
            @ ^ [L3: list @ A] :
                ( N
                = ( size_size @ ( list @ A ) @ L3 ) ) ) ) ) ) ).

% lists_of_len_fin2
thf(fact_3024_lists__of__len__fin1,axiom,
    ! [A: $tType,P2: set @ A,N: nat] :
      ( ( finite_finite @ A @ P2 )
     => ( finite_finite @ ( list @ A )
        @ ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ P2 )
          @ ( collect @ ( list @ A )
            @ ^ [L3: list @ A] :
                ( ( size_size @ ( list @ A ) @ L3 )
                = N ) ) ) ) ) ).

% lists_of_len_fin1
thf(fact_3025_tl__subset,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( tl @ A @ Xs ) ) @ A5 ) ) ) ).

% tl_subset
thf(fact_3026_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_3027_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M2 @ A3 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M2 @ A3 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_3028_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image2 @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A3 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M2 @ A3 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image2 @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M2 @ A3 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_3029_Misc_Onth__tl,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( suc @ N ) ) ) ) ).

% Misc.nth_tl
thf(fact_3030_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_3031_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,A3: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ C2 )
                  @ S )
                = ( times_times @ A @ ( B2 @ A3 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member2 @ B @ A3 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K4: B] : ( if @ A @ ( K4 = A3 ) @ ( B2 @ K4 ) @ C2 )
                  @ S )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_3032_tl__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( tl @ A @ ( take @ A @ N @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( tl @ A @ Xs ) ) ) ).

% tl_take
thf(fact_3033_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N3 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_3034_butlast__rev__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( butlast @ A @ ( rev @ A @ Xs ) )
        = ( rev @ A @ ( tl @ A @ Xs ) ) ) ) ).

% butlast_rev_tl
thf(fact_3035_remove1__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( remove1 @ A @ ( hd @ A @ Xs ) @ Xs )
        = ( tl @ A @ Xs ) ) ) ).

% remove1_tl
thf(fact_3036_card__lists__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs4: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 )
                & ( ( size_size @ ( list @ A ) @ Xs4 )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A5 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_3037_fact__div__fact,axiom,
    ! [N: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N @ M2 )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M2 ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M2 ) ) ) ) ).

% fact_div_fact
thf(fact_3038_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs @ ( nil @ A ) )
        = ( insert3 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_3039_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys )
        = ( insert3 @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_3040_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M2: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_3041_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_3042_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A4 ) @ N3 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A4 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N3 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A4 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_3043_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A3: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A3 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_3044_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A3 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_3045_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) )
     => ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
        = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) @ ( image2 @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ) ) ) ).

% shuffles.psimps(3)
thf(fact_3046_List_Onth__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( suc @ N ) ) ) ) ).

% List.nth_tl
thf(fact_3047_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P7: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P7 )
         => ( ( ord_less_eq @ nat @ K @ P7 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( if @ A @ ( J2 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P7 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( H2 @ J2 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P7 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_3048_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N3: nat] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_3049_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z2: A,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( ( Xs
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs )
            = Z2 )
          & ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs ) @ Ys ) ) )
        | ( ( Ys
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys )
            = Z2 )
          & ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ ( tl @ A @ Ys ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_3050_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I3 ) )
              = N ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I4: nat] :
                ( map @ nat @ A
                @ ^ [J2: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J2 ) @ I4 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_3051_take__Suc,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N ) @ Xs )
        = ( cons @ A @ ( hd @ A @ Xs ) @ ( take @ A @ N @ ( tl @ A @ Xs ) ) ) ) ) ).

% take_Suc
thf(fact_3052_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K4: nat] :
              ( if @ A
              @ ( K4
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L3: nat] : ( times_times @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ L3 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K4 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K4 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_3053_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_3054_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( set_Cons @ A @ A5 @ ( insert3 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image2 @ A @ ( list @ A )
        @ ^ [X2: A] : ( cons @ A @ X2 @ ( nil @ A ) )
        @ A5 ) ) ).

% set_Cons_sing_Nil
thf(fact_3055_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs4: list @ A] :
            ( if @ nat
            @ ( Xs4
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs4 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_3056_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_3057_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter @ ( list @ A )
                @ ^ [Ys4: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys4 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I2 ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J ) @ I2 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_3058_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_3059_inf1I,axiom,
    ! [A: $tType,A5: A > $o,X: A,B4: A > $o] :
      ( ( A5 @ X )
     => ( ( B4 @ X )
       => ( inf_inf @ ( A > $o ) @ A5 @ B4 @ X ) ) ) ).

% inf1I
thf(fact_3060_inf2I,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o,X: A,Y: B,B4: A > B > $o] :
      ( ( A5 @ X @ Y )
     => ( ( B4 @ X @ Y )
       => ( inf_inf @ ( A > B > $o ) @ A5 @ B4 @ X @ Y ) ) ) ).

% inf2I
thf(fact_3061_filter__filter,axiom,
    ! [A: $tType,P2: A > $o,Q2: A > $o,Xs: list @ A] :
      ( ( filter @ A @ P2 @ ( filter @ A @ Q2 @ Xs ) )
      = ( filter @ A
        @ ^ [X2: A] :
            ( ( Q2 @ X2 )
            & ( P2 @ X2 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_3062_filter__True,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P2 @ X3 ) )
     => ( ( filter @ A @ P2 @ Xs )
        = Xs ) ) ).

% filter_True
thf(fact_3063_filter__append,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( filter @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( filter @ A @ P2 @ Xs ) @ ( filter @ A @ P2 @ Ys ) ) ) ).

% filter_append
thf(fact_3064_remove1__filter__not,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P2 @ X )
     => ( ( remove1 @ A @ X @ ( filter @ A @ P2 @ Xs ) )
        = ( filter @ A @ P2 @ Xs ) ) ) ).

% remove1_filter_not
thf(fact_3065_removeAll__filter__not,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P2 @ X )
     => ( ( removeAll @ A @ X @ ( filter @ A @ P2 @ Xs ) )
        = ( filter @ A @ P2 @ Xs ) ) ) ).

% removeAll_filter_not
thf(fact_3066_set__filter,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter @ A @ P2 @ Xs ) )
      = ( collect @ A
        @ ^ [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P2 @ X2 ) ) ) ) ).

% set_filter
thf(fact_3067_filter__False,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ~ ( P2 @ X3 ) )
     => ( ( filter @ A @ P2 @ Xs )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_3068_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A5: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : Y
            @ A5 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_3069_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A5: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A5 )
              & ( member2 @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A5 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A5 )
                & ( member2 @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_3070_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A5: set @ B,F2: B > A,P2: B > $o] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( zero_neq_one_of_bool @ A @ ( P2 @ X2 ) ) )
              @ A5 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P2 ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_3071_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A5: set @ B,P2: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P2 @ X2 ) ) @ ( F2 @ X2 ) )
              @ A5 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P2 ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_3072_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A5: set @ nat,C2: nat > A,D3: nat > A] :
          ( ( ( ( finite_finite @ nat @ A5 )
              & ( member2 @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D3 @ I4 ) )
                @ A5 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D3 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A5 )
                & ( member2 @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D3 @ I4 ) )
                @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_3073_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A5: set @ B,P2: B > $o] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X2: B] : ( zero_neq_one_of_bool @ A @ ( P2 @ X2 ) )
                @ A5 )
              = ( semiring_1_of_nat @ A @ ( finite_card @ B @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P2 ) ) ) ) ) ) ) ) ).

% sum_of_bool_eq
thf(fact_3074_inf1E,axiom,
    ! [A: $tType,A5: A > $o,B4: A > $o,X: A] :
      ( ( inf_inf @ ( A > $o ) @ A5 @ B4 @ X )
     => ~ ( ( A5 @ X )
         => ~ ( B4 @ X ) ) ) ).

% inf1E
thf(fact_3075_inf2E,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o,B4: A > B > $o,X: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A5 @ B4 @ X @ Y )
     => ~ ( ( A5 @ X @ Y )
         => ~ ( B4 @ X @ Y ) ) ) ).

% inf2E
thf(fact_3076_inf1D1,axiom,
    ! [A: $tType,A5: A > $o,B4: A > $o,X: A] :
      ( ( inf_inf @ ( A > $o ) @ A5 @ B4 @ X )
     => ( A5 @ X ) ) ).

% inf1D1
thf(fact_3077_inf1D2,axiom,
    ! [A: $tType,A5: A > $o,B4: A > $o,X: A] :
      ( ( inf_inf @ ( A > $o ) @ A5 @ B4 @ X )
     => ( B4 @ X ) ) ).

% inf1D2
thf(fact_3078_inf2D1,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o,B4: A > B > $o,X: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A5 @ B4 @ X @ Y )
     => ( A5 @ X @ Y ) ) ).

% inf2D1
thf(fact_3079_inf2D2,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o,B4: A > B > $o,X: A,Y: B] :
      ( ( inf_inf @ ( A > B > $o ) @ A5 @ B4 @ X @ Y )
     => ( B4 @ X @ Y ) ) ).

% inf2D2
thf(fact_3080_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P2: A > $o] :
      ( ( filter @ A @ P2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_3081_filter__id__conv,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( filter @ A @ P2 @ Xs )
        = Xs )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X2 ) ) ) ) ).

% filter_id_conv
thf(fact_3082_filter__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P2: A > $o,Q2: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( P2 @ X3 )
              = ( Q2 @ X3 ) ) )
       => ( ( filter @ A @ P2 @ Xs )
          = ( filter @ A @ Q2 @ Ys ) ) ) ) ).

% filter_cong
thf(fact_3083_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( ( P2 @ X )
       => ( ( filter @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( filter @ A @ P2 @ Xs ) ) ) )
      & ( ~ ( P2 @ X )
       => ( ( filter @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( filter @ A @ P2 @ Xs ) ) ) ) ).

% filter.simps(2)
thf(fact_3084_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,P2: A > $o] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( filter @ A @ P2 @ Xs ) ) ) ).

% sorted_wrt_filter
thf(fact_3085_distinct__filter,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( filter @ A @ P2 @ Xs ) ) ) ).

% distinct_filter
thf(fact_3086_rev__filter,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( rev @ A @ ( filter @ A @ P2 @ Xs ) )
      = ( filter @ A @ P2 @ ( rev @ A @ Xs ) ) ) ).

% rev_filter
thf(fact_3087_filter__remove1,axiom,
    ! [A: $tType,Q2: A > $o,X: A,Xs: list @ A] :
      ( ( filter @ A @ Q2 @ ( remove1 @ A @ X @ Xs ) )
      = ( remove1 @ A @ X @ ( filter @ A @ Q2 @ Xs ) ) ) ).

% filter_remove1
thf(fact_3088_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A5: set @ A,G: C > B,B4: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B4 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J2: C] : ( times_times @ B @ ( F2 @ I4 ) @ ( G @ J2 ) )
                @ B4 )
            @ A5 ) ) ) ).

% sum_product
thf(fact_3089_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A5: set @ B,R4: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ R4 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N3: B] : ( times_times @ A @ ( F2 @ N3 ) @ R4 )
            @ A5 ) ) ) ).

% sum_distrib_right
thf(fact_3090_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R4: A,F2: B > A,A5: set @ B] :
          ( ( times_times @ A @ R4 @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N3: B] : ( times_times @ A @ R4 @ ( F2 @ N3 ) )
            @ A5 ) ) ) ).

% sum_distrib_left
thf(fact_3091_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( member2 @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter @ A @ P2 @ Xs )
        @ ( filter @ A
          @ ^ [X2: A] :
              ~ ( P2 @ X2 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_3092_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X2: A] :
            ( filter @ A
            @ ^ [Y2: A] : ( X2 != Y2 ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_3093_empty__filter__conv,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( filter @ A @ P2 @ Xs ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ~ ( P2 @ X2 ) ) ) ) ).

% empty_filter_conv
thf(fact_3094_filter__empty__conv,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( filter @ A @ P2 @ Xs )
        = ( nil @ A ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ~ ( P2 @ X2 ) ) ) ) ).

% filter_empty_conv
thf(fact_3095_filter__is__subset,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter @ A @ P2 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% filter_is_subset
thf(fact_3096_length__filter__le,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter @ A @ P2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_3097_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,P2: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct @ A @ ( map @ B @ A @ F2 @ ( filter @ B @ P2 @ Xs ) ) ) ) ).

% distinct_map_filter
thf(fact_3098_last__filter,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( P2 @ ( last @ A @ Xs ) )
       => ( ( last @ A @ ( filter @ A @ P2 @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) ).

% last_filter
thf(fact_3099_sum__length__filter__compl,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter @ A @ P2 @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter @ A
            @ ^ [X2: A] :
                ~ ( P2 @ X2 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_3100_filter__concat,axiom,
    ! [A: $tType,P7: A > $o,Xs: list @ ( list @ A )] :
      ( ( filter @ A @ P7 @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter @ A @ P7 ) @ Xs ) ) ) ).

% filter_concat
thf(fact_3101_inter__set__filter,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter @ A
          @ ^ [X2: A] : ( member2 @ A @ X2 @ A5 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_3102_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter @ A
            @ ^ [X2: A] :
                ( X2
                = ( G @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_3103_filter__shuffles,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( image2 @ ( list @ A ) @ ( list @ A ) @ ( filter @ A @ P2 ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( shuffles @ A @ ( filter @ A @ P2 @ Xs ) @ ( filter @ A @ P2 @ Ys ) ) ) ).

% filter_shuffles
thf(fact_3104_concat__filter__neq__Nil,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( filter @ ( list @ A )
          @ ^ [Ys4: list @ A] :
              ( Ys4
             != ( nil @ A ) )
          @ Xs ) )
      = ( concat @ A @ Xs ) ) ).

% concat_filter_neq_Nil
thf(fact_3105_union__coset__filter,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( coset @ A @ Xs ) @ A5 )
      = ( coset @ A
        @ ( filter @ A
          @ ^ [X2: A] :
              ~ ( member2 @ A @ X2 @ A5 )
          @ Xs ) ) ) ).

% union_coset_filter
thf(fact_3106_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P2: A > $o] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P2 @ X )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter @ A @ P2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_3107_Cons__eq__filterD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter @ A @ P2 @ Ys ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs3 ) ) )
          & ! [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Us3 ) )
             => ~ ( P2 @ X4 ) )
          & ( P2 @ X )
          & ( Xs
            = ( filter @ A @ P2 @ Vs3 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_3108_filter__eq__ConsD,axiom,
    ! [A: $tType,P2: A > $o,Ys: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter @ A @ P2 @ Ys )
        = ( cons @ A @ X @ Xs ) )
     => ? [Us3: list @ A,Vs3: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs3 ) ) )
          & ! [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Us3 ) )
             => ~ ( P2 @ X4 ) )
          & ( P2 @ X )
          & ( Xs
            = ( filter @ A @ P2 @ Vs3 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_3109_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter @ A @ P2 @ Ys ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs2 ) ) )
            & ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set2 @ A @ Us2 ) )
               => ~ ( P2 @ X2 ) )
            & ( P2 @ X )
            & ( Xs
              = ( filter @ A @ P2 @ Vs2 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_3110_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P2: A > $o,Ys: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter @ A @ P2 @ Ys )
        = ( cons @ A @ X @ Xs ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs2 ) ) )
            & ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set2 @ A @ Us2 ) )
               => ~ ( P2 @ X2 ) )
            & ( P2 @ X )
            & ( Xs
              = ( filter @ A @ P2 @ Vs2 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_3111_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P2: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter @ B @ P2 @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_3112_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert3 @ A @ Y @ ( set2 @ A @ Xs ) ) )
     => ( ( filter @ A
          @ ^ [X2: A] :
              ( ( F2 @ Y )
              = ( F2 @ X2 ) )
          @ Xs )
        = ( filter @ A
          @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
            @ Y )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_3113_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter @ B
              @ ^ [X2: B] :
                  ( ( F2 @ X2 )
                  = ( G @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_3114_length__filter__conv__card,axiom,
    ! [A: $tType,P7: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter @ A @ P7 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P7 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_3115_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( member2 @ B @ X2 @ B4 ) @ ( G @ X2 ) @ ( zero_zero @ A ) )
              @ A5 ) ) ) ) ).

% sum.inter_restrict
thf(fact_3116_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M2: nat,I: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M2 @ I4 ) )
            @ I )
          = ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I ) ) ) ) ).

% sum_power_add
thf(fact_3117_filter__in__nths,axiom,
    ! [A: $tType,Xs: list @ A,S3: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ( filter @ A
          @ ^ [X2: A] : ( member2 @ A @ X2 @ ( set2 @ A @ ( nths @ A @ Xs @ S3 ) ) )
          @ Xs )
        = ( nths @ A @ Xs @ S3 ) ) ) ).

% filter_in_nths
thf(fact_3118_minus__coset__filter,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( coset @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter @ A
          @ ^ [X2: A] : ( member2 @ A @ X2 @ A5 )
          @ Xs ) ) ) ).

% minus_coset_filter
thf(fact_3119_filter__eq__snocD,axiom,
    ! [A: $tType,P2: A > $o,L: list @ A,L6: list @ A,X: A] :
      ( ( ( filter @ A @ P2 @ L )
        = ( append @ A @ L6 @ ( cons @ A @ X @ ( nil @ A ) ) ) )
     => ( ( member2 @ A @ X @ ( set2 @ A @ L ) )
        & ( P2 @ X ) ) ) ).

% filter_eq_snocD
thf(fact_3120_filter__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( filter @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] :
            ( foldr @ A @ ( list @ A )
            @ ^ [X2: A,Xt: list @ A] : ( if @ ( list @ A ) @ ( P @ X2 ) @ ( cons @ A @ X2 @ Xt ) @ Xt )
            @ Xs4
            @ ( nil @ A ) ) ) ) ).

% filter_conv_foldr
thf(fact_3121_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_3122_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,K5: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) ) ) ) ).

% sum_bounded_below
thf(fact_3123_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T )
         => ( ( finite_finite @ B @ S )
           => ( ! [I3: B] :
                  ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
                 => ( ( H2 @ I3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S @ T ) )
                   => ( ( G @ I3 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member2 @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S @ T ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_3124_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_3125_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A5 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_3126_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert3 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter @ A
          @ ^ [X2: A] : ( X2 != Y )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_3127_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A5: set @ A,As8: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A5 @ As8 ) )
      = ( set_Cons @ A @ A5 @ ( listset @ A @ As8 ) ) ) ).

% listset.simps(2)
thf(fact_3128_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter @ A
            @ ^ [X2: A] :
                ~ ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_3129_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter @ A
            @ ^ [X2: A] : ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_3130_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter @ A
            @ ^ [X2: A] :
                ~ ( member2 @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_3131_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member2 @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter @ A
            @ ^ [X2: A] : ( member2 @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_3132_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,P2: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P2 @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A5 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P2 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P2 ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_3133_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] :
            ( nths @ A @ Xs4
            @ ( collect @ nat
              @ ^ [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs4 ) )
                  & ( P @ ( nth @ A @ Xs4 @ I4 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_3134_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( F2 @ ( suc @ K4 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_3135_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J2: nat] : ( binomial @ ( plus_plus @ nat @ N @ J2 ) @ N )
        @ ( set_ord_atMost @ nat @ M2 ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M2 ) @ ( one_one @ nat ) ) @ M2 ) ) ).

% choose_rising_sum(2)
thf(fact_3136_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J2: nat] : ( binomial @ ( plus_plus @ nat @ N @ J2 ) @ N )
        @ ( set_ord_atMost @ nat @ M2 ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M2 ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_3137_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_3138_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_3139_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A5 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_3140_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A5 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_3141_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A5: set @ A,B4: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A5 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B4 @ A5 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_3142_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N: nat,G: nat > A,P7: nat] :
          ( ( ord_less_eq @ nat @ M2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ N @ P7 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P7 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_3143_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss2: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs4: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs4 ) )
          @ Xss2
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X2: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter @ ( list @ B )
              @ ^ [Ys4: list @ B] :
                  ( Ys4
                 != ( nil @ B ) )
              @ Xss2 )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_3144_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A5: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A4: B] : ( divide_divide @ A @ ( F2 @ A4 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A5
                  @ ( collect @ B
                    @ ^ [A4: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A5
                    @ ( collect @ B
                      @ ^ [A4: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_3145_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter @ A @ P2 @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P2 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_3146_sum_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I: set @ B,A5: B > ( set @ C ),G: C > A] :
          ( ( finite_finite @ B @ I )
         => ( ! [X3: B] :
                ( ( member2 @ B @ X3 @ I )
               => ( finite_finite @ C @ ( A5 @ X3 ) ) )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ I )
                 => ! [Xa3: B] :
                      ( ( member2 @ B @ Xa3 @ I )
                     => ( ( X3 != Xa3 )
                       => ( ( inf_inf @ ( set @ C ) @ ( A5 @ X3 ) @ ( A5 @ Xa3 ) )
                          = ( bot_bot @ ( set @ C ) ) ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A5 @ I ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [X2: B] : ( groups7311177749621191930dd_sum @ C @ A @ G @ ( A5 @ X2 ) )
                  @ I ) ) ) ) ) ) ).

% sum.UNION_disjoint
thf(fact_3147_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_3148_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_3149_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_3150_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs4: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_3151_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ K4 ) ) @ K4 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_3152_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member2 @ B @ I3 @ A5 )
             => ( ord_less @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A5 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_3153_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I: set @ A,X: A > B,A3: A > B,B2: B,Delta: B] :
          ( ! [I3: A] :
              ( ( member2 @ A @ I3 @ I )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I3 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I )
              = ( one_one @ B ) )
           => ( ! [I3: A] :
                  ( ( member2 @ A @ I3 @ I )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A3 @ I3 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I4: A] : ( times_times @ B @ ( A3 @ I4 ) @ ( X @ I4 ) )
                      @ I )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_3154_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S: set @ A,R: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S )
         => ( ( finite_finite @ B @ R )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image2 @ A @ B @ G @ S ) @ R )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
                  @ S )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y2: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X2: A] :
                                ( ( member2 @ A @ X2 @ S )
                                & ( ( G @ X2 )
                                  = Y2 ) ) ) ) )
                      @ ( F2 @ Y2 ) )
                  @ R ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_3155_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_3156_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M2 @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K4: nat] : ( minus_minus @ A @ ( F2 @ K4 ) @ ( F2 @ ( plus_plus @ nat @ K4 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( minus_minus @ A @ ( F2 @ M2 ) @ ( F2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M2 @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K4: nat] : ( minus_minus @ A @ ( F2 @ K4 ) @ ( F2 @ ( plus_plus @ nat @ K4 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_3157_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N ) ) @ ( power_power @ A @ Y @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P5: nat] : ( times_times @ A @ ( power_power @ A @ X @ P5 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ P5 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_3158_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) ) @ ( power_power @ A @ X @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_3159_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_3160_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K4: nat] : ( minus_minus @ A @ ( F2 @ K4 ) @ ( F2 @ ( minus_minus @ nat @ K4 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M2 ) ) ) ) ) ).

% sum_telescope''
thf(fact_3161_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M2: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_3162_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q6: nat] : ( ord_less @ nat @ Q6 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_3163_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M2: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M2 @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_3164_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_3165_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ A3 @ K4 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K4 ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ M2 ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_3166_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A3 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K4 ) ) @ ( power_power @ A @ A3 @ K4 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_3167_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A3: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A3 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K4 ) ) @ ( comm_s3205402744901411588hammer @ A @ A3 @ K4 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_3168_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A4: A,Xs4: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F3 @ ( nth @ B @ Xs4 @ N3 ) ) @ ( power_power @ A @ A4 @ N3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs4 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_3169_nth__transpose,axiom,
    ! [A: $tType,I2: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I2 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs4: list @ A] : ( nth @ A @ Xs4 @ I2 )
          @ ( filter @ ( list @ A )
            @ ^ [Ys4: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys4 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_3170_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P7: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P7 )
         => ( ( ord_less_eq @ nat @ K @ P7 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( if @ A @ ( J2 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P7 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( H2 @ J2 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P7 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_3171_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J2: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J2 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_3172_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat,A3: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ A3 ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M2 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A3 ) @ K4 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K4 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M2 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_3173_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_3174_Sum__Ico__nat,axiom,
    ! [M2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M2 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_3175_distinct__concat_H,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A )
        @ ( filter @ ( list @ A )
          @ ^ [Ys4: list @ A] :
              ( Ys4
             != ( nil @ A ) )
          @ Xs ) )
     => ( ! [Ys3: list @ A] :
            ( ( member2 @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
       => ( ! [Ys3: list @ A,Zs2: list @ A] :
              ( ( member2 @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member2 @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys3 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat'
thf(fact_3176_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: A,D3: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D3 ) ) ) ) ) ).

% double_arith_series
thf(fact_3177_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_3178_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_3179_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat,A3: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ A3 ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M2 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K4 ) @ A3 ) @ ( one_one @ A ) ) @ K4 ) @ ( power_power @ A @ X @ K4 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M2 @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_3180_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_3181_Sum__Icc__nat,axiom,
    ! [M2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M2 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_3182_binomial__r__part__sum,axiom,
    ! [M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ).

% binomial_r_part_sum
thf(fact_3183_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( times_times @ nat @ I4 @ ( binomial @ N @ I4 ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_3184_card__lists__length__le,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs4: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A5 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_3185_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_3186_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A,D3: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D3 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_3187_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_3188_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M2: nat,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ M2 @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ M2 @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_3189_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_3190_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter @ ( list @ A )
              @ ^ [Ys4: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys4 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I2 ) ) ) ) ) ).

% transpose_column_length
thf(fact_3191_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_3192_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R4: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ R4 @ K4 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R4 @ ( suc @ M2 ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_3193_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M2: nat,X: A] :
          ( ( ( ord_less @ nat @ N @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M2 )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M2 ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_3194_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M2 ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_3195_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys4: list @ A] : ( nth @ A @ Ys4 @ I2 )
            @ ( filter @ ( list @ A )
              @ ^ [Ys4: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys4 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I2 ) ) ) ) ).

% transpose_column
thf(fact_3196_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K4: nat] : ( times_times @ A @ ( gbinomial @ A @ A3 @ K4 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K4 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A3 @ ( plus_plus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_3197_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_3198_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
          @ Xss2 ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter @ ( list @ A )
          @ ^ [Ys4: list @ A] :
              ( Ys4
             != ( nil @ A ) )
          @ Xss2 ) ) ) ).

% transpose_aux_filter_tail
thf(fact_3199_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I4: A] : ( plus_plus @ A @ I4 @ ( one_one @ A ) )
              @ N3
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_3200_splice_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ( ( Y
                    = ( cons @ A @ X3 @ ( splice @ A @ Xa @ Xs2 ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xa ) ) ) ) ) ) ) ).

% splice.pelims
thf(fact_3201_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H: A,T2: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
          @ Xss2 ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter @ ( list @ A )
          @ ^ [Ys4: list @ A] :
              ( Ys4
             != ( nil @ A ) )
          @ Xss2 ) ) ) ).

% transpose_aux_filter_head
thf(fact_3202_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M2 ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q6: A,R3: A] : ( product_Pair @ A @ A @ Q6 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R3 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M2 @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_3203_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M2 ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q6: A,R3: A] : ( product_Pair @ A @ A @ Q6 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R3 ) )
            @ ( unique8689654367752047608divmod @ A @ M2 @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_3204_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: B > C,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( H2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( case_list @ C @ A @ ( H2 @ F1 )
        @ ^ [X12: A,X24: list @ A] : ( H2 @ ( F22 @ X12 @ X24 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_3205_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y2: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X2: A,Z3: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y2 @ Z3 ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys @ ( zip @ A @ C @ Xs @ Zs ) ) ) ) ).

% zip_left_commute
thf(fact_3206_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > ( list @ A ) > B,X21: A,X22: list @ A] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( cons @ A @ X21 @ X22 ) )
      = ( F22 @ X21 @ X22 ) ) ).

% list.simps(5)
thf(fact_3207_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(4)
thf(fact_3208_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_3209_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs4: list @ A,Ys4: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X2: B,Y2: A] : ( product_Pair @ A @ B @ Y2 @ X2 ) )
            @ ( zip @ B @ A @ Ys4 @ Xs4 ) ) ) ) ).

% zip_commute
thf(fact_3210_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P2: nat > $o,Xs: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( P2 @ ( suc @ ( product_snd @ A @ nat @ P5 ) ) )
          @ ( zip @ A @ nat @ Xs @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( P2 @ ( product_snd @ A @ nat @ P5 ) )
          @ ( zip @ A @ nat @ Xs @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_3211_sum__eq__1__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 )
          = ( one_one @ nat ) )
        = ( ? [X2: A] :
              ( ( member2 @ A @ X2 @ A5 )
              & ( ( F2 @ X2 )
                = ( one_one @ nat ) )
              & ! [Y2: A] :
                  ( ( member2 @ A @ Y2 @ A5 )
                 => ( ( X2 != Y2 )
                   => ( ( F2 @ Y2 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_3212_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X223: list @ A] : X223 ) ) ).

% tl_def
thf(fact_3213_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys )
        @ ^ [Z3: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys )
        @ Xs ) ) ).

% tl_append
thf(fact_3214_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,Xs: list @ C,Ys: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ Ys )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) ) )
        @ ( zip @ C @ B @ Xs @ Ys ) ) ) ).

% zip_map1
thf(fact_3215_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,F2: C > B,Ys: list @ C] :
      ( ( zip @ A @ B @ Xs @ ( map @ C @ B @ F2 @ Ys ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X2: A,Y2: C] : ( product_Pair @ A @ B @ X2 @ ( F2 @ Y2 ) ) )
        @ ( zip @ A @ C @ Xs @ Ys ) ) ) ).

% zip_map2
thf(fact_3216_map__prod__fun__zip,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: C > A,G: D > B,Xs: list @ C,Ys: list @ D] :
      ( ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X2: C,Y2: D] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ Y2 ) ) )
        @ ( zip @ C @ D @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ ( map @ D @ B @ G @ Ys ) ) ) ).

% map_prod_fun_zip
thf(fact_3217_map2__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,H2: B > C > A,F2: D > B,Xs: list @ D,G: D > C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ H2 ) @ ( zip @ B @ C @ ( map @ D @ B @ F2 @ Xs ) @ ( map @ D @ C @ G @ Xs ) ) )
      = ( map @ D @ A
        @ ^ [X2: D] : ( H2 @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ Xs ) ) ).

% map2_map_map
thf(fact_3218_semilattice__map2,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ( semilattice @ A @ F2 )
     => ( semilattice @ ( list @ A )
        @ ^ [Xs4: list @ A,Ys4: list @ A] : ( map @ ( product_prod @ A @ A ) @ A @ ( product_case_prod @ A @ A @ A @ F2 ) @ ( zip @ A @ A @ Xs4 @ Ys4 ) ) ) ) ).

% semilattice_map2
thf(fact_3219_nths__shift__lemma,axiom,
    ! [A: $tType,A5: set @ nat,Xs: list @ A,I2: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member2 @ nat @ ( product_snd @ A @ nat @ P5 ) @ A5 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ I2 @ ( plus_plus @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member2 @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P5 ) @ I2 ) @ A5 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_3220_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs4: list @ A,A10: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter @ ( product_prod @ A @ nat )
              @ ^ [P5: product_prod @ A @ nat] : ( member2 @ nat @ ( product_snd @ A @ nat @ P5 ) @ A10 )
              @ ( zip @ A @ nat @ Xs4 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs4 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_3221_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( product_prod @ B @ C ) > A,G: D > B,Xs: list @ D,Ys: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ ( map @ D @ B @ G @ Xs ) @ Ys ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X2: D,Y2: C] : ( F2 @ ( product_Pair @ B @ C @ ( G @ X2 ) @ Y2 ) ) )
        @ ( zip @ D @ C @ Xs @ Ys ) ) ) ).

% map_zip_map
thf(fact_3222_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( product_prod @ B @ C ) > A,Xs: list @ B,G: D > C,Ys: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ Xs @ ( map @ D @ C @ G @ Ys ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X2: B,Y2: D] : ( F2 @ ( product_Pair @ B @ C @ X2 @ ( G @ Y2 ) ) ) )
        @ ( zip @ B @ D @ Xs @ Ys ) ) ) ).

% map_zip_map2
thf(fact_3223_sum__Un__nat,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_3224_sum__count__set,axiom,
    ! [A: $tType,Xs: list @ A,X7: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X7 )
     => ( ( finite_finite @ A @ X7 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs ) @ X7 )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% sum_count_set
thf(fact_3225_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F12: B,F23: A > ( list @ A ) > B,List3: list @ A] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F12
            @ ( F23 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_3226_card__UN__disjoint,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A5: A > ( set @ B )] :
      ( ( finite_finite @ A @ I )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ I )
           => ( finite_finite @ B @ ( A5 @ X3 ) ) )
       => ( ! [X3: A] :
              ( ( member2 @ A @ X3 @ I )
             => ! [Xa3: A] :
                  ( ( member2 @ A @ Xa3 @ I )
                 => ( ( X3 != Xa3 )
                   => ( ( inf_inf @ ( set @ B ) @ ( A5 @ X3 ) @ ( A5 @ Xa3 ) )
                      = ( bot_bot @ ( set @ B ) ) ) ) ) )
         => ( ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A5 @ I ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I4: A] : ( finite_card @ B @ ( A5 @ I4 ) )
              @ I ) ) ) ) ) ).

% card_UN_disjoint
thf(fact_3227_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( min_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( case_list @ A @ A @ X
            @ ^ [A4: A,List3: list @ A] : ( ord_min @ A @ X @ ( min_list @ A @ Xs ) )
            @ Xs ) ) ) ).

% min_list.simps
thf(fact_3228_transpose_Oelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ ( list @ A ) ) )
         => ( Y
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss: list @ ( list @ A )] :
              ( ( X
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
             => ( Y
               != ( transpose @ A @ Xss ) ) )
         => ~ ! [X3: A,Xs2: list @ A,Xss: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) )
               => ( Y
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X3
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H: A,T2: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                          @ Xss ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs2
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_3229_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss2: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss2 ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H: A,T2: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
              @ Xss2 ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                @ Xss2 ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_3230_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P2: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P2 @ F1 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P2 @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_3231_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P2: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P2 @ F1 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P2 @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_3232_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y2: B,Ys4: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( zip @ A @ B @ Xs @ Ys4 ) )
        @ Ys ) ) ).

% zip_Cons1
thf(fact_3233_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( cons @ B @ Y @ Ys ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z3: A,Zs3: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z3 @ Y ) @ ( zip @ A @ B @ Zs3 @ Ys ) )
        @ Xs ) ) ).

% zip_Cons
thf(fact_3234_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L3: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q6: nat,R3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L3 ) @ R3 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R3 @ ( numeral_numeral @ nat @ L3 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q6 ) @ R3 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_3235_splice_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P2: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys3: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys3 ) )
           => ( P2 @ ( nil @ A ) @ Ys3 ) )
       => ( ! [X3: A,Xs2: list @ A,Ys3: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 ) )
             => ( ( P2 @ Ys3 @ Xs2 )
               => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 ) ) )
         => ( P2 @ A0 @ A1 ) ) ) ) ).

% splice.pinduct
thf(fact_3236_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L3: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q6: int,R3: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L3 ) @ R3 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R3 @ ( numeral_numeral @ int @ L3 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q6 ) @ R3 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_3237_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) )
     => ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ Ys )
        = ( cons @ A @ X @ ( splice @ A @ Ys @ Xs ) ) ) ) ).

% splice.psimps(2)
thf(fact_3238_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( splice @ A @ ( nil @ A ) @ Ys )
        = Ys ) ) ).

% splice.psimps(1)
thf(fact_3239_Sum__Icc__int,axiom,
    ! [M2: int,N: int] :
      ( ( ord_less_eq @ int @ M2 @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X2: int] : X2
          @ ( set_or1337092689740270186AtMost @ int @ M2 @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M2 @ ( minus_minus @ int @ M2 @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_3240_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L3: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q6: A,R3: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L3 ) @ R3 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R3 @ ( numeral_numeral @ A @ L3 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q6 ) @ R3 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_3241_card__UNION,axiom,
    ! [A: $tType,A5: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A5 )
     => ( ! [X3: set @ A] :
            ( ( member2 @ ( set @ A ) @ X3 @ A5 )
           => ( finite_finite @ A @ X3 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A5 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_3242_normalize__def,axiom,
    ( normalize
    = ( ^ [P5: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P5 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P5 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_3243_length__remdups__concat,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss2 ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss2 ) ) ) ) ) ).

% length_remdups_concat
thf(fact_3244_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_3245_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F3: A > nat,Xs4: list @ A] :
            ( if @ nat
            @ ( Xs4
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F3 @ ( hd @ A @ Xs4 ) ) @ ( size_list @ A @ F3 @ ( tl @ A @ Xs4 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_3246_remdups__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( remdups @ nat @ ( upt @ M2 @ N ) )
      = ( upt @ M2 @ N ) ) ).

% remdups_upt
thf(fact_3247_takeWhile__idem,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( takeWhile @ A @ P2 @ ( takeWhile @ A @ P2 @ Xs ) )
      = ( takeWhile @ A @ P2 @ Xs ) ) ).

% takeWhile_idem
thf(fact_3248_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_gcd @ A @ A3 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_3249_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A3 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_3250_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P2 @ Xs )
        = Xs )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X2 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_3251_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_3252_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( remdups @ A @ X )
        = ( nil @ A ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_3253_set__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_remdups
thf(fact_3254_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% length_remdups_eq
thf(fact_3255_gcd__1__int,axiom,
    ! [M2: int] :
      ( ( gcd_gcd @ int @ M2 @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% gcd_1_int
thf(fact_3256_distinct__remdups,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs ) ) ).

% distinct_remdups
thf(fact_3257_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups @ A @ Xs )
        = Xs )
      = ( distinct @ A @ Xs ) ) ).

% remdups_id_iff_distinct
thf(fact_3258_Inf__insert,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: A,A5: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( insert3 @ A @ A3 @ A5 ) )
          = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ A5 ) ) ) ) ).

% Inf_insert
thf(fact_3259_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A3 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_3260_takeWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P2 @ X )
       => ( ( takeWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P2 @ Xs ) ) ) ) ).

% takeWhile_append1
thf(fact_3261_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P2 @ X3 ) )
     => ( ( takeWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ Xs @ ( takeWhile @ A @ P2 @ Ys ) ) ) ) ).

% takeWhile_append2
thf(fact_3262_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_remdups_leq
thf(fact_3263_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ F2 @ Ys ) ) ) ).

% size_list_append
thf(fact_3264_INT__insert,axiom,
    ! [A: $tType,B: $tType,B4: B > ( set @ A ),A3: B,A5: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B4 @ ( insert3 @ B @ A3 @ A5 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( B4 @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B4 @ A5 ) ) ) ) ).

% INT_insert
thf(fact_3265_INT__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,C5: set @ A,A5: A > ( set @ B ),B4: set @ B] :
      ( ( ( C5
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X2: A] : ( inf_inf @ ( set @ B ) @ ( A5 @ X2 ) @ B4 )
              @ C5 ) )
          = ( top_top @ ( set @ B ) ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X2: A] : ( inf_inf @ ( set @ B ) @ ( A5 @ X2 ) @ B4 )
              @ C5 ) )
          = ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A5 @ C5 ) ) @ B4 ) ) ) ) ).

% INT_simps(1)
thf(fact_3266_INT__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C5: set @ D,A5: set @ C,B4: D > ( set @ C )] :
      ( ( ( C5
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X2: D] : ( inf_inf @ ( set @ C ) @ A5 @ ( B4 @ X2 ) )
              @ C5 ) )
          = ( top_top @ ( set @ C ) ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X2: D] : ( inf_inf @ ( set @ C ) @ A5 @ ( B4 @ X2 ) )
              @ C5 ) )
          = ( inf_inf @ ( set @ C ) @ A5 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B4 @ C5 ) ) ) ) ) ) ).

% INT_simps(2)
thf(fact_3267_mergesort__by__rel__simps_I3_J,axiom,
    ! [A: $tType,R: A > A > $o,X13: A,X25: A,Xs: list @ A] :
      ( ( mergesort_by_rel @ A @ R @ ( cons @ A @ X13 @ ( cons @ A @ X25 @ Xs ) ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
        @ ^ [Xs13: list @ A,Xs24: list @ A] : ( merges9089515139780605204_merge @ A @ R @ ( mergesort_by_rel @ A @ R @ Xs13 ) @ ( mergesort_by_rel @ A @ R @ Xs24 ) )
        @ ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X13 @ ( nil @ A ) ) @ ( cons @ A @ X25 @ ( nil @ A ) ) ) @ Xs ) ) ) ).

% mergesort_by_rel_simps(3)
thf(fact_3268_Inter__Un__distrib,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B4: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B4 ) ) ) ).

% Inter_Un_distrib
thf(fact_3269_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P2: A > $o] :
      ( ( takeWhile @ A @ P2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_3270_takeWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P2: A > $o,Q2: A > $o] :
      ( ( L = K )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ L ) )
           => ( ( P2 @ X3 )
              = ( Q2 @ X3 ) ) )
       => ( ( takeWhile @ A @ P2 @ L )
          = ( takeWhile @ A @ Q2 @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_3271_set__takeWhileD,axiom,
    ! [A: $tType,X: A,P2: A > $o,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( takeWhile @ A @ P2 @ Xs ) ) )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
        & ( P2 @ X ) ) ) ).

% set_takeWhileD
thf(fact_3272_remdups__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ Xs ) ) ).

% remdups_remdups
thf(fact_3273_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( takeWhile @ A @ P2 @ Xs ) ) ) ).

% distinct_takeWhile
thf(fact_3274_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_3275_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F2 @ ( remdups @ B @ Xs ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% remdups_map_remdups
thf(fact_3276_remdups__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs @ ( remdups @ A @ Ys ) ) )
      = ( remdups @ A @ ( append @ A @ Xs @ Ys ) ) ) ).

% remdups_append2
thf(fact_3277_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% distinct_remdups_id
thf(fact_3278_remdups__filter,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( remdups @ A @ ( filter @ A @ P2 @ Xs ) )
      = ( filter @ A @ P2 @ ( remdups @ A @ Xs ) ) ) ).

% remdups_filter
thf(fact_3279_INF__UNIV__bool__expand,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: $o > A] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ $o @ A @ A5 @ ( top_top @ ( set @ $o ) ) ) )
          = ( inf_inf @ A @ ( A5 @ $true ) @ ( A5 @ $false ) ) ) ) ).

% INF_UNIV_bool_expand
thf(fact_3280_inj__split__Cons,axiom,
    ! [A: $tType,X7: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs4: list @ A,N3: A] : ( cons @ A @ N3 @ Xs4 ) )
      @ X7 ) ).

% inj_split_Cons
thf(fact_3281_INT__bool__eq,axiom,
    ! [A: $tType,A5: $o > ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ $o @ ( set @ A ) @ A5 @ ( top_top @ ( set @ $o ) ) ) )
      = ( inf_inf @ ( set @ A ) @ ( A5 @ $true ) @ ( A5 @ $false ) ) ) ).

% INT_bool_eq
thf(fact_3282_insert__remdups,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( insert @ A @ X @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ ( insert @ A @ X @ Xs ) ) ) ).

% insert_remdups
thf(fact_3283_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M2: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M2 @ ( plus_plus @ A @ ( times_times @ A @ K @ M2 ) @ N ) )
          = ( gcd_gcd @ A @ M2 @ N ) ) ) ).

% gcd_add_mult
thf(fact_3284_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_3285_Inf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
          = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ).

% Inf_union_distrib
thf(fact_3286_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( ( P2 @ X )
       => ( ( takeWhile @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( takeWhile @ A @ P2 @ Xs ) ) ) )
      & ( ~ ( P2 @ X )
       => ( ( takeWhile @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_3287_takeWhile__tail,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A,L: list @ A] :
      ( ~ ( P2 @ X )
     => ( ( takeWhile @ A @ P2 @ ( append @ A @ Xs @ ( cons @ A @ X @ L ) ) )
        = ( takeWhile @ A @ P2 @ Xs ) ) ) ).

% takeWhile_tail
thf(fact_3288_length__takeWhile__le,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_3289_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P2: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P2 @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_3290_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu2: A,Uv: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_3291_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu2: A,Uv: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_3292_takeWhile__eq__take,axiom,
    ! [A: $tType] :
      ( ( takeWhile @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] : ( take @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs4 ) ) @ Xs4 ) ) ) ).

% takeWhile_eq_take
thf(fact_3293_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P2 @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P2 @ ( hd @ A @ Xs ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_3294_INF__absorb,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [K: B,I: set @ B,A5: B > A] :
          ( ( member2 @ B @ K @ I )
         => ( ( inf_inf @ A @ ( A5 @ K ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ A5 @ I ) ) )
            = ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ A5 @ I ) ) ) ) ) ).

% INF_absorb
thf(fact_3295_INF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A5: set @ B,G: B > A] :
          ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ A5 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image2 @ B @ A
              @ ^ [A4: B] : ( inf_inf @ A @ ( F2 @ A4 ) @ ( G @ A4 ) )
              @ A5 ) ) ) ) ).

% INF_inf_distrib
thf(fact_3296_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( remdups @ A @ Xs ) ) )
      & ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( remdups @ A @ Xs ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_3297_Inter__insert,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ ( set @ A )] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( insert3 @ ( set @ A ) @ A3 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( complete_Inf_Inf @ ( set @ A ) @ B4 ) ) ) ).

% Inter_insert
thf(fact_3298_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_remdups
thf(fact_3299_INT__absorb,axiom,
    ! [B: $tType,A: $tType,K: A,I: set @ A,A5: A > ( set @ B )] :
      ( ( member2 @ A @ K @ I )
     => ( ( inf_inf @ ( set @ B ) @ ( A5 @ K ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A5 @ I ) ) )
        = ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A5 @ I ) ) ) ) ).

% INT_absorb
thf(fact_3300_INT__Int__distrib,axiom,
    ! [A: $tType,B: $tType,A5: B > ( set @ A ),B4: B > ( set @ A ),I: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [I4: B] : ( inf_inf @ ( set @ A ) @ ( A5 @ I4 ) @ ( B4 @ I4 ) )
          @ I ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A5 @ I ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B4 @ I ) ) ) ) ).

% INT_Int_distrib
thf(fact_3301_Int__Inter__image,axiom,
    ! [A: $tType,B: $tType,A5: B > ( set @ A ),B4: B > ( set @ A ),C5: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A )
        @ ( image2 @ B @ ( set @ A )
          @ ^ [X2: B] : ( inf_inf @ ( set @ A ) @ ( A5 @ X2 ) @ ( B4 @ X2 ) )
          @ C5 ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ A5 @ C5 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B4 @ C5 ) ) ) ) ).

% Int_Inter_image
thf(fact_3302_Int__Inter__eq_I1_J,axiom,
    ! [A: $tType,B10: set @ ( set @ A ),A5: set @ A] :
      ( ( ( B10
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A5 @ ( complete_Inf_Inf @ ( set @ A ) @ B10 ) )
          = A5 ) )
      & ( ( B10
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ A5 @ ( complete_Inf_Inf @ ( set @ A ) @ B10 ) )
          = ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ ( set @ A ) @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 ) @ B10 ) ) ) ) ) ).

% Int_Inter_eq(1)
thf(fact_3303_Int__Inter__eq_I2_J,axiom,
    ! [A: $tType,B10: set @ ( set @ A ),A5: set @ A] :
      ( ( ( B10
          = ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B10 ) @ A5 )
          = A5 ) )
      & ( ( B10
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ B10 ) @ A5 )
          = ( complete_Inf_Inf @ ( set @ A )
            @ ( image2 @ ( set @ A ) @ ( set @ A )
              @ ^ [B6: set @ A] : ( inf_inf @ ( set @ A ) @ B6 @ A5 )
              @ B10 ) ) ) ) ) ).

% Int_Inter_eq(2)
thf(fact_3304_remove1__remdups,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ ( remdups @ A @ Xs ) )
        = ( remdups @ A @ ( remove1 @ A @ X @ Xs ) ) ) ) ).

% remove1_remdups
thf(fact_3305_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_3306_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_3307_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A3 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_3308_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_3309_finite__Inf__in,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y3: A] :
                  ( ( member2 @ A @ X3 @ A5 )
                 => ( ( member2 @ A @ Y3 @ A5 )
                   => ( member2 @ A @ ( inf_inf @ A @ X3 @ Y3 ) @ A5 ) ) )
             => ( member2 @ A @ ( complete_Inf_Inf @ A @ A5 ) @ A5 ) ) ) ) ) ).

% finite_Inf_in
thf(fact_3310_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_3311_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_3312_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_3313_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less_eq @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_3314_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ G @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_3315_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P2: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P2 @ Xs ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% takeWhile_nth
thf(fact_3316_nth__length__takeWhile,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P2 @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_3317_INF__inf__const2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,F2: B > A,X: A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I4: B] : ( inf_inf @ A @ ( F2 @ I4 ) @ X )
                @ I ) )
            = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ I ) ) @ X ) ) ) ) ).

% INF_inf_const2
thf(fact_3318_INF__inf__const1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: set @ B,X: A,F2: B > A] :
          ( ( I
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image2 @ B @ A
                @ ^ [I4: B] : ( inf_inf @ A @ X @ ( F2 @ I4 ) )
                @ I ) )
            = ( inf_inf @ A @ X @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ I ) ) ) ) ) ) ).

% INF_inf_const1
thf(fact_3319_INF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: B,A5: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( insert3 @ B @ A3 @ A5 ) ) )
          = ( inf_inf @ A @ ( F2 @ A3 ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A5 ) ) ) ) ) ).

% INF_insert
thf(fact_3320_INF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [M: B > A,A5: set @ B,B4: set @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) ) )
          = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ M @ B4 ) ) ) ) ) ).

% INF_union
thf(fact_3321_INT__extend__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,C5: set @ A,A5: A > ( set @ B ),B4: set @ B] :
      ( ( ( C5
          = ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A5 @ C5 ) ) @ B4 )
          = B4 ) )
      & ( ( C5
         != ( bot_bot @ ( set @ A ) ) )
       => ( ( inf_inf @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image2 @ A @ ( set @ B ) @ A5 @ C5 ) ) @ B4 )
          = ( complete_Inf_Inf @ ( set @ B )
            @ ( image2 @ A @ ( set @ B )
              @ ^ [X2: A] : ( inf_inf @ ( set @ B ) @ ( A5 @ X2 ) @ B4 )
              @ C5 ) ) ) ) ) ).

% INT_extend_simps(1)
thf(fact_3322_INT__extend__simps_I2_J,axiom,
    ! [C: $tType,D: $tType,C5: set @ D,A5: set @ C,B4: D > ( set @ C )] :
      ( ( ( C5
          = ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A5 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B4 @ C5 ) ) )
          = A5 ) )
      & ( ( C5
         != ( bot_bot @ ( set @ D ) ) )
       => ( ( inf_inf @ ( set @ C ) @ A5 @ ( complete_Inf_Inf @ ( set @ C ) @ ( image2 @ D @ ( set @ C ) @ B4 @ C5 ) ) )
          = ( complete_Inf_Inf @ ( set @ C )
            @ ( image2 @ D @ ( set @ C )
              @ ^ [X2: D] : ( inf_inf @ ( set @ C ) @ A5 @ ( B4 @ X2 ) )
              @ C5 ) ) ) ) ) ).

% INT_extend_simps(2)
thf(fact_3323_INT__Un,axiom,
    ! [A: $tType,B: $tType,M: B > ( set @ A ),A5: set @ B,B4: set @ B] :
      ( ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ A5 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ M @ B4 ) ) ) ) ).

% INT_Un
thf(fact_3324_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X2: A,Y2: B,Z3: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y2 @ Z3 ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs @ Ys ) @ Zs ) ) ) ).

% zip_assoc
thf(fact_3325_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs ) ) ) ).

% length_remdups_card_conv
thf(fact_3326_Inter__Un__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B4: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B4 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A5 @ B4 ) ) ) ).

% Inter_Un_subset
thf(fact_3327_takeWhile__not__last,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( takeWhile @ A
          @ ^ [Y2: A] :
              ( Y2
             != ( last @ A @ Xs ) )
          @ Xs )
        = ( butlast @ A @ Xs ) ) ) ).

% takeWhile_not_last
thf(fact_3328_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P2: A > $o,Xs: list @ A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ J )
         => ( P2 @ ( nth @ A @ Xs @ I3 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_3329_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P2: A > $o] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P2 @ ( nth @ A @ Xs @ I3 ) ) ) )
     => ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
         => ~ ( P2 @ ( nth @ A @ Xs @ N ) ) )
       => ( ( takeWhile @ A @ P2 @ Xs )
          = ( take @ A @ N @ Xs ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_3330_foldr__snd__zip,axiom,
    ! [B: $tType,A: $tType,C: $tType,Ys: list @ A,Xs: list @ B,F2: A > C > C,B2: C] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ B ) @ Xs ) )
     => ( ( foldr @ ( product_prod @ B @ A ) @ C
          @ ( product_case_prod @ B @ A @ ( C > C )
            @ ^ [X2: B] : F2 )
          @ ( zip @ B @ A @ Xs @ Ys )
          @ B2 )
        = ( foldr @ A @ C @ F2 @ Ys @ B2 ) ) ) ).

% foldr_snd_zip
thf(fact_3331_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs4: list @ A,Ys4: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs4 ) @ ( size_size @ ( list @ A ) @ Ys4 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs4 )
                      = ( size_size @ ( list @ A ) @ Ys4 ) )
                    & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs4 @ Ys4 ) @ ( lex @ A @ R3 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_3332_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X21: A,X22: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X21 @ X22 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X21 ) @ ( size_list @ A @ X @ X22 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_3333_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter @ B
              @ ^ [X2: B] : ( ord_less @ A @ T3 @ ( F2 @ X2 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X2: B] : ( ord_less @ A @ T3 @ ( F2 @ X2 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_3334_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R3: A > A > $o,Xs4: list @ A,Ys4: list @ A] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs4 @ Ys4 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_3335_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R3: A > A > $o,Xs4: list @ A,Ys4: list @ A] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs4 @ Ys4 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R3 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_3336_sort__key__by__quicksort__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ B @ A )
        = ( ^ [F3: B > A,Xs4: list @ B] :
              ( case_list @ ( list @ B ) @ B @ ( nil @ B )
              @ ^ [X2: B] :
                  ( case_list @ ( list @ B ) @ B @ Xs4
                  @ ^ [Y2: B] :
                      ( case_list @ ( list @ B ) @ B @ ( if @ ( list @ B ) @ ( ord_less_eq @ A @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) @ Xs4 @ ( cons @ B @ Y2 @ ( cons @ B @ X2 @ ( nil @ B ) ) ) )
                      @ ^ [Ab: B,List3: list @ B] :
                          ( product_case_prod @ ( list @ B ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( list @ B )
                          @ ^ [Lts: list @ B] :
                              ( product_case_prod @ ( list @ B ) @ ( list @ B ) @ ( list @ B )
                              @ ^ [Eqs: list @ B,Gts: list @ B] : ( append @ B @ ( linorder_sort_key @ B @ A @ F3 @ Lts ) @ ( append @ B @ Eqs @ ( linorder_sort_key @ B @ A @ F3 @ Gts ) ) ) )
                          @ ( linorder_part @ B @ A @ F3 @ ( F3 @ ( nth @ B @ Xs4 @ ( divide_divide @ nat @ ( size_size @ ( list @ B ) @ Xs4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Xs4 ) ) ) )
              @ Xs4 ) ) ) ) ).

% sort_key_by_quicksort_code
thf(fact_3337_Inf__finite__insert,axiom,
    ! [A: $tType] :
      ( ( finite_lattice @ A )
     => ! [A3: A,A5: set @ A] :
          ( ( complete_Inf_Inf @ A @ ( insert3 @ A @ A3 @ A5 ) )
          = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ A5 ) ) ) ) ).

% Inf_finite_insert
thf(fact_3338_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss2: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss2 ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss2 ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H: A,T2: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                @ Xss2 ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss2 ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_3339_gcd__1__nat,axiom,
    ! [M2: nat] :
      ( ( gcd_gcd @ nat @ M2 @ ( one_one @ nat ) )
      = ( one_one @ nat ) ) ).

% gcd_1_nat
thf(fact_3340_sort__upt,axiom,
    ! [M2: nat,N: nat] :
      ( ( linorder_sort_key @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( upt @ M2 @ N ) )
      = ( upt @ M2 @ N ) ) ).

% sort_upt
thf(fact_3341_sort__upto,axiom,
    ! [I2: int,J: int] :
      ( ( linorder_sort_key @ int @ int
        @ ^ [X2: int] : X2
        @ ( upto @ I2 @ J ) )
      = ( upto @ I2 @ J ) ) ).

% sort_upto
thf(fact_3342_sort__key__simps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A] :
          ( ( linorder_sort_key @ B @ A @ F2 @ ( nil @ B ) )
          = ( nil @ B ) ) ) ).

% sort_key_simps(1)
thf(fact_3343_set__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( set2 @ B @ Xs ) ) ) ).

% set_sort
thf(fact_3344_length__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( size_size @ ( list @ B ) @ Xs ) ) ) ).

% length_sort
thf(fact_3345_distinct__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( distinct @ B @ Xs ) ) ) ).

% distinct_sort
thf(fact_3346_sort__key__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [C2: B,Xs: list @ A] :
          ( ( linorder_sort_key @ A @ B
            @ ^ [X2: A] : C2
            @ Xs )
          = Xs ) ) ).

% sort_key_const
thf(fact_3347_filter__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P2: B > $o,F2: B > A,Xs: list @ B] :
          ( ( filter @ B @ P2 @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( linorder_sort_key @ B @ A @ F2 @ ( filter @ B @ P2 @ Xs ) ) ) ) ).

% filter_sort
thf(fact_3348_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_3349_sort__key__stable,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,K: B,Xs: list @ A] :
          ( ( filter @ A
            @ ^ [Y2: A] :
                ( ( F2 @ Y2 )
                = K )
            @ ( linorder_sort_key @ A @ B @ F2 @ Xs ) )
          = ( filter @ A
            @ ^ [Y2: A] :
                ( ( F2 @ Y2 )
                = K )
            @ Xs ) ) ) ).

% sort_key_stable
thf(fact_3350_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
        = ( transpose @ A @ Xss2 ) ) ) ).

% transpose.psimps(2)
thf(fact_3351_sorted__sort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Xs ) ) ) ).

% sorted_sort
thf(fact_3352_sorted__sort__id,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( linorder_sort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Xs )
            = Xs ) ) ) ).

% sorted_sort_id
thf(fact_3353_sorted__sort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_sort_key
thf(fact_3354_sorted__list__of__set__sort__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
          = ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_list_of_set_sort_remdups
thf(fact_3355_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P2: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P2 @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
             => ( ( P2 @ Xss )
               => ( P2 @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) ) ) )
         => ( ! [X3: A,Xs2: list @ A,Xss: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) )
               => ( ( P2
                    @ ( cons @ ( list @ A ) @ Xs2
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss ) ) ) )
                 => ( P2 @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) ) ) )
           => ( P2 @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_3356_transpose_Opelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ ( list @ A ) ) )
           => ( ( Y
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
               => ( ( Y
                    = ( transpose @ A @ Xss ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) ) ) )
           => ~ ! [X3: A,Xs2: list @ A,Xss: list @ ( list @ A )] :
                  ( ( X
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) )
                 => ( ( Y
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X3
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H: A,T2: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                              @ Xss ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs2
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H: A,T2: list @ A] : ( cons @ ( list @ A ) @ T2 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_3357_Bleast__code,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P2: A > $o] :
          ( ( bleast @ A @ ( set2 @ A @ Xs ) @ P2 )
          = ( case_list @ A @ A @ ( abort_Bleast @ A @ ( set2 @ A @ Xs ) @ P2 )
            @ ^ [X2: A,Xs4: list @ A] : X2
            @ ( filter @ A @ P2
              @ ( linorder_sort_key @ A @ A
                @ ^ [X2: A] : X2
                @ Xs ) ) ) ) ) ).

% Bleast_code
thf(fact_3358_rat__inverse__code,axiom,
    ! [P7: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P7 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,B3: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A4
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A4 ) @ B3 ) @ ( abs_abs @ int @ A4 ) ) )
        @ ( quotient_of @ P7 ) ) ) ).

% rat_inverse_code
thf(fact_3359_quicksort_Oelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ A,Y: list @ A] :
          ( ( ( linorder_quicksort @ A @ X )
            = Y )
         => ( ( ( X
                = ( nil @ A ) )
             => ( Y
               != ( nil @ A ) ) )
           => ~ ! [X3: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ( Y
                   != ( append @ A
                      @ ( linorder_quicksort @ A
                        @ ( filter @ A
                          @ ^ [Y2: A] :
                              ~ ( ord_less_eq @ A @ X3 @ Y2 )
                          @ Xs2 ) )
                      @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( linorder_quicksort @ A @ ( filter @ A @ ( ord_less_eq @ A @ X3 ) @ Xs2 ) ) ) ) ) ) ) ) ) ).

% quicksort.elims
thf(fact_3360_quicksort_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( linorder_quicksort @ A @ ( cons @ A @ X @ Xs ) )
          = ( append @ A
            @ ( linorder_quicksort @ A
              @ ( filter @ A
                @ ^ [Y2: A] :
                    ~ ( ord_less_eq @ A @ X @ Y2 )
                @ Xs ) )
            @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( linorder_quicksort @ A @ ( filter @ A @ ( ord_less_eq @ A @ X ) @ Xs ) ) ) ) ) ) ).

% quicksort.simps(2)
thf(fact_3361_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy2: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy2 )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy2 ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys ) ) ) ) ).

% set_relcomp
thf(fact_3362_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3363_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3364_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3365_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A3 @ ( inverse_inverse @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3366_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ A3 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3367_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3368_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3369_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y: A,X: A] :
          ( ( ( times_times @ A @ Y @ X )
            = ( times_times @ A @ X @ Y ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3370_quicksort_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_quicksort @ A @ ( nil @ A ) )
        = ( nil @ A ) ) ) ).

% quicksort.simps(1)
thf(fact_3371_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A3 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3372_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( ( times_times @ A @ A3 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A3 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3373_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3374_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% divide_inverse
thf(fact_3375_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ ( inverse_inverse @ A @ B3 ) @ A4 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3376_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3377_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) @ ( power_power @ A @ X @ M2 ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3378_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M2 ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3379_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3380_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3381_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3382_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3383_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3384_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( plus_plus @ A @ A3 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3385_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A3 @ B2 ) @ ( inverse_inverse @ A @ A3 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3386_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ A3 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3387_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A3 ) @ ( minus_minus @ A @ B2 @ A3 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3388_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A3 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A3 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3389_trancl__Int__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R4 ) @ S3 ) @ R4 ) @ S3 )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R4 ) @ S3 ) ) ) ).

% trancl_Int_subset
thf(fact_3390_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less @ A @ B2 @ A3 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A3 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3391_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A3 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A3 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A3 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A3 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A3 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3392_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3393_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3394_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A3 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3395_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M2 @ N )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N @ M2 ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M2 ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3396_quicksort_Opelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ A,Y: list @ A] :
          ( ( ( linorder_quicksort @ A @ X )
            = Y )
         => ( ( accp @ ( list @ A ) @ ( linord6200660962353139674rt_rel @ A ) @ X )
           => ( ( ( X
                  = ( nil @ A ) )
               => ( ( Y
                    = ( nil @ A ) )
                 => ~ ( accp @ ( list @ A ) @ ( linord6200660962353139674rt_rel @ A ) @ ( nil @ A ) ) ) )
             => ~ ! [X3: A,Xs2: list @ A] :
                    ( ( X
                      = ( cons @ A @ X3 @ Xs2 ) )
                   => ( ( Y
                        = ( append @ A
                          @ ( linorder_quicksort @ A
                            @ ( filter @ A
                              @ ^ [Y2: A] :
                                  ~ ( ord_less_eq @ A @ X3 @ Y2 )
                              @ Xs2 ) )
                          @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ ( linorder_quicksort @ A @ ( filter @ A @ ( ord_less_eq @ A @ X3 ) @ Xs2 ) ) ) ) )
                     => ~ ( accp @ ( list @ A ) @ ( linord6200660962353139674rt_rel @ A ) @ ( cons @ A @ X3 @ Xs2 ) ) ) ) ) ) ) ) ).

% quicksort.pelims
thf(fact_3397_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_3398_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L3: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q6: code_integer,R3: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L3 ) @ R3 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R3 @ ( numeral_numeral @ code_integer @ L3 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q6 ) @ R3 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_3399_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A3: B,Xs: list @ B,F2: B > A] :
          ( ( member2 @ B @ A3 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter @ B
                    @ ^ [X2: B] :
                        ( ( F2 @ A3 )
                        = ( F2 @ X2 ) )
                    @ Xs ) )
                = A3 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A3 @ ( remove1 @ B @ A3 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_3400_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_3401_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X: B,F2: B > A,Xs: list @ B] :
          ( ( remove1 @ B @ X @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = Xs ) ) ).

% remove1_insort_key
thf(fact_3402_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% length_insort
thf(fact_3403_sort__key__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( linorder_sort_key @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
          = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) ) ) ) ).

% sort_key_simps(2)
thf(fact_3404_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member2 @ A @ X @ A5 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert3 @ A @ X @ A5 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X
                @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_3405_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert3 @ A @ X @ A5 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_3406_atLeastPlusOneLessThan__greaterThanLessThan__integer,axiom,
    ! [L: code_integer,U: code_integer] :
      ( ( set_or7035219750837199246ssThan @ code_integer @ ( plus_plus @ code_integer @ L @ ( one_one @ code_integer ) ) @ U )
      = ( set_or5935395276787703475ssThan @ code_integer @ L @ U ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_integer
thf(fact_3407_atLeastLessThanPlusOne__atLeastAtMost__integer,axiom,
    ! [L: code_integer,U: code_integer] :
      ( ( set_or7035219750837199246ssThan @ code_integer @ L @ ( plus_plus @ code_integer @ U @ ( one_one @ code_integer ) ) )
      = ( set_or1337092689740270186AtMost @ code_integer @ L @ U ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_integer
thf(fact_3408_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y4: num,Z5: num] : ( Y4 = Z5 )
                @ R
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_3409_atLeastPlusOneAtMost__greaterThanAtMost__integer,axiom,
    ! [L: code_integer,U: code_integer] :
      ( ( set_or1337092689740270186AtMost @ code_integer @ ( plus_plus @ code_integer @ L @ ( one_one @ code_integer ) ) @ U )
      = ( set_or3652927894154168847AtMost @ code_integer @ L @ U ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_integer
thf(fact_3410_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Xs: list @ B] :
          ( ( ( F2 @ X )
           != ( F2 @ Y ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_insort_key @ B @ A @ F2 @ Y @ Xs ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_3411_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
                @ R )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_3412_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K4: code_integer] :
          ( if @ code_integer
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_3413_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ X
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Y
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_3414_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,A3: B,Xs: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ A3 @ Xs )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_3415_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P2: B > $o,X: B,F2: B > A,Xs: list @ B] :
          ( ~ ( P2 @ X )
         => ( ( filter @ B @ P2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( filter @ B @ P2 @ Xs ) ) ) ) ).

% filter_insort_triv
thf(fact_3416_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R @ R @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
                  @ R
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_3417_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ X @ ( cons @ B @ Y @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_3418_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( nil @ B ) )
          = ( cons @ B @ X @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_3419_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( insert3 @ B @ X @ ( set2 @ B @ Xs ) ) ) ) ).

% set_insort_key
thf(fact_3420_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( ~ ( member2 @ B @ X @ ( set2 @ B @ Xs ) )
            & ( distinct @ B @ Xs ) ) ) ) ).

% distinct_insort
thf(fact_3421_one__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ).

% one_rat.rsp
thf(fact_3422_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_3423_insort__insert__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs )
            = ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) ) ) ) ).

% insort_insert_insort
thf(fact_3424_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,A3: B] :
          ( ! [X3: B] :
              ( ( member2 @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F2 @ A3 ) @ ( F2 @ X3 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A3 @ Xs )
            = ( cons @ B @ A3 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_3425_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_3426_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_3427_one__integer_Orsp,axiom,
    ( ( one_one @ int )
    = ( one_one @ int ) ) ).

% one_integer.rsp
thf(fact_3428_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) ) ).

% one_natural.rsp
thf(fact_3429_insort__insert__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord329482645794927042rt_key @ B @ A )
        = ( ^ [F3: B > A,X2: B,Xs4: list @ B] : ( if @ ( list @ B ) @ ( member2 @ A @ ( F3 @ X2 ) @ ( image2 @ B @ A @ F3 @ ( set2 @ B @ Xs4 ) ) ) @ Xs4 @ ( linorder_insort_key @ B @ A @ F3 @ X2 @ Xs4 ) ) ) ) ) ).

% insort_insert_key_def
thf(fact_3430_insort__insert__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ~ ( member2 @ A @ ( F2 @ X ) @ ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
         => ( ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs )
            = ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) ) ) ).

% insort_insert_insort_key
thf(fact_3431_sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ B @ A )
        = ( ^ [F3: B > A,Xs4: list @ B] : ( foldr @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 ) @ Xs4 @ ( nil @ B ) ) ) ) ) ).

% sort_key_def
thf(fact_3432_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( ~ ( member2 @ A @ ( F2 @ X ) @ ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% distinct_insort_key
thf(fact_3433_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P2: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( P2 @ X )
           => ( ( filter @ B @ P2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X @ ( filter @ B @ P2 @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_3434_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,Xs: list @ A] :
          ( ( member2 @ A @ A3 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A3
                @ ( remove1 @ A @ A3 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_3435_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member2 @ A @ X @ A5 )
           => ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_3436_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A3: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X3: A] :
                ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X3 @ A3 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A3
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A3 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_3437_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R @ ( bNF_rel_fun @ A @ B @ A @ B @ R @ R ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
                @ R
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_3438_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K4: int] :
          ( if @ code_integer @ ( ord_less @ int @ K4 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K4 ) ) )
          @ ( if @ code_integer
            @ ( K4
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_3439_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit1 @ N ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_3440_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu2: product_prod @ A @ B] :
          ? [I4: nat] :
            ( ( Uu2
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I4 ) @ ( nth @ B @ Ys @ I4 ) ) )
            & ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% set_zip
thf(fact_3441_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,R4: set @ ( product_prod @ A @ B )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R4 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [X2: product_prod @ A @ B] :
            ( ( member2 @ ( product_prod @ A @ B ) @ X2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y2: A,Z3: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y2 @ Z3 ) @ R4 )
              @ X2 ) ) ) ) ).

% listrel_iff_zip
thf(fact_3442_ex__assn__proper,axiom,
    ! [A: $tType,P2: A > ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) > $o] :
      ( ! [X3: A] : ( proper @ ( P2 @ X3 ) )
     => ( proper
        @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ? [X2: A] : ( P2 @ X2 @ H ) ) ) ).

% ex_assn_proper
thf(fact_3443_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A10: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z3: list @ A] :
              ? [X2: A,Xs4: list @ A] :
                ( ( Z3
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( member2 @ A @ X2 @ A10 )
                & ( member2 @ ( list @ A ) @ Xs4 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_3444_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
      @ ratrel )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) ) ) ).

% Fract.rsp
thf(fact_3445_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R: A > B > $o] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
              @ R
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_3446_one__integer__def,axiom,
    ( ( one_one @ code_integer )
    = ( code_integer_of_int @ ( one_one @ int ) ) ) ).

% one_integer_def
thf(fact_3447_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: A,A5: set @ A] :
          ( ( inf_inf @ A @ A3 @ ( complete_Sup_Sup @ A @ A5 ) )
          = ( complete_Sup_Sup @ A
            @ ( collect @ A
              @ ^ [Uu2: A] :
                ? [B3: A] :
                  ( ( Uu2
                    = ( inf_inf @ A @ A3 @ B3 ) )
                  & ( member2 @ A @ B3 @ A5 ) ) ) ) ) ) ).

% finite_inf_Sup
thf(fact_3448_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs4: list @ A,Ys4: list @ A] :
                ? [Us2: list @ A,Z3: A,Z7: A,Vs2: list @ A] :
                  ( ( Xs4
                    = ( append @ A @ Us2 @ ( cons @ A @ Z3 @ Vs2 ) ) )
                  & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ Z7 ) @ R3 )
                  & ( Ys4
                    = ( append @ A @ Us2 @ ( cons @ A @ Z7 @ Vs2 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_3449_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X2: list @ A,Y2: list @ A] :
                ? [A4: A,V3: list @ A] :
                  ( ( Y2
                    = ( append @ A @ X2 @ ( cons @ A @ A4 @ V3 ) ) )
                  | ? [U2: list @ A,B3: A,C3: A,W4: list @ A,Z3: list @ A] :
                      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C3 ) @ R3 )
                      & ( X2
                        = ( append @ A @ U2 @ ( cons @ A @ B3 @ W4 ) ) )
                      & ( Y2
                        = ( append @ A @ U2 @ ( cons @ A @ C3 @ Z3 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_3450_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa )
     => ~ ! [X3: A,Ys3: list @ A] :
            ( ( Xa
              = ( cons @ A @ X3 @ Ys3 ) )
           => ( ! [Xa3: A] :
                  ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Ys3 ) )
                 => ( X @ X3 @ Xa3 ) )
              & ( sorted_wrt @ A @ X @ Ys3 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_3451_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P2: A > A > $o,X: A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P2 @ ( cons @ A @ X @ Ys ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Ys ) )
           => ( P2 @ X @ X2 ) )
        & ( sorted_wrt @ A @ P2 @ Ys ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_3452_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs4: list @ A,Ys4: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs4 )
                    = ( size_size @ ( list @ A ) @ Ys4 ) )
                  & ? [Xys2: list @ A,X2: A,Y2: A,Xs6: list @ A,Ys6: list @ A] :
                      ( ( Xs4
                        = ( append @ A @ Xys2 @ ( cons @ A @ X2 @ Xs6 ) ) )
                      & ( Ys4
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y2 @ Ys6 ) ) )
                      & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_3453_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X3 ) )
       => ( ( takeWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P2 @ Ys ) ) ) )
      & ( ~ ! [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
             => ( P2 @ X4 ) )
       => ( ( takeWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P2 @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_3454_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa )
     => ( ( Xa
         != ( nil @ A ) )
       => ~ ! [X3: A,Ys3: list @ A] :
              ( ( Xa
                = ( cons @ A @ X3 @ Ys3 ) )
             => ~ ( ! [Xa2: A] :
                      ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Ys3 ) )
                     => ( X @ X3 @ Xa2 ) )
                  & ( sorted_wrt @ A @ X @ Ys3 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_3455_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ~ Y )
       => ~ ! [X3: A,Ys3: list @ A] :
              ( ( Xa
                = ( cons @ A @ X3 @ Ys3 ) )
             => ( Y
                = ( ~ ( ! [Y2: A] :
                          ( ( member2 @ A @ Y2 @ ( set2 @ A @ Ys3 ) )
                         => ( X @ X3 @ Y2 ) )
                      & ( sorted_wrt @ A @ X @ Ys3 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_3456_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs4: list @ A] :
            ( collect @ A
            @ ^ [Uu2: A] :
              ? [I4: nat] :
                ( ( Uu2
                  = ( nth @ A @ Xs4 @ I4 ) )
                & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs4 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_3457_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y4: list @ A,Z5: list @ A] : ( Y4 = Z5 ) )
      = ( ^ [Xs4: list @ A,Ys4: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs4 )
              = ( size_size @ ( list @ A ) @ Ys4 ) )
            & ! [X2: product_prod @ A @ A] :
                ( ( member2 @ ( product_prod @ A @ A ) @ X2 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs4 @ Ys4 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
                  @ X2 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_3458_concat__injective,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs )
        = ( concat @ A @ Ys ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ! [X3: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y2: list @ A,Z3: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y2 )
                    = ( size_size @ ( list @ A ) @ Z3 ) )
                @ X3 ) )
         => ( Xs = Ys ) ) ) ) ).

% concat_injective
thf(fact_3459_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ! [X3: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y2: list @ A,Z3: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y2 )
                = ( size_size @ ( list @ A ) @ Z3 ) )
            @ X3 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ( ( concat @ A @ Xs )
            = ( concat @ A @ Ys ) )
          = ( Xs = Ys ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_3460_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_3461_set__nths,axiom,
    ! [A: $tType,Xs: list @ A,I: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs @ I ) )
      = ( collect @ A
        @ ^ [Uu2: A] :
          ? [I4: nat] :
            ( ( Uu2
              = ( nth @ A @ Xs @ I4 ) )
            & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( member2 @ nat @ I4 @ I ) ) ) ) ).

% set_nths
thf(fact_3462_FI__def,axiom,
    ( fi
    = ( ^ [M3: list @ ( product_prod @ assn @ assn ),P5: assn,Q6: assn,Up: assn,Uq: assn,F3: assn] :
          ( ! [X2: product_prod @ assn @ assn] :
              ( ( member2 @ ( product_prod @ assn @ assn ) @ X2 @ ( set2 @ ( product_prod @ assn @ assn ) @ M3 ) )
             => ( product_case_prod @ assn @ assn @ $o @ entails @ X2 ) )
         => ( entails @ ( times_times @ assn @ ( times_times @ assn @ ( foldr @ assn @ assn @ ( times_times @ assn ) @ ( map @ ( product_prod @ assn @ assn ) @ assn @ ( product_fst @ assn @ assn ) @ M3 ) @ ( one_one @ assn ) ) @ P5 ) @ Up ) @ ( times_times @ assn @ ( times_times @ assn @ ( times_times @ assn @ ( foldr @ assn @ assn @ ( times_times @ assn ) @ ( map @ ( product_prod @ assn @ assn ) @ assn @ ( product_snd @ assn @ assn ) @ M3 ) @ ( one_one @ assn ) ) @ Q6 ) @ Uq ) @ F3 ) ) ) ) ) ).

% FI_def
thf(fact_3463_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) )
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_3464_FI__RESULT__def,axiom,
    ( fI_RESULT
    = ( ^ [M5: list @ ( product_prod @ assn @ assn ),UP: assn,UQ: assn,F: assn] :
          ( ! [X2: product_prod @ assn @ assn] :
              ( ( member2 @ ( product_prod @ assn @ assn ) @ X2 @ ( set2 @ ( product_prod @ assn @ assn ) @ M5 ) )
             => ( product_case_prod @ assn @ assn @ $o @ entails @ X2 ) )
         => ( entails @ ( times_times @ assn @ ( foldr @ assn @ assn @ ( times_times @ assn ) @ ( map @ ( product_prod @ assn @ assn ) @ assn @ ( product_fst @ assn @ assn ) @ M5 ) @ ( one_one @ assn ) ) @ UP ) @ ( times_times @ assn @ ( times_times @ assn @ ( foldr @ assn @ assn @ ( times_times @ assn ) @ ( map @ ( product_prod @ assn @ assn ) @ assn @ ( product_snd @ assn @ assn ) @ M5 ) @ ( one_one @ assn ) ) @ UQ ) @ F ) ) ) ) ) ).

% FI_RESULT_def
thf(fact_3465_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) )
         => ~ ! [X3: A,Ys3: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ Ys3 ) )
               => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ Ys3 ) ) )
                 => ~ ( ! [Xa2: A] :
                          ( ( member2 @ A @ Xa2 @ ( set2 @ A @ Ys3 ) )
                         => ( X @ X3 @ Xa2 ) )
                      & ( sorted_wrt @ A @ X @ Ys3 ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
thf(fact_3466_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
         => ~ ! [X3: A,Ys3: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ Ys3 ) )
               => ( ( Y
                    = ( ! [Y2: A] :
                          ( ( member2 @ A @ Y2 @ ( set2 @ A @ Ys3 ) )
                         => ( X @ X3 @ Y2 ) )
                      & ( sorted_wrt @ A @ X @ Ys3 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ Ys3 ) ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
thf(fact_3467_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A ),N3: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs4: list @ A,Ys4: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs4 )
                    = N3 )
                  & ( ( size_size @ ( list @ A ) @ Ys4 )
                    = N3 )
                  & ? [Xys2: list @ A,X2: A,Y2: A,Xs6: list @ A,Ys6: list @ A] :
                      ( ( Xs4
                        = ( append @ A @ Xys2 @ ( cons @ A @ X2 @ Xs6 ) ) )
                      & ( Ys4
                        = ( append @ A @ Xys2 @ ( cons @ A @ Y2 @ Ys6 ) ) )
                      & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_3468_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ~ ! [X3: A,Ys3: list @ A] :
              ( ( Xa
                = ( cons @ A @ X3 @ Ys3 ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ Ys3 ) ) )
               => ( ! [Xa3: A] :
                      ( ( member2 @ A @ Xa3 @ ( set2 @ A @ Ys3 ) )
                     => ( X @ X3 @ Xa3 ) )
                  & ( sorted_wrt @ A @ X @ Ys3 ) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
thf(fact_3469_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R4 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_3470_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image2 @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R3 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_3471_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexn @ A @ R4 @ N ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N ) ) ) ).

% lexn_length
thf(fact_3472_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K4: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K4 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L3: code_integer,J2: code_integer] :
                ( if @ num
                @ ( J2
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L3 ) @ ( code_num_of_integer @ L3 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L3 ) @ ( code_num_of_integer @ L3 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_3473_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K4: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K4 ) ) )
          @ ( if @ int
            @ ( K4
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L3: code_integer,J2: code_integer] :
                  ( if @ int
                  @ ( J2
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L3 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L3 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_3474_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K4: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R3: code_integer,S4: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K4 ) @ R3 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ S4 ) )
                @ ( S4
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_3475_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K4: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L3: code_integer,J2: code_integer] :
                ( if @ nat
                @ ( J2
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L3 ) @ ( code_nat_of_integer @ L3 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L3 ) @ ( code_nat_of_integer @ L3 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K4 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_3476_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A4: A,Xs4: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( times_times @ A @ A4 ) @ ( F3 @ ( nth @ B @ Xs4 @ N3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs4 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_3477_relpowp__1,axiom,
    ! [A: $tType,P2: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( one_one @ nat ) @ P2 )
      = P2 ) ).

% relpowp_1
thf(fact_3478_one__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ int ) ) ).

% one_integer.rep_eq
thf(fact_3479_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_3480_rotate__def,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N3: nat] : ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N3 @ ( rotate1 @ A ) ) ) ) ).

% rotate_def
thf(fact_3481_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_3482_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A3: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A3 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A3 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_3483_butlast__power,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N @ ( butlast @ A ) @ Xs )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) @ Xs ) ) ).

% butlast_power
thf(fact_3484_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K4: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K4 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_3485_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K4: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L3 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K4 ) @ ( code_divmod_abs @ K4 @ L3 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R3: code_integer,S4: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S4
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L3 @ S4 ) ) )
                @ ( code_divmod_abs @ K4 @ L3 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L3
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K4 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K4 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K4 @ L3 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R3: code_integer,S4: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S4
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L3 ) @ S4 ) ) )
                    @ ( code_divmod_abs @ K4 @ L3 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_3486_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ! [X3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ( Y
                 != ( case_list @ A @ A @ X3
                    @ ^ [A4: A,List3: list @ A] : ( ord_min @ A @ X3 @ ( min_list @ A @ Xs2 ) )
                    @ Xs2 ) ) )
           => ~ ( ( X
                  = ( nil @ A ) )
               => ( Y
                 != ( undefined @ A ) ) ) ) ) ) ).

% min_list.elims
thf(fact_3487_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,P7: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member2 @ B @ X2 @ I )
                  & ( ( P7 @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member2 @ B @ I2 @ I )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P7 @ ( insert3 @ B @ I2 @ I ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P7 @ I ) ) )
            & ( ~ ( member2 @ B @ I2 @ I )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P7 @ ( insert3 @ B @ I2 @ I ) )
                = ( times_times @ A @ ( P7 @ I2 ) @ ( groups1962203154675924110t_prod @ B @ A @ P7 @ I ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_3488_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% sorted_list_of_set_def
thf(fact_3489_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M2: nat,A3: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M2 @ A3 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q6: nat] : ( product_Pair @ nat @ A @ Q6 @ A3 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M2 ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_3490_replicate__eq__replicate,axiom,
    ! [A: $tType,M2: nat,X: A,N: nat,Y: A] :
      ( ( ( replicate @ A @ M2 @ X )
        = ( replicate @ A @ N @ Y ) )
      = ( ( M2 = N )
        & ( ( M2
           != ( zero_zero @ nat ) )
         => ( X = Y ) ) ) ) ).

% replicate_eq_replicate
thf(fact_3491_length__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N @ X ) )
      = N ) ).

% length_replicate
thf(fact_3492_concat__replicate__trivial,axiom,
    ! [A: $tType,I2: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I2 @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_3493_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A,N: nat,X: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( replicate @ A @ N @ ( F2 @ X ) ) ) ).

% map_replicate
thf(fact_3494_rev__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( rev @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ N @ X ) ) ).

% rev_replicate
thf(fact_3495_replicate__empty,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( replicate @ A @ N @ X )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_3496_empty__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_3497_in__set__replicate,axiom,
    ! [A: $tType,X: A,N: nat,Y: A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( replicate @ A @ N @ Y ) ) )
      = ( ( X = Y )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_3498_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A3: A,P2: A > $o] :
      ( ( ? [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N @ A3 ) ) )
            & ( P2 @ X2 ) ) )
      = ( ( P2 @ A3 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_3499_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A3: A,P2: A > $o] :
      ( ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N @ A3 ) ) )
           => ( P2 @ X2 ) ) )
      = ( ( P2 @ A3 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_3500_nth__replicate,axiom,
    ! [A: $tType,I2: nat,N: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ N )
     => ( ( nth @ A @ ( replicate @ A @ N @ X ) @ I2 )
        = X ) ) ).

% nth_replicate
thf(fact_3501_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P7: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P7 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_3502_hd__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_3503_drop__replicate,axiom,
    ! [A: $tType,I2: nat,K: nat,X: A] :
      ( ( drop @ A @ I2 @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I2 ) @ X ) ) ).

% drop_replicate
thf(fact_3504_takeWhile__replicate,axiom,
    ! [A: $tType,P2: A > $o,X: A,N: nat] :
      ( ( ( P2 @ X )
       => ( ( takeWhile @ A @ P2 @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) )
      & ( ~ ( P2 @ X )
       => ( ( takeWhile @ A @ P2 @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_3505_last__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( last @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% last_replicate
thf(fact_3506_take__replicate,axiom,
    ! [A: $tType,I2: nat,K: nat,X: A] :
      ( ( take @ A @ I2 @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( ord_min @ nat @ I2 @ K ) @ X ) ) ).

% take_replicate
thf(fact_3507_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N: nat,X: B] :
      ( ( foldr @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( compow @ ( A > A ) @ N @ ( F2 @ X ) ) ) ).

% foldr_replicate
thf(fact_3508_splice__replicate,axiom,
    ! [A: $tType,M2: nat,X: A,N: nat] :
      ( ( splice @ A @ ( replicate @ A @ M2 @ X ) @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ ( plus_plus @ nat @ M2 @ N ) @ X ) ) ).

% splice_replicate
thf(fact_3509_tl__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( tl @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ).

% tl_replicate
thf(fact_3510_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I2: nat,X: A,J: nat,Y: B] :
      ( ( zip @ A @ B @ ( replicate @ A @ I2 @ X ) @ ( replicate @ B @ J @ Y ) )
      = ( replicate @ ( product_prod @ A @ B ) @ ( ord_min @ nat @ I2 @ J ) @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_replicate
thf(fact_3511_mod__h__bot__normalize,axiom,
    ! [A: $tType,H2: heap_ext @ product_unit,P2: assn] :
      ( ( syntax7388354845996824322omatch @ A @ ( heap_ext @ product_unit ) @ ( undefined @ A ) @ H2 )
     => ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
        = ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ ( undefined @ ( heap_ext @ product_unit ) ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_normalize
thf(fact_3512_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
        = ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_3513_append__replicate__commute,axiom,
    ! [A: $tType,N: nat,X: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ K @ X ) )
      = ( append @ A @ ( replicate @ A @ K @ X ) @ ( replicate @ A @ N @ X ) ) ) ).

% append_replicate_commute
thf(fact_3514_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member2 @ B @ X2 @ I )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I ) ) ) ).

% prod.non_neutral'
thf(fact_3515_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X )
      = ( cons @ A @ X @ ( replicate @ A @ N @ X ) ) ) ).

% replicate_Suc
thf(fact_3516_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_3517_replicate__app__Cons__same,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( append @ A @ ( replicate @ A @ N @ X ) @ Xs ) ) ) ).

% replicate_app_Cons_same
thf(fact_3518_replicate__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = N )
     => ( ! [Y3: A] :
            ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( Y3 = X ) )
       => ( Xs
          = ( replicate @ A @ N @ X ) ) ) ) ).

% replicate_eqI
thf(fact_3519_replicate__length__same,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( X3 = X ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X )
        = Xs ) ) ).

% replicate_length_same
thf(fact_3520_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X ) ) ) ).

% sorted_replicate
thf(fact_3521_replicate__add,axiom,
    ! [A: $tType,N: nat,M2: nat,X: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N @ M2 ) @ X )
      = ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ M2 @ X ) ) ) ).

% replicate_add
thf(fact_3522_filter__replicate,axiom,
    ! [A: $tType,P2: A > $o,X: A,N: nat] :
      ( ( ( P2 @ X )
       => ( ( filter @ A @ P2 @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) )
      & ( ~ ( P2 @ X )
       => ( ( filter @ A @ P2 @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_3523_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Ys @ Xs ) )
     => ? [M6: nat,N4: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M6 @ Zs2 ) )
            = Xs )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N4 @ Zs2 ) )
            = Ys ) ) ) ).

% comm_append_are_replicate
thf(fact_3524_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X2: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_3525_replicate__length__filter,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter @ A
            @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
              @ X )
            @ Xs ) )
        @ X )
      = ( filter @ A
        @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
          @ X )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_3526_replicate__append__same,axiom,
    ! [A: $tType,I2: nat,X: A] :
      ( ( append @ A @ ( replicate @ A @ I2 @ X ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( replicate @ A @ I2 @ X ) ) ) ).

% replicate_append_same
thf(fact_3527_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I4: B] : ( times_times @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
              @ I )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_3528_hd__def,axiom,
    ! [A: $tType] :
      ( ( hd @ A )
      = ( case_list @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X223: list @ A] : X213 ) ) ).

% hd_def
thf(fact_3529_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I2: nat] :
      ( ( map @ nat @ A
        @ ^ [I4: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I2 ) )
      = ( replicate @ A @ I2 @ X ) ) ).

% map_replicate_trivial
thf(fact_3530_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_3531_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X ) )
      = ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_3532_replicate__Suc__conv__snoc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X )
      = ( append @ A @ ( replicate @ A @ N @ X ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% replicate_Suc_conv_snoc
thf(fact_3533_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T )
         => ( ! [X3: B] :
                ( ( member2 @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_3534_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T )
         => ( ! [X3: B] :
                ( ( member2 @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_3535_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
               => ( ( H2 @ I3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_3536_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,T: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T )
         => ( ! [X3: B] :
                ( ( member2 @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member2 @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_3537_zipf_Oelims,axiom,
    ! [B: $tType,A: $tType,C: $tType,X: A > B > C,Xa: list @ A,Xb: list @ B,Y: list @ C] :
      ( ( ( zipf @ A @ B @ C @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( ( Xb
              = ( nil @ B ) )
           => ( Y
             != ( nil @ C ) ) ) )
       => ( ! [A6: A,As: list @ A] :
              ( ( Xa
                = ( cons @ A @ A6 @ As ) )
             => ! [B5: B,Bs2: list @ B] :
                  ( ( Xb
                    = ( cons @ B @ B5 @ Bs2 ) )
                 => ( Y
                   != ( cons @ C @ ( X @ A6 @ B5 ) @ ( zipf @ A @ B @ C @ X @ As @ Bs2 ) ) ) ) )
         => ( ( ? [V: A,Va: list @ A] :
                  ( Xa
                  = ( cons @ A @ V @ Va ) )
             => ( ( Xb
                  = ( nil @ B ) )
               => ( Y
                 != ( undefined @ ( list @ C ) ) ) ) )
           => ~ ( ( Xa
                  = ( nil @ A ) )
               => ( ? [V: B,Va: list @ B] :
                      ( Xb
                      = ( cons @ B @ V @ Va ) )
                 => ( Y
                   != ( undefined @ ( list @ C ) ) ) ) ) ) ) ) ) ).

% zipf.elims
thf(fact_3538_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N: nat,X: A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( replicate @ A @ N @ X ) @ Ys )
      = ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ ( take @ B @ N @ Ys ) ) ) ).

% zip_replicate1
thf(fact_3539_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member2 @ B @ X2 @ I )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member2 @ B @ X2 @ I )
                    & ( ( H2 @ X2 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I4: B] : ( times_times @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
                @ I )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_3540_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P5: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member2 @ B @ X2 @ I7 )
                      & ( ( P5 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P5
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member2 @ B @ X2 @ I7 )
                      & ( ( P5 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_3541_map__zip1,axiom,
    ! [A: $tType,B: $tType,K: B,L: list @ A] :
      ( ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ K )
        @ L )
      = ( zip @ A @ B @ L @ ( replicate @ B @ ( size_size @ ( list @ A ) @ L ) @ K ) ) ) ).

% map_zip1
thf(fact_3542_map__zip2,axiom,
    ! [A: $tType,B: $tType,K: A,L: list @ B] :
      ( ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K ) @ L )
      = ( zip @ A @ B @ ( replicate @ A @ ( size_size @ ( list @ B ) @ L ) @ K ) @ L ) ) ).

% map_zip2
thf(fact_3543_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,N: nat,Y: B] :
      ( ( zip @ A @ B @ Xs @ ( replicate @ B @ N @ Y ) )
      = ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ Y )
        @ ( take @ A @ N @ Xs ) ) ) ).

% zip_replicate2
thf(fact_3544_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat,Y: A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( replicate @ A @ N @ Y ) )
      = ( ( X = Y )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_3545_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys )
            = ( append @ A @ Ys @ Xs ) )
         => ? [N4: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N4 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N4 @ Zs2 ) )
                = ( append @ A @ Xs @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_3546_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa )
            = Y )
         => ( ! [X3: A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ( Y != X3 ) )
           => ( ! [X3: A,Y3: A,Zs2: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Zs2 ) ) )
                 => ( Y
                   != ( if @ A @ ( ord_less_eq @ B @ ( X @ X3 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs2 ) ) ) ) @ X3 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs2 ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ( Y
                   != ( undefined @ A ) ) ) ) ) ) ) ).

% arg_min_list.elims
thf(fact_3547_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ X )
           => ( ! [X3: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ( ( Y
                      = ( case_list @ A @ A @ X3
                        @ ^ [A4: A,List3: list @ A] : ( ord_min @ A @ X3 @ ( min_list @ A @ Xs2 ) )
                        @ Xs2 ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( cons @ A @ X3 @ Xs2 ) ) ) )
             => ~ ( ( X
                    = ( nil @ A ) )
                 => ( ( Y
                      = ( undefined @ A ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( nil @ A ) ) ) ) ) ) ) ) ).

% min_list.pelims
thf(fact_3548_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ Xa ) )
           => ( ! [X3: A] :
                  ( ( Xa
                    = ( cons @ A @ X3 @ ( nil @ A ) ) )
                 => ( ( Y = X3 )
                   => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
             => ( ! [X3: A,Y3: A,Zs2: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Zs2 ) ) )
                   => ( ( Y
                        = ( if @ A @ ( ord_less_eq @ B @ ( X @ X3 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs2 ) ) ) ) @ X3 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y3 @ Zs2 ) ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Zs2 ) ) ) ) ) )
               => ~ ( ( Xa
                      = ( nil @ A ) )
                   => ( ( Y
                        = ( undefined @ A ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
thf(fact_3549_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K4: code_integer,L3: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K4
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L3
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K4 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L3
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K4 )
                  = ( sgn_sgn @ code_integer @ L3 ) )
                @ ( code_divmod_abs @ K4 @ L3 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R3: code_integer,S4: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S4
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R3 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L3 ) @ S4 ) ) )
                  @ ( code_divmod_abs @ K4 @ L3 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_3550_listrel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrel @ A @ B )
      = ( ^ [R3: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ B ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ B ) @ $o
              @ ( listrelp @ A @ B
                @ ^ [X2: A,Y2: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R3 ) ) ) ) ) ) ).

% listrel_def
thf(fact_3551_sorted__key__list__of__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord144544945434240204of_set @ B @ A )
        = ( ^ [F3: B > A] : ( finite_folding_F @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 ) @ ( nil @ B ) ) ) ) ) ).

% sorted_key_list_of_set_def
thf(fact_3552_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > C,G: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F2 ) @ ( map @ A @ B @ G ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) ) ) ).

% List.map.comp
thf(fact_3553_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,G: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F2 ) @ ( map @ A @ C @ G ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F2 @ G ) ) ) ).

% map_comp_map
thf(fact_3554_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F2: A > B,V2: list @ A] :
      ( ( map @ B @ C @ G @ ( map @ A @ B @ F2 @ V2 ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G @ F2 ) @ V2 ) ) ).

% list.map_comp
thf(fact_3555_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C,G: A > B,List: list @ A] :
      ( ( map @ B @ C @ F2 @ ( map @ A @ B @ G @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) @ List ) ) ).

% List.map.compositionality
thf(fact_3556_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > A,G: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F2 @ ( map @ C @ B @ G @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F2 @ G ) @ Xs ) ) ).

% map_map
thf(fact_3557_listrelp_OCons,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( R4 @ X @ Y )
     => ( ( listrelp @ A @ B @ R4 @ Xs @ Ys )
       => ( listrelp @ A @ B @ R4 @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) ) ) ).

% listrelp.Cons
thf(fact_3558_listrelp_ONil,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o] : ( listrelp @ A @ B @ R4 @ ( nil @ A ) @ ( nil @ B ) ) ).

% listrelp.Nil
thf(fact_3559_foldr_Ofoldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F2 @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( F2 @ X ) @ ( foldr @ A @ B @ F2 @ Xs ) ) ) ).

% foldr.foldr_Cons
thf(fact_3560_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: B > A > A,F2: C > B,Xs: list @ C,A3: A] :
      ( ( foldr @ B @ A @ G @ ( map @ C @ B @ F2 @ Xs ) @ A3 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F2 ) @ Xs @ A3 ) ) ).

% foldr_map
thf(fact_3561_listrelp_Ocases,axiom,
    ! [A: $tType,B: $tType,R4: A > B > $o,A1: list @ A,A22: list @ B] :
      ( ( listrelp @ A @ B @ R4 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X3: A,Y3: B,Xs2: list @ A] :
              ( ( A1
                = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Ys3: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y3 @ Ys3 ) )
                 => ( ( R4 @ X3 @ Y3 )
                   => ~ ( listrelp @ A @ B @ R4 @ Xs2 @ Ys3 ) ) ) ) ) ) ).

% listrelp.cases
thf(fact_3562_listrelp_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R3: A > B > $o,A12: list @ A,A23: list @ B] :
            ( ( ( A12
                = ( nil @ A ) )
              & ( A23
                = ( nil @ B ) ) )
            | ? [X2: A,Y2: B,Xs4: list @ A,Ys4: list @ B] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( A23
                  = ( cons @ B @ Y2 @ Ys4 ) )
                & ( R3 @ X2 @ Y2 )
                & ( listrelp @ A @ B @ R3 @ Xs4 @ Ys4 ) ) ) ) ) ).

% listrelp.simps
thf(fact_3563_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ! [X3: B,Y3: B] :
                ( ( member2 @ B @ X3 @ A5 )
               => ( ( member2 @ B @ Y3 @ A5 )
                 => ( ( X3 != Y3 )
                   => ( ( ( H2 @ X3 )
                        = ( H2 @ Y3 ) )
                     => ( ( G @ ( H2 @ X3 ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image2 @ B @ C @ H2 @ A5 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A5 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_3564_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ B )] :
      ( ( listrelp @ A @ B
        @ ^ [X2: A,Y2: B] : ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R4 ) )
      = ( ^ [X2: list @ A,Y2: list @ B] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X2 @ Y2 ) @ ( listrel @ A @ B @ R4 ) ) ) ) ).

% listrelp_listrel_eq
thf(fact_3565_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_3566_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_3567_Pow__set_I2_J,axiom,
    ! [B: $tType,X: B,Xs: list @ B] :
      ( ( pow @ B @ ( set2 @ B @ ( cons @ B @ X @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow @ B @ ( set2 @ B @ Xs ) ) @ ( image2 @ ( set @ B ) @ ( set @ B ) @ ( insert3 @ B @ X ) @ ( pow @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_3568_lists__length__Suc__eq,axiom,
    ! [A: $tType,A5: set @ A,N: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs4: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 )
            & ( ( size_size @ ( list @ A ) @ Xs4 )
              = ( suc @ N ) ) ) )
      = ( image2 @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs4: list @ A,N3: A] : ( cons @ A @ N3 @ Xs4 ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs4: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs4 ) @ A5 )
                & ( ( size_size @ ( list @ A ) @ Xs4 )
                  = N ) ) )
          @ ^ [Uu2: list @ A] : A5 ) ) ) ).

% lists_length_Suc_eq
thf(fact_3569_INF__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ Xs @ ( top_top @ A ) ) ) ) ).

% INF_set_fold
thf(fact_3570_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_3571_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% remdups_adj_set
thf(fact_3572_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_rev
thf(fact_3573_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% hd_remdups_adj
thf(fact_3574_last__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( last @ A @ ( remdups_adj @ A @ Xs ) )
      = ( last @ A @ Xs ) ) ).

% last_remdups_adj
thf(fact_3575_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: A > nat,G: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F2 @ ( map @ B @ A @ G @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F2 @ G ) @ Xs ) ) ).

% size_list_map
thf(fact_3576_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P2: A > $o,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter @ A @ P2 @ ( map @ B @ A @ F2 @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter @ B @ ( comp @ A @ $o @ B @ P2 @ F2 ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_3577_fold__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,Xs: list @ B,Ys: list @ B] :
      ( ( fold @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) )
      = ( comp @ A @ A @ A @ ( fold @ B @ A @ F2 @ Ys ) @ ( fold @ B @ A @ F2 @ Xs ) ) ) ).

% fold_append
thf(fact_3578_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_3579_fold__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N: nat,X: B] :
      ( ( fold @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( compow @ ( A > A ) @ N @ ( F2 @ X ) ) ) ).

% fold_replicate
thf(fact_3580_Pow__Int__eq,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( pow @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ ( set @ A ) ) @ ( pow @ A @ A5 ) @ ( pow @ A @ B4 ) ) ) ).

% Pow_Int_eq
thf(fact_3581_set__product,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( product_Sigma @ A @ B @ ( set2 @ A @ Xs )
        @ ^ [Uu2: A] : ( set2 @ B @ Ys ) ) ) ).

% set_product
thf(fact_3582_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: B > nat,G: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F2 ) @ ( map @ A @ B @ G ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F2 @ G ) ) ) ).

% list.size_gen_o_map
thf(fact_3583_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_3584_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      & ( ( X != Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( cons @ A @ X @ ( remdups_adj @ A @ ( cons @ A @ Y @ Xs ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_3585_fold__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,S3: A] :
      ( ( fold @ B @ A @ F2 @ ( nil @ B ) @ S3 )
      = S3 ) ).

% fold_simps(1)
thf(fact_3586_fold__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,X: B,Xs: list @ B,S3: A] :
      ( ( fold @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) @ S3 )
      = ( fold @ B @ A @ F2 @ Xs @ ( F2 @ X @ S3 ) ) ) ).

% fold_simps(2)
thf(fact_3587_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups_adj @ A @ Xs )
        = Xs ) ) ).

% remdups_adj_distinct
thf(fact_3588_fold__invariant,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Q2: A > $o,P2: B > $o,S3: B,F2: A > B > B] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( Q2 @ X3 ) )
     => ( ( P2 @ S3 )
       => ( ! [X3: A,S5: B] :
              ( ( Q2 @ X3 )
             => ( ( P2 @ S5 )
               => ( P2 @ ( F2 @ X3 @ S5 ) ) ) )
         => ( P2 @ ( fold @ A @ B @ F2 @ Xs @ S3 ) ) ) ) ) ).

% fold_invariant
thf(fact_3589_List_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,A3: A,B2: A,Xs: list @ B,Ys: list @ B,F2: B > A > A,G: B > A > A] :
      ( ( A3 = B2 )
     => ( ( Xs = Ys )
       => ( ! [X3: B] :
              ( ( member2 @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ( F2 @ X3 )
                = ( G @ X3 ) ) )
         => ( ( fold @ B @ A @ F2 @ Xs @ A3 )
            = ( fold @ B @ A @ G @ Ys @ B2 ) ) ) ) ) ).

% List.fold_cong
thf(fact_3590_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_3591_filter__map,axiom,
    ! [A: $tType,B: $tType,P2: A > $o,F2: B > A,Xs: list @ B] :
      ( ( filter @ A @ P2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( filter @ B @ ( comp @ A @ $o @ B @ P2 @ F2 ) @ Xs ) ) ) ).

% filter_map
thf(fact_3592_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P2: A > $o,F2: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P2 @ F2 ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_3593_fold__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs: list @ A] :
      ( ( fold @ A @ B @ F2 @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( fold @ A @ B @ F2 @ Xs ) @ ( F2 @ X ) ) ) ).

% fold_Cons
thf(fact_3594_fold__commute__apply,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H2: B > C,G: A > B > B,F2: A > C > C,S3: B] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H2 @ ( G @ X3 ) )
            = ( comp @ C @ C @ B @ ( F2 @ X3 ) @ H2 ) ) )
     => ( ( H2 @ ( fold @ A @ B @ G @ Xs @ S3 ) )
        = ( fold @ A @ C @ F2 @ Xs @ ( H2 @ S3 ) ) ) ) ).

% fold_commute_apply
thf(fact_3595_fold__commute,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H2: B > C,G: A > B > B,F2: A > C > C] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H2 @ ( G @ X3 ) )
            = ( comp @ C @ C @ B @ ( F2 @ X3 ) @ H2 ) ) )
     => ( ( comp @ B @ C @ B @ H2 @ ( fold @ A @ B @ G @ Xs ) )
        = ( comp @ C @ C @ B @ ( fold @ A @ C @ F2 @ Xs ) @ H2 ) ) ) ).

% fold_commute
thf(fact_3596_remdups__adj_Oelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( nil @ A ) ) )
       => ( ! [X3: A] :
              ( ( X
                = ( cons @ A @ X3 @ ( nil @ A ) ) )
             => ( Y
               != ( cons @ A @ X3 @ ( nil @ A ) ) ) )
         => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
               => ~ ( ( ( X3 = Y3 )
                     => ( Y
                        = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs2 ) ) ) )
                    & ( ( X3 != Y3 )
                     => ( Y
                        = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_3597_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_3598_rotate__add,axiom,
    ! [A: $tType,M2: nat,N: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M2 @ N ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M2 ) @ ( rotate @ A @ N ) ) ) ).

% rotate_add
thf(fact_3599_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_3600_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_3601_fold__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G: B > A > A,F2: C > B,Xs: list @ C] :
      ( ( fold @ B @ A @ G @ ( map @ C @ B @ F2 @ Xs ) )
      = ( fold @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F2 ) @ Xs ) ) ).

% fold_map
thf(fact_3602_listrel__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4
        @ ( product_Sigma @ A @ A @ A5
          @ ^ [Uu2: A] : A5 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R4 )
        @ ( product_Sigma @ ( list @ A ) @ ( list @ A ) @ ( lists @ A @ A5 )
          @ ^ [Uu2: list @ A] : ( lists @ A @ A5 ) ) ) ) ).

% listrel_subset
thf(fact_3603_foldr__conv__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F3: B > A > A,Xs4: list @ B] : ( fold @ B @ A @ F3 @ ( rev @ B @ Xs4 ) ) ) ) ).

% foldr_conv_fold
thf(fact_3604_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A,X: B,Y: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( ( member2 @ B @ X @ S )
       => ( ( member2 @ B @ Y @ S )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_3605_union__set__fold,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
      = ( fold @ A @ ( set @ A ) @ ( insert3 @ A ) @ Xs @ A5 ) ) ).

% union_set_fold
thf(fact_3606_rev__conv__fold,axiom,
    ! [A: $tType] :
      ( ( rev @ A )
      = ( ^ [Xs4: list @ A] : ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs4 @ ( nil @ A ) ) ) ) ).

% rev_conv_fold
thf(fact_3607_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P2: A > $o,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( takeWhile @ A @ P2 @ Xs ) @ Ys )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ A @ $o @ ( product_prod @ A @ B ) @ P2 @ ( product_fst @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_fst
thf(fact_3608_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,P2: B > $o,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( takeWhile @ B @ P2 @ Ys ) )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ B @ $o @ ( product_prod @ A @ B ) @ P2 @ ( product_snd @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_snd
thf(fact_3609_fold__Cons__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs )
      = ( append @ A @ ( rev @ A @ Xs ) ) ) ).

% fold_Cons_rev
thf(fact_3610_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Y: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X = Y ) @ ( nil @ A ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_3611_fold__rev,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X3: A,Y3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ Y3 ) @ ( F2 @ X3 ) )
              = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) ) ) )
     => ( ( fold @ A @ B @ F2 @ ( rev @ A @ Xs ) )
        = ( fold @ A @ B @ F2 @ Xs ) ) ) ).

% fold_rev
thf(fact_3612_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( map @ A @ B @ F2 @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_3613_List_Ounion__def,axiom,
    ! [A: $tType] :
      ( ( union @ A )
      = ( fold @ A @ ( list @ A ) @ ( insert @ A ) ) ) ).

% List.union_def
thf(fact_3614_foldr__fold,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X3: A,Y3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ Y3 ) @ ( F2 @ X3 ) )
              = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) ) ) ) )
     => ( ( foldr @ A @ B @ F2 @ Xs )
        = ( fold @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_fold
thf(fact_3615_fold__remove1__split,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B,X: A] :
      ( ! [X3: A,Y3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y3 ) )
              = ( comp @ B @ B @ B @ ( F2 @ Y3 ) @ ( F2 @ X3 ) ) ) ) )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( fold @ A @ B @ F2 @ Xs )
          = ( comp @ B @ B @ B @ ( fold @ A @ B @ F2 @ ( remove1 @ A @ X @ Xs ) ) @ ( F2 @ X ) ) ) ) ) ).

% fold_remove1_split
thf(fact_3616_Restr__trancl__mono,axiom,
    ! [A: $tType,V2: A,W: A,E4: set @ ( product_prod @ A @ A ),U3: set @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V2 @ W )
        @ ( transitive_trancl @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E4
            @ ( product_Sigma @ A @ A @ U3
              @ ^ [Uu2: A] : U3 ) ) ) )
     => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V2 @ W ) @ ( transitive_trancl @ A @ E4 ) ) ) ).

% Restr_trancl_mono
thf(fact_3617_set__zip__cart,axiom,
    ! [B: $tType,A: $tType,X: product_prod @ A @ B,L: list @ A,L6: list @ B] :
      ( ( member2 @ ( product_prod @ A @ B ) @ X @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ L @ L6 ) ) )
     => ( member2 @ ( product_prod @ A @ B ) @ X
        @ ( product_Sigma @ A @ B @ ( set2 @ A @ L )
          @ ^ [Uu2: A] : ( set2 @ B @ L6 ) ) ) ) ).

% set_zip_cart
thf(fact_3618_minus__set__fold,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( set2 @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A5 ) ) ).

% minus_set_fold
thf(fact_3619_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member2 @ ( set @ B ) @ X3 @ B4 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [A13: set @ B] :
                ( ( member2 @ ( set @ B ) @ A13 @ B4 )
               => ! [A24: set @ B] :
                    ( ( member2 @ ( set @ B ) @ A24 @ B4 )
                   => ( ( A13 != A24 )
                     => ! [X3: B] :
                          ( ( member2 @ B @ X3 @ A13 )
                         => ( ( member2 @ B @ X3 @ A24 )
                           => ( ( G @ X3 )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B4 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ B4 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_3620_sort__conv__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Xs )
          = ( fold @ A @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2 )
            @ Xs
            @ ( nil @ A ) ) ) ) ).

% sort_conv_fold
thf(fact_3621_remdups__adj__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X @ ( nil @ A ) )
        @ ^ [Y2: A,Xs4: list @ A] : ( if @ ( list @ A ) @ ( X = Y2 ) @ ( cons @ A @ Y2 @ Xs4 ) @ ( cons @ A @ X @ ( cons @ A @ Y2 @ Xs4 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_3622_inter__coset__fold,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( coset @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A5 ) ) ).

% inter_coset_fold
thf(fact_3623_fold__append__concat__rev,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( fold @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss2 )
      = ( append @ A @ ( concat @ A @ ( rev @ ( list @ A ) @ Xss2 ) ) ) ) ).

% fold_append_concat_rev
thf(fact_3624_Sup__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Sup_Sup @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% Sup_set_fold
thf(fact_3625_Inf__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Inf_Inf @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ ( top_top @ A ) ) ) ) ).

% Inf_set_fold
thf(fact_3626_remdups__adj__adjacent,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I2 )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I2 ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_3627_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_3628_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
     => ( Xs
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X ) ) ) ).

% remdups_adj_singleton
thf(fact_3629_Min_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic643756798350308766er_Min @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( ord_min @ A ) @ Xs @ X ) ) ) ).

% Min.set_eq_fold
thf(fact_3630_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_3631_remdups__adj__append_H,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ A ) )
        | ( ( last @ A @ Xs )
         != ( hd @ A @ Ys ) ) )
     => ( ( remdups_adj @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( remdups_adj @ A @ Xs ) @ ( remdups_adj @ A @ Ys ) ) ) ) ).

% remdups_adj_append'
thf(fact_3632_prod_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C5: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member2 @ ( set @ B ) @ X3 @ C5 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [X3: set @ B] :
                ( ( member2 @ ( set @ B ) @ X3 @ C5 )
               => ! [Xa3: set @ B] :
                    ( ( member2 @ ( set @ B ) @ Xa3 @ C5 )
                   => ( ( X3 != Xa3 )
                     => ( ( inf_inf @ ( set @ B ) @ X3 @ Xa3 )
                        = ( bot_bot @ ( set @ B ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C5 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ C5 ) ) ) ) ) ).

% prod.Union_disjoint
thf(fact_3633_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_3634_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_3635_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_3636_sort__key__conv__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
         => ( ( linorder_sort_key @ B @ A @ F2 @ Xs )
            = ( fold @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 ) @ Xs @ ( nil @ B ) ) ) ) ) ).

% sort_key_conv_fold
thf(fact_3637_subseqs__powset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( image2 @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
      = ( pow @ A @ ( set2 @ A @ Xs ) ) ) ).

% subseqs_powset
thf(fact_3638_sum_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C5: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member2 @ ( set @ B ) @ X3 @ C5 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [X3: set @ B] :
                ( ( member2 @ ( set @ B ) @ X3 @ C5 )
               => ! [Xa3: set @ B] :
                    ( ( member2 @ ( set @ B ) @ Xa3 @ C5 )
                   => ( ( X3 != Xa3 )
                     => ( ( inf_inf @ ( set @ B ) @ X3 @ Xa3 )
                        = ( bot_bot @ ( set @ B ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C5 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ C5 ) ) ) ) ) ).

% sum.Union_disjoint
thf(fact_3639_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert3 @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_3640_SUP__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Sup_Sup @ A @ ( image2 @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F2 ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% SUP_set_fold
thf(fact_3641_Times__Int__Times,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B4: set @ B,C5: set @ A,D2: set @ B] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu2: A] : B4 )
        @ ( product_Sigma @ A @ B @ C5
          @ ^ [Uu2: A] : D2 ) )
      = ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ A5 @ C5 )
        @ ^ [Uu2: A] : ( inf_inf @ ( set @ B ) @ B4 @ D2 ) ) ) ).

% Times_Int_Times
thf(fact_3642_Sigma__Int__distrib2,axiom,
    ! [B: $tType,A: $tType,I: set @ A,A5: A > ( set @ B ),B4: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ I
        @ ^ [I4: A] : ( inf_inf @ ( set @ B ) @ ( A5 @ I4 ) @ ( B4 @ I4 ) ) )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ A5 ) @ ( product_Sigma @ A @ B @ I @ B4 ) ) ) ).

% Sigma_Int_distrib2
thf(fact_3643_Times__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B4: set @ A,C5: set @ B] :
      ( ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        @ ^ [Uu2: A] : C5 )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu2: A] : C5 )
        @ ( product_Sigma @ A @ B @ B4
          @ ^ [Uu2: A] : C5 ) ) ) ).

% Times_Int_distrib1
thf(fact_3644_Restr__subset,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ B4
              @ ^ [Uu2: A] : B4 ) )
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% Restr_subset
thf(fact_3645_remdups__adj_Opelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ( ( Y
                    = ( cons @ A @ X3 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
           => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
                 => ( ( ( ( X3 = Y3 )
                       => ( Y
                          = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs2 ) ) ) )
                      & ( ( X3 != Y3 )
                       => ( Y
                          = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_3646_Sigma__Int__distrib1,axiom,
    ! [B: $tType,A: $tType,I: set @ A,J4: set @ A,C5: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( inf_inf @ ( set @ A ) @ I @ J4 ) @ C5 )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ C5 ) @ ( product_Sigma @ A @ B @ J4 @ C5 ) ) ) ).

% Sigma_Int_distrib1
thf(fact_3647_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys )
      = ( ? [F3: nat > nat] :
            ( ( order_mono @ nat @ nat @ F3 )
            & ( ( image2 @ nat @ nat @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I4 )
                  = ( nth @ A @ Ys @ ( F3 @ I4 ) ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I4 )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) )
                  = ( ( F3 @ I4 )
                    = ( F3 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_3648_Fpow__Pow__finite,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A10: set @ A] : ( inf_inf @ ( set @ ( set @ A ) ) @ ( pow @ A @ A10 ) @ ( collect @ ( set @ A ) @ ( finite_finite @ A ) ) ) ) ) ).

% Fpow_Pow_finite
thf(fact_3649_rtrancl__last__visit__node,axiom,
    ! [A: $tType,S3: A,S6: A,R: set @ ( product_prod @ A @ A ),Sh: A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S3 @ S6 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( ( S3 != Sh )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S3 @ S6 )
            @ ( transitive_rtrancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu2: A] : ( uminus_uminus @ ( set @ A ) @ ( insert3 @ A @ Sh @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) )
        | ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ S3 @ Sh ) @ ( transitive_rtrancl @ A @ R ) )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Sh @ S6 )
            @ ( transitive_rtrancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
                @ ( product_Sigma @ A @ A @ ( top_top @ ( set @ A ) )
                  @ ^ [Uu2: A] : ( uminus_uminus @ ( set @ A ) @ ( insert3 @ A @ Sh @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% rtrancl_last_visit_node
thf(fact_3650_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,G: C > B,A5: set @ A,B4: set @ C] :
          ( ( inj_on @ ( product_prod @ A @ C ) @ B
            @ ( product_case_prod @ A @ C @ B
              @ ^ [A4: A,B3: C] : ( times_times @ B @ ( F2 @ A4 ) @ ( G @ B3 ) ) )
            @ ( product_Sigma @ A @ C @ A5
              @ ^ [Uu2: A] : B4 ) )
         => ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B4 ) )
            = ( groups7311177749621191930dd_sum @ B @ B @ ( id @ B )
              @ ( collect @ B
                @ ^ [Uu2: B] :
                  ? [A4: A,B3: C] :
                    ( ( Uu2
                      = ( times_times @ B @ ( F2 @ A4 ) @ ( G @ B3 ) ) )
                    & ( member2 @ A @ A4 @ A5 )
                    & ( member2 @ C @ B3 @ B4 ) ) ) ) ) ) ) ).

% sum_mult_sum_if_inj
thf(fact_3651_list_Omap__id0,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A @ ( id @ A ) )
      = ( id @ ( list @ A ) ) ) ).

% list.map_id0
thf(fact_3652_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_3653_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list @ A,R4: set @ ( product_prod @ A @ A )] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) ) ).

% listrel_rtrancl_refl
thf(fact_3654_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R4 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_3655_listrel__rtrancl__eq__rtrancl__listrel1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) )
      = ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel_rtrancl_eq_rtrancl_listrel1
thf(fact_3656_max__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M2: A,N: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ M2 ) @ ( F2 @ N ) )
            = ( F2 @ ( ord_max @ A @ M2 @ N ) ) ) ) ) ).

% max_of_mono
thf(fact_3657_min__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M2: A,N: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ M2 ) @ ( F2 @ N ) )
            = ( F2 @ ( ord_min @ A @ M2 @ N ) ) ) ) ) ).

% min_of_mono
thf(fact_3658_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A3: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A3 ) ) ) ).

% mono_add
thf(fact_3659_list_Omap__id,axiom,
    ! [A: $tType,T3: list @ A] :
      ( ( map @ A @ A @ ( id @ A ) @ T3 )
      = T3 ) ).

% list.map_id
thf(fact_3660_List_Omap_Oidentity,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2 )
      = ( id @ ( list @ A ) ) ) ).

% List.map.identity
thf(fact_3661_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R4 ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_3662_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A5: A,B4: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A5 @ B4 ) ) @ ( inf_inf @ B @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) ) ) ) ).

% mono_inf
thf(fact_3663_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A5: A,B4: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) @ ( F2 @ ( sup_sup @ A @ A5 @ B4 ) ) ) ) ) ).

% mono_sup
thf(fact_3664_fold__Nil,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B] :
      ( ( fold @ A @ B @ F2 @ ( nil @ A ) )
      = ( id @ B ) ) ).

% fold_Nil
thf(fact_3665_fold__id,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = ( id @ B ) ) )
     => ( ( fold @ A @ B @ F2 @ Xs )
        = ( id @ B ) ) ) ).

% fold_id
thf(fact_3666_foldr__Nil,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B] :
      ( ( foldr @ A @ B @ F2 @ ( nil @ A ) )
      = ( id @ B ) ) ).

% foldr_Nil
thf(fact_3667_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),Zs: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ) ).

% listrel_rtrancl_trans
thf(fact_3668_fold__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P2: B > $o,Xs: list @ B] :
      ( ( fold @ B @ A @ F2 @ ( filter @ B @ P2 @ Xs ) )
      = ( fold @ B @ A
        @ ^ [X2: B] : ( if @ ( A > A ) @ ( P2 @ X2 ) @ ( F2 @ X2 ) @ ( id @ A ) )
        @ Xs ) ) ).

% fold_filter
thf(fact_3669_foldr__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P2: B > $o,Xs: list @ B] :
      ( ( foldr @ B @ A @ F2 @ ( filter @ B @ P2 @ Xs ) )
      = ( foldr @ B @ A
        @ ^ [X2: B] : ( if @ ( A > A ) @ ( P2 @ X2 ) @ ( F2 @ X2 ) @ ( id @ A ) )
        @ Xs ) ) ).

% foldr_filter
thf(fact_3670_Rings_Omono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A3 ) ) ) ) ).

% Rings.mono_mult
thf(fact_3671_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_3672_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) )
     => ( ( size_size @ ( list @ A ) @ X )
        = ( size_size @ ( list @ A ) @ Y ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_3673_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R4 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R4 ) ) ) ) ).

% listrel_reflcl_if_listrel1
thf(fact_3674_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ R4 ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ).

% rtrancl_listrel1_if_listrel
thf(fact_3675_Restr__rtrancl__mono,axiom,
    ! [A: $tType,V2: A,W: A,E4: set @ ( product_prod @ A @ A ),U3: set @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V2 @ W )
        @ ( transitive_rtrancl @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E4
            @ ( product_Sigma @ A @ A @ U3
              @ ^ [Uu2: A] : U3 ) ) ) )
     => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ V2 @ W ) @ ( transitive_rtrancl @ A @ E4 ) ) ) ).

% Restr_rtrancl_mono
thf(fact_3676_listrel__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R4 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel_subset_rtrancl_listrel1
thf(fact_3677_list_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R2: A > B > $o,A4: list @ A,B3: list @ B] :
          ? [Z3: list @ ( product_prod @ A @ B )] :
            ( ( member2 @ ( list @ ( product_prod @ A @ B ) ) @ Z3
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X2: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z3 )
              = A4 )
            & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z3 )
              = B3 ) ) ) ) ).

% list.in_rel
thf(fact_3678_INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ ( top_top @ A ) @ A5 ) ) ) ) ).

% INF_fold_inf
thf(fact_3679_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y2: A] : ( Y2 != X )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y2: A] : ( Y2 != X )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_3680_stable__sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord3483353639454293061rt_key @ B @ A )
        = ( ^ [Sk: ( B > A ) > ( list @ B ) > ( list @ B )] :
            ! [F3: B > A,Xs4: list @ B,K4: A] :
              ( ( filter @ B
                @ ^ [Y2: B] :
                    ( ( F3 @ Y2 )
                    = K4 )
                @ ( Sk @ F3 @ Xs4 ) )
              = ( filter @ B
                @ ^ [Y2: B] :
                    ( ( F3 @ Y2 )
                    = K4 )
                @ Xs4 ) ) ) ) ) ).

% stable_sort_key_def
thf(fact_3681_dropWhile__idem,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( dropWhile @ A @ P2 @ ( dropWhile @ A @ P2 @ Xs ) )
      = ( dropWhile @ A @ P2 @ Xs ) ) ).

% dropWhile_idem
thf(fact_3682_list__all2__Nil,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ ( nil @ A ) @ Ys )
      = ( Ys
        = ( nil @ B ) ) ) ).

% list_all2_Nil
thf(fact_3683_list__all2__Nil2,axiom,
    ! [B: $tType,A: $tType,P2: A > B > $o,Xs: list @ A] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ ( nil @ B ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_all2_Nil2
thf(fact_3684_list__all2__rev,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys ) )
      = ( list_all2 @ A @ B @ P2 @ Xs @ Ys ) ) ).

% list_all2_rev
thf(fact_3685_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P2 @ Xs )
        = ( nil @ A ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X2 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_3686_dropWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P2 @ X )
       => ( ( dropWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P2 @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append1
thf(fact_3687_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P2 @ X3 ) )
     => ( ( dropWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
        = ( dropWhile @ A @ P2 @ Ys ) ) ) ).

% dropWhile_append2
thf(fact_3688_dropWhile__replicate,axiom,
    ! [A: $tType,P2: A > $o,X: A,N: nat] :
      ( ( ( P2 @ X )
       => ( ( dropWhile @ A @ P2 @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ~ ( P2 @ X )
       => ( ( dropWhile @ A @ P2 @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) ) ) ).

% dropWhile_replicate
thf(fact_3689_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P2 @ Xs ) @ ( dropWhile @ A @ P2 @ Xs ) )
      = Xs ) ).

% takeWhile_dropWhile_id
thf(fact_3690_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( dropWhile @ A @ P2 @ Xs ) ) ) ).

% distinct_dropWhile
thf(fact_3691_List_Ofilter__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( filter @ A )
      @ ( filter @ B ) ) ).

% List.filter_transfer
thf(fact_3692_tl__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( tl @ A ) @ ( tl @ B ) ) ).

% tl_transfer
thf(fact_3693_concat__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( concat @ A ) @ ( concat @ B ) ) ).

% concat_transfer
thf(fact_3694_butlast__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( butlast @ A ) @ ( butlast @ B ) ) ).

% butlast_transfer
thf(fact_3695_rotate__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( rotate @ A )
      @ ( rotate @ B ) ) ).

% rotate_transfer
thf(fact_3696_subseqs__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( subseqs @ A ) @ ( subseqs @ B ) ) ).

% subseqs_transfer
thf(fact_3697_product__lists__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( product_lists @ A ) @ ( product_lists @ B ) ) ).

% product_lists_transfer
thf(fact_3698_dropWhile__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( dropWhile @ A )
      @ ( dropWhile @ B ) ) ).

% dropWhile_transfer
thf(fact_3699_list_Orel__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: A > C > $o,Sc: B > D > $o] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( ( list @ C ) > ( list @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( ( list @ B ) > $o ) @ ( ( list @ D ) > $o ) @ ( list_all2 @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( list @ B ) @ ( list @ D ) @ $o @ $o @ ( list_all2 @ B @ D @ Sc )
          @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
      @ ( list_all2 @ A @ B )
      @ ( list_all2 @ C @ D ) ) ).

% list.rel_transfer
thf(fact_3700_length__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ nat @ nat @ ( list_all2 @ A @ B @ A5 )
      @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
      @ ( size_size @ ( list @ A ) )
      @ ( size_size @ ( list @ B ) ) ) ).

% length_transfer
thf(fact_3701_take__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( take @ A )
      @ ( take @ B ) ) ).

% take_transfer
thf(fact_3702_list__update__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( nat > A > ( list @ A ) ) @ ( nat > B > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 )
      @ ( bNF_rel_fun @ nat @ nat @ ( A > ( list @ A ) ) @ ( B > ( list @ B ) )
        @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
        @ ( bNF_rel_fun @ A @ B @ ( list @ A ) @ ( list @ B ) @ A5 @ ( list_all2 @ A @ B @ A5 ) ) )
      @ ( list_update @ A )
      @ ( list_update @ B ) ) ).

% list_update_transfer
thf(fact_3703_drop__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( drop @ A )
      @ ( drop @ B ) ) ).

% drop_transfer
thf(fact_3704_append__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( append @ A ) @ ( append @ B ) ) ).

% append_transfer
thf(fact_3705_rev__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( rev @ A ) @ ( rev @ B ) ) ).

% rev_transfer
thf(fact_3706_list_Octr__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] : ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ R @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R ) @ ( list_all2 @ A @ B @ R ) ) @ ( cons @ A ) @ ( cons @ B ) ) ).

% list.ctr_transfer(2)
thf(fact_3707_list_Ocase__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: C > D > $o,R: A > B > $o] : ( bNF_rel_fun @ C @ D @ ( ( A > ( list @ A ) > C ) > ( list @ A ) > C ) @ ( ( B > ( list @ B ) > D ) > ( list @ B ) > D ) @ S @ ( bNF_rel_fun @ ( A > ( list @ A ) > C ) @ ( B > ( list @ B ) > D ) @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ R @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R ) @ S ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R ) @ S ) ) @ ( case_list @ C @ A ) @ ( case_list @ D @ B ) ) ).

% list.case_transfer
thf(fact_3708_list_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X: list @ A,Ya: list @ A,Y: list @ B,Xa: list @ B,R: A > B > $o,Ra: A > B > $o] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z4: A,Yb: B] :
              ( ( member2 @ A @ Z4 @ ( set2 @ A @ Ya ) )
             => ( ( member2 @ B @ Yb @ ( set2 @ B @ Xa ) )
               => ( ( R @ Z4 @ Yb )
                  = ( Ra @ Z4 @ Yb ) ) ) )
         => ( ( list_all2 @ A @ B @ R @ X @ Y )
            = ( list_all2 @ A @ B @ Ra @ Ya @ Xa ) ) ) ) ) ).

% list.rel_cong
thf(fact_3709_list_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: list @ A,Y: list @ B,Ra: A > B > $o] :
      ( ( list_all2 @ A @ B @ R @ X @ Y )
     => ( ! [Z4: A,Yb: B] :
            ( ( member2 @ A @ Z4 @ ( set2 @ A @ X ) )
           => ( ( member2 @ B @ Yb @ ( set2 @ B @ Y ) )
             => ( ( R @ Z4 @ Yb )
               => ( Ra @ Z4 @ Yb ) ) ) )
       => ( list_all2 @ A @ B @ Ra @ X @ Y ) ) ) ).

% list.rel_mono_strong
thf(fact_3710_list_Orel__refl__strong,axiom,
    ! [A: $tType,X: list @ A,Ra: A > A > $o] :
      ( ! [Z4: A] :
          ( ( member2 @ A @ Z4 @ ( set2 @ A @ X ) )
         => ( Ra @ Z4 @ Z4 ) )
     => ( list_all2 @ A @ A @ Ra @ X @ X ) ) ).

% list.rel_refl_strong
thf(fact_3711_list__all2__same,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ( list_all2 @ A @ A @ P2 @ Xs @ Xs )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X2 @ X2 ) ) ) ) ).

% list_all2_same
thf(fact_3712_dropWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P2: A > $o,Q2: A > $o] :
      ( ( L = K )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ L ) )
           => ( ( P2 @ X3 )
              = ( Q2 @ X3 ) ) )
       => ( ( dropWhile @ A @ P2 @ L )
          = ( dropWhile @ A @ Q2 @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_3713_set__dropWhileD,axiom,
    ! [A: $tType,X: A,P2: A > $o,Xs: list @ A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( dropWhile @ A @ P2 @ Xs ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_dropWhileD
thf(fact_3714_list_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R @ Ra )
     => ( ord_less_eq @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( list_all2 @ A @ B @ R ) @ ( list_all2 @ A @ B @ Ra ) ) ) ).

% list.rel_mono
thf(fact_3715_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P2: A > $o] :
      ( ( dropWhile @ A @ P2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_3716_list_Orel__inject_I2_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X21: A,X22: list @ A,Y21: B,Y22: list @ B] :
      ( ( list_all2 @ A @ B @ R @ ( cons @ A @ X21 @ X22 ) @ ( cons @ B @ Y21 @ Y22 ) )
      = ( ( R @ X21 @ Y21 )
        & ( list_all2 @ A @ B @ R @ X22 @ Y22 ) ) ) ).

% list.rel_inject(2)
thf(fact_3717_list_Orel__intros_I2_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X21: A,Y21: B,X22: list @ A,Y22: list @ B] :
      ( ( R @ X21 @ Y21 )
     => ( ( list_all2 @ A @ B @ R @ X22 @ Y22 )
       => ( list_all2 @ A @ B @ R @ ( cons @ A @ X21 @ X22 ) @ ( cons @ B @ Y21 @ Y22 ) ) ) ) ).

% list.rel_intros(2)
thf(fact_3718_list__all2__Cons,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,X: A,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) )
      = ( ( P2 @ X @ Y )
        & ( list_all2 @ A @ B @ P2 @ Xs @ Ys ) ) ) ).

% list_all2_Cons
thf(fact_3719_list__all2__Cons1,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( ? [Z3: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z3 @ Zs3 ) )
            & ( P2 @ X @ Z3 )
            & ( list_all2 @ A @ B @ P2 @ Xs @ Zs3 ) ) ) ) ).

% list_all2_Cons1
thf(fact_3720_list__all2__Cons2,axiom,
    ! [B: $tType,A: $tType,P2: A > B > $o,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ ( cons @ B @ Y @ Ys ) )
      = ( ? [Z3: A,Zs3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Z3 @ Zs3 ) )
            & ( P2 @ Z3 @ Y )
            & ( list_all2 @ A @ B @ P2 @ Zs3 @ Ys ) ) ) ) ).

% list_all2_Cons2
thf(fact_3721_list__all2__appendI,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,A3: list @ A,B2: list @ B,C2: list @ A,D3: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ A3 @ B2 )
     => ( ( list_all2 @ A @ B @ P2 @ C2 @ D3 )
       => ( list_all2 @ A @ B @ P2 @ ( append @ A @ A3 @ C2 ) @ ( append @ B @ B2 @ D3 ) ) ) ) ).

% list_all2_appendI
thf(fact_3722_list_Octr__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] : ( list_all2 @ A @ B @ R @ ( nil @ A ) @ ( nil @ B ) ) ).

% list.ctr_transfer(1)
thf(fact_3723_list_Orel__eq,axiom,
    ! [A: $tType] :
      ( ( list_all2 @ A @ A
        @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
      = ( ^ [Y4: list @ A,Z5: list @ A] : ( Y4 = Z5 ) ) ) ).

% list.rel_eq
thf(fact_3724_list_Orel__refl,axiom,
    ! [B: $tType,Ra: B > B > $o,X: list @ B] :
      ( ! [X3: B] : ( Ra @ X3 @ X3 )
     => ( list_all2 @ B @ B @ Ra @ X @ X ) ) ).

% list.rel_refl
thf(fact_3725_list__all2__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y4: list @ A,Z5: list @ A] : ( Y4 = Z5 ) )
      = ( list_all2 @ A @ A
        @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) ) ) ).

% list_all2_eq
thf(fact_3726_list__all2__mono,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,Q2: A > B > $o] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( ! [Xs2: A,Ys3: B] :
            ( ( P2 @ Xs2 @ Ys3 )
           => ( Q2 @ Xs2 @ Ys3 ) )
       => ( list_all2 @ A @ B @ Q2 @ Xs @ Ys ) ) ) ).

% list_all2_mono
thf(fact_3727_list__all2__refl,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ! [X3: A] : ( P2 @ X3 @ X3 )
     => ( list_all2 @ A @ A @ P2 @ Xs @ Xs ) ) ).

% list_all2_refl
thf(fact_3728_list__all2__trans,axiom,
    ! [B: $tType,A: $tType,C: $tType,P1: A > B > $o,P22: B > C > $o,P32: A > C > $o,As2: list @ A,Bs: list @ B,Cs: list @ C] :
      ( ! [A6: A,B5: B,C4: C] :
          ( ( P1 @ A6 @ B5 )
         => ( ( P22 @ B5 @ C4 )
           => ( P32 @ A6 @ C4 ) ) )
     => ( ( list_all2 @ A @ B @ P1 @ As2 @ Bs )
       => ( ( list_all2 @ B @ C @ P22 @ Bs @ Cs )
         => ( list_all2 @ A @ C @ P32 @ As2 @ Cs ) ) ) ) ).

% list_all2_trans
thf(fact_3729_list__all2__antisym,axiom,
    ! [A: $tType,P2: A > A > $o,Q2: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ! [X3: A,Y3: A] :
          ( ( P2 @ X3 @ Y3 )
         => ( ( Q2 @ Y3 @ X3 )
           => ( X3 = Y3 ) ) )
     => ( ( list_all2 @ A @ A @ P2 @ Xs @ Ys )
       => ( ( list_all2 @ A @ A @ Q2 @ Ys @ Xs )
         => ( Xs = Ys ) ) ) ) ).

% list_all2_antisym
thf(fact_3730_list__all2__lengthD,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% list_all2_lengthD
thf(fact_3731_list__all2__update__cong,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,X: A,Y: B,I2: nat] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( ( P2 @ X @ Y )
       => ( list_all2 @ A @ B @ P2 @ ( list_update @ A @ Xs @ I2 @ X ) @ ( list_update @ B @ Ys @ I2 @ Y ) ) ) ) ).

% list_all2_update_cong
thf(fact_3732_list__all2__dropI,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,N: nat] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( list_all2 @ A @ B @ P2 @ ( drop @ A @ N @ Xs ) @ ( drop @ B @ N @ Ys ) ) ) ).

% list_all2_dropI
thf(fact_3733_list__all2__rev1,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ ( rev @ A @ Xs ) @ Ys )
      = ( list_all2 @ A @ B @ P2 @ Xs @ ( rev @ B @ Ys ) ) ) ).

% list_all2_rev1
thf(fact_3734_list__all2__takeI,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,N: nat] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( list_all2 @ A @ B @ P2 @ ( take @ A @ N @ Xs ) @ ( take @ B @ N @ Ys ) ) ) ).

% list_all2_takeI
thf(fact_3735_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( ( P2 @ X )
       => ( ( dropWhile @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( dropWhile @ A @ P2 @ Xs ) ) )
      & ( ~ ( P2 @ X )
       => ( ( dropWhile @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_3736_rotate1__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( rotate1 @ A ) @ ( rotate1 @ B ) ) ).

% rotate1_transfer
thf(fact_3737_splice__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( splice @ A ) @ ( splice @ B ) ) ).

% splice_transfer
thf(fact_3738_replicate__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( A > ( list @ A ) ) @ ( B > ( list @ B ) )
      @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 )
      @ ( bNF_rel_fun @ A @ B @ ( list @ A ) @ ( list @ B ) @ A5 @ ( list_all2 @ A @ B @ A5 ) )
      @ ( replicate @ A )
      @ ( replicate @ B ) ) ).

% replicate_transfer
thf(fact_3739_list__ex__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > $o ) @ ( ( list @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( list_ex @ A )
      @ ( list_ex @ B ) ) ).

% list_ex_transfer
thf(fact_3740_takeWhile__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( takeWhile @ A )
      @ ( takeWhile @ B ) ) ).

% takeWhile_transfer
thf(fact_3741_list_Odisc__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R )
      @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
      @ ^ [List3: list @ A] :
          ( List3
         != ( nil @ A ) )
      @ ^ [List3: list @ B] :
          ( List3
         != ( nil @ B ) ) ) ).

% list.disc_transfer(2)
thf(fact_3742_list_Odisc__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R )
      @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
      @ ^ [List3: list @ A] :
          ( List3
          = ( nil @ A ) )
      @ ^ [List3: list @ B] :
          ( List3
          = ( nil @ B ) ) ) ).

% list.disc_transfer(1)
thf(fact_3743_list__all2__map2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P2: A > B > $o,As2: list @ A,F2: C > B,Bs: list @ C] :
      ( ( list_all2 @ A @ B @ P2 @ As2 @ ( map @ C @ B @ F2 @ Bs ) )
      = ( list_all2 @ A @ C
        @ ^ [X2: A,Y2: C] : ( P2 @ X2 @ ( F2 @ Y2 ) )
        @ As2
        @ Bs ) ) ).

% list_all2_map2
thf(fact_3744_list__all2__map1,axiom,
    ! [C: $tType,A: $tType,B: $tType,P2: A > B > $o,F2: C > A,As2: list @ C,Bs: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ ( map @ C @ A @ F2 @ As2 ) @ Bs )
      = ( list_all2 @ C @ B
        @ ^ [X2: C] : ( P2 @ ( F2 @ X2 ) )
        @ As2
        @ Bs ) ) ).

% list_all2_map1
thf(fact_3745_list_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I2: A > C,X: list @ A,Y: list @ B] :
      ( ( list_all2 @ C @ B @ Sb @ ( map @ A @ C @ I2 @ X ) @ Y )
      = ( list_all2 @ A @ B
        @ ^ [X2: A] : ( Sb @ ( I2 @ X2 ) )
        @ X
        @ Y ) ) ).

% list.rel_map(1)
thf(fact_3746_list_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X: list @ A,G: B > C,Y: list @ B] :
      ( ( list_all2 @ A @ C @ Sa @ X @ ( map @ B @ C @ G @ Y ) )
      = ( list_all2 @ A @ B
        @ ^ [X2: A,Y2: B] : ( Sa @ X2 @ ( G @ Y2 ) )
        @ X
        @ Y ) ) ).

% list.rel_map(2)
thf(fact_3747_null__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
      @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
      @ ( null @ A )
      @ ( null @ B ) ) ).

% null_transfer
thf(fact_3748_list_Orel__distinct_I2_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,Y21: A,Y22: list @ A] :
      ~ ( list_all2 @ A @ B @ R @ ( cons @ A @ Y21 @ Y22 ) @ ( nil @ B ) ) ).

% list.rel_distinct(2)
thf(fact_3749_list_Orel__distinct_I1_J,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,Y21: B,Y22: list @ B] :
      ~ ( list_all2 @ A @ B @ R @ ( nil @ A ) @ ( cons @ B @ Y21 @ Y22 ) ) ).

% list.rel_distinct(1)
thf(fact_3750_list_Orel__cases,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,A3: list @ A,B2: list @ B] :
      ( ( list_all2 @ A @ B @ R @ A3 @ B2 )
     => ( ( ( A3
            = ( nil @ A ) )
         => ( B2
           != ( nil @ B ) ) )
       => ~ ! [X1: A,X23: list @ A] :
              ( ( A3
                = ( cons @ A @ X1 @ X23 ) )
             => ! [Y1: B,Y23: list @ B] :
                  ( ( B2
                    = ( cons @ B @ Y1 @ Y23 ) )
                 => ( ( R @ X1 @ Y1 )
                   => ~ ( list_all2 @ A @ B @ R @ X23 @ Y23 ) ) ) ) ) ) ).

% list.rel_cases
thf(fact_3751_list_Orel__induct,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: list @ A,Y: list @ B,Q2: ( list @ A ) > ( list @ B ) > $o] :
      ( ( list_all2 @ A @ B @ R @ X @ Y )
     => ( ( Q2 @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [A21: A,A222: list @ A,B21: B,B22: list @ B] :
              ( ( R @ A21 @ B21 )
             => ( ( Q2 @ A222 @ B22 )
               => ( Q2 @ ( cons @ A @ A21 @ A222 ) @ ( cons @ B @ B21 @ B22 ) ) ) )
         => ( Q2 @ X @ Y ) ) ) ) ).

% list.rel_induct
thf(fact_3752_List_Olist__all2__induct,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,R: ( list @ A ) > ( list @ B ) > $o] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( ( R @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Xs2: list @ A,Y3: B,Ys3: list @ B] :
              ( ( P2 @ X3 @ Y3 )
             => ( ( list_all2 @ A @ B @ P2 @ Xs2 @ Ys3 )
               => ( ( R @ Xs2 @ Ys3 )
                 => ( R @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys3 ) ) ) ) )
         => ( R @ Xs @ Ys ) ) ) ) ).

% List.list_all2_induct
thf(fact_3753_Misc_Olist__all2__induct,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,L: list @ A,L6: list @ B,Q2: ( list @ A ) > ( list @ B ) > $o] :
      ( ( list_all2 @ A @ B @ P2 @ L @ L6 )
     => ( ( Q2 @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,X8: B,Ls2: list @ A,Ls3: list @ B] :
              ( ( P2 @ X3 @ X8 )
             => ( ( list_all2 @ A @ B @ P2 @ Ls2 @ Ls3 )
               => ( ( Q2 @ Ls2 @ Ls3 )
                 => ( Q2 @ ( cons @ A @ X3 @ Ls2 ) @ ( cons @ B @ X8 @ Ls3 ) ) ) ) )
         => ( Q2 @ L @ L6 ) ) ) ) ).

% Misc.list_all2_induct
thf(fact_3754_list_Omap__transfer,axiom,
    ! [A: $tType,B: $tType,F10: $tType,E5: $tType,Rb: A > E5 > $o,Sd: B > F10 > $o] : ( bNF_rel_fun @ ( A > B ) @ ( E5 > F10 ) @ ( ( list @ A ) > ( list @ B ) ) @ ( ( list @ E5 ) > ( list @ F10 ) ) @ ( bNF_rel_fun @ A @ E5 @ B @ F10 @ Rb @ Sd ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ E5 ) @ ( list @ B ) @ ( list @ F10 ) @ ( list_all2 @ A @ E5 @ Rb ) @ ( list_all2 @ B @ F10 @ Sd ) ) @ ( map @ A @ B ) @ ( map @ E5 @ F10 ) ) ).

% list.map_transfer
thf(fact_3755_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A5: set @ A,B4: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) ) ) ).

% mono_Int
thf(fact_3756_list__all2__append2,axiom,
    ! [B: $tType,A: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ ( append @ B @ Ys @ Zs ) )
      = ( ? [Us2: list @ A,Vs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Us2 @ Vs2 ) )
            & ( ( size_size @ ( list @ A ) @ Us2 )
              = ( size_size @ ( list @ B ) @ Ys ) )
            & ( ( size_size @ ( list @ A ) @ Vs2 )
              = ( size_size @ ( list @ B ) @ Zs ) )
            & ( list_all2 @ A @ B @ P2 @ Us2 @ Ys )
            & ( list_all2 @ A @ B @ P2 @ Vs2 @ Zs ) ) ) ) ).

% list_all2_append2
thf(fact_3757_list__all2__append1,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ A,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P2 @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( ? [Us2: list @ B,Vs2: list @ B] :
            ( ( Zs
              = ( append @ B @ Us2 @ Vs2 ) )
            & ( ( size_size @ ( list @ B ) @ Us2 )
              = ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( size_size @ ( list @ B ) @ Vs2 )
              = ( size_size @ ( list @ A ) @ Ys ) )
            & ( list_all2 @ A @ B @ P2 @ Xs @ Us2 )
            & ( list_all2 @ A @ B @ P2 @ Ys @ Vs2 ) ) ) ) ).

% list_all2_append1
thf(fact_3758_list__all2__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P2: A > B > $o,Us: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( list_all2 @ A @ B @ P2 @ ( append @ A @ Xs @ Us ) @ ( append @ B @ Ys @ Vs ) )
        = ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
          & ( list_all2 @ A @ B @ P2 @ Us @ Vs ) ) ) ) ).

% list_all2_append
thf(fact_3759_dropWhile__append3,axiom,
    ! [A: $tType,P2: A > $o,Y: A,Xs: list @ A,Ys: list @ A] :
      ( ~ ( P2 @ Y )
     => ( ( dropWhile @ A @ P2 @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) )
        = ( append @ A @ ( dropWhile @ A @ P2 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ).

% dropWhile_append3
thf(fact_3760_length__dropWhile__le,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_3761_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P2: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P2 @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_3762_hd__dropWhile,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P2 @ Xs )
       != ( nil @ A ) )
     => ~ ( P2 @ ( hd @ A @ ( dropWhile @ A @ P2 @ Xs ) ) ) ) ).

% hd_dropWhile
thf(fact_3763_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P2 @ Xs )
        = Xs )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P2 @ ( hd @ A @ Xs ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_3764_dropWhile__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P2: A > $o] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P2 @ X )
       => ( ( last @ A @ ( dropWhile @ A @ P2 @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) ).

% dropWhile_last
thf(fact_3765_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P2: A > $o,F2: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P2 @ F2 ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_3766_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y2: A] : ( Y2 = X )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_3767_list__all2__nthD,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,P7: nat] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( ( ord_less @ nat @ P7 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P2 @ ( nth @ A @ Xs @ P7 ) @ ( nth @ B @ Ys @ P7 ) ) ) ) ).

% list_all2_nthD
thf(fact_3768_list__all2__nthD2,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,Xs: list @ A,Ys: list @ B,P7: nat] :
      ( ( list_all2 @ A @ B @ P2 @ Xs @ Ys )
     => ( ( ord_less @ nat @ P7 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( P2 @ ( nth @ A @ Xs @ P7 ) @ ( nth @ B @ Ys @ P7 ) ) ) ) ).

% list_all2_nthD2
thf(fact_3769_list__all2__all__nthI,axiom,
    ! [A: $tType,B: $tType,A3: list @ A,B2: list @ B,P2: A > B > $o] :
      ( ( ( size_size @ ( list @ A ) @ A3 )
        = ( size_size @ ( list @ B ) @ B2 ) )
     => ( ! [N4: nat] :
            ( ( ord_less @ nat @ N4 @ ( size_size @ ( list @ A ) @ A3 ) )
           => ( P2 @ ( nth @ A @ A3 @ N4 ) @ ( nth @ B @ B2 @ N4 ) ) )
       => ( list_all2 @ A @ B @ P2 @ A3 @ B2 ) ) ) ).

% list_all2_all_nthI
thf(fact_3770_list__all2__conv__all__nth,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P: A > B > $o,Xs4: list @ A,Ys4: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs4 )
              = ( size_size @ ( list @ B ) @ Ys4 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs4 ) )
               => ( P @ ( nth @ A @ Xs4 @ I4 ) @ ( nth @ B @ Ys4 @ I4 ) ) ) ) ) ) ).

% list_all2_conv_all_nth
thf(fact_3771_List_Ofold__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A5: A > C > $o,B4: B > D > $o] : ( bNF_rel_fun @ ( A > B > B ) @ ( C > D > D ) @ ( ( list @ A ) > B > B ) @ ( ( list @ C ) > D > D ) @ ( bNF_rel_fun @ A @ C @ ( B > B ) @ ( D > D ) @ A5 @ ( bNF_rel_fun @ B @ D @ B @ D @ B4 @ B4 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( B > B ) @ ( D > D ) @ ( list_all2 @ A @ C @ A5 ) @ ( bNF_rel_fun @ B @ D @ B @ D @ B4 @ B4 ) ) @ ( fold @ A @ B ) @ ( fold @ C @ D ) ) ).

% List.fold_transfer
thf(fact_3772_foldr__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A5: A > C > $o,B4: B > D > $o] : ( bNF_rel_fun @ ( A > B > B ) @ ( C > D > D ) @ ( ( list @ A ) > B > B ) @ ( ( list @ C ) > D > D ) @ ( bNF_rel_fun @ A @ C @ ( B > B ) @ ( D > D ) @ A5 @ ( bNF_rel_fun @ B @ D @ B @ D @ B4 @ B4 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( B > B ) @ ( D > D ) @ ( list_all2 @ A @ C @ A5 ) @ ( bNF_rel_fun @ B @ D @ B @ D @ B4 @ B4 ) ) @ ( foldr @ A @ B ) @ ( foldr @ C @ D ) ) ).

% foldr_transfer
thf(fact_3773_list_Orel__sel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R2: A > B > $o,A4: list @ A,B3: list @ B] :
            ( ( ( A4
                = ( nil @ A ) )
              = ( B3
                = ( nil @ B ) ) )
            & ( ( A4
               != ( nil @ A ) )
             => ( ( B3
                 != ( nil @ B ) )
               => ( ( R2 @ ( hd @ A @ A4 ) @ ( hd @ B @ B3 ) )
                  & ( list_all2 @ A @ B @ R2 @ ( tl @ A @ A4 ) @ ( tl @ B @ B3 ) ) ) ) ) ) ) ) ).

% list.rel_sel
thf(fact_3774_inf__Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B4: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A5 ) @ B4 )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ B4 @ A5 ) ) ) ) ).

% inf_Inf_fold_inf
thf(fact_3775_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( dropWhile @ A @ P2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ( Xs
          = ( append @ A @ ( takeWhile @ A @ P2 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) )
        & ~ ( P2 @ Y ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_3776_takeWhile__eq__filter,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ ( dropWhile @ A @ P2 @ Xs ) ) )
         => ~ ( P2 @ X3 ) )
     => ( ( takeWhile @ A @ P2 @ Xs )
        = ( filter @ A @ P2 @ Xs ) ) ) ).

% takeWhile_eq_filter
thf(fact_3777_dropWhile__eq__drop,axiom,
    ! [A: $tType] :
      ( ( dropWhile @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] : ( drop @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs4 ) ) @ Xs4 ) ) ) ).

% dropWhile_eq_drop
thf(fact_3778_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X3 ) )
       => ( ( dropWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
          = ( dropWhile @ A @ P2 @ Ys ) ) )
      & ( ~ ! [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
             => ( P2 @ X4 ) )
       => ( ( dropWhile @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P2 @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append
thf(fact_3779_product__lists__set,axiom,
    ! [A: $tType,Xss2: list @ ( list @ A )] :
      ( ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss2 ) )
      = ( collect @ ( list @ A )
        @ ^ [Xs4: list @ A] :
            ( list_all2 @ A @ ( list @ A )
            @ ^ [X2: A,Ys4: list @ A] : ( member2 @ A @ X2 @ ( set2 @ A @ Ys4 ) )
            @ Xs4
            @ Xss2 ) ) ) ).

% product_lists_set
thf(fact_3780_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_3781_list__all2I,axiom,
    ! [A: $tType,B: $tType,A3: list @ A,B2: list @ B,P2: A > B > $o] :
      ( ! [X3: product_prod @ A @ B] :
          ( ( member2 @ ( product_prod @ A @ B ) @ X3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ A3 @ B2 ) ) )
         => ( product_case_prod @ A @ B @ $o @ P2 @ X3 ) )
     => ( ( ( size_size @ ( list @ A ) @ A3 )
          = ( size_size @ ( list @ B ) @ B2 ) )
       => ( list_all2 @ A @ B @ P2 @ A3 @ B2 ) ) ) ).

% list_all2I
thf(fact_3782_Inf__fold__inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( complete_Inf_Inf @ A @ A5 )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ A5 ) ) ) ) ).

% Inf_fold_inf
thf(fact_3783_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G2 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_3784_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X12: list @ A,X24: list @ A] :
          ( ? [Y2: A,Ys4: list @ A] :
              ( ( X12
                = ( nil @ A ) )
              & ( X24
                = ( cons @ A @ Y2 @ Ys4 ) ) )
          | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
              ( ( X12
                = ( cons @ A @ X2 @ Xs4 ) )
              & ( X24
                = ( cons @ A @ Y2 @ Ys4 ) )
              & ( Less @ X2 @ Y2 ) )
          | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
              ( ( X12
                = ( cons @ A @ X2 @ Xs4 ) )
              & ( X24
                = ( cons @ A @ Y2 @ Ys4 ) )
              & ~ ( Less @ X2 @ Y2 )
              & ~ ( Less @ Y2 @ X2 )
              & ( P5 @ Xs4 @ Ys4 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_3785_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] : ( X2 = Y )
            @ Ys ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_3786_remdups__adj__append_H_H,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( remdups_adj @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( remdups_adj @ A @ Xs )
          @ ( remdups_adj @ A
            @ ( dropWhile @ A
              @ ^ [Y2: A] :
                  ( Y2
                  = ( last @ A @ Xs ) )
              @ Ys ) ) ) ) ) ).

% remdups_adj_append''
thf(fact_3787_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] :
                ( X2
                = ( hd @ A @ Ys ) )
            @ ( tl @ A @ Ys ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_3788_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X12: list @ A,X24: list @ A] :
            ( ? [Y2: A,Ys4: list @ A] :
                ( ( X12
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y2 @ Ys4 ) ) )
            | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                ( ( X12
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( X24
                  = ( cons @ A @ Y2 @ Ys4 ) )
                & ( ord_less @ A @ X2 @ Y2 ) )
            | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                ( ( X12
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( X24
                  = ( cons @ A @ Y2 @ Ys4 ) )
                & ~ ( ord_less @ A @ X2 @ Y2 )
                & ~ ( ord_less @ A @ Y2 @ X2 )
                & ( P5 @ Xs4 @ Ys4 ) ) ) ) ) ).

% lexordp.mono
thf(fact_3789_stable__sort__key__sort__key,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ( linord3483353639454293061rt_key @ A @ B @ ( linorder_sort_key @ A @ B ) ) ) ).

% stable_sort_key_sort_key
thf(fact_3790_inf__INF__fold__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B4: A,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( inf_inf @ A @ B4 @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A5 ) ) )
            = ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ B4 @ A5 ) ) ) ) ).

% inf_INF_fold_inf
thf(fact_3791_list__all2__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P: A > B > $o,Xs4: list @ A,Ys4: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs4 )
              = ( size_size @ ( list @ B ) @ Ys4 ) )
            & ! [X2: product_prod @ A @ B] :
                ( ( member2 @ ( product_prod @ A @ B ) @ X2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs4 @ Ys4 ) ) )
               => ( product_case_prod @ A @ B @ $o @ P @ X2 ) ) ) ) ) ).

% list_all2_iff
thf(fact_3792_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P2: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P2 @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P2 @ Xs ) @ J )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P2 @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_3793_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A5: A > B > $o,B4: C > D > $o] :
          ( ( A5 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B4 @ A5 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A5 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B4 ) @ A5 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_3794_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y2: A] : ( Y2 != X )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y2: A] : ( Y2 != X )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_3795_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S: set @ A,F2: A > B > B,A5: set @ A,B4: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ S )
         => ( ( finite_finite @ A @ A5 )
           => ( ( finite_finite @ A @ B4 )
             => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
                  = ( finite_fold @ A @ B @ F2 @ ( finite_fold @ A @ B @ F2 @ Z2 @ A5 ) @ B4 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_3796_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_mult @ B )
        & ( monoid_mult @ A ) )
     => ! [A5: A > B > $o] :
          ( ( A5 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A5 ) @ A5 @ ( groups5270119922927024881d_list @ A ) @ ( groups5270119922927024881d_list @ B ) ) ) ) ) ).

% prod_list_transfer
thf(fact_3797_comp__fun__idem__on_Ofold__set__fold,axiom,
    ! [A: $tType,B: $tType,S: set @ A,F2: A > B > B,Xs: list @ A,Y: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ S )
       => ( ( finite_fold @ A @ B @ F2 @ Y @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ B @ F2 @ Xs @ Y ) ) ) ) ).

% comp_fun_idem_on.fold_set_fold
thf(fact_3798_comp__fun__commute__on_Ofold__set__fold__remdups,axiom,
    ! [A: $tType,B: $tType,S: set @ A,F2: A > B > B,Xs: list @ A,Y: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ S )
       => ( ( finite_fold @ A @ B @ F2 @ Y @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ B @ F2 @ ( remdups @ A @ Xs ) @ Y ) ) ) ) ).

% comp_fun_commute_on.fold_set_fold_remdups
thf(fact_3799_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( times_times @ A @ X @ ( groups5270119922927024881d_list @ A @ Xs ) ) ) ) ).

% prod_list.Cons
thf(fact_3800_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A @ ( nil @ A ) )
        = ( one_one @ A ) ) ) ).

% prod_list.Nil
thf(fact_3801_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( times_times @ A @ ( groups5270119922927024881d_list @ A @ Xs ) @ ( groups5270119922927024881d_list @ A @ Ys ) ) ) ) ).

% prod_list.append
thf(fact_3802_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( ^ [Xs4: list @ A] : ( foldr @ A @ A @ ( times_times @ A ) @ Xs4 @ ( one_one @ A ) ) ) ) ) ).

% prod_list.eq_foldr
thf(fact_3803_list_Orec__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: C > D > $o,R: A > B > $o] : ( bNF_rel_fun @ C @ D @ ( ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) @ ( ( B > ( list @ B ) > D > D ) > ( list @ B ) > D ) @ S @ ( bNF_rel_fun @ ( A > ( list @ A ) > C > C ) @ ( B > ( list @ B ) > D > D ) @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > C > C ) @ ( ( list @ B ) > D > D ) @ R @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( C > C ) @ ( D > D ) @ ( list_all2 @ A @ B @ R ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S @ S ) ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R ) @ S ) ) @ ( rec_list @ C @ A ) @ ( rec_list @ D @ B ) ) ).

% list.rec_transfer
thf(fact_3804_foldl__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,B4: A > C > $o,A5: B > D > $o] : ( bNF_rel_fun @ ( A > B > A ) @ ( C > D > C ) @ ( A > ( list @ B ) > A ) @ ( C > ( list @ D ) > C ) @ ( bNF_rel_fun @ A @ C @ ( B > A ) @ ( D > C ) @ B4 @ ( bNF_rel_fun @ B @ D @ A @ C @ A5 @ B4 ) ) @ ( bNF_rel_fun @ A @ C @ ( ( list @ B ) > A ) @ ( ( list @ D ) > C ) @ B4 @ ( bNF_rel_fun @ ( list @ B ) @ ( list @ D ) @ A @ C @ ( list_all2 @ B @ D @ A5 ) @ B4 ) ) @ ( foldl @ A @ B ) @ ( foldl @ C @ D ) ) ).

% foldl_transfer
thf(fact_3805_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( ^ [A10: set @ A] : ( if @ A @ ( finite_finite @ A @ A10 ) @ ( finite_fold @ A @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ A10 ) @ ( one_one @ A ) ) ) ) ) ).

% Gcd_fin.eq_fold
thf(fact_3806_card__length__sum__list,axiom,
    ! [M2: nat,N2: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L3: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L3 )
                = M2 )
              & ( ( groups8242544230860333062m_list @ nat @ L3 )
                = N2 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ M2 ) @ ( one_one @ nat ) ) @ N2 ) ) ).

% card_length_sum_list
thf(fact_3807_foldl__append,axiom,
    ! [A: $tType,B: $tType,F2: A > B > A,A3: A,Xs: list @ B,Ys: list @ B] :
      ( ( foldl @ A @ B @ F2 @ A3 @ ( append @ B @ Xs @ Ys ) )
      = ( foldl @ A @ B @ F2 @ ( foldl @ A @ B @ F2 @ A3 @ Xs ) @ Ys ) ) ).

% foldl_append
thf(fact_3808_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_3809_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_fin.infinite
thf(fact_3810_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Gcd_fin @ A @ A5 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Gcd_fin @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Gcd_fin_iff
thf(fact_3811_foldl__cong,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: A,L: list @ B,K: list @ B,F2: A > B > A,G: A > B > A] :
      ( ( A3 = B2 )
     => ( ( L = K )
       => ( ! [A6: A,X3: B] :
              ( ( member2 @ B @ X3 @ ( set2 @ B @ L ) )
             => ( ( F2 @ A6 @ X3 )
                = ( G @ A6 @ X3 ) ) )
         => ( ( foldl @ A @ B @ F2 @ A3 @ L )
            = ( foldl @ A @ B @ G @ B2 @ K ) ) ) ) ) ).

% foldl_cong
thf(fact_3812_foldl__Nil,axiom,
    ! [A: $tType,B: $tType,F2: B > A > B,A3: B] :
      ( ( foldl @ B @ A @ F2 @ A3 @ ( nil @ A ) )
      = A3 ) ).

% foldl_Nil
thf(fact_3813_foldl__Cons,axiom,
    ! [B: $tType,A: $tType,F2: B > A > B,A3: B,X: A,Xs: list @ A] :
      ( ( foldl @ B @ A @ F2 @ A3 @ ( cons @ A @ X @ Xs ) )
      = ( foldl @ B @ A @ F2 @ ( F2 @ A3 @ X ) @ Xs ) ) ).

% foldl_Cons
thf(fact_3814_foldl__map,axiom,
    ! [A: $tType,B: $tType,C: $tType,G: A > B > A,A3: A,F2: C > B,Xs: list @ C] :
      ( ( foldl @ A @ B @ G @ A3 @ ( map @ C @ B @ F2 @ Xs ) )
      = ( foldl @ A @ C
        @ ^ [A4: A,X2: C] : ( G @ A4 @ ( F2 @ X2 ) )
        @ A3
        @ Xs ) ) ).

% foldl_map
thf(fact_3815_foldl__conv__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,S4: A,Xs4: list @ B] :
            ( fold @ B @ A
            @ ^ [X2: B,T2: A] : ( F3 @ T2 @ X2 )
            @ Xs4
            @ S4 ) ) ) ).

% foldl_conv_fold
thf(fact_3816_list_Osimps_I7_J,axiom,
    ! [C: $tType,A: $tType,F1: C,F22: A > ( list @ A ) > C > C,X21: A,X22: list @ A] :
      ( ( rec_list @ C @ A @ F1 @ F22 @ ( cons @ A @ X21 @ X22 ) )
      = ( F22 @ X21 @ X22 @ ( rec_list @ C @ A @ F1 @ F22 @ X22 ) ) ) ).

% list.simps(7)
thf(fact_3817_list_Osimps_I6_J,axiom,
    ! [A: $tType,C: $tType,F1: C,F22: A > ( list @ A ) > C > C] :
      ( ( rec_list @ C @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(6)
thf(fact_3818_foldl__conc__empty__eq,axiom,
    ! [A: $tType,I2: list @ A,Ww: list @ ( list @ A )] :
      ( ( foldl @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ I2 @ Ww )
      = ( append @ A @ I2 @ ( foldl @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ ( nil @ A ) @ Ww ) ) ) ).

% foldl_conc_empty_eq
thf(fact_3819_foldl__absorb1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Zs: list @ A] :
          ( ( times_times @ A @ X @ ( foldl @ A @ A @ ( times_times @ A ) @ ( one_one @ A ) @ Zs ) )
          = ( foldl @ A @ A @ ( times_times @ A ) @ X @ Zs ) ) ) ).

% foldl_absorb1
thf(fact_3820_foldl__snd__zip,axiom,
    ! [B: $tType,C: $tType,A: $tType,Ys: list @ A,Xs: list @ B,F2: C > A > C,B2: C] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ B ) @ Xs ) )
     => ( ( foldl @ C @ ( product_prod @ B @ A )
          @ ^ [B3: C] :
              ( product_case_prod @ B @ A @ C
              @ ^ [X2: B] : ( F2 @ B3 ) )
          @ B2
          @ ( zip @ B @ A @ Xs @ Ys ) )
        = ( foldl @ C @ A @ F2 @ B2 @ Ys ) ) ) ).

% foldl_snd_zip
thf(fact_3821_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_3822_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_3823_rec__list__Nil__imp,axiom,
    ! [A: $tType,B: $tType,F2: ( list @ A ) > B,F1: B,F22: A > ( list @ A ) > B > B] :
      ( ( F2
        = ( rec_list @ B @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( nil @ A ) )
        = F1 ) ) ).

% rec_list_Nil_imp
thf(fact_3824_foldr__conv__foldl,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F3: B > A > A,Xs4: list @ B,A4: A] :
            ( foldl @ A @ B
            @ ^ [X2: A,Y2: B] : ( F3 @ Y2 @ X2 )
            @ A4
            @ ( rev @ B @ Xs4 ) ) ) ) ).

% foldr_conv_foldl
thf(fact_3825_foldl__conv__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,A4: A,Xs4: list @ B] :
            ( foldr @ B @ A
            @ ^ [X2: B,Y2: A] : ( F3 @ Y2 @ X2 )
            @ ( rev @ B @ Xs4 )
            @ A4 ) ) ) ).

% foldl_conv_foldr
thf(fact_3826_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_3827_foldl__rule__aux__P,axiom,
    ! [Sigma: $tType,A: $tType,I: Sigma > ( list @ A ) > $o,Sigma_0: Sigma,L0: list @ A,F2: Sigma > A > Sigma,P2: Sigma > $o] :
      ( ( I @ Sigma_0 @ L0 )
     => ( ! [L1: list @ A,L2: list @ A,X3: A,Sigma2: Sigma] :
            ( ( L0
              = ( append @ A @ L1 @ ( cons @ A @ X3 @ L2 ) ) )
           => ( ( I @ Sigma2 @ ( cons @ A @ X3 @ L2 ) )
             => ( I @ ( F2 @ Sigma2 @ X3 ) @ L2 ) ) )
       => ( ! [Sigma2: Sigma] :
              ( ( I @ Sigma2 @ ( nil @ A ) )
             => ( P2 @ Sigma2 ) )
         => ( P2 @ ( foldl @ Sigma @ A @ F2 @ Sigma_0 @ L0 ) ) ) ) ) ).

% foldl_rule_aux_P
thf(fact_3828_foldl__rule__aux,axiom,
    ! [Sigma: $tType,A: $tType,I: Sigma > ( list @ A ) > $o,Sigma_0: Sigma,L0: list @ A,F2: Sigma > A > Sigma] :
      ( ( I @ Sigma_0 @ L0 )
     => ( ! [L1: list @ A,L2: list @ A,X3: A,Sigma2: Sigma] :
            ( ( L0
              = ( append @ A @ L1 @ ( cons @ A @ X3 @ L2 ) ) )
           => ( ( I @ Sigma2 @ ( cons @ A @ X3 @ L2 ) )
             => ( I @ ( F2 @ Sigma2 @ X3 ) @ L2 ) ) )
       => ( I @ ( foldl @ Sigma @ A @ F2 @ Sigma_0 @ L0 ) @ ( nil @ A ) ) ) ) ).

% foldl_rule_aux
thf(fact_3829_foldl__rule__P,axiom,
    ! [Sigma: $tType,A: $tType,I: Sigma > ( list @ A ) > ( list @ A ) > $o,Sigma_0: Sigma,L0: list @ A,F2: Sigma > A > Sigma,P2: Sigma > $o] :
      ( ( I @ Sigma_0 @ ( nil @ A ) @ L0 )
     => ( ! [L1: list @ A,L2: list @ A,X3: A,Sigma2: Sigma] :
            ( ( L0
              = ( append @ A @ L1 @ ( cons @ A @ X3 @ L2 ) ) )
           => ( ( I @ Sigma2 @ L1 @ ( cons @ A @ X3 @ L2 ) )
             => ( I @ ( F2 @ Sigma2 @ X3 ) @ ( append @ A @ L1 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) @ L2 ) ) )
       => ( ! [Sigma2: Sigma] :
              ( ( I @ Sigma2 @ L0 @ ( nil @ A ) )
             => ( P2 @ Sigma2 ) )
         => ( P2 @ ( foldl @ Sigma @ A @ F2 @ Sigma_0 @ L0 ) ) ) ) ) ).

% foldl_rule_P
thf(fact_3830_foldl__rule,axiom,
    ! [Sigma: $tType,A: $tType,I: Sigma > ( list @ A ) > ( list @ A ) > $o,Sigma_0: Sigma,L0: list @ A,F2: Sigma > A > Sigma] :
      ( ( I @ Sigma_0 @ ( nil @ A ) @ L0 )
     => ( ! [L1: list @ A,L2: list @ A,X3: A,Sigma2: Sigma] :
            ( ( L0
              = ( append @ A @ L1 @ ( cons @ A @ X3 @ L2 ) ) )
           => ( ( I @ Sigma2 @ L1 @ ( cons @ A @ X3 @ L2 ) )
             => ( I @ ( F2 @ Sigma2 @ X3 ) @ ( append @ A @ L1 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) @ L2 ) ) )
       => ( I @ ( foldl @ Sigma @ A @ F2 @ Sigma_0 @ L0 ) @ L0 @ ( nil @ A ) ) ) ) ).

% foldl_rule
thf(fact_3831_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X3: A] :
                ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_3832_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R4: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X2: C] : R4
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R4 ) ) ) ).

% sum_list_triv
thf(fact_3833_map__by__foldl,axiom,
    ! [B: $tType,A: $tType,F2: A > B,L: list @ A] :
      ( ( foldl @ ( list @ B ) @ A
        @ ^ [L3: list @ B,X2: A] : ( append @ B @ L3 @ ( cons @ B @ ( F2 @ X2 ) @ ( nil @ B ) ) )
        @ ( nil @ B )
        @ L )
      = ( map @ A @ B @ F2 @ L ) ) ).

% map_by_foldl
thf(fact_3834_list_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: C,Ga: B > ( list @ B ) > C > C,F2: A > B] :
      ( ( comp @ ( list @ B ) @ C @ ( list @ A ) @ ( rec_list @ C @ B @ G @ Ga ) @ ( map @ A @ B @ F2 ) )
      = ( rec_list @ C @ A @ G
        @ ^ [X2: A,Xa4: list @ A] : ( Ga @ ( F2 @ X2 ) @ ( map @ A @ B @ F2 @ Xa4 ) ) ) ) ).

% list.rec_o_map
thf(fact_3835_card__length__sum__list__rec,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M2 )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L3: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L3 )
                  = M2 )
                & ( ( groups8242544230860333062m_list @ nat @ L3 )
                  = N2 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L3: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L3 )
                    = ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L3 )
                    = N2 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L3: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L3 )
                    = M2 )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L3 ) @ ( one_one @ nat ) )
                    = N2 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_3836_set__rec,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( rec_list @ ( set @ A ) @ A @ ( bot_bot @ ( set @ A ) )
        @ ^ [X2: A,Uu2: list @ A] : ( insert3 @ A @ X2 ) ) ) ).

% set_rec
thf(fact_3837_map__rec,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map @ B @ A )
      = ( ^ [F3: B > A] :
            ( rec_list @ ( list @ A ) @ B @ ( nil @ A )
            @ ^ [X2: B,Uu2: list @ B] : ( cons @ A @ ( F3 @ X2 ) ) ) ) ) ).

% map_rec
thf(fact_3838_list__all__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > $o ) @ ( ( list @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( list_all @ A )
      @ ( list_all @ B ) ) ).

% list_all_transfer
thf(fact_3839_list_Opred__transfer,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > $o ) @ ( ( list @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R )
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( list_all @ A )
      @ ( list_all @ B ) ) ).

% list.pred_transfer
thf(fact_3840_image__split__eq__Sigma,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: C > A,G: C > B,A5: set @ C] :
      ( ( image2 @ C @ ( product_prod @ A @ B )
        @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ A5 )
      = ( product_Sigma @ A @ B @ ( image2 @ C @ A @ F2 @ A5 )
        @ ^ [X2: A] : ( image2 @ C @ B @ G @ ( inf_inf @ ( set @ C ) @ ( vimage @ C @ A @ F2 @ ( insert3 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ A5 ) ) ) ) ).

% image_split_eq_Sigma
thf(fact_3841_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_3842_vimage__Int,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ B,B4: set @ B] :
      ( ( vimage @ A @ B @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A5 ) @ ( vimage @ A @ B @ F2 @ B4 ) ) ) ).

% vimage_Int
thf(fact_3843_list_Opred__inject_I2_J,axiom,
    ! [A: $tType,P2: A > $o,A3: A,Aa2: list @ A] :
      ( ( list_all @ A @ P2 @ ( cons @ A @ A3 @ Aa2 ) )
      = ( ( P2 @ A3 )
        & ( list_all @ A @ P2 @ Aa2 ) ) ) ).

% list.pred_inject(2)
thf(fact_3844_list__all__simps_I1_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( list_all @ A @ P2 @ ( cons @ A @ X @ Xs ) )
      = ( ( P2 @ X )
        & ( list_all @ A @ P2 @ Xs ) ) ) ).

% list_all_simps(1)
thf(fact_3845_list__all__simps_I2_J,axiom,
    ! [A: $tType,P2: A > $o] : ( list_all @ A @ P2 @ ( nil @ A ) ) ).

% list_all_simps(2)
thf(fact_3846_list__all__append,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( list_all @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
      = ( ( list_all @ A @ P2 @ Xs )
        & ( list_all @ A @ P2 @ Ys ) ) ) ).

% list_all_append
thf(fact_3847_list__all__rev,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( list_all @ A @ P2 @ ( rev @ A @ Xs ) )
      = ( list_all @ A @ P2 @ Xs ) ) ).

% list_all_rev
thf(fact_3848_image__vimage__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ A] :
      ( ( image2 @ B @ A @ F2 @ ( vimage @ B @ A @ F2 @ A5 ) )
      = ( inf_inf @ ( set @ A ) @ A5 @ ( image2 @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ).

% image_vimage_eq
thf(fact_3849_list__ex1__simps_I2_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( list_ex1 @ A @ P2 @ ( cons @ A @ X @ Xs ) )
      = ( ( ( P2 @ X )
         => ( list_all @ A
            @ ^ [Y2: A] :
                ( ~ ( P2 @ Y2 )
                | ( X = Y2 ) )
            @ Xs ) )
        & ( ~ ( P2 @ X )
         => ( list_ex1 @ A @ P2 @ Xs ) ) ) ) ).

% list_ex1_simps(2)
thf(fact_3850_list_Opred__inject_I1_J,axiom,
    ! [A: $tType,P2: A > $o] : ( list_all @ A @ P2 @ ( nil @ A ) ) ).

% list.pred_inject(1)
thf(fact_3851_list_Opred__mono__strong,axiom,
    ! [A: $tType,P2: A > $o,X: list @ A,Pa: A > $o] :
      ( ( list_all @ A @ P2 @ X )
     => ( ! [Z4: A] :
            ( ( member2 @ A @ Z4 @ ( set2 @ A @ X ) )
           => ( ( P2 @ Z4 )
             => ( Pa @ Z4 ) ) )
       => ( list_all @ A @ Pa @ X ) ) ) ).

% list.pred_mono_strong
thf(fact_3852_list__all__cong,axiom,
    ! [A: $tType,X: list @ A,Ya: list @ A,P2: A > $o,Pa: A > $o] :
      ( ( X = Ya )
     => ( ! [Z4: A] :
            ( ( member2 @ A @ Z4 @ ( set2 @ A @ Ya ) )
           => ( ( P2 @ Z4 )
              = ( Pa @ Z4 ) ) )
       => ( ( list_all @ A @ P2 @ X )
          = ( list_all @ A @ Pa @ Ya ) ) ) ) ).

% list_all_cong
thf(fact_3853_vimage__inter__cong,axiom,
    ! [B: $tType,A: $tType,S: set @ A,F2: A > B,G: A > B,Y: set @ B] :
      ( ! [W3: A] :
          ( ( member2 @ A @ W3 @ S )
         => ( ( F2 @ W3 )
            = ( G @ W3 ) ) )
     => ( ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ Y ) @ S )
        = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ G @ Y ) @ S ) ) ) ).

% vimage_inter_cong
thf(fact_3854_Fract__of__int__eq,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( one_one @ int ) )
      = ( ring_1_of_int @ rat @ K ) ) ).

% Fract_of_int_eq
thf(fact_3855_list_Opred__mono,axiom,
    ! [A: $tType,P2: A > $o,Pa: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ P2 @ Pa )
     => ( ord_less_eq @ ( ( list @ A ) > $o ) @ ( list_all @ A @ P2 ) @ ( list_all @ A @ Pa ) ) ) ).

% list.pred_mono
thf(fact_3856_list_Opred__True,axiom,
    ! [A: $tType] :
      ( ( list_all @ A
        @ ^ [Uu2: A] : $true )
      = ( ^ [Uu2: list @ A] : $true ) ) ).

% list.pred_True
thf(fact_3857_list_Omap__cong__pred,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Ya: list @ A,F2: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ( list_all @ A
          @ ^ [Z3: A] :
              ( ( F2 @ Z3 )
              = ( G @ Z3 ) )
          @ Ya )
       => ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ G @ Ya ) ) ) ) ).

% list.map_cong_pred
thf(fact_3858_vimage__Times,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > ( product_prod @ B @ C ),A5: set @ B,B4: set @ C] :
      ( ( vimage @ A @ ( product_prod @ B @ C ) @ F2
        @ ( product_Sigma @ B @ C @ A5
          @ ^ [Uu2: B] : B4 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F2 ) @ A5 ) @ ( vimage @ A @ C @ ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F2 ) @ B4 ) ) ) ).

% vimage_Times
thf(fact_3859_eq__rat_I2_J,axiom,
    ! [A3: int] :
      ( ( fract @ A3 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_3860_Fract__of__nat__eq,axiom,
    ! [K: nat] :
      ( ( fract @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) )
      = ( semiring_1_of_nat @ rat @ K ) ) ).

% Fract_of_nat_eq
thf(fact_3861_One__rat__def,axiom,
    ( ( one_one @ rat )
    = ( fract @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% One_rat_def
thf(fact_3862_list_Opred__set,axiom,
    ! [A: $tType] :
      ( ( list_all @ A )
      = ( ^ [P: A > $o,X2: list @ A] :
          ! [Y2: A] :
            ( ( member2 @ A @ Y2 @ ( set2 @ A @ X2 ) )
           => ( P @ Y2 ) ) ) ) ).

% list.pred_set
thf(fact_3863_list__all__iff,axiom,
    ! [A: $tType] :
      ( ( list_all @ A )
      = ( ^ [P: A > $o,X2: list @ A] :
          ! [Y2: A] :
            ( ( member2 @ A @ Y2 @ ( set2 @ A @ X2 ) )
           => ( P @ Y2 ) ) ) ) ).

% list_all_iff
thf(fact_3864_Ball__set__list__all,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P2 @ X2 ) ) )
      = ( list_all @ A @ P2 @ Xs ) ) ).

% Ball_set_list_all
thf(fact_3865_list_Opred__map,axiom,
    ! [B: $tType,A: $tType,Q2: B > $o,F2: A > B,X: list @ A] :
      ( ( list_all @ B @ Q2 @ ( map @ A @ B @ F2 @ X ) )
      = ( list_all @ A @ ( comp @ B @ $o @ A @ Q2 @ F2 ) @ X ) ) ).

% list.pred_map
thf(fact_3866_finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F7: set @ A,H2: B > A,A5: set @ B] :
      ( ( finite_finite @ A @ F7 )
     => ( ( inj_on @ B @ A @ H2 @ A5 )
       => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ F7 ) @ A5 ) ) ) ) ).

% finite_vimage_IntI
thf(fact_3867_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_3868_Fract__add__one,axiom,
    ! [N: int,M2: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M2 @ N ) @ N )
        = ( plus_plus @ rat @ ( fract @ M2 @ N ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_3869_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_3870_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K4: num] : ( fract @ ( numeral_numeral @ int @ K4 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_3871_list__all__length,axiom,
    ! [A: $tType] :
      ( ( list_all @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] :
          ! [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs4 ) )
           => ( P @ ( nth @ A @ Xs4 @ N3 ) ) ) ) ) ).

% list_all_length
thf(fact_3872_finite__finite__vimage__IntI,axiom,
    ! [A: $tType,B: $tType,F7: set @ A,H2: B > A,A5: set @ B] :
      ( ( finite_finite @ A @ F7 )
     => ( ! [Y3: A] :
            ( ( member2 @ A @ Y3 @ F7 )
           => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ ( insert3 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A5 ) ) )
       => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H2 @ F7 ) @ A5 ) ) ) ) ).

% finite_finite_vimage_IntI
thf(fact_3873_one__le__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A3 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A3 ) ) ) ).

% one_le_Fract_iff
thf(fact_3874_Fract__le__one__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A3 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A3 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_3875_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X2: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X2
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X2 ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_3876_rat__floor__lemma,axiom,
    ! [A3: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A3 @ B2 ) ) @ ( fract @ A3 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A3 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_3877_one__less__Fract__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A3 @ B2 ) )
        = ( ord_less @ int @ B2 @ A3 ) ) ) ).

% one_less_Fract_iff
thf(fact_3878_Fract__less__one__iff,axiom,
    ! [B2: int,A3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A3 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A3 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_3879_rat__number__collapse_I5_J,axiom,
    ( ( fract @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) )
    = ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ).

% rat_number_collapse(5)
thf(fact_3880_inf__img__fin__domE_H,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( finite_finite @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
     => ( ~ ( finite_finite @ B @ A5 )
       => ~ ! [Y3: A] :
              ( ( member2 @ A @ Y3 @ ( image2 @ B @ A @ F2 @ A5 ) )
             => ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ ( insert3 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A5 ) ) ) ) ) ).

% inf_img_fin_domE'
thf(fact_3881_inf__img__fin__dom_H,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( finite_finite @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
     => ( ~ ( finite_finite @ B @ A5 )
       => ? [X3: A] :
            ( ( member2 @ A @ X3 @ ( image2 @ B @ A @ F2 @ A5 ) )
            & ~ ( finite_finite @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ ( insert3 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ A5 ) ) ) ) ) ).

% inf_img_fin_dom'
thf(fact_3882_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,D2: set @ A,A5: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ D2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A5 ) @ D2 ) ) @ ( finite_card @ B @ A5 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_3883_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
      @ pcr_rat )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_3884_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_3885_inv__image__partition,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P2 @ X3 ) )
     => ( ! [Y3: A] :
            ( ( member2 @ A @ Y3 @ ( set2 @ A @ Ys ) )
           => ~ ( P2 @ Y3 ) )
       => ( ( vimage @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( partition @ A @ P2 ) @ ( insert3 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) )
          = ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% inv_image_partition
thf(fact_3886_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,A3: B] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert3 @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) @ A5 )
        @ ( insert3 @ A
          @ ( the @ A
            @ ^ [X2: A] :
                ( ( member2 @ A @ X2 @ A5 )
                & ( ( F2 @ X2 )
                  = A3 ) ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_on_vimage_singleton
thf(fact_3887_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ~ ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ B2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ) ) ).

% euclidean_size_times_nonunit
thf(fact_3888_distinct__adj__append__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct_adj @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct_adj @ A @ Xs )
        & ( distinct_adj @ A @ Ys )
        & ( ( Xs
            = ( nil @ A ) )
          | ( Ys
            = ( nil @ A ) )
          | ( ( last @ A @ Xs )
           != ( hd @ A @ Ys ) ) ) ) ) ).

% distinct_adj_append_iff
thf(fact_3889_distinct__adj__Cons__Cons,axiom,
    ! [B: $tType,X: B,Y: B,Xs: list @ B] :
      ( ( distinct_adj @ B @ ( cons @ B @ X @ ( cons @ B @ Y @ Xs ) ) )
      = ( ( X != Y )
        & ( distinct_adj @ B @ ( cons @ B @ Y @ Xs ) ) ) ) ).

% distinct_adj_Cons_Cons
thf(fact_3890_distinct__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct_adj @ A @ ( rev @ A @ Xs ) )
      = ( distinct_adj @ A @ Xs ) ) ).

% distinct_adj_rev
thf(fact_3891_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) )
        = ( one_one @ nat ) ) ) ).

% euclidean_size_1
thf(fact_3892_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F3: A > $o,Xs4: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter @ A @ F3 @ Xs4 ) @ ( filter @ A @ ( comp @ $o @ $o @ A @ (~) @ F3 ) @ Xs4 ) ) ) ) ).

% partition_filter_conv
thf(fact_3893_distinct__adj__ConsD,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct_adj @ A @ ( cons @ A @ X @ Xs ) )
     => ( distinct_adj @ A @ Xs ) ) ).

% distinct_adj_ConsD
thf(fact_3894_distinct__adj__Nil,axiom,
    ! [A: $tType] : ( distinct_adj @ A @ ( nil @ A ) ) ).

% distinct_adj_Nil
thf(fact_3895_distinct__adj__mapD,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct_adj @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct_adj @ B @ Xs ) ) ).

% distinct_adj_mapD
thf(fact_3896_distinct__adj__appendD1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct_adj @ A @ ( append @ A @ Xs @ Ys ) )
     => ( distinct_adj @ A @ Xs ) ) ).

% distinct_adj_appendD1
thf(fact_3897_distinct__adj__appendD2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct_adj @ A @ ( append @ A @ Xs @ Ys ) )
     => ( distinct_adj @ A @ Ys ) ) ).

% distinct_adj_appendD2
thf(fact_3898_distinct__adj__altdef,axiom,
    ! [A: $tType] :
      ( ( distinct_adj @ A )
      = ( ^ [Xs4: list @ A] :
            ( ( remdups_adj @ A @ Xs4 )
            = Xs4 ) ) ) ).

% distinct_adj_altdef
thf(fact_3899_distinct__adj__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct_adj @ A @ ( remdups_adj @ A @ Xs ) ) ).

% distinct_adj_remdups_adj
thf(fact_3900_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ A3 )
            = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) ) ) ) ).

% euclidean_size_unit
thf(fact_3901_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A] :
          ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ nat @ ( euclid6346220572633701492n_size @ A @ A3 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% euclidean_size_mult
thf(fact_3902_distinct__adj__singleton,axiom,
    ! [B: $tType,X: B] : ( distinct_adj @ B @ ( cons @ B @ X @ ( nil @ B ) ) ) ).

% distinct_adj_singleton
thf(fact_3903_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
          = ( ( ( euclid6346220572633701492n_size @ A @ A3 )
              = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) )
            & ( A3
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_iff_euclidean_size
thf(fact_3904_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A3 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ B2 @ A3 ) ) ) ) ) ).

% size_mult_mono'
thf(fact_3905_size__mult__mono,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A3 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% size_mult_mono
thf(fact_3906_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% euclidean_size_times_unit
thf(fact_3907_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P2: A > $o] :
      ( ( partition @ A @ P2 @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_3908_partition__P,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Yes2: list @ A,No2: list @ A] :
      ( ( ( partition @ A @ P2 @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) )
     => ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ Yes2 ) )
           => ( P2 @ X4 ) )
        & ! [X4: A] :
            ( ( member2 @ A @ X4 @ ( set2 @ A @ No2 ) )
           => ~ ( P2 @ X4 ) ) ) ) ).

% partition_P
thf(fact_3909_distinct__adj__map__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( set2 @ A @ Xs ) )
     => ( ( distinct_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( distinct_adj @ A @ Xs ) ) ) ).

% distinct_adj_map_iff
thf(fact_3910_distinct__adj__mapI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( distinct_adj @ A @ Xs )
     => ( ( inj_on @ A @ B @ F2 @ ( set2 @ A @ Xs ) )
       => ( distinct_adj @ B @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% distinct_adj_mapI
thf(fact_3911_distinct__adj__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( ( X
           != ( hd @ A @ Xs ) )
          & ( distinct_adj @ A @ Xs ) ) ) ) ).

% distinct_adj_Cons
thf(fact_3912_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X2: rat] :
          ( the @ int
          @ ^ [Z3: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z3 ) @ X2 )
              & ( ord_less @ rat @ X2 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_3913_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( partition @ A @ P2 @ ( cons @ A @ X @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes3: list @ A,No3: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P2 @ X ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Yes3 ) @ No3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes3 @ ( cons @ A @ X @ No3 ) ) )
        @ ( partition @ A @ P2 @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_3914_partition__filter1,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P2 @ Xs ) )
      = ( filter @ A @ P2 @ Xs ) ) ).

% partition_filter1
thf(fact_3915_partition__filter2,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P2 @ Xs ) )
      = ( filter @ A @ ( comp @ $o @ $o @ A @ (~) @ P2 ) @ Xs ) ) ).

% partition_filter2
thf(fact_3916_partition__set,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Yes2: list @ A,No2: list @ A] :
      ( ( ( partition @ A @ P2 @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes2 ) @ ( set2 @ A @ No2 ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_3917_divmod__cases,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A3: A] :
          ( ( ( B2
             != ( zero_zero @ A ) )
           => ( ( ( modulo_modulo @ A @ A3 @ B2 )
                = ( zero_zero @ A ) )
             => ( A3
               != ( times_times @ A @ ( divide_divide @ A @ A3 @ B2 ) @ B2 ) ) ) )
         => ( ( ( B2
               != ( zero_zero @ A ) )
             => ! [Q7: A,R5: A] :
                  ( ( ( euclid7384307370059645450egment @ A @ R5 )
                    = ( euclid7384307370059645450egment @ A @ B2 ) )
                 => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R5 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
                   => ( ( R5
                       != ( zero_zero @ A ) )
                     => ( ( ( divide_divide @ A @ A3 @ B2 )
                          = Q7 )
                       => ( ( ( modulo_modulo @ A @ A3 @ B2 )
                            = R5 )
                         => ( A3
                           != ( plus_plus @ A @ ( times_times @ A @ Q7 @ B2 ) @ R5 ) ) ) ) ) ) ) )
           => ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divmod_cases
thf(fact_3918_mod__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R4: A,Q4: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R4 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R4 )
                  = A3 )
               => ( ( modulo_modulo @ A @ A3 @ B2 )
                  = R4 ) ) ) ) ) ) ).

% mod_eqI
thf(fact_3919_div__bounded,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R4: A,Q4: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R4 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R4 ) @ B2 )
                = Q4 ) ) ) ) ) ).

% div_bounded
thf(fact_3920_div__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R4: A,Q4: A,A3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R4 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q4 @ B2 ) @ R4 )
                  = A3 )
               => ( ( divide_divide @ A @ A3 @ B2 )
                  = Q4 ) ) ) ) ) ) ).

% div_eqI
thf(fact_3921_abs__division__segment,axiom,
    ! [K: int] :
      ( ( abs_abs @ int @ ( euclid7384307370059645450egment @ int @ K ) )
      = ( one_one @ int ) ) ).

% abs_division_segment
thf(fact_3922_division__segment__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid7384307370059645450egment @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% division_segment_1
thf(fact_3923_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [K: num] :
          ( ( euclid7384307370059645450egment @ A @ ( numeral_numeral @ A @ K ) )
          = ( one_one @ A ) ) ) ).

% division_segment_numeral
thf(fact_3924_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid7384307370059645450egment @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( one_one @ A ) ) ) ).

% division_segment_of_nat
thf(fact_3925_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A3 ) @ ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A3 ) ) )
          = A3 ) ) ).

% division_segment_euclidean_size
thf(fact_3926_division__segment__nat__def,axiom,
    ( ( euclid7384307370059645450egment @ nat )
    = ( ^ [N3: nat] : ( one_one @ nat ) ) ) ).

% division_segment_nat_def
thf(fact_3927_division__segment__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( euclid7384307370059645450egment @ A @ ( times_times @ A @ A3 @ B2 ) )
              = ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A3 ) @ ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ) ).

% division_segment_mult
thf(fact_3928_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A3: A] : ( dvd_dvd @ A @ ( euclid7384307370059645450egment @ A @ A3 ) @ ( one_one @ A ) ) ) ).

% is_unit_division_segment
thf(fact_3929_division__segment__int__def,axiom,
    ( ( euclid7384307370059645450egment @ int )
    = ( ^ [K4: int] : ( if @ int @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ K4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% division_segment_int_def
thf(fact_3930_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R4 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R4 @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_3931_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R4 ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R4 ) ) ) ).

% one_le_of_rat_iff
thf(fact_3932_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R4 ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R4 @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_3933_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R4: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R4 ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R4 ) ) ) ).

% one_less_of_rat_iff
thf(fact_3934_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: rat] :
          ( ( ( one_one @ A )
            = ( field_char_0_of_rat @ A @ A3 ) )
          = ( ( one_one @ rat )
            = A3 ) ) ) ).

% one_eq_of_rat_iff
thf(fact_3935_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: rat] :
          ( ( ( field_char_0_of_rat @ A @ A3 )
            = ( one_one @ A ) )
          = ( A3
            = ( one_one @ rat ) ) ) ) ).

% of_rat_eq_1_iff
thf(fact_3936_of__rat__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( one_one @ rat ) )
        = ( one_one @ A ) ) ) ).

% of_rat_1
thf(fact_3937_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% of_rat_neg_one
thf(fact_3938_of__rat__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A3: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( times_times @ rat @ A3 @ B2 ) )
          = ( times_times @ A @ ( field_char_0_of_rat @ A @ A3 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_mult
thf(fact_3939_listrel__Nil,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ B @ A )] :
      ( ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R4 ) @ ( insert3 @ ( list @ B ) @ ( nil @ B ) @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) )
      = ( insert3 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listrel_Nil
thf(fact_3940_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_3941_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X2: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X2 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_3942_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs4: list @ A,Ys4: list @ A] : ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs4 @ Ys4 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( ord_less @ A ) ) ) ) ) ) ) ) ).

% lexordp_conv_lexord
thf(fact_3943_lexordp__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A] :
          ~ ( ord_lexordp @ A @ Xs @ ( nil @ A ) ) ) ).

% lexordp_simps(2)
thf(fact_3944_lexordp__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Ys: list @ A] :
          ( ( ord_lexordp @ A @ ( nil @ A ) @ Ys )
          = ( ( Ys
             != ( nil @ A ) ) ) ) ) ).

% lexordp_simps(1)
thf(fact_3945_lexordp__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A,Y: A,Ys: list @ A] :
          ( ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp @ A @ Xs @ Ys ) ) ) ) ) ).

% lexordp_simps(3)
thf(fact_3946_Image__Id__on,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( image @ A @ A @ ( id_on @ A @ A5 ) @ B4 )
      = ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ).

% Image_Id_on
thf(fact_3947_lexordp__irreflexive_H,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Xs: list @ A] :
          ~ ( ord_lexordp @ A @ Xs @ Xs ) ) ).

% lexordp_irreflexive'
thf(fact_3948_lexordp__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
          | ( Xs = Ys )
          | ( ord_lexordp @ A @ Ys @ Xs ) ) ) ).

% lexordp_linear
thf(fact_3949_lexordp__trans,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A,Zs: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ( ord_lexordp @ A @ Ys @ Zs )
           => ( ord_lexordp @ A @ Xs @ Zs ) ) ) ) ).

% lexordp_trans
thf(fact_3950_lexordp__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ~ ( ord_lexordp @ A @ Ys @ Xs ) ) ) ).

% lexordp_antisym
thf(fact_3951_lexordp__irreflexive,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ~ ( ord_less @ A @ X3 @ X3 )
         => ~ ( ord_lexordp @ A @ Xs @ Xs ) ) ) ).

% lexordp_irreflexive
thf(fact_3952_lexordp__append__leftI,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Us: list @ A,Vs: list @ A,Xs: list @ A] :
          ( ( ord_lexordp @ A @ Us @ Vs )
         => ( ord_lexordp @ A @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) ) ) ) ).

% lexordp_append_leftI
thf(fact_3953_Image__Int__subset,axiom,
    ! [A: $tType,B: $tType,R: set @ ( product_prod @ B @ A ),A5: set @ B,B4: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ R @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ R @ A5 ) @ ( image @ B @ A @ R @ B4 ) ) ) ).

% Image_Int_subset
thf(fact_3954_lexordp_OCons__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys: list @ A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp @ A @ Xs @ Ys )
             => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ) ).

% lexordp.Cons_eq
thf(fact_3955_lexordp_OCons,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ).

% lexordp.Cons
thf(fact_3956_lexordp_ONil,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Y: A,Ys: list @ A] : ( ord_lexordp @ A @ ( nil @ A ) @ ( cons @ A @ Y @ Ys ) ) ) ).

% lexordp.Nil
thf(fact_3957_lexordp__append__leftD,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A,Us: list @ A,Vs: list @ A] :
          ( ( ord_lexordp @ A @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) )
         => ( ! [A6: A] :
                ~ ( ord_less @ A @ A6 @ A6 )
           => ( ord_lexordp @ A @ Us @ Vs ) ) ) ) ).

% lexordp_append_leftD
thf(fact_3958_lexordp__append__rightI,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Ys: list @ A,Xs: list @ A] :
          ( ( Ys
           != ( nil @ A ) )
         => ( ord_lexordp @ A @ Xs @ ( append @ A @ Xs @ Ys ) ) ) ) ).

% lexordp_append_rightI
thf(fact_3959_lexordp__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A,P2: ( list @ A ) > ( list @ A ) > $o] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ! [Y3: A,Ys3: list @ A] : ( P2 @ ( nil @ A ) @ ( cons @ A @ Y3 @ Ys3 ) )
           => ( ! [X3: A,Xs2: list @ A,Y3: A,Ys3: list @ A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys3 ) ) )
             => ( ! [X3: A,Xs2: list @ A,Ys3: list @ A] :
                    ( ( ord_lexordp @ A @ Xs2 @ Ys3 )
                   => ( ( P2 @ Xs2 @ Ys3 )
                     => ( P2 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ X3 @ Ys3 ) ) ) )
               => ( P2 @ Xs @ Ys ) ) ) ) ) ) ).

% lexordp_induct
thf(fact_3960_lexordp__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ! [Y3: A,Ys2: list @ A] :
                  ( Ys
                 != ( cons @ A @ Y3 @ Ys2 ) ) )
           => ( ! [X3: A] :
                  ( ? [Xs3: list @ A] :
                      ( Xs
                      = ( cons @ A @ X3 @ Xs3 ) )
                 => ! [Y3: A] :
                      ( ? [Ys2: list @ A] :
                          ( Ys
                          = ( cons @ A @ Y3 @ Ys2 ) )
                     => ~ ( ord_less @ A @ X3 @ Y3 ) ) )
             => ~ ! [X3: A,Xs3: list @ A] :
                    ( ( Xs
                      = ( cons @ A @ X3 @ Xs3 ) )
                   => ! [Ys2: list @ A] :
                        ( ( Ys
                          = ( cons @ A @ X3 @ Ys2 ) )
                       => ~ ( ord_lexordp @ A @ Xs3 @ Ys2 ) ) ) ) ) ) ) ).

% lexordp_cases
thf(fact_3961_lexordp_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [A12: list @ A,A23: list @ A] :
              ( ? [Y2: A,Ys4: list @ A] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A23
                    = ( cons @ A @ Y2 @ Ys4 ) ) )
              | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                  ( ( A12
                    = ( cons @ A @ X2 @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y2 @ Ys4 ) )
                  & ( ord_less @ A @ X2 @ Y2 ) )
              | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                  ( ( A12
                    = ( cons @ A @ X2 @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y2 @ Ys4 ) )
                  & ~ ( ord_less @ A @ X2 @ Y2 )
                  & ~ ( ord_less @ A @ Y2 @ X2 )
                  & ( ord_lexordp @ A @ Xs4 @ Ys4 ) ) ) ) ) ) ).

% lexordp.simps
thf(fact_3962_lexordp_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A1: list @ A,A22: list @ A] :
          ( ( ord_lexordp @ A @ A1 @ A22 )
         => ( ( ( A1
                = ( nil @ A ) )
             => ! [Y3: A,Ys3: list @ A] :
                  ( A22
                 != ( cons @ A @ Y3 @ Ys3 ) ) )
           => ( ! [X3: A] :
                  ( ? [Xs2: list @ A] :
                      ( A1
                      = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y3: A] :
                      ( ? [Ys3: list @ A] :
                          ( A22
                          = ( cons @ A @ Y3 @ Ys3 ) )
                     => ~ ( ord_less @ A @ X3 @ Y3 ) ) )
             => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                    ( ( A1
                      = ( cons @ A @ X3 @ Xs2 ) )
                   => ! [Ys3: list @ A] :
                        ( ( A22
                          = ( cons @ A @ Y3 @ Ys3 ) )
                       => ( ~ ( ord_less @ A @ X3 @ Y3 )
                         => ( ~ ( ord_less @ A @ Y3 @ X3 )
                           => ~ ( ord_lexordp @ A @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ) ).

% lexordp.cases
thf(fact_3963_lexordp__append__left__rightI,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Us: list @ A,Xs: list @ A,Ys: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( append @ A @ Us @ ( cons @ A @ X @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys ) ) ) ) ) ).

% lexordp_append_left_rightI
thf(fact_3964_lexordp__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs4: list @ A,Ys4: list @ A] :
              ( ? [X2: A,Vs2: list @ A] :
                  ( Ys4
                  = ( append @ A @ Xs4 @ ( cons @ A @ X2 @ Vs2 ) ) )
              | ? [Us2: list @ A,A4: A,B3: A,Vs2: list @ A,Ws3: list @ A] :
                  ( ( ord_less @ A @ A4 @ B3 )
                  & ( Xs4
                    = ( append @ A @ Us2 @ ( cons @ A @ A4 @ Vs2 ) ) )
                  & ( Ys4
                    = ( append @ A @ Us2 @ ( cons @ A @ B3 @ Ws3 ) ) ) ) ) ) ) ) ).

% lexordp_iff
thf(fact_3965_listrel__Cons,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ B @ A ),X: B,Xs: list @ B] :
      ( ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R4 ) @ ( insert3 @ ( list @ B ) @ ( cons @ B @ X @ Xs ) @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) )
      = ( set_Cons @ A @ ( image @ B @ A @ R4 @ ( insert3 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) @ ( image @ ( list @ B ) @ ( list @ A ) @ ( listrel @ B @ A @ R4 ) @ ( insert3 @ ( list @ B ) @ Xs @ ( bot_bot @ ( set @ ( list @ B ) ) ) ) ) ) ) ).

% listrel_Cons
thf(fact_3966_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_3967_Sigma__Image,axiom,
    ! [A: $tType,B: $tType,A5: set @ B,B4: B > ( set @ A ),X7: set @ B] :
      ( ( image @ B @ A @ ( product_Sigma @ B @ A @ A5 @ B4 ) @ X7 )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image2 @ B @ ( set @ A ) @ B4 @ ( inf_inf @ ( set @ B ) @ X7 @ A5 ) ) ) ) ).

% Sigma_Image
thf(fact_3968_trancl__restrict__reachable,axiom,
    ! [A: $tType,U: A,V2: A,E4: set @ ( product_prod @ A @ A ),S: set @ A] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V2 ) @ ( transitive_trancl @ A @ E4 ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ E4 @ S ) @ S )
       => ( ( member2 @ A @ U @ S )
         => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ U @ V2 )
            @ ( transitive_trancl @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ E4
                @ ( product_Sigma @ A @ A @ S
                  @ ^ [Uu2: A] : S ) ) ) ) ) ) ) ).

% trancl_restrict_reachable
thf(fact_3969_ord__class_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp @ A )
        = ( complete_lattice_lfp @ ( ( list @ A ) > ( list @ A ) > $o )
          @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X12: list @ A,X24: list @ A] :
              ( ? [Y2: A,Ys4: list @ A] :
                  ( ( X12
                    = ( nil @ A ) )
                  & ( X24
                    = ( cons @ A @ Y2 @ Ys4 ) ) )
              | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                  ( ( X12
                    = ( cons @ A @ X2 @ Xs4 ) )
                  & ( X24
                    = ( cons @ A @ Y2 @ Ys4 ) )
                  & ( ord_less @ A @ X2 @ Y2 ) )
              | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                  ( ( X12
                    = ( cons @ A @ X2 @ Xs4 ) )
                  & ( X24
                    = ( cons @ A @ Y2 @ Ys4 ) )
                  & ~ ( ord_less @ A @ X2 @ Y2 )
                  & ~ ( ord_less @ A @ Y2 @ X2 )
                  & ( P5 @ Xs4 @ Ys4 ) ) ) ) ) ) ).

% ord_class.lexordp_def
thf(fact_3970_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ) ).

% Gcd_fin_def
thf(fact_3971_strict__sorted__equal__Uniq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( uniq @ ( list @ A )
          @ ^ [Xs4: list @ A] :
              ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs4 )
              & ( ( set2 @ A @ Xs4 )
                = A5 ) ) ) ) ).

% strict_sorted_equal_Uniq
thf(fact_3972_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_3973_lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,P2: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P2 ) ) @ P2 )
           => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P2 ) ) ) ) ).

% lfp_induct
thf(fact_3974_def__lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: A,F2: A > A,P2: A] :
          ( ( A5
            = ( complete_lattice_lfp @ A @ F2 ) )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ A5 @ P2 ) ) @ P2 )
             => ( ord_less_eq @ A @ A5 @ P2 ) ) ) ) ) ).

% def_lfp_induct
thf(fact_3975_ord_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ A )
      = ( ^ [Less2: A > A > $o] :
            ( complete_lattice_lfp @ ( ( list @ A ) > ( list @ A ) > $o )
            @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X12: list @ A,X24: list @ A] :
                ( ? [Y2: A,Ys4: list @ A] :
                    ( ( X12
                      = ( nil @ A ) )
                    & ( X24
                      = ( cons @ A @ Y2 @ Ys4 ) ) )
                | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                    ( ( X12
                      = ( cons @ A @ X2 @ Xs4 ) )
                    & ( X24
                      = ( cons @ A @ Y2 @ Ys4 ) )
                    & ( Less2 @ X2 @ Y2 ) )
                | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                    ( ( X12
                      = ( cons @ A @ X2 @ Xs4 ) )
                    & ( X24
                      = ( cons @ A @ Y2 @ Ys4 ) )
                    & ~ ( Less2 @ X2 @ Y2 )
                    & ~ ( Less2 @ Y2 @ X2 )
                    & ( P5 @ Xs4 @ Ys4 ) ) ) ) ) ) ).

% ord.lexordp_def
thf(fact_3976_mod__h__bot__iff_I8_J,axiom,
    ! [C: $tType,R: C > assn,H2: heap_ext @ product_unit] :
      ( ( rep_assn @ ( ex_assn @ C @ R ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) )
      = ( ? [X2: C] : ( rep_assn @ ( R @ X2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ).

% mod_h_bot_iff(8)
thf(fact_3977_ex__assn__const,axiom,
    ! [A: $tType,C2: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : C2 )
      = C2 ) ).

% ex_assn_const
thf(fact_3978_ord_Olexordp__simps_I3_J,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( lexordp2 @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X @ Y )
        | ( ~ ( Less @ Y @ X )
          & ( lexordp2 @ A @ Less @ Xs @ Ys ) ) ) ) ).

% ord.lexordp_simps(3)
thf(fact_3979_ord_Olexordp__simps_I2_J,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A] :
      ~ ( lexordp2 @ A @ Less @ Xs @ ( nil @ A ) ) ).

% ord.lexordp_simps(2)
thf(fact_3980_ord_Olexordp__simps_I1_J,axiom,
    ! [A: $tType,Less: A > A > $o,Ys: list @ A] :
      ( ( lexordp2 @ A @ Less @ ( nil @ A ) @ Ys )
      = ( ( Ys
         != ( nil @ A ) ) ) ) ).

% ord.lexordp_simps(1)
thf(fact_3981_norm__assertion__simps_I16_J,axiom,
    ! [A: $tType,Q2: A > assn,R: assn] :
      ( ( times_times @ assn @ ( ex_assn @ A @ Q2 ) @ R )
      = ( ex_assn @ A
        @ ^ [X2: A] : ( times_times @ assn @ ( Q2 @ X2 ) @ R ) ) ) ).

% norm_assertion_simps(16)
thf(fact_3982_norm__assertion__simps_I17_J,axiom,
    ! [B: $tType,R: assn,Q2: B > assn] :
      ( ( times_times @ assn @ R @ ( ex_assn @ B @ Q2 ) )
      = ( ex_assn @ B
        @ ^ [X2: B] : ( times_times @ assn @ R @ ( Q2 @ X2 ) ) ) ) ).

% norm_assertion_simps(17)
thf(fact_3983_mod__ex__dist,axiom,
    ! [A: $tType,P2: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( ex_assn @ A @ P2 ) @ H2 )
      = ( ? [X2: A] : ( rep_assn @ ( P2 @ X2 ) @ H2 ) ) ) ).

% mod_ex_dist
thf(fact_3984_triv__exI,axiom,
    ! [A: $tType,Q2: A > assn,X: A] : ( entails @ ( Q2 @ X ) @ ( ex_assn @ A @ Q2 ) ) ).

% triv_exI
thf(fact_3985_norm__assertion__simps_I21_J,axiom,
    ! [F10: $tType,Q2: assn,P2: F10 > assn] :
      ( ( sup_sup @ assn @ Q2 @ ( ex_assn @ F10 @ P2 ) )
      = ( ex_assn @ F10
        @ ^ [X2: F10] : ( sup_sup @ assn @ Q2 @ ( P2 @ X2 ) ) ) ) ).

% norm_assertion_simps(21)
thf(fact_3986_norm__assertion__simps_I20_J,axiom,
    ! [E5: $tType,Q2: E5 > assn,P2: assn] :
      ( ( sup_sup @ assn @ ( ex_assn @ E5 @ Q2 ) @ P2 )
      = ( ex_assn @ E5
        @ ^ [X2: E5] : ( sup_sup @ assn @ ( Q2 @ X2 ) @ P2 ) ) ) ).

% norm_assertion_simps(20)
thf(fact_3987_norm__assertion__simps_I19_J,axiom,
    ! [D: $tType,Q2: assn,P2: D > assn] :
      ( ( inf_inf @ assn @ Q2 @ ( ex_assn @ D @ P2 ) )
      = ( ex_assn @ D
        @ ^ [X2: D] : ( inf_inf @ assn @ Q2 @ ( P2 @ X2 ) ) ) ) ).

% norm_assertion_simps(19)
thf(fact_3988_norm__assertion__simps_I18_J,axiom,
    ! [C: $tType,Q2: C > assn,P2: assn] :
      ( ( inf_inf @ assn @ ( ex_assn @ C @ Q2 ) @ P2 )
      = ( ex_assn @ C
        @ ^ [X2: C] : ( inf_inf @ assn @ ( Q2 @ X2 ) @ P2 ) ) ) ).

% norm_assertion_simps(18)
thf(fact_3989_ord_Olexordp_OCons,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Xs: list @ A,Ys: list @ A] :
      ( ( Less @ X @ Y )
     => ( lexordp2 @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ).

% ord.lexordp.Cons
thf(fact_3990_ord_Olexordp_OCons__eq,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Xs: list @ A,Ys: list @ A] :
      ( ~ ( Less @ X @ Y )
     => ( ~ ( Less @ Y @ X )
       => ( ( lexordp2 @ A @ Less @ Xs @ Ys )
         => ( lexordp2 @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ).

% ord.lexordp.Cons_eq
thf(fact_3991_ord_Olexordp__irreflexive,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A] :
      ( ! [X3: A] :
          ~ ( Less @ X3 @ X3 )
     => ~ ( lexordp2 @ A @ Less @ Xs @ Xs ) ) ).

% ord.lexordp_irreflexive
thf(fact_3992_ord_Olexordp_Ocong,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ A )
      = ( lexordp2 @ A ) ) ).

% ord.lexordp.cong
thf(fact_3993_ord_Olexordp__append__leftI,axiom,
    ! [A: $tType,Less: A > A > $o,Us: list @ A,Vs: list @ A,Xs: list @ A] :
      ( ( lexordp2 @ A @ Less @ Us @ Vs )
     => ( lexordp2 @ A @ Less @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) ) ) ).

% ord.lexordp_append_leftI
thf(fact_3994_ord_Olexordp__append__leftD,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( lexordp2 @ A @ Less @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) )
     => ( ! [A6: A] :
            ~ ( Less @ A6 @ A6 )
       => ( lexordp2 @ A @ Less @ Us @ Vs ) ) ) ).

% ord.lexordp_append_leftD
thf(fact_3995_ex__distrib__star,axiom,
    ! [A: $tType,P2: A > assn,Q2: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( times_times @ assn @ ( P2 @ X2 ) @ Q2 ) )
      = ( times_times @ assn @ ( ex_assn @ A @ P2 ) @ Q2 ) ) ).

% ex_distrib_star
thf(fact_3996_mod__exE,axiom,
    ! [A: $tType,P2: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( rep_assn @ ( ex_assn @ A @ P2 ) @ H2 )
     => ~ ! [X3: A] :
            ~ ( rep_assn @ ( P2 @ X3 ) @ H2 ) ) ).

% mod_exE
thf(fact_3997_mod__exI,axiom,
    ! [A: $tType,P2: A > assn,H2: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ? [X4: A] : ( rep_assn @ ( P2 @ X4 ) @ H2 )
     => ( rep_assn @ ( ex_assn @ A @ P2 ) @ H2 ) ) ).

% mod_exI
thf(fact_3998_ex__one__point__gen,axiom,
    ! [A: $tType,P2: A > assn,V2: A] :
      ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),X3: A] :
          ( ( rep_assn @ ( P2 @ X3 ) @ H3 )
         => ( X3 = V2 ) )
     => ( ( ex_assn @ A @ P2 )
        = ( P2 @ V2 ) ) ) ).

% ex_one_point_gen
thf(fact_3999_ent__ex__preI,axiom,
    ! [A: $tType,P2: A > assn,Q2: assn] :
      ( ! [X3: A] : ( entails @ ( P2 @ X3 ) @ Q2 )
     => ( entails @ ( ex_assn @ A @ P2 ) @ Q2 ) ) ).

% ent_ex_preI
thf(fact_4000_ent__ex__postI,axiom,
    ! [A: $tType,P2: assn,Q2: A > assn,X: A] :
      ( ( entails @ P2 @ ( Q2 @ X ) )
     => ( entails @ P2 @ ( ex_assn @ A @ Q2 ) ) ) ).

% ent_ex_postI
thf(fact_4001_enorm__exI_H,axiom,
    ! [A: $tType,Z8: A > $o,P2: assn,Q2: A > assn] :
      ( ! [X3: A] :
          ( ( Z8 @ X3 )
         => ( entails @ P2 @ ( Q2 @ X3 ) ) )
     => ( ? [X_12: A] : ( Z8 @ X_12 )
       => ( entails @ P2 @ ( ex_assn @ A @ Q2 ) ) ) ) ).

% enorm_exI'
thf(fact_4002_ex__distrib__or,axiom,
    ! [A: $tType,P2: A > assn,Q2: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( sup_sup @ assn @ ( P2 @ X2 ) @ Q2 ) )
      = ( sup_sup @ assn @ ( ex_assn @ A @ P2 ) @ Q2 ) ) ).

% ex_distrib_or
thf(fact_4003_ex__join__or,axiom,
    ! [A: $tType,P2: A > assn,Q2: A > assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( sup_sup @ assn @ ( P2 @ X2 ) @ ( ex_assn @ A @ Q2 ) ) )
      = ( ex_assn @ A
        @ ^ [X2: A] : ( sup_sup @ assn @ ( P2 @ X2 ) @ ( Q2 @ X2 ) ) ) ) ).

% ex_join_or
thf(fact_4004_ex__distrib__and,axiom,
    ! [A: $tType,P2: A > assn,Q2: assn] :
      ( ( ex_assn @ A
        @ ^ [X2: A] : ( inf_inf @ assn @ ( P2 @ X2 ) @ Q2 ) )
      = ( inf_inf @ assn @ ( ex_assn @ A @ P2 ) @ Q2 ) ) ).

% ex_distrib_and
thf(fact_4005_lfp__induct__set,axiom,
    ! [A: $tType,A3: A,F2: ( set @ A ) > ( set @ A ),P2: A > $o] :
      ( ( member2 @ A @ A3 @ ( complete_lattice_lfp @ ( set @ A ) @ F2 ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F2 )
       => ( ! [X3: A] :
              ( ( member2 @ A @ X3 @ ( F2 @ ( inf_inf @ ( set @ A ) @ ( complete_lattice_lfp @ ( set @ A ) @ F2 ) @ ( collect @ A @ P2 ) ) ) )
             => ( P2 @ X3 ) )
         => ( P2 @ A3 ) ) ) ) ).

% lfp_induct_set
thf(fact_4006_def__lfp__induct__set,axiom,
    ! [A: $tType,A5: set @ A,F2: ( set @ A ) > ( set @ A ),A3: A,P2: A > $o] :
      ( ( A5
        = ( complete_lattice_lfp @ ( set @ A ) @ F2 ) )
     => ( ( order_mono @ ( set @ A ) @ ( set @ A ) @ F2 )
       => ( ( member2 @ A @ A3 @ A5 )
         => ( ! [X3: A] :
                ( ( member2 @ A @ X3 @ ( F2 @ ( inf_inf @ ( set @ A ) @ A5 @ ( collect @ A @ P2 ) ) ) )
               => ( P2 @ X3 ) )
           => ( P2 @ A3 ) ) ) ) ) ).

% def_lfp_induct_set
thf(fact_4007_ord_Olexordp_Osimps,axiom,
    ! [A: $tType] :
      ( ( lexordp2 @ A )
      = ( ^ [Less2: A > A > $o,A12: list @ A,A23: list @ A] :
            ( ? [Y2: A,Ys4: list @ A] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys4 ) ) )
            | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys4 ) )
                & ( Less2 @ X2 @ Y2 ) )
            | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys4 ) )
                & ~ ( Less2 @ X2 @ Y2 )
                & ~ ( Less2 @ Y2 @ X2 )
                & ( lexordp2 @ A @ Less2 @ Xs4 @ Ys4 ) ) ) ) ) ).

% ord.lexordp.simps
thf(fact_4008_ord_Olexordp_Ocases,axiom,
    ! [A: $tType,Less: A > A > $o,A1: list @ A,A22: list @ A] :
      ( ( lexordp2 @ A @ Less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Y3: A,Ys3: list @ A] :
              ( A22
             != ( cons @ A @ Y3 @ Ys3 ) ) )
       => ( ! [X3: A] :
              ( ? [Xs2: list @ A] :
                  ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Y3: A] :
                  ( ? [Ys3: list @ A] :
                      ( A22
                      = ( cons @ A @ Y3 @ Ys3 ) )
                 => ~ ( Less @ X3 @ Y3 ) ) )
         => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                ( ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ! [Ys3: list @ A] :
                    ( ( A22
                      = ( cons @ A @ Y3 @ Ys3 ) )
                   => ( ~ ( Less @ X3 @ Y3 )
                     => ( ~ ( Less @ Y3 @ X3 )
                       => ~ ( lexordp2 @ A @ Less @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ).

% ord.lexordp.cases
thf(fact_4009_ord_Olexordp_ONil,axiom,
    ! [A: $tType,Less: A > A > $o,Y: A,Ys: list @ A] : ( lexordp2 @ A @ Less @ ( nil @ A ) @ ( cons @ A @ Y @ Ys ) ) ).

% ord.lexordp.Nil
thf(fact_4010_ord_Olexordp__append__left__rightI,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Us: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( Less @ X @ Y )
     => ( lexordp2 @ A @ Less @ ( append @ A @ Us @ ( cons @ A @ X @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys ) ) ) ) ).

% ord.lexordp_append_left_rightI
thf(fact_4011_ord_Olexordp__append__rightI,axiom,
    ! [A: $tType,Ys: list @ A,Less: A > A > $o,Xs: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( lexordp2 @ A @ Less @ Xs @ ( append @ A @ Xs @ Ys ) ) ) ).

% ord.lexordp_append_rightI
thf(fact_4012_lfp__induct2,axiom,
    ! [A: $tType,B: $tType,A3: A,B2: B,F2: ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ A @ B ) ),P2: A > B > $o] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B2 ) @ ( complete_lattice_lfp @ ( set @ ( product_prod @ A @ B ) ) @ F2 ) )
     => ( ( order_mono @ ( set @ ( product_prod @ A @ B ) ) @ ( set @ ( product_prod @ A @ B ) ) @ F2 )
       => ( ! [A6: A,B5: B] :
              ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B5 ) @ ( F2 @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( complete_lattice_lfp @ ( set @ ( product_prod @ A @ B ) ) @ F2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P2 ) ) ) ) )
             => ( P2 @ A6 @ B5 ) )
         => ( P2 @ A3 @ B2 ) ) ) ) ).

% lfp_induct2
thf(fact_4013_ex__assn__def,axiom,
    ! [A: $tType] :
      ( ( ex_assn @ A )
      = ( ^ [P: A > assn] :
            ( abs_assn
            @ ^ [H: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
              ? [X2: A] : ( rep_assn @ ( P @ X2 ) @ H ) ) ) ) ).

% ex_assn_def
thf(fact_4014_take__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( nil @ A )
        @ ^ [M3: nat] : ( cons @ A @ X @ ( take @ A @ M3 @ Xs ) )
        @ N ) ) ).

% take_Cons
thf(fact_4015_zipf_Opelims,axiom,
    ! [C: $tType,A: $tType,B: $tType,X: A > B > C,Xa: list @ A,Xb: list @ B,Y: list @ C] :
      ( ( ( zipf @ A @ B @ C @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Xb
                = ( nil @ B ) )
             => ( ( Y
                  = ( nil @ C ) )
               => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) ) ) ) )
         => ( ! [A6: A,As: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A6 @ As ) )
               => ! [B5: B,Bs2: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ B5 @ Bs2 ) )
                   => ( ( Y
                        = ( cons @ C @ ( X @ A6 @ B5 ) @ ( zipf @ A @ B @ C @ X @ As @ Bs2 ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ ( cons @ B @ B5 @ Bs2 ) ) ) ) ) ) )
           => ( ! [V: A,Va: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ V @ Va ) )
                 => ( ( Xb
                      = ( nil @ B ) )
                   => ( ( Y
                        = ( undefined @ ( list @ C ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V @ Va ) @ ( nil @ B ) ) ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ! [V: B,Va: list @ B] :
                      ( ( Xb
                        = ( cons @ B @ V @ Va ) )
                     => ( ( Y
                          = ( undefined @ ( list @ C ) ) )
                       => ~ ( accp @ ( product_prod @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( zipf_rel @ A @ B @ C ) @ ( product_Pair @ ( A > B > C ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V @ Va ) ) ) ) ) ) ) ) ) ) ) ) ).

% zipf.pelims
thf(fact_4016_sorted__wrt__iff__nth__Suc__transp,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ( transp @ A @ P2 )
     => ( ( sorted_wrt @ A @ P2 @ Xs )
        = ( ! [I4: nat] :
              ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( P2 @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_Suc_transp
thf(fact_4017_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_4018_list_Orel__transp,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( transp @ A @ R )
     => ( transp @ ( list @ A ) @ ( list_all2 @ A @ A @ R ) ) ) ).

% list.rel_transp
thf(fact_4019_transp__inf,axiom,
    ! [A: $tType,R4: A > A > $o,S3: A > A > $o] :
      ( ( transp @ A @ R4 )
     => ( ( transp @ A @ S3 )
       => ( transp @ A @ ( inf_inf @ ( A > A > $o ) @ R4 @ S3 ) ) ) ) ).

% transp_inf
thf(fact_4020_sorted__wrt2,axiom,
    ! [A: $tType,P2: A > A > $o,X: A,Y: A,Zs: list @ A] :
      ( ( transp @ A @ P2 )
     => ( ( sorted_wrt @ A @ P2 @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
        = ( ( P2 @ X @ Y )
          & ( sorted_wrt @ A @ P2 @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% sorted_wrt2
thf(fact_4021_drop__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ X @ Xs )
        @ ^ [M3: nat] : ( drop @ A @ M3 @ Xs )
        @ N ) ) ).

% drop_Cons
thf(fact_4022_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I2: nat,V2: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ I2 @ V2 )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V2 @ Xs )
        @ ^ [J2: nat] : ( cons @ A @ X @ ( list_update @ A @ Xs @ J2 @ V2 ) )
        @ I2 ) ) ).

% list_update.simps(2)
thf(fact_4023_nth__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
      = ( case_nat @ A @ X @ ( nth @ A @ Xs ) @ N ) ) ).

% nth_Cons
thf(fact_4024_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X2: A,F3: nat > A,N3: nat] :
            ( if @ A
            @ ( N3
              = ( zero_zero @ nat ) )
            @ X2
            @ ( F3 @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_4025_map__tailrec__rev_Opelims,axiom,
    ! [A: $tType,B: $tType,X: A > B,Xa: list @ A,Xb: list @ B,Y: list @ B] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Y = Xb )
             => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xb ) ) ) ) )
         => ~ ! [A6: A,As: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A6 @ As ) )
               => ( ( Y
                    = ( map_tailrec_rev @ A @ B @ X @ As @ ( cons @ B @ ( X @ A6 ) @ Xb ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ Xb ) ) ) ) ) ) ) ) ).

% map_tailrec_rev.pelims
thf(fact_4026_mergesort__by__rel__merge_Opelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( merges9089515139780605204_merge @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ Xb ) ) )
       => ( ! [X3: A,Xs2: list @ A] :
              ( ( Xa
                = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Y3: A,Ys3: list @ A] :
                  ( ( Xb
                    = ( cons @ A @ Y3 @ Ys3 ) )
                 => ( ( ( ( X @ X3 @ Y3 )
                       => ( Y
                          = ( cons @ A @ X3 @ ( merges9089515139780605204_merge @ A @ X @ Xs2 @ ( cons @ A @ Y3 @ Ys3 ) ) ) ) )
                      & ( ~ ( X @ X3 @ Y3 )
                       => ( Y
                          = ( cons @ A @ Y3 @ ( merges9089515139780605204_merge @ A @ X @ ( cons @ A @ X3 @ Xs2 ) @ Ys3 ) ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys3 ) ) ) ) ) ) )
         => ( ( ( Xb
                = ( nil @ A ) )
             => ( ( Y = Xa )
               => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( nil @ A ) ) ) ) ) )
           => ~ ( ( Xa
                  = ( nil @ A ) )
               => ! [V: A,Va: list @ A] :
                    ( ( Xb
                      = ( cons @ A @ V @ Va ) )
                   => ( ( Y
                        = ( cons @ A @ V @ Va ) )
                     => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( merges2244889521215249637ge_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( cons @ A @ V @ Va ) ) ) ) ) ) ) ) ) ) ) ).

% mergesort_by_rel_merge.pelims
thf(fact_4027_revg_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( revg @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( revg_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( revg_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [A6: A,As: list @ A] :
                ( ( X
                  = ( cons @ A @ A6 @ As ) )
               => ( ( Y
                    = ( revg @ A @ As @ ( cons @ A @ A6 @ Xa ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( revg_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A6 @ As ) @ Xa ) ) ) ) ) ) ) ).

% revg.pelims
thf(fact_4028_irrefl__tranclI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( converse @ A @ A @ R4 ) @ ( transitive_rtrancl @ A @ R4 ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( transitive_trancl @ A @ R4 ) ) ) ).

% irrefl_tranclI
thf(fact_4029_in__listrel1__converse,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( listrel1 @ A @ ( converse @ A @ A @ R4 ) ) )
      = ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( converse @ ( list @ A ) @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ) ).

% in_listrel1_converse
thf(fact_4030_listrel1__converse,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( listrel1 @ A @ ( converse @ A @ A @ R4 ) )
      = ( converse @ ( list @ A ) @ ( list @ A ) @ ( listrel1 @ A @ R4 ) ) ) ).

% listrel1_converse
thf(fact_4031_converse__Int,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ B @ A ),S3: set @ ( product_prod @ B @ A )] :
      ( ( converse @ B @ A @ ( inf_inf @ ( set @ ( product_prod @ B @ A ) ) @ R4 @ S3 ) )
      = ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ ( converse @ B @ A @ R4 ) @ ( converse @ B @ A @ S3 ) ) ) ).

% converse_Int
thf(fact_4032_revg_Osimps_I1_J,axiom,
    ! [A: $tType,B2: list @ A] :
      ( ( revg @ A @ ( nil @ A ) @ B2 )
      = B2 ) ).

% revg.simps(1)
thf(fact_4033_revg_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: list @ A] :
      ( ( ( revg @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ~ ! [A6: A,As: list @ A] :
              ( ( X
                = ( cons @ A @ A6 @ As ) )
             => ( Y
               != ( revg @ A @ As @ ( cons @ A @ A6 @ Xa ) ) ) ) ) ) ).

% revg.elims
thf(fact_4034_is__singleton__altdef,axiom,
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A10: set @ A] :
            ( ( finite_card @ A @ A10 )
            = ( one_one @ nat ) ) ) ) ).

% is_singleton_altdef
thf(fact_4035_successively__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( list @ A ) > $o ) @ ( ( list @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A5
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
          @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( successively @ A )
      @ ( successively @ B ) ) ).

% successively_transfer
thf(fact_4036_prod__list__def,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( groups_monoid_F @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_list_def
thf(fact_4037_lexn_Osimps_I2_J,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( lexn @ A @ R4 @ ( suc @ N ) )
      = ( inf_inf @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image2 @ ( product_prod @ ( product_prod @ A @ ( list @ A ) ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_map_prod @ ( product_prod @ A @ ( list @ A ) ) @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( list @ A ) @ ( product_case_prod @ A @ ( list @ A ) @ ( list @ A ) @ ( cons @ A ) ) @ ( product_case_prod @ A @ ( list @ A ) @ ( list @ A ) @ ( cons @ A ) ) ) @ ( lex_prod @ A @ ( list @ A ) @ R4 @ ( lexn @ A @ R4 @ N ) ) )
        @ ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
          @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Xs4: list @ A,Ys4: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs4 )
                  = ( suc @ N ) )
                & ( ( size_size @ ( list @ A ) @ Ys4 )
                  = ( suc @ N ) ) ) ) ) ) ) ).

% lexn.simps(2)
thf(fact_4038_successively__rev,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ( successively @ A @ P2 @ ( rev @ A @ Xs ) )
      = ( successively @ A
        @ ^ [X2: A,Y2: A] : ( P2 @ Y2 @ X2 )
        @ Xs ) ) ).

% successively_rev
thf(fact_4039_successively__remdups__adjI,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ( successively @ A @ P2 @ Xs )
     => ( successively @ A @ P2 @ ( remdups_adj @ A @ Xs ) ) ) ).

% successively_remdups_adjI
thf(fact_4040_successively__mono,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A,Q2: A > A > $o] :
      ( ( successively @ A @ P2 @ Xs )
     => ( ! [X3: A,Y3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
             => ( ( P2 @ X3 @ Y3 )
               => ( Q2 @ X3 @ Y3 ) ) ) )
       => ( successively @ A @ Q2 @ Xs ) ) ) ).

% successively_mono
thf(fact_4041_successively__cong,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > A > $o,Q2: A > A > $o,Ys: list @ A] :
      ( ! [X3: A,Y3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( P2 @ X3 @ Y3 )
              = ( Q2 @ X3 @ Y3 ) ) ) )
     => ( ( Xs = Ys )
       => ( ( successively @ A @ P2 @ Xs )
          = ( successively @ A @ Q2 @ Ys ) ) ) ) ).

% successively_cong
thf(fact_4042_successively_Osimps_I3_J,axiom,
    ! [A: $tType,P2: A > A > $o,X: A,Y: A,Xs: list @ A] :
      ( ( successively @ A @ P2 @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
      = ( ( P2 @ X @ Y )
        & ( successively @ A @ P2 @ ( cons @ A @ Y @ Xs ) ) ) ) ).

% successively.simps(3)
thf(fact_4043_successively_Oelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( successively @ A @ X @ Xa )
     => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
            ( ( Xa
              = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
           => ( ( X @ X3 @ Y3 )
              & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ).

% successively.elims(3)
thf(fact_4044_successively_Osimps_I1_J,axiom,
    ! [A: $tType,P2: A > A > $o] : ( successively @ A @ P2 @ ( nil @ A ) ) ).

% successively.simps(1)
thf(fact_4045_successively__if__sorted__wrt,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P2 @ Xs )
     => ( successively @ A @ P2 @ Xs ) ) ).

% successively_if_sorted_wrt
thf(fact_4046_successively__map,axiom,
    ! [A: $tType,B: $tType,P2: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( successively @ A @ P2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( successively @ B
        @ ^ [X2: B,Y2: B] : ( P2 @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
        @ Xs ) ) ).

% successively_map
thf(fact_4047_distinct__adj__def,axiom,
    ! [A: $tType] :
      ( ( distinct_adj @ A )
      = ( successively @ A
        @ ^ [X2: A,Y2: A] : ( X2 != Y2 ) ) ) ).

% distinct_adj_def
thf(fact_4048_successively_Oelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( successively @ A @ X @ Xa )
     => ( ( Xa
         != ( nil @ A ) )
       => ( ! [X3: A] :
              ( Xa
             != ( cons @ A @ X3 @ ( nil @ A ) ) )
         => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
               => ~ ( ( X @ X3 @ Y3 )
                    & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ).

% successively.elims(2)
thf(fact_4049_successively_Oelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( successively @ A @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ~ Y )
       => ( ( ? [X3: A] :
                ( Xa
                = ( cons @ A @ X3 @ ( nil @ A ) ) )
           => ~ Y )
         => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
               => ( Y
                  = ( ~ ( ( X @ X3 @ Y3 )
                        & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% successively.elims(1)
thf(fact_4050_successively_Osimps_I2_J,axiom,
    ! [A: $tType,P2: A > A > $o,X: A] : ( successively @ A @ P2 @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% successively.simps(2)
thf(fact_4051_successively__iff__sorted__wrt__strong,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > A > $o] :
      ( ! [X3: A,Y3: A,Z4: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs ) )
           => ( ( member2 @ A @ Z4 @ ( set2 @ A @ Xs ) )
             => ( ( P2 @ X3 @ Y3 )
               => ( ( P2 @ Y3 @ Z4 )
                 => ( P2 @ X3 @ Z4 ) ) ) ) ) )
     => ( ( successively @ A @ P2 @ Xs )
        = ( sorted_wrt @ A @ P2 @ Xs ) ) ) ).

% successively_iff_sorted_wrt_strong
thf(fact_4052_successively__remdups__adj__iff,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > A > $o] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P2 @ X3 @ X3 ) )
     => ( ( successively @ A @ P2 @ ( remdups_adj @ A @ Xs ) )
        = ( successively @ A @ P2 @ Xs ) ) ) ).

% successively_remdups_adj_iff
thf(fact_4053_successively__conv__sorted__wrt,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A] :
      ( ( transp @ A @ P2 )
     => ( ( successively @ A @ P2 @ Xs )
        = ( sorted_wrt @ A @ P2 @ Xs ) ) ) ).

% successively_conv_sorted_wrt
thf(fact_4054_successively__altdef,axiom,
    ! [A: $tType] :
      ( ( successively @ A )
      = ( ^ [P: A > A > $o] :
            ( rec_list @ $o @ A @ $true
            @ ^ [X2: A,Xs4: list @ A,B3: $o] :
                ( case_list @ $o @ A @ $true
                @ ^ [Y2: A,Xa4: list @ A] :
                    ( ( P @ X2 @ Y2 )
                    & B3 )
                @ Xs4 ) ) ) ) ).

% successively_altdef
thf(fact_4055_successively__Cons,axiom,
    ! [A: $tType,P2: A > A > $o,X: A,Xs: list @ A] :
      ( ( successively @ A @ P2 @ ( cons @ A @ X @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( ( P2 @ X @ ( hd @ A @ Xs ) )
          & ( successively @ A @ P2 @ Xs ) ) ) ) ).

% successively_Cons
thf(fact_4056_successively__append__iff,axiom,
    ! [A: $tType,P2: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( successively @ A @ P2 @ ( append @ A @ Xs @ Ys ) )
      = ( ( successively @ A @ P2 @ Xs )
        & ( successively @ A @ P2 @ Ys )
        & ( ( Xs
            = ( nil @ A ) )
          | ( Ys
            = ( nil @ A ) )
          | ( P2 @ ( last @ A @ Xs ) @ ( hd @ A @ Ys ) ) ) ) ) ).

% successively_append_iff
thf(fact_4057_successively_Opelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ( successively @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
           => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
                 => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) )
                   => ~ ( ( X @ X3 @ Y3 )
                        & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% successively.pelims(2)
thf(fact_4058_successively_Opelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Y: $o] :
      ( ( ( successively @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( Y
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
         => ( ! [X3: A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ( Y
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
           => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
                 => ( ( Y
                      = ( ( X @ X3 @ Y3 )
                        & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs2 ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ) ) ) ).

% successively.pelims(1)
thf(fact_4059_successively_Opelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A] :
      ( ~ ( successively @ A @ X @ Xa )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa ) )
       => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
              ( ( Xa
                = ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( successively_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) )
               => ( ( X @ X3 @ Y3 )
                  & ( successively @ A @ X @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) ) ).

% successively.pelims(3)
thf(fact_4060_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M2 @ N )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_4061_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
          = ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_minus_1_iff
thf(fact_4062_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ A3 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% bit_minus_iff
thf(fact_4063_bit__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ ( one_one @ nat ) )
            & ( N
              = ( one_one @ nat ) ) ) ) ) ).

% bit_2_iff
thf(fact_4064_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M2 ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_4065_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A3: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            & ( N
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_double_iff
thf(fact_4066_Refl__Field__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        = ( inf_inf @ ( set @ A ) @ ( field2 @ A @ R4 ) @ A5 ) ) ) ).

% Refl_Field_Restr
thf(fact_4067_Refl__Field__Restr2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( field2 @ A @ R4 ) )
       => ( ( field2 @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ A5
                @ ^ [Uu2: A] : A5 ) ) )
          = A5 ) ) ) ).

% Refl_Field_Restr2
thf(fact_4068_Sup__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ X ) ) ) ).

% Sup_fin.set_eq_fold
thf(fact_4069_rtrancl__Int__subset,axiom,
    ! [A: $tType,S3: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( id2 @ A ) @ S3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R4 ) @ S3 ) @ R4 ) @ S3 )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R4 ) @ S3 ) ) ) ).

% rtrancl_Int_subset
thf(fact_4070_Restr__Field,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
        @ ( product_Sigma @ A @ A @ ( field2 @ A @ R4 )
          @ ^ [Uu2: A] : ( field2 @ A @ R4 ) ) )
      = R4 ) ).

% Restr_Field
thf(fact_4071_Field__Restr__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ord_less_eq @ ( set @ A )
      @ ( field2 @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) )
      @ A5 ) ).

% Field_Restr_subset
thf(fact_4072_Refl__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( refl_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( refl_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% Refl_Restr
thf(fact_4073_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A,A3: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member2 @ A @ A3 @ A5 )
           => ( ( inf_inf @ A @ A3 @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = A3 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_4074_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu2: A] :
                    ? [A4: A] :
                      ( ( Uu2
                        = ( inf_inf @ A @ X @ A4 ) )
                      & ( member2 @ A @ A4 @ A5 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_4075_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ B4 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu2: A] :
                        ? [A4: A,B3: A] :
                          ( ( Uu2
                            = ( inf_inf @ A @ A4 @ B3 ) )
                          & ( member2 @ A @ A4 @ A5 )
                          & ( member2 @ A @ B3 @ B4 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_4076_Preorder__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_preorder_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_preorder_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% Preorder_Restr
thf(fact_4077_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert3 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert3 @ A @ X @ A5 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_4078_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member2 @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
                  = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_4079_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert3 @ A @ X @ A5 ) )
              = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_4080_Partial__order__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_7125193373082350890der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_7125193373082350890der_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% Partial_order_Restr
thf(fact_4081_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member2 @ A @ X @ A5 )
           => ( ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_4082_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [H2: A > A,N2: set @ A] :
          ( ! [X3: A,Y3: A] :
              ( ( H2 @ ( inf_inf @ A @ X3 @ Y3 ) )
              = ( inf_inf @ A @ ( H2 @ X3 ) @ ( H2 @ Y3 ) ) )
         => ( ( finite_finite @ A @ N2 )
           => ( ( N2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic7752659483105999362nf_fin @ A @ N2 ) )
                = ( lattic7752659483105999362nf_fin @ A @ ( image2 @ A @ A @ H2 @ N2 ) ) ) ) ) ) ) ).

% Inf_fin.hom_commute
thf(fact_4083_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A5 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B4 ) @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_4084_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y3: A] : ( member2 @ A @ ( inf_inf @ A @ X3 @ Y3 ) @ ( insert3 @ A @ X3 @ ( insert3 @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member2 @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Inf_fin.closed
thf(fact_4085_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member2 @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert3 @ A @ X @ A5 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
thf(fact_4086_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( B4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
                  = ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ ( lattic7752659483105999362nf_fin @ A @ B4 ) ) ) ) ) ) ) ) ).

% Inf_fin.union
thf(fact_4087_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic7752659483105999362nf_fin @ A @ ( insert3 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ X @ A5 ) ) ) ) ).

% Inf_fin.eq_fold
thf(fact_4088_Inf__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ X ) ) ) ).

% Inf_fin.set_eq_fold
thf(fact_4089_Linear__order__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_679001287576687338der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_679001287576687338der_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% Linear_order_Restr
thf(fact_4090_inter__Set__filter,axiom,
    ! [A: $tType,B4: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
        = ( filter2 @ A
          @ ^ [X2: A] : ( member2 @ A @ X2 @ A5 )
          @ B4 ) ) ) ).

% inter_Set_filter
thf(fact_4091_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic4895041142388067077er_set @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% Inf_fin.semilattice_order_set_axioms
thf(fact_4092_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ nat,B4: set @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( A5
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( ( B4
            = ( set2 @ A @ Xs ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs ) @ A5 @ B4 ) ) ) ) ).

% bij_betw_nth
thf(fact_4093_bij__betw__partition,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,C5: set @ A,B4: set @ B,D2: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A5 @ C5 ) @ ( sup_sup @ ( set @ B ) @ B4 @ D2 ) )
     => ( ( bij_betw @ A @ B @ F2 @ C5 @ D2 )
       => ( ( ( inf_inf @ ( set @ A ) @ A5 @ C5 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( ( inf_inf @ ( set @ B ) @ B4 @ D2 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( bij_betw @ A @ B @ F2 @ A5 @ B4 ) ) ) ) ) ).

% bij_betw_partition
thf(fact_4094_bij__betw__combine,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B4: set @ B,C5: set @ A,D2: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A5 @ B4 )
     => ( ( bij_betw @ A @ B @ F2 @ C5 @ D2 )
       => ( ( ( inf_inf @ ( set @ B ) @ B4 @ D2 )
            = ( bot_bot @ ( set @ B ) ) )
         => ( bij_betw @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A5 @ C5 ) @ ( sup_sup @ ( set @ B ) @ B4 @ D2 ) ) ) ) ) ).

% bij_betw_combine
thf(fact_4095_bij__betw__disjoint__Un,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,C5: set @ B,G: A > B,B4: set @ A,D2: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A5 @ C5 )
     => ( ( bij_betw @ A @ B @ G @ B4 @ D2 )
       => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( ( inf_inf @ ( set @ B ) @ C5 @ D2 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( bij_betw @ A @ B
              @ ^ [X2: A] : ( if @ B @ ( member2 @ A @ X2 @ A5 ) @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( sup_sup @ ( set @ A ) @ A5 @ B4 )
              @ ( sup_sup @ ( set @ B ) @ C5 @ D2 ) ) ) ) ) ) ).

% bij_betw_disjoint_Un
thf(fact_4096_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M: set @ A] :
      ( ( finite_finite @ A @ M )
     => ? [H3: nat > A] : ( bij_betw @ nat @ A @ H3 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( finite_card @ A @ M ) ) @ M ) ) ).

% ex_bij_betw_nat_finite_1
thf(fact_4097_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T4: set @ C,H2: B > C,S: set @ B,T: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T4 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S @ S2 ) @ ( minus_minus @ ( set @ C ) @ T @ T4 ) )
             => ( ! [A6: B] :
                    ( ( member2 @ B @ A6 @ S2 )
                   => ( ( G @ ( H2 @ A6 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B5: C] :
                      ( ( member2 @ C @ B5 @ T4 )
                     => ( ( G @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                      @ S )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_4098_filter__set,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P2 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A @ ( filter @ A @ P2 @ Xs ) ) ) ).

% filter_set
thf(fact_4099_linear__order__on__Restr,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A ),X: A] :
      ( ( order_679001287576687338der_on @ A @ A5 @ R4 )
     => ( order_679001287576687338der_on @ A @ ( inf_inf @ ( set @ A ) @ A5 @ ( order_above @ A @ R4 @ X ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ ( order_above @ A @ R4 @ X )
            @ ^ [Uu2: A] : ( order_above @ A @ R4 @ X ) ) ) ) ) ).

% linear_order_on_Restr
thf(fact_4100_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M2
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M2 @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_4101_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M2
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M2 @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M2 ) ) ) ) ) ).

% power_int_add_1'
thf(fact_4102_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_4103_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_4104_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( one_one @ int ) )
          = Y ) ) ).

% power_int_1_right
thf(fact_4105_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y: A,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M2 ) @ ( power_int @ A @ Y @ M2 ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_4106_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W: num,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W ) ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M2 ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_4107_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_4108_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_4109_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_4110_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M2 ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M2 @ N ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_4111_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M2 ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M2 @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_4112_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y ) ) ) ).

% power_int_minus1_right
thf(fact_4113_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_commutes
thf(fact_4114_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ Y @ M2 ) ) ) ) ).

% power_int_mult_distrib
thf(fact_4115_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_one_over
thf(fact_4116_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int] :
          ( ( ( M2
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M2 )
              = ( one_one @ A ) ) )
          & ( ( M2
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_4117_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N2: int,A3: A] :
          ( ( ord_less_eq @ int @ N @ N2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ A3 @ N2 ) ) ) ) ) ).

% power_int_increasing
thf(fact_4118_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N2: int,A3: A] :
          ( ( ord_less @ int @ N @ N2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
           => ( ord_less @ A @ ( power_int @ A @ A3 @ N ) @ ( power_int @ A @ A3 @ N2 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_4119_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) ) ) ).

% power_int_minus_one_minus
thf(fact_4120_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A3 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A3 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_4121_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N2: int,A3: A] :
          ( ( ord_less @ int @ N @ N2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less @ A @ A3 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A3 @ N2 ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_4122_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_4123_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A3 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_4124_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M2 @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M2 @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_add
thf(fact_4125_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X: C,A3: A,N: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A3 ) @ N )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_4126_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N2: int,A3: A] :
          ( ( ord_less_eq @ int @ N @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A3 )
           => ( ( ord_less_eq @ A @ A3 @ ( one_one @ A ) )
             => ( ( ( A3
                   != ( zero_zero @ A ) )
                  | ( N2
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A3 @ N2 ) @ ( power_int @ A @ A3 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_4127_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_4128_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M2: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M2 @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_4129_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M2: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M2 @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_4130_List_Oinsert__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ A5 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( insert @ A ) @ ( insert @ B ) ) ) ).

% List.insert_transfer
thf(fact_4131_mset__set__Union,axiom,
    ! [A: $tType,A5: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( mset_set @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
            = ( plus_plus @ ( multiset @ A ) @ ( mset_set @ A @ A5 ) @ ( mset_set @ A @ B4 ) ) ) ) ) ) ).

% mset_set_Union
thf(fact_4132_add_Ogroup__axioms,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( group @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A ) ) ) ).

% add.group_axioms
thf(fact_4133_merge_Opelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ A,Xa: list @ A,Y: list @ A] :
          ( ( ( merge @ A @ X @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
           => ( ( ( X
                  = ( nil @ A ) )
               => ( ( Y = Xa )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
             => ( ! [V: A,Va: list @ A] :
                    ( ( X
                      = ( cons @ A @ V @ Va ) )
                   => ( ( Xa
                        = ( nil @ A ) )
                     => ( ( Y
                          = ( cons @ A @ V @ Va ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ V @ Va ) @ ( nil @ A ) ) ) ) ) )
               => ~ ! [X1: A,L1: list @ A] :
                      ( ( X
                        = ( cons @ A @ X1 @ L1 ) )
                     => ! [X23: A,L2: list @ A] :
                          ( ( Xa
                            = ( cons @ A @ X23 @ L2 ) )
                         => ( ( ( ( ord_less @ A @ X1 @ X23 )
                               => ( Y
                                  = ( cons @ A @ X1 @ ( merge @ A @ L1 @ ( cons @ A @ X23 @ L2 ) ) ) ) )
                              & ( ~ ( ord_less @ A @ X1 @ X23 )
                               => ( ( ( X1 = X23 )
                                   => ( Y
                                      = ( cons @ A @ X1 @ ( merge @ A @ L1 @ L2 ) ) ) )
                                  & ( ( X1 != X23 )
                                   => ( Y
                                      = ( cons @ A @ X23 @ ( merge @ A @ ( cons @ A @ X1 @ L1 ) @ L2 ) ) ) ) ) ) )
                           => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( merge_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X23 @ L2 ) ) ) ) ) ) ) ) ) ) ) ).

% merge.pelims
thf(fact_4134_group_Oinverse__distrib__swap,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A3: A,B2: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( Inverse @ ( F2 @ A3 @ B2 ) )
        = ( F2 @ ( Inverse @ B2 ) @ ( Inverse @ A3 ) ) ) ) ).

% group.inverse_distrib_swap
thf(fact_4135_group_Ogroup__left__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( F2 @ Z2 @ A3 )
        = A3 ) ) ).

% group.group_left_neutral
thf(fact_4136_group_Oinverse__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( Inverse @ Z2 )
        = Z2 ) ) ).

% group.inverse_neutral
thf(fact_4137_group_Oinverse__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( Inverse @ ( Inverse @ A3 ) )
        = A3 ) ) ).

% group.inverse_inverse
thf(fact_4138_group_Oinverse__unique,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A3: A,B2: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( ( F2 @ A3 @ B2 )
          = Z2 )
       => ( ( Inverse @ A3 )
          = B2 ) ) ) ).

% group.inverse_unique
thf(fact_4139_group_Oright__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( F2 @ A3 @ ( Inverse @ A3 ) )
        = Z2 ) ) ).

% group.right_inverse
thf(fact_4140_group_Oright__cancel,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,B2: A,A3: A,C2: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( ( F2 @ B2 @ A3 )
          = ( F2 @ C2 @ A3 ) )
        = ( B2 = C2 ) ) ) ).

% group.right_cancel
thf(fact_4141_group_Oleft__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A3: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( F2 @ ( Inverse @ A3 ) @ A3 )
        = Z2 ) ) ).

% group.left_inverse
thf(fact_4142_group_Oleft__cancel,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A,A3: A,B2: A,C2: A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( ( ( F2 @ A3 @ B2 )
          = ( F2 @ A3 @ C2 ) )
        = ( B2 = C2 ) ) ) ).

% group.left_cancel
thf(fact_4143_list_Obi__unique__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( bi_unique @ A @ B @ R )
     => ( bi_unique @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R ) ) ) ).

% list.bi_unique_rel
thf(fact_4144_merge_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L22: list @ A] :
          ( ( merge @ A @ ( nil @ A ) @ L22 )
          = L22 ) ) ).

% merge.simps(1)
thf(fact_4145_group_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( semigroup @ A @ F2 ) ) ).

% group.axioms(1)
thf(fact_4146_merge_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [V2: A,Va2: list @ A] :
          ( ( merge @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
          = ( cons @ A @ V2 @ Va2 ) ) ) ).

% merge.simps(2)
thf(fact_4147_remdups__adj__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( remdups_adj @ A ) @ ( remdups_adj @ B ) ) ) ).

% remdups_adj_transfer
thf(fact_4148_remdups__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( remdups @ A ) @ ( remdups @ B ) ) ) ).

% remdups_transfer
thf(fact_4149_distinct__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
        @ ( distinct @ A )
        @ ( distinct @ B ) ) ) ).

% distinct_transfer
thf(fact_4150_distinct__adj__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ A5 )
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
        @ ( distinct_adj @ A )
        @ ( distinct_adj @ B ) ) ) ).

% distinct_adj_transfer
thf(fact_4151_merge_Oelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ A,Xa: list @ A,Y: list @ A] :
          ( ( ( merge @ A @ X @ Xa )
            = Y )
         => ( ( ( X
                = ( nil @ A ) )
             => ( Y != Xa ) )
           => ( ! [V: A,Va: list @ A] :
                  ( ( X
                    = ( cons @ A @ V @ Va ) )
                 => ( ( Xa
                      = ( nil @ A ) )
                   => ( Y
                     != ( cons @ A @ V @ Va ) ) ) )
             => ~ ! [X1: A,L1: list @ A] :
                    ( ( X
                      = ( cons @ A @ X1 @ L1 ) )
                   => ! [X23: A,L2: list @ A] :
                        ( ( Xa
                          = ( cons @ A @ X23 @ L2 ) )
                       => ~ ( ( ( ord_less @ A @ X1 @ X23 )
                             => ( Y
                                = ( cons @ A @ X1 @ ( merge @ A @ L1 @ ( cons @ A @ X23 @ L2 ) ) ) ) )
                            & ( ~ ( ord_less @ A @ X1 @ X23 )
                             => ( ( ( X1 = X23 )
                                 => ( Y
                                    = ( cons @ A @ X1 @ ( merge @ A @ L1 @ L2 ) ) ) )
                                & ( ( X1 != X23 )
                                 => ( Y
                                    = ( cons @ A @ X23 @ ( merge @ A @ ( cons @ A @ X1 @ L1 ) @ L2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% merge.elims
thf(fact_4152_remove1__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ A5 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( remove1 @ A ) @ ( remove1 @ B ) ) ) ).

% remove1_transfer
thf(fact_4153_removeAll__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ A5 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( removeAll @ A ) @ ( removeAll @ B ) ) ) ).

% removeAll_transfer
thf(fact_4154_group_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( semigroup @ A @ F2 )
     => ( ( group_axioms @ A @ F2 @ Z2 @ Inverse )
       => ( group @ A @ F2 @ Z2 @ Inverse ) ) ) ).

% group.intro
thf(fact_4155_group__def,axiom,
    ! [A: $tType] :
      ( ( group @ A )
      = ( ^ [F3: A > A > A,Z3: A,Inverse2: A > A] :
            ( ( semigroup @ A @ F3 )
            & ( group_axioms @ A @ F3 @ Z3 @ Inverse2 ) ) ) ) ).

% group_def
thf(fact_4156_merge__list_Oelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ ( list @ A ),Xa: list @ ( list @ A ),Y: list @ A] :
          ( ( ( merge_list @ A @ X @ Xa )
            = Y )
         => ( ( ( X
                = ( nil @ ( list @ A ) ) )
             => ( ( Xa
                  = ( nil @ ( list @ A ) ) )
               => ( Y
                 != ( nil @ A ) ) ) )
           => ( ( ( X
                  = ( nil @ ( list @ A ) ) )
               => ! [L4: list @ A] :
                    ( ( Xa
                      = ( cons @ ( list @ A ) @ L4 @ ( nil @ ( list @ A ) ) ) )
                   => ( Y != L4 ) ) )
             => ( ! [La: list @ A,Acc2: list @ ( list @ A )] :
                    ( ( X
                      = ( cons @ ( list @ A ) @ La @ Acc2 ) )
                   => ( ( Xa
                        = ( nil @ ( list @ A ) ) )
                     => ( Y
                       != ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ La @ Acc2 ) ) ) ) )
               => ( ! [La: list @ A,Acc2: list @ ( list @ A )] :
                      ( ( X
                        = ( cons @ ( list @ A ) @ La @ Acc2 ) )
                     => ! [L4: list @ A] :
                          ( ( Xa
                            = ( cons @ ( list @ A ) @ L4 @ ( nil @ ( list @ A ) ) ) )
                         => ( Y
                           != ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L4 @ ( cons @ ( list @ A ) @ La @ Acc2 ) ) ) ) ) )
                 => ~ ! [L1: list @ A,L2: list @ A,Ls2: list @ ( list @ A )] :
                        ( ( Xa
                          = ( cons @ ( list @ A ) @ L1 @ ( cons @ ( list @ A ) @ L2 @ Ls2 ) ) )
                       => ( Y
                         != ( merge_list @ A @ ( cons @ ( list @ A ) @ ( merge @ A @ L1 @ L2 ) @ X ) @ Ls2 ) ) ) ) ) ) ) ) ) ).

% merge_list.elims
thf(fact_4157_atMost__Int__atLeast,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [N: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atMost @ A @ N ) @ ( set_ord_atLeast @ A @ N ) )
          = ( insert3 @ A @ N @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atMost_Int_atLeast
thf(fact_4158_Int__atLeastAtMostL2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A3 @ B2 ) @ ( set_ord_atLeast @ A @ C2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ B2 ) ) ) ).

% Int_atLeastAtMostL2
thf(fact_4159_Int__atLeastAtMostR2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,C2: A,D3: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ A3 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D3 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A3 @ C2 ) @ D3 ) ) ) ).

% Int_atLeastAtMostR2
thf(fact_4160_group__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ! [A6: A] :
          ( ( F2 @ Z2 @ A6 )
          = A6 )
     => ( ! [A6: A] :
            ( ( F2 @ ( Inverse @ A6 ) @ A6 )
            = Z2 )
       => ( group_axioms @ A @ F2 @ Z2 @ Inverse ) ) ) ).

% group_axioms.intro
thf(fact_4161_group__axioms__def,axiom,
    ! [A: $tType] :
      ( ( group_axioms @ A )
      = ( ^ [F3: A > A > A,Z3: A,Inverse2: A > A] :
            ( ! [A4: A] :
                ( ( F3 @ Z3 @ A4 )
                = A4 )
            & ! [A4: A] :
                ( ( F3 @ ( Inverse2 @ A4 ) @ A4 )
                = Z3 ) ) ) ) ).

% group_axioms_def
thf(fact_4162_merge__list_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) )
        = ( nil @ A ) ) ) ).

% merge_list.simps(1)
thf(fact_4163_ivl__disj__int__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(8)
thf(fact_4164_atLeastAtMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or1337092689740270186AtMost @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ L3 ) @ ( set_ord_atMost @ A @ U2 ) ) ) ) ) ).

% atLeastAtMost_def
thf(fact_4165_atLeastLessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ L3 ) @ ( set_ord_lessThan @ A @ U2 ) ) ) ) ) ).

% atLeastLessThan_def
thf(fact_4166_ivl__disj__int__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(6)
thf(fact_4167_group_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z2 @ Inverse )
     => ( group_axioms @ A @ F2 @ Z2 @ Inverse ) ) ).

% group.axioms(2)
thf(fact_4168_mergesort__remdups__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( mergesort_remdups @ A )
        = ( ^ [Xs4: list @ A] :
              ( merge_list @ A @ ( nil @ ( list @ A ) )
              @ ( map @ A @ ( list @ A )
                @ ^ [X2: A] : ( cons @ A @ X2 @ ( nil @ A ) )
                @ Xs4 ) ) ) ) ) ).

% mergesort_remdups_def
thf(fact_4169_merge__list_Opelims,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: list @ ( list @ A ),Xa: list @ ( list @ A ),Y: list @ A] :
          ( ( ( merge_list @ A @ X @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) @ ( merge_list_rel @ A ) @ ( product_Pair @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) @ X @ Xa ) )
           => ( ( ( X
                  = ( nil @ ( list @ A ) ) )
               => ( ( Xa
                    = ( nil @ ( list @ A ) ) )
                 => ( ( Y
                      = ( nil @ A ) )
                   => ~ ( accp @ ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) @ ( merge_list_rel @ A ) @ ( product_Pair @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) ) ) ) ) )
             => ( ( ( X
                    = ( nil @ ( list @ A ) ) )
                 => ! [L4: list @ A] :
                      ( ( Xa
                        = ( cons @ ( list @ A ) @ L4 @ ( nil @ ( list @ A ) ) ) )
                     => ( ( Y = L4 )
                       => ~ ( accp @ ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) @ ( merge_list_rel @ A ) @ ( product_Pair @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L4 @ ( nil @ ( list @ A ) ) ) ) ) ) ) )
               => ( ! [La: list @ A,Acc2: list @ ( list @ A )] :
                      ( ( X
                        = ( cons @ ( list @ A ) @ La @ Acc2 ) )
                     => ( ( Xa
                          = ( nil @ ( list @ A ) ) )
                       => ( ( Y
                            = ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ La @ Acc2 ) ) )
                         => ~ ( accp @ ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) @ ( merge_list_rel @ A ) @ ( product_Pair @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ La @ Acc2 ) @ ( nil @ ( list @ A ) ) ) ) ) ) )
                 => ( ! [La: list @ A,Acc2: list @ ( list @ A )] :
                        ( ( X
                          = ( cons @ ( list @ A ) @ La @ Acc2 ) )
                       => ! [L4: list @ A] :
                            ( ( Xa
                              = ( cons @ ( list @ A ) @ L4 @ ( nil @ ( list @ A ) ) ) )
                           => ( ( Y
                                = ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L4 @ ( cons @ ( list @ A ) @ La @ Acc2 ) ) ) )
                             => ~ ( accp @ ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) @ ( merge_list_rel @ A ) @ ( product_Pair @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ La @ Acc2 ) @ ( cons @ ( list @ A ) @ L4 @ ( nil @ ( list @ A ) ) ) ) ) ) ) )
                   => ~ ! [L1: list @ A,L2: list @ A,Ls2: list @ ( list @ A )] :
                          ( ( Xa
                            = ( cons @ ( list @ A ) @ L1 @ ( cons @ ( list @ A ) @ L2 @ Ls2 ) ) )
                         => ( ( Y
                              = ( merge_list @ A @ ( cons @ ( list @ A ) @ ( merge @ A @ L1 @ L2 ) @ X ) @ Ls2 ) )
                           => ~ ( accp @ ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) @ ( merge_list_rel @ A ) @ ( product_Pair @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) @ X @ ( cons @ ( list @ A ) @ L1 @ ( cons @ ( list @ A ) @ L2 @ Ls2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% merge_list.pelims
thf(fact_4170_merge__list_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( accp @ ( product_prod @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) ) @ ( merge_list_rel @ A ) @ ( product_Pair @ ( list @ ( list @ A ) ) @ ( list @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) ) )
       => ( ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) )
          = ( nil @ A ) ) ) ) ).

% merge_list.psimps(1)
thf(fact_4171_folding__insort__key_Oaxioms_I2_J,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S @ F2 )
     => ( foldin3648464208017769352axioms @ B @ A @ S @ F2 ) ) ).

% folding_insort_key.axioms(2)
thf(fact_4172_folding__insort__key__axioms__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldin3648464208017769352axioms @ B @ A )
      = ( ^ [S7: set @ B,F3: B > A] : ( inj_on @ B @ A @ F3 @ S7 ) ) ) ).

% folding_insort_key_axioms_def
thf(fact_4173_folding__insort__key__axioms_Ointro,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S: set @ B] :
      ( ( inj_on @ B @ A @ F2 @ S )
     => ( foldin3648464208017769352axioms @ B @ A @ S @ F2 ) ) ).

% folding_insort_key_axioms.intro
thf(fact_4174_rel__restrict__alt__def,axiom,
    ! [A: $tType] :
      ( ( rel_restrict @ A )
      = ( ^ [R2: set @ ( product_prod @ A @ A ),A10: set @ A] :
            ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R2
            @ ( product_Sigma @ A @ A @ ( uminus_uminus @ ( set @ A ) @ A10 )
              @ ^ [Uu2: A] : ( uminus_uminus @ ( set @ A ) @ A10 ) ) ) ) ) ).

% rel_restrict_alt_def
thf(fact_4175_partition__rev_Oelims,axiom,
    ! [A: $tType,X: A > $o,Xa: product_prod @ ( list @ A ) @ ( list @ A ),Xb: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( partition_rev @ A @ X @ Xa @ Xb )
        = Y )
     => ( ! [Yes: list @ A,No: list @ A] :
            ( ( Xa
              = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
           => ( ( Xb
                = ( nil @ A ) )
             => ( Y
               != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) ) ) )
       => ~ ! [Yes: list @ A,No: list @ A] :
              ( ( Xa
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
             => ! [X3: A,Xs2: list @ A] :
                  ( ( Xb
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ( Y
                   != ( partition_rev @ A @ X @ ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( X @ X3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Yes ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ ( cons @ A @ X3 @ No ) ) ) @ Xs2 ) ) ) ) ) ) ).

% partition_rev.elims
thf(fact_4176_sort__quicksort__by__rel,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ A @ A
          @ ^ [X2: A] : X2 )
        = ( quicksort_by_rel @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ) ).

% sort_quicksort_by_rel
thf(fact_4177_total__on__imp__Total__Restr,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( total_on @ A @ A5 @ R4 )
     => ( total_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% total_on_imp_Total_Restr
thf(fact_4178_quicksort__by__rel_Osimps_I1_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl2: list @ A] :
      ( ( quicksort_by_rel @ A @ R @ Sl2 @ ( nil @ A ) )
      = Sl2 ) ).

% quicksort_by_rel.simps(1)
thf(fact_4179_total__lexord,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( total_on @ A @ ( top_top @ ( set @ A ) ) @ R4 )
     => ( total_on @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) @ ( lexord @ A @ R4 ) ) ) ).

% total_lexord
thf(fact_4180_total__lenlex,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( total_on @ A @ ( top_top @ ( set @ A ) ) @ R4 )
     => ( total_on @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) @ ( lenlex @ A @ R4 ) ) ) ).

% total_lenlex
thf(fact_4181_quicksort__by__rel__remove__acc__guared,axiom,
    ! [A: $tType,Sl2: list @ A,R: A > A > $o,Xs: list @ A] :
      ( ( Sl2
       != ( nil @ A ) )
     => ( ( quicksort_by_rel @ A @ R @ Sl2 @ Xs )
        = ( append @ A @ ( quicksort_by_rel @ A @ R @ ( nil @ A ) @ Xs ) @ Sl2 ) ) ) ).

% quicksort_by_rel_remove_acc_guared
thf(fact_4182_quicksort__by__rel__remove__acc,axiom,
    ! [A: $tType] :
      ( ( quicksort_by_rel @ A )
      = ( ^ [R2: A > A > $o,Sl3: list @ A,Xs4: list @ A] : ( append @ A @ ( quicksort_by_rel @ A @ R2 @ ( nil @ A ) @ Xs4 ) @ Sl3 ) ) ) ).

% quicksort_by_rel_remove_acc
thf(fact_4183_sorted__wrt__quicksort__by__rel,axiom,
    ! [X9: $tType,R: X9 > X9 > $o,Xs: list @ X9] :
      ( ! [X3: X9,Y3: X9] :
          ( ( R @ X3 @ Y3 )
          | ( R @ Y3 @ X3 ) )
     => ( ! [X3: X9,Y3: X9,Z4: X9] :
            ( ( R @ X3 @ Y3 )
           => ( ( R @ Y3 @ Z4 )
             => ( R @ X3 @ Z4 ) ) )
       => ( sorted_wrt @ X9 @ R @ ( quicksort_by_rel @ X9 @ R @ ( nil @ X9 ) @ Xs ) ) ) ) ).

% sorted_wrt_quicksort_by_rel
thf(fact_4184_partition__rev_Osimps_I1_J,axiom,
    ! [A: $tType,P2: A > $o,Yes2: list @ A,No2: list @ A] :
      ( ( partition_rev @ A @ P2 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ No2 ) ) ).

% partition_rev.simps(1)
thf(fact_4185_quicksort__by__rel_Oelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( quicksort_by_rel @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xb
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ~ ! [X3: A,Xs2: list @ A] :
              ( ( Xb
                = ( cons @ A @ X3 @ Xs2 ) )
             => ( Y
               != ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
                  @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ X @ ( cons @ A @ X3 @ ( quicksort_by_rel @ A @ X @ Xa @ Xs_b ) ) @ Xs_s )
                  @ ( partition_rev @ A
                    @ ^ [Y2: A] : ( X @ Y2 @ X3 )
                    @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                    @ Xs2 ) ) ) ) ) ) ).

% quicksort_by_rel.elims
thf(fact_4186_quicksort__by__rel_Osimps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl2: list @ A,X: A,Xs: list @ A] :
      ( ( quicksort_by_rel @ A @ R @ Sl2 @ ( cons @ A @ X @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
        @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ R @ ( cons @ A @ X @ ( quicksort_by_rel @ A @ R @ Sl2 @ Xs_b ) ) @ Xs_s )
        @ ( partition_rev @ A
          @ ^ [Y2: A] : ( R @ Y2 @ X )
          @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
          @ Xs ) ) ) ).

% quicksort_by_rel.simps(2)
thf(fact_4187_rel__restrict__Int__empty,axiom,
    ! [A: $tType,A5: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ ( field2 @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( rel_restrict @ A @ R @ A5 )
        = R ) ) ).

% rel_restrict_Int_empty
thf(fact_4188_sorted__quicksort__by__rel,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( quicksort_by_rel @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) @ Xs ) ) ) ).

% sorted_quicksort_by_rel
thf(fact_4189_rel__restrict__compl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( rel_restrict @ A @ R @ A5 ) @ ( rel_restrict @ A @ R @ ( uminus_uminus @ ( set @ A ) @ A5 ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% rel_restrict_compl
thf(fact_4190_Total__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( total_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( total_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% Total_Restr
thf(fact_4191_quicksort__by__rel_Opelims,axiom,
    ! [A: $tType,X: A > A > $o,Xa: list @ A,Xb: list @ A,Y: list @ A] :
      ( ( ( quicksort_by_rel @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ Xb ) ) )
       => ( ( ( Xb
              = ( nil @ A ) )
           => ( ( Y = Xa )
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( nil @ A ) ) ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( Xb
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ( ( Y
                    = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
                      @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ X @ ( cons @ A @ X3 @ ( quicksort_by_rel @ A @ X @ Xa @ Xs_b ) ) @ Xs_s )
                      @ ( partition_rev @ A
                        @ ^ [Y2: A] : ( X @ Y2 @ X3 )
                        @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                        @ Xs2 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xa @ ( cons @ A @ X3 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% quicksort_by_rel.pelims
thf(fact_4192_quicksort__by__rel_Opsimps_I2_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl2: list @ A,X: A,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl2 @ ( cons @ A @ X @ Xs ) ) ) )
     => ( ( quicksort_by_rel @ A @ R @ Sl2 @ ( cons @ A @ X @ Xs ) )
        = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
          @ ^ [Xs_s: list @ A,Xs_b: list @ A] : ( quicksort_by_rel @ A @ R @ ( cons @ A @ X @ ( quicksort_by_rel @ A @ R @ Sl2 @ Xs_b ) ) @ Xs_s )
          @ ( partition_rev @ A
            @ ^ [Y2: A] : ( R @ Y2 @ X )
            @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
            @ Xs ) ) ) ) ).

% quicksort_by_rel.psimps(2)
thf(fact_4193_quicksort__by__rel_Opinduct,axiom,
    ! [A: $tType,A0: A > A > $o,A1: list @ A,A22: list @ A,P2: ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ A0 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A1 @ A22 ) ) )
     => ( ! [R6: A > A > $o,Sl: list @ A] :
            ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R6 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( nil @ A ) ) ) )
           => ( P2 @ R6 @ Sl @ ( nil @ A ) ) )
       => ( ! [R6: A > A > $o,Sl: list @ A,X3: A,Xs2: list @ A] :
              ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R6 @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl @ ( cons @ A @ X3 @ Xs2 ) ) ) )
             => ( ! [Xa2: product_prod @ ( list @ A ) @ ( list @ A ),Xb2: list @ A,Y5: list @ A] :
                    ( ( Xa2
                      = ( partition_rev @ A
                        @ ^ [Z3: A] : ( R6 @ Z3 @ X3 )
                        @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                        @ Xs2 ) )
                   => ( ( ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xb2 @ Y5 )
                        = Xa2 )
                     => ( P2 @ R6 @ Sl @ Y5 ) ) )
               => ( ! [Xa2: product_prod @ ( list @ A ) @ ( list @ A ),Xb2: list @ A,Y5: list @ A] :
                      ( ( Xa2
                        = ( partition_rev @ A
                          @ ^ [Z3: A] : ( R6 @ Z3 @ X3 )
                          @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) )
                          @ Xs2 ) )
                     => ( ( ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xb2 @ Y5 )
                          = Xa2 )
                       => ( P2 @ R6 @ ( cons @ A @ X3 @ ( quicksort_by_rel @ A @ R6 @ Sl @ Y5 ) ) @ Xb2 ) ) )
                 => ( P2 @ R6 @ Sl @ ( cons @ A @ X3 @ Xs2 ) ) ) ) )
         => ( P2 @ A0 @ A1 @ A22 ) ) ) ) ).

% quicksort_by_rel.pinduct
thf(fact_4194_quicksort__by__rel_Opsimps_I1_J,axiom,
    ! [A: $tType,R: A > A > $o,Sl2: list @ A] :
      ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( quicksort_by_rel_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ R @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Sl2 @ ( nil @ A ) ) ) )
     => ( ( quicksort_by_rel @ A @ R @ Sl2 @ ( nil @ A ) )
        = Sl2 ) ) ).

% quicksort_by_rel.psimps(1)
thf(fact_4195_partition__rev_Opelims,axiom,
    ! [A: $tType,X: A > $o,Xa: product_prod @ ( list @ A ) @ ( list @ A ),Xb: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( partition_rev @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) @ ( partition_rev_rel @ A ) @ ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ Xa @ Xb ) ) )
       => ( ! [Yes: list @ A,No: list @ A] :
              ( ( Xa
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
             => ( ( Xb
                  = ( nil @ A ) )
               => ( ( Y
                    = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
                 => ~ ( accp @ ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) @ ( partition_rev_rel @ A ) @ ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( nil @ A ) ) ) ) ) ) )
         => ~ ! [Yes: list @ A,No: list @ A] :
                ( ( Xa
                  = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) )
               => ! [X3: A,Xs2: list @ A] :
                    ( ( Xb
                      = ( cons @ A @ X3 @ Xs2 ) )
                   => ( ( Y
                        = ( partition_rev @ A @ X @ ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( X @ X3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Yes ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ ( cons @ A @ X3 @ No ) ) ) @ Xs2 ) )
                     => ~ ( accp @ ( product_prod @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) ) @ ( partition_rev_rel @ A ) @ ( product_Pair @ ( A > $o ) @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ X @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No ) @ ( cons @ A @ X3 @ Xs2 ) ) ) ) ) ) ) ) ) ) ).

% partition_rev.pelims
thf(fact_4196_mergesort__by__rel__split_Opelims,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A ),Xa: list @ A,Y: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ( ( merges295452479951948502_split @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ X @ Xa ) )
       => ( ! [Xs1: list @ A,Xs22: list @ A] :
              ( ( X
                = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) )
             => ( ( Xa
                  = ( nil @ A ) )
               => ( ( Y
                    = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) )
                 => ~ ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) @ ( nil @ A ) ) ) ) ) )
         => ( ! [Xs1: list @ A,Xs22: list @ A] :
                ( ( X
                  = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) )
               => ! [X3: A] :
                    ( ( Xa
                      = ( cons @ A @ X3 @ ( nil @ A ) ) )
                   => ( ( Y
                        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs1 ) @ Xs22 ) )
                     => ~ ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) ) )
           => ~ ! [Xs1: list @ A,Xs22: list @ A] :
                  ( ( X
                    = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) )
                 => ! [X1: A,X23: A,Xs2: list @ A] :
                      ( ( Xa
                        = ( cons @ A @ X1 @ ( cons @ A @ X23 @ Xs2 ) ) )
                     => ( ( Y
                          = ( merges295452479951948502_split @ A @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X1 @ Xs1 ) @ ( cons @ A @ X23 @ Xs22 ) ) @ Xs2 ) )
                       => ~ ( accp @ ( product_prod @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) ) @ ( merges7066485432131860899it_rel @ A ) @ ( product_Pair @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( list @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs1 @ Xs22 ) @ ( cons @ A @ X1 @ ( cons @ A @ X23 @ Xs2 ) ) ) ) ) ) ) ) ) ) ) ).

% mergesort_by_rel_split.pelims
thf(fact_4197_Max_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic643756798349783984er_Max @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( ord_max @ A ) @ Xs @ X ) ) ) ).

% Max.set_eq_fold
thf(fact_4198_integer__of__nat__1,axiom,
    ( ( code_integer_of_nat @ ( one_one @ nat ) )
    = ( one_one @ code_integer ) ) ).

% integer_of_nat_1
thf(fact_4199_Image__Int__eq,axiom,
    ! [A: $tType,B: $tType,R: set @ ( product_prod @ B @ A ),A5: set @ B,B4: set @ B] :
      ( ( single_valued @ A @ B @ ( converse @ B @ A @ R ) )
     => ( ( image @ B @ A @ R @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
        = ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ R @ A5 ) @ ( image @ B @ A @ R @ B4 ) ) ) ) ).

% Image_Int_eq
thf(fact_4200_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat,S3: A] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S @ ( set_ord_lessThan @ A @ S3 ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S @ ( set_ord_lessThan @ A @ S3 ) ) @ N )
              = ( infini527867602293511546merate @ A @ S @ N ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_4201_max__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_min @ A @ X @ Y ) ) ) ) ) ).

% max_of_antimono
thf(fact_4202_min__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_max @ A @ X @ Y ) ) ) ) ) ).

% min_of_antimono
thf(fact_4203_single__valued__inter2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( single_valued @ A @ B @ R )
     => ( single_valued @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ S @ R ) ) ) ).

% single_valued_inter2
thf(fact_4204_single__valued__inter1,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( single_valued @ A @ B @ R )
     => ( single_valued @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) ) ).

% single_valued_inter1
thf(fact_4205_well__order__on__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( field2 @ A @ R4 ) )
       => ( order_well_order_on @ A @ A5
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) ) ) ) ).

% well_order_on_Restr
thf(fact_4206_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N3: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_4207_list__all__iff__all__interval__int,axiom,
    ! [P2: int > $o,I2: int,J: int] :
      ( ( list_all @ int @ P2 @ ( upto @ I2 @ J ) )
      = ( all_interval_int @ P2 @ I2 @ J ) ) ).

% list_all_iff_all_interval_int
thf(fact_4208_list__ex__iff__not__all__inverval__int,axiom,
    ! [P2: int > $o,I2: int,J: int] :
      ( ( list_ex @ int @ P2 @ ( upto @ I2 @ J ) )
      = ( ~ ( all_interval_int @ ( comp @ $o @ $o @ int @ (~) @ P2 ) @ I2 @ J ) ) ) ).

% list_ex_iff_not_all_inverval_int
thf(fact_4209_Well__order__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( order_well_order_on @ A
        @ ( field2 @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ A5
              @ ^ [Uu2: A] : A5 ) ) )
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% Well_order_Restr
thf(fact_4210_all__interval__int__def,axiom,
    ( all_interval_int
    = ( ^ [P: int > $o,I4: int,J2: int] :
        ! [X2: int] :
          ( ( member2 @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ I4 @ J2 ) )
         => ( P @ X2 ) ) ) ) ).

% all_interval_int_def
thf(fact_4211_ofilter__Restr__Int,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,B4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( order_ofilter @ A
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
            @ ( product_Sigma @ A @ A @ B4
              @ ^ [Uu2: A] : B4 ) )
          @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% ofilter_Restr_Int
thf(fact_4212_ofilter__Restr__subset,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,B4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
         => ( order_ofilter @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ B4
                @ ^ [Uu2: A] : B4 ) )
            @ A5 ) ) ) ) ).

% ofilter_Restr_subset
thf(fact_4213_Field__Restr__ofilter,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( field2 @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ A5
                @ ^ [Uu2: A] : A5 ) ) )
          = A5 ) ) ) ).

% Field_Restr_ofilter
thf(fact_4214_ofilter__subset__embedS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,B4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( order_ofilter @ A @ R4 @ B4 )
         => ( ( ord_less @ ( set @ A ) @ A5 @ B4 )
            = ( bNF_Wellorder_embedS @ A @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A5
                  @ ^ [Uu2: A] : A5 ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ B4
                  @ ^ [Uu2: A] : B4 ) )
              @ ( id @ A ) ) ) ) ) ) ).

% ofilter_subset_embedS
thf(fact_4215_ofilter__subset__embedS__iso,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,B4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( order_ofilter @ A @ R4 @ B4 )
         => ( ( ( ord_less @ ( set @ A ) @ A5 @ B4 )
              = ( bNF_Wellorder_embedS @ A @ A
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A5
                    @ ^ [Uu2: A] : A5 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B4
                    @ ^ [Uu2: A] : B4 ) )
                @ ( id @ A ) ) )
            & ( ( A5 = B4 )
              = ( bNF_Wellorder_iso @ A @ A
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A5
                    @ ^ [Uu2: A] : A5 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B4
                    @ ^ [Uu2: A] : B4 ) )
                @ ( id @ A ) ) ) ) ) ) ) ).

% ofilter_subset_embedS_iso
thf(fact_4216_ofilter__subset__embed,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,B4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( order_ofilter @ A @ R4 @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
            = ( bNF_Wellorder_embed @ A @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A5
                  @ ^ [Uu2: A] : A5 ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ B4
                  @ ^ [Uu2: A] : B4 ) )
              @ ( id @ A ) ) ) ) ) ) ).

% ofilter_subset_embed
thf(fact_4217_ofilter__embed,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
        = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( field2 @ A @ R4 ) )
          & ( bNF_Wellorder_embed @ A @ A
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ A5
                @ ^ [Uu2: A] : A5 ) )
            @ R4
            @ ( id @ A ) ) ) ) ) ).

% ofilter_embed
thf(fact_4218_ofilter__subset__ordLess,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,B4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( order_ofilter @ A @ R4 @ B4 )
         => ( ( ord_less @ ( set @ A ) @ A5 @ B4 )
            = ( member2 @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A5
                    @ ^ [Uu2: A] : A5 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B4
                    @ ^ [Uu2: A] : B4 ) ) )
              @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ) ).

% ofilter_subset_ordLess
thf(fact_4219_embed__implies__iso__Restr,axiom,
    ! [A: $tType,B: $tType,R4: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B ),F2: B > A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R7 ) @ R7 )
       => ( ( bNF_Wellorder_embed @ B @ A @ R7 @ R4 @ F2 )
         => ( bNF_Wellorder_iso @ B @ A @ R7
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ ( image2 @ B @ A @ F2 @ ( field2 @ B @ R7 ) )
                @ ^ [Uu2: A] : ( image2 @ B @ A @ F2 @ ( field2 @ B @ R7 ) ) ) )
            @ F2 ) ) ) ) ).

% embed_implies_iso_Restr
thf(fact_4220_ofilter__ordLess,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( ord_less @ ( set @ A ) @ A5 @ ( field2 @ A @ R4 ) )
          = ( member2 @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
            @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A5
                  @ ^ [Uu2: A] : A5 ) )
              @ R4 )
            @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ).

% ofilter_ordLess
thf(fact_4221_underS__Restr__ordLess,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A3: A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( ( field2 @ A @ R4 )
         != ( bot_bot @ ( set @ A ) ) )
       => ( member2 @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
          @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
            @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
              @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ A3 )
                @ ^ [Uu2: A] : ( order_underS @ A @ R4 @ A3 ) ) )
            @ R4 )
          @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ).

% underS_Restr_ordLess
thf(fact_4222_ofilter__subset__ordLeq,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,B4: set @ A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( order_ofilter @ A @ R4 @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
            = ( member2 @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
              @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ A5
                    @ ^ [Uu2: A] : A5 ) )
                @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                  @ ( product_Sigma @ A @ A @ B4
                    @ ^ [Uu2: A] : B4 ) ) )
              @ ( bNF_Wellorder_ordLeq @ A @ A ) ) ) ) ) ) ).

% ofilter_subset_ordLeq
thf(fact_4223_ofilter__Restr__under,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A,A3: A] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_ofilter @ A @ R4 @ A5 )
       => ( ( member2 @ A @ A3 @ A5 )
         => ( ( order_under @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ A5
                  @ ^ [Uu2: A] : A5 ) )
              @ A3 )
            = ( order_under @ A @ R4 @ A3 ) ) ) ) ) ).

% ofilter_Restr_under
thf(fact_4224_is__num__normalize_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( neg_numeral_is_num @ A @ ( one_one @ A ) ) ) ).

% is_num_normalize(4)
thf(fact_4225_ordLeq__iff__ordLess__Restr,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R7 ) @ R7 )
       => ( ( member2 @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ R7 ) @ ( bNF_Wellorder_ordLeq @ A @ B ) )
          = ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( field2 @ A @ R4 ) )
               => ( member2 @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) )
                  @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) )
                    @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                      @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ X2 )
                        @ ^ [Uu2: A] : ( order_underS @ A @ R4 @ X2 ) ) )
                    @ R7 )
                  @ ( bNF_We4044943003108391690rdLess @ A @ B ) ) ) ) ) ) ) ).

% ordLeq_iff_ordLess_Restr
thf(fact_4226_is__num_Ocases,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A3: A] :
          ( ( neg_numeral_is_num @ A @ A3 )
         => ( ( A3
             != ( one_one @ A ) )
           => ( ! [X3: A] :
                  ( ( A3
                    = ( uminus_uminus @ A @ X3 ) )
                 => ~ ( neg_numeral_is_num @ A @ X3 ) )
             => ~ ! [X3: A,Y3: A] :
                    ( ( A3
                      = ( plus_plus @ A @ X3 @ Y3 ) )
                   => ( ( neg_numeral_is_num @ A @ X3 )
                     => ~ ( neg_numeral_is_num @ A @ Y3 ) ) ) ) ) ) ) ).

% is_num.cases
thf(fact_4227_is__num_Osimps,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_is_num @ A )
        = ( ^ [A4: A] :
              ( ( A4
                = ( one_one @ A ) )
              | ? [X2: A] :
                  ( ( A4
                    = ( uminus_uminus @ A @ X2 ) )
                  & ( neg_numeral_is_num @ A @ X2 ) )
              | ? [X2: A,Y2: A] :
                  ( ( A4
                    = ( plus_plus @ A @ X2 @ Y2 ) )
                  & ( neg_numeral_is_num @ A @ X2 )
                  & ( neg_numeral_is_num @ A @ Y2 ) ) ) ) ) ) ).

% is_num.simps
thf(fact_4228_ordLess__iff__ordIso__Restr,axiom,
    ! [B: $tType,A: $tType,R4: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ B @ B )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( order_well_order_on @ B @ ( field2 @ B @ R7 ) @ R7 )
       => ( ( member2 @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R7 @ R4 ) @ ( bNF_We4044943003108391690rdLess @ B @ A ) )
          = ( ? [X2: A] :
                ( ( member2 @ A @ X2 @ ( field2 @ A @ R4 ) )
                & ( member2 @ ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                  @ ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R7
                    @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                      @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ X2 )
                        @ ^ [Uu2: A] : ( order_underS @ A @ R4 @ X2 ) ) ) )
                  @ ( bNF_Wellorder_ordIso @ B @ A ) ) ) ) ) ) ) ).

% ordLess_iff_ordIso_Restr
thf(fact_4229_greaterThanLessThan__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or5935395276787703475ssThan @ A )
        = ( ^ [A4: A,B3: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A4 ) @ ( set_ord_lessThan @ A @ B3 ) ) ) ) ) ).

% greaterThanLessThan_eq
thf(fact_4230_greaterThanLessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or5935395276787703475ssThan @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ L3 ) @ ( set_ord_lessThan @ A @ U2 ) ) ) ) ) ).

% greaterThanLessThan_def
thf(fact_4231_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,Xs: list @ B] :
      ( ( map_filter @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F2 @ Xs )
        @ ^ [Y2: A] : ( cons @ A @ Y2 @ ( map_filter @ B @ A @ F2 @ Xs ) )
        @ ( F2 @ X ) ) ) ).

% map_filter_simps(1)
thf(fact_4232_lessThan__Int__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A3 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( set_ord_greaterThan @ A @ ( ord_max @ A @ A3 @ B2 ) ) ) ) ).

% lessThan_Int_lessThan
thf(fact_4233_ivl__disj__int__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(7)
thf(fact_4234_ivl__disj__int__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,U: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ).

% ivl_disj_int_one(5)
thf(fact_4235_greaterThanAtMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [L3: A,U2: A] : ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ L3 ) @ ( set_ord_atMost @ A @ U2 ) ) ) ) ) ).

% greaterThanAtMost_def
thf(fact_4236_mult__one__div__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ A3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ B2 ) ) )
          = ( divide_divide @ A @ A3 @ ( unit_f5069060285200089521factor @ A @ B2 ) ) ) ) ).

% mult_one_div_unit_factor
thf(fact_4237_unit__factor__mult__unit__right,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ B2 @ A3 ) )
            = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ B2 ) @ A3 ) ) ) ) ).

% unit_factor_mult_unit_right
thf(fact_4238_unit__factor__mult__unit__left,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( times_times @ A @ A3 @ ( unit_f5069060285200089521factor @ A @ B2 ) ) ) ) ) ).

% unit_factor_mult_unit_left
thf(fact_4239_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite_folding_on @ A @ ( list @ A ) @ ( top_top @ ( set @ A ) )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
thf(fact_4240_unit__factor__simps_I2_J,axiom,
    ! [N: nat] :
      ( ( unit_f5069060285200089521factor @ nat @ ( suc @ N ) )
      = ( one_one @ nat ) ) ).

% unit_factor_simps(2)
thf(fact_4241_unit__factor__1,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( unit_f5069060285200089521factor @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% unit_factor_1
thf(fact_4242_inv__unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ A3 ) )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) ).

% inv_unit_factor_eq_0_iff
thf(fact_4243_unit__factor__mult,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A3: A,B2: A] :
          ( ( unit_f5069060285200089521factor @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) @ ( unit_f5069060285200089521factor @ A @ B2 ) ) ) ) ).

% unit_factor_mult
thf(fact_4244_is__unit__unit__factor,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ A3 )
            = A3 ) ) ) ).

% is_unit_unit_factor
thf(fact_4245_unit__factor__nat__def,axiom,
    ( ( unit_f5069060285200089521factor @ nat )
    = ( ^ [N3: nat] :
          ( if @ nat
          @ ( N3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( one_one @ nat ) ) ) ) ).

% unit_factor_nat_def
thf(fact_4246_mult__gcd__left,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ C2 ) @ ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_gcd_left
thf(fact_4247_mult__gcd__right,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ ( gcd_gcd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) @ ( unit_f5069060285200089521factor @ A @ C2 ) ) ) ) ).

% mult_gcd_right
thf(fact_4248_gcd__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [K: A,A3: A,B2: A] :
          ( ( times_times @ A @ K @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( gcd_gcd @ A @ ( times_times @ A @ K @ A3 ) @ ( times_times @ A @ K @ B2 ) ) @ ( unit_f5069060285200089521factor @ A @ K ) ) ) ) ).

% gcd_mult_distrib
thf(fact_4249_unit__factor__is__unit,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) @ ( one_one @ A ) ) ) ) ).

% unit_factor_is_unit
thf(fact_4250_unit__factor__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( A3
                = ( zero_zero @ A ) )
              & ( B2
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A3 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A3
                  = ( zero_zero @ A ) )
                & ( B2
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A3 @ B2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_gcd
thf(fact_4251_Lcm__no__units,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A )
        = ( ^ [A10: set @ A] :
              ( gcd_Lcm @ A
              @ ( minus_minus @ ( set @ A ) @ A10
                @ ( collect @ A
                  @ ^ [A4: A] : ( dvd_dvd @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% Lcm_no_units
thf(fact_4252_unit__factor__Gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( ( gcd_Gcd @ A @ A5 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A5 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Gcd @ A @ A5 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A5 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Gcd
thf(fact_4253_list__all__iff__all__interval__nat,axiom,
    ! [P2: nat > $o,I2: nat,J: nat] :
      ( ( list_all @ nat @ P2 @ ( upt @ I2 @ J ) )
      = ( all_interval_nat @ P2 @ I2 @ J ) ) ).

% list_all_iff_all_interval_nat
thf(fact_4254_list__ex__iff__not__all__inverval__nat,axiom,
    ! [P2: nat > $o,I2: nat,J: nat] :
      ( ( list_ex @ nat @ P2 @ ( upt @ I2 @ J ) )
      = ( ~ ( all_interval_nat @ ( comp @ $o @ $o @ nat @ (~) @ P2 ) @ I2 @ J ) ) ) ).

% list_ex_iff_not_all_inverval_nat
thf(fact_4255_Lcm__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Lcm_empty
thf(fact_4256_Lcm__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( gcd_Lcm @ A @ A5 )
            = ( one_one @ A ) )
          = ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ A5 )
               => ( dvd_dvd @ A @ X2 @ ( one_one @ A ) ) ) ) ) ) ).

% Lcm_1_iff
thf(fact_4257_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( top_top @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Gcd_UNIV
thf(fact_4258_Gcd__1,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A] :
          ( ( member2 @ A @ ( one_one @ A ) @ A5 )
         => ( ( gcd_Gcd @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_1
thf(fact_4259_Gcd__nat__eq__one,axiom,
    ! [N2: set @ nat] :
      ( ( member2 @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( gcd_Gcd @ nat @ N2 )
        = ( one_one @ nat ) ) ) ).

% Gcd_nat_eq_one
thf(fact_4260_Lcm__nat__empty,axiom,
    ( ( gcd_Lcm @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( one_one @ nat ) ) ).

% Lcm_nat_empty
thf(fact_4261_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: A,A5: set @ A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( member2 @ A @ A3 @ A5 )
           => ( ( gcd_Gcd @ A @ A5 )
              = ( one_one @ A ) ) ) ) ) ).

% Gcd_eq_1_I
thf(fact_4262_unit__factor__Lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( ( gcd_Lcm @ A @ A5 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A5 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Lcm @ A @ A5 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A5 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Lcm
thf(fact_4263_all__interval__nat__def,axiom,
    ( all_interval_nat
    = ( ^ [P: nat > $o,I4: nat,J2: nat] :
        ! [X2: nat] :
          ( ( member2 @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ I4 @ J2 ) )
         => ( P @ X2 ) ) ) ) ).

% all_interval_nat_def
thf(fact_4264_listsp__mono,axiom,
    ! [A: $tType,A5: A > $o,B4: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ A5 @ B4 )
     => ( ord_less_eq @ ( ( list @ A ) > $o ) @ ( listsp @ A @ A5 ) @ ( listsp @ A @ B4 ) ) ) ).

% listsp_mono
thf(fact_4265_prod_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups4802862169904069756st_set @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod.comm_monoid_list_set_axioms
thf(fact_4266_prod_H__def,axiom,
    ! [C: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ C @ A )
        = ( groups_comm_monoid_G @ A @ C @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod'_def
thf(fact_4267_Lcm__set__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [Xs: list @ A] :
          ( ( gcd_Lcm @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_lcm @ A ) @ Xs @ ( one_one @ A ) ) ) ) ).

% Lcm_set_eq_fold
thf(fact_4268_listsp__conj__eq,axiom,
    ! [A: $tType,A5: A > $o,B4: A > $o] :
      ( ( listsp @ A
        @ ^ [X2: A] :
            ( ( A5 @ X2 )
            & ( B4 @ X2 ) ) )
      = ( ^ [X2: list @ A] :
            ( ( listsp @ A @ A5 @ X2 )
            & ( listsp @ A @ B4 @ X2 ) ) ) ) ).

% listsp_conj_eq
thf(fact_4269_lcm__1__iff__int,axiom,
    ! [M2: int,N: int] :
      ( ( ( gcd_lcm @ int @ M2 @ N )
        = ( one_one @ int ) )
      = ( ( ( M2
            = ( one_one @ int ) )
          | ( M2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
        & ( ( N
            = ( one_one @ int ) )
          | ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% lcm_1_iff_int
thf(fact_4270_listsp__simps_I1_J,axiom,
    ! [A: $tType,A5: A > $o] : ( listsp @ A @ A5 @ ( nil @ A ) ) ).

% listsp_simps(1)
thf(fact_4271_in__listspI,axiom,
    ! [A: $tType,Xs: list @ A,A5: A > $o] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( A5 @ X3 ) )
     => ( listsp @ A @ A5 @ Xs ) ) ).

% in_listspI
thf(fact_4272_append__in__listsp__conv,axiom,
    ! [A: $tType,A5: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( listsp @ A @ A5 @ ( append @ A @ Xs @ Ys ) )
      = ( ( listsp @ A @ A5 @ Xs )
        & ( listsp @ A @ A5 @ Ys ) ) ) ).

% append_in_listsp_conv
thf(fact_4273_listsp__inf__eq,axiom,
    ! [A: $tType,A5: A > $o,B4: A > $o] :
      ( ( listsp @ A @ ( inf_inf @ ( A > $o ) @ A5 @ B4 ) )
      = ( inf_inf @ ( ( list @ A ) > $o ) @ ( listsp @ A @ A5 ) @ ( listsp @ A @ B4 ) ) ) ).

% listsp_inf_eq
thf(fact_4274_lcm__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( gcd_lcm @ A @ A3 @ B2 )
            = ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% lcm_eq_1_iff
thf(fact_4275_unit__factor__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( ( A3
                = ( zero_zero @ A ) )
              | ( B2
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A3 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A3
                  = ( zero_zero @ A ) )
                | ( B2
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A3 @ B2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_lcm
thf(fact_4276_listsp__simps_I2_J,axiom,
    ! [A: $tType,A5: A > $o,X: A,Xs: list @ A] :
      ( ( listsp @ A @ A5 @ ( cons @ A @ X @ Xs ) )
      = ( ( A5 @ X )
        & ( listsp @ A @ A5 @ Xs ) ) ) ).

% listsp_simps(2)
thf(fact_4277_listsp_OCons,axiom,
    ! [A: $tType,A5: A > $o,A3: A,L: list @ A] :
      ( ( A5 @ A3 )
     => ( ( listsp @ A @ A5 @ L )
       => ( listsp @ A @ A5 @ ( cons @ A @ A3 @ L ) ) ) ) ).

% listsp.Cons
thf(fact_4278_listspE,axiom,
    ! [A: $tType,A5: A > $o,X: A,L: list @ A] :
      ( ( listsp @ A @ A5 @ ( cons @ A @ X @ L ) )
     => ~ ( ( A5 @ X )
         => ~ ( listsp @ A @ A5 @ L ) ) ) ).

% listspE
thf(fact_4279_listsp_ONil,axiom,
    ! [A: $tType,A5: A > $o] : ( listsp @ A @ A5 @ ( nil @ A ) ) ).

% listsp.Nil
thf(fact_4280_in__listspD,axiom,
    ! [A: $tType,A5: A > $o,Xs: list @ A] :
      ( ( listsp @ A @ A5 @ Xs )
     => ! [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
         => ( A5 @ X4 ) ) ) ).

% in_listspD
thf(fact_4281_in__listsp__conv__set,axiom,
    ! [A: $tType] :
      ( ( listsp @ A )
      = ( ^ [A10: A > $o,Xs4: list @ A] :
          ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs4 ) )
           => ( A10 @ X2 ) ) ) ) ).

% in_listsp_conv_set
thf(fact_4282_listsp__infI,axiom,
    ! [A: $tType,A5: A > $o,L: list @ A,B4: A > $o] :
      ( ( listsp @ A @ A5 @ L )
     => ( ( listsp @ A @ B4 @ L )
       => ( listsp @ A @ ( inf_inf @ ( A > $o ) @ A5 @ B4 ) @ L ) ) ) ).

% listsp_infI
thf(fact_4283_lists__def,axiom,
    ! [A: $tType] :
      ( ( lists @ A )
      = ( ^ [A10: set @ A] :
            ( collect @ ( list @ A )
            @ ( listsp @ A
              @ ^ [X2: A] : ( member2 @ A @ X2 @ A10 ) ) ) ) ) ).

% lists_def
thf(fact_4284_listsp__lists__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( listsp @ A
        @ ^ [X2: A] : ( member2 @ A @ X2 @ A5 ) )
      = ( ^ [X2: list @ A] : ( member2 @ ( list @ A ) @ X2 @ ( lists @ A @ A5 ) ) ) ) ).

% listsp_lists_eq
thf(fact_4285_mult__lcm__left,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ C2 ) @ ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_lcm_left
thf(fact_4286_mult__lcm__right,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A3 @ B2 ) @ C2 )
          = ( times_times @ A @ ( gcd_lcm @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) @ ( unit_f5069060285200089521factor @ A @ C2 ) ) ) ) ).

% mult_lcm_right
thf(fact_4287_lcm__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [K: A,A3: A,B2: A] :
          ( ( times_times @ A @ K @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( gcd_lcm @ A @ ( times_times @ A @ K @ A3 ) @ ( times_times @ A @ K @ B2 ) ) @ ( unit_f5069060285200089521factor @ A @ K ) ) ) ) ).

% lcm_mult_distrib
thf(fact_4288_Lcm__nat__set__eq__fold,axiom,
    ! [Xs: list @ nat] :
      ( ( gcd_Lcm @ nat @ ( set2 @ nat @ Xs ) )
      = ( fold @ nat @ nat @ ( gcd_lcm @ nat ) @ Xs @ ( one_one @ nat ) ) ) ).

% Lcm_nat_set_eq_fold
thf(fact_4289_listsp_Osimps,axiom,
    ! [A: $tType] :
      ( ( listsp @ A )
      = ( ^ [A10: A > $o,A4: list @ A] :
            ( ( A4
              = ( nil @ A ) )
            | ? [B3: A,L3: list @ A] :
                ( ( A4
                  = ( cons @ A @ B3 @ L3 ) )
                & ( A10 @ B3 )
                & ( listsp @ A @ A10 @ L3 ) ) ) ) ) ).

% listsp.simps
thf(fact_4290_listsp_Ocases,axiom,
    ! [A: $tType,A5: A > $o,A3: list @ A] :
      ( ( listsp @ A @ A5 @ A3 )
     => ( ( A3
         != ( nil @ A ) )
       => ~ ! [A6: A,L4: list @ A] :
              ( ( A3
                = ( cons @ A @ A6 @ L4 ) )
             => ( ( A5 @ A6 )
               => ~ ( listsp @ A @ A5 @ L4 ) ) ) ) ) ).

% listsp.cases
thf(fact_4291_Lcm__int__set__eq__fold,axiom,
    ! [Xs: list @ int] :
      ( ( gcd_Lcm @ int @ ( set2 @ int @ Xs ) )
      = ( fold @ int @ int @ ( gcd_lcm @ int ) @ Xs @ ( one_one @ int ) ) ) ).

% Lcm_int_set_eq_fold
thf(fact_4292_lcm__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ B2 @ ( times_times @ A @ C2 @ A3 ) )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_mult_unit2
thf(fact_4293_lcm__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ ( times_times @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_mult_unit1
thf(fact_4294_lcm__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ ( divide_divide @ A @ B2 @ A3 ) @ C2 )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_div_unit1
thf(fact_4295_lcm__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( gcd_lcm @ A @ B2 @ ( divide_divide @ A @ C2 @ A3 ) )
            = ( gcd_lcm @ A @ B2 @ C2 ) ) ) ) ).

% lcm_div_unit2
thf(fact_4296_Lcm__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( ^ [A10: set @ A] : ( if @ A @ ( finite_finite @ A @ A10 ) @ ( finite_fold @ A @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ A10 ) @ ( zero_zero @ A ) ) ) ) ) ).

% Lcm_fin.eq_fold
thf(fact_4297_Lcm__nat__def,axiom,
    ( ( gcd_Lcm @ nat )
    = ( ^ [M5: set @ nat] : ( if @ nat @ ( finite_finite @ nat @ M5 ) @ ( lattic5214292709420241887eutr_F @ nat @ ( gcd_lcm @ nat ) @ ( one_one @ nat ) @ M5 ) @ ( zero_zero @ nat ) ) ) ) ).

% Lcm_nat_def
thf(fact_4298_Lcm__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ).

% Lcm_fin_def
thf(fact_4299_Lcm__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A] :
          ( ( semiring_gcd_Lcm_fin @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_lcm @ A ) @ Xs @ ( one_one @ A ) ) ) ) ).

% Lcm_fin.set_eq_fold
thf(fact_4300_Lcm__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Lcm_fin.empty
thf(fact_4301_is__unit__Lcm__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Lcm_fin @ A @ A5 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Lcm_fin @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Lcm_fin_iff
thf(fact_4302_Lcm__fin__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( semiring_gcd_Lcm_fin @ A @ A5 )
            = ( one_one @ A ) )
          = ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ A5 )
               => ( dvd_dvd @ A @ X2 @ ( one_one @ A ) ) )
            & ( finite_finite @ A @ A5 ) ) ) ) ).

% Lcm_fin_1_iff
thf(fact_4303_gcd__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( gcd_gcd @ A @ A3 @ B2 )
              = ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ ( times_times @ A @ A3 @ B2 ) @ ( gcd_lcm @ A @ A3 @ B2 ) ) ) ) ) ) ) ).

% gcd_lcm
thf(fact_4304_count__mset__set_H,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( ( ( finite_finite @ A @ A5 )
          & ( member2 @ A @ X @ A5 ) )
       => ( ( count @ A @ ( mset_set @ A @ A5 ) @ X )
          = ( one_one @ nat ) ) )
      & ( ~ ( ( finite_finite @ A @ A5 )
            & ( member2 @ A @ X @ A5 ) )
       => ( ( count @ A @ ( mset_set @ A @ A5 ) @ X )
          = ( zero_zero @ nat ) ) ) ) ).

% count_mset_set'
thf(fact_4305_count__mset__set__finite__iff,axiom,
    ! [A: $tType,S: set @ A,A3: A] :
      ( ( finite_finite @ A @ S )
     => ( ( ( member2 @ A @ A3 @ S )
         => ( ( count @ A @ ( mset_set @ A @ S ) @ A3 )
            = ( one_one @ nat ) ) )
        & ( ~ ( member2 @ A @ A3 @ S )
         => ( ( count @ A @ ( mset_set @ A @ S ) @ A3 )
            = ( zero_zero @ nat ) ) ) ) ) ).

% count_mset_set_finite_iff
thf(fact_4306_monoid__list_ONil,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A] :
      ( ( groups_monoid_list @ A @ F2 @ Z2 )
     => ( ( groups_monoid_F @ A @ F2 @ Z2 @ ( nil @ A ) )
        = Z2 ) ) ).

% monoid_list.Nil
thf(fact_4307_normalize__mult__normalize__left,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% normalize_mult_normalize_left
thf(fact_4308_normalize__mult__normalize__right,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ ( normal6383669964737779283malize @ A @ B2 ) ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% normalize_mult_normalize_right
thf(fact_4309_gcd_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( normal6383669964737779283malize @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% gcd.normalize_bottom
thf(fact_4310_normalize__1,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( normal6383669964737779283malize @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% normalize_1
thf(fact_4311_lcm_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_lcm @ A @ A3 @ ( one_one @ A ) )
          = ( normal6383669964737779283malize @ A @ A3 ) ) ) ).

% lcm.top_right_normalize
thf(fact_4312_lcm_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] :
          ( ( gcd_lcm @ A @ ( one_one @ A ) @ A3 )
          = ( normal6383669964737779283malize @ A @ A3 ) ) ) ).

% lcm.top_left_normalize
thf(fact_4313_normalize__mult__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( unit_f5069060285200089521factor @ A @ A3 ) )
          = A3 ) ) ).

% normalize_mult_unit_factor
thf(fact_4314_unit__factor__mult__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( times_times @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ A3 ) )
          = A3 ) ) ).

% unit_factor_mult_normalize
thf(fact_4315_normalize__mult__unit__left,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% normalize_mult_unit_left
thf(fact_4316_normalize__mult__unit__right,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) )
            = ( normal6383669964737779283malize @ A @ A3 ) ) ) ) ).

% normalize_mult_unit_right
thf(fact_4317_normalize__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( unit_f5069060285200089521factor @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% normalize_unit_factor
thf(fact_4318_unit__factor__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( A3
           != ( zero_zero @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( normal6383669964737779283malize @ A @ A3 ) )
            = ( one_one @ A ) ) ) ) ).

% unit_factor_normalize
thf(fact_4319_lcm__mult__gcd,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A3 @ B2 ) @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% lcm_mult_gcd
thf(fact_4320_gcd__mult__lcm,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% gcd_mult_lcm
thf(fact_4321_normalize__div,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( divide_divide @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ A3 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ A3 ) ) ) ) ).

% normalize_div
thf(fact_4322_count__mset__set_I1_J,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( member2 @ A @ X @ A5 )
       => ( ( count @ A @ ( mset_set @ A @ A5 ) @ X )
          = ( one_one @ nat ) ) ) ) ).

% count_mset_set(1)
thf(fact_4323_normalize__mult,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A3: A,B2: A] :
          ( ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) )
          = ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ B2 ) ) ) ) ).

% normalize_mult
thf(fact_4324_associated__unit,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A,B2: A] :
          ( ( ( normal6383669964737779283malize @ A @ A3 )
            = ( normal6383669964737779283malize @ A @ B2 ) )
         => ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% associated_unit
thf(fact_4325_normalize__1__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A3 )
            = ( one_one @ A ) )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% normalize_1_iff
thf(fact_4326_is__unit__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( ( normal6383669964737779283malize @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_normalize
thf(fact_4327_normalize__idem__imp__is__unit__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A3: A] :
          ( ( ( normal6383669964737779283malize @ A @ A3 )
            = A3 )
         => ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
            = ( A3
              = ( one_one @ A ) ) ) ) ) ).

% normalize_idem_imp_is_unit_iff
thf(fact_4328_gcd__mult__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ) ).

% gcd_mult_left
thf(fact_4329_gcd__mult__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( gcd_gcd @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( gcd_gcd @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% gcd_mult_right
thf(fact_4330_gcd__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ C2 ) @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% gcd_mult_distrib'
thf(fact_4331_lcm__mult__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_lcm @ A @ A3 @ B2 ) ) ) ) ) ).

% lcm_mult_left
thf(fact_4332_lcm__mult__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( gcd_lcm @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ ( gcd_lcm @ A @ B2 @ A3 ) @ C2 ) ) ) ) ).

% lcm_mult_right
thf(fact_4333_lcm__mult__distrib_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ C2 ) @ ( gcd_lcm @ A @ A3 @ B2 ) )
          = ( gcd_lcm @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% lcm_mult_distrib'
thf(fact_4334_lcm__gcd__prod,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A3: A,B2: A] :
          ( ( times_times @ A @ ( gcd_lcm @ A @ A3 @ B2 ) @ ( gcd_gcd @ A @ A3 @ B2 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ).

% lcm_gcd_prod
thf(fact_4335_Gcd__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [C2: A,A5: set @ A] :
          ( ( gcd_Gcd @ A @ ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ A5 ) )
          = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_Gcd @ A @ A5 ) ) ) ) ) ).

% Gcd_mult
thf(fact_4336_prod__list_Omonoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( groups_monoid_list @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_list.monoid_list_axioms
thf(fact_4337_Lcm__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A,C2: A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( gcd_Lcm @ A @ ( image2 @ A @ A @ ( times_times @ A @ C2 ) @ A5 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ C2 @ ( gcd_Lcm @ A @ A5 ) ) ) ) ) ) ).

% Lcm_mult
thf(fact_4338_lcm__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( gcd_lcm @ A )
        = ( ^ [A4: A,B3: A] : ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ ( times_times @ A @ A4 @ B3 ) @ ( gcd_gcd @ A @ A4 @ B3 ) ) ) ) ) ) ).

% lcm_gcd
thf(fact_4339_Lcm__fin__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( semiring_gcd_Lcm_fin @ A @ ( image2 @ A @ A @ ( times_times @ A @ B2 ) @ A5 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ B2 @ ( semiring_gcd_Lcm_fin @ A @ A5 ) ) ) ) ) ) ).

% Lcm_fin_mult
thf(fact_4340_Gcd__fin__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( semiring_gcd_Gcd_fin @ A @ ( image2 @ A @ A @ ( times_times @ A @ B2 ) @ A5 ) )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ B2 @ ( semiring_gcd_Gcd_fin @ A @ A5 ) ) ) ) ) ) ).

% Gcd_fin_mult
thf(fact_4341_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
thf(fact_4342_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
thf(fact_4343_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% lcm.bounded_quasi_semilattice_axioms
thf(fact_4344_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% gcd.bounded_quasi_semilattice_axioms
thf(fact_4345_distinct__count__atmost__1,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [X2: list @ A] :
          ! [A4: A] :
            ( ( ( member2 @ A @ A4 @ ( set2 @ A @ X2 ) )
             => ( ( count @ A @ ( mset @ A @ X2 ) @ A4 )
                = ( one_one @ nat ) ) )
            & ( ~ ( member2 @ A @ A4 @ ( set2 @ A @ X2 ) )
             => ( ( count @ A @ ( mset @ A @ X2 ) @ A4 )
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% distinct_count_atmost_1
thf(fact_4346_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb @ Xa )
               => ( Y = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb @ Xa )
               => ( Y
                  = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_4347_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: nat > A > A,A3: nat,B2: nat,Acc3: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A3 @ ( product_Pair @ nat @ A @ B2 @ Acc3 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A3 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A3 @ B2 @ Acc3 )
            = Acc3 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A3 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A3 @ B2 @ Acc3 )
            = ( set_fo6178422350223883121st_nat @ A @ F2 @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B2 @ ( F2 @ A3 @ Acc3 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_4348_max_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_max @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% max.semilattice_order_axioms
thf(fact_4349_mset__zero__iff__right,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( zero_zero @ ( multiset @ A ) )
        = ( mset @ A @ X ) )
      = ( X
        = ( nil @ A ) ) ) ).

% mset_zero_iff_right
thf(fact_4350_mset__zero__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( mset @ A @ X )
        = ( zero_zero @ ( multiset @ A ) ) )
      = ( X
        = ( nil @ A ) ) ) ).

% mset_zero_iff
thf(fact_4351_semilattice__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( semilattice @ A @ F2 ) ) ).

% semilattice_order.axioms(1)
thf(fact_4352_mset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( mset @ A @ ( nil @ A ) )
      = ( zero_zero @ ( multiset @ A ) ) ) ).

% mset.simps(1)
thf(fact_4353_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,C2: A,A3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ B2 @ C2 )
       => ( Less @ ( F2 @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI2
thf(fact_4354_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,C2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A3 @ C2 )
       => ( Less @ ( F2 @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI1
thf(fact_4355_semilattice__order_Ostrict__order__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
        = ( ( A3
            = ( F2 @ A3 @ B2 ) )
          & ( A3 != B2 ) ) ) ) ).

% semilattice_order.strict_order_iff
thf(fact_4356_semilattice__order_Ostrict__boundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A3 @ ( F2 @ B2 @ C2 ) )
       => ~ ( ( Less @ A3 @ B2 )
           => ~ ( Less @ A3 @ C2 ) ) ) ) ).

% semilattice_order.strict_boundedE
thf(fact_4357_semilattice__order_OcoboundedI2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,C2: A,A3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ C2 )
       => ( Less_eq @ ( F2 @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI2
thf(fact_4358_semilattice__order_OcoboundedI1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,C2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ C2 )
       => ( Less_eq @ ( F2 @ A3 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI1
thf(fact_4359_semilattice__order_Obounded__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ ( F2 @ B2 @ C2 ) )
        = ( ( Less_eq @ A3 @ B2 )
          & ( Less_eq @ A3 @ C2 ) ) ) ) ).

% semilattice_order.bounded_iff
thf(fact_4360_semilattice__order_Oabsorb__iff2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ A3 )
        = ( ( F2 @ A3 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb_iff2
thf(fact_4361_semilattice__order_Oabsorb__iff1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
        = ( ( F2 @ A3 @ B2 )
          = A3 ) ) ) ).

% semilattice_order.absorb_iff1
thf(fact_4362_semilattice__order_Ocobounded2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( Less_eq @ ( F2 @ A3 @ B2 ) @ B2 ) ) ).

% semilattice_order.cobounded2
thf(fact_4363_semilattice__order_Ocobounded1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( Less_eq @ ( F2 @ A3 @ B2 ) @ A3 ) ) ).

% semilattice_order.cobounded1
thf(fact_4364_semilattice__order_Oorder__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
        = ( A3
          = ( F2 @ A3 @ B2 ) ) ) ) ).

% semilattice_order.order_iff
thf(fact_4365_semilattice__order_OboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( ( Less_eq @ A3 @ C2 )
         => ( Less_eq @ A3 @ ( F2 @ B2 @ C2 ) ) ) ) ) ).

% semilattice_order.boundedI
thf(fact_4366_semilattice__order_OboundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ ( F2 @ B2 @ C2 ) )
       => ~ ( ( Less_eq @ A3 @ B2 )
           => ~ ( Less_eq @ A3 @ C2 ) ) ) ) ).

% semilattice_order.boundedE
thf(fact_4367_semilattice__order_Oabsorb4,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ B2 @ A3 )
       => ( ( F2 @ A3 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb4
thf(fact_4368_semilattice__order_Oabsorb3,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A3 @ B2 )
       => ( ( F2 @ A3 @ B2 )
          = A3 ) ) ) ).

% semilattice_order.absorb3
thf(fact_4369_semilattice__order_Oabsorb2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ A3 )
       => ( ( F2 @ A3 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb2
thf(fact_4370_semilattice__order_Oabsorb1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( ( F2 @ A3 @ B2 )
          = A3 ) ) ) ).

% semilattice_order.absorb1
thf(fact_4371_semilattice__order_OorderI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( A3
          = ( F2 @ A3 @ B2 ) )
       => ( Less_eq @ A3 @ B2 ) ) ) ).

% semilattice_order.orderI
thf(fact_4372_semilattice__order_OorderE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ B2 )
       => ( A3
          = ( F2 @ A3 @ B2 ) ) ) ) ).

% semilattice_order.orderE
thf(fact_4373_semilattice__order_Omono,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A3: A,C2: A,B2: A,D3: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A3 @ C2 )
       => ( ( Less_eq @ B2 @ D3 )
         => ( Less_eq @ ( F2 @ A3 @ B2 ) @ ( F2 @ C2 @ D3 ) ) ) ) ) ).

% semilattice_order.mono
thf(fact_4374_ex__mset__zip__left,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Xs5: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( mset @ A @ Xs5 )
          = ( mset @ A @ Xs ) )
       => ? [Ys2: list @ B] :
            ( ( ( size_size @ ( list @ B ) @ Ys2 )
              = ( size_size @ ( list @ A ) @ Xs5 ) )
            & ( ( mset @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs5 @ Ys2 ) )
              = ( mset @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ) ).

% ex_mset_zip_left
thf(fact_4375_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less )
     => ( semilattice_order @ A @ F2 @ Less_eq @ Less ) ) ).

% semilattice_neutr_order.axioms(2)
thf(fact_4376_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A1: nat,A22: nat,A32: A,P2: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A1 @ ( product_Pair @ nat @ A @ A22 @ A32 ) ) ) )
     => ( ! [F9: nat > A > A,A6: nat,B5: nat,Acc4: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F9 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A6 @ ( product_Pair @ nat @ A @ B5 @ Acc4 ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B5 @ A6 )
               => ( P2 @ F9 @ ( plus_plus @ nat @ A6 @ ( one_one @ nat ) ) @ B5 @ ( F9 @ A6 @ Acc4 ) ) )
             => ( P2 @ F9 @ A6 @ B5 @ Acc4 ) ) )
       => ( P2 @ A0 @ A1 @ A22 @ A32 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_4377_semilattice__neutr__order__def,axiom,
    ! [A: $tType] :
      ( ( semila1105856199041335345_order @ A )
      = ( ^ [F3: A > A > A,Z3: A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice_neutr @ A @ F3 @ Z3 )
            & ( semilattice_order @ A @ F3 @ Less_eq2 @ Less2 ) ) ) ) ).

% semilattice_neutr_order_def
thf(fact_4378_semilattice__neutr__order_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_neutr @ A @ F2 @ Z2 )
     => ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
       => ( semila1105856199041335345_order @ A @ F2 @ Z2 @ Less_eq @ Less ) ) ) ).

% semilattice_neutr_order.intro
thf(fact_4379_inf_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semilattice_order @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf.semilattice_order_axioms
thf(fact_4380_min_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_min @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% min.semilattice_order_axioms
thf(fact_4381_sup_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semilattice_order @ A @ ( sup_sup @ A )
        @ ^ [X2: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ X2 )
        @ ^ [X2: A,Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% sup.semilattice_order_axioms
thf(fact_4382_mset__zip__take__Cons__drop__twice,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,J: nat,X: A,Y: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( mset @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( append @ A @ ( take @ A @ J @ Xs ) @ ( cons @ A @ X @ ( drop @ A @ J @ Xs ) ) ) @ ( append @ B @ ( take @ B @ J @ Ys ) @ ( cons @ B @ Y @ ( drop @ B @ J @ Ys ) ) ) ) )
          = ( add_mset @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( mset @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ) ).

% mset_zip_take_Cons_drop_twice
thf(fact_4383_semilattice__order__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_order @ A )
      = ( ^ [F3: A > A > A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice @ A @ F3 )
            & ( semila6385135966242565138axioms @ A @ F3 @ Less_eq2 @ Less2 ) ) ) ) ).

% semilattice_order_def
thf(fact_4384_semilattice__order_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice @ A @ F2 )
     => ( ( semila6385135966242565138axioms @ A @ F2 @ Less_eq @ Less )
       => ( semilattice_order @ A @ F2 @ Less_eq @ Less ) ) ) ).

% semilattice_order.intro
thf(fact_4385_lexordp__eq__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Ys: list @ A] : ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) ).

% lexordp_eq_simps(1)
thf(fact_4386_lexordp__eq__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A] :
          ( ( ord_lexordp_eq @ A @ Xs @ ( nil @ A ) )
          = ( Xs
            = ( nil @ A ) ) ) ) ).

% lexordp_eq_simps(2)
thf(fact_4387_lexordp__eq__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A,Y: A,Ys: list @ A] :
          ( ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp_eq @ A @ Xs @ Ys ) ) ) ) ) ).

% lexordp_eq_simps(4)
thf(fact_4388_lexordp__eq__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A] :
          ~ ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) ) ).

% lexordp_eq_simps(3)
thf(fact_4389_mset__single__iff__right,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) )
        = ( mset @ A @ Xs ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% mset_single_iff_right
thf(fact_4390_mset__single__iff,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( mset @ A @ Xs )
        = ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% mset_single_iff
thf(fact_4391_lexordp__eq__pref,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [U: list @ A,V2: list @ A] : ( ord_lexordp_eq @ A @ U @ ( append @ A @ U @ V2 ) ) ) ).

% lexordp_eq_pref
thf(fact_4392_lexordp__eq_ONil,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Ys: list @ A] : ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) ).

% lexordp_eq.Nil
thf(fact_4393_lexordp__eq__refl,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A] : ( ord_lexordp_eq @ A @ Xs @ Xs ) ) ).

% lexordp_eq_refl
thf(fact_4394_lexordp__eq__trans,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A,Zs: list @ A] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Zs )
           => ( ord_lexordp_eq @ A @ Xs @ Zs ) ) ) ) ).

% lexordp_eq_trans
thf(fact_4395_lexordp__eq__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
          | ( ord_lexordp_eq @ A @ Ys @ Xs ) ) ) ).

% lexordp_eq_linear
thf(fact_4396_lexordp__eq__antisym,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Xs )
           => ( Xs = Ys ) ) ) ) ).

% lexordp_eq_antisym
thf(fact_4397_semilattice__order__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,F2: A > A > A,Less: A > A > $o] :
      ( ! [A6: A,B5: A] :
          ( ( Less_eq @ A6 @ B5 )
          = ( A6
            = ( F2 @ A6 @ B5 ) ) )
     => ( ! [A6: A,B5: A] :
            ( ( Less @ A6 @ B5 )
            = ( ( A6
                = ( F2 @ A6 @ B5 ) )
              & ( A6 != B5 ) ) )
       => ( semila6385135966242565138axioms @ A @ F2 @ Less_eq @ Less ) ) ) ).

% semilattice_order_axioms.intro
thf(fact_4398_semilattice__order__axioms__def,axiom,
    ! [A: $tType] :
      ( ( semila6385135966242565138axioms @ A )
      = ( ^ [F3: A > A > A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ! [A4: A,B3: A] :
                ( ( Less_eq2 @ A4 @ B3 )
                = ( A4
                  = ( F3 @ A4 @ B3 ) ) )
            & ! [A4: A,B3: A] :
                ( ( Less2 @ A4 @ B3 )
                = ( ( A4
                    = ( F3 @ A4 @ B3 ) )
                  & ( A4 != B3 ) ) ) ) ) ) ).

% semilattice_order_axioms_def
thf(fact_4399_lexordp__into__lexordp__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ord_lexordp_eq @ A @ Xs @ Ys ) ) ) ).

% lexordp_into_lexordp_eq
thf(fact_4400_lexordp__eq__conv__lexord,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [Xs4: list @ A,Ys4: list @ A] :
              ( ( Xs4 = Ys4 )
              | ( ord_lexordp @ A @ Xs4 @ Ys4 ) ) ) ) ) ).

% lexordp_eq_conv_lexord
thf(fact_4401_lexordp__conv__lexordp__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs4: list @ A,Ys4: list @ A] :
              ( ( ord_lexordp_eq @ A @ Xs4 @ Ys4 )
              & ~ ( ord_lexordp_eq @ A @ Ys4 @ Xs4 ) ) ) ) ) ).

% lexordp_conv_lexordp_eq
thf(fact_4402_lexordp__eq_OCons,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ).

% lexordp_eq.Cons
thf(fact_4403_lexordp__eq_OCons__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys: list @ A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp_eq @ A @ Xs @ Ys )
             => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ) ).

% lexordp_eq.Cons_eq
thf(fact_4404_count__single,axiom,
    ! [A: $tType,B2: A,A3: A] :
      ( ( ( B2 = A3 )
       => ( ( count @ A @ ( add_mset @ A @ B2 @ ( zero_zero @ ( multiset @ A ) ) ) @ A3 )
          = ( one_one @ nat ) ) )
      & ( ( B2 != A3 )
       => ( ( count @ A @ ( add_mset @ A @ B2 @ ( zero_zero @ ( multiset @ A ) ) ) @ A3 )
          = ( zero_zero @ nat ) ) ) ) ).

% count_single
thf(fact_4405_semilattice__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( semila6385135966242565138axioms @ A @ F2 @ Less_eq @ Less ) ) ).

% semilattice_order.axioms(2)
thf(fact_4406_lexordp__eq_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A1: list @ A,A22: list @ A] :
          ( ( ord_lexordp_eq @ A @ A1 @ A22 )
         => ( ( A1
             != ( nil @ A ) )
           => ( ! [X3: A] :
                  ( ? [Xs2: list @ A] :
                      ( A1
                      = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y3: A] :
                      ( ? [Ys3: list @ A] :
                          ( A22
                          = ( cons @ A @ Y3 @ Ys3 ) )
                     => ~ ( ord_less @ A @ X3 @ Y3 ) ) )
             => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                    ( ( A1
                      = ( cons @ A @ X3 @ Xs2 ) )
                   => ! [Ys3: list @ A] :
                        ( ( A22
                          = ( cons @ A @ Y3 @ Ys3 ) )
                       => ( ~ ( ord_less @ A @ X3 @ Y3 )
                         => ( ~ ( ord_less @ A @ Y3 @ X3 )
                           => ~ ( ord_lexordp_eq @ A @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ) ).

% lexordp_eq.cases
thf(fact_4407_lexordp__eq_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [A12: list @ A,A23: list @ A] :
              ( ? [Ys4: list @ A] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A23 = Ys4 ) )
              | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                  ( ( A12
                    = ( cons @ A @ X2 @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y2 @ Ys4 ) )
                  & ( ord_less @ A @ X2 @ Y2 ) )
              | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                  ( ( A12
                    = ( cons @ A @ X2 @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y2 @ Ys4 ) )
                  & ~ ( ord_less @ A @ X2 @ Y2 )
                  & ~ ( ord_less @ A @ Y2 @ X2 )
                  & ( ord_lexordp_eq @ A @ Xs4 @ Ys4 ) ) ) ) ) ) ).

% lexordp_eq.simps
thf(fact_4408_sorted__list__of__multiset__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( linord6283353356039996273ltiset @ A @ ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted_list_of_multiset_singleton
thf(fact_4409_sorted__list__of__multiset__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord6283353356039996273ltiset @ A @ ( zero_zero @ ( multiset @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_multiset_empty
thf(fact_4410_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_4411_coprime__diff__one__right__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% coprime_diff_one_right_nat
thf(fact_4412_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
          = ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
            & ( algebr8660921524188924756oprime @ A @ B2 @ C2 ) ) ) ) ).

% coprime_mult_left_iff
thf(fact_4413_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ ( times_times @ A @ A3 @ B2 ) )
          = ( ( algebr8660921524188924756oprime @ A @ C2 @ A3 )
            & ( algebr8660921524188924756oprime @ A @ C2 @ B2 ) ) ) ) ).

% coprime_mult_right_iff
thf(fact_4414_coprime__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ A3 )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_self
thf(fact_4415_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ( ( gcd_gcd @ A @ A3 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% coprime_imp_gcd_eq_1
thf(fact_4416_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_4417_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A3 )
          = ( dvd_dvd @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_4418_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ C2 @ A3 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ).

% coprime_mult_self_left_iff
thf(fact_4419_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A3 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ).

% coprime_mult_self_right_iff
thf(fact_4420_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A3 @ B2 ) @ ( one_one @ A ) )
          = ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% is_unit_gcd
thf(fact_4421_coprime__1__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ ( one_one @ A ) @ A3 ) ) ).

% coprime_1_left
thf(fact_4422_coprime__1__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ A3 @ ( one_one @ A ) ) ) ).

% coprime_1_right
thf(fact_4423_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) @ A3 ) ) ).

% coprime_add_one_left
thf(fact_4424_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ A3 @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_add_one_right
thf(fact_4425_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ A3 @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) ) ) ).

% coprime_doff_one_right
thf(fact_4426_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A3: A] : ( algebr8660921524188924756oprime @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) @ A3 ) ) ).

% coprime_diff_one_left
thf(fact_4427_divides__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
             => ( dvd_dvd @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 ) ) ) ) ) ).

% divides_mult
thf(fact_4428_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% coprime_dvd_mult_left_iff
thf(fact_4429_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( dvd_dvd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A3 @ B2 ) ) ) ) ).

% coprime_dvd_mult_right_iff
thf(fact_4430_coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ! [C4: A] :
              ( ( dvd_dvd @ A @ C4 @ A3 )
             => ( ( dvd_dvd @ A @ C4 @ B2 )
               => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% coprimeI
thf(fact_4431_coprime__def,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A4: A,B3: A] :
            ! [C3: A] :
              ( ( dvd_dvd @ A @ C3 @ A4 )
             => ( ( dvd_dvd @ A @ C3 @ B3 )
               => ( dvd_dvd @ A @ C3 @ ( one_one @ A ) ) ) ) ) ) ) ).

% coprime_def
thf(fact_4432_not__coprimeE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ~ ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ~ ! [C4: A] :
                ( ( dvd_dvd @ A @ C4 @ A3 )
               => ( ( dvd_dvd @ A @ C4 @ B2 )
                 => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) ) ) ) ).

% not_coprimeE
thf(fact_4433_not__coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A3: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A3 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ~ ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
             => ~ ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ) ).

% not_coprimeI
thf(fact_4434_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y )
            = ( dvd_dvd @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_left
thf(fact_4435_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,D3: A,A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ D3 )
         => ( ! [E: A] :
                ( ~ ( dvd_dvd @ A @ E @ ( one_one @ A ) )
               => ( ( dvd_dvd @ A @ E @ A3 )
                 => ( ( dvd_dvd @ A @ E @ B2 )
                   => ( dvd_dvd @ A @ E @ C2 ) ) ) )
           => ( ! [E: A] :
                  ( ~ ( dvd_dvd @ A @ E @ ( one_one @ A ) )
                 => ( ( dvd_dvd @ A @ E @ A3 )
                   => ( ( dvd_dvd @ A @ E @ B2 )
                     => ( dvd_dvd @ A @ E @ D3 ) ) ) )
             => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ) ) ).

% coprime_imp_coprime
thf(fact_4436_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [Y: A,X: A] :
          ( ( dvd_dvd @ A @ Y @ X )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y )
            = ( dvd_dvd @ A @ Y @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_right
thf(fact_4437_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ A3 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( dvd_dvd @ A @ C2 @ ( one_one @ A ) ) ) ) ) ) ).

% coprime_common_divisor
thf(fact_4438_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A3: A,B2: A] :
          ( ( dvd_dvd @ A @ A3 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% is_unit_left_imp_coprime
thf(fact_4439_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A3: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% is_unit_right_imp_coprime
thf(fact_4440_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [N: A,A3: A,M2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ N @ A3 ) @ M2 )
            = ( modulo_modulo @ A @ ( times_times @ A @ N @ B2 ) @ M2 ) )
         => ( ( algebr8660921524188924756oprime @ A @ M2 @ N )
           => ( ( modulo_modulo @ A @ A3 @ M2 )
              = ( modulo_modulo @ A @ B2 @ M2 ) ) ) ) ) ).

% mult_mod_cancel_left
thf(fact_4441_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [A3: A,N: A,M2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ N ) @ M2 )
            = ( modulo_modulo @ A @ ( times_times @ A @ B2 @ N ) @ M2 ) )
         => ( ( algebr8660921524188924756oprime @ A @ M2 @ N )
           => ( ( modulo_modulo @ A @ A3 @ M2 )
              = ( modulo_modulo @ A @ B2 @ M2 ) ) ) ) ) ).

% mult_mod_cancel_right
thf(fact_4442_coprime__common__divisor__nat,axiom,
    ! [A3: nat,B2: nat,X: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ A3 @ B2 )
     => ( ( dvd_dvd @ nat @ X @ A3 )
       => ( ( dvd_dvd @ nat @ X @ B2 )
         => ( X
            = ( one_one @ nat ) ) ) ) ) ).

% coprime_common_divisor_nat
thf(fact_4443_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A3 ) @ B2 )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_left_left_cancel
thf(fact_4444_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A3: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ A3 @ C2 ) @ B2 )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_left_right_cancel
thf(fact_4445_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( gcd_gcd @ A @ A3 @ ( times_times @ A @ C2 @ B2 ) )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_right_left_cancel
thf(fact_4446_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ C2 )
         => ( ( gcd_gcd @ A @ A3 @ ( times_times @ A @ B2 @ C2 ) )
            = ( gcd_gcd @ A @ A3 @ B2 ) ) ) ) ).

% gcd_mult_right_right_cancel
thf(fact_4447_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( gcd_gcd @ A @ A4 @ B3 )
              = ( one_one @ A ) ) ) ) ) ).

% coprime_iff_gcd_eq_1
thf(fact_4448_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A3 @ B2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ B2 ) ) ) ).

% gcd_eq_1_imp_coprime
thf(fact_4449_coprime__crossproduct,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,D3: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ D3 )
         => ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
           => ( ( ( times_times @ A @ ( normal6383669964737779283malize @ A @ A3 ) @ ( normal6383669964737779283malize @ A @ C2 ) )
                = ( times_times @ A @ ( normal6383669964737779283malize @ A @ B2 ) @ ( normal6383669964737779283malize @ A @ D3 ) ) )
              = ( ( ( normal6383669964737779283malize @ A @ A3 )
                  = ( normal6383669964737779283malize @ A @ B2 ) )
                & ( ( normal6383669964737779283malize @ A @ C2 )
                  = ( normal6383669964737779283malize @ A @ D3 ) ) ) ) ) ) ) ).

% coprime_crossproduct
thf(fact_4450_invertible__coprime,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A3 @ B2 ) @ C2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A3 @ C2 ) ) ) ).

% invertible_coprime
thf(fact_4451_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A3 @ B2 )
           != ( zero_zero @ A ) )
         => ? [A8: A,B8: A] :
              ( ( A3
                = ( times_times @ A @ A8 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
              & ( B2
                = ( times_times @ A @ B8 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A8 @ B8 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_4452_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A,A9: A,B7: A] :
          ( ( ( gcd_gcd @ A @ A3 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A3
              = ( times_times @ A @ A9 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
           => ( ( B2
                = ( times_times @ A @ B7 @ ( gcd_gcd @ A @ A3 @ B2 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A9 @ B7 ) ) ) ) ) ).

% gcd_coprime
thf(fact_4453_coprime__crossproduct_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [B2: A,D3: A,A3: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( unit_f5069060285200089521factor @ A @ B2 )
              = ( unit_f5069060285200089521factor @ A @ D3 ) )
           => ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
             => ( ( algebr8660921524188924756oprime @ A @ C2 @ D3 )
               => ( ( ( times_times @ A @ A3 @ D3 )
                    = ( times_times @ A @ B2 @ C2 ) )
                  = ( ( A3 = C2 )
                    & ( B2 = D3 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
thf(fact_4454_lcm__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A3 @ B2 )
         => ( ( gcd_lcm @ A @ A3 @ B2 )
            = ( normal6383669964737779283malize @ A @ ( times_times @ A @ A3 @ B2 ) ) ) ) ) ).

% lcm_coprime
thf(fact_4455_coprime__diff__one__left__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ N ) ) ).

% coprime_diff_one_left_nat
thf(fact_4456_sorted__list__of__multiset__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord6283353356039996273ltiset @ A )
        = ( fold_mset @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_multiset_def
thf(fact_4457_equiv__class__nondisjoint,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A ),X: A,A3: A,B2: A] :
      ( ( equiv_equiv @ A @ A5 @ R4 )
     => ( ( member2 @ A @ X @ ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ R4 @ ( insert3 @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( image @ A @ A @ R4 @ ( insert3 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B2 ) @ R4 ) ) ) ).

% equiv_class_nondisjoint
thf(fact_4458_count__greater__eq__one__iff,axiom,
    ! [A: $tType,M: multiset @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ ( count @ A @ M @ X ) )
      = ( member2 @ A @ X @ ( set_mset @ A @ M ) ) ) ).

% count_greater_eq_one_iff
thf(fact_4459_in__range_Osimps,axiom,
    ! [H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
      = ( ! [X2: nat] :
            ( ( member2 @ nat @ X2 @ As2 )
           => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% in_range.simps
thf(fact_4460_equiv__listrel,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( equiv_equiv @ A @ A5 @ R4 )
     => ( equiv_equiv @ ( list @ A ) @ ( lists @ A @ A5 ) @ ( listrel @ A @ A @ R4 ) ) ) ).

% equiv_listrel
thf(fact_4461_coprime__common__divisor__int,axiom,
    ! [A3: int,B2: int,X: int] :
      ( ( algebr8660921524188924756oprime @ int @ A3 @ B2 )
     => ( ( dvd_dvd @ int @ X @ A3 )
       => ( ( dvd_dvd @ int @ X @ B2 )
         => ( ( abs_abs @ int @ X )
            = ( one_one @ int ) ) ) ) ) ).

% coprime_common_divisor_int
thf(fact_4462_in__range_Oelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( in_range @ X )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ! [X3: nat] :
                ( ( member2 @ nat @ X3 @ As )
               => ( ord_less @ nat @ X3 @ ( lim @ product_unit @ H3 ) ) ) ) ) ).

% in_range.elims(3)
thf(fact_4463_in__range_Oelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( in_range @ X )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ~ ! [X4: nat] :
                  ( ( member2 @ nat @ X4 @ As )
                 => ( ord_less @ nat @ X4 @ ( lim @ product_unit @ H3 ) ) ) ) ) ).

% in_range.elims(2)
thf(fact_4464_in__range_Oelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( in_range @ X )
        = Y )
     => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
            ( ( X
              = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
           => ( Y
              = ( ~ ! [X2: nat] :
                      ( ( member2 @ nat @ X2 @ As )
                     => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ).

% in_range.elims(1)
thf(fact_4465_sum__wcount__Int,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat,N2: multiset @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( wcount @ A @ F2 @ N2 ) @ ( inf_inf @ ( set @ A ) @ A5 @ ( set_mset @ A @ N2 ) ) )
        = ( groups7311177749621191930dd_sum @ A @ nat @ ( wcount @ A @ F2 @ N2 ) @ A5 ) ) ) ).

% sum_wcount_Int
thf(fact_4466_count__image__mset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: multiset @ B,X: A] :
      ( ( count @ A @ ( image_mset @ B @ A @ F2 @ A5 ) @ X )
      = ( groups7311177749621191930dd_sum @ B @ nat @ ( count @ B @ A5 ) @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ ( insert3 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( set_mset @ B @ A5 ) ) ) ) ).

% count_image_mset
thf(fact_4467_size__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A5: multiset @ A] :
      ( ( ( member2 @ A @ X @ ( set_mset @ A @ A5 ) )
       => ( ( size_size @ ( multiset @ A ) @ ( minus_minus @ ( multiset @ A ) @ A5 @ ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( size_size @ ( multiset @ A ) @ A5 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member2 @ A @ X @ ( set_mset @ A @ A5 ) )
       => ( ( size_size @ ( multiset @ A ) @ ( minus_minus @ ( multiset @ A ) @ A5 @ ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) ) ) )
          = ( size_size @ ( multiset @ A ) @ A5 ) ) ) ) ).

% size_Diff_singleton_if
thf(fact_4468_size__Diff__singleton,axiom,
    ! [A: $tType,X: A,M: multiset @ A] :
      ( ( member2 @ A @ X @ ( set_mset @ A @ M ) )
     => ( ( size_size @ ( multiset @ A ) @ ( minus_minus @ ( multiset @ A ) @ M @ ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( size_size @ ( multiset @ A ) @ M ) @ ( one_one @ nat ) ) ) ) ).

% size_Diff_singleton
thf(fact_4469_size__single,axiom,
    ! [A: $tType,B2: A] :
      ( ( size_size @ ( multiset @ A ) @ ( add_mset @ A @ B2 @ ( zero_zero @ ( multiset @ A ) ) ) )
      = ( one_one @ nat ) ) ).

% size_single
thf(fact_4470_size__1__singleton__mset,axiom,
    ! [A: $tType,M: multiset @ A] :
      ( ( ( size_size @ ( multiset @ A ) @ M )
        = ( one_one @ nat ) )
     => ? [A6: A] :
          ( M
          = ( add_mset @ A @ A6 @ ( zero_zero @ ( multiset @ A ) ) ) ) ) ).

% size_1_singleton_mset
thf(fact_4471_mset__size1elem,axiom,
    ! [A: $tType,P2: multiset @ A,Q4: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( multiset @ A ) @ P2 ) @ ( one_one @ nat ) )
     => ( ( member2 @ A @ Q4 @ ( set_mset @ A @ P2 ) )
       => ( P2
          = ( add_mset @ A @ Q4 @ ( zero_zero @ ( multiset @ A ) ) ) ) ) ) ).

% mset_size1elem
thf(fact_4472_size__diff__se,axiom,
    ! [A: $tType,T3: A,S: multiset @ A] :
      ( ( member2 @ A @ T3 @ ( set_mset @ A @ S ) )
     => ( ( size_size @ ( multiset @ A ) @ S )
        = ( plus_plus @ nat @ ( size_size @ ( multiset @ A ) @ ( minus_minus @ ( multiset @ A ) @ S @ ( add_mset @ A @ T3 @ ( zero_zero @ ( multiset @ A ) ) ) ) ) @ ( one_one @ nat ) ) ) ) ).

% size_diff_se
thf(fact_4473_sum__mset__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [Y: B,A5: multiset @ A] :
          ( ( comm_m7189776963980413722m_mset @ B
            @ ( image_mset @ A @ B
              @ ^ [X2: A] : Y
              @ A5 ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( multiset @ A ) @ A5 ) ) @ Y ) ) ) ).

% sum_mset_constant
thf(fact_4474_sum__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: B,C2: A,A5: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( X2 = Y ) @ C2 @ ( zero_zero @ A ) )
              @ A5 ) )
          = ( times_times @ A @ C2 @ ( semiring_1_of_nat @ A @ ( count @ B @ A5 @ Y ) ) ) ) ) ).

% sum_mset_delta
thf(fact_4475_sum__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: B,C2: A,A5: multiset @ B] :
          ( ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( Y = X2 ) @ C2 @ ( zero_zero @ A ) )
              @ A5 ) )
          = ( times_times @ A @ C2 @ ( semiring_1_of_nat @ A @ ( count @ B @ A5 @ Y ) ) ) ) ) ).

% sum_mset_delta'
thf(fact_4476_prod__mset_Oremove,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [X: A,A5: multiset @ A] :
          ( ( member2 @ A @ X @ ( set_mset @ A @ A5 ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ A5 )
            = ( times_times @ A @ X @ ( comm_m9189036328036947845d_mset @ A @ ( minus_minus @ ( multiset @ A ) @ A5 @ ( add_mset @ A @ X @ ( zero_zero @ ( multiset @ A ) ) ) ) ) ) ) ) ) ).

% prod_mset.remove
thf(fact_4477_prod__mset__empty,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A @ ( zero_zero @ ( multiset @ A ) ) )
        = ( one_one @ A ) ) ) ).

% prod_mset_empty
thf(fact_4478_prod__mset_Oadd__mset,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [X: A,N2: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( add_mset @ A @ X @ N2 ) )
          = ( times_times @ A @ X @ ( comm_m9189036328036947845d_mset @ A @ N2 ) ) ) ) ).

% prod_mset.add_mset
thf(fact_4479_prod__mset_Ounion,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: multiset @ A,N2: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( plus_plus @ ( multiset @ A ) @ M @ N2 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ M ) @ ( comm_m9189036328036947845d_mset @ A @ N2 ) ) ) ) ).

% prod_mset.union
thf(fact_4480_prod__mset__Un,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: multiset @ A,B4: multiset @ A] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( plus_plus @ ( multiset @ A ) @ A5 @ B4 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ A5 ) @ ( comm_m9189036328036947845d_mset @ A @ B4 ) ) ) ) ).

% prod_mset_Un
thf(fact_4481_prod__mset_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [Uu2: B] : ( one_one @ A )
              @ A5 ) )
          = ( one_one @ A ) ) ) ).

% prod_mset.neutral_const
thf(fact_4482_prod__mset_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,X: B,A5: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ ( add_mset @ B @ X @ A5 ) ) )
          = ( times_times @ A @ ( G @ X ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A5 ) ) ) ) ) ).

% prod_mset.insert
thf(fact_4483_prod__mset_Oneutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: multiset @ A] :
          ( ! [X3: A] :
              ( ( member2 @ A @ X3 @ ( set_mset @ A @ A5 ) )
             => ( X3
                = ( one_one @ A ) ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% prod_mset.neutral
thf(fact_4484_prod__mset_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A5: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
              @ A5 ) )
          = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A5 ) ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ H2 @ A5 ) ) ) ) ) ).

% prod_mset.distrib
thf(fact_4485_sum__mset__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( times @ A )
        & ( semiring_0 @ B ) )
     => ! [F2: A > B,A5: multiset @ A,G: C > B,B4: multiset @ C] :
          ( ( times_times @ B @ ( comm_m7189776963980413722m_mset @ B @ ( image_mset @ A @ B @ F2 @ A5 ) ) @ ( comm_m7189776963980413722m_mset @ B @ ( image_mset @ C @ B @ G @ B4 ) ) )
          = ( comm_m7189776963980413722m_mset @ B
            @ ( image_mset @ A @ B
              @ ^ [I4: A] :
                  ( comm_m7189776963980413722m_mset @ B
                  @ ( image_mset @ C @ B
                    @ ^ [J2: C] : ( times_times @ B @ ( F2 @ I4 ) @ ( G @ J2 ) )
                    @ B4 ) )
              @ A5 ) ) ) ) ).

% sum_mset_product
thf(fact_4486_sum__mset__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,M: multiset @ B,C2: A] :
          ( ( times_times @ A @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ F2 @ M ) ) @ C2 )
          = ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ M ) ) ) ) ).

% sum_mset_distrib_right
thf(fact_4487_sum__mset__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,M: multiset @ B] :
          ( ( times_times @ A @ C2 @ ( comm_m7189776963980413722m_mset @ A @ ( image_mset @ B @ A @ F2 @ M ) ) )
          = ( comm_m7189776963980413722m_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ M ) ) ) ) ).

% sum_mset_distrib_left
thf(fact_4488_size__eq__sum__mset,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( multiset @ A ) )
      = ( ^ [M5: multiset @ A] :
            ( comm_m7189776963980413722m_mset @ nat
            @ ( image_mset @ A @ nat
              @ ^ [A4: A] : ( one_one @ nat )
              @ M5 ) ) ) ) ).

% size_eq_sum_mset
thf(fact_4489_is__unit__prod__mset__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A5: multiset @ A] :
          ( ( dvd_dvd @ A @ ( comm_m9189036328036947845d_mset @ A @ A5 ) @ ( one_one @ A ) )
          = ( ! [X2: A] :
                ( ( member2 @ A @ X2 @ ( set_mset @ A @ A5 ) )
               => ( dvd_dvd @ A @ X2 @ ( one_one @ A ) ) ) ) ) ) ).

% is_unit_prod_mset_iff
thf(fact_4490_prod__mset_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A )
        = ( fold_mset @ A @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_mset.eq_fold
thf(fact_4491_prod__mset__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: B,C2: A,A5: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( X2 = Y ) @ C2 @ ( one_one @ A ) )
              @ A5 ) )
          = ( power_power @ A @ C2 @ ( count @ B @ A5 @ Y ) ) ) ) ).

% prod_mset_delta
thf(fact_4492_prod__mset__delta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: B,C2: A,A5: multiset @ B] :
          ( ( comm_m9189036328036947845d_mset @ A
            @ ( image_mset @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( Y = X2 ) @ C2 @ ( one_one @ A ) )
              @ A5 ) )
          = ( power_power @ A @ C2 @ ( count @ B @ A5 @ Y ) ) ) ) ).

% prod_mset_delta'
thf(fact_4493_sum__mset__replicate__mset,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,A3: A] :
          ( ( comm_m7189776963980413722m_mset @ A @ ( replicate_mset @ A @ N @ A3 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ A3 ) ) ) ).

% sum_mset_replicate_mset
thf(fact_4494_prod__mset__def,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( comm_m9189036328036947845d_mset @ A )
        = ( comm_monoid_F @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% prod_mset_def
thf(fact_4495_ord_Olexordp__eq__simps_I3_J,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Xs: list @ A] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) ).

% ord.lexordp_eq_simps(3)
thf(fact_4496_sngr__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ( ( ( ref_get @ A @ H3 @ X )
                    = Xa )
                  & ( As
                    = ( insert3 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                  & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ).

% sngr_assn_raw.elims(3)
thf(fact_4497_ord_Olexordp__eq__simps_I4_J,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X @ Y )
        | ( ~ ( Less @ Y @ X )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) ).

% ord.lexordp_eq_simps(4)
thf(fact_4498_ord_Olexordp__eq__simps_I2_J,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% ord.lexordp_eq_simps(2)
thf(fact_4499_ord_Olexordp__eq__simps_I1_J,axiom,
    ! [A: $tType,Less: A > A > $o,Ys: list @ A] : ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) ).

% ord.lexordp_eq_simps(1)
thf(fact_4500_ord_Olexordp__eq_OCons,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Xs: list @ A,Ys: list @ A] :
      ( ( Less @ X @ Y )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ).

% ord.lexordp_eq.Cons
thf(fact_4501_ord_Olexordp__eq_OCons__eq,axiom,
    ! [A: $tType,Less: A > A > $o,X: A,Y: A,Xs: list @ A,Ys: list @ A] :
      ( ~ ( Less @ X @ Y )
     => ( ~ ( Less @ Y @ X )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ).

% ord.lexordp_eq.Cons_eq
thf(fact_4502_ord_Olexordp__eq_ONil,axiom,
    ! [A: $tType,Less: A > A > $o,Ys: list @ A] : ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) ).

% ord.lexordp_eq.Nil
thf(fact_4503_ord_Olexordp__eq__refl,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A] : ( lexordp_eq @ A @ Less @ Xs @ Xs ) ).

% ord.lexordp_eq_refl
thf(fact_4504_ord_Olexordp__eq_Ocong,axiom,
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( lexordp_eq @ A ) ) ).

% ord.lexordp_eq.cong
thf(fact_4505_relH__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: ref @ A] :
          ( ( relH @ As2 @ H2 @ H5 )
         => ( ( member2 @ nat @ ( addr_of_ref @ A @ R4 ) @ As2 )
           => ( ( ref_get @ A @ H2 @ R4 )
              = ( ref_get @ A @ H5 @ R4 ) ) ) ) ) ).

% relH_ref
thf(fact_4506_ord_Olexordp__eq__pref,axiom,
    ! [A: $tType,Less: A > A > $o,U: list @ A,V2: list @ A] : ( lexordp_eq @ A @ Less @ U @ ( append @ A @ U @ V2 ) ) ).

% ord.lexordp_eq_pref
thf(fact_4507_ord_Olexordp__into__lexordp__eq,axiom,
    ! [A: $tType,Less: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( lexordp2 @ A @ Less @ Xs @ Ys )
     => ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ).

% ord.lexordp_into_lexordp_eq
thf(fact_4508_ord_Olexordp__eq_Osimps,axiom,
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: A > A > $o,A12: list @ A,A23: list @ A] :
            ( ? [Ys4: list @ A] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys4 ) )
            | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys4 ) )
                & ( Less2 @ X2 @ Y2 ) )
            | ? [X2: A,Y2: A,Xs4: list @ A,Ys4: list @ A] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs4 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys4 ) )
                & ~ ( Less2 @ X2 @ Y2 )
                & ~ ( Less2 @ Y2 @ X2 )
                & ( lexordp_eq @ A @ Less2 @ Xs4 @ Ys4 ) ) ) ) ) ).

% ord.lexordp_eq.simps
thf(fact_4509_ord_Olexordp__eq_Ocases,axiom,
    ! [A: $tType,Less: A > A > $o,A1: list @ A,A22: list @ A] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A22 )
     => ( ( A1
         != ( nil @ A ) )
       => ( ! [X3: A] :
              ( ? [Xs2: list @ A] :
                  ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Y3: A] :
                  ( ? [Ys3: list @ A] :
                      ( A22
                      = ( cons @ A @ Y3 @ Ys3 ) )
                 => ~ ( Less @ X3 @ Y3 ) ) )
         => ~ ! [X3: A,Y3: A,Xs2: list @ A] :
                ( ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ! [Ys3: list @ A] :
                    ( ( A22
                      = ( cons @ A @ Y3 @ Ys3 ) )
                   => ( ~ ( Less @ X3 @ Y3 )
                     => ( ~ ( Less @ Y3 @ X3 )
                       => ~ ( lexordp_eq @ A @ Less @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ).

% ord.lexordp_eq.cases
thf(fact_4510_sngr__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,X: A,H2: heap_ext @ product_unit,As2: set @ nat] :
          ( ( sngr_assn_raw @ A @ R4 @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
          = ( ( ( ref_get @ A @ H2 @ R4 )
              = X )
            & ( As2
              = ( insert3 @ nat @ ( addr_of_ref @ A @ R4 ) @ ( bot_bot @ ( set @ nat ) ) ) )
            & ( ord_less @ nat @ ( addr_of_ref @ A @ R4 ) @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% sngr_assn_raw.simps
thf(fact_4511_sngr__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ( Y
                  = ( ~ ( ( ( ref_get @ A @ H3 @ X )
                          = Xa )
                        & ( As
                          = ( insert3 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.elims(1)
thf(fact_4512_sngr__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ~ ( ( ( ref_get @ A @ H3 @ X )
                      = Xa )
                    & ( As
                      = ( insert3 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                    & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ).

% sngr_assn_raw.elims(2)
thf(fact_4513_sngr__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                 => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
                   => ( ( ( ref_get @ A @ H3 @ X )
                        = Xa )
                      & ( As
                        = ( insert3 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                      & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(3)
thf(fact_4514_sngr__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                 => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
                   => ~ ( ( ( ref_get @ A @ H3 @ X )
                          = Xa )
                        & ( As
                          = ( insert3 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(2)
thf(fact_4515_sngr__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: ref @ A,Xa: A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( sngr_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ( ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                 => ( ( Y
                      = ( ( ( ref_get @ A @ H3 @ X )
                          = Xa )
                        & ( As
                          = ( insert3 @ nat @ ( addr_of_ref @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_ref @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( sngr_assn_raw_rel @ A ) @ ( product_Pair @ ( ref @ A ) @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ) ) ) ) ).

% sngr_assn_raw.pelims(1)
thf(fact_4516_relH__set__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,As2: set @ nat,H2: heap_ext @ product_unit,X: A] :
          ( ~ ( member2 @ nat @ ( addr_of_ref @ A @ R4 ) @ As2 )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
           => ( relH @ As2 @ H2 @ ( ref_set @ A @ R4 @ X @ H2 ) ) ) ) ) ).

% relH_set_ref
thf(fact_4517_snga__assn__raw_Oelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ( ( ( array_get @ A @ H3 @ X )
                    = Xa )
                  & ( As
                    = ( insert3 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                  & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ).

% snga_assn_raw.elims(3)
thf(fact_4518_snga__assn__raw_Oelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ~ ( ( ( array_get @ A @ H3 @ X )
                      = Xa )
                    & ( As
                      = ( insert3 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                    & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ).

% snga_assn_raw.elims(2)
thf(fact_4519_snga__assn__raw_Oelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                ( ( Xb
                  = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ( Y
                  = ( ~ ( ( ( array_get @ A @ H3 @ X )
                          = Xa )
                        & ( As
                          = ( insert3 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ) ).

% snga_assn_raw.elims(1)
thf(fact_4520_snga__assn__raw_Osimps,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: array @ A,X: list @ A,H2: heap_ext @ product_unit,As2: set @ nat] :
          ( ( snga_assn_raw @ A @ R4 @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
          = ( ( ( array_get @ A @ H2 @ R4 )
              = X )
            & ( As2
              = ( insert3 @ nat @ ( addr_of_array @ A @ R4 ) @ ( bot_bot @ ( set @ nat ) ) ) )
            & ( ord_less @ nat @ ( addr_of_array @ A @ R4 ) @ ( lim @ product_unit @ H2 ) ) ) ) ) ).

% snga_assn_raw.simps
thf(fact_4521_relH__array,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [As2: set @ nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: array @ A] :
          ( ( relH @ As2 @ H2 @ H5 )
         => ( ( member2 @ nat @ ( addr_of_array @ A @ R4 ) @ As2 )
           => ( ( array_get @ A @ H2 @ R4 )
              = ( array_get @ A @ H5 @ R4 ) ) ) ) ) ).

% relH_array
thf(fact_4522_snga__assn__raw_Opelims_I3_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ~ ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                 => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
                   => ( ( ( array_get @ A @ H3 @ X )
                        = Xa )
                      & ( As
                        = ( insert3 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                      & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(3)
thf(fact_4523_snga__assn__raw_Opelims_I2_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                 => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) )
                   => ~ ( ( ( array_get @ A @ H3 @ X )
                          = Xa )
                        & ( As
                          = ( insert3 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(2)
thf(fact_4524_snga__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: array @ A,Xa: list @ A,Xb: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
          ( ( ( snga_assn_raw @ A @ X @ Xa @ Xb )
            = Y )
         => ( ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ Xb ) ) )
           => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
                  ( ( Xb
                    = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
                 => ( ( Y
                      = ( ( ( array_get @ A @ H3 @ X )
                          = Xa )
                        & ( As
                          = ( insert3 @ nat @ ( addr_of_array @ A @ X ) @ ( bot_bot @ ( set @ nat ) ) ) )
                        & ( ord_less @ nat @ ( addr_of_array @ A @ X ) @ ( lim @ product_unit @ H3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) ) @ ( snga_assn_raw_rel @ A ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ Xa @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ) ) ) ) ).

% snga_assn_raw.pelims(1)
thf(fact_4525_relH__set__array,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: array @ A,As2: set @ nat,H2: heap_ext @ product_unit,X: list @ A] :
          ( ~ ( member2 @ nat @ ( addr_of_array @ A @ R4 ) @ As2 )
         => ( ( in_range @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
           => ( relH @ As2 @ H2 @ ( array_set @ A @ R4 @ X @ H2 ) ) ) ) ) ).

% relH_set_array
thf(fact_4526_pure__assn__raw_Opelims_I3_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ~ ( pure_assn_raw @ A @ B @ X @ Xa )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ Xa ) )
       => ~ ! [H3: A,As: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) ) )
               => ( ( As
                    = ( bot_bot @ ( set @ B ) ) )
                  & X ) ) ) ) ) ).

% pure_assn_raw.pelims(3)
thf(fact_4527_pure__assn__raw_Opelims_I2_J,axiom,
    ! [B: $tType,A: $tType,X: $o,Xa: product_prod @ A @ ( set @ B )] :
      ( ( pure_assn_raw @ A @ B @ X @ Xa )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ Xa ) )
       => ~ ! [H3: A,As: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) ) )
               => ~ ( ( As
                      = ( bot_bot @ ( set @ B ) ) )
                    & X ) ) ) ) ) ).

% pure_assn_raw.pelims(2)
thf(fact_4528_pure__assn__raw_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: $o,Xa: product_prod @ A @ ( set @ B ),Y: $o] :
      ( ( ( pure_assn_raw @ A @ B @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ Xa ) )
       => ~ ! [H3: A,As: set @ B] :
              ( ( Xa
                = ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) )
             => ( ( Y
                  = ( ( As
                      = ( bot_bot @ ( set @ B ) ) )
                    & X ) )
               => ~ ( accp @ ( product_prod @ $o @ ( product_prod @ A @ ( set @ B ) ) ) @ ( pure_assn_raw_rel @ A @ B ) @ ( product_Pair @ $o @ ( product_prod @ A @ ( set @ B ) ) @ X @ ( product_Pair @ A @ ( set @ B ) @ H3 @ As ) ) ) ) ) ) ) ).

% pure_assn_raw.pelims(1)
thf(fact_4529_cINF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,B4: set @ B] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
           => ( ( B4
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ B4 ) )
               => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ B4 ) ) ) ) ) ) ) ) ) ).

% cINF_union
thf(fact_4530_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F2: B > A,G: B > A,A5: set @ B] :
          ( ( condit1013018076250108175_below @ A
            @ ( image2 @ B @ A
              @ ^ [X2: B] : ( inf_inf @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ A5 ) )
          = ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
            & ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ A5 ) ) ) ) ) ).

% bdd_below_image_inf
thf(fact_4531_bdd__below__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A5 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% bdd_below_Int1
thf(fact_4532_bdd__below__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B4: set @ A,A5: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B4 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% bdd_below_Int2
thf(fact_4533_cInf__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A3: A] :
          ( ( condit1013018076250108175_below @ A @ X7 )
         => ( ( ( X7
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert3 @ A @ A3 @ X7 ) )
                = A3 ) )
            & ( ( X7
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert3 @ A @ A3 @ X7 ) )
                = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ X7 ) ) ) ) ) ) ) ).

% cInf_insert_If
thf(fact_4534_cInf__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A3: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X7 )
           => ( ( complete_Inf_Inf @ A @ ( insert3 @ A @ A3 @ X7 ) )
              = ( inf_inf @ A @ A3 @ ( complete_Inf_Inf @ A @ X7 ) ) ) ) ) ) ).

% cInf_insert
thf(fact_4535_cInf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A5 )
           => ( ( B4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit1013018076250108175_below @ A @ B4 )
               => ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ) ) ) ) ).

% cInf_union_distrib
thf(fact_4536_cINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,G: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
           => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ G @ A5 ) )
             => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ G @ A5 ) ) )
                = ( complete_Inf_Inf @ A
                  @ ( image2 @ B @ A
                    @ ^ [A4: B] : ( inf_inf @ A @ ( F2 @ A4 ) @ ( G @ A4 ) )
                    @ A5 ) ) ) ) ) ) ) ).

% cINF_inf_distrib
thf(fact_4537_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A5 )
         => ( ( condit1013018076250108175_below @ A @ B4 )
           => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ) ) ) ).

% less_eq_cInf_inter
thf(fact_4538_cINF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,A3: B] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image2 @ B @ A @ F2 @ A5 ) )
           => ( ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ ( insert3 @ B @ A3 @ A5 ) ) )
              = ( inf_inf @ A @ ( F2 @ A3 ) @ ( complete_Inf_Inf @ A @ ( image2 @ B @ A @ F2 @ A5 ) ) ) ) ) ) ) ).

% cINF_insert
thf(fact_4539_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( condit941137186595557371_above @ A @ A5 )
         => ( ( condit941137186595557371_above @ A @ B4 )
           => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B4 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) @ ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ) ) ).

% cSup_inter_less_eq
thf(fact_4540_prod__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups1828464146339083142d_list @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_list.comm_monoid_list_axioms
thf(fact_4541_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_4542_lexord__asymmetric,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A3: list @ A,B2: list @ A] :
      ( ( asym @ A @ R )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A3 @ B2 ) @ ( lexord @ A @ R ) )
       => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ B2 @ A3 ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_asymmetric
thf(fact_4543_bdd__above__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A5: set @ A,B4: set @ A] :
          ( ( condit941137186595557371_above @ A @ A5 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% bdd_above_Int1
thf(fact_4544_bdd__above__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B4: set @ A,A5: set @ A] :
          ( ( condit941137186595557371_above @ A @ B4 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ) ).

% bdd_above_Int2
thf(fact_4545_asym__lex,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( asym @ A @ R )
     => ( asym @ ( list @ A ) @ ( lex @ A @ R ) ) ) ).

% asym_lex
thf(fact_4546_lexord__asym,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( asym @ A @ R )
     => ( asym @ ( list @ A ) @ ( lexord @ A @ R ) ) ) ).

% lexord_asym
thf(fact_4547_asym__lenlex,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( asym @ A @ R )
     => ( asym @ ( list @ A ) @ ( lenlex @ A @ R ) ) ) ).

% asym_lenlex
thf(fact_4548_list__all__zip_Opelims_I1_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B,Y: $o] :
      ( ( ( list_all_zip @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Xb
                = ( nil @ B ) )
             => ( Y
               => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) ) ) ) )
         => ( ! [A6: A,As: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A6 @ As ) )
               => ! [B5: B,Bs2: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ B5 @ Bs2 ) )
                   => ( ( Y
                        = ( ( X @ A6 @ B5 )
                          & ( list_all_zip @ A @ B @ X @ As @ Bs2 ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ ( cons @ B @ B5 @ Bs2 ) ) ) ) ) ) )
           => ( ! [V: A,Va: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ V @ Va ) )
                 => ( ( Xb
                      = ( nil @ B ) )
                   => ( ~ Y
                     => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V @ Va ) @ ( nil @ B ) ) ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ! [V: B,Va: list @ B] :
                      ( ( Xb
                        = ( cons @ B @ V @ Va ) )
                     => ( ~ Y
                       => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V @ Va ) ) ) ) ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(1)
thf(fact_4549_list__all__zip_Opelims_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B] :
      ( ( list_all_zip @ A @ B @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Xb
                = ( nil @ B ) )
             => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) ) ) ) )
         => ~ ! [A6: A,As: list @ A] :
                ( ( Xa
                  = ( cons @ A @ A6 @ As ) )
               => ! [B5: B,Bs2: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ B5 @ Bs2 ) )
                   => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ ( cons @ B @ B5 @ Bs2 ) ) ) )
                     => ~ ( ( X @ A6 @ B5 )
                          & ( list_all_zip @ A @ B @ X @ As @ Bs2 ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(2)
thf(fact_4550_list__all__zip_Opelims_I3_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B] :
      ( ~ ( list_all_zip @ A @ B @ X @ Xa @ Xb )
     => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ! [A6: A,As: list @ A] :
              ( ( Xa
                = ( cons @ A @ A6 @ As ) )
             => ! [B5: B,Bs2: list @ B] :
                  ( ( Xb
                    = ( cons @ B @ B5 @ Bs2 ) )
                 => ( ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ ( cons @ B @ B5 @ Bs2 ) ) ) )
                   => ( ( X @ A6 @ B5 )
                      & ( list_all_zip @ A @ B @ X @ As @ Bs2 ) ) ) ) )
         => ( ! [V: A,Va: list @ A] :
                ( ( Xa
                  = ( cons @ A @ V @ Va ) )
               => ( ( Xb
                    = ( nil @ B ) )
                 => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ V @ Va ) @ ( nil @ B ) ) ) ) ) )
           => ~ ( ( Xa
                  = ( nil @ A ) )
               => ! [V: B,Va: list @ B] :
                    ( ( Xb
                      = ( cons @ B @ V @ Va ) )
                   => ~ ( accp @ ( product_prod @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( list_all_zip_rel @ A @ B ) @ ( product_Pair @ ( A > B > $o ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( cons @ B @ V @ Va ) ) ) ) ) ) ) ) ) ) ).

% list_all_zip.pelims(3)
thf(fact_4551_nths__nths,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ nat,B4: set @ nat] :
      ( ( nths @ A @ ( nths @ A @ Xs @ A5 ) @ B4 )
      = ( nths @ A @ Xs
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( member2 @ nat @ I4 @ A5 )
              & ( member2 @ nat
                @ ( finite_card @ nat
                  @ ( collect @ nat
                    @ ^ [I8: nat] :
                        ( ( member2 @ nat @ I8 @ A5 )
                        & ( ord_less @ nat @ I8 @ I4 ) ) ) )
                @ B4 ) ) ) ) ) ).

% nths_nths
thf(fact_4552_list__all__zip_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o] : ( list_all_zip @ A @ B @ P2 @ ( nil @ A ) @ ( nil @ B ) ) ).

% list_all_zip.simps(1)
thf(fact_4553_Bex__set__list__ex,axiom,
    ! [A: $tType,Xs: list @ A,P2: A > $o] :
      ( ( ? [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P2 @ X2 ) ) )
      = ( list_ex @ A @ P2 @ Xs ) ) ).

% Bex_set_list_ex
thf(fact_4554_list__all__zip_Oelims_I3_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B] :
      ( ~ ( list_all_zip @ A @ B @ X @ Xa @ Xb )
     => ( ! [A6: A,As: list @ A] :
            ( ( Xa
              = ( cons @ A @ A6 @ As ) )
           => ! [B5: B,Bs2: list @ B] :
                ( ( Xb
                  = ( cons @ B @ B5 @ Bs2 ) )
               => ( ( X @ A6 @ B5 )
                  & ( list_all_zip @ A @ B @ X @ As @ Bs2 ) ) ) )
       => ( ( ? [V: A,Va: list @ A] :
                ( Xa
                = ( cons @ A @ V @ Va ) )
           => ( Xb
             != ( nil @ B ) ) )
         => ~ ( ( Xa
                = ( nil @ A ) )
             => ! [V: B,Va: list @ B] :
                  ( Xb
                 != ( cons @ B @ V @ Va ) ) ) ) ) ) ).

% list_all_zip.elims(3)
thf(fact_4555_list__all__zip_Oelims_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B] :
      ( ( list_all_zip @ A @ B @ X @ Xa @ Xb )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Xb
           != ( nil @ B ) ) )
       => ~ ! [A6: A,As: list @ A] :
              ( ( Xa
                = ( cons @ A @ A6 @ As ) )
             => ! [B5: B,Bs2: list @ B] :
                  ( ( Xb
                    = ( cons @ B @ B5 @ Bs2 ) )
                 => ~ ( ( X @ A6 @ B5 )
                      & ( list_all_zip @ A @ B @ X @ As @ Bs2 ) ) ) ) ) ) ).

% list_all_zip.elims(2)
thf(fact_4556_list__all__zip_Oelims_I1_J,axiom,
    ! [B: $tType,A: $tType,X: A > B > $o,Xa: list @ A,Xb: list @ B,Y: $o] :
      ( ( ( list_all_zip @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( ( Xb
              = ( nil @ B ) )
           => ~ Y ) )
       => ( ! [A6: A,As: list @ A] :
              ( ( Xa
                = ( cons @ A @ A6 @ As ) )
             => ! [B5: B,Bs2: list @ B] :
                  ( ( Xb
                    = ( cons @ B @ B5 @ Bs2 ) )
                 => ( Y
                    = ( ~ ( ( X @ A6 @ B5 )
                          & ( list_all_zip @ A @ B @ X @ As @ Bs2 ) ) ) ) ) )
         => ( ( ? [V: A,Va: list @ A] :
                  ( Xa
                  = ( cons @ A @ V @ Va ) )
             => ( ( Xb
                  = ( nil @ B ) )
               => Y ) )
           => ~ ( ( Xa
                  = ( nil @ A ) )
               => ( ? [V: B,Va: list @ B] :
                      ( Xb
                      = ( cons @ B @ V @ Va ) )
                 => Y ) ) ) ) ) ) ).

% list_all_zip.elims(1)
thf(fact_4557_list__all__zip_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,V2: B,Va2: list @ B] :
      ~ ( list_all_zip @ A @ B @ P2 @ ( nil @ A ) @ ( cons @ B @ V2 @ Va2 ) ) ).

% list_all_zip.simps(4)
thf(fact_4558_list__all__zip_Osimps_I3_J,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o,V2: A,Va2: list @ A] :
      ~ ( list_all_zip @ A @ B @ P2 @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ B ) ) ).

% list_all_zip.simps(3)
thf(fact_4559_quotient__disj,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A ),X7: set @ A,Y6: set @ A] :
      ( ( equiv_equiv @ A @ A5 @ R4 )
     => ( ( member2 @ ( set @ A ) @ X7 @ ( equiv_quotient @ A @ A5 @ R4 ) )
       => ( ( member2 @ ( set @ A ) @ Y6 @ ( equiv_quotient @ A @ A5 @ R4 ) )
         => ( ( X7 = Y6 )
            | ( ( inf_inf @ ( set @ A ) @ X7 @ Y6 )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% quotient_disj
thf(fact_4560_Range__Int__subset,axiom,
    ! [A: $tType,B: $tType,A5: set @ ( product_prod @ B @ A ),B4: set @ ( product_prod @ B @ A )] : ( ord_less_eq @ ( set @ A ) @ ( range2 @ B @ A @ ( inf_inf @ ( set @ ( product_prod @ B @ A ) ) @ A5 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( range2 @ B @ A @ A5 ) @ ( range2 @ B @ A @ B4 ) ) ) ).

% Range_Int_subset
thf(fact_4561_Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( bleast @ A )
        = ( ^ [S7: set @ A,P: A > $o] :
              ( ord_Least @ A
              @ ^ [X2: A] :
                  ( ( member2 @ A @ X2 @ S7 )
                  & ( P @ X2 ) ) ) ) ) ) ).

% Bleast_def
thf(fact_4562_abort__Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( abort_Bleast @ A )
        = ( ^ [S7: set @ A,P: A > $o] :
              ( ord_Least @ A
              @ ^ [X2: A] :
                  ( ( member2 @ A @ X2 @ S7 )
                  & ( P @ X2 ) ) ) ) ) ) ).

% abort_Bleast_def
thf(fact_4563_dom__ran__disj__comp,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( relcomp @ A @ A @ A @ R @ R )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% dom_ran_disj_comp
thf(fact_4564_Domain__Int__subset,axiom,
    ! [B: $tType,A: $tType,A5: set @ ( product_prod @ A @ B ),B4: set @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ A ) @ ( domain @ A @ B @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ A5 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( domain @ A @ B @ A5 ) @ ( domain @ A @ B @ B4 ) ) ) ).

% Domain_Int_subset
thf(fact_4565_nth__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I2: nat,Xs: list @ A,A3: array @ A] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( hoare_hoare_triple @ A @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_nth @ A @ A3 @ I2 )
            @ ^ [R3: A] :
                ( times_times @ assn @ ( snga_assn @ A @ A3 @ Xs )
                @ ( pure_assn
                  @ ( R3
                    = ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ) ).

% nth_rule
thf(fact_4566_norm__pre__pure__iff,axiom,
    ! [A: $tType,P2: assn,B2: $o,F2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ( hoare_hoare_triple @ A @ ( times_times @ assn @ P2 @ ( pure_assn @ B2 ) ) @ F2 @ Q2 )
      = ( B2
       => ( hoare_hoare_triple @ A @ P2 @ F2 @ Q2 ) ) ) ).

% norm_pre_pure_iff
thf(fact_4567_norm__pre__pure__iff__sng,axiom,
    ! [A: $tType,B2: $o,F2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ( hoare_hoare_triple @ A @ ( pure_assn @ B2 ) @ F2 @ Q2 )
      = ( B2
       => ( hoare_hoare_triple @ A @ ( one_one @ assn ) @ F2 @ Q2 ) ) ) ).

% norm_pre_pure_iff_sng
thf(fact_4568_norm__pre__pure__rule2,axiom,
    ! [A: $tType,B2: $o,F2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ( B2
       => ( hoare_hoare_triple @ A @ ( one_one @ assn ) @ F2 @ Q2 ) )
     => ( hoare_hoare_triple @ A @ ( pure_assn @ B2 ) @ F2 @ Q2 ) ) ).

% norm_pre_pure_rule2
thf(fact_4569_is__hoare__triple,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 )
     => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 ) ) ).

% is_hoare_triple
thf(fact_4570_cons__post__rule,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn,Q3: A > assn] :
      ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 )
     => ( ! [X3: A] : ( entails @ ( Q2 @ X3 ) @ ( Q3 @ X3 ) )
       => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q3 ) ) ) ).

% cons_post_rule
thf(fact_4571_cons__rule,axiom,
    ! [A: $tType,P2: assn,P3: assn,Q2: A > assn,Q3: A > assn,C2: heap_Time_Heap @ A] :
      ( ( entails @ P2 @ P3 )
     => ( ! [X3: A] : ( entails @ ( Q2 @ X3 ) @ ( Q3 @ X3 ) )
       => ( ( hoare_hoare_triple @ A @ P3 @ C2 @ Q2 )
         => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q3 ) ) ) ) ).

% cons_rule
thf(fact_4572_hoare__triple__preI,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P2 @ H3 )
         => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 ) )
     => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 ) ) ).

% hoare_triple_preI
thf(fact_4573_case__list__rule,axiom,
    ! [A: $tType,B: $tType,L: list @ A,P2: assn,Fn: heap_Time_Heap @ B,Q2: B > assn,Fc: A > ( list @ A ) > ( heap_Time_Heap @ B )] :
      ( ( ( L
          = ( nil @ A ) )
       => ( hoare_hoare_triple @ B @ P2 @ Fn @ Q2 ) )
     => ( ! [X3: A,Xs2: list @ A] :
            ( ( L
              = ( cons @ A @ X3 @ Xs2 ) )
           => ( hoare_hoare_triple @ B @ P2 @ ( Fc @ X3 @ Xs2 ) @ Q2 ) )
       => ( hoare_hoare_triple @ B @ P2 @ ( case_list @ ( heap_Time_Heap @ B ) @ A @ Fn @ Fc @ L ) @ Q2 ) ) ) ).

% case_list_rule
thf(fact_4574_cons__pre__rule,axiom,
    ! [A: $tType,P2: assn,P3: assn,C2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ( entails @ P2 @ P3 )
     => ( ( hoare_hoare_triple @ A @ P3 @ C2 @ Q2 )
       => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 ) ) ) ).

% cons_pre_rule
thf(fact_4575_norm__pre__pure__rule1,axiom,
    ! [A: $tType,B2: $o,P2: assn,F2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ( B2
       => ( hoare_hoare_triple @ A @ P2 @ F2 @ Q2 ) )
     => ( hoare_hoare_triple @ A @ ( times_times @ assn @ P2 @ ( pure_assn @ B2 ) ) @ F2 @ Q2 ) ) ).

% norm_pre_pure_rule1
thf(fact_4576_frame__rule,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn,R: assn] :
      ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 )
     => ( hoare_hoare_triple @ A @ ( times_times @ assn @ P2 @ R ) @ C2
        @ ^ [X2: A] : ( times_times @ assn @ ( Q2 @ X2 ) @ R ) ) ) ).

% frame_rule
thf(fact_4577_cons__rulet,axiom,
    ! [A: $tType,P2: assn,P3: assn,Q2: A > assn,Q3: A > assn,C2: heap_Time_Heap @ A] :
      ( ( entailst @ P2 @ P3 )
     => ( ! [X3: A] : ( entailst @ ( Q2 @ X3 ) @ ( Q3 @ X3 ) )
       => ( ( hoare_hoare_triple @ A @ P3 @ C2
            @ ^ [R3: A] : ( times_times @ assn @ ( Q2 @ R3 ) @ ( top_top @ assn ) ) )
         => ( hoare_hoare_triple @ A @ P2 @ C2
            @ ^ [R3: A] : ( times_times @ assn @ ( Q3 @ R3 ) @ ( top_top @ assn ) ) ) ) ) ) ).

% cons_rulet
thf(fact_4578_cons__pre__rulet,axiom,
    ! [A: $tType,P2: assn,P3: assn,C2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ( entailst @ P2 @ P3 )
     => ( ( hoare_hoare_triple @ A @ P3 @ C2
          @ ^ [R3: A] : ( times_times @ assn @ ( Q2 @ R3 ) @ ( top_top @ assn ) ) )
       => ( hoare_hoare_triple @ A @ P2 @ C2
          @ ^ [R3: A] : ( times_times @ assn @ ( Q2 @ R3 ) @ ( top_top @ assn ) ) ) ) ) ).

% cons_pre_rulet
thf(fact_4579_cons__post__rulet,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn,Q3: A > assn] :
      ( ( hoare_hoare_triple @ A @ P2 @ C2
        @ ^ [R3: A] : ( times_times @ assn @ ( Q2 @ R3 ) @ ( top_top @ assn ) ) )
     => ( ! [X3: A] : ( entailst @ ( Q2 @ X3 ) @ ( Q3 @ X3 ) )
       => ( hoare_hoare_triple @ A @ P2 @ C2
          @ ^ [R3: A] : ( times_times @ assn @ ( Q3 @ R3 ) @ ( top_top @ assn ) ) ) ) ) ).

% cons_post_rulet
thf(fact_4580_if__rule__split,axiom,
    ! [A: $tType,B2: $o,P2: assn,F2: heap_Time_Heap @ A,Q1: A > assn,G: heap_Time_Heap @ A,Q22: A > assn,Q2: A > assn] :
      ( ( B2
       => ( hoare_hoare_triple @ A @ P2 @ F2 @ Q1 ) )
     => ( ( ~ B2
         => ( hoare_hoare_triple @ A @ P2 @ G @ Q22 ) )
       => ( ! [X3: A] : ( entails @ ( sup_sup @ assn @ ( times_times @ assn @ ( Q1 @ X3 ) @ ( pure_assn @ B2 ) ) @ ( times_times @ assn @ ( Q22 @ X3 ) @ ( pure_assn @ ~ B2 ) ) ) @ ( Q2 @ X3 ) )
         => ( hoare_hoare_triple @ A @ P2 @ ( if @ ( heap_Time_Heap @ A ) @ B2 @ F2 @ G ) @ Q2 ) ) ) ) ).

% if_rule_split
thf(fact_4581_upd__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I2: nat,Xs: list @ A,A3: array @ A,X: A] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( hoare_hoare_triple @ ( array @ A ) @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_upd @ A @ I2 @ X @ A3 )
            @ ^ [R3: array @ A] : ( times_times @ assn @ ( snga_assn @ A @ A3 @ ( list_update @ A @ Xs @ I2 @ X ) ) @ ( pure_assn @ ( R3 = A3 ) ) ) ) ) ) ).

% upd_rule
thf(fact_4582_make__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,F2: nat > A] :
          ( hoare_hoare_triple @ ( array @ A ) @ ( one_one @ assn ) @ ( array_make @ A @ N @ F2 )
          @ ^ [R3: array @ A] : ( snga_assn @ A @ R3 @ ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% make_rule
thf(fact_4583_length__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,Xs: list @ A] :
          ( hoare_hoare_triple @ nat @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_len @ A @ A3 )
          @ ^ [R3: nat] :
              ( times_times @ assn @ ( snga_assn @ A @ A3 @ Xs )
              @ ( pure_assn
                @ ( R3
                  = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% length_rule
thf(fact_4584_new__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,X: A] :
          ( hoare_hoare_triple @ ( array @ A ) @ ( one_one @ assn ) @ ( array_new @ A @ N @ X )
          @ ^ [R3: array @ A] : ( snga_assn @ A @ R3 @ ( replicate @ A @ N @ X ) ) ) ) ).

% new_rule
thf(fact_4585_lookup__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [P7: ref @ A,X: A] :
          ( hoare_hoare_triple @ A @ ( sngr_assn @ A @ P7 @ X ) @ ( ref_lookup @ A @ P7 )
          @ ^ [R3: A] : ( times_times @ assn @ ( sngr_assn @ A @ P7 @ X ) @ ( pure_assn @ ( R3 = X ) ) ) ) ) ).

% lookup_rule
thf(fact_4586_of__list__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [Xs: list @ A] :
          ( hoare_hoare_triple @ ( array @ A ) @ ( one_one @ assn ) @ ( array_of_list @ A @ Xs )
          @ ^ [R3: array @ A] : ( snga_assn @ A @ R3 @ Xs ) ) ) ).

% of_list_rule
thf(fact_4587_freeze__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,Xs: list @ A] :
          ( hoare_hoare_triple @ ( list @ A ) @ ( snga_assn @ A @ A3 @ Xs ) @ ( array_freeze @ A @ A3 )
          @ ^ [R3: list @ A] : ( times_times @ assn @ ( snga_assn @ A @ A3 @ Xs ) @ ( pure_assn @ ( R3 = Xs ) ) ) ) ) ).

% freeze_rule
thf(fact_4588_ref__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [X: A] :
          ( hoare_hoare_triple @ ( ref @ A ) @ ( one_one @ assn ) @ ( ref_ref @ A @ X )
          @ ^ [R3: ref @ A] : ( sngr_assn @ A @ R3 @ X ) ) ) ).

% ref_rule
thf(fact_4589_return__sp__rule,axiom,
    ! [A: $tType,P2: assn,X: A] :
      ( hoare_hoare_triple @ A @ P2 @ ( heap_Time_return @ A @ X )
      @ ^ [R3: A] : ( times_times @ assn @ P2 @ ( pure_assn @ ( R3 = X ) ) ) ) ).

% return_sp_rule
thf(fact_4590_wf__UN,axiom,
    ! [B: $tType,A: $tType,I: set @ A,R4: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ! [I3: A] :
          ( ( member2 @ A @ I3 @ I )
         => ( wf @ B @ ( R4 @ I3 ) ) )
     => ( ! [I3: A,J3: A] :
            ( ( member2 @ A @ I3 @ I )
           => ( ( member2 @ A @ J3 @ I )
             => ( ( ( R4 @ I3 )
                 != ( R4 @ J3 ) )
               => ( ( inf_inf @ ( set @ B ) @ ( domain @ B @ B @ ( R4 @ I3 ) ) @ ( range2 @ B @ B @ ( R4 @ J3 ) ) )
                  = ( bot_bot @ ( set @ B ) ) ) ) ) )
       => ( wf @ B @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ B ) ) @ ( image2 @ A @ ( set @ ( product_prod @ B @ B ) ) @ R4 @ I ) ) ) ) ) ).

% wf_UN
thf(fact_4591_hoare__triple__success,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 )
     => ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ( heap_Time_success @ A @ C2 @ H2 ) ) ) ).

% hoare_triple_success
thf(fact_4592_wf__no__path,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R ) @ ( range2 @ A @ A @ R ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( wf @ A @ R ) ) ).

% wf_no_path
thf(fact_4593_wf__listrel1__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( wf @ ( list @ A ) @ ( listrel1 @ A @ R4 ) )
      = ( wf @ A @ R4 ) ) ).

% wf_listrel1_iff
thf(fact_4594_wf__lex,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( wf @ ( list @ A ) @ ( lex @ A @ R4 ) ) ) ).

% wf_lex
thf(fact_4595_wf__lenlex,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( wf @ ( list @ A ) @ ( lenlex @ A @ R4 ) ) ) ).

% wf_lenlex
thf(fact_4596_wf__Int2,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( wf @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R7 @ R4 ) ) ) ).

% wf_Int2
thf(fact_4597_wf__Int1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),R7: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( wf @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ R7 ) ) ) ).

% wf_Int1
thf(fact_4598_wf__measures,axiom,
    ! [A: $tType,Fs: list @ ( A > nat )] : ( wf @ A @ ( measures @ A @ Fs ) ) ).

% wf_measures
thf(fact_4599_wf__lexn,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( wf @ A @ R4 )
     => ( wf @ ( list @ A ) @ ( lexn @ A @ R4 @ N ) ) ) ).

% wf_lexn
thf(fact_4600_wf__Un,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( ( wf @ A @ S3 )
       => ( ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ R4 ) @ ( range2 @ A @ A @ S3 ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( wf @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S3 ) ) ) ) ) ).

% wf_Un
thf(fact_4601_wf__Union,axiom,
    ! [A: $tType,R: set @ ( set @ ( product_prod @ A @ A ) )] :
      ( ! [X3: set @ ( product_prod @ A @ A )] :
          ( ( member2 @ ( set @ ( product_prod @ A @ A ) ) @ X3 @ R )
         => ( wf @ A @ X3 ) )
     => ( ! [X3: set @ ( product_prod @ A @ A )] :
            ( ( member2 @ ( set @ ( product_prod @ A @ A ) ) @ X3 @ R )
           => ! [Xa3: set @ ( product_prod @ A @ A )] :
                ( ( member2 @ ( set @ ( product_prod @ A @ A ) ) @ Xa3 @ R )
               => ( ( X3 != Xa3 )
                 => ( ( inf_inf @ ( set @ A ) @ ( domain @ A @ A @ X3 ) @ ( range2 @ A @ A @ Xa3 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
       => ( wf @ A @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) ) @ R ) ) ) ) ).

% wf_Union
thf(fact_4602_trans__wf__iff,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( ( wf @ A @ R4 )
        = ( ! [A4: A] :
              ( wf @ A
              @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                @ ( product_Sigma @ A @ A @ ( image @ A @ A @ ( converse @ A @ A @ R4 ) @ ( insert3 @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
                  @ ^ [Uu2: A] : ( image @ A @ A @ ( converse @ A @ A @ R4 ) @ ( insert3 @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% trans_wf_iff
thf(fact_4603_Array__Time_Omake__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_make @ A )
        = ( ^ [N3: nat,F3: nat > A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) )
                  @ ( array_alloc @ A @ ( map @ nat @ A @ F3 @ ( upt @ ( zero_zero @ nat ) @ N3 ) ) @ H ) ) ) ) ) ) ).

% Array_Time.make_def
thf(fact_4604_wait__rule,axiom,
    ! [N: nat] :
      ( hoare_hoare_triple @ product_unit @ ( one_one @ assn ) @ ( heap_Time_wait @ N )
      @ ^ [Uu2: product_unit] : ( one_one @ assn ) ) ).

% wait_rule
thf(fact_4605_lenlex__transI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( trans @ ( list @ A ) @ ( lenlex @ A @ R4 ) ) ) ).

% lenlex_transI
thf(fact_4606_lexn__transI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( trans @ A @ R4 )
     => ( trans @ ( list @ A ) @ ( lexn @ A @ R4 @ N ) ) ) ).

% lexn_transI
thf(fact_4607_listrel__trans,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( trans @ ( list @ A ) @ ( listrel @ A @ A @ R4 ) ) ) ).

% listrel_trans
thf(fact_4608_lexord__transI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( trans @ ( list @ A ) @ ( lexord @ A @ R4 ) ) ) ).

% lexord_transI
thf(fact_4609_lex__transI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( trans @ ( list @ A ) @ ( lex @ A @ R4 ) ) ) ).

% lex_transI
thf(fact_4610_trans__Int,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( trans @ A @ R4 )
     => ( ( trans @ A @ S3 )
       => ( trans @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S3 ) ) ) ) ).

% trans_Int
thf(fact_4611_lexord__trans,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A ),Z2: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R4 ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ Z2 ) @ ( lexord @ A @ R4 ) )
       => ( ( trans @ A @ R4 )
         => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Z2 ) @ ( lexord @ A @ R4 ) ) ) ) ) ).

% lexord_trans
thf(fact_4612_lenlex__trans,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R4: set @ ( product_prod @ A @ A ),Z2: list @ A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lenlex @ A @ R4 ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ Z2 ) @ ( lenlex @ A @ R4 ) )
       => ( ( trans @ A @ R4 )
         => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Z2 ) @ ( lenlex @ A @ R4 ) ) ) ) ) ).

% lenlex_trans
thf(fact_4613_trans__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( trans @ A @ R4 )
     => ( trans @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% trans_Restr
thf(fact_4614_of__list__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_of_list @ A )
        = ( ^ [Xs4: list @ A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs4 ) ) ) )
                  @ ( array_alloc @ A @ Xs4 @ H ) ) ) ) ) ) ).

% of_list_def
thf(fact_4615_new__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_new @ A )
        = ( ^ [N3: nat,X2: A] :
              ( heap_Time_heap @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) )
                  @ ( array_alloc @ A @ ( replicate @ A @ N3 @ X2 ) @ H ) ) ) ) ) ) ).

% new_def
thf(fact_4616_return__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_return @ A )
      = ( ^ [X2: A] :
            ( heap_Time_heap @ A
            @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ) ).

% return_def
thf(fact_4617_effect__makeI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H5: heap_ext @ product_unit,F2: nat > A,N: nat,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ A3 @ H5 )
            = ( array_alloc @ A @ ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N ) ) @ H2 ) )
         => ( heap_Time_effect @ ( array @ A ) @ ( array_make @ A @ N @ F2 ) @ H2 @ H5 @ A3 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% effect_makeI
thf(fact_4618_execute__make,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,F2: nat > A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_make @ A @ N @ F2 ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
              @ ( array_alloc @ A @ ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N ) ) @ H2 ) ) ) ) ) ).

% execute_make
thf(fact_4619_effect__returnI,axiom,
    ! [A: $tType,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,X: A] :
      ( ( H2 = H5 )
     => ( heap_Time_effect @ A @ ( heap_Time_return @ A @ X ) @ H2 @ H5 @ X @ ( one_one @ nat ) ) ) ).

% effect_returnI
thf(fact_4620_effect__returnE,axiom,
    ! [A: $tType,X: A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_return @ A @ X ) @ H2 @ H5 @ R4 @ N )
     => ~ ( ( R4 = X )
         => ( ( H5 = H2 )
           => ( N
             != ( one_one @ nat ) ) ) ) ) ).

% effect_returnE
thf(fact_4621_execute__return,axiom,
    ! [A: $tType,X: A] :
      ( ( heap_Time_execute @ A @ ( heap_Time_return @ A @ X ) )
      = ( comp @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( option @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) ) @ ( heap_ext @ product_unit ) @ ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) )
        @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ).

% execute_return
thf(fact_4622_execute__of__list,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [Xs: list @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_of_list @ A @ Xs ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) )
              @ ( array_alloc @ A @ Xs @ H2 ) ) ) ) ) ).

% execute_of_list
thf(fact_4623_execute__new,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,X: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( array @ A ) @ ( array_new @ A @ N @ X ) @ H2 )
          = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: array @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
              @ ( array_alloc @ A @ ( replicate @ A @ N @ X ) @ H2 ) ) ) ) ) ).

% execute_new
thf(fact_4624_effect__of__listI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H5: heap_ext @ product_unit,Xs: list @ A,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ A3 @ H5 )
            = ( array_alloc @ A @ Xs @ H2 ) )
         => ( heap_Time_effect @ ( array @ A ) @ ( array_of_list @ A @ Xs ) @ H2 @ H5 @ A3 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% effect_of_listI
thf(fact_4625_effect__newI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H5: heap_ext @ product_unit,N: nat,X: A,H2: heap_ext @ product_unit] :
          ( ( ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ A3 @ H5 )
            = ( array_alloc @ A @ ( replicate @ A @ N @ X ) @ H2 ) )
         => ( heap_Time_effect @ ( array @ A ) @ ( array_new @ A @ N @ X ) @ H2 @ H5 @ A3 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% effect_newI
thf(fact_4626_execute__lookup,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ A @ ( ref_lookup @ A @ R4 ) @ H2 )
          = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( ref_get @ A @ H2 @ R4 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_lookup
thf(fact_4627_hoare__tripleE,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 )
     => ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ~ ! [R5: A,H4: heap_ext @ product_unit] :
              ( ? [T5: nat] :
                  ( ( heap_Time_execute @ A @ C2 @ H2 )
                  = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R5 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H4 @ T5 ) ) ) )
             => ( ( rep_assn @ ( Q2 @ R5 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ ( hoare_new_addrs @ H2 @ As2 @ H4 ) ) )
               => ( ( relH
                    @ ( collect @ nat
                      @ ^ [A4: nat] :
                          ( ( ord_less @ nat @ A4 @ ( lim @ product_unit @ H2 ) )
                          & ~ ( member2 @ nat @ A4 @ As2 ) ) )
                    @ H2
                    @ H4 )
                 => ~ ( ord_less_eq @ nat @ ( lim @ product_unit @ H2 ) @ ( lim @ product_unit @ H4 ) ) ) ) ) ) ) ).

% hoare_tripleE
thf(fact_4628_hoare__tripleI,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ! [H3: heap_ext @ product_unit,As: set @ nat] :
          ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
         => ? [R8: A,H6: heap_ext @ product_unit,T6: nat] :
              ( ( ( heap_Time_execute @ A @ C2 @ H3 )
                = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R8 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H6 @ T6 ) ) ) )
              & ( rep_assn @ ( Q2 @ R8 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H6 @ ( hoare_new_addrs @ H3 @ As @ H6 ) ) )
              & ( relH
                @ ( collect @ nat
                  @ ^ [A4: nat] :
                      ( ( ord_less @ nat @ A4 @ ( lim @ product_unit @ H3 ) )
                      & ~ ( member2 @ nat @ A4 @ As ) ) )
                @ H3
                @ H6 )
              & ( ord_less_eq @ nat @ ( lim @ product_unit @ H3 ) @ ( lim @ product_unit @ H6 ) ) ) )
     => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 ) ) ).

% hoare_tripleI
thf(fact_4629_hoare__triple__effect,axiom,
    ! [A: $tType,P2: assn,C2: heap_Time_Heap @ A,Q2: A > assn,H2: heap_ext @ product_unit,As2: set @ nat] :
      ( ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 )
     => ( ( rep_assn @ P2 @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H2 @ As2 ) )
       => ? [H4: heap_ext @ product_unit,R5: A,T5: nat] :
            ( ( heap_Time_effect @ A @ C2 @ H2 @ H4 @ R5 @ T5 )
            & ( rep_assn @ ( Q2 @ R5 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H4 @ ( hoare_new_addrs @ H2 @ As2 @ H4 ) ) ) ) ) ) ).

% hoare_triple_effect
thf(fact_4630_effect__lookupE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,X: A,N: nat] :
          ( ( heap_Time_effect @ A @ ( ref_lookup @ A @ R4 ) @ H2 @ H5 @ X @ N )
         => ~ ( ( H5 = H2 )
             => ( ( X
                  = ( ref_get @ A @ H2 @ R4 ) )
               => ( N
                 != ( one_one @ nat ) ) ) ) ) ) ).

% effect_lookupE
thf(fact_4631_effect__lookupI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [H5: heap_ext @ product_unit,H2: heap_ext @ product_unit,X: A,R4: ref @ A,N: nat] :
          ( ( H5 = H2 )
         => ( ( X
              = ( ref_get @ A @ H2 @ R4 ) )
           => ( ( N
                = ( one_one @ nat ) )
             => ( heap_Time_effect @ A @ ( ref_lookup @ A @ R4 ) @ H2 @ H5 @ X @ N ) ) ) ) ) ).

% effect_lookupI
thf(fact_4632_hoare__triple__def,axiom,
    ! [A: $tType] :
      ( ( hoare_hoare_triple @ A )
      = ( ^ [P: assn,C3: heap_Time_Heap @ A,Q: A > assn] :
          ! [H: heap_ext @ product_unit,As7: set @ nat] :
            ( ( rep_assn @ P @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H @ As7 ) )
           => ? [R3: A,H7: heap_ext @ product_unit] :
                ( ? [T2: nat] :
                    ( ( heap_Time_execute @ A @ C3 @ H )
                    = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ T2 ) ) ) )
                & ( rep_assn @ ( Q @ R3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H7 @ ( hoare_new_addrs @ H @ As7 @ H7 ) ) )
                & ( relH
                  @ ( collect @ nat
                    @ ^ [A4: nat] :
                        ( ( ord_less @ nat @ A4 @ ( lim @ product_unit @ H ) )
                        & ~ ( member2 @ nat @ A4 @ As7 ) ) )
                  @ H
                  @ H7 )
                & ( ord_less_eq @ nat @ ( lim @ product_unit @ H ) @ ( lim @ product_unit @ H7 ) ) ) ) ) ) ).

% hoare_triple_def
thf(fact_4633_inf__Some,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ ( option @ A ) @ ( some @ A @ X ) @ ( some @ A @ Y ) )
          = ( some @ A @ ( inf_inf @ A @ X @ Y ) ) ) ) ).

% inf_Some
thf(fact_4634_map__project__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_project @ A @ B )
      = ( ^ [F3: A > ( option @ B ),A10: set @ A] :
            ( collect @ B
            @ ^ [B3: B] :
              ? [X2: A] :
                ( ( member2 @ A @ X2 @ A10 )
                & ( ( F3 @ X2 )
                  = ( some @ B @ B3 ) ) ) ) ) ) ).

% map_project_def
thf(fact_4635_effect__makeE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,F2: nat > A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: array @ A,N5: nat] :
          ( ( heap_Time_effect @ ( array @ A ) @ ( array_make @ A @ N @ F2 ) @ H2 @ H5 @ R4 @ N5 )
         => ~ ( ( R4
                = ( product_fst @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array_alloc @ A @ ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N ) ) @ H2 ) ) )
             => ( ( H5
                  = ( product_snd @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array_alloc @ A @ ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N ) ) @ H2 ) ) )
               => ( ( ( array_get @ A @ H5 @ R4 )
                    = ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
                 => ( ( array_present @ A @ H5 @ R4 )
                   => ( ~ ( array_present @ A @ H2 @ R4 )
                     => ( ( plus_plus @ nat @ N @ ( one_one @ nat ) )
                       != N5 ) ) ) ) ) ) ) ) ).

% effect_makeE
thf(fact_4636_effect__of__listE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [Xs: list @ A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: array @ A,N5: nat] :
          ( ( heap_Time_effect @ ( array @ A ) @ ( array_of_list @ A @ Xs ) @ H2 @ H5 @ R4 @ N5 )
         => ~ ( ( R4
                = ( product_fst @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array_alloc @ A @ Xs @ H2 ) ) )
             => ( ( H5
                  = ( product_snd @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array_alloc @ A @ Xs @ H2 ) ) )
               => ( ( ( array_get @ A @ H5 @ R4 )
                    = Xs )
                 => ( ( array_present @ A @ H5 @ R4 )
                   => ( ~ ( array_present @ A @ H2 @ R4 )
                     => ( N5
                       != ( plus_plus @ nat @ ( one_one @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ) ) ) ) ).

% effect_of_listE
thf(fact_4637_effect__newE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [N: nat,X: A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: array @ A,N5: nat] :
          ( ( heap_Time_effect @ ( array @ A ) @ ( array_new @ A @ N @ X ) @ H2 @ H5 @ R4 @ N5 )
         => ~ ( ( R4
                = ( product_fst @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array_alloc @ A @ ( replicate @ A @ N @ X ) @ H2 ) ) )
             => ( ( H5
                  = ( product_snd @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array_alloc @ A @ ( replicate @ A @ N @ X ) @ H2 ) ) )
               => ( ( ( array_get @ A @ H5 @ R4 )
                    = ( replicate @ A @ N @ X ) )
                 => ( ( array_present @ A @ H5 @ R4 )
                   => ( ~ ( array_present @ A @ H2 @ R4 )
                     => ( ( plus_plus @ nat @ N @ ( one_one @ nat ) )
                       != N5 ) ) ) ) ) ) ) ) ).

% effect_newE
thf(fact_4638_execute__tap,axiom,
    ! [A: $tType,F2: ( heap_ext @ product_unit ) > A,H2: heap_ext @ product_unit] :
      ( ( heap_Time_execute @ A @ ( heap_Time_tap @ A @ F2 ) @ H2 )
      = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F2 @ H2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ).

% execute_tap
thf(fact_4639_execute__nth_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I2: nat,H2: heap_ext @ product_unit,A3: array @ A] :
          ( ( ord_less @ nat @ I2 @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( heap_Time_execute @ A @ ( array_nth @ A @ A3 @ I2 ) @ H2 )
            = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H2 @ A3 ) @ I2 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% execute_nth(1)
thf(fact_4640_execute__assert_I1_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,H2: heap_ext @ product_unit] :
      ( ( P2 @ X )
     => ( ( heap_Time_execute @ A @ ( heap_Time_assert @ A @ P2 @ X ) @ H2 )
        = ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ X @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_assert(1)
thf(fact_4641_effect__lengthE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: nat,N: nat] :
          ( ( heap_Time_effect @ nat @ ( array_len @ A @ A3 ) @ H2 @ H5 @ R4 @ N )
         => ~ ( ( R4
                = ( array_length @ A @ H5 @ A3 ) )
             => ( ( H5 = H2 )
               => ( N
                 != ( one_one @ nat ) ) ) ) ) ) ).

% effect_lengthE
thf(fact_4642_effect__lengthI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [H5: heap_ext @ product_unit,H2: heap_ext @ product_unit,R4: nat,A3: array @ A,N: nat] :
          ( ( H5 = H2 )
         => ( ( R4
              = ( array_length @ A @ H2 @ A3 ) )
           => ( ( N
                = ( one_one @ nat ) )
             => ( heap_Time_effect @ nat @ ( array_len @ A @ A3 ) @ H2 @ H5 @ R4 @ N ) ) ) ) ) ).

% effect_lengthI
thf(fact_4643_effect__assertI,axiom,
    ! [A: $tType,P2: A > $o,X: A,H5: heap_ext @ product_unit,H2: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( P2 @ X )
     => ( ( H5 = H2 )
       => ( ( R4 = X )
         => ( ( N
              = ( one_one @ nat ) )
           => ( heap_Time_effect @ A @ ( heap_Time_assert @ A @ P2 @ X ) @ H2 @ H5 @ R4 @ N ) ) ) ) ) ).

% effect_assertI
thf(fact_4644_effect__assertE,axiom,
    ! [A: $tType,P2: A > $o,X: A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_assert @ A @ P2 @ X ) @ H2 @ H5 @ R4 @ N )
     => ~ ( ( P2 @ X )
         => ( ( R4 = X )
           => ( ( H5 = H2 )
             => ( N
               != ( one_one @ nat ) ) ) ) ) ) ).

% effect_assertE
thf(fact_4645_execute__len,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ nat @ ( array_len @ A @ A3 ) @ H2 )
          = ( some @ ( product_prod @ nat @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ nat @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( array_length @ A @ H2 @ A3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_len
thf(fact_4646_effect__tapI,axiom,
    ! [A: $tType,H5: heap_ext @ product_unit,H2: heap_ext @ product_unit,R4: A,F2: ( heap_ext @ product_unit ) > A] :
      ( ( H5 = H2 )
     => ( ( R4
          = ( F2 @ H2 ) )
       => ( heap_Time_effect @ A @ ( heap_Time_tap @ A @ F2 ) @ H2 @ H5 @ R4 @ ( one_one @ nat ) ) ) ) ).

% effect_tapI
thf(fact_4647_effect__tapE,axiom,
    ! [A: $tType,F2: ( heap_ext @ product_unit ) > A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: A,N: nat] :
      ( ( heap_Time_effect @ A @ ( heap_Time_tap @ A @ F2 ) @ H2 @ H5 @ R4 @ N )
     => ~ ( ( H5 = H2 )
         => ( ( R4
              = ( F2 @ H2 ) )
           => ( N
             != ( one_one @ nat ) ) ) ) ) ).

% effect_tapE
thf(fact_4648_effect__freezeI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [H5: heap_ext @ product_unit,H2: heap_ext @ product_unit,R4: list @ A,A3: array @ A,N: nat] :
          ( ( H5 = H2 )
         => ( ( R4
              = ( array_get @ A @ H2 @ A3 ) )
           => ( ( N
                = ( array_length @ A @ H2 @ A3 ) )
             => ( heap_Time_effect @ ( list @ A ) @ ( array_freeze @ A @ A3 ) @ H2 @ H5 @ R4 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% effect_freezeI
thf(fact_4649_effect__freezeE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: list @ A,N: nat] :
          ( ( heap_Time_effect @ ( list @ A ) @ ( array_freeze @ A @ A3 ) @ H2 @ H5 @ R4 @ N )
         => ~ ( ( H5 = H2 )
             => ( ( R4
                  = ( array_get @ A @ H2 @ A3 ) )
               => ( N
                 != ( plus_plus @ nat @ ( array_length @ A @ H2 @ A3 ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% effect_freezeE
thf(fact_4650_execute__freeze,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( list @ A ) @ ( array_freeze @ A @ A3 ) @ H2 )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( array_get @ A @ H2 @ A3 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H2 @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( array_length @ A @ H2 @ A3 ) ) ) ) ) ) ) ).

% execute_freeze
thf(fact_4651_freeze__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_freeze @ A )
        = ( ^ [A4: array @ A] :
              ( heap_Time_heap @ ( list @ A )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ ( list @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( array_get @ A @ H @ A4 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( plus_plus @ nat @ ( one_one @ nat ) @ ( array_length @ A @ H @ A4 ) ) ) ) ) ) ) ) ).

% freeze_def
thf(fact_4652_effect__nthE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [A3: array @ A,I2: nat,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: A,N: nat] :
          ( ( heap_Time_effect @ A @ ( array_nth @ A @ A3 @ I2 ) @ H2 @ H5 @ R4 @ N )
         => ~ ( ( ord_less @ nat @ I2 @ ( array_length @ A @ H2 @ A3 ) )
             => ( ( R4
                  = ( nth @ A @ ( array_get @ A @ H2 @ A3 ) @ I2 ) )
               => ( ( H5 = H2 )
                 => ( N
                   != ( one_one @ nat ) ) ) ) ) ) ) ).

% effect_nthE
thf(fact_4653_effect__nthI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I2: nat,H2: heap_ext @ product_unit,A3: array @ A,H5: heap_ext @ product_unit,R4: A,N: nat] :
          ( ( ord_less @ nat @ I2 @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( H5 = H2 )
           => ( ( R4
                = ( nth @ A @ ( array_get @ A @ H2 @ A3 ) @ I2 ) )
             => ( ( N
                  = ( one_one @ nat ) )
               => ( heap_Time_effect @ A @ ( array_nth @ A @ A3 @ I2 ) @ H2 @ H5 @ R4 @ N ) ) ) ) ) ) ).

% effect_nthI
thf(fact_4654_Array__Time_Onth__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_nth @ A )
        = ( ^ [A4: array @ A,I4: nat] :
              ( heap_Time_guard @ A
              @ ^ [H: heap_ext @ product_unit] : ( ord_less @ nat @ I4 @ ( array_length @ A @ H @ A4 ) )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( nth @ A @ ( array_get @ A @ H @ A4 ) @ I4 ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ) ) ).

% Array_Time.nth_def
thf(fact_4655_execute__upd_I1_J,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I2: nat,H2: heap_ext @ product_unit,A3: array @ A,X: A] :
          ( ( ord_less @ nat @ I2 @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( heap_Time_execute @ ( array @ A ) @ ( array_upd @ A @ I2 @ X @ A3 ) @ H2 )
            = ( some @ ( product_prod @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A3 @ I2 @ X @ H2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% execute_upd(1)
thf(fact_4656_extract__Some__iff,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P2 @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs ) ) )
        & ( P2 @ Y )
        & ~ ? [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Ys ) )
              & ( P2 @ X2 ) ) ) ) ).

% extract_Some_iff
thf(fact_4657_upd__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_upd @ A )
        = ( ^ [I4: nat,X2: A,A4: array @ A] :
              ( heap_Time_guard @ ( array @ A )
              @ ^ [H: heap_ext @ product_unit] : ( ord_less @ nat @ I4 @ ( array_length @ A @ H @ A4 ) )
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ ( array @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ A4 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( array_update @ A @ A4 @ I4 @ X2 @ H ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% upd_def
thf(fact_4658_effect__updE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I2: nat,V2: A,A3: array @ A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: array @ A,N: nat] :
          ( ( heap_Time_effect @ ( array @ A ) @ ( array_upd @ A @ I2 @ V2 @ A3 ) @ H2 @ H5 @ R4 @ N )
         => ~ ( ( R4 = A3 )
             => ( ( H5
                  = ( array_update @ A @ A3 @ I2 @ V2 @ H2 ) )
               => ( ( ord_less @ nat @ I2 @ ( array_length @ A @ H2 @ A3 ) )
                 => ( N
                   != ( one_one @ nat ) ) ) ) ) ) ) ).

% effect_updE
thf(fact_4659_effect__updI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [I2: nat,H2: heap_ext @ product_unit,A3: array @ A,H5: heap_ext @ product_unit,V2: A,N: nat] :
          ( ( ord_less @ nat @ I2 @ ( array_length @ A @ H2 @ A3 ) )
         => ( ( H5
              = ( array_update @ A @ A3 @ I2 @ V2 @ H2 ) )
           => ( ( N
                = ( one_one @ nat ) )
             => ( heap_Time_effect @ ( array @ A ) @ ( array_upd @ A @ I2 @ V2 @ A3 ) @ H2 @ H5 @ A3 @ N ) ) ) ) ) ).

% effect_updI
thf(fact_4660_extract__SomeE,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P2 @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs ) ) )
        & ( P2 @ Y )
        & ~ ? [X4: A] :
              ( ( member2 @ A @ X4 @ ( set2 @ A @ Ys ) )
              & ( P2 @ X4 ) ) ) ) ).

% extract_SomeE
thf(fact_4661_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y2: A,Ys4: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs4 ) @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Ys4 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs4 ) ) ) ) ).

% extract_def
thf(fact_4662_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P2: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ? [X4: A] :
                ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
                & ( P2 @ X4 ) )
           => ( ( find @ A @ P2 @ Xs )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X2: A] :
                        ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
                        & ( P2 @ X2 ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_4663_tap__def,axiom,
    ! [A: $tType] :
      ( ( heap_Time_tap @ A )
      = ( ^ [F3: ( heap_ext @ product_unit ) > A] :
            ( heap_Time_Heap2 @ A
            @ ^ [H: heap_ext @ product_unit] : ( some @ ( product_prod @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ A @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ ( F3 @ H ) @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H @ ( one_one @ nat ) ) ) ) ) ) ) ).

% tap_def
thf(fact_4664_inf__None__1,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [Y: option @ A] :
          ( ( inf_inf @ ( option @ A ) @ ( none @ A ) @ Y )
          = ( none @ A ) ) ) ).

% inf_None_1
thf(fact_4665_inf__None__2,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ! [X: option @ A] :
          ( ( inf_inf @ ( option @ A ) @ X @ ( none @ A ) )
          = ( none @ A ) ) ) ).

% inf_None_2
thf(fact_4666_find__None__iff,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( find @ A @ P2 @ Xs )
        = ( none @ A ) )
      = ( ~ ? [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
              & ( P2 @ X2 ) ) ) ) ).

% find_None_iff
thf(fact_4667_find__None__iff2,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P2 @ Xs ) )
      = ( ~ ? [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
              & ( P2 @ X2 ) ) ) ) ).

% find_None_iff2
thf(fact_4668_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: A > $o] :
      ( ( find @ A @ Uu @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_4669_find__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P2: A > $o,Q2: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( P2 @ X3 )
              = ( Q2 @ X3 ) ) )
       => ( ( find @ A @ P2 @ Xs )
          = ( find @ A @ Q2 @ Ys ) ) ) ) ).

% find_cong
thf(fact_4670_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P: A > $o,Xs4: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X2: A,Xa4: list @ A] : ( some @ A @ X2 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs4 ) ) ) ) ).

% find_dropWhile
thf(fact_4671_extract__Nil__code,axiom,
    ! [A: $tType,P2: A > $o] :
      ( ( extract @ A @ P2 @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_4672_extract__None__iff,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A] :
      ( ( ( extract @ A @ P2 @ Xs )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X2: A] :
              ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
              & ( P2 @ X2 ) ) ) ) ).

% extract_None_iff
thf(fact_4673_find_Osimps_I2_J,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( ( P2 @ X )
       => ( ( find @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( some @ A @ X ) ) )
      & ( ~ ( P2 @ X )
       => ( ( find @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( find @ A @ P2 @ Xs ) ) ) ) ).

% find.simps(2)
thf(fact_4674_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P2: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter @ B @ P2 @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X2: B] : ( if @ ( option @ A ) @ ( P2 @ X2 ) @ ( some @ A @ ( F2 @ X2 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_4675_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P2: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X )
        = ( find @ A @ P2 @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P2 @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J2: nat] :
                ( ( ord_less @ nat @ J2 @ I4 )
               => ~ ( P2 @ ( nth @ A @ Xs @ J2 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_4676_find__Some__iff,axiom,
    ! [A: $tType,P2: A > $o,Xs: list @ A,X: A] :
      ( ( ( find @ A @ P2 @ Xs )
        = ( some @ A @ X ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P2 @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J2: nat] :
                ( ( ord_less @ nat @ J2 @ I4 )
               => ~ ( P2 @ ( nth @ A @ Xs @ J2 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_4677_extract__Cons__code,axiom,
    ! [A: $tType,P2: A > $o,X: A,Xs: list @ A] :
      ( ( ( P2 @ X )
       => ( ( extract @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X @ Xs ) ) ) ) )
      & ( ~ ( P2 @ X )
       => ( ( extract @ A @ P2 @ ( cons @ A @ X @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys4: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y2: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X @ Ys4 ) @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P2 @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_4678_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A10: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y2: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( inf_inf @ A @ X2 ) @ Y2 ) )
                @ ( none @ A )
                @ A10 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_4679_inf__option__def,axiom,
    ! [A: $tType] :
      ( ( inf @ A )
     => ( ( inf_inf @ ( option @ A ) )
        = ( ^ [X2: option @ A,Y2: option @ A] :
              ( case_option @ ( option @ A ) @ A @ ( none @ A )
              @ ^ [Z3: A] :
                  ( case_option @ ( option @ A ) @ A @ ( none @ A )
                  @ ^ [Aa3: A] : ( some @ A @ ( inf_inf @ A @ Z3 @ Aa3 ) )
                  @ Y2 )
              @ X2 ) ) ) ) ).

% inf_option_def
thf(fact_4680_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F3: A > ( option @ B ),Xs4: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F3 )
            @ ( filter @ A
              @ ^ [X2: A] :
                  ( ( F3 @ X2 )
                 != ( none @ B ) )
              @ Xs4 ) ) ) ) ).

% map_filter_def
thf(fact_4681_subset__eq__mset__impl_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: option @ $o] :
      ( ( ( subset_eq_mset_impl @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( some @ $o
              @ ( Xa
               != ( nil @ A ) ) ) ) )
       => ~ ! [X3: A,Xs2: list @ A] :
              ( ( X
                = ( cons @ A @ X3 @ Xs2 ) )
             => ( Y
               != ( case_option @ ( option @ $o ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ $o )
                  @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ $o )
                    @ ^ [Ys1: list @ A] :
                        ( product_case_prod @ A @ ( list @ A ) @ ( option @ $o )
                        @ ^ [Y2: A,Ys22: list @ A] : ( subset_eq_mset_impl @ A @ Xs2 @ ( append @ A @ Ys1 @ Ys22 ) ) ) )
                  @ ( extract @ A
                    @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
                      @ X3 )
                    @ Xa ) ) ) ) ) ) ).

% subset_eq_mset_impl.elims
thf(fact_4682_subset__eq__mset__impl_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa: list @ A,Y: option @ $o] :
      ( ( ( subset_eq_mset_impl @ A @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( some @ $o
                  @ ( Xa
                   != ( nil @ A ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ( ( Y
                    = ( case_option @ ( option @ $o ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ $o )
                      @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ $o )
                        @ ^ [Ys1: list @ A] :
                            ( product_case_prod @ A @ ( list @ A ) @ ( option @ $o )
                            @ ^ [Y2: A,Ys22: list @ A] : ( subset_eq_mset_impl @ A @ Xs2 @ ( append @ A @ Ys1 @ Ys22 ) ) ) )
                      @ ( extract @ A
                        @ ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 )
                          @ X3 )
                        @ Xa ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( subset751672762298770561pl_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xa ) ) ) ) ) ) ) ).

% subset_eq_mset_impl.pelims
thf(fact_4683_Array__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( array_alloc @ A )
        = ( ^ [Xs4: list @ A,H: heap_ext @ product_unit] :
              ( product_Pair @ ( array @ A ) @ ( heap_ext @ product_unit ) @ ( array2 @ A @ ( lim @ product_unit @ H ) )
              @ ( array_set @ A @ ( array2 @ A @ ( lim @ product_unit @ H ) ) @ Xs4
                @ ( lim_update @ product_unit
                  @ ^ [Uu2: nat] : ( plus_plus @ nat @ ( lim @ product_unit @ H ) @ ( one_one @ nat ) )
                  @ H ) ) ) ) ) ) ).

% Array_Time.alloc_def
thf(fact_4684_subset__eq__mset__impl_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( subset_eq_mset_impl @ A @ ( nil @ A ) @ Ys )
      = ( some @ $o
        @ ( Ys
         != ( nil @ A ) ) ) ) ).

% subset_eq_mset_impl.simps(1)
thf(fact_4685_effect__refE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [V2: A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: ref @ A,N: nat] :
          ( ( heap_Time_effect @ ( ref @ A ) @ ( ref_ref @ A @ V2 ) @ H2 @ H5 @ R4 @ N )
         => ~ ( ( ( ref_get @ A @ H5 @ R4 )
                = V2 )
             => ( ( ref_present @ A @ H5 @ R4 )
               => ( ~ ( ref_present @ A @ H2 @ R4 )
                 => ( N
                   != ( one_one @ nat ) ) ) ) ) ) ) ).

% effect_refE
thf(fact_4686_execute__ref,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [V2: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ ( ref @ A ) @ ( ref_ref @ A @ V2 ) @ H2 )
          = ( some @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
            @ ( product_case_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
              @ ^ [R3: ref @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( one_one @ nat ) ) )
              @ ( ref_alloc @ A @ V2 @ H2 ) ) ) ) ) ).

% execute_ref
thf(fact_4687_ref__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_ref @ A )
        = ( ^ [V3: A] :
              ( heap_Time_heap @ ( ref @ A )
              @ ^ [H: heap_ext @ product_unit] :
                  ( product_case_prod @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( product_prod @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) )
                  @ ^ [R3: ref @ A,H7: heap_ext @ product_unit] : ( product_Pair @ ( ref @ A ) @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ R3 @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ H7 @ ( one_one @ nat ) ) )
                  @ ( ref_alloc @ A @ V3 @ H ) ) ) ) ) ) ).

% ref_def
thf(fact_4688_effect__refI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,H5: heap_ext @ product_unit,V2: A,H2: heap_ext @ product_unit,N: nat] :
          ( ( ( product_Pair @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ R4 @ H5 )
            = ( ref_alloc @ A @ V2 @ H2 ) )
         => ( ( N
              = ( one_one @ nat ) )
           => ( heap_Time_effect @ ( ref @ A ) @ ( ref_ref @ A @ V2 ) @ H2 @ H5 @ R4 @ N ) ) ) ) ).

% effect_refI
thf(fact_4689_Ref__Time_Oalloc__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_alloc @ A )
        = ( ^ [X2: A,H: heap_ext @ product_unit] :
              ( product_Pair @ ( ref @ A ) @ ( heap_ext @ product_unit ) @ ( ref2 @ A @ ( lim @ product_unit @ H ) )
              @ ( ref_set @ A @ ( ref2 @ A @ ( lim @ product_unit @ H ) ) @ X2
                @ ( lim_update @ product_unit
                  @ ^ [Uu2: nat] : ( plus_plus @ nat @ ( lim @ product_unit @ H ) @ ( one_one @ nat ) )
                  @ H ) ) ) ) ) ) ).

% Ref_Time.alloc_def
thf(fact_4690_effect__updateE,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R7: ref @ A,V2: A,H2: heap_ext @ product_unit,H5: heap_ext @ product_unit,R4: product_unit,N: nat] :
          ( ( heap_Time_effect @ product_unit @ ( ref_update @ A @ R7 @ V2 ) @ H2 @ H5 @ R4 @ N )
         => ~ ( ( H5
                = ( ref_set @ A @ R7 @ V2 @ H2 ) )
             => ( N
               != ( one_one @ nat ) ) ) ) ) ).

% effect_updateE
thf(fact_4691_effect__updateI,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [H5: heap_ext @ product_unit,R4: ref @ A,V2: A,H2: heap_ext @ product_unit,N: nat,X: product_unit] :
          ( ( H5
            = ( ref_set @ A @ R4 @ V2 @ H2 ) )
         => ( ( N
              = ( one_one @ nat ) )
           => ( heap_Time_effect @ product_unit @ ( ref_update @ A @ R4 @ V2 ) @ H2 @ H5 @ X @ N ) ) ) ) ).

% effect_updateI
thf(fact_4692_update__wp__rule,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,Y: A,X: A,Q2: product_unit > assn] : ( hoare_hoare_triple @ product_unit @ ( times_times @ assn @ ( sngr_assn @ A @ R4 @ Y ) @ ( wand_assn @ ( sngr_assn @ A @ R4 @ X ) @ ( Q2 @ product_Unity ) ) ) @ ( ref_update @ A @ R4 @ X ) @ Q2 ) ) ).

% update_wp_rule
thf(fact_4693_Ref__Time_Oupdate__def,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ( ( ref_update @ A )
        = ( ^ [R3: ref @ A,V3: A] :
              ( heap_Time_heap @ product_unit
              @ ^ [H: heap_ext @ product_unit] : ( product_Pair @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ product_Unity @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( ref_set @ A @ R3 @ V3 @ H ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% Ref_Time.update_def
thf(fact_4694_execute__update,axiom,
    ! [A: $tType] :
      ( ( heap @ A )
     => ! [R4: ref @ A,V2: A,H2: heap_ext @ product_unit] :
          ( ( heap_Time_execute @ product_unit @ ( ref_update @ A @ R4 @ V2 ) @ H2 )
          = ( some @ ( product_prod @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) ) @ ( product_Pair @ product_unit @ ( product_prod @ ( heap_ext @ product_unit ) @ nat ) @ product_Unity @ ( product_Pair @ ( heap_ext @ product_unit ) @ nat @ ( ref_set @ A @ R4 @ V2 @ H2 ) @ ( one_one @ nat ) ) ) ) ) ) ).

% execute_update
thf(fact_4695_inf__unit__def,axiom,
    ( ( inf_inf @ product_unit )
    = ( ^ [Uu3: product_unit,Uv2: product_unit] : product_Unity ) ) ).

% inf_unit_def
thf(fact_4696_map__of__zip__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,I2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( distinct @ A @ Xs )
       => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
         => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) @ ( nth @ A @ Xs @ I2 ) )
            = ( some @ B @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ) ).

% map_of_zip_nth
thf(fact_4697_assert_H__rule,axiom,
    ! [P2: assn,Phi: $o] :
      ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P2 @ H3 )
         => Phi )
     => ( hoare_hoare_triple @ product_unit @ P2 @ ( refine_Imp_assert @ Phi )
        @ ^ [Uu2: product_unit] : P2 ) ) ).

% assert'_rule
thf(fact_4698_map__of__zip__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ ( map @ A @ B @ F2 @ Xs ) ) )
      = ( ^ [X2: A] : ( if @ ( option @ B ) @ ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) ) @ ( some @ B @ ( F2 @ X2 ) ) @ ( none @ B ) ) ) ) ).

% map_of_zip_map
thf(fact_4699_map__of__eq__empty__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list @ ( product_prod @ A @ B )] :
      ( ( ( map_of @ A @ B @ Xys )
        = ( ^ [X2: A] : ( none @ B ) ) )
      = ( Xys
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% map_of_eq_empty_iff
thf(fact_4700_empty__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys: list @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X2: A] : ( none @ B ) )
        = ( map_of @ A @ B @ Xys ) )
      = ( Xys
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% empty_eq_map_of_iff
thf(fact_4701_map__of__zip__is__None,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) @ X )
          = ( none @ B ) )
        = ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ) ) ).

% map_of_zip_is_None
thf(fact_4702_natural__zero__minus__one,axiom,
    ( ( minus_minus @ code_natural @ ( zero_zero @ code_natural ) @ ( one_one @ code_natural ) )
    = ( zero_zero @ code_natural ) ) ).

% natural_zero_minus_one
thf(fact_4703_map__of__Cons__code_I1_J,axiom,
    ! [B: $tType,A: $tType,K: B] :
      ( ( map_of @ B @ A @ ( nil @ ( product_prod @ B @ A ) ) @ K )
      = ( none @ A ) ) ).

% map_of_Cons_code(1)
thf(fact_4704_map__of_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_of @ A @ B @ ( nil @ ( product_prod @ A @ B ) ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% map_of.simps(1)
thf(fact_4705_map__of__zip__inject,axiom,
    ! [B: $tType,A: $tType,Ys: list @ A,Xs: list @ B,Zs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Ys )
        = ( size_size @ ( list @ B ) @ Xs ) )
     => ( ( ( size_size @ ( list @ A ) @ Zs )
          = ( size_size @ ( list @ B ) @ Xs ) )
       => ( ( distinct @ B @ Xs )
         => ( ( ( map_of @ B @ A @ ( zip @ B @ A @ Xs @ Ys ) )
              = ( map_of @ B @ A @ ( zip @ B @ A @ Xs @ Zs ) ) )
           => ( Ys = Zs ) ) ) ) ) ).

% map_of_zip_inject
thf(fact_4706_map__of__zip__is__Some,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
        = ( ? [Y2: B] :
              ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) @ X )
              = ( some @ B @ Y2 ) ) ) ) ) ).

% map_of_zip_is_Some
thf(fact_4707_log_Oelims,axiom,
    ! [X: code_natural,Xa: code_natural,Y: code_natural] :
      ( ( ( log @ X @ Xa )
        = Y )
     => ( ( ( ( ord_less_eq @ code_natural @ X @ ( one_one @ code_natural ) )
            | ( ord_less @ code_natural @ Xa @ X ) )
         => ( Y
            = ( one_one @ code_natural ) ) )
        & ( ~ ( ( ord_less_eq @ code_natural @ X @ ( one_one @ code_natural ) )
              | ( ord_less @ code_natural @ Xa @ X ) )
         => ( Y
            = ( plus_plus @ code_natural @ ( one_one @ code_natural ) @ ( log @ X @ ( divide_divide @ code_natural @ Xa @ X ) ) ) ) ) ) ) ).

% log.elims
thf(fact_4708_log_Osimps,axiom,
    ( log
    = ( ^ [B3: code_natural,I4: code_natural] :
          ( if @ code_natural
          @ ( ( ord_less_eq @ code_natural @ B3 @ ( one_one @ code_natural ) )
            | ( ord_less @ code_natural @ I4 @ B3 ) )
          @ ( one_one @ code_natural )
          @ ( plus_plus @ code_natural @ ( one_one @ code_natural ) @ ( log @ B3 @ ( divide_divide @ code_natural @ I4 @ B3 ) ) ) ) ) ) ).

% log.simps
thf(fact_4709_next_Osimps,axiom,
    ! [V2: code_natural,W: code_natural] :
      ( ( next @ ( product_Pair @ code_natural @ code_natural @ V2 @ W ) )
      = ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( one_one @ code_natural ) ) ) @ ( one_one @ code_natural ) ) @ ( product_Pair @ code_natural @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V2 @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% next.simps
thf(fact_4710_Random_Orange__def,axiom,
    ( range
    = ( ^ [K4: code_natural] :
          ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) )
          @ ( iterate @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( log @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ K4 )
            @ ^ [L3: code_natural] :
                ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) @ next
                @ ^ [V3: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ V3 @ ( times_times @ code_natural @ L3 @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
            @ ( one_one @ code_natural ) )
          @ ^ [V3: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( modulo_modulo @ code_natural @ V3 @ K4 ) ) ) ) ) ).

% Random.range_def
thf(fact_4711_inc__shift__def,axiom,
    ( inc_shift
    = ( ^ [V3: code_natural,K4: code_natural] : ( if @ code_natural @ ( V3 = K4 ) @ ( one_one @ code_natural ) @ ( plus_plus @ code_natural @ K4 @ ( one_one @ code_natural ) ) ) ) ) ).

% inc_shift_def
thf(fact_4712_log_Opelims,axiom,
    ! [X: code_natural,Xa: code_natural,Y: code_natural] :
      ( ( ( log @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ code_natural @ code_natural ) @ log_rel @ ( product_Pair @ code_natural @ code_natural @ X @ Xa ) )
       => ~ ( ( ( ( ( ord_less_eq @ code_natural @ X @ ( one_one @ code_natural ) )
                  | ( ord_less @ code_natural @ Xa @ X ) )
               => ( Y
                  = ( one_one @ code_natural ) ) )
              & ( ~ ( ( ord_less_eq @ code_natural @ X @ ( one_one @ code_natural ) )
                    | ( ord_less @ code_natural @ Xa @ X ) )
               => ( Y
                  = ( plus_plus @ code_natural @ ( one_one @ code_natural ) @ ( log @ X @ ( divide_divide @ code_natural @ Xa @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ code_natural @ code_natural ) @ log_rel @ ( product_Pair @ code_natural @ code_natural @ X @ Xa ) ) ) ) ) ).

% log.pelims
thf(fact_4713_iterate_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( iterate @ B @ A )
      = ( ^ [K4: code_natural,F3: B > A > ( product_prod @ B @ A ),X2: B] :
            ( if @ ( A > ( product_prod @ B @ A ) )
            @ ( K4
              = ( zero_zero @ code_natural ) )
            @ ( product_Pair @ B @ A @ X2 )
            @ ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( F3 @ X2 ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ K4 @ ( one_one @ code_natural ) ) @ F3 ) ) ) ) ) ).

% iterate.simps
thf(fact_4714_iterate_Oelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: B > A > ( product_prod @ B @ A ),Xb: B,Y: A > ( product_prod @ B @ A )] :
      ( ( ( iterate @ B @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( ( X
            = ( zero_zero @ code_natural ) )
         => ( Y
            = ( product_Pair @ B @ A @ Xb ) ) )
        & ( ( X
           != ( zero_zero @ code_natural ) )
         => ( Y
            = ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( Xa @ Xb ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ X @ ( one_one @ code_natural ) ) @ Xa ) ) ) ) ) ) ).

% iterate.elims
thf(fact_4715_select,axiom,
    ! [A: $tType,Xs: list @ A,S3: product_prod @ code_natural @ code_natural] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member2 @ A @ ( product_fst @ A @ ( product_prod @ code_natural @ code_natural ) @ ( select @ A @ Xs @ S3 ) ) @ ( set2 @ A @ Xs ) ) ) ).

% select
thf(fact_4716_iterate_Opelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: B > A > ( product_prod @ B @ A ),Xb: B,Y: A > ( product_prod @ B @ A )] :
      ( ( ( iterate @ B @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) @ ( iterate_rel @ B @ A ) @ ( product_Pair @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) @ X @ ( product_Pair @ ( B > A > ( product_prod @ B @ A ) ) @ B @ Xa @ Xb ) ) )
       => ~ ( ( ( ( X
                  = ( zero_zero @ code_natural ) )
               => ( Y
                  = ( product_Pair @ B @ A @ Xb ) ) )
              & ( ( X
                 != ( zero_zero @ code_natural ) )
               => ( Y
                  = ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( Xa @ Xb ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ X @ ( one_one @ code_natural ) ) @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) @ ( iterate_rel @ B @ A ) @ ( product_Pair @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) @ X @ ( product_Pair @ ( B > A > ( product_prod @ B @ A ) ) @ B @ Xa @ Xb ) ) ) ) ) ) ).

% iterate.pelims
thf(fact_4717_ran__map__of__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( distinct @ A @ Xs )
       => ( ( ran @ A @ B @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) ) )
          = ( set2 @ B @ Ys ) ) ) ) ).

% ran_map_of_zip
thf(fact_4718_select__weight__select,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( select_weight @ A @ ( map @ A @ ( product_prod @ code_natural @ A ) @ ( product_Pair @ code_natural @ A @ ( one_one @ code_natural ) ) @ Xs ) )
        = ( select @ A @ Xs ) ) ) ).

% select_weight_select
thf(fact_4719_map__of__zip__upd,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,Xs: list @ A,Zs: list @ B,X: A,Y: B,Z2: B] :
      ( ( ( size_size @ ( list @ B ) @ Ys )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( size_size @ ( list @ B ) @ Zs )
          = ( size_size @ ( list @ A ) @ Xs ) )
       => ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ( ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) ) @ X @ ( some @ B @ Y ) )
              = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Zs ) ) @ X @ ( some @ B @ Z2 ) ) )
           => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) )
              = ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Zs ) ) ) ) ) ) ) ).

% map_of_zip_upd
thf(fact_4720_assert_H__bind__rule,axiom,
    ! [A: $tType,P2: assn,Phi: $o,C2: heap_Time_Heap @ A,Q2: A > assn] :
      ( ! [H3: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
          ( ( rep_assn @ P2 @ H3 )
         => Phi )
     => ( ( Phi
         => ( hoare_hoare_triple @ A @ P2 @ C2 @ Q2 ) )
       => ( hoare_hoare_triple @ A @ P2
          @ ( heap_Time_bind @ product_unit @ A @ ( refine_Imp_assert @ Phi )
            @ ^ [Uu2: product_unit] : C2 )
          @ Q2 ) ) ) ).

% assert'_bind_rule
thf(fact_4721_map__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y: A,Xs: list @ A,F2: A > B,V2: B] :
      ( ~ ( member2 @ A @ Y @ ( set2 @ A @ Xs ) )
     => ( ( map @ A @ B @ ( fun_upd @ A @ B @ F2 @ Y @ V2 ) @ Xs )
        = ( map @ A @ B @ F2 @ Xs ) ) ) ).

% map_fun_upd
thf(fact_4722_return__bind,axiom,
    ! [B: $tType,A: $tType,X: B,F2: B > ( heap_Time_Heap @ A )] :
      ( ( heap_Time_bind @ B @ A @ ( heap_Time_return @ B @ X ) @ F2 )
      = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
        @ ^ [Uu2: product_unit] : ( F2 @ X ) ) ) ).

% return_bind
thf(fact_4723_bind__return,axiom,
    ! [A: $tType,F2: heap_Time_Heap @ A] :
      ( ( heap_Time_bind @ A @ A @ F2 @ ( heap_Time_return @ A ) )
      = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
        @ ^ [Uu2: product_unit] : F2 ) ) ).

% bind_return
thf(fact_4724_lookup__chain,axiom,
    ! [B: $tType,A: $tType] :
      ( ( heap @ B )
     => ! [R4: ref @ B,F2: heap_Time_Heap @ A] :
          ( ( heap_Time_bind @ B @ A @ ( ref_lookup @ B @ R4 )
            @ ^ [Uu2: B] : F2 )
          = ( heap_Time_bind @ product_unit @ A @ ( heap_Time_wait @ ( one_one @ nat ) )
            @ ^ [Uu2: product_unit] : F2 ) ) ) ).

% lookup_chain
thf(fact_4725_bind__rule_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P2: assn,F2: heap_Time_Heap @ B,R: B > assn,G: B > ( heap_Time_Heap @ C ),Q2: C > assn] :
      ( ! [R5: A] :
          ( hoare_hoare_triple @ B @ P2 @ F2
          @ ^ [S4: B] : ( times_times @ assn @ P2 @ ( R @ S4 ) ) )
     => ( ! [X3: B] : ( hoare_hoare_triple @ C @ ( times_times @ assn @ ( R @ X3 ) @ P2 ) @ ( G @ X3 ) @ Q2 )
       => ( hoare_hoare_triple @ C @ P2 @ ( heap_Time_bind @ B @ C @ F2 @ G ) @ Q2 ) ) ) ).

% bind_rule'
thf(fact_4726_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,M2: A > ( option @ B ),X: A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M2 @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ Ys )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M2 @ Xs @ Ys ) @ X @ ( some @ B @ ( nth @ B @ Ys @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% map_upds_append1
thf(fact_4727_map__upds__fold__map__upd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_upds @ A @ B )
      = ( ^ [M3: A > ( option @ B ),Ks: list @ A,Vs2: list @ B] :
            ( foldl @ ( A > ( option @ B ) ) @ ( product_prod @ A @ B )
            @ ^ [N3: A > ( option @ B )] :
                ( product_case_prod @ A @ B @ ( A > ( option @ B ) )
                @ ^ [K4: A,V3: B] : ( fun_upd @ A @ ( option @ B ) @ N3 @ K4 @ ( some @ B @ V3 ) ) )
            @ M3
            @ ( zip @ A @ B @ Ks @ Vs2 ) ) ) ) ).

% map_upds_fold_map_upd
thf(fact_4728_pick__same,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( pick @ A @ ( map @ A @ ( product_prod @ code_natural @ A ) @ ( product_Pair @ code_natural @ A @ ( one_one @ code_natural ) ) @ Xs ) @ ( code_natural_of_nat @ L ) )
        = ( nth @ A @ Xs @ L ) ) ) ).

% pick_same
thf(fact_4729_map__upds__Nil2,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),As2: list @ A] :
      ( ( map_upds @ A @ B @ M2 @ As2 @ ( nil @ B ) )
      = M2 ) ).

% map_upds_Nil2
thf(fact_4730_map__upds__Nil1,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),Bs: list @ B] :
      ( ( map_upds @ A @ B @ M2 @ ( nil @ A ) @ Bs )
      = M2 ) ).

% map_upds_Nil1
thf(fact_4731_one__natural__def,axiom,
    ( ( one_one @ code_natural )
    = ( code_natural_of_nat @ ( one_one @ nat ) ) ) ).

% one_natural_def
thf(fact_4732_map__upds__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_upds @ A @ B )
      = ( ^ [M3: A > ( option @ B ),Xs4: list @ A,Ys4: list @ B] : ( map_add @ A @ B @ M3 @ ( map_of @ A @ B @ ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs4 @ Ys4 ) ) ) ) ) ) ).

% map_upds_def
thf(fact_4733_dom__map__of__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( dom @ A @ B @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys ) ) )
        = ( set2 @ A @ Xs ) ) ) ).

% dom_map_of_zip
thf(fact_4734_Suc__natural__minus__one,axiom,
    ! [N: code_natural] :
      ( ( minus_minus @ code_natural @ ( code_Suc @ N ) @ ( one_one @ code_natural ) )
      = N ) ).

% Suc_natural_minus_one
thf(fact_4735_ran__map__add,axiom,
    ! [B: $tType,A: $tType,M1: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M1 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( ran @ A @ B @ ( map_add @ A @ B @ M1 @ M22 ) )
        = ( sup_sup @ ( set @ B ) @ ( ran @ A @ B @ M1 ) @ ( ran @ A @ B @ M22 ) ) ) ) ).

% ran_map_add
thf(fact_4736_ran__add,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B ),G: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ F2 ) @ ( dom @ A @ B @ G ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( ran @ A @ B @ ( map_add @ A @ B @ F2 @ G ) )
        = ( sup_sup @ ( set @ B ) @ ( ran @ A @ B @ F2 ) @ ( ran @ A @ B @ G ) ) ) ) ).

% ran_add
thf(fact_4737_map__add__left__comm,axiom,
    ! [B: $tType,A: $tType,A5: A > ( option @ B ),B4: A > ( option @ B ),C5: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ A5 ) @ ( dom @ A @ B @ B4 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( map_add @ A @ B @ A5 @ ( map_add @ A @ B @ B4 @ C5 ) )
        = ( map_add @ A @ B @ B4 @ ( map_add @ A @ B @ A5 @ C5 ) ) ) ) ).

% map_add_left_comm
thf(fact_4738_map__add__comm,axiom,
    ! [B: $tType,A: $tType,M1: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M1 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( map_add @ A @ B @ M1 @ M22 )
        = ( map_add @ A @ B @ M22 @ M1 ) ) ) ).

% map_add_comm
thf(fact_4739_map__add__distinct__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( preorder @ B )
     => ! [M2: A > ( option @ B ),M7: A > ( option @ B ),N: A > ( option @ B ),N5: A > ( option @ B )] :
          ( ( ord_less_eq @ ( A > ( option @ B ) ) @ M2 @ M7 )
         => ( ( ord_less_eq @ ( A > ( option @ B ) ) @ N @ N5 )
           => ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M7 ) @ ( dom @ A @ B @ N5 ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ ( A > ( option @ B ) ) @ ( map_add @ A @ B @ M2 @ N ) @ ( map_add @ A @ B @ M7 @ N5 ) ) ) ) ) ) ).

% map_add_distinct_le
thf(fact_4740_dom__if,axiom,
    ! [B: $tType,A: $tType,P2: A > $o,F2: A > ( option @ B ),G: A > ( option @ B )] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( if @ ( option @ B ) @ ( P2 @ X2 ) @ ( F2 @ X2 ) @ ( G @ X2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ F2 ) @ ( collect @ A @ P2 ) )
        @ ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ G )
          @ ( collect @ A
            @ ^ [X2: A] :
                ~ ( P2 @ X2 ) ) ) ) ) ).

% dom_if
thf(fact_4741_dom__override__on,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B ),G: A > ( option @ B ),A5: set @ A] :
      ( ( dom @ A @ B @ ( override_on @ A @ ( option @ B ) @ F2 @ G @ A5 ) )
      = ( sup_sup @ ( set @ A )
        @ ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F2 )
          @ ( collect @ A
            @ ^ [A4: A] : ( member2 @ A @ A4 @ ( minus_minus @ ( set @ A ) @ A5 @ ( dom @ A @ B @ G ) ) ) ) )
        @ ( collect @ A
          @ ^ [A4: A] : ( member2 @ A @ A4 @ ( inf_inf @ ( set @ A ) @ A5 @ ( dom @ A @ B @ G ) ) ) ) ) ) ).

% dom_override_on
thf(fact_4742_graph__map__add,axiom,
    ! [B: $tType,A: $tType,M1: A > ( option @ B ),M22: A > ( option @ B )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M1 ) @ ( dom @ A @ B @ M22 ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( graph @ A @ B @ ( map_add @ A @ B @ M1 @ M22 ) )
        = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( graph @ A @ B @ M1 ) @ ( graph @ A @ B @ M22 ) ) ) ) ).

% graph_map_add
thf(fact_4743_Code__Numeral_Osub__code_I9_J,axiom,
    ! [M2: num,N: num] :
      ( ( code_sub @ ( bit0 @ M2 ) @ ( bit1 @ N ) )
      = ( minus_minus @ code_integer @ ( code_dup @ ( code_sub @ M2 @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% Code_Numeral.sub_code(9)
thf(fact_4744_Code__Numeral_Osub__code_I8_J,axiom,
    ! [M2: num,N: num] :
      ( ( code_sub @ ( bit1 @ M2 ) @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_dup @ ( code_sub @ M2 @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% Code_Numeral.sub_code(8)
thf(fact_4745_AboveS__disjoint,axiom,
    ! [A: $tType,A5: set @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( order_AboveS @ A @ R4 @ A5 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% AboveS_disjoint
thf(fact_4746_antisym__Restr,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( antisym @ A @ R4 )
     => ( antisym @ A
        @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu2: A] : A5 ) ) ) ) ).

% antisym_Restr
thf(fact_4747_restrict__map__eq_I1_J,axiom,
    ! [A: $tType,B: $tType,M2: B > ( option @ A ),A5: set @ B,K: B] :
      ( ( ( restrict_map @ B @ A @ M2 @ A5 @ K )
        = ( none @ A ) )
      = ( ~ ( member2 @ B @ K @ ( inf_inf @ ( set @ B ) @ ( dom @ B @ A @ M2 ) @ A5 ) ) ) ) ).

% restrict_map_eq(1)
thf(fact_4748_restrict__restrict,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),A5: set @ A,B4: set @ A] :
      ( ( restrict_map @ A @ B @ ( restrict_map @ A @ B @ M2 @ A5 ) @ B4 )
      = ( restrict_map @ A @ B @ M2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) ) ) ).

% restrict_restrict
thf(fact_4749_dom__restrict,axiom,
    ! [B: $tType,A: $tType,M2: A > ( option @ B ),A5: set @ A] :
      ( ( dom @ A @ B @ ( restrict_map @ A @ B @ M2 @ A5 ) )
      = ( inf_inf @ ( set @ A ) @ ( dom @ A @ B @ M2 ) @ A5 ) ) ).

% dom_restrict
thf(fact_4750_partition__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( ( list @ B ) > ( product_prod @ ( list @ B ) @ ( list @ B ) ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_prod @ ( list @ B ) @ ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( basic_rel_prod @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) )
      @ ( partition @ A )
      @ ( partition @ B ) ) ).

% partition_transfer
thf(fact_4751_Int_Osub__code_I9_J,axiom,
    ! [M2: num,N: num] :
      ( ( sub @ ( bit0 @ M2 ) @ ( bit1 @ N ) )
      = ( minus_minus @ int @ ( dup @ ( sub @ M2 @ N ) ) @ ( one_one @ int ) ) ) ).

% Int.sub_code(9)
thf(fact_4752_Int_Osub__code_I8_J,axiom,
    ! [M2: num,N: num] :
      ( ( sub @ ( bit1 @ M2 ) @ ( bit0 @ N ) )
      = ( plus_plus @ int @ ( dup @ ( sub @ M2 @ N ) ) @ ( one_one @ int ) ) ) ).

% Int.sub_code(8)
thf(fact_4753_zip__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A5: A > B > $o,B4: C > D > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ C ) > ( list @ ( product_prod @ A @ C ) ) ) @ ( ( list @ D ) > ( list @ ( product_prod @ B @ D ) ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ ( list @ ( product_prod @ A @ C ) ) @ ( list @ ( product_prod @ B @ D ) ) @ ( list_all2 @ C @ D @ B4 ) @ ( list_all2 @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( basic_rel_prod @ A @ B @ C @ D @ A5 @ B4 ) ) ) @ ( zip @ A @ C ) @ ( zip @ B @ D ) ) ).

% zip_transfer
thf(fact_4754_product__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A5: A > B > $o,B4: C > D > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ C ) > ( list @ ( product_prod @ A @ C ) ) ) @ ( ( list @ D ) > ( list @ ( product_prod @ B @ D ) ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ ( list @ ( product_prod @ A @ C ) ) @ ( list @ ( product_prod @ B @ D ) ) @ ( list_all2 @ C @ D @ B4 ) @ ( list_all2 @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( basic_rel_prod @ A @ B @ C @ D @ A5 @ B4 ) ) ) @ ( product @ A @ C ) @ ( product @ B @ D ) ) ).

% product_transfer
thf(fact_4755_comm__monoid__set_Ozero__middle,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,P7: nat,K: nat,G: nat > A,H2: nat > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P7 )
       => ( ( ord_less_eq @ nat @ K @ P7 )
         => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( if @ A @ ( J2 = K ) @ Z2 @ ( H2 @ ( minus_minus @ nat @ J2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
              @ ( set_ord_atMost @ nat @ P7 ) )
            = ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2
              @ ^ [J2: nat] : ( if @ A @ ( ord_less @ nat @ J2 @ K ) @ ( G @ J2 ) @ ( H2 @ J2 ) )
              @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P7 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% comm_monoid_set.zero_middle
thf(fact_4756_Fract__def,axiom,
    ( fract
    = ( map_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat ) @ ( id @ int ) @ ( map_fun @ int @ int @ ( product_prod @ int @ int ) @ rat @ ( id @ int ) @ abs_Rat )
      @ ^ [A4: int,B3: int] :
          ( if @ ( product_prod @ int @ int )
          @ ( B3
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ A4 @ B3 ) ) ) ) ).

% Fract_def
thf(fact_4757_find__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( option @ A ) ) @ ( ( list @ B ) > ( option @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( option @ A ) @ ( option @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( rel_option @ A @ B @ A5 ) )
      @ ( find @ A )
      @ ( find @ B ) ) ).

% find_transfer
thf(fact_4758_comm__monoid__set_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A5: set @ B,B4: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ( finite_finite @ B @ B4 )
         => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
            = ( F2 @ ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A5 ) ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_diff2
thf(fact_4759_comm__monoid__set_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A5: set @ B,B4: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ( finite_finite @ B @ B4 )
         => ( ! [X3: B] :
                ( ( member2 @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
               => ( ( G @ X3 )
                  = Z2 ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
              = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A5 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ B4 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_inter_neutral
thf(fact_4760_comm__monoid__set_Ounion__inter,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A5: set @ B,B4: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ( finite_finite @ B @ B4 )
         => ( ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) )
            = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A5 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ B4 ) ) ) ) ) ) ).

% comm_monoid_set.union_inter
thf(fact_4761_comm__monoid__set_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A5: set @ B,G: B > A,B4: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) )
          = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
            @ ^ [X2: B] : ( if @ A @ ( member2 @ B @ X2 @ B4 ) @ ( G @ X2 ) @ Z2 )
            @ A5 ) ) ) ) ).

% comm_monoid_set.inter_restrict
thf(fact_4762_comm__monoid__set_OIf__cases,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A5: set @ B,P2: B > $o,H2: B > A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
            @ ^ [X2: B] : ( if @ A @ ( P2 @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
            @ A5 )
          = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P2 ) ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A5 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P2 ) ) ) ) ) ) ) ) ).

% comm_monoid_set.If_cases
thf(fact_4763_comm__monoid__set_OInt__Diff,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A5: set @ B,G: B > A,B4: set @ B] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A5 )
          = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( inf_inf @ ( set @ B ) @ A5 @ B4 ) ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( minus_minus @ ( set @ B ) @ A5 @ B4 ) ) ) ) ) ) ).

% comm_monoid_set.Int_Diff
thf(fact_4764_comm__monoid__set_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,T: set @ B,S: set @ B,H2: B > A,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ T )
       => ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T @ S ) )
               => ( ( H2 @ I3 )
                  = Z2 ) )
           => ( ! [I3: B] :
                  ( ( member2 @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S @ T ) )
                 => ( ( G @ I3 )
                    = Z2 ) )
             => ( ! [X3: B] :
                    ( ( member2 @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S @ T ) )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ S )
                  = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ H2 @ T ) ) ) ) ) ) ) ) ).

% comm_monoid_set.mono_neutral_cong
thf(fact_4765_comm__monoid__set_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,A5: set @ B,B4: set @ B,G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ A5 )
       => ( ( finite_finite @ B @ B4 )
         => ( ( ( inf_inf @ ( set @ B ) @ A5 @ B4 )
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( sup_sup @ ( set @ B ) @ A5 @ B4 ) )
              = ( F2 @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ A5 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ B4 ) ) ) ) ) ) ) ).

% comm_monoid_set.union_disjoint
thf(fact_4766_comm__monoid__set_OUnion__disjoint,axiom,
    ! [A: $tType,B: $tType,F2: A > A > A,Z2: A,C5: set @ ( set @ B ),G: B > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ! [X3: set @ B] :
            ( ( member2 @ ( set @ B ) @ X3 @ C5 )
           => ( finite_finite @ B @ X3 ) )
       => ( ! [X3: set @ B] :
              ( ( member2 @ ( set @ B ) @ X3 @ C5 )
             => ! [Xa3: set @ B] :
                  ( ( member2 @ ( set @ B ) @ Xa3 @ C5 )
                 => ( ( X3 != Xa3 )
                   => ( ( inf_inf @ ( set @ B ) @ X3 @ Xa3 )
                      = ( bot_bot @ ( set @ B ) ) ) ) ) )
         => ( ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 @ G @ ( complete_Sup_Sup @ ( set @ B ) @ C5 ) )
            = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups_comm_monoid_F @ A @ ( set @ B ) @ F2 @ Z2 ) @ ( groups_comm_monoid_F @ A @ B @ F2 @ Z2 ) @ G @ C5 ) ) ) ) ) ).

% comm_monoid_set.Union_disjoint
thf(fact_4767_comm__monoid__set_Oub__add__nat,axiom,
    ! [A: $tType,F2: A > A > A,Z2: A,M2: nat,N: nat,G: nat > A,P7: nat] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( ord_less_eq @ nat @ M2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ N @ P7 ) ) )
          = ( F2 @ ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N ) ) @ ( groups_comm_monoid_F @ A @ nat @ F2 @ Z2 @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P7 ) ) ) ) ) ) ) ).

% comm_monoid_set.ub_add_nat
thf(fact_4768_prod_Ocomm__monoid__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( groups778175481326437816id_set @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod.comm_monoid_set_axioms
thf(fact_4769_comm__monoid__set_OUNION__disjoint,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > A > A,Z2: A,I: set @ B,A5: B > ( set @ C ),G: C > A] :
      ( ( groups778175481326437816id_set @ A @ F2 @ Z2 )
     => ( ( finite_finite @ B @ I )
       => ( ! [X3: B] :
              ( ( member2 @ B @ X3 @ I )
             => ( finite_finite @ C @ ( A5 @ X3 ) ) )
         => ( ! [X3: B] :
                ( ( member2 @ B @ X3 @ I )
               => ! [Xa3: B] :
                    ( ( member2 @ B @ Xa3 @ I )
                   => ( ( X3 != Xa3 )
                     => ( ( inf_inf @ ( set @ C ) @ ( A5 @ X3 ) @ ( A5 @ Xa3 ) )
                        = ( bot_bot @ ( set @ C ) ) ) ) ) )
           => ( ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ G @ ( complete_Sup_Sup @ ( set @ C ) @ ( image2 @ B @ ( set @ C ) @ A5 @ I ) ) )
              = ( groups_comm_monoid_F @ A @ B @ F2 @ Z2
                @ ^ [X2: B] : ( groups_comm_monoid_F @ A @ C @ F2 @ Z2 @ G @ ( A5 @ X2 ) )
                @ I ) ) ) ) ) ) ).

% comm_monoid_set.UNION_disjoint
thf(fact_4770_comm__monoid__mult__class_Oprod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( groups_comm_monoid_F @ A @ B @ ( times_times @ A ) @ ( one_one @ A ) ) ) ) ).

% comm_monoid_mult_class.prod_def
thf(fact_4771_rel__option__inf,axiom,
    ! [B: $tType,A: $tType,A5: A > B > $o,B4: A > B > $o] :
      ( ( inf_inf @ ( ( option @ A ) > ( option @ B ) > $o ) @ ( rel_option @ A @ B @ A5 ) @ ( rel_option @ A @ B @ B4 ) )
      = ( rel_option @ A @ B @ ( inf_inf @ ( A > B > $o ) @ A5 @ B4 ) ) ) ).

% rel_option_inf
thf(fact_4772_those__transfer,axiom,
    ! [A: $tType,B: $tType,P2: A > B > $o] : ( bNF_rel_fun @ ( list @ ( option @ A ) ) @ ( list @ ( option @ B ) ) @ ( option @ ( list @ A ) ) @ ( option @ ( list @ B ) ) @ ( list_all2 @ ( option @ A ) @ ( option @ B ) @ ( rel_option @ A @ B @ P2 ) ) @ ( rel_option @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ P2 ) ) @ ( those @ A ) @ ( those @ B ) ) ).

% those_transfer
thf(fact_4773_in__range_Opelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( in_range @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ! [X3: nat] :
                    ( ( member2 @ nat @ X3 @ As )
                   => ( ord_less @ nat @ X3 @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ).

% in_range.pelims(3)
thf(fact_4774_those_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( those @ A @ ( nil @ ( option @ A ) ) )
      = ( some @ ( list @ A ) @ ( nil @ A ) ) ) ).

% those.simps(1)
thf(fact_4775_in__range_Opelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( in_range @ X )
        = Y )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( Y
                  = ( ! [X2: nat] :
                        ( ( member2 @ nat @ X2 @ As )
                       => ( ord_less @ nat @ X2 @ ( lim @ product_unit @ H3 ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ) ).

% in_range.pelims(1)
thf(fact_4776_in__range_Opelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( in_range @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ X )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ in_range_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ~ ! [X4: nat] :
                      ( ( member2 @ nat @ X4 @ As )
                     => ( ord_less @ nat @ X4 @ ( lim @ product_unit @ H3 ) ) ) ) ) ) ) ).

% in_range.pelims(2)
thf(fact_4777_one__assn__raw_Opelims_I3_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ~ ( one_assn_raw @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ( As
                  = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.pelims(3)
thf(fact_4778_one__assn__raw_Opelims_I2_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat )] :
      ( ( one_assn_raw @ X )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
               => ( As
                 != ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% one_assn_raw.pelims(2)
thf(fact_4779_one__assn__raw_Opelims_I1_J,axiom,
    ! [X: product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ),Y: $o] :
      ( ( ( one_assn_raw @ X )
        = Y )
     => ( ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ X )
       => ~ ! [H3: heap_ext @ product_unit,As: set @ nat] :
              ( ( X
                = ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) )
             => ( ( Y
                  = ( As
                    = ( bot_bot @ ( set @ nat ) ) ) )
               => ~ ( accp @ ( product_prod @ ( heap_ext @ product_unit ) @ ( set @ nat ) ) @ one_assn_raw_rel @ ( product_Pair @ ( heap_ext @ product_unit ) @ ( set @ nat ) @ H3 @ As ) ) ) ) ) ) ).

% one_assn_raw.pelims(1)
thf(fact_4780_lenlex__def,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R3: set @ ( product_prod @ A @ A )] :
            ( inv_image @ ( product_prod @ nat @ ( list @ A ) ) @ ( list @ A ) @ ( lex_prod @ nat @ ( list @ A ) @ less_than @ ( lex @ A @ R3 ) )
            @ ^ [Xs4: list @ A] : ( product_Pair @ nat @ ( list @ A ) @ ( size_size @ ( list @ A ) @ Xs4 ) @ Xs4 ) ) ) ) ).

% lenlex_def
thf(fact_4781_Card__order__iff__Restr__underS,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( order_well_order_on @ A @ ( field2 @ A @ R4 ) @ R4 )
     => ( ( bNF_Ca8970107618336181345der_on @ A @ ( field2 @ A @ R4 ) @ R4 )
        = ( ! [X2: A] :
              ( ( member2 @ A @ X2 @ ( field2 @ A @ R4 ) )
             => ( member2 @ ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) )
                @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )
                  @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4
                    @ ( product_Sigma @ A @ A @ ( order_underS @ A @ R4 @ X2 )
                      @ ^ [Uu2: A] : ( order_underS @ A @ R4 @ X2 ) ) )
                  @ ( bNF_Ca6860139660246222851ard_of @ A @ ( field2 @ A @ R4 ) ) )
                @ ( bNF_We4044943003108391690rdLess @ A @ A ) ) ) ) ) ) ).

% Card_order_iff_Restr_underS
thf(fact_4782_enumerate__Suc__eq,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( enumerate @ A @ ( suc @ N ) @ Xs )
      = ( map @ ( product_prod @ nat @ A ) @ ( product_prod @ nat @ A ) @ ( product_apfst @ nat @ nat @ A @ suc ) @ ( enumerate @ A @ N @ Xs ) ) ) ).

% enumerate_Suc_eq
thf(fact_4783_measures__def,axiom,
    ! [A: $tType] :
      ( ( measures @ A )
      = ( ^ [Fs2: list @ ( A > nat )] :
            ( inv_image @ ( list @ nat ) @ A @ ( lex @ nat @ less_than )
            @ ^ [A4: A] :
                ( map @ ( A > nat ) @ nat
                @ ^ [F3: A > nat] : ( F3 @ A4 )
                @ Fs2 ) ) ) ) ).

% measures_def
thf(fact_4784_Restr__natLeq,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat
          @ ( collect @ nat
            @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) )
          @ ^ [Uu2: nat] :
              ( collect @ nat
              @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y2: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ) ).

% Restr_natLeq
thf(fact_4785_Restr__natLeq2,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat @ ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N )
          @ ^ [Uu2: nat] : ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y2: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y2 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ) ).

% Restr_natLeq2
thf(fact_4786_those_Osimps_I2_J,axiom,
    ! [A: $tType,X: option @ A,Xs: list @ ( option @ A )] :
      ( ( those @ A @ ( cons @ ( option @ A ) @ X @ Xs ) )
      = ( case_option @ ( option @ ( list @ A ) ) @ A @ ( none @ ( list @ A ) )
        @ ^ [Y2: A] : ( map_option @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( those @ A @ Xs ) )
        @ X ) ) ).

% those.simps(2)
thf(fact_4787_prod__mset_Ocomm__monoid__mset__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( comm_monoid_mset @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% prod_mset.comm_monoid_mset_axioms
thf(fact_4788_wf__set,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_acyclic @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% wf_set
thf(fact_4789_sym__Int__converse,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] : ( sym @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( converse @ A @ A @ R4 ) ) ) ).

% sym_Int_converse
thf(fact_4790_Predicate_Oiterate__upto_Opinduct,axiom,
    ! [A: $tType,A0: code_natural > A,A1: code_natural,A22: code_natural,P2: ( code_natural > A ) > code_natural > code_natural > $o] :
      ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ A0 @ ( product_Pair @ code_natural @ code_natural @ A1 @ A22 ) ) )
     => ( ! [F9: code_natural > A,N4: code_natural,M6: code_natural] :
            ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ F9 @ ( product_Pair @ code_natural @ code_natural @ N4 @ M6 ) ) )
           => ( ! [X4: product_unit] :
                  ( ~ ( ord_less @ code_natural @ M6 @ N4 )
                 => ( P2 @ F9 @ ( plus_plus @ code_natural @ N4 @ ( one_one @ code_natural ) ) @ M6 ) )
             => ( P2 @ F9 @ N4 @ M6 ) ) )
       => ( P2 @ A0 @ A1 @ A22 ) ) ) ).

% Predicate.iterate_upto.pinduct
thf(fact_4791_one__integer__code,axiom,
    ( ( one_one @ code_integer )
    = ( code_Pos @ one2 ) ) ).

% one_integer_code
thf(fact_4792_listrel__sym,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( sym @ A @ R4 )
     => ( sym @ ( list @ A ) @ ( listrel @ A @ A @ R4 ) ) ) ).

% listrel_sym
thf(fact_4793_sym__Int,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( sym @ A @ R4 )
     => ( ( sym @ A @ S3 )
       => ( sym @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S3 ) ) ) ) ).

% sym_Int
thf(fact_4794_Predicate_Oiterate__upto_Opelims,axiom,
    ! [A: $tType,X: code_natural > A,Xa: code_natural,Xb: code_natural,Y: pred @ A] :
      ( ( ( iterate_upto @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ X @ ( product_Pair @ code_natural @ code_natural @ Xa @ Xb ) ) )
       => ~ ( ( Y
              = ( seq2 @ A
                @ ^ [U2: product_unit] : ( if @ ( seq @ A ) @ ( ord_less @ code_natural @ Xb @ Xa ) @ ( empty @ A ) @ ( insert2 @ A @ ( X @ Xa ) @ ( iterate_upto @ A @ X @ ( plus_plus @ code_natural @ Xa @ ( one_one @ code_natural ) ) @ Xb ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ X @ ( product_Pair @ code_natural @ code_natural @ Xa @ Xb ) ) ) ) ) ) ).

% Predicate.iterate_upto.pelims
thf(fact_4795_Predicate_Oiterate__upto_Opsimps,axiom,
    ! [A: $tType,F2: code_natural > A,N: code_natural,M2: code_natural] :
      ( ( accp @ ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) ) @ ( iterate_upto_rel @ A ) @ ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ F2 @ ( product_Pair @ code_natural @ code_natural @ N @ M2 ) ) )
     => ( ( iterate_upto @ A @ F2 @ N @ M2 )
        = ( seq2 @ A
          @ ^ [U2: product_unit] : ( if @ ( seq @ A ) @ ( ord_less @ code_natural @ M2 @ N ) @ ( empty @ A ) @ ( insert2 @ A @ ( F2 @ N ) @ ( iterate_upto @ A @ F2 @ ( plus_plus @ code_natural @ N @ ( one_one @ code_natural ) ) @ M2 ) ) ) ) ) ) ).

% Predicate.iterate_upto.psimps
thf(fact_4796_Inf__fin__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( inf_inf @ A ) ) ) ) ).

% Inf_fin_def
thf(fact_4797_Predicate_Oiterate__upto_Oelims,axiom,
    ! [A: $tType,X: code_natural > A,Xa: code_natural,Xb: code_natural,Y: pred @ A] :
      ( ( ( iterate_upto @ A @ X @ Xa @ Xb )
        = Y )
     => ( Y
        = ( seq2 @ A
          @ ^ [U2: product_unit] : ( if @ ( seq @ A ) @ ( ord_less @ code_natural @ Xb @ Xa ) @ ( empty @ A ) @ ( insert2 @ A @ ( X @ Xa ) @ ( iterate_upto @ A @ X @ ( plus_plus @ code_natural @ Xa @ ( one_one @ code_natural ) ) @ Xb ) ) ) ) ) ) ).

% Predicate.iterate_upto.elims
thf(fact_4798_Predicate_Oiterate__upto_Osimps,axiom,
    ! [A: $tType] :
      ( ( iterate_upto @ A )
      = ( ^ [F3: code_natural > A,N3: code_natural,M3: code_natural] :
            ( seq2 @ A
            @ ^ [U2: product_unit] : ( if @ ( seq @ A ) @ ( ord_less @ code_natural @ M3 @ N3 ) @ ( empty @ A ) @ ( insert2 @ A @ ( F3 @ N3 ) @ ( iterate_upto @ A @ F3 @ ( plus_plus @ code_natural @ N3 @ ( one_one @ code_natural ) ) @ M3 ) ) ) ) ) ) ).

% Predicate.iterate_upto.simps
thf(fact_4799_semilattice__set_Oset__eq__fold,axiom,
    ! [A: $tType,F2: A > A > A,X: A,Xs: list @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
        = ( fold @ A @ A @ F2 @ Xs @ X ) ) ) ).

% semilattice_set.set_eq_fold
thf(fact_4800_one__natural_Orep__eq,axiom,
    ( ( code_nat_of_natural @ ( one_one @ code_natural ) )
    = ( one_one @ nat ) ) ).

% one_natural.rep_eq
thf(fact_4801_filter__rev__aux_Osimps_I1_J,axiom,
    ! [A: $tType,A3: list @ A,P2: A > $o] :
      ( ( filter_rev_aux @ A @ A3 @ P2 @ ( nil @ A ) )
      = A3 ) ).

% filter_rev_aux.simps(1)
thf(fact_4802_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic149705377957585745ce_set @ A @ ( inf_inf @ A ) ) ) ).

% Inf_fin.semilattice_set_axioms
thf(fact_4803_filter__rev__def,axiom,
    ! [A: $tType] :
      ( ( filter_rev @ A )
      = ( filter_rev_aux @ A @ ( nil @ A ) ) ) ).

% filter_rev_def
thf(fact_4804_set__mset__inter,axiom,
    ! [A: $tType,A5: multiset @ A,B4: multiset @ A] :
      ( ( set_mset @ A @ ( inter_mset @ A @ A5 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ ( set_mset @ A @ A5 ) @ ( set_mset @ A @ B4 ) ) ) ).

% set_mset_inter
thf(fact_4805_nat__of__num__code_I1_J,axiom,
    ( ( nat_of_num @ one2 )
    = ( one_one @ nat ) ) ).

% nat_of_num_code(1)
thf(fact_4806_prod__mset_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: multiset @ B,B4: multiset @ B,G: B > A] :
          ( ( ( inter_mset @ B @ A5 @ B4 )
            = ( zero_zero @ ( multiset @ B ) ) )
         => ( ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ ( union_mset @ B @ A5 @ B4 ) ) )
            = ( times_times @ A @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ A5 ) ) @ ( comm_m9189036328036947845d_mset @ A @ ( image_mset @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod_mset.union_disjoint
thf(fact_4807_one__int__code,axiom,
    ( ( one_one @ int )
    = ( pos @ one2 ) ) ).

% one_int_code
thf(fact_4808_disjnt__def,axiom,
    ! [A: $tType] :
      ( ( disjnt @ A )
      = ( ^ [A10: set @ A,B6: set @ A] :
            ( ( inf_inf @ ( set @ A ) @ A10 @ B6 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% disjnt_def
thf(fact_4809_disjnt__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,C5: A > ( set @ B ),B4: set @ A] :
      ( ( disjnt @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A5 @ C5 ) @ ( product_Sigma @ A @ B @ B4 @ C5 ) )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( inf_inf @ ( set @ A ) @ A5 @ B4 ) )
           => ( ( C5 @ X2 )
              = ( bot_bot @ ( set @ B ) ) ) )
        | ( disjnt @ A @ A5 @ B4 ) ) ) ).

% disjnt_Sigma_iff
thf(fact_4810_one__natural_Otransfer,axiom,
    code_pcr_natural @ ( one_one @ nat ) @ ( one_one @ code_natural ) ).

% one_natural.transfer
thf(fact_4811_list_Opred__rel,axiom,
    ! [A: $tType] :
      ( ( list_all @ A )
      = ( ^ [P: A > $o,X2: list @ A] : ( list_all2 @ A @ A @ ( bNF_eq_onp @ A @ P ) @ X2 @ X2 ) ) ) ).

% list.pred_rel
thf(fact_4812_list_Orel__Grp,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,F2: A > B] :
      ( ( list_all2 @ A @ B @ ( bNF_Grp @ A @ B @ A5 @ F2 ) )
      = ( bNF_Grp @ ( list @ A ) @ ( list @ B )
        @ ( collect @ ( list @ A )
          @ ^ [X2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ X2 ) @ A5 ) )
        @ ( map @ A @ B @ F2 ) ) ) ).

% list.rel_Grp
thf(fact_4813_list_Orel__eq__onp,axiom,
    ! [A: $tType,P2: A > $o] :
      ( ( list_all2 @ A @ A @ ( bNF_eq_onp @ A @ P2 ) )
      = ( bNF_eq_onp @ ( list @ A ) @ ( list_all @ A @ P2 ) ) ) ).

% list.rel_eq_onp
thf(fact_4814_list_Orel__compp__Grp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R2: A > B > $o] :
            ( relcompp @ ( list @ A ) @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ B )
            @ ( conversep @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ A )
              @ ( bNF_Grp @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ A )
                @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [X2: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
                @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) ) ) )
            @ ( bNF_Grp @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ B )
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X2: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) )
              @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) ) ) ) ) ) ).

% list.rel_compp_Grp
thf(fact_4815_one__integer_Otransfer,axiom,
    code_pcr_integer @ ( one_one @ int ) @ ( one_one @ code_integer ) ).

% one_integer.transfer
thf(fact_4816_comp__fun__commute__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite6289374366891150609ommute @ A @ ( list @ A )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% comp_fun_commute_insort
thf(fact_4817_list_Orel__conversep,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( list_all2 @ B @ A @ ( conversep @ A @ B @ R ) )
      = ( conversep @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R ) ) ) ).

% list.rel_conversep
thf(fact_4818_list_Orel__compp,axiom,
    ! [A: $tType,C: $tType,B: $tType,R: A > B > $o,S: B > C > $o] :
      ( ( list_all2 @ A @ C @ ( relcompp @ A @ B @ C @ R @ S ) )
      = ( relcompp @ ( list @ A ) @ ( list @ B ) @ ( list @ C ) @ ( list_all2 @ A @ B @ R ) @ ( list_all2 @ B @ C @ S ) ) ) ).

% list.rel_compp
thf(fact_4819_list_Orel__flip,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,A3: list @ B,B2: list @ A] :
      ( ( list_all2 @ B @ A @ ( conversep @ A @ B @ R ) @ A3 @ B2 )
      = ( list_all2 @ A @ B @ R @ B2 @ A3 ) ) ).

% list.rel_flip
thf(fact_4820_converse__meet,axiom,
    ! [A: $tType,B: $tType,R4: B > A > $o,S3: B > A > $o] :
      ( ( conversep @ B @ A @ ( inf_inf @ ( B > A > $o ) @ R4 @ S3 ) )
      = ( inf_inf @ ( A > B > $o ) @ ( conversep @ B @ A @ R4 ) @ ( conversep @ B @ A @ S3 ) ) ) ).

% converse_meet
thf(fact_4821_pcr__Domainp__par,axiom,
    ! [A: $tType,B: $tType,C: $tType,B4: A > B > $o,P22: A > $o,A5: C > A > $o,P1: C > $o,P23: C > $o] :
      ( ( ( domainp @ A @ B @ B4 )
        = P22 )
     => ( ( ( domainp @ C @ A @ A5 )
          = P1 )
       => ( ( bNF_rel_fun @ C @ A @ $o @ $o @ A5
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
            @ P23
            @ P22 )
         => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A5 @ B4 ) )
            = ( inf_inf @ ( C > $o ) @ P1 @ P23 ) ) ) ) ) ).

% pcr_Domainp_par
thf(fact_4822_composed__equiv__rel__eq__onp,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o,P2: A > $o,P3: B > $o,P8: A > $o] :
      ( ( left_unique @ A @ B @ R )
     => ( ( bNF_rel_fun @ A @ B @ $o @ $o @ R
          @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
          @ P2
          @ P3 )
       => ( ( ( domainp @ A @ B @ R )
            = P8 )
         => ( ( relcompp @ A @ B @ A @ R @ ( relcompp @ B @ B @ A @ ( bNF_eq_onp @ B @ P3 ) @ ( conversep @ A @ B @ R ) ) )
            = ( bNF_eq_onp @ A @ ( inf_inf @ ( A > $o ) @ P8 @ P2 ) ) ) ) ) ) ).

% composed_equiv_rel_eq_onp
thf(fact_4823_ListMem__iff,axiom,
    ! [A: $tType] :
      ( ( listMem @ A )
      = ( ^ [X2: A,Xs4: list @ A] : ( member2 @ A @ X2 @ ( set2 @ A @ Xs4 ) ) ) ) ).

% ListMem_iff
thf(fact_4824_list_Oleft__unique__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( left_unique @ A @ B @ R )
     => ( left_unique @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R ) ) ) ).

% list.left_unique_rel
thf(fact_4825_list_ODomainp__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( domainp @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R ) )
      = ( list_all @ A @ ( domainp @ A @ B @ R ) ) ) ).

% list.Domainp_rel
thf(fact_4826_elem,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( listMem @ A @ X @ ( cons @ A @ X @ Xs ) ) ).

% elem
thf(fact_4827_ListMem_Ocases,axiom,
    ! [A: $tType,A1: A,A22: list @ A] :
      ( ( listMem @ A @ A1 @ A22 )
     => ( ! [Xs2: list @ A] :
            ( A22
           != ( cons @ A @ A1 @ Xs2 ) )
       => ~ ! [Xs2: list @ A] :
              ( ? [Y3: A] :
                  ( A22
                  = ( cons @ A @ Y3 @ Xs2 ) )
             => ~ ( listMem @ A @ A1 @ Xs2 ) ) ) ) ).

% ListMem.cases
thf(fact_4828_ListMem_Osimps,axiom,
    ! [A: $tType] :
      ( ( listMem @ A )
      = ( ^ [A12: A,A23: list @ A] :
            ( ? [X2: A,Xs4: list @ A] :
                ( ( A12 = X2 )
                & ( A23
                  = ( cons @ A @ X2 @ Xs4 ) ) )
            | ? [X2: A,Xs4: list @ A,Y2: A] :
                ( ( A12 = X2 )
                & ( A23
                  = ( cons @ A @ Y2 @ Xs4 ) )
                & ( listMem @ A @ X2 @ Xs4 ) ) ) ) ) ).

% ListMem.simps
thf(fact_4829_insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ( listMem @ A @ X @ Xs )
     => ( listMem @ A @ X @ ( cons @ A @ Y @ Xs ) ) ) ).

% insert
thf(fact_4830_multiset_Odomain__par,axiom,
    ! [B: $tType,C: $tType,T: C > B > $o,DT: C > $o,DS: nat > $o,P23: ( C > nat ) > $o] :
      ( ( ( domainp @ C @ B @ T )
        = DT )
     => ( ( ( domainp @ nat @ nat
            @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 ) )
          = DS )
       => ( ( left_unique @ C @ B @ T )
         => ( ( bNF_rel_fun @ ( C > nat ) @ ( B > nat ) @ $o @ $o
              @ ( bNF_rel_fun @ C @ B @ nat @ nat @ T
                @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 ) )
              @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
              @ P23
              @ ^ [F3: B > nat] :
                  ( finite_finite @ B
                  @ ( collect @ B
                    @ ^ [X2: B] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X2 ) ) ) ) )
           => ( ( domainp @ ( C > nat ) @ ( multiset @ B ) @ ( pcr_multiset @ C @ B @ T ) )
              = ( inf_inf @ ( ( C > nat ) > $o ) @ ( basic_pred_fun @ C @ nat @ DT @ DS ) @ P23 ) ) ) ) ) ) ).

% multiset.domain_par
thf(fact_4831_rat_Odomain__par,axiom,
    ! [DR1: int > $o,DR2: int > $o,P23: ( product_prod @ int @ int ) > $o] :
      ( ( ( domainp @ int @ int
          @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 ) )
        = DR1 )
     => ( ( ( domainp @ int @ int
            @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 ) )
          = DR2 )
       => ( ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o
            @ ( basic_rel_prod @ int @ int @ int @ int
              @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 )
              @ ^ [Y4: int,Z5: int] : ( Y4 = Z5 ) )
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 )
            @ P23
            @ ^ [X2: product_prod @ int @ int] : ( ratrel @ X2 @ X2 ) )
         => ( ( domainp @ ( product_prod @ int @ int ) @ rat @ pcr_rat )
            = ( inf_inf @ ( ( product_prod @ int @ int ) > $o ) @ ( basic_pred_prod @ int @ int @ DR1 @ DR2 ) @ P23 ) ) ) ) ) ).

% rat.domain_par
thf(fact_4832_wfP__SUP,axiom,
    ! [B: $tType,A: $tType,R4: A > B > B > $o] :
      ( ! [I3: A] : ( wfP @ B @ ( R4 @ I3 ) )
     => ( ! [I3: A,J3: A] :
            ( ( ( R4 @ I3 )
             != ( R4 @ J3 ) )
           => ( ( inf_inf @ ( B > $o ) @ ( domainp @ B @ B @ ( R4 @ I3 ) ) @ ( rangep @ B @ B @ ( R4 @ J3 ) ) )
              = ( bot_bot @ ( B > $o ) ) ) )
       => ( wfP @ B @ ( complete_Sup_Sup @ ( B > B > $o ) @ ( image2 @ A @ ( B > B > $o ) @ R4 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% wfP_SUP
thf(fact_4833_monotone__parametric,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A5: A > B > $o,B4: C > D > $o] :
      ( ( bi_total @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( C > C > $o ) > ( A > C ) > $o ) @ ( ( D > D > $o ) > ( B > D ) > $o )
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A5
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
        @ ( bNF_rel_fun @ ( C > C > $o ) @ ( D > D > $o ) @ ( ( A > C ) > $o ) @ ( ( B > D ) > $o )
          @ ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B4
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B4
              @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A5 @ B4 )
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
        @ ( comple7038119648293358887notone @ A @ C )
        @ ( comple7038119648293358887notone @ B @ D ) ) ) ).

% monotone_parametric
thf(fact_4834_fun__ord__parametric,axiom,
    ! [C: $tType,D: $tType,A: $tType,B: $tType,F10: $tType,E5: $tType,C5: A > B > $o,A5: C > E5 > $o,B4: D > F10 > $o] :
      ( ( bi_total @ A @ B @ C5 )
     => ( bNF_rel_fun @ ( C > D > $o ) @ ( E5 > F10 > $o ) @ ( ( A > C ) > ( A > D ) > $o ) @ ( ( B > E5 ) > ( B > F10 ) > $o )
        @ ( bNF_rel_fun @ C @ E5 @ ( D > $o ) @ ( F10 > $o ) @ A5
          @ ( bNF_rel_fun @ D @ F10 @ $o @ $o @ B4
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
        @ ( bNF_rel_fun @ ( A > C ) @ ( B > E5 ) @ ( ( A > D ) > $o ) @ ( ( B > F10 ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ E5 @ C5 @ A5 )
          @ ( bNF_rel_fun @ ( A > D ) @ ( B > F10 ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ D @ F10 @ C5 @ B4 )
            @ ^ [Y4: $o,Z5: $o] : ( Y4 = Z5 ) ) )
        @ ( partial_fun_ord @ C @ D @ A )
        @ ( partial_fun_ord @ E5 @ F10 @ B ) ) ) ).

% fun_ord_parametric
thf(fact_4835_vimage__right__total__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B4: A > B > $o,A5: C > D > $o] :
      ( ( bi_unique @ A @ B @ B4 )
     => ( ( right_total @ C @ D @ A5 )
       => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( set @ A ) > ( set @ C ) ) @ ( ( set @ B ) > ( set @ D ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ A5 @ B4 ) @ ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ C ) @ ( set @ D ) @ ( bNF_rel_set @ A @ B @ B4 ) @ ( bNF_rel_set @ C @ D @ A5 ) )
          @ ^ [F3: C > A,X5: set @ A] : ( inf_inf @ ( set @ C ) @ ( vimage @ C @ A @ F3 @ X5 ) @ ( collect @ C @ ( domainp @ C @ D @ A5 ) ) )
          @ ( vimage @ D @ B ) ) ) ) ).

% vimage_right_total_transfer
thf(fact_4836_right__total__Inter__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( ( right_total @ A @ B @ A5 )
       => ( bNF_rel_fun @ ( set @ ( set @ A ) ) @ ( set @ ( set @ B ) ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A5 ) ) @ ( bNF_rel_set @ A @ B @ A5 )
          @ ^ [S7: set @ ( set @ A )] : ( inf_inf @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ S7 ) @ ( collect @ A @ ( domainp @ A @ B @ A5 ) ) )
          @ ( complete_Inf_Inf @ ( set @ B ) ) ) ) ) ).

% right_total_Inter_transfer
thf(fact_4837_right__total__Compl__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( ( right_total @ A @ B @ A5 )
       => ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A5 ) @ ( bNF_rel_set @ A @ B @ A5 )
          @ ^ [S7: set @ A] : ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ S7 ) @ ( collect @ A @ ( domainp @ A @ B @ A5 ) ) )
          @ ( uminus_uminus @ ( set @ B ) ) ) ) ) ).

% right_total_Compl_transfer
thf(fact_4838_listset__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ ( set @ A ) ) @ ( list @ ( set @ B ) ) @ ( set @ ( list @ A ) ) @ ( set @ ( list @ B ) ) @ ( list_all2 @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A5 ) ) @ ( bNF_rel_set @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( listset @ A ) @ ( listset @ B ) ) ).

% listset_transfer
thf(fact_4839_lists__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ ( list @ A ) ) @ ( set @ ( list @ B ) ) @ ( bNF_rel_set @ A @ B @ A5 ) @ ( bNF_rel_set @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( lists @ A ) @ ( lists @ B ) ) ).

% lists_transfer
thf(fact_4840_set__Cons__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) @ ( ( set @ ( list @ B ) ) > ( set @ ( list @ B ) ) ) @ ( bNF_rel_set @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( set @ ( list @ A ) ) @ ( set @ ( list @ B ) ) @ ( set @ ( list @ A ) ) @ ( set @ ( list @ B ) ) @ ( bNF_rel_set @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( bNF_rel_set @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) ) @ ( set_Cons @ A ) @ ( set_Cons @ B ) ) ).

% set_Cons_transfer
thf(fact_4841_rtrancl__parametric,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( ( bi_total @ A @ B @ A5 )
       => ( bNF_rel_fun @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_rel_set @ ( product_prod @ A @ A ) @ ( product_prod @ B @ B ) @ ( basic_rel_prod @ A @ B @ A @ B @ A5 @ A5 ) ) @ ( bNF_rel_set @ ( product_prod @ A @ A ) @ ( product_prod @ B @ B ) @ ( basic_rel_prod @ A @ B @ A @ B @ A5 @ A5 ) ) @ ( transitive_rtrancl @ A ) @ ( transitive_rtrancl @ B ) ) ) ) ).

% rtrancl_parametric
thf(fact_4842_inter__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( ( bi_unique @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( ( set @ A ) > ( set @ A ) ) @ ( ( set @ B ) > ( set @ B ) ) @ ( bNF_rel_set @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ ( set @ A ) @ ( set @ B ) @ ( bNF_rel_set @ A @ B @ A5 ) @ ( bNF_rel_set @ A @ B @ A5 ) ) @ ( inf_inf @ ( set @ A ) ) @ ( inf_inf @ ( set @ B ) ) ) ) ).

% inter_transfer
thf(fact_4843_list_Obi__total__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( bi_total @ A @ B @ R )
     => ( bi_total @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R ) ) ) ).

% list.bi_total_rel
thf(fact_4844_list_Oright__total__rel,axiom,
    ! [B: $tType,A: $tType,R: A > B > $o] :
      ( ( right_total @ A @ B @ R )
     => ( right_total @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R ) ) ) ).

% list.right_total_rel
thf(fact_4845_list_Oset__transfer,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( set @ A ) @ ( set @ B ) @ ( list_all2 @ A @ B @ R ) @ ( bNF_rel_set @ A @ B @ R ) @ ( set2 @ A ) @ ( set2 @ B ) ) ).

% list.set_transfer
thf(fact_4846_shuffles__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ A ) > ( set @ ( list @ A ) ) ) @ ( ( list @ B ) > ( set @ ( list @ B ) ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( set @ ( list @ A ) ) @ ( set @ ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_set @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) ) @ ( shuffles @ A ) @ ( shuffles @ B ) ) ).

% shuffles_transfer
thf(fact_4847_nths__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( set @ nat ) > ( list @ A ) ) @ ( ( set @ nat ) > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 )
      @ ( bNF_rel_fun @ ( set @ nat ) @ ( set @ nat ) @ ( list @ A ) @ ( list @ B )
        @ ( bNF_rel_set @ nat @ nat
          @ ^ [Y4: nat,Z5: nat] : ( Y4 = Z5 ) )
        @ ( list_all2 @ A @ B @ A5 ) )
      @ ( nths @ A )
      @ ( nths @ B ) ) ).

% nths_transfer
thf(fact_4848_fun__lub__parametric,axiom,
    ! [A: $tType,C: $tType,E5: $tType,F10: $tType,D: $tType,B: $tType,A5: A > B > $o,B4: C > D > $o,C5: E5 > F10 > $o] :
      ( ( bi_total @ A @ B @ A5 )
     => ( ( bi_unique @ A @ B @ A5 )
       => ( bNF_rel_fun @ ( ( set @ A ) > C ) @ ( ( set @ B ) > D ) @ ( ( set @ ( E5 > A ) ) > E5 > C ) @ ( ( set @ ( F10 > B ) ) > F10 > D ) @ ( bNF_rel_fun @ ( set @ A ) @ ( set @ B ) @ C @ D @ ( bNF_rel_set @ A @ B @ A5 ) @ B4 ) @ ( bNF_rel_fun @ ( set @ ( E5 > A ) ) @ ( set @ ( F10 > B ) ) @ ( E5 > C ) @ ( F10 > D ) @ ( bNF_rel_set @ ( E5 > A ) @ ( F10 > B ) @ ( bNF_rel_fun @ E5 @ F10 @ A @ B @ C5 @ A5 ) ) @ ( bNF_rel_fun @ E5 @ F10 @ C @ D @ C5 @ B4 ) ) @ ( partial_fun_lub @ A @ C @ E5 ) @ ( partial_fun_lub @ B @ D @ F10 ) ) ) ) ).

% fun_lub_parametric
thf(fact_4849_syntax__nomatch__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( syntax2379306206330768139omatch @ A @ B )
      = ( ^ [Pat: A,Obj: B] : $true ) ) ).

% syntax_nomatch_def
thf(fact_4850_comp__fun__idem__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( finite_comp_fun_idem @ A @ A @ ( inf_inf @ A ) ) ) ).

% comp_fun_idem_inf
thf(fact_4851_subset__mset_Omono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ! [F2: ( multiset @ A ) > B,A5: multiset @ A,B4: multiset @ A] :
          ( ( mono @ ( multiset @ A ) @ B @ ( subseteq_mset @ A ) @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inter_mset @ A @ A5 @ B4 ) ) @ ( inf_inf @ B @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) ) ) ) ).

% subset_mset.mono_inf
thf(fact_4852_subset__mset_Oless__eq__cInf__inter,axiom,
    ! [A: $tType,A5: set @ ( multiset @ A ),B4: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A5 )
     => ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B4 )
       => ( ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( subseteq_mset @ A @ ( inter_mset @ A @ ( complete_Inf_Inf @ ( multiset @ A ) @ A5 ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ B4 ) ) @ ( complete_Inf_Inf @ ( multiset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 ) ) ) ) ) ) ).

% subset_mset.less_eq_cInf_inter
thf(fact_4853_subset__mset_OcSup__inter__less__eq,axiom,
    ! [A: $tType,A5: set @ ( multiset @ A ),B4: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A5 )
     => ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B4 )
       => ( ( ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 )
           != ( bot_bot @ ( set @ ( multiset @ A ) ) ) )
         => ( subseteq_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 ) ) @ ( union_mset @ A @ ( complete_Sup_Sup @ ( multiset @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( multiset @ A ) @ B4 ) ) ) ) ) ) ).

% subset_mset.cSup_inter_less_eq
thf(fact_4854_subset__mset_Obdd__above__Int1,axiom,
    ! [A: $tType,A5: set @ ( multiset @ A ),B4: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A5 )
     => ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 ) ) ) ).

% subset_mset.bdd_above_Int1
thf(fact_4855_subset__mset_Obdd__above__Int2,axiom,
    ! [A: $tType,B4: set @ ( multiset @ A ),A5: set @ ( multiset @ A )] :
      ( ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B4 )
     => ( condit8047198070973881523_above @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 ) ) ) ).

% subset_mset.bdd_above_Int2
thf(fact_4856_subset__mset_Obdd__below__Int1,axiom,
    ! [A: $tType,A5: set @ ( multiset @ A ),B4: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ A5 )
     => ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 ) ) ) ).

% subset_mset.bdd_below_Int1
thf(fact_4857_subset__mset_Obdd__below__Int2,axiom,
    ! [A: $tType,B4: set @ ( multiset @ A ),A5: set @ ( multiset @ A )] :
      ( ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ B4 )
     => ( condit8119078960628432327_below @ ( multiset @ A ) @ ( subseteq_mset @ A ) @ ( inf_inf @ ( set @ ( multiset @ A ) ) @ A5 @ B4 ) ) ) ).

% subset_mset.bdd_below_Int2

% Type constructors (603)
thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice @ assn ).

thf(tcon_Predicate_Opred___Lattices_Obounded__lattice_2,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( pred @ A11 ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice_3,axiom,
    ! [A11: $tType] :
      ( ( bounded_lattice_top @ A11 )
     => ( bounded_lattice @ ( option @ A11 ) ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_4,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_5,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( set @ A11 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_6,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( bounded_lattice @ A14 )
     => ( bounded_lattice @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( comple6319245703460814977attice @ A14 )
     => ( condit1219197933456340205attice @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( comple592849572758109894attice @ A14 )
     => ( comple592849572758109894attice @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( bounded_lattice @ A14 )
     => ( bounde4967611905675639751up_bot @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( bounded_lattice @ A14 )
     => ( bounde4346867609351753570nf_top @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( comple6319245703460814977attice @ A14 )
     => ( comple6319245703460814977attice @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( boolea8198339166811842893lgebra @ A14 )
     => ( boolea8198339166811842893lgebra @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( bounded_lattice @ A14 )
     => ( bounded_lattice_top @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( bounded_lattice @ A14 )
     => ( bounded_lattice_bot @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( semilattice_sup @ A14 )
     => ( semilattice_sup @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( semilattice_inf @ A14 )
     => ( semilattice_inf @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( distrib_lattice @ A14 )
     => ( distrib_lattice @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( preorder @ A14 )
     => ( preorder @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( lattice @ A14 )
     => ( lattice @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( order @ A14 )
     => ( order @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( ord @ A14 )
     => ( ord @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( uminus @ A14 )
     => ( uminus @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Lattices_Oinf,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( semilattice_inf @ A14 )
     => ( inf @ ( A11 > A14 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( minus @ A14 )
     => ( minus @ ( A11 > A14 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_7,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_8,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_9,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_10,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_11,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_12,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_13,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Orderings_Oord_14,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_15,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Lattices_Oinf_16,axiom,
    inf @ int ).

thf(tcon_Int_Oint___Groups_Otimes,axiom,
    times @ int ).

thf(tcon_Int_Oint___Groups_Ominus_17,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Int_Oint___Heap_Oheap,axiom,
    heap @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_18,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_19,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_20,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_21,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_22,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_23,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_24,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_25,axiom,
    normal6328177297339901930cative @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_26,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_27,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_28,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_29,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_30,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_31,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_32,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_33,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_34,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_35,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_36,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_37,axiom,
    semido2269285787275462019factor @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_38,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_39,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_40,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_41,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_42,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_43,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_44,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_45,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_46,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_47,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom_48,axiom,
    normal8620421768224518004emidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_49,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_50,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_51,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_52,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_53,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_54,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_55,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_56,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_57,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_58,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_59,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_60,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_61,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_62,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_63,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_64,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_65,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_66,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_67,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_68,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_69,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_70,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_71,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_72,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_73,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_74,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_75,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_76,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_77,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_78,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_79,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_80,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_81,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_82,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_83,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_84,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_85,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_86,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_87,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Lattices_Oinf_88,axiom,
    inf @ nat ).

thf(tcon_Nat_Onat___Groups_Otimes_89,axiom,
    times @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_90,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_91,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_92,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_93,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_94,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_95,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Heap_Oheap_96,axiom,
    heap @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_97,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_98,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_99,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_100,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Otimes_101,axiom,
    times @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_102,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_103,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_104,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_105,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_106,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_107,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_108,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_109,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_110,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_111,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_112,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_113,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_114,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_115,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_116,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_117,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_118,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_119,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_120,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_121,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_122,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_123,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_124,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_125,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_126,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_127,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_128,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_129,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_130,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_131,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_132,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_133,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_134,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_135,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_136,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_137,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_138,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_139,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_140,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_141,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_142,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_143,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_144,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_145,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_146,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_147,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_148,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_149,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_150,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_151,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_152,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_153,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_154,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_155,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_156,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_157,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_158,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_159,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_160,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_161,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_162,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_163,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_164,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_165,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_166,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_167,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_168,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_169,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_170,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_171,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_172,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Lattices_Oinf_173,axiom,
    inf @ rat ).

thf(tcon_Rat_Orat___Groups_Otimes_174,axiom,
    times @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_175,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_176,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_177,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_178,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_179,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_180,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_181,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_182,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_183,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_184,axiom,
    ! [A11: $tType] : ( comple592849572758109894attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_185,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_186,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_187,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_188,axiom,
    ! [A11: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_189,axiom,
    ! [A11: $tType] : ( bounded_lattice_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_190,axiom,
    ! [A11: $tType] : ( bounded_lattice_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_191,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_192,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_193,axiom,
    ! [A11: $tType] : ( distrib_lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_194,axiom,
    ! [A11: $tType] : ( preorder @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_195,axiom,
    ! [A11: $tType] : ( lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_196,axiom,
    ! [A11: $tType] : ( order @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_197,axiom,
    ! [A11: $tType] : ( ord @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_198,axiom,
    ! [A11: $tType] : ( uminus @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Oinf_199,axiom,
    ! [A11: $tType] : ( inf @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_200,axiom,
    ! [A11: $tType] : ( minus @ ( set @ A11 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_201,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_202,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_203,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_204,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_205,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_206,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_207,axiom,
    bounded_lattice_top @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_208,axiom,
    bounded_lattice_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_209,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_210,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_211,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_212,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_213,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_214,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_215,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_216,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_217,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Lattices_Oinf_218,axiom,
    inf @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_219,axiom,
    minus @ $o ).

thf(tcon_HOL_Obool___Heap_Oheap_220,axiom,
    heap @ $o ).

thf(tcon_Heap_Oref___Heap_Oheap_221,axiom,
    ! [A11: $tType] : ( heap @ ( ref @ A11 ) ) ).

thf(tcon_List_Olist___Heap_Oheap_222,axiom,
    ! [A11: $tType] :
      ( ( heap @ A11 )
     => ( heap @ ( list @ A11 ) ) ) ).

thf(tcon_Heap_Oarray___Heap_Oheap_223,axiom,
    ! [A11: $tType] : ( heap @ ( array @ A11 ) ) ).

thf(tcon_String_Ochar___Heap_Oheap_224,axiom,
    heap @ char ).

thf(tcon_Option_Ooption___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_225,axiom,
    ! [A11: $tType] :
      ( ( comple6319245703460814977attice @ A11 )
     => ( condit1219197933456340205attice @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__distrib__lattice_226,axiom,
    ! [A11: $tType] :
      ( ( comple592849572758109894attice @ A11 )
     => ( comple592849572758109894attice @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__semilattice__sup__bot_227,axiom,
    ! [A11: $tType] :
      ( ( lattice @ A11 )
     => ( bounde4967611905675639751up_bot @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__semilattice__inf__top_228,axiom,
    ! [A11: $tType] :
      ( ( bounded_lattice_top @ A11 )
     => ( bounde4346867609351753570nf_top @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__linorder,axiom,
    ! [A11: $tType] :
      ( ( comple5582772986160207858norder @ A11 )
     => ( comple5582772986160207858norder @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Complete__Lattices_Ocomplete__lattice_229,axiom,
    ! [A11: $tType] :
      ( ( comple6319245703460814977attice @ A11 )
     => ( comple6319245703460814977attice @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice__top_230,axiom,
    ! [A11: $tType] :
      ( ( bounded_lattice_top @ A11 )
     => ( bounded_lattice_top @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Obounded__lattice__bot_231,axiom,
    ! [A11: $tType] :
      ( ( lattice @ A11 )
     => ( bounded_lattice_bot @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osemilattice__sup_232,axiom,
    ! [A11: $tType] :
      ( ( semilattice_sup @ A11 )
     => ( semilattice_sup @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Osemilattice__inf_233,axiom,
    ! [A11: $tType] :
      ( ( semilattice_inf @ A11 )
     => ( semilattice_inf @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Odistrib__lattice_234,axiom,
    ! [A11: $tType] :
      ( ( distrib_lattice @ A11 )
     => ( distrib_lattice @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Owellorder_235,axiom,
    ! [A11: $tType] :
      ( ( wellorder @ A11 )
     => ( wellorder @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Opreorder_236,axiom,
    ! [A11: $tType] :
      ( ( preorder @ A11 )
     => ( preorder @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Olinorder_237,axiom,
    ! [A11: $tType] :
      ( ( linorder @ A11 )
     => ( linorder @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Olattice_238,axiom,
    ! [A11: $tType] :
      ( ( lattice @ A11 )
     => ( lattice @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oorder_239,axiom,
    ! [A11: $tType] :
      ( ( order @ A11 )
     => ( order @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Orderings_Oord_240,axiom,
    ! [A11: $tType] :
      ( ( preorder @ A11 )
     => ( ord @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Lattices_Oinf_241,axiom,
    ! [A11: $tType] :
      ( ( inf @ A11 )
     => ( inf @ ( option @ A11 ) ) ) ).

thf(tcon_Option_Ooption___Heap_Oheap_242,axiom,
    ! [A11: $tType] :
      ( ( heap @ A11 )
     => ( heap @ ( option @ A11 ) ) ) ).

thf(tcon_Predicate_Opred___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_243,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__distrib__lattice_244,axiom,
    ! [A11: $tType] : ( comple592849572758109894attice @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__semilattice__sup__bot_245,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__semilattice__inf__top_246,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Complete__Lattices_Ocomplete__lattice_247,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Boolean__Algebras_Oboolean__algebra_248,axiom,
    ! [A11: $tType] : ( boolea8198339166811842893lgebra @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__lattice__top_249,axiom,
    ! [A11: $tType] : ( bounded_lattice_top @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Obounded__lattice__bot_250,axiom,
    ! [A11: $tType] : ( bounded_lattice_bot @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Osemilattice__sup_251,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Osemilattice__inf_252,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Odistrib__lattice_253,axiom,
    ! [A11: $tType] : ( distrib_lattice @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Opreorder_254,axiom,
    ! [A11: $tType] : ( preorder @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Olattice_255,axiom,
    ! [A11: $tType] : ( lattice @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Oorder_256,axiom,
    ! [A11: $tType] : ( order @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Orderings_Oord_257,axiom,
    ! [A11: $tType] : ( ord @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Groups_Ouminus_258,axiom,
    ! [A11: $tType] : ( uminus @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Lattices_Oinf_259,axiom,
    ! [A11: $tType] : ( inf @ ( pred @ A11 ) ) ).

thf(tcon_Predicate_Opred___Groups_Ominus_260,axiom,
    ! [A11: $tType] : ( minus @ ( pred @ A11 ) ) ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__sup__bot_261,axiom,
    bounde4967611905675639751up_bot @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__semilattice__inf__top_262,axiom,
    bounde4346867609351753570nf_top @ assn ).

thf(tcon_Assertions_Oassn___Boolean__Algebras_Oboolean__algebra_263,axiom,
    boolea8198339166811842893lgebra @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice__top_264,axiom,
    bounded_lattice_top @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Obounded__lattice__bot_265,axiom,
    bounded_lattice_bot @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osemilattice__sup_266,axiom,
    semilattice_sup @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Osemilattice__inf_267,axiom,
    semilattice_inf @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Odistrib__lattice_268,axiom,
    distrib_lattice @ assn ).

thf(tcon_Assertions_Oassn___Groups_Oab__semigroup__mult_269,axiom,
    ab_semigroup_mult @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ocomm__monoid__mult_270,axiom,
    comm_monoid_mult @ assn ).

thf(tcon_Assertions_Oassn___Groups_Osemigroup__mult_271,axiom,
    semigroup_mult @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Opreorder_272,axiom,
    preorder @ assn ).

thf(tcon_Assertions_Oassn___Groups_Omonoid__mult_273,axiom,
    monoid_mult @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Olattice_274,axiom,
    lattice @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oorder_275,axiom,
    order @ assn ).

thf(tcon_Assertions_Oassn___Orderings_Oord_276,axiom,
    ord @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ouminus_277,axiom,
    uminus @ assn ).

thf(tcon_Assertions_Oassn___Lattices_Oinf_278,axiom,
    inf @ assn ).

thf(tcon_Assertions_Oassn___Groups_Otimes_279,axiom,
    times @ assn ).

thf(tcon_Assertions_Oassn___Groups_Ominus_280,axiom,
    minus @ assn ).

thf(tcon_Assertions_Oassn___Power_Opower_281,axiom,
    power @ assn ).

thf(tcon_Assertions_Oassn___Groups_Oone_282,axiom,
    one @ assn ).

thf(tcon_Assertions_Oassn___Rings_Odvd_283,axiom,
    dvd @ assn ).

thf(tcon_Typerep_Otyperep___Heap_Oheap_284,axiom,
    heap @ typerep ).

thf(tcon_Multiset_Omultiset___Groups_Oordered__ab__semigroup__add_285,axiom,
    ! [A11: $tType] :
      ( ( preorder @ A11 )
     => ( ordere6658533253407199908up_add @ ( multiset @ A11 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__ab__semigroup__add_286,axiom,
    ! [A11: $tType] : ( cancel2418104881723323429up_add @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__comm__monoid__add_287,axiom,
    ! [A11: $tType] : ( cancel1802427076303600483id_add @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocancel__semigroup__add_288,axiom,
    ! [A11: $tType] : ( cancel_semigroup_add @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__diff_289,axiom,
    ! [A11: $tType] : ( comm_monoid_diff @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Oab__semigroup__add_290,axiom,
    ! [A11: $tType] : ( ab_semigroup_add @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ocomm__monoid__add_291,axiom,
    ! [A11: $tType] : ( comm_monoid_add @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Osemigroup__add_292,axiom,
    ! [A11: $tType] : ( semigroup_add @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Opreorder_293,axiom,
    ! [A11: $tType] :
      ( ( preorder @ A11 )
     => ( preorder @ ( multiset @ A11 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Omonoid__add_294,axiom,
    ! [A11: $tType] : ( monoid_add @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Oorder_295,axiom,
    ! [A11: $tType] :
      ( ( preorder @ A11 )
     => ( order @ ( multiset @ A11 ) ) ) ).

thf(tcon_Multiset_Omultiset___Orderings_Oord_296,axiom,
    ! [A11: $tType] :
      ( ( preorder @ A11 )
     => ( ord @ ( multiset @ A11 ) ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ominus_297,axiom,
    ! [A11: $tType] : ( minus @ ( multiset @ A11 ) ) ).

thf(tcon_Multiset_Omultiset___Groups_Ozero_298,axiom,
    ! [A11: $tType] : ( zero @ ( multiset @ A11 ) ) ).

thf(tcon_Product__Type_Oprod___Heap_Oheap_299,axiom,
    ! [A11: $tType,A14: $tType] :
      ( ( ( heap @ A11 )
        & ( heap @ A14 ) )
     => ( heap @ ( product_prod @ A11 @ A14 ) ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_300,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_301,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_302,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_303,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_304,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_305,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_306,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_307,axiom,
    bounded_lattice_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_308,axiom,
    bounded_lattice_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_309,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_310,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_311,axiom,
    distrib_lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_312,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_313,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_314,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_315,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_316,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_317,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_318,axiom,
    uminus @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Oinf_319,axiom,
    inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ominus_320,axiom,
    minus @ product_unit ).

thf(tcon_Product__Type_Ounit___Heap_Oheap_321,axiom,
    heap @ product_unit ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_322,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_323,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_324,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_325,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_326,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_327,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_328,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_329,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_330,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_331,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_332,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_333,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_334,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_335,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_336,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_337,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_338,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_339,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_340,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_341,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_342,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_343,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_344,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_345,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_346,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_347,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_348,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_349,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_350,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_351,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_352,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_353,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_354,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_355,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_356,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_357,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_358,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_359,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_360,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_361,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_362,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_363,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_364,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_365,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_366,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_367,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_368,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_369,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_370,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_371,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_372,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_373,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_374,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_375,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_376,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_377,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_378,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_379,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_380,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_381,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_382,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_383,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_384,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_385,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_386,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_387,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_388,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_389,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_390,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_391,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_392,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_393,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_394,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_395,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_396,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_397,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_398,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_399,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_400,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_401,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_402,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_403,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Otimes_404,axiom,
    times @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_405,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_406,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_407,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_408,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_409,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_410,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_411,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_412,axiom,
    dvd @ code_integer ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_413,axiom,
    bit_un5681908812861735899ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_414,axiom,
    euclid5411537665997757685th_nat @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_415,axiom,
    ordere1937475149494474687imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_416,axiom,
    euclid3128863361964157862miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_417,axiom,
    euclid4440199948858584721cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_418,axiom,
    semiri6575147826004484403cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_419,axiom,
    strict9044650504122735259up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_420,axiom,
    ordere580206878836729694up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_421,axiom,
    ordere2412721322843649153imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_422,axiom,
    bit_se359711467146920520ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_423,axiom,
    linord2810124833399127020strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_424,axiom,
    strict7427464778891057005id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_425,axiom,
    ordere8940638589300402666id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_426,axiom,
    euclid3725896446679973847miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_427,axiom,
    linord181362715937106298miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_428,axiom,
    linord8928482502909563296strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_429,axiom,
    semiri3467727345109120633visors @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_430,axiom,
    ordere6658533253407199908up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_431,axiom,
    ordere6911136660526730532id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_432,axiom,
    cancel2418104881723323429up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_433,axiom,
    cancel1802427076303600483id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1__cancel_434,axiom,
    comm_s4317794764714335236cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_435,axiom,
    bit_semiring_bits @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_436,axiom,
    ordere2520102378445227354miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_437,axiom,
    cancel_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_438,axiom,
    linordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_439,axiom,
    ordered_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_440,axiom,
    linordered_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_441,axiom,
    ab_semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_442,axiom,
    algebraic_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_443,axiom,
    comm_monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_444,axiom,
    comm_monoid_diff @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_445,axiom,
    ab_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_446,axiom,
    ordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_447,axiom,
    semiring_parity @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_448,axiom,
    comm_monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_449,axiom,
    semiring_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_450,axiom,
    comm_semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_451,axiom,
    comm_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_452,axiom,
    semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_453,axiom,
    semidom_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_454,axiom,
    semidom_divide @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_455,axiom,
    semiring_numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_456,axiom,
    semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_457,axiom,
    zero_less_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring_458,axiom,
    comm_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_459,axiom,
    semiring_char_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_460,axiom,
    zero_neq_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Opreorder_461,axiom,
    preorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Olinorder_462,axiom,
    linorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_463,axiom,
    monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_464,axiom,
    monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_465,axiom,
    semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_466,axiom,
    semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Omult__zero_467,axiom,
    mult_zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oorder_468,axiom,
    order @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring_469,axiom,
    semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oord_470,axiom,
    ord @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Otimes_471,axiom,
    times @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ominus_472,axiom,
    minus @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Power_Opower_473,axiom,
    power @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Onumeral_474,axiom,
    numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_475,axiom,
    zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oone_476,axiom,
    one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Odvd_477,axiom,
    dvd @ code_natural ).

% Helper facts (3)
thf(help_If_3_1_T,axiom,
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    fI_QUERY @ p @ q @ f ).

%------------------------------------------------------------------------------
