%------------------------------------------------------------------------------
% File     : VBT00016^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Definitions 00195_007561
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0063_VEBT_Definitions_00195_007561 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9605 (2869 unt; 618 typ;   0 def)
%            Number of atoms       : 29066 (8849 equ;   0 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 168502 (1906   ~; 295   |;2276   &;150958   @)
%                                         (   0 <=>;13067  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   13 (  12 usr)
%            Number of type conns  : 4056 (4056   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  609 ( 606 usr;  10 con; 0-9 aty)
%            Number of variables   : 28154 (2836   ^24054   !; 704   ?;28154   :)
%                                         ( 560  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 17:14:09.463
%------------------------------------------------------------------------------
% Could-be-implicit typings (18)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_String_Oliteral,type,
    literal: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (600)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Odist__norm,type,
    real_V6936659425649961206t_norm: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniformity,type,
    topolo4638772830378233104ormity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,type,
    counta4013691401010221786attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2p,type,
    bNF_Greatest_image2p: 
      !>[C: $tType,A: $tType,D: $tType,B: $tType] : ( ( C > A ) > ( D > B ) > ( C > D > $o ) > A > B > $o ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__nat,type,
    code_integer_of_nat: nat > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Target__Nat_Oint__of__nat,type,
    code_T6385005292777649522of_nat: nat > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Complex_Orcis,type,
    rcis: real > real > complex ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Countable__Set_Ocountable,type,
    countable_countable: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Countable__Set_Ofrom__nat__into,type,
    counta4804993851260445106t_into: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

thf(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( nat > T ) > T > extended_enat > T ) ).

thf(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oabstract__filter,type,
    abstract_filter: 
      !>[A: $tType] : ( ( product_unit > ( filter @ A ) ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ ( set @ A ) ) ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( filter @ B ) > ( filter @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B > $o ) ).

thf(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( ( A > nat ) > $o ) ).

thf(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( set @ A ) > A ) ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ogen__length,type,
    gen_length: 
      !>[A: $tType] : ( nat > ( list @ A ) > nat ) ).

thf(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oint__decode,type,
    nat_int_decode: nat > int ).

thf(sy_c_Nat__Bijection_Oint__encode,type,
    nat_int_encode: int > nat ).

thf(sy_c_Nat__Bijection_Olist__decode,type,
    nat_list_decode: nat > ( list @ nat ) ).

thf(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: nat > nat > $o ).

thf(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: ( list @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: ( list @ nat ) > ( list @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Orec__num,type,
    rec_num: 
      !>[A: $tType] : ( A > ( num > A > A ) > ( num > A > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Order__Continuity_Ocountable__complete__lattice__class_Occlfp,type,
    order_532582986084564980_cclfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( A > ( set @ A ) > A ) ).

thf(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( A > ( A > A > A ) > A > nat > A ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Real_OReal,type,
    real2: ( nat > rat ) > real ).

thf(sy_c_Real_Ocauchy,type,
    cauchy: ( nat > rat ) > $o ).

thf(sy_c_Real_Opcr__real,type,
    pcr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opositive,type,
    positive2: real > $o ).

thf(sy_c_Real_Orealrel,type,
    realrel: ( nat > rat ) > ( nat > rat ) > $o ).

thf(sy_c_Real_Orep__real,type,
    rep_real: real > nat > rat ).

thf(sy_c_Real_Ovanishes,type,
    vanishes: ( nat > rat ) > $o ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__bilinear,type,
    real_V2442710119149674383linear: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Oconstruct,type,
    real_V4425403222259421789struct: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > A > B ) ).

thf(sy_c_Real__Vector__Spaces_Odependent,type,
    real_V358717886546972837endent: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odim,type,
    real_Vector_dim: 
      !>[A: $tType] : ( ( set @ A ) > nat ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oextend__basis,type,
    real_V4986007116245087402_basis: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Real__Vector__Spaces_Olinear,type,
    real_Vector_linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_Orepresentation,type,
    real_V7696804695334737415tation: 
      !>[A: $tType] : ( ( set @ A ) > A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Real__Vector__Spaces_Ospan,type,
    real_Vector_span: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Real__Vector__Spaces_Osubspace,type,
    real_Vector_subspace: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_OCode_Oabort,type,
    abort: 
      !>[A: $tType] : ( literal > ( product_unit > A ) > A ) ).

thf(sy_c_String_OLiteral,type,
    literal2: $o > $o > $o > $o > $o > $o > $o > literal > literal ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oconnected,type,
    topolo1966860045006549960nected: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oconvergent,type,
    topolo6863149650580417670ergent: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocomplete,type,
    topolo2479028161051973599mplete: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Opowr__real,type,
    powr_real: real > real > real ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Orelpow,type,
    transitive_relpow: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Orelpowp,type,
    transitive_relpowp: 
      !>[A: $tType] : ( nat > ( A > A > $o ) > A > A > $o ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Orec__VEBT,type,
    vEBT_rec_VEBT: 
      !>[A: $tType] : ( ( ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ ( product_prod @ vEBT_VEBT @ A ) ) > vEBT_VEBT > A > A ) > ( $o > $o > A ) > vEBT_VEBT > A ) ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_thesis,type,
    thesis: $o ).

thf(sy_v_x,type,
    x: nat ).

% Relevant facts (8183)
thf(fact_0_that_I1_J,axiom,
    ! [N: nat] :
      ( ( x
        = ( plus_plus @ nat @ N @ N ) )
     => thesis ) ).

% that(1)
thf(fact_1_that_I2_J,axiom,
    ! [N: nat] :
      ( ( x
        = ( plus_plus @ nat @ N @ ( suc @ N ) ) )
     => thesis ) ).

% that(2)
thf(fact_2_add__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc_right
thf(fact_3_nat_Oinject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% nat.inject
thf(fact_4_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_5_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_6_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_7_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A3 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_8_add__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc
thf(fact_9_add__Suc__shift,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) ).

% add_Suc_shift
thf(fact_10_Suc__inject,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) ).

% Suc_inject
thf(fact_11_n__not__Suc__n,axiom,
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) ).

% n_not_Suc_n
thf(fact_12_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_13_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_14_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_15_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_16_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ B3 @ A4 ) ) ) ) ).

% add.commute
thf(fact_17_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_18_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_19_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_20_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B4 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_21_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_22_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_23_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_24_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N: nat,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N ) @ I )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N @ ( Inc @ I ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_25_triangle__Suc,axiom,
    ! [N: nat] :
      ( ( nat_triangle @ ( suc @ N ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N ) @ ( suc @ N ) ) ) ).

% triangle_Suc
thf(fact_26_mult__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc_right
thf(fact_27_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F2: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F2 @ ( suc @ Nat ) )
      = ( F2 @ Nat @ ( rec_nat @ T @ F1 @ F2 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_28_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_add
thf(fact_29_Suc__funpow,axiom,
    ! [N: nat] :
      ( ( compow @ ( nat > nat ) @ N @ suc )
      = ( plus_plus @ nat @ N ) ) ).

% Suc_funpow
thf(fact_30_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_31_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_32_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_33_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_34_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N2: nat] : ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_35_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) ).

% of_nat_eq_iff
thf(fact_36_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_37_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_38_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_39_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_40_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_41_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_42_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_43_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( collect @ A
        @ ^ [X3: A] : ( member @ A @ X3 @ A3 ) )
      = A3 ) ).

% Collect_mem_eq
thf(fact_44_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_45_ext,axiom,
    ! [B: $tType,A: $tType,F3: A > B,G: A > B] :
      ( ! [X4: A] :
          ( ( F3 @ X4 )
          = ( G @ X4 ) )
     => ( F3 = G ) ) ).

% ext
thf(fact_46_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_47_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_48_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_49_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_50_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_51_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_52_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_53_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_54_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_55_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_56_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_57_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_58_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_59_funpow__0,axiom,
    ! [A: $tType,F3: A > A,X: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F3 @ X )
      = X ) ).

% funpow_0
thf(fact_60_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F2: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F2 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_61_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% triangle_0
thf(fact_62_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_63_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) ).

% of_nat_0_eq_iff
thf(fact_64_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_65_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_66_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_67_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_68_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_69_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_70_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_71_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_72_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I )
          = I ) ) ).

% of_nat_aux.simps(1)
thf(fact_73_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_74_mult__0,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_75_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_76_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_77_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_78_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_79_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ B3 @ A4 ) ) ) ) ).

% mult.commute
thf(fact_80_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_81_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_82_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_83_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ N @ ( compow @ ( A > A ) @ M @ F3 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N ) @ F3 ) ) ).

% funpow_mult
thf(fact_84_funpow__swap1,axiom,
    ! [A: $tType,F3: A > A,N: nat,X: A] :
      ( ( F3 @ ( compow @ ( A > A ) @ N @ F3 @ X ) )
      = ( compow @ ( A > A ) @ N @ F3 @ ( F3 @ X ) ) ) ).

% funpow_swap1
thf(fact_85_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_86_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_87_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_88_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_89_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_90_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_91_list__decode_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ~ ! [N3: nat] :
            ( X
           != ( suc @ N3 ) ) ) ).

% list_decode.cases
thf(fact_92_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( M = N ) ) ).

% Suc_mult_cancel1
thf(fact_93_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% add_mult_distrib
thf(fact_94_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% add_mult_distrib2
thf(fact_95_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_96_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_97_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_98_nat_Odistinct_I1_J,axiom,
    ! [X2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X2 ) ) ).

% nat.distinct(1)
thf(fact_99_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat3: nat] :
      ( ( suc @ Nat3 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_100_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_101_nat_OdiscI,axiom,
    ! [Nat: nat,X2: nat] :
      ( ( Nat
        = ( suc @ X2 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_102_old_Onat_Oexhaust,axiom,
    ! [Y: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ~ ! [Nat4: nat] :
            ( Y
           != ( suc @ Nat4 ) ) ) ).

% old.nat.exhaust
thf(fact_103_nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N ) ) ) ).

% nat_induct
thf(fact_104_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X4: nat] : ( P @ X4 @ ( zero_zero @ nat ) )
     => ( ! [Y3: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y3 ) )
       => ( ! [X4: nat,Y3: nat] :
              ( ( P @ X4 @ Y3 )
             => ( P @ ( suc @ X4 ) @ ( suc @ Y3 ) ) )
         => ( P @ M @ N ) ) ) ) ).

% diff_induct
thf(fact_105_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_106_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_107_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_108_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_109_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M2: nat] :
          ( N
          = ( suc @ M2 ) ) ) ).

% not0_implies_Suc
thf(fact_110_plus__nat_Oadd__0,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% plus_nat.add_0
thf(fact_111_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_112_mult__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc
thf(fact_113_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_114_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_115_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_116_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_117_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_118_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_119_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_120_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_121_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_122_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_123_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_124_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_125_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z ) ) ).

% zadd_int_left
thf(fact_126_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_127_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_128_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_129_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_130_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_131_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_132_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_133_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_134_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y: A,X: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y ) @ ( times_times @ A @ X @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z ) @ ( times_times @ A @ X @ Y ) ) )
          = ( ( W = X )
            | ( Y = Z ) ) ) ) ).

% crossproduct_eq
thf(fact_135_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_136_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_137_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_138_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_139_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_140_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_141_relpowp__1,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( one_one @ nat ) @ P )
      = P ) ).

% relpowp_1
thf(fact_142_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_143_left__add__mult__distrib,axiom,
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I @ J ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_144_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_145_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A5: nat,B5: nat] :
          ( ( P @ A5 @ B5 )
          = ( P @ B5 @ A5 ) )
     => ( ! [A5: nat] : ( P @ A5 @ ( zero_zero @ nat ) )
       => ( ! [A5: nat,B5: nat] :
              ( ( P @ A5 @ B5 )
             => ( P @ A5 @ ( plus_plus @ nat @ A5 @ B5 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_146_relpowp__E,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N
                = ( suc @ M2 ) )
             => ( ( compow @ ( A > A > $o ) @ M2 @ P @ X @ Y3 )
               => ~ ( P @ Y3 @ Z ) ) ) ) ) ).

% relpowp_E
thf(fact_147_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N
                = ( suc @ M2 ) )
             => ( ( P @ X @ Y3 )
               => ~ ( compow @ ( A > A > $o ) @ M2 @ P @ Y3 @ Z ) ) ) ) ) ).

% relpowp_E2
thf(fact_148_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_1: nat] : ( P @ X_1 )
       => ? [N3: nat] :
            ( ~ ( P @ N3 )
            & ( P @ ( suc @ N3 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_149_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_1: A] : ( P @ ( zero_zero @ nat ) @ X_1 )
     => ( ! [X4: A,N3: nat] :
            ( ( P @ N3 @ X4 )
           => ? [Y4: A] :
                ( ( P @ ( suc @ N3 ) @ Y4 )
                & ( Q @ N3 @ X4 @ Y4 ) ) )
       => ? [F4: nat > A] :
          ! [N4: nat] :
            ( ( P @ N4 @ ( F4 @ N4 ) )
            & ( Q @ N4 @ ( F4 @ N4 ) @ ( F4 @ ( suc @ N4 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_150_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_151_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_152_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_153_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z2: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z2 ) ) ) ).

% int_distrib(2)
thf(fact_154_int__distrib_I1_J,axiom,
    ! [Z1: int,Z2: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z2 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z2 @ W ) ) ) ).

% int_distrib(1)
thf(fact_155_plus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) ).

% plus_int_code(2)
thf(fact_156_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_157_odd__nonzero,axiom,
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_158_relpowp__Suc__D2_H,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X5: A,Y4: A,Z3: A] :
      ( ( ( compow @ ( A > A > $o ) @ N @ P @ X5 @ Y4 )
        & ( P @ Y4 @ Z3 ) )
     => ? [W2: A] :
          ( ( P @ X5 @ W2 )
          & ( compow @ ( A > A > $o ) @ N @ P @ W2 @ Z3 ) ) ) ).

% relpowp_Suc_D2'
thf(fact_159_int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N ) )
      = ( M = N ) ) ).

% int_int_eq
thf(fact_160_nat__int__comparison_I1_J,axiom,
    ( ( ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    = ( ^ [A4: nat,B3: nat] :
          ( ( semiring_1_of_nat @ int @ A4 )
          = ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(1)
thf(fact_161_int__if,axiom,
    ! [P: $o,A2: nat,B2: nat] :
      ( ( P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ A2 ) ) )
      & ( ~ P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ B2 ) ) ) ) ).

% int_if
thf(fact_162_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_163_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_164_relpowp__Suc__E,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z )
     => ~ ! [Y3: A] :
            ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Y3 )
           => ~ ( P @ Y3 @ Z ) ) ) ).

% relpowp_Suc_E
thf(fact_165_relpowp__Suc__I,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Y: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Y )
     => ( ( P @ Y @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z ) ) ) ).

% relpowp_Suc_I
thf(fact_166_relpowp__Suc__D2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z )
     => ? [Y3: A] :
          ( ( P @ X @ Y3 )
          & ( compow @ ( A > A > $o ) @ N @ P @ Y3 @ Z ) ) ) ).

% relpowp_Suc_D2
thf(fact_167_relpowp__Suc__E2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z )
     => ~ ! [Y3: A] :
            ( ( P @ X @ Y3 )
           => ~ ( compow @ ( A > A > $o ) @ N @ P @ Y3 @ Z ) ) ) ).

% relpowp_Suc_E2
thf(fact_168_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y: A,N: nat,Z: A] :
      ( ( P @ X @ Y )
     => ( ( compow @ ( A > A > $o ) @ N @ P @ Y @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N ) @ P @ X @ Z ) ) ) ).

% relpowp_Suc_I2
thf(fact_169_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_170_relpowp__0__I,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ X ) ).

% relpowp_0_I
thf(fact_171_relpowp__0__E,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ Y )
     => ( X = Y ) ) ).

% relpowp_0_E
thf(fact_172_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R2: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R2 )
      = ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) ) ) ).

% relpowp.simps(1)
thf(fact_173_int__plus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_174_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_175_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_176_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_177_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X3: A] : ( plus_plus @ A @ ( plus_plus @ A @ X3 @ X3 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_178_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_179_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_180_relpowp__code__def,axiom,
    ! [A: $tType] :
      ( ( transitive_relpowp @ A )
      = ( compow @ ( A > A > $o ) ) ) ).

% relpowp_code_def
thf(fact_181_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_182_ntrancl__Zero,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( transitive_ntrancl @ A @ ( zero_zero @ nat ) @ R2 )
      = R2 ) ).

% ntrancl_Zero
thf(fact_183_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% mult_eq_if
thf(fact_184_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% add_eq_if
thf(fact_185_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C3: nat > A,N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( C3 @ ( suc @ N2 ) ) ) ) ) ) ).

% diffs_def
thf(fact_186_round__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archimedean_round @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% round_of_nat
thf(fact_187_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_188_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A2: A,Y: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_189_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N @ M ) ) ).

% Suc_le_mono
thf(fact_190_le0,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% le0
thf(fact_191_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_192_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% nat_add_left_cancel_le
thf(fact_193_diff__diff__cancel,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ N )
     => ( ( minus_minus @ nat @ N @ ( minus_minus @ nat @ N @ I ) )
        = I ) ) ).

% diff_diff_cancel
thf(fact_194_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_195_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_196_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_197_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_198_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_199_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_200_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_201_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_202_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_203_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_204_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_205_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_206_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_207_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_208_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% of_nat_le_iff
thf(fact_209_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N ) @ K ) ) ).

% Suc_diff_diff
thf(fact_210_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_Suc_Suc
thf(fact_211_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_212_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% diff_is_0_eq
thf(fact_213_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_214_diff__0__eq__0,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_215_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_216_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_217_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_218_diff__diff__left,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ I @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_219_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_220_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_221_powr__one__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% powr_one_eq_one
thf(fact_222_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_223_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_224_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_225_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_226_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_227_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_228_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_229_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_230_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_231_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_232_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_233_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) ) ).

% one_le_mult_iff
thf(fact_234_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_235_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_236_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_237_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_238_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_239_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_240_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_round @ A @ Y ) ) ) ) ).

% round_mono
thf(fact_241_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_242_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_243_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% of_nat_diff
thf(fact_244_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ).

% diff_le_mono2
thf(fact_245_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_246_diff__le__self,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ).

% diff_le_self
thf(fact_247_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L ) @ ( minus_minus @ nat @ N @ L ) ) ) ).

% diff_le_mono
thf(fact_248_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_249_diff__commute,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I @ K ) @ J ) ) ).

% diff_commute
thf(fact_250_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% le_diff_iff
thf(fact_251_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N @ K ) )
          = ( M = N ) ) ) ) ).

% eq_diff_iff
thf(fact_252_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_253_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_254_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_255_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_256_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_257_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_258_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_259_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_260_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_261_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_262_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_263_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ord_less_eq @ A @ I @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_264_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_265_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_266_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_267_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_268_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_269_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_270_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_271_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_272_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_273_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_274_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_275_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_276_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( suc @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Suc_diff_le
thf(fact_277_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F3 @ N ) @ ( F3 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_278_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ ( suc @ N3 ) ) @ ( F3 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F3 @ N5 ) @ ( F3 @ N ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_279_le__diff__conv,axiom,
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ).

% le_diff_conv
thf(fact_280_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_281_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_282_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_283_Nat_Ole__imp__diff__is__add,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( minus_minus @ nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_284_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_285_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_286_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% zle_int
thf(fact_287_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_288_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_289_nat__diff__add__eq2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_290_nat__diff__add__eq1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_diff_add_eq1
thf(fact_291_nat__le__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_le_add_iff2
thf(fact_292_nat__le__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_le_add_iff1
thf(fact_293_nat__eq__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_294_nat__eq__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M )
          = N ) ) ) ).

% nat_eq_add_iff1
thf(fact_295_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( minus_minus @ A @ A4 @ B3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_296_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_297_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_298_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_299_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_300_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_301_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_302_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_303_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_304_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_305_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_306_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_307_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_308_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_309_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_310_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_311_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K @ I ) ) ) ) ).

% zero_induct_lemma
thf(fact_312_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N @ M )
          = ( zero_zero @ nat ) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
thf(fact_313_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_314_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_315_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_316_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_317_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
            ? [C3: A] :
              ( B3
              = ( plus_plus @ A @ A4 @ C3 ) ) ) ) ) ).

% le_iff_add
thf(fact_318_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_319_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C4 ) ) ) ) ).

% less_eqE
thf(fact_320_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_321_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_322_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_323_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_324_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_325_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ N )
      = M ) ).

% diff_add_inverse2
thf(fact_326_diff__add__inverse,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N @ M ) @ N )
      = M ) ).

% diff_add_inverse
thf(fact_327_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_cancel2
thf(fact_328_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% Nat.diff_cancel
thf(fact_329_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R2: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ! [X4: nat] : ( R2 @ X4 @ X4 )
       => ( ! [X4: nat,Y3: nat,Z5: nat] :
              ( ( R2 @ X4 @ Y3 )
             => ( ( R2 @ Y3 @ Z5 )
               => ( R2 @ X4 @ Z5 ) ) )
         => ( ! [N3: nat] : ( R2 @ N3 @ ( suc @ N3 ) )
           => ( R2 @ M @ N ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_330_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_at_least
thf(fact_331_full__nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M4: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M4 ) @ N3 )
             => ( P @ M4 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% full_nat_induct
thf(fact_332_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N ) )
      = ( ord_less_eq @ nat @ ( suc @ N ) @ M ) ) ).

% not_less_eq_eq
thf(fact_333_Suc__n__not__le__n,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N ) @ N ) ).

% Suc_n_not_le_n
thf(fact_334_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq @ nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) ).

% le_Suc_eq
thf(fact_335_Suc__le__D,axiom,
    ! [N: nat,M5: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ M5 )
     => ? [M2: nat] :
          ( M5
          = ( suc @ M2 ) ) ) ).

% Suc_le_D
thf(fact_336_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ ( suc @ N ) ) ) ).

% le_SucI
thf(fact_337_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) ).

% le_SucE
thf(fact_338_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_leD
thf(fact_339_le__0__eq,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_340_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_341_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_342_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% less_eq_nat.simps(1)
thf(fact_343_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less_eq @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% real_arch_simple
thf(fact_344_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% diff_mult_distrib2
thf(fact_345_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% diff_mult_distrib
thf(fact_346_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( plus_plus @ nat @ M3 @ K2 ) ) ) ) ).

% nat_le_iff_add
thf(fact_347_trans__le__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_le_add2
thf(fact_348_trans__le__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_le_add1
thf(fact_349_add__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_350_add__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_le_mono
thf(fact_351_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_352_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) ).

% add_leD2
thf(fact_353_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% add_leD1
thf(fact_354_le__add2,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) ).

% le_add2
thf(fact_355_le__add1,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) ).

% le_add1
thf(fact_356_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) ).

% add_leE
thf(fact_357_mult__le__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_358_mult__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_359_mult__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ L ) ) ) ) ).

% mult_le_mono
thf(fact_360_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_361_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_362_int__ge__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_ge_induct
thf(fact_363_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% nonneg_int_cases
thf(fact_364_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_365_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X: A,Y: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ A @ X @ Y ) ) ) ) ).

% square_diff_square_factored
thf(fact_366_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_367_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_368_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_369_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_370_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_371_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_372_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_373_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_374_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_375_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_376_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_377_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_378_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_379_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_380_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_381_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_382_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_383_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_384_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_385_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_386_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_387_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_388_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_389_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_390_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_391_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_392_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_393_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_394_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_395_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_396_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_nat_0_le_iff
thf(fact_397_diff__add__0,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ N @ ( plus_plus @ nat @ N @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_398_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_399_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_mult_le_cancel1
thf(fact_400_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N2: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_401_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_402_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A,B2: A] :
          ( ( powr @ A @ X @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X @ A2 ) @ ( powr @ A @ X @ B2 ) ) ) ) ).

% powr_add
thf(fact_403_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_404_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_405_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_406_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_407_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_408_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_409_Suc__if__eq,axiom,
    ! [A: $tType,F3: nat > A,H: nat > A,G: A,N: nat] :
      ( ! [N3: nat] :
          ( ( F3 @ ( suc @ N3 ) )
          = ( H @ N3 ) )
     => ( ( ( F3 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( F3 @ N )
              = G ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( F3 @ N )
              = ( H @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_410_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X: A,Y: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ Y ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ ( minus_minus @ A @ Y @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_411_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A6: A > B,B6: A > B,X3: A] : ( minus_minus @ B @ ( A6 @ X3 ) @ ( B6 @ X3 ) ) ) ) ) ).

% minus_apply
thf(fact_412_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_413_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_414_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_415_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D3: A,Q: A > $o] :
          ( ! [X4: A,K3: A] :
              ( ( P @ X4 )
              = ( P @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D3 ) ) ) )
         => ( ! [X4: A,K3: A] :
                ( ( Q @ X4 )
                = ( Q @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D3 ) ) ) )
           => ! [X5: A,K4: A] :
                ( ( ( P @ X5 )
                  | ( Q @ X5 ) )
                = ( ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D3 ) ) )
                  | ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D3 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_416_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D3: A,Q: A > $o] :
          ( ! [X4: A,K3: A] :
              ( ( P @ X4 )
              = ( P @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D3 ) ) ) )
         => ( ! [X4: A,K3: A] :
                ( ( Q @ X4 )
                = ( Q @ ( minus_minus @ A @ X4 @ ( times_times @ A @ K3 @ D3 ) ) ) )
           => ! [X5: A,K4: A] :
                ( ( ( P @ X5 )
                  & ( Q @ X5 ) )
                = ( ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D3 ) ) )
                  & ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D3 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_417_power_Opower__eq__if,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( ^ [One: A,Times: A > A > A,P2: A,M3: nat] :
            ( if @ A
            @ ( M3
              = ( zero_zero @ nat ) )
            @ One
            @ ( Times @ P2 @ ( power2 @ A @ One @ Times @ P2 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% power.power_eq_if
thf(fact_418_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X3: A] : ( minus_minus @ A @ ( plus_plus @ A @ X3 @ X3 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_419_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_420_verit__la__generic,axiom,
    ! [A2: int,X: int] :
      ( ( ord_less_eq @ int @ A2 @ X )
      | ( A2 = X )
      | ( ord_less_eq @ int @ X @ A2 ) ) ).

% verit_la_generic
thf(fact_421_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ? [X4: nat] :
            ( ( P @ X4 )
            & ! [Y4: nat] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ Y4 @ X4 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_422_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) ).

% nat_le_linear
thf(fact_423_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) ).

% le_antisym
thf(fact_424_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% eq_imp_le
thf(fact_425_le__trans,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I @ K ) ) ) ).

% le_trans
thf(fact_426_le__refl,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ N ) ).

% le_refl
thf(fact_427_power_Opower_Ocong,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( power2 @ A ) ) ).

% power.power.cong
thf(fact_428_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_429_int__le__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I @ K )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_le_induct
thf(fact_430_int__distrib_I3_J,axiom,
    ! [Z1: int,Z2: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z2 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z2 @ W ) ) ) ).

% int_distrib(3)
thf(fact_431_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z2: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z2 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z2 ) ) ) ).

% int_distrib(4)
thf(fact_432_int__diff__cases,axiom,
    ! [Z: int] :
      ~ ! [M2: nat,N3: nat] :
          ( Z
         != ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_diff_cases
thf(fact_433_int__induct,axiom,
    ! [P: int > $o,K: int,I: int] :
      ( ( P @ K )
     => ( ! [I2: int] :
            ( ( ord_less_eq @ int @ K @ I2 )
           => ( ( P @ I2 )
             => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_induct
thf(fact_434_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A,N: nat] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( suc @ N ) )
      = ( Times2 @ A2 @ ( power2 @ A @ One2 @ Times2 @ A2 @ N ) ) ) ).

% power.power.power_Suc
thf(fact_435_power_Opower_Opower__0,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( zero_zero @ nat ) )
      = One2 ) ).

% power.power.power_0
thf(fact_436_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% order_antisym_conv
thf(fact_437_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_le_cases
thf(fact_438_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F3: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F3 @ B2 )
              = C2 )
           => ( ! [X4: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y3 )
                 => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less_eq @ B @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_439_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F3 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X4: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y3 )
                 => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_440_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_linear
thf(fact_441_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_eq_refl
thf(fact_442_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F3: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F3 @ B2 ) @ C2 )
           => ( ! [X4: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y3 )
                 => ( ord_less_eq @ C @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less_eq @ C @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_443_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F3 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X4: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y3 )
                 => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_444_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_445_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F5: A > B,G2: A > B] :
            ! [X3: A] : ( ord_less_eq @ B @ ( F5 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) ).

% le_fun_def
thf(fact_446_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F3: A > B,G: A > B] :
          ( ! [X4: A] : ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( G @ X4 ) )
         => ( ord_less_eq @ ( A > B ) @ F3 @ G ) ) ) ).

% le_funI
thf(fact_447_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F3: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F3 @ G )
         => ( ord_less_eq @ B @ ( F3 @ X ) @ ( G @ X ) ) ) ) ).

% le_funE
thf(fact_448_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F3: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F3 @ G )
         => ( ord_less_eq @ B @ ( F3 @ X ) @ ( G @ X ) ) ) ) ).

% le_funD
thf(fact_449_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_450_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_451_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_452_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_453_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A5: A,B5: A] :
              ( ( ord_less_eq @ A @ A5 @ B5 )
             => ( P @ A5 @ B5 ) )
         => ( ! [A5: A,B5: A] :
                ( ( P @ B5 @ A5 )
               => ( P @ A5 @ B5 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_454_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% order_trans
thf(fact_455_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_456_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) ).

% order_antisym
thf(fact_457_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_458_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_459_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [X3: A,Y6: A] :
              ( ( ord_less_eq @ A @ X3 @ Y6 )
              & ( ord_less_eq @ A @ Y6 @ X3 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_460_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z ) )
           => ( ( ( ord_less_eq @ A @ X @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_461_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_462_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A6: A > B,B6: A > B,X3: A] : ( minus_minus @ B @ ( A6 @ X3 ) @ ( B6 @ X3 ) ) ) ) ) ).

% fun_diff_def
thf(fact_463_conj__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P3: $o] :
      ( ( X = X6 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
         => ( P = P3 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
            & P3 ) ) ) ) ).

% conj_le_cong
thf(fact_464_imp__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P3: $o] :
      ( ( X = X6 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
         => ( P = P3 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
           => P3 ) ) ) ) ).

% imp_le_cong
thf(fact_465_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_466_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P2: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P2 @ ( power_power @ A @ P2 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_467_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A2: A,Y: A,U: A,V: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_468_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_469_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( suc @ ( nat2 @ Z ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_470_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_471_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_472_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_le_iff
thf(fact_473_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_474_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_475_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_le_iff
thf(fact_476_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: int,Z: int] :
          ( ( ( ring_1_of_int @ A @ W )
            = ( ring_1_of_int @ A @ Z ) )
          = ( W = Z ) ) ) ).

% of_int_eq_iff
thf(fact_477_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_478_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_479_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_480_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_481_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_482_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_483_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_484_power__Suc__0,axiom,
    ! [N: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_485_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M: nat] :
      ( ( ( power_power @ nat @ X @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_486_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_eq
thf(fact_487_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% Suc_mono
thf(fact_488_lessI,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( suc @ N ) ) ).

% lessI
thf(fact_489_nat__zero__less__power__iff,axiom,
    ! [X: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_490_less__nat__zero__code,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_491_neq0__conv,axiom,
    ! [N: nat] :
      ( ( ( N
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% neq0_conv
thf(fact_492_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_493_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_494_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_495_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N ) ) ) ).

% of_nat_power
thf(fact_496_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ W @ Z ) ) ) ).

% of_int_less_iff
thf(fact_497_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% nat_add_left_cancel_less
thf(fact_498_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( divide_divide @ nat @ M @ N ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_499_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_500_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X ) )
          = ( ( power_power @ int @ B2 @ W )
            = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_501_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int,N: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z @ N ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z ) @ N ) ) ) ).

% of_int_power
thf(fact_502_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_503_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) @ A2 )
      = ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_504_nat__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( semiring_1_of_nat @ int @ N ) )
      = N ) ).

% nat_int
thf(fact_505_ceiling__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_ceiling @ A @ ( ring_1_of_int @ A @ Z ) )
          = Z ) ) ).

% ceiling_of_int
thf(fact_506_round__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int] :
          ( ( archimedean_round @ A @ ( ring_1_of_int @ A @ N ) )
          = N ) ) ).

% round_of_int
thf(fact_507_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_508_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_509_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_510_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_511_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_512_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_513_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_514_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_515_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_516_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_517_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N ) )
            = ( M = N ) ) ) ) ).

% power_inject_exp
thf(fact_518_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_519_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_iff
thf(fact_520_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_521_less__Suc0,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_522_zero__less__Suc,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) ).

% zero_less_Suc
thf(fact_523_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_524_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_525_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% add_gr_0
thf(fact_526_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_527_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_528_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( zero_zero @ A ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_529_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% zero_less_diff
thf(fact_530_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% nat_0_less_mult_iff
thf(fact_531_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% mult_less_cancel2
thf(fact_532_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_533_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% of_int_le_iff
thf(fact_534_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_535_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_536_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( one_one @ A ) )
          = ( Z
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_537_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_mult
thf(fact_538_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_add
thf(fact_539_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
        & ( ord_less @ int @ W @ Z ) ) ) ).

% zless_nat_conj
thf(fact_540_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_541_of__int__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( minus_minus @ int @ W @ Z ) )
          = ( minus_minus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_diff
thf(fact_542_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_1_of_nat @ int @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_int_of_nat_eq
thf(fact_543_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z ) ) ).

% zle_add1_eq_le
thf(fact_544_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_545_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z ) ) ).

% zle_diff1_eq
thf(fact_546_ceiling__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archimedean_ceiling @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% ceiling_of_nat
thf(fact_547_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less @ nat @ X @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_548_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% power_eq_0_iff
thf(fact_549_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_550_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_551_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_552_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_553_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_less_iff
thf(fact_554_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_555_Suc__pred,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% Suc_pred
thf(fact_556_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_less_iff
thf(fact_557_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_558_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_559_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_560_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% mult_le_cancel2
thf(fact_561_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_562_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_less_ceiling
thf(fact_563_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_564_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% zero_less_nat_eq
thf(fact_565_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_566_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_567_nat__0__iff,axiom,
    ! [I: int] :
      ( ( ( nat2 @ I )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_568_nat__le__0,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_569_int__nat__eq,axiom,
    ! [Z: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = Z ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_570_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ Z ) ) ) ).

% ceiling_add_of_int
thf(fact_571_ceiling__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ Z ) ) ) ).

% ceiling_diff_of_int
thf(fact_572_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_573_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less_eq @ nat @ X @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_574_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_575_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% of_nat_0_less_iff
thf(fact_576_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_577_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ).

% one_less_nat_eq
thf(fact_578_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_579_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_580_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z ) )
            = ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_nat_nat
thf(fact_581_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_582_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_583_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X ) @ N ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_584_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat,M3: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M3 ) ) ) ) ).

% nat_less_real_le
thf(fact_585_real__nat__ceiling__ge,axiom,
    ! [X: real] : ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_586_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F5: A > B,G2: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F5 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F5 ) ) ) ) ) ).

% less_fun_def
thf(fact_587_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% le_of_int_ceiling
thf(fact_588_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z ) ) ).

% zless_nat_eq_int_zless
thf(fact_589_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% ceiling_less_cancel
thf(fact_590_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% less_ceiling_iff
thf(fact_591_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z5 ) @ X ) ) ).

% ex_of_int_less
thf(fact_592_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] : ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z5 ) ) ) ).

% ex_less_of_int
thf(fact_593_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_594_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V2: A > nat,X: A] :
      ( ! [X4: A] :
          ( ~ ( P @ X4 )
         => ? [Y4: A] :
              ( ( ord_less @ nat @ ( V2 @ Y4 ) @ ( V2 @ X4 ) )
              & ~ ( P @ Y4 ) ) )
     => ( P @ X ) ) ).

% infinite_descent_measure
thf(fact_595_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F3: A > B,P: A > $o,A2: A] :
          ( ! [X4: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F3 @ Y4 ) @ ( F3 @ X4 ) )
                 => ( P @ Y4 ) )
             => ( P @ X4 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_596_linorder__neqE__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less @ nat @ X @ Y )
       => ( ord_less @ nat @ Y @ X ) ) ) ).

% linorder_neqE_nat
thf(fact_597_infinite__descent,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M4: nat] :
              ( ( ord_less @ nat @ M4 @ N3 )
              & ~ ( P @ M4 ) ) )
     => ( P @ N ) ) ).

% infinite_descent
thf(fact_598_nat__less__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M4: nat] :
              ( ( ord_less @ nat @ M4 @ N3 )
             => ( P @ M4 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% nat_less_induct
thf(fact_599_less__irrefl__nat,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_irrefl_nat
thf(fact_600_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F3: A > B,P: A > $o,A2: A] :
          ( ! [X4: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ B @ ( F3 @ Y4 ) @ ( F3 @ X4 ) )
                 => ( P @ Y4 ) )
             => ( P @ X4 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_601_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) ).

% less_not_refl3
thf(fact_602_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) ).

% less_not_refl2
thf(fact_603_less__not__refl,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_not_refl
thf(fact_604_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M != N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) ).

% nat_neq_iff
thf(fact_605_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_606_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_divide
thf(fact_607_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_mono_iff
thf(fact_608_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N6: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N6 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N6 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_609_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less @ nat @ M @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_610_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_less_power
thf(fact_611_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_one_over
thf(fact_612_nat__power__less__imp__less,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% nat_power_less_imp_less
thf(fact_613_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N @ N5 )
           => ( ord_less @ A @ ( F3 @ N ) @ ( F3 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_614_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,N: nat,M: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F3 @ N ) @ ( F3 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_615_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N2: int,M3: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_616_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
         => ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_imp_less
thf(fact_617_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_618_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_619_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_pos
thf(fact_620_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N6: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N6 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N6 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_621_nat__power__eq,axiom,
    ! [Z: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( power_power @ int @ Z @ N ) )
        = ( power_power @ nat @ ( nat2 @ Z ) @ N ) ) ) ).

% nat_power_eq
thf(fact_622_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_623_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ P4 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ Q2 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_624_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_less_eq_zless
thf(fact_625_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,X: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ X ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_626_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) @ P4 ) ) ) ).

% ceiling_divide_lower
thf(fact_627_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_628_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z ) ) ) ) ).

% ceiling_unique
thf(fact_629_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_630_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I3: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I3 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I3 ) ) )
               => ( P @ I3 ) ) ) ) ) ).

% ceiling_split
thf(fact_631_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_632_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_633_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ R @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_634_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_635_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% ceiling_le_iff
thf(fact_636_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_637_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_638_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_639_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_640_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_641_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_642_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_643_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N @ K ) ) ) ).

% power_gt_expt
thf(fact_644_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( divide_divide @ nat @ M @ N ) ) ) ).

% nat_mult_div_cancel1
thf(fact_645_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z5 ) ) ) ).

% ex_le_of_int
thf(fact_646_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_647_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_648_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_commutes
thf(fact_649_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_650_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_651_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B7: B,A7: B] :
          ( ( ~ ( ord_less_eq @ B @ B7 @ A7 ) )
          = ( ord_less @ B @ A7 @ B7 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_652_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z5 )
         => ~ ( ord_less_eq @ A @ T2 @ X5 ) ) ) ).

% minf(8)
thf(fact_653_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z5 )
         => ( ord_less_eq @ A @ X5 @ T2 ) ) ) ).

% minf(6)
thf(fact_654_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z5 @ X5 )
         => ( ord_less_eq @ A @ T2 @ X5 ) ) ) ).

% pinf(8)
thf(fact_655_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z5 @ X5 )
         => ~ ( ord_less_eq @ A @ X5 @ T2 ) ) ) ).

% pinf(6)
thf(fact_656_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ~ ( ord_less @ A @ X @ Y ) ) ) ).

% leD
thf(fact_657_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% leI
thf(fact_658_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_659_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% antisym_conv1
thf(fact_660_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv2
thf(fact_661_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,Y: A] :
          ( ! [X4: A] :
              ( ( ord_less @ A @ Z @ X4 )
             => ( ord_less_eq @ A @ Y @ X4 ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) ).

% dense_ge
thf(fact_662_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y: A,Z: A] :
          ( ! [X4: A] :
              ( ( ord_less @ A @ X4 @ Y )
             => ( ord_less_eq @ A @ X4 @ Z ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) ).

% dense_le
thf(fact_663_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X3: A,Y6: A] :
              ( ( ord_less_eq @ A @ X3 @ Y6 )
              & ~ ( ord_less_eq @ A @ Y6 @ X3 ) ) ) ) ) ).

% less_le_not_le
thf(fact_664_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% not_le_imp_less
thf(fact_665_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less @ A @ A4 @ B3 )
              | ( A4 = B3 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_666_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ( A4 != B3 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_667_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_668_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_669_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ~ ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_670_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ Z @ W2 )
               => ( ( ord_less @ A @ W2 @ X )
                 => ( ord_less_eq @ A @ Y @ W2 ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% dense_ge_bounded
thf(fact_671_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ X @ W2 )
               => ( ( ord_less @ A @ W2 @ Y )
                 => ( ord_less_eq @ A @ W2 @ Z ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% dense_le_bounded
thf(fact_672_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less @ A @ B3 @ A4 )
              | ( A4 = B3 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_673_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ( A4 != B3 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_674_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_675_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_676_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ~ ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_677_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_678_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_679_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y6: A] :
              ( ( ord_less @ A @ X3 @ Y6 )
              | ( X3 = Y6 ) ) ) ) ) ).

% order_le_less
thf(fact_680_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X3: A,Y6: A] :
              ( ( ord_less_eq @ A @ X3 @ Y6 )
              & ( X3 != Y6 ) ) ) ) ) ).

% order_less_le
thf(fact_681_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_not_le
thf(fact_682_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_not_less
thf(fact_683_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_less_imp_le
thf(fact_684_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_685_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_686_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_le_less_trans
thf(fact_687_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_less_le_trans
thf(fact_688_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F3 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X4: B,Y3: B] :
                  ( ( ord_less @ B @ X4 @ Y3 )
                 => ( ord_less @ A @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_689_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F3: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F3 @ B2 ) @ C2 )
           => ( ! [X4: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y3 )
                 => ( ord_less_eq @ C @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less @ C @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_690_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F3: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F3 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X4: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y3 )
                 => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_691_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F3: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F3 @ B2 ) @ C2 )
           => ( ! [X4: A,Y3: A] :
                  ( ( ord_less @ A @ X4 @ Y3 )
                 => ( ord_less @ C @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
             => ( ord_less @ C @ ( F3 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_692_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_693_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ X @ Y )
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_694_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_695_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_696_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_697_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_698_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_699_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E2: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
                & ( ord_less @ A @ E2 @ D1 )
                & ( ord_less @ A @ E2 @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_700_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_701_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_702_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_703_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_704_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_705_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_706_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_707_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_708_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_709_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_710_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_711_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_712_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_713_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N ) ) ) ).

% power_mult
thf(fact_714_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_715_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_716_strict__inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I2: nat] :
            ( ( J
              = ( suc @ I2 ) )
           => ( P @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ J )
             => ( ( P @ ( suc @ I2 ) )
               => ( P @ I2 ) ) )
         => ( P @ I ) ) ) ) ).

% strict_inc_induct
thf(fact_717_less__Suc__induct,axiom,
    ! [I: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I2: nat] : ( P @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J2: nat,K3: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K3 )
               => ( ( P @ I2 @ J2 )
                 => ( ( P @ J2 @ K3 )
                   => ( P @ I2 @ K3 ) ) ) ) )
         => ( P @ I @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_718_less__trans__Suc,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_719_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_SucD
thf(fact_720_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) ).

% less_antisym
thf(fact_721_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N ) @ M )
      = ( ? [M6: nat] :
            ( ( M
              = ( suc @ M6 ) )
            & ( ord_less @ nat @ N @ M6 ) ) ) ) ).

% Suc_less_eq2
thf(fact_722_All__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N ) )
           => ( P @ I3 ) ) )
      = ( ( P @ N )
        & ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N )
           => ( P @ I3 ) ) ) ) ).

% All_less_Suc
thf(fact_723_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N ) )
      = ( ord_less @ nat @ N @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_724_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( M = N ) ) ) ).

% less_Suc_eq
thf(fact_725_Ex__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N ) )
            & ( P @ I3 ) ) )
      = ( ( P @ N )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N )
            & ( P @ I3 ) ) ) ) ).

% Ex_less_Suc
thf(fact_726_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% less_SucI
thf(fact_727_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( M = N ) ) ) ).

% less_SucE
thf(fact_728_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less @ nat @ ( suc @ M ) @ N ) ) ) ).

% Suc_lessI
thf(fact_729_Suc__lessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_730_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_lessD
thf(fact_731_Nat_OlessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ I @ K )
     => ( ( K
         != ( suc @ I ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_732_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P: A > $o,X: A] :
      ( ! [X4: A] :
          ( ( ( V2 @ X4 )
            = ( zero_zero @ nat ) )
         => ( P @ X4 ) )
     => ( ! [X4: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X4 ) )
           => ( ~ ( P @ X4 )
             => ? [Y4: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y4 ) @ ( V2 @ X4 ) )
                  & ~ ( P @ Y4 ) ) ) )
       => ( P @ X ) ) ) ).

% infinite_descent0_measure
thf(fact_733_infinite__descent0,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M4: nat] :
                  ( ( ord_less @ nat @ M4 @ N3 )
                  & ~ ( P @ M4 ) ) ) )
       => ( P @ N ) ) ) ).

% infinite_descent0
thf(fact_734_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_735_less__zeroE,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_736_not__less0,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_737_not__gr0,axiom,
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_738_gr0I,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% gr0I
thf(fact_739_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_740_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M2 ) @ X ) @ C2 ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_741_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_742_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M3 @ N2 )
          & ( M3 != N2 ) ) ) ) ).

% nat_less_le
thf(fact_743_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_imp_le_nat
thf(fact_744_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( ( ord_less @ nat @ M3 @ N2 )
          | ( M3 = N2 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_745_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_or_eq_imp_le
thf(fact_746_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% le_neq_implies_less
thf(fact_747_less__mono__imp__le__mono,axiom,
    ! [F3: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less @ nat @ I2 @ J2 )
         => ( ord_less @ nat @ ( F3 @ I2 ) @ ( F3 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ord_less_eq @ nat @ ( F3 @ I ) @ ( F3 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_748_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N2: nat,M3: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_749_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M @ L )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% less_add_eq_less
thf(fact_750_trans__less__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_less_add2
thf(fact_751_trans__less__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_less_add1
thf(fact_752_add__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_753_not__add__less2,axiom,
    ! [J: nat,I: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I ) @ I ) ).

% not_add_less2
thf(fact_754_not__add__less1,axiom,
    ! [I: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ I ) ).

% not_add_less1
thf(fact_755_add__less__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_less_mono
thf(fact_756_add__lessD1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
     => ( ord_less @ nat @ I @ K ) ) ).

% add_lessD1
thf(fact_757_int__less__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_less_induct
thf(fact_758_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N ) @ K ) ) ).

% less_imp_diff_less
thf(fact_759_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ord_less @ nat @ M @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_760_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( plus_plus @ A @ R @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_761_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( one_one @ A ) ) @ R ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_762_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_763_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_764_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N )
                  = ( power_power @ A @ B2 @ N ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_765_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_766_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_767_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_768_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_diff
thf(fact_769_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z5 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_770_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X4: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X4 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X4 @ ( one_one @ int ) ) ) )
          & ! [Y4: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y4 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y4 @ ( one_one @ int ) ) ) ) )
             => ( Y4 = X4 ) ) ) ) ).

% floor_exists1
thf(fact_771_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% nat_le_eq_zle
thf(fact_772_split__nat,axiom,
    ! [P: nat > $o,I: int] :
      ( ( P @ ( nat2 @ I ) )
      = ( ! [N2: nat] :
            ( ( I
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ( P @ N2 ) )
        & ( ( ord_less @ int @ I @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_773_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X )
              = ( plus_plus @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_774_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_775_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_776_zmult__zless__mono2__lemma,axiom,
    ! [I: int,J: int,K: nat] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_777_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E ) ) ) ).

% nat_approx_posE
thf(fact_778_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_779_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y ) @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% ceiling_mono
thf(fact_780_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_781_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_power
thf(fact_782_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono
thf(fact_783_nat__mono,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ X @ Y )
     => ( ord_less_eq @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ).

% nat_mono
thf(fact_784_ex__nat,axiom,
    ( ( ^ [P5: nat > $o] :
        ? [X7: nat] : ( P5 @ X7 ) )
    = ( ^ [P6: nat > $o] :
        ? [X3: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
          & ( P6 @ ( nat2 @ X3 ) ) ) ) ) ).

% ex_nat
thf(fact_785_all__nat,axiom,
    ( ( ^ [P5: nat > $o] :
        ! [X7: nat] : ( P5 @ X7 ) )
    = ( ^ [P6: nat > $o] :
        ! [X3: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
         => ( P6 @ ( nat2 @ X3 ) ) ) ) ) ).

% all_nat
thf(fact_786_eq__nat__nat__iff,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( ( nat2 @ Z )
            = ( nat2 @ Z7 ) )
          = ( Z = Z7 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_787_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% one_le_power
thf(fact_788_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_789_int__minus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_790_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_791_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_Suc
thf(fact_792_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_793_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_794_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_795_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_796_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_797_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_798_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_799_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_800_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_801_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_802_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_803_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_804_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_805_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_806_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_807_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_808_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_809_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_810_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_811_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_812_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_813_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_814_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_815_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_816_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_817_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_818_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_819_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_820_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X @ Y ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_821_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_822_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_823_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C4 ) )
               => ( C4
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_824_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_825_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_add
thf(fact_826_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_827_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_828_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_829_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_830_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_831_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_832_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_833_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_834_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F3: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F3 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F3 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_835_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z2: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z2 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z2 ) ) ) ) ).

% powr_diff
thf(fact_836_Ex__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N ) )
            & ( P @ I3 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N )
            & ( P @ ( suc @ I3 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_837_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
      = ( ? [M3: nat] :
            ( N
            = ( suc @ M3 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_838_All__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( suc @ N ) )
           => ( P @ I3 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ N )
           => ( P @ ( suc @ I3 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_839_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ? [M2: nat] :
          ( N
          = ( suc @ M2 ) ) ) ).

% gr0_implies_Suc
thf(fact_840_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less @ nat @ J3 @ N ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_841_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_leI
thf(fact_842_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_eq
thf(fact_843_dec__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ I )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ N3 )
                 => ( P @ ( suc @ N3 ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_844_inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ J )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ ( suc @ N3 ) )
                 => ( P @ N3 ) ) ) )
         => ( P @ I ) ) ) ) ).

% inc_induct
thf(fact_845_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_lessD
thf(fact_846_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% le_less_Suc_eq
thf(fact_847_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% less_Suc_eq_le
thf(fact_848_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat] : ( ord_less_eq @ nat @ ( suc @ N2 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_849_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% le_imp_less_Suc
thf(fact_850_ex__least__nat__le,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K3 )
               => ~ ( P @ I4 ) )
            & ( P @ K3 ) ) ) ) ).

% ex_least_nat_le
thf(fact_851_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ? [K3: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K3 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_852_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M3 @ K2 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_853_less__add__Suc2,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ M @ I ) ) ) ).

% less_add_Suc2
thf(fact_854_less__add__Suc1,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ I @ M ) ) ) ).

% less_add_Suc1
thf(fact_855_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ~ ! [Q3: nat] :
            ( N
           != ( suc @ ( plus_plus @ nat @ M @ Q3 ) ) ) ) ).

% less_natE
thf(fact_856_less__imp__add__positive,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ? [K3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K3 )
          & ( ( plus_plus @ nat @ I @ K3 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_857_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N ) ) )
        = ( minus_minus @ nat @ M @ N ) ) ) ).

% Suc_diff_Suc
thf(fact_858_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_859_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ) ) ).

% diff_less
thf(fact_860_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_mult_less_cancel1
thf(fact_861_mono__nat__linear__lb,axiom,
    ! [F3: nat > nat,M: nat,K: nat] :
      ( ! [M2: nat,N3: nat] :
          ( ( ord_less @ nat @ M2 @ N3 )
         => ( ord_less @ nat @ ( F3 @ M2 ) @ ( F3 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F3 @ M ) @ K ) @ ( F3 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_862_mult__less__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_863_mult__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_864_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N ) )
        = ( M = N ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_865_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel1
thf(fact_866_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_867_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less @ nat @ M @ N ) ) ) ) ).

% less_diff_iff
thf(fact_868_less__diff__conv,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_869_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( plus_plus @ nat @ N @ ( minus_minus @ nat @ M @ N ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_870_zmult__zless__mono2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_871_plusinfinity,axiom,
    ! [D2: int,P3: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X4: int,K3: int] :
            ( ( P3 @ X4 )
            = ( P3 @ ( minus_minus @ int @ X4 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z3: int] :
            ! [X4: int] :
              ( ( ord_less @ int @ Z3 @ X4 )
             => ( ( P @ X4 )
                = ( P3 @ X4 ) ) )
         => ( ? [X_1: int] : ( P3 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% plusinfinity
thf(fact_872_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X4: int,K3: int] :
            ( ( P1 @ X4 )
            = ( P1 @ ( minus_minus @ int @ X4 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z3: int] :
            ! [X4: int] :
              ( ( ord_less @ int @ X4 @ Z3 )
             => ( ( P @ X4 )
                = ( P1 @ X4 ) ) )
         => ( ? [X_1: int] : ( P1 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% minusinfinity
thf(fact_873_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z )
        | ( W = Z ) ) ) ).

% zless_add1_eq
thf(fact_874_int__gr__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_gr_induct
thf(fact_875_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% ceiling_ge_round
thf(fact_876_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) ) ) ) ).

% ceiling_add_le
thf(fact_877_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_878_nat__diff__distrib,axiom,
    ! [Z7: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
     => ( ( ord_less_eq @ int @ Z7 @ Z )
       => ( ( nat2 @ ( minus_minus @ int @ Z @ Z7 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_879_nat__diff__distrib_H,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( minus_minus @ int @ X @ Y ) )
          = ( minus_minus @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_880_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N ) )
            = ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_881_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_882_nat__le__iff,axiom,
    ! [X: int,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X ) @ N )
      = ( ord_less_eq @ int @ X @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_le_iff
thf(fact_883_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_884_nat__0__le,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
        = Z ) ) ).

% nat_0_le
thf(fact_885_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z )
      = ( ( M
          = ( nat2 @ Z ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% int_eq_iff
thf(fact_886_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N6: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N6 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N6 ) ) ) ) ) ).

% power_increasing
thf(fact_887_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_888_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_889_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_890_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_891_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_892_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_893_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_894_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_895_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_896_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_897_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_898_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_899_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_900_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_901_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_902_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_903_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_904_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_905_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_906_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_907_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_908_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_909_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_910_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_911_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_912_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_913_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_914_nat__one__le__power,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I @ N ) ) ) ).

% nat_one_le_power
thf(fact_915_ex__least__nat__less,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less @ nat @ K3 @ N )
            & ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ K3 )
               => ~ ( P @ I4 ) )
            & ( P @ ( suc @ K3 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_916_diff__Suc__less,axiom,
    ! [N: nat,I: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N @ ( suc @ I ) ) @ N ) ) ).

% diff_Suc_less
thf(fact_917_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ N @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_918_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ) ).

% n_less_m_mult_n
thf(fact_919_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) ) ) ) ).

% one_less_mult
thf(fact_920_nat__induct__non__zero,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_921_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel1
thf(fact_922_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D4: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D4 ) )
                & ~ ( P @ D4 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_923_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D4: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D4 ) )
           => ( P @ D4 ) ) ) ) ).

% nat_diff_split
thf(fact_924_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_925_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% int_one_le_iff_zero_less
thf(fact_926_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_927_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X4: int] :
            ( ( P @ X4 )
           => ( P @ ( minus_minus @ int @ X4 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X5: int] :
              ( ( P @ X5 )
             => ( P @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_928_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N2: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_929_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_930_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_931_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ Z )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z ) ) ).

% zless_imp_add1_zle
thf(fact_932_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z )
      = ( ord_less @ int @ W @ Z ) ) ).

% add1_zle_eq
thf(fact_933_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N2: nat,P6: A > A > $o,X3: A,Y6: A] :
          ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = X3 )
            & ( ( F5 @ N2 )
              = Y6 )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ N2 )
               => ( P6 @ ( F5 @ I3 ) @ ( F5 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_934_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_nonneg
thf(fact_935_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_936_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_937_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_938_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% le_nat_iff
thf(fact_939_nat__add__distrib,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( nat2 @ ( plus_plus @ int @ Z @ Z7 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_940_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N6: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N6 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N6 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_941_nat__mult__distrib,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ).

% nat_mult_distrib
thf(fact_942_Suc__as__int,axiom,
    ( suc
    = ( ^ [A4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_943_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_944_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_945_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_946_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_947_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_948_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_949_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_950_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_951_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_952_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_953_nat__less__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_less_add_iff2
thf(fact_954_nat__less__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_less_add_iff1
thf(fact_955_le__imp__0__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ).

% le_imp_0_less
thf(fact_956_zdiff__int__split,axiom,
    ! [P: int > $o,X: nat,Y: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X @ Y ) ) )
      = ( ( ( ord_less_eq @ nat @ Y @ X )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X ) @ ( semiring_1_of_nat @ int @ Y ) ) ) )
        & ( ( ord_less @ nat @ X @ Y )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_957_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X4: int] :
            ( ( P @ X4 )
           => ( P @ ( plus_plus @ int @ X4 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X5: int] :
              ( ( P @ X5 )
             => ( P @ ( plus_plus @ int @ X5 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_958_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_959_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_960_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_961_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_962_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_963_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_964_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_965_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_966_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_967_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_968_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_969_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_970_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_971_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_972_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_973_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_974_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_975_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_976_ln__inj__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( ln_ln @ real @ X )
            = ( ln_ln @ real @ Y ) )
          = ( X = Y ) ) ) ) ).

% ln_inj_iff
thf(fact_977_powr__gt__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ A2 ) )
      = ( ( X
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_978_ln__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_979_powr__nonneg__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_980_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_981_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_982_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_983_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_984_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_985_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_986_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_987_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_988_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_989_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_990_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_991_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_992_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_993_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_994_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_995_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_996_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_997_ln__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_998_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_999_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_iff
thf(fact_1000_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_1001_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_1002_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% powr_one_gt_zero_iff
thf(fact_1003_powr__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) ).

% powr_one
thf(fact_1004_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_1005_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_1006_div__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_1007_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_1008_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_1009_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_1010_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_1011_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_1012_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_1013_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_1014_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_1015_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_1016_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_1017_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_1018_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_iff
thf(fact_1019_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N @ M ) @ N )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_1020_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N ) @ N )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_1021_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N2: int,M3: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M3 ) ) ) ) ).

% int_less_real_le
thf(fact_1022_powr__mult__base,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y ) ) ) ) ).

% powr_mult_base
thf(fact_1023_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self
thf(fact_1024_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_1025_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_1026_powr__less__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_1027_ln__le__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( minus_minus @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_1028_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( minus_minus @ real @ X @ ( one_one @ real ) ) )
       => ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_1029_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ Y )
           => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_1030_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X ) ) ) ) ).

% ln_powr_bound2
thf(fact_1031_powr__ge__pzero,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ Y ) ) ).

% powr_ge_pzero
thf(fact_1032_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_1033_powr__mono2_H,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_1034_powr__divide,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( divide_divide @ real @ X @ Y ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_1035_powr__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_1036_ln__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_ge_zero
thf(fact_1037_ln__diff__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X @ Y ) @ Y ) ) ) ) ).

% ln_diff_le
thf(fact_1038_powr__mult,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( times_times @ real @ X @ Y ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_1039_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_mono
thf(fact_1040_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_1041_ln__bound,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_bound
thf(fact_1042_reals__Archimedean3,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ! [Y4: real] :
        ? [N3: nat] : ( ord_less @ real @ Y4 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X ) ) ) ).

% reals_Archimedean3
thf(fact_1043_ln__div,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X @ Y ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_div
thf(fact_1044_real__of__nat__div3,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_1045_real__of__nat__div2,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) ) ).

% real_of_nat_div2
thf(fact_1046_real__of__nat__div4,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) ) ).

% real_of_nat_div4
thf(fact_1047_complete__real,axiom,
    ! [S2: set @ real] :
      ( ? [X5: real] : ( member @ real @ X5 @ S2 )
     => ( ? [Z3: real] :
          ! [X4: real] :
            ( ( member @ real @ X4 @ S2 )
           => ( ord_less_eq @ real @ X4 @ Z3 ) )
       => ? [Y3: real] :
            ( ! [X5: real] :
                ( ( member @ real @ X5 @ S2 )
               => ( ord_less_eq @ real @ X5 @ Y3 ) )
            & ! [Z3: real] :
                ( ! [X4: real] :
                    ( ( member @ real @ X4 @ S2 )
                   => ( ord_less_eq @ real @ X4 @ Z3 ) )
               => ( ord_less_eq @ real @ Y3 @ Z3 ) ) ) ) ) ).

% complete_real
thf(fact_1048_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X3: real,Y6: real] :
          ( ( ord_less @ real @ X3 @ Y6 )
          | ( X3 = Y6 ) ) ) ) ).

% less_eq_real_def
thf(fact_1049_real__of__int__div4,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) ) ).

% real_of_int_div4
thf(fact_1050_real__arch__pow,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ? [N3: nat] : ( ord_less @ real @ Y @ ( power_power @ real @ X @ N3 ) ) ) ).

% real_arch_pow
thf(fact_1051_real__of__int__div2,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) ) ).

% real_of_int_div2
thf(fact_1052_real__of__int__div3,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_1053_real__arch__pow__inv,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X @ N3 ) @ Y ) ) ) ).

% real_arch_pow_inv
thf(fact_1054_powr__inj,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y ) )
          = ( X = Y ) ) ) ) ).

% powr_inj
thf(fact_1055_ln__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_gt_zero
thf(fact_1056_ln__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_realpow
thf(fact_1057_gr__one__powr,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X @ Y ) ) ) ) ).

% gr_one_powr
thf(fact_1058_ln__less__self,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_less_self
thf(fact_1059_ln__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_1060_powr__non__neg,axiom,
    ! [A2: real,X: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_1061_powr__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
        = ( power_power @ real @ X @ N ) ) ) ).

% powr_realpow
thf(fact_1062_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_1063_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_1064_powr__less__mono2__neg,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_1065_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_1066_ln__mult,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( times_times @ real @ X @ Y ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_mult
thf(fact_1067_powr__powr,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ X @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_1068_ln__powr,axiom,
    ! [X: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_powr
thf(fact_1069_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N @ K ) ) ) ).

% div_le_mono
thf(fact_1070_div__le__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ).

% div_le_dividend
thf(fact_1071_div__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) ).

% div_mult2_eq
thf(fact_1072_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_1073_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W ) @ ( times_times @ A @ Y @ Z ) ) ) ) ).

% divide_divide_times_eq
thf(fact_1074_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_1075_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_1076_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1077_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_1078_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_1079_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ ( divide_divide @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_div_le_mono
thf(fact_1080_less__mult__imp__div__less,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I @ N ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ I ) ) ).

% less_mult_imp_div_less
thf(fact_1081_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_1082_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_1083_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_1084_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_1085_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_1086_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_1087_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_1088_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_1089_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_1090_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_1091_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_neg_neg
thf(fact_1092_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_1093_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_1094_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_pos_pos
thf(fact_1095_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_1096_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_1097_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_1098_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_1099_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_1100_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_1101_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_1102_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_1103_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_1104_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_1105_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_1106_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y )
                = ( divide_divide @ A @ W @ Z ) )
              = ( ( times_times @ A @ X @ Z )
                = ( times_times @ A @ W @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_1107_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_1108_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_1109_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_1110_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ N @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% div_greater_zero_iff
thf(fact_1111_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q2 ) @ N )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N @ Q2 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_1112_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N )
          = M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1113_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1114_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_1115_nat__div__distrib_H,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib'
thf(fact_1116_nat__div__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib
thf(fact_1117_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ X @ ( plus_plus @ A @ Y @ E2 ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_epsilon
thf(fact_1118_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_1119_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_1120_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_1121_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_1122_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_1123_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_1124_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_1125_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_1126_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_1127_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_1128_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z @ Y ) @ X )
           => ( ord_less @ A @ Z @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_1129_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ Z ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_1130_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_1131_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_1132_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_1133_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_1134_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_1135_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_1136_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1137_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1138_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_1139_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_1140_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_1141_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ Z )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_1142_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z @ ( divide_divide @ A @ X @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_1143_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y @ Z ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ Y ) @ Z ) ) ) ) ).

% add_divide_eq_iff
thf(fact_1144_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% divide_add_eq_iff
thf(fact_1145_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1146_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1147_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1148_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y @ Z ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ Y ) @ Z ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1149_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1150_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1151_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1152_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1153_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M3 @ N2 )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ) ).

% div_if
thf(fact_1154_div__nat__eqI,axiom,
    ! [N: nat,Q2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q2 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q2 ) ) )
       => ( ( divide_divide @ nat @ M @ N )
          = Q2 ) ) ) ).

% div_nat_eqI
thf(fact_1155_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N @ Q2 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q2 ) @ N ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_1156_split__div,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I3: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I3 ) @ J3 ) )
               => ( P @ I3 ) ) ) ) ) ) ).

% split_div
thf(fact_1157_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% dividend_less_div_times
thf(fact_1158_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_1159_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z5 )
             => ( ( ord_less @ A @ Z5 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z5 @ X ) @ Y ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_1160_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1161_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1162_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1163_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1164_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_1165_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_1166_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_1167_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ Z ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_1168_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ Y ) @ X )
           => ( ord_less_eq @ A @ Z @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_1169_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_1170_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1171_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1172_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1173_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1174_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% le_div_geq
thf(fact_1175_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_1176_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
           => ( ( ord_less_eq @ A @ R @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R @ ( minus_minus @ A @ V @ U ) ) @ S ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1177_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1178_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X @ X ) ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_1179_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1180_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1181_linear__plus__1__le__power,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) @ N ) ) ) ).

% linear_plus_1_le_power
thf(fact_1182_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( ord_less @ int @ B2 @ R3 )
           => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_1183_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less @ int @ R @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_1184_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B7: int,Q5: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B7 @ Q5 ) @ R3 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B7 @ Q5 ) @ R3 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B7 )
             => ( ( ord_less_eq @ int @ B7 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_1185_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B7: int,Q5: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B7 @ Q5 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B7 @ Q5 ) @ R3 ) )
       => ( ( ord_less @ int @ R3 @ B7 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B7 )
             => ( ( ord_less_eq @ int @ B7 @ B2 )
               => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_1186_q__pos__lemma,axiom,
    ! [B7: int,Q5: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B7 @ Q5 ) @ R3 ) )
     => ( ( ord_less @ int @ R3 @ B7 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B7 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_1187_real__divide__square__eq,axiom,
    ! [R: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ R ) )
      = ( divide_divide @ real @ A2 @ R ) ) ).

% real_divide_square_eq
thf(fact_1188_powr__powr__swap,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ ( powr @ real @ X @ B2 ) @ A2 ) ) ).

% powr_powr_swap
thf(fact_1189_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_1190_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_1191_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_1192_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_1193_realpow__pos__nth2,axiom,
    ! [A2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
          & ( ( power_power @ real @ R4 @ ( suc @ N ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_1194_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A5: real,B5: real,C4: real] :
            ( ( P @ A5 @ B5 )
           => ( ( P @ B5 @ C4 )
             => ( ( ord_less_eq @ real @ A5 @ B5 )
               => ( ( ord_less_eq @ real @ B5 @ C4 )
                 => ( P @ A5 @ C4 ) ) ) ) )
       => ( ! [X4: real] :
              ( ( ord_less_eq @ real @ A2 @ X4 )
             => ( ( ord_less_eq @ real @ X4 @ B2 )
               => ? [D5: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                    & ! [A5: real,B5: real] :
                        ( ( ( ord_less_eq @ real @ A5 @ X4 )
                          & ( ord_less_eq @ real @ X4 @ B5 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B5 @ A5 ) @ D5 ) )
                       => ( P @ A5 @ B5 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1195_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_1196_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_1197_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_1198_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I @ K ) )
        = ( ord_less_eq @ int @ K @ I ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_1199_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_1200_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_1201_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_1202_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_1203_zdiv__mono2__neg,axiom,
    ! [A2: int,B7: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B7 )
       => ( ( ord_less_eq @ int @ B7 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B7 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_1204_zdiv__mono1__neg,axiom,
    ! [A2: int,A7: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A7 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A7 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_1205_zdiv__eq__0__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( divide_divide @ int @ I @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_1206_zdiv__mono2,axiom,
    ! [A2: int,B7: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B7 )
       => ( ( ord_less_eq @ int @ B7 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B7 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_1207_zdiv__mono1,axiom,
    ! [A2: int,A7: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A7 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A7 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_1208_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1209_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_1210_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_1211_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_1212_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_1213_realpow__pos__nth__unique,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X4 )
            & ( ( power_power @ real @ X4 @ N )
              = A2 )
            & ! [Y4: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ( power_power @ real @ Y4 @ N )
                    = A2 ) )
               => ( Y4 = X4 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_1214_realpow__pos__nth,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ( ( power_power @ real @ R4 @ N )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_1215_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_geq
thf(fact_1216_split__zdiv,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 ) ) ) ) ) ).

% split_zdiv
thf(fact_1217_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_neg_eq
thf(fact_1218_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_pos_eq
thf(fact_1219_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_1220_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_1221_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_1222_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ Z ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_1223_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ X ) @ ( times_times @ A @ Z @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_1224_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X )
            & ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_1225_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_1226_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_1227_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less @ real @ X @ Y ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_1228_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_1229_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ A2 @ X ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_1230_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_1231_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_1232_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_1233_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_1234_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ A2 @ X ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_1235_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_1236_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_1237_log__powr__cancel,axiom,
    ! [A2: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y ) )
          = Y ) ) ) ).

% log_powr_cancel
thf(fact_1238_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X ) )
            = X ) ) ) ) ).

% powr_log_cancel
thf(fact_1239_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_1240_log__def,axiom,
    ( log
    = ( ^ [A4: real,X3: real] : ( divide_divide @ real @ ( ln_ln @ real @ X3 ) @ ( ln_ln @ real @ A4 ) ) ) ) ).

% log_def
thf(fact_1241_log__base__powr,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_1242_log__powr,axiom,
    ! [X: real,B2: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( log @ B2 @ X ) ) ) ) ).

% log_powr
thf(fact_1243_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X )
          = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_1244_less__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% less_log_iff
thf(fact_1245_log__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_less_iff
thf(fact_1246_less__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% less_powr_iff
thf(fact_1247_powr__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_less_iff
thf(fact_1248_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_1249_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_1250_log__mult,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( times_times @ real @ X @ Y ) )
              = ( plus_plus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_mult
thf(fact_1251_powr__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_le_iff
thf(fact_1252_le__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% le_powr_iff
thf(fact_1253_log__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_le_iff
thf(fact_1254_le__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% le_log_iff
thf(fact_1255_log__divide,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( divide_divide @ real @ X @ Y ) )
              = ( minus_minus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_divide
thf(fact_1256_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_1257_log__base__pow,axiom,
    ! [A2: real,N: nat,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log_base_pow
thf(fact_1258_log__nat__power,axiom,
    ! [X: real,B2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ B2 @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ).

% log_nat_power
thf(fact_1259_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_less
thf(fact_1260_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( ( log @ A2 @ X )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_1261_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_1262_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_1263_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_1264_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_le
thf(fact_1265_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ Z ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_1266_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F3: A > nat,N: nat] :
      ( ( P @ K )
     => ( ! [X4: A] :
            ( ( P @ X4 )
           => ? [Y4: A] :
                ( ( P @ Y4 )
                & ~ ( ord_less_eq @ nat @ ( F3 @ Y4 ) @ ( F3 @ X4 ) ) ) )
       => ? [Y3: A] :
            ( ( P @ Y3 )
            & ~ ( ord_less @ nat @ ( F3 @ Y3 ) @ ( plus_plus @ nat @ ( F3 @ K ) @ N ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_1267_powr__int,axiom,
    ! [X: real,I: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I ) )
            = ( power_power @ real @ X @ ( nat2 @ I ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ I ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_1268_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X )
            & ( ord_less @ real @ X @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_1269_nat0__intermed__int__val,axiom,
    ! [N: nat,F3: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F3 @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) ) @ ( F3 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F3 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F3 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F3 @ I2 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_1270_root__powr__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ X )
          = ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_1271_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_1272_eq__diff__eq_H,axiom,
    ! [X: real,Y: real,Z: real] :
      ( ( X
        = ( minus_minus @ real @ Y @ Z ) )
      = ( Y
        = ( plus_plus @ real @ X @ Z ) ) ) ).

% eq_diff_eq'
thf(fact_1273_nat__descend__induct,axiom,
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K3: nat] :
          ( ( ord_less @ nat @ N @ K3 )
         => ( P @ K3 ) )
     => ( ! [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ! [I4: nat] :
                  ( ( ord_less @ nat @ K3 @ I4 )
                 => ( P @ I4 ) )
             => ( P @ K3 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_1274_verit__minus__simplify_I4_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( uminus_uminus @ B @ ( uminus_uminus @ B @ B2 ) )
          = B2 ) ) ).

% verit_minus_simplify(4)
thf(fact_1275_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1276_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1277_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_1278_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_abs
thf(fact_1279_arsinh__minus__real,axiom,
    ! [X: real] :
      ( ( arsinh @ real @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( arsinh @ real @ X ) ) ) ).

% arsinh_minus_real
thf(fact_1280_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1281_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1282_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1283_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1284_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1285_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1286_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1287_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1288_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1289_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1290_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1291_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1292_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1293_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_1294_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_1295_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_1296_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_1297_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_1298_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_1299_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_1300_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_1301_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_1302_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus
thf(fact_1303_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% abs_of_nat
thf(fact_1304_real__root__zero,axiom,
    ! [N: nat] :
      ( ( root @ N @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_1305_floor__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archim6421214686448440834_floor @ A @ ( ring_1_of_int @ A @ Z ) )
          = Z ) ) ).

% floor_of_int
thf(fact_1306_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1307_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1308_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1309_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1310_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1311_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1312_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1313_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1314_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1315_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1316_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_1317_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_1318_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1
thf(fact_1319_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1_right
thf(fact_1320_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_1321_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_1322_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_1323_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1324_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1325_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_1326_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_1327_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_1328_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_1329_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% abs_power_minus
thf(fact_1330_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_1331_of__int__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ Z ) )
          = ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_minus
thf(fact_1332_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_1333_real__root__Suc__0,axiom,
    ! [X: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X )
      = X ) ).

% real_root_Suc_0
thf(fact_1334_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_1335_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) ).

% real_add_minus_iff
thf(fact_1336_root__0,axiom,
    ! [X: real] :
      ( ( root @ ( zero_zero @ nat ) @ X )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_1337_real__root__eq__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( root @ N @ Y ) )
        = ( X = Y ) ) ) ).

% real_root_eq_iff
thf(fact_1338_negative__zle,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_1339_of__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int] :
          ( ( ring_1_of_int @ A @ ( abs_abs @ int @ X ) )
          = ( abs_abs @ A @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% of_int_abs
thf(fact_1340_floor__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% floor_of_nat
thf(fact_1341_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_1342_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1343_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1344_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1345_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_1346_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_1347_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_1348_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1349_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1350_real__root__eq__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_1351_real__root__less__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ X @ Y ) ) ) ).

% real_root_less_iff
thf(fact_1352_real__root__le__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ X @ Y ) ) ) ).

% real_root_le_iff
thf(fact_1353_real__root__eq__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( one_one @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_1354_real__root__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_1355_negative__zless,axiom,
    ! [N: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_1356_nat__zminus__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_1357_floor__uminus__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z ) ) )
          = ( uminus_uminus @ int @ Z ) ) ) ).

% floor_uminus_of_int
thf(fact_1358_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z ) @ ( one_one @ int ) )
      = ( Z
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_1359_floor__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z ) ) ) ).

% floor_diff_of_int
thf(fact_1360_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_1361_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_1362_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_le_floor
thf(fact_1363_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_1364_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_1365_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_1366_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_1367_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_1368_real__root__lt__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_1369_real__root__gt__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_gt_0_iff
thf(fact_1370_real__root__ge__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_ge_0_iff
thf(fact_1371_real__root__le__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_1372_real__root__lt__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_1373_real__root__gt__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_gt_1_iff
thf(fact_1374_real__root__ge__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_ge_1_iff
thf(fact_1375_real__root__le__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_1376_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_1377_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_1378_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_1379_real__root__pow__pos2,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos2
thf(fact_1380_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_1381_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_1382_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_1383_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_1384_ceiling__minus,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archim6421214686448440834_floor @ A @ X ) ) ) ) ).

% ceiling_minus
thf(fact_1385_floor__minus,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% floor_minus
thf(fact_1386_ceiling__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X3: A] : ( uminus_uminus @ int @ ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) ).

% ceiling_def
thf(fact_1387_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_1388_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) ) ) ) ).

% verit_negate_coefficient(3)
thf(fact_1389_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_1390_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_1391_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ( ( ( abs_abs @ A @ X )
            = ( abs_abs @ A @ Y ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% abs_eq_iff
thf(fact_1392_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_1393_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_1394_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_1395_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_1396_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if
thf(fact_1397_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if_raw
thf(fact_1398_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I3: int] : ( if @ int @ ( ord_less @ int @ I3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I3 ) @ I3 ) ) ) ).

% zabs_def
thf(fact_1399_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_1400_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_1401_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_1402_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_1403_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_1404_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_1405_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_abs
thf(fact_1406_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,X: real] :
      ( ( root @ ( times_times @ nat @ M @ N ) @ X )
      = ( root @ M @ ( root @ N @ X ) ) ) ).

% real_root_mult_exp
thf(fact_1407_real__root__mult,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( root @ N @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ).

% real_root_mult
thf(fact_1408_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1409_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1410_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1411_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1412_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1413_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1414_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_1415_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_1416_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1417_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1418_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1419_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1420_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1421_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1422_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_1423_int__cases2,axiom,
    ! [Z: int] :
      ( ! [N3: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% int_cases2
thf(fact_1424_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_1425_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ).

% floor_mono
thf(fact_1426_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_1427_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_1428_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X ) ) ).

% of_int_floor_le
thf(fact_1429_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% floor_less_cancel
thf(fact_1430_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_1431_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_1432_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_1433_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_1434_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_1435_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_1436_real__root__pos__pos__le,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ).

% real_root_pos_pos_le
thf(fact_1437_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% floor_le_ceiling
thf(fact_1438_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1439_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1440_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1441_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1442_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1443_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1444_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1445_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1446_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1447_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1448_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1449_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1450_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_1451_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B4 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1452_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1453_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1454_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_1455_real__minus__mult__self__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X @ X ) ) ).

% real_minus_mult_self_le
thf(fact_1456_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_round @ A @ X ) ) ) ).

% floor_le_round
thf(fact_1457_int__cases,axiom,
    ! [Z: int] :
      ( ! [N3: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% int_cases
thf(fact_1458_int__of__nat__induct,axiom,
    ! [P: int > $o,Z: int] :
      ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ int @ N3 ) )
     => ( ! [N3: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) )
       => ( P @ Z ) ) ) ).

% int_of_nat_induct
thf(fact_1459_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1460_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1461_minus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L )
      = ( uminus_uminus @ int @ L ) ) ).

% minus_int_code(2)
thf(fact_1462_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_1463_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X3: real,Y6: real] : ( plus_plus @ real @ X3 @ ( uminus_uminus @ real @ Y6 ) ) ) ) ).

% minus_real_def
thf(fact_1464_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K2: int] : ( if @ A @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K2 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K2 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_1465_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E2 ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_1466_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_1467_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_1468_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% zero_le_power_abs
thf(fact_1469_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X ) @ Y )
            = ( abs_abs @ A @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% abs_div_pos
thf(fact_1470_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less_eq @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_1471_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_1472_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_1473_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_1474_real__root__less__mono,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) ).

% real_root_less_mono
thf(fact_1475_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% le_floor_iff
thf(fact_1476_real__root__le__mono,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) ).

% real_root_le_mono
thf(fact_1477_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% floor_less_iff
thf(fact_1478_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% le_floor_add
thf(fact_1479_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( plus_plus @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ) ).

% int_add_floor
thf(fact_1480_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ) ).

% floor_add_int
thf(fact_1481_real__root__power,axiom,
    ! [N: nat,X: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ K ) )
        = ( power_power @ real @ ( root @ N @ X ) @ K ) ) ) ).

% real_root_power
thf(fact_1482_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_1483_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1484_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1485_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1486_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1487_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1488_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1489_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1490_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1491_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1492_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus
thf(fact_1493_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_1494_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A] :
          ( ( powr @ A @ X @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_1495_int__cases4,axiom,
    ! [M: int] :
      ( ! [N3: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_1496_real__add__less__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_less_0_iff
thf(fact_1497_real__0__less__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_less_add_iff
thf(fact_1498_real__add__le__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_le_0_iff
thf(fact_1499_real__0__le__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_le_add_iff
thf(fact_1500_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_1501_negative__zle__0,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_1502_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% nonpos_int_cases
thf(fact_1503_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_1504_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y4: A] :
              ( ( P @ Y4 )
             => ( ord_less_eq @ nat @ ( M @ X4 ) @ ( M @ Y4 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_1505_bounded__Max__nat,axiom,
    ! [P: nat > $o,X: nat,M7: nat] :
      ( ( P @ X )
     => ( ! [X4: nat] :
            ( ( P @ X4 )
           => ( ord_less_eq @ nat @ X4 @ M7 ) )
       => ~ ! [M2: nat] :
              ( ( P @ M2 )
             => ~ ! [X5: nat] :
                    ( ( P @ X5 )
                   => ( ord_less_eq @ nat @ X5 @ M2 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1506_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R ) ) ) @ R ) ) ) ).

% of_nat_floor
thf(fact_1507_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_1508_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_1509_real__root__gt__zero,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_gt_zero
thf(fact_1510_real__root__strict__decreasing,axiom,
    ! [N: nat,N6: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N6 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X )
         => ( ord_less @ real @ ( root @ N6 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_1511_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_1512_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_1513_nat__floor__neg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_1514_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_1515_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_1516_floor__eq3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq3
thf(fact_1517_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X ) @ A2 )
     => ( ord_less_eq @ nat @ X @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_1518_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X3: A] :
              ( if @ int
              @ ( X3
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X3 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X3 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_1519_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_1520_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : ( ord_less @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_1521_floor__eq,axiom,
    ! [N: int,X: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq
thf(fact_1522_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : ( ord_less_eq @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_1523_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : ( ord_less @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_1524_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_1525_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1526_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1527_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1528_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1529_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1530_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1531_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1532_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1533_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1534_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1535_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1536_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_1537_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_1538_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_1539_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_1540_not__zle__0__negative,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ).

% not_zle_0_negative
thf(fact_1541_negative__zless__0,axiom,
    ! [N: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_1542_negD,axiom,
    ! [X: int] :
      ( ( ord_less @ int @ X @ ( zero_zero @ int ) )
     => ? [N3: nat] :
          ( X
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ).

% negD
thf(fact_1543_verit__less__mono__div__int2,axiom,
    ! [A3: int,B4: int,N: int] :
      ( ( ord_less_eq @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B4 @ N ) @ ( divide_divide @ int @ A3 @ N ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_1544_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1545_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I3: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I3 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I3 ) @ ( one_one @ A ) ) ) )
               => ( P @ I3 ) ) ) ) ) ).

% floor_split
thf(fact_1546_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_1547_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z ) ) ) ) ).

% floor_unique
thf(fact_1548_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_1549_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_1550_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_1551_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_1552_real__root__pos__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_pos_pos
thf(fact_1553_real__root__strict__increasing,axiom,
    ! [N: nat,N6: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N6 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N6 @ X ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_1554_real__root__decreasing,axiom,
    ! [N: nat,N6: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N6 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ord_less_eq @ real @ ( root @ N6 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_decreasing
thf(fact_1555_real__root__pow__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos
thf(fact_1556_real__root__pos__unique,axiom,
    ! [N: nat,Y: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( power_power @ real @ Y @ N )
            = X )
         => ( ( root @ N @ X )
            = Y ) ) ) ) ).

% real_root_pos_unique
thf(fact_1557_real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ ( power_power @ real @ X @ N ) )
          = X ) ) ) ).

% real_root_power_cancel
thf(fact_1558_floor__eq4,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq4
thf(fact_1559_floor__eq2,axiom,
    ! [N: int,X: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq2
thf(fact_1560_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1561_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1562_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1563_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1564_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1565_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1566_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_1567_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_1568_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_1569_powr__neg__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X ) ) ) ).

% powr_neg_one
thf(fact_1570_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z7 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_1571_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self2
thf(fact_1572_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ Q2 ) @ P4 ) ) ) ).

% floor_divide_lower
thf(fact_1573_real__root__increasing,axiom,
    ! [N: nat,N6: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N6 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N6 @ X ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_1574_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F3: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I2 )
            & ( ord_less @ nat @ I2 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F3 @ ( suc @ I2 ) ) @ ( F3 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( ord_less_eq @ int @ ( F3 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F3 @ N ) )
           => ? [I2: nat] :
                ( ( ord_less_eq @ nat @ M @ I2 )
                & ( ord_less_eq @ nat @ I2 @ N )
                & ( ( F3 @ I2 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_1575_decr__lemma,axiom,
    ! [D2: int,X: int,Z: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z ) ) ).

% decr_lemma
thf(fact_1576_incr__lemma,axiom,
    ! [D2: int,Z: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_1577_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ P4 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) ) ) ) ).

% floor_divide_upper
thf(fact_1578_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) @ ( uminus_uminus @ real @ X ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_1579_Bernoulli__inequality,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality
thf(fact_1580_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_1581_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% ln_root
thf(fact_1582_log__root,axiom,
    ! [N: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_root
thf(fact_1583_log__base__root,axiom,
    ! [N: nat,B2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N @ B2 ) @ X )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ) ).

% log_base_root
thf(fact_1584_nat__ivt__aux,axiom,
    ! [N: nat,F3: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F3 @ ( suc @ I2 ) ) @ ( F3 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F3 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F3 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F3 @ I2 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_1585_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F3: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: A] :
            ( ( P @ Y3 )
           => ( ord_less @ nat @ ( F3 @ Y3 ) @ B2 ) )
       => ? [X4: A] :
            ( ( P @ X4 )
            & ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ nat @ ( F3 @ Y4 ) @ ( F3 @ X4 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_1586_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1587_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_1588_powr__real__of__int,axiom,
    ! [X: real,N: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( power_power @ real @ X @ ( nat2 @ N ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_1589_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ ( uminus_uminus @ real @ X ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_1590_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ X ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_1591_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_1592_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_1593_abs__exp__cancel,axiom,
    ! [X: real] :
      ( ( abs_abs @ real @ ( exp @ real @ X ) )
      = ( exp @ real @ X ) ) ).

% abs_exp_cancel
thf(fact_1594_exp__inj__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( exp @ real @ X )
        = ( exp @ real @ Y ) )
      = ( X = Y ) ) ).

% exp_inj_iff
thf(fact_1595_frac__frac,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( archimedean_frac @ A @ X ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_frac
thf(fact_1596_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_1597_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_1598_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_1599_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_1600_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_1601_exp__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel_iff
thf(fact_1602_exp__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) ) ) ).

% exp_less_mono
thf(fact_1603_exp__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% exp_le_cancel_iff
thf(fact_1604_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% pochhammer_1
thf(fact_1605_ln__exp,axiom,
    ! [X: real] :
      ( ( ln_ln @ real @ ( exp @ real @ X ) )
      = X ) ).

% ln_exp
thf(fact_1606_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_1607_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_1608_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_1609_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_1610_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_1611_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_1612_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_1613_artanh__minus__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X ) ) ) ) ).

% artanh_minus_real
thf(fact_1614_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_1615_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_1616_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ X )
        = ( one_one @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_1617_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_1618_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_1619_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_1620_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_1621_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_1622_exp__less__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_1623_one__less__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_less_exp_iff
thf(fact_1624_one__le__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_le_exp_iff
thf(fact_1625_exp__le__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_1626_exp__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X ) ) ).

% exp_ln
thf(fact_1627_exp__ln__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% exp_ln_iff
thf(fact_1628_exp__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( exp @ A @ ( uminus_uminus @ A @ X ) )
          = ( inverse_inverse @ A @ ( exp @ A @ X ) ) ) ) ).

% exp_minus
thf(fact_1629_pochhammer__of__nat,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: nat,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( semiring_1_of_nat @ A @ X ) @ N )
          = ( semiring_1_of_nat @ A @ ( comm_s3205402744901411588hammer @ nat @ X @ N ) ) ) ) ).

% pochhammer_of_nat
thf(fact_1630_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_1631_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_1632_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_1633_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_1634_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_1635_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y: A,X: A] :
          ( ( ( times_times @ A @ Y @ X )
            = ( times_times @ A @ X @ Y ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_1636_exp__less__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
     => ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel
thf(fact_1637_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_inverse
thf(fact_1638_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( exp @ A @ X )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_1639_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A3: A] :
          ( ( times_times @ A @ ( exp @ A @ A3 ) @ A3 )
          = ( times_times @ A @ A3 @ ( exp @ A @ A3 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_1640_ln__unique,axiom,
    ! [Y: real,X: real] :
      ( ( ( exp @ real @ Y )
        = X )
     => ( ( ln_ln @ real @ X )
        = Y ) ) ).

% ln_unique
thf(fact_1641_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_1642_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_1643_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_1644_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_1645_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_1646_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_1647_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_1648_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_1649_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_1650_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_1651_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_1652_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_1653_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% divide_inverse
thf(fact_1654_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ ( inverse_inverse @ A @ B3 ) @ A4 ) ) ) ) ).

% divide_inverse_commute
thf(fact_1655_exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X4: real] :
          ( ( exp @ real @ X4 )
          = Y ) ) ).

% exp_total
thf(fact_1656_exp__gt__zero,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_gt_zero
thf(fact_1657_not__exp__less__zero,axiom,
    ! [X: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_1658_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_1659_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_1660_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_1661_not__exp__le__zero,axiom,
    ! [X: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_1662_exp__ge__zero,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_ge_zero
thf(fact_1663_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_1664_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_1665_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_1666_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) )
          = ( exp @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% mult_exp_exp
thf(fact_1667_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) ) ) ) ) ).

% exp_add_commuting
thf(fact_1668_powr__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A] :
          ( ( powr @ A @ X @ ( uminus_uminus @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( powr @ A @ X @ A2 ) ) ) ) ).

% powr_minus
thf(fact_1669_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( divide_divide @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) ) ) ) ).

% exp_diff
thf(fact_1670_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X3: real,Y6: real] : ( times_times @ real @ X3 @ ( inverse_inverse @ real @ Y6 ) ) ) ) ).

% divide_real_def
thf(fact_1671_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_pos
thf(fact_1672_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_1673_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_1674_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) ) ) ).

% frac_ge_0
thf(fact_1675_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_1676_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_1677_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_1678_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_1679_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_1680_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_1681_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_1682_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_1683_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_1684_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_1685_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_1686_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_1687_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_1688_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_1689_exp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) ) ) ).

% exp_gt_one
thf(fact_1690_exp__ge__add__one__self,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ).

% exp_ge_add_one_self
thf(fact_1691_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_1692_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,N: nat] :
          ( ( exp @ A @ ( times_times @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat2_mult
thf(fact_1693_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat_mult
thf(fact_1694_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A4: real] : ( if @ real @ ( ord_less @ real @ A4 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A4 ) @ A4 ) ) ) ).

% abs_real_def
thf(fact_1695_inverse__powr,axiom,
    ! [Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_1696_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_nonneg
thf(fact_1697_log__ln,axiom,
    ( ( ln_ln @ real )
    = ( log @ ( exp @ real @ ( one_one @ real ) ) ) ) ).

% log_ln
thf(fact_1698_real__root__abs,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( abs_abs @ real @ X ) )
        = ( abs_abs @ real @ ( root @ N @ X ) ) ) ) ).

% real_root_abs
thf(fact_1699_sin__bound__lemma,axiom,
    ! [X: real,Y: real,U: real,V: real] :
      ( ( X = Y )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X @ U ) @ Y ) ) @ V ) ) ) ).

% sin_bound_lemma
thf(fact_1700_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_1701_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_1702_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_1703_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_1704_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_1705_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_1706_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_1707_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X ) ) ) ).

% reals_Archimedean
thf(fact_1708_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_1709_lemma__exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y )
     => ? [X4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
          & ( ord_less_eq @ real @ X4 @ ( minus_minus @ real @ Y @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X4 )
            = Y ) ) ) ).

% lemma_exp_total
thf(fact_1710_ln__ge__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ Y @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y ) @ X ) ) ) ).

% ln_ge_iff
thf(fact_1711_ln__x__over__x__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y ) @ Y ) @ ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_1712_forall__pos__mono__1,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D6: real,E2: real] :
          ( ( ord_less @ real @ D6 @ E2 )
         => ( ( P @ D6 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono_1
thf(fact_1713_real__arch__inverse,axiom,
    ! [E: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
      = ( ? [N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ E ) ) ) ) ).

% real_arch_inverse
thf(fact_1714_forall__pos__mono,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D6: real,E2: real] :
          ( ( ord_less @ real @ D6 @ E2 )
         => ( ( P @ D6 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono
thf(fact_1715_ln__inverse,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_inverse
thf(fact_1716_root__abs__power,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( abs_abs @ real @ ( root @ N @ ( power_power @ real @ Y @ N ) ) )
        = ( abs_abs @ real @ Y ) ) ) ).

% root_abs_power
thf(fact_1717_frac__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_frac @ A )
        = ( ^ [X3: A] : ( minus_minus @ A @ X3 @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X3 ) ) ) ) ) ) ).

% frac_def
thf(fact_1718_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_1719_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_1720_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_1721_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X3: A,A4: A] :
              ( if @ A
              @ ( X3
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A4 @ ( ln_ln @ A @ X3 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_1722_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ? [K2: nat] :
                ( ( ord_less @ nat @ K2 @ N )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K2 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_1723_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_1724_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,K: nat] :
          ( ( ord_less @ nat @ N @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_1725_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_1726_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( plus_plus @ nat @ N @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_1727_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_1728_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_1729_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) ) @ N )
            = ( exp @ A @ X ) ) ) ) ).

% exp_divide_power_eq
thf(fact_1730_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X ) ) ) ) ) ) ).

% log_inverse
thf(fact_1731_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_1732_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_1733_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,Z: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_1734_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R ) @ K ) )
          = ( times_times @ A @ R @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_1735_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_1736_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_le_swap1
thf(fact_1737_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_le_swap2
thf(fact_1738_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_1739_lemma__interval,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D6 )
               => ( ( ord_less_eq @ real @ A2 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_1740_lemma__interval__lt,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [Y4: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D6 )
               => ( ( ord_less @ real @ A2 @ Y4 )
                  & ( ord_less @ real @ Y4 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_1741_arctan__add,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_1742_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ ( uminus_uminus @ A @ X3 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_1743_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C4: A] :
                  ( ( ord_less_eq @ A @ A2 @ C4 )
                  & ( ord_less_eq @ A @ C4 @ B2 )
                  & ! [X5: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X5 )
                        & ( ord_less @ A @ X5 @ C4 ) )
                     => ( P @ X5 ) )
                  & ! [D5: A] :
                      ( ! [X4: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X4 )
                            & ( ord_less @ A @ X4 @ D5 ) )
                         => ( P @ X4 ) )
                     => ( ord_less_eq @ A @ D5 @ C4 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_1744_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_1745_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_1746_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_1747_tanh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( tanh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_1748_tanh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% tanh_real_less_iff
thf(fact_1749_tanh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% tanh_real_le_iff
thf(fact_1750_tanh__real__abs,axiom,
    ! [X: real] :
      ( ( tanh @ real @ ( abs_abs @ real @ X ) )
      = ( abs_abs @ real @ ( tanh @ real @ X ) ) ) ).

% tanh_real_abs
thf(fact_1751_tanh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_pos_iff
thf(fact_1752_tanh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_1753_tanh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_nonneg_iff
thf(fact_1754_tanh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_1755_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_1756_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_1757_arctan__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ( arctan @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_1758_tanh__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( tanh @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ A @ ( tanh @ A @ X ) ) ) ) ).

% tanh_minus
thf(fact_1759_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% gbinomial_1
thf(fact_1760_frac__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( member @ A @ ( archimedean_frac @ A @ X ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_in_Ints_iff
thf(fact_1761_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_1762_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_1763_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_1764_zero__less__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_less_arctan_iff
thf(fact_1765_arctan__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_1766_arctan__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_1767_zero__le__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_arctan_iff
thf(fact_1768_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_1769_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ) ).

% floor_add2
thf(fact_1770_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) )
          = ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_1771_of__nat__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat,K: nat] :
          ( ( semiring_1_of_nat @ A @ ( gbinomial @ nat @ N @ K ) )
          = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K ) ) ) ).

% of_nat_gbinomial
thf(fact_1772_arctan__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( arctan @ X )
        = ( arctan @ Y ) )
      = ( X = Y ) ) ).

% arctan_eq_iff
thf(fact_1773_artanh__tanh__real,axiom,
    ! [X: real] :
      ( ( artanh @ real @ ( tanh @ real @ X ) )
      = X ) ).

% artanh_tanh_real
thf(fact_1774_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_1775_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_1776_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_1777_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_1778_Ints__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_diff
thf(fact_1779_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ ( uminus_uminus @ A @ X ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% minus_in_Ints_iff
thf(fact_1780_Ints__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( uminus_uminus @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_minus
thf(fact_1781_arctan__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% arctan_less_iff
thf(fact_1782_arctan__monotone,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone
thf(fact_1783_arctan__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% arctan_le_iff
thf(fact_1784_arctan__monotone_H,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone'
thf(fact_1785_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_1786_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_nat
thf(fact_1787_Ints__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( abs_abs @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_abs
thf(fact_1788_arctan__minus,axiom,
    ! [X: real] :
      ( ( arctan @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( arctan @ X ) ) ) ).

% arctan_minus
thf(fact_1789_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] : ( member @ A @ ( ring_1_of_int @ A @ Z ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_int
thf(fact_1790_Ints__induct,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q2: A,P: A > $o] :
          ( ( member @ A @ Q2 @ ( ring_1_Ints @ A ) )
         => ( ! [Z5: int] : ( P @ ( ring_1_of_int @ A @ Z5 ) )
           => ( P @ Q2 ) ) ) ) ).

% Ints_induct
thf(fact_1791_Ints__cases,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q2: A] :
          ( ( member @ A @ Q2 @ ( ring_1_Ints @ A ) )
         => ~ ! [Z5: int] :
                ( Q2
               != ( ring_1_of_int @ A @ Z5 ) ) ) ) ).

% Ints_cases
thf(fact_1792_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_1793_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_1794_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_1795_tanh__real__lt__1,axiom,
    ! [X: real] : ( ord_less @ real @ ( tanh @ real @ X ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_1796_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_1797_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_1798_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_1799_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_1800_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_1801_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_1802_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_1803_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_1804_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_1805_tanh__real__gt__neg1,axiom,
    ! [X: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X ) ) ).

% tanh_real_gt_neg1
thf(fact_1806_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_1807_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_1808_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_1809_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_1810_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_1811_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_1812_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_1813_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A4 ) @ ( one_one @ A ) ) @ K2 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_1814_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_1815_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_1816_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_1817_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_1818_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K2 ) ) @ ( one_one @ A ) ) @ K2 ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_1819_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A4 ) @ K2 ) ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_1820_split__root,axiom,
    ! [P: real > $o,N: nat,X: real] :
      ( ( P @ ( root @ N @ X ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ! [Y6: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y6 ) @ ( power_power @ real @ ( abs_abs @ real @ Y6 ) @ N ) )
                = X )
             => ( P @ Y6 ) ) ) ) ) ).

% split_root
thf(fact_1821_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_1822_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_1823_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I3: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 @ J3 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1824_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I3: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ I3 @ J3 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1825_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% sgn_sgn
thf(fact_1826_cosh__real__abs,axiom,
    ! [X: real] :
      ( ( cosh @ real @ ( abs_abs @ real @ X ) )
      = ( cosh @ real @ X ) ) ).

% cosh_real_abs
thf(fact_1827_cosh__real__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( cosh @ real @ X )
        = ( cosh @ real @ Y ) )
      = ( ( abs_abs @ real @ X )
        = ( abs_abs @ real @ Y ) ) ) ).

% cosh_real_eq_iff
thf(fact_1828_tanh__real__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( tanh @ real @ X )
        = ( tanh @ real @ Y ) )
      = ( X = Y ) ) ).

% tanh_real_eq_iff
thf(fact_1829_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_1830_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_1831_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_1832_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_1833_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_1834_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_1835_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_1836_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_1837_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_1838_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_1839_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_sgn
thf(fact_1840_of__nat__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( semiring_char_0_fact @ nat @ N ) )
          = ( semiring_char_0_fact @ A @ N ) ) ) ).

% of_nat_fact
thf(fact_1841_cosh__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( uminus_uminus @ A @ X ) )
          = ( cosh @ A @ X ) ) ) ).

% cosh_minus
thf(fact_1842_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_1843_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_1844_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_1845_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_1846_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_1847_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_1848_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_1849_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_1850_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_1851_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_1852_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_1853_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_1854_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_1855_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_1856_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_1857_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_1858_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_1859_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1860_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_1861_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_1862_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_1863_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_1864_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1865_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1866_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_1867_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mod
thf(fact_1868_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_1869_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ).

% fact_mono_nat
thf(fact_1870_fact__ge__self,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_self
thf(fact_1871_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_1872_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_1873_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_1874_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_1875_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_1876_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_1877_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A7: A,B2: A,B7: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A7 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B7 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A7 @ B7 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_1878_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_1879_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_1880_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A7: A,B2: A,B7: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A7 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B7 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A7 @ B7 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_1881_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_1882_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_1883_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_1884_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_1885_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A7: A,B2: A,B7: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A7 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B7 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A7 @ B7 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_1886_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_1887_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_1888_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_1889_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ N )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_1890_cosh__real__nonzero,axiom,
    ! [X: real] :
      ( ( cosh @ real @ X )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_1891_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_1892_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_1893_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% fact_less_mono_nat
thf(fact_1894_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_1895_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D6: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D6 ) ) ) ) ) ).

% mod_eqE
thf(fact_1896_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_1897_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_1898_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_1899_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_zero
thf(fact_1900_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K2: A] : ( times_times @ A @ K2 @ ( sgn_sgn @ A @ K2 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_1901_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_1902_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_1903_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) ).

% mult_sgn_abs
thf(fact_1904_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_gt_zero
thf(fact_1905_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_1906_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_1907_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_1908_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_mono
thf(fact_1909_cosh__real__pos,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_pos
thf(fact_1910_cosh__real__nonpos__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_1911_cosh__real__nonneg__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_1912_cosh__real__nonneg,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_nonneg
thf(fact_1913_arcosh__cosh__real,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( arcosh @ real @ ( cosh @ real @ X ) )
        = X ) ) ).

% arcosh_cosh_real
thf(fact_1914_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_1915_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_1916_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1917_cosh__real__ge__1,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_ge_1
thf(fact_1918_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_1919_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_1920_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1921_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q3: int] :
          ( M
          = ( times_times @ int @ D2 @ Q3 ) ) ) ).

% zmod_eq_0D
thf(fact_1922_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_1923_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_1924_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_1925_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_Suc_0_nat
thf(fact_1926_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_1927_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_1928_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_1929_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_1930_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_1931_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_1932_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_1933_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_1934_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_1935_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1936_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1937_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1938_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1939_sgn__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( sgn_sgn @ real @ ( root @ N @ X ) )
        = ( sgn_sgn @ real @ X ) ) ) ).

% sgn_root
thf(fact_1940_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_1941_cosh__real__nonpos__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_1942_cosh__real__nonneg__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_1943_cosh__real__strict__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_1944_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ) ).

% fact_less_mono
thf(fact_1945_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1946_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1947_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_1948_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_1949_zmod__trivial__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( modulo_modulo @ int @ I @ K )
        = I )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zmod_trivial_iff
thf(fact_1950_zdiv__mono__strict,axiom,
    ! [A3: int,B4: int,N: int] :
      ( ( ord_less @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ( ( modulo_modulo @ int @ A3 @ N )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B4 @ N )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A3 @ N ) @ ( divide_divide @ int @ B4 @ N ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1951_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_1952_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_1953_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_1954_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N @ N ) ) ) ) ).

% fact_le_power
thf(fact_1955_div__mod__decomp__int,axiom,
    ! [A3: int,N: int] :
      ( A3
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A3 @ N ) @ N ) @ ( modulo_modulo @ int @ A3 @ N ) ) ) ).

% div_mod_decomp_int
thf(fact_1956_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A4: real] :
          ( if @ real
          @ ( A4
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A4 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_1957_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_1958_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_1959_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X3: A] :
              ( if @ A
              @ ( X3
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X3 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_1960_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_1961_fact__div__fact__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ R ) ) ) @ ( power_power @ nat @ N @ R ) ) ) ).

% fact_div_fact_le_pow
thf(fact_1962_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1963_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L ) @ L ) ) ) ) ).

% mod_pos_geq
thf(fact_1964_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1965_sgn__power__injE,axiom,
    ! [A2: real,N: nat,X: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N ) )
        = X )
     => ( ( X
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_1966_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1967_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1968_split__zmod,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ J3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I3: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I3 ) @ J3 ) ) )
             => ( P @ J3 ) ) ) ) ) ).

% split_zmod
thf(fact_1969_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1970_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1971_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1972_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1973_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1974_sgn__power__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N @ X ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N @ X ) ) @ N ) )
        = X ) ) ).

% sgn_power_root
thf(fact_1975_root__sgn__power,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) ) )
        = Y ) ) ).

% root_sgn_power
thf(fact_1976_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_1977_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_1978_verit__le__mono__div__int,axiom,
    ! [A3: int,B4: int,N: int] :
      ( ( ord_less @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B4 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B4 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1979_sgn__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_1980_zero__le__sgn__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_sgn_iff
thf(fact_1981_sgn__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_one
thf(fact_1982_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_1983_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( sgn_sgn @ A @ Y ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_1984_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( sgn_sgn @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_1985_verit__le__mono__div,axiom,
    ! [A3: nat,B4: nat,N: nat] :
      ( ( ord_less @ nat @ A3 @ B4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A3 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B4 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B4 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_1986_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_1987_Suc__mod__mult__self4,axiom,
    ! [N: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self4
thf(fact_1988_Suc__mod__mult__self3,axiom,
    ! [K: nat,N: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self3
thf(fact_1989_Suc__mod__mult__self2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N @ K ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self2
thf(fact_1990_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self1
thf(fact_1991_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N ) ) ).

% mod_Suc_Suc_eq
thf(fact_1992_mod__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% mod_Suc_eq
thf(fact_1993_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ M ) ).

% mod_less_eq_dividend
thf(fact_1994_funpow__mod__eq,axiom,
    ! [A: $tType,N: nat,F3: A > A,X: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N @ F3 @ X )
        = X )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N ) @ F3 @ X )
        = ( compow @ ( A > A ) @ M @ F3 @ X ) ) ) ).

% funpow_mod_eq
thf(fact_1995_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N3: nat,L2: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_sgnE
thf(fact_1996_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
          = N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
         != N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ).

% mod_Suc
thf(fact_1997_mod__induct,axiom,
    ! [P: nat > $o,N: nat,P4: nat,M: nat] :
      ( ( P @ N )
     => ( ( ord_less @ nat @ N @ P4 )
       => ( ( ord_less @ nat @ M @ P4 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P4 )
               => ( ( P @ N3 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P4 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_1998_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [M2: nat] : ( P @ M2 @ ( zero_zero @ nat ) )
     => ( ! [M2: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P @ N3 @ ( modulo_modulo @ nat @ M2 @ N3 ) )
             => ( P @ M2 @ N3 ) ) )
       => ( P @ M @ N ) ) ) ).

% gcd_nat_induct
thf(fact_1999_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_less_divisor
thf(fact_2000_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N ) ) @ N ) ).

% mod_Suc_le_divisor
thf(fact_2001_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q3: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q3 ) ) ) ).

% mod_eq_0D
thf(fact_2002_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% mod_geq
thf(fact_2003_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N2: nat] : ( if @ nat @ ( ord_less @ nat @ M3 @ N2 ) @ M3 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ).

% mod_if
thf(fact_2004_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% le_mod_geq
thf(fact_2005_nat__mod__eq__iff,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y @ N ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X @ ( times_times @ nat @ N @ Q1 ) )
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_2006_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2007_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_le_divisor
thf(fact_2008_nat__mod__eq__lemma,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y @ N ) )
     => ( ( ord_less_eq @ nat @ Y @ X )
       => ? [Q3: nat] :
            ( X
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N @ Q3 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_2009_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ~ ! [S3: nat] :
              ( N
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_2010_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ~ ! [S3: nat] :
              ( M
             != ( plus_plus @ nat @ N @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_2011_div__less__mono,axiom,
    ! [A3: nat,B4: nat,N: nat] :
      ( ( ord_less @ nat @ A3 @ B4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( modulo_modulo @ nat @ A3 @ N )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B4 @ N )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A3 @ N ) @ ( divide_divide @ nat @ B4 @ N ) ) ) ) ) ) ).

% div_less_mono
thf(fact_2012_div__mod__decomp,axiom,
    ! [A3: nat,N: nat] :
      ( A3
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A3 @ N ) @ N ) @ ( modulo_modulo @ nat @ A3 @ N ) ) ) ).

% div_mod_decomp
thf(fact_2013_mod__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) @ ( modulo_modulo @ nat @ M @ N ) ) ) ).

% mod_mult2_eq
thf(fact_2014_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N2: nat] : ( minus_minus @ nat @ M3 @ ( times_times @ nat @ ( divide_divide @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ).

% modulo_nat_def
thf(fact_2015_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I3: int] :
          ( if @ int
          @ ( I3
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I3 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_2016_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_2017_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2018_split__mod,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I3: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I3 ) @ J3 ) )
               => ( P @ J3 ) ) ) ) ) ) ).

% split_mod
thf(fact_2019_nat__mod__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( modulo_modulo @ int @ X @ Y ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_2020_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_2021_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_2022_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X8: nat > real] :
        ! [J3: nat] :
        ? [M8: nat] :
        ! [M3: nat] :
          ( ( ord_less_eq @ nat @ M8 @ M3 )
         => ! [N2: nat] :
              ( ( ord_less_eq @ nat @ M8 @ N2 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X8 @ M3 ) @ ( X8 @ N2 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_2023_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_2024_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_2025_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2026_cpmi,axiom,
    ! [D3: int,P: int > $o,P3: int > $o,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ? [Z3: int] :
          ! [X4: int] :
            ( ( ord_less @ int @ X4 @ Z3 )
           => ( ( P @ X4 )
              = ( P3 @ X4 ) ) )
       => ( ! [X4: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ B4 )
                     => ( X4
                       != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
             => ( ( P @ X4 )
               => ( P @ ( minus_minus @ int @ X4 @ D3 ) ) ) )
         => ( ! [X4: int,K3: int] :
                ( ( P3 @ X4 )
                = ( P3 @ ( minus_minus @ int @ X4 @ ( times_times @ int @ K3 @ D3 ) ) ) )
           => ( ( ? [X8: int] : ( P @ X8 ) )
              = ( ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                    & ( P3 @ X3 ) )
                | ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                    & ? [Y6: int] :
                        ( ( member @ int @ Y6 @ B4 )
                        & ( P @ ( plus_plus @ int @ Y6 @ X3 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_2027_cppi,axiom,
    ! [D3: int,P: int > $o,P3: int > $o,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ? [Z3: int] :
          ! [X4: int] :
            ( ( ord_less @ int @ Z3 @ X4 )
           => ( ( P @ X4 )
              = ( P3 @ X4 ) ) )
       => ( ! [X4: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ A3 )
                     => ( X4
                       != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
             => ( ( P @ X4 )
               => ( P @ ( plus_plus @ int @ X4 @ D3 ) ) ) )
         => ( ! [X4: int,K3: int] :
                ( ( P3 @ X4 )
                = ( P3 @ ( minus_minus @ int @ X4 @ ( times_times @ int @ K3 @ D3 ) ) ) )
           => ( ( ? [X8: int] : ( P @ X8 ) )
              = ( ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                    & ( P3 @ X3 ) )
                | ? [X3: int] :
                    ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
                    & ? [Y6: int] :
                        ( ( member @ int @ Y6 @ A3 )
                        & ( P @ ( minus_minus @ int @ Y6 @ X3 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_2028_aset_I8_J,axiom,
    ! [D3: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X5 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X5 @ D3 ) ) ) ) ) ).

% aset(8)
thf(fact_2029_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) ).

% numeral_eq_iff
thf(fact_2030_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_mult_numeral
thf(fact_2031_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_2032_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_2033_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% numeral_le_iff
thf(fact_2034_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% numeral_less_iff
thf(fact_2035_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_2036_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_2037_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% numeral_plus_numeral
thf(fact_2038_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) ).

% add_numeral_left
thf(fact_2039_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_2040_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) ).

% neg_numeral_eq_iff
thf(fact_2041_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_2042_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_2043_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% of_nat_numeral
thf(fact_2044_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,H: A,L3: A,H2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L @ H )
            = ( set_or1337092689740270186AtMost @ A @ L3 @ H2 ) )
          = ( ( ( L = L3 )
              & ( H = H2 ) )
            | ( ~ ( ord_less_eq @ A @ L @ H )
              & ~ ( ord_less_eq @ A @ L3 @ H2 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_2045_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_2046_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_2047_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_numeral
thf(fact_2048_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int,N: num] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( numeral_numeral @ A @ N ) )
          = ( Z
            = ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_2049_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_2050_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_2051_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_2052_norm__fact,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( semiring_char_0_fact @ A @ N ) )
          = ( semiring_char_0_fact @ real @ N ) ) ) ).

% norm_fact
thf(fact_2053_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% numeral_powr_numeral_real
thf(fact_2054_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ int @ N ) ) ) ).

% round_numeral
thf(fact_2055_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_2056_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_2057_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_2058_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_2059_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_2060_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_2061_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_2062_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_2063_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_2064_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y ) ) ) ).

% semiring_norm(172)
thf(fact_2065_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(171)
thf(fact_2066_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(170)
thf(fact_2067_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_2068_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(168)
thf(fact_2069_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_2070_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_2071_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_neg_numeral
thf(fact_2072_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_2073_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_2074_norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( one_one @ A ) )
        = ( one_one @ real ) ) ) ).

% norm_one
thf(fact_2075_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2076_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_2077_norm__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ real @ N ) ) ) ).

% norm_of_nat
thf(fact_2078_diff__nat__numeral,axiom,
    ! [V: num,V3: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V3 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V3 ) ) ) ) ).

% diff_nat_numeral
thf(fact_2079_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y: int,X: num,N: nat] :
      ( ( ( nat2 @ Y )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( Y
        = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_2080_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,N: nat,Y: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
        = ( nat2 @ Y ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
        = Y ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_2081_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_2082_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_2083_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_2084_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_2085_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_2086_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_2087_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_2088_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
          = ( ( X
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2089_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2090_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2091_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2092_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2093_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2094_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2095_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2096_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: num,N: nat,Y: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( semiring_1_of_nat @ A @ Y ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
            = Y ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2097_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y: nat,X: num,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2098_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_le_floor
thf(fact_2099_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_2100_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_2101_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_less_ceiling
thf(fact_2102_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_2103_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_2104_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_2105_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_2106_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
            = Y ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2107_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y
            = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2108_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_2109_powr__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( numeral_numeral @ real @ N ) )
        = ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% powr_numeral
thf(fact_2110_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_2111_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ).

% round_neg_numeral
thf(fact_2112_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_2113_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_2114_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_2115_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_2116_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_2117_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_2118_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2119_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2120_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_2121_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_2122_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_2123_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_2124_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_2125_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_2126_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_2127_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_2128_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_2129_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2130_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I: num,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2131_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2132_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I: num,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2133_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_2134_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_2135_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_le_floor
thf(fact_2136_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_2137_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_2138_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2139_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2140_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_2141_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2142_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2143_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( Y
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2144_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N )
            = Y ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2145_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_2146_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_2147_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_2148_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_2149_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_2150_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2151_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2152_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2153_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2154_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I3: num] : ( nat2 @ ( numeral_numeral @ int @ I3 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_2155_int__ops_I3_J,axiom,
    ! [N: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ int @ N ) ) ).

% int_ops(3)
thf(fact_2156_norm__minus__commute,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% norm_minus_commute
thf(fact_2157_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) ).

% zero_neq_numeral
thf(fact_2158_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_2159_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_2160_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_2161_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: num] : ( member @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_2162_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_2163_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_2164_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_2165_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K2: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K2 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_2166_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2167_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% norm_ge_zero
thf(fact_2168_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult
thf(fact_2169_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N2 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M3 ) @ ( X8 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_2170_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M9: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M2 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ M2 ) @ ( X9 @ N3 ) ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X9 ) ) ) ).

% CauchyI
thf(fact_2171_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X9 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M10: nat] :
              ! [M4: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M4 )
               => ! [N4: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N4 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ M4 ) @ ( X9 @ N4 ) ) ) @ E ) ) ) ) ) ) ).

% CauchyD
thf(fact_2172_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_2173_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_le_numeral
thf(fact_2174_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_2175_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_less_numeral
thf(fact_2176_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_2177_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_2178_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_2179_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_le_numeral
thf(fact_2180_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_2181_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_2182_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_less_numeral
thf(fact_2183_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_2184_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_2185_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_2186_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_2187_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ Y ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% norm_uminus_minus
thf(fact_2188_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2189_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat,Z: A] :
          ( ( ( power_power @ A @ W @ N )
            = ( power_power @ A @ Z @ N ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2190_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,R: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ R @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_2191_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult_ineq
thf(fact_2192_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,R: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_2193_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_lt
thf(fact_2194_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2195_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2196_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_le
thf(fact_2197_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2198_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2199_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A,N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power_ineq
thf(fact_2200_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_le_diff
thf(fact_2201_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2202_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2203_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2204_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_2205_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_2206_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_2207_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_2208_bset_I1_J,axiom,
    ! [D3: int,B4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X4: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X4 )
           => ( P @ ( minus_minus @ int @ X4 @ D3 ) ) ) )
     => ( ! [X4: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X4 )
             => ( Q @ ( minus_minus @ int @ X4 @ D3 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
             => ( ( P @ ( minus_minus @ int @ X5 @ D3 ) )
                & ( Q @ ( minus_minus @ int @ X5 @ D3 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_2209_bset_I2_J,axiom,
    ! [D3: int,B4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X4: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B4 )
                 => ( X4
                   != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X4 )
           => ( P @ ( minus_minus @ int @ X4 @ D3 ) ) ) )
     => ( ! [X4: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B4 )
                   => ( X4
                     != ( plus_plus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X4 )
             => ( Q @ ( minus_minus @ int @ X4 @ D3 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
             => ( ( P @ ( minus_minus @ int @ X5 @ D3 ) )
                | ( Q @ ( minus_minus @ int @ X5 @ D3 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_2210_aset_I1_J,axiom,
    ! [D3: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X4: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X4
                   != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X4 )
           => ( P @ ( plus_plus @ int @ X4 @ D3 ) ) ) )
     => ( ! [X4: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X4 )
             => ( Q @ ( plus_plus @ int @ X4 @ D3 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
             => ( ( P @ ( plus_plus @ int @ X5 @ D3 ) )
                & ( Q @ ( plus_plus @ int @ X5 @ D3 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_2211_aset_I2_J,axiom,
    ! [D3: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X4: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X4
                   != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
         => ( ( P @ X4 )
           => ( P @ ( plus_plus @ int @ X4 @ D3 ) ) ) )
     => ( ! [X4: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X4
                     != ( minus_minus @ int @ Xb @ Xa2 ) ) ) )
           => ( ( Q @ X4 )
             => ( Q @ ( plus_plus @ int @ X4 @ D3 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
             => ( ( P @ ( plus_plus @ int @ X5 @ D3 ) )
                | ( Q @ ( plus_plus @ int @ X5 @ D3 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_2212_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2213_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_2214_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_2215_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2216_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_2217_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_2218_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_2219_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_2220_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_2221_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_2222_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_2223_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_2224_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_2225_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_2226_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_2227_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_exp
thf(fact_2228_powr__neg__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_2229_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat] :
          ( ( ( power_power @ A @ W @ N )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2230_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2231_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_2232_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_2233_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_2234_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_2235_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_2236_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_2237_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X4: int,K3: int] :
            ( ( P @ X4 )
            = ( P @ ( minus_minus @ int @ X4 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ( ? [X8: int] : ( P @ X8 ) )
          = ( ? [X3: int] :
                ( ( member @ int @ X3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X3 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_2238_bset_I3_J,axiom,
    ! [D3: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 = T2 )
             => ( ( minus_minus @ int @ X5 @ D3 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_2239_bset_I4_J,axiom,
    ! [D3: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ T2 @ B4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 != T2 )
             => ( ( minus_minus @ int @ X5 @ D3 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_2240_bset_I5_J,axiom,
    ! [D3: int,B4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B4 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X5 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_2241_bset_I7_J,axiom,
    ! [D3: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ T2 @ B4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X5 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X5 @ D3 ) ) ) ) ) ) ).

% bset(7)
thf(fact_2242_aset_I3_J,axiom,
    ! [D3: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 = T2 )
             => ( ( plus_plus @ int @ X5 @ D3 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_2243_aset_I4_J,axiom,
    ! [D3: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X5 != T2 )
             => ( ( plus_plus @ int @ X5 @ D3 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_2244_aset_I5_J,axiom,
    ! [D3: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X5 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_2245_aset_I7_J,axiom,
    ! [D3: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X5 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X5 @ D3 ) ) ) ) ) ).

% aset(7)
thf(fact_2246_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X9: A > B] :
          ( ( ? [K5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ K5 ) ) )
          = ( ? [N7: nat] :
              ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2247_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X9: A > B] :
          ( ( ? [K5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ K5 ) ) )
          = ( ? [N7: nat] :
              ! [N2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2248_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_2249_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_2250_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_2251_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_2252_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R: real,X: A] :
          ( ( ord_less_eq @ real @ R @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X ) ) @ ( inverse_inverse @ real @ R ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_2253_bset_I6_J,axiom,
    ! [D3: int,B4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B4 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X5 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_2254_bset_I8_J,axiom,
    ! [D3: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X5 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X5 @ D3 ) ) ) ) ) ) ).

% bset(8)
thf(fact_2255_aset_I6_J,axiom,
    ! [D3: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D3 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X5 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_2256_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(1)
thf(fact_2257_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H: A,Z: A,K6: real,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K6 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z @ H ) ) @ K6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K6 @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2258_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ? [K7: real] :
            ! [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K7 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F3 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_2259_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F5: A > B] :
            ? [K5: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_2260_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_2261_complex__mod__minus__le__complex__mod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_2262_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_2263_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(87)
thf(fact_2264_verit__eq__simplify_I8_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( ( bit0 @ X2 )
        = ( bit0 @ Y2 ) )
      = ( X2 = Y2 ) ) ).

% verit_eq_simplify(8)
thf(fact_2265_semiring__norm_I83_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) ).

% semiring_norm(83)
thf(fact_2266_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_2267_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(6)
thf(fact_2268_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ).

% semiring_norm(13)
thf(fact_2269_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_2270_semiring__norm_I12_J,axiom,
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) ).

% semiring_norm(12)
thf(fact_2271_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(71)
thf(fact_2272_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(78)
thf(fact_2273_semiring__norm_I68_J,axiom,
    ! [N: num] : ( ord_less_eq @ num @ one2 @ N ) ).

% semiring_norm(68)
thf(fact_2274_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_2275_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_2276_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_2277_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_2278_num__double,axiom,
    ! [N: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N )
      = ( bit0 @ N ) ) ).

% num_double
thf(fact_2279_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_2280_semiring__norm_I76_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit0 @ N ) ) ).

% semiring_norm(76)
thf(fact_2281_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_2282_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_2283_Suc__numeral,axiom,
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% Suc_numeral
thf(fact_2284_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_2285_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_2286_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_2287_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_2288_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_2289_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_2290_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_2291_add__2__eq__Suc,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc
thf(fact_2292_add__2__eq__Suc_H,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc'
thf(fact_2293_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_2294_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_2295_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_2296_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_2297_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_2298_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_2299_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_2300_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_2301_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_2302_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_2303_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_2304_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_2305_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_2306_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_2307_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X = Y ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_2308_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_2309_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_2310_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_2311_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_2312_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_2313_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_2314_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_2315_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_2316_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_2317_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_2318_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_2319_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_2320_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_2321_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_2322_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_2323_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_2324_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_2325_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_2326_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_2327_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_2328_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_2329_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_2330_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_2331_square__powr__half,axiom,
    ! [X: real] :
      ( ( powr @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% square_powr_half
thf(fact_2332_le__num__One__iff,axiom,
    ! [X: num] :
      ( ( ord_less_eq @ num @ X @ one2 )
      = ( X = one2 ) ) ).

% le_num_One_iff
thf(fact_2333_i0__lb,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ).

% i0_lb
thf(fact_2334_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_2335_add__One__commute,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) ).

% add_One_commute
thf(fact_2336_verit__eq__simplify_I10_J,axiom,
    ! [X2: num] :
      ( one2
     != ( bit0 @ X2 ) ) ).

% verit_eq_simplify(10)
thf(fact_2337_pow_Osimps_I1_J,axiom,
    ! [X: num] :
      ( ( pow @ X @ one2 )
      = X ) ).

% pow.simps(1)
thf(fact_2338_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y: extended_enat,X: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z @ Y )
     => ( ( plus_plus @ extended_enat @ X @ ( minus_minus @ extended_enat @ Y @ Z ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ Z ) ) ) ).

% add_diff_assoc_enat
thf(fact_2339_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_2340_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_2341_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_2342_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_2343_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_2344_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% power2_eq_iff
thf(fact_2345_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_2346_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_2347_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_2348_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% double_not_eq_Suc_double
thf(fact_2349_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_double_not_eq_double
thf(fact_2350_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_2351_four__x__squared,axiom,
    ! [X: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_2352_less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% less_exp
thf(fact_2353_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_imp_le
thf(fact_2354_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_eq_le
thf(fact_2355_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_2356_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_2357_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_2358_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( X = Y ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_2359_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% power2_le_imp_le
thf(fact_2360_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_2361_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2
thf(fact_2362_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2_right
thf(fact_2363_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_2364_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X ) ) ).

% field_sum_of_halves
thf(fact_2365_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_2366_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( abs_abs @ A @ Y ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2367_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_2368_less__2__cases,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_2369_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2370_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X: A] :
          ( ! [X4: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X4 )
             => ( P @ X4 @ ( power_power @ A @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X ) @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2371_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_2372_nat__induct2,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct2
thf(fact_2373_two__realpow__ge__one,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) ) ).

% two_realpow_ge_one
thf(fact_2374_square__fact__le__2__fact,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% square_fact_le_2_fact
thf(fact_2375_realpow__square__minus__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_2376_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) ) ) ) ).

% diff_le_diff_pow
thf(fact_2377_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2378_not__exp__less__eq__0__int,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_2379_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( semiring_1_of_nat @ real @ N )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_2380_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% power2_less_imp_less
thf(fact_2381_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_2382_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_2383_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_2384_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_2385_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_2386_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_2387_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less @ A @ X @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_2388_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_2389_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_2390_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ Y ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2391_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% of_nat_less_two_power
thf(fact_2392_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_2393_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_2394_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% zero_le_even_power'
thf(fact_2395_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_2396_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2397_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2398_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ).

% div_exp_eq
thf(fact_2399_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_2400_ex__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X3 ) ) ) ) ).

% ex_nat_less
thf(fact_2401_all__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X3 ) ) ) ) ).

% all_nat_less
thf(fact_2402_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_2403_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) )
          = ( power_power @ A @ ( exp @ A @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_2404_nat__bit__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_bit_induct
thf(fact_2405_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2406_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_2407_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_2408_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_2409_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_Bit0
thf(fact_2410_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_2411_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_2412_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_2413_exp__plus__inverse__exp,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_2414_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_2415_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_2416_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_2417_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_2418_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_2419_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N ) ) ).

% Suc_nat_number_of_add
thf(fact_2420_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_2421_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N2: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_2422_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_2423_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_2424_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_2425_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_2426_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_2427_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_2428_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2429_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_2430_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_2431_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_2432_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_2433_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_2434_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K3: int] :
              ( ( P @ K3 )
             => ( ( K3
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K3: int] :
                ( ( P @ K3 )
               => ( ( K3
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2435_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_2436_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_2437_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_2438_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_2439_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_2440_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_2441_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_2442_exp__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_2443_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_less
thf(fact_2444_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_2445_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_2446_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X3: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X3 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_2447_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_2448_real__le__x__sinh,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_2449_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_2450_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_2451_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_2452_real__le__abs__sinh,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_2453_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_2454_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X: A,Y: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X @ Y ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_2455_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X @ M ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_2456_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_2457_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2458_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_2459_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_2460_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_2461_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_le
thf(fact_2462_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_2463_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( divide_divide @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_2464_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2465_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X3: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X3 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X3 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_2466_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_2467_cosh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( cosh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_2468_floor__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_2469_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_2470_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2471_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N ) ) ) ).

% round_unique'
thf(fact_2472_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2473_arctan__double,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2474_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X3: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X3 ) ) @ ( archimedean_ceiling @ A @ X3 ) @ ( archim6421214686448440834_floor @ A @ X3 ) ) ) ) ) ).

% round_altdef
thf(fact_2475_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X3: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X3 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X3 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_2476_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_2477_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y ) ) ) ) ).

% round_unique
thf(fact_2478_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_2479_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2480_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_2481_tanh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( tanh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2482_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_2483_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_2484_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_2485_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2486_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_2487_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_2488_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_2489_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_2490_psubsetI,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( A3 != B4 )
       => ( ord_less @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% psubsetI
thf(fact_2491_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X3: nat,N2: nat] : ( modulo_modulo @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% low_def
thf(fact_2492_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X3: nat,N2: nat] : ( divide_divide @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% high_def
thf(fact_2493_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_2494_subset__antisym,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( A3 = B4 ) ) ) ).

% subset_antisym
thf(fact_2495_subsetI,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A3 )
         => ( member @ A @ X4 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% subsetI
thf(fact_2496_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ).

% Compl_subset_Compl_iff
thf(fact_2497_Compl__anti__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) ).

% Compl_anti_mono
thf(fact_2498_i0__less,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( ( N
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_2499_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_2500_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_2501_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_2502_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_2503_idiff__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = N ) ).

% idiff_0_right
thf(fact_2504_idiff__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_2505_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ) ) ).

% enat_0_less_mult_iff
thf(fact_2506_not__iless0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less @ extended_enat @ N @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_2507_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_2508_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_2509_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_2510_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M3 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_2511_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_2512_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) ) ).

% set_bit_greater_eq
thf(fact_2513_Diff__mono,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,D3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ D3 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ C5 @ D3 ) ) ) ) ).

% Diff_mono
thf(fact_2514_Diff__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ A3 ) ).

% Diff_subset
thf(fact_2515_double__diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ( minus_minus @ ( set @ A ) @ B4 @ ( minus_minus @ ( set @ A ) @ C5 @ A3 ) )
          = A3 ) ) ) ).

% double_diff
thf(fact_2516_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X3: A] :
            ( ( P @ X3 )
           => ( Q @ X3 ) ) ) ) ).

% Collect_mono_iff
thf(fact_2517_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y5: set @ A,Z4: set @ A] : ( Y5 = Z4 ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
            & ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) ) ) ).

% set_eq_subset
thf(fact_2518_subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% subset_trans
thf(fact_2519_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X4: A] :
          ( ( P @ X4 )
         => ( Q @ X4 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_2520_subset__refl,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) ).

% subset_refl
thf(fact_2521_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A6 )
           => ( member @ A @ T3 @ B6 ) ) ) ) ).

% subset_iff
thf(fact_2522_equalityD2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( A3 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ).

% equalityD2
thf(fact_2523_equalityD1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( A3 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% equalityD1
thf(fact_2524_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ( member @ A @ X3 @ B6 ) ) ) ) ).

% subset_eq
thf(fact_2525_equalityE,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( A3 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ) ).

% equalityE
thf(fact_2526_subsetD,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B4 ) ) ) ).

% subsetD
thf(fact_2527_in__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B4 ) ) ) ).

% in_mono
thf(fact_2528_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ? [B5: A] : ( member @ A @ B5 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_2529_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A6 @ B6 )
            | ( A6 = B6 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_2530_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% subset_psubset_trans
thf(fact_2531_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_2532_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% psubset_subset_trans
thf(fact_2533_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% psubset_imp_subset
thf(fact_2534_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
            & ( A6 != B6 ) ) ) ) ).

% psubset_eq
thf(fact_2535_psubsetE,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ) ).

% psubsetE
thf(fact_2536_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_2537_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_2538_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_2539_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_2540_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_2541_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X3: A] : ( ln_ln @ A @ ( plus_plus @ A @ X3 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_2542_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X3: A] : ( ln_ln @ A @ ( plus_plus @ A @ X3 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_2543_log__base__10__eq1,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq1
thf(fact_2544_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(90)
thf(fact_2545_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( ( bit1 @ X32 )
        = ( bit1 @ Y32 ) )
      = ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
thf(fact_2546_Diff__idemp,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ B4 )
      = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_idemp
thf(fact_2547_Diff__iff,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( member @ A @ C2 @ A3 )
        & ~ ( member @ A @ C2 @ B4 ) ) ) ).

% Diff_iff
thf(fact_2548_DiffI,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ A3 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% DiffI
thf(fact_2549_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) ).

% semiring_norm(88)
thf(fact_2550_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) ).

% semiring_norm(89)
thf(fact_2551_semiring__norm_I84_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit1 @ N ) ) ).

% semiring_norm(84)
thf(fact_2552_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2553_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_2554_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_2555_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_2556_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(73)
thf(fact_2557_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(80)
thf(fact_2558_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_2559_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_2560_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_2561_of__real__1,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( one_one @ real ) )
        = ( one_one @ A ) ) ) ).

% of_real_1
thf(fact_2562_of__real__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ real ) ) ) ) ).

% of_real_eq_1_iff
thf(fact_2563_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X @ Y ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_mult
thf(fact_2564_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_2565_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X @ Y ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_add
thf(fact_2566_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_2567_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_2568_of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( minus_minus @ real @ X @ Y ) )
          = ( minus_minus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_diff
thf(fact_2569_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(7)
thf(fact_2570_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(9)
thf(fact_2571_of__real__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_Vector_of_real @ A @ ( semiring_1_of_nat @ real @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_real_of_nat_eq
thf(fact_2572_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N ) ) ) ) ).

% semiring_norm(14)
thf(fact_2573_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N ) ) ) ).

% semiring_norm(15)
thf(fact_2574_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(72)
thf(fact_2575_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(81)
thf(fact_2576_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2577_semiring__norm_I77_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit1 @ N ) ) ).

% semiring_norm(77)
thf(fact_2578_of__real__fact,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_Vector_of_real @ A @ ( semiring_char_0_fact @ real @ N ) )
          = ( semiring_char_0_fact @ A @ N ) ) ) ).

% of_real_fact
thf(fact_2579_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_2580_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_2581_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2582_semiring__norm_I3_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) ).

% semiring_norm(3)
thf(fact_2583_semiring__norm_I4_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2584_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_2585_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2586_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2587_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2588_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(74)
thf(fact_2589_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(79)
thf(fact_2590_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_2591_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_2592_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2593_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_2594_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2595_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2596_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2597_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2598_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2599_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_2600_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_2601_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_2602_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2603_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2604_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2605_DiffD2,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( member @ A @ C2 @ B4 ) ) ).

% DiffD2
thf(fact_2606_DiffD1,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ( member @ A @ C2 @ A3 ) ) ).

% DiffD1
thf(fact_2607_DiffE,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( ( member @ A @ C2 @ A3 )
         => ( member @ A @ C2 @ B4 ) ) ) ).

% DiffE
thf(fact_2608_verit__eq__simplify_I14_J,axiom,
    ! [X2: num,X32: num] :
      ( ( bit0 @ X2 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2609_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2610_pochhammer__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_V2191834092415804123ebra_1 @ A )
        & ( comm_semiring_1 @ A ) )
     => ! [X: real,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( real_Vector_of_real @ A @ X ) @ N )
          = ( real_Vector_of_real @ A @ ( comm_s3205402744901411588hammer @ real @ X @ N ) ) ) ) ).

% pochhammer_of_real
thf(fact_2611_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% signed_take_bit_mult
thf(fact_2612_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ K @ L ) ) ) ).

% signed_take_bit_add
thf(fact_2613_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% signed_take_bit_diff
thf(fact_2614_num_Oexhaust,axiom,
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X22: num] :
            ( Y
           != ( bit0 @ X22 ) )
       => ~ ! [X33: num] :
              ( Y
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2615_of__real__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: real] :
          ( ( real_Vector_of_real @ A @ ( exp @ real @ X ) )
          = ( exp @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ).

% of_real_exp
thf(fact_2616_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X3: A] : ( plus_plus @ A @ X3 @ X3 ) ) ) ) ).

% dbl_def
thf(fact_2617_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y: real,X: real] :
          ( ( Y
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_2618_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real] :
          ( ( X
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_2619_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2620_eval__nat__numeral_I3_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2621_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2622_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_2623_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2624_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2625_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2626_Suc3__eq__add__3,axiom,
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ).

% Suc3_eq_add_3
thf(fact_2627_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_2628_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2629_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2630_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_div_eq_add3_div
thf(fact_2631_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2632_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_2633_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2634_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_2635_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_2636_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_2637_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_2638_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_2639_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2640_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2641_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2642_log__base__10__eq2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq2
thf(fact_2643_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_2644_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2645_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_2646_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_concat_bit @ ( suc @ N ) @ K @ L )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L ) ) ) ) ).

% concat_bit_Suc
thf(fact_2647_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X ) ) ) ) ).

% arctan_inverse
thf(fact_2648_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2649_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_2650_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_2651_int__dvd__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( dvd_dvd @ nat @ M @ N ) ) ).

% int_dvd_int_iff
thf(fact_2652_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_2653_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_2654_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_2655_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_2656_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( dvd_dvd @ A @ X @ ( uminus_uminus @ A @ Y ) )
          = ( dvd_dvd @ A @ X @ Y ) ) ) ).

% dvd_minus_iff
thf(fact_2657_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X ) @ Y )
          = ( dvd_dvd @ A @ X @ Y ) ) ) ).

% minus_dvd_iff
thf(fact_2658_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_2659_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_2660_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_2661_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_2662_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_2663_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_2664_binomial__Suc__n,axiom,
    ! [N: nat] :
      ( ( binomial @ ( suc @ N ) @ N )
      = ( suc @ N ) ) ).

% binomial_Suc_n
thf(fact_2665_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2666_binomial__n__n,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ N )
      = ( one_one @ nat ) ) ).

% binomial_n_n
thf(fact_2667_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_2668_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_2669_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_2670_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_2671_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_2672_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_2673_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_2674_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_2675_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_2676_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_2677_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_2678_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_2679_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_2680_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_2681_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_2682_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_2683_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_2684_binomial__1,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = N ) ).

% binomial_1
thf(fact_2685_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N @ K ) ) ).

% binomial_eq_0_iff
thf(fact_2686_binomial__Suc__Suc,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_2687_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2688_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_2689_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ( suc @ N )
        = ( numeral_numeral @ nat @ K ) )
      = ( N
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2690_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N ) )
      = ( ( pred_numeral @ K )
        = N ) ) ).

% eq_numeral_Suc
thf(fact_2691_dvd__nat__abs__iff,axiom,
    ! [N: nat,K: int] :
      ( ( dvd_dvd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% dvd_nat_abs_iff
thf(fact_2692_nat__abs__dvd__iff,axiom,
    ! [K: int,N: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( dvd_dvd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_abs_dvd_iff
thf(fact_2693_sgn__mult__dvd__iff,axiom,
    ! [R: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_2694_mult__sgn__dvd__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_2695_dvd__sgn__mult__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_2696_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_2697_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_2698_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_2699_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_2700_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_2701_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% even_Suc_Suc_iff
thf(fact_2702_even__Suc,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_Suc
thf(fact_2703_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_2704_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) )
      = ( ord_less_eq @ nat @ K @ N ) ) ).

% zero_less_binomial_iff
thf(fact_2705_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2706_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2707_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% less_numeral_Suc
thf(fact_2708_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2709_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% le_numeral_Suc
thf(fact_2710_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2711_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% diff_numeral_Suc
thf(fact_2712_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_2713_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_2714_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_2715_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_2716_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_2717_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_2718_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_2719_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_2720_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_2721_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_2722_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_2723_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_2724_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_of_nat
thf(fact_2725_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% odd_Suc_minus_one
thf(fact_2726_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ).

% even_diff_nat
thf(fact_2727_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_2728_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_2729_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_2730_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_2731_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% even_power
thf(fact_2732_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_2733_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2734_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_2735_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_2736_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_2737_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2738_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_2739_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ A2 ) ) ).

% dvd_refl
thf(fact_2740_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_2741_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% of_nat_dvd_iff
thf(fact_2742_choose__one,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( one_one @ nat ) )
      = N ) ).

% choose_one
thf(fact_2743_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( zero_zero @ A ) )
             => ( B3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_2744_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_2745_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B8: A,C6: A] :
              ( ( A2
                = ( times_times @ A @ B8 @ C6 ) )
              & ( dvd_dvd @ A @ B8 @ B2 )
              & ( dvd_dvd @ A @ C6 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_2746_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P4: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P4 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X4: A,Y3: A] :
                ( ( P4
                  = ( times_times @ A @ X4 @ Y3 ) )
               => ( ( dvd_dvd @ A @ X4 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y3 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_2747_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_2748_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_2749_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_2750_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_2751_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_2752_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_2753_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_2754_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B3: A,A4: A] :
            ? [K2: A] :
              ( A4
              = ( times_times @ A @ B3 @ K2 ) ) ) ) ) ).

% dvd_def
thf(fact_2755_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_2756_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K3: A] :
                ( A2
               != ( times_times @ A @ B2 @ K3 ) ) ) ) ).

% dvdE
thf(fact_2757_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_2758_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_2759_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_2760_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_2761_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_2762_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_2763_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_2764_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( dvd_dvd @ A @ X @ Z )
           => ( dvd_dvd @ A @ X @ ( minus_minus @ A @ Y @ Z ) ) ) ) ) ).

% dvd_diff
thf(fact_2765_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_2766_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_2767_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_2768_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) ) ) ) ).

% dvd_power_same
thf(fact_2769_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_2770_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) )
        & ( A2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_2771_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_2772_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
        & ( ( zero_zero @ nat )
         != A2 ) ) ).

% gcd_nat.extremum_strict
thf(fact_2773_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_2774_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_2775_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L: A,K: A] :
          ( ( ( abs_abs @ A @ L )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_2776_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_iff
thf(fact_2777_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_2778_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% dvd_diff_nat
thf(fact_2779_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ K @ ( minus_minus @ int @ M @ N ) )
     => ( ( dvd_dvd @ int @ K @ N )
       => ( dvd_dvd @ int @ K @ M ) ) ) ).

% zdvd_zdiffD
thf(fact_2780_zdvd__antisym__abs,axiom,
    ! [A2: int,B2: int] :
      ( ( dvd_dvd @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ B2 @ A2 )
       => ( ( abs_abs @ int @ A2 )
          = ( abs_abs @ int @ B2 ) ) ) ) ).

% zdvd_antisym_abs
thf(fact_2781_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L: int,R: int] :
      ( ( bit_concat_bit @ N @ K @ ( bit_concat_bit @ M @ L @ R ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N ) @ ( bit_concat_bit @ N @ K @ L ) @ R ) ) ).

% concat_bit_assoc
thf(fact_2782_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ N @ K )
     => ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_2783_Suc__times__binomial__eq,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_2784_Suc__times__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) ) ).

% Suc_times_binomial
thf(fact_2785_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( binomial @ N @ ( minus_minus @ nat @ N @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_2786_choose__mult__lemma,axiom,
    ! [M: nat,R: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_2787_binomial__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R @ N )
     => ( ord_less_eq @ nat @ ( binomial @ N @ R ) @ ( power_power @ nat @ N @ R ) ) ) ).

% binomial_le_pow
thf(fact_2788_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_2789_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ Z5 @ X5 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_2790_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ Z5 @ X5 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_2791_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ X5 @ Z5 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ).

% minf(9)
thf(fact_2792_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ X5 @ Z5 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_2793_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_2794_binomial__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat,K: nat] :
          ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
          = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K ) ) ) ).

% binomial_gbinomial
thf(fact_2795_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_2796_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_2797_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_2798_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_2799_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_2800_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_2801_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_2802_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_2803_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_2804_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_2805_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_2806_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_2807_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_2808_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_2809_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_2810_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_2811_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_2812_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_2813_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_2814_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_2815_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% div_power
thf(fact_2816_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_2817_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( modulo_modulo @ A @ B3 @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_2818_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_2819_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% le_imp_power_dvd
thf(fact_2820_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_2821_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N: nat,M: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_2822_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_2823_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_2824_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_2825_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_2826_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_2827_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_2828_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_2829_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) )
      = ( ( ord_less @ nat @ N @ M )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_minus_self
thf(fact_2830_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
       => ( ( dvd_dvd @ int @ M @ N )
         => ( ( dvd_dvd @ int @ N @ M )
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_2831_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_2832_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ N ) ) ) ) ).

% dvd_diffD1
thf(fact_2833_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_2834_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N )
       => ~ ( dvd_dvd @ int @ N @ M ) ) ) ).

% zdvd_not_zless
thf(fact_2835_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_2836_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N ) ) ) ).

% zdvd_mult_cancel
thf(fact_2837_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D6: nat,X4: nat,Y3: nat] :
      ( ( dvd_dvd @ nat @ D6 @ A2 )
      & ( dvd_dvd @ nat @ D6 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X4 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ D6 ) )
        | ( ( times_times @ nat @ B2 @ X4 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ D6 ) ) ) ) ).

% bezout_add_nat
thf(fact_2838_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X: nat,Y: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A2 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y ) @ D2 ) ) )
         => ? [X4: nat,Y3: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A2 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X4 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y3 ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X4 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_2839_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_2840_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D6: nat,X4: nat,Y3: nat] :
      ( ( dvd_dvd @ nat @ D6 @ A2 )
      & ( dvd_dvd @ nat @ D6 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X4 ) @ ( times_times @ nat @ B2 @ Y3 ) )
          = D6 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X4 ) @ ( times_times @ nat @ A2 @ Y3 ) )
          = D6 ) ) ) ).

% bezout1_nat
thf(fact_2841_zdvd__period,axiom,
    ! [A2: int,D2: int,X: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_2842_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N ) ) ).

% zdvd_reduce
thf(fact_2843_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K2: num] : ( suc @ ( pred_numeral @ K2 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2844_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( binomial @ N @ ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_2845_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( dvd_dvd @ int @ Z @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_2846_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) ) ) ).

% zero_less_binomial
thf(fact_2847_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_2848_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( times_times @ nat @ ( binomial @ N @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N @ K ) @ ( binomial @ ( minus_minus @ nat @ N @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_2849_binomial__Suc__Suc__eq__times,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_2850_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N @ K ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_2851_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C4: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C4 ) ) ) ) ) ).

% unit_dvdE
thf(fact_2852_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X3: A] : ( P @ ( times_times @ A @ L @ X3 ) ) )
          = ( ? [X3: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X3 @ ( zero_zero @ A ) ) )
                & ( P @ X3 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_2853_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_2854_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_2855_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_2856_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_2857_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_2858_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D3: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D3 )
         => ! [X5: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X5 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D3 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_2859_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D3: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D3 )
         => ! [X5: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X5 @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D3 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_2860_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_2861_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_2862_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_2863_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_2864_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_2865_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_2866_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_2867_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_2868_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat @ K @ N ) ) ) ).

% dvd_imp_le
thf(fact_2869_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_2870_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_2871_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_mult_cancel
thf(fact_2872_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D6: nat,X4: nat,Y3: nat] :
          ( ( dvd_dvd @ nat @ D6 @ A2 )
          & ( dvd_dvd @ nat @ D6 @ B2 )
          & ( ( times_times @ nat @ A2 @ X4 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ D6 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_2873_zdvd__imp__le,axiom,
    ! [Z: int,N: int] :
      ( ( dvd_dvd @ int @ Z @ N )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int @ Z @ N ) ) ) ).

% zdvd_imp_le
thf(fact_2874_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_2875_dvd__imp__le__int,axiom,
    ! [I: int,D2: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2876_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q2 )
          = ( modulo_modulo @ nat @ N @ Q2 ) )
        = ( dvd_dvd @ nat @ Q2 @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_2877_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_2878_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_2879_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K2: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K2 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2880_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% dvd_fact
thf(fact_2881_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_2882_binomial__absorption,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N @ ( suc @ K ) ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_2883_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_2884_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_2885_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_2886_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B5: A] :
                  ( ( B5
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B5 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B5 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B5 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B5 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B5 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_2887_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B5: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B5 ) ) ) ) ).

% evenE
thf(fact_2888_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_2889_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_2890_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ N ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_2891_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( binomial @ N @ K ) )
        = ( semiring_char_0_fact @ nat @ N ) ) ) ).

% binomial_fact_lemma
thf(fact_2892_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N ) ) ) ) ).

% dvd_power
thf(fact_2893_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2894_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2895_div2__even__ext__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y ) )
       => ( X = Y ) ) ) ).

% div2_even_ext_nat
thf(fact_2896_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_2897_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_2898_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_2899_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_2900_dvd__minus__add,axiom,
    ! [Q2: nat,N: nat,R: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q2 @ N )
     => ( ( ord_less_eq @ nat @ Q2 @ ( times_times @ nat @ R @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ Q2 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N @ ( minus_minus @ nat @ ( times_times @ nat @ R @ M ) @ Q2 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_2901_mod__nat__eqI,axiom,
    ! [R: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ R @ N )
     => ( ( ord_less_eq @ nat @ R @ M )
       => ( ( dvd_dvd @ nat @ N @ ( minus_minus @ nat @ M @ R ) )
         => ( ( modulo_modulo @ nat @ M @ N )
            = R ) ) ) ) ).

% mod_nat_eqI
thf(fact_2902_power__dvd__imp__le,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_2903_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N ) @ M )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2904_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( ( L
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% mod_int_pos_iff
thf(fact_2905_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2906_bset_I9_J,axiom,
    ! [D2: int,D3: int,B4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B4 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_2907_bset_I10_J,axiom,
    ! [D2: int,D3: int,B4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B4 )
                 => ( X5
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_2908_aset_I9_J,axiom,
    ! [D2: int,D3: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_2909_aset_I10_J,axiom,
    ! [D2: int,D3: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D3 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D3 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X5 @ D3 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_2910_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( dvd_dvd @ int @ L @ K )
     => ( ( divide_divide @ int @ K @ L )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_2911_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_2912_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% binomial_maximum'
thf(fact_2913_binomial__mono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K8 ) @ N )
       => ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K8 ) ) ) ) ).

% binomial_mono
thf(fact_2914_binomial__maximum,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_2915_binomial__antimono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K8 @ N )
         => ( ord_less_eq @ nat @ ( binomial @ N @ K8 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_2916_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% binomial_le_pow2
thf(fact_2917_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_2918_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_2919_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_2920_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_2921_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_2922_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_2923_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_odd
thf(fact_2924_odd__pos,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% odd_pos
thf(fact_2925_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2926_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% dvd_power_iff_le
thf(fact_2927_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_2928_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2929_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_2930_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2931_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_2932_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_diff_iff
thf(fact_2933_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_abs_add_iff
thf(fact_2934_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_add_abs_iff
thf(fact_2935_binomial__strict__antimono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K8 @ N )
         => ( ord_less @ nat @ ( binomial @ N @ K8 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_2936_binomial__strict__mono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K8 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K8 ) @ N )
       => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K8 ) ) ) ) ).

% binomial_strict_mono
thf(fact_2937_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_2938_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2939_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2940_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_2941_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B5: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B5 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_2942_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_2943_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_2944_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_2945_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_2946_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_even_power
thf(fact_2947_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_2948_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_even
thf(fact_2949_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2950_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2951_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2952_arctan__ubound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2953_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_2954_choose__two,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_2955_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_2956_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2957_arctan__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2958_arctan__lbound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) ) ).

% arctan_lbound
thf(fact_2959_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_2960_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_2961_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_2962_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_2963_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2964_Bernoulli__inequality__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2965_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_2966_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_2967_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_2968_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_2969_binomial__code,axiom,
    ( binomial
    = ( ^ [N2: nat,K2: nat] : ( if @ nat @ ( ord_less @ nat @ N2 @ K2 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K2 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ K2 ) @ ( one_one @ nat ) ) @ N2 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K2 ) ) ) ) ) ) ).

% binomial_code
thf(fact_2970_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_2971_sin__cos__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% sin_cos_npi
thf(fact_2972_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_2973_cot__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_2974_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_2975_cos__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( uminus_uminus @ A @ X ) )
          = ( cos @ A @ X ) ) ) ).

% cos_minus
thf(fact_2976_sin__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( sin @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ A @ ( sin @ A @ X ) ) ) ) ).

% sin_minus
thf(fact_2977_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_2978_cot__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cot @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ A @ ( cot @ A @ X ) ) ) ) ).

% cot_minus
thf(fact_2979_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2980_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_2981_sin__pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ pi @ X ) )
      = ( sin @ real @ X ) ) ).

% sin_pi_minus
thf(fact_2982_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_2983_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2984_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_2985_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_2986_cos__pi,axiom,
    ( ( cos @ real @ pi )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% cos_pi
thf(fact_2987_cos__periodic__pi2,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi2
thf(fact_2988_cos__periodic__pi,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi
thf(fact_2989_sin__periodic__pi2,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi2
thf(fact_2990_sin__periodic__pi,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi
thf(fact_2991_cos__pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_pi_minus
thf(fact_2992_cos__minus__pi,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_minus_pi
thf(fact_2993_sin__minus__pi,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_minus_pi
thf(fact_2994_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ X ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_2995_cos__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% cos_of_real_pi
thf(fact_2996_sin__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2997_sin__npi2,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2998_sin__npi__int,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_2999_cot__npi,axiom,
    ! [N: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3000_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_3001_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_3002_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_3003_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_3004_cos__periodic,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X ) ) ).

% cos_periodic
thf(fact_3005_sin__periodic,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X ) ) ).

% sin_periodic
thf(fact_3006_cos__2pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( cos @ real @ X ) ) ).

% cos_2pi_minus
thf(fact_3007_cos__npi2,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi2
thf(fact_3008_cos__npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi
thf(fact_3009_cot__periodic,axiom,
    ! [X: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X ) ) ).

% cot_periodic
thf(fact_3010_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_3011_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_3012_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_3013_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_3014_sin__2npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_3015_cos__2npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_3016_sin__2pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_2pi_minus
thf(fact_3017_sin__int__2pin,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_3018_cos__int__2pin,axiom,
    ! [N: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_3019_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_3020_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_3021_cos__npi__int,axiom,
    ! [N: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_3022_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ N @ M )
       => ( M = N ) ) ) ).

% dvd_antisym
thf(fact_3023_gcd__nat_Oasym,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
     => ~ ( ( dvd_dvd @ nat @ B2 @ A2 )
          & ( B2 != A2 ) ) ) ).

% gcd_nat.asym
thf(fact_3024_gcd__nat_Orefl,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ A2 ) ).

% gcd_nat.refl
thf(fact_3025_gcd__nat_Otrans,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ B2 )
     => ( ( dvd_dvd @ nat @ B2 @ C2 )
       => ( dvd_dvd @ nat @ A2 @ C2 ) ) ) ).

% gcd_nat.trans
thf(fact_3026_gcd__nat_Oeq__iff,axiom,
    ( ( ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    = ( ^ [A4: nat,B3: nat] :
          ( ( dvd_dvd @ nat @ A4 @ B3 )
          & ( dvd_dvd @ nat @ B3 @ A4 ) ) ) ) ).

% gcd_nat.eq_iff
thf(fact_3027_gcd__nat_Oirrefl,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ A2 @ A2 )
        & ( A2 != A2 ) ) ).

% gcd_nat.irrefl
thf(fact_3028_gcd__nat_Oantisym,axiom,
    ! [A2: nat,B2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ B2 )
     => ( ( dvd_dvd @ nat @ B2 @ A2 )
       => ( A2 = B2 ) ) ) ).

% gcd_nat.antisym
thf(fact_3029_gcd__nat_Ostrict__trans,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
     => ( ( ( dvd_dvd @ nat @ B2 @ C2 )
          & ( B2 != C2 ) )
       => ( ( dvd_dvd @ nat @ A2 @ C2 )
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans
thf(fact_3030_gcd__nat_Ostrict__trans1,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ B2 )
     => ( ( ( dvd_dvd @ nat @ B2 @ C2 )
          & ( B2 != C2 ) )
       => ( ( dvd_dvd @ nat @ A2 @ C2 )
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans1
thf(fact_3031_gcd__nat_Ostrict__trans2,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
     => ( ( dvd_dvd @ nat @ B2 @ C2 )
       => ( ( dvd_dvd @ nat @ A2 @ C2 )
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans2
thf(fact_3032_gcd__nat_Ostrict__iff__not,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
      = ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ~ ( dvd_dvd @ nat @ B2 @ A2 ) ) ) ).

% gcd_nat.strict_iff_not
thf(fact_3033_gcd__nat_Oorder__iff__strict,axiom,
    ( ( dvd_dvd @ nat )
    = ( ^ [A4: nat,B3: nat] :
          ( ( ( dvd_dvd @ nat @ A4 @ B3 )
            & ( A4 != B3 ) )
          | ( A4 = B3 ) ) ) ) ).

% gcd_nat.order_iff_strict
thf(fact_3034_gcd__nat_Ostrict__iff__order,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
      = ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) ) ) ).

% gcd_nat.strict_iff_order
thf(fact_3035_gcd__nat_Ostrict__implies__order,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
     => ( dvd_dvd @ nat @ A2 @ B2 ) ) ).

% gcd_nat.strict_implies_order
thf(fact_3036_gcd__nat_Ostrict__implies__not__eq,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
     => ( A2 != B2 ) ) ).

% gcd_nat.strict_implies_not_eq
thf(fact_3037_gcd__nat_Onot__eq__order__implies__strict,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != B2 )
     => ( ( dvd_dvd @ nat @ A2 @ B2 )
       => ( ( dvd_dvd @ nat @ A2 @ B2 )
          & ( A2 != B2 ) ) ) ) ).

% gcd_nat.not_eq_order_implies_strict
thf(fact_3038_diffs__sin__coeff,axiom,
    ( ( diffs @ real @ sin_coeff )
    = cos_coeff ) ).

% diffs_sin_coeff
thf(fact_3039_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X3: A] : ( divide_divide @ A @ ( cos @ A @ X3 ) @ ( sin @ A @ X3 ) ) ) ) ) ).

% cot_def
thf(fact_3040_polar__Ex,axiom,
    ! [X: real,Y: real] :
    ? [R4: real,A5: real] :
      ( ( X
        = ( times_times @ real @ R4 @ ( cos @ real @ A5 ) ) )
      & ( Y
        = ( times_times @ real @ R4 @ ( sin @ real @ A5 ) ) ) ) ).

% polar_Ex
thf(fact_3041_diffs__cos__coeff,axiom,
    ( ( diffs @ real @ cos_coeff )
    = ( ^ [N2: nat] : ( uminus_uminus @ real @ ( sin_coeff @ N2 ) ) ) ) ).

% diffs_cos_coeff
thf(fact_3042_cos__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: real] :
          ( ( cos @ A @ ( real_Vector_of_real @ A @ X ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ X ) ) ) ) ).

% cos_of_real
thf(fact_3043_cot__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: real] :
          ( ( real_Vector_of_real @ A @ ( cot @ real @ X ) )
          = ( cot @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ).

% cot_of_real
thf(fact_3044_sin__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: real] :
          ( ( sin @ A @ ( real_Vector_of_real @ A @ X ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ X ) ) ) ) ).

% sin_of_real
thf(fact_3045_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% sin_diff
thf(fact_3046_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% sin_add
thf(fact_3047_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_3048_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% cos_diff
thf(fact_3049_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% cos_add
thf(fact_3050_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3051_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3052_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X ) ) @ ( cos @ A @ X ) ) ) ) ).

% sin_double
thf(fact_3053_sincos__principal__value,axiom,
    ! [X: real] :
    ? [Y3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y3 )
      & ( ord_less_eq @ real @ Y3 @ pi )
      & ( ( sin @ real @ Y3 )
        = ( sin @ real @ X ) )
      & ( ( cos @ real @ Y3 )
        = ( cos @ real @ X ) ) ) ).

% sincos_principal_value
thf(fact_3054_sin__x__le__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( sin @ real @ X ) @ X ) ) ).

% sin_x_le_x
thf(fact_3055_sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_3056_cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_3057_abs__sin__x__le__abs__x,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( abs_abs @ real @ X ) ) ).

% abs_sin_x_le_abs_x
thf(fact_3058_cos__arctan__not__zero,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_3059_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% cos_int_times_real
thf(fact_3060_sin__cos__le1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) ) @ ( times_times @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3061_sin__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( sin_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( cos_coeff @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% sin_coeff_Suc
thf(fact_3062_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% sin_int_times_real
thf(fact_3063_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3064_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3065_sin__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero
thf(fact_3066_sin__x__ge__neg__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ ( sin @ real @ X ) ) ) ).

% sin_x_ge_neg_x
thf(fact_3067_sin__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_ge_zero
thf(fact_3068_sin__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X ) ) ).

% sin_ge_minus_one
thf(fact_3069_cos__monotone__0__pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_3070_cos__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less_eq @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_3071_cos__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ( cos @ real @ X )
                = ( cos @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_3072_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_3073_cos__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X ) ) ).

% cos_ge_minus_one
thf(fact_3074_abs__sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_3075_abs__cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_3076_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3077_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3078_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3079_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3080_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3081_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3082_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3083_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X3: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X3 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_3084_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X3: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X3 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_3085_cos__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( cos_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% cos_coeff_Suc
thf(fact_3086_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3087_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X ) )
          = ( cos @ A @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_3088_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3089_cos__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_3090_cos__monotone__0__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_3091_sin__eq__0__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ( ( sin @ real @ X )
            = ( zero_zero @ real ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_3092_sin__zero__pi__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ pi )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_3093_cos__monotone__minus__pi__0_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_3094_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( X
            = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_3095_sincos__total__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X
              = ( cos @ real @ T4 ) )
            & ( Y
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3096_sin__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3097_cos__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3098_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero_02
thf(fact_3099_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3100_cos__is__zero,axiom,
    ? [X4: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
      & ( ord_less_eq @ real @ X4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X4 )
        = ( zero_zero @ real ) )
      & ! [Y4: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
            & ( ord_less_eq @ real @ Y4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y4 )
              = ( zero_zero @ real ) ) )
         => ( Y4 = X4 ) ) ) ).

% cos_is_zero
thf(fact_3101_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3102_cos__monotone__minus__pi__0,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_3103_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F5: nat > A > A,A4: nat,B3: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B3 @ A4 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F5 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B3 @ ( F5 @ A4 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_3104_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb3: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb3 @ Xc )
        = Y )
     => ( ( ( ord_less @ nat @ Xb3 @ Xa )
         => ( Y = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb3 @ Xa )
         => ( Y
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb3 @ ( X @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_3105_cos__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
            & ( ord_less_eq @ real @ X4 @ pi )
            & ( ( cos @ real @ X4 )
              = Y )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ pi )
                  & ( ( cos @ real @ Y4 )
                    = Y ) )
               => ( Y4 = X4 ) ) ) ) ) ).

% cos_total
thf(fact_3106_sincos__total__pi__half,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X
                = ( cos @ real @ T4 ) )
              & ( Y
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3107_sincos__total__2pi__le,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X
            = ( cos @ real @ T4 ) )
          & ( Y
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3108_sincos__total__2pi,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X
                  = ( cos @ real @ T4 ) )
               => ( Y
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3109_sin__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_3110_cos__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_3111_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_3112_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3113_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3114_sin__gt__zero2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero2
thf(fact_3115_sin__lt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_3116_cos__double__less__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3117_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_3118_cos__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero
thf(fact_3119_sin__monotone__2pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_3120_sin__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_3121_sin__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X )
                = ( sin @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_3122_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3123_cos__one__2pi__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X3: int] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3124_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3125_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3126_sin__le__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_3127_sin__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_3128_sin__monotone__2pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_3129_sin__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_3130_sin__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X4: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X4 )
            & ( ord_less_eq @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X4 )
              = Y )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y4 )
                    = Y ) )
               => ( Y4 = X4 ) ) ) ) ) ).

% sin_total
thf(fact_3131_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3132_cos__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_ge_zero
thf(fact_3133_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X3: nat] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X3: nat] :
            ( X
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X3 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3134_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_3135_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I3 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_3136_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I3: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I3 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3137_cot__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X ) ) ) ) ).

% cot_gt_zero
thf(fact_3138_sin__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_3139_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_3140_cos__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( cos @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3141_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3142_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_3143_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3144_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3145_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K3: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K3 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3146_le__arcsin__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y @ ( arcsin @ X ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y ) @ X ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3147_arcsin__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ Y )
              = ( ord_less_eq @ real @ X @ ( sin @ real @ Y ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3148_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_3149_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_3150_tan__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( tan @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ A @ ( tan @ A @ X ) ) ) ) ).

% tan_minus
thf(fact_3151_tan__periodic__pi,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_pi
thf(fact_3152_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_3153_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3154_tan__npi,axiom,
    ! [N: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3155_tan__periodic__n,axiom,
    ! [X: real,N: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_n
thf(fact_3156_tan__periodic__nat,axiom,
    ! [X: real,N: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_nat
thf(fact_3157_tan__periodic__int,axiom,
    ! [X: real,I: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( ring_1_of_int @ real @ I ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_int
thf(fact_3158_arccos__minus__1,axiom,
    ( ( arccos @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = pi ) ).

% arccos_minus_1
thf(fact_3159_cos__arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y ) )
          = Y ) ) ) ).

% cos_arccos
thf(fact_3160_sin__arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y ) )
          = Y ) ) ) ).

% sin_arcsin
thf(fact_3161_norm__cos__sin,axiom,
    ! [T2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ ( cos @ real @ T2 ) @ ( sin @ real @ T2 ) ) )
      = ( one_one @ real ) ) ).

% norm_cos_sin
thf(fact_3162_tan__periodic,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic
thf(fact_3163_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3164_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3165_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3166_tan__of__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: real] :
          ( ( real_Vector_of_real @ A @ ( tan @ real @ X ) )
          = ( tan @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ).

% tan_of_real
thf(fact_3167_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A2
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_3168_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_3169_complex__eq__cancel__iff2,axiom,
    ! [X: real,Y: real,Xa: real] :
      ( ( ( complex2 @ X @ Y )
        = ( real_Vector_of_real @ complex @ Xa ) )
      = ( ( X = Xa )
        & ( Y
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_3170_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X3: real] : ( complex2 @ X3 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_3171_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_3172_Complex__mult__complex__of__real,axiom,
    ! [X: real,Y: real,R: real] :
      ( ( times_times @ complex @ ( complex2 @ X @ Y ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( times_times @ real @ X @ R ) @ ( times_times @ real @ Y @ R ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_3173_complex__of__real__mult__Complex,axiom,
    ! [R: real,X: real,Y: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X @ Y ) )
      = ( complex2 @ ( times_times @ real @ R @ X ) @ ( times_times @ real @ R @ Y ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_3174_complex__diff,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( minus_minus @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ A2 @ C2 ) @ ( minus_minus @ real @ B2 @ D2 ) ) ) ).

% complex_diff
thf(fact_3175_tan__arctan,axiom,
    ! [Y: real] :
      ( ( tan @ real @ ( arctan @ Y ) )
      = Y ) ).

% tan_arctan
thf(fact_3176_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3177_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3178_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_3179_cot__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X3: A] : ( inverse_inverse @ A @ ( tan @ A @ X3 ) ) ) ) ) ).

% cot_altdef
thf(fact_3180_tan__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X3: A] : ( inverse_inverse @ A @ ( cot @ A @ X3 ) ) ) ) ) ).

% tan_altdef
thf(fact_3181_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3182_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_3183_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_3184_arccos__le__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3185_arccos__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% arccos_le_mono
thf(fact_3186_arccos__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X )
          = ( arccos @ Y ) )
        = ( X = Y ) ) ) ).

% arccos_eq_iff
thf(fact_3187_arcsin__le__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_3188_arcsin__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ real @ ( arcsin @ X ) ) ) ) ) ).

% arcsin_minus
thf(fact_3189_arcsin__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% arcsin_le_mono
thf(fact_3190_arcsin__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X )
            = ( arcsin @ Y ) )
          = ( X = Y ) ) ) ) ).

% arcsin_eq_iff
thf(fact_3191_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X3: A] : ( divide_divide @ A @ ( sin @ A @ X3 ) @ ( cos @ A @ X3 ) ) ) ) ) ).

% tan_def
thf(fact_3192_arccos__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) ) ) ) ).

% arccos_lbound
thf(fact_3193_arccos__less__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3194_arccos__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% arccos_less_mono
thf(fact_3195_arccos__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3196_arccos__cos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( arccos @ ( cos @ real @ X ) )
          = X ) ) ) ).

% arccos_cos
thf(fact_3197_arcsin__less__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3198_arcsin__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% arcsin_less_mono
thf(fact_3199_cos__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y ) )
        = Y ) ) ).

% cos_arccos_abs
thf(fact_3200_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3201_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3202_arccos__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3203_arccos__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3204_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3205_arccos__cos2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( arccos @ ( cos @ real @ X ) )
          = ( uminus_uminus @ real @ X ) ) ) ) ).

% arccos_cos2
thf(fact_3206_arccos__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ) ).

% arccos_minus
thf(fact_3207_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3208_lemma__tan__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X4 )
          & ( ord_less @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y @ ( tan @ real @ X4 ) ) ) ) ).

% lemma_tan_total
thf(fact_3209_tan__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_gt_zero
thf(fact_3210_tan__total,axiom,
    ! [Y: real] :
    ? [X4: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X4 )
      & ( ord_less @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X4 )
        = Y )
      & ! [Y4: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y4 )
            & ( ord_less @ real @ Y4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y4 )
              = Y ) )
         => ( Y4 = X4 ) ) ) ).

% tan_total
thf(fact_3211_tan__monotone,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ).

% tan_monotone
thf(fact_3212_tan__monotone_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
         => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y @ X )
              = ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3213_tan__mono__lt__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3214_lemma__tan__total1,axiom,
    ! [Y: real] :
    ? [X4: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X4 )
      & ( ord_less @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X4 )
        = Y ) ) ).

% lemma_tan_total1
thf(fact_3215_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3216_tan__inverse,axiom,
    ! [Y: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y ) ) ) ).

% tan_inverse
thf(fact_3217_tan__cot,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X ) ) ) ).

% tan_cot
thf(fact_3218_arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y ) )
            = Y ) ) ) ) ).

% arccos
thf(fact_3219_arccos__minus__abs,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ).

% arccos_minus_abs
thf(fact_3220_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3221_tan__cot_H,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( cot @ real @ X ) ) ).

% tan_cot'
thf(fact_3222_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3223_tan__total__pos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ? [X4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
          & ( ord_less @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X4 )
            = Y ) ) ) ).

% tan_total_pos
thf(fact_3224_tan__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3225_tan__mono__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) ) ) ) ) ).

% tan_mono_le
thf(fact_3226_tan__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3227_tan__bound__pi2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3228_arctan,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y ) )
        = Y ) ) ).

% arctan
thf(fact_3229_arctan__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X ) )
          = X ) ) ) ).

% arctan_tan
thf(fact_3230_arctan__unique,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X )
            = Y )
         => ( ( arctan @ Y )
            = X ) ) ) ) ).

% arctan_unique
thf(fact_3231_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3232_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3233_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3234_tan__total__pi4,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ? [Z5: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z5 )
          & ( ord_less @ real @ Z5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z5 )
            = X ) ) ) ).

% tan_total_pi4
thf(fact_3235_arccos__le__pi2,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3236_arcsin__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3237_arcsin__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) ) ) ) ).

% arcsin_lbound
thf(fact_3238_arcsin__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3239_arcsin__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3240_arcsin__sin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X ) )
          = X ) ) ) ).

% arcsin_sin
thf(fact_3241_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3242_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X3: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X3 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3243_arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin
thf(fact_3244_arcsin__pi,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin_pi
thf(fact_3245_sin__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X )
        = ( divide_divide @ real @ ( tan @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3246_cos__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3247_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_3248_set__decode__Suc,axiom,
    ! [N: nat,X: nat] :
      ( ( member @ nat @ ( suc @ N ) @ ( nat_set_decode @ X ) )
      = ( member @ nat @ N @ ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_3249_set__decode__0,axiom,
    ! [X: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% set_decode_0
thf(fact_3250_nat__of__bool,axiom,
    ! [P: $o] :
      ( ( nat2 @ ( zero_neq_one_of_bool @ int @ P ) )
      = ( zero_neq_one_of_bool @ nat @ P ) ) ).

% nat_of_bool
thf(fact_3251_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_3252_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_3253_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_3254_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_3255_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_3256_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_3257_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_3258_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_3259_real__sqrt__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% real_sqrt_le_iff
thf(fact_3260_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_3261_real__sqrt__eq__1__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( one_one @ real ) )
      = ( X
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_3262_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_3263_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_3264_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( ring_1_of_int @ A @ ( zero_neq_one_of_bool @ int @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_int_of_bool
thf(fact_3265_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_3266_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_3267_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_3268_Suc__0__mod__eq,axiom,
    ! [N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_3269_real__sqrt__gt__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_gt_0_iff
thf(fact_3270_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_3271_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_3272_real__sqrt__ge__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_ge_0_iff
thf(fact_3273_real__sqrt__gt__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_gt_1_iff
thf(fact_3274_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_3275_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_3276_real__sqrt__ge__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_ge_1_iff
thf(fact_3277_real__sqrt__abs2,axiom,
    ! [X: real] :
      ( ( sqrt @ ( times_times @ real @ X @ X ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs2
thf(fact_3278_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_3279_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3280_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_3281_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_3282_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sgn_of_nat
thf(fact_3283_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_3284_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% real_sqrt_pow2_iff
thf(fact_3285_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X ) ) ).

% real_sqrt_pow2
thf(fact_3286_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_3287_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_3288_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_3289_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_3290_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P4: $o,Q2: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P4 )
            = ( zero_neq_one_of_bool @ A @ Q2 ) )
          = ( P4 = Q2 ) ) ) ).

% of_bool_eq_iff
thf(fact_3291_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A5: complex,R4: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R4 ) @ ( exp @ complex @ A5 ) ) ) ).

% complex_exp_exists
thf(fact_3292_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X3: complex,Y6: complex] : ( times_times @ complex @ X3 @ ( inverse_inverse @ complex @ Y6 ) ) ) ) ).

% divide_complex_def
thf(fact_3293_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_3294_real__sqrt__mult,axiom,
    ! [X: real,Y: real] :
      ( ( sqrt @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_mult
thf(fact_3295_real__sqrt__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_le_mono
thf(fact_3296_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% subset_decode_imp_le
thf(fact_3297_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_gt_zero
thf(fact_3298_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sqrt @ X )
          = ( zero_zero @ real ) )
       => ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_3299_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_zero
thf(fact_3300_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_3301_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_one
thf(fact_3302_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_3303_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P2: $o] : ( if @ A @ P2 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_3304_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ( P4
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P4
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_3305_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ~ ( ( P4
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P4
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_3306_real__div__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ X @ ( sqrt @ X ) )
        = ( sqrt @ X ) ) ) ).

% real_div_sqrt
thf(fact_3307_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X @ Y ) ) @ ( plus_plus @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_3308_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X @ X ) @ ( times_times @ real @ Y @ Y ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_3309_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ ( sqrt @ X ) @ X )
        = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3310_sqrt__le__D,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ Y )
     => ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_3311_real__le__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less_eq @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_le_rsqrt
thf(fact_3312_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3313_real__sqrt__unique,axiom,
    ! [Y: real,X: real] :
      ( ( ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( sqrt @ X )
          = Y ) ) ) ).

% real_sqrt_unique
thf(fact_3314_real__le__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_le_lsqrt
thf(fact_3315_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_3316_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X )
     => ( Y
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_3317_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y )
     => ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_3318_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_3319_real__sqrt__sum__squares__ge2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ Y @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_3320_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_3321_sqrt__ge__absD,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ Y ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y ) ) ).

% sqrt_ge_absD
thf(fact_3322_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A5: A] :
              ( ( ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A5 )
             => ( P @ A5 ) )
         => ( ! [A5: A,B5: $o] :
                ( ( P @ A5 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B5 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A5 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B5 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_3323_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3324_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_3325_real__less__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_less_lsqrt
thf(fact_3326_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_3327_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3328_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3329_ln__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( sqrt @ X ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_3330_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ Y ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_3331_real__sqrt__ge__abs2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_3332_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_3333_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3334_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_3335_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_3336_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_3337_arsinh__real__aux,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_3338_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_3339_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X @ Y ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_3340_real__sqrt__power__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( sqrt @ X ) @ N )
          = ( power_power @ real @ X @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_3341_powr__half__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X ) ) ) ).

% powr_half_sqrt
thf(fact_3342_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X3: real] : ( ln_ln @ real @ ( plus_plus @ real @ X3 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_3343_cos__x__y__le__one,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_3344_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_3345_cos__arctan,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3346_sin__arctan,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3347_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ X @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_3348_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) )
     => ( ( sin @ real @ X )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3349_arctan__half,axiom,
    ( arctan
    = ( ^ [X3: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X3 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_3350_sin__arccos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3351_cos__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3352_sin__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3353_divide__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_3354_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K2: int,L4: int] :
          ( if @ int
          @ ( L4
            = ( zero_zero @ int ) )
          @ K2
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L4 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L4 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L4 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L4 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L4 @ K2 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_3355_modulo__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_3356_arcosh__real__def,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( arcosh @ real @ X )
        = ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_3357_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K2: int,L4: int] :
          ( if @ int
          @ ( L4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L4 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L4 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L4 @ K2 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_3358_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_3359_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_3360_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_3361_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_3362_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_3363_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% mask_nat_positive_iff
thf(fact_3364_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_3365_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_3366_norm__ii,axiom,
    ( ( real_V7770717601297561774m_norm @ complex @ imaginary_unit )
    = ( one_one @ real ) ) ).

% norm_ii
thf(fact_3367_norm__cis,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( cis @ A2 ) )
      = ( one_one @ real ) ) ).

% norm_cis
thf(fact_3368_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3369_complex__i__mult__minus,axiom,
    ! [X: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X ) )
      = ( uminus_uminus @ complex @ X ) ) ).

% complex_i_mult_minus
thf(fact_3370_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_3371_cis__pi,axiom,
    ( ( cis @ pi )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% cis_pi
thf(fact_3372_divide__i,axiom,
    ! [X: complex] :
      ( ( divide_divide @ complex @ X @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X ) ) ).

% divide_i
thf(fact_3373_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3374_divide__numeral__i,axiom,
    ! [Z: complex,N: num] :
      ( ( divide_divide @ complex @ Z @ ( times_times @ complex @ ( numeral_numeral @ complex @ N ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) @ ( numeral_numeral @ complex @ N ) ) ) ).

% divide_numeral_i
thf(fact_3375_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3376_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3377_i__even__power,axiom,
    ! [N: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N ) ) ).

% i_even_power
thf(fact_3378_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_3379_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_3380_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_nat_mask_eq
thf(fact_3381_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B3: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_3382_less__eq__mask,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% less_eq_mask
thf(fact_3383_cis__divide,axiom,
    ! [A2: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% cis_divide
thf(fact_3384_complex__i__not__zero,axiom,
    imaginary_unit
 != ( zero_zero @ complex ) ).

% complex_i_not_zero
thf(fact_3385_complex__i__not__one,axiom,
    imaginary_unit
 != ( one_one @ complex ) ).

% complex_i_not_one
thf(fact_3386_cis__neq__zero,axiom,
    ! [A2: real] :
      ( ( cis @ A2 )
     != ( zero_zero @ complex ) ) ).

% cis_neq_zero
thf(fact_3387_mask__nonnegative__int,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N ) ) ).

% mask_nonnegative_int
thf(fact_3388_not__mask__negative__int,axiom,
    ! [N: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_3389_DeMoivre,axiom,
    ! [A2: real,N: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3390_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3391_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W )
        = Z )
      = ( W
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) ) ) ).

% i_times_eq_iff
thf(fact_3392_less__mask,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ) ).

% less_mask
thf(fact_3393_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3394_Complex__eq__i,axiom,
    ! [X: real,Y: real] :
      ( ( ( complex2 @ X @ Y )
        = imaginary_unit )
      = ( ( X
          = ( zero_zero @ real ) )
        & ( Y
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3395_i__mult__Complex,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% i_mult_Complex
thf(fact_3396_Complex__mult__i,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% Complex_mult_i
thf(fact_3397_complex__of__real__i,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% complex_of_real_i
thf(fact_3398_i__complex__of__real,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% i_complex_of_real
thf(fact_3399_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_3400_Complex__eq,axiom,
    ( complex2
    = ( ^ [A4: real,B3: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A4 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% Complex_eq
thf(fact_3401_Suc__mask__eq__exp,axiom,
    ! [N: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_mask_eq_exp
thf(fact_3402_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_3403_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R4: real,A5: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R4 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A5 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A5 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_3404_mask__half__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_3405_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N2: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_3406_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N2: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_3407_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N2: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_3408_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_3409_cmod__complex__polar,axiom,
    ! [R: real,A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) ) )
      = ( abs_abs @ real @ R ) ) ).

% cmod_complex_polar
thf(fact_3410_num_Osize__gen_I2_J,axiom,
    ! [X2: num] :
      ( ( size_num @ ( bit0 @ X2 ) )
      = ( plus_plus @ nat @ ( size_num @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_3411_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_3412_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z )
          = ( cis @ ( arg @ Z ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
        & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ) ).

% Arg_correct
thf(fact_3413_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_3414_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L4: int] :
          ( if @ int
          @ ( ( K2
              = ( zero_zero @ int ) )
            | ( L4
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L4
            @ ( if @ int
              @ ( L4
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K2
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_3415_sinh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( sinh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3416_sinh__real__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( sinh @ real @ X )
        = ( sinh @ real @ Y ) )
      = ( X = Y ) ) ).

% sinh_real_eq_iff
thf(fact_3417_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_3418_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_3419_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_3420_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_3421_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_3422_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3423_sinh__minus,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( sinh @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ A @ ( sinh @ A @ X ) ) ) ) ).

% sinh_minus
thf(fact_3424_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] :
      ( ( bit_concat_bit @ N @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_3425_sinh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sinh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3426_sinh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% sinh_real_less_iff
thf(fact_3427_sinh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% sinh_real_le_iff
thf(fact_3428_sinh__real__abs,axiom,
    ! [X: real] :
      ( ( sinh @ real @ ( abs_abs @ real @ X ) )
      = ( abs_abs @ real @ ( sinh @ real @ X ) ) ) ).

% sinh_real_abs
thf(fact_3429_csqrt__0,axiom,
    ( ( csqrt @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% csqrt_0
thf(fact_3430_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( csqrt @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% csqrt_eq_0
thf(fact_3431_csqrt__1,axiom,
    ( ( csqrt @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% csqrt_1
thf(fact_3432_csqrt__eq__1,axiom,
    ! [Z: complex] :
      ( ( ( csqrt @ Z )
        = ( one_one @ complex ) )
      = ( Z
        = ( one_one @ complex ) ) ) ).

% csqrt_eq_1
thf(fact_3433_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_3434_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_3435_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_3436_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_3437_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_3438_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_3439_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_3440_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_3441_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_3442_sinh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_pos_iff
thf(fact_3443_sinh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3444_sinh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_nonneg_iff
thf(fact_3445_sinh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3446_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_3447_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_3448_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_3449_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_3450_take__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% take_bit_of_Suc_0
thf(fact_3451_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_3452_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_3453_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(3)
thf(fact_3454_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_3455_and__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_3456_and__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_3457_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(6)
thf(fact_3458_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(4)
thf(fact_3459_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_3460_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_3461_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_3462_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_3463_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_3464_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_3465_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_3466_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_3467_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_3468_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q2 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N @ Q2 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_3469_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_and_eq
thf(fact_3470_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_3471_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_3472_take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% take_bit_diff
thf(fact_3473_take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% take_bit_mult
thf(fact_3474_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_3475_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_3476_arsinh__sinh__real,axiom,
    ! [X: real] :
      ( ( arsinh @ real @ ( sinh @ real @ X ) )
      = X ) ).

% arsinh_sinh_real
thf(fact_3477_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_3478_AND__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) ) ) ).

% AND_lower
thf(fact_3479_AND__upper1,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ X ) ) ).

% AND_upper1
thf(fact_3480_AND__upper2,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Y ) ) ).

% AND_upper2
thf(fact_3481_AND__upper1_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z ) ) ) ).

% AND_upper1'
thf(fact_3482_AND__upper2_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z ) ) ) ).

% AND_upper2'
thf(fact_3483_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_3484_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% take_bit_nonnegative
thf(fact_3485_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_3486_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_3487_not__take__bit__negative,axiom,
    ! [N: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_3488_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_3489_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_3490_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_3491_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_3492_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_3493_sinh__less__cosh__real,axiom,
    ! [X: real] : ( ord_less @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_less_cosh_real
thf(fact_3494_sinh__le__cosh__real,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_le_cosh_real
thf(fact_3495_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_3496_AND__upper2_H_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z ) ) ) ).

% AND_upper2''
thf(fact_3497_AND__upper1_H_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z ) ) ) ).

% AND_upper1''
thf(fact_3498_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_3499_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_3500_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_3501_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_3502_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% sinh_add
thf(fact_3503_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% cosh_add
thf(fact_3504_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% sinh_diff
thf(fact_3505_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% cosh_diff
thf(fact_3506_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% sinh_plus_cosh
thf(fact_3507_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% cosh_plus_sinh
thf(fact_3508_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( cis @ ( arg @ Z ) )
        = ( sgn_sgn @ complex @ Z ) ) ) ).

% cis_Arg
thf(fact_3509_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X3: A] : ( divide_divide @ A @ ( sinh @ A @ X3 ) @ ( cosh @ A @ X3 ) ) ) ) ) ).

% tanh_def
thf(fact_3510_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_3511_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_3512_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_3513_cosh__minus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ X ) )
          = ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) ) ).

% cosh_minus_sinh
thf(fact_3514_sinh__minus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) )
          = ( uminus_uminus @ A @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) ) ) ).

% sinh_minus_cosh
thf(fact_3515_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_3516_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_3517_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_3518_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_3519_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_3520_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_3521_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X ) ) @ ( cosh @ A @ X ) ) ) ) ).

% sinh_double
thf(fact_3522_of__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X ) ) ) ) ).

% of_real_sqrt
thf(fact_3523_Arg__bounded,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
      & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ).

% Arg_bounded
thf(fact_3524_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_3525_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_3526_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_3527_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_3528_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_3529_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_3530_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_3531_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_3532_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_3533_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_3534_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_3535_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( plus_plus @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_3536_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L4: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L4 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_3537_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_3538_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3539_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3540_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3541_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3542_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_3543_cis__Arg__unique,axiom,
    ! [Z: complex,X: real] :
      ( ( ( sgn_sgn @ complex @ Z )
        = ( cis @ X ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ( arg @ Z )
            = X ) ) ) ) ).

% cis_Arg_unique
thf(fact_3544_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_3545_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3546_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_3547_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_3548_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K2 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_3549_Suc__0__xor__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_3550_xor__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_3551_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_3552_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_3553_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_3554_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_3555_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_3556_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_3557_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_3558_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_3559_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ).

% signed_take_bit_negative_iff
thf(fact_3560_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_3561_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% xor_numerals(1)
thf(fact_3562_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y ) ) ) ) ).

% xor_numerals(2)
thf(fact_3563_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_3564_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_3565_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_3566_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_3567_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_3568_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_3569_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_3570_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_3571_and__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_3572_and__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_3573_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_3574_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_3575_xor__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% xor_nat_numerals(1)
thf(fact_3576_xor__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y ) ) ) ).

% xor_nat_numerals(2)
thf(fact_3577_xor__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% xor_nat_numerals(3)
thf(fact_3578_xor__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X ) ) ) ).

% xor_nat_numerals(4)
thf(fact_3579_and__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_3580_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_3581_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( N
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_3582_Suc__0__and__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_3583_and__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_3584_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_3585_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_3586_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_3587_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_3588_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_xor_eq
thf(fact_3589_num__induct,axiom,
    ! [P: num > $o,X: num] :
      ( ( P @ one2 )
     => ( ! [X4: num] :
            ( ( P @ X4 )
           => ( P @ ( inc @ X4 ) ) )
       => ( P @ X ) ) ) ).

% num_induct
thf(fact_3590_add__inc,axiom,
    ! [X: num,Y: num] :
      ( ( plus_plus @ num @ X @ ( inc @ Y ) )
      = ( inc @ ( plus_plus @ num @ X @ Y ) ) ) ).

% add_inc
thf(fact_3591_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_3592_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_3593_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_3594_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N )
          = ( B2
            & ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_3595_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_3596_inc_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit0 @ X ) )
      = ( bit1 @ X ) ) ).

% inc.simps(2)
thf(fact_3597_inc_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit1 @ X ) )
      = ( bit0 @ ( inc @ X ) ) ) ).

% inc.simps(3)
thf(fact_3598_add__One,axiom,
    ! [X: num] :
      ( ( plus_plus @ num @ X @ one2 )
      = ( inc @ X ) ) ).

% add_One
thf(fact_3599_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_3600_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff'
thf(fact_3601_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% and_nat_def
thf(fact_3602_mult__inc,axiom,
    ! [X: num,Y: num] :
      ( ( times_times @ num @ X @ ( inc @ Y ) )
      = ( plus_plus @ num @ ( times_times @ num @ X @ Y ) @ X ) ) ).

% mult_inc
thf(fact_3603_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_3604_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L ) @ N )
      = ( ( ( ord_less @ nat @ N @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) )
        | ( ( ord_less_eq @ nat @ M @ N )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_3605_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_3606_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) ) ).

% bit_Suc
thf(fact_3607_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M4: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M4 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M4 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_3608_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_3609_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_3610_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_3611_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_3612_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_3613_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( ( M3
              = ( zero_zero @ nat ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_3614_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_3615_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_3616_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_3617_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_3618_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_3619_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_3620_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K2: int] :
          ( plus_plus @ int @ K2
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% set_bit_eq
thf(fact_3621_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ K2 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_3622_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_3623_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3624_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_3625_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X3 ) @ ( exp @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3626_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A4: complex,B3: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A4 @ ( cnj @ B3 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_3627_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( ( A2 = B2 )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_3628_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_3629_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X: A,A2: real,Y: A] :
          ( ( times_times @ A @ X @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) ).

% mult_scaleR_right
thf(fact_3630_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ Y )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) ).

% mult_scaleR_left
thf(fact_3631_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
          = ( ( X = Y )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_3632_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_3633_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_3634_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_3635_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_3636_scaleR__one,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( one_one @ real ) @ X )
          = X ) ) ).

% scaleR_one
thf(fact_3637_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_3638_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_3639_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X ) ) ) ).

% scaleR_scaleR
thf(fact_3640_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_3641_complex__cnj__mult,axiom,
    ! [X: complex,Y: complex] :
      ( ( cnj @ ( times_times @ complex @ X @ Y ) )
      = ( times_times @ complex @ ( cnj @ X ) @ ( cnj @ Y ) ) ) ).

% complex_cnj_mult
thf(fact_3642_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] :
      ( ( bit_concat_bit @ N @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_3643_complex__cnj__zero,axiom,
    ( ( cnj @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% complex_cnj_zero
thf(fact_3644_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( ( cnj @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% complex_cnj_zero_iff
thf(fact_3645_complex__cnj__one,axiom,
    ( ( cnj @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% complex_cnj_one
thf(fact_3646_complex__cnj__one__iff,axiom,
    ! [Z: complex] :
      ( ( ( cnj @ Z )
        = ( one_one @ complex ) )
      = ( Z
        = ( one_one @ complex ) ) ) ).

% complex_cnj_one_iff
thf(fact_3647_complex__cnj__diff,axiom,
    ! [X: complex,Y: complex] :
      ( ( cnj @ ( minus_minus @ complex @ X @ Y ) )
      = ( minus_minus @ complex @ ( cnj @ X ) @ ( cnj @ Y ) ) ) ).

% complex_cnj_diff
thf(fact_3648_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_3649_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_3650_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_3651_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_3652_scaleR__minus1__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
          = ( uminus_uminus @ A @ X ) ) ) ).

% scaleR_minus1_left
thf(fact_3653_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_3654_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_scaleR
thf(fact_3655_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_3656_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_3657_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_3658_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_3659_push__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% push_bit_of_Suc_0
thf(fact_3660_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( ( N
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_3661_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_3662_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_3663_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_3664_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se5824344971392196577ns_xor @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_3665_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q2 ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_3666_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X: A,Y: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y ) )
         => ( X != Y ) ) ) ).

% size_neq_size_imp_neq
thf(fact_3667_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_push_bit
thf(fact_3668_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_3669_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ).

% scaleR_right_distrib
thf(fact_3670_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_3671_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,A2: real,B2: real] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_3672_scaleR__right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ).

% scaleR_right_diff_distrib
thf(fact_3673_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_3674_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
           => ( X = Y ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_3675_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_3676_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N ) ) ).

% not_bit_Suc_0_Suc
thf(fact_3677_XOR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) ) ) ) ).

% XOR_lower
thf(fact_3678_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ).

% scaleR_left_distrib
thf(fact_3679_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: real,Y: real,Xa: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X @ Y ) @ Xa )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Xa ) @ ( real_V8093663219630862766scaleR @ A @ Y @ Xa ) ) ) ) ).

% scaleR_left.add
thf(fact_3680_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_3681_of__real__def,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A )
        = ( ^ [R5: real] : ( real_V8093663219630862766scaleR @ A @ R5 @ ( one_one @ A ) ) ) ) ) ).

% of_real_def
thf(fact_3682_scaleR__left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ).

% scaleR_left_diff_distrib
thf(fact_3683_scaleR__left_Odiff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: real,Y: real,Xa: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ X @ Y ) @ Xa )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Xa ) @ ( real_V8093663219630862766scaleR @ A @ Y @ Xa ) ) ) ) ).

% scaleR_left.diff
thf(fact_3684_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ B2 ) ) ) ).

% complex_scaleR
thf(fact_3685_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_3686_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_3687_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_3688_not__bit__Suc__0__numeral,axiom,
    ! [N: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N ) ) ).

% not_bit_Suc_0_numeral
thf(fact_3689_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3690_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3691_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3692_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3693_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3694_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3695_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3696_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V: real,A2: A,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 )
            = X )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V @ X ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3697_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,U: real,V: real,A2: A] :
          ( ( X
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 ) )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V @ X )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3698_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3699_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3700_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_3701_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% xor_nat_def
thf(fact_3702_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K2: int,L4: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K2 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L4 ) ) ) ) ).

% concat_bit_eq
thf(fact_3703_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se5824344971392196577ns_xor @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_3704_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3705_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3706_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A,Y: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3707_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3708_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3709_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3710_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3711_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3712_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3713_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3714_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ X ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3715_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X )
          = ( plus_plus @ A @ X @ X ) ) ) ).

% scaleR_2
thf(fact_3716_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X: A,C2: A,Y: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 )
              = Y )
            = ( X
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3717_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y: A,X: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3718_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3719_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3720_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3721_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3722_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3723_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3724_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3725_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3726_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_nat_iff
thf(fact_3727_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_3728_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_3729_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_3730_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_3731_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3732_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3733_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3734_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3735_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3736_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3737_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3738_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3739_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( times_times @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_int_def
thf(fact_3740_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N2: nat,M3: nat] : ( times_times @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_nat_def
thf(fact_3741_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_3742_complex__mod__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_3743_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_3744_XOR__upper,axiom,
    ! [X: int,N: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% XOR_upper
thf(fact_3745_complex__norm__square,axiom,
    ! [Z: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ).

% complex_norm_square
thf(fact_3746_num_Osize_I5_J,axiom,
    ! [X2: num] :
      ( ( size_size @ num @ ( bit0 @ X2 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_3747_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L4: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L4 ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_3748_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L4: int] :
          ( if @ int
          @ ( K2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L4 )
          @ ( if @ int
            @ ( L4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K2 )
            @ ( if @ int
              @ ( K2
                = ( zero_zero @ int ) )
              @ L4
              @ ( if @ int
                @ ( L4
                  = ( zero_zero @ int ) )
                @ K2
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_3749_complex__diff__cnj,axiom,
    ! [Z: complex] :
      ( ( minus_minus @ complex @ Z @ ( cnj @ Z ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_3750_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_3751_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_3752_complex__Im__of__int,axiom,
    ! [Z: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_3753_complex__Im__of__nat,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_3754_complex__Im__fact,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_3755_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_3756_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_3757_Im__complex__of__real,axiom,
    ! [Z: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_3758_Im__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X @ N ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_3759_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_3760_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_3761_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_3762_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_3763_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_3764_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_3765_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_3766_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_3767_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_3768_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_3769_Im__i__times,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( re @ Z ) ) ).

% Im_i_times
thf(fact_3770_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_3771_Re__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X @ N ) )
        = ( power_power @ real @ ( re @ X ) @ N ) ) ) ).

% Re_power_real
thf(fact_3772_Re__i__times,axiom,
    ! [Z: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( uminus_uminus @ real @ ( im @ Z ) ) ) ).

% Re_i_times
thf(fact_3773_cos__Arg__i__mult__zero,axiom,
    ! [Y: complex] :
      ( ( Y
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_3774_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_3775_csqrt__of__real__nonneg,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) )
       => ( ( csqrt @ X )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_3776_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( ( ord_less @ real @ ( im @ X ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X ) ) ) ) ).

% csqrt_minus
thf(fact_3777_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_3778_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,X: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( re @ X ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_3779_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,X: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( im @ X ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_3780_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X3: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X3 ) ) @ ( times_times @ real @ R5 @ ( im @ X3 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_3781_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I3: int] :
            ( ( re @ Z )
            = ( ring_1_of_int @ real @ I3 ) ) ) ) ).

% complex_is_Int_iff
thf(fact_3782_times__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( times_times @ complex @ X @ Y ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) ) ) ).

% times_complex.simps(2)
thf(fact_3783_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( ( im @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( re @ Z ) ) ) ) ).

% cmod_eq_Re
thf(fact_3784_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( ( re @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_eq_Im
thf(fact_3785_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z ) )
     => ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_3786_cmod__Re__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( im @ X )
        = ( im @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( abs_abs @ real @ ( re @ Y ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_3787_cmod__Im__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( re @ X )
        = ( re @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( abs_abs @ real @ ( im @ Y ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_3788_times__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( times_times @ complex @ X @ Y ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) ) ).

% times_complex.simps(1)
thf(fact_3789_minus__complex_Ocode,axiom,
    ( ( minus_minus @ complex )
    = ( ^ [X3: complex,Y6: complex] : ( complex2 @ ( minus_minus @ real @ ( re @ X3 ) @ ( re @ Y6 ) ) @ ( minus_minus @ real @ ( im @ X3 ) @ ( im @ Y6 ) ) ) ) ) ).

% minus_complex.code
thf(fact_3790_csqrt__principal,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) )
      | ( ( ( re @ ( csqrt @ Z ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z ) ) ) ) ) ).

% csqrt_principal
thf(fact_3791_cmod__le,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_le
thf(fact_3792_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_3793_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_3794_Re__exp,axiom,
    ! [Z: complex] :
      ( ( re @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( cos @ real @ ( im @ Z ) ) ) ) ).

% Re_exp
thf(fact_3795_Im__exp,axiom,
    ! [Z: complex] :
      ( ( im @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( sin @ real @ ( im @ Z ) ) ) ) ).

% Im_exp
thf(fact_3796_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_3797_complex__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( re @ X ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_Re_le_cmod
thf(fact_3798_imaginary__unit_Osimps_I2_J,axiom,
    ( ( im @ imaginary_unit )
    = ( one_one @ real ) ) ).

% imaginary_unit.simps(2)
thf(fact_3799_fun__complex__eq,axiom,
    ! [A: $tType,F3: A > complex] :
      ( F3
      = ( ^ [X3: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F3 @ X3 ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F3 @ X3 ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_3800_complex__eq,axiom,
    ! [A2: complex] :
      ( A2
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A2 ) ) ) ) ) ).

% complex_eq
thf(fact_3801_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_3802_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_3803_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_3804_one__complex_Osimps_I1_J,axiom,
    ( ( re @ ( one_one @ complex ) )
    = ( one_one @ real ) ) ).

% one_complex.simps(1)
thf(fact_3805_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X3: complex,Y6: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X3 ) @ ( re @ Y6 ) ) @ ( times_times @ real @ ( im @ X3 ) @ ( im @ Y6 ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X3 ) @ ( im @ Y6 ) ) @ ( times_times @ real @ ( im @ X3 ) @ ( re @ Y6 ) ) ) ) ) ) ).

% times_complex.code
thf(fact_3806_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_3807_minus__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( minus_minus @ complex @ X @ Y ) )
      = ( minus_minus @ real @ ( im @ X ) @ ( im @ Y ) ) ) ).

% minus_complex.simps(2)
thf(fact_3808_minus__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( minus_minus @ complex @ X @ Y ) )
      = ( minus_minus @ real @ ( re @ X ) @ ( re @ Y ) ) ) ).

% minus_complex.simps(1)
thf(fact_3809_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z6: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z6 ) ) ) @ ( cis @ ( im @ Z6 ) ) ) ) ) ).

% exp_eq_polar
thf(fact_3810_Im__power2,axiom,
    ! [X: complex] :
      ( ( im @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X ) ) @ ( im @ X ) ) ) ).

% Im_power2
thf(fact_3811_Re__power2,axiom,
    ! [X: complex] :
      ( ( re @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_3812_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_3813_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_3814_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A4: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_3815_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K2 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_3816_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_3817_abs__Im__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Im_le_cmod
thf(fact_3818_abs__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Re_le_cmod
thf(fact_3819_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_3820_Re__csqrt,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) ) ).

% Re_csqrt
thf(fact_3821_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_3822_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_3823_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se5824344872417868541ns_and @ int @ K2 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_3824_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( ( Z
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_3825_Re__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_3826_complex__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( times_times @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_3827_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z )
          = W ) ) ) ).

% csqrt_unique
thf(fact_3828_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_3829_and__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_3830_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_3831_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N ) ) ).

% bit_minus_int_iff
thf(fact_3832_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_3833_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_3834_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_3835_Im__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_3836_complex__abs__le__norm,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% complex_abs_le_norm
thf(fact_3837_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z6: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z6 @ ( cnj @ Z6 ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_3838_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_3839_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_3840_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_3841_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X3: complex,Y6: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X3 ) @ ( re @ Y6 ) ) @ ( times_times @ real @ ( im @ X3 ) @ ( im @ Y6 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X3 ) @ ( re @ Y6 ) ) @ ( times_times @ real @ ( re @ X3 ) @ ( im @ Y6 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_3842_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_3843_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_3844_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_3845_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_3846_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_3847_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_3848_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_3849_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_3850_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_3851_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_3852_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_3853_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_3854_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_3855_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_3856_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_3857_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_3858_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff_eq
thf(fact_3859_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( ( im @ ( csqrt @ Z ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_3860_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z6: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z6 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z6 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_3861_complex__add__cnj,axiom,
    ! [Z: complex] :
      ( ( plus_plus @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z ) ) ) ) ).

% complex_add_cnj
thf(fact_3862_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_3863_Im__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R ) ) @ ( im @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_3864_Re__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R ) @ ( re @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_3865_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L4: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L4 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_3866_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_3867_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_3868_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_3869_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_3870_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_3871_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_3872_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_3873_or__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(2)
thf(fact_3874_or__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(4)
thf(fact_3875_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(2)
thf(fact_3876_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_3877_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_3878_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_3879_real__eq__imaginary__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( X
            = ( times_times @ complex @ imaginary_unit @ Y ) )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_3880_imaginary__eq__real__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y )
            = X )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_3881_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% or_numerals(3)
thf(fact_3882_or__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(3)
thf(fact_3883_or__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(1)
thf(fact_3884_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_3885_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(1)
thf(fact_3886_or__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_3887_or__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_3888_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_3889_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_3890_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_3891_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_3892_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_3893_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_3894_Reals__1,axiom,
    ! [B: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ B )
     => ( member @ B @ ( one_one @ B ) @ ( real_Vector_Reals @ B ) ) ) ).

% Reals_1
thf(fact_3895_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_3896_Reals__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_diff
thf(fact_3897_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% or_nat_def
thf(fact_3898_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_or_eq
thf(fact_3899_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( zero_zero @ A ) )
          = X ) ) ).

% bit.disj_zero_right
thf(fact_3900_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_3901_Reals__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_of_nat
thf(fact_3902_cos__in__Reals,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( member @ A @ Z @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( cos @ A @ Z ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% cos_in_Reals
thf(fact_3903_sin__in__Reals,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( member @ A @ Z @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( sin @ A @ Z ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% sin_in_Reals
thf(fact_3904_fact__in__Reals,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_char_0_fact @ A @ N ) @ ( real_Vector_Reals @ A ) ) ) ).

% fact_in_Reals
thf(fact_3905_exp__in__Reals,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( member @ A @ Z @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( exp @ A @ Z ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% exp_in_Reals
thf(fact_3906_tan__in__Reals,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( member @ A @ Z @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( tan @ A @ Z ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% tan_in_Reals
thf(fact_3907_cot__in__Reals,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( member @ A @ Z @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( cot @ A @ Z ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% cot_in_Reals
thf(fact_3908_OR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) ) ) ) ).

% OR_lower
thf(fact_3909_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_3910_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_3911_plus__and__or,axiom,
    ! [X: int,Y: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) )
      = ( plus_plus @ int @ X @ Y ) ) ).

% plus_and_or
thf(fact_3912_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_3913_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_3914_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_3915_Complex__in__Reals,axiom,
    ! [X: real] : ( member @ complex @ ( complex2 @ X @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_3916_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_3917_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_3918_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_3919_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se1065995026697491101ons_or @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_3920_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_3921_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_3922_or__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(2)
thf(fact_3923_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_3924_or__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(3)
thf(fact_3925_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_3926_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% mask_Suc_exp
thf(fact_3927_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_3928_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_3929_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_3930_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_3931_OR__upper,axiom,
    ! [X: int,N: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% OR_upper
thf(fact_3932_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_3933_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A4 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_3934_Suc__0__or__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_or_eq
thf(fact_3935_or__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% or_Suc_0_eq
thf(fact_3936_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_3937_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_3938_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_3939_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L4: int] :
          ( if @ int
          @ ( ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L4
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ int ) )
            @ L4
            @ ( if @ int
              @ ( L4
                = ( zero_zero @ int ) )
              @ K2
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_3940_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_3941_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_3942_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ A4
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_3943_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_3944_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_3945_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_3946_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_3947_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_3948_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_3949_drop__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_3950_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_3951_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_3952_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_Suc_Suc
thf(fact_3953_max__0R,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ N @ ( zero_zero @ nat ) )
      = N ) ).

% max_0R
thf(fact_3954_max__0L,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% max_0L
thf(fact_3955_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_3956_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_3957_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_3958_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_3959_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_3960_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(4)
thf(fact_3961_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(3)
thf(fact_3962_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_3963_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_3964_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_3965_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_3966_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_3967_drop__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_3968_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_3969_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_3970_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_3971_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_3972_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_3973_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_3974_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_3975_max__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% max_numeral_Suc
thf(fact_3976_max__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_3977_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_3978_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_3979_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_drop_bit
thf(fact_3980_of__int__max,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y: int] :
          ( ( ring_1_of_int @ A @ ( ord_max @ int @ X @ Y ) )
          = ( ord_max @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y ) ) ) ) ).

% of_int_max
thf(fact_3981_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X @ Y ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_max
thf(fact_3982_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_max_left
thf(fact_3983_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_max_right
thf(fact_3984_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z ) @ ( minus_minus @ A @ Y @ Z ) ) ) ) ).

% max_diff_distrib_left
thf(fact_3985_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y @ Z ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% max_add_distrib_right
thf(fact_3986_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y @ Z ) ) ) ) ).

% max_add_distrib_left
thf(fact_3987_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N ) @ ( plus_plus @ nat @ M @ Q2 ) ) ) ).

% nat_add_max_right
thf(fact_3988_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q2 ) @ ( plus_plus @ nat @ N @ Q2 ) ) ) ).

% nat_add_max_left
thf(fact_3989_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_max @ A @ X @ Y )
            = Y ) ) ) ).

% max_absorb2
thf(fact_3990_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_max @ A @ X @ Y )
            = X ) ) ) ).

% max_absorb1
thf(fact_3991_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_3992_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_3993_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% max.absorb_iff2
thf(fact_3994_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% max.absorb_iff1
thf(fact_3995_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less_eq @ A @ Z @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less_eq @ A @ Z @ X )
            | ( ord_less_eq @ A @ Z @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_3996_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_3997_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_3998_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( ord_max @ A @ A4 @ B3 ) ) ) ) ) ).

% max.order_iff
thf(fact_3999_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_4000_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_4001_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_4002_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_4003_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_4004_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ B3 @ A4 ) ) ) ) ).

% max_def
thf(fact_4005_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N @ M ) @ M )
      = ( ord_max @ nat @ N @ M ) ) ).

% nat_minus_add_max
thf(fact_4006_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_4007_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_4008_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_4009_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_4010_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_4011_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A4 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_4012_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_4013_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_4014_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_4015_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_4016_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_4017_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_4018_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_4019_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = Q2 ) ).

% max_enat_simps(2)
thf(fact_4020_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = Q2 ) ).

% max_enat_simps(3)
thf(fact_4021_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_4022_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% diff_numeral_simps(1)
thf(fact_4023_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_4024_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_4025_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_4026_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_4027_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y ) ) ) ).

% semiring_norm(166)
thf(fact_4028_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y ) ) ) ).

% semiring_norm(167)
thf(fact_4029_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_4030_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_4031_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_4032_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_4033_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_4034_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_4035_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_4036_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_4037_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_4038_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_4039_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_4040_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K2: num,L4: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K2 ) @ ( numeral_numeral @ A @ L4 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_4041_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% sub_non_negative
thf(fact_4042_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% sub_non_positive
thf(fact_4043_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% sub_positive
thf(fact_4044_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% sub_negative
thf(fact_4045_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N ) @ one2 )
          = ( numeral_numeral @ A @ N ) ) ) ).

% sub_inc_One_eq
thf(fact_4046_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_4047_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = ( inc @ ( num_of_nat @ N ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_4048_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_4049_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_4050_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q2 ) )
      = Q2 ) ).

% num_of_nat_numeral_eq
thf(fact_4051_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_4052_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_4053_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_4054_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_4055_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_4056_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z6: A] :
              ( Z6
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_4057_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_4058_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_4059_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_4060_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [X3: A,Y6: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X3 @ Y6 ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_4061_semiring__norm_I27_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit0 @ N ) )
      = ( bit1 @ ( bitM @ N ) ) ) ).

% semiring_norm(27)
thf(fact_4062_semiring__norm_I28_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ N ) ) ) ).

% semiring_norm(28)
thf(fact_4063_inc__BitM__eq,axiom,
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% inc_BitM_eq
thf(fact_4064_BitM__inc__eq,axiom,
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) ).

% BitM_inc_eq
thf(fact_4065_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_4066_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_4067_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_4068_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_4069_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_4070_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_4071_eval__nat__numeral_I2_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_4072_one__plus__BitM,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% one_plus_BitM
thf(fact_4073_BitM__plus__one,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ ( bitM @ N ) @ one2 )
      = ( bit0 @ N ) ) ).

% BitM_plus_one
thf(fact_4074_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N ) )
        = N ) ) ).

% numeral_num_of_nat
thf(fact_4075_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_4076_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_4077_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_4078_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_4079_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_4080_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_4081_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y @ X ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_4082_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_4083_sub__BitM__One__eq,axiom,
    ! [N: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_4084_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_4085_num__of__nat__double,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N @ N ) )
        = ( bit0 @ ( num_of_nat @ N ) ) ) ) ).

% num_of_nat_double
thf(fact_4086_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_4087_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_4088_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_4089_or__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4090_or__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4091_pow_Osimps_I3_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit1 @ Y ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X @ Y ) ) @ X ) ) ).

% pow.simps(3)
thf(fact_4092_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_4093_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_4094_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_4095_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_4096_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_Suc_Suc
thf(fact_4097_min__0L,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_4098_min__0R,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ N @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_4099_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(1)
thf(fact_4100_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_4101_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_4102_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_4103_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_4104_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_4105_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_4106_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_4107_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(3)
thf(fact_4108_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_4109_min__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_4110_min__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% min_numeral_Suc
thf(fact_4111_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ A4 @ B3 ) ) ) ) ).

% min_def
thf(fact_4112_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_4113_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_4114_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_4115_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_4116_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_4117_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( ord_min @ A @ A4 @ B3 ) ) ) ) ) ).

% min.order_iff
thf(fact_4118_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_4119_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_4120_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% min.absorb_iff1
thf(fact_4121_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% min.absorb_iff2
thf(fact_4122_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_4123_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_4124_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            | ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% min_le_iff_disj
thf(fact_4125_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_min @ A @ X @ Y )
            = X ) ) ) ).

% min_absorb1
thf(fact_4126_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_min @ A @ X @ Y )
            = Y ) ) ) ).

% min_absorb2
thf(fact_4127_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y @ Z ) ) ) ) ).

% min_add_distrib_left
thf(fact_4128_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y @ Z ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% min_add_distrib_right
thf(fact_4129_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z ) @ ( minus_minus @ A @ Y @ Z ) ) ) ) ).

% min_diff_distrib_left
thf(fact_4130_min__diff,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I ) @ ( minus_minus @ nat @ N @ I ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N ) @ I ) ) ).

% min_diff
thf(fact_4131_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N @ Q2 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_min_right
thf(fact_4132_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N ) @ Q2 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_min_left
thf(fact_4133_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X @ Y ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_min
thf(fact_4134_of__int__min,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y: int] :
          ( ( ring_1_of_int @ A @ ( ord_min @ int @ X @ Y ) )
          = ( ord_min @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y ) ) ) ) ).

% of_int_min
thf(fact_4135_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_4136_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_4137_sqr_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) ).

% sqr.simps(2)
thf(fact_4138_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_4139_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L: int,R: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N @ K @ L ) @ R )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N ) @ L @ R ) ) ) ).

% concat_bit_assoc_sym
thf(fact_4140_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X3: num] : ( times_times @ num @ X3 @ X3 ) ) ) ).

% sqr_conv_mult
thf(fact_4141_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N @ K @ L ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N ) @ L ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_4142_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_4143_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_4144_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_4145_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_4146_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_4147_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_4148_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_4149_pow_Osimps_I2_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit0 @ Y ) )
      = ( sqr @ ( pow @ X @ Y ) ) ) ).

% pow.simps(2)
thf(fact_4150_sqr_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N ) @ N ) ) ) ) ).

% sqr.simps(3)
thf(fact_4151_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4152_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L4: int] :
          ( if @ int
          @ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L4 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L4 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L4 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4153_set__decode__plus__power__2,axiom,
    ! [N: nat,Z: nat] :
      ( ~ ( member @ nat @ N @ ( nat_set_decode @ Z ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ Z ) )
        = ( insert @ nat @ N @ ( nat_set_decode @ Z ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4154_rcis__inverse,axiom,
    ! [R: real,A2: real] :
      ( ( inverse_inverse @ complex @ ( rcis @ R @ A2 ) )
      = ( rcis @ ( divide_divide @ real @ ( one_one @ real ) @ R ) @ ( uminus_uminus @ real @ A2 ) ) ) ).

% rcis_inverse
thf(fact_4155_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_4156_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_4157_subset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_4158_empty__subsetI,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) ).

% empty_subsetI
thf(fact_4159_insert__subset,axiom,
    ! [A: $tType,X: A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
      = ( ( member @ A @ X @ B4 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% insert_subset
thf(fact_4160_Diff__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) ).

% Diff_empty
thf(fact_4161_empty__Diff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% empty_Diff
thf(fact_4162_Diff__cancel,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_cancel
thf(fact_4163_insert__Diff1,axiom,
    ! [A: $tType,X: A,B4: set @ A,A3: set @ A] :
      ( ( member @ A @ X @ B4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
        = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% insert_Diff1
thf(fact_4164_Diff__insert0,axiom,
    ! [A: $tType,X: A,A3: set @ A,B4: set @ A] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
        = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% Diff_insert0
thf(fact_4165_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_4166_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_4167_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A3: set @ A] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A3 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_4168_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B2: A] :
      ( ( ( insert @ A @ A2 @ A3 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_4169_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_eq_empty_iff
thf(fact_4170_insert__Diff__single,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A2 @ A3 ) ) ).

% insert_Diff_single
thf(fact_4171_rcis__zero__arg,axiom,
    ! [R: real] :
      ( ( rcis @ R @ ( zero_zero @ real ) )
      = ( real_Vector_of_real @ complex @ R ) ) ).

% rcis_zero_arg
thf(fact_4172_rcis__zero__mod,axiom,
    ! [A2: real] :
      ( ( rcis @ ( zero_zero @ real ) @ A2 )
      = ( zero_zero @ complex ) ) ).

% rcis_zero_mod
thf(fact_4173_rcis__eq__zero__iff,axiom,
    ! [R: real,A2: real] :
      ( ( ( rcis @ R @ A2 )
        = ( zero_zero @ complex ) )
      = ( R
        = ( zero_zero @ real ) ) ) ).

% rcis_eq_zero_iff
thf(fact_4174_subset__Compl__singleton,axiom,
    ! [A: $tType,A3: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A3 ) ) ) ).

% subset_Compl_singleton
thf(fact_4175_Re__rcis,axiom,
    ! [R: real,A2: real] :
      ( ( re @ ( rcis @ R @ A2 ) )
      = ( times_times @ real @ R @ ( cos @ real @ A2 ) ) ) ).

% Re_rcis
thf(fact_4176_Im__rcis,axiom,
    ! [R: real,A2: real] :
      ( ( im @ ( rcis @ R @ A2 ) )
      = ( times_times @ real @ R @ ( sin @ real @ A2 ) ) ) ).

% Im_rcis
thf(fact_4177_Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Diff_insert
thf(fact_4178_insert__Diff,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A3 ) ) ).

% insert_Diff
thf(fact_4179_Diff__insert2,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) ).

% Diff_insert2
thf(fact_4180_Diff__insert__absorb,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A3 ) ) ).

% Diff_insert_absorb
thf(fact_4181_Compl__insert,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) )
      = ( minus_minus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Compl_insert
thf(fact_4182_insert__Diff__if,axiom,
    ! [A: $tType,X: A,B4: set @ A,A3: set @ A] :
      ( ( ( member @ A @ X @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
          = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) )
      & ( ~ ( member @ A @ X @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ).

% insert_Diff_if
thf(fact_4183_insert__mono,axiom,
    ! [A: $tType,C5: set @ A,D3: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ D3 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C5 ) @ ( insert @ A @ A2 @ D3 ) ) ) ).

% insert_mono
thf(fact_4184_subset__insert,axiom,
    ! [A: $tType,X: A,A3: set @ A,B4: set @ A] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% subset_insert
thf(fact_4185_subset__insertI,axiom,
    ! [A: $tType,B4: set @ A,A2: A] : ( ord_less_eq @ ( set @ A ) @ B4 @ ( insert @ A @ A2 @ B4 ) ) ).

% subset_insertI
thf(fact_4186_subset__insertI2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ B4 ) ) ) ).

% subset_insertI2
thf(fact_4187_subset__singletonD,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( A3
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_4188_subset__singleton__iff,axiom,
    ! [A: $tType,X9: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X9 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X9
          = ( bot_bot @ ( set @ A ) ) )
        | ( X9
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_4189_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_4190_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_4191_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_4192_Diff__single__insert,axiom,
    ! [A: $tType,A3: set @ A,X: A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) ) ) ).

% Diff_single_insert
thf(fact_4193_subset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
      = ( ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) )
        & ( ~ ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% subset_insert_iff
thf(fact_4194_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
      = ( ( ( member @ A @ X @ B4 )
         => ( ord_less @ ( set @ A ) @ A3 @ B4 ) )
        & ( ~ ( member @ A @ X @ B4 )
         => ( ( ( member @ A @ X @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) )
            & ( ~ ( member @ A @ X @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_4195_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( minus_minus @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% diff_shunt_var
thf(fact_4196_subset__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,X: A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ ( insert @ A @ X @ C5 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ C5 ) )
        & ~ ( member @ A @ X @ A3 ) ) ) ).

% subset_Diff_insert
thf(fact_4197_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I3: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I3 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I3 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_4198_subset__Compl__self__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_4199_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sinh @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4200_atLeast0__atMost__Suc,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_4201_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4202_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) )
        = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4203_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4204_cis__rcis__eq,axiom,
    ( cis
    = ( rcis @ ( one_one @ real ) ) ) ).

% cis_rcis_eq
thf(fact_4205_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
        = ( insert @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N ) @ ( set_or1337092689740270186AtMost @ int @ M @ N ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4206_rcis__mult,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] :
      ( ( times_times @ complex @ ( rcis @ R1 @ A2 ) @ ( rcis @ R22 @ B2 ) )
      = ( rcis @ ( times_times @ real @ R1 @ R22 ) @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% rcis_mult
thf(fact_4207_rcis__divide,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] :
      ( ( divide_divide @ complex @ ( rcis @ R1 @ A2 ) @ ( rcis @ R22 @ B2 ) )
      = ( rcis @ ( divide_divide @ real @ R1 @ R22 ) @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% rcis_divide
thf(fact_4208_rcis__def,axiom,
    ( rcis
    = ( ^ [R5: real,A4: real] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ R5 ) @ ( cis @ A4 ) ) ) ) ).

% rcis_def
thf(fact_4209_DeMoivre2,axiom,
    ! [R: real,A2: real,N: nat] :
      ( ( power_power @ complex @ ( rcis @ R @ A2 ) @ N )
      = ( rcis @ ( power_power @ real @ R @ N ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre2
thf(fact_4210_insert__subsetI,axiom,
    ! [A: $tType,X: A,A3: set @ A,X9: set @ A] :
      ( ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ X9 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X9 ) @ A3 ) ) ) ).

% insert_subsetI
thf(fact_4211_subset__emptyI,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ! [X4: A] :
          ~ ( member @ A @ X4 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_4212_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4213_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_4214_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4215_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_4216_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_4217_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_4218_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_4219_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K3: int,L2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K3 @ L2 ) )
           => ( ( ~ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K3 @ L2 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_4220_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R: A,Q2: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ R ) ) ) ) ) ).

% divmod_step_eq
thf(fact_4221_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( plus_plus @ int @ Q2
        @ ( zero_neq_one_of_bool @ int
          @ ( R
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_4222_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_4223_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I2: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I2 @ J2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I2 @ J2 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_4224_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_4225_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q2 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_4226_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q2 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q2 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_4227_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q2 ) @ R ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
            & ( ord_less @ int @ R @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R )
                & ( ord_less_eq @ int @ R @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q2
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_4228_eucl__rel__int__remainderI,axiom,
    ! [R: int,L: int,K: int,Q2: int] :
      ( ( ( sgn_sgn @ int @ R )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q2 @ L ) @ R ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_4229_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A1 @ A22 @ A32 )
     => ( ( ( A22
            = ( zero_zero @ int ) )
         => ( A32
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A1 ) ) )
       => ( ! [Q3: int] :
              ( ( A32
                = ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) )
             => ( ( A22
                 != ( zero_zero @ int ) )
               => ( A1
                 != ( times_times @ int @ Q3 @ A22 ) ) ) )
         => ~ ! [R4: int,Q3: int] :
                ( ( A32
                  = ( product_Pair @ int @ int @ Q3 @ R4 ) )
               => ( ( ( sgn_sgn @ int @ R4 )
                    = ( sgn_sgn @ int @ A22 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R4 ) @ ( abs_abs @ int @ A22 ) )
                   => ( A1
                     != ( plus_plus @ int @ ( times_times @ int @ Q3 @ A22 ) @ R4 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_4230_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A12: int,A23: int,A33: product_prod @ int @ int] :
          ( ? [K2: int] :
              ( ( A12 = K2 )
              & ( A23
                = ( zero_zero @ int ) )
              & ( A33
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K2 ) ) )
          | ? [L4: int,K2: int,Q4: int] :
              ( ( A12 = K2 )
              & ( A23 = L4 )
              & ( A33
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L4
               != ( zero_zero @ int ) )
              & ( K2
                = ( times_times @ int @ Q4 @ L4 ) ) )
          | ? [R5: int,L4: int,K2: int,Q4: int] :
              ( ( A12 = K2 )
              & ( A23 = L4 )
              & ( A33
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L4 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L4 ) )
              & ( K2
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L4 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_4231_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_4232_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_4233_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_4234_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: A,R: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q2 @ R ) )
          = ( R
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_4235_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_4236_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_4237_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_4238_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_4239_minus__one__div__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_div_numeral
thf(fact_4240_one__div__minus__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% one_div_minus_numeral
thf(fact_4241_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N2: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M3 @ N2 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M3 ) ) @ ( unique1321980374590559556d_step @ A @ N2 @ ( unique8689654367752047608divmod @ A @ M3 @ ( bit0 @ N2 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_4242_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_4243_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( gcd_Gcd @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_4244_card__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or1337092689740270186AtMost @ int @ L @ U ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ U @ L ) @ ( one_one @ int ) ) ) ) ).

% card_atLeastAtMost_int
thf(fact_4245_remove__def,axiom,
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X3: A,A6: set @ A] : ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% remove_def
thf(fact_4246_abs__Gcd__eq,axiom,
    ! [K6: set @ int] :
      ( ( abs_abs @ int @ ( gcd_Gcd @ int @ K6 ) )
      = ( gcd_Gcd @ int @ K6 ) ) ).

% abs_Gcd_eq
thf(fact_4247_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_4248_Gcd__greatest,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A,A2: A] :
          ( ! [B5: A] :
              ( ( member @ A @ B5 @ A3 )
             => ( dvd_dvd @ A @ A2 @ B5 ) )
         => ( dvd_dvd @ A @ A2 @ ( gcd_Gcd @ A @ A3 ) ) ) ) ).

% Gcd_greatest
thf(fact_4249_dvd__Gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [X: A,A3: set @ A] :
          ( ( dvd_dvd @ A @ X @ ( gcd_Gcd @ A @ A3 ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( dvd_dvd @ A @ X @ X3 ) ) ) ) ) ).

% dvd_Gcd_iff
thf(fact_4250_dvd__GcdD,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [X: A,A3: set @ A,Y: A] :
          ( ( dvd_dvd @ A @ X @ ( gcd_Gcd @ A @ A3 ) )
         => ( ( member @ A @ Y @ A3 )
           => ( dvd_dvd @ A @ X @ Y ) ) ) ) ).

% dvd_GcdD
thf(fact_4251_Gcd__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( member @ A @ A2 @ A3 )
         => ( dvd_dvd @ A @ ( gcd_Gcd @ A @ A3 ) @ A2 ) ) ) ).

% Gcd_dvd
thf(fact_4252_Gcd__dvd__int,axiom,
    ! [A2: int,A3: set @ int] :
      ( ( member @ int @ A2 @ A3 )
     => ( dvd_dvd @ int @ ( gcd_Gcd @ int @ A3 ) @ A2 ) ) ).

% Gcd_dvd_int
thf(fact_4253_Gcd__greatest__int,axiom,
    ! [A3: set @ int,A2: int] :
      ( ! [B5: int] :
          ( ( member @ int @ B5 @ A3 )
         => ( dvd_dvd @ int @ A2 @ B5 ) )
     => ( dvd_dvd @ int @ A2 @ ( gcd_Gcd @ int @ A3 ) ) ) ).

% Gcd_greatest_int
thf(fact_4254_Gcd__1,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( member @ A @ ( one_one @ A ) @ A3 )
         => ( ( gcd_Gcd @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_1
thf(fact_4255_Gcd__nat__eq__one,axiom,
    ! [N6: set @ nat] :
      ( ( member @ nat @ ( one_one @ nat ) @ N6 )
     => ( ( gcd_Gcd @ nat @ N6 )
        = ( one_one @ nat ) ) ) ).

% Gcd_nat_eq_one
thf(fact_4256_Gcd__dvd__nat,axiom,
    ! [A2: nat,A3: set @ nat] :
      ( ( member @ nat @ A2 @ A3 )
     => ( dvd_dvd @ nat @ ( gcd_Gcd @ nat @ A3 ) @ A2 ) ) ).

% Gcd_dvd_nat
thf(fact_4257_Gcd__greatest__nat,axiom,
    ! [A3: set @ nat,A2: nat] :
      ( ! [B5: nat] :
          ( ( member @ nat @ B5 @ A3 )
         => ( dvd_dvd @ nat @ A2 @ B5 ) )
     => ( dvd_dvd @ nat @ A2 @ ( gcd_Gcd @ nat @ A3 ) ) ) ).

% Gcd_greatest_nat
thf(fact_4258_Gcd__int__greater__eq__0,axiom,
    ! [K6: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K6 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_4259_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( member @ A @ A2 @ A3 )
           => ( ( gcd_Gcd @ A @ A3 )
              = ( one_one @ A ) ) ) ) ) ).

% Gcd_eq_1_I
thf(fact_4260_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ A2 @ B4 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( one_one @ nat ) ) ) ) ) ).

% card_Diff_insert
thf(fact_4261_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_4262_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X @ Y ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_4263_card__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_4264_card__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or1337092689740270186AtMost @ nat @ L @ U ) )
      = ( minus_minus @ nat @ ( suc @ U ) @ L ) ) ).

% card_atLeastAtMost
thf(fact_4265_card__insert__le,axiom,
    ! [A: $tType,A3: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( insert @ A @ X @ A3 ) ) ) ).

% card_insert_le
thf(fact_4266_card__1__singletonE,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( one_one @ nat ) )
     => ~ ! [X4: A] :
            ( A3
           != ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_4267_card__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B3: A,B6: set @ A] :
            ( ( A3
              = ( insert @ A @ B3 @ B6 ) )
            & ~ ( member @ A @ B3 @ B6 )
            & ( ( finite_card @ A @ B6 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B6
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_4268_card__eq__SucD,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
     => ? [B5: A,B9: set @ A] :
          ( ( A3
            = ( insert @ A @ B5 @ B9 ) )
          & ~ ( member @ A @ B5 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_4269_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X3: A] :
            ( A3
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_4270_card__Diff1__le,axiom,
    ! [A: $tType,A3: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ).

% card_Diff1_le
thf(fact_4271_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( member @ A @ X @ A3 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_4272_card__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or5935395276787703475ssThan @ int @ L @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ ( plus_plus @ int @ L @ ( one_one @ int ) ) ) ) ) ).

% card_greaterThanLessThan_int
thf(fact_4273_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_4274_complex__is__Nat__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( semiring_1_Nats @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I3: nat] :
            ( ( re @ Z )
            = ( semiring_1_of_nat @ real @ I3 ) ) ) ) ).

% complex_is_Nat_iff
thf(fact_4275_possible__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se6407376104438227557le_bit @ A )
        = ( ^ [Tyrep: itself @ A,N2: nat] :
              ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% possible_bit_def
thf(fact_4276_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_4277_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( one_one @ int ) )
          = Y ) ) ).

% power_int_1_right
thf(fact_4278_power__int__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( sgn_sgn @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_int_sgn
thf(fact_4279_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_4280_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_4281_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( power_int @ A @ X @ N )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( N
             != ( zero_zero @ int ) ) ) ) ) ).

% power_int_eq_0_iff
thf(fact_4282_power__int__0__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( M
           != ( zero_zero @ int ) )
         => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
            = ( zero_zero @ A ) ) ) ) ).

% power_int_0_left
thf(fact_4283_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_4284_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_4285_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_4286_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_4287_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ).

% abs_power_int_minus
thf(fact_4288_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: nat] :
          ( ( power_int @ A @ X @ ( semiring_1_of_nat @ int @ N ) )
          = ( power_power @ A @ X @ N ) ) ) ).

% power_int_of_nat
thf(fact_4289_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( power_int @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_4290_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_4291_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_4292_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: num] :
          ( ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% power_int_numeral
thf(fact_4293_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y ) ) ) ).

% power_int_minus1_right
thf(fact_4294_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_4295_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_4296_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_4297_possible__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Ty: itself @ A] : ( bit_se6407376104438227557le_bit @ A @ Ty @ ( zero_zero @ nat ) ) ) ).

% possible_bit_0
thf(fact_4298_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( power_int @ A @ X @ ( times_times @ int @ M @ N ) )
          = ( power_int @ A @ ( power_int @ A @ X @ M ) @ N ) ) ) ).

% power_int_mult
thf(fact_4299_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_4300_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_commutes
thf(fact_4301_power__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_int_abs
thf(fact_4302_power__int__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( inverse_inverse @ A @ X ) @ N )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_inverse
thf(fact_4303_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X @ Y ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_4304_possible__bit__less__imp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I: nat,J: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I )
         => ( ( ord_less_eq @ nat @ J @ I )
           => ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J ) ) ) ) ).

% possible_bit_less_imp
thf(fact_4305_Nats__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_0
thf(fact_4306_Nats__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_numeral
thf(fact_4307_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_4308_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_4309_Nats__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_add
thf(fact_4310_Nats__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ~ ! [N3: nat] :
                ( X
               != ( semiring_1_of_nat @ A @ N3 ) ) ) ) ).

% Nats_cases
thf(fact_4311_Nats__induct,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A,P: A > $o] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ A @ N3 ) )
           => ( P @ X ) ) ) ) ).

% Nats_induct
thf(fact_4312_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_Nats @ A ) ) ) ).

% of_nat_in_Nats
thf(fact_4313_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_le_power_int
thf(fact_4314_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_less_power_int
thf(fact_4315_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_one_over
thf(fact_4316_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_int_not_zero
thf(fact_4317_power__int__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ X @ ( uminus_uminus @ int @ N ) )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus
thf(fact_4318_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_4319_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N6: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N6 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N6 ) ) ) ) ) ).

% power_int_increasing
thf(fact_4320_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N6: int,A2: A] :
          ( ( ord_less @ int @ N @ N6 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N6 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_4321_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) ) ) ).

% power_int_minus_one_minus
thf(fact_4322_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M != N ) )
         => ( ( power_int @ A @ X @ ( minus_minus @ int @ M @ N ) )
            = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_diff
thf(fact_4323_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A2 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A2 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_4324_Nats__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( ( ord_less_eq @ A @ B2 @ A2 )
             => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ) ).

% Nats_diff
thf(fact_4325_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_4326_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Nats_subset_Ints
thf(fact_4327_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N6: int,A2: A] :
          ( ( ord_less @ int @ N @ N6 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N6 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_4328_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,N: int] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( power_int @ A @ Y @ N ) ) ) ) ) ) ).

% power_int_mono
thf(fact_4329_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_4330_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_4331_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_4332_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_add
thf(fact_4333_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_4334_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ).

% atLeastAtMost_diff_ends
thf(fact_4335_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_4336_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_4337_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N6: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N6 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N6
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N6 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_4338_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_4339_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_4340_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_4341_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_4342_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_4343_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_4344_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X3: A,N2: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 ) @ ( power_power @ A @ X3 @ ( nat2 @ N2 ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X3 ) @ ( nat2 @ ( uminus_uminus @ int @ N2 ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_4345_powr__real__of__int_H,axiom,
    ! [X: real,N: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( X
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N ) )
       => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
          = ( power_int @ real @ X @ N ) ) ) ) ).

% powr_real_of_int'
thf(fact_4346_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M @ N )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_4347_bit__minus__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% bit_minus_2_iff
thf(fact_4348_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            & ( N
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_double_iff
thf(fact_4349_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_4350_card__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or5935395276787703475ssThan @ nat @ L @ U ) )
      = ( minus_minus @ nat @ U @ ( suc @ L ) ) ) ).

% card_greaterThanLessThan
thf(fact_4351_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
          = ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_minus_1_iff
thf(fact_4352_tanh__real__bounds,axiom,
    ! [X: real] : ( member @ real @ ( tanh @ real @ X ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) ).

% tanh_real_bounds
thf(fact_4353_bit__of__nat__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ) ).

% bit_of_nat_iff
thf(fact_4354_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% bit_minus_iff
thf(fact_4355_bit__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less_eq @ nat @ M @ N )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_push_bit_iff
thf(fact_4356_fold__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% fold_possible_bit
thf(fact_4357_bit__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ ( one_one @ nat ) )
            & ( N
              = ( one_one @ nat ) ) ) ) ) ).

% bit_2_iff
thf(fact_4358_bit__minus__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% bit_minus_exp_iff
thf(fact_4359_CHAR__eq0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
          = ( zero_zero @ nat ) )
        = ( ! [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( semiring_1_of_nat @ A @ N2 )
               != ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_eq0_iff
thf(fact_4360_CHAR__eq__posI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
         => ( ( ( semiring_1_of_nat @ A @ C2 )
              = ( zero_zero @ A ) )
           => ( ! [X4: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X4 )
                 => ( ( ord_less @ nat @ X4 @ C2 )
                   => ( ( semiring_1_of_nat @ A @ X4 )
                     != ( zero_zero @ A ) ) ) )
             => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
                = C2 ) ) ) ) ) ).

% CHAR_eq_posI
thf(fact_4361_CHAR__pos__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( ? [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
              & ( ( semiring_1_of_nat @ A @ N2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_pos_iff
thf(fact_4362_of__nat__CHAR,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_CHAR
thf(fact_4363_CHAR__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
        = ( zero_zero @ nat ) ) ) ).

% CHAR_eq_0
thf(fact_4364_of__nat__eq__0__iff__char__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ nat @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) @ N ) ) ) ).

% of_nat_eq_0_iff_char_dvd
thf(fact_4365_CHAR__eqI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ( semiring_1_of_nat @ A @ C2 )
            = ( zero_zero @ A ) )
         => ( ! [X4: nat] :
                ( ( ( semiring_1_of_nat @ A @ X4 )
                  = ( zero_zero @ A ) )
               => ( dvd_dvd @ nat @ C2 @ X4 ) )
           => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
              = C2 ) ) ) ) ).

% CHAR_eqI
thf(fact_4366_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_4367_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_4368_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_4369_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K2: nat,M3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M3 @ K2 ) @ ( product_Pair @ nat @ nat @ M3 @ ( minus_minus @ nat @ K2 @ M3 ) ) @ ( nat_prod_decode_aux @ ( suc @ K2 ) @ ( minus_minus @ nat @ M3 @ ( suc @ K2 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_4370_prod__decode__aux_Ocases,axiom,
    ! [X: product_prod @ nat @ nat] :
      ~ ! [K3: nat,M2: nat] :
          ( X
         != ( product_Pair @ nat @ nat @ K3 @ M2 ) ) ).

% prod_decode_aux.cases
thf(fact_4371_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_4372_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X @ Y ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_4373_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_4374_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_4375_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_4376_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_4377_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_minus'
thf(fact_4378_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X: C,A2: A,N: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_4379_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_4380_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_4381_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] :
      ( ( nat_prod_encode @ ( nat_prod_decode_aux @ K @ M ) )
      = ( plus_plus @ nat @ ( nat_triangle @ K ) @ M ) ) ).

% prod_encode_prod_decode_aux
thf(fact_4382_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [J3: nat] :
            ? [M8: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ M8 @ M3 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N2 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_4383_prod__encode__eq,axiom,
    ! [X: product_prod @ nat @ nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_encode @ X )
        = ( nat_prod_encode @ Y ) )
      = ( X = Y ) ) ).

% prod_encode_eq
thf(fact_4384_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_4385_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_4386_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ X @ X )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_4387_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X @ Y )
            = ( zero_zero @ real ) )
          = ( X = Y ) ) ) ).

% dist_eq_0_iff
thf(fact_4388_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X )
          = ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% dist_0_norm
thf(fact_4389_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) )
          = ( ( X != Y ) ) ) ) ).

% zero_less_dist_iff
thf(fact_4390_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) )
          = ( X = Y ) ) ) ).

% dist_le_zero_iff
thf(fact_4391_dist__diff_I2_J,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( minus_minus @ A @ A2 @ B2 ) @ A2 )
          = ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ).

% dist_diff(2)
thf(fact_4392_dist__diff_I1_J,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V557655796197034286t_dist @ A @ A2 @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ).

% dist_diff(1)
thf(fact_4393_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: real,A2: A,Y: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_4394_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X3: A] : ( real_V557655796197034286t_dist @ A @ X3 @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_4395_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_4396_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ) ).

% dist_pos_lt
thf(fact_4397_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ).

% zero_le_dist
thf(fact_4398_dist__norm,axiom,
    ! [A: $tType] :
      ( ( real_V6936659425649961206t_norm @ A )
     => ( ( real_V557655796197034286t_dist @ A )
        = ( ^ [X3: A,Y6: A] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ Y6 ) ) ) ) ) ).

% dist_norm
thf(fact_4399_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z ) ) ) ) ).

% dist_triangle
thf(fact_4400_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z ) ) ) ) ).

% dist_triangle2
thf(fact_4401_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y ) ) ) ) ).

% dist_triangle3
thf(fact_4402_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E ) ) ) ).

% dist_triangle_le
thf(fact_4403_dist__real__def,axiom,
    ( ( real_V557655796197034286t_dist @ real )
    = ( ^ [X3: real,Y6: real] : ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y6 ) ) ) ) ).

% dist_real_def
thf(fact_4404_dist__complex__def,axiom,
    ( ( real_V557655796197034286t_dist @ complex )
    = ( ^ [X3: complex,Y6: complex] : ( real_V7770717601297561774m_norm @ complex @ ( minus_minus @ complex @ X3 @ Y6 ) ) ) ) ).

% dist_complex_def
thf(fact_4405_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_4406_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_4407_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : ( ord_less_eq @ nat @ A2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_4408_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_4409_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S4: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N7: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S4 @ N2 ) @ ( S4 @ N7 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_4410_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X9 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M10: nat] :
              ! [M4: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M4 )
               => ! [N4: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N4 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M4 ) @ ( X9 @ N4 ) ) @ E ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_4411_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M9: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M2 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M2 ) @ ( X9 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X9 ) ) ) ).

% metric_CauchyI
thf(fact_4412_dist__of__int,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: int,N: int] :
          ( ( real_V557655796197034286t_dist @ A @ ( ring_1_of_int @ A @ M ) @ ( ring_1_of_int @ A @ N ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ M @ N ) ) ) ) ) ).

% dist_of_int
thf(fact_4413_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F5: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less @ nat @ M3 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F5 @ M3 ) @ ( F5 @ N2 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_4414_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M9: nat] :
                ! [M2: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M2 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M2 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ M2 ) @ ( X9 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X9 ) ) ) ).

% CauchyI'
thf(fact_4415_dist__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( real_V557655796197034286t_dist @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ) ).

% dist_of_nat
thf(fact_4416_normalize__negative,axiom,
    ! [Q2: int,P4: int] :
      ( ( ord_less @ int @ Q2 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q2 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P4 ) @ ( uminus_uminus @ int @ Q2 ) ) ) ) ) ).

% normalize_negative
thf(fact_4417_normalize__denom__zero,axiom,
    ! [P4: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P4 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_4418_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_4419_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K2: int] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K2 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_4420_rat__one__code,axiom,
    ( ( quotient_of @ ( one_one @ rat ) )
    = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% rat_one_code
thf(fact_4421_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I3: nat] : ( ord_less_eq @ nat @ I3 @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_4422_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A2 @ F3 @ ( numeral_numeral @ nat @ V ) )
      = ( F3 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A2 @ F3 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_4423_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_4424_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: nat > A > A,V: num,N: nat] :
      ( ( rec_nat @ A @ A2 @ F3 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F3 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) @ ( rec_nat @ A @ A2 @ F3 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_4425_quotient__of__number_I4_J,axiom,
    ( ( quotient_of @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
    = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(4)
thf(fact_4426_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_4427_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A4: rat] :
          ( if @ rat
          @ ( A4
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A4 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_4428_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A4: rat] : ( if @ rat @ ( ord_less @ rat @ A4 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A4 ) @ A4 ) ) ) ).

% abs_rat_def
thf(fact_4429_diff__rat__def,axiom,
    ( ( minus_minus @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( plus_plus @ rat @ Q4 @ ( uminus_uminus @ rat @ R5 ) ) ) ) ).

% diff_rat_def
thf(fact_4430_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ B3 @ A4 ) ) ) ) ).

% max_def_raw
thf(fact_4431_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_4432_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ A2 ) )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_4433_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X3: A] : ( member @ A @ X3 @ A6 )
            @ ^ [X3: A] : ( member @ A @ X3 @ B6 ) ) ) ) ).

% less_eq_set_def
thf(fact_4434_Collect__subset,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ A3 )
            & ( P @ X3 ) ) )
      @ A3 ) ).

% Collect_subset
thf(fact_4435_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ A2 ) )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_4436_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H3: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_4437_minus__set__def,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( collect @ A
            @ ( minus_minus @ ( A > $o )
              @ ^ [X3: A] : ( member @ A @ X3 @ A6 )
              @ ^ [X3: A] : ( member @ A @ X3 @ B6 ) ) ) ) ) ).

% minus_set_def
thf(fact_4438_set__diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A6 )
                & ~ ( member @ A @ X3 @ B6 ) ) ) ) ) ).

% set_diff_eq
thf(fact_4439_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X3: A] : X3 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_4440_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X3: A] : ( times_times @ A @ X3 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_4441_diffs__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [C2: nat > A] :
          ( ( diffs @ A
            @ ^ [N2: nat] : ( uminus_uminus @ A @ ( C2 @ N2 ) ) )
          = ( ^ [N2: nat] : ( uminus_uminus @ A @ ( diffs @ A @ C2 @ N2 ) ) ) ) ) ).

% diffs_minus
thf(fact_4442_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_leq_as_int
thf(fact_4443_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_less_as_int
thf(fact_4444_exp__fdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( diffs @ A
          @ ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) )
        = ( ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ) ).

% exp_fdiffs
thf(fact_4445_Collect__restrict,axiom,
    ! [A: $tType,X9: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ X9 )
            & ( P @ X3 ) ) )
      @ X9 ) ).

% Collect_restrict
thf(fact_4446_prop__restrict,axiom,
    ! [A: $tType,X: A,Z8: set @ A,X9: set @ A,P: A > $o] :
      ( ( member @ A @ X @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ X9 )
                & ( P @ X3 ) ) ) )
       => ( P @ X ) ) ) ).

% prop_restrict
thf(fact_4447_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ A4 @ B3 ) ) ) ) ).

% min_def_raw
thf(fact_4448_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_4449_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_4450_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_4451_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_4452_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_4453_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_4454_diffs__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [F3: nat > real] :
          ( ( diffs @ A
            @ ^ [N2: nat] : ( real_Vector_of_real @ A @ ( F3 @ N2 ) ) )
          = ( ^ [N2: nat] : ( real_Vector_of_real @ A @ ( diffs @ real @ F3 @ N2 ) ) ) ) ) ).

% diffs_of_real
thf(fact_4455_card__less,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_4456_card__less__Suc,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K2: nat] :
                  ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                  & ( ord_less @ nat @ K2 @ I ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_4457_card__less__Suc2,axiom,
    ! [M7: set @ nat,I: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                & ( ord_less @ nat @ K2 @ I ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_4458_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_4459_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N2: A] :
              ( ( member @ A @ N2 @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ) ).

% Nats_altdef2
thf(fact_4460_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_4461_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z6: complex] :
                  ( ( power_power @ complex @ Z6 @ N )
                  = C2 ) ) )
          = N ) ) ) ).

% card_nth_roots
thf(fact_4462_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) ) )
        = N ) ) ).

% card_roots_unity_eq
thf(fact_4463_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( semiring_1_of_nat @ A @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_4464_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( power_power @ A @ Z6 @ N )
                    = ( one_one @ A ) ) ) )
            @ N ) ) ) ).

% card_roots_unity
thf(fact_4465_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I3: A] : ( plus_plus @ A @ I3 @ ( one_one @ A ) )
              @ N2
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_4466_diff__nat__eq__if,axiom,
    ! [Z7: int,Z: int] :
      ( ( ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) )
          = ( nat2 @ Z ) ) )
      & ( ~ ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z @ Z7 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z @ Z7 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_4467_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X3: nat] :
          ( collect @ nat
          @ ^ [N2: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_4468_quotient__of__denom__pos,axiom,
    ! [R: rat,P4: int,Q2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ P4 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% quotient_of_denom_pos
thf(fact_4469_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A4 ) @ N2 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A4 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A4 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4470_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_4471_normalize__denom__pos,axiom,
    ! [R: product_prod @ int @ int,P4: int,Q2: int] :
      ( ( ( normalize @ R )
        = ( product_Pair @ int @ int @ P4 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% normalize_denom_pos
thf(fact_4472_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P4: int,R: int] :
      ( ( Q2
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q2 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R @ S ) ) )
         => ( ( times_times @ int @ P4 @ S )
            = ( times_times @ int @ R @ Q2 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_4473_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L4: nat] : ( times_times @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ L4 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_4474_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_4475_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] : ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_4476_ln__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X )
          = ( suminf @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ ( one_one @ real ) ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_4477_arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arctan @ X )
        = ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_4478_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X4: A] :
          ( ( P @ X4 )
         => ( Q @ X4 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_4479_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( ring_1 @ B ) )
     => ! [A3: set @ A,F3: A > B] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ( member @ B @ ( F3 @ X4 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ A3 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_prod
thf(fact_4480_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F3: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F3 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X3: B] : ( semiring_1_of_nat @ A @ ( F3 @ X3 ) )
            @ A3 ) ) ) ).

% of_nat_prod
thf(fact_4481_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F3: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F3 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X3: B] : ( ring_1_of_int @ A @ ( F3 @ X3 ) )
            @ A3 ) ) ) ).

% of_int_prod
thf(fact_4482_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F3: nat > A] :
          ( ( suminf @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) )
          = ( F3 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_4483_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_4484_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F3: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A4: B] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ A4 ) )
            @ A3 ) ) ) ).

% norm_prod_le
thf(fact_4485_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R
                 != ( plus_plus @ rat @ S3 @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_4486_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X: A,Q: A > $o] :
      ( ( P @ X )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X ) ) ) ).

% rev_predicate1D
thf(fact_4487_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X )
       => ( Q @ X ) ) ) ).

% predicate1D
thf(fact_4488_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X3: rat,Y6: rat] :
          ( ( ord_less @ rat @ X3 @ Y6 )
          | ( X3 = Y6 ) ) ) ) ).

% less_eq_rat_def
thf(fact_4489_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
thf(fact_4490_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_4491_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_4492_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_4493_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_4494_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_4495_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_4496_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X3: nat] : X3
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod
thf(fact_4497_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X3: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ) ).

% sin_def
thf(fact_4498_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X3: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ) ).

% cos_def
thf(fact_4499_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F3: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( times_times @ A @ ( F3 @ A4 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_4500_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P4 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P4 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_4501_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X3: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ) ).

% exp_def
thf(fact_4502_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X3: nat] : X3
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_4503_monoseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X ) ) ) ) ).

% monoseq_realpow
thf(fact_4504_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_4505_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_4506_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X3: nat] : X3
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_4507_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_4508_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_4509_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X3: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N2 ) ) ) @ ( power_power @ A @ X3 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_4510_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_4511_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X3: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X3 )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X3 @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_4512_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K2: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_4513_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_4514_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_4515_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A,N: A,K: nat] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) )
                & ( ord_less_eq @ A @ ( F3 @ I2 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_4516_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N2: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_4517_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu2: B] : ( one_one @ A )
            @ A3 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_4518_int__prod,axiom,
    ! [B: $tType,F3: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F3 @ A3 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X3: B] : ( semiring_1_of_nat @ int @ ( F3 @ X3 ) )
        @ A3 ) ) ).

% int_prod
thf(fact_4519_prod__int__eq,axiom,
    ! [I: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ J ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X3: int] : X3
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ J ) ) ) ) ).

% prod_int_eq
thf(fact_4520_prod__int__plus__eq,axiom,
    ! [I: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ ( plus_plus @ nat @ I @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X3: int] : X3
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_4521_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
           != ( one_one @ A ) )
         => ~ ! [A5: B] :
                ( ( member @ B @ A5 @ A3 )
               => ( ( G @ A5 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_4522_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ( G @ X4 )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_4523_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X3: B] : ( times_times @ A @ ( G @ X3 ) @ ( H @ X3 ) )
            @ A3 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ H @ A3 ) ) ) ) ).

% prod.distrib
thf(fact_4524_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X4 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ).

% prod_nonneg
thf(fact_4525_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) )
                & ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( G @ I2 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_mono
thf(fact_4526_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ X4 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ).

% prod_pos
thf(fact_4527_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F3 @ X4 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ).

% prod_ge_1
thf(fact_4528_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X4 ) )
                & ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_4529_quotient__of__int,axiom,
    ! [A2: int] :
      ( ( quotient_of @ ( of_int @ A2 ) )
      = ( product_Pair @ int @ int @ A2 @ ( one_one @ int ) ) ) ).

% quotient_of_int
thf(fact_4530_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4531_summable__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_4532_sin__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X ) ) ).

% sin_paired
thf(fact_4533_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N2: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_4534_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F3: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_4535_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N2: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_4536_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( summable @ A @ F3 ) ) ) ).

% summable_iff_shift
thf(fact_4537_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F3 ) ) ) ) ).

% summable_cmult_iff
thf(fact_4538_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F3 @ N2 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F3 ) ) ) ) ).

% summable_divide_iff
thf(fact_4539_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
            @ X )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X ) ) ) ).

% powser_sums_zero_iff
thf(fact_4540_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_4541_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_4542_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_add
thf(fact_4543_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_4544_summable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_diff
thf(fact_4545_sums__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
              @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_diff
thf(fact_4546_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F3: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F3 @ I ) ) ) ).

% sums_single
thf(fact_4547_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu2: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_4548_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F3: nat > A] :
          ( ! [N3: nat] :
              ( ( F3 @ N3 )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F3 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_4549_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N6: nat,F3: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N6 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( G @ N3 ) ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_comparison_test'
thf(fact_4550_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_comparison_test
thf(fact_4551_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,G: nat > A,S: A,T2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( G @ N3 ) )
         => ( ( sums @ A @ F3 @ S )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_4552_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_4553_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F3 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_4554_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) ) ) ) ).

% summable_mult
thf(fact_4555_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_4556_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) ) )
          = ( summable @ A @ F3 ) ) ) ).

% summable_Suc_iff
thf(fact_4557_bij__betw__funpow,axiom,
    ! [A: $tType,F3: A > A,S2: set @ A,N: nat] :
      ( ( bij_betw @ A @ A @ F3 @ S2 @ S2 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ S2 @ S2 ) ) ).

% bij_betw_funpow
thf(fact_4558_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_4559_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,G: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( G @ N3 ) )
         => ( ( summable @ A @ F3 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F3 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_4560_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F3: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F3 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_4561_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F3: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F3 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_4562_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_mult_D
thf(fact_4563_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_4564_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_mult
thf(fact_4565_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( summable @ A @ F3 )
         => ( ( times_times @ A @ ( suminf @ A @ F3 ) @ C2 )
            = ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_4566_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F3 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( plus_plus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_4567_suminf__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( summable @ A @ G )
           => ( ( minus_minus @ A @ ( suminf @ A @ F3 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_diff
thf(fact_4568_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_4569_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ( ( suminf @ A @ F3 )
                = ( zero_zero @ A ) )
              = ( ! [N2: nat] :
                    ( ( F3 @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_4570_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_pos
thf(fact_4571_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F3 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_4572_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,S: A] :
          ( ( ( F3 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
              @ S )
           => ( sums @ A @ F3 @ S ) ) ) ) ).

% sums_Suc_imp
thf(fact_4573_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F3: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ L )
         => ( sums @ A @ F3 @ ( plus_plus @ A @ L @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_4574_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ S )
          = ( sums @ A @ F3 @ ( plus_plus @ A @ S @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_4575_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N: nat,F3: nat > A,S: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ N )
             => ( ( F3 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I3: nat] : ( F3 @ ( plus_plus @ nat @ I3 @ N ) )
              @ S )
            = ( sums @ A @ F3 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_4576_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_0_powser
thf(fact_4577_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F3: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_zero_power'
thf(fact_4578_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_4579_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_4580_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: nat > A,M: nat,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( plus_plus @ nat @ N2 @ M ) ) @ ( power_power @ A @ Z @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_4581_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_4582_summable__rabs__comparison__test,axiom,
    ! [F3: nat > real,G: nat > real] :
      ( ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F3 @ N3 ) ) @ ( G @ N3 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F3 @ N2 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_4583_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N6: nat,F3: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N3: nat] : ( member @ complex @ ( G @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N6 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N3 ) ) ) )
               => ( summable @ A @ F3 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4584_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [X4: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_4585_summable__rabs,axiom,
    ! [F3: nat > real] :
      ( ( summable @ real
        @ ^ [N2: nat] : ( abs_abs @ real @ ( F3 @ N2 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F3 ) )
        @ ( suminf @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F3 @ N2 ) ) ) ) ) ).

% summable_rabs
thf(fact_4586_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) )
              = ( ? [I3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I3 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_4587_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,I: nat] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F3 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_4588_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( C2 @ N2 ) ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_4589_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( if @ A @ ( N2 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z @ N2 ) )
          @ ( power_power @ A @ Z @ M ) ) ) ).

% powser_sums_if
thf(fact_4590_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_4591_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) ) ) ) ) ).

% powser_inside
thf(fact_4592_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_4593_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_4594_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F3 ) @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_4595_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% summable_exp
thf(fact_4596_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% summable_exp_generic
thf(fact_4597_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_converges
thf(fact_4598_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_converges
thf(fact_4599_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A] :
          ( ( summable @ real
            @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F3 ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) ) ) ) ) ).

% summable_norm
thf(fact_4600_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_4601_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_4602_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) )
          @ ( exp @ A @ X ) ) ) ).

% exp_converges
thf(fact_4603_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,K6: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K6 )
         => ( ! [X4: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K6 )
               => ( summable @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) ) ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_4604_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 ) ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_minus_converges
thf(fact_4605_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_minus_converges
thf(fact_4606_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_4607_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
            = ( plus_plus @ A @ ( F3 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
                @ Z ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_4608_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ Z )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_4609_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,F3: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ( summable @ A @ F3 )
           => ? [N9: nat] :
              ! [N4: nat] :
                ( ( ord_less_eq @ nat @ N9 @ N4 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I3: nat] : ( F3 @ ( plus_plus @ nat @ I3 @ N4 ) ) ) )
                  @ R ) ) ) ) ) ).

% suminf_exist_split
thf(fact_4610_summable__power__series,axiom,
    ! [F3: nat > real,Z: real] :
      ( ! [I2: nat] : ( ord_less_eq @ real @ ( F3 @ I2 ) @ ( one_one @ real ) )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ I2 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z )
         => ( ( ord_less @ real @ Z @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( F3 @ I3 ) @ ( power_power @ real @ Z @ I3 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_4611_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R )
         => ( ( ord_less @ real @ R @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N2 ) ) @ ( power_power @ real @ R @ N2 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_4612_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N6: nat,F3: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N6 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) ) ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_ratio_test
thf(fact_4613_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_4614_power__half__series,axiom,
    ( sums @ real
    @ ^ [N2: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N2 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_4615_sums__if_H,axiom,
    ! [G: nat > real,X: real] :
      ( ( sums @ real @ G @ X )
     => ( sums @ real
        @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X ) ) ).

% sums_if'
thf(fact_4616_sums__if,axiom,
    ! [G: nat > real,X: real,F3: nat > real,Y: real] :
      ( ( sums @ real @ G @ X )
     => ( ( sums @ real @ F3 @ Y )
       => ( sums @ real
          @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( F3 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sums_if
thf(fact_4617_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X ) ) ) ).

% cosh_converges
thf(fact_4618_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) )
          @ ( sinh @ A @ X ) ) ) ).

% sinh_converges
thf(fact_4619_cos__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ real @ X @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      @ ( cos @ real @ X ) ) ).

% cos_paired
thf(fact_4620_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( power_power @ A @ Z @ N2 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_4621_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M: nat,X: A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_4622_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X8: nat > A] :
              ( ! [M3: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N2 )
                 => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N2 ) ) )
              | ! [M3: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N2 )
                 => ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( X8 @ M3 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_4623_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [M2: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M2 @ N3 )
             => ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( X9 @ M2 ) ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% monoI2
thf(fact_4624_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [M2: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M2 @ N3 )
             => ( ord_less_eq @ A @ ( X9 @ M2 ) @ ( X9 @ N3 ) ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% monoI1
thf(fact_4625_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ B )
     => ! [A3: set @ A,F3: A > B] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ( member @ B @ ( F3 @ X4 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_sum
thf(fact_4626_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu2: B] : ( zero_zero @ A )
            @ A3 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_4627_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F3: B > nat,A3: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F3 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : ( semiring_1_of_nat @ A @ ( F3 @ X3 ) )
            @ A3 ) ) ) ).

% of_nat_sum
thf(fact_4628_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F3: B > int,A3: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F3 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : ( ring_1_of_int @ A @ ( F3 @ X3 ) )
            @ A3 ) ) ) ).

% of_int_sum
thf(fact_4629_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_4630_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F3: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] : ( abs_abs @ B @ ( F3 @ I3 ) )
            @ A3 ) ) ) ).

% sum_abs
thf(fact_4631_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F3: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] : ( abs_abs @ B @ ( F3 @ I3 ) )
            @ A3 ) ) ) ).

% sum_abs_ge_zero
thf(fact_4632_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : Y
            @ A3 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_4633_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_4634_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F3: A > B,A3: set @ A,G: C > B,B4: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B4 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I3: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J3: C] : ( times_times @ B @ ( F3 @ I3 ) @ ( G @ J3 ) )
                @ B4 )
            @ A3 ) ) ) ).

% sum_product
thf(fact_4635_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F3: B > A,A3: set @ B,R: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ ( F3 @ N2 ) @ R )
            @ A3 ) ) ) ).

% sum_distrib_right
thf(fact_4636_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R: A,F3: B > A,A3: set @ B] :
          ( ( times_times @ A @ R @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ R @ ( F3 @ N2 ) )
            @ A3 ) ) ) ).

% sum_distrib_left
thf(fact_4637_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F3: B > A,G: B > real] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ X4 ) ) @ ( G @ X4 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S2 ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S2 ) ) ) ) ).

% sum_norm_le
thf(fact_4638_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
           != ( zero_zero @ A ) )
         => ~ ! [A5: B] :
                ( ( member @ B @ A5 @ A3 )
               => ( ( G @ A5 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_4639_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ( G @ X4 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_4640_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : ( minus_minus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
            @ A3 )
          = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum_subtractf
thf(fact_4641_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X3: B] : ( plus_plus @ A @ ( G @ X3 ) @ ( H @ X3 ) )
            @ A3 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H @ A3 ) ) ) ) ).

% sum.distrib
thf(fact_4642_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K6: set @ B,F3: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ K6 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( G @ I2 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ K6 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K6 ) ) ) ) ).

% sum_mono
thf(fact_4643_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I3: B] : ( real_V7770717601297561774m_norm @ A @ ( F3 @ I3 ) )
            @ A3 ) ) ) ).

% norm_sum
thf(fact_4644_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_4645_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X4 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) ) ) ) ).

% sum_nonneg
thf(fact_4646_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ nat,F3: nat > A,G: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
         => ( ! [X4: nat] :
                ( ( member @ nat @ ( suc @ X4 ) @ A3 )
               => ( ( F3 @ ( suc @ X4 ) )
                  = ( G @ ( suc @ X4 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ A3 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A3 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_4647_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
thf(fact_4648_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_4649_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,I5: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M @ I3 ) )
            @ I5 )
          = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I5 ) ) ) ) ).

% sum_power_add
thf(fact_4650_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_4651_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F3: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ K6 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K6 ) ) ) ) ).

% sum_bounded_above
thf(fact_4652_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,K6: A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ K6 @ ( F3 @ I2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K6 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) ) ) ) ).

% sum_bounded_below
thf(fact_4653_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( ( F3 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_4654_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_4655_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_4656_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_4657_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_4658_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ I3 ) ) @ ( F3 @ I3 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F3 @ ( suc @ N ) ) @ ( F3 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_4659_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( plus_plus @ A @ ( F3 @ A4 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_4660_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F3: B > A,K6: real] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ X4 ) ) @ K6 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S2 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S2 ) ) @ K6 ) ) ) ) ).

% sum_norm_bound
thf(fact_4661_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P4 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P4 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_4662_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F3: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less @ A @ ( F3 @ I2 ) @ K6 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A3 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K6 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_4663_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,X: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I5 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I2 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I5 )
              = ( one_one @ B ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I5 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I2 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I3: A] : ( times_times @ B @ ( A2 @ I3 ) @ ( X @ I3 ) )
                      @ I5 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_4664_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F3 @ K2 ) @ ( F3 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( minus_minus @ A @ ( F3 @ M ) @ ( F3 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F3 @ K2 ) @ ( F3 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_4665_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( minus_minus @ A @ ( F3 @ K2 ) @ ( F3 @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
            = ( minus_minus @ A @ ( F3 @ N ) @ ( F3 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_4666_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,E: real] :
          ( ( summable @ A @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ~ ! [N9: nat] :
                  ~ ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ M4 )
                     => ! [N4: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ M4 @ N4 ) ) ) @ E ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_4667_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_4668_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_4669_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.in_pairs
thf(fact_4670_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_4671_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_4672_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_4673_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I3 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_4674_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_4675_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I3: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I3 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_4676_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_4677_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I3 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_4678_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_4679_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_4680_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_4681_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_4682_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ R @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_4683_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( X9 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% mono_SucI1
thf(fact_4684_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X9 @ ( suc @ N3 ) ) @ ( X9 @ N3 ) )
         => ( topological_monoseq @ A @ X9 ) ) ) ).

% mono_SucI2
thf(fact_4685_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X8: nat > A] :
              ( ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ N2 ) @ ( X8 @ ( suc @ N2 ) ) )
              | ! [N2: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N2 ) ) @ ( X8 @ N2 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_4686_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P2 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P2 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P2 ) ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P2 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P2 ) )
          @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ).

% sin_x_sin_y
thf(fact_4687_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P2 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P2 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P2 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P2 @ N2 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P2 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_4688_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P2 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P2 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P2 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P2 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P2 ) )
          @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ).

% cos_x_cos_y
thf(fact_4689_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I @ K ) ) ) ).

% atMost_iff
thf(fact_4690_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X ) @ ( set_ord_atMost @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% atMost_subset_iff
thf(fact_4691_card__atMost,axiom,
    ! [U: nat] :
      ( ( finite_card @ nat @ ( set_ord_atMost @ nat @ U ) )
      = ( suc @ U ) ) ).

% card_atMost
thf(fact_4692_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H: A,H2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) @ ( set_ord_atMost @ A @ H2 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H )
            | ( ord_less_eq @ A @ H @ H2 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_4693_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_4694_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_4695_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_4696_Complex__sum_H,axiom,
    ! [A: $tType,F3: A > real,S: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X3: A] : ( complex2 @ ( F3 @ X3 ) @ ( zero_zero @ real ) )
        @ S )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F3 @ S ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_4697_int__sum,axiom,
    ! [B: $tType,F3: B > nat,A3: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F3 @ A3 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X3: B] : ( semiring_1_of_nat @ int @ ( F3 @ X3 ) )
        @ A3 ) ) ).

% int_sum
thf(fact_4698_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X3: A] : ( ord_less_eq @ A @ X3 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_4699_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_4700_atMost__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ K ) )
      = ( insert @ nat @ ( suc @ K ) @ ( set_ord_atMost @ nat @ K ) ) ) ).

% atMost_Suc
thf(fact_4701_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H: A,L3: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H2 ) ) ) ).

% not_Iic_le_Icc
thf(fact_4702_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set @ A,G: A > nat,F3: A > nat] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A3 )
         => ( ord_less_eq @ nat @ ( G @ X4 ) @ ( F3 @ X4 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X3: A] : ( minus_minus @ nat @ ( F3 @ X3 ) @ ( G @ X3 ) )
          @ A3 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A3 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_4703_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X3: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_4704_sum__choose__upper,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( binomial @ K2 @ M )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ N ) @ ( suc @ M ) ) ) ).

% sum_choose_upper
thf(fact_4705_sum__SucD,axiom,
    ! [A: $tType,F3: A > nat,A3: set @ A,N: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 )
        = ( suc @ N ) )
     => ? [X4: A] :
          ( ( member @ A @ X4 @ A3 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X4 ) ) ) ) ).

% sum_SucD
thf(fact_4706_sum__Suc,axiom,
    ! [A: $tType,F3: A > nat,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X3: A] : ( suc @ ( F3 @ X3 ) )
        @ A3 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( finite_card @ A @ A3 ) ) ) ).

% sum_Suc
thf(fact_4707_real__of__card,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A3 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X3: A] : ( one_one @ real )
        @ A3 ) ) ).

% real_of_card
thf(fact_4708_sum__choose__lower,axiom,
    ! [R: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( binomial @ ( plus_plus @ nat @ R @ K2 ) @ K2 )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R @ N ) ) @ N ) ) ).

% sum_choose_lower
thf(fact_4709_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N @ J3 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_4710_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N @ J3 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_4711_sum__diff1__nat,axiom,
    ! [A: $tType,A2: A,A3: set @ A,F3: A > nat] :
      ( ( ( member @ A @ A2 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( F3 @ A2 ) ) ) )
      & ( ~ ( member @ A @ A2 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) ) ) ) ).

% sum_diff1_nat
thf(fact_4712_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_4713_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: nat > A,I: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ ( F3 @ I3 ) @ ( F3 @ ( suc @ I3 ) ) )
            @ ( set_ord_atMost @ nat @ I ) )
          = ( minus_minus @ A @ ( F3 @ ( zero_zero @ nat ) ) @ ( F3 @ ( suc @ I ) ) ) ) ) ).

% sum_telescope
thf(fact_4714_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,D2: nat > A] :
          ( ( ! [X3: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X3 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( D2 @ I3 ) @ ( power_power @ A @ X3 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) ) )
          = ( ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N )
               => ( ( C2 @ I3 )
                  = ( D2 @ I3 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_4715_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B4: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N3 ) ) @ B4 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_4716_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_4717_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K2: nat] : ( binomial @ ( minus_minus @ nat @ N @ K2 ) @ ( minus_minus @ nat @ M @ K2 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_4718_vandermonde,axiom,
    ! [M: nat,N: nat,R: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( binomial @ M @ K2 ) @ ( binomial @ N @ ( minus_minus @ nat @ R @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ R ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N ) @ R ) ) ).

% vandermonde
thf(fact_4719_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X3: complex] : X3
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_4720_norm__prod__diff,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I5: set @ I6,Z: I6 > A,W: I6 > A] :
          ( ! [I2: I6] :
              ( ( member @ I6 @ I2 @ I5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z @ I2 ) ) @ ( one_one @ real ) ) )
         => ( ! [I2: I6] :
                ( ( member @ I6 @ I2 @ I5 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I2 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I6 @ A @ Z @ I5 ) @ ( groups7121269368397514597t_prod @ I6 @ A @ W @ I5 ) ) )
              @ ( groups7311177749621191930dd_sum @ I6 @ real
                @ ^ [I3: I6] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z @ I3 ) @ ( W @ I3 ) ) )
                @ I5 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_4721_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N: nat,K: nat] :
          ( ! [W2: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ W2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_4722_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( ! [X3: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X3 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N )
               => ( ( C2 @ I3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_4723_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_4724_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K2 ) ) @ K2 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_4725_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4726_binomial,axiom,
    ! [A2: nat,B2: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K2 ) ) @ ( power_power @ nat @ A2 @ K2 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_4727_sum__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X3: complex] : X3
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_4728_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_4729_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              @ N ) ) ) ) ).

% polyfun_roots_card
thf(fact_4730_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_4731_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N: nat,B2: nat > nat,X: nat] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ M @ I2 )
         => ( ( A2 @ I2 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I3: nat] : ( times_times @ nat @ ( A2 @ I3 ) @ ( power_power @ nat @ X @ I3 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J3: nat] : ( times_times @ nat @ ( B2 @ J3 ) @ ( power_power @ nat @ X @ J3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K2: nat] : ( times_times @ nat @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_4732_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( power_power @ nat @ ( binomial @ N @ K2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_4733_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( summable @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I3 ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_4734_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I3 ) ) )
                    @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_4735_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.in_pairs_0
thf(fact_4736_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N: nat,B2: nat > A,X: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ M @ I2 )
             => ( ( A2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J3: nat] : ( times_times @ A @ ( B2 @ J3 ) @ ( power_power @ A @ X @ J3 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_4737_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_4738_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,K: A] :
          ( ( ! [X3: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X3 @ I3 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X3: nat] :
                ( ( member @ nat @ X3 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) )
               => ( ( C2 @ X3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_4739_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_4740_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K2 ) ) @ ( power_power @ A @ A2 @ K2 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_4741_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_4742_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( sums @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I3 ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_4743_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: nat,K: nat,G: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_4744_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_4745_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: nat,K: nat,G: nat > A,H: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_4746_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_4747_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I3: nat] : ( times_times @ nat @ I3 @ ( binomial @ N @ I3 ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_4748_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I3 ) ) @ ( power_power @ A @ X @ I3 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ I3 ) ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ I3 ) ) ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_4749_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,Z: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( ( power_power @ A @ Z @ N )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I3
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I3 = N ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z @ I3 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_4750_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_4751_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I3 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_4752_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K2 ) ) @ K2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_4753_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A2 ) @ ( one_one @ A ) ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_4754_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I3 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_4755_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E: real,C2: nat > A,N: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ? [M10: real] :
            ! [Z3: A] :
              ( ( ord_less_eq @ real @ M10 @ ( real_V7770717601297561774m_norm @ A @ Z3 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                    @ ( set_ord_atMost @ nat @ N ) ) )
                @ ( times_times @ real @ E @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ ( suc @ N ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_4756_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X3: int] : X3
          @ ( set_or1337092689740270186AtMost @ int @ M @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_4757_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_4758_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I3 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_4759_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I3 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_4760_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_4761_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_4762_Maclaurin__cos__expansion2,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_4763_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( sin @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_4764_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X ) @ ( set_ord_lessThan @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% lessThan_subset_iff
thf(fact_4765_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_4766_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A] :
          ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) @ ( set_ord_lessThan @ A @ K ) )
          = ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% single_Diff_lessThan
thf(fact_4767_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_4768_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_4769_sumr__cos__zero__one,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M3 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_4770_lessThan__Suc__atMost,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( set_ord_atMost @ nat @ K ) ) ).

% lessThan_Suc_atMost
thf(fact_4771_lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( insert @ nat @ K @ ( set_ord_lessThan @ nat @ K ) ) ) ).

% lessThan_Suc
thf(fact_4772_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_4773_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_4774_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I3 ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_4775_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I3 ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_4776_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N: A] :
          ( ! [X4: A] : ( ord_less_eq @ nat @ ( Q @ X4 ) @ ( P @ X4 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X3: A] : ( minus_minus @ nat @ ( P @ X3 ) @ ( Q @ X3 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_4777_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,X: A] :
          ( ( summable @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( ord_less_eq @ A @ ( suminf @ A @ F3 ) @ X ) ) ) ) ).

% suminf_le_const
thf(fact_4778_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F3: nat > A,N: nat,R: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ R ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ ( F3 @ I3 ) @ R )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_4779_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_4780_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F3 @ M ) @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_4781_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F3 @ ( zero_zero @ nat ) ) @ ( F3 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_4782_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,X: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( summable @ A @ F3 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_4783_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_4784_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( G @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_4785_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I3: nat] : ( F3 @ ( plus_plus @ nat @ I3 @ N ) )
            @ S )
          = ( sums @ A @ F3 @ ( plus_plus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_4786_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,S: A,N: nat] :
          ( ( sums @ A @ F3 @ S )
         => ( sums @ A
            @ ^ [I3: nat] : ( F3 @ ( plus_plus @ nat @ I3 @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_4787_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I3: nat] : ( F3 @ ( plus_plus @ nat @ I3 @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) ) )
          = ( sums @ A @ F3 @ S ) ) ) ).

% sums_iff_shift'
thf(fact_4788_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] : ( G @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_4789_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( F3 @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_4790_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I3 ) @ ( set_ord_lessThan @ nat @ I3 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nested_swap'
thf(fact_4791_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I3 ) @ ( set_ord_lessThan @ nat @ I3 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nested_swap'
thf(fact_4792_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_4793_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_4794_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_4795_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_4796_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_4797_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A @ F3 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_4798_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( summable @ A @ F3 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F3 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_4799_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,N: nat] :
          ( ( summable @ A @ F3 )
         => ( ! [M2: nat] :
                ( ( ord_less_eq @ nat @ N @ M2 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ M2 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F3 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_4800_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_4801_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z: A,H: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P2: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ ( minus_minus @ nat @ M @ P2 ) ) @ ( power_power @ A @ Z @ P2 ) ) @ ( power_power @ A @ Z @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P2: nat] : ( times_times @ A @ ( power_power @ A @ Z @ P2 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ ( minus_minus @ nat @ M @ P2 ) ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ M @ P2 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_4802_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N ) ) @ ( power_power @ A @ Y @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P2: nat] : ( times_times @ A @ ( power_power @ A @ X @ P2 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ P2 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_4803_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ ( suc @ I3 ) ) ) @ ( power_power @ A @ X @ I3 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_4804_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ A2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) )
         => ~ ! [B5: nat > A] :
                ~ ! [Z3: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z3 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( B5 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_4805_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N: nat,A2: A] :
        ? [B5: nat > A] :
        ! [Z3: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z3 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( B5 @ I3 ) @ ( power_power @ A @ Z3 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ A2 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_4806_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,F3: nat > A,K6: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N )
             => ( ord_less_eq @ A @ ( F3 @ P7 ) @ K6 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K6 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ K6 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_4807_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,N: nat,I: nat] :
          ( ( summable @ A @ F3 )
         => ( ! [M2: nat] :
                ( ( ord_less_eq @ nat @ N @ M2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ M2 ) ) )
           => ( ( ord_less_eq @ nat @ N @ I )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F3 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_4808_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ I3 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_4809_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: real,N: nat,Diff: nat > A > real] :
          ( ( X
            = ( zero_zero @ real ) )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_4810_Maclaurin__lemma,axiom,
    ! [H: real,F3: real > real,J: nat > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ? [B9: real] :
          ( ( F3 @ H )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
              @ ( set_ord_lessThan @ nat @ N ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H @ N ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_4811_sum__split__even__odd,axiom,
    ! [F3: nat > real,G: nat > real,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( F3 @ I3 ) @ ( G @ I3 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I3: nat] : ( F3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I3 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum_split_even_odd
thf(fact_4812_Maclaurin__exp__le,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( exp @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_4813_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y @ I3 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J3 @ K2 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y @ K2 ) ) @ ( power_power @ A @ X @ J3 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ J3 ) ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_4814_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X3: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X3 @ N2 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ K ) ) ) @ ( power_power @ A @ X3 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_4815_Maclaurin__sin__bound,axiom,
    ! [X: real,N: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( abs_abs @ real @ X ) @ N ) ) ) ).

% Maclaurin_sin_bound
thf(fact_4816_sum__pos__lt__pair,axiom,
    ! [F3: nat > real,K: nat] :
      ( ( summable @ real @ F3 )
     => ( ! [D6: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F3 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D6 ) ) ) @ ( F3 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D6 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F3 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F3 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_4817_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ X @ I3 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y @ I3 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( A2 @ I3 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ J3 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
                    @ ( power_power @ A @ X @ J3 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_4818_Maclaurin__exp__lt,axiom,
    ! [X: real,N: nat] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( exp @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_4819_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( bij_betw @ nat @ complex
        @ ^ [K2: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        @ ( set_ord_lessThan @ nat @ N )
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4820_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H: A,Z: A,N: nat] :
          ( ( H
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H ) @ Q4 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ P2 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_4821_Maclaurin__sin__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_4822_Maclaurin__sin__expansion2,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( sin @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_4823_Maclaurin__cos__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( cos @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_4824_Maclaurin__sin__expansion4,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X )
          & ( ( sin @ real @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_4825_Arg__def,axiom,
    ( arg
    = ( ^ [Z6: complex] :
          ( if @ real
          @ ( Z6
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A4: real] :
                ( ( ( sgn_sgn @ complex @ Z6 )
                  = ( cis @ A4 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A4 )
                & ( ord_less_eq @ real @ A4 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4826_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_4827_arctan__def,axiom,
    ( arctan
    = ( ^ [Y6: real] :
          ( the @ real
          @ ^ [X3: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
              & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X3 )
                = Y6 ) ) ) ) ) ).

% arctan_def
thf(fact_4828_some__sym__eq__trivial,axiom,
    ! [A: $tType,X: A] :
      ( ( fChoice @ A
        @ ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
          @ X ) )
      = X ) ).

% some_sym_eq_trivial
thf(fact_4829_some__eq__trivial,axiom,
    ! [A: $tType,X: A] :
      ( ( fChoice @ A
        @ ^ [Y6: A] : ( Y6 = X ) )
      = X ) ).

% some_eq_trivial
thf(fact_4830_some__equality,axiom,
    ! [A: $tType,P: A > $o,A2: A] :
      ( ( P @ A2 )
     => ( ! [X4: A] :
            ( ( P @ X4 )
           => ( X4 = A2 ) )
       => ( ( fChoice @ A @ P )
          = A2 ) ) ) ).

% some_equality
thf(fact_4831_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_4832_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P3: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X3: A] :
              ~ ( P @ X3 ) ) )
     => ( ! [X4: A] :
            ( ( P @ X4 )
            = ( P3 @ X4 ) )
       => ( ( ! [X8: A] : ( P3 @ X8 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_forall_indirect2
thf(fact_4833_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X3: A] :
              ~ ( P @ X3 ) ) )
     => ( ( ! [X8: A] : ( P @ X8 ) )
        = ( P @ X ) ) ) ).

% verit_sko_forall_indirect
thf(fact_4834_some1__equality,axiom,
    ! [A: $tType,P: A > $o,A2: A] :
      ( ? [X5: A] :
          ( ( P @ X5 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X5 ) ) )
     => ( ( P @ A2 )
       => ( ( fChoice @ A @ P )
          = A2 ) ) ) ).

% some1_equality
thf(fact_4835_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P3: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ! [X4: A] :
            ( ( P @ X4 )
            = ( P3 @ X4 ) )
       => ( ( ? [X8: A] : ( P3 @ X8 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_ex_indirect2
thf(fact_4836_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ( ? [X8: A] : ( P @ X8 ) )
        = ( P @ X ) ) ) ).

% verit_sko_ex_indirect
thf(fact_4837_some__eq__ex,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X8: A] : ( P @ X8 ) ) ) ).

% some_eq_ex
thf(fact_4838_someI2__bex,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o,Q: A > $o] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ A3 )
          & ( P @ X5 ) )
     => ( ! [X4: A] :
            ( ( ( member @ A @ X4 @ A3 )
              & ( P @ X4 ) )
           => ( Q @ X4 ) )
       => ( Q
          @ ( fChoice @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( P @ X3 ) ) ) ) ) ) ).

% someI2_bex
thf(fact_4839_someI2__ex,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ? [X_1: A] : ( P @ X_1 )
     => ( ! [X4: A] :
            ( ( P @ X4 )
           => ( Q @ X4 ) )
       => ( Q @ ( fChoice @ A @ P ) ) ) ) ).

% someI2_ex
thf(fact_4840_someI__ex,axiom,
    ! [A: $tType,P: A > $o] :
      ( ? [X_1: A] : ( P @ X_1 )
     => ( P @ ( fChoice @ A @ P ) ) ) ).

% someI_ex
thf(fact_4841_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B4: A,A3: A,P: A > $o] :
      ( ( B4 = A3 )
     => ( ( ( fChoice @ A @ P )
          = A3 )
        = ( ( fChoice @ A @ P )
          = B4 ) ) ) ).

% verit_sko_forall''
thf(fact_4842_verit__sko__forall_H,axiom,
    ! [A: $tType,P: A > $o,A3: $o] :
      ( ( ( P
          @ ( fChoice @ A
            @ ^ [X3: A] :
                ~ ( P @ X3 ) ) )
        = A3 )
     => ( ( ! [X8: A] : ( P @ X8 ) )
        = A3 ) ) ).

% verit_sko_forall'
thf(fact_4843_someI2,axiom,
    ! [A: $tType,P: A > $o,A2: A,Q: A > $o] :
      ( ( P @ A2 )
     => ( ! [X4: A] :
            ( ( P @ X4 )
           => ( Q @ X4 ) )
       => ( Q @ ( fChoice @ A @ P ) ) ) ) ).

% someI2
thf(fact_4844_verit__sko__forall,axiom,
    ! [A: $tType] :
      ( ( ^ [P5: A > $o] :
          ! [X7: A] : ( P5 @ X7 ) )
      = ( ^ [P6: A > $o] :
            ( P6
            @ ( fChoice @ A
              @ ^ [X3: A] :
                  ~ ( P6 @ X3 ) ) ) ) ) ).

% verit_sko_forall
thf(fact_4845_verit__sko__ex_H,axiom,
    ! [A: $tType,P: A > $o,A3: $o] :
      ( ( ( P @ ( fChoice @ A @ P ) )
        = A3 )
     => ( ( ? [X8: A] : ( P @ X8 ) )
        = A3 ) ) ).

% verit_sko_ex'
thf(fact_4846_someI,axiom,
    ! [A: $tType,P: A > $o,X: A] :
      ( ( P @ X )
     => ( P @ ( fChoice @ A @ P ) ) ) ).

% someI
thf(fact_4847_Eps__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( fChoice @ A @ P )
        = ( fChoice @ A @ Q ) ) ) ).

% Eps_cong
thf(fact_4848_tfl__some,axiom,
    ! [A: $tType,P8: A > $o,X5: A] :
      ( ( P8 @ X5 )
     => ( P8 @ ( fChoice @ A @ P8 ) ) ) ).

% tfl_some
thf(fact_4849_some__eq__imp,axiom,
    ! [A: $tType,P: A > $o,A2: A,B2: A] :
      ( ( ( fChoice @ A @ P )
        = A2 )
     => ( ( P @ B2 )
       => ( P @ A2 ) ) ) ).

% some_eq_imp
thf(fact_4850_some__in__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( member @ A
        @ ( fChoice @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ A3 ) )
        @ A3 )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) ) ) ) ).

% some_in_eq
thf(fact_4851_ln__real__def,axiom,
    ( ( ln_ln @ real )
    = ( ^ [X3: real] :
          ( the @ real
          @ ^ [U2: real] :
              ( ( exp @ real @ U2 )
              = X3 ) ) ) ) ).

% ln_real_def
thf(fact_4852_ln__neg__is__const,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X )
        = ( the @ real
          @ ^ [X3: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_4853_rat__times__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ B3 ) @ ( times_times @ int @ C3 @ D4 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_times_code
thf(fact_4854_rat__divide__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ D4 ) @ ( times_times @ int @ C3 @ B3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_divide_code
thf(fact_4855_arccos__def,axiom,
    ( arccos
    = ( ^ [Y6: real] :
          ( the @ real
          @ ^ [X3: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
              & ( ord_less_eq @ real @ X3 @ pi )
              & ( ( cos @ real @ X3 )
                = Y6 ) ) ) ) ) ).

% arccos_def
thf(fact_4856_rat__plus__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A4 @ D4 ) @ ( times_times @ int @ B3 @ C3 ) ) @ ( times_times @ int @ C3 @ D4 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_plus_code
thf(fact_4857_rat__minus__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D4: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A4 @ D4 ) @ ( times_times @ int @ B3 @ C3 ) ) @ ( times_times @ int @ C3 @ D4 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_minus_code
thf(fact_4858_rat__inverse__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,B3: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A4
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A4 ) @ B3 ) @ ( abs_abs @ int @ A4 ) ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_inverse_code
thf(fact_4859_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L4: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L4 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L4 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_4860_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L4: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L4 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L4 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_4861_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X3 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_4862_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X3 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_4863_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L4: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L4 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L4 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_4864_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y6: real] :
          ( the @ real
          @ ^ [X3: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
              & ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X3 )
                = Y6 ) ) ) ) ) ).

% arcsin_def
thf(fact_4865_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F22: nat > T > T,X3: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F22 @ X3 ) ) ) ) ).

% old.rec_nat_def
thf(fact_4866_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N2: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N2
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M3 @ N2 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M3 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_4867_rec__nat__0__imp,axiom,
    ! [A: $tType,F3: nat > A,F1: A,F2: nat > A > A] :
      ( ( F3
        = ( rec_nat @ A @ F1 @ F2 ) )
     => ( ( F3 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_4868_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_4869_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_4870_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_4871_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_4872_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I3: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( G @ I3 @ ( minus_minus @ nat @ K2 @ I3 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_4873_subset__CollectI,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ B4 )
           => ( ( Q @ X4 )
             => ( P @ X4 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ B4 )
                & ( Q @ X3 ) ) )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( P @ X3 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_4874_subset__Collect__iff,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( P @ X3 ) ) ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ B4 )
             => ( P @ X3 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_4875_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X3: rat] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z6 ) @ X3 )
              & ( ord_less @ rat @ X3 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_4876_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X3: real] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z6 ) @ X3 )
              & ( ord_less @ real @ X3 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_4877_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F3: nat > A,F1: A,F2: nat > A > A,N: nat] :
      ( ( F3
        = ( rec_nat @ A @ F1 @ F2 ) )
     => ( ( F3 @ ( suc @ N ) )
        = ( F2 @ N @ ( F3 @ N ) ) ) ) ).

% rec_nat_Suc_imp
thf(fact_4878_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M3: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_4879_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_4880_pred__subset__eq,axiom,
    ! [A: $tType,R2: set @ A,S2: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X3: A] : ( member @ A @ X3 @ R2 )
        @ ^ [X3: A] : ( member @ A @ X3 @ S2 ) )
      = ( ord_less_eq @ ( set @ A ) @ R2 @ S2 ) ) ).

% pred_subset_eq
thf(fact_4881_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( fChoice @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X10: A,Y7: B] :
              ( ( X = X10 )
              & ( Y = Y7 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y ) ) ).

% Eps_case_prod_eq
thf(fact_4882_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fChoice @ ( product_prod @ A @ B ) )
      = ( ^ [P6: ( product_prod @ A @ B ) > $o] :
            ( fChoice @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A4: A,B3: B] : ( P6 @ ( product_Pair @ A @ B @ A4 @ B3 ) ) ) ) ) ) ).

% split_paired_Eps
thf(fact_4883_subrelI,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ! [X4: A,Y3: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y3 ) @ R )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y3 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) ).

% subrelI
thf(fact_4884_prod__encode__def,axiom,
    ( nat_prod_encode
    = ( product_case_prod @ nat @ nat @ nat
      @ ^ [M3: nat,N2: nat] : ( plus_plus @ nat @ ( nat_triangle @ ( plus_plus @ nat @ M3 @ N2 ) ) @ M3 ) ) ) ).

% prod_encode_def
thf(fact_4885_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X3: A,Y6: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y6 ) @ R2 )
        @ ^ [X3: A,Y6: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y6 ) @ S2 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S2 ) ) ).

% pred_subset_eq2
thf(fact_4886_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_4887_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_4888_Frct__code__post_I3_J,axiom,
    ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) )
    = ( one_one @ rat ) ) ).

% Frct_code_post(3)
thf(fact_4889_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_4890_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4891_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4892_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4893_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X4: A,Y3: B] :
          ( ( P @ X4 @ Y3 )
         => ( Q @ X4 @ Y3 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_4894_set__decode__inverse,axiom,
    ! [N: nat] :
      ( ( nat_set_encode @ ( nat_set_decode @ N ) )
      = N ) ).

% set_decode_inverse
thf(fact_4895_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4896_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4897_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,J: A,M: A,N: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ J ) @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
          = ( ( ord_less_eq @ A @ J @ I )
            | ( ( ord_less_eq @ A @ M @ I )
              & ( ord_less_eq @ A @ J @ N ) ) ) ) ) ).

% ivl_subset
thf(fact_4898_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,N: A,M: A] :
          ( ( ord_less_eq @ A @ I @ N )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ M ) @ ( set_or7035219750837199246ssThan @ A @ I @ N ) )
            = ( set_or7035219750837199246ssThan @ A @ N @ M ) ) ) ) ).

% ivl_diff
thf(fact_4899_lessThan__minus__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: A,M: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_ord_lessThan @ A @ N ) @ ( set_ord_lessThan @ A @ M ) )
          = ( set_or7035219750837199246ssThan @ A @ M @ N ) ) ) ).

% lessThan_minus_lessThan
thf(fact_4900_card__atLeastLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or7035219750837199246ssThan @ nat @ L @ U ) )
      = ( minus_minus @ nat @ U @ L ) ) ).

% card_atLeastLessThan
thf(fact_4901_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4902_atLeastLessThan__singleton,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ M ) )
      = ( insert @ nat @ M @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_4903_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4904_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4905_less__by__empty,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A ),B4: set @ ( product_prod @ A @ A )] :
      ( ( A3
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A3 @ B4 ) ) ).

% less_by_empty
thf(fact_4906_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X: A,Y: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X @ Y )
       => ( Q @ X @ Y ) ) ) ).

% predicate2D
thf(fact_4907_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Y: B,Q: A > B > $o] :
      ( ( P @ X @ Y )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X @ Y ) ) ) ).

% rev_predicate2D
thf(fact_4908_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4909_all__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X3 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4910_ex__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X3: nat] :
            ( ( member @ nat @ X3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X3 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4911_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ L @ ( suc @ U ) )
      = ( set_or1337092689740270186AtMost @ nat @ L @ U ) ) ).

% atLeastLessThanSuc_atLeastAtMost
thf(fact_4912_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_4913_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_4914_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_Suc_ivl
thf(fact_4915_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4916_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( suc @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_Suc_ivl
thf(fact_4917_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( plus_plus @ nat @ I3 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4918_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ L ) @ U )
      = ( set_or5935395276787703475ssThan @ nat @ L @ U ) ) ).

% atLeastSucLessThan_greaterThanLessThan
thf(fact_4919_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X4: B] :
                  ( ( ord_less_eq @ B @ C2 @ X4 )
                 => ( ( ord_less @ B @ X4 @ D2 )
                   => ( ( G @ X4 )
                      = ( H @ X4 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4920_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X4: B] :
                  ( ( ord_less_eq @ B @ C2 @ X4 )
                 => ( ( ord_less @ B @ X4 @ D2 )
                   => ( ( G @ X4 )
                      = ( H @ X4 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4921_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,P4: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P4 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4922_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,P4: nat,F3: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P4 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ N @ P4 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4923_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,P4: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P4 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4924_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_4925_subset__card__intvl__is__intvl,axiom,
    ! [A3: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) )
     => ( A3
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_4926_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4927_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4928_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: nat > A,K: nat] :
          ( ( ( F3 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_4929_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4930_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4931_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4932_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_4933_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [A4: A,B3: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
thf(fact_4934_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4935_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4936_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4937_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ N ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4938_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4939_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F3: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ I3 ) ) @ ( F3 @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F3 @ N ) @ ( F3 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4940_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I3 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_4941_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_4942_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P2: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C3: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D4: int] : ( ord_less @ int @ ( times_times @ int @ A4 @ D4 ) @ ( times_times @ int @ C3 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P2 ) ) ) ) ).

% rat_less_code
thf(fact_4943_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sum.nested_swap
thf(fact_4944_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I3 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_4945_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( A2 @ I3 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% prod.nested_swap
thf(fact_4946_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_4947_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_4948_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P2: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C3: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D4: int] : ( ord_less_eq @ int @ ( times_times @ int @ A4 @ D4 ) @ ( times_times @ int @ C3 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P2 ) ) ) ) ).

% rat_less_eq_code
thf(fact_4949_prod__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_fact
thf(fact_4950_prod__Suc__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_Suc_fact
thf(fact_4951_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N6: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N6 ) @ N ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_4952_card__sum__le__nat__sum,axiom,
    ! [S2: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S2 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X3: nat] : X3
        @ S2 ) ) ).

% card_sum_le_nat_sum
thf(fact_4953_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4954_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4955_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_4956_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4957_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I3 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4958_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4959_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_4960_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_4961_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F5: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N7: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ M3 )
                 => ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N2 ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4962_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F3: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F3 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N2 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_4963_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( bit_se4730199178511100633sh_bit @ A @ K2 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ K2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% take_bit_sum
thf(fact_4964_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_4965_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4966_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4967_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I3: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K2 @ I3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4968_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4969_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I3: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I3 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4970_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I3: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I3 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) )
              @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4971_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: nat > A,B2: nat > A] :
          ( ! [I2: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N )
               => ( ord_less_eq @ A @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
         => ( ! [I2: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ K2 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4972_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N )
           => ( ord_less_eq @ nat @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
     => ( ! [I2: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I3: nat] : ( times_times @ nat @ ( A2 @ I3 ) @ ( B2 @ I3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4973_accp__subset,axiom,
    ! [A: $tType,R12: A > A > $o,R23: A > A > $o] :
      ( ( ord_less_eq @ ( A > A > $o ) @ R12 @ R23 )
     => ( ord_less_eq @ ( A > $o ) @ ( accp @ A @ R23 ) @ ( accp @ A @ R12 ) ) ) ).

% accp_subset
thf(fact_4974_card__atLeastLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ L @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ L ) ) ) ).

% card_atLeastLessThan_int
thf(fact_4975_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ L @ ( plus_plus @ int @ U @ ( one_one @ int ) ) )
      = ( set_or1337092689740270186AtMost @ int @ L @ U ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
thf(fact_4976_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_4977_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or5935395276787703475ssThan @ int @ L @ U ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
thf(fact_4978_accp__subset__induct,axiom,
    ! [A: $tType,D3: A > $o,R2: A > A > $o,X: A,P: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ D3 @ ( accp @ A @ R2 ) )
     => ( ! [X4: A,Z5: A] :
            ( ( D3 @ X4 )
           => ( ( R2 @ Z5 @ X4 )
             => ( D3 @ Z5 ) ) )
       => ( ( D3 @ X )
         => ( ! [X4: A] :
                ( ( D3 @ X4 )
               => ( ! [Z3: A] :
                      ( ( R2 @ Z3 @ X4 )
                     => ( P @ Z3 ) )
                 => ( P @ X4 ) ) )
           => ( P @ X ) ) ) ) ) ).

% accp_subset_induct
thf(fact_4979_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_4980_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D4: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z9: int,Z6: int] :
                ( ( ord_less_eq @ int @ D4 @ Z6 )
                & ( ord_less @ int @ Z9 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_4981_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D4: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z9: int,Z6: int] :
                ( ( ord_less_eq @ int @ D4 @ Z9 )
                & ( ord_less @ int @ Z9 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_4982_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F3: nat > A > A,A2: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F3 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A2 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F3 @ A2 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F3 @ A2 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F3 @ ( plus_plus @ nat @ A2 @ ( one_one @ nat ) ) @ B2 @ ( F3 @ A2 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_4983_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb3: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb3 @ Xc )
        = Y )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb3 @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb3 @ Xa )
               => ( Y = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb3 @ Xa )
               => ( Y
                  = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb3 @ ( X @ Xa @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb3 @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_4984_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A3: A > B > $o,B4: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A3 ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ B4 ) ) ) ) ).

% Collect_case_prod_mono
thf(fact_4985_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A1: nat,A22: nat,A32: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A1 @ ( product_Pair @ nat @ A @ A22 @ A32 ) ) ) )
     => ( ! [F4: nat > A > A,A5: nat,B5: nat,Acc3: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F4 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A5 @ ( product_Pair @ nat @ A @ B5 @ Acc3 ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B5 @ A5 )
               => ( P @ F4 @ ( plus_plus @ nat @ A5 @ ( one_one @ nat ) ) @ B5 @ ( F4 @ A5 @ Acc3 ) ) )
             => ( P @ F4 @ A5 @ B5 @ Acc3 ) ) )
       => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_4986_set__encode__insert,axiom,
    ! [A3: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ~ ( member @ nat @ N @ A3 )
       => ( ( nat_set_encode @ ( insert @ nat @ N @ A3 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( nat_set_encode @ A3 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4987_int__of__nat__def,axiom,
    ( code_T6385005292777649522of_nat
    = ( semiring_1_of_nat @ int ) ) ).

% int_of_nat_def
thf(fact_4988_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L4: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L4 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L4 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4989_finite__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% finite_Diff
thf(fact_4990_finite__Diff2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( finite_finite @ A @ A3 ) ) ) ).

% finite_Diff2
thf(fact_4991_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ B6 @ A3 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_4992_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4993_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_4994_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F6: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ F6 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ F6 )
              = ( zero_zero @ A ) )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ F6 )
                 => ( ( F3 @ X3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_4995_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 )
              = ( zero_zero @ A ) )
            = ( ? [X3: B] :
                  ( ( member @ B @ X3 @ A3 )
                  & ( ( F3 @ X3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_4996_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_4997_card_Oinfinite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_4998_finite__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) ) )
      = ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% finite_Diff_insert
thf(fact_4999_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_5000_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( zero_zero @ A ) )
                  @ S2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_5001_prod__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7121269368397514597t_prod @ A @ nat @ F3 @ A3 )
          = ( one_one @ nat ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ( F3 @ X3 )
                = ( one_one @ nat ) ) ) ) ) ) ).

% prod_eq_1_iff
thf(fact_5002_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_5003_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_5004_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F3: nat > A] :
          ( ( finite_finite @ nat @ A3 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_5005_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F3: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_5006_set__encode__inverse,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( nat_set_decode @ ( nat_set_encode @ A3 ) )
        = A3 ) ) ).

% set_encode_inverse
thf(fact_5007_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum.insert
thf(fact_5008_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod.insert
thf(fact_5009_card__0__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( finite_card @ A @ A3 )
          = ( zero_zero @ nat ) )
        = ( A3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_5010_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ~ ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
          = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_insert_disjoint
thf(fact_5011_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F3 @ A3 ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F3 @ X3 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_5012_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) )
                @ A3 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_5013_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) ) @ ( D2 @ I3 ) )
                @ A3 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I3 ) ) @ ( D2 @ I3 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_5014_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K2: code_integer] :
          ( if @ code_integer
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_5015_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = L ) ).

% plus_integer_code(2)
thf(fact_5016_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_5017_finite__set__decode,axiom,
    ! [N: nat] : ( finite_finite @ nat @ ( nat_set_decode @ N ) ) ).

% finite_set_decode
thf(fact_5018_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_5019_Diff__infinite__finite,axiom,
    ! [A: $tType,T5: set @ A,S2: set @ A] :
      ( ( finite_finite @ A @ T5 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) ) ) ) ).

% Diff_infinite_finite
thf(fact_5020_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( uminus_uminus @ code_integer @ L ) ) ).

% minus_integer_code(2)
thf(fact_5021_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_5022_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_5023_finite__less__ub,axiom,
    ! [F3: nat > nat,U: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F3 @ N3 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N2: nat] : ( ord_less_eq @ nat @ ( F3 @ N2 ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_5024_finite__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( finite_finite @ A @ B4 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% finite_subset
thf(fact_5025_infinite__super,axiom,
    ! [A: $tType,S2: set @ A,T5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T5 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ T5 ) ) ) ).

% infinite_super
thf(fact_5026_rev__finite__subset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% rev_finite_subset
thf(fact_5027_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ A3 )
                & ( ord_less_eq @ A @ X4 @ A2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X4 )
                     => ( X4 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_5028_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ A3 )
                & ( ord_less_eq @ A @ A2 @ X4 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ X4 @ Xa2 )
                     => ( X4 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_5029_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N7: set @ nat] :
        ? [M3: nat] :
        ! [X3: nat] :
          ( ( member @ nat @ X3 @ N7 )
         => ( ord_less_eq @ nat @ X3 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_5030_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_5031_set__encode__eq,axiom,
    ! [A3: set @ nat,B4: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( finite_finite @ nat @ B4 )
       => ( ( ( nat_set_encode @ A3 )
            = ( nat_set_encode @ B4 ) )
          = ( A3 = B4 ) ) ) ) ).

% set_encode_eq
thf(fact_5032_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ A3 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X4 )
                     => ( X4 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_5033_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ A3 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A3 )
                   => ( ( ord_less_eq @ A @ X4 @ Xa2 )
                     => ( X4 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_5034_sum__mono__inv,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F3: I6 > A,I5: set @ I6,G: I6 > A,I: I6] :
          ( ( ( groups7311177749621191930dd_sum @ I6 @ A @ F3 @ I5 )
            = ( groups7311177749621191930dd_sum @ I6 @ A @ G @ I5 ) )
         => ( ! [I2: I6] :
                ( ( member @ I6 @ I2 @ I5 )
               => ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( G @ I2 ) ) )
           => ( ( member @ I6 @ I @ I5 )
             => ( ( finite_finite @ I6 @ I5 )
               => ( ( F3 @ I )
                  = ( G @ I ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_5035_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ? [X5: B] :
                ( ( member @ B @ X5 @ A3 )
                & ( ( F3 @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_5036_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N6: set @ nat,F3: nat > A] :
          ( ( finite_finite @ nat @ N6 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N6 )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_finite
thf(fact_5037_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [B9: set @ A] :
          ( ( finite_finite @ A @ B9 )
          & ( ( finite_card @ A @ B9 )
            = N )
          & ( ord_less_eq @ ( set @ A ) @ B9 @ A3 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_5038_card__subset__eq,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ( finite_card @ A @ A3 )
            = ( finite_card @ A @ B4 ) )
         => ( A3 = B4 ) ) ) ) ).

% card_subset_eq
thf(fact_5039_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B4: set @ A,A3: set @ B,R: B > A > $o] :
      ( ( finite_finite @ A @ B4 )
     => ( ! [A5: B] :
            ( ( member @ B @ A5 @ A3 )
           => ? [B10: A] :
                ( ( member @ A @ B10 @ B4 )
                & ( R @ A5 @ B10 ) ) )
       => ( ! [A13: B,A24: B,B5: A] :
              ( ( member @ B @ A13 @ A3 )
             => ( ( member @ B @ A24 @ A3 )
               => ( ( member @ A @ B5 @ B4 )
                 => ( ( R @ A13 @ B5 )
                   => ( ( R @ A24 @ B5 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_5040_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I3: B] :
                  ( ( member @ B @ I3 @ I5 )
                  & ( ( X @ I3 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( Y @ I3 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( plus_plus @ A @ ( X @ I3 ) @ ( Y @ I3 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_5041_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I3: B] :
                  ( ( member @ B @ I3 @ I5 )
                  & ( ( X @ I3 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( Y @ I3 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                    & ( ( times_times @ A @ ( X @ I3 ) @ ( Y @ I3 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_5042_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( P @ X3 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( G @ X3 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_filter
thf(fact_5043_set__encode__inf,axiom,
    ! [A3: set @ nat] :
      ( ~ ( finite_finite @ nat @ A3 )
     => ( ( nat_set_encode @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_5044_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( P @ X3 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( G @ X3 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_filter
thf(fact_5045_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X3 )
                & ( ord_less_eq @ A @ X3 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_5046_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ A3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ X4 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 )
                = ( zero_zero @ A ) )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                   => ( ( F3 @ X3 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_5047_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T2: set @ C,G: C > A,I: C > B,F3: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X4: C] :
                  ( ( member @ C @ X4 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X4 ) ) )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ S )
                   => ? [Xa2: C] :
                        ( ( member @ C @ Xa2 @ T2 )
                        & ( ( I @ Xa2 )
                          = X4 )
                        & ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ Xa2 ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_5048_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: set @ I6,F3: I6 > A,G: I6 > A] :
          ( ( finite_finite @ I6 @ A3 )
         => ( ! [X4: I6] :
                ( ( member @ I6 @ X4 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
           => ( ? [X5: I6] :
                  ( ( member @ I6 @ X5 @ A3 )
                  & ( ord_less @ A @ ( F3 @ X5 ) @ ( G @ X5 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I6 @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ I6 @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_5049_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R2: A > A > $o,S2: set @ B,H: B > A,G: B > A] :
          ( ( R2 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X1: A,Y1: A,X22: A,Y22: A] :
                ( ( ( R2 @ X1 @ X22 )
                  & ( R2 @ Y1 @ Y22 ) )
               => ( R2 @ ( plus_plus @ A @ X1 @ Y1 ) @ ( plus_plus @ A @ X22 @ Y22 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ S2 )
                   => ( R2 @ ( H @ X4 ) @ ( G @ X4 ) ) )
               => ( R2 @ ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_5050_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F3: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X4: B,S5: set @ B] :
                  ( ( finite_finite @ B @ S5 )
                 => ( ! [Y4: B] :
                        ( ( member @ B @ Y4 @ S5 )
                       => ( ord_less_eq @ A @ ( F3 @ Y4 ) @ ( F3 @ X4 ) ) )
                   => ( ( P @ S5 )
                     => ( P @ ( insert @ B @ X4 @ S5 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_5051_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R2: A > A > $o,S2: set @ B,H: B > A,G: B > A] :
          ( ( R2 @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X1: A,Y1: A,X22: A,Y22: A] :
                ( ( ( R2 @ X1 @ X22 )
                  & ( R2 @ Y1 @ Y22 ) )
               => ( R2 @ ( times_times @ A @ X1 @ Y1 ) @ ( times_times @ A @ X22 @ Y22 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ S2 )
                   => ( R2 @ ( H @ X4 ) @ ( G @ X4 ) ) )
               => ( R2 @ ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_5052_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_5053_finite__subset__induct,axiom,
    ! [A: $tType,F6: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F6 )
     => ( ( ord_less_eq @ ( set @ A ) @ F6 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A5: A,F7: set @ A] :
                ( ( finite_finite @ A @ F7 )
               => ( ( member @ A @ A5 @ A3 )
                 => ( ~ ( member @ A @ A5 @ F7 )
                   => ( ( P @ F7 )
                     => ( P @ ( insert @ A @ A5 @ F7 ) ) ) ) ) )
           => ( P @ F6 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_5054_finite__subset__induct_H,axiom,
    ! [A: $tType,F6: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F6 )
     => ( ( ord_less_eq @ ( set @ A ) @ F6 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A5: A,F7: set @ A] :
                ( ( finite_finite @ A @ F7 )
               => ( ( member @ A @ A5 @ A3 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F7 @ A3 )
                   => ( ~ ( member @ A @ A5 @ F7 )
                     => ( ( P @ F7 )
                       => ( P @ ( insert @ A @ A5 @ F7 ) ) ) ) ) ) )
           => ( P @ F6 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_5055_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S6: set @ B,T6: set @ C,S2: set @ B,I: C > B,J: B > C,T5: set @ C,G: B > A,H: C > A] :
          ( ( finite_finite @ B @ S6 )
         => ( ( finite_finite @ C @ T6 )
           => ( ! [A5: B] :
                  ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) )
                 => ( ( I @ ( J @ A5 ) )
                    = A5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) )
                   => ( member @ C @ ( J @ A5 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                     => ( ( J @ ( I @ B5 ) )
                        = B5 ) )
                 => ( ! [B5: C] :
                        ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                       => ( member @ B @ ( I @ B5 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) ) )
                   => ( ! [A5: B] :
                          ( ( member @ B @ A5 @ S6 )
                         => ( ( G @ A5 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B5: C] :
                            ( ( member @ C @ B5 @ T6 )
                           => ( ( H @ B5 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A5: B] :
                              ( ( member @ B @ A5 @ S2 )
                             => ( ( H @ ( J @ A5 ) )
                                = ( G @ A5 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H @ T5 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_5056_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_5057_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A3 ) ) ) ).

% card_eq_0_iff
thf(fact_5058_finite__empty__induct,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A3 )
     => ( ( P @ A3 )
       => ( ! [A5: A,A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( member @ A @ A5 @ A8 )
               => ( ( P @ A8 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% finite_empty_induct
thf(fact_5059_infinite__coinduct,axiom,
    ! [A: $tType,X9: ( set @ A ) > $o,A3: set @ A] :
      ( ( X9 @ A3 )
     => ( ! [A8: set @ A] :
            ( ( X9 @ A8 )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A8 )
                & ( ( X9 @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite @ A @ A3 ) ) ) ).

% infinite_coinduct
thf(fact_5060_infinite__remove,axiom,
    ! [A: $tType,S2: set @ A,A2: A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_remove
thf(fact_5061_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
     => ( finite_finite @ A @ A3 ) ) ).

% card_ge_0_finite
thf(fact_5062_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ B,A3: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ B4 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_5063_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B4: set @ B,A3: set @ B,F3: B > A,G: B > A] :
          ( ( finite_finite @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( ! [A5: B] :
                  ( ( member @ B @ A5 @ A3 )
                 => ( dvd_dvd @ A @ ( F3 @ A5 ) @ ( G @ A5 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_5064_card__insert__if,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( member @ A @ X @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
            = ( finite_card @ A @ A3 ) ) )
        & ( ~ ( member @ A @ X @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
            = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_insert_if
thf(fact_5065_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B3: A,B6: set @ A] :
            ( ( A3
              = ( insert @ A @ B3 @ B6 ) )
            & ~ ( member @ A @ B3 @ B6 )
            & ( ( finite_card @ A @ B6 )
              = K )
            & ( finite_finite @ A @ B6 ) ) ) ) ).

% card_Suc_eq_finite
thf(fact_5066_card__mono,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ).

% card_mono
thf(fact_5067_card__seteq,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B4 ) @ ( finite_card @ A @ A3 ) )
         => ( A3 = B4 ) ) ) ) ).

% card_seteq
thf(fact_5068_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F6: set @ A,C5: nat] :
      ( ! [G3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G3 @ F6 )
         => ( ( finite_finite @ A @ G3 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G3 ) @ C5 ) ) )
     => ( ( finite_finite @ A @ F6 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F6 ) @ C5 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_5069_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S2: set @ A] :
      ( ( ord_less_eq @ nat @ N @ ( finite_card @ A @ S2 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S2 )
           => ( ( ( finite_card @ A @ T7 )
                = N )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_5070_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S6: set @ B,T6: set @ C,S2: set @ B,I: C > B,J: B > C,T5: set @ C,G: B > A,H: C > A] :
          ( ( finite_finite @ B @ S6 )
         => ( ( finite_finite @ C @ T6 )
           => ( ! [A5: B] :
                  ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) )
                 => ( ( I @ ( J @ A5 ) )
                    = A5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) )
                   => ( member @ C @ ( J @ A5 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                     => ( ( J @ ( I @ B5 ) )
                        = B5 ) )
                 => ( ! [B5: C] :
                        ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
                       => ( member @ B @ ( I @ B5 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) ) )
                   => ( ! [A5: B] :
                          ( ( member @ B @ A5 @ S6 )
                         => ( ( G @ A5 )
                            = ( one_one @ A ) ) )
                     => ( ! [B5: C] :
                            ( ( member @ C @ B5 @ T6 )
                           => ( ( H @ B5 )
                              = ( one_one @ A ) ) )
                       => ( ! [A5: B] :
                              ( ( member @ B @ A5 @ S2 )
                             => ( ( H @ ( J @ A5 ) )
                                = ( G @ A5 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                            = ( groups7121269368397514597t_prod @ C @ A @ H @ T5 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_5071_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_5072_card__le__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_5073_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: A > nat] : ( bij_betw @ A @ nat @ H4 @ M7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_5074_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X3: A] :
              ( ( member @ A @ X3 @ A3 )
              & ( ( F3 @ X3 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y6: A] :
                  ( ( member @ A @ Y6 @ A3 )
                 => ( ( X3 != Y6 )
                   => ( ( F3 @ Y6 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_5075_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_5076_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 )
          = ( one_one @ nat ) )
        = ( ? [X3: A] :
              ( ( member @ A @ X3 @ A3 )
              & ( ( F3 @ X3 )
                = ( one_one @ nat ) )
              & ! [Y6: A] :
                  ( ( member @ A @ Y6 @ A3 )
                 => ( ( X3 != Y6 )
                   => ( ( F3 @ Y6 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_5077_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_5078_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F3: B > A,B4: A,I: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S )
                = B4 )
             => ( ( member @ B @ I @ S )
               => ( ord_less_eq @ A @ ( F3 @ I ) @ B4 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_5079_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F3: B > A,I: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ S )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I @ S )
               => ( ( F3 @ I )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_5080_one__integer_Orsp,axiom,
    ( ( one_one @ int )
    = ( one_one @ int ) ) ).

% one_integer.rsp
thf(fact_5081_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) ) ).

% one_natural.rsp
thf(fact_5082_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( G @ X3 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_5083_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( G @ X3 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_5084_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_5085_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N6: set @ nat,F3: nat > A] :
          ( ( finite_finite @ nat @ N6 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N6 )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F3 @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ N6 ) ) ) ) ) ).

% sums_finite
thf(fact_5086_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F3: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( collect @ nat @ P ) ) ) ) ) ).

% sums_If_finite
thf(fact_5087_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F3: nat > A] :
          ( ( finite_finite @ nat @ A3 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F3 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ A3 ) ) ) ) ).

% sums_If_finite_set
thf(fact_5088_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N6: set @ nat,F3: nat > A] :
          ( ( finite_finite @ nat @ N6 )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ N6 )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F3 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ N6 ) ) ) ) ) ).

% suminf_finite
thf(fact_5089_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K2: A] :
                ( ( member @ A @ K2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K2 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_5090_exp__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( real_Vector_banach @ B )
        & ( real_V2822296259951069270ebra_1 @ B ) )
     => ! [I5: set @ A,F3: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( exp @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ I5 ) )
            = ( groups7121269368397514597t_prod @ A @ B
              @ ^ [X3: A] : ( exp @ B @ ( F3 @ X3 ) )
              @ I5 ) ) ) ) ).

% exp_sum
thf(fact_5091_n__subsets,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B6: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B6 @ A3 )
                & ( ( finite_card @ A @ B6 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A3 ) @ K ) ) ) ).

% n_subsets
thf(fact_5092_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N6: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N6 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N6 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_5093_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N6: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N6 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N6 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_5094_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,T5: set @ B,R2: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T5 )
       => ( ! [X4: B] :
              ( ( member @ B @ X4 @ T5 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I3: A] :
                        ( ( member @ A @ I3 @ S2 )
                        & ( R2 @ I3 @ X4 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I3: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J3: B] :
                        ( ( member @ B @ J3 @ T5 )
                        & ( R2 @ I3 @ J3 ) ) ) )
              @ S2 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T5 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_5095_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,I: B,F3: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( member @ B @ I @ I5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ I5 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ I5 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_5096_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ I5 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ I5 ) ) ) ) ) ) ).

% sum_pos
thf(fact_5097_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,I: A,F3: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( member @ A @ I @ I5 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F3 @ I ) )
             => ( ! [I2: A] :
                    ( ( member @ A @ I2 @ I5 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F3 @ I2 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ I5 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_5098_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,F3: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I5 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F3 @ I2 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ I5 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_5099_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H @ B5 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B4 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C5 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_5100_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H @ B5 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ C5 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H @ B4 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_5101_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( G @ X4 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_5102_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( G @ X4 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_5103_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S2: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( H @ X4 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ S2 )
                   => ( ( G @ X4 )
                      = ( H @ X4 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ T5 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_5104_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S2: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( G @ X4 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ S2 )
                   => ( ( G @ X4 )
                      = ( H @ X4 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T5 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_5105_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_5106_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B4: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ B4 ) ) ) ) ) ) ).

% sum_diff
thf(fact_5107_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A3 ) ) ) ).

% card_gt_0_iff
thf(fact_5108_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B4: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B4 )
         => ( P @ B4 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B4 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B4 ) ) ) ) ).

% remove_induct
thf(fact_5109_finite__remove__induct,axiom,
    ! [A: $tType,B4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B4 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B4 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B4 ) ) ) ) ).

% finite_remove_induct
thf(fact_5110_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ! [Y6: A] :
                  ( ( member @ A @ Y6 @ A3 )
                 => ( X3 = Y6 ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_5111_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_5112_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( one_one @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ B4 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ C5 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_5113_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( one_one @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ C5 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H @ B4 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_5114_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( G @ X4 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T5 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_5115_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( G @ X4 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T5 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_5116_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S2: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( H @ X4 )
                    = ( one_one @ A ) ) )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ S2 )
                   => ( ( G @ X4 )
                      = ( H @ X4 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H @ T5 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_5117_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S2: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( G @ X4 )
                    = ( one_one @ A ) ) )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ S2 )
                   => ( ( G @ X4 )
                      = ( H @ X4 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T5 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_5118_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A3: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( finite_card @ A @ A3 ) )
      = ( ? [A4: A,B6: set @ A] :
            ( ( A3
              = ( insert @ A @ A4 @ B6 ) )
            & ~ ( member @ A @ A4 @ B6 )
            & ( ord_less_eq @ nat @ N @ ( finite_card @ A @ B6 ) )
            & ( finite_finite @ A @ B6 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_5119_card__Diff__subset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_5120_finite__induct__select,axiom,
    ! [A: $tType,S2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S2 )
             => ( ( P @ T7 )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ ( minus_minus @ ( set @ A ) @ S2 @ T7 ) )
                    & ( P @ ( insert @ A @ X5 @ T7 ) ) ) ) )
         => ( P @ S2 ) ) ) ) ).

% finite_induct_select
thf(fact_5121_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A3: set @ A,A2: A] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [H4: A > A] : ( bij_betw @ A @ A @ H4 @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw
thf(fact_5122_card__psubset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% card_psubset
thf(fact_5123_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_5124_sum__diff__nat,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ B4 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_5125_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_5126_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z6: A] :
                  ( ( power_power @ A @ Z6 @ N )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_5127_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite_1
thf(fact_5128_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S6: set @ B,T6: set @ C,H: B > C,S2: set @ B,T5: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S6 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( bij_betw @ B @ C @ H @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ S6 )
                   => ( ( G @ ( H @ A5 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ T6 )
                     => ( ( G @ B5 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X3: B] : ( G @ ( H @ X3 ) )
                      @ S2 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T5 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_5129_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S2: A,A3: set @ nat,S6: A,F3: nat > A] :
          ( ( sums @ A @ G @ S2 )
         => ( ( finite_finite @ nat @ A3 )
           => ( ( S6
                = ( plus_plus @ A @ S2
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
                    @ A3 ) ) )
             => ( sums @ A
                @ ^ [N2: nat] : ( if @ A @ ( member @ nat @ N2 @ A3 ) @ ( F3 @ N2 ) @ ( G @ N2 ) )
                @ S6 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_5130_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S6: set @ B,T6: set @ C,H: B > C,S2: set @ B,T5: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S6 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( bij_betw @ B @ C @ H @ ( minus_minus @ ( set @ B ) @ S2 @ S6 ) @ ( minus_minus @ ( set @ C ) @ T5 @ T6 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ S6 )
                   => ( ( G @ ( H @ A5 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ T6 )
                     => ( ( G @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X3: B] : ( G @ ( H @ X3 ) )
                      @ S2 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T5 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_5131_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A3 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ I2 ) )
                  & ( ord_less @ A @ ( F3 @ I2 ) @ ( G @ I2 ) ) ) )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_5132_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B4: set @ B,A3: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( ! [B5: B] :
                  ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ B5 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ B4 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_5133_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
            = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_5134_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_5135_sum__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,A2: B,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ A2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( F3 @ A2 ) ) ) )
            & ( ~ ( member @ B @ A2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) ) ) ) ) ) ).

% sum_diff1
thf(fact_5136_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_5137_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
            = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_5138_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_5139_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_5140_card_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ A3 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_5141_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) )
      = ( ( finite_finite @ A @ A3 )
        & ( member @ A @ X @ A3 ) ) ) ).

% card_Diff1_less_iff
thf(fact_5142_card__Diff2__less,axiom,
    ! [A: $tType,A3: set @ A,X: A,Y: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( member @ A @ Y @ A3 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_5143_card__Diff1__less,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff1_less
thf(fact_5144_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: nat > A,I5: set @ nat] :
          ( ( summable @ A @ F3 )
         => ( ( finite_finite @ nat @ I5 )
           => ( ! [N3: nat] :
                  ( ( member @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F3 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ I5 ) @ ( suminf @ A @ F3 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_5145_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_5146_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_5147_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B4: set @ A,A3: set @ A,B2: A,F3: A > B] :
          ( ( finite_finite @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F3 @ B2 ) )
               => ( ! [X4: A] :
                      ( ( member @ A @ X4 @ B4 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F3 @ X4 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ B4 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_5148_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I: C,A3: set @ C,F3: C > B] :
          ( ( member @ C @ I @ A3 )
         => ( ! [X4: C] :
                ( ( member @ C @ X4 @ ( minus_minus @ ( set @ C ) @ A3 @ ( insert @ C @ I @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F3 @ X4 ) ) )
           => ( ( finite_finite @ C @ A3 )
             => ( ord_less_eq @ B @ ( F3 @ I ) @ ( groups7311177749621191930dd_sum @ C @ B @ F3 @ A3 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_5149_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B4: set @ A,A3: set @ A,F3: A > B] :
          ( ( finite_finite @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( ! [B5: A] :
                  ( ( member @ A @ B5 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F3 @ B5 ) ) )
             => ( ! [A5: A] :
                    ( ( member @ A @ A5 @ A3 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F3 @ A5 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ A @ B @ F3 @ B4 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_5150_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: set @ B,F3: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( divide_divide @ A @ K6 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) ) ) )
         => ( ( finite_finite @ B @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ K6 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_5151_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: set @ B,F3: B > A,A2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( F3 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_5152_ln__prod,axiom,
    ! [A: $tType,I5: set @ A,F3: A > real] :
      ( ( finite_finite @ A @ I5 )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I5 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ I2 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F3 @ I5 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X3: A] : ( ln_ln @ real @ ( F3 @ X3 ) )
            @ I5 ) ) ) ) ).

% ln_prod
thf(fact_5153_even__set__encode__iff,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A3 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) ) ) ) ).

% even_set_encode_iff
thf(fact_5154_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_5155_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X3: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ X3 @ I3 ) )
                    @ ( set_ord_atMost @ nat @ N ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ N )
                & ( ( C2 @ I3 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_5156_Gcd__remove0__nat,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( gcd_Gcd @ nat @ M7 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M7 @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_5157_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_5158_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z6: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                          @ ( set_ord_atMost @ nat @ N ) )
                        = ( zero_zero @ A ) ) ) )
                @ N ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_5159_finite__nat__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S7: set @ nat] :
        ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S7 @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ).

% finite_nat_iff_bounded_le
thf(fact_5160_finite__nat__bounded,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S2 @ ( set_ord_lessThan @ nat @ K3 ) ) ) ).

% finite_nat_bounded
thf(fact_5161_finite__nat__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S7: set @ nat] :
        ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S7 @ ( set_ord_lessThan @ nat @ K2 ) ) ) ) ).

% finite_nat_iff_bounded
thf(fact_5162_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less_eq @ int @ A2 @ I3 )
            & ( ord_less_eq @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_5163_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less @ int @ A2 @ I3 )
            & ( ord_less @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_5164_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less @ int @ A2 @ I3 )
            & ( ord_less_eq @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_5165_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I3: int] :
            ( ( ord_less_eq @ int @ A2 @ I3 )
            & ( ord_less @ int @ I3 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_5166_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_5167_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K2: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K2 ) @ K2 ) ) ) ).

% abs_integer_code
thf(fact_5168_uminus__integer__code_I1_J,axiom,
    ( ( uminus_uminus @ code_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% uminus_integer_code(1)
thf(fact_5169_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_5170_infinite__int__iff__unbounded__le,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M3: int] :
          ? [N2: int] :
            ( ( ord_less_eq @ int @ M3 @ ( abs_abs @ int @ N2 ) )
            & ( member @ int @ N2 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_5171_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_5172_finite__divisors__int,axiom,
    ! [I: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( finite_finite @ int
        @ ( collect @ int
          @ ^ [D4: int] : ( dvd_dvd @ int @ D4 @ I ) ) ) ) ).

% finite_divisors_int
thf(fact_5173_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M3: nat] :
          ? [N2: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N2 )
            & ( member @ nat @ N2 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_5174_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K2: int] :
          ( if @ code_integer @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K2 ) ) )
          @ ( if @ code_integer
            @ ( K2
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_5175_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F6: set @ A,I5: set @ A,F3: A > B,I: A] :
          ( ( finite_finite @ A @ F6 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I3: A] :
                    ( ( member @ A @ I3 @ I5 )
                    & ( ( F3 @ I3 )
                     != ( zero_zero @ B ) ) ) )
              @ F6 )
           => ( ( ( member @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I5 ) @ ( F3 @ I ) ) ) )
              & ( ~ ( member @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I5 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_5176_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit1 @ N ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_5177_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_5178_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,P4: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I5 )
                  & ( ( P4 @ X3 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert @ B @ I @ I5 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I5 ) ) )
            & ( ~ ( member @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert @ B @ I @ I5 ) )
                = ( plus_plus @ A @ ( P4 @ I ) @ ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I5 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_5179_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I5: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I5 )
                  & ( ( G @ X3 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) ) ) ).

% sum.non_neutral'
thf(fact_5180_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_5181_plus__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( plus_plus @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( plus_plus @ int @ Xa @ X ) ) ) ).

% plus_integer.abs_eq
thf(fact_5182_times__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa @ X ) ) ) ).

% times_integer.abs_eq
thf(fact_5183_one__integer__def,axiom,
    ( ( one_one @ code_integer )
    = ( code_integer_of_int @ ( one_one @ int ) ) ) ).

% one_integer_def
thf(fact_5184_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( ord_less_eq @ int @ Xa @ X ) ) ).

% less_eq_integer.abs_eq
thf(fact_5185_minus__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( minus_minus @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( minus_minus @ int @ Xa @ X ) ) ) ).

% minus_integer.abs_eq
thf(fact_5186_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I3: B] : ( plus_plus @ A @ ( G @ I3 ) @ ( H @ I3 ) )
              @ I5 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H @ I5 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_5187_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( G @ X4 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_5188_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( G @ X4 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_5189_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T5: set @ B,H: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( H @ I2 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ S2 )
                 => ( ( G @ X4 )
                    = ( H @ X4 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ T5 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_5190_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T5: set @ B,G: B > A,H: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( G @ X4 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ S2 )
                 => ( ( G @ X4 )
                    = ( H @ X4 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T5 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_5191_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I5 )
                  & ( ( G @ X3 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ I5 )
                    & ( ( H @ X3 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I3: B] : ( plus_plus @ A @ ( G @ I3 ) @ ( H @ I3 ) )
                @ I5 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H @ I5 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_5192_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P2: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I7 )
                      & ( ( P2 @ X3 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P2
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I7 )
                      & ( ( P2 @ X3 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_5193_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_5194_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I5: set @ A,F3: A > B,I: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I3: A] :
                  ( ( member @ A @ I3 @ I5 )
                  & ( ( F3 @ I3 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I5 ) @ ( F3 @ I ) ) ) )
            & ( ~ ( member @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F3 @ I5 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_5195_card__Pow,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A3 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Pow
thf(fact_5196_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: nat > A,V: num,N: nat] :
      ( ( case_nat @ A @ A2 @ F3 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F3 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_5197_card__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A3 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_5198_Pow__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% Pow_iff
thf(fact_5199_PowI,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B4 ) ) ) ).

% PowI
thf(fact_5200_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: nat > A,V: num] :
      ( ( case_nat @ A @ A2 @ F3 @ ( numeral_numeral @ nat @ V ) )
      = ( F3 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_5201_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A6: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B6: set @ A] : ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) ) ) ).

% Pow_def
thf(fact_5202_Pow__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A3 ) @ ( pow2 @ A @ B4 ) ) ) ).

% Pow_mono
thf(fact_5203_PowD,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% PowD
thf(fact_5204_subset__code_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ B4 )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
           => ( member @ A @ X3 @ B4 ) ) ) ) ).

% subset_code(1)
thf(fact_5205_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: A > B,F1: A,F2: nat > A,Nat: nat] :
      ( ( H @ ( case_nat @ A @ F1 @ F2 @ Nat ) )
      = ( case_nat @ B @ ( H @ F1 )
        @ ^ [X3: nat] : ( H @ ( F2 @ X3 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_5206_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F2: nat > A] :
      ( ( case_nat @ A @ F1 @ F2 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_5207_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F2: nat > A,X2: nat] :
      ( ( case_nat @ A @ F1 @ F2 @ ( suc @ X2 ) )
      = ( F2 @ X2 ) ) ).

% old.nat.simps(5)
thf(fact_5208_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_pos_if_in_set
thf(fact_5209_card__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% card_length
thf(fact_5210_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu2: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_5211_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu2: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_5212_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
              & ( ( size_size @ ( list @ A ) @ Xs )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_5213_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_5214_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_5215_max__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ M6 @ N ) )
        @ M ) ) ).

% max_Suc2
thf(fact_5216_max__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ N @ M6 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_5217_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A3 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_5218_diff__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K2: nat] : K2
        @ ( minus_minus @ nat @ M @ N ) ) ) ).

% diff_Suc
thf(fact_5219_min__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ N @ M6 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_5220_min__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ M6 @ N ) )
        @ M ) ) ).

% min_Suc2
thf(fact_5221_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X3: A,F5: nat > A,N2: nat] :
            ( if @ A
            @ ( N2
              = ( zero_zero @ nat ) )
            @ X3
            @ ( F5 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_5222_binomial__def,axiom,
    ( binomial
    = ( ^ [N2: nat,K2: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K5: set @ nat] :
                ( ( member @ ( set @ nat ) @ K5 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
                & ( ( finite_card @ nat @ K5 )
                  = K2 ) ) ) ) ) ) ).

% binomial_def
thf(fact_5223_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A3 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs )
                    = K )
                  & ( distinct @ A @ Xs )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X3: nat] : X3
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_5224_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A3 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs )
                  = K )
                & ( distinct @ A @ Xs )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X3: nat] : X3
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_5225_sum__count__set,axiom,
    ! [A: $tType,Xs2: list @ A,X9: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ X9 )
     => ( ( finite_finite @ A @ X9 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs2 ) @ X9 )
          = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% sum_count_set
thf(fact_5226_count__notin,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( count_list @ A @ Xs2 @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_5227_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs )
                = N )
              & ( distinct @ A @ Xs )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_5228_count__le__length,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs2 @ X ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% count_le_length
thf(fact_5229_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F2: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F2 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F2 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_5230_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F2: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F2 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F2 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_5231_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K2: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S4: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S4 ) )
                @ ( S4
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_5232_divmod__abs__code_I6_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_5233_divmod__abs__code_I5_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ J @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J ) ) ) ).

% divmod_abs_code(5)
thf(fact_5234_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X23: nat] : X23 ) ) ).

% pred_def
thf(fact_5235_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L4: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L4 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ ( code_divmod_abs @ K2 @ L4 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S4: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S4
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L4 @ S4 ) ) )
                @ ( code_divmod_abs @ K2 @ L4 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L4
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K2 @ L4 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S4: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S4
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L4 ) @ S4 ) ) )
                    @ ( code_divmod_abs @ K2 @ L4 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_5236_set__remove1__eq,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( set2 @ A @ ( remove1 @ A @ X @ Xs2 ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_5237_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_5238_of__nat__of__integer,axiom,
    ! [K: code_integer] :
      ( ( semiring_1_of_nat @ code_integer @ ( code_nat_of_integer @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% of_nat_of_integer
thf(fact_5239_set__remove1__subset,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_remove1_subset
thf(fact_5240_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_5241_nat__of__integer__code__post_I2_J,axiom,
    ( ( code_nat_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ nat ) ) ).

% nat_of_integer_code_post(2)
thf(fact_5242_length__remove1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs2 ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs2 ) )
          = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% length_remove1
thf(fact_5243_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L4: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L4 ) @ ( code_nat_of_integer @ L4 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L4 ) @ ( code_nat_of_integer @ L4 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_5244_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L4: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L4
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L4
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K2 )
                  = ( sgn_sgn @ code_integer @ L4 ) )
                @ ( code_divmod_abs @ K2 @ L4 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S4: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S4
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L4 ) @ S4 ) ) )
                  @ ( code_divmod_abs @ K2 @ L4 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5245_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X3: nat,Y6: nat] : ( ord_less_eq @ nat @ Y6 @ X3 )
    @ ^ [X3: nat,Y6: nat] : ( ord_less @ nat @ Y6 @ X3 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5246_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F3: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F3 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ).

% comp_funpow
thf(fact_5247_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F3 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ F3 ) ) ).

% funpow_Suc_right
thf(fact_5248_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F3 )
      = ( comp @ A @ A @ A @ F3 @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ).

% funpow.simps(2)
thf(fact_5249_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F3: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N ) @ F3 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F3 ) @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ).

% funpow_add
thf(fact_5250_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H: B > A,G: C > B,A3: set @ C] :
          ( ( ( H @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X4: B,Y3: B] :
                ( ( H @ ( plus_plus @ B @ X4 @ Y3 ) )
                = ( plus_plus @ A @ ( H @ X4 ) @ ( H @ Y3 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H @ G ) @ A3 )
              = ( H @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A3 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5251_card__UNION,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A3 )
     => ( ! [X4: set @ A] :
            ( ( member @ ( set @ A ) @ X4 @ A3 )
           => ( finite_finite @ A @ X4 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A3 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5252_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X @ Xs2 ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5253_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K2 ) ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L4: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L4 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L4 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_5254_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastAtMost
thf(fact_5255_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastAtMost
thf(fact_5256_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastAtMost
thf(fact_5257_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastAtMost
thf(fact_5258_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_5259_plus__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( plus_plus @ code_integer @ X @ Xa ) )
      = ( plus_plus @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa ) ) ) ).

% plus_integer.rep_eq
thf(fact_5260_times__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X @ Xa ) )
      = ( times_times @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa ) ) ) ).

% times_integer.rep_eq
thf(fact_5261_one__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ int ) ) ).

% one_integer.rep_eq
thf(fact_5262_minus__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( minus_minus @ code_integer @ X @ Xa ) )
      = ( minus_minus @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa ) ) ) ).

% minus_integer.rep_eq
thf(fact_5263_int__of__integer__of__nat,axiom,
    ! [N: nat] :
      ( ( code_int_of_integer @ ( semiring_1_of_nat @ code_integer @ N ) )
      = ( semiring_1_of_nat @ int @ N ) ) ).

% int_of_integer_of_nat
thf(fact_5264_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ ( set @ B ),G: B > A] :
          ( ! [X4: set @ B] :
              ( ( member @ ( set @ B ) @ X4 @ B4 )
             => ( finite_finite @ B @ X4 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B4 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B4 )
                   => ( ( A14 != A25 )
                     => ! [X4: B] :
                          ( ( member @ B @ X4 @ A14 )
                         => ( ( member @ B @ X4 @ A25 )
                           => ( ( G @ X4 )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B4 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ B4 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_5265_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: set @ ( set @ B ),G: B > A] :
          ( ! [X4: set @ B] :
              ( ( member @ ( set @ B ) @ X4 @ B4 )
             => ( finite_finite @ B @ X4 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B4 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B4 )
                   => ( ( A14 != A25 )
                     => ! [X4: B] :
                          ( ( member @ B @ X4 @ A14 )
                         => ( ( member @ B @ X4 @ A25 )
                           => ( ( G @ X4 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B4 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B4 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_5266_card_Ocomp__fun__commute__on,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) ) ).

% card.comp_fun_commute_on
thf(fact_5267_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X9: set @ A] :
          ( ( member @ A @ Z @ X9 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X9 )
               => ( ord_less_eq @ A @ X4 @ Z ) )
           => ( ( complete_Sup_Sup @ A @ X9 )
              = Z ) ) ) ) ).

% cSup_eq_maximum
thf(fact_5268_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X9: set @ A,A2: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ X9 )
             => ( ord_less_eq @ A @ X4 @ A2 ) )
         => ( ! [Y3: A] :
                ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X9 )
                   => ( ord_less_eq @ A @ X5 @ Y3 ) )
               => ( ord_less_eq @ A @ A2 @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ X9 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_5269_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X9: set @ A] :
          ( ( member @ A @ Z @ X9 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X9 )
               => ( ord_less_eq @ A @ Z @ X4 ) )
           => ( ( complete_Inf_Inf @ A @ X9 )
              = Z ) ) ) ) ).

% cInf_eq_minimum
thf(fact_5270_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X9: set @ A,A2: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ X9 )
             => ( ord_less_eq @ A @ A2 @ X4 ) )
         => ( ! [Y3: A] :
                ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X9 )
                   => ( ord_less_eq @ A @ Y3 @ X5 ) )
               => ( ord_less_eq @ A @ Y3 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X9 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_5271_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,A2: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X9 )
               => ( ord_less_eq @ A @ A2 @ X4 ) )
           => ( ! [Y3: A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ X9 )
                     => ( ord_less_eq @ A @ Y3 @ X5 ) )
                 => ( ord_less_eq @ A @ Y3 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X9 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_5272_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,Z: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X9 )
               => ( ord_less_eq @ A @ Z @ X4 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ X9 ) ) ) ) ) ).

% cInf_greatest
thf(fact_5273_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,X: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( member @ A @ X @ X9 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X9 ) @ X ) ) ) ) ).

% cInf_le_finite
thf(fact_5274_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,A2: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X9 )
               => ( ord_less_eq @ A @ X4 @ A2 ) )
           => ( ! [Y3: A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ X9 )
                     => ( ord_less_eq @ A @ X5 @ Y3 ) )
                 => ( ord_less_eq @ A @ A2 @ Y3 ) )
             => ( ( complete_Sup_Sup @ A @ X9 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_5275_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,Z: A] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X9 )
               => ( ord_less_eq @ A @ X4 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X9 ) @ Z ) ) ) ) ).

% cSup_least
thf(fact_5276_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X9: set @ A,X: A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( member @ A @ X @ X9 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X9 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_5277_card__Union__le__sum__card,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ).

% card_Union_le_sum_card
thf(fact_5278_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K2: code_integer,L4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K2 ) @ ( code_int_of_integer @ L4 ) ) ) ) ).

% integer_less_eq_iff
thf(fact_5279_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X3: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X3 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_5280_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_removeAll_less_eq
thf(fact_5281_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X4 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_5282_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X4 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_5283_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
thf(fact_5284_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
thf(fact_5285_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5286_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5287_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
thf(fact_5288_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
thf(fact_5289_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5290_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5291_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5292_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] :
      ( ! [X4: set @ A] :
          ( ( member @ ( set @ A ) @ X4 @ U3 )
         => ( finite_finite @ A @ X4 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_5293_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X4 @ L ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L ) ) @ E ) ) ) ) ).

% cInf_asclose
thf(fact_5294_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X4 @ L ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L ) ) @ E ) ) ) ) ).

% cSup_asclose
thf(fact_5295_finite__subset__Union,axiom,
    ! [A: $tType,A3: set @ A,B11: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ B11 ) )
       => ~ ! [F8: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F8 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F8 @ B11 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ F8 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_5296_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5297_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5298_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5299_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5300_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5301_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5302_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5303_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5304_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5305_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5306_sum_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_int_atMost_int_shift
thf(fact_5307_prod_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_int_atMost_int_shift
thf(fact_5308_sum_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_int_lessThan_int_shift
thf(fact_5309_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5310_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5311_prod_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_int_lessThan_int_shift
thf(fact_5312_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Inf_le_Sup
thf(fact_5313_subset__Pow__Union,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ A3 @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) ) ) ).

% subset_Pow_Union
thf(fact_5314_Inter__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ A] :
      ( ! [X11: set @ A] :
          ( ( member @ ( set @ A ) @ X11 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X11 @ B4 ) )
     => ( ( A3
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B4 ) ) ) ).

% Inter_subset
thf(fact_5315_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_5316_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ V @ U )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5317_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ B2 )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ord_less_eq @ A @ X3 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5318_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Sup_upper
thf(fact_5319_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ( ord_less_eq @ A @ X4 @ Z ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ Z ) ) ) ).

% Sup_least
thf(fact_5320_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ! [A5: A] :
              ( ( member @ A @ A5 @ A3 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ B4 )
                  & ( ord_less_eq @ A @ A5 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_mono
thf(fact_5321_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ! [Y3: A] :
              ( ( member @ A @ Y3 @ A3 )
             => ( ord_less_eq @ A @ Y3 @ X ) )
         => ( ! [Y3: A] :
                ( ! [Z3: A] :
                    ( ( member @ A @ Z3 @ A3 )
                   => ( ord_less_eq @ A @ Z3 @ Y3 ) )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ A3 )
              = X ) ) ) ) ).

% Sup_eqI
thf(fact_5322_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ( ord_less_eq @ A @ Z @ X4 ) )
         => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ).

% Inf_greatest
thf(fact_5323_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A3 ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ord_less_eq @ A @ B2 @ X3 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5324_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ U @ V )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ V ) ) ) ) ).

% Inf_lower2
thf(fact_5325_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X ) ) ) ).

% Inf_lower
thf(fact_5326_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ! [B5: A] :
              ( ( member @ A @ B5 @ B4 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ A3 )
                  & ( ord_less_eq @ A @ X5 @ B5 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ).

% Inf_mono
thf(fact_5327_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ A3 )
             => ( ord_less_eq @ A @ X @ I2 ) )
         => ( ! [Y3: A] :
                ( ! [I4: A] :
                    ( ( member @ A @ I4 @ A3 )
                   => ( ord_less_eq @ A @ Y3 @ I4 ) )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( complete_Inf_Inf @ A @ A3 )
              = X ) ) ) ) ).

% Inf_eqI
thf(fact_5328_Union__least,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C5: set @ A] :
      ( ! [X11: set @ A] :
          ( ( member @ ( set @ A ) @ X11 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X11 @ C5 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ C5 ) ) ).

% Union_least
thf(fact_5329_Union__upper,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B4 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) ) ) ).

% Union_upper
thf(fact_5330_Union__subsetI,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] :
      ( ! [X4: set @ A] :
          ( ( member @ ( set @ A ) @ X4 @ A3 )
         => ? [Y4: set @ A] :
              ( ( member @ ( set @ A ) @ Y4 @ B4 )
              & ( ord_less_eq @ ( set @ A ) @ X4 @ Y4 ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) ) ) ).

% Union_subsetI
thf(fact_5331_Inter__lower,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B4 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B4 ) ) ).

% Inter_lower
thf(fact_5332_Inter__greatest,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C5: set @ A] :
      ( ! [X11: set @ A] :
          ( ( member @ ( set @ A ) @ X11 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ C5 @ X11 ) )
     => ( ord_less_eq @ ( set @ A ) @ C5 @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) ) ) ).

% Inter_greatest
thf(fact_5333_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( ! [Y6: A] :
                ( ( ord_less @ A @ Y6 @ X )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                    & ( ord_less @ A @ Y6 @ X3 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5334_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X )
          = ( ! [Y6: A] :
                ( ( ord_less @ A @ X @ Y6 )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                    & ( ord_less @ A @ X3 @ Y6 ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5335_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A3 )
             => ( ord_less_eq @ A @ U @ V4 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5336_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5337_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A3 )
             => ( ord_less_eq @ A @ V4 @ U ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_5338_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5339_Union__mono,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) ) ) ).

% Union_mono
thf(fact_5340_Inter__anti__mono,axiom,
    ! [A: $tType,B4: set @ ( set @ A ),A3: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B4 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B4 ) ) ) ).

% Inter_anti_mono
thf(fact_5341_card__partition,axiom,
    ! [A: $tType,C5: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C5 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) )
       => ( ! [C4: set @ A] :
              ( ( member @ ( set @ A ) @ C4 @ C5 )
             => ( ( finite_card @ A @ C4 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C5 )
               => ( ( member @ ( set @ A ) @ C22 @ C5 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C5 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5342_inthall,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,N: nat] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
         => ( P @ X4 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( P @ ( nth @ A @ Xs2 @ N ) ) ) ) ).

% inthall
thf(fact_5343_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y6: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y6 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y6 @ U2 ) ) ) )
          @ Xa
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_5344_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% le_inf_iff
thf(fact_5345_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_5346_Int__subset__iff,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C5 @ A3 )
        & ( ord_less_eq @ ( set @ A ) @ C5 @ B4 ) ) ) ).

% Int_subset_iff
thf(fact_5347_Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_disjoint
thf(fact_5348_Diff__Compl,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_Compl
thf(fact_5349_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,F3: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X3 ) ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5350_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X3 ) ) @ ( F3 @ X3 ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5351_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X3: B] : ( zero_neq_one_of_bool @ A @ ( P @ X3 ) )
                @ A3 )
              = ( semiring_1_of_nat @ A @ ( finite_card @ B @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum_of_bool_eq
thf(fact_5352_Union__Int__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) ) ) ).

% Union_Int_subset
thf(fact_5353_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5354_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X4: nat,Y3: nat] :
          ( Z
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X4 @ Y3 ) ) ) ).

% eq_Abs_Integ
thf(fact_5355_int_Oabs__induct,axiom,
    ! [P: int > $o,X: int] :
      ( ! [Y3: product_prod @ nat @ nat] : ( P @ ( abs_Integ @ Y3 ) )
     => ( P @ X ) ) ).

% int.abs_induct
thf(fact_5356_Diff__Int__distrib2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C5 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Diff_Int_distrib2
thf(fact_5357_Diff__Int__distrib,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ C5 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ C5 @ A3 ) @ ( inf_inf @ ( set @ A ) @ C5 @ B4 ) ) ) ).

% Diff_Int_distrib
thf(fact_5358_Diff__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_Diff_Int
thf(fact_5359_Diff__Int2,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C5 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C5 ) @ B4 ) ) ).

% Diff_Int2
thf(fact_5360_Int__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Int_Diff
thf(fact_5361_Int__mono,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A,D3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ D3 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( inf_inf @ ( set @ A ) @ C5 @ D3 ) ) ) ) ).

% Int_mono
thf(fact_5362_Int__lower1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ A3 ) ).

% Int_lower1
thf(fact_5363_Int__lower2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ B4 ) ).

% Int_lower2
thf(fact_5364_Int__absorb1,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = B4 ) ) ).

% Int_absorb1
thf(fact_5365_Int__absorb2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = A3 ) ) ).

% Int_absorb2
thf(fact_5366_Int__greatest,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ C5 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ C5 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% Int_greatest
thf(fact_5367_Int__Collect__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A3 )
           => ( ( P @ X4 )
             => ( Q @ X4 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B4 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_5368_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_5369_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_5370_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_5371_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_5372_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_5373_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_5374_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( inf_inf @ A @ A4 @ B3 ) ) ) ) ) ).

% inf.order_iff
thf(fact_5375_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Z )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) ) ).

% inf_greatest
thf(fact_5376_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_5377_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_5378_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( inf_inf @ A @ X @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_5379_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( inf_inf @ A @ X @ Y )
            = X ) ) ) ).

% inf_absorb1
thf(fact_5380_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_5381_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_5382_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y6: A] :
              ( ( inf_inf @ A @ X3 @ Y6 )
              = X3 ) ) ) ) ).

% le_iff_inf
thf(fact_5383_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F3: A > A > A,X: A,Y: A] :
          ( ! [X4: A,Y3: A] : ( ord_less_eq @ A @ ( F3 @ X4 @ Y3 ) @ X4 )
         => ( ! [X4: A,Y3: A] : ( ord_less_eq @ A @ ( F3 @ X4 @ Y3 ) @ Y3 )
           => ( ! [X4: A,Y3: A,Z5: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y3 )
                 => ( ( ord_less_eq @ A @ X4 @ Z5 )
                   => ( ord_less_eq @ A @ X4 @ ( F3 @ Y3 @ Z5 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y )
                = ( F3 @ X @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_5384_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_5385_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_5386_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_5387_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_5388_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_5389_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_5390_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A2 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_5391_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_5392_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_le1
thf(fact_5393_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_5394_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_5395_diff__eq,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( minus_minus @ A )
        = ( ^ [X3: A,Y6: A] : ( inf_inf @ A @ X3 @ ( uminus_uminus @ A @ Y6 ) ) ) ) ) ).

% diff_eq
thf(fact_5396_Sup__inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B4: set @ A,A2: A] :
          ( ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B4 ) @ A2 )
            = ( bot_bot @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ B4 )
               => ( ( inf_inf @ A @ X3 @ A2 )
                  = ( bot_bot @ A ) ) ) ) ) ) ).

% Sup_inf_eq_bot_iff
thf(fact_5397_Int__Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_Diff_disjoint
thf(fact_5398_Diff__triv,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        = A3 ) ) ).

% Diff_triv
thf(fact_5399_Diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] : ( inf_inf @ ( set @ A ) @ A6 @ ( uminus_uminus @ ( set @ A ) @ B6 ) ) ) ) ).

% Diff_eq
thf(fact_5400_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_5401_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B4 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_5402_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( member @ B @ X3 @ B4 ) @ ( G @ X3 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_restrict
thf(fact_5403_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( member @ B @ X3 @ B4 ) @ ( G @ X3 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_restrict
thf(fact_5404_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5405_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N2: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N2 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5406_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T5: set @ B,S2: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( H @ I2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ S2 @ T5 ) )
                   => ( ( G @ I2 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X4: B] :
                      ( ( member @ B @ X4 @ ( inf_inf @ ( set @ B ) @ S2 @ T5 ) )
                     => ( ( G @ X4 )
                        = ( H @ X4 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H @ T5 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_5407_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5408_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5409_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T5: set @ B,S2: set @ B,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ T5 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
                 => ( ( H @ I2 )
                    = ( one_one @ A ) ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ S2 @ T5 ) )
                   => ( ( G @ I2 )
                      = ( one_one @ A ) ) )
               => ( ! [X4: B] :
                      ( ( member @ B @ X4 @ ( inf_inf @ ( set @ B ) @ S2 @ T5 ) )
                     => ( ( G @ X4 )
                        = ( H @ X4 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                    = ( groups7121269368397514597t_prod @ B @ A @ H @ T5 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_5410_card__Diff__subset__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ).

% card_Diff_subset_Int
thf(fact_5411_nat_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( nat2 @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ X ) ) ).

% nat.abs_eq
thf(fact_5412_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,P: B > $o,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( H @ X3 ) @ ( G @ X3 ) )
              @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5413_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,P: B > $o,H: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( H @ X3 ) @ ( G @ X3 ) )
              @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5414_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X3: nat,Y6: nat] : ( product_Pair @ nat @ nat @ Y6 @ X3 )
          @ X ) ) ) ).

% uminus_int.abs_eq
thf(fact_5415_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5416_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: set @ B,F3: B > A,B2: A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A4: B] : ( divide_divide @ A @ ( F3 @ A4 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A3
                  @ ( collect @ B
                    @ ^ [A4: B] : ( dvd_dvd @ A @ B2 @ ( F3 @ A4 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F3
                  @ ( inf_inf @ ( set @ B ) @ A3
                    @ ( collect @ B
                      @ ^ [A4: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F3 @ A4 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5417_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I3: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J3 ) )
            @ X ) ) ) ).

% of_int.abs_eq
thf(fact_5418_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y6: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) )
        @ Xa
        @ X ) ) ).

% less_int.abs_eq
thf(fact_5419_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y6: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) )
        @ Xa
        @ X ) ) ).

% less_eq_int.abs_eq
thf(fact_5420_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y6: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y6 @ V5 ) ) )
          @ Xa
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_5421_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X3: nat,Y6: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y6 @ U2 ) ) )
          @ Xa
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_5422_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs2: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs2 @ Ys ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_5423_set__update__distinct,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs2 @ N @ X ) )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ ( nth @ A @ Xs2 @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5424_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs2 @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5425_list__update__beyond,axiom,
    ! [A: $tType,Xs2: list @ A,I: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I )
     => ( ( list_update @ A @ Xs2 @ I @ X )
        = Xs2 ) ) ).

% list_update_beyond
thf(fact_5426_length__product,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs2 @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_5427_inf__int__def,axiom,
    ( ( inf_inf @ int )
    = ( ord_min @ int ) ) ).

% inf_int_def
thf(fact_5428_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_5429_set__update__subsetI,axiom,
    ! [A: $tType,Xs2: list @ A,A3: set @ A,X: A,I: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs2 @ I @ X ) ) @ A3 ) ) ) ).

% set_update_subsetI
thf(fact_5430_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_5431_set__update__subset__insert,axiom,
    ! [A: $tType,Xs2: list @ A,I: nat,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs2 @ I @ X ) ) @ ( insert @ A @ X @ ( set2 @ A @ Xs2 ) ) ) ).

% set_update_subset_insert
thf(fact_5432_distinct__list__update,axiom,
    ! [A: $tType,Xs2: list @ A,A2: A,I: nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ ( nth @ A @ Xs2 @ I ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs2 @ I @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_5433_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X3: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y6: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y6 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X3 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5434_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X3: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y6: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y6 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X3 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5435_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( times_times @ A @ A4 ) @ ( F5 @ ( nth @ B @ Xs @ N2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5436_nat_Orep__eq,axiom,
    ( nat2
    = ( ^ [X3: int] : ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ ( rep_Integ @ X3 ) ) ) ) ).

% nat.rep_eq
thf(fact_5437_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X3: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I3: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J3 ) )
              @ ( rep_Integ @ X3 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_5438_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F5 @ ( nth @ B @ Xs @ N2 ) ) @ ( power_power @ A @ A4 @ N2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_5439_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% nth_rotate1
thf(fact_5440_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs2: list @ A,N: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M ) @ ( nth @ A @ Xs2 @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5441_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X3: nat,Y6: nat] : ( product_Pair @ nat @ nat @ Y6 @ X3 ) ) ) ) ).

% uminus_int_def
thf(fact_5442_rotate1__length01,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs2 )
        = Xs2 ) ) ).

% rotate1_length01
thf(fact_5443_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y6: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y6 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y6 @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_5444_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y6: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y6 @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_5445_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X3: nat,Y6: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y6 @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_5446_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y: A,F3: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y @ S2 )
             => ( ord_less_eq @ B @ ( F3 @ ( lattic7623131987881927897min_on @ A @ B @ F3 @ S2 ) ) @ ( F3 @ Y ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5447_length__mul__elem,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N: nat] :
      ( ! [X4: list @ A] :
          ( ( member @ ( list @ A ) @ X4 @ ( set2 @ ( list @ A ) @ Xs2 ) )
         => ( ( size_size @ ( list @ A ) @ X4 )
            = N ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs2 ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) @ N ) ) ) ).

% length_mul_elem
thf(fact_5448_pred__nat__def,axiom,
    ( pred_nat
    = ( collect @ ( product_prod @ nat @ nat )
      @ ( product_case_prod @ nat @ nat @ $o
        @ ^ [M3: nat,N2: nat] :
            ( N2
            = ( suc @ M3 ) ) ) ) ) ).

% pred_nat_def
thf(fact_5449_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs2 ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys2 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys2 ) @ ( set2 @ A @ Xs2 ) ) ) ) ) ).

% set_n_lists
thf(fact_5450_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,P4: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I5 )
                  & ( ( P4 @ X3 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert @ B @ I @ I5 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P4 @ I5 ) ) )
            & ( ~ ( member @ B @ I @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert @ B @ I @ I5 ) )
                = ( times_times @ A @ ( P4 @ I ) @ ( groups1962203154675924110t_prod @ B @ A @ P4 @ I5 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5451_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5452_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_5453_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I5: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I5 )
                  & ( ( G @ X3 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) ) ) ).

% prod.non_neutral'
thf(fact_5454_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I3: B] : ( times_times @ A @ ( G @ I3 ) @ ( H @ I3 ) )
              @ I5 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H @ I5 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5455_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( G @ X4 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T5 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_5456_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T5: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( G @ X4 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T5 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S2 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_5457_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T5: set @ B,H: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( H @ I2 )
                  = ( one_one @ A ) ) )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ S2 )
                 => ( ( G @ X4 )
                    = ( H @ X4 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H @ T5 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_5458_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T5: set @ B,G: B > A,H: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T5 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ ( minus_minus @ ( set @ B ) @ T5 @ S2 ) )
               => ( ( G @ X4 )
                  = ( one_one @ A ) ) )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ S2 )
                 => ( ( G @ X4 )
                    = ( H @ X4 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T5 )
                = ( groups1962203154675924110t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_5459_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X3: B] :
                  ( ( member @ B @ X3 @ I5 )
                  & ( ( G @ X3 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X3: B] :
                    ( ( member @ B @ X3 @ I5 )
                    & ( ( H @ X3 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I3: B] : ( times_times @ A @ ( G @ I3 ) @ ( H @ I3 ) )
                @ I5 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H @ I5 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5460_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P2: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I7 )
                      & ( ( P2 @ X3 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P2
                @ ( collect @ B
                  @ ^ [X3: B] :
                      ( ( member @ B @ X3 @ I7 )
                      & ( ( P2 @ X3 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_5461_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ ( suc @ I ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5462_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X @ A3 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5463_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y )
       => ( ( image @ nat @ nat
            @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y )
       => ( ( ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I3: nat] : ( minus_minus @ nat @ I3 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_5464_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_5465_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N6: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N6 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N6 ) ) ).

% bij_betw_Suc
thf(fact_5466_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S2 )
          = S2 ) ) ).

% image_add_0
thf(fact_5467_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_5468_image__diff__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ D2 @ B2 ) @ ( minus_minus @ A @ D2 @ A2 ) ) ) ) ).

% image_diff_atLeastAtMost
thf(fact_5469_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_5470_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_5471_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X: B,Xs2: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 @ X @ Xs2 ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ).

% length_insort
thf(fact_5472_image__Suc__atLeastAtMost,axiom,
    ! [I: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ I @ J ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( suc @ I ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastAtMost
thf(fact_5473_image__Suc__atLeastLessThan,axiom,
    ! [I: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ I @ J ) )
      = ( set_or7035219750837199246ssThan @ nat @ ( suc @ I ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastLessThan
thf(fact_5474_bij__betw__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N6: set @ nat,A3: set @ A] :
          ( ( bij_betw @ nat @ A @ ( semiring_1_of_nat @ A ) @ N6 @ A3 )
          = ( ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ N6 )
            = A3 ) ) ) ).

% bij_betw_of_nat
thf(fact_5475_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_5476_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( image @ A @ A
            @ ^ [T3: A] : ( minus_minus @ A @ T3 @ D2 )
            @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ).

% image_minus_const_atLeastAtMost'
thf(fact_5477_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_5478_mult__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( times_times @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ C2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ).

% mult_rat
thf(fact_5479_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( divide_divide @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_5480_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_5481_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C3: A] : ( divide_divide @ A @ C3 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_5482_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_5483_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_5484_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_5485_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_5486_sgn__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( sgn_sgn @ rat @ ( fract @ A2 @ B2 ) )
      = ( ring_1_of_int @ rat @ ( times_times @ int @ ( sgn_sgn @ int @ A2 ) @ ( sgn_sgn @ int @ B2 ) ) ) ) ).

% sgn_rat
thf(fact_5487_finite__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: set @ B,F3: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ A @ B @ F3 @ A3 ) )
       => ( finite_finite @ B @ B4 ) ) ) ).

% finite_surj
thf(fact_5488_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,F3: B > A,A3: set @ B] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F3 @ A3 ) )
       => ? [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
            & ( finite_finite @ B @ C7 )
            & ( B4
              = ( image @ B @ A @ F3 @ C7 ) ) ) ) ) ).

% finite_subset_image
thf(fact_5489_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B6: set @ A] :
            ( ( finite_finite @ A @ B6 )
            & ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F3 @ A3 ) )
            & ( P @ B6 ) ) )
      = ( ? [B6: set @ B] :
            ( ( finite_finite @ B @ B6 )
            & ( ord_less_eq @ ( set @ B ) @ B6 @ A3 )
            & ( P @ ( image @ B @ A @ F3 @ B6 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_5490_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B6: set @ A] :
            ( ( ( finite_finite @ A @ B6 )
              & ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F3 @ A3 ) ) )
           => ( P @ B6 ) ) )
      = ( ! [B6: set @ B] :
            ( ( ( finite_finite @ B @ B6 )
              & ( ord_less_eq @ ( set @ B ) @ B6 @ A3 ) )
           => ( P @ ( image @ B @ A @ F3 @ B6 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_5491_zero__notin__Suc__image,axiom,
    ! [A3: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A3 ) ) ).

% zero_notin_Suc_image
thf(fact_5492_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F3: B > A,A3: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F3 @ A3 ) @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F3 ) @ ( pow2 @ B @ A3 ) ) @ ( pow2 @ A @ B4 ) ) ) ).

% image_Pow_mono
thf(fact_5493_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,F3: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F3 @ A3 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A3 )
            & ( B4
              = ( image @ B @ A @ F3 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_5494_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F3 @ A3 ) @ B4 )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A3 )
           => ( member @ A @ ( F3 @ X3 ) @ B4 ) ) ) ) ).

% image_subset_iff
thf(fact_5495_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,F3: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F3 @ A3 ) )
     => ~ ! [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
           => ( B4
             != ( image @ B @ A @ F3 @ C7 ) ) ) ) ).

% subset_imageE
thf(fact_5496_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F3: A > B,B4: set @ B] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A3 )
         => ( member @ B @ ( F3 @ X4 ) @ B4 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B4 ) ) ).

% image_subsetI
thf(fact_5497_image__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,F3: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ ( image @ A @ B @ F3 @ B4 ) ) ) ).

% image_mono
thf(fact_5498_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B6: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F3 @ A3 ) )
           => ( P @ B6 ) ) )
      = ( ! [B6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B6 @ A3 )
           => ( P @ ( image @ B @ A @ F3 @ B6 ) ) ) ) ) ).

% all_subset_image
thf(fact_5499_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F3: A > B,B4: set @ B] :
      ( ! [X4: A] :
          ( ( P @ X4 )
         => ( member @ B @ ( F3 @ X4 ) @ B4 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ ( collect @ A @ P ) ) @ B4 ) ) ).

% image_Collect_subsetI
thf(fact_5500_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] :
      ( ( fract @ ( zero_zero @ int ) @ A2 )
      = ( fract @ ( zero_zero @ int ) @ C2 ) ) ).

% eq_rat(3)
thf(fact_5501_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,G: C > A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B4 )
                  & ( ord_less_eq @ A @ ( G @ X5 ) @ ( F3 @ I2 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B4 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A3 )
                    & ( ord_less_eq @ A @ ( F3 @ X5 ) @ ( G @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ).

% INF_eq
thf(fact_5502_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,F3: B > A,G: C > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B4 )
                  & ( ord_less_eq @ A @ ( F3 @ I2 ) @ ( G @ X5 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B4 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A3 )
                    & ( ord_less_eq @ A @ ( G @ J2 ) @ ( F3 @ X5 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_5503_inf__Sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A2: A,B4: set @ A] :
          ( ( inf_inf @ A @ A2 @ ( complete_Sup_Sup @ A @ B4 ) )
          = ( complete_Sup_Sup @ A @ ( image @ A @ A @ ( inf_inf @ A @ A2 ) @ B4 ) ) ) ) ).

% inf_Sup
thf(fact_5504_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B,B4: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F3 @ A3 ) @ ( image @ B @ A @ F3 @ B4 ) ) ) ).

% image_Int_subset
thf(fact_5505_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B,B4: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F3 @ A3 ) @ ( image @ B @ A @ F3 @ B4 ) ) @ ( image @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ).

% image_diff_subset
thf(fact_5506_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_5507_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q2: rat] :
      ( ! [A5: int,B5: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( P @ ( fract @ A5 @ B5 ) ) )
     => ( P @ Q2 ) ) ).

% Rat_induct_pos
thf(fact_5508_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A2 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_5509_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_5510_Fract__of__nat__eq,axiom,
    ! [K: nat] :
      ( ( fract @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) )
      = ( semiring_1_of_nat @ rat @ K ) ) ).

% Fract_of_nat_eq
thf(fact_5511_rat__number__collapse_I1_J,axiom,
    ! [K: int] :
      ( ( fract @ ( zero_zero @ int ) @ K )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(1)
thf(fact_5512_rat__number__collapse_I6_J,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(6)
thf(fact_5513_One__rat__def,axiom,
    ( ( one_one @ rat )
    = ( fract @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% One_rat_def
thf(fact_5514_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,U: A,F3: B > A] :
          ( ( member @ B @ I @ A3 )
         => ( ( ord_less_eq @ A @ U @ ( F3 @ I ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_5515_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,A3: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ X3 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_5516_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,F3: B > A] :
          ( ( member @ B @ I @ A3 )
         => ( ord_less_eq @ A @ ( F3 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ).

% SUP_upper
thf(fact_5517_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ! [X4: B] : ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% SUP_mono'
thf(fact_5518_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F3: B > A,U: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_5519_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,F3: B > A,G: C > A] :
          ( ! [N3: B] :
              ( ( member @ B @ N3 @ A3 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B4 )
                  & ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( G @ X5 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ).

% SUP_mono
thf(fact_5520_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F3: B > A,X: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ I2 ) @ X ) )
         => ( ! [Y3: A] :
                ( ! [I4: B] :
                    ( ( member @ B @ I4 @ A3 )
                   => ( ord_less_eq @ A @ ( F3 @ I4 ) @ Y3 ) )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) )
              = X ) ) ) ) ).

% SUP_eqI
thf(fact_5521_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,U: A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ U @ ( F3 @ I2 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ).

% INF_greatest
thf(fact_5522_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F3: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
          = ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ U @ ( F3 @ X3 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_5523_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,F3: B > A,U: A] :
          ( ( member @ B @ I @ A3 )
         => ( ( ord_less_eq @ A @ ( F3 @ I ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_5524_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: B > A,G: B > A,A3: set @ B] :
          ( ! [X4: B] : ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% INF_mono'
thf(fact_5525_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A3: set @ B,F3: B > A] :
          ( ( member @ B @ I @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( F3 @ I ) ) ) ) ).

% INF_lower
thf(fact_5526_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ B,A3: set @ C,F3: C > A,G: B > A] :
          ( ! [M2: B] :
              ( ( member @ B @ M2 @ B4 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ A3 )
                  & ( ord_less_eq @ A @ ( F3 @ X5 ) @ ( G @ M2 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ).

% INF_mono
thf(fact_5527_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,X: A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ X @ ( F3 @ I2 ) ) )
         => ( ! [Y3: A] :
                ( ! [I4: B] :
                    ( ( member @ B @ I4 @ A3 )
                   => ( ord_less_eq @ A @ Y3 @ ( F3 @ I4 ) ) )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) )
              = X ) ) ) ) ).

% INF_eqI
thf(fact_5528_Fract__of__int__eq,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( one_one @ int ) )
      = ( ring_1_of_int @ rat @ K ) ) ).

% Fract_of_int_eq
thf(fact_5529_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,B4: set @ B,A2: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ B4 ) ) @ A2 )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [B3: B] : ( inf_inf @ A @ ( F3 @ B3 ) @ A2 )
              @ B4 ) ) ) ) ).

% SUP_inf
thf(fact_5530_Sup__inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B4: set @ A,A2: A] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ B4 ) @ A2 )
          = ( complete_Sup_Sup @ A
            @ ( image @ A @ A
              @ ^ [B3: A] : ( inf_inf @ A @ B3 @ A2 )
              @ B4 ) ) ) ) ).

% Sup_inf
thf(fact_5531_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A2: A,F3: B > A,B4: set @ B] :
          ( ( inf_inf @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ B4 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [B3: B] : ( inf_inf @ A @ A2 @ ( F3 @ B3 ) )
              @ B4 ) ) ) ) ).

% inf_SUP
thf(fact_5532_SUP__inf__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,A3: set @ B,G: C > A,B4: set @ C] :
          ( ( inf_inf @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [A4: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ C @ A
                    @ ^ [B3: C] : ( inf_inf @ A @ ( F3 @ A4 ) @ ( G @ B3 ) )
                    @ B4 ) )
              @ A3 ) ) ) ) ).

% SUP_inf_distrib2
thf(fact_5533_Gcd__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ B,F3: B > A,G: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( dvd_dvd @ A @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
         => ( dvd_dvd @ A @ ( gcd_Gcd @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( gcd_Gcd @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% Gcd_mono
thf(fact_5534_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,F3: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
          = ( ! [Y6: A] :
                ( ( ord_less @ A @ Y6 @ X )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( ord_less @ A @ Y6 @ ( F3 @ X3 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_5535_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F3: B > A,A3: set @ B,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ X )
          = ( ! [Y6: A] :
                ( ( ord_less @ A @ X @ Y6 )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( ord_less @ A @ ( F3 @ X3 ) @ Y6 ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_5536_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,C2: A,F3: B > A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I5 )
               => ( ord_less_eq @ A @ C2 @ ( F3 @ I2 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ I5 ) )
                = C2 )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ I5 )
                   => ( ( F3 @ X3 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_5537_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F3: B > A,M7: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ X4 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_5538_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,F3: B > A,C2: A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I5 )
               => ( ord_less_eq @ A @ ( F3 @ I2 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ I5 ) )
                = C2 )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ I5 )
                   => ( ( F3 @ X3 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_5539_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,M: A,F3: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ A3 )
               => ( ord_less_eq @ A @ M @ ( F3 @ X4 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_5540_card__image__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F3: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F3 @ A3 ) ) @ ( finite_card @ A @ A3 ) ) ) ).

% card_image_le
thf(fact_5541_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_5542_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ B,F3: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_5543_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ B,A3: set @ B,F3: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ B4 )
               => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_5544_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T5: set @ C,G: B > C,H: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T5 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y6: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X3: B] :
                            ( ( member @ B @ X3 @ S2 )
                            & ( ( G @ X3 )
                              = Y6 ) ) ) )
                  @ T5 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% sum.group
thf(fact_5545_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T5: set @ C,G: B > C,H: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T5 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y6: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H
                      @ ( collect @ B
                        @ ^ [X3: B] :
                            ( ( member @ B @ X3 @ S2 )
                            & ( ( G @ X3 )
                              = Y6 ) ) ) )
                  @ T5 )
                = ( groups7121269368397514597t_prod @ B @ A @ H @ S2 ) ) ) ) ) ) ).

% prod.group
thf(fact_5546_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_5547_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K2: num] : ( fract @ ( numeral_numeral @ int @ K2 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_5548_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,H: B > C,G: C > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X4: B,Y3: B] :
                ( ( member @ B @ X4 @ A3 )
               => ( ( member @ B @ Y3 @ A3 )
                 => ( ( X4 != Y3 )
                   => ( ( ( H @ X4 )
                        = ( H @ Y3 ) )
                     => ( ( G @ ( H @ X4 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image @ B @ C @ H @ A3 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H ) @ A3 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_5549_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F3: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_5550_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,H: B > C,G: C > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X4: B,Y3: B] :
                ( ( member @ B @ X4 @ A3 )
               => ( ( member @ B @ Y3 @ A3 )
                 => ( ( X4 != Y3 )
                   => ( ( ( H @ X4 )
                        = ( H @ Y3 ) )
                     => ( ( G @ ( H @ X4 ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image @ B @ C @ H @ A3 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H ) @ A3 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_5551_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B,F3: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ A @ B @ F3 @ A3 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B4 ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% surj_card_le
thf(fact_5552_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_5553_image__Suc__lessThan,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ).

% image_Suc_lessThan
thf(fact_5554_image__Suc__atMost,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N ) ) ) ).

% image_Suc_atMost
thf(fact_5555_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_5556_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_5557_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_5558_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_5559_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_less_Fract_iff
thf(fact_5560_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_5561_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_5562_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_5563_rat__number__collapse_I5_J,axiom,
    ( ( fract @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) )
    = ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ).

% rat_number_collapse(5)
thf(fact_5564_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N ) @ N )
        = ( plus_plus @ rat @ ( fract @ M @ N ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_5565_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I5: set @ C,G: A > B,F3: C > A] :
          ( ( finite_finite @ C @ I5 )
         => ( ! [I2: C] :
                ( ( member @ C @ I2 @ I5 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F3 @ I2 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F3 @ I5 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F3 ) @ I5 ) ) ) ) ) ).

% sum_image_le
thf(fact_5566_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_5567_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_5568_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_5569_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_5570_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_5571_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_5572_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_5573_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ X
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5574_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( times_times @ A @ X3 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5575_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5576_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X3 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5577_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( plus_plus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5578_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X3: A] : ( minus_minus @ A @ ( divide_divide @ A @ X3 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5579_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R2: set @ B,G: A > B,F3: B > C] :
          ( ( finite_finite @ A @ S2 )
         => ( ( finite_finite @ B @ R2 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S2 ) @ R2 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X3: A] : ( F3 @ ( G @ X3 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y6: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X3: A] :
                                ( ( member @ A @ X3 @ S2 )
                                & ( ( G @ X3 )
                                  = Y6 ) ) ) ) )
                      @ ( F3 @ Y6 ) )
                  @ R2 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5580_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A,B4: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 @ B4 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 )
            = B4 ) ) ) ).

% bij_betw_add
thf(fact_5581_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B4: A] :
          ( ( inf_inf @ A @ A3
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X3: nat] : B4
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A3 @ B4 ) ) ) ).

% INF_nat_binary
thf(fact_5582_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F9: A > B,A9: set @ A,A10: set @ B,F3: C > A,A3: set @ C] :
      ( ( bij_betw @ A @ B @ F9 @ A9 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F3 @ A3 ) @ A9 )
       => ( ( bij_betw @ C @ A @ F3 @ A3 @ A9 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F9 @ F3 ) @ A3 @ A10 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_5583_Gcd__abs__eq,axiom,
    ! [K6: set @ int] :
      ( ( gcd_Gcd @ int @ ( image @ int @ int @ ( abs_abs @ int ) @ K6 ) )
      = ( gcd_Gcd @ int @ K6 ) ) ).

% Gcd_abs_eq
thf(fact_5584_Gcd__int__eq,axiom,
    ! [N6: set @ nat] :
      ( ( gcd_Gcd @ int @ ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ N6 ) )
      = ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ N6 ) ) ) ).

% Gcd_int_eq
thf(fact_5585_Gcd__nat__abs__eq,axiom,
    ! [K6: set @ int] :
      ( ( gcd_Gcd @ nat
        @ ( image @ int @ nat
          @ ^ [K2: int] : ( nat2 @ ( abs_abs @ int @ K2 ) )
          @ K6 ) )
      = ( nat2 @ ( gcd_Gcd @ int @ K6 ) ) ) ).

% Gcd_nat_abs_eq
thf(fact_5586_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B4: B > ( set @ A ),A3: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X3: B] : ( pow2 @ A @ ( B4 @ X3 ) )
          @ A3 ) )
      @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B4 @ A3 ) ) ) ) ).

% UN_Pow_subset
thf(fact_5587_finite__int__iff__bounded__le,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S7: set @ int] :
        ? [K2: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S7 ) @ ( set_ord_atMost @ int @ K2 ) ) ) ) ).

% finite_int_iff_bounded_le
thf(fact_5588_finite__int__iff__bounded,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S7: set @ int] :
        ? [K2: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S7 ) @ ( set_ord_lessThan @ int @ K2 ) ) ) ) ).

% finite_int_iff_bounded
thf(fact_5589_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,F3: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ B4 ) ) ) ) ) ).

% UN_mono
thf(fact_5590_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: A > ( set @ B ),C5: set @ B] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ ( B4 @ X4 ) @ C5 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) @ C5 ) ) ).

% UN_least
thf(fact_5591_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B4: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( B4 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) ) ) ).

% UN_upper
thf(fact_5592_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I5: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I5 ) ) @ B4 )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ ( A3 @ X3 ) @ B4 ) ) ) ) ).

% UN_subset_iff
thf(fact_5593_UN__extend__simps_I6_J,axiom,
    ! [L5: $tType,K9: $tType,A3: K9 > ( set @ L5 ),C5: set @ K9,B4: set @ L5] :
      ( ( minus_minus @ ( set @ L5 ) @ ( complete_Sup_Sup @ ( set @ L5 ) @ ( image @ K9 @ ( set @ L5 ) @ A3 @ C5 ) ) @ B4 )
      = ( complete_Sup_Sup @ ( set @ L5 )
        @ ( image @ K9 @ ( set @ L5 )
          @ ^ [X3: K9] : ( minus_minus @ ( set @ L5 ) @ ( A3 @ X3 ) @ B4 )
          @ C5 ) ) ) ).

% UN_extend_simps(6)
thf(fact_5594_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B4: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) @ ( B4 @ A2 ) ) ) ).

% INT_lower
thf(fact_5595_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C5: set @ B,B4: A > ( set @ B )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ C5 @ ( B4 @ X4 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C5 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) ) ) ).

% INT_greatest
thf(fact_5596_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,F3: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F3 @ B4 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ A3 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_5597_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,A3: B > ( set @ A ),I5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I5 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ B4 @ ( A3 @ X3 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_5598_in__image__insert__iff,axiom,
    ! [A: $tType,B4: set @ ( set @ A ),X: A,A3: set @ A] :
      ( ! [C7: set @ A] :
          ( ( member @ ( set @ A ) @ C7 @ B4 )
         => ~ ( member @ A @ X @ C7 ) )
     => ( ( member @ ( set @ A ) @ A3 @ ( image @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X ) @ B4 ) )
        = ( ( member @ A @ X @ A3 )
          & ( member @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) ) ) ).

% in_image_insert_iff
thf(fact_5599_image__int__atLeastAtMost,axiom,
    ! [A2: nat,B2: nat] :
      ( ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
      = ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% image_int_atLeastAtMost
thf(fact_5600_image__int__atLeastLessThan,axiom,
    ! [A2: nat,B2: nat] :
      ( ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) )
      = ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% image_int_atLeastLessThan
thf(fact_5601_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B ),F3: B > C,A9: A > ( set @ C )] :
      ( ! [I2: A,J2: A] :
          ( ( member @ A @ I2 @ I5 )
         => ( ( member @ A @ J2 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I2 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I5 )
           => ( bij_betw @ B @ C @ F3 @ ( A3 @ I2 ) @ ( A9 @ I2 ) ) )
       => ( bij_betw @ B @ C @ F3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I5 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A9 @ I5 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_5602_UN__extend__simps_I7_J,axiom,
    ! [M11: $tType,N10: $tType,A3: set @ M11,B4: N10 > ( set @ M11 ),C5: set @ N10] :
      ( ( minus_minus @ ( set @ M11 ) @ A3 @ ( complete_Inf_Inf @ ( set @ M11 ) @ ( image @ N10 @ ( set @ M11 ) @ B4 @ C5 ) ) )
      = ( complete_Sup_Sup @ ( set @ M11 )
        @ ( image @ N10 @ ( set @ M11 )
          @ ^ [X3: N10] : ( minus_minus @ ( set @ M11 ) @ A3 @ ( B4 @ X3 ) )
          @ C5 ) ) ) ).

% UN_extend_simps(7)
thf(fact_5603_INT__extend__simps_I4_J,axiom,
    ! [G4: $tType,H5: $tType,C5: set @ H5,A3: set @ G4,B4: H5 > ( set @ G4 )] :
      ( ( ( C5
          = ( bot_bot @ ( set @ H5 ) ) )
       => ( ( minus_minus @ ( set @ G4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G4 ) @ ( image @ H5 @ ( set @ G4 ) @ B4 @ C5 ) ) )
          = A3 ) )
      & ( ( C5
         != ( bot_bot @ ( set @ H5 ) ) )
       => ( ( minus_minus @ ( set @ G4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G4 ) @ ( image @ H5 @ ( set @ G4 ) @ B4 @ C5 ) ) )
          = ( complete_Inf_Inf @ ( set @ G4 )
            @ ( image @ H5 @ ( set @ G4 )
              @ ^ [X3: H5] : ( minus_minus @ ( set @ G4 ) @ A3 @ ( B4 @ X3 ) )
              @ C5 ) ) ) ) ) ).

% INT_extend_simps(4)
thf(fact_5604_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I3: nat] : ( M7 @ ( plus_plus @ nat @ I3 @ K ) )
          @ ( set_ord_lessThan @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_5605_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I3: nat] : ( M7 @ ( plus_plus @ nat @ I3 @ K ) )
          @ ( set_ord_atMost @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_5606_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X3: int] : ( plus_plus @ int @ X3 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_5607_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite @ A @ I5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I5 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I3: A] : ( finite_card @ B @ ( A3 @ I3 ) )
          @ I5 ) ) ) ).

% card_UN_le
thf(fact_5608_Gcd__int__def,axiom,
    ( ( gcd_Gcd @ int )
    = ( ^ [K5: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ ( image @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K5 ) ) ) ) ) ).

% Gcd_int_def
thf(fact_5609_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_5610_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_5611_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_5612_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F9: B > A,F3: A > B,A9: set @ B] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A3 )
         => ( ( F9 @ ( F3 @ X4 ) )
            = X4 ) )
     => ( ! [X4: B] :
            ( ( member @ B @ X4 @ A9 )
           => ( ( F3 @ ( F9 @ X4 ) )
              = X4 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ A9 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F9 @ A9 ) @ A3 )
           => ( bij_betw @ A @ B @ F3 @ A3 @ A9 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_5613_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ A,A9: set @ B,B4: set @ A,B12: set @ B] :
      ( ( bij_betw @ A @ B @ F3 @ A3 @ A9 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( ( image @ A @ B @ F3 @ B4 )
            = B12 )
         => ( bij_betw @ A @ B @ F3 @ B4 @ B12 ) ) ) ) ).

% bij_betw_subset
thf(fact_5614_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_5615_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
            @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
              @ S )
            @ ( image @ A @ A
              @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_Int
thf(fact_5616_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
            @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
              @ S )
            @ ( image @ A @ A
              @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_diff
thf(fact_5617_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
            @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_Compl
thf(fact_5618_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S7: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K2: set @ A] :
                  ( ( finite_finite @ A @ K2 )
                  & ( ord_less_eq @ ( set @ A ) @ S7
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X3: A] :
                            ( collect @ A
                            @ ^ [Y6: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y6 ) @ E3 ) )
                        @ K2 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_5619_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F3: B > ( set @ A ),G: C > ( set @ B ),X: C,X9: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ ( G @ X ) ) ) @ X9 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X )
        @ ( collect @ B
          @ ^ [X3: B] : ( ord_less_eq @ ( set @ A ) @ ( F3 @ X3 ) @ X9 ) ) ) ) ).

% UN_image_subset
thf(fact_5620_INF__filter__not__bot,axiom,
    ! [I6: $tType,A: $tType,B4: set @ I6,F6: I6 > ( filter @ A )] :
      ( ! [X11: set @ I6] :
          ( ( ord_less_eq @ ( set @ I6 ) @ X11 @ B4 )
         => ( ( finite_finite @ I6 @ X11 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I6 @ ( filter @ A ) @ F6 @ X11 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I6 @ ( filter @ A ) @ F6 @ B4 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_5621_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,F6: A > ( filter @ B )] :
      ( ! [I2: A] :
          ( ( member @ A @ I2 @ I5 )
         => ! [J2: A] :
              ( ( member @ A @ J2 @ I5 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ I5 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F6 @ X5 ) @ ( inf_inf @ ( filter @ B ) @ ( F6 @ I2 ) @ ( F6 @ J2 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F6 @ I5 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X3: A] :
              ( ( member @ A @ X3 @ I5 )
              & ( ( F6 @ X3 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_5622_Inf__filter__not__bot,axiom,
    ! [A: $tType,B4: set @ ( filter @ A )] :
      ( ! [X11: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X11 @ B4 )
         => ( ( finite_finite @ ( filter @ A ) @ X11 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X11 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B4 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_5623_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T5 @ S2 )
           => ( topolo6688025880775521714ounded @ A @ T5 ) ) ) ) ).

% totally_bounded_subset
thf(fact_5624_conj__subset__def,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3
        @ ( collect @ A
          @ ^ [X3: A] :
              ( ( P @ X3 )
              & ( Q @ X3 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_5625_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F3: nat > ( set @ A ),S2: set @ A] :
      ( ! [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( F3 @ I2 ) @ S2 )
     => ( ( finite_finite @ A @ S2 )
       => ( ? [N8: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N8 )
                 => ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ M2 @ N8 )
                     => ( ( ord_less @ nat @ M2 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F3 @ M2 ) @ ( F3 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ( F3 @ N8 )
                    = ( F3 @ N3 ) ) ) )
         => ( ( F3 @ ( finite_card @ A @ S2 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_5626_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F3: B > A,A3: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F3 @ A3 ) @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F3 ) @ ( finite_Fpow @ B @ A3 ) ) @ ( finite_Fpow @ A @ B4 ) ) ) ).

% image_Fpow_mono
thf(fact_5627_suminf__eq__SUP__real,axiom,
    ! [X9: nat > real] :
      ( ( summable @ real @ X9 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X9 @ I2 ) )
       => ( ( suminf @ real @ X9 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I3: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X9 @ ( set_ord_lessThan @ nat @ I3 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_5628_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_5629_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_5630_range__diff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_diff
thf(fact_5631_Diff__UNIV,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_UNIV
thf(fact_5632_surj__fn,axiom,
    ! [A: $tType,F3: A > A,N: nat] :
      ( ( ( image @ A @ A @ F3 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_5633_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( top_top @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Gcd_UNIV
thf(fact_5634_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A
            @ ^ [X3: A] : ( minus_minus @ A @ X3 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_diff_right
thf(fact_5635_INT__simps_I3_J,axiom,
    ! [E4: $tType,F: $tType,C5: set @ E4,A3: E4 > ( set @ F ),B4: set @ F] :
      ( ( ( C5
          = ( bot_bot @ ( set @ E4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X3: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X3 ) @ B4 )
              @ C5 ) )
          = ( top_top @ ( set @ F ) ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ E4 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X3: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X3 ) @ B4 )
              @ C5 ) )
          = ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C5 ) ) @ B4 ) ) ) ) ).

% INT_simps(3)
thf(fact_5636_INT__simps_I4_J,axiom,
    ! [G4: $tType,H5: $tType,C5: set @ H5,A3: set @ G4,B4: H5 > ( set @ G4 )] :
      ( ( ( C5
          = ( bot_bot @ ( set @ H5 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G4 )
            @ ( image @ H5 @ ( set @ G4 )
              @ ^ [X3: H5] : ( minus_minus @ ( set @ G4 ) @ A3 @ ( B4 @ X3 ) )
              @ C5 ) )
          = ( top_top @ ( set @ G4 ) ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ H5 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G4 )
            @ ( image @ H5 @ ( set @ G4 )
              @ ^ [X3: H5] : ( minus_minus @ ( set @ G4 ) @ A3 @ ( B4 @ X3 ) )
              @ C5 ) )
          = ( minus_minus @ ( set @ G4 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G4 ) @ ( image @ H5 @ ( set @ G4 ) @ B4 @ C5 ) ) ) ) ) ) ).

% INT_simps(4)
thf(fact_5637_SUP__INF,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [P: C > B > A] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [Y6: B] :
                  ( complete_Inf_Inf @ A
                  @ ( image @ C @ A
                    @ ^ [X3: C] : ( P @ X3 @ Y6 )
                    @ ( top_top @ ( set @ C ) ) ) )
              @ ( top_top @ ( set @ B ) ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ ( B > C ) @ A
              @ ^ [X3: B > C] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ B @ A
                    @ ^ [Y6: B] : ( P @ ( X3 @ Y6 ) @ Y6 )
                    @ ( top_top @ ( set @ B ) ) ) )
              @ ( top_top @ ( set @ ( B > C ) ) ) ) ) ) ) ).

% SUP_INF
thf(fact_5638_INF__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [P: C > B > A] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [Y6: B] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ C @ A
                    @ ^ [X3: C] : ( P @ X3 @ Y6 )
                    @ ( top_top @ ( set @ C ) ) ) )
              @ ( top_top @ ( set @ B ) ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ ( B > C ) @ A
              @ ^ [F5: B > C] :
                  ( complete_Inf_Inf @ A
                  @ ( image @ B @ A
                    @ ^ [X3: B] : ( P @ ( F5 @ X3 ) @ X3 )
                    @ ( top_top @ ( set @ B ) ) ) )
              @ ( top_top @ ( set @ ( B > C ) ) ) ) ) ) ) ).

% INF_SUP
thf(fact_5639_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F10: filter @ A,F11: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F10 @ F11 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F11 @ F10 ) ) ) ) ).

% less_filter_def
thf(fact_5640_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_5641_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_5642_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_5643_subset__UNIV,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_5644_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_5645_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F3: B > A,B4: set @ A,I: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) @ B4 )
     => ( member @ A @ ( F3 @ I ) @ B4 ) ) ).

% range_subsetD
thf(fact_5646_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) ) ) ).

% not_UNIV_le_Icc
thf(fact_5647_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H ) ) ) ).

% not_UNIV_le_Iic
thf(fact_5648_Compl__eq__Diff__UNIV,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) ) ) ).

% Compl_eq_Diff_UNIV
thf(fact_5649_bij__fn,axiom,
    ! [A: $tType,F3: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F3 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_5650_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F3: B > A,A3: set @ B] :
      ( ( ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F3 @ A3 ) ) @ ( image @ B @ A @ F3 @ ( uminus_uminus @ ( set @ B ) @ A3 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_5651_Nats__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Nats_def
thf(fact_5652_Fpow__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) @ ( finite_Fpow @ A @ B4 ) ) ) ).

% Fpow_mono
thf(fact_5653_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_5654_Fpow__subset__Pow,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) @ ( pow2 @ A @ A3 ) ) ).

% Fpow_subset_Pow
thf(fact_5655_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A6: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X8 @ A6 )
                & ( finite_finite @ A @ X8 ) ) ) ) ) ).

% Fpow_def
thf(fact_5656_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_5657_INT__extend__simps_I3_J,axiom,
    ! [F: $tType,E4: $tType,C5: set @ E4,A3: E4 > ( set @ F ),B4: set @ F] :
      ( ( ( C5
          = ( bot_bot @ ( set @ E4 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C5 ) ) @ B4 )
          = ( minus_minus @ ( set @ F ) @ ( top_top @ ( set @ F ) ) @ B4 ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ E4 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E4 @ ( set @ F ) @ A3 @ C5 ) ) @ B4 )
          = ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E4 @ ( set @ F )
              @ ^ [X3: E4] : ( minus_minus @ ( set @ F ) @ ( A3 @ X3 ) @ B4 )
              @ C5 ) ) ) ) ) ).

% INT_extend_simps(3)
thf(fact_5658_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N2: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_5659_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F3: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_5660_UN__finite__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),C5: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ C5 ) ) ).

% UN_finite_subset
thf(fact_5661_UN__finite2__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B4: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_5662_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image @ nat @ nat
          @ ^ [M3: nat] : ( modulo_modulo @ nat @ M3 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_5663_UN__finite2__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B4: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_5664_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_5665_cclfp__def,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ( ( order_532582986084564980_cclfp @ A )
        = ( ^ [F5: A > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [I3: nat] : ( compow @ ( A > A ) @ I3 @ F5 @ ( bot_bot @ A ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% cclfp_def
thf(fact_5666_measure__function__int,axiom,
    fun_is_measure @ int @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) ).

% measure_function_int
thf(fact_5667_card__UNIV__unit,axiom,
    ( ( finite_card @ product_unit @ ( top_top @ ( set @ product_unit ) ) )
    = ( one_one @ nat ) ) ).

% card_UNIV_unit
thf(fact_5668_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_5669_range__abs__Nats,axiom,
    ( ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) )
    = ( semiring_1_Nats @ int ) ) ).

% range_abs_Nats
thf(fact_5670_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_5671_infinite__UNIV__int,axiom,
    ~ ( finite_finite @ int @ ( top_top @ ( set @ int ) ) ) ).

% infinite_UNIV_int
thf(fact_5672_bij__prod__encode,axiom,
    bij_betw @ ( product_prod @ nat @ nat ) @ nat @ nat_prod_encode @ ( top_top @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( top_top @ ( set @ nat ) ) ).

% bij_prod_encode
thf(fact_5673_surj__prod__encode,axiom,
    ( ( image @ ( product_prod @ nat @ nat ) @ nat @ nat_prod_encode @ ( top_top @ ( set @ ( product_prod @ nat @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% surj_prod_encode
thf(fact_5674_Ints__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_Ints @ A )
        = ( image @ int @ A @ ( ring_1_of_int @ A ) @ ( top_top @ ( set @ int ) ) ) ) ) ).

% Ints_def
thf(fact_5675_int__in__range__abs,axiom,
    ! [N: nat] : ( member @ int @ ( semiring_1_of_nat @ int @ N ) @ ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) ) ) ).

% int_in_range_abs
thf(fact_5676_root__def,axiom,
    ( root
    = ( ^ [N2: nat,X3: real] :
          ( if @ real
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y6: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y6 ) @ ( power_power @ real @ ( abs_abs @ real @ Y6 ) @ N2 ) )
            @ X3 ) ) ) ) ).

% root_def
thf(fact_5677_DERIV__real__root__generic,axiom,
    ! [N: nat,X: real,D3: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( D3
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
             => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
               => ( D3
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
               => ( D3
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N ) @ D3 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_5678_DERIV__even__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
       => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_5679_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Y: A,Z: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S2 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X3: A] : ( F3 @ ( plus_plus @ A @ Z @ X3 ) )
            @ Y
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_5680_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,G: A > A,X: A,S: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( image @ A @ A @ G @ S ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F3 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_5681_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Y: A,Z: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S2 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F3 @ ( plus_plus @ A @ Z ) ) @ Y @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_5682_MVT2,axiom,
    ! [A2: real,B2: real,F3: real > real,F9: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ord_less_eq @ real @ A2 @ X4 )
           => ( ( ord_less_eq @ real @ X4 @ B2 )
             => ( has_field_derivative @ real @ F3 @ ( F9 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z5: real] :
            ( ( ord_less @ real @ A2 @ Z5 )
            & ( ord_less @ real @ Z5 @ B2 )
            & ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F9 @ Z5 ) ) ) ) ) ) ).

% MVT2
thf(fact_5683_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ord_less_eq @ real @ A2 @ X4 )
           => ( ( ord_less_eq @ real @ X4 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_5684_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ord_less_eq @ real @ A2 @ X4 )
           => ( ( ord_less_eq @ real @ X4 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less @ real @ ( F3 @ A2 ) @ ( F3 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_5685_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ord_less_eq @ real @ A2 @ X4 )
           => ( ( ord_less_eq @ real @ X4 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ord_less_eq @ real @ ( F3 @ A2 ) @ ( F3 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_5686_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ord_less_eq @ real @ A2 @ X4 )
           => ( ( ord_less_eq @ real @ X4 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_5687_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G5: real > real] :
      ( ! [X4: real] :
          ( ( member @ real @ X4 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G5 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X4: real] :
            ( ( member @ real @ X4 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G5 @ X4 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_5688_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F3 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain
thf(fact_5689_DERIV__pos__inc__right,axiom,
    ! [F3: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D6 )
                 => ( ord_less @ real @ ( F3 @ X ) @ ( F3 @ ( plus_plus @ real @ X @ H6 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_5690_DERIV__neg__dec__right,axiom,
    ! [F3: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D6 )
                 => ( ord_less @ real @ ( F3 @ ( plus_plus @ real @ X @ H6 ) ) @ ( F3 @ X ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_5691_DERIV__neg__dec__left,axiom,
    ! [F3: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D6 )
                 => ( ord_less @ real @ ( F3 @ X ) @ ( F3 @ ( minus_minus @ real @ X @ H6 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_5692_DERIV__pos__inc__left,axiom,
    ! [F3: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D6 )
                 => ( ord_less @ real @ ( F3 @ ( minus_minus @ real @ X @ H6 ) ) @ ( F3 @ X ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_5693_DERIV__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_5694_DERIV__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( has_field_derivative @ A @ ( cos @ A ) @ ( uminus_uminus @ A @ ( sin @ A @ X ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos
thf(fact_5695_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X: real,Y: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X4: real] :
                ( ( member @ real @ X4 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F3 @ X )
              = ( F3 @ Y ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_5696_DERIV__isconst__all,axiom,
    ! [F3: real > real,X: real,Y: real] :
      ( ! [X4: real] : ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F3 @ X )
        = ( F3 @ Y ) ) ) ).

% DERIV_isconst_all
thf(fact_5697_DERIV__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( has_field_derivative @ A @ ( exp @ A ) @ ( exp @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_exp
thf(fact_5698_DERIV__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( has_field_derivative @ A @ ( sin @ A ) @ ( cos @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_sin
thf(fact_5699_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Y: A,X: A,Z: A] :
          ( ( has_field_derivative @ A @ F3 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X @ Z ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X3: A] : ( F3 @ ( plus_plus @ A @ X3 @ Z ) )
            @ Y
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_5700_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( sin @ A @ ( G @ X3 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_5701_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S: set @ A,G: A > A,G5: A > A,F3: A > A,F9: A,X: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ S )
             => ( has_field_derivative @ A @ G @ ( G5 @ X4 ) @ ( topolo174197925503356063within @ A @ X4 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F3 @ X ) @ S )
             => ( has_field_derivative @ A
                @ ^ [X3: A] : ( G @ ( F3 @ X3 ) )
                @ ( times_times @ A @ F9 @ ( G5 @ ( F3 @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_5702_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G5: A > A,F3: A > A,F9: A,X: A] :
          ( ! [X4: A] : ( has_field_derivative @ A @ G @ ( G5 @ X4 ) @ ( topolo174197925503356063within @ A @ X4 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( G @ ( F3 @ X3 ) )
              @ ( times_times @ A @ F9 @ ( G5 @ ( F3 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_5703_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( F3 @ ( G @ X3 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain2
thf(fact_5704_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ ( F3 @ X ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( G @ ( F3 @ X3 ) )
              @ ( times_times @ A @ E5 @ D3 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain'
thf(fact_5705_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( exp @ A @ ( G @ X3 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_5706_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F3: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X4: real] : ( has_field_derivative @ real @ F3 @ K @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) @ ( minus_minus @ real @ B2 @ A2 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_5707_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F3: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X4: real] : ( has_field_derivative @ real @ F3 @ K @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_5708_DERIV__local__const,axiom,
    ! [F3: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D2 )
             => ( ( F3 @ X )
                = ( F3 @ Y3 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_5709_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,A2: A,S2: set @ A,D2: real,G: A > A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ A2 @ S2 )
             => ( ! [X4: A] :
                    ( ( member @ A @ X4 @ S2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A2 ) @ D2 )
                     => ( ( F3 @ X4 )
                        = ( G @ X4 ) ) ) )
               => ( has_field_derivative @ A @ G @ F9 @ ( topolo174197925503356063within @ A @ A2 @ S2 ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_5710_has__real__derivative__pos__inc__left,axiom,
    ! [F3: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D6 )
                   => ( ord_less @ real @ ( F3 @ ( minus_minus @ real @ X @ H6 ) ) @ ( F3 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_5711_has__real__derivative__neg__dec__left,axiom,
    ! [F3: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D6 )
                   => ( ord_less @ real @ ( F3 @ X ) @ ( F3 @ ( minus_minus @ real @ X @ H6 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_5712_has__real__derivative__pos__inc__right,axiom,
    ! [F3: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D6 )
                   => ( ord_less @ real @ ( F3 @ X ) @ ( F3 @ ( plus_plus @ real @ X @ H6 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_5713_has__real__derivative__neg__dec__right,axiom,
    ! [F3: real > real,L: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D6 )
                   => ( ord_less @ real @ ( F3 @ ( plus_plus @ real @ X @ H6 ) ) @ ( F3 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_5714_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F3 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( inverse_inverse @ A @ ( F3 @ X3 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F3 @ X ) ) @ D3 ) @ ( inverse_inverse @ A @ ( F3 @ X ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_5715_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F6: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X3: A] : K
          @ ( zero_zero @ A )
          @ F6 ) ) ).

% DERIV_const
thf(fact_5716_has__field__derivative__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,F6: filter @ A,C2: real] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ F6 )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ C2 @ ( F3 @ X3 ) )
            @ ( real_V8093663219630862766scaleR @ A @ C2 @ D3 )
            @ F6 ) ) ) ).

% has_field_derivative_scaleR_right
thf(fact_5717_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( plus_plus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( plus_plus @ A @ D3 @ E5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_add
thf(fact_5718_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,F6: filter @ A,G: A > A,G5: A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ F6 )
         => ( ( has_field_derivative @ A @ G @ G5 @ F6 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] : ( plus_plus @ A @ ( F3 @ Z6 ) @ ( G @ Z6 ) )
              @ ( plus_plus @ A @ F9 @ G5 )
              @ F6 ) ) ) ) ).

% field_differentiable_add
thf(fact_5719_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F3 @ X ) @ E5 ) @ ( times_times @ A @ D3 @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult'
thf(fact_5720_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Da: A,X: A,S: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F3 @ Da @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X ) ) @ ( times_times @ A @ Db @ ( F3 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult
thf(fact_5721_DERIV__ident,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F6: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X3: A] : X3
          @ ( one_one @ A )
          @ F6 ) ) ).

% DERIV_ident
thf(fact_5722_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X: A,S: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ).

% DERIV_cmult_Id
thf(fact_5723_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( times_times @ A @ ( F3 @ X3 ) @ C2 )
            @ ( times_times @ A @ D3 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult_right
thf(fact_5724_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( times_times @ A @ C2 @ ( F3 @ X3 ) )
            @ ( times_times @ A @ C2 @ D3 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult
thf(fact_5725_has__field__derivative__sinh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X3: A11] : ( sinh @ A11 @ ( G @ X3 ) )
            @ ( times_times @ A11 @ ( cosh @ A11 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_5726_has__field__derivative__cosh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X3: A11] : ( cosh @ A11 @ ( G @ X3 ) )
            @ ( times_times @ A11 @ ( sinh @ A11 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_5727_field__differentiable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,F6: filter @ A,G: A > A,G5: A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ F6 )
         => ( ( has_field_derivative @ A @ G @ G5 @ F6 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] : ( minus_minus @ A @ ( F3 @ Z6 ) @ ( G @ Z6 ) )
              @ ( minus_minus @ A @ F9 @ G5 )
              @ F6 ) ) ) ) ).

% field_differentiable_diff
thf(fact_5728_DERIV__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( minus_minus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( minus_minus @ A @ D3 @ E5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_diff
thf(fact_5729_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X3: A] : ( divide_divide @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D3 @ ( G @ X ) ) @ ( times_times @ A @ ( F3 @ X ) @ E5 ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_5730_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,F9: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_5731_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Y: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ Y @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F3 @ Y @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_5732_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,X: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X @ S ) @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ).

% at_le
thf(fact_5733_DERIV__local__min,axiom,
    ! [F3: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F3 @ X ) @ ( F3 @ Y3 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_5734_DERIV__local__max,axiom,
    ! [F3: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F3 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y3: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F3 @ Y3 ) @ ( F3 @ X ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_5735_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_5736_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( cos @ A @ ( G @ X3 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_5737_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa: A] :
          ( has_field_derivative @ A
          @ ^ [X3: A] : ( cos @ A @ ( plus_plus @ A @ X3 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_5738_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X: real,N: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X3: real] : ( power_power @ real @ ( G @ X3 ) @ N )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( G @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_5739_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( power_power @ A @ ( F3 @ X3 ) @ ( suc @ N ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) @ ( times_times @ A @ D3 @ ( power_power @ A @ ( F3 @ X ) @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_5740_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_5741_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] : ( power_power @ A @ ( F3 @ X3 ) @ N )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( times_times @ A @ D3 @ ( power_power @ A @ ( F3 @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power
thf(fact_5742_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D2: A,X: A,S: set @ A,N: int] :
          ( ( has_field_derivative @ A @ F3 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F3 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( power_int @ A @ ( F3 @ X3 ) @ N )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F3 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_power_int
thf(fact_5743_DERIV__pow,axiom,
    ! [N: nat,X: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X3: real] : ( power_power @ real @ X3 @ N )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X @ S ) ) ).

% DERIV_pow
thf(fact_5744_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y3: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y3 @ N2 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X3: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_5745_has__real__derivative__powr,axiom,
    ! [Z: real,R: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z )
     => ( has_field_derivative @ real
        @ ^ [Z6: real] : ( powr @ real @ Z6 @ R )
        @ ( times_times @ real @ R @ ( powr @ real @ Z @ ( minus_minus @ real @ R @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_5746_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D2: A,X: A,S: set @ A,G: A > A,E: A] :
          ( ( has_field_derivative @ A @ F3 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y6: A] : ( divide_divide @ A @ ( F3 @ Y6 ) @ ( G @ Y6 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X ) ) @ ( times_times @ A @ E @ ( F3 @ X ) ) ) @ ( power_power @ A @ ( G @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_5747_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D2: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F3 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] : ( inverse_inverse @ A @ ( F3 @ X3 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F3 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_5748_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K6: real,C2: nat > A,F3: A > A,F9: A,Z: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z5 ) @ K6 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z5 @ N2 ) )
                @ ( F3 @ Z5 ) ) )
         => ( ( has_field_derivative @ A @ F3 @ F9 @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K6 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) )
                @ F9 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_5749_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_5750_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X: real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( has_field_derivative @ real
          @ ^ [X3: real] : ( powr @ real @ ( G @ X3 ) @ R )
          @ ( times_times @ real @ ( times_times @ real @ R @ ( powr @ real @ ( G @ X ) @ ( minus_minus @ real @ R @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_5751_DERIV__powr,axiom,
    ! [G: real > real,M: real,X: real,F3: real > real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( ( has_field_derivative @ real @ F3 @ R @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X3: real] : ( powr @ real @ ( G @ X3 ) @ ( F3 @ X3 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F3 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ R @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F3 @ X ) ) @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_5752_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_5753_DERIV__series_H,axiom,
    ! [F3: real > nat > real,F9: real > nat > real,X0: real,A2: real,B2: real,L6: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X3: real] : ( F3 @ X3 @ N3 )
          @ ( F9 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X4: real] :
            ( ( member @ real @ X4 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F3 @ X4 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F9 @ X0 ) )
           => ( ( summable @ real @ L6 )
             => ( ! [N3: nat,X4: real,Y3: real] :
                    ( ( member @ real @ X4 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F3 @ X4 @ N3 ) @ ( F3 @ Y3 @ N3 ) ) ) @ ( times_times @ real @ ( L6 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X4 @ Y3 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X3: real] : ( suminf @ real @ ( F3 @ X3 ) )
                  @ ( suminf @ real @ ( F9 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_5754_DERIV__arctan,axiom,
    ! [X: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_5755_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K6 @ N2 ) ) )
         => ( ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ K6 @ N2 ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K6 @ N2 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
               => ( has_field_derivative @ A
                  @ ^ [X3: A] :
                      ( suminf @ A
                      @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
                  @ ( suminf @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_5756_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K6 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( has_field_derivative @ A
              @ ^ [X3: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_5757_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K6: real,C2: nat > A,Z: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z5 ) @ K6 )
             => ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z5 @ N2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K6 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z6 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_5758_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_5759_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D3: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( D3
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
           => ( D3
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D3 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_5760_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_5761_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_5762_has__field__derivative__tanh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G: A11 > A11,X: A11,Db: A11,S: set @ A11] :
          ( ( ( cosh @ A11 @ ( G @ X ) )
           != ( zero_zero @ A11 ) )
         => ( ( has_field_derivative @ A11 @ G @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
           => ( has_field_derivative @ A11
              @ ^ [X3: A11] : ( tanh @ A11 @ ( G @ X3 ) )
              @ ( times_times @ A11 @ ( minus_minus @ A11 @ ( one_one @ A11 ) @ ( power_power @ A11 @ ( tanh @ A11 @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_5763_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_5764_artanh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_5765_DERIV__power__series_H,axiom,
    ! [R2: real,F3: nat > real,X0: real] :
      ( ! [X4: real] :
          ( ( member @ real @ X4 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R2 ) @ R2 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F3 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X4 @ N2 ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R2 ) @ R2 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( has_field_derivative @ real
            @ ^ [X3: real] :
                ( suminf @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( F3 @ N2 ) @ ( power_power @ real @ X3 @ ( suc @ N2 ) ) ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F3 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X0 @ N2 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_5766_DERIV__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_5767_DERIV__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_5768_DERIV__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_5769_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F3: real > real,X: real,N: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
        & ! [M2: nat,X4: real] : ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
          & ( ( F3 @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_5770_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F3: real > real,X: real,N: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F3 )
     => ( ! [M2: nat,X4: real] : ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F3 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_5771_DERIV__odd__real__root,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_5772_Maclaurin__minus,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F3: real > real] :
      ( ( ord_less @ real @ H @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F3 )
         => ( ! [M2: nat,T4: real] :
                ( ( ( ord_less @ nat @ M2 @ N )
                  & ( ord_less_eq @ real @ H @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F3 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_5773_Maclaurin2,axiom,
    ! [H: real,Diff: nat > real > real,F3: real > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( ( ord_less @ nat @ M2 @ N )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H ) )
             => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H )
              & ( ( F3 @ H )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
                    @ ( set_ord_lessThan @ nat @ N ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_5774_Maclaurin,axiom,
    ! [H: real,N: nat,Diff: nat > real > real,F3: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F3 )
         => ( ! [M2: nat,T4: real] :
                ( ( ( ord_less @ nat @ M2 @ N )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H ) )
               => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H )
                & ( ( F3 @ H )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_5775_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F3: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( X
           != ( zero_zero @ real ) )
         => ( ! [M2: nat,X4: real] : ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
                & ( ( F3 @ X )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_5776_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F3: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F3 )
     => ( ! [M2: nat,T4: real] :
            ( ( ( ord_less @ nat @ M2 @ N )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F3 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_5777_Taylor,axiom,
    ! [N: nat,Diff: nat > real > real,F3: real > real,A2: real,B2: real,C2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( ( ord_less @ nat @ M2 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X )
               => ( ( ord_less_eq @ real @ X @ B2 )
                 => ( ( X != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ X @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X ) ) )
                        & ( ( F3 @ X )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ M3 ) )
                              @ ( set_ord_lessThan @ nat @ N ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_5778_Taylor__up,axiom,
    ! [N: nat,Diff: nat > real > real,F3: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( ( ord_less @ nat @ M2 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F3 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_5779_Taylor__down,axiom,
    ! [N: nat,Diff: nat > real > real,F3: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( ( ord_less @ nat @ M2 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A2 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F3 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_5780_Maclaurin__lemma2,axiom,
    ! [N: nat,H: real,Diff: nat > real > real,K: nat,B4: real] :
      ( ! [M2: nat,T4: real] :
          ( ( ( ord_less @ nat @ M2 @ N )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H ) )
         => ( has_field_derivative @ real @ ( Diff @ M2 ) @ ( Diff @ ( suc @ M2 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N
          = ( suc @ K ) )
       => ! [M4: nat,T8: real] :
            ( ( ( ord_less @ nat @ M4 @ N )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M4 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M4 @ P2 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P2 ) ) @ ( power_power @ real @ U2 @ P2 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ M4 ) ) )
                    @ ( times_times @ real @ B4 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N @ M4 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ M4 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M4 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M4 ) @ P2 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P2 ) ) @ ( power_power @ real @ T8 @ P2 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ M4 ) ) ) )
                  @ ( times_times @ real @ B4 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N @ ( suc @ M4 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ ( suc @ M4 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_5781_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X10: real] :
            ( suminf @ real
            @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X10 @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( power_power @ real @ X @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_5782_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G5: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X3: A] : ( arcsin @ ( G @ X3 ) )
                @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_5783_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G5: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X3: A] : ( arccos @ ( G @ X3 ) )
                @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_5784_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G5: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G @ X ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X3: A] : ( tan @ real @ ( G @ X3 ) )
              @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_5785_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F3: D > real,F9: D > real,X: D,S: set @ D,G: D > C,G5: D > C] :
          ( ( has_derivative @ D @ real @ F3 @ F9 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ C @ G @ G5 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ C
              @ ^ [X3: D] : ( real_V8093663219630862766scaleR @ C @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ^ [H3: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F3 @ X ) @ ( G5 @ H3 ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F9 @ H3 ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_5786_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F5: A > A,D7: A] : ( has_derivative @ A @ A @ F5 @ ( times_times @ A @ D7 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_5787_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A > A,F6: filter @ A,D8: A] :
          ( ( has_derivative @ A @ A @ F3 @ D3 @ F6 )
         => ( ! [X4: A] :
                ( ( times_times @ A @ X4 @ D8 )
                = ( D3 @ X4 ) )
           => ( has_field_derivative @ A @ F3 @ D8 @ F6 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_5788_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,F6: filter @ A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ F6 )
         => ( has_derivative @ A @ A @ F3 @ ( times_times @ A @ D3 ) @ F6 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_5789_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_5790_has__derivative__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,F6: filter @ A,G: A > B,G5: A > B] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ F6 )
         => ( ( has_derivative @ A @ B @ G @ G5 @ F6 )
           => ( has_derivative @ A @ B
              @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ^ [X3: A] : ( minus_minus @ B @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
              @ F6 ) ) ) ) ).

% has_derivative_diff
thf(fact_5791_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G5: C > A,F6: filter @ C,Y: A] :
          ( ( has_derivative @ C @ A @ G @ G5 @ F6 )
         => ( has_derivative @ C @ A
            @ ^ [X3: C] : ( times_times @ A @ ( G @ X3 ) @ Y )
            @ ^ [X3: C] : ( times_times @ A @ ( G5 @ X3 ) @ Y )
            @ F6 ) ) ) ).

% has_derivative_mult_left
thf(fact_5792_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G5: C > A,F6: filter @ C,X: A] :
          ( ( has_derivative @ C @ A @ G @ G5 @ F6 )
         => ( has_derivative @ C @ A
            @ ^ [X3: C] : ( times_times @ A @ X @ ( G @ X3 ) )
            @ ^ [X3: C] : ( times_times @ A @ X @ ( G5 @ X3 ) )
            @ F6 ) ) ) ).

% has_derivative_mult_right
thf(fact_5793_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,F6: filter @ A,G: A > B,G5: A > B] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ F6 )
         => ( ( has_derivative @ A @ B @ G @ G5 @ F6 )
           => ( has_derivative @ A @ B
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ^ [X3: A] : ( plus_plus @ B @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
              @ F6 ) ) ) ) ).

% has_derivative_add
thf(fact_5794_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F6: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X3: A] : C2
          @ ^ [X3: A] : ( zero_zero @ B )
          @ F6 ) ) ).

% has_derivative_const
thf(fact_5795_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: D > A,F9: D > A,X: D,S: set @ D,G: D > A,G5: D > A] :
          ( ( has_derivative @ D @ A @ F3 @ F9 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ A @ G @ G5 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ A
              @ ^ [X3: D] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ^ [H3: D] : ( plus_plus @ A @ ( times_times @ A @ ( F3 @ X ) @ ( G5 @ H3 ) ) @ ( times_times @ A @ ( F9 @ H3 ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_mult
thf(fact_5796_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F6: A > B,X: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X3: A] : ( zero_zero @ B )
            @ F6
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( F6
            = ( ^ [H3: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_5797_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G: A > B,G5: A > A > B,F3: C > A,S: set @ C,X: C,F9: C > A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ T2 )
             => ( has_derivative @ A @ B @ G @ ( G5 @ X4 ) @ ( topolo174197925503356063within @ A @ X4 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F3 @ S ) @ T2 )
           => ( ( member @ C @ X @ S )
             => ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X3: C] : ( G @ ( F3 @ X3 ) )
                  @ ^ [Y6: C] : ( G5 @ ( F3 @ X ) @ ( F9 @ Y6 ) )
                  @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_5798_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X3: A] : ( exp @ real @ ( G @ X3 ) )
            @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( exp @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_exp
thf(fact_5799_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X: A,S: set @ A,D2: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ X @ S )
             => ( ! [X12: A] :
                    ( ( member @ A @ X12 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X12 @ X ) @ D2 )
                     => ( ( F3 @ X12 )
                        = ( G @ X12 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_5800_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X3: A] : ( sin @ real @ ( G @ X3 ) )
            @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( cos @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sin
thf(fact_5801_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X3: A] : ( cosh @ A @ ( G @ X3 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cosh
thf(fact_5802_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X3: A] : ( sinh @ A @ ( G @ X3 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sinh
thf(fact_5803_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,F9: C > A,X: C,S2: set @ C,G: C > A,G5: C > A] :
          ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G5 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X3: C] : ( divide_divide @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ^ [H3: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F9 @ H3 ) @ ( G @ X ) ) @ ( times_times @ A @ ( F3 @ X ) @ ( G5 @ H3 ) ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_5804_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: C > A,X: C,F9: C > A,S2: set @ C] :
          ( ( ( F3 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X3: C] : ( inverse_inverse @ A @ ( F3 @ X3 ) )
              @ ^ [H3: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F3 @ X ) ) @ ( F9 @ H3 ) ) @ ( inverse_inverse @ A @ ( F3 @ X ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_5805_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H3: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X ) @ H3 ) @ ( inverse_inverse @ A @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_5806_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: real > real,F9: real,G: A > real,X: A,G5: A > real,S: set @ A] :
          ( ( has_field_derivative @ real @ F3 @ F9 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X3: A] : ( F3 @ ( G @ X3 ) )
              @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ F9 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_5807_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X3: A] : ( cos @ real @ ( G @ X3 ) )
            @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cos
thf(fact_5808_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,F9: A > B,X: A,S2: set @ A,N: nat] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_derivative @ A @ B
            @ ^ [X3: A] : ( power_power @ B @ ( F3 @ X3 ) @ N )
            @ ^ [Y6: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N ) @ ( F9 @ Y6 ) ) @ ( power_power @ B @ ( F3 @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power
thf(fact_5809_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G5: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X3: A] : ( ln_ln @ real @ ( G @ X3 ) )
              @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( inverse_inverse @ real @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_5810_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F3: C > A,F9: C > A,X: C,S2: set @ C,G: C > A,G5: C > A] :
          ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G5 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X3: C] : ( divide_divide @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ^ [H3: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F3 @ X ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X ) ) @ ( G5 @ H3 ) ) @ ( inverse_inverse @ A @ ( G @ X ) ) ) ) @ ( divide_divide @ A @ ( F9 @ H3 ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_5811_has__derivative__prod,axiom,
    ! [B: $tType,I6: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I5: set @ I6,F3: I6 > A > B,F9: I6 > A > B,X: A,S2: set @ A] :
          ( ! [I2: I6] :
              ( ( member @ I6 @ I2 @ I5 )
             => ( has_derivative @ A @ B @ ( F3 @ I2 ) @ ( F9 @ I2 ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X3: A] :
                ( groups7121269368397514597t_prod @ I6 @ B
                @ ^ [I3: I6] : ( F3 @ I3 @ X3 )
                @ I5 )
            @ ^ [Y6: A] :
                ( groups7311177749621191930dd_sum @ I6 @ B
                @ ^ [I3: I6] :
                    ( times_times @ B @ ( F9 @ I3 @ Y6 )
                    @ ( groups7121269368397514597t_prod @ I6 @ B
                      @ ^ [J3: I6] : ( F3 @ J3 @ X )
                      @ ( minus_minus @ ( set @ I6 ) @ I5 @ ( insert @ I6 @ I3 @ ( bot_bot @ ( set @ I6 ) ) ) ) ) )
                @ I5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_prod
thf(fact_5812_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,X: C,F9: C > A,S2: set @ C,N: int] :
          ( ( ( F3 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F3 @ F9 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X3: C] : ( power_int @ A @ ( F3 @ X3 ) @ N )
              @ ^ [H3: C] : ( times_times @ A @ ( F9 @ H3 ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F3 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_5813_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,N: int,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X3: A] : ( power_int @ A @ X3 @ N )
            @ ^ [Y6: A] : ( times_times @ A @ Y6 @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power_int'
thf(fact_5814_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X: A,X9: set @ A,F3: A > real,F9: A > real] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ X9 ) )
         => ( ( has_derivative @ A @ real @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ X9 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
             => ( ( member @ A @ X @ X9 )
               => ( has_derivative @ A @ real
                  @ ^ [X3: A] : ( powr @ real @ ( G @ X3 ) @ ( F3 @ X3 ) )
                  @ ^ [H3: A] : ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F3 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F9 @ H3 ) @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G5 @ H3 ) @ ( F3 @ X ) ) @ ( G @ X ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ X9 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_5815_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G5: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X3: A] : ( sqrt @ ( G @ X3 ) )
              @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_5816_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G5: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X3: A] : ( arctan @ ( G @ X3 ) )
            @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_5817_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X: A,F3: real > Aa,G5: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) @ F3 )
         => ( ~ ( member @ Aa @ ( F3 @ ( G @ X ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X3: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F3 @ ( G @ X3 ) ) ) )
                @ ^ [X3: A] : ( times_times @ real @ ( G5 @ X3 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_5818_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K6 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( filterlim @ A @ A
              @ ^ [H3: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X @ H3 ) @ N2 ) @ ( power_power @ A @ X @ N2 ) ) @ H3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_5819_surj__int__encode,axiom,
    ( ( image @ int @ nat @ nat_int_encode @ ( top_top @ ( set @ int ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% surj_int_encode
thf(fact_5820_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F3: B > A,L: A,F6: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F3 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F6 )
            = ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_5821_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F3: B > A,L: A,F6: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F6 )
            = ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_5822_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F3: A > real,F6: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real
          @ ^ [X3: A] : ( power_power @ real @ ( F3 @ X3 ) @ N )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F6 )
        = ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 ) ) ) ).

% power_tendsto_0_iff
thf(fact_5823_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X4: A] :
                ( ( X4 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X4 ) ) )
           => ( ! [X4: A] :
                  ( ( X4 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X4 ) @ ( F3 @ X4 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_5824_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F3: C > A,L: A,A2: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X4: C] :
                ( ( X4 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X4 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X4 ) @ L ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_5825_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F3: A > B,G: B > C,L: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L ) @ ( topolo174197925503356063within @ B @ ( F3 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D5: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X4 @ A2 ) ) @ D5 ) )
                     => ( ( F3 @ X4 )
                       != ( F3 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( G @ ( F3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_5826_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,A2: A,L6: B] :
          ( ( filterlim @ A @ B
            @ ^ [H3: A] : ( F3 @ ( plus_plus @ A @ A2 @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_5827_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H3: A] : ( F3 @ ( plus_plus @ A @ A2 @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_5828_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H3: A] : ( F3 @ ( plus_plus @ A @ A2 @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_5829_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F3 )
          = ( filterlim @ A @ B
            @ ^ [H3: A] : ( F3 @ ( plus_plus @ A @ X @ H3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F3 @ X ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_5830_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F3: A > C,G: C > D,L: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L ) @ ( topolo174197925503356063within @ C @ ( F3 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D5: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A2 ) @ D5 ) )
                     => ( ( F3 @ X4 )
                       != ( F3 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X3: A] : ( G @ ( F3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_5831_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A2: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X3: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_5832_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,L6: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X3: A] : ( F3 @ ( plus_plus @ A @ X3 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_5833_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F3: A > B,L: B,X: A,S2: set @ A,D2: real,G: A > B] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X12: A] :
                  ( ( member @ A @ X12 @ S2 )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X12 @ X ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X12 @ X ) @ D2 )
                     => ( ( F3 @ X12 )
                        = ( G @ X12 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_5834_continuous__within__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A,S: set @ A] : ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ Z @ S ) @ ( sin @ A ) ) ) ).

% continuous_within_sin
thf(fact_5835_continuous__within__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A,S: set @ A] : ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ Z @ S ) @ ( cos @ A ) ) ) ).

% continuous_within_cos
thf(fact_5836_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
          = ( filterlim @ A @ A
            @ ^ [Y6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ Y6 ) @ ( F3 @ X ) ) @ ( minus_minus @ A @ Y6 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D3 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_5837_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( filterlim @ A @ A
            @ ^ [Y6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ Y6 ) @ ( F3 @ X ) ) @ ( minus_minus @ A @ Y6 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D3 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivativeD
thf(fact_5838_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: A > B,L: filter @ B,X: A,S2: set @ A,T5: set @ A] :
          ( ( filterlim @ A @ B @ F3 @ L @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T5 @ S2 )
           => ( filterlim @ A @ B @ F3 @ L @ ( topolo174197925503356063within @ A @ X @ T5 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_5839_tendsto__arcosh,axiom,
    ! [B: $tType,F3: B > real,A2: real,F6: filter @ B] :
      ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X3: B] : ( arcosh @ real @ ( F3 @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F6 ) ) ) ).

% tendsto_arcosh
thf(fact_5840_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F3: A > B,F6: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X3: A] : ( power_power @ B @ ( F3 @ X3 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F6 ) ) ) ) ).

% tendsto_null_power
thf(fact_5841_tendsto__log,axiom,
    ! [A: $tType,F3: A > real,A2: real,F6: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F6 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X3: A] : ( log @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F6 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_5842_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I5: set @ B,F3: A > B > C,F6: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( F3 @ X3 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F6 ) )
         => ( filterlim @ A @ C
            @ ^ [I3: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F3 @ I3 ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F6 ) ) ) ).

% tendsto_null_sum
thf(fact_5843_tendsto__one__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I5: set @ B,F3: A > B > C,F6: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( F3 @ X3 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
                @ F6 ) )
         => ( filterlim @ A @ C
            @ ^ [I3: A] : ( groups7121269368397514597t_prod @ B @ C @ ( F3 @ I3 ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
            @ F6 ) ) ) ).

% tendsto_one_prod'
thf(fact_5844_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,L: B,F6: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F6 )
         => ( filterlim @ A @ B
            @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F6 ) ) ) ).

% LIM_zero
thf(fact_5845_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,L: B,F6: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F6 )
          = ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F6 ) ) ) ).

% LIM_zero_iff
thf(fact_5846_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A2: A,F6: filter @ B,F3: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( minus_minus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F6 )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 ) ) ) ) ).

% Lim_transform
thf(fact_5847_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( filterlim @ B @ A
              @ ^ [X3: B] : ( minus_minus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F6 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 ) ) ) ) ).

% Lim_transform2
thf(fact_5848_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,L: B,F6: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F6 )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F6 ) ) ) ).

% LIM_zero_cancel
thf(fact_5849_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,G: B > A,F6: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X3: B] : ( minus_minus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F6 )
         => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 ) ) ) ) ).

% Lim_transform_eq
thf(fact_5850_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F3: D > B,F6: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 )
           => ( filterlim @ D @ B
              @ ^ [X3: D] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F6 ) ) ) ) ).

% tendsto_add_zero
thf(fact_5851_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: D > A,F6: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
           => ( filterlim @ D @ A
              @ ^ [X3: D] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F6 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_5852_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: D > A,F6: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
         => ( filterlim @ D @ A
            @ ^ [X3: D] : ( times_times @ A @ ( F3 @ X3 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F6 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_5853_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F3: D > A,F6: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
         => ( filterlim @ D @ A
            @ ^ [X3: D] : ( times_times @ A @ C2 @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F6 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_5854_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: A > A,A2: A,F6: filter @ A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( ( sin @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X3: A] : ( cot @ A @ ( F3 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A2 ) )
              @ F6 ) ) ) ) ).

% tendsto_cot
thf(fact_5855_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F6: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( ( cosh @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X3: C] : ( tanh @ A @ ( F3 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A2 ) )
              @ F6 ) ) ) ) ).

% tendsto_tanh
thf(fact_5856_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F3: A > B,L: B,F6: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F6 )
          = ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V557655796197034286t_dist @ B @ ( F3 @ X3 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F6 ) ) ) ).

% tendsto_dist_iff
thf(fact_5857_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( inverse_inverse @ A @ ( F3 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A2 ) )
              @ F6 ) ) ) ) ).

% tendsto_inverse
thf(fact_5858_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: B > A,F6: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
         => ( filterlim @ B @ A
            @ ^ [X3: B] : ( divide_divide @ A @ ( F3 @ X3 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F6 ) ) ) ).

% tendsto_divide_zero
thf(fact_5859_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F6 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X3: B] : ( divide_divide @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F6 ) ) ) ) ) ).

% tendsto_divide
thf(fact_5860_tendsto__ln,axiom,
    ! [A: $tType,F3: A > real,A2: real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( A2
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( ln_ln @ real @ ( F3 @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A2 ) )
          @ F6 ) ) ) ).

% tendsto_ln
thf(fact_5861_tendsto__powr,axiom,
    ! [A: $tType,F3: A > real,A2: real,F6: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F6 )
       => ( ( A2
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F6 ) ) ) ) ).

% tendsto_powr
thf(fact_5862_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F6: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F6 )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_5863_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F6: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F6 )
          = ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_5864_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F6: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F6 ) ) ) ).

% tendsto_norm_zero
thf(fact_5865_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: B > A,L: A,F6: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 )
         => ( ( L
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( sgn_sgn @ A @ ( F3 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L ) )
              @ F6 ) ) ) ) ).

% tendsto_sgn
thf(fact_5866_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B,N: int] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( power_int @ A @ ( F3 @ X3 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ A @ ( power_int @ A @ A2 @ N ) )
              @ F6 ) ) ) ) ).

% tendsto_power_int
thf(fact_5867_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: A > A,A2: A,F6: filter @ A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( ( cos @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X3: A] : ( tan @ A @ ( F3 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A2 ) )
              @ F6 ) ) ) ) ).

% tendsto_tan
thf(fact_5868_int__encode__eq,axiom,
    ! [X: int,Y: int] :
      ( ( ( nat_int_encode @ X )
        = ( nat_int_encode @ Y ) )
      = ( X = Y ) ) ).

% int_encode_eq
thf(fact_5869_continuous__sinh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F6: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ F6
            @ ^ [X3: C] : ( sinh @ A @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_sinh
thf(fact_5870_tendsto__sinh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F6: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( filterlim @ C @ A
            @ ^ [X3: C] : ( sinh @ A @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( sinh @ A @ A2 ) )
            @ F6 ) ) ) ).

% tendsto_sinh
thf(fact_5871_tendsto__exp,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F6: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( filterlim @ C @ A
            @ ^ [X3: C] : ( exp @ A @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( exp @ A @ A2 ) )
            @ F6 ) ) ) ).

% tendsto_exp
thf(fact_5872_continuous__exp,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F6: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ F6
            @ ^ [X3: C] : ( exp @ A @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_exp
thf(fact_5873_continuous__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F6: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ F6
            @ ^ [X3: A] : ( sin @ B @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_sin
thf(fact_5874_continuous__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F6: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ F6
            @ ^ [X3: A] : ( cos @ B @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_cos
thf(fact_5875_tendsto__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,A2: B,F6: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F6 )
         => ( filterlim @ A @ B
            @ ^ [X3: A] : ( sin @ B @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( sin @ B @ A2 ) )
            @ F6 ) ) ) ).

% tendsto_sin
thf(fact_5876_tendsto__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,A2: B,F6: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F6 )
         => ( filterlim @ A @ B
            @ ^ [X3: A] : ( cos @ B @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( cos @ B @ A2 ) )
            @ F6 ) ) ) ).

% tendsto_cos
thf(fact_5877_tendsto__arsinh,axiom,
    ! [B: $tType,F3: B > real,A2: real,F6: filter @ B] :
      ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( filterlim @ B @ real
        @ ^ [X3: B] : ( arsinh @ real @ ( F3 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( arsinh @ real @ A2 ) )
        @ F6 ) ) ).

% tendsto_arsinh
thf(fact_5878_tendsto__arctan,axiom,
    ! [A: $tType,F3: A > real,X: real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F6 )
     => ( filterlim @ A @ real
        @ ^ [X3: A] : ( arctan @ ( F3 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( arctan @ X ) )
        @ F6 ) ) ).

% tendsto_arctan
thf(fact_5879_continuous__cosh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F6: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ F6
            @ ^ [X3: C] : ( cosh @ A @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_cosh
thf(fact_5880_tendsto__cosh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: C > A,A2: A,F6: filter @ C] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( filterlim @ C @ A
            @ ^ [X3: C] : ( cosh @ A @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( cosh @ A @ A2 ) )
            @ F6 ) ) ) ).

% tendsto_cosh
thf(fact_5881_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F6 )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( plus_plus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F6 ) ) ) ) ).

% tendsto_add
thf(fact_5882_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F6: filter @ D,F3: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F6 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F6 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F6
              @ ^ [X3: D] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_add
thf(fact_5883_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F3: B > A,D2: A,F6: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X3: B] : ( plus_plus @ A @ C2 @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F6 )
          = ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F6 ) ) ) ).

% tendsto_add_const_iff
thf(fact_5884_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F3: D > B,F6: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F6 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F6 )
           => ( filterlim @ D @ B
              @ ^ [X3: D] : ( times_times @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F6 ) ) ) ) ).

% tendsto_mult_one
thf(fact_5885_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F6: filter @ B,F3: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ B @ A @ F6
            @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_5886_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F6: filter @ B,F3: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ B @ A @ F6
            @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_5887_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F3: B > A,L: A,F6: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 )
         => ( filterlim @ B @ A
            @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
            @ F6 ) ) ) ).

% tendsto_mult_right
thf(fact_5888_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F3: B > A,L: A,F6: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 )
         => ( filterlim @ B @ A
            @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
            @ F6 ) ) ) ).

% tendsto_mult_left
thf(fact_5889_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F6: filter @ D,F3: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F6 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F6 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F6
              @ ^ [X3: D] : ( times_times @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_5890_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F6: filter @ D,F3: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F6 @ F3 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F6 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F6
              @ ^ [X3: D] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_5891_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F6 )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F6 ) ) ) ) ).

% tendsto_mult
thf(fact_5892_tendsto__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F6 )
           => ( filterlim @ B @ A
              @ ^ [X3: B] : ( minus_minus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( minus_minus @ A @ A2 @ B2 ) )
              @ F6 ) ) ) ) ).

% tendsto_diff
thf(fact_5893_continuous__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [F6: filter @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ F6
              @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_diff
thf(fact_5894_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X3: A] : ( abs_abs @ real @ ( F3 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F6 )
     => ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_5895_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X3: A] : ( abs_abs @ real @ ( F3 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F6 )
      = ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_5896_tendsto__rabs__zero,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 )
     => ( filterlim @ A @ real
        @ ^ [X3: A] : ( abs_abs @ real @ ( F3 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F6 ) ) ).

% tendsto_rabs_zero
thf(fact_5897_tendsto__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F6: filter @ B,F13: filter @ B,F3: B > A,L: A] :
          ( ( ord_less_eq @ ( filter @ B ) @ F6 @ F13 )
         => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F13 )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 ) ) ) ) ).

% tendsto_mono
thf(fact_5898_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F3: A > B,F23: filter @ B,F14: filter @ A,F24: filter @ B,F15: filter @ A] :
      ( ( filterlim @ A @ B @ F3 @ F23 @ F14 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F23 @ F24 )
       => ( ( ord_less_eq @ ( filter @ A ) @ F15 @ F14 )
         => ( filterlim @ A @ B @ F3 @ F24 @ F15 ) ) ) ) ).

% filterlim_mono
thf(fact_5899_tendsto__artanh,axiom,
    ! [A: $tType,F3: A > real,A2: real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( artanh @ real @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F6 ) ) ) ) ).

% tendsto_artanh
thf(fact_5900_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,L: B,A2: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X4: A] :
                ( ( X4 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X4 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F3 @ X4 ) @ L ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_5901_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F3: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X3: A] :
                        ( ( ( X3 != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ S4 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X3 ) @ L6 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_5902_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F3: A > B,L6: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X5: A] :
                    ( ( ( X5 != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X5 ) @ L6 ) @ R ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_5903_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F3: A > B,L6: B] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A2 ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X4 ) @ L6 ) @ R4 ) ) ) )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_5904_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L: B,A2: A,R2: real,F3: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ( ! [X4: A] :
                  ( ( X4 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A2 ) @ R2 )
                   => ( ( F3 @ X4 )
                      = ( G @ X4 ) ) ) )
             => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_5905_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D5: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ A2 ) @ D5 ) )
                     => ( ( F3 @ X4 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( G @ ( F3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_5906_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F3: A > D,L6: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F3 @ ( topolo7230453075368039082e_nhds @ D @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H3: A] : ( F3 @ ( plus_plus @ A @ A2 @ H3 ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L6 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_5907_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F3: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F3 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F3 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X4: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X4 )
                      & ( ord_less_eq @ A @ X4 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X4 @ ( top_top @ ( set @ A ) ) ) @ F3 ) )
               => ? [X4: A] :
                    ( ( ord_less_eq @ A @ A2 @ X4 )
                    & ( ord_less_eq @ A @ X4 @ B2 )
                    & ( ( F3 @ X4 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2
thf(fact_5908_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F3: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F3 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F3 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X4: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X4 )
                      & ( ord_less_eq @ A @ X4 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X4 @ ( top_top @ ( set @ A ) ) ) @ F3 ) )
               => ? [X4: A] :
                    ( ( ord_less_eq @ A @ A2 @ X4 )
                    & ( ord_less_eq @ A @ X4 @ B2 )
                    & ( ( F3 @ X4 )
                      = Y ) ) ) ) ) ) ) ).

% IVT
thf(fact_5909_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R2: real,A2: A,F3: A > B,G: A > B,L: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( ! [X4: A] :
                ( ( X4 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X4 @ A2 ) ) @ R2 )
                 => ( ( F3 @ X4 )
                    = ( G @ X4 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_5910_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X3: A] :
                        ( ( ( X3 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S4 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F3 @ X3 ) @ L6 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_5911_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B,L6: B] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [S8: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S8 )
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X4 @ A2 ) ) @ S8 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F3 @ X4 ) @ L6 ) ) @ R4 ) ) ) )
         => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_5912_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,L6: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X5: A] :
                    ( ( ( X5 != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F3 @ X5 ) @ L6 ) ) @ R ) ) ) ) ) ) ).

% LIM_D
thf(fact_5913_isCont__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( cos @ A ) ) ) ).

% isCont_cos
thf(fact_5914_isCont__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( sin @ A ) ) ) ).

% isCont_sin
thf(fact_5915_isCont__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( exp @ A ) ) ) ).

% isCont_exp
thf(fact_5916_isCont__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( cosh @ A ) ) ) ).

% isCont_cosh
thf(fact_5917_isCont__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] : ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( sinh @ A ) ) ) ).

% isCont_sinh
thf(fact_5918_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: A > A,A2: A,D3: A] :
          ( ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ A2 @ H3 ) ) @ ( F3 @ A2 ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D3 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ X3 ) @ ( F3 @ A2 ) ) @ ( minus_minus @ A @ X3 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D3 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_5919_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X4 )
              & ( ord_less_eq @ real @ X4 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
       => ? [L7: real,M10: real] :
            ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( ( ord_less_eq @ real @ L7 @ ( F3 @ X5 ) )
                  & ( ord_less_eq @ real @ ( F3 @ X5 ) @ M10 ) ) )
            & ! [Y4: real] :
                ( ( ( ord_less_eq @ real @ L7 @ Y4 )
                  & ( ord_less_eq @ real @ Y4 @ M10 ) )
               => ? [X4: real] :
                    ( ( ord_less_eq @ real @ A2 @ X4 )
                    & ( ord_less_eq @ real @ X4 @ B2 )
                    & ( ( F3 @ X4 )
                      = Y4 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_5920_LIM__fun__less__zero,axiom,
    ! [F3: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R4 ) )
               => ( ord_less @ real @ ( F3 @ X5 ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_5921_LIM__fun__not__zero,axiom,
    ! [F3: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L
         != ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R4 ) )
               => ( ( F3 @ X5 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_5922_LIM__fun__gt__zero,axiom,
    ! [F3: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R4 ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X5 ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_5923_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D5: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D5 )
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X4 @ A2 ) ) @ D5 ) )
                     => ( ( F3 @ X4 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X3: A] : ( G @ ( F3 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_5924_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S: set @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
                @ ^ [X3: A] : ( divide_divide @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_5925_isCont__arctan,axiom,
    ! [X: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arctan ) ).

% isCont_arctan
thf(fact_5926_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( times_times @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_5927_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% isCont_add
thf(fact_5928_isCont__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% isCont_diff
thf(fact_5929_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S: set @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_5930_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,S: set @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_5931_continuous__at__within__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S: set @ A,F3: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
              @ ^ [X3: A] : ( power_int @ B @ ( F3 @ X3 ) @ N ) ) ) ) ) ).

% continuous_at_within_power_int
thf(fact_5932_isCont__cos_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X3: A] : ( cos @ B @ ( F3 @ X3 ) ) ) ) ) ).

% isCont_cos'
thf(fact_5933_isCont__sin_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X3: A] : ( sin @ B @ ( F3 @ X3 ) ) ) ) ) ).

% isCont_sin'
thf(fact_5934_isCont__exp_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F3 )
         => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
            @ ^ [X3: C] : ( exp @ A @ ( F3 @ X3 ) ) ) ) ) ).

% isCont_exp'
thf(fact_5935_isCont__pochhammer,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Z: A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) )
          @ ^ [Z6: A] : ( comm_s3205402744901411588hammer @ A @ Z6 @ N ) ) ) ).

% isCont_pochhammer
thf(fact_5936_isCont__arsinh,axiom,
    ! [X: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arsinh @ real ) ) ).

% isCont_arsinh
thf(fact_5937_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F3 @ X ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D3 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_5938_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A] :
          ( ( has_field_derivative @ A @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F3 @ X ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D3 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_5939_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( one_one @ A ) ) @ Z6 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_5940_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F3: A > B,K6: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ H4 ) ) @ ( times_times @ real @ K6 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_5941_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F3: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X4: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X4 )
                  & ( ord_less_eq @ real @ X4 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
           => ? [M10: A] :
              ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( ord_less_eq @ A @ ( F3 @ X5 ) @ M10 ) ) ) ) ) ).

% isCont_bounded
thf(fact_5942_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F3: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X4: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X4 )
                  & ( ord_less_eq @ real @ X4 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F3 @ X5 ) @ M10 ) )
                & ? [X4: real] :
                    ( ( ord_less_eq @ real @ A2 @ X4 )
                    & ( ord_less_eq @ real @ X4 @ B2 )
                    & ( ( F3 @ X4 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_5943_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F3: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X4: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X4 )
                  & ( ord_less_eq @ real @ X4 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ M10 @ ( F3 @ X5 ) ) )
                & ? [X4: real] :
                    ( ( ord_less_eq @ real @ A2 @ X4 )
                    & ( ord_less_eq @ real @ X4 @ B2 )
                    & ( ( F3 @ X4 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_5944_isCont__inverse__function2,axiom,
    ! [A2: real,X: real,B2: real,G: real > real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ A2 @ Z5 )
             => ( ( ord_less_eq @ real @ Z5 @ B2 )
               => ( ( G @ ( F3 @ Z5 ) )
                  = Z5 ) ) )
         => ( ! [Z5: real] :
                ( ( ord_less_eq @ real @ A2 @ Z5 )
               => ( ( ord_less_eq @ real @ Z5 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F3 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F3 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_5945_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,D3: A,X: A] :
          ( ( has_derivative @ A @ A @ F3 @ ( times_times @ A @ D3 ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H3: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F3 @ X ) ) @ H3 )
            @ ( topolo7230453075368039082e_nhds @ A @ D3 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_5946_isCont__ln,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_5947_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X3: A] : ( divide_divide @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_5948_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( F3 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F3 @ X3 ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_5949_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: A > B,F6: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F3 @ F6 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X3: A] : ( F3 @ ( plus_plus @ A @ X3 @ A2 ) )
            @ F6
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_5950_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S: set @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S ) @ F3 )
         => ( ( ( cos @ A @ ( F3 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X3: A] : ( tan @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_5951_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S: set @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S ) @ F3 )
         => ( ( ( sin @ A @ ( F3 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X3: A] : ( cot @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_5952_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: C,A3: set @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A3 ) @ F3 )
         => ( ( ( cosh @ A @ ( F3 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A3 )
              @ ^ [X3: C] : ( tanh @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_5953_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,L: A,X: A] :
          ( ( has_field_derivative @ A @ F3 @ L @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G2: A > A] :
                ( ! [Z6: A] :
                    ( ( minus_minus @ A @ ( F3 @ Z6 ) @ ( F3 @ X ) )
                    = ( times_times @ A @ ( G2 @ Z6 ) @ ( minus_minus @ A @ Z6 @ X ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ G2 )
                & ( ( G2 @ X )
                  = L ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_5954_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F3: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X4: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X4 )
                  & ( ord_less_eq @ real @ X4 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F3 @ X5 ) @ M10 ) )
                & ! [N8: A] :
                    ( ( ord_less @ A @ N8 @ M10 )
                   => ? [X4: real] :
                        ( ( ord_less_eq @ real @ A2 @ X4 )
                        & ( ord_less_eq @ real @ X4 @ B2 )
                        & ( ord_less @ A @ N8 @ ( F3 @ X4 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_5955_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_5956_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: A > B,F6: filter @ B,A2: A,D2: A] :
          ( ( filterlim @ A @ B @ F3 @ F6 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F3 @ ( plus_plus @ A @ D2 ) ) @ F6 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_5957_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: A > B,D2: A,F6: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F3 @ ( plus_plus @ A @ D2 ) ) @ F6 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F3 @ F6 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_5958_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_5959_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_5960_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F3: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X4: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ S )
               => ( sums @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) )
                  @ ( F3 @ X4 ) ) )
           => ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_5961_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F3: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X4: A] :
                ( ( X4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ S )
                 => ( sums @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X4 @ N2 ) )
                    @ ( F3 @ X4 ) ) ) )
           => ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_5962_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G6: filter @ B,X: A,S2: set @ A,F6: filter @ B,D2: real,F3: A > B] :
          ( ( filterlim @ A @ B @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G6 @ F6 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X12: A] :
                    ( ( member @ A @ X12 @ S2 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X12 @ X ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X12 @ X ) @ D2 )
                       => ( ( F3 @ X12 )
                          = ( G @ X12 ) ) ) ) )
               => ( filterlim @ A @ B @ F3 @ F6 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_5963_bij__int__encode,axiom,
    bij_betw @ int @ nat @ nat_int_encode @ ( top_top @ ( set @ int ) ) @ ( top_top @ ( set @ nat ) ) ).

% bij_int_encode
thf(fact_5964_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F3: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F3 )
           => ( ! [H4: A,N3: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N3 ) ) @ ( times_times @ real @ ( F3 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H3: A] : ( suminf @ B @ ( G @ H3 ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_5965_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( cos @ A @ ( F3 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( tan @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_5966_isCont__arcosh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_5967_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X3: real] : ( divide_divide @ real @ ( cos @ real @ X3 ) @ ( sin @ real @ X3 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_5968_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( sin @ A @ ( F3 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( cot @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_5969_DERIV__inverse__function,axiom,
    ! [F3: real > real,D3: real,G: real > real,X: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F3 @ D3 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D3
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X )
         => ( ( ord_less @ real @ X @ B2 )
           => ( ! [Y3: real] :
                  ( ( ord_less @ real @ A2 @ Y3 )
                 => ( ( ord_less @ real @ Y3 @ B2 )
                   => ( ( F3 @ ( G @ Y3 ) )
                      = Y3 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D3 ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_5970_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ W3 @ I3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% isCont_polynom
thf(fact_5971_isCont__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_5972_isCont__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_5973_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y3: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y3 @ N2 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
            @ ^ [X3: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_5974_LIM__less__bound,axiom,
    ! [B2: real,X: real,F3: real > real] :
      ( ( ord_less @ real @ B2 @ X )
     => ( ! [X4: real] :
            ( ( member @ real @ X4 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X4 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F3 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X ) ) ) ) ) ).

% LIM_less_bound
thf(fact_5975_isCont__artanh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_5976_isCont__inverse__function,axiom,
    ! [D2: real,X: real,G: real > real,F3: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z5: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z5 @ X ) ) @ D2 )
           => ( ( G @ ( F3 @ Z5 ) )
              = Z5 ) )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z5 @ X ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F3 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_5977_GMVT_H,axiom,
    ! [A2: real,B2: real,F3: real > real,G: real > real,G5: real > real,F9: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z5: real] :
            ( ( ord_less_eq @ real @ A2 @ Z5 )
           => ( ( ord_less_eq @ real @ Z5 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F3 ) ) )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ A2 @ Z5 )
             => ( ( ord_less_eq @ real @ Z5 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z5: real] :
                ( ( ord_less @ real @ A2 @ Z5 )
               => ( ( ord_less @ real @ Z5 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G5 @ Z5 ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z5: real] :
                  ( ( ord_less @ real @ A2 @ Z5 )
                 => ( ( ord_less @ real @ Z5 @ B2 )
                   => ( has_field_derivative @ real @ F3 @ ( F9 @ Z5 ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C4: real] :
                  ( ( ord_less @ real @ A2 @ C4 )
                  & ( ord_less @ real @ C4 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) @ ( G5 @ C4 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F9 @ C4 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_5978_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X: real,F3: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F3 )
         => ( ~ ( member @ A @ ( F3 @ X ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X3: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F3 @ X3 ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_5979_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K6 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X3 @ N2 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_5980_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F3: A > Aa,C2: nat > Aa,K6: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( summable @ Aa
              @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ K6 @ N2 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F3 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K6 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X3: A] :
                    ( suminf @ Aa
                    @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ ( F3 @ X3 ) @ N2 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_5981_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N4: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N4 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N4 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_5982_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N4: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N4 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N4 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_5983_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_5984_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_5985_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( A2 @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_5986_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_5987_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F3: nat > A,F6: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X3: nat] : ( F3 @ ( suc @ X3 ) )
        @ F6
        @ ( at_top @ nat ) )
      = ( filterlim @ nat @ A @ F3 @ F6 @ ( at_top @ nat ) ) ) ).

% filterlim_sequentially_Suc
thf(fact_5988_filterlim__Suc,axiom,
    filterlim @ nat @ nat @ suc @ ( at_top @ nat ) @ ( at_top @ nat ) ).

% filterlim_Suc
thf(fact_5989_continuous__arctan,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F6
            @ ^ [X3: A] : ( arctan @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_arctan
thf(fact_5990_continuous__arsinh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( topolo3448309680560233919inuous @ A @ real @ F6
            @ ^ [X3: A] : ( arsinh @ real @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_arsinh
thf(fact_5991_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,L: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_Suc
thf(fact_5992_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,L: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_imp_Suc
thf(fact_5993_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_5994_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_5995_seq__offset__neg,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,L: A,K: nat] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [I3: nat] : ( F3 @ ( minus_minus @ nat @ I3 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% seq_offset_neg
thf(fact_5996_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ ( X9 @ N3 ) @ A2 ) )
           => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_5997_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N3 )
               => ( ord_less_eq @ A @ A2 @ ( X9 @ N3 ) ) )
           => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_5998_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: nat > A,L: A,N6: nat,C5: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N6 @ N3 )
               => ( ord_less_eq @ A @ C5 @ ( F3 @ N3 ) ) )
           => ( ord_less_eq @ A @ C5 @ L ) ) ) ) ).

% Lim_bounded2
thf(fact_5999_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: nat > A,L: A,M7: nat,C5: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N3 )
               => ( ord_less_eq @ A @ ( F3 @ N3 ) @ C5 ) )
           => ( ord_less_eq @ A @ L @ C5 ) ) ) ) ).

% Lim_bounded
thf(fact_6000_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,X: A,Y8: nat > A,Y: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y8 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
           => ( ? [N8: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N3 )
                 => ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( Y8 @ N3 ) ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_6001_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N6: nat,X9: nat > A,Y8: nat > A,X: A,Y: A] :
          ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N6 @ N3 )
             => ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( Y8 @ N3 ) ) )
         => ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y8 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% lim_mono
thf(fact_6002_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ).

% Sup_lim
thf(fact_6003_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_6004_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( summable @ A @ F3 )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_6005_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,S: set @ C,F3: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S ) @ G )
           => ( ( ( F3 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S )
                @ ^ [X3: C] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_6006_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,S: set @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S ) @ F3 )
         => ( ( ( F3 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S )
              @ ^ [X3: A] : ( ln_ln @ real @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_6007_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_6008_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X3: nat] : ( times_times @ nat @ X3 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_6009_monoseq__convergent,axiom,
    ! [X9: nat > real,B4: real] :
      ( ( topological_monoseq @ real @ X9 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X9 @ I2 ) ) @ B4 )
       => ~ ! [L7: real] :
              ~ ( filterlim @ nat @ real @ X9 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_6010_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( root @ N2 @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_6011_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,F3: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( ( ( F3 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X3: C] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_6012_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( ( F3 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( ln_ln @ real @ ( F3 @ X3 ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_6013_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( ! [N4: nat] : ( ord_less_eq @ A @ ( A2 @ N4 ) @ X )
                & ! [M4: nat,N4: nat] :
                    ( ( ord_less_eq @ nat @ M4 @ N4 )
                   => ( ord_less_eq @ A @ ( A2 @ M4 ) @ ( A2 @ N4 ) ) ) )
              | ( ! [N4: nat] : ( ord_less_eq @ A @ X @ ( A2 @ N4 ) )
                & ! [M4: nat,N4: nat] :
                    ( ( ord_less_eq @ nat @ M4 @ N4 )
                   => ( ord_less_eq @ A @ ( A2 @ N4 ) @ ( A2 @ M4 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_6014_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N2: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_6015_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_6016_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X9: nat > A,X: A,L: nat] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( X9 @ ( times_times @ nat @ N2 @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_6017_telescope__summable,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) ) ) ) ) ).

% telescope_summable
thf(fact_6018_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) ) ) ) ) ).

% telescope_summable'
thf(fact_6019_nested__sequence__unique,axiom,
    ! [F3: nat > real,G: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N3 ) ) @ ( G @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ ( G @ N3 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N2: nat] : ( minus_minus @ real @ ( F3 @ N2 ) @ ( G @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L2: real] :
                ( ! [N4: nat] : ( ord_less_eq @ real @ ( F3 @ N4 ) @ L2 )
                & ( filterlim @ nat @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) )
                & ! [N4: nat] : ( ord_less_eq @ real @ L2 @ ( G @ N4 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_6020_LIMSEQ__inverse__zero,axiom,
    ! [X9: nat > real] :
      ( ! [R4: real] :
        ? [N8: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N3 )
         => ( ord_less @ real @ R4 @ ( X9 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( X9 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_6021_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_6022_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( root @ N2 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_6023_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_6024_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_6025_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S: set @ A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ A2 ) )
             => ( ( ( F3 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S )
                    @ ^ [X3: A] : ( log @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_6026_increasing__LIMSEQ,axiom,
    ! [F3: nat > real,L: real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F3 @ N3 ) @ L )
       => ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [N4: nat] : ( ord_less_eq @ real @ L @ ( plus_plus @ real @ ( F3 @ N4 ) @ E2 ) ) )
         => ( filterlim @ nat @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_6027_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L6: A,R: real] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No: nat] :
              ! [N4: nat] :
                ( ( ord_less_eq @ nat @ No @ N4 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N4 ) @ L6 ) @ R ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_6028_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L6: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N3 ) @ L6 ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_6029_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N2 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N2 ) @ L6 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_6030_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_6031_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_6032_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_6033_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_6034_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ ( suc @ N2 ) ) @ ( F3 @ N2 ) )
            @ ( minus_minus @ A @ C2 @ ( F3 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_6035_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ ( F3 @ ( suc @ N2 ) ) )
            @ ( minus_minus @ A @ ( F3 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_6036_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_6037_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_6038_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_6039_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_6040_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F5: nat > A,S4: A] :
              ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S4 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_6041_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,X: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N2: nat] : ( root @ N2 @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% root_test_convergence
thf(fact_6042_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_6043_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ A2 ) )
             => ( ( ( F3 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X3: A] : ( log @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_6044_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N2 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ N2 ) @ L6 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_6045_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,L6: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ N3 ) @ L6 ) ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_6046_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,L6: A,R: real] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No: nat] :
              ! [N4: nat] :
                ( ( ord_less_eq @ nat @ No @ N4 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X9 @ N4 ) @ L6 ) ) @ R ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_6047_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_6048_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_6049_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No3 )
                    & ! [N2: nat] :
                        ( ( ord_less_eq @ nat @ No3 @ N2 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X9 @ N2 ) @ L6 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_6050_tendsto__at__iff__sequentially,axiom,
    ! [C: $tType,A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: A > C,A2: C,X: A,S: set @ A] :
          ( ( filterlim @ A @ C @ F3 @ ( topolo7230453075368039082e_nhds @ C @ A2 ) @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ! [X8: nat > A] :
                ( ! [I3: nat] : ( member @ A @ ( X8 @ I3 ) @ ( minus_minus @ ( set @ A ) @ S @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
                 => ( filterlim @ nat @ C @ ( comp @ A @ C @ nat @ F3 @ X8 ) @ ( topolo7230453075368039082e_nhds @ C @ A2 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% tendsto_at_iff_sequentially
thf(fact_6051_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F3: B > nat,F6: filter @ B,X: A] :
          ( ( filterlim @ B @ nat @ F3 @ ( at_top @ nat ) @ F6 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y6: B] : ( power_power @ A @ X @ ( F3 @ Y6 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F6 ) ) ) ) ).

% tendsto_power_zero
thf(fact_6052_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( times_times @ real @ R @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_6053_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_6054_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_6055_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,Df: A,Z: A,S: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F3 @ Df @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N2: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F3 @ ( plus_plus @ A @ Z @ ( S @ N2 ) ) ) @ ( F3 @ Z ) ) @ ( S @ N2 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_6056_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_6057_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_6058_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ) ).

% summable
thf(fact_6059_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J3 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K3: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_6060_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( Theta @ J3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K3: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_6061_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_6062_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_6063_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_6064_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_6065_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L2: real] :
              ( ! [N4: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N4 ) ) )
                  @ L2 )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) )
              & ! [N4: nat] :
                  ( ord_less_eq @ real @ L2
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N4 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L2 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_6066_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_6067_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I3 ) @ ( A2 @ I3 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_6068_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ B
              @ ^ [Y6: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y6 @ X ) ) ) @ ( minus_minus @ B @ ( F3 @ Y6 ) @ ( plus_plus @ B @ ( F3 @ X ) @ ( F9 @ ( minus_minus @ A @ Y6 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_6069_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,D3: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F3 @ D3 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D3 )
            & ( filterlim @ A @ real
              @ ^ [H3: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ ( plus_plus @ A @ X @ H3 ) ) @ ( F3 @ X ) ) @ ( D3 @ H3 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_6070_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X3: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_6071_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_6072_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F5: real > real] :
        ? [C3: real] :
          ( F5
          = ( ^ [X3: real] : ( times_times @ real @ X3 @ C3 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_6073_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X ) ) ) ).

% bounded_linear_mult_right
thf(fact_6074_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X3: C] : ( times_times @ A @ ( G @ X3 ) @ Y ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_6075_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X3: C] : ( times_times @ A @ X @ ( G @ X3 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_6076_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X3: A] : ( times_times @ A @ X3 @ Y ) ) ) ).

% bounded_linear_mult_left
thf(fact_6077_bounded__linear__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% bounded_linear_sub
thf(fact_6078_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ? [K10: real] :
            ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K10 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_6079_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,G: C > A,F6: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
           => ( filterlim @ C @ B
              @ ^ [X3: C] : ( F3 @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F6 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_6080_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ? [K10: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K10 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_6081_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F3 )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K10 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_6082_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,K6: real] :
          ( ! [X4: A,Y3: A] :
              ( ( F3 @ ( plus_plus @ A @ X4 @ Y3 ) )
              = ( plus_plus @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
         => ( ! [R4: real,X4: A] :
                ( ( F3 @ ( real_V8093663219630862766scaleR @ A @ R4 @ X4 ) )
                = ( real_V8093663219630862766scaleR @ B @ R4 @ ( F3 @ X4 ) ) )
           => ( ! [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K6 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F3 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_6083_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ real
              @ ^ [Y6: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y6 ) @ ( F3 @ X ) ) @ ( F9 @ ( minus_minus @ A @ Y6 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y6 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_6084_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F9: A > B,X: A,F3: A > B,S: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F9 )
         => ( ( filterlim @ A @ B
              @ ^ [Y6: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y6 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y6 ) @ ( F3 @ X ) ) @ ( F9 @ ( minus_minus @ A @ Y6 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivativeI
thf(fact_6085_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ B
              @ ^ [Y6: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y6 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y6 ) @ ( F3 @ X ) ) @ ( F9 @ ( minus_minus @ A @ Y6 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_6086_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ? [E3: A > B] :
                ( ! [H3: A] :
                    ( ( F3 @ ( plus_plus @ A @ X @ H3 ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F3 @ X ) @ ( F9 @ H3 ) ) @ ( E3 @ H3 ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H3: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H3 ) ) @ ( real_V7770717601297561774m_norm @ A @ H3 ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_6087_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E: real,F9: A > B,S: set @ A,X: A,F3: A > B,H7: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( ( real_V3181309239436604168linear @ A @ B @ F9 )
           => ( ! [Y3: A] :
                  ( ( member @ A @ Y3 @ S )
                 => ( ( Y3 != X )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y3 @ X ) @ E )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F3 @ Y3 ) @ ( F3 @ X ) ) @ ( F9 @ ( minus_minus @ A @ Y3 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y3 @ X ) ) ) @ ( H7 @ Y3 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H7 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X @ S ) )
               => ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_6088_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F9: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
            & ( filterlim @ A @ B
              @ ^ [Y6: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y6 @ X ) ) ) @ ( minus_minus @ B @ ( F3 @ Y6 ) @ ( plus_plus @ B @ ( F3 @ X ) @ ( F9 @ ( minus_minus @ A @ Y6 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_6089_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F5: A > B,F16: A > B,F10: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F16 )
              & ( filterlim @ A @ B
                @ ^ [Y6: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y6
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F10
                            @ ^ [X3: A] : X3 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F5 @ Y6 )
                        @ ( F5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F10
                            @ ^ [X3: A] : X3 ) ) )
                      @ ( F16
                        @ ( minus_minus @ A @ Y6
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F10
                            @ ^ [X3: A] : X3 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F10 ) ) ) ) ) ).

% has_derivative_def
thf(fact_6090_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X: A,S2: set @ A,F3: A > B,F9: A > B] :
          ( ( member @ A @ X @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( has_derivative @ A @ B @ F3 @ F9 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F9 )
                & ? [E3: A > B] :
                    ( ! [H3: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X @ H3 ) @ S2 )
                       => ( ( F3 @ ( plus_plus @ A @ X @ H3 ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F3 @ X ) @ ( F9 @ H3 ) ) @ ( E3 @ H3 ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H3: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H3 ) ) @ ( real_V7770717601297561774m_norm @ A @ H3 ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_6091_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I4: nat] :
              ( ( member @ A @ X @ ( A8 @ I4 ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I4 ) ) )
          & ! [S9: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S9 )
                & ( member @ A @ X @ S9 ) )
             => ? [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I2 ) @ S9 ) ) ) ) ).

% first_countable_basis
thf(fact_6092_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S7: set @ A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ S7 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member @ A @ X3 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S7 ) ) ) ) ) ) ).

% open_subopen
thf(fact_6093_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ S2 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member @ A @ X4 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S2 ) ) ) ).

% openI
thf(fact_6094_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S2: set @ A,T5: set @ A] :
          ( ( member @ A @ A2 @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ T5 )
             => ( ( topolo174197925503356063within @ A @ A2 @ T5 )
                = ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_6095_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ X @ Y )
             => ? [B5: A] :
                  ( ( ord_less @ A @ X @ B5 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X @ B5 ) @ S2 ) ) ) ) ) ) ).

% open_right
thf(fact_6096_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S7: set @ A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ S7 )
             => ? [E3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                  & ! [Y6: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y6 @ X3 ) @ E3 )
                     => ( member @ A @ Y6 @ S7 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_6097_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S7: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S7 )
               => ( ( member @ A @ F0 @ S7 )
                 => ? [N7: nat] :
                    ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ N2 )
                     => ( member @ A @ ( F3 @ N2 ) @ S7 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_6098_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F6: filter @ A,F3: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                    @ ^ [X3: A] : X3 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F6
                @ ^ [X3: A] : ( divide_divide @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_6099_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F6: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ F3 )
         => ( ( ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F6
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_6100_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F6: filter @ A,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ F3 )
         => ( ( ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F6
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_6101_continuous__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F6: filter @ A,F3: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F6 @ F3 )
         => ( ( ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F6
              @ ^ [X3: A] : ( power_int @ B @ ( F3 @ X3 ) @ N ) ) ) ) ) ).

% continuous_power_int
thf(fact_6102_at__within__nhd,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X: A,S2: set @ A,T5: set @ A,U3: set @ A] :
          ( ( member @ A @ X @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ T5 @ S2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ U3 @ S2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( topolo174197925503356063within @ A @ X @ T5 )
                = ( topolo174197925503356063within @ A @ X @ U3 ) ) ) ) ) ) ).

% at_within_nhd
thf(fact_6103_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ G )
           => ( ( ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                    @ ^ [X3: A] : X3 ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F6
                @ ^ [X3: A] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_6104_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( ( ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                  @ ^ [X3: A] : X3 ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F6
              @ ^ [X3: A] : ( ln_ln @ real @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_ln
thf(fact_6105_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F6: filter @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F6 @ F3 )
         => ( ( ( cos @ A
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                    @ ^ [X3: A] : X3 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F6
              @ ^ [X3: A] : ( tan @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_tan
thf(fact_6106_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F6: filter @ A,F3: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F6 @ F3 )
         => ( ( ( sin @ A
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                    @ ^ [X3: A] : X3 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F6
              @ ^ [X3: A] : ( cot @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_cot
thf(fact_6107_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F6: filter @ C,F3: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F6 @ F3 )
         => ( ( ( cosh @ A
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F6
                    @ ^ [X3: C] : X3 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F6
              @ ^ [X3: C] : ( tanh @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_6108_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                  @ ^ [X3: A] : X3 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F6
              @ ^ [X3: A] : ( arcosh @ real @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_6109_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S2: set @ A,F3: A > D,L6: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S2 )
           => ( ( topolo1002775350975398744n_open @ A @ S2 )
             => ( ( filterlim @ A @ D @ F3 @ ( topolo7230453075368039082e_nhds @ D @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
                = ( filterlim @ A @ D
                  @ ^ [H3: A] : ( F3 @ ( plus_plus @ A @ A2 @ H3 ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L6 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_6110_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F3
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                    @ ^ [X3: A] : X3 ) ) )
             => ( ( ( F3
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                      @ ^ [X3: A] : X3 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                        @ ^ [X3: A] : X3 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F6
                    @ ^ [X3: A] : ( log @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_6111_continuous__artanh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( ( member @ real
              @ ( F3
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F6
                  @ ^ [X3: A] : X3 ) )
              @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F6
              @ ^ [X3: A] : ( artanh @ real @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_artanh
thf(fact_6112_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_6113_tendsto__exp__limit__at__right,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y6: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y6 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y6 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_6114_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X ) @ ( set_ord_greaterThan @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% greaterThan_subset_iff
thf(fact_6115_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_6116_artanh__real__at__right__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ).

% artanh_real_at_right_1
thf(fact_6117_sinh__real__at__bot,axiom,
    filterlim @ real @ real @ ( sinh @ real ) @ ( at_bot @ real ) @ ( at_bot @ real ) ).

% sinh_real_at_bot
thf(fact_6118_arsinh__real__at__bot,axiom,
    filterlim @ real @ real @ ( arsinh @ real ) @ ( at_bot @ real ) @ ( at_bot @ real ) ).

% arsinh_real_at_bot
thf(fact_6119_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F3: real > A,F6: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F3 @ F6 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X3: real] : ( F3 @ ( plus_plus @ real @ X3 @ A2 ) )
        @ F6
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_6120_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_6121_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_6122_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_6123_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F3: B > A,P4: A,F14: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo174197925503356063within @ A @ P4 @ ( set_ord_greaterThan @ A @ P4 ) ) @ F14 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P4 ) )
             => ( filterlim @ B @ A
                @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F3 @ X3 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F14 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_6124_tanh__real__at__bot,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) @ ( at_bot @ real ) ).

% tanh_real_at_bot
thf(fact_6125_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F3: A > real,C2: real,F6: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F6 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F6 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
            @ ( at_bot @ real )
            @ F6 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_6126_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_6127_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F3: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X3: A] : ( if @ B @ ( ord_less_eq @ A @ X3 @ A2 ) @ ( G @ X3 ) @ ( F3 @ X3 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_6128_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F3: real > real,Flim: real] :
      ( ! [X4: real] :
          ( ( ord_less_eq @ real @ X4 @ B2 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) )
     => ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F3 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_6129_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F3: real > real,F6: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F3 @ ( at_bot @ real ) @ F6 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X3: real] : ( power_power @ real @ ( F3 @ X3 ) @ N )
            @ ( at_bot @ real )
            @ F6 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_6130_at__within__order,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,S: set @ A] :
          ( ( ( top_top @ ( set @ A ) )
           != ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ( topolo174197925503356063within @ A @ X @ S )
            = ( inf_inf @ ( filter @ A )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A4: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A4 ) @ S ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_greaterThan @ A @ X ) ) )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A4: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A4 ) @ S ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ) ).

% at_within_order
thf(fact_6131_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F3: real > real,F6: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F3 @ ( at_bot @ real ) @ F6 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X3: real] : ( power_power @ real @ ( F3 @ X3 ) @ N )
            @ ( at_top @ real )
            @ F6 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_6132_principal__le__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A3 ) @ ( principal @ A @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% principal_le_iff
thf(fact_6133_cosh__real__at__top,axiom,
    filterlim @ real @ real @ ( cosh @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% cosh_real_at_top
thf(fact_6134_sinh__real__at__top,axiom,
    filterlim @ real @ real @ ( sinh @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% sinh_real_at_top
thf(fact_6135_arcosh__real__at__top,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% arcosh_real_at_top
thf(fact_6136_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F6 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F6 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( times_times @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
          @ ( at_top @ real )
          @ F6 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_6137_arsinh__real__at__top,axiom,
    filterlim @ real @ real @ ( arsinh @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% arsinh_real_at_top
thf(fact_6138_ln__at__top,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% ln_at_top
thf(fact_6139_exp__at__top,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( at_top @ real ) @ ( at_top @ real ) ).

% exp_at_top
thf(fact_6140_cosh__real__at__bot,axiom,
    filterlim @ real @ real @ ( cosh @ real ) @ ( at_top @ real ) @ ( at_bot @ real ) ).

% cosh_real_at_bot
thf(fact_6141_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_6142_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F3: A > real,F6: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F6 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( power_power @ real @ ( F3 @ X3 ) @ N )
          @ ( at_top @ real )
          @ F6 ) ) ) ).

% filterlim_pow_at_top
thf(fact_6143_tanh__real__at__top,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) ) @ ( at_top @ real ) ).

% tanh_real_at_top
thf(fact_6144_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F3: A > real,C2: real,F6: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F6 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F6 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F6 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_6145_artanh__real__at__left__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_lessThan @ real @ ( one_one @ real ) ) ) ).

% artanh_real_at_left_1
thf(fact_6146_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F6 )
     => ( filterlim @ A @ real
        @ ^ [X3: A] : ( inverse_inverse @ real @ ( F3 @ X3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F6 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_6147_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_6148_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F3: A > real,C2: real,F6: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F6 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F6 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
            @ ( at_top @ real )
            @ F6 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_6149_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F3: A > real,C2: real,F6: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F6 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F6 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( G @ X3 ) @ ( F3 @ X3 ) )
            @ ( at_top @ real )
            @ F6 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_6150_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F3: A > real,F6: filter @ A] :
      ( ( ord_less @ real @ S @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F6 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( powr @ real @ ( F3 @ X3 ) @ S )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F6 ) ) ) ).

% tendsto_neg_powr
thf(fact_6151_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X3: real] : ( divide_divide @ real @ ( ln_ln @ real @ X3 ) @ X3 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_6152_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F3: real > A,F6: filter @ A] :
      ( ( filterlim @ real @ A @ F3 @ F6 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X3: real] : ( F3 @ ( inverse_inverse @ real @ X3 ) )
        @ F6
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_6153_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F3: real > A,F6: filter @ A] :
      ( ( filterlim @ real @ A @ F3 @ F6 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X3: real] : ( F3 @ ( inverse_inverse @ real @ X3 ) )
        @ F6
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_6154_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_6155_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_6156_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I5: set @ A,F6: A > ( set @ B ),F3: B > C,G6: D > ( set @ C ),J4: set @ D] :
      ( ( I5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I5 )
           => ! [J2: A] :
                ( ( member @ A @ J2 @ I5 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F6 @ I2 ) @ ( F6 @ J2 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F6 @ J2 ) @ ( F6 @ I2 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F3
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J3: D] : ( principal @ C @ ( G6 @ J3 ) )
                @ J4 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I3: A] : ( principal @ B @ ( F6 @ I3 ) )
                @ I5 ) ) )
          = ( ! [X3: D] :
                ( ( member @ D @ X3 @ J4 )
               => ? [Y6: A] :
                    ( ( member @ A @ Y6 @ I5 )
                    & ! [Z6: B] :
                        ( ( member @ B @ Z6 @ ( F6 @ Y6 ) )
                       => ( member @ C @ ( F3 @ Z6 ) @ ( G6 @ X3 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_6157_at__within__def,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo174197925503356063within @ A )
        = ( ^ [A4: A,S4: set @ A] : ( inf_inf @ ( filter @ A ) @ ( topolo7230453075368039082e_nhds @ A @ A4 ) @ ( principal @ A @ ( minus_minus @ ( set @ A ) @ S4 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% at_within_def
thf(fact_6158_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F3: A > real,C2: real,F6: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F6 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F6 )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( times_times @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
            @ ( at_bot @ real )
            @ F6 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_6159_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X3: real] : ( divide_divide @ real @ ( power_power @ real @ X3 @ K ) @ ( exp @ real @ X3 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_6160_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X3: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E3: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y6: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y6 @ X3 ) @ E3 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_6161_tendsto__exp__limit__at__top,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y6: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ Y6 ) ) @ Y6 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_6162_at__within__eq,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo174197925503356063within @ A )
        = ( ^ [X3: A,S4: set @ A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ ( set @ A ) @ ( filter @ A )
                @ ^ [S7: set @ A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S7 @ S4 ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                @ ( collect @ ( set @ A )
                  @ ^ [S7: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S7 )
                      & ( member @ A @ X3 @ S7 ) ) ) ) ) ) ) ) ).

% at_within_eq
thf(fact_6163_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_6164_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F3: real > real,Flim: real] :
      ( ! [X4: real] :
          ( ( ord_less_eq @ real @ B2 @ X4 )
         => ? [Y4: real] :
              ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F3 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_6165_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_6166_lhopital__left__at__top,axiom,
    ! [G: real > real,X: real,G5: real > real,F3: real > real,F9: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G5 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_6167_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G5: real > real,F3: real > real,F9: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G5 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_6168_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6169_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X4: A] :
              ( ( ord_less_eq @ A @ C2 @ X4 )
             => ( P @ X4 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_6170_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N7: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N7 @ N2 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_6171_le__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( filter @ A ) )
      = ( ^ [F10: filter @ A,F11: filter @ A] :
          ! [P6: A > $o] :
            ( ( eventually @ A @ P6 @ F11 )
           => ( eventually @ A @ P6 @ F10 ) ) ) ) ).

% le_filter_def
thf(fact_6172_filter__leI,axiom,
    ! [A: $tType,F13: filter @ A,F6: filter @ A] :
      ( ! [P9: A > $o] :
          ( ( eventually @ A @ P9 @ F13 )
         => ( eventually @ A @ P9 @ F6 ) )
     => ( ord_less_eq @ ( filter @ A ) @ F6 @ F13 ) ) ).

% filter_leI
thf(fact_6173_filter__leD,axiom,
    ! [A: $tType,F6: filter @ A,F13: filter @ A,P: A > $o] :
      ( ( ord_less_eq @ ( filter @ A ) @ F6 @ F13 )
     => ( ( eventually @ A @ P @ F13 )
       => ( eventually @ A @ P @ F6 ) ) ) ).

% filter_leD
thf(fact_6174_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N7: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N2 @ N7 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_6175_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X3: A] : ( ord_less_eq @ A @ X3 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_6176_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F3: A > B,F6: filter @ B,G6: filter @ A,F13: filter @ B,G7: filter @ A,F9: A > B] :
      ( ( filterlim @ A @ B @ F3 @ F6 @ G6 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F6 @ F13 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G7 @ G6 )
         => ( ( eventually @ A
              @ ^ [X3: A] :
                  ( ( F3 @ X3 )
                  = ( F9 @ X3 ) )
              @ G7 )
           => ( filterlim @ A @ B @ F9 @ F13 @ G7 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_6177_le__principal,axiom,
    ! [A: $tType,F6: filter @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F6 @ ( principal @ A @ A3 ) )
      = ( eventually @ A
        @ ^ [X3: A] : ( member @ A @ X3 @ A3 )
        @ F6 ) ) ).

% le_principal
thf(fact_6178_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F3: A > B,P: B > $o,G: B > A] :
          ( ! [X4: A,Y3: A] :
              ( ( Q @ X4 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X4 @ Y3 )
                 => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) ) ) )
         => ( ! [X4: B] :
                ( ( P @ X4 )
               => ( ( F3 @ ( G @ X4 ) )
                  = X4 ) )
           => ( ! [X4: B] :
                  ( ( P @ X4 )
                 => ( Q @ ( G @ X4 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6179_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F3: B > A,G: B > A,Net: filter @ B,H: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F3 @ N2 ) @ ( G @ N2 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N2: B] : ( ord_less_eq @ A @ ( G @ N2 ) @ ( H @ N2 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6180_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F6: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ F6 )
          = ( ! [Z10: B] :
                ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ B @ Z10 @ ( F3 @ X3 ) )
                @ F6 ) ) ) ) ).

% filterlim_at_top
thf(fact_6181_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F6: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ F6 )
          = ( ! [Z10: B] :
                ( ( ord_less_eq @ B @ C2 @ Z10 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ Z10 @ ( F3 @ X3 ) )
                  @ F6 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6182_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,F6: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F3 @ ( at_top @ A ) @ F6 )
         => ( ( eventually @ B
              @ ^ [X3: B] : ( ord_less_eq @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ F6 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F6 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6183_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F6: filter @ A] :
          ( ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ F6 )
          = ( ! [Z10: B] :
                ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ B @ ( F3 @ X3 ) @ Z10 )
                @ F6 ) ) ) ) ).

% filterlim_at_bot
thf(fact_6184_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F3: A > B,F6: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ F6 )
          = ( ! [Z10: B] :
                ( ( ord_less_eq @ B @ Z10 @ C2 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ ( F3 @ X3 ) @ Z10 )
                  @ F6 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_6185_real__tendsto__sandwich,axiom,
    ! [B: $tType,F3: B > real,G: B > real,Net: filter @ B,H: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N2: B] : ( ord_less_eq @ real @ ( F3 @ N2 ) @ ( G @ N2 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N2: B] : ( ord_less_eq @ real @ ( G @ N2 ) @ ( H @ N2 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_6186_eventually__Inf__base,axiom,
    ! [A: $tType,B4: set @ ( filter @ A ),P: A > $o] :
      ( ( B4
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F7: filter @ A] :
            ( ( member @ ( filter @ A ) @ F7 @ B4 )
           => ! [G3: filter @ A] :
                ( ( member @ ( filter @ A ) @ G3 @ B4 )
               => ? [X5: filter @ A] :
                    ( ( member @ ( filter @ A ) @ X5 @ B4 )
                    & ( ord_less_eq @ ( filter @ A ) @ X5 @ ( inf_inf @ ( filter @ A ) @ F7 @ G3 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B4 ) )
          = ( ? [X3: filter @ A] :
                ( ( member @ ( filter @ A ) @ X3 @ B4 )
                & ( eventually @ A @ P @ X3 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_6187_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
          = ( ? [D4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D4 ) )
                     => ( P @ X3 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_6188_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                & ! [X3: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D4 )
                   => ( P @ X3 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_6189_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X3: A] : ( P @ ( plus_plus @ A @ X3 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6190_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F3: B > A,L: A,F6: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F3 @ N2 ) @ L )
            @ F6 )
         => ( ! [X4: A] :
                ( ( ord_less @ A @ X4 @ L )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ X4 @ ( F3 @ N2 ) )
                  @ F6 ) )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 ) ) ) ) ).

% increasing_tendsto
thf(fact_6191_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F3: B > A,F6: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ L @ ( F3 @ N2 ) )
            @ F6 )
         => ( ! [X4: A] :
                ( ( ord_less @ A @ L @ X4 )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ ( F3 @ N2 ) @ X4 )
                  @ F6 ) )
           => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6192_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F3: A > B,F6: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ F6 )
          = ( ! [Z10: B] :
                ( ( ord_less @ B @ C2 @ Z10 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ Z10 @ ( F3 @ X3 ) )
                  @ F6 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6193_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F3: A > B,F6: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ F6 )
          = ( ! [Z10: B] :
                ( ( ord_less @ B @ Z10 @ C2 )
               => ( eventually @ A
                  @ ^ [X3: A] : ( ord_less_eq @ B @ ( F3 @ X3 ) @ Z10 )
                  @ F6 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_6194_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F6: filter @ B,F3: B > A,X: A,G: B > A,Y: A] :
          ( ( F6
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F6 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F6 )
             => ( ( eventually @ B
                  @ ^ [X3: B] : ( ord_less_eq @ A @ ( G @ X3 ) @ ( F3 @ X3 ) )
                  @ F6 )
               => ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6195_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: B > A,X: A,F6: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F6 )
         => ( ( eventually @ B
              @ ^ [I3: B] : ( ord_less_eq @ A @ A2 @ ( F3 @ I3 ) )
              @ F6 )
           => ( ( F6
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6196_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: B > A,X: A,F6: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F6 )
         => ( ( eventually @ B
              @ ^ [I3: B] : ( ord_less_eq @ A @ ( F3 @ I3 ) @ A2 )
              @ F6 )
           => ( ( F6
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6197_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F3: C > A,A2: A,F6: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( eventually @ C
              @ ^ [X3: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X3 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X3 ) @ A2 ) )
              @ F6 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F6 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_6198_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X3: real] : ( P @ ( plus_plus @ real @ X3 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_6199_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F6: B > ( filter @ A ),B4: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F6 @ B4 ) ) )
      = ( ? [X8: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X8 @ B4 )
            & ( finite_finite @ B @ X8 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F6 @ X8 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_6200_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F6: filter @ A,F3: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F6 @ F3 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F3 @ X3 ) )
              @ F6 )
           => ( topolo3448309680560233919inuous @ A @ real @ F6
              @ ^ [X3: A] : ( arcosh @ real @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6201_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
          = ( ? [D4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( ( X3 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D4 ) )
                     => ( P @ X3 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_6202_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F3: B > A,L: A,F6: filter @ B,E: real] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ( eventually @ B
              @ ^ [X3: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X3 ) @ L ) @ E )
              @ F6 ) ) ) ) ).

% tendstoD
thf(fact_6203_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F3: B > A,L: A,F6: filter @ B] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ( eventually @ B
                @ ^ [X3: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X3 ) @ L ) @ E2 )
                @ F6 ) )
         => ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 ) ) ) ).

% tendstoI
thf(fact_6204_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F3: B > A,L: A,F6: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F6 )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ( eventually @ B
                  @ ^ [X3: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ X3 ) @ L ) @ E3 )
                  @ F6 ) ) ) ) ) ).

% tendsto_iff
thf(fact_6205_eventually__Inf,axiom,
    ! [A: $tType,P: A > $o,B4: set @ ( filter @ A )] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B4 ) )
      = ( ? [X8: set @ ( filter @ A )] :
            ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X8 @ B4 )
            & ( finite_finite @ ( filter @ A ) @ X8 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ X8 ) ) ) ) ) ).

% eventually_Inf
thf(fact_6206_eventually__at__right__to__top,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X3: real] : ( P @ ( inverse_inverse @ real @ X3 ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_6207_eventually__at__top__to__right,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X3: real] : ( P @ ( inverse_inverse @ real @ X3 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_6208_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F3: B > real,A2: real,F6: filter @ B] :
      ( ( filterlim @ B @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X3: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F3 @ X3 ) )
            @ F6 )
         => ( filterlim @ B @ real
            @ ^ [X3: B] : ( arcosh @ real @ ( F3 @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F6 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_6209_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F3: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X4: A,Y3: A] :
              ( ( Q @ X4 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X4 @ Y3 )
                 => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) ) ) )
         => ( ! [X4: B] :
                ( ( P @ X4 )
               => ( ( F3 @ ( G @ X4 ) )
                  = X4 ) )
           => ( ! [X4: B] :
                  ( ( P @ X4 )
                 => ( Q @ ( G @ X4 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B5: A] :
                      ( ( Q @ B5 )
                     => ( ord_less @ A @ B5 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F3 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_6210_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B4: set @ A,F6: A > ( filter @ B ),P: B > $o] :
      ( ( B4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A5: A] :
            ( ( member @ A @ A5 @ B4 )
           => ! [B5: A] :
                ( ( member @ A @ B5 @ B4 )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ B4 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F6 @ X5 ) @ ( inf_inf @ ( filter @ B ) @ ( F6 @ A5 ) @ ( F6 @ B5 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F6 @ B4 ) ) )
          = ( ? [X3: A] :
                ( ( member @ A @ X3 @ B4 )
                & ( eventually @ B @ P @ ( F6 @ X3 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_6211_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F3: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X4: A,Y3: A] :
              ( ( Q @ X4 )
             => ( ( Q @ Y3 )
               => ( ( ord_less_eq @ A @ X4 @ Y3 )
                 => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) ) ) )
         => ( ! [X4: B] :
                ( ( P @ X4 )
               => ( ( F3 @ ( G @ X4 ) )
                  = X4 ) )
           => ( ! [X4: B] :
                  ( ( P @ X4 )
                 => ( Q @ ( G @ X4 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B5: A] :
                      ( ( Q @ B5 )
                     => ( ord_less @ A @ A2 @ B5 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F3 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_6212_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F6: filter @ A,G: A > C,K6: real] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) ) @ K6 ) )
              @ F6 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F6 ) ) ) ) ).

% tendsto_0_le
thf(fact_6213_filterlim__at__withinI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: B > A,C2: A,F6: filter @ B,A3: set @ A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F6 )
         => ( ( eventually @ B
              @ ^ [X3: B] : ( member @ A @ ( F3 @ X3 ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ) )
              @ F6 )
           => ( filterlim @ B @ A @ F3 @ ( topolo174197925503356063within @ A @ C2 @ A3 ) @ F6 ) ) ) ) ).

% filterlim_at_withinI
thf(fact_6214_tendsto__powr_H,axiom,
    ! [A: $tType,F3: A > real,A2: real,F6: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F6 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) )
                @ F6 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X3: A] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F6 ) ) ) ) ).

% tendsto_powr'
thf(fact_6215_tendsto__powr2,axiom,
    ! [A: $tType,F3: A > real,A2: real,F6: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F6 )
       => ( ( eventually @ A
            @ ^ [X3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) )
            @ F6 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X3: A] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F6 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_6216_tendsto__zero__powrI,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F6 )
       => ( ( eventually @ A
            @ ^ [X3: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) )
            @ F6 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X3: A] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F6 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_6217_LIM__at__top__divide,axiom,
    ! [A: $tType,F3: A > real,A2: real,F6: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F6 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 )
         => ( ( eventually @ A
              @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) )
              @ F6 )
           => ( filterlim @ A @ real
              @ ^ [X3: A] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( at_top @ real )
              @ F6 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_6218_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( eventually @ A
        @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) )
        @ F6 )
     => ( ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F6 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F3 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_6219_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( eventually @ A
        @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) )
        @ F6 )
     => ( ( filterlim @ A @ real
          @ ^ [X3: A] : ( inverse_inverse @ real @ ( F3 @ X3 ) )
          @ ( at_top @ real )
          @ F6 )
        = ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_6220_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) )
          @ F6 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( inverse_inverse @ real @ ( F3 @ X3 ) )
          @ ( at_top @ real )
          @ F6 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_6221_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F6 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( F3 @ X3 ) @ ( zero_zero @ real ) )
          @ F6 )
       => ( filterlim @ A @ real
          @ ^ [X3: A] : ( inverse_inverse @ real @ ( F3 @ X3 ) )
          @ ( at_bot @ real )
          @ F6 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_6222_lhopital,axiom,
    ! [F3: real > real,X: real,G: real > real,G5: real > real,F9: real > real,F6: filter @ real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G5 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_6223_lhopital__at__top,axiom,
    ! [G: real > real,X: real,G5: real > real,F3: real > real,F9: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G5 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_6224_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G5: real > real,F3: real > real,F9: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G5 @ X3 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_6225_lhopital__right,axiom,
    ! [F3: real > real,X: real,G: real > real,G5: real > real,F9: real > real,F6: filter @ real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G5 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_6226_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G5: real > real,F9: real > real,F6: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G0 @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G5 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F0 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G0 @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F0 @ X3 ) @ ( G0 @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_6227_lhopital__left,axiom,
    ! [F3: real > real,X: real,G: real > real,G5: real > real,F9: real > real,F6: filter @ real] :
      ( ( filterlim @ real @ real @ F3 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] :
                ( ( G @ X3 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] :
                  ( ( G5 @ X3 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                    @ F6
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_6228_lhopital__right__at__top,axiom,
    ! [G: real > real,X: real,G5: real > real,F3: real > real,F9: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X3: real] :
              ( ( G5 @ X3 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X3: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X3: real] : ( has_field_derivative @ real @ G @ ( G5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F9 @ X3 ) @ ( G5 @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X3: real] : ( divide_divide @ real @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_6229_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N: nat,B4: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N )
             => ( eventually @ A
                @ ^ [Z6: A] :
                    ( ord_less_eq @ real @ B4
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I3: nat] : ( times_times @ A @ ( C2 @ I3 ) @ ( power_power @ A @ Z6 @ I3 ) )
                        @ ( set_ord_atMost @ nat @ N ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_6230_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F10: filter @ A] :
            ? [Y6: B,K5: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
              & ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ X3 ) @ Y6 ) @ K5 )
                @ F10 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_6231_eventually__sequentially__Suc,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [I3: nat] : ( P @ ( suc @ I3 ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_Suc
thf(fact_6232_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N2: nat] : ( P @ ( plus_plus @ nat @ N2 @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_6233_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N2 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_6234_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X4: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X4 )
         => ( P @ X4 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6235_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N7: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ N7 @ N2 )
           => ( P @ N2 ) ) ) ) ).

% eventually_sequentially
thf(fact_6236_le__sequentially,axiom,
    ! [F6: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F6 @ ( at_top @ nat ) )
      = ( ! [N7: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N7 ) @ F6 ) ) ) ).

% le_sequentially
thf(fact_6237_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I3: nat] : ( P @ ( plus_plus @ nat @ I3 @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_6238_at__bot__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_bot @ real ) @ ( at_infinity @ real ) ).

% at_bot_le_at_infinity
thf(fact_6239_at__top__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_top @ real ) @ ( at_infinity @ real ) ).

% at_top_le_at_infinity
thf(fact_6240_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X3: nat] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_6241_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X3: nat] : ( plus_plus @ A @ ( F3 @ X3 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_6242_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X3: nat] : ( plus_plus @ A @ ( F3 @ X3 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_6243_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ).

% Bseq_Suc_iff
thf(fact_6244_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X9 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_6245_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X9: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X9 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_6246_filterlim__int__sequentially,axiom,
    filterlim @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( at_top @ int ) @ ( at_top @ nat ) ).

% filterlim_int_sequentially
thf(fact_6247_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A,K6: real] :
          ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N3 ) ) @ K6 )
         => ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_6248_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I4: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I4 ) )
             => ( ! [I4: nat] : ( member @ A @ X @ ( A8 @ I4 ) )
               => ~ ! [S9: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S9 )
                     => ( ( member @ A @ X @ S9 )
                       => ( eventually @ nat
                          @ ^ [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I3 ) @ S9 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_6249_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F3: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X3: nat] : ( times_times @ A @ C2 @ ( F3 @ X3 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_6250_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
              ! [X3: A] :
                ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
               => ( P @ X3 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_6251_tendsto__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( filterlim @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ).

% tendsto_of_nat
thf(fact_6252_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F6: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ F6 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F6 )
           => ( filterlim @ A @ B
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( at_infinity @ B )
              @ F6 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_6253_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,C2: B,F6: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F6 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F6 )
           => ( filterlim @ A @ B
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( at_infinity @ B )
              @ F6 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_6254_filterlim__int__of__nat__at__topD,axiom,
    ! [A: $tType,F3: int > A,F6: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X3: nat] : ( F3 @ ( semiring_1_of_nat @ int @ X3 ) )
        @ F6
        @ ( at_top @ nat ) )
     => ( filterlim @ int @ A @ F3 @ F6 @ ( at_top @ int ) ) ) ).

% filterlim_int_of_nat_at_topD
thf(fact_6255_Bseq__eq__bounded,axiom,
    ! [F3: nat > real,A2: real,B2: real] :
      ( ( ord_less_eq @ ( set @ real ) @ ( image @ nat @ real @ F3 @ ( top_top @ ( set @ nat ) ) ) @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
     => ( bfun @ nat @ real @ F3 @ ( at_top @ nat ) ) ) ).

% Bseq_eq_bounded
thf(fact_6256_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_6257_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ N2 ) ) @ ( G @ N2 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_6258_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [N4: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N4 ) ) @ K10 ) ) ) ) ).

% BseqD
thf(fact_6259_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
         => ~ ! [K10: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
               => ~ ! [N4: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N4 ) ) @ K10 ) ) ) ) ).

% BseqE
thf(fact_6260_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K6: real,X9: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
         => ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N3 ) ) @ K6 )
           => ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_6261_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [K5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
                & ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N2 ) ) @ K5 ) ) ) ) ) ).

% Bseq_def
thf(fact_6262_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [N7: nat] :
              ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_6263_Bseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_6264_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [N7: nat] :
              ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X9 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N7 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_6265_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: B > A,C2: A,F6: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F6 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F6 )
             => ( filterlim @ B @ A
                @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( at_infinity @ A )
                @ F6 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_6266_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: C > A,C2: A,F6: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F6 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F6 )
           => ( filterlim @ C @ A
              @ ^ [X3: C] : ( divide_divide @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F6 ) ) ) ) ).

% tendsto_divide_0
thf(fact_6267_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F3: A > B,F6: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F3 @ ( at_infinity @ B ) @ F6 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X3: A] : ( power_power @ B @ ( F3 @ X3 ) @ N )
              @ ( at_infinity @ B )
              @ F6 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_6268_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_6269_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P4: A > $o] :
          ( ( eventually @ A @ P4 @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B3 )
                & ! [X3: A] :
                    ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X3 ) )
                   => ( P4 @ X3 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_6270_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,K6: real,F6: filter @ A] :
          ( ( eventually @ A
            @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) ) @ K6 )
            @ F6 )
         => ( bfun @ A @ B @ F3 @ F6 ) ) ) ).

% BfunI
thf(fact_6271_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_infinity @ real ) @ F6 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) )
          @ F6 )
       => ( filterlim @ A @ real @ F3 @ ( at_top @ real ) @ F6 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_6272_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F3: A > real,F6: filter @ A] :
      ( ( filterlim @ A @ real @ F3 @ ( at_infinity @ real ) @ F6 )
     => ( ( eventually @ A
          @ ^ [X3: A] : ( ord_less @ real @ ( F3 @ X3 ) @ ( zero_zero @ real ) )
          @ F6 )
       => ( filterlim @ A @ real @ F3 @ ( at_bot @ real ) @ F6 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_6273_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G: A > B,F6: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X3: A] : ( inverse_inverse @ B @ ( G @ X3 ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F6 )
          = ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F6 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_6274_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [X3: A] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X9 @ N2 ) @ ( uminus_uminus @ A @ X3 ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_6275_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X9: nat > A] :
          ( ( bfun @ nat @ A @ X9 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [N7: nat] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X9 @ N2 ) @ ( uminus_uminus @ A @ ( X9 @ N7 ) ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_6276_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,C2: A,F6: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F6 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F6 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X3: A] : ( divide_divide @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( at_infinity @ A )
                @ F6 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_6277_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F3: C > A,F6: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F3 @ ( at_infinity @ A ) @ F6 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X3: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ X3 ) ) )
                    @ F6 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_6278_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F3: B > A,A2: A,F6: filter @ B] :
          ( ( filterlim @ B @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F6 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X3: B] : ( inverse_inverse @ A @ ( F3 @ X3 ) )
              @ F6 ) ) ) ) ).

% Bfun_inverse
thf(fact_6279_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_6280_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,L: A] :
          ( ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F3 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_6281_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X3: A] : ( F3 @ ( divide_divide @ A @ ( one_one @ A ) @ X3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_6282_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X3: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X3 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_6283_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F3: A > B,F6: filter @ A] :
          ( ( bfun @ A @ B @ F3 @ F6 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X3 ) ) @ B9 )
                    @ F6 ) ) ) ) ).

% BfunE
thf(fact_6284_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F10: filter @ A] :
            ? [K5: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
              & ( eventually @ A
                @ ^ [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X3 ) ) @ K5 )
                @ F10 ) ) ) ) ) ).

% Bfun_def
thf(fact_6285_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F3: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M3: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ M3 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N2 ) ) ) @ ( G @ M3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_Cauchy'
thf(fact_6286_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y8: set @ B,X9: set @ A,F6: filter @ B,F3: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ Y8 ) @ X9 )
     => ( ( eventually @ B
          @ ^ [X3: B] : ( member @ B @ X3 @ Y8 )
          @ F6 )
       => ( ( map_filter_on @ A @ C @ X9 @ F3 @ ( map_filter_on @ B @ A @ Y8 @ G @ F6 ) )
          = ( map_filter_on @ B @ C @ Y8 @ ( comp @ A @ C @ B @ F3 @ G ) @ F6 ) ) ) ) ).

% map_filter_on_comp
thf(fact_6287_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X3: A] :
              ! [Y6: A] :
                ( ( ord_less_eq @ A @ X3 @ Y6 )
               => ( P @ Y6 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_6288_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F3: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A4: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A4 )
               => ! [B3: nat] :
                    ( ( ord_less @ nat @ A4 @ B3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or3652927894154168847AtMost @ nat @ A4 @ B3 ) ) ) @ ( G @ A4 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F3 ) ) ) ) ).

% summable_bounded_partials
thf(fact_6289_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P6: A > $o] :
              ( the @ A
              @ ^ [X3: A] :
                  ( ( P6 @ X3 )
                  & ! [Y6: A] :
                      ( ( P6 @ Y6 )
                     => ( ord_less_eq @ A @ Y6 @ X3 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_6290_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_6291_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_6292_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_6293_card__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or3652927894154168847AtMost @ nat @ L @ U ) )
      = ( minus_minus @ nat @ U @ L ) ) ).

% card_greaterThanAtMost
thf(fact_6294_image__minus__const__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( minus_minus @ A @ C2 @ B2 ) @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_minus_const_greaterThanAtMost
thf(fact_6295_image__diff__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( minus_minus @ A @ C2 @ B2 ) @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_diff_atLeastLessThan
thf(fact_6296_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_6297_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_6298_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ L ) @ U )
      = ( set_or3652927894154168847AtMost @ nat @ L @ U ) ) ).

% atLeastSucAtMost_greaterThanAtMost
thf(fact_6299_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_6300_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_6301_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_1: nat] : ( P @ X_1 )
     => ( ! [Y3: nat] :
            ( ( P @ Y3 )
           => ( ord_less_eq @ nat @ Y3 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_6302_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_6303_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ Y @ X )
             => ? [B5: A] :
                  ( ( ord_less @ A @ B5 @ X )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B5 @ X ) @ S2 ) ) ) ) ) ) ).

% open_left
thf(fact_6304_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_6305_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ! [X4: A] :
                  ( ( P @ X4 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ( ord_less_eq @ A @ Y4 @ X4 ) )
                   => ( Q @ X4 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_6306_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.head
thf(fact_6307_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_6308_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_6309_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_6310_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_6311_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [A4: A,B3: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
thf(fact_6312_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ I ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_6313_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A5: A,B5: A,X4: A] :
              ( ( member @ A @ A5 @ S2 )
             => ( ( member @ A @ B5 @ S2 )
               => ( ( ord_less_eq @ A @ A5 @ X4 )
                 => ( ( ord_less_eq @ A @ X4 @ B5 )
                   => ( member @ A @ X4 @ S2 ) ) ) ) )
         => ? [A5: A,B5: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B5 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B5 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A5 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A5 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A5 @ B5 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A5 @ B5 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A5 @ B5 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A5 @ B5 ) ) ) ) ) ).

% interval_cases
thf(fact_6314_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F10: filter @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [P6: A > $o] :
                  ( ( eventually @ A @ P6 @ F10 )
                  & ! [X3: A,Y6: A] :
                      ( ( ( P6 @ X3 )
                        & ( P6 @ Y6 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y6 ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_6315_atLeast__0,axiom,
    ( ( set_ord_atLeast @ nat @ ( zero_zero @ nat ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% atLeast_0
thf(fact_6316_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I ) ) ) ).

% atLeast_iff
thf(fact_6317_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X ) @ ( set_ord_atLeast @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% atLeast_subset_iff
thf(fact_6318_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I ) ) ) ) ).

% image_add_atLeast
thf(fact_6319_card__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or3652927894154168847AtMost @ int @ L @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ L ) ) ) ).

% card_greaterThanAtMost_int
thf(fact_6320_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H: A,L3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H ) @ ( set_ord_atLeast @ A @ L3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H )
            | ( ord_less_eq @ A @ L3 @ L ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_6321_image__minus__const__AtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_ord_atMost @ A @ B2 ) )
          = ( set_ord_atLeast @ A @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% image_minus_const_AtMost
thf(fact_6322_image__minus__const__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_ord_atLeast @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_minus_const_atLeast
thf(fact_6323_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% Ioi_le_Ico
thf(fact_6324_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,L3: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H2 ) ) ) ).

% not_Ici_le_Icc
thf(fact_6325_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L4: A] : ( collect @ A @ ( ord_less_eq @ A @ L4 ) ) ) ) ) ).

% atLeast_def
thf(fact_6326_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L ) ) ) ).

% not_UNIV_le_Ici
thf(fact_6327_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_Ici_le_Iic
thf(fact_6328_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H: A,L3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H ) @ ( set_ord_atLeast @ A @ L3 ) ) ) ).

% not_Iic_le_Ici
thf(fact_6329_atLeast__Suc__greaterThan,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( set_ord_greaterThan @ nat @ K ) ) ).

% atLeast_Suc_greaterThan
thf(fact_6330_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_6331_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or3652927894154168847AtMost @ int @ L @ U ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
thf(fact_6332_nhds__imp__cauchy__filter,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [F6: filter @ A,X: A] :
          ( ( ord_less_eq @ ( filter @ A ) @ F6 @ ( topolo7230453075368039082e_nhds @ A @ X ) )
         => ( topolo6773858410816713723filter @ A @ F6 ) ) ) ).

% nhds_imp_cauchy_filter
thf(fact_6333_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_6334_complete__uniform,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo2479028161051973599mplete @ A )
        = ( ^ [S7: set @ A] :
            ! [F10: filter @ A] :
              ( ( ord_less_eq @ ( filter @ A ) @ F10 @ ( principal @ A @ S7 ) )
             => ( ( F10
                 != ( bot_bot @ ( filter @ A ) ) )
               => ( ( topolo6773858410816713723filter @ A @ F10 )
                 => ? [X3: A] :
                      ( ( member @ A @ X3 @ S7 )
                      & ( ord_less_eq @ ( filter @ A ) @ F10 @ ( topolo7230453075368039082e_nhds @ A @ X3 ) ) ) ) ) ) ) ) ) ).

% complete_uniform
thf(fact_6335_GMVT,axiom,
    ! [A2: real,B2: real,F3: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X4 )
              & ( ord_less_eq @ real @ X4 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) @ F3 ) )
       => ( ! [X4: real] :
              ( ( ( ord_less @ real @ A2 @ X4 )
                & ( ord_less @ real @ X4 @ B2 ) )
             => ( differentiable @ real @ real @ F3 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X4: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X4 )
                  & ( ord_less_eq @ real @ X4 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X4: real] :
                  ( ( ( ord_less @ real @ A2 @ X4 )
                    & ( ord_less @ real @ X4 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C4: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F3 @ F_c @ ( topolo174197925503356063within @ real @ C4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C4 )
                  & ( ord_less @ real @ C4 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_6336_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q2: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q2 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_6337_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q2: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q2 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_6338_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_6339_differentiable__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F6: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ F6 )
         => ( ( differentiable @ A @ B @ G @ F6 )
           => ( differentiable @ A @ B
              @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ F6 ) ) ) ) ).

% differentiable_diff
thf(fact_6340_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,F6: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ F6 )
         => ( ( differentiable @ A @ B @ G @ F6 )
           => ( differentiable @ A @ B
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ F6 ) ) ) ) ).

% differentiable_add
thf(fact_6341_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F3: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X3: A] : ( times_times @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_mult
thf(fact_6342_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X3: A] : ( divide_divide @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_6343_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,X: A,S: set @ A] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F3 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F3 @ X3 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_inverse
thf(fact_6344_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: A > B,X: A,S: set @ A,N: int] :
          ( ( differentiable @ A @ B @ F3 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F3 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X3: A] : ( power_int @ B @ ( F3 @ X3 ) @ N )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_power_int
thf(fact_6345_MVT,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X4: real] :
              ( ( ord_less @ real @ A2 @ X4 )
             => ( ( ord_less @ real @ X4 @ B2 )
               => ( differentiable @ real @ real @ F3 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L2: real,Z5: real] :
              ( ( ord_less @ real @ A2 @ Z5 )
              & ( ord_less @ real @ Z5 @ B2 )
              & ( has_field_derivative @ real @ F3 @ L2 @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L2 ) ) ) ) ) ) ).

% MVT
thf(fact_6346_eventually__filtercomap__at__topological,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ B )
     => ! [P: A > $o,F3: A > B,A3: B,B4: set @ B] :
          ( ( eventually @ A @ P @ ( filtercomap @ A @ B @ F3 @ ( topolo174197925503356063within @ B @ A3 @ B4 ) ) )
          = ( ? [S7: set @ B] :
                ( ( topolo1002775350975398744n_open @ B @ S7 )
                & ( member @ B @ A3 @ S7 )
                & ! [X3: A] :
                    ( ( member @ B @ ( F3 @ X3 ) @ ( minus_minus @ ( set @ B ) @ ( inf_inf @ ( set @ B ) @ S7 @ B4 ) @ ( insert @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                   => ( P @ X3 ) ) ) ) ) ) ).

% eventually_filtercomap_at_topological
thf(fact_6347_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( F3 @ X4 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X3: A] : ( ln_ln @ real @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_6348_continuous__on__cos__real,axiom,
    ! [A2: real,B2: real] : ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ ( cos @ real ) ) ).

% continuous_on_cos_real
thf(fact_6349_continuous__on__sin__real,axiom,
    ! [A2: real,B2: real] : ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ ( sin @ real ) ) ).

% continuous_on_sin_real
thf(fact_6350_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( F3 @ X4 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X3: A] : ( sgn_sgn @ B @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_6351_continuous__on__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F3: A > B,N: int] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( F3 @ X4 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X3: A] : ( power_int @ B @ ( F3 @ X3 ) @ N ) ) ) ) ) ).

% continuous_on_power_int
thf(fact_6352_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G )
           => ( ! [X4: A] :
                  ( ( member @ A @ X4 @ S )
                 => ( ( G @ X4 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X3: A] : ( divide_divide @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_6353_continuous__on__arsinh,axiom,
    ! [A3: set @ real] : ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( arsinh @ real ) ) ).

% continuous_on_arsinh
thf(fact_6354_continuous__on__sinh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ A3
            @ ^ [X3: C] : ( sinh @ A @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_sinh
thf(fact_6355_continuous__on__exp,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ S
            @ ^ [X3: C] : ( exp @ A @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_exp
thf(fact_6356_continuous__on__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ B @ S
            @ ^ [X3: A] : ( sin @ B @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_sin
thf(fact_6357_continuous__on__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ B )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ B @ S
            @ ^ [X3: A] : ( cos @ B @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_cos
thf(fact_6358_continuous__on__pochhammer,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A3: set @ A,N: nat] :
          ( topolo81223032696312382ous_on @ A @ A @ A3
          @ ^ [Z6: A] : ( comm_s3205402744901411588hammer @ A @ Z6 @ N ) ) ) ).

% continuous_on_pochhammer
thf(fact_6359_continuous__on__pochhammer_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ C,F3: C > A,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ S
            @ ^ [X3: C] : ( comm_s3205402744901411588hammer @ A @ ( F3 @ X3 ) @ N ) ) ) ) ).

% continuous_on_pochhammer'
thf(fact_6360_continuous__on__arctan,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X3: A] : ( arctan @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_arctan
thf(fact_6361_continuous__on__cosh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F3 )
         => ( topolo81223032696312382ous_on @ C @ A @ A3
            @ ^ [X3: C] : ( cosh @ A @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_cosh
thf(fact_6362_continuous__on__arsinh_H,axiom,
    ! [A3: set @ real,F3: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F3 )
     => ( topolo81223032696312382ous_on @ real @ real @ A3
        @ ^ [X3: real] : ( arsinh @ real @ ( F3 @ X3 ) ) ) ) ).

% continuous_on_arsinh'
thf(fact_6363_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S: set @ D,F3: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X3: D] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_6364_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_6365_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F3: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_6366_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F3: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F3 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_6367_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A3: set @ D,F3: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A3
              @ ^ [X3: D] : ( times_times @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_6368_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ D,F3: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S
              @ ^ [X3: D] : ( times_times @ A @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_6369_continuous__on__diff,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [S: set @ D,F3: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X3: D] : ( minus_minus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% continuous_on_diff
thf(fact_6370_continuous__on__op__minus,axiom,
    ! [A: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [S: set @ A,X: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( minus_minus @ A @ X ) ) ) ).

% continuous_on_op_minus
thf(fact_6371_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( F3 @ X4 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S
              @ ^ [X3: A] : ( inverse_inverse @ B @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_6372_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F3: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X4: C] :
                  ( ( member @ C @ X4 @ S )
                 => ( ( F3 @ X4 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X3: C] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_6373_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G: A > B,S: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F3 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F3 @ S ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X3: C] : ( G @ ( F3 @ X3 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_6374_filtercomap__mono,axiom,
    ! [B: $tType,A: $tType,F6: filter @ A,F13: filter @ A,F3: B > A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F6 @ F13 )
     => ( ord_less_eq @ ( filter @ B ) @ ( filtercomap @ B @ A @ F3 @ F6 ) @ ( filtercomap @ B @ A @ F3 @ F13 ) ) ) ).

% filtercomap_mono
thf(fact_6375_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,F3: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F3 ) ) ) ) ).

% continuous_on_subset
thf(fact_6376_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F3: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F3 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F3 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F3 )
               => ? [X4: A] :
                    ( ( ord_less_eq @ A @ A2 @ X4 )
                    & ( ord_less_eq @ A @ X4 @ B2 )
                    & ( ( F3 @ X4 )
                      = Y ) ) ) ) ) ) ) ).

% IVT'
thf(fact_6377_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F3: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F3 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F3 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F3 )
               => ? [X4: A] :
                    ( ( ord_less_eq @ A @ A2 @ X4 )
                    & ( ord_less_eq @ A @ X4 @ B2 )
                    & ( ( F3 @ X4 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_6378_filterlim__iff__le__filtercomap,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filterlim @ A @ B )
      = ( ^ [F5: A > B,F10: filter @ B,G8: filter @ A] : ( ord_less_eq @ ( filter @ A ) @ G8 @ ( filtercomap @ A @ B @ F5 @ F10 ) ) ) ) ).

% filterlim_iff_le_filtercomap
thf(fact_6379_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F3 @ A3 ) )
         => ( ! [X4: A,Y3: A] :
                ( ( member @ A @ X4 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( ord_less_eq @ A @ X4 @ Y3 )
                   => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A3 @ F3 ) ) ) ) ).

% continuous_onI_mono
thf(fact_6380_filtercomap__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType,F3: A > C,F6: B > ( filter @ C ),B4: set @ B] :
      ( ord_less_eq @ ( filter @ A )
      @ ( complete_Sup_Sup @ ( filter @ A )
        @ ( image @ B @ ( filter @ A )
          @ ^ [B3: B] : ( filtercomap @ A @ C @ F3 @ ( F6 @ B3 ) )
          @ B4 ) )
      @ ( filtercomap @ A @ C @ F3 @ ( complete_Sup_Sup @ ( filter @ C ) @ ( image @ B @ ( filter @ C ) @ F6 @ B4 ) ) ) ) ).

% filtercomap_SUP
thf(fact_6381_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F3: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( cos @ A @ ( F3 @ X4 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X3: A] : ( tan @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_6382_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: set @ A,F3: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( sin @ A @ ( F3 @ X4 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S
              @ ^ [X3: A] : ( cot @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_6383_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F3: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F3 )
         => ( ! [X4: C] :
                ( ( member @ C @ X4 @ A3 )
               => ( ( cosh @ A @ ( F3 @ X4 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A3
              @ ^ [X3: C] : ( tanh @ A @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_6384_continuous__on__arcosh_H,axiom,
    ! [A3: set @ real,F3: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F3 )
     => ( ! [X4: real] :
            ( ( member @ real @ X4 @ A3 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F3 @ X4 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X3: real] : ( arcosh @ real @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_6385_eventually__filtercomap__at__top__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F3: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F3 @ ( at_top @ A ) ) )
          = ( ? [N7: A] :
              ! [X3: B] :
                ( ( ord_less_eq @ A @ N7 @ ( F3 @ X3 ) )
               => ( P @ X3 ) ) ) ) ) ).

% eventually_filtercomap_at_top_linorder
thf(fact_6386_eventually__filtercomap__at__bot__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F3: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F3 @ ( at_bot @ A ) ) )
          = ( ? [N7: A] :
              ! [X3: B] :
                ( ( ord_less_eq @ A @ ( F3 @ X3 ) @ N7 )
               => ( P @ X3 ) ) ) ) ) ).

% eventually_filtercomap_at_bot_linorder
thf(fact_6387_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ? [C4: real,D6: real] :
            ( ( ( image @ real @ real @ F3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C4 @ D6 ) )
            & ( ord_less_eq @ real @ C4 @ D6 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_6388_continuous__on__arcosh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_6389_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S )
                = ( collect @ A
                  @ ^ [X3: A] :
                      ( ( member @ A @ X3 @ S )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X3 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_6390_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F3: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X4: C] :
                  ( ( member @ C @ X4 @ S )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X4 ) )
                    & ( ( ( F3 @ X4 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X4 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X3: C] : ( powr @ real @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_6391_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ( ! [X4: A] :
                  ( ( member @ A @ X4 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F3 @ X4 ) ) )
             => ( ! [X4: A] :
                    ( ( member @ A @ X4 @ S )
                   => ( ( F3 @ X4 )
                     != ( one_one @ real ) ) )
               => ( ! [X4: A] :
                      ( ( member @ A @ X4 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X4 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X3: A] : ( log @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_6392_continuous__on__arccos_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arccos ).

% continuous_on_arccos'
thf(fact_6393_continuous__on__arcsin_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arcsin ).

% continuous_on_arcsin'
thf(fact_6394_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F3 @ X4 ) )
                  & ( ord_less_eq @ real @ ( F3 @ X4 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X3: A] : ( arccos @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_6395_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F3: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F3 @ X4 ) )
                  & ( ord_less_eq @ real @ ( F3 @ X4 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X3: A] : ( arcsin @ ( F3 @ X3 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_6396_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F3: A > A] :
          ( ! [X4: A] :
              ( ( ord_less_eq @ A @ A2 @ X4 )
             => ( ( ord_less_eq @ A @ X4 @ B2 )
               => ? [Y4: A] : ( has_field_derivative @ A @ F3 @ Y4 @ ( topolo174197925503356063within @ A @ X4 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F3 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_6397_continuous__on__artanh_H,axiom,
    ! [A3: set @ real,F3: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F3 )
     => ( ! [X4: real] :
            ( ( member @ real @ X4 @ A3 )
           => ( member @ real @ ( F3 @ X4 ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X3: real] : ( artanh @ real @ ( F3 @ X3 ) ) ) ) ) ).

% continuous_on_artanh'
thf(fact_6398_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F3: real > real,F9: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F3 @ A2 )
          = ( F3 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ! [X4: real] :
                ( ( ord_less @ real @ A2 @ X4 )
               => ( ( ord_less @ real @ X4 @ B2 )
                 => ( has_derivative @ real @ real @ F3 @ ( F9 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z5: real] :
                ( ( ord_less @ real @ A2 @ Z5 )
                & ( ord_less @ real @ Z5 @ B2 )
                & ( ( F9 @ Z5 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_6399_mvt,axiom,
    ! [A2: real,B2: real,F3: real > real,F9: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X4: real] :
              ( ( ord_less @ real @ A2 @ X4 )
             => ( ( ord_less @ real @ X4 @ B2 )
               => ( has_derivative @ real @ real @ F3 @ ( F9 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) )
                   != ( F9 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_6400_continuous__on__of__int__floor,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X3: A] : ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ A @ X3 ) ) ) ) ).

% continuous_on_of_int_floor
thf(fact_6401_continuous__on__of__int__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X3: A] : ( ring_1_of_int @ B @ ( archimedean_ceiling @ A @ X3 ) ) ) ) ).

% continuous_on_of_int_ceiling
thf(fact_6402_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ord_less @ real @ A2 @ X4 )
           => ( ( ord_less @ real @ X4 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y4 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ord_less @ real @ ( F3 @ A2 ) @ ( F3 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_6403_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X4: real] :
            ( ( ord_less @ real @ A2 @ X4 )
           => ( ( ord_less @ real @ X4 @ B2 )
             => ? [Y4: real] :
                  ( ( has_field_derivative @ real @ F3 @ Y4 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y4 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ord_less @ real @ ( F3 @ B2 ) @ ( F3 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_6404_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X4: real] :
              ( ( ord_less @ real @ A2 @ X4 )
             => ( ( ord_less @ real @ X4 @ B2 )
               => ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F3 @ B2 )
            = ( F3 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_6405_continuous__on__artanh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_6406_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F3: real > real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
       => ( ! [X4: real] :
              ( ( ord_less @ real @ A2 @ X4 )
             => ( ( ord_less @ real @ X4 @ B2 )
               => ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X )
           => ( ( ord_less_eq @ real @ X @ B2 )
             => ( ( F3 @ X )
                = ( F3 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_6407_Rolle,axiom,
    ! [A2: real,B2: real,F3: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F3 @ A2 )
          = ( F3 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F3 )
         => ( ! [X4: real] :
                ( ( ord_less @ real @ A2 @ X4 )
               => ( ( ord_less @ real @ X4 @ B2 )
                 => ( differentiable @ real @ real @ F3 @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z5: real] :
                ( ( ord_less @ real @ A2 @ Z5 )
                & ( ord_less @ real @ Z5 @ B2 )
                & ( has_field_derivative @ real @ F3 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_6408_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E3: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X3: A,Y6: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y6 ) @ E3 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_6409_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X3: complex,Y6: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X3 @ Y6 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_6410_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [P6: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ P6 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [N7: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N2 )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ M3 )
                     => ( P6 @ ( product_Pair @ A @ A @ ( X8 @ N2 ) @ ( X8 @ M3 ) ) ) ) ) ) ) ) ) ).

% Cauchy_uniform_iff
thf(fact_6411_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                & ! [X3: A,Y6: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y6 ) @ E3 )
                   => ( P @ ( product_Pair @ A @ A @ X3 @ Y6 ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_6412_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X3: real,Y6: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X3 @ Y6 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_6413_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,C5: set @ B,F3: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C5 )
               => ( topolo1002775350975398744n_open @ A @ ( F3 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ C5 ) ) )
             => ~ ! [C8: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C8 @ C5 )
                   => ( ( finite_finite @ B @ C8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ C8 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_6414_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S7: set @ A] :
            ! [C9: set @ ( set @ A )] :
              ( ( ! [X3: set @ A] :
                    ( ( member @ ( set @ A ) @ X3 @ C9 )
                   => ( topolo1002775350975398744n_open @ A @ X3 ) )
                & ( ord_less_eq @ ( set @ A ) @ S7 @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) )
             => ? [D7: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D7 @ C9 )
                  & ( finite_finite @ ( set @ A ) @ D7 )
                  & ( ord_less_eq @ ( set @ A ) @ S7 @ ( complete_Sup_Sup @ ( set @ A ) @ D7 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_6415_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ S2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S2 )
                   => ( ord_less_eq @ A @ X4 @ Xa2 ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_6416_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X4: A] :
                ( ( member @ A @ X4 @ S2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S2 )
                   => ( ord_less_eq @ A @ Xa2 @ X4 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_6417_compact__diff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ T5 )
           => ( topolo2193935891317330818ompact @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) ) ) ) ) ).

% compact_diff
thf(fact_6418_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
             => ? [X4: A] :
                  ( ( member @ A @ X4 @ S )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                     => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Xa2 ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_6419_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F3: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
             => ? [X4: A] :
                  ( ( member @ A @ X4 @ S )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                     => ( ord_less_eq @ B @ ( F3 @ Xa2 ) @ ( F3 @ X4 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_6420_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B9: set @ A] :
                  ( ( member @ ( set @ A ) @ B9 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B9 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_6421_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( ! [C7: set @ ( set @ A )] :
              ( ! [X5: set @ A] :
                  ( ( member @ ( set @ A ) @ X5 @ C7 )
                 => ( topolo1002775350975398744n_open @ A @ X5 ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C7 ) )
               => ? [C10: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C10 @ C7 )
                    & ( finite_finite @ ( set @ A ) @ C10 )
                    & ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C10 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S ) ) ) ).

% compactI
thf(fact_6422_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I5: set @ B,F3: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I5 )
               => ( topolo7761053866217962861closed @ A @ ( F3 @ I2 ) ) )
           => ( ! [I8: set @ B] :
                  ( ( finite_finite @ B @ I8 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I8 @ I5 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ I8 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F3 @ I5 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_6423_inj__sgn__power,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( inj_on @ real @ real
        @ ^ [Y6: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y6 ) @ ( power_power @ real @ ( abs_abs @ real @ Y6 ) @ N ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_6424_open__Diff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T5 )
           => ( topolo1002775350975398744n_open @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) ) ) ) ) ).

% open_Diff
thf(fact_6425_closed__Diff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ T5 )
           => ( topolo7761053866217962861closed @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) ) ) ) ) ).

% closed_Diff
thf(fact_6426_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_6427_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B3: A] : ( divide_divide @ A @ B3 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_6428_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A2: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( insert @ A @ A2 @ A3 ) )
      = ( ( inj_on @ A @ B @ F3 @ A3 )
        & ~ ( member @ B @ ( F3 @ A2 ) @ ( image @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inj_on_insert
thf(fact_6429_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F3: B > A,T5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( image @ B @ A @ F3 @ T5 ) )
      = ( ? [U4: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U4 @ T5 )
            & ( inj_on @ B @ A @ F3 @ U4 )
            & ( S2
              = ( image @ B @ A @ F3 @ U4 ) ) ) ) ) ).

% subset_image_inj
thf(fact_6430_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
         => ( ( ( image @ A @ B @ F3 @ A3 )
              = ( image @ A @ B @ F3 @ B4 ) )
            = ( A3 = B4 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_6431_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,B4: set @ A,A2: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ B4 )
     => ( ( member @ A @ A2 @ B4 )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( member @ B @ ( F3 @ A2 ) @ ( image @ A @ B @ F3 @ A3 ) )
            = ( member @ A @ A2 @ A3 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_6432_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,F3: A > B] :
          ( ! [X4: A,Y3: A] :
              ( ( ord_less @ A @ X4 @ Y3 )
             => ( ( member @ A @ X4 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( F3 @ X4 )
                   != ( F3 @ Y3 ) ) ) ) )
         => ( ! [X4: A,Y3: A] :
                ( ( member @ A @ X4 @ A3 )
               => ( ( member @ A @ Y3 @ A3 )
                 => ( ( ord_less_eq @ A @ X4 @ Y3 )
                    | ( ord_less_eq @ A @ Y3 @ X4 ) ) ) )
           => ( inj_on @ A @ B @ F3 @ A3 ) ) ) ) ).

% linorder_inj_onI
thf(fact_6433_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( inj_on @ A @ B @ F3 @ B4 ) ) ) ).

% inj_on_subset
thf(fact_6434_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F3: A > B,B4: set @ A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( inj_on @ A @ B @ F3 @ A3 ) ) ) ).

% subset_inj_on
thf(fact_6435_inj__fn,axiom,
    ! [A: $tType,F3: A > A,N: nat] :
      ( ( inj_on @ A @ A @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_6436_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_6437_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B3: A] : ( plus_plus @ A @ B3 @ A2 )
          @ A3 ) ) ).

% inj_on_add'
thf(fact_6438_inj__on__diff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( inj_on @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% inj_on_diff
thf(fact_6439_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 ) ) ).

% inj_on_add
thf(fact_6440_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A3 ) ) ) ).

% inj_on_mult
thf(fact_6441_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( inj_on @ A @ A
          @ ^ [B3: A] : ( minus_minus @ A @ B3 @ A2 )
          @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_diff_right
thf(fact_6442_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ ( image @ A @ B @ F3 @ B4 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% inj_image_subset_iff
thf(fact_6443_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,A9: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F5: A > B] :
              ( ( inj_on @ A @ B @ F5 @ A3 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ A9 ) ) )
        = ( ? [G2: B > A] :
              ( ( image @ B @ A @ G2 @ A9 )
              = A3 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_6444_finite__surj__inj,axiom,
    ! [A: $tType,A3: set @ A,F3: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ A @ A @ F3 @ A3 ) )
       => ( inj_on @ A @ A @ F3 @ A3 ) ) ) ).

% finite_surj_inj
thf(fact_6445_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,B4: set @ B] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B4 )
       => ( ( finite_finite @ B @ B4 )
         => ( finite_finite @ A @ A3 ) ) ) ) ).

% inj_on_finite
thf(fact_6446_endo__inj__surj,axiom,
    ! [A: $tType,A3: set @ A,F3: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F3 @ A3 ) @ A3 )
       => ( ( inj_on @ A @ A @ F3 @ A3 )
         => ( ( image @ A @ A @ F3 @ A3 )
            = A3 ) ) ) ) ).

% endo_inj_surj
thf(fact_6447_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F3: A > B,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
         => ( ( image @ A @ B @ F3 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ ( image @ A @ B @ F3 @ B4 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_6448_image__set__diff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ ( image @ A @ B @ F3 @ B4 ) ) ) ) ).

% image_set_diff
thf(fact_6449_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F3: A > B,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C5 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
         => ( ( image @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ ( image @ A @ B @ F3 @ B4 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_6450_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,X: B,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ( member @ B @ X @ ( image @ A @ B @ F3 @ A3 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( member @ A @ ( the_inv_into @ A @ B @ A3 @ F3 @ X ) @ B4 ) ) ) ) ).

% the_inv_into_into
thf(fact_6451_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_6452_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B ),F3: B > C] :
      ( ! [I2: A,J2: A] :
          ( ( member @ A @ I2 @ I5 )
         => ( ( member @ A @ J2 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I2 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I5 )
           => ( inj_on @ B @ C @ F3 @ ( A3 @ I2 ) ) )
       => ( inj_on @ B @ C @ F3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I5 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_6453_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X3: A] : ( ord_less_eq @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_6454_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ A,B4: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B4 )
       => ( ( inj_on @ B @ A @ G @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B4 ) @ A3 )
           => ( ( finite_finite @ A @ A3 )
             => ( ( finite_finite @ B @ B4 )
               => ( ( finite_card @ A @ A3 )
                  = ( finite_card @ B @ B4 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_6455_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,T5: set @ B,F3: A > B] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T5 )
       => ( ( ( finite_card @ A @ S2 )
            = ( finite_card @ B @ T5 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ S2 ) @ T5 )
           => ( ( ! [X3: B] :
                    ( ( member @ B @ X3 @ T5 )
                   => ? [Y6: A] :
                        ( ( member @ A @ Y6 @ S2 )
                        & ( ( F3 @ Y6 )
                          = X3 ) ) ) )
              = ( inj_on @ A @ B @ F3 @ S2 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_6456_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_6457_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S2: set @ A,Y: A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ~ ( member @ A @ Y @ S2 )
           => ? [U5: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U5 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member @ A @ Y @ U5 )
                & ( ord_less_eq @ ( set @ A ) @ S2 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_6458_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T5 )
           => ( ( ( inf_inf @ ( set @ A ) @ S2 @ T5 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U5: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U5 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ U5 )
                  & ( ord_less_eq @ ( set @ A ) @ T5 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_6459_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: A > B,C5: set @ A,A3: set @ C,B4: C > ( set @ A ),J: C] :
      ( ( inj_on @ A @ B @ F3 @ C5 )
     => ( ! [X4: C] :
            ( ( member @ C @ X4 @ A3 )
           => ( ord_less_eq @ ( set @ A ) @ ( B4 @ X4 ) @ C5 ) )
       => ( ( member @ C @ J @ A3 )
         => ( ( image @ A @ B @ F3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B4 @ A3 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X3: C] : ( image @ A @ B @ F3 @ ( B4 @ X3 ) )
                @ A3 ) ) ) ) ) ) ).

% image_INT
thf(fact_6460_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ( topolo1002775350975398744n_open @ A @ A3 )
           => ? [A15: set @ A] :
                ( ( member @ A @ X @ A15 )
                & ( topolo7761053866217962861closed @ A @ A15 )
                & ( ord_less_eq @ ( set @ A ) @ A15 @ A3 )
                & ( eventually @ A
                  @ ^ [Y6: A] : ( member @ A @ Y6 @ A15 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X ) ) ) ) ) ) ).

% nhds_closed
thf(fact_6461_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) )
         => ? [F4: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F4 @ A3 ) @ B4 )
              & ( inj_on @ A @ B @ F4 @ A3 ) ) ) ) ) ).

% card_le_inj
thf(fact_6462_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ A,B4: set @ B] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B4 )
       => ( ( finite_finite @ B @ B4 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_6463_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B4 )
       => ( ( ? [F5: A > B] :
                ( ( inj_on @ A @ B @ F5 @ A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ B4 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_6464_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_6465_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F6: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: set @ A] :
                ( ( member @ ( set @ A ) @ T7 @ F6 )
               => ( topolo7761053866217962861closed @ A @ T7 ) )
           => ( ! [F17: set @ ( set @ A )] :
                  ( ( finite_finite @ ( set @ A ) @ F17 )
                 => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F17 @ F6 )
                   => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F17 ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F6 ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip
thf(fact_6466_compact__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [U4: set @ A] :
            ! [A6: set @ ( set @ A )] :
              ( ! [X3: set @ A] :
                  ( ( member @ ( set @ A ) @ X3 @ A6 )
                 => ( topolo7761053866217962861closed @ A @ X3 ) )
             => ( ! [B6: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B6 @ A6 )
                   => ( ( finite_finite @ ( set @ A ) @ B6 )
                     => ( ( inf_inf @ ( set @ A ) @ U4 @ ( complete_Inf_Inf @ ( set @ A ) @ B6 ) )
                       != ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( inf_inf @ ( set @ A ) @ U4 @ ( complete_Inf_Inf @ ( set @ A ) @ A6 ) )
                 != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% compact_fip
thf(fact_6467_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ A,B4: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B4 )
       => ( ( inj_on @ B @ A @ G @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B4 ) @ A3 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A3 @ B4 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_6468_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F3 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( inj_on @ B @ A @ F3 @ T9 )
            & ( P @ ( image @ B @ A @ F3 @ T9 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_6469_inj__on__diff__nat,axiom,
    ! [N6: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member @ nat @ N3 @ N6 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ K )
        @ N6 ) ) ).

% inj_on_diff_nat
thf(fact_6470_inj__int__encode,axiom,
    ! [A3: set @ int] : ( inj_on @ int @ nat @ nat_int_encode @ A3 ) ).

% inj_int_encode
thf(fact_6471_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_6472_inj__on__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N6: set @ nat] : ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ N6 ) ) ).

% inj_on_of_nat
thf(fact_6473_inj__Suc,axiom,
    ! [N6: set @ nat] : ( inj_on @ nat @ nat @ suc @ N6 ) ).

% inj_Suc
thf(fact_6474_inj__prod__encode,axiom,
    ! [A3: set @ ( product_prod @ nat @ nat )] : ( inj_on @ ( product_prod @ nat @ nat ) @ nat @ nat_prod_encode @ A3 ) ).

% inj_prod_encode
thf(fact_6475_inj__on__set__encode,axiom,
    inj_on @ ( set @ nat ) @ nat @ nat_set_encode @ ( collect @ ( set @ nat ) @ ( finite_finite @ nat ) ) ).

% inj_on_set_encode
thf(fact_6476_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X8: $o > A,Y9: $o > A] :
              ( ( ord_less_eq @ A @ ( X8 @ $false ) @ ( Y9 @ $false ) )
              & ( ord_less_eq @ A @ ( X8 @ $true ) @ ( Y9 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_6477_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ~ ( finite_finite @ A @ S2 ) )
      = ( ? [F5: nat > A] :
            ( ( inj_on @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_6478_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ? [F4: nat > A] :
          ( ( inj_on @ nat @ A @ F4 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F4 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ).

% infinite_countable_subset
thf(fact_6479_summable__reindex,axiom,
    ! [F3: nat > real,G: nat > nat] :
      ( ( summable @ real @ F3 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X4 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F3 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_6480_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F3: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N @ F3 @ S )
        = S )
     => ( ! [M2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
           => ( ( ord_less @ nat @ M2 @ N )
             => ( ( compow @ ( A > A ) @ M2 @ F3 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K2: nat] : ( compow @ ( A > A ) @ K2 @ F3 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_6481_suminf__reindex__mono,axiom,
    ! [F3: nat > real,G: nat > nat] :
      ( ( summable @ real @ F3 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X4 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F3 @ G ) ) @ ( suminf @ real @ F3 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_6482_suminf__reindex,axiom,
    ! [F3: nat > real,G: nat > nat] :
      ( ( summable @ real @ F3 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X4 ) )
         => ( ! [X4: nat] :
                ( ~ ( member @ nat @ X4 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F3 @ X4 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F3 @ G ) )
              = ( suminf @ real @ F3 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_6483_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F3 @ S2 ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
              & ( inj_on @ B @ A @ F3 @ T9 ) )
           => ( P @ ( image @ B @ A @ F3 @ T9 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_6484_surj__int__decode,axiom,
    ( ( image @ nat @ int @ nat_int_decode @ ( top_top @ ( set @ nat ) ) )
    = ( top_top @ ( set @ int ) ) ) ).

% surj_int_decode
thf(fact_6485_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_6486_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            & ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% le_sup_iff
thf(fact_6487_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_6488_Un__subset__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
        & ( ord_less_eq @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Un_subset_iff
thf(fact_6489_Un__Diff__cancel,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ).

% Un_Diff_cancel
thf(fact_6490_Un__Diff__cancel2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) @ A3 )
      = ( sup_sup @ ( set @ A ) @ B4 @ A3 ) ) ).

% Un_Diff_cancel2
thf(fact_6491_int__decode__inverse,axiom,
    ! [N: nat] :
      ( ( nat_int_encode @ ( nat_int_decode @ N ) )
      = N ) ).

% int_decode_inverse
thf(fact_6492_int__encode__inverse,axiom,
    ! [X: int] :
      ( ( nat_int_decode @ ( nat_int_encode @ X ) )
      = X ) ).

% int_encode_inverse
thf(fact_6493_Compl__Diff__eq,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ B4 ) ) ).

% Compl_Diff_eq
thf(fact_6494_inj__int__decode,axiom,
    ! [A3: set @ nat] : ( inj_on @ nat @ int @ nat_int_decode @ A3 ) ).

% inj_int_decode
thf(fact_6495_sup__Inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A2: A,B4: set @ A] :
          ( ( sup_sup @ A @ A2 @ ( complete_Inf_Inf @ A @ B4 ) )
          = ( complete_Inf_Inf @ A @ ( image @ A @ A @ ( sup_sup @ A @ A2 ) @ B4 ) ) ) ) ).

% sup_Inf
thf(fact_6496_Inf__sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B4: set @ A,A2: A] :
          ( ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ B4 ) @ A2 )
            = ( top_top @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ B4 )
               => ( ( sup_sup @ A @ X3 @ A2 )
                  = ( top_top @ A ) ) ) ) ) ) ).

% Inf_sup_eq_top_iff
thf(fact_6497_INF__sup__distrib2,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,A3: set @ B,G: C > A,B4: set @ C] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B4 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [A4: B] :
                  ( complete_Inf_Inf @ A
                  @ ( image @ C @ A
                    @ ^ [B3: C] : ( sup_sup @ A @ ( F3 @ A4 ) @ ( G @ B3 ) )
                    @ B4 ) )
              @ A3 ) ) ) ) ).

% INF_sup_distrib2
thf(fact_6498_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A2: A,F3: B > A,B4: set @ B] :
          ( ( sup_sup @ A @ A2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ B4 ) ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [B3: B] : ( sup_sup @ A @ A2 @ ( F3 @ B3 ) )
              @ B4 ) ) ) ) ).

% sup_INF
thf(fact_6499_Inf__sup,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [B4: set @ A,A2: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ B4 ) @ A2 )
          = ( complete_Inf_Inf @ A
            @ ( image @ A @ A
              @ ^ [B3: A] : ( sup_sup @ A @ B3 @ A2 )
              @ B4 ) ) ) ) ).

% Inf_sup
thf(fact_6500_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [F3: B > A,B4: set @ B,A2: A] :
          ( ( sup_sup @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ B4 ) ) @ A2 )
          = ( complete_Inf_Inf @ A
            @ ( image @ B @ A
              @ ^ [B3: B] : ( sup_sup @ A @ ( F3 @ B3 ) @ A2 )
              @ B4 ) ) ) ) ).

% INF_sup
thf(fact_6501_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_6502_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ C5 )
        = ( inf_inf @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C5 @ A3 ) ) ).

% Un_Int_assoc_eq
thf(fact_6503_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_6504_Un__mono,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A,D3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ D3 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ ( sup_sup @ ( set @ A ) @ C5 @ D3 ) ) ) ) ).

% Un_mono
thf(fact_6505_Un__least,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ C5 ) ) ) ).

% Un_least
thf(fact_6506_Un__upper1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ).

% Un_upper1
thf(fact_6507_Un__upper2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ B4 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ).

% Un_upper2
thf(fact_6508_Un__absorb1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B4 )
        = B4 ) ) ).

% Un_absorb1
thf(fact_6509_Un__absorb2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B4 )
        = A3 ) ) ).

% Un_absorb2
thf(fact_6510_subset__UnE,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ! [A15: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A15 @ A3 )
           => ! [B13: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B13 @ B4 )
               => ( C5
                 != ( sup_sup @ ( set @ A ) @ A15 @ B13 ) ) ) ) ) ).

% subset_UnE
thf(fact_6511_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: set @ A,B6: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A6 @ B6 )
            = B6 ) ) ) ).

% subset_Un_eq
thf(fact_6512_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_6513_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_6514_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_6515_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_6516_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_6517_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_6518_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% sup.order_iff
thf(fact_6519_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_6520_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_6521_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_6522_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) ).

% sup_absorb1
thf(fact_6523_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_6524_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_6525_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F3: A > A > A,X: A,Y: A] :
          ( ! [X4: A,Y3: A] : ( ord_less_eq @ A @ X4 @ ( F3 @ X4 @ Y3 ) )
         => ( ! [X4: A,Y3: A] : ( ord_less_eq @ A @ Y3 @ ( F3 @ X4 @ Y3 ) )
           => ( ! [X4: A,Y3: A,Z5: A] :
                  ( ( ord_less_eq @ A @ Y3 @ X4 )
                 => ( ( ord_less_eq @ A @ Z5 @ X4 )
                   => ( ord_less_eq @ A @ ( F3 @ Y3 @ Z5 ) @ X4 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F3 @ X @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_6526_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_6527_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_6528_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y6: A] :
              ( ( sup_sup @ A @ X3 @ Y6 )
              = Y6 ) ) ) ) ).

% le_iff_sup
thf(fact_6529_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z ) @ X ) ) ) ) ).

% sup_least
thf(fact_6530_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_6531_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_6532_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_6533_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_6534_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge2
thf(fact_6535_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge1
thf(fact_6536_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_6537_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_6538_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_6539_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_6540_Un__Pow__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A3 ) @ ( pow2 @ A @ B4 ) ) @ ( pow2 @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% Un_Pow_subset
thf(fact_6541_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% distrib_sup_le
thf(fact_6542_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% distrib_inf_le
thf(fact_6543_Diff__subset__conv,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Diff_subset_conv
thf(fact_6544_Diff__partition,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
        = B4 ) ) ).

% Diff_partition
thf(fact_6545_Un__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ C5 ) @ ( minus_minus @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Un_Diff
thf(fact_6546_int__decode__eq,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( nat_int_decode @ X )
        = ( nat_int_decode @ Y ) )
      = ( X = Y ) ) ).

% int_decode_eq
thf(fact_6547_Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) )
      = ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% Diff_Un
thf(fact_6548_Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% Diff_Int
thf(fact_6549_Int__Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = A3 ) ).

% Int_Diff_Un
thf(fact_6550_Un__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = A3 ) ).

% Un_Diff_Int
thf(fact_6551_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_6552_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% sup_shunt
thf(fact_6553_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P4: A,Q2: A,R: A] :
          ( ( ord_less_eq @ A @ P4 @ ( sup_sup @ A @ Q2 @ R ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P4 @ ( uminus_uminus @ A @ Q2 ) ) @ R ) ) ) ).

% sup_neg_inf
thf(fact_6554_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% shunt2
thf(fact_6555_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z ) ) ) ) ).

% shunt1
thf(fact_6556_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_6557_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_6558_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_6559_card__Un__le,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ).

% card_Un_le
thf(fact_6560_atLeastLessThan__add__Un,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_6561_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_6562_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_6563_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_6564_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_6565_Inter__Un__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B4 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B4 ) ) ) ).

% Inter_Un_subset
thf(fact_6566_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_6567_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_6568_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_6569_infinite__imp__bij__betw2,axiom,
    ! [A: $tType,A3: set @ A,A2: A] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [H4: A > A] : ( bij_betw @ A @ A @ H4 @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw2
thf(fact_6570_card__Un__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_6571_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_6572_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_6573_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_6574_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_6575_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_6576_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B4: A] :
          ( ( sup_sup @ A @ A3
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X3: nat] : B4
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A3 @ B4 ) ) ) ).

% SUP_nat_binary
thf(fact_6577_bij__int__decode,axiom,
    bij_betw @ nat @ int @ nat_int_decode @ ( top_top @ ( set @ nat ) ) @ ( top_top @ ( set @ int ) ) ).

% bij_int_decode
thf(fact_6578_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 )
        @ ^ [X3: A,Y6: A] : ( ord_less @ A @ Y6 @ X3 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_6579_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( G @ X4 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_6580_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B4: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_6581_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_6582_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( G @ X4 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_6583_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_6584_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_6585_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A3: set @ A,B4: set @ A,F3: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_6586_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_6587_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_6588_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_6589_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( inj_on @ A @ B @ F3 @ A3 )
        & ( inj_on @ A @ B @ F3 @ B4 )
        & ( ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( image @ A @ B @ F3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) )
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% inj_on_Un
thf(fact_6590_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_6591_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_6592_sum__Un__nat,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_6593_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_6594_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A3: set @ B,B4: set @ B,F3: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( F3 @ X4 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_6595_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C5: set @ A,B4: set @ A,X: A] :
      ( ( inj_on @ A @ B @ G @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ C5 @ ( sup_sup @ ( set @ A ) @ B4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I3: B] : ( if @ A @ ( member @ B @ I3 @ ( image @ A @ B @ G @ C5 ) ) @ ( the_inv_into @ A @ B @ C5 @ G @ I3 ) @ X )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_6596_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A3: B > ( set @ A ),I: B,B4: set @ A,J4: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ ( fun_upd @ B @ ( set @ A ) @ A3 @ I @ B4 ) @ J4 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ B ) @ J4 @ ( insert @ B @ I @ ( bot_bot @ ( set @ B ) ) ) ) ) ) @ ( if @ ( set @ A ) @ ( member @ B @ I @ J4 ) @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% UNION_fun_upd
thf(fact_6597_filtercomap__sup,axiom,
    ! [A: $tType,B: $tType,F3: A > B,F14: filter @ B,F23: filter @ B] : ( ord_less_eq @ ( filter @ A ) @ ( sup_sup @ ( filter @ A ) @ ( filtercomap @ A @ B @ F3 @ F14 ) @ ( filtercomap @ A @ B @ F3 @ F23 ) ) @ ( filtercomap @ A @ B @ F3 @ ( sup_sup @ ( filter @ B ) @ F14 @ F23 ) ) ) ).

% filtercomap_sup
thf(fact_6598_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_6599_sup__int__def,axiom,
    ( ( sup_sup @ int )
    = ( ord_max @ int ) ) ).

% sup_int_def
thf(fact_6600_ge__eq__refl,axiom,
    ! [A: $tType,R2: A > A > $o,X: A] :
      ( ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ R2 )
     => ( R2 @ X @ X ) ) ).

% ge_eq_refl
thf(fact_6601_refl__ge__eq,axiom,
    ! [A: $tType,R2: A > A > $o] :
      ( ! [X4: A] : ( R2 @ X4 @ X4 )
     => ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ R2 ) ) ).

% refl_ge_eq
thf(fact_6602_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,X: B,A3: set @ B,F3: B > A,Y: A] :
      ( ( ( member @ B @ X @ A3 )
       => ( ( image @ B @ A @ ( fun_upd @ B @ A @ F3 @ X @ Y ) @ A3 )
          = ( insert @ A @ Y @ ( image @ B @ A @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
      & ( ~ ( member @ B @ X @ A3 )
       => ( ( image @ B @ A @ ( fun_upd @ B @ A @ F3 @ X @ Y ) @ A3 )
          = ( image @ B @ A @ F3 @ A3 ) ) ) ) ).

% fun_upd_image
thf(fact_6603_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A16: set @ B,B1: set @ A,F2: C > D,B22: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F1 @ A16 )
        = B1 )
     => ( ( inj_on @ C @ D @ F2 @ B22 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F2 @ B22 ) @ A26 )
         => ( ( ( B22
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B22 @ B1 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B22 @ F1 @ F2 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A16 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_6604_pos__deriv__imp__strict__mono,axiom,
    ! [F3: real > real,F9: real > real] :
      ( ! [X4: real] : ( has_field_derivative @ real @ F3 @ ( F9 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X4: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F9 @ X4 ) )
       => ( order_strict_mono @ real @ real @ F3 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_6605_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K ) ) ) ).

% strict_mono_add
thf(fact_6606_tanh__real__strict__mono,axiom,
    order_strict_mono @ real @ real @ ( tanh @ real ) ).

% tanh_real_strict_mono
thf(fact_6607_sinh__real__strict__mono,axiom,
    order_strict_mono @ real @ real @ ( sinh @ real ) ).

% sinh_real_strict_mono
thf(fact_6608_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F3: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F3 )
         => ( ( ord_less_eq @ B @ ( F3 @ X ) @ ( F3 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% strict_mono_less_eq
thf(fact_6609_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R: A > B,M: A,N: A] :
          ( ( order_strict_mono @ A @ B @ R )
         => ( ( ord_less_eq @ A @ M @ N )
           => ( ord_less_eq @ B @ ( R @ M ) @ ( R @ N ) ) ) ) ) ).

% strict_mono_leD
thf(fact_6610_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: A > B,A26: set @ A,A16: set @ B,F1: B > C,B1: set @ C,F2: D > A,B22: set @ D] :
      ( ( member @ ( A > B ) @ G @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A16 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F1 @ A16 ) @ B1 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F2 @ B22 ) @ A26 )
         => ( member @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B22 @ F1 @ F2 @ G ) @ ( bNF_Wellorder_Func @ D @ C @ B22 @ B1 ) ) ) ) ) ).

% Func_map
thf(fact_6611_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ A @ A @ rep_Integ @ ( id @ A )
          @ ( product_case_prod @ nat @ nat @ A
            @ ^ [I3: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ) ).

% ring_1_class.of_int_def
thf(fact_6612_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_6613_of__nat__eq__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( id @ nat ) ) ).

% of_nat_eq_id
thf(fact_6614_id__funpow,axiom,
    ! [A: $tType,N: nat] :
      ( ( compow @ ( A > A ) @ N @ ( id @ A ) )
      = ( id @ A ) ) ).

% id_funpow
thf(fact_6615_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% push_bit_0_id
thf(fact_6616_drop__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% drop_bit_0
thf(fact_6617_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_6618_strict__mono__imp__increasing,axiom,
    ! [F3: nat > nat,N: nat] :
      ( ( order_strict_mono @ nat @ nat @ F3 )
     => ( ord_less_eq @ nat @ N @ ( F3 @ N ) ) ) ).

% strict_mono_imp_increasing
thf(fact_6619_less__eq__int__def,axiom,
    ( ( ord_less_eq @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y6: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) ) ) ) ).

% less_eq_int_def
thf(fact_6620_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F3: A > A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F3 )
      = ( id @ A ) ) ).

% funpow_simps_right(1)
thf(fact_6621_less__int__def,axiom,
    ( ( ord_less @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X3: nat,Y6: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) ) ) ) ).

% less_int_def
thf(fact_6622_nat__def,axiom,
    ( nat2
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ nat @ nat @ rep_Integ @ ( id @ nat ) @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ) ).

% nat_def
thf(fact_6623_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N2: nat] : ( ord_less @ A @ ( F5 @ N2 ) @ ( F5 @ ( suc @ N2 ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_6624_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F3: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( F3 @ ( G @ N2 ) ) )
              = ( summable @ A @ F3 ) ) ) ) ) ).

% summable_mono_reindex
thf(fact_6625_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F3: nat > A,C2: A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( sums @ A
                @ ^ [N2: nat] : ( F3 @ ( G @ N2 ) )
                @ C2 )
              = ( sums @ A @ F3 @ C2 ) ) ) ) ) ).

% sums_mono_reindex
thf(fact_6626_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > nat,F3: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N3: nat] :
                ( ~ ( member @ nat @ N3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F3 @ N3 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A
                @ ^ [N2: nat] : ( F3 @ ( G @ N2 ) ) )
              = ( suminf @ A @ F3 ) ) ) ) ) ).

% suminf_mono_reindex
thf(fact_6627_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F3: nat > A,G: nat > nat] :
          ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_eq @ nat @ X4 @ Y3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ X4 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F3 @ Y3 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X3: nat] : ( F3 @ ( G @ X3 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F3 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_6628_and__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_6629_and__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_6630_and__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_6631_and__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_6632_int__numeral__and__not__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N ) ) ) ).

% int_numeral_and_not_num
thf(fact_6633_int__numeral__not__and__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_6634_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F3: A > B > B,G: C > A,R2: set @ C] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite673082921795544331dem_on @ C @ B @ R2 @ ( comp @ A @ ( B > B ) @ C @ F3 @ G ) ) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
thf(fact_6635_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( positive @ ( fract @ A2 @ B2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ A2 @ B2 ) ) ) ).

% positive_rat
thf(fact_6636_Rat_Opositive__zero,axiom,
    ~ ( positive @ ( zero_zero @ rat ) ) ).

% Rat.positive_zero
thf(fact_6637_Rat_Opositive__mult,axiom,
    ! [X: rat,Y: rat] :
      ( ( positive @ X )
     => ( ( positive @ Y )
       => ( positive @ ( times_times @ rat @ X @ Y ) ) ) ) ).

% Rat.positive_mult
thf(fact_6638_Rat_Opositive__minus,axiom,
    ! [X: rat] :
      ( ~ ( positive @ X )
     => ( ( X
         != ( zero_zero @ rat ) )
       => ( positive @ ( uminus_uminus @ rat @ X ) ) ) ) ).

% Rat.positive_minus
thf(fact_6639_less__rat__def,axiom,
    ( ( ord_less @ rat )
    = ( ^ [X3: rat,Y6: rat] : ( positive @ ( minus_minus @ rat @ Y6 @ X3 ) ) ) ) ).

% less_rat_def
thf(fact_6640_nth__image,axiom,
    ! [A: $tType,L: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs2 ) ) ) ) ).

% nth_image
thf(fact_6641_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K2 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L4: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L4 ) @ ( code_num_of_integer @ L4 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L4 ) @ ( code_num_of_integer @ L4 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_6642_take__all,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N )
     => ( ( take @ A @ N @ Xs2 )
        = Xs2 ) ) ).

% take_all
thf(fact_6643_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( take @ A @ N @ Xs2 )
        = Xs2 )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% take_all_iff
thf(fact_6644_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A,Y: A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( take @ A @ N @ ( list_update @ A @ Xs2 @ M @ Y ) )
        = ( take @ A @ N @ Xs2 ) ) ) ).

% take_update_cancel
thf(fact_6645_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_take_subset
thf(fact_6646_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs2 ) ) @ ( set2 @ A @ ( take @ A @ N @ Xs2 ) ) ) ) ).

% set_take_subset_set_take
thf(fact_6647_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ K )
             => ( ( nth @ A @ Xs2 @ I2 )
                = ( nth @ A @ Ys @ I2 ) ) )
         => ( ( take @ A @ K @ Xs2 )
            = ( take @ A @ K @ Ys ) ) ) ) ) ).

% nth_take_lemma
thf(fact_6648_dual__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( max @ A
          @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 ) )
        = ( ord_min @ A ) ) ) ).

% dual_max
thf(fact_6649_dual__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( min @ A
          @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 ) )
        = ( ord_max @ A ) ) ) ).

% dual_min
thf(fact_6650_filterlim__finite__subsets__at__top,axiom,
    ! [A: $tType,B: $tType,F3: A > ( set @ B ),A3: set @ B,F6: filter @ A] :
      ( ( filterlim @ A @ ( set @ B ) @ F3 @ ( finite5375528669736107172at_top @ B @ A3 ) @ F6 )
      = ( ! [X8: set @ B] :
            ( ( ( finite_finite @ B @ X8 )
              & ( ord_less_eq @ ( set @ B ) @ X8 @ A3 ) )
           => ( eventually @ A
              @ ^ [Y6: A] :
                  ( ( finite_finite @ B @ ( F3 @ Y6 ) )
                  & ( ord_less_eq @ ( set @ B ) @ X8 @ ( F3 @ Y6 ) )
                  & ( ord_less_eq @ ( set @ B ) @ ( F3 @ Y6 ) @ A3 ) )
              @ F6 ) ) ) ) ).

% filterlim_finite_subsets_at_top
thf(fact_6651_card__Min__le__sum,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( lattic643756798350308766er_Min @ nat @ ( image @ A @ nat @ F3 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) ) ) ).

% card_Min_le_sum
thf(fact_6652_eventually__finite__subsets__at__top__weakI,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > $o] :
      ( ! [X11: set @ A] :
          ( ( finite_finite @ A @ X11 )
         => ( ( ord_less_eq @ ( set @ A ) @ X11 @ A3 )
           => ( P @ X11 ) ) )
     => ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A3 ) ) ) ).

% eventually_finite_subsets_at_top_weakI
thf(fact_6653_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_6654_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ A2 ) ) ) ) ).

% Min.coboundedI
thf(fact_6655_Min__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [Y3: A] :
                ( ( member @ A @ Y3 @ A3 )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( member @ A @ X @ A3 )
             => ( ( lattic643756798350308766er_Min @ A @ A3 )
                = X ) ) ) ) ) ).

% Min_eqI
thf(fact_6656_Min__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X ) ) ) ) ).

% Min_le
thf(fact_6657_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A3 )
                 => ( ord_less_eq @ A @ X @ A5 ) )
             => ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_6658_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A3 ) )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A3 )
                 => ( ord_less_eq @ A @ X @ A17 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_6659_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798350308766er_Min @ A @ A3 ) )
              = ( ( member @ A @ M @ A3 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ M @ X3 ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_6660_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ X )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                    & ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_6661_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A3 )
                = M )
              = ( ( member @ A @ M @ A3 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ M @ X3 ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_6662_Min__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [B5: A] :
                ( ( member @ A @ B5 @ A3 )
               => ( ord_less_eq @ A @ A2 @ B5 ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ A2 @ A3 ) )
              = A2 ) ) ) ) ).

% Min_insert2
thf(fact_6663_eventually__finite__subsets__at__top,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,A3: set @ A] :
      ( ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A3 ) )
      = ( ? [X8: set @ A] :
            ( ( finite_finite @ A @ X8 )
            & ( ord_less_eq @ ( set @ A ) @ X8 @ A3 )
            & ! [Y9: set @ A] :
                ( ( ( finite_finite @ A @ Y9 )
                  & ( ord_less_eq @ ( set @ A ) @ X8 @ Y9 )
                  & ( ord_less_eq @ ( set @ A ) @ Y9 @ A3 ) )
               => ( P @ Y9 ) ) ) ) ) ).

% eventually_finite_subsets_at_top
thf(fact_6664_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B4 ) @ ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_6665_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N6 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N6 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N6 ) @ ( lattic643756798350308766er_Min @ A @ M7 ) ) ) ) ) ) ).

% Min_antimono
thf(fact_6666_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B4 ) @ ( lattic643756798350308766er_Min @ A @ A3 ) )
                = ( lattic643756798350308766er_Min @ A @ A3 ) ) ) ) ) ) ).

% Min.subset
thf(fact_6667_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F3: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [X3: B] : ( plus_plus @ A @ ( F3 @ X3 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image @ B @ A @ F3 @ S2 ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_6668_finite__subsets__at__top__def,axiom,
    ! [A: $tType] :
      ( ( finite5375528669736107172at_top @ A )
      = ( ^ [A6: set @ A] :
            ( complete_Inf_Inf @ ( filter @ ( set @ A ) )
            @ ( image @ ( set @ A ) @ ( filter @ ( set @ A ) )
              @ ^ [X8: set @ A] :
                  ( principal @ ( set @ A )
                  @ ( collect @ ( set @ A )
                    @ ^ [Y9: set @ A] :
                        ( ( finite_finite @ A @ Y9 )
                        & ( ord_less_eq @ ( set @ A ) @ X8 @ Y9 )
                        & ( ord_less_eq @ ( set @ A ) @ Y9 @ A6 ) ) ) )
              @ ( collect @ ( set @ A )
                @ ^ [X8: set @ A] :
                    ( ( finite_finite @ A @ X8 )
                    & ( ord_less_eq @ ( set @ A ) @ X8 @ A6 ) ) ) ) ) ) ) ).

% finite_subsets_at_top_def
thf(fact_6669_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A3 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A3 )
                  = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_6670_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A3 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A3 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_6671_dual__Max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Max @ A
          @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 ) )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% dual_Max
thf(fact_6672_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N2: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I3 @ R6 )
              @ ( collect @ nat
                @ ^ [I3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I3 )
                    & ( ord_less_eq @ nat @ I3 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_6673_relpow__1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( one_one @ nat ) @ R2 )
      = R2 ) ).

% relpow_1
thf(fact_6674_finite__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% finite_relpow
thf(fact_6675_relpow__Suc__E,axiom,
    ! [A: $tType,X: A,Z: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) )
     => ~ ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z ) @ R2 ) ) ) ).

% relpow_Suc_E
thf(fact_6676_relpow__Suc__I,axiom,
    ! [A: $tType,X: A,Y: A,N: nat,R2: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) ) ) ) ).

% relpow_Suc_I
thf(fact_6677_relpow__Suc__D2,axiom,
    ! [A: $tType,X: A,Z: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) )
     => ? [Y3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpow_Suc_D2
thf(fact_6678_relpow__Suc__E2,axiom,
    ! [A: $tType,X: A,Z: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) )
     => ~ ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R2 )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpow_Suc_E2
thf(fact_6679_relpow__Suc__I2,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A ),Z: A,N: nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) ) ) ) ).

% relpow_Suc_I2
thf(fact_6680_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R2 ) )
     => ( X = Y ) ) ).

% relpow_0_E
thf(fact_6681_relpow__0__I,axiom,
    ! [A: $tType,X: A,R2: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R2 ) ) ).

% relpow_0_I
thf(fact_6682_relpow__Suc__D2_H,axiom,
    ! [A: $tType,N: nat,R2: set @ ( product_prod @ A @ A ),X5: A,Y4: A,Z3: A] :
      ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ R2 ) )
     => ? [W2: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ W2 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ W2 @ Z3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpow_Suc_D2'
thf(fact_6683_relpow__finite__bounded,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R2 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_6684_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( A > A > $o ) @ N
        @ ^ [X3: A,Y6: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y6 ) @ R2 ) )
      = ( ^ [X3: A,Y6: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y6 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpowp_relpow_eq
thf(fact_6685_relpow__E,axiom,
    ! [A: $tType,X: A,Z: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N
                = ( suc @ M2 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M2 @ R2 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z ) @ R2 ) ) ) ) ) ).

% relpow_E
thf(fact_6686_relpow__E2,axiom,
    ! [A: $tType,X: A,Z: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N
                = ( suc @ M2 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R2 )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M2 @ R2 ) ) ) ) ) ) ).

% relpow_E2
thf(fact_6687_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_6688_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
      = ( ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F5 @ N )
              = B2 )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ N )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F5 @ I3 ) @ ( F5 @ ( suc @ I3 ) ) ) @ R2 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_6689_relpow__finite__bounded1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R2 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                    & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_6690_relpow__code__def,axiom,
    ! [A: $tType] :
      ( ( transitive_relpow @ A )
      = ( compow @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% relpow_code_def
thf(fact_6691_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_trancl @ A @ R2 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
            @ ( collect @ nat
              @ ^ [N2: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                  & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_6692_trancl__empty,axiom,
    ! [A: $tType] :
      ( ( transitive_trancl @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ).

% trancl_empty
thf(fact_6693_finite__trancl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ ( transitive_trancl @ A @ R ) )
      = ( finite_finite @ ( product_prod @ A @ A ) @ R ) ) ).

% finite_trancl
thf(fact_6694_r__into__trancl_H,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ R )
     => ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ R ) ) ) ).

% r_into_trancl'
thf(fact_6695_trancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ R )
       => ~ ! [B5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B5 ) @ ( transitive_trancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ A22 ) @ R ) ) ) ) ).

% trancl.cases
thf(fact_6696_trancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R ) )
      = ( ? [A4: A,B3: A] :
            ( ( A1 = A4 )
            & ( A22 = B3 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R ) )
        | ? [A4: A,B3: A,C3: A] :
            ( ( A1 = A4 )
            & ( A22 = C3 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( transitive_trancl @ A @ R ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C3 ) @ R ) ) ) ) ).

% trancl.simps
thf(fact_6697_trancl_Or__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) ) ) ).

% trancl.r_into_trancl
thf(fact_6698_tranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
       => ~ ! [C4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C4 ) @ ( transitive_trancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ C4 @ B2 ) @ R ) ) ) ) ).

% tranclE
thf(fact_6699_trancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_trans
thf(fact_6700_trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ R )
           => ( P @ Y3 ) )
       => ( ! [Y3: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ ( transitive_trancl @ A @ R ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z5 ) @ R )
               => ( ( P @ Y3 )
                 => ( P @ Z5 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% trancl_induct
thf(fact_6701_trancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ! [A5: A,B5: B] :
            ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ R )
           => ( P @ A5 @ B5 ) )
       => ( ! [A5: A,B5: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
               => ( ( P @ A5 @ B5 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% trancl_induct2
thf(fact_6702_r__r__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ).

% r_r_into_trancl
thf(fact_6703_converse__tranclE,axiom,
    ! [A: $tType,X: A,Z: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ R )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% converse_tranclE
thf(fact_6704_irrefl__trancl__rD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: A,Y: A] :
      ( ! [X4: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ X4 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
       => ( X != Y ) ) ) ).

% irrefl_trancl_rD
thf(fact_6705_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% Transitive_Closure.trancl_into_trancl
thf(fact_6706_trancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_into_trancl2
thf(fact_6707_trancl__trans__induct,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),P: A > A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [X4: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y3 ) @ R )
           => ( P @ X4 @ Y3 ) )
       => ( ! [X4: A,Y3: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y3 ) @ ( transitive_trancl @ A @ R ) )
             => ( ( P @ X4 @ Y3 )
               => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z5 ) @ ( transitive_trancl @ A @ R ) )
                 => ( ( P @ Y3 @ Z5 )
                   => ( P @ X4 @ Z5 ) ) ) ) )
         => ( P @ X @ Y ) ) ) ) ).

% trancl_trans_induct
thf(fact_6708_converse__trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ B2 ) @ R )
           => ( P @ Y3 ) )
       => ( ! [Y3: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z5 ) @ R )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ B2 ) @ ( transitive_trancl @ A @ R ) )
               => ( ( P @ Z5 )
                 => ( P @ Y3 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_trancl_induct
thf(fact_6709_trancl__mono,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ R ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
       => ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ S ) ) ) ) ).

% trancl_mono
thf(fact_6710_trancl__insert2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X3: A,Y6: A] :
                ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ A2 ) @ ( transitive_trancl @ A @ R ) )
                  | ( X3 = A2 ) )
                & ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y6 ) @ ( transitive_trancl @ A @ R ) )
                  | ( Y6 = B2 ) ) ) ) ) ) ) ).

% trancl_insert2
thf(fact_6711_trancl__power,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ R2 ) )
      = ( ? [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( member @ ( product_prod @ A @ A ) @ P4 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ) ).

% trancl_power
thf(fact_6712_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs2: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs2 ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs2 ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs2 ) ) ) ).

% trancl_set_ntrancl
thf(fact_6713_finite__trancl__ntranl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_trancl @ A @ R2 )
        = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) @ ( one_one @ nat ) ) @ R2 ) ) ) ).

% finite_trancl_ntranl
thf(fact_6714_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_rtrancl @ A @ R2 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_6715_sum__le__card__Max,axiom,
    ! [A: $tType,A3: set @ A,F3: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F3 @ A3 ) @ ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( lattic643756798349783984er_Max @ nat @ ( image @ A @ nat @ F3 @ A3 ) ) ) ) ) ).

% sum_le_card_Max
thf(fact_6716_r__into__rtrancl,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ R )
     => ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_rtrancl @ A @ R ) ) ) ).

% r_into_rtrancl
thf(fact_6717_rtrancl__idemp,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( transitive_rtrancl @ A @ R ) )
      = ( transitive_rtrancl @ A @ R ) ) ).

% rtrancl_idemp
thf(fact_6718_rtrancl__trancl__absorb,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( transitive_rtrancl @ A @ R2 ) )
      = ( transitive_rtrancl @ A @ R2 ) ) ).

% rtrancl_trancl_absorb
thf(fact_6719_trancl__rtrancl__absorb,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( transitive_trancl @ A @ R2 ) )
      = ( transitive_rtrancl @ A @ R2 ) ) ).

% trancl_rtrancl_absorb
thf(fact_6720_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ N ) ) )
        = N ) ) ).

% Max_divisors_self_nat
thf(fact_6721_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_6722_tranclD,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R2 ) )
     => ? [Z5: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z5 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ Y ) @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ).

% tranclD
thf(fact_6723_rtranclD,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R2 ) )
     => ( ( A2 = B2 )
        | ( ( A2 != B2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ) ).

% rtranclD
thf(fact_6724_tranclD2,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R2 ) )
     => ? [Z5: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z5 ) @ ( transitive_rtrancl @ A @ R2 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ Y ) @ R2 ) ) ) ).

% tranclD2
thf(fact_6725_trancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ).

% trancl_into_rtrancl
thf(fact_6726_rtrancl__eq__or__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R2 ) )
      = ( ( X = Y )
        | ( ( X != Y )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ) ).

% rtrancl_eq_or_trancl
thf(fact_6727_rtrancl__into__trancl1,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_into_trancl1
thf(fact_6728_rtrancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_into_trancl2
thf(fact_6729_rtrancl__trancl__trancl,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_trancl_trancl
thf(fact_6730_trancl__rtrancl__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_rtrancl_trancl
thf(fact_6731_Max__ge,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ).

% Max_ge
thf(fact_6732_Max__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [Y3: A] :
                ( ( member @ A @ Y3 @ A3 )
               => ( ord_less_eq @ A @ Y3 @ X ) )
           => ( ( member @ A @ X @ A3 )
             => ( ( lattic643756798349783984er_Max @ A @ A3 )
                = X ) ) ) ) ) ).

% Max_eqI
thf(fact_6733_Max__eq__if,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( finite_finite @ A @ B4 )
           => ( ! [X4: A] :
                  ( ( member @ A @ X4 @ A3 )
                 => ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ B4 )
                      & ( ord_less_eq @ A @ X4 @ Xa2 ) ) )
             => ( ! [X4: A] :
                    ( ( member @ A @ X4 @ B4 )
                   => ? [Xa2: A] :
                        ( ( member @ A @ Xa2 @ A3 )
                        & ( ord_less_eq @ A @ X4 @ Xa2 ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = ( lattic643756798349783984er_Max @ A @ B4 ) ) ) ) ) ) ) ).

% Max_eq_if
thf(fact_6734_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ A2 @ ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ).

% Max.coboundedI
thf(fact_6735_rtrancl__insert,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X3: A,Y6: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ A2 ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y6 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% rtrancl_insert
thf(fact_6736_rtrancl__Un__subset,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R2 ) @ ( transitive_rtrancl @ A @ S2 ) ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S2 ) ) ) ).

% rtrancl_Un_subset
thf(fact_6737_in__rtrancl__UnI,axiom,
    ! [A: $tType,X: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ( member @ ( product_prod @ A @ A ) @ X @ ( transitive_rtrancl @ A @ R2 ) )
        | ( member @ ( product_prod @ A @ A ) @ X @ ( transitive_rtrancl @ A @ S2 ) ) )
     => ( member @ ( product_prod @ A @ A ) @ X @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S2 ) ) ) ) ).

% in_rtrancl_UnI
thf(fact_6738_rtrancl__Un__rtrancl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R2 ) @ ( transitive_rtrancl @ A @ S2 ) ) )
      = ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S2 ) ) ) ).

% rtrancl_Un_rtrancl
thf(fact_6739_rtrancl__Un__separatorE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X4: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ X4 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y3 ) @ Q )
             => ( X4 = Y3 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separatorE
thf(fact_6740_rtrancl__Un__separator__converseE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X4: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ B2 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X4 ) @ Q )
             => ( Y3 = X4 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separator_converseE
thf(fact_6741_rtrancl__mono,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_mono
thf(fact_6742_rtrancl__subset,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ S2 @ ( transitive_rtrancl @ A @ R2 ) )
       => ( ( transitive_rtrancl @ A @ S2 )
          = ( transitive_rtrancl @ A @ R2 ) ) ) ) ).

% rtrancl_subset
thf(fact_6743_rtrancl__subset__rtrancl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ ( transitive_rtrancl @ A @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_subset_rtrancl
thf(fact_6744_converse__rtrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% converse_rtrancl_into_rtrancl
thf(fact_6745_converse__rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( P @ Bx @ By )
       => ( ! [A5: A,B5: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
               => ( ( P @ Aa2 @ Ba )
                 => ( P @ A5 @ B5 ) ) ) )
         => ( P @ Ax @ Ay ) ) ) ) ).

% converse_rtrancl_induct2
thf(fact_6746_converse__rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( P @ B2 )
       => ( ! [Y3: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z5 ) @ R )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
               => ( ( P @ Z5 )
                 => ( P @ Y3 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_rtrancl_induct
thf(fact_6747_converse__rtranclE2,axiom,
    ! [B: $tType,A: $tType,Xa: A,Xb3: B,Za: A,Zb: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa @ Xb3 ) @ ( product_Pair @ A @ B @ Za @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( ( product_Pair @ A @ B @ Xa @ Xb3 )
         != ( product_Pair @ A @ B @ Za @ Zb ) )
       => ~ ! [A5: A,B5: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa @ Xb3 ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ R )
             => ~ ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Za @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) ) ) ) ) ).

% converse_rtranclE2
thf(fact_6748_converse__rtranclE,axiom,
    ! [A: $tType,X: A,Z: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( X != Z )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y3 ) @ R )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ).

% converse_rtranclE
thf(fact_6749_rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( P @ Ax @ Ay )
       => ( ! [A5: A,B5: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
               => ( ( P @ A5 @ B5 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% rtrancl_induct2
thf(fact_6750_rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( P @ A2 )
       => ( ! [Y3: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ ( transitive_rtrancl @ A @ R ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z5 ) @ R )
               => ( ( P @ Y3 )
                 => ( P @ Z5 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% rtrancl_induct
thf(fact_6751_rtrancl__trans,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% rtrancl_trans
thf(fact_6752_rtranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A2 != B2 )
       => ~ ! [Y3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y3 ) @ ( transitive_rtrancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ B2 ) @ R ) ) ) ) ).

% rtranclE
thf(fact_6753_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% rtrancl.rtrancl_into_rtrancl
thf(fact_6754_rtrancl_Ortrancl__refl,axiom,
    ! [A: $tType,A2: A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( transitive_rtrancl @ A @ R ) ) ).

% rtrancl.rtrancl_refl
thf(fact_6755_rtrancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R ) )
      = ( ? [A4: A] :
            ( ( A1 = A4 )
            & ( A22 = A4 ) )
        | ? [A4: A,B3: A,C3: A] :
            ( ( A1 = A4 )
            & ( A22 = C3 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( transitive_rtrancl @ A @ R ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C3 ) @ R ) ) ) ) ).

% rtrancl.simps
thf(fact_6756_rtrancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A22 != A1 )
       => ~ ! [B5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B5 ) @ ( transitive_rtrancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ A22 ) @ R ) ) ) ) ).

% rtrancl.cases
thf(fact_6757_rtrancl__imp__relpow,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_rtrancl @ A @ R2 ) )
     => ? [N3: nat] : ( member @ ( product_prod @ A @ A ) @ P4 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R2 ) ) ) ).

% rtrancl_imp_relpow
thf(fact_6758_relpow__imp__rtrancl,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
     => ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_rtrancl @ A @ R2 ) ) ) ).

% relpow_imp_rtrancl
thf(fact_6759_rtrancl__power,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_rtrancl @ A @ R2 ) )
      = ( ? [N2: nat] : ( member @ ( product_prod @ A @ A ) @ P4 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ).

% rtrancl_power
thf(fact_6760_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A3 )
                = M )
              = ( ( member @ A @ M @ A3 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ X3 @ M ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_6761_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ? [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                    & ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_6762_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798349783984er_Max @ A @ A3 ) )
              = ( ( member @ A @ M @ A3 )
                & ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ X3 @ M ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_6763_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A3 )
                 => ( ord_less_eq @ A @ A17 @ X ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_6764_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A3 )
                 => ( ord_less_eq @ A @ A5 @ X ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ X ) ) ) ) ) ).

% Max.boundedI
thf(fact_6765_Max__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [B5: A] :
                ( ( member @ A @ B5 @ A3 )
               => ( ord_less_eq @ A @ B5 @ A2 ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ A2 @ A3 ) )
              = A2 ) ) ) ) ).

% Max_insert2
thf(fact_6766_trancl__insert,axiom,
    ! [A: $tType,Y: A,X: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [A4: A,B3: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ Y ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ B3 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% trancl_insert
thf(fact_6767_pred__nat__trancl__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N ) @ ( transitive_rtrancl @ nat @ pred_nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% pred_nat_trancl_eq_le
thf(fact_6768_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N6: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N6 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N6 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M7 ) @ ( lattic643756798349783984er_Max @ A @ N6 ) ) ) ) ) ) ).

% Max_mono
thf(fact_6769_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A3 ) @ ( lattic643756798349783984er_Max @ A @ B4 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_6770_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B4 ) @ ( lattic643756798349783984er_Max @ A @ A3 ) )
                = ( lattic643756798349783984er_Max @ A @ A3 ) ) ) ) ) ) ).

% Max.subset
thf(fact_6771_card__le__Suc__Max,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ S2 ) @ ( suc @ ( lattic643756798349783984er_Max @ nat @ S2 ) ) ) ) ).

% card_le_Suc_Max
thf(fact_6772_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X8: set @ nat] :
          ( if @ nat
          @ ( X8
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X8 ) ) ) ) ).

% Sup_nat_def
thf(fact_6773_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F3: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [X3: B] : ( plus_plus @ A @ ( F3 @ X3 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image @ B @ A @ F3 @ S2 ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_6774_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K2: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K2 @ N2 ) @ M3 ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_6775_rtrancl__imp__UN__relpow,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_rtrancl @ A @ R2 ) )
     => ( member @ ( product_prod @ A @ A ) @ P4
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
            @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% rtrancl_imp_UN_relpow
thf(fact_6776_rtrancl__is__UN__relpow,axiom,
    ! [A: $tType] :
      ( ( transitive_rtrancl @ A )
      = ( ^ [R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R6 )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% rtrancl_is_UN_relpow
thf(fact_6777_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A3 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A3 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_6778_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A3 )
                  = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_6779_Gcd__eq__Max,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( M7
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
         => ( ( gcd_Gcd @ nat @ M7 )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image @ nat @ ( set @ nat )
                  @ ^ [M3: nat] :
                      ( collect @ nat
                      @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ M3 ) )
                  @ M7 ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_6780_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_6781_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,M: nat] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rotate @ A @ M @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% nth_rotate
thf(fact_6782_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_6783_rotate__Suc,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( rotate @ A @ ( suc @ N ) @ Xs2 )
      = ( rotate1 @ A @ ( rotate @ A @ N @ Xs2 ) ) ) ).

% rotate_Suc
thf(fact_6784_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D4: int] : ( dvd_dvd @ int @ D4 @ N ) ) )
        = ( abs_abs @ int @ N ) ) ) ).

% Max_divisors_self_int
thf(fact_6785_rotate__length01,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N @ Xs2 )
        = Xs2 ) ) ).

% rotate_length01
thf(fact_6786_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N @ Xs2 )
        = Xs2 ) ) ).

% rotate_id
thf(fact_6787_rotate__add,axiom,
    ! [A: $tType,M: nat,N: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M @ N ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M ) @ ( rotate @ A @ N ) ) ) ).

% rotate_add
thf(fact_6788_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N: nat,Xs2: list @ A] :
      ( ( rotate @ A @ M @ ( rotate @ A @ N @ Xs2 ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M @ N ) @ Xs2 ) ) ).

% rotate_rotate
thf(fact_6789_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( cons @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ ( lattic643756798350308766er_Min @ A @ A3 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set_nonempty
thf(fact_6790_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs2: list @ A,X: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ X ) @ ( nth @ A @ Xs2 @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_6791_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( suc @ N ) )
      = ( nth @ A @ Xs2 @ N ) ) ).

% nth_Cons_Suc
thf(fact_6792_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_6793_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( take @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs2 ) )
      = ( cons @ A @ X @ ( take @ A @ N @ Xs2 ) ) ) ).

% take_Suc_Cons
thf(fact_6794_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Ns ) )
               => ( X3
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_6795_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X @ Xs2 ) )
          = ( plus_plus @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% sum_list.Cons
thf(fact_6796_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F3: B > A,A2: A,X: B,Xs2: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ ( cons @ B @ X @ Xs2 ) )
          = ( plus_plus @ A @ ( F3 @ X ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ Xs2 ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_6797_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs2: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X @ Xs2 ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X ) @ ( enumerate @ B @ ( suc @ N ) @ Xs2 ) ) ) ).

% enumerate_simps(2)
thf(fact_6798_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_6799_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs2: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X @ Xs2 ) )
      = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs2 ) ) ) ).

% take_Cons_numeral
thf(fact_6800_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_6801_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y: A,Xs2: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ Xs2 @ Ys ) ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_6802_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs2 @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs2 ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_6803_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X: B,Y: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F3 @ X ) @ ( F3 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F3 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ X @ ( cons @ B @ Y @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F3 @ X ) @ ( F3 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F3 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ Y @ ( linorder_insort_key @ B @ A @ F3 @ X @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_6804_impossible__Cons,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs2
       != ( cons @ A @ X @ Ys ) ) ) ).

% impossible_Cons
thf(fact_6805_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,I: nat,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs2 ) @ ( suc @ I ) @ Y )
      = ( cons @ A @ X @ ( list_update @ A @ Xs2 @ I @ Y ) ) ) ).

% list_update_code(3)
thf(fact_6806_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs2 ) @ ( zero_zero @ nat ) @ Y )
      = ( cons @ A @ Y @ Xs2 ) ) ).

% list_update_code(2)
thf(fact_6807_length__Cons,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_Cons
thf(fact_6808_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [Y6: A,Ys2: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y6 @ Ys2 ) )
            & ( ( size_size @ ( list @ A ) @ Ys2 )
              = N ) ) ) ) ).

% Suc_length_conv
thf(fact_6809_length__Suc__conv,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N ) )
      = ( ? [Y6: A,Ys2: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y6 @ Ys2 ) )
            & ( ( size_size @ ( list @ A ) @ Ys2 )
              = N ) ) ) ) ).

% length_Suc_conv
thf(fact_6810_set__subset__Cons,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ ( cons @ A @ X @ Xs2 ) ) ) ).

% set_subset_Cons
thf(fact_6811_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% member_le_sum_list
thf(fact_6812_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ X4 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_6813_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X4 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs2 )
              = ( zero_zero @ A ) )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
                 => ( X3
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_6814_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X4 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_6815_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [X3: A,Ys2: list @ A] :
            ( ( Xs2
              = ( cons @ A @ X3 @ Ys2 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_6816_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ B,F3: B > A,A2: B] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ ( set2 @ B @ Xs2 ) )
             => ( ord_less_eq @ A @ ( F3 @ A2 ) @ ( F3 @ X4 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F3 @ A2 @ Xs2 )
            = ( cons @ B @ A2 @ Xs2 ) ) ) ) ).

% insort_is_Cons
thf(fact_6817_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs2: list @ A] :
      ( ( ( X = Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs2 ) @ Y )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs2 @ Y ) @ ( one_one @ nat ) ) ) )
      & ( ( X != Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs2 ) @ Y )
          = ( count_list @ A @ Xs2 @ Y ) ) ) ) ).

% count_list.simps(2)
thf(fact_6818_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_6819_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = X ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_6820_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_6821_card__length__sum__list__rec,axiom,
    ! [M: nat,N6: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L4: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L4 )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L4 )
                  = N6 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L4: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L4 )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L4 )
                    = N6 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L4: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L4 )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L4 ) @ ( one_one @ nat ) )
                    = N6 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_6822_card__length__sum__list,axiom,
    ! [M: nat,N6: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L4: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L4 )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L4 )
                = N6 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N6 @ M ) @ ( one_one @ nat ) ) @ N6 ) ) ).

% card_length_sum_list
thf(fact_6823_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_6824_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_6825_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
            = X )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_6826_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y: A,Xs2: list @ A,N: nat] :
      ( ( X != Y )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = Y )
        = ( ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_6827_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_6828_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I3: int,J3: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J3 @ I3 ) @ Js @ ( upto_aux @ I3 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) @ ( cons @ int @ J3 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_6829_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs2: list @ A,X9: set @ A,F3: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ X9 )
     => ( ( finite_finite @ A @ X9 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ Xs2 ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X3: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X3 ) @ ( F3 @ X3 ) )
            @ X9 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_6830_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( zero_zero @ A )
              @ Xs2 ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_6831_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F3: B > A,G: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( minus_minus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ Xs2 ) )
          = ( minus_minus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum_list_subtractf
thf(fact_6832_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F3: B > A,C2: A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ ( F3 @ X3 ) @ C2 )
              @ Xs2 ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs2 ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_6833_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F3: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( times_times @ A @ C2 @ ( F3 @ X3 ) )
              @ Xs2 ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs2 ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_6834_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F3: B > A,G: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( plus_plus @ A @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ Xs2 ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum_list_addf
thf(fact_6835_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs2: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs2 ) ) ) ) ).

% sum_list_abs
thf(fact_6836_sum__list__Suc,axiom,
    ! [A: $tType,F3: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X3: A] : ( suc @ ( F3 @ X3 ) )
          @ Xs2 ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% sum_list_Suc
thf(fact_6837_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs2: list @ A,F3: A > B,G: A > B] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F3 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs2 ) ) ) ) ) ).

% sum_list_mono
thf(fact_6838_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X: B,Xs2: list @ B,F3: B > A] :
          ( ( member @ B @ X @ ( set2 @ B @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs2 ) )
            = ( plus_plus @ A @ ( F3 @ X ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ ( remove1 @ B @ X @ Xs2 ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_6839_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R: B,Xs2: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X3: C] : R
              @ Xs2 ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs2 ) ) @ R ) ) ) ).

% sum_list_triv
thf(fact_6840_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F3: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ Xs2 ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X3: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X3 ) @ ( F3 @ X3 ) )
        @ ( set2 @ A @ Xs2 ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_6841_list__encode_Osimps_I2_J,axiom,
    ! [X: nat,Xs2: list @ nat] :
      ( ( nat_list_encode @ ( cons @ nat @ X @ Xs2 ) )
      = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X @ ( nat_list_encode @ Xs2 ) ) ) ) ) ).

% list_encode.simps(2)
thf(fact_6842_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F5: B > nat,Xs: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F5 @ Xs ) ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_6843_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs2 )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys2: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y6: A] : ( cons @ A @ Y6 @ Ys2 )
              @ Xs2 )
          @ ( n_lists @ A @ N @ Xs2 ) ) ) ) ).

% n_lists.simps(2)
thf(fact_6844_surj__list__encode,axiom,
    ( ( image @ ( list @ nat ) @ nat @ nat_list_encode @ ( top_top @ ( set @ ( list @ nat ) ) ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% surj_list_encode
thf(fact_6845_list__encode__eq,axiom,
    ! [X: list @ nat,Y: list @ nat] :
      ( ( ( nat_list_encode @ X )
        = ( nat_list_encode @ Y ) )
      = ( X = Y ) ) ).

% list_encode_eq
thf(fact_6846_bij__list__encode,axiom,
    bij_betw @ ( list @ nat ) @ nat @ nat_list_encode @ ( top_top @ ( set @ ( list @ nat ) ) ) @ ( top_top @ ( set @ nat ) ) ).

% bij_list_encode
thf(fact_6847_inj__list__encode,axiom,
    ! [A3: set @ ( list @ nat )] : ( inj_on @ ( list @ nat ) @ nat @ nat_list_encode @ A3 ) ).

% inj_list_encode
thf(fact_6848_size__list__pointwise,axiom,
    ! [A: $tType,Xs2: list @ A,F3: A > nat,G: A > nat] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ nat @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F3 @ Xs2 ) @ ( size_list @ A @ G @ Xs2 ) ) ) ).

% size_list_pointwise
thf(fact_6849_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y: nat,F3: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ Y @ ( F3 @ X ) )
       => ( ord_less_eq @ nat @ Y @ ( size_list @ A @ F3 @ Xs2 ) ) ) ) ).

% size_list_estimation'
thf(fact_6850_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X21 ) @ ( size_list @ A @ X @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_6851_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F3: nat > B,Ns: list @ nat] :
          ( ! [X4: nat,Y3: nat] :
              ( ( ord_less_eq @ nat @ X4 @ Y3 )
             => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F3 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_6852_list__encode_Oelims,axiom,
    ! [X: list @ nat,Y: nat] :
      ( ( ( nat_list_encode @ X )
        = Y )
     => ( ( ( X
            = ( nil @ nat ) )
         => ( Y
           != ( zero_zero @ nat ) ) )
       => ~ ! [X4: nat,Xs3: list @ nat] :
              ( ( X
                = ( cons @ nat @ X4 @ Xs3 ) )
             => ( Y
               != ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X4 @ ( nat_list_encode @ Xs3 ) ) ) ) ) ) ) ) ).

% list_encode.elims
thf(fact_6853_length__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( zero_zero @ nat ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_6854_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_6855_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N @ Xs2 ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs2
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_6856_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( take @ A @ N @ Xs2 )
        = ( nil @ A ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs2
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_6857_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_6858_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F3: B > A,A2: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_6859_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_6860_length__greater__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ( Xs2
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_6861_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) )
          = ( sorted_wrt @ B
            @ ^ [X3: B,Y6: B] : ( ord_less_eq @ A @ ( F3 @ X3 ) @ ( F3 @ Y6 ) )
            @ Xs2 ) ) ) ).

% sorted_map
thf(fact_6862_list__encode_Osimps_I1_J,axiom,
    ( ( nat_list_encode @ ( nil @ nat ) )
    = ( zero_zero @ nat ) ) ).

% list_encode.simps(1)
thf(fact_6863_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_6864_take__0,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs2 )
      = ( nil @ A ) ) ).

% take_0
thf(fact_6865_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_6866_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_6867_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N @ Xs2 ) ) ) ) ).

% sorted_take
thf(fact_6868_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_6869_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_6870_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_6871_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs2 ) ) ) ) ).

% sorted_remove1
thf(fact_6872_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs2 ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted_insort
thf(fact_6873_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_6874_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X @ X3 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_6875_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs2 )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_6876_list__encode_Ocases,axiom,
    ! [X: list @ nat] :
      ( ( X
       != ( nil @ nat ) )
     => ~ ! [X4: nat,Xs3: list @ nat] :
            ( X
           != ( cons @ nat @ X4 @ Xs3 ) ) ) ).

% list_encode.cases
thf(fact_6877_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_6878_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_6879_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs2 )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs2 = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_6880_sorted__wrt01,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs2 ) ) ).

% sorted_wrt01
thf(fact_6881_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,X: B,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ ( linorder_insort_key @ B @ A @ F3 @ X @ Xs2 ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) ) ) ) ).

% sorted_insort_key
thf(fact_6882_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs2: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ ( remove1 @ B @ X @ Xs2 ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_6883_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted01
thf(fact_6884_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I3: nat,J3: nat] :
                ( ( ord_less @ nat @ I3 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Xs2 @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_6885_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ? [X4: list @ A] :
              ( ( ( set2 @ A @ X4 )
                = A3 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X4 )
              & ( distinct @ A @ X4 )
              & ! [Y4: list @ A] :
                  ( ( ( ( set2 @ A @ Y4 )
                      = A3 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y4 )
                    & ( distinct @ A @ Y4 ) )
                 => ( Y4 = X4 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_6886_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_6887_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs2: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ A2
                @ ( remove1 @ A @ A2 @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% insort_remove1
thf(fact_6888_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I3: nat] :
                ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Xs2 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_6889_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I ) @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_6890_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I3: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Xs2 @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_6891_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I @ ( nth @ nat @ Ns @ I ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_6892_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs2: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F3 @ Xs2 ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F3 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs2 )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs2 = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_6893_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) ) ) ).

% take_Cons'
thf(fact_6894_list__encode_Opelims,axiom,
    ! [X: list @ nat,Y: nat] :
      ( ( ( nat_list_encode @ X )
        = Y )
     => ( ( accp @ ( list @ nat ) @ nat_list_encode_rel @ X )
       => ( ( ( X
              = ( nil @ nat ) )
           => ( ( Y
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( nil @ nat ) ) ) )
         => ~ ! [X4: nat,Xs3: list @ nat] :
                ( ( X
                  = ( cons @ nat @ X4 @ Xs3 ) )
               => ( ( Y
                    = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X4 @ ( nat_list_encode @ Xs3 ) ) ) ) )
                 => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( cons @ nat @ X4 @ Xs3 ) ) ) ) ) ) ) ).

% list_encode.pelims
thf(fact_6895_concat__inth,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = X ) ).

% concat_inth
thf(fact_6896_length__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_6897_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs2 @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_6898_size__list__append,axiom,
    ! [A: $tType,F3: A > nat,Xs2: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F3 @ ( append @ A @ Xs2 @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F3 @ Xs2 ) @ ( size_list @ A @ F3 @ Ys ) ) ) ).

% size_list_append
thf(fact_6899_nth__append__length__plus,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,N: nat] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) )
      = ( nth @ A @ Ys @ N ) ) ).

% nth_append_length_plus
thf(fact_6900_take__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( take @ A @ N @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( take @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys ) ) ) ).

% take_append
thf(fact_6901_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_6902_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_6903_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) @ ( enumerate @ A @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_6904_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs2 @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
               => ! [Y6: A] :
                    ( ( member @ A @ Y6 @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X3 @ Y6 ) ) ) ) ) ) ).

% sorted_append
thf(fact_6905_length__append__singleton,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_append_singleton
thf(fact_6906_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N ) )
      = ( ? [Y6: A,Ys2: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys2 @ ( cons @ A @ Y6 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys2 )
              = N ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_6907_nth__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ N )
          = ( nth @ A @ Xs2 @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ N )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nth_append
thf(fact_6908_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ N @ X )
          = ( append @ A @ ( list_update @ A @ Xs2 @ N @ X ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ N @ X )
          = ( append @ A @ Xs2 @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_6909_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F3: B > A,A2: A,Xs2: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ ( append @ B @ Xs2 @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ Xs2 ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs2 ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F3 @ A2 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_6910_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
               => ( ord_less_eq @ A @ X4 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X3: A] : X3
                @ A2
                @ Xs2 )
              = ( append @ A @ Xs2 @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_6911_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( take @ A @ ( suc @ I ) @ Xs2 )
        = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( cons @ A @ ( nth @ A @ Xs2 @ I ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_6912_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs2: list @ A,N: nat,X: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( M != N )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) @ M )
            = ( nth @ A @ Xs2 @ M ) ) ) ) ) ).

% nth_repl
thf(fact_6913_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Y: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( append @ A @ ( cons @ A @ Y @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N ) @ Xs2 ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_6914_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X3: list @ A] : X3 ) ) ).

% drop0
thf(fact_6915_drop__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A] :
      ( ( drop @ A @ N @ ( drop @ A @ M @ Xs2 ) )
      = ( drop @ A @ ( plus_plus @ nat @ N @ M ) @ Xs2 ) ) ).

% drop_drop
thf(fact_6916_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ ( cons @ A @ X @ Xs2 ) )
      = ( drop @ A @ N @ Xs2 ) ) ).

% drop_Suc_Cons
thf(fact_6917_length__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% length_drop
thf(fact_6918_drop__all,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N )
     => ( ( drop @ A @ N @ Xs2 )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_6919_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( drop @ A @ N @ Xs2 )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% drop_eq_Nil
thf(fact_6920_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N @ Xs2 ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% drop_eq_Nil2
thf(fact_6921_drop__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( drop @ A @ N @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ A @ ( drop @ A @ N @ Xs2 ) @ ( drop @ A @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys ) ) ) ).

% drop_append
thf(fact_6922_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs2: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X @ Xs2 ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs2 ) ) ).

% drop_Cons_numeral
thf(fact_6923_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,I: nat] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( drop @ A @ N @ Xs2 ) @ I )
        = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ N @ I ) ) ) ) ).

% nth_drop
thf(fact_6924_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N @ Xs2 ) ) ) ) ).

% sorted_drop
thf(fact_6925_drop__0,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs2 )
      = Xs2 ) ).

% drop_0
thf(fact_6926_drop__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A] :
      ( ( drop @ A @ N @ ( take @ A @ M @ Xs2 ) )
      = ( take @ A @ ( minus_minus @ nat @ M @ N ) @ ( drop @ A @ N @ Xs2 ) ) ) ).

% drop_take
thf(fact_6927_take__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A] :
      ( ( take @ A @ N @ ( drop @ A @ M @ Xs2 ) )
      = ( drop @ A @ M @ ( take @ A @ ( plus_plus @ nat @ N @ M ) @ Xs2 ) ) ) ).

% take_drop
thf(fact_6928_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_drop_subset
thf(fact_6929_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs2 ) ) @ ( set2 @ A @ ( drop @ A @ N @ Xs2 ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_6930_take__add,axiom,
    ! [A: $tType,I: nat,J: nat,Xs2: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I @ J ) @ Xs2 )
      = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( take @ A @ J @ ( drop @ A @ I @ Xs2 ) ) ) ) ).

% take_add
thf(fact_6931_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs2: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs2 @ N @ X ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs2 ) @ ( minus_minus @ nat @ N @ M ) @ X ) ) ) ).

% drop_update_swap
thf(fact_6932_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ Xs2 ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs2 ) )
          = ( drop @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) ) ).

% drop_Cons'
thf(fact_6933_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_6934_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( cons @ A @ ( nth @ A @ Xs2 @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs2 ) )
        = ( drop @ A @ I @ Xs2 ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_6935_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I: nat,J: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_6936_id__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( Xs2
        = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( cons @ A @ ( nth @ A @ Xs2 @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs2 ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_6937_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A,A2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( list_update @ A @ Xs2 @ I @ A2 )
        = ( append @ A @ ( take @ A @ I @ Xs2 ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I ) @ Xs2 ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_6938_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ~ ! [L2: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F3 @ L2 ) )
               => ( ( ( set2 @ B @ L2 )
                    = A3 )
                 => ( ( size_size @ ( list @ B ) @ L2 )
                   != ( finite_card @ B @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_6939_upto_Opsimps,axiom,
    ! [I: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I @ J ) )
     => ( ( ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_6940_nth__upto,axiom,
    ! [I: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I @ J ) @ K )
        = ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_6941_length__upto,axiom,
    ! [I: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_6942_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_6943_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_6944_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_6945_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_6946_sorted__upto,axiom,
    ! [M: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N ) ) ).

% sorted_upto
thf(fact_6947_upto__split2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_6948_upto__split1,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_6949_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I3: int,J3: int] : ( set2 @ int @ ( upto @ I3 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_6950_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I3: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_6951_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X3: A] : X3 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_6952_upto_Osimps,axiom,
    ( upto
    = ( ^ [I3: int,J3: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I3 @ J3 ) @ ( cons @ int @ I3 @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J3 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_6953_upto_Oelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_6954_upto__rec1,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_6955_upto__rec2,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_6956_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I3: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_6957_upto__split3,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_6958_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_6959_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F3 @ L ) )
              & ( ( set2 @ B @ L )
                = A3 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A3 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_6960_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_6961_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B,B4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( ord_less_eq @ ( set @ B ) @ B4 @ S2 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ B4 ) )
           => ( ( finite_finite @ B @ A3 )
             => ( ( finite_finite @ B @ B4 )
               => ( A3 = B4 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_6962_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) )
            = A3 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_6963_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) )
          = ( finite_card @ B @ A3 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_6964_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( distinct @ A @ ( map @ B @ A @ F3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_6965_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_6966_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F3 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_6967_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 )
              = ( nil @ B ) )
            = ( A3
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_6968_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,Xs2: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ S2 )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F3 @ Xs2 ) )
         => ( ( distinct @ B @ Xs2 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( set2 @ B @ Xs2 ) )
              = Xs2 ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_6969_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( insert @ B @ X @ A3 ) )
            = ( insort_key @ A @ B @ Less_eq @ F3 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_6970_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F3: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ ( insert @ B @ X @ A3 ) )
              = ( insort_key @ A @ B @ Less_eq @ F3 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F3 @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_6971_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( append @ A @ ( take @ A @ N @ Xs2 ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N @ Xs2 ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N ) @ Xs2 ) ) ) ).

% take_hd_drop
thf(fact_6972_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_6973_drop__upt,axiom,
    ! [M: nat,I: nat,J: nat] :
      ( ( drop @ nat @ M @ ( upt @ I @ J ) )
      = ( upt @ ( plus_plus @ nat @ I @ M ) @ J ) ) ).

% drop_upt
thf(fact_6974_take__upt,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ M ) @ N )
     => ( ( take @ nat @ M @ ( upt @ I @ N ) )
        = ( upt @ I @ ( plus_plus @ nat @ I @ M ) ) ) ) ).

% take_upt
thf(fact_6975_upt__conv__Nil,axiom,
    ! [J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( upt @ I @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_6976_length__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I @ J ) )
      = ( minus_minus @ nat @ J @ I ) ) ).

% length_upt
thf(fact_6977_hd__take,axiom,
    ! [A: $tType,J: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J )
     => ( ( hd @ A @ ( take @ A @ J @ Xs2 ) )
        = ( hd @ A @ Xs2 ) ) ) ).

% hd_take
thf(fact_6978_upt__eq__Nil__conv,axiom,
    ! [I: nat,J: nat] :
      ( ( ( upt @ I @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I ) ) ) ).

% upt_eq_Nil_conv
thf(fact_6979_nth__upt,axiom,
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ K ) ) ) ).

% nth_upt
thf(fact_6980_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X3: nat] : X3
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum_list_upt
thf(fact_6981_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_6982_upt__0,axiom,
    ! [I: nat] :
      ( ( upt @ I @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_6983_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list @ nat,Q2: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N @ Ns ) )
        = ( upt @ M @ Q2 ) )
      = ( ( cons @ nat @ N @ Ns )
        = ( upt @ ( suc @ M ) @ Q2 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_6984_map__add__upt,axiom,
    ! [N: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I3: nat] : ( plus_plus @ nat @ I3 @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N @ ( plus_plus @ nat @ M @ N ) ) ) ).

% map_add_upt
thf(fact_6985_map__Suc__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% map_Suc_upt
thf(fact_6986_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ N2 @ ( suc @ M3 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_6987_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast_upt
thf(fact_6988_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ ( suc @ M3 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_6989_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ M3 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_6990_sorted__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_upt
thf(fact_6991_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ) ) ) ).

% atMost_upto
thf(fact_6992_hd__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs2 )
        = ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_6993_upt__conv__Cons,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( upt @ I @ J )
        = ( cons @ nat @ I @ ( upt @ ( suc @ I ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_6994_map__decr__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N ) ) )
      = ( upt @ M @ N ) ) ).

% map_decr_upt
thf(fact_6995_upt__add__eq__append,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_6996_upt__eq__Cons__conv,axiom,
    ! [I: nat,J: nat,X: nat,Xs2: list @ nat] :
      ( ( ( upt @ I @ J )
        = ( cons @ nat @ X @ Xs2 ) )
      = ( ( ord_less @ nat @ I @ J )
        & ( I = X )
        & ( ( upt @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) @ J )
          = Xs2 ) ) ) ).

% upt_eq_Cons_conv
thf(fact_6997_upt__rec,axiom,
    ( upt
    = ( ^ [I3: nat,J3: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I3 @ J3 ) @ ( cons @ nat @ I3 @ ( upt @ ( suc @ I3 ) @ J3 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_6998_map__upt__Suc,axiom,
    ! [A: $tType,F3: nat > A,N: nat] :
      ( ( map @ nat @ A @ F3 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F3 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I3: nat] : ( F3 @ ( suc @ I3 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_6999_map__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs2 ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
      = Xs2 ) ).

% map_nth
thf(fact_7000_nth__map__upt,axiom,
    ! [A: $tType,I: nat,N: nat,M: nat,F3: nat > A] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ N @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F3 @ ( upt @ M @ N ) ) @ I )
        = ( F3 @ ( plus_plus @ nat @ M @ I ) ) ) ) ).

% nth_map_upt
thf(fact_7001_upt__Suc__append,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_7002_upt__Suc,axiom,
    ! [I: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_7003_map__upt__eqI,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,M: nat,F3: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( minus_minus @ nat @ N @ M ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( nth @ A @ Xs2 @ I2 )
              = ( F3 @ ( plus_plus @ nat @ M @ I2 ) ) ) )
       => ( ( map @ nat @ A @ F3 @ ( upt @ M @ N ) )
          = Xs2 ) ) ) ).

% map_upt_eqI
thf(fact_7004_transpose__rectangle,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N: nat] :
      ( ( ( Xs2
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I2 ) )
              = N ) )
       => ( ( transpose @ A @ Xs2 )
          = ( map @ nat @ ( list @ A )
            @ ^ [I3: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J3 ) @ I3 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_7005_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs2: list @ B,F3: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X3: B] :
                        ( ( F3 @ A2 )
                        = ( F3 @ X3 ) )
                    @ Xs2 ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F3 @ A2 @ ( remove1 @ B @ A2 @ Xs2 ) )
                = Xs2 ) ) ) ) ) ).

% insort_key_remove1
thf(fact_7006_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs2: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ).

% sorted_filter
thf(fact_7007_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs2: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X3: A] :
                ( X3
                = ( G @ Xs2 ) )
            @ Xs2 ) ) ) ).

% sorted_same
thf(fact_7008_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_filter_le
thf(fact_7009_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X3: A] :
                ~ ( P @ X3 )
            @ Xs2 ) ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% sum_length_filter_compl
thf(fact_7010_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% filter_is_subset
thf(fact_7011_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,G: ( list @ B ) > A,Xs2: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F3
            @ ( filter2 @ B
              @ ^ [X3: B] :
                  ( ( F3 @ X3 )
                  = ( G @ Xs2 ) )
              @ Xs2 ) ) ) ) ).

% sorted_map_same
thf(fact_7012_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F3: B > A,P: B > $o,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ ( filter2 @ B @ P @ Xs2 ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X3: B] : ( if @ A @ ( P @ X3 ) @ ( F3 @ X3 ) @ ( zero_zero @ A ) )
              @ Xs2 ) ) ) ) ).

% sum_list_map_filter'
thf(fact_7013_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F3: A > nat,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ ( filter2 @ A @ P @ Xs2 ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F3 @ Xs2 ) ) ) ).

% sum_list_filter_le_nat
thf(fact_7014_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ B,P: B > $o,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ ( set2 @ B @ Xs2 ) )
             => ( ~ ( P @ X4 )
               => ( ( F3 @ X4 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ ( filter2 @ B @ P @ Xs2 ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F3 @ Xs2 ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_7015_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs2: list @ B,P: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) )
         => ( ( P @ X )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F3 @ X @ Xs2 ) )
              = ( linorder_insort_key @ B @ A @ F3 @ X @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ) ).

% filter_insort
thf(fact_7016_set__minus__filter__out,axiom,
    ! [A: $tType,Xs2: list @ A,Y: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X3: A] : ( X3 != Y )
          @ Xs2 ) ) ) ).

% set_minus_filter_out
thf(fact_7017_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys2 ) )
                @ Xs2 ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs2 ) @ I ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J ) @ I ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_7018_transpose__column,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys2: list @ A] : ( nth @ A @ Ys2 @ I )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( nth @ ( list @ A ) @ Xs2 @ I ) ) ) ) ).

% transpose_column
thf(fact_7019_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( drop @ A @ N @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) @ Xs2 ) ) ) ).

% drop_rev
thf(fact_7020_rev__drop,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I @ Xs2 ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I ) @ ( rev @ A @ Xs2 ) ) ) ).

% rev_drop
thf(fact_7021_rev__take,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( rev @ A @ ( take @ A @ I @ Xs2 ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I ) @ ( rev @ A @ Xs2 ) ) ) ).

% rev_take
thf(fact_7022_take__rev,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( take @ A @ N @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) @ Xs2 ) ) ) ).

% take_rev
thf(fact_7023_rotate__rev,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( rotate @ A @ N @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) @ Xs2 ) ) ) ).

% rotate_rev
thf(fact_7024_sorted__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) ) ) ).

% sorted_transpose
thf(fact_7025_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rev @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_7026_rev__update,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,Y: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs2 @ K @ Y ) )
        = ( list_update @ A @ ( rev @ A @ Xs2 ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ K ) @ ( one_one @ nat ) ) @ Y ) ) ) ).

% rev_update
thf(fact_7027_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I3: nat] :
                ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ ( suc @ I3 ) ) @ ( nth @ A @ Xs2 @ I3 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_7028_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J ) @ ( nth @ A @ Xs2 @ I ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_7029_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I3: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J3 ) @ ( nth @ A @ Xs2 @ I3 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_7030_transpose__column__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I ) ) ) ) ) ).

% transpose_column_length
thf(fact_7031_length__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ( Xs2
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs2
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_7032_transpose__max__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( transpose @ A @ Xs2 )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X3: list @ A] :
              ( X3
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_max_length
thf(fact_7033_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X3: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X3 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys2: list @ B] :
                  ( Ys2
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_7034_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_7035_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs: list @ B] :
              ( foldr @ B @ A
              @ ^ [X3: B,B3: A] : ( plus_plus @ A @ ( F5 @ X3 ) @ ( times_times @ A @ A4 @ B3 ) )
              @ Xs
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_7036_length__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs ) )
        @ Xs2
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_7037_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Y: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ( Xs2
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y )
                = Y ) )
            & ( ( Xs2
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y )
                = ( ord_max @ A @ ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) @ Y ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_7038_transpose__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs2 ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X3: list @ A] :
              ( X3
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_transpose
thf(fact_7039_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs2: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F3 @ Xs2 ) ) )
         => ( ( filter2 @ B
              @ ^ [X3: B] : ( ord_less @ A @ T2 @ ( F3 @ X3 ) )
              @ Xs2 )
            = ( takeWhile @ B
              @ ^ [X3: B] : ( ord_less @ A @ T2 @ ( F3 @ X3 ) )
              @ Xs2 ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_7040_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_takeWhile_le
thf(fact_7041_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ).

% sorted_takeWhile
thf(fact_7042_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs2: list @ A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ J )
         => ( P @ ( nth @ A @ Xs2 @ I2 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_7043_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_7044_nths__Cons,axiom,
    ! [A: $tType,X: A,L: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L ) @ A3 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( suc @ J3 ) @ A3 ) ) ) ) ) ).

% nths_Cons
thf(fact_7045_nths__singleton,axiom,
    ! [A: $tType,A3: set @ nat,X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A3 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A3 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_7046_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I5: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs2 @ I5 ) ) ) ) ).

% sorted_nths
thf(fact_7047_set__nths__subset,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_nths_subset
thf(fact_7048_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N2: nat,Xs: list @ A] : ( nths @ A @ Xs @ ( collect @ nat @ ( ord_less_eq @ nat @ N2 ) ) ) ) ) ).

% drop_eq_nths
thf(fact_7049_nths__drop,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,I5: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N @ Xs2 ) @ I5 )
      = ( nths @ A @ Xs2 @ ( image @ nat @ nat @ ( plus_plus @ nat @ N ) @ I5 ) ) ) ).

% nths_drop
thf(fact_7050_nths__append,axiom,
    ! [A: $tType,L: list @ A,L3: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L @ L3 ) @ A3 )
      = ( append @ A @ ( nths @ A @ L @ A3 )
        @ ( nths @ A @ L3
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( plus_plus @ nat @ J3 @ ( size_size @ ( list @ A ) @ L ) ) @ A3 ) ) ) ) ) ).

% nths_append
thf(fact_7051_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F5: A > nat,Xs: list @ A] :
            ( if @ nat
            @ ( Xs
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F5 @ ( hd @ A @ Xs ) ) @ ( size_list @ A @ F5 @ ( tl @ A @ Xs ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_7052_finite__sequence__to__countable__set,axiom,
    ! [A: $tType,X9: set @ A] :
      ( ( countable_countable @ A @ X9 )
     => ~ ! [F7: nat > ( set @ A )] :
            ( ! [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( F7 @ I4 ) @ X9 )
           => ( ! [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( F7 @ I4 ) @ ( F7 @ ( suc @ I4 ) ) )
             => ( ! [I4: nat] : ( finite_finite @ A @ ( F7 @ I4 ) )
               => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F7 @ ( top_top @ ( set @ nat ) ) ) )
                 != X9 ) ) ) ) ) ).

% finite_sequence_to_countable_set
thf(fact_7053_countable__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( countable_countable @ A @ A3 )
     => ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% countable_Diff
thf(fact_7054_tl__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( tl @ nat @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ N ) ) ).

% tl_upt
thf(fact_7055_countable__Diff__eq,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( countable_countable @ A @ A3 ) ) ).

% countable_Diff_eq
thf(fact_7056_length__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_7057_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( drop @ A @ ( suc @ N ) @ Xs2 )
      = ( drop @ A @ N @ ( tl @ A @ Xs2 ) ) ) ).

% drop_Suc
thf(fact_7058_take__tl,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( take @ A @ N @ ( tl @ A @ Xs2 ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N ) @ Xs2 ) ) ) ).

% take_tl
thf(fact_7059_uncountable__minus__countable,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ~ ( countable_countable @ A @ A3 )
     => ( ( countable_countable @ A @ B4 )
       => ~ ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% uncountable_minus_countable
thf(fact_7060_ccInf__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( countable_countable @ A @ B4 )
         => ( ( countable_countable @ A @ A3 )
           => ( ! [B5: A] :
                  ( ( member @ A @ B5 @ B4 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A3 )
                      & ( ord_less_eq @ A @ X5 @ B5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ) ) ).

% ccInf_mono
thf(fact_7061_ccInf__lower,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X ) ) ) ) ).

% ccInf_lower
thf(fact_7062_ccInf__lower2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,U: A,V: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( member @ A @ U @ A3 )
           => ( ( ord_less_eq @ A @ U @ V )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ V ) ) ) ) ) ).

% ccInf_lower2
thf(fact_7063_le__ccInf__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A3 ) )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A3 )
                 => ( ord_less_eq @ A @ B2 @ X3 ) ) ) ) ) ) ).

% le_ccInf_iff
thf(fact_7064_ccInf__greatest,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ A3 )
               => ( ord_less_eq @ A @ Z @ X4 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ).

% ccInf_greatest
thf(fact_7065_infinite__countable__subset_H,axiom,
    ! [A: $tType,X9: set @ A] :
      ( ~ ( finite_finite @ A @ X9 )
     => ? [C7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ C7 @ X9 )
          & ( countable_countable @ A @ C7 )
          & ~ ( finite_finite @ A @ C7 ) ) ) ).

% infinite_countable_subset'
thf(fact_7066_countable__Collect__finite__subset,axiom,
    ! [A: $tType,T5: set @ A] :
      ( ( countable_countable @ A @ T5 )
     => ( countable_countable @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [A6: set @ A] :
              ( ( finite_finite @ A @ A6 )
              & ( ord_less_eq @ ( set @ A ) @ A6 @ T5 ) ) ) ) ) ).

% countable_Collect_finite_subset
thf(fact_7067_countable__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( countable_countable @ A @ B4 )
       => ( countable_countable @ A @ A3 ) ) ) ).

% countable_subset
thf(fact_7068_ccSup__upper2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,U: A,V: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( member @ A @ U @ A3 )
           => ( ( ord_less_eq @ A @ V @ U )
             => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% ccSup_upper2
thf(fact_7069_ccSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ B2 )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A3 )
                 => ( ord_less_eq @ A @ X3 @ B2 ) ) ) ) ) ) ).

% ccSup_le_iff
thf(fact_7070_ccSup__upper,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% ccSup_upper
thf(fact_7071_ccSup__least,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ( countable_countable @ A @ A3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ A3 )
               => ( ord_less_eq @ A @ X4 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ Z ) ) ) ) ).

% ccSup_least
thf(fact_7072_ccSup__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( countable_countable @ A @ B4 )
         => ( ( countable_countable @ A @ A3 )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A3 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ B4 )
                      & ( ord_less_eq @ A @ A5 @ X5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ) ).

% ccSup_mono
thf(fact_7073_countable__image__eq,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F3 @ S2 ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( ( image @ B @ A @ F3 @ S2 )
              = ( image @ B @ A @ F3 @ T9 ) ) ) ) ) ).

% countable_image_eq
thf(fact_7074_countable__subset__image,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,F3: B > A,A3: set @ B] :
      ( ( ( countable_countable @ A @ B4 )
        & ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F3 @ A3 ) ) )
      = ( ? [A18: set @ B] :
            ( ( countable_countable @ B @ A18 )
            & ( ord_less_eq @ ( set @ B ) @ A18 @ A3 )
            & ( B4
              = ( image @ B @ A @ F3 @ A18 ) ) ) ) ) ).

% countable_subset_image
thf(fact_7075_ex__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( countable_countable @ A @ T9 )
            & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F3 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( P @ ( image @ B @ A @ F3 @ T9 ) ) ) ) ) ).

% ex_countable_subset_image
thf(fact_7076_all__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ( countable_countable @ A @ T9 )
              & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F3 @ S2 ) ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( countable_countable @ B @ T9 )
              & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 ) )
           => ( P @ ( image @ B @ A @ F3 @ T9 ) ) ) ) ) ).

% all_countable_subset_image
thf(fact_7077_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs2 ) ) ) ) ).

% sorted_tl
thf(fact_7078_ccSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( countable_countable @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ).

% ccSup_subset_mono
thf(fact_7079_ccInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ) ).

% ccInf_superset_mono
thf(fact_7080_all__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ( countable_countable @ A @ T9 )
              & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F3 @ S2 ) ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( countable_countable @ B @ T9 )
              & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
              & ( inj_on @ B @ A @ F3 @ T9 ) )
           => ( P @ ( image @ B @ A @ F3 @ T9 ) ) ) ) ) ).

% all_countable_subset_image_inj
thf(fact_7081_ex__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( countable_countable @ A @ T9 )
            & ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F3 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( inj_on @ B @ A @ F3 @ T9 )
            & ( P @ ( image @ B @ A @ F3 @ T9 ) ) ) ) ) ).

% ex_countable_subset_image_inj
thf(fact_7082_countable__image__eq__inj,axiom,
    ! [A: $tType,B: $tType,F3: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F3 @ S2 ) )
      = ( ? [T9: set @ B] :
            ( ( countable_countable @ B @ T9 )
            & ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( ( image @ B @ A @ F3 @ S2 )
              = ( image @ B @ A @ F3 @ T9 ) )
            & ( inj_on @ B @ A @ F3 @ T9 ) ) ) ) ).

% countable_image_eq_inj
thf(fact_7083_ccSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,I: B,U: A,F3: B > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( member @ B @ I @ A3 )
           => ( ( ord_less_eq @ A @ U @ ( F3 @ I ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ) ).

% ccSUP_upper2
thf(fact_7084_ccSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,F3: B > A,U: A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A3 )
                 => ( ord_less_eq @ A @ ( F3 @ X3 ) @ U ) ) ) ) ) ) ).

% ccSUP_le_iff
thf(fact_7085_ccSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,I: B,F3: B > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( member @ B @ I @ A3 )
           => ( ord_less_eq @ A @ ( F3 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ).

% ccSUP_upper
thf(fact_7086_ccSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,F3: B > A,U: A] :
          ( ( countable_countable @ B @ A3 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A3 )
               => ( ord_less_eq @ A @ ( F3 @ I2 ) @ U ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U ) ) ) ) ).

% ccSUP_least
thf(fact_7087_ccSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,B4: set @ C,F3: B > A,G: C > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( countable_countable @ C @ B4 )
           => ( ! [N3: B] :
                  ( ( member @ B @ N3 @ A3 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ B4 )
                      & ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( G @ X5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ) ).

% ccSUP_mono
thf(fact_7088_ccINF__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,B4: set @ C,F3: B > A,G: C > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( countable_countable @ C @ B4 )
           => ( ! [M2: C] :
                  ( ( member @ C @ M2 @ B4 )
                 => ? [X5: B] :
                      ( ( member @ B @ X5 @ A3 )
                      & ( ord_less_eq @ A @ ( F3 @ X5 ) @ ( G @ M2 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ) ).

% ccINF_mono
thf(fact_7089_ccINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,I: B,F3: B > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( member @ B @ I @ A3 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( F3 @ I ) ) ) ) ) ).

% ccINF_lower
thf(fact_7090_ccINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,I: B,F3: B > A,U: A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( member @ B @ I @ A3 )
           => ( ( ord_less_eq @ A @ ( F3 @ I ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U ) ) ) ) ) ).

% ccINF_lower2
thf(fact_7091_le__ccINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,U: A,F3: B > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
            = ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A3 )
                 => ( ord_less_eq @ A @ U @ ( F3 @ X3 ) ) ) ) ) ) ) ).

% le_ccINF_iff
thf(fact_7092_ccINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,U: A,F3: B > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A3 )
               => ( ord_less_eq @ A @ U @ ( F3 @ I2 ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ).

% ccINF_greatest
thf(fact_7093_tl__take,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( tl @ A @ ( take @ A @ N @ Xs2 ) )
      = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( tl @ A @ Xs2 ) ) ) ).

% tl_take
thf(fact_7094_ccSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( countable_countable @ A @ B4 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ) ).

% ccSup_inter_less_eq
thf(fact_7095_less__eq__ccInf__inter,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( countable_countable @ A @ A3 )
         => ( ( countable_countable @ A @ B4 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% less_eq_ccInf_inter
thf(fact_7096_ccSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B4: set @ B,A3: set @ B,F3: B > A,G: B > A] :
          ( ( countable_countable @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ A3 )
                 => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% ccSUP_subset_mono
thf(fact_7097_ccINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: set @ B,B4: set @ B,F3: B > A,G: B > A] :
          ( ( countable_countable @ B @ A3 )
         => ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
           => ( ! [X4: B] :
                  ( ( member @ B @ X4 @ B4 )
                 => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% ccINF_superset_mono
thf(fact_7098_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs: list @ A] :
            ( if @ nat
            @ ( Xs
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_7099_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( suc @ N ) ) ) ) ).

% nth_tl
thf(fact_7100_take__Suc,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N ) @ Xs2 )
        = ( cons @ A @ ( hd @ A @ Xs2 ) @ ( take @ A @ N @ ( tl @ A @ Xs2 ) ) ) ) ) ).

% take_Suc
thf(fact_7101_vanishes__mult__bounded,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ? [A17: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ A17 )
          & ! [N3: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X9 @ N3 ) ) @ A17 ) )
     => ( ( vanishes @ Y8 )
       => ( vanishes
          @ ^ [N2: nat] : ( times_times @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ).

% vanishes_mult_bounded
thf(fact_7102_cauchy__def,axiom,
    ( cauchy
    = ( ^ [X8: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K2: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ K2 @ M3 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K2 @ N2 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M3 ) @ ( X8 @ N2 ) ) ) @ R5 ) ) ) ) ) ) ).

% cauchy_def
thf(fact_7103_vanishes__const,axiom,
    ! [C2: rat] :
      ( ( vanishes
        @ ^ [N2: nat] : C2 )
      = ( C2
        = ( zero_zero @ rat ) ) ) ).

% vanishes_const
thf(fact_7104_cauchy__not__vanishes,axiom,
    ! [X9: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ~ ( vanishes @ X9 )
       => ? [B5: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B5 )
            & ? [K3: nat] :
              ! [N4: nat] :
                ( ( ord_less_eq @ nat @ K3 @ N4 )
               => ( ord_less @ rat @ B5 @ ( abs_abs @ rat @ ( X9 @ N4 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes
thf(fact_7105_cauchy__not__vanishes__cases,axiom,
    ! [X9: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ~ ( vanishes @ X9 )
       => ? [B5: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B5 )
            & ? [K3: nat] :
                ( ! [N4: nat] :
                    ( ( ord_less_eq @ nat @ K3 @ N4 )
                   => ( ord_less @ rat @ B5 @ ( uminus_uminus @ rat @ ( X9 @ N4 ) ) ) )
                | ! [N4: nat] :
                    ( ( ord_less_eq @ nat @ K3 @ N4 )
                   => ( ord_less @ rat @ B5 @ ( X9 @ N4 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
thf(fact_7106_vanishes__diff,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( vanishes @ X9 )
     => ( ( vanishes @ Y8 )
       => ( vanishes
          @ ^ [N2: nat] : ( minus_minus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ).

% vanishes_diff
thf(fact_7107_cauchy__diff,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( cauchy @ Y8 )
       => ( cauchy
          @ ^ [N2: nat] : ( minus_minus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ).

% cauchy_diff
thf(fact_7108_cauchy__mult,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( cauchy @ Y8 )
       => ( cauchy
          @ ^ [N2: nat] : ( times_times @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ).

% cauchy_mult
thf(fact_7109_vanishes__diff__inverse,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ~ ( vanishes @ X9 )
       => ( ( cauchy @ Y8 )
         => ( ~ ( vanishes @ Y8 )
           => ( ( vanishes
                @ ^ [N2: nat] : ( minus_minus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) )
             => ( vanishes
                @ ^ [N2: nat] : ( minus_minus @ rat @ ( inverse_inverse @ rat @ ( X9 @ N2 ) ) @ ( inverse_inverse @ rat @ ( Y8 @ N2 ) ) ) ) ) ) ) ) ) ).

% vanishes_diff_inverse
thf(fact_7110_cauchy__imp__bounded,axiom,
    ! [X9: nat > rat] :
      ( ( cauchy @ X9 )
     => ? [B5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B5 )
          & ! [N4: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X9 @ N4 ) ) @ B5 ) ) ) ).

% cauchy_imp_bounded
thf(fact_7111_vanishes__def,axiom,
    ( vanishes
    = ( ^ [X8: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K2: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K2 @ N2 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N2 ) ) @ R5 ) ) ) ) ) ).

% vanishes_def
thf(fact_7112_vanishesI,axiom,
    ! [X9: nat > rat] :
      ( ! [R4: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R4 )
         => ? [K4: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N3 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X9 @ N3 ) ) @ R4 ) ) )
     => ( vanishes @ X9 ) ) ).

% vanishesI
thf(fact_7113_vanishesD,axiom,
    ! [X9: nat > rat,R: rat] :
      ( ( vanishes @ X9 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
       => ? [K3: nat] :
          ! [N4: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N4 )
           => ( ord_less @ rat @ ( abs_abs @ rat @ ( X9 @ N4 ) ) @ R ) ) ) ) ).

% vanishesD
thf(fact_7114_cauchyD,axiom,
    ! [X9: nat > rat,R: rat] :
      ( ( cauchy @ X9 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
       => ? [K3: nat] :
          ! [M4: nat] :
            ( ( ord_less_eq @ nat @ K3 @ M4 )
           => ! [N4: nat] :
                ( ( ord_less_eq @ nat @ K3 @ N4 )
               => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X9 @ M4 ) @ ( X9 @ N4 ) ) ) @ R ) ) ) ) ) ).

% cauchyD
thf(fact_7115_cauchyI,axiom,
    ! [X9: nat > rat] :
      ( ! [R4: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R4 )
         => ? [K4: nat] :
            ! [M2: nat] :
              ( ( ord_less_eq @ nat @ K4 @ M2 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X9 @ M2 ) @ ( X9 @ N3 ) ) ) @ R4 ) ) ) )
     => ( cauchy @ X9 ) ) ).

% cauchyI
thf(fact_7116_le__Real,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( cauchy @ Y8 )
       => ( ( ord_less_eq @ real @ ( real2 @ X9 ) @ ( real2 @ Y8 ) )
          = ( ! [R5: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
               => ? [K2: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N2 )
                   => ( ord_less_eq @ rat @ ( X9 @ N2 ) @ ( plus_plus @ rat @ ( Y8 @ N2 ) @ R5 ) ) ) ) ) ) ) ) ).

% le_Real
thf(fact_7117_inverse__Real,axiom,
    ! [X9: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( ( vanishes @ X9 )
         => ( ( inverse_inverse @ real @ ( real2 @ X9 ) )
            = ( zero_zero @ real ) ) )
        & ( ~ ( vanishes @ X9 )
         => ( ( inverse_inverse @ real @ ( real2 @ X9 ) )
            = ( real2
              @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X9 @ N2 ) ) ) ) ) ) ) ).

% inverse_Real
thf(fact_7118_one__real__def,axiom,
    ( ( one_one @ real )
    = ( real2
      @ ^ [N2: nat] : ( one_one @ rat ) ) ) ).

% one_real_def
thf(fact_7119_zero__real__def,axiom,
    ( ( zero_zero @ real )
    = ( real2
      @ ^ [N2: nat] : ( zero_zero @ rat ) ) ) ).

% zero_real_def
thf(fact_7120_mult__Real,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( cauchy @ Y8 )
       => ( ( times_times @ real @ ( real2 @ X9 ) @ ( real2 @ Y8 ) )
          = ( real2
            @ ^ [N2: nat] : ( times_times @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ) ).

% mult_Real
thf(fact_7121_diff__Real,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( cauchy @ Y8 )
       => ( ( minus_minus @ real @ ( real2 @ X9 ) @ ( real2 @ Y8 ) )
          = ( real2
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ) ).

% diff_Real
thf(fact_7122_eq__Real,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( cauchy @ Y8 )
       => ( ( ( real2 @ X9 )
            = ( real2 @ Y8 ) )
          = ( vanishes
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ) ).

% eq_Real
thf(fact_7123_not__positive__Real,axiom,
    ! [X9: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( ~ ( positive2 @ ( real2 @ X9 ) ) )
        = ( ! [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
             => ? [K2: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K2 @ N2 )
                 => ( ord_less_eq @ rat @ ( X9 @ N2 ) @ R5 ) ) ) ) ) ) ).

% not_positive_Real
thf(fact_7124_positive__Real,axiom,
    ! [X9: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( positive2 @ ( real2 @ X9 ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K2: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K2 @ N2 )
                 => ( ord_less @ rat @ R5 @ ( X9 @ N2 ) ) ) ) ) ) ) ).

% positive_Real
thf(fact_7125_Real_Opositive__zero,axiom,
    ~ ( positive2 @ ( zero_zero @ real ) ) ).

% Real.positive_zero
thf(fact_7126_Real_Opositive__mult,axiom,
    ! [X: real,Y: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y )
       => ( positive2 @ ( times_times @ real @ X @ Y ) ) ) ) ).

% Real.positive_mult
thf(fact_7127_Real_Opositive__minus,axiom,
    ! [X: real] :
      ( ~ ( positive2 @ X )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( positive2 @ ( uminus_uminus @ real @ X ) ) ) ) ).

% Real.positive_minus
thf(fact_7128_less__real__def,axiom,
    ( ( ord_less @ real )
    = ( ^ [X3: real,Y6: real] : ( positive2 @ ( minus_minus @ real @ Y6 @ X3 ) ) ) ) ).

% less_real_def
thf(fact_7129_Real_Opositive_Orep__eq,axiom,
    ( positive2
    = ( ^ [X3: real] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K2: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K2 @ N2 )
             => ( ord_less @ rat @ R5 @ ( rep_real @ X3 @ N2 ) ) ) ) ) ) ).

% Real.positive.rep_eq
thf(fact_7130_inverse__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( inverse_inverse @ real @ ( real2 @ X ) )
        = ( real2
          @ ( if @ ( nat > rat ) @ ( vanishes @ X )
            @ ^ [N2: nat] : ( zero_zero @ rat )
            @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X @ N2 ) ) ) ) ) ) ).

% inverse_real.abs_eq
thf(fact_7131_one__real_Orsp,axiom,
    ( realrel
    @ ^ [N2: nat] : ( one_one @ rat )
    @ ^ [N2: nat] : ( one_one @ rat ) ) ).

% one_real.rsp
thf(fact_7132_zero__real_Orsp,axiom,
    ( realrel
    @ ^ [N2: nat] : ( zero_zero @ rat )
    @ ^ [N2: nat] : ( zero_zero @ rat ) ) ).

% zero_real.rsp
thf(fact_7133_times__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X @ X )
       => ( ( times_times @ real @ ( real2 @ Xa ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N2: nat] : ( times_times @ rat @ ( Xa @ N2 ) @ ( X @ N2 ) ) ) ) ) ) ).

% times_real.abs_eq
thf(fact_7134_realrelI,axiom,
    ! [X9: nat > rat,Y8: nat > rat] :
      ( ( cauchy @ X9 )
     => ( ( cauchy @ Y8 )
       => ( ( vanishes
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) )
         => ( realrel @ X9 @ Y8 ) ) ) ) ).

% realrelI
thf(fact_7135_realrel__def,axiom,
    ( realrel
    = ( ^ [X8: nat > rat,Y9: nat > rat] :
          ( ( cauchy @ X8 )
          & ( cauchy @ Y9 )
          & ( vanishes
            @ ^ [N2: nat] : ( minus_minus @ rat @ ( X8 @ N2 ) @ ( Y9 @ N2 ) ) ) ) ) ) ).

% realrel_def
thf(fact_7136_Real_Opositive_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( positive2 @ ( real2 @ X ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K2: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K2 @ N2 )
                 => ( ord_less @ rat @ R5 @ ( X @ N2 ) ) ) ) ) ) ) ).

% Real.positive.abs_eq
thf(fact_7137_inverse__real__def,axiom,
    ( ( inverse_inverse @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X8: nat > rat] :
          ( if @ ( nat > rat ) @ ( vanishes @ X8 )
          @ ^ [N2: nat] : ( zero_zero @ rat )
          @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X8 @ N2 ) ) ) ) ) ).

% inverse_real_def
thf(fact_7138_funpow__inj__finite,axiom,
    ! [A: $tType,P4: A > A,X: A] :
      ( ( inj_on @ A @ A @ P4 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y6: A] :
              ? [N2: nat] :
                ( Y6
                = ( compow @ ( A > A ) @ N2 @ P4 @ X ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P4 @ X )
               != X ) ) ) ) ).

% funpow_inj_finite
thf(fact_7139_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu2: product_prod @ A @ A] :
            ? [X3: A,Y6: A] :
              ( ( Uu2
                = ( product_Pair @ A @ A @ X3 @ Y6 ) )
              & ( ord_less_eq @ A @ X3 @ Y6 ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_7140_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu2: product_prod @ A @ A] :
            ? [X3: A,Y6: A] :
              ( ( Uu2
                = ( product_Pair @ A @ A @ X3 @ Y6 ) )
              & ( ord_less_eq @ A @ Y6 @ X3 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_7141_exE__some,axiom,
    ! [A: $tType,P: A > $o,C2: A] :
      ( ? [X_1: A] : ( P @ X_1 )
     => ( ( C2
          = ( fChoice @ A @ P ) )
       => ( P @ C2 ) ) ) ).

% exE_some
thf(fact_7142_times__real__def,axiom,
    ( ( times_times @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X8: nat > rat,Y9: nat > rat,N2: nat] : ( times_times @ rat @ ( X8 @ N2 ) @ ( Y9 @ N2 ) ) ) ) ).

% times_real_def
thf(fact_7143_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_0 @ B )
     => ! [F3: A > B,G: C > B,A3: set @ A,B4: set @ C] :
          ( ( inj_on @ ( product_prod @ A @ C ) @ B
            @ ( product_case_prod @ A @ C @ B
              @ ^ [A4: A,B3: C] : ( times_times @ B @ ( F3 @ A4 ) @ ( G @ B3 ) ) )
            @ ( product_Sigma @ A @ C @ A3
              @ ^ [Uu2: A] : B4 ) )
         => ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F3 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B4 ) )
            = ( groups7311177749621191930dd_sum @ B @ B @ ( id @ B )
              @ ( collect @ B
                @ ^ [Uu2: B] :
                  ? [A4: A,B3: C] :
                    ( ( Uu2
                      = ( times_times @ B @ ( F3 @ A4 ) @ ( G @ B3 ) ) )
                    & ( member @ A @ A4 @ A3 )
                    & ( member @ C @ B3 @ B4 ) ) ) ) ) ) ) ).

% sum_mult_sum_if_inj
thf(fact_7144_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
            & ( ( size_size @ ( list @ A ) @ Xs )
              = ( suc @ N ) ) ) )
      = ( image @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs: list @ A,N2: A] : ( cons @ A @ N2 @ Xs ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs )
                  = N ) ) )
          @ ^ [Uu2: list @ A] : A3 ) ) ) ).

% lists_length_Suc_eq
thf(fact_7145_Sigma__Diff__distrib2,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B ),B4: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ I5
        @ ^ [I3: A] : ( minus_minus @ ( set @ B ) @ ( A3 @ I3 ) @ ( B4 @ I3 ) ) )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I5 @ A3 ) @ ( product_Sigma @ A @ B @ I5 @ B4 ) ) ) ).

% Sigma_Diff_distrib2
thf(fact_7146_Times__Diff__distrib1,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,C5: set @ B] :
      ( ( product_Sigma @ A @ B @ ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        @ ^ [Uu2: A] : C5 )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : C5 )
        @ ( product_Sigma @ A @ B @ B4
          @ ^ [Uu2: A] : C5 ) ) ) ).

% Times_Diff_distrib1
thf(fact_7147_Sigma__Diff__distrib1,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,J4: set @ A,C5: A > ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( minus_minus @ ( set @ A ) @ I5 @ J4 ) @ C5 )
      = ( minus_minus @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I5 @ C5 ) @ ( product_Sigma @ A @ B @ J4 @ C5 ) ) ) ).

% Sigma_Diff_distrib1
thf(fact_7148_Restr__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
            @ ( product_Sigma @ A @ A @ B4
              @ ^ [Uu2: A] : B4 ) )
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu2: A] : A3 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu2: A] : A3 ) ) ) ) ).

% Restr_subset
thf(fact_7149_open__prod__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S2: set @ ( product_prod @ A @ B )] :
          ( ! [X4: product_prod @ A @ B] :
              ( ( member @ ( product_prod @ A @ B ) @ X4 @ S2 )
             => ? [A19: set @ A,B14: set @ B] :
                  ( ( topolo1002775350975398744n_open @ A @ A19 )
                  & ( topolo1002775350975398744n_open @ B @ B14 )
                  & ( member @ ( product_prod @ A @ B ) @ X4
                    @ ( product_Sigma @ A @ B @ A19
                      @ ^ [Uu2: A] : B14 ) )
                  & ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                    @ ( product_Sigma @ A @ B @ A19
                      @ ^ [Uu2: A] : B14 )
                    @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) @ S2 ) ) ) ).

% open_prod_intro
thf(fact_7150_open__prod__elim,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S2: set @ ( product_prod @ A @ B ),X: product_prod @ A @ B] :
          ( ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) @ S2 )
         => ( ( member @ ( product_prod @ A @ B ) @ X @ S2 )
           => ~ ! [A8: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A8 )
                 => ! [B9: set @ B] :
                      ( ( topolo1002775350975398744n_open @ B @ B9 )
                     => ( ( member @ ( product_prod @ A @ B ) @ X
                          @ ( product_Sigma @ A @ B @ A8
                            @ ^ [Uu2: A] : B9 ) )
                       => ~ ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                            @ ( product_Sigma @ A @ B @ A8
                              @ ^ [Uu2: A] : B9 )
                            @ S2 ) ) ) ) ) ) ) ).

% open_prod_elim
thf(fact_7151_open__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ( ( topolo1002775350975398744n_open @ ( product_prod @ A @ B ) )
        = ( ^ [S7: set @ ( product_prod @ A @ B )] :
            ! [X3: product_prod @ A @ B] :
              ( ( member @ ( product_prod @ A @ B ) @ X3 @ S7 )
             => ? [A6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A6 )
                  & ? [B6: set @ B] :
                      ( ( topolo1002775350975398744n_open @ B @ B6 )
                      & ( member @ ( product_prod @ A @ B ) @ X3
                        @ ( product_Sigma @ A @ B @ A6
                          @ ^ [Uu2: A] : B6 ) )
                      & ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
                        @ ( product_Sigma @ A @ B @ A6
                          @ ^ [Uu2: A] : B6 )
                        @ S7 ) ) ) ) ) ) ) ).

% open_prod_def
thf(fact_7152_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X: A,C5: set @ A,A3: set @ B,B4: set @ B] :
      ( ( member @ A @ X @ C5 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
          @ ( product_Sigma @ B @ A @ A3
            @ ^ [Uu2: B] : C5 )
          @ ( product_Sigma @ B @ A @ B4
            @ ^ [Uu2: B] : C5 ) )
        = ( ord_less_eq @ ( set @ B ) @ A3 @ B4 ) ) ) ).

% Times_subset_cancel2
thf(fact_7153_Sigma__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C5: set @ A,B4: A > ( set @ B ),D3: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( B4 @ X4 ) @ ( D3 @ X4 ) ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ A3 @ B4 ) @ ( product_Sigma @ A @ B @ C5 @ D3 ) ) ) ) ).

% Sigma_mono
thf(fact_7154_trancl__subset__Sigma,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu2: A] : A3 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( product_Sigma @ A @ A @ A3
          @ ^ [Uu2: A] : A3 ) ) ) ).

% trancl_subset_Sigma
thf(fact_7155_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,C5: set @ B,B4: set @ A,D3: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : C5 )
        @ ( product_Sigma @ A @ B @ B4
          @ ^ [Uu2: A] : D3 ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( C5
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
          & ( ord_less_eq @ ( set @ B ) @ C5 @ D3 ) ) ) ) ).

% times_subset_iff
thf(fact_7156_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu2: A] : A3 ) )
       => ( ( A2 = B2 )
          | ( member @ A @ A2 @ A3 ) ) ) ) ).

% trancl_subset_Sigma_aux
thf(fact_7157_Ex__inj__on__UNION__Sigma,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I5: set @ B] :
    ? [F4: A > ( product_prod @ B @ A )] :
      ( ( inj_on @ A @ ( product_prod @ B @ A ) @ F4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I5 ) ) )
      & ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) ) @ ( image @ A @ ( product_prod @ B @ A ) @ F4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I5 ) ) ) @ ( product_Sigma @ B @ A @ I5 @ A3 ) ) ) ).

% Ex_inj_on_UNION_Sigma
thf(fact_7158_Sigma__interval__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order @ A )
     => ! [A3: set @ B,V: B > A,W: A] :
          ( ( inf_inf @ ( set @ ( product_prod @ B @ A ) )
            @ ( product_Sigma @ B @ A @ A3
              @ ^ [I3: B] : ( set_ord_atMost @ A @ ( V @ I3 ) ) )
            @ ( product_Sigma @ B @ A @ A3
              @ ^ [I3: B] : ( set_or3652927894154168847AtMost @ A @ ( V @ I3 ) @ W ) ) )
          = ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) ) ) ).

% Sigma_interval_disjoint
thf(fact_7159_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : B4 ) )
      = ( times_times @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ).

% card_cartesian_product
thf(fact_7160_product__atMost__eq__Un,axiom,
    ! [A3: set @ nat,M: nat] :
      ( ( product_Sigma @ nat @ nat @ A3
        @ ^ [Uu2: nat] : ( set_ord_atMost @ nat @ M ) )
      = ( sup_sup @ ( set @ ( product_prod @ nat @ nat ) )
        @ ( product_Sigma @ nat @ nat @ A3
          @ ^ [I3: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ I3 ) ) )
        @ ( product_Sigma @ nat @ nat @ A3
          @ ^ [I3: nat] : ( set_or3652927894154168847AtMost @ nat @ ( minus_minus @ nat @ M @ I3 ) @ M ) ) ) ) ).

% product_atMost_eq_Un
thf(fact_7161_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu2: A] :
            ? [N2: int] :
              ( ( Uu2
                = ( ring_1_of_int @ A @ N2 ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 ) ) ) ) ) ).

% Nats_altdef1
thf(fact_7162_pairs__le__eq__Sigma,axiom,
    ! [M: nat] :
      ( ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [I3: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ J3 ) @ M ) ) )
      = ( product_Sigma @ nat @ nat @ ( set_ord_atMost @ nat @ M )
        @ ^ [R5: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ R5 ) ) ) ) ).

% pairs_le_eq_Sigma
thf(fact_7163_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q4: int,R5: int] :
          ( plus_plus @ int @ Q4
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_7164_Real_Opositive__def,axiom,
    ( positive2
    = ( map_fun @ real @ ( nat > rat ) @ $o @ $o @ rep_real @ ( id @ $o )
      @ ^ [X8: nat > rat] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K2: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K2 @ N2 )
             => ( ord_less @ rat @ R5 @ ( X8 @ N2 ) ) ) ) ) ) ).

% Real.positive_def
thf(fact_7165_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F3: A > B,B4: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( bNF_Gr @ A @ B @ A3 @ F3 )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : B4 ) )
      = ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B4 ) ) ).

% Gr_incl
thf(fact_7166_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu2: real] :
        ? [I3: int,N2: nat] :
          ( ( Uu2
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I3 ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
          & ( N2
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_7167_Real_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ $o @ $o @ realrel
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K2: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
           => ( ord_less @ rat @ R5 @ ( X8 @ N2 ) ) ) )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K2: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
           => ( ord_less @ rat @ R5 @ ( X8 @ N2 ) ) ) ) ) ).

% Real.positive.rsp
thf(fact_7168_Rats__diff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_diff
thf(fact_7169_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( ring_1_Ints @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Ints_subset_Rats
thf(fact_7170_Rats__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_of_nat
thf(fact_7171_Rats__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_add
thf(fact_7172_Rats__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_1
thf(fact_7173_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_7174_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R2: A > B > $o] :
          ( ( R2 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R2 @ ( bNF_rel_fun @ A @ B @ A @ B @ R2 @ R2 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R2
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
                @ R2 )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_7175_Rats__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_0
thf(fact_7176_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R2: A > B > $o] :
          ( ( R2 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R2 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R2 @ ( bNF_rel_fun @ A @ B @ A @ B @ R2 @ R2 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
                @ R2
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_7177_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R2: A > B > $o] :
          ( ( R2 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R2 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R2 @ ( bNF_rel_fun @ A @ B @ A @ B @ R2 @ R2 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R2 @ R2 @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
                  @ R2
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_7178_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X4: real] :
      ( ( member @ real @ X4 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X @ X4 ) ) ).

% Rats_no_top_le
thf(fact_7179_Nats__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Nats_subset_Rats
thf(fact_7180_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu2: real] :
        ? [I3: int,J3: int] :
          ( ( Uu2
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I3 ) @ ( ring_1_of_int @ real @ J3 ) ) )
          & ( J3
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_7181_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R2: A > B > $o] :
          ( ( R2 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R2 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R2 @ ( bNF_rel_fun @ A @ B @ A @ B @ R2 @ R2 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
                @ R2
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_7182_rec__nat__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( nat > A > A ) > nat > A ) @ ( ( nat > B > B ) > nat > B ) @ A3
      @ ( bNF_rel_fun @ ( nat > A > A ) @ ( nat > B > B ) @ ( nat > A ) @ ( nat > B )
        @ ( bNF_rel_fun @ nat @ nat @ ( A > A ) @ ( B > B )
          @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
          @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) )
        @ ( bNF_rel_fun @ nat @ nat @ A @ B
          @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
          @ A3 ) )
      @ ( rec_nat @ A )
      @ ( rec_nat @ B ) ) ).

% rec_nat_transfer
thf(fact_7183_sub_Orsp,axiom,
    ( bNF_rel_fun @ num @ num @ ( num > int ) @ ( num > int )
    @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ num @ num @ int @ int
      @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ^ [M3: num,N2: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N2 ) )
    @ ^ [M3: num,N2: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N2 ) ) ) ).

% sub.rsp
thf(fact_7184_minus__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( minus_minus @ int )
    @ ( minus_minus @ int ) ) ).

% minus_integer.rsp
thf(fact_7185_minus__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( minus_minus @ nat )
    @ ( minus_minus @ nat ) ) ).

% minus_natural.rsp
thf(fact_7186_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R2: A > B > $o] :
          ( ( R2 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R2 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
              @ R2
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_7187_integer__of__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ int @ int
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( semiring_1_of_nat @ int )
    @ ( semiring_1_of_nat @ int ) ) ).

% integer_of_natural.rsp
thf(fact_7188_plus__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( plus_plus @ int )
    @ ( plus_plus @ int ) ) ).

% plus_integer.rsp
thf(fact_7189_plus__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( plus_plus @ nat )
    @ ( plus_plus @ nat ) ) ).

% plus_natural.rsp
thf(fact_7190_Suc_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ nat @ nat
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ suc
    @ suc ) ).

% Suc.rsp
thf(fact_7191_times__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( times_times @ int )
    @ ( times_times @ int ) ) ).

% times_integer.rsp
thf(fact_7192_times__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 ) )
    @ ( times_times @ nat )
    @ ( times_times @ nat ) ) ).

% times_natural.rsp
thf(fact_7193_dup_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ int @ int
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ^ [K2: int] : ( plus_plus @ int @ K2 @ K2 )
    @ ^ [K2: int] : ( plus_plus @ int @ K2 @ K2 ) ) ).

% dup.rsp
thf(fact_7194_less__eq__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( ord_less_eq @ nat )
    @ ( ord_less_eq @ nat ) ) ).

% less_eq_natural.rsp
thf(fact_7195_less__eq__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( ord_less_eq @ int )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_integer.rsp
thf(fact_7196_times__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X8: nat > rat,Y9: nat > rat,N2: nat] : ( times_times @ rat @ ( X8 @ N2 ) @ ( Y9 @ N2 ) )
    @ ^ [X8: nat > rat,Y9: nat > rat,N2: nat] : ( times_times @ rat @ ( X8 @ N2 ) @ ( Y9 @ N2 ) ) ) ).

% times_real.rsp
thf(fact_7197_inverse__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N2: nat] : ( zero_zero @ rat )
        @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X8 @ N2 ) ) )
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N2: nat] : ( zero_zero @ rat )
        @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X8 @ N2 ) ) ) ) ).

% inverse_real.rsp
thf(fact_7198_funpow__transfer,axiom,
    ! [A: $tType,B: $tType,A3: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( A > A ) > A > A ) @ ( ( B > B ) > B > B )
      @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
      @ ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > A ) @ ( B > B ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) )
      @ ( compow @ ( A > A ) )
      @ ( compow @ ( B > B ) ) ) ).

% funpow_transfer
thf(fact_7199_Real_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K2: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
           => ( ord_less @ rat @ R5 @ ( X8 @ N2 ) ) ) )
    @ positive2 ) ).

% Real.positive.transfer
thf(fact_7200_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y6 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y6 @ U2 ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_7201_zero__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N2: nat] : ( zero_zero @ rat )
    @ ( zero_zero @ real ) ) ).

% zero_real.transfer
thf(fact_7202_one__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N2: nat] : ( one_one @ rat )
    @ ( one_one @ real ) ) ).

% one_real.transfer
thf(fact_7203_zero__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( zero_zero @ int ) ).

% zero_int.transfer
thf(fact_7204_times__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X8: nat > rat,Y9: nat > rat,N2: nat] : ( times_times @ rat @ ( X8 @ N2 ) @ ( Y9 @ N2 ) )
    @ ( times_times @ real ) ) ).

% times_real.transfer
thf(fact_7205_int__transfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( product_prod @ nat @ nat ) @ int
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ pcr_int
    @ ^ [N2: nat] : ( product_Pair @ nat @ nat @ N2 @ ( zero_zero @ nat ) )
    @ ( semiring_1_of_nat @ int ) ) ).

% int_transfer
thf(fact_7206_uminus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y6: nat] : ( product_Pair @ nat @ nat @ Y6 @ X3 ) )
    @ ( uminus_uminus @ int ) ) ).

% uminus_int.transfer
thf(fact_7207_nat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ nat @ nat @ pcr_int
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ nat2 ) ).

% nat.transfer
thf(fact_7208_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_7209_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ A @ A @ pcr_int
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I3: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( ring_1_of_int @ A ) ) ) ).

% of_int.transfer
thf(fact_7210_inverse__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N2: nat] : ( zero_zero @ rat )
        @ ^ [N2: nat] : ( inverse_inverse @ rat @ ( X8 @ N2 ) ) )
    @ ( inverse_inverse @ real ) ) ).

% inverse_real.transfer
thf(fact_7211_less__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) )
    @ ( ord_less @ int ) ) ).

% less_int.transfer
thf(fact_7212_less__eq__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_int.transfer
thf(fact_7213_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y6 @ V5 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_7214_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y6 @ U2 ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_7215_num_Orec__transfer,axiom,
    ! [A: $tType,B: $tType,S2: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A > A ) > ( num > A > A ) > num > A ) @ ( ( num > B > B ) > ( num > B > B ) > num > B ) @ S2
      @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( ( num > A > A ) > num > A ) @ ( ( num > B > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
          @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
          @ ( bNF_rel_fun @ A @ B @ A @ B @ S2 @ S2 ) )
        @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ ( bNF_rel_fun @ A @ B @ A @ B @ S2 @ S2 ) )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ S2 ) ) )
      @ ( rec_num @ A )
      @ ( rec_num @ B ) ) ).

% num.rec_transfer
thf(fact_7216_fun__mono,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,C5: A > B > $o,A3: A > B > $o,B4: C > D > $o,D3: C > D > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ C5 @ A3 )
     => ( ( ord_less_eq @ ( C > D > $o ) @ B4 @ D3 )
       => ( ord_less_eq @ ( ( A > C ) > ( B > D ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B4 ) @ ( bNF_rel_fun @ A @ B @ C @ D @ C5 @ D3 ) ) ) ) ).

% fun_mono
thf(fact_7217_verit__eq__simplify_I19_J,axiom,
    ! [A: $tType,F1: A,F2: num > A > A,F32: num > A > A] :
      ( ( rec_num @ A @ F1 @ F2 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(19)
thf(fact_7218_verit__eq__simplify_I20_J,axiom,
    ! [A: $tType,F1: A,F2: num > A > A,F32: num > A > A,X2: num] :
      ( ( rec_num @ A @ F1 @ F2 @ F32 @ ( bit0 @ X2 ) )
      = ( F2 @ X2 @ ( rec_num @ A @ F1 @ F2 @ F32 @ X2 ) ) ) ).

% verit_eq_simplify(20)
thf(fact_7219_verit__eq__simplify_I21_J,axiom,
    ! [A: $tType,F1: A,F2: num > A > A,F32: num > A > A,X32: num] :
      ( ( rec_num @ A @ F1 @ F2 @ F32 @ ( bit1 @ X32 ) )
      = ( F32 @ X32 @ ( rec_num @ A @ F1 @ F2 @ F32 @ X32 ) ) ) ).

% verit_eq_simplify(21)
thf(fact_7220_num_Ocase__transfer,axiom,
    ! [A: $tType,B: $tType,S2: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A ) > ( num > A ) > num > A ) @ ( ( num > B ) > ( num > B ) > num > B ) @ S2
      @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( ( num > A ) > num > A ) @ ( ( num > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ A @ B
          @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
          @ S2 )
        @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ S2 )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y5: num,Z4: num] : ( Y5 = Z4 )
            @ S2 ) ) )
      @ ( case_num @ A )
      @ ( case_num @ B ) ) ).

% num.case_transfer
thf(fact_7221_fun_Orel__mono,axiom,
    ! [D: $tType,B: $tType,A: $tType,R2: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R2 @ Ra )
     => ( ord_less_eq @ ( ( D > A ) > ( D > B ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y5: D,Z4: D] : ( Y5 = Z4 )
          @ R2 )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y5: D,Z4: D] : ( Y5 = Z4 )
          @ Ra ) ) ) ).

% fun.rel_mono
thf(fact_7222_verit__eq__simplify_I18_J,axiom,
    ! [A: $tType,F1: A,F2: num > A,F32: num > A,X32: num] :
      ( ( case_num @ A @ F1 @ F2 @ F32 @ ( bit1 @ X32 ) )
      = ( F32 @ X32 ) ) ).

% verit_eq_simplify(18)
thf(fact_7223_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F2: num > A,F32: num > A,X2: num] :
      ( ( case_num @ A @ F1 @ F2 @ F32 @ ( bit0 @ X2 ) )
      = ( F2 @ X2 ) ) ).

% verit_eq_simplify(17)
thf(fact_7224_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F2: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F2 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_7225_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: A > B,F1: A,F2: num > A,F32: num > A,Num: num] :
      ( ( H @ ( case_num @ A @ F1 @ F2 @ F32 @ Num ) )
      = ( case_num @ B @ ( H @ F1 )
        @ ^ [X3: num] : ( H @ ( F2 @ X3 ) )
        @ ^ [X3: num] : ( H @ ( F32 @ X3 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_7226_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y6 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y6 @ U2 ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ U2 ) @ ( times_times @ nat @ Y6 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X3 @ V5 ) @ ( times_times @ nat @ Y6 @ U2 ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_7227_mult__inj__if__coprime__nat,axiom,
    ! [B: $tType,A: $tType,F3: A > nat,A3: set @ A,G: B > nat,B4: set @ B] :
      ( ( inj_on @ A @ nat @ F3 @ A3 )
     => ( ( inj_on @ B @ nat @ G @ B4 )
       => ( ! [A5: A,B5: B] :
              ( ( member @ A @ A5 @ A3 )
             => ( ( member @ B @ B5 @ B4 )
               => ( algebr8660921524188924756oprime @ nat @ ( F3 @ A5 ) @ ( G @ B5 ) ) ) )
         => ( inj_on @ ( product_prod @ A @ B ) @ nat
            @ ( product_case_prod @ A @ B @ nat
              @ ^ [A4: A,B3: B] : ( times_times @ nat @ ( F3 @ A4 ) @ ( G @ B3 ) ) )
            @ ( product_Sigma @ A @ B @ A3
              @ ^ [Uu2: A] : B4 ) ) ) ) ) ).

% mult_inj_if_coprime_nat
thf(fact_7228_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( algebr8660921524188924756oprime @ A @ C2 @ A2 )
            & ( algebr8660921524188924756oprime @ A @ C2 @ B2 ) ) ) ) ).

% coprime_mult_right_iff
thf(fact_7229_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
            & ( algebr8660921524188924756oprime @ A @ B2 @ C2 ) ) ) ) ).

% coprime_mult_left_iff
thf(fact_7230_coprime__minus__left__iff,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% coprime_minus_left_iff
thf(fact_7231_coprime__minus__right__iff,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% coprime_minus_right_iff
thf(fact_7232_coprime__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_self
thf(fact_7233_coprime__mod__right__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ A2 @ ( modulo_modulo @ A @ B2 @ A2 ) )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_right_iff
thf(fact_7234_coprime__mod__left__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_left_iff
thf(fact_7235_coprime__power__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( power_power @ A @ B2 @ N ) )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_right_iff
thf(fact_7236_coprime__power__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_left_iff
thf(fact_7237_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V: nat] :
      ( ( intrel @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ U @ V ) )
      = ( ( plus_plus @ nat @ X @ V )
        = ( plus_plus @ nat @ U @ Y ) ) ) ).

% intrel_iff
thf(fact_7238_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_7239_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_7240_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mult_self_left_iff
thf(fact_7241_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
            & ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mult_self_right_iff
thf(fact_7242_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [A2: A,N: A,M: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ N ) @ M )
            = ( modulo_modulo @ A @ ( times_times @ A @ B2 @ N ) @ M ) )
         => ( ( algebr8660921524188924756oprime @ A @ M @ N )
           => ( ( modulo_modulo @ A @ A2 @ M )
              = ( modulo_modulo @ A @ B2 @ M ) ) ) ) ) ).

% mult_mod_cancel_right
thf(fact_7243_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ( euclid8851590272496341667cancel @ A )
        & ( semiring_gcd @ A ) )
     => ! [N: A,A2: A,M: A,B2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ N @ A2 ) @ M )
            = ( modulo_modulo @ A @ ( times_times @ A @ N @ B2 ) @ M ) )
         => ( ( algebr8660921524188924756oprime @ A @ M @ N )
           => ( ( modulo_modulo @ A @ A2 @ M )
              = ( modulo_modulo @ A @ B2 @ M ) ) ) ) ) ).

% mult_mod_cancel_left
thf(fact_7244_coprime__common__divisor__nat,axiom,
    ! [A2: nat,B2: nat,X: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ A2 @ B2 )
     => ( ( dvd_dvd @ nat @ X @ A2 )
       => ( ( dvd_dvd @ nat @ X @ B2 )
         => ( X
            = ( one_one @ nat ) ) ) ) ) ).

% coprime_common_divisor_nat
thf(fact_7245_prod__coprime__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ B,F3: B > A,A2: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( algebr8660921524188924756oprime @ A @ ( F3 @ I2 ) @ A2 ) )
         => ( algebr8660921524188924756oprime @ A @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) @ A2 ) ) ) ).

% prod_coprime_left
thf(fact_7246_prod__coprime__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ B,A2: A,F3: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( algebr8660921524188924756oprime @ A @ A2 @ ( F3 @ I2 ) ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ ( groups7121269368397514597t_prod @ B @ A @ F3 @ A3 ) ) ) ) ).

% prod_coprime_right
thf(fact_7247_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% coprime_dvd_mult_right_iff
thf(fact_7248_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% coprime_dvd_mult_left_iff
thf(fact_7249_divides__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
             => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% divides_mult
thf(fact_7250_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% is_unit_right_imp_coprime
thf(fact_7251_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% is_unit_left_imp_coprime
thf(fact_7252_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( dvd_dvd @ A @ C2 @ ( one_one @ A ) ) ) ) ) ) ).

% coprime_common_divisor
thf(fact_7253_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [Y: A,X: A] :
          ( ( dvd_dvd @ A @ Y @ X )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y )
            = ( dvd_dvd @ A @ Y @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_right
thf(fact_7254_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,D2: A,A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ C2 @ D2 )
         => ( ! [E2: A] :
                ( ~ ( dvd_dvd @ A @ E2 @ ( one_one @ A ) )
               => ( ( dvd_dvd @ A @ E2 @ A2 )
                 => ( ( dvd_dvd @ A @ E2 @ B2 )
                   => ( dvd_dvd @ A @ E2 @ C2 ) ) ) )
           => ( ! [E2: A] :
                  ( ~ ( dvd_dvd @ A @ E2 @ ( one_one @ A ) )
                 => ( ( dvd_dvd @ A @ E2 @ A2 )
                   => ( ( dvd_dvd @ A @ E2 @ B2 )
                     => ( dvd_dvd @ A @ E2 @ D2 ) ) ) )
             => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% coprime_imp_coprime
thf(fact_7255_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( algebr8660921524188924756oprime @ A @ X @ Y )
            = ( dvd_dvd @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% coprime_absorb_left
thf(fact_7256_not__coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ~ ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
             => ~ ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% not_coprimeI
thf(fact_7257_not__coprimeE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( ( dvd_dvd @ A @ C4 @ A2 )
               => ( ( dvd_dvd @ A @ C4 @ B2 )
                 => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) ) ) ) ).

% not_coprimeE
thf(fact_7258_coprime__def,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A4: A,B3: A] :
            ! [C3: A] :
              ( ( dvd_dvd @ A @ C3 @ A4 )
             => ( ( dvd_dvd @ A @ C3 @ B3 )
               => ( dvd_dvd @ A @ C3 @ ( one_one @ A ) ) ) ) ) ) ) ).

% coprime_def
thf(fact_7259_coprimeI,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ! [C4: A] :
              ( ( dvd_dvd @ A @ C4 @ A2 )
             => ( ( dvd_dvd @ A @ C4 @ B2 )
               => ( dvd_dvd @ A @ C4 @ ( one_one @ A ) ) ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% coprimeI
thf(fact_7260_coprime__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [B3: A,A4: A] : ( algebr8660921524188924756oprime @ A @ A4 @ B3 ) ) ) ) ).

% coprime_commute
thf(fact_7261_coprime__divisors,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ D2 )
           => ( ( algebr8660921524188924756oprime @ A @ C2 @ D2 )
             => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ) ).

% coprime_divisors
thf(fact_7262_coprime__Suc__left__nat,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ N ) @ N ) ).

% coprime_Suc_left_nat
thf(fact_7263_coprime__Suc__right__nat,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ N @ ( suc @ N ) ) ).

% coprime_Suc_right_nat
thf(fact_7264_coprime__crossproduct__nat,axiom,
    ! [A2: nat,D2: nat,B2: nat,C2: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ A2 @ D2 )
     => ( ( algebr8660921524188924756oprime @ nat @ B2 @ C2 )
       => ( ( ( times_times @ nat @ A2 @ C2 )
            = ( times_times @ nat @ B2 @ D2 ) )
          = ( ( A2 = B2 )
            & ( C2 = D2 ) ) ) ) ) ).

% coprime_crossproduct_nat
thf(fact_7265_coprime__1__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( one_one @ A ) @ A2 ) ) ).

% coprime_1_left
thf(fact_7266_coprime__1__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( one_one @ A ) ) ) ).

% coprime_1_right
thf(fact_7267_coprime__Suc__0__right,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ).

% coprime_Suc_0_right
thf(fact_7268_coprime__Suc__0__left,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ).

% coprime_Suc_0_left
thf(fact_7269_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ A2 ) ) ).

% coprime_add_one_left
thf(fact_7270_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_add_one_right
thf(fact_7271_int_Oabs__eq__iff,axiom,
    ! [X: product_prod @ nat @ nat,Y: product_prod @ nat @ nat] :
      ( ( ( abs_Integ @ X )
        = ( abs_Integ @ Y ) )
      = ( intrel @ X @ Y ) ) ).

% int.abs_eq_iff
thf(fact_7272_zero__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ).

% zero_int.rsp
thf(fact_7273_invertible__coprime,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ C2 ) ) ) ).

% invertible_coprime
thf(fact_7274_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ A2 ) ) ).

% coprime_diff_one_left
thf(fact_7275_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A] : ( algebr8660921524188924756oprime @ A @ A2 @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_doff_one_right
thf(fact_7276_uminus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y6: nat] : ( product_Pair @ nat @ nat @ Y6 @ X3 ) )
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X3: nat,Y6: nat] : ( product_Pair @ nat @ nat @ Y6 @ X3 ) ) ) ).

% uminus_int.rsp
thf(fact_7277_nat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ nat @ nat @ intrel
    @ ^ [Y5: nat,Z4: nat] : ( Y5 = Z4 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ).

% nat.rsp
thf(fact_7278_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_7279_coprime__diff__one__left__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ N ) ) ).

% coprime_diff_one_left_nat
thf(fact_7280_coprime__diff__one__right__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% coprime_diff_one_right_nat
thf(fact_7281_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ A @ A @ intrel
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I3: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I3: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ).

% of_int.rsp
thf(fact_7282_intrel__def,axiom,
    ( intrel
    = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] :
              ( ( plus_plus @ nat @ X3 @ V5 )
              = ( plus_plus @ nat @ U2 @ Y6 ) ) ) ) ) ).

% intrel_def
thf(fact_7283_Rats__abs__nat__div__natE,axiom,
    ! [X: real] :
      ( ( member @ real @ X @ ( field_char_0_Rats @ real ) )
     => ~ ! [M2: nat,N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( ( ( abs_abs @ real @ X )
                = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ M2 ) @ ( semiring_1_of_nat @ real @ N3 ) ) )
             => ~ ( algebr8660921524188924756oprime @ nat @ M2 @ N3 ) ) ) ) ).

% Rats_abs_nat_div_natE
thf(fact_7284_less__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) ) ) ).

% less_int.rsp
thf(fact_7285_less__eq__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y6 ) ) ) ) ) ).

% less_eq_int.rsp
thf(fact_7286_int_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
    @ intrel
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) ) ).

% int.rel_eq_transfer
thf(fact_7287_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y6 @ V5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ U2 ) @ ( plus_plus @ nat @ Y6 @ V5 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_7288_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y6 @ U2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X3: nat,Y6: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X3 @ V5 ) @ ( plus_plus @ nat @ Y6 @ U2 ) ) ) ) ) ).

% minus_int.rsp
thf(fact_7289_butlast__take,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( butlast @ A @ ( take @ A @ N @ Xs2 ) )
        = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs2 ) ) ) ).

% butlast_take
thf(fact_7290_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F3 )
           => ( ! [N3: nat] :
                  ( ( ( F3 @ N3 )
                    = ( F3 @ ( suc @ N3 ) ) )
                 => ( ( F3 @ ( suc @ N3 ) )
                    = ( F3 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N9: nat] :
                  ( ! [N4: nat] :
                      ( ( ord_less_eq @ nat @ N4 @ N9 )
                     => ! [M4: nat] :
                          ( ( ord_less_eq @ nat @ M4 @ N9 )
                         => ( ( ord_less @ nat @ M4 @ N4 )
                           => ( ord_less @ A @ ( F3 @ M4 ) @ ( F3 @ N4 ) ) ) ) )
                  & ! [N4: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N4 )
                     => ( ( F3 @ N9 )
                        = ( F3 @ N4 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_7291_coprime__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( algebr8660921524188924756oprime @ nat @ M @ N ) ) ).

% coprime_int_iff
thf(fact_7292_length__butlast,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ).

% length_butlast
thf(fact_7293_normalize__stable,axiom,
    ! [Q2: int,P4: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Q2 )
     => ( ( algebr8660921524188924756oprime @ int @ P4 @ Q2 )
       => ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q2 ) )
          = ( product_Pair @ int @ int @ P4 @ Q2 ) ) ) ) ).

% normalize_stable
thf(fact_7294_coprime__nat__abs__right__iff,axiom,
    ! [N: nat,K: int] :
      ( ( algebr8660921524188924756oprime @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% coprime_nat_abs_right_iff
thf(fact_7295_coprime__nat__abs__left__iff,axiom,
    ! [K: int,N: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( algebr8660921524188924756oprime @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% coprime_nat_abs_left_iff
thf(fact_7296_coprime__crossproduct__int,axiom,
    ! [A2: int,D2: int,B2: int,C2: int] :
      ( ( algebr8660921524188924756oprime @ int @ A2 @ D2 )
     => ( ( algebr8660921524188924756oprime @ int @ B2 @ C2 )
       => ( ( ( times_times @ int @ ( abs_abs @ int @ A2 ) @ ( abs_abs @ int @ C2 ) )
            = ( times_times @ int @ ( abs_abs @ int @ B2 ) @ ( abs_abs @ int @ D2 ) ) )
          = ( ( ( abs_abs @ int @ A2 )
              = ( abs_abs @ int @ B2 ) )
            & ( ( abs_abs @ int @ C2 )
              = ( abs_abs @ int @ D2 ) ) ) ) ) ) ).

% coprime_crossproduct_int
thf(fact_7297_Rat__cases,axiom,
    ! [Q2: rat] :
      ~ ! [A5: int,B5: int] :
          ( ( Q2
            = ( fract @ A5 @ B5 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
           => ~ ( algebr8660921524188924756oprime @ int @ A5 @ B5 ) ) ) ).

% Rat_cases
thf(fact_7298_Rat__induct,axiom,
    ! [P: rat > $o,Q2: rat] :
      ( ! [A5: int,B5: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( ( algebr8660921524188924756oprime @ int @ A5 @ B5 )
           => ( P @ ( fract @ A5 @ B5 ) ) ) )
     => ( P @ Q2 ) ) ).

% Rat_induct
thf(fact_7299_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: A > A,A3: A,B4: A,N: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ A @ A3 @ B4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F3 @ A3 ) @ ( compow @ ( A > A ) @ N @ F3 @ B4 ) ) ) ) ) ).

% funpow_mono
thf(fact_7300_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F3: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F3 @ X ) @ ( F3 @ Y ) ) ) ) ) ).

% monoD
thf(fact_7301_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F3: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F3 @ X ) @ ( F3 @ Y ) ) ) ) ) ).

% monoE
thf(fact_7302_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F3: A > B] :
          ( ! [X4: A,Y3: A] :
              ( ( ord_less_eq @ A @ X4 @ Y3 )
             => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y3 ) ) )
         => ( order_mono @ A @ B @ F3 ) ) ) ).

% monoI
thf(fact_7303_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X3: A,Y6: A] :
              ( ( ord_less_eq @ A @ X3 @ Y6 )
             => ( ord_less_eq @ B @ ( F5 @ X3 ) @ ( F5 @ Y6 ) ) ) ) ) ) ).

% mono_def
thf(fact_7304_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F5 @ N2 ) @ ( F5 @ ( suc @ N2 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_7305_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X9: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X9 @ N3 ) @ ( X9 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X9 ) ) ) ).

% incseq_SucI
thf(fact_7306_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I: nat] :
          ( ( order_mono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ I ) @ ( A3 @ ( suc @ I ) ) ) ) ) ).

% incseq_SucD
thf(fact_7307_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: nat > A,I: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F3 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ord_less_eq @ A @ ( F3 @ I ) @ ( F3 @ J ) ) ) ) ) ).

% incseqD
thf(fact_7308_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X8: nat > A] :
            ! [M3: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N2 )
             => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N2 ) ) ) ) ) ) ).

% incseq_def
thf(fact_7309_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F3: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( ord_less @ B @ ( F3 @ X ) @ ( F3 @ Y ) )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mono_invE
thf(fact_7310_cclfp__lowerbound,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [F3: A > A,A3: A] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ A @ ( F3 @ A3 ) @ A3 )
           => ( ord_less_eq @ A @ ( order_532582986084564980_cclfp @ A @ F3 ) @ A3 ) ) ) ) ).

% cclfp_lowerbound
thf(fact_7311_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_7312_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F3: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ A @ ( F3 @ P4 ) @ P4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F3 @ ( bot_bot @ A ) ) @ P4 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_7313_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F3: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ A @ P4 @ ( F3 @ P4 ) )
           => ( ord_less_eq @ A @ P4 @ ( compow @ ( A > A ) @ K @ F3 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_7314_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F3: A > A,I: nat,J: nat,X: A,Y: A] :
          ( ( order_mono @ A @ A @ F3 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less_eq @ A @ X @ Y )
             => ( ( ord_less_eq @ A @ X @ ( F3 @ X ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I @ F3 @ X ) @ ( compow @ ( A > A ) @ J @ F3 @ Y ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_7315_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F3: A > B,A3: A,B4: A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( F3 @ ( inf_inf @ A @ A3 @ B4 ) ) @ ( inf_inf @ B @ ( F3 @ A3 ) @ ( F3 @ B4 ) ) ) ) ) ).

% mono_inf
thf(fact_7316_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F3: A > B,A3: A,B4: A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F3 @ A3 ) @ ( F3 @ B4 ) ) @ ( F3 @ ( sup_sup @ A @ A3 @ B4 ) ) ) ) ) ).

% mono_sup
thf(fact_7317_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I3: nat] : ( compow @ ( A > A ) @ I3 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_7318_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F3: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F3 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N @ F3 ) ) ) ) ).

% mono_pow
thf(fact_7319_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_7320_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_7321_mono__times__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N ) ) ) ).

% mono_times_nat
thf(fact_7322_coprime__common__divisor__int,axiom,
    ! [A2: int,B2: int,X: int] :
      ( ( algebr8660921524188924756oprime @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ X @ A2 )
       => ( ( dvd_dvd @ int @ X @ B2 )
         => ( ( abs_abs @ int @ X )
            = ( one_one @ int ) ) ) ) ) ).

% coprime_common_divisor_int
thf(fact_7323_incseq__bounded,axiom,
    ! [X9: nat > real,B4: real] :
      ( ( order_mono @ nat @ real @ X9 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X9 @ I2 ) @ B4 )
       => ( bfun @ nat @ real @ X9 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_7324_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F3 @ A3 ) ) @ ( F3 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% mono_Sup
thf(fact_7325_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X3: C] : ( F3 @ ( A3 @ X3 ) )
                @ I5 ) )
            @ ( F3 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I5 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_7326_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I5 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X3: C] : ( F3 @ ( A3 @ X3 ) )
                @ I5 ) ) ) ) ) ).

% mono_INF
thf(fact_7327_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ) ).

% mono_Inf
thf(fact_7328_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X9: nat > A,L6: A,N: nat] :
          ( ( order_mono @ nat @ A @ X9 )
         => ( ( filterlim @ nat @ A @ X9 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X9 @ N ) @ L6 ) ) ) ) ).

% incseq_le
thf(fact_7329_sorted__butlast,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( Xs2
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( butlast @ A @ Xs2 ) ) ) ) ) ).

% sorted_butlast
thf(fact_7330_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N: nat,F3: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F3 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F3 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_7331_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N: nat,F3: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F3 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F3 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_7332_incseq__convergent,axiom,
    ! [X9: nat > real,B4: real] :
      ( ( order_mono @ nat @ real @ X9 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X9 @ I2 ) @ B4 )
       => ~ ! [L7: real] :
              ( ( filterlim @ nat @ real @ X9 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) )
             => ~ ! [I4: nat] : ( ord_less_eq @ real @ ( X9 @ I4 ) @ L7 ) ) ) ) ).

% incseq_convergent
thf(fact_7333_mono__bij__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( comple5582772986160207858norder @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( bij_betw @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
           => ( ( F3 @ ( complete_Inf_Inf @ A @ A3 ) )
              = ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ) ) ).

% mono_bij_Inf
thf(fact_7334_butlast__power,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N @ ( butlast @ A ) @ Xs2 )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) @ Xs2 ) ) ).

% butlast_power
thf(fact_7335_Rat__cases__nonzero,axiom,
    ! [Q2: rat] :
      ( ! [A5: int,B5: int] :
          ( ( Q2
            = ( fract @ A5 @ B5 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
           => ( ( A5
               != ( zero_zero @ int ) )
             => ~ ( algebr8660921524188924756oprime @ int @ A5 @ B5 ) ) ) )
     => ( Q2
        = ( zero_zero @ rat ) ) ) ).

% Rat_cases_nonzero
thf(fact_7336_mono__ccSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F3: A > B,I5: set @ C,A3: C > A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( countable_countable @ C @ I5 )
           => ( ord_less_eq @ B
              @ ( complete_Sup_Sup @ B
                @ ( image @ C @ B
                  @ ^ [X3: C] : ( F3 @ ( A3 @ X3 ) )
                  @ I5 ) )
              @ ( F3 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I5 ) ) ) ) ) ) ) ).

% mono_ccSUP
thf(fact_7337_mono__ccSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( countable_countable @ A @ A3 )
           => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F3 @ A3 ) ) @ ( F3 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% mono_ccSup
thf(fact_7338_mono__ccInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( countable_countable @ A @ A3 )
           => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ) ) ).

% mono_ccInf
thf(fact_7339_mono__ccINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F3: A > B,I5: set @ C,A3: C > A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( countable_countable @ C @ I5 )
           => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I5 ) ) )
              @ ( complete_Inf_Inf @ B
                @ ( image @ C @ B
                  @ ^ [X3: C] : ( F3 @ ( A3 @ X3 ) )
                  @ I5 ) ) ) ) ) ) ).

% mono_ccINF
thf(fact_7340_Rats__cases_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( field_char_0_Rats @ A ) )
         => ~ ! [A5: int,B5: int] :
                ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
               => ( ( algebr8660921524188924756oprime @ int @ A5 @ B5 )
                 => ( X
                   != ( divide_divide @ A @ ( ring_1_of_int @ A @ A5 ) @ ( ring_1_of_int @ A @ B5 ) ) ) ) ) ) ) ).

% Rats_cases'
thf(fact_7341_butlast__conv__take,axiom,
    ! [A: $tType] :
      ( ( butlast @ A )
      = ( ^ [Xs: list @ A] : ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% butlast_conv_take
thf(fact_7342_butlast__list__update,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,X: A] :
      ( ( ( K
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
          = ( butlast @ A @ Xs2 ) ) )
      & ( ( K
         != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
          = ( list_update @ A @ ( butlast @ A @ Xs2 ) @ K @ X ) ) ) ) ).

% butlast_list_update
thf(fact_7343_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F3: nat > real,G: nat > nat] :
      ( ! [X4: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F3 @ X4 ) )
     => ( ( order_mono @ nat @ real @ F3 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X3: nat] : ( F3 @ ( G @ X3 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F3 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_7344_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M3 ) @ M3 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_7345_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs2 )
        = Ys )
      = ( ? [F5: nat > nat] :
            ( ( order_mono @ nat @ nat @ F5 )
            & ( ( image @ nat @ nat @ F5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( nth @ A @ Xs2 @ I3 )
                  = ( nth @ A @ Ys @ ( F5 @ I3 ) ) ) )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( ( nth @ A @ Xs2 @ I3 )
                    = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) )
                  = ( ( F5 @ I3 )
                    = ( F5 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_7346_mono__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ D )
        & ( order @ C )
        & ( order @ A ) )
     => ! [A3: A > B > $o,B4: C > D > $o] :
          ( ( bi_total @ A @ B @ A3 )
         => ( ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A3
              @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
                @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
              @ ( ord_less_eq @ A )
              @ ( ord_less_eq @ B ) )
           => ( ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B4
                @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B4
                  @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
                @ ( ord_less_eq @ C )
                @ ( ord_less_eq @ D ) )
             => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B4 )
                @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
                @ ( order_mono @ A @ C )
                @ ( order_mono @ B @ D ) ) ) ) ) ) ).

% mono_transfer
thf(fact_7347_mono__Int,axiom,
    ! [B: $tType,A: $tType,F3: ( set @ A ) > ( set @ B ),A3: set @ A,B4: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F3 )
     => ( ord_less_eq @ ( set @ B ) @ ( F3 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( inf_inf @ ( set @ B ) @ ( F3 @ A3 ) @ ( F3 @ B4 ) ) ) ) ).

% mono_Int
thf(fact_7348_mono__Un,axiom,
    ! [B: $tType,A: $tType,F3: ( set @ A ) > ( set @ B ),A3: set @ A,B4: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F3 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F3 @ A3 ) @ ( F3 @ B4 ) ) @ ( F3 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% mono_Un
thf(fact_7349_rtranclp_Omono,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P2: A > A > $o,X13: A,X23: A] :
          ( ? [A4: A] :
              ( ( X13 = A4 )
              & ( X23 = A4 ) )
          | ? [A4: A,B3: A,C3: A] :
              ( ( X13 = A4 )
              & ( X23 = C3 )
              & ( P2 @ A4 @ B3 )
              & ( R @ B3 @ C3 ) ) ) ) ).

% rtranclp.mono
thf(fact_7350_tranclp_Omono,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P2: A > A > $o,X13: A,X23: A] :
          ( ? [A4: A,B3: A] :
              ( ( X13 = A4 )
              & ( X23 = B3 )
              & ( R @ A4 @ B3 ) )
          | ? [A4: A,B3: A,C3: A] :
              ( ( X13 = A4 )
              & ( X23 = C3 )
              & ( P2 @ A4 @ B3 )
              & ( R @ B3 @ C3 ) ) ) ) ).

% tranclp.mono
thf(fact_7351_int_Obi__total,axiom,
    bi_total @ ( product_prod @ nat @ nat ) @ int @ pcr_int ).

% int.bi_total
thf(fact_7352_remdups__adj__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% remdups_adj_length
thf(fact_7353_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7354_remdups__adj__adjacent,axiom,
    ! [A: $tType,I: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ I )
       != ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ ( suc @ I ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_7355_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_7356_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs2
         != ( nil @ A ) )
        & ( Xs2
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( hd @ A @ Xs2 ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7357_rat__sgn__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( sgn_sgn @ rat @ P4 ) )
      = ( product_Pair @ int @ int @ ( sgn_sgn @ int @ ( product_fst @ int @ int @ ( quotient_of @ P4 ) ) ) @ ( one_one @ int ) ) ) ).

% rat_sgn_code
thf(fact_7358_intind,axiom,
    ! [A: $tType,I: nat,N: nat,P: A > $o,X: A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( P @ X )
       => ( P @ ( nth @ A @ ( replicate @ A @ N @ X ) @ I ) ) ) ) ).

% intind
thf(fact_7359_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N: nat,Y: A] :
      ( ( ( replicate @ A @ M @ X )
        = ( replicate @ A @ N @ Y ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X = Y ) ) ) ) ).

% replicate_eq_replicate
thf(fact_7360_empty__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_7361_replicate__empty,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( replicate @ A @ N @ X )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_7362_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
           => ( P @ X3 ) ) )
      = ( ( P @ A2 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_7363_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
            & ( P @ X3 ) ) )
      = ( ( P @ A2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_7364_in__set__replicate,axiom,
    ! [A: $tType,X: A,N: nat,Y: A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N @ Y ) ) )
      = ( ( X = Y )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_7365_hd__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_7366_drop__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,X: A] :
      ( ( drop @ A @ I @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I ) @ X ) ) ).

% drop_replicate
thf(fact_7367_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F3: B > A > A,N: nat,X: B] :
      ( ( foldr @ B @ A @ F3 @ ( replicate @ B @ N @ X ) )
      = ( compow @ ( A > A ) @ N @ ( F3 @ X ) ) ) ).

% foldr_replicate
thf(fact_7368_tl__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( tl @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ).

% tl_replicate
thf(fact_7369_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_7370_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_7371_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X ) ) ) ).

% sorted_replicate
thf(fact_7372_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_7373_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X )
      = ( cons @ A @ X @ ( replicate @ A @ N @ X ) ) ) ).

% replicate_Suc
thf(fact_7374_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,X: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N @ M ) @ X )
      = ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ M @ X ) ) ) ).

% replicate_add
thf(fact_7375_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_7376_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I: nat] :
      ( ( map @ nat @ A
        @ ^ [I3: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I ) )
      = ( replicate @ A @ I @ X ) ) ).

% map_replicate_trivial
thf(fact_7377_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_7378_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_7379_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_7380_subset__fst__imageI,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B,S2: set @ ( product_prod @ A @ B ),Y: B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : B4 )
        @ S2 )
     => ( ( member @ B @ Y @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S2 ) ) ) ) ).

% subset_fst_imageI
thf(fact_7381_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_7382_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat,Y: A] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( replicate @ A @ N @ Y ) )
      = ( ( X = Y )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs2
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_7383_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs2 @ Ys )
            = ( append @ A @ Ys @ Xs2 ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs2 @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_7384_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_7385_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X3: nat,Y6: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y6
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y6 @ ( modulo_modulo @ nat @ X3 @ Y6 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y6 @ ( modulo_modulo @ nat @ X3 @ Y6 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y6 @ ( modulo_modulo @ nat @ X3 @ Y6 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X3 @ Y6 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_7386_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) )
      = ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% map_fst_enumerate
thf(fact_7387_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_7388_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_7389_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_7390_quotient__of__denom__pos_H,axiom,
    ! [R: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R ) ) ) ).

% quotient_of_denom_pos'
thf(fact_7391_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) ) ) ).

% sorted_enumerate
thf(fact_7392_Eps__case__prod,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o] :
      ( ( fChoice @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) )
      = ( fChoice @ ( product_prod @ A @ B )
        @ ^ [Xy: product_prod @ A @ B] : ( P @ ( product_fst @ A @ B @ Xy ) @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% Eps_case_prod
thf(fact_7393_rel__fun__Collect__case__prodD,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,A3: A > B > $o,B4: C > D > $o,F3: A > C,G: B > D,X9: set @ ( product_prod @ A @ B ),X: product_prod @ A @ B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B4 @ F3 @ G )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ X9 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A3 ) ) )
       => ( ( member @ ( product_prod @ A @ B ) @ X @ X9 )
         => ( B4 @ ( comp @ A @ C @ ( product_prod @ A @ B ) @ F3 @ ( product_fst @ A @ B ) @ X ) @ ( comp @ B @ D @ ( product_prod @ A @ B ) @ G @ ( product_snd @ A @ B ) @ X ) ) ) ) ) ).

% rel_fun_Collect_case_prodD
thf(fact_7394_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X9: set @ A,A3: set @ ( product_prod @ A @ B ),Y8: set @ B,P: A > B > $o,Q: A > B > $o] :
      ( ( X9
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A3 ) )
     => ( ( Y8
          = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A3 ) )
       => ( ! [X4: A] :
              ( ( member @ A @ X4 @ X9 )
             => ! [Xa3: B] :
                  ( ( member @ B @ Xa3 @ Y8 )
                 => ( ( P @ X4 @ Xa3 )
                   => ( Q @ X4 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
           => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ Q ) ) ) ) ) ) ) ).

% Collect_split_mono_strong
thf(fact_7395_subset__snd__imageI,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B,S2: set @ ( product_prod @ A @ B ),X: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu2: A] : B4 )
        @ S2 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ S2 ) ) ) ) ).

% subset_snd_imageI
thf(fact_7396_subset__fst__snd,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3
      @ ( product_Sigma @ A @ B @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A3 )
        @ ^ [Uu2: A] : ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A3 ) ) ) ).

% subset_fst_snd
thf(fact_7397_quotient__of__unique,axiom,
    ! [R: rat] :
    ? [X4: product_prod @ int @ int] :
      ( ( R
        = ( fract @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ X4 ) ) )
      & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ X4 ) )
      & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ X4 ) )
      & ! [Y4: product_prod @ int @ int] :
          ( ( ( R
              = ( fract @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
            & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Y4 ) )
            & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
         => ( Y4 = X4 ) ) ) ).

% quotient_of_unique
thf(fact_7398_predicate2__transferD,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R12: A > B > $o,R23: C > D > $o,P: A > C > $o,Q: B > D > $o,A2: product_prod @ A @ B,A3: set @ ( product_prod @ A @ B ),B2: product_prod @ C @ D,B4: set @ ( product_prod @ C @ D )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ R12
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ R23
          @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 ) )
        @ P
        @ Q )
     => ( ( member @ ( product_prod @ A @ B ) @ A2 @ A3 )
       => ( ( member @ ( product_prod @ C @ D ) @ B2 @ B4 )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R12 ) ) )
           => ( ( ord_less_eq @ ( set @ ( product_prod @ C @ D ) ) @ B4 @ ( collect @ ( product_prod @ C @ D ) @ ( product_case_prod @ C @ D @ $o @ R23 ) ) )
             => ( ( P @ ( product_fst @ A @ B @ A2 ) @ ( product_fst @ C @ D @ B2 ) )
                = ( Q @ ( product_snd @ A @ B @ A2 ) @ ( product_snd @ C @ D @ B2 ) ) ) ) ) ) ) ) ).

% predicate2_transferD
thf(fact_7399_fun_Oin__rel,axiom,
    ! [B: $tType,A: $tType,D: $tType,R2: A > B > $o,A2: D > A,B2: D > B] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y5: D,Z4: D] : ( Y5 = Z4 )
        @ R2
        @ A2
        @ B2 )
      = ( ? [Z6: D > ( product_prod @ A @ B )] :
            ( ( member @ ( D > ( product_prod @ A @ B ) ) @ Z6
              @ ( collect @ ( D > ( product_prod @ A @ B ) )
                @ ^ [X3: D > ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ D @ ( product_prod @ A @ B ) @ X3 @ ( top_top @ ( set @ D ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R2 ) ) ) ) )
            & ( ( comp @ ( product_prod @ A @ B ) @ A @ D @ ( product_fst @ A @ B ) @ Z6 )
              = A2 )
            & ( ( comp @ ( product_prod @ A @ B ) @ B @ D @ ( product_snd @ A @ B ) @ Z6 )
              = B2 ) ) ) ) ).

% fun.in_rel
thf(fact_7400_quotient__of__def,axiom,
    ( quotient_of
    = ( ^ [X3: rat] :
          ( the @ ( product_prod @ int @ int )
          @ ^ [Pair: product_prod @ int @ int] :
              ( ( X3
                = ( fract @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) )
              & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Pair ) )
              & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) ) ) ) ) ).

% quotient_of_def
thf(fact_7401_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y )
     => ( ( bezw @ X @ Y )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_7402_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_7403_one__mod__minus__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_7404_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_7405_minus__one__mod__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_7406_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L4: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L4 @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_7407_in__set__enumerate__eq,axiom,
    ! [A: $tType,P4: product_prod @ nat @ A,N: nat,Xs2: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P4 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P4 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P4 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) )
        & ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P4 ) @ N ) )
          = ( product_snd @ nat @ A @ P4 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_7408_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F5: A > nat,G2: B > nat,P2: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F5 @ ( product_fst @ A @ B @ P2 ) ) @ ( G2 @ ( product_snd @ A @ B @ P2 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_7409_Rat_Opositive_Orep__eq,axiom,
    ( positive
    = ( ^ [X3: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ ( rep_Rat @ X3 ) ) @ ( product_snd @ int @ int @ ( rep_Rat @ X3 ) ) ) ) ) ) ).

% Rat.positive.rep_eq
thf(fact_7410_Rat_Opositive__def,axiom,
    ( positive
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ $o @ $o @ rep_Rat @ ( id @ $o )
      @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ) ).

% Rat.positive_def
thf(fact_7411_normalize__def,axiom,
    ( normalize
    = ( ^ [P2: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P2 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P2 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P2 ) @ ( product_snd @ int @ int @ P2 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P2 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P2 ) @ ( product_snd @ int @ int @ P2 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P2 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P2 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P2 ) @ ( product_snd @ int @ int @ P2 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P2 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P2 ) @ ( product_snd @ int @ int @ P2 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_7412_gcd__left__idem,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( gcd_gcd @ A @ A2 @ B2 ) )
          = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ).

% gcd_left_idem
thf(fact_7413_gcd__right__idem,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( gcd_gcd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ B2 )
          = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ).

% gcd_right_idem
thf(fact_7414_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_7415_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_7416_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_7417_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add2
thf(fact_7418_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add1
thf(fact_7419_gcd__neg2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ).

% gcd_neg2
thf(fact_7420_gcd__neg1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ).

% gcd_neg1
thf(fact_7421_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N ) ) ) ).

% gcd_exp
thf(fact_7422_gcd__greatest__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( gcd_gcd @ A @ B2 @ C2 ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% gcd_greatest_iff
thf(fact_7423_gcd__dvd2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ B2 ) ) ).

% gcd_dvd2
thf(fact_7424_gcd__dvd1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ A2 ) ) ).

% gcd_dvd1
thf(fact_7425_gcd__1__int,axiom,
    ! [M: int] :
      ( ( gcd_gcd @ int @ M @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% gcd_1_int
thf(fact_7426_gcd__neg2__int,axiom,
    ! [X: int,Y: int] :
      ( ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ Y ) )
      = ( gcd_gcd @ int @ X @ Y ) ) ).

% gcd_neg2_int
thf(fact_7427_gcd__neg1__int,axiom,
    ! [X: int,Y: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ Y )
      = ( gcd_gcd @ int @ X @ Y ) ) ).

% gcd_neg1_int
thf(fact_7428_gcd__abs2__int,axiom,
    ! [X: int,Y: int] :
      ( ( gcd_gcd @ int @ X @ ( abs_abs @ int @ Y ) )
      = ( gcd_gcd @ int @ X @ Y ) ) ).

% gcd_abs2_int
thf(fact_7429_gcd__abs1__int,axiom,
    ! [X: int,Y: int] :
      ( ( gcd_gcd @ int @ ( abs_abs @ int @ X ) @ Y )
      = ( gcd_gcd @ int @ X @ Y ) ) ).

% gcd_abs1_int
thf(fact_7430_abs__gcd__int,axiom,
    ! [X: int,Y: int] :
      ( ( abs_abs @ int @ ( gcd_gcd @ int @ X @ Y ) )
      = ( gcd_gcd @ int @ X @ Y ) ) ).

% abs_gcd_int
thf(fact_7431_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_7432_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_7433_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_7434_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
         => ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% coprime_imp_gcd_eq_1
thf(fact_7435_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_7436_Gcd__insert,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( gcd_Gcd @ A @ ( insert @ A @ A2 @ A3 ) )
          = ( gcd_gcd @ A @ A2 @ ( gcd_Gcd @ A @ A3 ) ) ) ) ).

% Gcd_insert
thf(fact_7437_gcd__neg__numeral__2__int,axiom,
    ! [X: int,N: num] :
      ( ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( gcd_gcd @ int @ X @ ( numeral_numeral @ int @ N ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_7438_gcd__neg__numeral__1__int,axiom,
    ! [N: num,X: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ X )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N ) @ X ) ) ).

% gcd_neg_numeral_1_int
thf(fact_7439_gcd__0__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ X @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_int
thf(fact_7440_gcd__0__left__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_left_int
thf(fact_7441_gcd__proj1__if__dvd__int,axiom,
    ! [X: int,Y: int] :
      ( ( dvd_dvd @ int @ X @ Y )
     => ( ( gcd_gcd @ int @ X @ Y )
        = ( abs_abs @ int @ X ) ) ) ).

% gcd_proj1_if_dvd_int
thf(fact_7442_gcd__proj2__if__dvd__int,axiom,
    ! [Y: int,X: int] :
      ( ( dvd_dvd @ int @ Y @ X )
     => ( ( gcd_gcd @ int @ X @ Y )
        = ( abs_abs @ int @ Y ) ) ) ).

% gcd_proj2_if_dvd_int
thf(fact_7443_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% is_unit_gcd
thf(fact_7444_Gcd__2,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( gcd_Gcd @ A @ ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ).

% Gcd_2
thf(fact_7445_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A2 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ E3 @ A2 )
              & ( dvd_dvd @ int @ E3 @ B2 ) )
           => ( dvd_dvd @ int @ E3 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_7446_gcd__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 ) )
    @ ( gcd_gcd @ int )
    @ ( gcd_gcd @ int ) ) ).

% gcd_integer.rsp
thf(fact_7447_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,A7: A,B7: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( times_times @ A @ A7 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
           => ( ( B2
                = ( times_times @ A @ B7 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A7 @ B7 ) ) ) ) ) ).

% gcd_coprime
thf(fact_7448_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ? [A20: A,B8: A] :
              ( ( A2
                = ( times_times @ A @ A20 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( B2
                = ( times_times @ A @ B8 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A20 @ B8 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_7449_div__gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( A2
             != ( zero_zero @ A ) )
            | ( B2
             != ( zero_zero @ A ) ) )
         => ( algebr8660921524188924756oprime @ A @ ( divide_divide @ A @ A2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) @ ( divide_divide @ A @ B2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ) ).

% div_gcd_coprime
thf(fact_7450_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( gcd_gcd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_right_right_cancel
thf(fact_7451_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ C2 )
         => ( ( gcd_gcd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_right_left_cancel
thf(fact_7452_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_left_right_cancel
thf(fact_7453_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ B2 @ C2 )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 )
            = ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ).

% gcd_mult_left_left_cancel
thf(fact_7454_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( algebr8660921524188924756oprime @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( gcd_gcd @ A @ A4 @ B3 )
              = ( one_one @ A ) ) ) ) ) ).

% coprime_iff_gcd_eq_1
thf(fact_7455_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ).

% gcd_eq_1_imp_coprime
thf(fact_7456_gcd__cases__int,axiom,
    ! [X: int,Y: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
         => ( P @ ( gcd_gcd @ int @ X @ Y ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ Y ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ Y ) ) ) )
         => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ ( uminus_uminus @ int @ Y ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X @ Y ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_7457_gcd__ge__0__int,axiom,
    ! [X: int,Y: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X @ Y ) ) ).

% gcd_ge_0_int
thf(fact_7458_gcd__diff1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ ( minus_minus @ A @ M @ N ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_diff1
thf(fact_7459_gcd__diff2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: A,M: A] :
          ( ( gcd_gcd @ A @ ( minus_minus @ A @ N @ M ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_diff2
thf(fact_7460_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_7461_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_7462_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_7463_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_7464_bezout__int,axiom,
    ! [X: int,Y: int] :
    ? [U6: int,V4: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U6 @ X ) @ ( times_times @ int @ V4 @ Y ) )
      = ( gcd_gcd @ int @ X @ Y ) ) ).

% bezout_int
thf(fact_7465_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_7466_gcd__idem__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ X @ X )
      = ( abs_abs @ int @ X ) ) ).

% gcd_idem_int
thf(fact_7467_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add_mult
thf(fact_7468_gcd__dvd__antisym,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( gcd_gcd @ A @ C2 @ D2 ) )
         => ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ C2 @ D2 ) @ ( gcd_gcd @ A @ A2 @ B2 ) )
           => ( ( gcd_gcd @ A @ A2 @ B2 )
              = ( gcd_gcd @ A @ C2 @ D2 ) ) ) ) ) ).

% gcd_dvd_antisym
thf(fact_7469_gcd__greatest,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ) ).

% gcd_greatest
thf(fact_7470_gcd__dvdI2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ C2 )
         => ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% gcd_dvdI2
thf(fact_7471_gcd__dvdI1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% gcd_dvdI1
thf(fact_7472_dvd__gcdD2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( gcd_gcd @ A @ B2 @ C2 ) )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_gcdD2
thf(fact_7473_dvd__gcdD1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( gcd_gcd @ A @ B2 @ C2 ) )
         => ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_gcdD1
thf(fact_7474_gcd__mono,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ B2 @ D2 )
           => ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( gcd_gcd @ A @ C2 @ D2 ) ) ) ) ) ).

% gcd_mono
thf(fact_7475_gcd_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( gcd_gcd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ C2 )
          = ( gcd_gcd @ A @ A2 @ ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd.assoc
thf(fact_7476_gcd_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( gcd_gcd @ A )
        = ( ^ [A4: A,B3: A] : ( gcd_gcd @ A @ B3 @ A4 ) ) ) ) ).

% gcd.commute
thf(fact_7477_gcd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( gcd_gcd @ A @ B2 @ ( gcd_gcd @ A @ A2 @ C2 ) )
          = ( gcd_gcd @ A @ A2 @ ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd.left_commute
thf(fact_7478_gcd__red__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [X3: int,Y6: int] : ( gcd_gcd @ int @ Y6 @ ( modulo_modulo @ int @ X3 @ Y6 ) ) ) ) ).

% gcd_red_int
thf(fact_7479_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) ) ) ).

% gcd_mult_distrib_int
thf(fact_7480_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_7481_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_7482_gcd__non__0__int,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y )
     => ( ( gcd_gcd @ int @ X @ Y )
        = ( gcd_gcd @ int @ Y @ ( modulo_modulo @ int @ X @ Y ) ) ) ) ).

% gcd_non_0_int
thf(fact_7483_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K2: int,L4: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L4
              = ( zero_zero @ int ) )
            @ K2
            @ ( gcd_gcd @ int @ L4 @ ( modulo_modulo @ int @ ( abs_abs @ int @ K2 ) @ ( abs_abs @ int @ L4 ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_7484_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( gcd_gcd @ int @ M @ N )
        = ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D4: int] :
                ( ( dvd_dvd @ int @ D4 @ M )
                & ( dvd_dvd @ int @ D4 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_int
thf(fact_7485_plus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) )
    @ ( plus_plus @ rat ) ) ).

% plus_rat.transfer
thf(fact_7486_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_7487_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_7488_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% gcd_nat.left_neutral
thf(fact_7489_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_7490_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% gcd_nat.right_neutral
thf(fact_7491_gcd__0__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ X @ ( zero_zero @ nat ) )
      = X ) ).

% gcd_0_nat
thf(fact_7492_gcd__0__left__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X )
      = X ) ).

% gcd_0_left_nat
thf(fact_7493_gcd__1__nat,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( one_one @ nat ) )
      = ( one_one @ nat ) ) ).

% gcd_1_nat
thf(fact_7494_gcd__nat_Oabsorb1,axiom,
    ! [A2: nat,B2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ B2 )
     => ( ( gcd_gcd @ nat @ A2 @ B2 )
        = A2 ) ) ).

% gcd_nat.absorb1
thf(fact_7495_gcd__nat_Oabsorb2,axiom,
    ! [B2: nat,A2: nat] :
      ( ( dvd_dvd @ nat @ B2 @ A2 )
     => ( ( gcd_gcd @ nat @ A2 @ B2 )
        = B2 ) ) ).

% gcd_nat.absorb2
thf(fact_7496_gcd__nat_Obounded__iff,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ ( gcd_gcd @ nat @ B2 @ C2 ) )
      = ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( dvd_dvd @ nat @ A2 @ C2 ) ) ) ).

% gcd_nat.bounded_iff
thf(fact_7497_gcd__proj1__if__dvd__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( dvd_dvd @ nat @ X @ Y )
     => ( ( gcd_gcd @ nat @ X @ Y )
        = X ) ) ).

% gcd_proj1_if_dvd_nat
thf(fact_7498_gcd__proj2__if__dvd__nat,axiom,
    ! [Y: nat,X: nat] :
      ( ( dvd_dvd @ nat @ Y @ X )
     => ( ( gcd_gcd @ nat @ X @ Y )
        = Y ) ) ).

% gcd_proj2_if_dvd_nat
thf(fact_7499_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_7500_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_7501_gcd__int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( gcd_gcd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_int_int_eq
thf(fact_7502_gcd__nat__abs__right__eq,axiom,
    ! [N: nat,K: int] :
      ( ( gcd_gcd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( nat2 @ ( gcd_gcd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% gcd_nat_abs_right_eq
thf(fact_7503_gcd__nat__abs__left__eq,axiom,
    ! [K: int,N: nat] :
      ( ( gcd_gcd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( nat2 @ ( gcd_gcd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ) ).

% gcd_nat_abs_left_eq
thf(fact_7504_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_7505_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_7506_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff1_nat
thf(fact_7507_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N @ M ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff2_nat
thf(fact_7508_Gcd__in,axiom,
    ! [A3: set @ nat] :
      ( ! [A5: nat,B5: nat] :
          ( ( member @ nat @ A5 @ A3 )
         => ( ( member @ nat @ B5 @ A3 )
           => ( member @ nat @ ( gcd_gcd @ nat @ A5 @ B5 ) @ A3 ) ) )
     => ( ( A3
         != ( bot_bot @ ( set @ nat ) ) )
       => ( member @ nat @ ( gcd_Gcd @ nat @ A3 ) @ A3 ) ) ) ).

% Gcd_in
thf(fact_7509_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K2: code_integer,L4: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L4
              = ( zero_zero @ code_integer ) )
            @ K2
            @ ( gcd_gcd @ code_integer @ L4 @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K2 ) @ ( abs_abs @ code_integer @ L4 ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_7510_gcd__non__0__nat,axiom,
    ! [Y: nat,X: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X @ Y )
        = ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) ) ).

% gcd_non_0_nat
thf(fact_7511_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X3: nat,Y6: nat] :
          ( if @ nat
          @ ( Y6
            = ( zero_zero @ nat ) )
          @ X3
          @ ( gcd_gcd @ nat @ Y6 @ ( modulo_modulo @ nat @ X3 @ Y6 ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_7512_gcd__nat_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y = X ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_7513_gcd__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa: code_integer] :
      ( ( code_int_of_integer @ ( gcd_gcd @ code_integer @ X @ Xa ) )
      = ( gcd_gcd @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa ) ) ) ).

% gcd_integer.rep_eq
thf(fact_7514_gcd__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( gcd_gcd @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( gcd_gcd @ int @ Xa @ X ) ) ) ).

% gcd_integer.abs_eq
thf(fact_7515_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_7516_gcd__red__nat,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X3: nat,Y6: nat] : ( gcd_gcd @ nat @ Y6 @ ( modulo_modulo @ nat @ X3 @ Y6 ) ) ) ) ).

% gcd_red_nat
thf(fact_7517_gcd__nat_Omono,axiom,
    ! [A2: nat,C2: nat,B2: nat,D2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ C2 )
     => ( ( dvd_dvd @ nat @ B2 @ D2 )
       => ( dvd_dvd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ ( gcd_gcd @ nat @ C2 @ D2 ) ) ) ) ).

% gcd_nat.mono
thf(fact_7518_gcd__nat_OorderE,axiom,
    ! [A2: nat,B2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ B2 )
     => ( A2
        = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ).

% gcd_nat.orderE
thf(fact_7519_gcd__nat_OorderI,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
     => ( dvd_dvd @ nat @ A2 @ B2 ) ) ).

% gcd_nat.orderI
thf(fact_7520_gcd__nat_Oabsorb3,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
     => ( ( gcd_gcd @ nat @ A2 @ B2 )
        = A2 ) ) ).

% gcd_nat.absorb3
thf(fact_7521_gcd__nat_Oabsorb4,axiom,
    ! [B2: nat,A2: nat] :
      ( ( ( dvd_dvd @ nat @ B2 @ A2 )
        & ( B2 != A2 ) )
     => ( ( gcd_gcd @ nat @ A2 @ B2 )
        = B2 ) ) ).

% gcd_nat.absorb4
thf(fact_7522_gcd__nat_OboundedE,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ ( gcd_gcd @ nat @ B2 @ C2 ) )
     => ~ ( ( dvd_dvd @ nat @ A2 @ B2 )
         => ~ ( dvd_dvd @ nat @ A2 @ C2 ) ) ) ).

% gcd_nat.boundedE
thf(fact_7523_gcd__nat_OboundedI,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ B2 )
     => ( ( dvd_dvd @ nat @ A2 @ C2 )
       => ( dvd_dvd @ nat @ A2 @ ( gcd_gcd @ nat @ B2 @ C2 ) ) ) ) ).

% gcd_nat.boundedI
thf(fact_7524_gcd__nat_Oorder__iff,axiom,
    ( ( dvd_dvd @ nat )
    = ( ^ [A4: nat,B3: nat] :
          ( A4
          = ( gcd_gcd @ nat @ A4 @ B3 ) ) ) ) ).

% gcd_nat.order_iff
thf(fact_7525_gcd__nat_Ocobounded1,axiom,
    ! [A2: nat,B2: nat] : ( dvd_dvd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ).

% gcd_nat.cobounded1
thf(fact_7526_gcd__nat_Ocobounded2,axiom,
    ! [A2: nat,B2: nat] : ( dvd_dvd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ).

% gcd_nat.cobounded2
thf(fact_7527_gcd__nat_Oabsorb__iff1,axiom,
    ( ( dvd_dvd @ nat )
    = ( ^ [A4: nat,B3: nat] :
          ( ( gcd_gcd @ nat @ A4 @ B3 )
          = A4 ) ) ) ).

% gcd_nat.absorb_iff1
thf(fact_7528_gcd__nat_Oabsorb__iff2,axiom,
    ( ( dvd_dvd @ nat )
    = ( ^ [B3: nat,A4: nat] :
          ( ( gcd_gcd @ nat @ A4 @ B3 )
          = B3 ) ) ) ).

% gcd_nat.absorb_iff2
thf(fact_7529_gcd__nat_OcoboundedI1,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( dvd_dvd @ nat @ A2 @ C2 )
     => ( dvd_dvd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ C2 ) ) ).

% gcd_nat.coboundedI1
thf(fact_7530_gcd__nat_OcoboundedI2,axiom,
    ! [B2: nat,C2: nat,A2: nat] :
      ( ( dvd_dvd @ nat @ B2 @ C2 )
     => ( dvd_dvd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ C2 ) ) ).

% gcd_nat.coboundedI2
thf(fact_7531_gcd__nat_Ostrict__boundedE,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ ( gcd_gcd @ nat @ B2 @ C2 ) )
        & ( A2
         != ( gcd_gcd @ nat @ B2 @ C2 ) ) )
     => ~ ( ( ( dvd_dvd @ nat @ A2 @ B2 )
            & ( A2 != B2 ) )
         => ~ ( ( dvd_dvd @ nat @ A2 @ C2 )
              & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_boundedE
thf(fact_7532_gcd__nat_Ostrict__order__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ B2 )
        & ( A2 != B2 ) )
      = ( ( A2
          = ( gcd_gcd @ nat @ A2 @ B2 ) )
        & ( A2 != B2 ) ) ) ).

% gcd_nat.strict_order_iff
thf(fact_7533_gcd__nat_Ostrict__coboundedI1,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ A2 @ C2 )
        & ( A2 != C2 ) )
     => ( ( dvd_dvd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ C2 )
        & ( ( gcd_gcd @ nat @ A2 @ B2 )
         != C2 ) ) ) ).

% gcd_nat.strict_coboundedI1
thf(fact_7534_gcd__nat_Ostrict__coboundedI2,axiom,
    ! [B2: nat,C2: nat,A2: nat] :
      ( ( ( dvd_dvd @ nat @ B2 @ C2 )
        & ( B2 != C2 ) )
     => ( ( dvd_dvd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ C2 )
        & ( ( gcd_gcd @ nat @ A2 @ B2 )
         != C2 ) ) ) ).

% gcd_nat.strict_coboundedI2
thf(fact_7535_gcd__unique__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat] :
      ( ( ( dvd_dvd @ nat @ D2 @ A2 )
        & ( dvd_dvd @ nat @ D2 @ B2 )
        & ! [E3: nat] :
            ( ( ( dvd_dvd @ nat @ E3 @ A2 )
              & ( dvd_dvd @ nat @ E3 @ B2 ) )
           => ( dvd_dvd @ nat @ E3 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ).

% gcd_unique_nat
thf(fact_7536_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X4: nat,Y3: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ ( times_times @ nat @ A2 @ X4 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X4 ) @ ( times_times @ nat @ B2 @ Y3 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y3 ) @ ( times_times @ nat @ B2 @ X4 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X4 ) @ ( times_times @ nat @ A2 @ Y3 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_7537_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X4: nat,Y3: nat] :
          ( ( times_times @ nat @ A2 @ X4 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y3 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_7538_gcd__int__def,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [X3: int,Y6: int] : ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ ( nat2 @ ( abs_abs @ int @ X3 ) ) @ ( nat2 @ ( abs_abs @ int @ Y6 ) ) ) ) ) ) ).

% gcd_int_def
thf(fact_7539_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M3: nat,N2: nat] :
        ( ( dvd_dvd @ nat @ M3 @ N2 )
        & ( M3 != N2 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_7540_one__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( one_one @ rat ) ).

% one_rat.transfer
thf(fact_7541_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( gcd_gcd @ nat @ M @ N )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D4: nat] :
                ( ( dvd_dvd @ nat @ D4 @ M )
                & ( dvd_dvd @ nat @ D4 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_7542_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_7543_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ pcr_rat )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_7544_bezw__aux,axiom,
    ! [X: nat,Y: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X @ Y ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ Y ) ) ) ) ).

% bezw_aux
thf(fact_7545_times__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) )
    @ ( times_times @ rat ) ) ).

% times_rat.transfer
thf(fact_7546_Rat_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ $o @ $o @ pcr_rat
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) )
    @ positive ) ).

% Rat.positive.transfer
thf(fact_7547_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y = X ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_7548_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs: list @ A,A6: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P2: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P2 ) @ A6 )
              @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ) ).

% nths_def
thf(fact_7549_gcd__nat_Oidem,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ A2 )
      = A2 ) ).

% gcd_nat.idem
thf(fact_7550_gcd__nat_Oleft__idem,axiom,
    ! [A2: nat,B2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( gcd_gcd @ nat @ A2 @ B2 ) ) ).

% gcd_nat.left_idem
thf(fact_7551_gcd__nat_Oright__idem,axiom,
    ! [A2: nat,B2: nat] :
      ( ( gcd_gcd @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 )
      = ( gcd_gcd @ nat @ A2 @ B2 ) ) ).

% gcd_nat.right_idem
thf(fact_7552_gcd__idem__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ X @ X )
      = X ) ).

% gcd_idem_nat
thf(fact_7553_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs2: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P2: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P2 ) ) )
          @ ( zip @ A @ nat @ Xs2 @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P2: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P2 ) )
          @ ( zip @ A @ nat @ Xs2 @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_7554_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set @ nat,Xs2: list @ A,I: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P2: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P2 ) @ A3 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ I @ ( plus_plus @ nat @ I @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P2: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P2 ) @ I ) @ A3 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_7555_list_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R6: A > B > $o,A4: list @ A,B3: list @ B] :
          ? [Z6: list @ ( product_prod @ A @ B )] :
            ( ( member @ ( list @ ( product_prod @ A @ B ) ) @ Z6
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X3: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X3 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R6 ) ) ) ) )
            & ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z6 )
              = A4 )
            & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z6 )
              = B3 ) ) ) ) ).

% list.in_rel
thf(fact_7556_independent__explicit__finite__subsets,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ A3 ) )
          = ( ! [S7: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ S7 @ A3 )
               => ( ( finite_finite @ A @ S7 )
                 => ! [U2: A > real] :
                      ( ( ( groups7311177749621191930dd_sum @ A @ A
                          @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                          @ S7 )
                        = ( zero_zero @ A ) )
                     => ! [X3: A] :
                          ( ( member @ A @ X3 @ S7 )
                         => ( ( U2 @ X3 )
                            = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_finite_subsets
thf(fact_7557_dependent__single,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V358717886546972837endent @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% dependent_single
thf(fact_7558_dependent__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ A3 )
         => ( real_V358717886546972837endent @ A @ A3 ) ) ) ).

% dependent_zero
thf(fact_7559_list_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R2: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R2 @ Ra )
     => ( ord_less_eq @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( list_all2 @ A @ B @ R2 ) @ ( list_all2 @ A @ B @ Ra ) ) ) ).

% list.rel_mono
thf(fact_7560_dependent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( real_V358717886546972837endent @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
           => ( real_V358717886546972837endent @ A @ A3 ) ) ) ) ).

% dependent_mono
thf(fact_7561_independent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ A3 )
         => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
           => ~ ( real_V358717886546972837endent @ A @ B4 ) ) ) ) ).

% independent_mono
thf(fact_7562_independent__Union__directed,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C5: set @ ( set @ A )] :
          ( ! [C4: set @ A,D6: set @ A] :
              ( ( member @ ( set @ A ) @ C4 @ C5 )
             => ( ( member @ ( set @ A ) @ D6 @ C5 )
               => ( ( ord_less_eq @ ( set @ A ) @ C4 @ D6 )
                  | ( ord_less_eq @ ( set @ A ) @ D6 @ C4 ) ) ) )
         => ( ! [C4: set @ A] :
                ( ( member @ ( set @ A ) @ C4 @ C5 )
               => ~ ( real_V358717886546972837endent @ A @ C4 ) )
           => ~ ( real_V358717886546972837endent @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) ) ) ) ) ).

% independent_Union_directed
thf(fact_7563_unique__representation,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,F3: A > real,G: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ! [V4: A] :
                ( ( ( F3 @ V4 )
                 != ( zero_zero @ real ) )
               => ( member @ A @ V4 @ Basis ) )
           => ( ! [V4: A] :
                  ( ( ( G @ V4 )
                   != ( zero_zero @ real ) )
                 => ( member @ A @ V4 @ Basis ) )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [V5: A] :
                        ( ( F3 @ V5 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [V5: A] :
                          ( ( G @ V5 )
                         != ( zero_zero @ real ) ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( F3 @ V5 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( G @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( G @ V5 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( F3 = G ) ) ) ) ) ) ) ) ).

% unique_representation
thf(fact_7564_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( monoid_add @ A ) )
     => ! [A3: A > B > $o] :
          ( ( A3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A3 ) @ A3 @ ( groups8242544230860333062m_list @ A ) @ ( groups8242544230860333062m_list @ B ) ) ) ) ) ).

% sum_list_transfer
thf(fact_7565_independent__if__scalars__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [F4: A > real,X4: A] :
                ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [Y6: A] : ( real_V8093663219630862766scaleR @ A @ ( F4 @ Y6 ) @ Y6 )
                    @ A3 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ X4 @ A3 )
                 => ( ( F4 @ X4 )
                    = ( zero_zero @ real ) ) ) )
           => ~ ( real_V358717886546972837endent @ A @ A3 ) ) ) ) ).

% independent_if_scalars_zero
thf(fact_7566_dependent__finite,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( real_V358717886546972837endent @ A @ S2 )
            = ( ? [U2: A > real] :
                  ( ? [X3: A] :
                      ( ( member @ A @ X3 @ S2 )
                      & ( ( U2 @ X3 )
                       != ( zero_zero @ real ) ) )
                  & ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ S2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% dependent_finite
thf(fact_7567_independentD__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A,X9: A > real,Y8: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ B4 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X3: A] :
                    ( ( X9 @ X3 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X9 @ X3 )
                     != ( zero_zero @ real ) ) )
                @ B4 )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( Y8 @ X3 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( Y8 @ X3 )
                         != ( zero_zero @ real ) ) )
                    @ B4 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X9 @ X3 ) @ X3 )
                        @ ( collect @ A
                          @ ^ [X3: A] :
                              ( ( X9 @ X3 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( Y8 @ X3 ) @ X3 )
                        @ ( collect @ A
                          @ ^ [X3: A] :
                              ( ( Y8 @ X3 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( X9 = Y8 ) ) ) ) ) ) ) ) ).

% independentD_unique
thf(fact_7568_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A3: A > B > $o,B4: C > D > $o] :
          ( ( A3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B4 @ A3 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A3 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B4 ) @ A3 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_7569_independentD,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A,T2: set @ A,U: A > real,V: A] :
          ( ~ ( real_V358717886546972837endent @ A @ S )
         => ( ( finite_finite @ A @ T2 )
           => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U @ V5 ) @ V5 )
                    @ T2 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ V @ T2 )
                 => ( ( U @ V )
                    = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independentD
thf(fact_7570_dependent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [B6: set @ A] :
            ? [X8: A > real] :
              ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X8 @ X3 )
                     != ( zero_zero @ real ) ) ) )
              & ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X8 @ X3 )
                     != ( zero_zero @ real ) ) )
                @ B6 )
              & ( ( groups7311177749621191930dd_sum @ A @ A
                  @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X3 ) @ X3 )
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( X8 @ X3 )
                       != ( zero_zero @ real ) ) ) )
                = ( zero_zero @ A ) )
              & ? [X3: A] :
                  ( ( X8 @ X3 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% dependent_alt
thf(fact_7571_independent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ B4 ) )
          = ( ! [X8: A > real] :
                ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( X8 @ X3 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( X8 @ X3 )
                         != ( zero_zero @ real ) ) )
                    @ B4 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X3 ) @ X3 )
                        @ ( collect @ A
                          @ ^ [X3: A] :
                              ( ( X8 @ X3 )
                             != ( zero_zero @ real ) ) ) )
                      = ( zero_zero @ A ) )
                   => ! [X3: A] :
                        ( ( X8 @ X3 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independent_alt
thf(fact_7572_independentD__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A,X9: A > real,X: A] :
          ( ~ ( real_V358717886546972837endent @ A @ B4 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X3: A] :
                    ( ( X9 @ X3 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X3: A] :
                      ( ( X9 @ X3 )
                     != ( zero_zero @ real ) ) )
                @ B4 )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( X9 @ X3 ) @ X3 )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( X9 @ X3 )
                         != ( zero_zero @ real ) ) ) )
                  = ( zero_zero @ A ) )
               => ( ( X9 @ X )
                  = ( zero_zero @ real ) ) ) ) ) ) ) ).

% independentD_alt
thf(fact_7573_dependent__explicit,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [S4: set @ A] :
            ? [T3: set @ A] :
              ( ( finite_finite @ A @ T3 )
              & ( ord_less_eq @ ( set @ A ) @ T3 @ S4 )
              & ? [U2: A > real] :
                  ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ T3 )
                    = ( zero_zero @ A ) )
                  & ? [X3: A] :
                      ( ( member @ A @ X3 @ T3 )
                      & ( ( U2 @ X3 )
                       != ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% dependent_explicit
thf(fact_7574_independent__explicit__module,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ S ) )
          = ( ! [T3: set @ A,U2: A > real,V5: A] :
                ( ( finite_finite @ A @ T3 )
               => ( ( ord_less_eq @ ( set @ A ) @ T3 @ S )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ W3 ) @ W3 )
                        @ T3 )
                      = ( zero_zero @ A ) )
                   => ( ( member @ A @ V5 @ T3 )
                     => ( ( U2 @ V5 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_module
thf(fact_7575_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_mult @ B )
        & ( monoid_mult @ A ) )
     => ! [A3: A > B > $o] :
          ( ( A3 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A3 ) @ A3 @ ( groups5270119922927024881d_list @ A ) @ ( groups5270119922927024881d_list @ B ) ) ) ) ) ).

% prod_list_transfer
thf(fact_7576_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X9: set @ A,Y8: set @ A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( finite_card @ A @ X9 ) )
             => ( ( infini527867602293511546merate @ A @ X9 @ I2 )
                = ( infini527867602293511546merate @ A @ Y8 @ I2 ) ) )
         => ( ( finite_finite @ A @ X9 )
           => ( ( finite_finite @ A @ Y8 )
             => ( ( ord_less_eq @ nat @ ( finite_card @ A @ X9 ) @ ( finite_card @ A @ Y8 ) )
               => ( ord_less_eq @ ( set @ A ) @ X9 @ Y8 ) ) ) ) ) ) ).

% finite_enum_subset
thf(fact_7577_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( cons @ A @ X @ Xs2 ) )
          = ( times_times @ A @ X @ ( groups5270119922927024881d_list @ A @ Xs2 ) ) ) ) ).

% prod_list.Cons
thf(fact_7578_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A @ ( nil @ A ) )
        = ( one_one @ A ) ) ) ).

% prod_list.Nil
thf(fact_7579_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( append @ A @ Xs2 @ Ys ) )
          = ( times_times @ A @ ( groups5270119922927024881d_list @ A @ Xs2 ) @ ( groups5270119922927024881d_list @ A @ Ys ) ) ) ) ).

% prod_list.append
thf(fact_7580_le__enumerate,axiom,
    ! [S2: set @ nat,N: nat] :
      ( ~ ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S2 @ N ) ) ) ).

% le_enumerate
thf(fact_7581_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( semiring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [Xs2: list @ A] :
          ( ( ( groups5270119922927024881d_list @ A @ Xs2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( zero_zero @ A ) @ ( set2 @ A @ Xs2 ) ) ) ) ).

% prod_list_zero_iff
thf(fact_7582_prod__list__coprime__right,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
             => ( algebr8660921524188924756oprime @ A @ A2 @ X4 ) )
         => ( algebr8660921524188924756oprime @ A @ A2 @ ( groups5270119922927024881d_list @ A @ Xs2 ) ) ) ) ).

% prod_list_coprime_right
thf(fact_7583_prod__list__coprime__left,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs2 ) )
             => ( algebr8660921524188924756oprime @ A @ X4 @ A2 ) )
         => ( algebr8660921524188924756oprime @ A @ ( groups5270119922927024881d_list @ A @ Xs2 ) @ A2 ) ) ) ).

% prod_list_coprime_left
thf(fact_7584_enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) ) ) ) ) ).

% enumerate_step
thf(fact_7585_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( ^ [Xs: list @ A] : ( foldr @ A @ A @ ( times_times @ A ) @ Xs @ ( one_one @ A ) ) ) ) ) ).

% prod_list.eq_foldr
thf(fact_7586_finite__le__enumerate,axiom,
    ! [S2: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ( ord_less @ nat @ N @ ( finite_card @ nat @ S2 ) )
       => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S2 @ N ) ) ) ) ).

% finite_le_enumerate
thf(fact_7587_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S2 ) )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) ) ) ) ) ) ).

% finite_enumerate_step
thf(fact_7588_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) ) @ ( bot_bot @ ( set @ A ) ) ) ) @ N ) ) ) ).

% enumerate_Suc'
thf(fact_7589_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S2 ) )
           => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
              = ( ord_Least @ A
                @ ^ [S4: A] :
                    ( ( member @ A @ S4 @ S2 )
                    & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S4 ) ) ) ) ) ) ) ).

% finite_enumerate_Suc''
thf(fact_7590_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A
            @ ( minus_minus @ ( set @ A ) @ S2
              @ ( insert @ A
                @ ( ord_Least @ A
                  @ ^ [N2: A] : ( member @ A @ N2 @ S2 ) )
                @ ( bot_bot @ ( set @ A ) ) ) )
            @ N ) ) ) ).

% enumerate_Suc
thf(fact_7591_Least__eq__0,axiom,
    ! [P: nat > $o] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( ord_Least @ nat @ P )
        = ( zero_zero @ nat ) ) ) ).

% Least_eq_0
thf(fact_7592_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_1: A] : ( P @ X_1 )
         => ( ! [A5: A] :
                ( ( P @ A5 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A5 @ B10 ) )
                 => ( Q @ A5 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_7593_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [A5: A] :
                ( ( P @ A5 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A5 @ B10 ) )
                 => ( Q @ A5 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_7594_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ( ord_Least @ A @ P )
              = X ) ) ) ) ).

% Least_equality
thf(fact_7595_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ A @ X @ Y3 ) )
           => ( ! [X4: A] :
                  ( ( P @ X4 )
                 => ( ! [Y4: A] :
                        ( ( P @ Y4 )
                       => ( ord_less_eq @ A @ X4 @ Y4 ) )
                   => ( Q @ X4 ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_7596_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z: A] :
          ( ? [X5: A] :
              ( ( P @ X5 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X5 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y3 @ Ya2 ) ) )
                 => ( Y3 = X5 ) ) )
         => ( ( P @ Z )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z ) ) ) ) ).

% Least1_le
thf(fact_7597_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X5: A] :
              ( ( P @ X5 )
              & ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ A @ X5 @ Y3 ) )
              & ! [Y3: A] :
                  ( ( ( P @ Y3 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y3 @ Ya2 ) ) )
                 => ( Y3 = X5 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_7598_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_7599_Least__Suc2,axiom,
    ! [P: nat > $o,N: nat,Q: nat > $o,M: nat] :
      ( ( P @ N )
     => ( ( Q @ M )
       => ( ~ ( P @ ( zero_zero @ nat ) )
         => ( ! [K3: nat] :
                ( ( P @ ( suc @ K3 ) )
                = ( Q @ K3 ) )
           => ( ( ord_Least @ nat @ P )
              = ( suc @ ( ord_Least @ nat @ Q ) ) ) ) ) ) ) ).

% Least_Suc2
thf(fact_7600_Least__Suc,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ( ( ord_Least @ nat @ P )
          = ( suc
            @ ( ord_Least @ nat
              @ ^ [M3: nat] : ( P @ ( suc @ M3 ) ) ) ) ) ) ) ).

% Least_Suc
thf(fact_7601_enumerate__0,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A] :
          ( ( infini527867602293511546merate @ A @ S2 @ ( zero_zero @ nat ) )
          = ( ord_Least @ A
            @ ^ [N2: A] : ( member @ A @ N2 @ S2 ) ) ) ) ).

% enumerate_0
thf(fact_7602_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F3: A > B,S2: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ? [X5: A] :
                ( ( member @ A @ X5 @ S2 )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ S2 )
                   => ( ord_less_eq @ A @ X5 @ Xa3 ) ) )
           => ( ( ord_Least @ B
                @ ^ [Y6: B] : ( member @ B @ Y6 @ ( image @ A @ B @ F3 @ S2 ) ) )
              = ( F3
                @ ( ord_Least @ A
                  @ ^ [X3: A] : ( member @ A @ X3 @ S2 ) ) ) ) ) ) ) ).

% Least_mono
thf(fact_7603_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P6: A > $o] :
              ( the @ A
              @ ^ [X3: A] :
                  ( ( P6 @ X3 )
                  & ! [Y6: A] :
                      ( ( P6 @ Y6 )
                     => ( ord_less_eq @ A @ X3 @ Y6 ) ) ) ) ) ) ) ).

% Least_def
thf(fact_7604_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N ) )
            = ( ord_Least @ A
              @ ^ [S4: A] :
                  ( ( member @ A @ S4 @ S2 )
                  & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N ) @ S4 ) ) ) ) ) ) ).

% enumerate_Suc''
thf(fact_7605_isUCont__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F3: A > B] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F3 )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S4: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S4 )
                    & ! [X3: A,Y6: A] :
                        ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ Y6 ) @ S4 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X3 ) @ ( F3 @ Y6 ) ) @ R5 ) ) ) ) ) ) ) ).

% isUCont_def
thf(fact_7606_plus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) )
    @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) ) ) ).

% plus_rat.rsp
thf(fact_7607_ratrel__iff,axiom,
    ( ratrel
    = ( ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X3 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y6 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ) ) ).

% ratrel_iff
thf(fact_7608_one__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ).

% one_rat.rsp
thf(fact_7609_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_7610_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y5: int,Z4: int] : ( Y5 = Z4 )
      @ ratrel )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) )
    @ ^ [A4: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A4 @ B3 ) ) ) ).

% Fract.rsp
thf(fact_7611_uniformly__continuous__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ( ( topolo6026614971017936543ous_on @ A @ B )
        = ( ^ [S4: set @ A,F5: A > B] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [D4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                  & ! [X3: A] :
                      ( ( member @ A @ X3 @ S4 )
                     => ! [Y6: A] :
                          ( ( member @ A @ Y6 @ S4 )
                         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y6 @ X3 ) @ D4 )
                           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ Y6 ) @ ( F5 @ X3 ) ) @ E3 ) ) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
thf(fact_7612_ratrel__def,axiom,
    ( ratrel
    = ( ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X3 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y6 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ) ) ).

% ratrel_def
thf(fact_7613_times__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) )
    @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) ) ) ).

% times_rat.rsp
thf(fact_7614_Rat_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o @ ratrel
    @ ^ [Y5: $o,Z4: $o] : ( Y5 = Z4 )
    @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) )
    @ ^ [X3: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) ) ) ).

% Rat.positive.rsp
thf(fact_7615_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) )
    @ ^ [X3: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X3 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_7616_plus__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X @ X )
       => ( ( plus_plus @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% plus_rat.abs_eq
thf(fact_7617_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_7618_one__rat__def,axiom,
    ( ( one_one @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ) ).

% one_rat_def
thf(fact_7619_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X3: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X3
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X3 ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_7620_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_7621_times__rat_Oabs__eq,axiom,
    ! [Xa: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa @ Xa )
     => ( ( ratrel @ X @ X )
       => ( ( times_times @ rat @ ( abs_Rat @ Xa ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa ) @ ( product_fst @ int @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% times_rat.abs_eq
thf(fact_7622_Rat_Opositive_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( positive @ ( abs_Rat @ X ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% Rat.positive.abs_eq
thf(fact_7623_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X3: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X3 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_fst @ int @ int @ X3 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_7624_acyclic__insert,axiom,
    ! [A: $tType,Y: A,X: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_acyclic @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ X ) @ R ) )
      = ( ( transitive_acyclic @ A @ R )
        & ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% acyclic_insert
thf(fact_7625_acyclic__def,axiom,
    ! [A: $tType] :
      ( ( transitive_acyclic @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [X3: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( transitive_trancl @ A @ R5 ) ) ) ) ).

% acyclic_def
thf(fact_7626_acyclicI,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ! [X4: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ X4 ) @ ( transitive_trancl @ A @ R ) )
     => ( transitive_acyclic @ A @ R ) ) ).

% acyclicI
thf(fact_7627_acyclicI__order,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [R: set @ ( product_prod @ B @ B ),F3: B > A] :
          ( ! [A5: B,B5: B] :
              ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A5 @ B5 ) @ R )
             => ( ord_less @ A @ ( F3 @ B5 ) @ ( F3 @ A5 ) ) )
         => ( transitive_acyclic @ B @ R ) ) ) ).

% acyclicI_order
thf(fact_7628_acyclic__subset,axiom,
    ! [A: $tType,S: set @ ( product_prod @ A @ A ),R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_acyclic @ A @ S )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
       => ( transitive_acyclic @ A @ R ) ) ) ).

% acyclic_subset
thf(fact_7629_plus__rat__def,axiom,
    ( ( plus_plus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ X3 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) ) ) ) ).

% plus_rat_def
thf(fact_7630_times__rat__def,axiom,
    ( ( times_times @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X3: product_prod @ int @ int,Y6: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_fst @ int @ int @ Y6 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X3 ) @ ( product_snd @ int @ int @ Y6 ) ) ) ) ) ).

% times_rat_def
thf(fact_7631_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% numeral_xor_num
thf(fact_7632_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ) ).

% numeral_and_num
thf(fact_7633_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) )
            & ( finite_finite @ A @ A3 ) ) ) ) ).

% Gcd_fin_0_iff
thf(fact_7634_last__list__update,axiom,
    ! [A: $tType,Xs2: list @ A,K: nat,X: A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( ( K
            = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
            = X ) )
        & ( ( K
           != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
            = ( last @ A @ Xs2 ) ) ) ) ) ).

% last_list_update
thf(fact_7635_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_fin.empty
thf(fact_7636_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_fin.infinite
thf(fact_7637_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Gcd_fin @ A @ A3 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Gcd_fin_iff
thf(fact_7638_Gcd__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( insert @ A @ A2 @ A3 ) )
          = ( gcd_gcd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ A3 ) ) ) ) ).

% Gcd_fin.insert
thf(fact_7639_last__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( last @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% last_replicate
thf(fact_7640_Gcd__fin__eq__Gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( gcd_Gcd @ A @ A3 ) ) ) ) ).

% Gcd_fin_eq_Gcd
thf(fact_7641_last__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( last @ nat @ ( upt @ I @ J ) )
        = ( minus_minus @ nat @ J @ ( one_one @ nat ) ) ) ) ).

% last_upt
thf(fact_7642_Gcd__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
         => ( ( gcd_gcd @ A @ ( semiring_gcd_Gcd_fin @ A @ B4 ) @ ( semiring_gcd_Gcd_fin @ A @ A3 ) )
            = ( semiring_gcd_Gcd_fin @ A @ A3 ) ) ) ) ).

% Gcd_fin.subset
thf(fact_7643_Gcd__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
          = ( gcd_gcd @ A @ ( semiring_gcd_Gcd_fin @ A @ A3 ) @ ( semiring_gcd_Gcd_fin @ A @ B4 ) ) ) ) ).

% Gcd_fin.union
thf(fact_7644_Gcd__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( member @ A @ A2 @ A3 )
         => ( ( gcd_gcd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ A3 ) )
            = ( semiring_gcd_Gcd_fin @ A @ A3 ) ) ) ) ).

% Gcd_fin.in_idem
thf(fact_7645_Gcd__fin__greatest,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ! [B5: A] :
                ( ( member @ A @ B5 @ A3 )
               => ( dvd_dvd @ A @ A2 @ B5 ) )
           => ( dvd_dvd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ A3 ) ) ) ) ) ).

% Gcd_fin_greatest
thf(fact_7646_dvd__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( dvd_dvd @ A @ B2 @ ( semiring_gcd_Gcd_fin @ A @ A3 ) )
            = ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A3 )
                 => ( dvd_dvd @ A @ B2 @ X3 ) ) ) ) ) ) ).

% dvd_Gcd_fin_iff
thf(fact_7647_Gcd__fin__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( member @ A @ A2 @ A3 )
         => ( dvd_dvd @ A @ ( semiring_gcd_Gcd_fin @ A @ A3 ) @ A2 ) ) ) ).

% Gcd_fin_dvd
thf(fact_7648_dvd__gcd__list__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,Xs2: list @ A] :
          ( ( dvd_dvd @ A @ B2 @ ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Xs2 ) ) )
          = ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
               => ( dvd_dvd @ A @ B2 @ X3 ) ) ) ) ) ).

% dvd_gcd_list_iff
thf(fact_7649_gcd__list__greatest,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Bs: list @ A,A2: A] :
          ( ! [B5: A] :
              ( ( member @ A @ B5 @ ( set2 @ A @ Bs ) )
             => ( dvd_dvd @ A @ A2 @ B5 ) )
         => ( dvd_dvd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Bs ) ) ) ) ) ).

% gcd_list_greatest
thf(fact_7650_Gcd__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( insert @ A @ A2 @ A3 ) )
          = ( gcd_gcd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% Gcd_fin.insert_remove
thf(fact_7651_Gcd__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( member @ A @ A2 @ A3 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A3 )
            = ( gcd_gcd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% Gcd_fin.remove
thf(fact_7652_last__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( last @ A @ Xs2 )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ) ) ).

% last_conv_nth
thf(fact_7653_connected__closed,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [S4: set @ A] :
              ~ ? [A6: set @ A,B6: set @ A] :
                  ( ( topolo7761053866217962861closed @ A @ A6 )
                  & ( topolo7761053866217962861closed @ A @ B6 )
                  & ( ord_less_eq @ ( set @ A ) @ S4 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) )
                  & ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) @ S4 )
                    = ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ A6 @ S4 )
                   != ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ B6 @ S4 )
                   != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% connected_closed
thf(fact_7654_connected__closedD,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,A3: set @ A,B4: set @ A] :
          ( ( topolo1966860045006549960nected @ A @ S )
         => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ S )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
             => ( ( topolo7761053866217962861closed @ A @ A3 )
               => ( ( topolo7761053866217962861closed @ A @ B4 )
                 => ( ( ( inf_inf @ ( set @ A ) @ A3 @ S )
                      = ( bot_bot @ ( set @ A ) ) )
                    | ( ( inf_inf @ ( set @ A ) @ B4 @ S )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% connected_closedD
thf(fact_7655_connected__contains__Icc,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A3: set @ A,A2: A,B2: A] :
          ( ( topolo1966860045006549960nected @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ( member @ A @ B2 @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ A3 ) ) ) ) ) ).

% connected_contains_Icc
thf(fact_7656_connected__iff__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [U4: set @ A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ U4 )
             => ! [Y6: A] :
                  ( ( member @ A @ Y6 @ U4 )
                 => ! [Z6: A] :
                      ( ( ord_less_eq @ A @ X3 @ Z6 )
                     => ( ( ord_less_eq @ A @ Z6 @ Y6 )
                       => ( member @ A @ Z6 @ U4 ) ) ) ) ) ) ) ) ).

% connected_iff_interval
thf(fact_7657_connectedI__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [U3: set @ A] :
          ( ! [X4: A,Y3: A,Z5: A] :
              ( ( member @ A @ X4 @ U3 )
             => ( ( member @ A @ Y3 @ U3 )
               => ( ( ord_less_eq @ A @ X4 @ Z5 )
                 => ( ( ord_less_eq @ A @ Z5 @ Y3 )
                   => ( member @ A @ Z5 @ U3 ) ) ) ) )
         => ( topolo1966860045006549960nected @ A @ U3 ) ) ) ).

% connectedI_interval
thf(fact_7658_connectedD__interval,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [U3: set @ A,X: A,Y: A,Z: A] :
          ( ( topolo1966860045006549960nected @ A @ U3 )
         => ( ( member @ A @ X @ U3 )
           => ( ( member @ A @ Y @ U3 )
             => ( ( ord_less_eq @ A @ X @ Z )
               => ( ( ord_less_eq @ A @ Z @ Y )
                 => ( member @ A @ Z @ U3 ) ) ) ) ) ) ) ).

% connectedD_interval
thf(fact_7659_connected__contains__Ioo,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A3: set @ A,A2: A,B2: A] :
          ( ( topolo1966860045006549960nected @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ( member @ A @ B2 @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ A3 ) ) ) ) ) ).

% connected_contains_Ioo
thf(fact_7660_connected__diff__open__from__closed,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,U: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ U )
           => ( ( topolo1002775350975398744n_open @ A @ S )
             => ( ( topolo7761053866217962861closed @ A @ T2 )
               => ( ( topolo1966860045006549960nected @ A @ U )
                 => ( ( topolo1966860045006549960nected @ A @ ( minus_minus @ ( set @ A ) @ T2 @ S ) )
                   => ( topolo1966860045006549960nected @ A @ ( minus_minus @ ( set @ A ) @ U @ S ) ) ) ) ) ) ) ) ) ).

% connected_diff_open_from_closed
thf(fact_7661_connected__def,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [S7: set @ A] :
              ~ ? [A6: set @ A,B6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ A6 )
                  & ( topolo1002775350975398744n_open @ A @ B6 )
                  & ( ord_less_eq @ ( set @ A ) @ S7 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) )
                  & ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) @ S7 )
                    = ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ A6 @ S7 )
                   != ( bot_bot @ ( set @ A ) ) )
                  & ( ( inf_inf @ ( set @ A ) @ B6 @ S7 )
                   != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% connected_def
thf(fact_7662_connectedI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [U3: set @ A] :
          ( ! [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
             => ! [B9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ B9 )
                 => ( ( ( inf_inf @ ( set @ A ) @ A8 @ U3 )
                     != ( bot_bot @ ( set @ A ) ) )
                   => ( ( ( inf_inf @ ( set @ A ) @ B9 @ U3 )
                       != ( bot_bot @ ( set @ A ) ) )
                     => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A8 @ B9 ) @ U3 )
                          = ( bot_bot @ ( set @ A ) ) )
                       => ~ ( ord_less_eq @ ( set @ A ) @ U3 @ ( sup_sup @ ( set @ A ) @ A8 @ B9 ) ) ) ) ) ) )
         => ( topolo1966860045006549960nected @ A @ U3 ) ) ) ).

% connectedI
thf(fact_7663_connectedD,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A3: set @ A,U3: set @ A,V2: set @ A] :
          ( ( topolo1966860045006549960nected @ A @ A3 )
         => ( ( topolo1002775350975398744n_open @ A @ U3 )
           => ( ( topolo1002775350975398744n_open @ A @ V2 )
             => ( ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ U3 @ V2 ) @ A3 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ U3 @ V2 ) )
                 => ( ( ( inf_inf @ ( set @ A ) @ U3 @ A3 )
                      = ( bot_bot @ ( set @ A ) ) )
                    | ( ( inf_inf @ ( set @ A ) @ V2 @ A3 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% connectedD
thf(fact_7664_minus__coset__filter,axiom,
    ! [A: $tType,A3: set @ A,Xs2: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( coset @ A @ Xs2 ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X3: A] : ( member @ A @ X3 @ A3 )
          @ Xs2 ) ) ) ).

% minus_coset_filter
thf(fact_7665_flat__lub__def,axiom,
    ! [A: $tType] :
      ( ( partial_flat_lub @ A )
      = ( ^ [B3: A,A6: set @ A] :
            ( if @ A @ ( ord_less_eq @ ( set @ A ) @ A6 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3
            @ ( the @ A
              @ ^ [X3: A] : ( member @ A @ X3 @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% flat_lub_def
thf(fact_7666_subset__code_I2_J,axiom,
    ! [B: $tType,A3: set @ B,Ys: list @ B] :
      ( ( ord_less_eq @ ( set @ B ) @ A3 @ ( coset @ B @ Ys ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ ( set2 @ B @ Ys ) )
           => ~ ( member @ B @ X3 @ A3 ) ) ) ) ).

% subset_code(2)
thf(fact_7667_subset__code_I3_J,axiom,
    ! [C: $tType] :
      ~ ( ord_less_eq @ ( set @ C ) @ ( coset @ C @ ( nil @ C ) ) @ ( set2 @ C @ ( nil @ C ) ) ) ).

% subset_code(3)
thf(fact_7668_arg__min__inj__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F3: A > B,P: A > $o,A2: A] :
          ( ( inj_on @ A @ B @ F3 @ ( collect @ A @ P ) )
         => ( ( P @ A2 )
           => ( ! [Y3: A] :
                  ( ( P @ Y3 )
                 => ( ord_less_eq @ B @ ( F3 @ A2 ) @ ( F3 @ Y3 ) ) )
             => ( ( lattices_ord_arg_min @ A @ B @ F3 @ P )
                = A2 ) ) ) ) ) ).

% arg_min_inj_eq
thf(fact_7669_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A3 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A3 )
                  = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_7670_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Sup_fin.coboundedI
thf(fact_7671_arg__min__nat__le,axiom,
    ! [A: $tType,P: A > $o,X: A,M: A > nat] :
      ( ( P @ X )
     => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ X ) ) ) ).

% arg_min_nat_le
thf(fact_7672_arg__min__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ( ( P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) )
        & ! [Y4: A] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ Y4 ) ) ) ) ) ).

% arg_min_nat_lemma
thf(fact_7673_arg__min__equality,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order @ A )
     => ! [P: C > $o,K: C,F3: C > A] :
          ( ( P @ K )
         => ( ! [X4: C] :
                ( ( P @ X4 )
               => ( ord_less_eq @ A @ ( F3 @ K ) @ ( F3 @ X4 ) ) )
           => ( ( F3 @ ( lattices_ord_arg_min @ C @ A @ F3 @ P ) )
              = ( F3 @ K ) ) ) ) ) ).

% arg_min_equality
thf(fact_7674_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ X3 @ X ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_7675_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A3 )
                 => ( ord_less_eq @ A @ A5 @ X ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_7676_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ X )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A3 )
                 => ( ord_less_eq @ A @ A17 @ X ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_7677_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ B4 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_7678_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B4 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) )
                = ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_7679_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A3 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A3 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_7680_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A3 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A3 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_7681_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A3 )
                  = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_7682_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ A2 ) ) ) ) ).

% Inf_fin.coboundedI
thf(fact_7683_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A3 )
                 => ( ord_less_eq @ A @ X @ A17 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_7684_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A3 )
                 => ( ord_less_eq @ A @ X @ A5 ) )
             => ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_7685_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ A3 )
                   => ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_7686_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B4 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_7687_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( B4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B4 ) @ ( lattic7752659483105999362nf_fin @ A @ A3 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A3 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_7688_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A3 ) @ ( lattic5882676163264333800up_fin @ A @ A3 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_7689_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A3: set @ A,A2: B] :
      ( ( inj_on @ A @ B @ F3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) @ A3 )
        @ ( insert @ A
          @ ( the @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( ( F3 @ X3 )
                  = A2 ) ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_on_vimage_singleton
thf(fact_7690_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F3: A > B,A2: B] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) )
        @ ( insert @ A
          @ ( the @ A
            @ ^ [X3: A] :
                ( ( F3 @ X3 )
                = A2 ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_vimage_singleton
thf(fact_7691_vimage__Diff,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ B,B4: set @ B] :
      ( ( vimage @ A @ B @ F3 @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ A3 ) @ ( vimage @ A @ B @ F3 @ B4 ) ) ) ).

% vimage_Diff
thf(fact_7692_vimage__Suc__insert__Suc,axiom,
    ! [N: nat,A3: set @ nat] :
      ( ( vimage @ nat @ nat @ suc @ ( insert @ nat @ ( suc @ N ) @ A3 ) )
      = ( insert @ nat @ N @ ( vimage @ nat @ nat @ suc @ A3 ) ) ) ).

% vimage_Suc_insert_Suc
thf(fact_7693_finite__vimage__Suc__iff,axiom,
    ! [F6: set @ nat] :
      ( ( finite_finite @ nat @ ( vimage @ nat @ nat @ suc @ F6 ) )
      = ( finite_finite @ nat @ F6 ) ) ).

% finite_vimage_Suc_iff
thf(fact_7694_vimage__Suc__insert__0,axiom,
    ! [A3: set @ nat] :
      ( ( vimage @ nat @ nat @ suc @ ( insert @ nat @ ( zero_zero @ nat ) @ A3 ) )
      = ( vimage @ nat @ nat @ suc @ A3 ) ) ).

% vimage_Suc_insert_0
thf(fact_7695_continuous__imp__open__vimage,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [S: set @ A,F3: A > B,B4: set @ B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F3 )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( topolo1002775350975398744n_open @ B @ B4 )
             => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ B4 ) @ S )
               => ( topolo1002775350975398744n_open @ A @ ( vimage @ A @ B @ F3 @ B4 ) ) ) ) ) ) ) ).

% continuous_imp_open_vimage
thf(fact_7696_vimage__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,F3: B > A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F3 @ A3 ) @ ( vimage @ B @ A @ F3 @ B4 ) ) ) ).

% vimage_mono
thf(fact_7697_subset__vimage__iff,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F3: A > B,B4: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( vimage @ A @ B @ F3 @ B4 ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( member @ B @ ( F3 @ X3 ) @ B4 ) ) ) ) ).

% subset_vimage_iff
thf(fact_7698_vimage__subsetD,axiom,
    ! [A: $tType,B: $tType,F3: B > A,B4: set @ A,A3: set @ B] :
      ( ( ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F3 @ B4 ) @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ).

% vimage_subsetD
thf(fact_7699_image__vimage__subset,axiom,
    ! [B: $tType,A: $tType,F3: B > A,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F3 @ ( vimage @ B @ A @ F3 @ A3 ) ) @ A3 ) ).

% image_vimage_subset
thf(fact_7700_image__subset__iff__subset__vimage,axiom,
    ! [B: $tType,A: $tType,F3: B > A,A3: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F3 @ A3 ) @ B4 )
      = ( ord_less_eq @ ( set @ B ) @ A3 @ ( vimage @ B @ A @ F3 @ B4 ) ) ) ).

% image_subset_iff_subset_vimage
thf(fact_7701_finite__vimageD_H,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ B] :
      ( ( finite_finite @ A @ ( vimage @ A @ B @ F3 @ A3 ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ ( image @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) ) )
       => ( finite_finite @ B @ A3 ) ) ) ).

% finite_vimageD'
thf(fact_7702_vimage__subsetI,axiom,
    ! [B: $tType,A: $tType,F3: A > B,B4: set @ B,A3: set @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ A @ B @ F3 @ A3 ) )
       => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ B4 ) @ A3 ) ) ) ).

% vimage_subsetI
thf(fact_7703_countable__vimage,axiom,
    ! [B: $tType,A: $tType,B4: set @ A,F3: B > A] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) )
     => ( ( countable_countable @ B @ ( vimage @ B @ A @ F3 @ B4 ) )
       => ( countable_countable @ A @ B4 ) ) ) ).

% countable_vimage
thf(fact_7704_vimage__subset__eq,axiom,
    ! [B: $tType,A: $tType,F3: A > B,B4: set @ B,A3: set @ A] :
      ( ( bij_betw @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ B4 ) @ A3 )
        = ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ).

% vimage_subset_eq
thf(fact_7705_card__vimage__inj,axiom,
    ! [A: $tType,B: $tType,F3: A > B,A3: set @ B] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ ( image @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) ) )
       => ( ( finite_card @ A @ ( vimage @ A @ B @ F3 @ A3 ) )
          = ( finite_card @ B @ A3 ) ) ) ) ).

% card_vimage_inj
thf(fact_7706_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F3: A > B,D3: set @ A,A3: set @ B] :
      ( ( inj_on @ A @ B @ F3 @ D3 )
     => ( ( finite_finite @ B @ A3 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ A3 ) @ D3 ) ) @ ( finite_card @ B @ A3 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_7707_set__decode__div__2,axiom,
    ! [X: nat] :
      ( ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( vimage @ nat @ nat @ suc @ ( nat_set_decode @ X ) ) ) ).

% set_decode_div_2
thf(fact_7708_set__encode__vimage__Suc,axiom,
    ! [A3: set @ nat] :
      ( ( nat_set_encode @ ( vimage @ nat @ nat @ suc @ A3 ) )
      = ( divide_divide @ nat @ ( nat_set_encode @ A3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% set_encode_vimage_Suc
thf(fact_7709_subset__range__from__nat__into,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( countable_countable @ A @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ nat @ A @ ( counta4804993851260445106t_into @ A @ A3 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% subset_range_from_nat_into
thf(fact_7710_Bseq__monoseq__convergent_H__dec,axiom,
    ! [F3: nat > real,M7: nat] :
      ( ( bfun @ nat @ real
        @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ M7 ) )
        @ ( at_top @ nat ) )
     => ( ! [M2: nat,N3: nat] :
            ( ( ord_less_eq @ nat @ M7 @ M2 )
           => ( ( ord_less_eq @ nat @ M2 @ N3 )
             => ( ord_less_eq @ real @ ( F3 @ N3 ) @ ( F3 @ M2 ) ) ) )
       => ( topolo6863149650580417670ergent @ real @ F3 ) ) ) ).

% Bseq_monoseq_convergent'_dec
thf(fact_7711_lim__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: nat > A,X: A] :
          ( ( topolo6863149650580417670ergent @ A @ F3 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ N3 ) @ X )
           => ( ord_less_eq @ A @ ( topolo3827282254853284352ce_Lim @ nat @ A @ ( at_top @ nat ) @ F3 ) @ X ) ) ) ) ).

% lim_le
thf(fact_7712_convergent__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A] :
          ( ( topolo6863149650580417670ergent @ A
            @ ^ [N2: nat] : ( F3 @ ( suc @ N2 ) ) )
          = ( topolo6863149650580417670ergent @ A @ F3 ) ) ) ).

% convergent_Suc_iff
thf(fact_7713_convergent__add,axiom,
    ! [A: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [X9: nat > A,Y8: nat > A] :
          ( ( topolo6863149650580417670ergent @ A @ X9 )
         => ( ( topolo6863149650580417670ergent @ A @ Y8 )
           => ( topolo6863149650580417670ergent @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ) ).

% convergent_add
thf(fact_7714_convergent__add__const__iff,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add @ A )
     => ! [C2: A,F3: nat > A] :
          ( ( topolo6863149650580417670ergent @ A
            @ ^ [N2: nat] : ( plus_plus @ A @ C2 @ ( F3 @ N2 ) ) )
          = ( topolo6863149650580417670ergent @ A @ F3 ) ) ) ).

% convergent_add_const_iff
thf(fact_7715_convergent__add__const__right__iff,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( topolo6863149650580417670ergent @ A
            @ ^ [N2: nat] : ( plus_plus @ A @ ( F3 @ N2 ) @ C2 ) )
          = ( topolo6863149650580417670ergent @ A @ F3 ) ) ) ).

% convergent_add_const_right_iff
thf(fact_7716_convergent__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: nat > A,M: nat] :
          ( ( topolo6863149650580417670ergent @ A
            @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ M ) ) )
          = ( topolo6863149650580417670ergent @ A @ F3 ) ) ) ).

% convergent_ignore_initial_segment
thf(fact_7717_convergent__mult,axiom,
    ! [A: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [X9: nat > A,Y8: nat > A] :
          ( ( topolo6863149650580417670ergent @ A @ X9 )
         => ( ( topolo6863149650580417670ergent @ A @ Y8 )
           => ( topolo6863149650580417670ergent @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ) ).

% convergent_mult
thf(fact_7718_convergent__mult__const__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F3: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( topolo6863149650580417670ergent @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F3 @ N2 ) ) )
            = ( topolo6863149650580417670ergent @ A @ F3 ) ) ) ) ).

% convergent_mult_const_iff
thf(fact_7719_convergent__mult__const__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F3: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( topolo6863149650580417670ergent @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F3 @ N2 ) @ C2 ) )
            = ( topolo6863149650580417670ergent @ A @ F3 ) ) ) ) ).

% convergent_mult_const_right_iff
thf(fact_7720_convergent__diff__const__right__iff,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add @ A )
     => ! [F3: nat > A,C2: A] :
          ( ( topolo6863149650580417670ergent @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F3 @ N2 ) @ C2 ) )
          = ( topolo6863149650580417670ergent @ A @ F3 ) ) ) ).

% convergent_diff_const_right_iff
thf(fact_7721_convergent__diff,axiom,
    ! [A: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [X9: nat > A,Y8: nat > A] :
          ( ( topolo6863149650580417670ergent @ A @ X9 )
         => ( ( topolo6863149650580417670ergent @ A @ Y8 )
           => ( topolo6863149650580417670ergent @ A
              @ ^ [N2: nat] : ( minus_minus @ A @ ( X9 @ N2 ) @ ( Y8 @ N2 ) ) ) ) ) ) ).

% convergent_diff
thf(fact_7722_Bseq__mono__convergent,axiom,
    ! [X9: nat > real] :
      ( ( bfun @ nat @ real @ X9 @ ( at_top @ nat ) )
     => ( ! [M2: nat,N3: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N3 )
           => ( ord_less_eq @ real @ ( X9 @ M2 ) @ ( X9 @ N3 ) ) )
       => ( topolo6863149650580417670ergent @ real @ X9 ) ) ) ).

% Bseq_mono_convergent
thf(fact_7723_convergent__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topolo6863149650580417670ergent @ real @ ( power_power @ real @ X ) ) ) ) ).

% convergent_realpow
thf(fact_7724_range__from__nat__into__subset,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ ( counta4804993851260445106t_into @ A @ A3 ) @ ( top_top @ ( set @ nat ) ) ) @ A3 ) ) ).

% range_from_nat_into_subset
thf(fact_7725_Bseq__monoseq__convergent_H__inc,axiom,
    ! [F3: nat > real,M7: nat] :
      ( ( bfun @ nat @ real
        @ ^ [N2: nat] : ( F3 @ ( plus_plus @ nat @ N2 @ M7 ) )
        @ ( at_top @ nat ) )
     => ( ! [M2: nat,N3: nat] :
            ( ( ord_less_eq @ nat @ M7 @ M2 )
           => ( ( ord_less_eq @ nat @ M2 @ N3 )
             => ( ord_less_eq @ real @ ( F3 @ M2 ) @ ( F3 @ N3 ) ) ) )
       => ( topolo6863149650580417670ergent @ real @ F3 ) ) ) ).

% Bseq_monoseq_convergent'_inc
thf(fact_7726_pair__lessI2,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ B2 )
     => ( ( ord_less @ nat @ S @ T2 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_less ) ) ) ).

% pair_lessI2
thf(fact_7727_sorted__insort__insert__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F3: B > A,Xs2: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F3 @ ( linord329482645794927042rt_key @ B @ A @ F3 @ X @ Xs2 ) ) ) ) ) ).

% sorted_insort_insert_key
thf(fact_7728_sorted__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,X: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X3: A] : X3
              @ X
              @ Xs2 ) ) ) ) ).

% sorted_insort_insert
thf(fact_7729_pair__leqI2,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ S @ T2 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_leq ) ) ) ).

% pair_leqI2
thf(fact_7730_cauchy__filter__metric__filtermap,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V768167426530841204y_dist @ B )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [F3: A > B,F6: filter @ A] :
          ( ( topolo6773858410816713723filter @ B @ ( filtermap @ A @ B @ F3 @ F6 ) )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ? [P6: A > $o] :
                    ( ( eventually @ A @ P6 @ F6 )
                    & ! [X3: A,Y6: A] :
                        ( ( ( P6 @ X3 )
                          & ( P6 @ Y6 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X3 ) @ ( F3 @ Y6 ) ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric_filtermap
thf(fact_7731_filtermap__mono,axiom,
    ! [B: $tType,A: $tType,F6: filter @ A,F13: filter @ A,F3: A > B] :
      ( ( ord_less_eq @ ( filter @ A ) @ F6 @ F13 )
     => ( ord_less_eq @ ( filter @ B ) @ ( filtermap @ A @ B @ F3 @ F6 ) @ ( filtermap @ A @ B @ F3 @ F13 ) ) ) ).

% filtermap_mono
thf(fact_7732_filtermap__le__iff__le__filtercomap,axiom,
    ! [B: $tType,A: $tType,F3: B > A,F6: filter @ B,G6: filter @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F3 @ F6 ) @ G6 )
      = ( ord_less_eq @ ( filter @ B ) @ F6 @ ( filtercomap @ B @ A @ F3 @ G6 ) ) ) ).

% filtermap_le_iff_le_filtercomap
thf(fact_7733_filtermap__filtercomap,axiom,
    ! [B: $tType,A: $tType,F3: B > A,F6: filter @ A] : ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F3 @ ( filtercomap @ B @ A @ F3 @ F6 ) ) @ F6 ) ).

% filtermap_filtercomap
thf(fact_7734_filtercomap__filtermap,axiom,
    ! [B: $tType,A: $tType,F6: filter @ A,F3: A > B] : ( ord_less_eq @ ( filter @ A ) @ F6 @ ( filtercomap @ A @ B @ F3 @ ( filtermap @ A @ B @ F3 @ F6 ) ) ) ).

% filtercomap_filtermap
thf(fact_7735_filterlim__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filterlim @ A @ B )
      = ( ^ [F5: A > B,F25: filter @ B,F18: filter @ A] : ( ord_less_eq @ ( filter @ B ) @ ( filtermap @ A @ B @ F5 @ F18 ) @ F25 ) ) ) ).

% filterlim_def
thf(fact_7736_filtermap__inf,axiom,
    ! [A: $tType,B: $tType,F3: B > A,F14: filter @ B,F23: filter @ B] : ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F3 @ ( inf_inf @ ( filter @ B ) @ F14 @ F23 ) ) @ ( inf_inf @ ( filter @ A ) @ ( filtermap @ B @ A @ F3 @ F14 ) @ ( filtermap @ B @ A @ F3 @ F23 ) ) ) ).

% filtermap_inf
thf(fact_7737_filtermap__nhds__times,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
            = ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ A2 ) ) ) ) ) ).

% filtermap_nhds_times
thf(fact_7738_filtermap__exp__at__top,axiom,
    ( ( filtermap @ real @ real @ ( exp @ real ) @ ( at_top @ real ) )
    = ( at_top @ real ) ) ).

% filtermap_exp_at_top
thf(fact_7739_filtermap__ln__at__top,axiom,
    ( ( filtermap @ real @ real @ ( ln_ln @ real ) @ ( at_top @ real ) )
    = ( at_top @ real ) ) ).

% filtermap_ln_at_top
thf(fact_7740_filtermap__nhds__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [D2: A,A2: A] :
          ( ( filtermap @ A @ A
            @ ^ [X3: A] : ( minus_minus @ A @ X3 @ D2 )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( topolo7230453075368039082e_nhds @ A @ ( minus_minus @ A @ A2 @ D2 ) ) ) ) ).

% filtermap_nhds_shift
thf(fact_7741_filtermap__mono__strong,axiom,
    ! [B: $tType,A: $tType,F3: A > B,F6: filter @ A,G6: filter @ A] :
      ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( filter @ B ) @ ( filtermap @ A @ B @ F3 @ F6 ) @ ( filtermap @ A @ B @ F3 @ G6 ) )
        = ( ord_less_eq @ ( filter @ A ) @ F6 @ G6 ) ) ) ).

% filtermap_mono_strong
thf(fact_7742_filtermap__at__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [D2: A,A2: A] :
          ( ( filtermap @ A @ A
            @ ^ [X3: A] : ( minus_minus @ A @ X3 @ D2 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filtermap_at_shift
thf(fact_7743_filtermap__at__right__shift,axiom,
    ! [D2: real,A2: real] :
      ( ( filtermap @ real @ real
        @ ^ [X3: real] : ( minus_minus @ real @ X3 @ D2 )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( topolo174197925503356063within @ real @ ( minus_minus @ real @ A2 @ D2 ) @ ( set_ord_greaterThan @ real @ ( minus_minus @ real @ A2 @ D2 ) ) ) ) ).

% filtermap_at_right_shift
thf(fact_7744_filtermap__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: B > A,F6: C > ( filter @ B ),B4: set @ C] :
      ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ B @ A @ F3 @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ C @ ( filter @ B ) @ F6 @ B4 ) ) )
      @ ( complete_Inf_Inf @ ( filter @ A )
        @ ( image @ C @ ( filter @ A )
          @ ^ [B3: C] : ( filtermap @ B @ A @ F3 @ ( F6 @ B3 ) )
          @ B4 ) ) ) ).

% filtermap_INF
thf(fact_7745_at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A] :
          ( ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          = ( filtermap @ A @ A
            @ ^ [X3: A] : ( plus_plus @ A @ X3 @ A2 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% at_to_0
thf(fact_7746_at__right__to__0,axiom,
    ! [A2: real] :
      ( ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) )
      = ( filtermap @ real @ real
        @ ^ [X3: real] : ( plus_plus @ real @ X3 @ A2 )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% at_right_to_0
thf(fact_7747_filterlim__INF__INF,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,J4: set @ A,I5: set @ B,F3: D > C,F6: B > ( filter @ D ),G6: A > ( filter @ C )] :
      ( ! [M2: A] :
          ( ( member @ A @ M2 @ J4 )
         => ? [X5: B] :
              ( ( member @ B @ X5 @ I5 )
              & ( ord_less_eq @ ( filter @ C ) @ ( filtermap @ D @ C @ F3 @ ( F6 @ X5 ) ) @ ( G6 @ M2 ) ) ) )
     => ( filterlim @ D @ C @ F3 @ ( complete_Inf_Inf @ ( filter @ C ) @ ( image @ A @ ( filter @ C ) @ G6 @ J4 ) ) @ ( complete_Inf_Inf @ ( filter @ D ) @ ( image @ B @ ( filter @ D ) @ F6 @ I5 ) ) ) ) ).

% filterlim_INF_INF
thf(fact_7748_filtermap__times__pos__at__right,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [C2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo174197925503356063within @ A @ P4 @ ( set_ord_greaterThan @ A @ P4 ) ) )
            = ( topolo174197925503356063within @ A @ ( times_times @ A @ C2 @ P4 ) @ ( set_ord_greaterThan @ A @ ( times_times @ A @ C2 @ P4 ) ) ) ) ) ) ).

% filtermap_times_pos_at_right
thf(fact_7749_at__to__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) )
        = ( filtermap @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) ) ) ) ).

% at_to_infinity
thf(fact_7750_at__top__to__right,axiom,
    ( ( at_top @ real )
    = ( filtermap @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% at_top_to_right
thf(fact_7751_at__right__to__top,axiom,
    ( ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) )
    = ( filtermap @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) ) ) ).

% at_right_to_top
thf(fact_7752_filtermap__ln__at__right,axiom,
    ( ( filtermap @ real @ real @ ( ln_ln @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
    = ( at_bot @ real ) ) ).

% filtermap_ln_at_right
thf(fact_7753_and__not__num__eq__None__iff,axiom,
    ! [M: num,N: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_7754_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ( ordering_top @ A
        @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 )
        @ ^ [X3: A,Y6: A] : ( ord_less @ A @ Y6 @ X3 )
        @ ( bot_bot @ A ) ) ) ).

% bot.ordering_top_axioms
thf(fact_7755_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_7756_gcd__nat_Oordering__top__axioms,axiom,
    ( ordering_top @ nat @ ( dvd_dvd @ nat )
    @ ^ [M3: nat,N2: nat] :
        ( ( dvd_dvd @ nat @ M3 @ N2 )
        & ( M3 != N2 ) )
    @ ( zero_zero @ nat ) ) ).

% gcd_nat.ordering_top_axioms
thf(fact_7757_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_7758_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_7759_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_7760_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ( ordering_top @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ A ) ) ) ).

% top.ordering_top_axioms
thf(fact_7761_bot__nat__0_Oordering__top__axioms,axiom,
    ( ordering_top @ nat
    @ ^ [X3: nat,Y6: nat] : ( ord_less_eq @ nat @ Y6 @ X3 )
    @ ^ [X3: nat,Y6: nat] : ( ord_less @ nat @ Y6 @ X3 )
    @ ( zero_zero @ nat ) ) ).

% bot_nat_0.ordering_top_axioms
thf(fact_7762_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_7763_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M3: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M3 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M3 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_7764_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_7765_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_7766_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_7767_option_Osize_I4_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X2 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_7768_option_Osize__neq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( size_size @ ( option @ A ) @ X )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_7769_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X2: A] :
      ( ( size_option @ A @ X @ ( some @ A @ X2 ) )
      = ( plus_plus @ nat @ ( X @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_7770_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ? [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
                & ( P @ X5 ) )
           => ( ( find @ A @ P @ Xs2 )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X3: A] :
                        ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
                        & ( P @ X3 ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_7771_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_option @ A @ X @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_7772_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Mi: nat,Ma2: nat] :
            ( ? [Va: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) )
           => ~ ( ( Xa = Mi )
                | ( Xa = Ma2 ) ) )
       => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list @ vEBT_VEBT] :
              ( ? [Vc: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) )
             => ~ ( ( Xa = Mi )
                  | ( Xa = Ma2 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) )
         => ~ ! [V4: nat,TreeList: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_7773_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs2 ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs2 ) @ J )
        = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_7774_VEBT_Oinject_I1_J,axiom,
    ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X112 @ X122 @ X132 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X112 = Y11 )
        & ( X122 = Y12 )
        & ( X132 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_7775_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi2: nat,Ma: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ X )
      = ( ( X = Mi2 )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_7776_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs2 ) ) ) ) ).

% sorted_dropWhile
thf(fact_7777_VEBT_Osize_I3_J,axiom,
    ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X112 @ X122 @ X132 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X132 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_7778_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_dropWhile_le
thf(fact_7779_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_7780_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList2 @ Vd2 ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_7781_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi2: nat,Ma: nat,V: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ ( suc @ V ) @ TreeList2 @ Vc2 ) @ X )
      = ( ( X = Mi2 )
        | ( X = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_7782_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Mi: nat,Ma2: nat,Va: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) @ Xa ) )
               => ~ ( ( Xa = Mi )
                    | ( Xa = Ma2 ) ) ) )
         => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) @ Xa ) )
                 => ~ ( ( Xa = Mi )
                      | ( Xa = Ma2 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) )
           => ~ ! [V4: nat,TreeList: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) @ Xa ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_7783_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y )
     => ( ( ? [Uu3: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu3 @ Uv ) )
         => Y )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) )
               => ( Y
                  = ( ~ ( ( Xa = Mi )
                        | ( Xa = Ma2 ) ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list @ vEBT_VEBT] :
                  ( ? [Vc: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) )
                 => ( Y
                    = ( ~ ( ( Xa = Mi )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) )
             => ~ ! [V4: nat,TreeList: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) )
                   => ( Y
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_7784_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% VEBT.inject(2)
thf(fact_7785_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu3: $o,Uv: $o,D6: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv ) @ D6 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) @ Deg2 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_7786_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A5: $o,B5: $o,X4: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ X4 ) )
     => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList: list @ vEBT_VEBT,S3: vEBT_VEBT,X4: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) @ X4 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_7787_VEBT_Odistinct_I1_J,axiom,
    ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X112 @ X122 @ X132 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_7788_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu4: $o,Uv2: $o,Uw2: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu4 @ Uv2 ) @ Uw2 ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_7789_VEBT_Oexhaust,axiom,
    ! [Y: vEBT_VEBT] :
      ( ! [X113: option @ ( product_prod @ nat @ nat ),X123: nat,X133: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y
         != ( vEBT_Node @ X113 @ X123 @ X133 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_7790_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_7791_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu3: $o,Uv: $o,Uw: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv ) @ Uw ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi: nat,Ma2: nat,Va: list @ vEBT_VEBT,Vb: vEBT_VEBT,X4: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) @ X4 ) )
         => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT,X4: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) @ X4 ) )
           => ~ ! [V4: nat,TreeList: list @ vEBT_VEBT,Vd: vEBT_VEBT,X4: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) @ X4 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_7792_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu3: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu3 @ Uv ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv ) @ Xa ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) )
           => ( ! [Mi: nat,Ma2: nat,Va: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) @ Xa ) )
                   => ( ( Xa = Mi )
                      | ( Xa = Ma2 ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) @ Xa ) )
                     => ( ( Xa = Mi )
                        | ( Xa = Ma2 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) )
               => ~ ! [V4: nat,TreeList: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) @ Xa ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_7793_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu3: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu3 @ Uv ) )
             => ( ~ Y
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv ) @ Xa ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,Va: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) )
                 => ( ( Y
                      = ( ( Xa = Mi )
                        | ( Xa = Ma2 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) @ Xa ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) )
                   => ( ( Y
                        = ( ( Xa = Mi )
                          | ( Xa = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) @ Xa ) ) ) )
               => ~ ! [V4: nat,TreeList: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) )
                     => ( ( Y
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_7794_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Uu3: $o,Uv: $o] :
            ( X
           != ( vEBT_Leaf @ Uu3 @ Uv ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) )
               => ( ( Xa = Mi )
                  | ( Xa = Ma2 ) ) )
           => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list @ vEBT_VEBT] :
                  ( ? [Vc: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ ( suc @ V4 ) @ TreeList @ Vc ) )
                 => ( ( Xa = Mi )
                    | ( Xa = Ma2 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) )
             => ~ ! [V4: nat,TreeList: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_7795_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y )
     => ( ! [A5: $o,B5: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ( Y
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu3: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv @ Uw ) )
           => Y )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) )
               => ( Y
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_7796_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A5: $o,B5: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A5 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B5 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_7797_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu4: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu4 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_7798_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_7799_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V ) @ TreeList2 @ S ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_7800_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A5: $o,B5: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A5 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B5 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv @ Uw ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_7801_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A5 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B5 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv @ Uw ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Xa ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) @ Xa ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_7802_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) @ Xa ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_7803_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( Y
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa ) ) ) )
         => ( ! [Uu3: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv @ Uw ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu3 @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Xa ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) )
                 => ( ( Y
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V4 ) @ TreeList @ S3 ) @ Xa ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_7804_VEBT_Osize__gen_I1_J,axiom,
    ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X112 @ X122 @ X132 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X132 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_7805_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( ( vEBT_invar_vebt @ A1 @ A22 )
     => ( ( ? [A5: $o,B5: $o] :
              ( A1
              = ( vEBT_Leaf @ A5 @ B5 ) )
         => ( A22
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList: list @ vEBT_VEBT,N3: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) )
             => ( ( A22 = Deg )
               => ( ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ( vEBT_invar_vebt @ X5 @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary @ M2 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                     => ( ( M2 = N3 )
                       => ( ( Deg
                            = ( plus_plus @ nat @ N3 @ M2 ) )
                         => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
                           => ~ ! [X5: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                 => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList: list @ vEBT_VEBT,N3: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat] :
                ( ( A1
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) )
               => ( ( A22 = Deg )
                 => ( ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ( vEBT_invar_vebt @ X5 @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary @ M2 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                       => ( ( M2
                            = ( suc @ N3 ) )
                         => ( ( Deg
                              = ( plus_plus @ nat @ N3 @ M2 ) )
                           => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
                             => ~ ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                   => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList: list @ vEBT_VEBT,N3: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat,Mi: nat,Ma2: nat] :
                  ( ( A1
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ Deg @ TreeList @ Summary ) )
                 => ( ( A22 = Deg )
                   => ( ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                         => ( vEBT_invar_vebt @ X5 @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary @ M2 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                         => ( ( M2 = N3 )
                           => ( ( Deg
                                = ( plus_plus @ nat @ N3 @ M2 ) )
                             => ( ! [I4: nat] :
                                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X8 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
                               => ( ( ( Mi = Ma2 )
                                   => ! [X5: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                                   => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                                     => ~ ( ( Mi != Ma2 )
                                         => ! [I4: nat] :
                                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                    = I4 )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                & ! [X5: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X5 @ N3 )
                                                        = I4 )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X5 @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi @ X5 )
                                                      & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList: list @ vEBT_VEBT,N3: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat,Mi: nat,Ma2: nat] :
                    ( ( A1
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma2 ) ) @ Deg @ TreeList @ Summary ) )
                   => ( ( A22 = Deg )
                     => ( ! [X5: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                           => ( vEBT_invar_vebt @ X5 @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary @ M2 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                           => ( ( M2
                                = ( suc @ N3 ) )
                             => ( ( Deg
                                  = ( plus_plus @ nat @ N3 @ M2 ) )
                               => ( ! [I4: nat] :
                                      ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                                     => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X8 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
                                 => ( ( ( Mi = Ma2 )
                                     => ! [X5: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                         => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi @ Ma2 )
                                     => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                                       => ~ ( ( Mi != Ma2 )
                                           => ! [I4: nat] :
                                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                      = I4 )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                  & ! [X5: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X5 @ N3 )
                                                          = I4 )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X5 @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi @ X5 )
                                                        & ( ord_less_eq @ nat @ X5 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_7806_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X3: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X3 )
          | ( vEBT_VEBT_membermima @ T3 @ X3 ) ) ) ) ).

% both_member_options_def
thf(fact_7807_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_7808_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X4 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary2 @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg3
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_12 )
               => ( ! [X4: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg3 @ TreeList2 @ Summary2 ) @ Deg3 ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_7809_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X4 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary2 @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg3
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_12 )
               => ( ! [X4: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg3 @ TreeList2 @ Summary2 ) @ Deg3 ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_7810_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_7811_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat,Mi2: nat,Ma: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X4 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary2 @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg3
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X4: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg3 ) )
                     => ( ( ( Mi2 != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X4: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X4 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ X4 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi2 @ X4 )
                                      & ( ord_less_eq @ nat @ X4 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg3 @ TreeList2 @ Summary2 ) @ Deg3 ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_7812_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat,Mi2: nat,Ma: nat] :
      ( ! [X4: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X4 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary2 @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg3
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I2 ) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X4: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg3 ) )
                     => ( ( ( Mi2 != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X4: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X4 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ X4 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi2 @ X4 )
                                      & ( ord_less_eq @ nat @ X4 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma ) ) @ Deg3 @ TreeList2 @ Summary2 ) @ Deg3 ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_7813_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A12: vEBT_VEBT,A23: nat] :
          ( ( ? [A4: $o,B3: $o] :
                ( A12
                = ( vEBT_Leaf @ A4 @ B3 ) )
            & ( A23
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X3 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X3 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X3 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ! [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I3 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X3: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                              = I3 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X3 )
                            & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X3: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X3 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ! [I3: nat] :
                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I3 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X3: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                              = I3 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X3 )
                            & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_7814_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N2: nat,TreeList3: list @ vEBT_VEBT,X3: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ X3 @ N2 ) ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) ) ) ).

% in_children_def
thf(fact_7815_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T3 ) ) ) ) ).

% set_vebt_def
thf(fact_7816_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_7817_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu3: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu3 @ Uv ) )
         => ( Xa
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) )
             => ( ( Deg = Xa )
                & ! [X4: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
                    & ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi3: nat,Ma3: nat] :
                        ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                        & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                        & ! [I3: nat] :
                            ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                        & ( ( Mi3 = Ma3 )
                         => ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                        & ( ( Mi3 != Ma3 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                            & ! [X3: nat] :
                                ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X3 )
                                 => ( ( ord_less @ nat @ Mi3 @ X3 )
                                    & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_7818_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu4: $o,Uv2: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu4 @ Uv2 ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_7819_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A6: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X3: A] :
                    ( ( member @ A @ X3 @ A6 )
                   => ( ord_less_eq @ A @ B3 @ X3 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_7820_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A6: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X3: A] :
                    ( ( member @ A @ X3 @ A6 )
                   => ( ord_less_eq @ A @ X3 @ B3 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_7821_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A6: set @ A,P6: A > $o] : ( ord_less_eq @ ( set @ A ) @ A6 @ ( collect @ A @ P6 ) ) ) ) ).

% Ball_Collect
thf(fact_7822_Ball__def__raw,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A6: set @ A,P6: A > $o] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ( P6 @ X3 ) ) ) ) ).

% Ball_def_raw
thf(fact_7823_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg3: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg3 @ TreeList2 @ Summary2 ) @ Deg4 )
      = ( ( Deg3 = Deg4 )
        & ! [X3: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
           => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg3 @ ( divide_divide @ nat @ Deg3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg3 @ ( divide_divide @ nat @ Deg3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
            & ! [X3: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi3: nat,Ma3: nat] :
                ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg3 ) )
                & ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg3 @ ( divide_divide @ nat @ Deg3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I3 ) ) )
                & ( ( Mi3 = Ma3 )
                 => ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                & ( ( Mi3 != Ma3 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                    & ! [X3: nat] :
                        ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg3 ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X3 )
                         => ( ( ord_less @ nat @ Mi3 @ X3 )
                            & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_7824_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y )
     => ( ( ? [Uu3: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu3 @ Uv ) )
         => ( Y
            = ( ( Xa
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) )
             => ( Y
                = ( ~ ( ( Deg = Xa )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                         => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
                          & ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                                  & ! [X3: nat] :
                                      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X3 )
                                       => ( ( ord_less @ nat @ Mi3 @ X3 )
                                          & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_7825_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu3: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu3 @ Uv ) )
         => ( Xa
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) )
             => ~ ( ( Deg = Xa )
                  & ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                         => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi3: nat,Ma3: nat] :
                          ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                          & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                          & ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                          & ( ( Mi3 = Ma3 )
                           => ! [X3: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                          & ( ( Mi3 != Ma3 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                              & ! [X3: nat] :
                                  ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X3 )
                                   => ( ( ord_less @ nat @ Mi3 @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_7826_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu3: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu3 @ Uv ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv ) @ Xa ) )
               => ( Xa
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) @ Xa ) )
                 => ( ( Deg = Xa )
                    & ! [X4: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
                        & ! [X3: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                           => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi3: nat,Ma3: nat] :
                            ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                            & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                            & ! [I3: nat] :
                                ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                            & ( ( Mi3 = Ma3 )
                             => ! [X3: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                            & ( ( Mi3 != Ma3 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                                & ! [X3: nat] :
                                    ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X3 )
                                     => ( ( ord_less @ nat @ Mi3 @ X3 )
                                        & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_7827_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu3: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu3 @ Uv ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv ) @ Xa ) )
               => ( Xa
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) @ Xa ) )
                 => ~ ( ( Deg = Xa )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                         => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
                          & ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                                  & ! [X3: nat] :
                                      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X3 )
                                       => ( ( ord_less @ nat @ Mi3 @ X3 )
                                          & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_7828_Sup__real__def,axiom,
    ( ( complete_Sup_Sup @ real )
    = ( ^ [X8: set @ real] :
          ( ord_Least @ real
          @ ^ [Z6: real] :
            ! [X3: real] :
              ( ( member @ real @ X3 @ X8 )
             => ( ord_less_eq @ real @ X3 @ Z6 ) ) ) ) ) ).

% Sup_real_def
thf(fact_7829_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X8: set @ int] :
          ( the @ int
          @ ^ [X3: int] :
              ( ( member @ int @ X3 @ X8 )
              & ! [Y6: int] :
                  ( ( member @ int @ Y6 @ X8 )
                 => ( ord_less_eq @ int @ Y6 @ X3 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_7830_Sup__Inf,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ( complete_Sup_Sup @ A @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A ) @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu2: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu2
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X3: set @ A] :
                        ( ( member @ ( set @ A ) @ X3 @ A3 )
                       => ( member @ A @ ( F5 @ X3 ) @ X3 ) ) ) ) ) ) ) ) ).

% Sup_Inf
thf(fact_7831_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S7: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F10: filter @ A] :
                ! [X3: filter @ A] :
                  ( ( member @ ( filter @ A ) @ X3 @ S7 )
                 => ( ord_less_eq @ ( filter @ A ) @ F10 @ X3 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_7832_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu2: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu2
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X3: set @ A] :
                        ( ( member @ ( set @ A ) @ X3 @ A3 )
                       => ( member @ A @ ( F5 @ X3 ) @ X3 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_7833_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu2: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu2
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X3: set @ A] :
                        ( ( member @ ( set @ A ) @ X3 @ A3 )
                       => ( member @ A @ ( F5 @ X3 ) @ X3 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) ) ) ) ).

% Sup_Inf_le
thf(fact_7834_SUP__INF__set,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [G: B > A,A3: set @ ( set @ B )] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [X3: set @ B] : ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ X3 ) )
              @ A3 ) )
          = ( complete_Inf_Inf @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [X3: set @ B] : ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ X3 ) )
              @ ( collect @ ( set @ B )
                @ ^ [Uu2: set @ B] :
                  ? [F5: ( set @ B ) > B] :
                    ( ( Uu2
                      = ( image @ ( set @ B ) @ B @ F5 @ A3 ) )
                    & ! [X3: set @ B] :
                        ( ( member @ ( set @ B ) @ X3 @ A3 )
                       => ( member @ B @ ( F5 @ X3 ) @ X3 ) ) ) ) ) ) ) ) ).

% SUP_INF_set
thf(fact_7835_INF__SUP__set,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [G: B > A,A3: set @ ( set @ B )] :
          ( ( complete_Inf_Inf @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [B6: set @ B] : ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B6 ) )
              @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ ( set @ B ) @ A
              @ ^ [B6: set @ B] : ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B6 ) )
              @ ( collect @ ( set @ B )
                @ ^ [Uu2: set @ B] :
                  ? [F5: ( set @ B ) > B] :
                    ( ( Uu2
                      = ( image @ ( set @ B ) @ B @ F5 @ A3 ) )
                    & ! [X3: set @ B] :
                        ( ( member @ ( set @ B ) @ X3 @ A3 )
                       => ( member @ B @ ( F5 @ X3 ) @ X3 ) ) ) ) ) ) ) ) ).

% INF_SUP_set
thf(fact_7836_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu3: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu3 @ Uv ) )
             => ( ( Y
                  = ( Xa
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu3 @ Uv ) @ Xa ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) )
               => ( ( Y
                    = ( ( Deg = Xa )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                         => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
                          & ! [X3: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                              & ! [I3: nat] :
                                  ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I3 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X8 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                                  & ! [X3: nat] :
                                      ( ( ord_less @ nat @ X3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X3 )
                                       => ( ( ord_less @ nat @ Mi3 @ X3 )
                                          & ( ord_less_eq @ nat @ X3 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg @ TreeList @ Summary ) @ Xa ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_7837_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu2: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu2
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X3: set @ A] :
                        ( ( member @ ( set @ A ) @ X3 @ A3 )
                       => ( member @ A @ ( F5 @ X3 ) @ X3 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_7838_VEBT_Osimps_I7_J,axiom,
    ! [A: $tType,F1: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ ( product_prod @ vEBT_VEBT @ A ) ) > vEBT_VEBT > A > A,F2: $o > $o > A,X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_rec_VEBT @ A @ F1 @ F2 @ ( vEBT_Node @ X112 @ X122 @ X132 @ X14 ) )
      = ( F1 @ X112 @ X122
        @ ( map @ vEBT_VEBT @ ( product_prod @ vEBT_VEBT @ A )
          @ ^ [VEBT: vEBT_VEBT] : ( product_Pair @ vEBT_VEBT @ A @ VEBT @ ( vEBT_rec_VEBT @ A @ F1 @ F2 @ VEBT ) )
          @ X132 )
        @ X14
        @ ( vEBT_rec_VEBT @ A @ F1 @ F2 @ X14 ) ) ) ).

% VEBT.simps(7)
thf(fact_7839_VEBT_Osimps_I8_J,axiom,
    ! [A: $tType,F1: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ ( product_prod @ vEBT_VEBT @ A ) ) > vEBT_VEBT > A > A,F2: $o > $o > A,X21: $o,X222: $o] :
      ( ( vEBT_rec_VEBT @ A @ F1 @ F2 @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( F2 @ X21 @ X222 ) ) ).

% VEBT.simps(8)
thf(fact_7840_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F5: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X3: A,Y6: A] :
                  ( ( ord_less @ nat @ ( F5 @ X3 ) @ ( F5 @ Y6 ) )
                  | ( ( ord_less_eq @ nat @ ( F5 @ X3 ) @ ( F5 @ Y6 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y6 ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_7841_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ~ ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ B2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ) ).

% euclidean_size_times_nonunit
thf(fact_7842_euclidean__size__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid6346220572633701492n_size @ A @ ( semiring_1_of_nat @ A @ N ) )
          = N ) ) ).

% euclidean_size_of_nat
thf(fact_7843_size__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ( ( euclid6346220572633701492n_size @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ nat ) ) ) ).

% size_0
thf(fact_7844_euclidean__size__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A] :
          ( ( ( euclid6346220572633701492n_size @ A @ B2 )
            = ( zero_zero @ nat ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% euclidean_size_eq_0_iff
thf(fact_7845_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) )
        = ( one_one @ nat ) ) ) ).

% euclidean_size_1
thf(fact_7846_euclidean__size__greater__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% euclidean_size_greater_0_iff
thf(fact_7847_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A] :
          ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% euclidean_size_mult
thf(fact_7848_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ A2 )
            = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) ) ) ) ).

% euclidean_size_unit
thf(fact_7849_dvd__euclidean__size__eq__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( euclid6346220572633701492n_size @ A @ A2 )
              = ( euclid6346220572633701492n_size @ A @ B2 ) )
           => ( ( dvd_dvd @ A @ B2 @ A2 )
             => ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_euclidean_size_eq_imp_dvd
thf(fact_7850_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
          = ( ( ( euclid6346220572633701492n_size @ A @ A2 )
              = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) )
            & ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_iff_euclidean_size
thf(fact_7851_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ B2 @ A2 ) ) ) ) ) ).

% size_mult_mono'
thf(fact_7852_size__mult__mono,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% size_mult_mono
thf(fact_7853_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% euclidean_size_times_unit
thf(fact_7854_dvd__proper__imp__size__less,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ~ ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ) ) ).

% dvd_proper_imp_size_less
thf(fact_7855_dvd__imp__size__le,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ) ).

% dvd_imp_size_le
thf(fact_7856_mod__size__less,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% mod_size_less
thf(fact_7857_mlex__leq,axiom,
    ! [A: $tType,F3: A > nat,X: A,Y: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F3 @ X ) @ ( F3 @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F3 @ R2 ) ) ) ) ).

% mlex_leq
thf(fact_7858_divmod__cases,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A2: A] :
          ( ( ( B2
             != ( zero_zero @ A ) )
           => ( ( ( modulo_modulo @ A @ A2 @ B2 )
                = ( zero_zero @ A ) )
             => ( A2
               != ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) )
         => ( ( ( B2
               != ( zero_zero @ A ) )
             => ! [Q3: A,R4: A] :
                  ( ( ( euclid7384307370059645450egment @ A @ R4 )
                    = ( euclid7384307370059645450egment @ A @ B2 ) )
                 => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R4 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
                   => ( ( R4
                       != ( zero_zero @ A ) )
                     => ( ( ( divide_divide @ A @ A2 @ B2 )
                          = Q3 )
                       => ( ( ( modulo_modulo @ A @ A2 @ B2 )
                            = R4 )
                         => ( A2
                           != ( plus_plus @ A @ ( times_times @ A @ Q3 @ B2 ) @ R4 ) ) ) ) ) ) ) )
           => ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divmod_cases
thf(fact_7859_mod__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R: A,Q2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q2 @ B2 ) @ R )
                  = A2 )
               => ( ( modulo_modulo @ A @ A2 @ B2 )
                  = R ) ) ) ) ) ) ).

% mod_eqI
thf(fact_7860_abs__division__segment,axiom,
    ! [K: int] :
      ( ( abs_abs @ int @ ( euclid7384307370059645450egment @ int @ K ) )
      = ( one_one @ int ) ) ).

% abs_division_segment
thf(fact_7861_division__segment__1,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( euclid7384307370059645450egment @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% division_segment_1
thf(fact_7862_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [K: num] :
          ( ( euclid7384307370059645450egment @ A @ ( numeral_numeral @ A @ K ) )
          = ( one_one @ A ) ) ) ).

% division_segment_numeral
thf(fact_7863_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid7384307370059645450egment @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( one_one @ A ) ) ) ).

% division_segment_of_nat
thf(fact_7864_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A2 ) @ ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A2 ) ) )
          = A2 ) ) ).

% division_segment_euclidean_size
thf(fact_7865_division__segment__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( euclid7384307370059645450egment @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A2 ) @ ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ) ).

% division_segment_mult
thf(fact_7866_division__segment__not__0,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A] :
          ( ( euclid7384307370059645450egment @ A @ A2 )
         != ( zero_zero @ A ) ) ) ).

% division_segment_not_0
thf(fact_7867_division__segment__nat__def,axiom,
    ( ( euclid7384307370059645450egment @ nat )
    = ( ^ [N2: nat] : ( one_one @ nat ) ) ) ).

% division_segment_nat_def
thf(fact_7868_division__segment__eq__sgn,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( euclid7384307370059645450egment @ int @ K )
        = ( sgn_sgn @ int @ K ) ) ) ).

% division_segment_eq_sgn
thf(fact_7869_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( euclid7384307370059645450egment @ A @ A2 ) @ ( one_one @ A ) ) ) ).

% is_unit_division_segment
thf(fact_7870_division__segment__mod,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ~ ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( euclid7384307370059645450egment @ A @ ( modulo_modulo @ A @ A2 @ B2 ) )
              = ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ).

% division_segment_mod
thf(fact_7871_of__nat__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A2 ) )
          = ( divide_divide @ A @ A2 @ ( euclid7384307370059645450egment @ A @ A2 ) ) ) ) ).

% of_nat_euclidean_size
thf(fact_7872_division__segment__int__def,axiom,
    ( ( euclid7384307370059645450egment @ int )
    = ( ^ [K2: int] : ( if @ int @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ K2 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% division_segment_int_def
thf(fact_7873_unique__euclidean__semiring__class_Odiv__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( euclid7384307370059645450egment @ A @ A2 )
            = ( euclid7384307370059645450egment @ A @ B2 ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
              | ( B2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% unique_euclidean_semiring_class.div_eq_0_iff
thf(fact_7874_div__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R: A,Q2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q2 @ B2 ) @ R )
                  = A2 )
               => ( ( divide_divide @ A @ A2 @ B2 )
                  = Q2 ) ) ) ) ) ) ).

% div_eqI
thf(fact_7875_div__bounded,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R: A,Q2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ Q2 @ B2 ) @ R ) @ B2 )
                = Q2 ) ) ) ) ) ).

% div_bounded
thf(fact_7876_sorted__wrt__iff__nth__Suc__transp,axiom,
    ! [A: $tType,P: A > A > $o,Xs2: list @ A] :
      ( ( transp @ A @ P )
     => ( ( sorted_wrt @ A @ P @ Xs2 )
        = ( ! [I3: nat] :
              ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P @ ( nth @ A @ Xs2 @ I3 ) @ ( nth @ A @ Xs2 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_Suc_transp
thf(fact_7877_less__eq__enat__def,axiom,
    ( ( ord_less_eq @ extended_enat )
    = ( ^ [M3: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [N1: nat] :
              ( extended_case_enat @ $o
              @ ^ [M1: nat] : ( ord_less_eq @ nat @ M1 @ N1 )
              @ $false
              @ M3 )
          @ $true ) ) ) ).

% less_eq_enat_def
thf(fact_7878_transp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A @ ( ord_less_eq @ A ) ) ) ).

% transp_le
thf(fact_7879_transp__ge,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A
        @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 ) ) ) ).

% transp_ge
thf(fact_7880_subset__subseqs,axiom,
    ! [A: $tType,X9: set @ A,Xs2: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X9 @ ( set2 @ A @ Xs2 ) )
     => ( member @ ( set @ A ) @ X9 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) ) ) ) ).

% subset_subseqs
thf(fact_7881_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_7882_zero__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( zero_zero @ A )
            = ( field_char_0_of_rat @ A @ A2 ) )
          = ( ( zero_zero @ rat )
            = A2 ) ) ) ).

% zero_eq_of_rat_iff
thf(fact_7883_of__rat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( field_char_0_of_rat @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ rat ) ) ) ) ).

% of_rat_eq_0_iff
thf(fact_7884_of__rat__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( zero_zero @ rat ) )
        = ( zero_zero @ A ) ) ) ).

% of_rat_0
thf(fact_7885_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( one_one @ A )
            = ( field_char_0_of_rat @ A @ A2 ) )
          = ( ( one_one @ rat )
            = A2 ) ) ) ).

% one_eq_of_rat_iff
thf(fact_7886_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( field_char_0_of_rat @ A @ A2 )
            = ( one_one @ A ) )
          = ( A2
            = ( one_one @ rat ) ) ) ) ).

% of_rat_eq_1_iff
thf(fact_7887_of__rat__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( one_one @ rat ) )
        = ( one_one @ A ) ) ) ).

% of_rat_1
thf(fact_7888_of__rat__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( field_char_0_of_rat @ A @ ( semiring_1_of_nat @ rat @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_rat_of_nat_eq
thf(fact_7889_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( zero_zero @ A ) )
          = ( ord_less @ rat @ R @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_less_0_iff
thf(fact_7890_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less @ rat @ ( zero_zero @ rat ) @ R ) ) ) ).

% zero_less_of_rat_iff
thf(fact_7891_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_7892_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R ) ) ) ).

% one_less_of_rat_iff
thf(fact_7893_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ R ) ) ) ).

% zero_le_of_rat_iff
thf(fact_7894_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ rat @ R @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_le_0_iff
thf(fact_7895_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% of_rat_neg_one
thf(fact_7896_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R ) ) ) ).

% one_le_of_rat_iff
thf(fact_7897_of__rat__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat,S: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( field_char_0_of_rat @ A @ S ) )
          = ( ord_less_eq @ rat @ R @ S ) ) ) ).

% of_rat_less_eq
thf(fact_7898_of__rat__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( times_times @ rat @ A2 @ B2 ) )
          = ( times_times @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_mult
thf(fact_7899_of__rat__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( plus_plus @ rat @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_add
thf(fact_7900_of__rat__diff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( minus_minus @ rat @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_diff
thf(fact_7901_Real__leI,axiom,
    ! [X9: nat > rat,Y: real] :
      ( ( cauchy @ X9 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( field_char_0_of_rat @ real @ ( X9 @ N3 ) ) @ Y )
       => ( ord_less_eq @ real @ ( real2 @ X9 ) @ Y ) ) ) ).

% Real_leI
thf(fact_7902_le__RealI,axiom,
    ! [Y8: nat > rat,X: real] :
      ( ( cauchy @ Y8 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ X @ ( field_char_0_of_rat @ real @ ( Y8 @ N3 ) ) )
       => ( ord_less_eq @ real @ X @ ( real2 @ Y8 ) ) ) ) ).

% le_RealI
thf(fact_7903_nonzero__of__rat__inverse,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( A2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( inverse_inverse @ rat @ A2 ) )
            = ( inverse_inverse @ A @ ( field_char_0_of_rat @ A @ A2 ) ) ) ) ) ).

% nonzero_of_rat_inverse
thf(fact_7904_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: rat,A2: rat] :
          ( ( B2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ) ).

% nonzero_of_rat_divide
thf(fact_7905_of__rat__rat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: int,A2: int] :
          ( ( B2
           != ( zero_zero @ int ) )
         => ( ( field_char_0_of_rat @ A @ ( fract @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) ) ) ) ).

% of_rat_rat
thf(fact_7906_Collect__finite__subset__eq__lists,axiom,
    ! [A: $tType,T5: set @ A] :
      ( ( collect @ ( set @ A )
        @ ^ [A6: set @ A] :
            ( ( finite_finite @ A @ A6 )
            & ( ord_less_eq @ ( set @ A ) @ A6 @ T5 ) ) )
      = ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( lists @ A @ T5 ) ) ) ).

% Collect_finite_subset_eq_lists
thf(fact_7907_span__explicit_H,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B3: set @ A] :
              ( collect @ A
              @ ^ [Uu2: A] :
                ? [F5: A > real] :
                  ( ( Uu2
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( F5 @ V5 ) @ V5 )
                      @ ( collect @ A
                        @ ^ [V5: A] :
                            ( ( F5 @ V5 )
                           != ( zero_zero @ real ) ) ) ) )
                  & ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [V5: A] :
                          ( ( F5 @ V5 )
                         != ( zero_zero @ real ) ) ) )
                  & ! [V5: A] :
                      ( ( ( F5 @ V5 )
                       != ( zero_zero @ real ) )
                     => ( member @ A @ V5 @ B3 ) ) ) ) ) ) ) ).

% span_explicit'
thf(fact_7908_span__insert__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( real_Vector_span @ A @ ( insert @ A @ ( zero_zero @ A ) @ S2 ) )
          = ( real_Vector_span @ A @ S2 ) ) ) ).

% span_insert_0
thf(fact_7909_span__empty,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% span_empty
thf(fact_7910_span__delete__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( real_Vector_span @ A @ S2 ) ) ) ).

% span_delete_0
thf(fact_7911_span__Un,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( real_Vector_span @ A @ ( sup_sup @ ( set @ A ) @ S2 @ T5 ) )
          = ( collect @ A
            @ ^ [Uu2: A] :
              ? [X3: A,Y6: A] :
                ( ( Uu2
                  = ( plus_plus @ A @ X3 @ Y6 ) )
                & ( member @ A @ X3 @ ( real_Vector_span @ A @ S2 ) )
                & ( member @ A @ Y6 @ ( real_Vector_span @ A @ T5 ) ) ) ) ) ) ).

% span_Un
thf(fact_7912_span__insert,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A,S2: set @ A] :
          ( ( real_Vector_span @ A @ ( insert @ A @ A2 @ S2 ) )
          = ( collect @ A
            @ ^ [X3: A] :
              ? [K2: real] : ( member @ A @ ( minus_minus @ A @ X3 @ ( real_V8093663219630862766scaleR @ A @ K2 @ A2 ) ) @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_insert
thf(fact_7913_lists__eq__set,axiom,
    ! [A: $tType] :
      ( ( lists @ A )
      = ( ^ [A6: set @ A] :
            ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A6 ) ) ) ) ).

% lists_eq_set
thf(fact_7914_span__breakdown__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,A2: A,S2: set @ A] :
          ( ( member @ A @ X @ ( real_Vector_span @ A @ ( insert @ A @ A2 @ S2 ) ) )
          = ( ? [K2: real] : ( member @ A @ ( minus_minus @ A @ X @ ( real_V8093663219630862766scaleR @ A @ K2 @ A2 ) ) @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_breakdown_eq
thf(fact_7915_in__span__delete,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A,S2: set @ A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_span @ A @ S2 ) )
         => ( ~ ( member @ A @ A2 @ ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( member @ A @ B2 @ ( real_Vector_span @ A @ ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% in_span_delete
thf(fact_7916_span__diff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,S2: set @ A,Y: A] :
          ( ( member @ A @ X @ ( real_Vector_span @ A @ S2 ) )
         => ( ( member @ A @ Y @ ( real_Vector_span @ A @ S2 ) )
           => ( member @ A @ ( minus_minus @ A @ X @ Y ) @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_diff
thf(fact_7917_eq__span__insert__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,S2: set @ A] :
          ( ( member @ A @ ( minus_minus @ A @ X @ Y ) @ ( real_Vector_span @ A @ S2 ) )
         => ( ( real_Vector_span @ A @ ( insert @ A @ X @ S2 ) )
            = ( real_Vector_span @ A @ ( insert @ A @ Y @ S2 ) ) ) ) ) ).

% eq_span_insert_eq
thf(fact_7918_span__induct__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,S2: set @ A,H: A > $o] :
          ( ( member @ A @ X @ ( real_Vector_span @ A @ S2 ) )
         => ( ( H @ ( zero_zero @ A ) )
           => ( ! [C4: real,X4: A,Y3: A] :
                  ( ( member @ A @ X4 @ S2 )
                 => ( ( H @ Y3 )
                   => ( H @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ C4 @ X4 ) @ Y3 ) ) ) )
             => ( H @ X ) ) ) ) ) ).

% span_induct_alt
thf(fact_7919_span__add,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,S2: set @ A,Y: A] :
          ( ( member @ A @ X @ ( real_Vector_span @ A @ S2 ) )
         => ( ( member @ A @ Y @ ( real_Vector_span @ A @ S2 ) )
           => ( member @ A @ ( plus_plus @ A @ X @ Y ) @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_add
thf(fact_7920_span__add__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,S2: set @ A,Y: A] :
          ( ( member @ A @ X @ ( real_Vector_span @ A @ S2 ) )
         => ( ( member @ A @ ( plus_plus @ A @ X @ Y ) @ ( real_Vector_span @ A @ S2 ) )
            = ( member @ A @ Y @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_add_eq
thf(fact_7921_span__add__eq2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Y: A,S2: set @ A,X: A] :
          ( ( member @ A @ Y @ ( real_Vector_span @ A @ S2 ) )
         => ( ( member @ A @ ( plus_plus @ A @ X @ Y ) @ ( real_Vector_span @ A @ S2 ) )
            = ( member @ A @ X @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_add_eq2
thf(fact_7922_span__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] : ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_span @ A @ S2 ) ) ) ).

% span_0
thf(fact_7923_span__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( ( real_Vector_span @ A @ S2 )
            = ( real_Vector_span @ A @ T5 ) )
          = ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T5 ) )
            & ( ord_less_eq @ ( set @ A ) @ T5 @ ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_eq
thf(fact_7924_span__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ord_less_eq @ ( set @ A ) @ ( real_Vector_span @ A @ A3 ) @ ( real_Vector_span @ A @ B4 ) ) ) ) ).

% span_mono
thf(fact_7925_span__superset,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] : ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ S2 ) ) ) ).

% span_superset
thf(fact_7926_maximal__independent__subset__extend,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,V2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S2 @ V2 )
         => ( ~ ( real_V358717886546972837endent @ A @ S2 )
           => ~ ! [B9: set @ A] :
                  ( ( ord_less_eq @ ( set @ A ) @ S2 @ B9 )
                 => ( ( ord_less_eq @ ( set @ A ) @ B9 @ V2 )
                   => ( ~ ( real_V358717886546972837endent @ A @ B9 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B9 ) ) ) ) ) ) ) ) ).

% maximal_independent_subset_extend
thf(fact_7927_spanning__subset__independent,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
         => ( ~ ( real_V358717886546972837endent @ A @ A3 )
           => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( real_Vector_span @ A @ B4 ) )
             => ( A3 = B4 ) ) ) ) ) ).

% spanning_subset_independent
thf(fact_7928_maximal__independent__subset,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [V2: set @ A] :
          ~ ! [B9: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ B9 @ V2 )
             => ( ~ ( real_V358717886546972837endent @ A @ B9 )
               => ~ ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B9 ) ) ) ) ) ).

% maximal_independent_subset
thf(fact_7929_lists__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( lists @ A @ A3 ) @ ( lists @ A @ B4 ) ) ) ).

% lists_mono
thf(fact_7930_dependent__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [P6: set @ A] :
            ? [X3: A] :
              ( ( member @ A @ X3 @ P6 )
              & ( member @ A @ X3 @ ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ P6 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% dependent_def
thf(fact_7931_span__image__scale,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,C2: A > real] :
          ( ( finite_finite @ A @ S2 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ S2 )
               => ( ( C2 @ X4 )
                 != ( zero_zero @ real ) ) )
           => ( ( real_Vector_span @ A
                @ ( image @ A @ A
                  @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( C2 @ X3 ) @ X3 )
                  @ S2 ) )
              = ( real_Vector_span @ A @ S2 ) ) ) ) ) ).

% span_image_scale
thf(fact_7932_span__explicit,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B3: set @ A] :
              ( collect @ A
              @ ^ [Uu2: A] :
                ? [T3: set @ A,R5: A > real] :
                  ( ( Uu2
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [A4: A] : ( real_V8093663219630862766scaleR @ A @ ( R5 @ A4 ) @ A4 )
                      @ T3 ) )
                  & ( finite_finite @ A @ T3 )
                  & ( ord_less_eq @ ( set @ A ) @ T3 @ B3 ) ) ) ) ) ) ).

% span_explicit
thf(fact_7933_span__breakdown,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,S2: set @ A,A2: A] :
          ( ( member @ A @ B2 @ S2 )
         => ( ( member @ A @ A2 @ ( real_Vector_span @ A @ S2 ) )
           => ? [K3: real] : ( member @ A @ ( minus_minus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ K3 @ B2 ) ) @ ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% span_breakdown
thf(fact_7934_independent__span__bound,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [T5: set @ A,S2: set @ A] :
          ( ( finite_finite @ A @ T5 )
         => ( ~ ( real_V358717886546972837endent @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T5 ) )
             => ( ( finite_finite @ A @ S2 )
                & ( ord_less_eq @ nat @ ( finite_card @ A @ S2 ) @ ( finite_card @ A @ T5 ) ) ) ) ) ) ) ).

% independent_span_bound
thf(fact_7935_exchange__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [T5: set @ A,S2: set @ A] :
          ( ( finite_finite @ A @ T5 )
         => ( ~ ( real_V358717886546972837endent @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T5 ) )
             => ? [T13: set @ A] :
                  ( ( ( finite_card @ A @ T13 )
                    = ( finite_card @ A @ T5 ) )
                  & ( finite_finite @ A @ T13 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ T13 )
                  & ( ord_less_eq @ ( set @ A ) @ T13 @ ( sup_sup @ ( set @ A ) @ S2 @ T5 ) )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ T13 ) ) ) ) ) ) ) ).

% exchange_lemma
thf(fact_7936_span__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B6: set @ A] :
              ( collect @ A
              @ ^ [Uu2: A] :
                ? [F5: A > real] :
                  ( ( Uu2
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [X3: A] : ( real_V8093663219630862766scaleR @ A @ ( F5 @ X3 ) @ X3 )
                      @ ( collect @ A
                        @ ^ [X3: A] :
                            ( ( F5 @ X3 )
                           != ( zero_zero @ real ) ) ) ) )
                  & ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( F5 @ X3 )
                         != ( zero_zero @ real ) ) )
                    @ B6 )
                  & ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [X3: A] :
                          ( ( F5 @ X3 )
                         != ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% span_alt
thf(fact_7937_representation__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V7696804695334737415tation @ A )
        = ( ^ [Basis2: set @ A,V5: A] :
              ( if @ ( A > real )
              @ ( ~ ( real_V358717886546972837endent @ A @ Basis2 )
                & ( member @ A @ V5 @ ( real_Vector_span @ A @ Basis2 ) ) )
              @ ( fChoice @ ( A > real )
                @ ^ [F5: A > real] :
                    ( ! [W3: A] :
                        ( ( ( F5 @ W3 )
                         != ( zero_zero @ real ) )
                       => ( member @ A @ W3 @ Basis2 ) )
                    & ( finite_finite @ A
                      @ ( collect @ A
                        @ ^ [W3: A] :
                            ( ( F5 @ W3 )
                           != ( zero_zero @ real ) ) ) )
                    & ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( F5 @ W3 ) @ W3 )
                        @ ( collect @ A
                          @ ^ [W3: A] :
                              ( ( F5 @ W3 )
                             != ( zero_zero @ real ) ) ) )
                      = V5 ) ) )
              @ ^ [B3: A] : ( zero_zero @ real ) ) ) ) ) ).

% representation_def
thf(fact_7938_extend__basis__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V4986007116245087402_basis @ A )
        = ( ^ [B6: set @ A] :
              ( fChoice @ ( set @ A )
              @ ^ [B15: set @ A] :
                  ( ( ord_less_eq @ ( set @ A ) @ B6 @ B15 )
                  & ~ ( real_V358717886546972837endent @ A @ B15 )
                  & ( ( real_Vector_span @ A @ B15 )
                    = ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% extend_basis_def
thf(fact_7939_finite__representation,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [B3: A] :
                ( ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 )
               != ( zero_zero @ real ) ) ) ) ) ).

% finite_representation
thf(fact_7940_representation__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A] :
          ( ( real_V7696804695334737415tation @ A @ Basis @ ( zero_zero @ A ) )
          = ( ^ [B3: A] : ( zero_zero @ real ) ) ) ) ).

% representation_zero
thf(fact_7941_representation__ne__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,B2: A] :
          ( ( ( real_V7696804695334737415tation @ A @ Basis @ V @ B2 )
           != ( zero_zero @ real ) )
         => ( member @ A @ B2 @ Basis ) ) ) ).

% representation_ne_zero
thf(fact_7942_representation__basis,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,B2: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ B2 @ Basis )
           => ( ( real_V7696804695334737415tation @ A @ Basis @ B2 )
              = ( ^ [V5: A] : ( if @ real @ ( V5 = B2 ) @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% representation_basis
thf(fact_7943_representation__extend,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,Basis3: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis3 ) )
           => ( ( ord_less_eq @ ( set @ A ) @ Basis3 @ Basis )
             => ( ( real_V7696804695334737415tation @ A @ Basis @ V )
                = ( real_V7696804695334737415tation @ A @ Basis3 @ V ) ) ) ) ) ) ).

% representation_extend
thf(fact_7944_extend__basis__superset,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ B4 )
         => ( ord_less_eq @ ( set @ A ) @ B4 @ ( real_V4986007116245087402_basis @ A @ B4 ) ) ) ) ).

% extend_basis_superset
thf(fact_7945_representation__add,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,U: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ( member @ A @ U @ ( real_Vector_span @ A @ Basis ) )
             => ( ( real_V7696804695334737415tation @ A @ Basis @ ( plus_plus @ A @ U @ V ) )
                = ( ^ [B3: A] : ( plus_plus @ real @ ( real_V7696804695334737415tation @ A @ Basis @ U @ B3 ) @ ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 ) ) ) ) ) ) ) ) ).

% representation_add
thf(fact_7946_representation__diff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,U: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ( member @ A @ U @ ( real_Vector_span @ A @ Basis ) )
             => ( ( real_V7696804695334737415tation @ A @ Basis @ ( minus_minus @ A @ U @ V ) )
                = ( ^ [B3: A] : ( minus_minus @ real @ ( real_V7696804695334737415tation @ A @ Basis @ U @ B3 ) @ ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 ) ) ) ) ) ) ) ) ).

% representation_diff
thf(fact_7947_representation__scale,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,R: real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ( real_V7696804695334737415tation @ A @ Basis @ ( real_V8093663219630862766scaleR @ A @ R @ V ) )
              = ( ^ [B3: A] : ( times_times @ real @ R @ ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 ) ) ) ) ) ) ) ).

% representation_scale
thf(fact_7948_sum__nonzero__representation__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ( groups7311177749621191930dd_sum @ A @ A
                @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 ) @ B3 )
                @ ( collect @ A
                  @ ^ [B3: A] :
                      ( ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 )
                     != ( zero_zero @ real ) ) ) )
              = V ) ) ) ) ).

% sum_nonzero_representation_eq
thf(fact_7949_sum__representation__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,B4: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ( ord_less_eq @ ( set @ A ) @ Basis @ B4 )
               => ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 ) @ B3 )
                    @ B4 )
                  = V ) ) ) ) ) ) ).

% sum_representation_eq
thf(fact_7950_representation__eqI,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,F3: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ! [B5: A] :
                  ( ( ( F3 @ B5 )
                   != ( zero_zero @ real ) )
                 => ( member @ A @ B5 @ Basis ) )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [B3: A] :
                        ( ( F3 @ B3 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ B3 ) @ B3 )
                      @ ( collect @ A
                        @ ^ [B3: A] :
                            ( ( F3 @ B3 )
                           != ( zero_zero @ real ) ) ) )
                    = V )
                 => ( ( real_V7696804695334737415tation @ A @ Basis @ V )
                    = F3 ) ) ) ) ) ) ) ).

% representation_eqI
thf(fact_7951_construct__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ( ( real_V4425403222259421789struct @ A @ B )
        = ( ^ [B6: set @ A,G2: A > B,V5: A] :
              ( groups7311177749621191930dd_sum @ A @ B
              @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ B @ ( real_V7696804695334737415tation @ A @ ( real_V4986007116245087402_basis @ A @ B6 ) @ V5 @ B3 ) @ ( if @ B @ ( member @ A @ B3 @ B6 ) @ ( G2 @ B3 ) @ ( zero_zero @ B ) ) )
              @ ( collect @ A
                @ ^ [B3: A] :
                    ( ( real_V7696804695334737415tation @ A @ ( real_V4986007116245087402_basis @ A @ B6 ) @ V5 @ B3 )
                   != ( zero_zero @ real ) ) ) ) ) ) ) ).

% construct_def
thf(fact_7952_dim__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_dim @ A )
        = ( ^ [V7: set @ A] :
              ( if @ nat
              @ ? [B3: set @ A] :
                  ( ~ ( real_V358717886546972837endent @ A @ B3 )
                  & ( ( real_Vector_span @ A @ B3 )
                    = ( real_Vector_span @ A @ V7 ) ) )
              @ ( finite_card @ A
                @ ( fChoice @ ( set @ A )
                  @ ^ [B3: set @ A] :
                      ( ~ ( real_V358717886546972837endent @ A @ B3 )
                      & ( ( real_Vector_span @ A @ B3 )
                        = ( real_Vector_span @ A @ V7 ) ) ) ) )
              @ ( zero_zero @ nat ) ) ) ) ) ).

% dim_def
thf(fact_7953_construct__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [B4: set @ A,F3: A > B,G: A > B,V: A] :
          ( ~ ( real_V358717886546972837endent @ A @ B4 )
         => ( ( real_V4425403222259421789struct @ A @ B @ B4
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
              @ V )
            = ( plus_plus @ B @ ( real_V4425403222259421789struct @ A @ B @ B4 @ F3 @ V ) @ ( real_V4425403222259421789struct @ A @ B @ B4 @ G @ V ) ) ) ) ) ).

% construct_add
thf(fact_7954_dim__le__card_H,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ S ) @ ( finite_card @ A @ S ) ) ) ) ).

% dim_le_card'
thf(fact_7955_dim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A,V2: set @ A,N: nat] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ V2 )
         => ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B4 ) )
           => ( ~ ( real_V358717886546972837endent @ A @ B4 )
             => ( ( ( finite_card @ A @ B4 )
                  = N )
               => ( ( real_Vector_dim @ A @ V2 )
                  = N ) ) ) ) ) ) ).

% dim_unique
thf(fact_7956_basis__exists,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [V2: set @ A] :
          ~ ! [B9: set @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ B9 @ V2 )
             => ( ~ ( real_V358717886546972837endent @ A @ B9 )
               => ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B9 ) )
                 => ( ( finite_card @ A @ B9 )
                   != ( real_Vector_dim @ A @ V2 ) ) ) ) ) ) ).

% basis_exists
thf(fact_7957_basis__card__eq__dim,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A,V2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ V2 )
         => ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B4 ) )
           => ( ~ ( real_V358717886546972837endent @ A @ B4 )
             => ( ( finite_card @ A @ B4 )
                = ( real_Vector_dim @ A @ V2 ) ) ) ) ) ) ).

% basis_card_eq_dim
thf(fact_7958_span__card__ge__dim,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B4: set @ A,V2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ V2 )
         => ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B4 ) )
           => ( ( finite_finite @ A @ B4 )
             => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ V2 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ) ).

% span_card_ge_dim
thf(fact_7959_dim__le__card,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [V2: set @ A,W4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ W4 ) )
         => ( ( finite_finite @ A @ W4 )
           => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ V2 ) @ ( finite_card @ A @ W4 ) ) ) ) ) ).

% dim_le_card
thf(fact_7960_construct__outside,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [B4: set @ A,V: A,F3: A > B] :
          ( ~ ( real_V358717886546972837endent @ A @ B4 )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ ( real_V4986007116245087402_basis @ A @ B4 ) @ B4 ) ) )
           => ( ( real_V4425403222259421789struct @ A @ B @ B4 @ F3 @ V )
              = ( zero_zero @ B ) ) ) ) ) ).

% construct_outside
thf(fact_7961_linear__indep__image__lemma,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,B4: set @ A,X: A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( finite_finite @ A @ B4 )
           => ( ~ ( real_V358717886546972837endent @ B @ ( image @ A @ B @ F3 @ B4 ) )
             => ( ( inj_on @ A @ B @ F3 @ B4 )
               => ( ( member @ A @ X @ ( real_Vector_span @ A @ B4 ) )
                 => ( ( ( F3 @ X )
                      = ( zero_zero @ B ) )
                   => ( X
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ) ).

% linear_indep_image_lemma
thf(fact_7962_bounded__bilinear__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ( ( real_V2442710119149674383linear @ A @ B @ C )
        = ( ^ [Prod: A > B > C] :
              ( ! [A4: A,A21: A,B3: B] :
                  ( ( Prod @ ( plus_plus @ A @ A4 @ A21 ) @ B3 )
                  = ( plus_plus @ C @ ( Prod @ A4 @ B3 ) @ ( Prod @ A21 @ B3 ) ) )
              & ! [A4: A,B3: B,B16: B] :
                  ( ( Prod @ A4 @ ( plus_plus @ B @ B3 @ B16 ) )
                  = ( plus_plus @ C @ ( Prod @ A4 @ B3 ) @ ( Prod @ A4 @ B16 ) ) )
              & ! [R5: real,A4: A,B3: B] :
                  ( ( Prod @ ( real_V8093663219630862766scaleR @ A @ R5 @ A4 ) @ B3 )
                  = ( real_V8093663219630862766scaleR @ C @ R5 @ ( Prod @ A4 @ B3 ) ) )
              & ! [A4: A,R5: real,B3: B] :
                  ( ( Prod @ A4 @ ( real_V8093663219630862766scaleR @ B @ R5 @ B3 ) )
                  = ( real_V8093663219630862766scaleR @ C @ R5 @ ( Prod @ A4 @ B3 ) ) )
              & ? [K5: real] :
                ! [A4: A,B3: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod @ A4 @ B3 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A4 ) @ ( real_V7770717601297561774m_norm @ B @ B3 ) ) @ K5 ) ) ) ) ) ) ).

% bounded_bilinear_def
thf(fact_7963_linear__spans__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,V2: set @ A,B4: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B4 ) )
           => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ V2 ) @ ( real_Vector_span @ B @ ( image @ A @ B @ F3 @ B4 ) ) ) ) ) ) ).

% linear_spans_image
thf(fact_7964_linear__eq__0__on__span,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F3: A > B,B2: set @ A,X: A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ B2 )
               => ( ( F3 @ X4 )
                  = ( zero_zero @ B ) ) )
           => ( ( member @ A @ X @ ( real_Vector_span @ A @ B2 ) )
             => ( ( F3 @ X )
                = ( zero_zero @ B ) ) ) ) ) ) ).

% linear_eq_0_on_span
thf(fact_7965_bounded__bilinear_Obounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ? [K10: real] :
            ! [A17: A,B10: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A17 @ B10 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A17 ) @ ( real_V7770717601297561774m_norm @ B @ B10 ) ) @ K10 ) ) ) ) ).

% bounded_bilinear.bounded
thf(fact_7966_Real__Vector__Spaces_Olinear__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ( ( real_Vector_linear @ A @ B )
        = ( ^ [F5: A > B] :
              ( ! [X3: A,Y6: A] :
                  ( ( F5 @ ( plus_plus @ A @ X3 @ Y6 ) )
                  = ( plus_plus @ B @ ( F5 @ X3 ) @ ( F5 @ Y6 ) ) )
              & ! [C3: real,X3: A] :
                  ( ( F5 @ ( real_V8093663219630862766scaleR @ A @ C3 @ X3 ) )
                  = ( real_V8093663219630862766scaleR @ B @ C3 @ ( F5 @ X3 ) ) ) ) ) ) ) ).

% Real_Vector_Spaces.linear_iff
thf(fact_7967_linearI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B] :
          ( ! [B17: A,B23: A] :
              ( ( F3 @ ( plus_plus @ A @ B17 @ B23 ) )
              = ( plus_plus @ B @ ( F3 @ B17 ) @ ( F3 @ B23 ) ) )
         => ( ! [R4: real,B5: A] :
                ( ( F3 @ ( real_V8093663219630862766scaleR @ A @ R4 @ B5 ) )
                = ( real_V8093663219630862766scaleR @ B @ R4 @ ( F3 @ B5 ) ) )
           => ( real_Vector_linear @ A @ B @ F3 ) ) ) ) ).

% linearI
thf(fact_7968_module__hom__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ( real_Vector_linear @ A @ B
        @ ^ [X3: A] : ( zero_zero @ B ) ) ) ).

% module_hom_zero
thf(fact_7969_bounded__bilinear_Ozero__left,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [Prod2: A > B > C,B2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ ( zero_zero @ A ) @ B2 )
            = ( zero_zero @ C ) ) ) ) ).

% bounded_bilinear.zero_left
thf(fact_7970_bounded__bilinear_Ozero__right,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [Prod2: A > B > C,A2: A] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ A2 @ ( zero_zero @ B ) )
            = ( zero_zero @ C ) ) ) ) ).

% bounded_bilinear.zero_right
thf(fact_7971_linear__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F3: A > B] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( F3 @ ( zero_zero @ A ) )
            = ( zero_zero @ B ) ) ) ) ).

% linear_0
thf(fact_7972_linear__compose__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( real_Vector_linear @ A @ B @ G )
           => ( real_Vector_linear @ A @ B
              @ ^ [X3: A] : ( plus_plus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% linear_compose_add
thf(fact_7973_bounded__bilinear__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ( real_V2442710119149674383linear @ A @ A @ A @ ( times_times @ A ) ) ) ).

% bounded_bilinear_mult
thf(fact_7974_real__linearD,axiom,
    ! [F3: real > real] :
      ( ( real_Vector_linear @ real @ real @ F3 )
     => ~ ! [C4: real] :
            ( F3
           != ( times_times @ real @ C4 ) ) ) ).

% real_linearD
thf(fact_7975_linear__scale__real,axiom,
    ! [F3: real > real,R: real,B2: real] :
      ( ( real_Vector_linear @ real @ real @ F3 )
     => ( ( F3 @ ( times_times @ real @ R @ B2 ) )
        = ( times_times @ real @ R @ ( F3 @ B2 ) ) ) ) ).

% linear_scale_real
thf(fact_7976_linear__times,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [C2: A] : ( real_Vector_linear @ A @ A @ ( times_times @ A @ C2 ) ) ) ).

% linear_times
thf(fact_7977_bounded__bilinear_Oadd__right,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A ) )
     => ! [Prod2: A > B > C,A2: A,B2: B,B7: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ A2 @ ( plus_plus @ B @ B2 @ B7 ) )
            = ( plus_plus @ C @ ( Prod2 @ A2 @ B2 ) @ ( Prod2 @ A2 @ B7 ) ) ) ) ) ).

% bounded_bilinear.add_right
thf(fact_7978_bounded__bilinear_Oadd__left,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A ) )
     => ! [Prod2: A > B > C,A2: A,A7: A,B2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ ( plus_plus @ A @ A2 @ A7 ) @ B2 )
            = ( plus_plus @ C @ ( Prod2 @ A2 @ B2 ) @ ( Prod2 @ A7 @ B2 ) ) ) ) ) ).

% bounded_bilinear.add_left
thf(fact_7979_linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,B18: A,B24: A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( F3 @ ( plus_plus @ A @ B18 @ B24 ) )
            = ( plus_plus @ B @ ( F3 @ B18 ) @ ( F3 @ B24 ) ) ) ) ) ).

% linear_add
thf(fact_7980_linear__times__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A] :
          ( real_Vector_linear @ real @ A
          @ ^ [X3: real] : ( times_times @ A @ A2 @ ( real_Vector_of_real @ A @ X3 ) ) ) ) ).

% linear_times_of_real
thf(fact_7981_bounded__bilinear_Odiff__left,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A ) )
     => ! [Prod2: A > B > C,A2: A,A7: A,B2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ ( minus_minus @ A @ A2 @ A7 ) @ B2 )
            = ( minus_minus @ C @ ( Prod2 @ A2 @ B2 ) @ ( Prod2 @ A7 @ B2 ) ) ) ) ) ).

% bounded_bilinear.diff_left
thf(fact_7982_bounded__bilinear_Odiff__right,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A ) )
     => ! [Prod2: A > B > C,A2: A,B2: B,B7: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ A2 @ ( minus_minus @ B @ B2 @ B7 ) )
            = ( minus_minus @ C @ ( Prod2 @ A2 @ B2 ) @ ( Prod2 @ A2 @ B7 ) ) ) ) ) ).

% bounded_bilinear.diff_right
thf(fact_7983_linear__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,X: A,Y: A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( F3 @ ( minus_minus @ A @ X @ Y ) )
            = ( minus_minus @ B @ ( F3 @ X ) @ ( F3 @ Y ) ) ) ) ) ).

% linear_diff
thf(fact_7984_linear__compose__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,G: A > B] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( real_Vector_linear @ A @ B @ G )
           => ( real_Vector_linear @ A @ B
              @ ^ [X3: A] : ( minus_minus @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) ) ) ).

% linear_compose_sub
thf(fact_7985_bounded__bilinear_Oprod__diff__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A ) )
     => ! [Prod2: A > B > C,X: A,Y: B,A2: A,B2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( minus_minus @ C @ ( Prod2 @ X @ Y ) @ ( Prod2 @ A2 @ B2 ) )
            = ( plus_plus @ C @ ( plus_plus @ C @ ( Prod2 @ ( minus_minus @ A @ X @ A2 ) @ ( minus_minus @ B @ Y @ B2 ) ) @ ( Prod2 @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) @ ( Prod2 @ A2 @ ( minus_minus @ B @ Y @ B2 ) ) ) ) ) ) ).

% bounded_bilinear.prod_diff_prod
thf(fact_7986_linear__injective__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( inj_on @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
            = ( ! [X3: A] :
                  ( ( ( F3 @ X3 )
                    = ( zero_zero @ B ) )
                 => ( X3
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% linear_injective_0
thf(fact_7987_bounded__bilinear_Otendsto__right__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C,F3: D > B,F6: filter @ D,C2: A] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( filterlim @ D @ B @ F3 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 )
           => ( filterlim @ D @ C
              @ ^ [X3: D] : ( Prod2 @ C2 @ ( F3 @ X3 ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
              @ F6 ) ) ) ) ).

% bounded_bilinear.tendsto_right_zero
thf(fact_7988_bounded__bilinear_Otendsto__left__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C,F3: D > A,F6: filter @ D,C2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
           => ( filterlim @ D @ C
              @ ^ [X3: D] : ( Prod2 @ ( F3 @ X3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
              @ F6 ) ) ) ) ).

% bounded_bilinear.tendsto_left_zero
thf(fact_7989_bounded__bilinear_Otendsto__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C,F3: D > A,F6: filter @ D,G: D > B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( filterlim @ D @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F6 )
           => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F6 )
             => ( filterlim @ D @ C
                @ ^ [X3: D] : ( Prod2 @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F6 ) ) ) ) ) ).

% bounded_bilinear.tendsto_zero
thf(fact_7990_bounded__bilinear_OFDERIV,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A ) )
     => ! [Prod2: A > B > C,F3: D > A,F9: D > A,X: D,S: set @ D,G: D > B,G5: D > B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( has_derivative @ D @ A @ F3 @ F9 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( ( has_derivative @ D @ B @ G @ G5 @ ( topolo174197925503356063within @ D @ X @ S ) )
             => ( has_derivative @ D @ C
                @ ^ [X3: D] : ( Prod2 @ ( F3 @ X3 ) @ ( G @ X3 ) )
                @ ^ [H3: D] : ( plus_plus @ C @ ( Prod2 @ ( F3 @ X ) @ ( G5 @ H3 ) ) @ ( Prod2 @ ( F9 @ H3 ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ) ).

% bounded_bilinear.FDERIV
thf(fact_7991_linear__spanning__surjective__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,S2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( real_Vector_span @ A @ S2 ) )
           => ( ( ( image @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
                = ( top_top @ ( set @ B ) ) )
             => ( ord_less_eq @ ( set @ B ) @ ( top_top @ ( set @ B ) ) @ ( real_Vector_span @ B @ ( image @ A @ B @ F3 @ S2 ) ) ) ) ) ) ) ).

% linear_spanning_surjective_image
thf(fact_7992_linear__surj__right__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F3: A > B,T5: set @ B,S2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( ord_less_eq @ ( set @ B ) @ ( real_Vector_span @ B @ T5 ) @ ( image @ A @ B @ F3 @ ( real_Vector_span @ A @ S2 ) ) )
           => ? [G9: B > A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G9 @ ( top_top @ ( set @ B ) ) ) @ ( real_Vector_span @ A @ S2 ) )
                & ( real_Vector_linear @ B @ A @ G9 )
                & ! [X5: B] :
                    ( ( member @ B @ X5 @ ( real_Vector_span @ B @ T5 ) )
                   => ( ( F3 @ ( G9 @ X5 ) )
                      = X5 ) ) ) ) ) ) ).

% linear_surj_right_inverse
thf(fact_7993_bounded__bilinear_Ononneg__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ? [K10: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K10 )
              & ! [A17: A,B10: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A17 @ B10 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A17 ) @ ( real_V7770717601297561774m_norm @ B @ B10 ) ) @ K10 ) ) ) ) ) ).

% bounded_bilinear.nonneg_bounded
thf(fact_7994_linear__inj__on__left__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,S2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( inj_on @ A @ B @ F3 @ ( real_Vector_span @ A @ S2 ) )
           => ? [G9: B > A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G9 @ ( top_top @ ( set @ B ) ) ) @ ( real_Vector_span @ A @ S2 ) )
                & ( real_Vector_linear @ B @ A @ G9 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ ( real_Vector_span @ A @ S2 ) )
                   => ( ( G9 @ ( F3 @ X5 ) )
                      = X5 ) ) ) ) ) ) ).

% linear_inj_on_left_inverse
thf(fact_7995_bounded__bilinear_Opos__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [A17: A,B10: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A17 @ B10 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A17 ) @ ( real_V7770717601297561774m_norm @ B @ B10 ) ) @ K10 ) ) ) ) ) ).

% bounded_bilinear.pos_bounded
thf(fact_7996_bounded__bilinear_Ointro,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ! [A5: A,A20: A,B5: B] :
              ( ( Prod2 @ ( plus_plus @ A @ A5 @ A20 ) @ B5 )
              = ( plus_plus @ C @ ( Prod2 @ A5 @ B5 ) @ ( Prod2 @ A20 @ B5 ) ) )
         => ( ! [A5: A,B5: B,B8: B] :
                ( ( Prod2 @ A5 @ ( plus_plus @ B @ B5 @ B8 ) )
                = ( plus_plus @ C @ ( Prod2 @ A5 @ B5 ) @ ( Prod2 @ A5 @ B8 ) ) )
           => ( ! [R4: real,A5: A,B5: B] :
                  ( ( Prod2 @ ( real_V8093663219630862766scaleR @ A @ R4 @ A5 ) @ B5 )
                  = ( real_V8093663219630862766scaleR @ C @ R4 @ ( Prod2 @ A5 @ B5 ) ) )
             => ( ! [A5: A,R4: real,B5: B] :
                    ( ( Prod2 @ A5 @ ( real_V8093663219630862766scaleR @ B @ R4 @ B5 ) )
                    = ( real_V8093663219630862766scaleR @ C @ R4 @ ( Prod2 @ A5 @ B5 ) ) )
               => ( ? [K7: real] :
                    ! [A5: A,B5: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A5 @ B5 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A5 ) @ ( real_V7770717601297561774m_norm @ B @ B5 ) ) @ K7 ) )
                 => ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 ) ) ) ) ) ) ) ).

% bounded_bilinear.intro
thf(fact_7997_finite__basis__to__basis__subspace__isomorphism,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [S2: set @ A,T5: set @ B,B4: set @ A,C5: set @ B] :
          ( ( real_Vector_subspace @ A @ S2 )
         => ( ( real_Vector_subspace @ B @ T5 )
           => ( ( ( real_Vector_dim @ A @ S2 )
                = ( real_Vector_dim @ B @ T5 ) )
             => ( ( finite_finite @ A @ B4 )
               => ( ( ord_less_eq @ ( set @ A ) @ B4 @ S2 )
                 => ( ~ ( real_V358717886546972837endent @ A @ B4 )
                   => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( real_Vector_span @ A @ B4 ) )
                     => ( ( ( finite_card @ A @ B4 )
                          = ( real_Vector_dim @ A @ S2 ) )
                       => ( ( finite_finite @ B @ C5 )
                         => ( ( ord_less_eq @ ( set @ B ) @ C5 @ T5 )
                           => ( ~ ( real_V358717886546972837endent @ B @ C5 )
                             => ( ( ord_less_eq @ ( set @ B ) @ T5 @ ( real_Vector_span @ B @ C5 ) )
                               => ( ( ( finite_card @ B @ C5 )
                                    = ( real_Vector_dim @ B @ T5 ) )
                                 => ? [F4: A > B] :
                                      ( ( real_Vector_linear @ A @ B @ F4 )
                                      & ( ( image @ A @ B @ F4 @ B4 )
                                        = C5 )
                                      & ( ( image @ A @ B @ F4 @ S2 )
                                        = T5 )
                                      & ( inj_on @ A @ B @ F4 @ S2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% finite_basis_to_basis_subspace_isomorphism
thf(fact_7998_linear__exists__left__inverse__on,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,V2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( real_Vector_subspace @ A @ V2 )
           => ( ( inj_on @ A @ B @ F3 @ V2 )
             => ? [G9: B > A] :
                  ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G9 @ ( top_top @ ( set @ B ) ) ) @ V2 )
                  & ( real_Vector_linear @ B @ A @ G9 )
                  & ! [X5: A] :
                      ( ( member @ A @ X5 @ V2 )
                     => ( ( G9 @ ( F3 @ X5 ) )
                        = X5 ) ) ) ) ) ) ) ).

% linear_exists_left_inverse_on
thf(fact_7999_linear__subspace__kernel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( real_Vector_subspace @ A
            @ ( collect @ A
              @ ^ [X3: A] :
                  ( ( F3 @ X3 )
                  = ( zero_zero @ B ) ) ) ) ) ) ).

% linear_subspace_kernel
thf(fact_8000_subspace__sums,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( real_Vector_subspace @ A @ S2 )
         => ( ( real_Vector_subspace @ A @ T5 )
           => ( real_Vector_subspace @ A
              @ ( collect @ A
                @ ^ [Uu2: A] :
                  ? [X3: A,Y6: A] :
                    ( ( Uu2
                      = ( plus_plus @ A @ X3 @ Y6 ) )
                    & ( member @ A @ X3 @ S2 )
                    & ( member @ A @ Y6 @ T5 ) ) ) ) ) ) ) ).

% subspace_sums
thf(fact_8001_subspace__diff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( real_Vector_subspace @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( member @ A @ Y @ S2 )
             => ( member @ A @ ( minus_minus @ A @ X @ Y ) @ S2 ) ) ) ) ) ).

% subspace_diff
thf(fact_8002_subspace__add,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( real_Vector_subspace @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( member @ A @ Y @ S2 )
             => ( member @ A @ ( plus_plus @ A @ X @ Y ) @ S2 ) ) ) ) ) ).

% subspace_add
thf(fact_8003_subspace__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( real_Vector_subspace @ A @ S2 )
         => ( member @ A @ ( zero_zero @ A ) @ S2 ) ) ) ).

% subspace_0
thf(fact_8004_span__subspace,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( real_Vector_span @ A @ A3 ) )
           => ( ( real_Vector_subspace @ A @ B4 )
             => ( ( real_Vector_span @ A @ A3 )
                = B4 ) ) ) ) ) ).

% span_subspace
thf(fact_8005_span__minimal,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S2 @ T5 )
         => ( ( real_Vector_subspace @ A @ T5 )
           => ( ord_less_eq @ ( set @ A ) @ ( real_Vector_span @ A @ S2 ) @ T5 ) ) ) ) ).

% span_minimal
thf(fact_8006_span__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ S2 @ T5 )
         => ( ( real_Vector_subspace @ A @ T5 )
           => ( ! [T14: set @ A] :
                  ( ( ord_less_eq @ ( set @ A ) @ S2 @ T14 )
                 => ( ( real_Vector_subspace @ A @ T14 )
                   => ( ord_less_eq @ ( set @ A ) @ T5 @ T14 ) ) )
             => ( ( real_Vector_span @ A @ S2 )
                = T5 ) ) ) ) ) ).

% span_unique
thf(fact_8007_subspace__single__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( real_Vector_subspace @ A @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% subspace_single_0
thf(fact_8008_subspace__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_subspace @ A )
        = ( ^ [S7: set @ A] :
              ( ( member @ A @ ( zero_zero @ A ) @ S7 )
              & ! [X3: A] :
                  ( ( member @ A @ X3 @ S7 )
                 => ! [Y6: A] :
                      ( ( member @ A @ Y6 @ S7 )
                     => ( member @ A @ ( plus_plus @ A @ X3 @ Y6 ) @ S7 ) ) )
              & ! [C3: real,X3: A] :
                  ( ( member @ A @ X3 @ S7 )
                 => ( member @ A @ ( real_V8093663219630862766scaleR @ A @ C3 @ X3 ) @ S7 ) ) ) ) ) ) ).

% subspace_def
thf(fact_8009_subspaceI,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ S2 )
         => ( ! [X4: A,Y3: A] :
                ( ( member @ A @ X4 @ S2 )
               => ( ( member @ A @ Y3 @ S2 )
                 => ( member @ A @ ( plus_plus @ A @ X4 @ Y3 ) @ S2 ) ) )
           => ( ! [C4: real,X4: A] :
                  ( ( member @ A @ X4 @ S2 )
                 => ( member @ A @ ( real_V8093663219630862766scaleR @ A @ C4 @ X4 ) @ S2 ) )
             => ( real_Vector_subspace @ A @ S2 ) ) ) ) ) ).

% subspaceI
thf(fact_8010_linear__injective__on__subspace__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F3: A > B,S: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( real_Vector_subspace @ A @ S )
           => ( ( inj_on @ A @ B @ F3 @ S )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S )
                   => ( ( ( F3 @ X3 )
                        = ( zero_zero @ B ) )
                     => ( X3
                        = ( zero_zero @ A ) ) ) ) ) ) ) ) ) ).

% linear_injective_on_subspace_0
thf(fact_8011_linear__exists__right__inverse__on,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F3: A > B,V2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F3 )
         => ( ( real_Vector_subspace @ A @ V2 )
           => ? [G9: B > A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G9 @ ( top_top @ ( set @ B ) ) ) @ V2 )
                & ( real_Vector_linear @ B @ A @ G9 )
                & ! [X5: B] :
                    ( ( member @ B @ X5 @ ( image @ A @ B @ F3 @ V2 ) )
                   => ( ( F3 @ ( G9 @ X5 ) )
                      = X5 ) ) ) ) ) ) ).

% linear_exists_right_inverse_on
thf(fact_8012_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ A3 @ I5 ) )
           => ( ( I5
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X3: C] : ( F3 @ ( A3 @ X3 ) )
                    @ I5 ) )
                @ ( F3 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I5 ) ) ) ) ) ) ) ) ).

% mono_cSUP
thf(fact_8013_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F3 @ A3 ) ) @ ( F3 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ) ).

% mono_cSup
thf(fact_8014_bdd__above_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,M7: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ( ord_less_eq @ A @ X4 @ M7 ) )
         => ( condit941137186595557371_above @ A @ A3 ) ) ) ).

% bdd_above.I
thf(fact_8015_bdd__above_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit941137186595557371_above @ A )
        = ( ^ [A6: set @ A] :
            ? [M8: A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ A6 )
             => ( ord_less_eq @ A @ X3 @ M8 ) ) ) ) ) ).

% bdd_above.unfold
thf(fact_8016_bdd__above_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A] :
          ( ( condit941137186595557371_above @ A @ A3 )
         => ~ ! [M10: A] :
                ~ ! [X5: A] :
                    ( ( member @ A @ X5 @ A3 )
                   => ( ord_less_eq @ A @ X5 @ M10 ) ) ) ) ).

% bdd_above.E
thf(fact_8017_bdd__above__mono,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( condit941137186595557371_above @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( condit941137186595557371_above @ A @ A3 ) ) ) ) ).

% bdd_above_mono
thf(fact_8018_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ S2 ) @ A2 )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ord_less_eq @ A @ X3 @ A2 ) ) ) ) ) ) ) ).

% cSup_le_iff
thf(fact_8019_cSup__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( B4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ! [B5: A] :
                  ( ( member @ A @ B5 @ B4 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A3 )
                      & ( ord_less_eq @ A @ B5 @ X5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ B4 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% cSup_mono
thf(fact_8020_cSup__upper2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X9: set @ A,Y: A] :
          ( ( member @ A @ X @ X9 )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( ( condit941137186595557371_above @ A @ X9 )
             => ( ord_less_eq @ A @ Y @ ( complete_Sup_Sup @ A @ X9 ) ) ) ) ) ) ).

% cSup_upper2
thf(fact_8021_cSup__upper,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X9: set @ A] :
          ( ( member @ A @ X @ X9 )
         => ( ( condit941137186595557371_above @ A @ X9 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X9 ) ) ) ) ) ).

% cSup_upper
thf(fact_8022_cSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: B,A3: set @ B,F3: B > A] :
          ( ( member @ B @ X @ A3 )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) )
           => ( ord_less_eq @ A @ ( F3 @ X ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ).

% cSUP_upper
thf(fact_8023_cSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F3: B > A,A3: set @ B,X: B,U: A] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) )
         => ( ( member @ B @ X @ A3 )
           => ( ( ord_less_eq @ A @ U @ ( F3 @ X ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ) ).

% cSUP_upper2
thf(fact_8024_bdd__above_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ B,F3: B > A,M7: A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less_eq @ A @ ( F3 @ X4 ) @ M7 ) )
         => ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ).

% bdd_above.I2
thf(fact_8025_cSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F3: B > A,U: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F3 @ A3 ) )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                   => ( ord_less_eq @ A @ ( F3 @ X3 ) @ U ) ) ) ) ) ) ) ).

% cSUP_le_iff
thf(fact_8026_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: C > A,B4: set @ C,F3: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ G @ B4 ) )
           => ( ! [N3: B] :
                  ( ( member @ B @ N3 @ A3 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ B4 )
                      & ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( G @ X5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ) ).

% cSUP_mono
thf(fact_8027_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ B4 )
           => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ) ).

% cSup_subset_mono
thf(fact_8028_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B,F3: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ G @ B4 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ A3 )
                   => ( ord_less_eq @ A @ ( F3 @ X4 ) @ ( G @ X4 ) ) )
               => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ) ) ).

% cSUP_subset_mono
thf(fact_8029_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( condit941137186595557371_above @ A @ A3 )
         => ( ( condit941137186595557371_above @ A @ B4 )
           => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ) ) ) ).

% cSup_inter_less_eq
thf(fact_8030_cSup__cInf,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S2 )
           => ( ( complete_Sup_Sup @ A @ S2 )
              = ( complete_Inf_Inf @ A
                @ ( collect @ A
                  @ ^ [X3: A] :
                    ! [Y6: A] :
                      ( ( member @ A @ Y6 @ S2 )
                     => ( ord_less_eq @ A @ Y6 @ X3 ) ) ) ) ) ) ) ) ).

% cSup_cInf
thf(fact_8031_prod__decode__triangle__add,axiom,
    ! [K: nat,M: nat] :
      ( ( nat_prod_decode @ ( plus_plus @ nat @ ( nat_triangle @ K ) @ M ) )
      = ( nat_prod_decode_aux @ K @ M ) ) ).

% prod_decode_triangle_add
thf(fact_8032_Max_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( lattic4895041142388067077er_set @ A @ ( ord_max @ A )
        @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 )
        @ ^ [X3: A,Y6: A] : ( ord_less @ A @ Y6 @ X3 ) ) ) ).

% Max.semilattice_order_set_axioms
thf(fact_8033_prod__decode__eq,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( nat_prod_decode @ X )
        = ( nat_prod_decode @ Y ) )
      = ( X = Y ) ) ).

% prod_decode_eq
thf(fact_8034_prod__encode__inverse,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( nat_prod_decode @ ( nat_prod_encode @ X ) )
      = X ) ).

% prod_encode_inverse
thf(fact_8035_prod__decode__inverse,axiom,
    ! [N: nat] :
      ( ( nat_prod_encode @ ( nat_prod_decode @ N ) )
      = N ) ).

% prod_decode_inverse
thf(fact_8036_inj__prod__decode,axiom,
    ! [A3: set @ nat] : ( inj_on @ nat @ ( product_prod @ nat @ nat ) @ nat_prod_decode @ A3 ) ).

% inj_prod_decode
thf(fact_8037_prod__decode__def,axiom,
    ( nat_prod_decode
    = ( nat_prod_decode_aux @ ( zero_zero @ nat ) ) ) ).

% prod_decode_def
thf(fact_8038_bij__prod__decode,axiom,
    bij_betw @ nat @ ( product_prod @ nat @ nat ) @ nat_prod_decode @ ( top_top @ ( set @ nat ) ) @ ( top_top @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

% bij_prod_decode
thf(fact_8039_surj__prod__decode,axiom,
    ( ( image @ nat @ ( product_prod @ nat @ nat ) @ nat_prod_decode @ ( top_top @ ( set @ nat ) ) )
    = ( top_top @ ( set @ ( product_prod @ nat @ nat ) ) ) ) ).

% surj_prod_decode
thf(fact_8040_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic4895041142388067077er_set @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% Inf_fin.semilattice_order_set_axioms
thf(fact_8041_Min_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( lattic4895041142388067077er_set @ A @ ( ord_min @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% Min.semilattice_order_set_axioms
thf(fact_8042_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( lattic4895041142388067077er_set @ A @ ( sup_sup @ A )
        @ ^ [X3: A,Y6: A] : ( ord_less_eq @ A @ Y6 @ X3 )
        @ ^ [X3: A,Y6: A] : ( ord_less @ A @ Y6 @ X3 ) ) ) ).

% Sup_fin.semilattice_order_set_axioms
thf(fact_8043_list__decode_Oelims,axiom,
    ! [X: nat,Y: list @ nat] :
      ( ( ( nat_list_decode @ X )
        = Y )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y
           != ( nil @ nat ) ) )
       => ~ ! [N3: nat] :
              ( ( X
                = ( suc @ N3 ) )
             => ( Y
               != ( product_case_prod @ nat @ nat @ ( list @ nat )
                  @ ^ [X3: nat,Y6: nat] : ( cons @ nat @ X3 @ ( nat_list_decode @ Y6 ) )
                  @ ( nat_prod_decode @ N3 ) ) ) ) ) ) ).

% list_decode.elims
thf(fact_8044_list__decode_Opinduct,axiom,
    ! [A0: nat,P: nat > $o] :
      ( ( accp @ nat @ nat_list_decode_rel @ A0 )
     => ( ( ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
       => ( ! [N3: nat] :
              ( ( accp @ nat @ nat_list_decode_rel @ ( suc @ N3 ) )
             => ( ! [X5: nat,Y4: nat] :
                    ( ( ( product_Pair @ nat @ nat @ X5 @ Y4 )
                      = ( nat_prod_decode @ N3 ) )
                   => ( P @ Y4 ) )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ A0 ) ) ) ) ).

% list_decode.pinduct
thf(fact_8045_list__decode__inverse,axiom,
    ! [N: nat] :
      ( ( nat_list_encode @ ( nat_list_decode @ N ) )
      = N ) ).

% list_decode_inverse
thf(fact_8046_list__encode__inverse,axiom,
    ! [X: list @ nat] :
      ( ( nat_list_decode @ ( nat_list_encode @ X ) )
      = X ) ).

% list_encode_inverse
thf(fact_8047_list__decode_Opsimps_I2_J,axiom,
    ! [N: nat] :
      ( ( accp @ nat @ nat_list_decode_rel @ ( suc @ N ) )
     => ( ( nat_list_decode @ ( suc @ N ) )
        = ( product_case_prod @ nat @ nat @ ( list @ nat )
          @ ^ [X3: nat,Y6: nat] : ( cons @ nat @ X3 @ ( nat_list_decode @ Y6 ) )
          @ ( nat_prod_decode @ N ) ) ) ) ).

% list_decode.psimps(2)
thf(fact_8048_list__decode_Opsimps_I1_J,axiom,
    ( ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) )
   => ( ( nat_list_decode @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ) ).

% list_decode.psimps(1)
thf(fact_8049_list__decode__eq,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( nat_list_decode @ X )
        = ( nat_list_decode @ Y ) )
      = ( X = Y ) ) ).

% list_decode_eq
thf(fact_8050_inj__list__decode,axiom,
    ! [A3: set @ nat] : ( inj_on @ nat @ ( list @ nat ) @ nat_list_decode @ A3 ) ).

% inj_list_decode
thf(fact_8051_list__decode_Osimps_I1_J,axiom,
    ( ( nat_list_decode @ ( zero_zero @ nat ) )
    = ( nil @ nat ) ) ).

% list_decode.simps(1)
thf(fact_8052_surj__list__decode,axiom,
    ( ( image @ nat @ ( list @ nat ) @ nat_list_decode @ ( top_top @ ( set @ nat ) ) )
    = ( top_top @ ( set @ ( list @ nat ) ) ) ) ).

% surj_list_decode
thf(fact_8053_bij__list__decode,axiom,
    bij_betw @ nat @ ( list @ nat ) @ nat_list_decode @ ( top_top @ ( set @ nat ) ) @ ( top_top @ ( set @ ( list @ nat ) ) ) ).

% bij_list_decode
thf(fact_8054_list__decode_Opelims,axiom,
    ! [X: nat,Y: list @ nat] :
      ( ( ( nat_list_decode @ X )
        = Y )
     => ( ( accp @ nat @ nat_list_decode_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y
                = ( nil @ nat ) )
             => ~ ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) ) ) )
         => ~ ! [N3: nat] :
                ( ( X
                  = ( suc @ N3 ) )
               => ( ( Y
                    = ( product_case_prod @ nat @ nat @ ( list @ nat )
                      @ ^ [X3: nat,Y6: nat] : ( cons @ nat @ X3 @ ( nat_list_decode @ Y6 ) )
                      @ ( nat_prod_decode @ N3 ) ) )
                 => ~ ( accp @ nat @ nat_list_decode_rel @ ( suc @ N3 ) ) ) ) ) ) ) ).

% list_decode.pelims
thf(fact_8055_list__decode_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( nat_list_decode @ ( suc @ N ) )
      = ( product_case_prod @ nat @ nat @ ( list @ nat )
        @ ^ [X3: nat,Y6: nat] : ( cons @ nat @ X3 @ ( nat_list_decode @ Y6 ) )
        @ ( nat_prod_decode @ N ) ) ) ).

% list_decode.simps(2)
thf(fact_8056_mono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ A3 @ I5 ) )
           => ( ( I5
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I5 ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image @ C @ B
                    @ ^ [X3: C] : ( F3 @ ( A3 @ X3 ) )
                    @ I5 ) ) ) ) ) ) ) ).

% mono_cINF
thf(fact_8057_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F3: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F3 )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( F3 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F3 @ A3 ) ) ) ) ) ) ) ).

% mono_cInf
thf(fact_8058_bdd__below_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,M7: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ( ord_less_eq @ A @ M7 @ X4 ) )
         => ( condit1013018076250108175_below @ A @ A3 ) ) ) ).

% bdd_below.I
thf(fact_8059_bdd__belowI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A,M: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ( ord_less_eq @ A @ M @ X4 ) )
         => ( condit1013018076250108175_below @ A @ A3 ) ) ) ).

% bdd_belowI
thf(fact_8060_cINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F3: B > A,A3: set @ B,X: B,U: A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) )
         => ( ( member @ B @ X @ A3 )
           => ( ( ord_less_eq @ A @ ( F3 @ X ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ U ) ) ) ) ) ).

% cINF_lower2
thf(fact_8061_cINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F3: B > A,A3: set @ B,X: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) )
         => ( ( member @ B @ X @ A3 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) @ ( F3 @ X ) ) ) ) ) ).

% cINF_lower
thf(fact_8062_bdd__below_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ B,M7: A,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less_eq @ A @ M7 @ ( F3 @ X4 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ).

% bdd_below.I2
thf(fact_8063_bdd__belowI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ B,M: A,F3: B > A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A3 )
             => ( ord_less_eq @ A @ M @ ( F3 @ X4 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ).

% bdd_belowI2
thf(fact_8064_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S2 )
           => ( ( ord_less_eq @ A @ A2 @ ( complete_Inf_Inf @ A @ S2 ) )
              = ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ord_less_eq @ A @ A2 @ X3 ) ) ) ) ) ) ) ).

% le_cInf_iff
thf(fact_8065_cInf__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( B4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A3 )
           => ( ! [B5: A] :
                  ( ( member @ A @ B5 @ B4 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A3 )
                      & ( ord_less_eq @ A @ X5 @ B5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ) ) ).

% cInf_mono
thf(fact_8066_cInf__lower2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X9: set @ A,Y: A] :
          ( ( member @ A @ X @ X9 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( condit1013018076250108175_below @ A @ X9 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X9 ) @ Y ) ) ) ) ) ).

% cInf_lower2
thf(fact_8067_cInf__lower,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X9: set @ A] :
          ( ( member @ A @ X @ X9 )
         => ( ( condit1013018076250108175_below @ A @ X9 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X9 ) @ X ) ) ) ) ).

% cInf_lower
thf(fact_8068_bdd__below__mono,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( condit1013018076250108175_below @ A @ A3 ) ) ) ) ).

% bdd_below_mono
thf(fact_8069_bdd__below_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A3: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A3 )
         => ~ ! [M10: A] :
                ~ ! [X5: A] :
                    ( ( member @ A @ X5 @ A3 )
                   => ( ord_less_eq @ A @ M10 @ X5 ) ) ) ) ).

% bdd_below.E
thf(fact_8070_bdd__below_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit1013018076250108175_below @ A )
        = ( ^ [A6: set @ A] :
            ? [M8: A] :
            ! [X3: A] :
              ( ( member @ A @ X3 @ A6 )
             => ( ord_less_eq @ A @ M8 @ X3 ) ) ) ) ) ).

% bdd_below.unfold
thf(fact_8071_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F3: B > A,U: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F3 @ A3 ) )
           => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) )
              = ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                   => ( ord_less_eq @ A @ U @ ( F3 @ X3 ) ) ) ) ) ) ) ) ).

% le_cINF_iff
thf(fact_8072_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B4: set @ B,F3: C > A,A3: set @ C,G: B > A] :
          ( ( B4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ F3 @ A3 ) )
           => ( ! [M2: B] :
                  ( ( member @ B @ M2 @ B4 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ A3 )
                      & ( ord_less_eq @ A @ ( F3 @ X5 ) @ ( G @ M2 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F3 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% cINF_mono
thf(fact_8073_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ B4 )
           => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ B4 ) @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ) ) ).

% cInf_superset_mono
thf(fact_8074_not__in__connected__cases,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A] :
          ( ( topolo1966860045006549960nected @ A @ S2 )
         => ( ~ ( member @ A @ X @ S2 )
           => ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( ( condit941137186595557371_above @ A @ S2 )
                 => ~ ! [Y4: A] :
                        ( ( member @ A @ Y4 @ S2 )
                       => ( ord_less_eq @ A @ Y4 @ X ) ) )
               => ~ ( ( condit1013018076250108175_below @ A @ S2 )
                   => ~ ! [Y4: A] :
                          ( ( member @ A @ Y4 @ S2 )
                         => ( ord_less_eq @ A @ X @ Y4 ) ) ) ) ) ) ) ) ).

% not_in_connected_cases
thf(fact_8075_cINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B,F3: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G @ B4 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ B4 )
                   => ( ord_less_eq @ A @ ( G @ X4 ) @ ( F3 @ X4 ) ) )
               => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F3 @ A3 ) ) ) ) ) ) ) ) ).

% cINF_superset_mono
thf(fact_8076_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A3 )
         => ( ( condit1013018076250108175_below @ A @ B4 )
           => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% less_eq_cInf_inter
thf(fact_8077_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A3 )
           => ( ( condit1013018076250108175_below @ A @ A3 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ) ).

% cInf_le_cSup
thf(fact_8078_cInf__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S2: set @ A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S2 )
           => ( ( complete_Inf_Inf @ A @ S2 )
              = ( complete_Sup_Sup @ A
                @ ( collect @ A
                  @ ^ [X3: A] :
                    ! [Y6: A] :
                      ( ( member @ A @ Y6 @ S2 )
                     => ( ord_less_eq @ A @ X3 @ Y6 ) ) ) ) ) ) ) ) ).

% cInf_cSup
thf(fact_8079_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ) ).

% Gcd_fin_def
thf(fact_8080_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_8081_char__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( unique5772411509450598832har_of @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( unique5772411509450598832har_of @ nat @ N ) ) ) ).

% char_of_nat
thf(fact_8082_bounded__quasi__semilattice__set_OF_Ocong,axiom,
    ! [A: $tType] :
      ( ( bounde2362111253966948842tice_F @ A )
      = ( bounde2362111253966948842tice_F @ A ) ) ).

% bounded_quasi_semilattice_set.F.cong
thf(fact_8083_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_8084_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_8085_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N2: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_8086_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A2: A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( member @ A @ A2 @ A3 )
       => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 )
          = ( F3 @ A2 @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% bounded_quasi_semilattice_set.remove
thf(fact_8087_char_Osize_I2_J,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_size @ char @ ( char2 @ X15 @ X2 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size(2)
thf(fact_8088_bounded__quasi__semilattice__set_Osubset,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,B4: set @ A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( F3 @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ B4 ) @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) )
          = ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) ) ) ) ).

% bounded_quasi_semilattice_set.subset
thf(fact_8089_bounded__quasi__semilattice__set_Oinfinite,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ~ ( finite_finite @ A @ A3 )
       => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 )
          = Bot ) ) ) ).

% bounded_quasi_semilattice_set.infinite
thf(fact_8090_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ ( bot_bot @ ( set @ A ) ) )
        = Top ) ) ).

% bounded_quasi_semilattice_set.empty
thf(fact_8091_bounded__quasi__semilattice__set_Onormalize,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( Normalize @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) )
        = ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) ) ) ).

% bounded_quasi_semilattice_set.normalize
thf(fact_8092_bounded__quasi__semilattice__set_Oin__idem,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A2: A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( member @ A @ A2 @ A3 )
       => ( ( F3 @ A2 @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) )
          = ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) ) ) ) ).

% bounded_quasi_semilattice_set.in_idem
thf(fact_8093_bounded__quasi__semilattice__set_Oinsert,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A2: A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ ( insert @ A @ A2 @ A3 ) )
        = ( F3 @ A2 @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) ) ) ) ).

% bounded_quasi_semilattice_set.insert
thf(fact_8094_bounded__quasi__semilattice__set_Ounion,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A3: set @ A,B4: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
        = ( F3 @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 ) @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ B4 ) ) ) ) ).

% bounded_quasi_semilattice_set.union
thf(fact_8095_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A2: A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ ( insert @ A @ A2 @ A3 ) )
        = ( F3 @ A2 @ ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
thf(fact_8096_integer__of__char__code,axiom,
    ! [B0: $o,B18: $o,B24: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B18 @ B24 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B24 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B18 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_8097_char_Osize__gen,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_char @ ( char2 @ X15 @ X2 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size_gen
thf(fact_8098_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_8099_gen__length__def,axiom,
    ! [A: $tType] :
      ( ( gen_length @ A )
      = ( ^ [N2: nat,Xs: list @ A] : ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% gen_length_def
thf(fact_8100_gen__length__code_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs2: list @ B] :
      ( ( gen_length @ B @ N @ ( cons @ B @ X @ Xs2 ) )
      = ( gen_length @ B @ ( suc @ N ) @ Xs2 ) ) ).

% gen_length_code(2)
thf(fact_8101_length__code,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( gen_length @ A @ ( zero_zero @ nat ) ) ) ).

% length_code
thf(fact_8102_compute__powr__real,axiom,
    ( powr_real
    = ( ^ [B3: real,I3: real] :
          ( if @ real @ ( ord_less_eq @ real @ B3 @ ( zero_zero @ real ) )
          @ ( abort @ real @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $true @ $false @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( zero_zero @ literal ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
            @ ^ [Uu2: product_unit] : ( powr_real @ B3 @ I3 ) )
          @ ( if @ real
            @ ( ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ I3 ) )
              = I3 )
            @ ( if @ real @ ( ord_less_eq @ real @ ( zero_zero @ real ) @ I3 ) @ ( power_power @ real @ B3 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ I3 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ B3 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ I3 ) ) ) ) ) )
            @ ( abort @ real @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $true @ $false @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $true @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( zero_zero @ literal ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
              @ ^ [Uu2: product_unit] : ( powr_real @ B3 @ I3 ) ) ) ) ) ) ).

% compute_powr_real
thf(fact_8103_integer__of__nat_Orep__eq,axiom,
    ! [X: nat] :
      ( ( code_int_of_integer @ ( code_integer_of_nat @ X ) )
      = ( semiring_1_of_nat @ int @ X ) ) ).

% integer_of_nat.rep_eq
thf(fact_8104_int__of__integer__integer__of__nat,axiom,
    ! [N: nat] :
      ( ( code_int_of_integer @ ( code_integer_of_nat @ N ) )
      = ( semiring_1_of_nat @ int @ N ) ) ).

% int_of_integer_integer_of_nat
thf(fact_8105_String_Oempty__neq__Literal,axiom,
    ! [B0: $o,B18: $o,B24: $o,B32: $o,B42: $o,B52: $o,B62: $o,S: literal] :
      ( ( zero_zero @ literal )
     != ( literal2 @ B0 @ B18 @ B24 @ B32 @ B42 @ B52 @ B62 @ S ) ) ).

% String.empty_neq_Literal
thf(fact_8106_powr__real__def,axiom,
    ( powr_real
    = ( powr @ real ) ) ).

% powr_real_def
thf(fact_8107_integer__of__nat__0,axiom,
    ( ( code_integer_of_nat @ ( zero_zero @ nat ) )
    = ( zero_zero @ code_integer ) ) ).

% integer_of_nat_0
thf(fact_8108_integer__of__nat_Oabs__eq,axiom,
    ( code_integer_of_nat
    = ( ^ [X3: nat] : ( code_integer_of_int @ ( semiring_1_of_nat @ int @ X3 ) ) ) ) ).

% integer_of_nat.abs_eq
thf(fact_8109_integer__of__nat__1,axiom,
    ( ( code_integer_of_nat @ ( one_one @ nat ) )
    = ( one_one @ code_integer ) ) ).

% integer_of_nat_1
thf(fact_8110_divmod__nat__code,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N2: nat] :
          ( product_map_prod @ code_integer @ nat @ code_integer @ nat @ code_nat_of_integer @ code_nat_of_integer
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( ( code_integer_of_nat @ M3 )
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( ( code_integer_of_nat @ N2 )
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( code_integer_of_nat @ M3 ) )
              @ ( code_divmod_abs @ ( code_integer_of_nat @ M3 ) @ ( code_integer_of_nat @ N2 ) ) ) ) ) ) ) ).

% divmod_nat_code
thf(fact_8111_integer__of__nat__def,axiom,
    ( code_integer_of_nat
    = ( map_fun @ nat @ nat @ int @ code_integer @ ( id @ nat ) @ code_integer_of_int @ ( semiring_1_of_nat @ int ) ) ) ).

% integer_of_nat_def
thf(fact_8112_uniformity__Abort,axiom,
    ! [A: $tType] :
      ( ( topolo4638772830378233104ormity @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( abstract_filter @ ( product_prod @ A @ A )
          @ ^ [U2: product_unit] :
              ( abort @ ( filter @ ( product_prod @ A @ A ) ) @ ( literal2 @ $true @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( zero_zero @ literal ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
              @ ^ [V5: product_unit] : ( topolo7806501430040627800ormity @ A ) ) ) ) ) ).

% uniformity_Abort
thf(fact_8113_card__def,axiom,
    ! [B: $tType] :
      ( ( finite_card @ B )
      = ( finite_folding_F @ B @ nat
        @ ^ [Uu2: B] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card_def
thf(fact_8114_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_folding_F @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
            = ( F3 @ X @ ( finite_folding_F @ A @ B @ F3 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% folding_on.insert_remove
thf(fact_8115_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,A3: set @ A,X: A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( finite_folding_F @ A @ B @ F3 @ Z @ A3 )
              = ( F3 @ X @ ( finite_folding_F @ A @ B @ F3 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% folding_on.remove
thf(fact_8116_card_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( finite_folding_on @ A @ nat @ ( top_top @ ( set @ A ) )
      @ ^ [Uu2: A] : suc ) ).

% card.folding_on_axioms
thf(fact_8117_folding__on_Oinsert,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_folding_F @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
              = ( F3 @ X @ ( finite_folding_F @ A @ B @ F3 @ Z @ A3 ) ) ) ) ) ) ) ).

% folding_on.insert
thf(fact_8118_folding__idem__on_Oinsert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite1890593828518410140dem_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_folding_F @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
            = ( F3 @ X @ ( finite_folding_F @ A @ B @ F3 @ Z @ A3 ) ) ) ) ) ) ).

% folding_idem_on.insert_idem
thf(fact_8119_rel__fun__iff__geq__image2p,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType] :
      ( ( bNF_rel_fun @ A @ B @ C @ D )
      = ( ^ [R6: A > B > $o,S7: C > D > $o,F5: A > C,G2: B > D] : ( ord_less_eq @ ( C > D > $o ) @ ( bNF_Greatest_image2p @ A @ C @ B @ D @ F5 @ G2 @ R6 ) @ S7 ) ) ) ).

% rel_fun_iff_geq_image2p
thf(fact_8120_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( ^ [A6: set @ A] : ( if @ A @ ( finite_finite @ A @ A6 ) @ ( finite_fold @ A @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ A6 ) @ ( one_one @ A ) ) ) ) ) ).

% Gcd_fin.eq_fold
thf(fact_8121_tendsto__add__Pair,axiom,
    ! [A: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [A2: A,B2: A] :
          ( filterlim @ ( product_prod @ A @ A ) @ A
          @ ^ [X3: product_prod @ A @ A] : ( plus_plus @ A @ ( product_fst @ A @ A @ X3 ) @ ( product_snd @ A @ A @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          @ ( prod_filter @ A @ A @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( topolo7230453075368039082e_nhds @ A @ B2 ) ) ) ) ).

% tendsto_add_Pair
thf(fact_8122_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu2: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_8123_minus__fold__remove,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ B4 @ A3 )
        = ( finite_fold @ A @ ( set @ A ) @ ( remove @ A ) @ B4 @ A3 ) ) ) ).

% minus_fold_remove
thf(fact_8124_filtermap__Pair,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: C > A,G: C > B,F6: filter @ C] :
      ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) )
      @ ( filtermap @ C @ ( product_prod @ A @ B )
        @ ^ [X3: C] : ( product_Pair @ A @ B @ ( F3 @ X3 ) @ ( G @ X3 ) )
        @ F6 )
      @ ( prod_filter @ A @ B @ ( filtermap @ C @ A @ F3 @ F6 ) @ ( filtermap @ C @ B @ G @ F6 ) ) ) ).

% filtermap_Pair
thf(fact_8125_prod__filter__mono__iff,axiom,
    ! [A: $tType,B: $tType,A3: filter @ A,B4: filter @ B,C5: filter @ A,D3: filter @ B] :
      ( ( A3
       != ( bot_bot @ ( filter @ A ) ) )
     => ( ( B4
         != ( bot_bot @ ( filter @ B ) ) )
       => ( ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) ) @ ( prod_filter @ A @ B @ A3 @ B4 ) @ ( prod_filter @ A @ B @ C5 @ D3 ) )
          = ( ( ord_less_eq @ ( filter @ A ) @ A3 @ C5 )
            & ( ord_less_eq @ ( filter @ B ) @ B4 @ D3 ) ) ) ) ) ).

% prod_filter_mono_iff
thf(fact_8126_prod__filter__mono,axiom,
    ! [A: $tType,B: $tType,F6: filter @ A,F13: filter @ A,G6: filter @ B,G7: filter @ B] :
      ( ( ord_less_eq @ ( filter @ A ) @ F6 @ F13 )
     => ( ( ord_less_eq @ ( filter @ B ) @ G6 @ G7 )
       => ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) ) @ ( prod_filter @ A @ B @ F6 @ G6 ) @ ( prod_filter @ A @ B @ F13 @ G7 ) ) ) ) ).

% prod_filter_mono
thf(fact_8127_filtermap__snd__prod__filter,axiom,
    ! [B: $tType,A: $tType,A3: filter @ B,B4: filter @ A] : ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( prod_filter @ B @ A @ A3 @ B4 ) ) @ B4 ) ).

% filtermap_snd_prod_filter
thf(fact_8128_filtermap__fst__prod__filter,axiom,
    ! [B: $tType,A: $tType,A3: filter @ A,B4: filter @ B] : ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( prod_filter @ A @ B @ A3 @ B4 ) ) @ A3 ) ).

% filtermap_fst_prod_filter
thf(fact_8129_cauchy__filter__def,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F10: filter @ A] : ( ord_less_eq @ ( filter @ ( product_prod @ A @ A ) ) @ ( prod_filter @ A @ A @ F10 @ F10 ) @ ( topolo7806501430040627800ormity @ A ) ) ) ) ) ).

% cauchy_filter_def
thf(fact_8130_bounded__quasi__semilattice__set_Oeq__fold,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,A3: set @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( ( finite_finite @ A @ A3 )
         => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 )
            = ( finite_fold @ A @ A @ F3 @ Top @ A3 ) ) )
        & ( ~ ( finite_finite @ A @ A3 )
         => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ A3 )
            = Bot ) ) ) ) ).

% bounded_quasi_semilattice_set.eq_fold
thf(fact_8131_eventually__prod__sequentially,axiom,
    ! [P: ( product_prod @ nat @ nat ) > $o] :
      ( ( eventually @ ( product_prod @ nat @ nat ) @ P @ ( prod_filter @ nat @ nat @ ( at_top @ nat ) @ ( at_top @ nat ) ) )
      = ( ? [N7: nat] :
          ! [M3: nat] :
            ( ( ord_less_eq @ nat @ N7 @ M3 )
           => ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N2 )
               => ( P @ ( product_Pair @ nat @ nat @ N2 @ M3 ) ) ) ) ) ) ).

% eventually_prod_sequentially
thf(fact_8132_le__prod__filterI,axiom,
    ! [A: $tType,B: $tType,F6: filter @ ( product_prod @ A @ B ),A3: filter @ A,B4: filter @ B] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( filtermap @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ F6 ) @ A3 )
     => ( ( ord_less_eq @ ( filter @ B ) @ ( filtermap @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ F6 ) @ B4 )
       => ( ord_less_eq @ ( filter @ ( product_prod @ A @ B ) ) @ F6 @ ( prod_filter @ A @ B @ A3 @ B4 ) ) ) ) ).

% le_prod_filterI
thf(fact_8133_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_8134_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G2 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_8135_comp__fun__idem__on_Ofold__insert__idem2,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
            = ( finite_fold @ A @ B @ F3 @ ( F3 @ X @ Z ) @ A3 ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem2
thf(fact_8136_comp__fun__idem__on_Ofold__insert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
            = ( F3 @ X @ ( finite_fold @ A @ B @ F3 @ Z @ A3 ) ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem
thf(fact_8137_tendsto__mult__Pair,axiom,
    ! [A: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [A2: A,B2: A] :
          ( filterlim @ ( product_prod @ A @ A ) @ A
          @ ^ [X3: product_prod @ A @ A] : ( times_times @ A @ ( product_fst @ A @ A @ X3 ) @ ( product_snd @ A @ A @ X3 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
          @ ( prod_filter @ A @ A @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( topolo7230453075368039082e_nhds @ A @ B2 ) ) ) ) ).

% tendsto_mult_Pair
thf(fact_8138_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,A3: set @ A,B4: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ S2 )
         => ( ( finite_finite @ A @ A3 )
           => ( ( finite_finite @ A @ B4 )
             => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F3 @ Z @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
                  = ( finite_fold @ A @ B @ F3 @ ( finite_fold @ A @ B @ F3 @ Z @ A3 ) @ B4 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_8139_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,A3: set @ A,X: A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F3 @ Z @ A3 )
              = ( F3 @ X @ ( finite_fold @ A @ B @ F3 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_8140_comp__fun__commute__on_Ocomp__fun__commute__on__funpow,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,G: A > nat] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( finite4664212375090638736ute_on @ A @ B @ S2
        @ ^ [X3: A] : ( compow @ ( B > B ) @ ( G @ X3 ) @ ( F3 @ X3 ) ) ) ) ).

% comp_fun_commute_on.comp_fun_commute_on_funpow
thf(fact_8141_Finite__Set_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,G: A > B > B,A3: set @ A,S: B,T2: B,B4: set @ A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ G )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
         => ( ( finite_finite @ A @ A3 )
           => ( ! [X4: A] :
                  ( ( member @ A @ X4 @ A3 )
                 => ( ( F3 @ X4 )
                    = ( G @ X4 ) ) )
             => ( ( S = T2 )
               => ( ( A3 = B4 )
                 => ( ( finite_fold @ A @ B @ F3 @ S @ A3 )
                    = ( finite_fold @ A @ B @ G @ T2 @ B4 ) ) ) ) ) ) ) ) ) ).

% Finite_Set.fold_cong
thf(fact_8142_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F3: A > B > B,G: C > A,R2: set @ C] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite4664212375090638736ute_on @ C @ B @ R2 @ ( comp @ A @ ( B > B ) @ C @ F3 @ G ) ) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
thf(fact_8143_comp__fun__commute__on_Ofold__fun__left__comm,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( F3 @ X @ ( finite_fold @ A @ B @ F3 @ Z @ A3 ) )
            = ( finite_fold @ A @ B @ F3 @ ( F3 @ X @ Z ) @ A3 ) ) ) ) ) ).

% comp_fun_commute_on.fold_fun_left_comm
thf(fact_8144_comp__fun__commute__on_Ofold__insert2,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
              = ( finite_fold @ A @ B @ F3 @ ( F3 @ X @ Z ) @ A3 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert2
thf(fact_8145_comp__fun__commute__on_Ofold__insert,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
              = ( F3 @ X @ ( finite_fold @ A @ B @ F3 @ Z @ A3 ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert
thf(fact_8146_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) )
            = ( F3 @ X @ ( finite_fold @ A @ B @ F3 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_8147_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F3: A > B > B,A3: set @ A,Z: B,Y: B,A2: A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F3 @ Z @ A3 @ Y )
         => ( ( member @ A @ A2 @ A3 )
           => ? [Y10: B] :
                ( ( Y
                  = ( F3 @ A2 @ Y10 ) )
                & ( finite_fold_graph @ A @ B @ F3 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ Y10 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
thf(fact_8148_comp__fun__commute__on_Ofold__graph__fold,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F3: A > B > B,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( finite_fold_graph @ A @ B @ F3 @ Z @ A3 @ ( finite_fold @ A @ B @ F3 @ Z @ A3 ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_fold
thf(fact_8149_comp__fun__commute__on_Ofold__graph__determ,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F3: A > B > B,A3: set @ A,Z: B,X: B,Y: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F3 @ Z @ A3 @ X )
         => ( ( finite_fold_graph @ A @ B @ F3 @ Z @ A3 @ Y )
           => ( Y = X ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_determ
thf(fact_8150_comp__fun__commute__on_Ofold__graph__insertE,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F3: A > B > B,X: A,A3: set @ A,Z: B,V: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F3 @ Z @ ( insert @ A @ X @ A3 ) @ V )
         => ( ~ ( member @ A @ X @ A3 )
           => ~ ! [Y3: B] :
                  ( ( V
                    = ( F3 @ X @ Y3 ) )
                 => ~ ( finite_fold_graph @ A @ B @ F3 @ Z @ A3 @ Y3 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE
thf(fact_8151_comp__fun__commute__on_Ofold__equality,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F3: A > B > B,A3: set @ A,Z: B,Y: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_fold_graph @ A @ B @ F3 @ Z @ A3 @ Y )
         => ( ( finite_fold @ A @ B @ F3 @ Z @ A3 )
            = Y ) ) ) ) ).

% comp_fun_commute_on.fold_equality
thf(fact_8152_Gcd__int__set__eq__fold,axiom,
    ! [Xs2: list @ int] :
      ( ( gcd_Gcd @ int @ ( set2 @ int @ Xs2 ) )
      = ( fold @ int @ int @ ( gcd_gcd @ int ) @ Xs2 @ ( zero_zero @ int ) ) ) ).

% Gcd_int_set_eq_fold
thf(fact_8153_numeral__le__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ).

% numeral_le_enat_iff
thf(fact_8154_enat__ord__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% enat_ord_simps(1)
thf(fact_8155_plus__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( plus_plus @ nat @ M @ N ) ) ) ).

% plus_enat_simps(1)
thf(fact_8156_fold__replicate,axiom,
    ! [A: $tType,B: $tType,F3: B > A > A,N: nat,X: B] :
      ( ( fold @ B @ A @ F3 @ ( replicate @ B @ N @ X ) )
      = ( compow @ ( A > A ) @ N @ ( F3 @ X ) ) ) ).

% fold_replicate
thf(fact_8157_idiff__enat__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( extended_enat2 @ ( zero_zero @ nat ) ) )
      = N ) ).

% idiff_enat_0_right
thf(fact_8158_idiff__enat__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ ( zero_zero @ nat ) ) @ N )
      = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% idiff_enat_0
thf(fact_8159_idiff__enat__enat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ A2 ) @ ( extended_enat2 @ B2 ) )
      = ( extended_enat2 @ ( minus_minus @ nat @ A2 @ B2 ) ) ) ).

% idiff_enat_enat
thf(fact_8160_times__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( times_times @ nat @ M @ N ) ) ) ).

% times_enat_simps(1)
thf(fact_8161_one__enat__def,axiom,
    ( ( one_one @ extended_enat )
    = ( extended_enat2 @ ( one_one @ nat ) ) ) ).

% one_enat_def
thf(fact_8162_enat__1__iff_I1_J,axiom,
    ! [X: nat] :
      ( ( ( extended_enat2 @ X )
        = ( one_one @ extended_enat ) )
      = ( X
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(1)
thf(fact_8163_enat__1__iff_I2_J,axiom,
    ! [X: nat] :
      ( ( ( one_one @ extended_enat )
        = ( extended_enat2 @ X ) )
      = ( X
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(2)
thf(fact_8164_fold__plus__sum__list__rev,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ A] :
          ( ( fold @ A @ A @ ( plus_plus @ A ) @ Xs2 )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( rev @ A @ Xs2 ) ) ) ) ) ).

% fold_plus_sum_list_rev
thf(fact_8165_enat__0__iff_I2_J,axiom,
    ! [X: nat] :
      ( ( ( zero_zero @ extended_enat )
        = ( extended_enat2 @ X ) )
      = ( X
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(2)
thf(fact_8166_enat__0__iff_I1_J,axiom,
    ! [X: nat] :
      ( ( ( extended_enat2 @ X )
        = ( zero_zero @ extended_enat ) )
      = ( X
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(1)
thf(fact_8167_zero__enat__def,axiom,
    ( ( zero_zero @ extended_enat )
    = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% zero_enat_def
thf(fact_8168_Suc__ile__eq,axiom,
    ! [M: nat,N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ ( suc @ M ) ) @ N )
      = ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ N ) ) ).

% Suc_ile_eq
thf(fact_8169_finite__enat__bounded,axiom,
    ! [A3: set @ extended_enat,N: nat] :
      ( ! [Y3: extended_enat] :
          ( ( member @ extended_enat @ Y3 @ A3 )
         => ( ord_less_eq @ extended_enat @ Y3 @ ( extended_enat2 @ N ) ) )
     => ( finite_finite @ extended_enat @ A3 ) ) ).

% finite_enat_bounded
thf(fact_8170_enat__ile,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K3: nat] :
          ( N
          = ( extended_enat2 @ K3 ) ) ) ).

% enat_ile
thf(fact_8171_bounded__quasi__semilattice__set_Oset__eq__fold,axiom,
    ! [A: $tType,F3: A > A > A,Top: A,Bot: A,Normalize: A > A,Xs2: list @ A] :
      ( ( bounde6485984586167503788ce_set @ A @ F3 @ Top @ Bot @ Normalize )
     => ( ( bounde2362111253966948842tice_F @ A @ F3 @ Top @ Bot @ ( set2 @ A @ Xs2 ) )
        = ( fold @ A @ A @ F3 @ Xs2 @ Top ) ) ) ).

% bounded_quasi_semilattice_set.set_eq_fold
thf(fact_8172_iadd__le__enat__iff,axiom,
    ! [X: extended_enat,Y: extended_enat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ ( extended_enat2 @ N ) )
      = ( ? [Y7: nat,X10: nat] :
            ( ( X
              = ( extended_enat2 @ X10 ) )
            & ( Y
              = ( extended_enat2 @ Y7 ) )
            & ( ord_less_eq @ nat @ ( plus_plus @ nat @ X10 @ Y7 ) @ N ) ) ) ) ).

% iadd_le_enat_iff
thf(fact_8173_Gcd__set__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [Xs2: list @ A] :
          ( ( gcd_Gcd @ A @ ( set2 @ A @ Xs2 ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs2 @ ( zero_zero @ A ) ) ) ) ).

% Gcd_set_eq_fold
thf(fact_8174_Gcd__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs2: list @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Xs2 ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs2 @ ( zero_zero @ A ) ) ) ) ).

% Gcd_fin.set_eq_fold
thf(fact_8175_comp__fun__idem__on_Ofold__set__fold,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F3: A > B > B,Xs2: list @ A,Y: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ S2 )
       => ( ( finite_fold @ A @ B @ F3 @ Y @ ( set2 @ A @ Xs2 ) )
          = ( fold @ A @ B @ F3 @ Xs2 @ Y ) ) ) ) ).

% comp_fun_idem_on.fold_set_fold
thf(fact_8176_comp__fun__commute__on_Ofold__set__fold__remdups,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F3: A > B > B,Xs2: list @ A,Y: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ S2 )
       => ( ( finite_fold @ A @ B @ F3 @ Y @ ( set2 @ A @ Xs2 ) )
          = ( fold @ A @ B @ F3 @ ( remdups @ A @ Xs2 ) @ Y ) ) ) ) ).

% comp_fun_commute_on.fold_set_fold_remdups
thf(fact_8177_times__enat__simps_I4_J,axiom,
    ! [M: nat] :
      ( ( ( M
          = ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ( M
         != ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% times_enat_simps(4)
thf(fact_8178_enat__ord__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q2 )
      = ( Q2
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% enat_ord_simps(5)
thf(fact_8179_enat__ord__code_I3_J,axiom,
    ! [Q2: extended_enat] : ( ord_less_eq @ extended_enat @ Q2 @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_code(3)
thf(fact_8180_idiff__infinity,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ N )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% idiff_infinity
thf(fact_8181_times__enat__simps_I2_J,axiom,
    ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extend4730790105801354508finity @ extended_enat ) )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% times_enat_simps(2)
thf(fact_8182_length__remdups__leq,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_remdups_leq

% Type constructors (797)
thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_2,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( filter @ A11 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_3,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_4,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( set @ A11 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_5,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( bounded_lattice @ A27 )
     => ( bounded_lattice @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( comple592849572758109894attice @ A27 )
     => ( counta4013691401010221786attice @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( comple6319245703460814977attice @ A27 )
     => ( condit1219197933456340205attice @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( counta3822494911875563373attice @ A27 )
     => ( counta3822494911875563373attice @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( comple592849572758109894attice @ A27 )
     => ( comple592849572758109894attice @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( bounded_lattice @ A27 )
     => ( bounde4967611905675639751up_bot @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( bounded_lattice @ A27 )
     => ( bounde4346867609351753570nf_top @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( comple6319245703460814977attice @ A27 )
     => ( comple6319245703460814977attice @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( boolea8198339166811842893lgebra @ A27 )
     => ( boolea8198339166811842893lgebra @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( semilattice_sup @ A27 )
     => ( semilattice_sup @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( semilattice_inf @ A27 )
     => ( semilattice_inf @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( order_top @ A27 )
     => ( order_top @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( order_bot @ A27 )
     => ( order_bot @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( preorder @ A27 )
     => ( preorder @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( lattice @ A27 )
     => ( lattice @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( order @ A27 )
     => ( order @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( ord @ A27 )
     => ( ord @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( uminus @ A27 )
     => ( uminus @ ( A11 > A27 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( minus @ A27 )
     => ( minus @ ( A11 > A27 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_7,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_8,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___Groups_Ominus_14,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_23,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_24,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_25,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_26,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_27,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_28,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_29,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_30,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_31,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_32,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_33,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_34,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_35,axiom,
    topolo4987421752381908075d_mult @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_36,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_37,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_38,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_39,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_40,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_41,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_42,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_43,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_44,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_45,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_46,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_47,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_48,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_49,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_50,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_51,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_52,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_53,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_54,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_55,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_56,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_57,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_58,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_59,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_60,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_61,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_62,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_63,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_64,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_65,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_66,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_67,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_68,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_69,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_70,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_71,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_72,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_73,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_74,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_75,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_76,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_77,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_78,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_79,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_80,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_81,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_82,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_83,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_84,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_85,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_86,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_87,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_88,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_89,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_90,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_91,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_92,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_93,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_94,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_95,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_96,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_97,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_98,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_99,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_100,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_101,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_102,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_103,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_104,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_105,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_106,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_107,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_108,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_109,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_110,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_111,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_112,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_113,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_114,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_115,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_116,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_117,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_118,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_119,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_120,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_121,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_122,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_123,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_124,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_125,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_126,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_127,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_128,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_129,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_130,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_131,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_132,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_133,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_134,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_135,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_136,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_137,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_138,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_139,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_140,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_141,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_142,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_143,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_144,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_145,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_146,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_147,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_148,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_149,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_150,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_151,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_152,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_153,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_154,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_155,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_156,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_157,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_158,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_159,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_160,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_161,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_162,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_163,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_164,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_165,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_166,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_167,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_168,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_169,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_170,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_171,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_172,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_173,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_174,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_175,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_176,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_177,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_178,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_179,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_180,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_181,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_182,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_183,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_184,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_185,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_186,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_187,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_188,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_189,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_190,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_191,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_192,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_193,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_194,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_195,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_196,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_197,axiom,
    ! [A11: $tType] : ( counta4013691401010221786attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_198,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_199,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_200,axiom,
    ! [A11: $tType] : ( comple592849572758109894attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_201,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_202,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_203,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_204,axiom,
    ! [A11: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_205,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_206,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_207,axiom,
    ! [A11: $tType] : ( order_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_208,axiom,
    ! [A11: $tType] : ( order_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_209,axiom,
    ! [A11: $tType] : ( preorder @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_210,axiom,
    ! [A11: $tType] : ( lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_211,axiom,
    ! [A11: $tType] : ( order @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_212,axiom,
    ! [A11: $tType] : ( ord @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_213,axiom,
    ! [A11: $tType] : ( uminus @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_214,axiom,
    ! [A11: $tType] : ( minus @ ( set @ A11 ) ) ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_215,axiom,
    counta4013691401010221786attice @ $o ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_216,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_217,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_218,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_219,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_220,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_221,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_222,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_223,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_224,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_225,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_226,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_227,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_228,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_229,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_230,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_231,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_232,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_233,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_234,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_235,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_236,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_237,axiom,
    minus @ $o ).

thf(tcon_List_Olist___Nat_Osize_238,axiom,
    ! [A11: $tType] : ( size @ ( list @ A11 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_239,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_240,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_241,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_242,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_243,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_244,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_245,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_246,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_247,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_248,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_249,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_250,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_251,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_252,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_253,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_254,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_255,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_256,axiom,
    linord4140545234300271783up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_257,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_258,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_259,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_260,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_261,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_262,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_263,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_264,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_265,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_266,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_267,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_268,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniformity,axiom,
    topolo4638772830378233104ormity @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_269,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_270,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_271,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_272,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_273,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Odist__norm,axiom,
    real_V6936659425649961206t_norm @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_274,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_275,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_276,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_277,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_278,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_279,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_280,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_281,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_282,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_283,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_284,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_285,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_286,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_287,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_288,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_289,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_290,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_291,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_292,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_293,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_294,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_295,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_296,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_297,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_298,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_299,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_300,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_301,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_302,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_303,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_304,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_305,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_306,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_307,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_308,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_309,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_310,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_311,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_312,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_313,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_314,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_315,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_316,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_317,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_318,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_319,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_320,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_321,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_322,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_323,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_324,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_325,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_326,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_327,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_328,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_329,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_330,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_331,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_332,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_333,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_334,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Groups_Ominus_335,axiom,
    minus @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_336,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_337,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_338,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_339,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_340,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_341,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_342,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_343,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_344,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_345,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_346,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_347,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_348,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_349,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_350,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_351,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_352,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_353,axiom,
    ! [A11: $tType] : ( order_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_354,axiom,
    ! [A11: $tType] : ( order_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_355,axiom,
    ! [A11: $tType] : ( preorder @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_356,axiom,
    ! [A11: $tType] : ( lattice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_357,axiom,
    ! [A11: $tType] : ( order @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_358,axiom,
    ! [A11: $tType] : ( ord @ ( filter @ A11 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_359,axiom,
    ! [A11: $tType] : ( size @ ( option @ A11 ) ) ).

thf(tcon_String_Oliteral___Groups_Osemigroup__add_360,axiom,
    semigroup_add @ literal ).

thf(tcon_String_Oliteral___Orderings_Opreorder_361,axiom,
    preorder @ literal ).

thf(tcon_String_Oliteral___Orderings_Olinorder_362,axiom,
    linorder @ literal ).

thf(tcon_String_Oliteral___Groups_Omonoid__add_363,axiom,
    monoid_add @ literal ).

thf(tcon_String_Oliteral___Orderings_Oorder_364,axiom,
    order @ literal ).

thf(tcon_String_Oliteral___Orderings_Oord_365,axiom,
    ord @ literal ).

thf(tcon_String_Oliteral___Groups_Ozero_366,axiom,
    zero @ literal ).

thf(tcon_String_Oliteral___Groups_Oplus_367,axiom,
    plus @ literal ).

thf(tcon_String_Oliteral___Nat_Osize_368,axiom,
    size @ literal ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_369,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_370,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_371,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_372,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_373,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_374,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_375,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_376,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_377,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_378,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_379,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_380,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_381,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_382,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_383,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_384,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_385,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_386,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_387,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_388,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_389,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_390,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_391,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_392,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniformity_393,axiom,
    topolo4638772830378233104ormity @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_394,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_395,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_396,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_397,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_398,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Odist__norm_399,axiom,
    real_V6936659425649961206t_norm @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_400,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_401,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_402,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_403,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_404,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_405,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_406,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_407,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_408,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_409,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_410,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_411,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_412,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_413,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_414,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_415,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_416,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_417,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_418,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_419,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_420,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_421,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_422,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_423,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_424,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_425,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_426,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_427,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_428,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_429,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_430,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_431,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_432,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_433,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_434,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_435,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_436,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_437,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ominus_438,axiom,
    minus @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_439,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_440,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_441,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_442,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_443,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_444,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_445,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_446,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_447,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_448,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_449,axiom,
    counta4013691401010221786attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_450,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_451,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_452,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_453,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_454,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_455,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_456,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_457,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_458,axiom,
    linord4140545234300271783up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_459,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_460,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_461,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_462,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_463,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_464,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_465,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_466,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_467,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_468,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_469,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_470,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_471,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_472,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_473,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_474,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_475,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_476,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_477,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_478,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_479,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_480,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_481,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_482,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_483,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_484,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_485,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_486,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_487,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_488,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_489,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_490,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_491,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_492,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_493,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_494,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ominus_495,axiom,
    minus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_496,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_497,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_498,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_499,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_500,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_501,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_502,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( ( topolo4958980785337419405_space @ A11 )
        & ( topolo4958980785337419405_space @ A27 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A11 @ A27 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_503,axiom,
    ! [A11: $tType,A27: $tType] :
      ( ( ( topological_t2_space @ A11 )
        & ( topological_t2_space @ A27 ) )
     => ( topological_t2_space @ ( product_prod @ A11 @ A27 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_504,axiom,
    ! [A11: $tType,A27: $tType] : ( size @ ( product_prod @ A11 @ A27 ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_505,axiom,
    condit6923001295902523014norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_506,axiom,
    counta4013691401010221786attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_507,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__lattice_508,axiom,
    counta3822494911875563373attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_509,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_510,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_511,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_512,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_513,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_514,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_515,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_516,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_517,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__top_518,axiom,
    order_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_519,axiom,
    order_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_520,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_521,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_522,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_523,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_524,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_525,axiom,
    uminus @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ominus_526,axiom,
    minus @ product_unit ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_527,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_528,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_529,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_530,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_531,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_532,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_533,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_534,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_535,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_536,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_537,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_538,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_539,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_540,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_541,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_542,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_543,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_544,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_545,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_546,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_547,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_548,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_549,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_550,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_551,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_552,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_553,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_554,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_555,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_556,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_557,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_558,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_559,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_560,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_561,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_562,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_563,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_564,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_565,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_566,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_567,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_568,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_569,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_570,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_571,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_572,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_573,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_574,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_575,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_576,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_577,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_578,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_579,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_580,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_581,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_582,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_583,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_584,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_585,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_586,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_587,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_588,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_589,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_590,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_591,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_592,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_593,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_594,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_595,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_596,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_597,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_598,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_599,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_600,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_601,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_602,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_603,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_604,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_605,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_606,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_607,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_608,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_609,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_610,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_611,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_612,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_613,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_614,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_615,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_616,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_617,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_618,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_619,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_620,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_621,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_622,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_623,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_624,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_625,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_626,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_627,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X8: A] : ( P @ X8 ) ) ) ).

% Conjectures (3)
thf(conj_0,hypothesis,
    ! [N4: nat] :
      ( ( x
        = ( plus_plus @ nat @ N4 @ N4 ) )
     => thesis ) ).

thf(conj_1,hypothesis,
    ! [N4: nat] :
      ( ( x
        = ( plus_plus @ nat @ N4 @ ( suc @ N4 ) ) )
     => thesis ) ).

thf(conj_2,conjecture,
    thesis ).

%------------------------------------------------------------------------------
