%------------------------------------------------------------------------------
% File     : VBT00016_4 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Definitions 00195_007561
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0063_VEBT_Definitions_00195_007561 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 11541 (4052 unt;1587 typ;   0 def)
%            Number of atoms       : 18583 (7376 equ)
%            Maximal formula atoms :   47 (   1 avg)
%            Number of connectives : 19206 (1617   ~; 292   |;2162   &)
%                                         (1986 <=>;13149  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   35 (   6 avg)
%            Maximal term depth    :   38 (   2 avg)
%            Number of FOOLs       : 1277 (1043 fml; 234 var)
%            Number of X terms     :  505 (   0  []; 449 ite;  56 let)
%            Number of types       :   14 (  13 usr)
%            Number of type conns  : 1351 (1146   >; 205   *;   0   +;   0  <<)
%            Number of predicates  :  244 ( 241 usr;   3 prp; 0-7 aty)
%            Number of functors    : 1345 (1345 usr;  66 con; 0-8 aty)
%            Number of variables   : 31622 (28443   !; 684   ?;31622   :)
%                                         (2495  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TX1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 17:14:07.398
%------------------------------------------------------------------------------
% Could-be-implicit typings (20)
tff(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

tff(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

tff(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

tff(ty_t_Product__Type_Oprod,type,
    product_prod: ( $tType * $tType ) > $tType ).

tff(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

tff(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

tff(ty_t_String_Oliteral,type,
    literal: $tType ).

tff(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

tff(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

tff(ty_t_String_Ochar,type,
    char: $tType ).

tff(ty_t_Real_Oreal,type,
    real: $tType ).

tff(ty_t_List_Olist,type,
    list: $tType > $tType ).

tff(ty_t_Set_Oset,type,
    set: $tType > $tType ).

tff(ty_t_Rat_Orat,type,
    rat: $tType ).

tff(ty_t_Num_Onum,type,
    num: $tType ).

tff(ty_t_Nat_Onat,type,
    nat: $tType ).

tff(ty_t_Int_Oint,type,
    int: $tType ).

tff(ty_t_itself,type,
    itself: $tType > $tType ).

tff(ty_t_fun,type,
    fun: ( $tType * $tType ) > $tType ).

tff(ty_tf_a,type,
    a: $tType ).

% Explicit typings (1567)
tff(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Odist__norm,type,
    real_V6936659425649961206t_norm: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ouniformity,type,
    topolo4638772830378233104ormity: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

tff(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

tff(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

tff(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

tff(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

tff(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

tff(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

tff(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

tff(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

tff(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,type,
    counta4013691401010221786attice: 
      !>[A: $tType] : $o ).

tff(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

tff(sy_c_ATP_058Lamp__a____,type,
    aTP_Lamp_a: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aa____,type,
    aTP_Lamp_aa: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aaa____,type,
    aTP_Lamp_aaa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aab____,type,
    aTP_Lamp_aab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aac____,type,
    aTP_Lamp_aac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aad____,type,
    aTP_Lamp_aad: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aae____,type,
    aTP_Lamp_aae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaf____,type,
    aTP_Lamp_aaf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aag____,type,
    aTP_Lamp_aag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aah____,type,
    aTP_Lamp_aah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aai____,type,
    aTP_Lamp_aai: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaj____,type,
    aTP_Lamp_aaj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aak____,type,
    aTP_Lamp_aak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aal____,type,
    aTP_Lamp_aal: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aam____,type,
    aTP_Lamp_aam: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aan____,type,
    aTP_Lamp_aan: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aao____,type,
    aTP_Lamp_aao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aap____,type,
    aTP_Lamp_aap: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaq____,type,
    aTP_Lamp_aaq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aar____,type,
    aTP_Lamp_aar: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aas____,type,
    aTP_Lamp_aas: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aat____,type,
    aTP_Lamp_aat: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aau____,type,
    aTP_Lamp_aau: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aav____,type,
    aTP_Lamp_aav: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaw____,type,
    aTP_Lamp_aaw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aax____,type,
    aTP_Lamp_aax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aay____,type,
    aTP_Lamp_aay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aaz____,type,
    aTP_Lamp_aaz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ab____,type,
    aTP_Lamp_ab: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aba____,type,
    aTP_Lamp_aba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abb____,type,
    aTP_Lamp_abb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abc____,type,
    aTP_Lamp_abc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abd____,type,
    aTP_Lamp_abd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abe____,type,
    aTP_Lamp_abe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abf____,type,
    aTP_Lamp_abf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abg____,type,
    aTP_Lamp_abg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abh____,type,
    aTP_Lamp_abh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abi____,type,
    aTP_Lamp_abi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abj____,type,
    aTP_Lamp_abj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abk____,type,
    aTP_Lamp_abk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abl____,type,
    aTP_Lamp_abl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abm____,type,
    aTP_Lamp_abm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abn____,type,
    aTP_Lamp_abn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__abo____,type,
    aTP_Lamp_abo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abp____,type,
    aTP_Lamp_abp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abq____,type,
    aTP_Lamp_abq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abr____,type,
    aTP_Lamp_abr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abs____,type,
    aTP_Lamp_abs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abt____,type,
    aTP_Lamp_abt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abu____,type,
    aTP_Lamp_abu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abv____,type,
    aTP_Lamp_abv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abw____,type,
    aTP_Lamp_abw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abx____,type,
    aTP_Lamp_abx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aby____,type,
    aTP_Lamp_aby: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__abz____,type,
    aTP_Lamp_abz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ac____,type,
    aTP_Lamp_ac: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aca____,type,
    aTP_Lamp_aca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acb____,type,
    aTP_Lamp_acb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acc____,type,
    aTP_Lamp_acc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acd____,type,
    aTP_Lamp_acd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ace____,type,
    aTP_Lamp_ace: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acf____,type,
    aTP_Lamp_acf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acg____,type,
    aTP_Lamp_acg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ach____,type,
    aTP_Lamp_ach: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aci____,type,
    aTP_Lamp_aci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acj____,type,
    aTP_Lamp_acj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ack____,type,
    aTP_Lamp_ack: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acl____,type,
    aTP_Lamp_acl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acm____,type,
    aTP_Lamp_acm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acn____,type,
    aTP_Lamp_acn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aco____,type,
    aTP_Lamp_aco: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acp____,type,
    aTP_Lamp_acp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acq____,type,
    aTP_Lamp_acq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acr____,type,
    aTP_Lamp_acr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acs____,type,
    aTP_Lamp_acs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__act____,type,
    aTP_Lamp_act: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acu____,type,
    aTP_Lamp_acu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acv____,type,
    aTP_Lamp_acv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acw____,type,
    aTP_Lamp_acw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acx____,type,
    aTP_Lamp_acx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__acy____,type,
    aTP_Lamp_acy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__acz____,type,
    aTP_Lamp_acz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ad____,type,
    aTP_Lamp_ad: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ada____,type,
    aTP_Lamp_ada: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adb____,type,
    aTP_Lamp_adb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adc____,type,
    aTP_Lamp_adc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__add____,type,
    aTP_Lamp_add: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ade____,type,
    aTP_Lamp_ade: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adf____,type,
    aTP_Lamp_adf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adg____,type,
    aTP_Lamp_adg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adh____,type,
    aTP_Lamp_adh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adi____,type,
    aTP_Lamp_adi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adj____,type,
    aTP_Lamp_adj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adk____,type,
    aTP_Lamp_adk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adl____,type,
    aTP_Lamp_adl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adm____,type,
    aTP_Lamp_adm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adn____,type,
    aTP_Lamp_adn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ado____,type,
    aTP_Lamp_ado: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adp____,type,
    aTP_Lamp_adp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adq____,type,
    aTP_Lamp_adq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adr____,type,
    aTP_Lamp_adr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ads____,type,
    aTP_Lamp_ads: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adt____,type,
    aTP_Lamp_adt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adu____,type,
    aTP_Lamp_adu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adv____,type,
    aTP_Lamp_adv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adw____,type,
    aTP_Lamp_adw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__adx____,type,
    aTP_Lamp_adx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ady____,type,
    aTP_Lamp_ady: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__adz____,type,
    aTP_Lamp_adz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ae____,type,
    aTP_Lamp_ae: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aea____,type,
    aTP_Lamp_aea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeb____,type,
    aTP_Lamp_aeb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aec____,type,
    aTP_Lamp_aec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aed____,type,
    aTP_Lamp_aed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aee____,type,
    aTP_Lamp_aee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aef____,type,
    aTP_Lamp_aef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeg____,type,
    aTP_Lamp_aeg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeh____,type,
    aTP_Lamp_aeh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aei____,type,
    aTP_Lamp_aei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aej____,type,
    aTP_Lamp_aej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aek____,type,
    aTP_Lamp_aek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ael____,type,
    aTP_Lamp_ael: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aem____,type,
    aTP_Lamp_aem: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aen____,type,
    aTP_Lamp_aen: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeo____,type,
    aTP_Lamp_aeo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aep____,type,
    aTP_Lamp_aep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aeq____,type,
    aTP_Lamp_aeq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aer____,type,
    aTP_Lamp_aer: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aes____,type,
    aTP_Lamp_aes: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aet____,type,
    aTP_Lamp_aet: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aeu____,type,
    aTP_Lamp_aeu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aev____,type,
    aTP_Lamp_aev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aew____,type,
    aTP_Lamp_aew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aex____,type,
    aTP_Lamp_aex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aey____,type,
    aTP_Lamp_aey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aez____,type,
    aTP_Lamp_aez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__af____,type,
    aTP_Lamp_af: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afa____,type,
    aTP_Lamp_afa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afb____,type,
    aTP_Lamp_afb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afc____,type,
    aTP_Lamp_afc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afd____,type,
    aTP_Lamp_afd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afe____,type,
    aTP_Lamp_afe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aff____,type,
    aTP_Lamp_aff: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afg____,type,
    aTP_Lamp_afg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afh____,type,
    aTP_Lamp_afh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afi____,type,
    aTP_Lamp_afi: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afj____,type,
    aTP_Lamp_afj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afk____,type,
    aTP_Lamp_afk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afl____,type,
    aTP_Lamp_afl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afm____,type,
    aTP_Lamp_afm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afn____,type,
    aTP_Lamp_afn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afo____,type,
    aTP_Lamp_afo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afp____,type,
    aTP_Lamp_afp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afq____,type,
    aTP_Lamp_afq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afr____,type,
    aTP_Lamp_afr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afs____,type,
    aTP_Lamp_afs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aft____,type,
    aTP_Lamp_aft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afu____,type,
    aTP_Lamp_afu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afv____,type,
    aTP_Lamp_afv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afw____,type,
    aTP_Lamp_afw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afx____,type,
    aTP_Lamp_afx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__afy____,type,
    aTP_Lamp_afy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__afz____,type,
    aTP_Lamp_afz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ag____,type,
    aTP_Lamp_ag: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aga____,type,
    aTP_Lamp_aga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agb____,type,
    aTP_Lamp_agb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agc____,type,
    aTP_Lamp_agc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agd____,type,
    aTP_Lamp_agd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__age____,type,
    aTP_Lamp_age: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agf____,type,
    aTP_Lamp_agf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agg____,type,
    aTP_Lamp_agg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agh____,type,
    aTP_Lamp_agh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agi____,type,
    aTP_Lamp_agi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agj____,type,
    aTP_Lamp_agj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agk____,type,
    aTP_Lamp_agk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agl____,type,
    aTP_Lamp_agl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agm____,type,
    aTP_Lamp_agm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agn____,type,
    aTP_Lamp_agn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ago____,type,
    aTP_Lamp_ago: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agp____,type,
    aTP_Lamp_agp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agq____,type,
    aTP_Lamp_agq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agr____,type,
    aTP_Lamp_agr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ags____,type,
    aTP_Lamp_ags: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agt____,type,
    aTP_Lamp_agt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agu____,type,
    aTP_Lamp_agu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agv____,type,
    aTP_Lamp_agv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__agw____,type,
    aTP_Lamp_agw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agx____,type,
    aTP_Lamp_agx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agy____,type,
    aTP_Lamp_agy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__agz____,type,
    aTP_Lamp_agz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ah____,type,
    aTP_Lamp_ah: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aha____,type,
    aTP_Lamp_aha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahb____,type,
    aTP_Lamp_ahb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahc____,type,
    aTP_Lamp_ahc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahd____,type,
    aTP_Lamp_ahd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahe____,type,
    aTP_Lamp_ahe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahf____,type,
    aTP_Lamp_ahf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahg____,type,
    aTP_Lamp_ahg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahh____,type,
    aTP_Lamp_ahh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahi____,type,
    aTP_Lamp_ahi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahj____,type,
    aTP_Lamp_ahj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahk____,type,
    aTP_Lamp_ahk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahl____,type,
    aTP_Lamp_ahl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahm____,type,
    aTP_Lamp_ahm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahn____,type,
    aTP_Lamp_ahn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aho____,type,
    aTP_Lamp_aho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahp____,type,
    aTP_Lamp_ahp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahq____,type,
    aTP_Lamp_ahq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahr____,type,
    aTP_Lamp_ahr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahs____,type,
    aTP_Lamp_ahs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aht____,type,
    aTP_Lamp_aht: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahu____,type,
    aTP_Lamp_ahu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ahv____,type,
    aTP_Lamp_ahv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahw____,type,
    aTP_Lamp_ahw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahx____,type,
    aTP_Lamp_ahx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahy____,type,
    aTP_Lamp_ahy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ahz____,type,
    aTP_Lamp_ahz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ai____,type,
    aTP_Lamp_ai: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aia____,type,
    aTP_Lamp_aia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aib____,type,
    aTP_Lamp_aib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aic____,type,
    aTP_Lamp_aic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aid____,type,
    aTP_Lamp_aid: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aie____,type,
    aTP_Lamp_aie: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aif____,type,
    aTP_Lamp_aif: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aig____,type,
    aTP_Lamp_aig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aih____,type,
    aTP_Lamp_aih: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aii____,type,
    aTP_Lamp_aii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aij____,type,
    aTP_Lamp_aij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aik____,type,
    aTP_Lamp_aik: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ail____,type,
    aTP_Lamp_ail: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aim____,type,
    aTP_Lamp_aim: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ain____,type,
    aTP_Lamp_ain: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aio____,type,
    aTP_Lamp_aio: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aip____,type,
    aTP_Lamp_aip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiq____,type,
    aTP_Lamp_aiq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__air____,type,
    aTP_Lamp_air: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ais____,type,
    aTP_Lamp_ais: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ait____,type,
    aTP_Lamp_ait: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiu____,type,
    aTP_Lamp_aiu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiv____,type,
    aTP_Lamp_aiv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aiw____,type,
    aTP_Lamp_aiw: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aix____,type,
    aTP_Lamp_aix: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aiy____,type,
    aTP_Lamp_aiy: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aiz____,type,
    aTP_Lamp_aiz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aj____,type,
    aTP_Lamp_aj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aja____,type,
    aTP_Lamp_aja: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajb____,type,
    aTP_Lamp_ajb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajc____,type,
    aTP_Lamp_ajc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajd____,type,
    aTP_Lamp_ajd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aje____,type,
    aTP_Lamp_aje: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajf____,type,
    aTP_Lamp_ajf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajg____,type,
    aTP_Lamp_ajg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajh____,type,
    aTP_Lamp_ajh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aji____,type,
    aTP_Lamp_aji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajj____,type,
    aTP_Lamp_ajj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajk____,type,
    aTP_Lamp_ajk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajl____,type,
    aTP_Lamp_ajl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajm____,type,
    aTP_Lamp_ajm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajn____,type,
    aTP_Lamp_ajn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajo____,type,
    aTP_Lamp_ajo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajp____,type,
    aTP_Lamp_ajp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajq____,type,
    aTP_Lamp_ajq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajr____,type,
    aTP_Lamp_ajr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajs____,type,
    aTP_Lamp_ajs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajt____,type,
    aTP_Lamp_ajt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aju____,type,
    aTP_Lamp_aju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajv____,type,
    aTP_Lamp_ajv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajw____,type,
    aTP_Lamp_ajw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajx____,type,
    aTP_Lamp_ajx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ajy____,type,
    aTP_Lamp_ajy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ajz____,type,
    aTP_Lamp_ajz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ak____,type,
    aTP_Lamp_ak: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aka____,type,
    aTP_Lamp_aka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akb____,type,
    aTP_Lamp_akb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akc____,type,
    aTP_Lamp_akc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akd____,type,
    aTP_Lamp_akd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ake____,type,
    aTP_Lamp_ake: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akf____,type,
    aTP_Lamp_akf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__akg____,type,
    aTP_Lamp_akg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akh____,type,
    aTP_Lamp_akh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aki____,type,
    aTP_Lamp_aki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akj____,type,
    aTP_Lamp_akj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akk____,type,
    aTP_Lamp_akk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akl____,type,
    aTP_Lamp_akl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akm____,type,
    aTP_Lamp_akm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akn____,type,
    aTP_Lamp_akn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ako____,type,
    aTP_Lamp_ako: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akp____,type,
    aTP_Lamp_akp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akq____,type,
    aTP_Lamp_akq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akr____,type,
    aTP_Lamp_akr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aks____,type,
    aTP_Lamp_aks: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__akt____,type,
    aTP_Lamp_akt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aku____,type,
    aTP_Lamp_aku: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__akv____,type,
    aTP_Lamp_akv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akw____,type,
    aTP_Lamp_akw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__akx____,type,
    aTP_Lamp_akx: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aky____,type,
    aTP_Lamp_aky: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__akz____,type,
    aTP_Lamp_akz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__al____,type,
    aTP_Lamp_al: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ala____,type,
    aTP_Lamp_ala: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__alb____,type,
    aTP_Lamp_alb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__alc____,type,
    aTP_Lamp_alc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ald____,type,
    aTP_Lamp_ald: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__am____,type,
    aTP_Lamp_am: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__an____,type,
    aTP_Lamp_an: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ao____,type,
    aTP_Lamp_ao: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ap____,type,
    aTP_Lamp_ap: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__aq____,type,
    aTP_Lamp_aq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ar____,type,
    aTP_Lamp_ar: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__as____,type,
    aTP_Lamp_as: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__at____,type,
    aTP_Lamp_at: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__au____,type,
    aTP_Lamp_au: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__av____,type,
    aTP_Lamp_av: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__aw____,type,
    aTP_Lamp_aw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ax____,type,
    aTP_Lamp_ax: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ay____,type,
    aTP_Lamp_ay: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__az____,type,
    aTP_Lamp_az: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ba____,type,
    aTP_Lamp_ba: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bb____,type,
    aTP_Lamp_bb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bc____,type,
    aTP_Lamp_bc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bd____,type,
    aTP_Lamp_bd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__be____,type,
    aTP_Lamp_be: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bf____,type,
    aTP_Lamp_bf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bg____,type,
    aTP_Lamp_bg: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bh____,type,
    aTP_Lamp_bh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bi____,type,
    aTP_Lamp_bi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bj____,type,
    aTP_Lamp_bj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bk____,type,
    aTP_Lamp_bk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bl____,type,
    aTP_Lamp_bl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bm____,type,
    aTP_Lamp_bm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bn____,type,
    aTP_Lamp_bn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bo____,type,
    aTP_Lamp_bo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bp____,type,
    aTP_Lamp_bp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bq____,type,
    aTP_Lamp_bq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__br____,type,
    aTP_Lamp_br: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bs____,type,
    aTP_Lamp_bs: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bt____,type,
    aTP_Lamp_bt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bu____,type,
    aTP_Lamp_bu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bv____,type,
    aTP_Lamp_bv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bw____,type,
    aTP_Lamp_bw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__bx____,type,
    aTP_Lamp_bx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__by____,type,
    aTP_Lamp_by: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__bz____,type,
    aTP_Lamp_bz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ca____,type,
    aTP_Lamp_ca: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cb____,type,
    aTP_Lamp_cb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cc____,type,
    aTP_Lamp_cc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cd____,type,
    aTP_Lamp_cd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ce____,type,
    aTP_Lamp_ce: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cf____,type,
    aTP_Lamp_cf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cg____,type,
    aTP_Lamp_cg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ch____,type,
    aTP_Lamp_ch: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ci____,type,
    aTP_Lamp_ci: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cj____,type,
    aTP_Lamp_cj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ck____,type,
    aTP_Lamp_ck: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cl____,type,
    aTP_Lamp_cl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cm____,type,
    aTP_Lamp_cm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cn____,type,
    aTP_Lamp_cn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__co____,type,
    aTP_Lamp_co: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cp____,type,
    aTP_Lamp_cp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cq____,type,
    aTP_Lamp_cq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cr____,type,
    aTP_Lamp_cr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cs____,type,
    aTP_Lamp_cs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ct____,type,
    aTP_Lamp_ct: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cu____,type,
    aTP_Lamp_cu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cv____,type,
    aTP_Lamp_cv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cw____,type,
    aTP_Lamp_cw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cx____,type,
    aTP_Lamp_cx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cy____,type,
    aTP_Lamp_cy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__cz____,type,
    aTP_Lamp_cz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__da____,type,
    aTP_Lamp_da: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__db____,type,
    aTP_Lamp_db: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dc____,type,
    aTP_Lamp_dc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dd____,type,
    aTP_Lamp_dd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__de____,type,
    aTP_Lamp_de: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__df____,type,
    aTP_Lamp_df: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dg____,type,
    aTP_Lamp_dg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dh____,type,
    aTP_Lamp_dh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__di____,type,
    aTP_Lamp_di: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dj____,type,
    aTP_Lamp_dj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dk____,type,
    aTP_Lamp_dk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dl____,type,
    aTP_Lamp_dl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dm____,type,
    aTP_Lamp_dm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__dn____,type,
    aTP_Lamp_dn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__do____,type,
    aTP_Lamp_do: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dp____,type,
    aTP_Lamp_dp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dq____,type,
    aTP_Lamp_dq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dr____,type,
    aTP_Lamp_dr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ds____,type,
    aTP_Lamp_ds: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dt____,type,
    aTP_Lamp_dt: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__du____,type,
    aTP_Lamp_du: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dv____,type,
    aTP_Lamp_dv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dw____,type,
    aTP_Lamp_dw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dx____,type,
    aTP_Lamp_dx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dy____,type,
    aTP_Lamp_dy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__dz____,type,
    aTP_Lamp_dz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ea____,type,
    aTP_Lamp_ea: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eb____,type,
    aTP_Lamp_eb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ec____,type,
    aTP_Lamp_ec: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ed____,type,
    aTP_Lamp_ed: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ee____,type,
    aTP_Lamp_ee: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ef____,type,
    aTP_Lamp_ef: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eg____,type,
    aTP_Lamp_eg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eh____,type,
    aTP_Lamp_eh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ei____,type,
    aTP_Lamp_ei: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ej____,type,
    aTP_Lamp_ej: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ek____,type,
    aTP_Lamp_ek: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__el____,type,
    aTP_Lamp_el: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__em____,type,
    aTP_Lamp_em: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__en____,type,
    aTP_Lamp_en: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eo____,type,
    aTP_Lamp_eo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ep____,type,
    aTP_Lamp_ep: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eq____,type,
    aTP_Lamp_eq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__er____,type,
    aTP_Lamp_er: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__es____,type,
    aTP_Lamp_es: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__et____,type,
    aTP_Lamp_et: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__eu____,type,
    aTP_Lamp_eu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ev____,type,
    aTP_Lamp_ev: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ew____,type,
    aTP_Lamp_ew: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ex____,type,
    aTP_Lamp_ex: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ey____,type,
    aTP_Lamp_ey: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ez____,type,
    aTP_Lamp_ez: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fa____,type,
    aTP_Lamp_fa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fb____,type,
    aTP_Lamp_fb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fc____,type,
    aTP_Lamp_fc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fd____,type,
    aTP_Lamp_fd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fe____,type,
    aTP_Lamp_fe: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ff____,type,
    aTP_Lamp_ff: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fg____,type,
    aTP_Lamp_fg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fh____,type,
    aTP_Lamp_fh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fi____,type,
    aTP_Lamp_fi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fj____,type,
    aTP_Lamp_fj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fk____,type,
    aTP_Lamp_fk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fl____,type,
    aTP_Lamp_fl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fm____,type,
    aTP_Lamp_fm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fn____,type,
    aTP_Lamp_fn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fo____,type,
    aTP_Lamp_fo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__fp____,type,
    aTP_Lamp_fp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fq____,type,
    aTP_Lamp_fq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fr____,type,
    aTP_Lamp_fr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fs____,type,
    aTP_Lamp_fs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ft____,type,
    aTP_Lamp_ft: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fu____,type,
    aTP_Lamp_fu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fv____,type,
    aTP_Lamp_fv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fw____,type,
    aTP_Lamp_fw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fx____,type,
    aTP_Lamp_fx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fy____,type,
    aTP_Lamp_fy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__fz____,type,
    aTP_Lamp_fz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ga____,type,
    aTP_Lamp_ga: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gb____,type,
    aTP_Lamp_gb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gc____,type,
    aTP_Lamp_gc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gd____,type,
    aTP_Lamp_gd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ge____,type,
    aTP_Lamp_ge: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gf____,type,
    aTP_Lamp_gf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gg____,type,
    aTP_Lamp_gg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gh____,type,
    aTP_Lamp_gh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gi____,type,
    aTP_Lamp_gi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gj____,type,
    aTP_Lamp_gj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gk____,type,
    aTP_Lamp_gk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gl____,type,
    aTP_Lamp_gl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gm____,type,
    aTP_Lamp_gm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gn____,type,
    aTP_Lamp_gn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__go____,type,
    aTP_Lamp_go: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gp____,type,
    aTP_Lamp_gp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gq____,type,
    aTP_Lamp_gq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gr____,type,
    aTP_Lamp_gr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gs____,type,
    aTP_Lamp_gs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gt____,type,
    aTP_Lamp_gt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gu____,type,
    aTP_Lamp_gu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gv____,type,
    aTP_Lamp_gv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gw____,type,
    aTP_Lamp_gw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gx____,type,
    aTP_Lamp_gx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gy____,type,
    aTP_Lamp_gy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__gz____,type,
    aTP_Lamp_gz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ha____,type,
    aTP_Lamp_ha: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hb____,type,
    aTP_Lamp_hb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hc____,type,
    aTP_Lamp_hc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hd____,type,
    aTP_Lamp_hd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__he____,type,
    aTP_Lamp_he: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hf____,type,
    aTP_Lamp_hf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hg____,type,
    aTP_Lamp_hg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hh____,type,
    aTP_Lamp_hh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hi____,type,
    aTP_Lamp_hi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hj____,type,
    aTP_Lamp_hj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hk____,type,
    aTP_Lamp_hk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hl____,type,
    aTP_Lamp_hl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hm____,type,
    aTP_Lamp_hm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hn____,type,
    aTP_Lamp_hn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ho____,type,
    aTP_Lamp_ho: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hp____,type,
    aTP_Lamp_hp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hq____,type,
    aTP_Lamp_hq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hr____,type,
    aTP_Lamp_hr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hs____,type,
    aTP_Lamp_hs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ht____,type,
    aTP_Lamp_ht: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hu____,type,
    aTP_Lamp_hu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hv____,type,
    aTP_Lamp_hv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hw____,type,
    aTP_Lamp_hw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hx____,type,
    aTP_Lamp_hx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hy____,type,
    aTP_Lamp_hy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__hz____,type,
    aTP_Lamp_hz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ia____,type,
    aTP_Lamp_ia: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ib____,type,
    aTP_Lamp_ib: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ic____,type,
    aTP_Lamp_ic: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__id____,type,
    aTP_Lamp_id: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ie____,type,
    aTP_Lamp_ie: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__if____,type,
    aTP_Lamp_if: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ig____,type,
    aTP_Lamp_ig: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ih____,type,
    aTP_Lamp_ih: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ii____,type,
    aTP_Lamp_ii: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ij____,type,
    aTP_Lamp_ij: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ik____,type,
    aTP_Lamp_ik: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__il____,type,
    aTP_Lamp_il: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__im____,type,
    aTP_Lamp_im: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__in____,type,
    aTP_Lamp_in: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__io____,type,
    aTP_Lamp_io: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ip____,type,
    aTP_Lamp_ip: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iq____,type,
    aTP_Lamp_iq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ir____,type,
    aTP_Lamp_ir: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__is____,type,
    aTP_Lamp_is: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__it____,type,
    aTP_Lamp_it: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iu____,type,
    aTP_Lamp_iu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__iv____,type,
    aTP_Lamp_iv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iw____,type,
    aTP_Lamp_iw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ix____,type,
    aTP_Lamp_ix: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__iy____,type,
    aTP_Lamp_iy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__iz____,type,
    aTP_Lamp_iz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ja____,type,
    aTP_Lamp_ja: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jb____,type,
    aTP_Lamp_jb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jc____,type,
    aTP_Lamp_jc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jd____,type,
    aTP_Lamp_jd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__je____,type,
    aTP_Lamp_je: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jf____,type,
    aTP_Lamp_jf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jg____,type,
    aTP_Lamp_jg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jh____,type,
    aTP_Lamp_jh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ji____,type,
    aTP_Lamp_ji: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jj____,type,
    aTP_Lamp_jj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jk____,type,
    aTP_Lamp_jk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jl____,type,
    aTP_Lamp_jl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jm____,type,
    aTP_Lamp_jm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__jn____,type,
    aTP_Lamp_jn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jo____,type,
    aTP_Lamp_jo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jp____,type,
    aTP_Lamp_jp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jq____,type,
    aTP_Lamp_jq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jr____,type,
    aTP_Lamp_jr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__js____,type,
    aTP_Lamp_js: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jt____,type,
    aTP_Lamp_jt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ju____,type,
    aTP_Lamp_ju: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jv____,type,
    aTP_Lamp_jv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jw____,type,
    aTP_Lamp_jw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jx____,type,
    aTP_Lamp_jx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jy____,type,
    aTP_Lamp_jy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__jz____,type,
    aTP_Lamp_jz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ka____,type,
    aTP_Lamp_ka: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kb____,type,
    aTP_Lamp_kb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kc____,type,
    aTP_Lamp_kc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kd____,type,
    aTP_Lamp_kd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ke____,type,
    aTP_Lamp_ke: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kf____,type,
    aTP_Lamp_kf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kg____,type,
    aTP_Lamp_kg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kh____,type,
    aTP_Lamp_kh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ki____,type,
    aTP_Lamp_ki: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kj____,type,
    aTP_Lamp_kj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kk____,type,
    aTP_Lamp_kk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kl____,type,
    aTP_Lamp_kl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__km____,type,
    aTP_Lamp_km: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kn____,type,
    aTP_Lamp_kn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ko____,type,
    aTP_Lamp_ko: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kp____,type,
    aTP_Lamp_kp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kq____,type,
    aTP_Lamp_kq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kr____,type,
    aTP_Lamp_kr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ks____,type,
    aTP_Lamp_ks: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kt____,type,
    aTP_Lamp_kt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ku____,type,
    aTP_Lamp_ku: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kv____,type,
    aTP_Lamp_kv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kw____,type,
    aTP_Lamp_kw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kx____,type,
    aTP_Lamp_kx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ky____,type,
    aTP_Lamp_ky: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__kz____,type,
    aTP_Lamp_kz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__la____,type,
    aTP_Lamp_la: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lb____,type,
    aTP_Lamp_lb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lc____,type,
    aTP_Lamp_lc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ld____,type,
    aTP_Lamp_ld: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__le____,type,
    aTP_Lamp_le: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lf____,type,
    aTP_Lamp_lf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lg____,type,
    aTP_Lamp_lg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lh____,type,
    aTP_Lamp_lh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__li____,type,
    aTP_Lamp_li: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lj____,type,
    aTP_Lamp_lj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lk____,type,
    aTP_Lamp_lk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ll____,type,
    aTP_Lamp_ll: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lm____,type,
    aTP_Lamp_lm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ln____,type,
    aTP_Lamp_ln: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lo____,type,
    aTP_Lamp_lo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lp____,type,
    aTP_Lamp_lp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lq____,type,
    aTP_Lamp_lq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lr____,type,
    aTP_Lamp_lr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ls____,type,
    aTP_Lamp_ls: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lt____,type,
    aTP_Lamp_lt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lu____,type,
    aTP_Lamp_lu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lv____,type,
    aTP_Lamp_lv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lw____,type,
    aTP_Lamp_lw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lx____,type,
    aTP_Lamp_lx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ly____,type,
    aTP_Lamp_ly: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__lz____,type,
    aTP_Lamp_lz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ma____,type,
    aTP_Lamp_ma: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mb____,type,
    aTP_Lamp_mb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mc____,type,
    aTP_Lamp_mc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__md____,type,
    aTP_Lamp_md: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__me____,type,
    aTP_Lamp_me: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mf____,type,
    aTP_Lamp_mf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mg____,type,
    aTP_Lamp_mg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mh____,type,
    aTP_Lamp_mh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mi____,type,
    aTP_Lamp_mi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mj____,type,
    aTP_Lamp_mj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mk____,type,
    aTP_Lamp_mk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ml____,type,
    aTP_Lamp_ml: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mm____,type,
    aTP_Lamp_mm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mn____,type,
    aTP_Lamp_mn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mo____,type,
    aTP_Lamp_mo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mp____,type,
    aTP_Lamp_mp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mq____,type,
    aTP_Lamp_mq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mr____,type,
    aTP_Lamp_mr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ms____,type,
    aTP_Lamp_ms: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mt____,type,
    aTP_Lamp_mt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mu____,type,
    aTP_Lamp_mu: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__mv____,type,
    aTP_Lamp_mv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mw____,type,
    aTP_Lamp_mw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mx____,type,
    aTP_Lamp_mx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__my____,type,
    aTP_Lamp_my: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__mz____,type,
    aTP_Lamp_mz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__na____,type,
    aTP_Lamp_na: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nb____,type,
    aTP_Lamp_nb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nc____,type,
    aTP_Lamp_nc: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nd____,type,
    aTP_Lamp_nd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ne____,type,
    aTP_Lamp_ne: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nf____,type,
    aTP_Lamp_nf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ng____,type,
    aTP_Lamp_ng: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nh____,type,
    aTP_Lamp_nh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ni____,type,
    aTP_Lamp_ni: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nj____,type,
    aTP_Lamp_nj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nk____,type,
    aTP_Lamp_nk: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nl____,type,
    aTP_Lamp_nl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nm____,type,
    aTP_Lamp_nm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nn____,type,
    aTP_Lamp_nn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__no____,type,
    aTP_Lamp_no: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__np____,type,
    aTP_Lamp_np: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nq____,type,
    aTP_Lamp_nq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nr____,type,
    aTP_Lamp_nr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__ns____,type,
    aTP_Lamp_ns: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nt____,type,
    aTP_Lamp_nt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nu____,type,
    aTP_Lamp_nu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nv____,type,
    aTP_Lamp_nv: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__nw____,type,
    aTP_Lamp_nw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nx____,type,
    aTP_Lamp_nx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ny____,type,
    aTP_Lamp_ny: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__nz____,type,
    aTP_Lamp_nz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oa____,type,
    aTP_Lamp_oa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ob____,type,
    aTP_Lamp_ob: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oc____,type,
    aTP_Lamp_oc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__od____,type,
    aTP_Lamp_od: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oe____,type,
    aTP_Lamp_oe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__of____,type,
    aTP_Lamp_of: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__og____,type,
    aTP_Lamp_og: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oh____,type,
    aTP_Lamp_oh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oi____,type,
    aTP_Lamp_oi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oj____,type,
    aTP_Lamp_oj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ok____,type,
    aTP_Lamp_ok: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ol____,type,
    aTP_Lamp_ol: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__om____,type,
    aTP_Lamp_om: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__on____,type,
    aTP_Lamp_on: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oo____,type,
    aTP_Lamp_oo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__op____,type,
    aTP_Lamp_op: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oq____,type,
    aTP_Lamp_oq: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__or____,type,
    aTP_Lamp_or: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__os____,type,
    aTP_Lamp_os: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ot____,type,
    aTP_Lamp_ot: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ou____,type,
    aTP_Lamp_ou: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ov____,type,
    aTP_Lamp_ov: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ow____,type,
    aTP_Lamp_ow: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ox____,type,
    aTP_Lamp_ox: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oy____,type,
    aTP_Lamp_oy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__oz____,type,
    aTP_Lamp_oz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pa____,type,
    aTP_Lamp_pa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pb____,type,
    aTP_Lamp_pb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pc____,type,
    aTP_Lamp_pc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pd____,type,
    aTP_Lamp_pd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pe____,type,
    aTP_Lamp_pe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pf____,type,
    aTP_Lamp_pf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pg____,type,
    aTP_Lamp_pg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ph____,type,
    aTP_Lamp_ph: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pi____,type,
    aTP_Lamp_pi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pj____,type,
    aTP_Lamp_pj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pk____,type,
    aTP_Lamp_pk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pl____,type,
    aTP_Lamp_pl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pm____,type,
    aTP_Lamp_pm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pn____,type,
    aTP_Lamp_pn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__po____,type,
    aTP_Lamp_po: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pp____,type,
    aTP_Lamp_pp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pq____,type,
    aTP_Lamp_pq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pr____,type,
    aTP_Lamp_pr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ps____,type,
    aTP_Lamp_ps: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pt____,type,
    aTP_Lamp_pt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pu____,type,
    aTP_Lamp_pu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pv____,type,
    aTP_Lamp_pv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pw____,type,
    aTP_Lamp_pw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__px____,type,
    aTP_Lamp_px: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__py____,type,
    aTP_Lamp_py: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__pz____,type,
    aTP_Lamp_pz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__qa____,type,
    aTP_Lamp_qa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qb____,type,
    aTP_Lamp_qb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qc____,type,
    aTP_Lamp_qc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qd____,type,
    aTP_Lamp_qd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qe____,type,
    aTP_Lamp_qe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qf____,type,
    aTP_Lamp_qf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qg____,type,
    aTP_Lamp_qg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qh____,type,
    aTP_Lamp_qh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qi____,type,
    aTP_Lamp_qi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qj____,type,
    aTP_Lamp_qj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qk____,type,
    aTP_Lamp_qk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ql____,type,
    aTP_Lamp_ql: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qm____,type,
    aTP_Lamp_qm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qn____,type,
    aTP_Lamp_qn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qo____,type,
    aTP_Lamp_qo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qp____,type,
    aTP_Lamp_qp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qq____,type,
    aTP_Lamp_qq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qr____,type,
    aTP_Lamp_qr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qs____,type,
    aTP_Lamp_qs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qt____,type,
    aTP_Lamp_qt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qu____,type,
    aTP_Lamp_qu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qv____,type,
    aTP_Lamp_qv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qw____,type,
    aTP_Lamp_qw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qx____,type,
    aTP_Lamp_qx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qy____,type,
    aTP_Lamp_qy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__qz____,type,
    aTP_Lamp_qz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ra____,type,
    aTP_Lamp_ra: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rb____,type,
    aTP_Lamp_rb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rc____,type,
    aTP_Lamp_rc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rd____,type,
    aTP_Lamp_rd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__re____,type,
    aTP_Lamp_re: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rf____,type,
    aTP_Lamp_rf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rg____,type,
    aTP_Lamp_rg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rh____,type,
    aTP_Lamp_rh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ri____,type,
    aTP_Lamp_ri: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rj____,type,
    aTP_Lamp_rj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rk____,type,
    aTP_Lamp_rk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rl____,type,
    aTP_Lamp_rl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rm____,type,
    aTP_Lamp_rm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rn____,type,
    aTP_Lamp_rn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ro____,type,
    aTP_Lamp_ro: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rp____,type,
    aTP_Lamp_rp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rq____,type,
    aTP_Lamp_rq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rr____,type,
    aTP_Lamp_rr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rs____,type,
    aTP_Lamp_rs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rt____,type,
    aTP_Lamp_rt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ru____,type,
    aTP_Lamp_ru: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__rv____,type,
    aTP_Lamp_rv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rw____,type,
    aTP_Lamp_rw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rx____,type,
    aTP_Lamp_rx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ry____,type,
    aTP_Lamp_ry: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__rz____,type,
    aTP_Lamp_rz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sa____,type,
    aTP_Lamp_sa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sb____,type,
    aTP_Lamp_sb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sc____,type,
    aTP_Lamp_sc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sd____,type,
    aTP_Lamp_sd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__se____,type,
    aTP_Lamp_se: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sf____,type,
    aTP_Lamp_sf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sg____,type,
    aTP_Lamp_sg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sh____,type,
    aTP_Lamp_sh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__si____,type,
    aTP_Lamp_si: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sj____,type,
    aTP_Lamp_sj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sk____,type,
    aTP_Lamp_sk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sl____,type,
    aTP_Lamp_sl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sm____,type,
    aTP_Lamp_sm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sn____,type,
    aTP_Lamp_sn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__so____,type,
    aTP_Lamp_so: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sp____,type,
    aTP_Lamp_sp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sq____,type,
    aTP_Lamp_sq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sr____,type,
    aTP_Lamp_sr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ss____,type,
    aTP_Lamp_ss: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__st____,type,
    aTP_Lamp_st: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__su____,type,
    aTP_Lamp_su: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sv____,type,
    aTP_Lamp_sv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sw____,type,
    aTP_Lamp_sw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sx____,type,
    aTP_Lamp_sx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sy____,type,
    aTP_Lamp_sy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__sz____,type,
    aTP_Lamp_sz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ta____,type,
    aTP_Lamp_ta: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tb____,type,
    aTP_Lamp_tb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tc____,type,
    aTP_Lamp_tc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__td____,type,
    aTP_Lamp_td: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__te____,type,
    aTP_Lamp_te: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tf____,type,
    aTP_Lamp_tf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tg____,type,
    aTP_Lamp_tg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__th____,type,
    aTP_Lamp_th: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ti____,type,
    aTP_Lamp_ti: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tj____,type,
    aTP_Lamp_tj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tk____,type,
    aTP_Lamp_tk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tl____,type,
    aTP_Lamp_tl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tm____,type,
    aTP_Lamp_tm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tn____,type,
    aTP_Lamp_tn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__to____,type,
    aTP_Lamp_to: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tp____,type,
    aTP_Lamp_tp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tq____,type,
    aTP_Lamp_tq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tr____,type,
    aTP_Lamp_tr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ts____,type,
    aTP_Lamp_ts: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tt____,type,
    aTP_Lamp_tt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tu____,type,
    aTP_Lamp_tu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tv____,type,
    aTP_Lamp_tv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tw____,type,
    aTP_Lamp_tw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tx____,type,
    aTP_Lamp_tx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ty____,type,
    aTP_Lamp_ty: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__tz____,type,
    aTP_Lamp_tz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ua____,type,
    aTP_Lamp_ua: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ub____,type,
    aTP_Lamp_ub: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uc____,type,
    aTP_Lamp_uc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ud____,type,
    aTP_Lamp_ud: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ue____,type,
    aTP_Lamp_ue: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uf____,type,
    aTP_Lamp_uf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ug____,type,
    aTP_Lamp_ug: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uh____,type,
    aTP_Lamp_uh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ui____,type,
    aTP_Lamp_ui: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uj____,type,
    aTP_Lamp_uj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uk____,type,
    aTP_Lamp_uk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ul____,type,
    aTP_Lamp_ul: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__um____,type,
    aTP_Lamp_um: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__un____,type,
    aTP_Lamp_un: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uo____,type,
    aTP_Lamp_uo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__up____,type,
    aTP_Lamp_up: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uq____,type,
    aTP_Lamp_uq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ur____,type,
    aTP_Lamp_ur: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__us____,type,
    aTP_Lamp_us: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ut____,type,
    aTP_Lamp_ut: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uu____,type,
    aTP_Lamp_uu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uv____,type,
    aTP_Lamp_uv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uw____,type,
    aTP_Lamp_uw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ux____,type,
    aTP_Lamp_ux: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uy____,type,
    aTP_Lamp_uy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__uz____,type,
    aTP_Lamp_uz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__va____,type,
    aTP_Lamp_va: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vb____,type,
    aTP_Lamp_vb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vc____,type,
    aTP_Lamp_vc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vd____,type,
    aTP_Lamp_vd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ve____,type,
    aTP_Lamp_ve: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vf____,type,
    aTP_Lamp_vf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vg____,type,
    aTP_Lamp_vg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vh____,type,
    aTP_Lamp_vh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vi____,type,
    aTP_Lamp_vi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vj____,type,
    aTP_Lamp_vj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vk____,type,
    aTP_Lamp_vk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vl____,type,
    aTP_Lamp_vl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vm____,type,
    aTP_Lamp_vm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vn____,type,
    aTP_Lamp_vn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vo____,type,
    aTP_Lamp_vo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vp____,type,
    aTP_Lamp_vp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vq____,type,
    aTP_Lamp_vq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vr____,type,
    aTP_Lamp_vr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vs____,type,
    aTP_Lamp_vs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vt____,type,
    aTP_Lamp_vt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vu____,type,
    aTP_Lamp_vu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vv____,type,
    aTP_Lamp_vv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vw____,type,
    aTP_Lamp_vw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vx____,type,
    aTP_Lamp_vx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vy____,type,
    aTP_Lamp_vy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__vz____,type,
    aTP_Lamp_vz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wa____,type,
    aTP_Lamp_wa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wb____,type,
    aTP_Lamp_wb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wc____,type,
    aTP_Lamp_wc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wd____,type,
    aTP_Lamp_wd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__we____,type,
    aTP_Lamp_we: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wf____,type,
    aTP_Lamp_wf: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__wg____,type,
    aTP_Lamp_wg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wh____,type,
    aTP_Lamp_wh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wi____,type,
    aTP_Lamp_wi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wj____,type,
    aTP_Lamp_wj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wk____,type,
    aTP_Lamp_wk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wl____,type,
    aTP_Lamp_wl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wm____,type,
    aTP_Lamp_wm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wn____,type,
    aTP_Lamp_wn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wo____,type,
    aTP_Lamp_wo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wp____,type,
    aTP_Lamp_wp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wq____,type,
    aTP_Lamp_wq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wr____,type,
    aTP_Lamp_wr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ws____,type,
    aTP_Lamp_ws: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wt____,type,
    aTP_Lamp_wt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wu____,type,
    aTP_Lamp_wu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wv____,type,
    aTP_Lamp_wv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ww____,type,
    aTP_Lamp_ww: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wx____,type,
    aTP_Lamp_wx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wy____,type,
    aTP_Lamp_wy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__wz____,type,
    aTP_Lamp_wz: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xa____,type,
    aTP_Lamp_xa: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xb____,type,
    aTP_Lamp_xb: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xc____,type,
    aTP_Lamp_xc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xd____,type,
    aTP_Lamp_xd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xe____,type,
    aTP_Lamp_xe: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xf____,type,
    aTP_Lamp_xf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xg____,type,
    aTP_Lamp_xg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xh____,type,
    aTP_Lamp_xh: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xi____,type,
    aTP_Lamp_xi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xj____,type,
    aTP_Lamp_xj: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xk____,type,
    aTP_Lamp_xk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xl____,type,
    aTP_Lamp_xl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xm____,type,
    aTP_Lamp_xm: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xn____,type,
    aTP_Lamp_xn: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xo____,type,
    aTP_Lamp_xo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__xp____,type,
    aTP_Lamp_xp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xq____,type,
    aTP_Lamp_xq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xr____,type,
    aTP_Lamp_xr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xs____,type,
    aTP_Lamp_xs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xt____,type,
    aTP_Lamp_xt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xu____,type,
    aTP_Lamp_xu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xv____,type,
    aTP_Lamp_xv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xw____,type,
    aTP_Lamp_xw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xx____,type,
    aTP_Lamp_xx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xy____,type,
    aTP_Lamp_xy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__xz____,type,
    aTP_Lamp_xz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ya____,type,
    aTP_Lamp_ya: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yb____,type,
    aTP_Lamp_yb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yc____,type,
    aTP_Lamp_yc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yd____,type,
    aTP_Lamp_yd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ye____,type,
    aTP_Lamp_ye: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yf____,type,
    aTP_Lamp_yf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yg____,type,
    aTP_Lamp_yg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yh____,type,
    aTP_Lamp_yh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yi____,type,
    aTP_Lamp_yi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yj____,type,
    aTP_Lamp_yj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yk____,type,
    aTP_Lamp_yk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yl____,type,
    aTP_Lamp_yl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ym____,type,
    aTP_Lamp_ym: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yn____,type,
    aTP_Lamp_yn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yo____,type,
    aTP_Lamp_yo: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yp____,type,
    aTP_Lamp_yp: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__yq____,type,
    aTP_Lamp_yq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yr____,type,
    aTP_Lamp_yr: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ys____,type,
    aTP_Lamp_ys: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yt____,type,
    aTP_Lamp_yt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yu____,type,
    aTP_Lamp_yu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yv____,type,
    aTP_Lamp_yv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yw____,type,
    aTP_Lamp_yw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yx____,type,
    aTP_Lamp_yx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yy____,type,
    aTP_Lamp_yy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__yz____,type,
    aTP_Lamp_yz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__za____,type,
    aTP_Lamp_za: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zb____,type,
    aTP_Lamp_zb: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zc____,type,
    aTP_Lamp_zc: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zd____,type,
    aTP_Lamp_zd: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__ze____,type,
    aTP_Lamp_ze: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zf____,type,
    aTP_Lamp_zf: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zg____,type,
    aTP_Lamp_zg: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zh____,type,
    aTP_Lamp_zh: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zi____,type,
    aTP_Lamp_zi: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zj____,type,
    aTP_Lamp_zj: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zk____,type,
    aTP_Lamp_zk: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zl____,type,
    aTP_Lamp_zl: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zm____,type,
    aTP_Lamp_zm: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zn____,type,
    aTP_Lamp_zn: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zo____,type,
    aTP_Lamp_zo: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zp____,type,
    aTP_Lamp_zp: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zq____,type,
    aTP_Lamp_zq: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zr____,type,
    aTP_Lamp_zr: 
      !>[A: $tType,B: $tType] : fun(A,B) ).

tff(sy_c_ATP_058Lamp__zs____,type,
    aTP_Lamp_zs: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zt____,type,
    aTP_Lamp_zt: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zu____,type,
    aTP_Lamp_zu: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zv____,type,
    aTP_Lamp_zv: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zw____,type,
    aTP_Lamp_zw: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zx____,type,
    aTP_Lamp_zx: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zy____,type,
    aTP_Lamp_zy: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_ATP_058Lamp__zz____,type,
    aTP_Lamp_zz: 
      !>[A: $tType,B: $tType] : ( A > B ) ).

tff(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

tff(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > set(product_prod(A,B)) ) ).

tff(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,fun(C,$o)) * fun(B,fun(D,$o)) ) > fun(fun(A,B),fun(fun(C,D),$o)) ) ).

tff(sy_c_BNF__Greatest__Fixpoint_Oimage2p,type,
    bNF_Greatest_image2p: 
      !>[C: $tType,A: $tType,D: $tType,B: $tType] : ( ( fun(C,A) * fun(D,B) * fun(C,fun(D,$o)) ) > fun(A,fun(B,$o)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set(A) * set(B) ) > set(fun(A,B)) ) ).

tff(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set(B) * fun(C,A) * fun(B,D) ) > fun(fun(D,C),fun(B,A)) ) ).

tff(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( fun(A,nat) * fun(B,nat) * product_prod(A,B) ) > nat ) ).

tff(sy_c_Binomial_Obinomial,type,
    binomial: nat > fun(nat,nat) ).

tff(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > fun(nat,A) ) ).

tff(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: ( nat * int * int ) > int ).

tff(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: ( num * num ) > num ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > fun(A,A) ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( ( nat * A ) > A ) ).

tff(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > fun(nat,$o) ) ).

tff(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself(A) * nat ) > $o ) ).

tff(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: ( nat * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: ( num * num ) > option(num) ).

tff(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: ( num * num ) > option(num) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A ) > $o ) ).

tff(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,A)) * fun(A,A) * A * A * fun(A,fun(A,A)) ) > $o ) ).

tff(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > product_prod(code_integer,$o) ).

tff(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: ( code_integer * code_integer ) > product_prod(code_integer,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

tff(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: fun(int,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger__of__nat,type,
    code_integer_of_nat: fun(nat,code_integer) ).

tff(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

tff(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: fun(code_integer,nat) ).

tff(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

tff(sy_c_Code__Target__Nat_Oint__of__nat,type,
    code_T6385005292777649522of_nat: fun(nat,int) ).

tff(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Complex_OArg,type,
    arg: complex > real ).

tff(sy_c_Complex_Ocis,type,
    cis: real > complex ).

tff(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

tff(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: ( real * real ) > complex ).

tff(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

tff(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

tff(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

tff(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

tff(sy_c_Complex_Orcis,type,
    rcis: ( real * real ) > complex ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Countable__Set_Ocountable,type,
    countable_countable: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Countable__Set_Ofrom__nat__into,type,
    counta4804993851260445106t_into: 
      !>[A: $tType] : ( set(A) > fun(nat,A) ) ).

tff(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( fun(A,A) * A * filter(A) ) > $o ) ).

tff(sy_c_Divides_Oadjust__div,type,
    adjust_div: product_prod(int,int) > int ).

tff(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: ( int * int ) > int ).

tff(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: ( nat * nat ) > product_prod(nat,nat) ).

tff(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: ( int * int * product_prod(int,int) ) > $o ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( product_prod(A,A) > $o ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( ( num * num ) > product_prod(A,A) ) ).

tff(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( ( num * product_prod(A,A) ) > product_prod(A,A) ) ).

tff(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

tff(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

tff(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( fun(nat,T) * T * extended_enat ) > $o ) ).

tff(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

tff(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( ( A * nat ) > A ) ).

tff(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

tff(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Filter_Oabstract__filter,type,
    abstract_filter: 
      !>[A: $tType] : ( fun(product_unit,filter(A)) > filter(A) ) ).

tff(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( fun(A,$o) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) ) > filter(A) ) ).

tff(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(B) * filter(A) ) > $o ) ).

tff(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( set(A) > filter(set(A)) ) ).

tff(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * filter(A) ) > filter(B) ) ).

tff(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( set(A) > filter(A) ) ).

tff(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * filter(B) ) > filter(product_prod(A,B)) ) ).

tff(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : fun(set(B),nat) ).

tff(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : fun(set(A),$o) ).

tff(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) ) > B ) ).

tff(sy_c_Finite__Set_Ofold__graph,type,
    finite_fold_graph: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B * set(A) * B ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,fun(B,B)) ) > $o ) ).

tff(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * B ) > fun(set(A),B) ) ).

tff(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) * set(B) ) > $o ) ).

tff(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( fun(B,C) > fun(fun(A,B),fun(A,C)) ) ).

tff(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A * B ) > fun(A,B) ) ).

tff(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(A) ) > $o ) ).

tff(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( fun(C,A) * fun(B,D) ) > fun(fun(A,B),fun(C,D)) ) ).

tff(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * B ) > A ) ).

tff(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( fun(A,nat) > $o ) ).

tff(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set(product_prod(product_prod(nat,nat),product_prod(nat,nat))) ).

tff(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_GCD_Obezw,type,
    bezw: ( nat * nat ) > product_prod(int,int) ).

tff(sy_c_GCD_Obezw__rel,type,
    bezw_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A * fun(A,A) ) > $o ) ).

tff(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * A ) > fun(set(A),A) ) ).

tff(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( itself(A) > nat ) ).

tff(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

tff(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(set(B),A)) ).

tff(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( fun(C,A) * set(C) ) > A ) ).

tff(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : fun(fun(B,A),fun(A,fun(list(B),A))) ).

tff(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : fun(list(A),A) ).

tff(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( ( A * B ) > $o ) ).

tff(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set(A) * nat ) > A ) ).

tff(sy_c_Int_OAbs__Integ,type,
    abs_Integ: fun(product_prod(nat,nat),int) ).

tff(sy_c_Int_ORep__Integ,type,
    rep_Integ: fun(int,product_prod(nat,nat)) ).

tff(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > set(product_prod(int,int)) ).

tff(sy_c_Int_Ointrel,type,
    intrel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Int_Onat,type,
    nat2: fun(int,nat) ).

tff(sy_c_Int_Opcr__int,type,
    pcr_int: fun(product_prod(nat,nat),fun(int,$o)) ).

tff(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( ( A * int ) > A ) ).

tff(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : fun(int,A) ).

tff(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * A * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(set(A),A) ) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : fun(set(A),A) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * fun(B,$o) ) > B ) ).

tff(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * set(B) ) > B ) ).

tff(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( fun(A,fun(A,A)) * fun(A,fun(A,$o)) * fun(A,fun(A,$o)) ) > $o ) ).

tff(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( set(A) > A ) ).

tff(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * filter(A) ) > $o ) ).

tff(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : filter(A) ).

tff(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > list(A) ) ).

tff(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : fun(list(A),list(A)) ).

tff(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( list(list(A)) > list(A) ) ).

tff(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( list(A) > set(A) ) ).

tff(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( list(A) > fun(A,nat) ) ).

tff(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( list(A) > $o ) ).

tff(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(product_prod(nat,A)) ) ).

tff(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > option(A) ) ).

tff(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * set(B) * fun(B,A) ) > $o ) ).

tff(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(B,B)) * list(A) ) > fun(B,B) ) ).

tff(sy_c_List_Ogen__length,type,
    gen_length: 
      !>[A: $tType] : ( nat > fun(list(A),nat) ) ).

tff(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( fun(A,fun(A,$o)) * fun(B,A) * set(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( fun(B,A) * B * list(B) ) > list(B) ) ).

tff(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( set(A) > list(A) ) ).

tff(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > fun(list(A),list(A)) ) ).

tff(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : list(A) ).

tff(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( list(A) > A ) ).

tff(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > fun(list(A),fun(list(B),$o)) ) ).

tff(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( fun(A,Aa) * list(A) ) > list(Aa) ) ).

tff(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : fun(list(A),set(A)) ).

tff(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( fun(A,nat) * list(A) ) > nat ) ).

tff(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list(A) * nat * A ) > list(A) ) ).

tff(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( set(A) > set(list(A)) ) ).

tff(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(list(A)) ) ).

tff(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( list(A) > fun(nat,A) ) ).

tff(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list(A) * set(nat) ) > list(A) ) ).

tff(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( ( A * list(A) ) > list(A) ) ).

tff(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( ( nat * A ) > list(A) ) ).

tff(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > fun(list(A),list(A)) ) ).

tff(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( list(A) > list(A) ) ).

tff(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list(A) * list(A) ) > set(list(A)) ) ).

tff(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * list(A) ) > $o ) ).

tff(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( list(A) > list(list(A)) ) ).

tff(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( ( nat * list(A) ) > list(A) ) ).

tff(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( fun(A,$o) * list(A) ) > list(A) ) ).

tff(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( list(list(A)) > list(list(A)) ) ).

tff(sy_c_List_Oupt,type,
    upt: ( nat * nat ) > list(nat) ).

tff(sy_c_List_Oupto,type,
    upto: ( int * int ) > list(int) ).

tff(sy_c_List_Oupto__aux,type,
    upto_aux: ( int * int * list(int) ) > list(int) ).

tff(sy_c_List_Oupto__rel,type,
    upto_rel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list(A) * list(B) ) > list(product_prod(A,B)) ) ).

tff(sy_c_Nat_OSuc,type,
    suc: fun(nat,nat) ).

tff(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : fun(nat,fun(A,A)) ).

tff(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : fun(nat,fun(fun(A,A),fun(A,A))) ).

tff(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( ( A * fun(nat,A) * nat ) > A ) ).

tff(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

tff(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : fun(T,fun(fun(nat,fun(T,T)),fun(nat,T))) ).

tff(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( ( T * fun(nat,fun(T,T)) * nat ) > fun(T,$o) ) ).

tff(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : fun(nat,A) ).

tff(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( fun(A,A) * nat * A ) > A ) ).

tff(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : fun(A,nat) ).

tff(sy_c_Nat__Bijection_Oint__decode,type,
    nat_int_decode: fun(nat,int) ).

tff(sy_c_Nat__Bijection_Oint__encode,type,
    nat_int_encode: fun(int,nat) ).

tff(sy_c_Nat__Bijection_Olist__decode,type,
    nat_list_decode: fun(nat,list(nat)) ).

tff(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: fun(nat,fun(nat,$o)) ).

tff(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: fun(list(nat),nat) ).

tff(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: fun(list(nat),fun(list(nat),$o)) ).

tff(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: fun(nat,product_prod(nat,nat)) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > fun(nat,product_prod(nat,nat)) ).

tff(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)) ).

tff(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: fun(product_prod(nat,nat),nat) ).

tff(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > set(nat) ).

tff(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: fun(set(nat),nat) ).

tff(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

tff(sy_c_NthRoot_Oroot,type,
    root: nat > fun(real,real) ).

tff(sy_c_NthRoot_Osqrt,type,
    sqrt: fun(real,real) ).

tff(sy_c_Num_OBitM,type,
    bitM: num > num ).

tff(sy_c_Num_Oinc,type,
    inc: num > num ).

tff(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

tff(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( ( num * num ) > A ) ).

tff(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

tff(sy_c_Num_Onum_OBit1,type,
    bit1: fun(num,num) ).

tff(sy_c_Num_Onum_OOne,type,
    one2: num ).

tff(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : fun(A,fun(fun(num,A),fun(fun(num,A),fun(num,A)))) ).

tff(sy_c_Num_Onum_Orec__num,type,
    rec_num: 
      !>[A: $tType] : fun(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)))) ).

tff(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

tff(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

tff(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : fun(num,A) ).

tff(sy_c_Num_Opow,type,
    pow: ( num * num ) > num ).

tff(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

tff(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

tff(sy_c_Num_Osqr,type,
    sqr: num > num ).

tff(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : option(A) ).

tff(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > option(A) ) ).

tff(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( ( B * fun(A,B) * option(A) ) > B ) ).

tff(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( fun(A,nat) * option(A) ) > nat ) ).

tff(sy_c_Order__Continuity_Ocountable__complete__lattice__class_Occlfp,type,
    order_532582986084564980_cclfp: 
      !>[A: $tType] : ( fun(A,A) > A ) ).

tff(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

tff(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,A)) ) ).

tff(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,fun(A,A)) ) ).

tff(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : fun(fun(A,B),$o) ).

tff(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( fun(A,fun(A,$o)) * fun(A,fun(A,$o)) * A ) > $o ) ).

tff(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

tff(sy_c_Partial__Function_Oflat__lub,type,
    partial_flat_lub: 
      !>[A: $tType] : ( ( A * set(A) ) > A ) ).

tff(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( ( A * fun(A,fun(A,A)) ) > fun(A,fun(nat,A)) ) ).

tff(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : fun(A,fun(nat,A)) ).

tff(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > fun(B,product_prod(A,B)) ) ).

tff(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,set(B)) ) > set(product_prod(A,B)) ) ).

tff(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : fun(fun(B,C),fun(product_prod(A,B),product_prod(A,C))) ).

tff(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( fun(A,C) * fun(B,D) * product_prod(A,B) ) > product_prod(C,D) ) ).

tff(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,C)) > fun(product_prod(A,B),C) ) ).

tff(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),A) ).

tff(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : fun(product_prod(A,B),B) ).

tff(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : itself(A) ).

tff(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: fun(product_prod(int,int),rat) ).

tff(sy_c_Rat_OFract,type,
    fract: fun(int,fun(int,rat)) ).

tff(sy_c_Rat_OFrct,type,
    frct: product_prod(int,int) > rat ).

tff(sy_c_Rat_ORep__Rat,type,
    rep_Rat: fun(rat,product_prod(int,int)) ).

tff(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

tff(sy_c_Rat_Onormalize,type,
    normalize: product_prod(int,int) > product_prod(int,int) ).

tff(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

tff(sy_c_Rat_Opcr__rat,type,
    pcr_rat: fun(product_prod(int,int),fun(rat,$o)) ).

tff(sy_c_Rat_Opositive,type,
    positive: fun(rat,$o) ).

tff(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > product_prod(int,int) ).

tff(sy_c_Rat_Oratrel,type,
    ratrel: fun(product_prod(int,int),fun(product_prod(int,int),$o)) ).

tff(sy_c_Real_OReal,type,
    real2: fun(fun(nat,rat),real) ).

tff(sy_c_Real_Ocauchy,type,
    cauchy: fun(nat,rat) > $o ).

tff(sy_c_Real_Opcr__real,type,
    pcr_real: fun(fun(nat,rat),fun(real,$o)) ).

tff(sy_c_Real_Opositive,type,
    positive2: fun(real,$o) ).

tff(sy_c_Real_Orealrel,type,
    realrel: fun(fun(nat,rat),fun(fun(nat,rat),$o)) ).

tff(sy_c_Real_Orep__real,type,
    rep_real: fun(real,fun(nat,rat)) ).

tff(sy_c_Real_Ovanishes,type,
    vanishes: fun(nat,rat) > $o ).

tff(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : set(A) ).

tff(sy_c_Real__Vector__Spaces_Obounded__bilinear,type,
    real_V2442710119149674383linear: 
      !>[A: $tType,B: $tType,C: $tType] : ( fun(A,fun(B,C)) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Oconstruct,type,
    real_V4425403222259421789struct: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) * A ) > B ) ).

tff(sy_c_Real__Vector__Spaces_Odependent,type,
    real_V358717886546972837endent: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Odim,type,
    real_Vector_dim: 
      !>[A: $tType] : ( set(A) > nat ) ).

tff(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( ( A * A ) > real ) ).

tff(sy_c_Real__Vector__Spaces_Oextend__basis,type,
    real_V4986007116245087402_basis: 
      !>[A: $tType] : ( set(A) > set(A) ) ).

tff(sy_c_Real__Vector__Spaces_Olinear,type,
    real_Vector_linear: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > $o ) ).

tff(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

tff(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

tff(sy_c_Real__Vector__Spaces_Orepresentation,type,
    real_V7696804695334737415tation: 
      !>[A: $tType] : ( ( set(A) * A ) > fun(A,real) ) ).

tff(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > fun(A,A) ) ).

tff(sy_c_Real__Vector__Spaces_Ospan,type,
    real_Vector_span: 
      !>[A: $tType] : ( set(A) > set(A) ) ).

tff(sy_c_Real__Vector__Spaces_Osubspace,type,
    real_Vector_subspace: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > $o ) ).

tff(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( ( A * A ) > $o ) ).

tff(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( ( A * A ) > A ) ).

tff(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : fun($o,A) ).

tff(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( fun(nat,A) > A ) ).

tff(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( fun(nat,A) * A ) > $o ) ).

tff(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( fun(A,$o) > set(A) ) ).

tff(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( set(A) > set(set(A)) ) ).

tff(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( fun(A,B) > fun(set(A),set(B)) ) ).

tff(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > fun(set(A),set(A)) ) ).

tff(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : fun(A,fun(set(A),set(A))) ).

tff(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * set(B) ) > set(A) ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( fun(nat,fun(A,A)) * nat * nat * A ) > A ) ).

tff(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),fun(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),$o)) ).

tff(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( ( A * A ) > set(A) ) ).

tff(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > set(A) ) ).

tff(sy_c_String_OCode_Oabort,type,
    abort: 
      !>[A: $tType] : ( ( literal * fun(product_unit,A) ) > A ) ).

tff(sy_c_String_OLiteral,type,
    literal2: ( $o * $o * $o * $o * $o * $o * $o * literal ) > literal ).

tff(sy_c_String_Ochar_OChar,type,
    char2: ( $o * $o * $o * $o * $o * $o * $o * $o ) > char ).

tff(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

tff(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : fun(char,A) ).

tff(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

tff(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : fun(A,char) ).

tff(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter(F) * fun(F,A) ) > A ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( ( A * set(A) ) > filter(A) ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oconnected,type,
    topolo1966860045006549960nected: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Oconvergent,type,
    topolo6863149650580417670ergent: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > filter(A) ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( fun(nat,A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( filter(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ocomplete,type,
    topolo2479028161051973599mplete: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( set(A) > $o ) ).

tff(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : filter(product_prod(A,A)) ).

tff(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set(A) * fun(A,B) ) > $o ) ).

tff(sy_c_Transcendental_Oarccos,type,
    arccos: fun(real,real) ).

tff(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oarcsin,type,
    arcsin: fun(real,real) ).

tff(sy_c_Transcendental_Oarctan,type,
    arctan: fun(real,real) ).

tff(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: fun(nat,real) ).

tff(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( fun(nat,A) > fun(nat,A) ) ).

tff(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Olog,type,
    log: real > fun(real,real) ).

tff(sy_c_Transcendental_Opi,type,
    pi: real ).

tff(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : fun(A,fun(A,A)) ).

tff(sy_c_Transcendental_Opowr__real,type,
    powr_real: fun(real,fun(real,real)) ).

tff(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: fun(nat,real) ).

tff(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : fun(A,A) ).

tff(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( fun(A,fun(B,$o)) > $o ) ).

tff(sy_c_Transitive__Closure_Oacyclic,type,
    transitive_acyclic: 
      !>[A: $tType] : ( set(product_prod(A,A)) > $o ) ).

tff(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( ( nat * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Orelpow,type,
    transitive_relpow: 
      !>[A: $tType] : fun(nat,fun(set(product_prod(A,A)),set(product_prod(A,A)))) ).

tff(sy_c_Transitive__Closure_Orelpowp,type,
    transitive_relpowp: 
      !>[A: $tType] : fun(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o)))) ).

tff(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( set(product_prod(A,A)) > set(product_prod(A,A)) ) ).

tff(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: ( $o * $o ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option(product_prod(nat,nat)) * nat * list(vEBT_VEBT) * vEBT_VEBT ) > vEBT_VEBT ).

tff(sy_c_VEBT__Definitions_OVEBT_Orec__VEBT,type,
    vEBT_rec_VEBT: 
      !>[A: $tType] : ( ( fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))) * fun($o,fun($o,A)) * vEBT_VEBT ) > A ) ).

tff(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: fun(vEBT_VEBT,nat) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > fun(nat,$o) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: ( nat * list(vEBT_VEBT) * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: ( nat * nat ) > nat ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: fun(product_prod(vEBT_VEBT,nat),fun(product_prod(vEBT_VEBT,nat),$o)) ).

tff(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: ( vEBT_VEBT * nat ) > $o ).

tff(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > set(nat) ).

tff(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( fun(A,fun(A,$o)) > fun(A,$o) ) ).

tff(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( fun(A,nat) * set(product_prod(A,A)) ) > set(product_prod(A,A)) ) ).

tff(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set(product_prod(nat,nat)) ).

tff(sy_c_aa,type,
    aa: 
      !>[A: $tType,B: $tType] : ( ( fun(A,B) * A ) > B ) ).

tff(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( fun(A,$o) > A ) ).

tff(sy_c_fequal,type,
    fequal: 
      !>[A: $tType] : fun(A,fun(A,$o)) ).

tff(sy_c_member,type,
    member: 
      !>[A: $tType] : ( ( A * set(A) ) > $o ) ).

tff(sy_v_thesis,type,
    thesis: $o ).

tff(sy_v_x,type,
    x: nat ).

% Relevant facts (9149)
tff(fact_0_that_I1_J,axiom,
    ! [N: nat] :
      ( ( x = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N) )
     => thesis ) ).

% that(1)
tff(fact_1_that_I2_J,axiom,
    ! [N: nat] :
      ( ( x = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,suc,N)) )
     => thesis ) ).

% that(2)
tff(fact_2_add__Suc__right,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% add_Suc_right
tff(fact_3_nat_Oinject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( aa(nat,nat,suc,X2) = aa(nat,nat,suc,Y2) )
    <=> ( X2 = Y2 ) ) ).

% nat.inject
tff(fact_4_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( aa(nat,nat,suc,Nat) = aa(nat,nat,suc,Nat2) )
    <=> ( Nat = Nat2 ) ) ).

% old.nat.inject
tff(fact_5_add__left__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add_left_cancel
tff(fact_6_add__right__cancel,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
        <=> ( B2 = C2 ) ) ) ).

% add_right_cancel
tff(fact_7_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),A2) )
     => ( aa(nat,nat,suc,A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,suc,A2)) ) ) ).

% nat_arith.suc1
tff(fact_8_add__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% add_Suc
tff(fact_9_add__Suc__shift,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,suc,N)) ) ).

% add_Suc_shift
tff(fact_10_Suc__inject,axiom,
    ! [Xa: nat,Y: nat] :
      ( ( aa(nat,nat,suc,Xa) = aa(nat,nat,suc,Y) )
     => ( Xa = Y ) ) ).

% Suc_inject
tff(fact_11_n__not__Suc__n,axiom,
    ! [N: nat] : ( N != aa(nat,nat,suc,N) ) ).

% n_not_Suc_n
tff(fact_12_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% ab_semigroup_add_class.add_ac(1)
tff(fact_13_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
tff(fact_14_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
tff(fact_15_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.left_commute
tff(fact_16_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) ) ) ).

% add.commute
tff(fact_17_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) )
        <=> ( B2 = C2 ) ) ) ).

% add.right_cancel
tff(fact_18_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) )
        <=> ( B2 = C2 ) ) ) ).

% add.left_cancel
tff(fact_19_add_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add.assoc
tff(fact_20_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% group_cancel.add2
tff(fact_21_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% group_cancel.add1
tff(fact_22_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
tff(fact_23_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% is_num_normalize(1)
tff(fact_24_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),N: nat,I: A] : ( semiri8178284476397505188at_aux(A,Inc,aa(nat,nat,suc,N),I) = semiri8178284476397505188at_aux(A,Inc,N,aa(A,A,Inc,I)) ) ) ).

% of_nat_aux.simps(2)
tff(fact_25_triangle__Suc,axiom,
    ! [N: nat] : ( nat_triangle(aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(N)),aa(nat,nat,suc,N)) ) ).

% triangle_Suc
tff(fact_26_mult__Suc__right,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ).

% mult_Suc_right
tff(fact_27_old_Onat_Osimps_I7_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,fun(A,A)),Nat: nat] : ( aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),F1),F2),aa(nat,nat,suc,Nat)) = aa(A,A,aa(nat,fun(A,A),F2,Nat),aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),F1),F2),Nat)) ) ).

% old.nat.simps(7)
tff(fact_28_of__nat__add,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_add
tff(fact_29_Suc__funpow,axiom,
    ! [N: nat] : ( aa(fun(nat,nat),fun(nat,nat),aa(nat,fun(fun(nat,nat),fun(nat,nat)),compow(fun(nat,nat)),N),suc) = aa(nat,fun(nat,nat),plus_plus(nat),N) ) ).

% Suc_funpow
tff(fact_30_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) )
    <=> ( ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
          & ( N = zero_zero(nat) ) )
        | ( ( M = zero_zero(nat) )
          & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% one_is_add
tff(fact_31_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
          & ( N = zero_zero(nat) ) )
        | ( ( M = zero_zero(nat) )
          & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ) ).

% add_is_1
tff(fact_32_Suc__eq__plus1__left,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),N) ) ).

% Suc_eq_plus1_left
tff(fact_33_plus__1__eq__Suc,axiom,
    aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)) = suc ).

% plus_1_eq_Suc
tff(fact_34_Suc__eq__plus1,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)) ) ).

% Suc_eq_plus1
tff(fact_35_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat,N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),M) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( M = N ) ) ) ).

% of_nat_eq_iff
tff(fact_36_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% add.right_neutral
tff(fact_37_double__zero__sym,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% double_zero_sym
tff(fact_38_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) = A2 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_left
tff(fact_39_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = A2 )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_left_right
tff(fact_40_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_left
tff(fact_41_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% add_cancel_right_right
tff(fact_42_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: fun(A,$o)] :
      ( member(A,A2,collect(A,P))
    <=> aa(A,$o,P,A2) ) ).

% mem_Collect_eq
tff(fact_43_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set(A)] : ( collect(A,aTP_Lamp_a(set(A),fun(A,$o),A3)) = A3 ) ).

% Collect_mem_eq
tff(fact_44_Collect__cong,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ! [X: A] :
          ( aa(A,$o,P,X)
        <=> aa(A,$o,Q,X) )
     => ( collect(A,P) = collect(A,Q) ) ) ).

% Collect_cong
tff(fact_45_ext,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),G: fun(A,B)] :
      ( ! [X: A] : ( aa(A,B,F3,X) = aa(A,B,G,X) )
     => ( F3 = G ) ) ).

% ext
tff(fact_46_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y) = zero_zero(A) )
        <=> ( ( Xa = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
tff(fact_47_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Xa: A,Y: A] :
          ( ( zero_zero(A) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y) )
        <=> ( ( Xa = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
tff(fact_48_add__0,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% add_0
tff(fact_49_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),one_one(A)) = A2 ) ) ).

% mult.right_neutral
tff(fact_50_mult__1,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A2) = A2 ) ) ).

% mult_1
tff(fact_51_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = zero_zero(nat) )
    <=> ( ( M = zero_zero(nat) )
        & ( N = zero_zero(nat) ) ) ) ).

% add_is_0
tff(fact_52_Nat_Oadd__0__right,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),zero_zero(nat)) = M ) ).

% Nat.add_0_right
tff(fact_53_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = zero_zero(nat) )
    <=> ( ( M = zero_zero(nat) )
        | ( N = zero_zero(nat) ) ) ) ).

% mult_is_0
tff(fact_54_mult__0__right,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),zero_zero(nat)) = zero_zero(nat) ) ).

% mult_0_right
tff(fact_55_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N) )
    <=> ( ( M = N )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel1
tff(fact_56_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K) )
    <=> ( ( M = N )
        | ( K = zero_zero(nat) ) ) ) ).

% mult_cancel2
tff(fact_57_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( one_one(nat) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) )
    <=> ( ( M = one_one(nat) )
        & ( N = one_one(nat) ) ) ) ).

% nat_1_eq_mult_iff
tff(fact_58_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = one_one(nat) )
    <=> ( ( M = one_one(nat) )
        & ( N = one_one(nat) ) ) ) ).

% nat_mult_eq_1_iff
tff(fact_59_funpow__0,axiom,
    ! [A: $tType,F3: fun(A,A),Xa: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),zero_zero(nat)),F3),Xa) = Xa ) ).

% funpow_0
tff(fact_60_old_Onat_Osimps_I6_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,fun(A,A))] : ( aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),F1),F2),zero_zero(nat)) = F1 ) ).

% old.nat.simps(6)
tff(fact_61_triangle__0,axiom,
    nat_triangle(zero_zero(nat)) = zero_zero(nat) ).

% triangle_0
tff(fact_62_of__nat__0,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),zero_zero(nat)) = zero_zero(A) ) ) ).

% of_nat_0
tff(fact_63_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( zero_zero(A) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( zero_zero(nat) = N ) ) ) ).

% of_nat_0_eq_iff
tff(fact_64_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),M) = zero_zero(A) )
        <=> ( M = zero_zero(nat) ) ) ) ).

% of_nat_eq_0_iff
tff(fact_65_of__nat__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_mult
tff(fact_66_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,suc,zero_zero(nat)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) )
    <=> ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
        & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% one_eq_mult_iff
tff(fact_67_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( M = aa(nat,nat,suc,zero_zero(nat)) )
        & ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% mult_eq_1_iff
tff(fact_68_of__nat__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),one_one(nat)) = one_one(A) ) ) ).

% of_nat_1
tff(fact_69_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( one_one(A) = aa(nat,A,semiring_1_of_nat(A),N) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_1_eq_iff
tff(fact_70_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),N) = one_one(A) )
        <=> ( N = one_one(nat) ) ) ) ).

% of_nat_eq_1_iff
tff(fact_71_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),M)) ) ) ).

% of_nat_Suc
tff(fact_72_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Inc: fun(A,A),I: A] : ( semiri8178284476397505188at_aux(A,Inc,zero_zero(nat),I) = I ) ) ).

% of_nat_aux.simps(1)
tff(fact_73_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
tff(fact_74_mult__0,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),zero_zero(nat)),N) = zero_zero(nat) ) ).

% mult_0
tff(fact_75_of__nat__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% of_nat_def
tff(fact_76_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),one_one(A)),A2) = A2 ) ) ).

% comm_monoid_mult_class.mult_1
tff(fact_77_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( semigroup_mult(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.assoc
tff(fact_78_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Xa: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Xa)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,semiring_1_of_nat(A),Xa)) ) ) ).

% mult_of_nat_commute
tff(fact_79_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2) ) ) ).

% mult.commute
tff(fact_80_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),one_one(A)) = A2 ) ) ).

% mult.comm_neutral
tff(fact_81_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% mult.left_commute
tff(fact_82_nat__mult__1,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),one_one(nat)),N) = N ) ).

% nat_mult_1
tff(fact_83_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F3)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),F3) ) ).

% funpow_mult
tff(fact_84_funpow__swap1,axiom,
    ! [A: $tType,F3: fun(A,A),N: nat,Xa: A] : ( aa(A,A,F3,aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),Xa)) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),aa(A,A,F3,Xa)) ) ).

% funpow_swap1
tff(fact_85_one__reorient,axiom,
    ! [A: $tType] :
      ( one(A)
     => ! [Xa: A] :
          ( ( one_one(A) = Xa )
        <=> ( Xa = one_one(A) ) ) ) ).

% one_reorient
tff(fact_86_zero__reorient,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [Xa: A] :
          ( ( zero_zero(A) = Xa )
        <=> ( Xa = zero_zero(A) ) ) ) ).

% zero_reorient
tff(fact_87_nat__mult__1__right,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),one_one(nat)) = N ) ).

% nat_mult_1_right
tff(fact_88_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N) )
     => ( ( N = one_one(nat) )
        | ( M = zero_zero(nat) ) ) ) ).

% mult_eq_self_implies_10
tff(fact_89_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N)) != zero_zero(A) ) ) ).

% of_nat_neq_0
tff(fact_90_One__nat__def,axiom,
    one_one(nat) = aa(nat,nat,suc,zero_zero(nat)) ).

% One_nat_def
tff(fact_91_list__decode_Ocases,axiom,
    ! [Xa: nat] :
      ( ( Xa != zero_zero(nat) )
     => ~ ! [N2: nat] : ( Xa != aa(nat,nat,suc,N2) ) ) ).

% list_decode.cases
tff(fact_92_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),N) )
    <=> ( M = N ) ) ).

% Suc_mult_cancel1
tff(fact_93_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)) ) ).

% add_mult_distrib
tff(fact_94_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) ) ).

% add_mult_distrib2
tff(fact_95_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% comm_monoid_add_class.add_0
tff(fact_96_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% add.comm_neutral
tff(fact_97_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A)),A2) = A2 ) ) ).

% add.group_left_neutral
tff(fact_98_nat_Odistinct_I1_J,axiom,
    ! [X2: nat] : ( zero_zero(nat) != aa(nat,nat,suc,X2) ) ).

% nat.distinct(1)
tff(fact_99_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat2: nat] : ( aa(nat,nat,suc,Nat2) != zero_zero(nat) ) ).

% old.nat.distinct(2)
tff(fact_100_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] : ( zero_zero(nat) != aa(nat,nat,suc,Nat2) ) ).

% old.nat.distinct(1)
tff(fact_101_nat_OdiscI,axiom,
    ! [Nat: nat,X2: nat] :
      ( ( Nat = aa(nat,nat,suc,X2) )
     => ( Nat != zero_zero(nat) ) ) ).

% nat.discI
tff(fact_102_old_Onat_Oexhaust,axiom,
    ! [Y: nat] :
      ( ( Y != zero_zero(nat) )
     => ~ ! [Nat3: nat] : ( Y != aa(nat,nat,suc,Nat3) ) ) ).

% old.nat.exhaust
tff(fact_103_nat__induct,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N2: nat] :
            ( aa(nat,$o,P,N2)
           => aa(nat,$o,P,aa(nat,nat,suc,N2)) )
       => aa(nat,$o,P,N) ) ) ).

% nat_induct
tff(fact_104_diff__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),M: nat,N: nat] :
      ( ! [X: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,X),zero_zero(nat))
     => ( ! [Y3: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,zero_zero(nat)),aa(nat,nat,suc,Y3))
       => ( ! [X: nat,Y3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),P,X),Y3)
             => aa(nat,$o,aa(nat,fun(nat,$o),P,aa(nat,nat,suc,X)),aa(nat,nat,suc,Y3)) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,M),N) ) ) ) ).

% diff_induct
tff(fact_105_zero__induct,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [N2: nat] :
            ( aa(nat,$o,P,aa(nat,nat,suc,N2))
           => aa(nat,$o,P,N2) )
       => aa(nat,$o,P,zero_zero(nat)) ) ) ).

% zero_induct
tff(fact_106_Suc__neq__Zero,axiom,
    ! [M: nat] : ( aa(nat,nat,suc,M) != zero_zero(nat) ) ).

% Suc_neq_Zero
tff(fact_107_Zero__neq__Suc,axiom,
    ! [M: nat] : ( zero_zero(nat) != aa(nat,nat,suc,M) ) ).

% Zero_neq_Suc
tff(fact_108_Zero__not__Suc,axiom,
    ! [M: nat] : ( zero_zero(nat) != aa(nat,nat,suc,M) ) ).

% Zero_not_Suc
tff(fact_109_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => ? [M2: nat] : ( N = aa(nat,nat,suc,M2) ) ) ).

% not0_implies_Suc
tff(fact_110_plus__nat_Oadd__0,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),zero_zero(nat)),N) = N ) ).

% plus_nat.add_0
tff(fact_111_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N) = M )
     => ( N = zero_zero(nat) ) ) ).

% add_eq_self_zero
tff(fact_112_mult__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ).

% mult_Suc
tff(fact_113_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = zero_zero(A) )
        <=> ( ( Xa = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_eq_zero_iff
tff(fact_114_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = one_one(A) ) ) ) ) ).

% mult_cancel_right2
tff(fact_115_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_right1
tff(fact_116_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = C2 )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = one_one(A) ) ) ) ) ).

% mult_cancel_left2
tff(fact_117_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [C2: A,B2: A] :
          ( ( C2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( B2 = one_one(A) ) ) ) ) ).

% mult_cancel_left1
tff(fact_118_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% double_eq_0_iff
tff(fact_119_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
tff(fact_120_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
tff(fact_121_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% mult_eq_0_iff
tff(fact_122_mult__zero__right,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% mult_zero_right
tff(fact_123_mult__zero__left,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% mult_zero_left
tff(fact_124_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [R: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R != zero_zero(A) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),R),C2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),R),D2)) ) ) ) ) ).

% add_scale_eq_noteq
tff(fact_125_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),Z)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))),Z) ) ).

% zadd_int_left
tff(fact_126_mult__not__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) != zero_zero(A) )
         => ( ( A2 != zero_zero(A) )
            & ( B2 != zero_zero(A) ) ) ) ) ).

% mult_not_zero
tff(fact_127_divisors__zero,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = zero_zero(A) )
         => ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divisors_zero
tff(fact_128_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( semiri3467727345109120633visors(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) != zero_zero(A) ) ) ) ) ).

% no_zero_divisors
tff(fact_129_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) )
          <=> ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
tff(fact_130_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( semiri6575147826004484403cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) )
          <=> ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
tff(fact_131_zero__neq__one,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( zero_zero(A) != one_one(A) ) ) ).

% zero_neq_one
tff(fact_132_add__0__iff,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [B2: A,A2: A] :
          ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% add_0_iff
tff(fact_133_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),D2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% crossproduct_noteq
tff(fact_134_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( semiri1453513574482234551roduct(A)
     => ! [W: A,Y: A,Xa: A,Z: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),W),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y)) )
        <=> ( ( W = Xa )
            | ( Y = Z ) ) ) ) ).

% crossproduct_eq
tff(fact_135_combine__common__factor,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,E: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),E)),C2) ) ) ).

% combine_common_factor
tff(fact_136_distrib__right,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% distrib_right
tff(fact_137_distrib__left,axiom,
    ! [A: $tType] :
      ( semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% distrib_left
tff(fact_138_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( comm_semiring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% comm_semiring_class.distrib
tff(fact_139_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% ring_class.ring_distribs(1)
tff(fact_140_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% ring_class.ring_distribs(2)
tff(fact_141_relpowp__1,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o))] : ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),one_one(nat)),P) = P ) ).

% relpowp_1
tff(fact_142_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] : ( funpow(A) = compow(fun(A,A)) ) ).

% Nat.funpow_code_def
tff(fact_143_left__add__mult__distrib,axiom,
    ! [I: nat,U: nat,J: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J)),U)),K) ) ).

% left_add_mult_distrib
tff(fact_144_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N) )
    <=> ( ( K = zero_zero(nat) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
tff(fact_145_Euclid__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),A2: nat,B2: nat] :
      ( ! [A4: nat,B4: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),P,A4),B4)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),P,B4),A4) )
     => ( ! [A4: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,A4),zero_zero(nat))
       => ( ! [A4: nat,B4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),P,A4),B4)
             => aa(nat,$o,aa(nat,fun(nat,$o),P,A4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),B4)) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,A2),B2) ) ) ) ).

% Euclid_induct
tff(fact_146_relpowp__E,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),Xa: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Xa),Z)
     => ( ( ( N = zero_zero(nat) )
         => ( Xa != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N = aa(nat,nat,suc,M2) )
             => ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),M2),P),Xa),Y3)
               => ~ aa(A,$o,aa(A,fun(A,$o),P,Y3),Z) ) ) ) ) ).

% relpowp_E
tff(fact_147_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),Xa: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Xa),Z)
     => ( ( ( N = zero_zero(nat) )
         => ( Xa != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N = aa(nat,nat,suc,M2) )
             => ( aa(A,$o,aa(A,fun(A,$o),P,Xa),Y3)
               => ~ aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),M2),P),Y3),Z) ) ) ) ) ).

% relpowp_E2
tff(fact_148_exists__least__lemma,axiom,
    ! [P: fun(nat,$o)] :
      ( ~ aa(nat,$o,P,zero_zero(nat))
     => ( ? [X_1: nat] : aa(nat,$o,P,X_1)
       => ? [N2: nat] :
            ( ~ aa(nat,$o,P,N2)
            & aa(nat,$o,P,aa(nat,nat,suc,N2)) ) ) ) ).

% exists_least_lemma
tff(fact_149_dependent__nat__choice,axiom,
    ! [A: $tType,P: fun(nat,fun(A,$o)),Q: fun(nat,fun(A,fun(A,$o)))] :
      ( ? [X_1: A] : aa(A,$o,aa(nat,fun(A,$o),P,zero_zero(nat)),X_1)
     => ( ! [X: A,N2: nat] :
            ( aa(A,$o,aa(nat,fun(A,$o),P,N2),X)
           => ? [Y4: A] :
                ( aa(A,$o,aa(nat,fun(A,$o),P,aa(nat,nat,suc,N2)),Y4)
                & aa(A,$o,aa(A,fun(A,$o),aa(nat,fun(A,fun(A,$o)),Q,N2),X),Y4) ) )
       => ? [F4: fun(nat,A)] :
          ! [N3: nat] :
            ( aa(A,$o,aa(nat,fun(A,$o),P,N3),aa(nat,A,F4,N3))
            & aa(A,$o,aa(A,fun(A,$o),aa(nat,fun(A,fun(A,$o)),Q,N3),aa(nat,A,F4,N3)),aa(nat,A,F4,aa(nat,nat,suc,N3))) ) ) ) ).

% dependent_nat_choice
tff(fact_150_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),zero_zero(A)) = A2 ) ) ).

% verit_sum_simplify
tff(fact_151_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,zero_zero(A)) = one_one(A) ) ) ).

% dbl_inc_simps(2)
tff(fact_152_arcosh__1,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arcosh(A),one_one(A)) = zero_zero(A) ) ) ).

% arcosh_1
tff(fact_153_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z2: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z2)) ) ).

% int_distrib(2)
tff(fact_154_int__distrib_I1_J,axiom,
    ! [Z1: int,Z2: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z1),Z2)),W) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z2),W)) ) ).

% int_distrib(1)
tff(fact_155_plus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),zero_zero(int)),L) = L ) ).

% plus_int_code(2)
tff(fact_156_plus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),K),zero_zero(int)) = K ) ).

% plus_int_code(1)
tff(fact_157_odd__nonzero,axiom,
    ! [Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z) != zero_zero(int) ) ).

% odd_nonzero
tff(fact_158_relpowp__Suc__D2_H,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),X3: A,Y4: A,Z3: A] :
      ( ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),X3),Y4)
        & aa(A,$o,aa(A,fun(A,$o),P,Y4),Z3) )
     => ? [W2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),P,X3),W2)
          & aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),W2),Z3) ) ) ).

% relpowp_Suc_D2'
tff(fact_159_int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = aa(nat,int,semiring_1_of_nat(int),N) )
    <=> ( M = N ) ) ).

% int_int_eq
tff(fact_160_nat__int__comparison_I1_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 = B2 )
    <=> ( aa(nat,int,semiring_1_of_nat(int),A2) = aa(nat,int,semiring_1_of_nat(int),B2) ) ) ).

% nat_int_comparison(1)
tff(fact_161_int__if,axiom,
    ! [P: $o,A2: nat,B2: nat] :
      ( aa(nat,int,semiring_1_of_nat(int),$ite((P),A2,B2))
      = $ite((P),aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_if
tff(fact_162_int__ops_I4_J,axiom,
    ! [A2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,A2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),one_one(int)) ) ).

% int_ops(4)
tff(fact_163_int__Suc,axiom,
    ! [N: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),one_one(int)) ) ).

% int_Suc
tff(fact_164_relpowp__Suc__E,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),Xa: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,N)),P),Xa),Z)
     => ~ ! [Y3: A] :
            ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Xa),Y3)
           => ~ aa(A,$o,aa(A,fun(A,$o),P,Y3),Z) ) ) ).

% relpowp_Suc_E
tff(fact_165_relpowp__Suc__I,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),Xa: A,Y: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Xa),Y)
     => ( aa(A,$o,aa(A,fun(A,$o),P,Y),Z)
       => aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,N)),P),Xa),Z) ) ) ).

% relpowp_Suc_I
tff(fact_166_relpowp__Suc__D2,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),Xa: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,N)),P),Xa),Z)
     => ? [Y3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),P,Xa),Y3)
          & aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Y3),Z) ) ) ).

% relpowp_Suc_D2
tff(fact_167_relpowp__Suc__E2,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),Xa: A,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,N)),P),Xa),Z)
     => ~ ! [Y3: A] :
            ( aa(A,$o,aa(A,fun(A,$o),P,Xa),Y3)
           => ~ aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Y3),Z) ) ) ).

% relpowp_Suc_E2
tff(fact_168_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xa: A,Y: A,N: nat,Z: A] :
      ( aa(A,$o,aa(A,fun(A,$o),P,Xa),Y)
     => ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Y),Z)
       => aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),aa(nat,nat,suc,N)),P),Xa),Z) ) ) ).

% relpowp_Suc_I2
tff(fact_169_int__ops_I1_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),zero_zero(nat)) = zero_zero(int) ).

% int_ops(1)
tff(fact_170_relpowp__0__I,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xa: A] : aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),P),Xa),Xa) ).

% relpowp_0_I
tff(fact_171_relpowp__0__E,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xa: A,Y: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),P),Xa),Y)
     => ( Xa = Y ) ) ).

% relpowp_0_E
tff(fact_172_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R2: fun(A,fun(A,$o))] : ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),zero_zero(nat)),R2) = fequal(A) ) ).

% relpowp.simps(1)
tff(fact_173_int__plus,axiom,
    ! [N: nat,M: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(nat,int,semiring_1_of_nat(int),M)) ) ).

% int_plus
tff(fact_174_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(5)
tff(fact_175_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),B2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% int_ops(7)
tff(fact_176_int__ops_I2_J,axiom,
    aa(nat,int,semiring_1_of_nat(int),one_one(nat)) = one_one(int) ).

% int_ops(2)
tff(fact_177_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Xa: A] : ( neg_numeral_dbl_inc(A,Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Xa)),one_one(A)) ) ) ).

% dbl_inc_def
tff(fact_178_artanh__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ( aa(A,A,artanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% artanh_0
tff(fact_179_arsinh__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,arsinh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% arsinh_0
tff(fact_180_relpowp__code__def,axiom,
    ! [A: $tType] : ( transitive_relpowp(A) = compow(fun(A,fun(A,$o))) ) ).

% relpowp_code_def
tff(fact_181_ln__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ( aa(A,A,ln_ln(A),one_one(A)) = zero_zero(A) ) ) ).

% ln_one
tff(fact_182_ntrancl__Zero,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( transitive_ntrancl(A,zero_zero(nat),R2) = R2 ) ).

% ntrancl_Zero
tff(fact_183_mult__eq__if,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)
      = $ite(M = zero_zero(nat),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),N))) ) ).

% mult_eq_if
tff(fact_184_add__eq__if,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)
      = $ite(M = zero_zero(nat),N,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),N))) ) ).

% add_eq_if
tff(fact_185_diffs__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [C2: fun(nat,A),X3: nat] : ( aa(nat,A,diffs(A,C2),X3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,X3))),aa(nat,A,C2,aa(nat,nat,suc,X3))) ) ) ).

% diffs_def
tff(fact_186_round__of__nat,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: nat] : ( archimedean_round(A,aa(nat,A,semiring_1_of_nat(A),N)) = aa(nat,int,semiring_1_of_nat(int),N) ) ) ).

% round_of_nat
tff(fact_187_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Xa: A] :
          ( aa(A,A,aa(A,fun(A,A),powr(A),Xa),zero_zero(A))
          = $ite(Xa = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% powr_zero_eq_one
tff(fact_188_convex__bound__le,axiom,
    ! [A: $tType] :
      ( linord6961819062388156250ring_1(A)
     => ! [Xa: A,A2: A,Y: A,U: A,V: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),U)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),V)
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A2) ) ) ) ) ) ) ).

% convex_bound_le
tff(fact_189_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(nat,nat,suc,M))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M) ) ).

% Suc_le_mono
tff(fact_190_le0,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),N) ).

% le0
tff(fact_191_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),A2) ).

% bot_nat_0.extremum
tff(fact_192_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% nat_add_left_cancel_le
tff(fact_193_diff__diff__cancel,axiom,
    ! [I: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),I)) = I ) ) ).

% diff_diff_cancel
tff(fact_194_le__zero__eq,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),N),zero_zero(A))
        <=> ( N = zero_zero(A) ) ) ) ).

% le_zero_eq
tff(fact_195_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_cancel_right
tff(fact_196_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_cancel_left
tff(fact_197_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A2) = zero_zero(A) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
tff(fact_198_diff__zero,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),zero_zero(A)) = A2 ) ) ).

% diff_zero
tff(fact_199_zero__diff,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% zero_diff
tff(fact_200_diff__0__right,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),zero_zero(A)) = A2 ) ) ).

% diff_0_right
tff(fact_201_diff__self,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A2) = zero_zero(A) ) ) ).

% diff_self
tff(fact_202_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = A2 ) ) ).

% add_diff_cancel_right'
tff(fact_203_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ).

% add_diff_cancel_right
tff(fact_204_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),A2) = B2 ) ) ).

% add_diff_cancel_left'
tff(fact_205_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ).

% add_diff_cancel_left
tff(fact_206_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),B2) = A2 ) ) ).

% diff_add_cancel
tff(fact_207_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2) = A2 ) ) ).

% add_diff_cancel
tff(fact_208_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ).

% of_nat_le_iff
tff(fact_209_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),K) ) ).

% Suc_diff_diff
tff(fact_210_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ).

% diff_Suc_Suc
tff(fact_211_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) = zero_zero(nat) ) ) ).

% diff_is_0_eq'
tff(fact_212_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) = zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% diff_is_0_eq
tff(fact_213_diff__self__eq__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),M) = zero_zero(nat) ) ).

% diff_self_eq_0
tff(fact_214_diff__0__eq__0,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),zero_zero(nat)),N) = zero_zero(nat) ) ).

% diff_0_eq_0
tff(fact_215_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J)),K) ) ) ).

% Nat.add_diff_assoc
tff(fact_216_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K)),I) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),I)),K) ) ) ).

% Nat.add_diff_assoc2
tff(fact_217_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J) ) ) ).

% Nat.diff_diff_right
tff(fact_218_diff__diff__left,axiom,
    ! [I: nat,J: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),K)) ) ).

% diff_diff_left
tff(fact_219_powr__0,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),powr(A),zero_zero(A)),Z) = zero_zero(A) ) ) ).

% powr_0
tff(fact_220_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [W: A,Z: A] :
          ( ( aa(A,A,aa(A,fun(A,A),powr(A),W),Z) = zero_zero(A) )
        <=> ( W = zero_zero(A) ) ) ) ).

% powr_eq_0_iff
tff(fact_221_powr__one__eq__one,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),powr(A),one_one(A)),A2) = one_one(A) ) ) ).

% powr_one_eq_one
tff(fact_222_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% add_le_same_cancel1
tff(fact_223_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% add_le_same_cancel2
tff(fact_224_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ).

% le_add_same_cancel1
tff(fact_225_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ).

% le_add_same_cancel2
tff(fact_226_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
tff(fact_227_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
tff(fact_228_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% diff_ge_0_iff_ge
tff(fact_229_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),B2) = A2 ) ) ) ).

% le_add_diff_inverse2
tff(fact_230_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = A2 ) ) ) ).

% le_add_diff_inverse
tff(fact_231_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),one_one(A)) = zero_zero(A) ) ) ).

% diff_numeral_special(9)
tff(fact_232_diff__add__zero,axiom,
    ! [A: $tType] :
      ( comm_monoid_diff(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = zero_zero(A) ) ) ).

% diff_add_zero
tff(fact_233_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),M)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),N) ) ) ).

% one_le_mult_iff
tff(fact_234_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K))),I) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,J)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I)) ) ) ).

% diff_Suc_diff_eq2
tff(fact_235_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,suc,J)) ) ) ).

% diff_Suc_diff_eq1
tff(fact_236_diff__Suc__1,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,N)),one_one(nat)) = N ) ).

% diff_Suc_1
tff(fact_237_round__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,zero_zero(A)) = zero_zero(int) ) ) ).

% round_0
tff(fact_238_round__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_round(A,one_one(A)) = one_one(int) ) ) ).

% round_1
tff(fact_239_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),M)),zero_zero(A))
        <=> ( M = zero_zero(nat) ) ) ) ).

% of_nat_le_0_iff
tff(fact_240_round__mono,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_round(A,Xa)),archimedean_round(A,Y)) ) ) ).

% round_mono
tff(fact_241_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
          | ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% verit_la_disequality
tff(fact_242_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),A2) ) ).

% verit_comp_simplify1(2)
tff(fact_243_of__nat__diff,axiom,
    ! [A: $tType] :
      ( semiring_1_cancel(A)
     => ! [N: nat,M: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ) ).

% of_nat_diff
tff(fact_244_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),M)) ) ).

% diff_le_mono2
tff(fact_245_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),C2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),C2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),A2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),C2),B2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),A2) ) ) ) ).

% le_diff_iff'
tff(fact_246_diff__le__self,axiom,
    ! [M: nat,N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),M) ).

% diff_le_self
tff(fact_247_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),L)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),L)) ) ).

% diff_le_mono
tff(fact_248_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ) ) ).

% Nat.diff_diff_eq
tff(fact_249_diff__commute,axiom,
    ! [I: nat,J: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),K)),J) ) ).

% diff_commute
tff(fact_250_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ) ).

% le_diff_iff
tff(fact_251_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
       => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K) )
        <=> ( M = N ) ) ) ) ).

% eq_diff_iff
tff(fact_252_diff__right__commute,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,C2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) ) ) ).

% diff_right_commute
tff(fact_253_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2) ) ) ) ).

% diff_eq_diff_less_eq
tff(fact_254_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% diff_right_mono
tff(fact_255_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% diff_left_mono
tff(fact_256_diff__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ) ).

% diff_mono
tff(fact_257_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( ( A2 = B2 )
          <=> ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
tff(fact_258_times__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),zero_zero(int)),L) = zero_zero(int) ) ).

% times_int_code(2)
tff(fact_259_times__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),K),zero_zero(int)) = zero_zero(int) ) ).

% times_int_code(1)
tff(fact_260_less__eq__int__code_I1_J,axiom,
    aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),zero_zero(int)) ).

% less_eq_int_code(1)
tff(fact_261_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),zero_zero(A)) ) ) ).

% le_iff_diff_le_0
tff(fact_262_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: A,K: A,N: A,J: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),N)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),K))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),N)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),K))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),N),K)),J) ) ) ) ) ) ).

% add_le_add_imp_diff_le
tff(fact_263_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: A,K: A,N: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),N)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),aa(A,A,aa(A,fun(A,A),minus_minus(A),N),K)) ) ) ).

% add_le_imp_le_diff
tff(fact_264_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% diff_le_eq
tff(fact_265_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% le_diff_eq
tff(fact_266_diff__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),A2) = B2 ) ) ) ).

% diff_add
tff(fact_267_le__add__diff,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2)) ) ) ).

% le_add_diff
tff(fact_268_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
tff(fact_269_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
tff(fact_270_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
tff(fact_271_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
tff(fact_272_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),C2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
tff(fact_273_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),B2) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
tff(fact_274_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
tff(fact_275_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
tff(fact_276_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) ) ) ).

% Suc_diff_le
tff(fact_277_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),N: nat,N4: nat] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N2)),aa(nat,A,F3,aa(nat,nat,suc,N2)))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N4)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N)),aa(nat,A,F3,N4)) ) ) ) ).

% lift_Suc_mono_le
tff(fact_278_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),N: nat,N4: nat] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,aa(nat,nat,suc,N2))),aa(nat,A,F3,N2))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N4)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N4)),aa(nat,A,F3,N)) ) ) ) ).

% lift_Suc_antimono_le
tff(fact_279_le__diff__conv,axiom,
    ! [J: nat,K: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K)),I)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)) ) ).

% le_diff_conv
tff(fact_280_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J) ) ) ).

% Nat.le_diff_conv2
tff(fact_281_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K)) ) ) ).

% Nat.diff_add_assoc
tff(fact_282_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),I)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K)),I) ) ) ).

% Nat.diff_add_assoc2
tff(fact_283_Nat_Ole__imp__diff__is__add,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),I) = K )
      <=> ( J = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),I) ) ) ) ).

% Nat.le_imp_diff_is_add
tff(fact_284_of__nat__mono,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [I: nat,J: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),I)),aa(nat,A,semiring_1_of_nat(A),J)) ) ) ).

% of_nat_mono
tff(fact_285_nat__int__comparison_I3_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% nat_int_comparison(3)
tff(fact_286_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% zle_int
tff(fact_287_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E)),D2)) ) ) ).

% ordered_ring_class.le_add_iff2
tff(fact_288_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E)),C2)),D2) ) ) ).

% ordered_ring_class.le_add_iff1
tff(fact_289_nat__diff__add__eq2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),I)),U)),N)) ) ) ).

% nat_diff_add_eq2
tff(fact_290_nat__diff__add__eq1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),I)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J)),U)),M)),N) ) ) ).

% nat_diff_add_eq1
tff(fact_291_nat__le__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),I)),U)),N)) ) ) ).

% nat_le_add_iff2
tff(fact_292_nat__le__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),I)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J)),U)),M)),N) ) ) ).

% nat_le_add_iff1
tff(fact_293_nat__eq__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N) )
      <=> ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),I)),U)),N) ) ) ) ).

% nat_eq_add_iff2
tff(fact_294_nat__eq__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),I)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N) )
      <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J)),U)),M) = N ) ) ) ).

% nat_eq_add_iff1
tff(fact_295_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = zero_zero(A) ) ) ) ).

% eq_iff_diff_eq_0
tff(fact_296_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% left_diff_distrib
tff(fact_297_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% right_diff_distrib
tff(fact_298_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [B2: A,C2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) ) ) ).

% left_diff_distrib'
tff(fact_299_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% right_diff_distrib'
tff(fact_300_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( cancel2418104881723323429up_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% diff_diff_eq
tff(fact_301_add__implies__diff,axiom,
    ! [A: $tType] :
      ( cancel1802427076303600483id_add(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) = A2 )
         => ( C2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) ) ) ) ).

% add_implies_diff
tff(fact_302_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),B2) ) ) ).

% diff_add_eq_diff_diff_swap
tff(fact_303_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ).

% diff_add_eq
tff(fact_304_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ).

% diff_diff_eq2
tff(fact_305_add__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% add_diff_eq
tff(fact_306_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = C2 ) ) ) ).

% eq_diff_eq
tff(fact_307_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = C2 )
        <=> ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2) ) ) ) ).

% diff_eq_eq
tff(fact_308_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A3),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% group_cancel.sub1
tff(fact_309_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),zero_zero(A)) ) ).

% le_numeral_extra(3)
tff(fact_310_zero__le,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa) ) ).

% zero_le
tff(fact_311_zero__induct__lemma,axiom,
    ! [P: fun(nat,$o),K: nat,I: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [N2: nat] :
            ( aa(nat,$o,P,aa(nat,nat,suc,N2))
           => aa(nat,$o,P,N2) )
       => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I)) ) ) ).

% zero_induct_lemma
tff(fact_312_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) = zero_zero(nat) )
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M) = zero_zero(nat) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
tff(fact_313_minus__nat_Odiff__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),zero_zero(nat)) = M ) ).

% minus_nat.diff_0
tff(fact_314_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),one_one(A)) ) ).

% le_numeral_extra(4)
tff(fact_315_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_imp_le_right
tff(fact_316_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% add_le_imp_le_left
tff(fact_317_le__iff__add,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ? [C3: A] : ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C3) ) ) ) ).

% le_iff_add
tff(fact_318_add__right__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add_right_mono
tff(fact_319_less__eqE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ~ ! [C4: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C4) ) ) ) ).

% less_eqE
tff(fact_320_add__left__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% add_left_mono
tff(fact_321_add__mono,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_mono
tff(fact_322_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),J)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_semiring(1)
tff(fact_323_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_semiring(2)
tff(fact_324_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),J)
            & ( K = L ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_semiring(3)
tff(fact_325_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),N) = M ) ).

% diff_add_inverse2
tff(fact_326_diff__add__inverse,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),N) = M ) ).

% diff_add_inverse
tff(fact_327_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ).

% diff_cancel2
tff(fact_328_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ).

% Nat.diff_cancel
tff(fact_329_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R2: fun(nat,fun(nat,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( ! [X: nat] : aa(nat,$o,aa(nat,fun(nat,$o),R2,X),X)
       => ( ! [X: nat,Y3: nat,Z4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),R2,X),Y3)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),R2,Y3),Z4)
               => aa(nat,$o,aa(nat,fun(nat,$o),R2,X),Z4) ) )
         => ( ! [N2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),R2,N2),aa(nat,nat,suc,N2))
           => aa(nat,$o,aa(nat,fun(nat,$o),R2,M),N) ) ) ) ) ).

% transitive_stepwise_le
tff(fact_330_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(nat,$o,P,M)
       => ( ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N2)
             => ( aa(nat,$o,P,N2)
               => aa(nat,$o,P,aa(nat,nat,suc,N2)) ) )
         => aa(nat,$o,P,N) ) ) ) ).

% nat_induct_at_least
tff(fact_331_full__nat__induct,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M3)),N2)
             => aa(nat,$o,P,M3) )
         => aa(nat,$o,P,N2) )
     => aa(nat,$o,P,N) ) ).

% full_nat_induct
tff(fact_332_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),M) ) ).

% not_less_eq_eq
tff(fact_333_Suc__n__not__le__n,axiom,
    ! [N: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),N) ).

% Suc_n_not_le_n
tff(fact_334_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
        | ( M = aa(nat,nat,suc,N) ) ) ) ).

% le_Suc_eq
tff(fact_335_Suc__le__D,axiom,
    ! [N: nat,M4: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),M4)
     => ? [M2: nat] : ( M4 = aa(nat,nat,suc,M2) ) ) ).

% Suc_le_D
tff(fact_336_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N)) ) ).

% le_SucI
tff(fact_337_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N))
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
       => ( M = aa(nat,nat,suc,N) ) ) ) ).

% le_SucE
tff(fact_338_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% Suc_leD
tff(fact_339_le__0__eq,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),zero_zero(nat))
    <=> ( N = zero_zero(nat) ) ) ).

% le_0_eq
tff(fact_340_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),zero_zero(nat))
     => ( A2 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_uniqueI
tff(fact_341_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),zero_zero(nat))
    <=> ( A2 = zero_zero(nat) ) ) ).

% bot_nat_0.extremum_unique
tff(fact_342_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),zero_zero(nat)),N) ).

% less_eq_nat.simps(1)
tff(fact_343_real__arch__simple,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
        ? [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(nat,A,semiring_1_of_nat(A),N2)) ) ).

% real_arch_simple
tff(fact_344_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) ) ).

% diff_mult_distrib2
tff(fact_345_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)) ) ).

% diff_mult_distrib
tff(fact_346_nat__le__iff__add,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
    <=> ? [K2: nat] : ( N = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K2) ) ) ).

% nat_le_iff_add
tff(fact_347_trans__le__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),J)) ) ).

% trans_le_add2
tff(fact_348_trans__le__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),M)) ) ).

% trans_le_add1
tff(fact_349_add__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),K)) ) ).

% add_le_mono1
tff(fact_350_add__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),L)) ) ) ).

% add_le_mono
tff(fact_351_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
     => ? [N2: nat] : ( L = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N2) ) ) ).

% le_Suc_ex
tff(fact_352_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N) ) ).

% add_leD2
tff(fact_353_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% add_leD1
tff(fact_354_le__add2,axiom,
    ! [N: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ).

% le_add2
tff(fact_355_le__add1,axiom,
    ! [N: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)) ).

% le_add1
tff(fact_356_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),N)
     => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N) ) ) ).

% add_leE
tff(fact_357_mult__le__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J)) ) ).

% mult_le_mono2
tff(fact_358_mult__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),K)) ) ).

% mult_le_mono1
tff(fact_359_mult__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),L)) ) ) ).

% mult_le_mono
tff(fact_360_le__square,axiom,
    ! [M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),M)) ).

% le_square
tff(fact_361_le__cube,axiom,
    ! [M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),M))) ).

% le_cube
tff(fact_362_int__ge__induct,axiom,
    ! [K: int,I: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I)
     => ( aa(int,$o,P,K)
       => ( ! [I2: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I2)
             => ( aa(int,$o,P,I2)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int))) ) )
         => aa(int,$o,P,I) ) ) ) ).

% int_ge_induct
tff(fact_363_nonneg__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ~ ! [N2: nat] : ( K != aa(nat,int,semiring_1_of_nat(int),N2) ) ) ).

% nonneg_int_cases
tff(fact_364_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ? [N2: nat] : ( K = aa(nat,int,semiring_1_of_nat(int),N2) ) ) ).

% zero_le_imp_eq_int
tff(fact_365_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( comm_ring(A)
     => ! [Xa: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) ) ) ).

% square_diff_square_factored
tff(fact_366_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2) )
        <=> ( C2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E)),D2) ) ) ) ).

% eq_add_iff2
tff(fact_367_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E)),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E)),C2) = D2 ) ) ) ).

% eq_add_iff1
tff(fact_368_mult__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_mono
tff(fact_369_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_mono'
tff(fact_370_zero__le__square,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)) ) ).

% zero_le_square
tff(fact_371_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% split_mult_pos_le
tff(fact_372_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_left_mono_neg
tff(fact_373_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_nonpos_nonpos
tff(fact_374_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_left_mono
tff(fact_375_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_right_mono_neg
tff(fact_376_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_right_mono
tff(fact_377_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ) ) ).

% mult_le_0_iff
tff(fact_378_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ).

% split_mult_neg_le
tff(fact_379_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_nonneg_nonneg
tff(fact_380_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_nonneg_nonpos
tff(fact_381_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_nonpos_nonneg
tff(fact_382_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ordered_semiring_0(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),zero_zero(A)) ) ) ) ).

% mult_nonneg_nonpos2
tff(fact_383_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_le_mult_iff
tff(fact_384_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ordere2520102378445227354miring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
tff(fact_385_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),one_one(A)) ) ).

% zero_less_one_class.zero_le_one
tff(fact_386_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),one_one(A)) ) ).

% linordered_nonzero_semiring_class.zero_le_one
tff(fact_387_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),zero_zero(A)) ) ).

% not_one_le_zero
tff(fact_388_add__decreasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ) ).

% add_decreasing
tff(fact_389_add__increasing,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_increasing
tff(fact_390_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),B2) ) ) ) ).

% add_decreasing2
tff(fact_391_add__increasing2,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_increasing2
tff(fact_392_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_nonneg_nonneg
tff(fact_393_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_nonpos_nonpos
tff(fact_394_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y) = zero_zero(A) )
            <=> ( ( Xa = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
tff(fact_395_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),zero_zero(A))
           => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y) = zero_zero(A) )
            <=> ( ( Xa = zero_zero(A) )
                & ( Y = zero_zero(A) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
tff(fact_396_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),N)) ) ).

% of_nat_0_le_iff
tff(fact_397_diff__add__0,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)) = zero_zero(nat) ) ).

% diff_add_0
tff(fact_398_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))),N) ) ).

% diff_Suc_eq_diff_pred
tff(fact_399_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% Suc_mult_le_cancel1
tff(fact_400_zle__iff__zadd,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z)
    <=> ? [N5: nat] : ( Z = aa(int,int,aa(int,fun(int,int),plus_plus(int),W),aa(nat,int,semiring_1_of_nat(int),N5)) ) ) ).

% zle_iff_zadd
tff(fact_401_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),one_one(A))) ) ) ).

% square_diff_one_factored
tff(fact_402_powr__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [Xa: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),powr(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),powr(A),Xa),A2)),aa(A,A,aa(A,fun(A,A),powr(A),Xa),B2)) ) ) ).

% powr_add
tff(fact_403_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Xa)),Xa) ) ) ) ) ).

% mult_left_le_one_le
tff(fact_404_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y)),Xa) ) ) ) ) ).

% mult_right_le_one_le
tff(fact_405_mult__le__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A)) ) ) ) ) ).

% mult_le_one
tff(fact_406_mult__left__le,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),A2) ) ) ) ).

% mult_left_le
tff(fact_407_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A))
        <=> ( ( Xa = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_squares_le_zero_iff
tff(fact_408_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))) ) ).

% sum_squares_ge_zero
tff(fact_409_Suc__if__eq,axiom,
    ! [A: $tType,F3: fun(nat,A),H: fun(nat,A),G: A,N: nat] :
      ( ! [N2: nat] : ( aa(nat,A,F3,aa(nat,nat,suc,N2)) = aa(nat,A,H,N2) )
     => ( ( aa(nat,A,F3,zero_zero(nat)) = G )
       => ( aa(nat,A,F3,N)
          = $ite(N = zero_zero(nat),G,aa(nat,A,H,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ).

% Suc_if_eq
tff(fact_410_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [Xa: A,Y: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),A2)),B2)) ) ) ).

% mult_diff_mult
tff(fact_411_minus__apply,axiom,
    ! [A: $tType,B: $tType] :
      ( minus(A)
     => ! [A3: fun(B,A),B3: fun(B,A),Xa: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(fun(B,A),fun(fun(B,A),fun(B,A)),minus_minus(fun(B,A)),A3),B3),Xa) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,A3,Xa)),aa(B,A,B3,Xa)) ) ) ).

% minus_apply
tff(fact_412_order__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Xa) ) ).

% order_refl
tff(fact_413_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),A2) ) ).

% dual_order.refl
tff(fact_414_add__diff__add,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,C2: A,B2: A,D2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2)) ) ) ).

% add_diff_add
tff(fact_415_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,$o),D3: A,Q: fun(A,$o)] :
          ( ! [X: A,K3: A] :
              ( aa(A,$o,P,X)
            <=> aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D3))) )
         => ( ! [X: A,K3: A] :
                ( aa(A,$o,Q,X)
              <=> aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D3))) )
           => ! [X3: A,K4: A] :
                ( ( aa(A,$o,P,X3)
                  | aa(A,$o,Q,X3) )
              <=> ( aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D3)))
                  | aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D3))) ) ) ) ) ) ).

% inf_period(2)
tff(fact_416_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [P: fun(A,$o),D3: A,Q: fun(A,$o)] :
          ( ! [X: A,K3: A] :
              ( aa(A,$o,P,X)
            <=> aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D3))) )
         => ( ! [X: A,K3: A] :
                ( aa(A,$o,Q,X)
              <=> aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),aa(A,A,aa(A,fun(A,A),times_times(A),K3),D3))) )
           => ! [X3: A,K4: A] :
                ( ( aa(A,$o,P,X3)
                  & aa(A,$o,Q,X3) )
              <=> ( aa(A,$o,P,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D3)))
                  & aa(A,$o,Q,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D3))) ) ) ) ) ) ).

% inf_period(1)
tff(fact_417_power_Opower__eq__if,axiom,
    ! [A: $tType,One: A,Times: fun(A,fun(A,A)),P2: A,M: nat] :
      ( aa(nat,A,aa(A,fun(nat,A),power2(A,One,Times),P2),M)
      = $ite(M = zero_zero(nat),One,aa(A,A,aa(A,fun(A,A),Times,P2),aa(nat,A,aa(A,fun(nat,A),power2(A,One,Times),P2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))) ) ).

% power.power_eq_if
tff(fact_418_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Xa: A] : ( neg_numeral_dbl_dec(A,Xa) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Xa)),one_one(A)) ) ) ).

% dbl_dec_def
tff(fact_419_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,one_one(A)) = one_one(A) ) ) ).

% dbl_dec_simps(3)
tff(fact_420_verit__la__generic,axiom,
    ! [A2: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),Xa)
      | ( A2 = Xa )
      | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),A2) ) ).

% verit_la_generic
tff(fact_421_Nat_Oex__has__greatest__nat,axiom,
    ! [P: fun(nat,$o),K: nat,B2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [Y3: nat] :
            ( aa(nat,$o,P,Y3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y3),B2) )
       => ? [X: nat] :
            ( aa(nat,$o,P,X)
            & ! [Y4: nat] :
                ( aa(nat,$o,P,Y4)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y4),X) ) ) ) ) ).

% Nat.ex_has_greatest_nat
tff(fact_422_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
      | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M) ) ).

% nat_le_linear
tff(fact_423_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
       => ( M = N ) ) ) ).

% le_antisym
tff(fact_424_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% eq_imp_le
tff(fact_425_le__trans,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),K) ) ) ).

% le_trans
tff(fact_426_le__refl,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N) ).

% le_refl
tff(fact_427_power_Opower_Ocong,axiom,
    ! [A: $tType,One: A,Times: fun(A,fun(A,A))] : ( power2(A,One,Times) = power2(A,One,Times) ) ).

% power.power.cong
tff(fact_428_minus__int__code_I1_J,axiom,
    ! [K: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),K),zero_zero(int)) = K ) ).

% minus_int_code(1)
tff(fact_429_int__le__induct,axiom,
    ! [I: int,K: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),K)
     => ( aa(int,$o,P,K)
       => ( ! [I2: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),K)
             => ( aa(int,$o,P,I2)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I2),one_one(int))) ) )
         => aa(int,$o,P,I) ) ) ) ).

% int_le_induct
tff(fact_430_int__distrib_I3_J,axiom,
    ! [Z1: int,Z2: int,W: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z2)),W) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Z1),W)),aa(int,int,aa(int,fun(int,int),times_times(int),Z2),W)) ) ).

% int_distrib(3)
tff(fact_431_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z2: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z1),Z2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z1)),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z2)) ) ).

% int_distrib(4)
tff(fact_432_int__diff__cases,axiom,
    ! [Z: int] :
      ~ ! [M2: nat,N2: nat] : ( Z != aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),M2)),aa(nat,int,semiring_1_of_nat(int),N2)) ) ).

% int_diff_cases
tff(fact_433_int__induct,axiom,
    ! [P: fun(int,$o),K: int,I: int] :
      ( aa(int,$o,P,K)
     => ( ! [I2: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I2)
           => ( aa(int,$o,P,I2)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int))) ) )
       => ( ! [I2: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),K)
             => ( aa(int,$o,P,I2)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I2),one_one(int))) ) )
         => aa(int,$o,P,I) ) ) ) ).

% int_induct
tff(fact_434_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One: A,Times: fun(A,fun(A,A)),A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power2(A,One,Times),A2),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),Times,A2),aa(nat,A,aa(A,fun(nat,A),power2(A,One,Times),A2),N)) ) ).

% power.power.power_Suc
tff(fact_435_power_Opower_Opower__0,axiom,
    ! [A: $tType,One: A,Times: fun(A,fun(A,A)),A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power2(A,One,Times),A2),zero_zero(nat)) = One ) ).

% power.power.power_0
tff(fact_436_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
          <=> ( Xa = Y ) ) ) ) ).

% order_antisym_conv
tff(fact_437_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ).

% linorder_le_cases
tff(fact_438_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( ( aa(A,B,F3,B2) = C2 )
           => ( ! [X: A,Y3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% ord_le_eq_subst
tff(fact_439_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord(B)
        & ord(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( ( A2 = aa(B,A,F3,B2) )
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B2),C2)
           => ( ! [X: B,Y3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,X)),aa(B,A,F3,Y3)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% ord_eq_le_subst
tff(fact_440_linorder__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
          | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ).

% linorder_linear
tff(fact_441_order__eq__refl,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A] :
          ( ( Xa = Y )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ).

% order_eq_refl
tff(fact_442_order__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,B2)),C2)
           => ( ! [X: A,Y3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% order_subst2
tff(fact_443_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(B,A,F3,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B2),C2)
           => ( ! [X: B,Y3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,X)),aa(B,A,F3,Y3)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% order_subst1
tff(fact_444_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% Orderings.order_eq_iff
tff(fact_445_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),F3),G)
        <=> ! [X4: A] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,G,X4)) ) ) ).

% le_fun_def
tff(fact_446_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( ! [X: A] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X))
         => aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),F3),G) ) ) ).

% le_funI
tff(fact_447_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F3: fun(A,B),G: fun(A,B),Xa: A] :
          ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),F3),G)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa)),aa(A,B,G,Xa)) ) ) ).

% le_funE
tff(fact_448_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F3: fun(A,B),G: fun(A,B),Xa: A] :
          ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),F3),G)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa)),aa(A,B,G,Xa)) ) ) ).

% le_funD
tff(fact_449_antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
           => ( A2 = B2 ) ) ) ) ).

% antisym
tff(fact_450_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2) ) ) ) ).

% dual_order.trans
tff(fact_451_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
tff(fact_452_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% dual_order.eq_iff
tff(fact_453_linorder__wlog,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,fun(A,$o)),A2: A,B2: A] :
          ( ! [A4: A,B4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),B4)
             => aa(A,$o,aa(A,fun(A,$o),P,A4),B4) )
         => ( ! [A4: A,B4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),P,B4),A4)
               => aa(A,$o,aa(A,fun(A,$o),P,A4),B4) )
           => aa(A,$o,aa(A,fun(A,$o),P,A2),B2) ) ) ) ).

% linorder_wlog
tff(fact_454_order__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z) ) ) ) ).

% order_trans
tff(fact_455_order_Otrans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2) ) ) ) ).

% order.trans
tff(fact_456_order__antisym,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
           => ( Xa = Y ) ) ) ) ).

% order_antisym
tff(fact_457_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( ( B2 = C2 )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2) ) ) ) ).

% ord_le_eq_trans
tff(fact_458_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2) ) ) ) ).

% ord_eq_le_trans
tff(fact_459_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Xa: A,Y: A] :
          ( ( Xa = Y )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ) ).

% order_class.order_eq_iff
tff(fact_460_le__cases3,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
           => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) )
         => ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z) )
           => ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z)
               => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Y) )
             => ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Y)
                 => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) )
               => ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z)
                   => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Xa) )
                 => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Xa)
                     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ) ) ) ) ).

% le_cases3
tff(fact_461_nle__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & ( B2 != A2 ) ) ) ) ).

% nle_le
tff(fact_462_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( minus(B)
     => ! [A3: fun(A,B),B3: fun(A,B),X3: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),minus_minus(fun(A,B)),A3),B3),X3) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A3,X3)),aa(A,B,B3,X3)) ) ) ).

% fun_diff_def
tff(fact_463_conj__le__cong,axiom,
    ! [Xa: int,X5: int,P: $o,P3: $o] :
      ( ( Xa = X5 )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X5)
         => ( (P)
          <=> (P3) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
            & (P) )
        <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X5)
            & (P3) ) ) ) ) ).

% conj_le_cong
tff(fact_464_imp__le__cong,axiom,
    ! [Xa: int,X5: int,P: $o,P3: $o] :
      ( ( Xa = X5 )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X5)
         => ( (P)
          <=> (P3) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
           => (P) )
        <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X5)
           => (P3) ) ) ) ) ).

% imp_le_cong
tff(fact_465_Suc__diff__1,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) = N ) ) ).

% Suc_diff_1
tff(fact_466_power__eq__if,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [P2: A,M: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),P2),M)
          = $ite(M = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(nat,A,aa(A,fun(nat,A),power_power(A),P2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))) ) ) ).

% power_eq_if
tff(fact_467_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( linord715952674999750819strict(A)
     => ! [Xa: A,A2: A,Y: A,U: A,V: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),U)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),V)
               => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V) = one_one(A) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),U),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),V),Y))),A2) ) ) ) ) ) ) ).

% convex_bound_lt
tff(fact_468_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: nat,M: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
         => ( ( N != zero_zero(nat) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,one_one(A),aa(nat,A,semiring_1_of_nat(A),M))),divide_divide(A,one_one(A),aa(nat,A,semiring_1_of_nat(A),N))) ) ) ) ).

% inverse_of_nat_le
tff(fact_469_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(nat,nat,suc,aa(int,nat,nat2,Z)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)) ) ) ).

% Suc_nat_eq_nat_zadd1
tff(fact_470_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A2)),archimedean_ceiling(A,B2))) ) ) ) ).

% mult_ceiling_le
tff(fact_471_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),one_one(int)) ) ) ).

% of_int_le_1_iff
tff(fact_472_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),Z) ) ) ).

% of_int_1_le_iff
tff(fact_473_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),one_one(A))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,Xa)),one_one(int)) ) ) ).

% ceiling_add_one
tff(fact_474_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),zero_zero(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int)) ) ) ).

% of_int_le_0_iff
tff(fact_475_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) ) ) ).

% of_int_0_le_iff
tff(fact_476_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [W: int,Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),W) = aa(int,A,ring_1_of_int(A),Z) )
        <=> ( W = Z ) ) ) ).

% of_int_eq_iff
tff(fact_477_not__gr__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),N)
        <=> ( N = zero_zero(A) ) ) ) ).

% not_gr_zero
tff(fact_478_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_cancel_right
tff(fact_479_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_cancel_left
tff(fact_480_div__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( divide_divide(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% div_0
tff(fact_481_div__by__0,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( divide_divide(A,A2,zero_zero(A)) = zero_zero(A) ) ) ).

% div_by_0
tff(fact_482_div__by__1,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] : ( divide_divide(A,A2,one_one(A)) = A2 ) ) ).

% div_by_1
tff(fact_483_power__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),N) = one_one(A) ) ) ).

% power_one
tff(fact_484_power__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,suc,zero_zero(nat))),N) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% power_Suc_0
tff(fact_485_nat__power__eq__Suc__0__iff,axiom,
    ! [Xa: nat,M: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Xa),M) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( M = zero_zero(nat) )
        | ( Xa = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% nat_power_eq_Suc_0_iff
tff(fact_486_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% Suc_less_eq
tff(fact_487_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)) ) ).

% Suc_mono
tff(fact_488_lessI,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,suc,N)) ).

% lessI
tff(fact_489_nat__zero__less__power__iff,axiom,
    ! [Xa: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Xa),N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Xa)
        | ( N = zero_zero(nat) ) ) ) ).

% nat_zero_less_power_iff
tff(fact_490_less__nat__zero__code,axiom,
    ! [N: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),zero_zero(nat)) ).

% less_nat_zero_code
tff(fact_491_neq0__conv,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ).

% neq0_conv
tff(fact_492_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( A2 != zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),A2) ) ).

% bot_nat_0.not_eq_extremum
tff(fact_493_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Xa: nat,B2: nat,W: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Xa) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W) )
        <=> ( Xa = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
tff(fact_494_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [B2: nat,W: nat,Xa: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W) = aa(nat,A,semiring_1_of_nat(A),Xa) )
        <=> ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W) = Xa ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
tff(fact_495_of__nat__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),M),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),M)),N) ) ) ).

% of_nat_power
tff(fact_496_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: int,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% of_int_less_iff
tff(fact_497_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% nat_add_left_cancel_less
tff(fact_498_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
      = $ite(K = zero_zero(nat),zero_zero(nat),divide_divide(nat,M,N)) ) ).

% nat_mult_div_cancel_disj
tff(fact_499_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Xa: int,B2: int,W: nat] :
          ( ( aa(int,A,ring_1_of_int(A),Xa) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W) )
        <=> ( Xa = aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
tff(fact_500_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [B2: int,W: nat,Xa: int] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W) = aa(int,A,ring_1_of_int(A),Xa) )
        <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W) = Xa ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
tff(fact_501_of__int__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int,N: nat] : ( aa(int,A,ring_1_of_int(A),aa(nat,int,aa(int,fun(nat,int),power_power(int),Z),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),Z)),N) ) ) ).

% of_int_power
tff(fact_502_power__one__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),one_one(nat)) = A2 ) ) ).

% power_one_right
tff(fact_503_nat__ceiling__le__eq,axiom,
    ! [Xa: real,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,archimedean_ceiling(real,Xa))),A2)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(nat,real,semiring_1_of_nat(real),A2)) ) ).

% nat_ceiling_le_eq
tff(fact_504_nat__int,axiom,
    ! [N: nat] : ( aa(int,nat,nat2,aa(nat,int,semiring_1_of_nat(int),N)) = N ) ).

% nat_int
tff(fact_505_ceiling__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int] : ( archimedean_ceiling(A,aa(int,A,ring_1_of_int(A),Z)) = Z ) ) ).

% ceiling_of_int
tff(fact_506_round__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: int] : ( archimedean_round(A,aa(int,A,ring_1_of_int(A),N)) = N ) ) ).

% round_of_int
tff(fact_507_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% add_less_same_cancel1
tff(fact_508_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% add_less_same_cancel2
tff(fact_509_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ).

% less_add_same_cancel1
tff(fact_510_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ordere1937475149494474687imp_le(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ).

% less_add_same_cancel2
tff(fact_511_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
tff(fact_512_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
tff(fact_513_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% diff_gt_0_iff_gt
tff(fact_514_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),A2) = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
tff(fact_515_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),B2) = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
tff(fact_516_div__self,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( divide_divide(A,A2,A2) = one_one(A) ) ) ) ).

% div_self
tff(fact_517_power__inject__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N) )
          <=> ( M = N ) ) ) ) ).

% power_inject_exp
tff(fact_518_power__0__Suc,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),aa(nat,nat,suc,N)) = zero_zero(A) ) ) ).

% power_0_Suc
tff(fact_519_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% of_nat_less_iff
tff(fact_520_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% power_Suc0_right
tff(fact_521_less__Suc0,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,suc,zero_zero(nat)))
    <=> ( N = zero_zero(nat) ) ) ).

% less_Suc0
tff(fact_522_zero__less__Suc,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,suc,N)) ).

% zero_less_Suc
tff(fact_523_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: int,B2: int,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Xa),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)) ) ) ).

% of_int_power_less_of_int_cancel_iff
tff(fact_524_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,Xa: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W)),aa(int,A,ring_1_of_int(A),Xa))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)),Xa) ) ) ).

% of_int_less_of_int_power_cancel_iff
tff(fact_525_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% add_gr_0
tff(fact_526_of__int__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),zero_zero(int)) = zero_zero(A) ) ) ).

% of_int_0
tff(fact_527_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( zero_zero(A) = aa(int,A,ring_1_of_int(A),Z) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_0_eq_iff
tff(fact_528_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = zero_zero(A) )
        <=> ( Z = zero_zero(int) ) ) ) ).

% of_int_eq_0_iff
tff(fact_529_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% zero_less_diff
tff(fact_530_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% nat_0_less_mult_iff
tff(fact_531_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% mult_less_cancel2
tff(fact_532_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% nat_mult_less_cancel_disj
tff(fact_533_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [W: int,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ) ).

% of_int_le_iff
tff(fact_534_less__one,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),one_one(nat))
    <=> ( N = zero_zero(nat) ) ) ).

% less_one
tff(fact_535_of__int__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( aa(int,A,ring_1_of_int(A),one_one(int)) = one_one(A) ) ) ).

% of_int_1
tff(fact_536_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = one_one(A) )
        <=> ( Z = one_one(int) ) ) ) ).

% of_int_eq_1_iff
tff(fact_537_of__int__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_mult
tff(fact_538_of__int__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_add
tff(fact_539_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% zless_nat_conj
tff(fact_540_ceiling__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,zero_zero(A)) = zero_zero(int) ) ) ).

% ceiling_zero
tff(fact_541_of__int__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: int,Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),minus_minus(int),W),Z)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),W)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_diff
tff(fact_542_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(int,A,ring_1_of_int(A),aa(nat,int,semiring_1_of_nat(int),N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ).

% of_int_of_nat_eq
tff(fact_543_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int)))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ).

% zle_add1_eq_le
tff(fact_544_ceiling__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archimedean_ceiling(A,one_one(A)) = one_one(int) ) ) ).

% ceiling_one
tff(fact_545_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),one_one(int)))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ).

% zle_diff1_eq
tff(fact_546_ceiling__of__nat,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: nat] : ( archimedean_ceiling(A,aa(nat,A,semiring_1_of_nat(A),N)) = aa(nat,int,semiring_1_of_nat(int),N) ) ) ).

% ceiling_of_nat
tff(fact_547_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,Xa: nat,Y: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xa),Y) ) ) ) ).

% power_strict_increasing_iff
tff(fact_548_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A,N: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ) ).

% power_eq_0_iff
tff(fact_549_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: nat,B2: nat,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
tff(fact_550_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,Xa: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),Xa))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)),Xa) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
tff(fact_551_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: nat,B2: nat,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
tff(fact_552_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: nat,W: nat,Xa: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),B2)),W)),aa(nat,A,semiring_1_of_nat(A),Xa))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),W)),Xa) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
tff(fact_553_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ) ).

% of_int_0_less_iff
tff(fact_554_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),zero_zero(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),zero_zero(int)) ) ) ).

% of_int_less_0_iff
tff(fact_555_Suc__pred,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))) = N ) ) ).

% Suc_pred
tff(fact_556_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z) ) ) ).

% of_int_1_less_iff
tff(fact_557_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),one_one(int)) ) ) ).

% of_int_less_1_iff
tff(fact_558_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: int,W: nat,Xa: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W)),aa(int,A,ring_1_of_int(A),Xa))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)),Xa) ) ) ).

% of_int_le_of_int_power_cancel_iff
tff(fact_559_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: int,B2: int,W: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(int,A,ring_1_of_int(A),B2)),W))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),aa(nat,int,aa(int,fun(nat,int),power_power(int),B2),W)) ) ) ).

% of_int_power_le_of_int_cancel_iff
tff(fact_560_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ).

% mult_le_cancel2
tff(fact_561_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ).

% nat_mult_le_cancel_disj
tff(fact_562_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa) ) ) ).

% zero_less_ceiling
tff(fact_563_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,Xa)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A)) ) ) ).

% ceiling_less_one
tff(fact_564_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ).

% zero_less_nat_eq
tff(fact_565_nat__1,axiom,
    aa(int,nat,nat2,one_one(int)) = aa(nat,nat,suc,zero_zero(nat)) ).

% nat_1
tff(fact_566_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Xa) ) ) ).

% one_less_ceiling
tff(fact_567_nat__0__iff,axiom,
    ! [I: int] :
      ( ( aa(int,nat,nat2,I) = zero_zero(nat) )
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),zero_zero(int)) ) ).

% nat_0_iff
tff(fact_568_nat__le__0,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int))
     => ( aa(int,nat,nat2,Z) = zero_zero(nat) ) ) ).

% nat_le_0
tff(fact_569_int__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z),Z,zero_zero(int)) ) ).

% int_nat_eq
tff(fact_570_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,Xa)),Z) ) ) ).

% ceiling_add_of_int
tff(fact_571_ceiling__diff__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,Xa)),Z) ) ) ).

% ceiling_diff_of_int
tff(fact_572_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M) ) ) ) ) ).

% power_strict_decreasing_iff
tff(fact_573_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,Xa: nat,Y: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),Y))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),Y) ) ) ) ).

% power_increasing_iff
tff(fact_574_power__mono__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N))
              <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ) ).

% power_mono_iff
tff(fact_575_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,semiring_1_of_nat(A),N))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% of_nat_0_less_iff
tff(fact_576_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,Xa)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A)) ) ) ).

% ceiling_le_zero
tff(fact_577_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),Z) ) ).

% one_less_nat_eq
tff(fact_578_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa) ) ) ).

% one_le_ceiling
tff(fact_579_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,Xa)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),one_one(A)) ) ) ).

% ceiling_le_one
tff(fact_580_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,Z)) = aa(int,A,ring_1_of_int(A),Z) ) ) ) ).

% of_nat_nat
tff(fact_581_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,Xa)),one_one(int)) ) ) ).

% ceiling_diff_one
tff(fact_582_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [B2: A,M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N))
            <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M) ) ) ) ) ).

% power_decreasing_iff
tff(fact_583_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,semiring_1_of_nat(A),Xa)),N))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Xa)
            | ( N = zero_zero(nat) ) ) ) ) ).

% of_nat_zero_less_power_iff
tff(fact_584_nat__less__real__le,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),N)),one_one(real))),aa(nat,real,semiring_1_of_nat(real),M)) ) ).

% nat_less_real_le
tff(fact_585_real__nat__ceiling__ge,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(nat,real,semiring_1_of_nat(real),aa(int,nat,nat2,archimedean_ceiling(real,Xa)))) ).

% real_nat_ceiling_ge
tff(fact_586_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ord(B)
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less(fun(A,B)),F3),G)
        <=> ( aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),F3),G)
            & ~ aa(fun(A,B),$o,aa(fun(A,B),fun(fun(A,B),$o),ord_less_eq(fun(A,B)),G),F3) ) ) ) ).

% less_fun_def
tff(fact_587_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,Xa))) ) ).

% le_of_int_ceiling
tff(fact_588_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(int,nat,nat2,Z))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),M)),Z) ) ).

% zless_nat_eq_int_zless
tff(fact_589_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,Xa)),archimedean_ceiling(A,Y))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y) ) ) ).

% ceiling_less_cancel
tff(fact_590_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),Xa) ) ) ).

% less_ceiling_iff
tff(fact_591_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
        ? [Z4: int] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z4)),Xa) ) ).

% ex_of_int_less
tff(fact_592_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
        ? [Z4: int] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(int,A,ring_1_of_int(A),Z4)) ) ).

% ex_less_of_int
tff(fact_593_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),A2) ) ).

% verit_comp_simplify1(1)
tff(fact_594_infinite__descent__measure,axiom,
    ! [A: $tType,P: fun(A,$o),V2: fun(A,nat),Xa: A] :
      ( ! [X: A] :
          ( ~ aa(A,$o,P,X)
         => ? [Y4: A] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,V2,Y4)),aa(A,nat,V2,X))
              & ~ aa(A,$o,P,Y4) ) )
     => aa(A,$o,P,Xa) ) ).

% infinite_descent_measure
tff(fact_595_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F3: fun(A,B),P: fun(A,$o),A2: A] :
          ( ! [X: A] :
              ( ! [Y4: A] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,Y4)),aa(A,B,F3,X))
                 => aa(A,$o,P,Y4) )
             => aa(A,$o,P,X) )
         => aa(A,$o,P,A2) ) ) ).

% measure_induct_rule
tff(fact_596_linorder__neqE__nat,axiom,
    ! [Xa: nat,Y: nat] :
      ( ( Xa != Y )
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xa),Y)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Y),Xa) ) ) ).

% linorder_neqE_nat
tff(fact_597_infinite__descent,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( ! [N2: nat] :
          ( ~ aa(nat,$o,P,N2)
         => ? [M3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N2)
              & ~ aa(nat,$o,P,M3) ) )
     => aa(nat,$o,P,N) ) ).

% infinite_descent
tff(fact_598_nat__less__induct,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N2)
             => aa(nat,$o,P,M3) )
         => aa(nat,$o,P,N2) )
     => aa(nat,$o,P,N) ) ).

% nat_less_induct
tff(fact_599_less__irrefl__nat,axiom,
    ! [N: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N) ).

% less_irrefl_nat
tff(fact_600_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( wellorder(B)
     => ! [F3: fun(A,B),P: fun(A,$o),A2: A] :
          ( ! [X: A] :
              ( ! [Y4: A] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,Y4)),aa(A,B,F3,X))
                 => aa(A,$o,P,Y4) )
             => aa(A,$o,P,X) )
         => aa(A,$o,P,A2) ) ) ).

% measure_induct
tff(fact_601_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),S),T2)
     => ( S != T2 ) ) ).

% less_not_refl3
tff(fact_602_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
     => ( M != N ) ) ).

% less_not_refl2
tff(fact_603_less__not__refl,axiom,
    ! [N: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N) ).

% less_not_refl
tff(fact_604_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( M != N )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M) ) ) ).

% nat_neq_iff
tff(fact_605_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( ( Xa != Y )
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Xa) ) ) ) ).

% linorder_neqE_linordered_idom
tff(fact_606_power__divide,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),divide_divide(A,A2,B2)),N) = divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ).

% power_divide
tff(fact_607_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% nat_mono_iff
tff(fact_608_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N6: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N6)) ) ) ) ).

% power_strict_increasing
tff(fact_609_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ) ).

% power_less_imp_less_exp
tff(fact_610_zero__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% zero_less_power
tff(fact_611_power__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),divide_divide(A,one_one(A),A2)),N) = divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% power_one_over
tff(fact_612_nat__power__less__imp__less,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),I)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I),N))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% nat_power_less_imp_less
tff(fact_613_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),N: nat,N4: nat] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,N2)),aa(nat,A,F3,aa(nat,nat,suc,N2)))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N4)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,N)),aa(nat,A,F3,N4)) ) ) ) ).

% lift_Suc_mono_less
tff(fact_614_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),N: nat,M: nat] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,N2)),aa(nat,A,F3,aa(nat,nat,suc,N2)))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,N)),aa(nat,A,F3,M))
          <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M) ) ) ) ).

% lift_Suc_mono_less_iff
tff(fact_615_int__le__real__less,axiom,
    ! [N: int,M: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),N),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(int,real,ring_1_of_int(real),N)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),M)),one_one(real))) ) ).

% int_le_real_less
tff(fact_616_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% of_nat_less_imp_less
tff(fact_617_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% less_imp_of_nat_less
tff(fact_618_nat__int__comparison_I2_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% nat_int_comparison(2)
tff(fact_619_of__int__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_pos
tff(fact_620_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N6: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N6)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ) ) ).

% power_strict_decreasing
tff(fact_621_nat__power__eq,axiom,
    ! [Z: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,nat,nat2,aa(nat,int,aa(int,fun(nat,int),power_power(int),Z),N)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(int,nat,nat2,Z)),N) ) ) ).

% nat_power_eq
tff(fact_622_one__less__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ) ).

% one_less_power
tff(fact_623_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,divide_divide(A,P2,Q2)))),Q2)) ) ) ).

% ceiling_divide_upper
tff(fact_624_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ) ).

% nat_less_eq_zless
tff(fact_625_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,Xa: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(int,A,ring_1_of_int(A),Xa))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),N)),Xa) ) ) ).

% of_nat_less_of_int_iff
tff(fact_626_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,divide_divide(A,P2,Q2)))),one_one(A))),Q2)),P2) ) ) ).

% ceiling_divide_lower
tff(fact_627_ceiling__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,Xa))),one_one(A))),Xa)
          & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,Xa))) ) ) ).

% ceiling_correct
tff(fact_628_ceiling__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(int,A,ring_1_of_int(A),Z))
           => ( archimedean_ceiling(A,Xa) = Z ) ) ) ) ).

% ceiling_unique
tff(fact_629_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,A2: int] :
          ( ( archimedean_ceiling(A,Xa) = A2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),A2)),one_one(A))),Xa)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(int,A,ring_1_of_int(A),A2)) ) ) ) ).

% ceiling_eq_iff
tff(fact_630_ceiling__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,$o),T2: A] :
          ( aa(int,$o,P,archimedean_ceiling(A,T2))
        <=> ! [I3: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),I3)),one_one(A))),T2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),aa(int,A,ring_1_of_int(A),I3)) )
             => aa(int,$o,P,I3) ) ) ) ).

% ceiling_split
tff(fact_631_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,Xa)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))) ) ) ).

% ceiling_less_iff
tff(fact_632_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),Xa) ) ) ).

% le_ceiling_iff
tff(fact_633_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),R),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,archimedean_ceiling(A,R)))) ) ).

% of_nat_ceiling
tff(fact_634_power__strict__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ) ) ).

% power_strict_mono
tff(fact_635_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,Xa)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% ceiling_le_iff
tff(fact_636_ceiling__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(int,A,ring_1_of_int(A),A2))
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,Xa)),A2) ) ) ).

% ceiling_le
tff(fact_637_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% power_less_imp_less_base
tff(fact_638_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,W)),M)
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(nat,int,semiring_1_of_nat(int),M)) ) ) ).

% nat_less_iff
tff(fact_639_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))) ) ) ).

% power_gt1_lemma
tff(fact_640_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))) ) ) ).

% power_less_power_Suc
tff(fact_641_zero__power,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),N) = zero_zero(A) ) ) ) ).

% zero_power
tff(fact_642_power__gt1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,N))) ) ) ).

% power_gt1
tff(fact_643_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),N),K)) ) ).

% power_gt_expt
tff(fact_644_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) = divide_divide(nat,M,N) ) ) ).

% nat_mult_div_cancel1
tff(fact_645_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
        ? [Z4: int] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(int,A,ring_1_of_int(A),Z4)) ) ).

% ex_le_of_int
tff(fact_646_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: int,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Xa)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(int,A,ring_1_of_int(A),Xa)) ) ) ).

% mult_of_int_commute
tff(fact_647_power__not__zero,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A,N: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N) != zero_zero(A) ) ) ) ).

% power_not_zero
tff(fact_648_power__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% power_commutes
tff(fact_649_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ).

% power_mult_distrib
tff(fact_650_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xa: A,Y: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),Xa) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)) ) ) ) ).

% power_commuting_commutes
tff(fact_651_verit__comp__simplify1_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B5: A,A5: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B5),A5)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A5),B5) ) ) ).

% verit_comp_simplify1(3)
tff(fact_652_minf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z4)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),X3) ) ) ).

% minf(8)
tff(fact_653_minf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z4)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),T2) ) ) ).

% minf(6)
tff(fact_654_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z4),X3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),T2),X3) ) ) ).

% pinf(8)
tff(fact_655_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [T2: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z4),X3)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),T2) ) ) ).

% pinf(6)
tff(fact_656_leD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y) ) ) ).

% leD
tff(fact_657_leI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ).

% leI
tff(fact_658_nless__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            | ( A2 = B2 ) ) ) ) ).

% nless_le
tff(fact_659_antisym__conv1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Xa: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
          <=> ( Xa = Y ) ) ) ) ).

% antisym_conv1
tff(fact_660_antisym__conv2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
          <=> ( Xa = Y ) ) ) ) ).

% antisym_conv2
tff(fact_661_dense__ge,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,Y: A] :
          ( ! [X: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),X)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),X) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ).

% dense_ge
tff(fact_662_dense__le,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Y: A,Z: A] :
          ( ! [X: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Z) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ).

% dense_le
tff(fact_663_less__le__not__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ) ).

% less_le_not_le
tff(fact_664_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Y: A,Xa: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y) ) ) ).

% not_le_imp_less
tff(fact_665_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
            | ( A2 = B2 ) ) ) ) ).

% order.order_iff_strict
tff(fact_666_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & ( A2 != B2 ) ) ) ) ).

% order.strict_iff_order
tff(fact_667_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans1
tff(fact_668_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),C2) ) ) ) ).

% order.strict_trans2
tff(fact_669_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% order.strict_iff_not
tff(fact_670_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),Xa)
         => ( ! [W2: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),W2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W2),Xa)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),W2) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ) ).

% dense_ge_bounded
tff(fact_671_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
         => ( ! [W2: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),W2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W2),Y)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W2),Z) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ) ).

% dense_le_bounded
tff(fact_672_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
            | ( A2 = B2 ) ) ) ) ).

% dual_order.order_iff_strict
tff(fact_673_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & ( A2 != B2 ) ) ) ) ).

% dual_order.strict_iff_order
tff(fact_674_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans1
tff(fact_675_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2) ) ) ) ).

% dual_order.strict_trans2
tff(fact_676_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% dual_order.strict_iff_not
tff(fact_677_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% order.strict_implies_order
tff(fact_678_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% dual_order.strict_implies_order
tff(fact_679_order__le__less,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
            | ( Xa = Y ) ) ) ) ).

% order_le_less
tff(fact_680_order__less__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
            & ( Xa != Y ) ) ) ) ).

% order_less_le
tff(fact_681_linorder__not__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Xa) ) ) ).

% linorder_not_le
tff(fact_682_linorder__not__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ).

% linorder_not_less
tff(fact_683_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ).

% order_less_imp_le
tff(fact_684_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( ( A2 != B2 )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% order_le_neq_trans
tff(fact_685_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% order_neq_le_trans
tff(fact_686_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Z) ) ) ) ).

% order_le_less_trans
tff(fact_687_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Z) ) ) ) ).

% order_less_le_trans
tff(fact_688_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(B,A,F3,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),B2),C2)
           => ( ! [X: B,Y3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),Y3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,X)),aa(B,A,F3,Y3)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% order_le_less_subst1
tff(fact_689_order__le__less__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,B2)),C2)
           => ( ! [X: A,Y3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% order_le_less_subst2
tff(fact_690_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,F3: fun(B,A),B2: B,C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,B2))
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),B2),C2)
           => ( ! [X: B,Y3: B] :
                  ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,X)),aa(B,A,F3,Y3)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(B,A,F3,C2)) ) ) ) ) ).

% order_less_le_subst1
tff(fact_691_order__less__le__subst2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( order(B)
        & order(A) )
     => ! [A2: A,B2: A,F3: fun(A,B),C2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,B2)),C2)
           => ( ! [X: A,Y3: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,A2)),C2) ) ) ) ) ).

% order_less_le_subst2
tff(fact_692_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
          | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Xa) ) ) ).

% linorder_le_less_linear
tff(fact_693_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
            | ( Xa = Y ) ) ) ) ).

% order_le_imp_less_or_eq
tff(fact_694_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),zero_zero(A)) ) ).

% less_numeral_extra(3)
tff(fact_695_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),N)
        <=> ( N != zero_zero(A) ) ) ) ).

% zero_less_iff_neq_zero
tff(fact_696_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [M: A,N: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),N)
         => ( N != zero_zero(A) ) ) ) ).

% gr_implies_not_zero
tff(fact_697_not__less__zero,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),N),zero_zero(A)) ) ).

% not_less_zero
tff(fact_698_gr__zeroI,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [N: A] :
          ( ( N != zero_zero(A) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),N) ) ) ).

% gr_zeroI
tff(fact_699_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D1: A,D22: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D1)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D22)
           => ? [E2: A] :
                ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),E2),D1)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),E2),D22) ) ) ) ) ).

% field_lbound_gt_zero
tff(fact_700_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),one_one(A)) ) ).

% less_numeral_extra(4)
tff(fact_701_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_imp_less_right
tff(fact_702_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% add_less_imp_less_left
tff(fact_703_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ).

% add_strict_right_mono
tff(fact_704_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% add_strict_left_mono
tff(fact_705_add__strict__mono,axiom,
    ! [A: $tType] :
      ( strict9044650504122735259up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_strict_mono
tff(fact_706_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I),J)
            & ( K = L ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_field(1)
tff(fact_707_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_field(2)
tff(fact_708_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I),J)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_field(5)
tff(fact_709_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% diff_strict_right_mono
tff(fact_710_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% diff_strict_left_mono
tff(fact_711_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),D2) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2) ) ) ) ).

% diff_eq_diff_less
tff(fact_712_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),D2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ) ).

% diff_strict_mono
tff(fact_713_power__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: nat,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),N) ) ) ).

% power_mult
tff(fact_714_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
        ? [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(nat,A,semiring_1_of_nat(A),N2)) ) ).

% reals_Archimedean2
tff(fact_715_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,suc,M))
      <=> ( N = M ) ) ) ).

% not_less_less_Suc_eq
tff(fact_716_strict__inc__induct,axiom,
    ! [I: nat,J: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( ! [I2: nat] :
            ( ( J = aa(nat,nat,suc,I2) )
           => aa(nat,$o,P,I2) )
       => ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J)
             => ( aa(nat,$o,P,aa(nat,nat,suc,I2))
               => aa(nat,$o,P,I2) ) )
         => aa(nat,$o,P,I) ) ) ) ).

% strict_inc_induct
tff(fact_717_less__Suc__induct,axiom,
    ! [I: nat,J: nat,P: fun(nat,fun(nat,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( ! [I2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,I2),aa(nat,nat,suc,I2))
       => ( ! [I2: nat,J2: nat,K3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),K3)
               => ( aa(nat,$o,aa(nat,fun(nat,$o),P,I2),J2)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),P,J2),K3)
                   => aa(nat,$o,aa(nat,fun(nat,$o),P,I2),K3) ) ) ) )
         => aa(nat,$o,aa(nat,fun(nat,$o),P,I),J) ) ) ) ).

% less_Suc_induct
tff(fact_718_less__trans__Suc,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),K) ) ) ).

% less_trans_Suc
tff(fact_719_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% Suc_less_SucD
tff(fact_720_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,suc,M))
       => ( M = N ) ) ) ).

% less_antisym
tff(fact_721_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),M)
    <=> ? [M5: nat] :
          ( ( M = aa(nat,nat,suc,M5) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M5) ) ) ).

% Suc_less_eq2
tff(fact_722_All__less__Suc,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,suc,N))
         => aa(nat,$o,P,I3) )
    <=> ( aa(nat,$o,P,N)
        & ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),N)
           => aa(nat,$o,P,I3) ) ) ) ).

% All_less_Suc
tff(fact_723_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,suc,M)) ) ).

% not_less_eq
tff(fact_724_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
        | ( M = N ) ) ) ).

% less_Suc_eq
tff(fact_725_Ex__less__Suc,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ? [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,suc,N))
          & aa(nat,$o,P,I3) )
    <=> ( aa(nat,$o,P,N)
        | ? [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),N)
            & aa(nat,$o,P,I3) ) ) ) ).

% Ex_less_Suc
tff(fact_726_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,N)) ) ).

% less_SucI
tff(fact_727_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,N))
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
       => ( M = N ) ) ) ).

% less_SucE
tff(fact_728_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ( ( aa(nat,nat,suc,M) != N )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),N) ) ) ).

% Suc_lessI
tff(fact_729_Suc__lessE,axiom,
    ! [I: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),K)
     => ~ ! [J2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J2)
           => ( K != aa(nat,nat,suc,J2) ) ) ) ).

% Suc_lessE
tff(fact_730_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,M)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% Suc_lessD
tff(fact_731_Nat_OlessE,axiom,
    ! [I: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),K)
     => ( ( K != aa(nat,nat,suc,I) )
       => ~ ! [J2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J2)
             => ( K != aa(nat,nat,suc,J2) ) ) ) ) ).

% Nat.lessE
tff(fact_732_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: fun(A,nat),P: fun(A,$o),Xa: A] :
      ( ! [X: A] :
          ( ( aa(A,nat,V2,X) = zero_zero(nat) )
         => aa(A,$o,P,X) )
     => ( ! [X: A] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,V2,X))
           => ( ~ aa(A,$o,P,X)
             => ? [Y4: A] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,V2,Y4)),aa(A,nat,V2,X))
                  & ~ aa(A,$o,P,Y4) ) ) )
       => aa(A,$o,P,Xa) ) ) ).

% infinite_descent0_measure
tff(fact_733_infinite__descent0,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
           => ( ~ aa(nat,$o,P,N2)
             => ? [M3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N2)
                  & ~ aa(nat,$o,P,M3) ) ) )
       => aa(nat,$o,P,N) ) ) ).

% infinite_descent0
tff(fact_734_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ( N != zero_zero(nat) ) ) ).

% gr_implies_not0
tff(fact_735_less__zeroE,axiom,
    ! [N: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),zero_zero(nat)) ).

% less_zeroE
tff(fact_736_not__less0,axiom,
    ! [N: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),zero_zero(nat)) ).

% not_less0
tff(fact_737_not__gr0,axiom,
    ! [N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
    <=> ( N = zero_zero(nat) ) ) ).

% not_gr0
tff(fact_738_gr0I,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ).

% gr0I
tff(fact_739_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),zero_zero(nat)) ).

% bot_nat_0.extremum_strict
tff(fact_740_real__archimedian__rdiv__eq__0,axiom,
    ! [Xa: real,C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),C2)
       => ( ! [M2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M2)),Xa)),C2) )
         => ( Xa = zero_zero(real) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
tff(fact_741_less__int__code_I1_J,axiom,
    ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),zero_zero(int)) ).

% less_int_code(1)
tff(fact_742_nat__less__le,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
        & ( M != N ) ) ) ).

% nat_less_le
tff(fact_743_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% less_imp_le_nat
tff(fact_744_le__eq__less__or__eq,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
        | ( M = N ) ) ) ).

% le_eq_less_or_eq
tff(fact_745_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
        | ( M = N ) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% less_or_eq_imp_le
tff(fact_746_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( ( M != N )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% le_neq_implies_less
tff(fact_747_less__mono__imp__le__mono,axiom,
    ! [F3: fun(nat,nat),I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J2)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,F3,I2)),aa(nat,nat,F3,J2)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,F3,I)),aa(nat,nat,F3,J)) ) ) ).

% less_mono_imp_le_mono
tff(fact_748_nat__le__real__less,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,semiring_1_of_nat(real),M)),one_one(real))) ) ).

% nat_le_real_less
tff(fact_749_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),L)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),L) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% less_add_eq_less
tff(fact_750_trans__less__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),J)) ) ).

% trans_less_add2
tff(fact_751_trans__less__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),M)) ) ).

% trans_less_add1
tff(fact_752_add__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),K)) ) ).

% add_less_mono1
tff(fact_753_not__add__less2,axiom,
    ! [J: nat,I: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),I)),I) ).

% not_add_less2
tff(fact_754_not__add__less1,axiom,
    ! [I: nat,J: nat] : ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J)),I) ).

% not_add_less1
tff(fact_755_add__less__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),L)) ) ) ).

% add_less_mono
tff(fact_756_add__lessD1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J)),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),K) ) ).

% add_lessD1
tff(fact_757_int__less__induct,axiom,
    ! [I: int,K: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I),K)
     => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)))
       => ( ! [I2: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I2),K)
             => ( aa(int,$o,P,I2)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),I2),one_one(int))) ) )
         => aa(int,$o,P,I) ) ) ) ).

% int_less_induct
tff(fact_758_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),N)),K) ) ).

% less_imp_diff_less
tff(fact_759_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),L)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),L),M)) ) ) ).

% diff_less_mono2
tff(fact_760_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,R))),aa(A,A,aa(A,fun(A,A),plus_plus(A),R),one_one(A))) ) ).

% of_int_ceiling_le_add_one
tff(fact_761_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_ceiling(A,R))),one_one(A))),R) ) ).

% of_int_ceiling_diff_one_le
tff(fact_762_power__Suc__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ) ).

% power_Suc_less
tff(fact_763_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,N))),one_one(A)) ) ) ) ).

% power_Suc_less_one
tff(fact_764_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N) = aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N) )
              <=> ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
tff(fact_765_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat,B2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N) = aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
tff(fact_766_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ) ).

% power_le_imp_le_exp
tff(fact_767_self__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ) ).

% self_le_power
tff(fact_768_power__diff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2 != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ) ) ).

% power_diff
tff(fact_769_floor__exists,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
        ? [Z4: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z4)),Xa)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z4),one_one(int)))) ) ) ).

% floor_exists
tff(fact_770_floor__exists1,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
        ? [X: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),X)),Xa)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),X),one_one(int))))
          & ! [Y4: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y4)),Xa)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),Y4),one_one(int)))) )
             => ( Y4 = X ) ) ) ) ).

% floor_exists1
tff(fact_771_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),W)
        | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,W)),aa(int,nat,nat2,Z))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),W),Z) ) ) ).

% nat_le_eq_zle
tff(fact_772_split__nat,axiom,
    ! [P: fun(nat,$o),I: int] :
      ( aa(nat,$o,P,aa(int,nat,nat2,I))
    <=> ( ! [N5: nat] :
            ( ( I = aa(nat,int,semiring_1_of_nat(int),N5) )
           => aa(nat,$o,P,N5) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I),zero_zero(int))
         => aa(nat,$o,P,zero_zero(nat)) ) ) ) ).

% split_nat
tff(fact_773_ceiling__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: int,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),N)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),N)),one_one(A)))
           => ( archimedean_ceiling(A,Xa) = aa(int,int,aa(int,fun(int,int),plus_plus(int),N),one_one(int)) ) ) ) ) ).

% ceiling_eq
tff(fact_774_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ? [N2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
          & ( K = aa(nat,int,semiring_1_of_nat(int),N2) ) ) ) ).

% zero_less_imp_eq_int
tff(fact_775_pos__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ~ ! [N2: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N2) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2) ) ) ).

% pos_int_cases
tff(fact_776_zmult__zless__mono2__lemma,axiom,
    ! [I: int,J: int,K: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),I)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),K)),J)) ) ) ).

% zmult_zless_mono2_lemma
tff(fact_777_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [E: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E)
         => ~ ! [N2: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N2)))),E) ) ) ).

% nat_approx_posE
tff(fact_778_power__minus__mult,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [N: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),A2) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N) ) ) ) ).

% power_minus_mult
tff(fact_779_ceiling__mono,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,Y)),archimedean_ceiling(A,Xa)) ) ) ).

% ceiling_mono
tff(fact_780_nat__zero__as__int,axiom,
    zero_zero(nat) = aa(int,nat,nat2,zero_zero(int)) ).

% nat_zero_as_int
tff(fact_781_zero__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% zero_le_power
tff(fact_782_power__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ) ).

% power_mono
tff(fact_783_nat__mono,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),Y)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,Xa)),aa(int,nat,nat2,Y)) ) ).

% nat_mono
tff(fact_784_ex__nat,axiom,
    ! [P: fun(nat,$o)] :
      ( ? [X_12: nat] : aa(nat,$o,P,X_12)
    <=> ? [X4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X4)
          & aa(nat,$o,P,aa(int,nat,nat2,X4)) ) ) ).

% ex_nat
tff(fact_785_all__nat,axiom,
    ! [P: fun(nat,$o)] :
      ( ! [X_12: nat] : aa(nat,$o,P,X_12)
    <=> ! [X4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),X4)
         => aa(nat,$o,P,aa(int,nat,nat2,X4)) ) ) ).

% all_nat
tff(fact_786_eq__nat__nat__iff,axiom,
    ! [Z: int,Z5: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z5)
       => ( ( aa(int,nat,nat2,Z) = aa(int,nat,nat2,Z5) )
        <=> ( Z = Z5 ) ) ) ) ).

% eq_nat_nat_iff
tff(fact_787_one__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% one_le_power
tff(fact_788_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xa: A,Y: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y) = one_one(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),N)) = one_one(A) ) ) ) ).

% left_right_inverse_power
tff(fact_789_int__minus,axiom,
    ! [N: nat,M: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) = aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(nat,int,semiring_1_of_nat(int),M)))) ) ).

% int_minus
tff(fact_790_nat__one__as__int,axiom,
    one_one(nat) = aa(int,nat,nat2,one_one(int)) ).

% nat_one_as_int
tff(fact_791_power__Suc,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% power_Suc
tff(fact_792_power__Suc2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),A2) ) ) ).

% power_Suc2
tff(fact_793_power__0,axiom,
    ! [A: $tType] :
      ( power(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),zero_zero(nat)) = one_one(A) ) ) ).

% power_0
tff(fact_794_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_neg_neg
tff(fact_795_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)),zero_zero(A)) ) ).

% not_square_less_zero
tff(fact_796_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ) ).

% mult_less_0_iff
tff(fact_797_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_neg_pos
tff(fact_798_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A)) ) ) ) ).

% mult_pos_neg
tff(fact_799_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ) ).

% mult_pos_pos
tff(fact_800_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),zero_zero(A)) ) ) ) ).

% mult_pos_neg2
tff(fact_801_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_less_mult_iff
tff(fact_802_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ).

% zero_less_mult_pos
tff(fact_803_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ).

% zero_less_mult_pos2
tff(fact_804_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% mult_less_cancel_left_neg
tff(fact_805_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_less_cancel_left_pos
tff(fact_806_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_strict_left_mono_neg
tff(fact_807_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% mult_strict_left_mono
tff(fact_808_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_left_disj
tff(fact_809_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_strict_right_mono_neg
tff(fact_810_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ) ).

% mult_strict_right_mono
tff(fact_811_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_right_disj
tff(fact_812_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linord2810124833399127020strict(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
tff(fact_813_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),J)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_field(4)
tff(fact_814_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [I: A,J: A,K: A,L: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),I),J)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),L) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K)),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),L)) ) ) ).

% add_mono_thms_linordered_field(3)
tff(fact_815_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_le_less_mono
tff(fact_816_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ordere580206878836729694up_add(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),D2)) ) ) ) ).

% add_less_le_mono
tff(fact_817_zero__less__one,axiom,
    ! [A: $tType] :
      ( zero_less_one(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),one_one(A)) ) ).

% zero_less_one
tff(fact_818_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),zero_zero(A)) ) ).

% not_one_less_zero
tff(fact_819_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),one_one(A)) ) ).

% less_numeral_extra(1)
tff(fact_820_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A)) ) ) ) ).

% add_less_zeroD
tff(fact_821_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_neg_neg
tff(fact_822_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_pos_pos
tff(fact_823_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ~ ! [C4: A] :
                ( ( B2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C4) )
               => ( C4 = zero_zero(A) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
tff(fact_824_pos__add__strict,axiom,
    ! [A: $tType] :
      ( strict7427464778891057005id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% pos_add_strict
tff(fact_825_power__add,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: nat,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% power_add
tff(fact_826_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),zero_zero(A)) ) ) ).

% less_iff_diff_less_0
tff(fact_827_less__1__mult,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: A,N: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),N)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),M),N)) ) ) ) ).

% less_1_mult
tff(fact_828_add__mono1,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),one_one(A))) ) ) ).

% add_mono1
tff(fact_829_less__add__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))) ) ).

% less_add_one
tff(fact_830_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
tff(fact_831_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),C2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% diff_less_eq
tff(fact_832_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),C2) ) ) ).

% less_diff_eq
tff(fact_833_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),M)),zero_zero(A)) ) ).

% of_nat_less_0_iff
tff(fact_834_funpow__times__power,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [F3: fun(A,nat),Xa: A] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(A,nat,F3,Xa)),aa(A,fun(A,A),times_times(A),Xa)) = aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(A,nat,F3,Xa))) ) ) ).

% funpow_times_power
tff(fact_835_powr__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [W: A,Z1: A,Z2: A] : ( aa(A,A,aa(A,fun(A,A),powr(A),W),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z1),Z2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),powr(A),W),Z1),aa(A,A,aa(A,fun(A,A),powr(A),W),Z2)) ) ) ).

% powr_diff
tff(fact_836_Ex__less__Suc2,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ? [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,suc,N))
          & aa(nat,$o,P,I3) )
    <=> ( aa(nat,$o,P,zero_zero(nat))
        | ? [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),N)
            & aa(nat,$o,P,aa(nat,nat,suc,I3)) ) ) ) ).

% Ex_less_Suc2
tff(fact_837_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
    <=> ? [M6: nat] : ( N = aa(nat,nat,suc,M6) ) ) ).

% gr0_conv_Suc
tff(fact_838_All__less__Suc2,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ! [I3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,suc,N))
         => aa(nat,$o,P,I3) )
    <=> ( aa(nat,$o,P,zero_zero(nat))
        & ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),N)
           => aa(nat,$o,P,aa(nat,nat,suc,I3)) ) ) ) ).

% All_less_Suc2
tff(fact_839_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ? [M2: nat] : ( N = aa(nat,nat,suc,M2) ) ) ).

% gr0_implies_Suc
tff(fact_840_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,N))
    <=> ( ( M = zero_zero(nat) )
        | ? [J3: nat] :
            ( ( M = aa(nat,nat,suc,J3) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),N) ) ) ) ).

% less_Suc_eq_0_disj
tff(fact_841_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),N) ) ).

% Suc_leI
tff(fact_842_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),N)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% Suc_le_eq
tff(fact_843_dec__induct,axiom,
    ! [I: nat,J: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,$o,P,I)
       => ( ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),N2)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N2),J)
               => ( aa(nat,$o,P,N2)
                 => aa(nat,$o,P,aa(nat,nat,suc,N2)) ) ) )
         => aa(nat,$o,P,J) ) ) ) ).

% dec_induct
tff(fact_844_inc__induct,axiom,
    ! [I: nat,J: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,$o,P,J)
       => ( ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),N2)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N2),J)
               => ( aa(nat,$o,P,aa(nat,nat,suc,N2))
                 => aa(nat,$o,P,N2) ) ) )
         => aa(nat,$o,P,I) ) ) ) ).

% inc_induct
tff(fact_845_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% Suc_le_lessD
tff(fact_846_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,suc,M))
      <=> ( N = M ) ) ) ).

% le_less_Suc_eq
tff(fact_847_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% less_Suc_eq_le
tff(fact_848_less__eq__Suc__le,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),M) ) ).

% less_eq_Suc_le
tff(fact_849_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,suc,N)) ) ).

% le_imp_less_Suc
tff(fact_850_ex__least__nat__le,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( aa(nat,$o,P,N)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ? [K3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N)
            & ! [I4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),K3)
               => ~ aa(nat,$o,P,I4) )
            & aa(nat,$o,P,K3) ) ) ) ).

% ex_least_nat_le
tff(fact_851_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ? [K3: nat] : ( N = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K3)) ) ) ).

% less_imp_Suc_add
tff(fact_852_less__iff__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
    <=> ? [K2: nat] : ( N = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K2)) ) ) ).

% less_iff_Suc_add
tff(fact_853_less__add__Suc2,axiom,
    ! [I: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I))) ).

% less_add_Suc2
tff(fact_854_less__add__Suc1,axiom,
    ! [I: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M))) ).

% less_add_Suc1
tff(fact_855_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ~ ! [Q3: nat] : ( N != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q3)) ) ) ).

% less_natE
tff(fact_856_less__imp__add__positive,axiom,
    ! [I: nat,J: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ? [K3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K3)
          & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K3) = J ) ) ) ).

% less_imp_add_positive
tff(fact_857_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,N))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N) ) ) ).

% Suc_diff_Suc
tff(fact_858_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),aa(nat,nat,suc,M)) ).

% diff_less_Suc
tff(fact_859_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),M) ) ) ).

% diff_less
tff(fact_860_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ).

% Suc_mult_less_cancel1
tff(fact_861_mono__nat__linear__lb,axiom,
    ! [F3: fun(nat,nat),M: nat,K: nat] :
      ( ! [M2: nat,N2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N2)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,F3,M2)),aa(nat,nat,F3,N2)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,F3,M)),K)),aa(nat,nat,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K))) ) ).

% mono_nat_linear_lb
tff(fact_862_mult__less__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),I)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),J)) ) ) ).

% mult_less_mono2
tff(fact_863_mult__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),K)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),K)) ) ) ).

% mult_less_mono1
tff(fact_864_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N) )
      <=> ( M = N ) ) ) ).

% nat_mult_eq_cancel1
tff(fact_865_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ).

% nat_mult_less_cancel1
tff(fact_866_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),C2),A2)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),C2)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),B2),C2)) ) ) ).

% diff_less_mono
tff(fact_867_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ) ) ) ).

% less_diff_iff
tff(fact_868_less__diff__conv,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J) ) ).

% less_diff_conv
tff(fact_869_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) = M ) ) ).

% add_diff_inverse_nat
tff(fact_870_zmult__zless__mono2,axiom,
    ! [I: int,J: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),I),J)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I)),aa(int,int,aa(int,fun(int,int),times_times(int),K),J)) ) ) ).

% zmult_zless_mono2
tff(fact_871_plusinfinity,axiom,
    ! [D2: int,P3: fun(int,$o),P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X: int,K3: int] :
            ( aa(int,$o,P3,X)
          <=> aa(int,$o,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K3),D2))) )
       => ( ? [Z3: int] :
            ! [X: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z3),X)
             => ( aa(int,$o,P,X)
              <=> aa(int,$o,P3,X) ) )
         => ( ? [X_1: int] : aa(int,$o,P3,X_1)
           => ? [X_13: int] : aa(int,$o,P,X_13) ) ) ) ) ).

% plusinfinity
tff(fact_872_minusinfinity,axiom,
    ! [D2: int,P1: fun(int,$o),P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X: int,K3: int] :
            ( aa(int,$o,P1,X)
          <=> aa(int,$o,P1,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K3),D2))) )
       => ( ? [Z3: int] :
            ! [X: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),Z3)
             => ( aa(int,$o,P,X)
              <=> aa(int,$o,P1,X) ) )
         => ( ? [X_1: int] : aa(int,$o,P1,X_1)
           => ? [X_13: int] : aa(int,$o,P,X_13) ) ) ) ) ).

% minusinfinity
tff(fact_873_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),one_one(int)))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
        | ( W = Z ) ) ) ).

% zless_add1_eq
tff(fact_874_int__gr__induct,axiom,
    ! [K: int,I: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I)
     => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int)))
       => ( ! [I2: int] :
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I2)
             => ( aa(int,$o,P,I2)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int))) ) )
         => aa(int,$o,P,I) ) ) ) ).

% int_gr_induct
tff(fact_875_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_round(A,Xa)),archimedean_ceiling(A,Xa)) ) ).

% ceiling_ge_round
tff(fact_876_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))),aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,Xa)),archimedean_ceiling(A,Y))) ) ).

% ceiling_add_le
tff(fact_877_power__le__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),one_one(A)) ) ) ) ).

% power_le_one
tff(fact_878_nat__diff__distrib,axiom,
    ! [Z5: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z5)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z5),Z)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) ) ) ) ).

% nat_diff_distrib
tff(fact_879_nat__diff__distrib_H,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa),Y)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Xa)),aa(int,nat,nat2,Y)) ) ) ) ).

% nat_diff_distrib'
tff(fact_880_power__inject__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat,B2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),aa(nat,nat,suc,N)) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
tff(fact_881_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),aa(nat,nat,suc,N)))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% power_le_imp_le_base
tff(fact_882_nat__le__iff,axiom,
    ! [Xa: int,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,Xa)),N)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),aa(nat,int,semiring_1_of_nat(int),N)) ) ).

% nat_le_iff
tff(fact_883_power__0__left,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),N)
          = $ite(N = zero_zero(nat),one_one(A),zero_zero(A)) ) ) ).

% power_0_left
tff(fact_884_nat__0__le,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(nat,int,semiring_1_of_nat(int),aa(int,nat,nat2,Z)) = Z ) ) ).

% nat_0_le
tff(fact_885_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = Z )
    <=> ( ( M = aa(int,nat,nat2,Z) )
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z) ) ) ).

% int_eq_iff
tff(fact_886_power__increasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N6: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N6)) ) ) ) ).

% power_increasing
tff(fact_887_nat__int__add,axiom,
    ! [A2: nat,B2: nat] : ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2) ) ).

% nat_int_add
tff(fact_888_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% mult_le_cancel_left
tff(fact_889_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% mult_le_cancel_right
tff(fact_890_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_left_less_imp_less
tff(fact_891_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_strict_mono
tff(fact_892_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_left
tff(fact_893_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semiring(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% mult_right_less_imp_less
tff(fact_894_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_strict_mono'
tff(fact_895_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% mult_less_cancel_right
tff(fact_896_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% mult_le_cancel_left_neg
tff(fact_897_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_le_cancel_left_pos
tff(fact_898_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_left_le_imp_le
tff(fact_899_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% mult_right_le_imp_le
tff(fact_900_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_le_less_imp_less
tff(fact_901_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( linord8928482502909563296strict(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ) ).

% mult_less_le_imp_less
tff(fact_902_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_strict_increasing2
tff(fact_903_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) ) ) ) ).

% add_strict_increasing
tff(fact_904_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_pos_nonneg
tff(fact_905_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_nonpos_neg
tff(fact_906_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% add_nonneg_pos
tff(fact_907_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),zero_zero(A)) ) ) ) ).

% add_neg_nonpos
tff(fact_908_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linord4710134922213307826strict(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y)))
        <=> ( ( Xa != zero_zero(A) )
            | ( Y != zero_zero(A) ) ) ) ) ).

% sum_squares_gt_zero_iff
tff(fact_909_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [Xa: A,Y: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Y))),zero_zero(A)) ) ).

% not_sum_squares_lt_zero
tff(fact_910_zero__less__two,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A))) ) ).

% zero_less_two
tff(fact_911_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)),E)),D2)) ) ) ).

% less_add_iff2
tff(fact_912_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ordered_ring(A)
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),E)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),E)),C2)),D2) ) ) ).

% less_add_iff1
tff(fact_913_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => ? [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N2)),Xa)) ) ) ).

% ex_less_of_nat_mult
tff(fact_914_nat__one__le__power,axiom,
    ! [I: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),I)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I),N)) ) ).

% nat_one_le_power
tff(fact_915_ex__least__nat__less,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( aa(nat,$o,P,N)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ? [K3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K3),N)
            & ! [I4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I4),K3)
               => ~ aa(nat,$o,P,I4) )
            & aa(nat,$o,P,aa(nat,nat,suc,K3)) ) ) ) ).

% ex_least_nat_less
tff(fact_916_diff__Suc__less,axiom,
    ! [N: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,I))),N) ) ).

% diff_Suc_less
tff(fact_917_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),M)) ) ) ).

% n_less_n_mult_m
tff(fact_918_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ) ).

% n_less_m_mult_n
tff(fact_919_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ) ).

% one_less_mult
tff(fact_920_nat__induct__non__zero,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,P,one_one(nat))
       => ( ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
             => ( aa(nat,$o,P,N2)
               => aa(nat,$o,P,aa(nat,nat,suc,N2)) ) )
         => aa(nat,$o,P,N) ) ) ) ).

% nat_induct_non_zero
tff(fact_921_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ).

% nat_mult_le_cancel1
tff(fact_922_nat__diff__split__asm,axiom,
    ! [P: fun(nat,$o),A2: nat,B2: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
    <=> ~ ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
            & ~ aa(nat,$o,P,zero_zero(nat)) )
          | ? [D4: nat] :
              ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D4) )
              & ~ aa(nat,$o,P,D4) ) ) ) ).

% nat_diff_split_asm
tff(fact_923_nat__diff__split,axiom,
    ! [P: fun(nat,$o),A2: nat,B2: nat] :
      ( aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A2),B2)
         => aa(nat,$o,P,zero_zero(nat)) )
        & ! [D4: nat] :
            ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),B2),D4) )
           => aa(nat,$o,P,D4) ) ) ) ).

% nat_diff_split
tff(fact_924_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),K)),I)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)) ) ) ).

% less_diff_conv2
tff(fact_925_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),Z)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Z) ) ).

% int_one_le_iff_zero_less
tff(fact_926_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2)),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))) ) ).

% int_ops(6)
tff(fact_927_decr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,$o),K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X: int] :
            ( aa(int,$o,P,X)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D2)) )
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
         => ! [X3: int] :
              ( aa(int,$o,P,X3)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2))) ) ) ) ) ).

% decr_mult_lemma
tff(fact_928_zless__iff__Suc__zadd,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
    <=> ? [N5: nat] : ( Z = aa(int,int,aa(int,fun(int,int),plus_plus(int),W),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N5))) ) ) ).

% zless_iff_Suc_zadd
tff(fact_929_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),M)
     => ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),N) = one_one(int) )
      <=> ( ( M = one_one(int) )
          & ( N = one_one(int) ) ) ) ) ).

% pos_zmult_eq_1_iff
tff(fact_930_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)),Z)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),zero_zero(int)) ) ).

% odd_less_0_iff
tff(fact_931_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z) ) ).

% zless_imp_add1_zle
tff(fact_932_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),W),one_one(int))),Z)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),W),Z) ) ).

% add1_zle_eq
tff(fact_933_relpowp__fun__conv,axiom,
    ! [A: $tType,N: nat,P: fun(A,fun(A,$o)),Xa: A,Y: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),P),Xa),Y)
    <=> ? [F5: fun(nat,A)] :
          ( ( aa(nat,A,F5,zero_zero(nat)) = Xa )
          & ( aa(nat,A,F5,N) = Y )
          & ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),N)
             => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,F5,I3)),aa(nat,A,F5,aa(nat,nat,suc,I3))) ) ) ) ).

% relpowp_fun_conv
tff(fact_934_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_nonneg
tff(fact_935_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M = aa(int,nat,nat2,W) )
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W),W = aa(nat,int,semiring_1_of_nat(int),M),M = zero_zero(nat)) ) ).

% nat_eq_iff2
tff(fact_936_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( aa(int,nat,nat2,W) = M )
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),W),W = aa(nat,int,semiring_1_of_nat(int),M),M = zero_zero(nat)) ) ).

% nat_eq_iff
tff(fact_937_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,N))),A2) ) ) ) ).

% power_Suc_le_self
tff(fact_938_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(int,nat,nat2,K))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),N)),K) ) ) ).

% le_nat_iff
tff(fact_939_nat__add__distrib,axiom,
    ! [Z: int,Z5: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z5)
       => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) ) ) ) ).

% nat_add_distrib
tff(fact_940_power__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,N6: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N6)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ) ) ).

% power_decreasing
tff(fact_941_nat__mult__distrib,axiom,
    ! [Z: int,Z5: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5)) ) ) ).

% nat_mult_distrib
tff(fact_942_Suc__as__int,axiom,
    ! [X3: nat] : ( aa(nat,nat,suc,X3) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X3)),one_one(int))) ) ).

% Suc_as_int
tff(fact_943_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A)) ) ) ) ) ).

% mult_le_cancel_left1
tff(fact_944_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2) ) ) ) ) ).

% mult_le_cancel_left2
tff(fact_945_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),one_one(A)) ) ) ) ) ).

% mult_le_cancel_right1
tff(fact_946_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2) ) ) ) ) ).

% mult_le_cancel_right2
tff(fact_947_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A)) ) ) ) ) ).

% mult_less_cancel_left1
tff(fact_948_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2) ) ) ) ) ).

% mult_less_cancel_left2
tff(fact_949_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),one_one(A)) ) ) ) ) ).

% mult_less_cancel_right1
tff(fact_950_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),C2)
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2) ) ) ) ) ).

% mult_less_cancel_right2
tff(fact_951_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ).

% Suc_diff_eq_diff_pred
tff(fact_952_Suc__pred_H,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( N = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ).

% Suc_pred'
tff(fact_953_nat__less__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),I)),U)),N)) ) ) ).

% nat_less_add_iff2
tff(fact_954_nat__less__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),I)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),U)),M)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),J),U)),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),I),J)),U)),M)),N) ) ) ).

% nat_less_add_iff1
tff(fact_955_le__imp__0__less,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),Z)) ) ).

% le_imp_0_less
tff(fact_956_zdiff__int__split,axiom,
    ! [P: fun(int,$o),Xa: nat,Y: nat] :
      ( aa(int,$o,P,aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),Y)))
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y),Xa)
         => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),Xa)),aa(nat,int,semiring_1_of_nat(int),Y))) )
        & ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xa),Y)
         => aa(int,$o,P,zero_zero(int)) ) ) ) ).

% zdiff_int_split
tff(fact_957_incr__mult__lemma,axiom,
    ! [D2: int,P: fun(int,$o),K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X: int] :
            ( aa(int,$o,P,X)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D2)) )
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
         => ! [X3: int] :
              ( aa(int,$o,P,X3)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),aa(int,int,aa(int,fun(int,int),times_times(int),K),D2))) ) ) ) ) ).

% incr_mult_lemma
tff(fact_958_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% divide_le_eq_1_neg
tff(fact_959_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% divide_le_eq_1_pos
tff(fact_960_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),divide_divide(A,B2,A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% le_divide_eq_1_neg
tff(fact_961_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),divide_divide(A,B2,A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% le_divide_eq_1_pos
tff(fact_962_div__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A2,B2)) ) ) ) ).

% div_mult_self4
tff(fact_963_div__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A2,B2)) ) ) ) ).

% div_mult_self3
tff(fact_964_div__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A2,B2)) ) ) ) ).

% div_mult_self2
tff(fact_965_div__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),divide_divide(A,A2,B2)) ) ) ) ).

% div_mult_self1
tff(fact_966_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = divide_divide(A,one_one(A),B2) ) ) ) ).

% nonzero_divide_mult_cancel_left
tff(fact_967_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,B2,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = divide_divide(A,one_one(A),A2) ) ) ) ).

% nonzero_divide_mult_cancel_right
tff(fact_968_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( divide_divide(A,A2,zero_zero(A)) = zero_zero(A) ) ) ).

% division_ring_divide_zero
tff(fact_969_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( divide_divide(A,A2,C2) = divide_divide(A,B2,C2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
tff(fact_970_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( divide_divide(A,C2,A2) = divide_divide(A,C2,B2) )
        <=> ( ( C2 = zero_zero(A) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
tff(fact_971_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( divide_divide(A,A2,B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_eq_0_iff
tff(fact_972_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% times_divide_eq_right
tff(fact_973_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,C2: A] : ( divide_divide(A,A2,divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),B2) ) ) ).

% divide_divide_eq_right
tff(fact_974_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A,C2: A] : ( divide_divide(A,divide_divide(A,A2,B2),C2) = divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% divide_divide_eq_left
tff(fact_975_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [B2: A,C2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,C2)),A2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2),C2) ) ) ).

% times_divide_eq_left
tff(fact_976_ln__inj__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( ( aa(real,real,ln_ln(real),Xa) = aa(real,real,ln_ln(real),Y) )
        <=> ( Xa = Y ) ) ) ) ).

% ln_inj_iff
tff(fact_977_powr__gt__zero,axiom,
    ! [Xa: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2))
    <=> ( Xa != zero_zero(real) ) ) ).

% powr_gt_zero
tff(fact_978_ln__less__cancel__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),Xa)),aa(real,real,ln_ln(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ) ) ).

% ln_less_cancel_iff
tff(fact_979_powr__nonneg__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),A2),Xa)),zero_zero(real))
    <=> ( A2 = zero_zero(real) ) ) ).

% powr_nonneg_iff
tff(fact_980_powr__less__cancel__iff,axiom,
    ! [Xa: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),B2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2) ) ) ).

% powr_less_cancel_iff
tff(fact_981_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          = $ite(C2 = zero_zero(A),zero_zero(A),divide_divide(A,A2,B2)) ) ) ).

% div_mult_mult1_if
tff(fact_982_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,A2,B2) ) ) ) ).

% div_mult_mult2
tff(fact_983_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A2,B2) ) ) ) ).

% div_mult_mult1
tff(fact_984_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A2,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
tff(fact_985_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,A2,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
tff(fact_986_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,A2,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
tff(fact_987_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = divide_divide(A,A2,B2) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
tff(fact_988_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          = $ite(C2 = zero_zero(A),zero_zero(A),divide_divide(A,A2,B2)) ) ) ).

% mult_divide_mult_cancel_left_if
tff(fact_989_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = divide_divide(A,one_one(A),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% zero_eq_1_divide_iff
tff(fact_990_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( divide_divide(A,one_one(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% one_divide_eq_0_iff
tff(fact_991_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( one_one(A) = divide_divide(A,B2,A2) )
        <=> ( ( A2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
tff(fact_992_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( divide_divide(A,B2,A2) = one_one(A) )
        <=> ( ( A2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
tff(fact_993_divide__self__if,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( divide_divide(A,A2,A2)
          = $ite(A2 = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% divide_self_if
tff(fact_994_divide__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( divide_divide(A,A2,A2) = one_one(A) ) ) ) ).

% divide_self
tff(fact_995_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( one_one(A) = divide_divide(A,A2,B2) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
tff(fact_996_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( divide_divide(A,A2,B2) = one_one(A) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
tff(fact_997_ln__le__cancel__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),Xa)),aa(real,real,ln_ln(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ) ) ).

% ln_le_cancel_iff
tff(fact_998_ln__eq__zero__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( ( aa(real,real,ln_ln(real),Xa) = zero_zero(real) )
      <=> ( Xa = one_one(real) ) ) ) ).

% ln_eq_zero_iff
tff(fact_999_ln__gt__zero__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),Xa))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa) ) ) ).

% ln_gt_zero_iff
tff(fact_1000_powr__eq__one__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( ( aa(real,real,aa(real,fun(real,real),powr(real),A2),Xa) = one_one(real) )
      <=> ( Xa = zero_zero(real) ) ) ) ).

% powr_eq_one_iff
tff(fact_1001_ln__less__zero__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),Xa)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real)) ) ) ).

% ln_less_zero_iff
tff(fact_1002_powr__one__gt__zero__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),one_one(real)) = Xa )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa) ) ).

% powr_one_gt_zero_iff
tff(fact_1003_powr__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),one_one(real)) = Xa ) ) ).

% powr_one
tff(fact_1004_powr__le__cancel__iff,axiom,
    ! [Xa: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),B2))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2) ) ) ).

% powr_le_cancel_iff
tff(fact_1005_div__by__Suc__0,axiom,
    ! [M: nat] : ( divide_divide(nat,M,aa(nat,nat,suc,zero_zero(nat))) = M ) ).

% div_by_Suc_0
tff(fact_1006_div__less,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ( divide_divide(nat,M,N) = zero_zero(nat) ) ) ).

% div_less
tff(fact_1007_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),K)
       => ( divide_divide(int,K,L) = zero_zero(int) ) ) ) ).

% div_neg_neg_trivial
tff(fact_1008_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),L)
       => ( divide_divide(int,K,L) = zero_zero(int) ) ) ) ).

% div_pos_pos_trivial
tff(fact_1009_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),divide_divide(A,one_one(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% zero_le_divide_1_iff
tff(fact_1010_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,one_one(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% divide_le_0_1_iff
tff(fact_1011_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),divide_divide(A,one_one(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% zero_less_divide_1_iff
tff(fact_1012_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),divide_divide(A,B2,A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% less_divide_eq_1_pos
tff(fact_1013_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),divide_divide(A,B2,A2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% less_divide_eq_1_neg
tff(fact_1014_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% divide_less_eq_1_pos
tff(fact_1015_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,A2)),one_one(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ).

% divide_less_eq_1_neg
tff(fact_1016_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,one_one(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% divide_less_0_1_iff
tff(fact_1017_ln__le__zero__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),Xa)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real)) ) ) ).

% ln_le_zero_iff
tff(fact_1018_ln__ge__zero__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),Xa))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa) ) ) ).

% ln_ge_zero_iff
tff(fact_1019_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),M),N) = M ) ) ).

% div_mult_self1_is_m
tff(fact_1020_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N),N) = M ) ) ).

% div_mult_self_is_m
tff(fact_1021_int__less__real__le,axiom,
    ! [N: int,M: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),M)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),N)),one_one(real))),aa(int,real,ring_1_of_int(real),M)) ) ).

% int_less_real_le
tff(fact_1022_powr__mult__base,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),Xa),Y)) = aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Y)) ) ) ).

% powr_mult_base
tff(fact_1023_ln__add__one__self__le__self,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa))),Xa) ) ).

% ln_add_one_self_le_self
tff(fact_1024_ln__ge__zero__imp__ge__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),Xa))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa) ) ) ).

% ln_ge_zero_imp_ge_one
tff(fact_1025_ge__one__powr__ge__zero,axiom,
    ! [Xa: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)) ) ) ).

% ge_one_powr_ge_zero
tff(fact_1026_powr__less__mono2,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Y),A2)) ) ) ) ).

% powr_less_mono2
tff(fact_1027_ln__le__minus__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),Xa)),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),one_one(real))) ) ).

% ln_le_minus_one
tff(fact_1028_ln__eq__minus__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( ( aa(real,real,ln_ln(real),Xa) = aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),one_one(real)) )
       => ( Xa = one_one(real) ) ) ) ).

% ln_eq_minus_one
tff(fact_1029_powr__mono__both,axiom,
    ! [A2: real,B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Y),B2)) ) ) ) ) ).

% powr_mono_both
tff(fact_1030_ln__powr__bound2,axiom,
    ! [Xa: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,ln_ln(real),Xa)),A2)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),powr(real),A2),A2)),Xa)) ) ) ).

% ln_powr_bound2
tff(fact_1031_powr__ge__pzero,axiom,
    ! [Xa: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),Y)) ).

% powr_ge_pzero
tff(fact_1032_ln__powr__bound,axiom,
    ! [Xa: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),Xa)),divide_divide(real,aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2),A2)) ) ) ).

% ln_powr_bound
tff(fact_1033_powr__mono2_H,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),Y),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)) ) ) ) ).

% powr_mono2'
tff(fact_1034_powr__divide,axiom,
    ! [Xa: real,Y: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,real,aa(real,fun(real,real),powr(real),divide_divide(real,Xa,Y)),A2) = divide_divide(real,aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2),aa(real,real,aa(real,fun(real,real),powr(real),Y),A2)) ) ) ) ).

% powr_divide
tff(fact_1035_powr__mono2,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Y),A2)) ) ) ) ).

% powr_mono2
tff(fact_1036_ln__ge__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,ln_ln(real),Xa)) ) ).

% ln_ge_zero
tff(fact_1037_ln__diff__le,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),Xa)),aa(real,real,ln_ln(real),Y))),divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y),Y)) ) ) ).

% ln_diff_le
tff(fact_1038_powr__mult,axiom,
    ! [Xa: real,Y: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)),A2) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Y),A2)) ) ) ) ).

% powr_mult
tff(fact_1039_powr__mono,axiom,
    ! [A2: real,B2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),B2)) ) ) ).

% powr_mono
tff(fact_1040_powr__le1,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),one_one(real)) ) ) ) ).

% powr_le1
tff(fact_1041_ln__bound,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),Xa)),Xa) ) ).

% ln_bound
tff(fact_1042_reals__Archimedean3,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ! [Y4: real] :
        ? [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N2)),Xa)) ) ).

% reals_Archimedean3
tff(fact_1043_ln__div,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,real,ln_ln(real),divide_divide(real,Xa,Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),Xa)),aa(real,real,ln_ln(real),Y)) ) ) ) ).

% ln_div
tff(fact_1044_real__of__nat__div3,axiom,
    ! [N: nat,Xa: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,aa(nat,real,semiring_1_of_nat(real),N),aa(nat,real,semiring_1_of_nat(real),Xa))),aa(nat,real,semiring_1_of_nat(real),divide_divide(nat,N,Xa)))),one_one(real)) ).

% real_of_nat_div3
tff(fact_1045_real__of__nat__div2,axiom,
    ! [N: nat,Xa: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,aa(nat,real,semiring_1_of_nat(real),N),aa(nat,real,semiring_1_of_nat(real),Xa))),aa(nat,real,semiring_1_of_nat(real),divide_divide(nat,N,Xa)))) ).

% real_of_nat_div2
tff(fact_1046_real__of__nat__div4,axiom,
    ! [N: nat,Xa: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),divide_divide(nat,N,Xa))),divide_divide(real,aa(nat,real,semiring_1_of_nat(real),N),aa(nat,real,semiring_1_of_nat(real),Xa))) ).

% real_of_nat_div4
tff(fact_1047_complete__real,axiom,
    ! [S2: set(real)] :
      ( ? [X3: real] : member(real,X3,S2)
     => ( ? [Z3: real] :
          ! [X: real] :
            ( member(real,X,S2)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Z3) )
       => ? [Y3: real] :
            ( ! [X3: real] :
                ( member(real,X3,S2)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),Y3) )
            & ! [Z3: real] :
                ( ! [X: real] :
                    ( member(real,X,S2)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),Z3) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),Z3) ) ) ) ) ).

% complete_real
tff(fact_1048_less__eq__real__def,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
        | ( Xa = Y ) ) ) ).

% less_eq_real_def
tff(fact_1049_real__of__int__div4,axiom,
    ! [N: int,Xa: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(int,real,ring_1_of_int(real),divide_divide(int,N,Xa))),divide_divide(real,aa(int,real,ring_1_of_int(real),N),aa(int,real,ring_1_of_int(real),Xa))) ).

% real_of_int_div4
tff(fact_1050_real__arch__pow,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => ? [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N2)) ) ).

% real_arch_pow
tff(fact_1051_real__of__int__div2,axiom,
    ! [N: int,Xa: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,aa(int,real,ring_1_of_int(real),N),aa(int,real,ring_1_of_int(real),Xa))),aa(int,real,ring_1_of_int(real),divide_divide(int,N,Xa)))) ).

% real_of_int_div2
tff(fact_1052_real__of__int__div3,axiom,
    ! [N: int,Xa: int] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,aa(int,real,ring_1_of_int(real),N),aa(int,real,ring_1_of_int(real),Xa))),aa(int,real,ring_1_of_int(real),divide_divide(int,N,Xa)))),one_one(real)) ).

% real_of_int_div3
tff(fact_1053_real__arch__pow__inv,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => ? [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N2)),Y) ) ) ).

% real_arch_pow_inv
tff(fact_1054_powr__inj,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( ( aa(real,real,aa(real,fun(real,real),powr(real),A2),Xa) = aa(real,real,aa(real,fun(real,real),powr(real),A2),Y) )
        <=> ( Xa = Y ) ) ) ) ).

% powr_inj
tff(fact_1055_ln__gt__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),Xa)) ) ).

% ln_gt_zero
tff(fact_1056_ln__realpow,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,ln_ln(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,ln_ln(real),Xa)) ) ) ).

% ln_realpow
tff(fact_1057_gr__one__powr,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),Y)) ) ) ).

% gr_one_powr
tff(fact_1058_ln__less__self,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),Xa)),Xa) ) ).

% ln_less_self
tff(fact_1059_ln__less__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),Xa)),zero_zero(real)) ) ) ).

% ln_less_zero
tff(fact_1060_powr__non__neg,axiom,
    ! [A2: real,Xa: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),A2),Xa)),zero_zero(real)) ).

% powr_non_neg
tff(fact_1061_powr__realpow,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(nat,real,semiring_1_of_nat(real),N)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N) ) ) ).

% powr_realpow
tff(fact_1062_powr__less__mono,axiom,
    ! [A2: real,B2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),B2)) ) ) ).

% powr_less_mono
tff(fact_1063_powr__less__cancel,axiom,
    ! [Xa: real,A2: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),B2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2) ) ) ).

% powr_less_cancel
tff(fact_1064_powr__less__mono2__neg,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),Y),A2)),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)) ) ) ) ).

% powr_less_mono2_neg
tff(fact_1065_ln__gt__zero__imp__gt__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,ln_ln(real),Xa))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa) ) ) ).

% ln_gt_zero_imp_gt_one
tff(fact_1066_ln__mult,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
       => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,ln_ln(real),Xa)),aa(real,real,ln_ln(real),Y)) ) ) ) ).

% ln_mult
tff(fact_1067_powr__powr,axiom,
    ! [Xa: real,A2: real,B2: real] : ( aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),B2) = aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),A2),B2)) ) ).

% powr_powr
tff(fact_1068_ln__powr,axiom,
    ! [Xa: real,Y: real] :
      ( ( Xa != zero_zero(real) )
     => ( aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y),aa(real,real,ln_ln(real),Xa)) ) ) ).

% ln_powr
tff(fact_1069_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),divide_divide(nat,M,K)),divide_divide(nat,N,K)) ) ).

% div_le_mono
tff(fact_1070_div__le__dividend,axiom,
    ! [M: nat,N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),divide_divide(nat,M,N)),M) ).

% div_le_dividend
tff(fact_1071_div__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( divide_divide(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) = divide_divide(nat,divide_divide(nat,M,N),Q2) ) ).

% div_mult2_eq
tff(fact_1072_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( divide_divide(A,divide_divide(A,A2,B2),C2) = divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% divide_divide_eq_left'
tff(fact_1073_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,Y: A,Z: A,W: A] : ( divide_divide(A,divide_divide(A,Xa,Y),divide_divide(A,Z,W)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),W),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)) ) ) ).

% divide_divide_times_eq
tff(fact_1074_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,Y: A,Z: A,W: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,Xa,Y)),divide_divide(A,Z,W)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z),aa(A,A,aa(A,fun(A,A),times_times(A),Y),W)) ) ) ).

% times_divide_times_eq
tff(fact_1075_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ).

% add_divide_distrib
tff(fact_1076_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] : ( divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ).

% diff_divide_distrib
tff(fact_1077_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),divide_divide(nat,M,N)) = divide_divide(A,aa(nat,A,semiring_1_of_nat(A),M),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
tff(fact_1078_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide(nat,M,N) = zero_zero(nat) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
        | ( N = zero_zero(nat) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
tff(fact_1079_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),divide_divide(nat,M,N)),divide_divide(nat,aa(nat,nat,suc,M),N)) ).

% Suc_div_le_mono
tff(fact_1080_less__mult__imp__div__less,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),I),N))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),divide_divide(nat,M,N)),I) ) ).

% less_mult_imp_div_less
tff(fact_1081_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),divide_divide(nat,M,N))),M) ).

% times_div_less_eq_dividend
tff(fact_1082_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),divide_divide(nat,M,N)),N)),M) ).

% div_times_less_eq_dividend
tff(fact_1083_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,C2)),divide_divide(A,A2,C2)) ) ) ) ).

% divide_right_mono_neg
tff(fact_1084_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),divide_divide(A,Xa,Y)) ) ) ) ).

% divide_nonpos_nonpos
tff(fact_1085_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,Xa,Y)),zero_zero(A)) ) ) ) ).

% divide_nonpos_nonneg
tff(fact_1086_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,Xa,Y)),zero_zero(A)) ) ) ) ).

% divide_nonneg_nonpos
tff(fact_1087_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),divide_divide(A,Xa,Y)) ) ) ) ).

% divide_nonneg_nonneg
tff(fact_1088_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),divide_divide(A,A2,B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_le_divide_iff
tff(fact_1089_divide__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ) ).

% divide_right_mono
tff(fact_1090_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,A2,B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) ) ) ) ) ).

% divide_le_0_iff
tff(fact_1091_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),divide_divide(A,Xa,Y)) ) ) ) ).

% divide_neg_neg
tff(fact_1092_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,Xa,Y)),zero_zero(A)) ) ) ) ).

% divide_neg_pos
tff(fact_1093_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,Xa,Y)),zero_zero(A)) ) ) ) ).

% divide_pos_neg
tff(fact_1094_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),divide_divide(A,Xa,Y)) ) ) ) ).

% divide_pos_pos
tff(fact_1095_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,A2,B2)),zero_zero(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) ) ) ) ) ).

% divide_less_0_iff
tff(fact_1096_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            & ( C2 != zero_zero(A) ) ) ) ) ).

% divide_less_cancel
tff(fact_1097_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),divide_divide(A,A2,B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A)) ) ) ) ) ).

% zero_less_divide_iff
tff(fact_1098_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ) ).

% divide_strict_right_mono
tff(fact_1099_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ) ).

% divide_strict_right_mono_neg
tff(fact_1100_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( A2 = divide_divide(A,B2,C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
tff(fact_1101_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( divide_divide(A,B2,C2) = A2 )
          <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) ) ) ) ) ).

% nonzero_divide_eq_eq
tff(fact_1102_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2 )
           => ( A2 = divide_divide(A,B2,C2) ) ) ) ) ).

% eq_divide_imp
tff(fact_1103_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) )
           => ( divide_divide(A,B2,C2) = A2 ) ) ) ) ).

% divide_eq_imp
tff(fact_1104_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = divide_divide(A,B2,C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq
tff(fact_1105_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( divide_divide(A,B2,C2) = A2 )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq
tff(fact_1106_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,Xa: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( ( divide_divide(A,Xa,Y) = divide_divide(A,W,Z) )
            <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z) = aa(A,A,aa(A,fun(A,A),times_times(A),W),Y) ) ) ) ) ) ).

% frac_eq_eq
tff(fact_1107_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( divide_divide(A,A2,B2) = one_one(A) )
          <=> ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
tff(fact_1108_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,M: nat,N: nat] : ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))) = divide_divide(A,divide_divide(A,A2,aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% div_mult2_eq'
tff(fact_1109_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),divide_divide(nat,K,N)),divide_divide(nat,K,M)) ) ) ).

% div_le_mono2
tff(fact_1110_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),divide_divide(nat,M,N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ).

% div_greater_zero_iff
tff(fact_1111_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Q2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),divide_divide(nat,M,Q2)),N)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) ) ) ).

% div_less_iff_less_mult
tff(fact_1112_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( ( divide_divide(nat,M,N) = M )
      <=> ( N = one_one(nat) ) ) ) ).

% div_eq_dividend_iff
tff(fact_1113_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),divide_divide(nat,M,N)),M) ) ) ).

% div_less_dividend
tff(fact_1114_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),C2)
     => ( divide_divide(int,A2,aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = divide_divide(int,divide_divide(int,A2,B2),C2) ) ) ).

% zdiv_zmult2_eq
tff(fact_1115_nat__div__distrib_H,axiom,
    ! [Y: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,nat,nat2,divide_divide(int,Xa,Y)) = divide_divide(nat,aa(int,nat,nat2,Xa),aa(int,nat,nat2,Y)) ) ) ).

% nat_div_distrib'
tff(fact_1116_nat__div__distrib,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => ( aa(int,nat,nat2,divide_divide(int,Xa,Y)) = divide_divide(nat,aa(int,nat,nat2,Xa),aa(int,nat,nat2,Y)) ) ) ).

% nat_div_distrib
tff(fact_1117_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( ! [E2: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),E2)) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ).

% field_le_epsilon
tff(fact_1118_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,Xa,Y)),zero_zero(A)) ) ) ) ).

% divide_nonpos_pos
tff(fact_1119_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),divide_divide(A,Xa,Y)) ) ) ) ).

% divide_nonpos_neg
tff(fact_1120_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),divide_divide(A,Xa,Y)) ) ) ) ).

% divide_nonneg_pos
tff(fact_1121_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,Xa,Y)),zero_zero(A)) ) ) ) ).

% divide_nonneg_neg
tff(fact_1122_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% divide_le_cancel
tff(fact_1123_frac__less2,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,Xa,Z)),divide_divide(A,Y,W)) ) ) ) ) ) ).

% frac_less2
tff(fact_1124_frac__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,Xa,Z)),divide_divide(A,Y,W)) ) ) ) ) ) ).

% frac_less
tff(fact_1125_frac__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Xa: A,W: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),W)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),W),Z)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,Xa,Z)),divide_divide(A,Y,W)) ) ) ) ) ) ).

% frac_le
tff(fact_1126_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,C2,A2)),divide_divide(A,C2,B2)) ) ) ) ) ).

% divide_strict_left_mono_neg
tff(fact_1127_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,C2,A2)),divide_divide(A,C2,B2)) ) ) ) ) ).

% divide_strict_left_mono
tff(fact_1128_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y)),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z),divide_divide(A,Xa,Y)) ) ) ) ).

% mult_imp_less_div_pos
tff(fact_1129_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Xa: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,Xa,Y)),Z) ) ) ) ).

% mult_imp_div_pos_less
tff(fact_1130_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),divide_divide(A,B2,C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% pos_less_divide_eq
tff(fact_1131_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_divide_less_eq
tff(fact_1132_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),divide_divide(A,B2,C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_less_divide_eq
tff(fact_1133_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% neg_divide_less_eq
tff(fact_1134_less__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),divide_divide(A,B2,C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))) ) ) ) ).

% less_divide_eq
tff(fact_1135_divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,C2)),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)) ) ) ) ).

% divide_less_eq
tff(fact_1136_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),divide_divide(A,B2,A2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% less_divide_eq_1
tff(fact_1137_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,A2)),one_one(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) )
            | ( A2 = zero_zero(A) ) ) ) ) ).

% divide_less_eq_1
tff(fact_1138_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,Z)),B2)
          = $ite(Z = zero_zero(A),B2,divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z)),Z)) ) ) ).

% add_divide_eq_if_simps(2)
tff(fact_1139_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,Z: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),divide_divide(A,B2,Z))
          = $ite(Z = zero_zero(A),A2,divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),Z)),B2),Z)) ) ) ).

% add_divide_eq_if_simps(1)
tff(fact_1140_add__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,Xa: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,Xa,Y)),divide_divide(A,W,Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)) ) ) ) ) ).

% add_frac_eq
tff(fact_1141_add__frac__num,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Xa: A,Z: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,Xa,Y)),Z) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y)),Y) ) ) ) ).

% add_frac_num
tff(fact_1142_add__num__frac,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,Xa: A] :
          ( ( Y != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),divide_divide(A,Xa,Y)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y)),Y) ) ) ) ).

% add_num_frac
tff(fact_1143_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),divide_divide(A,Y,Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),Y),Z) ) ) ) ).

% add_divide_eq_iff
tff(fact_1144_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,Xa,Z)),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)),Z) ) ) ) ).

% divide_add_eq_iff
tff(fact_1145_div__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,B2)),one_one(A)) ) ) ) ).

% div_add_self1
tff(fact_1146_div__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,B2)),one_one(A)) ) ) ) ).

% div_add_self2
tff(fact_1147_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,Xa,Z)),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)),Z) ) ) ) ).

% divide_diff_eq_iff
tff(fact_1148_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),divide_divide(A,Y,Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),Y),Z) ) ) ) ).

% diff_divide_eq_iff
tff(fact_1149_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Y: A,Z: A,Xa: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,Xa,Y)),divide_divide(A,W,Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)) ) ) ) ) ).

% diff_frac_eq
tff(fact_1150_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,Z: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),divide_divide(A,B2,Z))
          = $ite(Z = zero_zero(A),A2,divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),Z)),B2),Z)) ) ) ).

% add_divide_eq_if_simps(4)
tff(fact_1151_gt__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))),B2) ) ) ).

% gt_half_sum
tff(fact_1152_less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)))) ) ) ).

% less_half_sum
tff(fact_1153_div__if,axiom,
    ! [M: nat,N: nat] :
      ( divide_divide(nat,M,N)
      = $ite(
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
          | ( N = zero_zero(nat) ) ),
          zero_zero(nat),
          aa(nat,nat,suc,divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N)) ) ) ).

% div_if
tff(fact_1154_div__nat__eqI,axiom,
    ! [N: nat,Q2: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,Q2)))
       => ( divide_divide(nat,M,N) = Q2 ) ) ) ).

% div_nat_eqI
tff(fact_1155_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Q2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),divide_divide(nat,N,Q2))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)),N) ) ) ).

% less_eq_div_iff_mult_less_eq
tff(fact_1156_split__div,axiom,
    ! [P: fun(nat,$o),M: nat,N: nat] :
      ( aa(nat,$o,P,divide_divide(nat,M,N))
    <=> ( ( ( N = zero_zero(nat) )
         => aa(nat,$o,P,zero_zero(nat)) )
        & ( ( N != zero_zero(nat) )
         => ! [I3: nat,J3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),N)
             => ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),I3)),J3) )
               => aa(nat,$o,P,I3) ) ) ) ) ) ).

% split_div
tff(fact_1157_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),divide_divide(nat,M,N)),N))) ) ).

% dividend_less_div_times
tff(fact_1158_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),divide_divide(nat,M,N)))) ) ).

% dividend_less_times_div
tff(fact_1159_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( ! [Z4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z4)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z4),one_one(A))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z4),Xa)),Y) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ).

% field_le_mult_one_interval
tff(fact_1160_divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,C2)),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)) ) ) ) ).

% divide_le_eq
tff(fact_1161_le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),divide_divide(A,B2,C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))) ) ) ) ).

% le_divide_eq
tff(fact_1162_divide__left__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,C2,A2)),divide_divide(A,C2,B2)) ) ) ) ) ).

% divide_left_mono
tff(fact_1163_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% neg_divide_le_eq
tff(fact_1164_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),divide_divide(A,B2,C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_le_divide_eq
tff(fact_1165_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,C2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_divide_le_eq
tff(fact_1166_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),divide_divide(A,B2,C2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ).

% pos_le_divide_eq
tff(fact_1167_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Xa: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,Xa,Y)),Z) ) ) ) ).

% mult_imp_div_pos_le
tff(fact_1168_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y)),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),divide_divide(A,Xa,Y)) ) ) ) ).

% mult_imp_le_div_pos
tff(fact_1169_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,C2,A2)),divide_divide(A,C2,B2)) ) ) ) ) ).

% divide_left_mono_neg
tff(fact_1170_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,A2)),one_one(A))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            | ( A2 = zero_zero(A) ) ) ) ) ).

% divide_le_eq_1
tff(fact_1171_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),divide_divide(A,B2,A2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% le_divide_eq_1
tff(fact_1172_frac__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,Xa: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,Xa,Y)),divide_divide(A,W,Z))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),zero_zero(A)) ) ) ) ) ).

% frac_le_eq
tff(fact_1173_frac__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Z: A,Xa: A,W: A] :
          ( ( Y != zero_zero(A) )
         => ( ( Z != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,Xa,Y)),divide_divide(A,W,Z))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),W),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))),zero_zero(A)) ) ) ) ) ).

% frac_less_eq
tff(fact_1174_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
       => ( divide_divide(nat,M,N) = aa(nat,nat,suc,divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N)) ) ) ) ).

% le_div_geq
tff(fact_1175_split__div_H,axiom,
    ! [P: fun(nat,$o),M: nat,N: nat] :
      ( aa(nat,$o,P,divide_divide(nat,M,N))
    <=> ( ( ( N = zero_zero(nat) )
          & aa(nat,$o,P,zero_zero(nat)) )
        | ? [Q4: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q4)),M)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,Q4)))
            & aa(nat,$o,P,Q4) ) ) ) ).

% split_div'
tff(fact_1176_scaling__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,V: A,R: A,S: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),V)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),R)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),R),S)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),U),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),R),aa(A,A,aa(A,fun(A,A),minus_minus(A),V),U)),S))),V) ) ) ) ) ).

% scaling_mono
tff(fact_1177_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,M: nat,N: nat] :
          ( ( A2 != zero_zero(A) )
         => ( divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))
            = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))) ) ) ) ).

% power_diff_power_eq
tff(fact_1178_not__real__square__gt__zero,axiom,
    ! [Xa: real] :
      ( ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Xa))
    <=> ( Xa = zero_zero(real) ) ) ).

% not_real_square_gt_zero
tff(fact_1179_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
       => ( divide_divide(int,aa(nat,int,aa(int,fun(nat,int),power_power(int),K),M),K) = aa(nat,int,aa(int,fun(nat,int),power_power(int),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,zero_zero(nat)))) ) ) ) ).

% int_power_div_base
tff(fact_1180_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
       => ( divide_divide(int,K,L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),divide_divide(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L),L)),one_one(int)) ) ) ) ).

% div_pos_geq
tff(fact_1181_linear__plus__1__le__power,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),Xa)),one_one(real))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),one_one(real))),N)) ) ).

% linear_plus_1_le_power
tff(fact_1182_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q5)),R3)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R3)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q2),Q5) ) ) ) ) ).

% unique_quotient_lemma_neg
tff(fact_1183_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q5)),R3)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R3)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R3),B2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q5),Q2) ) ) ) ) ).

% unique_quotient_lemma
tff(fact_1184_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R3: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R3) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R3)),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R3)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
               => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q5),Q2) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
tff(fact_1185_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R3: int] :
      ( ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R3) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R3))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R3),B5)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
               => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Q2),Q5) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
tff(fact_1186_q__pos__lemma,axiom,
    ! [B5: int,Q5: int,R3: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B5),Q5)),R3))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R3),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Q5) ) ) ) ).

% q_pos_lemma
tff(fact_1187_real__divide__square__eq,axiom,
    ! [R: real,A2: real] : ( divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),R),A2),aa(real,real,aa(real,fun(real,real),times_times(real),R),R)) = divide_divide(real,A2,R) ) ).

% real_divide_square_eq
tff(fact_1188_powr__powr__swap,axiom,
    ! [Xa: real,A2: real,B2: real] : ( aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),A2)),B2) = aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,aa(real,fun(real,real),powr(real),Xa),B2)),A2) ) ).

% powr_powr_swap
tff(fact_1189_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),divide_divide(int,A2,B2)),zero_zero(int))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int)) ) ) ).

% pos_imp_zdiv_neg_iff
tff(fact_1190_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),divide_divide(int,A2,B2)),zero_zero(int))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2) ) ) ).

% neg_imp_zdiv_neg_iff
tff(fact_1191_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),divide_divide(int,A2,B2)),zero_zero(int)) ) ) ).

% div_neg_pos_less0
tff(fact_1192_zdiv__int,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,A2,B2)) = divide_divide(int,aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zdiv_int
tff(fact_1193_realpow__pos__nth2,axiom,
    ! [A2: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ? [R4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
          & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),R4),aa(nat,nat,suc,N)) = A2 ) ) ) ).

% realpow_pos_nth2
tff(fact_1194_Bolzano,axiom,
    ! [A2: real,B2: real,P: fun(real,fun(real,$o))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [A4: real,B4: real,C4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),P,A4),B4)
           => ( aa(real,$o,aa(real,fun(real,$o),P,B4),C4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A4),B4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B4),C4)
                 => aa(real,$o,aa(real,fun(real,$o),P,A4),C4) ) ) ) )
       => ( ! [X: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
               => ? [D5: real] :
                    ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
                    & ! [A4: real,B4: real] :
                        ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A4),X)
                          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B4)
                          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B4),A4)),D5) )
                       => aa(real,$o,aa(real,fun(real,$o),P,A4),B4) ) ) ) )
         => aa(real,$o,aa(real,fun(real,$o),P,A2),B2) ) ) ) ).

% Bolzano
tff(fact_1195_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),divide_divide(int,A2,B2))
      <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),A2)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
tff(fact_1196_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),divide_divide(int,A2,B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2) ) ) ).

% pos_imp_zdiv_nonneg_iff
tff(fact_1197_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),divide_divide(int,A2,B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int)) ) ) ).

% neg_imp_zdiv_nonneg_iff
tff(fact_1198_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),divide_divide(int,I,K))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),I) ) ) ).

% pos_imp_zdiv_pos_iff
tff(fact_1199_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),divide_divide(int,A2,B2)),zero_zero(int)) ) ) ).

% div_nonpos_pos_le0
tff(fact_1200_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),divide_divide(int,A2,B2)),zero_zero(int)) ) ) ).

% div_nonneg_neg_le0
tff(fact_1201_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),divide_divide(int,K,L)) ) ) ).

% div_positive_int
tff(fact_1202_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),divide_divide(int,K,L))
    <=> ( ( K = zero_zero(int) )
        | ( L = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
          & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ) ).

% div_int_pos_iff
tff(fact_1203_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),divide_divide(int,A2,B5)),divide_divide(int,A2,B2)) ) ) ) ).

% zdiv_mono2_neg
tff(fact_1204_zdiv__mono1__neg,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),A5)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),divide_divide(int,A5,B2)),divide_divide(int,A2,B2)) ) ) ).

% zdiv_mono1_neg
tff(fact_1205_zdiv__eq__0__iff,axiom,
    ! [I: int,K: int] :
      ( ( divide_divide(int,I,K) = zero_zero(int) )
    <=> ( ( K = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),I),K) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I) ) ) ) ).

% zdiv_eq_0_iff
tff(fact_1206_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B5)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B5),B2)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),divide_divide(int,A2,B2)),divide_divide(int,A2,B5)) ) ) ) ).

% zdiv_mono2
tff(fact_1207_zdiv__mono1,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),A5)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),divide_divide(int,A2,B2)),divide_divide(int,A5,B2)) ) ) ).

% zdiv_mono1
tff(fact_1208_int__div__less__self,axiom,
    ! [Xa: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Xa)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),K)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),divide_divide(int,Xa,K)),Xa) ) ) ).

% int_div_less_self
tff(fact_1209_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( divide_divide(A,A2,B2) = zero_zero(A) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
tff(fact_1210_div__positive,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),divide_divide(A,A2,B2)) ) ) ) ).

% div_positive
tff(fact_1211_discrete,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),B2) ) ) ).

% discrete
tff(fact_1212_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A2,B2),C2) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
tff(fact_1213_realpow__pos__nth__unique,axiom,
    ! [N: nat,A2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ? [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
            & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),X),N) = A2 )
            & ! [Y4: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y4)
                  & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),Y4),N) = A2 ) )
               => ( Y4 = X ) ) ) ) ) ).

% realpow_pos_nth_unique
tff(fact_1214_realpow__pos__nth,axiom,
    ! [N: nat,A2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ? [R4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
            & ( aa(nat,real,aa(real,fun(nat,real),power_power(real),R4),N) = A2 ) ) ) ) ).

% realpow_pos_nth
tff(fact_1215_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
       => ( divide_divide(nat,M,N) = aa(nat,nat,suc,divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N)) ) ) ) ).

% div_geq
tff(fact_1216_split__zdiv,axiom,
    ! [P: fun(int,$o),N: int,K: int] :
      ( aa(int,$o,P,divide_divide(int,N,K))
    <=> ( ( ( K = zero_zero(int) )
         => aa(int,$o,P,zero_zero(int)) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
         => ! [I3: int,J3: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J3)
                & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J3),K)
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I3)),J3) ) )
             => aa(int,$o,P,I3) ) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
         => ! [I3: int,J3: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J3)
                & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J3),zero_zero(int))
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I3)),J3) ) )
             => aa(int,$o,P,I3) ) ) ) ) ).

% split_zdiv
tff(fact_1217_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R)
         => ( divide_divide(int,A2,B2) = Q2 ) ) ) ) ).

% int_div_neg_eq
tff(fact_1218_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
         => ( divide_divide(int,A2,B2) = Q2 ) ) ) ) ).

% int_div_pos_eq
tff(fact_1219_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( divide_divide(A,A2,one_one(A)) = A2 ) ) ).

% bits_div_by_1
tff(fact_1220_bits__div__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( divide_divide(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% bits_div_0
tff(fact_1221_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( divide_divide(A,A2,zero_zero(A)) = zero_zero(A) ) ) ).

% bits_div_by_0
tff(fact_1222_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ).

% mult_le_cancel_iff1
tff(fact_1223_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Z),Y))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ).

% mult_le_cancel_iff2
tff(fact_1224_ceiling__log__eq__powr__iff,axiom,
    ! [Xa: real,B2: real,K: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( ( archimedean_ceiling(real,aa(real,real,log(B2),Xa)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),K)),one_one(int)) )
        <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),B2),aa(nat,real,semiring_1_of_nat(real),K))),Xa)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))))) ) ) ) ) ).

% ceiling_log_eq_powr_iff
tff(fact_1225_log__one,axiom,
    ! [A2: real] : ( aa(real,real,log(A2),one_one(real)) = zero_zero(real) ) ).

% log_one
tff(fact_1226_log__eq__one,axiom,
    ! [A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),A2) = one_one(real) ) ) ) ).

% log_eq_one
tff(fact_1227_log__less__cancel__iff,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),Xa)),aa(real,real,log(A2),Y))
          <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ) ) ) ).

% log_less_cancel_iff
tff(fact_1228_log__less__one__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),Xa)),one_one(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),A2) ) ) ) ).

% log_less_one_cancel_iff
tff(fact_1229_one__less__log__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,log(A2),Xa))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xa) ) ) ) ).

% one_less_log_cancel_iff
tff(fact_1230_log__less__zero__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(A2),Xa)),zero_zero(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real)) ) ) ) ).

% log_less_zero_cancel_iff
tff(fact_1231_zero__less__log__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,log(A2),Xa))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa) ) ) ) ).

% zero_less_log_cancel_iff
tff(fact_1232_zero__le__log__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,log(A2),Xa))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa) ) ) ) ).

% zero_le_log_cancel_iff
tff(fact_1233_log__le__zero__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),Xa)),zero_zero(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real)) ) ) ) ).

% log_le_zero_cancel_iff
tff(fact_1234_one__le__log__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,log(A2),Xa))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Xa) ) ) ) ).

% one_le_log_cancel_iff
tff(fact_1235_log__le__one__cancel__iff,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),Xa)),one_one(real))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),A2) ) ) ) ).

% log_le_one_cancel_iff
tff(fact_1236_log__le__cancel__iff,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(A2),Xa)),aa(real,real,log(A2),Y))
          <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ) ) ) ).

% log_le_cancel_iff
tff(fact_1237_log__powr__cancel,axiom,
    ! [A2: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),aa(real,real,aa(real,fun(real,real),powr(real),A2),Y)) = Y ) ) ) ).

% log_powr_cancel
tff(fact_1238_powr__log__cancel,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,real,aa(real,fun(real,real),powr(real),A2),aa(real,real,log(A2),Xa)) = Xa ) ) ) ) ).

% powr_log_cancel
tff(fact_1239_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(A2),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),B2)) = aa(nat,real,semiring_1_of_nat(real),B2) ) ) ) ).

% log_pow_cancel
tff(fact_1240_log__def,axiom,
    ! [A2: real,Xa: real] : ( aa(real,real,log(A2),Xa) = divide_divide(real,aa(real,real,ln_ln(real),Xa),aa(real,real,ln_ln(real),A2)) ) ).

% log_def
tff(fact_1241_log__base__powr,axiom,
    ! [A2: real,B2: real,Xa: real] :
      ( ( A2 != zero_zero(real) )
     => ( aa(real,real,log(aa(real,real,aa(real,fun(real,real),powr(real),A2),B2)),Xa) = divide_divide(real,aa(real,real,log(A2),Xa),B2) ) ) ).

% log_base_powr
tff(fact_1242_log__powr,axiom,
    ! [Xa: real,B2: real,Y: real] :
      ( ( Xa != zero_zero(real) )
     => ( aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),powr(real),Xa),Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),Y),aa(real,real,log(B2),Xa)) ) ) ).

% log_powr
tff(fact_1243_log__base__change,axiom,
    ! [A2: real,B2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,real,log(B2),Xa) = divide_divide(real,aa(real,real,log(A2),Xa),aa(real,real,log(A2),B2)) ) ) ) ).

% log_base_change
tff(fact_1244_less__log__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,log(B2),Xa))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y)),Xa) ) ) ) ).

% less_log_iff
tff(fact_1245_log__less__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),Xa)),Y)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y)) ) ) ) ).

% log_less_iff
tff(fact_1246_less__powr__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),Xa)),Y) ) ) ) ).

% less_powr_iff
tff(fact_1247_powr__less__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y)),Xa)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,log(B2),Xa)) ) ) ) ).

% powr_less_iff
tff(fact_1248_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( aa(nat,real,semiring_1_of_nat(real),M) = aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),N) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,real,semiring_1_of_nat(real),N) = aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M)) ) ) ) ).

% log_of_power_eq
tff(fact_1249_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),N)),M)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),M)) ) ) ).

% less_log_of_power
tff(fact_1250_log__mult,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
           => ( aa(real,real,log(A2),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(A2),Xa)),aa(real,real,log(A2),Y)) ) ) ) ) ) ).

% log_mult
tff(fact_1251_powr__le__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y)),Xa)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,log(B2),Xa)) ) ) ) ).

% powr_le_iff
tff(fact_1252_le__powr__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),Xa)),Y) ) ) ) ).

% le_powr_iff
tff(fact_1253_log__le__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),Xa)),Y)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y)) ) ) ) ).

% log_le_iff
tff(fact_1254_le__log__iff,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,log(B2),Xa))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y)),Xa) ) ) ) ).

% le_log_iff
tff(fact_1255_log__divide,axiom,
    ! [A2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
           => ( aa(real,real,log(A2),divide_divide(real,Xa,Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(A2),Xa)),aa(real,real,log(A2),Y)) ) ) ) ) ) ).

% log_divide
tff(fact_1256_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),N)),M)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),M)) ) ) ).

% le_log_of_power
tff(fact_1257_log__base__pow,axiom,
    ! [A2: real,N: nat,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( aa(real,real,log(aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),N)),Xa) = divide_divide(real,aa(real,real,log(A2),Xa),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ).

% log_base_pow
tff(fact_1258_log__nat__power,axiom,
    ! [Xa: real,B2: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,log(B2),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),Xa)) ) ) ).

% log_nat_power
tff(fact_1259_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),M)),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),N))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ) ).

% log_of_power_less
tff(fact_1260_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
         => ( ( B2 != one_one(real) )
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
             => ( aa(real,real,log(A2),Xa) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,ln_ln(real),B2),aa(real,real,ln_ln(real),A2))),aa(real,real,log(B2),Xa)) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
tff(fact_1261_log__add__eq__powr,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,log(B2),Xa)),Y) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y))) ) ) ) ) ).

% log_add_eq_powr
tff(fact_1262_add__log__eq__powr,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),Y),aa(real,real,log(B2),Xa)) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),powr(real),B2),Y)),Xa)) ) ) ) ) ).

% add_log_eq_powr
tff(fact_1263_minus__log__eq__powr,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),aa(real,real,log(B2),Xa)) = aa(real,real,log(B2),divide_divide(real,aa(real,real,aa(real,fun(real,real),powr(real),B2),Y),Xa)) ) ) ) ) ).

% minus_log_eq_powr
tff(fact_1264_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),M)),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),N))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(B2),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ) ).

% log_of_power_le
tff(fact_1265_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Z)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y) ) ) ) ).

% mult_less_iff1
tff(fact_1266_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,F3: fun(A,nat),N: nat] :
      ( aa(A,$o,P,K)
     => ( ! [X: A] :
            ( aa(A,$o,P,X)
           => ? [Y4: A] :
                ( aa(A,$o,P,Y4)
                & ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F3,Y4)),aa(A,nat,F3,X)) ) )
       => ? [Y3: A] :
            ( aa(A,$o,P,Y3)
            & ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F3,Y3)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F3,K)),N)) ) ) ) ).

% ex_has_greatest_nat_lemma
tff(fact_1267_powr__int,axiom,
    ! [Xa: real,I: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(int,real,ring_1_of_int(real),I))
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(int,nat,nat2,I)),divide_divide(real,one_one(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),I))))) ) ) ).

% powr_int
tff(fact_1268_floor__log__eq__powr__iff,axiom,
    ! [Xa: real,B2: real,K: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(B2),Xa)) = K )
        <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),powr(real),B2),aa(int,real,ring_1_of_int(real),K))),Xa)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))))) ) ) ) ) ).

% floor_log_eq_powr_iff
tff(fact_1269_nat0__intermed__int__val,axiom,
    ! [N: nat,F3: fun(nat,int),K: int] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),N)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I2),one_one(nat)))),aa(nat,int,F3,I2)))),one_one(int)) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F3,zero_zero(nat))),K)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F3,N))
         => ? [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),N)
              & ( aa(nat,int,F3,I2) = K ) ) ) ) ) ).

% nat0_intermed_int_val
tff(fact_1270_root__powr__inverse,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(real,real,root(N),Xa) = aa(real,real,aa(real,fun(real,real),powr(real),Xa),divide_divide(real,one_one(real),aa(nat,real,semiring_1_of_nat(real),N))) ) ) ) ).

% root_powr_inverse
tff(fact_1271_log__minus__eq__powr,axiom,
    ! [B2: real,Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
     => ( ( B2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,log(B2),Xa)),Y) = aa(real,real,log(B2),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),aa(real,real,aa(real,fun(real,real),powr(real),B2),aa(real,real,uminus_uminus(real),Y)))) ) ) ) ) ).

% log_minus_eq_powr
tff(fact_1272_eq__diff__eq_H,axiom,
    ! [Xa: real,Y: real,Z: real] :
      ( ( Xa = aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),Z) )
    <=> ( Y = aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Z) ) ) ).

% eq_diff_eq'
tff(fact_1273_nat__descend__induct,axiom,
    ! [N: nat,P: fun(nat,$o),M: nat] :
      ( ! [K3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),K3)
         => aa(nat,$o,P,K3) )
     => ( ! [K3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N)
           => ( ! [I4: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K3),I4)
                 => aa(nat,$o,P,I4) )
             => aa(nat,$o,P,K3) ) )
       => aa(nat,$o,P,M) ) ) ).

% nat_descend_induct
tff(fact_1274_verit__minus__simplify_I4_J,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),B2)) = B2 ) ) ).

% verit_minus_simplify(4)
tff(fact_1275_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,uminus_uminus(A),B2) )
        <=> ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
tff(fact_1276_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,uminus_uminus(A),A2)) = A2 ) ) ).

% add.inverse_inverse
tff(fact_1277_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_idempotent
tff(fact_1278_abs__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,abs_abs(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_abs
tff(fact_1279_arsinh__minus__real,axiom,
    ! [Xa: real] : ( aa(real,real,arsinh(real),aa(real,real,uminus_uminus(real),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,arsinh(real),Xa)) ) ).

% arsinh_minus_real
tff(fact_1280_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% neg_le_iff_le
tff(fact_1281_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = A2 )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% neg_equal_zero
tff(fact_1282_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% equal_neg_zero
tff(fact_1283_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% neg_equal_0_iff_equal
tff(fact_1284_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),A2) )
        <=> ( zero_zero(A) = A2 ) ) ) ).

% neg_0_equal_iff_equal
tff(fact_1285_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ( aa(A,A,uminus_uminus(A),zero_zero(A)) = zero_zero(A) ) ) ).

% add.inverse_neutral
tff(fact_1286_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% neg_less_iff_less
tff(fact_1287_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% mult_minus_left
tff(fact_1288_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) ) ) ).

% minus_mult_minus
tff(fact_1289_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ) ).

% mult_minus_right
tff(fact_1290_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_add_distrib
tff(fact_1291_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = B2 ) ) ).

% minus_add_cancel
tff(fact_1292_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),B2)) = B2 ) ) ).

% add_minus_cancel
tff(fact_1293_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) ) ) ).

% minus_diff_eq
tff(fact_1294_abs__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_0
tff(fact_1295_abs__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ( aa(A,A,abs_abs(A),zero_zero(A)) = zero_zero(A) ) ) ).

% abs_zero
tff(fact_1296_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_eq_0
tff(fact_1297_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( ( zero_zero(A) = aa(A,A,abs_abs(A),A2) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_0_eq
tff(fact_1298_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),A2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) ) ) ).

% abs_mult_self_eq
tff(fact_1299_abs__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_1
tff(fact_1300_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_add_abs
tff(fact_1301_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_minus_cancel
tff(fact_1302_abs__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,abs_abs(A),A2) ) ) ).

% abs_minus
tff(fact_1303_abs__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,semiring_1_of_nat(A),N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ).

% abs_of_nat
tff(fact_1304_real__root__zero,axiom,
    ! [N: nat] : ( aa(real,real,root(N),zero_zero(real)) = zero_zero(real) ) ).

% real_root_zero
tff(fact_1305_floor__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int] : ( archim6421214686448440834_floor(A,aa(int,A,ring_1_of_int(A),Z)) = Z ) ) ).

% floor_of_int
tff(fact_1306_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% neg_less_eq_nonneg
tff(fact_1307_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% less_eq_neg_nonpos
tff(fact_1308_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% neg_le_0_iff_le
tff(fact_1309_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% neg_0_le_iff_le
tff(fact_1310_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% neg_less_0_iff_less
tff(fact_1311_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% neg_0_less_iff_less
tff(fact_1312_neg__less__pos,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% neg_less_pos
tff(fact_1313_less__neg__neg,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% less_neg_neg
tff(fact_1314_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),A2)) = zero_zero(A) ) ) ).

% add.right_inverse
tff(fact_1315_ab__left__minus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),A2) = zero_zero(A) ) ) ).

% ab_left_minus
tff(fact_1316_diff__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ).

% diff_0
tff(fact_1317_verit__minus__simplify_I3_J,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),zero_zero(A)),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% verit_minus_simplify(3)
tff(fact_1318_mult__minus1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),one_one(A))),Z) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1
tff(fact_1319_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),Z) ) ) ).

% mult_minus1_right
tff(fact_1320_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),zero_zero(A))
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_le_zero_iff
tff(fact_1321_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% abs_le_self_iff
tff(fact_1322_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,A,abs_abs(A),A2) = A2 ) ) ) ).

% abs_of_nonneg
tff(fact_1323_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) ) ) ).

% diff_minus_eq_add
tff(fact_1324_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2) ) ) ).

% uminus_add_conv_diff
tff(fact_1325_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,abs_abs(A),A2))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% zero_less_abs_iff
tff(fact_1326_div__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A] : ( divide_divide(A,A2,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),A2) ) ) ).

% div_minus1_right
tff(fact_1327_divide__minus1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A] : ( divide_divide(A,Xa,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),Xa) ) ) ).

% divide_minus1
tff(fact_1328_abs__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),one_one(A))) = one_one(A) ) ) ).

% abs_neg_one
tff(fact_1329_abs__power__minus,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),N)) = aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% abs_power_minus
tff(fact_1330_floor__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,zero_zero(A)) = zero_zero(int) ) ) ).

% floor_zero
tff(fact_1331_of__int__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),Z)) = aa(A,A,uminus_uminus(A),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% of_int_minus
tff(fact_1332_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N)) = aa(nat,int,semiring_1_of_nat(int),M) )
    <=> ( ( N = zero_zero(nat) )
        & ( M = zero_zero(nat) ) ) ) ).

% negative_eq_positive
tff(fact_1333_real__root__Suc__0,axiom,
    ! [Xa: real] : ( aa(real,real,root(aa(nat,nat,suc,zero_zero(nat))),Xa) = Xa ) ).

% real_root_Suc_0
tff(fact_1334_floor__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ( archim6421214686448440834_floor(A,one_one(A)) = one_one(int) ) ) ).

% floor_one
tff(fact_1335_real__add__minus__iff,axiom,
    ! [Xa: real,A2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,uminus_uminus(real),A2)) = zero_zero(real) )
    <=> ( Xa = A2 ) ) ).

% real_add_minus_iff
tff(fact_1336_root__0,axiom,
    ! [Xa: real] : ( aa(real,real,root(zero_zero(nat)),Xa) = zero_zero(real) ) ).

% root_0
tff(fact_1337_real__root__eq__iff,axiom,
    ! [N: nat,Xa: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ( aa(real,real,root(N),Xa) = aa(real,real,root(N),Y) )
      <=> ( Xa = Y ) ) ) ).

% real_root_eq_iff
tff(fact_1338_negative__zle,axiom,
    ! [N: nat,M: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N))),aa(nat,int,semiring_1_of_nat(int),M)) ).

% negative_zle
tff(fact_1339_of__int__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,abs_abs(int),Xa)) = aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),Xa)) ) ) ).

% of_int_abs
tff(fact_1340_floor__of__nat,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: nat] : ( archim6421214686448440834_floor(A,aa(nat,A,semiring_1_of_nat(A),N)) = aa(nat,int,semiring_1_of_nat(int),N) ) ) ).

% floor_of_nat
tff(fact_1341_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_inc_simps(4)
tff(fact_1342_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% add_neg_numeral_special(7)
tff(fact_1343_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = zero_zero(A) ) ) ).

% add_neg_numeral_special(8)
tff(fact_1344_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% diff_numeral_special(12)
tff(fact_1345_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
         => ( aa(A,A,abs_abs(A),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% abs_of_nonpos
tff(fact_1346_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,A2,aa(A,A,abs_abs(A),B2))),zero_zero(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))
            | ( B2 = zero_zero(A) ) ) ) ) ).

% divide_le_0_abs_iff
tff(fact_1347_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),divide_divide(A,A2,aa(A,A,abs_abs(A),B2)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            | ( B2 = zero_zero(A) ) ) ) ) ).

% zero_le_divide_abs_iff
tff(fact_1348_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)) = one_one(A) ) ) ).

% minus_one_mult_self
tff(fact_1349_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),A2)) = A2 ) ) ).

% left_minus_one_mult_self
tff(fact_1350_real__root__eq__0__iff,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ( aa(real,real,root(N),Xa) = zero_zero(real) )
      <=> ( Xa = zero_zero(real) ) ) ) ).

% real_root_eq_0_iff
tff(fact_1351_real__root__less__iff,axiom,
    ! [N: nat,Xa: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N),Xa)),aa(real,real,root(N),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ) ).

% real_root_less_iff
tff(fact_1352_real__root__le__iff,axiom,
    ! [N: nat,Xa: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N),Xa)),aa(real,real,root(N),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ) ).

% real_root_le_iff
tff(fact_1353_real__root__eq__1__iff,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ( aa(real,real,root(N),Xa) = one_one(real) )
      <=> ( Xa = one_one(real) ) ) ) ).

% real_root_eq_1_iff
tff(fact_1354_real__root__one,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,real,root(N),one_one(real)) = one_one(real) ) ) ).

% real_root_one
tff(fact_1355_negative__zless,axiom,
    ! [N: nat,M: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N)))),aa(nat,int,semiring_1_of_nat(int),M)) ).

% negative_zless
tff(fact_1356_nat__zminus__int,axiom,
    ! [N: nat] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N))) = zero_zero(nat) ) ).

% nat_zminus_int
tff(fact_1357_floor__uminus__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int] : ( archim6421214686448440834_floor(A,aa(A,A,uminus_uminus(A),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,uminus_uminus(int),Z) ) ) ).

% floor_uminus_of_int
tff(fact_1358_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),Z)),one_one(int))
    <=> ( Z = zero_zero(int) ) ) ).

% zabs_less_one_iff
tff(fact_1359_floor__diff__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(int,A,ring_1_of_int(A),Z))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,Xa)),Z) ) ) ).

% floor_diff_of_int
tff(fact_1360_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% dbl_dec_simps(2)
tff(fact_1361_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),N))
        <=> ( ( A2 != zero_zero(A) )
            | ( N = zero_zero(nat) ) ) ) ) ).

% zero_less_power_abs_iff
tff(fact_1362_zero__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa) ) ) ).

% zero_le_floor
tff(fact_1363_floor__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,Xa)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),zero_zero(A)) ) ) ).

% floor_less_zero
tff(fact_1364_zero__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),Xa) ) ) ).

% zero_less_floor
tff(fact_1365_floor__le__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),one_one(A)) ) ) ).

% floor_le_zero
tff(fact_1366_one__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),one_one(int)),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),Xa) ) ) ).

% one_le_floor
tff(fact_1367_floor__less__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,Xa)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),one_one(A)) ) ) ).

% floor_less_one
tff(fact_1368_real__root__lt__0__iff,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N),Xa)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real)) ) ) ).

% real_root_lt_0_iff
tff(fact_1369_real__root__gt__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,root(N),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y) ) ) ).

% real_root_gt_0_iff
tff(fact_1370_real__root__ge__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(N),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y) ) ) ).

% real_root_ge_0_iff
tff(fact_1371_real__root__le__0__iff,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N),Xa)),zero_zero(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real)) ) ) ).

% real_root_le_0_iff
tff(fact_1372_real__root__lt__1__iff,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N),Xa)),one_one(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real)) ) ) ).

% real_root_lt_1_iff
tff(fact_1373_real__root__gt__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,root(N),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Y) ) ) ).

% real_root_gt_1_iff
tff(fact_1374_real__root__ge__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,root(N),Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y) ) ) ).

% real_root_ge_1_iff
tff(fact_1375_real__root__le__1__iff,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N),Xa)),one_one(real))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real)) ) ) ).

% real_root_le_1_iff
tff(fact_1376_floor__diff__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),one_one(A))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,Xa)),one_one(int)) ) ) ).

% floor_diff_one
tff(fact_1377_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,Xa)),zero_zero(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ).

% ceiling_less_zero
tff(fact_1378_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),Xa) ) ) ).

% zero_le_ceiling
tff(fact_1379_real__root__pow__pos2,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
       => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),N) = Xa ) ) ) ).

% real_root_pow_pos2
tff(fact_1380_abs__leI,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2) ) ) ) ).

% abs_leI
tff(fact_1381_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% abs_le_D2
tff(fact_1382_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ) ).

% abs_le_iff
tff(fact_1383_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_minus_self
tff(fact_1384_ceiling__minus,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_ceiling(A,aa(A,A,uminus_uminus(A),Xa)) = aa(int,int,uminus_uminus(int),archim6421214686448440834_floor(A,Xa)) ) ) ).

% ceiling_minus
tff(fact_1385_floor__minus,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archim6421214686448440834_floor(A,aa(A,A,uminus_uminus(A),Xa)) = aa(int,int,uminus_uminus(int),archimedean_ceiling(A,Xa)) ) ) ).

% floor_minus
tff(fact_1386_ceiling__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_ceiling(A,Xa) = aa(int,int,uminus_uminus(int),archim6421214686448440834_floor(A,aa(A,A,uminus_uminus(A),Xa))) ) ) ).

% ceiling_def
tff(fact_1387_abs__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),B2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ) ).

% abs_less_iff
tff(fact_1388_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,uminus_uminus(A),B2) ) ) ) ).

% verit_negate_coefficient(3)
tff(fact_1389_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = B2 )
        <=> ( aa(A,A,uminus_uminus(A),B2) = A2 ) ) ) ).

% minus_equation_iff
tff(fact_1390_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% equation_minus_iff
tff(fact_1391_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,abs_abs(A),Xa) = aa(A,A,abs_abs(A),Y) )
        <=> ( ( Xa = Y )
            | ( Xa = aa(A,A,uminus_uminus(A),Y) ) ) ) ) ).

% abs_eq_iff
tff(fact_1392_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = B2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
            & ( ( A2 = B2 )
              | ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ) ).

% abs_eq_iff'
tff(fact_1393_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( linordered_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,abs_abs(A),B2) )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            & ( ( B2 = A2 )
              | ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ) ) ).

% eq_abs_iff'
tff(fact_1394_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,abs_abs(A),A2))),zero_zero(A)) ) ).

% abs_minus_le_zero
tff(fact_1395_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,A,abs_abs(A),A2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% abs_of_neg
tff(fact_1396_abs__if,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [A2: A] :
          ( aa(A,A,abs_abs(A),A2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)),aa(A,A,uminus_uminus(A),A2),A2) ) ) ).

% abs_if
tff(fact_1397_abs__if__raw,axiom,
    ! [A: $tType] :
      ( abs_if(A)
     => ! [X3: A] :
          ( aa(A,A,abs_abs(A),X3)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),zero_zero(A)),aa(A,A,uminus_uminus(A),X3),X3) ) ) ).

% abs_if_raw
tff(fact_1398_zabs__def,axiom,
    ! [I: int] :
      ( aa(int,int,abs_abs(int),I)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),I),zero_zero(int)),aa(int,int,uminus_uminus(int),I),I) ) ).

% zabs_def
tff(fact_1399_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_self
tff(fact_1400_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% abs_le_D1
tff(fact_1401_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] :
          ( ( aa(A,A,abs_abs(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% abs_eq_0_iff
tff(fact_1402_abs__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ).

% abs_mult
tff(fact_1403_abs__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( aa(A,A,abs_abs(A),one_one(A)) = one_one(A) ) ) ).

% abs_one
tff(fact_1404_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ).

% abs_minus_commute
tff(fact_1405_power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] : ( aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),N) ) ) ).

% power_abs
tff(fact_1406_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,Xa: real] : ( aa(real,real,root(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),Xa) = aa(real,real,root(M),aa(real,real,root(N),Xa)) ) ).

% real_root_mult_exp
tff(fact_1407_real__root__mult,axiom,
    ! [N: nat,Xa: real,Y: real] : ( aa(real,real,root(N),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,root(N),Xa)),aa(real,real,root(N),Y)) ) ).

% real_root_mult
tff(fact_1408_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% le_imp_neg_le
tff(fact_1409_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),A2) ) ) ).

% minus_le_iff
tff(fact_1410_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% le_minus_iff
tff(fact_1411_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% verit_negate_coefficient(2)
tff(fact_1412_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),A2)),B2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),A2) ) ) ).

% minus_less_iff
tff(fact_1413_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% less_minus_iff
tff(fact_1414_square__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),B2) )
        <=> ( ( A2 = B2 )
            | ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% square_eq_iff
tff(fact_1415_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ring(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% minus_mult_commute
tff(fact_1416_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( one_one(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% one_neq_neg_one
tff(fact_1417_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% add.inverse_distrib_swap
tff(fact_1418_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A3: A,K: A,A2: A] :
          ( ( A3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),A2) )
         => ( aa(A,A,uminus_uminus(A),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,uminus_uminus(A),A2)) ) ) ) ).

% group_cancel.neg1
tff(fact_1419_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [A2: A,B2: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,uminus_uminus(A),A2)) ) ) ).

% is_num_normalize(8)
tff(fact_1420_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),B2)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),B2) ) ) ).

% minus_diff_commute
tff(fact_1421_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ).

% minus_diff_minus
tff(fact_1422_uminus__int__code_I1_J,axiom,
    aa(int,int,uminus_uminus(int),zero_zero(int)) = zero_zero(int) ).

% uminus_int_code(1)
tff(fact_1423_int__cases2,axiom,
    ! [Z: int] :
      ( ! [N2: nat] : ( Z != aa(nat,int,semiring_1_of_nat(int),N2) )
     => ~ ! [N2: nat] : ( Z != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) ) ) ).

% int_cases2
tff(fact_1424_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,abs_abs(A),A2)) ) ).

% abs_ge_zero
tff(fact_1425_floor__mono,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),archim6421214686448440834_floor(A,Y)) ) ) ).

% floor_mono
tff(fact_1426_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,A,abs_abs(A),A2) = A2 ) ) ) ).

% abs_of_pos
tff(fact_1427_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),zero_zero(A)) ) ).

% abs_not_less_zero
tff(fact_1428_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,Xa))),Xa) ) ).

% of_int_floor_le
tff(fact_1429_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,Xa)),archim6421214686448440834_floor(A,Y))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y) ) ) ).

% floor_less_cancel
tff(fact_1430_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) ) ).

% abs_triangle_ineq
tff(fact_1431_abs__mult__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),A2)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),B2)),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2)) ) ) ) ).

% abs_mult_less
tff(fact_1432_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))) ) ).

% abs_triangle_ineq2_sym
tff(fact_1433_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% abs_triangle_ineq3
tff(fact_1434_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% abs_triangle_ineq2
tff(fact_1435_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),divide_divide(A,A2,B2)) = divide_divide(A,aa(A,A,abs_abs(A),A2),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% nonzero_abs_divide
tff(fact_1436_real__root__pos__pos__le,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(N),Xa)) ) ).

% real_root_pos_pos_le
tff(fact_1437_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),archimedean_ceiling(A,Xa)) ) ).

% floor_le_ceiling
tff(fact_1438_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% le_minus_one_simps(4)
tff(fact_1439_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) ) ).

% le_minus_one_simps(2)
tff(fact_1440_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ( zero_zero(A) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% zero_neq_neg_one
tff(fact_1441_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) )
        <=> ( B2 = aa(A,A,uminus_uminus(A),A2) ) ) ) ).

% add_eq_0_iff
tff(fact_1442_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),A2) = zero_zero(A) ) ) ).

% ab_group_add_class.ab_left_minus
tff(fact_1443_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),A2) = B2 ) ) ) ).

% add.inverse_unique
tff(fact_1444_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),B2) )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) ) ) ) ).

% eq_neg_iff_add_eq_0
tff(fact_1445_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,uminus_uminus(A),A2) = B2 )
        <=> ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = zero_zero(A) ) ) ) ).

% neg_eq_iff_add_eq_0
tff(fact_1446_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% less_minus_one_simps(4)
tff(fact_1447_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) ) ).

% less_minus_one_simps(2)
tff(fact_1448_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( divide_divide(A,aa(A,A,uminus_uminus(A),A2),aa(A,A,uminus_uminus(A),B2)) = divide_divide(A,A2,B2) ) ) ) ).

% nonzero_minus_divide_divide
tff(fact_1449_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,A,uminus_uminus(A),divide_divide(A,A2,B2)) = divide_divide(A,A2,aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% nonzero_minus_divide_right
tff(fact_1450_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [Xa: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa) = one_one(A) )
        <=> ( ( Xa = one_one(A) )
            | ( Xa = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% square_eq_1_iff
tff(fact_1451_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3 = aa(A,A,aa(A,fun(A,A),plus_plus(A),K),B2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),K)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% group_cancel.sub2
tff(fact_1452_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% diff_conv_add_uminus
tff(fact_1453_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,uminus_uminus(A),B2)) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
tff(fact_1454_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),M),N)) = one_one(int) )
     => ( aa(int,int,abs_abs(int),M) = one_one(int) ) ) ).

% abs_zmult_eq_1
tff(fact_1455_real__minus__mult__self__le,axiom,
    ! [U: real,Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),U),U))),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Xa)) ).

% real_minus_mult_self_le
tff(fact_1456_floor__le__round,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),archimedean_round(A,Xa)) ) ).

% floor_le_round
tff(fact_1457_int__cases,axiom,
    ! [Z: int] :
      ( ! [N2: nat] : ( Z != aa(nat,int,semiring_1_of_nat(int),N2) )
     => ~ ! [N2: nat] : ( Z != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N2))) ) ) ).

% int_cases
tff(fact_1458_int__of__nat__induct,axiom,
    ! [P: fun(int,$o),Z: int] :
      ( ! [N2: nat] : aa(int,$o,P,aa(nat,int,semiring_1_of_nat(int),N2))
     => ( ! [N2: nat] : aa(int,$o,P,aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N2))))
       => aa(int,$o,P,Z) ) ) ).

% int_of_nat_induct
tff(fact_1459_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),N) = one_one(int) )
    <=> ( ( ( M = one_one(int) )
          & ( N = one_one(int) ) )
        | ( ( M = aa(int,int,uminus_uminus(int),one_one(int)) )
          & ( N = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ) ).

% zmult_eq_1_iff
tff(fact_1460_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( aa(int,int,aa(int,fun(int,int),times_times(int),M),N) = one_one(int) )
     => ( ( M = one_one(int) )
        | ( M = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
tff(fact_1461_minus__int__code_I2_J,axiom,
    ! [L: int] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),zero_zero(int)),L) = aa(int,int,uminus_uminus(int),L) ) ).

% minus_int_code(2)
tff(fact_1462_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),M))) ).

% not_int_zless_negative
tff(fact_1463_minus__real__def,axiom,
    ! [Xa: real,Y: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,uminus_uminus(real),Y)) ) ).

% minus_real_def
tff(fact_1464_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( aa(int,A,ring_1_of_int(A),K)
          = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),K)))),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,K))) ) ) ).

% of_int_of_nat
tff(fact_1465_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs(A)
        & dense_linorder(A) )
     => ! [Xa: A] :
          ( ! [E2: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),E2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),Xa)),E2) )
         => ( Xa = zero_zero(A) ) ) ) ).

% dense_eq0_I
tff(fact_1466_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),Y)),Xa) = aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Xa)) ) ) ) ).

% abs_mult_pos
tff(fact_1467_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ordered_ring_abs(A)
     => ! [A2: A,B2: A] :
          ( ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
              | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
              | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% abs_eq_mult
tff(fact_1468_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),N)) ) ).

% zero_le_power_abs
tff(fact_1469_abs__div__pos,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Y)
         => ( divide_divide(A,aa(A,A,abs_abs(A),Xa),Y) = aa(A,A,abs_abs(A),divide_divide(A,Xa,Y)) ) ) ) ).

% abs_div_pos
tff(fact_1470_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,A2: A,R: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),A2))),R)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),R)),Xa)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),R)) ) ) ) ).

% abs_diff_le_iff
tff(fact_1471_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))) ) ).

% abs_triangle_ineq4
tff(fact_1472_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [A2: A,B2: A,C2: A,D2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)))) ) ).

% abs_diff_triangle_ineq
tff(fact_1473_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,A2: A,R: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),A2))),R)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),R)),Xa)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),R)) ) ) ) ).

% abs_diff_less_iff
tff(fact_1474_real__root__less__mono,axiom,
    ! [N: nat,Xa: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N),Xa)),aa(real,real,root(N),Y)) ) ) ).

% real_root_less_mono
tff(fact_1475_le__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),Xa) ) ) ).

% le_floor_iff
tff(fact_1476_real__root__le__mono,axiom,
    ! [N: nat,Xa: real,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N),Xa)),aa(real,real,root(N),Y)) ) ) ).

% real_root_le_mono
tff(fact_1477_floor__less__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,Xa)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(int,A,ring_1_of_int(A),Z)) ) ) ).

% floor_less_iff
tff(fact_1478_le__floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),archim6421214686448440834_floor(A,Y))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))) ) ).

% le_floor_add
tff(fact_1479_int__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,Xa: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),Z),archim6421214686448440834_floor(A,Xa)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),Xa)) ) ) ).

% int_add_floor
tff(fact_1480_floor__add__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),Z) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(int,A,ring_1_of_int(A),Z))) ) ) ).

% floor_add_int
tff(fact_1481_real__root__power,axiom,
    ! [N: nat,Xa: real,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,real,root(N),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),K)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),K) ) ) ).

% real_root_power
tff(fact_1482_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [K: int,L: int] : ( archim6421214686448440834_floor(A,divide_divide(A,aa(int,A,ring_1_of_int(A),K),aa(int,A,ring_1_of_int(A),L))) = divide_divide(int,K,L) ) ) ).

% floor_divide_of_int_eq
tff(fact_1483_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% le_minus_one_simps(3)
tff(fact_1484_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A)) ) ).

% le_minus_one_simps(1)
tff(fact_1485_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% less_minus_one_simps(3)
tff(fact_1486_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),zero_zero(A)) ) ).

% less_minus_one_simps(1)
tff(fact_1487_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) = aa(A,A,uminus_uminus(A),B2),A2 = zero_zero(A)) ) ) ).

% eq_minus_divide_eq
tff(fact_1488_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)) = A2 )
        <=> $ite(C2 != zero_zero(A),aa(A,A,uminus_uminus(A),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),A2 = zero_zero(A)) ) ) ).

% minus_divide_eq_eq
tff(fact_1489_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( aa(A,A,uminus_uminus(A),divide_divide(A,A2,B2)) = C2 )
          <=> ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
tff(fact_1490_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( C2 = aa(A,A,uminus_uminus(A),divide_divide(A,A2,B2)) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) = aa(A,A,uminus_uminus(A),A2) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
tff(fact_1491_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( divide_divide(A,A2,B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( B2 != zero_zero(A) )
            & ( A2 = aa(A,A,uminus_uminus(A),B2) ) ) ) ) ).

% divide_eq_minus_1_iff
tff(fact_1492_power__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% power_minus
tff(fact_1493_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] : ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),times_times(int),W),Z))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),W))),aa(int,nat,nat2,aa(int,int,abs_abs(int),Z))) ) ).

% nat_abs_mult_distrib
tff(fact_1494_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [Xa: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),powr(A),Xa),aa(A,A,uminus_uminus(A),A2)) = divide_divide(A,one_one(A),aa(A,A,aa(A,fun(A,A),powr(A),Xa),A2)) ) ) ).

% powr_minus_divide
tff(fact_1495_int__cases4,axiom,
    ! [M: int] :
      ( ! [N2: nat] : ( M != aa(nat,int,semiring_1_of_nat(int),N2) )
     => ~ ! [N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
           => ( M != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) ) ) ) ).

% int_cases4
tff(fact_1496_real__add__less__0__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,uminus_uminus(real),Xa)) ) ).

% real_add_less_0_iff
tff(fact_1497_real__0__less__add__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),Xa)),Y) ) ).

% real_0_less_add_iff
tff(fact_1498_real__add__le__0__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,uminus_uminus(real),Xa)) ) ).

% real_add_le_0_iff
tff(fact_1499_real__0__le__add__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),Xa)),Y) ) ).

% real_0_le_add_iff
tff(fact_1500_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),N)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),M)))
    <=> ( ( N = zero_zero(nat) )
        & ( M = zero_zero(nat) ) ) ) ).

% int_zle_neg
tff(fact_1501_negative__zle__0,axiom,
    ! [N: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N))),zero_zero(int)) ).

% negative_zle_0
tff(fact_1502_nonpos__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ~ ! [N2: nat] : ( K != aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) ) ) ).

% nonpos_int_cases
tff(fact_1503_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] : ( divide_divide(real,A2,aa(real,real,aa(real,fun(real,real),powr(real),B2),C2)) = aa(real,real,aa(real,fun(real,real),times_times(real),A2),aa(real,real,aa(real,fun(real,real),powr(real),B2),aa(real,real,uminus_uminus(real),C2))) ) ).

% divide_powr_uminus
tff(fact_1504_ex__has__least__nat,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,M: fun(A,nat)] :
      ( aa(A,$o,P,K)
     => ? [X: A] :
          ( aa(A,$o,P,X)
          & ! [Y4: A] :
              ( aa(A,$o,P,Y4)
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,M,X)),aa(A,nat,M,Y4)) ) ) ) ).

% ex_has_least_nat
tff(fact_1505_bounded__Max__nat,axiom,
    ! [P: fun(nat,$o),Xa: nat,M7: nat] :
      ( aa(nat,$o,P,Xa)
     => ( ! [X: nat] :
            ( aa(nat,$o,P,X)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),M7) )
       => ~ ! [M2: nat] :
              ( aa(nat,$o,P,M2)
             => ~ ! [X3: nat] :
                    ( aa(nat,$o,P,X3)
                   => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),M2) ) ) ) ) ).

% bounded_Max_nat
tff(fact_1506_of__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [R: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),R)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,archim6421214686448440834_floor(A,R)))),R) ) ) ).

% of_nat_floor
tff(fact_1507_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,abs_abs(A),Xa))) ) ).

% abs_add_one_gt_zero
tff(fact_1508_one__add__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),one_one(int)) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),one_one(A))) ) ) ).

% one_add_floor
tff(fact_1509_real__root__gt__zero,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,root(N),Xa)) ) ) ).

% real_root_gt_zero
tff(fact_1510_real__root__strict__decreasing,axiom,
    ! [N: nat,N6: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N6)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N6),Xa)),aa(real,real,root(N),Xa)) ) ) ) ).

% real_root_strict_decreasing
tff(fact_1511_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,archim6421214686448440834_floor(A,A2))),aa(int,nat,nat2,archim6421214686448440834_floor(A,B2)))),aa(int,nat,nat2,archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))) ) ).

% le_mult_nat_floor
tff(fact_1512_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [M: nat,N: nat] : ( archim6421214686448440834_floor(A,divide_divide(A,aa(nat,A,semiring_1_of_nat(A),M),aa(nat,A,semiring_1_of_nat(A),N))) = aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,M,N)) ) ) ).

% floor_divide_of_nat_eq
tff(fact_1513_nat__floor__neg,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
     => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,Xa)) = zero_zero(nat) ) ) ).

% nat_floor_neg
tff(fact_1514_of__int__leD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),Xa)
         => ( ( N = zero_zero(int) )
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),Xa) ) ) ) ).

% of_int_leD
tff(fact_1515_of__int__lessD,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: int,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(int,A,ring_1_of_int(A),N))),Xa)
         => ( ( N = zero_zero(int) )
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Xa) ) ) ) ).

% of_int_lessD
tff(fact_1516_floor__eq3,axiom,
    ! [N: nat,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N)))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,Xa)) = N ) ) ) ).

% floor_eq3
tff(fact_1517_le__nat__floor,axiom,
    ! [Xa: nat,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),Xa)),A2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),aa(int,nat,nat2,archim6421214686448440834_floor(real,A2))) ) ).

% le_nat_floor
tff(fact_1518_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( archimedean_ceiling(A,Xa)
          = $ite(Xa = aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,Xa)),archim6421214686448440834_floor(A,Xa),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),one_one(int))) ) ) ).

% ceiling_altdef
tff(fact_1519_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,Xa)),archim6421214686448440834_floor(A,Xa))),one_one(int)) ) ).

% ceiling_diff_floor_le_1
tff(fact_1520_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),R),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R))),one_one(real))) ).

% real_of_int_floor_add_one_gt
tff(fact_1521_floor__eq,axiom,
    ! [N: int,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(int,real,ring_1_of_int(real),N)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),N)),one_one(real)))
       => ( archim6421214686448440834_floor(real,Xa) = N ) ) ) ).

% floor_eq
tff(fact_1522_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),R),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R))),one_one(real))) ).

% real_of_int_floor_add_one_ge
tff(fact_1523_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R),one_one(real))),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R))) ).

% real_of_int_floor_gt_diff_one
tff(fact_1524_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),R),one_one(real))),aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,R))) ).

% real_of_int_floor_ge_diff_one
tff(fact_1525_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))) ) ) ) ).

% less_minus_divide_eq
tff(fact_1526_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)) ) ) ) ).

% minus_divide_less_eq
tff(fact_1527_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_less_minus_divide_eq
tff(fact_1528_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divide_less_eq
tff(fact_1529_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_less_minus_divide_eq
tff(fact_1530_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_minus_divide_less_eq
tff(fact_1531_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),divide_divide(A,Xa,Z))),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)),Z) ) ) ) ).

% minus_divide_add_eq_iff
tff(fact_1532_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),divide_divide(A,A2,Z))),B2)
          = $ite(Z = zero_zero(A),B2,divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z)),Z)) ) ) ).

% add_divide_eq_if_simps(3)
tff(fact_1533_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( ( Z != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),divide_divide(A,Xa,Z))),Y) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),Z)),Z) ) ) ) ).

% minus_divide_diff_eq_iff
tff(fact_1534_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A2,Z)),B2)
          = $ite(Z = zero_zero(A),aa(A,A,uminus_uminus(A),B2),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z)),Z)) ) ) ).

% add_divide_eq_if_simps(5)
tff(fact_1535_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,Z: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),divide_divide(A,A2,Z))),B2)
          = $ite(Z = zero_zero(A),aa(A,A,uminus_uminus(A),B2),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),Z)),Z)) ) ) ).

% add_divide_eq_if_simps(6)
tff(fact_1536_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: A,M: int] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),aa(int,A,ring_1_of_int(A),archimedean_round(A,Z))))),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),aa(int,A,ring_1_of_int(A),M)))) ) ).

% round_diff_minimal
tff(fact_1537_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ).

% nat_abs_triangle_ineq
tff(fact_1538_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( divide_divide(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% div_abs_eq_div_nat
tff(fact_1539_int__cases3,axiom,
    ! [K: int] :
      ( ( K != zero_zero(int) )
     => ( ! [N2: nat] :
            ( ( K = aa(nat,int,semiring_1_of_nat(int),N2) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2) )
       => ~ ! [N2: nat] :
              ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) )
             => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2) ) ) ) ).

% int_cases3
tff(fact_1540_not__zle__0__negative,axiom,
    ! [N: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N)))) ).

% not_zle_0_negative
tff(fact_1541_negative__zless__0,axiom,
    ! [N: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N)))),zero_zero(int)) ).

% negative_zless_0
tff(fact_1542_negD,axiom,
    ! [Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Xa),zero_zero(int))
     => ? [N2: nat] : ( Xa = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,suc,N2))) ) ) ).

% negD
tff(fact_1543_verit__less__mono__div__int2,axiom,
    ! [A3: int,B3: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A3),B3)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,uminus_uminus(int),N))
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),divide_divide(int,B3,N)),divide_divide(int,A3,N)) ) ) ).

% verit_less_mono_div_int2
tff(fact_1544_div__eq__minus1,axiom,
    ! [B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( divide_divide(int,aa(int,int,uminus_uminus(int),one_one(int)),B2) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ).

% div_eq_minus1
tff(fact_1545_floor__split,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [P: fun(int,$o),T2: A] :
          ( aa(int,$o,P,archim6421214686448440834_floor(A,T2))
        <=> ! [I3: int] :
              ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),I3)),T2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less(A),T2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),I3)),one_one(A))) )
             => aa(int,$o,P,I3) ) ) ) ).

% floor_split
tff(fact_1546_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,A2: int] :
          ( ( archim6421214686448440834_floor(A,Xa) = A2 )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A2)),Xa)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),A2)),one_one(A))) ) ) ) ).

% floor_eq_iff
tff(fact_1547_floor__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A)))
           => ( archim6421214686448440834_floor(A,Xa) = Z ) ) ) ) ).

% floor_unique
tff(fact_1548_le__mult__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A2)),archim6421214686448440834_floor(A,B2))),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))) ) ) ) ).

% le_mult_floor
tff(fact_1549_less__floor__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))),Xa) ) ) ).

% less_floor_iff
tff(fact_1550_floor__le__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Z: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),Z)),one_one(A))) ) ) ).

% floor_le_iff
tff(fact_1551_floor__correct,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,Xa))),Xa)
          & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),one_one(int)))) ) ) ).

% floor_correct
tff(fact_1552_real__root__pos__pos,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,root(N),Xa)) ) ) ).

% real_root_pos_pos
tff(fact_1553_real__root__strict__increasing,axiom,
    ! [N: nat,N6: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),N6)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,root(N),Xa)),aa(real,real,root(N6),Xa)) ) ) ) ) ).

% real_root_strict_increasing
tff(fact_1554_real__root__decreasing,axiom,
    ! [N: nat,N6: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N6)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N6),Xa)),aa(real,real,root(N),Xa)) ) ) ) ).

% real_root_decreasing
tff(fact_1555_real__root__pow__pos,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),N) = Xa ) ) ) ).

% real_root_pow_pos
tff(fact_1556_real__root__pos__unique,axiom,
    ! [N: nat,Y: real,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( ( aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),N) = Xa )
         => ( aa(real,real,root(N),Xa) = Y ) ) ) ) ).

% real_root_pos_unique
tff(fact_1557_real__root__power__cancel,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
       => ( aa(real,real,root(N),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N)) = Xa ) ) ) ).

% real_root_power_cancel
tff(fact_1558_floor__eq4,axiom,
    ! [N: nat,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),N)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N)))
       => ( aa(int,nat,nat2,archim6421214686448440834_floor(real,Xa)) = N ) ) ) ).

% floor_eq4
tff(fact_1559_floor__eq2,axiom,
    ! [N: int,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(int,real,ring_1_of_int(real),N)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(int,real,ring_1_of_int(real),N)),one_one(real)))
       => ( archim6421214686448440834_floor(real,Xa) = N ) ) ) ).

% floor_eq2
tff(fact_1560_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A))) ) ) ) ).

% le_minus_divide_eq
tff(fact_1561_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A2)
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)) ) ) ) ).

% minus_divide_le_eq
tff(fact_1562_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% neg_le_minus_divide_eq
tff(fact_1563_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divide_le_eq
tff(fact_1564_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_le_minus_divide_eq
tff(fact_1565_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),divide_divide(A,B2,C2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ) ).

% pos_minus_divide_le_eq
tff(fact_1566_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),B2)
     => ( archim6421214686448440834_floor(real,divide_divide(real,A2,aa(int,real,ring_1_of_int(real),B2))) = divide_divide(int,archim6421214686448440834_floor(real,A2),B2) ) ) ).

% floor_divide_real_eq_div
tff(fact_1567_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(int,nat,nat2,aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),A2)),aa(nat,int,semiring_1_of_nat(int),B2))))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),B2),A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2)) ) ).

% nat_abs_int_diff
tff(fact_1568_neg__int__cases,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => ~ ! [N2: nat] :
            ( ( K = aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),N2)) )
           => ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2) ) ) ).

% neg_int_cases
tff(fact_1569_powr__neg__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(real,real,uminus_uminus(real),one_one(real))) = divide_divide(real,one_one(real),Xa) ) ) ).

% powr_neg_one
tff(fact_1570_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z5: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),zero_zero(int))
     => ( aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),Z),Z5)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z))),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),Z5))) ) ) ).

% nat_mult_distrib_neg
tff(fact_1571_ln__add__one__self__le__self2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa))),Xa) ) ).

% ln_add_one_self_le_self2
tff(fact_1572_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,divide_divide(A,P2,Q2)))),Q2)),P2) ) ) ).

% floor_divide_lower
tff(fact_1573_real__root__increasing,axiom,
    ! [N: nat,N6: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),N6)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,root(N),Xa)),aa(real,real,root(N6),Xa)) ) ) ) ) ).

% real_root_increasing
tff(fact_1574_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F3: fun(nat,int),K: int] :
      ( ! [I2: nat] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),I2)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),N) )
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F3,aa(nat,nat,suc,I2))),aa(nat,int,F3,I2)))),one_one(int)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F3,M)),K)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F3,N))
           => ? [I2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),I2)
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),N)
                & ( aa(nat,int,F3,I2) = K ) ) ) ) ) ) ).

% nat_intermed_int_val
tff(fact_1575_decr__lemma,axiom,
    ! [D2: int,Xa: int,Z: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa),Z))),one_one(int))),D2))),Z) ) ).

% decr_lemma
tff(fact_1576_incr__lemma,axiom,
    ! [D2: int,Z: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa),Z))),one_one(int))),D2))) ) ).

% incr_lemma
tff(fact_1577_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Q2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Q2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,divide_divide(A,P2,Q2)))),one_one(A))),Q2)) ) ) ).

% floor_divide_upper
tff(fact_1578_ln__one__minus__pos__upper__bound,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),Xa))),aa(real,real,uminus_uminus(real),Xa)) ) ) ).

% ln_one_minus_pos_upper_bound
tff(fact_1579_Bernoulli__inequality,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),Xa))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa)),N)) ) ).

% Bernoulli_inequality
tff(fact_1580_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int))
       => ( divide_divide(int,K,L) = aa(int,int,uminus_uminus(int),one_one(int)) ) ) ) ).

% div_pos_neg_trivial
tff(fact_1581_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
       => ( aa(real,real,ln_ln(real),aa(real,real,root(N),B2)) = divide_divide(real,aa(real,real,ln_ln(real),B2),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ) ).

% ln_root
tff(fact_1582_log__root,axiom,
    ! [N: nat,A2: real,B2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ( aa(real,real,log(B2),aa(real,real,root(N),A2)) = divide_divide(real,aa(real,real,log(B2),A2),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ) ).

% log_root
tff(fact_1583_log__base__root,axiom,
    ! [N: nat,B2: real,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
       => ( aa(real,real,log(aa(real,real,root(N),B2)),Xa) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(B2),Xa)) ) ) ) ).

% log_base_root
tff(fact_1584_nat__ivt__aux,axiom,
    ! [N: nat,F3: fun(nat,int),K: int] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),N)
         => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,F3,aa(nat,nat,suc,I2))),aa(nat,int,F3,I2)))),one_one(int)) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,F3,zero_zero(nat))),K)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,F3,N))
         => ? [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),N)
              & ( aa(nat,int,F3,I2) = K ) ) ) ) ) ).

% nat_ivt_aux
tff(fact_1585_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,F3: fun(A,nat),B2: nat] :
      ( aa(A,$o,P,K)
     => ( ! [Y3: A] :
            ( aa(A,$o,P,Y3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,F3,Y3)),B2) )
       => ? [X: A] :
            ( aa(A,$o,P,X)
            & ! [Y4: A] :
                ( aa(A,$o,P,Y4)
               => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F3,Y4)),aa(A,nat,F3,X)) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
tff(fact_1586_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
tff(fact_1587_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),Xa)),aa(A,A,uminus_uminus(A),Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ).

% compl_le_compl_iff
tff(fact_1588_powr__real__of__int,axiom,
    ! [Xa: real,N: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(int,real,ring_1_of_int(real),N))
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(int,nat,nat2,N)),aa(real,real,inverse_inverse(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),N))))) ) ) ).

% powr_real_of_int
tff(fact_1589_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(nat,real,semiring_1_of_nat(real),N))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),divide_divide(real,Xa,aa(nat,real,semiring_1_of_nat(real),N)))),N)),aa(real,real,exp(real),aa(real,real,uminus_uminus(real),Xa))) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
tff(fact_1590_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),N))),Xa)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),divide_divide(real,Xa,aa(nat,real,semiring_1_of_nat(real),N)))),N)),aa(real,real,exp(real),Xa)) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
tff(fact_1591_floor__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] :
          ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,Xa)),archimedean_frac(A,Y))),one_one(A)),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),archim6421214686448440834_floor(A,Y)),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),archim6421214686448440834_floor(A,Y))),one_one(int))) ) ) ).

% floor_add
tff(fact_1592_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K)) ) ) ).

% pochhammer_minus'
tff(fact_1593_abs__exp__cancel,axiom,
    ! [Xa: real] : ( aa(real,real,abs_abs(real),aa(real,real,exp(real),Xa)) = aa(real,real,exp(real),Xa) ) ).

% abs_exp_cancel
tff(fact_1594_exp__inj__iff,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,exp(real),Xa) = aa(real,real,exp(real),Y) )
    <=> ( Xa = Y ) ) ).

% exp_inj_iff
tff(fact_1595_frac__frac,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_frac(A,archimedean_frac(A,Xa)) = archimedean_frac(A,Xa) ) ) ).

% frac_frac
tff(fact_1596_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% inverse_nonzero_iff_nonzero
tff(fact_1597_inverse__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% inverse_zero
tff(fact_1598_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% inverse_mult_distrib
tff(fact_1599_inverse__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),one_one(A)) = one_one(A) ) ) ).

% inverse_1
tff(fact_1600_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A] :
          ( ( aa(A,A,inverse_inverse(A),Xa) = one_one(A) )
        <=> ( Xa = one_one(A) ) ) ) ).

% inverse_eq_1_iff
tff(fact_1601_exp__less__cancel__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),Xa)),aa(real,real,exp(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ).

% exp_less_cancel_iff
tff(fact_1602_exp__less__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),Xa)),aa(real,real,exp(real),Y)) ) ).

% exp_less_mono
tff(fact_1603_exp__le__cancel__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Xa)),aa(real,real,exp(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ).

% exp_le_cancel_iff
tff(fact_1604_pochhammer__1,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,one_one(nat)) = A2 ) ) ).

% pochhammer_1
tff(fact_1605_ln__exp,axiom,
    ! [Xa: real] : ( aa(real,real,ln_ln(real),aa(real,real,exp(real),Xa)) = Xa ) ).

% ln_exp
tff(fact_1606_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) ) ) ).

% inverse_nonpositive_iff_nonpositive
tff(fact_1607_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% inverse_nonnegative_iff_nonnegative
tff(fact_1608_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% inverse_less_iff_less
tff(fact_1609_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ) ).

% inverse_less_iff_less_neg
tff(fact_1610_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% inverse_negative_iff_negative
tff(fact_1611_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% inverse_positive_iff_positive
tff(fact_1612_exp__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,exp(A),zero_zero(A)) = one_one(A) ) ) ).

% exp_zero
tff(fact_1613_artanh__minus__real,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,real,artanh(real),aa(real,real,uminus_uminus(real),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,artanh(real),Xa)) ) ) ).

% artanh_minus_real
tff(fact_1614_pochhammer__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,zero_zero(nat)) = one_one(A) ) ) ).

% pochhammer_0
tff(fact_1615_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% pochhammer_Suc0
tff(fact_1616_exp__eq__one__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,exp(real),Xa) = one_one(real) )
    <=> ( Xa = zero_zero(real) ) ) ).

% exp_eq_one_iff
tff(fact_1617_frac__of__int,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Z: int] : ( archimedean_frac(A,aa(int,A,ring_1_of_int(A),Z)) = zero_zero(A) ) ) ).

% frac_of_int
tff(fact_1618_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% inverse_le_iff_le_neg
tff(fact_1619_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% inverse_le_iff_le
tff(fact_1620_right__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),A2)) = one_one(A) ) ) ) ).

% right_inverse
tff(fact_1621_left__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),A2) = one_one(A) ) ) ) ).

% left_inverse
tff(fact_1622_exp__less__one__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),Xa)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real)) ) ).

% exp_less_one_iff
tff(fact_1623_one__less__exp__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,exp(real),Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa) ) ).

% one_less_exp_iff
tff(fact_1624_one__le__exp__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,exp(real),Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa) ) ).

% one_le_exp_iff
tff(fact_1625_exp__le__one__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Xa)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real)) ) ).

% exp_le_one_iff
tff(fact_1626_exp__ln,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,exp(real),aa(real,real,ln_ln(real),Xa)) = Xa ) ) ).

% exp_ln
tff(fact_1627_exp__ln__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,exp(real),aa(real,real,ln_ln(real),Xa)) = Xa )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa) ) ).

% exp_ln_iff
tff(fact_1628_exp__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,inverse_inverse(A),aa(A,A,exp(A),Xa)) ) ) ).

% exp_minus
tff(fact_1629_pochhammer__of__nat,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Xa: nat,N: nat] : ( comm_s3205402744901411588hammer(A,aa(nat,A,semiring_1_of_nat(A),Xa),N) = aa(nat,A,semiring_1_of_nat(A),comm_s3205402744901411588hammer(nat,Xa,N)) ) ) ).

% pochhammer_of_nat
tff(fact_1630_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A2) != zero_zero(A) ) ) ) ).

% nonzero_imp_inverse_nonzero
tff(fact_1631_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,inverse_inverse(A),A2)) = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
tff(fact_1632_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = aa(A,A,inverse_inverse(A),B2) )
         => ( ( A2 != zero_zero(A) )
           => ( ( B2 != zero_zero(A) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
tff(fact_1633_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( aa(A,A,inverse_inverse(A),A2) = zero_zero(A) )
         => ( A2 = zero_zero(A) ) ) ) ).

% inverse_zero_imp_zero
tff(fact_1634_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( field(A)
     => ( aa(A,A,inverse_inverse(A),zero_zero(A)) = zero_zero(A) ) ) ).

% field_class.field_inverse_zero
tff(fact_1635_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Y: A,Xa: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Y),Xa) = aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Y)),Xa) = aa(A,A,aa(A,fun(A,A),times_times(A),Xa),aa(A,A,inverse_inverse(A),Y)) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
tff(fact_1636_exp__less__cancel,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),Xa)),aa(real,real,exp(real),Y))
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ).

% exp_less_cancel
tff(fact_1637_power__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),A2)),N) = aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% power_inverse
tff(fact_1638_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,exp(A),Xa) != zero_zero(A) ) ) ).

% exp_not_eq_zero
tff(fact_1639_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [A3: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),A3)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),A3),aa(A,A,exp(A),A3)) ) ) ).

% exp_times_arg_commute
tff(fact_1640_ln__unique,axiom,
    ! [Y: real,Xa: real] :
      ( ( aa(real,real,exp(real),Y) = Xa )
     => ( aa(real,real,ln_ln(real),Xa) = Y ) ) ).

% ln_unique
tff(fact_1641_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% inverse_less_imp_less
tff(fact_1642_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% less_imp_inverse_less
tff(fact_1643_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ) ).

% inverse_less_imp_less_neg
tff(fact_1644_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% less_imp_inverse_less_neg
tff(fact_1645_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A))
         => ( ( A2 != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% inverse_negative_imp_negative
tff(fact_1646_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2))
         => ( ( A2 != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ).

% inverse_positive_imp_positive
tff(fact_1647_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),zero_zero(A)) ) ) ).

% negative_imp_inverse_negative
tff(fact_1648_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ).

% positive_imp_inverse_positive
tff(fact_1649_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ) ).

% nonzero_inverse_mult_distrib
tff(fact_1650_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% nonzero_inverse_minus_eq
tff(fact_1651_inverse__unique,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = one_one(A) )
         => ( aa(A,A,inverse_inverse(A),A2) = B2 ) ) ) ).

% inverse_unique
tff(fact_1652_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( divide_divide(A,A2,B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% field_class.field_divide_inverse
tff(fact_1653_divide__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] : ( divide_divide(A,A2,B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,inverse_inverse(A),B2)) ) ) ).

% divide_inverse
tff(fact_1654_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] : ( divide_divide(A,A2,B2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),B2)),A2) ) ) ).

% divide_inverse_commute
tff(fact_1655_exp__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
     => ? [X: real] : ( aa(real,real,exp(real),X) = Y ) ) ).

% exp_total
tff(fact_1656_exp__gt__zero,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,exp(real),Xa)) ).

% exp_gt_zero
tff(fact_1657_not__exp__less__zero,axiom,
    ! [Xa: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,exp(real),Xa)),zero_zero(real)) ).

% not_exp_less_zero
tff(fact_1658_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] : ( aa(A,A,inverse_inverse(A),A2) = divide_divide(A,one_one(A),A2) ) ) ).

% inverse_eq_divide
tff(fact_1659_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),Xa)),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),Xa)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)) ) ) ).

% power_mult_power_inverse_commute
tff(fact_1660_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(A,A,inverse_inverse(A),Xa)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)) ) ) ).

% power_mult_inverse_distrib
tff(fact_1661_not__exp__le__zero,axiom,
    ! [Xa: real] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Xa)),zero_zero(real)) ).

% not_exp_le_zero
tff(fact_1662_exp__ge__zero,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,exp(real),Xa)) ).

% exp_ge_zero
tff(fact_1663_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: nat,Xb: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))),Xb) = aa(A,A,aa(A,fun(A,A),times_times(A),Xb),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Xa))) ) ) ).

% mult_inverse_of_nat_commute
tff(fact_1664_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,inverse_inverse(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,abs_abs(A),A2)) ) ) ) ).

% nonzero_abs_inverse
tff(fact_1665_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: int,Xb: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))),Xb) = aa(A,A,aa(A,fun(A,A),times_times(A),Xb),aa(A,A,inverse_inverse(A),aa(int,A,ring_1_of_int(A),Xa))) ) ) ).

% mult_inverse_of_int_commute
tff(fact_1666_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),Xa)),aa(A,A,exp(A),Y)) = aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) ) ) ).

% mult_exp_exp
tff(fact_1667_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),Xa) )
         => ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),Xa)),aa(A,A,exp(A),Y)) ) ) ) ).

% exp_add_commuting
tff(fact_1668_powr__minus,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [Xa: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),powr(A),Xa),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,inverse_inverse(A),aa(A,A,aa(A,fun(A,A),powr(A),Xa),A2)) ) ) ).

% powr_minus
tff(fact_1669_exp__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = divide_divide(A,aa(A,A,exp(A),Xa),aa(A,A,exp(A),Y)) ) ) ).

% exp_diff
tff(fact_1670_divide__real__def,axiom,
    ! [Xa: real,Y: real] : ( divide_divide(real,Xa,Y) = aa(real,real,aa(real,fun(real,real),times_times(real),Xa),aa(real,real,inverse_inverse(real),Y)) ) ).

% divide_real_def
tff(fact_1671_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),comm_s3205402744901411588hammer(A,Xa,N)) ) ) ).

% pochhammer_pos
tff(fact_1672_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,M: nat,N: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,M) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
           => ( comm_s3205402744901411588hammer(A,A2,N) != zero_zero(A) ) ) ) ) ).

% pochhammer_neq_0_mono
tff(fact_1673_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,N) = zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
           => ( comm_s3205402744901411588hammer(A,A2,M) = zero_zero(A) ) ) ) ) ).

% pochhammer_eq_0_mono
tff(fact_1674_frac__ge__0,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),archimedean_frac(A,Xa)) ) ).

% frac_ge_0
tff(fact_1675_frac__lt__1,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),archimedean_frac(A,Xa)),one_one(A)) ) ).

% frac_lt_1
tff(fact_1676_frac__1__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),one_one(A))) = archimedean_frac(A,Xa) ) ) ).

% frac_1_eq
tff(fact_1677_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% le_imp_inverse_le_neg
tff(fact_1678_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% inverse_le_imp_le_neg
tff(fact_1679_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),B2)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% le_imp_inverse_le
tff(fact_1680_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% inverse_le_imp_le
tff(fact_1681_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),Xa)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),Xa) ) ) ) ).

% inverse_le_1_iff
tff(fact_1682_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),Xa))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),one_one(A)) ) ) ) ).

% one_less_inverse_iff
tff(fact_1683_one__less__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% one_less_inverse
tff(fact_1684_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),A2) = one_one(A) ) ) ) ).

% field_class.field_inverse
tff(fact_1685_inverse__add,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,inverse_inverse(A),A2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% inverse_add
tff(fact_1686_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_add
tff(fact_1687_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2))),aa(A,A,inverse_inverse(A),B2)) ) ) ) ) ).

% division_ring_inverse_diff
tff(fact_1688_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,inverse_inverse(A),A2) = divide_divide(A,one_one(A),A2) ) ) ) ).

% nonzero_inverse_eq_divide
tff(fact_1689_exp__gt__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,exp(real),Xa)) ) ).

% exp_gt_one
tff(fact_1690_exp__ge__add__one__self,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa)),aa(real,real,exp(real),Xa)) ).

% exp_ge_add_one_self
tff(fact_1691_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),Xa)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa))) = one_one(A) ) ) ).

% exp_minus_inverse
tff(fact_1692_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,N: nat] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),aa(nat,A,semiring_1_of_nat(A),N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),Xa)),N) ) ) ).

% exp_of_nat2_mult
tff(fact_1693_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [N: nat,Xa: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),Xa)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),Xa)),N) ) ) ).

% exp_of_nat_mult
tff(fact_1694_abs__real__def,axiom,
    ! [A2: real] :
      ( aa(real,real,abs_abs(real),A2)
      = $ite(aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real)),aa(real,real,uminus_uminus(real),A2),A2) ) ).

% abs_real_def
tff(fact_1695_inverse__powr,axiom,
    ! [Y: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,inverse_inverse(real),Y)),A2) = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),powr(real),Y),A2)) ) ) ).

% inverse_powr
tff(fact_1696_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),comm_s3205402744901411588hammer(A,Xa,N)) ) ) ).

% pochhammer_nonneg
tff(fact_1697_log__ln,axiom,
    ! [Xa: real] : ( aa(real,real,ln_ln(real),Xa) = aa(real,real,log(aa(real,real,exp(real),one_one(real))),Xa) ) ).

% log_ln
tff(fact_1698_real__root__abs,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,real,root(N),aa(real,real,abs_abs(real),Xa)) = aa(real,real,abs_abs(real),aa(real,real,root(N),Xa)) ) ) ).

% real_root_abs
tff(fact_1699_sin__bound__lemma,axiom,
    ! [Xa: real,Y: real,U: real,V: real] :
      ( ( Xa = Y )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),U)),V)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),U)),Y))),V) ) ) ).

% sin_bound_lemma
tff(fact_1700_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] :
          ( comm_s3205402744901411588hammer(A,zero_zero(A),N)
          = $ite(N = zero_zero(nat),one_one(A),zero_zero(A)) ) ) ).

% pochhammer_0_left
tff(fact_1701_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ).

% inverse_le_iff
tff(fact_1702_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2))
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) )
            & ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),zero_zero(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ) ) ).

% inverse_less_iff
tff(fact_1703_one__le__inverse,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),A2)) ) ) ) ).

% one_le_inverse
tff(fact_1704_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),Xa)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
            | aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Xa) ) ) ) ).

% inverse_less_1_iff
tff(fact_1705_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,inverse_inverse(A),Xa))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),one_one(A)) ) ) ) ).

% one_le_inverse_iff
tff(fact_1706_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,inverse_inverse(A),B2)) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),A2)),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(A,A,inverse_inverse(A),B2))) ) ) ) ) ).

% inverse_diff_inverse
tff(fact_1707_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => ? [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N2)))),Xa) ) ) ).

% reals_Archimedean
tff(fact_1708_exp__ge__add__one__self__aux,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa)),aa(real,real,exp(real),Xa)) ) ).

% exp_ge_add_one_self_aux
tff(fact_1709_lemma__exp__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y)
     => ? [X: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),one_one(real)))
          & ( aa(real,real,exp(real),X) = Y ) ) ) ).

% lemma_exp_total
tff(fact_1710_ln__ge__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,ln_ln(real),Xa))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Y)),Xa) ) ) ).

% ln_ge_iff
tff(fact_1711_ln__x__over__x__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),divide_divide(real,aa(real,real,ln_ln(real),Y),Y)),divide_divide(real,aa(real,real,ln_ln(real),Xa),Xa)) ) ) ).

% ln_x_over_x_mono
tff(fact_1712_forall__pos__mono__1,axiom,
    ! [P: fun(real,$o),E: real] :
      ( ! [D6: real,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),D6),E2)
         => ( aa(real,$o,P,D6)
           => aa(real,$o,P,E2) ) )
     => ( ! [N2: nat] : aa(real,$o,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
         => aa(real,$o,P,E) ) ) ) ).

% forall_pos_mono_1
tff(fact_1713_real__arch__inverse,axiom,
    ! [E: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
    <=> ? [N5: nat] :
          ( ( N5 != zero_zero(nat) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N5)))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N5))),E) ) ) ).

% real_arch_inverse
tff(fact_1714_forall__pos__mono,axiom,
    ! [P: fun(real,$o),E: real] :
      ( ! [D6: real,E2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),D6),E2)
         => ( aa(real,$o,P,D6)
           => aa(real,$o,P,E2) ) )
     => ( ! [N2: nat] :
            ( ( N2 != zero_zero(nat) )
           => aa(real,$o,P,aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),N2))) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
         => aa(real,$o,P,E) ) ) ) ).

% forall_pos_mono
tff(fact_1715_ln__inverse,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,ln_ln(real),aa(real,real,inverse_inverse(real),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,ln_ln(real),Xa)) ) ) ).

% ln_inverse
tff(fact_1716_root__abs__power,axiom,
    ! [N: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,real,abs_abs(real),aa(real,real,root(N),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),N))) = aa(real,real,abs_abs(real),Y) ) ) ).

% root_abs_power
tff(fact_1717_frac__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_frac(A,Xa) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(int,A,ring_1_of_int(A),archim6421214686448440834_floor(A,Xa))) ) ) ).

% frac_def
tff(fact_1718_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),N)) ) ) ).

% pochhammer_rec
tff(fact_1719_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,A2,N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),N))) ) ) ).

% pochhammer_Suc
tff(fact_1720_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,N: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),N))),comm_s3205402744901411588hammer(A,Z,N)) ) ) ).

% pochhammer_rec'
tff(fact_1721_powr__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Xa: A,A2: A] :
          ( aa(A,A,aa(A,fun(A,A),powr(A),Xa),A2)
          = $ite(Xa = zero_zero(A),zero_zero(A),aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,ln_ln(A),Xa)))) ) ) ).

% powr_def
tff(fact_1722_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer(A,A2,N) = zero_zero(A) )
        <=> ? [K2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K2),N)
              & ( A2 = aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K2)) ) ) ) ) ).

% pochhammer_eq_0_iff
tff(fact_1723_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [N: nat,K: nat] :
          ( ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),K) = zero_zero(A) )
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),K) ) ) ).

% pochhammer_of_nat_eq_0_iff
tff(fact_1724_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,K: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),K)
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),K) = zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
tff(fact_1725_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ring_char_0(A)
        & idom(A) )
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),K) != zero_zero(A) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
tff(fact_1726_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Z: A,N: nat,M: nat] : ( comm_s3205402744901411588hammer(A,Z,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,N)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),N)),M)) ) ) ).

% pochhammer_product'
tff(fact_1727_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( archim462609752435547400_field(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => ? [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),N2))),Xa) ) ) ) ).

% ex_inverse_of_nat_less
tff(fact_1728_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: nat,N: nat] :
          ( ( Xa != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
           => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),Xa)),M)) ) ) ) ) ).

% power_diff_conv_inverse
tff(fact_1729_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [N: nat,Xa: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),divide_divide(A,Xa,aa(nat,A,semiring_1_of_nat(A),N)))),N) = aa(A,A,exp(A),Xa) ) ) ) ).

% exp_divide_power_eq
tff(fact_1730_log__inverse,axiom,
    ! [A2: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
     => ( ( A2 != one_one(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( aa(real,real,log(A2),aa(real,real,inverse_inverse(real),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,log(A2),Xa)) ) ) ) ) ).

% log_inverse
tff(fact_1731_frac__eq,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( ( archimedean_frac(A,Xa) = Xa )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),one_one(A)) ) ) ) ).

% frac_eq
tff(fact_1732_frac__add,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] :
          ( archimedean_frac(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,Xa)),archimedean_frac(A,Y))),one_one(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,Xa)),archimedean_frac(A,Y)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),archimedean_frac(A,Xa)),archimedean_frac(A,Y))),one_one(A))) ) ) ).

% frac_add
tff(fact_1733_pochhammer__product,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M: nat,N: nat,Z: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( comm_s3205402744901411588hammer(A,Z,N) = aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,M)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ).

% pochhammer_product
tff(fact_1734_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [R: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),R),aa(nat,A,semiring_1_of_nat(A),K))),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),R),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),R),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),R)),one_one(A)),K)) ) ) ).

% pochhammer_absorb_comp
tff(fact_1735_compl__mono,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y)),aa(A,A,uminus_uminus(A),Xa)) ) ) ).

% compl_mono
tff(fact_1736_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(A,A,uminus_uminus(A),Xa))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% compl_le_swap1
tff(fact_1737_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),Y)),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),Xa)),Y) ) ) ).

% compl_le_swap2
tff(fact_1738_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [B2: A,K: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),B2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K)) ) ) ).

% pochhammer_minus
tff(fact_1739_lemma__interval,axiom,
    ! [A2: real,Xa: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),B2)
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [Y4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y4))),D6)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Y4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),B2) ) ) ) ) ) ).

% lemma_interval
tff(fact_1740_lemma__interval__lt,axiom,
    ! [A2: real,Xa: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),B2)
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [Y4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y4))),D6)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Y4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),B2) ) ) ) ) ) ).

% lemma_interval_lt
tff(fact_1741_arctan__add,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,arctan,Xa)),aa(real,real,arctan,Y)) = aa(real,real,arctan,divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)))) ) ) ) ).

% arctan_add
tff(fact_1742_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,tanh(A),Xa) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Xa)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),Xa)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa)))) ) ) ).

% tanh_altdef
tff(fact_1743_complete__interval,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [A2: A,B2: A,P: fun(A,$o)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,P,A2)
           => ( ~ aa(A,$o,P,B2)
             => ? [C4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C4)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C4),B2)
                  & ! [X3: A] :
                      ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X3)
                        & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),C4) )
                     => aa(A,$o,P,X3) )
                  & ! [D5: A] :
                      ( ! [X: A] :
                          ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X)
                            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),D5) )
                         => aa(A,$o,P,X) )
                     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D5),C4) ) ) ) ) ) ) ).

% complete_interval
tff(fact_1744_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ) ).

% gbinomial_absorption'
tff(fact_1745_mult__ceiling__le__Ints,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & linordered_idom(B) )
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( member(A,A2,ring_1_Ints(A))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))),aa(int,B,ring_1_of_int(B),aa(int,int,aa(int,fun(int,int),times_times(int),archimedean_ceiling(A,A2)),archimedean_ceiling(A,B2)))) ) ) ) ).

% mult_ceiling_le_Ints
tff(fact_1746_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,A2: A] :
          ( ( archimedean_frac(A,Xa) = A2 )
        <=> ( member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),A2),ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A)) ) ) ) ).

% frac_unique_iff
tff(fact_1747_tanh__real__zero__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,tanh(real),Xa) = zero_zero(real) )
    <=> ( Xa = zero_zero(real) ) ) ).

% tanh_real_zero_iff
tff(fact_1748_tanh__real__less__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),Xa)),aa(real,real,tanh(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ).

% tanh_real_less_iff
tff(fact_1749_tanh__real__le__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tanh(real),Xa)),aa(real,real,tanh(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ).

% tanh_real_le_iff
tff(fact_1750_tanh__real__abs,axiom,
    ! [Xa: real] : ( aa(real,real,tanh(real),aa(real,real,abs_abs(real),Xa)) = aa(real,real,abs_abs(real),aa(real,real,tanh(real),Xa)) ) ).

% tanh_real_abs
tff(fact_1751_tanh__real__pos__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,tanh(real),Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa) ) ).

% tanh_real_pos_iff
tff(fact_1752_tanh__real__neg__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real)) ) ).

% tanh_real_neg_iff
tff(fact_1753_tanh__real__nonneg__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,tanh(real),Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa) ) ).

% tanh_real_nonneg_iff
tff(fact_1754_tanh__real__nonpos__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tanh(real),Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real)) ) ).

% tanh_real_nonpos_iff
tff(fact_1755_tanh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tanh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tanh_0
tff(fact_1756_arctan__zero__zero,axiom,
    aa(real,real,arctan,zero_zero(real)) = zero_zero(real) ).

% arctan_zero_zero
tff(fact_1757_arctan__eq__zero__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,arctan,Xa) = zero_zero(real) )
    <=> ( Xa = zero_zero(real) ) ) ).

% arctan_eq_zero_iff
tff(fact_1758_tanh__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,tanh(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,uminus_uminus(A),aa(A,A,tanh(A),Xa)) ) ) ).

% tanh_minus
tff(fact_1759_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),one_one(nat)) = A2 ) ) ).

% gbinomial_1
tff(fact_1760_frac__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( member(A,archimedean_frac(A,Xa),ring_1_Ints(A))
        <=> member(A,Xa,ring_1_Ints(A)) ) ) ).

% frac_in_Ints_iff
tff(fact_1761_gbinomial__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [K: nat] : ( aa(nat,A,gbinomial(A,zero_zero(A)),aa(nat,nat,suc,K)) = zero_zero(A) ) ) ).

% gbinomial_0(2)
tff(fact_1762_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),zero_zero(nat)) = one_one(A) ) ) ).

% gbinomial_0(1)
tff(fact_1763_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,zero_zero(nat))) = A2 ) ) ).

% gbinomial_Suc0
tff(fact_1764_zero__less__arctan__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,arctan,Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa) ) ).

% zero_less_arctan_iff
tff(fact_1765_arctan__less__zero__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real)) ) ).

% arctan_less_zero_iff
tff(fact_1766_arctan__le__zero__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arctan,Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real)) ) ).

% arctan_le_zero_iff
tff(fact_1767_zero__le__arctan__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arctan,Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa) ) ).

% zero_le_arctan_iff
tff(fact_1768_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( ( archimedean_frac(A,Xa) = zero_zero(A) )
        <=> member(A,Xa,ring_1_Ints(A)) ) ) ).

% frac_eq_0_iff
tff(fact_1769_floor__add2,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: A] :
          ( ( member(A,Xa,ring_1_Ints(A))
            | member(A,Y,ring_1_Ints(A)) )
         => ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(A,Xa)),archim6421214686448440834_floor(A,Y)) ) ) ) ).

% floor_add2
tff(fact_1770_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),archimedean_frac(A,Xa))
        <=> ~ member(A,Xa,ring_1_Ints(A)) ) ) ).

% frac_gt_0_iff
tff(fact_1771_of__nat__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat,K: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,gbinomial(nat,N),K)) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),N)),K) ) ) ).

% of_nat_gbinomial
tff(fact_1772_arctan__eq__iff,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,arctan,Xa) = aa(real,real,arctan,Y) )
    <=> ( Xa = Y ) ) ).

% arctan_eq_iff
tff(fact_1773_artanh__tanh__real,axiom,
    ! [Xa: real] : ( aa(real,real,artanh(real),aa(real,real,tanh(real),Xa)) = Xa ) ).

% artanh_tanh_real
tff(fact_1774_Ints__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => member(A,zero_zero(A),ring_1_Ints(A)) ) ).

% Ints_0
tff(fact_1775_Ints__mult,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( member(A,B2,ring_1_Ints(A))
           => member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),ring_1_Ints(A)) ) ) ) ).

% Ints_mult
tff(fact_1776_Ints__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => member(A,one_one(A),ring_1_Ints(A)) ) ).

% Ints_1
tff(fact_1777_Ints__add,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( member(A,B2,ring_1_Ints(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),ring_1_Ints(A)) ) ) ) ).

% Ints_add
tff(fact_1778_Ints__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( member(A,B2,ring_1_Ints(A))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),ring_1_Ints(A)) ) ) ) ).

% Ints_diff
tff(fact_1779_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: A] :
          ( member(A,aa(A,A,uminus_uminus(A),Xa),ring_1_Ints(A))
        <=> member(A,Xa,ring_1_Ints(A)) ) ) ).

% minus_in_Ints_iff
tff(fact_1780_Ints__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => member(A,aa(A,A,uminus_uminus(A),A2),ring_1_Ints(A)) ) ) ).

% Ints_minus
tff(fact_1781_arctan__less__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Xa)),aa(real,real,arctan,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ).

% arctan_less_iff
tff(fact_1782_arctan__monotone,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Xa)),aa(real,real,arctan,Y)) ) ).

% arctan_monotone
tff(fact_1783_arctan__le__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arctan,Xa)),aa(real,real,arctan,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ).

% arctan_le_iff
tff(fact_1784_arctan__monotone_H,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arctan,Xa)),aa(real,real,arctan,Y)) ) ).

% arctan_monotone'
tff(fact_1785_Ints__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,N: nat] :
          ( member(A,A2,ring_1_Ints(A))
         => member(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N),ring_1_Ints(A)) ) ) ).

% Ints_power
tff(fact_1786_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : member(A,aa(nat,A,semiring_1_of_nat(A),N),ring_1_Ints(A)) ) ).

% Ints_of_nat
tff(fact_1787_Ints__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => member(A,aa(A,A,abs_abs(A),A2),ring_1_Ints(A)) ) ) ).

% Ints_abs
tff(fact_1788_arctan__minus,axiom,
    ! [Xa: real] : ( aa(real,real,arctan,aa(real,real,uminus_uminus(real),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,arctan,Xa)) ) ).

% arctan_minus
tff(fact_1789_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: int] : member(A,aa(int,A,ring_1_of_int(A),Z),ring_1_Ints(A)) ) ).

% Ints_of_int
tff(fact_1790_Ints__induct,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Q2: A,P: fun(A,$o)] :
          ( member(A,Q2,ring_1_Ints(A))
         => ( ! [Z4: int] : aa(A,$o,P,aa(int,A,ring_1_of_int(A),Z4))
           => aa(A,$o,P,Q2) ) ) ) ).

% Ints_induct
tff(fact_1791_Ints__cases,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Q2: A] :
          ( member(A,Q2,ring_1_Ints(A))
         => ~ ! [Z4: int] : ( Q2 != aa(int,A,ring_1_of_int(A),Z4) ) ) ) ).

% Ints_cases
tff(fact_1792_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,A2),K)),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc_Suc
tff(fact_1793_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),N)),K) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ) ).

% gbinomial_of_nat_symmetric
tff(fact_1794_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% Ints_double_eq_0_iff
tff(fact_1795_tanh__real__lt__1,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tanh(real),Xa)),one_one(real)) ).

% tanh_real_lt_1
tff(fact_1796_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_addition_formula
tff(fact_1797_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,A,gbinomial(A,A2),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_absorb_comp
tff(fact_1798_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),K)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),divide_divide(A,A2,aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% gbinomial_ge_n_over_k_pow_k
tff(fact_1799_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A2),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1'
tff(fact_1800_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,A2),K)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),K)),aa(nat,A,gbinomial(A,A2),K))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_mult_1
tff(fact_1801_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),A2) != zero_zero(A) ) ) ) ).

% Ints_odd_nonzero
tff(fact_1802_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% Suc_times_gbinomial
tff(fact_1803_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ).

% gbinomial_absorption
tff(fact_1804_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,M: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),M)),aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),M)),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K))) ) ) ) ).

% gbinomial_trinomial_revision
tff(fact_1805_tanh__real__gt__neg1,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(real,real,tanh(real),Xa)) ).

% tanh_real_gt_neg1
tff(fact_1806_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( member(A,A2,ring_1_Ints(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),A2)),zero_zero(A))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% Ints_odd_less_0
tff(fact_1807_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] :
          ( member(A,Xa,ring_1_Ints(A))
         => ( ( Xa != zero_zero(A) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,abs_abs(A),Xa)) ) ) ) ).

% Ints_nonzero_abs_ge1
tff(fact_1808_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] :
          ( member(A,Xa,ring_1_Ints(A))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),Xa)),one_one(A))
           => ( Xa = zero_zero(A) ) ) ) ) ).

% Ints_nonzero_abs_less1
tff(fact_1809_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( member(A,Xa,ring_1_Ints(A))
         => ( member(A,Y,ring_1_Ints(A))
           => ( ( Xa = Y )
            <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y))),one_one(A)) ) ) ) ) ).

% Ints_eq_abs_less1
tff(fact_1810_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))),aa(nat,A,gbinomial(A,A2),K)) ) ) ).

% gbinomial_factors
tff(fact_1811_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))),aa(nat,nat,suc,K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,K)))) ) ) ).

% gbinomial_rec
tff(fact_1812_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),N)) ) ) ).

% gbinomial_index_swap
tff(fact_1813_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),K)),A2)),one_one(A))),K)) ) ) ).

% gbinomial_negated_upper
tff(fact_1814_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),A2)),K) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A))),K)) ) ) ).

% gbinomial_minus
tff(fact_1815_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
         => ( aa(nat,A,gbinomial(A,A2),K) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),K)) ) ) ) ).

% gbinomial_reduce_nat
tff(fact_1816_frac__neg,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( archimedean_frac(A,aa(A,A,uminus_uminus(A),Xa))
          = $ite(member(A,Xa,ring_1_Ints(A)),zero_zero(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),archimedean_frac(A,Xa))) ) ) ).

% frac_neg
tff(fact_1817_le__mult__floor__Ints,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & linordered_idom(B) )
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( member(A,A2,ring_1_Ints(A))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(int,B,ring_1_of_int(B),aa(int,int,aa(int,fun(int,int),times_times(int),archim6421214686448440834_floor(A,A2)),archim6421214686448440834_floor(A,B2)))),aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)))) ) ) ) ).

% le_mult_floor_Ints
tff(fact_1818_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = divide_divide(A,comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(nat,A,semiring_1_of_nat(A),K))),one_one(A)),K),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer'
tff(fact_1819_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),K)),comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),A2),K)),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_pochhammer
tff(fact_1820_split__root,axiom,
    ! [P: fun(real,$o),N: nat,Xa: real] :
      ( aa(real,$o,P,aa(real,real,root(N),Xa))
    <=> ( ( ( N = zero_zero(nat) )
         => aa(real,$o,P,zero_zero(real)) )
        & ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ! [Y5: real] :
              ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y5)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),Y5)),N)) = Xa )
             => aa(real,$o,P,Y5) ) ) ) ) ).

% split_root
tff(fact_1821_tanh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,cosh(A),Xa) != zero_zero(A) )
         => ( ( aa(A,A,cosh(A),Y) != zero_zero(A) )
           => ( aa(A,A,tanh(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tanh(A),Xa)),aa(A,A,tanh(A),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tanh(A),Xa)),aa(A,A,tanh(A),Y)))) ) ) ) ) ).

% tanh_add
tff(fact_1822_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_ring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,uminus_uminus(A),aa(nat,A,semiring_1_of_nat(A),N)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),semiring_char_0_fact(A,N)) ) ) ).

% pochhammer_same
tff(fact_1823_split__neg__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,$o)),N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),P,divide_divide(int,N,K)),modulo_modulo(int,N,K))
      <=> ! [I3: int,J3: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J3)
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J3),zero_zero(int))
              & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I3)),J3) ) )
           => aa(int,$o,aa(int,fun(int,$o),P,I3),J3) ) ) ) ).

% split_neg_lemma
tff(fact_1824_split__pos__lemma,axiom,
    ! [K: int,P: fun(int,fun(int,$o)),N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),P,divide_divide(int,N,K)),modulo_modulo(int,N,K))
      <=> ! [I3: int,J3: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J3)
              & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J3),K)
              & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I3)),J3) ) )
           => aa(int,$o,aa(int,fun(int,$o),P,I3),J3) ) ) ) ).

% split_pos_lemma
tff(fact_1825_sgn__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,sgn_sgn(A),A2)) = aa(A,A,sgn_sgn(A),A2) ) ) ).

% sgn_sgn
tff(fact_1826_cosh__real__abs,axiom,
    ! [Xa: real] : ( aa(real,real,cosh(real),aa(real,real,abs_abs(real),Xa)) = aa(real,real,cosh(real),Xa) ) ).

% cosh_real_abs
tff(fact_1827_cosh__real__eq__iff,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,cosh(real),Xa) = aa(real,real,cosh(real),Y) )
    <=> ( aa(real,real,abs_abs(real),Xa) = aa(real,real,abs_abs(real),Y) ) ) ).

% cosh_real_eq_iff
tff(fact_1828_tanh__real__eq__iff,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,tanh(real),Xa) = aa(real,real,tanh(real),Y) )
    <=> ( Xa = Y ) ) ).

% tanh_real_eq_iff
tff(fact_1829_bits__mod__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( modulo_modulo(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% bits_mod_0
tff(fact_1830_mod__self,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,A2) = zero_zero(A) ) ) ).

% mod_self
tff(fact_1831_mod__by__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,zero_zero(A)) = A2 ) ) ).

% mod_by_0
tff(fact_1832_mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,zero_zero(A),A2) = zero_zero(A) ) ) ).

% mod_0
tff(fact_1833_mod__add__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_add_self1
tff(fact_1834_mod__add__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_add_self2
tff(fact_1835_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% minus_mod_self2
tff(fact_1836_sgn__0,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_0
tff(fact_1837_sgn__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_1
tff(fact_1838_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),A2)) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),A2)) ) ) ).

% idom_abs_sgn_class.sgn_minus
tff(fact_1839_power__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sgn_sgn(A),A2)),N) ) ) ).

% power_sgn
tff(fact_1840_of__nat__fact,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),semiring_char_0_fact(nat,N)) = semiring_char_0_fact(A,N) ) ) ).

% of_nat_fact
tff(fact_1841_cosh__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,cosh(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,cosh(A),Xa) ) ) ).

% cosh_minus
tff(fact_1842_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),B2) = zero_zero(A) ) ) ).

% mod_mult_self2_is_0
tff(fact_1843_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2),B2) = zero_zero(A) ) ) ).

% mod_mult_self1_is_0
tff(fact_1844_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,one_one(A)) = zero_zero(A) ) ) ).

% bits_mod_by_1
tff(fact_1845_mod__by__1,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,one_one(A)) = zero_zero(A) ) ) ).

% mod_by_1
tff(fact_1846_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A] : ( divide_divide(A,modulo_modulo(A,A2,B2),B2) = zero_zero(A) ) ) ).

% bits_mod_div_trivial
tff(fact_1847_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A] : ( divide_divide(A,modulo_modulo(A,A2,B2),B2) = zero_zero(A) ) ) ).

% mod_div_trivial
tff(fact_1848_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self1
tff(fact_1849_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self2
tff(fact_1850_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self3
tff(fact_1851_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [B2: A,C2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2),B2) = modulo_modulo(A,A2,B2) ) ) ).

% mod_mult_self4
tff(fact_1852_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [B2: A,A2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2),B2) = modulo_modulo(A,aa(A,A,uminus_uminus(A),A2),B2) ) ) ).

% minus_mod_self1
tff(fact_1853_sgn__less,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,sgn_sgn(A),A2)),zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% sgn_less
tff(fact_1854_sgn__greater,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,sgn_sgn(A),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% sgn_greater
tff(fact_1855_divide__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A] : ( divide_divide(A,A2,aa(A,A,sgn_sgn(A),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% divide_sgn
tff(fact_1856_fact__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,zero_zero(nat)) = one_one(A) ) ) ).

% fact_0
tff(fact_1857_cosh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,cosh(A),zero_zero(A)) = one_one(A) ) ) ).

% cosh_0
tff(fact_1858_fact__1,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,one_one(nat)) = one_one(A) ) ) ).

% fact_1
tff(fact_1859_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A] : ( modulo_modulo(A,A2,aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% mod_minus1_right
tff(fact_1860_sgn__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => ( aa(A,A,sgn_sgn(A),A2) = one_one(A) ) ) ) ).

% sgn_pos
tff(fact_1861_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2)) = one_one(A) ) ) ) ).

% abs_sgn_eq_1
tff(fact_1862_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiring_char_0_fact(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% fact_Suc_0
tff(fact_1863_fact__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_Suc
tff(fact_1864_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),K)
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_neg_neg_trivial
tff(fact_1865_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),L)
       => ( modulo_modulo(int,K,L) = K ) ) ) ).

% mod_pos_pos_trivial
tff(fact_1866_sgn__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% sgn_neg
tff(fact_1867_of__nat__mod,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,M,N)) = modulo_modulo(A,aa(nat,A,semiring_1_of_nat(A),M),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_mod
tff(fact_1868_fact__mod,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom(A)
        & semidom_modulo(A) )
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( modulo_modulo(A,semiring_char_0_fact(A,N),semiring_char_0_fact(A,M)) = zero_zero(A) ) ) ) ).

% fact_mod
tff(fact_1869_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),semiring_char_0_fact(nat,M)),semiring_char_0_fact(nat,N)) ) ).

% fact_mono_nat
tff(fact_1870_fact__ge__self,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),semiring_char_0_fact(nat,N)) ).

% fact_ge_self
tff(fact_1871_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% sgn_eq_0_iff
tff(fact_1872_sgn__0__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% sgn_0_0
tff(fact_1873_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_right_eq
tff(fact_1874_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_left_eq
tff(fact_1875_mult__mod__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),C2),modulo_modulo(A,A2,B2)) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ).

% mult_mod_right
tff(fact_1876_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,B2)),C2) ) ) ).

% mod_mult_mult2
tff(fact_1877_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A5),B5),C2) ) ) ) ) ).

% mod_mult_cong
tff(fact_1878_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ).

% mod_mult_eq
tff(fact_1879_mod__add__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_eq
tff(fact_1880_mod__add__cong,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A5),B5),C2) ) ) ) ) ).

% mod_add_cong
tff(fact_1881_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_left_eq
tff(fact_1882_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) ) ) ).

% mod_add_right_eq
tff(fact_1883_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A,C2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_right_eq
tff(fact_1884_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,C2)),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_left_eq
tff(fact_1885_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,A5,C2) )
         => ( ( modulo_modulo(A,B2,C2) = modulo_modulo(A,B5,C2) )
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A5),B5),C2) ) ) ) ) ).

% mod_diff_cong
tff(fact_1886_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) ) ) ).

% mod_diff_eq
tff(fact_1887_sgn__mult,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A,B2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),B2)) ) ) ).

% sgn_mult
tff(fact_1888_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A2) )
         => ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,sgn_sgn(A),A2) ) ) ) ).

% same_sgn_sgn_add
tff(fact_1889_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semiri3467727345109120633visors(A) )
     => ! [N: nat] : ( semiring_char_0_fact(A,N) != zero_zero(A) ) ) ).

% fact_nonzero
tff(fact_1890_cosh__real__nonzero,axiom,
    ! [Xa: real] : ( aa(real,real,cosh(real),Xa) != zero_zero(real) ) ).

% cosh_real_nonzero
tff(fact_1891_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),modulo_modulo(A,A2,B2)),A2) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
tff(fact_1892_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,B2)),B2) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
tff(fact_1893_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),semiring_char_0_fact(nat,M)),semiring_char_0_fact(nat,N)) ) ) ).

% fact_less_mono_nat
tff(fact_1894_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = A2 )
        <=> ( divide_divide(A,A2,B2) = zero_zero(A) ) ) ) ).

% mod_eq_self_iff_div_eq_0
tff(fact_1895_mod__eqE,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,B2,C2) )
         => ~ ! [D6: A] : ( B2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D6)) ) ) ) ).

% mod_eqE
tff(fact_1896_div__add1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A,C2: A] : ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2))),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,C2)),modulo_modulo(A,B2,C2)),C2)) ) ) ).

% div_add1_eq
tff(fact_1897_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) != aa(A,A,sgn_sgn(A),A2) )
         => ( ( aa(A,A,sgn_sgn(A),A2) != zero_zero(A) )
           => ( ( aa(A,A,sgn_sgn(A),B2) != zero_zero(A) )
             => ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),aa(A,A,sgn_sgn(A),B2)) ) ) ) ) ) ).

% sgn_not_eq_imp
tff(fact_1898_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ( aa(A,A,sgn_sgn(A),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% sgn_minus_1
tff(fact_1899_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),semiring_char_0_fact(A,N)) ) ).

% fact_ge_zero
tff(fact_1900_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [K: A] : ( aa(A,A,abs_abs(A),K) = aa(A,A,aa(A,fun(A,A),times_times(A),K),aa(A,A,sgn_sgn(A),K)) ) ) ).

% linordered_idom_class.abs_sgn
tff(fact_1901_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,abs_abs(A),A2)),aa(A,A,sgn_sgn(A),A2)) = A2 ) ) ).

% abs_mult_sgn
tff(fact_1902_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,abs_abs(A),A2)) = A2 ) ) ).

% sgn_mult_abs
tff(fact_1903_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),Xa)),aa(A,A,abs_abs(A),Xa)) = Xa ) ) ).

% mult_sgn_abs
tff(fact_1904_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),semiring_char_0_fact(A,N)) ) ).

% fact_gt_zero
tff(fact_1905_fact__not__neg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),semiring_char_0_fact(A,N)),zero_zero(A)) ) ).

% fact_not_neg
tff(fact_1906_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [B2: A,A2: A] :
          ( ( aa(A,A,sgn_sgn(A),B2) = aa(A,A,sgn_sgn(A),A2) )
         => ( aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2)) ) ) ) ).

% same_sgn_abs_add
tff(fact_1907_fact__ge__1,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),semiring_char_0_fact(A,N)) ) ).

% fact_ge_1
tff(fact_1908_fact__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),semiring_char_0_fact(A,M)),semiring_char_0_fact(A,N)) ) ) ).

% fact_mono
tff(fact_1909_cosh__real__pos,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,cosh(real),Xa)) ).

% cosh_real_pos
tff(fact_1910_cosh__real__nonpos__le__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),zero_zero(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,cosh(real),Xa)),aa(real,real,cosh(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),Xa) ) ) ) ).

% cosh_real_nonpos_le_iff
tff(fact_1911_cosh__real__nonneg__le__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,cosh(real),Xa)),aa(real,real,cosh(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ) ) ).

% cosh_real_nonneg_le_iff
tff(fact_1912_cosh__real__nonneg,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,cosh(real),Xa)) ).

% cosh_real_nonneg
tff(fact_1913_arcosh__cosh__real,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,real,arcosh(real),aa(real,real,cosh(real),Xa)) = Xa ) ) ).

% arcosh_cosh_real
tff(fact_1914_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),M)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,M,K)),M) ) ).

% zmod_le_nonneg_dividend
tff(fact_1915_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),modulo_modulo(int,K,L)) ) ).

% neg_mod_bound
tff(fact_1916_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),modulo_modulo(int,K,L)),L) ) ).

% Euclidean_Division.pos_mod_bound
tff(fact_1917_cosh__real__ge__1,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,cosh(real),Xa)) ).

% cosh_real_ge_1
tff(fact_1918_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus1_not_zero
tff(fact_1919_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo(int,K,aa(int,int,uminus_uminus(int),L)) != zero_zero(int) )
     => ( modulo_modulo(int,K,L) != zero_zero(int) ) ) ).

% zmod_zminus2_not_zero
tff(fact_1920_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( modulo_modulo(int,M,D2) = zero_zero(int) )
    <=> ? [Q4: int] : ( M = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q4) ) ) ).

% zmod_eq_0_iff
tff(fact_1921_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( modulo_modulo(int,M,D2) = zero_zero(int) )
     => ? [Q3: int] : ( M = aa(int,int,aa(int,fun(int,int),times_times(int),D2),Q3) ) ) ).

% zmod_eq_0D
tff(fact_1922_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & comm_semiring_1(A) )
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = comm_s3205402744901411588hammer(A,one_one(A),N) ) ) ).

% pochhammer_fact
tff(fact_1923_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),modulo_modulo(A,A2,B2)) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
tff(fact_1924_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( modulo_modulo(A,A2,B2) = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
tff(fact_1925_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),semiring_char_0_fact(nat,N)) ).

% fact_ge_Suc_0_nat
tff(fact_1926_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = one_one(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% sgn_1_pos
tff(fact_1927_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A,C2: A] : ( divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),divide_divide(A,B2,C2))),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),modulo_modulo(A,B2,C2)),C2)) ) ) ).

% div_mult1_eq
tff(fact_1928_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A2,B2))),modulo_modulo(A,A2,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) ) ) ).

% cancel_div_mod_rules(2)
tff(fact_1929_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),B2)),modulo_modulo(A,A2,B2))),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2) ) ) ).

% cancel_div_mod_rules(1)
tff(fact_1930_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( A2 = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),B2)),modulo_modulo(A,A2,B2)) ) ) ).

% mod_div_decomp
tff(fact_1931_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),B2)),modulo_modulo(A,A2,B2)) = A2 ) ) ).

% div_mult_mod_eq
tff(fact_1932_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),B2)) = A2 ) ) ).

% mod_div_mult_eq
tff(fact_1933_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,B2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A2,B2))) = A2 ) ) ).

% mod_mult_div_eq
tff(fact_1934_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [B2: A,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A2,B2))),modulo_modulo(A,A2,B2)) = A2 ) ) ).

% mult_div_mod_eq
tff(fact_1935_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A2,B2))) = modulo_modulo(A,A2,B2) ) ) ).

% minus_mult_div_eq_mod
tff(fact_1936_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,A2,B2)) ) ) ).

% minus_mod_eq_mult_div
tff(fact_1937_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),B2) ) ) ).

% minus_mod_eq_div_mult
tff(fact_1938_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),B2)) = modulo_modulo(A,A2,B2) ) ) ).

% minus_div_mult_eq_mod
tff(fact_1939_sgn__root,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,real,sgn_sgn(real),aa(real,real,root(N),Xa)) = aa(real,real,sgn_sgn(real),Xa) ) ) ).

% sgn_root
tff(fact_1940_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2))
          = $ite(A2 = zero_zero(A),zero_zero(A),one_one(A)) ) ) ).

% abs_sgn_eq
tff(fact_1941_cosh__real__nonpos__less__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),zero_zero(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cosh(real),Xa)),aa(real,real,cosh(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa) ) ) ) ).

% cosh_real_nonpos_less_iff
tff(fact_1942_cosh__real__nonneg__less__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cosh(real),Xa)),aa(real,real,cosh(real),Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ) ) ).

% cosh_real_nonneg_less_iff
tff(fact_1943_cosh__real__strict__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cosh(real),Xa)),aa(real,real,cosh(real),Y)) ) ) ).

% cosh_real_strict_mono
tff(fact_1944_fact__less__mono,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),semiring_char_0_fact(A,M)),semiring_char_0_fact(A,N)) ) ) ) ).

% fact_less_mono
tff(fact_1945_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,K,L)),zero_zero(int)) ) ).

% neg_mod_sign
tff(fact_1946_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L)) ) ).

% Euclidean_Division.pos_mod_sign
tff(fact_1947_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),zero_zero(int))
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),modulo_modulo(int,A2,B2)),zero_zero(int))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),modulo_modulo(int,A2,B2)) ) ) ).

% neg_mod_conj
tff(fact_1948_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,A2,B2))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),modulo_modulo(int,A2,B2)),B2) ) ) ).

% pos_mod_conj
tff(fact_1949_zmod__trivial__iff,axiom,
    ! [I: int,K: int] :
      ( ( modulo_modulo(int,I,K) = I )
    <=> ( ( K = zero_zero(int) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),I)
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),I),K) )
        | ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),zero_zero(int))
          & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),I) ) ) ) ).

% zmod_trivial_iff
tff(fact_1950_zdiv__mono__strict,axiom,
    ! [A3: int,B3: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A3),B3)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
       => ( ( modulo_modulo(int,A3,N) = zero_zero(int) )
         => ( ( modulo_modulo(int,B3,N) = zero_zero(int) )
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),divide_divide(int,A3,N)),divide_divide(int,B3,N)) ) ) ) ) ).

% zdiv_mono_strict
tff(fact_1951_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( modulo_modulo(int,A2,aa(int,int,uminus_uminus(int),B2))
      = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,A2,B2)),B2)) ) ).

% zmod_zminus2_eq_if
tff(fact_1952_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( modulo_modulo(int,aa(int,int,uminus_uminus(int),A2),B2)
      = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),modulo_modulo(int,A2,B2))) ) ).

% zmod_zminus1_eq_if
tff(fact_1953_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),modulo_modulo(int,K,L))),aa(int,int,abs_abs(int),L)) ) ).

% abs_mod_less
tff(fact_1954_fact__le__power,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),semiring_char_0_fact(A,N)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),N),N))) ) ).

% fact_le_power
tff(fact_1955_div__mod__decomp__int,axiom,
    ! [A3: int,N: int] : ( A3 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),divide_divide(int,A3,N)),N)),modulo_modulo(int,A3,N)) ) ).

% div_mod_decomp_int
tff(fact_1956_sgn__real__def,axiom,
    ! [A2: real] :
      ( aa(real,real,sgn_sgn(real),A2)
      = $ite(
          A2 = zero_zero(real),
          zero_zero(real),
          $ite(aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2),one_one(real),aa(real,real,uminus_uminus(real),one_one(real))) ) ) ).

% sgn_real_def
tff(fact_1957_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,suc,M))
     => ( semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,M)),N)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))) ) ) ).

% fact_diff_Suc
tff(fact_1958_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( ( aa(A,A,sgn_sgn(A),A2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ).

% sgn_1_neg
tff(fact_1959_sgn__if,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] :
          ( aa(A,A,sgn_sgn(A),Xa)
          = $ite(
              Xa = zero_zero(A),
              zero_zero(A),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa),one_one(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ) ).

% sgn_if
tff(fact_1960_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,M: nat,N: nat] : ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),modulo_modulo(A,divide_divide(A,A2,aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)))),modulo_modulo(A,A2,aa(nat,A,semiring_1_of_nat(A),M))) ) ) ).

% mod_mult2_eq'
tff(fact_1961_fact__div__fact__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),divide_divide(nat,semiring_char_0_fact(nat,N),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),R)))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),N),R)) ) ).

% fact_div_fact_le_pow
tff(fact_1962_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)),zero_zero(int))
       => ( modulo_modulo(int,K,L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L) ) ) ) ).

% mod_pos_neg_trivial
tff(fact_1963_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),L),K)
       => ( modulo_modulo(int,K,L) = modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L),L) ) ) ) ).

% mod_pos_geq
tff(fact_1964_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
         => ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),modulo_modulo(A,divide_divide(A,A2,B2),C2))),modulo_modulo(A,A2,B2)) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
tff(fact_1965_sgn__power__injE,axiom,
    ! [A2: real,N: nat,Xa: real,B2: real] :
      ( ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),A2)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),A2)),N)) = Xa )
     => ( ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),B2)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),B2)),N)) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
tff(fact_1966_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),B2)
         => ( modulo_modulo(int,A2,B2) = R ) ) ) ) ).

% int_mod_pos_eq
tff(fact_1967_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),Q2)),R) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),R)
         => ( modulo_modulo(int,A2,B2) = R ) ) ) ) ).

% int_mod_neg_eq
tff(fact_1968_split__zmod,axiom,
    ! [P: fun(int,$o),N: int,K: int] :
      ( aa(int,$o,P,modulo_modulo(int,N,K))
    <=> ( ( ( K = zero_zero(int) )
         => aa(int,$o,P,N) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
         => ! [I3: int,J3: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),J3)
                & aa(int,$o,aa(int,fun(int,$o),ord_less(int),J3),K)
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I3)),J3) ) )
             => aa(int,$o,P,J3) ) )
        & ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
         => ! [I3: int,J3: int] :
              ( ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),J3)
                & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J3),zero_zero(int))
                & ( N = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),I3)),J3) ) )
             => aa(int,$o,P,J3) ) ) ) ) ).

% split_zmod
tff(fact_1969_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L)
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),K),L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),L),one_one(int))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)),L)) ) ) ).

% minus_mod_int_eq
tff(fact_1970_zmod__minus1,axiom,
    ! [B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),B2) = aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),one_one(int)) ) ) ).

% zmod_minus1
tff(fact_1971_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),C2)
     => ( modulo_modulo(int,A2,aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),B2),modulo_modulo(int,divide_divide(int,A2,B2),C2))),modulo_modulo(int,A2,B2)) ) ) ).

% zmod_zmult2_eq
tff(fact_1972_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2 != zero_zero(int) )
     => ( divide_divide(int,A2,aa(int,int,uminus_uminus(int),B2))
        = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),aa(int,int,uminus_uminus(int),divide_divide(int,A2,B2)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),divide_divide(int,A2,B2))),one_one(int))) ) ) ).

% zdiv_zminus2_eq_if
tff(fact_1973_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2 != zero_zero(int) )
     => ( divide_divide(int,aa(int,int,uminus_uminus(int),A2),B2)
        = $ite(modulo_modulo(int,A2,B2) = zero_zero(int),aa(int,int,uminus_uminus(int),divide_divide(int,A2,B2)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),divide_divide(int,A2,B2))),one_one(int))) ) ) ).

% zdiv_zminus1_eq_if
tff(fact_1974_sgn__power__root,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),aa(real,real,root(N),Xa))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),aa(real,real,root(N),Xa))),N)) = Xa ) ) ).

% sgn_power_root
tff(fact_1975_root__sgn__power,axiom,
    ! [N: nat,Y: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,real,root(N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Y)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),Y)),N))) = Y ) ) ).

% root_sgn_power
tff(fact_1976_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: nat] :
          ( semiring_char_0_fact(A,M)
          = $ite(M = zero_zero(nat),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),M)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat))))) ) ) ).

% fact_num_eq_if
tff(fact_1977_fact__reduce,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ) ).

% fact_reduce
tff(fact_1978_verit__le__mono__div__int,axiom,
    ! [A3: int,B3: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),A3),B3)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
       => aa(int,$o,
            aa(int,fun(int,$o),ord_less_eq(int),
              aa(int,int,aa(int,fun(int,int),plus_plus(int),divide_divide(int,A3,N)),$ite(modulo_modulo(int,B3,N) = zero_zero(int),one_one(int),zero_zero(int)))),
            divide_divide(int,B3,N)) ) ) ).

% verit_le_mono_div_int
tff(fact_1979_sgn__le__0__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sgn_sgn(real),Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real)) ) ).

% sgn_le_0_iff
tff(fact_1980_zero__le__sgn__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sgn_sgn(real),Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa) ) ).

% zero_le_sgn_iff
tff(fact_1981_sgn__one,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ( aa(A,A,sgn_sgn(A),one_one(A)) = one_one(A) ) ) ).

% sgn_one
tff(fact_1982_sgn__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( aa(A,A,sgn_sgn(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sgn_zero
tff(fact_1983_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Xa: A,Y: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),Xa)),aa(A,A,sgn_sgn(A),Y)) ) ) ).

% Real_Vector_Spaces.sgn_mult
tff(fact_1984_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] :
          ( ( aa(A,A,sgn_sgn(A),Xa) = zero_zero(A) )
        <=> ( Xa = zero_zero(A) ) ) ) ).

% sgn_zero_iff
tff(fact_1985_verit__le__mono__div,axiom,
    ! [A3: nat,B3: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),B3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => aa(nat,$o,
            aa(nat,fun(nat,$o),ord_less_eq(nat),
              aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),divide_divide(nat,A3,N)),$ite(modulo_modulo(nat,B3,N) = zero_zero(nat),one_one(nat),zero_zero(nat)))),
            divide_divide(nat,B3,N)) ) ) ).

% verit_le_mono_div
tff(fact_1986_mod__by__Suc__0,axiom,
    ! [M: nat] : ( modulo_modulo(nat,M,aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% mod_by_Suc_0
tff(fact_1987_Suc__mod__mult__self4,axiom,
    ! [N: nat,K: nat,M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K)),M)),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self4
tff(fact_1988_Suc__mod__mult__self3,axiom,
    ! [K: nat,N: nat,M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)),M)),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self3
tff(fact_1989_Suc__mod__mult__self2,axiom,
    ! [M: nat,N: nat,K: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self2
tff(fact_1990_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% Suc_mod_mult_self1
tff(fact_1991_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,modulo_modulo(nat,M,N))),N) = modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,M)),N) ) ).

% mod_Suc_Suc_eq
tff(fact_1992_mod__Suc__eq,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,modulo_modulo(nat,M,N)),N) = modulo_modulo(nat,aa(nat,nat,suc,M),N) ) ).

% mod_Suc_eq
tff(fact_1993_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,M,N)),M) ).

% mod_less_eq_dividend
tff(fact_1994_funpow__mod__eq,axiom,
    ! [A: $tType,N: nat,F3: fun(A,A),Xa: A,M: nat] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),Xa) = Xa )
     => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),modulo_modulo(nat,M,N)),F3),Xa) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F3),Xa) ) ) ).

% funpow_mod_eq
tff(fact_1995_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N2: nat,L2: int] : ( K != aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L2)),aa(nat,int,semiring_1_of_nat(int),N2)) ) ).

% int_sgnE
tff(fact_1996_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( modulo_modulo(nat,aa(nat,nat,suc,M),N)
      = $ite(aa(nat,nat,suc,modulo_modulo(nat,M,N)) = N,zero_zero(nat),aa(nat,nat,suc,modulo_modulo(nat,M,N))) ) ).

% mod_Suc
tff(fact_1997_mod__induct,axiom,
    ! [P: fun(nat,$o),N: nat,P2: nat,M: nat] :
      ( aa(nat,$o,P,N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),P2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),P2)
         => ( ! [N2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N2),P2)
               => ( aa(nat,$o,P,N2)
                 => aa(nat,$o,P,modulo_modulo(nat,aa(nat,nat,suc,N2),P2)) ) )
           => aa(nat,$o,P,M) ) ) ) ) ).

% mod_induct
tff(fact_1998_gcd__nat__induct,axiom,
    ! [P: fun(nat,fun(nat,$o)),M: nat,N: nat] :
      ( ! [M2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),P,M2),zero_zero(nat))
     => ( ! [M2: nat,N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),P,N2),modulo_modulo(nat,M2,N2))
             => aa(nat,$o,aa(nat,fun(nat,$o),P,M2),N2) ) )
       => aa(nat,$o,aa(nat,fun(nat,$o),P,M),N) ) ) ).

% gcd_nat_induct
tff(fact_1999_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),modulo_modulo(nat,M,N)),N) ) ).

% mod_less_divisor
tff(fact_2000_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,M,aa(nat,nat,suc,N))),N) ).

% mod_Suc_le_divisor
tff(fact_2001_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( modulo_modulo(nat,M,D2) = zero_zero(nat) )
     => ? [Q3: nat] : ( M = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),D2),Q3) ) ) ).

% mod_eq_0D
tff(fact_2002_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
     => ( modulo_modulo(nat,M,N) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N) ) ) ).

% mod_geq
tff(fact_2003_mod__if,axiom,
    ! [M: nat,N: nat] :
      ( modulo_modulo(nat,M,N)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N),M,modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N)) ) ).

% mod_if
tff(fact_2004_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => ( modulo_modulo(nat,M,N) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N) ) ) ).

% le_mod_geq
tff(fact_2005_nat__mod__eq__iff,axiom,
    ! [Xa: nat,N: nat,Y: nat] :
      ( ( modulo_modulo(nat,Xa,N) = modulo_modulo(nat,Y,N) )
    <=> ? [Q1: nat,Q22: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q1)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q22)) ) ) ).

% nat_mod_eq_iff
tff(fact_2006_zmod__int,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,A2,B2)) = modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% zmod_int
tff(fact_2007_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),modulo_modulo(nat,M,N)),N) ) ).

% mod_le_divisor
tff(fact_2008_nat__mod__eq__lemma,axiom,
    ! [Xa: nat,N: nat,Y: nat] :
      ( ( modulo_modulo(nat,Xa,N) = modulo_modulo(nat,Y,N) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y),Xa)
       => ? [Q3: nat] : ( Xa = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Y),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q3)) ) ) ) ).

% nat_mod_eq_lemma
tff(fact_2009_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( modulo_modulo(nat,M,Q2) = modulo_modulo(nat,N,Q2) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
       => ~ ! [S3: nat] : ( N != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q2),S3)) ) ) ) ).

% mod_eq_nat2E
tff(fact_2010_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( modulo_modulo(nat,M,Q2) = modulo_modulo(nat,N,Q2) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
       => ~ ! [S3: nat] : ( M != aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Q2),S3)) ) ) ) ).

% mod_eq_nat1E
tff(fact_2011_div__less__mono,axiom,
    ! [A3: nat,B3: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A3),B3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ( ( modulo_modulo(nat,A3,N) = zero_zero(nat) )
         => ( ( modulo_modulo(nat,B3,N) = zero_zero(nat) )
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),divide_divide(nat,A3,N)),divide_divide(nat,B3,N)) ) ) ) ) ).

% div_less_mono
tff(fact_2012_div__mod__decomp,axiom,
    ! [A3: nat,N: nat] : ( A3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),divide_divide(nat,A3,N)),N)),modulo_modulo(nat,A3,N)) ) ).

% div_mod_decomp
tff(fact_2013_mod__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( modulo_modulo(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),modulo_modulo(nat,divide_divide(nat,M,N),Q2))),modulo_modulo(nat,M,N)) ) ).

% mod_mult2_eq
tff(fact_2014_modulo__nat__def,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,M,N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),divide_divide(nat,M,N)),N)) ) ).

% modulo_nat_def
tff(fact_2015_zsgn__def,axiom,
    ! [I: int] :
      ( aa(int,int,sgn_sgn(int),I)
      = $ite(
          I = zero_zero(int),
          zero_zero(int),
          $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),I),one_one(int),aa(int,int,uminus_uminus(int),one_one(int))) ) ) ).

% zsgn_def
tff(fact_2016_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V != zero_zero(int) )
     => ( divide_divide(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),K)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),V)),aa(int,int,abs_abs(int),L))) = divide_divide(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L)) ) ) ).

% div_sgn_abs_cancel
tff(fact_2017_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),divide_divide(nat,M,N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),modulo_modulo(nat,M,N))),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% field_char_0_class.of_nat_div
tff(fact_2018_split__mod,axiom,
    ! [P: fun(nat,$o),M: nat,N: nat] :
      ( aa(nat,$o,P,modulo_modulo(nat,M,N))
    <=> ( ( ( N = zero_zero(nat) )
         => aa(nat,$o,P,M) )
        & ( ( N != zero_zero(nat) )
         => ! [I3: nat,J3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),N)
             => ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),I3)),J3) )
               => aa(nat,$o,P,J3) ) ) ) ) ) ).

% split_mod
tff(fact_2019_nat__mod__distrib,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => ( aa(int,nat,nat2,modulo_modulo(int,Xa,Y)) = modulo_modulo(nat,aa(int,nat,nat2,Xa),aa(int,nat,nat2,Y)) ) ) ) ).

% nat_mod_distrib
tff(fact_2020_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] : ( modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L)) = aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))) ) ).

% mod_abs_eq_div_nat
tff(fact_2021_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),M)
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),M) = one_one(nat) ) ) ).

% Suc_times_mod_eq
tff(fact_2022_Cauchy__iff2,axiom,
    ! [X6: fun(nat,real)] :
      ( topolo3814608138187158403Cauchy(real,X6)
    <=> ! [J3: nat] :
        ? [M8: nat] :
        ! [M6: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M6)
         => ! [N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N5)
             => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,X6,M6)),aa(nat,real,X6,N5)))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J3)))) ) ) ) ).

% Cauchy_iff2
tff(fact_2023_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ).

% divide_le_eq_numeral(2)
tff(fact_2024_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),divide_divide(A,B2,C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ).

% le_divide_eq_numeral(2)
tff(fact_2025_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A,W: A,M: nat] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),one_one(real))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,W)),one_one(real))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),W),M)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W)))) ) ) ) ).

% norm_power_diff
tff(fact_2026_cpmi,axiom,
    ! [D3: int,P: fun(int,$o),P3: fun(int,$o),B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( ? [Z3: int] :
          ! [X: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X),Z3)
           => ( aa(int,$o,P,X)
            <=> aa(int,$o,P3,X) ) )
       => ( ! [X: int] :
              ( ! [Xa2: int] :
                  ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
                 => ! [Xb2: int] :
                      ( member(int,Xb2,B3)
                     => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
             => ( aa(int,$o,P,X)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D3)) ) )
         => ( ! [X: int,K3: int] :
                ( aa(int,$o,P3,X)
              <=> aa(int,$o,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K3),D3))) )
           => ( ? [X_12: int] : aa(int,$o,P,X_12)
            <=> ( ? [X4: int] :
                    ( member(int,X4,set_or1337092689740270186AtMost(int,one_one(int),D3))
                    & aa(int,$o,P3,X4) )
                | ? [X4: int] :
                    ( member(int,X4,set_or1337092689740270186AtMost(int,one_one(int),D3))
                    & ? [Xa3: int] :
                        ( member(int,Xa3,B3)
                        & aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa3),X4)) ) ) ) ) ) ) ) ) ).

% cpmi
tff(fact_2027_cppi,axiom,
    ! [D3: int,P: fun(int,$o),P3: fun(int,$o),A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( ? [Z3: int] :
          ! [X: int] :
            ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z3),X)
           => ( aa(int,$o,P,X)
            <=> aa(int,$o,P3,X) ) )
       => ( ! [X: int] :
              ( ! [Xa2: int] :
                  ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
                 => ! [Xb2: int] :
                      ( member(int,Xb2,A3)
                     => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
             => ( aa(int,$o,P,X)
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D3)) ) )
         => ( ! [X: int,K3: int] :
                ( aa(int,$o,P3,X)
              <=> aa(int,$o,P3,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K3),D3))) )
           => ( ? [X_12: int] : aa(int,$o,P,X_12)
            <=> ( ? [X4: int] :
                    ( member(int,X4,set_or1337092689740270186AtMost(int,one_one(int),D3))
                    & aa(int,$o,P3,X4) )
                | ? [X4: int] :
                    ( member(int,X4,set_or1337092689740270186AtMost(int,one_one(int),D3))
                    & ? [Xa3: int] :
                        ( member(int,Xa3,A3)
                        & aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa3),X4)) ) ) ) ) ) ) ) ) ).

% cppi
tff(fact_2028_aset_I8_J,axiom,
    ! [D3: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),X3)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)) ) ) ) ).

% aset(8)
tff(fact_2029_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [M: num,N: num] :
          ( ( aa(num,A,numeral_numeral(A),M) = aa(num,A,numeral_numeral(A),N) )
        <=> ( M = N ) ) ) ).

% numeral_eq_iff
tff(fact_2030_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: num,N: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),M))),aa(num,nat,numeral_numeral(nat),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% power_mult_numeral
tff(fact_2031_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( aa(nat,int,semiring_1_of_nat(int),M) = aa(num,int,numeral_numeral(int),V) )
    <=> ( M = aa(num,nat,numeral_numeral(nat),V) ) ) ).

% int_eq_iff_numeral
tff(fact_2032_nat__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(num,int,numeral_numeral(int),K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% nat_numeral
tff(fact_2033_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: num,N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),N) ) ) ).

% numeral_le_iff
tff(fact_2034_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [M: num,N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N) ) ) ).

% numeral_less_iff
tff(fact_2035_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Z) ) ) ).

% mult_numeral_left_semiring_numeral
tff(fact_2036_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N)) ) ) ).

% numeral_times_numeral
tff(fact_2037_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ) ).

% numeral_plus_numeral
tff(fact_2038_add__numeral__left,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [V: num,W: num,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W))),Z) ) ) ).

% add_numeral_left
tff(fact_2039_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),aa(num,nat,numeral_numeral(nat),K)) = zero_zero(A) ) ) ).

% power_zero_numeral
tff(fact_2040_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,N: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) )
        <=> ( M = N ) ) ) ).

% neg_numeral_eq_iff
tff(fact_2041_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: num,N: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),M))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),N))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)))),B2) ) ) ).

% power_add_numeral2
tff(fact_2042_power__add__numeral,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),M))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N))) ) ) ).

% power_add_numeral
tff(fact_2043_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: num] : ( aa(nat,A,semiring_1_of_nat(A),aa(num,nat,numeral_numeral(nat),N)) = aa(num,A,numeral_numeral(A),N) ) ) ).

% of_nat_numeral
tff(fact_2044_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,H: A,L3: A,H2: A] :
          ( ( set_or1337092689740270186AtMost(A,L,H) = set_or1337092689740270186AtMost(A,L3,H2) )
        <=> ( ( ( L = L3 )
              & ( H = H2 ) )
            | ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),H)
              & ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L3),H2) ) ) ) ) ).

% Icc_eq_Icc
tff(fact_2045_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,L: A,U: A] :
          ( member(A,I,set_or1337092689740270186AtMost(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),I)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),U) ) ) ) ).

% atLeastAtMost_iff
tff(fact_2046_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% atLeastatMost_subset_iff
tff(fact_2047_abs__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ( aa(A,A,abs_abs(A),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),N) ) ) ).

% abs_numeral
tff(fact_2048_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Z: int,N: num] :
          ( ( aa(int,A,ring_1_of_int(A),Z) = aa(num,A,numeral_numeral(A),N) )
        <=> ( Z = aa(num,int,numeral_numeral(int),N) ) ) ) ).

% of_int_eq_numeral_iff
tff(fact_2049_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(num,int,numeral_numeral(int),K)) = aa(num,A,numeral_numeral(A),K) ) ) ).

% of_int_numeral
tff(fact_2050_floor__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% floor_numeral
tff(fact_2051_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(num,A,numeral_numeral(A),V)) = aa(num,int,numeral_numeral(int),V) ) ) ).

% ceiling_numeral
tff(fact_2052_norm__fact,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [N: nat] : ( real_V7770717601297561774m_norm(A,semiring_char_0_fact(A,N)) = semiring_char_0_fact(real,N) ) ) ).

% norm_fact
tff(fact_2053_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] : ( aa(real,real,aa(real,fun(real,real),powr(real),aa(num,real,numeral_numeral(real),M)),aa(num,real,numeral_numeral(real),N)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),M)),aa(num,nat,numeral_numeral(nat),N)) ) ).

% numeral_powr_numeral_real
tff(fact_2054_round__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: num] : ( archimedean_round(A,aa(num,A,numeral_numeral(A),N)) = aa(num,int,numeral_numeral(int),N) ) ) ).

% round_numeral
tff(fact_2055_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),N),M) ) ) ).

% neg_numeral_le_iff
tff(fact_2056_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% distrib_left_numeral
tff(fact_2057_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & semiring(A) )
     => ! [A2: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% distrib_right_numeral
tff(fact_2058_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),N),M) ) ) ).

% neg_numeral_less_iff
tff(fact_2059_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [V: num,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),C2)) ) ) ).

% right_diff_distrib_numeral
tff(fact_2060_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ring(A) )
     => ! [A2: A,B2: A,V: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)),aa(num,A,numeral_numeral(A),V)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(num,A,numeral_numeral(A),V))) ) ) ).

% left_diff_distrib_numeral
tff(fact_2061_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% mult_neg_numeral_simps(3)
tff(fact_2062_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% mult_neg_numeral_simps(2)
tff(fact_2063_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),M),N)) ) ) ).

% mult_neg_numeral_simps(1)
tff(fact_2064_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W))),Y) ) ) ).

% semiring_norm(172)
tff(fact_2065_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y) ) ) ).

% semiring_norm(171)
tff(fact_2066_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),V),W)))),Y) ) ) ).

% semiring_norm(170)
tff(fact_2067_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N))) ) ) ).

% add_neg_numeral_simps(3)
tff(fact_2068_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),W)))),Y) ) ) ).

% semiring_norm(168)
tff(fact_2069_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N))) ) ) ).

% diff_numeral_simps(3)
tff(fact_2070_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ) ).

% diff_numeral_simps(2)
tff(fact_2071_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ( aa(A,A,abs_abs(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),N) ) ) ).

% abs_neg_numeral
tff(fact_2072_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] :
          ( ( real_V7770717601297561774m_norm(A,Xa) = zero_zero(real) )
        <=> ( Xa = zero_zero(A) ) ) ) ).

% norm_eq_zero
tff(fact_2073_norm__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( real_V7770717601297561774m_norm(A,zero_zero(A)) = zero_zero(real) ) ) ).

% norm_zero
tff(fact_2074_norm__one,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ( real_V7770717601297561774m_norm(A,one_one(A)) = one_one(real) ) ) ).

% norm_one
tff(fact_2075_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),N)),aa(nat,real,semiring_1_of_nat(real),M))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),N)),M) ) ).

% numeral_le_real_of_nat_iff
tff(fact_2076_nat__neg__numeral,axiom,
    ! [K: num] : ( aa(int,nat,nat2,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = zero_zero(nat) ) ).

% nat_neg_numeral
tff(fact_2077_norm__of__nat,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [N: nat] : ( real_V7770717601297561774m_norm(A,aa(nat,A,semiring_1_of_nat(A),N)) = aa(nat,real,semiring_1_of_nat(real),N) ) ) ).

% norm_of_nat
tff(fact_2078_diff__nat__numeral,axiom,
    ! [V: num,V3: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),aa(num,nat,numeral_numeral(nat),V3)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),aa(num,int,numeral_numeral(int),V3))) ) ).

% diff_nat_numeral
tff(fact_2079_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y: int,Xa: num,N: nat] :
      ( ( aa(int,nat,nat2,Y) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N) )
    <=> ( Y = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N) ) ) ).

% nat_eq_numeral_power_cancel_iff
tff(fact_2080_numeral__power__eq__nat__cancel__iff,axiom,
    ! [Xa: num,N: nat,Y: int] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N) = aa(int,nat,nat2,Y) )
    <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N) = Y ) ) ).

% numeral_power_eq_nat_cancel_iff
tff(fact_2081_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))),B2) ) ) ).

% le_divide_eq_numeral1(1)
tff(fact_2082_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) ) ) ).

% divide_le_eq_numeral1(1)
tff(fact_2083_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,W: num] :
          ( ( A2 = divide_divide(A,B2,aa(num,A,numeral_numeral(A),W)) )
        <=> $ite(aa(num,A,numeral_numeral(A),W) != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W)) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral1(1)
tff(fact_2084_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A2: A] :
          ( ( divide_divide(A,B2,aa(num,A,numeral_numeral(A),W)) = A2 )
        <=> $ite(aa(num,A,numeral_numeral(A),W) != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W)),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral1(1)
tff(fact_2085_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) ) ) ).

% divide_less_eq_numeral1(1)
tff(fact_2086_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),divide_divide(A,B2,aa(num,A,numeral_numeral(A),W)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))),B2) ) ) ).

% less_divide_eq_numeral1(1)
tff(fact_2087_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),W)) = divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),W)) ) ) ).

% inverse_eq_divide_numeral
tff(fact_2088_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V7770717601297561774m_norm(A,Xa))
        <=> ( Xa != zero_zero(A) ) ) ) ).

% zero_less_norm_iff
tff(fact_2089_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Xa)),zero_zero(real))
        <=> ( Xa = zero_zero(A) ) ) ) ).

% norm_le_zero_iff
tff(fact_2090_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),N)),Z) ) ) ).

% of_int_numeral_le_iff
tff(fact_2091_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Z)),aa(num,A,numeral_numeral(A),N))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),aa(num,int,numeral_numeral(int),N)) ) ) ).

% of_int_le_numeral_iff
tff(fact_2092_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [W: num,A2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),W)),real_V7770717601297561774m_norm(A,A2)) ) ) ).

% norm_mult_numeral1
tff(fact_2093_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A,W: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),W))) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A2)),aa(num,real,numeral_numeral(real),W)) ) ) ).

% norm_mult_numeral2
tff(fact_2094_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Z: int,N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),Z)),aa(num,A,numeral_numeral(A),N))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z),aa(num,int,numeral_numeral(int),N)) ) ) ).

% of_int_less_numeral_iff
tff(fact_2095_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,Z: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),N)),aa(int,A,ring_1_of_int(A),Z))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),N)),Z) ) ) ).

% of_int_numeral_less_iff
tff(fact_2096_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Xa: num,N: nat,Y: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N) = aa(nat,A,semiring_1_of_nat(A),Y) )
        <=> ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N) = Y ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
tff(fact_2097_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [Y: nat,Xa: num,N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),Y) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N) )
        <=> ( Y = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
tff(fact_2098_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),V)),Xa) ) ) ).

% numeral_le_floor
tff(fact_2099_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,Xa)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(num,A,numeral_numeral(A),V)) ) ) ).

% floor_less_numeral
tff(fact_2100_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,Xa)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(num,A,numeral_numeral(A),V)) ) ) ).

% ceiling_le_numeral
tff(fact_2101_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),V)),Xa) ) ) ).

% numeral_less_ceiling
tff(fact_2102_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archim6421214686448440834_floor(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_neg_numeral
tff(fact_2103_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(A,Xa)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_add_numeral
tff(fact_2104_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] : ( archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archim6421214686448440834_floor(A,Xa)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% floor_diff_numeral
tff(fact_2105_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num] : ( archimedean_ceiling(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_neg_numeral
tff(fact_2106_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Xa: num,N: nat,Y: int] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N) = aa(int,A,ring_1_of_int(A),Y) )
        <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N) = Y ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
tff(fact_2107_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y: int,Xa: num,N: nat] :
          ( ( aa(int,A,ring_1_of_int(A),Y) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N) )
        <=> ( Y = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
tff(fact_2108_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] : ( archimedean_ceiling(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(num,A,numeral_numeral(A),V))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),archimedean_ceiling(A,Xa)),aa(num,int,numeral_numeral(int),V)) ) ) ).

% ceiling_diff_numeral
tff(fact_2109_powr__numeral,axiom,
    ! [Xa: real,N: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(num,real,numeral_numeral(real),N)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),N)) ) ) ).

% powr_numeral
tff(fact_2110_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) != one_one(nat) )
     => ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),K)),N)),aa(num,nat,numeral_numeral(nat),K)) = one_one(nat) ) ) ).

% Suc_times_numeral_mod_eq
tff(fact_2111_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [N: num] : ( archimedean_round(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)) ) ) ).

% round_neg_numeral
tff(fact_2112_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% le_divide_eq_numeral1(2)
tff(fact_2113_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2) ) ) ).

% divide_le_eq_numeral1(2)
tff(fact_2114_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: A,B2: A,W: num] :
          ( ( A2 = divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) )
        <=> $ite(aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = B2,A2 = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral1(2)
tff(fact_2115_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,W: num,A2: A] :
          ( ( divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = A2 )
        <=> $ite(aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),A2 = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral1(2)
tff(fact_2116_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,W: num,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))),B2) ) ) ).

% divide_less_eq_numeral1(2)
tff(fact_2117_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),divide_divide(A,B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ).

% less_divide_eq_numeral1(2)
tff(fact_2118_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_dec_simps(1)
tff(fact_2119_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_inc_simps(1)
tff(fact_2120_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num] : ( aa(A,A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) = divide_divide(A,one_one(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% inverse_eq_divide_neg_numeral
tff(fact_2121_nat__numeral__diff__1,axiom,
    ! [V: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),V)),one_one(int))) ) ).

% nat_numeral_diff_1
tff(fact_2122_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,Xa: num,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(int,nat,nat2,A2)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)) ) ).

% nat_less_numeral_power_cancel_iff
tff(fact_2123_numeral__power__less__nat__cancel__iff,axiom,
    ! [Xa: num,N: nat,A2: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N)),aa(int,nat,nat2,A2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)),A2) ) ).

% numeral_power_less_nat_cancel_iff
tff(fact_2124_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,Xa: num,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(int,nat,nat2,A2)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)) ) ).

% nat_le_numeral_power_cancel_iff
tff(fact_2125_numeral__power__le__nat__cancel__iff,axiom,
    ! [Xa: num,N: nat,A2: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),Xa)),N)),aa(int,nat,nat2,A2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)),A2) ) ).

% numeral_power_le_nat_cancel_iff
tff(fact_2126_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),B2))) = divide_divide(int,one_one(int),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_one_divide_eq_div_numeral
tff(fact_2127_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(num,int,numeral_numeral(int),V)),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),Xa) ) ) ).

% numeral_less_floor
tff(fact_2128_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))) ) ) ).

% floor_le_numeral
tff(fact_2129_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: num,N: nat,Xa: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I)),N)),aa(nat,A,semiring_1_of_nat(A),Xa))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I)),N)),Xa) ) ) ).

% numeral_power_less_of_nat_cancel_iff
tff(fact_2130_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: nat,I: num,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I)),N))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I)),N)) ) ) ).

% of_nat_less_numeral_power_cancel_iff
tff(fact_2131_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [I: num,N: nat,Xa: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I)),N)),aa(nat,A,semiring_1_of_nat(A),Xa))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I)),N)),Xa) ) ) ).

% numeral_power_le_of_nat_cancel_iff
tff(fact_2132_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: nat,I: num,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,semiring_1_of_nat(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),I)),N))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xa),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),I)),N)) ) ) ).

% of_nat_le_numeral_power_cancel_iff
tff(fact_2133_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,Xa)),aa(num,int,numeral_numeral(int),V))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))) ) ) ).

% ceiling_less_numeral
tff(fact_2134_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),V)),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),V)),one_one(A))),Xa) ) ) ).

% numeral_le_ceiling
tff(fact_2135_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),Xa) ) ) ).

% neg_numeral_le_floor
tff(fact_2136_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archim6421214686448440834_floor(A,Xa)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% floor_less_neg_numeral
tff(fact_2137_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archimedean_ceiling(A,Xa)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% ceiling_le_neg_numeral
tff(fact_2138_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: num,N: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)),A2) ) ) ).

% numeral_power_le_of_int_cancel_iff
tff(fact_2139_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,Xa: num,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)) ) ) ).

% of_int_le_numeral_power_cancel_iff
tff(fact_2140_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),Xa) ) ) ).

% neg_numeral_less_ceiling
tff(fact_2141_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: num,N: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)),A2) ) ) ).

% numeral_power_less_of_int_cancel_iff
tff(fact_2142_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,Xa: num,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),Xa)),N))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),Xa)),N)) ) ) ).

% of_int_less_numeral_power_cancel_iff
tff(fact_2143_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Y: int,Xa: num,N: nat] :
          ( ( aa(int,A,ring_1_of_int(A),Y) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa))),N) )
        <=> ( Y = aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Xa))),N) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
tff(fact_2144_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [Xa: num,N: nat,Y: int] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa))),N) = aa(int,A,ring_1_of_int(A),Y) )
        <=> ( aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Xa))),N) = Y ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
tff(fact_2145_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] : ( archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),B2)))) = divide_divide(int,aa(int,int,uminus_uminus(int),one_one(int)),aa(num,int,numeral_numeral(int),B2)) ) ).

% floor_minus_one_divide_eq_div_numeral
tff(fact_2146_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),Xa) ) ) ).

% neg_numeral_less_floor
tff(fact_2147_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))) ) ) ).

% floor_le_neg_numeral
tff(fact_2148_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,V: num] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),archimedean_ceiling(A,Xa)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V)))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))) ) ) ).

% ceiling_less_neg_numeral
tff(fact_2149_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [V: num,Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),V))),archimedean_ceiling(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),one_one(A))),Xa) ) ) ).

% neg_numeral_le_ceiling
tff(fact_2150_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: num,N: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa))),N)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Xa))),N)),A2) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
tff(fact_2151_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,Xa: num,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa))),N))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Xa))),N)) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
tff(fact_2152_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: num,N: nat,A2: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa))),N)),aa(int,A,ring_1_of_int(A),A2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Xa))),N)),A2) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
tff(fact_2153_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: int,Xa: num,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(int,A,ring_1_of_int(A),A2)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa))),N))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),Xa))),N)) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
tff(fact_2154_nat__numeral__as__int,axiom,
    ! [X3: num] : ( aa(num,nat,numeral_numeral(nat),X3) = aa(int,nat,nat2,aa(num,int,numeral_numeral(int),X3)) ) ).

% nat_numeral_as_int
tff(fact_2155_int__ops_I3_J,axiom,
    ! [N: num] : ( aa(nat,int,semiring_1_of_nat(int),aa(num,nat,numeral_numeral(nat),N)) = aa(num,int,numeral_numeral(int),N) ) ).

% int_ops(3)
tff(fact_2156_norm__minus__commute,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),A2)) ) ) ).

% norm_minus_commute
tff(fact_2157_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] : ( zero_zero(A) != aa(num,A,numeral_numeral(A),N) ) ) ).

% zero_neq_numeral
tff(fact_2158_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,N: num] : ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) != aa(num,A,numeral_numeral(A),N) ) ) ).

% neg_numeral_neq_numeral
tff(fact_2159_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [M: num,N: num] : ( aa(num,A,numeral_numeral(A),M) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% numeral_neq_neg_numeral
tff(fact_2160_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,K: num,L: num] : ( divide_divide(A,divide_divide(A,A2,aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) = divide_divide(A,A2,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),times_times(num),K),L))) ) ) ).

% div_mult2_numeral_eq
tff(fact_2161_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: num] : member(A,aa(num,A,numeral_numeral(A),N),ring_1_Ints(A)) ) ).

% Ints_numeral
tff(fact_2162_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),K)),A2) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),A2) ) ) ).

% numeral_add_unfold_funpow
tff(fact_2163_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: num] : ( aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K)) ) ) ).

% of_int_neg_numeral
tff(fact_2164_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
              | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2)
                & ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),A2)
                  | aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) )
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2) ) ) ) ).

% atLeastatMost_psubset_iff
tff(fact_2165_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),K) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(num,nat,numeral_numeral(nat),K)),aa(A,fun(A,A),plus_plus(A),one_one(A))),zero_zero(A)) ) ) ).

% numeral_unfold_funpow
tff(fact_2166_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),zero_zero(real)) ) ).

% norm_not_less_zero
tff(fact_2167_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),real_V7770717601297561774m_norm(A,Xa)) ) ).

% norm_ge_zero
tff(fact_2168_norm__mult,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Xa: A,Y: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,Y)) ) ) ).

% norm_mult
tff(fact_2169_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X6)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M8: nat] :
                ! [M6: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M6)
                 => ! [N5: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N5)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X6,M6)),aa(nat,A,X6,N5)))),E3) ) ) ) ) ) ).

% Cauchy_iff
tff(fact_2170_CauchyI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( ! [E2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
             => ? [M9: nat] :
                ! [M2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M2)
                 => ! [N2: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),N2)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X6,M2)),aa(nat,A,X6,N2)))),E2) ) ) )
         => topolo3814608138187158403Cauchy(A,X6) ) ) ).

% CauchyI
tff(fact_2171_CauchyD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A),E: real] :
          ( topolo3814608138187158403Cauchy(A,X6)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
           => ? [M10: nat] :
              ! [M3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M10),M3)
               => ! [N3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M10),N3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X6,M3)),aa(nat,A,X6,N3)))),E) ) ) ) ) ) ).

% CauchyD
tff(fact_2172_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),zero_zero(A)) ) ).

% not_numeral_le_zero
tff(fact_2173_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),N)) ) ).

% zero_le_numeral
tff(fact_2174_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),N)),zero_zero(A)) ) ).

% not_numeral_less_zero
tff(fact_2175_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),N)) ) ).

% zero_less_numeral
tff(fact_2176_one__le__numeral,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) ) ).

% one_le_numeral
tff(fact_2177_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),N)),one_one(A)) ) ).

% not_numeral_less_one
tff(fact_2178_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) ) ).

% not_numeral_le_neg_numeral
tff(fact_2179_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) ) ).

% neg_numeral_le_numeral
tff(fact_2180_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( zero_zero(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% zero_neq_neg_numeral
tff(fact_2181_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) ) ).

% not_numeral_less_neg_numeral
tff(fact_2182_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num,N: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) ) ).

% neg_numeral_less_numeral
tff(fact_2183_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),Xa)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Xa)),one_one(A)) ) ) ).

% one_plus_numeral_commute
tff(fact_2184_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [W: num,Xa: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,aa(A,fun(A,A),times_times(A),Xa),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))) ) ) ).

% numeral_times_minus_swap
tff(fact_2185_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),N) != aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% numeral_neq_neg_one
tff(fact_2186_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] : ( one_one(A) != aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) ) ) ).

% one_neq_neg_numeral
tff(fact_2187_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),Xa)),Y)) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) ) ) ).

% norm_uminus_minus
tff(fact_2188_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,divide_divide(A,A2,B2)) = divide_divide(real,real_V7770717601297561774m_norm(A,A2),real_V7770717601297561774m_norm(A,B2)) ) ) ) ).

% nonzero_norm_divide
tff(fact_2189_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,N: nat,Z: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),W),N) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),N) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( real_V7770717601297561774m_norm(A,W) = real_V7770717601297561774m_norm(A,Z) ) ) ) ) ).

% power_eq_imp_eq_norm
tff(fact_2190_norm__mult__less,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Xa: A,R: real,Y: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Y)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y))),aa(real,real,aa(real,fun(real,real),times_times(real),R),S)) ) ) ) ).

% norm_mult_less
tff(fact_2191_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Xa: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,Y))) ) ).

% norm_mult_ineq
tff(fact_2192_norm__add__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,R: real,Y: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Y)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R),S)) ) ) ) ).

% norm_add_less
tff(fact_2193_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,Y))),E)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))),E) ) ) ).

% norm_triangle_lt
tff(fact_2194_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,R: real,B2: A,S: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,A2)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),S)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),R),S)) ) ) ) ).

% norm_triangle_mono
tff(fact_2195_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,Y))) ) ).

% norm_triangle_ineq
tff(fact_2196_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,Y))),E)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))),E) ) ) ).

% norm_triangle_le
tff(fact_2197_norm__add__leD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))),C2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,B2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,A2)),C2)) ) ) ).

% norm_add_leD
tff(fact_2198_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A,E1: real,Z: A,E22: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y))),E1)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z))),E22)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22)) ) ) ) ).

% norm_diff_triangle_less
tff(fact_2199_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Xa: A,N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(A,Xa)),N)) ) ).

% norm_power_ineq
tff(fact_2200_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,Y))),E)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y))),E) ) ) ).

% norm_triangle_le_diff
tff(fact_2201_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A,E1: real,Z: A,E22: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y))),E1)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z))),E22)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),E1),E22)) ) ) ) ).

% norm_diff_triangle_le
tff(fact_2202_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2))) ) ).

% norm_triangle_ineq4
tff(fact_2203_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Xa)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,Y)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)))) ) ).

% norm_triangle_sub
tff(fact_2204_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) ) ).

% not_zero_le_neg_numeral
tff(fact_2205_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))),zero_zero(A)) ) ).

% neg_numeral_le_zero
tff(fact_2206_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))),zero_zero(A)) ) ).

% neg_numeral_less_zero
tff(fact_2207_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) ) ).

% not_zero_less_neg_numeral
tff(fact_2208_bset_I1_J,axiom,
    ! [D3: int,B3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb2: int] :
                  ( member(int,Xb2,B3)
                 => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D3)) ) )
     => ( ! [X: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb2: int] :
                    ( member(int,Xb2,B3)
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D3)) ) )
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
           => ( ( aa(int,$o,P,X3)
                & aa(int,$o,Q,X3) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3))
                & aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)) ) ) ) ) ) ).

% bset(1)
tff(fact_2209_bset_I2_J,axiom,
    ! [D3: int,B3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb2: int] :
                  ( member(int,Xb2,B3)
                 => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D3)) ) )
     => ( ! [X: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb2: int] :
                    ( member(int,Xb2,B3)
                   => ( X != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),D3)) ) )
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
           => ( ( aa(int,$o,P,X3)
                | aa(int,$o,Q,X3) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3))
                | aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)) ) ) ) ) ) ).

% bset(2)
tff(fact_2210_aset_I1_J,axiom,
    ! [D3: int,A3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb2: int] :
                  ( member(int,Xb2,A3)
                 => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D3)) ) )
     => ( ! [X: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb2: int] :
                    ( member(int,Xb2,A3)
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D3)) ) )
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
           => ( ( aa(int,$o,P,X3)
                & aa(int,$o,Q,X3) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3))
                & aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)) ) ) ) ) ) ).

% aset(1)
tff(fact_2211_aset_I2_J,axiom,
    ! [D3: int,A3: set(int),P: fun(int,$o),Q: fun(int,$o)] :
      ( ! [X: int] :
          ( ! [Xa2: int] :
              ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb2: int] :
                  ( member(int,Xb2,A3)
                 => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
         => ( aa(int,$o,P,X)
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D3)) ) )
     => ( ! [X: int] :
            ( ! [Xa2: int] :
                ( member(int,Xa2,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb2: int] :
                    ( member(int,Xb2,A3)
                   => ( X != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb2),Xa2) ) ) )
           => ( aa(int,$o,Q,X)
             => aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X),D3)) ) )
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
           => ( ( aa(int,$o,P,X3)
                | aa(int,$o,Q,X3) )
             => ( aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3))
                | aa(int,$o,Q,aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)) ) ) ) ) ) ).

% aset(2)
tff(fact_2212_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))) ) ).

% norm_diff_ineq
tff(fact_2213_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(num,A,numeral_numeral(A),W) = divide_divide(A,B2,C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2) = B2,aa(num,A,numeral_numeral(A),W) = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral(1)
tff(fact_2214_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( divide_divide(A,B2,C2) = aa(num,A,numeral_numeral(A),W) )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2),aa(num,A,numeral_numeral(A),W) = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral(1)
tff(fact_2215_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% norm_triangle_ineq2
tff(fact_2216_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) ) ).

% not_one_le_neg_numeral
tff(fact_2217_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_numeral_le_neg_one
tff(fact_2218_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% neg_numeral_le_neg_one
tff(fact_2219_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M)) ) ).

% neg_one_le_numeral
tff(fact_2220_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) ) ).

% neg_numeral_le_one
tff(fact_2221_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) ) ).

% neg_numeral_less_one
tff(fact_2222_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),M)) ) ).

% neg_one_less_numeral
tff(fact_2223_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_numeral_less_neg_one
tff(fact_2224_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) ) ).

% not_one_less_neg_numeral
tff(fact_2225_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) ) ).

% not_neg_one_less_neg_numeral
tff(fact_2226_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: A] :
          ( ( A2 != zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),A2)) = aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,A2)) ) ) ) ).

% nonzero_norm_inverse
tff(fact_2227_norm__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Xa))),aa(real,real,exp(real),real_V7770717601297561774m_norm(A,Xa))) ) ).

% norm_exp
tff(fact_2228_powr__neg__numeral,axiom,
    ! [Xa: real,N: num] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),N))) = divide_divide(real,one_one(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% powr_neg_numeral
tff(fact_2229_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [W: A,N: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),W),N) = one_one(A) )
         => ( ( real_V7770717601297561774m_norm(A,W) = one_one(real) )
            | ( N = zero_zero(nat) ) ) ) ) ).

% power_eq_1_iff
tff(fact_2230_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: A,D2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),D2)))),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),C2))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)))) ) ).

% norm_diff_triangle_ineq
tff(fact_2231_norm__sgn,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] :
          ( real_V7770717601297561774m_norm(A,aa(A,A,sgn_sgn(A),Xa))
          = $ite(Xa = zero_zero(A),zero_zero(real),one_one(real)) ) ) ).

% norm_sgn
tff(fact_2232_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),W)),divide_divide(A,B2,C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ).

% less_divide_eq_numeral(1)
tff(fact_2233_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,C2)),aa(num,A,numeral_numeral(A),W))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ).

% divide_less_eq_numeral(1)
tff(fact_2234_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [W: num,B2: A,C2: A] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = divide_divide(A,B2,C2) )
        <=> $ite(C2 != zero_zero(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2) = B2,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A)) ) ) ).

% eq_divide_eq_numeral(2)
tff(fact_2235_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [B2: A,C2: A,W: num] :
          ( ( divide_divide(A,B2,C2) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) )
        <=> $ite(C2 != zero_zero(A),B2 = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)) = zero_zero(A)) ) ) ).

% divide_eq_eq_numeral(2)
tff(fact_2236_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(A,A2)),real_V7770717601297561774m_norm(A,B2)))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))) ) ).

% norm_triangle_ineq3
tff(fact_2237_periodic__finite__ex,axiom,
    ! [D2: int,P: fun(int,$o)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D2)
     => ( ! [X: int,K3: int] :
            ( aa(int,$o,P,X)
          <=> aa(int,$o,P,aa(int,int,aa(int,fun(int,int),minus_minus(int),X),aa(int,int,aa(int,fun(int,int),times_times(int),K3),D2))) )
       => ( ? [X_12: int] : aa(int,$o,P,X_12)
        <=> ? [X4: int] :
              ( member(int,X4,set_or1337092689740270186AtMost(int,one_one(int),D2))
              & aa(int,$o,P,X4) ) ) ) ) ).

% periodic_finite_ex
tff(fact_2238_bset_I3_J,axiom,
    ! [D3: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int)),B3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
           => ( ( X3 = T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3) = T2 ) ) ) ) ) ).

% bset(3)
tff(fact_2239_bset_I4_J,axiom,
    ! [D3: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,T2,B3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
           => ( ( X3 != T2 )
             => ( aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3) != T2 ) ) ) ) ) ).

% bset(4)
tff(fact_2240_bset_I5_J,axiom,
    ! [D3: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X3),T2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)),T2) ) ) ) ).

% bset(5)
tff(fact_2241_bset_I7_J,axiom,
    ! [D3: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,T2,B3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),X3)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)) ) ) ) ) ).

% bset(7)
tff(fact_2242_aset_I3_J,axiom,
    ! [D3: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int)),A3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
           => ( ( X3 = T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3) = T2 ) ) ) ) ) ).

% aset(3)
tff(fact_2243_aset_I4_J,axiom,
    ! [D3: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,T2,A3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
           => ( ( X3 != T2 )
             => ( aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3) != T2 ) ) ) ) ) ).

% aset(4)
tff(fact_2244_aset_I5_J,axiom,
    ! [D3: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,T2,A3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),X3),T2)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)),T2) ) ) ) ) ).

% aset(5)
tff(fact_2245_aset_I7_J,axiom,
    ! [D3: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),X3)
           => aa(int,$o,aa(int,fun(int,$o),ord_less(int),T2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)) ) ) ) ).

% aset(7)
tff(fact_2246_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X6: fun(A,B)] :
          ( ? [K5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K5)
              & ! [N5: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X6,N5))),K5) )
        <=> ? [N7: nat] :
            ! [N5: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X6,N5))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N7))) ) ) ).

% lemma_NBseq_def
tff(fact_2247_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [X6: fun(A,B)] :
          ( ? [K5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K5)
              & ! [N5: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,X6,N5))),K5) )
        <=> ? [N7: nat] :
            ! [N5: A] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,X6,N5))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N7))) ) ) ).

% lemma_NBseq_def2
tff(fact_2248_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,B2,C2)),aa(num,A,numeral_numeral(A),W))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(num,A,numeral_numeral(A),W))) ) ) ) ).

% divide_le_eq_numeral(1)
tff(fact_2249_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),divide_divide(A,B2,C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),W)),zero_zero(A))) ) ) ) ).

% le_divide_eq_numeral(1)
tff(fact_2250_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [W: num,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),divide_divide(A,B2,C2))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),zero_zero(A))) ) ) ) ).

% less_divide_eq_numeral(2)
tff(fact_2251_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [B2: A,C2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),divide_divide(A,B2,C2)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),C2),zero_zero(A)),aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),C2)),B2),aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))) ) ) ) ).

% divide_less_eq_numeral(2)
tff(fact_2252_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [R: real,Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),R),real_V7770717601297561774m_norm(A,Xa))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,inverse_inverse(A),Xa))),aa(real,real,inverse_inverse(real),R)) ) ) ) ).

% norm_inverse_le_norm
tff(fact_2253_bset_I6_J,axiom,
    ! [D3: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X3),T2)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)),T2) ) ) ) ).

% bset(6)
tff(fact_2254_bset_I8_J,axiom,
    ! [D3: int,T2: int,B3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),T2),one_one(int)),B3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,B3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),X3)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),T2),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)) ) ) ) ) ).

% bset(8)
tff(fact_2255_aset_I6_J,axiom,
    ! [D3: int,T2: int,A3: set(int)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),D3)
     => ( member(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),T2),one_one(int)),A3)
       => ! [X3: int] :
            ( ! [Xa4: int] :
                ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
               => ! [Xb3: int] :
                    ( member(int,Xb3,A3)
                   => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X3),T2)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)),T2) ) ) ) ) ).

% aset(6)
tff(fact_2256_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),aa(num,extended_enat,numeral_numeral(extended_enat),N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N)) ) ).

% enat_ord_number(1)
tff(fact_2257_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [H: A,Z: A,K6: real,N: nat] :
          ( ( H != zero_zero(A) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),K6)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H))),K6)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),N)),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),K6),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),real_V7770717601297561774m_norm(A,H))) ) ) ) ) ).

% lemma_termdiff3
tff(fact_2258_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( ? [K7: real] :
            ! [X: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K7))
         => real_V4916620083959148203axioms(A,B,F3) ) ) ).

% bounded_linear_axioms.intro
tff(fact_2259_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V4916620083959148203axioms(A,B,F3)
        <=> ? [K5: real] :
            ! [X4: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X4))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X4)),K5)) ) ) ).

% bounded_linear_axioms_def
tff(fact_2260_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),B2),A2))),real_V7770717601297561774m_norm(complex,B2))),real_V7770717601297561774m_norm(complex,A2)) ).

% complex_mod_triangle_ineq2
tff(fact_2261_complex__mod__minus__le__complex__mod,axiom,
    ! [Xa: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),real_V7770717601297561774m_norm(complex,Xa))),real_V7770717601297561774m_norm(complex,Xa)) ).

% complex_mod_minus_le_complex_mod
tff(fact_2262_power__numeral,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num,L: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),K)),aa(num,nat,numeral_numeral(nat),L)) = aa(num,A,numeral_numeral(A),pow(K,L)) ) ) ).

% power_numeral
tff(fact_2263_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0(M) = bit0(N) )
    <=> ( M = N ) ) ).

% semiring_norm(87)
tff(fact_2264_verit__eq__simplify_I8_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( bit0(X2) = bit0(Y2) )
    <=> ( X2 = Y2 ) ) ).

% verit_eq_simplify(8)
tff(fact_2265_semiring__norm_I83_J,axiom,
    ! [N: num] : ( one2 != bit0(N) ) ).

% semiring_norm(83)
tff(fact_2266_semiring__norm_I85_J,axiom,
    ! [M: num] : ( bit0(M) != one2 ) ).

% semiring_norm(85)
tff(fact_2267_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit0(M)),bit0(N)) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ).

% semiring_norm(6)
tff(fact_2268_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit0(M)),bit0(N)) = bit0(bit0(aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ).

% semiring_norm(13)
tff(fact_2269_semiring__norm_I11_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),M),one2) = M ) ).

% semiring_norm(11)
tff(fact_2270_semiring__norm_I12_J,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),one2),N) = N ) ).

% semiring_norm(12)
tff(fact_2271_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),bit0(M)),bit0(N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),N) ) ).

% semiring_norm(71)
tff(fact_2272_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),bit0(M)),bit0(N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N) ) ).

% semiring_norm(78)
tff(fact_2273_semiring__norm_I68_J,axiom,
    ! [N: num] : aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),one2),N) ).

% semiring_norm(68)
tff(fact_2274_semiring__norm_I75_J,axiom,
    ! [M: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),one2) ).

% semiring_norm(75)
tff(fact_2275_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),N) )
        <=> ( one2 = N ) ) ) ).

% one_eq_numeral_iff
tff(fact_2276_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: num] :
          ( ( aa(num,A,numeral_numeral(A),N) = one_one(A) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_one_iff
tff(fact_2277_semiring__norm_I2_J,axiom,
    aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),one2) = bit0(one2) ).

% semiring_norm(2)
tff(fact_2278_num__double,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit0(one2)),N) = bit0(N) ) ).

% num_double
tff(fact_2279_semiring__norm_I69_J,axiom,
    ! [M: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),bit0(M)),one2) ).

% semiring_norm(69)
tff(fact_2280_semiring__norm_I76_J,axiom,
    ! [N: num] : aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),bit0(N)) ).

% semiring_norm(76)
tff(fact_2281_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) )
        <=> ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
tff(fact_2282_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [N: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
tff(fact_2283_Suc__numeral,axiom,
    ! [N: num] : ( aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),N)) = aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ).

% Suc_numeral
tff(fact_2284_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)))
        <=> ( M != one2 ) ) ) ).

% not_neg_one_le_neg_numeral_iff
tff(fact_2285_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A)))
        <=> ( M != one2 ) ) ) ).

% neg_numeral_less_neg_one_iff
tff(fact_2286_one__add__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),one_one(A)) = aa(num,A,numeral_numeral(A),bit0(one2)) ) ) ).

% one_add_one
tff(fact_2287_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( semiri2026040879449505780visors(A)
     => ! [A2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% zero_eq_power2
tff(fact_2288_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% bits_one_mod_two_eq_one
tff(fact_2289_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% one_mod_two_eq_one
tff(fact_2290_power2__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power2_minus
tff(fact_2291_add__2__eq__Suc,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) = aa(nat,nat,suc,aa(nat,nat,suc,N)) ) ).

% add_2_eq_Suc
tff(fact_2292_add__2__eq__Suc_H,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,suc,aa(nat,nat,suc,N)) ) ).

% add_2_eq_Suc'
tff(fact_2293_abs__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% abs_power2
tff(fact_2294_power2__abs,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,abs_abs(A),A2)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power2_abs
tff(fact_2295_Suc__1,axiom,
    aa(nat,nat,suc,one_one(nat)) = aa(num,nat,numeral_numeral(nat),bit0(one2)) ).

% Suc_1
tff(fact_2296_div2__Suc__Suc,axiom,
    ! [M: nat] : ( divide_divide(nat,aa(nat,nat,suc,aa(nat,nat,suc,M)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,suc,divide_divide(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% div2_Suc_Suc
tff(fact_2297_mod2__Suc__Suc,axiom,
    ! [M: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,M)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% mod2_Suc_Suc
tff(fact_2298_add__self__div__2,axiom,
    ! [M: nat] : ( divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),M),aa(num,nat,numeral_numeral(nat),bit0(one2))) = M ) ).

% add_self_div_2
tff(fact_2299_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% one_plus_numeral
tff(fact_2300_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ) ).

% numeral_plus_one
tff(fact_2301_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),N)),one_one(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),N),one2) ) ) ).

% numeral_le_one_iff
tff(fact_2302_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [N: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),aa(num,A,numeral_numeral(A),N))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),N) ) ) ).

% one_less_numeral_iff
tff(fact_2303_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),bit0(V)),aa(num,int,numeral_numeral(int),bit0(W))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W))) ) ).

% zmod_numeral_Bit0
tff(fact_2304_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ).

% one_div_two_eq_zero
tff(fact_2305_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ).

% bits_1_div_2
tff(fact_2306_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% add_neg_numeral_special(9)
tff(fact_2307_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))) )
            <=> ( Xa = Y ) ) ) ) ) ).

% power2_eq_iff_nonneg
tff(fact_2308_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),zero_zero(A))
        <=> ( A2 = zero_zero(A) ) ) ) ).

% power2_less_eq_zero_iff
tff(fact_2309_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),bit0(one2)) ) ) ).

% diff_numeral_special(11)
tff(fact_2310_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% diff_numeral_special(10)
tff(fact_2311_zero__less__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2))))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% zero_less_power2
tff(fact_2312_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( divide_divide(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% minus_1_div_2_eq
tff(fact_2313_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = zero_zero(A) )
        <=> ( ( Xa = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_power2_eq_zero_iff
tff(fact_2314_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) != one_one(A) )
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ) ).

% not_mod_2_eq_1_eq_0
tff(fact_2315_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) != zero_zero(A) )
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ) ).

% not_mod_2_eq_0_eq_1
tff(fact_2316_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% bits_minus_1_mod_2_eq
tff(fact_2317_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( euclid8789492081693882211th_nat(A)
     => ( modulo_modulo(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ).

% minus_1_mod_2_eq
tff(fact_2318_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ) ).

% Power.ring_1_class.power_minus_even
tff(fact_2319_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) != aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(nat) ) ) ).

% not_mod2_eq_Suc_0_eq_0
tff(fact_2320_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),one2))) ) ) ).

% diff_numeral_special(4)
tff(fact_2321_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N)) ) ) ).

% diff_numeral_special(3)
tff(fact_2322_add__self__mod__2,axiom,
    ! [M: nat] : ( modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),M),aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(nat) ) ).

% add_self_mod_2
tff(fact_2323_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2))))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% half_nonnegative_int_iff
tff(fact_2324_half__negative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% half_negative_int_iff
tff(fact_2325_real__average__minus__first,axiom,
    ! [A2: real,B2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2),aa(num,real,numeral_numeral(real),bit0(one2)))),A2) = divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2),aa(num,real,numeral_numeral(real),bit0(one2))) ) ).

% real_average_minus_first
tff(fact_2326_real__average__minus__second,axiom,
    ! [B2: real,A2: real] : ( aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),A2),aa(num,real,numeral_numeral(real),bit0(one2)))),A2) = divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2),aa(num,real,numeral_numeral(real),bit0(one2))) ) ).

% real_average_minus_second
tff(fact_2327_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = one_one(A) ) ) ).

% power_minus1_even
tff(fact_2328_one__less__floor,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),one_one(int)),archim6421214686448440834_floor(A,Xa))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa) ) ) ).

% one_less_floor
tff(fact_2329_floor__le__one,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),archim6421214686448440834_floor(A,Xa)),one_one(int))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% floor_le_one
tff(fact_2330_mod2__gr__0,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2))))
    <=> ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(nat) ) ) ).

% mod2_gr_0
tff(fact_2331_square__powr__half,axiom,
    ! [Xa: real] : ( aa(real,real,aa(real,fun(real,real),powr(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))) = aa(real,real,abs_abs(real),Xa) ) ).

% square_powr_half
tff(fact_2332_le__num__One__iff,axiom,
    ! [Xa: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),Xa),one2)
    <=> ( Xa = one2 ) ) ).

% le_num_One_iff
tff(fact_2333_i0__lb,axiom,
    ! [N: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),zero_zero(extended_enat)),N) ).

% i0_lb
tff(fact_2334_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),N),zero_zero(extended_enat))
    <=> ( N = zero_zero(extended_enat) ) ) ).

% ile0_eq
tff(fact_2335_add__One__commute,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),N) = aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2) ) ).

% add_One_commute
tff(fact_2336_verit__eq__simplify_I10_J,axiom,
    ! [X2: num] : ( one2 != bit0(X2) ) ).

% verit_eq_simplify(10)
tff(fact_2337_pow_Osimps_I1_J,axiom,
    ! [Xa: num] : ( pow(Xa,one2) = Xa ) ).

% pow.simps(1)
tff(fact_2338_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y: extended_enat,Xa: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Z),Y)
     => ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Xa),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),Y),Z)) = aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Xa),Y)),Z) ) ) ).

% add_diff_assoc_enat
tff(fact_2339_zero__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = zero_zero(A) ) ) ).

% zero_power2
tff(fact_2340_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xa: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Xa)),Xa)),Xa) ) ) ).

% power4_eq_xxxx
tff(fact_2341_power2__eq__square,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2) ) ) ).

% power2_eq_square
tff(fact_2342_one__power2,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),one_one(A)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) ) ) ).

% one_power2
tff(fact_2343_power2__commute,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Xa: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power2_commute
tff(fact_2344_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))) )
        <=> ( ( Xa = Y )
            | ( Xa = aa(A,A,uminus_uminus(A),Y) ) ) ) ) ).

% power2_eq_iff
tff(fact_2345_numeral__2__eq__2,axiom,
    aa(num,nat,numeral_numeral(nat),bit0(one2)) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% numeral_2_eq_2
tff(fact_2346_pos2,axiom,
    aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ).

% pos2
tff(fact_2347_power__even__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% power_even_eq
tff(fact_2348_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M) != aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% double_not_eq_Suc_double
tff(fact_2349_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)) != aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% Suc_double_not_eq_double
tff(fact_2350_nat__1__add__1,axiom,
    aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),one_one(nat)),one_one(nat)) = aa(num,nat,numeral_numeral(nat),bit0(one2)) ).

% nat_1_add_1
tff(fact_2351_four__x__squared,axiom,
    ! [Xa: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% four_x_squared
tff(fact_2352_less__exp,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ).

% less_exp
tff(fact_2353_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% power2_nat_le_imp_le
tff(fact_2354_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),M),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2))))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% power2_nat_le_eq_le
tff(fact_2355_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),M)) ) ).

% self_le_ge2_pow
tff(fact_2356_numerals_I1_J,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = one_one(nat) ).

% numerals(1)
tff(fact_2357_zero__le__power2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% zero_le_power2
tff(fact_2358_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
             => ( Xa = Y ) ) ) ) ) ).

% power2_eq_imp_eq
tff(fact_2359_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ).

% power2_le_imp_le
tff(fact_2360_power2__less__0,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),zero_zero(A)) ) ).

% power2_less_0
tff(fact_2361_mult__2,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Z) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2
tff(fact_2362_mult__2__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Z),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Z) ) ) ).

% mult_2_right
tff(fact_2363_left__add__twice,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)),B2) ) ) ).

% left_add_twice
tff(fact_2364_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,Xa,aa(num,A,numeral_numeral(A),bit0(one2)))),divide_divide(A,Xa,aa(num,A,numeral_numeral(A),bit0(one2)))) = Xa ) ) ).

% field_sum_of_halves
tff(fact_2365_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ring_15535105094025558882visors(A)
     => ! [A2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) )
        <=> ( ( A2 = one_one(A) )
            | ( A2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% power2_eq_1_iff
tff(fact_2366_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),Xa)),aa(A,A,abs_abs(A),Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% abs_le_square_iff
tff(fact_2367_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))
    <=> ( ( N = zero_zero(nat) )
        | ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases_iff
tff(fact_2368_less__2__cases,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))
     => ( ( N = zero_zero(nat) )
        | ( N = aa(nat,nat,suc,zero_zero(nat)) ) ) ) ).

% less_2_cases
tff(fact_2369_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) )
        <=> ( aa(A,A,abs_abs(A),Xa) = one_one(A) ) ) ) ).

% abs_square_eq_1
tff(fact_2370_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: fun(A,fun(A,$o)),Xa: A] :
          ( ! [X: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X)
             => aa(A,$o,aa(A,fun(A,$o),P,X),aa(nat,A,aa(A,fun(nat,A),power_power(A),X),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
         => aa(A,$o,aa(A,fun(A,$o),P,aa(A,A,abs_abs(A),Xa)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% abs_sqrt_wlog
tff(fact_2371_nat__2,axiom,
    aa(int,nat,nat2,aa(num,int,numeral_numeral(int),bit0(one2))) = aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))) ).

% nat_2
tff(fact_2372_nat__induct2,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( aa(nat,$o,P,one_one(nat))
       => ( ! [N2: nat] :
              ( aa(nat,$o,P,N2)
             => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) )
         => aa(nat,$o,P,N) ) ) ) ).

% nat_induct2
tff(fact_2373_two__realpow__ge__one,axiom,
    ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),bit0(one2))),N)) ).

% two_realpow_ge_one
tff(fact_2374_square__fact__le__2__fact,axiom,
    ! [N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),semiring_char_0_fact(real,N)),semiring_char_0_fact(real,N))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ).

% square_fact_le_2_fact
tff(fact_2375_realpow__square__minus__le,axiom,
    ! [U: real,Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),U),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ).

% realpow_square_minus_le
tff(fact_2376_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),N))) ) ).

% diff_le_diff_pow
tff(fact_2377_ln__2__less__1,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),bit0(one2)))),one_one(real)) ).

% ln_2_less_1
tff(fact_2378_not__exp__less__eq__0__int,axiom,
    ! [N: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),zero_zero(int)) ).

% not_exp_less_eq_0_int
tff(fact_2379_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) )
     => ( aa(nat,real,semiring_1_of_nat(real),N) = aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M)) ) ) ).

% log2_of_power_eq
tff(fact_2380_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y) ) ) ) ).

% power2_less_imp_less
tff(fact_2381_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ).

% half_gt_zero_iff
tff(fact_2382_half__gt__zero,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% half_gt_zero
tff(fact_2383_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% sum_power2_ge_zero
tff(fact_2384_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))),zero_zero(A))
        <=> ( ( Xa = zero_zero(A) )
            & ( Y = zero_zero(A) ) ) ) ) ).

% sum_power2_le_zero_iff
tff(fact_2385_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))
        <=> ( ( Xa != zero_zero(A) )
            | ( Y != zero_zero(A) ) ) ) ) ).

% sum_power2_gt_zero_iff
tff(fact_2386_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A] : ~ aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))),zero_zero(A)) ) ).

% not_sum_power2_lt_zero
tff(fact_2387_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% field_less_half_sum
tff(fact_2388_power2__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Xa: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)),Y)) ) ) ).

% power2_sum
tff(fact_2389_square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),one_one(A))),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)) ) ) ) ).

% square_le_1
tff(fact_2390_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),Xa)),Y) ) ) ) ).

% power2_le_iff_abs_le
tff(fact_2391_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ).

% of_nat_less_two_power
tff(fact_2392_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_right
tff(fact_2393_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M) != zero_zero(A) ) ) ) ).

% exp_add_not_zero_imp_left
tff(fact_2394_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% zero_le_even_power'
tff(fact_2395_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat,M: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) != zero_zero(A) )
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) != zero_zero(A) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
tff(fact_2396_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),Xa)),one_one(A)) ) ) ).

% abs_square_le_1
tff(fact_2397_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),Xa)),one_one(A)) ) ) ).

% abs_square_less_1
tff(fact_2398_div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,M: nat,N: nat] : ( divide_divide(A,divide_divide(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = divide_divide(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ) ) ).

% div_exp_eq
tff(fact_2399_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),A2)),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ) ).

% minus_power_mult_self
tff(fact_2400_ex__nat__less,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ? [M6: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M6),N)
          & aa(nat,$o,P,M6) )
    <=> ? [X4: nat] :
          ( member(nat,X4,set_or1337092689740270186AtMost(nat,zero_zero(nat),N))
          & aa(nat,$o,P,X4) ) ) ).

% ex_nat_less
tff(fact_2401_all__nat__less,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ! [M6: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M6),N)
         => aa(nat,$o,P,M6) )
    <=> ! [X4: nat] :
          ( member(nat,X4,set_or1337092689740270186AtMost(nat,zero_zero(nat),N))
         => aa(nat,$o,P,X4) ) ) ).

% all_nat_less
tff(fact_2402_power__odd__eq,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% power_odd_eq
tff(fact_2403_exp__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] : ( aa(A,A,exp(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Z)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% exp_double
tff(fact_2404_nat__bit__induct,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ! [N2: nat] :
            ( aa(nat,$o,P,N2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
             => aa(nat,$o,P,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2)) ) )
       => ( ! [N2: nat] :
              ( aa(nat,$o,P,N2)
             => aa(nat,$o,P,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2))) )
         => aa(nat,$o,P,N) ) ) ) ).

% nat_bit_induct
tff(fact_2405_square__norm__one,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Xa: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))) = one_one(A) )
         => ( real_V7770717601297561774m_norm(A,Xa) = one_one(real) ) ) ) ).

% square_norm_one
tff(fact_2406_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),divide_divide(nat,aa(nat,nat,suc,N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% Suc_n_div_2_gt_zero
tff(fact_2407_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% div_2_gt_zero
tff(fact_2408_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,aa(real,fun(real,real),times_times(real),A2),C2))),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),D2),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),C2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ).

% L2_set_mult_ineq_lemma
tff(fact_2409_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bit0(N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N)) ) ) ).

% numeral_Bit0
tff(fact_2410_exp__half__le2,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% exp_half_le2
tff(fact_2411_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: A,K: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(K))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(K))) ) ) ).

% power_minus_Bit0
tff(fact_2412_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] : ( divide_divide(int,aa(int,int,uminus_uminus(int),one_one(int)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% minus_1_div_exp_eq_int
tff(fact_2413_exp__plus__inverse__exp,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,exp(real),Xa)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),Xa)))) ).

% exp_plus_inverse_exp
tff(fact_2414_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),one2)) = A2 ) ) ).

% mult_numeral_1_right
tff(fact_2415_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),one2)),A2) = A2 ) ) ).

% mult_numeral_1
tff(fact_2416_numeral__One,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ( aa(num,A,numeral_numeral(A),one2) = one_one(A) ) ) ).

% numeral_One
tff(fact_2417_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] : ( divide_divide(A,A2,aa(num,A,numeral_numeral(A),one2)) = A2 ) ) ).

% divide_numeral_1
tff(fact_2418_numeral__1__eq__Suc__0,axiom,
    aa(num,nat,numeral_numeral(nat),one2) = aa(nat,nat,suc,zero_zero(nat)) ).

% numeral_1_eq_Suc_0
tff(fact_2419_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] : ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,aa(num,fun(num,num),plus_plus(num),V),one2))),N) ) ).

% Suc_nat_number_of_add
tff(fact_2420_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ( aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),one2)) = aa(num,A,numeral_numeral(A),one2) ) ) ).

% inverse_numeral_1
tff(fact_2421_triangle__def,axiom,
    ! [N: nat] : ( nat_triangle(N) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% triangle_def
tff(fact_2422_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% sum_squares_bound
tff(fact_2423_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),B2)
           => ( modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)) = modulo_modulo(A,A2,B2) ) ) ) ) ).

% divmod_digit_0(2)
tff(fact_2424_power2__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Xa: A,Y: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)),Y)) ) ) ).

% power2_diff
tff(fact_2425_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( ( divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) = A2 )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))) = zero_zero(A) ) ) ) ).

% bits_stable_imp_add_self
tff(fact_2426_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ).

% odd_0_le_power_imp_0_le
tff(fact_2427_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A))
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),zero_zero(A)) ) ) ).

% odd_power_less_zero
tff(fact_2428_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% power_minus1_odd
tff(fact_2429_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat,M: nat] : ( modulo_modulo(A,divide_divide(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) = divide_divide(A,modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% div_exp_mod_exp_eq
tff(fact_2430_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)
       => ? [N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N2)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),one_one(nat)))) ) ) ) ).

% ex_power_ivl2
tff(fact_2431_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),K)
       => ? [N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N2)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),one_one(nat)))) ) ) ) ).

% ex_power_ivl1
tff(fact_2432_plus__inverse__ge__2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,inverse_inverse(real),Xa))) ) ).

% plus_inverse_ge_2
tff(fact_2433_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ).

% exp_bound_half
tff(fact_2434_int__bit__induct,axiom,
    ! [P: fun(int,$o),K: int] :
      ( aa(int,$o,P,zero_zero(int))
     => ( aa(int,$o,P,aa(int,int,uminus_uminus(int),one_one(int)))
       => ( ! [K3: int] :
              ( aa(int,$o,P,K3)
             => ( ( K3 != zero_zero(int) )
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),times_times(int),K3),aa(num,int,numeral_numeral(int),bit0(one2)))) ) )
         => ( ! [K3: int] :
                ( aa(int,$o,P,K3)
               => ( ( K3 != aa(int,int,uminus_uminus(int),one_one(int)) )
                 => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),K3),aa(num,int,numeral_numeral(int),bit0(one2))))) ) )
           => aa(int,$o,P,K) ) ) ) ) ).

% int_bit_induct
tff(fact_2435_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),M)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M))) ) ).

% less_log2_of_power
tff(fact_2436_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),M)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M))) ) ).

% le_log2_of_power
tff(fact_2437_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),B2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))) = divide_divide(A,A2,B2) ) ) ) ) ).

% divmod_digit_0(1)
tff(fact_2438_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) ) ) ) ).

% mult_exp_mod_exp_eq
tff(fact_2439_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,cosh(A),Xa) = zero_zero(A) )
        <=> ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,exp(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% cosh_zero_iff
tff(fact_2440_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num,Q2: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),bit0(N)),aa(num,A,numeral_numeral(A),bit0(Q2))) = zero_zero(A) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(2)
tff(fact_2441_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( aa(A,A,cosh(A),Z) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% cosh_field_def
tff(fact_2442_exp__bound,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Xa)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% exp_bound
tff(fact_2443_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ).

% log2_of_power_less
tff(fact_2444_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( divide_divide(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A2)) = divide_divide(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int)),A2) ) ) ).

% neg_zdiv_mult_2
tff(fact_2445_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( divide_divide(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A2)) = divide_divide(int,B2,A2) ) ) ).

% pos_zdiv_mult_2
tff(fact_2446_round__def,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : ( archimedean_round(A,Xa) = archim6421214686448440834_floor(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% round_def
tff(fact_2447_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2)
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A2)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,B2,A2))) ) ) ).

% pos_zmod_mult_2
tff(fact_2448_real__le__x__sinh,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),Xa)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),Xa))),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ).

% real_le_x_sinh
tff(fact_2449_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(2)
tff(fact_2450_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))),B2) = aa(A,A,uminus_uminus(A),B2) ) ) ).

% mult_1s_ring_1(1)
tff(fact_2451_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% uminus_numeral_One
tff(fact_2452_real__le__abs__sinh,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),aa(real,real,abs_abs(real),divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,exp(real),Xa)),aa(real,real,inverse_inverse(real),aa(real,real,exp(real),Xa))),aa(num,real,numeral_numeral(real),bit0(one2))))) ).

% real_le_abs_sinh
tff(fact_2453_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),one2)) = zero_zero(A) ) ) ).

% cong_exp_iff_simps(1)
tff(fact_2454_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [U: A,Xa: A,Y: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),U),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Y)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ) ) ).

% arith_geo_mean
tff(fact_2455_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
           => ( ( modulo_modulo(A,Xa,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) = modulo_modulo(A,Xa,M) )
              | ( modulo_modulo(A,Xa,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,Xa,M)),M) ) ) ) ) ) ).

% mod_double_modulus
tff(fact_2456_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)))
             => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),B2) = modulo_modulo(A,A2,B2) ) ) ) ) ) ).

% divmod_digit_1(2)
tff(fact_2457_of__int__round__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,Xa))),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ).

% of_int_round_le
tff(fact_2458_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,Xa))) ) ).

% of_int_round_ge
tff(fact_2459_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(int,A,ring_1_of_int(A),archimedean_round(A,Xa))) ) ).

% of_int_round_gt
tff(fact_2460_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,Z)),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,exp(A),Z))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),real_V7770717601297561774m_norm(A,Z)))) ) ) ).

% exp_bound_lemma
tff(fact_2461_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),M))),aa(nat,real,semiring_1_of_nat(real),N)) ) ) ).

% log2_of_power_le
tff(fact_2462_real__exp__bound__lemma,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),Xa)),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),Xa))) ) ) ).

% real_exp_bound_lemma
tff(fact_2463_exp__lower__Taylor__quadratic,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa)),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,exp(real),Xa)) ) ).

% exp_lower_Taylor_quadratic
tff(fact_2464_ln__one__plus__pos__lower__bound,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa))) ) ) ).

% ln_one_plus_pos_lower_bound
tff(fact_2465_artanh__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & ln(A) )
     => ! [Xa: A] : ( aa(A,A,artanh(A),Xa) = divide_divide(A,aa(A,A,ln_ln(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),Xa),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% artanh_def
tff(fact_2466_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int))
     => ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A2)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),B2),one_one(int)),A2))),one_one(int)) ) ) ).

% neg_zmod_mult_2
tff(fact_2467_cosh__ln__real,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,cosh(real),aa(real,real,ln_ln(real),Xa)) = divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,inverse_inverse(real),Xa)),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ).

% cosh_ln_real
tff(fact_2468_floor__log2__div2,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archim6421214686448440834_floor(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))))),one_one(int)) ) ) ).

% floor_log2_div2
tff(fact_2469_fact__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),comm_s3205402744901411588hammer(A,divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))),N))),semiring_char_0_fact(A,N)) ) ) ).

% fact_double
tff(fact_2470_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(int,A,ring_1_of_int(A),archimedean_round(A,Xa))),Xa))),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ).

% of_int_round_abs_le
tff(fact_2471_round__unique_H,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(int,A,ring_1_of_int(A),N)))),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))))
         => ( archimedean_round(A,Xa) = N ) ) ) ).

% round_unique'
tff(fact_2472_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa))),Xa))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
tff(fact_2473_arctan__double,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,arctan,Xa)) = aa(real,real,arctan,divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),Xa),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% arctan_double
tff(fact_2474_round__altdef,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A] :
          ( archimedean_round(A,Xa)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2)))),archimedean_frac(A,Xa)),archimedean_ceiling(A,Xa),archim6421214686448440834_floor(A,Xa)) ) ) ).

% round_altdef
tff(fact_2475_tanh__real__altdef,axiom,
    ! [Xa: real] : ( aa(real,real,tanh(real),Xa) = divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),bit0(one2)))),Xa))),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,exp(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),bit0(one2)))),Xa)))) ) ).

% tanh_real_altdef
tff(fact_2476_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),modulo_modulo(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)))
             => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)))),one_one(A)) = divide_divide(A,A2,B2) ) ) ) ) ) ).

% divmod_digit_1(1)
tff(fact_2477_round__unique,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Xa: A,Y: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2))))),aa(int,A,ring_1_of_int(A),Y))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(int,A,ring_1_of_int(A),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2)))))
           => ( archimedean_round(A,Xa) = Y ) ) ) ) ).

% round_unique
tff(fact_2478_pochhammer__double,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Z),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),comm_s3205402744901411588hammer(A,Z,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2)))),N)) ) ) ).

% pochhammer_double
tff(fact_2479_ln__one__minus__pos__lower__bound,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,uminus_uminus(real),Xa)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),Xa))) ) ) ).

% ln_one_minus_pos_lower_bound
tff(fact_2480_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa))),Xa))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% abs_ln_one_plus_x_minus_x_bound
tff(fact_2481_tanh__ln__real,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,tanh(real),aa(real,real,ln_ln(real),Xa)) = divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))) ) ) ).

% tanh_ln_real
tff(fact_2482_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2)
         => ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),N) ) ) ) ) ).

% floor_log_nat_eq_if
tff(fact_2483_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( ( archim6421214686448440834_floor(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(nat,int,semiring_1_of_nat(int),N) )
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
tff(fact_2484_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),archimedean_ceiling(real,aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat)))))),one_one(int)) ) ) ).

% ceiling_log2_div2
tff(fact_2485_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa))),Xa))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
tff(fact_2486_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2)
         => ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),one_one(int)) ) ) ) ) ).

% ceiling_log_nat_eq_if
tff(fact_2487_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( ( archimedean_ceiling(real,aa(real,real,log(aa(nat,real,semiring_1_of_nat(real),B2)),aa(nat,real,semiring_1_of_nat(real),K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),N)),one_one(int)) )
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),N)),K)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),B2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
tff(fact_2488_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),vEBT_VEBT_high(Ma,N)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)) ) ).

% high_bound_aux
tff(fact_2489_set__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( bit_se5668285175392031749et_bit(A,zero_zero(nat),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% set_bit_0
tff(fact_2490_psubsetI,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( ( A3 != B3 )
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3) ) ) ).

% psubsetI
tff(fact_2491_low__def,axiom,
    ! [Xa: nat,N: nat] : ( vEBT_VEBT_low(Xa,N) = modulo_modulo(nat,Xa,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% low_def
tff(fact_2492_high__def,axiom,
    ! [Xa: nat,N: nat] : ( vEBT_VEBT_high(Xa,N) = divide_divide(nat,Xa,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% high_def
tff(fact_2493_unset__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( bit_se2638667681897837118et_bit(A,zero_zero(nat),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% unset_bit_0
tff(fact_2494_subset__antisym,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( A3 = B3 ) ) ) ).

% subset_antisym
tff(fact_2495_subsetI,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ! [X: A] :
          ( member(A,X,A3)
         => member(A,X,B3) )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% subsetI
tff(fact_2496_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),aa(set(A),set(A),uminus_uminus(set(A)),B3))
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ).

% Compl_subset_Compl_iff
tff(fact_2497_Compl__anti__mono,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),B3)),aa(set(A),set(A),uminus_uminus(set(A)),A3)) ) ).

% Compl_anti_mono
tff(fact_2498_i0__less,axiom,
    ! [N: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),N)
    <=> ( N != zero_zero(extended_enat) ) ) ).

% i0_less
tff(fact_2499_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se2638667681897837118et_bit(int,N,K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% unset_bit_nonnegative_int_iff
tff(fact_2500_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se5668285175392031749et_bit(int,N,K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% set_bit_nonnegative_int_iff
tff(fact_2501_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se2638667681897837118et_bit(int,N,K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% unset_bit_negative_int_iff
tff(fact_2502_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se5668285175392031749et_bit(int,N,K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% set_bit_negative_int_iff
tff(fact_2503_idiff__0__right,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),N),zero_zero(extended_enat)) = N ) ).

% idiff_0_right
tff(fact_2504_idiff__0,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),zero_zero(extended_enat)),N) = zero_zero(extended_enat) ) ).

% idiff_0
tff(fact_2505_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),N))
    <=> ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),M)
        & aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),zero_zero(extended_enat)),N) ) ) ).

% enat_0_less_mult_iff
tff(fact_2506_not__iless0,axiom,
    ! [N: extended_enat] : ~ aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),N),zero_zero(extended_enat)) ).

% not_iless0
tff(fact_2507_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),M),N) = zero_zero(extended_enat) )
    <=> ( ( M = zero_zero(extended_enat) )
        & ( N = zero_zero(extended_enat) ) ) ) ).

% iadd_is_0
tff(fact_2508_zero__one__enat__neq_I1_J,axiom,
    zero_zero(extended_enat) != one_one(extended_enat) ).

% zero_one_enat_neq(1)
tff(fact_2509_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),M),N) = zero_zero(extended_enat) )
    <=> ( ( M = zero_zero(extended_enat) )
        | ( N = zero_zero(extended_enat) ) ) ) ).

% imult_is_0
tff(fact_2510_unset__bit__nat__def,axiom,
    ! [M: nat,N: nat] : ( bit_se2638667681897837118et_bit(nat,M,N) = aa(int,nat,nat2,bit_se2638667681897837118et_bit(int,M,aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% unset_bit_nat_def
tff(fact_2511_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),bit_se2638667681897837118et_bit(int,N,K)),K) ).

% unset_bit_less_eq
tff(fact_2512_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),bit_se5668285175392031749et_bit(int,N,K)) ).

% set_bit_greater_eq
tff(fact_2513_Diff__mono,axiom,
    ! [A: $tType,A3: set(A),C5: set(A),D3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),D3),B3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),D3)) ) ) ).

% Diff_mono
tff(fact_2514_Diff__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),A3) ).

% Diff_subset
tff(fact_2515_double__diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),A3)) = A3 ) ) ) ).

% double_diff
tff(fact_2516_Collect__mono__iff,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,P)),collect(A,Q))
    <=> ! [X4: A] :
          ( aa(A,$o,P,X4)
         => aa(A,$o,Q,X4) ) ) ).

% Collect_mono_iff
tff(fact_2517_set__eq__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( A3 = B3 )
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ) ).

% set_eq_subset
tff(fact_2518_subset__trans,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5) ) ) ).

% subset_trans
tff(fact_2519_Collect__mono,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ! [X: A] :
          ( aa(A,$o,P,X)
         => aa(A,$o,Q,X) )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,P)),collect(A,Q)) ) ).

% Collect_mono
tff(fact_2520_subset__refl,axiom,
    ! [A: $tType,A3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),A3) ).

% subset_refl
tff(fact_2521_subset__iff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
    <=> ! [T3: A] :
          ( member(A,T3,A3)
         => member(A,T3,B3) ) ) ).

% subset_iff
tff(fact_2522_equalityD2,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( A3 = B3 )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ).

% equalityD2
tff(fact_2523_equalityD1,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( A3 = B3 )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% equalityD1
tff(fact_2524_subset__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
    <=> ! [X4: A] :
          ( member(A,X4,A3)
         => member(A,X4,B3) ) ) ).

% subset_eq
tff(fact_2525_equalityE,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( A3 = B3 )
     => ~ ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ) ).

% equalityE
tff(fact_2526_subsetD,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C2: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( member(A,C2,A3)
       => member(A,C2,B3) ) ) ).

% subsetD
tff(fact_2527_in__mono,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),Xa: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( member(A,Xa,A3)
       => member(A,Xa,B3) ) ) ).

% in_mono
tff(fact_2528_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ? [B4: A] : member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) ) ).

% psubset_imp_ex_mem
tff(fact_2529_subset__iff__psubset__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
        | ( A3 = B3 ) ) ) ).

% subset_iff_psubset_eq
tff(fact_2530_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),B3),C5)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C5) ) ) ).

% subset_psubset_trans
tff(fact_2531_subset__not__subset__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
        & ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ) ).

% subset_not_subset_eq
tff(fact_2532_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),C5) ) ) ).

% psubset_subset_trans
tff(fact_2533_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% psubset_imp_subset
tff(fact_2534_psubset__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
        & ( A3 != B3 ) ) ) ).

% psubset_eq
tff(fact_2535_psubsetE,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3)
     => ~ ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3) ) ) ).

% psubsetE
tff(fact_2536_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( bit_se5668285175392031749et_bit(A,aa(nat,nat,suc,N),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se5668285175392031749et_bit(A,N,divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% set_bit_Suc
tff(fact_2537_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( bit_se2638667681897837118et_bit(A,aa(nat,nat,suc,N),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2638667681897837118et_bit(A,N,divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% unset_bit_Suc
tff(fact_2538_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( bit_se8732182000553998342ip_bit(A,aa(nat,nat,suc,N),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se8732182000553998342ip_bit(A,N,divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% flip_bit_Suc
tff(fact_2539_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A2)
          = $ite(N = zero_zero(nat),aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))))) ) ) ).

% signed_take_bit_rec
tff(fact_2540_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% dbl_simps(4)
tff(fact_2541_arcosh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Xa: A] : ( aa(A,A,arcosh(A),Xa) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(A,A,aa(A,fun(A,A),powr(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A))),real_Vector_of_real(A,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))))) ) ) ).

% arcosh_def
tff(fact_2542_arsinh__def,axiom,
    ! [A: $tType] :
      ( ln(A)
     => ! [Xa: A] : ( aa(A,A,arsinh(A),Xa) = aa(A,A,ln_ln(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(A,A,aa(A,fun(A,A),powr(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A))),real_Vector_of_real(A,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))))))) ) ) ).

% arsinh_def
tff(fact_2543_log__base__10__eq1,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(aa(num,num,bit1,bit0(one2))))),Xa) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,ln_ln(real),aa(real,real,exp(real),one_one(real))),aa(real,real,ln_ln(real),aa(num,real,numeral_numeral(real),bit0(aa(num,num,bit1,bit0(one2))))))),aa(real,real,ln_ln(real),Xa)) ) ) ).

% log_base_10_eq1
tff(fact_2544_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( aa(num,num,bit1,M) = aa(num,num,bit1,N) )
    <=> ( M = N ) ) ).

% semiring_norm(90)
tff(fact_2545_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( aa(num,num,bit1,X32) = aa(num,num,bit1,Y32) )
    <=> ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
tff(fact_2546_Diff__idemp,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) ) ).

% Diff_idemp
tff(fact_2547_Diff__iff,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
    <=> ( member(A,C2,A3)
        & ~ member(A,C2,B3) ) ) ).

% Diff_iff
tff(fact_2548_DiffI,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,A3)
     => ( ~ member(A,C2,B3)
       => member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ) ).

% DiffI
tff(fact_2549_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] : ( bit0(M) != aa(num,num,bit1,N) ) ).

% semiring_norm(88)
tff(fact_2550_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,bit1,M) != bit0(N) ) ).

% semiring_norm(89)
tff(fact_2551_semiring__norm_I84_J,axiom,
    ! [N: num] : ( one2 != aa(num,num,bit1,N) ) ).

% semiring_norm(84)
tff(fact_2552_semiring__norm_I86_J,axiom,
    ! [M: num] : ( aa(num,num,bit1,M) != one2 ) ).

% semiring_norm(86)
tff(fact_2553_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se8732182000553998342ip_bit(int,N,K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% flip_bit_nonnegative_int_iff
tff(fact_2554_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se8732182000553998342ip_bit(int,N,K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% flip_bit_negative_int_iff
tff(fact_2555_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% signed_take_bit_of_0
tff(fact_2556_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,M)),aa(num,num,bit1,N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),N) ) ).

% semiring_norm(73)
tff(fact_2557_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit1,M)),aa(num,num,bit1,N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N) ) ).

% semiring_norm(80)
tff(fact_2558_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,zero_zero(A)) = zero_zero(A) ) ) ).

% dbl_simps(2)
tff(fact_2559_of__real__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ( real_Vector_of_real(A,zero_zero(real)) = zero_zero(A) ) ) ).

% of_real_0
tff(fact_2560_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Xa: real] :
          ( ( real_Vector_of_real(A,Xa) = zero_zero(A) )
        <=> ( Xa = zero_zero(real) ) ) ) ).

% of_real_eq_0_iff
tff(fact_2561_of__real__1,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ( real_Vector_of_real(A,one_one(real)) = one_one(A) ) ) ).

% of_real_1
tff(fact_2562_of__real__eq__1__iff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Xa: real] :
          ( ( real_Vector_of_real(A,Xa) = one_one(A) )
        <=> ( Xa = one_one(real) ) ) ) ).

% of_real_eq_1_iff
tff(fact_2563_of__real__mult,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Xa: real,Y: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)) = aa(A,A,aa(A,fun(A,A),times_times(A),real_Vector_of_real(A,Xa)),real_Vector_of_real(A,Y)) ) ) ).

% of_real_mult
tff(fact_2564_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% signed_take_bit_of_minus_1
tff(fact_2565_of__real__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Xa: real,Y: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,Xa)),real_Vector_of_real(A,Y)) ) ) ).

% of_real_add
tff(fact_2566_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_Suc_1
tff(fact_2567_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),one_one(A)) = one_one(A) ) ) ).

% signed_take_bit_numeral_of_1
tff(fact_2568_of__real__diff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Xa: real,Y: real] : ( real_Vector_of_real(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),real_Vector_of_real(A,Xa)),real_Vector_of_real(A,Y)) ) ) ).

% of_real_diff
tff(fact_2569_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit0(M)),aa(num,num,bit1,N)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ).

% semiring_norm(7)
tff(fact_2570_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,M)),bit0(N)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)) ) ).

% semiring_norm(9)
tff(fact_2571_of__real__of__nat__eq,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [N: nat] : ( real_Vector_of_real(A,aa(nat,real,semiring_1_of_nat(real),N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ).

% of_real_of_nat_eq
tff(fact_2572_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),bit0(M)),aa(num,num,bit1,N)) = bit0(aa(num,num,aa(num,fun(num,num),times_times(num),M),aa(num,num,bit1,N))) ) ).

% semiring_norm(14)
tff(fact_2573_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,M)),bit0(N)) = bit0(aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,M)),N)) ) ).

% semiring_norm(15)
tff(fact_2574_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),bit0(M)),aa(num,num,bit1,N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),N) ) ).

% semiring_norm(72)
tff(fact_2575_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),aa(num,num,bit1,M)),bit0(N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N) ) ).

% semiring_norm(81)
tff(fact_2576_semiring__norm_I70_J,axiom,
    ! [M: num] : ~ aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,M)),one2) ).

% semiring_norm(70)
tff(fact_2577_semiring__norm_I77_J,axiom,
    ! [N: num] : aa(num,$o,aa(num,fun(num,$o),ord_less(num),one2),aa(num,num,bit1,N)) ).

% semiring_norm(77)
tff(fact_2578_of__real__fact,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [N: nat] : ( real_Vector_of_real(A,semiring_char_0_fact(real,N)) = semiring_char_0_fact(A,N) ) ) ).

% of_real_fact
tff(fact_2579_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),bit0(K)) ) ) ).

% dbl_simps(5)
tff(fact_2580_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,uminus_uminus(A),neg_numeral_dbl(A,aa(num,A,numeral_numeral(A),K))) ) ) ).

% dbl_simps(1)
tff(fact_2581_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_inc(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,K)) ) ) ).

% dbl_inc_simps(5)
tff(fact_2582_semiring__norm_I3_J,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),bit0(N)) = aa(num,num,bit1,N) ) ).

% semiring_norm(3)
tff(fact_2583_semiring__norm_I4_J,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),aa(num,num,bit1,N)) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),N),one2)) ) ).

% semiring_norm(4)
tff(fact_2584_semiring__norm_I5_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bit0(M)),one2) = aa(num,num,bit1,M) ) ).

% semiring_norm(5)
tff(fact_2585_semiring__norm_I8_J,axiom,
    ! [M: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,M)),one2) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),M),one2)) ) ).

% semiring_norm(8)
tff(fact_2586_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,bit1,M)),aa(num,num,bit1,N)) = bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)),one2)) ) ).

% semiring_norm(10)
tff(fact_2587_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),aa(num,num,bit1,M)),aa(num,num,bit1,N)) = aa(num,num,bit1,aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)),bit0(aa(num,num,aa(num,fun(num,num),times_times(num),M),N)))) ) ).

% semiring_norm(16)
tff(fact_2588_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),aa(num,num,bit1,M)),bit0(N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N) ) ).

% semiring_norm(74)
tff(fact_2589_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( aa(num,$o,aa(num,fun(num,$o),ord_less(num),bit0(M)),aa(num,num,bit1,N))
    <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),N) ) ).

% semiring_norm(79)
tff(fact_2590_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(num,int,numeral_numeral(int),bit0(K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_Suc_bit0
tff(fact_2591_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl(A,one_one(A)) = aa(num,A,numeral_numeral(A),bit0(one2)) ) ) ).

% dbl_simps(3)
tff(fact_2592_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_inc(A,one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2)) ) ) ).

% dbl_inc_simps(3)
tff(fact_2593_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_Suc_minus_bit0
tff(fact_2594_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] : ( divide_divide(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),aa(num,nat,numeral_numeral(nat),V)) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_div_eq_add3_div_numeral
tff(fact_2595_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] : ( divide_divide(nat,M,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,N)))) = divide_divide(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),N)) ) ).

% div_Suc_eq_div_add3
tff(fact_2596_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,M,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,N)))) = modulo_modulo(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),N)) ) ).

% mod_Suc_eq_mod_add3
tff(fact_2597_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),aa(num,nat,numeral_numeral(nat),V)) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M),aa(num,nat,numeral_numeral(nat),V)) ) ).

% Suc_mod_eq_add3_mod_numeral
tff(fact_2598_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_dbl_dec(A,aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))) ) ) ).

% dbl_dec_simps(4)
tff(fact_2599_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,zero_zero(nat)),A2) = aa(A,A,uminus_uminus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% signed_take_bit_0
tff(fact_2600_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Xa: real] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,Xa)),one_one(A))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),one_one(real))) ) ) ).

% norm_of_real_add1
tff(fact_2601_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Xa: real,B2: num] : ( real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,Xa)),aa(num,A,numeral_numeral(A),B2))) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(num,real,numeral_numeral(real),B2))) ) ) ).

% norm_of_real_addn
tff(fact_2602_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_bit1
tff(fact_2603_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] : ( modulo_modulo(int,aa(num,int,numeral_numeral(int),aa(num,num,bit1,V)),aa(num,int,numeral_numeral(int),bit0(W))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),modulo_modulo(int,aa(num,int,numeral_numeral(int),V),aa(num,int,numeral_numeral(int),W)))),one_one(int)) ) ).

% zmod_numeral_Bit1
tff(fact_2604_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_Suc_minus_bit1
tff(fact_2605_DiffD2,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
     => ~ member(A,C2,B3) ) ).

% DiffD2
tff(fact_2606_DiffD1,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
     => member(A,C2,A3) ) ).

% DiffD1
tff(fact_2607_DiffE,axiom,
    ! [A: $tType,C2: A,A3: set(A),B3: set(A)] :
      ( member(A,C2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
     => ~ ( member(A,C2,A3)
         => member(A,C2,B3) ) ) ).

% DiffE
tff(fact_2608_verit__eq__simplify_I14_J,axiom,
    ! [X2: num,X32: num] : ( bit0(X2) != aa(num,num,bit1,X32) ) ).

% verit_eq_simplify(14)
tff(fact_2609_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] : ( one2 != aa(num,num,bit1,X32) ) ).

% verit_eq_simplify(12)
tff(fact_2610_pochhammer__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1(A)
        & comm_semiring_1(A) )
     => ! [Xa: real,N: nat] : ( comm_s3205402744901411588hammer(A,real_Vector_of_real(A,Xa),N) = real_Vector_of_real(A,comm_s3205402744901411588hammer(real,Xa,N)) ) ) ).

% pochhammer_of_real
tff(fact_2611_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% signed_take_bit_mult
tff(fact_2612_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% signed_take_bit_add
tff(fact_2613_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),L))) = aa(int,int,bit_ri4674362597316999326ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% signed_take_bit_diff
tff(fact_2614_num_Oexhaust,axiom,
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X22: num] : ( Y != bit0(X22) )
       => ~ ! [X33: num] : ( Y != aa(num,num,bit1,X33) ) ) ) ).

% num.exhaust
tff(fact_2615_of__real__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: real] : ( real_Vector_of_real(A,aa(real,real,exp(real),Xa)) = aa(A,A,exp(A),real_Vector_of_real(A,Xa)) ) ) ).

% of_real_exp
tff(fact_2616_dbl__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [Xa: A] : ( neg_numeral_dbl(A,Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Xa) ) ) ).

% dbl_def
tff(fact_2617_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [Y: real,Xa: real] :
          ( ( Y != zero_zero(real) )
         => ( real_Vector_of_real(A,divide_divide(real,Xa,Y)) = divide_divide(A,real_Vector_of_real(A,Xa),real_Vector_of_real(A,Y)) ) ) ) ).

% nonzero_of_real_divide
tff(fact_2618_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [Xa: real] :
          ( ( Xa != zero_zero(real) )
         => ( real_Vector_of_real(A,aa(real,real,inverse_inverse(real),Xa)) = aa(A,A,inverse_inverse(A),real_Vector_of_real(A,Xa)) ) ) ) ).

% nonzero_of_real_inverse
tff(fact_2619_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),N)),aa(num,A,numeral_numeral(A),N))),one_one(A)) ) ) ).

% numeral_Bit1
tff(fact_2620_eval__nat__numeral_I3_J,axiom,
    ! [N: num] : ( aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,N)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),bit0(N))) ) ).

% eval_nat_numeral(3)
tff(fact_2621_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: A,K: num] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,K))) = aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,K)))) ) ) ).

% power_minus_Bit1
tff(fact_2622_norm__less__p1,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Xa: A] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),real_Vector_of_real(A,real_V7770717601297561774m_norm(A,Xa))),one_one(A)))) ) ).

% norm_less_p1
tff(fact_2623_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num,Q2: num] : ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,N)),aa(num,A,numeral_numeral(A),bit0(Q2))) != zero_zero(A) ) ) ).

% cong_exp_iff_simps(3)
tff(fact_2624_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [A2: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),A2)),A2) ) ) ).

% power3_eq_cube
tff(fact_2625_numeral__3__eq__3,axiom,
    aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) = aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))) ).

% numeral_3_eq_3
tff(fact_2626_Suc3__eq__add__3,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,N))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),N) ) ).

% Suc3_eq_add_3
tff(fact_2627_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [B2: real,A2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),real_Vector_of_real(A,B2)),real_Vector_of_real(A,A2)))),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2))) ) ).

% norm_of_real_diff
tff(fact_2628_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: num,N: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),bit0(Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,N)),aa(num,A,numeral_numeral(A),bit0(Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),N),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(7)
tff(fact_2629_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,Q2: num] :
          ( ( modulo_modulo(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,M)),aa(num,A,numeral_numeral(A),bit0(Q2))) = modulo_modulo(A,aa(num,A,numeral_numeral(A),one2),aa(num,A,numeral_numeral(A),bit0(Q2))) )
        <=> ( modulo_modulo(A,aa(num,A,numeral_numeral(A),M),aa(num,A,numeral_numeral(A),Q2)) = zero_zero(A) ) ) ) ).

% cong_exp_iff_simps(11)
tff(fact_2630_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] : ( divide_divide(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),N) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M),N) ) ).

% Suc_div_eq_add3_div
tff(fact_2631_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,aa(nat,nat,suc,aa(nat,nat,suc,M))),N) = modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),M),N) ) ).

% Suc_mod_eq_add3_mod
tff(fact_2632_exp__le,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,exp(real),one_one(real))),aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))) ).

% exp_le
tff(fact_2633_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = zero_zero(nat) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = one_one(nat) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(num,nat,numeral_numeral(nat),bit0(one2)) )
      | ( modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) ) ) ).

% mod_exhaust_less_4
tff(fact_2634_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),K) ) ).

% signed_take_bit_int_less_self_iff
tff(fact_2635_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% signed_take_bit_int_greater_eq_self_iff
tff(fact_2636_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)) ).

% signed_take_bit_int_greater_eq_minus_exp
tff(fact_2637_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))),K) ) ).

% signed_take_bit_int_less_eq_self_iff
tff(fact_2638_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),K)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(nat,nat,suc,N)))) ) ).

% signed_take_bit_int_less_eq
tff(fact_2639_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
       => ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = K ) ) ) ).

% signed_take_bit_int_eq_self
tff(fact_2640_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = K )
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ) ).

% signed_take_bit_int_eq_self_iff
tff(fact_2641_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(nat,nat,suc,N)))),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)) ) ).

% signed_take_bit_int_greater_eq
tff(fact_2642_log__base__10__eq2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(aa(num,num,bit1,bit0(one2))))),Xa) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,log(aa(num,real,numeral_numeral(real),bit0(aa(num,num,bit1,bit0(one2))))),aa(real,real,exp(real),one_one(real)))),aa(real,real,ln_ln(real),Xa)) ) ) ).

% log_base_10_eq2
tff(fact_2643_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,aa(nat,nat,suc,N)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_ri4674362597316999326ke_bit(A,N),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))))) ) ) ).

% signed_take_bit_Suc
tff(fact_2644_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_minus_bit1
tff(fact_2645_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))),N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N)))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),N))) ) ).

% central_binomial_lower_bound
tff(fact_2646_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L: int] : ( bit_concat_bit(aa(nat,nat,suc,N),K,L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),bit_concat_bit(N,divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2))),L))) ) ).

% concat_bit_Suc
tff(fact_2647_arctan__inverse,axiom,
    ! [Xa: real] :
      ( ( Xa != zero_zero(real) )
     => ( aa(real,real,arctan,divide_divide(real,one_one(real),Xa)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Xa)),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(real,real,arctan,Xa)) ) ) ).

% arctan_inverse
tff(fact_2648_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% signed_take_bit_numeral_bit1
tff(fact_2649_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),modulo_modulo(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N))) ) ) ) ) ).

% even_succ_mod_exp
tff(fact_2650_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),one_one(nat))
    <=> ( M = one_one(nat) ) ) ).

% nat_dvd_1_iff_1
tff(fact_2651_int__dvd__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N) ) ).

% int_dvd_int_iff
tff(fact_2652_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),A2)
        <=> ( A2 = zero_zero(A) ) ) ) ).

% dvd_0_left_iff
tff(fact_2653_dvd__0__right,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),zero_zero(A)) ) ).

% dvd_0_right
tff(fact_2654_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_triv_left_iff
tff(fact_2655_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_triv_right_iff
tff(fact_2656_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),aa(A,A,uminus_uminus(A),Y))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Y) ) ) ).

% dvd_minus_iff
tff(fact_2657_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,uminus_uminus(A),Xa)),Y)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Y) ) ) ).

% minus_dvd_iff
tff(fact_2658_div__dvd__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),divide_divide(A,B2,A2)),divide_divide(A,C2,A2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ) ).

% div_dvd_div
tff(fact_2659_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,suc,zero_zero(nat)))
    <=> ( M = aa(nat,nat,suc,zero_zero(nat)) ) ) ).

% dvd_1_iff_1
tff(fact_2660_dvd__1__left,axiom,
    ! [K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,suc,zero_zero(nat))),K) ).

% dvd_1_left
tff(fact_2661_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,abs_abs(A),M)),K)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),K) ) ) ).

% abs_dvd_iff
tff(fact_2662_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [M: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),aa(A,A,abs_abs(A),K))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),M),K) ) ) ).

% dvd_abs_iff
tff(fact_2663_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
    <=> ( ( K = zero_zero(nat) )
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N) ) ) ).

% nat_mult_dvd_cancel_disj
tff(fact_2664_binomial__Suc__n,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,N)),N) = aa(nat,nat,suc,N) ) ).

% binomial_Suc_n
tff(fact_2665_zdvd1__eq,axiom,
    ! [Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Xa),one_one(int))
    <=> ( aa(int,int,abs_abs(int),Xa) = one_one(int) ) ) ).

% zdvd1_eq
tff(fact_2666_binomial__n__n,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),N) = one_one(nat) ) ).

% binomial_n_n
tff(fact_2667_concat__bit__0,axiom,
    ! [K: int,L: int] : ( bit_concat_bit(zero_zero(nat),K,L) = L ) ).

% concat_bit_0
tff(fact_2668_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% dvd_times_right_cancel_iff
tff(fact_2669_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% dvd_times_left_cancel_iff
tff(fact_2670_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( ( C2 = zero_zero(A) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_mult_cancel_right
tff(fact_2671_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( ( C2 = zero_zero(A) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_mult_cancel_left
tff(fact_2672_unit__prod,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A)) ) ) ) ).

% unit_prod
tff(fact_2673_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_times_triv_left_iff
tff(fact_2674_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_add_times_triv_right_iff
tff(fact_2675_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,A2)),A2) = B2 ) ) ) ).

% dvd_div_mult_self
tff(fact_2676_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),divide_divide(A,B2,A2)) = B2 ) ) ) ).

% dvd_mult_div_cancel
tff(fact_2677_unit__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),divide_divide(A,A2,B2)),one_one(A)) ) ) ) ).

% unit_div
tff(fact_2678_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),divide_divide(A,one_one(A),A2)),one_one(A)) ) ) ).

% unit_div_1_unit
tff(fact_2679_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( divide_divide(A,one_one(A),divide_divide(A,one_one(A),A2)) = A2 ) ) ) ).

% unit_div_1_div_1
tff(fact_2680_div__add,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ) ) ).

% div_add
tff(fact_2681_div__diff,axiom,
    ! [A: $tType] :
      ( idom_modulo(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ) ) ).

% div_diff
tff(fact_2682_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( modulo_modulo(A,B2,A2) = zero_zero(A) ) ) ) ).

% dvd_imp_mod_0
tff(fact_2683_binomial__0__Suc,axiom,
    ! [K: nat] : ( aa(nat,nat,binomial(zero_zero(nat)),aa(nat,nat,suc,K)) = zero_zero(nat) ) ).

% binomial_0_Suc
tff(fact_2684_binomial__1,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),aa(nat,nat,suc,zero_zero(nat))) = N ) ).

% binomial_1
tff(fact_2685_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( aa(nat,nat,binomial(N),K) = zero_zero(nat) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),K) ) ).

% binomial_eq_0_iff
tff(fact_2686_binomial__Suc__Suc,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),aa(nat,nat,suc,K))) ) ).

% binomial_Suc_Suc
tff(fact_2687_pred__numeral__simps_I1_J,axiom,
    pred_numeral(one2) = zero_zero(nat) ).

% pred_numeral_simps(1)
tff(fact_2688_binomial__n__0,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),zero_zero(nat)) = one_one(nat) ) ).

% binomial_n_0
tff(fact_2689_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( aa(nat,nat,suc,N) = aa(num,nat,numeral_numeral(nat),K) )
    <=> ( N = pred_numeral(K) ) ) ).

% Suc_eq_numeral
tff(fact_2690_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,N) )
    <=> ( pred_numeral(K) = N ) ) ).

% eq_numeral_Suc
tff(fact_2691_dvd__nat__abs__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),N),aa(int,nat,nat2,aa(int,int,abs_abs(int),K)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(nat,int,semiring_1_of_nat(int),N)),K) ) ).

% dvd_nat_abs_iff
tff(fact_2692_nat__abs__dvd__iff,axiom,
    ! [K: int,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),N)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),aa(nat,int,semiring_1_of_nat(int),N)) ) ).

% nat_abs_dvd_iff
tff(fact_2693_sgn__mult__dvd__iff,axiom,
    ! [R: int,L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R)),L)),K)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        & ( ( R = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% sgn_mult_dvd_iff
tff(fact_2694_mult__sgn__dvd__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),aa(int,int,sgn_sgn(int),R))),K)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        & ( ( R = zero_zero(int) )
         => ( K = zero_zero(int) ) ) ) ) ).

% mult_sgn_dvd_iff
tff(fact_2695_dvd__sgn__mult__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),R)),K))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( R = zero_zero(int) ) ) ) ).

% dvd_sgn_mult_iff
tff(fact_2696_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(int,int,sgn_sgn(int),R)))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( R = zero_zero(int) ) ) ) ).

% dvd_mult_sgn_iff
tff(fact_2697_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_concat_bit(N,K,L))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ).

% concat_bit_nonnegative_iff
tff(fact_2698_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_concat_bit(N,K,L)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ).

% concat_bit_negative_iff
tff(fact_2699_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,A2)),A2) = B2 ) ) ) ).

% unit_div_mult_self
tff(fact_2700_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),divide_divide(A,one_one(A),A2)) = divide_divide(A,B2,A2) ) ) ) ).

% unit_mult_div_div
tff(fact_2701_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,aa(nat,nat,suc,N)))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% even_Suc_Suc_iff
tff(fact_2702_even__Suc,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% even_Suc
tff(fact_2703_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [N: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% pow_divides_pow_iff
tff(fact_2704_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(N),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N) ) ).

% zero_less_binomial_iff
tff(fact_2705_pred__numeral__simps_I3_J,axiom,
    ! [K: num] : ( pred_numeral(aa(num,num,bit1,K)) = aa(num,nat,numeral_numeral(nat),bit0(K)) ) ).

% pred_numeral_simps(3)
tff(fact_2706_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),pred_numeral(K)) ) ).

% less_Suc_numeral
tff(fact_2707_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pred_numeral(K)),N) ) ).

% less_numeral_Suc
tff(fact_2708_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),pred_numeral(K)) ) ).

% le_Suc_numeral
tff(fact_2709_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),pred_numeral(K)),N) ) ).

% le_numeral_Suc
tff(fact_2710_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),pred_numeral(K)) ) ).

% diff_Suc_numeral
tff(fact_2711_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),pred_numeral(K)),N) ) ).

% diff_numeral_Suc
tff(fact_2712_even__mult__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2) ) ) ) ).

% even_mult_iff
tff(fact_2713_odd__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> ~ ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2) ) ) ) ).

% odd_add
tff(fact_2714_even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2) ) ) ) ).

% even_add
tff(fact_2715_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( divide_divide(nat,aa(nat,nat,suc,N),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(nat,nat,suc,divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% odd_Suc_div_two
tff(fact_2716_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( divide_divide(nat,aa(nat,nat,suc,N),aa(num,nat,numeral_numeral(nat),bit0(one2))) = divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ).

% even_Suc_div_two
tff(fact_2717_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W))
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_le_power_eq_numeral
tff(fact_2718_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A))
        <=> ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W))
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% power_less_zero_eq_numeral
tff(fact_2719_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),zero_zero(A))
        <=> ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),zero_zero(A)) ) ) ) ).

% power_less_zero_eq
tff(fact_2720_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2) ) ) ).

% even_plus_one_iff
tff(fact_2721_even__diff,axiom,
    ! [A: $tType] :
      ( ring_parity(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ).

% even_diff
tff(fact_2722_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = one_one(A) ) ) ) ).

% neg_one_even_power
tff(fact_2723_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ).

% neg_one_odd_power
tff(fact_2724_even__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,semiring_1_of_nat(A),N))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ) ).

% even_of_nat
tff(fact_2725_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))) = N ) ) ).

% odd_Suc_minus_one
tff(fact_2726_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ) ).

% even_diff_nat
tff(fact_2727_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2),aa(num,A,numeral_numeral(A),bit0(one2))) = divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ) ).

% even_succ_div_2
tff(fact_2728_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ) ).

% even_succ_div_two
tff(fact_2729_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),one_one(A)) ) ) ) ).

% odd_succ_div_two
tff(fact_2730_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W)))
        <=> ( ( aa(num,nat,numeral_numeral(nat),W) = zero_zero(nat) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W))
              & ( A2 != zero_zero(A) ) )
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W))
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_less_power_eq_numeral
tff(fact_2731_even__power,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ) ).

% even_power
tff(fact_2732_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)) ) ) ).

% odd_two_times_div_two_nat
tff(fact_2733_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(num,int,numeral_numeral(int),bit0(K))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(num,int,numeral_numeral(int),K))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_numeral_bit0
tff(fact_2734_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))),one_one(A)) = A2 ) ) ) ).

% odd_two_times_div_two_succ
tff(fact_2735_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,W: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(num,nat,numeral_numeral(nat),W))),zero_zero(A))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(num,nat,numeral_numeral(nat),W))
            & ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W))
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
              | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(num,nat,numeral_numeral(nat),W))
                & ( A2 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
tff(fact_2736_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_parity_class.even_mask_iff
tff(fact_2737_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% signed_take_bit_numeral_minus_bit0
tff(fact_2738_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = divide_divide(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ) ) ).

% even_succ_div_exp
tff(fact_2739_dvd__refl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),A2) ) ).

% dvd_refl
tff(fact_2740_dvd__trans,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_trans
tff(fact_2741_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N) ) ) ).

% of_nat_dvd_iff
tff(fact_2742_choose__one,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),one_one(nat)) = N ) ).

% choose_one
tff(fact_2743_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
        <=> ( ( A2 = zero_zero(A) )
           => ( B2 = zero_zero(A) ) ) ) ) ).

% dvd_field_iff
tff(fact_2744_dvd__0__left,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),A2)
         => ( A2 = zero_zero(A) ) ) ) ).

% dvd_0_left
tff(fact_2745_division__decomp,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
         => ? [B6: A,C6: A] :
              ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B6),C6) )
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B6),B2)
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C6),C2) ) ) ) ).

% division_decomp
tff(fact_2746_dvd__productE,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [P2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),P2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
         => ~ ! [X: A,Y3: A] :
                ( ( P2 = aa(A,A,aa(A,fun(A,A),times_times(A),X),Y3) )
               => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),X),A2)
                 => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y3),B2) ) ) ) ) ).

% dvd_productE
tff(fact_2747_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)) ) ).

% dvd_triv_right
tff(fact_2748_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ).

% dvd_mult_right
tff(fact_2749_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),D2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ).

% mult_dvd_mono
tff(fact_2750_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) ) ).

% dvd_triv_left
tff(fact_2751_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ).

% dvd_mult_left
tff(fact_2752_dvd__mult2,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% dvd_mult2
tff(fact_2753_dvd__mult,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) ) ) ).

% dvd_mult
tff(fact_2754_dvd__def,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
        <=> ? [K2: A] : ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K2) ) ) ) ).

% dvd_def
tff(fact_2755_dvdI,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [A2: A,B2: A,K: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),B2),K) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% dvdI
tff(fact_2756_dvdE,axiom,
    ! [A: $tType] :
      ( dvd(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ~ ! [K3: A] : ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),B2),K3) ) ) ) ).

% dvdE
tff(fact_2757_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ) ).

% dvd_unit_imp_unit
tff(fact_2758_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% unit_imp_dvd
tff(fact_2759_one__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),one_one(A)),A2) ) ).

% one_dvd
tff(fact_2760_dvd__add,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2)) ) ) ) ).

% dvd_add
tff(fact_2761_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% dvd_add_left_iff
tff(fact_2762_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( comm_s4317794764714335236cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_add_right_iff
tff(fact_2763_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( euclid5891614535332579305n_ring(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),C2)) ) ) ).

% dvd_diff_commute
tff(fact_2764_dvd__diff,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Z)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z)) ) ) ) ).

% dvd_diff
tff(fact_2765_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( ( divide_divide(A,A2,C2) = divide_divide(A,B2,C2) )
            <=> ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
tff(fact_2766_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( divide_divide(A,A2,C2) = divide_divide(A,B2,C2) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
tff(fact_2767_div__div__div__same,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [D2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( divide_divide(A,divide_divide(A,A2,D2),divide_divide(A,B2,D2)) = divide_divide(A,A2,B2) ) ) ) ) ).

% div_div_div_same
tff(fact_2768_dvd__power__same,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Xa: A,Y: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Y)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),N)) ) ) ).

% dvd_power_same
tff(fact_2769_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
     => ( A2 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_uniqueI
tff(fact_2770_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( A2 != zero_zero(nat) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),zero_zero(nat))
        & ( A2 != zero_zero(nat) ) ) ) ).

% gcd_nat.not_eq_extremum
tff(fact_2771_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
    <=> ( A2 = zero_zero(nat) ) ) ).

% gcd_nat.extremum_unique
tff(fact_2772_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),zero_zero(nat)),A2)
        & ( zero_zero(nat) != A2 ) ) ).

% gcd_nat.extremum_strict
tff(fact_2773_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),zero_zero(nat)) ).

% gcd_nat.extremum
tff(fact_2774_pi__neq__zero,axiom,
    pi != zero_zero(real) ).

% pi_neq_zero
tff(fact_2775_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [L: A,K: A] :
          ( ( aa(A,A,abs_abs(A),L) = aa(A,A,abs_abs(A),K) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),L),K) ) ) ).

% dvd_if_abs_eq
tff(fact_2776_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),modulo_modulo(A,A2,B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2) ) ) ) ).

% dvd_mod_iff
tff(fact_2777_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),modulo_modulo(A,A2,B2))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2) ) ) ) ).

% dvd_mod_imp_dvd
tff(fact_2778_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) ) ) ).

% dvd_diff_nat
tff(fact_2779_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),N))
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),N)
       => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),M) ) ) ).

% zdvd_zdiffD
tff(fact_2780_zdvd__antisym__abs,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),B2)
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B2),A2)
       => ( aa(int,int,abs_abs(int),A2) = aa(int,int,abs_abs(int),B2) ) ) ) ).

% zdvd_antisym_abs
tff(fact_2781_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L: int,R: int] : ( bit_concat_bit(N,K,bit_concat_bit(M,L,R)) = bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N),bit_concat_bit(N,K,L),R) ) ).

% concat_bit_assoc
tff(fact_2782_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),K)
     => ( aa(nat,nat,binomial(N),K) = zero_zero(nat) ) ) ).

% binomial_eq_0
tff(fact_2783_Suc__times__binomial__eq,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,binomial(N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K))),aa(nat,nat,suc,K)) ) ).

% Suc_times_binomial_eq
tff(fact_2784_Suc__times__binomial,axiom,
    ! [K: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,binomial(N),K)) ) ).

% Suc_times_binomial
tff(fact_2785_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
     => ( aa(nat,nat,binomial(N),K) = aa(nat,nat,binomial(N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)) ) ) ).

% binomial_symmetric
tff(fact_2786_choose__mult__lemma,axiom,
    ! [M: nat,R: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R)),K)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K)),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R)),K)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),R)),M)) ) ).

% choose_mult_lemma
tff(fact_2787_binomial__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(N),R)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),N),R)) ) ).

% binomial_le_pow
tff(fact_2788_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),zero_zero(A)),one_one(A)) ) ).

% not_is_unit_0
tff(fact_2789_pinf_I9_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z4),X3)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S)) ) ) ) ).

% pinf(9)
tff(fact_2790_pinf_I10_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Z4),X3)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S))
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S)) ) ) ) ).

% pinf(10)
tff(fact_2791_minf_I9_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z4)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S)) ) ) ) ).

% minf(9)
tff(fact_2792_minf_I10_J,axiom,
    ! [A: $tType] :
      ( ( plus(A)
        & linorder(A)
        & dvd(A) )
     => ! [D2: A,S: A] :
        ? [Z4: A] :
        ! [X3: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X3),Z4)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S))
          <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),S)) ) ) ) ).

% minf(10)
tff(fact_2793_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( ( divide_divide(A,A2,B2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% dvd_div_eq_0_iff
tff(fact_2794_binomial__gbinomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat,K: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),N)),K) ) ) ).

% binomial_gbinomial
tff(fact_2795_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
tff(fact_2796_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
tff(fact_2797_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2) ) ) ) ).

% mult_unit_dvd_iff'
tff(fact_2798_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_mult_unit_iff'
tff(fact_2799_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% mult_unit_dvd_iff
tff(fact_2800_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_mult_unit_iff
tff(fact_2801_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A)) ) ) ) ).

% is_unit_mult_iff
tff(fact_2802_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,B2,C2)),A2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2),C2) ) ) ) ).

% dvd_div_mult
tff(fact_2803_div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ) ).

% div_mult_swap
tff(fact_2804_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( divide_divide(A,A2,divide_divide(A,B2,C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),C2) ) ) ) ) ).

% div_div_eq_right
tff(fact_2805_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)),A2)
         => ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A2,B2),C2) ) ) ) ).

% dvd_div_mult2_eq
tff(fact_2806_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),divide_divide(A,B2,C2)) ) ) ).

% dvd_mult_imp_div
tff(fact_2807_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),C2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),divide_divide(A,C2,D2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),D2)) ) ) ) ) ).

% div_mult_div_if_dvd
tff(fact_2808_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( ( divide_divide(A,B2,A2) = divide_divide(A,C2,A2) )
          <=> ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
tff(fact_2809_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),divide_divide(A,A2,B2)),C2)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% div_unit_dvd_iff
tff(fact_2810_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),divide_divide(A,C2,B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% dvd_div_unit_iff
tff(fact_2811_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ) ).

% div_plus_div_distrib_dvd_right
tff(fact_2812_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( euclid4440199948858584721cancel(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),C2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,C2)),divide_divide(A,B2,C2)) ) ) ) ).

% div_plus_div_distrib_dvd_left
tff(fact_2813_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( divide_divide(A,A2,aa(A,A,uminus_uminus(A),B2)) = aa(A,A,uminus_uminus(A),divide_divide(A,A2,B2)) ) ) ) ).

% dvd_div_neg
tff(fact_2814_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( divide_divide(A,aa(A,A,uminus_uminus(A),A2),B2) = aa(A,A,uminus_uminus(A),divide_divide(A,A2,B2)) ) ) ) ).

% dvd_neg_div
tff(fact_2815_div__power,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),divide_divide(A,A2,B2)),N) = divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ) ).

% div_power
tff(fact_2816_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( semiring_modulo(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% mod_0_imp_dvd
tff(fact_2817_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
        <=> ( modulo_modulo(A,B2,A2) = zero_zero(A) ) ) ) ).

% dvd_eq_mod_eq_0
tff(fact_2818_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ).

% mod_eq_0_iff_dvd
tff(fact_2819_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [M: nat,N: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% le_imp_power_dvd
tff(fact_2820_power__le__dvd,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat,B2: A,M: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),B2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),M)),B2) ) ) ) ).

% power_le_dvd
tff(fact_2821_dvd__power__le,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Xa: A,Y: A,N: nat,M: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Y)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),M)) ) ) ) ).

% dvd_power_le
tff(fact_2822_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo(A,A2,C2) = modulo_modulo(A,B2,C2) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ).

% mod_eq_dvd_iff
tff(fact_2823_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( semidom_modulo(A)
     => ! [B2: A,A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),modulo_modulo(A,A2,B2))) ) ).

% dvd_minus_mod
tff(fact_2824_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M) ) ) ).

% dvd_pos_nat
tff(fact_2825_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
       => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),N),M) ) ) ).

% nat_dvd_not_less
tff(fact_2826_pi__gt__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),pi) ).

% pi_gt_zero
tff(fact_2827_pi__not__less__zero,axiom,
    ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),zero_zero(real)) ).

% pi_not_less_zero
tff(fact_2828_pi__ge__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),pi) ).

% pi_ge_zero
tff(fact_2829_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
        | aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N) ) ) ).

% dvd_minus_self
tff(fact_2830_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),M)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
       => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),N)
         => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),N),M)
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
tff(fact_2831_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),N)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),M) ) ) ) ).

% dvd_diffD
tff(fact_2832_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),M)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),N) ) ) ) ).

% dvd_diffD1
tff(fact_2833_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N)
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) ) ) ).

% less_eq_dvd_minus
tff(fact_2834_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),M)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),M),N)
       => ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),N),M) ) ) ).

% zdvd_not_zless
tff(fact_2835_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),T2)
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),T2)) ) ) ).

% zdvd_mono
tff(fact_2836_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),N))
     => ( ( K != zero_zero(int) )
       => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),M),N) ) ) ).

% zdvd_mult_cancel
tff(fact_2837_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D6: nat,X: nat,Y3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D6),A2)
      & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D6),B2)
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y3)),D6) )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y3)),D6) ) ) ) ).

% bezout_add_nat
tff(fact_2838_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,Xa: nat,Y: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),B2)
       => ( ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Xa) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y)),D2) )
            | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Xa) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y)),D2) ) )
         => ? [X: nat,Y3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))
              & ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),Y3)),D2) )
                | ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y3)),D2) ) ) ) ) ) ) ).

% bezout_lemma_nat
tff(fact_2839_fact__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,M: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),semiring_char_0_fact(A,N)),semiring_char_0_fact(A,M)) ) ) ).

% fact_dvd
tff(fact_2840_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D6: nat,X: nat,Y3: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D6),A2)
      & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D6),B2)
      & ( ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y3)) = D6 )
        | ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y3)) = D6 ) ) ) ).

% bezout1_nat
tff(fact_2841_zdvd__period,axiom,
    ! [A2: int,D2: int,Xa: int,T2: int,C2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),D2)
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),T2))
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),aa(int,int,aa(int,fun(int,int),times_times(int),C2),D2))),T2)) ) ) ).

% zdvd_period
tff(fact_2842_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),aa(int,int,aa(int,fun(int,int),plus_plus(int),N),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),K),N) ) ).

% zdvd_reduce
tff(fact_2843_numeral__eq__Suc,axiom,
    ! [K: num] : ( aa(num,nat,numeral_numeral(nat),K) = aa(nat,nat,suc,pred_numeral(K)) ) ).

% numeral_eq_Suc
tff(fact_2844_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( aa(nat,nat,binomial(N),aa(nat,nat,suc,divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))) = aa(nat,nat,binomial(N),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% central_binomial_odd
tff(fact_2845_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(int,nat,nat2,Z)),M)
    <=> $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Z),aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Z),aa(nat,int,semiring_1_of_nat(int),M)),M = zero_zero(nat)) ) ).

% nat_dvd_iff
tff(fact_2846_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,binomial(N),K)) ) ).

% zero_less_binomial
tff(fact_2847_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,A2)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))),aa(nat,nat,suc,A2))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,B2)),aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2))),A2)) ) ).

% Suc_times_binomial_add
tff(fact_2848_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(N),M)),aa(nat,nat,binomial(M),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),K))) ) ) ) ).

% choose_mult
tff(fact_2849_binomial__Suc__Suc__eq__times,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,K)) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,binomial(N),K)),aa(nat,nat,suc,K)) ) ).

% binomial_Suc_Suc_eq_times
tff(fact_2850_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)),aa(nat,nat,binomial(N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ).

% binomial_absorb_comp
tff(fact_2851_unit__dvdE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ~ ( ( A2 != zero_zero(A) )
             => ! [C4: A] : ( B2 != aa(A,A,aa(A,fun(A,A),times_times(A),A2),C4) ) ) ) ) ).

% unit_dvdE
tff(fact_2852_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( dvd(A)
        & semiring_0(A) )
     => ! [P: fun(A,$o),L: A] :
          ( ? [X4: A] : aa(A,$o,P,aa(A,A,aa(A,fun(A,A),times_times(A),L),X4))
        <=> ? [X4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),L),aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),zero_zero(A)))
              & aa(A,$o,P,X4) ) ) ) ).

% unity_coeff_ex
tff(fact_2853_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( C2 != zero_zero(A) )
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),D2)
               => ( ( divide_divide(A,B2,A2) = divide_divide(A,D2,C2) )
                <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),D2) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
tff(fact_2854_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),divide_divide(A,B2,C2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) ) ) ) ) ).

% dvd_div_iff_mult
tff(fact_2855_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),divide_divide(A,A2,B2)),C2)
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) ) ) ) ) ).

% div_dvd_iff_mult
tff(fact_2856_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
           => ( ( divide_divide(A,B2,A2) = C2 )
            <=> ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2) ) ) ) ) ) ).

% dvd_div_eq_mult
tff(fact_2857_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( divide_divide(A,A2,B2) = zero_zero(A) )
          <=> ( A2 = zero_zero(A) ) ) ) ) ).

% unit_div_eq_0_iff
tff(fact_2858_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D3: A,T2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),D3)
         => ! [X3: A,K4: A] :
              ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),T2))
            <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D3))),T2)) ) ) ) ).

% inf_period(4)
tff(fact_2859_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( comm_ring(A)
        & dvd(A) )
     => ! [D2: A,D3: A,T2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),D3)
         => ! [X3: A,K4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),X3),T2))
            <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),D2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),aa(A,A,aa(A,fun(A,A),times_times(A),K4),D3))),T2)) ) ) ) ).

% inf_period(3)
tff(fact_2860_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
           => ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A2,B2),C2) ) ) ) ) ).

% is_unit_div_mult2_eq
tff(fact_2861_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),divide_divide(A,B2,C2)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) ) ) ) ).

% unit_div_mult_swap
tff(fact_2862_unit__div__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),C2) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),B2) ) ) ) ).

% unit_div_commute
tff(fact_2863_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = divide_divide(A,divide_divide(A,A2,B2),C2) ) ) ) ) ).

% div_mult_unit2
tff(fact_2864_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( A2 = divide_divide(A,C2,B2) )
          <=> ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2) = C2 ) ) ) ) ).

% unit_eq_div2
tff(fact_2865_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( ( divide_divide(A,A2,B2) = C2 )
          <=> ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2) ) ) ) ) ).

% unit_eq_div1
tff(fact_2866_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => ( modulo_modulo(A,A2,B2) = zero_zero(A) ) ) ) ).

% unit_imp_mod_eq_0
tff(fact_2867_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),one_one(A))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
            | ( N = zero_zero(nat) ) ) ) ) ).

% is_unit_power_iff
tff(fact_2868_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),K),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N) ) ) ).

% dvd_imp_le
tff(fact_2869_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,N))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),N))) ) ).

% fact_fact_dvd_fact
tff(fact_2870_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N) ) ) ).

% nat_mult_dvd_cancel1
tff(fact_2871_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N) ) ) ).

% dvd_mult_cancel
tff(fact_2872_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => ? [D6: nat,X: nat,Y3: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D6),A2)
          & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D6),B2)
          & ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y3)),D6) ) ) ) ).

% bezout_add_strong_nat
tff(fact_2873_zdvd__imp__le,axiom,
    ! [Z: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Z),N)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Z),N) ) ) ).

% zdvd_imp_le
tff(fact_2874_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),modulo_modulo(nat,M,N))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),N),M) ) ).

% mod_greater_zero_iff_not_dvd
tff(fact_2875_dvd__imp__le__int,axiom,
    ! [I: int,D2: int] :
      ( ( I != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),I)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,abs_abs(int),D2)),aa(int,int,abs_abs(int),I)) ) ) ).

% dvd_imp_le_int
tff(fact_2876_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => ( ( modulo_modulo(nat,M,Q2) = modulo_modulo(nat,N,Q2) )
      <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Q2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) ) ) ).

% mod_eq_dvd_iff_nat
tff(fact_2877_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( idom_divide(A)
     => ! [B2: int,A2: int] :
          ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),B2),A2)
         => member(A,divide_divide(A,aa(int,A,ring_1_of_int(A),A2),aa(int,A,ring_1_of_int(A),B2)),ring_1_Ints(A)) ) ) ).

% of_int_divide_in_Ints
tff(fact_2878_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
       => ( aa(int,int,sgn_sgn(int),modulo_modulo(int,K,L)) = aa(int,int,sgn_sgn(int),L) ) ) ) ).

% sgn_mod
tff(fact_2879_pred__numeral__def,axiom,
    ! [K: num] : ( pred_numeral(K) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),K)),one_one(nat)) ) ).

% pred_numeral_def
tff(fact_2880_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),semiring_char_0_fact(nat,N)) ) ) ).

% dvd_fact
tff(fact_2881_even__nat__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(int,nat,nat2,K))
      <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K) ) ) ).

% even_nat_iff
tff(fact_2882_binomial__absorption,axiom,
    ! [K: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,K)),aa(nat,nat,binomial(N),aa(nat,nat,suc,K))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ).

% binomial_absorption
tff(fact_2883_even__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),zero_zero(A)) ) ).

% even_zero
tff(fact_2884_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)) = divide_divide(A,one_one(A),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_right
tff(fact_2885_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
           => ( divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = divide_divide(A,one_one(A),B2) ) ) ) ) ).

% is_unit_div_mult_cancel_left
tff(fact_2886_is__unitE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ~ ( ( A2 != zero_zero(A) )
             => ! [B4: A] :
                  ( ( B4 != zero_zero(A) )
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B4),one_one(A))
                   => ( ( divide_divide(A,one_one(A),A2) = B4 )
                     => ( ( divide_divide(A,one_one(A),B4) = A2 )
                       => ( ( aa(A,A,aa(A,fun(A,A),times_times(A),A2),B4) = one_one(A) )
                         => ( divide_divide(A,C2,A2) != aa(A,A,aa(A,fun(A,A),times_times(A),C2),B4) ) ) ) ) ) ) ) ) ) ).

% is_unitE
tff(fact_2887_evenE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ~ ! [B4: A] : ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B4) ) ) ) ).

% evenE
tff(fact_2888_odd__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),one_one(A)) ) ).

% odd_one
tff(fact_2889_odd__even__add,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A,B2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% odd_even_add
tff(fact_2890_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [Xa: A,M: nat,N: nat] :
          ( ( Xa != zero_zero(A) )
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N))
          <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),one_one(A))
              | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ) ) ).

% dvd_power_iff
tff(fact_2891_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),aa(nat,nat,binomial(N),K)) = semiring_char_0_fact(nat,N) ) ) ).

% binomial_fact_lemma
tff(fact_2892_dvd__power,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat,Xa: A] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
            | ( Xa = one_one(A) ) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)) ) ) ).

% dvd_power
tff(fact_2893_pi__less__4,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) ).

% pi_less_4
tff(fact_2894_pi__ge__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi) ).

% pi_ge_two
tff(fact_2895_div2__even__ext__nat,axiom,
    ! [Xa: nat,Y: nat] :
      ( ( divide_divide(nat,Xa,aa(num,nat,numeral_numeral(nat),bit0(one2))) = divide_divide(nat,Y,aa(num,nat,numeral_numeral(nat),bit0(one2))) )
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Xa)
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Y) )
       => ( Xa = Y ) ) ) ).

% div2_even_ext_nat
tff(fact_2896_choose__dvd,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),semiring_char_0_fact(A,N)) ) ) ).

% choose_dvd
tff(fact_2897_pi__half__neq__two,axiom,
    divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))) != aa(num,real,numeral_numeral(real),bit0(one2)) ).

% pi_half_neq_two
tff(fact_2898_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),M)
      <=> ( N = one_one(nat) ) ) ) ).

% dvd_mult_cancel1
tff(fact_2899_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),M)),M)
      <=> ( N = one_one(nat) ) ) ) ).

% dvd_mult_cancel2
tff(fact_2900_dvd__minus__add,axiom,
    ! [Q2: nat,N: nat,R: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Q2),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Q2),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R),M))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),Q2))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),R),M)),Q2))) ) ) ) ).

% dvd_minus_add
tff(fact_2901_mod__nat__eqI,axiom,
    ! [R: nat,N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),R),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),R),M)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),R))
         => ( modulo_modulo(nat,M,N) = R ) ) ) ) ).

% mod_nat_eqI
tff(fact_2902_power__dvd__imp__le,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),I),N))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),I)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ).

% power_dvd_imp_le
tff(fact_2903_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M != zero_zero(int) )
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(int,int,aa(int,fun(int,int),times_times(int),M),N)),M)
      <=> ( aa(int,int,abs_abs(int),N) = one_one(int) ) ) ) ).

% zdvd_mult_cancel1
tff(fact_2904_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),modulo_modulo(int,K,L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
        | ( ( L = zero_zero(int) )
          & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) )
        | aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L) ) ) ).

% mod_int_pos_iff
tff(fact_2905_fact__numeral,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: num] : ( semiring_char_0_fact(A,aa(num,nat,numeral_numeral(nat),K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),semiring_char_0_fact(A,pred_numeral(K))) ) ) ).

% fact_numeral
tff(fact_2906_bset_I9_J,axiom,
    ! [D2: int,D3: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),T2))
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)),T2)) ) ) ) ).

% bset(9)
tff(fact_2907_bset_I10_J,axiom,
    ! [D2: int,D3: int,B3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,B3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),plus_plus(int),Xb3),Xa4) ) ) )
         => ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),T2))
           => ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),X3),D3)),T2)) ) ) ) ).

% bset(10)
tff(fact_2908_aset_I9_J,axiom,
    ! [D2: int,D3: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
         => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),T2))
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)),T2)) ) ) ) ).

% aset(9)
tff(fact_2909_aset_I10_J,axiom,
    ! [D2: int,D3: int,A3: set(int),T2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),D3)
     => ! [X3: int] :
          ( ! [Xa4: int] :
              ( member(int,Xa4,set_or1337092689740270186AtMost(int,one_one(int),D3))
             => ! [Xb3: int] :
                  ( member(int,Xb3,A3)
                 => ( X3 != aa(int,int,aa(int,fun(int,int),minus_minus(int),Xb3),Xa4) ) ) )
         => ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),T2))
           => ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),X3),D3)),T2)) ) ) ) ).

% aset(10)
tff(fact_2910_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)
     => ( divide_divide(int,K,L) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(int,int,sgn_sgn(int),L))),divide_divide(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L))) ) ) ).

% div_dvd_sgn_abs
tff(fact_2911_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),divide_divide(A,aa(nat,A,semiring_1_of_nat(A),N),aa(nat,A,semiring_1_of_nat(A),K))),K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K))) ) ) ).

% binomial_ge_n_over_k_pow_k
tff(fact_2912_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),K)),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),N)) ).

% binomial_maximum'
tff(fact_2913_binomial__mono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),K8)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K8)),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),K8)) ) ) ).

% binomial_mono
tff(fact_2914_binomial__maximum,axiom,
    ! [N: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))) ).

% binomial_maximum
tff(fact_2915_binomial__antimono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),K8)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))),K)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K8),N)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(N),K8)),aa(nat,nat,binomial(N),K)) ) ) ) ).

% binomial_antimono
tff(fact_2916_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ).

% binomial_le_pow2
tff(fact_2917_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => ( aa(nat,nat,binomial(N),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ) ) ).

% choose_reduce_nat
tff(fact_2918_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,binomial(N),K)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)))) ) ) ).

% times_binomial_minus1_eq
tff(fact_2919_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))) = A2 ) ) ) ).

% even_two_times_div_two
tff(fact_2920_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ) ).

% even_iff_mod_2_eq_zero
tff(fact_2921_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
        <=> ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) = one_one(A) ) ) ) ).

% odd_iff_mod_2_eq_one
tff(fact_2922_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
     => ( aa(nat,nat,binomial(N),K) = divide_divide(nat,semiring_char_0_fact(nat,N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,K)),semiring_char_0_fact(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ).

% binomial_altdef_nat
tff(fact_2923_power__mono__odd,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A2: A,B2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ) ).

% power_mono_odd
tff(fact_2924_odd__pos,axiom,
    ! [N: nat] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ).

% odd_pos
tff(fact_2925_pi__half__neq__zero,axiom,
    divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))) != zero_zero(real) ).

% pi_half_neq_zero
tff(fact_2926_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),K),N))
      <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ).

% dvd_power_iff_le
tff(fact_2927_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2638667681897837118et_bit(A,M,A2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
            | ( M = zero_zero(nat) ) ) ) ) ).

% even_unset_bit_iff
tff(fact_2928_pi__half__less__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% pi_half_less_two
tff(fact_2929_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se5668285175392031749et_bit(A,M,A2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
            & ( M != zero_zero(nat) ) ) ) ) ).

% even_set_bit_iff
tff(fact_2930_pi__half__le__two,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% pi_half_le_two
tff(fact_2931_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se8732182000553998342ip_bit(A,M,A2))
        <=> ~ ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
            <=> ( M = zero_zero(nat) ) ) ) ) ).

% even_flip_bit_iff
tff(fact_2932_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_diff_iff
tff(fact_2933_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),K)),L))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_abs_add_iff
tff(fact_2934_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,abs_abs(int),L)))
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),L)) ) ).

% even_add_abs_iff
tff(fact_2935_binomial__strict__antimono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),K8)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K8),N)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(N),K8)),aa(nat,nat,binomial(N),K)) ) ) ) ).

% binomial_strict_antimono
tff(fact_2936_binomial__strict__mono,axiom,
    ! [K: nat,K8: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),K8)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K8)),N)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),K8)) ) ) ).

% binomial_strict_mono
tff(fact_2937_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,binomial(N),K)),aa(nat,nat,binomial(N),aa(nat,nat,suc,K))) ) ).

% binomial_less_binomial_Suc
tff(fact_2938_binomial__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)) = divide_divide(A,semiring_char_0_fact(A,N),aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))) ) ) ) ).

% binomial_fact
tff(fact_2939_fact__binomial,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K))) = divide_divide(A,semiring_char_0_fact(A,N),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_binomial
tff(fact_2940_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,nat,binomial(N),aa(nat,nat,suc,K)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(nat,nat,suc,K))),aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),K)) ) ) ).

% binomial_addition_formula
tff(fact_2941_oddE,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ~ ! [B4: A] : ( A2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B4)),one_one(A)) ) ) ) ).

% oddE
tff(fact_2942_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2),zero_zero(A),one_one(A)) ) ) ).

% mod2_eq_if
tff(fact_2943_parity__cases,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [A2: A] :
          ( ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
           => ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) != zero_zero(A) ) )
         => ~ ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
             => ( modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) != one_one(A) ) ) ) ) ).

% parity_cases
tff(fact_2944_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_le_power_eq
tff(fact_2945_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A2: A] :
          ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2) ) ) ) ).

% zero_le_odd_power
tff(fact_2946_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)) ) ) ).

% zero_le_even_power
tff(fact_2947_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N),one_one(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ) ).

% minus_one_power_iff
tff(fact_2948_power__mono__even,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A2: A,B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),A2)),aa(A,A,abs_abs(A),B2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) ) ) ) ).

% power_mono_even
tff(fact_2949_pi__half__gt__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% pi_half_gt_zero
tff(fact_2950_pi__half__ge__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% pi_half_ge_zero
tff(fact_2951_m2pi__less__pi,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))),pi) ).

% m2pi_less_pi
tff(fact_2952_arctan__ubound,axiom,
    ! [Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% arctan_ubound
tff(fact_2953_arctan__one,axiom,
    aa(real,real,arctan,one_one(real)) = divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) ).

% arctan_one
tff(fact_2954_choose__two,axiom,
    ! [N: nat] : ( aa(nat,nat,binomial(N),aa(num,nat,numeral_numeral(nat),bit0(one2))) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% choose_two
tff(fact_2955_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N))
        <=> ( ( N = zero_zero(nat) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
              & ( A2 != zero_zero(A) ) )
            | ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2) ) ) ) ) ).

% zero_less_power_eq
tff(fact_2956_minus__pi__half__less__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),zero_zero(real)) ).

% minus_pi_half_less_zero
tff(fact_2957_arctan__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arctan,Y))
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ).

% arctan_bounded
tff(fact_2958_arctan__lbound,axiom,
    ! [Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arctan,Y)) ).

% arctan_lbound
tff(fact_2959_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)))
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ).

% even_mask_div_iff'
tff(fact_2960_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),zero_zero(A))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
            & ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),zero_zero(A)) )
              | ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
                & ( A2 = zero_zero(A) ) ) ) ) ) ) ).

% power_le_zero_eq
tff(fact_2961_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(nat,nat,suc,zero_zero(nat)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% even_mod_4_div_2
tff(fact_2962_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)))
        <=> ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) = zero_zero(A) )
            | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ) ).

% even_mask_div_iff
tff(fact_2963_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2)) )
     => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% odd_mod_4_div_2
tff(fact_2964_Bernoulli__inequality__even,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),Xa))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),Xa)),N)) ) ).

% Bernoulli_inequality_even
tff(fact_2965_machin__Euler,axiom,
    aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,bit0(one2)))),aa(real,real,arctan,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,one2))))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,arctan,divide_divide(real,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,bit0(bit0(one2))))))))))) = divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) ).

% machin_Euler
tff(fact_2966_machin,axiom,
    divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(bit0(one2)))),aa(real,real,arctan,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,bit0(one2))))))),aa(real,real,arctan,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,aa(num,num,bit1,bit0(aa(num,num,bit1,aa(num,num,bit1,one2))))))))))) ).

% machin
tff(fact_2967_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,M: nat,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)))
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
            | ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) = zero_zero(A) )
            | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
              & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))) ) ) ) ) ).

% even_mult_exp_div_exp_iff
tff(fact_2968_sin__coeff__def,axiom,
    ! [X3: nat] :
      ( aa(nat,real,sin_coeff,X3)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X3),zero_zero(real),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X3),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),semiring_char_0_fact(real,X3))) ) ).

% sin_coeff_def
tff(fact_2969_binomial__code,axiom,
    ! [N: nat,K: nat] :
      ( aa(nat,nat,binomial(N),K)
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),K),
          zero_zero(nat),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)),aa(nat,nat,binomial(N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)),divide_divide(nat,set_fo6178422350223883121st_nat(nat,times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)),one_one(nat)),N,one_one(nat)),semiring_char_0_fact(nat,K))) ) ) ).

% binomial_code
tff(fact_2970_cos__coeff__def,axiom,
    ! [X3: nat] :
      ( aa(nat,real,cos_coeff,X3)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),X3),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),divide_divide(nat,X3,aa(num,nat,numeral_numeral(nat),bit0(one2)))),semiring_char_0_fact(real,X3)),zero_zero(real)) ) ).

% cos_coeff_def
tff(fact_2971_sin__cos__npi,axiom,
    ! [N: nat] : ( aa(real,real,sin(real),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),pi),aa(num,real,numeral_numeral(real),bit0(one2)))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),N) ) ).

% sin_cos_npi
tff(fact_2972_cos__pi__eq__zero,axiom,
    ! [M: nat] : ( aa(real,real,cos(real),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)))),aa(num,real,numeral_numeral(real),bit0(one2)))) = zero_zero(real) ) ).

% cos_pi_eq_zero
tff(fact_2973_cot__less__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),divide_divide(real,aa(real,real,uminus_uminus(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cot(real),Xa)),zero_zero(real)) ) ) ).

% cot_less_zero
tff(fact_2974_sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,sin(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sin_zero
tff(fact_2975_cos__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,cos(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,cos(A),Xa) ) ) ).

% cos_minus
tff(fact_2976_sin__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,sin(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,uminus_uminus(A),aa(A,A,sin(A),Xa)) ) ) ).

% sin_minus
tff(fact_2977_cot__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,cot(A),zero_zero(A)) = zero_zero(A) ) ) ).

% cot_zero
tff(fact_2978_cot__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,cot(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,uminus_uminus(A),aa(A,A,cot(A),Xa)) ) ) ).

% cot_minus
tff(fact_2979_cos__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,cos(A),zero_zero(A)) = one_one(A) ) ) ).

% cos_zero
tff(fact_2980_sin__pi,axiom,
    aa(real,real,sin(real),pi) = zero_zero(real) ).

% sin_pi
tff(fact_2981_sin__pi__minus,axiom,
    ! [Xa: real] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),Xa)) = aa(real,real,sin(real),Xa) ) ).

% sin_pi_minus
tff(fact_2982_sin__coeff__0,axiom,
    aa(nat,real,sin_coeff,zero_zero(nat)) = zero_zero(real) ).

% sin_coeff_0
tff(fact_2983_cos__coeff__0,axiom,
    aa(nat,real,cos_coeff,zero_zero(nat)) = one_one(real) ).

% cos_coeff_0
tff(fact_2984_cot__pi,axiom,
    aa(real,real,cot(real),pi) = zero_zero(real) ).

% cot_pi
tff(fact_2985_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,sin(A),real_Vector_of_real(A,pi)) = zero_zero(A) ) ) ).

% sin_of_real_pi
tff(fact_2986_cos__pi,axiom,
    aa(real,real,cos(real),pi) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% cos_pi
tff(fact_2987_cos__periodic__pi2,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),pi),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,cos(real),Xa)) ) ).

% cos_periodic_pi2
tff(fact_2988_cos__periodic__pi,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),pi)) = aa(real,real,uminus_uminus(real),aa(real,real,cos(real),Xa)) ) ).

% cos_periodic_pi
tff(fact_2989_sin__periodic__pi2,axiom,
    ! [Xa: real] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),pi),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,sin(real),Xa)) ) ).

% sin_periodic_pi2
tff(fact_2990_sin__periodic__pi,axiom,
    ! [Xa: real] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),pi)) = aa(real,real,uminus_uminus(real),aa(real,real,sin(real),Xa)) ) ).

% sin_periodic_pi
tff(fact_2991_cos__pi__minus,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,cos(real),Xa)) ) ).

% cos_pi_minus
tff(fact_2992_cos__minus__pi,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),pi)) = aa(real,real,uminus_uminus(real),aa(real,real,cos(real),Xa)) ) ).

% cos_minus_pi
tff(fact_2993_sin__minus__pi,axiom,
    ! [Xa: real] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),pi)) = aa(real,real,uminus_uminus(real),aa(real,real,sin(real),Xa)) ) ).

% sin_minus_pi
tff(fact_2994_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,cos(A),Xa))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),Xa)),aa(A,A,sin(A),Xa))) = one_one(A) ) ) ).

% sin_cos_squared_add3
tff(fact_2995_cos__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,cos(A),real_Vector_of_real(A,pi)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% cos_of_real_pi
tff(fact_2996_sin__npi,axiom,
    ! [N: nat] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = zero_zero(real) ) ).

% sin_npi
tff(fact_2997_sin__npi2,axiom,
    ! [N: nat] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),N))) = zero_zero(real) ) ).

% sin_npi2
tff(fact_2998_sin__npi__int,axiom,
    ! [N: int] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(int,real,ring_1_of_int(real),N))) = zero_zero(real) ) ).

% sin_npi_int
tff(fact_2999_cot__npi,axiom,
    ! [N: nat] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = zero_zero(real) ) ).

% cot_npi
tff(fact_3000_cos__pi__half,axiom,
    aa(real,real,cos(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) = zero_zero(real) ).

% cos_pi_half
tff(fact_3001_sin__two__pi,axiom,
    aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)) = zero_zero(real) ).

% sin_two_pi
tff(fact_3002_sin__pi__half,axiom,
    aa(real,real,sin(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) = one_one(real) ).

% sin_pi_half
tff(fact_3003_cos__two__pi,axiom,
    aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)) = one_one(real) ).

% cos_two_pi
tff(fact_3004_cos__periodic,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = aa(real,real,cos(real),Xa) ) ).

% cos_periodic
tff(fact_3005_sin__periodic,axiom,
    ! [Xa: real] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = aa(real,real,sin(real),Xa) ) ).

% sin_periodic
tff(fact_3006_cos__2pi__minus,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),Xa)) = aa(real,real,cos(real),Xa) ) ).

% cos_2pi_minus
tff(fact_3007_cos__npi2,axiom,
    ! [N: nat] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(nat,real,semiring_1_of_nat(real),N))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),N) ) ).

% cos_npi2
tff(fact_3008_cos__npi,axiom,
    ! [N: nat] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),N) ) ).

% cos_npi
tff(fact_3009_cot__periodic,axiom,
    ! [Xa: real] : ( aa(real,real,cot(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = aa(real,real,cot(real),Xa) ) ).

% cot_periodic
tff(fact_3010_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sin(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add
tff(fact_3011_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sin(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(A) ) ) ).

% sin_cos_squared_add2
tff(fact_3012_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,cos(A),divide_divide(A,real_Vector_of_real(A,pi),aa(num,A,numeral_numeral(A),bit0(one2)))) = zero_zero(A) ) ) ).

% cos_of_real_pi_half
tff(fact_3013_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V7773925162809079976_field(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,sin(A),divide_divide(A,real_Vector_of_real(A,pi),aa(num,A,numeral_numeral(A),bit0(one2)))) = one_one(A) ) ) ).

% sin_of_real_pi_half
tff(fact_3014_sin__2npi,axiom,
    ! [N: nat] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))),pi)) = zero_zero(real) ) ).

% sin_2npi
tff(fact_3015_cos__2npi,axiom,
    ! [N: nat] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(nat,real,semiring_1_of_nat(real),N))),pi)) = one_one(real) ) ).

% cos_2npi
tff(fact_3016_sin__2pi__minus,axiom,
    ! [Xa: real] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,sin(real),Xa)) ) ).

% sin_2pi_minus
tff(fact_3017_sin__int__2pin,axiom,
    ! [N: int] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),aa(int,real,ring_1_of_int(real),N))) = zero_zero(real) ) ).

% sin_int_2pin
tff(fact_3018_cos__int__2pin,axiom,
    ! [N: int] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),aa(int,real,ring_1_of_int(real),N))) = one_one(real) ) ).

% cos_int_2pin
tff(fact_3019_cos__3over2__pi,axiom,
    aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi)) = zero_zero(real) ).

% cos_3over2_pi
tff(fact_3020_sin__3over2__pi,axiom,
    aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi)) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% sin_3over2_pi
tff(fact_3021_cos__npi__int,axiom,
    ! [N: int] :
      ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),pi),aa(int,real,ring_1_of_int(real),N)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),N),one_one(real),aa(real,real,uminus_uminus(real),one_one(real))) ) ).

% cos_npi_int
tff(fact_3022_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),M),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),N),M)
       => ( M = N ) ) ) ).

% dvd_antisym
tff(fact_3023_gcd__nat_Oasym,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
          & ( B2 != A2 ) ) ) ).

% gcd_nat.asym
tff(fact_3024_gcd__nat_Orefl,axiom,
    ! [A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),A2) ).

% gcd_nat.refl
tff(fact_3025_gcd__nat_Otrans,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2) ) ) ).

% gcd_nat.trans
tff(fact_3026_gcd__nat_Oeq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 = B2 )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2) ) ) ).

% gcd_nat.eq_iff
tff(fact_3027_gcd__nat_Oirrefl,axiom,
    ! [A2: nat] :
      ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),A2)
        & ( A2 != A2 ) ) ).

% gcd_nat.irrefl
tff(fact_3028_gcd__nat_Oantisym,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
       => ( A2 = B2 ) ) ) ).

% gcd_nat.antisym
tff(fact_3029_gcd__nat_Ostrict__trans,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
          & ( B2 != C2 ) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans
tff(fact_3030_gcd__nat_Ostrict__trans1,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
          & ( B2 != C2 ) )
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans1
tff(fact_3031_gcd__nat_Ostrict__trans2,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
          & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_trans2
tff(fact_3032_gcd__nat_Ostrict__iff__not,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2) ) ) ).

% gcd_nat.strict_iff_not
tff(fact_3033_gcd__nat_Oorder__iff__strict,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
          & ( A2 != B2 ) )
        | ( A2 = B2 ) ) ) ).

% gcd_nat.order_iff_strict
tff(fact_3034_gcd__nat_Ostrict__iff__order,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) ) ) ).

% gcd_nat.strict_iff_order
tff(fact_3035_gcd__nat_Ostrict__implies__order,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2) ) ).

% gcd_nat.strict_implies_order
tff(fact_3036_gcd__nat_Ostrict__implies__not__eq,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( A2 != B2 ) ) ).

% gcd_nat.strict_implies_not_eq
tff(fact_3037_gcd__nat_Onot__eq__order__implies__strict,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != B2 )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
          & ( A2 != B2 ) ) ) ) ).

% gcd_nat.not_eq_order_implies_strict
tff(fact_3038_diffs__sin__coeff,axiom,
    diffs(real,sin_coeff) = cos_coeff ).

% diffs_sin_coeff
tff(fact_3039_cot__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,cot(A),X3) = divide_divide(A,aa(A,A,cos(A),X3),aa(A,A,sin(A),X3)) ) ) ).

% cot_def
tff(fact_3040_polar__Ex,axiom,
    ! [Xa: real,Y: real] :
    ? [R4: real,A4: real] :
      ( ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),R4),aa(real,real,cos(real),A4)) )
      & ( Y = aa(real,real,aa(real,fun(real,real),times_times(real),R4),aa(real,real,sin(real),A4)) ) ) ).

% polar_Ex
tff(fact_3041_diffs__cos__coeff,axiom,
    ! [X3: nat] : ( aa(nat,real,diffs(real,cos_coeff),X3) = aa(real,real,uminus_uminus(real),aa(nat,real,sin_coeff,X3)) ) ).

% diffs_cos_coeff
tff(fact_3042_cos__of__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: real] : ( aa(A,A,cos(A),real_Vector_of_real(A,Xa)) = real_Vector_of_real(A,aa(real,real,cos(real),Xa)) ) ) ).

% cos_of_real
tff(fact_3043_cot__of__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: real] : ( real_Vector_of_real(A,aa(real,real,cot(real),Xa)) = aa(A,A,cot(A),real_Vector_of_real(A,Xa)) ) ) ).

% cot_of_real
tff(fact_3044_sin__of__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: real] : ( aa(A,A,sin(A),real_Vector_of_real(A,Xa)) = real_Vector_of_real(A,aa(real,real,sin(real),Xa)) ) ) ).

% sin_of_real
tff(fact_3045_sin__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),Xa)),aa(A,A,cos(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,sin(A),Y))) ) ) ).

% sin_diff
tff(fact_3046_sin__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),Xa)),aa(A,A,cos(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,sin(A),Y))) ) ) ).

% sin_add
tff(fact_3047_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,cos(A),Xa) = one_one(A) )
         => ( aa(A,A,sin(A),Xa) = zero_zero(A) ) ) ) ).

% cos_one_sin_zero
tff(fact_3048_cos__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,cos(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),Xa)),aa(A,A,sin(A),Y))) ) ) ).

% cos_diff
tff(fact_3049_cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,cos(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),Xa)),aa(A,A,sin(A),Y))) ) ) ).

% cos_add
tff(fact_3050_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,sin(A),Xa) = zero_zero(A) )
         => ( real_V7770717601297561774m_norm(A,aa(A,A,cos(A),Xa)) = one_one(real) ) ) ) ).

% sin_zero_norm_cos_one
tff(fact_3051_sin__zero__abs__cos__one,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sin(real),Xa) = zero_zero(real) )
     => ( aa(real,real,abs_abs(real),aa(real,real,cos(real),Xa)) = one_one(real) ) ) ).

% sin_zero_abs_cos_one
tff(fact_3052_sin__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,sin(A),Xa))),aa(A,A,cos(A),Xa)) ) ) ).

% sin_double
tff(fact_3053_sincos__principal__value,axiom,
    ! [Xa: real] :
    ? [Y3: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Y3)
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y3),pi)
      & ( aa(real,real,sin(real),Y3) = aa(real,real,sin(real),Xa) )
      & ( aa(real,real,cos(real),Y3) = aa(real,real,cos(real),Xa) ) ) ).

% sincos_principal_value
tff(fact_3054_sin__x__le__x,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sin(real),Xa)),Xa) ) ).

% sin_x_le_x
tff(fact_3055_sin__le__one,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sin(real),Xa)),one_one(real)) ).

% sin_le_one
tff(fact_3056_cos__le__one,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,cos(real),Xa)),one_one(real)) ).

% cos_le_one
tff(fact_3057_abs__sin__x__le__abs__x,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,sin(real),Xa))),aa(real,real,abs_abs(real),Xa)) ).

% abs_sin_x_le_abs_x
tff(fact_3058_cos__arctan__not__zero,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,arctan,Xa)) != zero_zero(real) ) ).

% cos_arctan_not_zero
tff(fact_3059_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [M: int,Xa: real] : ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),M)),real_Vector_of_real(A,Xa))) = real_Vector_of_real(A,aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),M)),Xa))) ) ) ).

% cos_int_times_real
tff(fact_3060_sin__cos__le1,axiom,
    ! [Xa: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sin(real),Xa)),aa(real,real,sin(real),Y))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,cos(real),Xa)),aa(real,real,cos(real),Y))))),one_one(real)) ).

% sin_cos_le1
tff(fact_3061_sin__coeff__Suc,axiom,
    ! [N: nat] : ( aa(nat,real,sin_coeff,aa(nat,nat,suc,N)) = divide_divide(real,aa(nat,real,cos_coeff,N),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))) ) ).

% sin_coeff_Suc
tff(fact_3062_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [M: int,Xa: real] : ( aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),M)),real_Vector_of_real(A,Xa))) = real_Vector_of_real(A,aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),M)),Xa))) ) ) ).

% sin_int_times_real
tff(fact_3063_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sin(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% sin_squared_eq
tff(fact_3064_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sin(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% cos_squared_eq
tff(fact_3065_sin__gt__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),pi)
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sin(real),Xa)) ) ) ).

% sin_gt_zero
tff(fact_3066_sin__x__ge__neg__x,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),Xa)),aa(real,real,sin(real),Xa)) ) ).

% sin_x_ge_neg_x
tff(fact_3067_sin__ge__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sin(real),Xa)) ) ) ).

% sin_ge_zero
tff(fact_3068_sin__ge__minus__one,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(real,real,sin(real),Xa)) ).

% sin_ge_minus_one
tff(fact_3069_cos__monotone__0__pi__le,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,cos(real),Xa)),aa(real,real,cos(real),Y)) ) ) ) ).

% cos_monotone_0_pi_le
tff(fact_3070_cos__mono__le__eq,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),pi)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,cos(real),Xa)),aa(real,real,cos(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),Xa) ) ) ) ) ) ).

% cos_mono_le_eq
tff(fact_3071_cos__inj__pi,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),pi)
           => ( ( aa(real,real,cos(real),Xa) = aa(real,real,cos(real),Y) )
             => ( Xa = Y ) ) ) ) ) ) ).

% cos_inj_pi
tff(fact_3072_sin__times__pi__eq__0,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),pi)) = zero_zero(real) )
    <=> member(real,Xa,ring_1_Ints(real)) ) ).

% sin_times_pi_eq_0
tff(fact_3073_cos__ge__minus__one,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(real,real,cos(real),Xa)) ).

% cos_ge_minus_one
tff(fact_3074_abs__sin__le__one,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,sin(real),Xa))),one_one(real)) ).

% abs_sin_le_one
tff(fact_3075_abs__cos__le__one,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,cos(real),Xa))),one_one(real)) ).

% abs_cos_le_one
tff(fact_3076_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),W)),aa(A,A,sin(A),Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% sin_times_sin
tff(fact_3077_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),W)),aa(A,A,cos(A),Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% sin_times_cos
tff(fact_3078_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),W)),aa(A,A,sin(A),Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% cos_times_sin
tff(fact_3079_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,sin(A),W)),aa(A,A,sin(A),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,sin(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z),aa(num,A,numeral_numeral(A),bit0(one2)))))),aa(A,A,cos(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% sin_plus_sin
tff(fact_3080_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,sin(A),W)),aa(A,A,sin(A),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,sin(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z),aa(num,A,numeral_numeral(A),bit0(one2)))))),aa(A,A,cos(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% sin_diff_sin
tff(fact_3081_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,cos(A),W)),aa(A,A,cos(A),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,sin(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z),aa(num,A,numeral_numeral(A),bit0(one2)))))),aa(A,A,sin(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Z),W),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% cos_diff_cos
tff(fact_3082_cos__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sin(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% cos_double
tff(fact_3083_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,sin(A),Xa) = aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,real_Vector_of_real(A,pi),aa(num,A,numeral_numeral(A),bit0(one2)))),Xa)) ) ) ).

% sin_cos_eq
tff(fact_3084_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,cos(A),Xa) = aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,real_Vector_of_real(A,pi),aa(num,A,numeral_numeral(A),bit0(one2)))),Xa)) ) ) ).

% cos_sin_eq
tff(fact_3085_cos__coeff__Suc,axiom,
    ! [N: nat] : ( aa(nat,real,cos_coeff,aa(nat,nat,suc,N)) = divide_divide(real,aa(real,real,uminus_uminus(real),aa(nat,real,sin_coeff,N)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N))) ) ).

% cos_coeff_Suc
tff(fact_3086_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sin(A),W)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% cos_double_sin
tff(fact_3087_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,sin(A),Xa)) = aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),divide_divide(A,real_Vector_of_real(A,pi),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% minus_sin_cos_eq
tff(fact_3088_cos__two__neq__zero,axiom,
    aa(real,real,cos(real),aa(num,real,numeral_numeral(real),bit0(one2))) != zero_zero(real) ).

% cos_two_neq_zero
tff(fact_3089_cos__mono__less__eq,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),pi)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cos(real),Xa)),aa(real,real,cos(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa) ) ) ) ) ) ).

% cos_mono_less_eq
tff(fact_3090_cos__monotone__0__pi,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cos(real),Xa)),aa(real,real,cos(real),Y)) ) ) ) ).

% cos_monotone_0_pi
tff(fact_3091_sin__eq__0__pi,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),pi)
       => ( ( aa(real,real,sin(real),Xa) = zero_zero(real) )
         => ( Xa = zero_zero(real) ) ) ) ) ).

% sin_eq_0_pi
tff(fact_3092_sin__zero__pi__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),pi)
     => ( ( aa(real,real,sin(real),Xa) = zero_zero(real) )
      <=> ( Xa = zero_zero(real) ) ) ) ).

% sin_zero_pi_iff
tff(fact_3093_cos__monotone__minus__pi__0_H,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,cos(real),Y)),aa(real,real,cos(real),Xa)) ) ) ) ).

% cos_monotone_minus_pi_0'
tff(fact_3094_sin__zero__iff__int2,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sin(real),Xa) = zero_zero(real) )
    <=> ? [I3: int] : ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I3)),pi) ) ) ).

% sin_zero_iff_int2
tff(fact_3095_sincos__total__pi,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
       => ? [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),pi)
            & ( Xa = aa(real,real,cos(real),T4) )
            & ( Y = aa(real,real,sin(real),T4) ) ) ) ) ).

% sincos_total_pi
tff(fact_3096_sin__expansion__lemma,axiom,
    ! [Xa: real,M: nat] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,M))),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) = aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ).

% sin_expansion_lemma
tff(fact_3097_cos__expansion__lemma,axiom,
    ! [Xa: real,M: nat] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,M))),pi),aa(num,real,numeral_numeral(real),bit0(one2))))) = aa(real,real,uminus_uminus(real),aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),M)),pi),aa(num,real,numeral_numeral(real),bit0(one2)))))) ) ).

% cos_expansion_lemma
tff(fact_3098_sin__gt__zero__02,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(num,real,numeral_numeral(real),bit0(one2)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sin(real),Xa)) ) ) ).

% sin_gt_zero_02
tff(fact_3099_cos__two__less__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cos(real),aa(num,real,numeral_numeral(real),bit0(one2)))),zero_zero(real)) ).

% cos_two_less_zero
tff(fact_3100_cos__is__zero,axiom,
    ? [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),aa(num,real,numeral_numeral(real),bit0(one2)))
      & ( aa(real,real,cos(real),X) = zero_zero(real) )
      & ! [Y4: real] :
          ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),aa(num,real,numeral_numeral(real),bit0(one2)))
            & ( aa(real,real,cos(real),Y4) = zero_zero(real) ) )
         => ( Y4 = X ) ) ) ).

% cos_is_zero
tff(fact_3101_cos__two__le__zero,axiom,
    aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,cos(real),aa(num,real,numeral_numeral(real),bit0(one2)))),zero_zero(real)) ).

% cos_two_le_zero
tff(fact_3102_cos__monotone__minus__pi__0,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cos(real),Y)),aa(real,real,cos(real),Xa)) ) ) ) ).

% cos_monotone_minus_pi_0
tff(fact_3103_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType,F3: fun(nat,fun(A,A)),A2: nat,B2: nat,Acc: A] :
      ( set_fo6178422350223883121st_nat(A,F3,A2,B2,Acc)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),B2),A2),Acc,set_fo6178422350223883121st_nat(A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),one_one(nat)),B2,aa(A,A,aa(nat,fun(A,A),F3,A2),Acc))) ) ).

% fold_atLeastAtMost_nat.simps
tff(fact_3104_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,Xa: fun(nat,fun(A,A)),Xaa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( set_fo6178422350223883121st_nat(A,Xa,Xaa,Xb,Xc) = Y )
     => ( Y
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xb),Xaa),Xc,set_fo6178422350223883121st_nat(A,Xa,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xaa),one_one(nat)),Xb,aa(A,A,aa(nat,fun(A,A),Xa,Xaa),Xc))) ) ) ).

% fold_atLeastAtMost_nat.elims
tff(fact_3105_cos__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ? [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),pi)
            & ( aa(real,real,cos(real),X) = Y )
            & ! [Y4: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),pi)
                  & ( aa(real,real,cos(real),Y4) = Y ) )
               => ( Y4 = X ) ) ) ) ) ).

% cos_total
tff(fact_3106_sincos__total__pi__half,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
         => ? [T4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
              & ( Xa = aa(real,real,cos(real),T4) )
              & ( Y = aa(real,real,sin(real),T4) ) ) ) ) ) ).

% sincos_total_pi_half
tff(fact_3107_sincos__total__2pi__le,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
     => ? [T4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))
          & ( Xa = aa(real,real,cos(real),T4) )
          & ( Y = aa(real,real,sin(real),T4) ) ) ) ).

% sincos_total_2pi_le
tff(fact_3108_sincos__total__2pi,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) )
     => ~ ! [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))
             => ( ( Xa = aa(real,real,cos(real),T4) )
               => ( Y != aa(real,real,sin(real),T4) ) ) ) ) ) ).

% sincos_total_2pi
tff(fact_3109_sin__integer__2pi,axiom,
    ! [N: real] :
      ( member(real,N,ring_1_Ints(real))
     => ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),N)) = zero_zero(real) ) ) ).

% sin_integer_2pi
tff(fact_3110_cos__integer__2pi,axiom,
    ! [N: real] :
      ( member(real,N,ring_1_Ints(real))
     => ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),N)) = one_one(real) ) ) ).

% cos_integer_2pi
tff(fact_3111_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sin(real),divide_divide(real,pi,aa(nat,real,semiring_1_of_nat(real),N)))) ) ).

% sin_pi_divide_n_ge_0
tff(fact_3112_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,cos(A),W)),aa(A,A,cos(A),Z)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,cos(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z),aa(num,A,numeral_numeral(A),bit0(one2)))))),aa(A,A,cos(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z),aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% cos_plus_cos
tff(fact_3113_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),W)),aa(A,A,cos(A),Z)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),W),Z))),aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),W),Z))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% cos_times_cos
tff(fact_3114_sin__gt__zero2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sin(real),Xa)) ) ) ).

% sin_gt_zero2
tff(fact_3115_sin__lt__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),pi),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sin(real),Xa)),zero_zero(real)) ) ) ).

% sin_lt_zero
tff(fact_3116_cos__double__less__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(num,real,numeral_numeral(real),bit0(one2)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),Xa))),one_one(real)) ) ) ).

% cos_double_less_one
tff(fact_3117_sin__30,axiom,
    aa(real,real,sin(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(aa(num,num,bit1,one2))))) = divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% sin_30
tff(fact_3118_cos__gt__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,cos(real),Xa)) ) ) ).

% cos_gt_zero
tff(fact_3119_sin__monotone__2pi__le,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sin(real),Y)),aa(real,real,sin(real),Xa)) ) ) ) ).

% sin_monotone_2pi_le
tff(fact_3120_sin__mono__le__eq,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sin(real),Xa)),aa(real,real,sin(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ) ) ) ) ).

% sin_mono_le_eq
tff(fact_3121_sin__inj__pi,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( ( aa(real,real,sin(real),Xa) = aa(real,real,sin(real),Y) )
             => ( Xa = Y ) ) ) ) ) ) ).

% sin_inj_pi
tff(fact_3122_cos__60,axiom,
    aa(real,real,cos(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% cos_60
tff(fact_3123_cos__one__2pi__int,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,cos(real),Xa) = one_one(real) )
    <=> ? [X4: int] : ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),X4)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi) ) ) ).

% cos_one_2pi_int
tff(fact_3124_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [W: A] : ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),W)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),W)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),one_one(A)) ) ) ).

% cos_double_cos
tff(fact_3125_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))),Xa)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),Xa)),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,one2))),aa(A,A,cos(A),Xa))) ) ) ).

% cos_treble_cos
tff(fact_3126_sin__le__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),pi),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sin(real),Xa)),zero_zero(real)) ) ) ).

% sin_le_zero
tff(fact_3127_sin__less__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),divide_divide(real,aa(real,real,uminus_uminus(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sin(real),Xa)),zero_zero(real)) ) ) ).

% sin_less_zero
tff(fact_3128_sin__monotone__2pi,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sin(real),Y)),aa(real,real,sin(real),Xa)) ) ) ) ).

% sin_monotone_2pi
tff(fact_3129_sin__mono__less__eq,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sin(real),Xa)),aa(real,real,sin(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ) ) ) ) ).

% sin_mono_less_eq
tff(fact_3130_sin__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ? [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),X)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
            & ( aa(real,real,sin(real),X) = Y )
            & ! [Y4: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
                  & ( aa(real,real,sin(real),Y4) = Y ) )
               => ( Y4 = X ) ) ) ) ) ).

% sin_total
tff(fact_3131_cos__gt__zero__pi,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,cos(real),Xa)) ) ) ).

% cos_gt_zero_pi
tff(fact_3132_cos__ge__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,cos(real),Xa)) ) ) ).

% cos_ge_zero
tff(fact_3133_cos__one__2pi,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,cos(real),Xa) = one_one(real) )
    <=> ( ? [X4: nat] : ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X4)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi) )
        | ? [X4: nat] : ( Xa = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),X4)),aa(num,real,numeral_numeral(real),bit0(one2)))),pi)) ) ) ) ).

% cos_one_2pi
tff(fact_3134_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sin(real),divide_divide(real,pi,aa(nat,real,semiring_1_of_nat(real),N)))) ) ).

% sin_pi_divide_n_gt_0
tff(fact_3135_sin__zero__iff__int,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sin(real),Xa) = zero_zero(real) )
    <=> ? [I3: int] :
          ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),I3)
          & ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I3)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ).

% sin_zero_iff_int
tff(fact_3136_cos__zero__iff__int,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,cos(real),Xa) = zero_zero(real) )
    <=> ? [I3: int] :
          ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),I3)
          & ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I3)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ).

% cos_zero_iff_int
tff(fact_3137_cot__gt__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,cot(real),Xa)) ) ) ).

% cot_gt_zero
tff(fact_3138_sin__zero__lemma,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( ( aa(real,real,sin(real),Xa) = zero_zero(real) )
       => ? [N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2)
            & ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N2)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ) ).

% sin_zero_lemma
tff(fact_3139_sin__zero__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sin(real),Xa) = zero_zero(real) )
    <=> ( ? [N5: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5)
            & ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N5)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) )
        | ? [N5: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5)
            & ( Xa = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N5)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ) ) ).

% sin_zero_iff
tff(fact_3140_cos__zero__lemma,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( ( aa(real,real,cos(real),Xa) = zero_zero(real) )
       => ? [N2: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N2)
            & ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N2)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ) ).

% cos_zero_lemma
tff(fact_3141_cos__zero__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,cos(real),Xa) = zero_zero(real) )
    <=> ( ? [N5: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5)
            & ( Xa = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N5)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) )
        | ? [N5: nat] :
            ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5)
            & ( Xa = aa(real,real,uminus_uminus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N5)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))) ) ) ) ) ).

% cos_zero_iff
tff(fact_3142_fact__code,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),set_fo6178422350223883121st_nat(nat,times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2)),N,one_one(nat))) ) ) ).

% fact_code
tff(fact_3143_tan__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => ( ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)) != zero_zero(A) )
           => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,tan(A),Xa)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,tan(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ) ) ).

% tan_double
tff(fact_3144_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm(complex,Z) = one_one(real) )
     => ~ ! [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))
             => ( Z != complex2(aa(real,real,cos(real),T4),aa(real,real,sin(real),T4)) ) ) ) ) ).

% complex_unimodular_polar
tff(fact_3145_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K3: int] : ( aa(real,real,arccos,aa(real,real,cos(real),Theta)) != aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Theta),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),K3)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)))) ) ).

% arccos_cos_eq_abs_2pi
tff(fact_3146_le__arcsin__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),divide_divide(real,aa(real,real,uminus_uminus(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,arcsin,Xa))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sin(real),Y)),Xa) ) ) ) ) ) ).

% le_arcsin_iff
tff(fact_3147_arcsin__le__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),divide_divide(real,aa(real,real,uminus_uminus(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Xa)),Y)
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(real,real,sin(real),Y)) ) ) ) ) ) ).

% arcsin_le_iff
tff(fact_3148_tan__pi,axiom,
    aa(real,real,tan(real),pi) = zero_zero(real) ).

% tan_pi
tff(fact_3149_tan__zero,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ( aa(A,A,tan(A),zero_zero(A)) = zero_zero(A) ) ) ).

% tan_zero
tff(fact_3150_tan__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,tan(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,uminus_uminus(A),aa(A,A,tan(A),Xa)) ) ) ).

% tan_minus
tff(fact_3151_tan__periodic__pi,axiom,
    ! [Xa: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),pi)) = aa(real,real,tan(real),Xa) ) ).

% tan_periodic_pi
tff(fact_3152_arcsin__0,axiom,
    aa(real,real,arcsin,zero_zero(real)) = zero_zero(real) ).

% arcsin_0
tff(fact_3153_arccos__1,axiom,
    aa(real,real,arccos,one_one(real)) = zero_zero(real) ).

% arccos_1
tff(fact_3154_tan__npi,axiom,
    ! [N: nat] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi)) = zero_zero(real) ) ).

% tan_npi
tff(fact_3155_tan__periodic__n,axiom,
    ! [Xa: real,N: num] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),N)),pi))) = aa(real,real,tan(real),Xa) ) ).

% tan_periodic_n
tff(fact_3156_tan__periodic__nat,axiom,
    ! [Xa: real,N: nat] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),pi))) = aa(real,real,tan(real),Xa) ) ).

% tan_periodic_nat
tff(fact_3157_tan__periodic__int,axiom,
    ! [Xa: real,I: int] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),I)),pi))) = aa(real,real,tan(real),Xa) ) ).

% tan_periodic_int
tff(fact_3158_arccos__minus__1,axiom,
    aa(real,real,arccos,aa(real,real,uminus_uminus(real),one_one(real))) = pi ).

% arccos_minus_1
tff(fact_3159_cos__arccos,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,real,cos(real),aa(real,real,arccos,Y)) = Y ) ) ) ).

% cos_arccos
tff(fact_3160_sin__arcsin,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,real,sin(real),aa(real,real,arcsin,Y)) = Y ) ) ) ).

% sin_arcsin
tff(fact_3161_norm__cos__sin,axiom,
    ! [T2: real] : ( real_V7770717601297561774m_norm(complex,complex2(aa(real,real,cos(real),T2),aa(real,real,sin(real),T2))) = one_one(real) ) ).

% norm_cos_sin
tff(fact_3162_tan__periodic,axiom,
    ! [Xa: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) = aa(real,real,tan(real),Xa) ) ).

% tan_periodic
tff(fact_3163_arccos__0,axiom,
    aa(real,real,arccos,zero_zero(real)) = divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))) ).

% arccos_0
tff(fact_3164_arcsin__1,axiom,
    aa(real,real,arcsin,one_one(real)) = divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))) ).

% arcsin_1
tff(fact_3165_arcsin__minus__1,axiom,
    aa(real,real,arcsin,aa(real,real,uminus_uminus(real),one_one(real))) = aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ).

% arcsin_minus_1
tff(fact_3166_tan__of__real,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: real] : ( real_Vector_of_real(A,aa(real,real,tan(real),Xa)) = aa(A,A,tan(A),real_Vector_of_real(A,Xa)) ) ) ).

% tan_of_real
tff(fact_3167_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = zero_zero(complex) )
    <=> ( ( A2 = zero_zero(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_0
tff(fact_3168_zero__complex_Ocode,axiom,
    zero_zero(complex) = complex2(zero_zero(real),zero_zero(real)) ).

% zero_complex.code
tff(fact_3169_complex__eq__cancel__iff2,axiom,
    ! [Xa: real,Y: real,Xaa: real] :
      ( ( complex2(Xa,Y) = real_Vector_of_real(complex,Xaa) )
    <=> ( ( Xa = Xaa )
        & ( Y = zero_zero(real) ) ) ) ).

% complex_eq_cancel_iff2
tff(fact_3170_complex__of__real__code,axiom,
    ! [X3: real] : ( real_Vector_of_real(complex,X3) = complex2(X3,zero_zero(real)) ) ).

% complex_of_real_code
tff(fact_3171_complex__of__real__def,axiom,
    ! [R: real] : ( real_Vector_of_real(complex,R) = complex2(R,zero_zero(real)) ) ).

% complex_of_real_def
tff(fact_3172_Complex__mult__complex__of__real,axiom,
    ! [Xa: real,Y: real,R: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(Xa,Y)),real_Vector_of_real(complex,R)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),Xa),R),aa(real,real,aa(real,fun(real,real),times_times(real),Y),R)) ) ).

% Complex_mult_complex_of_real
tff(fact_3173_complex__of__real__mult__Complex,axiom,
    ! [R: real,Xa: real,Y: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R)),complex2(Xa,Y)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R),Xa),aa(real,real,aa(real,fun(real,real),times_times(real),R),Y)) ) ).

% complex_of_real_mult_Complex
tff(fact_3174_complex__diff,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),complex2(A2,B2)),complex2(C2,D2)) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),C2),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),D2)) ) ).

% complex_diff
tff(fact_3175_tan__arctan,axiom,
    ! [Y: real] : ( aa(real,real,tan(real),aa(real,real,arctan,Y)) = Y ) ).

% tan_arctan
tff(fact_3176_one__complex_Ocode,axiom,
    one_one(complex) = complex2(one_one(real),zero_zero(real)) ).

% one_complex.code
tff(fact_3177_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = one_one(complex) )
    <=> ( ( A2 = one_one(real) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_1
tff(fact_3178_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( complex2(A2,B2) = aa(num,complex,numeral_numeral(complex),W) )
    <=> ( ( A2 = aa(num,real,numeral_numeral(real),W) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_numeral
tff(fact_3179_cot__altdef,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,cot(A),Xa) = aa(A,A,inverse_inverse(A),aa(A,A,tan(A),Xa)) ) ) ).

% cot_altdef
tff(fact_3180_tan__altdef,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,tan(A),Xa) = aa(A,A,inverse_inverse(A),aa(A,A,cot(A),Xa)) ) ) ).

% tan_altdef
tff(fact_3181_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( complex2(A2,B2) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) )
    <=> ( ( A2 = aa(real,real,uminus_uminus(real),one_one(real)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_1
tff(fact_3182_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( complex2(A2,B2) = aa(complex,complex,uminus_uminus(complex),aa(num,complex,numeral_numeral(complex),W)) )
    <=> ( ( A2 = aa(real,real,uminus_uminus(real),aa(num,real,numeral_numeral(real),W)) )
        & ( B2 = zero_zero(real) ) ) ) ).

% Complex_eq_neg_numeral
tff(fact_3183_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(A2,B2)),complex2(C2,D2)) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A2),C2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),D2)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),A2),D2)),aa(real,real,aa(real,fun(real,real),times_times(real),B2),C2))) ) ).

% complex_mult
tff(fact_3184_arccos__le__arccos,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),aa(real,real,arccos,Xa)) ) ) ) ).

% arccos_le_arccos
tff(fact_3185_arccos__le__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Xa)),aa(real,real,arccos,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),Xa) ) ) ) ).

% arccos_le_mono
tff(fact_3186_arccos__eq__iff,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real)) )
     => ( ( aa(real,real,arccos,Xa) = aa(real,real,arccos,Y) )
      <=> ( Xa = Y ) ) ) ).

% arccos_eq_iff
tff(fact_3187_arcsin__le__arcsin,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Xa)),aa(real,real,arcsin,Y)) ) ) ) ).

% arcsin_le_arcsin
tff(fact_3188_arcsin__minus,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => ( aa(real,real,arcsin,aa(real,real,uminus_uminus(real),Xa)) = aa(real,real,uminus_uminus(real),aa(real,real,arcsin,Xa)) ) ) ) ).

% arcsin_minus
tff(fact_3189_arcsin__le__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Xa)),aa(real,real,arcsin,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ) ) ).

% arcsin_le_mono
tff(fact_3190_arcsin__eq__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( ( aa(real,real,arcsin,Xa) = aa(real,real,arcsin,Y) )
        <=> ( Xa = Y ) ) ) ) ).

% arcsin_eq_iff
tff(fact_3191_tan__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: A] : ( aa(A,A,tan(A),X3) = divide_divide(A,aa(A,A,sin(A),X3),aa(A,A,cos(A),X3)) ) ) ).

% tan_def
tff(fact_3192_arccos__lbound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y)) ) ) ).

% arccos_lbound
tff(fact_3193_arccos__less__arccos,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,Y)),aa(real,real,arccos,Xa)) ) ) ) ).

% arccos_less_arccos
tff(fact_3194_arccos__less__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,Xa)),aa(real,real,arccos,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa) ) ) ) ).

% arccos_less_mono
tff(fact_3195_arccos__ubound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),pi) ) ) ).

% arccos_ubound
tff(fact_3196_arccos__cos,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
       => ( aa(real,real,arccos,aa(real,real,cos(real),Xa)) = Xa ) ) ) ).

% arccos_cos
tff(fact_3197_arcsin__less__arcsin,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,Xa)),aa(real,real,arcsin,Y)) ) ) ) ).

% arcsin_less_arcsin
tff(fact_3198_arcsin__less__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,Xa)),aa(real,real,arcsin,Y))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ) ) ).

% arcsin_less_mono
tff(fact_3199_cos__arccos__abs,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
     => ( aa(real,real,cos(real),aa(real,real,arccos,Y)) = Y ) ) ).

% cos_arccos_abs
tff(fact_3200_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Theta)),pi)
     => ( aa(real,real,arccos,aa(real,real,cos(real),Theta)) = aa(real,real,abs_abs(real),Theta) ) ) ).

% arccos_cos_eq_abs
tff(fact_3201_tan__45,axiom,
    aa(real,real,tan(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2))))) = one_one(real) ).

% tan_45
tff(fact_3202_arccos__lt__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,arccos,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arccos,Y)),pi) ) ) ) ).

% arccos_lt_bounded
tff(fact_3203_arccos__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),pi) ) ) ) ).

% arccos_bounded
tff(fact_3204_sin__arccos__nonzero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => ( aa(real,real,sin(real),aa(real,real,arccos,Xa)) != zero_zero(real) ) ) ) ).

% sin_arccos_nonzero
tff(fact_3205_arccos__cos2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),pi)),Xa)
       => ( aa(real,real,arccos,aa(real,real,cos(real),Xa)) = aa(real,real,uminus_uminus(real),Xa) ) ) ) ).

% arccos_cos2
tff(fact_3206_arccos__minus,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => ( aa(real,real,arccos,aa(real,real,uminus_uminus(real),Xa)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),aa(real,real,arccos,Xa)) ) ) ) ).

% arccos_minus
tff(fact_3207_cos__arcsin__nonzero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => ( aa(real,real,cos(real),aa(real,real,arcsin,Xa)) != zero_zero(real) ) ) ) ).

% cos_arcsin_nonzero
tff(fact_3208_lemma__tan__total,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y)
     => ? [X: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),X)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),aa(real,real,tan(real),X)) ) ) ).

% lemma_tan_total
tff(fact_3209_tan__gt__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,tan(real),Xa)) ) ) ).

% tan_gt_zero
tff(fact_3210_tan__total,axiom,
    ! [Y: real] :
    ? [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),X)
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
      & ( aa(real,real,tan(real),X) = Y )
      & ! [Y4: real] :
          ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
            & ( aa(real,real,tan(real),Y4) = Y ) )
         => ( Y4 = X ) ) ) ).

% tan_total
tff(fact_3211_tan__monotone,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Y)),aa(real,real,tan(real),Xa)) ) ) ) ).

% tan_monotone
tff(fact_3212_tan__monotone_H,axiom,
    ! [Y: real,Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),Xa)
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Y)),aa(real,real,tan(real),Xa)) ) ) ) ) ) ).

% tan_monotone'
tff(fact_3213_tan__mono__lt__eq,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Xa)),aa(real,real,tan(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ) ) ) ) ).

% tan_mono_lt_eq
tff(fact_3214_lemma__tan__total1,axiom,
    ! [Y: real] :
    ? [X: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),X)
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
      & ( aa(real,real,tan(real),X) = Y ) ) ).

% lemma_tan_total1
tff(fact_3215_tan__minus__45,axiom,
    aa(real,real,tan(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))))) = aa(real,real,uminus_uminus(real),one_one(real)) ).

% tan_minus_45
tff(fact_3216_tan__inverse,axiom,
    ! [Y: real] : ( divide_divide(real,one_one(real),aa(real,real,tan(real),Y)) = aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))),Y)) ) ).

% tan_inverse
tff(fact_3217_tan__cot,axiom,
    ! [Xa: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))),Xa)) = aa(real,real,inverse_inverse(real),aa(real,real,tan(real),Xa)) ) ).

% tan_cot
tff(fact_3218_arccos,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,arccos,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),pi)
          & ( aa(real,real,cos(real),aa(real,real,arccos,Y)) = Y ) ) ) ) ).

% arccos
tff(fact_3219_arccos__minus__abs,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,real,arccos,aa(real,real,uminus_uminus(real),Xa)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),pi),aa(real,real,arccos,Xa)) ) ) ).

% arccos_minus_abs
tff(fact_3220_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => ( ( aa(A,A,cos(A),Y) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),Xa)),aa(A,A,tan(A),Y)) = divide_divide(A,aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,cos(A),Y))) ) ) ) ) ).

% add_tan_eq
tff(fact_3221_tan__cot_H,axiom,
    ! [Xa: real] : ( aa(real,real,tan(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))),Xa)) = aa(real,real,cot(real),Xa) ) ).

% tan_cot'
tff(fact_3222_tan__pos__pi2__le,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,tan(real),Xa)) ) ) ).

% tan_pos_pi2_le
tff(fact_3223_tan__total__pos,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ? [X: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),X)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
          & ( aa(real,real,tan(real),X) = Y ) ) ) ).

% tan_total_pos
tff(fact_3224_tan__less__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),divide_divide(real,aa(real,real,uminus_uminus(real),pi),aa(num,real,numeral_numeral(real),bit0(one2)))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,tan(real),Xa)),zero_zero(real)) ) ) ).

% tan_less_zero
tff(fact_3225_tan__mono__le,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tan(real),Xa)),aa(real,real,tan(real),Y)) ) ) ) ).

% tan_mono_le
tff(fact_3226_tan__mono__le__eq,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,tan(real),Xa)),aa(real,real,tan(real),Y))
            <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ) ) ) ) ).

% tan_mono_le_eq
tff(fact_3227_tan__bound__pi2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))))
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,tan(real),Xa))),one_one(real)) ) ).

% tan_bound_pi2
tff(fact_3228_arctan,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arctan,Y))
      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arctan,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
      & ( aa(real,real,tan(real),aa(real,real,arctan,Y)) = Y ) ) ).

% arctan
tff(fact_3229_arctan__tan,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,real,arctan,aa(real,real,tan(real),Xa)) = Xa ) ) ) ).

% arctan_tan
tff(fact_3230_arctan__unique,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( ( aa(real,real,tan(real),Xa) = Y )
         => ( aa(real,real,arctan,Y) = Xa ) ) ) ) ).

% arctan_unique
tff(fact_3231_tan__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => ( ( aa(A,A,cos(A),Y) != zero_zero(A) )
           => ( ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,tan(A),Xa)),aa(A,A,tan(A),Y)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),Xa)),aa(A,A,tan(A),Y)))) ) ) ) ) ) ).

% tan_add
tff(fact_3232_tan__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => ( ( aa(A,A,cos(A),Y) != zero_zero(A) )
           => ( ( aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) != zero_zero(A) )
             => ( aa(A,A,tan(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,tan(A),Xa)),aa(A,A,tan(A),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),Xa)),aa(A,A,tan(A),Y)))) ) ) ) ) ) ).

% tan_diff
tff(fact_3233_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => ( ( aa(A,A,cos(A),Y) != zero_zero(A) )
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,tan(A),Xa)),aa(A,A,tan(A),Y))) = divide_divide(A,aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,cos(A),Y))) ) ) ) ) ).

% lemma_tan_add1
tff(fact_3234_tan__total__pi4,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ? [Z4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))))),Z4)
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z4),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))))
          & ( aa(real,real,tan(real),Z4) = Xa ) ) ) ).

% tan_total_pi4
tff(fact_3235_arccos__le__pi2,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arccos,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ).

% arccos_le_pi2
tff(fact_3236_arcsin__lt__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,arcsin,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ).

% arcsin_lt_bounded
tff(fact_3237_arcsin__lbound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y)) ) ) ).

% arcsin_lbound
tff(fact_3238_arcsin__ubound,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ).

% arcsin_ubound
tff(fact_3239_arcsin__bounded,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ) ).

% arcsin_bounded
tff(fact_3240_arcsin__sin,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,real,arcsin,aa(real,real,sin(real),Xa)) = Xa ) ) ) ).

% arcsin_sin
tff(fact_3241_tan__sec,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,tan(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),aa(A,A,cos(A),Xa))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ) ) ).

% tan_sec
tff(fact_3242_tan__half,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,tan(A),Xa) = divide_divide(A,aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa))),one_one(A))) ) ) ).

% tan_half
tff(fact_3243_arcsin,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
          & ( aa(real,real,sin(real),aa(real,real,arcsin,Y)) = Y ) ) ) ) ).

% arcsin
tff(fact_3244_arcsin__pi,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Y)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),one_one(real))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),aa(real,real,arcsin,Y))
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,arcsin,Y)),pi)
          & ( aa(real,real,sin(real),aa(real,real,arcsin,Y)) = Y ) ) ) ) ).

% arcsin_pi
tff(fact_3245_sin__tan,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
     => ( aa(real,real,sin(real),Xa) = divide_divide(real,aa(real,real,tan(real),Xa),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,tan(real),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% sin_tan
tff(fact_3246_cos__tan,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
     => ( aa(real,real,cos(real),Xa) = divide_divide(real,one_one(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,tan(real),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% cos_tan
tff(fact_3247_flip__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( bit_se8732182000553998342ip_bit(A,zero_zero(nat),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% flip_bit_0
tff(fact_3248_set__decode__Suc,axiom,
    ! [N: nat,Xa: nat] :
      ( member(nat,aa(nat,nat,suc,N),nat_set_decode(Xa))
    <=> member(nat,N,nat_set_decode(divide_divide(nat,Xa,aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% set_decode_Suc
tff(fact_3249_set__decode__0,axiom,
    ! [Xa: nat] :
      ( member(nat,zero_zero(nat),nat_set_decode(Xa))
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Xa) ) ).

% set_decode_0
tff(fact_3250_nat__of__bool,axiom,
    ! [P: $o] : ( aa(int,nat,nat2,aa($o,int,zero_neq_one_of_bool(int),P)) = aa($o,nat,zero_neq_one_of_bool(nat),P) ) ).

% nat_of_bool
tff(fact_3251_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: $o,Q: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q))
        <=> ( (P)
           => (Q) ) ) ) ).

% of_bool_less_eq_iff
tff(fact_3252_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa($o,A,zero_neq_one_of_bool(A),$false) = zero_zero(A) ) ) ).

% of_bool_eq(1)
tff(fact_3253_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P) = zero_zero(A) )
        <=> ~ (P) ) ) ).

% of_bool_eq_0_iff
tff(fact_3254_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [P: $o,Q: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q))
        <=> ( ~ (P)
            & (Q) ) ) ) ).

% of_bool_less_iff
tff(fact_3255_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ( aa($o,A,zero_neq_one_of_bool(A),$true) = one_one(A) ) ) ).

% of_bool_eq(2)
tff(fact_3256_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P) = one_one(A) )
        <=> (P) ) ) ).

% of_bool_eq_1_iff
tff(fact_3257_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sqrt,Xa) = zero_zero(real) )
    <=> ( Xa = zero_zero(real) ) ) ).

% real_sqrt_eq_zero_cancel_iff
tff(fact_3258_real__sqrt__zero,axiom,
    aa(real,real,sqrt,zero_zero(real)) = zero_zero(real) ).

% real_sqrt_zero
tff(fact_3259_real__sqrt__le__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,Xa)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ).

% real_sqrt_le_iff
tff(fact_3260_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: $o] : ( aa(nat,A,semiring_1_of_nat(A),aa($o,nat,zero_neq_one_of_bool(nat),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% of_nat_of_bool
tff(fact_3261_real__sqrt__eq__1__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sqrt,Xa) = one_one(real) )
    <=> ( Xa = one_one(real) ) ) ).

% real_sqrt_eq_1_iff
tff(fact_3262_real__sqrt__one,axiom,
    aa(real,real,sqrt,one_one(real)) = one_one(real) ).

% real_sqrt_one
tff(fact_3263_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P: $o] : ( aa(A,A,abs_abs(A),aa($o,A,zero_neq_one_of_bool(A),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% abs_bool_eq
tff(fact_3264_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: $o] : ( aa(int,A,ring_1_of_int(A),aa($o,int,zero_neq_one_of_bool(int),P)) = aa($o,A,zero_neq_one_of_bool(A),P) ) ) ).

% of_int_of_bool
tff(fact_3265_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa($o,A,zero_neq_one_of_bool(A),P))
        <=> (P) ) ) ).

% zero_less_of_bool_iff
tff(fact_3266_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa($o,A,zero_neq_one_of_bool(A),P)),one_one(A))
        <=> ~ (P) ) ) ).

% of_bool_less_one_iff
tff(fact_3267_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [P: $o] : ( aa($o,A,zero_neq_one_of_bool(A),~ (P)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa($o,A,zero_neq_one_of_bool(A),P)) ) ) ).

% of_bool_not_iff
tff(fact_3268_Suc__0__mod__eq,axiom,
    ! [N: nat] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa($o,nat,zero_neq_one_of_bool(nat),( N != aa(nat,nat,suc,zero_zero(nat)) )) ) ).

% Suc_0_mod_eq
tff(fact_3269_real__sqrt__gt__0__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y) ) ).

% real_sqrt_gt_0_iff
tff(fact_3270_real__sqrt__lt__0__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real)) ) ).

% real_sqrt_lt_0_iff
tff(fact_3271_real__sqrt__le__0__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real)) ) ).

% real_sqrt_le_0_iff
tff(fact_3272_real__sqrt__ge__0__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y) ) ).

% real_sqrt_ge_0_iff
tff(fact_3273_real__sqrt__gt__1__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Y) ) ).

% real_sqrt_gt_1_iff
tff(fact_3274_real__sqrt__lt__1__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,Xa)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real)) ) ).

% real_sqrt_lt_1_iff
tff(fact_3275_real__sqrt__le__1__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,Xa)),one_one(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real)) ) ).

% real_sqrt_le_1_iff
tff(fact_3276_real__sqrt__ge__1__iff,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,sqrt,Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Y) ) ).

% real_sqrt_ge_1_iff
tff(fact_3277_real__sqrt__abs2,axiom,
    ! [Xa: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Xa)) = aa(real,real,abs_abs(real),Xa) ) ).

% real_sqrt_abs2
tff(fact_3278_real__sqrt__mult__self,axiom,
    ! [A2: real] : ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,A2)),aa(real,real,sqrt,A2)) = aa(real,real,abs_abs(real),A2) ) ).

% real_sqrt_mult_self
tff(fact_3279_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sgn_sgn(A),A2)),aa(A,A,sgn_sgn(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% sgn_mult_self_eq
tff(fact_3280_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,sgn_sgn(A),aa(A,A,abs_abs(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% idom_abs_sgn_class.abs_sgn
tff(fact_3281_sgn__abs,axiom,
    ! [A: $tType] :
      ( idom_abs_sgn(A)
     => ! [A2: A] : ( aa(A,A,abs_abs(A),aa(A,A,sgn_sgn(A),A2)) = aa($o,A,zero_neq_one_of_bool(A),( A2 != zero_zero(A) )) ) ) ).

% sgn_abs
tff(fact_3282_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat] : ( aa(A,A,sgn_sgn(A),aa(nat,A,semiring_1_of_nat(A),N)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% sgn_of_nat
tff(fact_3283_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [B2: $o] : ( divide_divide(A,aa($o,A,zero_neq_one_of_bool(A),B2),aa(num,A,numeral_numeral(A),bit0(one2))) = zero_zero(A) ) ) ).

% of_bool_half_eq_0
tff(fact_3284_real__sqrt__pow2__iff,axiom,
    ! [Xa: real] :
      ( ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = Xa )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa) ) ).

% real_sqrt_pow2_iff
tff(fact_3285_real__sqrt__pow2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = Xa ) ) ).

% real_sqrt_pow2
tff(fact_3286_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [Xa: real,Y: real,Xaa: real,Ya: real] : ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xaa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Ya),aa(num,nat,numeral_numeral(nat),bit0(one2))))))),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xaa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Ya),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% real_sqrt_sum_squares_mult_squared_eq
tff(fact_3287_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa($o,A,zero_neq_one_of_bool(A),( N = zero_zero(nat) )) ) ) ).

% one_div_2_pow_eq
tff(fact_3288_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] : ( divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa($o,A,zero_neq_one_of_bool(A),( N = zero_zero(nat) )) ) ) ).

% bits_1_div_exp
tff(fact_3289_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( modulo_modulo(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% one_mod_2_pow_eq
tff(fact_3290_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P2: $o,Q2: $o] :
          ( ( aa($o,A,zero_neq_one_of_bool(A),P2) = aa($o,A,zero_neq_one_of_bool(A),Q2) )
        <=> ( (P2)
          <=> (Q2) ) ) ) ).

% of_bool_eq_iff
tff(fact_3291_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A4: complex,R4: real] : ( Z = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R4)),aa(complex,complex,exp(complex),A4)) ) ).

% complex_exp_exists
tff(fact_3292_divide__complex__def,axiom,
    ! [Xa: complex,Y: complex] : ( divide_divide(complex,Xa,Y) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Xa),aa(complex,complex,inverse_inverse(complex),Y)) ) ).

% divide_complex_def
tff(fact_3293_of__bool__conj,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [P: $o,Q: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),
              (P)
            & (Q))
          = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_conj
tff(fact_3294_real__sqrt__mult,axiom,
    ! [Xa: real,Y: real] : ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,Xa)),aa(real,real,sqrt,Y)) ) ).

% real_sqrt_mult
tff(fact_3295_real__sqrt__le__mono,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,Xa)),aa(real,real,sqrt,Y)) ) ).

% real_sqrt_le_mono
tff(fact_3296_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),nat_set_decode(M)),nat_set_decode(N))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% subset_decode_imp_le
tff(fact_3297_real__sqrt__gt__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sqrt,Xa)) ) ).

% real_sqrt_gt_zero
tff(fact_3298_real__sqrt__eq__zero__cancel,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( ( aa(real,real,sqrt,Xa) = zero_zero(real) )
       => ( Xa = zero_zero(real) ) ) ) ).

% real_sqrt_eq_zero_cancel
tff(fact_3299_real__sqrt__ge__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,Xa)) ) ).

% real_sqrt_ge_zero
tff(fact_3300_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa($o,A,zero_neq_one_of_bool(A),P)) ) ).

% zero_less_eq_of_bool
tff(fact_3301_real__sqrt__ge__one,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,sqrt,Xa)) ) ).

% real_sqrt_ge_one
tff(fact_3302_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,zero_neq_one_of_bool(A),P)),one_one(A)) ) ).

% of_bool_less_eq_one
tff(fact_3303_of__bool__def,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P2: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),P2)
          = $ite((P2),one_one(A),zero_zero(A)) ) ) ).

% of_bool_def
tff(fact_3304_split__of__bool,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,$o),P2: $o] :
          ( aa(A,$o,P,aa($o,A,zero_neq_one_of_bool(A),P2))
        <=> ( ( (P2)
             => aa(A,$o,P,one_one(A)) )
            & ( ~ (P2)
             => aa(A,$o,P,zero_zero(A)) ) ) ) ) ).

% split_of_bool
tff(fact_3305_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( zero_neq_one(A)
     => ! [P: fun(A,$o),P2: $o] :
          ( aa(A,$o,P,aa($o,A,zero_neq_one_of_bool(A),P2))
        <=> ~ ( ( (P2)
                & ~ aa(A,$o,P,one_one(A)) )
              | ( ~ (P2)
                & ~ aa(A,$o,P,zero_zero(A)) ) ) ) ) ).

% split_of_bool_asm
tff(fact_3306_real__div__sqrt,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( divide_divide(real,Xa,aa(real,real,sqrt,Xa)) = aa(real,real,sqrt,Xa) ) ) ).

% real_div_sqrt
tff(fact_3307_sqrt__add__le__add__sqrt,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,Xa)),aa(real,real,sqrt,Y))) ) ) ).

% sqrt_add_le_add_sqrt
tff(fact_3308_le__real__sqrt__sumsq,axiom,
    ! [Xa: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Xa)),aa(real,real,aa(real,fun(real,real),times_times(real),Y),Y)))) ).

% le_real_sqrt_sumsq
tff(fact_3309_sqrt__divide__self__eq,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( divide_divide(real,aa(real,real,sqrt,Xa),Xa) = aa(real,real,inverse_inverse(real),aa(real,real,sqrt,Xa)) ) ) ).

% sqrt_divide_self_eq
tff(fact_3310_sqrt__le__D,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,Xa)),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% sqrt_le_D
tff(fact_3311_real__le__rsqrt,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),Y)
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(real,real,sqrt,Y)) ) ).

% real_le_rsqrt
tff(fact_3312_tan__60,axiom,
    aa(real,real,tan(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))) ).

% tan_60
tff(fact_3313_real__sqrt__unique,axiom,
    ! [Y: real,Xa: real] :
      ( ( aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))) = Xa )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,real,sqrt,Xa) = Y ) ) ) ).

% real_sqrt_unique
tff(fact_3314_real__le__lsqrt,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,Xa)),Y) ) ) ) ).

% real_le_lsqrt
tff(fact_3315_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),U)
     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),divide_divide(real,U,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))))),U) ) ).

% lemma_real_divide_sqrt_less
tff(fact_3316_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))) = Xa )
     => ( Y = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel
tff(fact_3317_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))) = Y )
     => ( Xa = zero_zero(real) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
tff(fact_3318_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),C2)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),B2),D2)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),A2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),C2),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),D2),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ).

% real_sqrt_sum_squares_triangle_ineq
tff(fact_3319_real__sqrt__sum__squares__ge2,axiom,
    ! [Y: real,Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ).

% real_sqrt_sum_squares_ge2
tff(fact_3320_real__sqrt__sum__squares__ge1,axiom,
    ! [Xa: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ).

% real_sqrt_sum_squares_ge1
tff(fact_3321_sqrt__ge__absD,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),aa(real,real,sqrt,Y))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),Y) ) ).

% sqrt_ge_absD
tff(fact_3322_bits__induct,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [P: fun(A,$o),A2: A] :
          ( ! [A4: A] :
              ( ( divide_divide(A,A4,aa(num,A,numeral_numeral(A),bit0(one2))) = A4 )
             => aa(A,$o,P,A4) )
         => ( ! [A4: A,B4: $o] :
                ( aa(A,$o,P,A4)
               => ( ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),B4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A4)),aa(num,A,numeral_numeral(A),bit0(one2))) = A4 )
                 => aa(A,$o,P,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa($o,A,zero_neq_one_of_bool(A),B4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A4))) ) )
           => aa(A,$o,P,A2) ) ) ) ).

% bits_induct
tff(fact_3323_cos__45,axiom,
    aa(real,real,cos(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2))))) = divide_divide(real,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% cos_45
tff(fact_3324_sin__45,axiom,
    aa(real,real,sin(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2))))) = divide_divide(real,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% sin_45
tff(fact_3325_real__less__lsqrt,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,Xa)),Y) ) ) ) ).

% real_less_lsqrt
tff(fact_3326_sqrt__sum__squares__le__sum,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y)) ) ) ).

% sqrt_sum_squares_le_sum
tff(fact_3327_real__inv__sqrt__pow2,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,Xa))),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(real,real,inverse_inverse(real),Xa) ) ) ).

% real_inv_sqrt_pow2
tff(fact_3328_tan__30,axiom,
    aa(real,real,tan(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(aa(num,num,bit1,one2))))) = divide_divide(real,one_one(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) ).

% tan_30
tff(fact_3329_ln__sqrt,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,ln_ln(real),aa(real,real,sqrt,Xa)) = divide_divide(real,aa(real,real,ln_ln(real),Xa),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ).

% ln_sqrt
tff(fact_3330_sqrt__sum__squares__le__sum__abs,axiom,
    ! [Xa: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),Xa)),aa(real,real,abs_abs(real),Y))) ).

% sqrt_sum_squares_le_sum_abs
tff(fact_3331_real__sqrt__ge__abs2,axiom,
    ! [Y: real,Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ).

% real_sqrt_ge_abs2
tff(fact_3332_real__sqrt__ge__abs1,axiom,
    ! [Xa: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ).

% real_sqrt_ge_abs1
tff(fact_3333_cos__30,axiom,
    aa(real,real,cos(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(aa(num,num,bit1,one2))))) = divide_divide(real,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% cos_30
tff(fact_3334_sin__60,axiom,
    aa(real,real,sin(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2)))) = divide_divide(real,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),aa(num,num,bit1,one2))),aa(num,real,numeral_numeral(real),bit0(one2))) ).

% sin_60
tff(fact_3335_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [M: nat,N: nat] : ( modulo_modulo(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) ) ) ).

% exp_mod_exp
tff(fact_3336_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L != zero_zero(int) )
     => ( ( aa(int,int,sgn_sgn(int),K) != aa(int,int,sgn_sgn(int),L) )
       => ( divide_divide(int,K,L) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),divide_divide(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L)))),aa($o,int,zero_neq_one_of_bool(int),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K))) ) ) ) ).

% div_noneq_sgn_abs
tff(fact_3337_arsinh__real__aux,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))))) ).

% arsinh_real_aux
tff(fact_3338_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [Xa: real,Y: real,Xaa: real,Ya: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xaa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Ya),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ).

% real_sqrt_sum_squares_mult_ge_zero
tff(fact_3339_arith__geo__mean__sqrt,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y))),divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ).

% arith_geo_mean_sqrt
tff(fact_3340_real__sqrt__power__even,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
       => ( aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,sqrt,Xa)),N) = aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ) ).

% real_sqrt_power_even
tff(fact_3341_powr__half__sqrt,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))) = aa(real,real,sqrt,Xa) ) ) ).

% powr_half_sqrt
tff(fact_3342_arsinh__real__def,axiom,
    ! [Xa: real] : ( aa(real,real,arsinh(real),Xa) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))))) ) ).

% arsinh_real_def
tff(fact_3343_cos__x__y__le__one,axiom,
    ! [Xa: real,Y: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),divide_divide(real,Xa,aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))),one_one(real)) ).

% cos_x_y_le_one
tff(fact_3344_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( divide_divide(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N))
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                aa($o,A,zero_neq_one_of_bool(A),
                  ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M) != zero_zero(A) )
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M))),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N))) ) ) ).

% exp_div_exp_eq
tff(fact_3345_cos__arctan,axiom,
    ! [Xa: real] : ( aa(real,real,cos(real),aa(real,real,arctan,Xa)) = divide_divide(real,one_one(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% cos_arctan
tff(fact_3346_sin__arctan,axiom,
    ! [Xa: real] : ( aa(real,real,sin(real),aa(real,real,arctan,Xa)) = divide_divide(real,Xa,aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% sin_arctan
tff(fact_3347_sqrt__sum__squares__half__less,axiom,
    ! [Xa: real,U: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),divide_divide(real,U,aa(num,real,numeral_numeral(real),bit0(one2))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y),divide_divide(real,U,aa(num,real,numeral_numeral(real),bit0(one2))))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),U) ) ) ) ) ).

% sqrt_sum_squares_half_less
tff(fact_3348_sin__cos__sqrt,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sin(real),Xa))
     => ( aa(real,real,sin(real),Xa) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,cos(real),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% sin_cos_sqrt
tff(fact_3349_arctan__half,axiom,
    ! [Xa: real] : ( aa(real,real,arctan,Xa) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),aa(real,real,arctan,divide_divide(real,Xa,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))))))) ) ).

% arctan_half
tff(fact_3350_sin__arccos,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => ( aa(real,real,sin(real),aa(real,real,arccos,Xa)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ) ).

% sin_arccos
tff(fact_3351_cos__arcsin,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => ( aa(real,real,cos(real),aa(real,real,arcsin,Xa)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ) ).

% cos_arcsin
tff(fact_3352_sin__arccos__abs,axiom,
    ! [Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Y)),one_one(real))
     => ( aa(real,real,sin(real),aa(real,real,arccos,Y)) = aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Y),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% sin_arccos_abs
tff(fact_3353_divide__int__unfold,axiom,
    ! [K: int,M: nat,L: int,N: nat] :
      ( divide_divide(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N)))
      = $ite(
          ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( N = zero_zero(nat) ) ),
          zero_zero(int),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,M,N)),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),divide_divide(nat,M,N)),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),N),M)))))) ) ) ).

% divide_int_unfold
tff(fact_3354_modulo__int__def,axiom,
    ! [K: int,L: int] :
      ( modulo_modulo(int,K,L)
      = $ite(
          L = zero_zero(int),
          K,
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),L)),aa($o,int,zero_neq_one_of_bool(int),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L))))))) ) ) ).

% modulo_int_def
tff(fact_3355_modulo__int__unfold,axiom,
    ! [K: int,M: nat,L: int,N: nat] :
      ( modulo_modulo(int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),N)))
      = $ite(
          ( ( aa(int,int,sgn_sgn(int),L) = zero_zero(int) )
          | ( aa(int,int,sgn_sgn(int),K) = zero_zero(int) )
          | ( N = zero_zero(nat) ) ),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),K)),aa(nat,int,semiring_1_of_nat(int),M)),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,M,N))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),L)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),N),M))))),aa(nat,int,semiring_1_of_nat(int),modulo_modulo(nat,M,N))))) ) ) ).

% modulo_int_unfold
tff(fact_3356_arcosh__real__def,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),Xa)
     => ( aa(real,real,arcosh(real),Xa) = aa(real,real,ln_ln(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real))))) ) ) ).

% arcosh_real_def
tff(fact_3357_divide__int__def,axiom,
    ! [K: int,L: int] :
      ( divide_divide(int,K,L)
      = $ite(
          L = zero_zero(int),
          zero_zero(int),
          $ite(aa(int,int,sgn_sgn(int),K) = aa(int,int,sgn_sgn(int),L),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))),aa(int,int,uminus_uminus(int),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),divide_divide(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),aa(int,nat,nat2,aa(int,int,abs_abs(int),L)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),L),K)))))) ) ) ).

% divide_int_def
tff(fact_3358_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( member(real,N,ring_1_Ints(real))
     => ( cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),N)) = one_one(complex) ) ) ).

% cis_multiple_2pi
tff(fact_3359_exp__two__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),bit0(one2))),real_Vector_of_real(complex,pi))),imaginary_unit)) = one_one(complex) ).

% exp_two_pi_i
tff(fact_3360_exp__two__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,pi)),aa(num,complex,numeral_numeral(complex),bit0(one2))))) = one_one(complex) ).

% exp_two_pi_i'
tff(fact_3361_mask__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: num] : ( bit_se2239418461657761734s_mask(A,aa(num,nat,numeral_numeral(nat),N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2239418461657761734s_mask(A,pred_numeral(N)))) ) ) ).

% mask_numeral
tff(fact_3362_num_Osize__gen_I3_J,axiom,
    ! [X32: num] : ( size_num(aa(num,num,bit1,X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(3)
tff(fact_3363_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),bit_se2239418461657761734s_mask(nat,N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ).

% mask_nat_positive_iff
tff(fact_3364_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask(A,N) = zero_zero(A) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% mask_eq_0_iff
tff(fact_3365_mask__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,zero_zero(nat)) = zero_zero(A) ) ) ).

% mask_0
tff(fact_3366_norm__ii,axiom,
    real_V7770717601297561774m_norm(complex,imaginary_unit) = one_one(real) ).

% norm_ii
tff(fact_3367_norm__cis,axiom,
    ! [A2: real] : ( real_V7770717601297561774m_norm(complex,cis(A2)) = one_one(real) ) ).

% norm_cis
tff(fact_3368_cis__zero,axiom,
    cis(zero_zero(real)) = one_one(complex) ).

% cis_zero
tff(fact_3369_complex__i__mult__minus,axiom,
    ! [Xa: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Xa)) = aa(complex,complex,uminus_uminus(complex),Xa) ) ).

% complex_i_mult_minus
tff(fact_3370_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,zero_zero(nat))) = one_one(A) ) ) ).

% mask_Suc_0
tff(fact_3371_cis__pi,axiom,
    cis(pi) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% cis_pi
tff(fact_3372_divide__i,axiom,
    ! [Xa: complex] : ( divide_divide(complex,Xa,imaginary_unit) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,uminus_uminus(complex),imaginary_unit)),Xa) ) ).

% divide_i
tff(fact_3373_i__squared,axiom,
    aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),imaginary_unit) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% i_squared
tff(fact_3374_divide__numeral__i,axiom,
    ! [Z: complex,N: num] : ( divide_divide(complex,Z,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(num,complex,numeral_numeral(complex),N)),imaginary_unit)) = divide_divide(complex,aa(complex,complex,uminus_uminus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)),aa(num,complex,numeral_numeral(complex),N)) ) ).

% divide_numeral_i
tff(fact_3375_power2__i,axiom,
    aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),imaginary_unit),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% power2_i
tff(fact_3376_cis__2pi,axiom,
    cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)) = one_one(complex) ).

% cis_2pi
tff(fact_3377_i__even__power,axiom,
    ! [N: nat] : ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),imaginary_unit),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),aa(complex,complex,uminus_uminus(complex),one_one(complex))),N) ) ).

% i_even_power
tff(fact_3378_exp__pi__i,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,pi)),imaginary_unit)) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i
tff(fact_3379_exp__pi__i_H,axiom,
    aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,pi))) = aa(complex,complex,uminus_uminus(complex),one_one(complex)) ).

% exp_pi_i'
tff(fact_3380_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),bit_se2239418461657761734s_mask(nat,N)) = bit_se2239418461657761734s_mask(A,N) ) ) ).

% of_nat_mask_eq
tff(fact_3381_cis__conv__exp,axiom,
    ! [B2: real] : ( cis(B2) = aa(complex,complex,exp(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,B2))) ) ).

% cis_conv_exp
tff(fact_3382_less__eq__mask,axiom,
    ! [N: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),bit_se2239418461657761734s_mask(nat,N)) ).

% less_eq_mask
tff(fact_3383_cis__divide,axiom,
    ! [A2: real,B2: real] : ( divide_divide(complex,cis(A2),cis(B2)) = cis(aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)) ) ).

% cis_divide
tff(fact_3384_complex__i__not__zero,axiom,
    imaginary_unit != zero_zero(complex) ).

% complex_i_not_zero
tff(fact_3385_complex__i__not__one,axiom,
    imaginary_unit != one_one(complex) ).

% complex_i_not_one
tff(fact_3386_cis__neq__zero,axiom,
    ! [A2: real] : ( cis(A2) != zero_zero(complex) ) ).

% cis_neq_zero
tff(fact_3387_mask__nonnegative__int,axiom,
    ! [N: nat] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),bit_se2239418461657761734s_mask(int,N)) ).

% mask_nonnegative_int
tff(fact_3388_not__mask__negative__int,axiom,
    ! [N: nat] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),bit_se2239418461657761734s_mask(int,N)),zero_zero(int)) ).

% not_mask_negative_int
tff(fact_3389_DeMoivre,axiom,
    ! [A2: real,N: nat] : ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),cis(A2)),N) = cis(aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),A2)) ) ).

% DeMoivre
tff(fact_3390_cis__mult,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cis(A2)),cis(B2)) = cis(aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)) ) ).

% cis_mult
tff(fact_3391_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),W) = Z )
    <=> ( W = aa(complex,complex,uminus_uminus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) ) ) ).

% i_times_eq_iff
tff(fact_3392_less__mask,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,zero_zero(nat))),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),bit_se2239418461657761734s_mask(nat,N)) ) ).

% less_mask
tff(fact_3393_imaginary__unit_Ocode,axiom,
    imaginary_unit = complex2(zero_zero(real),one_one(real)) ).

% imaginary_unit.code
tff(fact_3394_Complex__eq__i,axiom,
    ! [Xa: real,Y: real] :
      ( ( complex2(Xa,Y) = imaginary_unit )
    <=> ( ( Xa = zero_zero(real) )
        & ( Y = one_one(real) ) ) ) ).

% Complex_eq_i
tff(fact_3395_i__mult__Complex,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),complex2(A2,B2)) = complex2(aa(real,real,uminus_uminus(real),B2),A2) ) ).

% i_mult_Complex
tff(fact_3396_Complex__mult__i,axiom,
    ! [A2: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),complex2(A2,B2)),imaginary_unit) = complex2(aa(real,real,uminus_uminus(real),B2),A2) ) ).

% Complex_mult_i
tff(fact_3397_complex__of__real__i,axiom,
    ! [R: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R)),imaginary_unit) = complex2(zero_zero(real),R) ) ).

% complex_of_real_i
tff(fact_3398_i__complex__of__real,axiom,
    ! [R: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,R)) = complex2(zero_zero(real),R) ) ).

% i_complex_of_real
tff(fact_3399_num_Osize__gen_I1_J,axiom,
    size_num(one2) = zero_zero(nat) ).

% num.size_gen(1)
tff(fact_3400_Complex__eq,axiom,
    ! [A2: real,B2: real] : ( complex2(A2,B2) = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,A2)),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,B2))) ) ).

% Complex_eq
tff(fact_3401_Suc__mask__eq__exp,axiom,
    ! [N: nat] : ( aa(nat,nat,suc,bit_se2239418461657761734s_mask(nat,N)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% Suc_mask_eq_exp
tff(fact_3402_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2239418461657761734s_mask(A,N))
        <=> ( N = zero_zero(nat) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
tff(fact_3403_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R4: real,A4: real] : ( Z = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R4)),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,aa(real,real,cos(real),A4))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,aa(real,real,sin(real),A4))))) ) ).

% complex_split_polar
tff(fact_3404_mask__half__int,axiom,
    ! [N: nat] : ( divide_divide(int,bit_se2239418461657761734s_mask(int,N),aa(num,int,numeral_numeral(int),bit0(one2))) = bit_se2239418461657761734s_mask(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ).

% mask_half_int
tff(fact_3405_mask__nat__def,axiom,
    ! [N: nat] : ( bit_se2239418461657761734s_mask(nat,N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),one_one(nat)) ) ).

% mask_nat_def
tff(fact_3406_mask__int__def,axiom,
    ! [N: nat] : ( bit_se2239418461657761734s_mask(int,N) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),one_one(int)) ) ).

% mask_int_def
tff(fact_3407_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,N) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)) ) ) ).

% mask_eq_exp_minus_1
tff(fact_3408_cmod__unit__one,axiom,
    ! [A2: real] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,aa(real,real,cos(real),A2))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,aa(real,real,sin(real),A2))))) = one_one(real) ) ).

% cmod_unit_one
tff(fact_3409_cmod__complex__polar,axiom,
    ! [R: real,A2: real] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R)),aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,aa(real,real,cos(real),A2))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,aa(real,real,sin(real),A2)))))) = aa(real,real,abs_abs(real),R) ) ).

% cmod_complex_polar
tff(fact_3410_num_Osize__gen_I2_J,axiom,
    ! [X2: num] : ( size_num(bit0(X2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_num(X2)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size_gen(2)
tff(fact_3411_csqrt__ii,axiom,
    csqrt(imaginary_unit) = divide_divide(complex,aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),one_one(complex)),imaginary_unit),real_Vector_of_real(complex,aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2))))) ).

% csqrt_ii
tff(fact_3412_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(arg(Z)) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z))
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),arg(Z)),pi) ) ) ).

% Arg_correct
tff(fact_3413_take__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)
          = $ite(N = zero_zero(nat),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))),aa(num,A,numeral_numeral(A),bit0(one2)))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% take_bit_rec
tff(fact_3414_and__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( ( K = zero_zero(int) )
          | ( L = zero_zero(int) ) ),
          zero_zero(int),
          $ite(
            K = aa(int,int,uminus_uminus(int),one_one(int)),
            L,
            $ite(L = aa(int,int,uminus_uminus(int),one_one(int)),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),bit0(one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2))))))) ) ) ) ).

% and_int_unfold
tff(fact_3415_sinh__ln__real,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,real,sinh(real),aa(real,real,ln_ln(real),Xa)) = divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),aa(real,real,inverse_inverse(real),Xa)),aa(num,real,numeral_numeral(real),bit0(one2))) ) ) ).

% sinh_ln_real
tff(fact_3416_sinh__real__eq__iff,axiom,
    ! [Xa: real,Y: real] :
      ( ( aa(real,real,sinh(real),Xa) = aa(real,real,sinh(real),Y) )
    <=> ( Xa = Y ) ) ).

% sinh_real_eq_iff
tff(fact_3417_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% take_bit_of_0
tff(fact_3418_and__zero__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),zero_zero(A)) = zero_zero(A) ) ) ).

% and_zero_eq
tff(fact_3419_zero__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),A2) = zero_zero(A) ) ) ).

% zero_and_eq
tff(fact_3420_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),zero_zero(A)),Xa) = zero_zero(A) ) ) ).

% bit.conj_zero_left
tff(fact_3421_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Xa),zero_zero(A)) = zero_zero(A) ) ) ).

% bit.conj_zero_right
tff(fact_3422_sinh__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ( aa(A,A,sinh(A),zero_zero(A)) = zero_zero(A) ) ) ).

% sinh_0
tff(fact_3423_sinh__minus,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,sinh(A),aa(A,A,uminus_uminus(A),Xa)) = aa(A,A,uminus_uminus(A),aa(A,A,sinh(A),Xa)) ) ) ).

% sinh_minus
tff(fact_3424_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] : ( bit_concat_bit(N,K,zero_zero(int)) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) ) ).

% concat_bit_of_zero_2
tff(fact_3425_sinh__real__zero__iff,axiom,
    ! [Xa: real] :
      ( ( aa(real,real,sinh(real),Xa) = zero_zero(real) )
    <=> ( Xa = zero_zero(real) ) ) ).

% sinh_real_zero_iff
tff(fact_3426_sinh__real__less__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sinh(real),Xa)),aa(real,real,sinh(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y) ) ).

% sinh_real_less_iff
tff(fact_3427_sinh__real__le__iff,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sinh(real),Xa)),aa(real,real,sinh(real),Y))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),Y) ) ).

% sinh_real_le_iff
tff(fact_3428_sinh__real__abs,axiom,
    ! [Xa: real] : ( aa(real,real,sinh(real),aa(real,real,abs_abs(real),Xa)) = aa(real,real,abs_abs(real),aa(real,real,sinh(real),Xa)) ) ).

% sinh_real_abs
tff(fact_3429_csqrt__0,axiom,
    csqrt(zero_zero(complex)) = zero_zero(complex) ).

% csqrt_0
tff(fact_3430_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( csqrt(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% csqrt_eq_0
tff(fact_3431_csqrt__1,axiom,
    csqrt(one_one(complex)) = one_one(complex) ).

% csqrt_1
tff(fact_3432_csqrt__eq__1,axiom,
    ! [Z: complex] :
      ( ( csqrt(Z) = one_one(complex) )
    <=> ( Z = one_one(complex) ) ) ).

% csqrt_eq_1
tff(fact_3433_take__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,zero_zero(nat)),A2) = zero_zero(A) ) ) ).

% take_bit_0
tff(fact_3434_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Xa),aa(A,A,uminus_uminus(A),one_one(A))) = Xa ) ) ).

% bit.conj_one_right
tff(fact_3435_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,uminus_uminus(A),one_one(A))) = A2 ) ) ).

% and.right_neutral
tff(fact_3436_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,uminus_uminus(A),one_one(A))),A2) = A2 ) ) ).

% and.left_neutral
tff(fact_3437_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),one_one(A)) = one_one(A) ) ) ).

% take_bit_Suc_1
tff(fact_3438_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),one_one(A)) = one_one(A) ) ) ).

% take_bit_numeral_1
tff(fact_3439_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [N: nat,K: int] : ( aa(nat,A,semiring_1_of_nat(A),aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))) = aa(int,A,ring_1_of_int(A),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ) ).

% of_nat_nat_take_bit_eq
tff(fact_3440_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        | aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% and_nonnegative_int_iff
tff(fact_3441_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),zero_zero(int))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% and_negative_int_iff
tff(fact_3442_sinh__real__pos__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,sinh(real),Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa) ) ).

% sinh_real_pos_iff
tff(fact_3443_sinh__real__neg__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sinh(real),Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real)) ) ).

% sinh_real_neg_iff
tff(fact_3444_sinh__real__nonneg__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,sinh(real),Xa))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa) ) ).

% sinh_real_nonneg_iff
tff(fact_3445_sinh__real__nonpos__iff,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sinh(real),Xa)),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real)) ) ).

% sinh_real_nonpos_iff
tff(fact_3446_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),one_one(A)) = zero_zero(A) )
        <=> ( N = zero_zero(nat) ) ) ) ).

% take_bit_of_1_eq_0_iff
tff(fact_3447_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = one_one(A) ) ) ).

% and_numerals(2)
tff(fact_3448_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),one_one(A)) = one_one(A) ) ) ).

% and_numerals(8)
tff(fact_3449_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,uminus_uminus(A),one_one(A))) = bit_se2239418461657761734s_mask(A,N) ) ) ).

% take_bit_minus_one_eq_mask
tff(fact_3450_take__bit__of__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(nat,nat,suc,zero_zero(nat))) = aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ).

% take_bit_of_Suc_0
tff(fact_3451_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(Y))) = zero_zero(A) ) ) ).

% and_numerals(1)
tff(fact_3452_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit0(Xa))),one_one(A)) = zero_zero(A) ) ) ).

% and_numerals(5)
tff(fact_3453_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit0(Xa))),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(3)
tff(fact_3454_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),one_one(A)) = aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)) ) ) ).

% take_bit_of_1
tff(fact_3455_and__minus__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = one_one(int) ) ).

% and_minus_numerals(2)
tff(fact_3456_and__minus__numerals_I6_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))),one_one(int)) = one_one(int) ) ).

% and_minus_numerals(6)
tff(fact_3457_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(6)
tff(fact_3458_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),bit0(Xa))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% and_numerals(4)
tff(fact_3459_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2))
        <=> ( ( N = zero_zero(nat) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2) ) ) ) ).

% even_take_bit_eq
tff(fact_3460_and__minus__numerals_I1_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))) = zero_zero(int) ) ).

% and_minus_numerals(1)
tff(fact_3461_and__minus__numerals_I5_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))),one_one(int)) = zero_zero(int) ) ).

% and_minus_numerals(5)
tff(fact_3462_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,zero_zero(nat))),A2) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_Suc_0
tff(fact_3463_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% and_numerals(7)
tff(fact_3464_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% take_bit_of_exp
tff(fact_3465_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(num,A,numeral_numeral(A),bit0(one2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_of_2
tff(fact_3466_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A,B2: A,M: nat] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
           => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,M),B2) ) ) ) ) ).

% take_bit_tightened
tff(fact_3467_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M)),M) ).

% take_bit_nat_less_eq_self
tff(fact_3468_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,M),Q2)),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),Q2)) ) ).

% take_bit_tightened_less_eq_nat
tff(fact_3469_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_and_eq
tff(fact_3470_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M)) ) ) ).

% take_bit_of_nat
tff(fact_3471_take__bit__add,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,A2: A,B2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)),aa(A,A,bit_se2584673776208193580ke_bit(A,N),B2))) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ).

% take_bit_add
tff(fact_3472_take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),L)) ) ).

% take_bit_diff
tff(fact_3473_take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),L))) = aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),times_times(int),K),L)) ) ).

% take_bit_mult
tff(fact_3474_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) = aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(int,nat,nat2,K)) ) ) ).

% nat_take_bit_eq
tff(fact_3475_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(int,nat,nat2,K)) = aa(int,nat,nat2,aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ) ).

% take_bit_nat_eq
tff(fact_3476_arsinh__sinh__real,axiom,
    ! [Xa: real] : ( aa(real,real,arsinh(real),aa(real,real,sinh(real),Xa)) = Xa ) ).

% arsinh_sinh_real
tff(fact_3477_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),B2) = aa(A,A,uminus_uminus(A),one_one(A)) )
        <=> ( ( A2 = aa(A,A,uminus_uminus(A),one_one(A)) )
            & ( B2 = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ) ) ).

% and_eq_minus_1_iff
tff(fact_3478_AND__lower,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Y)) ) ).

% AND_lower
tff(fact_3479_AND__upper1,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Y)),Xa) ) ).

% AND_upper1
tff(fact_3480_AND__upper2,axiom,
    ! [Y: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Y)),Y) ) ).

% AND_upper2
tff(fact_3481_AND__upper1_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y),Ya)),Z) ) ) ).

% AND_upper1'
tff(fact_3482_AND__upper2_H,axiom,
    ! [Y: int,Z: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Y)),Z) ) ) ).

% AND_upper2'
tff(fact_3483_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,M),K)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ).

% take_bit_tightened_less_eq_int
tff(fact_3484_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ).

% take_bit_nonnegative
tff(fact_3485_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% take_bit_int_less_eq_self_iff
tff(fact_3486_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% take_bit_int_greater_self_iff
tff(fact_3487_not__take__bit__negative,axiom,
    ! [N: nat,K: int] : ~ aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),zero_zero(int)) ).

% not_take_bit_negative
tff(fact_3488_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A2: A,B2: A] :
          ( ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A2) = aa(A,A,bit_ri4674362597316999326ke_bit(A,N),B2) )
        <=> ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A2) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),B2) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
tff(fact_3489_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2))
          = aa(A,A,$ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M),bit_se2584673776208193580ke_bit(A,N),bit_ri4674362597316999326ke_bit(A,M)),A2) ) ) ).

% signed_take_bit_take_bit
tff(fact_3490_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),bit_se2638667681897837118et_bit(A,M,A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2),bit_se2638667681897837118et_bit(A,M,aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2))) ) ) ).

% take_bit_unset_bit_eq
tff(fact_3491_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),bit_se5668285175392031749et_bit(A,M,A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2),bit_se5668285175392031749et_bit(A,M,aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2))) ) ) ).

% take_bit_set_bit_eq
tff(fact_3492_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat,A2: A] :
          ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),bit_se8732182000553998342ip_bit(A,M,A2))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2),bit_se8732182000553998342ip_bit(A,M,aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2))) ) ) ).

% take_bit_flip_bit_eq
tff(fact_3493_sinh__less__cosh__real,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,sinh(real),Xa)),aa(real,real,cosh(real),Xa)) ).

% sinh_less_cosh_real
tff(fact_3494_sinh__le__cosh__real,axiom,
    ! [Xa: real] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,sinh(real),Xa)),aa(real,real,cosh(real),Xa)) ).

% sinh_le_cosh_real
tff(fact_3495_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N))
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,M),A2) ) ) ) ).

% take_bit_signed_take_bit
tff(fact_3496_AND__upper2_H_H,axiom,
    ! [Y: int,Z: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Y)),Z) ) ) ).

% AND_upper2''
tff(fact_3497_AND__upper1_H_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),Z)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Y),Ya)),Z) ) ) ).

% AND_upper1''
tff(fact_3498_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)),K) ) ).

% and_less_eq
tff(fact_3499_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = bit_se2239418461657761734s_mask(int,N) )
    <=> ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = zero_zero(int) ) ) ).

% take_bit_eq_mask_iff
tff(fact_3500_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) != zero_zero(int) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),one_one(int)) ) ) ).

% take_bit_decr_eq
tff(fact_3501_Arg__zero,axiom,
    arg(zero_zero(complex)) = zero_zero(real) ).

% Arg_zero
tff(fact_3502_sinh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,sinh(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sinh(A),Xa)),aa(A,A,cosh(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cosh(A),Xa)),aa(A,A,sinh(A),Y))) ) ) ).

% sinh_add
tff(fact_3503_cosh__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,cosh(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cosh(A),Xa)),aa(A,A,cosh(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sinh(A),Xa)),aa(A,A,sinh(A),Y))) ) ) ).

% cosh_add
tff(fact_3504_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,sinh(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sinh(A),Xa)),aa(A,A,cosh(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cosh(A),Xa)),aa(A,A,sinh(A),Y))) ) ) ).

% sinh_diff
tff(fact_3505_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : ( aa(A,A,cosh(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cosh(A),Xa)),aa(A,A,cosh(A),Y))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sinh(A),Xa)),aa(A,A,sinh(A),Y))) ) ) ).

% cosh_diff
tff(fact_3506_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,sinh(A),Xa)),aa(A,A,cosh(A),Xa)) = aa(A,A,exp(A),Xa) ) ) ).

% sinh_plus_cosh
tff(fact_3507_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,cosh(A),Xa)),aa(A,A,sinh(A),Xa)) = aa(A,A,exp(A),Xa) ) ) ).

% cosh_plus_sinh
tff(fact_3508_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( cis(arg(Z)) = aa(complex,complex,sgn_sgn(complex),Z) ) ) ).

% cis_Arg
tff(fact_3509_tanh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,tanh(A),Xa) = divide_divide(A,aa(A,A,sinh(A),Xa),aa(A,A,cosh(A),Xa)) ) ) ).

% tanh_def
tff(fact_3510_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),bit0(K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_Suc_bit0
tff(fact_3511_one__and__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),one_one(A)),A2) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% one_and_eq
tff(fact_3512_and__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),one_one(A)) = modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% and_one_eq
tff(fact_3513_cosh__minus__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,cosh(A),Xa)),aa(A,A,sinh(A),Xa)) = aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa)) ) ) ).

% cosh_minus_sinh
tff(fact_3514_sinh__minus__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,sinh(A),Xa)),aa(A,A,cosh(A),Xa)) = aa(A,A,uminus_uminus(A),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa))) ) ) ).

% sinh_minus_cosh
tff(fact_3515_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2) = zero_zero(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),A2) ) ) ).

% take_bit_eq_0_iff
tff(fact_3516_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),bit0(K))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% take_bit_numeral_bit0
tff(fact_3517_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),M)),M)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),M) ) ).

% take_bit_nat_less_self_iff
tff(fact_3518_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% take_bit_Suc_minus_bit0
tff(fact_3519_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),K)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),K) ) ).

% take_bit_int_less_self_iff
tff(fact_3520_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% take_bit_int_greater_eq_self_iff
tff(fact_3521_sinh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,sinh(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,sinh(A),Xa))),aa(A,A,cosh(A),Xa)) ) ) ).

% sinh_double
tff(fact_3522_of__real__sqrt,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( real_Vector_of_real(complex,aa(real,real,sqrt,Xa)) = csqrt(real_Vector_of_real(complex,Xa)) ) ) ).

% of_real_sqrt
tff(fact_3523_Arg__bounded,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),arg(Z))
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),arg(Z)),pi) ) ).

% Arg_bounded
tff(fact_3524_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = K )
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ) ).

% take_bit_int_eq_self_iff
tff(fact_3525_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = K ) ) ) ).

% take_bit_int_eq_self
tff(fact_3526_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ).

% take_bit_numeral_minus_bit0
tff(fact_3527_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) != aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),one_one(int)) )
     => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ) ).

% take_bit_incr_eq
tff(fact_3528_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),K) = bit_se2239418461657761734s_mask(int,N) )
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),one_one(int))) ) ).

% take_bit_eq_mask_iff_exp_dvd
tff(fact_3529_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,suc,N))),one_one(A)) ) ) ).

% take_bit_Suc_minus_1_eq
tff(fact_3530_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2)))),one_one(A)) ) ) ).

% take_bit_Suc_bit1
tff(fact_3531_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),K)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(num,nat,numeral_numeral(nat),K))),one_one(A)) ) ) ).

% take_bit_numeral_minus_1_eq
tff(fact_3532_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))),aa(num,A,numeral_numeral(A),bit0(one2)))),modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% take_bit_Suc
tff(fact_3533_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),K)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ) ).

% take_bit_int_less_eq
tff(fact_3534_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ).

% take_bit_int_greater_eq
tff(fact_3535_signed__take__bit__eq__take__bit__shift,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)))),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% signed_take_bit_eq_take_bit_shift
tff(fact_3536_and__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)
            & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% and_int_rec
tff(fact_3537_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,N: nat] :
          ( ( divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))) = A2 )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)
            = $ite(aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2),zero_zero(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A))) ) ) ) ).

% stable_imp_take_bit_eq
tff(fact_3538_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] : ( aa(A,A,sinh(A),Z) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Z)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Z))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% sinh_field_def
tff(fact_3539_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cosh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sinh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)) ) ) ).

% cosh_square_eq
tff(fact_3540_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cosh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sinh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(A) ) ) ).

% hyperbolic_pythagoras
tff(fact_3541_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sinh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cosh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(A)) ) ) ).

% sinh_square_eq
tff(fact_3542_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [L: num,K: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),L)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se2584673776208193580ke_bit(A,pred_numeral(L)),aa(num,A,numeral_numeral(A),K))),aa(num,A,numeral_numeral(A),bit0(one2)))),one_one(A)) ) ) ).

% take_bit_numeral_bit1
tff(fact_3543_cis__Arg__unique,axiom,
    ! [Z: complex,Xa: real] :
      ( ( aa(complex,complex,sgn_sgn(complex),Z) = cis(Xa) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Xa)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),pi)
         => ( arg(Z) = Xa ) ) ) ) ).

% cis_Arg_unique
tff(fact_3544_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),K)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
       => ( aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),K)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),K) ) ) ) ).

% take_bit_minus_small_eq
tff(fact_3545_cosh__double,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : ( aa(A,A,cosh(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Xa)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cosh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sinh(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% cosh_double
tff(fact_3546_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,pred_numeral(L)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% take_bit_numeral_minus_bit1
tff(fact_3547_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K))))),aa(num,int,numeral_numeral(int),bit0(one2)))),one_one(int)) ) ).

% take_bit_Suc_minus_bit1
tff(fact_3548_signed__take__bit__eq__take__bit__minus,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),K)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(nat,nat,suc,N))),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N)))) ) ).

% signed_take_bit_eq_take_bit_minus
tff(fact_3549_Suc__0__xor__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),N) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% Suc_0_xor_eq
tff(fact_3550_xor__Suc__0__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),N),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),aa($o,nat,zero_neq_one_of_bool(nat),~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% xor_Suc_0_eq
tff(fact_3551_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),zero_zero(A)) = A2 ) ) ).

% xor.right_neutral
tff(fact_3552_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),zero_zero(A)),A2) = A2 ) ) ).

% xor.left_neutral
tff(fact_3553_xor__self__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),A2) = zero_zero(A) ) ) ).

% xor_self_eq
tff(fact_3554_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Xa),Xa) = zero_zero(A) ) ) ).

% bit.xor_self
tff(fact_3555_pred__numeral__inc,axiom,
    ! [K: num] : ( pred_numeral(inc(K)) = aa(num,nat,numeral_numeral(nat),K) ) ).

% pred_numeral_inc
tff(fact_3556_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit0(M))),aa(nat,nat,suc,N))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),N) ) ) ).

% bit_numeral_Bit0_Suc_iff
tff(fact_3557_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),aa(num,num,bit1,M))),aa(nat,nat,suc,N))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),M)),N) ) ) ).

% bit_numeral_Bit1_Suc_iff
tff(fact_3558_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) ).

% signed_take_bit_nonnegative_iff
tff(fact_3559_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4674362597316999326ke_bit(int,N),K)),zero_zero(int))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) ).

% signed_take_bit_negative_iff
tff(fact_3560_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit0(Xa))),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(3)
tff(fact_3561_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% xor_numerals(1)
tff(fact_3562_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),bit0(Y)) ) ) ).

% xor_numerals(2)
tff(fact_3563_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit0(Xa))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa)) ) ) ).

% xor_numerals(5)
tff(fact_3564_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),one_one(A)) = aa(num,A,numeral_numeral(A),bit0(Xa)) ) ) ).

% xor_numerals(8)
tff(fact_3565_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(M))) ) ) ).

% add_neg_numeral_special(6)
tff(fact_3566_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% add_neg_numeral_special(5)
tff(fact_3567_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),inc(N))) ) ) ).

% diff_numeral_special(5)
tff(fact_3568_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(num,A,numeral_numeral(A),inc(M)) ) ) ).

% diff_numeral_special(6)
tff(fact_3569_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(W)))),aa(nat,nat,suc,N))
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),N) ) ).

% bit_minus_numeral_Bit0_Suc_iff
tff(fact_3570_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,W)))),aa(nat,nat,suc,N))
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(num,int,numeral_numeral(int),W)),N) ) ).

% bit_minus_numeral_Bit1_Suc_iff
tff(fact_3571_and__nat__numerals_I3_J,axiom,
    ! [Xa: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),bit0(Xa))),aa(nat,nat,suc,zero_zero(nat))) = zero_zero(nat) ) ).

% and_nat_numerals(3)
tff(fact_3572_and__nat__numerals_I1_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(Y))) = zero_zero(nat) ) ).

% and_nat_numerals(1)
tff(fact_3573_bit__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),zero_zero(nat))
        <=> ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2) ) ) ).

% bit_0
tff(fact_3574_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% xor_numerals(7)
tff(fact_3575_xor__nat__numerals_I1_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(Y))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y)) ) ).

% xor_nat_numerals(1)
tff(fact_3576_xor__nat__numerals_I2_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y))) = aa(num,nat,numeral_numeral(nat),bit0(Y)) ) ).

% xor_nat_numerals(2)
tff(fact_3577_xor__nat__numerals_I3_J,axiom,
    ! [Xa: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),bit0(Xa))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Xa)) ) ).

% xor_nat_numerals(3)
tff(fact_3578_xor__nat__numerals_I4_J,axiom,
    ! [Xa: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Xa))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),bit0(Xa)) ) ).

% xor_nat_numerals(4)
tff(fact_3579_and__nat__numerals_I2_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y))) = one_one(nat) ) ).

% and_nat_numerals(2)
tff(fact_3580_and__nat__numerals_I4_J,axiom,
    ! [Xa: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Xa))),aa(nat,nat,suc,zero_zero(nat))) = one_one(nat) ) ).

% and_nat_numerals(4)
tff(fact_3581_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,modulo_modulo(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),N)
        <=> ( ( N = zero_zero(nat) )
            & ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2) ) ) ) ).

% bit_mod_2_iff
tff(fact_3582_Suc__0__and__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),aa(nat,nat,suc,zero_zero(nat))),N) = modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% Suc_0_and_eq
tff(fact_3583_and__Suc__0__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),N),aa(nat,nat,suc,zero_zero(nat))) = modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% and_Suc_0_eq
tff(fact_3584_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),bit0(Xa))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(4)
tff(fact_3585_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% xor_numerals(6)
tff(fact_3586_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,B2: A,N: nat] :
          ( ! [N2: nat] :
              ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N2)
              | ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N2) )
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),N)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
              | aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N) ) ) ) ) ).

% bit_disjunctive_add_iff
tff(fact_3587_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(nat,A,semiring_1_of_nat(A),M)),N)
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(nat,M),N) ) ) ).

% bit_of_nat_iff_bit
tff(fact_3588_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N)) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_xor_eq
tff(fact_3589_num__induct,axiom,
    ! [P: fun(num,$o),Xa: num] :
      ( aa(num,$o,P,one2)
     => ( ! [X: num] :
            ( aa(num,$o,P,X)
           => aa(num,$o,P,inc(X)) )
       => aa(num,$o,P,Xa) ) ) ).

% num_induct
tff(fact_3590_add__inc,axiom,
    ! [Xa: num,Y: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),Xa),inc(Y)) = inc(aa(num,num,aa(num,fun(num,num),plus_plus(num),Xa),Y)) ) ).

% add_inc
tff(fact_3591_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(nat,nat,suc,N)) ) ).

% not_bit_1_Suc
tff(fact_3592_bit__1__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),N)
        <=> ( N = zero_zero(nat) ) ) ) ).

% bit_1_iff
tff(fact_3593_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,one_one(A)),aa(num,nat,numeral_numeral(nat),N)) ) ).

% bit_numeral_simps(1)
tff(fact_3594_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [B2: $o,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa($o,A,zero_neq_one_of_bool(A),B2)),N)
        <=> ( (B2)
            & ( N = zero_zero(nat) ) ) ) ) ).

% bit_of_bool_iff
tff(fact_3595_inc_Osimps_I1_J,axiom,
    inc(one2) = bit0(one2) ).

% inc.simps(1)
tff(fact_3596_inc_Osimps_I2_J,axiom,
    ! [Xa: num] : ( inc(bit0(Xa)) = aa(num,num,bit1,Xa) ) ).

% inc.simps(2)
tff(fact_3597_inc_Osimps_I3_J,axiom,
    ! [Xa: num] : ( inc(aa(num,num,bit1,Xa)) = bit0(inc(Xa)) ) ).

% inc.simps(3)
tff(fact_3598_add__One,axiom,
    ! [Xa: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),Xa),one2) = inc(Xa) ) ).

% add_One
tff(fact_3599_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
     => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N)
       => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,bit_se2584673776208193580ke_bit(int,M),K)) ) ) ).

% bit_imp_take_bit_positive
tff(fact_3600_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int))),N)
    <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) ).

% bit_not_int_iff'
tff(fact_3601_and__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% and_nat_def
tff(fact_3602_mult__inc,axiom,
    ! [Xa: num,Y: num] : ( aa(num,num,aa(num,fun(num,num),times_times(num),Xa),inc(Y)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),aa(num,num,aa(num,fun(num,num),times_times(num),Xa),Y)),Xa) ) ).

% mult_inc
tff(fact_3603_numeral__inc,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [Xa: num] : ( aa(num,A,numeral_numeral(A),inc(Xa)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),Xa)),one_one(A)) ) ) ).

% numeral_inc
tff(fact_3604_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,bit_concat_bit(M,K,L)),N)
    <=> ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M)
          & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) )
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
          & aa(nat,$o,bit_se5641148757651400278ts_bit(int,L),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) ) ) ) ).

% bit_concat_bit_iff
tff(fact_3605_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat,A2: A] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) = zero_zero(A) )
         => ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N) ) ) ).

% exp_eq_0_imp_not_bit
tff(fact_3606_bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,suc,N))
        <=> aa(nat,$o,bit_se5641148757651400278ts_bit(A,divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),N) ) ) ).

% bit_Suc
tff(fact_3607_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N2: nat] :
          ( ! [M3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N2),M3)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),M3)
              <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N2) ) )
         => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
             => ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N2),one_one(nat)))
              <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N2) ) ) ) ).

% int_bit_bound
tff(fact_3608_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) = zero_zero(A) )
        <=> ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N) ) ) ).

% and_exp_eq_0_iff_not_bit
tff(fact_3609_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),A2)),N)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% even_bit_succ_iff
tff(fact_3610_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
          <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),N)
              | ( N = zero_zero(nat) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
tff(fact_3611_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A,N: nat] :
          ( ! [J2: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,suc,J2))
         => ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2))),N)
          <=> $ite(N = zero_zero(nat),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2),aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),B2)),N)) ) ) ) ).

% bit_sum_mult_2_cases
tff(fact_3612_bit__rec,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
        <=> $ite(N = zero_zero(nat),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2),aa(nat,$o,bit_se5641148757651400278ts_bit(A,divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ) ).

% bit_rec
tff(fact_3613_and__nat__unfold,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N)
      = $ite(
          ( ( M = zero_zero(nat) )
          | ( N = zero_zero(nat) ) ),
          zero_zero(nat),
          aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),divide_divide(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% and_nat_unfold
tff(fact_3614_and__nat__rec,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),M),N)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)
            & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344872417868541ns_and(nat),divide_divide(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% and_nat_rec
tff(fact_3615_xor__nat__unfold,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N)
      = $ite(
          M = zero_zero(nat),
          N,
          $ite(N = zero_zero(nat),M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),divide_divide(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ) ) ).

% xor_nat_unfold
tff(fact_3616_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,suc,N)),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N)))),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)) ) ).

% take_bit_Suc_from_most
tff(fact_3617_xor__nat__rec,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
             != ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),divide_divide(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% xor_nat_rec
tff(fact_3618_one__xor__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),one_one(A)),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)))),aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2))) ) ) ).

% one_xor_eq
tff(fact_3619_xor__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),one_one(A)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)))),aa($o,A,zero_neq_one_of_bool(A),~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2))) ) ) ).

% xor_one_eq
tff(fact_3620_set__bit__eq,axiom,
    ! [N: nat,K: int] : ( bit_se5668285175392031749et_bit(int,N,K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa($o,int,zero_neq_one_of_bool(int),~ aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N))),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ).

% set_bit_eq
tff(fact_3621_unset__bit__eq,axiom,
    ! [N: nat,K: int] : ( bit_se2638667681897837118et_bit(int,N,K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),K),aa(int,int,aa(int,fun(int,int),times_times(int),aa($o,int,zero_neq_one_of_bool(int),aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N))),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))) ) ).

% unset_bit_eq
tff(fact_3622_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(num,nat,numeral_numeral(nat),N)),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(num,nat,numeral_numeral(nat),N))) ) ) ).

% push_bit_numeral_minus_1
tff(fact_3623_sinh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,sinh(A),Xa) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Xa)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa)))) ) ) ).

% sinh_def
tff(fact_3624_num_Osize_I6_J,axiom,
    ! [X32: num] : ( aa(num,nat,size_size(num),aa(num,num,bit1,X32)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X32)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(6)
tff(fact_3625_cosh__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,cosh(A),Xa) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,exp(A),Xa)),aa(A,A,exp(A),aa(A,A,uminus_uminus(A),Xa)))) ) ) ).

% cosh_def
tff(fact_3626_complex__div__cnj,axiom,
    ! [A2: complex,B2: complex] : ( divide_divide(complex,A2,B2) = divide_divide(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)),real_Vector_of_real(complex,aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,B2)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% complex_div_cnj
tff(fact_3627_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,Xa: A,B2: real] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa) = aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa) )
        <=> ( ( A2 = B2 )
            | ( Xa = zero_zero(A) ) ) ) ) ).

% scaleR_cancel_right
tff(fact_3628_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),zero_zero(A)) = zero_zero(A) ) ) ).

% scaleR_zero_right
tff(fact_3629_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V6157519004096292374lgebra(A)
     => ! [Xa: A,A2: real,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),Xa),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) = aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y)) ) ) ).

% mult_scaleR_right
tff(fact_3630_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( real_V6157519004096292374lgebra(A)
     => ! [A2: real,Xa: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),Y) = aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y)) ) ) ).

% mult_scaleR_left
tff(fact_3631_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,Xa: A,Y: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa) = aa(A,A,real_V8093663219630862766scaleR(A,A2),Y) )
        <=> ( ( Xa = Y )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% scaleR_cancel_left
tff(fact_3632_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% xor_nonnegative_int_iff
tff(fact_3633_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se4730199178511100633sh_bit(int,N),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% push_bit_nonnegative_int_iff
tff(fact_3634_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)),zero_zero(int))
    <=> ~ ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% xor_negative_int_iff
tff(fact_3635_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se4730199178511100633sh_bit(int,N),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% push_bit_negative_int_iff
tff(fact_3636_scaleR__one,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,one_one(real)),Xa) = Xa ) ) ).

% scaleR_one
tff(fact_3637_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% push_bit_of_0
tff(fact_3638_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,A2: A] :
          ( ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(A) ) ) ) ).

% push_bit_eq_0_iff
tff(fact_3639_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,B2: real,Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),times_times(real),A2),B2)),Xa) ) ) ).

% scaleR_scaleR
tff(fact_3640_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A2)) = aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),A2) ) ) ).

% push_bit_push_bit
tff(fact_3641_complex__cnj__mult,axiom,
    ! [Xa: complex,Y: complex] : ( cnj(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Xa),Y)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cnj(Xa)),cnj(Y)) ) ).

% complex_cnj_mult
tff(fact_3642_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] : ( bit_concat_bit(N,zero_zero(int),L) = aa(int,int,bit_se4730199178511100633sh_bit(int,N),L) ) ).

% concat_bit_of_zero_1
tff(fact_3643_complex__cnj__zero,axiom,
    cnj(zero_zero(complex)) = zero_zero(complex) ).

% complex_cnj_zero
tff(fact_3644_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( cnj(Z) = zero_zero(complex) )
    <=> ( Z = zero_zero(complex) ) ) ).

% complex_cnj_zero_iff
tff(fact_3645_complex__cnj__one,axiom,
    cnj(one_one(complex)) = one_one(complex) ).

% complex_cnj_one
tff(fact_3646_complex__cnj__one__iff,axiom,
    ! [Z: complex] :
      ( ( cnj(Z) = one_one(complex) )
    <=> ( Z = one_one(complex) ) ) ).

% complex_cnj_one_iff
tff(fact_3647_complex__cnj__diff,axiom,
    ! [Xa: complex,Y: complex] : ( cnj(aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Xa),Y)) = aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),cnj(Xa)),cnj(Y)) ) ).

% complex_cnj_diff
tff(fact_3648_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,Xa: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(real) )
            | ( Xa = zero_zero(A) ) ) ) ) ).

% scaleR_eq_0_iff
tff(fact_3649_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,zero_zero(real)),Xa) = zero_zero(A) ) ) ).

% scaleR_zero_left
tff(fact_3650_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: A,U: real,A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,U),B2)) )
        <=> ( ( A2 = B2 )
            | ( U = one_one(real) ) ) ) ) ).

% scaleR_eq_iff
tff(fact_3651_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),K)) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(num,A,numeral_numeral(A),bit0(K))) ) ) ).

% push_bit_Suc_numeral
tff(fact_3652_scaleR__minus1__left,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,uminus_uminus(real),one_one(real))),Xa) = aa(A,A,uminus_uminus(A),Xa) ) ) ).

% scaleR_minus1_left
tff(fact_3653_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),U)),A2)),aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) = A2 ) ) ).

% scaleR_collapse
tff(fact_3654_norm__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: real,Xa: A] : ( real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,abs_abs(real),A2)),real_V7770717601297561774m_norm(A,Xa)) ) ) ).

% norm_scaleR
tff(fact_3655_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),K))) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(K)))) ) ) ).

% push_bit_Suc_minus_numeral
tff(fact_3656_scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),U)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W))),A2) ) ) ).

% scaleR_times
tff(fact_3657_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),A2) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% push_bit_Suc
tff(fact_3658_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) ) ) ).

% push_bit_of_1
tff(fact_3659_push__bit__of__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,N),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N) ) ).

% push_bit_of_Suc_0
tff(fact_3660_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A2))
        <=> ( ( N != zero_zero(nat) )
            | aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2) ) ) ) ).

% even_push_bit_iff
tff(fact_3661_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [V: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,aa(num,real,numeral_numeral(real),W),aa(num,real,numeral_numeral(real),V))),A2) ) ) ).

% inverse_scaleR_times
tff(fact_3662_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [U: num,V: num,W: num,A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,aa(num,real,numeral_numeral(real),U),aa(num,real,numeral_numeral(real),V))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),A2)) = aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),U)),aa(num,real,numeral_numeral(real),W)),aa(num,real,numeral_numeral(real),V))),A2) ) ) ).

% fraction_scaleR_times
tff(fact_3663_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A2)) = A2 ) ) ).

% scaleR_half_double
tff(fact_3664_flip__bit__int__def,axiom,
    ! [N: nat,K: int] : ( bit_se8732182000553998342ip_bit(int,N,K) = aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),aa(int,int,bit_se4730199178511100633sh_bit(int,N),one_one(int))) ) ).

% flip_bit_int_def
tff(fact_3665_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),Q2)),N)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(nat,Q2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) ) ) ).

% bit_push_bit_iff_nat
tff(fact_3666_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( size(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,nat,size_size(A),Xa) != aa(A,nat,size_size(A),Y) )
         => ( Xa != Y ) ) ) ).

% size_neq_size_imp_neq
tff(fact_3667_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),N)) = aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_push_bit
tff(fact_3668_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,M: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,N),M)) ) ) ).

% push_bit_of_nat
tff(fact_3669_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,Xa: A,Y: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ).

% scaleR_right_distrib
tff(fact_3670_push__bit__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A,B2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A2)),aa(A,A,bit_se4730199178511100633sh_bit(A,N),B2)) ) ) ).

% push_bit_add
tff(fact_3671_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,A2: real,B2: real] :
          ( ( Xa != zero_zero(A) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa) = aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
tff(fact_3672_scaleR__right__diff__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,Xa: A,Y: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ).

% scaleR_right_diff_distrib
tff(fact_3673_real__scaleR__def,axiom,
    ! [A2: real,Xa: real] : ( aa(real,real,real_V8093663219630862766scaleR(real,A2),Xa) = aa(real,real,aa(real,fun(real,real),times_times(real),A2),Xa) ) ).

% real_scaleR_def
tff(fact_3674_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,Xa: A,Y: A] :
          ( ( A2 != zero_zero(real) )
         => ( ( aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa) = aa(A,A,real_V8093663219630862766scaleR(A,A2),Y) )
           => ( Xa = Y ) ) ) ) ).

% scaleR_left_imp_eq
tff(fact_3675_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),N)
    <=> ( N = zero_zero(nat) ) ) ).

% bit_Suc_0_iff
tff(fact_3676_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(nat,nat,suc,N)) ).

% not_bit_Suc_0_Suc
tff(fact_3677_XOR__lower,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),Xa),Y)) ) ) ).

% XOR_lower
tff(fact_3678_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,B2: real,Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa)) ) ) ).

% scaleR_left_distrib
tff(fact_3679_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: real,Y: real,Xaa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y)),Xaa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,Xa),Xaa)),aa(A,A,real_V8093663219630862766scaleR(A,Y),Xaa)) ) ) ).

% scaleR_left.add
tff(fact_3680_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [R: real,Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,R),Xa) = aa(A,A,aa(A,fun(A,A),times_times(A),real_Vector_of_real(A,R)),Xa) ) ) ).

% scaleR_conv_of_real
tff(fact_3681_of__real__def,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [R: real] : ( real_Vector_of_real(A,R) = aa(A,A,real_V8093663219630862766scaleR(A,R),one_one(A)) ) ) ).

% of_real_def
tff(fact_3682_scaleR__left__diff__distrib,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: real,B2: real,Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),Xa) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa)) ) ) ).

% scaleR_left_diff_distrib
tff(fact_3683_scaleR__left_Odiff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: real,Y: real,Xaa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y)),Xaa) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,Xa),Xaa)),aa(A,A,real_V8093663219630862766scaleR(A,Y),Xaa)) ) ) ).

% scaleR_left.diff
tff(fact_3684_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] : ( aa(complex,complex,real_V8093663219630862766scaleR(complex,R),complex2(A2,B2)) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R),A2),aa(real,real,aa(real,fun(real,real),times_times(real),R),B2)) ) ).

% complex_scaleR
tff(fact_3685_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),aa(A,A,bit_se4730199178511100633sh_bit(A,M),A2)) ) ) ).

% push_bit_take_bit
tff(fact_3686_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A2)) = aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),A2)) ) ) ).

% take_bit_push_bit
tff(fact_3687_flip__bit__nat__def,axiom,
    ! [M: nat,N: nat] : ( bit_se8732182000553998342ip_bit(nat,M,N) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),N),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),one_one(nat))) ) ).

% flip_bit_nat_def
tff(fact_3688_not__bit__Suc__0__numeral,axiom,
    ! [N: num] : ~ aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),N)) ).

% not_bit_Suc_0_numeral
tff(fact_3689_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa)) ) ) ) ).

% scaleR_right_mono
tff(fact_3690_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: real,A2: real,C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),C2)) ) ) ) ).

% scaleR_right_mono_neg
tff(fact_3691_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) )
            & ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ) ).

% scaleR_le_cancel_left
tff(fact_3692_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ) ).

% scaleR_le_cancel_left_neg
tff(fact_3693_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ).

% scaleR_le_cancel_left_pos
tff(fact_3694_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [Xa: A,Y: A,A2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ) ).

% scaleR_left_mono
tff(fact_3695_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [B2: A,A2: A,C2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),zero_zero(real))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),B2)) ) ) ) ).

% scaleR_left_mono_neg
tff(fact_3696_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [U: real,V: real,A2: A,Xa: A] :
          ( ( aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,U,V)),A2) = Xa )
        <=> $ite(V = zero_zero(real),Xa = zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,U),A2) = aa(A,A,real_V8093663219630862766scaleR(A,V),Xa)) ) ) ).

% vector_fraction_eq_iff
tff(fact_3697_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,U: real,V: real,A2: A] :
          ( ( Xa = aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,U,V)),A2) )
        <=> $ite(V = zero_zero(real),Xa = zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,V),Xa) = aa(A,A,real_V8093663219630862766scaleR(A,U),A2)) ) ) ).

% eq_vector_fraction_iff
tff(fact_3698_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),E)),C2)),D2) ) ) ).

% Real_Vector_Spaces.le_add_iff1
tff(fact_3699_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),E)),C2)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,B2),E)),D2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),E)),D2)) ) ) ).

% Real_Vector_Spaces.le_add_iff2
tff(fact_3700_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_se4730199178511100633sh_bit(int,M),K)),N)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) ) ) ).

% bit_push_bit_iff_int
tff(fact_3701_xor__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se5824344971392196577ns_xor(nat),M),N) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% xor_nat_def
tff(fact_3702_concat__bit__eq,axiom,
    ! [N: nat,K: int,L: int] : ( bit_concat_bit(N,K,L) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,bit_se2584673776208193580ke_bit(int,N),K)),aa(int,int,bit_se4730199178511100633sh_bit(int,N),L)) ) ).

% concat_bit_eq
tff(fact_3703_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( bit_se8732182000553998342ip_bit(A,N,A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),A2),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) ) ) ).

% flip_bit_eq_xor
tff(fact_3704_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)),zero_zero(A))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% scaleR_le_0_iff
tff(fact_3705_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2))
        <=> ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) )
            | ( A2 = zero_zero(real) ) ) ) ) ).

% zero_le_scaleR_iff
tff(fact_3706_scaleR__mono,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,Xa: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),B2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Y)) ) ) ) ) ) ).

% scaleR_mono
tff(fact_3707_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),D2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),C2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),C2)),aa(A,A,real_V8093663219630862766scaleR(A,B2),D2)) ) ) ) ) ) ).

% scaleR_mono'
tff(fact_3708_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,Xa: A] :
          ( ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A)) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),zero_zero(A)) ) ) ).

% split_scaleR_neg_le
tff(fact_3709_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A)) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)) ) ) ).

% split_scaleR_pos_le
tff(fact_3710_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)) ) ) ) ).

% scaleR_nonneg_nonneg
tff(fact_3711_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),zero_zero(A)) ) ) ) ).

% scaleR_nonneg_nonpos
tff(fact_3712_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),zero_zero(A)) ) ) ) ).

% scaleR_nonpos_nonneg
tff(fact_3713_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [A2: real,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),zero_zero(A))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(A,A,real_V8093663219630862766scaleR(A,A2),B2)) ) ) ) ).

% scaleR_nonpos_nonpos
tff(fact_3714_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [Xa: A,A2: real] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),one_one(real))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),Xa) ) ) ) ).

% scaleR_left_le_one_le
tff(fact_3715_scaleR__2,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A] : ( aa(A,A,real_V8093663219630862766scaleR(A,aa(num,real,numeral_numeral(real),bit0(one2))),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Xa) ) ) ).

% scaleR_2
tff(fact_3716_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [M: real,Xa: A,C2: A,Y: A] :
          ( ( M != zero_zero(real) )
         => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,M),Xa)),C2) = Y )
          <=> ( Xa = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),Y)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),C2)) ) ) ) ) ).

% real_vector_affinity_eq
tff(fact_3717_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [M: real,Y: A,Xa: A,C2: A] :
          ( ( M != zero_zero(real) )
         => ( ( Y = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,M),Xa)),C2) )
          <=> ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),Y)),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),M)),C2)) = Xa ) ) ) ) ).

% real_vector_eq_affinity
tff(fact_3718_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_le_divideR_eq
tff(fact_3719_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% neg_divideR_le_eq
tff(fact_3720_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% pos_le_divideR_eq
tff(fact_3721_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_divideR_le_eq
tff(fact_3722_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_divideR_less_eq
tff(fact_3723_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% pos_less_divideR_eq
tff(fact_3724_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),B2) ) ) ) ).

% neg_divideR_less_eq
tff(fact_3725_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_less_divideR_eq
tff(fact_3726_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(nat,aa(int,nat,nat2,K)),N)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(nat,$o,bit_se5641148757651400278ts_bit(int,K),N) ) ) ).

% bit_nat_iff
tff(fact_3727_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A2: real,Xa: A] :
          ( ( A2 != zero_zero(real) )
         => ( ( Xa != zero_zero(A) )
           => ( aa(A,A,inverse_inverse(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),A2)),aa(A,A,inverse_inverse(A),Xa)) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
tff(fact_3728_push__bit__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(num,A,numeral_numeral(A),bit0(one2)))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),A2)),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% push_bit_double
tff(fact_3729_num_Osize_I4_J,axiom,
    aa(num,nat,size_size(num),one2) = zero_zero(nat) ).

% num.size(4)
tff(fact_3730_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) != zero_zero(A) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
tff(fact_3731_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divideR_le_eq
tff(fact_3732_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_le_minus_divideR_eq
tff(fact_3733_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_minus_divideR_le_eq
tff(fact_3734_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_le_minus_divideR_eq
tff(fact_3735_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% pos_less_minus_divideR_eq
tff(fact_3736_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% pos_minus_divideR_less_eq
tff(fact_3737_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,A2: A,B2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2)))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),B2)),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)) ) ) ) ).

% neg_less_minus_divideR_eq
tff(fact_3738_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,B2: A,A2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),C2)),B2))),A2)
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(A,A,real_V8093663219630862766scaleR(A,C2),A2)),aa(A,A,uminus_uminus(A),B2)) ) ) ) ).

% neg_minus_divideR_less_eq
tff(fact_3739_push__bit__int__def,axiom,
    ! [N: nat,K: int] : ( aa(int,int,bit_se4730199178511100633sh_bit(int,N),K) = aa(int,int,aa(int,fun(int,int),times_times(int),K),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% push_bit_int_def
tff(fact_3740_push__bit__nat__def,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,bit_se4730199178511100633sh_bit(nat,N),M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)) ) ).

% push_bit_nat_def
tff(fact_3741_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),A2) = aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)) ) ) ).

% push_bit_eq_mult
tff(fact_3742_complex__mod__mult__cnj,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% complex_mod_mult_cnj
tff(fact_3743_push__bit__minus__one,axiom,
    ! [N: nat] : ( aa(int,int,bit_se4730199178511100633sh_bit(int,N),aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ).

% push_bit_minus_one
tff(fact_3744_XOR__upper,axiom,
    ! [Xa: int,N: nat,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Xa),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
         => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),Xa),Y)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ) ) ).

% XOR_upper
tff(fact_3745_complex__norm__square,axiom,
    ! [Z: complex] : ( real_Vector_of_real(complex,aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) ) ).

% complex_norm_square
tff(fact_3746_num_Osize_I5_J,axiom,
    ! [X2: num] : ( aa(num,nat,size_size(num),bit0(X2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,size_size(num),X2)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% num.size(5)
tff(fact_3747_xor__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ( ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K) )
             != ( ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L) ) ))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% xor_int_rec
tff(fact_3748_xor__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),K),L)
      = $ite(
          K = aa(int,int,uminus_uminus(int),one_one(int)),
          aa(int,int,bit_ri4277139882892585799ns_not(int),L),
          $ite(
            L = aa(int,int,uminus_uminus(int),one_one(int)),
            aa(int,int,bit_ri4277139882892585799ns_not(int),K),
            $ite(
              K = zero_zero(int),
              L,
              $ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),bit0(one2)))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344971392196577ns_xor(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2))))))) ) ) ) ) ).

% xor_int_unfold
tff(fact_3749_complex__diff__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Z),cnj(Z)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),im(Z)))),imaginary_unit) ) ).

% complex_diff_cnj
tff(fact_3750_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),cnj(Z)),W)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(W))))) ) ).

% cnj_add_mult_eq_Re
tff(fact_3751_not__int__rec,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa($o,int,zero_neq_one_of_bool(int),aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,bit_ri4277139882892585799ns_not(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% not_int_rec
tff(fact_3752_complex__Im__of__int,axiom,
    ! [Z: int] : ( im(aa(int,complex,ring_1_of_int(complex),Z)) = zero_zero(real) ) ).

% complex_Im_of_int
tff(fact_3753_complex__Im__of__nat,axiom,
    ! [N: nat] : ( im(aa(nat,complex,semiring_1_of_nat(complex),N)) = zero_zero(real) ) ).

% complex_Im_of_nat
tff(fact_3754_complex__Im__fact,axiom,
    ! [N: nat] : ( im(semiring_char_0_fact(complex,N)) = zero_zero(real) ) ).

% complex_Im_fact
tff(fact_3755_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_ri4277139882892585799ns_not(A),Xa)),Xa) = zero_zero(A) ) ) ).

% bit.conj_cancel_left
tff(fact_3756_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Xa),aa(A,A,bit_ri4277139882892585799ns_not(A),Xa)) = zero_zero(A) ) ) ).

% bit.conj_cancel_right
tff(fact_3757_Im__complex__of__real,axiom,
    ! [Z: real] : ( im(real_Vector_of_real(complex,Z)) = zero_zero(real) ) ).

% Im_complex_of_real
tff(fact_3758_Im__power__real,axiom,
    ! [Xa: complex,N: nat] :
      ( ( im(Xa) = zero_zero(real) )
     => ( im(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Xa),N)) = zero_zero(real) ) ) ).

% Im_power_real
tff(fact_3759_complex__Im__numeral,axiom,
    ! [V: num] : ( im(aa(num,complex,numeral_numeral(complex),V)) = zero_zero(real) ) ).

% complex_Im_numeral
tff(fact_3760_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),zero_zero(A)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.compl_zero
tff(fact_3761_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,uminus_uminus(A),one_one(A))) = zero_zero(A) ) ) ).

% bit.compl_one
tff(fact_3762_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,uminus_uminus(A),one_one(A))),Xa) = aa(A,A,bit_ri4277139882892585799ns_not(A),Xa) ) ) ).

% bit.xor_one_left
tff(fact_3763_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Xa),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),Xa) ) ) ).

% bit.xor_one_right
tff(fact_3764_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(A,A,bit_ri4277139882892585799ns_not(A),Xa)),Xa) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_left
tff(fact_3765_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),Xa),aa(A,A,bit_ri4277139882892585799ns_not(A),Xa)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.xor_cancel_right
tff(fact_3766_not__negative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_ri4277139882892585799ns_not(int),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% not_negative_int_iff
tff(fact_3767_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% not_nonnegative_int_iff
tff(fact_3768_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z))) = zero_zero(real) ) ).

% complex_In_mult_cnj_zero
tff(fact_3769_Im__i__times,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) = re(Z) ) ).

% Im_i_times
tff(fact_3770_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% push_bit_minus_one_eq_not_mask
tff(fact_3771_Re__power__real,axiom,
    ! [Xa: complex,N: nat] :
      ( ( im(Xa) = zero_zero(real) )
     => ( re(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Xa),N)) = aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Xa)),N) ) ) ).

% Re_power_real
tff(fact_3772_Re__i__times,axiom,
    ! [Z: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Z)) = aa(real,real,uminus_uminus(real),im(Z)) ) ).

% Re_i_times
tff(fact_3773_cos__Arg__i__mult__zero,axiom,
    ! [Y: complex] :
      ( ( Y != zero_zero(complex) )
     => ( ( re(Y) = zero_zero(real) )
       => ( aa(real,real,cos(real),arg(Y)) = zero_zero(real) ) ) ) ).

% cos_Arg_i_mult_zero
tff(fact_3774_not__one__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ( aa(A,A,bit_ri4277139882892585799ns_not(A),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% not_one_eq
tff(fact_3775_csqrt__of__real__nonneg,axiom,
    ! [Xa: complex] :
      ( ( im(Xa) = zero_zero(real) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(Xa))
       => ( csqrt(Xa) = real_Vector_of_real(complex,aa(real,real,sqrt,re(Xa))) ) ) ) ).

% csqrt_of_real_nonneg
tff(fact_3776_csqrt__minus,axiom,
    ! [Xa: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(Xa)),zero_zero(real))
        | ( ( im(Xa) = zero_zero(real) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(Xa)) ) )
     => ( csqrt(aa(complex,complex,uminus_uminus(complex),Xa)) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),csqrt(Xa)) ) ) ).

% csqrt_minus
tff(fact_3777_csqrt__of__real__nonpos,axiom,
    ! [Xa: complex] :
      ( ( im(Xa) = zero_zero(real) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(Xa)),zero_zero(real))
       => ( csqrt(Xa) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,aa(real,real,sqrt,aa(real,real,abs_abs(real),re(Xa))))) ) ) ) ).

% csqrt_of_real_nonpos
tff(fact_3778_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,Xa: complex] : ( re(aa(complex,complex,real_V8093663219630862766scaleR(complex,R),Xa)) = aa(real,real,aa(real,fun(real,real),times_times(real),R),re(Xa)) ) ).

% scaleR_complex.simps(1)
tff(fact_3779_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,Xa: complex] : ( im(aa(complex,complex,real_V8093663219630862766scaleR(complex,R),Xa)) = aa(real,real,aa(real,fun(real,real),times_times(real),R),im(Xa)) ) ).

% scaleR_complex.simps(2)
tff(fact_3780_scaleR__complex_Ocode,axiom,
    ! [R: real,Xa: complex] : ( aa(complex,complex,real_V8093663219630862766scaleR(complex,R),Xa) = complex2(aa(real,real,aa(real,fun(real,real),times_times(real),R),re(Xa)),aa(real,real,aa(real,fun(real,real),times_times(real),R),im(Xa))) ) ).

% scaleR_complex.code
tff(fact_3781_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( member(complex,Z,ring_1_Ints(complex))
    <=> ( ( im(Z) = zero_zero(real) )
        & ? [I3: int] : ( re(Z) = aa(int,real,ring_1_of_int(real),I3) ) ) ) ).

% complex_is_Int_iff
tff(fact_3782_times__complex_Osimps_I2_J,axiom,
    ! [Xa: complex,Y: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Xa),Y)) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),im(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),re(Y))) ) ).

% times_complex.simps(2)
tff(fact_3783_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( im(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),re(Z)) ) ) ).

% cmod_eq_Re
tff(fact_3784_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( re(Z) = zero_zero(real) )
     => ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,abs_abs(real),im(Z)) ) ) ).

% cmod_eq_Im
tff(fact_3785_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( aa(real,real,abs_abs(real),re(Z)) = real_V7770717601297561774m_norm(complex,Z) )
     => ( im(Z) = zero_zero(real) ) ) ).

% Im_eq_0
tff(fact_3786_cmod__Re__le__iff,axiom,
    ! [Xa: complex,Y: complex] :
      ( ( im(Xa) = im(Y) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(complex,Xa)),real_V7770717601297561774m_norm(complex,Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),re(Xa))),aa(real,real,abs_abs(real),re(Y))) ) ) ).

% cmod_Re_le_iff
tff(fact_3787_cmod__Im__le__iff,axiom,
    ! [Xa: complex,Y: complex] :
      ( ( re(Xa) = re(Y) )
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(complex,Xa)),real_V7770717601297561774m_norm(complex,Y))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),im(Xa))),aa(real,real,abs_abs(real),im(Y))) ) ) ).

% cmod_Im_le_iff
tff(fact_3788_times__complex_Osimps_I1_J,axiom,
    ! [Xa: complex,Y: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Xa),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),im(Y))) ) ).

% times_complex.simps(1)
tff(fact_3789_minus__complex_Ocode,axiom,
    ! [Xa: complex,Y: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Xa),Y) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),re(Xa)),re(Y)),aa(real,real,aa(real,fun(real,real),minus_minus(real),im(Xa)),im(Y))) ) ).

% minus_complex.code
tff(fact_3790_csqrt__principal,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(csqrt(Z)))
      | ( ( re(csqrt(Z)) = zero_zero(real) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(csqrt(Z))) ) ) ).

% csqrt_principal
tff(fact_3791_cmod__le,axiom,
    ! [Z: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(complex,Z)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),re(Z))),aa(real,real,abs_abs(real),im(Z)))) ).

% cmod_le
tff(fact_3792_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),B2) ) ) ).

% not_diff_distrib
tff(fact_3793_not__add__distrib,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,B2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),B2) ) ) ).

% not_add_distrib
tff(fact_3794_Re__exp,axiom,
    ! [Z: complex] : ( re(aa(complex,complex,exp(complex),Z)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,exp(real),re(Z))),aa(real,real,cos(real),im(Z))) ) ).

% Re_exp
tff(fact_3795_Im__exp,axiom,
    ! [Z: complex] : ( im(aa(complex,complex,exp(complex),Z)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,exp(real),re(Z))),aa(real,real,sin(real),im(Z))) ) ).

% Im_exp
tff(fact_3796_imaginary__unit_Osimps_I1_J,axiom,
    re(imaginary_unit) = zero_zero(real) ).

% imaginary_unit.simps(1)
tff(fact_3797_complex__Re__le__cmod,axiom,
    ! [Xa: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(Xa)),real_V7770717601297561774m_norm(complex,Xa)) ).

% complex_Re_le_cmod
tff(fact_3798_imaginary__unit_Osimps_I2_J,axiom,
    im(imaginary_unit) = one_one(real) ).

% imaginary_unit.simps(2)
tff(fact_3799_fun__complex__eq,axiom,
    ! [A: $tType,F3: fun(A,complex),X3: A] : ( aa(A,complex,F3,X3) = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,re(aa(A,complex,F3,X3)))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,im(aa(A,complex,F3,X3))))) ) ).

% fun_complex_eq
tff(fact_3800_complex__eq,axiom,
    ! [A2: complex] : ( A2 = aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),real_Vector_of_real(complex,re(A2))),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),real_Vector_of_real(complex,im(A2)))) ) ).

% complex_eq
tff(fact_3801_zero__complex_Osimps_I2_J,axiom,
    im(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(2)
tff(fact_3802_one__complex_Osimps_I2_J,axiom,
    im(one_one(complex)) = zero_zero(real) ).

% one_complex.simps(2)
tff(fact_3803_zero__complex_Osimps_I1_J,axiom,
    re(zero_zero(complex)) = zero_zero(real) ).

% zero_complex.simps(1)
tff(fact_3804_one__complex_Osimps_I1_J,axiom,
    re(one_one(complex)) = one_one(real) ).

% one_complex.simps(1)
tff(fact_3805_times__complex_Ocode,axiom,
    ! [Xa: complex,Y: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Xa),Y) = complex2(aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),im(Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),im(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),re(Y)))) ) ).

% times_complex.code
tff(fact_3806_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(divide_divide(complex,A2,B2)))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) )
      & ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(divide_divide(complex,A2,B2)))
      <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ) ).

% complex_div_gt_0
tff(fact_3807_minus__complex_Osimps_I2_J,axiom,
    ! [Xa: complex,Y: complex] : ( im(aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Xa),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),im(Xa)),im(Y)) ) ).

% minus_complex.simps(2)
tff(fact_3808_minus__complex_Osimps_I1_J,axiom,
    ! [Xa: complex,Y: complex] : ( re(aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Xa),Y)) = aa(real,real,aa(real,fun(real,real),minus_minus(real),re(Xa)),re(Y)) ) ).

% minus_complex.simps(1)
tff(fact_3809_exp__eq__polar,axiom,
    ! [Z: complex] : ( aa(complex,complex,exp(complex),Z) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,exp(real),re(Z)))),cis(im(Z))) ) ).

% exp_eq_polar
tff(fact_3810_Im__power2,axiom,
    ! [Xa: complex] : ( im(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),re(Xa))),im(Xa)) ) ).

% Im_power2
tff(fact_3811_Re__power2,axiom,
    ! [Xa: complex] : ( re(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ).

% Re_power2
tff(fact_3812_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),one_one(A)) ) ) ).

% minus_eq_not_plus_1
tff(fact_3813_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,uminus_uminus(A),A2) = aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))) ) ) ).

% minus_eq_not_minus_1
tff(fact_3814_not__eq__complement,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A] : ( aa(A,A,bit_ri4277139882892585799ns_not(A),A2) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),A2)),one_one(A)) ) ) ).

% not_eq_complement
tff(fact_3815_not__int__def,axiom,
    ! [K: int] : ( aa(int,int,bit_ri4277139882892585799ns_not(int),K) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),K)),one_one(int)) ) ).

% not_int_def
tff(fact_3816_and__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = zero_zero(int) ).

% and_not_numerals(1)
tff(fact_3817_abs__Im__le__cmod,axiom,
    ! [Xa: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),im(Xa))),real_V7770717601297561774m_norm(complex,Xa)) ).

% abs_Im_le_cmod
tff(fact_3818_abs__Re__le__cmod,axiom,
    ! [Xa: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),re(Xa))),real_V7770717601297561774m_norm(complex,Xa)) ).

% abs_Re_le_cmod
tff(fact_3819_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [B2: A,A2: A] :
          ( ! [N2: nat] :
              ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N2)
             => aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N2) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_ri4277139882892585799ns_not(A),B2)) ) ) ) ).

% disjunctive_diff
tff(fact_3820_Re__csqrt,axiom,
    ! [Z: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(csqrt(Z))) ).

% Re_csqrt
tff(fact_3821_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),aa(A,A,bit_ri4277139882892585799ns_not(A),A2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),bit_se2239418461657761734s_mask(A,N)),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)) ) ) ).

% take_bit_not_eq_mask_diff
tff(fact_3822_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z = zero_zero(complex) )
    <=> ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = zero_zero(real) ) ) ).

% complex_eq_0
tff(fact_3823_unset__bit__int__def,axiom,
    ! [N: nat,K: int] : ( bit_se2638667681897837118et_bit(int,N,K) = aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,bit_se4730199178511100633sh_bit(int,N),one_one(int)))) ) ).

% unset_bit_int_def
tff(fact_3824_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% complex_neq_0
tff(fact_3825_Re__divide,axiom,
    ! [Xa: complex,Y: complex] : ( re(divide_divide(complex,Xa,Y)) = divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),im(Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% Re_divide
tff(fact_3826_complex__mult__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% complex_mult_cnj
tff(fact_3827_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),W),aa(num,nat,numeral_numeral(nat),bit0(one2))) = Z )
     => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(W))
          | ( ( re(W) = zero_zero(real) )
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(W)) ) )
       => ( csqrt(Z) = W ) ) ) ).

% csqrt_unique
tff(fact_3828_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(B2))
        | ( ( re(B2) = zero_zero(real) )
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(B2)) ) )
     => ( csqrt(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),B2),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = B2 ) ) ).

% csqrt_square
tff(fact_3829_and__not__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = one_one(int) ) ).

% and_not_numerals(2)
tff(fact_3830_and__not__numerals_I4_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),bit0(M)) ) ).

% and_not_numerals(4)
tff(fact_3831_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,uminus_uminus(int),K)),N)
    <=> aa(nat,$o,bit_se5641148757651400278ts_bit(int,aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),K),one_one(int)))),N) ) ).

% bit_minus_int_iff
tff(fact_3832_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N))) = zero_zero(A) ) ) ) ).

% take_bit_not_mask_eq_0
tff(fact_3833_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( im(divide_divide(complex,A2,B2)) = zero_zero(real) )
    <=> ( im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))) = zero_zero(real) ) ) ).

% Im_complex_div_eq_0
tff(fact_3834_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( re(divide_divide(complex,A2,B2)) = zero_zero(real) )
    <=> ( re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2))) = zero_zero(real) ) ) ).

% Re_complex_div_eq_0
tff(fact_3835_Im__divide,axiom,
    ! [Xa: complex,Y: complex] : ( im(divide_divide(complex,Xa,Y)) = divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),im(Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% Im_divide
tff(fact_3836_complex__abs__le__norm,axiom,
    ! [Z: complex] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,abs_abs(real),re(Z))),aa(real,real,abs_abs(real),im(Z)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sqrt,aa(num,real,numeral_numeral(real),bit0(one2)))),real_V7770717601297561774m_norm(complex,Z))) ).

% complex_abs_le_norm
tff(fact_3837_complex__mod__sqrt__Re__mult__cnj,axiom,
    ! [Z: complex] : ( real_V7770717601297561774m_norm(complex,Z) = aa(real,real,sqrt,re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),Z),cnj(Z)))) ) ).

% complex_mod_sqrt_Re_mult_cnj
tff(fact_3838_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,M),bit_se2239418461657761734s_mask(A,N)) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,M))) ) ) ).

% push_bit_mask_eq
tff(fact_3839_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z != zero_zero(complex) )
     => ( aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),divide_divide(real,re(Z),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),divide_divide(real,im(Z),real_V7770717601297561774m_norm(complex,Z))),aa(num,nat,numeral_numeral(nat),bit0(one2)))) = one_one(real) ) ) ).

% complex_unit_circle
tff(fact_3840_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A2: A] : ( bit_se2638667681897837118et_bit(A,N,A2) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,bit_ri4277139882892585799ns_not(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A)))) ) ) ).

% unset_bit_eq_and_not
tff(fact_3841_Complex__divide,axiom,
    ! [Xa: complex,Y: complex] : ( divide_divide(complex,Xa,Y) = complex2(divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),im(Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(real,fun(real,real),times_times(real),im(Xa)),re(Y))),aa(real,real,aa(real,fun(real,real),times_times(real),re(Xa)),im(Y))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),re(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),im(Y)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% Complex_divide
tff(fact_3842_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% and_not_numerals(5)
tff(fact_3843_and__not__numerals_I7_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(num,int,numeral_numeral(int),bit0(M)) ) ).

% and_not_numerals(7)
tff(fact_3844_and__not__numerals_I3_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = zero_zero(int) ) ).

% and_not_numerals(3)
tff(fact_3845_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z))),zero_zero(real))
    <=> ( re(Z) = aa(real,real,uminus_uminus(real),real_V7770717601297561774m_norm(complex,Z)) ) ) ).

% cmod_plus_Re_le_0_iff
tff(fact_3846_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(divide_divide(complex,A2,B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Im_complex_div_lt_0
tff(fact_3847_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(divide_divide(complex,A2,B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Im_complex_div_gt_0
tff(fact_3848_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(divide_divide(complex,A2,B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Im_complex_div_ge_0
tff(fact_3849_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),im(divide_divide(complex,A2,B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),im(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Im_complex_div_le_0
tff(fact_3850_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),re(divide_divide(complex,A2,B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Re_complex_div_lt_0
tff(fact_3851_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(divide_divide(complex,A2,B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Re_complex_div_gt_0
tff(fact_3852_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(divide_divide(complex,A2,B2)))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))) ) ).

% Re_complex_div_ge_0
tff(fact_3853_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(divide_divide(complex,A2,B2))),zero_zero(real))
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),re(aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),A2),cnj(B2)))),zero_zero(real)) ) ).

% Re_complex_div_le_0
tff(fact_3854_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A2: real] : ( aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),A2)) = im(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),cis(A2)),N)) ) ).

% sin_n_Im_cis_pow_n
tff(fact_3855_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A2: real] : ( aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),A2)) = re(aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),cis(A2)),N)) ) ).

% cos_n_Re_cis_pow_n
tff(fact_3856_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% and_not_numerals(6)
tff(fact_3857_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% and_not_numerals(9)
tff(fact_3858_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_ri4277139882892585799ns_not(A),A2)),N)
        <=> ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) != zero_zero(A) )
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N) ) ) ) ).

% bit_not_iff_eq
tff(fact_3859_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( im(csqrt(Z))
      = aa(real,real,
          aa(real,fun(real,real),times_times(real),$ite(im(Z) = zero_zero(real),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),
          aa(real,real,sqrt,divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z)),aa(num,real,numeral_numeral(real),bit0(one2))))) ) ).

% csqrt.simps(2)
tff(fact_3860_csqrt_Ocode,axiom,
    ! [Z: complex] :
      ( csqrt(Z)
      = complex2(aa(real,real,sqrt,divide_divide(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z)),aa(num,real,numeral_numeral(real),bit0(one2)))),
          aa(real,real,
            aa(real,fun(real,real),times_times(real),$ite(im(Z) = zero_zero(real),one_one(real),aa(real,real,sgn_sgn(real),im(Z)))),
            aa(real,real,sqrt,divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V7770717601297561774m_norm(complex,Z)),re(Z)),aa(num,real,numeral_numeral(real),bit0(one2)))))) ) ).

% csqrt.code
tff(fact_3861_complex__add__cnj,axiom,
    ! [Z: complex] : ( aa(complex,complex,aa(complex,fun(complex,complex),plus_plus(complex),Z),cnj(Z)) = real_Vector_of_real(complex,aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),re(Z))) ) ).

% complex_add_cnj
tff(fact_3862_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% and_not_numerals(8)
tff(fact_3863_Im__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( member(complex,R,real_Vector_Reals(complex))
     => ( im(divide_divide(complex,R,Z)) = divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),re(R))),im(Z)),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% Im_Reals_divide
tff(fact_3864_Re__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( member(complex,R,real_Vector_Reals(complex))
     => ( re(divide_divide(complex,R,Z)) = divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),re(R)),re(Z)),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(complex,Z)),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ) ) ).

% Re_Reals_divide
tff(fact_3865_or__int__rec,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)
      = aa(int,int,
          aa(int,fun(int,int),plus_plus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)
            | ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))),
          aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ).

% or_int_rec
tff(fact_3866_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(7)
tff(fact_3867_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),zero_zero(A)),A2) = A2 ) ) ).

% or.left_neutral
tff(fact_3868_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),zero_zero(A)) = A2 ) ) ).

% or.right_neutral
tff(fact_3869_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Xa),aa(A,A,uminus_uminus(A),one_one(A))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_right
tff(fact_3870_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,uminus_uminus(A),one_one(A))),Xa) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_one_left
tff(fact_3871_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L) ) ) ).

% or_nonnegative_int_iff
tff(fact_3872_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)),zero_zero(int))
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int))
        | aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)) ) ) ).

% or_negative_int_iff
tff(fact_3873_or__nat__numerals_I2_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y)) ) ).

% or_nat_numerals(2)
tff(fact_3874_or__nat__numerals_I4_J,axiom,
    ! [Xa: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Xa))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Xa)) ) ).

% or_nat_numerals(4)
tff(fact_3875_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(2)
tff(fact_3876_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa)) ) ) ).

% or_numerals(8)
tff(fact_3877_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Xa),aa(A,A,bit_ri4277139882892585799ns_not(A),Xa)) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_right
tff(fact_3878_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_ri4277139882892585799ns_not(A),Xa)),Xa) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% bit.disj_cancel_left
tff(fact_3879_real__eq__imaginary__iff,axiom,
    ! [Y: complex,Xa: complex] :
      ( member(complex,Y,real_Vector_Reals(complex))
     => ( member(complex,Xa,real_Vector_Reals(complex))
       => ( ( Xa = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y) )
        <=> ( ( Xa = zero_zero(complex) )
            & ( Y = zero_zero(complex) ) ) ) ) ) ).

% real_eq_imaginary_iff
tff(fact_3880_imaginary__eq__real__iff,axiom,
    ! [Y: complex,Xa: complex] :
      ( member(complex,Y,real_Vector_Reals(complex))
     => ( member(complex,Xa,real_Vector_Reals(complex))
       => ( ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),imaginary_unit),Y) = Xa )
        <=> ( ( Xa = zero_zero(complex) )
            & ( Y = zero_zero(complex) ) ) ) ) ) ).

% imaginary_eq_real_iff
tff(fact_3881_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit0(Xa))),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y))) ) ) ).

% or_numerals(3)
tff(fact_3882_or__nat__numerals_I3_J,axiom,
    ! [Xa: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(num,nat,numeral_numeral(nat),bit0(Xa))),aa(nat,nat,suc,zero_zero(nat))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Xa)) ) ).

% or_nat_numerals(3)
tff(fact_3883_or__nat__numerals_I1_J,axiom,
    ! [Y: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),aa(num,nat,numeral_numeral(nat),bit0(Y))) = aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,Y)) ) ).

% or_nat_numerals(1)
tff(fact_3884_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit0(Xa))),one_one(A)) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa)) ) ) ).

% or_numerals(5)
tff(fact_3885_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y)) ) ) ).

% or_numerals(1)
tff(fact_3886_or__minus__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N))) ) ).

% or_minus_numerals(2)
tff(fact_3887_or__minus__numerals_I6_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N))) ) ).

% or_minus_numerals(6)
tff(fact_3888_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),N)),one_one(int)))) ) ).

% and_minus_minus_numerals
tff(fact_3889_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),N)),one_one(int)))) ) ).

% or_minus_minus_numerals
tff(fact_3890_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),bit0(Xa))),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(4)
tff(fact_3891_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Xa: num,Y: num] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),aa(num,num,bit1,Xa))),aa(num,A,numeral_numeral(A),bit0(Y))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(num,A,numeral_numeral(A),Xa)),aa(num,A,numeral_numeral(A),Y)))) ) ) ).

% or_numerals(6)
tff(fact_3892_Reals__0,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => member(A,zero_zero(A),real_Vector_Reals(A)) ) ).

% Reals_0
tff(fact_3893_Reals__mult,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),real_Vector_Reals(A)) ) ) ) ).

% Reals_mult
tff(fact_3894_Reals__1,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => member(A,one_one(A),real_Vector_Reals(A)) ) ).

% Reals_1
tff(fact_3895_Reals__add,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),real_Vector_Reals(A)) ) ) ) ).

% Reals_add
tff(fact_3896_Reals__diff,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),real_Vector_Reals(A)) ) ) ) ).

% Reals_diff
tff(fact_3897_or__nat__def,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% or_nat_def
tff(fact_3898_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,semiring_1_of_nat(A),M)),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_or_eq
tff(fact_3899_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Xa),zero_zero(A)) = Xa ) ) ).

% bit.disj_zero_right
tff(fact_3900_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% or_eq_0_iff
tff(fact_3901_Reals__of__nat,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [N: nat] : member(A,aa(nat,A,semiring_1_of_nat(A),N),real_Vector_Reals(A)) ) ).

% Reals_of_nat
tff(fact_3902_cos__in__Reals,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( member(A,Z,real_Vector_Reals(A))
         => member(A,aa(A,A,cos(A),Z),real_Vector_Reals(A)) ) ) ).

% cos_in_Reals
tff(fact_3903_sin__in__Reals,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( member(A,Z,real_Vector_Reals(A))
         => member(A,aa(A,A,sin(A),Z),real_Vector_Reals(A)) ) ) ).

% sin_in_Reals
tff(fact_3904_fact__in__Reals,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [N: nat] : member(A,semiring_char_0_fact(A,N),real_Vector_Reals(A)) ) ).

% fact_in_Reals
tff(fact_3905_exp__in__Reals,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Z: A] :
          ( member(A,Z,real_Vector_Reals(A))
         => member(A,aa(A,A,exp(A),Z),real_Vector_Reals(A)) ) ) ).

% exp_in_Reals
tff(fact_3906_tan__in__Reals,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] :
          ( member(A,Z,real_Vector_Reals(A))
         => member(A,aa(A,A,tan(A),Z),real_Vector_Reals(A)) ) ) ).

% tan_in_Reals
tff(fact_3907_cot__in__Reals,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] :
          ( member(A,Z,real_Vector_Reals(A))
         => member(A,aa(A,A,cot(A),Z),real_Vector_Reals(A)) ) ) ).

% cot_in_Reals
tff(fact_3908_OR__lower,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
       => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),Xa),Y)) ) ) ).

% OR_lower
tff(fact_3909_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),L)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),K),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)) ) ).

% or_greater_eq
tff(fact_3910_disjunctive__add,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,B2: A] :
          ( ! [N2: nat] :
              ( ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N2)
              | ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,B2),N2) )
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),B2) ) ) ) ).

% disjunctive_add
tff(fact_3911_plus__and__or,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Y)),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),Xa),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),Y) ) ).

% plus_and_or
tff(fact_3912_set__bit__nat__def,axiom,
    ! [M: nat,N: nat] : ( bit_se5668285175392031749et_bit(nat,M,N) = aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),N),aa(nat,nat,bit_se4730199178511100633sh_bit(nat,M),one_one(nat))) ) ).

% set_bit_nat_def
tff(fact_3913_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( member(complex,Z,real_Vector_Reals(complex))
    <=> ( im(Z) = zero_zero(real) ) ) ).

% complex_is_Real_iff
tff(fact_3914_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( real_V7773925162809079976_field(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( member(A,B2,real_Vector_Reals(A))
           => ( ( B2 != zero_zero(A) )
             => member(A,divide_divide(A,A2,B2),real_Vector_Reals(A)) ) ) ) ) ).

% nonzero_Reals_divide
tff(fact_3915_Complex__in__Reals,axiom,
    ! [Xa: real] : member(complex,complex2(Xa,zero_zero(real)),real_Vector_Reals(complex)) ).

% Complex_in_Reals
tff(fact_3916_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( real_V5047593784448816457lgebra(A)
     => ! [A2: A] :
          ( member(A,A2,real_Vector_Reals(A))
         => ( ( A2 != zero_zero(A) )
           => member(A,aa(A,A,inverse_inverse(A),A2),real_Vector_Reals(A)) ) ) ) ).

% nonzero_Reals_inverse
tff(fact_3917_or__not__numerals_I1_J,axiom,
    aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ).

% or_not_numerals(1)
tff(fact_3918_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( bit_se5668285175392031749et_bit(A,N,A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) ) ) ).

% set_bit_eq_or
tff(fact_3919_set__bit__int__def,axiom,
    ! [N: nat,K: int] : ( bit_se5668285175392031749et_bit(int,N,K) = aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),aa(int,int,bit_se4730199178511100633sh_bit(int,N),one_one(int))) ) ).

% set_bit_int_def
tff(fact_3920_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),Xa) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),Xa) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),Y) = zero_zero(A) )
             => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
               => ( Xa = Y ) ) ) ) ) ) ).

% bit.complement_unique
tff(fact_3921_or__not__numerals_I4_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int)) ) ).

% or_not_numerals(4)
tff(fact_3922_or__not__numerals_I2_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N))) ) ).

% or_not_numerals(2)
tff(fact_3923_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),Xa),Y) = zero_zero(A) )
         => ( ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),Xa),Y) = aa(A,A,uminus_uminus(A),one_one(A)) )
           => ( aa(A,A,bit_ri4277139882892585799ns_not(A),Xa) = Y ) ) ) ) ).

% bit.compl_unique
tff(fact_3924_or__not__numerals_I3_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N))) ) ).

% or_not_numerals(3)
tff(fact_3925_or__not__numerals_I7_J,axiom,
    ! [M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),one_one(int))) = aa(int,int,bit_ri4277139882892585799ns_not(int),zero_zero(int)) ) ).

% or_not_numerals(7)
tff(fact_3926_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),bit_se2239418461657761734s_mask(A,N)) ) ) ).

% mask_Suc_exp
tff(fact_3927_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N)))) ) ).

% or_not_numerals(6)
tff(fact_3928_one__or__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),A2) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2))) ) ) ).

% one_or_eq
tff(fact_3929_or__one__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),A2),one_one(A)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa($o,A,zero_neq_one_of_bool(A),aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2))) ) ) ).

% or_one_eq
tff(fact_3930_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( bit_se2239418461657761734s_mask(A,aa(nat,nat,suc,N)) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),one_one(A)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),bit_se2239418461657761734s_mask(A,N))) ) ) ).

% mask_Suc_double
tff(fact_3931_OR__upper,axiom,
    ! [Xa: int,N: nat,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Xa),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Y),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N))
         => aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),Xa),Y)),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),N)) ) ) ) ).

% OR_upper
tff(fact_3932_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),bit0(M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% or_not_numerals(5)
tff(fact_3933_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A2) = aa(A,A,aa(A,fun(A,A),bit_se1065995026697491101ons_or(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)))) ) ) ).

% signed_take_bit_def
tff(fact_3934_Suc__0__or__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),aa(nat,nat,suc,zero_zero(nat))),N) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% Suc_0_or_eq
tff(fact_3935_or__Suc__0__eq,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),N),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa($o,nat,zero_neq_one_of_bool(nat),aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) ) ).

% or_Suc_0_eq
tff(fact_3936_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% or_not_numerals(9)
tff(fact_3937_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,M))),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))))) ) ).

% or_not_numerals(8)
tff(fact_3938_or__nat__rec,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N)
      = aa(nat,nat,
          aa(nat,fun(nat,nat),plus_plus(nat),
            aa($o,nat,zero_neq_one_of_bool(nat),
              ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)
            | ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))),
          aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),divide_divide(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ).

% or_nat_rec
tff(fact_3939_or__int__unfold,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),K),L)
      = $ite(
          ( ( K = aa(int,int,uminus_uminus(int),one_one(int)) )
          | ( L = aa(int,int,uminus_uminus(int),one_one(int)) ) ),
          aa(int,int,uminus_uminus(int),one_one(int)),
          $ite(
            K = zero_zero(int),
            L,
            $ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),ord_max(int),modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),modulo_modulo(int,L,aa(num,int,numeral_numeral(int),bit0(one2))))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2))))))) ) ) ) ).

% or_int_unfold
tff(fact_3940_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea3799213064322606851m_diff(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A)),bit_se5824344971392196577ns_xor(A)) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
tff(fact_3941_or__nat__unfold,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),M),N)
      = $ite(
          M = zero_zero(nat),
          N,
          $ite(N = zero_zero(nat),M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),modulo_modulo(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),modulo_modulo(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),bit_se1065995026697491101ons_or(nat),divide_divide(nat,M,aa(num,nat,numeral_numeral(nat),bit0(one2)))),divide_divide(nat,N,aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ) ) ).

% or_nat_unfold
tff(fact_3942_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] :
          ( aa(A,A,bit_se4197421643247451524op_bit(A,N),A2)
          = $ite(N = zero_zero(nat),A2,aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2))))) ) ) ).

% drop_bit_rec
tff(fact_3943_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = A2 ) ) ) ).

% max.absorb1
tff(fact_3944_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = B2 ) ) ) ).

% max.absorb2
tff(fact_3945_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2) ) ) ) ).

% max.bounded_iff
tff(fact_3946_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,bit_se4197421643247451524op_bit(int,N),K))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K) ) ).

% drop_bit_nonnegative_int_iff
tff(fact_3947_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,bit_se4197421643247451524op_bit(int,N),K)),zero_zero(int))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)) ) ).

% drop_bit_negative_int_iff
tff(fact_3948_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),zero_zero(A)) = zero_zero(A) ) ) ).

% drop_bit_of_0
tff(fact_3949_drop__bit__minus__one,axiom,
    ! [N: nat] : ( aa(int,int,bit_se4197421643247451524op_bit(int,N),aa(int,int,uminus_uminus(int),one_one(int))) = aa(int,int,uminus_uminus(int),one_one(int)) ) ).

% drop_bit_minus_one
tff(fact_3950_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,N),A2)) = aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),A2) ) ) ).

% drop_bit_drop_bit
tff(fact_3951_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [P: $o,Q: $o] :
          ( aa($o,A,zero_neq_one_of_bool(A),
              (P)
            | (Q))
          = aa(A,A,aa(A,fun(A,A),ord_max(A),aa($o,A,zero_neq_one_of_bool(A),P)),aa($o,A,zero_neq_one_of_bool(A),Q)) ) ) ).

% of_bool_or_iff
tff(fact_3952_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),N)) ) ).

% max_Suc_Suc
tff(fact_3953_max__0R,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),zero_zero(nat)) = N ) ).

% max_0R
tff(fact_3954_max__0L,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),N) = N ) ).

% max_0L
tff(fact_3955_max__nat_Oright__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),zero_zero(nat)) = A2 ) ).

% max_nat.right_neutral
tff(fact_3956_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),B2) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.neutr_eq_iff
tff(fact_3957_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),zero_zero(nat)),A2) = A2 ) ).

% max_nat.left_neutral
tff(fact_3958_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),A2),B2) = zero_zero(nat) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% max_nat.eq_neutr_iff
tff(fact_3959_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),V),aa(num,A,numeral_numeral(A),U)) ) ) ).

% max_number_of(1)
tff(fact_3960_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),Xa)),zero_zero(A)) = aa(num,A,numeral_numeral(A),Xa) ) ) ).

% max_0_1(4)
tff(fact_3961_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),aa(num,A,numeral_numeral(A),Xa)) = aa(num,A,numeral_numeral(A),Xa) ) ) ).

% max_0_1(3)
tff(fact_3962_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),zero_zero(A)),one_one(A)) = one_one(A) ) ) ).

% max_0_1(1)
tff(fact_3963_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),zero_zero(A)) = one_one(A) ) ) ).

% max_0_1(2)
tff(fact_3964_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),Xa)),one_one(A)) = aa(num,A,numeral_numeral(A),Xa) ) ) ).

% max_0_1(6)
tff(fact_3965_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_max(A),one_one(A)),aa(num,A,numeral_numeral(A),Xa)) = aa(num,A,numeral_numeral(A),Xa) ) ) ).

% max_0_1(5)
tff(fact_3966_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,B2: $o] :
          ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa($o,A,zero_neq_one_of_bool(A),B2))
          = aa($o,A,zero_neq_one_of_bool(A),
              ( N = zero_zero(nat) )
            & (B2)) ) ) ).

% drop_bit_of_bool
tff(fact_3967_drop__bit__of__Suc__0,axiom,
    ! [N: nat] : ( aa(nat,nat,bit_se4197421643247451524op_bit(nat,N),aa(nat,nat,suc,zero_zero(nat))) = aa($o,nat,zero_neq_one_of_bool(nat),( N = zero_zero(nat) )) ) ).

% drop_bit_of_Suc_0
tff(fact_3968_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))) ) ) ).

% max_number_of(4)
tff(fact_3969_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),V),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))) ) ) ).

% max_number_of(3)
tff(fact_3970_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),U)) ) ) ).

% max_number_of(2)
tff(fact_3971_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))) ) ).

% drop_bit_Suc_minus_bit0
tff(fact_3972_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),bit0(K))) = aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit0
tff(fact_3973_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,K: num] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,N)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,K))) = aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(num,A,numeral_numeral(A),K)) ) ) ).

% drop_bit_Suc_bit1
tff(fact_3974_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),one_one(A)) = aa($o,A,zero_neq_one_of_bool(A),( N = zero_zero(nat) )) ) ) ).

% drop_bit_of_1
tff(fact_3975_max__numeral__Suc,axiom,
    ! [K: num,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),pred_numeral(K)),N)) ) ).

% max_numeral_Suc
tff(fact_3976_max__Suc__numeral,axiom,
    ! [N: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),pred_numeral(K))) ) ).

% max_Suc_numeral
tff(fact_3977_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] : ( aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,suc,N)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,K)))) = aa(int,int,bit_se4197421643247451524op_bit(int,N),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),inc(K)))) ) ).

% drop_bit_Suc_minus_bit1
tff(fact_3978_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,M: nat] : ( aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(nat,A,semiring_1_of_nat(A),M)) = aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4197421643247451524op_bit(nat,N),M)) ) ) ).

% drop_bit_of_nat
tff(fact_3979_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: nat,N: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,bit_se4197421643247451524op_bit(nat,M),N)) = aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% of_nat_drop_bit
tff(fact_3980_of__int__max,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: int,Y: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),ord_max(int),Xa),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(int,A,ring_1_of_int(A),Xa)),aa(int,A,ring_1_of_int(A),Y)) ) ) ).

% of_int_max
tff(fact_3981_of__nat__max,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: nat,Y: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Xa),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,semiring_1_of_nat(A),Xa)),aa(nat,A,semiring_1_of_nat(A),Y)) ) ) ).

% of_nat_max
tff(fact_3982_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),N)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) ) ).

% nat_mult_max_left
tff(fact_3983_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)) ) ).

% nat_mult_max_right
tff(fact_3984_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [Xa: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z)) ) ) ).

% max_diff_distrib_left
tff(fact_3985_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [Xa: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(A,A,aa(A,fun(A,A),ord_max(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Z)) ) ) ).

% max_add_distrib_right
tff(fact_3986_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [Xa: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z)) ) ) ).

% max_add_distrib_left
tff(fact_3987_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q2)) ) ).

% nat_add_max_right
tff(fact_3988_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),N)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),Q2)) ) ).

% nat_add_max_left
tff(fact_3989_max__absorb2,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y) = Y ) ) ) ).

% max_absorb2
tff(fact_3990_max__absorb1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y) = Xa ) ) ) ).

% max_absorb1
tff(fact_3991_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ) ).

% max.coboundedI2
tff(fact_3992_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ) ).

% max.coboundedI1
tff(fact_3993_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = B2 ) ) ) ).

% max.absorb_iff2
tff(fact_3994_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) = A2 ) ) ) ).

% max.absorb_iff1
tff(fact_3995_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Z: A,Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Xa)
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Y) ) ) ) ).

% le_max_iff_disj
tff(fact_3996_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ).

% max.cobounded2
tff(fact_3997_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ).

% max.cobounded1
tff(fact_3998_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( A2 = aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) ) ) ) ).

% max.order_iff
tff(fact_3999_max_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A2) ) ) ) ).

% max.boundedI
tff(fact_4000_max_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),B2),C2)),A2)
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2) ) ) ) ).

% max.boundedE
tff(fact_4001_max_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% max.orderI
tff(fact_4002_max_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( A2 = aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2) ) ) ) ).

% max.orderE
tff(fact_4003_max_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_max(A),C2),D2)),aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)) ) ) ) ).

% max.mono
tff(fact_4004_max__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),A2),B2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2),B2,A2) ) ) ).

% max_def
tff(fact_4005_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),M) = aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),N),M) ) ).

% nat_minus_add_max
tff(fact_4006_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] :
          ( ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2) = A2 )
        <=> ( aa(A,A,bit_se4197421643247451524op_bit(A,N),A2) = zero_zero(A) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
tff(fact_4007_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] : ( aa(int,int,bit_se4197421643247451524op_bit(int,M),aa(int,int,bit_se4730199178511100633sh_bit(int,N),K)) = aa(int,int,bit_se4197421643247451524op_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),aa(int,int,bit_se4730199178511100633sh_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),K)) ) ).

% drop_bit_push_bit_int
tff(fact_4008_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,N),A2)) = aa(A,A,bit_se4197421643247451524op_bit(A,N),aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),A2)) ) ) ).

% take_bit_drop_bit
tff(fact_4009_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)) = aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),aa(A,A,bit_se4197421643247451524op_bit(A,M),A2)) ) ) ).

% drop_bit_take_bit
tff(fact_4010_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,N: nat] : ( divide_divide(A,A2,aa(A,A,bit_se4730199178511100633sh_bit(A,N),one_one(A))) = aa(A,A,bit_se4197421643247451524op_bit(A,N),A2) ) ) ).

% div_push_bit_of_1_eq_drop_bit
tff(fact_4011_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),N)
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(A,A,bit_se4197421643247451524op_bit(A,N),A2)),one_one(A)) = one_one(A) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
tff(fact_4012_bits__ident,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,bit_se4197421643247451524op_bit(A,N),A2))),aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2)) = A2 ) ) ).

% bits_ident
tff(fact_4013_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_se4197421643247451524op_bit(A,aa(nat,nat,suc,N)),A2) = aa(A,A,bit_se4197421643247451524op_bit(A,N),divide_divide(A,A2,aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% drop_bit_Suc
tff(fact_4014_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,M: nat,A2: A] : ( aa(A,A,bit_se4730199178511100633sh_bit(A,N),aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(A,A,bit_se4197421643247451524op_bit(A,N),A2))) = aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),A2),aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),bit_se2239418461657761734s_mask(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))),aa(A,A,bit_ri4277139882892585799ns_not(A),bit_se2239418461657761734s_mask(A,N)))) ) ) ).

% slice_eq_mask
tff(fact_4015_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => boolea2506097494486148201lgebra(A,bit_se5824344872417868541ns_and(A),bit_se1065995026697491101ons_or(A),bit_ri4277139882892585799ns_not(A),zero_zero(A),aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% bit.abstract_boolean_algebra_axioms
tff(fact_4016_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,aa(num,num,bit1,L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(L))) ) ) ).

% sub_num_simps(3)
tff(fact_4017_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),neg_numeral_sub(A,M,one2))),one_one(A)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M)) ) ) ).

% minus_sub_one_diff_one
tff(fact_4018_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,N,one2) ) ) ).

% diff_numeral_special(7)
tff(fact_4019_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),Q2),zero_zero(extended_enat)) = Q2 ) ).

% max_enat_simps(2)
tff(fact_4020_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_max(extended_enat),zero_zero(extended_enat)),Q2) = Q2 ) ).

% max_enat_simps(3)
tff(fact_4021_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ( neg_numeral_sub(A,one2,one2) = zero_zero(A) ) ) ).

% sub_num_simps(1)
tff(fact_4022_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,M,N) ) ) ).

% diff_numeral_simps(1)
tff(fact_4023_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,bit0(K),bit0(L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(6)
tff(fact_4024_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),aa(num,num,bit1,L)) = neg_numeral_dbl(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(9)
tff(fact_4025_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,N,M) ) ) ).

% add_neg_numeral_simps(2)
tff(fact_4026_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,M,N) ) ) ).

% add_neg_numeral_simps(1)
tff(fact_4027_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),V)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W))),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,V,W)),Y) ) ) ).

% semiring_norm(166)
tff(fact_4028_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [V: num,W: num,Y: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),W)),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),neg_numeral_sub(A,W,V)),Y) ) ) ).

% semiring_norm(167)
tff(fact_4029_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = neg_numeral_sub(A,N,M) ) ) ).

% diff_numeral_simps(4)
tff(fact_4030_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,bit0(K),aa(num,num,bit1,L)) = neg_numeral_dbl_dec(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(7)
tff(fact_4031_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),bit0(L)) = neg_numeral_dbl_inc(A,neg_numeral_sub(A,K,L)) ) ) ).

% sub_num_simps(8)
tff(fact_4032_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,one2,N) ) ) ).

% diff_numeral_special(1)
tff(fact_4033_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),M)),one_one(A)) = neg_numeral_sub(A,M,one2) ) ) ).

% diff_numeral_special(2)
tff(fact_4034_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,aa(num,num,bit1,K),one2) = aa(num,A,numeral_numeral(A),bit0(K)) ) ) ).

% sub_num_simps(5)
tff(fact_4035_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))) = neg_numeral_sub(A,one2,M) ) ) ).

% add_neg_numeral_special(1)
tff(fact_4036_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),one_one(A)) = neg_numeral_sub(A,one2,M) ) ) ).

% add_neg_numeral_special(2)
tff(fact_4037_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(num,A,numeral_numeral(A),M)),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,M,one2) ) ) ).

% add_neg_numeral_special(3)
tff(fact_4038_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,uminus_uminus(A),one_one(A))),aa(num,A,numeral_numeral(A),N)) = neg_numeral_sub(A,N,one2) ) ) ).

% add_neg_numeral_special(4)
tff(fact_4039_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [M: num] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),M))),aa(A,A,uminus_uminus(A),one_one(A))) = neg_numeral_sub(A,one2,M) ) ) ).

% diff_numeral_special(8)
tff(fact_4040_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num,L: num] : ( neg_numeral_sub(A,K,L) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),L)) ) ) ).

% neg_numeral_class.sub_def
tff(fact_4041_sub__non__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),neg_numeral_sub(A,N,M))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),N) ) ) ).

% sub_non_negative
tff(fact_4042_sub__non__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),neg_numeral_sub(A,N,M)),zero_zero(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),N),M) ) ) ).

% sub_non_positive
tff(fact_4043_sub__positive,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),neg_numeral_sub(A,N,M))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N) ) ) ).

% sub_positive
tff(fact_4044_sub__negative,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: num,M: num] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),neg_numeral_sub(A,N,M)),zero_zero(A))
        <=> aa(num,$o,aa(num,fun(num,$o),ord_less(num),N),M) ) ) ).

% sub_negative
tff(fact_4045_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( neg_numeral_sub(A,inc(N),one2) = aa(num,A,numeral_numeral(A),N) ) ) ).

% sub_inc_One_eq
tff(fact_4046_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [L: num] : ( neg_numeral_sub(A,one2,bit0(L)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bitM(L))) ) ) ).

% sub_num_simps(2)
tff(fact_4047_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( num_of_nat(aa(nat,nat,suc,N))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N),inc(num_of_nat(N)),one2) ) ).

% num_of_nat.simps(2)
tff(fact_4048_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa)) = one_one(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Xa),one2))) ) ) ).

% eq_numeral_iff_iszero(7)
tff(fact_4049_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),Y))) ) ) ).

% eq_numeral_iff_iszero(8)
tff(fact_4050_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] : ( num_of_nat(aa(num,nat,numeral_numeral(nat),Q2)) = Q2 ) ).

% num_of_nat_numeral_eq
tff(fact_4051_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [W: num] :
          ( ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),W)))
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ) ).

% iszero_neg_numeral
tff(fact_4052_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_dbl_dec(A,aa(num,A,numeral_numeral(A),K)) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% dbl_dec_simps(5)
tff(fact_4053_pred__numeral__simps_I2_J,axiom,
    ! [K: num] : ( pred_numeral(bit0(K)) = aa(num,nat,numeral_numeral(nat),bitM(K)) ) ).

% pred_numeral_simps(2)
tff(fact_4054_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [K: num] : ( neg_numeral_sub(A,bit0(K),one2) = aa(num,A,numeral_numeral(A),bitM(K)) ) ) ).

% sub_num_simps(4)
tff(fact_4055_semiring__norm_I26_J,axiom,
    bitM(one2) = one2 ).

% semiring_norm(26)
tff(fact_4056_iszero__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Z: A] :
          ( ring_1_iszero(A,Z)
        <=> ( Z = zero_zero(A) ) ) ) ).

% iszero_def
tff(fact_4057_iszero__0,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ring_1_iszero(A,zero_zero(A)) ) ).

% iszero_0
tff(fact_4058_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ring_char_0(A)
     => ! [W: num] : ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),W)) ) ).

% not_iszero_numeral
tff(fact_4059_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,one_one(A)) ) ).

% not_iszero_1
tff(fact_4060_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: A,Y: A] :
          ( ( Xa = Y )
        <=> ring_1_iszero(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) ) ) ).

% eq_iff_iszero_diff
tff(fact_4061_semiring__norm_I27_J,axiom,
    ! [N: num] : ( bitM(bit0(N)) = aa(num,num,bit1,bitM(N)) ) ).

% semiring_norm(27)
tff(fact_4062_semiring__norm_I28_J,axiom,
    ! [N: num] : ( bitM(aa(num,num,bit1,N)) = aa(num,num,bit1,bit0(N)) ) ).

% semiring_norm(28)
tff(fact_4063_inc__BitM__eq,axiom,
    ! [N: num] : ( inc(bitM(N)) = bit0(N) ) ).

% inc_BitM_eq
tff(fact_4064_BitM__inc__eq,axiom,
    ! [N: num] : ( bitM(inc(N)) = aa(num,num,bit1,N) ) ).

% BitM_inc_eq
tff(fact_4065_num__of__nat_Osimps_I1_J,axiom,
    num_of_nat(zero_zero(nat)) = one2 ).

% num_of_nat.simps(1)
tff(fact_4066_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( zero_zero(A) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y)) ) ) ).

% eq_numeral_iff_iszero(10)
tff(fact_4067_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num] :
          ( ( aa(num,A,numeral_numeral(A),Xa) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Xa)) ) ) ).

% eq_numeral_iff_iszero(9)
tff(fact_4068_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(num,A,numeral_numeral(A),one2)) ) ).

% not_iszero_Numeral1
tff(fact_4069_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),one_one(A))) ) ).

% not_iszero_neg_1
tff(fact_4070_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num,Y: num] :
          ( ( aa(num,A,numeral_numeral(A),Xa) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,Xa,Y)) ) ) ).

% eq_numeral_iff_iszero(1)
tff(fact_4071_eval__nat__numeral_I2_J,axiom,
    ! [N: num] : ( aa(num,nat,numeral_numeral(nat),bit0(N)) = aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),bitM(N))) ) ).

% eval_nat_numeral(2)
tff(fact_4072_one__plus__BitM,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),one2),bitM(N)) = bit0(N) ) ).

% one_plus_BitM
tff(fact_4073_BitM__plus__one,axiom,
    ! [N: num] : ( aa(num,num,aa(num,fun(num,num),plus_plus(num),bitM(N)),one2) = bit0(N) ) ).

% BitM_plus_one
tff(fact_4074_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(num,nat,numeral_numeral(nat),num_of_nat(N)) = N ) ) ).

% numeral_num_of_nat
tff(fact_4075_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa)) = zero_zero(A) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Xa)) ) ) ).

% eq_numeral_iff_iszero(11)
tff(fact_4076_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( zero_zero(A) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),Y)) ) ) ).

% eq_numeral_iff_iszero(12)
tff(fact_4077_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ~ ring_1_iszero(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),one2))) ) ).

% not_iszero_neg_Numeral1
tff(fact_4078_num__of__nat__One,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),one_one(nat))
     => ( num_of_nat(N) = one2 ) ) ).

% num_of_nat_One
tff(fact_4079_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num,Y: num] :
          ( ( aa(num,A,numeral_numeral(A),Xa) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Xa),Y))) ) ) ).

% eq_numeral_iff_iszero(2)
tff(fact_4080_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num,Y: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa)) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,aa(num,A,numeral_numeral(A),aa(num,num,aa(num,fun(num,num),plus_plus(num),Xa),Y))) ) ) ).

% eq_numeral_iff_iszero(3)
tff(fact_4081_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num,Y: num] :
          ( ( aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Xa)) = aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),Y)) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,Y,Xa)) ) ) ).

% eq_numeral_iff_iszero(4)
tff(fact_4082_numeral__BitM,axiom,
    ! [A: $tType] :
      ( neg_numeral(A)
     => ! [N: num] : ( aa(num,A,numeral_numeral(A),bitM(N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(num,A,numeral_numeral(A),bit0(N))),one_one(A)) ) ) ).

% numeral_BitM
tff(fact_4083_sub__BitM__One__eq,axiom,
    ! [N: num] : ( neg_numeral_sub(int,bitM(N),one2) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),neg_numeral_sub(int,N,one2)) ) ).

% sub_BitM_One_eq
tff(fact_4084_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( aa(num,A,numeral_numeral(A),num_of_nat(N))
          = $ite(N = zero_zero(nat),one_one(A),aa(nat,A,semiring_1_of_nat(A),N)) ) ) ).

% numeral_num_of_nat_unfold
tff(fact_4085_num__of__nat__double,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),N)) = bit0(num_of_nat(N)) ) ) ).

% num_of_nat_double
tff(fact_4086_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ( num_of_nat(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(num,num,aa(num,fun(num,num),plus_plus(num),num_of_nat(M)),num_of_nat(N)) ) ) ) ).

% num_of_nat_plus_distrib
tff(fact_4087_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Y: num] :
          ( ( one_one(A) = aa(num,A,numeral_numeral(A),Y) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,one2,Y)) ) ) ).

% eq_numeral_iff_iszero(6)
tff(fact_4088_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: num] :
          ( ( aa(num,A,numeral_numeral(A),Xa) = one_one(A) )
        <=> ring_1_iszero(A,neg_numeral_sub(A,Xa,one2)) ) ) ).

% eq_numeral_iff_iszero(5)
tff(fact_4089_or__minus__numerals_I1_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(N)))) ) ).

% or_minus_numerals(1)
tff(fact_4090_or__minus__numerals_I5_J,axiom,
    ! [N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se1065995026697491101ons_or(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))),one_one(int)) = aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit_or_not_num_neg(one2,bitM(N)))) ) ).

% or_minus_numerals(5)
tff(fact_4091_pow_Osimps_I3_J,axiom,
    ! [Xa: num,Y: num] : ( pow(Xa,aa(num,num,bit1,Y)) = aa(num,num,aa(num,fun(num,num),times_times(num),sqr(pow(Xa,Y))),Xa) ) ).

% pow.simps(3)
tff(fact_4092_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat,M: nat] : ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N))),one_one(A)) ) ) ).

% mask_mod_exp
tff(fact_4093_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2) ) ) ) ).

% min.bounded_iff
tff(fact_4094_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = B2 ) ) ) ).

% min.absorb2
tff(fact_4095_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = A2 ) ) ) ).

% min.absorb1
tff(fact_4096_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,M)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)) ) ).

% min_Suc_Suc
tff(fact_4097_min__0L,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),zero_zero(nat)),N) = zero_zero(nat) ) ).

% min_0L
tff(fact_4098_min__0R,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),N),zero_zero(nat)) = zero_zero(nat) ) ).

% min_0R
tff(fact_4099_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)),aa(num,A,numeral_numeral(A),U),aa(num,A,numeral_numeral(A),V)) ) ) ).

% min_number_of(1)
tff(fact_4100_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),aa(num,A,numeral_numeral(A),Xa)) = zero_zero(A) ) ) ).

% min_0_1(3)
tff(fact_4101_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),Xa)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(4)
tff(fact_4102_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),zero_zero(A)) = zero_zero(A) ) ) ).

% min_0_1(2)
tff(fact_4103_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ( aa(A,A,aa(A,fun(A,A),ord_min(A),zero_zero(A)),one_one(A)) = zero_zero(A) ) ) ).

% min_0_1(1)
tff(fact_4104_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),one_one(A)),aa(num,A,numeral_numeral(A),Xa)) = one_one(A) ) ) ).

% min_0_1(5)
tff(fact_4105_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: num] : ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),Xa)),one_one(A)) = one_one(A) ) ) ).

% min_0_1(6)
tff(fact_4106_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(num,A,numeral_numeral(A),U),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% min_number_of(2)
tff(fact_4107_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(num,A,numeral_numeral(A),V)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)),aa(num,A,numeral_numeral(A),V)) ) ) ).

% min_number_of(3)
tff(fact_4108_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( uminus(A)
        & numeral(A)
        & ord(A) )
     => ! [U: num,V: num] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V)))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),U)),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),V))) ) ) ).

% min_number_of(4)
tff(fact_4109_min__Suc__numeral,axiom,
    ! [N: nat,K: num] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),K)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),N),pred_numeral(K))) ) ).

% min_Suc_numeral
tff(fact_4110_min__numeral__Suc,axiom,
    ! [K: num,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(num,nat,numeral_numeral(nat),K)),aa(nat,nat,suc,N)) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),pred_numeral(K)),N)) ) ).

% min_numeral_Suc
tff(fact_4111_min__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [A2: A,B2: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2),A2,B2) ) ) ).

% min_def
tff(fact_4112_min_Omono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),aa(A,A,aa(A,fun(A,A),ord_min(A),C2),D2)) ) ) ) ).

% min.mono
tff(fact_4113_min_OorderE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( A2 = aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) ) ) ) ).

% min.orderE
tff(fact_4114_min_OorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% min.orderI
tff(fact_4115_min_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2))
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2) ) ) ) ).

% min.boundedE
tff(fact_4116_min_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),ord_min(A),B2),C2)) ) ) ) ).

% min.boundedI
tff(fact_4117_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( A2 = aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) ) ) ) ).

% min.order_iff
tff(fact_4118_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),A2) ) ).

% min.cobounded1
tff(fact_4119_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),B2) ) ).

% min.cobounded2
tff(fact_4120_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = A2 ) ) ) ).

% min.absorb_iff1
tff(fact_4121_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2) = B2 ) ) ) ).

% min.absorb_iff2
tff(fact_4122_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),C2) ) ) ).

% min.coboundedI1
tff(fact_4123_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),A2),B2)),C2) ) ) ).

% min.coboundedI2
tff(fact_4124_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y)),Z)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z)
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ) ).

% min_le_iff_disj
tff(fact_4125_min__absorb1,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y) = Xa ) ) ) ).

% min_absorb1
tff(fact_4126_min__absorb2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y) = Y ) ) ) ).

% min_absorb2
tff(fact_4127_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [Xa: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Y),Z)) ) ) ).

% min_add_distrib_left
tff(fact_4128_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ordere2412721322843649153imp_le(A)
     => ! [Xa: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(A,A,aa(A,fun(A,A),ord_min(A),Y),Z)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Z)) ) ) ).

% min_add_distrib_right
tff(fact_4129_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [Xa: A,Y: A,Z: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y)),Z) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Z)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Y),Z)) ) ) ).

% min_diff_distrib_left
tff(fact_4130_min__diff,axiom,
    ! [M: nat,I: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),I)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),I)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)),I) ) ).

% min_diff
tff(fact_4131_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),N),Q2)) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)) ) ).

% nat_mult_min_right
tff(fact_4132_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N)),Q2) = aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),Q2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),Q2)) ) ).

% nat_mult_min_left
tff(fact_4133_of__nat__min,axiom,
    ! [A: $tType] :
      ( linord181362715937106298miring(A)
     => ! [Xa: nat,Y: nat] : ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Xa),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(nat,A,semiring_1_of_nat(A),Xa)),aa(nat,A,semiring_1_of_nat(A),Y)) ) ) ).

% of_nat_min
tff(fact_4134_of__int__min,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: int,Y: int] : ( aa(int,A,ring_1_of_int(A),aa(int,int,aa(int,fun(int,int),ord_min(int),Xa),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(int,A,ring_1_of_int(A),Xa)),aa(int,A,ring_1_of_int(A),Y)) ) ) ).

% of_int_min
tff(fact_4135_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [Xa: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,uminus_uminus(A),Xa)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_min_eq_max
tff(fact_4136_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( linord5086331880401160121up_add(A)
     => ! [Xa: A,Y: A] : ( aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,uminus_uminus(A),Xa)),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% minus_max_eq_min
tff(fact_4137_sqr_Osimps_I2_J,axiom,
    ! [N: num] : ( sqr(bit0(N)) = bit0(bit0(sqr(N))) ) ).

% sqr.simps(2)
tff(fact_4138_sqr_Osimps_I1_J,axiom,
    sqr(one2) = one2 ).

% sqr.simps(1)
tff(fact_4139_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L: int,R: int] : ( bit_concat_bit(M,bit_concat_bit(N,K,L),R) = bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N),K,bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),L,R)) ) ).

% concat_bit_assoc_sym
tff(fact_4140_sqr__conv__mult,axiom,
    ! [Xa: num] : ( sqr(Xa) = aa(num,num,aa(num,fun(num,num),times_times(num),Xa),Xa) ) ).

% sqr_conv_mult
tff(fact_4141_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L: int] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,M),bit_concat_bit(N,K,L)) = bit_concat_bit(aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),N),K,aa(int,int,bit_se2584673776208193580ke_bit(int,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),L)) ) ).

% take_bit_concat_bit_eq
tff(fact_4142_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A,P2: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y)),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P2)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P2))) ) ) ).

% min_mult_distrib_right
tff(fact_4143_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Xa: A,Y: A,P2: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y)),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P2)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),P2)),aa(A,A,aa(A,fun(A,A),times_times(A),Y),P2))) ) ) ).

% max_mult_distrib_right
tff(fact_4144_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,Xa: A,Y: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y)),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y))) ) ) ).

% min_mult_distrib_left
tff(fact_4145_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [P2: A,Xa: A,Y: A] :
          ( aa(A,A,aa(A,fun(A,A),times_times(A),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y)),aa(A,A,aa(A,fun(A,A),ord_min(A),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),P2),Y))) ) ) ).

% max_mult_distrib_left
tff(fact_4146_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A,P2: A] :
          ( divide_divide(A,aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),Y),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_min(A),divide_divide(A,Xa,P2)),divide_divide(A,Y,P2)),aa(A,A,aa(A,fun(A,A),ord_max(A),divide_divide(A,Xa,P2)),divide_divide(A,Y,P2))) ) ) ).

% min_divide_distrib_right
tff(fact_4147_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A,P2: A] :
          ( divide_divide(A,aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),Y),P2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),P2),aa(A,A,aa(A,fun(A,A),ord_max(A),divide_divide(A,Xa,P2)),divide_divide(A,Y,P2)),aa(A,A,aa(A,fun(A,A),ord_min(A),divide_divide(A,Xa,P2)),divide_divide(A,Y,P2))) ) ) ).

% max_divide_distrib_right
tff(fact_4148_numeral__sqr,axiom,
    ! [A: $tType] :
      ( semiring_numeral(A)
     => ! [K: num] : ( aa(num,A,numeral_numeral(A),sqr(K)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),K)),aa(num,A,numeral_numeral(A),K)) ) ) ).

% numeral_sqr
tff(fact_4149_pow_Osimps_I2_J,axiom,
    ! [Xa: num,Y: num] : ( pow(Xa,bit0(Y)) = sqr(pow(Xa,Y)) ) ).

% pow.simps(2)
tff(fact_4150_sqr_Osimps_I3_J,axiom,
    ! [N: num] : ( sqr(aa(num,num,bit1,N)) = aa(num,num,bit1,bit0(aa(num,num,aa(num,fun(num,num),plus_plus(num),sqr(N)),N))) ) ).

% sqr.simps(3)
tff(fact_4151_and__int_Oelims,axiom,
    ! [Xa: int,Xaa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Xaa) = Y )
     => ( Y
        = $ite(
            ( member(int,Xa,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & member(int,Xaa,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xaa))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xaa))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,Xa,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,Xaa,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ).

% and_int.elims
tff(fact_4152_and__int_Osimps,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
      = $ite(
          ( member(int,K,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
          & member(int,L,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
          aa(int,int,uminus_uminus(int),
            aa($o,int,zero_neq_one_of_bool(int),
              ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)
            & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))),
          aa(int,int,
            aa(int,fun(int,int),plus_plus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))),
            aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ).

% and_int.simps
tff(fact_4153_set__decode__plus__power__2,axiom,
    ! [N: nat,Z: nat] :
      ( ~ member(nat,N,nat_set_decode(Z))
     => ( nat_set_decode(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),Z)) = aa(set(nat),set(nat),insert(nat,N),nat_set_decode(Z)) ) ) ).

% set_decode_plus_power_2
tff(fact_4154_rcis__inverse,axiom,
    ! [R: real,A2: real] : ( aa(complex,complex,inverse_inverse(complex),rcis(R,A2)) = rcis(divide_divide(real,one_one(real),R),aa(real,real,uminus_uminus(real),A2)) ) ).

% rcis_inverse
tff(fact_4155_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),Q2),zero_zero(extended_enat)) = zero_zero(extended_enat) ) ).

% min_enat_simps(2)
tff(fact_4156_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),ord_min(extended_enat),zero_zero(extended_enat)),Q2) = zero_zero(extended_enat) ) ).

% min_enat_simps(3)
tff(fact_4157_subset__empty,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),bot_bot(set(A)))
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% subset_empty
tff(fact_4158_empty__subsetI,axiom,
    ! [A: $tType,A3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),bot_bot(set(A))),A3) ).

% empty_subsetI
tff(fact_4159_insert__subset,axiom,
    ! [A: $tType,Xa: A,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),B3)
    <=> ( member(A,Xa,B3)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ) ).

% insert_subset
tff(fact_4160_Diff__empty,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),bot_bot(set(A))) = A3 ) ).

% Diff_empty
tff(fact_4161_empty__Diff,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),bot_bot(set(A))),A3) = bot_bot(set(A)) ) ).

% empty_Diff
tff(fact_4162_Diff__cancel,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),A3) = bot_bot(set(A)) ) ).

% Diff_cancel
tff(fact_4163_insert__Diff1,axiom,
    ! [A: $tType,Xa: A,B3: set(A),A3: set(A)] :
      ( member(A,Xa,B3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) ) ) ).

% insert_Diff1
tff(fact_4164_Diff__insert0,axiom,
    ! [A: $tType,Xa: A,A3: set(A),B3: set(A)] :
      ( ~ member(A,Xa,A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) ) ) ).

% Diff_insert0
tff(fact_4165_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( ( set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% atLeastatMost_empty_iff
tff(fact_4166_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or1337092689740270186AtMost(A,A2,B2) )
        <=> ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% atLeastatMost_empty_iff2
tff(fact_4167_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A3: set(A)] :
      ( ( aa(set(A),set(A),insert(A,B2),bot_bot(set(A))) = aa(set(A),set(A),insert(A,A2),A3) )
    <=> ( ( A2 = B2 )
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))) ) ) ).

% singleton_insert_inj_eq
tff(fact_4168_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A3: set(A),B2: A] :
      ( ( aa(set(A),set(A),insert(A,A2),A3) = aa(set(A),set(A),insert(A,B2),bot_bot(set(A))) )
    <=> ( ( A2 = B2 )
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))) ) ) ).

% singleton_insert_inj_eq'
tff(fact_4169_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = bot_bot(set(A)) )
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% Diff_eq_empty_iff
tff(fact_4170_insert__Diff__single,axiom,
    ! [A: $tType,A2: A,A3: set(A)] : ( aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) = aa(set(A),set(A),insert(A,A2),A3) ) ).

% insert_Diff_single
tff(fact_4171_rcis__zero__arg,axiom,
    ! [R: real] : ( rcis(R,zero_zero(real)) = real_Vector_of_real(complex,R) ) ).

% rcis_zero_arg
tff(fact_4172_rcis__zero__mod,axiom,
    ! [A2: real] : ( rcis(zero_zero(real),A2) = zero_zero(complex) ) ).

% rcis_zero_mod
tff(fact_4173_rcis__eq__zero__iff,axiom,
    ! [R: real,A2: real] :
      ( ( rcis(R,A2) = zero_zero(complex) )
    <=> ( R = zero_zero(real) ) ) ).

% rcis_eq_zero_iff
tff(fact_4174_subset__Compl__singleton,axiom,
    ! [A: $tType,A3: set(A),B2: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))))
    <=> ~ member(A,B2,A3) ) ).

% subset_Compl_singleton
tff(fact_4175_Re__rcis,axiom,
    ! [R: real,A2: real] : ( re(rcis(R,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(real,real,cos(real),A2)) ) ).

% Re_rcis
tff(fact_4176_Im__rcis,axiom,
    ! [R: real,A2: real] : ( im(rcis(R,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(real,real,sin(real),A2)) ) ).

% Im_rcis
tff(fact_4177_Diff__insert,axiom,
    ! [A: $tType,A3: set(A),A2: A,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))) ) ).

% Diff_insert
tff(fact_4178_insert__Diff,axiom,
    ! [A: $tType,A2: A,A3: set(A)] :
      ( member(A,A2,A3)
     => ( aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) = A3 ) ) ).

% insert_Diff
tff(fact_4179_Diff__insert2,axiom,
    ! [A: $tType,A3: set(A),A2: A,B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))),B3) ) ).

% Diff_insert2
tff(fact_4180_Diff__insert__absorb,axiom,
    ! [A: $tType,Xa: A,A3: set(A)] :
      ( ~ member(A,Xa,A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = A3 ) ) ).

% Diff_insert_absorb
tff(fact_4181_Compl__insert,axiom,
    ! [A: $tType,Xa: A,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),insert(A,Xa),A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) ) ).

% Compl_insert
tff(fact_4182_insert__Diff__if,axiom,
    ! [A: $tType,Xa: A,A3: set(A),B3: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),B3)
      = $ite(member(A,Xa,B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3),aa(set(A),set(A),insert(A,Xa),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ).

% insert_Diff_if
tff(fact_4183_insert__mono,axiom,
    ! [A: $tType,C5: set(A),D3: set(A),A2: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),D3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,A2),C5)),aa(set(A),set(A),insert(A,A2),D3)) ) ).

% insert_mono
tff(fact_4184_subset__insert,axiom,
    ! [A: $tType,Xa: A,A3: set(A),B3: set(A)] :
      ( ~ member(A,Xa,A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,Xa),B3))
      <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ) ).

% subset_insert
tff(fact_4185_subset__insertI,axiom,
    ! [A: $tType,B3: set(A),A2: A] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(A),set(A),insert(A,A2),B3)) ).

% subset_insertI
tff(fact_4186_subset__insertI2,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),B2: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B2),B3)) ) ).

% subset_insertI2
tff(fact_4187_subset__singletonD,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))
     => ( ( A3 = bot_bot(set(A)) )
        | ( A3 = aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))) ) ) ) ).

% subset_singletonD
tff(fact_4188_subset__singleton__iff,axiom,
    ! [A: $tType,X6: set(A),A2: A] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X6),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))
    <=> ( ( X6 = bot_bot(set(A)) )
        | ( X6 = aa(set(A),set(A),insert(A,A2),bot_bot(set(A))) ) ) ) ).

% subset_singleton_iff
tff(fact_4189_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),bot_bot(A))
         => ( A2 = bot_bot(A) ) ) ) ).

% bot.extremum_uniqueI
tff(fact_4190_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),bot_bot(A))
        <=> ( A2 = bot_bot(A) ) ) ) ).

% bot.extremum_unique
tff(fact_4191_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),bot_bot(A)),A2) ) ).

% bot.extremum
tff(fact_4192_Diff__single__insert,axiom,
    ! [A: $tType,A3: set(A),Xa: A,B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))),B3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,Xa),B3)) ) ).

% Diff_single_insert
tff(fact_4193_subset__insert__iff,axiom,
    ! [A: $tType,A3: set(A),Xa: A,B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,Xa),B3))
    <=> $ite(member(A,Xa,A3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))),B3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)) ) ).

% subset_insert_iff
tff(fact_4194_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set(A),Xa: A,B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),aa(set(A),set(A),insert(A,Xa),B3))
    <=> $ite(
          member(A,Xa,B3),
          aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3),
          $ite(member(A,Xa,A3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))),B3),aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)) ) ) ).

% psubset_insert_iff
tff(fact_4195_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y) = bot_bot(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ).

% diff_shunt_var
tff(fact_4196_subset__Diff__insert,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),Xa: A,C5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),aa(set(A),set(A),insert(A,Xa),C5)))
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C5))
        & ~ member(A,Xa,A3) ) ) ).

% subset_Diff_insert
tff(fact_4197_simp__from__to,axiom,
    ! [I: int,J: int] :
      ( set_or1337092689740270186AtMost(int,I,J)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J),I),bot_bot(set(int)),aa(set(int),set(int),insert(int,I),set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J))) ) ).

% simp_from_to
tff(fact_4198_subset__Compl__self__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),A3))
    <=> ( A3 = bot_bot(set(A)) ) ) ).

% subset_Compl_self_eq
tff(fact_4199_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,sinh(A),Xa) = zero_zero(A) )
        <=> member(A,aa(A,A,exp(A),Xa),aa(set(A),set(A),insert(A,one_one(A)),aa(set(A),set(A),insert(A,aa(A,A,uminus_uminus(A),one_one(A))),bot_bot(set(A))))) ) ) ).

% sinh_zero_iff
tff(fact_4200_atLeast0__atMost__Suc,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,N)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ).

% atLeast0_atMost_Suc
tff(fact_4201_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( set_or1337092689740270186AtMost(nat,M,N) = aa(set(nat),set(nat),insert(nat,M),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N)) ) ) ).

% Icc_eq_insert_lb_nat
tff(fact_4202_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N))
     => ( set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,N)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% atLeastAtMostSuc_conv
tff(fact_4203_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(set(nat),set(nat),insert(nat,M),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N)) = set_or1337092689740270186AtMost(nat,M,N) ) ) ).

% atLeastAtMost_insertL
tff(fact_4204_cis__rcis__eq,axiom,
    ! [A2: real] : ( cis(A2) = rcis(one_one(real),A2) ) ).

% cis_rcis_eq
tff(fact_4205_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),N))
     => ( set_or1337092689740270186AtMost(int,M,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),N)) = aa(set(int),set(int),insert(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),N)),set_or1337092689740270186AtMost(int,M,N)) ) ) ).

% atLeastAtMostPlus1_int_conv
tff(fact_4206_rcis__mult,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] : ( aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),rcis(R1,A2)),rcis(R22,B2)) = rcis(aa(real,real,aa(real,fun(real,real),times_times(real),R1),R22),aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)) ) ).

% rcis_mult
tff(fact_4207_rcis__divide,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] : ( divide_divide(complex,rcis(R1,A2),rcis(R22,B2)) = rcis(divide_divide(real,R1,R22),aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)) ) ).

% rcis_divide
tff(fact_4208_rcis__def,axiom,
    ! [R: real,A2: real] : ( rcis(R,A2) = aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,R)),cis(A2)) ) ).

% rcis_def
tff(fact_4209_DeMoivre2,axiom,
    ! [R: real,A2: real,N: nat] : ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),rcis(R,A2)),N) = rcis(aa(nat,real,aa(real,fun(nat,real),power_power(real),R),N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),A2)) ) ).

% DeMoivre2
tff(fact_4210_insert__subsetI,axiom,
    ! [A: $tType,Xa: A,A3: set(A),X6: set(A)] :
      ( member(A,Xa,A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X6),A3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),X6)),A3) ) ) ).

% insert_subsetI
tff(fact_4211_subset__emptyI,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ! [X: A] : ~ member(A,X,A3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),bot_bot(set(A))) ) ).

% subset_emptyI
tff(fact_4212_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,K),L))
     => ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),K),L)
        = $ite(
            ( member(int,K,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
            & member(int,L,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
            aa(int,int,uminus_uminus(int),
              aa($o,int,zero_neq_one_of_bool(int),
                ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)
              & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))),
            aa(int,int,
              aa(int,fun(int,int),plus_plus(int),
                aa($o,int,zero_neq_one_of_bool(int),
                  ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),K)
                & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),L))),
              aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) ) ) ).

% and_int.psimps
tff(fact_4213_and__int_Opelims,axiom,
    ! [Xa: int,Xaa: int,Y: int] :
      ( ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),Xa),Xaa) = Y )
     => ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,Xa),Xaa))
       => ~ ( ( Y
              = $ite(
                  ( member(int,Xa,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                  & member(int,Xaa,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) ),
                  aa(int,int,uminus_uminus(int),
                    aa($o,int,zero_neq_one_of_bool(int),
                      ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa)
                    & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xaa))),
                  aa(int,int,
                    aa(int,fun(int,int),plus_plus(int),
                      aa($o,int,zero_neq_one_of_bool(int),
                        ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xa)
                      & ~ aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),aa(num,int,numeral_numeral(int),bit0(one2))),Xaa))),
                    aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),divide_divide(int,Xa,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,Xaa,aa(num,int,numeral_numeral(int),bit0(one2)))))) ) )
           => ~ aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,Xa),Xaa)) ) ) ) ).

% and_int.pelims
tff(fact_4214_bit__0__eq,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ( bit_se5641148757651400278ts_bit(A,zero_zero(A)) = bot_bot(fun(nat,$o)) ) ) ).

% bit_0_eq
tff(fact_4215_set__decode__zero,axiom,
    nat_set_decode(zero_zero(nat)) = bot_bot(set(nat)) ).

% set_decode_zero
tff(fact_4216_bot__nat__def,axiom,
    bot_bot(nat) = zero_zero(nat) ).

% bot_nat_def
tff(fact_4217_bot__enat__def,axiom,
    bot_bot(extended_enat) = zero_zero(extended_enat) ).

% bot_enat_def
tff(fact_4218_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),bot_bot(fun(A,fun(A,$o)))) = bot_bot(fun(A,fun(A,$o))) ) ) ).

% relpowp_bot
tff(fact_4219_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,$o))] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,A0),A1))
     => ( ! [K3: int,L2: int] :
            ( aa(product_prod(int,int),$o,accp(product_prod(int,int),bit_and_int_rel),aa(int,product_prod(int,int),product_Pair(int,int,K3),L2))
           => ( ( ~ ( member(int,K3,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int)))))
                    & member(int,L2,aa(set(int),set(int),insert(int,zero_zero(int)),aa(set(int),set(int),insert(int,aa(int,int,uminus_uminus(int),one_one(int))),bot_bot(set(int))))) )
               => aa(int,$o,aa(int,fun(int,$o),P,divide_divide(int,K3,aa(num,int,numeral_numeral(int),bit0(one2)))),divide_divide(int,L2,aa(num,int,numeral_numeral(int),bit0(one2)))) )
             => aa(int,$o,aa(int,fun(int,$o),P,K3),L2) ) )
       => aa(int,$o,aa(int,fun(int,$o),P,A0),A1) ) ) ).

% and_int.pinduct
tff(fact_4220_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Q2: A,R: A] :
          ( unique1321980374590559556d_step(A,L,aa(A,product_prod(A,A),product_Pair(A,A,Q2),R))
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),L)),R),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Q2)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),R),aa(num,A,numeral_numeral(A),L))),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Q2)),R)) ) ) ).

% divmod_step_eq
tff(fact_4221_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R: int] : ( adjust_div(aa(int,product_prod(int,int),product_Pair(int,int,Q2),R)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Q2),aa($o,int,zero_neq_one_of_bool(int),( R != zero_zero(int) ))) ) ).

% Divides.adjust_div_eq
tff(fact_4222_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),zero_zero(int))
     => ( eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),A2),one_one(int)),B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2),aa(int,product_prod(int,int),product_Pair(int,int,Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),R)),one_one(int)))) ) ) ).

% neg_eucl_rel_int_mult_2
tff(fact_4223_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: fun(int,fun(int,$o))] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,A0),A1))
     => ( ! [I2: int,J2: int] :
            ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,I2),J2))
           => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I2),J2)
               => aa(int,$o,aa(int,fun(int,$o),P,aa(int,int,aa(int,fun(int,int),plus_plus(int),I2),one_one(int))),J2) )
             => aa(int,$o,aa(int,fun(int,$o),P,I2),J2) ) )
       => aa(int,$o,aa(int,fun(int,$o),P,A0),A1) ) ) ).

% upto.pinduct
tff(fact_4224_eucl__rel__int__by0,axiom,
    ! [K: int] : eucl_rel_int(K,zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),K)) ).

% eucl_rel_int_by0
tff(fact_4225_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L != zero_zero(int) )
     => ( ( K = aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L) )
       => eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),zero_zero(int))) ) ) ).

% eucl_rel_int_dividesI
tff(fact_4226_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R))
     => ( ( B2 != zero_zero(int) )
       => eucl_rel_int(aa(int,int,uminus_uminus(int),A2),B2,
            aa(int,product_prod(int,int),
              product_Pair(int,int,$ite(R = zero_zero(int),aa(int,int,uminus_uminus(int),Q2),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,uminus_uminus(int),Q2)),one_one(int)))),
              $ite(R = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),R)))) ) ) ).

% zminus1_lemma
tff(fact_4227_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R))
    <=> ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),L),Q2)),R) )
        & $ite(
            aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),L),
            ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),R)
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),R),L) ),
            $ite(
              aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),zero_zero(int)),
              ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),L),R)
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),R),zero_zero(int)) ),
              Q2 = zero_zero(int) ) ) ) ) ).

% eucl_rel_int_iff
tff(fact_4228_eucl__rel__int__remainderI,axiom,
    ! [R: int,L: int,K: int,Q2: int] :
      ( ( aa(int,int,sgn_sgn(int),R) = aa(int,int,sgn_sgn(int),L) )
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R)),aa(int,int,abs_abs(int),L))
       => ( ( K = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q2),L)),R) )
         => eucl_rel_int(K,L,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R)) ) ) ) ).

% eucl_rel_int_remainderI
tff(fact_4229_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
     => ( ( ( A22 = zero_zero(int) )
         => ( A32 != aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),A1) ) )
       => ( ! [Q3: int] :
              ( ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q3),zero_zero(int)) )
             => ( ( A22 != zero_zero(int) )
               => ( A1 != aa(int,int,aa(int,fun(int,int),times_times(int),Q3),A22) ) ) )
         => ~ ! [R4: int,Q3: int] :
                ( ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q3),R4) )
               => ( ( aa(int,int,sgn_sgn(int),R4) = aa(int,int,sgn_sgn(int),A22) )
                 => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R4)),aa(int,int,abs_abs(int),A22))
                   => ( A1 != aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q3),A22)),R4) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
tff(fact_4230_eucl__rel__int_Osimps,axiom,
    ! [A1: int,A22: int,A32: product_prod(int,int)] :
      ( eucl_rel_int(A1,A22,A32)
    <=> ( ? [K2: int] :
            ( ( A1 = K2 )
            & ( A22 = zero_zero(int) )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),K2) ) )
        | ? [L4: int,K2: int,Q4: int] :
            ( ( A1 = K2 )
            & ( A22 = L4 )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q4),zero_zero(int)) )
            & ( L4 != zero_zero(int) )
            & ( K2 = aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L4) ) )
        | ? [R5: int,L4: int,K2: int,Q4: int] :
            ( ( A1 = K2 )
            & ( A22 = L4 )
            & ( A32 = aa(int,product_prod(int,int),product_Pair(int,int,Q4),R5) )
            & ( aa(int,int,sgn_sgn(int),R5) = aa(int,int,sgn_sgn(int),L4) )
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,abs_abs(int),R5)),aa(int,int,abs_abs(int),L4))
            & ( K2 = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Q4),L4)),R5) ) ) ) ) ).

% eucl_rel_int.simps
tff(fact_4231_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),B2)
     => ( eucl_rel_int(A2,B2,aa(int,product_prod(int,int),product_Pair(int,int,Q2),R))
       => eucl_rel_int(aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),B2),aa(int,product_prod(int,int),product_Pair(int,int,Q2),aa(int,int,aa(int,fun(int,int),plus_plus(int),one_one(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),R)))) ) ) ).

% pos_eucl_rel_int_mult_2
tff(fact_4232_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] :
          ( unique8689654367752047608divmod(A,aa(num,num,bit1,M),aa(num,num,bit1,N))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N),aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),aa(num,num,bit1,M))),unique1321980374590559556d_step(A,aa(num,num,bit1,N),unique8689654367752047608divmod(A,aa(num,num,bit1,M),bit0(aa(num,num,bit1,N))))) ) ) ).

% divmod_algorithm_code(8)
tff(fact_4233_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] :
          ( unique8689654367752047608divmod(A,bit0(M),aa(num,num,bit1,N))
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less_eq(num),M),N),aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),bit0(M))),unique1321980374590559556d_step(A,aa(num,num,bit1,N),unique8689654367752047608divmod(A,bit0(M),bit0(aa(num,num,bit1,N))))) ) ) ).

% divmod_algorithm_code(7)
tff(fact_4234_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Q2: A,R: A] :
          ( unique5940410009612947441es_aux(A,aa(A,product_prod(A,A),product_Pair(A,A,Q2),R))
        <=> ( R = zero_zero(A) ) ) ) ).

% divides_aux_eq
tff(fact_4235_divmod__BitM__2__eq,axiom,
    ! [M: num] : ( unique8689654367752047608divmod(int,bitM(M),bit0(one2)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),M)),one_one(int))),one_one(int)) ) ).

% divmod_BitM_2_eq
tff(fact_4236_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num] : ( unique8689654367752047608divmod(A,M,one2) = aa(A,product_prod(A,A),product_Pair(A,A,aa(num,A,numeral_numeral(A),M)),zero_zero(A)) ) ) ).

% divmod_algorithm_code(2)
tff(fact_4237_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( unique8689654367752047608divmod(A,one2,bit0(N)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(3)
tff(fact_4238_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( unique8689654367752047608divmod(A,one2,aa(num,num,bit1,N)) = aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),one2)) ) ) ).

% divmod_algorithm_code(4)
tff(fact_4239_minus__one__div__numeral,axiom,
    ! [N: num] : ( divide_divide(int,aa(int,int,uminus_uminus(int),one_one(int)),aa(num,int,numeral_numeral(int),N)) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,N))) ) ).

% minus_one_div_numeral
tff(fact_4240_one__div__minus__numeral,axiom,
    ! [N: num] : ( divide_divide(int,one_one(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,uminus_uminus(int),adjust_div(unique8689654367752047608divmod(int,one2,N))) ) ).

% one_div_minus_numeral
tff(fact_4241_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] :
          ( unique8689654367752047608divmod(A,M,N)
          = $ite(aa(num,$o,aa(num,fun(num,$o),ord_less(num),M),N),aa(A,product_prod(A,A),product_Pair(A,A,zero_zero(A)),aa(num,A,numeral_numeral(A),M)),unique1321980374590559556d_step(A,N,unique8689654367752047608divmod(A,M,bit0(N)))) ) ) ).

% divmod_divmod_step
tff(fact_4242_bezw__0,axiom,
    ! [Xa: nat] : ( bezw(Xa,zero_zero(nat)) = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)) ) ).

% bezw_0
tff(fact_4243_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( ( gcd_Gcd(A,A3) = zero_zero(A) )
        <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A)))) ) ) ).

% Gcd_0_iff
tff(fact_4244_card__atLeastAtMost__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or1337092689740270186AtMost(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L)),one_one(int))) ) ).

% card_atLeastAtMost_int
tff(fact_4245_remove__def,axiom,
    ! [A: $tType,Xa: A,A3: set(A)] : ( aa(set(A),set(A),aa(A,fun(set(A),set(A)),remove(A),Xa),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) ) ).

% remove_def
tff(fact_4246_abs__Gcd__eq,axiom,
    ! [K6: set(int)] : ( aa(int,int,abs_abs(int),gcd_Gcd(int,K6)) = gcd_Gcd(int,K6) ) ).

% abs_Gcd_eq
tff(fact_4247_Gcd__empty,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_empty
tff(fact_4248_Gcd__greatest,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A),A2: A] :
          ( ! [B4: A] :
              ( member(A,B4,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B4) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),gcd_Gcd(A,A3)) ) ) ).

% Gcd_greatest
tff(fact_4249_dvd__Gcd__iff,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Xa: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),gcd_Gcd(A,A3))
        <=> ! [X4: A] :
              ( member(A,X4,A3)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),X4) ) ) ) ).

% dvd_Gcd_iff
tff(fact_4250_dvd__GcdD,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Xa: A,A3: set(A),Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),gcd_Gcd(A,A3))
         => ( member(A,Y,A3)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Y) ) ) ) ).

% dvd_GcdD
tff(fact_4251_Gcd__dvd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),gcd_Gcd(A,A3)),A2) ) ) ).

% Gcd_dvd
tff(fact_4252_Gcd__dvd__int,axiom,
    ! [A2: int,A3: set(int)] :
      ( member(int,A2,A3)
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),gcd_Gcd(int,A3)),A2) ) ).

% Gcd_dvd_int
tff(fact_4253_Gcd__greatest__int,axiom,
    ! [A3: set(int),A2: int] :
      ( ! [B4: int] :
          ( member(int,B4,A3)
         => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),B4) )
     => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),A2),gcd_Gcd(int,A3)) ) ).

% Gcd_greatest_int
tff(fact_4254_Gcd__1,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( member(A,one_one(A),A3)
         => ( gcd_Gcd(A,A3) = one_one(A) ) ) ) ).

% Gcd_1
tff(fact_4255_Gcd__nat__eq__one,axiom,
    ! [N6: set(nat)] :
      ( member(nat,one_one(nat),N6)
     => ( gcd_Gcd(nat,N6) = one_one(nat) ) ) ).

% Gcd_nat_eq_one
tff(fact_4256_Gcd__dvd__nat,axiom,
    ! [A2: nat,A3: set(nat)] :
      ( member(nat,A2,A3)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),gcd_Gcd(nat,A3)),A2) ) ).

% Gcd_dvd_nat
tff(fact_4257_Gcd__greatest__nat,axiom,
    ! [A3: set(nat),A2: nat] :
      ( ! [B4: nat] :
          ( member(nat,B4,A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B4) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),gcd_Gcd(nat,A3)) ) ).

% Gcd_greatest_nat
tff(fact_4258_Gcd__int__greater__eq__0,axiom,
    ! [K6: set(int)] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),gcd_Gcd(int,K6)) ).

% Gcd_int_greater_eq_0
tff(fact_4259_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( member(A,A2,A3)
           => ( gcd_Gcd(A,A3) = one_one(A) ) ) ) ) ).

% Gcd_eq_1_I
tff(fact_4260_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A3: set(A),B3: set(A)] :
      ( member(A,A2,A3)
     => ( ~ member(A,A2,B3)
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),one_one(nat)) ) ) ) ).

% card_Diff_insert
tff(fact_4261_card_Oempty,axiom,
    ! [A: $tType] : ( aa(set(A),nat,finite_card(A),bot_bot(set(A))) = zero_zero(nat) ) ).

% card.empty
tff(fact_4262_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y: set(A),Xa: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),Y)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,Xa),Y))),N) ) ) ).

% card_insert_le_m1
tff(fact_4263_card__Diff__singleton__if,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))
      = $ite(member(A,Xa,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),one_one(nat)),aa(set(A),nat,finite_card(A),A3)) ) ).

% card_Diff_singleton_if
tff(fact_4264_card__atLeastAtMost,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or1337092689740270186AtMost(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,suc,U)),L) ) ).

% card_atLeastAtMost
tff(fact_4265_card__insert__le,axiom,
    ! [A: $tType,A3: set(A),Xa: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,Xa),A3))) ).

% card_insert_le
tff(fact_4266_card__1__singletonE,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = one_one(nat) )
     => ~ ! [X: A] : ( A3 != aa(set(A),set(A),insert(A,X),bot_bot(set(A))) ) ) ).

% card_1_singletonE
tff(fact_4267_card__Suc__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
    <=> ? [B7: A,B8: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B7),B8) )
          & ~ member(A,B7,B8)
          & ( aa(set(A),nat,finite_card(A),B8) = K )
          & ( ( K = zero_zero(nat) )
           => ( B8 = bot_bot(set(A)) ) ) ) ) ).

% card_Suc_eq
tff(fact_4268_card__eq__SucD,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
     => ? [B4: A,B9: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B4),B9) )
          & ~ member(A,B4,B9)
          & ( aa(set(A),nat,finite_card(A),B9) = K )
          & ( ( K = zero_zero(nat) )
           => ( B9 = bot_bot(set(A)) ) ) ) ) ).

% card_eq_SucD
tff(fact_4269_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ? [X4: A] : ( A3 = aa(set(A),set(A),insert(A,X4),bot_bot(set(A))) ) ) ).

% card_1_singleton_iff
tff(fact_4270_card__Diff1__le,axiom,
    ! [A: $tType,A3: set(A),Xa: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3)) ).

% card_Diff1_le
tff(fact_4271_card__Diff__singleton,axiom,
    ! [A: $tType,Xa: A,A3: set(A)] :
      ( member(A,Xa,A3)
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),one_one(nat)) ) ) ).

% card_Diff_singleton
tff(fact_4272_card__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or5935395276787703475ssThan(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),U),aa(int,int,aa(int,fun(int,int),plus_plus(int),L),one_one(int)))) ) ).

% card_greaterThanLessThan_int
tff(fact_4273_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: num,N: num] : ( power_int(A,aa(num,A,numeral_numeral(A),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(A,A,inverse_inverse(A),aa(num,A,numeral_numeral(A),pow(M,N))) ) ) ).

% power_int_numeral_neg_numeral
tff(fact_4274_complex__is__Nat__iff,axiom,
    ! [Z: complex] :
      ( member(complex,Z,semiring_1_Nats(complex))
    <=> ( ( im(Z) = zero_zero(real) )
        & ? [I3: nat] : ( re(Z) = aa(nat,real,semiring_1_of_nat(real),I3) ) ) ) ).

% complex_is_Nat_iff
tff(fact_4275_possible__bit__def,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Tyrep: itself(A),N: nat] :
          ( bit_se6407376104438227557le_bit(A,Tyrep,N)
        <=> ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) != zero_zero(A) ) ) ) ).

% possible_bit_def
tff(fact_4276_power__int__1__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int] : ( power_int(A,one_one(A),N) = one_one(A) ) ) ).

% power_int_1_left
tff(fact_4277_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & monoid_mult(A) )
     => ! [Y: A] : ( power_int(A,Y,one_one(int)) = Y ) ) ).

% power_int_1_right
tff(fact_4278_power__int__sgn,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,N: int] : ( aa(A,A,sgn_sgn(A),power_int(A,A2,N)) = power_int(A,aa(A,A,sgn_sgn(A),A2),N) ) ) ).

% power_int_sgn
tff(fact_4279_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,W: num,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),aa(num,A,numeral_numeral(A),W)),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,M)),power_int(A,aa(num,A,numeral_numeral(A),W),M)) ) ) ).

% power_int_mult_distrib_numeral2
tff(fact_4280_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [W: num,Y: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),W)),Y),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(num,A,numeral_numeral(A),W),M)),power_int(A,Y,M)) ) ) ).

% power_int_mult_distrib_numeral1
tff(fact_4281_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,N: int] :
          ( ( power_int(A,Xa,N) = zero_zero(A) )
        <=> ( ( Xa = zero_zero(A) )
            & ( N != zero_zero(int) ) ) ) ) ).

% power_int_eq_0_iff
tff(fact_4282_power__int__0__left,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] :
          ( ( M != zero_zero(int) )
         => ( power_int(A,zero_zero(A),M) = zero_zero(A) ) ) ) ).

% power_int_0_left
tff(fact_4283_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),K)
         => ( set_or5935395276787703475ssThan(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanLessThan_empty
tff(fact_4284_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ( set_or5935395276787703475ssThan(A,A2,B2) = bot_bot(set(A)) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% greaterThanLessThan_empty_iff
tff(fact_4285_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A] :
          ( ( bot_bot(set(A)) = set_or5935395276787703475ssThan(A,A2,B2) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% greaterThanLessThan_empty_iff2
tff(fact_4286_power__int__0__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [Xa: A] : ( power_int(A,Xa,zero_zero(int)) = one_one(A) ) ) ).

% power_int_0_right
tff(fact_4287_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,N: int] : ( aa(A,A,abs_abs(A),power_int(A,aa(A,A,uminus_uminus(A),A2),N)) = aa(A,A,abs_abs(A),power_int(A,A2,N)) ) ) ).

% abs_power_int_minus
tff(fact_4288_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [Xa: A,N: nat] : ( power_int(A,Xa,aa(nat,int,semiring_1_of_nat(int),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N) ) ) ).

% power_int_of_nat
tff(fact_4289_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: num,N: num] : ( power_int(A,power_int(A,Xa,aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)) = power_int(A,Xa,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),times_times(num),M),N))) ) ) ).

% power_int_mult_numeral
tff(fact_4290_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),B2)) = B2 ) ) ).

% power_int_minus_one_mult_self'
tff(fact_4291_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)),power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),M)) = one_one(A) ) ) ).

% power_int_minus_one_mult_self
tff(fact_4292_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [Xa: A,N: num] : ( power_int(A,Xa,aa(num,int,numeral_numeral(int),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(num,nat,numeral_numeral(nat),N)) ) ) ).

% power_int_numeral
tff(fact_4293_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & monoid_mult(A) )
     => ! [Y: A] : ( power_int(A,Y,aa(int,int,uminus_uminus(int),one_one(int))) = aa(A,A,inverse_inverse(A),Y) ) ) ).

% power_int_minus1_right
tff(fact_4294_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,aa(num,int,numeral_numeral(int),M))),power_int(A,Xa,aa(num,int,numeral_numeral(int),N))) = power_int(A,Xa,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N))) ) ) ).

% power_int_add_numeral
tff(fact_4295_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: num,N: num,B2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,aa(num,int,numeral_numeral(int),M))),aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,aa(num,int,numeral_numeral(int),N))),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,aa(num,int,numeral_numeral(int),aa(num,num,aa(num,fun(num,num),plus_plus(num),M),N)))),B2) ) ) ).

% power_int_add_numeral2
tff(fact_4296_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),B2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,A2,N)),power_int(A,B2,N))
              <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ) ) ) ).

% power_int_mono_iff
tff(fact_4297_possible__bit__0,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Ty: itself(A)] : bit_se6407376104438227557le_bit(A,Ty,zero_zero(nat)) ) ).

% possible_bit_0
tff(fact_4298_power__int__mult,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: int,N: int] : ( power_int(A,Xa,aa(int,int,aa(int,fun(int,int),times_times(int),M),N)) = power_int(A,power_int(A,Xa,M),N) ) ) ).

% power_int_mult
tff(fact_4299_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,Y: A,M: int] : ( power_int(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y),M) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,M)),power_int(A,Y,M)) ) ) ).

% power_int_mult_distrib
tff(fact_4300_power__int__commutes,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,N: int] : ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,N)),Xa) = aa(A,A,aa(A,fun(A,A),times_times(A),Xa),power_int(A,Xa,N)) ) ) ).

% power_int_commutes
tff(fact_4301_power__int__abs,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,N: int] : ( aa(A,A,abs_abs(A),power_int(A,A2,N)) = power_int(A,aa(A,A,abs_abs(A),A2),N) ) ) ).

% power_int_abs
tff(fact_4302_power__int__inverse,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,N: int] : ( power_int(A,aa(A,A,inverse_inverse(A),Xa),N) = aa(A,A,inverse_inverse(A),power_int(A,Xa,N)) ) ) ).

% power_int_inverse
tff(fact_4303_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,Y: A,M: int] : ( power_int(A,divide_divide(A,Xa,Y),M) = divide_divide(A,power_int(A,Xa,M),power_int(A,Y,M)) ) ) ).

% power_int_divide_distrib
tff(fact_4304_possible__bit__less__imp,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [Tyrep: itself(A),I: nat,J: nat] :
          ( bit_se6407376104438227557le_bit(A,Tyrep,I)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),I)
           => bit_se6407376104438227557le_bit(A,Tyrep,J) ) ) ) ).

% possible_bit_less_imp
tff(fact_4305_Nats__0,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => member(A,zero_zero(A),semiring_1_Nats(A)) ) ).

% Nats_0
tff(fact_4306_Nats__numeral,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [W: num] : member(A,aa(num,A,numeral_numeral(A),W),semiring_1_Nats(A)) ) ).

% Nats_numeral
tff(fact_4307_Nats__mult,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,semiring_1_Nats(A))
         => ( member(A,B2,semiring_1_Nats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),semiring_1_Nats(A)) ) ) ) ).

% Nats_mult
tff(fact_4308_Nats__1,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => member(A,one_one(A),semiring_1_Nats(A)) ) ).

% Nats_1
tff(fact_4309_Nats__add,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,semiring_1_Nats(A))
         => ( member(A,B2,semiring_1_Nats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),semiring_1_Nats(A)) ) ) ) ).

% Nats_add
tff(fact_4310_Nats__cases,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Xa: A] :
          ( member(A,Xa,semiring_1_Nats(A))
         => ~ ! [N2: nat] : ( Xa != aa(nat,A,semiring_1_of_nat(A),N2) ) ) ) ).

% Nats_cases
tff(fact_4311_Nats__induct,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Xa: A,P: fun(A,$o)] :
          ( member(A,Xa,semiring_1_Nats(A))
         => ( ! [N2: nat] : aa(A,$o,P,aa(nat,A,semiring_1_of_nat(A),N2))
           => aa(A,$o,P,Xa) ) ) ) ).

% Nats_induct
tff(fact_4312_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : member(A,aa(nat,A,semiring_1_of_nat(A),N),semiring_1_Nats(A)) ) ).

% of_nat_in_Nats
tff(fact_4313_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),power_int(A,Xa,N)) ) ) ).

% zero_le_power_int
tff(fact_4314_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),power_int(A,Xa,N)) ) ) ).

% zero_less_power_int
tff(fact_4315_power__int__one__over,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,N: int] : ( power_int(A,divide_divide(A,one_one(A),Xa),N) = divide_divide(A,one_one(A),power_int(A,Xa,N)) ) ) ).

% power_int_one_over
tff(fact_4316_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,N: int] :
          ( ( ( Xa != zero_zero(A) )
            | ( N = zero_zero(int) ) )
         => ( power_int(A,Xa,N) != zero_zero(A) ) ) ) ).

% power_int_not_zero
tff(fact_4317_power__int__minus,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,N: int] : ( power_int(A,Xa,aa(int,int,uminus_uminus(int),N)) = aa(A,A,inverse_inverse(A),power_int(A,Xa,N)) ) ) ).

% power_int_minus
tff(fact_4318_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [M: int] :
          ( power_int(A,zero_zero(A),M)
          = $ite(M = zero_zero(int),one_one(A),zero_zero(A)) ) ) ).

% power_int_0_left_If
tff(fact_4319_power__int__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N6: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,A2,N)),power_int(A,A2,N6)) ) ) ) ).

% power_int_increasing
tff(fact_4320_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N6: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,A2,N)),power_int(A,A2,N6)) ) ) ) ).

% power_int_strict_increasing
tff(fact_4321_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [N: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,uminus_uminus(int),N)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),N) ) ) ).

% power_int_minus_one_minus
tff(fact_4322_power__int__diff,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,M: int,N: int] :
          ( ( ( Xa != zero_zero(A) )
            | ( M != N ) )
         => ( power_int(A,Xa,aa(int,int,aa(int,fun(int,int),minus_minus(int),M),N)) = divide_divide(A,power_int(A,Xa,M),power_int(A,Xa,N)) ) ) ) ).

% power_int_diff
tff(fact_4323_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [A2: int,B2: int] : ( power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),A2),B2)) = power_int(A,aa(A,A,uminus_uminus(A),one_one(A)),aa(int,int,aa(int,fun(int,int),minus_minus(int),B2),A2)) ) ) ).

% power_int_minus_one_diff_commute
tff(fact_4324_Nats__diff,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,semiring_1_Nats(A))
         => ( member(A,B2,semiring_1_Nats(A))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
             => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),semiring_1_Nats(A)) ) ) ) ) ).

% Nats_diff
tff(fact_4325_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or5935395276787703475ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
tff(fact_4326_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),semiring_1_Nats(A)),ring_1_Ints(A)) ) ).

% Nats_subset_Ints
tff(fact_4327_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N6: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,A2,N6)),power_int(A,A2,N)) ) ) ) ) ).

% power_int_strict_decreasing
tff(fact_4328_power__int__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,Y: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,Xa,N)),power_int(A,Y,N)) ) ) ) ) ).

% power_int_mono
tff(fact_4329_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),zero_zero(int))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,B2,N)),power_int(A,A2,N)) ) ) ) ) ).

% power_int_strict_antimono
tff(fact_4330_one__le__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),Xa)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),power_int(A,Xa,N)) ) ) ) ).

% one_le_power_int
tff(fact_4331_one__less__power__int,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),A2)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),power_int(A,A2,N)) ) ) ) ).

% one_less_power_int
tff(fact_4332_power__int__add,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: int,N: int] :
          ( ( ( Xa != zero_zero(A) )
            | ( aa(int,int,aa(int,fun(int,int),plus_plus(int),M),N) != zero_zero(int) ) )
         => ( power_int(A,Xa,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,M)),power_int(A,Xa,N)) ) ) ) ).

% power_int_add
tff(fact_4333_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
tff(fact_4334_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))) = set_or5935395276787703475ssThan(A,A2,B2) ) ) ).

% atLeastAtMost_diff_ends
tff(fact_4335_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N)
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,A2,N)),power_int(A,B2,N)) ) ) ) ) ).

% power_int_strict_mono
tff(fact_4336_power__int__antimono,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [A2: A,B2: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),A2)
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),N),zero_zero(int))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,B2,N)),power_int(A,A2,N)) ) ) ) ) ).

% power_int_antimono
tff(fact_4337_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [N: int,N6: int,A2: A] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),N),N6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),one_one(A))
             => ( ( ( A2 != zero_zero(A) )
                  | ( N6 != zero_zero(int) )
                  | ( N = zero_zero(int) ) )
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,A2,N6)),power_int(A,A2,N)) ) ) ) ) ) ).

% power_int_decreasing
tff(fact_4338_power__int__le__one,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Xa)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),one_one(A))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,Xa,N)),one_one(A)) ) ) ) ) ).

% power_int_le_one
tff(fact_4339_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,M: int,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),power_int(A,Xa,M)),power_int(A,Xa,N))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
             => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M),N) ) ) ) ) ).

% power_int_le_imp_le_exp
tff(fact_4340_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Xa: A,M: int,N: int] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),power_int(A,Xa,M)),power_int(A,Xa,N))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N)
             => aa(int,$o,aa(int,fun(int,$o),ord_less(int),M),N) ) ) ) ) ).

% power_int_le_imp_less_exp
tff(fact_4341_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,N: int] :
          ( ( ( Xa != zero_zero(A) )
            | ( N != zero_zero(int) ) )
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int)))),Xa) = power_int(A,Xa,N) ) ) ) ).

% power_int_minus_mult
tff(fact_4342_power__int__add__1,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: int] :
          ( ( ( Xa != zero_zero(A) )
            | ( M != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,Xa,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),power_int(A,Xa,M)),Xa) ) ) ) ).

% power_int_add_1
tff(fact_4343_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Xa: A,M: int] :
          ( ( ( Xa != zero_zero(A) )
            | ( M != aa(int,int,uminus_uminus(int),one_one(int)) ) )
         => ( power_int(A,Xa,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),one_one(int))) = aa(A,A,aa(A,fun(A,A),times_times(A),Xa),power_int(A,Xa,M)) ) ) ) ).

% power_int_add_1'
tff(fact_4344_power__int__def,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & power(A) )
     => ! [Xa: A,N: int] :
          ( power_int(A,Xa,N)
          = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(int,nat,nat2,N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),Xa)),aa(int,nat,nat2,aa(int,int,uminus_uminus(int),N)))) ) ) ).

% power_int_def
tff(fact_4345_powr__real__of__int_H,axiom,
    ! [Xa: real,N: int] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( ( ( Xa != zero_zero(real) )
          | aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),N) )
       => ( aa(real,real,aa(real,fun(real,real),powr(real),Xa),aa(int,real,ring_1_of_int(real),N)) = power_int(real,Xa,N) ) ) ) ).

% powr_real_of_int'
tff(fact_4346_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: nat] :
          ( aa(A,A,bit_se4197421643247451524op_bit(A,M),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N))
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                aa($o,A,zero_neq_one_of_bool(A),
                  aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
                & bit_se6407376104438227557le_bit(A,type2(A),N))),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% drop_bit_exp_eq
tff(fact_4347_bit__minus__2__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),bit0(one2)))),N)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),N)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ) ).

% bit_minus_2_iff
tff(fact_4348_bit__double__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)),N)
        <=> ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))
            & ( N != zero_zero(nat) )
            & bit_se6407376104438227557le_bit(A,type2(A),N) ) ) ) ).

% bit_double_iff
tff(fact_4349_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M)),one_one(A))),N)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),N)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M) ) ) ) ).

% bit_mask_sub_iff
tff(fact_4350_card__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or5935395276787703475ssThan(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),U),aa(nat,nat,suc,L)) ) ).

% card_greaterThanLessThan
tff(fact_4351_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),one_one(A))),N)
        <=> bit_se6407376104438227557le_bit(A,type2(A),N) ) ) ).

% bit_minus_1_iff
tff(fact_4352_tanh__real__bounds,axiom,
    ! [Xa: real] : member(real,aa(real,real,tanh(real),Xa),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real))) ).

% tanh_real_bounds
tff(fact_4353_bit__of__nat__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(nat,A,semiring_1_of_nat(A),M)),N)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),N)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(nat,M),N) ) ) ) ).

% bit_of_nat_iff
tff(fact_4354_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),A2)),N)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),N)
            & ~ aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),N) ) ) ) ).

% bit_minus_iff
tff(fact_4355_bit__push__bit__iff,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,A2: A,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se4730199178511100633sh_bit(A,M),A2)),N)
        <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
            & bit_se6407376104438227557le_bit(A,type2(A),N)
            & aa(nat,$o,bit_se5641148757651400278ts_bit(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)) ) ) ) ).

% bit_push_bit_iff
tff(fact_4356_fold__possible__bit,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] :
          ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) = zero_zero(A) )
        <=> ~ bit_se6407376104438227557le_bit(A,type2(A),N) ) ) ).

% fold_possible_bit
tff(fact_4357_bit__2__iff,axiom,
    ! [A: $tType] :
      ( bit_semiring_bits(A)
     => ! [N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(num,A,numeral_numeral(A),bit0(one2))),N)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),one_one(nat))
            & ( N = one_one(nat) ) ) ) ) ).

% bit_2_iff
tff(fact_4358_bit__minus__exp__iff,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [M: nat,N: nat] :
          ( aa(nat,$o,bit_se5641148757651400278ts_bit(A,aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M))),N)
        <=> ( bit_se6407376104438227557le_bit(A,type2(A),N)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ) ) ).

% bit_minus_exp_iff
tff(fact_4359_CHAR__eq0__iff,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( ( semiri4206861660011772517g_char(A,type2(A)) = zero_zero(nat) )
      <=> ! [N5: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N5)
           => ( aa(nat,A,semiring_1_of_nat(A),N5) != zero_zero(A) ) ) ) ) ).

% CHAR_eq0_iff
tff(fact_4360_CHAR__eq__posI,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [C2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
         => ( ( aa(nat,A,semiring_1_of_nat(A),C2) = zero_zero(A) )
           => ( ! [X: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),X)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X),C2)
                   => ( aa(nat,A,semiring_1_of_nat(A),X) != zero_zero(A) ) ) )
             => ( semiri4206861660011772517g_char(A,type2(A)) = C2 ) ) ) ) ) ).

% CHAR_eq_posI
tff(fact_4361_CHAR__pos__iff,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),semiri4206861660011772517g_char(A,type2(A)))
      <=> ? [N5: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N5)
            & ( aa(nat,A,semiring_1_of_nat(A),N5) = zero_zero(A) ) ) ) ) ).

% CHAR_pos_iff
tff(fact_4362_of__nat__CHAR,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( aa(nat,A,semiring_1_of_nat(A),semiri4206861660011772517g_char(A,type2(A))) = zero_zero(A) ) ) ).

% of_nat_CHAR
tff(fact_4363_CHAR__eq__0,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ( semiri4206861660011772517g_char(A,type2(A)) = zero_zero(nat) ) ) ).

% CHAR_eq_0
tff(fact_4364_of__nat__eq__0__iff__char__dvd,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),N) = zero_zero(A) )
        <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),semiri4206861660011772517g_char(A,type2(A))),N) ) ) ).

% of_nat_eq_0_iff_char_dvd
tff(fact_4365_CHAR__eqI,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [C2: nat] :
          ( ( aa(nat,A,semiring_1_of_nat(A),C2) = zero_zero(A) )
         => ( ! [X: nat] :
                ( ( aa(nat,A,semiring_1_of_nat(A),X) = zero_zero(A) )
               => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),C2),X) )
           => ( semiri4206861660011772517g_char(A,type2(A)) = C2 ) ) ) ) ).

% CHAR_eqI
tff(fact_4366_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,Y: A,C2: B,A2: real,B2: real] :
          ( nO_MATCH(A,B,divide_divide(A,Xa,Y),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),B2)),Xa) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa)) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
tff(fact_4367_scale__left__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,Y: A,C2: B,A2: real,B2: real] :
          ( nO_MATCH(A,B,divide_divide(A,Xa,Y),C2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,aa(real,fun(real,real),plus_plus(real),A2),B2)),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,B2),Xa)) ) ) ) ).

% scale_left_distrib_NO_MATCH
tff(fact_4368_prod__decode__aux_Oelims,axiom,
    ! [Xa: nat,Xaa: nat,Y: product_prod(nat,nat)] :
      ( ( aa(nat,product_prod(nat,nat),nat_prod_decode_aux(Xa),Xaa) = Y )
     => ( Y
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xaa),Xa),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xaa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),Xaa)),aa(nat,product_prod(nat,nat),nat_prod_decode_aux(aa(nat,nat,suc,Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xaa),aa(nat,nat,suc,Xa)))) ) ) ).

% prod_decode_aux.elims
tff(fact_4369_prod__decode__aux_Osimps,axiom,
    ! [K: nat,M: nat] :
      ( aa(nat,product_prod(nat,nat),nat_prod_decode_aux(K),M)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),K),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),M)),aa(nat,product_prod(nat,nat),nat_prod_decode_aux(aa(nat,nat,suc,K)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,K)))) ) ).

% prod_decode_aux.simps
tff(fact_4370_prod__decode__aux_Ocases,axiom,
    ! [Xa: product_prod(nat,nat)] :
      ~ ! [K3: nat,M2: nat] : ( Xa != aa(nat,product_prod(nat,nat),product_Pair(nat,nat,K3),M2) ) ).

% prod_decode_aux.cases
tff(fact_4371_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,Y: A,A2: real] :
          ( nO_MATCH(A,real,divide_divide(A,Xa,Y),A2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ) ).

% scale_right_distrib_NO_MATCH
tff(fact_4372_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,Y: A,A2: real] :
          ( nO_MATCH(A,real,divide_divide(A,Xa,Y),A2)
         => ( aa(A,A,real_V8093663219630862766scaleR(A,A2),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,real_V8093663219630862766scaleR(A,A2),Xa)),aa(A,A,real_V8093663219630862766scaleR(A,A2),Y)) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
tff(fact_4373_distrib__right__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring(B)
     => ! [Xa: A,Y: A,C2: B,A2: B,B2: B] :
          ( nO_MATCH(A,B,divide_divide(A,Xa,Y),C2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),C2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),B2),C2)) ) ) ) ).

% distrib_right_NO_MATCH
tff(fact_4374_distrib__left__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring(B)
     => ! [Xa: A,Y: A,A2: B,B2: B,C2: B] :
          ( nO_MATCH(A,B,divide_divide(A,Xa,Y),A2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A2),aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),C2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)) ) ) ) ).

% distrib_left_NO_MATCH
tff(fact_4375_left__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( ring(B)
     => ! [Xa: A,Y: A,C2: B,A2: B,B2: B] :
          ( nO_MATCH(A,B,divide_divide(A,Xa,Y),C2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),A2),B2)),C2) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)),aa(B,B,aa(B,fun(B,B),times_times(B),B2),C2)) ) ) ) ).

% left_diff_distrib_NO_MATCH
tff(fact_4376_right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType,B: $tType] :
      ( ring(B)
     => ! [Xa: A,Y: A,A2: B,B2: B,C2: B] :
          ( nO_MATCH(A,B,divide_divide(A,Xa,Y),A2)
         => ( aa(B,B,aa(B,fun(B,B),times_times(B),A2),aa(B,B,aa(B,fun(B,B),minus_minus(B),B2),C2)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),aa(B,B,aa(B,fun(B,B),times_times(B),A2),C2)) ) ) ) ).

% right_diff_distrib_NO_MATCH
tff(fact_4377_power__minus_H,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: A,N: nat] :
          ( nO_MATCH(A,A,one_one(A),Xa)
         => ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Xa)),N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)) ) ) ) ).

% power_minus'
tff(fact_4378_power__int__minus__left__distrib,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( division_ring(C)
        & one(A)
        & uminus(A) )
     => ! [Xa: B,A2: C,N: int] :
          ( nO_MATCH(A,B,aa(A,A,uminus_uminus(A),one_one(A)),Xa)
         => ( power_int(C,aa(C,C,uminus_uminus(C),A2),N) = aa(C,C,aa(C,fun(C,C),times_times(C),power_int(C,aa(C,C,uminus_uminus(C),one_one(C)),N)),power_int(C,A2,N)) ) ) ) ).

% power_int_minus_left_distrib
tff(fact_4379_div__add__self2__no__field,axiom,
    ! [A: $tType,B: $tType] :
      ( ( euclid4440199948858584721cancel(B)
        & field(A) )
     => ! [Xa: A,B2: B,A2: B] :
          ( nO_MATCH(A,B,Xa,B2)
         => ( ( B2 != zero_zero(B) )
           => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A2,B2)),one_one(B)) ) ) ) ) ).

% div_add_self2_no_field
tff(fact_4380_div__add__self1__no__field,axiom,
    ! [A: $tType,B: $tType] :
      ( ( euclid4440199948858584721cancel(B)
        & field(A) )
     => ! [Xa: A,B2: B,A2: B] :
          ( nO_MATCH(A,B,Xa,B2)
         => ( ( B2 != zero_zero(B) )
           => ( divide_divide(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),A2),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),divide_divide(B,A2,B2)),one_one(B)) ) ) ) ) ).

% div_add_self1_no_field
tff(fact_4381_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] : ( aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),nat_prod_decode_aux(K),M)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(K)),M) ) ).

% prod_encode_prod_decode_aux
tff(fact_4382_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X6)
        <=> ! [J3: nat] :
            ? [M8: nat] :
            ! [M6: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M6)
             => ! [N5: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N5)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,M6),aa(nat,A,X6,N5))),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,J3)))) ) ) ) ) ).

% metric_Cauchy_iff2
tff(fact_4383_prod__encode__eq,axiom,
    ! [Xa: product_prod(nat,nat),Y: product_prod(nat,nat)] :
      ( ( aa(product_prod(nat,nat),nat,nat_prod_encode,Xa) = aa(product_prod(nat,nat),nat,nat_prod_encode,Y) )
    <=> ( Xa = Y ) ) ).

% prod_encode_eq
tff(fact_4384_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),C2)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel
tff(fact_4385_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [B2: A,A2: A,C2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),B2),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)) = real_V557655796197034286t_dist(A,B2,C2) ) ) ).

% dist_add_cancel2
tff(fact_4386_dist__self,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A] : ( real_V557655796197034286t_dist(A,Xa,Xa) = zero_zero(real) ) ) ).

% dist_self
tff(fact_4387_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A] :
          ( ( real_V557655796197034286t_dist(A,Xa,Y) = zero_zero(real) )
        <=> ( Xa = Y ) ) ) ).

% dist_eq_0_iff
tff(fact_4388_dist__0__norm,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] : ( real_V557655796197034286t_dist(A,zero_zero(A),Xa) = real_V7770717601297561774m_norm(A,Xa) ) ) ).

% dist_0_norm
tff(fact_4389_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,Xa,Y))
        <=> ( Xa != Y ) ) ) ).

% zero_less_dist_iff
tff(fact_4390_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,Xa,Y)),zero_zero(real))
        <=> ( Xa = Y ) ) ) ).

% dist_le_zero_iff
tff(fact_4391_dist__diff_I2_J,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : ( real_V557655796197034286t_dist(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),A2) = real_V7770717601297561774m_norm(A,B2) ) ) ).

% dist_diff(2)
tff(fact_4392_dist__diff_I1_J,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A,B2: A] : ( real_V557655796197034286t_dist(A,A2,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) = real_V7770717601297561774m_norm(A,B2) ) ) ).

% dist_diff(1)
tff(fact_4393_dist__scaleR,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: real,A2: A,Y: real] : ( real_V557655796197034286t_dist(A,aa(A,A,real_V8093663219630862766scaleR(A,Xa),A2),aa(A,A,real_V8093663219630862766scaleR(A,Y),A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y))),real_V7770717601297561774m_norm(A,A2)) ) ) ).

% dist_scaleR
tff(fact_4394_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Xa: A] : ( real_V7770717601297561774m_norm(A,Xa) = real_V557655796197034286t_dist(A,Xa,zero_zero(A)) ) ) ).

% norm_conv_dist
tff(fact_4395_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A] : ~ aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Xa,Y)),zero_zero(real)) ) ).

% dist_not_less_zero
tff(fact_4396_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A] :
          ( ( Xa != Y )
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,Xa,Y)) ) ) ).

% dist_pos_lt
tff(fact_4397_zero__le__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),real_V557655796197034286t_dist(A,Xa,Y)) ) ).

% zero_le_dist
tff(fact_4398_dist__norm,axiom,
    ! [A: $tType] :
      ( real_V6936659425649961206t_norm(A)
     => ! [Xa: A,Y: A] : ( real_V557655796197034286t_dist(A,Xa,Y) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) ) ) ).

% dist_norm
tff(fact_4399_dist__triangle,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Z: A,Y: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,Xa,Z)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,Xa,Y)),real_V557655796197034286t_dist(A,Y,Z))) ) ).

% dist_triangle
tff(fact_4400_dist__triangle2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A,Z: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,Xa,Y)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,Xa,Z)),real_V557655796197034286t_dist(A,Y,Z))) ) ).

% dist_triangle2
tff(fact_4401_dist__triangle3,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Y: A,A2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,Xa,Y)),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,A2,Xa)),real_V557655796197034286t_dist(A,A2,Y))) ) ).

% dist_triangle3
tff(fact_4402_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A,Z: A,Y: A,E: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),real_V557655796197034286t_dist(A,Xa,Z)),real_V557655796197034286t_dist(A,Y,Z))),E)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,Xa,Y)),E) ) ) ).

% dist_triangle_le
tff(fact_4403_dist__real__def,axiom,
    ! [Xa: real,Y: real] : ( real_V557655796197034286t_dist(real,Xa,Y) = aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y)) ) ).

% dist_real_def
tff(fact_4404_dist__complex__def,axiom,
    ! [Xa: complex,Y: complex] : ( real_V557655796197034286t_dist(complex,Xa,Y) = real_V7770717601297561774m_norm(complex,aa(complex,complex,aa(complex,fun(complex,complex),minus_minus(complex),Xa),Y)) ) ).

% dist_complex_def
tff(fact_4405_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [A2: A,B2: A,C2: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),real_V557655796197034286t_dist(A,A2,B2)),real_V557655796197034286t_dist(A,B2,C2)))),real_V557655796197034286t_dist(A,A2,C2)) ) ).

% abs_dist_diff_le
tff(fact_4406_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),B2),aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),B2))) ).

% le_prod_encode_2
tff(fact_4407_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),B2))) ).

% le_prod_encode_1
tff(fact_4408_Cauchy__def,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X6)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M8: nat] :
                ! [M6: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M6)
                 => ! [N5: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),N5)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,M6),aa(nat,A,X6,N5))),E3) ) ) ) ) ) ).

% Cauchy_def
tff(fact_4409_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,S)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [N7: nat] :
                ! [N5: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N5)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,S,N5),aa(nat,A,S,N7))),E3) ) ) ) ) ).

% Cauchy_altdef2
tff(fact_4410_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A),E: real] :
          ( topolo3814608138187158403Cauchy(A,X6)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
           => ? [M10: nat] :
              ! [M3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M10),M3)
               => ! [N3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M10),N3)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,M3),aa(nat,A,X6,N3))),E) ) ) ) ) ) ).

% metric_CauchyD
tff(fact_4411_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A)] :
          ( ! [E2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
             => ? [M9: nat] :
                ! [M2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M2)
                 => ! [N2: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),N2)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,M2),aa(nat,A,X6,N2))),E2) ) ) )
         => topolo3814608138187158403Cauchy(A,X6) ) ) ).

% metric_CauchyI
tff(fact_4412_dist__of__int,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [M: int,N: int] : ( real_V557655796197034286t_dist(A,aa(int,A,ring_1_of_int(A),M),aa(int,A,ring_1_of_int(A),N)) = aa(int,real,ring_1_of_int(real),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),N))) ) ) ).

% dist_of_int
tff(fact_4413_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [F3: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [M8: nat] :
                ! [M6: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M8),M6)
                 => ! [N5: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M6),N5)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,F3,M6),aa(nat,A,F3,N5))),E3) ) ) ) ) ) ).

% Cauchy_altdef
tff(fact_4414_CauchyI_H,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A)] :
          ( ! [E2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
             => ? [M9: nat] :
                ! [M2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M9),M2)
                 => ! [N2: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N2)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,M2),aa(nat,A,X6,N2))),E2) ) ) )
         => topolo3814608138187158403Cauchy(A,X6) ) ) ).

% CauchyI'
tff(fact_4415_dist__of__nat,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [M: nat,N: nat] : ( real_V557655796197034286t_dist(A,aa(nat,A,semiring_1_of_nat(A),M),aa(nat,A,semiring_1_of_nat(A),N)) = aa(int,real,ring_1_of_int(real),aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N)))) ) ) ).

% dist_of_nat
tff(fact_4416_normalize__negative,axiom,
    ! [Q2: int,P2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Q2),zero_zero(int))
     => ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2)) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),P2)),aa(int,int,uminus_uminus(int),Q2))) ) ) ).

% normalize_negative
tff(fact_4417_normalize__denom__zero,axiom,
    ! [P2: int] : ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P2),zero_zero(int))) = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)) ) ).

% normalize_denom_zero
tff(fact_4418_quotient__of__number_I5_J,axiom,
    ! [K: num] : ( quotient_of(aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K))) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% quotient_of_number(5)
tff(fact_4419_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [K: int] :
          ( aa(int,A,ring_1_of_int(A),K)
          = $ite(
              K = zero_zero(int),
              zero_zero(A),
              $ite(
                aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),
                aa(A,A,uminus_uminus(A),aa(int,A,ring_1_of_int(A),aa(int,int,uminus_uminus(int),K))),
                $let(
                  l: A,
                  l := aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(int,A,ring_1_of_int(A),divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2))))),
                  $ite(modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2))) = zero_zero(int),l,aa(A,A,aa(A,fun(A,A),plus_plus(A),l),one_one(A))) ) ) ) ) ) ).

% of_int_code_if
tff(fact_4420_rat__one__code,axiom,
    quotient_of(one_one(rat)) = aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int)) ).

% rat_one_code
tff(fact_4421_card__Collect__le__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_aa(nat,fun(nat,$o)),N))) = aa(nat,nat,suc,N) ) ).

% card_Collect_le_nat
tff(fact_4422_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,fun(A,A)),V: num] :
      ( aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),A2),F3),aa(num,nat,numeral_numeral(nat),V))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(A,A,aa(nat,fun(A,A),F3,pv),aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),A2),F3),pv)) ) ) ).

% rec_nat_numeral
tff(fact_4423_rat__zero__code,axiom,
    quotient_of(zero_zero(rat)) = aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)) ).

% rat_zero_code
tff(fact_4424_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,fun(A,A)),V: num,N: nat] :
      ( aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),A2),F3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N))
      = $let(
          pv: nat,
          pv := pred_numeral(V),
          aa(A,A,aa(nat,fun(A,A),F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),N)),aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),A2),F3),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pv),N))) ) ) ).

% rec_nat_add_eq_if
tff(fact_4425_quotient__of__number_I4_J,axiom,
    quotient_of(aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,uminus_uminus(int),one_one(int))),one_one(int)) ).

% quotient_of_number(4)
tff(fact_4426_quotient__of__number_I3_J,axiom,
    ! [K: num] : ( quotient_of(aa(num,rat,numeral_numeral(rat),K)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% quotient_of_number(3)
tff(fact_4427_sgn__rat__def,axiom,
    ! [A2: rat] :
      ( aa(rat,rat,sgn_sgn(rat),A2)
      = $ite(
          A2 = zero_zero(rat),
          zero_zero(rat),
          $ite(aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),A2),one_one(rat),aa(rat,rat,uminus_uminus(rat),one_one(rat))) ) ) ).

% sgn_rat_def
tff(fact_4428_abs__rat__def,axiom,
    ! [A2: rat] :
      ( aa(rat,rat,abs_abs(rat),A2)
      = $ite(aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),A2),zero_zero(rat)),aa(rat,rat,uminus_uminus(rat),A2),A2) ) ).

% abs_rat_def
tff(fact_4429_diff__rat__def,axiom,
    ! [Q2: rat,R: rat] : ( aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),Q2),R) = aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),Q2),aa(rat,rat,uminus_uminus(rat),R)) ) ).

% diff_rat_def
tff(fact_4430_max__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: A,Xa2: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_max(A),X3),Xa2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Xa2),Xa2,X3) ) ) ).

% max_def_raw
tff(fact_4431_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] :
          ( aa(num,A,numeral_numeral(A),bit0(N))
          = $let(
              m: A,
              m := aa(num,A,numeral_numeral(A),N),
              aa(A,A,aa(A,fun(A,A),plus_plus(A),m),m) ) ) ) ).

% numeral_code(2)
tff(fact_4432_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_ab(A,fun(A,$o),A2))),collect(A,aTP_Lamp_ab(A,fun(A,$o),B2)))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% subset_divisors_dvd
tff(fact_4433_less__eq__set__def,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
    <=> aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),aTP_Lamp_a(set(A),fun(A,$o),A3)),aTP_Lamp_a(set(A),fun(A,$o),B3)) ) ).

% less_eq_set_def
tff(fact_4434_Collect__subset,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))),A3) ).

% Collect_subset
tff(fact_4435_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),collect(A,aTP_Lamp_ab(A,fun(A,$o),A2))),collect(A,aTP_Lamp_ab(A,fun(A,$o),B2)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
            & ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2) ) ) ) ).

% strict_subset_divisors_dvd
tff(fact_4436_lambda__zero,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ( aTP_Lamp_ad(A,A) = aa(A,fun(A,A),times_times(A),zero_zero(A)) ) ) ).

% lambda_zero
tff(fact_4437_minus__set__def,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = collect(A,aa(fun(A,$o),fun(A,$o),aa(fun(A,$o),fun(fun(A,$o),fun(A,$o)),minus_minus(fun(A,$o)),aTP_Lamp_a(set(A),fun(A,$o),A3)),aTP_Lamp_a(set(A),fun(A,$o),B3))) ) ).

% minus_set_def
tff(fact_4438_set__diff__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = collect(A,aa(set(A),fun(A,$o),aTP_Lamp_ae(set(A),fun(set(A),fun(A,$o)),A3),B3)) ) ).

% set_diff_eq
tff(fact_4439_lambda__one,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aTP_Lamp_af(A,A) = aa(A,fun(A,A),times_times(A),one_one(A)) ) ) ).

% lambda_one
tff(fact_4440_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [C2: A] : ( aTP_Lamp_ag(A,fun(A,A),C2) = aa(A,fun(A,A),times_times(A),C2) ) ) ).

% mult_commute_abs
tff(fact_4441_diffs__minus,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [C2: fun(nat,A),X3: nat] : ( aa(nat,A,diffs(A,aTP_Lamp_ah(fun(nat,A),fun(nat,A),C2)),X3) = aa(A,A,uminus_uminus(A),aa(nat,A,diffs(A,C2),X3)) ) ) ).

% diffs_minus
tff(fact_4442_nat__leq__as__int,axiom,
    ! [X3: nat,Xa2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Xa2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(nat,int,semiring_1_of_nat(int),X3)),aa(nat,int,semiring_1_of_nat(int),Xa2)) ) ).

% nat_leq_as_int
tff(fact_4443_nat__less__as__int,axiom,
    ! [X3: nat,Xa2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X3),Xa2)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(nat,int,semiring_1_of_nat(int),X3)),aa(nat,int,semiring_1_of_nat(int),Xa2)) ) ).

% nat_less_as_int
tff(fact_4444_exp__fdiffs,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [X3: nat] : ( aa(nat,A,diffs(A,aTP_Lamp_ai(nat,A)),X3) = aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,X3)) ) ) ).

% exp_fdiffs
tff(fact_4445_Collect__restrict,axiom,
    ! [A: $tType,X6: set(A),P: fun(A,$o)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),X6),P))),X6) ).

% Collect_restrict
tff(fact_4446_prop__restrict,axiom,
    ! [A: $tType,Xa: A,Z6: set(A),X6: set(A),P: fun(A,$o)] :
      ( member(A,Xa,Z6)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Z6),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),X6),P)))
       => aa(A,$o,P,Xa) ) ) ).

% prop_restrict
tff(fact_4447_min__def__raw,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X3: A,Xa2: A] :
          ( aa(A,A,aa(A,fun(A,A),ord_min(A),X3),Xa2)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Xa2),X3,Xa2) ) ) ).

% min_def_raw
tff(fact_4448_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( numeral(A)
     => ! [N: num] :
          ( aa(num,A,numeral_numeral(A),aa(num,num,bit1,N))
          = $let(
              m: A,
              m := aa(num,A,numeral_numeral(A),N),
              aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),m),m)),one_one(A)) ) ) ) ).

% numeral_code(3)
tff(fact_4449_power__numeral__even,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),bit0(W)))
          = $let(
              w: A,
              w := aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),W)),
              aa(A,A,aa(A,fun(A,A),times_times(A),w),w) ) ) ) ).

% power_numeral_even
tff(fact_4450_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Z: A,W: num] :
          ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,W)))
          = $let(
              w: A,
              w := aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(num,nat,numeral_numeral(nat),W)),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),Z),w)),w) ) ) ) ).

% power_numeral_odd
tff(fact_4451_nat__plus__as__int,axiom,
    ! [X3: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X3),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(nat,int,semiring_1_of_nat(int),X3)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_plus_as_int
tff(fact_4452_nat__times__as__int,axiom,
    ! [X3: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),X3),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,semiring_1_of_nat(int),X3)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_times_as_int
tff(fact_4453_nat__minus__as__int,axiom,
    ! [X3: nat,Xa2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),X3),Xa2) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,semiring_1_of_nat(int),X3)),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_minus_as_int
tff(fact_4454_diffs__of__real,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [F3: fun(nat,real),X3: nat] : ( aa(nat,A,diffs(A,aTP_Lamp_aj(fun(nat,real),fun(nat,A),F3)),X3) = real_Vector_of_real(A,aa(nat,real,diffs(real,F3),X3)) ) ) ).

% diffs_of_real
tff(fact_4455_card__less,axiom,
    ! [M7: set(nat),I: nat] :
      ( member(nat,zero_zero(nat),M7)
     => ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ak(set(nat),fun(nat,fun(nat,$o)),M7),I))) != zero_zero(nat) ) ) ).

% card_less
tff(fact_4456_card__less__Suc,axiom,
    ! [M7: set(nat),I: nat] :
      ( member(nat,zero_zero(nat),M7)
     => ( aa(nat,nat,suc,aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_al(set(nat),fun(nat,fun(nat,$o)),M7),I)))) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ak(set(nat),fun(nat,fun(nat,$o)),M7),I))) ) ) ).

% card_less_Suc
tff(fact_4457_card__less__Suc2,axiom,
    ! [M7: set(nat),I: nat] :
      ( ~ member(nat,zero_zero(nat),M7)
     => ( aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_al(set(nat),fun(nat,fun(nat,$o)),M7),I))) = aa(set(nat),nat,finite_card(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ak(set(nat),fun(nat,fun(nat,$o)),M7),I))) ) ) ).

% card_less_Suc2
tff(fact_4458_nat__div__as__int,axiom,
    ! [X3: nat,Xa2: nat] : ( divide_divide(nat,X3,Xa2) = aa(int,nat,nat2,divide_divide(int,aa(nat,int,semiring_1_of_nat(int),X3),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_div_as_int
tff(fact_4459_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ( semiring_1_Nats(A) = collect(A,aTP_Lamp_am(A,$o)) ) ) ).

% Nats_altdef2
tff(fact_4460_nat__mod__as__int,axiom,
    ! [X3: nat,Xa2: nat] : ( modulo_modulo(nat,X3,Xa2) = aa(int,nat,nat2,modulo_modulo(int,aa(nat,int,semiring_1_of_nat(int),X3),aa(nat,int,semiring_1_of_nat(int),Xa2))) ) ).

% nat_mod_as_int
tff(fact_4461_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ( aa(set(complex),nat,finite_card(complex),collect(complex,aa(nat,fun(complex,$o),aTP_Lamp_an(complex,fun(nat,fun(complex,$o)),C2),N))) = N ) ) ) ).

% card_nth_roots
tff(fact_4462_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(set(complex),nat,finite_card(complex),collect(complex,aTP_Lamp_ao(nat,fun(complex,$o),N))) = N ) ) ).

% card_roots_unity_eq
tff(fact_4463_semiring__char__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: itself(A)] : ( semiri4206861660011772517g_char(A,Uu) = gcd_Gcd(nat,collect(nat,aTP_Lamp_ap(nat,$o))) ) ) ).

% semiring_char_def
tff(fact_4464_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),N)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aTP_Lamp_aq(nat,fun(A,$o),N)))),N) ) ) ).

% card_roots_unity
tff(fact_4465_of__nat__code,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] : ( aa(nat,A,semiring_1_of_nat(A),N) = semiri8178284476397505188at_aux(A,aTP_Lamp_ar(A,A),N,zero_zero(A)) ) ) ).

% of_nat_code
tff(fact_4466_diff__nat__eq__if,axiom,
    ! [Z: int,Z5: int] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(int,nat,nat2,Z)),aa(int,nat,nat2,Z5))
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),Z5),zero_zero(int)),
          aa(int,nat,nat2,Z),
          $let(
            d: int,
            d := aa(int,int,aa(int,fun(int,int),minus_minus(int),Z),Z5),
            $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),d),zero_zero(int)),zero_zero(nat),aa(int,nat,nat2,d)) ) ) ) ).

% diff_nat_eq_if
tff(fact_4467_set__decode__def,axiom,
    ! [Xa: nat] : ( nat_set_decode(Xa) = collect(nat,aTP_Lamp_as(nat,fun(nat,$o),Xa)) ) ).

% set_decode_def
tff(fact_4468_quotient__of__denom__pos,axiom,
    ! [R: rat,P2: int,Q2: int] :
      ( ( quotient_of(R) = aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2) ) ).

% quotient_of_denom_pos
tff(fact_4469_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( bit_ri3973907225187159222ations(A)
     => ! [N: nat,A2: A] :
          ( aa(A,A,bit_ri4674362597316999326ke_bit(A,N),A2)
          = $let(
              l: A,
              l := aa(A,A,bit_se2584673776208193580ke_bit(A,aa(nat,nat,suc,N)),A2),
              $ite(aa(nat,$o,bit_se5641148757651400278ts_bit(A,l),N),aa(A,A,aa(A,fun(A,A),plus_plus(A),l),aa(A,A,bit_se4730199178511100633sh_bit(A,aa(nat,nat,suc,N)),aa(A,A,uminus_uminus(A),one_one(A)))),l) ) ) ) ).

% signed_take_bit_code
tff(fact_4470_pochhammer__code,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat] :
          ( comm_s3205402744901411588hammer(A,A2,N)
          = $ite(N = zero_zero(nat),one_one(A),set_fo6178422350223883121st_nat(A,aTP_Lamp_at(A,fun(nat,fun(A,A)),A2),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),one_one(A))) ) ) ).

% pochhammer_code
tff(fact_4471_normalize__denom__pos,axiom,
    ! [R: product_prod(int,int),P2: int,Q2: int] :
      ( ( normalize(R) = aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2) )
     => aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2) ) ).

% normalize_denom_pos
tff(fact_4472_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P2: int,R: int] :
      ( ( Q2 != zero_zero(int) )
     => ( ( S != zero_zero(int) )
       => ( ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2)) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,R),S)) )
         => ( aa(int,int,aa(int,fun(int,int),times_times(int),P2),S) = aa(int,int,aa(int,fun(int,int),times_times(int),R),Q2) ) ) ) ) ).

% normalize_crossproduct
tff(fact_4473_gbinomial__code,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] :
          ( aa(nat,A,gbinomial(A,A2),K)
          = $ite(K = zero_zero(nat),one_one(A),divide_divide(A,set_fo6178422350223883121st_nat(A,aTP_Lamp_au(A,fun(nat,fun(A,A)),A2),zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),one_one(nat)),one_one(A)),semiring_char_0_fact(A,K))) ) ) ).

% gbinomial_code
tff(fact_4474_monoseq__arctan__series,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => topological_monoseq(real,aTP_Lamp_av(real,fun(nat,real),Xa)) ) ).

% monoseq_arctan_series
tff(fact_4475_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Z: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),comm_s3205402744901411588hammer(A,Z,aa(nat,nat,suc,N))),comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_aw(A,fun(nat,A),Z)),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),one_one(nat)))) ) ) ).

% pochhammer_times_pochhammer_half
tff(fact_4476_ln__series,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),aa(num,real,numeral_numeral(real),bit0(one2)))
       => ( aa(real,real,ln_ln(real),Xa) = suminf(real,aTP_Lamp_ax(real,fun(nat,real),Xa)) ) ) ) ).

% ln_series
tff(fact_4477_arctan__series,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => ( aa(real,real,arctan,Xa) = suminf(real,aTP_Lamp_ay(real,fun(nat,real),Xa)) ) ) ).

% arctan_series
tff(fact_4478_predicate1I,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ! [X: A] :
          ( aa(A,$o,P,X)
         => aa(A,$o,Q,X) )
     => aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),P),Q) ) ).

% predicate1I
tff(fact_4479_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(B)
        & ring_1(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => member(B,aa(A,B,F3,X),ring_1_Ints(B)) )
         => member(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3),ring_1_Ints(B)) ) ) ).

% Ints_prod
tff(fact_4480_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F3: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7121269368397514597t_prod(B,nat),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_az(fun(B,nat),fun(B,A),F3)),A3) ) ) ).

% of_nat_prod
tff(fact_4481_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [F3: fun(B,int),A3: set(B)] : ( aa(int,A,ring_1_of_int(A),aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7121269368397514597t_prod(B,int),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_ba(fun(B,int),fun(B,A),F3)),A3) ) ) ).

% of_int_prod
tff(fact_4482_powser__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [F3: fun(nat,A)] : ( suminf(A,aTP_Lamp_bb(fun(nat,A),fun(nat,A),F3)) = aa(nat,A,F3,zero_zero(nat)) ) ) ).

% powser_zero
tff(fact_4483_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),M),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N)))) ) ) ).

% prod.cl_ivl_Suc
tff(fact_4484_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [F3: fun(B,A),A3: set(B)] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),F3),A3))),aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7121269368397514597t_prod(B,real),aTP_Lamp_bc(fun(B,A),fun(B,real),F3)),A3)) ) ).

% norm_prod_le
tff(fact_4485_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R)
     => ~ ! [S3: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),S3)
           => ! [T4: rat] :
                ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),T4)
               => ( R != aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),S3),T4) ) ) ) ) ).

% obtain_pos_sum
tff(fact_4486_rev__predicate1D,axiom,
    ! [A: $tType,P: fun(A,$o),Xa: A,Q: fun(A,$o)] :
      ( aa(A,$o,P,Xa)
     => ( aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),P),Q)
       => aa(A,$o,Q,Xa) ) ) ).

% rev_predicate1D
tff(fact_4487_predicate1D,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o),Xa: A] :
      ( aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),P),Q)
     => ( aa(A,$o,P,Xa)
       => aa(A,$o,Q,Xa) ) ) ).

% predicate1D
tff(fact_4488_less__eq__rat__def,axiom,
    ! [Xa: rat,Y: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),Xa),Y)
    <=> ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),Xa),Y)
        | ( Xa = Y ) ) ) ).

% less_eq_rat_def
tff(fact_4489_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bd(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
tff(fact_4490_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_be(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.shift_bounds_cl_nat_ivl
tff(fact_4491_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_bf(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or1337092689740270186AtMost(nat,N,M)) ) ) ).

% prod.atLeastAtMost_rev
tff(fact_4492_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atLeast0_atMost_Suc
tff(fact_4493_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,aa(nat,nat,suc,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% prod.nat_ivl_Suc'
tff(fact_4494_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% prod.atLeast_Suc_atMost
tff(fact_4495_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bd(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% prod.Suc_reindex_ivl
tff(fact_4496_fact__prod,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_bg(nat,nat)),set_or1337092689740270186AtMost(nat,one_one(nat),N))) ) ) ).

% fact_prod
tff(fact_4497_sin__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,sin(A),X3) = suminf(A,aTP_Lamp_bh(A,fun(nat,A),X3)) ) ) ).

% sin_def
tff(fact_4498_cos__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,cos(A),X3) = suminf(A,aTP_Lamp_bi(A,fun(nat,A),X3)) ) ) ).

% cos_def
tff(fact_4499_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [F3: fun(nat,A),A2: nat,B2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),F3),set_or1337092689740270186AtMost(nat,A2,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_bj(fun(nat,A),fun(nat,fun(A,A)),F3),A2,B2,one_one(A)) ) ) ).

% prod_atLeastAtMost_code
tff(fact_4500_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A),P2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2)))) ) ) ) ).

% prod.ub_add_nat
tff(fact_4501_exp__def,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [X3: A] : ( aa(A,A,exp(A),X3) = suminf(A,aTP_Lamp_bk(A,fun(nat,A),X3)) ) ) ).

% exp_def
tff(fact_4502_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => ( semiring_char_0_fact(nat,M) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),semiring_char_0_fact(nat,N)),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_bg(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M))) ) ) ).

% fact_eq_fact_times
tff(fact_4503_monoseq__realpow,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => topological_monoseq(real,aa(real,fun(nat,real),power_power(real),Xa)) ) ) ).

% monoseq_realpow
tff(fact_4504_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bl(A,fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod
tff(fact_4505_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat] : ( comm_s3205402744901411588hammer(A,A2,N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_bm(A,fun(nat,fun(nat,A)),A2),N)),set_or1337092689740270186AtMost(nat,one_one(nat),N)) ) ) ).

% pochhammer_prod_rev
tff(fact_4506_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => ( divide_divide(nat,semiring_char_0_fact(nat,M),semiring_char_0_fact(nat,N)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_bg(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),M)) ) ) ).

% fact_div_fact
tff(fact_4507_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bn(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.in_pairs
tff(fact_4508_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat] : ( comm_s3205402744901411588hammer(A,A2,aa(nat,nat,suc,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_bm(A,fun(nat,fun(nat,A)),A2),N)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_Suc_prod_rev
tff(fact_4509_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,exp(A),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),suminf(A,aTP_Lamp_bo(A,fun(nat,A),Xa))) ) ) ).

% exp_first_term
tff(fact_4510_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),aa(nat,nat,suc,K)) = divide_divide(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bp(A,fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),K)),semiring_char_0_fact(A,aa(nat,nat,suc,K))) ) ) ).

% gbinomial_Suc
tff(fact_4511_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : ( aa(A,A,exp(A),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),Xa)),suminf(A,aTP_Lamp_bq(A,fun(nat,A),Xa))) ) ) ).

% exp_first_two_terms
tff(fact_4512_pi__series,axiom,
    divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(bit0(one2)))) = suminf(real,aTP_Lamp_br(nat,real)) ).

% pi_series
tff(fact_4513_suminf__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => ( suminf(A,aa(A,fun(nat,A),power_power(A),C2)) = divide_divide(A,one_one(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2)) ) ) ) ).

% suminf_geometric
tff(fact_4514_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty
tff(fact_4515_prod__le__power,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B),N: B,K: nat] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),N) ) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),K)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),N)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),aa(nat,B,aa(B,fun(nat,B),power_power(B),N),K)) ) ) ) ) ).

% prod_le_power
tff(fact_4516_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ( suminf(A,aTP_Lamp_bs(nat,A)) = zero_zero(A) ) ) ).

% suminf_zero
tff(fact_4517_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aTP_Lamp_bt(B,A)),A3) = one_one(A) ) ) ).

% prod.neutral_const
tff(fact_4518_int__prod,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7121269368397514597t_prod(A,nat),F3),A3)) = aa(set(A),int,aa(fun(A,int),fun(set(A),int),groups7121269368397514597t_prod(A,int),aTP_Lamp_bu(fun(A,nat),fun(A,int),F3)),A3) ) ).

% int_prod
tff(fact_4519_prod__int__eq,axiom,
    ! [I: nat,J: nat] : ( aa(set(nat),int,aa(fun(nat,int),fun(set(nat),int),groups7121269368397514597t_prod(nat,int),semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,I,J)) = aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7121269368397514597t_prod(int,int),aTP_Lamp_bv(int,int)),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I),aa(nat,int,semiring_1_of_nat(int),J))) ) ).

% prod_int_eq
tff(fact_4520_prod__int__plus__eq,axiom,
    ! [I: nat,J: nat] : ( aa(set(nat),int,aa(fun(nat,int),fun(set(nat),int),groups7121269368397514597t_prod(nat,int),semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J))) = aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7121269368397514597t_prod(int,int),aTP_Lamp_bv(int,int)),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),I),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J)))) ) ).

% prod_int_plus_eq
tff(fact_4521_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) != one_one(A) )
         => ~ ! [A4: B] :
                ( member(B,A4,A3)
               => ( aa(B,A,G,A4) = one_one(A) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
tff(fact_4522_prod_Oneutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => ( aa(A,B,G,X) = one_one(B) ) )
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = one_one(B) ) ) ) ).

% prod.neutral
tff(fact_4523_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),H: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_bw(fun(B,A),fun(fun(B,A),fun(B,A)),G),H)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H),A3)) ) ) ).

% prod.distrib
tff(fact_4524_prod__nonneg,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)) ) ) ).

% prod_nonneg
tff(fact_4525_prod__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),aa(A,B,G,I2)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)) ) ) ).

% prod_mono
tff(fact_4526_prod__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,X)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)) ) ) ).

% prod_pos
tff(fact_4527_prod__ge__1,axiom,
    ! [B: $tType,A: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F3,X)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)) ) ) ).

% prod_ge_1
tff(fact_4528_prod__le__1,axiom,
    ! [A: $tType,B: $tType] :
      ( linord181362715937106298miring(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X))
                & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),one_one(B)) ) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),one_one(B)) ) ) ).

% prod_le_1
tff(fact_4529_quotient__of__int,axiom,
    ! [A2: int] : ( quotient_of(of_int(A2)) = aa(int,product_prod(int,int),product_Pair(int,int,A2),one_one(int)) ) ).

% quotient_of_int
tff(fact_4530_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2 != zero_zero(complex) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => bij_betw(complex,complex,aa(complex,fun(complex,complex),times_times(complex),aa(complex,complex,aa(complex,fun(complex,complex),times_times(complex),real_Vector_of_real(complex,aa(real,real,root(N),real_V7770717601297561774m_norm(complex,C2)))),cis(divide_divide(real,arg(C2),aa(nat,real,semiring_1_of_nat(real),N))))),collect(complex,aTP_Lamp_ao(nat,fun(complex,$o),N)),collect(complex,aa(nat,fun(complex,$o),aTP_Lamp_an(complex,fun(nat,fun(complex,$o)),C2),N))) ) ) ).

% bij_betw_nth_root_unity
tff(fact_4531_summable__arctan__series,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => summable(real,aTP_Lamp_ay(real,fun(nat,real),Xa)) ) ).

% summable_arctan_series
tff(fact_4532_sin__paired,axiom,
    ! [Xa: real] : sums(real,aTP_Lamp_bx(real,fun(nat,real),Xa),aa(real,real,sin(real),Xa)) ).

% sin_paired
tff(fact_4533_summable__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,aTP_Lamp_by(nat,A)) ) ).

% summable_zero
tff(fact_4534_summable__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I: nat,F3: fun(nat,A)] : summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bz(nat,fun(fun(nat,A),fun(nat,A)),I),F3)) ) ).

% summable_single
tff(fact_4535_sums__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => sums(A,aTP_Lamp_by(nat,A),zero_zero(A)) ) ).

% sums_zero
tff(fact_4536_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),K))
        <=> summable(A,F3) ) ) ).

% summable_iff_shift
tff(fact_4537_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cb(A,fun(fun(nat,A),fun(nat,A)),C2),F3))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F3) ) ) ) ).

% summable_cmult_iff
tff(fact_4538_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cc(fun(nat,A),fun(A,fun(nat,A)),F3),C2))
        <=> ( ( C2 = zero_zero(A) )
            | summable(A,F3) ) ) ) ).

% summable_divide_iff
tff(fact_4539_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: fun(nat,A),Xa: A] :
          ( sums(A,aTP_Lamp_cd(fun(nat,A),fun(nat,A),A2),Xa)
        <=> ( aa(nat,A,A2,zero_zero(nat)) = Xa ) ) ) ).

% powser_sums_zero_iff
tff(fact_4540_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( summable(A,aa(A,fun(nat,A),power_power(A),C2))
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real)) ) ) ).

% summable_geometric_iff
tff(fact_4541_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,F3)
         => summable(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),K)) ) ) ).

% summable_ignore_initial_segment
tff(fact_4542_summable__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ).

% summable_add
tff(fact_4543_sums__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),A2: A,G: fun(nat,A),B2: A] :
          ( sums(A,F3,A2)
         => ( sums(A,G,B2)
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)) ) ) ) ).

% sums_add
tff(fact_4544_summable__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cf(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ).

% summable_diff
tff(fact_4545_sums__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),A2: A,G: fun(nat,A),B2: A] :
          ( sums(A,F3,A2)
         => ( sums(A,G,B2)
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cf(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2)) ) ) ) ).

% sums_diff
tff(fact_4546_sums__single,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [I: nat,F3: fun(nat,A)] : sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bz(nat,fun(fun(nat,A),fun(nat,A)),I),F3),aa(nat,A,F3,I)) ) ).

% sums_single
tff(fact_4547_summable__const__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [C2: A] :
          ( summable(A,aTP_Lamp_cg(A,fun(nat,A),C2))
        <=> ( C2 = zero_zero(A) ) ) ) ).

% summable_const_iff
tff(fact_4548_sums__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A)] :
          ( ! [N2: nat] : ( aa(nat,A,F3,N2) = zero_zero(A) )
         => sums(A,F3,zero_zero(A)) ) ) ).

% sums_0
tff(fact_4549_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [G: fun(nat,real),N6: nat,F3: fun(nat,A)] :
          ( summable(real,G)
         => ( ! [N2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N2)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N2))),aa(nat,real,G,N2)) )
           => summable(A,F3) ) ) ) ).

% summable_comparison_test'
tff(fact_4550_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N2))),aa(nat,real,G,N2)) )
         => ( summable(real,G)
           => summable(A,F3) ) ) ) ).

% summable_comparison_test
tff(fact_4551_sums__le,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),G: fun(nat,A),S: A,T2: A] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N2)),aa(nat,A,G,N2))
         => ( sums(A,F3,S)
           => ( sums(A,G,T2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),S),T2) ) ) ) ) ).

% sums_le
tff(fact_4552_sums__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),A2: A,C2: A] :
          ( sums(A,F3,A2)
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),F3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) ) ) ).

% sums_mult
tff(fact_4553_sums__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),A2: A,C2: A] :
          ( sums(A,F3,A2)
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),F3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)) ) ) ).

% sums_mult2
tff(fact_4554_summable__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ).

% summable_mult
tff(fact_4555_summable__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ).

% summable_mult2
tff(fact_4556_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),F3))
        <=> summable(A,F3) ) ) ).

% summable_Suc_iff
tff(fact_4557_bij__betw__funpow,axiom,
    ! [A: $tType,F3: fun(A,A),S2: set(A),N: nat] :
      ( bij_betw(A,A,F3,S2,S2)
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),S2,S2) ) ).

% bij_betw_funpow
tff(fact_4558_powser__insidea,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A),Xa: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_ck(fun(nat,A),fun(A,fun(nat,A)),F3),Xa))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,Xa))
           => summable(real,aa(A,fun(nat,real),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,real)),F3),Z)) ) ) ) ).

% powser_insidea
tff(fact_4559_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N2)),aa(nat,A,G,N2))
         => ( summable(A,F3)
           => ( summable(A,G)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),suminf(A,F3)),suminf(A,G)) ) ) ) ) ).

% suminf_le
tff(fact_4560_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F3: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cm(A,fun(fun(nat,A),fun(nat,A)),C2),F3),aa(A,A,aa(A,fun(A,A),times_times(A),D2),C2))
          <=> sums(A,F3,D2) ) ) ) ).

% sums_mult2_iff
tff(fact_4561_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [C2: A,F3: fun(nat,A),D2: A] :
          ( ( C2 != zero_zero(A) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cn(A,fun(fun(nat,A),fun(nat,A)),C2),F3),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D2))
          <=> sums(A,F3,D2) ) ) ) ).

% sums_mult_iff
tff(fact_4562_summable__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A)] :
          ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cb(A,fun(fun(nat,A),fun(nat,A)),C2),F3))
         => ( ( C2 != zero_zero(A) )
           => summable(A,F3) ) ) ) ).

% summable_mult_D
tff(fact_4563_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1(A)
        & topolo4958980785337419405_space(A) )
     => summable(A,aa(A,fun(nat,A),power_power(A),zero_zero(A))) ) ).

% summable_zero_power
tff(fact_4564_suminf__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),suminf(A,F3)) ) ) ) ).

% suminf_mult
tff(fact_4565_suminf__mult2,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( summable(A,F3)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,F3)),C2) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),F3),C2)) ) ) ) ).

% suminf_mult2
tff(fact_4566_suminf__add,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,F3)),suminf(A,G)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ) ).

% suminf_add
tff(fact_4567_suminf__diff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( summable(A,F3)
         => ( summable(A,G)
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F3)),suminf(A,G)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cf(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G)) ) ) ) ) ).

% suminf_diff
tff(fact_4568_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),suminf(A,F3)) ) ) ) ).

% suminf_nonneg
tff(fact_4569_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N2))
           => ( ( suminf(A,F3) = zero_zero(A) )
            <=> ! [N5: nat] : ( aa(nat,A,F3,N5) = zero_zero(A) ) ) ) ) ) ).

% suminf_eq_zero_iff
tff(fact_4570_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,N2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F3)) ) ) ) ).

% suminf_pos
tff(fact_4571_sums__mult__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A),A2: A] :
          ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cb(A,fun(fun(nat,A),fun(nat,A)),C2),F3),A2)
         => ( ( C2 != zero_zero(A) )
           => sums(A,F3,divide_divide(A,A2,C2)) ) ) ) ).

% sums_mult_D
tff(fact_4572_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),S: A] :
          ( ( aa(nat,A,F3,zero_zero(nat)) = zero_zero(A) )
         => ( sums(A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),F3),S)
           => sums(A,F3,S) ) ) ) ).

% sums_Suc_imp
tff(fact_4573_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [F3: fun(nat,A),L: A] :
          ( sums(A,aTP_Lamp_co(fun(nat,A),fun(nat,A),F3),L)
         => sums(A,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),L),aa(nat,A,F3,zero_zero(nat)))) ) ) ).

% sums_Suc
tff(fact_4574_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),S: A] :
          ( sums(A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),F3),S)
        <=> sums(A,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(nat,A,F3,zero_zero(nat)))) ) ) ).

% sums_Suc_iff
tff(fact_4575_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [N: nat,F3: fun(nat,A),S: A] :
          ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),N)
             => ( aa(nat,A,F3,I2) = zero_zero(A) ) )
         => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cp(nat,fun(fun(nat,A),fun(nat,A)),N),F3),S)
          <=> sums(A,F3,S) ) ) ) ).

% sums_zero_iff_shift
tff(fact_4576_summable__0__powser,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A)] : summable(A,aTP_Lamp_cd(fun(nat,A),fun(nat,A),F3)) ) ).

% summable_0_powser
tff(fact_4577_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A)] : summable(A,aTP_Lamp_cq(fun(nat,A),fun(nat,A),F3)) ) ).

% summable_zero_power'
tff(fact_4578_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cr(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_ck(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ).

% summable_powser_split_head
tff(fact_4579_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_ct(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ).

% powser_split_head(3)
tff(fact_4580_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [F3: fun(nat,A),M: nat,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_cu(fun(nat,A),fun(nat,fun(A,fun(nat,A))),F3),M),Z))
        <=> summable(A,aa(A,fun(nat,A),aTP_Lamp_ck(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ).

% summable_powser_ignore_initial_segment
tff(fact_4581_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N2))),aa(nat,real,G,N2)) )
         => ( summable(real,G)
           => summable(real,aTP_Lamp_cv(fun(nat,A),fun(nat,real),F3)) ) ) ) ).

% summable_norm_comparison_test
tff(fact_4582_summable__rabs__comparison__test,axiom,
    ! [F3: fun(nat,real),G: fun(nat,real)] :
      ( ? [N8: nat] :
        ! [N2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(nat,real,F3,N2))),aa(nat,real,G,N2)) )
     => ( summable(real,G)
       => summable(real,aTP_Lamp_cw(fun(nat,real),fun(nat,real),F3)) ) ) ).

% summable_rabs_comparison_test
tff(fact_4583_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [G: fun(nat,complex),N6: nat,F3: fun(nat,A)] :
          ( summable(complex,G)
         => ( ! [N2: nat] : member(complex,aa(nat,complex,G,N2),real_Vector_Reals(complex))
           => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),re(aa(nat,complex,G,N2)))
             => ( ! [N2: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N2)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N2))),real_V7770717601297561774m_norm(complex,aa(nat,complex,G,N2))) )
               => summable(A,F3) ) ) ) ) ) ).

% series_comparison_complex
tff(fact_4584_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),Xa: A] :
          ( ! [X: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),X))
         => summable(A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),Xa)) ) ) ).

% termdiff_converges_all
tff(fact_4585_summable__rabs,axiom,
    ! [F3: fun(nat,real)] :
      ( summable(real,aTP_Lamp_cw(fun(nat,real),fun(nat,real),F3))
     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),suminf(real,F3))),suminf(real,aTP_Lamp_cw(fun(nat,real),fun(nat,real),F3))) ) ).

% summable_rabs
tff(fact_4586_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N2))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F3))
            <=> ? [I3: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,I3)) ) ) ) ) ).

% suminf_pos_iff
tff(fact_4587_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),I: nat] :
          ( summable(A,F3)
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N2))
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,I))
             => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),suminf(A,F3)) ) ) ) ) ).

% suminf_pos2
tff(fact_4588_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [C2: fun(nat,A),Xa: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cz(fun(nat,A),fun(A,fun(nat,A)),C2),Xa))
         => sums(A,aa(A,fun(nat,A),aTP_Lamp_da(fun(nat,A),fun(A,fun(nat,A)),C2),Xa),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cz(fun(nat,A),fun(A,fun(nat,A)),C2),Xa))) ) ) ).

% diffs_equiv
tff(fact_4589_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [M: nat,Z: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_db(nat,fun(A,fun(nat,A)),M),Z),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),M)) ) ).

% powser_sums_if
tff(fact_4590_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: fun(nat,A)] : sums(A,aTP_Lamp_cd(fun(nat,A),fun(nat,A),A2),aa(nat,A,A2,zero_zero(nat))) ) ).

% powser_sums_zero
tff(fact_4591_powser__inside,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),Xa: A,Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),F3),Xa))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),real_V7770717601297561774m_norm(A,Xa))
           => summable(A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) ) ) ) ).

% powser_inside
tff(fact_4592_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),one_one(real))
         => summable(A,aa(A,fun(nat,A),power_power(A),Xa)) ) ) ).

% complete_algebra_summable_geometric
tff(fact_4593_summable__geometric,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => summable(A,aa(A,fun(nat,A),power_power(A),C2)) ) ) ).

% summable_geometric
tff(fact_4594_suminf__split__head,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => ( suminf(A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),F3)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F3)),aa(nat,A,F3,zero_zero(nat))) ) ) ) ).

% suminf_split_head
tff(fact_4595_summable__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : summable(A,aTP_Lamp_dc(A,fun(nat,A),Xa)) ) ).

% summable_exp
tff(fact_4596_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : summable(A,aTP_Lamp_bk(A,fun(nat,A),Xa)) ) ).

% summable_exp_generic
tff(fact_4597_sin__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : sums(A,aTP_Lamp_bh(A,fun(nat,A),Xa),aa(A,A,sin(A),Xa)) ) ).

% sin_converges
tff(fact_4598_cos__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : sums(A,aTP_Lamp_bi(A,fun(nat,A),Xa),aa(A,A,cos(A),Xa)) ) ).

% cos_converges
tff(fact_4599_summable__norm,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A)] :
          ( summable(real,aTP_Lamp_dd(fun(nat,A),fun(nat,real),F3))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,suminf(A,F3))),suminf(real,aTP_Lamp_dd(fun(nat,A),fun(nat,real),F3))) ) ) ).

% summable_norm
tff(fact_4600_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : summable(real,aTP_Lamp_de(A,fun(nat,real),Xa)) ) ).

% summable_norm_sin
tff(fact_4601_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : summable(real,aTP_Lamp_df(A,fun(nat,real),Xa)) ) ).

% summable_norm_cos
tff(fact_4602_exp__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : sums(A,aTP_Lamp_bk(A,fun(nat,A),Xa),aa(A,A,exp(A),Xa)) ) ).

% exp_converges
tff(fact_4603_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,K6: real,C2: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),K6)
         => ( ! [X: A] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),K6)
               => summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),X)) )
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dg(A,fun(fun(nat,A),fun(nat,A)),Xa),C2)) ) ) ) ).

% termdiff_converges
tff(fact_4604_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : sums(A,aTP_Lamp_dh(A,fun(nat,A),Xa),aa(A,A,sin(A),Xa)) ) ).

% sin_minus_converges
tff(fact_4605_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : sums(A,aTP_Lamp_di(A,fun(nat,A),Xa),aa(A,A,cos(A),Xa)) ) ).

% cos_minus_converges
tff(fact_4606_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : summable(real,aTP_Lamp_dj(A,fun(nat,real),Xa)) ) ).

% summable_norm_exp
tff(fact_4607_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
         => ( suminf(A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),F3),Z)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,F3,zero_zero(nat))),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_ct(fun(nat,A),fun(A,fun(nat,A)),F3),Z))),Z)) ) ) ) ).

% powser_split_head(1)
tff(fact_4608_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(nat,A),Z: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),F3),Z))
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_ct(fun(nat,A),fun(A,fun(nat,A)),F3),Z))),Z) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),F3),Z))),aa(nat,A,F3,zero_zero(nat))) ) ) ) ).

% powser_split_head(2)
tff(fact_4609_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R: real,F3: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
         => ( summable(A,F3)
           => ? [N9: nat] :
              ! [N3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N9),N3)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,suminf(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),N3)))),R) ) ) ) ) ).

% suminf_exist_split
tff(fact_4610_summable__power__series,axiom,
    ! [F3: fun(nat,real),Z: real] :
      ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,I2)),one_one(real))
     => ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,I2))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Z)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z),one_one(real))
           => summable(real,aa(real,fun(nat,real),aTP_Lamp_dk(fun(nat,real),fun(real,fun(nat,real)),F3),Z)) ) ) ) ) ).

% summable_power_series
tff(fact_4611_Abel__lemma,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [R: real,R0: real,A2: fun(nat,A),M7: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),R)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),R),R0)
           => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,A2,N2))),aa(nat,real,aa(real,fun(nat,real),power_power(real),R0),N2))),M7)
             => summable(real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_dl(real,fun(fun(nat,A),fun(nat,real)),R),A2)) ) ) ) ) ).

% Abel_lemma
tff(fact_4612_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [C2: real,N6: nat,F3: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),one_one(real))
         => ( ! [N2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N2)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,aa(nat,nat,suc,N2)))),aa(real,real,aa(real,fun(real,real),times_times(real),C2),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N2)))) )
           => summable(A,F3) ) ) ) ).

% summable_ratio_test
tff(fact_4613_geometric__sums,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,C2)),one_one(real))
         => sums(A,aa(A,fun(nat,A),power_power(A),C2),divide_divide(A,one_one(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),C2))) ) ) ).

% geometric_sums
tff(fact_4614_power__half__series,axiom,
    sums(real,aTP_Lamp_dm(nat,real),one_one(real)) ).

% power_half_series
tff(fact_4615_sums__if_H,axiom,
    ! [G: fun(nat,real),Xa: real] :
      ( sums(real,G,Xa)
     => sums(real,aTP_Lamp_dn(fun(nat,real),fun(nat,real),G),Xa) ) ).

% sums_if'
tff(fact_4616_sums__if,axiom,
    ! [G: fun(nat,real),Xa: real,F3: fun(nat,real),Y: real] :
      ( sums(real,G,Xa)
     => ( sums(real,F3,Y)
       => sums(real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_do(fun(nat,real),fun(fun(nat,real),fun(nat,real)),G),F3),aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),Y)) ) ) ).

% sums_if
tff(fact_4617_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : sums(A,aTP_Lamp_dp(A,fun(nat,A),Xa),aa(A,A,cosh(A),Xa)) ) ).

% cosh_converges
tff(fact_4618_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A] : sums(A,aTP_Lamp_dq(A,fun(nat,A),Xa),aa(A,A,sinh(A),Xa)) ) ).

% sinh_converges
tff(fact_4619_cos__paired,axiom,
    ! [Xa: real] : sums(real,aTP_Lamp_dr(real,fun(nat,real),Xa),aa(real,real,cos(real),Xa)) ).

% cos_paired
tff(fact_4620_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),one_one(real))
         => sums(A,aTP_Lamp_ds(A,fun(nat,A),Z),divide_divide(A,one_one(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Z)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% geometric_deriv_sums
tff(fact_4621_sum__gp,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [Xa: A,M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_or1337092689740270186AtMost(nat,M,N))
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M),
              zero_zero(A),
              $ite(Xa = one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),M)),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(nat,nat,suc,N))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa))) ) ) ) ).

% sum_gp
tff(fact_4622_monoseq__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( topological_monoseq(A,X6)
        <=> ( ! [M6: nat,N5: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M6),N5)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,M6)),aa(nat,A,X6,N5)) )
            | ! [M6: nat,N5: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M6),N5)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N5)),aa(nat,A,X6,M6)) ) ) ) ) ).

% monoseq_def
tff(fact_4623_monoI2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( ! [M2: nat,N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N2)),aa(nat,A,X6,M2)) )
         => topological_monoseq(A,X6) ) ) ).

% monoI2
tff(fact_4624_monoI1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( ! [M2: nat,N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,M2)),aa(nat,A,X6,N2)) )
         => topological_monoseq(A,X6) ) ) ).

% monoI1
tff(fact_4625_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => member(B,aa(A,B,F3,X),ring_1_Ints(B)) )
         => member(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3),ring_1_Ints(B)) ) ) ).

% Ints_sum
tff(fact_4626_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_dt(B,A)),A3) = zero_zero(A) ) ) ).

% sum.neutral_const
tff(fact_4627_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [F3: fun(B,nat),A3: set(B)] : ( aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,aa(fun(B,nat),fun(set(B),nat),groups7311177749621191930dd_sum(B,nat),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_du(fun(B,nat),fun(B,A),F3)),A3) ) ) ).

% of_nat_sum
tff(fact_4628_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [F3: fun(B,int),A3: set(B)] : ( aa(int,A,ring_1_of_int(A),aa(set(B),int,aa(fun(B,int),fun(set(B),int),groups7311177749621191930dd_sum(B,int),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_dv(fun(B,int),fun(B,A),F3)),A3) ) ) ).

% of_int_sum
tff(fact_4629_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty
tff(fact_4630_sum__abs,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [F3: fun(B,A),A3: set(B)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_dw(fun(B,A),fun(B,A),F3)),A3)) ) ).

% sum_abs
tff(fact_4631_sum__abs__ge__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [F3: fun(B,A),A3: set(B)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_dw(fun(B,A),fun(B,A),F3)),A3)) ) ).

% sum_abs_ge_zero
tff(fact_4632_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Y: A,A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aTP_Lamp_dx(A,fun(B,A),Y)),A3) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(B),nat,finite_card(B),A3))),Y) ) ) ).

% sum_constant
tff(fact_4633_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),M),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N)))) ) ) ).

% sum.cl_ivl_Suc
tff(fact_4634_sum__product,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(C,A),B3: set(C)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)),aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),G),B3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_dz(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F3),G),B3)),A3) ) ) ).

% sum_product
tff(fact_4635_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [F3: fun(B,A),A3: set(B),R: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)),R) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(A,fun(B,A),aTP_Lamp_ea(fun(B,A),fun(A,fun(B,A)),F3),R)),A3) ) ) ).

% sum_distrib_right
tff(fact_4636_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [R: A,F3: fun(B,A),A3: set(B)] : ( aa(A,A,aa(A,fun(A,A),times_times(A),R),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_eb(A,fun(fun(B,A),fun(B,A)),R),F3)),A3) ) ) ).

% sum_distrib_left
tff(fact_4637_sum__norm__le,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [S2: set(A),F3: fun(A,B),G: fun(A,real)] :
          ( ! [X: A] :
              ( member(A,X,S2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X))),aa(A,real,G,X)) )
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),S2))),aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),G),S2)) ) ) ).

% sum_norm_le
tff(fact_4638_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A3: set(B)] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) != zero_zero(A) )
         => ~ ! [A4: B] :
                ( member(B,A4,A3)
               => ( aa(B,A,G,A4) = zero_zero(A) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
tff(fact_4639_sum_Oneutral,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => ( aa(A,B,G,X) = zero_zero(B) ) )
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = zero_zero(B) ) ) ) ).

% sum.neutral
tff(fact_4640_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(B,A),G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_ec(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G)),A3) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)) ) ) ).

% sum_subtractf
tff(fact_4641_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),H: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(fun(B,A),fun(B,A),aTP_Lamp_ed(fun(B,A),fun(fun(B,A),fun(B,A)),G),H)),A3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),A3)) ) ) ).

% sum.distrib
tff(fact_4642_sum__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [K6: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [I2: A] :
              ( member(A,I2,K6)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),aa(A,B,G,I2)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),K6)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),K6)) ) ) ).

% sum_mono
tff(fact_4643_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(B,A),A3: set(B)] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),A3))),aa(set(B),real,aa(fun(B,real),fun(set(B),real),groups7311177749621191930dd_sum(B,real),aTP_Lamp_ee(fun(B,A),fun(B,real),F3)),A3)) ) ).

% norm_sum
tff(fact_4644_sum__nonpos,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),zero_zero(B)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),zero_zero(B)) ) ) ).

% sum_nonpos
tff(fact_4645_sum__nonneg,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)) ) ) ).

% sum_nonneg
tff(fact_4646_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A3: set(nat),F3: fun(nat,A),G: fun(nat,A)] :
          ( ~ member(nat,zero_zero(nat),A3)
         => ( ! [X: nat] :
                ( member(nat,aa(nat,nat,suc,X),A3)
               => ( aa(nat,A,F3,aa(nat,nat,suc,X)) = aa(nat,A,G,aa(nat,nat,suc,X)) ) )
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),A3) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),A3) ) ) ) ) ).

% sum_cong_Suc
tff(fact_4647_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
tff(fact_4648_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_eg(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.shift_bounds_cl_nat_ivl
tff(fact_4649_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Xa: A,M: nat,I5: set(nat)] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_eh(A,fun(nat,fun(nat,A)),Xa),M)),I5) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),I5)) ) ) ).

% sum_power_add
tff(fact_4650_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ei(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or1337092689740270186AtMost(nat,N,M)) ) ) ).

% sum.atLeastAtMost_rev
tff(fact_4651_sum__bounded__above,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [A3: set(A),F3: fun(A,B),K6: B] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),K6) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(set(A),nat,finite_card(A),A3))),K6)) ) ) ).

% sum_bounded_above
tff(fact_4652_sum__bounded__below,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [A3: set(A),K6: B,F3: fun(A,B)] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),K6),aa(A,B,F3,I2)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(set(A),nat,finite_card(A),A3))),K6)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)) ) ) ).

% sum_bounded_below
tff(fact_4653_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F3,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0
tff(fact_4654_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% sum.atLeast0_atMost_Suc
tff(fact_4655_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% sum.atLeast_Suc_atMost
tff(fact_4656_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,aa(nat,nat,suc,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% sum.nat_ivl_Suc'
tff(fact_4657_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(nat,A,G,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N))) ) ) ) ).

% sum.Suc_reindex_ivl
tff(fact_4658_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,F3: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,suc,N))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ej(fun(nat,A),fun(nat,A),F3)),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,aa(nat,nat,suc,N))),aa(nat,A,F3,M)) ) ) ) ).

% sum_Suc_diff
tff(fact_4659_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),A2: nat,B2: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,A2,B2)) = set_fo6178422350223883121st_nat(A,aTP_Lamp_ek(fun(nat,A),fun(nat,fun(A,A)),F3),A2,B2,zero_zero(A)) ) ) ).

% sum_atLeastAtMost_code
tff(fact_4660_sum__norm__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [S2: set(A),F3: fun(A,B),K6: real] :
          ( ! [X: A] :
              ( member(A,X,S2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X))),K6) )
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),S2))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),aa(set(A),nat,finite_card(A),S2))),K6)) ) ) ).

% sum_norm_bound
tff(fact_4661_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A),P2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),P2)))) ) ) ) ).

% sum.ub_add_nat
tff(fact_4662_sum__bounded__above__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere8940638589300402666id_add(B)
        & semiring_1(B) )
     => ! [A3: set(A),F3: fun(A,B),K6: B] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,I2)),K6) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A3))
           => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),aa(set(A),nat,finite_card(A),A3))),K6)) ) ) ) ).

% sum_bounded_above_strict
tff(fact_4663_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),Xa: fun(A,B),A2: fun(A,B),B2: B,Delta: B] :
          ( ! [I2: A] :
              ( member(A,I2,I5)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,Xa,I2)) )
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),Xa),I5) = one_one(B) )
           => ( ! [I2: A] :
                  ( member(A,I2,I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,A2,I2)),B2))),Delta) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,abs_abs(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_el(fun(A,B),fun(fun(A,B),fun(A,B)),Xa),A2)),I5)),B2))),Delta) ) ) ) ) ).

% convex_sum_bound_le
tff(fact_4664_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_em(fun(nat,A),fun(nat,A),F3)),set_or1337092689740270186AtMost(nat,M,N))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,M)),aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))),zero_zero(A)) ) ) ).

% sum_natinterval_diff
tff(fact_4665_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,F3: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_en(fun(nat,A),fun(nat,A),F3)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,N)),aa(nat,A,F3,M)) ) ) ) ).

% sum_telescope''
tff(fact_4666_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),E: real] :
          ( summable(A,F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
           => ~ ! [N9: nat] :
                  ~ ! [M3: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N9),M3)
                     => ! [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,M3,N3)))),E) ) ) ) ) ).

% summable_partial_sum_bound
tff(fact_4667_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( semiring_parity(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N)),one_one(A)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2)))),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_eo(nat,fun(nat,$o)),N))) ) ) ).

% mask_eq_sum_exp
tff(fact_4668_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M: nat,N: nat,Xa: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_or1337092689740270186AtMost(nat,M,N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(nat,nat,suc,N))) ) ) ) ).

% sum_gp_multiplied
tff(fact_4669_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ep(fun(nat,A),fun(nat,A),G)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.in_pairs
tff(fact_4670_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),aa(nat,nat,suc,zero_zero(nat))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2)))),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_eo(nat,fun(nat,$o)),N))) ) ).

% mask_eq_sum_exp_nat
tff(fact_4671_gauss__sum__nat,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_bg(nat,nat)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,suc,N)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% gauss_sum_nat
tff(fact_4672_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eq(nat,fun(nat,A),K)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),one_one(nat))) ) ) ).

% gbinomial_sum_up_index
tff(fact_4673_double__arith__series,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,D2: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_er(A,fun(A,fun(nat,A)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D2))) ) ) ).

% double_arith_series
tff(fact_4674_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum
tff(fact_4675_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_es(nat,fun(nat,fun(nat,nat)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,N)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),A2)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),D2))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% arith_series_nat
tff(fact_4676_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_bg(nat,nat)),set_or1337092689740270186AtMost(nat,M,N)) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat)))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% Sum_Icc_nat
tff(fact_4677_arith__series,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A,D2: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_et(A,fun(A,fun(nat,A)),A2),D2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),A2)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),D2))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% arith_series
tff(fact_4678_gauss__sum,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% gauss_sum
tff(fact_4679_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))) ) ) ).

% double_gauss_sum_from_Suc_0
tff(fact_4680_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [Xa: A,M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_or1337092689740270186AtMost(nat,M,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)))
          = $ite(Xa = one_one(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A)),divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(nat,nat,suc,N)))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa))) ) ) ).

% sum_gp_offset
tff(fact_4681_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),semiring_1_of_nat(A)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),N)),one_one(A))),aa(num,A,numeral_numeral(A),bit0(one2))) ) ) ).

% gauss_sum_from_Suc_0
tff(fact_4682_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [R: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eu(A,fun(nat,A),R)),set_or1337092689740270186AtMost(nat,zero_zero(nat),M)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,M)),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,A,gbinomial(A,R),aa(nat,nat,suc,M))) ) ) ).

% gchoose_row_sum_weighted
tff(fact_4683_mono__SucI1,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N2)),aa(nat,A,X6,aa(nat,nat,suc,N2)))
         => topological_monoseq(A,X6) ) ) ).

% mono_SucI1
tff(fact_4684_mono__SucI2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,aa(nat,nat,suc,N2))),aa(nat,A,X6,N2))
         => topological_monoseq(A,X6) ) ) ).

% mono_SucI2
tff(fact_4685_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( topological_monoseq(A,X6)
        <=> ( ! [N5: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N5)),aa(nat,A,X6,aa(nat,nat,suc,N5)))
            | ! [N5: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,aa(nat,nat,suc,N5))),aa(nat,A,X6,N5)) ) ) ) ).

% monoseq_Suc
tff(fact_4686_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_ew(A,fun(A,fun(nat,A)),Xa),Y),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sin(A),Xa)),aa(A,A,sin(A),Y))) ) ).

% sin_x_sin_y
tff(fact_4687_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_ey(A,fun(A,fun(nat,A)),Xa),Y),aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y))) ) ).

% sums_cos_x_plus_y
tff(fact_4688_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,Y: A] : sums(A,aa(A,fun(nat,A),aTP_Lamp_fa(A,fun(A,fun(nat,A)),Xa),Y),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),Xa)),aa(A,A,cos(A),Y))) ) ).

% cos_x_cos_y
tff(fact_4689_atMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,K: A] :
          ( member(A,I,set_ord_atMost(A,K))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),K) ) ) ).

% atMost_iff
tff(fact_4690_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atMost(A,Xa)),set_ord_atMost(A,Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ).

% atMost_subset_iff
tff(fact_4691_card__atMost,axiom,
    ! [U: nat] : ( aa(set(nat),nat,finite_card(nat),set_ord_atMost(nat,U)) = aa(nat,nat,suc,U) ) ).

% card_atMost
tff(fact_4692_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [L: A,H: A,H2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,L,H)),set_ord_atMost(A,H2))
        <=> ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),H)
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),H),H2) ) ) ) ).

% Icc_subset_Iic_iff
tff(fact_4693_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% sum.atMost_Suc
tff(fact_4694_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,N))),aa(nat,A,G,aa(nat,nat,suc,N))) ) ) ).

% prod.atMost_Suc
tff(fact_4695_atMost__0,axiom,
    set_ord_atMost(nat,zero_zero(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))) ).

% atMost_0
tff(fact_4696_Complex__sum_H,axiom,
    ! [A: $tType,F3: fun(A,real),S: set(A)] : ( aa(set(A),complex,aa(fun(A,complex),fun(set(A),complex),groups7311177749621191930dd_sum(A,complex),aTP_Lamp_fb(fun(A,real),fun(A,complex),F3)),S) = complex2(aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),F3),S),zero_zero(real)) ) ).

% Complex_sum'
tff(fact_4697_int__sum,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A)] : ( aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)) = aa(set(A),int,aa(fun(A,int),fun(set(A),int),groups7311177749621191930dd_sum(A,int),aTP_Lamp_bu(fun(A,nat),fun(A,int),F3)),A3) ) ).

% int_sum
tff(fact_4698_atMost__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [U: A] : ( set_ord_atMost(A,U) = collect(A,aTP_Lamp_fc(A,fun(A,$o),U)) ) ) ).

% atMost_def
tff(fact_4699_atMost__atLeast0,axiom,
    ! [N: nat] : ( set_ord_atMost(nat,N) = set_or1337092689740270186AtMost(nat,zero_zero(nat),N) ) ).

% atMost_atLeast0
tff(fact_4700_atMost__Suc,axiom,
    ! [K: nat] : ( set_ord_atMost(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),set_ord_atMost(nat,K)) ) ).

% atMost_Suc
tff(fact_4701_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [H: A,L3: A,H2: A] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atMost(A,H)),set_or1337092689740270186AtMost(A,L3,H2)) ) ).

% not_Iic_le_Icc
tff(fact_4702_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set(A),G: fun(A,nat),F3: fun(A,nat)] :
      ( ! [X: A] :
          ( member(A,X,A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,G,X)),aa(A,nat,F3,X)) )
     => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_fd(fun(A,nat),fun(fun(A,nat),fun(A,nat)),G),F3)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),G),A3)) ) ) ).

% sum_subtractf_nat
tff(fact_4703_card__eq__sum,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),nat,finite_card(A),A3) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_fe(A,nat)),A3) ) ).

% card_eq_sum
tff(fact_4704_sum__choose__upper,axiom,
    ! [M: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_ff(nat,fun(nat,nat),M)),set_ord_atMost(nat,N)) = aa(nat,nat,binomial(aa(nat,nat,suc,N)),aa(nat,nat,suc,M)) ) ).

% sum_choose_upper
tff(fact_4705_sum__SucD,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A),N: nat] :
      ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3) = aa(nat,nat,suc,N) )
     => ? [X: A] :
          ( member(A,X,A3)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,F3,X)) ) ) ).

% sum_SucD
tff(fact_4706_sum__Suc,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A)] : ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_fg(fun(A,nat),fun(A,nat),F3)),A3) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(set(A),nat,finite_card(A),A3)) ) ).

% sum_Suc
tff(fact_4707_real__of__card,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(nat,real,semiring_1_of_nat(real),aa(set(A),nat,finite_card(A),A3)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_fh(A,real)),A3) ) ).

% real_of_card
tff(fact_4708_sum__choose__lower,axiom,
    ! [R: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fi(nat,fun(nat,nat),R)),set_ord_atMost(nat,N)) = aa(nat,nat,binomial(aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),R),N))),N) ) ).

% sum_choose_lower
tff(fact_4709_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fj(nat,fun(nat,nat),N)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),one_one(nat))),M) ) ).

% choose_rising_sum(2)
tff(fact_4710_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fj(nat,fun(nat,nat),N)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))) ) ).

% choose_rising_sum(1)
tff(fact_4711_sum__diff1__nat,axiom,
    ! [A: $tType,F3: fun(A,nat),A3: set(A),A2: A] :
      ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))
      = $ite(member(A,A2,A3),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(A,nat,F3,A2)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)) ) ).

% sum_diff1_nat
tff(fact_4712_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N))) ) ) ).

% sum.atMost_Suc_shift
tff(fact_4713_sum__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),I: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fk(fun(nat,A),fun(nat,A),F3)),set_ord_atMost(nat,I)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,zero_zero(nat))),aa(nat,A,F3,aa(nat,nat,suc,I))) ) ) ).

% sum_telescope
tff(fact_4714_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat,D2: fun(nat,A)] :
          ( ! [X4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fl(fun(nat,A),fun(A,fun(nat,A)),C2),X4)),set_ord_atMost(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fl(fun(nat,A),fun(A,fun(nat,A)),D2),X4)),set_ord_atMost(nat,N)) )
        <=> ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),N)
             => ( aa(nat,A,C2,I3) = aa(nat,A,D2,I3) ) ) ) ) ).

% polyfun_eq_coeffs
tff(fact_4715_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linord2810124833399127020strict(A)
        & topolo1944317154257567458pology(A) )
     => ! [A2: fun(nat,A),B3: A] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,A2,N2))
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A2),set_ord_atMost(nat,N2))),B3)
           => summable(A,A2) ) ) ) ).

% bounded_imp_summable
tff(fact_4716_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bd(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N))) ) ) ).

% prod.atMost_Suc_shift
tff(fact_4717_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_fm(nat,fun(nat,fun(nat,nat)),M),N)),set_ord_atMost(nat,M)) = aa(nat,nat,binomial(aa(nat,nat,suc,N)),M) ) ) ).

% sum_choose_diagonal
tff(fact_4718_vandermonde,axiom,
    ! [M: nat,N: nat,R: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_fn(nat,fun(nat,fun(nat,fun(nat,nat))),M),N),R)),set_ord_atMost(nat,R)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),R) ) ).

% vandermonde
tff(fact_4719_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),N)
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_fo(complex,complex)),collect(complex,aa(complex,fun(complex,$o),aTP_Lamp_fp(nat,fun(complex,fun(complex,$o)),N),C2))) = zero_zero(complex) ) ) ).

% sum_nth_roots
tff(fact_4720_norm__prod__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [I5: set(A),Z: fun(A,B),W: fun(A,B)] :
          ( ! [I2: A] :
              ( member(A,I2,I5)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,Z,I2))),one_one(real)) )
         => ( ! [I2: A] :
                ( member(A,I2,I5)
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,W,I2))),one_one(real)) )
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),Z),I5)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),W),I5)))),aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aa(fun(A,B),fun(A,real),aTP_Lamp_fq(fun(A,B),fun(fun(A,B),fun(A,real)),Z),W)),I5)) ) ) ) ).

% norm_prod_diff
tff(fact_4721_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [C2: fun(nat,A),N: nat,K: nat] :
          ( ! [W2: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fr(fun(nat,A),fun(A,fun(nat,A)),C2),W2)),set_ord_atMost(nat,N)) = zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
           => ( aa(nat,A,C2,K) = zero_zero(A) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
tff(fact_4722_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat] :
          ( ! [X4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fl(fun(nat,A),fun(A,fun(nat,A)),C2),X4)),set_ord_atMost(nat,N)) = zero_zero(A) )
        <=> ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),N)
             => ( aa(nat,A,C2,I3) = zero_zero(A) ) ) ) ) ).

% polyfun_eq_0
tff(fact_4723_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_atMost(nat,M))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)))) ) ) ).

% sum_up_index_split
tff(fact_4724_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fs(A,fun(nat,A),A2)),set_ord_atMost(nat,N)) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),aa(nat,A,semiring_1_of_nat(A),N))),one_one(A))),N) ) ) ).

% gbinomial_parallel_sum
tff(fact_4725_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atMost(nat,N)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_atMost_eq_remove0
tff(fact_4726_binomial,axiom,
    ! [A2: nat,B2: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),B2)),N) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_ft(nat,fun(nat,fun(nat,fun(nat,nat))),A2),B2),N)),set_ord_atMost(nat,N)) ) ).

% binomial
tff(fact_4727_sum__roots__unity,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),N)
     => ( aa(set(complex),complex,aa(fun(complex,complex),fun(set(complex),complex),groups7311177749621191930dd_sum(complex,complex),aTP_Lamp_fo(complex,complex)),collect(complex,aTP_Lamp_ao(nat,fun(complex,$o),N))) = zero_zero(complex) ) ) ).

% sum_roots_unity
tff(fact_4728_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_ord_atMost(nat,N))) = aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(nat,nat,suc,N))) ) ) ).

% sum_gp_basic
tff(fact_4729_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,N: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_fu(fun(nat,A),fun(nat,fun(A,$o)),C2),N)))),N) ) ) ) ).

% polyfun_roots_card
tff(fact_4730_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [M: nat,N: nat,Xa: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)))) ) ) ) ).

% sum_power_shift
tff(fact_4731_polynomial__product__nat,axiom,
    ! [M: nat,A2: fun(nat,nat),N: nat,B2: fun(nat,nat),Xa: nat] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),I2)
         => ( aa(nat,nat,A2,I2) = zero_zero(nat) ) )
     => ( ! [J2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),J2)
           => ( aa(nat,nat,B2,J2) = zero_zero(nat) ) )
       => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_fv(fun(nat,nat),fun(nat,fun(nat,nat)),A2),Xa)),set_ord_atMost(nat,M))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aTP_Lamp_fv(fun(nat,nat),fun(nat,fun(nat,nat)),B2),Xa)),set_ord_atMost(nat,N))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_fx(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),A2),B2),Xa)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ) ) ) ).

% polynomial_product_nat
tff(fact_4732_choose__square__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_fy(nat,fun(nat,nat),N)),set_ord_atMost(nat,N)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),N) ) ).

% choose_square_sum
tff(fact_4733_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_fz(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_fz(fun(nat,A),fun(nat,real),B2))
           => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_gb(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)) ) ) ) ).

% summable_Cauchy_product
tff(fact_4734_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_fz(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_fz(fun(nat,A),fun(nat,real),B2))
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A2)),suminf(A,B2)) = suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_gb(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)) ) ) ) ) ).

% Cauchy_product
tff(fact_4735_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ep(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N)) ) ) ).

% sum.in_pairs_0
tff(fact_4736_polynomial__product,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [M: nat,A2: fun(nat,A),N: nat,B2: fun(nat,A),Xa: A] :
          ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),I2)
             => ( aa(nat,A,A2,I2) = zero_zero(A) ) )
         => ( ! [J2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),J2)
               => ( aa(nat,A,B2,J2) = zero_zero(A) ) )
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),A2),Xa)),set_ord_atMost(nat,M))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),B2),Xa)),set_ord_atMost(nat,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_ge(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),A2),B2),Xa)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N))) ) ) ) ) ).

% polynomial_product
tff(fact_4737_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bn(fun(nat,A),fun(nat,A),G)),set_ord_atMost(nat,N)) ) ) ).

% prod.in_pairs_0
tff(fact_4738_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat,K: A] :
          ( ! [X4: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fl(fun(nat,A),fun(A,fun(nat,A)),C2),X4)),set_ord_atMost(nat,N)) = K )
        <=> ( ( aa(nat,A,C2,zero_zero(nat)) = K )
            & ! [X4: nat] :
                ( member(nat,X4,set_or1337092689740270186AtMost(nat,one_one(nat),N))
               => ( aa(nat,A,C2,X4) = zero_zero(A) ) ) ) ) ) ).

% polyfun_eq_const
tff(fact_4739_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gf(A,fun(nat,A),A2)),set_ord_atMost(nat,M)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),M)),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))),M)) ) ) ).

% gbinomial_sum_lower_neg
tff(fact_4740_binomial__ring,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,B2: A,N: nat] : ( aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gg(A,fun(A,fun(nat,fun(nat,A))),A2),B2),N)),set_ord_atMost(nat,N)) ) ) ).

% binomial_ring
tff(fact_4741_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [A2: A,B2: A,N: nat] : ( comm_s3205402744901411588hammer(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gh(A,fun(A,fun(nat,fun(nat,A))),A2),B2),N)),set_ord_atMost(nat,N)) ) ) ).

% pochhammer_binomial_sum
tff(fact_4742_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [A2: fun(nat,A),B2: fun(nat,A)] :
          ( summable(real,aTP_Lamp_fz(fun(nat,A),fun(nat,real),A2))
         => ( summable(real,aTP_Lamp_fz(fun(nat,A),fun(nat,real),B2))
           => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_gb(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2),aa(A,A,aa(A,fun(A,A),times_times(A),suminf(A,A2)),suminf(A,B2))) ) ) ) ).

% Cauchy_product_sums
tff(fact_4743_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P2)
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gi(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,P2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gj(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P2),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% sum.zero_middle
tff(fact_4744_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,A2: A,Xa: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gk(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),Xa),Y)),set_ord_atMost(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gl(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),Xa),Y)),set_ord_atMost(nat,M)) ) ) ).

% gbinomial_partial_sum_poly
tff(fact_4745_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P2: nat,K: nat,G: fun(nat,A),H: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),P2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),P2)
           => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gm(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,P2)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gn(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),K),G),H)),set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),P2),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ) ).

% prod.zero_middle
tff(fact_4746_binomial__r__part__sum,axiom,
    ! [M: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)),one_one(nat)))),set_ord_atMost(nat,M)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)) ) ).

% binomial_r_part_sum
tff(fact_4747_choose__linear__sum,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_go(nat,fun(nat,nat),N)),set_ord_atMost(nat,N)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ).

% choose_linear_sum
tff(fact_4748_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A,Y: A,N: nat] :
          ( ( aa(A,A,aa(A,fun(A,A),times_times(A),Xa),Y) = aa(A,A,aa(A,fun(A,A),times_times(A),Y),Xa) )
         => ( aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gp(A,fun(A,fun(nat,fun(nat,A))),Xa),Y),N)),set_ord_atMost(nat,N)) ) ) ) ).

% exp_series_add_commuting
tff(fact_4749_root__polyfun,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,Z: A,A2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),N)
         => ( ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),N) = A2 )
          <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_gq(nat,fun(A,fun(A,fun(nat,A))),N),Z),A2)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ) ).

% root_polyfun
tff(fact_4750_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_ord_atMost(nat,N))
          = $ite(Xa = one_one(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat))),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(nat,nat,suc,N))),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa))) ) ) ).

% sum_gp0
tff(fact_4751_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( ( N != one_one(nat) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gr(nat,fun(nat,A),N)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ).

% choose_alternating_linear_sum
tff(fact_4752_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gs(nat,fun(nat,A),M)),set_ord_atMost(nat,M)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),M) ) ) ).

% gbinomial_sum_nat_pow2
tff(fact_4753_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat,A2: A,Xa: A,Y: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gk(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),Xa),Y)),set_ord_atMost(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gt(nat,fun(A,fun(A,fun(A,fun(nat,A)))),M),A2),Xa),Y)),set_ord_atMost(nat,M)) ) ) ).

% gbinomial_partial_sum_poly_xpos
tff(fact_4754_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gu(nat,fun(nat,A),N)),set_ord_atMost(nat,N)) = zero_zero(A) ) ) ) ).

% choose_alternating_sum
tff(fact_4755_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [E: real,C2: fun(nat,A),N: nat] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
         => ? [M10: real] :
            ! [Z3: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),M10),real_V7770717601297561774m_norm(A,Z3))
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ck(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,N)))),aa(real,real,aa(real,fun(real,real),times_times(real),E),aa(nat,real,aa(real,fun(nat,real),power_power(real),real_V7770717601297561774m_norm(A,Z3)),aa(nat,nat,suc,N)))) ) ) ) ).

% polyfun_extremal_lemma
tff(fact_4756_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M),N)
     => ( aa(set(int),int,aa(fun(int,int),fun(set(int),int),groups7311177749621191930dd_sum(int,int),aTP_Lamp_bv(int,int)),set_or1337092689740270186AtMost(int,M,N)) = divide_divide(int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),N),aa(int,int,aa(int,fun(int,int),plus_plus(int),N),one_one(int)))),aa(int,int,aa(int,fun(int,int),times_times(int),M),aa(int,int,aa(int,fun(int,int),minus_minus(int),M),one_one(int)))),aa(num,int,numeral_numeral(int),bit0(one2))) ) ) ).

% Sum_Icc_int
tff(fact_4757_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,A,semiring_1_of_nat(A),M))),one_one(A)))),set_ord_atMost(nat,M)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M)) ) ) ).

% gbinomial_r_part_sum
tff(fact_4758_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gv(nat,fun(nat,A),N)),set_ord_atMost(nat,N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) ) ) ) ).

% choose_odd_sum
tff(fact_4759_choose__even__sum,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
         => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_gw(nat,fun(nat,A),N)),set_ord_atMost(nat,N))) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),N) ) ) ) ).

% choose_even_sum
tff(fact_4760_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_eu(A,fun(nat,A),A2)),set_ord_atMost(nat,M)) = aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),M)),one_one(A)),aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,A,gbinomial(A,A2),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),one_one(nat)))) ) ) ).

% gbinomial_partial_row_sum
tff(fact_4761_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real))
       => ? [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),T4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),zero_zero(real))
            & ( aa(real,real,cos(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gx(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi))),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
tff(fact_4762_Maclaurin__cos__expansion2,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ? [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),Xa)
            & ( aa(real,real,cos(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gx(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi))),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ) ).

% Maclaurin_cos_expansion2
tff(fact_4763_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => ? [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),Xa)
            & ( aa(real,real,sin(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gy(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi))),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ) ).

% Maclaurin_sin_expansion3
tff(fact_4764_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_lessThan(A,Xa)),set_ord_lessThan(A,Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ).

% lessThan_subset_iff
tff(fact_4765_lessThan__0,axiom,
    set_ord_lessThan(nat,zero_zero(nat)) = bot_bot(set(nat)) ).

% lessThan_0
tff(fact_4766_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [K: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),insert(A,K),bot_bot(set(A)))),set_ord_lessThan(A,K)) = aa(set(A),set(A),insert(A,K),bot_bot(set(A))) ) ) ).

% single_Diff_lessThan
tff(fact_4767_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,N))),aa(nat,A,G,N)) ) ) ).

% sum.lessThan_Suc
tff(fact_4768_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,N))),aa(nat,A,G,N)) ) ) ).

% prod.lessThan_Suc
tff(fact_4769_sumr__cos__zero__one,axiom,
    ! [N: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gz(nat,real)),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = one_one(real) ) ).

% sumr_cos_zero_one
tff(fact_4770_lessThan__Suc__atMost,axiom,
    ! [K: nat] : ( set_ord_lessThan(nat,aa(nat,nat,suc,K)) = set_ord_atMost(nat,K) ) ).

% lessThan_Suc_atMost
tff(fact_4771_lessThan__Suc,axiom,
    ! [K: nat] : ( set_ord_lessThan(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),insert(nat,K),set_ord_lessThan(nat,K)) ) ).

% lessThan_Suc
tff(fact_4772_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan(nat,N) = bot_bot(set(nat)) )
    <=> ( N = zero_zero(nat) ) ) ).

% lessThan_empty_iff
tff(fact_4773_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atMost(A,A2)),set_ord_lessThan(A,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2) ) ) ).

% Iic_subset_Iio_iff
tff(fact_4774_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ha(fun(nat,A),fun(nat,fun(nat,A)),G),N)),set_ord_lessThan(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,N)) ) ) ).

% sum.nat_diff_reindex
tff(fact_4775_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hb(fun(nat,A),fun(nat,fun(nat,A)),G),N)),set_ord_lessThan(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,N)) ) ) ).

% prod.nat_diff_reindex
tff(fact_4776_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Q: fun(A,nat),P: fun(A,nat),N: A] :
          ( ! [X: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,Q,X)),aa(A,nat,P,X))
         => ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),P),set_ord_lessThan(A,N))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),Q),set_ord_lessThan(A,N))) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_hc(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Q),P)),set_ord_lessThan(A,N)) ) ) ) ).

% sum_diff_distrib
tff(fact_4777_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),Xa: A] :
          ( summable(A,F3)
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N2))),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),suminf(A,F3)),Xa) ) ) ) ).

% suminf_le_const
tff(fact_4778_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [F3: fun(nat,A),N: nat,R: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),R)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_hd(fun(nat,A),fun(A,fun(nat,A)),F3),R)),set_ord_lessThan(nat,N)) ) ) ).

% sumr_diff_mult_const2
tff(fact_4779_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% sum.lessThan_Suc_shift
tff(fact_4780_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ej(fun(nat,A),fun(nat,A),F3)),set_ord_lessThan(nat,M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,M)),aa(nat,A,F3,zero_zero(nat))) ) ) ).

% sum_lessThan_telescope
tff(fact_4781_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(nat,A),M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_fk(fun(nat,A),fun(nat,A),F3)),set_ord_lessThan(nat,M)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,zero_zero(nat))),aa(nat,A,F3,M)) ) ) ).

% sum_lessThan_telescope'
tff(fact_4782_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),Xa: A] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N2))
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N2))),Xa)
           => summable(A,F3) ) ) ) ).

% summableI_nonneg_bounded
tff(fact_4783_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bd(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% prod.lessThan_Suc_shift
tff(fact_4784_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N)) ) ) ).

% sum.atLeast1_atMost_eq
tff(fact_4785_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),N: nat,S: A] :
          ( sums(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),N),S)
        <=> sums(A,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N)))) ) ) ).

% sums_iff_shift
tff(fact_4786_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),S: A,N: nat] :
          ( sums(A,F3,S)
         => sums(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),N),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N)))) ) ) ).

% sums_split_initial_segment
tff(fact_4787_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),N: nat,S: A] :
          ( sums(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),N),aa(A,A,aa(A,fun(A,A),minus_minus(A),S),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N))))
        <=> sums(A,F3,S) ) ) ).

% sums_iff_shift'
tff(fact_4788_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bd(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N)) ) ) ).

% prod.atLeast1_atMost_eq
tff(fact_4789_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),Mm: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),F3)),set_ord_lessThan(nat,Mm)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or1337092689740270186AtMost(nat,one_one(nat),Mm)) ) ) ).

% sum_bounds_lt_plus1
tff(fact_4790_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_he(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_ord_atMost(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),N)),set_ord_lessThan(nat,N)) ) ) ).

% sum.nested_swap'
tff(fact_4791_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_hh(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_ord_atMost(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hj(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),N)),set_ord_lessThan(nat,N)) ) ) ).

% prod.nested_swap'
tff(fact_4792_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),one_one(A)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),one_one(A))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_1_eq
tff(fact_4793_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq
tff(fact_4794_geometric__sum,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Xa: A,N: nat] :
          ( ( Xa != one_one(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_ord_lessThan(nat,N)) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),one_one(A)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),one_one(A))) ) ) ) ).

% geometric_sum
tff(fact_4795_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% sum.atMost_shift
tff(fact_4796_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bd(fun(nat,A),fun(nat,A),G)),set_ord_lessThan(nat,N))) ) ) ).

% prod.atMost_shift
tff(fact_4797_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,F3)
         => ( suminf(A,F3) = aa(A,A,aa(A,fun(A,A),plus_plus(A),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),K))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,K))) ) ) ) ).

% suminf_split_initial_segment
tff(fact_4798_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( summable(A,F3)
         => ( suminf(A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),F3),K)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),suminf(A,F3)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,K))) ) ) ) ).

% suminf_minus_initial_segment
tff(fact_4799_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),N: nat] :
          ( summable(A,F3)
         => ( ! [M2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,M2)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N))),suminf(A,F3)) ) ) ) ).

% sum_less_suminf
tff(fact_4800_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( division_ring(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),power_power(A),Xa)),set_ord_lessThan(nat,N))
          = $ite(Xa = one_one(A),aa(nat,A,semiring_1_of_nat(A),N),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa))) ) ) ).

% sum_gp_strict
tff(fact_4801_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Z: A,H: A,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_hk(A,fun(A,fun(nat,fun(nat,A))),Z),H),M)),set_ord_lessThan(nat,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_hl(A,fun(A,fun(nat,fun(nat,A))),Z),H),M)),set_ord_lessThan(nat,M)) ) ) ).

% lemma_termdiff1
tff(fact_4802_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),aa(nat,nat,suc,N))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_hm(A,fun(nat,fun(A,fun(nat,A))),Xa),N),Y)),set_ord_lessThan(nat,aa(nat,nat,suc,N)))) ) ) ).

% diff_power_eq_sum
tff(fact_4803_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Y),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_hn(A,fun(nat,fun(A,fun(nat,A))),Xa),N),Y)),set_ord_lessThan(nat,N))) ) ) ).

% power_diff_sumr2
tff(fact_4804_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),A2: A,N: nat] :
          ( ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),C2),A2)),set_ord_atMost(nat,N)) = zero_zero(A) )
         => ~ ! [B4: fun(nat,A)] :
                ~ ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),B4),Z3)),set_ord_lessThan(nat,N))) ) ) ) ).

% polyfun_linear_factor_root
tff(fact_4805_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [C2: fun(nat,A),N: nat,A2: A] :
        ? [B4: fun(nat,A)] :
        ! [Z3: A] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),C2),Z3)),set_ord_atMost(nat,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z3),A2)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),B4),Z3)),set_ord_lessThan(nat,N)))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),C2),A2)),set_ord_atMost(nat,N))) ) ) ).

% polyfun_linear_factor
tff(fact_4806_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [N: nat,F3: fun(nat,A),K6: A,K: nat] :
          ( ! [P4: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),P4),N)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,P4)),K6) )
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),K6)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),K6)) ) ) ) ).

% real_sum_nat_ivl_bounded2
tff(fact_4807_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),N: nat,I: nat] :
          ( summable(A,F3)
         => ( ! [M2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,M2)) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),I)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),aa(nat,A,F3,I))
               => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_ord_lessThan(nat,N))),suminf(A,F3)) ) ) ) ) ) ).

% sum_less_suminf2
tff(fact_4808_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Xa: A,N: nat] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Xa),N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),Xa)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ho(A,fun(nat,fun(nat,A)),Xa),N)),set_ord_lessThan(nat,N))) ) ) ).

% one_diff_power_eq'
tff(fact_4809_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [Xa: real,N: nat,Diff: fun(nat,fun(A,real))] :
          ( ( Xa = zero_zero(real) )
         => ( ( N != zero_zero(nat) )
           => ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_hp(real,fun(fun(nat,fun(A,real)),fun(nat,real)),Xa),Diff)),set_ord_lessThan(nat,N)) = aa(A,real,aa(nat,fun(A,real),Diff,zero_zero(nat)),zero_zero(A)) ) ) ) ) ).

% Maclaurin_zero
tff(fact_4810_Maclaurin__lemma,axiom,
    ! [H: real,F3: fun(real,real),J: fun(nat,real),N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ? [B9: real] : ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_hq(real,fun(fun(nat,real),fun(nat,real)),H),J)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),B9),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),H),N),semiring_char_0_fact(real,N)))) ) ) ).

% Maclaurin_lemma
tff(fact_4811_sum__split__even__odd,axiom,
    ! [F3: fun(nat,real),G: fun(nat,real),N: nat] : ( aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,real),fun(nat,real),aTP_Lamp_hr(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F3),G)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N))) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_hs(fun(nat,real),fun(nat,real),F3)),set_ord_lessThan(nat,N))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_ht(fun(nat,real),fun(nat,real),G)),set_ord_lessThan(nat,N))) ) ).

% sum_split_even_odd
tff(fact_4812_Maclaurin__exp__le,axiom,
    ! [Xa: real,N: nat] :
    ? [T4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
      & ( aa(real,real,exp(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_hu(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,exp(real),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ).

% Maclaurin_exp_le
tff(fact_4813_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,A2: fun(nat,A),Xa: A,Y: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),N)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),A2),Xa)),set_ord_atMost(nat,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),A2),Y)),set_ord_atMost(nat,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_hw(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),N),A2),Xa),Y)),set_ord_lessThan(nat,N))) ) ) ) ).

% polyfun_diff_alt
tff(fact_4814_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Xa: A,K: nat] : ( aa(A,A,exp(A),Xa) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_bk(A,fun(nat,A),Xa)),set_ord_lessThan(nat,K))),suminf(A,aa(nat,fun(nat,A),aTP_Lamp_hx(A,fun(nat,fun(nat,A)),Xa),K))) ) ) ).

% exp_first_terms
tff(fact_4815_Maclaurin__sin__bound,axiom,
    ! [Xa: real,N: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,sin(real),Xa)),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gy(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),Xa)),N))) ).

% Maclaurin_sin_bound
tff(fact_4816_sum__pos__lt__pair,axiom,
    ! [F3: fun(nat,real),K: nat] :
      ( summable(real,F3)
     => ( ! [D6: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D6)))),aa(nat,real,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat)))),D6)),one_one(nat))))))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),F3),set_ord_lessThan(nat,K))),suminf(real,F3)) ) ) ).

% sum_pos_lt_pair
tff(fact_4817_polyfun__diff,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [N: nat,A2: fun(nat,A),Xa: A,Y: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),N)
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),A2),Xa)),set_ord_atMost(nat,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),A2),Y)),set_ord_atMost(nat,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_hz(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),N),A2),Xa),Y)),set_ord_lessThan(nat,N))) ) ) ) ).

% polyfun_diff
tff(fact_4818_Maclaurin__exp__lt,axiom,
    ! [Xa: real,N: nat] :
      ( ( Xa != zero_zero(real) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ? [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T4))
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
            & ( aa(real,real,exp(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_hu(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,exp(real),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ) ).

% Maclaurin_exp_lt
tff(fact_4819_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => bij_betw(nat,complex,aTP_Lamp_ia(nat,fun(nat,complex),N),set_ord_lessThan(nat,N),collect(complex,aTP_Lamp_ao(nat,fun(complex,$o),N))) ) ).

% bij_betw_roots_unity
tff(fact_4820_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [H: A,Z: A,N: nat] :
          ( ( H != zero_zero(A) )
         => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),H)),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),N)),H)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Z),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),times_times(A),H),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ic(A,fun(A,fun(nat,fun(nat,A))),H),Z),N)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) ) ) ) ).

% lemma_termdiff2
tff(fact_4821_Maclaurin__sin__expansion,axiom,
    ! [Xa: real,N: nat] :
    ? [T4: real] : ( aa(real,real,sin(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gy(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi))),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ).

% Maclaurin_sin_expansion
tff(fact_4822_Maclaurin__sin__expansion2,axiom,
    ! [Xa: real,N: nat] :
    ? [T4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
      & ( aa(real,real,sin(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gy(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi))),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ).

% Maclaurin_sin_expansion2
tff(fact_4823_Maclaurin__cos__expansion,axiom,
    ! [Xa: real,N: nat] :
    ? [T4: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
      & ( aa(real,real,cos(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gx(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi))),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ).

% Maclaurin_cos_expansion
tff(fact_4824_Maclaurin__sin__expansion4,axiom,
    ! [Xa: real,N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => ? [T4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T4)
          & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),Xa)
          & ( aa(real,real,sin(real),Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_gy(real,fun(nat,real),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,sin(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),T4),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,real,semiring_1_of_nat(real),N))),pi))),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ).

% Maclaurin_sin_expansion4
tff(fact_4825_Arg__def,axiom,
    ! [Z: complex] :
      ( arg(Z)
      = $ite(Z = zero_zero(complex),zero_zero(real),fChoice(real,aTP_Lamp_id(complex,fun(real,$o),Z))) ) ).

% Arg_def
tff(fact_4826_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( unique8689654367752047608divmod(A,aa(num,num,bit1,M),bit0(N)) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_ie(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M,N)) ) ) ).

% divmod_algorithm_code(6)
tff(fact_4827_arctan__def,axiom,
    ! [Y: real] : ( aa(real,real,arctan,Y) = the(real,aTP_Lamp_if(real,fun(real,$o),Y)) ) ).

% arctan_def
tff(fact_4828_some__sym__eq__trivial,axiom,
    ! [A: $tType,Xa: A] : ( fChoice(A,aa(A,fun(A,$o),fequal(A),Xa)) = Xa ) ).

% some_sym_eq_trivial
tff(fact_4829_some__eq__trivial,axiom,
    ! [A: $tType,Xa: A] : ( fChoice(A,aTP_Lamp_ig(A,fun(A,$o),Xa)) = Xa ) ).

% some_eq_trivial
tff(fact_4830_some__equality,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A] :
      ( aa(A,$o,P,A2)
     => ( ! [X: A] :
            ( aa(A,$o,P,X)
           => ( X = A2 ) )
       => ( fChoice(A,P) = A2 ) ) ) ).

% some_equality
tff(fact_4831_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [M: num,N: num] : ( unique8689654367752047608divmod(A,bit0(M),bit0(N)) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_ih(A,fun(A,product_prod(A,A)))),unique8689654367752047608divmod(A,M,N)) ) ) ).

% divmod_algorithm_code(5)
tff(fact_4832_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,Xa: A,P: fun(A,$o),P3: fun(A,$o)] :
      ( ( Xa = fChoice(A,aTP_Lamp_ii(fun(A,$o),fun(A,$o),P)) )
     => ( ! [X: A] :
            ( aa(A,$o,P,X)
          <=> aa(A,$o,P3,X) )
       => ( ! [X_12: A] : aa(A,$o,P3,X_12)
        <=> aa(A,$o,P,Xa) ) ) ) ).

% verit_sko_forall_indirect2
tff(fact_4833_verit__sko__forall__indirect,axiom,
    ! [A: $tType,Xa: A,P: fun(A,$o)] :
      ( ( Xa = fChoice(A,aTP_Lamp_ii(fun(A,$o),fun(A,$o),P)) )
     => ( ! [X_12: A] : aa(A,$o,P,X_12)
      <=> aa(A,$o,P,Xa) ) ) ).

% verit_sko_forall_indirect
tff(fact_4834_some1__equality,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A] :
      ( ? [X3: A] :
          ( aa(A,$o,P,X3)
          & ! [Y3: A] :
              ( aa(A,$o,P,Y3)
             => ( Y3 = X3 ) ) )
     => ( aa(A,$o,P,A2)
       => ( fChoice(A,P) = A2 ) ) ) ).

% some1_equality
tff(fact_4835_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,Xa: A,P: fun(A,$o),P3: fun(A,$o)] :
      ( ( Xa = fChoice(A,P) )
     => ( ! [X: A] :
            ( aa(A,$o,P,X)
          <=> aa(A,$o,P3,X) )
       => ( ? [X_12: A] : aa(A,$o,P3,X_12)
        <=> aa(A,$o,P,Xa) ) ) ) ).

% verit_sko_ex_indirect2
tff(fact_4836_verit__sko__ex__indirect,axiom,
    ! [A: $tType,Xa: A,P: fun(A,$o)] :
      ( ( Xa = fChoice(A,P) )
     => ( ? [X_12: A] : aa(A,$o,P,X_12)
      <=> aa(A,$o,P,Xa) ) ) ).

% verit_sko_ex_indirect
tff(fact_4837_some__eq__ex,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( aa(A,$o,P,fChoice(A,P))
    <=> ? [X_12: A] : aa(A,$o,P,X_12) ) ).

% some_eq_ex
tff(fact_4838_someI2__bex,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( ? [X3: A] :
          ( member(A,X3,A3)
          & aa(A,$o,P,X3) )
     => ( ! [X: A] :
            ( ( member(A,X,A3)
              & aa(A,$o,P,X) )
           => aa(A,$o,Q,X) )
       => aa(A,$o,Q,fChoice(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) ) ) ).

% someI2_bex
tff(fact_4839_someI2__ex,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ? [X_1: A] : aa(A,$o,P,X_1)
     => ( ! [X: A] :
            ( aa(A,$o,P,X)
           => aa(A,$o,Q,X) )
       => aa(A,$o,Q,fChoice(A,P)) ) ) ).

% someI2_ex
tff(fact_4840_someI__ex,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( ? [X_1: A] : aa(A,$o,P,X_1)
     => aa(A,$o,P,fChoice(A,P)) ) ).

% someI_ex
tff(fact_4841_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B3: A,A3: A,P: fun(A,$o)] :
      ( ( B3 = A3 )
     => ( ( fChoice(A,P) = A3 )
      <=> ( fChoice(A,P) = B3 ) ) ) ).

% verit_sko_forall''
tff(fact_4842_verit__sko__forall_H,axiom,
    ! [A: $tType,P: fun(A,$o),A3: $o] :
      ( ( aa(A,$o,P,fChoice(A,aTP_Lamp_ii(fun(A,$o),fun(A,$o),P)))
      <=> (A3) )
     => ( ! [X_12: A] : aa(A,$o,P,X_12)
      <=> (A3) ) ) ).

% verit_sko_forall'
tff(fact_4843_someI2,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A,Q: fun(A,$o)] :
      ( aa(A,$o,P,A2)
     => ( ! [X: A] :
            ( aa(A,$o,P,X)
           => aa(A,$o,Q,X) )
       => aa(A,$o,Q,fChoice(A,P)) ) ) ).

% someI2
tff(fact_4844_verit__sko__forall,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( ! [X_12: A] : aa(A,$o,P,X_12)
    <=> aa(A,$o,P,fChoice(A,aTP_Lamp_ii(fun(A,$o),fun(A,$o),P))) ) ).

% verit_sko_forall
tff(fact_4845_verit__sko__ex_H,axiom,
    ! [A: $tType,P: fun(A,$o),A3: $o] :
      ( ( aa(A,$o,P,fChoice(A,P))
      <=> (A3) )
     => ( ? [X_12: A] : aa(A,$o,P,X_12)
      <=> (A3) ) ) ).

% verit_sko_ex'
tff(fact_4846_someI,axiom,
    ! [A: $tType,P: fun(A,$o),Xa: A] :
      ( aa(A,$o,P,Xa)
     => aa(A,$o,P,fChoice(A,P)) ) ).

% someI
tff(fact_4847_Eps__cong,axiom,
    ! [A: $tType,P: fun(A,$o),Q: fun(A,$o)] :
      ( ! [X: A] :
          ( aa(A,$o,P,X)
        <=> aa(A,$o,Q,X) )
     => ( fChoice(A,P) = fChoice(A,Q) ) ) ).

% Eps_cong
tff(fact_4848_tfl__some,axiom,
    ! [A: $tType,P5: fun(A,$o),X3: A] :
      ( aa(A,$o,P5,X3)
     => aa(A,$o,P5,fChoice(A,P5)) ) ).

% tfl_some
tff(fact_4849_some__eq__imp,axiom,
    ! [A: $tType,P: fun(A,$o),A2: A,B2: A] :
      ( ( fChoice(A,P) = A2 )
     => ( aa(A,$o,P,B2)
       => aa(A,$o,P,A2) ) ) ).

% some_eq_imp
tff(fact_4850_some__in__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( member(A,fChoice(A,aTP_Lamp_a(set(A),fun(A,$o),A3)),A3)
    <=> ( A3 != bot_bot(set(A)) ) ) ).

% some_in_eq
tff(fact_4851_ln__real__def,axiom,
    ! [Xa: real] : ( aa(real,real,ln_ln(real),Xa) = the(real,aTP_Lamp_ij(real,fun(real,$o),Xa)) ) ).

% ln_real_def
tff(fact_4852_ln__neg__is__const,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),zero_zero(real))
     => ( aa(real,real,ln_ln(real),Xa) = the(real,aTP_Lamp_ik(real,$o)) ) ) ).

% ln_neg_is_const
tff(fact_4853_rat__times__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_im(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_times_code
tff(fact_4854_rat__divide__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(divide_divide(rat,P2,Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_io(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_divide_code
tff(fact_4855_arccos__def,axiom,
    ! [Y: real] : ( aa(real,real,arccos,Y) = the(real,aTP_Lamp_ip(real,fun(real,$o),Y)) ) ).

% arccos_def
tff(fact_4856_rat__plus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_ir(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_plus_code
tff(fact_4857_rat__minus__code,axiom,
    ! [P2: rat,Q2: rat] : ( quotient_of(aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),P2),Q2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_it(rat,fun(int,fun(int,product_prod(int,int))),Q2)),quotient_of(P2)) ) ).

% rat_minus_code
tff(fact_4858_rat__inverse__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,inverse_inverse(rat),P2)) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_iu(int,fun(int,product_prod(int,int)))),quotient_of(P2)) ) ).

% rat_inverse_code
tff(fact_4859_divmod__step__nat__def,axiom,
    ! [L: num,Qr: product_prod(nat,nat)] : ( unique1321980374590559556d_step(nat,L,Qr) = aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_iv(num,fun(nat,fun(nat,product_prod(nat,nat))),L)),Qr) ) ).

% divmod_step_nat_def
tff(fact_4860_divmod__step__int__def,axiom,
    ! [L: num,Qr: product_prod(int,int)] : ( unique1321980374590559556d_step(int,L,Qr) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aTP_Lamp_iw(num,fun(int,fun(int,product_prod(int,int))),L)),Qr) ) ).

% divmod_step_int_def
tff(fact_4861_pi__half,axiom,
    divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))) = the(real,aTP_Lamp_ix(real,$o)) ).

% pi_half
tff(fact_4862_pi__def,axiom,
    pi = aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),the(real,aTP_Lamp_ix(real,$o))) ).

% pi_def
tff(fact_4863_divmod__step__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [L: num,Qr: product_prod(A,A)] : ( unique1321980374590559556d_step(A,L,Qr) = aa(product_prod(A,A),product_prod(A,A),product_case_prod(A,A,product_prod(A,A),aTP_Lamp_iy(num,fun(A,fun(A,product_prod(A,A))),L)),Qr) ) ) ).

% divmod_step_def
tff(fact_4864_arcsin__def,axiom,
    ! [Y: real] : ( aa(real,real,arcsin,Y) = the(real,aTP_Lamp_iz(real,fun(real,$o),Y)) ) ).

% arcsin_def
tff(fact_4865_old_Orec__nat__def,axiom,
    ! [A: $tType,X3: A,Xa2: fun(nat,fun(A,A)),Xb2: nat] : ( aa(nat,A,aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),X3),Xa2),Xb2) = the(A,rec_set_nat(A,X3,Xa2,Xb2)) ) ).

% old.rec_nat_def
tff(fact_4866_divmod__nat__if,axiom,
    ! [M: nat,N: nat] :
      ( divmod_nat(M,N)
      = $ite(
          ( ( N = zero_zero(nat) )
          | aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N) ),
          aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),M),
          aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_ja(nat,fun(nat,product_prod(nat,nat)))),divmod_nat(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),N)) ) ) ).

% divmod_nat_if
tff(fact_4867_rec__nat__0__imp,axiom,
    ! [A: $tType,F3: fun(nat,A),F1: A,F2: fun(nat,fun(A,A))] :
      ( ( F3 = aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),F1),F2) )
     => ( aa(nat,A,F3,zero_zero(nat)) = F1 ) ) ).

% rec_nat_0_imp
tff(fact_4868_divide__rat__def,axiom,
    ! [Q2: rat,R: rat] : ( divide_divide(rat,Q2,R) = aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),Q2),aa(rat,rat,inverse_inverse(rat),R)) ) ).

% divide_rat_def
tff(fact_4869_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_jb(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jd(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_atMost(nat,N)) ) ) ).

% sum.triangle_reindex_eq
tff(fact_4870_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7121269368397514597t_prod(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_jb(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_jf(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_atMost(nat,N)) ) ) ).

% prod.triangle_reindex_eq
tff(fact_4871_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7311177749621191930dd_sum(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_jg(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jd(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_lessThan(nat,N)) ) ) ).

% sum.triangle_reindex
tff(fact_4872_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,fun(nat,A)),N: nat] : ( aa(set(product_prod(nat,nat)),A,aa(fun(product_prod(nat,nat),A),fun(set(product_prod(nat,nat)),A),groups7121269368397514597t_prod(product_prod(nat,nat),A),product_case_prod(nat,nat,A,G)),collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_jg(nat,fun(nat,fun(nat,$o)),N)))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_jf(fun(nat,fun(nat,A)),fun(nat,A),G)),set_ord_lessThan(nat,N)) ) ) ).

% prod.triangle_reindex
tff(fact_4873_subset__CollectI,axiom,
    ! [A: $tType,B3: set(A),A3: set(A),Q: fun(A,$o),P: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
     => ( ! [X: A] :
            ( member(A,X,B3)
           => ( aa(A,$o,Q,X)
             => aa(A,$o,P,X) ) )
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),B3),Q))),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) ) ) ).

% subset_CollectI
tff(fact_4874_subset__Collect__iff,axiom,
    ! [A: $tType,B3: set(A),A3: set(A),P: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),A3),P)))
      <=> ! [X4: A] :
            ( member(A,X4,B3)
           => aa(A,$o,P,X4) ) ) ) ).

% subset_Collect_iff
tff(fact_4875_floor__rat__def,axiom,
    ! [Xa: rat] : ( archim6421214686448440834_floor(rat,Xa) = the(int,aTP_Lamp_jh(rat,fun(int,$o),Xa)) ) ).

% floor_rat_def
tff(fact_4876_floor__real__def,axiom,
    ! [Xa: real] : ( archim6421214686448440834_floor(real,Xa) = the(int,aTP_Lamp_ji(real,fun(int,$o),Xa)) ) ).

% floor_real_def
tff(fact_4877_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F3: fun(nat,A),F1: A,F2: fun(nat,fun(A,A)),N: nat] :
      ( ( F3 = aa(fun(nat,fun(A,A)),fun(nat,A),aa(A,fun(fun(nat,fun(A,A)),fun(nat,A)),rec_nat(A),F1),F2) )
     => ( aa(nat,A,F3,aa(nat,nat,suc,N)) = aa(A,A,aa(nat,fun(A,A),F2,N),aa(nat,A,F3,N)) ) ) ).

% rec_nat_Suc_imp
tff(fact_4878_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat] :
          ( aa(nat,A,semiring_1_of_nat(A),N)
          = $ite(N = zero_zero(nat),zero_zero(A),aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_jj(nat,fun(nat,A))),divmod_nat(N,aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% of_nat_code_if
tff(fact_4879_Frct__code__post_I5_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),aa(num,int,numeral_numeral(int),K))) = divide_divide(rat,one_one(rat),aa(num,rat,numeral_numeral(rat),K)) ) ).

% Frct_code_post(5)
tff(fact_4880_pred__subset__eq,axiom,
    ! [A: $tType,R2: set(A),S2: set(A)] :
      ( aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),aTP_Lamp_a(set(A),fun(A,$o),R2)),aTP_Lamp_a(set(A),fun(A,$o),S2))
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),R2),S2) ) ).

% pred_subset_eq
tff(fact_4881_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,Xa: A,Y: B] : ( fChoice(product_prod(A,B),product_case_prod(A,B,$o,aa(B,fun(A,fun(B,$o)),aTP_Lamp_jk(A,fun(B,fun(A,fun(B,$o))),Xa),Y))) = aa(B,product_prod(A,B),product_Pair(A,B,Xa),Y) ) ).

% Eps_case_prod_eq
tff(fact_4882_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType,P: fun(product_prod(A,B),$o)] : ( fChoice(product_prod(A,B),P) = fChoice(product_prod(A,B),product_case_prod(A,B,$o,aTP_Lamp_jl(fun(product_prod(A,B),$o),fun(A,fun(B,$o)),P))) ) ).

% split_paired_Eps
tff(fact_4883_subrelI,axiom,
    ! [B: $tType,A: $tType,R: set(product_prod(A,B)),S: set(product_prod(A,B))] :
      ( ! [X: A,Y3: B] :
          ( member(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,X),Y3),R)
         => member(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,X),Y3),S) )
     => aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),R),S) ) ).

% subrelI
tff(fact_4884_prod__encode__def,axiom,
    nat_prod_encode = product_case_prod(nat,nat,nat,aTP_Lamp_jm(nat,fun(nat,nat))) ).

% prod_encode_def
tff(fact_4885_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set(product_prod(A,B)),S2: set(product_prod(A,B))] :
      ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),aTP_Lamp_jn(set(product_prod(A,B)),fun(A,fun(B,$o)),R2)),aTP_Lamp_jn(set(product_prod(A,B)),fun(A,fun(B,$o)),S2))
    <=> aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),R2),S2) ) ).

% pred_subset_eq2
tff(fact_4886_Frct__code__post_I1_J,axiom,
    ! [A2: int] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),A2)) = zero_zero(rat) ) ).

% Frct_code_post(1)
tff(fact_4887_Frct__code__post_I2_J,axiom,
    ! [A2: int] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,A2),zero_zero(int))) = zero_zero(rat) ) ).

% Frct_code_post(2)
tff(fact_4888_Frct__code__post_I3_J,axiom,
    frct(aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))) = one_one(rat) ).

% Frct_code_post(3)
tff(fact_4889_Frct__code__post_I4_J,axiom,
    ! [K: num] : ( frct(aa(int,product_prod(int,int),product_Pair(int,int,aa(num,int,numeral_numeral(int),K)),one_one(int))) = aa(num,rat,numeral_numeral(rat),K) ) ).

% Frct_code_post(4)
tff(fact_4890_set__encode__def,axiom,
    nat_set_encode = aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2)))) ).

% set_encode_def
tff(fact_4891_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_bg(nat,nat)),set_or7035219750837199246ssThan(nat,M,N)) = divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),one_one(nat)))),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% Sum_Ico_nat
tff(fact_4892_sum__power2,axiom,
    ! [K: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2)))),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)),one_one(nat)) ) ).

% sum_power2
tff(fact_4893_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,$o)),Q: fun(A,fun(B,$o))] :
      ( ! [X: A,Y3: B] :
          ( aa(B,$o,aa(A,fun(B,$o),P,X),Y3)
         => aa(B,$o,aa(A,fun(B,$o),Q,X),Y3) )
     => aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),P),Q) ) ).

% predicate2I
tff(fact_4894_set__decode__inverse,axiom,
    ! [N: nat] : ( aa(set(nat),nat,nat_set_encode,nat_set_decode(N)) = N ) ).

% set_decode_inverse
tff(fact_4895_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,L: A,U: A] :
          ( member(A,I,set_or7035219750837199246ssThan(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),I)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),I),U) ) ) ) ).

% atLeastLessThan_iff
tff(fact_4896_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( set_or7035219750837199246ssThan(A,A2,B2) = bot_bot(set(A)) ) ) ) ).

% atLeastLessThan_empty
tff(fact_4897_ivl__subset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [I: A,J: A,M: A,N: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,I,J)),set_or7035219750837199246ssThan(A,M,N))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),J),I)
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),I)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),J),N) ) ) ) ) ).

% ivl_subset
tff(fact_4898_ivl__diff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [I: A,N: A,M: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),N)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or7035219750837199246ssThan(A,I,M)),set_or7035219750837199246ssThan(A,I,N)) = set_or7035219750837199246ssThan(A,N,M) ) ) ) ).

% ivl_diff
tff(fact_4899_lessThan__minus__lessThan,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [N: A,M: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_ord_lessThan(A,N)),set_ord_lessThan(A,M)) = set_or7035219750837199246ssThan(A,M,N) ) ) ).

% lessThan_minus_lessThan
tff(fact_4900_card__atLeastLessThan,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or7035219750837199246ssThan(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),U),L) ) ).

% card_atLeastLessThan
tff(fact_4901_set__encode__empty,axiom,
    aa(set(nat),nat,nat_set_encode,bot_bot(set(nat))) = zero_zero(nat) ).

% set_encode_empty
tff(fact_4902_atLeastLessThan__singleton,axiom,
    ! [M: nat] : ( set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,M)) = aa(set(nat),set(nat),insert(nat,M),bot_bot(set(nat))) ) ).

% atLeastLessThan_singleton
tff(fact_4903_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N))) ) ) ).

% sum.op_ivl_Suc
tff(fact_4904_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N)))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N))) ) ) ).

% prod.op_ivl_Suc
tff(fact_4905_less__by__empty,axiom,
    ! [A: $tType,A3: set(product_prod(A,A)),B3: set(product_prod(A,A))] :
      ( ( A3 = bot_bot(set(product_prod(A,A))) )
     => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),A3),B3) ) ).

% less_by_empty
tff(fact_4906_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Q: fun(A,fun(B,$o)),Xa: A,Y: B] :
      ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),P),Q)
     => ( aa(B,$o,aa(A,fun(B,$o),P,Xa),Y)
       => aa(B,$o,aa(A,fun(B,$o),Q,Xa),Y) ) ) ).

% predicate2D
tff(fact_4907_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: fun(A,fun(B,$o)),Xa: A,Y: B,Q: fun(A,fun(B,$o))] :
      ( aa(B,$o,aa(A,fun(B,$o),P,Xa),Y)
     => ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),P),Q)
       => aa(B,$o,aa(A,fun(B,$o),Q,Xa),Y) ) ) ).

% rev_predicate2D
tff(fact_4908_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% atLeastLessThan_subset_iff
tff(fact_4909_all__nat__less__eq,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ! [M6: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M6),N)
         => aa(nat,$o,P,M6) )
    <=> ! [X4: nat] :
          ( member(nat,X4,set_or7035219750837199246ssThan(nat,zero_zero(nat),N))
         => aa(nat,$o,P,X4) ) ) ).

% all_nat_less_eq
tff(fact_4910_ex__nat__less__eq,axiom,
    ! [N: nat,P: fun(nat,$o)] :
      ( ? [M6: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M6),N)
          & aa(nat,$o,P,M6) )
    <=> ? [X4: nat] :
          ( member(nat,X4,set_or7035219750837199246ssThan(nat,zero_zero(nat),N))
          & aa(nat,$o,P,X4) ) ) ).

% ex_nat_less_eq
tff(fact_4911_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L: nat,U: nat] : ( set_or7035219750837199246ssThan(nat,L,aa(nat,nat,suc,U)) = set_or1337092689740270186AtMost(nat,L,U) ) ).

% atLeastLessThanSuc_atLeastAtMost
tff(fact_4912_lessThan__atLeast0,axiom,
    ! [N: nat] : ( set_ord_lessThan(nat,N) = set_or7035219750837199246ssThan(nat,zero_zero(nat),N) ) ).

% lessThan_atLeast0
tff(fact_4913_atLeastLessThan0,axiom,
    ! [M: nat] : ( set_or7035219750837199246ssThan(nat,M,zero_zero(nat)) = bot_bot(set(nat)) ) ).

% atLeastLessThan0
tff(fact_4914_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ef(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.shift_bounds_Suc_ivl
tff(fact_4915_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_eg(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.shift_bounds_nat_ivl
tff(fact_4916_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bd(fun(nat,A),fun(nat,A),G)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.shift_bounds_Suc_ivl
tff(fact_4917_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_be(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.shift_bounds_nat_ivl
tff(fact_4918_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,L),U) = set_or5935395276787703475ssThan(nat,L,U) ) ).

% atLeastSucLessThan_greaterThanLessThan
tff(fact_4919_sum_Oivl__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & comm_monoid_add(B) )
     => ! [A2: A,C2: A,B2: A,D2: A,G: fun(A,B),H: fun(A,B)] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),X)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),D2)
                   => ( aa(A,B,G,X) = aa(A,B,H,X) ) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),set_or7035219750837199246ssThan(A,A2,B2)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),set_or7035219750837199246ssThan(A,C2,D2)) ) ) ) ) ) ).

% sum.ivl_cong
tff(fact_4920_prod_Oivl__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord(A)
        & comm_monoid_mult(B) )
     => ! [A2: A,C2: A,B2: A,D2: A,G: fun(A,B),H: fun(A,B)] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),X)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),D2)
                   => ( aa(A,B,G,X) = aa(A,B,H,X) ) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),set_or7035219750837199246ssThan(A,A2,B2)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),set_or7035219750837199246ssThan(A,C2,D2)) ) ) ) ) ) ).

% prod.ivl_cong
tff(fact_4921_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,P2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),P2)
           => ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,P2))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,P2)) ) ) ) ) ).

% sum.atLeastLessThan_concat
tff(fact_4922_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,P2: nat,F3: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),P2)
           => ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,M,P2))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,M,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,N,P2)) ) ) ) ) ).

% sum_diff_nat_ivl
tff(fact_4923_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,P2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),P2)
           => ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,N,P2))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,P2)) ) ) ) ) ).

% prod.atLeastLessThan_concat
tff(fact_4924_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,N),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ).

% atLeast0_lessThan_Suc
tff(fact_4925_subset__card__intvl__is__intvl,axiom,
    ! [A3: set(nat),K: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),A3),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(set(nat),nat,finite_card(nat),A3))))
     => ( A3 = set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),K),aa(set(nat),nat,finite_card(nat),A3))) ) ) ).

% subset_card_intvl_is_intvl
tff(fact_4926_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
tff(fact_4927_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
tff(fact_4928_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(nat,A),K: nat] :
          ( ( aa(nat,A,F3,zero_zero(nat)) = zero_zero(A) )
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
tff(fact_4929_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,A,G,N)) ) ) ).

% sum.atLeast0_lessThan_Suc
tff(fact_4930_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% sum.atLeast_Suc_lessThan
tff(fact_4931_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: nat,B2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A2,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,A2,B2))),aa(nat,A,G,B2)) ) ) ) ).

% sum.atLeastLessThan_Suc
tff(fact_4932_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
tff(fact_4933_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] : ( set_or7035219750837199246ssThan(A,A2,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
tff(fact_4934_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(nat,A,G,N)) ) ) ).

% prod.atLeast0_lessThan_Suc
tff(fact_4935_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),N))) ) ) ) ).

% prod.atLeast_Suc_lessThan
tff(fact_4936_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: nat,B2: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A2,aa(nat,nat,suc,B2))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,A2,B2))),aa(nat,A,G,B2)) ) ) ) ).

% prod.atLeastLessThan_Suc
tff(fact_4937_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,N)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))) ) ) ) ).

% sum.last_plus
tff(fact_4938_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,N)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))) ) ) ) ).

% prod.last_plus
tff(fact_4939_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [M: nat,N: nat,F3: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_ej(fun(nat,A),fun(nat,A),F3)),set_or7035219750837199246ssThan(nat,M,N)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,N)),aa(nat,A,F3,M)) ) ) ) ).

% sum_Suc_diff'
tff(fact_4940_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_jo(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or7035219750837199246ssThan(nat,N,M)) ) ) ).

% sum.atLeastLessThan_rev
tff(fact_4941_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( set_or7035219750837199246ssThan(nat,M,aa(nat,nat,suc,N))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N),aa(set(nat),set(nat),insert(nat,N),set_or7035219750837199246ssThan(nat,M,N)),bot_bot(set(nat))) ) ).

% atLeastLessThanSuc
tff(fact_4942_rat__less__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),P2),Q2)
    <=> aa(product_prod(int,int),$o,product_case_prod(int,int,$o,aTP_Lamp_jq(rat,fun(int,fun(int,$o)),Q2)),quotient_of(P2)) ) ).

% rat_less_code
tff(fact_4943_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [A2: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jr(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% sum.nested_swap
tff(fact_4944_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_js(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or7035219750837199246ssThan(nat,N,M)) ) ) ).

% prod.atLeastLessThan_rev
tff(fact_4945_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [A2: fun(nat,fun(nat,A)),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_jt(fun(nat,fun(nat,A)),fun(nat,A),A2)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hj(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),A2),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% prod.nested_swap
tff(fact_4946_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ju(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_ord_lessThan(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% sum.nat_group
tff(fact_4947_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jv(fun(nat,A),fun(nat,fun(nat,A)),G),K)),set_ord_lessThan(nat,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),K))) ) ) ).

% prod.nat_group
tff(fact_4948_rat__less__eq__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),P2),Q2)
    <=> aa(product_prod(int,int),$o,product_case_prod(int,int,$o,aTP_Lamp_jx(rat,fun(int,fun(int,$o)),Q2)),quotient_of(P2)) ) ).

% rat_less_eq_code
tff(fact_4949_prod__Suc__fact,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) = semiring_char_0_fact(nat,N) ) ).

% prod_Suc_fact
tff(fact_4950_prod__Suc__Suc__fact,axiom,
    ! [N: nat] : ( aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N)) = semiring_char_0_fact(nat,N) ) ).

% prod_Suc_Suc_fact
tff(fact_4951_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N6: set(nat),N: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N6),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,finite_card(nat),N6)),N) ) ).

% subset_eq_atLeast0_lessThan_card
tff(fact_4952_card__sum__le__nat__sum,axiom,
    ! [S2: set(nat)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_bg(nat,nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(nat),nat,finite_card(nat),S2)))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_bg(nat,nat)),S2)) ).

% card_sum_le_nat_sum
tff(fact_4953_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M),zero_zero(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N))) ) ) ).

% sum.head_if
tff(fact_4954_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N))
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),M),one_one(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,N))),aa(nat,A,G,N))) ) ) ).

% prod.head_if
tff(fact_4955_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% fact_prod_Suc
tff(fact_4956_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ei(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M)) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4957_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat,M: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,N,M)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_bf(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),G),N),M)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,N),M)) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
tff(fact_4958_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [A2: A,N: nat] : ( comm_s3205402744901411588hammer(A,A2,N) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bl(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% pochhammer_prod
tff(fact_4959_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( set_or7035219750837199246ssThan(nat,M,aa(num,nat,numeral_numeral(nat),K))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),pred_numeral(K)),aa(set(nat),set(nat),insert(nat,pred_numeral(K)),set_or7035219750837199246ssThan(nat,M,pred_numeral(K))),bot_bot(set(nat))) ) ).

% atLeastLessThan_nat_numeral
tff(fact_4960_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N: nat] : ( semiring_char_0_fact(A,N) = aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aa(nat,fun(nat,nat),minus_minus(nat),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% fact_prod_rev
tff(fact_4961_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [N7: nat] :
                ! [M6: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),M6)
                 => ! [N5: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,M6,N5)))),E3) ) ) ) ) ).

% summable_Cauchy
tff(fact_4962_sums__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A),S: A,K: nat] :
          ( sums(A,F3,S)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
           => sums(A,aa(nat,fun(nat,A),aTP_Lamp_jy(fun(nat,A),fun(nat,fun(nat,A)),F3),K),S) ) ) ) ).

% sums_group
tff(fact_4963_take__bit__sum,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,A2: A] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_jz(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% take_bit_sum
tff(fact_4964_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,zero_zero(nat)),N) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_lessThan(nat,N)),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat)))) ) ).

% atLeast1_lessThan_eq_remove0
tff(fact_4965_fact__split,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( semiring_char_0_fact(A,N) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),suc),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K),N)))),semiring_char_0_fact(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),K))) ) ) ) ).

% fact_split
tff(fact_4966_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
         => ( aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(N),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_ka(nat,fun(nat,fun(nat,A)),K),N)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ) ).

% binomial_altdef_of_nat
tff(fact_4967_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_kb(A,fun(nat,fun(nat,A)),A2),K)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_altdef_of_nat
tff(fact_4968_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [K: nat,A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),semiring_char_0_fact(A,K)),aa(nat,A,gbinomial(A,A2),K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_kc(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact
tff(fact_4969_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,K: nat] : ( aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,A2),K)),semiring_char_0_fact(A,K)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_kc(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)) ) ) ).

% gbinomial_mult_fact'
tff(fact_4970_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [A2: A,K: nat] : ( aa(nat,A,gbinomial(A,A2),K) = divide_divide(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aTP_Lamp_bp(A,fun(nat,A),A2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),K)),semiring_char_0_fact(A,K)) ) ) ).

% gbinomial_prod_rev
tff(fact_4971_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [N: nat,A2: fun(nat,A),B2: fun(nat,A)] :
          ( ! [I2: nat,J2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),N)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A2,I2)),aa(nat,A,A2,J2)) ) )
         => ( ! [I2: nat,J2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
               => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),N)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,B2,J2)),aa(nat,A,B2,I2)) ) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_kd(fun(nat,A),fun(fun(nat,A),fun(nat,A)),A2),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))) ) ) ) ).

% Chebyshev_sum_upper
tff(fact_4972_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A2: fun(nat,nat),B2: fun(nat,nat)] :
      ( ! [I2: nat,J2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),N)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,A2,I2)),aa(nat,nat,A2,J2)) ) )
     => ( ! [I2: nat,J2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I2),J2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J2),N)
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,B2,J2)),aa(nat,nat,B2,I2)) ) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),N),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_ke(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),A2),B2)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),A2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),B2),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)))) ) ) ).

% Chebyshev_sum_upper_nat
tff(fact_4973_accp__subset,axiom,
    ! [A: $tType,R12: fun(A,fun(A,$o)),R23: fun(A,fun(A,$o))] :
      ( aa(fun(A,fun(A,$o)),$o,aa(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),$o),ord_less_eq(fun(A,fun(A,$o))),R12),R23)
     => aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),accp(A,R23)),accp(A,R12)) ) ).

% accp_subset
tff(fact_4974_card__atLeastLessThan__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or7035219750837199246ssThan(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L)) ) ).

% card_atLeastLessThan_int
tff(fact_4975_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L: int,U: int] : ( set_or7035219750837199246ssThan(int,L,aa(int,int,aa(int,fun(int,int),plus_plus(int),U),one_one(int))) = set_or1337092689740270186AtMost(int,L,U) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
tff(fact_4976_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( aa(set(int),nat,finite_card(int),set_or7035219750837199246ssThan(int,zero_zero(int),U)) = aa(int,nat,nat2,U) ) ).

% card_atLeastZeroLessThan_int
tff(fact_4977_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] : ( set_or7035219750837199246ssThan(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),L),one_one(int)),U) = set_or5935395276787703475ssThan(int,L,U) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
tff(fact_4978_accp__subset__induct,axiom,
    ! [A: $tType,D3: fun(A,$o),R2: fun(A,fun(A,$o)),Xa: A,P: fun(A,$o)] :
      ( aa(fun(A,$o),$o,aa(fun(A,$o),fun(fun(A,$o),$o),ord_less_eq(fun(A,$o)),D3),accp(A,R2))
     => ( ! [X: A,Z4: A] :
            ( aa(A,$o,D3,X)
           => ( aa(A,$o,aa(A,fun(A,$o),R2,Z4),X)
             => aa(A,$o,D3,Z4) ) )
       => ( aa(A,$o,D3,Xa)
         => ( ! [X: A] :
                ( aa(A,$o,D3,X)
               => ( ! [Z3: A] :
                      ( aa(A,$o,aa(A,fun(A,$o),R2,Z3),X)
                     => aa(A,$o,P,Z3) )
                 => aa(A,$o,P,X) ) )
           => aa(A,$o,P,Xa) ) ) ) ) ).

% accp_subset_induct
tff(fact_4979_prod__decode__aux_Opelims,axiom,
    ! [Xa: nat,Xaa: nat,Y: product_prod(nat,nat)] :
      ( ( aa(nat,product_prod(nat,nat),nat_prod_decode_aux(Xa),Xaa) = Y )
     => ( aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),Xaa))
       => ~ ( ( Y
              = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Xaa),Xa),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xaa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),Xaa)),aa(nat,product_prod(nat,nat),nat_prod_decode_aux(aa(nat,nat,suc,Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xaa),aa(nat,nat,suc,Xa)))) )
           => ~ aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),nat_pr5047031295181774490ux_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),Xaa)) ) ) ) ).

% prod_decode_aux.pelims
tff(fact_4980_int__ge__less__than2__def,axiom,
    ! [D2: int] : ( int_ge_less_than2(D2) = collect(product_prod(int,int),product_case_prod(int,int,$o,aTP_Lamp_kf(int,fun(int,fun(int,$o)),D2))) ) ).

% int_ge_less_than2_def
tff(fact_4981_int__ge__less__than__def,axiom,
    ! [D2: int] : ( int_ge_less_than(D2) = collect(product_prod(int,int),product_case_prod(int,int,$o,aTP_Lamp_kg(int,fun(int,fun(int,$o)),D2))) ) ).

% int_ge_less_than_def
tff(fact_4982_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F3: fun(nat,fun(A,A)),A2: nat,B2: nat,Acc: A] :
      ( aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),$o,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),F3),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),A2),aa(A,product_prod(nat,A),product_Pair(nat,A,B2),Acc))))
     => ( set_fo6178422350223883121st_nat(A,F3,A2,B2,Acc)
        = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),B2),A2),Acc,set_fo6178422350223883121st_nat(A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A2),one_one(nat)),B2,aa(A,A,aa(nat,fun(A,A),F3,A2),Acc))) ) ) ).

% fold_atLeastAtMost_nat.psimps
tff(fact_4983_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,Xa: fun(nat,fun(A,A)),Xaa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( set_fo6178422350223883121st_nat(A,Xa,Xaa,Xb,Xc) = Y )
     => ( aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),$o,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),Xa),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),Xaa),aa(A,product_prod(nat,A),product_Pair(nat,A,Xb),Xc))))
       => ~ ( ( Y
              = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xb),Xaa),Xc,set_fo6178422350223883121st_nat(A,Xa,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xaa),one_one(nat)),Xb,aa(A,A,aa(nat,fun(A,A),Xa,Xaa),Xc))) )
           => ~ aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),$o,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),Xa),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),Xaa),aa(A,product_prod(nat,A),product_Pair(nat,A,Xb),Xc)))) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
tff(fact_4984_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A3: fun(A,fun(B,$o)),B3: fun(A,fun(B,$o))] :
      ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),A3),B3)
     => aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),collect(product_prod(A,B),product_case_prod(A,B,$o,A3))),collect(product_prod(A,B),product_case_prod(A,B,$o,B3))) ) ).

% Collect_case_prod_mono
tff(fact_4985_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: fun(nat,fun(A,A)),A1: nat,A22: nat,A32: A,P: fun(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,$o))))] :
      ( aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),$o,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),A0),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),A1),aa(A,product_prod(nat,A),product_Pair(nat,A,A22),A32))))
     => ( ! [F4: fun(nat,fun(A,A)),A4: nat,B4: nat,Acc2: A] :
            ( aa(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),$o,accp(product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),set_fo1817059534552279752at_rel(A)),aa(product_prod(nat,product_prod(nat,A)),product_prod(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A))),product_Pair(fun(nat,fun(A,A)),product_prod(nat,product_prod(nat,A)),F4),aa(product_prod(nat,A),product_prod(nat,product_prod(nat,A)),product_Pair(nat,product_prod(nat,A),A4),aa(A,product_prod(nat,A),product_Pair(nat,A,B4),Acc2))))
           => ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),B4),A4)
               => aa(A,$o,aa(nat,fun(A,$o),aa(nat,fun(nat,fun(A,$o)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,$o))),P,F4),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),A4),one_one(nat))),B4),aa(A,A,aa(nat,fun(A,A),F4,A4),Acc2)) )
             => aa(A,$o,aa(nat,fun(A,$o),aa(nat,fun(nat,fun(A,$o)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,$o))),P,F4),A4),B4),Acc2) ) )
       => aa(A,$o,aa(nat,fun(A,$o),aa(nat,fun(nat,fun(A,$o)),aa(fun(nat,fun(A,A)),fun(nat,fun(nat,fun(A,$o))),P,A0),A1),A22),A32) ) ) ).

% fold_atLeastAtMost_nat.pinduct
tff(fact_4986_set__encode__insert,axiom,
    ! [A3: set(nat),N: nat] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( ~ member(nat,N,A3)
       => ( aa(set(nat),nat,nat_set_encode,aa(set(nat),set(nat),insert(nat,N),A3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),aa(set(nat),nat,nat_set_encode,A3)) ) ) ) ).

% set_encode_insert
tff(fact_4987_int__of__nat__def,axiom,
    code_T6385005292777649522of_nat = semiring_1_of_nat(int) ).

% int_of_nat_def
tff(fact_4988_divmod__step__integer__def,axiom,
    ! [L: num,Qr: product_prod(code_integer,code_integer)] : ( unique1321980374590559556d_step(code_integer,L,Qr) = aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_kh(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),Qr) ) ).

% divmod_step_integer_def
tff(fact_4989_finite__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% finite_Diff
tff(fact_4990_finite__Diff2,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))
      <=> aa(set(A),$o,finite_finite(A),A3) ) ) ).

% finite_Diff2
tff(fact_4991_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(set(A)),$o,finite_finite(set(A)),collect(set(A),aTP_Lamp_ki(set(A),fun(set(A),$o),A3))) ) ).

% finite_Collect_subsets
tff(fact_4992_finite__Collect__le__nat,axiom,
    ! [K: nat] : aa(set(nat),$o,finite_finite(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_aa(nat,fun(nat,$o)),K))) ).

% finite_Collect_le_nat
tff(fact_4993_sum_Oinfinite,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ~ aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = zero_zero(B) ) ) ) ).

% sum.infinite
tff(fact_4994_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( canoni5634975068530333245id_add(B)
     => ! [F6: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),F6)
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),F6) = zero_zero(B) )
          <=> ! [X4: A] :
                ( member(A,X4,F6)
               => ( aa(A,B,F3,X4) = zero_zero(B) ) ) ) ) ) ).

% sum_eq_0_iff
tff(fact_4995_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( semidom(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3) = zero_zero(B) )
          <=> ? [X4: A] :
                ( member(A,X4,A3)
                & ( aa(A,B,F3,X4) = zero_zero(B) ) ) ) ) ) ).

% prod_zero_iff
tff(fact_4996_prod_Oinfinite,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( ~ aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = one_one(B) ) ) ) ).

% prod.infinite
tff(fact_4997_card_Oinfinite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ~ aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) ) ) ).

% card.infinite
tff(fact_4998_finite__Diff__insert,axiom,
    ! [A: $tType,A3: set(A),A2: A,B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),B3)))
    <=> aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% finite_Diff_insert
tff(fact_4999_sum_Odelta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [S2: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_kj(A,fun(fun(A,B),fun(A,B)),A2),B2)),S2)
            = $ite(member(A,A2,S2),aa(A,B,B2,A2),zero_zero(B)) ) ) ) ).

% sum.delta'
tff(fact_5000_sum_Odelta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [S2: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_kk(A,fun(fun(A,B),fun(A,B)),A2),B2)),S2)
            = $ite(member(A,A2,S2),aa(A,B,B2,A2),zero_zero(B)) ) ) ) ).

% sum.delta
tff(fact_5001_prod__eq__1__iff,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7121269368397514597t_prod(A,nat),F3),A3) = one_one(nat) )
      <=> ! [X4: A] :
            ( member(A,X4,A3)
           => ( aa(A,nat,F3,X4) = one_one(nat) ) ) ) ) ).

% prod_eq_1_iff
tff(fact_5002_prod_Odelta_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_kl(A,fun(fun(A,B),fun(A,B)),A2),B2)),S2)
            = $ite(member(A,A2,S2),aa(A,B,B2,A2),one_one(B)) ) ) ) ).

% prod.delta'
tff(fact_5003_prod_Odelta,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),A2: A,B2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_km(A,fun(fun(A,B),fun(A,B)),A2),B2)),S2)
            = $ite(member(A,A2,S2),aa(A,B,B2,A2),one_one(B)) ) ) ) ).

% prod.delta
tff(fact_5004_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A3: set(nat),F3: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),A3)
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kn(set(nat),fun(fun(nat,A),fun(nat,A)),A3),F3)) ) ) ).

% summable_If_finite_set
tff(fact_5005_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,$o),F3: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),collect(nat,P))
         => summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ko(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),P),F3)) ) ) ).

% summable_If_finite
tff(fact_5006_set__encode__inverse,axiom,
    ! [A3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( nat_set_decode(aa(set(nat),nat,nat_set_encode,A3)) = A3 ) ) ).

% set_encode_inverse
tff(fact_5007_sum_Oinsert,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),Xa: A,G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ~ member(A,Xa,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum.insert
tff(fact_5008_prod_Oinsert,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),Xa: A,G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ~ member(A,Xa,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)) ) ) ) ) ).

% prod.insert
tff(fact_5009_card__0__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) )
      <=> ( A3 = bot_bot(set(A)) ) ) ) ).

% card_0_eq
tff(fact_5010_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ~ member(A,Xa,A3)
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,Xa),A3)) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),A3)) ) ) ) ).

% card_insert_disjoint
tff(fact_5011_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7121269368397514597t_prod(A,nat),F3),A3))
      <=> ! [X4: A] :
            ( member(A,X4,A3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(A,nat,F3,X4)) ) ) ) ).

% prod_pos_nat_iff
tff(fact_5012_sum__zero__power,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [C2: fun(nat,A),A3: set(nat)] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aTP_Lamp_kp(fun(nat,A),fun(nat,A),C2)),A3)
          = $ite(
              ( aa(set(nat),$o,finite_finite(nat),A3)
              & member(nat,zero_zero(nat),A3) ),
              aa(nat,A,C2,zero_zero(nat)),
              zero_zero(A) ) ) ) ).

% sum_zero_power
tff(fact_5013_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [C2: fun(nat,A),D2: fun(nat,A),A3: set(nat)] :
          ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_kq(fun(nat,A),fun(fun(nat,A),fun(nat,A)),C2),D2)),A3)
          = $ite(
              ( aa(set(nat),$o,finite_finite(nat),A3)
              & member(nat,zero_zero(nat),A3) ),
              divide_divide(A,aa(nat,A,C2,zero_zero(nat)),aa(nat,A,D2,zero_zero(nat))),
              zero_zero(A) ) ) ) ).

% sum_zero_power'
tff(fact_5014_sgn__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,code_integer,sgn_sgn(code_integer),K)
      = $ite(
          K = zero_zero(code_integer),
          zero_zero(code_integer),
          $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),aa(code_integer,code_integer,uminus_uminus(code_integer),one_one(code_integer)),one_one(code_integer)) ) ) ).

% sgn_integer_code
tff(fact_5015_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),zero_zero(code_integer)),L) = L ) ).

% plus_integer_code(2)
tff(fact_5016_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),K),zero_zero(code_integer)) = K ) ).

% plus_integer_code(1)
tff(fact_5017_finite__set__decode,axiom,
    ! [N: nat] : aa(set(nat),$o,finite_finite(nat),nat_set_decode(N)) ).

% finite_set_decode
tff(fact_5018_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),K),zero_zero(code_integer)) = K ) ).

% minus_integer_code(1)
tff(fact_5019_Diff__infinite__finite,axiom,
    ! [A: $tType,T5: set(A),S2: set(A)] :
      ( aa(set(A),$o,finite_finite(A),T5)
     => ( ~ aa(set(A),$o,finite_finite(A),S2)
       => ~ aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T5)) ) ) ).

% Diff_infinite_finite
tff(fact_5020_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),zero_zero(code_integer)),L) = aa(code_integer,code_integer,uminus_uminus(code_integer),L) ) ).

% minus_integer_code(2)
tff(fact_5021_times__integer__code_I2_J,axiom,
    ! [L: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),zero_zero(code_integer)),L) = zero_zero(code_integer) ) ).

% times_integer_code(2)
tff(fact_5022_times__integer__code_I1_J,axiom,
    ! [K: code_integer] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),K),zero_zero(code_integer)) = zero_zero(code_integer) ) ).

% times_integer_code(1)
tff(fact_5023_finite__less__ub,axiom,
    ! [F3: fun(nat,nat),U: nat] :
      ( ! [N2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N2),aa(nat,nat,F3,N2))
     => aa(set(nat),$o,finite_finite(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_kr(fun(nat,nat),fun(nat,fun(nat,$o)),F3),U))) ) ).

% finite_less_ub
tff(fact_5024_finite__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => aa(set(A),$o,finite_finite(A),A3) ) ) ).

% finite_subset
tff(fact_5025_infinite__super,axiom,
    ! [A: $tType,S2: set(A),T5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
     => ( ~ aa(set(A),$o,finite_finite(A),S2)
       => ~ aa(set(A),$o,finite_finite(A),T5) ) ) ).

% infinite_super
tff(fact_5026_rev__finite__subset,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
       => aa(set(A),$o,finite_finite(A),A3) ) ) ).

% rev_finite_subset
tff(fact_5027_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => ? [X: A] :
                ( member(A,X,A3)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),A2)
                & ! [Xa2: A] :
                    ( member(A,Xa2,A3)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa2),X)
                     => ( X = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal2
tff(fact_5028_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => ? [X: A] :
                ( member(A,X,A3)
                & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X)
                & ! [Xa2: A] :
                    ( member(A,Xa2,A3)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Xa2)
                     => ( X = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal2
tff(fact_5029_finite__nat__set__iff__bounded__le,axiom,
    ! [N6: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),N6)
    <=> ? [M6: nat] :
        ! [X4: nat] :
          ( member(nat,X4,N6)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),M6) ) ) ).

% finite_nat_set_iff_bounded_le
tff(fact_5030_less__eq__integer__code_I1_J,axiom,
    aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ).

% less_eq_integer_code(1)
tff(fact_5031_set__encode__eq,axiom,
    ! [A3: set(nat),B3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( aa(set(nat),$o,finite_finite(nat),B3)
       => ( ( aa(set(nat),nat,nat_set_encode,A3) = aa(set(nat),nat,nat_set_encode,B3) )
        <=> ( A3 = B3 ) ) ) ) ).

% set_encode_eq
tff(fact_5032_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ? [X: A] :
                ( member(A,X,A3)
                & ! [Xa2: A] :
                    ( member(A,Xa2,A3)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa2),X)
                     => ( X = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
tff(fact_5033_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ? [X: A] :
                ( member(A,X,A3)
                & ! [Xa2: A] :
                    ( member(A,Xa2,A3)
                   => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Xa2)
                     => ( X = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
tff(fact_5034_sum__mono__inv,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere8940638589300402666id_add(A)
     => ! [F3: fun(B,A),I5: set(B),G: fun(B,A),I: B] :
          ( ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),F3),I5) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),I5) )
         => ( ! [I2: B] :
                ( member(B,I2,I5)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,I2)),aa(B,A,G,I2)) )
           => ( member(B,I,I5)
             => ( aa(set(B),$o,finite_finite(B),I5)
               => ( aa(B,A,F3,I) = aa(B,A,G,I) ) ) ) ) ) ) ).

% sum_mono_inv
tff(fact_5035_prod__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ? [X3: A] :
                ( member(A,X3,A3)
                & ( aa(A,B,F3,X3) = zero_zero(B) ) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3) = zero_zero(B) ) ) ) ) ).

% prod_zero
tff(fact_5036_summable__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N6: set(nat),F3: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),N6)
         => ( ! [N2: nat] :
                ( ~ member(nat,N2,N6)
               => ( aa(nat,A,F3,N2) = zero_zero(A) ) )
           => summable(A,F3) ) ) ) ).

% summable_finite
tff(fact_5037_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( ~ aa(set(A),$o,finite_finite(A),A3)
     => ? [B9: set(A)] :
          ( aa(set(A),$o,finite_finite(A),B9)
          & ( aa(set(A),nat,finite_card(A),B9) = N )
          & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B9),A3) ) ) ).

% infinite_arbitrarily_large
tff(fact_5038_card__subset__eq,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
       => ( ( aa(set(A),nat,finite_card(A),A3) = aa(set(A),nat,finite_card(A),B3) )
         => ( A3 = B3 ) ) ) ) ).

% card_subset_eq
tff(fact_5039_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B3: set(A),A3: set(B),R: fun(B,fun(A,$o))] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( ! [A4: B] :
            ( member(B,A4,A3)
           => ? [B10: A] :
                ( member(A,B10,B3)
                & aa(A,$o,aa(B,fun(A,$o),R,A4),B10) ) )
       => ( ! [A12: B,A23: B,B4: A] :
              ( member(B,A12,A3)
             => ( member(B,A23,A3)
               => ( member(A,B4,B3)
                 => ( aa(A,$o,aa(B,fun(A,$o),R,A12),B4)
                   => ( aa(A,$o,aa(B,fun(A,$o),R,A23),B4)
                     => ( A12 = A23 ) ) ) ) ) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(B),nat,finite_card(B),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ).

% card_le_if_inj_on_rel
tff(fact_5040_sum_Ofinite__Collect__op,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),Xa: fun(A,B),Y: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ks(set(A),fun(fun(A,B),fun(A,$o)),I5),Xa)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ks(set(A),fun(fun(A,B),fun(A,$o)),I5),Y)))
           => aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_kt(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),I5),Xa),Y))) ) ) ) ).

% sum.finite_Collect_op
tff(fact_5041_prod_Ofinite__Collect__op,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),Xa: fun(A,B),Y: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ku(set(A),fun(fun(A,B),fun(A,$o)),I5),Xa)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ku(set(A),fun(fun(A,B),fun(A,$o)),I5),Y)))
           => aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_kv(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),I5),Xa),Y))) ) ) ) ).

% prod.finite_Collect_op
tff(fact_5042_sum_Ointer__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),P: fun(A,$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,$o),fun(A,B),aTP_Lamp_kw(fun(A,B),fun(fun(A,$o),fun(A,B)),G),P)),A3) ) ) ) ).

% sum.inter_filter
tff(fact_5043_set__encode__inf,axiom,
    ! [A3: set(nat)] :
      ( ~ aa(set(nat),$o,finite_finite(nat),A3)
     => ( aa(set(nat),nat,nat_set_encode,A3) = zero_zero(nat) ) ) ).

% set_encode_inf
tff(fact_5044_prod_Ointer__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),P: fun(A,$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),A3),P))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,$o),fun(A,B),aTP_Lamp_kx(fun(A,B),fun(fun(A,$o),fun(A,B)),G),P)),A3) ) ) ) ).

% prod.inter_filter
tff(fact_5045_finite__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A,B2: A] : aa(set(A),$o,finite_finite(A),collect(A,aa(A,fun(A,$o),aTP_Lamp_ky(A,fun(A,fun(A,$o)),A2),B2))) ) ).

% finite_int_segment
tff(fact_5046_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X: A] :
                ( member(A,X,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3) = zero_zero(B) )
            <=> ! [X4: A] :
                  ( member(A,X4,A3)
                 => ( aa(A,B,F3,X4) = zero_zero(B) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
tff(fact_5047_sum__le__included,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(C)
     => ! [S: set(A),T2: set(B),G: fun(B,C),I: fun(B,A),F3: fun(A,C)] :
          ( aa(set(A),$o,finite_finite(A),S)
         => ( aa(set(B),$o,finite_finite(B),T2)
           => ( ! [X: B] :
                  ( member(B,X,T2)
                 => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),zero_zero(C)),aa(B,C,G,X)) )
             => ( ! [X: A] :
                    ( member(A,X,S)
                   => ? [Xa2: B] :
                        ( member(B,Xa2,T2)
                        & ( aa(B,A,I,Xa2) = X )
                        & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,X)),aa(B,C,G,Xa2)) ) )
               => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),F3),S)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),T2)) ) ) ) ) ) ).

% sum_le_included
tff(fact_5048_sum__strict__mono__ex1,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X: A] :
                ( member(A,X,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
           => ( ? [X3: A] :
                  ( member(A,X3,A3)
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,X3)),aa(A,B,G,X3)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)) ) ) ) ) ).

% sum_strict_mono_ex1
tff(fact_5049_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [R2: fun(A,fun(A,$o)),S2: set(B),H: fun(B,A),G: fun(B,A)] :
          ( aa(A,$o,aa(A,fun(A,$o),R2,zero_zero(A)),zero_zero(A))
         => ( ! [X1: A,Y1: A,X22: A,Y22: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),R2,X1),X22)
                  & aa(A,$o,aa(A,fun(A,$o),R2,Y1),Y22) )
               => aa(A,$o,aa(A,fun(A,$o),R2,aa(A,A,aa(A,fun(A,A),plus_plus(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),plus_plus(A),X22),Y22)) )
           => ( aa(set(B),$o,finite_finite(B),S2)
             => ( ! [X: B] :
                    ( member(B,X,S2)
                   => aa(A,$o,aa(A,fun(A,$o),R2,aa(B,A,H,X)),aa(B,A,G,X)) )
               => aa(A,$o,aa(A,fun(A,$o),R2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),H),S2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),S2)) ) ) ) ) ) ).

% sum.related
tff(fact_5050_finite__ranking__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [S2: set(A),P: fun(set(A),$o),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),$o,P,bot_bot(set(A)))
           => ( ! [X: A,S4: set(A)] :
                  ( aa(set(A),$o,finite_finite(A),S4)
                 => ( ! [Y4: A] :
                        ( member(A,Y4,S4)
                       => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Y4)),aa(A,B,F3,X)) )
                   => ( aa(set(A),$o,P,S4)
                     => aa(set(A),$o,P,aa(set(A),set(A),insert(A,X),S4)) ) ) )
             => aa(set(A),$o,P,S2) ) ) ) ) ).

% finite_ranking_induct
tff(fact_5051_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [R2: fun(A,fun(A,$o)),S2: set(B),H: fun(B,A),G: fun(B,A)] :
          ( aa(A,$o,aa(A,fun(A,$o),R2,one_one(A)),one_one(A))
         => ( ! [X1: A,Y1: A,X22: A,Y22: A] :
                ( ( aa(A,$o,aa(A,fun(A,$o),R2,X1),X22)
                  & aa(A,$o,aa(A,fun(A,$o),R2,Y1),Y22) )
               => aa(A,$o,aa(A,fun(A,$o),R2,aa(A,A,aa(A,fun(A,A),times_times(A),X1),Y1)),aa(A,A,aa(A,fun(A,A),times_times(A),X22),Y22)) )
           => ( aa(set(B),$o,finite_finite(B),S2)
             => ( ! [X: B] :
                    ( member(B,X,S2)
                   => aa(A,$o,aa(A,fun(A,$o),R2,aa(B,A,H,X)),aa(B,A,G,X)) )
               => aa(A,$o,aa(A,fun(A,$o),R2,aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),H),S2)),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),S2)) ) ) ) ) ) ).

% prod.related
tff(fact_5052_sum_Oinsert__if,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,Xa),A3))
            = $ite(member(A,Xa,A3),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3))) ) ) ) ).

% sum.insert_if
tff(fact_5053_finite__subset__induct,axiom,
    ! [A: $tType,F6: set(A),A3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),F6)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),F6),A3)
       => ( aa(set(A),$o,P,bot_bot(set(A)))
         => ( ! [A4: A,F7: set(A)] :
                ( aa(set(A),$o,finite_finite(A),F7)
               => ( member(A,A4,A3)
                 => ( ~ member(A,A4,F7)
                   => ( aa(set(A),$o,P,F7)
                     => aa(set(A),$o,P,aa(set(A),set(A),insert(A,A4),F7)) ) ) ) )
           => aa(set(A),$o,P,F6) ) ) ) ) ).

% finite_subset_induct
tff(fact_5054_finite__subset__induct_H,axiom,
    ! [A: $tType,F6: set(A),A3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),F6)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),F6),A3)
       => ( aa(set(A),$o,P,bot_bot(set(A)))
         => ( ! [A4: A,F7: set(A)] :
                ( aa(set(A),$o,finite_finite(A),F7)
               => ( member(A,A4,A3)
                 => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),F7),A3)
                   => ( ~ member(A,A4,F7)
                     => ( aa(set(A),$o,P,F7)
                       => aa(set(A),$o,P,aa(set(A),set(A),insert(A,A4),F7)) ) ) ) ) )
           => aa(set(A),$o,P,F6) ) ) ) ) ).

% finite_subset_induct'
tff(fact_5055_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S5: set(A),T6: set(B),S2: set(A),I: fun(B,A),J: fun(A,B),T5: set(B),G: fun(A,C),H: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S5)
         => ( aa(set(B),$o,finite_finite(B),T6)
           => ( ! [A4: A] :
                  ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5))
                 => ( aa(B,A,I,aa(A,B,J,A4)) = A4 ) )
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5))
                   => member(B,aa(A,B,J,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6)) )
               => ( ! [B4: B] :
                      ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6))
                     => ( aa(A,B,J,aa(B,A,I,B4)) = B4 ) )
                 => ( ! [B4: B] :
                        ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6))
                       => member(A,aa(B,A,I,B4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5)) )
                   => ( ! [A4: A] :
                          ( member(A,A4,S5)
                         => ( aa(A,C,G,A4) = zero_zero(C) ) )
                     => ( ! [B4: B] :
                            ( member(B,B4,T6)
                           => ( aa(B,C,H,B4) = zero_zero(C) ) )
                       => ( ! [A4: A] :
                              ( member(A,A4,S2)
                             => ( aa(B,C,H,aa(A,B,J,A4)) = aa(A,C,G,A4) ) )
                         => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),G),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),H),T5) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
tff(fact_5056_prod_Oinsert__if,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),insert(A,Xa),A3))
            = $ite(member(A,Xa,A3),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3))) ) ) ) ).

% prod.insert_if
tff(fact_5057_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( aa(set(A),nat,finite_card(A),A3) = zero_zero(nat) )
    <=> ( ( A3 = bot_bot(set(A)) )
        | ~ aa(set(A),$o,finite_finite(A),A3) ) ) ).

% card_eq_0_iff
tff(fact_5058_finite__empty__induct,axiom,
    ! [A: $tType,A3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,P,A3)
       => ( ! [A4: A,A6: set(A)] :
              ( aa(set(A),$o,finite_finite(A),A6)
             => ( member(A,A4,A6)
               => ( aa(set(A),$o,P,A6)
                 => aa(set(A),$o,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A6),aa(set(A),set(A),insert(A,A4),bot_bot(set(A))))) ) ) )
         => aa(set(A),$o,P,bot_bot(set(A))) ) ) ) ).

% finite_empty_induct
tff(fact_5059_infinite__coinduct,axiom,
    ! [A: $tType,X6: fun(set(A),$o),A3: set(A)] :
      ( aa(set(A),$o,X6,A3)
     => ( ! [A6: set(A)] :
            ( aa(set(A),$o,X6,A6)
           => ? [X3: A] :
                ( member(A,X3,A6)
                & ( aa(set(A),$o,X6,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A6),aa(set(A),set(A),insert(A,X3),bot_bot(set(A)))))
                  | ~ aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A6),aa(set(A),set(A),insert(A,X3),bot_bot(set(A))))) ) ) )
       => ~ aa(set(A),$o,finite_finite(A),A3) ) ) ).

% infinite_coinduct
tff(fact_5060_infinite__remove,axiom,
    ! [A: $tType,S2: set(A),A2: A] :
      ( ~ aa(set(A),$o,finite_finite(A),S2)
     => ~ aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) ) ).

% infinite_remove
tff(fact_5061_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A3))
     => aa(set(A),$o,finite_finite(A),A3) ) ).

% card_ge_0_finite
tff(fact_5062_prod__dvd__prod__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [B3: set(A),A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),B3)) ) ) ) ).

% prod_dvd_prod_subset
tff(fact_5063_prod__dvd__prod__subset2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(B)
     => ! [B3: set(A),A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( ! [A4: A] :
                  ( member(A,A4,A3)
                 => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F3,A4)),aa(A,B,G,A4)) )
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ).

% prod_dvd_prod_subset2
tff(fact_5064_card__insert__if,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,Xa),A3))
        = $ite(member(A,Xa,A3),aa(set(A),nat,finite_card(A),A3),aa(nat,nat,suc,aa(set(A),nat,finite_card(A),A3))) ) ) ).

% card_insert_if
tff(fact_5065_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,K) )
    <=> ? [B7: A,B8: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,B7),B8) )
          & ~ member(A,B7,B8)
          & ( aa(set(A),nat,finite_card(A),B8) = K )
          & aa(set(A),$o,finite_finite(A),B8) ) ) ).

% card_Suc_eq_finite
tff(fact_5066_card__mono,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ).

% card_mono
tff(fact_5067_card__seteq,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),B3)),aa(set(A),nat,finite_card(A),A3))
         => ( A3 = B3 ) ) ) ) ).

% card_seteq
tff(fact_5068_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F6: set(A),C5: nat] :
      ( ! [G2: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),G2),F6)
         => ( aa(set(A),$o,finite_finite(A),G2)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),G2)),C5) ) )
     => ( aa(set(A),$o,finite_finite(A),F6)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),F6)),C5) ) ) ).

% finite_if_finite_subsets_card_bdd
tff(fact_5069_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S2: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(set(A),nat,finite_card(A),S2))
     => ~ ! [T7: set(A)] :
            ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T7),S2)
           => ( ( aa(set(A),nat,finite_card(A),T7) = N )
             => ~ aa(set(A),$o,finite_finite(A),T7) ) ) ) ).

% obtain_subset_with_card_n
tff(fact_5070_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S5: set(A),T6: set(B),S2: set(A),I: fun(B,A),J: fun(A,B),T5: set(B),G: fun(A,C),H: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S5)
         => ( aa(set(B),$o,finite_finite(B),T6)
           => ( ! [A4: A] :
                  ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5))
                 => ( aa(B,A,I,aa(A,B,J,A4)) = A4 ) )
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5))
                   => member(B,aa(A,B,J,A4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6)) )
               => ( ! [B4: B] :
                      ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6))
                     => ( aa(A,B,J,aa(B,A,I,B4)) = B4 ) )
                 => ( ! [B4: B] :
                        ( member(B,B4,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6))
                       => member(A,aa(B,A,I,B4),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5)) )
                   => ( ! [A4: A] :
                          ( member(A,A4,S5)
                         => ( aa(A,C,G,A4) = one_one(C) ) )
                     => ( ! [B4: B] :
                            ( member(B,B4,T6)
                           => ( aa(B,C,H,B4) = one_one(C) ) )
                       => ( ! [A4: A] :
                              ( member(A,A4,S2)
                             => ( aa(B,C,H,aa(A,B,J,A4)) = aa(A,C,G,A4) ) )
                         => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),G),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),H),T5) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
tff(fact_5071_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))) ) ) ) ).

% card_less_sym_Diff
tff(fact_5072_card__le__sym__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))) ) ) ) ).

% card_le_sym_Diff
tff(fact_5073_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set(A)] :
      ( aa(set(A),$o,finite_finite(A),M7)
     => ? [H3: fun(A,nat)] : bij_betw(A,nat,H3,M7,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(A),nat,finite_card(A),M7))) ) ).

% ex_bij_betw_finite_nat
tff(fact_5074_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3) = aa(nat,nat,suc,zero_zero(nat)) )
      <=> ? [X4: A] :
            ( member(A,X4,A3)
            & ( aa(A,nat,F3,X4) = aa(nat,nat,suc,zero_zero(nat)) )
            & ! [Xa3: A] :
                ( member(A,Xa3,A3)
               => ( ( X4 != Xa3 )
                 => ( aa(A,nat,F3,Xa3) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
tff(fact_5075_zero__natural_Orsp,axiom,
    zero_zero(nat) = zero_zero(nat) ).

% zero_natural.rsp
tff(fact_5076_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3) = one_one(nat) )
      <=> ? [X4: A] :
            ( member(A,X4,A3)
            & ( aa(A,nat,F3,X4) = one_one(nat) )
            & ! [Xa3: A] :
                ( member(A,Xa3,A3)
               => ( ( X4 != Xa3 )
                 => ( aa(A,nat,F3,Xa3) = zero_zero(nat) ) ) ) ) ) ) ).

% sum_eq_1_iff
tff(fact_5077_zero__integer_Orsp,axiom,
    zero_zero(int) = zero_zero(int) ).

% zero_integer.rsp
tff(fact_5078_sum__nonneg__leq__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [S: set(A),F3: fun(A,B),B3: B,I: A] :
          ( aa(set(A),$o,finite_finite(A),S)
         => ( ! [I2: A] :
                ( member(A,I2,S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),S) = B3 )
             => ( member(A,I,S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I)),B3) ) ) ) ) ) ).

% sum_nonneg_leq_bound
tff(fact_5079_sum__nonneg__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [S: set(A),F3: fun(A,B),I: A] :
          ( aa(set(A),$o,finite_finite(A),S)
         => ( ! [I2: A] :
                ( member(A,I2,S)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2)) )
           => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),S) = zero_zero(B) )
             => ( member(A,I,S)
               => ( aa(A,B,F3,I) = zero_zero(B) ) ) ) ) ) ) ).

% sum_nonneg_0
tff(fact_5080_one__integer_Orsp,axiom,
    one_one(int) = one_one(int) ).

% one_integer.rsp
tff(fact_5081_one__natural_Orsp,axiom,
    one_one(nat) = one_one(nat) ).

% one_natural.rsp
tff(fact_5082_sum_Osetdiff__irrelevant,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),collect(A,aTP_Lamp_kz(fun(A,B),fun(A,$o),G)))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) ) ) ) ).

% sum.setdiff_irrelevant
tff(fact_5083_prod_Osetdiff__irrelevant,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),collect(A,aTP_Lamp_la(fun(A,B),fun(A,$o),G)))) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) ) ) ) ).

% prod.setdiff_irrelevant
tff(fact_5084_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M)
     => aa(set(nat),$o,finite_finite(nat),collect(nat,aTP_Lamp_lb(nat,fun(nat,$o),M))) ) ).

% finite_divisors_nat
tff(fact_5085_sums__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [N6: set(nat),F3: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),N6)
         => ( ! [N2: nat] :
                ( ~ member(nat,N2,N6)
               => ( aa(nat,A,F3,N2) = zero_zero(A) ) )
           => sums(A,F3,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),N6)) ) ) ) ).

% sums_finite
tff(fact_5086_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [P: fun(nat,$o),F3: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),collect(nat,P))
         => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ko(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),P),F3),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),collect(nat,P))) ) ) ).

% sums_If_finite
tff(fact_5087_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [A3: set(nat),F3: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),A3)
         => sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kn(set(nat),fun(fun(nat,A),fun(nat,A)),A3),F3),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),A3)) ) ) ).

% sums_If_finite_set
tff(fact_5088_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [N6: set(nat),F3: fun(nat,A)] :
          ( aa(set(nat),$o,finite_finite(nat),N6)
         => ( ! [N2: nat] :
                ( ~ member(nat,N2,N6)
               => ( aa(nat,A,F3,N2) = zero_zero(A) ) )
           => ( suminf(A,F3) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),N6) ) ) ) ) ).

% suminf_finite
tff(fact_5089_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [A2: A] : aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_lc(A,fun(A,$o),A2))) ) ).

% finite_abs_int_segment
tff(fact_5090_exp__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_Vector_banach(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [I5: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( aa(B,B,exp(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),I5)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aTP_Lamp_ld(fun(A,B),fun(A,B),F3)),I5) ) ) ) ).

% exp_sum
tff(fact_5091_n__subsets,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(set(A)),nat,finite_card(set(A)),collect(set(A),aa(nat,fun(set(A),$o),aTP_Lamp_le(set(A),fun(nat,fun(set(A),$o)),A3),K))) = aa(nat,nat,binomial(aa(set(A),nat,finite_card(A),A3)),K) ) ) ).

% n_subsets
tff(fact_5092_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N6: set(nat),N: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N6),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))
     => aa(set(nat),$o,finite_finite(nat),N6) ) ).

% subset_eq_atLeast0_atMost_finite
tff(fact_5093_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N6: set(nat),N: nat] :
      ( aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),N6),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))
     => aa(set(nat),$o,finite_finite(nat),N6) ) ).

% subset_eq_atLeast0_lessThan_finite
tff(fact_5094_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set(A),T5: set(B),R2: fun(A,fun(B,$o)),K: nat] :
      ( aa(set(A),$o,finite_finite(A),S2)
     => ( aa(set(B),$o,finite_finite(B),T5)
       => ( ! [X: B] :
              ( member(B,X,T5)
             => ( aa(set(A),nat,finite_card(A),collect(A,aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_lf(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),S2),R2),X))) = K ) )
         => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,fun(B,$o)),fun(A,nat),aTP_Lamp_lh(set(B),fun(fun(A,fun(B,$o)),fun(A,nat)),T5),R2)),S2) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(B),nat,finite_card(B),T5)) ) ) ) ) ).

% sum_multicount
tff(fact_5095_sum__pos2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),I: A,F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( member(A,I,I5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,I))
             => ( ! [I2: A] :
                    ( member(A,I2,I5)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),I5)) ) ) ) ) ) ).

% sum_pos2
tff(fact_5096_sum__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( ( I5 != bot_bot(set(A)) )
           => ( ! [I2: A] :
                  ( member(A,I2,I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,I2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),I5)) ) ) ) ) ).

% sum_pos
tff(fact_5097_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),I: A,F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( member(A,I,I5)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(A,B,F3,I))
             => ( ! [I2: A] :
                    ( member(A,I2,I5)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F3,I2)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),I5)) ) ) ) ) ) ).

% less_1_prod2
tff(fact_5098_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [I5: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( ( I5 != bot_bot(set(A)) )
           => ( ! [I2: A] :
                  ( member(A,I2,I5)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(A,B,F3,I2)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),one_one(B)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),I5)) ) ) ) ) ).

% less_1_prod
tff(fact_5099_sum_Osame__carrier,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [C5: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),A3))
                   => ( aa(A,B,G,A4) = zero_zero(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),B3))
                     => ( aa(A,B,H,B4) = zero_zero(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),B3) )
                  <=> ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),C5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),C5) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
tff(fact_5100_sum_Osame__carrierI,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [C5: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),A3))
                   => ( aa(A,B,G,A4) = zero_zero(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),B3))
                     => ( aa(A,B,H,B4) = zero_zero(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),C5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),C5) )
                   => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),B3) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
tff(fact_5101_sum_Omono__neutral__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S2: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,G,X) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S2) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T5) ) ) ) ) ) ).

% sum.mono_neutral_left
tff(fact_5102_sum_Omono__neutral__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S2: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,G,X) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S2) ) ) ) ) ) ).

% sum.mono_neutral_right
tff(fact_5103_sum_Omono__neutral__cong__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S2: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,H,X) = zero_zero(B) ) )
             => ( ! [X: A] :
                    ( member(A,X,S2)
                   => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S2) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),T5) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
tff(fact_5104_sum_Omono__neutral__cong__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S2: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,G,X) = zero_zero(B) ) )
             => ( ! [X: A] :
                    ( member(A,X,S2)
                   => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),S2) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
tff(fact_5105_sum_Osubset__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [B3: set(A),A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ).

% sum.subset_diff
tff(fact_5106_sum__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [A3: set(A),B3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),B3)) ) ) ) ) ).

% sum_diff
tff(fact_5107_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),A3))
    <=> ( ( A3 != bot_bot(set(A)) )
        & aa(set(A),$o,finite_finite(A),A3) ) ) ).

% card_gt_0_iff
tff(fact_5108_remove__induct,axiom,
    ! [A: $tType,P: fun(set(A),$o),B3: set(A)] :
      ( aa(set(A),$o,P,bot_bot(set(A)))
     => ( ( ~ aa(set(A),$o,finite_finite(A),B3)
         => aa(set(A),$o,P,B3) )
       => ( ! [A6: set(A)] :
              ( aa(set(A),$o,finite_finite(A),A6)
             => ( ( A6 != bot_bot(set(A)) )
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A6),B3)
                 => ( ! [X3: A] :
                        ( member(A,X3,A6)
                       => aa(set(A),$o,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A6),aa(set(A),set(A),insert(A,X3),bot_bot(set(A))))) )
                   => aa(set(A),$o,P,A6) ) ) ) )
         => aa(set(A),$o,P,B3) ) ) ) ).

% remove_induct
tff(fact_5109_finite__remove__induct,axiom,
    ! [A: $tType,B3: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,P,bot_bot(set(A)))
       => ( ! [A6: set(A)] :
              ( aa(set(A),$o,finite_finite(A),A6)
             => ( ( A6 != bot_bot(set(A)) )
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A6),B3)
                 => ( ! [X3: A] :
                        ( member(A,X3,A6)
                       => aa(set(A),$o,P,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A6),aa(set(A),set(A),insert(A,X3),bot_bot(set(A))))) )
                   => aa(set(A),$o,P,A6) ) ) ) )
         => aa(set(A),$o,P,B3) ) ) ) ).

% finite_remove_induct
tff(fact_5110_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(nat,nat,suc,zero_zero(nat)))
      <=> ! [X4: A] :
            ( member(A,X4,A3)
           => ! [Xa3: A] :
                ( member(A,Xa3,A3)
               => ( X4 = Xa3 ) ) ) ) ) ).

% card_le_Suc0_iff_eq
tff(fact_5111_prod_Osubset__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [B3: set(A),A3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ).

% prod.subset_diff
tff(fact_5112_prod_Osame__carrier,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [C5: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),A3))
                   => ( aa(A,B,G,A4) = one_one(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),B3))
                     => ( aa(A,B,H,B4) = one_one(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),B3) )
                  <=> ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),C5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),C5) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
tff(fact_5113_prod_Osame__carrierI,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [C5: set(A),A3: set(A),B3: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),C5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
             => ( ! [A4: A] :
                    ( member(A,A4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),A3))
                   => ( aa(A,B,G,A4) = one_one(B) ) )
               => ( ! [B4: A] :
                      ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),C5),B3))
                     => ( aa(A,B,H,B4) = one_one(B) ) )
                 => ( ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),C5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),C5) )
                   => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),B3) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
tff(fact_5114_prod_Omono__neutral__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S2: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,G,X) = one_one(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S2) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),T5) ) ) ) ) ) ).

% prod.mono_neutral_left
tff(fact_5115_prod_Omono__neutral__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S2: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,G,X) = one_one(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S2) ) ) ) ) ) ).

% prod.mono_neutral_right
tff(fact_5116_prod_Omono__neutral__cong__left,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S2: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,H,X) = one_one(B) ) )
             => ( ! [X: A] :
                    ( member(A,X,S2)
                   => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S2) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),T5) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
tff(fact_5117_prod_Omono__neutral__cong__right,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S2: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,G,X) = one_one(B) ) )
             => ( ! [X: A] :
                    ( member(A,X,S2)
                   => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
               => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),T5) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),S2) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
tff(fact_5118_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(set(A),nat,finite_card(A),A3))
    <=> ? [A7: A,B8: set(A)] :
          ( ( A3 = aa(set(A),set(A),insert(A,A7),B8) )
          & ~ member(A,A7,B8)
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(set(A),nat,finite_card(A),B8))
          & aa(set(A),$o,finite_finite(A),B8) ) ) ).

% card_le_Suc_iff
tff(fact_5119_card__Diff__subset,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ).

% card_Diff_subset
tff(fact_5120_finite__induct__select,axiom,
    ! [A: $tType,S2: set(A),P: fun(set(A),$o)] :
      ( aa(set(A),$o,finite_finite(A),S2)
     => ( aa(set(A),$o,P,bot_bot(set(A)))
       => ( ! [T7: set(A)] :
              ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),T7),S2)
             => ( aa(set(A),$o,P,T7)
               => ? [X3: A] :
                    ( member(A,X3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T7))
                    & aa(set(A),$o,P,aa(set(A),set(A),insert(A,X3),T7)) ) ) )
         => aa(set(A),$o,P,S2) ) ) ) ).

% finite_induct_select
tff(fact_5121_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A3: set(A),A2: A] :
      ( ~ aa(set(A),$o,finite_finite(A),A3)
     => ? [H3: fun(A,A)] : bij_betw(A,A,H3,A3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) ) ).

% infinite_imp_bij_betw
tff(fact_5122_card__psubset,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),A3),B3) ) ) ) ).

% card_psubset
tff(fact_5123_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ).

% diff_card_le_card_Diff
tff(fact_5124_sum__diff__nat,axiom,
    ! [A: $tType,B3: set(A),A3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),B3)) ) ) ) ).

% sum_diff_nat
tff(fact_5125_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set(A)] :
      ( aa(set(A),$o,finite_finite(A),M7)
     => ? [H3: fun(nat,A)] : bij_betw(nat,A,H3,set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(set(A),nat,finite_card(A),M7)),M7) ) ).

% ex_bij_betw_nat_finite
tff(fact_5126_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [N: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),N)
         => aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aq(nat,fun(A,$o),N))) ) ) ).

% finite_roots_unity
tff(fact_5127_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M7: set(A)] :
      ( aa(set(A),$o,finite_finite(A),M7)
     => ? [H3: fun(nat,A)] : bij_betw(nat,A,H3,set_or1337092689740270186AtMost(nat,one_one(nat),aa(set(A),nat,finite_card(A),M7)),M7) ) ).

% ex_bij_betw_nat_finite_1
tff(fact_5128_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [S5: set(A),T6: set(B),H: fun(A,B),S2: set(A),T5: set(B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S5)
         => ( aa(set(B),$o,finite_finite(B),T6)
           => ( bij_betw(A,B,H,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6))
             => ( ! [A4: A] :
                    ( member(A,A4,S5)
                   => ( aa(B,C,G,aa(A,B,H,A4)) = zero_zero(C) ) )
               => ( ! [B4: B] :
                      ( member(B,B4,T6)
                     => ( aa(B,C,G,B4) = zero_zero(C) ) )
                 => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_li(fun(A,B),fun(fun(B,C),fun(A,C)),H),G)),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),T5) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
tff(fact_5129_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [G: fun(nat,A),S2: A,A3: set(nat),S5: A,F3: fun(nat,A)] :
          ( sums(A,G,S2)
         => ( aa(set(nat),$o,finite_finite(nat),A3)
           => ( ( S5 = aa(A,A,aa(A,fun(A,A),plus_plus(A),S2),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,A),fun(nat,A),aTP_Lamp_lj(fun(nat,A),fun(fun(nat,A),fun(nat,A)),G),F3)),A3)) )
             => sums(A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_lk(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),G),A3),F3),S5) ) ) ) ) ).

% sums_If_finite_set'
tff(fact_5130_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [S5: set(A),T6: set(B),H: fun(A,B),S2: set(A),T5: set(B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S5)
         => ( aa(set(B),$o,finite_finite(B),T6)
           => ( bij_betw(A,B,H,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),S5),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),T5),T6))
             => ( ! [A4: A] :
                    ( member(A,A4,S5)
                   => ( aa(B,C,G,aa(A,B,H,A4)) = one_one(C) ) )
               => ( ! [B4: B] :
                      ( member(B,B4,T6)
                     => ( aa(B,C,G,B4) = one_one(C) ) )
                 => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_ll(fun(A,B),fun(fun(B,C),fun(A,C)),H),G)),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),T5) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
tff(fact_5131_prod__mono__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_semidom(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [I2: A] :
                ( member(A,I2,A3)
               => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,I2))
                  & aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,I2)),aa(A,B,G,I2)) ) )
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)) ) ) ) ) ).

% prod_mono_strict
tff(fact_5132_sum__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [B3: set(A),A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( ! [B4: A] :
                  ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,B4)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),B3)) ) ) ) ) ).

% sum_mono2
tff(fact_5133_sum_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ).

% sum.insert_remove
tff(fact_5134_sum_Oremove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),Xa: A,G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ) ).

% sum.remove
tff(fact_5135_sum__diff1,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [A3: set(A),F3: fun(A,B),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))
            = $ite(member(A,A2,A3),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(A,B,F3,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)) ) ) ) ).

% sum_diff1
tff(fact_5136_prod_Oremove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),Xa: A,G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ) ).

% prod.remove
tff(fact_5137_prod_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,G,Xa)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ).

% prod.insert_remove
tff(fact_5138_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,Xa,A3)
       => ( aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) = aa(set(A),nat,finite_card(A),A3) ) ) ) ).

% card_Suc_Diff1
tff(fact_5139_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),insert(A,Xa),A3)) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ).

% card.insert_remove
tff(fact_5140_card_Oremove,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,Xa,A3)
       => ( aa(set(A),nat,finite_card(A),A3) = aa(nat,nat,suc,aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ).

% card.remove
tff(fact_5141_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3))
    <=> ( aa(set(A),$o,finite_finite(A),A3)
        & member(A,Xa,A3) ) ) ).

% card_Diff1_less_iff
tff(fact_5142_card__Diff2__less,axiom,
    ! [A: $tType,A3: set(A),Xa: A,Y: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,Xa,A3)
       => ( member(A,Y,A3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3)) ) ) ) ).

% card_Diff2_less
tff(fact_5143_card__Diff1__less,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( member(A,Xa,A3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))),aa(set(A),nat,finite_card(A),A3)) ) ) ).

% card_Diff1_less
tff(fact_5144_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(nat,A),I5: set(nat)] :
          ( summable(A,F3)
         => ( aa(set(nat),$o,finite_finite(nat),I5)
           => ( ! [N2: nat] :
                  ( member(nat,N2,aa(set(nat),set(nat),uminus_uminus(set(nat)),I5))
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(nat,A,F3,N2)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),I5)),suminf(A,F3)) ) ) ) ) ).

% sum_le_suminf
tff(fact_5145_sum_Odelta__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S2: set(A),A2: A,B2: fun(A,B),C2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_lm(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),B2),C2)),S2)
            = $ite(member(A,A2,S2),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,B2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% sum.delta_remove
tff(fact_5146_prod_Odelta__remove,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),A2: A,B2: fun(A,B),C2: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_ln(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),B2),C2)),S2)
            = $ite(member(A,A2,S2),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,B2,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),C2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% prod.delta_remove
tff(fact_5147_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ordere8940638589300402666id_add(B)
     => ! [B3: set(A),A3: set(A),B2: A,F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( member(A,B2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))
             => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),aa(A,B,F3,B2))
               => ( ! [X: A] :
                      ( member(A,X,B3)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X)) )
                 => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),B3)) ) ) ) ) ) ) ).

% sum_strict_mono2
tff(fact_5148_member__le__sum,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add(B)
        & semiring_1(B) )
     => ! [I: A,A3: set(A),F3: fun(A,B)] :
          ( member(A,I,A3)
         => ( ! [X: A] :
                ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,I),bot_bot(set(A)))))
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,X)) )
           => ( aa(set(A),$o,finite_finite(A),A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)) ) ) ) ) ).

% member_le_sum
tff(fact_5149_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [B3: set(A),A3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( ! [B4: A] :
                  ( member(A,B4,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),one_one(B)),aa(A,B,F3,B4)) )
             => ( ! [A4: A] :
                    ( member(A,A4,A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(A,B,F3,A4)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),B3)) ) ) ) ) ) ).

% prod_mono2
tff(fact_5150_sum__bounded__above__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( linordered_field(B)
     => ! [A3: set(A),F3: fun(A,B),K6: B] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),divide_divide(B,K6,aa(nat,B,semiring_1_of_nat(B),aa(set(A),nat,finite_card(A),A3)))) )
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),K6) ) ) ) ) ).

% sum_bounded_above_divide
tff(fact_5151_prod__diff1,axiom,
    ! [B: $tType,A: $tType] :
      ( semidom_divide(B)
     => ! [A3: set(A),F3: fun(A,B),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))
              = $ite(member(A,A2,A3),divide_divide(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3),aa(A,B,F3,A2)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)) ) ) ) ) ).

% prod_diff1
tff(fact_5152_ln__prod,axiom,
    ! [A: $tType,I5: set(A),F3: fun(A,real)] :
      ( aa(set(A),$o,finite_finite(A),I5)
     => ( ! [I2: A] :
            ( member(A,I2,I5)
           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,I2)) )
       => ( aa(real,real,ln_ln(real),aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7121269368397514597t_prod(A,real),F3),I5)) = aa(set(A),real,aa(fun(A,real),fun(set(A),real),groups7311177749621191930dd_sum(A,real),aTP_Lamp_lo(fun(A,real),fun(A,real),F3)),I5) ) ) ) ).

% ln_prod
tff(fact_5153_even__set__encode__iff,axiom,
    ! [A3: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(set(nat),nat,nat_set_encode,A3))
      <=> ~ member(nat,zero_zero(nat),A3) ) ) ).

% even_set_encode_iff
tff(fact_5154_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,N: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
           => aa(set(A),$o,finite_finite(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_fu(fun(nat,A),fun(nat,fun(A,$o)),C2),N))) ) ) ) ).

% polyfun_roots_finite
tff(fact_5155_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),N: nat] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_fu(fun(nat,A),fun(nat,fun(A,$o)),C2),N)))
        <=> ? [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),N)
              & ( aa(nat,A,C2,I3) != zero_zero(A) ) ) ) ) ).

% polyfun_finite_roots
tff(fact_5156_Gcd__remove0__nat,axiom,
    ! [M7: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M7)
     => ( gcd_Gcd(nat,M7) = gcd_Gcd(nat,aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),M7),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))))) ) ) ).

% Gcd_remove0_nat
tff(fact_5157_prod__gen__delta,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),A2: A,B2: fun(A,B),C2: B] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(B,fun(A,B),aa(fun(A,B),fun(B,fun(A,B)),aTP_Lamp_lp(A,fun(fun(A,B),fun(B,fun(A,B))),A2),B2),C2)),S2)
            = $ite(member(A,A2,S2),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,B2,A2)),aa(nat,B,aa(B,fun(nat,B),power_power(B),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),S2)),one_one(nat)))),aa(nat,B,aa(B,fun(nat,B),power_power(B),C2),aa(set(A),nat,finite_card(A),S2))) ) ) ) ).

% prod_gen_delta
tff(fact_5158_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [C2: fun(nat,A),K: nat,N: nat] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
           => ( aa(set(A),$o,finite_finite(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_fu(fun(nat,A),fun(nat,fun(A,$o)),C2),N)))
              & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),collect(A,aa(nat,fun(A,$o),aTP_Lamp_fu(fun(nat,A),fun(nat,fun(A,$o)),C2),N)))),N) ) ) ) ) ).

% polyfun_rootbound
tff(fact_5159_finite__nat__iff__bounded__le,axiom,
    ! [S2: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),S2)
    <=> ? [K2: nat] : aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),S2),set_ord_atMost(nat,K2)) ) ).

% finite_nat_iff_bounded_le
tff(fact_5160_finite__nat__bounded,axiom,
    ! [S2: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),S2)
     => ? [K3: nat] : aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),S2),set_ord_lessThan(nat,K3)) ) ).

% finite_nat_bounded
tff(fact_5161_finite__nat__iff__bounded,axiom,
    ! [S2: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),S2)
    <=> ? [K2: nat] : aa(set(nat),$o,aa(set(nat),fun(set(nat),$o),ord_less_eq(set(nat)),S2),set_ord_lessThan(nat,K2)) ) ).

% finite_nat_iff_bounded
tff(fact_5162_finite__interval__int1,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_lq(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int1
tff(fact_5163_finite__interval__int4,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_lr(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int4
tff(fact_5164_finite__interval__int3,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_ls(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int3
tff(fact_5165_finite__interval__int2,axiom,
    ! [A2: int,B2: int] : aa(set(int),$o,finite_finite(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_lt(int,fun(int,fun(int,$o)),A2),B2))) ).

% finite_interval_int2
tff(fact_5166_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(set(complex),$o,finite_finite(complex),collect(complex,aa(complex,fun(complex,$o),aTP_Lamp_fp(nat,fun(complex,fun(complex,$o)),N),C2))) ) ).

% finite_nth_roots
tff(fact_5167_abs__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,code_integer,abs_abs(code_integer),K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),aa(code_integer,code_integer,uminus_uminus(code_integer),K),K) ) ).

% abs_integer_code
tff(fact_5168_uminus__integer__code_I1_J,axiom,
    aa(code_integer,code_integer,uminus_uminus(code_integer),zero_zero(code_integer)) = zero_zero(code_integer) ).

% uminus_integer_code(1)
tff(fact_5169_less__integer__code_I1_J,axiom,
    ~ aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),zero_zero(code_integer)) ).

% less_integer_code(1)
tff(fact_5170_infinite__int__iff__unbounded__le,axiom,
    ! [S2: set(int)] :
      ( ~ aa(set(int),$o,finite_finite(int),S2)
    <=> ! [M6: int] :
        ? [N5: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),M6),aa(int,int,abs_abs(int),N5))
          & member(int,N5,S2) ) ) ).

% infinite_int_iff_unbounded_le
tff(fact_5171_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : aa(set(int),$o,finite_finite(int),set_or7035219750837199246ssThan(int,zero_zero(int),U)) ).

% finite_atLeastZeroLessThan_int
tff(fact_5172_finite__divisors__int,axiom,
    ! [I: int] :
      ( ( I != zero_zero(int) )
     => aa(set(int),$o,finite_finite(int),collect(int,aTP_Lamp_lu(int,fun(int,$o),I))) ) ).

% finite_divisors_int
tff(fact_5173_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set(nat)] :
      ( ~ aa(set(nat),$o,finite_finite(nat),S2)
    <=> ! [M6: nat] :
        ? [N5: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M6),N5)
          & member(nat,N5,S2) ) ) ).

% infinite_nat_iff_unbounded_le
tff(fact_5174_integer__of__int__code,axiom,
    ! [K: int] :
      ( aa(int,code_integer,code_integer_of_int,K)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),K),zero_zero(int)),
          aa(code_integer,code_integer,uminus_uminus(code_integer),aa(int,code_integer,code_integer_of_int,aa(int,int,uminus_uminus(int),K))),
          $ite(
            K = zero_zero(int),
            zero_zero(code_integer),
            $let(
              l: code_integer,
              l := aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),aa(int,code_integer,code_integer_of_int,divide_divide(int,K,aa(num,int,numeral_numeral(int),bit0(one2))))),
              $ite(modulo_modulo(int,K,aa(num,int,numeral_numeral(int),bit0(one2))) = zero_zero(int),l,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),l),one_one(code_integer))) ) ) ) ) ).

% integer_of_int_code
tff(fact_5175_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [F6: set(A),I5: set(A),F3: fun(A,B),I: A] :
          ( aa(set(A),$o,finite_finite(A),F6)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_lv(set(A),fun(fun(A,B),fun(A,$o)),I5),F3))),F6)
           => ( groups1027152243600224163dd_sum(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert(A,I),bot_bot(set(A)))))
              = $ite(member(A,I,I5),aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F3,I5)),aa(A,B,F3,I)),groups1027152243600224163dd_sum(A,B,F3,I5)) ) ) ) ) ).

% sum_diff1'_aux
tff(fact_5176_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( code_integer_of_num(aa(num,num,bit1,N))
      = $let(
          k: code_integer,
          k := code_integer_of_num(N),
          aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),k),k)),one_one(code_integer)) ) ) ).

% integer_of_num(3)
tff(fact_5177_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: fun(B,A)] : ( groups1027152243600224163dd_sum(B,A,P2,bot_bot(set(B))) = zero_zero(A) ) ) ).

% sum.empty'
tff(fact_5178_sum_Oinsert_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),P2: fun(A,B),I: A] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ks(set(A),fun(fun(A,B),fun(A,$o)),I5),P2)))
         => ( groups1027152243600224163dd_sum(A,B,P2,aa(set(A),set(A),insert(A,I),I5))
            = $ite(member(A,I,I5),groups1027152243600224163dd_sum(A,B,P2,I5),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,P2,I)),groups1027152243600224163dd_sum(A,B,P2,I5))) ) ) ) ).

% sum.insert'
tff(fact_5179_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),I5: set(B)] : ( groups1027152243600224163dd_sum(B,A,G,collect(B,aa(set(B),fun(B,$o),aTP_Lamp_lw(fun(B,A),fun(set(B),fun(B,$o)),G),I5))) = groups1027152243600224163dd_sum(B,A,G,I5) ) ) ).

% sum.non_neutral'
tff(fact_5180_zero__integer__def,axiom,
    zero_zero(code_integer) = aa(int,code_integer,code_integer_of_int,zero_zero(int)) ).

% zero_integer_def
tff(fact_5181_plus__integer_Oabs__eq,axiom,
    ! [Xa: int,Xb: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(int,code_integer,code_integer_of_int,Xa)),aa(int,code_integer,code_integer_of_int,Xb)) = aa(int,code_integer,code_integer_of_int,aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),Xb)) ) ).

% plus_integer.abs_eq
tff(fact_5182_times__integer_Oabs__eq,axiom,
    ! [Xa: int,Xb: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(int,code_integer,code_integer_of_int,Xa)),aa(int,code_integer,code_integer_of_int,Xb)) = aa(int,code_integer,code_integer_of_int,aa(int,int,aa(int,fun(int,int),times_times(int),Xa),Xb)) ) ).

% times_integer.abs_eq
tff(fact_5183_one__integer__def,axiom,
    one_one(code_integer) = aa(int,code_integer,code_integer_of_int,one_one(int)) ).

% one_integer_def
tff(fact_5184_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,Xb: int] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),aa(int,code_integer,code_integer_of_int,Xa)),aa(int,code_integer,code_integer_of_int,Xb))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),Xb) ) ).

% less_eq_integer.abs_eq
tff(fact_5185_minus__integer_Oabs__eq,axiom,
    ! [Xa: int,Xb: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(int,code_integer,code_integer_of_int,Xa)),aa(int,code_integer,code_integer_of_int,Xb)) = aa(int,code_integer,code_integer_of_int,aa(int,int,aa(int,fun(int,int),minus_minus(int),Xa),Xb)) ) ).

% minus_integer.abs_eq
tff(fact_5186_sum_Odistrib__triv_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( groups1027152243600224163dd_sum(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_lx(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),plus_plus(B),groups1027152243600224163dd_sum(A,B,G,I5)),groups1027152243600224163dd_sum(A,B,H,I5)) ) ) ) ).

% sum.distrib_triv'
tff(fact_5187_sum_Omono__neutral__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S2: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [X: A] :
                ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,G,X) = zero_zero(B) ) )
           => ( groups1027152243600224163dd_sum(A,B,G,S2) = groups1027152243600224163dd_sum(A,B,G,T5) ) ) ) ) ).

% sum.mono_neutral_left'
tff(fact_5188_sum_Omono__neutral__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S2: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [X: A] :
                ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,G,X) = zero_zero(B) ) )
           => ( groups1027152243600224163dd_sum(A,B,G,T5) = groups1027152243600224163dd_sum(A,B,G,S2) ) ) ) ) ).

% sum.mono_neutral_right'
tff(fact_5189_sum_Omono__neutral__cong__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S2: set(A),T5: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [I2: A] :
                ( member(A,I2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,H,I2) = zero_zero(B) ) )
           => ( ! [X: A] :
                  ( member(A,X,S2)
                 => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
             => ( groups1027152243600224163dd_sum(A,B,G,S2) = groups1027152243600224163dd_sum(A,B,H,T5) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
tff(fact_5190_sum_Omono__neutral__cong__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [S2: set(A),T5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [X: A] :
                ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,G,X) = zero_zero(B) ) )
           => ( ! [X: A] :
                  ( member(A,X,S2)
                 => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
             => ( groups1027152243600224163dd_sum(A,B,G,T5) = groups1027152243600224163dd_sum(A,B,H,S2) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
tff(fact_5191_sum_Odistrib_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ks(set(A),fun(fun(A,B),fun(A,$o)),I5),G)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ks(set(A),fun(fun(A,B),fun(A,$o)),I5),H)))
           => ( groups1027152243600224163dd_sum(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_lx(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),plus_plus(B),groups1027152243600224163dd_sum(A,B,G,I5)),groups1027152243600224163dd_sum(A,B,H,I5)) ) ) ) ) ).

% sum.distrib'
tff(fact_5192_sum_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [P2: fun(B,A),I5: set(B)] :
          ( groups1027152243600224163dd_sum(B,A,P2,I5)
          = $ite(aa(set(B),$o,finite_finite(B),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_lw(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),P2),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_lw(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),zero_zero(A)) ) ) ).

% sum.G_def
tff(fact_5193_integer__of__num__triv_I1_J,axiom,
    code_integer_of_num(one2) = one_one(code_integer) ).

% integer_of_num_triv(1)
tff(fact_5194_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [I5: set(A),F3: fun(A,B),I: A] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_lv(set(A),fun(fun(A,B),fun(A,$o)),I5),F3)))
         => ( groups1027152243600224163dd_sum(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),aa(set(A),set(A),insert(A,I),bot_bot(set(A)))))
            = $ite(member(A,I,I5),aa(B,B,aa(B,fun(B,B),minus_minus(B),groups1027152243600224163dd_sum(A,B,F3,I5)),aa(A,B,F3,I)),groups1027152243600224163dd_sum(A,B,F3,I5)) ) ) ) ).

% sum_diff1'
tff(fact_5195_card__Pow,axiom,
    ! [A: $tType,A3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(set(A)),nat,finite_card(set(A)),pow2(A,A3)) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(set(A),nat,finite_card(A),A3)) ) ) ).

% card_Pow
tff(fact_5196_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,A),V: num,N: nat] : ( case_nat(A,A2,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(num,nat,numeral_numeral(nat),V)),N)) = aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),pred_numeral(V)),N)) ) ).

% case_nat_add_eq_if
tff(fact_5197_card__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_ly(set(A),fun(nat,fun(list(A),$o)),A3),N))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),power_power(nat),aa(set(A),nat,finite_card(A),A3))),set_ord_atMost(nat,N)) ) ) ).

% card_lists_length_le
tff(fact_5198_Pow__iff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( member(set(A),A3,pow2(A,B3))
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% Pow_iff
tff(fact_5199_PowI,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => member(set(A),A3,pow2(A,B3)) ) ).

% PowI
tff(fact_5200_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F3: fun(nat,A),V: num] : ( case_nat(A,A2,F3,aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,F3,pred_numeral(V)) ) ).

% case_nat_numeral
tff(fact_5201_Pow__def,axiom,
    ! [A: $tType,A3: set(A)] : ( pow2(A,A3) = collect(set(A),aTP_Lamp_ki(set(A),fun(set(A),$o),A3)) ) ).

% Pow_def
tff(fact_5202_Pow__mono,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),pow2(A,A3)),pow2(A,B3)) ) ).

% Pow_mono
tff(fact_5203_PowD,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( member(set(A),A3,pow2(A,B3))
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% PowD
tff(fact_5204_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),B3)
    <=> ! [X4: A] :
          ( member(A,X4,aa(list(A),set(A),set2(A),Xs))
         => member(A,X4,B3) ) ) ).

% subset_code(1)
tff(fact_5205_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: fun(B,A),F1: B,F2: fun(nat,B),Nat: nat] : ( aa(B,A,H,case_nat(B,F1,F2,Nat)) = case_nat(A,aa(B,A,H,F1),aa(fun(nat,B),fun(nat,A),aTP_Lamp_lz(fun(B,A),fun(fun(nat,B),fun(nat,A)),H),F2),Nat) ) ).

% nat.case_distrib
tff(fact_5206_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,A)] : ( case_nat(A,F1,F2,zero_zero(nat)) = F1 ) ).

% old.nat.simps(4)
tff(fact_5207_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F2: fun(nat,A),X2: nat] : ( case_nat(A,F1,F2,aa(nat,nat,suc,X2)) = aa(nat,A,F2,X2) ) ).

% old.nat.simps(5)
tff(fact_5208_length__pos__if__in__set,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] :
      ( member(A,Xa,aa(list(A),set(A),set2(A),Xs))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_pos_if_in_set
tff(fact_5209_card__length,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(list(A),set(A),set2(A),Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% card_length
tff(fact_5210_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( Nat != zero_zero(nat) )
    <=> case_nat($o,$false,aTP_Lamp_ma(nat,$o),Nat) ) ).

% nat.disc_eq_case(2)
tff(fact_5211_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat = zero_zero(nat) )
    <=> case_nat($o,$true,aTP_Lamp_mb(nat,$o),Nat) ) ).

% nat.disc_eq_case(1)
tff(fact_5212_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(list(A)),$o,finite_finite(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_mc(set(A),fun(nat,fun(list(A),$o)),A3),N))) ) ).

% finite_lists_length_eq
tff(fact_5213_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(list(A)),$o,finite_finite(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_ly(set(A),fun(nat,fun(list(A),$o)),A3),N))) ) ).

% finite_lists_length_le
tff(fact_5214_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,M)),N)
    <=> case_nat($o,$false,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% less_eq_nat.simps(2)
tff(fact_5215_max__Suc2,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),M),aa(nat,nat,suc,N)) = case_nat(nat,aa(nat,nat,suc,N),aTP_Lamp_md(nat,fun(nat,nat),N),M) ) ).

% max_Suc2
tff(fact_5216_max__Suc1,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,N)),M) = case_nat(nat,aa(nat,nat,suc,N),aTP_Lamp_me(nat,fun(nat,nat),N),M) ) ).

% max_Suc1
tff(fact_5217_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_mc(set(A),fun(nat,fun(list(A),$o)),A3),N))) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(set(A),nat,finite_card(A),A3)),N) ) ) ).

% card_lists_length_eq
tff(fact_5218_diff__Suc,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),aa(nat,nat,suc,N)) = case_nat(nat,zero_zero(nat),aTP_Lamp_bg(nat,nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)) ) ).

% diff_Suc
tff(fact_5219_min__Suc1,axiom,
    ! [N: nat,M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),aa(nat,nat,suc,N)),M) = case_nat(nat,zero_zero(nat),aTP_Lamp_mf(nat,fun(nat,nat),N),M) ) ).

% min_Suc1
tff(fact_5220_min__Suc2,axiom,
    ! [M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),M),aa(nat,nat,suc,N)) = case_nat(nat,zero_zero(nat),aTP_Lamp_mg(nat,fun(nat,nat),N),M) ) ).

% min_Suc2
tff(fact_5221_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType,Xa: A,F3: fun(nat,A),N: nat] :
      ( case_nat(A,Xa,F3,N)
      = $ite(N = zero_zero(nat),Xa,aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ).

% Nitpick.case_nat_unfold
tff(fact_5222_binomial__def,axiom,
    ! [N: nat,K: nat] : ( aa(nat,nat,binomial(N),K) = aa(set(set(nat)),nat,finite_card(set(nat)),collect(set(nat),aa(nat,fun(set(nat),$o),aTP_Lamp_mh(nat,fun(nat,fun(set(nat),$o)),N),K))) ) ).

% binomial_def
tff(fact_5223_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),K: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(set(A),nat,finite_card(A),A3))
       => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_mi(set(A),fun(nat,fun(list(A),$o)),A3),K))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_bg(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A3))) ) ) ) ).

% card_lists_distinct_length_eq
tff(fact_5224_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(set(A),nat,finite_card(A),A3))
     => ( aa(set(list(A)),nat,finite_card(list(A)),collect(list(A),aa(set(A),fun(list(A),$o),aTP_Lamp_mj(nat,fun(set(A),fun(list(A),$o)),K),A3))) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7121269368397514597t_prod(nat,nat),aTP_Lamp_bg(nat,nat)),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),K)),one_one(nat)),aa(set(A),nat,finite_card(A),A3))) ) ) ).

% card_lists_distinct_length_eq'
tff(fact_5225_sum__count__set,axiom,
    ! [A: $tType,Xs: list(A),X6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X6)
     => ( aa(set(A),$o,finite_finite(A),X6)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),count_list(A,Xs)),X6) = aa(list(A),nat,size_size(list(A)),Xs) ) ) ) ).

% sum_count_set
tff(fact_5226_count__notin,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] :
      ( ~ member(A,Xa,aa(list(A),set(A),set2(A),Xs))
     => ( aa(A,nat,count_list(A,Xs),Xa) = zero_zero(nat) ) ) ).

% count_notin
tff(fact_5227_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(set(list(A)),$o,finite_finite(list(A)),collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_mi(set(A),fun(nat,fun(list(A),$o)),A3),N))) ) ).

% finite_lists_distinct_length_eq
tff(fact_5228_count__le__length,axiom,
    ! [A: $tType,Xs: list(A),Xa: A] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,count_list(A,Xs),Xa)),aa(list(A),nat,size_size(list(A)),Xs)) ).

% count_le_length
tff(fact_5229_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: fun(A,$o),F1: A,F2: fun(nat,A),Nat: nat] :
      ( aa(A,$o,P,case_nat(A,F1,F2,Nat))
    <=> ~ ( ( ( Nat = zero_zero(nat) )
            & ~ aa(A,$o,P,F1) )
          | ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
            & ~ aa(A,$o,P,aa(nat,A,F2,pred(Nat))) ) ) ) ).

% nat.split_sels(2)
tff(fact_5230_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: fun(A,$o),F1: A,F2: fun(nat,A),Nat: nat] :
      ( aa(A,$o,P,case_nat(A,F1,F2,Nat))
    <=> ( ( ( Nat = zero_zero(nat) )
         => aa(A,$o,P,F1) )
        & ( ( Nat = aa(nat,nat,suc,pred(Nat)) )
         => aa(A,$o,P,aa(nat,A,F2,pred(Nat))) ) ) ) ).

% nat.split_sels(1)
tff(fact_5231_bit__cut__integer__code,axiom,
    ! [K: code_integer] :
      ( code_bit_cut_integer(K)
      = $ite(K = zero_zero(code_integer),aa($o,product_prod(code_integer,$o),product_Pair(code_integer,$o,zero_zero(code_integer)),$false),aa(product_prod(code_integer,code_integer),product_prod(code_integer,$o),product_case_prod(code_integer,code_integer,product_prod(code_integer,$o),aTP_Lamp_mk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),K)),code_divmod_abs(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))))) ) ).

% bit_cut_integer_code
tff(fact_5232_divmod__abs__code_I6_J,axiom,
    ! [J: code_integer] : ( code_divmod_abs(zero_zero(code_integer),J) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)) ) ).

% divmod_abs_code(6)
tff(fact_5233_divmod__abs__code_I5_J,axiom,
    ! [J: code_integer] : ( code_divmod_abs(J,zero_zero(code_integer)) = aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),aa(code_integer,code_integer,abs_abs(code_integer),J)) ) ).

% divmod_abs_code(5)
tff(fact_5234_pred__def,axiom,
    ! [Nat: nat] : ( pred(Nat) = case_nat(nat,zero_zero(nat),aTP_Lamp_bg(nat,nat),Nat) ) ).

% pred_def
tff(fact_5235_divmod__integer__code,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),L),
            $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),K),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_ml(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L))),
            $ite(
              L = zero_zero(code_integer),
              aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),K),
              aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),product_apsnd(code_integer,code_integer,code_integer),uminus_uminus(code_integer)),$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_mm(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ) ).

% divmod_integer_code
tff(fact_5236_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list(A),Xa: A] :
      ( distinct(A,Xs)
     => ( aa(list(A),set(A),set2(A),remove1(A,Xa,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) ) ) ).

% set_remove1_eq
tff(fact_5237_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),zero_zero(code_integer))
     => ( aa(code_integer,nat,code_nat_of_integer,K) = zero_zero(nat) ) ) ).

% nat_of_integer_non_positive
tff(fact_5238_of__nat__of__integer,axiom,
    ! [K: code_integer] : ( aa(nat,code_integer,semiring_1_of_nat(code_integer),aa(code_integer,nat,code_nat_of_integer,K)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),ord_max(code_integer),zero_zero(code_integer)),K) ) ).

% of_nat_of_integer
tff(fact_5239_set__remove1__subset,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),remove1(A,Xa,Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% set_remove1_subset
tff(fact_5240_nat__of__integer__code__post_I1_J,axiom,
    aa(code_integer,nat,code_nat_of_integer,zero_zero(code_integer)) = zero_zero(nat) ).

% nat_of_integer_code_post(1)
tff(fact_5241_nat__of__integer__code__post_I2_J,axiom,
    aa(code_integer,nat,code_nat_of_integer,one_one(code_integer)) = one_one(nat) ).

% nat_of_integer_code_post(2)
tff(fact_5242_length__remove1,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] :
      ( aa(list(A),nat,size_size(list(A)),remove1(A,Xa,Xs))
      = $ite(member(A,Xa,aa(list(A),set(A),set2(A),Xs)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_remove1
tff(fact_5243_nat__of__integer__code,axiom,
    ! [K: code_integer] :
      ( aa(code_integer,nat,code_nat_of_integer,K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),zero_zero(code_integer)),zero_zero(nat),aa(product_prod(code_integer,code_integer),nat,product_case_prod(code_integer,code_integer,nat,aTP_Lamp_mn(code_integer,fun(code_integer,nat))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))))) ) ).

% nat_of_integer_code
tff(fact_5244_divmod__integer__eq__cases,axiom,
    ! [K: code_integer,L: code_integer] :
      ( code_divmod_integer(K,L)
      = $ite(
          K = zero_zero(code_integer),
          aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)),
          $ite(
            L = zero_zero(code_integer),
            aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),K),
            aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),aa(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),aa(fun(code_integer,code_integer),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,aa(fun(code_integer,fun(code_integer,code_integer)),fun(code_integer,fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer))),comp(fun(code_integer,code_integer),fun(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer)),code_integer,product_apsnd(code_integer,code_integer,code_integer)),times_times(code_integer))),sgn_sgn(code_integer)),L),$ite(aa(code_integer,code_integer,sgn_sgn(code_integer),K) = aa(code_integer,code_integer,sgn_sgn(code_integer),L),code_divmod_abs(K,L),aa(product_prod(code_integer,code_integer),product_prod(code_integer,code_integer),product_case_prod(code_integer,code_integer,product_prod(code_integer,code_integer),aTP_Lamp_mo(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),L)),code_divmod_abs(K,L)))) ) ) ) ).

% divmod_integer_eq_cases
tff(fact_5245_max__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,ord_max(nat),zero_zero(nat),aTP_Lamp_aa(nat,fun(nat,$o)),aTP_Lamp_eo(nat,fun(nat,$o))) ).

% max_nat.semilattice_neutr_order_axioms
tff(fact_5246_comp__funpow,axiom,
    ! [A: $tType,B: $tType,N: nat,F3: fun(B,B)] : ( aa(fun(fun(A,B),fun(A,B)),fun(fun(A,B),fun(A,B)),aa(nat,fun(fun(fun(A,B),fun(A,B)),fun(fun(A,B),fun(A,B))),compow(fun(fun(A,B),fun(A,B))),N),comp(B,B,A,F3)) = comp(B,B,A,aa(fun(B,B),fun(B,B),aa(nat,fun(fun(B,B),fun(B,B)),compow(fun(B,B)),N),F3)) ) ).

% comp_funpow
tff(fact_5247_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,N)),F3) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3)),F3) ) ).

% funpow_Suc_right
tff(fact_5248_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,suc,N)),F3) = aa(fun(A,A),fun(A,A),comp(A,A,A,F3),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3)) ) ).

% funpow.simps(2)
tff(fact_5249_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),F3) = aa(fun(A,A),fun(A,A),comp(A,A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F3)),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3)) ) ).

% funpow_add
tff(fact_5250_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comm_monoid_add(B)
        & comm_monoid_add(A) )
     => ! [H: fun(B,A),G: fun(C,B),A3: set(C)] :
          ( ( aa(B,A,H,zero_zero(B)) = zero_zero(A) )
         => ( ! [X: B,Y3: B] : ( aa(B,A,H,aa(B,B,aa(B,fun(B,B),plus_plus(B),X),Y3)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,H,X)),aa(B,A,H,Y3)) )
           => ( aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(fun(C,B),fun(C,A),comp(B,A,C,H),G)),A3) = aa(B,A,H,aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),A3)) ) ) ) ) ).

% sum_comp_morphism
tff(fact_5251_card__UNION,axiom,
    ! [A: $tType,A3: set(set(A))] :
      ( aa(set(set(A)),$o,finite_finite(set(A)),A3)
     => ( ! [X: set(A)] :
            ( member(set(A),X,A3)
           => aa(set(A),$o,finite_finite(A),X) )
       => ( aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)) = aa(int,nat,nat2,aa(set(set(set(A))),int,aa(fun(set(set(A)),int),fun(set(set(set(A))),int),groups7311177749621191930dd_sum(set(set(A)),int),aTP_Lamp_mp(set(set(A)),int)),collect(set(set(A)),aTP_Lamp_mq(set(set(A)),fun(set(set(A)),$o),A3)))) ) ) ) ).

% card_UNION
tff(fact_5252_set__removeAll,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] : ( aa(list(A),set(A),set2(A),removeAll(A,Xa,Xs)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) ) ).

% set_removeAll
tff(fact_5253_int__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_int_of_integer(K)
      = $ite(
          aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),K),zero_zero(code_integer)),
          aa(int,int,uminus_uminus(int),code_int_of_integer(aa(code_integer,code_integer,uminus_uminus(code_integer),K))),
          $ite(K = zero_zero(code_integer),zero_zero(int),aa(product_prod(code_integer,code_integer),int,product_case_prod(code_integer,code_integer,int,aTP_Lamp_mr(code_integer,fun(code_integer,int))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))))) ) ) ).

% int_of_integer_code
tff(fact_5254_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or1337092689740270186AtMost(A,Xa,Y)) = Y ) ) ) ).

% Sup_atLeastAtMost
tff(fact_5255_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(set(A),A,complete_Sup_Sup(A),set_or1337092689740270186AtMost(A,Y,Xa)) = Xa ) ) ) ).

% cSup_atLeastAtMost
tff(fact_5256_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or1337092689740270186AtMost(A,Xa,Y)) = Xa ) ) ) ).

% Inf_atLeastAtMost
tff(fact_5257_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(set(A),A,complete_Inf_Inf(A),set_or1337092689740270186AtMost(A,Y,Xa)) = Y ) ) ) ).

% cInf_atLeastAtMost
tff(fact_5258_zero__integer_Orep__eq,axiom,
    code_int_of_integer(zero_zero(code_integer)) = zero_zero(int) ).

% zero_integer.rep_eq
tff(fact_5259_plus__integer_Orep__eq,axiom,
    ! [Xa: code_integer,Xaa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),Xa),Xaa)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),code_int_of_integer(Xa)),code_int_of_integer(Xaa)) ) ).

% plus_integer.rep_eq
tff(fact_5260_times__integer_Orep__eq,axiom,
    ! [Xa: code_integer,Xaa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),Xa),Xaa)) = aa(int,int,aa(int,fun(int,int),times_times(int),code_int_of_integer(Xa)),code_int_of_integer(Xaa)) ) ).

% times_integer.rep_eq
tff(fact_5261_one__integer_Orep__eq,axiom,
    code_int_of_integer(one_one(code_integer)) = one_one(int) ).

% one_integer.rep_eq
tff(fact_5262_minus__integer_Orep__eq,axiom,
    ! [Xa: code_integer,Xaa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Xa),Xaa)) = aa(int,int,aa(int,fun(int,int),minus_minus(int),code_int_of_integer(Xa)),code_int_of_integer(Xaa)) ) ).

% minus_integer.rep_eq
tff(fact_5263_int__of__integer__of__nat,axiom,
    ! [N: nat] : ( code_int_of_integer(aa(nat,code_integer,semiring_1_of_nat(code_integer),N)) = aa(nat,int,semiring_1_of_nat(int),N) ) ).

% int_of_integer_of_nat
tff(fact_5264_prod_OUnion__comp,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [B3: set(set(A)),G: fun(A,B)] :
          ( ! [X: set(A)] :
              ( member(set(A),X,B3)
             => aa(set(A),$o,finite_finite(A),X) )
         => ( ! [A13: set(A)] :
                ( member(set(A),A13,B3)
               => ! [A24: set(A)] :
                    ( member(set(A),A24,B3)
                   => ( ( A13 != A24 )
                     => ! [X: A] :
                          ( member(A,X,A13)
                         => ( member(A,X,A24)
                           => ( aa(A,B,G,X) = one_one(B) ) ) ) ) ) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)) = aa(set(set(A)),B,aa(fun(A,B),fun(set(set(A)),B),aa(fun(fun(A,B),fun(set(A),B)),fun(fun(A,B),fun(set(set(A)),B)),comp(fun(set(A),B),fun(set(set(A)),B),fun(A,B),groups7121269368397514597t_prod(set(A),B)),groups7121269368397514597t_prod(A,B)),G),B3) ) ) ) ) ).

% prod.Union_comp
tff(fact_5265_sum_OUnion__comp,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [B3: set(set(A)),G: fun(A,B)] :
          ( ! [X: set(A)] :
              ( member(set(A),X,B3)
             => aa(set(A),$o,finite_finite(A),X) )
         => ( ! [A13: set(A)] :
                ( member(set(A),A13,B3)
               => ! [A24: set(A)] :
                    ( member(set(A),A24,B3)
                   => ( ( A13 != A24 )
                     => ! [X: A] :
                          ( member(A,X,A13)
                         => ( member(A,X,A24)
                           => ( aa(A,B,G,X) = zero_zero(B) ) ) ) ) ) )
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)) = aa(set(set(A)),B,aa(fun(A,B),fun(set(set(A)),B),aa(fun(fun(A,B),fun(set(A),B)),fun(fun(A,B),fun(set(set(A)),B)),comp(fun(set(A),B),fun(set(set(A)),B),fun(A,B),groups7311177749621191930dd_sum(set(A),B)),groups7311177749621191930dd_sum(A,B)),G),B3) ) ) ) ) ).

% sum.Union_comp
tff(fact_5266_card_Ocomp__fun__commute__on,axiom,
    aa(fun(nat,nat),fun(nat,nat),comp(nat,nat,nat,suc),suc) = aa(fun(nat,nat),fun(nat,nat),comp(nat,nat,nat,suc),suc) ).

% card.comp_fun_commute_on
tff(fact_5267_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Z: A,X6: set(A)] :
          ( member(A,Z,X6)
         => ( ! [X: A] :
                ( member(A,X,X6)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Z) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X6) = Z ) ) ) ) ).

% cSup_eq_maximum
tff(fact_5268_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & no_bot(A) )
     => ! [X6: set(A),A2: A] :
          ( ! [X: A] :
              ( member(A,X,X6)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),A2) )
         => ( ! [Y3: A] :
                ( ! [X3: A] :
                    ( member(A,X3,X6)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y3) )
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),Y3) )
           => ( aa(set(A),A,complete_Sup_Sup(A),X6) = A2 ) ) ) ) ).

% cSup_eq
tff(fact_5269_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Z: A,X6: set(A)] :
          ( member(A,Z,X6)
         => ( ! [X: A] :
                ( member(A,X,X6)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),X) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X6) = Z ) ) ) ) ).

% cInf_eq_minimum
tff(fact_5270_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & no_top(A) )
     => ! [X6: set(A),A2: A] :
          ( ! [X: A] :
              ( member(A,X,X6)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X) )
         => ( ! [Y3: A] :
                ( ! [X3: A] :
                    ( member(A,X3,X6)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),X3) )
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),A2) )
           => ( aa(set(A),A,complete_Inf_Inf(A),X6) = A2 ) ) ) ) ).

% cInf_eq
tff(fact_5271_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A2: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,X6)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X) )
           => ( ! [Y3: A] :
                  ( ! [X3: A] :
                      ( member(A,X3,X6)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),X3) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),A2) )
             => ( aa(set(A),A,complete_Inf_Inf(A),X6) = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
tff(fact_5272_cInf__greatest,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),Z: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,X6)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),X) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),aa(set(A),A,complete_Inf_Inf(A),X6)) ) ) ) ).

% cInf_greatest
tff(fact_5273_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),X6)
         => ( member(A,Xa,X6)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),X6)),Xa) ) ) ) ).

% cInf_le_finite
tff(fact_5274_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),A2: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,X6)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),A2) )
           => ( ! [Y3: A] :
                  ( ! [X3: A] :
                      ( member(A,X3,X6)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y3) )
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),Y3) )
             => ( aa(set(A),A,complete_Sup_Sup(A),X6) = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
tff(fact_5275_cSup__least,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),Z: A] :
          ( ( X6 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,X6)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Z) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),X6)),Z) ) ) ) ).

% cSup_least
tff(fact_5276_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [X6: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),X6)
         => ( member(A,Xa,X6)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,complete_Sup_Sup(A),X6)) ) ) ) ).

% le_cSup_finite
tff(fact_5277_card__Union__le__sum__card,axiom,
    ! [A: $tType,U2: set(set(A))] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),U2))),aa(set(set(A)),nat,aa(fun(set(A),nat),fun(set(set(A)),nat),groups7311177749621191930dd_sum(set(A),nat),finite_card(A)),U2)) ).

% card_Union_le_sum_card
tff(fact_5278_integer__less__eq__iff,axiom,
    ! [K: code_integer,L: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),L)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),code_int_of_integer(K)),code_int_of_integer(L)) ) ).

% integer_less_eq_iff
tff(fact_5279_less__eq__integer_Orep__eq,axiom,
    ! [Xa: code_integer,Xaa: code_integer] :
      ( aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),Xa),Xaa)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),code_int_of_integer(Xa)),code_int_of_integer(Xaa)) ) ).

% less_eq_integer.rep_eq
tff(fact_5280_length__removeAll__less__eq,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),removeAll(A,Xa,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_removeAll_less_eq
tff(fact_5281_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),A2: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,S2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X)),A2) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Inf_Inf(A),S2))),A2) ) ) ) ).

% cInf_abs_ge
tff(fact_5282_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),A2: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,S2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),X)),A2) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(set(A),A,complete_Sup_Sup(A),S2))),A2) ) ) ) ).

% cSup_abs_le
tff(fact_5283_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
tff(fact_5284_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
tff(fact_5285_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.atLeastAtMost_shift_bounds
tff(fact_5286_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.atLeastLessThan_shift_bounds
tff(fact_5287_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
tff(fact_5288_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
tff(fact_5289_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.atLeastAtMost_shift_bounds
tff(fact_5290_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,K: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),K),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),K))),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.atLeastLessThan_shift_bounds
tff(fact_5291_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [N: nat,A2: A] : ( bit_se5641148757651400278ts_bit(A,aa(A,A,bit_se4197421643247451524op_bit(A,N),A2)) = aa(fun(nat,nat),fun(nat,$o),comp(nat,$o,nat,bit_se5641148757651400278ts_bit(A,A2)),aa(nat,fun(nat,nat),plus_plus(nat),N)) ) ) ).

% bit_drop_bit_eq
tff(fact_5292_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U2: set(set(A))] :
      ( ! [X: set(A)] :
          ( member(set(A),X,U2)
         => aa(set(A),$o,finite_finite(A),X) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),U2))),aa(set(set(A)),nat,aa(fun(set(A),nat),fun(set(set(A)),nat),groups7311177749621191930dd_sum(set(A),nat),finite_card(A)),U2)) ) ).

% card_Union_le_sum_card_weak
tff(fact_5293_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),L: A,E: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,S2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),L))),E) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Inf_Inf(A),S2)),L))),E) ) ) ) ).

% cInf_asclose
tff(fact_5294_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder(A)
        & linordered_idom(A) )
     => ! [S2: set(A),L: A,E: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,S2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),X),L))),E) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(set(A),A,complete_Sup_Sup(A),S2)),L))),E) ) ) ) ).

% cSup_asclose
tff(fact_5295_finite__subset__Union,axiom,
    ! [A: $tType,A3: set(A),B11: set(set(A))] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B11))
       => ~ ! [F8: set(set(A))] :
              ( aa(set(set(A)),$o,finite_finite(set(A)),F8)
             => ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),F8),B11)
               => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),F8)) ) ) ) ) ).

% finite_subset_Union
tff(fact_5296_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_atMost_Suc_shift
tff(fact_5297_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
tff(fact_5298_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_atMost_Suc_shift
tff(fact_5299_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N))) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,zero_zero(nat))),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),suc)),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
tff(fact_5300_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% sum.atLeastLessThan_shift_0
tff(fact_5301_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ).

% prod.atLeastLessThan_shift_0
tff(fact_5302_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ms(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.atLeast_atMost_pred_shift
tff(fact_5303_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ms(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.atLeast_lessThan_pred_shift
tff(fact_5304_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ms(nat,nat))),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.atLeast_atMost_pred_shift
tff(fact_5305_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(nat,A),M: nat,N: nat] : ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aTP_Lamp_ms(nat,nat))),set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.atLeast_lessThan_pred_shift
tff(fact_5306_sum_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(int,A),M: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7311177749621191930dd_sum(int,A),G),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,int),fun(nat,A),comp(int,A,nat,G),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% sum.atLeast_int_atMost_int_shift
tff(fact_5307_prod_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(int,A),M: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7121269368397514597t_prod(int,A),G),set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),M),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,int),fun(nat,A),comp(int,A,nat,G),semiring_1_of_nat(int))),set_or1337092689740270186AtMost(nat,M,N)) ) ) ).

% prod.atLeast_int_atMost_int_shift
tff(fact_5308_sum_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(int,A),M: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7311177749621191930dd_sum(int,A),G),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,int),fun(nat,A),comp(int,A,nat,G),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum.atLeast_int_lessThan_int_shift
tff(fact_5309_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ).

% sum.atLeastAtMost_shift_0
tff(fact_5310_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,nat),fun(nat,A),comp(nat,A,nat,G),aa(nat,fun(nat,nat),plus_plus(nat),M))),set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))) ) ) ) ).

% prod.atLeastAtMost_shift_0
tff(fact_5311_prod_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(int,A),M: nat,N: nat] : ( aa(set(int),A,aa(fun(int,A),fun(set(int),A),groups7121269368397514597t_prod(int,A),G),set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),M),aa(nat,int,semiring_1_of_nat(int),N))) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(fun(nat,int),fun(nat,A),comp(int,A,nat,G),semiring_1_of_nat(int))),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% prod.atLeast_int_lessThan_int_shift
tff(fact_5312_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ).

% Inf_le_Sup
tff(fact_5313_subset__Pow__Union,axiom,
    ! [A: $tType,A3: set(set(A))] : aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),A3),pow2(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3))) ).

% subset_Pow_Union
tff(fact_5314_Inter__subset,axiom,
    ! [A: $tType,A3: set(set(A)),B3: set(A)] :
      ( ! [X7: set(A)] :
          ( member(set(A),X7,A3)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X7),B3) )
     => ( ( A3 != bot_bot(set(set(A))) )
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)),B3) ) ) ).

% Inter_subset
tff(fact_5315_Sup__nat__empty,axiom,
    aa(set(nat),nat,complete_Sup_Sup(nat),bot_bot(set(nat))) = zero_zero(nat) ).

% Sup_nat_empty
tff(fact_5316_Sup__upper2,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,A3: set(A),V: A] :
          ( member(A,U,A3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),V),U)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),V),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ) ).

% Sup_upper2
tff(fact_5317_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),B2)
        <=> ! [X4: A] :
              ( member(A,X4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),B2) ) ) ) ).

% Sup_le_iff
tff(fact_5318_Sup__upper,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xa: A,A3: set(A)] :
          ( member(A,Xa,A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ).

% Sup_upper
tff(fact_5319_Sup__least,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),Z: A] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Z) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),Z) ) ) ).

% Sup_least
tff(fact_5320_Sup__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( ! [A4: A] :
              ( member(A,A4,A3)
             => ? [X3: A] :
                  ( member(A,X3,B3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),X3) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3)) ) ) ).

% Sup_mono
tff(fact_5321_Sup__eqI,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),Xa: A] :
          ( ! [Y3: A] :
              ( member(A,Y3,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),Xa) )
         => ( ! [Y3: A] :
                ( ! [Z3: A] :
                    ( member(A,Z3,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z3),Y3) )
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y3) )
           => ( aa(set(A),A,complete_Sup_Sup(A),A3) = Xa ) ) ) ) ).

% Sup_eqI
tff(fact_5322_Inf__greatest,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),Z: A] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),X) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),aa(set(A),A,complete_Inf_Inf(A),A3)) ) ) ).

% Inf_greatest
tff(fact_5323_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B2: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(set(A),A,complete_Inf_Inf(A),A3))
        <=> ! [X4: A] :
              ( member(A,X4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),X4) ) ) ) ).

% le_Inf_iff
tff(fact_5324_Inf__lower2,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,A3: set(A),V: A] :
          ( member(A,U,A3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),V)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),V) ) ) ) ).

% Inf_lower2
tff(fact_5325_Inf__lower,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Xa: A,A3: set(A)] :
          ( member(A,Xa,A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),Xa) ) ) ).

% Inf_lower
tff(fact_5326_Inf__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: set(A),A3: set(A)] :
          ( ! [B4: A] :
              ( member(A,B4,B3)
             => ? [X3: A] :
                  ( member(A,X3,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),B4) ) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3)) ) ) ).

% Inf_mono
tff(fact_5327_Inf__eqI,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),Xa: A] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),I2) )
         => ( ! [Y3: A] :
                ( ! [I4: A] :
                    ( member(A,I4,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),I4) )
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),Xa) )
           => ( aa(set(A),A,complete_Inf_Inf(A),A3) = Xa ) ) ) ) ).

% Inf_eqI
tff(fact_5328_Union__least,axiom,
    ! [A: $tType,A3: set(set(A)),C5: set(A)] :
      ( ! [X7: set(A)] :
          ( member(set(A),X7,A3)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X7),C5) )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)),C5) ) ).

% Union_least
tff(fact_5329_Union__upper,axiom,
    ! [A: $tType,B3: set(A),A3: set(set(A))] :
      ( member(set(A),B3,A3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)) ) ).

% Union_upper
tff(fact_5330_Union__subsetI,axiom,
    ! [A: $tType,A3: set(set(A)),B3: set(set(A))] :
      ( ! [X: set(A)] :
          ( member(set(A),X,A3)
         => ? [Y4: set(A)] :
              ( member(set(A),Y4,B3)
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X),Y4) ) )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)) ) ).

% Union_subsetI
tff(fact_5331_Inter__lower,axiom,
    ! [A: $tType,B3: set(A),A3: set(set(A))] :
      ( member(set(A),B3,A3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)),B3) ) ).

% Inter_lower
tff(fact_5332_Inter__greatest,axiom,
    ! [A: $tType,A3: set(set(A)),C5: set(A)] :
      ( ! [X7: set(A)] :
          ( member(set(A),X7,A3)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),X7) )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)) ) ).

% Inter_greatest
tff(fact_5333_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [Xa: A,A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,complete_Sup_Sup(A),A3))
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),Xa)
             => ? [X4: A] :
                  ( member(A,X4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),X4) ) ) ) ) ).

% le_Sup_iff
tff(fact_5334_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),Xa)
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y5)
             => ? [X4: A] :
                  ( member(A,X4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),X4),Y5) ) ) ) ) ).

% Inf_le_iff
tff(fact_5335_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),U: A] :
          ( ! [V4: A] :
              ( member(A,V4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),V4) )
         => ( ( A3 != bot_bot(set(A)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ) ).

% less_eq_Sup
tff(fact_5336_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3)) ) ) ).

% Sup_subset_mono
tff(fact_5337_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),U: A] :
          ( ! [V4: A] :
              ( member(A,V4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),V4),U) )
         => ( ( A3 != bot_bot(set(A)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),U) ) ) ) ).

% Inf_less_eq
tff(fact_5338_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [B3: set(A),A3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3)) ) ) ).

% Inf_superset_mono
tff(fact_5339_Union__mono,axiom,
    ! [A: $tType,A3: set(set(A)),B3: set(set(A))] :
      ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),A3),B3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3)) ) ).

% Union_mono
tff(fact_5340_Inter__anti__mono,axiom,
    ! [A: $tType,B3: set(set(A)),A3: set(set(A))] :
      ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),B3),A3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B3)) ) ).

% Inter_anti_mono
tff(fact_5341_card__partition,axiom,
    ! [A: $tType,C5: set(set(A)),K: nat] :
      ( aa(set(set(A)),$o,finite_finite(set(A)),C5)
     => ( aa(set(A),$o,finite_finite(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C5))
       => ( ! [C4: set(A)] :
              ( member(set(A),C4,C5)
             => ( aa(set(A),nat,finite_card(A),C4) = K ) )
         => ( ! [C1: set(A),C22: set(A)] :
                ( member(set(A),C1,C5)
               => ( member(set(A),C22,C5)
                 => ( ( C1 != C22 )
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C1),C22) = bot_bot(set(A)) ) ) ) )
           => ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(set(set(A)),nat,finite_card(set(A)),C5)) = aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C5)) ) ) ) ) ) ).

% card_partition
tff(fact_5342_inthall,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,$o),N: nat] :
      ( ! [X: A] :
          ( member(A,X,aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,P,X) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
       => aa(A,$o,P,aa(nat,A,nth(A,Xs),N)) ) ) ).

% inthall
tff(fact_5343_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),Xb: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,Xb)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_mu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),Xb)) ) ).

% times_int.abs_eq
tff(fact_5344_le__inf__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z) ) ) ) ).

% le_inf_iff
tff(fact_5345_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2) ) ) ) ).

% inf.bounded_iff
tff(fact_5346_Int__subset__iff,axiom,
    ! [A: $tType,C5: set(A),A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),A3)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),B3) ) ) ).

% Int_subset_iff
tff(fact_5347_Diff__disjoint,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) = bot_bot(set(A)) ) ).

% Diff_disjoint
tff(fact_5348_Diff__Compl,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) ) ).

% Diff_Compl
tff(fact_5349_sum__mult__of__bool__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [A3: set(A),F3: fun(A,B),P: fun(A,$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,$o),fun(A,B),aTP_Lamp_mv(fun(A,B),fun(fun(A,$o),fun(A,B)),F3),P)),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,P))) ) ) ) ).

% sum_mult_of_bool_eq
tff(fact_5350_sum__of__bool__mult__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [A3: set(A),P: fun(A,$o),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aTP_Lamp_mw(fun(A,$o),fun(fun(A,B),fun(A,B)),P),F3)),A3) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,P))) ) ) ) ).

% sum_of_bool_mult_eq
tff(fact_5351_sum__of__bool__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [A3: set(A),P: fun(A,$o)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aTP_Lamp_mx(fun(A,$o),fun(A,B),P)),A3) = aa(nat,B,semiring_1_of_nat(B),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,P)))) ) ) ) ) ).

% sum_of_bool_eq
tff(fact_5352_Union__Int__subset,axiom,
    ! [A: $tType,A3: set(set(A)),B3: set(set(A))] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A3),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),A3)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),B3))) ).

% Union_Int_subset
tff(fact_5353_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B3: set(A)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3))) ) ).

% Sup_inter_less_eq
tff(fact_5354_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X: nat,Y3: nat] : ( Z != aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),Y3)) ) ).

% eq_Abs_Integ
tff(fact_5355_int_Oabs__induct,axiom,
    ! [P: fun(int,$o),Xa: int] :
      ( ! [Y3: product_prod(nat,nat)] : aa(int,$o,P,aa(product_prod(nat,nat),int,abs_Integ,Y3))
     => aa(int,$o,P,Xa) ) ).

% int.abs_induct
tff(fact_5356_Diff__Int__distrib2,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),C5) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C5)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C5)) ) ).

% Diff_Int_distrib2
tff(fact_5357_Diff__Int__distrib,axiom,
    ! [A: $tType,C5: set(A),A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C5),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C5),A3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C5),B3)) ) ).

% Diff_Int_distrib
tff(fact_5358_Diff__Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) ) ).

% Diff_Diff_Int
tff(fact_5359_Diff__Int2,axiom,
    ! [A: $tType,A3: set(A),C5: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C5)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C5)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),C5)),B3) ) ).

% Diff_Int2
tff(fact_5360_Int__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),C5) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C5)) ) ).

% Int_Diff
tff(fact_5361_Int__mono,axiom,
    ! [A: $tType,A3: set(A),C5: set(A),B3: set(A),D3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),D3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),C5),D3)) ) ) ).

% Int_mono
tff(fact_5362_Int__lower1,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),A3) ).

% Int_lower1
tff(fact_5363_Int__lower2,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),B3) ).

% Int_lower2
tff(fact_5364_Int__absorb1,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = B3 ) ) ).

% Int_absorb1
tff(fact_5365_Int__absorb2,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = A3 ) ) ).

% Int_absorb2
tff(fact_5366_Int__greatest,axiom,
    ! [A: $tType,C5: set(A),A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),B3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) ) ) ).

% Int_greatest
tff(fact_5367_Int__Collect__mono,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( ! [X: A] :
            ( member(A,X,A3)
           => ( aa(A,$o,P,X)
             => aa(A,$o,Q,X) ) )
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,P))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),collect(A,Q))) ) ) ).

% Int_Collect_mono
tff(fact_5368_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),C2) ) ) ).

% inf.coboundedI2
tff(fact_5369_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),C2) ) ) ).

% inf.coboundedI1
tff(fact_5370_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = B2 ) ) ) ).

% inf.absorb_iff2
tff(fact_5371_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = A2 ) ) ) ).

% inf.absorb_iff1
tff(fact_5372_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),B2) ) ).

% inf.cobounded2
tff(fact_5373_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),A2) ) ).

% inf.cobounded1
tff(fact_5374_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( A2 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) ) ) ) ).

% inf.order_iff
tff(fact_5375_inf__greatest,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z)) ) ) ) ).

% inf_greatest
tff(fact_5376_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2)) ) ) ) ).

% inf.boundedI
tff(fact_5377_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),inf_inf(A),B2),C2))
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2) ) ) ) ).

% inf.boundedE
tff(fact_5378_inf__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y) = Y ) ) ) ).

% inf_absorb2
tff(fact_5379_inf__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y) = Xa ) ) ) ).

% inf_absorb1
tff(fact_5380_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = B2 ) ) ) ).

% inf.absorb2
tff(fact_5381_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) = A2 ) ) ) ).

% inf.absorb1
tff(fact_5382_le__iff__inf,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
        <=> ( aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y) = Xa ) ) ) ).

% le_iff_inf
tff(fact_5383_inf__unique,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [F3: fun(A,fun(A,A)),Xa: A,Y: A] :
          ( ! [X: A,Y3: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F3,X),Y3)),X)
         => ( ! [X: A,Y3: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F3,X),Y3)),Y3)
           => ( ! [X: A,Y3: A,Z4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Z4)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),F3,Y3),Z4)) ) )
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y) = aa(A,A,aa(A,fun(A,A),F3,Xa),Y) ) ) ) ) ) ).

% inf_unique
tff(fact_5384_inf_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2) ) ) ).

% inf.orderI
tff(fact_5385_inf_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( A2 = aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2) ) ) ) ).

% inf.orderE
tff(fact_5386_le__infI2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [B2: A,Xa: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),Xa) ) ) ).

% le_infI2
tff(fact_5387_le__infI1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,Xa: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),Xa)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),Xa) ) ) ).

% le_infI1
tff(fact_5388_inf__mono,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)),aa(A,A,aa(A,fun(A,A),inf_inf(A),C2),D2)) ) ) ) ).

% inf_mono
tff(fact_5389_le__infI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2)) ) ) ) ).

% le_infI
tff(fact_5390_le__infE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),B2))
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),B2) ) ) ) ).

% le_infE
tff(fact_5391_inf__le2,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y)),Y) ) ).

% inf_le2
tff(fact_5392_inf__le1,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y)),Xa) ) ).

% inf_le1
tff(fact_5393_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y)),Xa) ) ).

% inf_sup_ord(1)
tff(fact_5394_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y)),Y) ) ).

% inf_sup_ord(2)
tff(fact_5395_diff__eq,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% diff_eq
tff(fact_5396_Sup__inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),B3)),A2) = bot_bot(A) )
        <=> ! [X4: A] :
              ( member(A,X4,B3)
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),X4),A2) = bot_bot(A) ) ) ) ) ).

% Sup_inf_eq_bot_iff
tff(fact_5397_Int__Diff__disjoint,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = bot_bot(set(A)) ) ).

% Int_Diff_disjoint
tff(fact_5398_Diff__triv,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = A3 ) ) ).

% Diff_triv
tff(fact_5399_Diff__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B3)) ) ).

% Diff_eq
tff(fact_5400_inf__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y) = bot_bot(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,uminus_uminus(A),Y)) ) ) ).

% inf_shunt
tff(fact_5401_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),B3)) ) ).

% disjoint_eq_subset_Compl
tff(fact_5402_sum_Ointer__restrict,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(set(A),fun(A,B),aTP_Lamp_my(fun(A,B),fun(set(A),fun(A,B)),G),B3)),A3) ) ) ) ).

% sum.inter_restrict
tff(fact_5403_prod_Ointer__restrict,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(set(A),fun(A,B),aTP_Lamp_mz(fun(A,B),fun(set(A),fun(A,B)),G),B3)),A3) ) ) ) ).

% prod.inter_restrict
tff(fact_5404_zero__int__def,axiom,
    zero_zero(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))) ).

% zero_int_def
tff(fact_5405_int__def,axiom,
    ! [N: nat] : ( aa(nat,int,semiring_1_of_nat(int),N) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,N),zero_zero(nat))) ) ).

% int_def
tff(fact_5406_sum_Omono__neutral__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [T5: set(A),S2: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,finite_finite(A),S2)
           => ( ! [I2: A] :
                  ( member(A,I2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,H,I2) = zero_zero(B) ) )
             => ( ! [I2: A] :
                    ( member(A,I2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T5))
                   => ( aa(A,B,G,I2) = zero_zero(B) ) )
               => ( ! [X: A] :
                      ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T5))
                     => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
                 => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),S2) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),T5) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
tff(fact_5407_sum_OInt__Diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ) ) ).

% sum.Int_Diff
tff(fact_5408_prod_OInt__Diff,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))) ) ) ) ).

% prod.Int_Diff
tff(fact_5409_prod_Omono__neutral__cong,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [T5: set(A),S2: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( aa(set(A),$o,finite_finite(A),S2)
           => ( ! [I2: A] :
                  ( member(A,I2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
                 => ( aa(A,B,H,I2) = one_one(B) ) )
             => ( ! [I2: A] :
                    ( member(A,I2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T5))
                   => ( aa(A,B,G,I2) = one_one(B) ) )
               => ( ! [X: A] :
                      ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T5))
                     => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
                 => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),S2) = aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),T5) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
tff(fact_5410_card__Diff__subset__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
     => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ).

% card_Diff_subset_Int
tff(fact_5411_nat_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat)] : ( aa(int,nat,nat2,aa(product_prod(nat,nat),int,abs_Integ,Xa)) = aa(product_prod(nat,nat),nat,product_case_prod(nat,nat,nat,minus_minus(nat)),Xa) ) ).

% nat.abs_eq
tff(fact_5412_sum_OIf__cases,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),P: fun(A,$o),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_na(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),P),H),G)),A3) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),H),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,P)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),collect(A,P))))) ) ) ) ).

% sum.If_cases
tff(fact_5413_prod_OIf__cases,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),P: fun(A,$o),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_nb(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),P),H),G)),A3) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),H),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,P)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),uminus_uminus(set(A)),collect(A,P))))) ) ) ) ).

% prod.If_cases
tff(fact_5414_uminus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat)] : ( aa(int,int,uminus_uminus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_nc(nat,fun(nat,product_prod(nat,nat)))),Xa)) ) ).

% uminus_int.abs_eq
tff(fact_5415_one__int__def,axiom,
    one_one(int) = aa(product_prod(nat,nat),int,abs_Integ,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))) ).

% one_int_def
tff(fact_5416_sum__div__partition,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [A3: set(A),F3: fun(A,B),B2: B] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( divide_divide(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3),B2) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(B,fun(A,B),aTP_Lamp_nd(fun(A,B),fun(B,fun(A,B)),F3),B2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,aa(B,fun(A,$o),aTP_Lamp_ne(fun(A,B),fun(B,fun(A,$o)),F3),B2))))),divide_divide(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),collect(A,aa(B,fun(A,$o),aTP_Lamp_nf(fun(A,B),fun(B,fun(A,$o)),F3),B2)))),B2)) ) ) ) ).

% sum_div_partition
tff(fact_5417_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: product_prod(nat,nat)] : ( aa(int,A,ring_1_of_int(A),aa(product_prod(nat,nat),int,abs_Integ,Xa)) = aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_ng(nat,fun(nat,A))),Xa) ) ) ).

% of_int.abs_eq
tff(fact_5418_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),Xb: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,Xb))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_ni(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa),Xb) ) ).

% less_int.abs_eq
tff(fact_5419_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),Xb: product_prod(nat,nat)] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,Xb))
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_nk(nat,fun(nat,fun(product_prod(nat,nat),$o)))),Xa),Xb) ) ).

% less_eq_int.abs_eq
tff(fact_5420_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),Xb: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,Xb)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nm(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),Xb)) ) ).

% plus_int.abs_eq
tff(fact_5421_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod(nat,nat),Xb: product_prod(nat,nat)] : ( aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(nat,nat),int,abs_Integ,Xa)),aa(product_prod(nat,nat),int,abs_Integ,Xb)) = aa(product_prod(nat,nat),int,abs_Integ,aa(product_prod(nat,nat),product_prod(nat,nat),aa(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_no(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))))),Xa),Xb)) ) ).

% minus_int.abs_eq
tff(fact_5422_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list(A),Ys: list(B)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)))
     => ( aa(nat,product_prod(A,B),nth(product_prod(A,B),product(A,B,Xs,Ys)),N) = aa(B,product_prod(A,B),product_Pair(A,B,aa(nat,A,nth(A,Xs),divide_divide(nat,N,aa(list(B),nat,size_size(list(B)),Ys)))),aa(nat,B,nth(B,Ys),modulo_modulo(nat,N,aa(list(B),nat,size_size(list(B)),Ys)))) ) ) ).

% product_nth
tff(fact_5423_set__update__distinct,axiom,
    ! [A: $tType,Xs: list(A),N: nat,Xa: A] :
      ( distinct(A,Xs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
       => ( aa(list(A),set(A),set2(A),list_update(A,Xs,N,Xa)) = aa(set(A),set(A),insert(A,Xa),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),N)),bot_bot(set(A))))) ) ) ) ).

% set_update_distinct
tff(fact_5424_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)) = bot_bot(set(A)) )
     => ( aa(set(list(A)),nat,finite_card(list(A)),shuffles(A,Xs,Ys)) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% card_disjoint_shuffles
tff(fact_5425_list__update__beyond,axiom,
    ! [A: $tType,Xs: list(A),I: nat,Xa: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),I)
     => ( list_update(A,Xs,I,Xa) = Xs ) ) ).

% list_update_beyond
tff(fact_5426_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Ys: list(B)] : ( aa(list(product_prod(A,B)),nat,size_size(list(product_prod(A,B))),product(A,B,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(B),nat,size_size(list(B)),Ys)) ) ).

% length_product
tff(fact_5427_inf__int__def,axiom,
    inf_inf(int) = ord_min(int) ).

% inf_int_def
tff(fact_5428_inf__nat__def,axiom,
    inf_inf(nat) = ord_min(nat) ).

% inf_nat_def
tff(fact_5429_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list(A),A3: set(A),Xa: A,I: nat] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),A3)
     => ( member(A,Xa,A3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),list_update(A,Xs,I,Xa))),A3) ) ) ).

% set_update_subsetI
tff(fact_5430_length__shuffles,axiom,
    ! [A: $tType,Zs: list(A),Xs: list(A),Ys: list(A)] :
      ( member(list(A),Zs,shuffles(A,Xs,Ys))
     => ( aa(list(A),nat,size_size(list(A)),Zs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)) ) ) ).

% length_shuffles
tff(fact_5431_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list(A),I: nat,Xa: A] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),list_update(A,Xs,I,Xa))),aa(set(A),set(A),insert(A,Xa),aa(list(A),set(A),set2(A),Xs))) ).

% set_update_subset_insert
tff(fact_5432_distinct__list__update,axiom,
    ! [A: $tType,Xs: list(A),A2: A,I: nat] :
      ( distinct(A,Xs)
     => ( ~ member(A,A2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,aa(nat,A,nth(A,Xs),I)),bot_bot(set(A)))))
       => distinct(A,list_update(A,Xs,I,A2)) ) ) ).

% distinct_list_update
tff(fact_5433_less__eq__int_Orep__eq,axiom,
    ! [Xa: int,Xaa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),Xaa)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_nk(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,Xa)),aa(int,product_prod(nat,nat),rep_Integ,Xaa)) ) ).

% less_eq_int.rep_eq
tff(fact_5434_less__int_Orep__eq,axiom,
    ! [Xa: int,Xaa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Xa),Xaa)
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_ni(nat,fun(nat,fun(product_prod(nat,nat),$o)))),aa(int,product_prod(nat,nat),rep_Integ,Xa)),aa(int,product_prod(nat,nat),rep_Integ,Xaa)) ) ).

% less_int.rep_eq
tff(fact_5435_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_np(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F3),A2),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum_funpow
tff(fact_5436_nat_Orep__eq,axiom,
    ! [Xa: int] : ( aa(int,nat,nat2,Xa) = aa(product_prod(nat,nat),nat,product_case_prod(nat,nat,nat,minus_minus(nat)),aa(int,product_prod(nat,nat),rep_Integ,Xa)) ) ).

% nat.rep_eq
tff(fact_5437_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Xa: int] : ( aa(int,A,ring_1_of_int(A),Xa) = aa(product_prod(nat,nat),A,product_case_prod(nat,nat,A,aTP_Lamp_ng(nat,fun(nat,A))),aa(int,product_prod(nat,nat),rep_Integ,Xa)) ) ) ).

% of_int.rep_eq
tff(fact_5438_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_nq(fun(B,A),fun(A,fun(list(B),fun(nat,A))),F3),A2),Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(B),nat,size_size(list(B)),Xs))) ) ) ).

% horner_sum_eq_sum
tff(fact_5439_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,rotate1(A,Xs)),N) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,aa(nat,nat,suc,N),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% nth_rotate1
tff(fact_5440_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list(A),N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,product_prod(nat,A),nth(product_prod(nat,A),enumerate(A,N,Xs)),M) = aa(A,product_prod(nat,A),product_Pair(nat,A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M)),aa(nat,A,nth(A,Xs),M)) ) ) ).

% nth_enumerate_eq
tff(fact_5441_uminus__int__def,axiom,
    uminus_uminus(int) = aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_nc(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int_def
tff(fact_5442_rotate1__length01,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => ( rotate1(A,Xs) = Xs ) ) ).

% rotate1_length01
tff(fact_5443_times__int__def,axiom,
    times_times(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_mu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int_def
tff(fact_5444_minus__int__def,axiom,
    minus_minus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_no(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int_def
tff(fact_5445_plus__int__def,axiom,
    plus_plus(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(int,fun(int,int)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),rep_Integ,map_fun(int,product_prod(nat,nat),product_prod(nat,nat),int,rep_Integ,abs_Integ)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nm(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int_def
tff(fact_5446_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [S2: set(A),Y: A,F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ( member(A,Y,S2)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,lattic7623131987881927897min_on(A,B,F3,S2))),aa(A,B,F3,Y)) ) ) ) ) ).

% arg_min_least
tff(fact_5447_length__mul__elem,axiom,
    ! [A: $tType,Xs: list(list(A)),N: nat] :
      ( ! [X: list(A)] :
          ( member(list(A),X,aa(list(list(A)),set(list(A)),set2(list(A)),Xs))
         => ( aa(list(A),nat,size_size(list(A)),X) = N ) )
     => ( aa(list(A),nat,size_size(list(A)),concat(A,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(list(list(A)),nat,size_size(list(list(A))),Xs)),N) ) ) ).

% length_mul_elem
tff(fact_5448_pred__nat__def,axiom,
    pred_nat = collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_nr(nat,fun(nat,$o)))) ).

% pred_nat_def
tff(fact_5449_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(list(A)),set(list(A)),set2(list(A)),n_lists(A,N,Xs)) = collect(list(A),aa(list(A),fun(list(A),$o),aTP_Lamp_ns(nat,fun(list(A),fun(list(A),$o)),N),Xs)) ) ).

% set_n_lists
tff(fact_5450_prod_Oinsert_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),P2: fun(A,B),I: A] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ku(set(A),fun(fun(A,B),fun(A,$o)),I5),P2)))
         => ( groups1962203154675924110t_prod(A,B,P2,aa(set(A),set(A),insert(A,I),I5))
            = $ite(member(A,I,I5),groups1962203154675924110t_prod(A,B,P2,I5),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,P2,I)),groups1962203154675924110t_prod(A,B,P2,I5))) ) ) ) ).

% prod.insert'
tff(fact_5451_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))) = remove1(A,Xa,linord4507533701916653071of_set(A,A3)) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
tff(fact_5452_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P2: fun(B,A)] : ( groups1962203154675924110t_prod(B,A,P2,bot_bot(set(B))) = one_one(A) ) ) ).

% prod.empty'
tff(fact_5453_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),I5: set(B)] : ( groups1962203154675924110t_prod(B,A,G,collect(B,aa(set(B),fun(B,$o),aTP_Lamp_nt(fun(B,A),fun(set(B),fun(B,$o)),G),I5))) = groups1962203154675924110t_prod(B,A,G,I5) ) ) ).

% prod.non_neutral'
tff(fact_5454_prod_Odistrib__triv_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( groups1962203154675924110t_prod(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nu(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),times_times(B),groups1962203154675924110t_prod(A,B,G,I5)),groups1962203154675924110t_prod(A,B,H,I5)) ) ) ) ).

% prod.distrib_triv'
tff(fact_5455_prod_Omono__neutral__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [X: A] :
                ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,G,X) = one_one(B) ) )
           => ( groups1962203154675924110t_prod(A,B,G,S2) = groups1962203154675924110t_prod(A,B,G,T5) ) ) ) ) ).

% prod.mono_neutral_left'
tff(fact_5456_prod_Omono__neutral__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),T5: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [X: A] :
                ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,G,X) = one_one(B) ) )
           => ( groups1962203154675924110t_prod(A,B,G,T5) = groups1962203154675924110t_prod(A,B,G,S2) ) ) ) ) ).

% prod.mono_neutral_right'
tff(fact_5457_prod_Omono__neutral__cong__left_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),T5: set(A),H: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [I2: A] :
                ( member(A,I2,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,H,I2) = one_one(B) ) )
           => ( ! [X: A] :
                  ( member(A,X,S2)
                 => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
             => ( groups1962203154675924110t_prod(A,B,G,S2) = groups1962203154675924110t_prod(A,B,H,T5) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
tff(fact_5458_prod_Omono__neutral__cong__right_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [S2: set(A),T5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( ! [X: A] :
                ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T5),S2))
               => ( aa(A,B,G,X) = one_one(B) ) )
           => ( ! [X: A] :
                  ( member(A,X,S2)
                 => ( aa(A,B,G,X) = aa(A,B,H,X) ) )
             => ( groups1962203154675924110t_prod(A,B,G,T5) = groups1962203154675924110t_prod(A,B,H,S2) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
tff(fact_5459_prod_Odistrib_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [I5: set(A),G: fun(A,B),H: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ku(set(A),fun(fun(A,B),fun(A,$o)),I5),G)))
         => ( aa(set(A),$o,finite_finite(A),collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_ku(set(A),fun(fun(A,B),fun(A,$o)),I5),H)))
           => ( groups1962203154675924110t_prod(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nu(fun(A,B),fun(fun(A,B),fun(A,B)),G),H),I5) = aa(B,B,aa(B,fun(B,B),times_times(B),groups1962203154675924110t_prod(A,B,G,I5)),groups1962203154675924110t_prod(A,B,H,I5)) ) ) ) ) ).

% prod.distrib'
tff(fact_5460_prod_OG__def,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [P2: fun(B,A),I5: set(B)] :
          ( groups1962203154675924110t_prod(B,A,P2,I5)
          = $ite(aa(set(B),$o,finite_finite(B),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_nt(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),P2),collect(B,aa(set(B),fun(B,$o),aTP_Lamp_nt(fun(B,A),fun(set(B),fun(B,$o)),P2),I5))),one_one(A)) ) ) ).

% prod.G_def
tff(fact_5461_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),aa(nat,nat,suc,I)))
     => ( aa(nat,nat,nth(nat,linord4507533701916653071of_set(nat,set_or5935395276787703475ssThan(nat,I,J))),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),N)) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
tff(fact_5462_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( linord4507533701916653071of_set(A,aa(set(A),set(A),insert(A,Xa),A3)) = linorder_insort_key(A,A,aTP_Lamp_nv(A,A),Xa,linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
tff(fact_5463_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Xa: nat,Y: nat] :
      ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_nw(nat,fun(nat,nat),C2)),set_or7035219750837199246ssThan(nat,Xa,Y))
      = $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),C2),Y),
          set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Xa),C2),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Y),C2)),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Xa),Y),aa(set(nat),set(nat),insert(nat,zero_zero(nat)),bot_bot(set(nat))),bot_bot(set(nat))) ) ) ).

% image_minus_const_atLeastLessThan_nat
tff(fact_5464_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),divide_divide(int,A2,B2))),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      & aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),divide_divide(int,A2,B2)),one_one(int)))) ) ).

% rat_floor_lemma
tff(fact_5465_bij__betw__Suc,axiom,
    ! [M7: set(nat),N6: set(nat)] :
      ( bij_betw(nat,nat,suc,M7,N6)
    <=> ( aa(set(nat),set(nat),image(nat,nat,suc),M7) = N6 ) ) ).

% bij_betw_Suc
tff(fact_5466_image__add__0,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [S2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),zero_zero(A))),S2) = S2 ) ) ).

% image_add_0
tff(fact_5467_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_or1337092689740270186AtMost(A,I,J)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),K)) ) ) ).

% image_add_atLeastAtMost
tff(fact_5468_image__diff__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [D2: A,A2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),minus_minus(A),D2)),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),D2),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),D2),A2)) ) ) ).

% image_diff_atLeastAtMost
tff(fact_5469_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_or7035219750837199246ssThan(A,I,J)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),K)) ) ) ).

% image_add_atLeastLessThan
tff(fact_5470_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ordered_ab_group_add(A)
     => ! [C2: A,A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),C2)),set_ord_atMost(A,A2)) = set_ord_atMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2)) ) ) ).

% image_add_atMost
tff(fact_5471_length__insort,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),Xa: A,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),linorder_insort_key(A,B,F3,Xa,Xs)) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ) ).

% length_insort
tff(fact_5472_image__Suc__atLeastAtMost,axiom,
    ! [I: nat,J: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),set_or1337092689740270186AtMost(nat,I,J)) = set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,I),aa(nat,nat,suc,J)) ) ).

% image_Suc_atLeastAtMost
tff(fact_5473_image__Suc__atLeastLessThan,axiom,
    ! [I: nat,J: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),set_or7035219750837199246ssThan(nat,I,J)) = set_or7035219750837199246ssThan(nat,aa(nat,nat,suc,I),aa(nat,nat,suc,J)) ) ).

% image_Suc_atLeastLessThan
tff(fact_5474_bij__betw__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N6: set(nat),A3: set(A)] :
          ( bij_betw(nat,A,semiring_1_of_nat(A),N6,A3)
        <=> ( aa(set(nat),set(A),image(nat,A,semiring_1_of_nat(A)),N6) = A3 ) ) ) ).

% bij_betw_of_nat
tff(fact_5475_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_nx(A,fun(A,A),K)),set_or1337092689740270186AtMost(A,I,J)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),K)) ) ) ).

% image_add_atLeastAtMost'
tff(fact_5476_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [D2: A,A2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_ny(A,fun(A,A),D2)),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),aa(A,A,aa(A,fun(A,A),minus_minus(A),B2),D2)) ) ) ).

% image_minus_const_atLeastAtMost'
tff(fact_5477_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A,J: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_nx(A,fun(A,A),K)),set_or7035219750837199246ssThan(A,I,J)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),I),K),aa(A,A,aa(A,fun(A,A),plus_plus(A),J),K)) ) ) ).

% image_add_atLeastLessThan'
tff(fact_5478_mult__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] : ( aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),times_times(int),A2),C2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ).

% mult_rat
tff(fact_5479_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] : ( divide_divide(rat,aa(int,rat,aa(int,fun(int,rat),fract,A2),B2),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),C2)) ) ).

% divide_rat
tff(fact_5480_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D2)
         => ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),D2)),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),D2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),D2),B2)) ) ) ) ).

% image_mult_atLeastAtMost
tff(fact_5481_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [D2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),D2)
         => ( aa(set(A),set(A),image(A,A,aTP_Lamp_nz(A,fun(A,A),D2)),set_or1337092689740270186AtMost(A,A2,B2)) = set_or1337092689740270186AtMost(A,divide_divide(A,A2,D2),divide_divide(A,B2,D2)) ) ) ) ).

% image_divide_atLeastAtMost
tff(fact_5482_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))) ) ) ) ).

% less_rat
tff(fact_5483_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ) ) ).

% add_rat
tff(fact_5484_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2))
        <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2))) ) ) ) ).

% le_rat
tff(fact_5485_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),aa(int,rat,aa(int,fun(int,rat),fract,C2),D2)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2))),aa(int,int,aa(int,fun(int,int),times_times(int),B2),D2)) ) ) ) ).

% diff_rat
tff(fact_5486_sgn__rat,axiom,
    ! [A2: int,B2: int] : ( aa(rat,rat,sgn_sgn(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)) = aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),A2)),aa(int,int,sgn_sgn(int),B2))) ) ).

% sgn_rat
tff(fact_5487_finite__surj,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: set(B),F3: fun(A,B)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B3),aa(set(A),set(B),image(A,B,F3),A3))
       => aa(set(B),$o,finite_finite(B),B3) ) ) ).

% finite_surj
tff(fact_5488_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F3: fun(B,A),A3: set(B)] :
      ( aa(set(A),$o,finite_finite(A),B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F3),A3))
       => ? [C7: set(B)] :
            ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C7),A3)
            & aa(set(B),$o,finite_finite(B),C7)
            & ( B3 = aa(set(B),set(A),image(B,A,F3),C7) ) ) ) ) ).

% finite_subset_image
tff(fact_5489_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B),P: fun(set(A),$o)] :
      ( ? [B8: set(A)] :
          ( aa(set(A),$o,finite_finite(A),B8)
          & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B8),aa(set(B),set(A),image(B,A,F3),A3))
          & aa(set(A),$o,P,B8) )
    <=> ? [B8: set(B)] :
          ( aa(set(B),$o,finite_finite(B),B8)
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B8),A3)
          & aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),B8)) ) ) ).

% ex_finite_subset_image
tff(fact_5490_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B),P: fun(set(A),$o)] :
      ( ! [B8: set(A)] :
          ( ( aa(set(A),$o,finite_finite(A),B8)
            & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B8),aa(set(B),set(A),image(B,A,F3),A3)) )
         => aa(set(A),$o,P,B8) )
    <=> ! [B8: set(B)] :
          ( ( aa(set(B),$o,finite_finite(B),B8)
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B8),A3) )
         => aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),B8)) ) ) ).

% all_finite_subset_image
tff(fact_5491_zero__notin__Suc__image,axiom,
    ! [A3: set(nat)] : ~ member(nat,zero_zero(nat),aa(set(nat),set(nat),image(nat,nat,suc),A3)) ).

% zero_notin_Suc_image
tff(fact_5492_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),A3: set(B),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F3),A3)),B3)
     => aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),aa(set(set(B)),set(set(A)),image(set(B),set(A),image(B,A,F3)),pow2(B,A3))),pow2(A,B3)) ) ).

% image_Pow_mono
tff(fact_5493_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F3: fun(B,A),A3: set(B)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F3),A3))
    <=> ? [AA: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),AA),A3)
          & ( B3 = aa(set(B),set(A),image(B,A,F3),AA) ) ) ) ).

% subset_image_iff
tff(fact_5494_image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),A3: set(B),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F3),A3)),B3)
    <=> ! [X4: B] :
          ( member(B,X4,A3)
         => member(A,aa(B,A,F3,X4),B3) ) ) ).

% image_subset_iff
tff(fact_5495_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F3: fun(B,A),A3: set(B)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F3),A3))
     => ~ ! [C7: set(B)] :
            ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C7),A3)
           => ( B3 != aa(set(B),set(A),image(B,A,F3),C7) ) ) ) ).

% subset_imageE
tff(fact_5496_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F3: fun(A,B),B3: set(B)] :
      ( ! [X: A] :
          ( member(A,X,A3)
         => member(B,aa(A,B,F3,X),B3) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),B3) ) ).

% image_subsetI
tff(fact_5497_image__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(A),F3: fun(A,B)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),aa(set(A),set(B),image(A,B,F3),B3)) ) ).

% image_mono
tff(fact_5498_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B),P: fun(set(A),$o)] :
      ( ! [B8: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B8),aa(set(B),set(A),image(B,A,F3),A3))
         => aa(set(A),$o,P,B8) )
    <=> ! [B8: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B8),A3)
         => aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),B8)) ) ) ).

% all_subset_image
tff(fact_5499_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F3: fun(A,B),B3: set(B)] :
      ( ! [X: A] :
          ( aa(A,$o,P,X)
         => member(B,aa(A,B,F3,X),B3) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),collect(A,P))),B3) ) ).

% image_Collect_subsetI
tff(fact_5500_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),A2) = aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),C2) ) ).

% eq_rat(3)
tff(fact_5501_INF__eq,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(A),B3: set(B),G: fun(B,C),F3: fun(A,C)] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => ? [X3: B] :
                  ( member(B,X3,B3)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,G,X3)),aa(A,C,F3,I2)) ) )
         => ( ! [J2: B] :
                ( member(B,J2,B3)
               => ? [X3: A] :
                    ( member(A,X3,A3)
                    & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,X3)),aa(B,C,G,J2)) ) )
           => ( aa(set(C),C,complete_Inf_Inf(C),aa(set(A),set(C),image(A,C,F3),A3)) = aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image(B,C,G),B3)) ) ) ) ) ).

% INF_eq
tff(fact_5502_SUP__eq,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(A),B3: set(B),F3: fun(A,C),G: fun(B,C)] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => ? [X3: B] :
                  ( member(B,X3,B3)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,I2)),aa(B,C,G,X3)) ) )
         => ( ! [J2: B] :
                ( member(B,J2,B3)
               => ? [X3: A] :
                    ( member(A,X3,A3)
                    & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,G,J2)),aa(A,C,F3,X3)) ) )
           => ( aa(set(C),C,complete_Sup_Sup(C),aa(set(A),set(C),image(A,C,F3),A3)) = aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image(B,C,G),B3)) ) ) ) ) ).

% SUP_eq
tff(fact_5503_inf__Sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A2: A,B3: set(A)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),aa(set(A),A,complete_Sup_Sup(A),B3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),inf_inf(A),A2)),B3)) ) ) ).

% inf_Sup
tff(fact_5504_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B),B3: set(B)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),A3),B3))),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(B),set(A),image(B,A,F3),A3)),aa(set(B),set(A),image(B,A,F3),B3))) ).

% image_Int_subset
tff(fact_5505_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B),B3: set(B)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(B),set(A),image(B,A,F3),A3)),aa(set(B),set(A),image(B,A,F3),B3))),aa(set(B),set(A),image(B,A,F3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B3))) ).

% image_diff_subset
tff(fact_5506_eq__rat_I2_J,axiom,
    ! [A2: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,A2),zero_zero(int)) = aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),one_one(int)) ) ).

% eq_rat(2)
tff(fact_5507_Rat__induct__pos,axiom,
    ! [P: fun(rat,$o),Q2: rat] :
      ( ! [A4: int,B4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
         => aa(rat,$o,P,aa(int,rat,aa(int,fun(int,rat),fract,A4),B4)) )
     => aa(rat,$o,P,Q2) ) ).

% Rat_induct_pos
tff(fact_5508_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2 != zero_zero(int) )
     => ( ( D2 != zero_zero(int) )
       => ( ( aa(int,rat,aa(int,fun(int,rat),fract,A2),B2) = aa(int,rat,aa(int,fun(int,rat),fract,C2),D2) )
        <=> ( aa(int,int,aa(int,fun(int,int),times_times(int),A2),D2) = aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2) ) ) ) ) ).

% eq_rat(1)
tff(fact_5509_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2 != zero_zero(int) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),times_times(int),C2),A2)),aa(int,int,aa(int,fun(int,int),times_times(int),C2),B2)) = aa(int,rat,aa(int,fun(int,rat),fract,A2),B2) ) ) ).

% mult_rat_cancel
tff(fact_5510_Fract__of__nat__eq,axiom,
    ! [K: nat] : ( aa(int,rat,aa(int,fun(int,rat),fract,aa(nat,int,semiring_1_of_nat(int),K)),one_one(int)) = aa(nat,rat,semiring_1_of_nat(rat),K) ) ).

% Fract_of_nat_eq
tff(fact_5511_rat__number__collapse_I1_J,axiom,
    ! [K: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),K) = zero_zero(rat) ) ).

% rat_number_collapse(1)
tff(fact_5512_rat__number__collapse_I6_J,axiom,
    ! [K: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,K),zero_zero(int)) = zero_zero(rat) ) ).

% rat_number_collapse(6)
tff(fact_5513_One__rat__def,axiom,
    one_one(rat) = aa(int,rat,aa(int,fun(int,rat),fract,one_one(int)),one_one(int)) ).

% One_rat_def
tff(fact_5514_SUP__upper2,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I: A,A3: set(A),U: B,F3: fun(A,B)] :
          ( member(A,I,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,I))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ).

% SUP_upper2
tff(fact_5515_SUP__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(B,A),A3: set(B),U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))),U)
        <=> ! [X4: B] :
              ( member(B,X4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,X4)),U) ) ) ) ).

% SUP_le_iff
tff(fact_5516_SUP__upper,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I: A,A3: set(A),F3: fun(A,B)] :
          ( member(A,I,A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I)),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ).

% SUP_upper
tff(fact_5517_SUP__mono_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F3: fun(A,B),G: fun(A,B),A3: set(A)] :
          ( ! [X: A] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,G),A3))) ) ) ).

% SUP_mono'
tff(fact_5518_SUP__least,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F3: fun(A,B),U: B] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),U) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),U) ) ) ).

% SUP_least
tff(fact_5519_SUP__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [A3: set(A),B3: set(B),F3: fun(A,C),G: fun(B,C)] :
          ( ! [N2: A] :
              ( member(A,N2,A3)
             => ? [X3: B] :
                  ( member(B,X3,B3)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,N2)),aa(B,C,G,X3)) ) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(A),set(C),image(A,C,F3),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image(B,C,G),B3))) ) ) ).

% SUP_mono
tff(fact_5520_SUP__eqI,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F3: fun(A,B),Xa: B] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),Xa) )
         => ( ! [Y3: B] :
                ( ! [I4: A] :
                    ( member(A,I4,A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I4)),Y3) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Xa),Y3) )
           => ( aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3)) = Xa ) ) ) ) ).

% SUP_eqI
tff(fact_5521_INF__greatest,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),U: B,F3: fun(A,B)] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,I2)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ).

% INF_greatest
tff(fact_5522_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [U: A,F3: fun(B,A),A3: set(B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3)))
        <=> ! [X4: B] :
              ( member(B,X4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(B,A,F3,X4)) ) ) ) ).

% le_INF_iff
tff(fact_5523_INF__lower2,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I: A,A3: set(A),F3: fun(A,B),U: B] :
          ( member(A,I,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I)),U)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),U) ) ) ) ).

% INF_lower2
tff(fact_5524_INF__mono_H,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [F3: fun(A,B),G: fun(A,B),A3: set(A)] :
          ( ! [X: A] : aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X))
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),A3))) ) ) ).

% INF_mono'
tff(fact_5525_INF__lower,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I: A,A3: set(A),F3: fun(A,B)] :
          ( member(A,I,A3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,I)) ) ) ).

% INF_lower
tff(fact_5526_INF__mono,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comple6319245703460814977attice(C)
     => ! [B3: set(A),A3: set(B),F3: fun(B,C),G: fun(A,C)] :
          ( ! [M2: A] :
              ( member(A,M2,B3)
             => ? [X3: B] :
                  ( member(B,X3,A3)
                  & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(B,C,F3,X3)),aa(A,C,G,M2)) ) )
         => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image(B,C,F3),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(A),set(C),image(A,C,G),B3))) ) ) ).

% INF_mono
tff(fact_5527_INF__eqI,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),Xa: B,F3: fun(A,B)] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Xa),aa(A,B,F3,I2)) )
         => ( ! [Y3: B] :
                ( ! [I4: A] :
                    ( member(A,I4,A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y3),aa(A,B,F3,I4)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y3),Xa) )
           => ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3)) = Xa ) ) ) ) ).

% INF_eqI
tff(fact_5528_Fract__of__int__eq,axiom,
    ! [K: int] : ( aa(int,rat,aa(int,fun(int,rat),fract,K),one_one(int)) = aa(int,rat,ring_1_of_int(rat),K) ) ).

% Fract_of_int_eq
tff(fact_5529_SUP__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),B3: set(B),A2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),B3))),A2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(A,fun(B,A),aTP_Lamp_oa(fun(B,A),fun(A,fun(B,A)),F3),A2)),B3)) ) ) ).

% SUP_inf
tff(fact_5530_Sup__inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A2: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),B3)),A2) = aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),image(A,A,aTP_Lamp_ob(A,fun(A,A),A2)),B3)) ) ) ).

% Sup_inf
tff(fact_5531_inf__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A2: A,F3: fun(B,A),B3: set(B)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A2),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),B3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_oc(A,fun(fun(B,A),fun(B,A)),A2),F3)),B3)) ) ) ).

% inf_SUP
tff(fact_5532_SUP__inf__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(C,A),B3: set(C)] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,G),B3))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_oe(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F3),G),B3)),A3)) ) ) ).

% SUP_inf_distrib2
tff(fact_5533_Gcd__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_Gcd(B)
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
         => aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),gcd_Gcd(B,aa(set(A),set(B),image(A,B,F3),A3))),gcd_Gcd(B,aa(set(A),set(B),image(A,B,G),A3))) ) ) ).

% Gcd_mono
tff(fact_5534_le__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [Xa: A,F3: fun(B,A),A3: set(B)] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3)))
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),Xa)
             => ? [X4: B] :
                  ( member(B,X4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y5),aa(B,A,F3,X4)) ) ) ) ) ).

% le_SUP_iff
tff(fact_5535_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( comple5582772986160207858norder(A)
     => ! [F3: fun(B,A),A3: set(B),Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),Xa)
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y5)
             => ? [X4: B] :
                  ( member(B,X4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(B,A,F3,X4)),Y5) ) ) ) ) ).

% INF_le_iff
tff(fact_5536_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I5: set(A),C2: B,F3: fun(A,B)] :
          ( ( I5 != bot_bot(set(A)) )
         => ( ! [I2: A] :
                ( member(A,I2,I5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),aa(A,B,F3,I2)) )
           => ( ( aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),I5)) = C2 )
            <=> ! [X4: A] :
                  ( member(A,X4,I5)
                 => ( aa(A,B,F3,X4) = C2 ) ) ) ) ) ) ).

% SUP_eq_iff
tff(fact_5537_cSUP__least,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),F3: fun(A,B),M7: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),M7) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),M7) ) ) ) ).

% cSUP_least
tff(fact_5538_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [I5: set(A),F3: fun(A,B),C2: B] :
          ( ( I5 != bot_bot(set(A)) )
         => ( ! [I2: A] :
                ( member(A,I2,I5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),C2) )
           => ( ( aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),I5)) = C2 )
            <=> ! [X4: A] :
                  ( member(A,X4,I5)
                 => ( aa(A,B,F3,X4) = C2 ) ) ) ) ) ) ).

% INF_eq_iff
tff(fact_5539_cINF__greatest,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),M: B,F3: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( ! [X: A] :
                ( member(A,X,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M),aa(A,B,F3,X)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ).

% cINF_greatest
tff(fact_5540_card__image__le,axiom,
    ! [B: $tType,A: $tType,A3: set(A),F3: fun(A,B)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(B),nat,finite_card(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(A),nat,finite_card(A),A3)) ) ).

% card_image_le
tff(fact_5541_Zero__rat__def,axiom,
    zero_zero(rat) = aa(int,rat,aa(int,fun(int,rat),fract,zero_zero(int)),one_one(int)) ).

% Zero_rat_def
tff(fact_5542_SUP__subset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),B3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ( ! [X: A] :
                ( member(A,X,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,G),B3))) ) ) ) ).

% SUP_subset_mono
tff(fact_5543_INF__superset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [B3: set(A),A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( ! [X: A] :
                ( member(A,X,B3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),B3))) ) ) ) ).

% INF_superset_mono
tff(fact_5544_sum_Ogroup,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [S2: set(A),T5: set(B),G: fun(A,B),H: fun(A,C)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(B),$o,finite_finite(B),T5)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,G),S2)),T5)
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_og(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),S2),G),H)),T5) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),H),S2) ) ) ) ) ) ).

% sum.group
tff(fact_5545_prod_Ogroup,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [S2: set(A),T5: set(B),G: fun(A,B),H: fun(A,C)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(B),$o,finite_finite(B),T5)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,G),S2)),T5)
             => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_oh(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),S2),G),H)),T5) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),H),S2) ) ) ) ) ) ).

% prod.group
tff(fact_5546_rat__number__collapse_I3_J,axiom,
    ! [W: num] : ( aa(int,rat,aa(int,fun(int,rat),fract,aa(num,int,numeral_numeral(int),W)),one_one(int)) = aa(num,rat,numeral_numeral(rat),W) ) ).

% rat_number_collapse(3)
tff(fact_5547_rat__number__expand_I3_J,axiom,
    ! [K: num] : ( aa(num,rat,numeral_numeral(rat),K) = aa(int,rat,aa(int,fun(int,rat),fract,aa(num,int,numeral_numeral(int),K)),one_one(int)) ) ).

% rat_number_expand(3)
tff(fact_5548_sum_Oreindex__nontrivial,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [A3: set(A),H: fun(A,B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X: A,Y3: A] :
                ( member(A,X,A3)
               => ( member(A,Y3,A3)
                 => ( ( X != Y3 )
                   => ( ( aa(A,B,H,X) = aa(A,B,H,Y3) )
                     => ( aa(B,C,G,aa(A,B,H,X)) = zero_zero(C) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),aa(set(A),set(B),image(A,B,H),A3)) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(A,B),fun(A,C),comp(B,C,A,G),H)),A3) ) ) ) ) ).

% sum.reindex_nontrivial
tff(fact_5549_INF__le__SUP,axiom,
    ! [B: $tType,A: $tType] :
      ( comple6319245703460814977attice(B)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ).

% INF_le_SUP
tff(fact_5550_prod_Oreindex__nontrivial,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [A3: set(A),H: fun(A,B),G: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [X: A,Y3: A] :
                ( member(A,X,A3)
               => ( member(A,Y3,A3)
                 => ( ( X != Y3 )
                   => ( ( aa(A,B,H,X) = aa(A,B,H,Y3) )
                     => ( aa(B,C,G,aa(A,B,H,X)) = one_one(C) ) ) ) ) )
           => ( aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7121269368397514597t_prod(B,C),G),aa(set(A),set(B),image(A,B,H),A3)) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(fun(A,B),fun(A,C),comp(B,C,A,G),H)),A3) ) ) ) ) ).

% prod.reindex_nontrivial
tff(fact_5551_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(B),F3: fun(A,B)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B3),aa(set(A),set(B),image(A,B,F3),A3))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(B),nat,finite_card(B),B3)),aa(set(A),nat,finite_card(A),A3)) ) ) ).

% surj_card_le
tff(fact_5552_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( real_V5355595471888546746vector(A)
     => ! [C2: real,Xa: A,Y: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
         => ( aa(set(A),set(A),image(A,A,real_V8093663219630862766scaleR(A,C2)),set_or1337092689740270186AtMost(A,Xa,Y)) = set_or1337092689740270186AtMost(A,aa(A,A,real_V8093663219630862766scaleR(A,C2),Xa),aa(A,A,real_V8093663219630862766scaleR(A,C2),Y)) ) ) ) ).

% scaleR_image_atLeastAtMost
tff(fact_5553_image__Suc__lessThan,axiom,
    ! [N: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),set_ord_lessThan(nat,N)) = set_or1337092689740270186AtMost(nat,one_one(nat),N) ) ).

% image_Suc_lessThan
tff(fact_5554_image__Suc__atMost,axiom,
    ! [N: nat] : ( aa(set(nat),set(nat),image(nat,nat,suc),set_ord_atMost(nat,N)) = set_or1337092689740270186AtMost(nat,one_one(nat),aa(nat,nat,suc,N)) ) ).

% image_Suc_atMost
tff(fact_5555_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_or1337092689740270186AtMost(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_or1337092689740270186AtMost(nat,zero_zero(nat),N))) ) ).

% atLeast0_atMost_Suc_eq_insert_0
tff(fact_5556_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_or7035219750837199246ssThan(nat,zero_zero(nat),N))) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
tff(fact_5557_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_ord_lessThan(nat,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_ord_lessThan(nat,N))) ) ).

% lessThan_Suc_eq_insert_0
tff(fact_5558_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] : ( set_ord_atMost(nat,aa(nat,nat,suc,N)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),set_ord_atMost(nat,N))) ) ).

% atMost_Suc_eq_insert_0
tff(fact_5559_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2) ) ) ).

% zero_less_Fract_iff
tff(fact_5560_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),zero_zero(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),zero_zero(int)) ) ) ).

% Fract_less_zero_iff
tff(fact_5561_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),one_one(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),B2),A2) ) ) ).

% one_less_Fract_iff
tff(fact_5562_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),one_one(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),A2),B2) ) ) ).

% Fract_less_one_iff
tff(fact_5563_rat__number__collapse_I5_J,axiom,
    aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,uminus_uminus(int),one_one(int))),one_one(int)) = aa(rat,rat,uminus_uminus(rat),one_one(rat)) ).

% rat_number_collapse(5)
tff(fact_5564_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N != zero_zero(int) )
     => ( aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,aa(int,fun(int,int),plus_plus(int),M),N)),N) = aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(int,rat,aa(int,fun(int,rat),fract,M),N)),one_one(rat)) ) ) ).

% Fract_add_one
tff(fact_5565_sum__image__le,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ordere6911136660526730532id_add(B)
     => ! [I5: set(A),G: fun(C,B),F3: fun(A,C)] :
          ( aa(set(A),$o,finite_finite(A),I5)
         => ( ! [I2: A] :
                ( member(A,I2,I5)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),zero_zero(B)),aa(C,B,G,aa(A,C,F3,I2))) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(C),B,aa(fun(C,B),fun(set(C),B),groups7311177749621191930dd_sum(C,B),G),aa(set(A),set(C),image(A,C,F3),I5))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),aa(fun(A,C),fun(A,B),comp(C,B,A,G),F3)),I5)) ) ) ) ).

% sum_image_le
tff(fact_5566_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),zero_zero(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),zero_zero(int)) ) ) ).

% Fract_le_zero_iff
tff(fact_5567_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),zero_zero(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),A2) ) ) ).

% zero_le_Fract_iff
tff(fact_5568_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)),one_one(rat))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),A2),B2) ) ) ).

% Fract_le_one_iff
tff(fact_5569_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),one_one(rat)),aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),B2),A2) ) ) ).

% one_le_Fract_iff
tff(fact_5570_rat__number__collapse_I4_J,axiom,
    ! [W: num] : ( aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),W))),one_one(int)) = aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),W)) ) ).

% rat_number_collapse(4)
tff(fact_5571_rat__number__expand_I5_J,axiom,
    ! [K: num] : ( aa(rat,rat,uminus_uminus(rat),aa(num,rat,numeral_numeral(rat),K)) = aa(int,rat,aa(int,fun(int,rat),fract,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),K))),one_one(int)) ) ).

% rat_number_expand(5)
tff(fact_5572_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,Xa: A,Y: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),times_times(A),C2)),set_or1337092689740270186AtMost(A,Xa,Y))
          = $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),
              set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),Xa),aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),Y),aa(A,A,aa(A,fun(A,A),times_times(A),C2),Xa)),bot_bot(set(A))) ) ) ) ).

% image_mult_atLeastAtMost_if
tff(fact_5573_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( linord4507533701916653071of_set(A,A3) = linorder_insort_key(A,A,aTP_Lamp_nv(A,A),Xa,linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
tff(fact_5574_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [C2: A,Xa: A,Y: A] :
          ( aa(set(A),set(A),image(A,A,aTP_Lamp_oi(A,fun(A,A),C2)),set_or1337092689740270186AtMost(A,Xa,Y))
          = $ite(
              aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),Xa),C2),aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),times_times(A),Y),C2),aa(A,A,aa(A,fun(A,A),times_times(A),Xa),C2))),
              bot_bot(set(A)) ) ) ) ).

% image_mult_atLeastAtMost_if'
tff(fact_5575_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_oj(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost
tff(fact_5576_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_ok(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),B2)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),M),A2)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_diff
tff(fact_5577_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_ol(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,M)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,B2,M)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,B2,M)),C2),aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,A2,M)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div
tff(fact_5578_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [M: A,C2: A,A2: A,B2: A] :
          ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),aTP_Lamp_om(A,fun(A,fun(A,A)),M),C2)),set_or1337092689740270186AtMost(A,A2,B2))
          = $ite(
              set_or1337092689740270186AtMost(A,A2,B2) = bot_bot(set(A)),
              bot_bot(set(A)),
              $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),M),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A2,M)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,B2,M)),C2)),set_or1337092689740270186AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,B2,M)),C2),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,A2,M)),C2))) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
tff(fact_5579_sum__fun__comp,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [S2: set(A),R2: set(B),G: fun(A,B),F3: fun(B,C)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(set(B),$o,finite_finite(B),R2)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,G),S2)),R2)
             => ( aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(fun(B,C),fun(A,C),aTP_Lamp_on(fun(A,B),fun(fun(B,C),fun(A,C)),G),F3)),S2) = aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_oo(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),S2),G),F3)),R2) ) ) ) ) ) ).

% sum_fun_comp
tff(fact_5580_bij__betw__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A),B3: set(A)] :
          ( bij_betw(A,A,aa(A,fun(A,A),plus_plus(A),A2),A3,B3)
        <=> ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),A3) = B3 ) ) ) ).

% bij_betw_add
tff(fact_5581_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),aa(set(A),A,complete_Inf_Inf(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_op(A,fun(nat,A),B3)),collect(nat,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B3) ) ) ).

% INF_nat_binary
tff(fact_5582_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F9: fun(A,B),A8: set(A),A9: set(B),F3: fun(C,A),A3: set(C)] :
      ( bij_betw(A,B,F9,A8,A9)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F3),A3)),A8)
       => ( bij_betw(C,A,F3,A3,A8)
        <=> bij_betw(C,B,aa(fun(C,A),fun(C,B),comp(A,B,C,F9),F3),A3,A9) ) ) ) ).

% bij_betw_comp_iff2
tff(fact_5583_Gcd__abs__eq,axiom,
    ! [K6: set(int)] : ( gcd_Gcd(int,aa(set(int),set(int),image(int,int,abs_abs(int)),K6)) = gcd_Gcd(int,K6) ) ).

% Gcd_abs_eq
tff(fact_5584_Gcd__int__eq,axiom,
    ! [N6: set(nat)] : ( gcd_Gcd(int,aa(set(nat),set(int),image(nat,int,semiring_1_of_nat(int)),N6)) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,N6)) ) ).

% Gcd_int_eq
tff(fact_5585_Gcd__nat__abs__eq,axiom,
    ! [K6: set(int)] : ( gcd_Gcd(nat,aa(set(int),set(nat),image(int,nat,aTP_Lamp_oq(int,nat)),K6)) = aa(int,nat,nat2,gcd_Gcd(int,K6)) ) ).

% Gcd_nat_abs_eq
tff(fact_5586_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B3: fun(B,set(A)),A3: set(B)] : aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),aa(set(set(set(A))),set(set(A)),complete_Sup_Sup(set(set(A))),aa(set(B),set(set(set(A))),image(B,set(set(A)),aTP_Lamp_or(fun(B,set(A)),fun(B,set(set(A))),B3)),A3))),pow2(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B3),A3)))) ).

% UN_Pow_subset
tff(fact_5587_finite__int__iff__bounded__le,axiom,
    ! [S2: set(int)] :
      ( aa(set(int),$o,finite_finite(int),S2)
    <=> ? [K2: int] : aa(set(int),$o,aa(set(int),fun(set(int),$o),ord_less_eq(set(int)),aa(set(int),set(int),image(int,int,abs_abs(int)),S2)),set_ord_atMost(int,K2)) ) ).

% finite_int_iff_bounded_le
tff(fact_5588_finite__int__iff__bounded,axiom,
    ! [S2: set(int)] :
      ( aa(set(int),$o,finite_finite(int),S2)
    <=> ? [K2: int] : aa(set(int),$o,aa(set(int),fun(set(int),$o),ord_less_eq(set(int)),aa(set(int),set(int),image(int,int,abs_abs(int)),S2)),set_ord_lessThan(int,K2)) ) ).

% finite_int_iff_bounded
tff(fact_5589_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(A),F3: fun(A,set(B)),G: fun(A,set(B))] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( ! [X: A] :
            ( member(A,X,A3)
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F3,X)),aa(A,set(B),G,X)) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),F3),A3))),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),G),B3))) ) ) ).

% UN_mono
tff(fact_5590_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: fun(A,set(B)),C5: set(B)] :
      ( ! [X: A] :
          ( member(A,X,A3)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),B3,X)),C5) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A3))),C5) ) ).

% UN_least
tff(fact_5591_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set(A),B3: fun(A,set(B))] :
      ( member(A,A2,A3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),B3,A2)),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A3))) ) ).

% UN_upper
tff(fact_5592_UN__subset__iff,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),I5: set(B),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5))),B3)
    <=> ! [X4: B] :
          ( member(B,X4,I5)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(B,set(A),A3,X4)),B3) ) ) ).

% UN_subset_iff
tff(fact_5593_UN__extend__simps_I6_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C5: set(B),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C5))),B3) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_os(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B3)),C5)) ) ).

% UN_extend_simps(6)
tff(fact_5594_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set(A),B3: fun(A,set(B))] :
      ( member(A,A2,A3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A3))),aa(A,set(B),B3,A2)) ) ).

% INT_lower
tff(fact_5595_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set(A),C5: set(B),B3: fun(A,set(B))] :
      ( ! [X: A] :
          ( member(A,X,A3)
         => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C5),aa(A,set(B),B3,X)) )
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C5),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),B3),A3))) ) ).

% INT_greatest
tff(fact_5596_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(A),F3: fun(A,set(B)),G: fun(A,set(B))] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( ! [X: A] :
            ( member(A,X,A3)
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F3,X)),aa(A,set(B),G,X)) )
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),F3),B3))),aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(A),set(set(B)),image(A,set(B),G),A3))) ) ) ).

% INT_anti_mono
tff(fact_5597_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B3: set(A),A3: fun(B,set(A)),I5: set(B)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5)))
    <=> ! [X4: B] :
          ( member(B,X4,I5)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(B,set(A),A3,X4)) ) ) ).

% INT_subset_iff
tff(fact_5598_in__image__insert__iff,axiom,
    ! [A: $tType,B3: set(set(A)),Xa: A,A3: set(A)] :
      ( ! [C7: set(A)] :
          ( member(set(A),C7,B3)
         => ~ member(A,Xa,C7) )
     => ( member(set(A),A3,aa(set(set(A)),set(set(A)),image(set(A),set(A),insert(A,Xa)),B3))
      <=> ( member(A,Xa,A3)
          & member(set(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))),B3) ) ) ) ).

% in_image_insert_iff
tff(fact_5599_image__int__atLeastAtMost,axiom,
    ! [A2: nat,B2: nat] : ( aa(set(nat),set(int),image(nat,int,semiring_1_of_nat(int)),set_or1337092689740270186AtMost(nat,A2,B2)) = set_or1337092689740270186AtMost(int,aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% image_int_atLeastAtMost
tff(fact_5600_image__int__atLeastLessThan,axiom,
    ! [A2: nat,B2: nat] : ( aa(set(nat),set(int),image(nat,int,semiring_1_of_nat(int)),set_or7035219750837199246ssThan(nat,A2,B2)) = set_or7035219750837199246ssThan(int,aa(nat,int,semiring_1_of_nat(int),A2),aa(nat,int,semiring_1_of_nat(int),B2)) ) ).

% image_int_atLeastLessThan
tff(fact_5601_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I5: set(A),A3: fun(A,set(B)),F3: fun(B,C),A8: fun(A,set(C))] :
      ( ! [I2: A,J2: A] :
          ( member(A,I2,I5)
         => ( member(A,J2,I5)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,I2)),aa(A,set(B),A3,J2))
              | aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,J2)),aa(A,set(B),A3,I2)) ) ) )
     => ( ! [I2: A] :
            ( member(A,I2,I5)
           => bij_betw(B,C,F3,aa(A,set(B),A3,I2),aa(A,set(C),A8,I2)) )
       => bij_betw(B,C,F3,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)),aa(set(set(C)),set(C),complete_Sup_Sup(set(C)),aa(set(A),set(set(C)),image(A,set(C),A8),I5))) ) ) ).

% bij_betw_UNION_chain
tff(fact_5602_UN__extend__simps_I7_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: fun(B,set(A)),C5: set(B)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),B3),C5))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ot(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B3)),C5)) ) ).

% UN_extend_simps(7)
tff(fact_5603_INT__extend__simps_I4_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: fun(B,set(A)),C5: set(B)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B3),C5)))
      = $ite(C5 = bot_bot(set(B)),A3,aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ot(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B3)),C5))) ) ).

% INT_extend_simps(4)
tff(fact_5604_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: fun(nat,set(A)),K: nat,N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_ou(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M7),K)),set_ord_lessThan(nat,N))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_or7035219750837199246ssThan(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift_strict
tff(fact_5605_UN__le__add__shift,axiom,
    ! [A: $tType,M7: fun(nat,set(A)),K: nat,N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_ou(fun(nat,set(A)),fun(nat,fun(nat,set(A))),M7),K)),set_ord_atMost(nat,N))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_or1337092689740270186AtMost(nat,K,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),K)))) ) ).

% UN_le_add_shift
tff(fact_5606_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] : ( aa(set(int),set(int),image(int,int,aTP_Lamp_ov(int,fun(int,int),L)),set_or7035219750837199246ssThan(int,zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L))) = set_or7035219750837199246ssThan(int,L,U) ) ).

% image_add_int_atLeastLessThan
tff(fact_5607_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B))] :
      ( aa(set(A),$o,finite_finite(A),I5)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(B),nat,finite_card(B),aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5)))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aTP_Lamp_ow(fun(A,set(B)),fun(A,nat),A3)),I5)) ) ).

% card_UN_le
tff(fact_5608_Gcd__int__def,axiom,
    ! [K6: set(int)] : ( gcd_Gcd(int,K6) = aa(nat,int,semiring_1_of_nat(int),gcd_Gcd(nat,aa(set(int),set(nat),image(int,nat,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))),K6))) ) ).

% Gcd_int_def
tff(fact_5609_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),U)
     => ( set_or7035219750837199246ssThan(int,zero_zero(int),U) = aa(set(nat),set(int),image(nat,int,semiring_1_of_nat(int)),set_ord_lessThan(nat,aa(int,nat,nat2,U))) ) ) ).

% image_atLeastZeroLessThan_int
tff(fact_5610_translation__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),S)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),T2)) ) ) ).

% translation_Int
tff(fact_5611_translation__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),S)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),T2)) ) ) ).

% translation_diff
tff(fact_5612_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F9: fun(B,A),F3: fun(A,B),A8: set(B)] :
      ( ! [X: A] :
          ( member(A,X,A3)
         => ( aa(B,A,F9,aa(A,B,F3,X)) = X ) )
     => ( ! [X: B] :
            ( member(B,X,A8)
           => ( aa(A,B,F3,aa(B,A,F9,X)) = X ) )
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),A8)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F9),A8)),A3)
           => bij_betw(A,B,F3,A3,A8) ) ) ) ) ).

% bij_betw_byWitness
tff(fact_5613_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(A),A8: set(B),B3: set(A),B12: set(B)] :
      ( bij_betw(A,B,F3,A3,A8)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( ( aa(set(A),set(B),image(A,B,F3),B3) = B12 )
         => bij_betw(A,B,F3,B3,B12) ) ) ) ).

% bij_betw_subset
tff(fact_5614_translation__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,T2: set(A)] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),aa(set(A),set(A),uminus_uminus(set(A)),T2)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),T2)) ) ) ).

% translation_Compl
tff(fact_5615_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),S)),aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),T2)) ) ) ).

% translation_subtract_Int
tff(fact_5616_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,S: set(A),T2: set(A)] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),T2)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),S)),aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),T2)) ) ) ).

% translation_subtract_diff
tff(fact_5617_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A,T2: set(A)] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),aa(set(A),set(A),uminus_uminus(set(A)),T2)) = aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),T2)) ) ) ).

% translation_subtract_Compl
tff(fact_5618_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S2: set(A)] :
          ( topolo6688025880775521714ounded(A,S2)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [K2: set(A)] :
                  ( aa(set(A),$o,finite_finite(A),K2)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(A),set(set(A)),image(A,set(A),aTP_Lamp_oz(real,fun(A,set(A)),E3)),K2))) ) ) ) ) ).

% totally_bounded_metric
tff(fact_5619_UN__image__subset,axiom,
    ! [C: $tType,B: $tType,A: $tType,F3: fun(B,set(A)),G: fun(C,set(B)),Xa: C,X6: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),aa(C,set(B),G,Xa)))),X6)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(C,set(B),G,Xa)),collect(B,aa(set(A),fun(B,$o),aTP_Lamp_pa(fun(B,set(A)),fun(set(A),fun(B,$o)),F3),X6))) ) ).

% UN_image_subset
tff(fact_5620_INF__filter__not__bot,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F6: fun(A,filter(B))] :
      ( ! [X7: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X7),B3)
         => ( aa(set(A),$o,finite_finite(A),X7)
           => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F6),X7)) != bot_bot(filter(B)) ) ) )
     => ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F6),B3)) != bot_bot(filter(B)) ) ) ).

% INF_filter_not_bot
tff(fact_5621_INF__filter__bot__base,axiom,
    ! [A: $tType,B: $tType,I5: set(A),F6: fun(A,filter(B))] :
      ( ! [I2: A] :
          ( member(A,I2,I5)
         => ! [J2: A] :
              ( member(A,J2,I5)
             => ? [X3: A] :
                  ( member(A,X3,I5)
                  & aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),aa(A,filter(B),F6,X3)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F6,I2)),aa(A,filter(B),F6,J2))) ) ) )
     => ( ( aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F6),I5)) = bot_bot(filter(B)) )
      <=> ? [X4: A] :
            ( member(A,X4,I5)
            & ( aa(A,filter(B),F6,X4) = bot_bot(filter(B)) ) ) ) ) ).

% INF_filter_bot_base
tff(fact_5622_Inf__filter__not__bot,axiom,
    ! [A: $tType,B3: set(filter(A))] :
      ( ! [X7: set(filter(A))] :
          ( aa(set(filter(A)),$o,aa(set(filter(A)),fun(set(filter(A)),$o),ord_less_eq(set(filter(A))),X7),B3)
         => ( aa(set(filter(A)),$o,finite_finite(filter(A)),X7)
           => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),X7) != bot_bot(filter(A)) ) ) )
     => ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3) != bot_bot(filter(A)) ) ) ).

% Inf_filter_not_bot
tff(fact_5623_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [S2: set(A),T5: set(A)] :
          ( topolo6688025880775521714ounded(A,S2)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T5),S2)
           => topolo6688025880775521714ounded(A,T5) ) ) ) ).

% totally_bounded_subset
tff(fact_5624_conj__subset__def,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o),Q: fun(A,$o)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_pb(fun(A,$o),fun(fun(A,$o),fun(A,$o)),P),Q)))
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),collect(A,P))
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),collect(A,Q)) ) ) ).

% conj_subset_def
tff(fact_5625_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F3: fun(nat,set(A)),S2: set(A)] :
      ( ! [I2: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),F3,I2)),S2)
     => ( aa(set(A),$o,finite_finite(A),S2)
       => ( ? [N8: nat] :
              ( ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N2),N8)
                 => ! [M2: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N8)
                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N2)
                       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less(set(A)),aa(nat,set(A),F3,M2)),aa(nat,set(A),F3,N2)) ) ) )
              & ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
                 => ( aa(nat,set(A),F3,N8) = aa(nat,set(A),F3,N2) ) ) )
         => ( aa(nat,set(A),F3,aa(set(A),nat,finite_card(A),S2)) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),F3),top_top(set(nat)))) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
tff(fact_5626_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),A3: set(B),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F3),A3)),B3)
     => aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),aa(set(set(B)),set(set(A)),image(set(B),set(A),image(B,A,F3)),finite_Fpow(B,A3))),finite_Fpow(A,B3)) ) ).

% image_Fpow_mono
tff(fact_5627_suminf__eq__SUP__real,axiom,
    ! [X6: fun(nat,real)] :
      ( summable(real,X6)
     => ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,X6,I2))
       => ( suminf(real,X6) = aa(set(real),real,complete_Sup_Sup(real),aa(set(nat),set(real),image(nat,real,aTP_Lamp_pc(fun(nat,real),fun(nat,real),X6)),top_top(set(nat)))) ) ) ) ).

% suminf_eq_SUP_real
tff(fact_5628_surj__plus,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_plus
tff(fact_5629_range__add,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),A2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% range_add
tff(fact_5630_range__diff,axiom,
    ! [A: $tType] :
      ( group_add(A)
     => ! [A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),minus_minus(A),A2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% range_diff
tff(fact_5631_Diff__UNIV,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),top_top(set(A))) = bot_bot(set(A)) ) ).

% Diff_UNIV
tff(fact_5632_surj__fn,axiom,
    ! [A: $tType,F3: fun(A,A),N: nat] :
      ( ( aa(set(A),set(A),image(A,A,F3),top_top(set(A))) = top_top(set(A)) )
     => ( aa(set(A),set(A),image(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_fn
tff(fact_5633_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ( gcd_Gcd(A,top_top(set(A))) = one_one(A) ) ) ).

% Gcd_UNIV
tff(fact_5634_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : ( aa(set(A),set(A),image(A,A,aTP_Lamp_ox(A,fun(A,A),A2)),top_top(set(A))) = top_top(set(A)) ) ) ).

% surj_diff_right
tff(fact_5635_INT__simps_I3_J,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),B3: set(A),C5: set(B)] :
      ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_os(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B3)),C5))
      = $ite(C5 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C5))),B3)) ) ).

% INT_simps(3)
tff(fact_5636_INT__simps_I4_J,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: fun(B,set(A)),C5: set(B)] :
      ( aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ot(set(A),fun(fun(B,set(A)),fun(B,set(A))),A3),B3)),C5))
      = $ite(C5 = bot_bot(set(B)),top_top(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),B3),C5)))) ) ).

% INT_simps(4)
tff(fact_5637_SUP__INF,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [P: fun(C,fun(B,A))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aTP_Lamp_pe(fun(C,fun(B,A)),fun(B,A),P)),top_top(set(B)))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(fun(B,C)),set(A),image(fun(B,C),A,aTP_Lamp_pg(fun(C,fun(B,A)),fun(fun(B,C),A),P)),top_top(set(fun(B,C))))) ) ) ).

% SUP_INF
tff(fact_5638_INF__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [P: fun(C,fun(B,A))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aTP_Lamp_ph(fun(C,fun(B,A)),fun(B,A),P)),top_top(set(B)))) = aa(set(A),A,complete_Sup_Sup(A),aa(set(fun(B,C)),set(A),image(fun(B,C),A,aTP_Lamp_pi(fun(C,fun(B,A)),fun(fun(B,C),A),P)),top_top(set(fun(B,C))))) ) ) ).

% INF_SUP
tff(fact_5639_less__filter__def,axiom,
    ! [A: $tType,F6: filter(A),F10: filter(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less(filter(A)),F6),F10)
    <=> ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10)
        & ~ aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F10),F6) ) ) ).

% less_filter_def
tff(fact_5640_top__greatest,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),top_top(A)) ) ).

% top_greatest
tff(fact_5641_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),top_top(A)),A2)
        <=> ( A2 = top_top(A) ) ) ) ).

% top.extremum_unique
tff(fact_5642_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),top_top(A)),A2)
         => ( A2 = top_top(A) ) ) ) ).

% top.extremum_uniqueI
tff(fact_5643_subset__UNIV,axiom,
    ! [A: $tType,A3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),top_top(set(A))) ).

% subset_UNIV
tff(fact_5644_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( aa(set(fun(A,B)),$o,finite_finite(fun(A,B)),top_top(set(fun(A,B))))
     => ( ( aa(set(B),nat,finite_card(B),top_top(set(B))) != aa(nat,nat,suc,zero_zero(nat)) )
       => aa(set(A),$o,finite_finite(A),top_top(set(A))) ) ) ).

% finite_fun_UNIVD1
tff(fact_5645_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),B3: set(A),I: B] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F3),top_top(set(B)))),B3)
     => member(A,aa(B,A,F3,I),B3) ) ).

% range_subsetD
tff(fact_5646_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [L: A,H: A] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),top_top(set(A))),set_or1337092689740270186AtMost(A,L,H)) ) ).

% not_UNIV_le_Icc
tff(fact_5647_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [H: A] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),top_top(set(A))),set_ord_atMost(A,H)) ) ).

% not_UNIV_le_Iic
tff(fact_5648_Compl__eq__Diff__UNIV,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),A3) ) ).

% Compl_eq_Diff_UNIV
tff(fact_5649_bij__fn,axiom,
    ! [A: $tType,F3: fun(A,A),N: nat] :
      ( bij_betw(A,A,F3,top_top(set(A)),top_top(set(A)))
     => bij_betw(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),top_top(set(A)),top_top(set(A))) ) ).

% bij_fn
tff(fact_5650_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),A3: set(B)] :
      ( ( aa(set(B),set(A),image(B,A,F3),top_top(set(B))) = top_top(set(A)) )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),aa(set(B),set(A),image(B,A,F3),A3))),aa(set(B),set(A),image(B,A,F3),aa(set(B),set(B),uminus_uminus(set(B)),A3))) ) ).

% surj_Compl_image_subset
tff(fact_5651_Nats__def,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ( semiring_1_Nats(A) = aa(set(nat),set(A),image(nat,A,semiring_1_of_nat(A)),top_top(set(nat))) ) ) ).

% Nats_def
tff(fact_5652_Fpow__mono,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),finite_Fpow(A,A3)),finite_Fpow(A,B3)) ) ).

% Fpow_mono
tff(fact_5653_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4346867609351753570nf_top(A)
     => semila1105856199041335345_order(A,inf_inf(A),top_top(A),ord_less_eq(A),ord_less(A)) ) ).

% inf_top.semilattice_neutr_order_axioms
tff(fact_5654_Fpow__subset__Pow,axiom,
    ! [A: $tType,A3: set(A)] : aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),finite_Fpow(A,A3)),pow2(A,A3)) ).

% Fpow_subset_Pow
tff(fact_5655_Fpow__def,axiom,
    ! [A: $tType,A3: set(A)] : ( finite_Fpow(A,A3) = collect(set(A),aTP_Lamp_pj(set(A),fun(set(A),$o),A3)) ) ).

% Fpow_def
tff(fact_5656_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( aa(set(A),$o,finite_finite(A),top_top(set(A)))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),top_top(set(A)))) ) ).

% finite_UNIV_card_ge_0
tff(fact_5657_INT__extend__simps_I3_J,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),C5: set(B),B3: set(A)] :
      ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),C5))),B3)
      = $ite(C5 = bot_bot(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),B3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_os(fun(B,set(A)),fun(set(A),fun(B,set(A))),A3),B3)),C5))) ) ).

% INT_extend_simps(3)
tff(fact_5658_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A))] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),aTP_Lamp_pk(fun(nat,set(A)),fun(nat,set(A)),A3)),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat)))) ) ).

% UN_UN_finite_eq
tff(fact_5659_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A)] :
      ( aa(set(A),$o,finite_finite(A),aa(set(B),set(A),image(B,A,F3),top_top(set(B))))
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(set(A),nat,finite_card(A),aa(set(B),set(A),image(B,A,F3),top_top(set(B))))) ) ).

% card_range_greater_zero
tff(fact_5660_UN__finite__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),C5: set(A)] :
      ( ! [N2: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),C5)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat))))),C5) ) ).

% UN_finite_subset
tff(fact_5661_UN__finite2__eq,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B3: fun(nat,set(A)),K: nat] :
      ( ! [N2: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K)))) )
     => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat)))) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),top_top(set(nat)))) ) ) ).

% UN_finite2_eq
tff(fact_5662_range__mod,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(set(nat),set(nat),image(nat,nat,aTP_Lamp_pl(nat,fun(nat,nat),N)),top_top(set(nat))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),N) ) ) ).

% range_mod
tff(fact_5663_UN__finite2__subset,axiom,
    ! [A: $tType,A3: fun(nat,set(A)),B3: fun(nat,set(A)),K: nat] :
      ( ! [N2: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),set_or7035219750837199246ssThan(nat,zero_zero(nat),N2)))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),K)))))
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),A3),top_top(set(nat))))),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),B3),top_top(set(nat))))) ) ).

% UN_finite2_subset
tff(fact_5664_UNIV__nat__eq,axiom,
    top_top(set(nat)) = aa(set(nat),set(nat),insert(nat,zero_zero(nat)),aa(set(nat),set(nat),image(nat,nat,suc),top_top(set(nat)))) ).

% UNIV_nat_eq
tff(fact_5665_cclfp__def,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [F3: fun(A,A)] : ( order_532582986084564980_cclfp(A,F3) = aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_pm(fun(A,A),fun(nat,A),F3)),top_top(set(nat)))) ) ) ).

% cclfp_def
tff(fact_5666_measure__function__int,axiom,
    fun_is_measure(int,aa(fun(int,int),fun(int,nat),comp(int,nat,int,nat2),abs_abs(int))) ).

% measure_function_int
tff(fact_5667_card__UNIV__unit,axiom,
    aa(set(product_unit),nat,finite_card(product_unit),top_top(set(product_unit))) = one_one(nat) ).

% card_UNIV_unit
tff(fact_5668_range__mult,axiom,
    ! [A2: real] :
      ( aa(set(real),set(real),image(real,real,aa(real,fun(real,real),times_times(real),A2)),top_top(set(real)))
      = $ite(A2 = zero_zero(real),aa(set(real),set(real),insert(real,zero_zero(real)),bot_bot(set(real))),top_top(set(real))) ) ).

% range_mult
tff(fact_5669_range__abs__Nats,axiom,
    aa(set(int),set(int),image(int,int,abs_abs(int)),top_top(set(int))) = semiring_1_Nats(int) ).

% range_abs_Nats
tff(fact_5670_card__UNIV__bool,axiom,
    aa(set($o),nat,finite_card($o),top_top(set($o))) = aa(num,nat,numeral_numeral(nat),bit0(one2)) ).

% card_UNIV_bool
tff(fact_5671_infinite__UNIV__int,axiom,
    ~ aa(set(int),$o,finite_finite(int),top_top(set(int))) ).

% infinite_UNIV_int
tff(fact_5672_bij__prod__encode,axiom,
    bij_betw(product_prod(nat,nat),nat,nat_prod_encode,top_top(set(product_prod(nat,nat))),top_top(set(nat))) ).

% bij_prod_encode
tff(fact_5673_surj__prod__encode,axiom,
    aa(set(product_prod(nat,nat)),set(nat),image(product_prod(nat,nat),nat,nat_prod_encode),top_top(set(product_prod(nat,nat)))) = top_top(set(nat)) ).

% surj_prod_encode
tff(fact_5674_Ints__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_Ints(A) = aa(set(int),set(A),image(int,A,ring_1_of_int(A)),top_top(set(int))) ) ) ).

% Ints_def
tff(fact_5675_int__in__range__abs,axiom,
    ! [N: nat] : member(int,aa(nat,int,semiring_1_of_nat(int),N),aa(set(int),set(int),image(int,int,abs_abs(int)),top_top(set(int)))) ).

% int_in_range_abs
tff(fact_5676_root__def,axiom,
    ! [N: nat,Xa: real] :
      ( aa(real,real,root(N),Xa)
      = $ite(N = zero_zero(nat),zero_zero(real),the_inv_into(real,real,top_top(set(real)),aTP_Lamp_pn(nat,fun(real,real),N),Xa)) ) ).

% root_def
tff(fact_5677_DERIV__real__root__generic,axiom,
    ! [N: nat,Xa: real,D3: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ( Xa != zero_zero(real) )
       => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
             => ( D3 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) ) ) )
         => ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real))
               => ( D3 = aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat))))))) ) ) )
           => ( ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
               => ( D3 = aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))) ) )
             => has_field_derivative(real,root(N),D3,topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ) ) ).

% DERIV_real_root_generic
tff(fact_5678_DERIV__even__real__root,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real))
         => has_field_derivative(real,root(N),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,uminus_uminus(real),aa(nat,real,semiring_1_of_nat(real),N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ).

% DERIV_even_real_root
tff(fact_5679_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Y: A,Z: A,Xa: A,S2: set(A)] :
          ( has_field_derivative(A,F3,Y,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Xa),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),Z)),S2)))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_po(fun(A,A),fun(A,fun(A,A)),F3),Z),Y,topolo174197925503356063within(A,Xa,S2)) ) ) ).

% DERIV_at_within_shift
tff(fact_5680_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,G: fun(A,A),Xa: A,S: set(A),Db: A] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,aa(A,A,G,Xa),aa(set(A),set(A),image(A,A,G),S)))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_image_chain
tff(fact_5681_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Y: A,Z: A,Xa: A,S2: set(A)] :
          ( has_field_derivative(A,F3,Y,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Z),Xa),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),Z)),S2)))
         => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),aa(A,fun(A,A),plus_plus(A),Z)),Y,topolo174197925503356063within(A,Xa,S2)) ) ) ).

% DERIV_at_within_shift_lemma
tff(fact_5682_MVT2,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),F9: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
             => has_field_derivative(real,F3,aa(real,real,F9,X),topolo174197925503356063within(real,X,top_top(set(real)))) ) )
       => ? [Z4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z4),B2)
            & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),aa(real,real,F9,Z4)) ) ) ) ) ).

% MVT2
tff(fact_5683_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
             => ? [Y4: real] :
                  ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),zero_zero(real)) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) ) ) ).

% DERIV_neg_imp_decreasing
tff(fact_5684_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
             => ? [Y4: real] :
                  ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y4) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,A2)),aa(real,real,F3,B2)) ) ) ).

% DERIV_pos_imp_increasing
tff(fact_5685_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
             => ? [Y4: real] :
                  ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Y4) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,A2)),aa(real,real,F3,B2)) ) ) ).

% DERIV_nonneg_imp_nondecreasing
tff(fact_5686_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
             => ? [Y4: real] :
                  ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),zero_zero(real)) ) ) )
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) ) ) ).

% DERIV_nonpos_imp_nonincreasing
tff(fact_5687_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: fun(real,real),G3: fun(real,real)] :
      ( ! [X: real] :
          ( member(real,X,set_or1337092689740270186AtMost(real,A2,B2))
         => has_field_derivative(real,G,aa(real,real,G3,X),topolo174197925503356063within(real,X,top_top(set(real)))) )
     => ( ! [X: real] :
            ( member(real,X,set_or1337092689740270186AtMost(real,A2,B2))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,G3,X)) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,G,A2)),aa(real,real,G,B2)) ) ) ) ).

% deriv_nonneg_imp_mono
tff(fact_5688_DERIV__chain,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,G: fun(A,A),Xa: A,Db: A,S: set(A)] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,aa(A,A,G,Xa),top_top(set(A))))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_chain
tff(fact_5689_DERIV__pos__inc__right,axiom,
    ! [F3: fun(real,real),L: real,Xa: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,Xa)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),H4))) ) ) ) ) ) ).

% DERIV_pos_inc_right
tff(fact_5690_DERIV__neg__dec__right,axiom,
    ! [F3: fun(real,real),L: real,Xa: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),H4))),aa(real,real,F3,Xa)) ) ) ) ) ) ).

% DERIV_neg_dec_right
tff(fact_5691_DERIV__neg__dec__left,axiom,
    ! [F3: fun(real,real),L: real,Xa: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,Xa)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),H4))) ) ) ) ) ) ).

% DERIV_neg_dec_left
tff(fact_5692_DERIV__pos__inc__left,axiom,
    ! [F3: fun(real,real),L: real,Xa: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),H4))),aa(real,real,F3,Xa)) ) ) ) ) ) ).

% DERIV_pos_inc_left
tff(fact_5693_DERIV__ln,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => has_field_derivative(real,ln_ln(real),aa(real,real,inverse_inverse(real),Xa),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ).

% DERIV_ln
tff(fact_5694_DERIV__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : has_field_derivative(A,cos(A),aa(A,A,uminus_uminus(A),aa(A,A,sin(A),Xa)),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ).

% DERIV_cos
tff(fact_5695_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,Xa: real,Y: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( member(real,Xa,set_or5935395276787703475ssThan(real,A2,B2))
       => ( member(real,Y,set_or5935395276787703475ssThan(real,A2,B2))
         => ( ! [X: real] :
                ( member(real,X,set_or5935395276787703475ssThan(real,A2,B2))
               => has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X,top_top(set(real)))) )
           => ( aa(real,real,F3,Xa) = aa(real,real,F3,Y) ) ) ) ) ) ).

% DERIV_isconst3
tff(fact_5696_DERIV__isconst__all,axiom,
    ! [F3: fun(real,real),Xa: real,Y: real] :
      ( ! [X: real] : has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X,top_top(set(real))))
     => ( aa(real,real,F3,Xa) = aa(real,real,F3,Y) ) ) ).

% DERIV_isconst_all
tff(fact_5697_DERIV__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : has_field_derivative(A,exp(A),aa(A,A,exp(A),Xa),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ).

% DERIV_exp
tff(fact_5698_DERIV__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : has_field_derivative(A,sin(A),aa(A,A,cos(A),Xa),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ).

% DERIV_sin
tff(fact_5699_DERIV__shift,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Y: A,Xa: A,Z: A] :
          ( has_field_derivative(A,F3,Y,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Z),top_top(set(A))))
        <=> has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_pp(fun(A,A),fun(A,fun(A,A)),F3),Z),Y,topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ).

% DERIV_shift
tff(fact_5700_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),M: A,Xa: A] :
          ( has_field_derivative(A,G,M,topolo174197925503356063within(A,Xa,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_pq(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cos(A),aa(A,A,G,Xa))),M),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ).

% DERIV_fun_sin
tff(fact_5701_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [S: set(A),G: fun(A,A),G3: fun(A,A),F3: fun(A,A),F9: A,Xa: A] :
          ( ! [X: A] :
              ( member(A,X,S)
             => has_field_derivative(A,G,aa(A,A,G3,X),topolo174197925503356063within(A,X,top_top(set(A)))) )
         => ( has_field_derivative(A,F3,F9,topolo174197925503356063within(A,Xa,top_top(set(A))))
           => ( member(A,aa(A,A,F3,Xa),S)
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_pr(fun(A,A),fun(fun(A,A),fun(A,A)),G),F3),aa(A,A,aa(A,fun(A,A),times_times(A),F9),aa(A,A,G3,aa(A,A,F3,Xa))),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ) ) ).

% DERIV_chain_s
tff(fact_5702_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [G: fun(A,A),G3: fun(A,A),F3: fun(A,A),F9: A,Xa: A] :
          ( ! [X: A] : has_field_derivative(A,G,aa(A,A,G3,X),topolo174197925503356063within(A,X,top_top(set(A))))
         => ( has_field_derivative(A,F3,F9,topolo174197925503356063within(A,Xa,top_top(set(A))))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_pr(fun(A,A),fun(fun(A,A),fun(A,A)),G),F3),aa(A,A,aa(A,fun(A,A),times_times(A),F9),aa(A,A,G3,aa(A,A,F3,Xa))),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ) ).

% DERIV_chain3
tff(fact_5703_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,G: fun(A,A),Xa: A,Db: A,S: set(A)] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,aa(A,A,G,Xa),top_top(set(A))))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_pr(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),Da),Db),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_chain2
tff(fact_5704_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,aa(A,A,F3,Xa),top_top(set(A))))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_ps(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),times_times(A),E4),D3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_chain'
tff(fact_5705_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),M: A,Xa: A] :
          ( has_field_derivative(A,G,M,topolo174197925503356063within(A,Xa,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_pt(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,exp(A),aa(A,A,G,Xa))),M),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ).

% DERIV_fun_exp
tff(fact_5706_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),K: real] :
      ( ( A2 != B2 )
     => ( ! [X: real] : has_field_derivative(real,F3,K,topolo174197925503356063within(real,X,top_top(set(real))))
       => ( divide_divide(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)) = K ) ) ) ).

% DERIV_const_ratio_const2
tff(fact_5707_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),K: real] :
      ( ( A2 != B2 )
     => ( ! [X: real] : has_field_derivative(real,F3,K,topolo174197925503356063within(real,X,top_top(set(real))))
       => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),K) ) ) ) ).

% DERIV_const_ratio_const
tff(fact_5708_DERIV__local__const,axiom,
    ! [F3: fun(real,real),L: real,Xa: real,D2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y3))),D2)
             => ( aa(real,real,F3,Xa) = aa(real,real,F3,Y3) ) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_const
tff(fact_5709_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F9: A,A2: A,S2: set(A),D2: real,G: fun(A,A)] :
          ( has_field_derivative(A,F3,F9,topolo174197925503356063within(A,A2,S2))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( member(A,A2,S2)
             => ( ! [X: A] :
                    ( member(A,X,S2)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,A2)),D2)
                     => ( aa(A,A,F3,X) = aa(A,A,G,X) ) ) )
               => has_field_derivative(A,G,F9,topolo174197925503356063within(A,A2,S2)) ) ) ) ) ) ).

% has_field_derivative_transform_within
tff(fact_5710_has__real__derivative__pos__inc__left,axiom,
    ! [F3: fun(real,real),L: real,Xa: real,S2: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,S2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( member(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),H4),S2)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),H4))),aa(real,real,F3,Xa)) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
tff(fact_5711_has__real__derivative__neg__dec__left,axiom,
    ! [F3: fun(real,real),L: real,Xa: real,S2: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,S2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( member(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),H4),S2)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,Xa)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),H4))) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
tff(fact_5712_has__real__derivative__pos__inc__right,axiom,
    ! [F3: fun(real,real),L: real,Xa: real,S2: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,S2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( member(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),H4),S2)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,Xa)),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),H4))) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
tff(fact_5713_has__real__derivative__neg__dec__right,axiom,
    ! [F3: fun(real,real),L: real,Xa: real,S2: set(real)] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,S2))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [D6: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D6)
            & ! [H4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H4)
               => ( member(real,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),H4),S2)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H4),D6)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,aa(real,real,aa(real,fun(real,real),plus_plus(real),Xa),H4))),aa(real,real,F3,Xa)) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
tff(fact_5714_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A)] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => ( ( aa(A,A,F3,Xa) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_pu(fun(A,A),fun(A,A),F3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(A,A,F3,Xa))),D3)),aa(A,A,inverse_inverse(A),aa(A,A,F3,Xa)))),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_inverse'
tff(fact_5715_DERIV__const,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [K: A,F6: filter(A)] : has_field_derivative(A,aTP_Lamp_pv(A,fun(A,A),K),zero_zero(A),F6) ) ).

% DERIV_const
tff(fact_5716_has__field__derivative__scaleR__right,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,F6: filter(A),C2: real] :
          ( has_field_derivative(A,F3,D3,F6)
         => has_field_derivative(A,aa(real,fun(A,A),aTP_Lamp_pw(fun(A,A),fun(real,fun(A,A)),F3),C2),aa(A,A,real_V8093663219630862766scaleR(A,C2),D3),F6) ) ) ).

% has_field_derivative_scaleR_right
tff(fact_5717_DERIV__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_px(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),D3),E4),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_add
tff(fact_5718_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F9: A,F6: filter(A),G: fun(A,A),G3: A] :
          ( has_field_derivative(A,F3,F9,F6)
         => ( has_field_derivative(A,G,G3,F6)
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_px(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),F9),G3),F6) ) ) ) ).

% field_differentiable_add
tff(fact_5719_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_py(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F3,Xa)),E4)),aa(A,A,aa(A,fun(A,A),times_times(A),D3),aa(A,A,G,Xa))),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_mult'
tff(fact_5720_DERIV__mult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Da: A,Xa: A,S: set(A),G: fun(A,A),Db: A] :
          ( has_field_derivative(A,F3,Da,topolo174197925503356063within(A,Xa,S))
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_py(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Da),aa(A,A,G,Xa))),aa(A,A,aa(A,fun(A,A),times_times(A),Db),aa(A,A,F3,Xa))),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_mult
tff(fact_5721_DERIV__ident,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F6: filter(A)] : has_field_derivative(A,aTP_Lamp_pz(A,A),one_one(A),F6) ) ).

% DERIV_ident
tff(fact_5722_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,Xa: A,S: set(A)] : has_field_derivative(A,aa(A,fun(A,A),times_times(A),C2),C2,topolo174197925503356063within(A,Xa,S)) ) ).

% DERIV_cmult_Id
tff(fact_5723_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_qa(fun(A,A),fun(A,fun(A,A)),F3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),D3),C2),topolo174197925503356063within(A,Xa,S)) ) ) ).

% DERIV_cmult_right
tff(fact_5724_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),C2: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => has_field_derivative(A,aa(A,fun(A,A),aTP_Lamp_qb(fun(A,A),fun(A,fun(A,A)),F3),C2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),D3),topolo174197925503356063within(A,Xa,S)) ) ) ).

% DERIV_cmult
tff(fact_5725_has__field__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,Xa: A,S: set(A)] :
          ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,Xa,S))
         => has_field_derivative(A,aTP_Lamp_qc(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cosh(A),aa(A,A,G,Xa))),Db),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_field_derivative_sinh
tff(fact_5726_has__field__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,Xa: A,S: set(A)] :
          ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,Xa,S))
         => has_field_derivative(A,aTP_Lamp_qd(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sinh(A),aa(A,A,G,Xa))),Db),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_field_derivative_cosh
tff(fact_5727_field__differentiable__diff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F9: A,F6: filter(A),G: fun(A,A),G3: A] :
          ( has_field_derivative(A,F3,F9,F6)
         => ( has_field_derivative(A,G,G3,F6)
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_qe(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),F9),G3),F6) ) ) ) ).

% field_differentiable_diff
tff(fact_5728_DERIV__diff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_qe(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),aa(A,A,aa(A,fun(A,A),minus_minus(A),D3),E4),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_diff
tff(fact_5729_DERIV__divide,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),G: fun(A,A),E4: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => ( has_field_derivative(A,G,E4,topolo174197925503356063within(A,Xa,S))
           => ( ( aa(A,A,G,Xa) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_qf(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D3),aa(A,A,G,Xa))),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,F3,Xa)),E4)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G,Xa)),aa(A,A,G,Xa))),topolo174197925503356063within(A,Xa,S)) ) ) ) ) ).

% DERIV_divide
tff(fact_5730_DERIV__subset,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),F9: A,Xa: A,S: set(A),T2: set(A)] :
          ( has_field_derivative(A,F3,F9,topolo174197925503356063within(A,Xa,S))
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),S)
           => has_field_derivative(A,F3,F9,topolo174197925503356063within(A,Xa,T2)) ) ) ) ).

% DERIV_subset
tff(fact_5731_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Y: A,Xa: A,S: set(A),T2: set(A)] :
          ( has_field_derivative(A,F3,Y,topolo174197925503356063within(A,Xa,S))
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),S)
           => has_field_derivative(A,F3,Y,topolo174197925503356063within(A,Xa,T2)) ) ) ) ).

% has_field_derivative_subset
tff(fact_5732_at__le,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),T2: set(A),Xa: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S),T2)
         => aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),topolo174197925503356063within(A,Xa,S)),topolo174197925503356063within(A,Xa,T2)) ) ) ).

% at_le
tff(fact_5733_DERIV__local__min,axiom,
    ! [F3: fun(real,real),L: real,Xa: real,D2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y3))),D2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,Xa)),aa(real,real,F3,Y3)) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_min
tff(fact_5734_DERIV__local__max,axiom,
    ! [F3: fun(real,real),L: real,Xa: real,D2: real] :
      ( has_field_derivative(real,F3,L,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
       => ( ! [Y3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),Y3))),D2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,Y3)),aa(real,real,F3,Xa)) )
         => ( L = zero_zero(real) ) ) ) ) ).

% DERIV_local_max
tff(fact_5735_DERIV__ln__divide,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => has_field_derivative(real,ln_ln(real),divide_divide(real,one_one(real),Xa),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ).

% DERIV_ln_divide
tff(fact_5736_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),M: A,Xa: A] :
          ( has_field_derivative(A,G,M,topolo174197925503356063within(A,Xa,top_top(set(A))))
         => has_field_derivative(A,aTP_Lamp_qg(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,uminus_uminus(A),aa(A,A,sin(A),aa(A,A,G,Xa)))),M),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ).

% DERIV_fun_cos
tff(fact_5737_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K: A,Xa: A] : has_field_derivative(A,aTP_Lamp_qh(A,fun(A,A),K),aa(A,A,uminus_uminus(A),aa(A,A,sin(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),K))),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ).

% DERIV_cos_add
tff(fact_5738_DERIV__fun__pow,axiom,
    ! [G: fun(real,real),M: real,Xa: real,N: nat] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_qi(fun(real,real),fun(nat,fun(real,real)),G),N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,G,Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))))),M),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ).

% DERIV_fun_pow
tff(fact_5739_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),N: nat] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_qj(fun(A,A),fun(nat,fun(A,A)),F3),N),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),one_one(A)),aa(nat,A,semiring_1_of_nat(A),N))),aa(A,A,aa(A,fun(A,A),times_times(A),D3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,F3,Xa)),N))),topolo174197925503356063within(A,Xa,S)) ) ) ).

% DERIV_power_Suc
tff(fact_5740_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Xa: A,S: set(A)] :
          ( ( Xa != zero_zero(A) )
         => has_field_derivative(A,inverse_inverse(A),aa(A,A,uminus_uminus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,inverse_inverse(A),Xa)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,Xa,S)) ) ) ).

% DERIV_inverse
tff(fact_5741_DERIV__power,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S: set(A),N: nat] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S))
         => has_field_derivative(A,aa(nat,fun(A,A),aTP_Lamp_qk(fun(A,A),fun(nat,fun(A,A)),F3),N),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),aa(A,A,aa(A,fun(A,A),times_times(A),D3),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,F3,Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(A,Xa,S)) ) ) ).

% DERIV_power
tff(fact_5742_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D2: A,Xa: A,S: set(A),N: int] :
          ( has_field_derivative(A,F3,D2,topolo174197925503356063within(A,Xa,S))
         => ( ( aa(A,A,F3,Xa) != zero_zero(A) )
           => has_field_derivative(A,aa(int,fun(A,A),aTP_Lamp_ql(fun(A,A),fun(int,fun(A,A)),F3),N),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),N)),power_int(A,aa(A,A,F3,Xa),aa(int,int,aa(int,fun(int,int),minus_minus(int),N),one_one(int))))),D2),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_power_int
tff(fact_5743_DERIV__pow,axiom,
    ! [N: nat,Xa: real,S: set(real)] : has_field_derivative(real,aTP_Lamp_qm(nat,fun(real,real),N),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(real,Xa,S)) ).

% DERIV_pow
tff(fact_5744_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),Xa: A] :
          ( ! [Y3: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),Y3))
         => has_field_derivative(A,aTP_Lamp_qn(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),Xa)),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ).

% termdiffs_strong_converges_everywhere
tff(fact_5745_has__real__derivative__powr,axiom,
    ! [Z: real,R: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Z)
     => has_field_derivative(real,aTP_Lamp_qo(real,fun(real,real),R),aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(real,real,aa(real,fun(real,real),powr(real),Z),aa(real,real,aa(real,fun(real,real),minus_minus(real),R),one_one(real)))),topolo174197925503356063within(real,Z,top_top(set(real)))) ) ).

% has_real_derivative_powr
tff(fact_5746_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D2: A,Xa: A,S: set(A),G: fun(A,A),E: A] :
          ( has_field_derivative(A,F3,D2,topolo174197925503356063within(A,Xa,S))
         => ( has_field_derivative(A,G,E,topolo174197925503356063within(A,Xa,S))
           => ( ( aa(A,A,G,Xa) != zero_zero(A) )
             => has_field_derivative(A,aa(fun(A,A),fun(A,A),aTP_Lamp_qf(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,G,Xa))),aa(A,A,aa(A,fun(A,A),times_times(A),E),aa(A,A,F3,Xa))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,G,Xa)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))),topolo174197925503356063within(A,Xa,S)) ) ) ) ) ).

% DERIV_quotient
tff(fact_5747_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D2: A,Xa: A,S: set(A)] :
          ( has_field_derivative(A,F3,D2,topolo174197925503356063within(A,Xa,S))
         => ( ( aa(A,A,F3,Xa) != zero_zero(A) )
           => has_field_derivative(A,aTP_Lamp_pu(fun(A,A),fun(A,A),F3),aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),D2),aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,F3,Xa)),aa(nat,nat,suc,aa(nat,nat,suc,zero_zero(nat))))))),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_inverse_fun
tff(fact_5748_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K6: real,C2: fun(nat,A),F3: fun(A,A),F9: A,Z: A] :
          ( ! [Z4: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z4)),K6)
             => sums(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),Z4),aa(A,A,F3,Z4)) )
         => ( has_field_derivative(A,F3,F9,topolo174197925503356063within(A,Z,top_top(set(A))))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K6)
             => sums(A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),Z),F9) ) ) ) ) ).

% termdiffs_sums_strong
tff(fact_5749_DERIV__log,axiom,
    ! [Xa: real,B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => has_field_derivative(real,log(B2),divide_divide(real,one_one(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,ln_ln(real),B2)),Xa)),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ).

% DERIV_log
tff(fact_5750_DERIV__fun__powr,axiom,
    ! [G: fun(real,real),M: real,Xa: real,R: real] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,G,Xa))
       => has_field_derivative(real,aa(real,fun(real,real),aTP_Lamp_qp(fun(real,real),fun(real,fun(real,real)),G),R),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,G,Xa)),aa(real,real,aa(real,fun(real,real),minus_minus(real),R),aa(nat,real,semiring_1_of_nat(real),one_one(nat)))))),M),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ).

% DERIV_fun_powr
tff(fact_5751_DERIV__powr,axiom,
    ! [G: fun(real,real),M: real,Xa: real,F3: fun(real,real),R: real] :
      ( has_field_derivative(real,G,M,topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,G,Xa))
       => ( has_field_derivative(real,F3,R,topolo174197925503356063within(real,Xa,top_top(set(real))))
         => has_field_derivative(real,aa(fun(real,real),fun(real,real),aTP_Lamp_qq(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,G,Xa)),aa(real,real,F3,Xa))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(real,real,ln_ln(real),aa(real,real,G,Xa)))),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),M),aa(real,real,F3,Xa)),aa(real,real,G,Xa)))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ).

% DERIV_powr
tff(fact_5752_DERIV__real__sqrt,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
     => has_field_derivative(real,sqrt,divide_divide(real,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,Xa)),aa(num,real,numeral_numeral(real),bit0(one2))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ).

% DERIV_real_sqrt
tff(fact_5753_DERIV__series_H,axiom,
    ! [F3: fun(real,fun(nat,real)),F9: fun(real,fun(nat,real)),X0: real,A2: real,B2: real,L5: fun(nat,real)] :
      ( ! [N2: nat] : has_field_derivative(real,aa(nat,fun(real,real),aTP_Lamp_qr(fun(real,fun(nat,real)),fun(nat,fun(real,real)),F3),N2),aa(nat,real,aa(real,fun(nat,real),F9,X0),N2),topolo174197925503356063within(real,X0,top_top(set(real))))
     => ( ! [X: real] :
            ( member(real,X,set_or5935395276787703475ssThan(real,A2,B2))
           => summable(real,aa(real,fun(nat,real),F3,X)) )
       => ( member(real,X0,set_or5935395276787703475ssThan(real,A2,B2))
         => ( summable(real,aa(real,fun(nat,real),F9,X0))
           => ( summable(real,L5)
             => ( ! [N2: nat,X: real,Y3: real] :
                    ( member(real,X,set_or5935395276787703475ssThan(real,A2,B2))
                   => ( member(real,Y3,set_or5935395276787703475ssThan(real,A2,B2))
                     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),F3,X),N2)),aa(nat,real,aa(real,fun(nat,real),F3,Y3),N2)))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,L5,N2)),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),X),Y3)))) ) )
               => has_field_derivative(real,aTP_Lamp_qs(fun(real,fun(nat,real)),fun(real,real),F3),suminf(real,aa(real,fun(nat,real),F9,X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_series'
tff(fact_5754_DERIV__arctan,axiom,
    ! [Xa: real] : has_field_derivative(real,arctan,aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ).

% DERIV_arctan
tff(fact_5755_termdiffs,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K6: A,Xa: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),K6))
         => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),K6))
           => ( summable(A,aa(A,fun(nat,A),aTP_Lamp_qt(fun(nat,A),fun(A,fun(nat,A)),C2),K6))
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,K6))
               => has_field_derivative(A,aTP_Lamp_qn(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),Xa)),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ) ) ) ).

% termdiffs
tff(fact_5756_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K6: A,Xa: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),K6))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,K6))
           => has_field_derivative(A,aTP_Lamp_qn(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),Xa)),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ) ).

% termdiffs_strong
tff(fact_5757_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [K6: real,C2: fun(nat,A),Z: A] :
          ( ! [Z4: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z4)),K6)
             => summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),Z4)) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Z)),K6)
           => has_field_derivative(A,aTP_Lamp_qn(fun(nat,A),fun(A,A),C2),suminf(A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),C2),Z)),topolo174197925503356063within(A,Z,top_top(set(A)))) ) ) ) ).

% termdiffs_strong'
tff(fact_5758_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => has_field_derivative(A,tan(A),aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,cos(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2)))),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ).

% DERIV_tan
tff(fact_5759_DERIV__real__sqrt__generic,axiom,
    ! [Xa: real,D3: real] :
      ( ( Xa != zero_zero(real) )
     => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
         => ( D3 = divide_divide(real,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,Xa)),aa(num,real,numeral_numeral(real),bit0(one2))) ) )
       => ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),zero_zero(real))
           => ( D3 = divide_divide(real,aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,Xa))),aa(num,real,numeral_numeral(real),bit0(one2))) ) )
         => has_field_derivative(real,sqrt,D3,topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ).

% DERIV_real_sqrt_generic
tff(fact_5760_arsinh__real__has__field__derivative,axiom,
    ! [Xa: real,A3: set(real)] : has_field_derivative(real,arsinh(real),divide_divide(real,one_one(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real)))),topolo174197925503356063within(real,Xa,A3)) ).

% arsinh_real_has_field_derivative
tff(fact_5761_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,sin(A),Xa) != zero_zero(A) )
         => has_field_derivative(A,cot(A),aa(A,A,uminus_uminus(A),aa(A,A,inverse_inverse(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,sin(A),Xa)),aa(num,nat,numeral_numeral(nat),bit0(one2))))),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ).

% DERIV_cot
tff(fact_5762_has__field__derivative__tanh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Xa: A,Db: A,S: set(A)] :
          ( ( aa(A,A,cosh(A),aa(A,A,G,Xa)) != zero_zero(A) )
         => ( has_field_derivative(A,G,Db,topolo174197925503356063within(A,Xa,S))
           => has_field_derivative(A,aTP_Lamp_qu(fun(A,A),fun(A,A),G),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),one_one(A)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,tanh(A),aa(A,A,G,Xa))),aa(num,nat,numeral_numeral(nat),bit0(one2))))),Db),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_field_derivative_tanh
tff(fact_5763_arcosh__real__has__field__derivative,axiom,
    ! [Xa: real,A3: set(real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => has_field_derivative(real,arcosh(real),divide_divide(real,one_one(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(real)))),topolo174197925503356063within(real,Xa,A3)) ) ).

% arcosh_real_has_field_derivative
tff(fact_5764_artanh__real__has__field__derivative,axiom,
    ! [Xa: real,A3: set(real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => has_field_derivative(real,artanh(real),divide_divide(real,one_one(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))),topolo174197925503356063within(real,Xa,A3)) ) ).

% artanh_real_has_field_derivative
tff(fact_5765_DERIV__power__series_H,axiom,
    ! [R2: real,F3: fun(nat,real),X0: real] :
      ( ! [X: real] :
          ( member(real,X,set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R2),R2))
         => summable(real,aa(real,fun(nat,real),aTP_Lamp_qv(fun(nat,real),fun(real,fun(nat,real)),F3),X)) )
     => ( member(real,X0,set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),R2),R2))
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
         => has_field_derivative(real,aTP_Lamp_qx(fun(nat,real),fun(real,real),F3),suminf(real,aa(real,fun(nat,real),aTP_Lamp_qv(fun(nat,real),fun(real,fun(nat,real)),F3),X0)),topolo174197925503356063within(real,X0,top_top(set(real)))) ) ) ) ).

% DERIV_power_series'
tff(fact_5766_DERIV__real__root,axiom,
    ! [N: nat,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Xa)
       => has_field_derivative(real,root(N),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ).

% DERIV_real_root
tff(fact_5767_DERIV__arccos,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => has_field_derivative(real,arccos,aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2))))))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ).

% DERIV_arccos
tff(fact_5768_DERIV__arcsin,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => has_field_derivative(real,arcsin,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ).

% DERIV_arcsin
tff(fact_5769_Maclaurin__all__le__objl,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),Xa: real,N: nat] :
      ( ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
        & ! [M2: nat,X: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),X),topolo174197925503356063within(real,X,top_top(set(real)))) )
     => ? [T4: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
          & ( aa(real,real,F3,Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_qy(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ).

% Maclaurin_all_le_objl
tff(fact_5770_Maclaurin__all__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),Xa: real,N: nat] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
     => ( ! [M2: nat,X: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),X),topolo174197925503356063within(real,X,top_top(set(real))))
       => ? [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
            & ( aa(real,real,F3,Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_qy(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ) ).

% Maclaurin_all_le
tff(fact_5771_DERIV__odd__real__root,axiom,
    ! [N: nat,Xa: real] :
      ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
     => ( ( Xa != zero_zero(real) )
       => has_field_derivative(real,root(N),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,semiring_1_of_nat(real),N)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,root(N),Xa)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,zero_zero(nat)))))),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ).

% DERIV_odd_real_root
tff(fact_5772_Maclaurin__minus,axiom,
    ! [H: real,N: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H),zero_zero(real))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
         => ( ! [M2: nat,T4: real] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),H),T4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),zero_zero(real)) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
           => ? [T4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),H),T4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),zero_zero(real))
                & ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_qz(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),H),N))) ) ) ) ) ) ) ).

% Maclaurin_minus
tff(fact_5773_Maclaurin2,axiom,
    ! [H: real,Diff: fun(nat,fun(real,real)),F3: fun(real,real),N: nat] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),H) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
         => ? [T4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T4)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),H)
              & ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_qz(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),H),N))) ) ) ) ) ) ).

% Maclaurin2
tff(fact_5774_Maclaurin,axiom,
    ! [H: real,N: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),H)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
         => ( ! [M2: nat,T4: real] :
                ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),H) )
               => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
           => ? [T4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),T4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),H)
                & ( aa(real,real,F3,H) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_qz(real,fun(fun(nat,fun(real,real)),fun(nat,real)),H),Diff)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),H),N))) ) ) ) ) ) ) ).

% Maclaurin
tff(fact_5775_Maclaurin__all__lt,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),N: nat,Xa: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => ( ( Xa != zero_zero(real) )
         => ( ! [M2: nat,X: real] : has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),X),topolo174197925503356063within(real,X,top_top(set(real))))
           => ? [T4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,abs_abs(real),T4))
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
                & ( aa(real,real,F3,Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_qy(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ) ) ) ).

% Maclaurin_all_lt
tff(fact_5776_Maclaurin__bi__le,axiom,
    ! [Diff: fun(nat,fun(real,real)),F3: fun(real,real),N: nat,Xa: real] :
      ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
     => ( ! [M2: nat,T4: real] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa)) )
           => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
       => ? [T4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),T4)),aa(real,real,abs_abs(real),Xa))
            & ( aa(real,real,F3,Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aTP_Lamp_qy(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Diff),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Xa),N))) ) ) ) ) ).

% Maclaurin_bi_le
tff(fact_5777_Taylor,axiom,
    ! [N: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real),A2: real,B2: real,C2: real,Xa: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),B2)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Xa)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),B2)
                 => ( ( Xa != C2 )
                   => ? [T4: real] :
                        ( $ite(
                            aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),C2),
                            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),T4)
                            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),C2) ),
                            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),T4)
                            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),Xa) ) )
                        & ( aa(real,real,F3,Xa) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_ra(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),C2),Xa)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Xa),C2)),N))) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
tff(fact_5778_Taylor__up,axiom,
    ! [N: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real),A2: real,B2: real,C2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),B2)
             => ? [T4: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),T4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),B2)
                  & ( aa(real,real,F3,B2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_rb(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),B2),C2)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),C2)),N))) ) ) ) ) ) ) ) ).

% Taylor_up
tff(fact_5779_Taylor__down,axiom,
    ! [N: nat,Diff: fun(nat,fun(real,real)),F3: fun(real,real),A2: real,B2: real,C2: real] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( ( aa(nat,fun(real,real),Diff,zero_zero(nat)) = F3 )
       => ( ! [M2: nat,T4: real] :
              ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),T4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),B2) )
             => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C2)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C2),B2)
             => ? [T4: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),T4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),T4),C2)
                  & ( aa(real,real,F3,A2) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_rb(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Diff),A2),C2)),set_ord_lessThan(nat,N))),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Diff,N),T4),semiring_char_0_fact(real,N))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),C2)),N))) ) ) ) ) ) ) ) ).

% Taylor_down
tff(fact_5780_Maclaurin__lemma2,axiom,
    ! [N: nat,H: real,Diff: fun(nat,fun(real,real)),K: nat,B3: real] :
      ( ! [M2: nat,T4: real] :
          ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T4)
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T4),H) )
         => has_field_derivative(real,aa(nat,fun(real,real),Diff,M2),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M2)),T4),topolo174197925503356063within(real,T4,top_top(set(real)))) )
     => ( ( N = aa(nat,nat,suc,K) )
       => ! [M3: nat,T8: real] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),T8)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),T8),H) )
           => has_field_derivative(real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_rd(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),N),Diff),B3),M3),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Diff,aa(nat,nat,suc,M3)),T8)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_re(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Diff),M3),T8)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,M3))))),aa(real,real,aa(real,fun(real,real),times_times(real),B3),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),T8),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,M3))),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(nat,nat,suc,M3))))))),topolo174197925503356063within(real,T8,top_top(set(real)))) ) ) ) ).

% Maclaurin_lemma2
tff(fact_5781_DERIV__arctan__series,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => has_field_derivative(real,aTP_Lamp_rf(real,real),suminf(real,aTP_Lamp_rg(real,fun(nat,real),Xa)),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ).

% DERIV_arctan_series
tff(fact_5782_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),Xa: A,G3: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,Xa))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,G,Xa)),one_one(real))
           => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
             => has_derivative(A,real,aTP_Lamp_rh(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_ri(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),Xa),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ) ).

% has_derivative_arcsin
tff(fact_5783_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),Xa: A,G3: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,G,Xa))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,G,Xa)),one_one(real))
           => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
             => has_derivative(A,real,aTP_Lamp_rj(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_rk(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),Xa),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ) ).

% has_derivative_arccos
tff(fact_5784_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),Xa: A,G3: fun(A,real),S: set(A)] :
          ( ( aa(real,real,cos(real),aa(A,real,G,Xa)) != zero_zero(real) )
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
           => has_derivative(A,real,aTP_Lamp_rl(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_rm(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),Xa),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_tan
tff(fact_5785_has__derivative__scaleR,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,real),F9: fun(A,real),Xa: A,S: set(A),G: fun(A,B),G3: fun(A,B)] :
          ( has_derivative(A,real,F3,F9,topolo174197925503356063within(A,Xa,S))
         => ( has_derivative(A,B,G,G3,topolo174197925503356063within(A,Xa,S))
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rn(fun(A,real),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_ro(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F9),Xa),G),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_scaleR
tff(fact_5786_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,F6: filter(A)] :
          ( has_field_derivative(A,F3,D3,F6)
        <=> has_derivative(A,A,F3,aa(A,fun(A,A),times_times(A),D3),F6) ) ) ).

% has_field_derivative_def
tff(fact_5787_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: fun(A,A),F6: filter(A),D7: A] :
          ( has_derivative(A,A,F3,D3,F6)
         => ( ! [X: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),X),D7) = aa(A,A,D3,X) )
           => has_field_derivative(A,F3,D7,F6) ) ) ) ).

% has_derivative_imp_has_field_derivative
tff(fact_5788_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,F6: filter(A)] :
          ( has_field_derivative(A,F3,D3,F6)
         => has_derivative(A,A,F3,aa(A,fun(A,A),times_times(A),D3),F6) ) ) ).

% has_field_derivative_imp_has_derivative
tff(fact_5789_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S: set(A),T2: set(A)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S))
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),S)
           => has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,T2)) ) ) ) ).

% has_derivative_subset
tff(fact_5790_has__derivative__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),F6: filter(A),G: fun(A,B),G3: fun(A,B)] :
          ( has_derivative(A,B,F3,F9,F6)
         => ( has_derivative(A,B,G,G3,F6)
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rp(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aTP_Lamp_rp(fun(A,B),fun(fun(A,B),fun(A,B)),F9),G3),F6) ) ) ) ).

% has_derivative_diff
tff(fact_5791_has__derivative__mult__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [G: fun(A,B),G3: fun(A,B),F6: filter(A),Y: B] :
          ( has_derivative(A,B,G,G3,F6)
         => has_derivative(A,B,aa(B,fun(A,B),aTP_Lamp_rq(fun(A,B),fun(B,fun(A,B)),G),Y),aa(B,fun(A,B),aTP_Lamp_rq(fun(A,B),fun(B,fun(A,B)),G3),Y),F6) ) ) ).

% has_derivative_mult_left
tff(fact_5792_has__derivative__mult__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [G: fun(A,B),G3: fun(A,B),F6: filter(A),Xa: B] :
          ( has_derivative(A,B,G,G3,F6)
         => has_derivative(A,B,aa(B,fun(A,B),aTP_Lamp_rr(fun(A,B),fun(B,fun(A,B)),G),Xa),aa(B,fun(A,B),aTP_Lamp_rr(fun(A,B),fun(B,fun(A,B)),G3),Xa),F6) ) ) ).

% has_derivative_mult_right
tff(fact_5793_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),F6: filter(A),G: fun(A,B),G3: fun(A,B)] :
          ( has_derivative(A,B,F3,F9,F6)
         => ( has_derivative(A,B,G,G3,F6)
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rs(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aTP_Lamp_rs(fun(A,B),fun(fun(A,B),fun(A,B)),F9),G3),F6) ) ) ) ).

% has_derivative_add
tff(fact_5794_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [C2: B,F6: filter(A)] : has_derivative(A,B,aTP_Lamp_rt(B,fun(A,B),C2),aTP_Lamp_ru(A,B),F6) ) ).

% has_derivative_const
tff(fact_5795_has__derivative__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S: set(A),G: fun(A,B),G3: fun(A,B)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S))
         => ( has_derivative(A,B,G,G3,topolo174197925503356063within(A,Xa,S))
           => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rv(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_rw(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F9),Xa),G),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_mult
tff(fact_5796_has__derivative__zero__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [F6: fun(A,B),Xa: A] :
          ( has_derivative(A,B,aTP_Lamp_ru(A,B),F6,topolo174197925503356063within(A,Xa,top_top(set(A))))
         => ! [X3: A] : ( aa(A,B,F6,X3) = zero_zero(B) ) ) ) ).

% has_derivative_zero_unique
tff(fact_5797_has__derivative__in__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [T2: set(A),G: fun(A,B),G3: fun(A,fun(A,B)),F3: fun(C,A),S: set(C),Xa: C,F9: fun(C,A)] :
          ( ! [X: A] :
              ( member(A,X,T2)
             => has_derivative(A,B,G,aa(A,fun(A,B),G3,X),topolo174197925503356063within(A,X,T2)) )
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F3),S)),T2)
           => ( member(C,Xa,S)
             => ( has_derivative(C,A,F3,F9,topolo174197925503356063within(C,Xa,S))
               => has_derivative(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_rx(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3),aa(fun(C,A),fun(C,B),aa(C,fun(fun(C,A),fun(C,B)),aa(fun(C,A),fun(C,fun(fun(C,A),fun(C,B))),aTP_Lamp_ry(fun(A,fun(A,B)),fun(fun(C,A),fun(C,fun(fun(C,A),fun(C,B)))),G3),F3),Xa),F9),topolo174197925503356063within(C,Xa,S)) ) ) ) ) ) ).

% has_derivative_in_compose2
tff(fact_5798_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),Xa: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
         => has_derivative(A,real,aTP_Lamp_rz(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_sa(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),Xa),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_derivative_exp
tff(fact_5799_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S: set(A),D2: real,G: fun(A,B)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( member(A,Xa,S)
             => ( ! [X8: A] :
                    ( member(A,X8,S)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X8,Xa)),D2)
                     => ( aa(A,B,F3,X8) = aa(A,B,G,X8) ) ) )
               => has_derivative(A,B,G,F9,topolo174197925503356063within(A,Xa,S)) ) ) ) ) ) ).

% has_derivative_transform_within
tff(fact_5800_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),Xa: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
         => has_derivative(A,real,aTP_Lamp_sb(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_sc(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),Xa),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_derivative_sin
tff(fact_5801_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,Xa: A,S: set(A)] :
          ( has_derivative(A,A,G,aa(A,fun(A,A),times_times(A),Db),topolo174197925503356063within(A,Xa,S))
         => has_derivative(A,A,aTP_Lamp_qd(fun(A,A),fun(A,A),G),aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,sinh(A),aa(A,A,G,Xa))),Db)),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_derivative_cosh
tff(fact_5802_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [G: fun(A,A),Db: A,Xa: A,S: set(A)] :
          ( has_derivative(A,A,G,aa(A,fun(A,A),times_times(A),Db),topolo174197925503356063within(A,Xa,S))
         => has_derivative(A,A,aTP_Lamp_qc(fun(A,A),fun(A,A),G),aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,cosh(A),aa(A,A,G,Xa))),Db)),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_derivative_sinh
tff(fact_5803_has__derivative__divide_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S2: set(A),G: fun(A,B),G3: fun(A,B)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S2))
         => ( has_derivative(A,B,G,G3,topolo174197925503356063within(A,Xa,S2))
           => ( ( aa(A,B,G,Xa) != zero_zero(B) )
             => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sd(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_se(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F9),Xa),G),G3),topolo174197925503356063within(A,Xa,S2)) ) ) ) ) ).

% has_derivative_divide'
tff(fact_5804_has__derivative__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [F3: fun(B,A),Xa: B,F9: fun(B,A),S2: set(B)] :
          ( ( aa(B,A,F3,Xa) != zero_zero(A) )
         => ( has_derivative(B,A,F3,F9,topolo174197925503356063within(B,Xa,S2))
           => has_derivative(B,A,aTP_Lamp_sf(fun(B,A),fun(B,A),F3),aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_sg(fun(B,A),fun(B,fun(fun(B,A),fun(B,A))),F3),Xa),F9),topolo174197925503356063within(B,Xa,S2)) ) ) ) ).

% has_derivative_inverse
tff(fact_5805_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Xa: A,S2: set(A)] :
          ( ( Xa != zero_zero(A) )
         => has_derivative(A,A,inverse_inverse(A),aTP_Lamp_sh(A,fun(A,A),Xa),topolo174197925503356063within(A,Xa,S2)) ) ) ).

% has_derivative_inverse'
tff(fact_5806_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(real,real),F9: real,G: fun(A,real),Xa: A,G3: fun(A,real),S: set(A)] :
          ( has_field_derivative(real,F3,F9,topolo174197925503356063within(real,aa(A,real,G,Xa),top_top(set(real))))
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
           => has_derivative(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_si(fun(real,real),fun(fun(A,real),fun(A,real)),F3),G),aa(fun(A,real),fun(A,real),aTP_Lamp_sj(real,fun(fun(A,real),fun(A,real)),F9),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% DERIV_compose_FDERIV
tff(fact_5807_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),Xa: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
         => has_derivative(A,real,aTP_Lamp_sk(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_sl(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),Xa),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_derivative_cos
tff(fact_5808_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S2: set(A),N: nat] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S2))
         => has_derivative(A,B,aa(nat,fun(A,B),aTP_Lamp_sm(fun(A,B),fun(nat,fun(A,B)),F3),N),aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_sn(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),F3),F9),Xa),N),topolo174197925503356063within(A,Xa,S2)) ) ) ).

% has_derivative_power
tff(fact_5809_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),Xa: A,G3: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,Xa))
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
           => has_derivative(A,real,aTP_Lamp_so(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_sp(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),Xa),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_ln
tff(fact_5810_has__derivative__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S2: set(A),G: fun(A,B),G3: fun(A,B)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S2))
         => ( has_derivative(A,B,G,G3,topolo174197925503356063within(A,Xa,S2))
           => ( ( aa(A,B,G,Xa) != zero_zero(B) )
             => has_derivative(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sq(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_sr(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),F3),F9),Xa),G),G3),topolo174197925503356063within(A,Xa,S2)) ) ) ) ) ).

% has_derivative_divide
tff(fact_5811_has__derivative__prod,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(C) )
     => ! [I5: set(A),F3: fun(A,fun(B,C)),F9: fun(A,fun(B,C)),Xa: B,S2: set(B)] :
          ( ! [I2: A] :
              ( member(A,I2,I5)
             => has_derivative(B,C,aa(A,fun(B,C),F3,I2),aa(A,fun(B,C),F9,I2),topolo174197925503356063within(B,Xa,S2)) )
         => has_derivative(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_st(set(A),fun(fun(A,fun(B,C)),fun(B,C)),I5),F3),aa(B,fun(B,C),aa(fun(A,fun(B,C)),fun(B,fun(B,C)),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C))),aTP_Lamp_sv(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C)))),I5),F3),F9),Xa),topolo174197925503356063within(B,Xa,S2)) ) ) ).

% has_derivative_prod
tff(fact_5812_has__derivative__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(A) )
     => ! [F3: fun(B,A),Xa: B,F9: fun(B,A),S2: set(B),N: int] :
          ( ( aa(B,A,F3,Xa) != zero_zero(A) )
         => ( has_derivative(B,A,F3,F9,topolo174197925503356063within(B,Xa,S2))
           => has_derivative(B,A,aa(int,fun(B,A),aTP_Lamp_sw(fun(B,A),fun(int,fun(B,A)),F3),N),aa(int,fun(B,A),aa(fun(B,A),fun(int,fun(B,A)),aa(B,fun(fun(B,A),fun(int,fun(B,A))),aTP_Lamp_sx(fun(B,A),fun(B,fun(fun(B,A),fun(int,fun(B,A)))),F3),Xa),F9),N),topolo174197925503356063within(B,Xa,S2)) ) ) ) ).

% has_derivative_power_int
tff(fact_5813_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Xa: A,N: int,S2: set(A)] :
          ( ( Xa != zero_zero(A) )
         => has_derivative(A,A,aTP_Lamp_sy(int,fun(A,A),N),aa(int,fun(A,A),aTP_Lamp_sz(A,fun(int,fun(A,A)),Xa),N),topolo174197925503356063within(A,Xa,S2)) ) ) ).

% has_derivative_power_int'
tff(fact_5814_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),Xa: A,X6: set(A),F3: fun(A,real),F9: fun(A,real)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,X6))
         => ( has_derivative(A,real,F3,F9,topolo174197925503356063within(A,Xa,X6))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,Xa))
             => ( member(A,Xa,X6)
               => has_derivative(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ta(fun(A,real),fun(fun(A,real),fun(A,real)),G),F3),aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_tb(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),G),G3),Xa),F3),F9),topolo174197925503356063within(A,Xa,X6)) ) ) ) ) ) ).

% has_derivative_powr
tff(fact_5815_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),Xa: A,G3: fun(A,real),S: set(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,Xa))
         => ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
           => has_derivative(A,real,aTP_Lamp_tc(fun(A,real),fun(A,real),G),aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_td(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),G),Xa),G3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_real_sqrt
tff(fact_5816_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [G: fun(A,real),G3: fun(A,real),Xa: A,S: set(A)] :
          ( has_derivative(A,real,G,G3,topolo174197925503356063within(A,Xa,S))
         => has_derivative(A,real,aTP_Lamp_te(fun(A,real),fun(A,real),G),aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_tf(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),G),G3),Xa),topolo174197925503356063within(A,Xa,S)) ) ) ).

% has_derivative_arctan
tff(fact_5817_has__derivative__floor,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [G: fun(B,real),Xa: B,F3: fun(real,A),G3: fun(B,real),S: set(B)] :
          ( topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,aa(B,real,G,Xa),top_top(set(real))),F3)
         => ( ~ member(A,aa(real,A,F3,aa(B,real,G,Xa)),ring_1_Ints(A))
           => ( has_derivative(B,real,G,G3,topolo174197925503356063within(B,Xa,S))
             => has_derivative(B,real,aa(fun(real,A),fun(B,real),aTP_Lamp_tg(fun(B,real),fun(fun(real,A),fun(B,real)),G),F3),aTP_Lamp_th(fun(B,real),fun(B,real),G3),topolo174197925503356063within(B,Xa,S)) ) ) ) ) ).

% has_derivative_floor
tff(fact_5818_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K6: A,Xa: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_qt(fun(nat,A),fun(A,fun(nat,A)),C2),K6))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,K6))
           => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_tj(fun(nat,A),fun(A,fun(A,A)),C2),Xa),topolo7230453075368039082e_nhds(A,zero_zero(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% termdiffs_aux
tff(fact_5819_surj__int__encode,axiom,
    aa(set(int),set(nat),image(int,nat,nat_int_encode),top_top(set(int))) = top_top(set(nat)) ).

% surj_int_encode
tff(fact_5820_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F3: fun(B,A),L: A,F6: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_tk(A,fun(fun(B,A),fun(B,A)),C2),F3),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),L)),F6)
          <=> filterlim(B,A,F3,topolo7230453075368039082e_nhds(A,L),F6) ) ) ) ).

% tendsto_mult_left_iff
tff(fact_5821_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F3: fun(B,A),L: A,F6: filter(B)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_tl(A,fun(fun(B,A),fun(B,A)),C2),F3),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),L),C2)),F6)
          <=> filterlim(B,A,F3,topolo7230453075368039082e_nhds(A,L),F6) ) ) ) ).

% tendsto_mult_right_iff
tff(fact_5822_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F3: fun(A,real),F6: filter(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tm(nat,fun(fun(A,real),fun(A,real)),N),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
      <=> filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ).

% power_tendsto_0_iff
tff(fact_5823_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(A,real),A2: A,G: fun(A,real)] :
          ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( ! [X: A] :
                ( ( X != A2 )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,G,X)) )
           => ( ! [X: A] :
                  ( ( X != A2 )
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,G,X)),aa(A,real,F3,X)) )
             => filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% real_LIM_sandwich_zero
tff(fact_5824_metric__LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V7819770556892013058_space(C)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),L: B,A2: A,G: fun(A,C),M: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( ! [X: A] :
                ( ( X != A2 )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(C,aa(A,C,G,X),M)),real_V557655796197034286t_dist(B,aa(A,B,F3,X),L)) )
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,M),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ).

% metric_LIM_imp_LIM
tff(fact_5825_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F3: fun(A,B),G: fun(B,C),L: C] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(B,aa(A,B,F3,A2),top_top(set(B))))
           => ( ? [D5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
                  & ! [X: A] :
                      ( ( ( X != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2))),D5) )
                     => ( aa(A,B,F3,X) != aa(A,B,F3,A2) ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tn(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% isCont_LIM_compose2
tff(fact_5826_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),A2: A,L5: B] :
          ( filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_to(fun(A,B),fun(A,fun(A,B)),F3),A2),topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIM_offset_zero_cancel
tff(fact_5827_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),L5: B,A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_to(fun(A,B),fun(A,fun(A,B)),F3),A2),topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_offset_zero
tff(fact_5828_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,F3,A2)),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_to(fun(A,B),fun(A,fun(A,B)),F3),A2),topolo7230453075368039082e_nhds(B,aa(A,B,F3,A2)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% LIM_isCont_iff
tff(fact_5829_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Xa: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,Xa,top_top(set(A))),F3)
        <=> filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_tp(A,fun(fun(A,B),fun(A,B)),Xa),F3),topolo7230453075368039082e_nhds(B,aa(A,B,F3,Xa)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% isCont_iff
tff(fact_5830_metric__isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [A2: A,F3: fun(A,B),G: fun(B,C),L: C] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(B,aa(A,B,F3,A2),top_top(set(B))))
           => ( ? [D5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
                  & ! [X: A] :
                      ( ( ( X != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,A2)),D5) )
                     => ( aa(A,B,F3,X) != aa(A,B,F3,A2) ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tq(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_isCont_LIM_compose2
tff(fact_5831_LIM__not__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo8386298272705272623_space(B)
        & zero(A)
        & topological_t2_space(A) )
     => ! [K: A,A2: B] :
          ( ( K != zero_zero(A) )
         => ~ filterlim(B,A,aTP_Lamp_tr(A,fun(B,A),K),topolo7230453075368039082e_nhds(A,zero_zero(A)),topolo174197925503356063within(B,A2,top_top(set(B)))) ) ) ).

% LIM_not_zero
tff(fact_5832_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),L5: B,A2: A,K: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_ts(fun(A,B),fun(A,fun(A,B)),F3),K),topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),K),top_top(set(A)))) ) ) ).

% LIM_offset
tff(fact_5833_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),L: B,Xa: A,S2: set(A),D2: real,G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,Xa,S2))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
           => ( ! [X8: A] :
                  ( member(A,X8,S2)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X8,Xa))
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X8,Xa)),D2)
                     => ( aa(A,B,F3,X8) = aa(A,B,G,X8) ) ) ) )
             => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,Xa,S2)) ) ) ) ) ).

% Lim_transform_within
tff(fact_5834_continuous__within__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A,S: set(A)] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Z,S),sin(A)) ) ).

% continuous_within_sin
tff(fact_5835_continuous__within__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Z: A,S: set(A)] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Z,S),cos(A)) ) ).

% continuous_within_cos
tff(fact_5836_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S2: set(A)] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S2))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_tt(fun(A,A),fun(A,fun(A,A)),F3),Xa),topolo7230453075368039082e_nhds(A,D3),topolo174197925503356063within(A,Xa,S2)) ) ) ).

% has_field_derivative_iff
tff(fact_5837_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A,S2: set(A)] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,S2))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_tt(fun(A,A),fun(A,fun(A,A)),F3),Xa),topolo7230453075368039082e_nhds(A,D3),topolo174197925503356063within(A,Xa,S2)) ) ) ).

% has_field_derivativeD
tff(fact_5838_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(A,B),L: filter(B),Xa: A,S2: set(A),T5: set(A)] :
          ( filterlim(A,B,F3,L,topolo174197925503356063within(A,Xa,S2))
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T5),S2)
           => filterlim(A,B,F3,L,topolo174197925503356063within(A,Xa,T5)) ) ) ) ).

% tendsto_within_subset
tff(fact_5839_tendsto__arcosh,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),A2)
       => filterlim(A,real,aTP_Lamp_tu(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A2)),F6) ) ) ).

% tendsto_arcosh
tff(fact_5840_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [F3: fun(A,B),F6: filter(A),N: nat] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_tv(fun(A,B),fun(nat,fun(A,B)),F3),N),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ) ).

% tendsto_null_power
tff(fact_5841_tendsto__log,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F6)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
         => ( ( A2 != one_one(real) )
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
             => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tw(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,aa(real,real,log(A2),B2)),F6) ) ) ) ) ) ).

% tendsto_log
tff(fact_5842_tendsto__null__sum,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [I5: set(A),F3: fun(B,fun(A,C)),F6: filter(B)] :
          ( ! [I2: A] :
              ( member(A,I2,I5)
             => filterlim(B,C,aa(A,fun(B,C),aTP_Lamp_tx(fun(B,fun(A,C)),fun(A,fun(B,C)),F3),I2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F6) )
         => filterlim(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_ty(set(A),fun(fun(B,fun(A,C)),fun(B,C)),I5),F3),topolo7230453075368039082e_nhds(C,zero_zero(C)),F6) ) ) ).

% tendsto_null_sum
tff(fact_5843_tendsto__one__prod_H,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [I5: set(A),F3: fun(B,fun(A,C)),F6: filter(B)] :
          ( ! [I2: A] :
              ( member(A,I2,I5)
             => filterlim(B,C,aa(A,fun(B,C),aTP_Lamp_tz(fun(B,fun(A,C)),fun(A,fun(B,C)),F3),I2),topolo7230453075368039082e_nhds(C,one_one(C)),F6) )
         => filterlim(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_ua(set(A),fun(fun(B,fun(A,C)),fun(B,C)),I5),F3),topolo7230453075368039082e_nhds(C,one_one(C)),F6) ) ) ).

% tendsto_one_prod'
tff(fact_5844_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ub(fun(A,B),fun(B,fun(A,B)),F3),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ).

% LIM_zero
tff(fact_5845_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ub(fun(A,B),fun(B,fun(A,B)),F3),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
        <=> filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6) ) ) ).

% LIM_zero_iff
tff(fact_5846_Lim__transform,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [G: fun(A,B),A2: B,F6: filter(A),F3: fun(A,B)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_uc(fun(A,B),fun(fun(A,B),fun(A,B)),G),F3),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6) ) ) ) ).

% Lim_transform
tff(fact_5847_Lim__transform2,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ud(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
           => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F6) ) ) ) ).

% Lim_transform2
tff(fact_5848_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ub(fun(A,B),fun(B,fun(A,B)),F3),L),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6) ) ) ).

% LIM_zero_cancel
tff(fact_5849_Lim__transform__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),G: fun(A,B),F6: filter(A),A2: B] :
          ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ud(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
          <=> filterlim(A,B,G,topolo7230453075368039082e_nhds(B,A2),F6) ) ) ) ).

% Lim_transform_eq
tff(fact_5850_tendsto__add__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ue(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ) ).

% tendsto_add_zero
tff(fact_5851_tendsto__mult__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_uf(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ) ).

% tendsto_mult_zero
tff(fact_5852_tendsto__mult__left__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F3: fun(A,B),F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_ug(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ).

% tendsto_mult_left_zero
tff(fact_5853_tendsto__mult__right__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [F3: fun(A,B),F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_uh(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ).

% tendsto_mult_right_zero
tff(fact_5854_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: fun(A,A),A2: A,F6: filter(A)] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,A2),F6)
         => ( ( aa(A,A,sin(A),A2) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_ui(fun(A,A),fun(A,A),F3),topolo7230453075368039082e_nhds(A,aa(A,A,cot(A),A2)),F6) ) ) ) ).

% tendsto_cot
tff(fact_5855_tendsto__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( ( aa(B,B,cosh(B),A2) != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_uj(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,tanh(B),A2)),F6) ) ) ) ).

% tendsto_tanh
tff(fact_5856_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6)
        <=> filterlim(A,real,aa(B,fun(A,real),aTP_Lamp_uk(fun(A,B),fun(B,fun(A,real)),F3),L),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ).

% tendsto_dist_iff
tff(fact_5857_tendsto__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( ( A2 != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_ul(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,inverse_inverse(B),A2)),F6) ) ) ) ).

% tendsto_inverse
tff(fact_5858_tendsto__divide__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F3: fun(A,B),F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_um(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ).

% tendsto_divide_zero
tff(fact_5859_tendsto__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F6)
           => ( ( B2 != zero_zero(B) )
             => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_un(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,divide_divide(B,A2,B2)),F6) ) ) ) ) ).

% tendsto_divide
tff(fact_5860_tendsto__ln,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( ( A2 != zero_zero(real) )
       => filterlim(A,real,aTP_Lamp_lo(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,ln_ln(real),A2)),F6) ) ) ).

% tendsto_ln
tff(fact_5861_tendsto__powr,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F6)
       => ( ( A2 != zero_zero(real) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_uo(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,aa(real,real,aa(real,fun(real,real),powr(real),A2),B2)),F6) ) ) ) ).

% tendsto_powr
tff(fact_5862_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_up(fun(A,B),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ).

% tendsto_norm_zero_cancel
tff(fact_5863_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( filterlim(A,real,aTP_Lamp_up(fun(A,B),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
        <=> filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ).

% tendsto_norm_zero_iff
tff(fact_5864_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => filterlim(A,real,aTP_Lamp_up(fun(A,B),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ).

% tendsto_norm_zero
tff(fact_5865_tendsto__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6)
         => ( ( L != zero_zero(B) )
           => filterlim(A,B,aTP_Lamp_uq(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,sgn_sgn(B),L)),F6) ) ) ) ).

% tendsto_sgn
tff(fact_5866_tendsto__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A),N: int] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( ( A2 != zero_zero(B) )
           => filterlim(A,B,aa(int,fun(A,B),aTP_Lamp_ur(fun(A,B),fun(int,fun(A,B)),F3),N),topolo7230453075368039082e_nhds(B,power_int(B,A2,N)),F6) ) ) ) ).

% tendsto_power_int
tff(fact_5867_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F3: fun(A,A),A2: A,F6: filter(A)] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,A2),F6)
         => ( ( aa(A,A,cos(A),A2) != zero_zero(A) )
           => filterlim(A,A,aTP_Lamp_us(fun(A,A),fun(A,A),F3),topolo7230453075368039082e_nhds(A,aa(A,A,tan(A),A2)),F6) ) ) ) ).

% tendsto_tan
tff(fact_5868_int__encode__eq,axiom,
    ! [Xa: int,Y: int] :
      ( ( aa(int,nat,nat_int_encode,Xa) = aa(int,nat,nat_int_encode,Y) )
    <=> ( Xa = Y ) ) ).

% int_encode_eq
tff(fact_5869_continuous__sinh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_ut(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_sinh
tff(fact_5870_tendsto__sinh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => filterlim(A,B,aTP_Lamp_uu(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,sinh(B),A2)),F6) ) ) ).

% tendsto_sinh
tff(fact_5871_tendsto__exp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => filterlim(A,B,aTP_Lamp_uv(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,exp(B),A2)),F6) ) ) ).

% tendsto_exp
tff(fact_5872_continuous__exp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_uw(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_exp
tff(fact_5873_continuous__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_ux(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_sin
tff(fact_5874_continuous__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_uy(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_cos
tff(fact_5875_tendsto__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => filterlim(A,B,aTP_Lamp_ux(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,sin(B),A2)),F6) ) ) ).

% tendsto_sin
tff(fact_5876_tendsto__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => filterlim(A,B,aTP_Lamp_uy(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,cos(B),A2)),F6) ) ) ).

% tendsto_cos
tff(fact_5877_tendsto__arsinh,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => filterlim(A,real,aTP_Lamp_uz(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arsinh(real),A2)),F6) ) ).

% tendsto_arsinh
tff(fact_5878_tendsto__arctan,axiom,
    ! [A: $tType,F3: fun(A,real),Xa: real,F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,Xa),F6)
     => filterlim(A,real,aTP_Lamp_va(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arctan,Xa)),F6) ) ).

% tendsto_arctan
tff(fact_5879_continuous__cosh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_vb(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_cosh
tff(fact_5880_tendsto__cosh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => filterlim(A,B,aTP_Lamp_vc(fun(A,B),fun(A,B),F3),topolo7230453075368039082e_nhds(B,aa(B,B,cosh(B),A2)),F6) ) ) ).

% tendsto_cosh
tff(fact_5881_tendsto__add,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ue(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),A2),B2)),F6) ) ) ) ).

% tendsto_add
tff(fact_5882_continuous__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [F6: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( topolo3448309680560233919inuous(A,B,F6,G)
           => topolo3448309680560233919inuous(A,B,F6,aa(fun(A,B),fun(A,B),aTP_Lamp_vd(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_add
tff(fact_5883_tendsto__add__const__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [C2: B,F3: fun(A,B),D2: B,F6: filter(A)] :
          ( filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ve(B,fun(fun(A,B),fun(A,B)),C2),F3),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),plus_plus(B),C2),D2)),F6)
        <=> filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,D2),F6) ) ) ).

% tendsto_add_const_iff
tff(fact_5884_tendsto__mult__one,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,one_one(B)),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,one_one(B)),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vf(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,one_one(B)),F6) ) ) ) ).

% tendsto_mult_one
tff(fact_5885_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [F6: filter(A),F3: fun(A,B),C2: B] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => topolo3448309680560233919inuous(A,B,F6,aa(B,fun(A,B),aTP_Lamp_vg(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_mult_right
tff(fact_5886_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [F6: filter(A),F3: fun(A,B),C2: B] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => topolo3448309680560233919inuous(A,B,F6,aa(B,fun(A,B),aTP_Lamp_vh(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_mult_left
tff(fact_5887_tendsto__mult__right,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_vi(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),times_times(B),L),C2)),F6) ) ) ).

% tendsto_mult_right
tff(fact_5888_tendsto__mult__left,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6)
         => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_vj(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),times_times(B),C2),L)),F6) ) ) ).

% tendsto_mult_left
tff(fact_5889_continuous__mult_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [F6: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( topolo3448309680560233919inuous(A,B,F6,G)
           => topolo3448309680560233919inuous(A,B,F6,aa(fun(A,B),fun(A,B),aTP_Lamp_vk(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_mult'
tff(fact_5890_continuous__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F6: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( topolo3448309680560233919inuous(A,B,F6,G)
           => topolo3448309680560233919inuous(A,B,F6,aa(fun(A,B),fun(A,B),aTP_Lamp_vl(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_mult
tff(fact_5891_tendsto__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vm(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),times_times(B),A2),B2)),F6) ) ) ) ).

% tendsto_mult
tff(fact_5892_tendsto__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A),G: fun(A,B),B2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,B2),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vn(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),A2),B2)),F6) ) ) ) ).

% tendsto_diff
tff(fact_5893_continuous__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [F6: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( topolo3448309680560233919inuous(A,B,F6,G)
           => topolo3448309680560233919inuous(A,B,F6,aa(fun(A,B),fun(A,B),aTP_Lamp_vo(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_diff
tff(fact_5894_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_vp(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
     => filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ).

% tendsto_rabs_zero_cancel
tff(fact_5895_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,aTP_Lamp_vp(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
    <=> filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ).

% tendsto_rabs_zero_iff
tff(fact_5896_tendsto__rabs__zero,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
     => filterlim(A,real,aTP_Lamp_vp(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ).

% tendsto_rabs_zero
tff(fact_5897_tendsto__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F6: filter(A),F10: filter(A),F3: fun(A,B),L: B] :
          ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10)
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F10)
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6) ) ) ) ).

% tendsto_mono
tff(fact_5898_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),F22: filter(B),F12: filter(A),F23: filter(B),F13: filter(A)] :
      ( filterlim(A,B,F3,F22,F12)
     => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),F22),F23)
       => ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F13),F12)
         => filterlim(A,B,F3,F23,F13) ) ) ) ).

% filterlim_mono
tff(fact_5899_tendsto__artanh,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),one_one(real))
         => filterlim(A,real,aTP_Lamp_vq(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,artanh(real),A2)),F6) ) ) ) ).

% tendsto_artanh
tff(fact_5900_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),L: B,A2: A,G: fun(A,C),M: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( ! [X: A] :
                ( ( X != A2 )
               => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(A,C,G,X)),M))),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,X)),L))) )
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,M),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ).

% LIM_imp_LIM
tff(fact_5901_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),L5: B,A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),S6) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X4),L5)),R5) ) ) ) ) ) ).

% LIM_def
tff(fact_5902_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),L5: B,A2: A,R: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [S3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S3)
                & ! [X3: A] :
                    ( ( ( X3 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X3,A2)),S3) )
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X3),L5)),R) ) ) ) ) ) ).

% metric_LIM_D
tff(fact_5903_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & real_V7819770556892013058_space(B) )
     => ! [A2: A,F3: fun(A,B),L5: B] :
          ( ! [R4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
             => ? [S7: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S7)
                  & ! [X: A] :
                      ( ( ( X != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,A2)),S7) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X),L5)),R4) ) ) )
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% metric_LIM_I
tff(fact_5904_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [G: fun(A,B),L: B,A2: A,R2: real,F3: fun(A,B)] :
          ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
           => ( ! [X: A] :
                  ( ( X != A2 )
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,A2)),R2)
                   => ( aa(A,B,F3,X) = aa(A,B,G,X) ) ) )
             => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_equal2
tff(fact_5905_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F3: fun(A,B),B2: B,A2: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
                  & ! [X: A] :
                      ( ( ( X != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X,A2)),D5) )
                     => ( aa(A,B,F3,X) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tq(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% metric_LIM_compose2
tff(fact_5906_LIM__offset__zero__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C)
        & zero(A) )
     => ! [A2: B,F3: fun(B,C),L5: C] :
          ( nO_MATCH(A,B,zero_zero(A),A2)
         => ( filterlim(B,C,F3,topolo7230453075368039082e_nhds(C,L5),topolo174197925503356063within(B,A2,top_top(set(B))))
          <=> filterlim(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_vr(B,fun(fun(B,C),fun(B,C)),A2),F3),topolo7230453075368039082e_nhds(C,L5),topolo174197925503356063within(B,zero_zero(B),top_top(set(B)))) ) ) ) ).

% LIM_offset_zero_iff
tff(fact_5907_IVT2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo8458572112393995274pology(B) )
     => ! [F3: fun(B,A),B2: B,Y: A,A2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,B2)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(B,A,F3,A2))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),B2)
             => ( ! [X: B] :
                    ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),X)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),B2) )
                   => topolo3448309680560233919inuous(B,A,topolo174197925503356063within(B,X,top_top(set(B))),F3) )
               => ? [X: B] :
                    ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),X)
                    & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),B2)
                    & ( aa(B,A,F3,X) = Y ) ) ) ) ) ) ) ).

% IVT2
tff(fact_5908_IVT,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo8458572112393995274pology(B) )
     => ! [F3: fun(B,A),A2: B,Y: A,B2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,A2)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(B,A,F3,B2))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),B2)
             => ( ! [X: B] :
                    ( ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),X)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),B2) )
                   => topolo3448309680560233919inuous(B,A,topolo174197925503356063within(B,X,top_top(set(B))),F3) )
               => ? [X: B] :
                    ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),X)
                    & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),B2)
                    & ( aa(B,A,F3,X) = Y ) ) ) ) ) ) ) ).

% IVT
tff(fact_5909_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [R2: real,A2: A,F3: fun(A,B),G: fun(A,B),L: B] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R2)
         => ( ! [X: A] :
                ( ( X != A2 )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2))),R2)
                 => ( aa(A,B,F3,X) = aa(A,B,G,X) ) ) )
           => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A))))
             => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% LIM_equal2
tff(fact_5910_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),L5: B,A2: A] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S6)
                  & ! [X4: A] :
                      ( ( ( X4 != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X4),A2))),S6) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,X4)),L5))),R5) ) ) ) ) ) ).

% LIM_eq
tff(fact_5911_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B),L5: B] :
          ( ! [R4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
             => ? [S7: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S7)
                  & ! [X: A] :
                      ( ( ( X != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2))),S7) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,X)),L5))),R4) ) ) )
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% LIM_I
tff(fact_5912_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),L5: B,A2: A,R: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L5),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [S3: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S3)
                & ! [X3: A] :
                    ( ( ( X3 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X3),A2))),S3) )
                   => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,X3)),L5))),R) ) ) ) ) ) ).

% LIM_D
tff(fact_5913_isCont__cos,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),cos(A)) ) ).

% isCont_cos
tff(fact_5914_isCont__sin,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),sin(A)) ) ).

% isCont_sin
tff(fact_5915_isCont__exp,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),exp(A)) ) ).

% isCont_exp
tff(fact_5916_isCont__cosh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),cosh(A)) ) ).

% isCont_cosh
tff(fact_5917_isCont__sinh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),sinh(A)) ) ).

% isCont_sinh
tff(fact_5918_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(A,A),A2: A,D3: A] :
          ( filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_vs(fun(A,A),fun(A,fun(A,A)),F3),A2),topolo7230453075368039082e_nhds(A,D3),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_vt(fun(A,A),fun(A,fun(A,A)),F3),A2),topolo7230453075368039082e_nhds(A,D3),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% DERIV_LIM_iff
tff(fact_5919_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( ! [X: real] :
            ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),F3) )
       => ? [L6: real,M10: real] :
            ( ! [X3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L6),aa(real,real,F3,X3))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,F3,X3)),M10) ) )
            & ! [Y4: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L6),Y4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Y4),M10) )
               => ? [X: real] :
                    ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                    & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
                    & ( aa(real,real,F3,X) = Y4 ) ) ) ) ) ) ).

% isCont_Lb_Ub
tff(fact_5920_LIM__fun__less__zero,axiom,
    ! [F3: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),L),zero_zero(real))
       => ? [R4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X3))),R4) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,X3)),zero_zero(real)) ) ) ) ) ).

% LIM_fun_less_zero
tff(fact_5921_LIM__fun__not__zero,axiom,
    ! [F3: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( ( L != zero_zero(real) )
       => ? [R4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X3))),R4) )
               => ( aa(real,real,F3,X3) != zero_zero(real) ) ) ) ) ) ).

% LIM_fun_not_zero
tff(fact_5922_LIM__fun__gt__zero,axiom,
    ! [F3: fun(real,real),L: real,C2: real] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,L),topolo174197925503356063within(real,C2,top_top(set(real))))
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),L)
       => ? [R4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),C2),X3))),R4) )
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,F3,X3)) ) ) ) ) ).

% LIM_fun_gt_zero
tff(fact_5923_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [F3: fun(A,B),B2: B,A2: A,G: fun(B,C),C2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,B2),topolo174197925503356063within(A,A2,top_top(set(A))))
         => ( filterlim(B,C,G,topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(B,B2,top_top(set(B))))
           => ( ? [D5: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D5)
                  & ! [X: A] :
                      ( ( ( X != A2 )
                        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),X),A2))),D5) )
                     => ( aa(A,B,F3,X) != B2 ) ) )
             => filterlim(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tn(fun(A,B),fun(fun(B,C),fun(A,C)),F3),G),topolo7230453075368039082e_nhds(C,C2),topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ) ) ).

% LIM_compose2
tff(fact_5924_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),G)
           => ( ( aa(A,B,G,A2) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aa(fun(A,B),fun(A,B),aTP_Lamp_vu(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% continuous_at_within_divide
tff(fact_5925_isCont__arctan,axiom,
    ! [Xa: real] : topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),arctan) ).

% isCont_arctan
tff(fact_5926_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_vl(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% isCont_mult
tff(fact_5927_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_vd(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% isCont_add
tff(fact_5928_isCont__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_vv(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% isCont_diff
tff(fact_5929_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [A2: A,S: set(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aTP_Lamp_vw(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_at_within_inverse
tff(fact_5930_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,S: set(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aTP_Lamp_vx(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_at_within_sgn
tff(fact_5931_continuous__at__within__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [A2: A,S: set(A),F3: fun(A,B),N: int] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),F3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,S),aa(int,fun(A,B),aTP_Lamp_vy(fun(A,B),fun(int,fun(A,B)),F3),N)) ) ) ) ).

% continuous_at_within_power_int
tff(fact_5932_isCont__cos_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_uy(fun(A,B),fun(A,B),F3)) ) ) ).

% isCont_cos'
tff(fact_5933_isCont__sin_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ux(fun(A,B),fun(A,B),F3)) ) ) ).

% isCont_sin'
tff(fact_5934_isCont__exp_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_uw(fun(A,B),fun(A,B),F3)) ) ) ).

% isCont_exp'
tff(fact_5935_isCont__pochhammer,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Z: A,N: nat] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Z,top_top(set(A))),aTP_Lamp_vz(nat,fun(A,A),N)) ) ).

% isCont_pochhammer
tff(fact_5936_isCont__arsinh,axiom,
    ! [Xa: real] : topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),arsinh(real)) ).

% isCont_arsinh
tff(fact_5937_DERIV__def,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_wa(fun(A,A),fun(A,fun(A,A)),F3),Xa),topolo7230453075368039082e_nhds(A,D3),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_def
tff(fact_5938_DERIV__D,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A] :
          ( has_field_derivative(A,F3,D3,topolo174197925503356063within(A,Xa,top_top(set(A))))
         => filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_wa(fun(A,A),fun(A,fun(A,A)),F3),Xa),topolo7230453075368039082e_nhds(A,D3),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% DERIV_D
tff(fact_5939_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => filterlim(A,A,aTP_Lamp_wb(A,A),topolo7230453075368039082e_nhds(A,one_one(A)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% lim_exp_minus_1
tff(fact_5940_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [K: real,F3: fun(A,B),K6: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K)
         => ( ! [H3: A] :
                ( ( H3 != zero_zero(A) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,H3)),K)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,H3))),aa(real,real,aa(real,fun(real,real),times_times(real),K6),real_V7770717601297561774m_norm(A,H3))) ) )
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% lemma_termdiff4
tff(fact_5941_isCont__bounded,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A2: real,B2: real,F3: fun(real,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( ! [X: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X,top_top(set(real))),F3) )
           => ? [M10: A] :
              ! [X3: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(real,A,F3,X3)),M10) ) ) ) ) ).

% isCont_bounded
tff(fact_5942_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A2: real,B2: real,F3: fun(real,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( ! [X: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X,top_top(set(real))),F3) )
           => ? [M10: A] :
                ( ! [X3: real] :
                    ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(real,A,F3,X3)),M10) )
                & ? [X: real] :
                    ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                    & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
                    & ( aa(real,A,F3,X) = M10 ) ) ) ) ) ) ).

% isCont_eq_Ub
tff(fact_5943_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A2: real,B2: real,F3: fun(real,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( ! [X: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X,top_top(set(real))),F3) )
           => ? [M10: A] :
                ( ! [X3: real] :
                    ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M10),aa(real,A,F3,X3)) )
                & ? [X: real] :
                    ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                    & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
                    & ( aa(real,A,F3,X) = M10 ) ) ) ) ) ) ).

% isCont_eq_Lb
tff(fact_5944_isCont__inverse__function2,axiom,
    ! [A2: real,Xa: real,B2: real,G: fun(real,real),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),B2)
       => ( ! [Z4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z4),B2)
               => ( aa(real,real,G,aa(real,real,F3,Z4)) = Z4 ) ) )
         => ( ! [Z4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z4),B2)
                 => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),F3) ) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F3,Xa),top_top(set(real))),G) ) ) ) ) ).

% isCont_inverse_function2
tff(fact_5945_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),D3: A,Xa: A] :
          ( has_derivative(A,A,F3,aa(A,fun(A,A),times_times(A),D3),topolo174197925503356063within(A,Xa,top_top(set(A))))
        <=> filterlim(A,A,aa(A,fun(A,A),aTP_Lamp_wa(fun(A,A),fun(A,fun(A,A)),F3),Xa),topolo7230453075368039082e_nhds(A,D3),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% field_has_derivative_at
tff(fact_5946_isCont__ln,axiom,
    ! [Xa: real] :
      ( ( Xa != zero_zero(real) )
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),ln_ln(real)) ) ).

% isCont_ln
tff(fact_5947_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [A2: A,F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( ( aa(A,B,G,A2) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aTP_Lamp_vu(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% isCont_divide
tff(fact_5948_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [A2: A,F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( ( aa(A,B,F3,A2) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_vx(fun(A,B),fun(A,B),F3)) ) ) ) ).

% isCont_sgn
tff(fact_5949_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(A,B),F6: filter(B),A2: A] :
          ( filterlim(A,B,F3,F6,topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> filterlim(A,B,aa(A,fun(A,B),aTP_Lamp_wc(fun(A,B),fun(A,fun(A,B)),F3),A2),F6,topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% filterlim_at_to_0
tff(fact_5950_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,S: set(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,S),F3)
         => ( ( aa(A,A,cos(A),aa(A,A,F3,Xa)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,S),aTP_Lamp_us(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_within_tan
tff(fact_5951_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A,S: set(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,S),F3)
         => ( ( aa(A,A,sin(A),aa(A,A,F3,Xa)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,S),aTP_Lamp_ui(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_within_cot
tff(fact_5952_continuous__at__within__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Xa: A,A3: set(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,Xa,A3),F3)
         => ( ( aa(B,B,cosh(B),aa(A,B,F3,Xa)) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,Xa,A3),aTP_Lamp_wd(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_at_within_tanh
tff(fact_5953_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),L: A,Xa: A] :
          ( has_field_derivative(A,F3,L,topolo174197925503356063within(A,Xa,top_top(set(A))))
        <=> ? [G4: fun(A,A)] :
              ( ! [Z7: A] : ( aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,F3,Z7)),aa(A,A,F3,Xa)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,G4,Z7)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Z7),Xa)) )
              & topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),G4)
              & ( aa(A,A,G4,Xa) = L ) ) ) ) ).

% CARAT_DERIV
tff(fact_5954_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A2: real,B2: real,F3: fun(real,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
         => ( ! [X: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
               => topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,X,top_top(set(real))),F3) )
           => ? [M10: A] :
                ( ! [X3: real] :
                    ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X3)
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X3),B2) )
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(real,A,F3,X3)),M10) )
                & ! [N8: A] :
                    ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),N8),M10)
                   => ? [X: real] :
                        ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
                        & aa(A,$o,aa(A,fun(A,$o),ord_less(A),N8),aa(real,A,F3,X)) ) ) ) ) ) ) ).

% isCont_has_Ub
tff(fact_5955_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,cos(A),Xa) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),tan(A)) ) ) ).

% isCont_tan
tff(fact_5956_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(A,B),F6: filter(B),A2: A,D2: A] :
          ( filterlim(A,B,F3,F6,topolo174197925503356063within(A,A2,top_top(set(A))))
         => filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F3),aa(A,fun(A,A),plus_plus(A),D2)),F6,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A)))) ) ) ).

% filterlim_shift
tff(fact_5957_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(A,B),D2: A,F6: filter(B),A2: A] :
          ( filterlim(A,B,aa(fun(A,A),fun(A,B),comp(A,B,A,F3),aa(A,fun(A,A),plus_plus(A),D2)),F6,topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A))))
        <=> filterlim(A,B,F3,F6,topolo174197925503356063within(A,A2,top_top(set(A)))) ) ) ).

% filterlim_shift_iff
tff(fact_5958_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,sin(A),Xa) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),cot(A)) ) ) ).

% isCont_cot
tff(fact_5959_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( ( aa(A,A,cosh(A),Xa) != zero_zero(A) )
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),tanh(A)) ) ) ).

% isCont_tanh
tff(fact_5960_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A2: fun(nat,A),F3: fun(A,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S)
         => ( ! [X: A] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),S)
               => sums(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),A2),X),aa(A,A,F3,X)) )
           => filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,aa(nat,A,A2,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0
tff(fact_5961_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: real,A2: fun(nat,A),F3: fun(A,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S)
         => ( ! [X: A] :
                ( ( X != zero_zero(A) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,X)),S)
                 => sums(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),A2),X),aa(A,A,F3,X)) ) )
           => filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,aa(nat,A,A2,zero_zero(nat))),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% powser_limit_0_strong
tff(fact_5962_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [G: fun(A,B),G5: filter(B),Xa: A,S2: set(A),F6: filter(B),D2: real,F3: fun(A,B)] :
          ( filterlim(A,B,G,G5,topolo174197925503356063within(A,Xa,S2))
         => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),G5),F6)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
             => ( ! [X8: A] :
                    ( member(A,X8,S2)
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),real_V557655796197034286t_dist(A,X8,Xa))
                     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X8,Xa)),D2)
                       => ( aa(A,B,F3,X8) = aa(A,B,G,X8) ) ) ) )
               => filterlim(A,B,F3,F6,topolo174197925503356063within(A,Xa,S2)) ) ) ) ) ) ).

% filterlim_transform_within
tff(fact_5963_bij__int__encode,axiom,
    bij_betw(int,nat,nat_int_encode,top_top(set(int)),top_top(set(nat))) ).

% bij_int_encode
tff(fact_5964_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [K: real,F3: fun(nat,real),G: fun(A,fun(nat,B))] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K)
         => ( summable(real,F3)
           => ( ! [H3: A,N2: nat] :
                  ( ( H3 != zero_zero(A) )
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,H3)),K)
                   => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(nat,B,aa(A,fun(nat,B),G,H3),N2))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,F3,N2)),real_V7770717601297561774m_norm(A,H3))) ) )
             => filterlim(A,B,aTP_Lamp_we(fun(A,fun(nat,B)),fun(A,B),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% lemma_termdiff5
tff(fact_5965_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: A,F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( ( aa(A,A,cos(A),aa(A,A,F3,A2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_us(fun(A,A),fun(A,A),F3)) ) ) ) ).

% isCont_tan'
tff(fact_5966_isCont__arcosh,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),arcosh(real)) ) ).

% isCont_arcosh
tff(fact_5967_LIM__cos__div__sin,axiom,
    filterlim(real,real,aTP_Lamp_wf(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))),top_top(set(real)))) ).

% LIM_cos_div_sin
tff(fact_5968_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: A,F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( ( aa(A,A,sin(A),aa(A,A,F3,A2)) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aTP_Lamp_ui(fun(A,A),fun(A,A),F3)) ) ) ) ).

% isCont_cot'
tff(fact_5969_DERIV__inverse__function,axiom,
    ! [F3: fun(real,real),D3: real,G: fun(real,real),Xa: real,A2: real,B2: real] :
      ( has_field_derivative(real,F3,D3,topolo174197925503356063within(real,aa(real,real,G,Xa),top_top(set(real))))
     => ( ( D3 != zero_zero(real) )
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xa)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),B2)
           => ( ! [Y3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Y3)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y3),B2)
                   => ( aa(real,real,F3,aa(real,real,G,Y3)) = Y3 ) ) )
             => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),G)
               => has_field_derivative(real,G,aa(real,real,inverse_inverse(real),D3),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ) ) ) ).

% DERIV_inverse_function
tff(fact_5970_isCont__polynom,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [A2: A,C2: fun(nat,A),N: nat] : topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,A2,top_top(set(A))),aa(nat,fun(A,A),aTP_Lamp_wg(fun(nat,A),fun(nat,fun(A,A)),C2),N)) ) ).

% isCont_polynom
tff(fact_5971_isCont__arccos,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),arccos) ) ) ).

% isCont_arccos
tff(fact_5972_isCont__arcsin,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),arcsin) ) ) ).

% isCont_arcsin
tff(fact_5973_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),Xa: A] :
          ( ! [Y3: A] : summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),Y3))
         => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),aTP_Lamp_qn(fun(nat,A),fun(A,A),C2)) ) ) ).

% isCont_powser_converges_everywhere
tff(fact_5974_LIM__less__bound,axiom,
    ! [B2: real,Xa: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),B2),Xa)
     => ( ! [X: real] :
            ( member(real,X,set_or5935395276787703475ssThan(real,B2,Xa))
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,F3,X)) )
       => ( topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),F3)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(real,real,F3,Xa)) ) ) ) ).

% LIM_less_bound
tff(fact_5975_isCont__artanh,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),one_one(real))),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Xa,top_top(set(real))),artanh(real)) ) ) ).

% isCont_artanh
tff(fact_5976_isCont__inverse__function,axiom,
    ! [D2: real,Xa: real,G: fun(real,real),F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D2)
     => ( ! [Z4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z4),Xa))),D2)
           => ( aa(real,real,G,aa(real,real,F3,Z4)) = Z4 ) )
       => ( ! [Z4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Z4),Xa))),D2)
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),F3) )
         => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,aa(real,real,F3,Xa),top_top(set(real))),G) ) ) ) ).

% isCont_inverse_function
tff(fact_5977_GMVT_H,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),G: fun(real,real),G3: fun(real,real),F9: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [Z4: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z4)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z4),B2)
             => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),F3) ) )
       => ( ! [Z4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Z4)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Z4),B2)
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,Z4,top_top(set(real))),G) ) )
         => ( ! [Z4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z4)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z4),B2)
                 => has_field_derivative(real,G,aa(real,real,G3,Z4),topolo174197925503356063within(real,Z4,top_top(set(real)))) ) )
           => ( ! [Z4: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z4)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z4),B2)
                   => has_field_derivative(real,F3,aa(real,real,F9,Z4),topolo174197925503356063within(real,Z4,top_top(set(real)))) ) )
             => ? [C4: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),C4),B2)
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2))),aa(real,real,G3,C4)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A2))),aa(real,real,F9,C4)) ) ) ) ) ) ) ) ).

% GMVT'
tff(fact_5978_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Xa: real,F3: fun(real,A)] :
          ( topolo3448309680560233919inuous(real,A,topolo174197925503356063within(real,Xa,top_top(set(real))),F3)
         => ( ~ member(A,aa(real,A,F3,Xa),ring_1_Ints(A))
           => has_field_derivative(real,aTP_Lamp_wh(fun(real,A),fun(real,real),F3),zero_zero(real),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ).

% floor_has_real_derivative
tff(fact_5979_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [C2: fun(nat,A),K6: A,Xa: A] :
          ( summable(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),C2),K6))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),real_V7770717601297561774m_norm(A,K6))
           => topolo3448309680560233919inuous(A,A,topolo174197925503356063within(A,Xa,top_top(set(A))),aTP_Lamp_qn(fun(nat,A),fun(A,A),C2)) ) ) ) ).

% isCont_powser
tff(fact_5980_isCont__powser_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B)
        & topological_t2_space(A) )
     => ! [A2: A,F3: fun(A,B),C2: fun(nat,B),K6: B] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( summable(B,aa(B,fun(nat,B),aTP_Lamp_wi(fun(nat,B),fun(B,fun(nat,B)),C2),K6))
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,A2))),real_V7770717601297561774m_norm(B,K6))
             => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(nat,B),fun(A,B),aTP_Lamp_wk(fun(A,B),fun(fun(nat,B),fun(A,B)),F3),C2)) ) ) ) ) ).

% isCont_powser'
tff(fact_5981_summable__Leibniz_I2_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(nat,real,A2,zero_zero(nat)))
         => ! [N3: nat] : member(real,suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3)),one_one(nat)))))) ) ) ) ).

% summable_Leibniz(2)
tff(fact_5982_summable__Leibniz_I3_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(nat,real,A2,zero_zero(nat))),zero_zero(real))
         => ! [N3: nat] : member(real,suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_or1337092689740270186AtMost(real,aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3)),one_one(nat)))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3))))) ) ) ) ).

% summable_Leibniz(3)
tff(fact_5983_summable__Leibniz_H_I5_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N2))
       => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N2))),aa(nat,real,A2,N2))
         => filterlim(nat,real,aTP_Lamp_wm(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(5)
tff(fact_5984_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wn(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_right_iff
tff(fact_5985_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wo(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_mult_left_iff
tff(fact_5986_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,A2: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wp(A,fun(fun(nat,A),fun(nat,A)),C2),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
          <=> filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ) ).

% tendsto_zero_divide_iff
tff(fact_5987_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F3: fun(nat,A),F6: filter(A)] :
      ( filterlim(nat,A,aTP_Lamp_wq(fun(nat,A),fun(nat,A),F3),F6,at_top(nat))
    <=> filterlim(nat,A,F3,F6,at_top(nat)) ) ).

% filterlim_sequentially_Suc
tff(fact_5988_filterlim__Suc,axiom,
    filterlim(nat,nat,suc,at_top(nat),at_top(nat)) ).

% filterlim_Suc
tff(fact_5989_continuous__arctan,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => topolo3448309680560233919inuous(A,real,F6,aTP_Lamp_wr(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_arctan
tff(fact_5990_continuous__arsinh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => topolo3448309680560233919inuous(A,real,F6,aTP_Lamp_ws(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_arsinh
tff(fact_5991_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),L: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,aTP_Lamp_wt(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% LIMSEQ_Suc
tff(fact_5992_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),L: A] :
          ( filterlim(nat,A,aTP_Lamp_wt(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% LIMSEQ_imp_Suc
tff(fact_5993_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),A2: A,K: nat] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
         => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wu(fun(nat,A),fun(nat,fun(nat,A)),F3),K),topolo7230453075368039082e_nhds(A,A2),at_top(nat)) ) ) ).

% LIMSEQ_ignore_initial_segment
tff(fact_5994_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),K: nat,A2: A] :
          ( filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wu(fun(nat,A),fun(nat,fun(nat,A)),F3),K),topolo7230453075368039082e_nhds(A,A2),at_top(nat))
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,A2),at_top(nat)) ) ) ).

% LIMSEQ_offset
tff(fact_5995_seq__offset__neg,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),L: A,K: nat] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wv(fun(nat,A),fun(nat,fun(nat,A)),F3),K),topolo7230453075368039082e_nhds(A,L),at_top(nat)) ) ) ).

% seq_offset_neg
tff(fact_5996_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X6: fun(nat,A),Xa: A,A2: A] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,Xa),at_top(nat))
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N2)),A2) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A2) ) ) ) ).

% LIMSEQ_le_const2
tff(fact_5997_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X6: fun(nat,A),Xa: A,A2: A] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,Xa),at_top(nat))
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(nat,A,X6,N2)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),Xa) ) ) ) ).

% LIMSEQ_le_const
tff(fact_5998_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F3: fun(nat,A),L: A,N6: nat,C5: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => ( ! [N2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C5),aa(nat,A,F3,N2)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C5),L) ) ) ) ).

% Lim_bounded2
tff(fact_5999_Lim__bounded,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F3: fun(nat,A),L: A,M7: nat,C5: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,L),at_top(nat))
         => ( ! [N2: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),N2)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N2)),C5) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),C5) ) ) ) ).

% Lim_bounded
tff(fact_6000_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X6: fun(nat,A),Xa: A,Y6: fun(nat,A),Y: A] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,Xa),at_top(nat))
         => ( filterlim(nat,A,Y6,topolo7230453075368039082e_nhds(A,Y),at_top(nat))
           => ( ? [N8: nat] :
                ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N2)),aa(nat,A,Y6,N2)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ) ).

% LIMSEQ_le
tff(fact_6001_lim__mono,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [N6: nat,X6: fun(nat,A),Y6: fun(nat,A),Xa: A,Y: A] :
          ( ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N6),N2)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N2)),aa(nat,A,Y6,N2)) )
         => ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,Xa),at_top(nat))
           => ( filterlim(nat,A,Y6,topolo7230453075368039082e_nhds(A,Y),at_top(nat))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ) ).

% lim_mono
tff(fact_6002_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: fun(nat,A),S: set(A),A2: A] :
          ( ! [N2: nat] : member(A,aa(nat,A,B2,N2),S)
         => ( filterlim(nat,A,B2,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(set(A),A,complete_Sup_Sup(A),S)) ) ) ) ).

% Sup_lim
tff(fact_6003_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & topolo1944317154257567458pology(A) )
     => ! [B2: fun(nat,A),S: set(A),A2: A] :
          ( ! [N2: nat] : member(A,aa(nat,A,B2,N2),S)
         => ( filterlim(nat,A,B2,topolo7230453075368039082e_nhds(A,A2),at_top(nat))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),S)),A2) ) ) ) ).

% Inf_lim
tff(fact_6004_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( summable(A,F3)
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% summable_LIMSEQ_zero
tff(fact_6005_continuous__at__within__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),G)
           => ( ( aa(A,real,F3,A2) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),aa(fun(A,real),fun(A,real),aTP_Lamp_ww(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_at_within_powr
tff(fact_6006_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Xa: A,S: set(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,Xa,S),F3)
         => ( ( aa(A,real,F3,Xa) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,Xa,S),aTP_Lamp_wx(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_within_ln
tff(fact_6007_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
     => filterlim(nat,nat,aa(nat,fun(nat,nat),times_times(nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_left_at_top
tff(fact_6008_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),C2)
     => filterlim(nat,nat,aTP_Lamp_wy(nat,fun(nat,nat),C2),at_top(nat),at_top(nat)) ) ).

% mult_nat_right_at_top
tff(fact_6009_monoseq__convergent,axiom,
    ! [X6: fun(nat,real),B3: real] :
      ( topological_monoseq(real,X6)
     => ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),aa(nat,real,X6,I2))),B3)
       => ~ ! [L6: real] : ~ filterlim(nat,real,X6,topolo7230453075368039082e_nhds(real,L6),at_top(nat)) ) ) ).

% monoseq_convergent
tff(fact_6010_LIMSEQ__root,axiom,
    filterlim(nat,real,aTP_Lamp_wz(nat,real),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ).

% LIMSEQ_root
tff(fact_6011_isCont__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( ( aa(A,real,F3,A2) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,real),fun(A,real),aTP_Lamp_ww(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% isCont_powr
tff(fact_6012_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Xa: A,F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,Xa,top_top(set(A))),F3)
         => ( ( aa(A,real,F3,Xa) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,Xa,top_top(set(A))),aTP_Lamp_wx(fun(A,real),fun(A,real),F3)) ) ) ) ).

% isCont_ln'
tff(fact_6013_monoseq__le,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A2: fun(nat,A),Xa: A] :
          ( topological_monoseq(A,A2)
         => ( filterlim(nat,A,A2,topolo7230453075368039082e_nhds(A,Xa),at_top(nat))
           => ( ( ! [N3: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A2,N3)),Xa)
                & ! [M3: nat,N3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M3),N3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A2,M3)),aa(nat,A,A2,N3)) ) )
              | ( ! [N3: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(nat,A,A2,N3))
                & ! [M3: nat,N3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M3),N3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A2,N3)),aa(nat,A,A2,M3)) ) ) ) ) ) ) ).

% monoseq_le
tff(fact_6014_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A2: A] : filterlim(nat,A,aTP_Lamp_xa(A,fun(nat,A),A2),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_const_over_n
tff(fact_6015_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_xb(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_inverse_n
tff(fact_6016_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [X6: fun(nat,A),Xa: A,L: nat] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,Xa),at_top(nat))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),L)
           => filterlim(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xc(fun(nat,A),fun(nat,fun(nat,A)),X6),L),topolo7230453075368039082e_nhds(A,Xa),at_top(nat)) ) ) ) ).

% LIMSEQ_linear
tff(fact_6017_telescope__summable,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => summable(A,aTP_Lamp_xd(fun(nat,A),fun(nat,A),F3)) ) ) ).

% telescope_summable
tff(fact_6018_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => summable(A,aTP_Lamp_xe(fun(nat,A),fun(nat,A),F3)) ) ) ).

% telescope_summable'
tff(fact_6019_nested__sequence__unique,axiom,
    ! [F3: fun(nat,real),G: fun(nat,real)] :
      ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N2)),aa(nat,real,F3,aa(nat,nat,suc,N2)))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,G,aa(nat,nat,suc,N2))),aa(nat,real,G,N2))
       => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N2)),aa(nat,real,G,N2))
         => ( filterlim(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_xf(fun(nat,real),fun(fun(nat,real),fun(nat,real)),F3),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => ? [L2: real] :
                ( ! [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N3)),L2)
                & filterlim(nat,real,F3,topolo7230453075368039082e_nhds(real,L2),at_top(nat))
                & ! [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L2),aa(nat,real,G,N3))
                & filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ) ).

% nested_sequence_unique
tff(fact_6020_LIMSEQ__inverse__zero,axiom,
    ! [X6: fun(nat,real)] :
      ( ! [R4: real] :
        ? [N8: nat] :
        ! [N2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N8),N2)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),R4),aa(nat,real,X6,N2)) )
     => filterlim(nat,real,aTP_Lamp_xg(fun(nat,real),fun(nat,real),X6),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_zero
tff(fact_6021_lim__inverse__n_H,axiom,
    filterlim(nat,real,aTP_Lamp_xh(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% lim_inverse_n'
tff(fact_6022_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
     => filterlim(nat,real,aTP_Lamp_xi(real,fun(nat,real),C2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat)) ) ).

% LIMSEQ_root_const
tff(fact_6023_LIMSEQ__inverse__real__of__nat,axiom,
    filterlim(nat,real,aTP_Lamp_xj(nat,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat
tff(fact_6024_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R: real] : filterlim(nat,real,aTP_Lamp_xk(real,fun(nat,real),R),topolo7230453075368039082e_nhds(real,R),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add
tff(fact_6025_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,A2))
             => ( ( aa(A,real,F3,A2) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,A2))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,S),aa(fun(A,real),fun(A,real),aTP_Lamp_xl(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% continuous_at_within_log
tff(fact_6026_increasing__LIMSEQ,axiom,
    ! [F3: fun(nat,real),L: real] :
      ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N2)),aa(nat,real,F3,aa(nat,nat,suc,N2)))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N2)),L)
       => ( ! [E2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
             => ? [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(nat,real,F3,N3)),E2)) )
         => filterlim(nat,real,F3,topolo7230453075368039082e_nhds(real,L),at_top(nat)) ) ) ) ).

% increasing_LIMSEQ
tff(fact_6027_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A),L5: A,R: real] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [No: nat] :
              ! [N3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No),N3)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,N3),L5)),R) ) ) ) ) ).

% metric_LIMSEQ_D
tff(fact_6028_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A),L5: A] :
          ( ! [R4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
             => ? [No2: nat] :
                ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No2),N2)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,N2),L5)),R4) ) )
         => filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat)) ) ) ).

% metric_LIMSEQ_I
tff(fact_6029_lim__sequentially,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A),L5: A] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No3: nat] :
                ! [N5: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No3),N5)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,N5),L5)),R5) ) ) ) ) ).

% lim_sequentially
tff(fact_6030_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_xm(nat,A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ).

% lim_1_over_n
tff(fact_6031_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_xn(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_Suc_n_over_n
tff(fact_6032_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => filterlim(nat,A,aTP_Lamp_xo(nat,A),topolo7230453075368039082e_nhds(A,one_one(A)),at_top(nat)) ) ).

% LIMSEQ_n_over_Suc_n
tff(fact_6033_LIMSEQ__realpow__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
       => filterlim(nat,real,aa(real,fun(nat,real),power_power(real),Xa),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ) ).

% LIMSEQ_realpow_zero
tff(fact_6034_telescope__sums,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => sums(A,aTP_Lamp_xd(fun(nat,A),fun(nat,A),F3),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),aa(nat,A,F3,zero_zero(nat)))) ) ) ).

% telescope_sums
tff(fact_6035_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,C2),at_top(nat))
         => sums(A,aTP_Lamp_xe(fun(nat,A),fun(nat,A),F3),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,F3,zero_zero(nat))),C2)) ) ) ).

% telescope_sums'
tff(fact_6036_LIMSEQ__divide__realpow__zero,axiom,
    ! [Xa: real,A2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_xp(real,fun(real,fun(nat,real)),Xa),A2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_divide_realpow_zero
tff(fact_6037_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real))
     => filterlim(nat,real,aa(real,fun(nat,real),power_power(real),C2),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero2
tff(fact_6038_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,abs_abs(real),C2)),one_one(real))
     => filterlim(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),C2)),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_abs_realpow_zero
tff(fact_6039_LIMSEQ__inverse__realpow__zero,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),Xa)
     => filterlim(nat,real,aTP_Lamp_xq(real,fun(nat,real),Xa),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% LIMSEQ_inverse_realpow_zero
tff(fact_6040_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [F3: fun(nat,A),S: A] :
          ( sums(A,F3,S)
        <=> filterlim(nat,A,aTP_Lamp_xr(fun(nat,A),fun(nat,A),F3),topolo7230453075368039082e_nhds(A,S),at_top(nat)) ) ) ).

% sums_def'
tff(fact_6041_root__test__convergence,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),Xa: real] :
          ( filterlim(nat,real,aTP_Lamp_xs(fun(nat,A),fun(nat,real),F3),topolo7230453075368039082e_nhds(real,Xa),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),one_one(real))
           => summable(A,F3) ) ) ) ).

% root_test_convergence
tff(fact_6042_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R: real] : filterlim(nat,real,aTP_Lamp_xt(real,fun(nat,real),R),topolo7230453075368039082e_nhds(real,R),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add_minus
tff(fact_6043_isCont__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [A2: A,F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),F3)
         => ( topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,A2))
             => ( ( aa(A,real,F3,A2) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,A2))
                 => topolo3448309680560233919inuous(A,real,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,real),fun(A,real),aTP_Lamp_xl(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% isCont_log
tff(fact_6044_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A),L5: A] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No3: nat] :
                ! [N5: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No3),N5)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X6,N5)),L5))),R5) ) ) ) ) ).

% LIMSEQ_iff
tff(fact_6045_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A),L5: A] :
          ( ! [R4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R4)
             => ? [No2: nat] :
                ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No2),N2)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X6,N2)),L5))),R4) ) )
         => filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat)) ) ) ).

% LIMSEQ_I
tff(fact_6046_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A),L5: A,R: real] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R)
           => ? [No: nat] :
              ! [N3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No),N3)
               => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,X6,N3)),L5))),R) ) ) ) ) ).

% LIMSEQ_D
tff(fact_6047_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),one_one(real))
         => filterlim(nat,A,aa(A,fun(nat,A),power_power(A),Xa),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_power_zero
tff(fact_6048_tendsto__exp__limit__sequentially,axiom,
    ! [Xa: real] : filterlim(nat,real,aTP_Lamp_xu(real,fun(nat,real),Xa),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),Xa)),at_top(nat)) ).

% tendsto_exp_limit_sequentially
tff(fact_6049_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A),L5: A] :
          ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [No3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),No3)
                  & ! [N5: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),No3),N5)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(nat,A,X6,N5),L5)),R5) ) ) ) ) ) ).

% LIMSEQ_iff_nz
tff(fact_6050_tendsto__at__iff__sequentially,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo3112930676232923870pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [F3: fun(A,B),A2: B,Xa: A,S: set(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),topolo174197925503356063within(A,Xa,S))
        <=> ! [X9: fun(nat,A)] :
              ( ! [I3: nat] : member(A,aa(nat,A,X9,I3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))
             => ( filterlim(nat,A,X9,topolo7230453075368039082e_nhds(A,Xa),at_top(nat))
               => filterlim(nat,B,aa(fun(nat,A),fun(nat,B),comp(A,B,nat,F3),X9),topolo7230453075368039082e_nhds(B,A2),at_top(nat)) ) ) ) ) ).

% tendsto_at_iff_sequentially
tff(fact_6051_tendsto__power__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [F3: fun(A,nat),F6: filter(A),Xa: B] :
          ( filterlim(A,nat,F3,at_top(nat),F6)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(B,Xa)),one_one(real))
           => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_xv(fun(A,nat),fun(B,fun(A,B)),F3),Xa),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ) ).

% tendsto_power_zero
tff(fact_6052_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] : filterlim(nat,real,aTP_Lamp_xw(real,fun(nat,real),R),topolo7230453075368039082e_nhds(real,R),at_top(nat)) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
tff(fact_6053_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,N2))),divide_divide(real,one_one(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N2))))
         => filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% LIMSEQ_norm_0
tff(fact_6054_summable__Leibniz_I1_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => summable(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)) ) ) ).

% summable_Leibniz(1)
tff(fact_6055_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),Df: A,Z: A,S: fun(nat,A),A2: A] :
          ( has_field_derivative(A,F3,Df,topolo174197925503356063within(A,Z,top_top(set(A))))
         => ( filterlim(nat,A,S,topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat))
           => ( ! [N2: nat] : ( aa(nat,A,S,N2) != zero_zero(A) )
             => ( filterlim(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_xx(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),F3),Z),S),topolo7230453075368039082e_nhds(A,A2),at_top(nat))
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
tff(fact_6056_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,Xa)),one_one(real))
         => filterlim(nat,A,aTP_Lamp_xy(A,fun(nat,A),Xa),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% powser_times_n_limit_0
tff(fact_6057_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,Xa))
         => filterlim(nat,A,aTP_Lamp_xz(A,fun(nat,A),Xa),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_top(nat)) ) ) ).

% lim_n_over_pown
tff(fact_6058_summable,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N2))
       => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N2))),aa(nat,real,A2,N2))
         => summable(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)) ) ) ) ).

% summable
tff(fact_6059_cos__diff__limit__1,axiom,
    ! [Theta: fun(nat,real),Theta2: real] :
      ( filterlim(nat,real,aa(real,fun(nat,real),aTP_Lamp_ya(fun(nat,real),fun(real,fun(nat,real)),Theta),Theta2),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ~ ! [K3: fun(nat,int)] : ~ filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_yb(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K3),topolo7230453075368039082e_nhds(real,Theta2),at_top(nat)) ) ).

% cos_diff_limit_1
tff(fact_6060_cos__limit__1,axiom,
    ! [Theta: fun(nat,real)] :
      ( filterlim(nat,real,aTP_Lamp_yc(fun(nat,real),fun(nat,real),Theta),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(nat))
     => ? [K3: fun(nat,int)] : filterlim(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_yb(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Theta),K3),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% cos_limit_1
tff(fact_6061_summable__Leibniz_I4_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => filterlim(nat,real,aTP_Lamp_yd(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ).

% summable_Leibniz(4)
tff(fact_6062_zeroseq__arctan__series,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,abs_abs(real),Xa)),one_one(real))
     => filterlim(nat,real,aTP_Lamp_av(real,fun(nat,real),Xa),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat)) ) ).

% zeroseq_arctan_series
tff(fact_6063_summable__Leibniz_H_I3_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N2))
       => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N2))),aa(nat,real,A2,N2))
         => filterlim(nat,real,aTP_Lamp_yd(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ) ).

% summable_Leibniz'(3)
tff(fact_6064_summable__Leibniz_H_I2_J,axiom,
    ! [A2: fun(nat,real),N: nat] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N2))
       => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N2))),aa(nat,real,A2,N2))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)))),suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2))) ) ) ) ).

% summable_Leibniz'(2)
tff(fact_6065_sums__alternating__upper__lower,axiom,
    ! [A2: fun(nat,real)] :
      ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N2))),aa(nat,real,A2,N2))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N2))
       => ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
         => ? [L2: real] :
              ( ! [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3)))),L2)
              & filterlim(nat,real,aTP_Lamp_yd(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,L2),at_top(nat))
              & ! [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),L2),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N3)),one_one(nat)))))
              & filterlim(nat,real,aTP_Lamp_wm(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,L2),at_top(nat)) ) ) ) ) ).

% sums_alternating_upper_lower
tff(fact_6066_summable__Leibniz_I5_J,axiom,
    ! [A2: fun(nat,real)] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( topological_monoseq(real,A2)
       => filterlim(nat,real,aTP_Lamp_wm(fun(nat,real),fun(nat,real),A2),topolo7230453075368039082e_nhds(real,suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2))),at_top(nat)) ) ) ).

% summable_Leibniz(5)
tff(fact_6067_summable__Leibniz_H_I4_J,axiom,
    ! [A2: fun(nat,real),N: nat] :
      ( filterlim(nat,real,A2,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,A2,N2))
       => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,A2,aa(nat,nat,suc,N2))),aa(nat,real,A2,N2))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),suminf(real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2))),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),A2)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)),one_one(nat))))) ) ) ) ).

% summable_Leibniz'(4)
tff(fact_6068_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F9)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_ye(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F3),F9),Xa),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,Xa,top_top(set(A)))) ) ) ) ).

% has_derivative_at2
tff(fact_6069_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),D3: fun(A,B),Xa: A] :
          ( has_derivative(A,B,F3,D3,topolo174197925503356063within(A,Xa,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,D3)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yf(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F3),D3),Xa),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ).

% has_derivative_at
tff(fact_6070_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => real_V3181309239436604168linear(A,B,aTP_Lamp_ru(A,B)) ) ).

% bounded_linear_zero
tff(fact_6071_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( real_V3181309239436604168linear(A,B,G)
           => real_V3181309239436604168linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rs(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% bounded_linear_add
tff(fact_6072_real__bounded__linear,axiom,
    ! [F3: fun(real,real)] :
      ( real_V3181309239436604168linear(real,real,F3)
    <=> ? [C3: real] :
        ! [X4: real] : ( aa(real,real,F3,X4) = aa(real,real,aa(real,fun(real,real),times_times(real),X4),C3) ) ) ).

% real_bounded_linear
tff(fact_6073_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Xa: A] : real_V3181309239436604168linear(A,A,aa(A,fun(A,A),times_times(A),Xa)) ) ).

% bounded_linear_mult_right
tff(fact_6074_bounded__linear__mult__const,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & real_V822414075346904944vector(A) )
     => ! [G: fun(A,B),Y: B] :
          ( real_V3181309239436604168linear(A,B,G)
         => real_V3181309239436604168linear(A,B,aa(B,fun(A,B),aTP_Lamp_rq(fun(A,B),fun(B,fun(A,B)),G),Y)) ) ) ).

% bounded_linear_mult_const
tff(fact_6075_bounded__linear__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & real_V822414075346904944vector(A) )
     => ! [G: fun(A,B),Xa: B] :
          ( real_V3181309239436604168linear(A,B,G)
         => real_V3181309239436604168linear(A,B,aa(B,fun(A,B),aTP_Lamp_rr(fun(A,B),fun(B,fun(A,B)),G),Xa)) ) ) ).

% bounded_linear_const_mult
tff(fact_6076_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Y: A] : real_V3181309239436604168linear(A,A,aTP_Lamp_yg(A,fun(A,A),Y)) ) ).

% bounded_linear_mult_left
tff(fact_6077_bounded__linear__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( real_V3181309239436604168linear(A,B,G)
           => real_V3181309239436604168linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rp(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% bounded_linear_sub
tff(fact_6078_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ? [K9: real] :
            ! [X3: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X3))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X3)),K9)) ) ) ).

% bounded_linear.bounded
tff(fact_6079_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),G: fun(C,A),F6: filter(C)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ( filterlim(C,A,G,topolo7230453075368039082e_nhds(A,zero_zero(A)),F6)
           => filterlim(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_yh(fun(A,B),fun(fun(C,A),fun(C,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ) ).

% bounded_linear.tendsto_zero
tff(fact_6080_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),K9)
              & ! [X3: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X3))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X3)),K9)) ) ) ) ).

% bounded_linear.nonneg_bounded
tff(fact_6081_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_V3181309239436604168linear(A,B,F3)
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K9)
              & ! [X3: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X3))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X3)),K9)) ) ) ) ).

% bounded_linear.pos_bounded
tff(fact_6082_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),K6: real] :
          ( ! [X: A,Y3: A] : ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) )
         => ( ! [R4: real,X: A] : ( aa(A,B,F3,aa(A,A,real_V8093663219630862766scaleR(A,R4),X)) = aa(B,B,real_V8093663219630862766scaleR(B,R4),aa(A,B,F3,X)) )
           => ( ! [X: A] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,F3,X))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,X)),K6))
             => real_V3181309239436604168linear(A,B,F3) ) ) ) ) ).

% bounded_linear_intro
tff(fact_6083_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S: set(A)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S))
        <=> ( real_V3181309239436604168linear(A,B,F9)
            & filterlim(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yi(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),F3),F9),Xa),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_iff_norm
tff(fact_6084_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F9: fun(A,B),Xa: A,F3: fun(A,B),S: set(A)] :
          ( real_V3181309239436604168linear(A,B,F9)
         => ( filterlim(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_yj(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),F9),Xa),F3),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,Xa,S))
           => has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivativeI
tff(fact_6085_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S: set(A)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S))
        <=> ( real_V3181309239436604168linear(A,B,F9)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_yk(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F3),F9),Xa),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_at_within
tff(fact_6086_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,top_top(set(A))))
        <=> ( real_V3181309239436604168linear(A,B,F9)
            & ? [E3: fun(A,B)] :
                ( ! [H5: A] : ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),H5)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,Xa)),aa(A,B,F9,H5))),aa(A,B,E3,H5)) )
                & filterlim(A,real,aTP_Lamp_yl(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ).

% has_derivative_iff_Ex
tff(fact_6087_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [E: real,F9: fun(A,B),S: set(A),Xa: A,F3: fun(A,B),H6: fun(A,real)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
         => ( real_V3181309239436604168linear(A,B,F9)
           => ( ! [Y3: A] :
                  ( member(A,Y3,S)
                 => ( ( Y3 != Xa )
                   => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y3,Xa)),E)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),divide_divide(real,real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,Y3)),aa(A,B,F3,Xa))),aa(A,B,F9,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y3),Xa)))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Y3),Xa)))),aa(A,real,H6,Y3)) ) ) )
             => ( filterlim(A,real,H6,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,Xa,S))
               => has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S)) ) ) ) ) ) ).

% has_derivativeI_sandwich
tff(fact_6088_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),Xa: A,S: set(A)] :
          ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S))
        <=> ( real_V3181309239436604168linear(A,B,F9)
            & filterlim(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_ye(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),F3),F9),Xa),topolo7230453075368039082e_nhds(B,zero_zero(B)),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% has_derivative_within
tff(fact_6089_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F9: fun(A,B),F6: filter(A)] :
          ( has_derivative(A,B,F3,F9,F6)
        <=> ( real_V3181309239436604168linear(A,B,F9)
            & filterlim(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_yn(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),F3),F9),F6),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ) ).

% has_derivative_def
tff(fact_6090_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Xa: A,S2: set(A),F3: fun(A,B),F9: fun(A,B)] :
          ( member(A,Xa,S2)
         => ( topolo1002775350975398744n_open(A,S2)
           => ( has_derivative(A,B,F3,F9,topolo174197925503356063within(A,Xa,S2))
            <=> ( real_V3181309239436604168linear(A,B,F9)
                & ? [E3: fun(A,B)] :
                    ( ! [H5: A] :
                        ( member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),H5),S2)
                       => ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),H5)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,Xa)),aa(A,B,F9,H5))),aa(A,B,E3,H5)) ) )
                    & filterlim(A,real,aTP_Lamp_yl(fun(A,B),fun(A,real),E3),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
tff(fact_6091_first__countable__basis,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Xa: A] :
        ? [A6: fun(nat,set(A))] :
          ( ! [I4: nat] :
              ( member(A,Xa,aa(nat,set(A),A6,I4))
              & topolo1002775350975398744n_open(A,aa(nat,set(A),A6,I4)) )
          & ! [S8: set(A)] :
              ( ( topolo1002775350975398744n_open(A,S8)
                & member(A,Xa,S8) )
             => ? [I2: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),A6,I2)),S8) ) ) ) ).

% first_countable_basis
tff(fact_6092_open__subopen,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A)] :
          ( topolo1002775350975398744n_open(A,S2)
        <=> ! [X4: A] :
              ( member(A,X4,S2)
             => ? [T9: set(A)] :
                  ( topolo1002775350975398744n_open(A,T9)
                  & member(A,X4,T9)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T9),S2) ) ) ) ) ).

% open_subopen
tff(fact_6093_openI,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A)] :
          ( ! [X: A] :
              ( member(A,X,S2)
             => ? [T10: set(A)] :
                  ( topolo1002775350975398744n_open(A,T10)
                  & member(A,X,T10)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T10),S2) ) )
         => topolo1002775350975398744n_open(A,S2) ) ) ).

% openI
tff(fact_6094_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A2: A,S2: set(A),T5: set(A)] :
          ( member(A,A2,S2)
         => ( topolo1002775350975398744n_open(A,S2)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
             => ( topolo174197925503356063within(A,A2,T5) = topolo174197925503356063within(A,A2,top_top(set(A))) ) ) ) ) ) ).

% at_within_open_subset
tff(fact_6095_open__right,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A),Xa: A,Y: A] :
          ( topolo1002775350975398744n_open(A,S2)
         => ( member(A,Xa,S2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),Y)
             => ? [B4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Xa),B4)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or7035219750837199246ssThan(A,Xa,B4)),S2) ) ) ) ) ) ).

% open_right
tff(fact_6096_open__dist,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [S2: set(A)] :
          ( topolo1002775350975398744n_open(A,S2)
        <=> ! [X4: A] :
              ( member(A,X4,S2)
             => ? [E3: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
                  & ! [Y5: A] :
                      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Y5,X4)),E3)
                     => member(A,Y5,S2) ) ) ) ) ) ).

% open_dist
tff(fact_6097_lim__explicit,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),F0: A] :
          ( filterlim(nat,A,F3,topolo7230453075368039082e_nhds(A,F0),at_top(nat))
        <=> ! [S9: set(A)] :
              ( topolo1002775350975398744n_open(A,S9)
             => ( member(A,F0,S9)
               => ? [N7: nat] :
                  ! [N5: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N5)
                   => member(A,aa(nat,A,F3,N5),S9) ) ) ) ) ) ).

% lim_explicit
tff(fact_6098_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [F6: filter(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( topolo3448309680560233919inuous(A,B,F6,G)
           => ( ( aa(A,B,G,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))) != zero_zero(B) )
             => topolo3448309680560233919inuous(A,B,F6,aa(fun(A,B),fun(A,B),aTP_Lamp_vu(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% continuous_divide
tff(fact_6099_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( ( aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_vw(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_inverse
tff(fact_6100_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( ( aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_vx(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_sgn
tff(fact_6101_continuous__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [F6: filter(A),F3: fun(A,B),N: int] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( ( aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F6,aa(int,fun(A,B),aTP_Lamp_vy(fun(A,B),fun(int,fun(A,B)),F3),N)) ) ) ) ).

% continuous_power_int
tff(fact_6102_at__within__nhd,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Xa: A,S2: set(A),T5: set(A),U2: set(A)] :
          ( member(A,Xa,S2)
         => ( topolo1002775350975398744n_open(A,S2)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),T5),S2)),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U2),S2)),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) )
             => ( topolo174197925503356063within(A,Xa,T5) = topolo174197925503356063within(A,Xa,U2) ) ) ) ) ) ).

% at_within_nhd
tff(fact_6103_continuous__powr,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => ( topolo3448309680560233919inuous(A,real,F6,G)
           => ( ( aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))) != zero_zero(real) )
             => topolo3448309680560233919inuous(A,real,F6,aa(fun(A,real),fun(A,real),aTP_Lamp_ww(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_powr
tff(fact_6104_continuous__ln,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => ( ( aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))) != zero_zero(real) )
           => topolo3448309680560233919inuous(A,real,F6,aTP_Lamp_wx(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_ln
tff(fact_6105_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F6: filter(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F6,F3)
         => ( ( aa(A,A,cos(A),aa(A,A,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yp(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F6,aTP_Lamp_us(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_tan
tff(fact_6106_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [F6: filter(A),F3: fun(A,A)] :
          ( topolo3448309680560233919inuous(A,A,F6,F3)
         => ( ( aa(A,A,sin(A),aa(A,A,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yp(A,A)))) != zero_zero(A) )
           => topolo3448309680560233919inuous(A,A,F6,aTP_Lamp_ui(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_cot
tff(fact_6107_continuous__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [F6: filter(A),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,F6,F3)
         => ( ( aa(B,B,cosh(B),aa(A,B,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A)))) != zero_zero(B) )
           => topolo3448309680560233919inuous(A,B,F6,aTP_Lamp_wd(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_tanh
tff(fact_6108_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))))
           => topolo3448309680560233919inuous(A,real,F6,aTP_Lamp_yq(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_arcosh
tff(fact_6109_tendsto__offset__zero__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C)
        & zero(A) )
     => ! [A2: B,S2: set(B),F3: fun(B,C),L5: C] :
          ( nO_MATCH(A,B,zero_zero(A),A2)
         => ( member(B,A2,S2)
           => ( topolo1002775350975398744n_open(B,S2)
             => ( filterlim(B,C,F3,topolo7230453075368039082e_nhds(C,L5),topolo174197925503356063within(B,A2,S2))
              <=> filterlim(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_vr(B,fun(fun(B,C),fun(B,C)),A2),F3),topolo7230453075368039082e_nhds(C,L5),topolo174197925503356063within(B,zero_zero(B),top_top(set(B)))) ) ) ) ) ) ).

% tendsto_offset_zero_iff
tff(fact_6110_continuous__log,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => ( topolo3448309680560233919inuous(A,real,F6,G)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))))
             => ( ( aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))) != one_one(real) )
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))))
                 => topolo3448309680560233919inuous(A,real,F6,aa(fun(A,real),fun(A,real),aTP_Lamp_xl(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% continuous_log
tff(fact_6111_continuous__artanh,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => ( member(real,aa(A,real,F3,topolo3827282254853284352ce_Lim(A,A,F6,aTP_Lamp_yo(A,A))),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)))
           => topolo3448309680560233919inuous(A,real,F6,aTP_Lamp_yr(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_artanh
tff(fact_6112_tendsto__arctan__at__bot,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),at_bot(real)) ).

% tendsto_arctan_at_bot
tff(fact_6113_tendsto__exp__limit__at__right,axiom,
    ! [Xa: real] : filterlim(real,real,aTP_Lamp_ys(real,fun(real,real),Xa),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),Xa)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% tendsto_exp_limit_at_right
tff(fact_6114_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_greaterThan(A,Xa)),set_ord_greaterThan(A,Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ).

% greaterThan_subset_iff
tff(fact_6115_ln__at__0,axiom,
    filterlim(real,real,ln_ln(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% ln_at_0
tff(fact_6116_artanh__real__at__right__1,axiom,
    filterlim(real,real,artanh(real),at_bot(real),topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),one_one(real)),set_ord_greaterThan(real,aa(real,real,uminus_uminus(real),one_one(real))))) ).

% artanh_real_at_right_1
tff(fact_6117_sinh__real__at__bot,axiom,
    filterlim(real,real,sinh(real),at_bot(real),at_bot(real)) ).

% sinh_real_at_bot
tff(fact_6118_arsinh__real__at__bot,axiom,
    filterlim(real,real,arsinh(real),at_bot(real),at_bot(real)) ).

% arsinh_real_at_bot
tff(fact_6119_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F3: fun(real,A),F6: filter(A),A2: real] :
      ( filterlim(real,A,F3,F6,topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2)))
    <=> filterlim(real,A,aa(real,fun(real,A),aTP_Lamp_yt(fun(real,A),fun(real,fun(real,A)),F3),A2),F6,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% filterlim_at_right_to_0
tff(fact_6120_filterlim__tan__at__right,axiom,
    filterlim(real,real,tan(real),at_bot(real),topolo174197925503356063within(real,aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))),set_ord_greaterThan(real,aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))))) ).

% filterlim_tan_at_right
tff(fact_6121_exp__at__bot,axiom,
    filterlim(real,real,exp(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_bot(real)) ).

% exp_at_bot
tff(fact_6122_filterlim__inverse__at__bot__neg,axiom,
    filterlim(real,real,inverse_inverse(real),at_bot(real),topolo174197925503356063within(real,zero_zero(real),set_ord_lessThan(real,zero_zero(real)))) ).

% filterlim_inverse_at_bot_neg
tff(fact_6123_filterlim__times__pos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field(B)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),P2: B,F12: filter(A),C2: B,L: B] :
          ( filterlim(A,B,F3,topolo174197925503356063within(B,P2,set_ord_greaterThan(B,P2)),F12)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),zero_zero(B)),C2)
           => ( ( L = aa(B,B,aa(B,fun(B,B),times_times(B),C2),P2) )
             => filterlim(A,B,aa(B,fun(A,B),aTP_Lamp_yu(fun(A,B),fun(B,fun(A,B)),F3),C2),topolo174197925503356063within(B,L,set_ord_greaterThan(B,L)),F12) ) ) ) ) ).

% filterlim_times_pos
tff(fact_6124_tanh__real__at__bot,axiom,
    filterlim(real,real,tanh(real),topolo7230453075368039082e_nhds(real,aa(real,real,uminus_uminus(real),one_one(real))),at_bot(real)) ).

% tanh_real_at_bot
tff(fact_6125_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F6: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_bot(real),F6)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_yv(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_bot(real),F6) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
tff(fact_6126_tendsto__arcosh__at__left__1,axiom,
    filterlim(real,real,arcosh(real),topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,one_one(real),set_ord_greaterThan(real,one_one(real)))) ).

% tendsto_arcosh_at_left_1
tff(fact_6127_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [A2: A,G: fun(A,B),F3: fun(A,B)] :
          ( topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,set_ord_lessThan(A,A2)),G)
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,aa(A,B,G,A2)),topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2)))
           => topolo3448309680560233919inuous(A,B,topolo174197925503356063within(A,A2,top_top(set(A))),aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_yw(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),A2),G),F3)) ) ) ) ).

% isCont_If_ge
tff(fact_6128_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F3: fun(real,real),Flim: real] :
      ( ! [X: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2)
         => ? [Y4: real] :
              ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y4) ) )
     => ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,Flim),at_bot(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),Flim),aa(real,real,F3,B2)) ) ) ).

% DERIV_pos_imp_increasing_at_bot
tff(fact_6129_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F3: fun(real,real),F6: filter(real)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( filterlim(real,real,F3,at_bot(real),F6)
       => ( ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_yx(nat,fun(fun(real,real),fun(real,real)),N),F3),at_bot(real),F6) ) ) ) ).

% filterlim_pow_at_bot_odd
tff(fact_6130_at__within__order,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Xa: A,S: set(A)] :
          ( ( top_top(set(A)) != aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))) )
         => ( topolo174197925503356063within(A,Xa,S) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_yy(A,fun(set(A),fun(A,filter(A))),Xa),S)),set_ord_greaterThan(A,Xa)))),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(A),set(filter(A)),image(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_yz(A,fun(set(A),fun(A,filter(A))),Xa),S)),set_ord_lessThan(A,Xa)))) ) ) ) ).

% at_within_order
tff(fact_6131_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F3: fun(real,real),F6: filter(real)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( filterlim(real,real,F3,at_bot(real),F6)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N)
         => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_yx(nat,fun(fun(real,real),fun(real,real)),N),F3),at_top(real),F6) ) ) ) ).

% filterlim_pow_at_bot_even
tff(fact_6132_principal__le__iff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),principal(A,A3)),principal(A,B3))
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ).

% principal_le_iff
tff(fact_6133_cosh__real__at__top,axiom,
    filterlim(real,real,cosh(real),at_top(real),at_top(real)) ).

% cosh_real_at_top
tff(fact_6134_sinh__real__at__top,axiom,
    filterlim(real,real,sinh(real),at_top(real),at_top(real)) ).

% sinh_real_at_top
tff(fact_6135_arcosh__real__at__top,axiom,
    filterlim(real,real,arcosh(real),at_top(real),at_top(real)) ).

% arcosh_real_at_top
tff(fact_6136_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,at_top(real),F6)
     => ( filterlim(A,real,G,at_top(real),F6)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_yv(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F6) ) ) ).

% filterlim_at_top_mult_at_top
tff(fact_6137_arsinh__real__at__top,axiom,
    filterlim(real,real,arsinh(real),at_top(real),at_top(real)) ).

% arsinh_real_at_top
tff(fact_6138_ln__at__top,axiom,
    filterlim(real,real,ln_ln(real),at_top(real),at_top(real)) ).

% ln_at_top
tff(fact_6139_exp__at__top,axiom,
    filterlim(real,real,exp(real),at_top(real),at_top(real)) ).

% exp_at_top
tff(fact_6140_cosh__real__at__bot,axiom,
    filterlim(real,real,cosh(real),at_top(real),at_bot(real)) ).

% cosh_real_at_bot
tff(fact_6141_greaterThan__0,axiom,
    set_ord_greaterThan(nat,zero_zero(nat)) = aa(set(nat),set(nat),image(nat,nat,suc),top_top(set(nat))) ).

% greaterThan_0
tff(fact_6142_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F3: fun(A,real),F6: filter(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( filterlim(A,real,F3,at_top(real),F6)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tm(nat,fun(fun(A,real),fun(A,real)),N),F3),at_top(real),F6) ) ) ).

% filterlim_pow_at_top
tff(fact_6143_tanh__real__at__top,axiom,
    filterlim(real,real,tanh(real),topolo7230453075368039082e_nhds(real,one_one(real)),at_top(real)) ).

% tanh_real_at_top
tff(fact_6144_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F6: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F6)
     => ( filterlim(A,real,G,at_top(real),F6)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_za(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ).

% real_tendsto_divide_at_top
tff(fact_6145_artanh__real__at__left__1,axiom,
    filterlim(real,real,artanh(real),at_top(real),topolo174197925503356063within(real,one_one(real),set_ord_lessThan(real,one_one(real)))) ).

% artanh_real_at_left_1
tff(fact_6146_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,F3,at_top(real),F6)
     => filterlim(A,real,aTP_Lamp_zb(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ).

% tendsto_inverse_0_at_top
tff(fact_6147_greaterThan__Suc,axiom,
    ! [K: nat] : ( set_ord_greaterThan(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_greaterThan(nat,K)),aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,K)),bot_bot(set(nat)))) ) ).

% greaterThan_Suc
tff(fact_6148_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F6: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_top(real),F6)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_yv(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F6) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
tff(fact_6149_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F6: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),C2)
       => ( filterlim(A,real,G,at_top(real),F6)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zc(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F6) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
tff(fact_6150_tendsto__neg__powr,axiom,
    ! [A: $tType,S: real,F3: fun(A,real),F6: filter(A)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),S),zero_zero(real))
     => ( filterlim(A,real,F3,at_top(real),F6)
       => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zd(real,fun(fun(A,real),fun(A,real)),S),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ).

% tendsto_neg_powr
tff(fact_6151_ln__x__over__x__tendsto__0,axiom,
    filterlim(real,real,aTP_Lamp_ze(real,real),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% ln_x_over_x_tendsto_0
tff(fact_6152_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F3: fun(real,A),F6: filter(A)] :
      ( filterlim(real,A,F3,F6,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
    <=> filterlim(real,A,aTP_Lamp_zf(fun(real,A),fun(real,A),F3),F6,at_top(real)) ) ).

% filterlim_at_right_to_top
tff(fact_6153_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F3: fun(real,A),F6: filter(A)] :
      ( filterlim(real,A,F3,F6,at_top(real))
    <=> filterlim(real,A,aTP_Lamp_zf(fun(real,A),fun(real,A),F3),F6,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% filterlim_at_top_to_right
tff(fact_6154_filterlim__inverse__at__right__top,axiom,
    filterlim(real,real,inverse_inverse(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))),at_top(real)) ).

% filterlim_inverse_at_right_top
tff(fact_6155_filterlim__inverse__at__top__right,axiom,
    filterlim(real,real,inverse_inverse(real),at_top(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% filterlim_inverse_at_top_right
tff(fact_6156_filterlim__base__iff,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,I5: set(A),F6: fun(A,set(B)),F3: fun(B,C),G5: fun(D,set(C)),J4: set(D)] :
      ( ( I5 != bot_bot(set(A)) )
     => ( ! [I2: A] :
            ( member(A,I2,I5)
           => ! [J2: A] :
                ( member(A,J2,I5)
               => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F6,I2)),aa(A,set(B),F6,J2))
                  | aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),F6,J2)),aa(A,set(B),F6,I2)) ) ) )
       => ( filterlim(B,C,F3,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(D),set(filter(C)),image(D,filter(C),aTP_Lamp_zg(fun(D,set(C)),fun(D,filter(C)),G5)),J4)),aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),aTP_Lamp_zh(fun(A,set(B)),fun(A,filter(B)),F6)),I5)))
        <=> ! [X4: D] :
              ( member(D,X4,J4)
             => ? [Xa3: A] :
                  ( member(A,Xa3,I5)
                  & ! [Xb4: B] :
                      ( member(B,Xb4,aa(A,set(B),F6,Xa3))
                     => member(C,aa(B,C,F3,Xb4),aa(D,set(C),G5,X4)) ) ) ) ) ) ) ).

% filterlim_base_iff
tff(fact_6157_at__within__def,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A2: A,S: set(A)] : ( topolo174197925503356063within(A,A2,S) = aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),topolo7230453075368039082e_nhds(A,A2)),principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% at_within_def
tff(fact_6158_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),C2: real,F6: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),zero_zero(real))
       => ( filterlim(A,real,G,at_top(real),F6)
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_yv(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_bot(real),F6) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
tff(fact_6159_tendsto__power__div__exp__0,axiom,
    ! [K: nat] : filterlim(real,real,aTP_Lamp_zi(nat,fun(real,real),K),topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(real)) ).

% tendsto_power_div_exp_0
tff(fact_6160_nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Xa: A] : ( topolo7230453075368039082e_nhds(A,Xa) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(real),set(filter(A)),image(real,filter(A),aTP_Lamp_zk(A,fun(real,filter(A)),Xa)),set_ord_greaterThan(real,zero_zero(real)))) ) ) ).

% nhds_metric
tff(fact_6161_tendsto__exp__limit__at__top,axiom,
    ! [Xa: real] : filterlim(real,real,aTP_Lamp_zl(real,fun(real,real),Xa),topolo7230453075368039082e_nhds(real,aa(real,real,exp(real),Xa)),at_top(real)) ).

% tendsto_exp_limit_at_top
tff(fact_6162_at__within__eq,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Xa: A,S: set(A)] : ( topolo174197925503356063within(A,Xa,S) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(set(A)),set(filter(A)),image(set(A),filter(A),aa(set(A),fun(set(A),filter(A)),aTP_Lamp_zm(A,fun(set(A),fun(set(A),filter(A))),Xa),S)),collect(set(A),aTP_Lamp_zn(A,fun(set(A),$o),Xa)))) ) ) ).

% at_within_eq
tff(fact_6163_filterlim__tan__at__left,axiom,
    filterlim(real,real,tan(real),at_top(real),topolo174197925503356063within(real,divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))),set_ord_lessThan(real,divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))))) ).

% filterlim_tan_at_left
tff(fact_6164_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F3: fun(real,real),Flim: real] :
      ( ! [X: real] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),X)
         => ? [Y4: real] :
              ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),zero_zero(real)) ) )
     => ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,Flim),at_top(real))
       => aa(real,$o,aa(real,fun(real,$o),ord_less(real),Flim),aa(real,real,F3,B2)) ) ) ).

% DERIV_neg_imp_decreasing_at_top
tff(fact_6165_tendsto__arctan__at__top,axiom,
    filterlim(real,real,arctan,topolo7230453075368039082e_nhds(real,divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2)))),at_top(real)) ).

% tendsto_arctan_at_top
tff(fact_6166_lhopital__left__at__top,axiom,
    ! [G: fun(real,real),Xa: real,G3: fun(real,real),F3: fun(real,real),F9: fun(real,real),Y: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
     => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa))) ) ) ) ) ) ).

% lhopital_left_at_top
tff(fact_6167_lhopital__right__0__at__top,axiom,
    ! [G: fun(real,real),G3: fun(real,real),F3: fun(real,real),F9: fun(real,real),Xa: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
     => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),topolo7230453075368039082e_nhds(real,Xa),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Xa),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ) ) ) ) ).

% lhopital_right_0_at_top
tff(fact_6168_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aa(A,fun(A,$o),ord_less_eq(A),C2),at_top(A)) ) ).

% eventually_ge_at_top
tff(fact_6169_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A,P: fun(A,$o)] :
          ( ! [X: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),X)
             => aa(A,$o,P,X) )
         => eventually(A,P,at_top(A)) ) ) ).

% eventually_at_top_linorderI
tff(fact_6170_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_top(A))
        <=> ? [N7: A] :
            ! [N5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),N7),N5)
             => aa(A,$o,P,N5) ) ) ) ).

% eventually_at_top_linorder
tff(fact_6171_le__filter__def,axiom,
    ! [A: $tType,F6: filter(A),F10: filter(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10)
    <=> ! [P6: fun(A,$o)] :
          ( eventually(A,P6,F10)
         => eventually(A,P6,F6) ) ) ).

% le_filter_def
tff(fact_6172_filter__leI,axiom,
    ! [A: $tType,F10: filter(A),F6: filter(A)] :
      ( ! [P7: fun(A,$o)] :
          ( eventually(A,P7,F10)
         => eventually(A,P7,F6) )
     => aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10) ) ).

% filter_leI
tff(fact_6173_filter__leD,axiom,
    ! [A: $tType,F6: filter(A),F10: filter(A),P: fun(A,$o)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10)
     => ( eventually(A,P,F10)
       => eventually(A,P,F6) ) ) ).

% filter_leD
tff(fact_6174_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_bot(A))
        <=> ? [N7: A] :
            ! [N5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),N5),N7)
             => aa(A,$o,P,N5) ) ) ) ).

% eventually_at_bot_linorder
tff(fact_6175_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [C2: A] : eventually(A,aa(A,fun(A,$o),aTP_Lamp_zr(A,fun(A,$o)),C2),at_bot(A)) ) ).

% eventually_le_at_bot
tff(fact_6176_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),F6: filter(B),G5: filter(A),F10: filter(B),G6: filter(A),F9: fun(A,B)] :
      ( filterlim(A,B,F3,F6,G5)
     => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),F6),F10)
       => ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),G6),G5)
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_zs(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),F9),G6)
           => filterlim(A,B,F9,F10,G6) ) ) ) ) ).

% filterlim_mono_eventually
tff(fact_6177_le__principal,axiom,
    ! [A: $tType,F6: filter(A),A3: set(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),principal(A,A3))
    <=> eventually(A,aTP_Lamp_a(set(A),fun(A,$o),A3),F6) ) ).

% le_principal
tff(fact_6178_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & linorder(B) )
     => ! [Q: fun(A,$o),F3: fun(A,B),P: fun(B,$o),G: fun(B,A)] :
          ( ! [X: A,Y3: A] :
              ( aa(A,$o,Q,X)
             => ( aa(A,$o,Q,Y3)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) ) ) )
         => ( ! [X: B] :
                ( aa(B,$o,P,X)
               => ( aa(A,B,F3,aa(B,A,G,X)) = X ) )
           => ( ! [X: B] :
                  ( aa(B,$o,P,X)
                 => aa(A,$o,Q,aa(B,A,G,X)) )
             => ( eventually(A,Q,at_top(A))
               => ( eventually(B,P,at_top(B))
                 => filterlim(A,B,F3,at_top(B),at_top(A)) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
tff(fact_6179_tendsto__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),G: fun(A,B),Net: filter(A),H: fun(A,B),C2: B] :
          ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_zt(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),Net)
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_zt(fun(A,B),fun(fun(A,B),fun(A,$o)),G),H),Net)
           => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),Net)
             => ( filterlim(A,B,H,topolo7230453075368039082e_nhds(B,C2),Net)
               => filterlim(A,B,G,topolo7230453075368039082e_nhds(B,C2),Net) ) ) ) ) ) ).

% tendsto_sandwich
tff(fact_6180_filterlim__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( filterlim(A,B,F3,at_top(B),F6)
        <=> ! [Z8: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_zu(fun(A,B),fun(B,fun(A,$o)),F3),Z8),F6) ) ) ).

% filterlim_at_top
tff(fact_6181_filterlim__at__top__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_top(B),F6)
        <=> ! [Z8: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),C2),Z8)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_zu(fun(A,B),fun(B,fun(A,$o)),F3),Z8),F6) ) ) ) ).

% filterlim_at_top_ge
tff(fact_6182_filterlim__at__top__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,at_top(B),F6)
         => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_zv(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),F6)
           => filterlim(A,B,G,at_top(B),F6) ) ) ) ).

% filterlim_at_top_mono
tff(fact_6183_filterlim__at__bot,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( filterlim(A,B,F3,at_bot(B),F6)
        <=> ! [Z8: B] : eventually(A,aa(B,fun(A,$o),aTP_Lamp_zw(fun(A,B),fun(B,fun(A,$o)),F3),Z8),F6) ) ) ).

% filterlim_at_bot
tff(fact_6184_filterlim__at__bot__le,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_bot(B),F6)
        <=> ! [Z8: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Z8),C2)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_zw(fun(A,B),fun(B,fun(A,$o)),F3),Z8),F6) ) ) ) ).

% filterlim_at_bot_le
tff(fact_6185_real__tendsto__sandwich,axiom,
    ! [A: $tType,F3: fun(A,real),G: fun(A,real),Net: filter(A),H: fun(A,real),C2: real] :
      ( eventually(A,aa(fun(A,real),fun(A,$o),aTP_Lamp_zx(fun(A,real),fun(fun(A,real),fun(A,$o)),F3),G),Net)
     => ( eventually(A,aa(fun(A,real),fun(A,$o),aTP_Lamp_zx(fun(A,real),fun(fun(A,real),fun(A,$o)),G),H),Net)
       => ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,C2),Net)
         => ( filterlim(A,real,H,topolo7230453075368039082e_nhds(real,C2),Net)
           => filterlim(A,real,G,topolo7230453075368039082e_nhds(real,C2),Net) ) ) ) ) ).

% real_tendsto_sandwich
tff(fact_6186_eventually__Inf__base,axiom,
    ! [A: $tType,B3: set(filter(A)),P: fun(A,$o)] :
      ( ( B3 != bot_bot(set(filter(A))) )
     => ( ! [F7: filter(A)] :
            ( member(filter(A),F7,B3)
           => ! [G2: filter(A)] :
                ( member(filter(A),G2,B3)
               => ? [X3: filter(A)] :
                    ( member(filter(A),X3,B3)
                    & aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),X3),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),F7),G2)) ) ) )
       => ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3))
        <=> ? [X4: filter(A)] :
              ( member(filter(A),X4,B3)
              & eventually(A,P,X4) ) ) ) ) ).

% eventually_Inf_base
tff(fact_6187_eventually__at,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A,S2: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,S2))
        <=> ? [D4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
              & ! [X4: A] :
                  ( member(A,X4,S2)
                 => ( ( ( X4 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),D4) )
                   => aa(A,$o,P,X4) ) ) ) ) ) ).

% eventually_at
tff(fact_6188_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A] :
          ( eventually(A,P,topolo7230453075368039082e_nhds(A,A2))
        <=> ? [D4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
              & ! [X4: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,A2)),D4)
                 => aa(A,$o,P,X4) ) ) ) ) ).

% eventually_nhds_metric
tff(fact_6189_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P: fun(A,$o),A2: A] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,top_top(set(A))))
        <=> eventually(A,aa(A,fun(A,$o),aTP_Lamp_zy(fun(A,$o),fun(A,fun(A,$o)),P),A2),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% eventually_at_to_0
tff(fact_6190_increasing__tendsto,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_zz(fun(A,B),fun(B,fun(A,$o)),F3),L),F6)
         => ( ! [X: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),X),L)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aaa(fun(A,B),fun(B,fun(A,$o)),F3),X),F6) )
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6) ) ) ) ).

% increasing_tendsto
tff(fact_6191_decreasing__tendsto,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [L: B,F3: fun(A,B),F6: filter(A)] :
          ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aab(B,fun(fun(A,B),fun(A,$o)),L),F3),F6)
         => ( ! [X: B] :
                ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),L),X)
               => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aac(fun(A,B),fun(B,fun(A,$o)),F3),X),F6) )
           => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6) ) ) ) ).

% decreasing_tendsto
tff(fact_6192_filterlim__at__top__gt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F3: fun(A,B),F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_top(B),F6)
        <=> ! [Z8: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),C2),Z8)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aad(fun(A,B),fun(B,fun(A,$o)),F3),Z8),F6) ) ) ) ).

% filterlim_at_top_gt
tff(fact_6193_filterlim__at__bot__lt,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [F3: fun(A,B),F6: filter(A),C2: B] :
          ( filterlim(A,B,F3,at_bot(B),F6)
        <=> ! [Z8: B] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),Z8),C2)
             => eventually(A,aa(B,fun(A,$o),aTP_Lamp_aae(fun(A,B),fun(B,fun(A,$o)),F3),Z8),F6) ) ) ) ).

% filterlim_at_bot_lt
tff(fact_6194_tendsto__le,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [F6: filter(A),F3: fun(A,B),Xa: B,G: fun(A,B),Y: B] :
          ( ( F6 != bot_bot(filter(A)) )
         => ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,Xa),F6)
           => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,Y),F6)
             => ( eventually(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aaf(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G),F6)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Y),Xa) ) ) ) ) ) ).

% tendsto_le
tff(fact_6195_tendsto__lowerbound,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [F3: fun(A,B),Xa: B,F6: filter(A),A2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,Xa),F6)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_aag(fun(A,B),fun(B,fun(A,$o)),F3),A2),F6)
           => ( ( F6 != bot_bot(filter(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),Xa) ) ) ) ) ).

% tendsto_lowerbound
tff(fact_6196_tendsto__upperbound,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [F3: fun(A,B),Xa: B,F6: filter(A),A2: B] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,Xa),F6)
         => ( eventually(A,aa(B,fun(A,$o),aTP_Lamp_aah(fun(A,B),fun(B,fun(A,$o)),F3),A2),F6)
           => ( ( F6 != bot_bot(filter(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Xa),A2) ) ) ) ) ).

% tendsto_upperbound
tff(fact_6197_metric__tendsto__imp__tendsto,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(C)
        & real_V7819770556892013058_space(B) )
     => ! [F3: fun(A,B),A2: B,F6: filter(A),G: fun(A,C),B2: C] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( eventually(A,aa(C,fun(A,$o),aa(fun(A,C),fun(C,fun(A,$o)),aa(B,fun(fun(A,C),fun(C,fun(A,$o))),aTP_Lamp_aai(fun(A,B),fun(B,fun(fun(A,C),fun(C,fun(A,$o)))),F3),A2),G),B2),F6)
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,B2),F6) ) ) ) ).

% metric_tendsto_imp_tendsto
tff(fact_6198_eventually__at__right__to__0,axiom,
    ! [P: fun(real,$o),A2: real] :
      ( eventually(real,P,topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2)))
    <=> eventually(real,aa(real,fun(real,$o),aTP_Lamp_aaj(fun(real,$o),fun(real,fun(real,$o)),P),A2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% eventually_at_right_to_0
tff(fact_6199_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: fun(A,$o),F6: fun(B,filter(A)),B3: set(B)] :
      ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),F6),B3)))
    <=> ? [X9: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X9),B3)
          & aa(set(B),$o,finite_finite(B),X9)
          & eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),F6),X9))) ) ) ).

% eventually_INF
tff(fact_6200_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [F6: filter(A),F3: fun(A,real)] :
          ( topolo3448309680560233919inuous(A,real,F6,F3)
         => ( eventually(A,aTP_Lamp_aak(fun(A,real),fun(A,$o),F3),F6)
           => topolo3448309680560233919inuous(A,real,F6,aTP_Lamp_yq(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_arcosh_strong
tff(fact_6201_eventually__at__le,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [P: fun(A,$o),A2: A,S2: set(A)] :
          ( eventually(A,P,topolo174197925503356063within(A,A2,S2))
        <=> ? [D4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
              & ! [X4: A] :
                  ( member(A,X4,S2)
                 => ( ( ( X4 != A2 )
                      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(A,X4,A2)),D4) )
                   => aa(A,$o,P,X4) ) ) ) ) ) ).

% eventually_at_le
tff(fact_6202_tendstoD,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A),E: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E)
           => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aal(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),L),E),F6) ) ) ) ).

% tendstoD
tff(fact_6203_tendstoI,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( ! [E2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E2)
             => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aal(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),L),E2),F6) )
         => filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6) ) ) ).

% tendstoI
tff(fact_6204_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),L: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,L),F6)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aal(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),L),E3),F6) ) ) ) ).

% tendsto_iff
tff(fact_6205_eventually__Inf,axiom,
    ! [A: $tType,P: fun(A,$o),B3: set(filter(A))] :
      ( eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),B3))
    <=> ? [X9: set(filter(A))] :
          ( aa(set(filter(A)),$o,aa(set(filter(A)),fun(set(filter(A)),$o),ord_less_eq(set(filter(A))),X9),B3)
          & aa(set(filter(A)),$o,finite_finite(filter(A)),X9)
          & eventually(A,P,aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),X9)) ) ) ).

% eventually_Inf
tff(fact_6206_eventually__at__right__to__top,axiom,
    ! [P: fun(real,$o)] :
      ( eventually(real,P,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
    <=> eventually(real,aTP_Lamp_aam(fun(real,$o),fun(real,$o),P),at_top(real)) ) ).

% eventually_at_right_to_top
tff(fact_6207_eventually__at__top__to__right,axiom,
    ! [P: fun(real,$o)] :
      ( eventually(real,P,at_top(real))
    <=> eventually(real,aTP_Lamp_aam(fun(real,$o),fun(real,$o),P),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% eventually_at_top_to_right
tff(fact_6208_tendsto__arcosh__strong,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),A2)
       => ( eventually(A,aTP_Lamp_aan(fun(A,real),fun(A,$o),F3),F6)
         => filterlim(A,real,aTP_Lamp_tu(fun(A,real),fun(A,real),F3),topolo7230453075368039082e_nhds(real,aa(real,real,arcosh(real),A2)),F6) ) ) ) ).

% tendsto_arcosh_strong
tff(fact_6209_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,$o),F3: fun(A,B),P: fun(B,$o),G: fun(B,A),A2: A] :
          ( ! [X: A,Y3: A] :
              ( aa(A,$o,Q,X)
             => ( aa(A,$o,Q,Y3)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) ) ) )
         => ( ! [X: B] :
                ( aa(B,$o,P,X)
               => ( aa(A,B,F3,aa(B,A,G,X)) = X ) )
           => ( ! [X: B] :
                  ( aa(B,$o,P,X)
                 => aa(A,$o,Q,aa(B,A,G,X)) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A2,set_ord_lessThan(A,A2)))
               => ( ! [B4: A] :
                      ( aa(A,$o,Q,B4)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),B4),A2) )
                 => ( eventually(B,P,at_top(B))
                   => filterlim(A,B,F3,at_top(B),topolo174197925503356063within(A,A2,set_ord_lessThan(A,A2))) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
tff(fact_6210_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B3: set(A),F6: fun(A,filter(B)),P: fun(B,$o)] :
      ( ( B3 != bot_bot(set(A)) )
     => ( ! [A4: A] :
            ( member(A,A4,B3)
           => ! [B4: A] :
                ( member(A,B4,B3)
               => ? [X3: A] :
                    ( member(A,X3,B3)
                    & aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),aa(A,filter(B),F6,X3)),aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),aa(A,filter(B),F6,A4)),aa(A,filter(B),F6,B4))) ) ) )
       => ( eventually(B,P,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(A),set(filter(B)),image(A,filter(B),F6),B3)))
        <=> ? [X4: A] :
              ( member(A,X4,B3)
              & eventually(B,P,aa(A,filter(B),F6,X4)) ) ) ) ) ).

% eventually_INF_base
tff(fact_6211_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & linorder(B) )
     => ! [Q: fun(A,$o),F3: fun(A,B),P: fun(B,$o),G: fun(B,A),A2: A] :
          ( ! [X: A,Y3: A] :
              ( aa(A,$o,Q,X)
             => ( aa(A,$o,Q,Y3)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) ) ) )
         => ( ! [X: B] :
                ( aa(B,$o,P,X)
               => ( aa(A,B,F3,aa(B,A,G,X)) = X ) )
           => ( ! [X: B] :
                  ( aa(B,$o,P,X)
                 => aa(A,$o,Q,aa(B,A,G,X)) )
             => ( eventually(A,Q,topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2)))
               => ( ! [B4: A] :
                      ( aa(A,$o,Q,B4)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B4) )
                 => ( eventually(B,P,at_bot(B))
                   => filterlim(A,B,F3,at_bot(B),topolo174197925503356063within(A,A2,set_ord_greaterThan(A,A2))) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
tff(fact_6212_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,C),K6: real] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
         => ( eventually(A,aa(real,fun(A,$o),aa(fun(A,C),fun(real,fun(A,$o)),aTP_Lamp_aao(fun(A,B),fun(fun(A,C),fun(real,fun(A,$o))),F3),G),K6),F6)
           => filterlim(A,C,G,topolo7230453075368039082e_nhds(C,zero_zero(C)),F6) ) ) ) ).

% tendsto_0_le
tff(fact_6213_filterlim__at__withinI,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [F3: fun(A,B),C2: B,F6: filter(A),A3: set(B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F6)
         => ( eventually(A,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_aap(fun(A,B),fun(B,fun(set(B),fun(A,$o))),F3),C2),A3),F6)
           => filterlim(A,B,F3,topolo174197925503356063within(B,C2,A3),F6) ) ) ) ).

% filterlim_at_withinI
tff(fact_6214_tendsto__powr_H,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F6)
       => ( ( ( A2 != zero_zero(real) )
            | ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
              & eventually(A,aTP_Lamp_aaq(fun(A,real),fun(A,$o),F3),F6) ) )
         => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_uo(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,aa(real,real,aa(real,fun(real,real),powr(real),A2),B2)),F6) ) ) ) ).

% tendsto_powr'
tff(fact_6215_tendsto__powr2,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F6)
       => ( eventually(A,aTP_Lamp_aaq(fun(A,real),fun(A,$o),F3),F6)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_uo(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,aa(real,real,aa(real,fun(real,real),powr(real),A2),B2)),F6) ) ) ) ) ).

% tendsto_powr2
tff(fact_6216_tendsto__zero__powrI,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A),G: fun(A,real),B2: real] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
     => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,B2),F6)
       => ( eventually(A,aTP_Lamp_aaq(fun(A,real),fun(A,$o),F3),F6)
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B2)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_uo(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ) ) ).

% tendsto_zero_powrI
tff(fact_6217_LIM__at__top__divide,axiom,
    ! [A: $tType,F3: fun(A,real),A2: real,F6: filter(A),G: fun(A,real)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,A2),F6)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),A2)
       => ( filterlim(A,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
         => ( eventually(A,aTP_Lamp_aar(fun(A,real),fun(A,$o),G),F6)
           => filterlim(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_za(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G),at_top(real),F6) ) ) ) ) ).

% LIM_at_top_divide
tff(fact_6218_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( eventually(A,aTP_Lamp_aar(fun(A,real),fun(A,$o),F3),F6)
     => ( filterlim(A,real,F3,at_top(real),F6)
      <=> filterlim(A,real,aa(fun(A,real),fun(A,real),comp(real,real,A,inverse_inverse(real)),F3),topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ).

% filterlim_at_top_iff_inverse_0
tff(fact_6219_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( eventually(A,aTP_Lamp_aar(fun(A,real),fun(A,$o),F3),F6)
     => ( filterlim(A,real,aTP_Lamp_zb(fun(A,real),fun(A,real),F3),at_top(real),F6)
      <=> filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6) ) ) ).

% filterlim_inverse_at_top_iff
tff(fact_6220_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
     => ( eventually(A,aTP_Lamp_aar(fun(A,real),fun(A,$o),F3),F6)
       => filterlim(A,real,aTP_Lamp_zb(fun(A,real),fun(A,real),F3),at_top(real),F6) ) ) ).

% filterlim_inverse_at_top
tff(fact_6221_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),F6)
     => ( eventually(A,aTP_Lamp_aas(fun(A,real),fun(A,$o),F3),F6)
       => filterlim(A,real,aTP_Lamp_zb(fun(A,real),fun(A,real),F3),at_bot(real),F6) ) ) ).

% filterlim_inverse_at_bot
tff(fact_6222_lhopital,axiom,
    ! [F3: fun(real,real),Xa: real,G: fun(real,real),G3: fun(real,real),F9: fun(real,real),F6: filter(real)] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,Xa,top_top(set(real))))
       => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,Xa,top_top(set(real))))
         => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,Xa,top_top(set(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),topolo174197925503356063within(real,Xa,top_top(set(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),topolo174197925503356063within(real,Xa,top_top(set(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),F6,topolo174197925503356063within(real,Xa,top_top(set(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aat(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),F6,topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ) ) ) ) ).

% lhopital
tff(fact_6223_lhopital__at__top,axiom,
    ! [G: fun(real,real),Xa: real,G3: fun(real,real),F3: fun(real,real),F9: fun(real,real),Y: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,Xa,top_top(set(real))))
     => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,Xa,top_top(set(real))))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),topolo174197925503356063within(real,Xa,top_top(set(real))))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),topolo174197925503356063within(real,Xa,top_top(set(real))))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,Xa,top_top(set(real))))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,Xa,top_top(set(real)))) ) ) ) ) ) ).

% lhopital_at_top
tff(fact_6224_lhospital__at__top__at__top,axiom,
    ! [G: fun(real,real),G3: fun(real,real),F3: fun(real,real),F9: fun(real,real),Xa: real] :
      ( filterlim(real,real,G,at_top(real),at_top(real))
     => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),at_top(real))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),at_top(real))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),at_top(real))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),topolo7230453075368039082e_nhds(real,Xa),at_top(real))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Xa),at_top(real)) ) ) ) ) ) ).

% lhospital_at_top_at_top
tff(fact_6225_lhopital__right,axiom,
    ! [F3: fun(real,real),Xa: real,G: fun(real,real),G3: fun(real,real),F9: fun(real,real),F6: filter(real)] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
       => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
         => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),F6,topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aat(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),F6,topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa))) ) ) ) ) ) ) ) ).

% lhopital_right
tff(fact_6226_lhopital__right__0,axiom,
    ! [F0: fun(real,real),G0: fun(real,real),G3: fun(real,real),F9: fun(real,real),F6: filter(real)] :
      ( filterlim(real,real,F0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
     => ( filterlim(real,real,G0,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
       => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G0),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
         => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F0),F9),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G0),G3),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),F6,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aat(fun(real,real),fun(fun(real,real),fun(real,real)),F0),G0),F6,topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ) ) ) ) ) ) ).

% lhopital_right_0
tff(fact_6227_lhopital__left,axiom,
    ! [F3: fun(real,real),Xa: real,G: fun(real,real),G3: fun(real,real),F9: fun(real,real),F6: filter(real)] :
      ( filterlim(real,real,F3,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
     => ( filterlim(real,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
       => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
         => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
           => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
             => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
               => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),F6,topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa)))
                 => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aat(fun(real,real),fun(fun(real,real),fun(real,real)),F3),G),F6,topolo174197925503356063within(real,Xa,set_ord_lessThan(real,Xa))) ) ) ) ) ) ) ) ).

% lhopital_left
tff(fact_6228_lhopital__right__at__top,axiom,
    ! [G: fun(real,real),Xa: real,G3: fun(real,real),F3: fun(real,real),F9: fun(real,real),Y: real] :
      ( filterlim(real,real,G,at_top(real),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
     => ( eventually(real,aTP_Lamp_zo(fun(real,real),fun(real,$o),G3),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
       => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),F3),F9),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
         => ( eventually(real,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),G),G3),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
           => ( filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G3),F9),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa)))
             => filterlim(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),G),F3),topolo7230453075368039082e_nhds(real,Y),topolo174197925503356063within(real,Xa,set_ord_greaterThan(real,Xa))) ) ) ) ) ) ).

% lhopital_right_at_top
tff(fact_6229_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [C2: fun(nat,A),K: nat,N: nat,B3: real] :
          ( ( aa(nat,A,C2,K) != zero_zero(A) )
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),K)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N)
             => eventually(A,aa(real,fun(A,$o),aa(nat,fun(real,fun(A,$o)),aTP_Lamp_aau(fun(nat,A),fun(nat,fun(real,fun(A,$o))),C2),N),B3),at_infinity(A)) ) ) ) ) ).

% polyfun_extremal
tff(fact_6230_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( bfun(A,B,F3,F6)
        <=> ? [Y5: B,K5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K5)
              & eventually(A,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aav(fun(A,B),fun(B,fun(real,fun(A,$o))),F3),Y5),K5),F6) ) ) ) ).

% Bfun_metric_def
tff(fact_6231_eventually__sequentially__Suc,axiom,
    ! [P: fun(nat,$o)] :
      ( eventually(nat,aTP_Lamp_aaw(fun(nat,$o),fun(nat,$o),P),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_Suc
tff(fact_6232_eventually__sequentially__seg,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( eventually(nat,aa(nat,fun(nat,$o),aTP_Lamp_aax(fun(nat,$o),fun(nat,fun(nat,$o)),P),K),at_top(nat))
    <=> eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentially_seg
tff(fact_6233_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(nat,A),G: fun(nat,B)] :
          ( eventually(nat,aa(fun(nat,B),fun(nat,$o),aTP_Lamp_aay(fun(nat,A),fun(fun(nat,B),fun(nat,$o)),F3),G),at_top(nat))
         => ( bfun(nat,B,G,at_top(nat))
           => bfun(nat,A,F3,at_top(nat)) ) ) ) ).

% Bseq_eventually_mono
tff(fact_6234_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: fun(nat,$o)] :
      ( ! [X: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),C2),X)
         => aa(nat,$o,P,X) )
     => eventually(nat,P,at_top(nat)) ) ).

% eventually_sequentiallyI
tff(fact_6235_eventually__sequentially,axiom,
    ! [P: fun(nat,$o)] :
      ( eventually(nat,P,at_top(nat))
    <=> ? [N7: nat] :
        ! [N5: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N5)
         => aa(nat,$o,P,N5) ) ) ).

% eventually_sequentially
tff(fact_6236_le__sequentially,axiom,
    ! [F6: filter(nat)] :
      ( aa(filter(nat),$o,aa(filter(nat),fun(filter(nat),$o),ord_less_eq(filter(nat)),F6),at_top(nat))
    <=> ! [N7: nat] : eventually(nat,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),F6) ) ).

% le_sequentially
tff(fact_6237_sequentially__offset,axiom,
    ! [P: fun(nat,$o),K: nat] :
      ( eventually(nat,P,at_top(nat))
     => eventually(nat,aa(nat,fun(nat,$o),aTP_Lamp_aax(fun(nat,$o),fun(nat,fun(nat,$o)),P),K),at_top(nat)) ) ).

% sequentially_offset
tff(fact_6238_at__bot__le__at__infinity,axiom,
    aa(filter(real),$o,aa(filter(real),fun(filter(real),$o),ord_less_eq(filter(real)),at_bot(real)),at_infinity(real)) ).

% at_bot_le_at_infinity
tff(fact_6239_at__top__le__at__infinity,axiom,
    aa(filter(real),$o,aa(filter(real),fun(filter(real),$o),ord_less_eq(filter(real)),at_top(real)),at_infinity(real)) ).

% at_top_le_at_infinity
tff(fact_6240_Bseq__mult,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(nat,A),G: fun(nat,A)] :
          ( bfun(nat,A,F3,at_top(nat))
         => ( bfun(nat,A,G,at_top(nat))
           => bfun(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aaz(fun(nat,A),fun(fun(nat,A),fun(nat,A)),F3),G),at_top(nat)) ) ) ) ).

% Bseq_mult
tff(fact_6241_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_aba(fun(nat,A),fun(A,fun(nat,A)),F3),C2),at_top(nat))
        <=> bfun(nat,A,F3,at_top(nat)) ) ) ).

% Bseq_add_iff
tff(fact_6242_Bseq__add,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( bfun(nat,A,F3,at_top(nat))
         => bfun(nat,A,aa(A,fun(nat,A),aTP_Lamp_aba(fun(nat,A),fun(A,fun(nat,A)),F3),C2),at_top(nat)) ) ) ).

% Bseq_add
tff(fact_6243_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A)] :
          ( bfun(nat,A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),F3),at_top(nat))
        <=> bfun(nat,A,F3,at_top(nat)) ) ) ).

% Bseq_Suc_iff
tff(fact_6244_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A),K: nat] :
          ( bfun(nat,A,X6,at_top(nat))
         => bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_abb(fun(nat,A),fun(nat,fun(nat,A)),X6),K),at_top(nat)) ) ) ).

% Bseq_ignore_initial_segment
tff(fact_6245_Bseq__offset,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [X6: fun(nat,A),K: nat] :
          ( bfun(nat,A,aa(nat,fun(nat,A),aTP_Lamp_abb(fun(nat,A),fun(nat,fun(nat,A)),X6),K),at_top(nat))
         => bfun(nat,A,X6,at_top(nat)) ) ) ).

% Bseq_offset
tff(fact_6246_filterlim__int__sequentially,axiom,
    filterlim(nat,int,semiring_1_of_nat(int),at_top(int),at_top(nat)) ).

% filterlim_int_sequentially
tff(fact_6247_BseqI_H,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A),K6: real] :
          ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X6,N2))),K6)
         => bfun(nat,A,X6,at_top(nat)) ) ) ).

% BseqI'
tff(fact_6248_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Xa: A] :
          ~ ! [A6: fun(nat,set(A))] :
              ( ! [I4: nat] : topolo1002775350975398744n_open(A,aa(nat,set(A),A6,I4))
             => ( ! [I4: nat] : member(A,Xa,aa(nat,set(A),A6,I4))
               => ~ ! [S8: set(A)] :
                      ( topolo1002775350975398744n_open(A,S8)
                     => ( member(A,Xa,S8)
                       => eventually(nat,aa(set(A),fun(nat,$o),aTP_Lamp_abc(fun(nat,set(A)),fun(set(A),fun(nat,$o)),A6),S8),at_top(nat)) ) ) ) ) ) ).

% countable_basis_at_decseq
tff(fact_6249_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,F3: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( bfun(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cb(A,fun(fun(nat,A),fun(nat,A)),C2),F3),at_top(nat))
          <=> bfun(nat,A,F3,at_top(nat)) ) ) ) ).

% Bseq_cmult_iff
tff(fact_6250_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_infinity(A))
        <=> ? [B7: real] :
            ! [X4: A] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B7),real_V7770717601297561774m_norm(A,X4))
             => aa(A,$o,P,X4) ) ) ) ).

% eventually_at_infinity
tff(fact_6251_tendsto__of__nat,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => filterlim(nat,A,semiring_1_of_nat(A),at_infinity(A),at_top(nat)) ) ).

% tendsto_of_nat
tff(fact_6252_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,B),C2: B] :
          ( filterlim(A,B,F3,at_infinity(B),F6)
         => ( filterlim(A,B,G,topolo7230453075368039082e_nhds(B,C2),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abd(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),at_infinity(B),F6) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
tff(fact_6253_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),C2: B,F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F6)
         => ( filterlim(A,B,G,at_infinity(B),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abd(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),at_infinity(B),F6) ) ) ) ).

% tendsto_add_filterlim_at_infinity
tff(fact_6254_filterlim__int__of__nat__at__topD,axiom,
    ! [A: $tType,F3: fun(int,A),F6: filter(A)] :
      ( filterlim(nat,A,aTP_Lamp_abe(fun(int,A),fun(nat,A),F3),F6,at_top(nat))
     => filterlim(int,A,F3,F6,at_top(int)) ) ).

% filterlim_int_of_nat_at_topD
tff(fact_6255_Bseq__eq__bounded,axiom,
    ! [F3: fun(nat,real),A2: real,B2: real] :
      ( aa(set(real),$o,aa(set(real),fun(set(real),$o),ord_less_eq(set(real)),aa(set(nat),set(real),image(nat,real,F3),top_top(set(nat)))),set_or1337092689740270186AtMost(real,A2,B2))
     => bfun(nat,real,F3,at_top(nat)) ) ).

% Bseq_eq_bounded
tff(fact_6256_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),topolo7230453075368039082e_nhds(A,zero_zero(A)),at_infinity(A)) ) ).

% tendsto_inverse_0
tff(fact_6257_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_abf(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F3),G),at_top(nat))
         => ( summable(real,G)
           => summable(A,F3) ) ) ) ).

% summable_comparison_test_ev
tff(fact_6258_BseqD,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( bfun(nat,A,X6,at_top(nat))
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K9)
              & ! [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X6,N3))),K9) ) ) ) ).

% BseqD
tff(fact_6259_BseqE,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( bfun(nat,A,X6,at_top(nat))
         => ~ ! [K9: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K9)
               => ~ ! [N3: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X6,N3))),K9) ) ) ) ).

% BseqE
tff(fact_6260_BseqI,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [K6: real,X6: fun(nat,A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K6)
         => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X6,N2))),K6)
           => bfun(nat,A,X6,at_top(nat)) ) ) ) ).

% BseqI
tff(fact_6261_Bseq__def,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( bfun(nat,A,X6,at_top(nat))
        <=> ? [K5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K5)
              & ! [N5: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X6,N5))),K5) ) ) ) ).

% Bseq_def
tff(fact_6262_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( bfun(nat,A,X6,at_top(nat))
        <=> ? [N7: nat] :
            ! [N5: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V7770717601297561774m_norm(A,aa(nat,A,X6,N5))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N7))) ) ) ).

% Bseq_iff1a
tff(fact_6263_Bseq__realpow,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => bfun(nat,real,aa(real,fun(nat,real),power_power(real),Xa),at_top(nat)) ) ) ).

% Bseq_realpow
tff(fact_6264_Bseq__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( bfun(nat,A,X6,at_top(nat))
        <=> ? [N7: nat] :
            ! [N5: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,X6,N5))),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,N7))) ) ) ).

% Bseq_iff
tff(fact_6265_tendsto__mult__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [F3: fun(A,B),C2: B,F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F6)
         => ( ( C2 != zero_zero(B) )
           => ( filterlim(A,B,G,at_infinity(B),F6)
             => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abg(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),at_infinity(B),F6) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
tff(fact_6266_tendsto__divide__0,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),C2: B,F6: filter(A),G: fun(A,B)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,C2),F6)
         => ( filterlim(A,B,G,at_infinity(B),F6)
           => filterlim(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abh(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo7230453075368039082e_nhds(B,zero_zero(B)),F6) ) ) ) ).

% tendsto_divide_0
tff(fact_6267_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),F6: filter(A),N: nat] :
          ( filterlim(A,B,F3,at_infinity(B),F6)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
           => filterlim(A,B,aa(nat,fun(A,B),aTP_Lamp_abi(fun(A,B),fun(nat,fun(A,B)),F3),N),at_infinity(B),F6) ) ) ) ).

% filterlim_power_at_infinity
tff(fact_6268_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => filterlim(A,A,inverse_inverse(A),at_infinity(A),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ).

% filterlim_inverse_at_infinity
tff(fact_6269_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [P2: fun(A,$o)] :
          ( eventually(A,P2,at_infinity(A))
        <=> ? [B7: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B7)
              & ! [X4: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B7),real_V7770717601297561774m_norm(A,X4))
                 => aa(A,$o,P2,X4) ) ) ) ) ).

% eventually_at_infinity_pos
tff(fact_6270_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),K6: real,F6: filter(A)] :
          ( eventually(A,aa(real,fun(A,$o),aTP_Lamp_abj(fun(A,B),fun(real,fun(A,$o)),F3),K6),F6)
         => bfun(A,B,F3,F6) ) ) ).

% BfunI
tff(fact_6271_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,F3,at_infinity(real),F6)
     => ( eventually(A,aTP_Lamp_aar(fun(A,real),fun(A,$o),F3),F6)
       => filterlim(A,real,F3,at_top(real),F6) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
tff(fact_6272_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F3: fun(A,real),F6: filter(A)] :
      ( filterlim(A,real,F3,at_infinity(real),F6)
     => ( eventually(A,aTP_Lamp_aas(fun(A,real),fun(A,$o),F3),F6)
       => filterlim(A,real,F3,at_bot(real),F6) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
tff(fact_6273_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [G: fun(A,B),F6: filter(A)] :
          ( filterlim(A,B,aTP_Lamp_ul(fun(A,B),fun(A,B),G),topolo174197925503356063within(B,zero_zero(B),top_top(set(B))),F6)
        <=> filterlim(A,B,G,at_infinity(B),F6) ) ) ).

% filterlim_inverse_at_iff
tff(fact_6274_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( bfun(nat,A,X6,at_top(nat))
        <=> ? [K2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K2)
              & ? [X4: A] :
                ! [N5: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X6,N5)),aa(A,A,uminus_uminus(A),X4)))),K2) ) ) ) ).

% Bseq_iff2
tff(fact_6275_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [X6: fun(nat,A)] :
          ( bfun(nat,A,X6,at_top(nat))
        <=> ? [K2: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K2)
              & ? [N7: nat] :
                ! [N5: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,X6,N5)),aa(A,A,uminus_uminus(A),aa(nat,A,X6,N7))))),K2) ) ) ) ).

% Bseq_iff3
tff(fact_6276_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),C2: A,F6: filter(A),G: fun(A,A)] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,C2),F6)
         => ( filterlim(A,A,G,topolo174197925503356063within(A,zero_zero(A),top_top(set(A))),F6)
           => ( ( C2 != zero_zero(A) )
             => filterlim(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_qf(fun(A,A),fun(fun(A,A),fun(A,A)),F3),G),at_infinity(A),F6) ) ) ) ) ).

% filterlim_divide_at_infinity
tff(fact_6277_filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [C2: real,F3: fun(A,B),F6: filter(A)] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),C2)
         => ( filterlim(A,B,F3,at_infinity(B),F6)
          <=> ! [R5: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),C2),R5)
               => eventually(A,aa(real,fun(A,$o),aTP_Lamp_abk(fun(A,B),fun(real,fun(A,$o)),F3),R5),F6) ) ) ) ) ).

% filterlim_at_infinity
tff(fact_6278_Bfun__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [F3: fun(A,B),A2: B,F6: filter(A)] :
          ( filterlim(A,B,F3,topolo7230453075368039082e_nhds(B,A2),F6)
         => ( ( A2 != zero_zero(B) )
           => bfun(A,B,aTP_Lamp_ul(fun(A,B),fun(A,B),F3),F6) ) ) ) ).

% Bfun_inverse
tff(fact_6279_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Xa: A] :
          ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),real_V7770717601297561774m_norm(A,Xa))
         => filterlim(nat,A,aa(A,fun(nat,A),power_power(A),Xa),at_infinity(A),at_top(nat)) ) ) ).

% filterlim_realpow_sequentially_gt1
tff(fact_6280_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),L: A] :
          ( filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,L),at_infinity(A))
        <=> filterlim(A,A,aa(fun(A,A),fun(A,A),comp(A,A,A,F3),inverse_inverse(A)),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% lim_at_infinity_0
tff(fact_6281_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [F3: fun(A,A),L: A] :
          ( filterlim(A,A,aTP_Lamp_abl(fun(A,A),fun(A,A),F3),topolo7230453075368039082e_nhds(A,L),topolo174197925503356063within(A,zero_zero(A),top_top(set(A))))
         => filterlim(A,A,F3,topolo7230453075368039082e_nhds(A,L),at_infinity(A)) ) ) ).

% lim_zero_infinity
tff(fact_6282_at__infinity__def,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ( at_infinity(A) = aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(real),set(filter(A)),image(real,filter(A),aTP_Lamp_abn(real,filter(A))),top_top(set(real)))) ) ) ).

% at_infinity_def
tff(fact_6283_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( bfun(A,B,F3,F6)
         => ~ ! [B9: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),B9)
               => ~ eventually(A,aa(real,fun(A,$o),aTP_Lamp_abj(fun(A,B),fun(real,fun(A,$o)),F3),B9),F6) ) ) ) ).

% BfunE
tff(fact_6284_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [F3: fun(A,B),F6: filter(A)] :
          ( bfun(A,B,F3,F6)
        <=> ? [K5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K5)
              & eventually(A,aa(real,fun(A,$o),aTP_Lamp_abj(fun(A,B),fun(real,fun(A,$o)),F3),K5),F6) ) ) ) ).

% Bfun_def
tff(fact_6285_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_abo(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F3),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F3) ) ) ) ).

% summable_Cauchy'
tff(fact_6286_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: fun(B,A),Y6: set(B),X6: set(A),F6: filter(B),F3: fun(A,C)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G),Y6)),X6)
     => ( eventually(B,aTP_Lamp_abp(set(B),fun(B,$o),Y6),F6)
       => ( map_filter_on(A,C,X6,F3,map_filter_on(B,A,Y6,G,F6)) = map_filter_on(B,C,Y6,aa(fun(B,A),fun(B,C),comp(A,C,B,F3),G),F6) ) ) ) ).

% map_filter_on_comp
tff(fact_6287_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [P: fun(A,$o)] :
          ( eventually(A,P,at_top(A))
         => eventually(A,aTP_Lamp_abq(fun(A,$o),fun(A,$o),P),at_top(A)) ) ) ).

% eventually_all_ge_at_top
tff(fact_6288_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [F3: fun(nat,A),G: fun(nat,real)] :
          ( eventually(nat,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_abr(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),F3),G),at_top(nat))
         => ( filterlim(nat,real,G,topolo7230453075368039082e_nhds(real,zero_zero(real)),at_top(nat))
           => summable(A,F3) ) ) ) ).

% summable_bounded_partials
tff(fact_6289_Greatest__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o)] : ( order_Greatest(A,P) = the(A,aTP_Lamp_abs(fun(A,$o),fun(A,$o),P)) ) ) ).

% Greatest_def
tff(fact_6290_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,L: A,U: A] :
          ( member(A,I,set_or3652927894154168847AtMost(A,L,U))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),I)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),I),U) ) ) ) ).

% greaterThanAtMost_iff
tff(fact_6291_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [L: A,K: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),K)
         => ( set_or3652927894154168847AtMost(A,K,L) = bot_bot(set(A)) ) ) ) ).

% greaterThanAtMost_empty
tff(fact_6292_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),C2)),set_or3652927894154168847AtMost(A,A2,B2)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),A2),aa(A,A,aa(A,fun(A,A),plus_plus(A),C2),B2)) ) ) ).

% image_add_greaterThanAtMost
tff(fact_6293_card__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] : ( aa(set(nat),nat,finite_card(nat),set_or3652927894154168847AtMost(nat,L,U)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),U),L) ) ).

% card_greaterThanAtMost
tff(fact_6294_image__minus__const__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),minus_minus(A),C2)),set_or3652927894154168847AtMost(A,A2,B2)) = set_or7035219750837199246ssThan(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)) ) ) ).

% image_minus_const_greaterThanAtMost
tff(fact_6295_image__diff__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),minus_minus(A),C2)),set_or7035219750837199246ssThan(A,A2,B2)) = set_or3652927894154168847AtMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2),aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)) ) ) ).

% image_diff_atLeastLessThan
tff(fact_6296_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or3652927894154168847AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            | ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% Ioc_subset_iff
tff(fact_6297_Ioc__inj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( set_or3652927894154168847AtMost(A,A2,B2) = set_or3652927894154168847AtMost(A,C2,D2) )
        <=> ( ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),C2) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
tff(fact_6298_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] : ( set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,L),U) = set_or3652927894154168847AtMost(nat,L,U) ) ).

% atLeastSucAtMost_greaterThanAtMost
tff(fact_6299_GreatestI__nat,axiom,
    ! [P: fun(nat,$o),K: nat,B2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [Y3: nat] :
            ( aa(nat,$o,P,Y3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y3),B2) )
       => aa(nat,$o,P,order_Greatest(nat,P)) ) ) ).

% GreatestI_nat
tff(fact_6300_Greatest__le__nat,axiom,
    ! [P: fun(nat,$o),K: nat,B2: nat] :
      ( aa(nat,$o,P,K)
     => ( ! [Y3: nat] :
            ( aa(nat,$o,P,Y3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y3),B2) )
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),order_Greatest(nat,P)) ) ) ).

% Greatest_le_nat
tff(fact_6301_GreatestI__ex__nat,axiom,
    ! [P: fun(nat,$o),B2: nat] :
      ( ? [X_1: nat] : aa(nat,$o,P,X_1)
     => ( ! [Y3: nat] :
            ( aa(nat,$o,P,Y3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y3),B2) )
       => aa(nat,$o,P,order_Greatest(nat,P)) ) ) ).

% GreatestI_ex_nat
tff(fact_6302_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or3652927894154168847AtMost(A,C2,D2)) = bot_bot(set(A)) )
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),C2)
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),C2)
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),A2) ) ) ) ).

% Ioc_disjoint
tff(fact_6303_open__left,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A),Xa: A,Y: A] :
          ( topolo1002775350975398744n_open(A,S2)
         => ( member(A,Xa,S2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),Y),Xa)
             => ? [B4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),B4),Xa)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,B4,Xa)),S2) ) ) ) ) ) ).

% open_left
tff(fact_6304_Greatest__equality,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o),Xa: A] :
          ( aa(A,$o,P,Xa)
         => ( ! [Y3: A] :
                ( aa(A,$o,P,Y3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),Xa) )
           => ( order_Greatest(A,P) = Xa ) ) ) ) ).

% Greatest_equality
tff(fact_6305_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o),Xa: A,Q: fun(A,$o)] :
          ( aa(A,$o,P,Xa)
         => ( ! [Y3: A] :
                ( aa(A,$o,P,Y3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),Xa) )
           => ( ! [X: A] :
                  ( aa(A,$o,P,X)
                 => ( ! [Y4: A] :
                        ( aa(A,$o,P,Y4)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y4),X) )
                   => aa(A,$o,Q,X) ) )
             => aa(A,$o,Q,order_Greatest(A,P)) ) ) ) ) ).

% GreatestI2_order
tff(fact_6306_sum_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),G),set_or3652927894154168847AtMost(nat,M,N))) ) ) ) ).

% sum.head
tff(fact_6307_prod_Ohead,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [M: nat,N: nat,G: fun(nat,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or1337092689740270186AtMost(nat,M,N)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,G,M)),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),G),set_or3652927894154168847AtMost(nat,M,N))) ) ) ) ).

% prod.head
tff(fact_6308_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or1337092689740270186AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
tff(fact_6309_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or3652927894154168847AtMost(A,A2,B2)),set_or7035219750837199246ssThan(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),D2) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
tff(fact_6310_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( dense_linorder(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),set_or3652927894154168847AtMost(A,C2,D2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),A2),B2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
tff(fact_6311_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A2: A,B2: A] : ( set_or3652927894154168847AtMost(A,A2,B2) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
tff(fact_6312_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),I))
     => ( aa(nat,nat,nth(nat,linord4507533701916653071of_set(nat,set_or3652927894154168847AtMost(nat,I,J))),N) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),N)) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
tff(fact_6313_interval__cases,axiom,
    ! [A: $tType] :
      ( condit6923001295902523014norder(A)
     => ! [S2: set(A)] :
          ( ! [A4: A,B4: A,X: A] :
              ( member(A,A4,S2)
             => ( member(A,B4,S2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),X)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),B4)
                   => member(A,X,S2) ) ) ) )
         => ? [A4: A,B4: A] :
              ( ( S2 = bot_bot(set(A)) )
              | ( S2 = top_top(set(A)) )
              | ( S2 = set_ord_lessThan(A,B4) )
              | ( S2 = set_ord_atMost(A,B4) )
              | ( S2 = set_ord_greaterThan(A,A4) )
              | ( S2 = set_ord_atLeast(A,A4) )
              | ( S2 = set_or5935395276787703475ssThan(A,A4,B4) )
              | ( S2 = set_or3652927894154168847AtMost(A,A4,B4) )
              | ( S2 = set_or7035219750837199246ssThan(A,A4,B4) )
              | ( S2 = set_or1337092689740270186AtMost(A,A4,B4) ) ) ) ) ).

% interval_cases
tff(fact_6314_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist(A)
        & topolo7287701948861334536_space(A) )
     => ! [F6: filter(A)] :
          ( topolo6773858410816713723filter(A,F6)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [P6: fun(A,$o)] :
                  ( eventually(A,P6,F6)
                  & ! [X4: A,Y5: A] :
                      ( ( aa(A,$o,P6,X4)
                        & aa(A,$o,P6,Y5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,Y5)),E3) ) ) ) ) ) ).

% cauchy_filter_metric
tff(fact_6315_atLeast__0,axiom,
    set_ord_atLeast(nat,zero_zero(nat)) = top_top(set(nat)) ).

% atLeast_0
tff(fact_6316_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [I: A,K: A] :
          ( member(A,I,set_ord_atLeast(A,K))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),K),I) ) ) ).

% atLeast_iff
tff(fact_6317_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Xa: A,Y: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atLeast(A,Xa)),set_ord_atLeast(A,Y))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa) ) ) ).

% atLeast_subset_iff
tff(fact_6318_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A,I: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),plus_plus(A),K)),set_ord_atLeast(A,I)) = set_ord_atLeast(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),K),I)) ) ) ).

% image_add_atLeast
tff(fact_6319_card__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] : ( aa(set(int),nat,finite_card(int),set_or3652927894154168847AtMost(int,L,U)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),minus_minus(int),U),L)) ) ).

% card_greaterThanAtMost_int
tff(fact_6320_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [L: A,H: A,L3: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,L,H)),set_ord_atLeast(A,L3))
        <=> ( ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),H)
            | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L3),L) ) ) ) ).

% Icc_subset_Ici_iff
tff(fact_6321_image__minus__const__AtMost,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,B2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),minus_minus(A),C2)),set_ord_atMost(A,B2)) = set_ord_atLeast(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),B2)) ) ) ).

% image_minus_const_AtMost
tff(fact_6322_image__minus__const__atLeast,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [C2: A,A2: A] : ( aa(set(A),set(A),image(A,A,aa(A,fun(A,A),minus_minus(A),C2)),set_ord_atLeast(A,A2)) = set_ord_atMost(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),C2),A2)) ) ) ).

% image_minus_const_atLeast
tff(fact_6323_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A2: A] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_greaterThan(A,A2)),set_ord_atLeast(A,A2)) ) ).

% Ioi_le_Ico
tff(fact_6324_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [L: A,L3: A,H2: A] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atLeast(A,L)),set_or1337092689740270186AtMost(A,L3,H2)) ) ).

% not_Ici_le_Icc
tff(fact_6325_atLeast__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [L: A] : ( set_ord_atLeast(A,L) = collect(A,aa(A,fun(A,$o),ord_less_eq(A),L)) ) ) ).

% atLeast_def
tff(fact_6326_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [L: A] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),top_top(set(A))),set_ord_atLeast(A,L)) ) ).

% not_UNIV_le_Ici
tff(fact_6327_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( no_top(A)
     => ! [L: A,H2: A] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atLeast(A,L)),set_ord_atMost(A,H2)) ) ).

% not_Ici_le_Iic
tff(fact_6328_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( no_bot(A)
     => ! [H: A,L3: A] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atMost(A,H)),set_ord_atLeast(A,L3)) ) ).

% not_Iic_le_Ici
tff(fact_6329_atLeast__Suc__greaterThan,axiom,
    ! [K: nat] : ( set_ord_atLeast(nat,aa(nat,nat,suc,K)) = set_ord_greaterThan(nat,K) ) ).

% atLeast_Suc_greaterThan
tff(fact_6330_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,B2: A] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_ord_atLeast(A,A2)),set_ord_greaterThan(A,B2))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),B2),A2) ) ) ).

% Ici_subset_Ioi_iff
tff(fact_6331_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] : ( set_or1337092689740270186AtMost(int,aa(int,int,aa(int,fun(int,int),plus_plus(int),L),one_one(int)),U) = set_or3652927894154168847AtMost(int,L,U) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
tff(fact_6332_nhds__imp__cauchy__filter,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [F6: filter(A),Xa: A] :
          ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),topolo7230453075368039082e_nhds(A,Xa))
         => topolo6773858410816713723filter(A,F6) ) ) ).

% nhds_imp_cauchy_filter
tff(fact_6333_atLeast__Suc,axiom,
    ! [K: nat] : ( set_ord_atLeast(nat,aa(nat,nat,suc,K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),minus_minus(set(nat)),set_ord_atLeast(nat,K)),aa(set(nat),set(nat),insert(nat,K),bot_bot(set(nat)))) ) ).

% atLeast_Suc
tff(fact_6334_complete__uniform,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [S2: set(A)] :
          ( topolo2479028161051973599mplete(A,S2)
        <=> ! [F11: filter(A)] :
              ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F11),principal(A,S2))
             => ( ( F11 != bot_bot(filter(A)) )
               => ( topolo6773858410816713723filter(A,F11)
                 => ? [X4: A] :
                      ( member(A,X4,S2)
                      & aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F11),topolo7230453075368039082e_nhds(A,X4)) ) ) ) ) ) ) ).

% complete_uniform
tff(fact_6335_GMVT,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),G: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X: real] :
            ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
              & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
           => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),F3) )
       => ( ! [X: real] :
              ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2) )
             => differentiable(real,real,F3,topolo174197925503356063within(real,X,top_top(set(real)))) )
         => ( ! [X: real] :
                ( ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),X)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X),B2) )
               => topolo3448309680560233919inuous(real,real,topolo174197925503356063within(real,X,top_top(set(real))),G) )
           => ( ! [X: real] :
                  ( ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
                    & aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2) )
                 => differentiable(real,real,G,topolo174197925503356063within(real,X,top_top(set(real)))) )
             => ? [G_c: real,F_c: real,C4: real] :
                  ( has_field_derivative(real,G,G_c,topolo174197925503356063within(real,C4,top_top(set(real))))
                  & has_field_derivative(real,F3,F_c,topolo174197925503356063within(real,C4,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),C4)
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),C4),B2)
                  & ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2))),G_c) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,G,B2)),aa(real,real,G,A2))),F_c) ) ) ) ) ) ) ) ).

% GMVT
tff(fact_6336_differentiable__cmult__right__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Q2: fun(A,B),C2: B,T2: A] :
          ( differentiable(A,B,aa(B,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(B,fun(A,B)),Q2),C2),topolo174197925503356063within(A,T2,top_top(set(A))))
        <=> ( ( C2 = zero_zero(B) )
            | differentiable(A,B,Q2,topolo174197925503356063within(A,T2,top_top(set(A)))) ) ) ) ).

% differentiable_cmult_right_iff
tff(fact_6337_differentiable__cmult__left__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [C2: B,Q2: fun(A,B),T2: A] :
          ( differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abu(B,fun(fun(A,B),fun(A,B)),C2),Q2),topolo174197925503356063within(A,T2,top_top(set(A))))
        <=> ( ( C2 = zero_zero(B) )
            | differentiable(A,B,Q2,topolo174197925503356063within(A,T2,top_top(set(A)))) ) ) ) ).

% differentiable_cmult_left_iff
tff(fact_6338_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),Xa: A,S: set(A),T2: set(A)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,Xa,S))
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),S)
           => differentiable(A,B,F3,topolo174197925503356063within(A,Xa,T2)) ) ) ) ).

% differentiable_within_subset
tff(fact_6339_differentiable__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,F6)
         => ( differentiable(A,B,G,F6)
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rp(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),F6) ) ) ) ).

% differentiable_diff
tff(fact_6340_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [F3: fun(A,B),F6: filter(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,F6)
         => ( differentiable(A,B,G,F6)
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rs(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),F6) ) ) ) ).

% differentiable_add
tff(fact_6341_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [F3: fun(A,B),Xa: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,Xa,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,Xa,S))
           => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rv(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% differentiable_mult
tff(fact_6342_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),Xa: A,S: set(A),G: fun(A,B)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,Xa,S))
         => ( differentiable(A,B,G,topolo174197925503356063within(A,Xa,S))
           => ( ( aa(A,B,G,Xa) != zero_zero(B) )
             => differentiable(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sd(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),topolo174197925503356063within(A,Xa,S)) ) ) ) ) ).

% differentiable_divide
tff(fact_6343_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),Xa: A,S: set(A)] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,Xa,S))
         => ( ( aa(A,B,F3,Xa) != zero_zero(B) )
           => differentiable(A,B,aTP_Lamp_abv(fun(A,B),fun(A,B),F3),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% differentiable_inverse
tff(fact_6344_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [F3: fun(A,B),Xa: A,S: set(A),N: int] :
          ( differentiable(A,B,F3,topolo174197925503356063within(A,Xa,S))
         => ( ( aa(A,B,F3,Xa) != zero_zero(B) )
           => differentiable(A,B,aa(int,fun(A,B),aTP_Lamp_abw(fun(A,B),fun(int,fun(A,B)),F3),N),topolo174197925503356063within(A,Xa,S)) ) ) ) ).

% differentiable_power_int
tff(fact_6345_MVT,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
               => differentiable(real,real,F3,topolo174197925503356063within(real,X,top_top(set(real)))) ) )
         => ? [L2: real,Z4: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z4)
              & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z4),B2)
              & has_field_derivative(real,F3,L2,topolo174197925503356063within(real,Z4,top_top(set(real))))
              & ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)),L2) ) ) ) ) ) ).

% MVT
tff(fact_6346_eventually__filtercomap__at__topological,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [P: fun(A,$o),F3: fun(A,B),A3: B,B3: set(B)] :
          ( eventually(A,P,filtercomap(A,B,F3,topolo174197925503356063within(B,A3,B3)))
        <=> ? [S9: set(B)] :
              ( topolo1002775350975398744n_open(B,S9)
              & member(B,A3,S9)
              & ! [X4: A] :
                  ( member(B,aa(A,B,F3,X4),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),S9),B3)),aa(set(B),set(B),insert(B,A3),bot_bot(set(B)))))
                 => aa(A,$o,P,X4) ) ) ) ) ).

% eventually_filtercomap_at_topological
tff(fact_6347_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(A,real,F3,X) != zero_zero(real) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_abx(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_on_ln
tff(fact_6348_continuous__on__cos__real,axiom,
    ! [A2: real,B2: real] : topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),cos(real)) ).

% continuous_on_cos_real
tff(fact_6349_continuous__on__sin__real,axiom,
    ! [A2: real,B2: real] : topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),sin(real)) ).

% continuous_on_sin_real
tff(fact_6350_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(A,B,F3,X) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_aby(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_on_sgn
tff(fact_6351_continuous__on__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),N: int] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(A,B,F3,X) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aa(int,fun(A,B),aTP_Lamp_abz(fun(A,B),fun(int,fun(A,B)),F3),N)) ) ) ) ).

% continuous_on_power_int
tff(fact_6352_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => ( ! [X: A] :
                  ( member(A,X,S)
                 => ( aa(A,B,G,X) != zero_zero(B) ) )
             => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_aca(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ) ).

% continuous_on_divide
tff(fact_6353_continuous__on__arsinh,axiom,
    ! [A3: set(real)] : topolo81223032696312382ous_on(real,real,A3,arsinh(real)) ).

% continuous_on_arsinh
tff(fact_6354_continuous__on__sinh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => topolo81223032696312382ous_on(A,B,A3,aTP_Lamp_acb(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_sinh
tff(fact_6355_continuous__on__exp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_acc(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_exp
tff(fact_6356_continuous__on__sin,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_ux(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_sin
tff(fact_6357_continuous__on__cos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_uy(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_cos
tff(fact_6358_continuous__on__pochhammer,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [A3: set(A),N: nat] : topolo81223032696312382ous_on(A,A,A3,aTP_Lamp_vz(nat,fun(A,A),N)) ) ).

% continuous_on_pochhammer
tff(fact_6359_continuous__on__pochhammer_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),N: nat] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aa(nat,fun(A,B),aTP_Lamp_acd(fun(A,B),fun(nat,fun(A,B)),F3),N)) ) ) ).

% continuous_on_pochhammer'
tff(fact_6360_continuous__on__arctan,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_ace(fun(A,real),fun(A,real),F3)) ) ) ).

% continuous_on_arctan
tff(fact_6361_continuous__on__cosh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => topolo81223032696312382ous_on(A,B,A3,aTP_Lamp_acf(fun(A,B),fun(A,B),F3)) ) ) ).

% continuous_on_cosh
tff(fact_6362_continuous__on__arsinh_H,axiom,
    ! [A3: set(real),F3: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F3)
     => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_acg(fun(real,real),fun(real,real),F3)) ) ).

% continuous_on_arsinh'
tff(fact_6363_continuous__on__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_ach(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_add
tff(fact_6364_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [S: set(A),C2: A] : topolo81223032696312382ous_on(A,A,S,aa(A,fun(A,A),times_times(A),C2)) ) ).

% continuous_on_mult_const
tff(fact_6365_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),C2: B] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aa(B,fun(A,B),aTP_Lamp_aci(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_on_mult_right
tff(fact_6366_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),C2: B] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => topolo81223032696312382ous_on(A,B,S,aa(B,fun(A,B),aTP_Lamp_acj(fun(A,B),fun(B,fun(A,B)),F3),C2)) ) ) ).

% continuous_on_mult_left
tff(fact_6367_continuous__on__mult_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => ( topolo81223032696312382ous_on(A,B,A3,G)
           => topolo81223032696312382ous_on(A,B,A3,aa(fun(A,B),fun(A,B),aTP_Lamp_ack(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_mult'
tff(fact_6368_continuous__on__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_acl(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_mult
tff(fact_6369_continuous__on__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [S: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo81223032696312382ous_on(A,B,S,G)
           => topolo81223032696312382ous_on(A,B,S,aa(fun(A,B),fun(A,B),aTP_Lamp_acm(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% continuous_on_diff
tff(fact_6370_continuous__on__op__minus,axiom,
    ! [A: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [S: set(A),Xa: A] : topolo81223032696312382ous_on(A,A,S,aa(A,fun(A,A),minus_minus(A),Xa)) ) ).

% continuous_on_op_minus
tff(fact_6371_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(A,B,F3,X) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,S,aTP_Lamp_acn(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_on_inverse
tff(fact_6372_continuous__on__powr,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X: A] :
                  ( member(A,X,S)
                 => ( aa(A,real,F3,X) != zero_zero(real) ) )
             => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_aco(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_on_powr
tff(fact_6373_continuous__on__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [T2: set(A),G: fun(A,B),S: set(C),F3: fun(C,A)] :
          ( topolo81223032696312382ous_on(A,B,T2,G)
         => ( topolo81223032696312382ous_on(C,A,S,F3)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,F3),S)),T2)
             => topolo81223032696312382ous_on(C,B,S,aa(fun(C,A),fun(C,B),aTP_Lamp_acp(fun(A,B),fun(fun(C,A),fun(C,B)),G),F3)) ) ) ) ) ).

% continuous_on_compose2
tff(fact_6374_filtercomap__mono,axiom,
    ! [B: $tType,A: $tType,F6: filter(A),F10: filter(A),F3: fun(B,A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10)
     => aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtercomap(B,A,F3,F6)),filtercomap(B,A,F3,F10)) ) ).

% filtercomap_mono
tff(fact_6375_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S: set(A),F3: fun(A,B),T2: set(A)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),S)
           => topolo81223032696312382ous_on(A,B,T2,F3) ) ) ) ).

% continuous_on_subset
tff(fact_6376_IVT_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo8458572112393995274pology(B) )
     => ! [F3: fun(B,A),A2: B,Y: A,B2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,A2)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(B,A,F3,B2))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),B2)
             => ( topolo81223032696312382ous_on(B,A,set_or1337092689740270186AtMost(B,A2,B2),F3)
               => ? [X: B] :
                    ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),X)
                    & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),B2)
                    & ( aa(B,A,F3,X) = Y ) ) ) ) ) ) ) ).

% IVT'
tff(fact_6377_IVT2_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo8458572112393995274pology(B) )
     => ! [F3: fun(B,A),B2: B,Y: A,A2: B] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,B2)),Y)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(B,A,F3,A2))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),B2)
             => ( topolo81223032696312382ous_on(B,A,set_or1337092689740270186AtMost(B,A2,B2),F3)
               => ? [X: B] :
                    ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),A2),X)
                    & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),B2)
                    & ( aa(B,A,F3,X) = Y ) ) ) ) ) ) ) ).

% IVT2'
tff(fact_6378_filterlim__iff__le__filtercomap,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),F6: filter(B),G5: filter(A)] :
      ( filterlim(A,B,F3,F6,G5)
    <=> aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),G5),filtercomap(A,B,F3,F6)) ) ).

% filterlim_iff_le_filtercomap
tff(fact_6379_continuous__onI__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology(B)
        & dense_order(A)
        & topolo1944317154257567458pology(A) )
     => ! [F3: fun(B,A),A3: set(B)] :
          ( topolo1002775350975398744n_open(A,aa(set(B),set(A),image(B,A,F3),A3))
         => ( ! [X: B,Y3: B] :
                ( member(B,X,A3)
               => ( member(B,Y3,A3)
                 => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),X),Y3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,X)),aa(B,A,F3,Y3)) ) ) )
           => topolo81223032696312382ous_on(B,A,A3,F3) ) ) ) ).

% continuous_onI_mono
tff(fact_6380_filtercomap__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType,F3: fun(A,C),F6: fun(B,filter(C)),B3: set(B)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),aa(set(B),set(filter(A)),image(B,filter(A),aa(fun(B,filter(C)),fun(B,filter(A)),aTP_Lamp_acq(fun(A,C),fun(fun(B,filter(C)),fun(B,filter(A))),F3),F6)),B3))),filtercomap(A,C,F3,aa(set(filter(C)),filter(C),complete_Sup_Sup(filter(C)),aa(set(B),set(filter(C)),image(B,filter(C),F6),B3)))) ).

% filtercomap_SUP
tff(fact_6381_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F3: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(A,A,cos(A),aa(A,A,F3,X)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_us(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_on_tan
tff(fact_6382_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [S: set(A),F3: fun(A,A)] :
          ( topolo81223032696312382ous_on(A,A,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(A,A,sin(A),aa(A,A,F3,X)) != zero_zero(A) ) )
           => topolo81223032696312382ous_on(A,A,S,aTP_Lamp_ui(fun(A,A),fun(A,A),F3)) ) ) ) ).

% continuous_on_cot
tff(fact_6383_continuous__on__tanh,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [A3: set(A),F3: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,A3,F3)
         => ( ! [X: A] :
                ( member(A,X,A3)
               => ( aa(B,B,cosh(B),aa(A,B,F3,X)) != zero_zero(B) ) )
           => topolo81223032696312382ous_on(A,B,A3,aTP_Lamp_acr(fun(A,B),fun(A,B),F3)) ) ) ) ).

% continuous_on_tanh
tff(fact_6384_continuous__on__arcosh_H,axiom,
    ! [A3: set(real),F3: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F3)
     => ( ! [X: real] :
            ( member(real,X,A3)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(real,real,F3,X)) )
       => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_acs(fun(real,real),fun(real,real),F3)) ) ) ).

% continuous_on_arcosh'
tff(fact_6385_eventually__filtercomap__at__top__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [P: fun(A,$o),F3: fun(A,B)] :
          ( eventually(A,P,filtercomap(A,B,F3,at_top(B)))
        <=> ? [N7: B] :
            ! [X4: A] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),N7),aa(A,B,F3,X4))
             => aa(A,$o,P,X4) ) ) ) ).

% eventually_filtercomap_at_top_linorder
tff(fact_6386_eventually__filtercomap__at__bot__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [P: fun(A,$o),F3: fun(A,B)] :
          ( eventually(A,P,filtercomap(A,B,F3,at_bot(B)))
        <=> ? [N7: B] :
            ! [X4: A] :
              ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),N7)
             => aa(A,$o,P,X4) ) ) ) ).

% eventually_filtercomap_at_bot_linorder
tff(fact_6387_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ? [C4: real,D6: real] :
            ( ( aa(set(real),set(real),image(real,real,F3),set_or1337092689740270186AtMost(real,A2,B2)) = set_or1337092689740270186AtMost(real,C4,D6) )
            & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),C4),D6) ) ) ) ).

% continuous_image_closed_interval
tff(fact_6388_continuous__on__arcosh,axiom,
    ! [A3: set(real)] :
      ( aa(set(real),$o,aa(set(real),fun(set(real),$o),ord_less_eq(set(real)),A3),set_ord_atLeast(real,one_one(real)))
     => topolo81223032696312382ous_on(real,real,A3,arcosh(real)) ) ).

% continuous_on_arcosh
tff(fact_6389_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ? [A6: set(A)] :
              ( topolo1002775350975398744n_open(A,A6)
              & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A6),S) = collect(A,aa(fun(A,real),fun(A,$o),aTP_Lamp_act(set(A),fun(fun(A,real),fun(A,$o)),S),F3)) ) ) ) ) ).

% open_Collect_positive
tff(fact_6390_continuous__on__powr_H,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X: A] :
                  ( member(A,X,S)
                 => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,F3,X))
                    & ( ( aa(A,real,F3,X) = zero_zero(real) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X)) ) ) )
             => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_aco(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ).

% continuous_on_powr'
tff(fact_6391_continuous__on__log,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( topolo81223032696312382ous_on(A,real,S,G)
           => ( ! [X: A] :
                  ( member(A,X,S)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,F3,X)) )
             => ( ! [X: A] :
                    ( member(A,X,S)
                   => ( aa(A,real,F3,X) != one_one(real) ) )
               => ( ! [X: A] :
                      ( member(A,X,S)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,G,X)) )
                 => topolo81223032696312382ous_on(A,real,S,aa(fun(A,real),fun(A,real),aTP_Lamp_acu(fun(A,real),fun(fun(A,real),fun(A,real)),F3),G)) ) ) ) ) ) ) ).

% continuous_on_log
tff(fact_6392_continuous__on__arccos_H,axiom,
    topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)),arccos) ).

% continuous_on_arccos'
tff(fact_6393_continuous__on__arcsin_H,axiom,
    topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)),arcsin) ).

% continuous_on_arcsin'
tff(fact_6394_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F3,X))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,F3,X)),one_one(real)) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_acv(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_on_arccos
tff(fact_6395_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),F3: fun(A,real)] :
          ( topolo81223032696312382ous_on(A,real,S,F3)
         => ( ! [X: A] :
                ( member(A,X,S)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),one_one(real))),aa(A,real,F3,X))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,F3,X)),one_one(real)) ) )
           => topolo81223032696312382ous_on(A,real,S,aTP_Lamp_acw(fun(A,real),fun(A,real),F3)) ) ) ) ).

% continuous_on_arcsin
tff(fact_6396_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ord(A)
        & real_V3459762299906320749_field(A) )
     => ! [A2: A,B2: A,F3: fun(A,A)] :
          ( ! [X: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),B2)
               => ? [Y4: A] : has_field_derivative(A,F3,Y4,topolo174197925503356063within(A,X,top_top(set(A)))) ) )
         => topolo81223032696312382ous_on(A,A,set_or1337092689740270186AtMost(A,A2,B2),F3) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
tff(fact_6397_continuous__on__artanh_H,axiom,
    ! [A3: set(real),F3: fun(real,real)] :
      ( topolo81223032696312382ous_on(real,real,A3,F3)
     => ( ! [X: real] :
            ( member(real,X,A3)
           => member(real,aa(real,real,F3,X),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real))) )
       => topolo81223032696312382ous_on(real,real,A3,aTP_Lamp_acx(fun(real,real),fun(real,real),F3)) ) ) ).

% continuous_on_artanh'
tff(fact_6398_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),F9: fun(real,fun(real,real))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ( aa(real,real,F3,A2) = aa(real,real,F3,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => ( ! [X: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
                 => has_derivative(real,real,F3,aa(real,fun(real,real),F9,X),topolo174197925503356063within(real,X,top_top(set(real)))) ) )
           => ? [Z4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z4),B2)
                & ! [X3: real] : ( aa(real,real,aa(real,fun(real,real),F9,Z4),X3) = zero_zero(real) ) ) ) ) ) ) ).

% Rolle_deriv
tff(fact_6399_mvt,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),F9: fun(real,fun(real,real))] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
               => has_derivative(real,real,F3,aa(real,fun(real,real),F9,X),topolo174197925503356063within(real,X,top_top(set(real)))) ) )
         => ~ ! [Xi: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Xi)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xi),B2)
                 => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) != aa(real,real,aa(real,fun(real,real),F9,Xi),aa(real,real,aa(real,fun(real,real),minus_minus(real),B2),A2)) ) ) ) ) ) ) ).

% mvt
tff(fact_6400_continuous__on__of__int__floor,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),ring_1_Ints(A)),aTP_Lamp_acy(A,B)) ) ).

% continuous_on_of_int_floor
tff(fact_6401_continuous__on__of__int__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => topolo81223032696312382ous_on(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),top_top(set(A))),ring_1_Ints(A)),aTP_Lamp_acz(A,B)) ) ).

% continuous_on_of_int_ceiling
tff(fact_6402_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
             => ? [Y4: real] :
                  ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),Y4) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,A2)),aa(real,real,F3,B2)) ) ) ) ).

% DERIV_pos_imp_increasing_open
tff(fact_6403_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ! [X: real] :
            ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
             => ? [Y4: real] :
                  ( has_field_derivative(real,F3,Y4,topolo174197925503356063within(real,X,top_top(set(real))))
                  & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Y4),zero_zero(real)) ) ) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,F3,B2)),aa(real,real,F3,A2)) ) ) ) ).

% DERIV_neg_imp_decreasing_open
tff(fact_6404_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
               => has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X,top_top(set(real)))) ) )
         => ( aa(real,real,F3,B2) = aa(real,real,F3,A2) ) ) ) ) ).

% DERIV_isconst_end
tff(fact_6405_continuous__on__artanh,axiom,
    ! [A3: set(real)] :
      ( aa(set(real),$o,aa(set(real),fun(set(real),$o),ord_less_eq(set(real)),A3),set_or5935395276787703475ssThan(real,aa(real,real,uminus_uminus(real),one_one(real)),one_one(real)))
     => topolo81223032696312382ous_on(real,real,A3,artanh(real)) ) ).

% continuous_on_artanh
tff(fact_6406_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F3: fun(real,real),Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
       => ( ! [X: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
             => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
               => has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,X,top_top(set(real)))) ) )
         => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),A2),Xa)
           => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),B2)
             => ( aa(real,real,F3,Xa) = aa(real,real,F3,A2) ) ) ) ) ) ) ).

% DERIV_isconst2
tff(fact_6407_Rolle,axiom,
    ! [A2: real,B2: real,F3: fun(real,real)] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),B2)
     => ( ( aa(real,real,F3,A2) = aa(real,real,F3,B2) )
       => ( topolo81223032696312382ous_on(real,real,set_or1337092689740270186AtMost(real,A2,B2),F3)
         => ( ! [X: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),X)
               => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),X),B2)
                 => differentiable(real,real,F3,topolo174197925503356063within(real,X,top_top(set(real)))) ) )
           => ? [Z4: real] :
                ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),A2),Z4)
                & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Z4),B2)
                & has_field_derivative(real,F3,zero_zero(real),topolo174197925503356063within(real,Z4,top_top(set(real)))) ) ) ) ) ) ).

% Rolle
tff(fact_6408_uniformity__dist,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ( topolo7806501430040627800ormity(A) = aa(set(filter(product_prod(A,A))),filter(product_prod(A,A)),complete_Inf_Inf(filter(product_prod(A,A))),aa(set(real),set(filter(product_prod(A,A))),image(real,filter(product_prod(A,A)),aTP_Lamp_adb(real,filter(product_prod(A,A)))),set_ord_greaterThan(real,zero_zero(real)))) ) ) ).

% uniformity_dist
tff(fact_6409_uniformity__complex__def,axiom,
    topolo7806501430040627800ormity(complex) = aa(set(filter(product_prod(complex,complex))),filter(product_prod(complex,complex)),complete_Inf_Inf(filter(product_prod(complex,complex))),aa(set(real),set(filter(product_prod(complex,complex))),image(real,filter(product_prod(complex,complex)),aTP_Lamp_add(real,filter(product_prod(complex,complex)))),set_ord_greaterThan(real,zero_zero(real)))) ).

% uniformity_complex_def
tff(fact_6410_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [X6: fun(nat,A)] :
          ( topolo3814608138187158403Cauchy(A,X6)
        <=> ! [P6: fun(product_prod(A,A),$o)] :
              ( eventually(product_prod(A,A),P6,topolo7806501430040627800ormity(A))
             => ? [N7: nat] :
                ! [N5: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N5)
                 => ! [M6: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),M6)
                     => aa(product_prod(A,A),$o,P6,aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,X6,N5)),aa(nat,A,X6,M6))) ) ) ) ) ) ).

% Cauchy_uniform_iff
tff(fact_6411_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [P: fun(product_prod(A,A),$o)] :
          ( eventually(product_prod(A,A),P,topolo7806501430040627800ormity(A))
        <=> ? [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
              & ! [X4: A,Y5: A] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,Y5)),E3)
                 => aa(product_prod(A,A),$o,P,aa(A,product_prod(A,A),product_Pair(A,A,X4),Y5)) ) ) ) ) ).

% eventually_uniformity_metric
tff(fact_6412_uniformity__real__def,axiom,
    topolo7806501430040627800ormity(real) = aa(set(filter(product_prod(real,real))),filter(product_prod(real,real)),complete_Inf_Inf(filter(product_prod(real,real))),aa(set(real),set(filter(product_prod(real,real))),image(real,filter(product_prod(real,real)),aTP_Lamp_adf(real,filter(product_prod(real,real)))),set_ord_greaterThan(real,zero_zero(real)))) ).

% uniformity_real_def
tff(fact_6413_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),C5: set(B),F3: fun(B,set(A))] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ! [T7: B] :
                ( member(B,T7,C5)
               => topolo1002775350975398744n_open(A,aa(B,set(A),F3,T7)) )
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),C5)))
             => ~ ! [C8: set(B)] :
                    ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C8),C5)
                   => ( aa(set(B),$o,finite_finite(B),C8)
                     => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),C8))) ) ) ) ) ) ) ).

% compactE_image
tff(fact_6414_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A)] :
          ( topolo2193935891317330818ompact(A,S2)
        <=> ! [C9: set(set(A))] :
              ( ( ! [X4: set(A)] :
                    ( member(set(A),X4,C9)
                   => topolo1002775350975398744n_open(A,X4) )
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C9)) )
             => ? [D8: set(set(A))] :
                  ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),D8),C9)
                  & aa(set(set(A)),$o,finite_finite(set(A)),D8)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),D8)) ) ) ) ) ).

% compact_eq_Heine_Borel
tff(fact_6415_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A)] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ? [X: A] :
                ( member(A,X,S2)
                & ! [Xa2: A] :
                    ( member(A,Xa2,S2)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Xa2) ) ) ) ) ) ).

% compact_attains_inf
tff(fact_6416_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A)] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ? [X: A] :
                ( member(A,X,S2)
                & ! [Xa2: A] :
                    ( member(A,Xa2,S2)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa2),X) ) ) ) ) ) ).

% compact_attains_sup
tff(fact_6417_compact__diff,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),T5: set(A)] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( topolo1002775350975398744n_open(A,T5)
           => topolo2193935891317330818ompact(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T5)) ) ) ) ).

% compact_diff
tff(fact_6418_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo2193935891317330818ompact(A,S)
         => ( ( S != bot_bot(set(A)) )
           => ( topolo81223032696312382ous_on(A,B,S,F3)
             => ? [X: A] :
                  ( member(A,X,S)
                  & ! [Xa2: A] :
                      ( member(A,Xa2,S)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Xa2)) ) ) ) ) ) ) ).

% continuous_attains_inf
tff(fact_6419_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo2193935891317330818ompact(A,S)
         => ( ( S != bot_bot(set(A)) )
           => ( topolo81223032696312382ous_on(A,B,S,F3)
             => ? [X: A] :
                  ( member(A,X,S)
                  & ! [Xa2: A] :
                      ( member(A,Xa2,S)
                     => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa2)),aa(A,B,F3,X)) ) ) ) ) ) ) ).

% continuous_attains_sup
tff(fact_6420_compactE,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),T11: set(set(A))] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),T11))
           => ( ! [B9: set(A)] :
                  ( member(set(A),B9,T11)
                 => topolo1002775350975398744n_open(A,B9) )
             => ~ ! [T12: set(set(A))] :
                    ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),T12),T11)
                   => ( aa(set(set(A)),$o,finite_finite(set(A)),T12)
                     => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),T12)) ) ) ) ) ) ) ).

% compactE
tff(fact_6421_compactI,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A)] :
          ( ! [C7: set(set(A))] :
              ( ! [X3: set(A)] :
                  ( member(set(A),X3,C7)
                 => topolo1002775350975398744n_open(A,X3) )
             => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C7))
               => ? [C10: set(set(A))] :
                    ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),C10),C7)
                    & aa(set(set(A)),$o,finite_finite(set(A)),C10)
                    & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C10)) ) ) )
         => topolo2193935891317330818ompact(A,S) ) ) ).

% compactI
tff(fact_6422_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),I5: set(B),F3: fun(B,set(A))] :
          ( topolo2193935891317330818ompact(A,S)
         => ( ! [I2: B] :
                ( member(B,I2,I5)
               => topolo7761053866217962861closed(A,aa(B,set(A),F3,I2)) )
           => ( ! [I6: set(B)] :
                  ( aa(set(B),$o,finite_finite(B),I6)
                 => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),I6),I5)
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),I6))) != bot_bot(set(A)) ) ) )
             => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(B),set(set(A)),image(B,set(A),F3),I5))) != bot_bot(set(A)) ) ) ) ) ) ).

% compact_imp_fip_image
tff(fact_6423_inj__sgn__power,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => inj_on(real,real,aTP_Lamp_pn(nat,fun(real,real),N),top_top(set(real))) ) ).

% inj_sgn_power
tff(fact_6424_open__Diff,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),T5: set(A)] :
          ( topolo1002775350975398744n_open(A,S2)
         => ( topolo7761053866217962861closed(A,T5)
           => topolo1002775350975398744n_open(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T5)) ) ) ) ).

% open_Diff
tff(fact_6425_closed__Diff,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),T5: set(A)] :
          ( topolo7761053866217962861closed(A,S2)
         => ( topolo1002775350975398744n_open(A,T5)
           => topolo7761053866217962861closed(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),T5)) ) ) ) ).

% closed_Diff
tff(fact_6426_inj__mult__left,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [A2: A] :
          ( inj_on(A,A,aa(A,fun(A,A),times_times(A),A2),top_top(set(A)))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% inj_mult_left
tff(fact_6427_inj__divide__right,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [A2: A] :
          ( inj_on(A,A,aTP_Lamp_adg(A,fun(A,A),A2),top_top(set(A)))
        <=> ( A2 != zero_zero(A) ) ) ) ).

% inj_divide_right
tff(fact_6428_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A2: A,A3: set(A)] :
      ( inj_on(A,B,F3,aa(set(A),set(A),insert(A,A2),A3))
    <=> ( inj_on(A,B,F3,A3)
        & ~ member(B,aa(A,B,F3,A2),aa(set(A),set(B),image(A,B,F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% inj_on_insert
tff(fact_6429_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F3: fun(B,A),T5: set(B)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(B),set(A),image(B,A,F3),T5))
    <=> ? [U3: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),U3),T5)
          & inj_on(B,A,F3,U3)
          & ( S2 = aa(set(B),set(A),image(B,A,F3),U3) ) ) ) ).

% subset_image_inj
tff(fact_6430_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),C5: set(A),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
         => ( ( aa(set(A),set(B),image(A,B,F3),A3) = aa(set(A),set(B),image(A,B,F3),B3) )
          <=> ( A3 = B3 ) ) ) ) ) ).

% inj_on_image_eq_iff
tff(fact_6431_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),B3: set(A),A2: A,A3: set(A)] :
      ( inj_on(A,B,F3,B3)
     => ( member(A,A2,B3)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ( member(B,aa(A,B,F3,A2),aa(set(A),set(B),image(A,B,F3),A3))
          <=> member(A,A2,A3) ) ) ) ) ).

% inj_on_image_mem_iff
tff(fact_6432_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( order(A)
     => ! [A3: set(A),F3: fun(A,B)] :
          ( ! [X: A,Y3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),X),Y3)
             => ( member(A,X,A3)
               => ( member(A,Y3,A3)
                 => ( aa(A,B,F3,X) != aa(A,B,F3,Y3) ) ) ) )
         => ( ! [X: A,Y3: A] :
                ( member(A,X,A3)
               => ( member(A,Y3,A3)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
                    | aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),X) ) ) )
           => inj_on(A,B,F3,A3) ) ) ) ).

% linorder_inj_onI
tff(fact_6433_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => inj_on(A,B,F3,B3) ) ) ).

% inj_on_subset
tff(fact_6434_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),B3: set(A),A3: set(A)] :
      ( inj_on(A,B,F3,B3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
       => inj_on(A,B,F3,A3) ) ) ).

% subset_inj_on
tff(fact_6435_inj__fn,axiom,
    ! [A: $tType,F3: fun(A,A),N: nat] :
      ( inj_on(A,A,F3,top_top(set(A)))
     => inj_on(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),top_top(set(A))) ) ).

% inj_fn
tff(fact_6436_inj__add__left,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A2),top_top(set(A))) ) ).

% inj_add_left
tff(fact_6437_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A)] : inj_on(A,A,aTP_Lamp_adh(A,fun(A,A),A2),A3) ) ).

% inj_on_add'
tff(fact_6438_inj__on__diff,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,A3)
     => inj_on(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% inj_on_diff
tff(fact_6439_inj__on__add,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [A2: A,A3: set(A)] : inj_on(A,A,aa(A,fun(A,A),plus_plus(A),A2),A3) ) ).

% inj_on_add
tff(fact_6440_inj__on__mult,axiom,
    ! [A: $tType] :
      ( semidom_divide(A)
     => ! [A2: A,A3: set(A)] :
          ( ( A2 != zero_zero(A) )
         => inj_on(A,A,aa(A,fun(A,A),times_times(A),A2),A3) ) ) ).

% inj_on_mult
tff(fact_6441_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [A2: A] : inj_on(A,A,aTP_Lamp_ox(A,fun(A,A),A2),top_top(set(A))) ) ).

% inj_diff_right
tff(fact_6442_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),aa(set(A),set(B),image(A,B,F3),B3))
      <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3) ) ) ).

% inj_image_subset_iff
tff(fact_6443_inj__on__iff__surj,axiom,
    ! [B: $tType,A: $tType,A3: set(A),A8: set(B)] :
      ( ( A3 != bot_bot(set(A)) )
     => ( ? [F5: fun(A,B)] :
            ( inj_on(A,B,F5,A3)
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F5),A3)),A8) )
      <=> ? [G4: fun(B,A)] : ( aa(set(B),set(A),image(B,A,G4),A8) = A3 ) ) ) ).

% inj_on_iff_surj
tff(fact_6444_finite__surj__inj,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),image(A,A,F3),A3))
       => inj_on(A,A,F3,A3) ) ) ).

% finite_surj_inj
tff(fact_6445_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),B3: set(B)] :
      ( inj_on(A,B,F3,A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),B3)
       => ( aa(set(B),$o,finite_finite(B),B3)
         => aa(set(A),$o,finite_finite(A),A3) ) ) ) ).

% inj_on_finite
tff(fact_6446_endo__inj__surj,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),image(A,A,F3),A3)),A3)
       => ( inj_on(A,A,F3,A3)
         => ( aa(set(A),set(A),image(A,A,F3),A3) = A3 ) ) ) ) ).

% endo_inj_surj
tff(fact_6447_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),C5: set(A),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
         => ( aa(set(A),set(B),image(A,B,F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),aa(set(A),set(B),image(A,B,F3),B3)) ) ) ) ) ).

% inj_on_image_Int
tff(fact_6448_image__set__diff,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( aa(set(A),set(B),image(A,B,F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),aa(set(A),set(B),image(A,B,F3),B3)) ) ) ).

% image_set_diff
tff(fact_6449_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),C5: set(A),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),C5)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
         => ( aa(set(A),set(B),image(A,B,F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),aa(set(A),set(B),image(A,B,F3),B3)) ) ) ) ) ).

% inj_on_image_set_diff
tff(fact_6450_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),Xa: B,B3: set(A)] :
      ( inj_on(A,B,F3,A3)
     => ( member(B,Xa,aa(set(A),set(B),image(A,B,F3),A3))
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => member(A,the_inv_into(A,B,A3,F3,Xa),B3) ) ) ) ).

% the_inv_into_into
tff(fact_6451_injective__scaleR,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [C2: real] :
          ( ( C2 != zero_zero(real) )
         => inj_on(A,A,real_V8093663219630862766scaleR(A,C2),top_top(set(A))) ) ) ).

% injective_scaleR
tff(fact_6452_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B)),F3: fun(B,C)] :
      ( ! [I2: A,J2: A] :
          ( member(A,I2,I5)
         => ( member(A,J2,I5)
           => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,I2)),aa(A,set(B),A3,J2))
              | aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),A3,J2)),aa(A,set(B),A3,I2)) ) ) )
     => ( ! [I2: A] :
            ( member(A,I2,I5)
           => inj_on(B,C,F3,aa(A,set(B),A3,I2)) )
       => inj_on(B,C,F3,aa(set(set(B)),set(B),complete_Sup_Sup(set(B)),aa(set(A),set(set(B)),image(A,set(B),A3),I5))) ) ) ).

% inj_on_UNION_chain
tff(fact_6453_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( topolo81223032696312382ous_on(A,B,top_top(set(A)),F3)
         => ( topolo81223032696312382ous_on(A,B,top_top(set(A)),G)
           => topolo7761053866217962861closed(A,collect(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_adi(fun(A,B),fun(fun(A,B),fun(A,$o)),F3),G))) ) ) ) ).

% closed_Collect_le
tff(fact_6454_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(A),B3: set(B),G: fun(B,A)] :
      ( inj_on(A,B,F3,A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),B3)
       => ( inj_on(B,A,G,B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G),B3)),A3)
           => ( aa(set(A),$o,finite_finite(A),A3)
             => ( aa(set(B),$o,finite_finite(B),B3)
               => ( aa(set(A),nat,finite_card(A),A3) = aa(set(B),nat,finite_card(B),B3) ) ) ) ) ) ) ) ).

% card_bij_eq
tff(fact_6455_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set(A),T5: set(B),F3: fun(A,B)] :
      ( aa(set(A),$o,finite_finite(A),S2)
     => ( aa(set(B),$o,finite_finite(B),T5)
       => ( ( aa(set(A),nat,finite_card(A),S2) = aa(set(B),nat,finite_card(B),T5) )
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),S2)),T5)
           => ( ! [X4: B] :
                  ( member(B,X4,T5)
                 => ? [Xa3: A] :
                      ( member(A,Xa3,S2)
                      & ( aa(A,B,F3,Xa3) = X4 ) ) )
            <=> inj_on(A,B,F3,S2) ) ) ) ) ) ).

% surjective_iff_injective_gen
tff(fact_6456_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),aa(set(A),set(A),uminus_uminus(set(A)),A3))),aa(set(B),set(B),uminus_uminus(set(B)),aa(set(A),set(B),image(A,B,F3),A3))) ) ).

% inj_image_Compl_subset
tff(fact_6457_t3__space,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [S2: set(A),Y: A] :
          ( topolo7761053866217962861closed(A,S2)
         => ( ~ member(A,Y,S2)
           => ? [U4: set(A),V5: set(A)] :
                ( topolo1002775350975398744n_open(A,U4)
                & topolo1002775350975398744n_open(A,V5)
                & member(A,Y,U4)
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),V5)
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U4),V5) = bot_bot(set(A)) ) ) ) ) ) ).

% t3_space
tff(fact_6458_t4__space,axiom,
    ! [A: $tType] :
      ( topological_t4_space(A)
     => ! [S2: set(A),T5: set(A)] :
          ( topolo7761053866217962861closed(A,S2)
         => ( topolo7761053866217962861closed(A,T5)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),T5) = bot_bot(set(A)) )
             => ? [U4: set(A),V5: set(A)] :
                  ( topolo1002775350975398744n_open(A,U4)
                  & topolo1002775350975398744n_open(A,V5)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),U4)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T5),V5)
                  & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U4),V5) = bot_bot(set(A)) ) ) ) ) ) ) ).

% t4_space
tff(fact_6459_image__INT,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: fun(A,B),C5: set(A),A3: set(C),B3: fun(C,set(A)),J: C] :
      ( inj_on(A,B,F3,C5)
     => ( ! [X: C] :
            ( member(C,X,A3)
           => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(C,set(A),B3,X)),C5) )
       => ( member(C,J,A3)
         => ( aa(set(A),set(B),image(A,B,F3),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(C),set(set(A)),image(C,set(A),B3),A3))) = aa(set(set(B)),set(B),complete_Inf_Inf(set(B)),aa(set(C),set(set(B)),image(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_adj(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),F3),B3)),A3)) ) ) ) ) ).

% image_INT
tff(fact_6460_nhds__closed,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [Xa: A,A3: set(A)] :
          ( member(A,Xa,A3)
         => ( topolo1002775350975398744n_open(A,A3)
           => ? [A10: set(A)] :
                ( member(A,Xa,A10)
                & topolo7761053866217962861closed(A,A10)
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A10),A3)
                & eventually(A,aTP_Lamp_adk(set(A),fun(A,$o),A10),topolo7230453075368039082e_nhds(A,Xa)) ) ) ) ) ).

% nhds_closed
tff(fact_6461_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(B)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(B),$o,finite_finite(B),B3)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(B),nat,finite_card(B),B3))
         => ? [F4: fun(A,B)] :
              ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F4),A3)),B3)
              & inj_on(A,B,F4,A3) ) ) ) ) ).

% card_le_inj
tff(fact_6462_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(A),B3: set(B)] :
      ( inj_on(A,B,F3,A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),B3)
       => ( aa(set(B),$o,finite_finite(B),B3)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(B),nat,finite_card(B),B3)) ) ) ) ).

% card_inj_on_le
tff(fact_6463_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: set(B)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(B),$o,finite_finite(B),B3)
       => ( ? [F5: fun(A,B)] :
              ( inj_on(A,B,F5,A3)
              & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F5),A3)),B3) )
        <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(B),nat,finite_card(B),B3)) ) ) ) ).

% inj_on_iff_card_le
tff(fact_6464_log__inj,axiom,
    ! [B2: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),one_one(real)),B2)
     => inj_on(real,real,log(B2),set_ord_greaterThan(real,zero_zero(real))) ) ).

% log_inj
tff(fact_6465_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A),F6: set(set(A))] :
          ( topolo2193935891317330818ompact(A,S2)
         => ( ! [T7: set(A)] :
                ( member(set(A),T7,F6)
               => topolo7761053866217962861closed(A,T7) )
           => ( ! [F14: set(set(A))] :
                  ( aa(set(set(A)),$o,finite_finite(set(A)),F14)
                 => ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),F14),F6)
                   => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),F14)) != bot_bot(set(A)) ) ) )
             => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),S2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),F6)) != bot_bot(set(A)) ) ) ) ) ) ).

% compact_imp_fip
tff(fact_6466_compact__fip,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [U2: set(A)] :
          ( topolo2193935891317330818ompact(A,U2)
        <=> ! [A11: set(set(A))] :
              ( ! [X4: set(A)] :
                  ( member(set(A),X4,A11)
                 => topolo7761053866217962861closed(A,X4) )
             => ( ! [B8: set(set(A))] :
                    ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),B8),A11)
                   => ( aa(set(set(A)),$o,finite_finite(set(A)),B8)
                     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B8)) != bot_bot(set(A)) ) ) )
               => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U2),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A11)) != bot_bot(set(A)) ) ) ) ) ) ).

% compact_fip
tff(fact_6467_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(A),B3: set(B),G: fun(B,A)] :
      ( inj_on(A,B,F3,A3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),B3)
       => ( inj_on(B,A,G,B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G),B3)),A3)
           => ? [H3: fun(A,B)] : bij_betw(A,B,H3,A3,B3) ) ) ) ) ).

% Schroeder_Bernstein
tff(fact_6468_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B),P: fun(set(A),$o)] :
      ( ? [T9: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F3),S2))
          & aa(set(A),$o,P,T9) )
    <=> ? [T9: set(B)] :
          ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2)
          & inj_on(B,A,F3,T9)
          & aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),T9)) ) ) ).

% ex_subset_image_inj
tff(fact_6469_inj__on__diff__nat,axiom,
    ! [N6: set(nat),K: nat] :
      ( ! [N2: nat] :
          ( member(nat,N2,N6)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),N2) )
     => inj_on(nat,nat,aTP_Lamp_nw(nat,fun(nat,nat),K),N6) ) ).

% inj_on_diff_nat
tff(fact_6470_inj__int__encode,axiom,
    ! [A3: set(int)] : inj_on(int,nat,nat_int_encode,A3) ).

% inj_int_encode
tff(fact_6471_inj__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => inj_on(nat,A,semiring_1_of_nat(A),top_top(set(nat))) ) ).

% inj_of_nat
tff(fact_6472_inj__on__of__nat,axiom,
    ! [A: $tType] :
      ( semiring_char_0(A)
     => ! [N6: set(nat)] : inj_on(nat,A,semiring_1_of_nat(A),N6) ) ).

% inj_on_of_nat
tff(fact_6473_inj__Suc,axiom,
    ! [N6: set(nat)] : inj_on(nat,nat,suc,N6) ).

% inj_Suc
tff(fact_6474_inj__prod__encode,axiom,
    ! [A3: set(product_prod(nat,nat))] : inj_on(product_prod(nat,nat),nat,nat_prod_encode,A3) ).

% inj_prod_encode
tff(fact_6475_inj__on__set__encode,axiom,
    inj_on(set(nat),nat,nat_set_encode,collect(set(nat),finite_finite(nat))) ).

% inj_on_set_encode
tff(fact_6476_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [X6: fun($o,A),Y6: fun($o,A)] :
          ( aa(fun($o,A),$o,aa(fun($o,A),fun(fun($o,A),$o),ord_less_eq(fun($o,A)),X6),Y6)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,X6,$false)),aa($o,A,Y6,$false))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa($o,A,X6,$true)),aa($o,A,Y6,$true)) ) ) ) ).

% le_rel_bool_arg_iff
tff(fact_6477_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ~ aa(set(A),$o,finite_finite(A),S2)
    <=> ? [F5: fun(nat,A)] :
          ( inj_on(nat,A,F5,top_top(set(nat)))
          & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(nat),set(A),image(nat,A,F5),top_top(set(nat)))),S2) ) ) ).

% infinite_iff_countable_subset
tff(fact_6478_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set(A)] :
      ( ~ aa(set(A),$o,finite_finite(A),S2)
     => ? [F4: fun(nat,A)] :
          ( inj_on(nat,A,F4,top_top(set(nat)))
          & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(nat),set(A),image(nat,A,F4),top_top(set(nat)))),S2) ) ) ).

% infinite_countable_subset
tff(fact_6479_summable__reindex,axiom,
    ! [F3: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F3)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,X))
         => summable(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F3),G)) ) ) ) ).

% summable_reindex
tff(fact_6480_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F3: fun(A,A),S: A] :
      ( ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),S) = S )
     => ( ! [M2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),M2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M2),N)
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M2),F3),S) != S ) ) )
       => inj_on(nat,A,aa(A,fun(nat,A),aTP_Lamp_adl(fun(A,A),fun(A,fun(nat,A)),F3),S),set_or7035219750837199246ssThan(nat,zero_zero(nat),N)) ) ) ).

% inj_on_funpow_least
tff(fact_6481_suminf__reindex__mono,axiom,
    ! [F3: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F3)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,X))
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F3),G))),suminf(real,F3)) ) ) ) ).

% suminf_reindex_mono
tff(fact_6482_suminf__reindex,axiom,
    ! [F3: fun(nat,real),G: fun(nat,nat)] :
      ( summable(real,F3)
     => ( inj_on(nat,nat,G,top_top(set(nat)))
       => ( ! [X: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,X))
         => ( ! [X: nat] :
                ( ~ member(nat,X,aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat))))
               => ( aa(nat,real,F3,X) = zero_zero(real) ) )
           => ( suminf(real,aa(fun(nat,nat),fun(nat,real),comp(nat,real,nat,F3),G)) = suminf(real,F3) ) ) ) ) ) ).

% suminf_reindex
tff(fact_6483_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B),P: fun(set(A),$o)] :
      ( ! [T9: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F3),S2))
         => aa(set(A),$o,P,T9) )
    <=> ! [T9: set(B)] :
          ( ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2)
            & inj_on(B,A,F3,T9) )
         => aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),T9)) ) ) ).

% all_subset_image_inj
tff(fact_6484_surj__int__decode,axiom,
    aa(set(nat),set(int),image(nat,int,nat_int_decode),top_top(set(nat))) = top_top(set(int)) ).

% surj_int_decode
tff(fact_6485_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: fun(nat,set(A)),N: nat] : ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_ord_atMost(nat,N))) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),M7),set_or1337092689740270186AtMost(nat,one_one(nat),N)))),aa(nat,set(A),M7,zero_zero(nat))) ) ).

% UN_le_eq_Un0
tff(fact_6486_le__sup__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y)),Z)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Z) ) ) ) ).

% le_sup_iff
tff(fact_6487_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A2)
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2) ) ) ) ).

% sup.bounded_iff
tff(fact_6488_Un__subset__iff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)),C5)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5) ) ) ).

% Un_subset_iff
tff(fact_6489_Un__Diff__cancel,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3) ) ).

% Un_Diff_cancel
tff(fact_6490_Un__Diff__cancel2,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)),A3) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),A3) ) ).

% Un_Diff_cancel2
tff(fact_6491_int__decode__inverse,axiom,
    ! [N: nat] : ( aa(int,nat,nat_int_encode,aa(nat,int,nat_int_decode,N)) = N ) ).

% int_decode_inverse
tff(fact_6492_int__encode__inverse,axiom,
    ! [Xa: int] : ( aa(nat,int,nat_int_decode,aa(int,nat,nat_int_encode,Xa)) = Xa ) ).

% int_encode_inverse
tff(fact_6493_Compl__Diff__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),uminus_uminus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),uminus_uminus(set(A)),A3)),B3) ) ).

% Compl_Diff_eq
tff(fact_6494_inj__int__decode,axiom,
    ! [A3: set(nat)] : inj_on(nat,int,nat_int_decode,A3) ).

% inj_int_decode
tff(fact_6495_sup__Inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A2: A,B3: set(A)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),aa(set(A),A,complete_Inf_Inf(A),B3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image(A,A,aa(A,fun(A,A),sup_sup(A),A2)),B3)) ) ) ).

% sup_Inf
tff(fact_6496_Inf__sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),B3)),A2) = top_top(A) )
        <=> ! [X4: A] :
              ( member(A,X4,B3)
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),X4),A2) = top_top(A) ) ) ) ) ).

% Inf_sup_eq_top_iff
tff(fact_6497_INF__sup__distrib2,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),A3: set(B),G: fun(C,A),B3: set(C)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,G),B3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_adn(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),F3),G),B3)),A3)) ) ) ).

% INF_sup_distrib2
tff(fact_6498_sup__INF,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A2: A,F3: fun(B,A),B3: set(B)] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),B3))) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ado(A,fun(fun(B,A),fun(B,A)),A2),F3)),B3)) ) ) ).

% sup_INF
tff(fact_6499_Inf__sup,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [B3: set(A),A2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),B3)),A2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),image(A,A,aTP_Lamp_adp(A,fun(A,A),A2)),B3)) ) ) ).

% Inf_sup
tff(fact_6500_INF__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [F3: fun(B,A),B3: set(B),A2: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),B3))),A2) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(A,fun(B,A),aTP_Lamp_adq(fun(B,A),fun(A,fun(B,A)),F3),A2)),B3)) ) ) ).

% INF_sup
tff(fact_6501_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
tff(fact_6502_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] :
      ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),C5) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C5)) )
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),A3) ) ).

% Un_Int_assoc_eq
tff(fact_6503_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(3)
tff(fact_6504_Un__mono,axiom,
    ! [A: $tType,A3: set(A),C5: set(A),B3: set(A),D3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),D3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),C5),D3)) ) ) ).

% Un_mono
tff(fact_6505_Un__least,axiom,
    ! [A: $tType,A3: set(A),C5: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),C5)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)),C5) ) ) ).

% Un_least
tff(fact_6506_Un__upper1,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) ).

% Un_upper1
tff(fact_6507_Un__upper2,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) ).

% Un_upper2
tff(fact_6508_Un__absorb1,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3) = B3 ) ) ).

% Un_absorb1
tff(fact_6509_Un__absorb2,axiom,
    ! [A: $tType,B3: set(A),A3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3) = A3 ) ) ).

% Un_absorb2
tff(fact_6510_subset__UnE,axiom,
    ! [A: $tType,C5: set(A),A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))
     => ~ ! [A10: set(A)] :
            ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A10),A3)
           => ! [B13: set(A)] :
                ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B13),B3)
               => ( C5 != aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A10),B13) ) ) ) ) ).

% subset_UnE
tff(fact_6511_subset__Un__eq,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
    <=> ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3) = B3 ) ) ).

% subset_Un_eq
tff(fact_6512_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% sup.coboundedI2
tff(fact_6513_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% sup.coboundedI1
tff(fact_6514_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = B2 ) ) ) ).

% sup.absorb_iff2
tff(fact_6515_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = A2 ) ) ) ).

% sup.absorb_iff1
tff(fact_6516_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ).

% sup.cobounded2
tff(fact_6517_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ).

% sup.cobounded1
tff(fact_6518_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
        <=> ( A2 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) ) ) ) ).

% sup.order_iff
tff(fact_6519_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A2) ) ) ) ).

% sup.boundedI
tff(fact_6520_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),B2),C2)),A2)
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2) ) ) ) ).

% sup.boundedE
tff(fact_6521_sup__absorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y) = Y ) ) ) ).

% sup_absorb2
tff(fact_6522_sup__absorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y) = Xa ) ) ) ).

% sup_absorb1
tff(fact_6523_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B2)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = B2 ) ) ) ).

% sup.absorb2
tff(fact_6524_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) = A2 ) ) ) ).

% sup.absorb1
tff(fact_6525_sup__unique,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [F3: fun(A,fun(A,A)),Xa: A,Y: A] :
          ( ! [X: A,Y3: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),aa(A,A,aa(A,fun(A,A),F3,X),Y3))
         => ( ! [X: A,Y3: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),aa(A,A,aa(A,fun(A,A),F3,X),Y3))
           => ( ! [X: A,Y3: A,Z4: A] :
                  ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),X)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z4),X)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),F3,Y3),Z4)),X) ) )
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y) = aa(A,A,aa(A,fun(A,A),F3,Xa),Y) ) ) ) ) ) ).

% sup_unique
tff(fact_6526_sup_OorderI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,B2: A] :
          ( ( A2 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2) ) ) ).

% sup.orderI
tff(fact_6527_sup_OorderE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),A2)
         => ( A2 = aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2) ) ) ) ).

% sup.orderE
tff(fact_6528_le__iff__sup,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
        <=> ( aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y) = Y ) ) ) ).

% le_iff_sup
tff(fact_6529_sup__least,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,Xa: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z)),Xa) ) ) ) ).

% sup_least
tff(fact_6530_sup__mono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),D2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D2)) ) ) ) ).

% sup_mono
tff(fact_6531_sup_Omono,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),D2),B2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),C2),D2)),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ) ).

% sup.mono
tff(fact_6532_le__supI2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Xa: A,B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),B2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% le_supI2
tff(fact_6533_le__supI1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Xa: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)) ) ) ).

% le_supI1
tff(fact_6534_sup__ge2,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Y: A,Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y)) ) ).

% sup_ge2
tff(fact_6535_sup__ge1,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y)) ) ).

% sup_ge1
tff(fact_6536_le__supI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,Xa: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),Xa)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)),Xa) ) ) ) ).

% le_supI
tff(fact_6537_le__supE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A2: A,B2: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),A2),B2)),Xa)
         => ~ ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),Xa)
             => ~ aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),Xa) ) ) ) ).

% le_supE
tff(fact_6538_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Xa: A,Y: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y)) ) ).

% inf_sup_ord(3)
tff(fact_6539_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Y: A,Xa: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y)) ) ).

% inf_sup_ord(4)
tff(fact_6540_Un__Pow__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),sup_sup(set(set(A))),pow2(A,A3)),pow2(A,B3))),pow2(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))) ).

% Un_Pow_subset
tff(fact_6541_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Xa: A,Y: A,Z: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),aa(A,A,aa(A,fun(A,A),inf_inf(A),Y),Z))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Z))) ) ).

% distrib_sup_le
tff(fact_6542_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [Xa: A,Y: A,Z: A] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y)),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Z))),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z))) ) ).

% distrib_inf_le
tff(fact_6543_Diff__subset__conv,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),C5)
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C5)) ) ).

% Diff_subset_conv
tff(fact_6544_Diff__partition,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)) = B3 ) ) ).

% Diff_partition
tff(fact_6545_Un__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)),C5) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C5)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),C5)) ) ).

% Un_Diff
tff(fact_6546_int__decode__eq,axiom,
    ! [Xa: nat,Y: nat] :
      ( ( aa(nat,int,nat_int_decode,Xa) = aa(nat,int,nat_int_decode,Y) )
    <=> ( Xa = Y ) ) ).

% int_decode_eq
tff(fact_6547_Diff__Un,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),C5)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C5)) ) ).

% Diff_Un
tff(fact_6548_Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),C5: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),C5)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),C5)) ) ).

% Diff_Int
tff(fact_6549_Int__Diff__Un,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) = A3 ) ).

% Int_Diff_Un
tff(fact_6550_Un__Diff__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)) = A3 ) ).

% Un_Diff_Int
tff(fact_6551_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or3652927894154168847AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(6)
tff(fact_6552_sup__shunt,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A] :
          ( ( aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),Y) = top_top(A) )
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,uminus_uminus(A),Xa)),Y) ) ) ).

% sup_shunt
tff(fact_6553_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [P2: A,Q2: A,R: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P2),aa(A,A,aa(A,fun(A,A),sup_sup(A),Q2),R))
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),P2),aa(A,A,uminus_uminus(A),Q2))),R) ) ) ).

% sup_neg_inf
tff(fact_6554_shunt2,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),aa(A,A,uminus_uminus(A),Y))),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),sup_sup(A),Y),Z)) ) ) ).

% shunt2
tff(fact_6555_shunt1,axiom,
    ! [A: $tType] :
      ( boolea8198339166811842893lgebra(A)
     => ! [Xa: A,Y: A,Z: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),Y)),Z)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(A,A,uminus_uminus(A),Y)),Z)) ) ) ).

% shunt1
tff(fact_6556_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A),B3: set(A)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ).

% less_eq_Inf_inter
tff(fact_6557_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(7)
tff(fact_6558_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_lessThan(A,L)),set_or7035219750837199246ssThan(A,L,U)) = set_ord_lessThan(A,U) ) ) ) ).

% ivl_disj_un_one(2)
tff(fact_6559_card__Un__le,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3))) ).

% card_Un_le
tff(fact_6560_atLeastLessThan__add__Un,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( set_or7035219750837199246ssThan(nat,I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),K)) = aa(set(nat),set(nat),aa(set(nat),fun(set(nat),set(nat)),sup_sup(set(nat)),set_or7035219750837199246ssThan(nat,I,J)),set_or7035219750837199246ssThan(nat,J,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),K))) ) ) ).

% atLeastLessThan_add_Un
tff(fact_6561_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or3652927894154168847AtMost(A,M,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(8)
tff(fact_6562_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,U)),set_ord_atLeast(A,U)) = set_ord_atLeast(A,L) ) ) ) ).

% ivl_disj_un_one(8)
tff(fact_6563_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_atMost(A,L)),set_or3652927894154168847AtMost(A,L,U)) = set_ord_atMost(A,U) ) ) ) ).

% ivl_disj_un_one(3)
tff(fact_6564_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,U)),set_ord_greaterThan(A,U)) = set_ord_greaterThan(A,L) ) ) ) ).

% ivl_disj_un_one(5)
tff(fact_6565_Inter__Un__subset,axiom,
    ! [A: $tType,A3: set(set(A)),B3: set(set(A))] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),A3)),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),B3))),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),aa(set(set(A)),set(set(A)),aa(set(set(A)),fun(set(set(A)),set(set(A))),inf_inf(set(set(A))),A3),B3))) ).

% Inter_Un_subset
tff(fact_6566_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
tff(fact_6567_sum_Ounion__inter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ).

% sum.union_inter
tff(fact_6568_prod_Ounion__inter,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ).

% prod.union_inter
tff(fact_6569_infinite__imp__bij__betw2,axiom,
    ! [A: $tType,A3: set(A),A2: A] :
      ( ~ aa(set(A),$o,finite_finite(A),A3)
     => ? [H3: fun(A,A)] : bij_betw(A,A,H3,A3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A))))) ) ).

% infinite_imp_bij_betw2
tff(fact_6570_card__Un__Int,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ).

% card_Un_Int
tff(fact_6571_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
tff(fact_6572_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,M)),set_or7035219750837199246ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(1)
tff(fact_6573_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_ord_lessThan(A,L)),set_or1337092689740270186AtMost(A,L,U)) = set_ord_atMost(A,U) ) ) ) ).

% ivl_disj_un_one(4)
tff(fact_6574_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or3652927894154168847AtMost(A,L,M)),set_or5935395276787703475ssThan(A,M,U)) = set_or5935395276787703475ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(2)
tff(fact_6575_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,U)),set_ord_greaterThan(A,U)) = set_ord_atLeast(A,L) ) ) ) ).

% ivl_disj_un_one(7)
tff(fact_6576_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: A,B3: A] : ( aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),aa(set(A),A,complete_Sup_Sup(A),aa(set(nat),set(A),image(nat,A,aTP_Lamp_op(A,fun(nat,A),B3)),collect(nat,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)))))) = aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B3) ) ) ).

% SUP_nat_binary
tff(fact_6577_bij__int__decode,axiom,
    bij_betw(nat,int,nat_int_decode,top_top(set(nat)),top_top(set(int))) ).

% bij_int_decode
tff(fact_6578_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => semila1105856199041335345_order(A,sup_sup(A),bot_bot(A),aTP_Lamp_adr(A,fun(A,$o)),aTP_Lamp_ads(A,fun(A,$o))) ) ).

% sup_bot.semilattice_neutr_order_axioms
tff(fact_6579_sum_Ounion__inter__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
                 => ( aa(A,B,G,X) = zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ) ).

% sum.union_inter_neutral
tff(fact_6580_sum__Un,axiom,
    ! [B: $tType,A: $tType] :
      ( ab_group_add(B)
     => ! [A3: set(A),B3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ).

% sum_Un
tff(fact_6581_sum_Ounion__disjoint,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),B3)) ) ) ) ) ) ).

% sum.union_disjoint
tff(fact_6582_prod_Ounion__inter__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
                 => ( aa(A,B,G,X) = one_one(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ) ).

% prod.union_inter_neutral
tff(fact_6583_prod_Ounion__disjoint,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),B3)) ) ) ) ) ) ).

% prod.union_disjoint
tff(fact_6584_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or7035219750837199246ssThan(A,L,U)),aa(set(A),set(A),insert(A,U),bot_bot(set(A)))) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(6)
tff(fact_6585_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))
         => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ).

% sum_Un2
tff(fact_6586_sum_Ounion__diff2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7311177749621191930dd_sum(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ).

% sum.union_diff2
tff(fact_6587_prod_Ounion__diff2,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [A3: set(A),B3: set(A),G: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3)))),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),G),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ).

% prod.union_diff2
tff(fact_6588_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
         => ( aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ) ).

% card_Un_disjoint
tff(fact_6589_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(A),B3: set(A)] :
      ( inj_on(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))
    <=> ( inj_on(A,B,F3,A3)
        & inj_on(A,B,F3,B3)
        & ( aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),image(A,B,F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3))),aa(set(A),set(B),image(A,B,F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3))) = bot_bot(set(B)) ) ) ) ).

% inj_on_Un
tff(fact_6590_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),U)
         => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(A),set(A),insert(A,L),bot_bot(set(A)))),set_or3652927894154168847AtMost(A,L,U)) = set_or1337092689740270186AtMost(A,L,U) ) ) ) ).

% ivl_disj_un_singleton(5)
tff(fact_6591_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or1337092689740270186AtMost(A,L,M)),set_or5935395276787703475ssThan(A,M,U)) = set_or7035219750837199246ssThan(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(4)
tff(fact_6592_sum__Un__nat,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),$o,finite_finite(A),B3)
       => ( aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),B3))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ).

% sum_Un_nat
tff(fact_6593_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: A,M: A,U: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),L),M)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),U)
           => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),set_or5935395276787703475ssThan(A,L,M)),set_or1337092689740270186AtMost(A,M,U)) = set_or3652927894154168847AtMost(A,L,U) ) ) ) ) ).

% ivl_disj_un_two(5)
tff(fact_6594_prod__Un,axiom,
    ! [B: $tType,A: $tType] :
      ( field(B)
     => ! [A3: set(A),B3: set(A),F3: fun(A,B)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ! [X: A] :
                  ( member(A,X,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))
                 => ( aa(A,B,F3,X) != zero_zero(B) ) )
             => ( aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = divide_divide(B,aa(B,B,aa(B,fun(B,B),times_times(B),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),B3)),aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ) ).

% prod_Un
tff(fact_6595_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: fun(A,B),C5: set(A),B3: set(A),Xa: A] :
      ( inj_on(A,B,G,C5)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C5),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))
       => member(fun(B,A),aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_adt(fun(A,B),fun(set(A),fun(A,fun(B,A))),G),C5),Xa),bNF_Wellorder_Func(B,A,top_top(set(B)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),B3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ).

% If_the_inv_into_in_Func
tff(fact_6596_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A3: fun(B,set(A)),I: B,B3: set(A),J4: set(B)] :
      ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),fun_upd(B,set(A),A3,I,B3)),J4))
      = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),J4),aa(set(B),set(B),insert(B,I),bot_bot(set(B))))))),$ite(member(B,I,J4),B3,bot_bot(set(A)))) ) ).

% UNION_fun_upd
tff(fact_6597_filtercomap__sup,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),F12: filter(B),F22: filter(B)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),sup_sup(filter(A)),filtercomap(A,B,F3,F12)),filtercomap(A,B,F3,F22))),filtercomap(A,B,F3,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),sup_sup(filter(B)),F12),F22))) ).

% filtercomap_sup
tff(fact_6598_sup__nat__def,axiom,
    sup_sup(nat) = ord_max(nat) ).

% sup_nat_def
tff(fact_6599_sup__int__def,axiom,
    sup_sup(int) = ord_max(int) ).

% sup_int_def
tff(fact_6600_ge__eq__refl,axiom,
    ! [A: $tType,R2: fun(A,fun(A,$o)),Xa: A] :
      ( aa(fun(A,fun(A,$o)),$o,aa(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),$o),ord_less_eq(fun(A,fun(A,$o))),fequal(A)),R2)
     => aa(A,$o,aa(A,fun(A,$o),R2,Xa),Xa) ) ).

% ge_eq_refl
tff(fact_6601_refl__ge__eq,axiom,
    ! [A: $tType,R2: fun(A,fun(A,$o))] :
      ( ! [X: A] : aa(A,$o,aa(A,fun(A,$o),R2,X),X)
     => aa(fun(A,fun(A,$o)),$o,aa(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),$o),ord_less_eq(fun(A,fun(A,$o))),fequal(A)),R2) ) ).

% refl_ge_eq
tff(fact_6602_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),Xa: B,Y: A,A3: set(B)] :
      ( aa(set(B),set(A),image(B,A,fun_upd(B,A,F3,Xa,Y)),A3)
      = $ite(member(B,Xa,A3),aa(set(A),set(A),insert(A,Y),aa(set(B),set(A),image(B,A,F3),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,Xa),bot_bot(set(B)))))),aa(set(B),set(A),image(B,A,F3),A3)) ) ).

% fun_upd_image
tff(fact_6603_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: fun(B,A),A14: set(B),B1: set(A),F2: fun(C,D),B22: set(C),A25: set(D)] :
      ( ( aa(set(B),set(A),image(B,A,F1),A14) = B1 )
     => ( inj_on(C,D,F2,B22)
       => ( aa(set(D),$o,aa(set(D),fun(set(D),$o),ord_less_eq(set(D)),aa(set(C),set(D),image(C,D,F2),B22)),A25)
         => ( ( ( B22 = bot_bot(set(C)) )
             => ( A25 = bot_bot(set(D)) ) )
           => ( bNF_Wellorder_Func(C,A,B22,B1) = aa(set(fun(D,B)),set(fun(C,A)),image(fun(D,B),fun(C,A),bNF_We4925052301507509544nc_map(C,B,A,D,B22,F1,F2)),bNF_Wellorder_Func(D,B,A25,A14)) ) ) ) ) ) ).

% Func_map_surj
tff(fact_6604_pos__deriv__imp__strict__mono,axiom,
    ! [F3: fun(real,real),F9: fun(real,real)] :
      ( ! [X: real] : has_field_derivative(real,F3,aa(real,real,F9,X),topolo174197925503356063within(real,X,top_top(set(real))))
     => ( ! [X: real] : aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(real,real,F9,X))
       => order_strict_mono(real,real,F3) ) ) ).

% pos_deriv_imp_strict_mono
tff(fact_6605_strict__mono__add,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [K: A] : order_strict_mono(A,A,aTP_Lamp_nx(A,fun(A,A),K)) ) ).

% strict_mono_add
tff(fact_6606_tanh__real__strict__mono,axiom,
    order_strict_mono(real,real,tanh(real)) ).

% tanh_real_strict_mono
tff(fact_6607_sinh__real__strict__mono,axiom,
    order_strict_mono(real,real,sinh(real)) ).

% sinh_real_strict_mono
tff(fact_6608_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F3: fun(A,B),Xa: A,Y: A] :
          ( order_strict_mono(A,B,F3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa)),aa(A,B,F3,Y))
          <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ).

% strict_mono_less_eq
tff(fact_6609_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [R: fun(A,B),M: A,N: A] :
          ( order_strict_mono(A,B,R)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),N)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,R,M)),aa(A,B,R,N)) ) ) ) ).

% strict_mono_leD
tff(fact_6610_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: fun(A,B),A25: set(A),A14: set(B),F1: fun(B,C),B1: set(C),F2: fun(D,A),B22: set(D)] :
      ( member(fun(A,B),G,bNF_Wellorder_Func(A,B,A25,A14))
     => ( aa(set(C),$o,aa(set(C),fun(set(C),$o),ord_less_eq(set(C)),aa(set(B),set(C),image(B,C,F1),A14)),B1)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(D),set(A),image(D,A,F2),B22)),A25)
         => member(fun(D,C),aa(fun(A,B),fun(D,C),bNF_We4925052301507509544nc_map(D,B,C,A,B22,F1,F2),G),bNF_Wellorder_Func(D,C,B22,B1)) ) ) ) ).

% Func_map
tff(fact_6611_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( ring_1_of_int(A) = aa(fun(product_prod(nat,nat),A),fun(int,A),map_fun(int,product_prod(nat,nat),A,A,rep_Integ,id(A)),product_case_prod(nat,nat,A,aTP_Lamp_ng(nat,fun(nat,A)))) ) ) ).

% ring_1_class.of_int_def
tff(fact_6612_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] : ( aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = case_option(int,num,zero_zero(int),aTP_Lamp_adu(num,fun(num,int),M),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M),N)) ) ).

% take_bit_numeral_minus_numeral_int
tff(fact_6613_of__nat__eq__id,axiom,
    semiring_1_of_nat(nat) = id(nat) ).

% of_nat_eq_id
tff(fact_6614_id__funpow,axiom,
    ! [A: $tType,N: nat] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),id(A)) = id(A) ) ).

% id_funpow
tff(fact_6615_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se4730199178511100633sh_bit(A,zero_zero(nat)) = id(A) ) ) ).

% push_bit_0_id
tff(fact_6616_drop__bit__0,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ( bit_se4197421643247451524op_bit(A,zero_zero(nat)) = id(A) ) ) ).

% drop_bit_0
tff(fact_6617_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: num,N: num] : ( aa(A,A,bit_se2584673776208193580ke_bit(A,aa(num,nat,numeral_numeral(nat),M)),aa(num,A,numeral_numeral(A),N)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_take_bit_num(aa(num,nat,numeral_numeral(nat),M),N)) ) ) ).

% take_bit_numeral_numeral
tff(fact_6618_strict__mono__imp__increasing,axiom,
    ! [F3: fun(nat,nat),N: nat] :
      ( order_strict_mono(nat,nat,F3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(nat,nat,F3,N)) ) ).

% strict_mono_imp_increasing
tff(fact_6619_less__eq__int__def,axiom,
    ord_less_eq(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(int,fun(int,$o)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(int,$o),rep_Integ,map_fun(int,product_prod(nat,nat),$o,$o,rep_Integ,id($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_nk(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_eq_int_def
tff(fact_6620_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F3: fun(A,A)] : ( aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),zero_zero(nat)),F3) = id(A) ) ).

% funpow_simps_right(1)
tff(fact_6621_less__int__def,axiom,
    ord_less(int) = aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(int,fun(int,$o)),map_fun(int,product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(int,$o),rep_Integ,map_fun(int,product_prod(nat,nat),$o,$o,rep_Integ,id($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_ni(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_int_def
tff(fact_6622_nat__def,axiom,
    nat2 = aa(fun(product_prod(nat,nat),nat),fun(int,nat),map_fun(int,product_prod(nat,nat),nat,nat,rep_Integ,id(nat)),product_case_prod(nat,nat,nat,minus_minus(nat))) ).

% nat_def
tff(fact_6623_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A)] :
          ( order_strict_mono(nat,A,F3)
        <=> ! [N5: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,N5)),aa(nat,A,F3,aa(nat,nat,suc,N5))) ) ) ).

% strict_mono_Suc_iff
tff(fact_6624_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [G: fun(nat,nat),F3: fun(nat,A)] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N2: nat] :
                ( ~ member(nat,N2,aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat))))
               => ( aa(nat,A,F3,N2) = zero_zero(A) ) )
           => ( summable(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adv(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F3))
            <=> summable(A,F3) ) ) ) ) ).

% summable_mono_reindex
tff(fact_6625_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [G: fun(nat,nat),F3: fun(nat,A),C2: A] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N2: nat] :
                ( ~ member(nat,N2,aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat))))
               => ( aa(nat,A,F3,N2) = zero_zero(A) ) )
           => ( sums(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adv(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F3),C2)
            <=> sums(A,F3,C2) ) ) ) ) ).

% sums_mono_reindex
tff(fact_6626_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [G: fun(nat,nat),F3: fun(nat,A)] :
          ( order_strict_mono(nat,nat,G)
         => ( ! [N2: nat] :
                ( ~ member(nat,N2,aa(set(nat),set(nat),image(nat,nat,G),top_top(set(nat))))
               => ( aa(nat,A,F3,N2) = zero_zero(A) ) )
           => ( suminf(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adw(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),G),F3)) = suminf(A,F3) ) ) ) ) ).

% suminf_mono_reindex
tff(fact_6627_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [F3: fun(nat,A),G: fun(nat,nat)] :
          ( ! [X: nat,Y3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Y3)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,F3,X))),real_V7770717601297561774m_norm(A,aa(nat,A,F3,Y3))) )
         => ( order_strict_mono(nat,nat,G)
           => ( bfun(nat,A,aa(fun(nat,nat),fun(nat,A),aTP_Lamp_adx(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),F3),G),at_top(nat))
            <=> bfun(nat,A,F3,at_top(nat)) ) ) ) ) ).

% increasing_Bseq_subseq_iff
tff(fact_6628_and__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,bitM(N))) ) ).

% and_minus_numerals(3)
tff(fact_6629_and__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),bit0(N)))),aa(num,int,numeral_numeral(int),M)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,bitM(N))) ) ).

% and_minus_numerals(7)
tff(fact_6630_and__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))),aa(num,int,numeral_numeral(int),M)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,bit0(N))) ) ).

% and_minus_numerals(8)
tff(fact_6631_and__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),aa(num,num,bit1,N)))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,bit0(N))) ) ).

% and_minus_numerals(4)
tff(fact_6632_int__numeral__and__not__num,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(M,N)) ) ).

% int_numeral_and_not_num
tff(fact_6633_int__numeral__not__and__num,axiom,
    ! [M: num,N: num] : ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),N)) = case_option(int,num,zero_zero(int),numeral_numeral(int),bit_and_not_num(N,M)) ) ).

% int_numeral_not_and_num
tff(fact_6634_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set(A),F3: fun(A,fun(B,B)),G: fun(C,A),R2: set(C)] :
      ( finite673082921795544331dem_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,G),top_top(set(C)))),S2)
       => finite673082921795544331dem_on(C,B,R2,aa(fun(C,A),fun(C,fun(B,B)),comp(A,fun(B,B),C,F3),G)) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
tff(fact_6635_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( aa(rat,$o,positive,aa(int,rat,aa(int,fun(int,rat),fract,A2),B2))
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),A2),B2)) ) ).

% positive_rat
tff(fact_6636_Rat_Opositive__zero,axiom,
    ~ aa(rat,$o,positive,zero_zero(rat)) ).

% Rat.positive_zero
tff(fact_6637_Rat_Opositive__mult,axiom,
    ! [Xa: rat,Y: rat] :
      ( aa(rat,$o,positive,Xa)
     => ( aa(rat,$o,positive,Y)
       => aa(rat,$o,positive,aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),Xa),Y)) ) ) ).

% Rat.positive_mult
tff(fact_6638_Rat_Opositive__minus,axiom,
    ! [Xa: rat] :
      ( ~ aa(rat,$o,positive,Xa)
     => ( ( Xa != zero_zero(rat) )
       => aa(rat,$o,positive,aa(rat,rat,uminus_uminus(rat),Xa)) ) ) ).

% Rat.positive_minus
tff(fact_6639_less__rat__def,axiom,
    ! [Xa: rat,Y: rat] :
      ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),Xa),Y)
    <=> aa(rat,$o,positive,aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),Y),Xa)) ) ).

% less_rat_def
tff(fact_6640_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),L),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(set(nat),set(A),image(nat,A,nth(A,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),L)) = aa(list(A),set(A),set2(A),take(A,L,Xs)) ) ) ).

% nth_image
tff(fact_6641_num__of__integer__code,axiom,
    ! [K: code_integer] :
      ( code_num_of_integer(K)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),K),one_one(code_integer)),one2,aa(product_prod(code_integer,code_integer),num,product_case_prod(code_integer,code_integer,num,aTP_Lamp_ady(code_integer,fun(code_integer,num))),code_divmod_integer(K,aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))))) ) ).

% num_of_integer_code
tff(fact_6642_take__all,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)
     => ( take(A,N,Xs) = Xs ) ) ).

% take_all
tff(fact_6643_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( take(A,N,Xs) = Xs )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% take_all_iff
tff(fact_6644_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A),Y: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => ( take(A,N,list_update(A,Xs,M,Y)) = take(A,N,Xs) ) ) ).

% take_update_cancel
tff(fact_6645_set__take__subset,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),take(A,N,Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% set_take_subset
tff(fact_6646_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),take(A,M,Xs))),aa(list(A),set(A),set2(A),take(A,N,Xs))) ) ).

% set_take_subset_set_take
tff(fact_6647_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Ys: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K),aa(list(A),nat,size_size(list(A)),Ys))
       => ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),K)
             => ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,nth(A,Ys),I2) ) )
         => ( take(A,K,Xs) = take(A,K,Ys) ) ) ) ) ).

% nth_take_lemma
tff(fact_6648_dual__max,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( max(A,aTP_Lamp_zr(A,fun(A,$o))) = ord_min(A) ) ) ).

% dual_max
tff(fact_6649_dual__min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( min(A,aTP_Lamp_zr(A,fun(A,$o))) = ord_max(A) ) ) ).

% dual_min
tff(fact_6650_filterlim__finite__subsets__at__top,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,set(B)),A3: set(B),F6: filter(A)] :
      ( filterlim(A,set(B),F3,finite5375528669736107172at_top(B,A3),F6)
    <=> ! [X9: set(B)] :
          ( ( aa(set(B),$o,finite_finite(B),X9)
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),X9),A3) )
         => eventually(A,aa(set(B),fun(A,$o),aa(set(B),fun(set(B),fun(A,$o)),aTP_Lamp_adz(fun(A,set(B)),fun(set(B),fun(set(B),fun(A,$o))),F3),A3),X9),F6) ) ) ).

% filterlim_finite_subsets_at_top
tff(fact_6651_card__Min__le__sum,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(nat),nat,lattic643756798350308766er_Min(nat),aa(set(A),set(nat),image(A,nat,F3),A3)))),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)) ) ).

% card_Min_le_sum
tff(fact_6652_eventually__finite__subsets__at__top__weakI,axiom,
    ! [A: $tType,A3: set(A),P: fun(set(A),$o)] :
      ( ! [X7: set(A)] :
          ( aa(set(A),$o,finite_finite(A),X7)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X7),A3)
           => aa(set(A),$o,P,X7) ) )
     => eventually(set(A),P,finite5375528669736107172at_top(A,A3)) ) ).

% eventually_finite_subsets_at_top_weakI
tff(fact_6653_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,lattic643756798350308766er_Min(A),A3))
            <=> ! [X4: A] :
                  ( member(A,X4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),X4) ) ) ) ) ) ).

% Min.bounded_iff
tff(fact_6654_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),A3)),A2) ) ) ) ).

% Min.coboundedI
tff(fact_6655_Min__eqI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [Y3: A] :
                ( member(A,Y3,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y3) )
           => ( member(A,Xa,A3)
             => ( aa(set(A),A,lattic643756798350308766er_Min(A),A3) = Xa ) ) ) ) ) ).

% Min_eqI
tff(fact_6656_Min__le,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),A3)),Xa) ) ) ) ).

% Min_le
tff(fact_6657_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A4: A] :
                  ( member(A,A4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A4) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,lattic643756798350308766er_Min(A),A3)) ) ) ) ) ).

% Min.boundedI
tff(fact_6658_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,lattic643756798350308766er_Min(A),A3))
             => ! [A15: A] :
                  ( member(A,A15,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A15) ) ) ) ) ) ).

% Min.boundedE
tff(fact_6659_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( M = aa(set(A),A,lattic643756798350308766er_Min(A),A3) )
            <=> ( member(A,M,A3)
                & ! [X4: A] :
                    ( member(A,X4,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),X4) ) ) ) ) ) ) ).

% eq_Min_iff
tff(fact_6660_Min__le__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),A3)),Xa)
            <=> ? [X4: A] :
                  ( member(A,X4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Xa) ) ) ) ) ) ).

% Min_le_iff
tff(fact_6661_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( aa(set(A),A,lattic643756798350308766er_Min(A),A3) = M )
            <=> ( member(A,M,A3)
                & ! [X4: A] :
                    ( member(A,X4,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),X4) ) ) ) ) ) ) ).

% Min_eq_iff
tff(fact_6662_Min__insert2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [B4: A] :
                ( member(A,B4,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),B4) )
           => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),insert(A,A2),A3)) = A2 ) ) ) ) ).

% Min_insert2
tff(fact_6663_eventually__finite__subsets__at__top,axiom,
    ! [A: $tType,P: fun(set(A),$o),A3: set(A)] :
      ( eventually(set(A),P,finite5375528669736107172at_top(A,A3))
    <=> ? [X9: set(A)] :
          ( aa(set(A),$o,finite_finite(A),X9)
          & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X9),A3)
          & ! [Y7: set(A)] :
              ( ( aa(set(A),$o,finite_finite(A),Y7)
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X9),Y7)
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Y7),A3) )
             => aa(set(A),$o,P,Y7) ) ) ) ).

% eventually_finite_subsets_at_top
tff(fact_6664_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,finite_finite(A),B3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),B3)),aa(set(A),A,lattic643756798350308766er_Min(A),A3)) ) ) ) ) ).

% Min.subset_imp
tff(fact_6665_Min__antimono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M7: set(A),N6: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),M7),N6)
         => ( ( M7 != bot_bot(set(A)) )
           => ( aa(set(A),$o,finite_finite(A),N6)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798350308766er_Min(A),N6)),aa(set(A),A,lattic643756798350308766er_Min(A),M7)) ) ) ) ) ).

% Min_antimono
tff(fact_6666_Min_Osubset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( B3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
             => ( aa(A,A,aa(A,fun(A,A),ord_min(A),aa(set(A),A,lattic643756798350308766er_Min(A),B3)),aa(set(A),A,lattic643756798350308766er_Min(A),A3)) = aa(set(A),A,lattic643756798350308766er_Min(A),A3) ) ) ) ) ) ).

% Min.subset
tff(fact_6667_Min__add__commute,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [S2: set(A),F3: fun(A,B),K: B] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ( aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(A),set(B),image(A,B,aa(B,fun(A,B),aTP_Lamp_aea(fun(A,B),fun(B,fun(A,B)),F3),K)),S2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(B),B,lattic643756798350308766er_Min(B),aa(set(A),set(B),image(A,B,F3),S2))),K) ) ) ) ) ).

% Min_add_commute
tff(fact_6668_finite__subsets__at__top__def,axiom,
    ! [A: $tType,A3: set(A)] : ( finite5375528669736107172at_top(A,A3) = aa(set(filter(set(A))),filter(set(A)),complete_Inf_Inf(filter(set(A))),aa(set(set(A)),set(filter(set(A))),image(set(A),filter(set(A)),aTP_Lamp_aec(set(A),fun(set(A),filter(set(A))),A3)),collect(set(A),aTP_Lamp_aed(set(A),fun(set(A),$o),A3)))) ) ).

% finite_subsets_at_top_def
tff(fact_6669_Min_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( aa(set(A),A,lattic643756798350308766er_Min(A),A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ) ).

% Min.remove
tff(fact_6670_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),insert(A,Xa),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),ord_min(A),Xa),aa(set(A),A,lattic643756798350308766er_Min(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ).

% Min.insert_remove
tff(fact_6671_dual__Max,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( lattices_Max(A,aTP_Lamp_zr(A,fun(A,$o))) = lattic643756798350308766er_Min(A) ) ) ).

% dual_Max
tff(fact_6672_ntrancl__def,axiom,
    ! [A: $tType,N: nat,R2: set(product_prod(A,A))] : ( transitive_ntrancl(A,N,R2) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R2)),collect(nat,aTP_Lamp_aef(nat,fun(nat,$o),N)))) ) ).

% ntrancl_def
tff(fact_6673_relpow__1,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),one_one(nat)),R2) = R2 ) ).

% relpow_1
tff(fact_6674_finite__relpow,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),N: nat] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
       => aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2)) ) ) ).

% finite_relpow
tff(fact_6675_relpow__Suc__E,axiom,
    ! [A: $tType,Xa: A,Z: A,N: nat,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,N)),R2))
     => ~ ! [Y3: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
           => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z),R2) ) ) ).

% relpow_Suc_E
tff(fact_6676_relpow__Suc__I,axiom,
    ! [A: $tType,Xa: A,Y: A,N: nat,R2: set(product_prod(A,A)),Z: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Z),R2)
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,N)),R2)) ) ) ).

% relpow_Suc_I
tff(fact_6677_relpow__Suc__D2,axiom,
    ! [A: $tType,Xa: A,Z: A,N: nat,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,N)),R2))
     => ? [Y3: A] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y3),R2)
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2)) ) ) ).

% relpow_Suc_D2
tff(fact_6678_relpow__Suc__E2,axiom,
    ! [A: $tType,Xa: A,Z: A,N: nat,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,N)),R2))
     => ~ ! [Y3: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y3),R2)
           => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2)) ) ) ).

% relpow_Suc_E2
tff(fact_6679_relpow__Suc__I2,axiom,
    ! [A: $tType,Xa: A,Y: A,R2: set(product_prod(A,A)),Z: A,N: nat] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),R2)
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),aa(nat,nat,suc,N)),R2)) ) ) ).

% relpow_Suc_I2
tff(fact_6680_relpow__0__E,axiom,
    ! [A: $tType,Xa: A,Y: A,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R2))
     => ( Xa = Y ) ) ).

% relpow_0_E
tff(fact_6681_relpow__0__I,axiom,
    ! [A: $tType,Xa: A,R2: set(product_prod(A,A))] : member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Xa),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),zero_zero(nat)),R2)) ).

% relpow_0_I
tff(fact_6682_relpow__Suc__D2_H,axiom,
    ! [A: $tType,N: nat,R2: set(product_prod(A,A)),X3: A,Y4: A,Z3: A] :
      ( ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X3),Y4),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
        & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y4),Z3),R2) )
     => ? [W2: A] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X3),W2),R2)
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,W2),Z3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2)) ) ) ).

% relpow_Suc_D2'
tff(fact_6683_relpow__finite__bounded,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),K: nat] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R2)
     => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),K),R2)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R2)),collect(nat,aTP_Lamp_aeg(set(product_prod(A,A)),fun(nat,$o),R2))))) ) ).

% relpow_finite_bounded
tff(fact_6684_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R2: set(product_prod(A,A)),X3: A,Xa2: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aa(nat,fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),compow(fun(A,fun(A,$o))),N),aTP_Lamp_aeh(set(product_prod(A,A)),fun(A,fun(A,$o)),R2)),X3),Xa2)
    <=> member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X3),Xa2),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2)) ) ).

% relpowp_relpow_eq
tff(fact_6685_relpow__E,axiom,
    ! [A: $tType,Xa: A,Z: A,N: nat,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
     => ( ( ( N = zero_zero(nat) )
         => ( Xa != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N = aa(nat,nat,suc,M2) )
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y3),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M2),R2))
               => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z),R2) ) ) ) ) ).

% relpow_E
tff(fact_6686_relpow__E2,axiom,
    ! [A: $tType,Xa: A,Z: A,N: nat,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
     => ( ( ( N = zero_zero(nat) )
         => ( Xa != Z ) )
       => ~ ! [Y3: A,M2: nat] :
              ( ( N = aa(nat,nat,suc,M2) )
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y3),R2)
               => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),M2),R2)) ) ) ) ) ).

% relpow_E2
tff(fact_6687_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ) ).

% relpow_empty
tff(fact_6688_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N: nat,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
    <=> ? [F5: fun(nat,A)] :
          ( ( aa(nat,A,F5,zero_zero(nat)) = A2 )
          & ( aa(nat,A,F5,N) = B2 )
          & ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),N)
             => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,aa(nat,A,F5,I3)),aa(nat,A,F5,aa(nat,nat,suc,I3))),R2) ) ) ) ).

% relpow_fun_conv
tff(fact_6689_relpow__finite__bounded1,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),K: nat] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),K)
       => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),K),R2)),aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R2)),collect(nat,aTP_Lamp_aei(set(product_prod(A,A)),fun(nat,$o),R2))))) ) ) ).

% relpow_finite_bounded1
tff(fact_6690_relpow__code__def,axiom,
    ! [A: $tType] : ( transitive_relpow(A) = compow(set(product_prod(A,A))) ) ).

% relpow_code_def
tff(fact_6691_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R2)
     => ( transitive_trancl(A,R2) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R2)),collect(nat,aTP_Lamp_aei(set(product_prod(A,A)),fun(nat,$o),R2)))) ) ) ).

% trancl_finite_eq_relpow
tff(fact_6692_trancl__empty,axiom,
    ! [A: $tType] : ( transitive_trancl(A,bot_bot(set(product_prod(A,A)))) = bot_bot(set(product_prod(A,A))) ) ).

% trancl_empty
tff(fact_6693_finite__trancl,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),transitive_trancl(A,R))
    <=> aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R) ) ).

% finite_trancl
tff(fact_6694_r__into__trancl_H,axiom,
    ! [A: $tType,P2: product_prod(A,A),R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,R)
     => member(product_prod(A,A),P2,transitive_trancl(A,R)) ) ).

% r_into_trancl'
tff(fact_6695_trancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A1),A22),transitive_trancl(A,R))
     => ( ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A1),A22),R)
       => ~ ! [B4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A1),B4),transitive_trancl(A,R))
             => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B4),A22),R) ) ) ) ).

% trancl.cases
tff(fact_6696_trancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A1),A22),transitive_trancl(A,R))
    <=> ( ? [A7: A,B7: A] :
            ( ( A1 = A7 )
            & ( A22 = B7 )
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A7),B7),R) )
        | ? [A7: A,B7: A,C3: A] :
            ( ( A1 = A7 )
            & ( A22 = C3 )
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A7),B7),transitive_trancl(A,R))
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B7),C3),R) ) ) ) ).

% trancl.simps
tff(fact_6697_trancl_Or__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),R)
     => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R)) ) ).

% trancl.r_into_trancl
tff(fact_6698_tranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R))
     => ( ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),R)
       => ~ ! [C4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C4),transitive_trancl(A,R))
             => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,C4),B2),R) ) ) ) ).

% tranclE
tff(fact_6699_trancl__trans,axiom,
    ! [A: $tType,Xa: A,Y: A,R: set(product_prod(A,A)),Z: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_trancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Z),transitive_trancl(A,R))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),transitive_trancl(A,R)) ) ) ).

% trancl_trans
tff(fact_6700_trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),P: fun(A,$o)] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R))
     => ( ! [Y3: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),Y3),R)
           => aa(A,$o,P,Y3) )
       => ( ! [Y3: A,Z4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),Y3),transitive_trancl(A,R))
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z4),R)
               => ( aa(A,$o,P,Y3)
                 => aa(A,$o,P,Z4) ) ) )
         => aa(A,$o,P,B2) ) ) ) ).

% trancl_induct
tff(fact_6701_trancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set(product_prod(product_prod(A,B),product_prod(A,B))),P: fun(A,fun(B,$o))] :
      ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Ax),Ay)),aa(B,product_prod(A,B),product_Pair(A,B,Bx),By)),transitive_trancl(product_prod(A,B),R))
     => ( ! [A4: A,B4: B] :
            ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Ax),Ay)),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),R)
           => aa(B,$o,aa(A,fun(B,$o),P,A4),B4) )
       => ( ! [A4: A,B4: B,Aa2: A,Ba: B] :
              ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Ax),Ay)),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),transitive_trancl(product_prod(A,B),R))
             => ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),aa(B,product_prod(A,B),product_Pair(A,B,Aa2),Ba)),R)
               => ( aa(B,$o,aa(A,fun(B,$o),P,A4),B4)
                 => aa(B,$o,aa(A,fun(B,$o),P,Aa2),Ba) ) ) )
         => aa(B,$o,aa(A,fun(B,$o),P,Bx),By) ) ) ) ).

% trancl_induct2
tff(fact_6702_r__r__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),R2)
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),R2)
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_trancl(A,R2)) ) ) ).

% r_r_into_trancl
tff(fact_6703_converse__tranclE,axiom,
    ! [A: $tType,Xa: A,Z: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),transitive_trancl(A,R))
     => ( ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),R)
       => ~ ! [Y3: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y3),R)
             => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z),transitive_trancl(A,R)) ) ) ) ).

% converse_tranclE
tff(fact_6704_irrefl__trancl__rD,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),Xa: A,Y: A] :
      ( ! [X: A] : ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),X),transitive_trancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),R)
       => ( Xa != Y ) ) ) ).

% irrefl_trancl_rD
tff(fact_6705_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),R)
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_trancl(A,R)) ) ) ).

% Transitive_Closure.trancl_into_trancl
tff(fact_6706_trancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),R)
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),transitive_trancl(A,R))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_trancl(A,R)) ) ) ).

% trancl_into_trancl2
tff(fact_6707_trancl__trans__induct,axiom,
    ! [A: $tType,Xa: A,Y: A,R: set(product_prod(A,A)),P: fun(A,fun(A,$o))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_trancl(A,R))
     => ( ! [X: A,Y3: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y3),R)
           => aa(A,$o,aa(A,fun(A,$o),P,X),Y3) )
       => ( ! [X: A,Y3: A,Z4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y3),transitive_trancl(A,R))
             => ( aa(A,$o,aa(A,fun(A,$o),P,X),Y3)
               => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z4),transitive_trancl(A,R))
                 => ( aa(A,$o,aa(A,fun(A,$o),P,Y3),Z4)
                   => aa(A,$o,aa(A,fun(A,$o),P,X),Z4) ) ) ) )
         => aa(A,$o,aa(A,fun(A,$o),P,Xa),Y) ) ) ) ).

% trancl_trans_induct
tff(fact_6708_converse__trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),P: fun(A,$o)] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R))
     => ( ! [Y3: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),B2),R)
           => aa(A,$o,P,Y3) )
       => ( ! [Y3: A,Z4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z4),R)
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Z4),B2),transitive_trancl(A,R))
               => ( aa(A,$o,P,Z4)
                 => aa(A,$o,P,Y3) ) ) )
         => aa(A,$o,P,A2) ) ) ) ).

% converse_trancl_induct
tff(fact_6709_trancl__mono,axiom,
    ! [A: $tType,P2: product_prod(A,A),R: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,transitive_trancl(A,R))
     => ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R),S)
       => member(product_prod(A,A),P2,transitive_trancl(A,S)) ) ) ).

% trancl_mono
tff(fact_6710_trancl__insert2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2)),R)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R)),collect(product_prod(A,A),product_case_prod(A,A,$o,aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_aej(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),A2),B2),R)))) ) ).

% trancl_insert2
tff(fact_6711_trancl__power,axiom,
    ! [A: $tType,P2: product_prod(A,A),R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,transitive_trancl(A,R2))
    <=> ? [N5: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N5)
          & member(product_prod(A,A),P2,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N5),R2)) ) ) ).

% trancl_power
tff(fact_6712_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list(product_prod(A,A))] : ( transitive_trancl(A,aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) = transitive_ntrancl(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs))),one_one(nat)),aa(list(product_prod(A,A)),set(product_prod(A,A)),set2(product_prod(A,A)),Xs)) ) ).

% trancl_set_ntrancl
tff(fact_6713_finite__trancl__ntranl,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R2)
     => ( transitive_trancl(A,R2) = transitive_ntrancl(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),R2)),one_one(nat)),R2) ) ) ).

% finite_trancl_ntranl
tff(fact_6714_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,finite_finite(product_prod(A,A)),R2)
     => ( transitive_rtrancl(A,R2) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R2)),collect(nat,aTP_Lamp_aeg(set(product_prod(A,A)),fun(nat,$o),R2)))) ) ) ).

% rtrancl_finite_eq_relpow
tff(fact_6715_sum__le__card__Max,axiom,
    ! [A: $tType,A3: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),F3),A3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(set(A),set(nat),image(A,nat,F3),A3)))) ) ).

% sum_le_card_Max
tff(fact_6716_r__into__rtrancl,axiom,
    ! [A: $tType,P2: product_prod(A,A),R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,R)
     => member(product_prod(A,A),P2,transitive_rtrancl(A,R)) ) ).

% r_into_rtrancl
tff(fact_6717_rtrancl__idemp,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] : ( transitive_rtrancl(A,transitive_rtrancl(A,R)) = transitive_rtrancl(A,R) ) ).

% rtrancl_idemp
tff(fact_6718_rtrancl__trancl__absorb,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( transitive_trancl(A,transitive_rtrancl(A,R2)) = transitive_rtrancl(A,R2) ) ).

% rtrancl_trancl_absorb
tff(fact_6719_trancl__rtrancl__absorb,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( transitive_rtrancl(A,transitive_trancl(A,R2)) = transitive_rtrancl(A,R2) ) ).

% trancl_rtrancl_absorb
tff(fact_6720_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N != zero_zero(nat) )
     => ( aa(set(nat),nat,lattic643756798349783984er_Max(nat),collect(nat,aTP_Lamp_lb(nat,fun(nat,$o),N))) = N ) ) ).

% Max_divisors_self_nat
tff(fact_6721_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),Xa)
            <=> ! [X4: A] :
                  ( member(A,X4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Xa) ) ) ) ) ) ).

% Max.bounded_iff
tff(fact_6722_tranclD,axiom,
    ! [A: $tType,Xa: A,Y: A,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_trancl(A,R2))
     => ? [Z4: A] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z4),R2)
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Z4),Y),transitive_rtrancl(A,R2)) ) ) ).

% tranclD
tff(fact_6723_rtranclD,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R2))
     => ( ( A2 = B2 )
        | ( ( A2 != B2 )
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R2)) ) ) ) ).

% rtranclD
tff(fact_6724_tranclD2,axiom,
    ! [A: $tType,Xa: A,Y: A,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_trancl(A,R2))
     => ? [Z4: A] :
          ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z4),transitive_rtrancl(A,R2))
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Z4),Y),R2) ) ) ).

% tranclD2
tff(fact_6725_trancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R))
     => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R)) ) ).

% trancl_into_rtrancl
tff(fact_6726_rtrancl__eq__or__trancl,axiom,
    ! [A: $tType,Xa: A,Y: A,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_rtrancl(A,R2))
    <=> ( ( Xa = Y )
        | ( ( Xa != Y )
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_trancl(A,R2)) ) ) ) ).

% rtrancl_eq_or_trancl
tff(fact_6727_rtrancl__into__trancl1,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),R)
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_trancl(A,R)) ) ) ).

% rtrancl_into_trancl1
tff(fact_6728_rtrancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),R)
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),transitive_rtrancl(A,R))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_trancl(A,R)) ) ) ).

% rtrancl_into_trancl2
tff(fact_6729_rtrancl__trancl__trancl,axiom,
    ! [A: $tType,Xa: A,Y: A,R: set(product_prod(A,A)),Z: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_rtrancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Z),transitive_trancl(A,R))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),transitive_trancl(A,R)) ) ) ).

% rtrancl_trancl_trancl
tff(fact_6730_trancl__rtrancl__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_trancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),transitive_rtrancl(A,R))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_trancl(A,R)) ) ) ).

% trancl_rtrancl_trancl
tff(fact_6731_Max__ge,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,lattic643756798349783984er_Max(A),A3)) ) ) ) ).

% Max_ge
tff(fact_6732_Max__eqI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [Y3: A] :
                ( member(A,Y3,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),Xa) )
           => ( member(A,Xa,A3)
             => ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = Xa ) ) ) ) ) ).

% Max_eqI
tff(fact_6733_Max__eq__if,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ! [X: A] :
                  ( member(A,X,A3)
                 => ? [Xa2: A] :
                      ( member(A,Xa2,B3)
                      & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Xa2) ) )
             => ( ! [X: A] :
                    ( member(A,X,B3)
                   => ? [Xa2: A] :
                        ( member(A,Xa2,A3)
                        & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Xa2) ) )
               => ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = aa(set(A),A,lattic643756798349783984er_Max(A),B3) ) ) ) ) ) ) ).

% Max_eq_if
tff(fact_6734_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(set(A),A,lattic643756798349783984er_Max(A),A3)) ) ) ) ).

% Max.coboundedI
tff(fact_6735_rtrancl__insert,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] : ( transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2)),R)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_rtrancl(A,R)),collect(product_prod(A,A),product_case_prod(A,A,$o,aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_aek(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),A2),B2),R)))) ) ).

% rtrancl_insert
tff(fact_6736_rtrancl__Un__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] : aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_rtrancl(A,R2)),transitive_rtrancl(A,S2))),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R2),S2))) ).

% rtrancl_Un_subset
tff(fact_6737_in__rtrancl__UnI,axiom,
    ! [A: $tType,Xa: product_prod(A,A),R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( ( member(product_prod(A,A),Xa,transitive_rtrancl(A,R2))
        | member(product_prod(A,A),Xa,transitive_rtrancl(A,S2)) )
     => member(product_prod(A,A),Xa,transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R2),S2))) ) ).

% in_rtrancl_UnI
tff(fact_6738_rtrancl__Un__rtrancl,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] : ( transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_rtrancl(A,R2)),transitive_rtrancl(A,S2))) = transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),R2),S2)) ) ).

% rtrancl_Un_rtrancl
tff(fact_6739_rtrancl__Un__separatorE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set(product_prod(A,A)),Q: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),P),Q)))
     => ( ! [X: A,Y3: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),X),transitive_rtrancl(A,P))
           => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),Y3),Q)
             => ( X = Y3 ) ) )
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,P)) ) ) ).

% rtrancl_Un_separatorE
tff(fact_6740_rtrancl__Un__separator__converseE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set(product_prod(A,A)),Q: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),P),Q)))
     => ( ! [X: A,Y3: A] :
            ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),B2),transitive_rtrancl(A,P))
           => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),X),Q)
             => ( Y3 = X ) ) )
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,P)) ) ) ).

% rtrancl_Un_separator_converseE
tff(fact_6741_rtrancl__mono,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R),S)
     => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),transitive_rtrancl(A,R)),transitive_rtrancl(A,S)) ) ).

% rtrancl_mono
tff(fact_6742_rtrancl__subset,axiom,
    ! [A: $tType,R2: set(product_prod(A,A)),S2: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R2),S2)
     => ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),S2),transitive_rtrancl(A,R2))
       => ( transitive_rtrancl(A,S2) = transitive_rtrancl(A,R2) ) ) ) ).

% rtrancl_subset
tff(fact_6743_rtrancl__subset__rtrancl,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),S: set(product_prod(A,A))] :
      ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R),transitive_rtrancl(A,S))
     => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),transitive_rtrancl(A,R)),transitive_rtrancl(A,S)) ) ).

% rtrancl_subset_rtrancl
tff(fact_6744_converse__rtrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),R)
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),transitive_rtrancl(A,R))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_rtrancl(A,R)) ) ) ).

% converse_rtrancl_into_rtrancl
tff(fact_6745_converse__rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set(product_prod(product_prod(A,B),product_prod(A,B))),P: fun(A,fun(B,$o))] :
      ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Ax),Ay)),aa(B,product_prod(A,B),product_Pair(A,B,Bx),By)),transitive_rtrancl(product_prod(A,B),R))
     => ( aa(B,$o,aa(A,fun(B,$o),P,Bx),By)
       => ( ! [A4: A,B4: B,Aa2: A,Ba: B] :
              ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),aa(B,product_prod(A,B),product_Pair(A,B,Aa2),Ba)),R)
             => ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Aa2),Ba)),aa(B,product_prod(A,B),product_Pair(A,B,Bx),By)),transitive_rtrancl(product_prod(A,B),R))
               => ( aa(B,$o,aa(A,fun(B,$o),P,Aa2),Ba)
                 => aa(B,$o,aa(A,fun(B,$o),P,A4),B4) ) ) )
         => aa(B,$o,aa(A,fun(B,$o),P,Ax),Ay) ) ) ) ).

% converse_rtrancl_induct2
tff(fact_6746_converse__rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),P: fun(A,$o)] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R))
     => ( aa(A,$o,P,B2)
       => ( ! [Y3: A,Z4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z4),R)
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Z4),B2),transitive_rtrancl(A,R))
               => ( aa(A,$o,P,Z4)
                 => aa(A,$o,P,Y3) ) ) )
         => aa(A,$o,P,A2) ) ) ) ).

% converse_rtrancl_induct
tff(fact_6747_converse__rtranclE2,axiom,
    ! [B: $tType,A: $tType,Xa: A,Xb: B,Za: A,Zb: B,R: set(product_prod(product_prod(A,B),product_prod(A,B)))] :
      ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Xa),Xb)),aa(B,product_prod(A,B),product_Pair(A,B,Za),Zb)),transitive_rtrancl(product_prod(A,B),R))
     => ( ( aa(B,product_prod(A,B),product_Pair(A,B,Xa),Xb) != aa(B,product_prod(A,B),product_Pair(A,B,Za),Zb) )
       => ~ ! [A4: A,B4: B] :
              ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Xa),Xb)),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),R)
             => ~ member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),aa(B,product_prod(A,B),product_Pair(A,B,Za),Zb)),transitive_rtrancl(product_prod(A,B),R)) ) ) ) ).

% converse_rtranclE2
tff(fact_6748_converse__rtranclE,axiom,
    ! [A: $tType,Xa: A,Z: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),transitive_rtrancl(A,R))
     => ( ( Xa != Z )
       => ~ ! [Y3: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y3),R)
             => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z),transitive_rtrancl(A,R)) ) ) ) ).

% converse_rtranclE
tff(fact_6749_rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set(product_prod(product_prod(A,B),product_prod(A,B))),P: fun(A,fun(B,$o))] :
      ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Ax),Ay)),aa(B,product_prod(A,B),product_Pair(A,B,Bx),By)),transitive_rtrancl(product_prod(A,B),R))
     => ( aa(B,$o,aa(A,fun(B,$o),P,Ax),Ay)
       => ( ! [A4: A,B4: B,Aa2: A,Ba: B] :
              ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Ax),Ay)),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),transitive_rtrancl(product_prod(A,B),R))
             => ( member(product_prod(product_prod(A,B),product_prod(A,B)),aa(product_prod(A,B),product_prod(product_prod(A,B),product_prod(A,B)),product_Pair(product_prod(A,B),product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,A4),B4)),aa(B,product_prod(A,B),product_Pair(A,B,Aa2),Ba)),R)
               => ( aa(B,$o,aa(A,fun(B,$o),P,A4),B4)
                 => aa(B,$o,aa(A,fun(B,$o),P,Aa2),Ba) ) ) )
         => aa(B,$o,aa(A,fun(B,$o),P,Bx),By) ) ) ) ).

% rtrancl_induct2
tff(fact_6750_rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),P: fun(A,$o)] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R))
     => ( aa(A,$o,P,A2)
       => ( ! [Y3: A,Z4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),Y3),transitive_rtrancl(A,R))
             => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),Z4),R)
               => ( aa(A,$o,P,Y3)
                 => aa(A,$o,P,Z4) ) ) )
         => aa(A,$o,P,B2) ) ) ) ).

% rtrancl_induct
tff(fact_6751_rtrancl__trans,axiom,
    ! [A: $tType,Xa: A,Y: A,R: set(product_prod(A,A)),Z: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_rtrancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Z),transitive_rtrancl(A,R))
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Z),transitive_rtrancl(A,R)) ) ) ).

% rtrancl_trans
tff(fact_6752_rtranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R))
     => ( ( A2 != B2 )
       => ~ ! [Y3: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),Y3),transitive_rtrancl(A,R))
             => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y3),B2),R) ) ) ) ).

% rtranclE
tff(fact_6753_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),C2: A] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B2),C2),R)
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),C2),transitive_rtrancl(A,R)) ) ) ).

% rtrancl.rtrancl_into_rtrancl
tff(fact_6754_rtrancl_Ortrancl__refl,axiom,
    ! [A: $tType,A2: A,R: set(product_prod(A,A))] : member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),A2),transitive_rtrancl(A,R)) ).

% rtrancl.rtrancl_refl
tff(fact_6755_rtrancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A1),A22),transitive_rtrancl(A,R))
    <=> ( ? [A7: A] :
            ( ( A1 = A7 )
            & ( A22 = A7 ) )
        | ? [A7: A,B7: A,C3: A] :
            ( ( A1 = A7 )
            & ( A22 = C3 )
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A7),B7),transitive_rtrancl(A,R))
            & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B7),C3),R) ) ) ) ).

% rtrancl.simps
tff(fact_6756_rtrancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R: set(product_prod(A,A))] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A1),A22),transitive_rtrancl(A,R))
     => ( ( A22 != A1 )
       => ~ ! [B4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A1),B4),transitive_rtrancl(A,R))
             => ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,B4),A22),R) ) ) ) ).

% rtrancl.cases
tff(fact_6757_rtrancl__imp__relpow,axiom,
    ! [A: $tType,P2: product_prod(A,A),R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,transitive_rtrancl(A,R2))
     => ? [N2: nat] : member(product_prod(A,A),P2,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N2),R2)) ) ).

% rtrancl_imp_relpow
tff(fact_6758_relpow__imp__rtrancl,axiom,
    ! [A: $tType,P2: product_prod(A,A),N: nat,R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N),R2))
     => member(product_prod(A,A),P2,transitive_rtrancl(A,R2)) ) ).

% relpow_imp_rtrancl
tff(fact_6759_rtrancl__power,axiom,
    ! [A: $tType,P2: product_prod(A,A),R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,transitive_rtrancl(A,R2))
    <=> ? [N5: nat] : member(product_prod(A,A),P2,aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),N5),R2)) ) ).

% rtrancl_power
tff(fact_6760_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( aa(set(A),A,lattic643756798349783984er_Max(A),A3) = M )
            <=> ( member(A,M,A3)
                & ! [X4: A] :
                    ( member(A,X4,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),M) ) ) ) ) ) ) ).

% Max_eq_iff
tff(fact_6761_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,lattic643756798349783984er_Max(A),A3))
            <=> ? [X4: A] :
                  ( member(A,X4,A3)
                  & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),X4) ) ) ) ) ) ).

% Max_ge_iff
tff(fact_6762_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),M: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ( M = aa(set(A),A,lattic643756798349783984er_Max(A),A3) )
            <=> ( member(A,M,A3)
                & ! [X4: A] :
                    ( member(A,X4,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),M) ) ) ) ) ) ) ).

% eq_Max_iff
tff(fact_6763_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),Xa)
             => ! [A15: A] :
                  ( member(A,A15,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A15),Xa) ) ) ) ) ) ).

% Max.boundedE
tff(fact_6764_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A4: A] :
                  ( member(A,A4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),Xa) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),Xa) ) ) ) ) ).

% Max.boundedI
tff(fact_6765_Max__insert2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [B4: A] :
                ( member(A,B4,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B4),A2) )
           => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),insert(A,A2),A3)) = A2 ) ) ) ) ).

% Max_insert2
tff(fact_6766_trancl__insert,axiom,
    ! [A: $tType,Y: A,Xa: A,R: set(product_prod(A,A))] : ( transitive_trancl(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Xa)),R)) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),sup_sup(set(product_prod(A,A))),transitive_trancl(A,R)),collect(product_prod(A,A),product_case_prod(A,A,$o,aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_aek(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),Y),Xa),R)))) ) ).

% trancl_insert
tff(fact_6767_pred__nat__trancl__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( member(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,M),N),transitive_rtrancl(nat,pred_nat))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% pred_nat_trancl_eq_le
tff(fact_6768_Max__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [M7: set(A),N6: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),M7),N6)
         => ( ( M7 != bot_bot(set(A)) )
           => ( aa(set(A),$o,finite_finite(A),N6)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),M7)),aa(set(A),A,lattic643756798349783984er_Max(A),N6)) ) ) ) ) ).

% Max_mono
tff(fact_6769_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,finite_finite(A),B3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,lattic643756798349783984er_Max(A),A3)),aa(set(A),A,lattic643756798349783984er_Max(A),B3)) ) ) ) ) ).

% Max.subset_imp
tff(fact_6770_Max_Osubset,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( B3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
             => ( aa(A,A,aa(A,fun(A,A),ord_max(A),aa(set(A),A,lattic643756798349783984er_Max(A),B3)),aa(set(A),A,lattic643756798349783984er_Max(A),A3)) = aa(set(A),A,lattic643756798349783984er_Max(A),A3) ) ) ) ) ) ).

% Max.subset
tff(fact_6771_card__le__Suc__Max,axiom,
    ! [S2: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),S2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(nat),nat,finite_card(nat),S2)),aa(nat,nat,suc,aa(set(nat),nat,lattic643756798349783984er_Max(nat),S2))) ) ).

% card_le_Suc_Max
tff(fact_6772_Sup__nat__def,axiom,
    ! [X6: set(nat)] :
      ( aa(set(nat),nat,complete_Sup_Sup(nat),X6)
      = $ite(X6 = bot_bot(set(nat)),zero_zero(nat),aa(set(nat),nat,lattic643756798349783984er_Max(nat),X6)) ) ).

% Sup_nat_def
tff(fact_6773_Max__add__commute,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [S2: set(A),F3: fun(A,B),K: B] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( ( S2 != bot_bot(set(A)) )
           => ( aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(A),set(B),image(A,B,aa(B,fun(A,B),aTP_Lamp_aea(fun(A,B),fun(B,fun(A,B)),F3),K)),S2)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(set(B),B,lattic643756798349783984er_Max(B),aa(set(A),set(B),image(A,B,F3),S2))),K) ) ) ) ) ).

% Max_add_commute
tff(fact_6774_divide__nat__def,axiom,
    ! [M: nat,N: nat] :
      ( divide_divide(nat,M,N)
      = $ite(N = zero_zero(nat),zero_zero(nat),aa(set(nat),nat,lattic643756798349783984er_Max(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ael(nat,fun(nat,fun(nat,$o)),M),N)))) ) ).

% divide_nat_def
tff(fact_6775_rtrancl__imp__UN__relpow,axiom,
    ! [A: $tType,P2: product_prod(A,A),R2: set(product_prod(A,A))] :
      ( member(product_prod(A,A),P2,transitive_rtrancl(A,R2))
     => member(product_prod(A,A),P2,aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R2)),top_top(set(nat))))) ) ).

% rtrancl_imp_UN_relpow
tff(fact_6776_rtrancl__is__UN__relpow,axiom,
    ! [A: $tType,R2: set(product_prod(A,A))] : ( transitive_rtrancl(A,R2) = aa(set(set(product_prod(A,A))),set(product_prod(A,A)),complete_Sup_Sup(set(product_prod(A,A))),aa(set(nat),set(set(product_prod(A,A))),image(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),R2)),top_top(set(nat)))) ) ).

% rtrancl_is_UN_relpow
tff(fact_6777_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),insert(A,Xa),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ).

% Max.insert_remove
tff(fact_6778_Max_Oremove,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( aa(set(A),A,lattic643756798349783984er_Max(A),A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),ord_max(A),Xa),aa(set(A),A,lattic643756798349783984er_Max(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ) ).

% Max.remove
tff(fact_6779_Gcd__eq__Max,axiom,
    ! [M7: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),M7)
     => ( ( M7 != bot_bot(set(nat)) )
       => ( ~ member(nat,zero_zero(nat),M7)
         => ( gcd_Gcd(nat,M7) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),aa(set(set(nat)),set(nat),complete_Inf_Inf(set(nat)),aa(set(nat),set(set(nat)),image(nat,set(nat),aTP_Lamp_aem(nat,set(nat))),M7))) ) ) ) ) ).

% Gcd_eq_Max
tff(fact_6780_dual__Min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ( lattices_Min(A,aTP_Lamp_zr(A,fun(A,$o))) = lattic643756798349783984er_Max(A) ) ) ).

% dual_Min
tff(fact_6781_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list(A),M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,aa(list(A),list(A),rotate(A,M),Xs)),N) = aa(nat,A,nth(A,Xs),modulo_modulo(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% nth_rotate
tff(fact_6782_rotate0,axiom,
    ! [A: $tType] : ( rotate(A,zero_zero(nat)) = id(list(A)) ) ).

% rotate0
tff(fact_6783_rotate__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,aa(nat,nat,suc,N)),Xs) = rotate1(A,aa(list(A),list(A),rotate(A,N),Xs)) ) ).

% rotate_Suc
tff(fact_6784_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N != zero_zero(int) )
     => ( aa(set(int),int,lattic643756798349783984er_Max(int),collect(int,aTP_Lamp_lu(int,fun(int,$o),N))) = aa(int,int,abs_abs(int),N) ) ) ).

% Max_divisors_self_int
tff(fact_6785_rotate__length01,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => ( aa(list(A),list(A),rotate(A,N),Xs) = Xs ) ) ).

% rotate_length01
tff(fact_6786_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs)) = zero_zero(nat) )
     => ( aa(list(A),list(A),rotate(A,N),Xs) = Xs ) ) ).

% rotate_id
tff(fact_6787_rotate__add,axiom,
    ! [A: $tType,M: nat,N: nat] : ( rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) = aa(fun(list(A),list(A)),fun(list(A),list(A)),comp(list(A),list(A),list(A),rotate(A,M)),rotate(A,N)) ) ).

% rotate_add
tff(fact_6788_rotate__rotate,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,M),aa(list(A),list(A),rotate(A,N),Xs)) = aa(list(A),list(A),rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)),Xs) ) ).

% rotate_rotate
tff(fact_6789_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( linord4507533701916653071of_set(A,A3) = aa(list(A),list(A),cons(A,aa(set(A),A,lattic643756798350308766er_Min(A),A3)),linord4507533701916653071of_set(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,aa(set(A),A,lattic643756798350308766er_Min(A),A3)),bot_bot(set(A)))))) ) ) ) ) ).

% sorted_list_of_set_nonempty
tff(fact_6790_sum__list__update,axiom,
    ! [A: $tType] :
      ( ordere1170586879665033532d_diff(A)
     => ! [K: nat,Xs: list(A),Xa: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
         => ( aa(list(A),A,groups8242544230860333062m_list(A),list_update(A,Xs,K,Xa)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),Xa)),aa(nat,A,nth(A,Xs),K)) ) ) ) ).

% sum_list_update
tff(fact_6791_nth__Cons__Suc,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),N: nat] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,Xa),Xs)),aa(nat,nat,suc,N)) = aa(nat,A,nth(A,Xs),N) ) ).

% nth_Cons_Suc
tff(fact_6792_nth__Cons__0,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,Xa),Xs)),zero_zero(nat)) = Xa ) ).

% nth_Cons_0
tff(fact_6793_take__Suc__Cons,axiom,
    ! [A: $tType,N: nat,Xa: A,Xs: list(A)] : ( take(A,aa(nat,nat,suc,N),aa(list(A),list(A),cons(A,Xa),Xs)) = aa(list(A),list(A),cons(A,Xa),take(A,N,Xs)) ) ).

% take_Suc_Cons
tff(fact_6794_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Ns: list(A)] :
          ( ( aa(list(A),A,groups8242544230860333062m_list(A),Ns) = zero_zero(A) )
        <=> ! [X4: A] :
              ( member(A,X4,aa(list(A),set(A),set2(A),Ns))
             => ( X4 = zero_zero(A) ) ) ) ) ).

% sum_list_eq_0_iff
tff(fact_6795_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xa: A,Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),aa(list(A),list(A),cons(A,Xa),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),aa(list(A),A,groups8242544230860333062m_list(A),Xs)) ) ) ).

% sum_list.Cons
tff(fact_6796_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A,Xa: B,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),aa(list(B),list(B),cons(B,Xa),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,F3,Xa)),aa(A,A,aa(A,fun(A,A),times_times(A),A2),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),Xs))) ) ) ).

% horner_sum_simps(2)
tff(fact_6797_enumerate__simps_I2_J,axiom,
    ! [A: $tType,N: nat,Xa: A,Xs: list(A)] : ( enumerate(A,N,aa(list(A),list(A),cons(A,Xa),Xs)) = aa(list(product_prod(nat,A)),list(product_prod(nat,A)),cons(product_prod(nat,A),aa(A,product_prod(nat,A),product_Pair(nat,A,N),Xa)),enumerate(A,aa(nat,nat,suc,N),Xs)) ) ).

% enumerate_simps(2)
tff(fact_6798_nth__Cons__numeral,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),V: num] : ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,Xa),Xs)),aa(num,nat,numeral_numeral(nat),V)) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat))) ) ).

% nth_Cons_numeral
tff(fact_6799_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,Xa: A,Xs: list(A)] : ( take(A,aa(num,nat,numeral_numeral(nat),V),aa(list(A),list(A),cons(A,Xa),Xs)) = aa(list(A),list(A),cons(A,Xa),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs)) ) ).

% take_Cons_numeral
tff(fact_6800_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,Xa: A,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,Xa),Xs)),N) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ) ).

% nth_Cons_pos
tff(fact_6801_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y: A,Xs: list(A),Ys: list(A)] : aa(set(list(A)),$o,aa(set(list(A)),fun(set(list(A)),$o),ord_less_eq(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Y)),shuffles(A,Xs,Ys))),shuffles(A,Xs,aa(list(A),list(A),cons(A,Y),Ys))) ).

% Cons_shuffles_subset2
tff(fact_6802_Cons__shuffles__subset1,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),Ys: list(A)] : aa(set(list(A)),$o,aa(set(list(A)),fun(set(list(A)),$o),ord_less_eq(set(list(A))),aa(set(list(A)),set(list(A)),image(list(A),list(A),cons(A,Xa)),shuffles(A,Xs,Ys))),shuffles(A,aa(list(A),list(A),cons(A,Xa),Xs),Ys)) ).

% Cons_shuffles_subset1
tff(fact_6803_insort__key_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),Xa: A,Y: A,Ys: list(A)] :
          ( linorder_insort_key(A,B,F3,Xa,aa(list(A),list(A),cons(A,Y),Ys))
          = $ite(aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa)),aa(A,B,F3,Y)),aa(list(A),list(A),cons(A,Xa),aa(list(A),list(A),cons(A,Y),Ys)),aa(list(A),list(A),cons(A,Y),linorder_insort_key(A,B,F3,Xa,Ys))) ) ) ).

% insort_key.simps(2)
tff(fact_6804_impossible__Cons,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),Xa: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys))
     => ( Xs != aa(list(A),list(A),cons(A,Xa),Ys) ) ) ).

% impossible_Cons
tff(fact_6805_list__update__code_I3_J,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),I: nat,Y: A] : ( list_update(A,aa(list(A),list(A),cons(A,Xa),Xs),aa(nat,nat,suc,I),Y) = aa(list(A),list(A),cons(A,Xa),list_update(A,Xs,I,Y)) ) ).

% list_update_code(3)
tff(fact_6806_list__update__code_I2_J,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),Y: A] : ( list_update(A,aa(list(A),list(A),cons(A,Xa),Xs),zero_zero(nat),Y) = aa(list(A),list(A),cons(A,Y),Xs) ) ).

% list_update_code(2)
tff(fact_6807_length__Cons,axiom,
    ! [A: $tType,Xa: A,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),cons(A,Xa),Xs)) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_Cons
tff(fact_6808_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( aa(nat,nat,suc,N) = aa(list(A),nat,size_size(list(A)),Xs) )
    <=> ? [Y5: A,Ys2: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,Y5),Ys2) )
          & ( aa(list(A),nat,size_size(list(A)),Ys2) = N ) ) ) ).

% Suc_length_conv
tff(fact_6809_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,N) )
    <=> ? [Y5: A,Ys2: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,Y5),Ys2) )
          & ( aa(list(A),nat,size_size(list(A)),Ys2) = N ) ) ) ).

% length_Suc_conv
tff(fact_6810_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list(A),Xa: A] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),aa(list(A),list(A),cons(A,Xa),Xs))) ).

% set_subset_Cons
tff(fact_6811_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [Xa: A,Xs: list(A)] :
          ( member(A,Xa,aa(list(A),set(A),set2(A),Xs))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(list(A),A,groups8242544230860333062m_list(A),Xs)) ) ) ).

% member_le_sum_list
tff(fact_6812_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),zero_zero(A)) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),zero_zero(A)) ) ) ).

% sum_list_nonpos
tff(fact_6813_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X) )
         => ( ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = zero_zero(A) )
          <=> ! [X4: A] :
                ( member(A,X4,aa(list(A),set(A),set2(A),Xs))
               => ( X4 = zero_zero(A) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
tff(fact_6814_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [Xs: list(A)] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),X) )
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),aa(list(A),A,groups8242544230860333062m_list(A),Xs)) ) ) ).

% Groups_List.sum_list_nonneg
tff(fact_6815_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,N)),aa(list(A),nat,size_size(list(A)),Xs))
    <=> ? [X4: A,Ys2: list(A)] :
          ( ( Xs = aa(list(A),list(A),cons(A,X4),Ys2) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(list(A),nat,size_size(list(A)),Ys2)) ) ) ).

% Suc_le_length_iff
tff(fact_6816_insort__is__Cons,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Xs: list(A),F3: fun(A,B),A2: A] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,A2)),aa(A,B,F3,X)) )
         => ( linorder_insort_key(A,B,F3,A2,Xs) = aa(list(A),list(A),cons(A,A2),Xs) ) ) ) ).

% insort_is_Cons
tff(fact_6817_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),Y: A] :
      ( aa(A,nat,count_list(A,aa(list(A),list(A),cons(A,Xa),Xs)),Y)
      = $ite(Xa = Y,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,count_list(A,Xs),Y)),one_one(nat)),aa(A,nat,count_list(A,Xs),Y)) ) ).

% count_list.simps(2)
tff(fact_6818_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),cons(A,X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),X222)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size(4)
tff(fact_6819_nth__Cons_H,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),N: nat] :
      ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,Xa),Xs)),N)
      = $ite(N = zero_zero(nat),Xa,aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)))) ) ).

% nth_Cons'
tff(fact_6820_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( canoni5634975068530333245id_add(A)
     => ! [K: nat,Ns: list(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Ns))
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Ns),K)),aa(list(A),A,groups8242544230860333062m_list(A),Ns)) ) ) ).

% elem_le_sum_list
tff(fact_6821_card__length__sum__list__rec,axiom,
    ! [M: nat,N6: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),one_one(nat)),M)
     => ( aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_aen(nat,fun(nat,fun(list(nat),$o)),M),N6))) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_aeo(nat,fun(nat,fun(list(nat),$o)),M),N6)))),aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_aep(nat,fun(nat,fun(list(nat),$o)),M),N6)))) ) ) ).

% card_length_sum_list_rec
tff(fact_6822_card__length__sum__list,axiom,
    ! [M: nat,N6: nat] : ( aa(set(list(nat)),nat,finite_card(list(nat)),collect(list(nat),aa(nat,fun(list(nat),$o),aTP_Lamp_aen(nat,fun(nat,fun(list(nat),$o)),M),N6))) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N6),M)),one_one(nat))),N6) ) ).

% card_length_sum_list
tff(fact_6823_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I: nat,J: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,I)),J)
     => ( linord4507533701916653071of_set(nat,set_or3652927894154168847AtMost(nat,I,J)) = aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,I)),linord4507533701916653071of_set(nat,set_or3652927894154168847AtMost(nat,aa(nat,nat,suc,I),J))) ) ) ).

% sorted_list_of_set_greaterThanAtMost
tff(fact_6824_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I: nat,J: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),J)
     => ( linord4507533701916653071of_set(nat,set_or5935395276787703475ssThan(nat,I,J)) = aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,I)),linord4507533701916653071of_set(nat,set_or5935395276787703475ssThan(nat,aa(nat,nat,suc,I),J))) ) ) ).

% sorted_list_of_set_greaterThanLessThan
tff(fact_6825_nth__equal__first__eq,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),N: nat] :
      ( ~ member(A,Xa,aa(list(A),set(A),set2(A),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
       => ( ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,Xa),Xs)),N) = Xa )
        <=> ( N = zero_zero(nat) ) ) ) ) ).

% nth_equal_first_eq
tff(fact_6826_nth__non__equal__first__eq,axiom,
    ! [A: $tType,Xa: A,Y: A,Xs: list(A),N: nat] :
      ( ( Xa != Y )
     => ( ( aa(nat,A,nth(A,aa(list(A),list(A),cons(A,Xa),Xs)),N) = Y )
      <=> ( ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) = Y )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N) ) ) ) ).

% nth_non_equal_first_eq
tff(fact_6827_sum__list__sum__nth,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),nth(A,Xs)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) ) ) ).

% sum_list_sum_nth
tff(fact_6828_upto__aux__rec,axiom,
    ! [I: int,J: int,Js: list(int)] :
      ( upto_aux(I,J,Js)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less(int),J),I),Js,upto_aux(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J),one_one(int)),aa(list(int),list(int),cons(int,J),Js))) ) ).

% upto_aux_rec
tff(fact_6829_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list(A),X6: set(A),F3: fun(A,nat)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),X6)
     => ( aa(set(A),$o,finite_finite(A),X6)
       => ( aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F3,Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(fun(A,nat),fun(A,nat),aTP_Lamp_aeq(list(A),fun(fun(A,nat),fun(A,nat)),Xs),F3)),X6) ) ) ) ).

% sum_list_map_eq_sum_count2
tff(fact_6830_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aTP_Lamp_aer(B,A),Xs)) = zero_zero(A) ) ) ).

% sum_list_0
tff(fact_6831_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [F3: fun(B,A),G: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ec(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G),Xs)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F3,Xs))),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,G,Xs))) ) ) ).

% sum_list_subtractf
tff(fact_6832_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [F3: fun(B,A),C2: A,Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(A,fun(B,A),aTP_Lamp_ea(fun(B,A),fun(A,fun(B,A)),F3),C2),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F3,Xs))),C2) ) ) ).

% sum_list_mult_const
tff(fact_6833_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [C2: A,F3: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_eb(A,fun(fun(B,A),fun(B,A)),C2),F3),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),C2),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F3,Xs))) ) ) ).

% sum_list_const_mult
tff(fact_6834_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [F3: fun(B,A),G: fun(B,A),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ed(fun(B,A),fun(fun(B,A),fun(B,A)),F3),G),Xs)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F3,Xs))),aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,G,Xs))) ) ) ).

% sum_list_addf
tff(fact_6835_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [Xs: list(A)] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs))),aa(list(A),A,groups8242544230860333062m_list(A),map(A,A,abs_abs(A),Xs))) ) ).

% sum_list_abs
tff(fact_6836_sum__list__Suc,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] : ( aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,aTP_Lamp_fg(fun(A,nat),fun(A,nat),F3),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F3,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% sum_list_Suc
tff(fact_6837_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add(B)
        & ordere6658533253407199908up_add(B) )
     => ! [Xs: list(A),F3: fun(A,B),G: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F3,Xs))),aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,G,Xs))) ) ) ).

% sum_list_mono
tff(fact_6838_sum__list__map__remove1,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Xa: A,Xs: list(A),F3: fun(A,B)] :
          ( member(A,Xa,aa(list(A),set(A),set2(A),Xs))
         => ( aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F3,Xs)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,Xa)),aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F3,remove1(A,Xa,Xs)))) ) ) ) ).

% sum_list_map_remove1
tff(fact_6839_sum__list__triv,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [R: A,Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aTP_Lamp_dx(A,fun(B,A),R),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(list(B),nat,size_size(list(B)),Xs))),R) ) ) ).

% sum_list_triv
tff(fact_6840_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] : ( aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F3,Xs)) = aa(set(A),nat,aa(fun(A,nat),fun(set(A),nat),groups7311177749621191930dd_sum(A,nat),aa(list(A),fun(A,nat),aTP_Lamp_aes(fun(A,nat),fun(list(A),fun(A,nat)),F3),Xs)),aa(list(A),set(A),set2(A),Xs)) ) ).

% sum_list_map_eq_sum_count
tff(fact_6841_list__encode_Osimps_I2_J,axiom,
    ! [Xa: nat,Xs: list(nat)] : ( aa(list(nat),nat,nat_list_encode,aa(list(nat),list(nat),cons(nat,Xa),Xs)) = aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),aa(list(nat),nat,nat_list_encode,Xs)))) ) ).

% list_encode.simps(2)
tff(fact_6842_size__list__conv__sum__list,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] : ( size_list(A,F3,Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F3,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% size_list_conv_sum_list
tff(fact_6843_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( n_lists(A,aa(nat,nat,suc,N),Xs) = concat(list(A),map(list(A),list(list(A)),aTP_Lamp_aeu(list(A),fun(list(A),list(list(A))),Xs),n_lists(A,N,Xs))) ) ).

% n_lists.simps(2)
tff(fact_6844_surj__list__encode,axiom,
    aa(set(list(nat)),set(nat),image(list(nat),nat,nat_list_encode),top_top(set(list(nat)))) = top_top(set(nat)) ).

% surj_list_encode
tff(fact_6845_list__encode__eq,axiom,
    ! [Xa: list(nat),Y: list(nat)] :
      ( ( aa(list(nat),nat,nat_list_encode,Xa) = aa(list(nat),nat,nat_list_encode,Y) )
    <=> ( Xa = Y ) ) ).

% list_encode_eq
tff(fact_6846_bij__list__encode,axiom,
    bij_betw(list(nat),nat,nat_list_encode,top_top(set(list(nat))),top_top(set(nat))) ).

% bij_list_encode
tff(fact_6847_inj__list__encode,axiom,
    ! [A3: set(list(nat))] : inj_on(list(nat),nat,nat_list_encode,A3) ).

% inj_list_encode
tff(fact_6848_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list(A),F3: fun(A,nat),G: fun(A,nat)] :
      ( ! [X: A] :
          ( member(A,X,aa(list(A),set(A),set2(A),Xs))
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F3,X)),aa(A,nat,G,X)) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),size_list(A,F3,Xs)),size_list(A,G,Xs)) ) ).

% size_list_pointwise
tff(fact_6849_size__list__estimation_H,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),Y: nat,F3: fun(A,nat)] :
      ( member(A,Xa,aa(list(A),set(A),set2(A),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y),aa(A,nat,F3,Xa))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Y),size_list(A,F3,Xs)) ) ) ).

% size_list_estimation'
tff(fact_6850_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,Xa: fun(A,nat),X21: A,X222: list(A)] : ( size_list(A,Xa,aa(list(A),list(A),cons(A,X21),X222)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,Xa,X21)),size_list(A,Xa,X222))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% list.size_gen(2)
tff(fact_6851_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [A: $tType] :
      ( ordere6911136660526730532id_add(A)
     => ! [F3: fun(nat,A),Ns: list(nat)] :
          ( ! [X: nat,Y3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Y3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,X)),aa(nat,A,F3,Y3)) )
         => ( sorted_wrt(nat,ord_less(nat),Ns)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),F3),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(nat),nat,size_size(list(nat)),Ns)))),aa(list(A),A,groups8242544230860333062m_list(A),map(nat,A,F3,Ns))) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
tff(fact_6852_list__encode_Oelims,axiom,
    ! [Xa: list(nat),Y: nat] :
      ( ( aa(list(nat),nat,nat_list_encode,Xa) = Y )
     => ( ( ( Xa = nil(nat) )
         => ( Y != zero_zero(nat) ) )
       => ~ ! [X: nat,Xs2: list(nat)] :
              ( ( Xa = aa(list(nat),list(nat),cons(nat,X),Xs2) )
             => ( Y != aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),aa(list(nat),nat,nat_list_encode,Xs2)))) ) ) ) ) ).

% list_encode.elims
tff(fact_6853_length__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = zero_zero(nat) )
    <=> ( Xs = nil(A) ) ) ).

% length_0_conv
tff(fact_6854_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ( aa(list(A),A,groups8242544230860333062m_list(A),nil(A)) = zero_zero(A) ) ) ).

% sum_list.Nil
tff(fact_6855_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( nil(A) = take(A,N,Xs) )
    <=> ( ( N = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil2
tff(fact_6856_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( take(A,N,Xs) = nil(A) )
    <=> ( ( N = zero_zero(nat) )
        | ( Xs = nil(A) ) ) ) ).

% take_eq_Nil
tff(fact_6857_take0,axiom,
    ! [A: $tType,X3: list(A)] : ( take(A,zero_zero(nat),X3) = nil(A) ) ).

% take0
tff(fact_6858_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),nil(B)) = zero_zero(A) ) ) ).

% horner_sum_simps(1)
tff(fact_6859_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( n_lists(A,N,nil(A))
      = $ite(N = zero_zero(nat),aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))),nil(list(A))) ) ).

% n_lists_Nil
tff(fact_6860_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(list(A),nat,size_size(list(A)),Xs))
    <=> ( Xs != nil(A) ) ) ).

% length_greater_0_conv
tff(fact_6861_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B)] :
          ( sorted_wrt(A,ord_less_eq(A),map(B,A,F3,Xs))
        <=> sorted_wrt(B,aTP_Lamp_aev(fun(B,A),fun(B,fun(B,$o)),F3),Xs) ) ) ).

% sorted_map
tff(fact_6862_list__encode_Osimps_I1_J,axiom,
    aa(list(nat),nat,nat_list_encode,nil(nat)) = zero_zero(nat) ).

% list_encode.simps(1)
tff(fact_6863_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,Xa: fun(A,nat)] : ( size_list(A,Xa,nil(A)) = zero_zero(nat) ) ).

% list.size_gen(1)
tff(fact_6864_take__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( take(A,zero_zero(nat),Xs) = nil(A) ) ).

% take_0
tff(fact_6865_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] : ( aa(A,nat,count_list(A,nil(A)),Y) = zero_zero(nat) ) ).

% count_list.simps(1)
tff(fact_6866_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [L: list(A)] :
          ( sorted_wrt(A,ord_less(A),L)
        <=> ( sorted_wrt(A,ord_less_eq(A),L)
            & distinct(A,L) ) ) ) ).

% strict_sorted_iff
tff(fact_6867_sorted__take,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),N: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),take(A,N,Xs)) ) ) ).

% sorted_take
tff(fact_6868_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% strict_sorted_imp_sorted
tff(fact_6869_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] : sorted_wrt(A,ord_less_eq(A),linord4507533701916653071of_set(A,A3)) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
tff(fact_6870_sorted0,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => sorted_wrt(A,ord_less_eq(A),nil(A)) ) ).

% sorted0
tff(fact_6871_sorted__remove1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),A2: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remove1(A,A2,Xs)) ) ) ).

% sorted_remove1
tff(fact_6872_sorted__insort,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),linorder_insort_key(A,A,aTP_Lamp_nv(A,A),Xa,Xs))
        <=> sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted_insort
tff(fact_6873_list_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(list(A),nat,size_size(list(A)),nil(A)) = zero_zero(nat) ) ).

% list.size(3)
tff(fact_6874_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Ys: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,Xa),Ys))
        <=> ( ! [X4: A] :
                ( member(A,X4,aa(list(A),set(A),set2(A),Ys))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),X4) )
            & sorted_wrt(A,ord_less_eq(A),Ys) ) ) ) ).

% sorted_simps(2)
tff(fact_6875_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list(A)] : ( n_lists(A,zero_zero(nat),Xs) = aa(list(list(A)),list(list(A)),cons(list(A),nil(A)),nil(list(A))) ) ).

% n_lists.simps(1)
tff(fact_6876_list__encode_Ocases,axiom,
    ! [Xa: list(nat)] :
      ( ( Xa != nil(nat) )
     => ~ ! [X: nat,Xs2: list(nat)] : ( Xa != aa(list(nat),list(nat),cons(nat,X),Xs2) ) ) ).

% list_encode.cases
tff(fact_6877_sorted1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A] : sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,Xa),nil(A))) ) ).

% sorted1
tff(fact_6878_sorted2,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xa: A,Y: A,Zs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,Xa),aa(list(A),list(A),cons(A,Y),Zs)))
        <=> ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
            & sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),cons(A,Y),Zs)) ) ) ) ).

% sorted2
tff(fact_6879_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( distinct(A,Xs)
           => ( sorted_wrt(A,ord_less_eq(A),Ys)
             => ( distinct(A,Ys)
               => ( ( aa(list(A),set(A),set2(A),Xs) = aa(list(A),set(A),set2(A),Ys) )
                 => ( Xs = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
tff(fact_6880_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list(A),P: fun(A,fun(A,$o))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
     => sorted_wrt(A,P,Xs) ) ).

% sorted_wrt01
tff(fact_6881_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xa: B,Xs: list(B)] :
          ( sorted_wrt(A,ord_less_eq(A),map(B,A,F3,linorder_insort_key(B,A,F3,Xa,Xs)))
        <=> sorted_wrt(A,ord_less_eq(A),map(B,A,F3,Xs)) ) ) ).

% sorted_insort_key
tff(fact_6882_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),Xa: B] :
          ( sorted_wrt(A,ord_less_eq(A),map(B,A,F3,Xs))
         => sorted_wrt(A,ord_less_eq(A),map(B,A,F3,remove1(B,Xa,Xs))) ) ) ).

% sorted_map_remove1
tff(fact_6883_sorted01,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))
         => sorted_wrt(A,ord_less_eq(A),Xs) ) ) ).

% sorted01
tff(fact_6884_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I3: nat,J3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),J3)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Xs),J3)) ) ) ) ) ).

% sorted_iff_nth_mono_less
tff(fact_6885_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ? [X: list(A)] :
              ( ( aa(list(A),set(A),set2(A),X) = A3 )
              & sorted_wrt(A,ord_less_eq(A),X)
              & distinct(A,X)
              & ! [Y4: list(A)] :
                  ( ( ( aa(list(A),set(A),set2(A),Y4) = A3 )
                    & sorted_wrt(A,ord_less_eq(A),Y4)
                    & distinct(A,Y4) )
                 => ( Y4 = X ) ) ) ) ) ).

% finite_sorted_distinct_unique
tff(fact_6886_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( distinct(A,Xs)
           => ( linord4507533701916653071of_set(A,aa(list(A),set(A),set2(A),Xs)) = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
tff(fact_6887_insort__remove1,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [A2: A,Xs: list(A)] :
          ( member(A,A2,aa(list(A),set(A),set2(A),Xs))
         => ( sorted_wrt(A,ord_less_eq(A),Xs)
           => ( linorder_insort_key(A,A,aTP_Lamp_nv(A,A),A2,remove1(A,A2,Xs)) = Xs ) ) ) ) ).

% insort_remove1
tff(fact_6888_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I3)),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I3))) ) ) ) ).

% sorted_iff_nth_Suc
tff(fact_6889_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I: nat,J: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I)),aa(nat,A,nth(A,Xs),J)) ) ) ) ) ).

% sorted_nth_mono
tff(fact_6890_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
        <=> ! [I3: nat,J3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J3)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Xs),J3)) ) ) ) ) ).

% sorted_iff_nth_mono
tff(fact_6891_sorted__wrt__less__idx,axiom,
    ! [Ns: list(nat),I: nat] :
      ( sorted_wrt(nat,ord_less(nat),Ns)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(nat),nat,size_size(list(nat)),Ns))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),aa(nat,nat,nth(nat,Ns),I)) ) ) ).

% sorted_wrt_less_idx
tff(fact_6892_map__sorted__distinct__set__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [F3: fun(A,B),Xs: list(A),Ys: list(A)] :
          ( inj_on(A,B,F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(list(A),set(A),set2(A),Ys)))
         => ( sorted_wrt(B,ord_less_eq(B),map(A,B,F3,Xs))
           => ( distinct(B,map(A,B,F3,Xs))
             => ( sorted_wrt(B,ord_less_eq(B),map(A,B,F3,Ys))
               => ( distinct(B,map(A,B,F3,Ys))
                 => ( ( aa(list(A),set(A),set2(A),Xs) = aa(list(A),set(A),set2(A),Ys) )
                   => ( Xs = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
tff(fact_6893_take__Cons_H,axiom,
    ! [A: $tType,N: nat,Xa: A,Xs: list(A)] :
      ( take(A,N,aa(list(A),list(A),cons(A,Xa),Xs))
      = $ite(N = zero_zero(nat),nil(A),aa(list(A),list(A),cons(A,Xa),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),Xs))) ) ).

% take_Cons'
tff(fact_6894_list__encode_Opelims,axiom,
    ! [Xa: list(nat),Y: nat] :
      ( ( aa(list(nat),nat,nat_list_encode,Xa) = Y )
     => ( aa(list(nat),$o,accp(list(nat),nat_list_encode_rel),Xa)
       => ( ( ( Xa = nil(nat) )
           => ( ( Y = zero_zero(nat) )
             => ~ aa(list(nat),$o,accp(list(nat),nat_list_encode_rel),nil(nat)) ) )
         => ~ ! [X: nat,Xs2: list(nat)] :
                ( ( Xa = aa(list(nat),list(nat),cons(nat,X),Xs2) )
               => ( ( Y = aa(nat,nat,suc,aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X),aa(list(nat),nat,nat_list_encode,Xs2)))) )
                 => ~ aa(list(nat),$o,accp(list(nat),nat_list_encode_rel),aa(list(nat),list(nat),cons(nat,X),Xs2)) ) ) ) ) ) ).

% list_encode.pelims
tff(fact_6895_concat__inth,axiom,
    ! [A: $tType,Xs: list(A),Xa: A,Ys: list(A)] : ( aa(nat,A,nth(A,append(A,Xs,append(A,aa(list(A),list(A),cons(A,Xa),nil(A)),Ys))),aa(list(A),nat,size_size(list(A)),Xs)) = Xa ) ).

% concat_inth
tff(fact_6896_length__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] : ( aa(list(A),nat,size_size(list(A)),append(A,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(list(A),nat,size_size(list(A)),Ys)) ) ).

% length_append
tff(fact_6897_sum__list__append,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A),Ys: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),append(A,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),Xs)),aa(list(A),A,groups8242544230860333062m_list(A),Ys)) ) ) ).

% sum_list_append
tff(fact_6898_size__list__append,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A),Ys: list(A)] : ( size_list(A,F3,append(A,Xs,Ys)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_list(A,F3,Xs)),size_list(A,F3,Ys)) ) ).

% size_list_append
tff(fact_6899_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),N: nat] : ( aa(nat,A,nth(A,append(A,Xs,Ys)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)) = aa(nat,A,nth(A,Ys),N) ) ).

% nth_append_length_plus
tff(fact_6900_take__append,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys: list(A)] : ( take(A,N,append(A,Xs,Ys)) = append(A,take(A,N,Xs),take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% take_append
tff(fact_6901_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] : ( linord4507533701916653071of_set(nat,set_ord_lessThan(nat,aa(nat,nat,suc,K))) = append(nat,linord4507533701916653071of_set(nat,set_ord_lessThan(nat,K)),aa(list(nat),list(nat),cons(nat,K),nil(nat))) ) ).

% sorted_list_of_set_lessThan_Suc
tff(fact_6902_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] : ( linord4507533701916653071of_set(nat,set_ord_atMost(nat,aa(nat,nat,suc,K))) = append(nat,linord4507533701916653071of_set(nat,set_ord_atMost(nat,K)),aa(list(nat),list(nat),cons(nat,aa(nat,nat,suc,K)),nil(nat))) ) ).

% sorted_list_of_set_atMost_Suc
tff(fact_6903_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys: list(A)] : ( enumerate(A,N,append(A,Xs,Ys)) = append(product_prod(nat,A),enumerate(A,N,Xs),enumerate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% enumerate_append_eq
tff(fact_6904_sorted__append,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Ys: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),append(A,Xs,Ys))
        <=> ( sorted_wrt(A,ord_less_eq(A),Xs)
            & sorted_wrt(A,ord_less_eq(A),Ys)
            & ! [X4: A] :
                ( member(A,X4,aa(list(A),set(A),set2(A),Xs))
               => ! [Xa3: A] :
                    ( member(A,Xa3,aa(list(A),set(A),set2(A),Ys))
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Xa3) ) ) ) ) ) ).

% sorted_append
tff(fact_6905_length__append__singleton,axiom,
    ! [A: $tType,Xs: list(A),Xa: A] : ( aa(list(A),nat,size_size(list(A)),append(A,Xs,aa(list(A),list(A),cons(A,Xa),nil(A)))) = aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% length_append_singleton
tff(fact_6906_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,suc,N) )
    <=> ? [Y5: A,Ys2: list(A)] :
          ( ( Xs = append(A,Ys2,aa(list(A),list(A),cons(A,Y5),nil(A))) )
          & ( aa(list(A),nat,size_size(list(A)),Ys2) = N ) ) ) ).

% length_Suc_conv_rev
tff(fact_6907_nth__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),N: nat] :
      ( aa(nat,A,nth(A,append(A,Xs,Ys)),N)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,A,nth(A,Xs),N),aa(nat,A,nth(A,Ys),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)))) ) ).

% nth_append
tff(fact_6908_list__update__append,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A),N: nat,Xa: A] :
      ( list_update(A,append(A,Xs,Ys),N,Xa)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),append(A,list_update(A,Xs,N,Xa),Ys),append(A,Xs,list_update(A,Ys,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),Xa))) ) ).

% list_update_append
tff(fact_6909_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B),Ys: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),append(B,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),Xs)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),aa(list(B),nat,size_size(list(B)),Xs))),aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),Ys))) ) ) ).

% horner_sum_append
tff(fact_6910_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),A2: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( ! [X: A] :
                ( member(A,X,aa(list(A),set(A),set2(A),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),A2) )
           => ( linorder_insort_key(A,A,aTP_Lamp_nv(A,A),A2,Xs) = append(A,Xs,aa(list(A),list(A),cons(A,A2),nil(A))) ) ) ) ) ).

% sorted_insort_is_snoc
tff(fact_6911_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
     => ( take(A,aa(nat,nat,suc,I),Xs) = append(A,take(A,I,Xs),aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I)),nil(A))) ) ) ).

% take_Suc_conv_app_nth
tff(fact_6912_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list(A),N: nat,Xa: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
       => ( ( M != N )
         => ( aa(nat,A,nth(A,append(A,take(A,N,Xs),append(A,aa(list(A),list(A),cons(A,Xa),nil(A)),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),one_one(nat)),Xs)))),M) = aa(nat,A,nth(A,Xs),M) ) ) ) ) ).

% nth_repl
tff(fact_6913_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Y: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),nat,size_size(list(A)),Xs) = aa(list(A),nat,size_size(list(A)),append(A,take(A,N,Xs),append(A,aa(list(A),list(A),cons(A,Y),nil(A)),drop(A,aa(nat,nat,suc,N),Xs)))) ) ) ).

% pos_n_replace
tff(fact_6914_drop0,axiom,
    ! [A: $tType,X3: list(A)] : ( drop(A,zero_zero(nat),X3) = X3 ) ).

% drop0
tff(fact_6915_drop__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] : ( drop(A,N,drop(A,M,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M),Xs) ) ).

% drop_drop
tff(fact_6916_drop__Suc__Cons,axiom,
    ! [A: $tType,N: nat,Xa: A,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,N),aa(list(A),list(A),cons(A,Xa),Xs)) = drop(A,N,Xs) ) ).

% drop_Suc_Cons
tff(fact_6917_length__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),drop(A,N,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% length_drop
tff(fact_6918_drop__all,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N)
     => ( drop(A,N,Xs) = nil(A) ) ) ).

% drop_all
tff(fact_6919_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( drop(A,N,Xs) = nil(A) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% drop_eq_Nil
tff(fact_6920_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( ( nil(A) = drop(A,N,Xs) )
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs)),N) ) ).

% drop_eq_Nil2
tff(fact_6921_drop__append,axiom,
    ! [A: $tType,N: nat,Xs: list(A),Ys: list(A)] : ( drop(A,N,append(A,Xs,Ys)) = append(A,drop(A,N,Xs),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)),Ys)) ) ).

% drop_append
tff(fact_6922_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,Xa: A,Xs: list(A)] : ( drop(A,aa(num,nat,numeral_numeral(nat),V),aa(list(A),list(A),cons(A,Xa),Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(num,nat,numeral_numeral(nat),V)),one_one(nat)),Xs) ) ).

% drop_Cons_numeral
tff(fact_6923_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A),I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,drop(A,N,Xs)),I) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),I)) ) ) ).

% nth_drop
tff(fact_6924_sorted__drop,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),N: nat] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),drop(A,N,Xs)) ) ) ).

% sorted_drop
tff(fact_6925_drop__0,axiom,
    ! [A: $tType,Xs: list(A)] : ( drop(A,zero_zero(nat),Xs) = Xs ) ).

% drop_0
tff(fact_6926_drop__take,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] : ( drop(A,N,take(A,M,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N),drop(A,N,Xs)) ) ).

% drop_take
tff(fact_6927_take__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] : ( take(A,N,drop(A,M,Xs)) = drop(A,M,take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M),Xs)) ) ).

% take_drop
tff(fact_6928_set__drop__subset,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),drop(A,N,Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% set_drop_subset
tff(fact_6929_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),drop(A,M,Xs))),aa(list(A),set(A),set2(A),drop(A,N,Xs))) ) ).

% set_drop_subset_set_drop
tff(fact_6930_take__add,axiom,
    ! [A: $tType,I: nat,J: nat,Xs: list(A)] : ( take(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),J),Xs) = append(A,take(A,I,Xs),take(A,J,drop(A,I,Xs))) ) ).

% take_add
tff(fact_6931_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list(A),Xa: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( drop(A,M,list_update(A,Xs,N,Xa)) = list_update(A,drop(A,M,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M),Xa) ) ) ).

% drop_update_swap
tff(fact_6932_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,Xa: A,Xs: list(A)] :
      ( drop(A,N,aa(list(A),list(A),cons(A,Xa),Xs))
      = $ite(N = zero_zero(nat),aa(list(A),list(A),cons(A,Xa),Xs),drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),Xs)) ) ).

% drop_Cons'
tff(fact_6933_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list(A),Xs_2: list(A),Ys_1: list(A),Ys_2: list(A)] :
      ( ( append(A,Xs_1,Xs_2) = append(A,Ys_1,Ys_2) )
    <=> $ite(
          aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Xs_1)),aa(list(A),nat,size_size(list(A)),Ys_1)),
          ( ( Xs_1 = take(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1) )
          & ( Xs_2 = append(A,drop(A,aa(list(A),nat,size_size(list(A)),Xs_1),Ys_1),Ys_2) ) ),
          ( ( take(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1) = Ys_1 )
          & ( append(A,drop(A,aa(list(A),nat,size_size(list(A)),Ys_1),Xs_1),Xs_2) = Ys_2 ) ) ) ) ).

% append_eq_append_conv_if
tff(fact_6934_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I)),drop(A,aa(nat,nat,suc,I),Xs)) = drop(A,I,Xs) ) ) ).

% Cons_nth_drop_Suc
tff(fact_6935_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list(A),I: nat,J: nat] :
      ( distinct(A,Vs)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
       => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(list(A),set(A),set2(A),take(A,I,Vs))),aa(list(A),set(A),set2(A),drop(A,J,Vs))) = bot_bot(set(A)) ) ) ) ).

% set_take_disj_set_drop_if_distinct
tff(fact_6936_id__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
     => ( Xs = append(A,take(A,I,Xs),aa(list(A),list(A),cons(A,aa(nat,A,nth(A,Xs),I)),drop(A,aa(nat,nat,suc,I),Xs))) ) ) ).

% id_take_nth_drop
tff(fact_6937_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list(A),A2: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(A),nat,size_size(list(A)),Xs))
     => ( list_update(A,Xs,I,A2) = append(A,take(A,I,Xs),aa(list(A),list(A),cons(A,A2),drop(A,aa(nat,nat,suc,I),Xs))) ) ) ).

% upd_conv_take_nth_drop
tff(fact_6938_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ~ ! [L2: list(B)] :
                ( sorted_wrt(A,Less,map(B,A,F3,L2))
               => ( ( aa(list(B),set(B),set2(B),L2) = A3 )
                 => ( aa(list(B),nat,size_size(list(B)),L2) != aa(set(B),nat,finite_card(B),A3) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
tff(fact_6939_upto_Opsimps,axiom,
    ! [I: int,J: int] :
      ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,I),J))
     => ( upto(I,J)
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J),aa(list(int),list(int),cons(int,I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J)),nil(int)) ) ) ).

% upto.psimps
tff(fact_6940_nth__upto,axiom,
    ! [I: int,K: nat,J: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),plus_plus(int),I),aa(nat,int,semiring_1_of_nat(int),K))),J)
     => ( aa(nat,int,nth(int,upto(I,J)),K) = aa(int,int,aa(int,fun(int,int),plus_plus(int),I),aa(nat,int,semiring_1_of_nat(int),K)) ) ) ).

% nth_upto
tff(fact_6941_length__upto,axiom,
    ! [I: int,J: int] : ( aa(list(int),nat,size_size(list(int)),upto(I,J)) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),J),I)),one_one(int))) ) ).

% length_upto
tff(fact_6942_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( upto(aa(num,int,numeral_numeral(int),M),aa(num,int,numeral_numeral(int),N))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N)),aa(list(int),list(int),cons(int,aa(num,int,numeral_numeral(int),M)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),M)),one_one(int)),aa(num,int,numeral_numeral(int),N))),nil(int)) ) ).

% upto_rec_numeral(1)
tff(fact_6943_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( upto(aa(num,int,numeral_numeral(int),M),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))),aa(list(int),list(int),cons(int,aa(num,int,numeral_numeral(int),M)),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(num,int,numeral_numeral(int),M)),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)))),nil(int)) ) ).

% upto_rec_numeral(2)
tff(fact_6944_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(num,int,numeral_numeral(int),N))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(num,int,numeral_numeral(int),N)),aa(list(int),list(int),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),one_one(int)),aa(num,int,numeral_numeral(int),N))),nil(int)) ) ).

% upto_rec_numeral(3)
tff(fact_6945_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( upto(aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)))
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))),aa(list(int),list(int),cons(int,aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),M))),one_one(int)),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N)))),nil(int)) ) ).

% upto_rec_numeral(4)
tff(fact_6946_sorted__upto,axiom,
    ! [M: int,N: int] : sorted_wrt(int,ord_less_eq(int),upto(M,N)) ).

% sorted_upto
tff(fact_6947_upto__split2,axiom,
    ! [I: int,J: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J),K)
       => ( upto(I,K) = append(int,upto(I,J),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J),one_one(int)),K)) ) ) ) ).

% upto_split2
tff(fact_6948_upto__split1,axiom,
    ! [I: int,J: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J),K)
       => ( upto(I,K) = append(int,upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J),one_one(int))),upto(J,K)) ) ) ) ).

% upto_split1
tff(fact_6949_atLeastLessThan__upto,axiom,
    ! [I: int,J: int] : ( set_or7035219750837199246ssThan(int,I,J) = aa(list(int),set(int),set2(int),upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J),one_one(int)))) ) ).

% atLeastLessThan_upto
tff(fact_6950_greaterThanAtMost__upto,axiom,
    ! [I: int,J: int] : ( set_or3652927894154168847AtMost(int,I,J) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J)) ) ).

% greaterThanAtMost_upto
tff(fact_6951_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => folding_insort_key(A,A,ord_less_eq(A),ord_less(A),top_top(set(A)),aTP_Lamp_nv(A,A)) ) ).

% sorted_list_of_set.folding_insort_key_axioms
tff(fact_6952_upto_Osimps,axiom,
    ! [I: int,J: int] :
      ( upto(I,J)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J),aa(list(int),list(int),cons(int,I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J)),nil(int)) ) ).

% upto.simps
tff(fact_6953_upto_Oelims,axiom,
    ! [Xa: int,Xaa: int,Y: list(int)] :
      ( ( upto(Xa,Xaa) = Y )
     => ( Y
        = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),Xaa),aa(list(int),list(int),cons(int,Xa),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),one_one(int)),Xaa)),nil(int)) ) ) ).

% upto.elims
tff(fact_6954_upto__rec1,axiom,
    ! [I: int,J: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J)
     => ( upto(I,J) = aa(list(int),list(int),cons(int,I),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),J)) ) ) ).

% upto_rec1
tff(fact_6955_upto__rec2,axiom,
    ! [I: int,J: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J)
     => ( upto(I,J) = append(int,upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J),one_one(int))),aa(list(int),list(int),cons(int,J),nil(int))) ) ) ).

% upto_rec2
tff(fact_6956_greaterThanLessThan__upto,axiom,
    ! [I: int,J: int] : ( set_or5935395276787703475ssThan(int,I,J) = aa(list(int),set(int),set2(int),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),I),one_one(int)),aa(int,int,aa(int,fun(int,int),minus_minus(int),J),one_one(int)))) ) ).

% greaterThanLessThan_upto
tff(fact_6957_upto__split3,axiom,
    ! [I: int,J: int,K: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),I),J)
     => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),J),K)
       => ( upto(I,K) = append(int,upto(I,aa(int,int,aa(int,fun(int,int),minus_minus(int),J),one_one(int))),aa(list(int),list(int),cons(int,J),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),J),one_one(int)),K))) ) ) ) ).

% upto_split3
tff(fact_6958_upto_Opelims,axiom,
    ! [Xa: int,Xaa: int,Y: list(int)] :
      ( ( upto(Xa,Xaa) = Y )
     => ( aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,Xa),Xaa))
       => ~ ( ( Y
              = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),Xaa),aa(list(int),list(int),cons(int,Xa),upto(aa(int,int,aa(int,fun(int,int),plus_plus(int),Xa),one_one(int)),Xaa)),nil(int)) )
           => ~ aa(product_prod(int,int),$o,accp(product_prod(int,int),upto_rel),aa(int,product_prod(int,int),product_Pair(int,int,Xa),Xaa)) ) ) ) ).

% upto.pelims
tff(fact_6959_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B),L: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( ( sorted_wrt(A,Less,map(B,A,F3,L))
              & ( aa(list(B),set(B),set2(B),L) = A3 )
              & ( aa(list(B),nat,size_size(list(B)),L) = aa(set(B),nat,finite_card(B),A3) ) )
          <=> ( sorted8670434370408473282of_set(A,B,Less_eq,F3,A3) = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
tff(fact_6960_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),Xa: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,Xa),A3)),S2)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,Xa),bot_bot(set(B))))) = remove1(B,Xa,sorted8670434370408473282of_set(A,B,Less_eq,F3,A3)) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
tff(fact_6961_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B),B3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B3),S2)
         => ( ( sorted8670434370408473282of_set(A,B,Less_eq,F3,A3) = sorted8670434370408473282of_set(A,B,Less_eq,F3,B3) )
           => ( aa(set(B),$o,finite_finite(B),A3)
             => ( aa(set(B),$o,finite_finite(B),B3)
               => ( A3 = B3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
tff(fact_6962_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( aa(list(B),set(B),set2(B),sorted8670434370408473282of_set(A,B,Less_eq,F3,A3)) = A3 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
tff(fact_6963_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => ( aa(list(B),nat,size_size(list(B)),sorted8670434370408473282of_set(A,B,Less_eq,F3,A3)) = aa(set(B),nat,finite_card(B),A3) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
tff(fact_6964_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => distinct(A,map(B,A,F3,sorted8670434370408473282of_set(A,B,Less_eq,F3,A3))) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
tff(fact_6965_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => sorted_wrt(A,Less_eq,map(B,A,F3,sorted8670434370408473282of_set(A,B,Less_eq,F3,A3))) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
tff(fact_6966_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => sorted_wrt(A,Less,map(B,A,F3,sorted8670434370408473282of_set(A,B,Less_eq,F3,A3))) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
tff(fact_6967_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),S2)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( ( sorted8670434370408473282of_set(A,B,Less_eq,F3,A3) = nil(B) )
          <=> ( A3 = bot_bot(set(B)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
tff(fact_6968_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),Xs: list(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(list(B),set(B),set2(B),Xs)),S2)
       => ( sorted_wrt(A,Less_eq,map(B,A,F3,Xs))
         => ( distinct(B,Xs)
           => ( sorted8670434370408473282of_set(A,B,Less_eq,F3,aa(list(B),set(B),set2(B),Xs)) = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
tff(fact_6969_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),Xa: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,Xa),A3)),S2)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( sorted8670434370408473282of_set(A,B,Less_eq,F3,aa(set(B),set(B),insert(B,Xa),A3)) = insort_key(A,B,Less_eq,F3,Xa,sorted8670434370408473282of_set(A,B,Less_eq,F3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),aa(set(B),set(B),insert(B,Xa),bot_bot(set(B)))))) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
tff(fact_6970_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: fun(A,fun(A,$o)),Less: fun(A,fun(A,$o)),S2: set(B),F3: fun(B,A),Xa: B,A3: set(B)] :
      ( folding_insort_key(A,B,Less_eq,Less,S2,F3)
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),insert(B,Xa),A3)),S2)
       => ( aa(set(B),$o,finite_finite(B),A3)
         => ( ~ member(B,Xa,A3)
           => ( sorted8670434370408473282of_set(A,B,Less_eq,F3,aa(set(B),set(B),insert(B,Xa),A3)) = insort_key(A,B,Less_eq,F3,Xa,sorted8670434370408473282of_set(A,B,Less_eq,F3,A3)) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
tff(fact_6971_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
     => ( append(A,take(A,N,Xs),aa(list(A),list(A),cons(A,hd(A,drop(A,N,Xs))),nil(A))) = take(A,aa(nat,nat,suc,N),Xs) ) ) ).

% take_hd_drop
tff(fact_6972_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [A2: A,N: nat] : ( aa(list($o),A,aa(A,fun(list($o),A),aa(fun($o,A),fun(A,fun(list($o),A)),groups4207007520872428315er_sum($o,A),zero_neq_one_of_bool(A)),aa(num,A,numeral_numeral(A),bit0(one2))),map(nat,$o,bit_se5641148757651400278ts_bit(A,A2),upt(zero_zero(nat),N))) = aa(A,A,bit_se2584673776208193580ke_bit(A,N),A2) ) ) ).

% horner_sum_bit_eq_take_bit
tff(fact_6973_drop__upt,axiom,
    ! [M: nat,I: nat,J: nat] : ( drop(nat,M,upt(I,J)) = upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M),J) ) ).

% drop_upt
tff(fact_6974_take__upt,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M)),N)
     => ( take(nat,M,upt(I,N)) = upt(I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),M)) ) ) ).

% take_upt
tff(fact_6975_upt__conv__Nil,axiom,
    ! [J: nat,I: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),I)
     => ( upt(I,J) = nil(nat) ) ) ).

% upt_conv_Nil
tff(fact_6976_length__upt,axiom,
    ! [I: nat,J: nat] : ( aa(list(nat),nat,size_size(list(nat)),upt(I,J)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),I) ) ).

% length_upt
tff(fact_6977_hd__take,axiom,
    ! [A: $tType,J: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),J)
     => ( hd(A,take(A,J,Xs)) = hd(A,Xs) ) ) ).

% hd_take
tff(fact_6978_upt__eq__Nil__conv,axiom,
    ! [I: nat,J: nat] :
      ( ( upt(I,J) = nil(nat) )
    <=> ( ( J = zero_zero(nat) )
        | aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),I) ) ) ).

% upt_eq_Nil_conv
tff(fact_6979_nth__upt,axiom,
    ! [I: nat,K: nat,J: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K)),J)
     => ( aa(nat,nat,nth(nat,upt(I,J)),K) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),K) ) ) ).

% nth_upt
tff(fact_6980_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(list(nat),nat,groups8242544230860333062m_list(nat),upt(M,N)) = aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aTP_Lamp_bg(nat,nat)),set_or7035219750837199246ssThan(nat,M,N)) ) ) ).

% sum_list_upt
tff(fact_6981_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( upt(aa(num,nat,numeral_numeral(nat),M),aa(num,nat,numeral_numeral(nat),N))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N)),aa(list(nat),list(nat),cons(nat,aa(num,nat,numeral_numeral(nat),M)),upt(aa(nat,nat,suc,aa(num,nat,numeral_numeral(nat),M)),aa(num,nat,numeral_numeral(nat),N))),nil(nat)) ) ).

% upt_rec_numeral
tff(fact_6982_upt__0,axiom,
    ! [I: nat] : ( upt(I,zero_zero(nat)) = nil(nat) ) ).

% upt_0
tff(fact_6983_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list(nat),Q2: nat] :
      ( ( aa(list(nat),list(nat),cons(nat,M),aa(list(nat),list(nat),cons(nat,N),Ns)) = upt(M,Q2) )
    <=> ( aa(list(nat),list(nat),cons(nat,N),Ns) = upt(aa(nat,nat,suc,M),Q2) ) ) ).

% upt_conv_Cons_Cons
tff(fact_6984_map__add__upt,axiom,
    ! [N: nat,M: nat] : ( map(nat,nat,aTP_Lamp_aew(nat,fun(nat,nat),N),upt(zero_zero(nat),M)) = upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% map_add_upt
tff(fact_6985_map__Suc__upt,axiom,
    ! [M: nat,N: nat] : ( map(nat,nat,suc,upt(M,N)) = upt(aa(nat,nat,suc,M),aa(nat,nat,suc,N)) ) ).

% map_Suc_upt
tff(fact_6986_atLeastAtMost__upt,axiom,
    ! [N: nat,M: nat] : ( set_or1337092689740270186AtMost(nat,N,M) = aa(list(nat),set(nat),set2(nat),upt(N,aa(nat,nat,suc,M))) ) ).

% atLeastAtMost_upt
tff(fact_6987_atLeast__upt,axiom,
    ! [N: nat] : ( set_ord_lessThan(nat,N) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),N)) ) ).

% atLeast_upt
tff(fact_6988_greaterThanAtMost__upt,axiom,
    ! [N: nat,M: nat] : ( set_or3652927894154168847AtMost(nat,N,M) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,N),aa(nat,nat,suc,M))) ) ).

% greaterThanAtMost_upt
tff(fact_6989_greaterThanLessThan__upt,axiom,
    ! [N: nat,M: nat] : ( set_or5935395276787703475ssThan(nat,N,M) = aa(list(nat),set(nat),set2(nat),upt(aa(nat,nat,suc,N),M)) ) ).

% greaterThanLessThan_upt
tff(fact_6990_sorted__upt,axiom,
    ! [M: nat,N: nat] : sorted_wrt(nat,ord_less_eq(nat),upt(M,N)) ).

% sorted_upt
tff(fact_6991_atMost__upto,axiom,
    ! [N: nat] : ( set_ord_atMost(nat,N) = aa(list(nat),set(nat),set2(nat),upt(zero_zero(nat),aa(nat,nat,suc,N))) ) ).

% atMost_upto
tff(fact_6992_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( hd(A,Xs) = aa(nat,A,nth(A,Xs),zero_zero(nat)) ) ) ).

% hd_conv_nth
tff(fact_6993_upt__conv__Cons,axiom,
    ! [I: nat,J: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( upt(I,J) = aa(list(nat),list(nat),cons(nat,I),upt(aa(nat,nat,suc,I),J)) ) ) ).

% upt_conv_Cons
tff(fact_6994_map__decr__upt,axiom,
    ! [M: nat,N: nat] : ( map(nat,nat,aTP_Lamp_ms(nat,nat),upt(aa(nat,nat,suc,M),aa(nat,nat,suc,N))) = upt(M,N) ) ).

% map_decr_upt
tff(fact_6995_upt__add__eq__append,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( upt(I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),K)) = append(nat,upt(I,J),upt(J,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),K))) ) ) ).

% upt_add_eq_append
tff(fact_6996_upt__eq__Cons__conv,axiom,
    ! [I: nat,J: nat,Xa: nat,Xs: list(nat)] :
      ( ( upt(I,J) = aa(list(nat),list(nat),cons(nat,Xa),Xs) )
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
        & ( I = Xa )
        & ( upt(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),one_one(nat)),J) = Xs ) ) ) ).

% upt_eq_Cons_conv
tff(fact_6997_upt__rec,axiom,
    ! [I: nat,J: nat] :
      ( upt(I,J)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J),aa(list(nat),list(nat),cons(nat,I),upt(aa(nat,nat,suc,I),J)),nil(nat)) ) ).

% upt_rec
tff(fact_6998_map__upt__Suc,axiom,
    ! [A: $tType,F3: fun(nat,A),N: nat] : ( map(nat,A,F3,upt(zero_zero(nat),aa(nat,nat,suc,N))) = aa(list(A),list(A),cons(A,aa(nat,A,F3,zero_zero(nat))),map(nat,A,aTP_Lamp_wq(fun(nat,A),fun(nat,A),F3),upt(zero_zero(nat),N))) ) ).

% map_upt_Suc
tff(fact_6999_map__nth,axiom,
    ! [A: $tType,Xs: list(A)] : ( map(nat,A,nth(A,Xs),upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = Xs ) ).

% map_nth
tff(fact_7000_nth__map__upt,axiom,
    ! [A: $tType,I: nat,N: nat,M: nat,F3: fun(nat,A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M))
     => ( aa(nat,A,nth(A,map(nat,A,F3,upt(M,N))),I) = aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I)) ) ) ).

% nth_map_upt
tff(fact_7001_upt__Suc__append,axiom,
    ! [I: nat,J: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
     => ( upt(I,aa(nat,nat,suc,J)) = append(nat,upt(I,J),aa(list(nat),list(nat),cons(nat,J),nil(nat))) ) ) ).

% upt_Suc_append
tff(fact_7002_upt__Suc,axiom,
    ! [I: nat,J: nat] :
      ( upt(I,aa(nat,nat,suc,J))
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J),append(nat,upt(I,J),aa(list(nat),list(nat),cons(nat,J),nil(nat))),nil(nat)) ) ).

% upt_Suc
tff(fact_7003_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list(A),N: nat,M: nat,F3: fun(nat,A)] :
      ( ( aa(list(A),nat,size_size(list(A)),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M) )
     => ( ! [I2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(A),nat,size_size(list(A)),Xs))
           => ( aa(nat,A,nth(A,Xs),I2) = aa(nat,A,F3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),I2)) ) )
       => ( map(nat,A,F3,upt(M,N)) = Xs ) ) ) ).

% map_upt_eqI
tff(fact_7004_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list(list(A)),N: nat] :
      ( ( ( Xs = nil(list(A)) )
       => ( N = zero_zero(nat) ) )
     => ( ! [I2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
           => ( aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I2)) = N ) )
       => ( transpose(A,Xs) = map(nat,list(A),aTP_Lamp_aey(list(list(A)),fun(nat,list(A)),Xs),upt(zero_zero(nat),N)) ) ) ) ).

% transpose_rectangle
tff(fact_7005_insort__key__remove1,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [A2: A,Xs: list(A),F3: fun(A,B)] :
          ( member(A,A2,aa(list(A),set(A),set2(A),Xs))
         => ( sorted_wrt(B,ord_less_eq(B),map(A,B,F3,Xs))
           => ( ( hd(A,filter2(A,aa(fun(A,B),fun(A,$o),aTP_Lamp_aez(A,fun(fun(A,B),fun(A,$o)),A2),F3),Xs)) = A2 )
             => ( linorder_insort_key(A,B,F3,A2,remove1(A,A2,Xs)) = Xs ) ) ) ) ) ).

% insort_key_remove1
tff(fact_7006_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),P: fun(B,$o)] :
          ( sorted_wrt(A,ord_less_eq(A),map(B,A,F3,Xs))
         => sorted_wrt(A,ord_less_eq(A),map(B,A,F3,filter2(B,P,Xs))) ) ) ).

% sorted_filter
tff(fact_7007_sorted__same,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [G: fun(list(A),A),Xs: list(A)] : sorted_wrt(A,ord_less_eq(A),filter2(A,aa(list(A),fun(A,$o),aTP_Lamp_afa(fun(list(A),A),fun(list(A),fun(A,$o)),G),Xs),Xs)) ) ).

% sorted_same
tff(fact_7008_length__filter__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),filter2(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_filter_le
tff(fact_7009_sum__length__filter__compl,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),filter2(A,P,Xs))),aa(list(A),nat,size_size(list(A)),filter2(A,aTP_Lamp_ii(fun(A,$o),fun(A,$o),P),Xs))) = aa(list(A),nat,size_size(list(A)),Xs) ) ).

% sum_length_filter_compl
tff(fact_7010_filter__is__subset,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),filter2(A,P,Xs))),aa(list(A),set(A),set2(A),Xs)) ).

% filter_is_subset
tff(fact_7011_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),G: fun(list(B),A),Xs: list(B)] : sorted_wrt(A,ord_less_eq(A),map(B,A,F3,filter2(B,aa(list(B),fun(B,$o),aa(fun(list(B),A),fun(list(B),fun(B,$o)),aTP_Lamp_afb(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,$o))),F3),G),Xs),Xs))) ) ).

% sorted_map_same
tff(fact_7012_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( monoid_add(A)
     => ! [F3: fun(B,A),P: fun(B,$o),Xs: list(B)] : ( aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,F3,filter2(B,P,Xs))) = aa(list(A),A,groups8242544230860333062m_list(A),map(B,A,aa(fun(B,$o),fun(B,A),aTP_Lamp_afc(fun(B,A),fun(fun(B,$o),fun(B,A)),F3),P),Xs)) ) ) ).

% sum_list_map_filter'
tff(fact_7013_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F3: fun(A,nat),P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F3,filter2(A,P,Xs)))),aa(list(nat),nat,groups8242544230860333062m_list(nat),map(A,nat,F3,Xs))) ).

% sum_list_filter_le_nat
tff(fact_7014_sum__list__map__filter,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(B)
     => ! [Xs: list(A),P: fun(A,$o),F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => ( ~ aa(A,$o,P,X)
               => ( aa(A,B,F3,X) = zero_zero(B) ) ) )
         => ( aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F3,filter2(A,P,Xs))) = aa(list(B),B,groups8242544230860333062m_list(B),map(A,B,F3,Xs)) ) ) ) ).

% sum_list_map_filter
tff(fact_7015_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),P: fun(B,$o),Xa: B] :
          ( sorted_wrt(A,ord_less_eq(A),map(B,A,F3,Xs))
         => ( aa(B,$o,P,Xa)
           => ( filter2(B,P,linorder_insort_key(B,A,F3,Xa,Xs)) = linorder_insort_key(B,A,F3,Xa,filter2(B,P,Xs)) ) ) ) ) ).

% filter_insort
tff(fact_7016_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list(A),Y: A] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(list(A),set(A),set2(A),Xs)),aa(set(A),set(A),insert(A,Y),bot_bot(set(A)))) = aa(list(A),set(A),set2(A),filter2(A,aTP_Lamp_afd(A,fun(A,$o),Y),Xs)) ) ).

% set_minus_filter_out
tff(fact_7017_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A)),I: nat,J: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)))
       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(list(A)),nat,size_size(list(list(A))),filter2(list(A),aTP_Lamp_afe(nat,fun(list(A),$o),I),Xs)))
         => ( aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),transpose(A,Xs)),I)),J) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Xs),J)),I) ) ) ) ) ).

% nth_nth_transpose_sorted
tff(fact_7018_transpose__column,axiom,
    ! [A: $tType,Xs: list(list(A)),I: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
       => ( map(list(A),A,aTP_Lamp_aff(nat,fun(list(A),A),I),filter2(list(A),aTP_Lamp_afe(nat,fun(list(A),$o),I),transpose(A,Xs))) = aa(nat,list(A),nth(list(A),Xs),I) ) ) ) ).

% transpose_column
tff(fact_7019_drop__rev,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( drop(A,N,rev(A,Xs)) = rev(A,take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N),Xs)) ) ).

% drop_rev
tff(fact_7020_rev__drop,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] : ( rev(A,drop(A,I,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I),rev(A,Xs)) ) ).

% rev_drop
tff(fact_7021_rev__take,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] : ( rev(A,take(A,I,Xs)) = drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),I),rev(A,Xs)) ) ).

% rev_take
tff(fact_7022_take__rev,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( take(A,N,rev(A,Xs)) = rev(A,drop(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N),Xs)) ) ).

% take_rev
tff(fact_7023_rotate__rev,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),rotate(A,N),rev(A,Xs)) = rev(A,aa(list(A),list(A),rotate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),modulo_modulo(nat,N,aa(list(A),nat,size_size(list(A)),Xs)))),Xs)) ) ).

% rotate_rev
tff(fact_7024_sorted__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),transpose(A,Xs)))) ).

% sorted_transpose
tff(fact_7025_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(nat,A,nth(A,rev(A,Xs)),N) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,suc,N))) ) ) ).

% rev_nth
tff(fact_7026_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list(A),Y: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),K),aa(list(A),nat,size_size(list(A)),Xs))
     => ( rev(A,list_update(A,Xs,K,Y)) = list_update(A,rev(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),K)),one_one(nat)),Y) ) ) ).

% rev_update
tff(fact_7027_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
        <=> ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I3)),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I3))),aa(nat,A,nth(A,Xs),I3)) ) ) ) ).

% sorted_rev_iff_nth_Suc
tff(fact_7028_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I: nat,J: nat] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),J)),aa(nat,A,nth(A,Xs),I)) ) ) ) ) ).

% sorted_rev_nth_mono
tff(fact_7029_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
        <=> ! [I3: nat,J3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I3),J3)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J3),aa(list(A),nat,size_size(list(A)),Xs))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,nth(A,Xs),J3)),aa(nat,A,nth(A,Xs),I3)) ) ) ) ) ).

% sorted_rev_iff_nth_mono
tff(fact_7030_transpose__column__length,axiom,
    ! [A: $tType,Xs: list(list(A)),I: nat] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),aa(list(list(A)),nat,size_size(list(list(A))),Xs))
       => ( aa(list(list(A)),nat,size_size(list(list(A))),filter2(list(A),aTP_Lamp_afe(nat,fun(list(A),$o),I),transpose(A,Xs))) = aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),I)) ) ) ) ).

% transpose_column_length
tff(fact_7031_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs))
        = $ite(Xs = nil(list(A)),zero_zero(nat),aa(list(A),nat,size_size(list(A)),aa(nat,list(A),nth(list(A),Xs),zero_zero(nat)))) ) ) ).

% length_transpose_sorted
tff(fact_7032_transpose__max__length,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(nat,nat,foldr(list(A),nat,aTP_Lamp_afg(list(A),fun(nat,nat)),transpose(A,Xs)),zero_zero(nat)) = aa(list(list(A)),nat,size_size(list(list(A))),filter2(list(A),aTP_Lamp_afh(list(A),$o),Xs)) ) ).

% transpose_max_length
tff(fact_7033_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list(A),Xss: list(list(B))] : ( aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),Xs))),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_afi(list(B),fun(nat,nat)),Xss),zero_zero(nat))) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Xs)),aa(nat,nat,foldr(list(B),nat,aTP_Lamp_afj(list(B),fun(nat,nat)),filter2(list(B),aTP_Lamp_afk(list(B),$o),Xss)),zero_zero(nat)))) ) ).

% transpose_aux_max
tff(fact_7034_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups8242544230860333062m_list(A),Xs) = aa(A,A,foldr(A,A,plus_plus(A),Xs),zero_zero(A)) ) ) ).

% sum_list.eq_foldr
tff(fact_7035_horner__sum__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [F3: fun(B,A),A2: A,Xs: list(B)] : ( aa(list(B),A,aa(A,fun(list(B),A),aa(fun(B,A),fun(A,fun(list(B),A)),groups4207007520872428315er_sum(B,A),F3),A2),Xs) = aa(A,A,foldr(B,A,aa(A,fun(B,fun(A,A)),aTP_Lamp_afl(fun(B,A),fun(A,fun(B,fun(A,A))),F3),A2),Xs),zero_zero(A)) ) ) ).

% horner_sum_foldr
tff(fact_7036_length__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),transpose(A,Xs)) = aa(nat,nat,foldr(list(A),nat,aTP_Lamp_afg(list(A),fun(nat,nat)),Xs),zero_zero(nat)) ) ).

% length_transpose
tff(fact_7037_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Y: A] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,Xs))
         => ( aa(A,A,foldr(A,A,ord_max(A),Xs),Y)
            = $ite(Xs = nil(A),Y,aa(A,A,aa(A,fun(A,A),ord_max(A),aa(nat,A,nth(A,Xs),zero_zero(nat))),Y)) ) ) ) ).

% foldr_max_sorted
tff(fact_7038_transpose__transpose,axiom,
    ! [A: $tType,Xs: list(list(A))] :
      ( sorted_wrt(nat,ord_less_eq(nat),rev(nat,map(list(A),nat,size_size(list(A)),Xs)))
     => ( transpose(A,transpose(A,Xs)) = takeWhile(list(A),aTP_Lamp_afh(list(A),$o),Xs) ) ) ).

% transpose_transpose
tff(fact_7039_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),T2: A] :
          ( sorted_wrt(A,ord_less_eq(A),rev(A,map(B,A,F3,Xs)))
         => ( filter2(B,aa(A,fun(B,$o),aTP_Lamp_afm(fun(B,A),fun(A,fun(B,$o)),F3),T2),Xs) = takeWhile(B,aa(A,fun(B,$o),aTP_Lamp_afm(fun(B,A),fun(A,fun(B,$o)),F3),T2),Xs) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
tff(fact_7040_length__takeWhile__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_takeWhile_le
tff(fact_7041_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,$o)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),takeWhile(A,P,Xs)) ) ) ).

% sorted_takeWhile
tff(fact_7042_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: fun(A,$o),Xs: list(A)] :
      ( ! [I2: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),J)
         => aa(A,$o,P,aa(nat,A,nth(A,Xs),I2)) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),aa(list(A),nat,size_size(list(A)),Xs))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),J),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs))) ) ) ).

% length_takeWhile_less_P_nth
tff(fact_7043_length__product__lists,axiom,
    ! [A: $tType,Xss: list(list(A))] : ( aa(list(list(A)),nat,size_size(list(list(A))),product_lists(A,Xss)) = aa(nat,nat,foldr(nat,nat,times_times(nat),map(list(A),nat,size_size(list(A)),Xss)),one_one(nat)) ) ).

% length_product_lists
tff(fact_7044_nths__Cons,axiom,
    ! [A: $tType,Xa: A,L: list(A),A3: set(nat)] :
      ( nths(A,aa(list(A),list(A),cons(A,Xa),L),A3)
      = append(A,$ite(member(nat,zero_zero(nat),A3),aa(list(A),list(A),cons(A,Xa),nil(A)),nil(A)),nths(A,L,collect(nat,aTP_Lamp_afn(set(nat),fun(nat,$o),A3)))) ) ).

% nths_Cons
tff(fact_7045_nths__singleton,axiom,
    ! [A: $tType,Xa: A,A3: set(nat)] :
      ( nths(A,aa(list(A),list(A),cons(A,Xa),nil(A)),A3)
      = $ite(member(nat,zero_zero(nat),A3),aa(list(A),list(A),cons(A,Xa),nil(A)),nil(A)) ) ).

% nths_singleton
tff(fact_7046_sorted__nths,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),I5: set(nat)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),nths(A,Xs,I5)) ) ) ).

% sorted_nths
tff(fact_7047_set__nths__subset,axiom,
    ! [A: $tType,Xs: list(A),I5: set(nat)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),nths(A,Xs,I5))),aa(list(A),set(A),set2(A),Xs)) ).

% set_nths_subset
tff(fact_7048_drop__eq__nths,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( drop(A,N,Xs) = nths(A,Xs,collect(nat,aa(nat,fun(nat,$o),ord_less_eq(nat),N))) ) ).

% drop_eq_nths
tff(fact_7049_nths__drop,axiom,
    ! [A: $tType,N: nat,Xs: list(A),I5: set(nat)] : ( nths(A,drop(A,N,Xs),I5) = nths(A,Xs,aa(set(nat),set(nat),image(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N)),I5)) ) ).

% nths_drop
tff(fact_7050_nths__append,axiom,
    ! [A: $tType,L: list(A),L3: list(A),A3: set(nat)] : ( nths(A,append(A,L,L3),A3) = append(A,nths(A,L,A3),nths(A,L3,collect(nat,aa(set(nat),fun(nat,$o),aTP_Lamp_afo(list(A),fun(set(nat),fun(nat,$o)),L),A3)))) ) ).

% nths_append
tff(fact_7051_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType,F3: fun(A,nat),Xs: list(A)] :
      ( size_list(A,F3,Xs)
      = $ite(Xs = nil(A),zero_zero(nat),aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F3,hd(A,Xs))),size_list(A,F3,tl(A,Xs))))) ) ).

% Nitpick.size_list_simp(1)
tff(fact_7052_finite__sequence__to__countable__set,axiom,
    ! [A: $tType,X6: set(A)] :
      ( countable_countable(A,X6)
     => ~ ! [F7: fun(nat,set(A))] :
            ( ! [I4: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),F7,I4)),X6)
           => ( ! [I4: nat] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),F7,I4)),aa(nat,set(A),F7,aa(nat,nat,suc,I4)))
             => ( ! [I4: nat] : aa(set(A),$o,finite_finite(A),aa(nat,set(A),F7,I4))
               => ( aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),F7),top_top(set(nat)))) != X6 ) ) ) ) ) ).

% finite_sequence_to_countable_set
tff(fact_7053_countable__Diff,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( countable_countable(A,A3)
     => countable_countable(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ).

% countable_Diff
tff(fact_7054_tl__upt,axiom,
    ! [M: nat,N: nat] : ( tl(nat,upt(M,N)) = upt(aa(nat,nat,suc,M),N) ) ).

% tl_upt
tff(fact_7055_countable__Diff__eq,axiom,
    ! [A: $tType,A3: set(A),Xa: A] :
      ( countable_countable(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))
    <=> countable_countable(A,A3) ) ).

% countable_Diff_eq
tff(fact_7056_length__tl,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),tl(A,Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)) ) ).

% length_tl
tff(fact_7057_drop__Suc,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( drop(A,aa(nat,nat,suc,N),Xs) = drop(A,N,tl(A,Xs)) ) ).

% drop_Suc
tff(fact_7058_take__tl,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( take(A,N,tl(A,Xs)) = tl(A,take(A,aa(nat,nat,suc,N),Xs)) ) ).

% take_tl
tff(fact_7059_uncountable__minus__countable,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( ~ countable_countable(A,A3)
     => ( countable_countable(A,B3)
       => ~ countable_countable(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3)) ) ) ).

% uncountable_minus_countable
tff(fact_7060_ccInf__mono,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [B3: set(A),A3: set(A)] :
          ( countable_countable(A,B3)
         => ( countable_countable(A,A3)
           => ( ! [B4: A] :
                  ( member(A,B4,B3)
                 => ? [X3: A] :
                      ( member(A,X3,A3)
                      & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),B4) ) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3)) ) ) ) ) ).

% ccInf_mono
tff(fact_7061_ccInf__lower,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),Xa: A] :
          ( countable_countable(A,A3)
         => ( member(A,Xa,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),Xa) ) ) ) ).

% ccInf_lower
tff(fact_7062_ccInf__lower2,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),U: A,V: A] :
          ( countable_countable(A,A3)
         => ( member(A,U,A3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),V)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),V) ) ) ) ) ).

% ccInf_lower2
tff(fact_7063_le__ccInf__iff,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),B2: A] :
          ( countable_countable(A,A3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),aa(set(A),A,complete_Inf_Inf(A),A3))
          <=> ! [X4: A] :
                ( member(A,X4,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B2),X4) ) ) ) ) ).

% le_ccInf_iff
tff(fact_7064_ccInf__greatest,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),Z: A] :
          ( countable_countable(A,A3)
         => ( ! [X: A] :
                ( member(A,X,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),X) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),aa(set(A),A,complete_Inf_Inf(A),A3)) ) ) ) ).

% ccInf_greatest
tff(fact_7065_infinite__countable__subset_H,axiom,
    ! [A: $tType,X6: set(A)] :
      ( ~ aa(set(A),$o,finite_finite(A),X6)
     => ? [C7: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C7),X6)
          & countable_countable(A,C7)
          & ~ aa(set(A),$o,finite_finite(A),C7) ) ) ).

% infinite_countable_subset'
tff(fact_7066_countable__Collect__finite__subset,axiom,
    ! [A: $tType,T5: set(A)] :
      ( countable_countable(A,T5)
     => countable_countable(set(A),collect(set(A),aTP_Lamp_aed(set(A),fun(set(A),$o),T5))) ) ).

% countable_Collect_finite_subset
tff(fact_7067_countable__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( countable_countable(A,B3)
       => countable_countable(A,A3) ) ) ).

% countable_subset
tff(fact_7068_ccSup__upper2,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),U: A,V: A] :
          ( countable_countable(A,A3)
         => ( member(A,U,A3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),V),U)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),V),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ) ) ).

% ccSup_upper2
tff(fact_7069_ccSup__le__iff,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),B2: A] :
          ( countable_countable(A,A3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),B2)
          <=> ! [X4: A] :
                ( member(A,X4,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),B2) ) ) ) ) ).

% ccSup_le_iff
tff(fact_7070_ccSup__upper,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),Xa: A] :
          ( countable_countable(A,A3)
         => ( member(A,Xa,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ) ).

% ccSup_upper
tff(fact_7071_ccSup__least,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),Z: A] :
          ( countable_countable(A,A3)
         => ( ! [X: A] :
                ( member(A,X,A3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Z) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),Z) ) ) ) ).

% ccSup_least
tff(fact_7072_ccSup__mono,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [B3: set(A),A3: set(A)] :
          ( countable_countable(A,B3)
         => ( countable_countable(A,A3)
           => ( ! [A4: A] :
                  ( member(A,A4,A3)
                 => ? [X3: A] :
                      ( member(A,X3,B3)
                      & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),X3) ) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3)) ) ) ) ) ).

% ccSup_mono
tff(fact_7073_countable__image__eq,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B)] :
      ( countable_countable(A,aa(set(B),set(A),image(B,A,F3),S2))
    <=> ? [T9: set(B)] :
          ( countable_countable(B,T9)
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2)
          & ( aa(set(B),set(A),image(B,A,F3),S2) = aa(set(B),set(A),image(B,A,F3),T9) ) ) ) ).

% countable_image_eq
tff(fact_7074_countable__subset__image,axiom,
    ! [A: $tType,B: $tType,B3: set(A),F3: fun(B,A),A3: set(B)] :
      ( ( countable_countable(A,B3)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F3),A3)) )
    <=> ? [A16: set(B)] :
          ( countable_countable(B,A16)
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A16),A3)
          & ( B3 = aa(set(B),set(A),image(B,A,F3),A16) ) ) ) ).

% countable_subset_image
tff(fact_7075_ex__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B),P: fun(set(A),$o)] :
      ( ? [T9: set(A)] :
          ( countable_countable(A,T9)
          & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F3),S2))
          & aa(set(A),$o,P,T9) )
    <=> ? [T9: set(B)] :
          ( countable_countable(B,T9)
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2)
          & aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),T9)) ) ) ).

% ex_countable_subset_image
tff(fact_7076_all__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B),P: fun(set(A),$o)] :
      ( ! [T9: set(A)] :
          ( ( countable_countable(A,T9)
            & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F3),S2)) )
         => aa(set(A),$o,P,T9) )
    <=> ! [T9: set(B)] :
          ( ( countable_countable(B,T9)
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2) )
         => aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),T9)) ) ) ).

% all_countable_subset_image
tff(fact_7077_sorted__tl,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),tl(A,Xs)) ) ) ).

% sorted_tl
tff(fact_7078_ccSup__subset__mono,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [B3: set(A),A3: set(A)] :
          ( countable_countable(A,B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3)) ) ) ) ).

% ccSup_subset_mono
tff(fact_7079_ccInf__superset__mono,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( countable_countable(A,A3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3)) ) ) ) ).

% ccInf_superset_mono
tff(fact_7080_all__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B),P: fun(set(A),$o)] :
      ( ! [T9: set(A)] :
          ( ( countable_countable(A,T9)
            & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F3),S2)) )
         => aa(set(A),$o,P,T9) )
    <=> ! [T9: set(B)] :
          ( ( countable_countable(B,T9)
            & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2)
            & inj_on(B,A,F3,T9) )
         => aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),T9)) ) ) ).

% all_countable_subset_image_inj
tff(fact_7081_ex__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B),P: fun(set(A),$o)] :
      ( ? [T9: set(A)] :
          ( countable_countable(A,T9)
          & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T9),aa(set(B),set(A),image(B,A,F3),S2))
          & aa(set(A),$o,P,T9) )
    <=> ? [T9: set(B)] :
          ( countable_countable(B,T9)
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2)
          & inj_on(B,A,F3,T9)
          & aa(set(A),$o,P,aa(set(B),set(A),image(B,A,F3),T9)) ) ) ).

% ex_countable_subset_image_inj
tff(fact_7082_countable__image__eq__inj,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),S2: set(B)] :
      ( countable_countable(A,aa(set(B),set(A),image(B,A,F3),S2))
    <=> ? [T9: set(B)] :
          ( countable_countable(B,T9)
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T9),S2)
          & ( aa(set(B),set(A),image(B,A,F3),S2) = aa(set(B),set(A),image(B,A,F3),T9) )
          & inj_on(B,A,F3,T9) ) ) ).

% countable_image_eq_inj
tff(fact_7083_ccSUP__upper2,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),I: A,U: B,F3: fun(A,B)] :
          ( countable_countable(A,A3)
         => ( member(A,I,A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,I))
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ) ).

% ccSUP_upper2
tff(fact_7084_ccSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),F3: fun(A,B),U: B] :
          ( countable_countable(A,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),U)
          <=> ! [X4: A] :
                ( member(A,X4,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),U) ) ) ) ) ).

% ccSUP_le_iff
tff(fact_7085_ccSUP__upper,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),I: A,F3: fun(A,B)] :
          ( countable_countable(A,A3)
         => ( member(A,I,A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I)),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ).

% ccSUP_upper
tff(fact_7086_ccSUP__least,axiom,
    ! [A: $tType,B: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),F3: fun(A,B),U: B] :
          ( countable_countable(A,A3)
         => ( ! [I2: A] :
                ( member(A,I2,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I2)),U) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),U) ) ) ) ).

% ccSUP_least
tff(fact_7087_ccSUP__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( counta3822494911875563373attice(C)
     => ! [A3: set(A),B3: set(B),F3: fun(A,C),G: fun(B,C)] :
          ( countable_countable(A,A3)
         => ( countable_countable(B,B3)
           => ( ! [N2: A] :
                  ( member(A,N2,A3)
                 => ? [X3: B] :
                      ( member(B,X3,B3)
                      & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,N2)),aa(B,C,G,X3)) ) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Sup_Sup(C),aa(set(A),set(C),image(A,C,F3),A3))),aa(set(C),C,complete_Sup_Sup(C),aa(set(B),set(C),image(B,C,G),B3))) ) ) ) ) ).

% ccSUP_mono
tff(fact_7088_ccINF__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( counta3822494911875563373attice(C)
     => ! [A3: set(A),B3: set(B),F3: fun(A,C),G: fun(B,C)] :
          ( countable_countable(A,A3)
         => ( countable_countable(B,B3)
           => ( ! [M2: B] :
                  ( member(B,M2,B3)
                 => ? [X3: A] :
                      ( member(A,X3,A3)
                      & aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(A,C,F3,X3)),aa(B,C,G,M2)) ) )
             => aa(C,$o,aa(C,fun(C,$o),ord_less_eq(C),aa(set(C),C,complete_Inf_Inf(C),aa(set(A),set(C),image(A,C,F3),A3))),aa(set(C),C,complete_Inf_Inf(C),aa(set(B),set(C),image(B,C,G),B3))) ) ) ) ) ).

% ccINF_mono
tff(fact_7089_ccINF__lower,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),I: A,F3: fun(A,B)] :
          ( countable_countable(A,A3)
         => ( member(A,I,A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,I)) ) ) ) ).

% ccINF_lower
tff(fact_7090_ccINF__lower2,axiom,
    ! [A: $tType,B: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),I: A,F3: fun(A,B),U: B] :
          ( countable_countable(A,A3)
         => ( member(A,I,A3)
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,I)),U)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),U) ) ) ) ) ).

% ccINF_lower2
tff(fact_7091_le__ccINF__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),U: B,F3: fun(A,B)] :
          ( countable_countable(A,A3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3)))
          <=> ! [X4: A] :
                ( member(A,X4,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,X4)) ) ) ) ) ).

% le_ccINF_iff
tff(fact_7092_ccINF__greatest,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),U: B,F3: fun(A,B)] :
          ( countable_countable(A,A3)
         => ( ! [I2: A] :
                ( member(A,I2,A3)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,I2)) )
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ).

% ccINF_greatest
tff(fact_7093_tl__take,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( tl(A,take(A,N,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),tl(A,Xs)) ) ).

% tl_take
tff(fact_7094_ccSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( countable_countable(A,A3)
         => ( countable_countable(A,B3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3))) ) ) ) ).

% ccSup_inter_less_eq
tff(fact_7095_less__eq__ccInf__inter,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( countable_countable(A,A3)
         => ( countable_countable(A,B3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ).

% less_eq_ccInf_inter
tff(fact_7096_ccSUP__subset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [B3: set(A),A3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( countable_countable(A,B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => ( ! [X: A] :
                  ( member(A,X,A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,G),B3))) ) ) ) ) ).

% ccSUP_subset_mono
tff(fact_7097_ccINF__superset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( counta3822494911875563373attice(B)
     => ! [A3: set(A),B3: set(A),F3: fun(A,B),G: fun(A,B)] :
          ( countable_countable(A,A3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
           => ( ! [X: A] :
                  ( member(A,X,B3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),B3))) ) ) ) ) ).

% ccINF_superset_mono
tff(fact_7098_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( aa(list(A),nat,size_size(list(A)),Xs)
      = $ite(Xs = nil(A),zero_zero(nat),aa(nat,nat,suc,aa(list(A),nat,size_size(list(A)),tl(A,Xs)))) ) ).

% Nitpick.size_list_simp(2)
tff(fact_7099_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(list(A),nat,size_size(list(A)),tl(A,Xs)))
     => ( aa(nat,A,nth(A,tl(A,Xs)),N) = aa(nat,A,nth(A,Xs),aa(nat,nat,suc,N)) ) ) ).

% nth_tl
tff(fact_7100_take__Suc,axiom,
    ! [A: $tType,Xs: list(A),N: nat] :
      ( ( Xs != nil(A) )
     => ( take(A,aa(nat,nat,suc,N),Xs) = aa(list(A),list(A),cons(A,hd(A,Xs)),take(A,N,tl(A,Xs))) ) ) ).

% take_Suc
tff(fact_7101_vanishes__mult__bounded,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( ? [A15: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),A15)
          & ! [N2: nat] : aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X6,N2))),A15) )
     => ( vanishes(Y6)
       => vanishes(aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X6),Y6)) ) ) ).

% vanishes_mult_bounded
tff(fact_7102_cauchy__def,axiom,
    ! [X6: fun(nat,rat)] :
      ( cauchy(X6)
    <=> ! [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
         => ? [K2: nat] :
            ! [M6: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),M6)
             => ! [N5: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
                 => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,X6,M6)),aa(nat,rat,X6,N5)))),R5) ) ) ) ) ).

% cauchy_def
tff(fact_7103_vanishes__const,axiom,
    ! [C2: rat] :
      ( vanishes(aTP_Lamp_afq(rat,fun(nat,rat),C2))
    <=> ( C2 = zero_zero(rat) ) ) ).

% vanishes_const
tff(fact_7104_cauchy__not__vanishes,axiom,
    ! [X6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( ~ vanishes(X6)
       => ? [B4: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),B4)
            & ? [K3: nat] :
              ! [N3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N3)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),B4),aa(rat,rat,abs_abs(rat),aa(nat,rat,X6,N3))) ) ) ) ) ).

% cauchy_not_vanishes
tff(fact_7105_cauchy__not__vanishes__cases,axiom,
    ! [X6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( ~ vanishes(X6)
       => ? [B4: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),B4)
            & ? [K3: nat] :
                ( ! [N3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N3)
                   => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),B4),aa(rat,rat,uminus_uminus(rat),aa(nat,rat,X6,N3))) )
                | ! [N3: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N3)
                   => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),B4),aa(nat,rat,X6,N3)) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
tff(fact_7106_vanishes__diff,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( vanishes(X6)
     => ( vanishes(Y6)
       => vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X6),Y6)) ) ) ).

% vanishes_diff
tff(fact_7107_cauchy__diff,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( cauchy(Y6)
       => cauchy(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X6),Y6)) ) ) ).

% cauchy_diff
tff(fact_7108_cauchy__mult,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( cauchy(Y6)
       => cauchy(aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X6),Y6)) ) ) ).

% cauchy_mult
tff(fact_7109_vanishes__diff__inverse,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( ~ vanishes(X6)
       => ( cauchy(Y6)
         => ( ~ vanishes(Y6)
           => ( vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X6),Y6))
             => vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afs(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X6),Y6)) ) ) ) ) ) ).

% vanishes_diff_inverse
tff(fact_7110_cauchy__imp__bounded,axiom,
    ! [X6: fun(nat,rat)] :
      ( cauchy(X6)
     => ? [B4: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),B4)
          & ! [N3: nat] : aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X6,N3))),B4) ) ) ).

% cauchy_imp_bounded
tff(fact_7111_vanishes__def,axiom,
    ! [X6: fun(nat,rat)] :
      ( vanishes(X6)
    <=> ! [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
         => ? [K2: nat] :
            ! [N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X6,N5))),R5) ) ) ) ).

% vanishes_def
tff(fact_7112_vanishesI,axiom,
    ! [X6: fun(nat,rat)] :
      ( ! [R4: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R4)
         => ? [K4: nat] :
            ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K4),N2)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X6,N2))),R4) ) )
     => vanishes(X6) ) ).

% vanishesI
tff(fact_7113_vanishesD,axiom,
    ! [X6: fun(nat,rat),R: rat] :
      ( vanishes(X6)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R)
       => ? [K3: nat] :
          ! [N3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N3)
           => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(nat,rat,X6,N3))),R) ) ) ) ).

% vanishesD
tff(fact_7114_cauchyD,axiom,
    ! [X6: fun(nat,rat),R: rat] :
      ( cauchy(X6)
     => ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R)
       => ? [K3: nat] :
          ! [M3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),M3)
           => ! [N3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K3),N3)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,X6,M3)),aa(nat,rat,X6,N3)))),R) ) ) ) ) ).

% cauchyD
tff(fact_7115_cauchyI,axiom,
    ! [X6: fun(nat,rat)] :
      ( ! [R4: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R4)
         => ? [K4: nat] :
            ! [M2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K4),M2)
             => ! [N2: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K4),N2)
                 => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),aa(rat,rat,abs_abs(rat),aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,X6,M2)),aa(nat,rat,X6,N2)))),R4) ) ) )
     => cauchy(X6) ) ).

% cauchyI
tff(fact_7116_le__Real,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( cauchy(Y6)
       => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(fun(nat,rat),real,real2,X6)),aa(fun(nat,rat),real,real2,Y6))
        <=> ! [R5: rat] :
              ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
             => ? [K2: nat] :
                ! [N5: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
                 => aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(nat,rat,X6,N5)),aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(nat,rat,Y6,N5)),R5)) ) ) ) ) ) ).

% le_Real
tff(fact_7117_inverse__Real,axiom,
    ! [X6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( aa(real,real,inverse_inverse(real),aa(fun(nat,rat),real,real2,X6))
        = $ite(vanishes(X6),zero_zero(real),aa(fun(nat,rat),real,real2,aTP_Lamp_aft(fun(nat,rat),fun(nat,rat),X6))) ) ) ).

% inverse_Real
tff(fact_7118_one__real__def,axiom,
    one_one(real) = aa(fun(nat,rat),real,real2,aTP_Lamp_afu(nat,rat)) ).

% one_real_def
tff(fact_7119_zero__real__def,axiom,
    zero_zero(real) = aa(fun(nat,rat),real,real2,aTP_Lamp_afv(nat,rat)) ).

% zero_real_def
tff(fact_7120_mult__Real,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( cauchy(Y6)
       => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(fun(nat,rat),real,real2,X6)),aa(fun(nat,rat),real,real2,Y6)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),X6),Y6)) ) ) ) ).

% mult_Real
tff(fact_7121_diff__Real,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( cauchy(Y6)
       => ( aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(fun(nat,rat),real,real2,X6)),aa(fun(nat,rat),real,real2,Y6)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X6),Y6)) ) ) ) ).

% diff_Real
tff(fact_7122_eq__Real,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( cauchy(Y6)
       => ( ( aa(fun(nat,rat),real,real2,X6) = aa(fun(nat,rat),real,real2,Y6) )
        <=> vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X6),Y6)) ) ) ) ).

% eq_Real
tff(fact_7123_not__positive__Real,axiom,
    ! [X6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( ~ aa(real,$o,positive2,aa(fun(nat,rat),real,real2,X6))
      <=> ! [R5: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
           => ? [K2: nat] :
              ! [N5: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(nat,rat,X6,N5)),R5) ) ) ) ) ).

% not_positive_Real
tff(fact_7124_positive__Real,axiom,
    ! [X6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( aa(real,$o,positive2,aa(fun(nat,rat),real,real2,X6))
      <=> ? [R5: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
            & ? [K2: nat] :
              ! [N5: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,X6,N5)) ) ) ) ) ).

% positive_Real
tff(fact_7125_Real_Opositive__zero,axiom,
    ~ aa(real,$o,positive2,zero_zero(real)) ).

% Real.positive_zero
tff(fact_7126_Real_Opositive__mult,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,positive2,Xa)
     => ( aa(real,$o,positive2,Y)
       => aa(real,$o,positive2,aa(real,real,aa(real,fun(real,real),times_times(real),Xa),Y)) ) ) ).

% Real.positive_mult
tff(fact_7127_Real_Opositive__minus,axiom,
    ! [Xa: real] :
      ( ~ aa(real,$o,positive2,Xa)
     => ( ( Xa != zero_zero(real) )
       => aa(real,$o,positive2,aa(real,real,uminus_uminus(real),Xa)) ) ) ).

% Real.positive_minus
tff(fact_7128_less__real__def,axiom,
    ! [Xa: real,Y: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),Xa),Y)
    <=> aa(real,$o,positive2,aa(real,real,aa(real,fun(real,real),minus_minus(real),Y),Xa)) ) ).

% less_real_def
tff(fact_7129_Real_Opositive_Orep__eq,axiom,
    ! [Xa: real] :
      ( aa(real,$o,positive2,Xa)
    <=> ? [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
          & ? [K2: nat] :
            ! [N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,aa(real,fun(nat,rat),rep_real,Xa),N5)) ) ) ) ).

% Real.positive.rep_eq
tff(fact_7130_inverse__real_Oabs__eq,axiom,
    ! [Xa: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,Xa),Xa)
     => ( aa(real,real,inverse_inverse(real),aa(fun(nat,rat),real,real2,Xa))
        = aa(fun(nat,rat),real,real2,$ite(vanishes(Xa),aTP_Lamp_afv(nat,rat),aTP_Lamp_aft(fun(nat,rat),fun(nat,rat),Xa))) ) ) ).

% inverse_real.abs_eq
tff(fact_7131_one__real_Orsp,axiom,
    aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,aTP_Lamp_afu(nat,rat)),aTP_Lamp_afu(nat,rat)) ).

% one_real.rsp
tff(fact_7132_zero__real_Orsp,axiom,
    aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,aTP_Lamp_afv(nat,rat)),aTP_Lamp_afv(nat,rat)) ).

% zero_real.rsp
tff(fact_7133_times__real_Oabs__eq,axiom,
    ! [Xa: fun(nat,rat),Xb: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,Xa),Xa)
     => ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,Xb),Xb)
       => ( aa(real,real,aa(real,fun(real,real),times_times(real),aa(fun(nat,rat),real,real2,Xa)),aa(fun(nat,rat),real,real2,Xb)) = aa(fun(nat,rat),real,real2,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),Xa),Xb)) ) ) ) ).

% times_real.abs_eq
tff(fact_7134_realrelI,axiom,
    ! [X6: fun(nat,rat),Y6: fun(nat,rat)] :
      ( cauchy(X6)
     => ( cauchy(Y6)
       => ( vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X6),Y6))
         => aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X6),Y6) ) ) ) ).

% realrelI
tff(fact_7135_realrel__def,axiom,
    ! [X3: fun(nat,rat),Xa2: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,X3),Xa2)
    <=> ( cauchy(X3)
        & cauchy(Xa2)
        & vanishes(aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),X3),Xa2)) ) ) ).

% realrel_def
tff(fact_7136_Real_Opositive_Oabs__eq,axiom,
    ! [Xa: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aa(fun(nat,rat),fun(fun(nat,rat),$o),realrel,Xa),Xa)
     => ( aa(real,$o,positive2,aa(fun(nat,rat),real,real2,Xa))
      <=> ? [R5: rat] :
            ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
            & ? [K2: nat] :
              ! [N5: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
               => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,Xa,N5)) ) ) ) ) ).

% Real.positive.abs_eq
tff(fact_7137_inverse__real__def,axiom,
    inverse_inverse(real) = aa(fun(fun(nat,rat),fun(nat,rat)),fun(real,real),map_fun(real,fun(nat,rat),fun(nat,rat),real,rep_real,real2),aTP_Lamp_afw(fun(nat,rat),fun(nat,rat))) ).

% inverse_real_def
tff(fact_7138_funpow__inj__finite,axiom,
    ! [A: $tType,P2: fun(A,A),Xa: A] :
      ( inj_on(A,A,P2,top_top(set(A)))
     => ( aa(set(A),$o,finite_finite(A),collect(A,aa(A,fun(A,$o),aTP_Lamp_afx(fun(A,A),fun(A,fun(A,$o)),P2),Xa)))
       => ~ ! [N2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N2)
             => ( aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N2),P2),Xa) != Xa ) ) ) ) ).

% funpow_inj_finite
tff(fact_7139_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo7761053866217962861closed(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_afy(product_prod(A,A),$o))) ) ).

% closed_subdiagonal
tff(fact_7140_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => topolo7761053866217962861closed(product_prod(A,A),collect(product_prod(A,A),aTP_Lamp_afz(product_prod(A,A),$o))) ) ).

% closed_superdiagonal
tff(fact_7141_exE__some,axiom,
    ! [A: $tType,P: fun(A,$o),C2: A] :
      ( ? [X_1: A] : aa(A,$o,P,X_1)
     => ( ( C2 = fChoice(A,P) )
       => aa(A,$o,P,C2) ) ) ).

% exE_some
tff(fact_7142_times__real__def,axiom,
    times_times(real) = aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(real,fun(real,real)),map_fun(real,fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),fun(real,real),rep_real,map_fun(real,fun(nat,rat),fun(nat,rat),real,rep_real,real2)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))) ).

% times_real_def
tff(fact_7143_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_0(C)
     => ! [F3: fun(A,C),G: fun(B,C),A3: set(A),B3: set(B)] :
          ( inj_on(product_prod(A,B),C,product_case_prod(A,B,C,aa(fun(B,C),fun(A,fun(B,C)),aTP_Lamp_aga(fun(A,C),fun(fun(B,C),fun(A,fun(B,C))),F3),G)),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),B3)))
         => ( aa(C,C,aa(C,fun(C,C),times_times(C),aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),F3),A3)),aa(set(B),C,aa(fun(B,C),fun(set(B),C),groups7311177749621191930dd_sum(B,C),G),B3)) = aa(set(C),C,aa(fun(C,C),fun(set(C),C),groups7311177749621191930dd_sum(C,C),id(C)),collect(C,aa(set(B),fun(C,$o),aa(set(A),fun(set(B),fun(C,$o)),aa(fun(B,C),fun(set(A),fun(set(B),fun(C,$o))),aTP_Lamp_agc(fun(A,C),fun(fun(B,C),fun(set(A),fun(set(B),fun(C,$o)))),F3),G),A3),B3))) ) ) ) ).

% sum_mult_sum_if_inj
tff(fact_7144_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set(A),N: nat] : ( collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_agd(set(A),fun(nat,fun(list(A),$o)),A3),N)) = aa(set(product_prod(list(A),A)),set(list(A)),image(product_prod(list(A),A),list(A),product_case_prod(list(A),A,list(A),aTP_Lamp_aet(list(A),fun(A,list(A))))),product_Sigma(list(A),A,collect(list(A),aa(nat,fun(list(A),$o),aTP_Lamp_mc(set(A),fun(nat,fun(list(A),$o)),A3),N)),aTP_Lamp_age(set(A),fun(list(A),set(A)),A3))) ) ).

% lists_length_Suc_eq
tff(fact_7145_Sigma__Diff__distrib2,axiom,
    ! [B: $tType,A: $tType,I5: set(A),A3: fun(A,set(B)),B3: fun(A,set(B))] : ( product_Sigma(A,B,I5,aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_agf(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),A3),B3)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,I5,A3)),product_Sigma(A,B,I5,B3)) ) ).

% Sigma_Diff_distrib2
tff(fact_7146_Times__Diff__distrib1,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: set(A),C5: set(B)] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),B3),aTP_Lamp_agb(set(B),fun(A,set(B)),C5)) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),C5))),product_Sigma(A,B,B3,aTP_Lamp_agb(set(B),fun(A,set(B)),C5))) ) ).

% Times_Diff_distrib1
tff(fact_7147_Sigma__Diff__distrib1,axiom,
    ! [B: $tType,A: $tType,I5: set(A),J4: set(A),C5: fun(A,set(B))] : ( product_Sigma(A,B,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),I5),J4),C5) = aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),minus_minus(set(product_prod(A,B))),product_Sigma(A,B,I5,C5)),product_Sigma(A,B,J4,C5)) ) ).

% Sigma_Diff_distrib1
tff(fact_7148_Restr__subset,axiom,
    ! [A: $tType,A3: set(A),B3: set(A),R: set(product_prod(A,A))] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => ( aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,B3,aTP_Lamp_agg(set(A),fun(A,set(A)),B3)))),product_Sigma(A,A,A3,aTP_Lamp_agg(set(A),fun(A,set(A)),A3))) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),set(product_prod(A,A))),inf_inf(set(product_prod(A,A))),R),product_Sigma(A,A,A3,aTP_Lamp_agg(set(A),fun(A,set(A)),A3))) ) ) ).

% Restr_subset
tff(fact_7149_open__prod__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S2: set(product_prod(A,B))] :
          ( ! [X: product_prod(A,B)] :
              ( member(product_prod(A,B),X,S2)
             => ? [A17: set(A),B14: set(B)] :
                  ( topolo1002775350975398744n_open(A,A17)
                  & topolo1002775350975398744n_open(B,B14)
                  & member(product_prod(A,B),X,product_Sigma(A,B,A17,aTP_Lamp_agh(set(B),fun(A,set(B)),B14)))
                  & aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A17,aTP_Lamp_agh(set(B),fun(A,set(B)),B14))),S2) ) )
         => topolo1002775350975398744n_open(product_prod(A,B),S2) ) ) ).

% open_prod_intro
tff(fact_7150_open__prod__elim,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S2: set(product_prod(A,B)),Xa: product_prod(A,B)] :
          ( topolo1002775350975398744n_open(product_prod(A,B),S2)
         => ( member(product_prod(A,B),Xa,S2)
           => ~ ! [A6: set(A)] :
                  ( topolo1002775350975398744n_open(A,A6)
                 => ! [B9: set(B)] :
                      ( topolo1002775350975398744n_open(B,B9)
                     => ( member(product_prod(A,B),Xa,product_Sigma(A,B,A6,aTP_Lamp_agh(set(B),fun(A,set(B)),B9)))
                       => ~ aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A6,aTP_Lamp_agh(set(B),fun(A,set(B)),B9))),S2) ) ) ) ) ) ) ).

% open_prod_elim
tff(fact_7151_open__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [S2: set(product_prod(A,B))] :
          ( topolo1002775350975398744n_open(product_prod(A,B),S2)
        <=> ! [X4: product_prod(A,B)] :
              ( member(product_prod(A,B),X4,S2)
             => ? [A11: set(A)] :
                  ( topolo1002775350975398744n_open(A,A11)
                  & ? [B8: set(B)] :
                      ( topolo1002775350975398744n_open(B,B8)
                      & member(product_prod(A,B),X4,product_Sigma(A,B,A11,aTP_Lamp_agh(set(B),fun(A,set(B)),B8)))
                      & aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A11,aTP_Lamp_agh(set(B),fun(A,set(B)),B8))),S2) ) ) ) ) ) ).

% open_prod_def
tff(fact_7152_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,Xa: A,C5: set(A),A3: set(B),B3: set(B)] :
      ( member(A,Xa,C5)
     => ( aa(set(product_prod(B,A)),$o,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),$o),ord_less_eq(set(product_prod(B,A))),product_Sigma(B,A,A3,aTP_Lamp_agi(set(A),fun(B,set(A)),C5))),product_Sigma(B,A,B3,aTP_Lamp_agi(set(A),fun(B,set(A)),C5)))
      <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),B3) ) ) ).

% Times_subset_cancel2
tff(fact_7153_Sigma__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),C5: set(A),B3: fun(A,set(B)),D3: fun(A,set(B))] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),C5)
     => ( ! [X: A] :
            ( member(A,X,A3)
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),B3,X)),aa(A,set(B),D3,X)) )
       => aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A3,B3)),product_Sigma(A,B,C5,D3)) ) ) ).

% Sigma_mono
tff(fact_7154_trancl__subset__Sigma,axiom,
    ! [A: $tType,R: set(product_prod(A,A)),A3: set(A)] :
      ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R),product_Sigma(A,A,A3,aTP_Lamp_agg(set(A),fun(A,set(A)),A3)))
     => aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),transitive_trancl(A,R)),product_Sigma(A,A,A3,aTP_Lamp_agg(set(A),fun(A,set(A)),A3))) ) ).

% trancl_subset_Sigma
tff(fact_7155_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: set(A),C5: set(B),B3: set(A),D3: set(B)] :
      ( aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),C5))),product_Sigma(A,B,B3,aTP_Lamp_agb(set(B),fun(A,set(B)),D3)))
    <=> ( ( A3 = bot_bot(set(A)) )
        | ( C5 = bot_bot(set(B)) )
        | ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
          & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C5),D3) ) ) ) ).

% times_subset_iff
tff(fact_7156_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A2: A,B2: A,R: set(product_prod(A,A)),A3: set(A)] :
      ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A2),B2),transitive_rtrancl(A,R))
     => ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R),product_Sigma(A,A,A3,aTP_Lamp_agg(set(A),fun(A,set(A)),A3)))
       => ( ( A2 = B2 )
          | member(A,A2,A3) ) ) ) ).

% trancl_subset_Sigma_aux
tff(fact_7157_Ex__inj__on__UNION__Sigma,axiom,
    ! [A: $tType,B: $tType,A3: fun(B,set(A)),I5: set(B)] :
    ? [F4: fun(A,product_prod(B,A))] :
      ( inj_on(A,product_prod(B,A),F4,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5)))
      & aa(set(product_prod(B,A)),$o,aa(set(product_prod(B,A)),fun(set(product_prod(B,A)),$o),ord_less_eq(set(product_prod(B,A))),aa(set(A),set(product_prod(B,A)),image(A,product_prod(B,A),F4),aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(B),set(set(A)),image(B,set(A),A3),I5)))),product_Sigma(B,A,I5,A3)) ) ).

% Ex_inj_on_UNION_Sigma
tff(fact_7158_Sigma__interval__disjoint,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [A3: set(A),V: fun(A,B),W: B] : ( aa(set(product_prod(A,B)),set(product_prod(A,B)),aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),set(product_prod(A,B))),inf_inf(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_agj(fun(A,B),fun(A,set(B)),V))),product_Sigma(A,B,A3,aa(B,fun(A,set(B)),aTP_Lamp_agk(fun(A,B),fun(B,fun(A,set(B))),V),W))) = bot_bot(set(product_prod(A,B))) ) ) ).

% Sigma_interval_disjoint
tff(fact_7159_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A3: set(A),B3: set(B)] : ( aa(set(product_prod(A,B)),nat,finite_card(product_prod(A,B)),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),B3))) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(A),nat,finite_card(A),A3)),aa(set(B),nat,finite_card(B),B3)) ) ).

% card_cartesian_product
tff(fact_7160_product__atMost__eq__Un,axiom,
    ! [A3: set(nat),M: nat] : ( product_Sigma(nat,nat,A3,aTP_Lamp_agl(nat,fun(nat,set(nat)),M)) = aa(set(product_prod(nat,nat)),set(product_prod(nat,nat)),aa(set(product_prod(nat,nat)),fun(set(product_prod(nat,nat)),set(product_prod(nat,nat))),sup_sup(set(product_prod(nat,nat))),product_Sigma(nat,nat,A3,aTP_Lamp_agm(nat,fun(nat,set(nat)),M))),product_Sigma(nat,nat,A3,aTP_Lamp_agn(nat,fun(nat,set(nat)),M))) ) ).

% product_atMost_eq_Un
tff(fact_7161_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ( semiring_1_Nats(A) = collect(A,aTP_Lamp_ago(A,$o)) ) ) ).

% Nats_altdef1
tff(fact_7162_pairs__le__eq__Sigma,axiom,
    ! [M: nat] : ( collect(product_prod(nat,nat),product_case_prod(nat,nat,$o,aTP_Lamp_jb(nat,fun(nat,fun(nat,$o)),M))) = product_Sigma(nat,nat,set_ord_atMost(nat,M),aTP_Lamp_agm(nat,fun(nat,set(nat)),M)) ) ).

% pairs_le_eq_Sigma
tff(fact_7163_Divides_Oadjust__div__def,axiom,
    ! [Qr: product_prod(int,int)] : ( adjust_div(Qr) = aa(product_prod(int,int),int,product_case_prod(int,int,int,aTP_Lamp_agp(int,fun(int,int))),Qr) ) ).

% Divides.adjust_div_def
tff(fact_7164_Real_Opositive__def,axiom,
    positive2 = aa(fun(fun(nat,rat),$o),fun(real,$o),map_fun(real,fun(nat,rat),$o,$o,rep_real,id($o)),aTP_Lamp_agq(fun(nat,rat),$o)) ).

% Real.positive_def
tff(fact_7165_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F3: fun(A,B),B3: set(B)] :
      ( aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),bNF_Gr(A,B,A3,F3)),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),B3)))
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),A3)),B3) ) ).

% Gr_incl
tff(fact_7166_Rats__eq__int__div__nat,axiom,
    field_char_0_Rats(real) = collect(real,aTP_Lamp_agr(real,$o)) ).

% Rats_eq_int_div_nat
tff(fact_7167_Real_Opositive_Orsp,axiom,
    aa(fun(fun(nat,rat),$o),$o,aa(fun(fun(nat,rat),$o),fun(fun(fun(nat,rat),$o),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),$o,$o,realrel,fequal($o)),aTP_Lamp_agq(fun(nat,rat),$o)),aTP_Lamp_agq(fun(nat,rat),$o)) ).

% Real.positive.rsp
tff(fact_7168_Rats__diff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,field_char_0_Rats(A))
         => ( member(A,B2,field_char_0_Rats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),B2),field_char_0_Rats(A)) ) ) ) ).

% Rats_diff
tff(fact_7169_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),ring_1_Ints(A)),field_char_0_Rats(A)) ) ).

% Ints_subset_Rats
tff(fact_7170_Rats__of__nat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat] : member(A,aa(nat,A,semiring_1_of_nat(A),N),field_char_0_Rats(A)) ) ).

% Rats_of_nat
tff(fact_7171_Rats__add,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,field_char_0_Rats(A))
         => ( member(A,B2,field_char_0_Rats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2),field_char_0_Rats(A)) ) ) ) ).

% Rats_add
tff(fact_7172_Rats__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => member(A,one_one(A),field_char_0_Rats(A)) ) ).

% Rats_1
tff(fact_7173_Rats__mult,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: A,B2: A] :
          ( member(A,A2,field_char_0_Rats(A))
         => ( member(A,B2,field_char_0_Rats(A))
           => member(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),field_char_0_Rats(A)) ) ) ) ).

% Rats_mult
tff(fact_7174_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( power(B)
        & power(A) )
     => ! [R2: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R2,one_one(A)),one_one(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R2,bNF_rel_fun(A,B,A,B,R2,R2)),times_times(A)),times_times(B))
           => aa(fun(B,fun(nat,B)),$o,aa(fun(A,fun(nat,A)),fun(fun(B,fun(nat,B)),$o),bNF_rel_fun(A,B,fun(nat,A),fun(nat,B),R2,bNF_rel_fun(nat,nat,A,B,fequal(nat),R2)),power_power(A)),power_power(B)) ) ) ) ).

% power_transfer
tff(fact_7175_Rats__0,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => member(A,zero_zero(A),field_char_0_Rats(A)) ) ).

% Rats_0
tff(fact_7176_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add(B)
        & semiring_numeral(B)
        & monoid_add(A)
        & semiring_numeral(A) )
     => ! [R2: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R2,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R2,one_one(A)),one_one(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R2,bNF_rel_fun(A,B,A,B,R2,R2)),plus_plus(A)),plus_plus(B))
             => aa(fun(num,B),$o,aa(fun(num,A),fun(fun(num,B),$o),bNF_rel_fun(num,num,A,B,fequal(num),R2),numeral_numeral(A)),numeral_numeral(B)) ) ) ) ) ).

% transfer_rule_numeral
tff(fact_7177_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1(B)
        & ring_1(A) )
     => ! [R2: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R2,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R2,one_one(A)),one_one(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R2,bNF_rel_fun(A,B,A,B,R2,R2)),plus_plus(A)),plus_plus(B))
             => ( aa(fun(B,B),$o,aa(fun(A,A),fun(fun(B,B),$o),bNF_rel_fun(A,B,A,B,R2,R2),uminus_uminus(A)),uminus_uminus(B))
               => aa(fun(int,B),$o,aa(fun(int,A),fun(fun(int,B),$o),bNF_rel_fun(int,int,A,B,fequal(int),R2),ring_1_of_int(A)),ring_1_of_int(B)) ) ) ) ) ) ).

% transfer_rule_of_int
tff(fact_7178_Rats__no__top__le,axiom,
    ! [Xa: real] :
    ? [X: real] :
      ( member(real,X,field_char_0_Rats(real))
      & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),X) ) ).

% Rats_no_top_le
tff(fact_7179_Nats__subset__Rats,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),semiring_1_Nats(A)),field_char_0_Rats(A)) ) ).

% Nats_subset_Rats
tff(fact_7180_Rats__eq__int__div__int,axiom,
    field_char_0_Rats(real) = collect(real,aTP_Lamp_ags(real,$o)) ).

% Rats_eq_int_div_int
tff(fact_7181_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1(B)
        & semiring_1(A) )
     => ! [R2: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R2,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R2,one_one(A)),one_one(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),R2,bNF_rel_fun(A,B,A,B,R2,R2)),plus_plus(A)),plus_plus(B))
             => aa(fun(nat,B),$o,aa(fun(nat,A),fun(fun(nat,B),$o),bNF_rel_fun(nat,nat,A,B,fequal(nat),R2),semiring_1_of_nat(A)),semiring_1_of_nat(B)) ) ) ) ) ).

% transfer_rule_of_nat
tff(fact_7182_rec__nat__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,$o))] : aa(fun(B,fun(fun(nat,fun(B,B)),fun(nat,B))),$o,aa(fun(A,fun(fun(nat,fun(A,A)),fun(nat,A))),fun(fun(B,fun(fun(nat,fun(B,B)),fun(nat,B))),$o),bNF_rel_fun(A,B,fun(fun(nat,fun(A,A)),fun(nat,A)),fun(fun(nat,fun(B,B)),fun(nat,B)),A3,bNF_rel_fun(fun(nat,fun(A,A)),fun(nat,fun(B,B)),fun(nat,A),fun(nat,B),bNF_rel_fun(nat,nat,fun(A,A),fun(B,B),fequal(nat),bNF_rel_fun(A,B,A,B,A3,A3)),bNF_rel_fun(nat,nat,A,B,fequal(nat),A3))),rec_nat(A)),rec_nat(B)) ).

% rec_nat_transfer
tff(fact_7183_sub_Orsp,axiom,
    aa(fun(num,fun(num,int)),$o,aa(fun(num,fun(num,int)),fun(fun(num,fun(num,int)),$o),bNF_rel_fun(num,num,fun(num,int),fun(num,int),fequal(num),bNF_rel_fun(num,num,int,int,fequal(num),fequal(int))),aTP_Lamp_agt(num,fun(num,int))),aTP_Lamp_agt(num,fun(num,int))) ).

% sub.rsp
tff(fact_7184_minus__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),minus_minus(int)),minus_minus(int)) ).

% minus_integer.rsp
tff(fact_7185_minus__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),minus_minus(nat)),minus_minus(nat)) ).

% minus_natural.rsp
tff(fact_7186_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( zero_neq_one(B)
        & zero_neq_one(A) )
     => ! [R2: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),R2,zero_zero(A)),zero_zero(B))
         => ( aa(B,$o,aa(A,fun(B,$o),R2,one_one(A)),one_one(B))
           => aa(fun($o,B),$o,aa(fun($o,A),fun(fun($o,B),$o),bNF_rel_fun($o,$o,A,B,fequal($o),R2),zero_neq_one_of_bool(A)),zero_neq_one_of_bool(B)) ) ) ) ).

% transfer_rule_of_bool
tff(fact_7187_integer__of__natural_Orsp,axiom,
    aa(fun(nat,int),$o,aa(fun(nat,int),fun(fun(nat,int),$o),bNF_rel_fun(nat,nat,int,int,fequal(nat),fequal(int)),semiring_1_of_nat(int)),semiring_1_of_nat(int)) ).

% integer_of_natural.rsp
tff(fact_7188_plus__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),plus_plus(int)),plus_plus(int)) ).

% plus_integer.rsp
tff(fact_7189_plus__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),plus_plus(nat)),plus_plus(nat)) ).

% plus_natural.rsp
tff(fact_7190_Suc_Orsp,axiom,
    aa(fun(nat,nat),$o,aa(fun(nat,nat),fun(fun(nat,nat),$o),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat)),suc),suc) ).

% Suc.rsp
tff(fact_7191_times__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),times_times(int)),times_times(int)) ).

% times_integer.rsp
tff(fact_7192_times__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,nat)),$o,aa(fun(nat,fun(nat,nat)),fun(fun(nat,fun(nat,nat)),$o),bNF_rel_fun(nat,nat,fun(nat,nat),fun(nat,nat),fequal(nat),bNF_rel_fun(nat,nat,nat,nat,fequal(nat),fequal(nat))),times_times(nat)),times_times(nat)) ).

% times_natural.rsp
tff(fact_7193_dup_Orsp,axiom,
    aa(fun(int,int),$o,aa(fun(int,int),fun(fun(int,int),$o),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int)),aTP_Lamp_agu(int,int)),aTP_Lamp_agu(int,int)) ).

% dup.rsp
tff(fact_7194_less__eq__natural_Orsp,axiom,
    aa(fun(nat,fun(nat,$o)),$o,aa(fun(nat,fun(nat,$o)),fun(fun(nat,fun(nat,$o)),$o),bNF_rel_fun(nat,nat,fun(nat,$o),fun(nat,$o),fequal(nat),bNF_rel_fun(nat,nat,$o,$o,fequal(nat),fequal($o))),ord_less_eq(nat)),ord_less_eq(nat)) ).

% less_eq_natural.rsp
tff(fact_7195_less__eq__integer_Orsp,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(int,fun(int,$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(int,int,fun(int,$o),fun(int,$o),fequal(int),bNF_rel_fun(int,int,$o,$o,fequal(int),fequal($o))),ord_less_eq(int)),ord_less_eq(int)) ).

% less_eq_integer.rsp
tff(fact_7196_times__real_Orsp,axiom,
    aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),$o,aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),fun(fun(nat,rat),fun(nat,rat)),realrel,bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(nat,rat),fun(nat,rat),realrel,realrel)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))) ).

% times_real.rsp
tff(fact_7197_inverse__real_Orsp,axiom,
    aa(fun(fun(nat,rat),fun(nat,rat)),$o,aa(fun(fun(nat,rat),fun(nat,rat)),fun(fun(fun(nat,rat),fun(nat,rat)),$o),bNF_rel_fun(fun(nat,rat),fun(nat,rat),fun(nat,rat),fun(nat,rat),realrel,realrel),aTP_Lamp_afw(fun(nat,rat),fun(nat,rat))),aTP_Lamp_afw(fun(nat,rat),fun(nat,rat))) ).

% inverse_real.rsp
tff(fact_7198_funpow__transfer,axiom,
    ! [A: $tType,B: $tType,A3: fun(A,fun(B,$o))] : aa(fun(nat,fun(fun(B,B),fun(B,B))),$o,aa(fun(nat,fun(fun(A,A),fun(A,A))),fun(fun(nat,fun(fun(B,B),fun(B,B))),$o),bNF_rel_fun(nat,nat,fun(fun(A,A),fun(A,A)),fun(fun(B,B),fun(B,B)),fequal(nat),bNF_rel_fun(fun(A,A),fun(B,B),fun(A,A),fun(B,B),bNF_rel_fun(A,B,A,B,A3,A3),bNF_rel_fun(A,B,A,B,A3,A3))),compow(fun(A,A))),compow(fun(B,B))) ).

% funpow_transfer
tff(fact_7199_Real_Opositive_Otransfer,axiom,
    aa(fun(real,$o),$o,aa(fun(fun(nat,rat),$o),fun(fun(real,$o),$o),bNF_rel_fun(fun(nat,rat),real,$o,$o,pcr_real,fequal($o)),aTP_Lamp_agq(fun(nat,rat),$o)),positive2) ).

% Real.positive.transfer
tff(fact_7200_times__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_mu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),times_times(int)) ).

% times_int.transfer
tff(fact_7201_zero__real_Otransfer,axiom,
    aa(real,$o,aa(fun(nat,rat),fun(real,$o),pcr_real,aTP_Lamp_afv(nat,rat)),zero_zero(real)) ).

% zero_real.transfer
tff(fact_7202_one__real_Otransfer,axiom,
    aa(real,$o,aa(fun(nat,rat),fun(real,$o),pcr_real,aTP_Lamp_afu(nat,rat)),one_one(real)) ).

% one_real.transfer
tff(fact_7203_zero__int_Otransfer,axiom,
    aa(int,$o,aa(product_prod(nat,nat),fun(int,$o),pcr_int,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))),zero_zero(int)) ).

% zero_int.transfer
tff(fact_7204_times__real_Otransfer,axiom,
    aa(fun(real,fun(real,real)),$o,aa(fun(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),fun(fun(real,fun(real,real)),$o),bNF_rel_fun(fun(nat,rat),real,fun(fun(nat,rat),fun(nat,rat)),fun(real,real),pcr_real,bNF_rel_fun(fun(nat,rat),real,fun(nat,rat),real,pcr_real,pcr_real)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)))),times_times(real)) ).

% times_real.transfer
tff(fact_7205_int__transfer,axiom,
    aa(fun(nat,int),$o,aa(fun(nat,product_prod(nat,nat)),fun(fun(nat,int),$o),bNF_rel_fun(nat,nat,product_prod(nat,nat),int,fequal(nat),pcr_int),aTP_Lamp_agv(nat,product_prod(nat,nat))),semiring_1_of_nat(int)) ).

% int_transfer
tff(fact_7206_uminus__int_Otransfer,axiom,
    aa(fun(int,int),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(int,int),$o),bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_nc(nat,fun(nat,product_prod(nat,nat))))),uminus_uminus(int)) ).

% uminus_int.transfer
tff(fact_7207_nat_Otransfer,axiom,
    aa(fun(int,nat),$o,aa(fun(product_prod(nat,nat),nat),fun(fun(int,nat),$o),bNF_rel_fun(product_prod(nat,nat),int,nat,nat,pcr_int,fequal(nat)),product_case_prod(nat,nat,nat,minus_minus(nat))),nat2) ).

% nat.transfer
tff(fact_7208_one__int_Otransfer,axiom,
    aa(int,$o,aa(product_prod(nat,nat),fun(int,$o),pcr_int,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))),one_one(int)) ).

% one_int.transfer
tff(fact_7209_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => aa(fun(int,A),$o,aa(fun(product_prod(nat,nat),A),fun(fun(int,A),$o),bNF_rel_fun(product_prod(nat,nat),int,A,A,pcr_int,fequal(A)),product_case_prod(nat,nat,A,aTP_Lamp_ng(nat,fun(nat,A)))),ring_1_of_int(A)) ) ).

% of_int.transfer
tff(fact_7210_inverse__real_Otransfer,axiom,
    aa(fun(real,real),$o,aa(fun(fun(nat,rat),fun(nat,rat)),fun(fun(real,real),$o),bNF_rel_fun(fun(nat,rat),real,fun(nat,rat),real,pcr_real,pcr_real),aTP_Lamp_afw(fun(nat,rat),fun(nat,rat))),inverse_inverse(real)) ).

% inverse_real.transfer
tff(fact_7211_less__int_Otransfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_ni(nat,fun(nat,fun(product_prod(nat,nat),$o))))),ord_less(int)) ).

% less_int.transfer
tff(fact_7212_less__eq__int_Otransfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_nk(nat,fun(nat,fun(product_prod(nat,nat),$o))))),ord_less_eq(int)) ).

% less_eq_int.transfer
tff(fact_7213_plus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nm(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),plus_plus(int)) ).

% plus_int.transfer
tff(fact_7214_minus__int_Otransfer,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),product_prod(nat,nat)),fun(int,int),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,product_prod(nat,nat),int,pcr_int,pcr_int)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_no(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),minus_minus(int)) ).

% minus_int.transfer
tff(fact_7215_num_Orec__transfer,axiom,
    ! [A: $tType,B: $tType,S2: fun(A,fun(B,$o))] : aa(fun(B,fun(fun(num,fun(B,B)),fun(fun(num,fun(B,B)),fun(num,B)))),$o,aa(fun(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)))),fun(fun(B,fun(fun(num,fun(B,B)),fun(fun(num,fun(B,B)),fun(num,B)))),$o),bNF_rel_fun(A,B,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),fun(fun(num,fun(B,B)),fun(fun(num,fun(B,B)),fun(num,B))),S2,bNF_rel_fun(fun(num,fun(A,A)),fun(num,fun(B,B)),fun(fun(num,fun(A,A)),fun(num,A)),fun(fun(num,fun(B,B)),fun(num,B)),bNF_rel_fun(num,num,fun(A,A),fun(B,B),fequal(num),bNF_rel_fun(A,B,A,B,S2,S2)),bNF_rel_fun(fun(num,fun(A,A)),fun(num,fun(B,B)),fun(num,A),fun(num,B),bNF_rel_fun(num,num,fun(A,A),fun(B,B),fequal(num),bNF_rel_fun(A,B,A,B,S2,S2)),bNF_rel_fun(num,num,A,B,fequal(num),S2)))),rec_num(A)),rec_num(B)) ).

% num.rec_transfer
tff(fact_7216_fun__mono,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,C5: fun(A,fun(B,$o)),A3: fun(A,fun(B,$o)),B3: fun(C,fun(D,$o)),D3: fun(C,fun(D,$o))] :
      ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),C5),A3)
     => ( aa(fun(C,fun(D,$o)),$o,aa(fun(C,fun(D,$o)),fun(fun(C,fun(D,$o)),$o),ord_less_eq(fun(C,fun(D,$o))),B3),D3)
       => aa(fun(fun(A,C),fun(fun(B,D),$o)),$o,aa(fun(fun(A,C),fun(fun(B,D),$o)),fun(fun(fun(A,C),fun(fun(B,D),$o)),$o),ord_less_eq(fun(fun(A,C),fun(fun(B,D),$o))),bNF_rel_fun(A,B,C,D,A3,B3)),bNF_rel_fun(A,B,C,D,C5,D3)) ) ) ).

% fun_mono
tff(fact_7217_verit__eq__simplify_I19_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,fun(A,A)),F32: fun(num,fun(A,A))] : ( aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F2),F32),one2) = F1 ) ).

% verit_eq_simplify(19)
tff(fact_7218_verit__eq__simplify_I20_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,fun(A,A)),F32: fun(num,fun(A,A)),X2: num] : ( aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F2),F32),bit0(X2)) = aa(A,A,aa(num,fun(A,A),F2,X2),aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F2),F32),X2)) ) ).

% verit_eq_simplify(20)
tff(fact_7219_verit__eq__simplify_I21_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,fun(A,A)),F32: fun(num,fun(A,A)),X32: num] : ( aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F2),F32),aa(num,num,bit1,X32)) = aa(A,A,aa(num,fun(A,A),F32,X32),aa(num,A,aa(fun(num,fun(A,A)),fun(num,A),aa(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A)),aa(A,fun(fun(num,fun(A,A)),fun(fun(num,fun(A,A)),fun(num,A))),rec_num(A),F1),F2),F32),X32)) ) ).

% verit_eq_simplify(21)
tff(fact_7220_num_Ocase__transfer,axiom,
    ! [A: $tType,B: $tType,S2: fun(A,fun(B,$o))] : aa(fun(B,fun(fun(num,B),fun(fun(num,B),fun(num,B)))),$o,aa(fun(A,fun(fun(num,A),fun(fun(num,A),fun(num,A)))),fun(fun(B,fun(fun(num,B),fun(fun(num,B),fun(num,B)))),$o),bNF_rel_fun(A,B,fun(fun(num,A),fun(fun(num,A),fun(num,A))),fun(fun(num,B),fun(fun(num,B),fun(num,B))),S2,bNF_rel_fun(fun(num,A),fun(num,B),fun(fun(num,A),fun(num,A)),fun(fun(num,B),fun(num,B)),bNF_rel_fun(num,num,A,B,fequal(num),S2),bNF_rel_fun(fun(num,A),fun(num,B),fun(num,A),fun(num,B),bNF_rel_fun(num,num,A,B,fequal(num),S2),bNF_rel_fun(num,num,A,B,fequal(num),S2)))),case_num(A)),case_num(B)) ).

% num.case_transfer
tff(fact_7221_fun_Orel__mono,axiom,
    ! [C: $tType,B: $tType,A: $tType,R2: fun(A,fun(B,$o)),Ra: fun(A,fun(B,$o))] :
      ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),R2),Ra)
     => aa(fun(fun(C,A),fun(fun(C,B),$o)),$o,aa(fun(fun(C,A),fun(fun(C,B),$o)),fun(fun(fun(C,A),fun(fun(C,B),$o)),$o),ord_less_eq(fun(fun(C,A),fun(fun(C,B),$o))),bNF_rel_fun(C,C,A,B,fequal(C),R2)),bNF_rel_fun(C,C,A,B,fequal(C),Ra)) ) ).

% fun.rel_mono
tff(fact_7222_verit__eq__simplify_I18_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,A),F32: fun(num,A),X32: num] : ( aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),F1),F2),F32),aa(num,num,bit1,X32)) = aa(num,A,F32,X32) ) ).

% verit_eq_simplify(18)
tff(fact_7223_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,A),F32: fun(num,A),X2: num] : ( aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),F1),F2),F32),bit0(X2)) = aa(num,A,F2,X2) ) ).

% verit_eq_simplify(17)
tff(fact_7224_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F2: fun(num,A),F32: fun(num,A)] : ( aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),F1),F2),F32),one2) = F1 ) ).

% verit_eq_simplify(16)
tff(fact_7225_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H: fun(B,A),F1: B,F2: fun(num,B),F32: fun(num,B),Num: num] : ( aa(B,A,H,aa(num,B,aa(fun(num,B),fun(num,B),aa(fun(num,B),fun(fun(num,B),fun(num,B)),aa(B,fun(fun(num,B),fun(fun(num,B),fun(num,B))),case_num(B),F1),F2),F32),Num)) = aa(num,A,aa(fun(num,A),fun(num,A),aa(fun(num,A),fun(fun(num,A),fun(num,A)),aa(A,fun(fun(num,A),fun(fun(num,A),fun(num,A))),case_num(A),aa(B,A,H,F1)),aa(fun(num,B),fun(num,A),aTP_Lamp_agw(fun(B,A),fun(fun(num,B),fun(num,A)),H),F2)),aa(fun(num,B),fun(num,A),aTP_Lamp_agw(fun(B,A),fun(fun(num,B),fun(num,A)),H),F32)),Num) ) ).

% num.case_distrib
tff(fact_7226_times__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_mu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_mu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% times_int.rsp
tff(fact_7227_mult__inj__if__coprime__nat,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,nat),A3: set(A),G: fun(B,nat),B3: set(B)] :
      ( inj_on(A,nat,F3,A3)
     => ( inj_on(B,nat,G,B3)
       => ( ! [A4: A,B4: B] :
              ( member(A,A4,A3)
             => ( member(B,B4,B3)
               => algebr8660921524188924756oprime(nat,aa(A,nat,F3,A4),aa(B,nat,G,B4)) ) )
         => inj_on(product_prod(A,B),nat,product_case_prod(A,B,nat,aa(fun(B,nat),fun(A,fun(B,nat)),aTP_Lamp_agx(fun(A,nat),fun(fun(B,nat),fun(A,fun(B,nat))),F3),G)),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),B3))) ) ) ) ).

% mult_inj_if_coprime_nat
tff(fact_7228_coprime__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,C2,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))
        <=> ( algebr8660921524188924756oprime(A,C2,A2)
            & algebr8660921524188924756oprime(A,C2,B2) ) ) ) ).

% coprime_mult_right_iff
tff(fact_7229_coprime__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2)
        <=> ( algebr8660921524188924756oprime(A,A2,C2)
            & algebr8660921524188924756oprime(A,B2,C2) ) ) ) ).

% coprime_mult_left_iff
tff(fact_7230_coprime__minus__left__iff,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,uminus_uminus(A),A2),B2)
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_minus_left_iff
tff(fact_7231_coprime__minus__right__iff,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,aa(A,A,uminus_uminus(A),B2))
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_minus_right_iff
tff(fact_7232_coprime__self,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,A2,A2)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ).

% coprime_self
tff(fact_7233_coprime__mod__right__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( algebr8660921524188924756oprime(A,A2,modulo_modulo(A,B2,A2))
          <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mod_right_iff
tff(fact_7234_coprime__mod__left__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( algebr8660921524188924756oprime(A,modulo_modulo(A,A2,B2),B2)
          <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mod_left_iff
tff(fact_7235_coprime__power__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,N: nat] :
          ( algebr8660921524188924756oprime(A,A2,aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N))
        <=> ( algebr8660921524188924756oprime(A,A2,B2)
            | ( N = zero_zero(nat) ) ) ) ) ).

% coprime_power_right_iff
tff(fact_7236_coprime__power__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,N: nat,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N),B2)
        <=> ( algebr8660921524188924756oprime(A,A2,B2)
            | ( N = zero_zero(nat) ) ) ) ) ).

% coprime_power_left_iff
tff(fact_7237_intrel__iff,axiom,
    ! [Xa: nat,Y: nat,U: nat,V: nat] :
      ( aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),Y)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,U),V))
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Xa),V) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),U),Y) ) ) ).

% intrel_iff
tff(fact_7238_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,zero_zero(A),A2)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ).

% coprime_0_left_iff
tff(fact_7239_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] :
          ( algebr8660921524188924756oprime(A,A2,zero_zero(A))
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A)) ) ) ).

% coprime_0_right_iff
tff(fact_7240_coprime__mult__self__left__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
            & algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mult_self_left_iff
tff(fact_7241_coprime__mult__self__right__iff,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
            & algebr8660921524188924756oprime(A,A2,B2) ) ) ) ).

% coprime_mult_self_right_iff
tff(fact_7242_mult__mod__cancel__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [A2: A,N: A,M: A,B2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),N),M) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),N),M) )
         => ( algebr8660921524188924756oprime(A,M,N)
           => ( modulo_modulo(A,A2,M) = modulo_modulo(A,B2,M) ) ) ) ) ).

% mult_mod_cancel_right
tff(fact_7243_mult__mod__cancel__left,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel(A)
        & semiring_gcd(A) )
     => ! [N: A,A2: A,M: A,B2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),N),A2),M) = modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),N),B2),M) )
         => ( algebr8660921524188924756oprime(A,M,N)
           => ( modulo_modulo(A,A2,M) = modulo_modulo(A,B2,M) ) ) ) ) ).

% mult_mod_cancel_left
tff(fact_7244_coprime__common__divisor__nat,axiom,
    ! [A2: nat,B2: nat,Xa: nat] :
      ( algebr8660921524188924756oprime(nat,A2,B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Xa),A2)
       => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Xa),B2)
         => ( Xa = one_one(nat) ) ) ) ) ).

% coprime_common_divisor_nat
tff(fact_7245_prod__coprime__left,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(A),F3: fun(A,B),A2: B] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => algebr8660921524188924756oprime(B,aa(A,B,F3,I2),A2) )
         => algebr8660921524188924756oprime(B,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3),A2) ) ) ).

% prod_coprime_left
tff(fact_7246_prod__coprime__right,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_gcd(B)
     => ! [A3: set(A),A2: B,F3: fun(A,B)] :
          ( ! [I2: A] :
              ( member(A,I2,A3)
             => algebr8660921524188924756oprime(B,A2,aa(A,B,F3,I2)) )
         => algebr8660921524188924756oprime(B,A2,aa(set(A),B,aa(fun(A,B),fun(set(A),B),groups7121269368397514597t_prod(A,B),F3),A3)) ) ) ).

% prod_coprime_right
tff(fact_7247_coprime__dvd__mult__right__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% coprime_dvd_mult_right_iff
tff(fact_7248_coprime__dvd__mult__left__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2))
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ).

% coprime_dvd_mult_left_iff
tff(fact_7249_divides__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
           => ( algebr8660921524188924756oprime(A,A2,B2)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),C2) ) ) ) ) ).

% divides_mult
tff(fact_7250_is__unit__right__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),one_one(A))
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% is_unit_right_imp_coprime
tff(fact_7251_is__unit__left__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% is_unit_left_imp_coprime
tff(fact_7252_coprime__common__divisor,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A,C2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A)) ) ) ) ) ).

% coprime_common_divisor
tff(fact_7253_coprime__absorb__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [Y: A,Xa: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y),Xa)
         => ( algebr8660921524188924756oprime(A,Xa,Y)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Y),one_one(A)) ) ) ) ).

% coprime_absorb_right
tff(fact_7254_coprime__imp__coprime,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,D2: A,A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,C2,D2)
         => ( ! [E2: A] :
                ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),one_one(A))
               => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),A2)
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),B2)
                   => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),C2) ) ) )
           => ( ! [E2: A] :
                  ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),one_one(A))
                 => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),A2)
                   => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),B2)
                     => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),E2),D2) ) ) )
             => algebr8660921524188924756oprime(A,A2,B2) ) ) ) ) ).

% coprime_imp_coprime
tff(fact_7255_coprime__absorb__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [Xa: A,Y: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),Y)
         => ( algebr8660921524188924756oprime(A,Xa,Y)
          <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Xa),one_one(A)) ) ) ) ).

% coprime_absorb_left
tff(fact_7256_not__coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),one_one(A))
             => ~ algebr8660921524188924756oprime(A,A2,B2) ) ) ) ) ).

% not_coprimeI
tff(fact_7257_not__coprimeE,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ~ algebr8660921524188924756oprime(A,A2,B2)
         => ~ ! [C4: A] :
                ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),A2)
               => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),B2)
                 => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),one_one(A)) ) ) ) ) ).

% not_coprimeE
tff(fact_7258_coprime__def,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
        <=> ! [C3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),B2)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C3),one_one(A)) ) ) ) ) ).

% coprime_def
tff(fact_7259_coprimeI,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,B2: A] :
          ( ! [C4: A] :
              ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),A2)
             => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),B2)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C4),one_one(A)) ) )
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprimeI
tff(fact_7260_coprime__commute,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [B2: A,A2: A] :
          ( algebr8660921524188924756oprime(A,B2,A2)
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% coprime_commute
tff(fact_7261_coprime__divisors,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),D2)
           => ( algebr8660921524188924756oprime(A,C2,D2)
             => algebr8660921524188924756oprime(A,A2,B2) ) ) ) ) ).

% coprime_divisors
tff(fact_7262_coprime__Suc__left__nat,axiom,
    ! [N: nat] : algebr8660921524188924756oprime(nat,aa(nat,nat,suc,N),N) ).

% coprime_Suc_left_nat
tff(fact_7263_coprime__Suc__right__nat,axiom,
    ! [N: nat] : algebr8660921524188924756oprime(nat,N,aa(nat,nat,suc,N)) ).

% coprime_Suc_right_nat
tff(fact_7264_coprime__crossproduct__nat,axiom,
    ! [A2: nat,D2: nat,B2: nat,C2: nat] :
      ( algebr8660921524188924756oprime(nat,A2,D2)
     => ( algebr8660921524188924756oprime(nat,B2,C2)
       => ( ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),C2) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),D2) )
        <=> ( ( A2 = B2 )
            & ( C2 = D2 ) ) ) ) ) ).

% coprime_crossproduct_nat
tff(fact_7265_coprime__1__left,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,one_one(A),A2) ) ).

% coprime_1_left
tff(fact_7266_coprime__1__right,axiom,
    ! [A: $tType] :
      ( algebraic_semidom(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,A2,one_one(A)) ) ).

% coprime_1_right
tff(fact_7267_coprime__Suc__0__right,axiom,
    ! [N: nat] : algebr8660921524188924756oprime(nat,N,aa(nat,nat,suc,zero_zero(nat))) ).

% coprime_Suc_0_right
tff(fact_7268_coprime__Suc__0__left,axiom,
    ! [N: nat] : algebr8660921524188924756oprime(nat,aa(nat,nat,suc,zero_zero(nat)),N) ).

% coprime_Suc_0_left
tff(fact_7269_coprime__add__one__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A)),A2) ) ).

% coprime_add_one_left
tff(fact_7270_coprime__add__one__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,A2,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),one_one(A))) ) ).

% coprime_add_one_right
tff(fact_7271_int_Oabs__eq__iff,axiom,
    ! [Xa: product_prod(nat,nat),Y: product_prod(nat,nat)] :
      ( ( aa(product_prod(nat,nat),int,abs_Integ,Xa) = aa(product_prod(nat,nat),int,abs_Integ,Y) )
    <=> aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,Xa),Y) ) ).

% int.abs_eq_iff
tff(fact_7272_zero__int_Orsp,axiom,
    aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,zero_zero(nat)),zero_zero(nat))) ).

% zero_int.rsp
tff(fact_7273_invertible__coprime,axiom,
    ! [A: $tType] :
      ( euclid8851590272496341667cancel(A)
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2),C2) = one_one(A) )
         => algebr8660921524188924756oprime(A,A2,C2) ) ) ).

% invertible_coprime
tff(fact_7274_coprime__diff__one__left,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A)),A2) ) ).

% coprime_diff_one_left
tff(fact_7275_coprime__doff__one__right,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A] : algebr8660921524188924756oprime(A,A2,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),one_one(A))) ) ).

% coprime_doff_one_right
tff(fact_7276_uminus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),product_prod(nat,nat)),$o,aa(fun(product_prod(nat,nat),product_prod(nat,nat)),fun(fun(product_prod(nat,nat),product_prod(nat,nat)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_nc(nat,fun(nat,product_prod(nat,nat))))),product_case_prod(nat,nat,product_prod(nat,nat),aTP_Lamp_nc(nat,fun(nat,product_prod(nat,nat))))) ).

% uminus_int.rsp
tff(fact_7277_nat_Orsp,axiom,
    aa(fun(product_prod(nat,nat),nat),$o,aa(fun(product_prod(nat,nat),nat),fun(fun(product_prod(nat,nat),nat),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),nat,nat,intrel,fequal(nat)),product_case_prod(nat,nat,nat,minus_minus(nat))),product_case_prod(nat,nat,nat,minus_minus(nat))) ).

% nat.rsp
tff(fact_7278_one__int_Orsp,axiom,
    aa(product_prod(nat,nat),$o,aa(product_prod(nat,nat),fun(product_prod(nat,nat),$o),intrel,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,one_one(nat)),zero_zero(nat))) ).

% one_int.rsp
tff(fact_7279_coprime__diff__one__left__nat,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => algebr8660921524188924756oprime(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),N) ) ).

% coprime_diff_one_left_nat
tff(fact_7280_coprime__diff__one__right__nat,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => algebr8660921524188924756oprime(nat,N,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat))) ) ).

% coprime_diff_one_right_nat
tff(fact_7281_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => aa(fun(product_prod(nat,nat),A),$o,aa(fun(product_prod(nat,nat),A),fun(fun(product_prod(nat,nat),A),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),A,A,intrel,fequal(A)),product_case_prod(nat,nat,A,aTP_Lamp_ng(nat,fun(nat,A)))),product_case_prod(nat,nat,A,aTP_Lamp_ng(nat,fun(nat,A)))) ) ).

% of_int.rsp
tff(fact_7282_intrel__def,axiom,
    intrel = product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_agz(nat,fun(nat,fun(product_prod(nat,nat),$o)))) ).

% intrel_def
tff(fact_7283_Rats__abs__nat__div__natE,axiom,
    ! [Xa: real] :
      ( member(real,Xa,field_char_0_Rats(real))
     => ~ ! [M2: nat,N2: nat] :
            ( ( N2 != zero_zero(nat) )
           => ( ( aa(real,real,abs_abs(real),Xa) = divide_divide(real,aa(nat,real,semiring_1_of_nat(real),M2),aa(nat,real,semiring_1_of_nat(real),N2)) )
             => ~ algebr8660921524188924756oprime(nat,M2,N2) ) ) ) ).

% Rats_abs_nat_div_natE
tff(fact_7284_less__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(product_prod(nat,nat),$o),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),$o,$o,intrel,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_ni(nat,fun(nat,fun(product_prod(nat,nat),$o))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_ni(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_int.rsp
tff(fact_7285_less__eq__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),$o),fun(product_prod(nat,nat),$o),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),$o,$o,intrel,fequal($o))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_nk(nat,fun(nat,fun(product_prod(nat,nat),$o))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),$o),aTP_Lamp_nk(nat,fun(nat,fun(product_prod(nat,nat),$o))))) ).

% less_eq_int.rsp
tff(fact_7286_int_Orel__eq__transfer,axiom,
    aa(fun(int,fun(int,$o)),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),$o)),fun(fun(int,fun(int,$o)),$o),bNF_rel_fun(product_prod(nat,nat),int,fun(product_prod(nat,nat),$o),fun(int,$o),pcr_int,bNF_rel_fun(product_prod(nat,nat),int,$o,$o,pcr_int,fequal($o))),intrel),fequal(int)) ).

% int.rel_eq_transfer
tff(fact_7287_plus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nm(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_nm(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% plus_int.rsp
tff(fact_7288_minus__int_Orsp,axiom,
    aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o,aa(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),fun(fun(product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat))),$o),bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),fun(product_prod(nat,nat),product_prod(nat,nat)),fun(product_prod(nat,nat),product_prod(nat,nat)),intrel,bNF_rel_fun(product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),product_prod(nat,nat),intrel,intrel)),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_no(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))),product_case_prod(nat,nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aTP_Lamp_no(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))))) ).

% minus_int.rsp
tff(fact_7289_butlast__take,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(list(A),nat,size_size(list(A)),Xs))
     => ( aa(list(A),list(A),butlast(A),take(A,N,Xs)) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),Xs) ) ) ).

% butlast_take
tff(fact_7290_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A)] :
          ( aa(set(A),$o,finite_finite(A),aa(set(nat),set(A),image(nat,A,F3),top_top(set(nat))))
         => ( aa(fun(nat,A),$o,order_mono(nat,A),F3)
           => ( ! [N2: nat] :
                  ( ( aa(nat,A,F3,N2) = aa(nat,A,F3,aa(nat,nat,suc,N2)) )
                 => ( aa(nat,A,F3,aa(nat,nat,suc,N2)) = aa(nat,A,F3,aa(nat,nat,suc,aa(nat,nat,suc,N2))) ) )
             => ? [N9: nat] :
                  ( ! [N3: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N3),N9)
                     => ! [M3: nat] :
                          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M3),N9)
                         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),M3),N3)
                           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),aa(nat,A,F3,M3)),aa(nat,A,F3,N3)) ) ) )
                  & ! [N3: nat] :
                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N9),N3)
                     => ( aa(nat,A,F3,N9) = aa(nat,A,F3,N3) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
tff(fact_7291_coprime__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( algebr8660921524188924756oprime(int,aa(nat,int,semiring_1_of_nat(int),M),aa(nat,int,semiring_1_of_nat(int),N))
    <=> algebr8660921524188924756oprime(nat,M,N) ) ).

% coprime_int_iff
tff(fact_7292_length__butlast,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),nat,size_size(list(A)),aa(list(A),list(A),butlast(A),Xs)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)) ) ).

% length_butlast
tff(fact_7293_normalize__stable,axiom,
    ! [Q2: int,P2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Q2)
     => ( algebr8660921524188924756oprime(int,P2,Q2)
       => ( normalize(aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2)) = aa(int,product_prod(int,int),product_Pair(int,int,P2),Q2) ) ) ) ).

% normalize_stable
tff(fact_7294_coprime__nat__abs__right__iff,axiom,
    ! [N: nat,K: int] :
      ( algebr8660921524188924756oprime(nat,N,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)))
    <=> algebr8660921524188924756oprime(int,aa(nat,int,semiring_1_of_nat(int),N),K) ) ).

% coprime_nat_abs_right_iff
tff(fact_7295_coprime__nat__abs__left__iff,axiom,
    ! [K: int,N: nat] :
      ( algebr8660921524188924756oprime(nat,aa(int,nat,nat2,aa(int,int,abs_abs(int),K)),N)
    <=> algebr8660921524188924756oprime(int,K,aa(nat,int,semiring_1_of_nat(int),N)) ) ).

% coprime_nat_abs_left_iff
tff(fact_7296_coprime__crossproduct__int,axiom,
    ! [A2: int,D2: int,B2: int,C2: int] :
      ( algebr8660921524188924756oprime(int,A2,D2)
     => ( algebr8660921524188924756oprime(int,B2,C2)
       => ( ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),A2)),aa(int,int,abs_abs(int),C2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),B2)),aa(int,int,abs_abs(int),D2)) )
        <=> ( ( aa(int,int,abs_abs(int),A2) = aa(int,int,abs_abs(int),B2) )
            & ( aa(int,int,abs_abs(int),C2) = aa(int,int,abs_abs(int),D2) ) ) ) ) ) ).

% coprime_crossproduct_int
tff(fact_7297_Rat__cases,axiom,
    ! [Q2: rat] :
      ~ ! [A4: int,B4: int] :
          ( ( Q2 = aa(int,rat,aa(int,fun(int,rat),fract,A4),B4) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
           => ~ algebr8660921524188924756oprime(int,A4,B4) ) ) ).

% Rat_cases
tff(fact_7298_Rat__induct,axiom,
    ! [P: fun(rat,$o),Q2: rat] :
      ( ! [A4: int,B4: int] :
          ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
         => ( algebr8660921524188924756oprime(int,A4,B4)
           => aa(rat,$o,P,aa(int,rat,aa(int,fun(int,rat),fract,A4),B4)) ) )
     => aa(rat,$o,P,Q2) ) ).

% Rat_induct
tff(fact_7299_funpow__mono,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(A,A),A3: A,B3: A,N: nat] :
          ( aa(fun(A,A),$o,order_mono(A,A),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A3),B3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),A3)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),B3)) ) ) ) ).

% funpow_mono
tff(fact_7300_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F3: fun(A,B),Xa: A,Y: A] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa)),aa(A,B,F3,Y)) ) ) ) ).

% monoD
tff(fact_7301_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F3: fun(A,B),Xa: A,Y: A] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa)),aa(A,B,F3,Y)) ) ) ) ).

% monoE
tff(fact_7302_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F3: fun(A,B)] :
          ( ! [X: A,Y3: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,F3,Y3)) )
         => aa(fun(A,B),$o,order_mono(A,B),F3) ) ) ).

% monoI
tff(fact_7303_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F3: fun(A,B)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
        <=> ! [X4: A,Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Y5)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),aa(A,B,F3,Y5)) ) ) ) ).

% mono_def
tff(fact_7304_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A)] :
          ( aa(fun(nat,A),$o,order_mono(nat,A),F3)
        <=> ! [N5: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N5)),aa(nat,A,F3,aa(nat,nat,suc,N5))) ) ) ).

% incseq_Suc_iff
tff(fact_7305_incseq__SucI,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N2)),aa(nat,A,X6,aa(nat,nat,suc,N2)))
         => aa(fun(nat,A),$o,order_mono(nat,A),X6) ) ) ).

% incseq_SucI
tff(fact_7306_incseq__SucD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [A3: fun(nat,A),I: nat] :
          ( aa(fun(nat,A),$o,order_mono(nat,A),A3)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,A3,I)),aa(nat,A,A3,aa(nat,nat,suc,I))) ) ) ).

% incseq_SucD
tff(fact_7307_incseqD,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(nat,A),I: nat,J: nat] :
          ( aa(fun(nat,A),$o,order_mono(nat,A),F3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,I)),aa(nat,A,F3,J)) ) ) ) ).

% incseqD
tff(fact_7308_incseq__def,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [X6: fun(nat,A)] :
          ( aa(fun(nat,A),$o,order_mono(nat,A),X6)
        <=> ! [M6: nat,N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M6),N5)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,M6)),aa(nat,A,X6,N5)) ) ) ) ).

% incseq_def
tff(fact_7309_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder(A)
        & order(B) )
     => ! [F3: fun(A,B),Xa: A,Y: A] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,Xa)),aa(A,B,F3,Y))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y) ) ) ) ).

% mono_invE
tff(fact_7310_cclfp__lowerbound,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [F3: fun(A,A),A3: A] :
          ( aa(fun(A,A),$o,order_mono(A,A),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,F3,A3)),A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),order_532582986084564980_cclfp(A,F3)),A3) ) ) ) ).

% cclfp_lowerbound
tff(fact_7311_mono__mult,axiom,
    ! [A: $tType] :
      ( ordered_semiring(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),A2)
         => aa(fun(A,A),$o,order_mono(A,A),aa(A,fun(A,A),times_times(A),A2)) ) ) ).

% mono_mult
tff(fact_7312_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [F3: fun(A,A),P2: A,K: nat] :
          ( aa(fun(A,A),$o,order_mono(A,A),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,F3,P2)),P2)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F3),bot_bot(A))),P2) ) ) ) ).

% Kleene_iter_lpfp
tff(fact_7313_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ! [F3: fun(A,A),P2: A,K: nat] :
          ( aa(fun(A,A),$o,order_mono(A,A),F3)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P2),aa(A,A,F3,P2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),P2),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),K),F3),top_top(A))) ) ) ) ).

% Kleene_iter_gpfp
tff(fact_7314_funpow__mono2,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [F3: fun(A,A),I: nat,J: nat,Xa: A,Y: A] :
          ( aa(fun(A,A),$o,order_mono(A,A),F3)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),I),J)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(A,A,F3,Xa))
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),I),F3),Xa)),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),J),F3),Y)) ) ) ) ) ) ).

% funpow_mono2
tff(fact_7315_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf(A)
        & semilattice_inf(B) )
     => ! [F3: fun(A,B),A3: A,B3: A] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(A,A,aa(A,fun(A,A),inf_inf(A),A3),B3))),aa(B,B,aa(B,fun(B,B),inf_inf(B),aa(A,B,F3,A3)),aa(A,B,F3,B3))) ) ) ).

% mono_inf
tff(fact_7316_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup(A)
        & semilattice_sup(B) )
     => ! [F3: fun(A,B),A3: A,B3: A] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(B,B,aa(B,fun(B,B),sup_sup(B),aa(A,B,F3,A3)),aa(A,B,F3,B3))),aa(A,B,F3,aa(A,A,aa(A,fun(A,A),sup_sup(A),A3),B3))) ) ) ).

% mono_sup
tff(fact_7317_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Q: fun(A,A)] :
          ( aa(fun(A,A),$o,order_mono(A,A),Q)
         => aa(fun(nat,A),$o,order_mono(nat,A),aTP_Lamp_aha(fun(A,A),fun(nat,A),Q)) ) ) ).

% mono_funpow
tff(fact_7318_mono__pow,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [F3: fun(A,A),N: nat] :
          ( aa(fun(A,A),$o,order_mono(A,A),F3)
         => aa(fun(A,A),$o,order_mono(A,A),aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3)) ) ) ).

% mono_pow
tff(fact_7319_mono__add,axiom,
    ! [A: $tType] :
      ( ordere6658533253407199908up_add(A)
     => ! [A2: A] : aa(fun(A,A),$o,order_mono(A,A),aa(A,fun(A,A),plus_plus(A),A2)) ) ).

% mono_add
tff(fact_7320_mono__Suc,axiom,
    aa(fun(nat,nat),$o,order_mono(nat,nat),suc) ).

% mono_Suc
tff(fact_7321_mono__times__nat,axiom,
    ! [N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => aa(fun(nat,nat),$o,order_mono(nat,nat),aa(nat,fun(nat,nat),times_times(nat),N)) ) ).

% mono_times_nat
tff(fact_7322_coprime__common__divisor__int,axiom,
    ! [A2: int,B2: int,Xa: int] :
      ( algebr8660921524188924756oprime(int,A2,B2)
     => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Xa),A2)
       => ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Xa),B2)
         => ( aa(int,int,abs_abs(int),Xa) = one_one(int) ) ) ) ) ).

% coprime_common_divisor_int
tff(fact_7323_incseq__bounded,axiom,
    ! [X6: fun(nat,real),B3: real] :
      ( aa(fun(nat,real),$o,order_mono(nat,real),X6)
     => ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,X6,I2)),B3)
       => bfun(nat,real,X6,at_top(nat)) ) ) ).

% incseq_bounded
tff(fact_7324_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ).

% mono_Sup
tff(fact_7325_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ahb(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,A3),I5)))) ) ) ).

% mono_SUP
tff(fact_7326_mono__INF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(B)
        & comple6319245703460814977attice(A) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,A3),I5)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ahb(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))) ) ) ).

% mono_INF
tff(fact_7327_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ).

% mono_Inf
tff(fact_7328_incseq__le,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [X6: fun(nat,A),L5: A,N: nat] :
          ( aa(fun(nat,A),$o,order_mono(nat,A),X6)
         => ( filterlim(nat,A,X6,topolo7230453075368039082e_nhds(A,L5),at_top(nat))
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,X6,N)),L5) ) ) ) ).

% incseq_le
tff(fact_7329_sorted__butlast,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( ( Xs != nil(A) )
         => ( sorted_wrt(A,ord_less_eq(A),Xs)
           => sorted_wrt(A,ord_less_eq(A),aa(list(A),list(A),butlast(A),Xs)) ) ) ) ).

% sorted_butlast
tff(fact_7330_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_top(A) )
     => ! [M: nat,N: nat,F3: fun(A,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(fun(A,A),$o,order_mono(A,A),F3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),top_top(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F3),top_top(A))) ) ) ) ).

% funpow_increasing
tff(fact_7331_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [M: nat,N: nat,F3: fun(A,A)] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
         => ( aa(fun(A,A),$o,order_mono(A,A),F3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),M),F3),bot_bot(A))),aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),F3),bot_bot(A))) ) ) ) ).

% funpow_decreasing
tff(fact_7332_incseq__convergent,axiom,
    ! [X6: fun(nat,real),B3: real] :
      ( aa(fun(nat,real),$o,order_mono(nat,real),X6)
     => ( ! [I2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,X6,I2)),B3)
       => ~ ! [L6: real] :
              ( filterlim(nat,real,X6,topolo7230453075368039082e_nhds(real,L6),at_top(nat))
             => ~ ! [I4: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,X6,I4)),L6) ) ) ) ).

% incseq_convergent
tff(fact_7333_mono__bij__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder(A)
        & comple5582772986160207858norder(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( bij_betw(A,B,F3,top_top(set(A)),top_top(set(B)))
           => ( aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),A3)) = aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3)) ) ) ) ) ).

% mono_bij_Inf
tff(fact_7334_butlast__power,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),list(A),aa(fun(list(A),list(A)),fun(list(A),list(A)),aa(nat,fun(fun(list(A),list(A)),fun(list(A),list(A))),compow(fun(list(A),list(A))),N),butlast(A)),Xs) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N),Xs) ) ).

% butlast_power
tff(fact_7335_Rat__cases__nonzero,axiom,
    ! [Q2: rat] :
      ( ! [A4: int,B4: int] :
          ( ( Q2 = aa(int,rat,aa(int,fun(int,rat),fract,A4),B4) )
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
           => ( ( A4 != zero_zero(int) )
             => ~ algebr8660921524188924756oprime(int,A4,B4) ) ) )
     => ( Q2 = zero_zero(rat) ) ) ).

% Rat_cases_nonzero
tff(fact_7336_mono__ccSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta4013691401010221786attice(A)
        & counta3822494911875563373attice(B) )
     => ! [F3: fun(A,B),I5: set(C),A3: fun(C,A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( countable_countable(C,I5)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ahc(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,A3),I5)))) ) ) ) ).

% mono_ccSUP
tff(fact_7337_mono__ccSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta4013691401010221786attice(A)
        & counta3822494911875563373attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( countable_countable(A,A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ) ).

% mono_ccSup
tff(fact_7338_mono__ccInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta4013691401010221786attice(A)
        & counta3822494911875563373attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( countable_countable(A,A3)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ).

% mono_ccInf
tff(fact_7339_mono__ccINF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( counta3822494911875563373attice(B)
        & counta4013691401010221786attice(A) )
     => ! [F3: fun(A,B),I5: set(C),A3: fun(C,A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( countable_countable(C,I5)
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,A3),I5)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ahc(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))) ) ) ) ).

% mono_ccINF
tff(fact_7340_Rats__cases_H,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Xa: A] :
          ( member(A,Xa,field_char_0_Rats(A))
         => ~ ! [A4: int,B4: int] :
                ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B4)
               => ( algebr8660921524188924756oprime(int,A4,B4)
                 => ( Xa != divide_divide(A,aa(int,A,ring_1_of_int(A),A4),aa(int,A,ring_1_of_int(A),B4)) ) ) ) ) ) ).

% Rats_cases'
tff(fact_7341_butlast__conv__take,axiom,
    ! [A: $tType,Xs: list(A)] : ( aa(list(A),list(A),butlast(A),Xs) = take(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),Xs) ) ).

% butlast_conv_take
tff(fact_7342_butlast__list__update,axiom,
    ! [A: $tType,Xs: list(A),K: nat,Xa: A] :
      ( aa(list(A),list(A),butlast(A),list_update(A,Xs,K,Xa))
      = $ite(K = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),aa(list(A),list(A),butlast(A),Xs),list_update(A,aa(list(A),list(A),butlast(A),Xs),K,Xa)) ) ).

% butlast_list_update
tff(fact_7343_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F3: fun(nat,real),G: fun(nat,nat)] :
      ( ! [X: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(nat,real,F3,X))
     => ( aa(fun(nat,real),$o,order_mono(nat,real),F3)
       => ( order_strict_mono(nat,nat,G)
         => ( bfun(nat,real,aa(fun(nat,nat),fun(nat,real),aTP_Lamp_ahd(fun(nat,real),fun(fun(nat,nat),fun(nat,real)),F3),G),at_top(nat))
          <=> bfun(nat,real,F3,at_top(nat)) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
tff(fact_7344_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),K)
     => aa(fun(nat,nat),$o,order_mono(nat,nat),aTP_Lamp_ahe(nat,fun(nat,nat),K)) ) ).

% mono_ge2_power_minus_self
tff(fact_7345_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( remdups_adj(A,Xs) = Ys )
    <=> ? [F5: fun(nat,nat)] :
          ( aa(fun(nat,nat),$o,order_mono(nat,nat),F5)
          & ( aa(set(nat),set(nat),image(nat,nat,F5),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(list(A),nat,size_size(list(A)),Ys)) )
          & ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(list(A),nat,size_size(list(A)),Xs))
             => ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,nth(A,Ys),aa(nat,nat,F5,I3)) ) )
          & ! [I3: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),one_one(nat))),aa(list(A),nat,size_size(list(A)),Xs))
             => ( ( aa(nat,A,nth(A,Xs),I3) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),one_one(nat))) )
              <=> ( aa(nat,nat,F5,I3) = aa(nat,nat,F5,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I3),one_one(nat))) ) ) ) ) ) ).

% remdups_adj_altdef
tff(fact_7346_mono__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType] :
      ( ( order(B)
        & order(D)
        & order(C)
        & order(A) )
     => ! [A3: fun(A,fun(B,$o)),B3: fun(C,fun(D,$o))] :
          ( bi_total(A,B,A3)
         => ( aa(fun(B,fun(B,$o)),$o,aa(fun(A,fun(A,$o)),fun(fun(B,fun(B,$o)),$o),bNF_rel_fun(A,B,fun(A,$o),fun(B,$o),A3,bNF_rel_fun(A,B,$o,$o,A3,fequal($o))),ord_less_eq(A)),ord_less_eq(B))
           => ( aa(fun(D,fun(D,$o)),$o,aa(fun(C,fun(C,$o)),fun(fun(D,fun(D,$o)),$o),bNF_rel_fun(C,D,fun(C,$o),fun(D,$o),B3,bNF_rel_fun(C,D,$o,$o,B3,fequal($o))),ord_less_eq(C)),ord_less_eq(D))
             => aa(fun(fun(B,D),$o),$o,aa(fun(fun(A,C),$o),fun(fun(fun(B,D),$o),$o),bNF_rel_fun(fun(A,C),fun(B,D),$o,$o,bNF_rel_fun(A,B,C,D,A3,B3),fequal($o)),order_mono(A,C)),order_mono(B,D)) ) ) ) ) ).

% mono_transfer
tff(fact_7347_mono__Int,axiom,
    ! [B: $tType,A: $tType,F3: fun(set(A),set(B)),A3: set(A),B3: set(A)] :
      ( aa(fun(set(A),set(B)),$o,order_mono(set(A),set(B)),F3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),inf_inf(set(B)),aa(set(A),set(B),F3,A3)),aa(set(A),set(B),F3,B3))) ) ).

% mono_Int
tff(fact_7348_mono__Un,axiom,
    ! [B: $tType,A: $tType,F3: fun(set(A),set(B)),A3: set(A),B3: set(A)] :
      ( aa(fun(set(A),set(B)),$o,order_mono(set(A),set(B)),F3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),sup_sup(set(B)),aa(set(A),set(B),F3,A3)),aa(set(A),set(B),F3,B3))),aa(set(A),set(B),F3,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))) ) ).

% mono_Un
tff(fact_7349_rtranclp_Omono,axiom,
    ! [A: $tType,R: fun(A,fun(A,$o))] : aa(fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),$o,order_mono(fun(A,fun(A,$o)),fun(A,fun(A,$o))),aTP_Lamp_ahf(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),R)) ).

% rtranclp.mono
tff(fact_7350_tranclp_Omono,axiom,
    ! [A: $tType,R: fun(A,fun(A,$o))] : aa(fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),$o,order_mono(fun(A,fun(A,$o)),fun(A,fun(A,$o))),aTP_Lamp_ahg(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),R)) ).

% tranclp.mono
tff(fact_7351_int_Obi__total,axiom,
    bi_total(product_prod(nat,nat),int,pcr_int) ).

% int.bi_total
tff(fact_7352_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% remdups_adj_length
tff(fact_7353_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),remdups_adj(A,Xs)) ) ) ).

% sorted_remdups_adj
tff(fact_7354_remdups__adj__adjacent,axiom,
    ! [A: $tType,I: nat,Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I)),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)))
     => ( aa(nat,A,nth(A,remdups_adj(A,Xs)),I) != aa(nat,A,nth(A,remdups_adj(A,Xs)),aa(nat,nat,suc,I)) ) ) ).

% remdups_adj_adjacent
tff(fact_7355_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,suc,zero_zero(nat))),aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs))) ) ).

% remdups_adj_length_ge1
tff(fact_7356_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( aa(list(A),nat,size_size(list(A)),remdups_adj(A,Xs)) = aa(nat,nat,suc,zero_zero(nat)) )
    <=> ( ( Xs != nil(A) )
        & ( Xs = replicate(A,aa(list(A),nat,size_size(list(A)),Xs),hd(A,Xs)) ) ) ) ).

% remdups_adj_singleton_iff
tff(fact_7357_rat__sgn__code,axiom,
    ! [P2: rat] : ( quotient_of(aa(rat,rat,sgn_sgn(rat),P2)) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,sgn_sgn(int),aa(product_prod(int,int),int,product_fst(int,int),quotient_of(P2)))),one_one(int)) ) ).

% rat_sgn_code
tff(fact_7358_intind,axiom,
    ! [A: $tType,I: nat,N: nat,P: fun(A,$o),Xa: A] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),N)
     => ( aa(A,$o,P,Xa)
       => aa(A,$o,P,aa(nat,A,nth(A,replicate(A,N,Xa)),I)) ) ) ).

% intind
tff(fact_7359_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,Xa: A,N: nat,Y: A] :
      ( ( replicate(A,M,Xa) = replicate(A,N,Y) )
    <=> ( ( M = N )
        & ( ( M != zero_zero(nat) )
         => ( Xa = Y ) ) ) ) ).

% replicate_eq_replicate
tff(fact_7360_empty__replicate,axiom,
    ! [A: $tType,N: nat,Xa: A] :
      ( ( nil(A) = replicate(A,N,Xa) )
    <=> ( N = zero_zero(nat) ) ) ).

% empty_replicate
tff(fact_7361_replicate__empty,axiom,
    ! [A: $tType,N: nat,Xa: A] :
      ( ( replicate(A,N,Xa) = nil(A) )
    <=> ( N = zero_zero(nat) ) ) ).

% replicate_empty
tff(fact_7362_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: fun(A,$o)] :
      ( ! [X4: A] :
          ( member(A,X4,aa(list(A),set(A),set2(A),replicate(A,N,A2)))
         => aa(A,$o,P,X4) )
    <=> ( aa(A,$o,P,A2)
        | ( N = zero_zero(nat) ) ) ) ).

% Ball_set_replicate
tff(fact_7363_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: fun(A,$o)] :
      ( ? [X4: A] :
          ( member(A,X4,aa(list(A),set(A),set2(A),replicate(A,N,A2)))
          & aa(A,$o,P,X4) )
    <=> ( aa(A,$o,P,A2)
        & ( N != zero_zero(nat) ) ) ) ).

% Bex_set_replicate
tff(fact_7364_in__set__replicate,axiom,
    ! [A: $tType,Xa: A,N: nat,Y: A] :
      ( member(A,Xa,aa(list(A),set(A),set2(A),replicate(A,N,Y)))
    <=> ( ( Xa = Y )
        & ( N != zero_zero(nat) ) ) ) ).

% in_set_replicate
tff(fact_7365_hd__replicate,axiom,
    ! [A: $tType,N: nat,Xa: A] :
      ( ( N != zero_zero(nat) )
     => ( hd(A,replicate(A,N,Xa)) = Xa ) ) ).

% hd_replicate
tff(fact_7366_drop__replicate,axiom,
    ! [A: $tType,I: nat,K: nat,Xa: A] : ( drop(A,I,replicate(A,K,Xa)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),K),I),Xa) ) ).

% drop_replicate
tff(fact_7367_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,fun(A,A)),N: nat,Xa: B] : ( foldr(B,A,F3,replicate(B,N,Xa)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),aa(B,fun(A,A),F3,Xa)) ) ).

% foldr_replicate
tff(fact_7368_tl__replicate,axiom,
    ! [A: $tType,N: nat,Xa: A] : ( tl(A,replicate(A,N,Xa)) = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),Xa) ) ).

% tl_replicate
tff(fact_7369_set__replicate,axiom,
    ! [A: $tType,N: nat,Xa: A] :
      ( ( N != zero_zero(nat) )
     => ( aa(list(A),set(A),set2(A),replicate(A,N,Xa)) = aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))) ) ) ).

% set_replicate
tff(fact_7370_one__div__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( divide_divide(A,one_one(A),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_fst(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_div_numeral
tff(fact_7371_sorted__replicate,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [N: nat,Xa: A] : sorted_wrt(A,ord_less_eq(A),replicate(A,N,Xa)) ) ).

% sorted_replicate
tff(fact_7372_replicate__0,axiom,
    ! [A: $tType,Xa: A] : ( replicate(A,zero_zero(nat),Xa) = nil(A) ) ).

% replicate_0
tff(fact_7373_replicate__Suc,axiom,
    ! [A: $tType,N: nat,Xa: A] : ( replicate(A,aa(nat,nat,suc,N),Xa) = aa(list(A),list(A),cons(A,Xa),replicate(A,N,Xa)) ) ).

% replicate_Suc
tff(fact_7374_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,Xa: A] : ( replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M),Xa) = append(A,replicate(A,N,Xa),replicate(A,M,Xa)) ) ).

% replicate_add
tff(fact_7375_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [N: nat,C2: A] : ( aa(list(A),A,groups8242544230860333062m_list(A),replicate(A,N,C2)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),N)),C2) ) ) ).

% sum_list_replicate
tff(fact_7376_map__replicate__trivial,axiom,
    ! [A: $tType,Xa: A,I: nat] : ( map(nat,A,aTP_Lamp_ahh(A,fun(nat,A),Xa),upt(zero_zero(nat),I)) = replicate(A,I,Xa) ) ).

% map_replicate_trivial
tff(fact_7377_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,Xa: A] : ( aa(list(A),set(A),set2(A),replicate(A,aa(nat,nat,suc,N),Xa)) = aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))) ) ).

% set_replicate_Suc
tff(fact_7378_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,Xa: A] :
      ( aa(list(A),set(A),set2(A),replicate(A,N,Xa))
      = $ite(N = zero_zero(nat),bot_bot(set(A)),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) ) ).

% set_replicate_conv_if
tff(fact_7379_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,Xa: A] :
      ( remdups_adj(A,replicate(A,N,Xa))
      = $ite(N = zero_zero(nat),nil(A),aa(list(A),list(A),cons(A,Xa),nil(A))) ) ).

% remdups_adj_replicate
tff(fact_7380_subset__fst__imageI,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(B),S2: set(product_prod(A,B)),Y: B] :
      ( aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),B3))),S2)
     => ( member(B,Y,B3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),S2)) ) ) ).

% subset_fst_imageI
tff(fact_7381_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A2: A] : ( enumerate(A,N,replicate(A,M,A2)) = map(nat,product_prod(nat,A),aTP_Lamp_ahi(A,fun(nat,product_prod(nat,A)),A2),upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M))) ) ).

% enumerate_replicate_eq
tff(fact_7382_Cons__replicate__eq,axiom,
    ! [A: $tType,Xa: A,Xs: list(A),N: nat,Y: A] :
      ( ( aa(list(A),list(A),cons(A,Xa),Xs) = replicate(A,N,Y) )
    <=> ( ( Xa = Y )
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
        & ( Xs = replicate(A,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),one_one(nat)),Xa) ) ) ) ).

% Cons_replicate_eq
tff(fact_7383_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list(A),Ys: list(A)] :
      ( ( Xs != nil(A) )
     => ( ( Ys != nil(A) )
       => ( ( append(A,Xs,Ys) = append(A,Ys,Xs) )
         => ? [N2: nat,Zs2: list(A)] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),one_one(nat)),N2)
              & ( concat(A,replicate(list(A),N2,Zs2)) = append(A,Xs,Ys) ) ) ) ) ) ).

% comm_append_is_replicate
tff(fact_7384_bezw_Oelims,axiom,
    ! [Xa: nat,Xaa: nat,Y: product_prod(int,int)] :
      ( ( bezw(Xa,Xaa) = Y )
     => ( Y
        = $ite(Xaa = zero_zero(nat),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Xaa,modulo_modulo(nat,Xa,Xaa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xaa,modulo_modulo(nat,Xa,Xaa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xaa,modulo_modulo(nat,Xa,Xaa)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,Xa,Xaa)))))) ) ) ).

% bezw.elims
tff(fact_7385_bezw_Osimps,axiom,
    ! [Xa: nat,Y: nat] :
      ( bezw(Xa,Y)
      = $ite(Y = zero_zero(nat),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,Xa,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,Xa,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,Xa,Y)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,Xa,Y)))))) ) ).

% bezw.simps
tff(fact_7386_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( map(product_prod(nat,A),nat,product_fst(nat,A),enumerate(A,N,Xs)) = upt(N,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(list(A),nat,size_size(list(A)),Xs))) ) ).

% map_fst_enumerate
tff(fact_7387_Suc__0__div__numeral,axiom,
    ! [K: num] : ( divide_divide(nat,aa(nat,nat,suc,zero_zero(nat)),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_fst(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_div_numeral
tff(fact_7388_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [N: num] : ( modulo_modulo(A,one_one(A),aa(num,A,numeral_numeral(A),N)) = aa(product_prod(A,A),A,product_snd(A,A),unique8689654367752047608divmod(A,one2,N)) ) ) ).

% one_mod_numeral
tff(fact_7389_divides__aux__def,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Qr: product_prod(A,A)] :
          ( unique5940410009612947441es_aux(A,Qr)
        <=> ( aa(product_prod(A,A),A,product_snd(A,A),Qr) = zero_zero(A) ) ) ) ).

% divides_aux_def
tff(fact_7390_quotient__of__denom__pos_H,axiom,
    ! [R: rat] : aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),quotient_of(R))) ).

% quotient_of_denom_pos'
tff(fact_7391_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : sorted_wrt(nat,ord_less_eq(nat),map(product_prod(nat,A),nat,product_fst(nat,A),enumerate(A,N,Xs))) ).

% sorted_enumerate
tff(fact_7392_Eps__case__prod,axiom,
    ! [B: $tType,A: $tType,P: fun(A,fun(B,$o))] : ( fChoice(product_prod(A,B),product_case_prod(A,B,$o,P)) = fChoice(product_prod(A,B),aTP_Lamp_ahj(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),P)) ) ).

% Eps_case_prod
tff(fact_7393_rel__fun__Collect__case__prodD,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,A3: fun(A,fun(B,$o)),B3: fun(C,fun(D,$o)),F3: fun(A,C),G: fun(B,D),X6: set(product_prod(A,B)),Xa: product_prod(A,B)] :
      ( aa(fun(B,D),$o,aa(fun(A,C),fun(fun(B,D),$o),bNF_rel_fun(A,B,C,D,A3,B3),F3),G)
     => ( aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),X6),collect(product_prod(A,B),product_case_prod(A,B,$o,A3)))
       => ( member(product_prod(A,B),Xa,X6)
         => aa(D,$o,aa(C,fun(D,$o),B3,aa(product_prod(A,B),C,aa(fun(product_prod(A,B),A),fun(product_prod(A,B),C),comp(A,C,product_prod(A,B),F3),product_fst(A,B)),Xa)),aa(product_prod(A,B),D,aa(fun(product_prod(A,B),B),fun(product_prod(A,B),D),comp(B,D,product_prod(A,B),G),product_snd(A,B)),Xa)) ) ) ) ).

% rel_fun_Collect_case_prodD
tff(fact_7394_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X6: set(A),A3: set(product_prod(A,B)),Y6: set(B),P: fun(A,fun(B,$o)),Q: fun(A,fun(B,$o))] :
      ( ( X6 = aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),A3) )
     => ( ( Y6 = aa(set(product_prod(A,B)),set(B),image(product_prod(A,B),B,product_snd(A,B)),A3) )
       => ( ! [X: A] :
              ( member(A,X,X6)
             => ! [Xa4: B] :
                  ( member(B,Xa4,Y6)
                 => ( aa(B,$o,aa(A,fun(B,$o),P,X),Xa4)
                   => aa(B,$o,aa(A,fun(B,$o),Q,X),Xa4) ) ) )
         => ( aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),A3),collect(product_prod(A,B),product_case_prod(A,B,$o,P)))
           => aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),A3),collect(product_prod(A,B),product_case_prod(A,B,$o,Q))) ) ) ) ) ).

% Collect_split_mono_strong
tff(fact_7395_subset__snd__imageI,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(B),S2: set(product_prod(A,B)),Xa: A] :
      ( aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),product_Sigma(A,B,A3,aTP_Lamp_agb(set(B),fun(A,set(B)),B3))),S2)
     => ( member(A,Xa,A3)
       => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B3),aa(set(product_prod(A,B)),set(B),image(product_prod(A,B),B,product_snd(A,B)),S2)) ) ) ).

% subset_snd_imageI
tff(fact_7396_subset__fst__snd,axiom,
    ! [B: $tType,A: $tType,A3: set(product_prod(A,B))] : aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),A3),product_Sigma(A,B,aa(set(product_prod(A,B)),set(A),image(product_prod(A,B),A,product_fst(A,B)),A3),aTP_Lamp_ahk(set(product_prod(A,B)),fun(A,set(B)),A3))) ).

% subset_fst_snd
tff(fact_7397_quotient__of__unique,axiom,
    ! [R: rat] :
    ? [X: product_prod(int,int)] :
      ( ( R = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),X)),aa(product_prod(int,int),int,product_snd(int,int),X)) )
      & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),X))
      & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),X),aa(product_prod(int,int),int,product_snd(int,int),X))
      & ! [Y4: product_prod(int,int)] :
          ( ( ( R = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),Y4)),aa(product_prod(int,int),int,product_snd(int,int),Y4)) )
            & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),Y4))
            & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),Y4),aa(product_prod(int,int),int,product_snd(int,int),Y4)) )
         => ( Y4 = X ) ) ) ).

% quotient_of_unique
tff(fact_7398_predicate2__transferD,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R12: fun(A,fun(B,$o)),R23: fun(C,fun(D,$o)),P: fun(A,fun(C,$o)),Q: fun(B,fun(D,$o)),A2: product_prod(A,B),A3: set(product_prod(A,B)),B2: product_prod(C,D),B3: set(product_prod(C,D))] :
      ( aa(fun(B,fun(D,$o)),$o,aa(fun(A,fun(C,$o)),fun(fun(B,fun(D,$o)),$o),bNF_rel_fun(A,B,fun(C,$o),fun(D,$o),R12,bNF_rel_fun(C,D,$o,$o,R23,fequal($o))),P),Q)
     => ( member(product_prod(A,B),A2,A3)
       => ( member(product_prod(C,D),B2,B3)
         => ( aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),A3),collect(product_prod(A,B),product_case_prod(A,B,$o,R12)))
           => ( aa(set(product_prod(C,D)),$o,aa(set(product_prod(C,D)),fun(set(product_prod(C,D)),$o),ord_less_eq(set(product_prod(C,D))),B3),collect(product_prod(C,D),product_case_prod(C,D,$o,R23)))
             => ( aa(C,$o,aa(A,fun(C,$o),P,aa(product_prod(A,B),A,product_fst(A,B),A2)),aa(product_prod(C,D),C,product_fst(C,D),B2))
              <=> aa(D,$o,aa(B,fun(D,$o),Q,aa(product_prod(A,B),B,product_snd(A,B),A2)),aa(product_prod(C,D),D,product_snd(C,D),B2)) ) ) ) ) ) ) ).

% predicate2_transferD
tff(fact_7399_fun_Oin__rel,axiom,
    ! [B: $tType,C: $tType,A: $tType,R2: fun(B,fun(C,$o)),A2: fun(A,B),B2: fun(A,C)] :
      ( aa(fun(A,C),$o,aa(fun(A,B),fun(fun(A,C),$o),bNF_rel_fun(A,A,B,C,fequal(A),R2),A2),B2)
    <=> ? [Z7: fun(A,product_prod(B,C))] :
          ( member(fun(A,product_prod(B,C)),Z7,collect(fun(A,product_prod(B,C)),aTP_Lamp_ahl(fun(B,fun(C,$o)),fun(fun(A,product_prod(B,C)),$o),R2)))
          & ( aa(fun(A,product_prod(B,C)),fun(A,B),comp(product_prod(B,C),B,A,product_fst(B,C)),Z7) = A2 )
          & ( aa(fun(A,product_prod(B,C)),fun(A,C),comp(product_prod(B,C),C,A,product_snd(B,C)),Z7) = B2 ) ) ) ).

% fun.in_rel
tff(fact_7400_quotient__of__def,axiom,
    ! [Xa: rat] : ( quotient_of(Xa) = the(product_prod(int,int),aTP_Lamp_ahm(rat,fun(product_prod(int,int),$o),Xa)) ) ).

% quotient_of_def
tff(fact_7401_bezw__non__0,axiom,
    ! [Y: nat,Xa: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Y)
     => ( bezw(Xa,Y) = aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,Xa,Y)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Y,modulo_modulo(nat,Xa,Y)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Y,modulo_modulo(nat,Xa,Y)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,Xa,Y))))) ) ) ).

% bezw_non_0
tff(fact_7402_bezw_Opelims,axiom,
    ! [Xa: nat,Xaa: nat,Y: product_prod(int,int)] :
      ( ( bezw(Xa,Xaa) = Y )
     => ( aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),Xaa))
       => ~ ( ( Y
              = $ite(Xaa = zero_zero(nat),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),zero_zero(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),bezw(Xaa,modulo_modulo(nat,Xa,Xaa)))),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xaa,modulo_modulo(nat,Xa,Xaa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xaa,modulo_modulo(nat,Xa,Xaa)))),aa(nat,int,semiring_1_of_nat(int),divide_divide(nat,Xa,Xaa)))))) )
           => ~ aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),bezw_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),Xaa)) ) ) ) ).

% bezw.pelims
tff(fact_7403_one__mod__minus__numeral,axiom,
    ! [N: num] : ( modulo_modulo(int,one_one(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,uminus_uminus(int),adjust_mod(aa(num,int,numeral_numeral(int),N),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,N)))) ) ).

% one_mod_minus_numeral
tff(fact_7404_Suc__0__mod__numeral,axiom,
    ! [K: num] : ( modulo_modulo(nat,aa(nat,nat,suc,zero_zero(nat)),aa(num,nat,numeral_numeral(nat),K)) = aa(product_prod(nat,nat),nat,product_snd(nat,nat),unique8689654367752047608divmod(nat,one2,K)) ) ).

% Suc_0_mod_numeral
tff(fact_7405_minus__one__mod__numeral,axiom,
    ! [N: num] : ( modulo_modulo(int,aa(int,int,uminus_uminus(int),one_one(int)),aa(num,int,numeral_numeral(int),N)) = adjust_mod(aa(num,int,numeral_numeral(int),N),aa(product_prod(int,int),int,product_snd(int,int),unique8689654367752047608divmod(int,one2,N))) ) ).

% minus_one_mod_numeral
tff(fact_7406_Divides_Oadjust__mod__def,axiom,
    ! [L: int,R: int] :
      ( adjust_mod(L,R)
      = $ite(R = zero_zero(int),zero_zero(int),aa(int,int,aa(int,fun(int,int),minus_minus(int),L),R)) ) ).

% Divides.adjust_mod_def
tff(fact_7407_in__set__enumerate__eq,axiom,
    ! [A: $tType,P2: product_prod(nat,A),N: nat,Xs: list(A)] :
      ( member(product_prod(nat,A),P2,aa(list(product_prod(nat,A)),set(product_prod(nat,A)),set2(product_prod(nat,A)),enumerate(A,N,Xs)))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),aa(product_prod(nat,A),nat,product_fst(nat,A),P2))
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P2)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(A),nat,size_size(list(A)),Xs)),N))
        & ( aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(product_prod(nat,A),nat,product_fst(nat,A),P2)),N)) = aa(product_prod(nat,A),A,product_snd(nat,A),P2) ) ) ) ).

% in_set_enumerate_eq
tff(fact_7408_size__prod__simp,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,nat),G: fun(B,nat),P2: product_prod(A,B)] : ( basic_BNF_size_prod(A,B,F3,G,P2) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,F3,aa(product_prod(A,B),A,product_fst(A,B),P2))),aa(B,nat,G,aa(product_prod(A,B),B,product_snd(A,B),P2)))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% size_prod_simp
tff(fact_7409_Rat_Opositive_Orep__eq,axiom,
    ! [Xa: rat] :
      ( aa(rat,$o,positive,Xa)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),aa(rat,product_prod(int,int),rep_Rat,Xa))),aa(product_prod(int,int),int,product_snd(int,int),aa(rat,product_prod(int,int),rep_Rat,Xa)))) ) ).

% Rat.positive.rep_eq
tff(fact_7410_Rat_Opositive__def,axiom,
    positive = aa(fun(product_prod(int,int),$o),fun(rat,$o),map_fun(rat,product_prod(int,int),$o,$o,rep_Rat,id($o)),aTP_Lamp_ahn(product_prod(int,int),$o)) ).

% Rat.positive_def
tff(fact_7411_normalize__def,axiom,
    ! [P2: product_prod(int,int)] :
      ( normalize(P2)
      = $ite(
          aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),P2)),
          $let(
            a2: int,
            a2 := aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2)),
            aa(int,product_prod(int,int),product_Pair(int,int,divide_divide(int,aa(product_prod(int,int),int,product_fst(int,int),P2),a2)),divide_divide(int,aa(product_prod(int,int),int,product_snd(int,int),P2),a2)) ),
          $ite(
            aa(product_prod(int,int),int,product_snd(int,int),P2) = zero_zero(int),
            aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),
            $let(
              a2: int,
              a2 := aa(int,int,uminus_uminus(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(product_prod(int,int),int,product_fst(int,int),P2)),aa(product_prod(int,int),int,product_snd(int,int),P2))),
              aa(int,product_prod(int,int),product_Pair(int,int,divide_divide(int,aa(product_prod(int,int),int,product_fst(int,int),P2),a2)),divide_divide(int,aa(product_prod(int,int),int,product_snd(int,int),P2),a2)) ) ) ) ) ).

% normalize_def
tff(fact_7412_gcd__left__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_left_idem
tff(fact_7413_gcd__right__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_right_idem
tff(fact_7414_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = zero_zero(A) )
        <=> ( ( A2 = zero_zero(A) )
            & ( B2 = zero_zero(A) ) ) ) ) ).

% gcd_eq_0_iff
tff(fact_7415_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),one_one(A)),A2) = one_one(A) ) ) ).

% gcd.bottom_left_bottom
tff(fact_7416_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),one_one(A)) = one_one(A) ) ) ).

% gcd.bottom_right_bottom
tff(fact_7417_gcd__add2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),aa(A,A,aa(A,fun(A,A),plus_plus(A),M),N)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_add2
tff(fact_7418_gcd__add1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),M),N)),N) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_add1
tff(fact_7419_gcd__neg2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,uminus_uminus(A),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_neg2
tff(fact_7420_gcd__neg1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,uminus_uminus(A),A2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% gcd_neg1
tff(fact_7421_gcd__exp,axiom,
    ! [A: $tType] :
      ( semiri6843258321239162965malize(A)
     => ! [A2: A,N: nat,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),A2),N)),aa(nat,A,aa(A,fun(nat,A),power_power(A),B2),N)) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),N) ) ) ).

% gcd_exp
tff(fact_7422_gcd__greatest__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2))
        <=> ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
            & aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ) ).

% gcd_greatest_iff
tff(fact_7423_gcd__dvd2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),B2) ) ).

% gcd_dvd2
tff(fact_7424_gcd__dvd1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),A2) ) ).

% gcd_dvd1
tff(fact_7425_gcd__1__int,axiom,
    ! [M: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),one_one(int)) = one_one(int) ) ).

% gcd_1_int
tff(fact_7426_gcd__neg2__int,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),aa(int,int,uminus_uminus(int),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) ) ).

% gcd_neg2_int
tff(fact_7427_gcd__neg1__int,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),Xa)),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) ) ).

% gcd_neg1_int
tff(fact_7428_gcd__abs2__int,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),aa(int,int,abs_abs(int),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) ) ).

% gcd_abs2_int
tff(fact_7429_gcd__abs1__int,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,abs_abs(int),Xa)),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) ) ).

% gcd_abs1_int
tff(fact_7430_abs__gcd__int,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,abs_abs(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) ) ).

% abs_gcd_int
tff(fact_7431_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [A2: A,N: num] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(num,A,numeral_numeral(A),N)) ) ) ).

% gcd_neg_numeral_2
tff(fact_7432_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [N: num,A2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,uminus_uminus(A),aa(num,A,numeral_numeral(A),N))),A2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(num,A,numeral_numeral(A),N)),A2) ) ) ).

% gcd_neg_numeral_1
tff(fact_7433_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),one_one(A))
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) ) ) ) ).

% is_unit_gcd_iff
tff(fact_7434_coprime__imp__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) ) ) ) ).

% coprime_imp_gcd_eq_1
tff(fact_7435_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),N))
    <=> ( ( M != zero_zero(int) )
        | ( N != zero_zero(int) ) ) ) ).

% gcd_pos_int
tff(fact_7436_Gcd__insert,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,A3: set(A)] : ( gcd_Gcd(A,aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),gcd_Gcd(A,A3)) ) ) ).

% Gcd_insert
tff(fact_7437_gcd__neg__numeral__2__int,axiom,
    ! [Xa: int,N: num] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),aa(num,int,numeral_numeral(int),N)) ) ).

% gcd_neg_numeral_2_int
tff(fact_7438_gcd__neg__numeral__1__int,axiom,
    ! [N: num,Xa: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),aa(num,int,numeral_numeral(int),N))),Xa) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(num,int,numeral_numeral(int),N)),Xa) ) ).

% gcd_neg_numeral_1_int
tff(fact_7439_gcd__0__int,axiom,
    ! [Xa: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),zero_zero(int)) = aa(int,int,abs_abs(int),Xa) ) ).

% gcd_0_int
tff(fact_7440_gcd__0__left__int,axiom,
    ! [Xa: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),zero_zero(int)),Xa) = aa(int,int,abs_abs(int),Xa) ) ).

% gcd_0_left_int
tff(fact_7441_gcd__proj1__if__dvd__int,axiom,
    ! [Xa: int,Y: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Xa),Y)
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) = aa(int,int,abs_abs(int),Xa) ) ) ).

% gcd_proj1_if_dvd_int
tff(fact_7442_gcd__proj2__if__dvd__int,axiom,
    ! [Y: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Y),Xa)
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) = aa(int,int,abs_abs(int),Y) ) ) ).

% gcd_proj2_if_dvd_int
tff(fact_7443_is__unit__gcd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),one_one(A))
        <=> algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% is_unit_gcd
tff(fact_7444_Gcd__2,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A2: A,B2: A] : ( gcd_Gcd(A,aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ).

% Gcd_2
tff(fact_7445_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),D2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),A2)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),D2),B2)
        & ! [E3: int] :
            ( ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),A2)
              & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),B2) )
           => aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),E3),D2) ) )
    <=> ( D2 = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2) ) ) ).

% gcd_unique_int
tff(fact_7446_gcd__integer_Orsp,axiom,
    aa(fun(int,fun(int,int)),$o,aa(fun(int,fun(int,int)),fun(fun(int,fun(int,int)),$o),bNF_rel_fun(int,int,fun(int,int),fun(int,int),fequal(int),bNF_rel_fun(int,int,int,int,fequal(int),fequal(int))),gcd_gcd(int)),gcd_gcd(int)) ).

% gcd_integer.rsp
tff(fact_7447_gcd__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,A5: A,B5: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) != zero_zero(A) )
         => ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),A5),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
           => ( ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),B5),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
             => algebr8660921524188924756oprime(A,A5,B5) ) ) ) ) ).

% gcd_coprime
tff(fact_7448_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) != zero_zero(A) )
         => ? [A18: A,B6: A] :
              ( ( A2 = aa(A,A,aa(A,fun(A,A),times_times(A),A18),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
              & ( B2 = aa(A,A,aa(A,fun(A,A),times_times(A),B6),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) )
              & algebr8660921524188924756oprime(A,A18,B6) ) ) ) ).

% gcd_coprime_exists
tff(fact_7449_div__gcd__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( ( A2 != zero_zero(A) )
            | ( B2 != zero_zero(A) ) )
         => algebr8660921524188924756oprime(A,divide_divide(A,A2,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),divide_divide(A,B2,aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2))) ) ) ).

% div_gcd_coprime
tff(fact_7450_gcd__mult__right__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),B2),C2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_right_right_cancel
tff(fact_7451_gcd__mult__right__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),B2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_right_left_cancel
tff(fact_7452_gcd__mult__left__right__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A2: A] :
          ( algebr8660921524188924756oprime(A,B2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),A2),C2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_left_right_cancel
tff(fact_7453_gcd__mult__left__left__cancel,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A2: A] :
          ( algebr8660921524188924756oprime(A,B2,C2)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) ) ) ) ).

% gcd_mult_left_left_cancel
tff(fact_7454_coprime__iff__gcd__eq__1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( algebr8660921524188924756oprime(A,A2,B2)
        <=> ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) ) ) ) ).

% coprime_iff_gcd_eq_1
tff(fact_7455_gcd__eq__1__imp__coprime,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] :
          ( ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = one_one(A) )
         => algebr8660921524188924756oprime(A,A2,B2) ) ) ).

% gcd_eq_1_imp_coprime
tff(fact_7456_gcd__cases__int,axiom,
    ! [Xa: int,Y: int,P: fun(int,$o)] :
      ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
       => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
         => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y)) ) )
     => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Xa)
         => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),zero_zero(int))
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),aa(int,int,uminus_uminus(int),Y))) ) )
       => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),zero_zero(int))
           => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),Y)
             => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),Xa)),Y)) ) )
         => ( ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Xa),zero_zero(int))
             => ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Y),zero_zero(int))
               => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,uminus_uminus(int),Xa)),aa(int,int,uminus_uminus(int),Y))) ) )
           => aa(int,$o,P,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y)) ) ) ) ) ).

% gcd_cases_int
tff(fact_7457_gcd__ge__0__int,axiom,
    ! [Xa: int,Y: int] : aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y)) ).

% gcd_ge_0_int
tff(fact_7458_gcd__diff1,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [M: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),M),N)),N) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_diff1
tff(fact_7459_gcd__diff2,axiom,
    ! [A: $tType] :
      ( ring_gcd(A)
     => ! [N: A,M: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),N),M)),N) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_diff2
tff(fact_7460_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),divide_divide(A,B2,A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit1
tff(fact_7461_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),divide_divide(A,C2,A2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_div_unit2
tff(fact_7462_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit1
tff(fact_7463_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2) ) ) ) ).

% gcd_mult_unit2
tff(fact_7464_bezout__int,axiom,
    ! [Xa: int,Y: int] :
    ? [U5: int,V4: int] : ( aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),U5),Xa)),aa(int,int,aa(int,fun(int,int),times_times(int),V4),Y)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) ) ).

% bezout_int
tff(fact_7465_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,K: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),times_times(A),K),B2)) ) ).

% gcd_dvd_prod
tff(fact_7466_gcd__idem__int,axiom,
    ! [Xa: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Xa) = aa(int,int,abs_abs(int),Xa) ) ).

% gcd_idem_int
tff(fact_7467_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [M: A,K: A,N: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),K),M)),N)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),M),N) ) ) ).

% gcd_add_mult
tff(fact_7468_gcd__dvd__antisym,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2))
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2))
           => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2) ) ) ) ) ).

% gcd_dvd_antisym
tff(fact_7469_gcd__greatest,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [C2: A,A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),A2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),B2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),C2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)) ) ) ) ).

% gcd_greatest
tff(fact_7470_gcd__dvdI2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,C2: A,A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),C2) ) ) ).

% gcd_dvdI2
tff(fact_7471_gcd__dvdI1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),C2) ) ) ).

% gcd_dvdI1
tff(fact_7472_dvd__gcdD2,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2) ) ) ).

% dvd_gcdD2
tff(fact_7473_dvd__gcdD1,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2))
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ).

% dvd_gcdD1
tff(fact_7474_gcd__mono,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),C2)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),D2)
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),C2),D2)) ) ) ) ).

% gcd_mono
tff(fact_7475_gcd_Oassoc,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2)),C2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2)) ) ) ).

% gcd.assoc
tff(fact_7476_gcd_Ocommute,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,B2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),B2) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),A2) ) ) ).

% gcd.commute
tff(fact_7477_gcd_Oleft__commute,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,A2: A,C2: A] : ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),C2)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(A,A,aa(A,fun(A,A),gcd_gcd(A),B2),C2)) ) ) ).

% gcd.left_commute
tff(fact_7478_gcd__red__int,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Y),modulo_modulo(int,Xa,Y)) ) ).

% gcd_red_int
tff(fact_7479_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N: int] : ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,abs_abs(int),K)),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),N)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(int,int,aa(int,fun(int,int),times_times(int),K),M)),aa(int,int,aa(int,fun(int,int),times_times(int),K),N)) ) ).

% gcd_mult_distrib_int
tff(fact_7480_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),B2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2)),B2) ) ).

% gcd_le2_int
tff(fact_7481_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),A2)
     => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),gcd_gcd(int),A2),B2)),A2) ) ).

% gcd_le1_int
tff(fact_7482_gcd__non__0__int,axiom,
    ! [Y: int,Xa: int] :
      ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),Y)
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Y),modulo_modulo(int,Xa,Y)) ) ) ).

% gcd_non_0_int
tff(fact_7483_gcd__code__int,axiom,
    ! [K: int,L: int] :
      ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),K),L)
      = aa(int,int,abs_abs(int),$ite(L = zero_zero(int),K,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),L),modulo_modulo(int,aa(int,int,abs_abs(int),K),aa(int,int,abs_abs(int),L))))) ) ).

% gcd_code_int
tff(fact_7484_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M: int] :
      ( ( N != zero_zero(int) )
     => ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),M),N) = aa(set(int),int,lattic643756798349783984er_Max(int),collect(int,aa(int,fun(int,$o),aTP_Lamp_aho(int,fun(int,fun(int,$o)),N),M))) ) ) ).

% gcd_is_Max_divisors_int
tff(fact_7485_plus__rat_Otransfer,axiom,
    aa(fun(rat,fun(rat,rat)),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),$o),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_ahp(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),plus_plus(rat)) ).

% plus_rat.transfer
tff(fact_7486_inverse__rat_Otransfer,axiom,
    aa(fun(rat,rat),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(rat,rat),$o),bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat),aTP_Lamp_ahq(product_prod(int,int),product_prod(int,int))),inverse_inverse(rat)) ).

% inverse_rat.transfer
tff(fact_7487_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = zero_zero(nat) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.eq_neutr_iff
tff(fact_7488_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),A2) = A2 ) ).

% gcd_nat.left_neutral
tff(fact_7489_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( zero_zero(nat) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) )
    <=> ( ( A2 = zero_zero(nat) )
        & ( B2 = zero_zero(nat) ) ) ) ).

% gcd_nat.neutr_eq_iff
tff(fact_7490_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),zero_zero(nat)) = A2 ) ).

% gcd_nat.right_neutral
tff(fact_7491_gcd__0__nat,axiom,
    ! [Xa: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),zero_zero(nat)) = Xa ) ).

% gcd_0_nat
tff(fact_7492_gcd__0__left__nat,axiom,
    ! [Xa: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),zero_zero(nat)),Xa) = Xa ) ).

% gcd_0_left_nat
tff(fact_7493_gcd__1__nat,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),one_one(nat)) = one_one(nat) ) ).

% gcd_1_nat
tff(fact_7494_gcd__nat_Oabsorb1,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = A2 ) ) ).

% gcd_nat.absorb1
tff(fact_7495_gcd__nat_Oabsorb2,axiom,
    ! [B2: nat,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = B2 ) ) ).

% gcd_nat.absorb2
tff(fact_7496_gcd__nat_Obounded__iff,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2))
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2) ) ) ).

% gcd_nat.bounded_iff
tff(fact_7497_gcd__proj1__if__dvd__nat,axiom,
    ! [Xa: nat,Y: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Xa),Y)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Y) = Xa ) ) ).

% gcd_proj1_if_dvd_nat
tff(fact_7498_gcd__proj2__if__dvd__nat,axiom,
    ! [Y: nat,Xa: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Y),Xa)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Y) = Y ) ) ).

% gcd_proj2_if_dvd_nat
tff(fact_7499_gcd__Suc__0,axiom,
    ! [M: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),aa(nat,nat,suc,zero_zero(nat))) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% gcd_Suc_0
tff(fact_7500_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N))
    <=> ( ( M != zero_zero(nat) )
        | ( N != zero_zero(nat) ) ) ) ).

% gcd_pos_nat
tff(fact_7501_gcd__int__int__eq,axiom,
    ! [M: nat,N: nat] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(nat,int,semiring_1_of_nat(int),M)),aa(nat,int,semiring_1_of_nat(int),N)) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N)) ) ).

% gcd_int_int_eq
tff(fact_7502_gcd__nat__abs__right__eq,axiom,
    ! [N: nat,K: int] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),N),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),aa(nat,int,semiring_1_of_nat(int),N)),K)) ) ).

% gcd_nat_abs_right_eq
tff(fact_7503_gcd__nat__abs__left__eq,axiom,
    ! [K: int,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),K))),N) = aa(int,nat,nat2,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),K),aa(nat,int,semiring_1_of_nat(int),N))) ) ).

% gcd_nat_abs_left_eq
tff(fact_7504_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),A2) ) ).

% gcd_le1_nat
tff(fact_7505_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2 != zero_zero(nat) )
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),B2) ) ).

% gcd_le2_nat
tff(fact_7506_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),M)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),M),N)),N) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N) ) ) ).

% gcd_diff1_nat
tff(fact_7507_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),N),M)),N) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N) ) ) ).

% gcd_diff2_nat
tff(fact_7508_Gcd__in,axiom,
    ! [A3: set(nat)] :
      ( ! [A4: nat,B4: nat] :
          ( member(nat,A4,A3)
         => ( member(nat,B4,A3)
           => member(nat,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A4),B4),A3) ) )
     => ( ( A3 != bot_bot(set(nat)) )
       => member(nat,gcd_Gcd(nat,A3),A3) ) ) ).

% Gcd_in
tff(fact_7509_gcd__code__integer,axiom,
    ! [K: code_integer,L: code_integer] :
      ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),K),L)
      = aa(code_integer,code_integer,abs_abs(code_integer),$ite(L = zero_zero(code_integer),K,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),L),modulo_modulo(code_integer,aa(code_integer,code_integer,abs_abs(code_integer),K),aa(code_integer,code_integer,abs_abs(code_integer),L))))) ) ).

% gcd_code_integer
tff(fact_7510_gcd__non__0__nat,axiom,
    ! [Y: nat,Xa: nat] :
      ( ( Y != zero_zero(nat) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Y) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y),modulo_modulo(nat,Xa,Y)) ) ) ).

% gcd_non_0_nat
tff(fact_7511_gcd__nat_Osimps,axiom,
    ! [Xa: nat,Y: nat] :
      ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Y)
      = $ite(Y = zero_zero(nat),Xa,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y),modulo_modulo(nat,Xa,Y))) ) ).

% gcd_nat.simps
tff(fact_7512_gcd__nat_Oelims,axiom,
    ! [Xa: nat,Xaa: nat,Y: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Xaa) = Y )
     => ( Y
        = $ite(Xaa = zero_zero(nat),Xa,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xaa),modulo_modulo(nat,Xa,Xaa))) ) ) ).

% gcd_nat.elims
tff(fact_7513_gcd__integer_Orep__eq,axiom,
    ! [Xa: code_integer,Xaa: code_integer] : ( code_int_of_integer(aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),Xa),Xaa)) = aa(int,int,aa(int,fun(int,int),gcd_gcd(int),code_int_of_integer(Xa)),code_int_of_integer(Xaa)) ) ).

% gcd_integer.rep_eq
tff(fact_7514_gcd__integer_Oabs__eq,axiom,
    ! [Xa: int,Xb: int] : ( aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),gcd_gcd(code_integer),aa(int,code_integer,code_integer_of_int,Xa)),aa(int,code_integer,code_integer_of_int,Xb)) = aa(int,code_integer,code_integer_of_int,aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Xb)) ) ).

% gcd_integer.abs_eq
tff(fact_7515_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),M)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),K),N)) ) ).

% gcd_mult_distrib_nat
tff(fact_7516_gcd__red__nat,axiom,
    ! [Xa: nat,Y: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Y) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Y),modulo_modulo(nat,Xa,Y)) ) ).

% gcd_red_nat
tff(fact_7517_gcd__nat_Omono,axiom,
    ! [A2: nat,C2: nat,B2: nat,D2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),D2)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),C2),D2)) ) ) ).

% gcd_nat.mono
tff(fact_7518_gcd__nat_OorderE,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ).

% gcd_nat.orderE
tff(fact_7519_gcd__nat_OorderI,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) )
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2) ) ).

% gcd_nat.orderI
tff(fact_7520_gcd__nat_Oabsorb3,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = A2 ) ) ).

% gcd_nat.absorb3
tff(fact_7521_gcd__nat_Oabsorb4,axiom,
    ! [B2: nat,A2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
        & ( B2 != A2 ) )
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = B2 ) ) ).

% gcd_nat.absorb4
tff(fact_7522_gcd__nat_OboundedE,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2))
     => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
         => ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2) ) ) ).

% gcd_nat.boundedE
tff(fact_7523_gcd__nat_OboundedI,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
       => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2)) ) ) ).

% gcd_nat.boundedI
tff(fact_7524_gcd__nat_Oorder__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
    <=> ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ).

% gcd_nat.order_iff
tff(fact_7525_gcd__nat_Ocobounded1,axiom,
    ! [A2: nat,B2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),A2) ).

% gcd_nat.cobounded1
tff(fact_7526_gcd__nat_Ocobounded2,axiom,
    ! [A2: nat,B2: nat] : aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),B2) ).

% gcd_nat.cobounded2
tff(fact_7527_gcd__nat_Oabsorb__iff1,axiom,
    ! [A2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = A2 ) ) ).

% gcd_nat.absorb_iff1
tff(fact_7528_gcd__nat_Oabsorb__iff2,axiom,
    ! [B2: nat,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),A2)
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) = B2 ) ) ).

% gcd_nat.absorb_iff2
tff(fact_7529_gcd__nat_OcoboundedI1,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2) ) ).

% gcd_nat.coboundedI1
tff(fact_7530_gcd__nat_OcoboundedI2,axiom,
    ! [B2: nat,C2: nat,A2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
     => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2) ) ).

% gcd_nat.coboundedI2
tff(fact_7531_gcd__nat_Ostrict__boundedE,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2))
        & ( A2 != aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),B2),C2) ) )
     => ~ ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
            & ( A2 != B2 ) )
         => ~ ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
              & ( A2 != C2 ) ) ) ) ).

% gcd_nat.strict_boundedE
tff(fact_7532_gcd__nat_Ostrict__order__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),B2)
        & ( A2 != B2 ) )
    <=> ( ( A2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) )
        & ( A2 != B2 ) ) ) ).

% gcd_nat.strict_order_iff
tff(fact_7533_gcd__nat_Ostrict__coboundedI1,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),A2),C2)
        & ( A2 != C2 ) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2)
        & ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) != C2 ) ) ) ).

% gcd_nat.strict_coboundedI1
tff(fact_7534_gcd__nat_Ostrict__coboundedI2,axiom,
    ! [B2: nat,C2: nat,A2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),B2),C2)
        & ( B2 != C2 ) )
     => ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),C2)
        & ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) != C2 ) ) ) ).

% gcd_nat.strict_coboundedI2
tff(fact_7535_gcd__unique__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),A2)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),D2),B2)
        & ! [E3: nat] :
            ( ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),E3),A2)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),E3),B2) )
           => aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),E3),D2) ) )
    <=> ( D2 = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ).

% gcd_unique_nat
tff(fact_7536_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X: nat,Y3: nat] :
      ( ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y3)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) )
      | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y3)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X))
        & ( aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),X)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),Y3)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ) ) ).

% bezout_gcd_nat'
tff(fact_7537_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2 != zero_zero(nat) )
     => ? [X: nat,Y3: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),A2),X) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),B2),Y3)),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)) ) ) ).

% bezout_nat
tff(fact_7538_gcd__int__def,axiom,
    ! [Xa: int,Y: int] : ( aa(int,int,aa(int,fun(int,int),gcd_gcd(int),Xa),Y) = aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(int,nat,nat2,aa(int,int,abs_abs(int),Xa))),aa(int,nat,nat2,aa(int,int,abs_abs(int),Y)))) ) ).

% gcd_int_def
tff(fact_7539_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    semila1105856199041335345_order(nat,gcd_gcd(nat),zero_zero(nat),dvd_dvd(nat),aTP_Lamp_ahr(nat,fun(nat,$o))) ).

% gcd_nat.semilattice_neutr_order_axioms
tff(fact_7540_one__rat_Otransfer,axiom,
    aa(rat,$o,aa(product_prod(int,int),fun(rat,$o),pcr_rat,aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))),one_one(rat)) ).

% one_rat.transfer
tff(fact_7541_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),N)
     => ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),M),N) = aa(set(nat),nat,lattic643756798349783984er_Max(nat),collect(nat,aa(nat,fun(nat,$o),aTP_Lamp_ahs(nat,fun(nat,fun(nat,$o)),N),M))) ) ) ).

% gcd_is_Max_divisors_nat
tff(fact_7542_zero__rat_Otransfer,axiom,
    aa(rat,$o,aa(product_prod(int,int),fun(rat,$o),pcr_rat,aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))),zero_zero(rat)) ).

% zero_rat.transfer
tff(fact_7543_Fract_Otransfer,axiom,
    aa(fun(int,fun(int,rat)),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,rat)),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,rat),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),rat,fequal(int),pcr_rat)),aTP_Lamp_aht(int,fun(int,product_prod(int,int)))),fract) ).

% Fract.transfer
tff(fact_7544_bezw__aux,axiom,
    ! [Xa: nat,Y: nat] : ( aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Y)) = aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),bezw(Xa,Y))),aa(nat,int,semiring_1_of_nat(int),Xa))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),bezw(Xa,Y))),aa(nat,int,semiring_1_of_nat(int),Y))) ) ).

% bezw_aux
tff(fact_7545_times__rat_Otransfer,axiom,
    aa(fun(rat,fun(rat,rat)),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(rat,fun(rat,rat)),$o),bNF_rel_fun(product_prod(int,int),rat,fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),pcr_rat,bNF_rel_fun(product_prod(int,int),rat,product_prod(int,int),rat,pcr_rat,pcr_rat)),aTP_Lamp_ahu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),times_times(rat)) ).

% times_rat.transfer
tff(fact_7546_Rat_Opositive_Otransfer,axiom,
    aa(fun(rat,$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(rat,$o),$o),bNF_rel_fun(product_prod(int,int),rat,$o,$o,pcr_rat,fequal($o)),aTP_Lamp_ahn(product_prod(int,int),$o)),positive) ).

% Rat.positive.transfer
tff(fact_7547_gcd__nat_Opelims,axiom,
    ! [Xa: nat,Xaa: nat,Y: nat] :
      ( ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Xaa) = Y )
     => ( aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),Xaa))
       => ~ ( ( Y
              = $ite(Xaa = zero_zero(nat),Xa,aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xaa),modulo_modulo(nat,Xa,Xaa))) )
           => ~ aa(product_prod(nat,nat),$o,accp(product_prod(nat,nat),gcd_nat_rel),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Xa),Xaa)) ) ) ) ).

% gcd_nat.pelims
tff(fact_7548_nths__def,axiom,
    ! [A: $tType,Xs: list(A),A3: set(nat)] : ( nths(A,Xs,A3) = map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_ahv(set(nat),fun(product_prod(A,nat),$o),A3),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_def
tff(fact_7549_gcd__nat_Oidem,axiom,
    ! [A2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),A2) = A2 ) ).

% gcd_nat.idem
tff(fact_7550_gcd__nat_Oleft__idem,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ).

% gcd_nat.left_idem
tff(fact_7551_gcd__nat_Oright__idem,axiom,
    ! [A2: nat,B2: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2)),B2) = aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),A2),B2) ) ).

% gcd_nat.right_idem
tff(fact_7552_gcd__idem__nat,axiom,
    ! [Xa: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),gcd_gcd(nat),Xa),Xa) = Xa ) ).

% gcd_idem_nat
tff(fact_7553_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: fun(nat,$o),Xs: list(A),Is: list(nat)] : ( map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_ahw(fun(nat,$o),fun(product_prod(A,nat),$o),P),zip(A,nat,Xs,Is))) = map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_ahx(fun(nat,$o),fun(product_prod(A,nat),$o),P),zip(A,nat,Xs,map(nat,nat,suc,Is)))) ) ).

% nths_shift_lemma_Suc
tff(fact_7554_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set(nat),Xs: list(A),I: nat] : ( map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aTP_Lamp_ahv(set(nat),fun(product_prod(A,nat),$o),A3),zip(A,nat,Xs,upt(I,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),I),aa(list(A),nat,size_size(list(A)),Xs)))))) = map(product_prod(A,nat),A,product_fst(A,nat),filter2(product_prod(A,nat),aa(nat,fun(product_prod(A,nat),$o),aTP_Lamp_ahy(set(nat),fun(nat,fun(product_prod(A,nat),$o)),A3),I),zip(A,nat,Xs,upt(zero_zero(nat),aa(list(A),nat,size_size(list(A)),Xs))))) ) ).

% nths_shift_lemma
tff(fact_7555_list_Oin__rel,axiom,
    ! [A: $tType,B: $tType,R2: fun(A,fun(B,$o)),A2: list(A),B2: list(B)] :
      ( aa(list(B),$o,aa(list(A),fun(list(B),$o),list_all2(A,B,R2),A2),B2)
    <=> ? [Z7: list(product_prod(A,B))] :
          ( member(list(product_prod(A,B)),Z7,collect(list(product_prod(A,B)),aTP_Lamp_ahz(fun(A,fun(B,$o)),fun(list(product_prod(A,B)),$o),R2)))
          & ( map(product_prod(A,B),A,product_fst(A,B),Z7) = A2 )
          & ( map(product_prod(A,B),B,product_snd(A,B),Z7) = B2 ) ) ) ).

% list.in_rel
tff(fact_7556_independent__explicit__finite__subsets,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A)] :
          ( ~ real_V358717886546972837endent(A,A3)
        <=> ! [S9: set(A)] :
              ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S9),A3)
             => ( aa(set(A),$o,finite_finite(A),S9)
               => ! [U6: fun(A,real)] :
                    ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),U6)),S9) = zero_zero(A) )
                   => ! [X4: A] :
                        ( member(A,X4,S9)
                       => ( aa(A,real,U6,X4) = zero_zero(real) ) ) ) ) ) ) ) ).

% independent_explicit_finite_subsets
tff(fact_7557_dependent__single,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A] :
          ( real_V358717886546972837endent(A,aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))
        <=> ( Xa = zero_zero(A) ) ) ) ).

% dependent_single
tff(fact_7558_dependent__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A)] :
          ( member(A,zero_zero(A),A3)
         => real_V358717886546972837endent(A,A3) ) ) ).

% dependent_zero
tff(fact_7559_list_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R2: fun(A,fun(B,$o)),Ra: fun(A,fun(B,$o))] :
      ( aa(fun(A,fun(B,$o)),$o,aa(fun(A,fun(B,$o)),fun(fun(A,fun(B,$o)),$o),ord_less_eq(fun(A,fun(B,$o))),R2),Ra)
     => aa(fun(list(A),fun(list(B),$o)),$o,aa(fun(list(A),fun(list(B),$o)),fun(fun(list(A),fun(list(B),$o)),$o),ord_less_eq(fun(list(A),fun(list(B),$o))),list_all2(A,B,R2)),list_all2(A,B,Ra)) ) ).

% list.rel_mono
tff(fact_7560_dependent__mono,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),A3: set(A)] :
          ( real_V358717886546972837endent(A,B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
           => real_V358717886546972837endent(A,A3) ) ) ) ).

% dependent_mono
tff(fact_7561_independent__mono,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A),B3: set(A)] :
          ( ~ real_V358717886546972837endent(A,A3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
           => ~ real_V358717886546972837endent(A,B3) ) ) ) ).

% independent_mono
tff(fact_7562_independent__Union__directed,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [C5: set(set(A))] :
          ( ! [C4: set(A),D6: set(A)] :
              ( member(set(A),C4,C5)
             => ( member(set(A),D6,C5)
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),C4),D6)
                  | aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),D6),C4) ) ) )
         => ( ! [C4: set(A)] :
                ( member(set(A),C4,C5)
               => ~ real_V358717886546972837endent(A,C4) )
           => ~ real_V358717886546972837endent(A,aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),C5)) ) ) ) ).

% independent_Union_directed
tff(fact_7563_unique__representation,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),F3: fun(A,real),G: fun(A,real)] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( ! [V4: A] :
                ( ( aa(A,real,F3,V4) != zero_zero(real) )
               => member(A,V4,Basis) )
           => ( ! [V4: A] :
                  ( ( aa(A,real,G,V4) != zero_zero(real) )
                 => member(A,V4,Basis) )
             => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F3)))
               => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),G)))
                 => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),F3)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F3))) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),G)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),G))) )
                   => ( F3 = G ) ) ) ) ) ) ) ) ).

% unique_representation
tff(fact_7564_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add(B)
        & monoid_add(A) )
     => ! [A3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),A3,zero_zero(A)),zero_zero(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),plus_plus(A)),plus_plus(B))
           => aa(fun(list(B),B),$o,aa(fun(list(A),A),fun(fun(list(B),B),$o),bNF_rel_fun(list(A),list(B),A,B,list_all2(A,B,A3),A3),groups8242544230860333062m_list(A)),groups8242544230860333062m_list(B)) ) ) ) ).

% sum_list_transfer
tff(fact_7565_independent__if__scalars__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [F4: fun(A,real),X: A] :
                ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),F4)),A3) = zero_zero(A) )
               => ( member(A,X,A3)
                 => ( aa(A,real,F4,X) = zero_zero(real) ) ) )
           => ~ real_V358717886546972837endent(A,A3) ) ) ) ).

% independent_if_scalars_zero
tff(fact_7566_dependent__finite,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( real_V358717886546972837endent(A,S2)
          <=> ? [U6: fun(A,real)] :
                ( ? [X4: A] :
                    ( member(A,X4,S2)
                    & ( aa(A,real,U6,X4) != zero_zero(real) ) )
                & ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),U6)),S2) = zero_zero(A) ) ) ) ) ) ).

% dependent_finite
tff(fact_7567_independentD__unique,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),X6: fun(A,real),Y6: fun(A,real)] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X6)))
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X6))),B3)
             => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),Y6)))
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),Y6))),B3)
                 => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),X6)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X6))) = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),Y6)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),Y6))) )
                   => ( X6 = Y6 ) ) ) ) ) ) ) ) ).

% independentD_unique
tff(fact_7568_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( comm_semiring_0(B)
        & comm_semiring_0(A) )
     => ! [A3: fun(A,fun(B,$o)),B3: fun(C,fun(D,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),A3,zero_zero(A)),zero_zero(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),plus_plus(A)),plus_plus(B))
           => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),times_times(A)),times_times(B))
             => aa(fun(fun(D,B),fun(B,fun(list(D),B))),$o,aa(fun(fun(C,A),fun(A,fun(list(C),A))),fun(fun(fun(D,B),fun(B,fun(list(D),B))),$o),bNF_rel_fun(fun(C,A),fun(D,B),fun(A,fun(list(C),A)),fun(B,fun(list(D),B)),bNF_rel_fun(C,D,A,B,B3,A3),bNF_rel_fun(A,B,fun(list(C),A),fun(list(D),B),A3,bNF_rel_fun(list(C),list(D),A,B,list_all2(C,D,B3),A3))),groups4207007520872428315er_sum(C,A)),groups4207007520872428315er_sum(D,B)) ) ) ) ) ).

% horner_sum_transfer
tff(fact_7569_independentD,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S: set(A),T2: set(A),U: fun(A,real),V: A] :
          ( ~ real_V358717886546972837endent(A,S)
         => ( aa(set(A),$o,finite_finite(A),T2)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),S)
             => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),U)),T2) = zero_zero(A) )
               => ( member(A,V,T2)
                 => ( aa(A,real,U,V) = zero_zero(real) ) ) ) ) ) ) ) ).

% independentD
tff(fact_7570_dependent__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] :
          ( real_V358717886546972837endent(A,B3)
        <=> ? [X9: fun(A,real)] :
              ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X9)))
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X9))),B3)
              & ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),X9)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X9))) = zero_zero(A) )
              & ? [X4: A] : ( aa(A,real,X9,X4) != zero_zero(real) ) ) ) ) ).

% dependent_alt
tff(fact_7571_independent__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] :
          ( ~ real_V358717886546972837endent(A,B3)
        <=> ! [X9: fun(A,real)] :
              ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X9)))
             => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X9))),B3)
               => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),X9)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X9))) = zero_zero(A) )
                 => ! [X4: A] : ( aa(A,real,X9,X4) = zero_zero(real) ) ) ) ) ) ) ).

% independent_alt
tff(fact_7572_independentD__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),X6: fun(A,real),Xa: A] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X6)))
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X6))),B3)
             => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),X6)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),X6))) = zero_zero(A) )
               => ( aa(A,real,X6,Xa) = zero_zero(real) ) ) ) ) ) ) ).

% independentD_alt
tff(fact_7573_dependent__explicit,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S: set(A)] :
          ( real_V358717886546972837endent(A,S)
        <=> ? [T3: set(A)] :
              ( aa(set(A),$o,finite_finite(A),T3)
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T3),S)
              & ? [U6: fun(A,real)] :
                  ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),U6)),T3) = zero_zero(A) )
                  & ? [X4: A] :
                      ( member(A,X4,T3)
                      & ( aa(A,real,U6,X4) != zero_zero(real) ) ) ) ) ) ) ).

% dependent_explicit
tff(fact_7574_independent__explicit__module,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S: set(A)] :
          ( ~ real_V358717886546972837endent(A,S)
        <=> ! [T3: set(A),U6: fun(A,real),V6: A] :
              ( aa(set(A),$o,finite_finite(A),T3)
             => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T3),S)
               => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),U6)),T3) = zero_zero(A) )
                 => ( member(A,V6,T3)
                   => ( aa(A,real,U6,V6) = zero_zero(real) ) ) ) ) ) ) ) ).

% independent_explicit_module
tff(fact_7575_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_mult(B)
        & monoid_mult(A) )
     => ! [A3: fun(A,fun(B,$o))] :
          ( aa(B,$o,aa(A,fun(B,$o),A3,one_one(A)),one_one(B))
         => ( aa(fun(B,fun(B,B)),$o,aa(fun(A,fun(A,A)),fun(fun(B,fun(B,B)),$o),bNF_rel_fun(A,B,fun(A,A),fun(B,B),A3,bNF_rel_fun(A,B,A,B,A3,A3)),times_times(A)),times_times(B))
           => aa(fun(list(B),B),$o,aa(fun(list(A),A),fun(fun(list(B),B),$o),bNF_rel_fun(list(A),list(B),A,B,list_all2(A,B,A3),A3),groups5270119922927024881d_list(A)),groups5270119922927024881d_list(B)) ) ) ) ).

% prod_list_transfer
tff(fact_7576_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [X6: set(A),Y6: set(A)] :
          ( ! [I2: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(set(A),nat,finite_card(A),X6))
             => ( infini527867602293511546merate(A,X6,I2) = infini527867602293511546merate(A,Y6,I2) ) )
         => ( aa(set(A),$o,finite_finite(A),X6)
           => ( aa(set(A),$o,finite_finite(A),Y6)
             => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),X6)),aa(set(A),nat,finite_card(A),Y6))
               => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X6),Y6) ) ) ) ) ) ).

% finite_enum_subset
tff(fact_7577_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xa: A,Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),aa(list(A),list(A),cons(A,Xa),Xs)) = aa(A,A,aa(A,fun(A,A),times_times(A),Xa),aa(list(A),A,groups5270119922927024881d_list(A),Xs)) ) ) ).

% prod_list.Cons
tff(fact_7578_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ( aa(list(A),A,groups5270119922927024881d_list(A),nil(A)) = one_one(A) ) ) ).

% prod_list.Nil
tff(fact_7579_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xs: list(A),Ys: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),append(A,Xs,Ys)) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(list(A),A,groups5270119922927024881d_list(A),Xs)),aa(list(A),A,groups5270119922927024881d_list(A),Ys)) ) ) ).

% prod_list.append
tff(fact_7580_le__enumerate,axiom,
    ! [S2: set(nat),N: nat] :
      ( ~ aa(set(nat),$o,finite_finite(nat),S2)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),infini527867602293511546merate(nat,S2,N)) ) ).

% le_enumerate
tff(fact_7581_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1(A)
        & semiri3467727345109120633visors(A) )
     => ! [Xs: list(A)] :
          ( ( aa(list(A),A,groups5270119922927024881d_list(A),Xs) = zero_zero(A) )
        <=> member(A,zero_zero(A),aa(list(A),set(A),set2(A),Xs)) ) ) ).

% prod_list_zero_iff
tff(fact_7582_prod__list__coprime__right,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A),A2: A] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => algebr8660921524188924756oprime(A,A2,X) )
         => algebr8660921524188924756oprime(A,A2,aa(list(A),A,groups5270119922927024881d_list(A),Xs)) ) ) ).

% prod_list_coprime_right
tff(fact_7583_prod__list__coprime__left,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A),A2: A] :
          ( ! [X: A] :
              ( member(A,X,aa(list(A),set(A),set2(A),Xs))
             => algebr8660921524188924756oprime(A,X,A2) )
         => algebr8660921524188924756oprime(A,aa(list(A),A,groups5270119922927024881d_list(A),Xs),A2) ) ) ).

% prod_list_coprime_left
tff(fact_7584_enumerate__step,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] :
          ( ~ aa(set(A),$o,finite_finite(A),S2)
         => aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S2,N)),infini527867602293511546merate(A,S2,aa(nat,nat,suc,N))) ) ) ).

% enumerate_step
tff(fact_7585_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Xs: list(A)] : ( aa(list(A),A,groups5270119922927024881d_list(A),Xs) = aa(A,A,foldr(A,A,times_times(A),Xs),one_one(A)) ) ) ).

% prod_list.eq_foldr
tff(fact_7586_finite__le__enumerate,axiom,
    ! [S2: set(nat),N: nat] :
      ( aa(set(nat),$o,finite_finite(nat),S2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),N),aa(set(nat),nat,finite_card(nat),S2))
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N),infini527867602293511546merate(nat,S2,N)) ) ) ).

% finite_le_enumerate
tff(fact_7587_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),aa(set(A),nat,finite_card(A),S2))
           => aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,S2,N)),infini527867602293511546merate(A,S2,aa(nat,nat,suc,N))) ) ) ) ).

% finite_enumerate_step
tff(fact_7588_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] : ( infini527867602293511546merate(A,S2,aa(nat,nat,suc,N)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,infini527867602293511546merate(A,S2,zero_zero(nat))),bot_bot(set(A)))),N) ) ) ).

% enumerate_Suc'
tff(fact_7589_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,N)),aa(set(A),nat,finite_card(A),S2))
           => ( infini527867602293511546merate(A,S2,aa(nat,nat,suc,N)) = ord_Least(A,aa(nat,fun(A,$o),aTP_Lamp_aic(set(A),fun(nat,fun(A,$o)),S2),N)) ) ) ) ) ).

% finite_enumerate_Suc''
tff(fact_7590_enumerate__Suc,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] : ( infini527867602293511546merate(A,S2,aa(nat,nat,suc,N)) = infini527867602293511546merate(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,ord_Least(A,aTP_Lamp_aid(set(A),fun(A,$o),S2))),bot_bot(set(A)))),N) ) ) ).

% enumerate_Suc
tff(fact_7591_Least__eq__0,axiom,
    ! [P: fun(nat,$o)] :
      ( aa(nat,$o,P,zero_zero(nat))
     => ( ord_Least(nat,P) = zero_zero(nat) ) ) ).

% Least_eq_0
tff(fact_7592_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,$o),Q: fun(A,$o)] :
          ( ? [X_1: A] : aa(A,$o,P,X_1)
         => ( ! [A4: A] :
                ( aa(A,$o,P,A4)
               => ( ! [B10: A] :
                      ( aa(A,$o,P,B10)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),B10) )
                 => aa(A,$o,Q,A4) ) )
           => aa(A,$o,Q,ord_Least(A,P)) ) ) ) ).

% LeastI2_wellorder_ex
tff(fact_7593_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,$o),A2: A,Q: fun(A,$o)] :
          ( aa(A,$o,P,A2)
         => ( ! [A4: A] :
                ( aa(A,$o,P,A4)
               => ( ! [B10: A] :
                      ( aa(A,$o,P,B10)
                     => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),B10) )
                 => aa(A,$o,Q,A4) ) )
           => aa(A,$o,Q,ord_Least(A,P)) ) ) ) ).

% LeastI2_wellorder
tff(fact_7594_Least__equality,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o),Xa: A] :
          ( aa(A,$o,P,Xa)
         => ( ! [Y3: A] :
                ( aa(A,$o,P,Y3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y3) )
           => ( ord_Least(A,P) = Xa ) ) ) ) ).

% Least_equality
tff(fact_7595_LeastI2__order,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o),Xa: A,Q: fun(A,$o)] :
          ( aa(A,$o,P,Xa)
         => ( ! [Y3: A] :
                ( aa(A,$o,P,Y3)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y3) )
           => ( ! [X: A] :
                  ( aa(A,$o,P,X)
                 => ( ! [Y4: A] :
                        ( aa(A,$o,P,Y4)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Y4) )
                   => aa(A,$o,Q,X) ) )
             => aa(A,$o,Q,ord_Least(A,P)) ) ) ) ) ).

% LeastI2_order
tff(fact_7596_Least1__le,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o),Z: A] :
          ( ? [X3: A] :
              ( aa(A,$o,P,X3)
              & ! [Y3: A] :
                  ( aa(A,$o,P,Y3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y3) )
              & ! [Y3: A] :
                  ( ( aa(A,$o,P,Y3)
                    & ! [Ya2: A] :
                        ( aa(A,$o,P,Ya2)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),Ya2) ) )
                 => ( Y3 = X3 ) ) )
         => ( aa(A,$o,P,Z)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ord_Least(A,P)),Z) ) ) ) ).

% Least1_le
tff(fact_7597_Least1I,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [P: fun(A,$o)] :
          ( ? [X3: A] :
              ( aa(A,$o,P,X3)
              & ! [Y3: A] :
                  ( aa(A,$o,P,Y3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Y3) )
              & ! [Y3: A] :
                  ( ( aa(A,$o,P,Y3)
                    & ! [Ya2: A] :
                        ( aa(A,$o,P,Ya2)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y3),Ya2) ) )
                 => ( Y3 = X3 ) ) )
         => aa(A,$o,P,ord_Least(A,P)) ) ) ).

% Least1I
tff(fact_7598_Least__le,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [P: fun(A,$o),K: A] :
          ( aa(A,$o,P,K)
         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),ord_Least(A,P)),K) ) ) ).

% Least_le
tff(fact_7599_Least__Suc2,axiom,
    ! [P: fun(nat,$o),N: nat,Q: fun(nat,$o),M: nat] :
      ( aa(nat,$o,P,N)
     => ( aa(nat,$o,Q,M)
       => ( ~ aa(nat,$o,P,zero_zero(nat))
         => ( ! [K3: nat] :
                ( aa(nat,$o,P,aa(nat,nat,suc,K3))
              <=> aa(nat,$o,Q,K3) )
           => ( ord_Least(nat,P) = aa(nat,nat,suc,ord_Least(nat,Q)) ) ) ) ) ) ).

% Least_Suc2
tff(fact_7600_Least__Suc,axiom,
    ! [P: fun(nat,$o),N: nat] :
      ( aa(nat,$o,P,N)
     => ( ~ aa(nat,$o,P,zero_zero(nat))
       => ( ord_Least(nat,P) = aa(nat,nat,suc,ord_Least(nat,aTP_Lamp_aaw(fun(nat,$o),fun(nat,$o),P))) ) ) ) ).

% Least_Suc
tff(fact_7601_enumerate__0,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A)] : ( infini527867602293511546merate(A,S2,zero_zero(nat)) = ord_Least(A,aTP_Lamp_aid(set(A),fun(A,$o),S2)) ) ) ).

% enumerate_0
tff(fact_7602_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [F3: fun(A,B),S2: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( ? [X3: A] :
                ( member(A,X3,S2)
                & ! [Xa4: A] :
                    ( member(A,Xa4,S2)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),Xa4) ) )
           => ( ord_Least(B,aa(set(A),fun(B,$o),aTP_Lamp_aie(fun(A,B),fun(set(A),fun(B,$o)),F3),S2)) = aa(A,B,F3,ord_Least(A,aTP_Lamp_aif(set(A),fun(A,$o),S2))) ) ) ) ) ).

% Least_mono
tff(fact_7603_Least__def,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [P: fun(A,$o)] : ( ord_Least(A,P) = the(A,aTP_Lamp_aig(fun(A,$o),fun(A,$o),P)) ) ) ).

% Least_def
tff(fact_7604_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [S2: set(A),N: nat] :
          ( ~ aa(set(A),$o,finite_finite(A),S2)
         => ( infini527867602293511546merate(A,S2,aa(nat,nat,suc,N)) = ord_Least(A,aa(nat,fun(A,$o),aTP_Lamp_aic(set(A),fun(nat,fun(A,$o)),S2),N)) ) ) ) ).

% enumerate_Suc''
tff(fact_7605_isUCont__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [F3: fun(A,B)] :
          ( topolo6026614971017936543ous_on(A,B,top_top(set(A)),F3)
        <=> ! [R5: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),R5)
             => ? [S6: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),S6)
                  & ! [X4: A,Y5: A] :
                      ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,X4,Y5)),S6)
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,X4),aa(A,B,F3,Y5))),R5) ) ) ) ) ) ).

% isUCont_def
tff(fact_7606_plus__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_ahp(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_ahp(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat.rsp
tff(fact_7607_ratrel__iff,axiom,
    ! [Xa: product_prod(int,int),Y: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xa),Y)
    <=> ( ( aa(product_prod(int,int),int,product_snd(int,int),Xa) != zero_zero(int) )
        & ( aa(product_prod(int,int),int,product_snd(int,int),Y) != zero_zero(int) )
        & ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),Y)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Y)),aa(product_prod(int,int),int,product_snd(int,int),Xa)) ) ) ) ).

% ratrel_iff
tff(fact_7608_one__rat_Orsp,axiom,
    aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))),aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))) ).

% one_rat.rsp
tff(fact_7609_zero__rat_Orsp,axiom,
    aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))) ).

% zero_rat.rsp
tff(fact_7610_Fract_Orsp,axiom,
    aa(fun(int,fun(int,product_prod(int,int))),$o,aa(fun(int,fun(int,product_prod(int,int))),fun(fun(int,fun(int,product_prod(int,int))),$o),bNF_rel_fun(int,int,fun(int,product_prod(int,int)),fun(int,product_prod(int,int)),fequal(int),bNF_rel_fun(int,int,product_prod(int,int),product_prod(int,int),fequal(int),ratrel)),aTP_Lamp_aht(int,fun(int,product_prod(int,int)))),aTP_Lamp_aht(int,fun(int,product_prod(int,int)))) ).

% Fract.rsp
tff(fact_7611_uniformly__continuous__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(A) )
     => ! [S: set(A),F3: fun(A,B)] :
          ( topolo6026614971017936543ous_on(A,B,S,F3)
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [D4: real] :
                  ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),D4)
                  & ! [X4: A] :
                      ( member(A,X4,S)
                     => ! [Xa3: A] :
                          ( member(A,Xa3,S)
                         => ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Xa3,X4)),D4)
                           => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,F3,Xa3),aa(A,B,F3,X4))),E3) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
tff(fact_7612_ratrel__def,axiom,
    ! [X3: product_prod(int,int),Xa2: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,X3),Xa2)
    <=> ( ( aa(product_prod(int,int),int,product_snd(int,int),X3) != zero_zero(int) )
        & ( aa(product_prod(int,int),int,product_snd(int,int),Xa2) != zero_zero(int) )
        & ( aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),X3)),aa(product_prod(int,int),int,product_snd(int,int),Xa2)) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa2)),aa(product_prod(int,int),int,product_snd(int,int),X3)) ) ) ) ).

% ratrel_def
tff(fact_7613_times__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o,aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(product_prod(int,int),product_prod(int,int)),ratrel,bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel)),aTP_Lamp_ahu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))),aTP_Lamp_ahu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat.rsp
tff(fact_7614_Rat_Opositive_Orsp,axiom,
    aa(fun(product_prod(int,int),$o),$o,aa(fun(product_prod(int,int),$o),fun(fun(product_prod(int,int),$o),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),$o,$o,ratrel,fequal($o)),aTP_Lamp_ahn(product_prod(int,int),$o)),aTP_Lamp_ahn(product_prod(int,int),$o)) ).

% Rat.positive.rsp
tff(fact_7615_inverse__rat_Orsp,axiom,
    aa(fun(product_prod(int,int),product_prod(int,int)),$o,aa(fun(product_prod(int,int),product_prod(int,int)),fun(fun(product_prod(int,int),product_prod(int,int)),$o),bNF_rel_fun(product_prod(int,int),product_prod(int,int),product_prod(int,int),product_prod(int,int),ratrel,ratrel),aTP_Lamp_ahq(product_prod(int,int),product_prod(int,int))),aTP_Lamp_ahq(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat.rsp
tff(fact_7616_plus__rat_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int),Xb: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xa),Xa)
     => ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xb),Xb)
       => ( aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),aa(product_prod(int,int),rat,abs_Rat,Xa)),aa(product_prod(int,int),rat,abs_Rat,Xb)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),Xb))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xb)),aa(product_prod(int,int),int,product_snd(int,int),Xa)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),Xb)))) ) ) ) ).

% plus_rat.abs_eq
tff(fact_7617_inverse__rat_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xa),Xa)
     => ( aa(rat,rat,inverse_inverse(rat),aa(product_prod(int,int),rat,abs_Rat,Xa))
        = aa(product_prod(int,int),rat,abs_Rat,$ite(aa(product_prod(int,int),int,product_fst(int,int),Xa) = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),Xa)),aa(product_prod(int,int),int,product_fst(int,int),Xa)))) ) ) ).

% inverse_rat.abs_eq
tff(fact_7618_one__rat__def,axiom,
    one_one(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),product_Pair(int,int,one_one(int)),one_one(int))) ).

% one_rat_def
tff(fact_7619_Fract_Oabs__eq,axiom,
    ! [Xa: int,Xb: int] :
      ( aa(int,rat,aa(int,fun(int,rat),fract,Xa),Xb)
      = aa(product_prod(int,int),rat,abs_Rat,$ite(Xb = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,Xa),Xb))) ) ).

% Fract.abs_eq
tff(fact_7620_zero__rat__def,axiom,
    zero_zero(rat) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int))) ).

% zero_rat_def
tff(fact_7621_times__rat_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int),Xb: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xa),Xa)
     => ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xb),Xb)
       => ( aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),aa(product_prod(int,int),rat,abs_Rat,Xa)),aa(product_prod(int,int),rat,abs_Rat,Xb)) = aa(product_prod(int,int),rat,abs_Rat,aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_fst(int,int),Xb))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),Xb)))) ) ) ) ).

% times_rat.abs_eq
tff(fact_7622_Rat_Opositive_Oabs__eq,axiom,
    ! [Xa: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aa(product_prod(int,int),fun(product_prod(int,int),$o),ratrel,Xa),Xa)
     => ( aa(rat,$o,positive,aa(product_prod(int,int),rat,abs_Rat,Xa))
      <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Xa)),aa(product_prod(int,int),int,product_snd(int,int),Xa))) ) ) ).

% Rat.positive.abs_eq
tff(fact_7623_inverse__rat__def,axiom,
    inverse_inverse(rat) = aa(fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat),aTP_Lamp_ahq(product_prod(int,int),product_prod(int,int))) ).

% inverse_rat_def
tff(fact_7624_acyclic__insert,axiom,
    ! [A: $tType,Y: A,Xa: A,R: set(product_prod(A,A))] :
      ( transitive_acyclic(A,aa(set(product_prod(A,A)),set(product_prod(A,A)),insert(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Y),Xa)),R))
    <=> ( transitive_acyclic(A,R)
        & ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),transitive_rtrancl(A,R)) ) ) ).

% acyclic_insert
tff(fact_7625_acyclic__def,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( transitive_acyclic(A,R)
    <=> ! [X4: A] : ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X4),X4),transitive_trancl(A,R)) ) ).

% acyclic_def
tff(fact_7626_acyclicI,axiom,
    ! [A: $tType,R: set(product_prod(A,A))] :
      ( ! [X: A] : ~ member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,X),X),transitive_trancl(A,R))
     => transitive_acyclic(A,R) ) ).

% acyclicI
tff(fact_7627_acyclicI__order,axiom,
    ! [B: $tType,A: $tType] :
      ( preorder(B)
     => ! [R: set(product_prod(A,A)),F3: fun(A,B)] :
          ( ! [A4: A,B4: A] :
              ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,A4),B4),R)
             => aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,F3,B4)),aa(A,B,F3,A4)) )
         => transitive_acyclic(A,R) ) ) ).

% acyclicI_order
tff(fact_7628_acyclic__subset,axiom,
    ! [A: $tType,S: set(product_prod(A,A)),R: set(product_prod(A,A))] :
      ( transitive_acyclic(A,S)
     => ( aa(set(product_prod(A,A)),$o,aa(set(product_prod(A,A)),fun(set(product_prod(A,A)),$o),ord_less_eq(set(product_prod(A,A))),R),S)
       => transitive_acyclic(A,R) ) ) ).

% acyclic_subset
tff(fact_7629_plus__rat__def,axiom,
    plus_plus(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_ahp(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% plus_rat_def
tff(fact_7630_times__rat__def,axiom,
    times_times(rat) = aa(fun(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),fun(rat,fun(rat,rat)),map_fun(rat,product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),fun(rat,rat),rep_Rat,map_fun(rat,product_prod(int,int),product_prod(int,int),rat,rep_Rat,abs_Rat)),aTP_Lamp_ahu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)))) ).

% times_rat_def
tff(fact_7631_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_un2480387367778600638or_num(M,N)) ) ) ).

% numeral_xor_num
tff(fact_7632_numeral__and__num,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: num] : ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = case_option(A,num,zero_zero(A),numeral_numeral(A),bit_un7362597486090784418nd_num(M,N)) ) ) ).

% numeral_and_num
tff(fact_7633_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = zero_zero(A) )
        <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A))))
            & aa(set(A),$o,finite_finite(A),A3) ) ) ) ).

% Gcd_fin_0_iff
tff(fact_7634_last__list__update,axiom,
    ! [A: $tType,Xs: list(A),K: nat,Xa: A] :
      ( ( Xs != nil(A) )
     => ( last(A,list_update(A,Xs,K,Xa))
        = $ite(K = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat)),Xa,last(A,Xs)) ) ) ).

% last_list_update
tff(fact_7635_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),bot_bot(set(A))) = zero_zero(A) ) ) ).

% Gcd_fin.empty
tff(fact_7636_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( ~ aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = one_one(A) ) ) ) ).

% Gcd_fin.infinite
tff(fact_7637_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)),one_one(A))
        <=> ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = one_one(A) ) ) ) ).

% is_unit_Gcd_fin_iff
tff(fact_7638_Gcd__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) ) ) ).

% Gcd_fin.insert
tff(fact_7639_last__replicate,axiom,
    ! [A: $tType,N: nat,Xa: A] :
      ( ( N != zero_zero(nat) )
     => ( last(A,replicate(A,N,Xa)) = Xa ) ) ).

% last_replicate
tff(fact_7640_Gcd__fin__eq__Gcd,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = gcd_Gcd(A,A3) ) ) ) ).

% Gcd_fin_eq_Gcd
tff(fact_7641_last__upt,axiom,
    ! [I: nat,J: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I),J)
     => ( last(nat,upt(I,J)) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),J),one_one(nat)) ) ) ).

% last_upt
tff(fact_7642_Gcd__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B3: set(A),A3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),B3)),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) = aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) ) ) ) ).

% Gcd_fin.subset
tff(fact_7643_Gcd__fin_Ounion,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B3: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)),aa(set(A),A,semiring_gcd_Gcd_fin(A),B3)) ) ) ).

% Gcd_fin.union
tff(fact_7644_Gcd__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => ( aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) = aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) ) ) ) ).

% Gcd_fin.in_idem
tff(fact_7645_Gcd__fin__greatest,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ! [B4: A] :
                ( member(A,B4,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B4) )
           => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)) ) ) ) ).

% Gcd_fin_greatest
tff(fact_7646_dvd__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A),B2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3))
          <=> ! [X4: A] :
                ( member(A,X4,A3)
               => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),X4) ) ) ) ) ).

% dvd_Gcd_fin_iff
tff(fact_7647_Gcd__fin__dvd,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)),A2) ) ) ).

% Gcd_fin_dvd
tff(fact_7648_dvd__gcd__list__iff,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [B2: A,Xs: list(A)] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(list(A),set(A),set2(A),Xs)))
        <=> ! [X4: A] :
              ( member(A,X4,aa(list(A),set(A),set2(A),Xs))
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),X4) ) ) ) ).

% dvd_gcd_list_iff
tff(fact_7649_gcd__list__greatest,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Bs: list(A),A2: A] :
          ( ! [B4: A] :
              ( member(A,B4,aa(list(A),set(A),set2(A),Bs))
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B4) )
         => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(list(A),set(A),set2(A),Bs))) ) ) ).

% gcd_list_greatest
tff(fact_7650_Gcd__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% Gcd_fin.insert_remove
tff(fact_7651_Gcd__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A2: A,A3: set(A)] :
          ( member(A,A2,A3)
         => ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3) = aa(A,A,aa(A,fun(A,A),gcd_gcd(A),A2),aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% Gcd_fin.remove
tff(fact_7652_last__conv__nth,axiom,
    ! [A: $tType,Xs: list(A)] :
      ( ( Xs != nil(A) )
     => ( last(A,Xs) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(A),nat,size_size(list(A)),Xs)),one_one(nat))) ) ) ).

% last_conv_nth
tff(fact_7653_connected__closed,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A)] :
          ( topolo1966860045006549960nected(A,S)
        <=> ~ ? [A11: set(A),B8: set(A)] :
                ( topolo7761053866217962861closed(A,A11)
                & topolo7761053866217962861closed(A,B8)
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A11),B8))
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A11),B8)),S) = bot_bot(set(A)) )
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A11),S) != bot_bot(set(A)) )
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B8),S) != bot_bot(set(A)) ) ) ) ) ).

% connected_closed
tff(fact_7654_connected__closedD,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),A3: set(A),B3: set(A)] :
          ( topolo1966860045006549960nected(A,S)
         => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3)),S) = bot_bot(set(A)) )
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3))
             => ( topolo7761053866217962861closed(A,A3)
               => ( topolo7761053866217962861closed(A,B3)
                 => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),S) = bot_bot(set(A)) )
                    | ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B3),S) = bot_bot(set(A)) ) ) ) ) ) ) ) ) ).

% connected_closedD
tff(fact_7655_connected__contains__Icc,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A3: set(A),A2: A,B2: A] :
          ( topolo1966860045006549960nected(A,A3)
         => ( member(A,A2,A3)
           => ( member(A,B2,A3)
             => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or1337092689740270186AtMost(A,A2,B2)),A3) ) ) ) ) ).

% connected_contains_Icc
tff(fact_7656_connected__iff__interval,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [U2: set(A)] :
          ( topolo1966860045006549960nected(A,U2)
        <=> ! [X4: A] :
              ( member(A,X4,U2)
             => ! [Xa3: A] :
                  ( member(A,Xa3,U2)
                 => ! [Z7: A] :
                      ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Z7)
                     => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z7),Xa3)
                       => member(A,Z7,U2) ) ) ) ) ) ) ).

% connected_iff_interval
tff(fact_7657_connectedI__interval,axiom,
    ! [A: $tType] :
      ( topolo8458572112393995274pology(A)
     => ! [U2: set(A)] :
          ( ! [X: A,Y3: A,Z4: A] :
              ( member(A,X,U2)
             => ( member(A,Y3,U2)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),Z4)
                 => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z4),Y3)
                   => member(A,Z4,U2) ) ) ) )
         => topolo1966860045006549960nected(A,U2) ) ) ).

% connectedI_interval
tff(fact_7658_connectedD__interval,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [U2: set(A),Xa: A,Y: A,Z: A] :
          ( topolo1966860045006549960nected(A,U2)
         => ( member(A,Xa,U2)
           => ( member(A,Y,U2)
             => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Z)
               => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Z),Y)
                 => member(A,Z,U2) ) ) ) ) ) ) ).

% connectedD_interval
tff(fact_7659_connected__contains__Ioo,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [A3: set(A),A2: A,B2: A] :
          ( topolo1966860045006549960nected(A,A3)
         => ( member(A,A2,A3)
           => ( member(A,B2,A3)
             => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),set_or5935395276787703475ssThan(A,A2,B2)),A3) ) ) ) ) ).

% connected_contains_Ioo
tff(fact_7660_connected__diff__open__from__closed,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S: set(A),T2: set(A),U: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S),T2)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T2),U)
           => ( topolo1002775350975398744n_open(A,S)
             => ( topolo7761053866217962861closed(A,T2)
               => ( topolo1966860045006549960nected(A,U)
                 => ( topolo1966860045006549960nected(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),T2),S))
                   => topolo1966860045006549960nected(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),U),S)) ) ) ) ) ) ) ) ).

% connected_diff_open_from_closed
tff(fact_7661_connected__def,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [S2: set(A)] :
          ( topolo1966860045006549960nected(A,S2)
        <=> ~ ? [A11: set(A),B8: set(A)] :
                ( topolo1002775350975398744n_open(A,A11)
                & topolo1002775350975398744n_open(A,B8)
                & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A11),B8))
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A11),B8)),S2) = bot_bot(set(A)) )
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A11),S2) != bot_bot(set(A)) )
                & ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B8),S2) != bot_bot(set(A)) ) ) ) ) ).

% connected_def
tff(fact_7662_connectedI,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [U2: set(A)] :
          ( ! [A6: set(A)] :
              ( topolo1002775350975398744n_open(A,A6)
             => ! [B9: set(A)] :
                  ( topolo1002775350975398744n_open(A,B9)
                 => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A6),U2) != bot_bot(set(A)) )
                   => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),B9),U2) != bot_bot(set(A)) )
                     => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A6),B9)),U2) = bot_bot(set(A)) )
                       => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),U2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A6),B9)) ) ) ) ) )
         => topolo1966860045006549960nected(A,U2) ) ) ).

% connectedI
tff(fact_7663_connectedD,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [A3: set(A),U2: set(A),V2: set(A)] :
          ( topolo1966860045006549960nected(A,A3)
         => ( topolo1002775350975398744n_open(A,U2)
           => ( topolo1002775350975398744n_open(A,V2)
             => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U2),V2)),A3) = bot_bot(set(A)) )
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),U2),V2))
                 => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),U2),A3) = bot_bot(set(A)) )
                    | ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),V2),A3) = bot_bot(set(A)) ) ) ) ) ) ) ) ) ).

% connectedD
tff(fact_7664_minus__coset__filter,axiom,
    ! [A: $tType,A3: set(A),Xs: list(A)] : ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),coset(A,Xs)) = aa(list(A),set(A),set2(A),filter2(A,aTP_Lamp_a(set(A),fun(A,$o),A3),Xs)) ) ).

% minus_coset_filter
tff(fact_7665_flat__lub__def,axiom,
    ! [A: $tType,B2: A,A3: set(A)] :
      ( partial_flat_lub(A,B2,A3)
      = $ite(aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))),B2,the(A,aa(set(A),fun(A,$o),aTP_Lamp_aih(A,fun(set(A),fun(A,$o)),B2),A3))) ) ).

% flat_lub_def
tff(fact_7666_subset__code_I2_J,axiom,
    ! [A: $tType,A3: set(A),Ys: list(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),coset(A,Ys))
    <=> ! [X4: A] :
          ( member(A,X4,aa(list(A),set(A),set2(A),Ys))
         => ~ member(A,X4,A3) ) ) ).

% subset_code(2)
tff(fact_7667_subset__code_I3_J,axiom,
    ! [A: $tType] : ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),coset(A,nil(A))),aa(list(A),set(A),set2(A),nil(A))) ).

% subset_code(3)
tff(fact_7668_arg__min__inj__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [F3: fun(A,B),P: fun(A,$o),A2: A] :
          ( inj_on(A,B,F3,collect(A,P))
         => ( aa(A,$o,P,A2)
           => ( ! [Y3: A] :
                  ( aa(A,$o,P,Y3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,A2)),aa(A,B,F3,Y3)) )
             => ( lattices_ord_arg_min(A,B,F3,P) = A2 ) ) ) ) ) ).

% arg_min_inj_eq
tff(fact_7669_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( lattic5882676163264333800up_fin(A,A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),lattic5882676163264333800up_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ) ).

% Sup_fin.remove
tff(fact_7670_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),lattic5882676163264333800up_fin(A,A3)) ) ) ) ).

% Sup_fin.coboundedI
tff(fact_7671_arg__min__nat__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xa: A,M: fun(A,nat)] :
      ( aa(A,$o,P,Xa)
     => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,M,lattices_ord_arg_min(A,nat,M,P))),aa(A,nat,M,Xa)) ) ).

% arg_min_nat_le
tff(fact_7672_arg__min__nat__lemma,axiom,
    ! [A: $tType,P: fun(A,$o),K: A,M: fun(A,nat)] :
      ( aa(A,$o,P,K)
     => ( aa(A,$o,P,lattices_ord_arg_min(A,nat,M,P))
        & ! [Y4: A] :
            ( aa(A,$o,P,Y4)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,M,lattices_ord_arg_min(A,nat,M,P))),aa(A,nat,M,Y4)) ) ) ) ).

% arg_min_nat_lemma
tff(fact_7673_arg__min__equality,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [P: fun(A,$o),K: A,F3: fun(A,B)] :
          ( aa(A,$o,P,K)
         => ( ! [X: A] :
                ( aa(A,$o,P,X)
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,K)),aa(A,B,F3,X)) )
           => ( aa(A,B,F3,lattices_ord_arg_min(A,B,F3,P)) = aa(A,B,F3,K) ) ) ) ) ).

% arg_min_equality
tff(fact_7674_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),Xa)
            <=> ! [X4: A] :
                  ( member(A,X4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Xa) ) ) ) ) ) ).

% Sup_fin.bounded_iff
tff(fact_7675_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A4: A] :
                  ( member(A,A4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A4),Xa) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),Xa) ) ) ) ) ).

% Sup_fin.boundedI
tff(fact_7676_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),Xa)
             => ! [A15: A] :
                  ( member(A,A15,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A15),Xa) ) ) ) ) ) ).

% Sup_fin.boundedE
tff(fact_7677_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,finite_finite(A),B3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),lattic5882676163264333800up_fin(A,A3)),lattic5882676163264333800up_fin(A,B3)) ) ) ) ) ).

% Sup_fin.subset_imp
tff(fact_7678_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( B3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
             => ( aa(A,A,aa(A,fun(A,A),sup_sup(A),lattic5882676163264333800up_fin(A,B3)),lattic5882676163264333800up_fin(A,A3)) = lattic5882676163264333800up_fin(A,A3) ) ) ) ) ) ).

% Sup_fin.subset
tff(fact_7679_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( lattic5882676163264333800up_fin(A,aa(set(A),set(A),insert(A,Xa),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),sup_sup(A),Xa),lattic5882676163264333800up_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ).

% Sup_fin.insert_remove
tff(fact_7680_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( lattic7752659483105999362nf_fin(A,aa(set(A),set(A),insert(A,Xa),A3))
            = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),lattic7752659483105999362nf_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ).

% Inf_fin.insert_remove
tff(fact_7681_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( lattic7752659483105999362nf_fin(A,A3)
              = $ite(aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))) = bot_bot(set(A)),Xa,aa(A,A,aa(A,fun(A,A),inf_inf(A),Xa),lattic7752659483105999362nf_fin(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A))))))) ) ) ) ) ).

% Inf_fin.remove
tff(fact_7682_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),A2: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,A2,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),lattic7752659483105999362nf_fin(A,A3)),A2) ) ) ) ).

% Inf_fin.coboundedI
tff(fact_7683_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),lattic7752659483105999362nf_fin(A,A3))
             => ! [A15: A] :
                  ( member(A,A15,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A15) ) ) ) ) ) ).

% Inf_fin.boundedE
tff(fact_7684_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( ! [A4: A] :
                  ( member(A,A4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),A4) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),lattic7752659483105999362nf_fin(A,A3)) ) ) ) ) ).

% Inf_fin.boundedI
tff(fact_7685_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),Xa: A] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),lattic7752659483105999362nf_fin(A,A3))
            <=> ! [X4: A] :
                  ( member(A,X4,A3)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),X4) ) ) ) ) ) ).

% Inf_fin.bounded_iff
tff(fact_7686_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ( ( A3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,finite_finite(A),B3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),lattic7752659483105999362nf_fin(A,B3)),lattic7752659483105999362nf_fin(A,A3)) ) ) ) ) ).

% Inf_fin.subset_imp
tff(fact_7687_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( B3 != bot_bot(set(A)) )
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
             => ( aa(A,A,aa(A,fun(A,A),inf_inf(A),lattic7752659483105999362nf_fin(A,B3)),lattic7752659483105999362nf_fin(A,A3)) = lattic7752659483105999362nf_fin(A,A3) ) ) ) ) ) ).

% Inf_fin.subset
tff(fact_7688_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( lattice(A)
     => ! [A3: set(A)] :
          ( aa(set(A),$o,finite_finite(A),A3)
         => ( ( A3 != bot_bot(set(A)) )
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),lattic7752659483105999362nf_fin(A,A3)),lattic5882676163264333800up_fin(A,A3)) ) ) ) ).

% Inf_fin_le_Sup_fin
tff(fact_7689_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A3: set(A),A2: B] :
      ( inj_on(A,B,F3,A3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),vimage(A,B,F3,aa(set(B),set(B),insert(B,A2),bot_bot(set(B))))),A3)),aa(set(A),set(A),insert(A,the(A,aa(B,fun(A,$o),aa(set(A),fun(B,fun(A,$o)),aTP_Lamp_aii(fun(A,B),fun(set(A),fun(B,fun(A,$o))),F3),A3),A2))),bot_bot(set(A)))) ) ).

% inj_on_vimage_singleton
tff(fact_7690_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),A2: B] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),vimage(A,B,F3,aa(set(B),set(B),insert(B,A2),bot_bot(set(B))))),aa(set(A),set(A),insert(A,the(A,aa(B,fun(A,$o),aTP_Lamp_aij(fun(A,B),fun(B,fun(A,$o)),F3),A2))),bot_bot(set(A)))) ) ).

% inj_vimage_singleton
tff(fact_7691_vimage__Diff,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(B),B3: set(B)] : ( vimage(A,B,F3,aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),A3),B3)) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),vimage(A,B,F3,A3)),vimage(A,B,F3,B3)) ) ).

% vimage_Diff
tff(fact_7692_vimage__Suc__insert__Suc,axiom,
    ! [N: nat,A3: set(nat)] : ( vimage(nat,nat,suc,aa(set(nat),set(nat),insert(nat,aa(nat,nat,suc,N)),A3)) = aa(set(nat),set(nat),insert(nat,N),vimage(nat,nat,suc,A3)) ) ).

% vimage_Suc_insert_Suc
tff(fact_7693_finite__vimage__Suc__iff,axiom,
    ! [F6: set(nat)] :
      ( aa(set(nat),$o,finite_finite(nat),vimage(nat,nat,suc,F6))
    <=> aa(set(nat),$o,finite_finite(nat),F6) ) ).

% finite_vimage_Suc_iff
tff(fact_7694_vimage__Suc__insert__0,axiom,
    ! [A3: set(nat)] : ( vimage(nat,nat,suc,aa(set(nat),set(nat),insert(nat,zero_zero(nat)),A3)) = vimage(nat,nat,suc,A3) ) ).

% vimage_Suc_insert_0
tff(fact_7695_continuous__imp__open__vimage,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [S: set(A),F3: fun(A,B),B3: set(B)] :
          ( topolo81223032696312382ous_on(A,B,S,F3)
         => ( topolo1002775350975398744n_open(A,S)
           => ( topolo1002775350975398744n_open(B,B3)
             => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),vimage(A,B,F3,B3)),S)
               => topolo1002775350975398744n_open(A,vimage(A,B,F3,B3)) ) ) ) ) ) ).

% continuous_imp_open_vimage
tff(fact_7696_vimage__mono,axiom,
    ! [B: $tType,A: $tType,A3: set(A),B3: set(A),F3: fun(B,A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),vimage(B,A,F3,A3)),vimage(B,A,F3,B3)) ) ).

% vimage_mono
tff(fact_7697_subset__vimage__iff,axiom,
    ! [A: $tType,B: $tType,A3: set(A),F3: fun(A,B),B3: set(B)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),vimage(A,B,F3,B3))
    <=> ! [X4: A] :
          ( member(A,X4,A3)
         => member(B,aa(A,B,F3,X4),B3) ) ) ).

% subset_vimage_iff
tff(fact_7698_vimage__subsetD,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),B3: set(A),A3: set(B)] :
      ( ( aa(set(B),set(A),image(B,A,F3),top_top(set(B))) = top_top(set(A)) )
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),vimage(B,A,F3,B3)),A3)
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F3),A3)) ) ) ).

% vimage_subsetD
tff(fact_7699_image__vimage__subset,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),A3: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F3),vimage(B,A,F3,A3))),A3) ).

% image_vimage_subset
tff(fact_7700_image__subset__iff__subset__vimage,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),A3: set(B),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,F3),A3)),B3)
    <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),vimage(B,A,F3,B3)) ) ).

% image_subset_iff_subset_vimage
tff(fact_7701_finite__vimageD_H,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(B)] :
      ( aa(set(A),$o,finite_finite(A),vimage(A,B,F3,A3))
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(A),set(B),image(A,B,F3),top_top(set(A))))
       => aa(set(B),$o,finite_finite(B),A3) ) ) ).

% finite_vimageD'
tff(fact_7702_vimage__subsetI,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),B3: set(B),A3: set(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B3),aa(set(A),set(B),image(A,B,F3),A3))
       => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),vimage(A,B,F3,B3)),A3) ) ) ).

% vimage_subsetI
tff(fact_7703_countable__vimage,axiom,
    ! [B: $tType,A: $tType,B3: set(A),F3: fun(B,A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),aa(set(B),set(A),image(B,A,F3),top_top(set(B))))
     => ( countable_countable(B,vimage(B,A,F3,B3))
       => countable_countable(A,B3) ) ) ).

% countable_vimage
tff(fact_7704_vimage__subset__eq,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),B3: set(B),A3: set(A)] :
      ( bij_betw(A,B,F3,top_top(set(A)),top_top(set(B)))
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),vimage(A,B,F3,B3)),A3)
      <=> aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),B3),aa(set(A),set(B),image(A,B,F3),A3)) ) ) ).

% vimage_subset_eq
tff(fact_7705_card__vimage__inj,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),A3: set(B)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),A3),aa(set(A),set(B),image(A,B,F3),top_top(set(A))))
       => ( aa(set(A),nat,finite_card(A),vimage(A,B,F3,A3)) = aa(set(B),nat,finite_card(B),A3) ) ) ) ).

% card_vimage_inj
tff(fact_7706_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),D3: set(A),A3: set(B)] :
      ( inj_on(A,B,F3,D3)
     => ( aa(set(B),$o,finite_finite(B),A3)
       => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),vimage(A,B,F3,A3)),D3))),aa(set(B),nat,finite_card(B),A3)) ) ) ).

% card_vimage_inj_on_le
tff(fact_7707_set__decode__div__2,axiom,
    ! [Xa: nat] : ( nat_set_decode(divide_divide(nat,Xa,aa(num,nat,numeral_numeral(nat),bit0(one2)))) = vimage(nat,nat,suc,nat_set_decode(Xa)) ) ).

% set_decode_div_2
tff(fact_7708_set__encode__vimage__Suc,axiom,
    ! [A3: set(nat)] : ( aa(set(nat),nat,nat_set_encode,vimage(nat,nat,suc,A3)) = divide_divide(nat,aa(set(nat),nat,nat_set_encode,A3),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% set_encode_vimage_Suc
tff(fact_7709_subset__range__from__nat__into,axiom,
    ! [A: $tType,A3: set(A)] :
      ( countable_countable(A,A3)
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),aa(set(nat),set(A),image(nat,A,counta4804993851260445106t_into(A,A3)),top_top(set(nat)))) ) ).

% subset_range_from_nat_into
tff(fact_7710_Bseq__monoseq__convergent_H__dec,axiom,
    ! [F3: fun(nat,real),M7: nat] :
      ( bfun(nat,real,aa(nat,fun(nat,real),aTP_Lamp_aik(fun(nat,real),fun(nat,fun(nat,real)),F3),M7),at_top(nat))
     => ( ! [M2: nat,N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,N2)),aa(nat,real,F3,M2)) ) )
       => topolo6863149650580417670ergent(real,F3) ) ) ).

% Bseq_monoseq_convergent'_dec
tff(fact_7711_lim__le,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [F3: fun(nat,A),Xa: A] :
          ( topolo6863149650580417670ergent(A,F3)
         => ( ! [N2: nat] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(nat,A,F3,N2)),Xa)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),topolo3827282254853284352ce_Lim(nat,A,at_top(nat),F3)),Xa) ) ) ) ).

% lim_le
tff(fact_7712_convergent__Suc__iff,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,aTP_Lamp_wt(fun(nat,A),fun(nat,A),F3))
        <=> topolo6863149650580417670ergent(A,F3) ) ) ).

% convergent_Suc_iff
tff(fact_7713_convergent__add,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [X6: fun(nat,A),Y6: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,X6)
         => ( topolo6863149650580417670ergent(A,Y6)
           => topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ail(fun(nat,A),fun(fun(nat,A),fun(nat,A)),X6),Y6)) ) ) ) ).

% convergent_add
tff(fact_7714_convergent__add__const__iff,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [C2: A,F3: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aim(A,fun(fun(nat,A),fun(nat,A)),C2),F3))
        <=> topolo6863149650580417670ergent(A,F3) ) ) ).

% convergent_add_const_iff
tff(fact_7715_convergent__add__const__right__iff,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( topolo6863149650580417670ergent(A,aa(A,fun(nat,A),aTP_Lamp_ain(fun(nat,A),fun(A,fun(nat,A)),F3),C2))
        <=> topolo6863149650580417670ergent(A,F3) ) ) ).

% convergent_add_const_right_iff
tff(fact_7716_convergent__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [F3: fun(nat,A),M: nat] :
          ( topolo6863149650580417670ergent(A,aa(nat,fun(nat,A),aTP_Lamp_wu(fun(nat,A),fun(nat,fun(nat,A)),F3),M))
        <=> topolo6863149650580417670ergent(A,F3) ) ) ).

% convergent_ignore_initial_segment
tff(fact_7717_convergent__mult,axiom,
    ! [A: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [X6: fun(nat,A),Y6: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,X6)
         => ( topolo6863149650580417670ergent(A,Y6)
           => topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aio(fun(nat,A),fun(fun(nat,A),fun(nat,A)),X6),Y6)) ) ) ) ).

% convergent_mult
tff(fact_7718_convergent__mult__const__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F3: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wo(A,fun(fun(nat,A),fun(nat,A)),C2),F3))
          <=> topolo6863149650580417670ergent(A,F3) ) ) ) ).

% convergent_mult_const_iff
tff(fact_7719_convergent__mult__const__right__iff,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [C2: A,F3: fun(nat,A)] :
          ( ( C2 != zero_zero(A) )
         => ( topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wn(A,fun(fun(nat,A),fun(nat,A)),C2),F3))
          <=> topolo6863149650580417670ergent(A,F3) ) ) ) ).

% convergent_mult_const_right_iff
tff(fact_7720_convergent__diff__const__right__iff,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [F3: fun(nat,A),C2: A] :
          ( topolo6863149650580417670ergent(A,aa(A,fun(nat,A),aTP_Lamp_aip(fun(nat,A),fun(A,fun(nat,A)),F3),C2))
        <=> topolo6863149650580417670ergent(A,F3) ) ) ).

% convergent_diff_const_right_iff
tff(fact_7721_convergent__diff,axiom,
    ! [A: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [X6: fun(nat,A),Y6: fun(nat,A)] :
          ( topolo6863149650580417670ergent(A,X6)
         => ( topolo6863149650580417670ergent(A,Y6)
           => topolo6863149650580417670ergent(A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aiq(fun(nat,A),fun(fun(nat,A),fun(nat,A)),X6),Y6)) ) ) ) ).

% convergent_diff
tff(fact_7722_Bseq__mono__convergent,axiom,
    ! [X6: fun(nat,real)] :
      ( bfun(nat,real,X6,at_top(nat))
     => ( ! [M2: nat,N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N2)
           => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,X6,M2)),aa(nat,real,X6,N2)) )
       => topolo6863149650580417670ergent(real,X6) ) ) ).

% Bseq_mono_convergent
tff(fact_7723_convergent__realpow,axiom,
    ! [Xa: real] :
      ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Xa)
     => ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),one_one(real))
       => topolo6863149650580417670ergent(real,aa(real,fun(nat,real),power_power(real),Xa)) ) ) ).

% convergent_realpow
tff(fact_7724_range__from__nat__into__subset,axiom,
    ! [A: $tType,A3: set(A)] :
      ( ( A3 != bot_bot(set(A)) )
     => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(nat),set(A),image(nat,A,counta4804993851260445106t_into(A,A3)),top_top(set(nat)))),A3) ) ).

% range_from_nat_into_subset
tff(fact_7725_Bseq__monoseq__convergent_H__inc,axiom,
    ! [F3: fun(nat,real),M7: nat] :
      ( bfun(nat,real,aa(nat,fun(nat,real),aTP_Lamp_aik(fun(nat,real),fun(nat,fun(nat,real)),F3),M7),at_top(nat))
     => ( ! [M2: nat,N2: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M7),M2)
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M2),N2)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(nat,real,F3,M2)),aa(nat,real,F3,N2)) ) )
       => topolo6863149650580417670ergent(real,F3) ) ) ).

% Bseq_monoseq_convergent'_inc
tff(fact_7726_pair__lessI2,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),S),T2)
       => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),product_Pair(product_prod(nat,nat),product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),S)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,B2),T2)),fun_pair_less) ) ) ).

% pair_lessI2
tff(fact_7727_sorted__insort__insert__key,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [F3: fun(B,A),Xs: list(B),Xa: B] :
          ( sorted_wrt(A,ord_less_eq(A),map(B,A,F3,Xs))
         => sorted_wrt(A,ord_less_eq(A),map(B,A,F3,linord329482645794927042rt_key(B,A,F3,Xa,Xs))) ) ) ).

% sorted_insort_insert_key
tff(fact_7728_sorted__insort__insert,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),Xa: A] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),linord329482645794927042rt_key(A,A,aTP_Lamp_nv(A,A),Xa,Xs)) ) ) ).

% sorted_insort_insert
tff(fact_7729_pair__leqI2,axiom,
    ! [A2: nat,B2: nat,S: nat,T2: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),A2),B2)
     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),S),T2)
       => member(product_prod(product_prod(nat,nat),product_prod(nat,nat)),aa(product_prod(nat,nat),product_prod(product_prod(nat,nat),product_prod(nat,nat)),product_Pair(product_prod(nat,nat),product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,A2),S)),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,B2),T2)),fun_pair_leq) ) ) ).

% pair_leqI2
tff(fact_7730_cauchy__filter__metric__filtermap,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V768167426530841204y_dist(A)
        & topolo7287701948861334536_space(A) )
     => ! [F3: fun(B,A),F6: filter(B)] :
          ( topolo6773858410816713723filter(A,filtermap(B,A,F3,F6))
        <=> ! [E3: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),E3)
             => ? [P6: fun(B,$o)] :
                  ( eventually(B,P6,F6)
                  & ! [X4: B,Y5: B] :
                      ( ( aa(B,$o,P6,X4)
                        & aa(B,$o,P6,Y5) )
                     => aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,aa(B,A,F3,X4),aa(B,A,F3,Y5))),E3) ) ) ) ) ) ).

% cauchy_filter_metric_filtermap
tff(fact_7731_filtermap__mono,axiom,
    ! [B: $tType,A: $tType,F6: filter(A),F10: filter(A),F3: fun(A,B)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10)
     => aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtermap(A,B,F3,F6)),filtermap(A,B,F3,F10)) ) ).

% filtermap_mono
tff(fact_7732_filtermap__le__iff__le__filtercomap,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),F6: filter(B),G5: filter(A)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),filtermap(B,A,F3,F6)),G5)
    <=> aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),F6),filtercomap(B,A,F3,G5)) ) ).

% filtermap_le_iff_le_filtercomap
tff(fact_7733_filtermap__filtercomap,axiom,
    ! [B: $tType,A: $tType,F3: fun(B,A),F6: filter(A)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),filtermap(B,A,F3,filtercomap(B,A,F3,F6))),F6) ).

% filtermap_filtercomap
tff(fact_7734_filtercomap__filtermap,axiom,
    ! [B: $tType,A: $tType,F6: filter(A),F3: fun(A,B)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),filtercomap(A,B,F3,filtermap(A,B,F3,F6))) ).

% filtercomap_filtermap
tff(fact_7735_filterlim__def,axiom,
    ! [A: $tType,B: $tType,F3: fun(A,B),F22: filter(B),F12: filter(A)] :
      ( filterlim(A,B,F3,F22,F12)
    <=> aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtermap(A,B,F3,F12)),F22) ) ).

% filterlim_def
tff(fact_7736_filtermap__inf,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,A),F12: filter(B),F22: filter(B)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),filtermap(B,A,F3,aa(filter(B),filter(B),aa(filter(B),fun(filter(B),filter(B)),inf_inf(filter(B)),F12),F22))),aa(filter(A),filter(A),aa(filter(A),fun(filter(A),filter(A)),inf_inf(filter(A)),filtermap(B,A,F3,F12)),filtermap(B,A,F3,F22))) ).

% filtermap_inf
tff(fact_7737_filtermap__nhds__times,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [C2: A,A2: A] :
          ( ( C2 != zero_zero(A) )
         => ( filtermap(A,A,aa(A,fun(A,A),times_times(A),C2),topolo7230453075368039082e_nhds(A,A2)) = topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),A2)) ) ) ) ).

% filtermap_nhds_times
tff(fact_7738_filtermap__exp__at__top,axiom,
    filtermap(real,real,exp(real),at_top(real)) = at_top(real) ).

% filtermap_exp_at_top
tff(fact_7739_filtermap__ln__at__top,axiom,
    filtermap(real,real,ln_ln(real),at_top(real)) = at_top(real) ).

% filtermap_ln_at_top
tff(fact_7740_filtermap__nhds__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [D2: A,A2: A] : ( filtermap(A,A,aTP_Lamp_air(A,fun(A,A),D2),topolo7230453075368039082e_nhds(A,A2)) = topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2)) ) ) ).

% filtermap_nhds_shift
tff(fact_7741_filtermap__mono__strong,axiom,
    ! [B: $tType,A: $tType,F3: fun(A,B),F6: filter(A),G5: filter(A)] :
      ( inj_on(A,B,F3,top_top(set(A)))
     => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtermap(A,B,F3,F6)),filtermap(A,B,F3,G5))
      <=> aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),G5) ) ) ).

% filtermap_mono_strong
tff(fact_7742_filtermap__at__shift,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [D2: A,A2: A] : ( filtermap(A,A,aTP_Lamp_air(A,fun(A,A),D2),topolo174197925503356063within(A,A2,top_top(set(A)))) = topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),D2),top_top(set(A))) ) ) ).

% filtermap_at_shift
tff(fact_7743_filtermap__at__right__shift,axiom,
    ! [D2: real,A2: real] : ( filtermap(real,real,aTP_Lamp_ais(real,fun(real,real),D2),topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2))) = topolo174197925503356063within(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),D2),set_ord_greaterThan(real,aa(real,real,aa(real,fun(real,real),minus_minus(real),A2),D2))) ) ).

% filtermap_at_right_shift
tff(fact_7744_filtermap__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType,F3: fun(B,A),F6: fun(C,filter(B)),B3: set(C)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),filtermap(B,A,F3,aa(set(filter(B)),filter(B),complete_Inf_Inf(filter(B)),aa(set(C),set(filter(B)),image(C,filter(B),F6),B3)))),aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),aa(set(C),set(filter(A)),image(C,filter(A),aa(fun(C,filter(B)),fun(C,filter(A)),aTP_Lamp_ait(fun(B,A),fun(fun(C,filter(B)),fun(C,filter(A))),F3),F6)),B3))) ).

% filtermap_INF
tff(fact_7745_at__to__0,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [A2: A] : ( topolo174197925503356063within(A,A2,top_top(set(A))) = filtermap(A,A,aTP_Lamp_aiu(A,fun(A,A),A2),topolo174197925503356063within(A,zero_zero(A),top_top(set(A)))) ) ) ).

% at_to_0
tff(fact_7746_at__right__to__0,axiom,
    ! [A2: real] : ( topolo174197925503356063within(real,A2,set_ord_greaterThan(real,A2)) = filtermap(real,real,aTP_Lamp_aiv(real,fun(real,real),A2),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ) ).

% at_right_to_0
tff(fact_7747_filterlim__INF__INF,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,J4: set(A),I5: set(B),F3: fun(D,C),F6: fun(B,filter(D)),G5: fun(A,filter(C))] :
      ( ! [M2: A] :
          ( member(A,M2,J4)
         => ? [X3: B] :
              ( member(B,X3,I5)
              & aa(filter(C),$o,aa(filter(C),fun(filter(C),$o),ord_less_eq(filter(C)),filtermap(D,C,F3,aa(B,filter(D),F6,X3))),aa(A,filter(C),G5,M2)) ) )
     => filterlim(D,C,F3,aa(set(filter(C)),filter(C),complete_Inf_Inf(filter(C)),aa(set(A),set(filter(C)),image(A,filter(C),G5),J4)),aa(set(filter(D)),filter(D),complete_Inf_Inf(filter(D)),aa(set(B),set(filter(D)),image(B,filter(D),F6),I5))) ) ).

% filterlim_INF_INF
tff(fact_7748_filtermap__times__pos__at__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field(A)
        & topolo1944317154257567458pology(A) )
     => ! [C2: A,P2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),C2)
         => ( filtermap(A,A,aa(A,fun(A,A),times_times(A),C2),topolo174197925503356063within(A,P2,set_ord_greaterThan(A,P2))) = topolo174197925503356063within(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),P2),set_ord_greaterThan(A,aa(A,A,aa(A,fun(A,A),times_times(A),C2),P2))) ) ) ) ).

% filtermap_times_pos_at_right
tff(fact_7749_at__to__infinity,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ( topolo174197925503356063within(A,zero_zero(A),top_top(set(A))) = filtermap(A,A,inverse_inverse(A),at_infinity(A)) ) ) ).

% at_to_infinity
tff(fact_7750_at__top__to__right,axiom,
    at_top(real) = filtermap(real,real,inverse_inverse(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) ).

% at_top_to_right
tff(fact_7751_at__right__to__top,axiom,
    topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real))) = filtermap(real,real,inverse_inverse(real),at_top(real)) ).

% at_right_to_top
tff(fact_7752_filtermap__ln__at__right,axiom,
    filtermap(real,real,ln_ln(real),topolo174197925503356063within(real,zero_zero(real),set_ord_greaterThan(real,zero_zero(real)))) = at_bot(real) ).

% filtermap_ln_at_right
tff(fact_7753_and__not__num__eq__None__iff,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num(M,N) = none(num) )
    <=> ( aa(int,int,aa(int,fun(int,int),bit_se5824344872417868541ns_and(int),aa(num,int,numeral_numeral(int),M)),aa(int,int,bit_ri4277139882892585799ns_not(int),aa(num,int,numeral_numeral(int),N))) = zero_zero(int) ) ) ).

% and_not_num_eq_None_iff
tff(fact_7754_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ordering_top(A,aTP_Lamp_aiw(A,fun(A,$o)),aTP_Lamp_aix(A,fun(A,$o)),bot_bot(A)) ) ).

% bot.ordering_top_axioms
tff(fact_7755_take__bit__num__simps_I1_J,axiom,
    ! [M: num] : ( bit_take_bit_num(zero_zero(nat),M) = none(num) ) ).

% take_bit_num_simps(1)
tff(fact_7756_gcd__nat_Oordering__top__axioms,axiom,
    ordering_top(nat,dvd_dvd(nat),aTP_Lamp_ahr(nat,fun(nat,$o)),zero_zero(nat)) ).

% gcd_nat.ordering_top_axioms
tff(fact_7757_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: num] :
          ( ( bit_un7362597486090784418nd_num(M,N) = none(num) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344872417868541ns_and(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = zero_zero(A) ) ) ) ).

% and_num_eq_None_iff
tff(fact_7758_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( bit_se359711467146920520ations(A)
     => ! [M: nat,N: num] :
          ( ( bit_take_bit_num(M,N) = none(num) )
         => ( aa(A,A,bit_se2584673776208193580ke_bit(A,M),aa(num,A,numeral_numeral(A),N)) = zero_zero(A) ) ) ) ).

% take_bit_num_eq_None_imp
tff(fact_7759_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [M: num,N: num] :
          ( ( bit_un2480387367778600638or_num(M,N) = none(num) )
        <=> ( aa(A,A,aa(A,fun(A,A),bit_se5824344971392196577ns_xor(A),aa(num,A,numeral_numeral(A),M)),aa(num,A,numeral_numeral(A),N)) = zero_zero(A) ) ) ) ).

% xor_num_eq_None_iff
tff(fact_7760_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( order_top(A)
     => ordering_top(A,ord_less_eq(A),ord_less(A),top_top(A)) ) ).

% top.ordering_top_axioms
tff(fact_7761_bot__nat__0_Oordering__top__axioms,axiom,
    ordering_top(nat,aTP_Lamp_aa(nat,fun(nat,$o)),aTP_Lamp_eo(nat,fun(nat,$o)),zero_zero(nat)) ).

% bot_nat_0.ordering_top_axioms
tff(fact_7762_option_Osize_I3_J,axiom,
    ! [A: $tType] : ( aa(option(A),nat,size_size(option(A)),none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(3)
tff(fact_7763_take__bit__num__def,axiom,
    ! [N: nat,M: num] :
      ( bit_take_bit_num(N,M)
      = $ite(aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(num,nat,numeral_numeral(nat),M)) = zero_zero(nat),none(num),some(num,num_of_nat(aa(nat,nat,bit_se2584673776208193580ke_bit(nat,N),aa(num,nat,numeral_numeral(nat),M))))) ) ).

% take_bit_num_def
tff(fact_7764_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] : ( bit_take_bit_num(aa(nat,nat,suc,N),one2) = some(num,one2) ) ).

% take_bit_num_simps(2)
tff(fact_7765_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M: num] : ( bit_take_bit_num(aa(nat,nat,suc,N),aa(num,num,bit1,M)) = some(num,case_option(num,num,one2,bit1,bit_take_bit_num(N,M))) ) ).

% take_bit_num_simps(4)
tff(fact_7766_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M: num] : ( bit_take_bit_num(aa(nat,nat,suc,N),bit0(M)) = case_option(option(num),num,none(num),aTP_Lamp_aiy(num,option(num)),bit_take_bit_num(N,M)) ) ).

% take_bit_num_simps(3)
tff(fact_7767_option_Osize_I4_J,axiom,
    ! [A: $tType,X2: A] : ( aa(option(A),nat,size_size(option(A)),some(A,X2)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size(4)
tff(fact_7768_option_Osize__neq,axiom,
    ! [A: $tType,Xa: option(A)] : ( aa(option(A),nat,size_size(option(A)),Xa) != zero_zero(nat) ) ).

% option.size_neq
tff(fact_7769_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,Xa: fun(A,nat),X2: A] : ( size_option(A,Xa,some(A,X2)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(A,nat,Xa,X2)),aa(nat,nat,suc,zero_zero(nat))) ) ).

% option.size_gen(2)
tff(fact_7770_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,$o)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => ( ? [X3: A] :
                ( member(A,X3,aa(list(A),set(A),set2(A),Xs))
                & aa(A,$o,P,X3) )
           => ( find(A,P,Xs) = some(A,aa(set(A),A,lattic643756798350308766er_Min(A),collect(A,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aiz(list(A),fun(fun(A,$o),fun(A,$o)),Xs),P)))) ) ) ) ) ).

% sorted_find_Min
tff(fact_7771_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,Xa: fun(A,nat)] : ( size_option(A,Xa,none(A)) = aa(nat,nat,suc,zero_zero(nat)) ) ).

% option.size_gen(1)
tff(fact_7772_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( vEBT_VEBT_membermima(Xa,Xaa)
     => ( ! [Mi: nat,Ma2: nat] :
            ( ? [Va: list(vEBT_VEBT),Vb: vEBT_VEBT] : ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb) )
           => ~ ( ( Xaa = Mi )
                | ( Xaa = Ma2 ) ) )
       => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list(vEBT_VEBT)] :
              ( ? [Vc: vEBT_VEBT] : ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc) )
             => ~ ( ( Xaa = Mi )
                  | ( Xaa = Ma2 )
                  | $let(
                      pos: nat,
                      pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                      $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) )
         => ~ ! [V4: nat,TreeList: list(vEBT_VEBT)] :
                ( ? [Vd: vEBT_VEBT] : ( Xa = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd) )
               => ~ $let(
                      pos: nat,
                      pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                      $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
tff(fact_7773_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: fun(A,$o),Xs: list(A)] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),J),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs)))
     => ( aa(nat,A,nth(A,dropWhile(A,P,Xs)),J) = aa(nat,A,nth(A,Xs),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),J),aa(list(A),nat,size_size(list(A)),takeWhile(A,P,Xs)))) ) ) ).

% dropWhile_nth
tff(fact_7774_VEBT_Oinject_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,Y11: option(product_prod(nat,nat)),Y12: nat,Y13: list(vEBT_VEBT),Y14: vEBT_VEBT] :
      ( ( vEBT_Node(X11,X12,X13,X14) = vEBT_Node(Y11,Y12,Y13,Y14) )
    <=> ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
tff(fact_7775_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi2: nat,Ma: nat,Va2: list(vEBT_VEBT),Vb2: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma)),zero_zero(nat),Va2,Vb2),Xa)
    <=> ( ( Xa = Mi2 )
        | ( Xa = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
tff(fact_7776_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Xs: list(A),P: fun(A,$o)] :
          ( sorted_wrt(A,ord_less_eq(A),Xs)
         => sorted_wrt(A,ord_less_eq(A),dropWhile(A,P,Xs)) ) ) ).

% sorted_dropWhile
tff(fact_7777_VEBT_Osize_I3_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_list(vEBT_VEBT,size_size(vEBT_VEBT),X13)),aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size(3)
tff(fact_7778_length__dropWhile__le,axiom,
    ! [A: $tType,P: fun(A,$o),Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),dropWhile(A,P,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_dropWhile_le
tff(fact_7779_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list(vEBT_VEBT),Uy: vEBT_VEBT,Uz: nat] : ~ vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux,Uy),Uz) ).

% VEBT_internal.membermima.simps(2)
tff(fact_7780_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList2: list(vEBT_VEBT),Vd2: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V),TreeList2,Vd2),Xa)
    <=> $let(
          pos: nat,
          pos := vEBT_VEBT_high(Xa,divide_divide(nat,aa(nat,nat,suc,V),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,divide_divide(nat,aa(nat,nat,suc,V),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ).

% VEBT_internal.membermima.simps(5)
tff(fact_7781_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi2: nat,Ma: nat,V: nat,TreeList2: list(vEBT_VEBT),Vc2: vEBT_VEBT,Xa: nat] :
      ( vEBT_VEBT_membermima(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma)),aa(nat,nat,suc,V),TreeList2,Vc2),Xa)
    <=> ( ( Xa = Mi2 )
        | ( Xa = Ma )
        | $let(
            pos: nat,
            pos := vEBT_VEBT_high(Xa,divide_divide(nat,aa(nat,nat,suc,V),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,divide_divide(nat,aa(nat,nat,suc,V),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ).

% VEBT_internal.membermima.simps(4)
tff(fact_7782_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( vEBT_VEBT_membermima(Xa,Xaa)
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [Mi: nat,Ma2: nat,Va: list(vEBT_VEBT),Vb: vEBT_VEBT] :
              ( ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb) )
             => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb)),Xaa))
               => ~ ( ( Xaa = Mi )
                    | ( Xaa = Ma2 ) ) ) )
         => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc) )
               => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc)),Xaa))
                 => ~ ( ( Xaa = Mi )
                      | ( Xaa = Ma2 )
                      | $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) )
           => ~ ! [V4: nat,TreeList: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                  ( ( Xa = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd) )
                 => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd)),Xaa))
                   => ~ $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
tff(fact_7783_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat,Y: $o] :
      ( ( vEBT_VEBT_membermima(Xa,Xaa)
      <=> (Y) )
     => ( ( ? [Uu2: $o,Uv: $o] : ( Xa = vEBT_Leaf(Uu2,Uv) )
         => (Y) )
       => ( ( ? [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( Xa = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
           => (Y) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va: list(vEBT_VEBT),Vb: vEBT_VEBT] : ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb) )
               => ( (Y)
                <=> ~ ( ( Xaa = Mi )
                      | ( Xaa = Ma2 ) ) ) )
           => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list(vEBT_VEBT)] :
                  ( ? [Vc: vEBT_VEBT] : ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc) )
                 => ( (Y)
                  <=> ~ ( ( Xaa = Mi )
                        | ( Xaa = Ma2 )
                        | $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) )
             => ~ ! [V4: nat,TreeList: list(vEBT_VEBT)] :
                    ( ? [Vd: vEBT_VEBT] : ( Xa = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd) )
                   => ( (Y)
                    <=> ~ $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
tff(fact_7784_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( vEBT_Leaf(X21,X222) = vEBT_Leaf(Y21,Y222) )
    <=> ( ( (X21)
        <=> (Y21) )
        & ( (X222)
        <=> (Y222) ) ) ) ).

% VEBT.inject(2)
tff(fact_7785_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [Xa: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: $o,Uv: $o,D6: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv)),D6) )
     => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT,Deg2: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg,TreeList,Summary)),Deg2) ) ) ).

% VEBT_internal.valid'.cases
tff(fact_7786_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [Xa: product_prod(vEBT_VEBT,nat)] :
      ( ! [A4: $o,B4: $o,X: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),X) )
     => ( ! [Uu2: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT,Ux2: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv,Uw)),Ux2) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList: list(vEBT_VEBT),S3: vEBT_VEBT,X: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3)),X) ) ) ) ).

% VEBT_internal.naive_member.cases
tff(fact_7787_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT,X21: $o,X222: $o] : ( vEBT_Node(X11,X12,X13,X14) != vEBT_Leaf(X21,X222) ) ).

% VEBT.distinct(1)
tff(fact_7788_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv2: $o,Uw2: nat] : ~ vEBT_VEBT_membermima(vEBT_Leaf(Uu,Uv2),Uw2) ).

% VEBT_internal.membermima.simps(1)
tff(fact_7789_VEBT_Oexhaust,axiom,
    ! [Y: vEBT_VEBT] :
      ( ! [X112: option(product_prod(nat,nat)),X122: nat,X132: list(vEBT_VEBT),X142: vEBT_VEBT] : ( Y != vEBT_Node(X112,X122,X132,X142) )
     => ~ ! [X212: $o,X223: $o] : ( Y != vEBT_Leaf(X212,X223) ) ) ).

% VEBT.exhaust
tff(fact_7790_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] : ( aa(vEBT_VEBT,nat,size_size(vEBT_VEBT),vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size(4)
tff(fact_7791_VEBT__internal_Omembermima_Ocases,axiom,
    ! [Xa: product_prod(vEBT_VEBT,nat)] :
      ( ! [Uu2: $o,Uv: $o,Uw: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv)),Uw) )
     => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT,Uz2: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Uz2) )
       => ( ! [Mi: nat,Ma2: nat,Va: list(vEBT_VEBT),Vb: vEBT_VEBT,X: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb)),X) )
         => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list(vEBT_VEBT),Vc: vEBT_VEBT,X: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc)),X) )
           => ~ ! [V4: nat,TreeList: list(vEBT_VEBT),Vd: vEBT_VEBT,X: nat] : ( Xa != aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd)),X) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
tff(fact_7792_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( ~ vEBT_VEBT_membermima(Xa,Xaa)
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [Uu2: $o,Uv: $o] :
              ( ( Xa = vEBT_Leaf(Uu2,Uv) )
             => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv)),Xaa)) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xaa)) )
           => ( ! [Mi: nat,Ma2: nat,Va: list(vEBT_VEBT),Vb: vEBT_VEBT] :
                  ( ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb) )
                 => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb)),Xaa))
                   => ( ( Xaa = Mi )
                      | ( Xaa = Ma2 ) ) ) )
             => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                    ( ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc) )
                   => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc)),Xaa))
                     => ( ( Xaa = Mi )
                        | ( Xaa = Ma2 )
                        | $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) )
               => ~ ! [V4: nat,TreeList: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                      ( ( Xa = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd) )
                     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd)),Xaa))
                       => $let(
                            pos: nat,
                            pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                            $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
tff(fact_7793_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat,Y: $o] :
      ( ( vEBT_VEBT_membermima(Xa,Xaa)
      <=> (Y) )
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [Uu2: $o,Uv: $o] :
              ( ( Xa = vEBT_Leaf(Uu2,Uv) )
             => ( ~ (Y)
               => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv)),Xaa)) ) )
         => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
               => ( ~ (Y)
                 => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2)),Xaa)) ) )
           => ( ! [Mi: nat,Ma2: nat,Va: list(vEBT_VEBT),Vb: vEBT_VEBT] :
                  ( ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb) )
                 => ( ( (Y)
                    <=> ( ( Xaa = Mi )
                        | ( Xaa = Ma2 ) ) )
                   => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb)),Xaa)) ) )
             => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list(vEBT_VEBT),Vc: vEBT_VEBT] :
                    ( ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc) )
                   => ( ( (Y)
                      <=> ( ( Xaa = Mi )
                          | ( Xaa = Ma2 )
                          | $let(
                              pos: nat,
                              pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                              $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) )
                     => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc)),Xaa)) ) )
               => ~ ! [V4: nat,TreeList: list(vEBT_VEBT),Vd: vEBT_VEBT] :
                      ( ( Xa = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd) )
                     => ( ( (Y)
                        <=> $let(
                              pos: nat,
                              pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                              $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) )
                       => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V4351362008482014158ma_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd)),Xaa)) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
tff(fact_7794_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( ~ vEBT_VEBT_membermima(Xa,Xaa)
     => ( ! [Uu2: $o,Uv: $o] : ( Xa != vEBT_Leaf(Uu2,Uv) )
       => ( ! [Ux2: list(vEBT_VEBT),Uy2: vEBT_VEBT] : ( Xa != vEBT_Node(none(product_prod(nat,nat)),zero_zero(nat),Ux2,Uy2) )
         => ( ! [Mi: nat,Ma2: nat] :
                ( ? [Va: list(vEBT_VEBT),Vb: vEBT_VEBT] : ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),zero_zero(nat),Va,Vb) )
               => ( ( Xaa = Mi )
                  | ( Xaa = Ma2 ) ) )
           => ( ! [Mi: nat,Ma2: nat,V4: nat,TreeList: list(vEBT_VEBT)] :
                  ( ? [Vc: vEBT_VEBT] : ( Xa = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),aa(nat,nat,suc,V4),TreeList,Vc) )
                 => ( ( Xaa = Mi )
                    | ( Xaa = Ma2 )
                    | $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) )
             => ~ ! [V4: nat,TreeList: list(vEBT_VEBT)] :
                    ( ? [Vd: vEBT_VEBT] : ( Xa = vEBT_Node(none(product_prod(nat,nat)),aa(nat,nat,suc,V4),TreeList,Vd) )
                   => $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_VEBT_membermima(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
tff(fact_7795_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat,Y: $o] :
      ( ( vEBT_V5719532721284313246member(Xa,Xaa)
      <=> (Y) )
     => ( ! [A4: $o,B4: $o] :
            ( ( Xa = vEBT_Leaf(A4,B4) )
           => ( (Y)
            <=> ~ $ite(
                    Xaa = zero_zero(nat),
                    (A4),
                    $ite(Xaa = one_one(nat),(B4),$false) ) ) )
       => ( ( ? [Uu2: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT] : ( Xa = vEBT_Node(Uu2,zero_zero(nat),Uv,Uw) )
           => (Y) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList: list(vEBT_VEBT)] :
                ( ? [S3: vEBT_VEBT] : ( Xa = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3) )
               => ( (Y)
                <=> ~ $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
tff(fact_7796_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( vEBT_V5719532721284313246member(Xa,Xaa)
     => ( ! [A4: $o,B4: $o] :
            ( ( Xa = vEBT_Leaf(A4,B4) )
           => ~ $ite(
                  Xaa = zero_zero(nat),
                  (A4),
                  $ite(Xaa = one_one(nat),(B4),$false) ) )
       => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList: list(vEBT_VEBT)] :
              ( ? [S3: vEBT_VEBT] : ( Xa = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3) )
             => ~ $let(
                    pos: nat,
                    pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                    $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
tff(fact_7797_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option(product_prod(nat,nat)),Uv2: list(vEBT_VEBT),Uw2: vEBT_VEBT,Ux: nat] : ~ vEBT_V5719532721284313246member(vEBT_Node(Uu,zero_zero(nat),Uv2,Uw2),Ux) ).

% VEBT_internal.naive_member.simps(2)
tff(fact_7798_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,Xa: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Leaf(A2,B2),Xa)
    <=> $ite(
          Xa = zero_zero(nat),
          (A2),
          $ite(Xa = one_one(nat),(B2),$false) ) ) ).

% VEBT_internal.naive_member.simps(1)
tff(fact_7799_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option(product_prod(nat,nat)),V: nat,TreeList2: list(vEBT_VEBT),S: vEBT_VEBT,Xa: nat] :
      ( vEBT_V5719532721284313246member(vEBT_Node(Uy,aa(nat,nat,suc,V),TreeList2,S),Xa)
    <=> $let(
          pos: nat,
          pos := vEBT_VEBT_high(Xa,divide_divide(nat,aa(nat,nat,suc,V),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),pos),vEBT_VEBT_low(Xa,divide_divide(nat,aa(nat,nat,suc,V),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ).

% VEBT_internal.naive_member.simps(3)
tff(fact_7800_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( ~ vEBT_V5719532721284313246member(Xa,Xaa)
     => ( ! [A4: $o,B4: $o] :
            ( ( Xa = vEBT_Leaf(A4,B4) )
           => $ite(
                Xaa = zero_zero(nat),
                (A4),
                $ite(Xaa = one_one(nat),(B4),$false) ) )
       => ( ! [Uu2: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT] : ( Xa != vEBT_Node(Uu2,zero_zero(nat),Uv,Uw) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList: list(vEBT_VEBT)] :
                ( ? [S3: vEBT_VEBT] : ( Xa = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3) )
               => $let(
                    pos: nat,
                    pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                    $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
tff(fact_7801_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( ~ vEBT_V5719532721284313246member(Xa,Xaa)
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [A4: $o,B4: $o] :
              ( ( Xa = vEBT_Leaf(A4,B4) )
             => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),Xaa))
               => $ite(
                    Xaa = zero_zero(nat),
                    (A4),
                    $ite(Xaa = one_one(nat),(B4),$false) ) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(Uu2,zero_zero(nat),Uv,Uw) )
               => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv,Uw)),Xaa)) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList: list(vEBT_VEBT),S3: vEBT_VEBT] :
                  ( ( Xa = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3) )
                 => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3)),Xaa))
                   => $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
tff(fact_7802_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( vEBT_V5719532721284313246member(Xa,Xaa)
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [A4: $o,B4: $o] :
              ( ( Xa = vEBT_Leaf(A4,B4) )
             => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),Xaa))
               => ~ $ite(
                      Xaa = zero_zero(nat),
                      (A4),
                      $ite(Xaa = one_one(nat),(B4),$false) ) ) )
         => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList: list(vEBT_VEBT),S3: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3) )
               => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3)),Xaa))
                 => ~ $let(
                        pos: nat,
                        pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                        $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
tff(fact_7803_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat,Y: $o] :
      ( ( vEBT_V5719532721284313246member(Xa,Xaa)
      <=> (Y) )
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [A4: $o,B4: $o] :
              ( ( Xa = vEBT_Leaf(A4,B4) )
             => ( ( (Y)
                <=> $ite(
                      Xaa = zero_zero(nat),
                      (A4),
                      $ite(Xaa = one_one(nat),(B4),$false) ) )
               => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(A4,B4)),Xaa)) ) )
         => ( ! [Uu2: option(product_prod(nat,nat)),Uv: list(vEBT_VEBT),Uw: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(Uu2,zero_zero(nat),Uv,Uw) )
               => ( ~ (Y)
                 => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uu2,zero_zero(nat),Uv,Uw)),Xaa)) ) )
           => ~ ! [Uy2: option(product_prod(nat,nat)),V4: nat,TreeList: list(vEBT_VEBT),S3: vEBT_VEBT] :
                  ( ( Xa = vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3) )
                 => ( ( (Y)
                    <=> $let(
                          pos: nat,
                          pos := vEBT_VEBT_high(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2)))),
                          $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),pos),aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList)),vEBT_V5719532721284313246member(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),pos),vEBT_VEBT_low(Xaa,divide_divide(nat,aa(nat,nat,suc,V4),aa(num,nat,numeral_numeral(nat),bit0(one2))))),$false) ) )
                   => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_V5765760719290551771er_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Uy2,aa(nat,nat,suc,V4),TreeList,S3)),Xaa)) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
tff(fact_7804_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Node(X11,X12,X13,X14)) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),size_list(vEBT_VEBT,vEBT_size_VEBT,X13)),aa(vEBT_VEBT,nat,vEBT_size_VEBT,X14))),aa(nat,nat,suc,zero_zero(nat))) ) ).

% VEBT.size_gen(1)
tff(fact_7805_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
     => ( ( ? [A4: $o,B4: $o] : ( A1 = vEBT_Leaf(A4,B4) )
         => ( A22 != aa(nat,nat,suc,zero_zero(nat)) ) )
       => ( ! [TreeList: list(vEBT_VEBT),N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat] :
              ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary) )
             => ( ( A22 = Deg )
               => ( ! [X3: vEBT_VEBT] :
                      ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                     => vEBT_invar_vebt(X3,N2) )
                 => ( vEBT_invar_vebt(Summary,M2)
                   => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2) )
                     => ( ( M2 = N2 )
                       => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M2) )
                         => ( ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X_1)
                           => ~ ! [X3: vEBT_VEBT] :
                                  ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                 => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList: list(vEBT_VEBT),N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat] :
                ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),Deg,TreeList,Summary) )
               => ( ( A22 = Deg )
                 => ( ! [X3: vEBT_VEBT] :
                        ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                       => vEBT_invar_vebt(X3,N2) )
                   => ( vEBT_invar_vebt(Summary,M2)
                     => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2) )
                       => ( ( M2 = aa(nat,nat,suc,N2) )
                         => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M2) )
                           => ( ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X_1)
                             => ~ ! [X3: vEBT_VEBT] :
                                    ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                   => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList: list(vEBT_VEBT),N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat,Mi: nat,Ma2: nat] :
                  ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),Deg,TreeList,Summary) )
                 => ( ( A22 = Deg )
                   => ( ! [X3: vEBT_VEBT] :
                          ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                         => vEBT_invar_vebt(X3,N2) )
                     => ( vEBT_invar_vebt(Summary,M2)
                       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2) )
                         => ( ( M2 = N2 )
                           => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M2) )
                             => ( ! [I4: nat] :
                                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2))
                                   => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),X_12)
                                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),I4) ) )
                               => ( ( ( Mi = Ma2 )
                                   => ! [X3: vEBT_VEBT] :
                                        ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                       => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) ) )
                                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi),Ma2)
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg))
                                     => ~ ( ( Mi != Ma2 )
                                         => ! [I4: nat] :
                                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2))
                                             => ( ( ( vEBT_VEBT_high(Ma2,N2) = I4 )
                                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(Ma2,N2)) )
                                                & ! [X3: nat] :
                                                    ( ( ( vEBT_VEBT_high(X3,N2) = I4 )
                                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(X3,N2)) )
                                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi),X3)
                                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Ma2) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList: list(vEBT_VEBT),N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat,Mi: nat,Ma2: nat] :
                    ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi),Ma2)),Deg,TreeList,Summary) )
                   => ( ( A22 = Deg )
                     => ( ! [X3: vEBT_VEBT] :
                            ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                           => vEBT_invar_vebt(X3,N2) )
                       => ( vEBT_invar_vebt(Summary,M2)
                         => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2) )
                           => ( ( M2 = aa(nat,nat,suc,N2) )
                             => ( ( Deg = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N2),M2) )
                               => ( ! [I4: nat] :
                                      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2))
                                     => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),X_12)
                                      <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),I4) ) )
                                 => ( ( ( Mi = Ma2 )
                                     => ! [X3: vEBT_VEBT] :
                                          ( member(vEBT_VEBT,X3,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                         => ~ ? [X_1: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X3),X_1) ) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi),Ma2)
                                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg))
                                       => ~ ( ( Mi != Ma2 )
                                           => ! [I4: nat] :
                                                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M2))
                                               => ( ( ( vEBT_VEBT_high(Ma2,N2) = I4 )
                                                   => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(Ma2,N2)) )
                                                  & ! [X3: nat] :
                                                      ( ( ( vEBT_VEBT_high(X3,N2) = I4 )
                                                        & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList),I4)),vEBT_VEBT_low(X3,N2)) )
                                                     => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi),X3)
                                                        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X3),Ma2) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
tff(fact_7806_both__member__options__def,axiom,
    ! [T2: vEBT_VEBT,Xa: nat] :
      ( aa(nat,$o,vEBT_V8194947554948674370ptions(T2),Xa)
    <=> ( vEBT_V5719532721284313246member(T2,Xa)
        | vEBT_VEBT_membermima(T2,Xa) ) ) ).

% both_member_options_def
tff(fact_7807_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : vEBT_invar_vebt(vEBT_Leaf(A2,B2),aa(nat,nat,suc,zero_zero(nat))) ).

% invar_vebt.intros(1)
tff(fact_7808_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat] :
      ( ! [X: vEBT_VEBT] :
          ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
         => vEBT_invar_vebt(X,N) )
     => ( vEBT_invar_vebt(Summary2,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = N )
           => ( ( Deg3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X_13)
               => ( ! [X: vEBT_VEBT] :
                      ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                     => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_13) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Deg3,TreeList2,Summary2),Deg3) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
tff(fact_7809_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat] :
      ( ! [X: vEBT_VEBT] :
          ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
         => vEBT_invar_vebt(X,N) )
     => ( vEBT_invar_vebt(Summary2,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = aa(nat,nat,suc,N) )
           => ( ( Deg3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X_13)
               => ( ! [X: vEBT_VEBT] :
                      ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                     => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_13) )
                 => vEBT_invar_vebt(vEBT_Node(none(product_prod(nat,nat)),Deg3,TreeList2,Summary2),Deg3) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
tff(fact_7810_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] : ( aa(vEBT_VEBT,nat,vEBT_size_VEBT,vEBT_Leaf(X21,X222)) = zero_zero(nat) ) ).

% VEBT.size_gen(2)
tff(fact_7811_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat,Mi2: nat,Ma: nat] :
      ( ! [X: vEBT_VEBT] :
          ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
         => vEBT_invar_vebt(X,N) )
     => ( vEBT_invar_vebt(Summary2,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = N )
           => ( ( Deg3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ! [I2: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M))
                   => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I2)),X_12)
                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),I2) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X: vEBT_VEBT] :
                        ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                       => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_13) ) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi2),Ma)
                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg3))
                     => ( ( ( Mi2 != Ma )
                         => ! [I2: nat] :
                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M))
                             => ( ( ( vEBT_VEBT_high(Ma,N) = I2 )
                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I2)),vEBT_VEBT_low(Ma,N)) )
                                & ! [X: nat] :
                                    ( ( ( vEBT_VEBT_high(X,N) = I2 )
                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I2)),vEBT_VEBT_low(X,N)) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi2),X)
                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Ma) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma)),Deg3,TreeList2,Summary2),Deg3) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
tff(fact_7812_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list(vEBT_VEBT),N: nat,Summary2: vEBT_VEBT,M: nat,Deg3: nat,Mi2: nat,Ma: nat] :
      ( ! [X: vEBT_VEBT] :
          ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
         => vEBT_invar_vebt(X,N) )
     => ( vEBT_invar_vebt(Summary2,M)
       => ( ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M) )
         => ( ( M = aa(nat,nat,suc,N) )
           => ( ( Deg3 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),M) )
             => ( ! [I2: nat] :
                    ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M))
                   => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I2)),X_12)
                    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),I2) ) )
               => ( ( ( Mi2 = Ma )
                   => ! [X: vEBT_VEBT] :
                        ( member(vEBT_VEBT,X,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                       => ~ ? [X_13: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X),X_13) ) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi2),Ma)
                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Deg3))
                     => ( ( ( Mi2 != Ma )
                         => ! [I2: nat] :
                              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I2),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),M))
                             => ( ( ( vEBT_VEBT_high(Ma,N) = I2 )
                                 => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I2)),vEBT_VEBT_low(Ma,N)) )
                                & ! [X: nat] :
                                    ( ( ( vEBT_VEBT_high(X,N) = I2 )
                                      & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),I2)),vEBT_VEBT_low(X,N)) )
                                   => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi2),X)
                                      & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X),Ma) ) ) ) ) )
                       => vEBT_invar_vebt(vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi2),Ma)),Deg3,TreeList2,Summary2),Deg3) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
tff(fact_7813_invar__vebt_Osimps,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( vEBT_invar_vebt(A1,A22)
    <=> ( ( ? [A7: $o,B7: $o] : ( A1 = vEBT_Leaf(A7,B7) )
          & ( A22 = aa(nat,nat,suc,zero_zero(nat)) ) )
        | ? [TreeList3: list(vEBT_VEBT),N5: nat,Summary3: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X4,N5) )
            & vEBT_invar_vebt(Summary3,N5)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N5),N5) )
            & ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),X_12)
            & ! [X4: vEBT_VEBT] :
                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) )
        | ? [TreeList3: list(vEBT_VEBT),N5: nat,Summary3: vEBT_VEBT] :
            ( ( A1 = vEBT_Node(none(product_prod(nat,nat)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X4,N5) )
            & vEBT_invar_vebt(Summary3,aa(nat,nat,suc,N5))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N5)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N5),aa(nat,nat,suc,N5)) )
            & ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),X_12)
            & ! [X4: vEBT_VEBT] :
                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) )
        | ? [TreeList3: list(vEBT_VEBT),N5: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma3)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X4,N5) )
            & vEBT_invar_vebt(Summary3,N5)
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N5),N5) )
            & ! [I3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5))
               => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I3)),X_12)
                <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),I3) ) )
            & ( ( Mi3 = Ma3 )
             => ! [X4: vEBT_VEBT] :
                  ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
                 => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi3),Ma3)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),A22))
            & ( ( Mi3 != Ma3 )
             => ! [I3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),N5))
                 => ( ( ( vEBT_VEBT_high(Ma3,N5) = I3 )
                     => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I3)),vEBT_VEBT_low(Ma3,N5)) )
                    & ! [X4: nat] :
                        ( ( ( vEBT_VEBT_high(X4,N5) = I3 )
                          & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I3)),vEBT_VEBT_low(X4,N5)) )
                       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi3),X4)
                          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Ma3) ) ) ) ) ) )
        | ? [TreeList3: list(vEBT_VEBT),N5: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
            ( ( A1 = vEBT_Node(some(product_prod(nat,nat),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Mi3),Ma3)),A22,TreeList3,Summary3) )
            & ! [X4: vEBT_VEBT] :
                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
               => vEBT_invar_vebt(X4,N5) )
            & vEBT_invar_vebt(Summary3,aa(nat,nat,suc,N5))
            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList3) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N5)) )
            & ( A22 = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N5),aa(nat,nat,suc,N5)) )
            & ! [I3: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N5)))
               => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I3)),X_12)
                <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Summary3),I3) ) )
            & ( ( Mi3 = Ma3 )
             => ! [X4: vEBT_VEBT] :
                  ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList3))
                 => ~ ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X_12) ) )
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Mi3),Ma3)
            & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Ma3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),A22))
            & ( ( Mi3 != Ma3 )
             => ! [I3: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,nat,suc,N5)))
                 => ( ( ( vEBT_VEBT_high(Ma3,N5) = I3 )
                     => aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I3)),vEBT_VEBT_low(Ma3,N5)) )
                    & ! [X4: nat] :
                        ( ( ( vEBT_VEBT_high(X4,N5) = I3 )
                          & aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList3),I3)),vEBT_VEBT_low(X4,N5)) )
                       => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Mi3),X4)
                          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Ma3) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
tff(fact_7814_in__children__def,axiom,
    ! [N: nat,TreeList2: list(vEBT_VEBT),Xa: nat] :
      ( vEBT_V5917875025757280293ildren(N,TreeList2,Xa)
    <=> aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,TreeList2),vEBT_VEBT_high(Xa,N))),vEBT_VEBT_low(Xa,N)) ) ).

% in_children_def
tff(fact_7815_set__vebt__def,axiom,
    ! [T2: vEBT_VEBT] : ( vEBT_set_vebt(T2) = collect(nat,vEBT_V8194947554948674370ptions(T2)) ) ).

% set_vebt_def
tff(fact_7816_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( vEBT_invar_vebt(T2,D2)
     => vEBT_VEBT_valid(T2,D2) ) ).

% valid_eq1
tff(fact_7817_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( ~ vEBT_VEBT_valid(Xa,Xaa)
     => ( ( ? [Uu2: $o,Uv: $o] : ( Xa = vEBT_Leaf(Uu2,Uv) )
         => ( Xaa = one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
              ( ( Xa = vEBT_Node(Mima,Deg,TreeList,Summary) )
             => ( ( Deg = Xaa )
                & $let(
                    n: nat,
                    n := divide_divide(nat,Deg,aa(num,nat,numeral_numeral(nat),bit0(one2))),
                    $let(
                      m: nat,
                      m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                      ( ! [X4: vEBT_VEBT] :
                          ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                         => vEBT_VEBT_valid(X4,n) )
                      & vEBT_VEBT_valid(Summary,m)
                      & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),m) )
                      & case_option($o,product_prod(nat,nat),
                          ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X9)
                        & ! [X4: vEBT_VEBT] :
                            ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                           => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
                          product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m)),Mima) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
tff(fact_7818_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv2: $o,D2: nat] :
      ( vEBT_VEBT_valid(vEBT_Leaf(Uu,Uv2),D2)
    <=> ( D2 = one_one(nat) ) ) ).

% VEBT_internal.valid'.simps(1)
tff(fact_7819_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Inf_Inf(A),A3) = aa(set(A),A,complete_Sup_Sup(A),collect(A,aTP_Lamp_ajb(set(A),fun(A,$o),A3))) ) ) ).

% Inf_eq_Sup
tff(fact_7820_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(A)] : ( aa(set(A),A,complete_Sup_Sup(A),A3) = aa(set(A),A,complete_Inf_Inf(A),collect(A,aTP_Lamp_ajc(set(A),fun(A,$o),A3))) ) ) ).

% Sup_eq_Inf
tff(fact_7821_Ball__Collect,axiom,
    ! [A: $tType,A3: set(A),P: fun(A,$o)] :
      ( ! [X4: A] :
          ( member(A,X4,A3)
         => aa(A,$o,P,X4) )
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),collect(A,P)) ) ).

% Ball_Collect
tff(fact_7822_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option(product_prod(nat,nat)),Deg3: nat,TreeList2: list(vEBT_VEBT),Summary2: vEBT_VEBT,Deg4: nat] :
      ( vEBT_VEBT_valid(vEBT_Node(Mima2,Deg3,TreeList2,Summary2),Deg4)
    <=> ( ( Deg3 = Deg4 )
        & $let(
            n: nat,
            n := divide_divide(nat,Deg3,aa(num,nat,numeral_numeral(nat),bit0(one2))),
            $let(
              m: nat,
              m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg3),n),
              ( ! [X4: vEBT_VEBT] :
                  ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                 => vEBT_VEBT_valid(X4,n) )
              & vEBT_VEBT_valid(Summary2,m)
              & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList2) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),m) )
              & case_option($o,product_prod(nat,nat),
                  ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary2),X9)
                & ! [X4: vEBT_VEBT] :
                    ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList2))
                   => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
                  product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg3),TreeList2),Summary2),n),m)),Mima2) ) ) ) ) ) ).

% VEBT_internal.valid'.simps(2)
tff(fact_7823_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat,Y: $o] :
      ( ( vEBT_VEBT_valid(Xa,Xaa)
      <=> (Y) )
     => ( ( ? [Uu2: $o,Uv: $o] : ( Xa = vEBT_Leaf(Uu2,Uv) )
         => ( (Y)
          <=> ( Xaa != one_one(nat) ) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
              ( ( Xa = vEBT_Node(Mima,Deg,TreeList,Summary) )
             => ( (Y)
              <=> ~ ( ( Deg = Xaa )
                    & $let(
                        n: nat,
                        n := divide_divide(nat,Deg,aa(num,nat,numeral_numeral(nat),bit0(one2))),
                        $let(
                          m: nat,
                          m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                          ( ! [X4: vEBT_VEBT] :
                              ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                             => vEBT_VEBT_valid(X4,n) )
                          & vEBT_VEBT_valid(Summary,m)
                          & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),m) )
                          & case_option($o,product_prod(nat,nat),
                              ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X9)
                            & ! [X4: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
                              product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m)),Mima) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
tff(fact_7824_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( vEBT_VEBT_valid(Xa,Xaa)
     => ( ( ? [Uu2: $o,Uv: $o] : ( Xa = vEBT_Leaf(Uu2,Uv) )
         => ( Xaa != one_one(nat) ) )
       => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
              ( ( Xa = vEBT_Node(Mima,Deg,TreeList,Summary) )
             => ~ ( ( Deg = Xaa )
                  & $let(
                      n: nat,
                      n := divide_divide(nat,Deg,aa(num,nat,numeral_numeral(nat),bit0(one2))),
                      $let(
                        m: nat,
                        m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                        ( ! [X4: vEBT_VEBT] :
                            ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                           => vEBT_VEBT_valid(X4,n) )
                        & vEBT_VEBT_valid(Summary,m)
                        & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),m) )
                        & case_option($o,product_prod(nat,nat),
                            ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X9)
                          & ! [X4: vEBT_VEBT] :
                              ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                             => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
                            product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m)),Mima) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
tff(fact_7825_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( ~ vEBT_VEBT_valid(Xa,Xaa)
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [Uu2: $o,Uv: $o] :
              ( ( Xa = vEBT_Leaf(Uu2,Uv) )
             => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv)),Xaa))
               => ( Xaa = one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(Mima,Deg,TreeList,Summary) )
               => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg,TreeList,Summary)),Xaa))
                 => ( ( Deg = Xaa )
                    & $let(
                        n: nat,
                        n := divide_divide(nat,Deg,aa(num,nat,numeral_numeral(nat),bit0(one2))),
                        $let(
                          m: nat,
                          m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                          ( ! [X4: vEBT_VEBT] :
                              ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                             => vEBT_VEBT_valid(X4,n) )
                          & vEBT_VEBT_valid(Summary,m)
                          & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),m) )
                          & case_option($o,product_prod(nat,nat),
                              ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X9)
                            & ! [X4: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
                              product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m)),Mima) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
tff(fact_7826_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat] :
      ( vEBT_VEBT_valid(Xa,Xaa)
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [Uu2: $o,Uv: $o] :
              ( ( Xa = vEBT_Leaf(Uu2,Uv) )
             => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv)),Xaa))
               => ( Xaa != one_one(nat) ) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(Mima,Deg,TreeList,Summary) )
               => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg,TreeList,Summary)),Xaa))
                 => ~ ( ( Deg = Xaa )
                      & $let(
                          n: nat,
                          n := divide_divide(nat,Deg,aa(num,nat,numeral_numeral(nat),bit0(one2))),
                          $let(
                            m: nat,
                            m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                            ( ! [X4: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => vEBT_VEBT_valid(X4,n) )
                            & vEBT_VEBT_valid(Summary,m)
                            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),m) )
                            & case_option($o,product_prod(nat,nat),
                                ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X9)
                              & ! [X4: vEBT_VEBT] :
                                  ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                 => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
                                product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m)),Mima) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
tff(fact_7827_Sup__real__def,axiom,
    ! [X6: set(real)] : ( aa(set(real),real,complete_Sup_Sup(real),X6) = ord_Least(real,aTP_Lamp_ajd(set(real),fun(real,$o),X6)) ) ).

% Sup_real_def
tff(fact_7828_Sup__int__def,axiom,
    ! [X6: set(int)] : ( aa(set(int),int,complete_Sup_Sup(int),X6) = the(int,aTP_Lamp_aje(set(int),fun(int,$o),X6)) ) ).

% Sup_int_def
tff(fact_7829_Sup__Inf,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),collect(set(A),aTP_Lamp_ajf(set(set(A)),fun(set(A),$o),A3)))) ) ) ).

% Sup_Inf
tff(fact_7830_Inf__filter__def,axiom,
    ! [A: $tType,S2: set(filter(A))] : ( aa(set(filter(A)),filter(A),complete_Inf_Inf(filter(A)),S2) = aa(set(filter(A)),filter(A),complete_Sup_Sup(filter(A)),collect(filter(A),aTP_Lamp_ajg(set(filter(A)),fun(filter(A),$o),S2))) ) ).

% Inf_filter_def
tff(fact_7831_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [A3: set(set(A))] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),collect(set(A),aTP_Lamp_ajf(set(set(A)),fun(set(A),$o),A3))))) ) ).

% Inf_Sup_le
tff(fact_7832_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [A3: set(set(A))] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),collect(set(A),aTP_Lamp_ajh(set(set(A)),fun(set(A),$o),A3))))),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A3))) ) ).

% Sup_Inf_le
tff(fact_7833_SUP__INF__set,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [G: fun(B,A),A3: set(set(B))] : ( aa(set(A),A,complete_Sup_Sup(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_aji(fun(B,A),fun(set(B),A),G)),A3)) = aa(set(A),A,complete_Inf_Inf(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_ajj(fun(B,A),fun(set(B),A),G)),collect(set(B),aTP_Lamp_ajk(set(set(B)),fun(set(B),$o),A3)))) ) ) ).

% SUP_INF_set
tff(fact_7834_INF__SUP__set,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [G: fun(B,A),A3: set(set(B))] : ( aa(set(A),A,complete_Inf_Inf(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_ajj(fun(B,A),fun(set(B),A),G)),A3)) = aa(set(A),A,complete_Sup_Sup(A),aa(set(set(B)),set(A),image(set(B),A,aTP_Lamp_aji(fun(B,A),fun(set(B),A),G)),collect(set(B),aTP_Lamp_ajk(set(set(B)),fun(set(B),$o),A3)))) ) ) ).

% INF_SUP_set
tff(fact_7835_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [Xa: vEBT_VEBT,Xaa: nat,Y: $o] :
      ( ( vEBT_VEBT_valid(Xa,Xaa)
      <=> (Y) )
     => ( aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,Xa),Xaa))
       => ( ! [Uu2: $o,Uv: $o] :
              ( ( Xa = vEBT_Leaf(Uu2,Uv) )
             => ( ( (Y)
                <=> ( Xaa = one_one(nat) ) )
               => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Leaf(Uu2,Uv)),Xaa)) ) )
         => ~ ! [Mima: option(product_prod(nat,nat)),Deg: nat,TreeList: list(vEBT_VEBT),Summary: vEBT_VEBT] :
                ( ( Xa = vEBT_Node(Mima,Deg,TreeList,Summary) )
               => ( ( (Y)
                  <=> ( ( Deg = Xaa )
                      & $let(
                          n: nat,
                          n := divide_divide(nat,Deg,aa(num,nat,numeral_numeral(nat),bit0(one2))),
                          $let(
                            m: nat,
                            m := aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Deg),n),
                            ( ! [X4: vEBT_VEBT] :
                                ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                               => vEBT_VEBT_valid(X4,n) )
                            & vEBT_VEBT_valid(Summary,m)
                            & ( aa(list(vEBT_VEBT),nat,size_size(list(vEBT_VEBT)),TreeList) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),m) )
                            & case_option($o,product_prod(nat,nat),
                                ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(Summary),X9)
                              & ! [X4: vEBT_VEBT] :
                                  ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),TreeList))
                                 => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
                                product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Deg),TreeList),Summary),n),m)),Mima) ) ) ) ) )
                 => ~ aa(product_prod(vEBT_VEBT,nat),$o,accp(product_prod(vEBT_VEBT,nat),vEBT_VEBT_valid_rel),aa(nat,product_prod(vEBT_VEBT,nat),product_Pair(vEBT_VEBT,nat,vEBT_Node(Mima,Deg,TreeList,Summary)),Xaa)) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
tff(fact_7836_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [A3: set(set(A))] : aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(set(A)),set(A),image(set(A),A,complete_Sup_Sup(A)),A3))),aa(set(A),A,complete_Sup_Sup(A),aa(set(set(A)),set(A),image(set(A),A,complete_Inf_Inf(A)),collect(set(A),aTP_Lamp_ajl(set(set(A)),fun(set(A),$o),A3))))) ) ).

% finite_Inf_Sup
tff(fact_7837_VEBT_Osimps_I7_J,axiom,
    ! [A: $tType,F1: fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),F2: fun($o,fun($o,A)),X11: option(product_prod(nat,nat)),X12: nat,X13: list(vEBT_VEBT),X14: vEBT_VEBT] : ( vEBT_rec_VEBT(A,F1,F2,vEBT_Node(X11,X12,X13,X14)) = aa(A,A,aa(vEBT_VEBT,fun(A,A),aa(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A)),aa(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))),aa(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A)))),F1,X11),X12),map(vEBT_VEBT,product_prod(vEBT_VEBT,A),aa(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A)),aTP_Lamp_ajm(fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),fun(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A))),F1),F2),X13)),X14),vEBT_rec_VEBT(A,F1,F2,X14)) ) ).

% VEBT.simps(7)
tff(fact_7838_VEBT_Osimps_I8_J,axiom,
    ! [A: $tType,F1: fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),F2: fun($o,fun($o,A)),X21: $o,X222: $o] : ( vEBT_rec_VEBT(A,F1,F2,vEBT_Leaf(X21,X222)) = aa($o,A,aa($o,fun($o,A),F2,X21),X222) ) ).

% VEBT.simps(8)
tff(fact_7839_mlex__eq,axiom,
    ! [A: $tType,F3: fun(A,nat),R2: set(product_prod(A,A))] : ( mlex_prod(A,F3,R2) = collect(product_prod(A,A),product_case_prod(A,A,$o,aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aTP_Lamp_ajn(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,$o))),F3),R2))) ) ).

% mlex_eq
tff(fact_7840_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,B2)),euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))) ) ) ) ) ).

% euclidean_size_times_nonunit
tff(fact_7841_euclidean__size__of__nat,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( euclid6346220572633701492n_size(A,aa(nat,A,semiring_1_of_nat(A),N)) = N ) ) ).

% euclidean_size_of_nat
tff(fact_7842_size__0,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ( euclid6346220572633701492n_size(A,zero_zero(A)) = zero_zero(nat) ) ) ).

% size_0
tff(fact_7843_euclidean__size__eq__0__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A] :
          ( ( euclid6346220572633701492n_size(A,B2) = zero_zero(nat) )
        <=> ( B2 = zero_zero(A) ) ) ) ).

% euclidean_size_eq_0_iff
tff(fact_7844_euclidean__size__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( euclid6346220572633701492n_size(A,one_one(A)) = one_one(nat) ) ) ).

% euclidean_size_1
tff(fact_7845_euclidean__size__greater__0__iff,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),euclid6346220572633701492n_size(A,B2))
        <=> ( B2 != zero_zero(A) ) ) ) ).

% euclidean_size_greater_0_iff
tff(fact_7846_euclidean__size__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A] : ( euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),euclid6346220572633701492n_size(A,A2)),euclid6346220572633701492n_size(A,B2)) ) ) ).

% euclidean_size_mult
tff(fact_7847_euclidean__size__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( euclid6346220572633701492n_size(A,A2) = euclid6346220572633701492n_size(A,one_one(A)) ) ) ) ).

% euclidean_size_unit
tff(fact_7848_dvd__euclidean__size__eq__imp__dvd,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( euclid6346220572633701492n_size(A,A2) = euclid6346220572633701492n_size(A,B2) )
           => ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
             => aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2) ) ) ) ) ).

% dvd_euclidean_size_eq_imp_dvd
tff(fact_7849_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
        <=> ( ( euclid6346220572633701492n_size(A,A2) = euclid6346220572633701492n_size(A,one_one(A)) )
            & ( A2 != zero_zero(A) ) ) ) ) ).

% unit_iff_euclidean_size
tff(fact_7850_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),euclid6346220572633701492n_size(A,A2)),euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),B2),A2))) ) ) ).

% size_mult_mono'
tff(fact_7851_size__mult__mono,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),euclid6346220572633701492n_size(A,A2)),euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2))) ) ) ).

% size_mult_mono
tff(fact_7852_euclidean__size__times__unit,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),one_one(A))
         => ( euclid6346220572633701492n_size(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = euclid6346220572633701492n_size(A,B2) ) ) ) ).

% euclidean_size_times_unit
tff(fact_7853_dvd__proper__imp__size__less,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( ( B2 != zero_zero(A) )
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,A2)),euclid6346220572633701492n_size(A,B2)) ) ) ) ) ).

% dvd_proper_imp_size_less
tff(fact_7854_dvd__imp__size__le,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [A2: A,B2: A] :
          ( aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),A2),B2)
         => ( ( B2 != zero_zero(A) )
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),euclid6346220572633701492n_size(A,A2)),euclid6346220572633701492n_size(A,B2)) ) ) ) ).

% dvd_imp_size_le
tff(fact_7855_mod__size__less,axiom,
    ! [A: $tType] :
      ( euclid3725896446679973847miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,modulo_modulo(A,A2,B2))),euclid6346220572633701492n_size(A,B2)) ) ) ).

% mod_size_less
tff(fact_7856_mlex__leq,axiom,
    ! [A: $tType,F3: fun(A,nat),Xa: A,Y: A,R2: set(product_prod(A,A))] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,F3,Xa)),aa(A,nat,F3,Y))
     => ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),R2)
       => member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Xa),Y),mlex_prod(A,F3,R2)) ) ) ).

% mlex_leq
tff(fact_7857_divmod__cases,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,A2: A] :
          ( ( ( B2 != zero_zero(A) )
           => ( ( modulo_modulo(A,A2,B2) = zero_zero(A) )
             => ( A2 != aa(A,A,aa(A,fun(A,A),times_times(A),divide_divide(A,A2,B2)),B2) ) ) )
         => ( ( ( B2 != zero_zero(A) )
             => ! [Q3: A,R4: A] :
                  ( ( euclid7384307370059645450egment(A,R4) = euclid7384307370059645450egment(A,B2) )
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,R4)),euclid6346220572633701492n_size(A,B2))
                   => ( ( R4 != zero_zero(A) )
                     => ( ( divide_divide(A,A2,B2) = Q3 )
                       => ( ( modulo_modulo(A,A2,B2) = R4 )
                         => ( A2 != aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q3),B2)),R4) ) ) ) ) ) ) )
           => ( B2 = zero_zero(A) ) ) ) ) ).

% divmod_cases
tff(fact_7858_mod__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R: A,Q2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R) = euclid7384307370059645450egment(A,B2) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,R)),euclid6346220572633701492n_size(A,B2))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q2),B2)),R) = A2 )
               => ( modulo_modulo(A,A2,B2) = R ) ) ) ) ) ) ).

% mod_eqI
tff(fact_7859_abs__division__segment,axiom,
    ! [K: int] : ( aa(int,int,abs_abs(int),euclid7384307370059645450egment(int,K)) = one_one(int) ) ).

% abs_division_segment
tff(fact_7860_division__segment__1,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ( euclid7384307370059645450egment(A,one_one(A)) = one_one(A) ) ) ).

% division_segment_1
tff(fact_7861_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [K: num] : ( euclid7384307370059645450egment(A,aa(num,A,numeral_numeral(A),K)) = one_one(A) ) ) ).

% division_segment_numeral
tff(fact_7862_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [N: nat] : ( euclid7384307370059645450egment(A,aa(nat,A,semiring_1_of_nat(A),N)) = one_one(A) ) ) ).

% division_segment_of_nat
tff(fact_7863_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] : ( aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A2)),aa(nat,A,semiring_1_of_nat(A),euclid6346220572633701492n_size(A,A2))) = A2 ) ) ).

% division_segment_euclidean_size
tff(fact_7864_division__segment__mult,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A] :
          ( ( A2 != zero_zero(A) )
         => ( ( B2 != zero_zero(A) )
           => ( euclid7384307370059645450egment(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),euclid7384307370059645450egment(A,A2)),euclid7384307370059645450egment(A,B2)) ) ) ) ) ).

% division_segment_mult
tff(fact_7865_division__segment__not__0,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A] : ( euclid7384307370059645450egment(A,A2) != zero_zero(A) ) ) ).

% division_segment_not_0
tff(fact_7866_division__segment__nat__def,axiom,
    ! [N: nat] : ( euclid7384307370059645450egment(nat,N) = one_one(nat) ) ).

% division_segment_nat_def
tff(fact_7867_division__segment__eq__sgn,axiom,
    ! [K: int] :
      ( ( K != zero_zero(int) )
     => ( euclid7384307370059645450egment(int,K) = aa(int,int,sgn_sgn(int),K) ) ) ).

% division_segment_eq_sgn
tff(fact_7868_is__unit__division__segment,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A] : aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),euclid7384307370059645450egment(A,A2)),one_one(A)) ) ).

% is_unit_division_segment
tff(fact_7869_division__segment__mod,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),B2),A2)
           => ( euclid7384307370059645450egment(A,modulo_modulo(A,A2,B2)) = euclid7384307370059645450egment(A,B2) ) ) ) ) ).

% division_segment_mod
tff(fact_7870_of__nat__euclidean__size,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [A2: A] : ( aa(nat,A,semiring_1_of_nat(A),euclid6346220572633701492n_size(A,A2)) = divide_divide(A,A2,euclid7384307370059645450egment(A,A2)) ) ) ).

% of_nat_euclidean_size
tff(fact_7871_division__segment__int__def,axiom,
    ! [K: int] :
      ( euclid7384307370059645450egment(int,K)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),K),one_one(int),aa(int,int,uminus_uminus(int),one_one(int))) ) ).

% division_segment_int_def
tff(fact_7872_unique__euclidean__semiring__class_Odiv__eq__0__iff,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [A2: A,B2: A] :
          ( ( euclid7384307370059645450egment(A,A2) = euclid7384307370059645450egment(A,B2) )
         => ( ( divide_divide(A,A2,B2) = zero_zero(A) )
          <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,A2)),euclid6346220572633701492n_size(A,B2))
              | ( B2 = zero_zero(A) ) ) ) ) ) ).

% unique_euclidean_semiring_class.div_eq_0_iff
tff(fact_7873_div__eqI,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R: A,Q2: A,A2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R) = euclid7384307370059645450egment(A,B2) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,R)),euclid6346220572633701492n_size(A,B2))
             => ( ( aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q2),B2)),R) = A2 )
               => ( divide_divide(A,A2,B2) = Q2 ) ) ) ) ) ) ).

% div_eqI
tff(fact_7874_div__bounded,axiom,
    ! [A: $tType] :
      ( euclid3128863361964157862miring(A)
     => ! [B2: A,R: A,Q2: A] :
          ( ( B2 != zero_zero(A) )
         => ( ( euclid7384307370059645450egment(A,R) = euclid7384307370059645450egment(A,B2) )
           => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),euclid6346220572633701492n_size(A,R)),euclid6346220572633701492n_size(A,B2))
             => ( divide_divide(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Q2),B2)),R),B2) = Q2 ) ) ) ) ) ).

% div_bounded
tff(fact_7875_sorted__wrt__iff__nth__Suc__transp,axiom,
    ! [A: $tType,P: fun(A,fun(A,$o)),Xs: list(A)] :
      ( transp(A,P)
     => ( sorted_wrt(A,P,Xs)
      <=> ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,suc,I3)),aa(list(A),nat,size_size(list(A)),Xs))
           => aa(A,$o,aa(A,fun(A,$o),P,aa(nat,A,nth(A,Xs),I3)),aa(nat,A,nth(A,Xs),aa(nat,nat,suc,I3))) ) ) ) ).

% sorted_wrt_iff_nth_Suc_transp
tff(fact_7876_less__eq__enat__def,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),M),N)
    <=> extended_case_enat($o,aTP_Lamp_ajo(extended_enat,fun(nat,$o),M),$true,N) ) ).

% less_eq_enat_def
tff(fact_7877_transp__le,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => transp(A,ord_less_eq(A)) ) ).

% transp_le
tff(fact_7878_transp__ge,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => transp(A,aTP_Lamp_ajp(A,fun(A,$o))) ) ).

% transp_ge
tff(fact_7879_subset__subseqs,axiom,
    ! [A: $tType,X6: set(A),Xs: list(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),X6),aa(list(A),set(A),set2(A),Xs))
     => member(set(A),X6,aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),aa(list(list(A)),set(list(A)),set2(list(A)),subseqs(A,Xs)))) ) ).

% subset_subseqs
tff(fact_7880_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),field_char_0_of_rat(A,R)),one_one(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),R),one_one(rat)) ) ) ).

% of_rat_le_1_iff
tff(fact_7881_zero__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( zero_zero(A) = field_char_0_of_rat(A,A2) )
        <=> ( zero_zero(rat) = A2 ) ) ) ).

% zero_eq_of_rat_iff
tff(fact_7882_of__rat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( field_char_0_of_rat(A,A2) = zero_zero(A) )
        <=> ( A2 = zero_zero(rat) ) ) ) ).

% of_rat_eq_0_iff
tff(fact_7883_of__rat__0,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( field_char_0_of_rat(A,zero_zero(rat)) = zero_zero(A) ) ) ).

% of_rat_0
tff(fact_7884_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( one_one(A) = field_char_0_of_rat(A,A2) )
        <=> ( one_one(rat) = A2 ) ) ) ).

% one_eq_of_rat_iff
tff(fact_7885_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( field_char_0_of_rat(A,A2) = one_one(A) )
        <=> ( A2 = one_one(rat) ) ) ) ).

% of_rat_eq_1_iff
tff(fact_7886_of__rat__1,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( field_char_0_of_rat(A,one_one(rat)) = one_one(A) ) ) ).

% of_rat_1
tff(fact_7887_of__rat__of__nat__eq,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [N: nat] : ( field_char_0_of_rat(A,aa(nat,rat,semiring_1_of_nat(rat),N)) = aa(nat,A,semiring_1_of_nat(A),N) ) ) ).

% of_rat_of_nat_eq
tff(fact_7888_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),field_char_0_of_rat(A,R)),zero_zero(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R),zero_zero(rat)) ) ) ).

% of_rat_less_0_iff
tff(fact_7889_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),zero_zero(A)),field_char_0_of_rat(A,R))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R) ) ) ).

% zero_less_of_rat_iff
tff(fact_7890_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),field_char_0_of_rat(A,R)),one_one(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R),one_one(rat)) ) ) ).

% of_rat_less_1_iff
tff(fact_7891_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less(A),one_one(A)),field_char_0_of_rat(A,R))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),one_one(rat)),R) ) ) ).

% one_less_of_rat_iff
tff(fact_7892_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),field_char_0_of_rat(A,R))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),zero_zero(rat)),R) ) ) ).

% zero_le_of_rat_iff
tff(fact_7893_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),field_char_0_of_rat(A,R)),zero_zero(A))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),R),zero_zero(rat)) ) ) ).

% of_rat_le_0_iff
tff(fact_7894_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ( field_char_0_of_rat(A,aa(rat,rat,uminus_uminus(rat),one_one(rat))) = aa(A,A,uminus_uminus(A),one_one(A)) ) ) ).

% of_rat_neg_one
tff(fact_7895_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),one_one(A)),field_char_0_of_rat(A,R))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),one_one(rat)),R) ) ) ).

% one_le_of_rat_iff
tff(fact_7896_of__rat__less__eq,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [R: rat,S: rat] :
          ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),field_char_0_of_rat(A,R)),field_char_0_of_rat(A,S))
        <=> aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),R),S) ) ) ).

% of_rat_less_eq
tff(fact_7897_of__rat__mult,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat,B2: rat] : ( field_char_0_of_rat(A,aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),A2),B2)) = aa(A,A,aa(A,fun(A,A),times_times(A),field_char_0_of_rat(A,A2)),field_char_0_of_rat(A,B2)) ) ) ).

% of_rat_mult
tff(fact_7898_of__rat__add,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat,B2: rat] : ( field_char_0_of_rat(A,aa(rat,rat,aa(rat,fun(rat,rat),plus_plus(rat),A2),B2)) = aa(A,A,aa(A,fun(A,A),plus_plus(A),field_char_0_of_rat(A,A2)),field_char_0_of_rat(A,B2)) ) ) ).

% of_rat_add
tff(fact_7899_of__rat__diff,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat,B2: rat] : ( field_char_0_of_rat(A,aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),A2),B2)) = aa(A,A,aa(A,fun(A,A),minus_minus(A),field_char_0_of_rat(A,A2)),field_char_0_of_rat(A,B2)) ) ) ).

% of_rat_diff
tff(fact_7900_Real__leI,axiom,
    ! [X6: fun(nat,rat),Y: real] :
      ( cauchy(X6)
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),field_char_0_of_rat(real,aa(nat,rat,X6,N2))),Y)
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(fun(nat,rat),real,real2,X6)),Y) ) ) ).

% Real_leI
tff(fact_7901_le__RealI,axiom,
    ! [Y6: fun(nat,rat),Xa: real] :
      ( cauchy(Y6)
     => ( ! [N2: nat] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),field_char_0_of_rat(real,aa(nat,rat,Y6,N2)))
       => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Xa),aa(fun(nat,rat),real,real2,Y6)) ) ) ).

% le_RealI
tff(fact_7902_nonzero__of__rat__inverse,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [A2: rat] :
          ( ( A2 != zero_zero(rat) )
         => ( field_char_0_of_rat(A,aa(rat,rat,inverse_inverse(rat),A2)) = aa(A,A,inverse_inverse(A),field_char_0_of_rat(A,A2)) ) ) ) ).

% nonzero_of_rat_inverse
tff(fact_7903_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [B2: rat,A2: rat] :
          ( ( B2 != zero_zero(rat) )
         => ( field_char_0_of_rat(A,divide_divide(rat,A2,B2)) = divide_divide(A,field_char_0_of_rat(A,A2),field_char_0_of_rat(A,B2)) ) ) ) ).

% nonzero_of_rat_divide
tff(fact_7904_of__rat__rat,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [B2: int,A2: int] :
          ( ( B2 != zero_zero(int) )
         => ( field_char_0_of_rat(A,aa(int,rat,aa(int,fun(int,rat),fract,A2),B2)) = divide_divide(A,aa(int,A,ring_1_of_int(A),A2),aa(int,A,ring_1_of_int(A),B2)) ) ) ) ).

% of_rat_rat
tff(fact_7905_Collect__finite__subset__eq__lists,axiom,
    ! [A: $tType,T5: set(A)] : ( collect(set(A),aTP_Lamp_aed(set(A),fun(set(A),$o),T5)) = aa(set(list(A)),set(set(A)),image(list(A),set(A),set2(A)),lists(A,T5)) ) ).

% Collect_finite_subset_eq_lists
tff(fact_7906_span__explicit_H,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: set(A)] : ( real_Vector_span(A,B2) = collect(A,aTP_Lamp_ajq(set(A),fun(A,$o),B2)) ) ) ).

% span_explicit'
tff(fact_7907_span__insert__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),insert(A,zero_zero(A)),S2)) = real_Vector_span(A,S2) ) ) ).

% span_insert_0
tff(fact_7908_span__empty,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ( real_Vector_span(A,bot_bot(set(A))) = aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A))) ) ) ).

% span_empty
tff(fact_7909_span__delete__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A))))) = real_Vector_span(A,S2) ) ) ).

% span_delete_0
tff(fact_7910_span__Un,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),T5: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),T5)) = collect(A,aa(set(A),fun(A,$o),aTP_Lamp_ajr(set(A),fun(set(A),fun(A,$o)),S2),T5)) ) ) ).

% span_Un
tff(fact_7911_span__insert,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: A,S2: set(A)] : ( real_Vector_span(A,aa(set(A),set(A),insert(A,A2),S2)) = collect(A,aa(set(A),fun(A,$o),aTP_Lamp_ajs(A,fun(set(A),fun(A,$o)),A2),S2)) ) ) ).

% span_insert
tff(fact_7912_lists__eq__set,axiom,
    ! [A: $tType,A3: set(A)] : ( lists(A,A3) = collect(list(A),aTP_Lamp_ajt(set(A),fun(list(A),$o),A3)) ) ).

% lists_eq_set
tff(fact_7913_span__breakdown__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,A2: A,S2: set(A)] :
          ( member(A,Xa,real_Vector_span(A,aa(set(A),set(A),insert(A,A2),S2)))
        <=> ? [K2: real] : member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),aa(A,A,real_V8093663219630862766scaleR(A,K2),A2)),real_Vector_span(A,S2)) ) ) ).

% span_breakdown_eq
tff(fact_7914_in__span__delete,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A2: A,S2: set(A),B2: A] :
          ( member(A,A2,real_Vector_span(A,S2))
         => ( ~ member(A,A2,real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))))
           => member(A,B2,real_Vector_span(A,aa(set(A),set(A),insert(A,A2),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A))))))) ) ) ) ).

% in_span_delete
tff(fact_7915_span__diff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,S2: set(A),Y: A] :
          ( member(A,Xa,real_Vector_span(A,S2))
         => ( member(A,Y,real_Vector_span(A,S2))
           => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y),real_Vector_span(A,S2)) ) ) ) ).

% span_diff
tff(fact_7916_eq__span__insert__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,Y: A,S2: set(A)] :
          ( member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y),real_Vector_span(A,S2))
         => ( real_Vector_span(A,aa(set(A),set(A),insert(A,Xa),S2)) = real_Vector_span(A,aa(set(A),set(A),insert(A,Y),S2)) ) ) ) ).

% eq_span_insert_eq
tff(fact_7917_span__induct__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,S2: set(A),H: fun(A,$o)] :
          ( member(A,Xa,real_Vector_span(A,S2))
         => ( aa(A,$o,H,zero_zero(A))
           => ( ! [C4: real,X: A,Y3: A] :
                  ( member(A,X,S2)
                 => ( aa(A,$o,H,Y3)
                   => aa(A,$o,H,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,real_V8093663219630862766scaleR(A,C4),X)),Y3)) ) )
             => aa(A,$o,H,Xa) ) ) ) ) ).

% span_induct_alt
tff(fact_7918_span__add,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,S2: set(A),Y: A] :
          ( member(A,Xa,real_Vector_span(A,S2))
         => ( member(A,Y,real_Vector_span(A,S2))
           => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y),real_Vector_span(A,S2)) ) ) ) ).

% span_add
tff(fact_7919_span__add__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Xa: A,S2: set(A),Y: A] :
          ( member(A,Xa,real_Vector_span(A,S2))
         => ( member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y),real_Vector_span(A,S2))
          <=> member(A,Y,real_Vector_span(A,S2)) ) ) ) ).

% span_add_eq
tff(fact_7920_span__add__eq2,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Y: A,S2: set(A),Xa: A] :
          ( member(A,Y,real_Vector_span(A,S2))
         => ( member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y),real_Vector_span(A,S2))
          <=> member(A,Xa,real_Vector_span(A,S2)) ) ) ) ).

% span_add_eq2
tff(fact_7921_span__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] : member(A,zero_zero(A),real_Vector_span(A,S2)) ) ).

% span_0
tff(fact_7922_span__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),T5: set(A)] :
          ( ( real_Vector_span(A,S2) = real_Vector_span(A,T5) )
        <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),real_Vector_span(A,T5))
            & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T5),real_Vector_span(A,S2)) ) ) ) ).

% span_eq
tff(fact_7923_span__mono,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),real_Vector_span(A,A3)),real_Vector_span(A,B3)) ) ) ).

% span_mono
tff(fact_7924_span__superset,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] : aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),real_Vector_span(A,S2)) ) ).

% span_superset
tff(fact_7925_maximal__independent__subset__extend,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),V2: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),V2)
         => ( ~ real_V358717886546972837endent(A,S2)
           => ~ ! [B9: set(A)] :
                  ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),B9)
                 => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B9),V2)
                   => ( ~ real_V358717886546972837endent(A,B9)
                     => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,B9)) ) ) ) ) ) ) ).

% maximal_independent_subset_extend
tff(fact_7926_spanning__subset__independent,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),A3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
         => ( ~ real_V358717886546972837endent(A,A3)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),real_Vector_span(A,B3))
             => ( A3 = B3 ) ) ) ) ) ).

% spanning_subset_independent
tff(fact_7927_maximal__independent__subset,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [V2: set(A)] :
          ~ ! [B9: set(A)] :
              ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B9),V2)
             => ( ~ real_V358717886546972837endent(A,B9)
               => ~ aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,B9)) ) ) ) ).

% maximal_independent_subset
tff(fact_7928_lists__mono,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
     => aa(set(list(A)),$o,aa(set(list(A)),fun(set(list(A)),$o),ord_less_eq(set(list(A))),lists(A,A3)),lists(A,B3)) ) ).

% lists_mono
tff(fact_7929_dependent__def,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [P: set(A)] :
          ( real_V358717886546972837endent(A,P)
        <=> ? [X4: A] :
              ( member(A,X4,P)
              & member(A,X4,real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),P),aa(set(A),set(A),insert(A,X4),bot_bot(set(A)))))) ) ) ) ).

% dependent_def
tff(fact_7930_span__image__scale,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),C2: fun(A,real)] :
          ( aa(set(A),$o,finite_finite(A),S2)
         => ( ! [X: A] :
                ( member(A,X,S2)
               => ( aa(A,real,C2,X) != zero_zero(real) ) )
           => ( real_Vector_span(A,aa(set(A),set(A),image(A,A,aTP_Lamp_aia(fun(A,real),fun(A,A),C2)),S2)) = real_Vector_span(A,S2) ) ) ) ) ).

% span_image_scale
tff(fact_7931_span__explicit,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: set(A)] : ( real_Vector_span(A,B2) = collect(A,aTP_Lamp_aju(set(A),fun(A,$o),B2)) ) ) ).

% span_explicit
tff(fact_7932_span__breakdown,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B2: A,S2: set(A),A2: A] :
          ( member(A,B2,S2)
         => ( member(A,A2,real_Vector_span(A,S2))
           => ? [K3: real] : member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),aa(A,A,real_V8093663219630862766scaleR(A,K3),B2)),real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),S2),aa(set(A),set(A),insert(A,B2),bot_bot(set(A)))))) ) ) ) ).

% span_breakdown
tff(fact_7933_independent__span__bound,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [T5: set(A),S2: set(A)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( ~ real_V358717886546972837endent(A,S2)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),real_Vector_span(A,T5))
             => ( aa(set(A),$o,finite_finite(A),S2)
                & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(set(A),nat,finite_card(A),S2)),aa(set(A),nat,finite_card(A),T5)) ) ) ) ) ) ).

% independent_span_bound
tff(fact_7934_exchange__lemma,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [T5: set(A),S2: set(A)] :
          ( aa(set(A),$o,finite_finite(A),T5)
         => ( ~ real_V358717886546972837endent(A,S2)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),real_Vector_span(A,T5))
             => ? [T13: set(A)] :
                  ( ( aa(set(A),nat,finite_card(A),T13) = aa(set(A),nat,finite_card(A),T5) )
                  & aa(set(A),$o,finite_finite(A),T13)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T13)
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T13),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),S2),T5))
                  & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),real_Vector_span(A,T13)) ) ) ) ) ) ).

% exchange_lemma
tff(fact_7935_span__alt,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] : ( real_Vector_span(A,B3) = collect(A,aTP_Lamp_ajv(set(A),fun(A,$o),B3)) ) ) ).

% span_alt
tff(fact_7936_representation__def,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A] :
          ( real_V7696804695334737415tation(A,Basis,V)
          = $ite(
              ( ~ real_V358717886546972837endent(A,Basis)
              & member(A,V,real_Vector_span(A,Basis)) ),
              fChoice(fun(A,real),aa(A,fun(fun(A,real),$o),aTP_Lamp_ajw(set(A),fun(A,fun(fun(A,real),$o)),Basis),V)),
              aTP_Lamp_ajx(A,real) ) ) ) ).

% representation_def
tff(fact_7937_extend__basis__def,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] : ( real_V4986007116245087402_basis(A,B3) = fChoice(set(A),aTP_Lamp_ajy(set(A),fun(set(A),$o),B3)) ) ) ).

% extend_basis_def
tff(fact_7938_finite__representation,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A] : aa(set(A),$o,finite_finite(A),collect(A,aa(A,fun(A,$o),aTP_Lamp_ajz(set(A),fun(A,fun(A,$o)),Basis),V))) ) ).

% finite_representation
tff(fact_7939_representation__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),X3: A] : ( aa(A,real,real_V7696804695334737415tation(A,Basis,zero_zero(A)),X3) = zero_zero(real) ) ) ).

% representation_zero
tff(fact_7940_representation__ne__zero,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,B2: A] :
          ( ( aa(A,real,real_V7696804695334737415tation(A,Basis,V),B2) != zero_zero(real) )
         => member(A,B2,Basis) ) ) ).

% representation_ne_zero
tff(fact_7941_representation__basis,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),B2: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,B2,Basis)
           => ! [X3: A] :
                ( aa(A,real,real_V7696804695334737415tation(A,Basis,B2),X3)
                = $ite(X3 = B2,one_one(real),zero_zero(real)) ) ) ) ) ).

% representation_basis
tff(fact_7942_representation__extend,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,Basis2: set(A)] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis2))
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Basis2),Basis)
             => ( real_V7696804695334737415tation(A,Basis,V) = real_V7696804695334737415tation(A,Basis2,V) ) ) ) ) ) ).

% representation_extend
tff(fact_7943_extend__basis__superset,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A)] :
          ( ~ real_V358717886546972837endent(A,B3)
         => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),real_V4986007116245087402_basis(A,B3)) ) ) ).

% extend_basis_superset
tff(fact_7944_representation__add,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,U: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( member(A,U,real_Vector_span(A,Basis))
             => ! [X3: A] : ( aa(A,real,real_V7696804695334737415tation(A,Basis,aa(A,A,aa(A,fun(A,A),plus_plus(A),U),V)),X3) = aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(A,real,real_V7696804695334737415tation(A,Basis,U),X3)),aa(A,real,real_V7696804695334737415tation(A,Basis,V),X3)) ) ) ) ) ) ).

% representation_add
tff(fact_7945_representation__diff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,U: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( member(A,U,real_Vector_span(A,Basis))
             => ! [X3: A] : ( aa(A,real,real_V7696804695334737415tation(A,Basis,aa(A,A,aa(A,fun(A,A),minus_minus(A),U),V)),X3) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(A,real,real_V7696804695334737415tation(A,Basis,U),X3)),aa(A,real,real_V7696804695334737415tation(A,Basis,V),X3)) ) ) ) ) ) ).

% representation_diff
tff(fact_7946_representation__scale,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,R: real] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ! [X3: A] : ( aa(A,real,real_V7696804695334737415tation(A,Basis,aa(A,A,real_V8093663219630862766scaleR(A,R),V)),X3) = aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(A,real,real_V7696804695334737415tation(A,Basis,V),X3)) ) ) ) ) ).

% representation_scale
tff(fact_7947_sum__nonzero__representation__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aa(A,fun(A,A),aTP_Lamp_aka(set(A),fun(A,fun(A,A)),Basis),V)),collect(A,aa(A,fun(A,$o),aTP_Lamp_ajz(set(A),fun(A,fun(A,$o)),Basis),V))) = V ) ) ) ) ).

% sum_nonzero_representation_eq
tff(fact_7948_sum__representation__eq,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,B3: set(A)] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( aa(set(A),$o,finite_finite(A),B3)
             => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Basis),B3)
               => ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aa(A,fun(A,A),aTP_Lamp_aka(set(A),fun(A,fun(A,A)),Basis),V)),B3) = V ) ) ) ) ) ) ).

% sum_representation_eq
tff(fact_7949_representation__eqI,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Basis: set(A),V: A,F3: fun(A,real)] :
          ( ~ real_V358717886546972837endent(A,Basis)
         => ( member(A,V,real_Vector_span(A,Basis))
           => ( ! [B4: A] :
                  ( ( aa(A,real,F3,B4) != zero_zero(real) )
                 => member(A,B4,Basis) )
             => ( aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F3)))
               => ( ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),F3)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F3))) = V )
                 => ( real_V7696804695334737415tation(A,Basis,V) = F3 ) ) ) ) ) ) ) ).

% representation_eqI
tff(fact_7950_construct__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [B3: set(B),G: fun(B,A),V: B] : ( real_V4425403222259421789struct(B,A,B3,G,V) = aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),aa(B,fun(B,A),aa(fun(B,A),fun(B,fun(B,A)),aTP_Lamp_akb(set(B),fun(fun(B,A),fun(B,fun(B,A))),B3),G),V)),collect(B,aa(B,fun(B,$o),aTP_Lamp_akc(set(B),fun(B,fun(B,$o)),B3),V))) ) ) ).

% construct_def
tff(fact_7951_dim__def,axiom,
    ! [V2: set(a)] :
      ( real_Vector_dim(a,V2)
      = $ite(
          ? [B7: set(a)] :
            ( ~ real_V358717886546972837endent(a,B7)
            & ( real_Vector_span(a,B7) = real_Vector_span(a,V2) ) ),
          aa(set(a),nat,finite_card(a),fChoice(set(a),aTP_Lamp_akd(set(a),fun(set(a),$o),V2))),
          zero_zero(nat) ) ) ).

% dim_def
tff(fact_7952_construct__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [B3: set(A),F3: fun(A,B),G: fun(A,B),V: A] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( real_V4425403222259421789struct(A,B,B3,aa(fun(A,B),fun(A,B),aTP_Lamp_ake(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G),V) = aa(B,B,aa(B,fun(B,B),plus_plus(B),real_V4425403222259421789struct(A,B,B3,F3,V)),real_V4425403222259421789struct(A,B,B3,G,V)) ) ) ) ).

% construct_add
tff(fact_7953_dim__le__card_H,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S: set(A)] :
          ( aa(set(A),$o,finite_finite(A),S)
         => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),real_Vector_dim(A,S)),aa(set(A),nat,finite_card(A),S)) ) ) ).

% dim_le_card'
tff(fact_7954_dim__unique,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),V2: set(A),N: nat] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),V2)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,B3))
           => ( ~ real_V358717886546972837endent(A,B3)
             => ( ( aa(set(A),nat,finite_card(A),B3) = N )
               => ( real_Vector_dim(A,V2) = N ) ) ) ) ) ) ).

% dim_unique
tff(fact_7955_basis__exists,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [V2: set(A)] :
          ~ ! [B9: set(A)] :
              ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B9),V2)
             => ( ~ real_V358717886546972837endent(A,B9)
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,B9))
                 => ( aa(set(A),nat,finite_card(A),B9) != real_Vector_dim(A,V2) ) ) ) ) ) ).

% basis_exists
tff(fact_7956_basis__card__eq__dim,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),V2: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),V2)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,B3))
           => ( ~ real_V358717886546972837endent(A,B3)
             => ( aa(set(A),nat,finite_card(A),B3) = real_Vector_dim(A,V2) ) ) ) ) ) ).

% basis_card_eq_dim
tff(fact_7957_span__card__ge__dim,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [B3: set(A),V2: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),V2)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,B3))
           => ( aa(set(A),$o,finite_finite(A),B3)
             => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),real_Vector_dim(A,V2)),aa(set(A),nat,finite_card(A),B3)) ) ) ) ) ).

% span_card_ge_dim
tff(fact_7958_dim__le__card,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [V2: set(A),W3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,W3))
         => ( aa(set(A),$o,finite_finite(A),W3)
           => aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),real_Vector_dim(A,V2)),aa(set(A),nat,finite_card(A),W3)) ) ) ) ).

% dim_le_card
tff(fact_7959_construct__outside,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [B3: set(A),V: A,F3: fun(A,B)] :
          ( ~ real_V358717886546972837endent(A,B3)
         => ( member(A,V,real_Vector_span(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),real_V4986007116245087402_basis(A,B3)),B3)))
           => ( real_V4425403222259421789struct(A,B,B3,F3,V) = zero_zero(B) ) ) ) ) ).

% construct_outside
tff(fact_7960_linear__indep__image__lemma,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),B3: set(A),Xa: A] :
          ( real_Vector_linear(A,B,F3)
         => ( aa(set(A),$o,finite_finite(A),B3)
           => ( ~ real_V358717886546972837endent(B,aa(set(A),set(B),image(A,B,F3),B3))
             => ( inj_on(A,B,F3,B3)
               => ( member(A,Xa,real_Vector_span(A,B3))
                 => ( ( aa(A,B,F3,Xa) = zero_zero(B) )
                   => ( Xa = zero_zero(A) ) ) ) ) ) ) ) ) ).

% linear_indep_image_lemma
tff(fact_7961_bounded__bilinear__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
        <=> ( ! [A7: A,A19: A,B7: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),plus_plus(A),A7),A19)),B7) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A7),B7)),aa(B,C,aa(A,fun(B,C),Prod,A19),B7)) )
            & ! [A7: A,B7: B,B15: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A7),aa(B,B,aa(B,fun(B,B),plus_plus(B),B7),B15)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A7),B7)),aa(B,C,aa(A,fun(B,C),Prod,A7),B15)) )
            & ! [R5: real,A7: A,B7: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,real_V8093663219630862766scaleR(A,R5),A7)),B7) = aa(C,C,real_V8093663219630862766scaleR(C,R5),aa(B,C,aa(A,fun(B,C),Prod,A7),B7)) )
            & ! [A7: A,R5: real,B7: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A7),aa(B,B,real_V8093663219630862766scaleR(B,R5),B7)) = aa(C,C,real_V8093663219630862766scaleR(C,R5),aa(B,C,aa(A,fun(B,C),Prod,A7),B7)) )
            & ? [K5: real] :
              ! [A7: A,B7: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A7),B7))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A7)),real_V7770717601297561774m_norm(B,B7))),K5)) ) ) ) ).

% bounded_bilinear_def
tff(fact_7962_linear__spans__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),V2: set(A),B3: set(A)] :
          ( real_Vector_linear(A,B,F3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),V2),real_Vector_span(A,B3))
           => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(set(A),set(B),image(A,B,F3),V2)),real_Vector_span(B,aa(set(A),set(B),image(A,B,F3),B3))) ) ) ) ).

% linear_spans_image
tff(fact_7963_linear__eq__0__on__span,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [F3: fun(A,B),B2: set(A),Xa: A] :
          ( real_Vector_linear(A,B,F3)
         => ( ! [X: A] :
                ( member(A,X,B2)
               => ( aa(A,B,F3,X) = zero_zero(B) ) )
           => ( member(A,Xa,real_Vector_span(A,B2))
             => ( aa(A,B,F3,Xa) = zero_zero(B) ) ) ) ) ) ).

% linear_eq_0_on_span
tff(fact_7964_bounded__bilinear_Obounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ? [K9: real] :
            ! [A15: A,B10: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A15),B10))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A15)),real_V7770717601297561774m_norm(B,B10))),K9)) ) ) ).

% bounded_bilinear.bounded
tff(fact_7965_Real__Vector__Spaces_Olinear__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_Vector_linear(A,B,F3)
        <=> ( ! [X4: A,Y5: A] : ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),Y5)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,X4)),aa(A,B,F3,Y5)) )
            & ! [C3: real,X4: A] : ( aa(A,B,F3,aa(A,A,real_V8093663219630862766scaleR(A,C3),X4)) = aa(B,B,real_V8093663219630862766scaleR(B,C3),aa(A,B,F3,X4)) ) ) ) ) ).

% Real_Vector_Spaces.linear_iff
tff(fact_7966_linearI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B)] :
          ( ! [B16: A,B23: A] : ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),B16),B23)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,B16)),aa(A,B,F3,B23)) )
         => ( ! [R4: real,B4: A] : ( aa(A,B,F3,aa(A,A,real_V8093663219630862766scaleR(A,R4),B4)) = aa(B,B,real_V8093663219630862766scaleR(B,R4),aa(A,B,F3,B4)) )
           => real_Vector_linear(A,B,F3) ) ) ) ).

% linearI
tff(fact_7967_module__hom__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => real_Vector_linear(A,B,aTP_Lamp_akf(A,B)) ) ).

% module_hom_zero
tff(fact_7968_bounded__bilinear_Ozero__left,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Prod: fun(A,fun(B,C)),B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,zero_zero(A)),B2) = zero_zero(C) ) ) ) ).

% bounded_bilinear.zero_left
tff(fact_7969_bounded__bilinear_Ozero__right,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Prod: fun(A,fun(B,C)),A2: A] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,A2),zero_zero(B)) = zero_zero(C) ) ) ) ).

% bounded_bilinear.zero_right
tff(fact_7970_linear__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [F3: fun(A,B)] :
          ( real_Vector_linear(A,B,F3)
         => ( aa(A,B,F3,zero_zero(A)) = zero_zero(B) ) ) ) ).

% linear_0
tff(fact_7971_linear__compose__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( real_Vector_linear(A,B,F3)
         => ( real_Vector_linear(A,B,G)
           => real_Vector_linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ake(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% linear_compose_add
tff(fact_7972_bounded__bilinear__mult,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => real_V2442710119149674383linear(A,A,A,times_times(A)) ) ).

% bounded_bilinear_mult
tff(fact_7973_real__linearD,axiom,
    ! [F3: fun(real,real)] :
      ( real_Vector_linear(real,real,F3)
     => ~ ! [C4: real] : ( F3 != aa(real,fun(real,real),times_times(real),C4) ) ) ).

% real_linearD
tff(fact_7974_linear__scale__real,axiom,
    ! [F3: fun(real,real),R: real,B2: real] :
      ( real_Vector_linear(real,real,F3)
     => ( aa(real,real,F3,aa(real,real,aa(real,fun(real,real),times_times(real),R),B2)) = aa(real,real,aa(real,fun(real,real),times_times(real),R),aa(real,real,F3,B2)) ) ) ).

% linear_scale_real
tff(fact_7975_linear__times,axiom,
    ! [A: $tType] :
      ( real_V6157519004096292374lgebra(A)
     => ! [C2: A] : real_Vector_linear(A,A,aa(A,fun(A,A),times_times(A),C2)) ) ).

% linear_times
tff(fact_7976_bounded__bilinear_Oadd__right,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,B2: B,B5: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,A2),aa(B,B,aa(B,fun(B,B),plus_plus(B),B2),B5)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A2),B5)) ) ) ) ).

% bounded_bilinear.add_right
tff(fact_7977_bounded__bilinear_Oadd__left,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,A5: A,B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),A5)),B2) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A5),B2)) ) ) ) ).

% bounded_bilinear.add_left
tff(fact_7978_linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),B17: A,B24: A] :
          ( real_Vector_linear(A,B,F3)
         => ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),plus_plus(A),B17),B24)) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,F3,B17)),aa(A,B,F3,B24)) ) ) ) ).

% linear_add
tff(fact_7979_linear__times__of__real,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [A2: A] : real_Vector_linear(real,A,aTP_Lamp_akg(A,fun(real,A),A2)) ) ).

% linear_times_of_real
tff(fact_7980_bounded__bilinear_Odiff__left,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,A5: A,B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),minus_minus(A),A2),A5)),B2) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A5),B2)) ) ) ) ).

% bounded_bilinear.diff_left
tff(fact_7981_bounded__bilinear_Odiff__right,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),A2: A,B2: B,B5: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(B,C,aa(A,fun(B,C),Prod,A2),aa(B,B,aa(B,fun(B,B),minus_minus(B),B2),B5)) = aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)),aa(B,C,aa(A,fun(B,C),Prod,A2),B5)) ) ) ) ).

% bounded_bilinear.diff_right
tff(fact_7982_linear__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),Xa: A,Y: A] :
          ( real_Vector_linear(A,B,F3)
         => ( aa(A,B,F3,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y)) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,F3,Xa)),aa(A,B,F3,Y)) ) ) ) ).

% linear_diff
tff(fact_7983_linear__compose__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),G: fun(A,B)] :
          ( real_Vector_linear(A,B,F3)
         => ( real_Vector_linear(A,B,G)
           => real_Vector_linear(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_akh(fun(A,B),fun(fun(A,B),fun(A,B)),F3),G)) ) ) ) ).

% linear_compose_sub
tff(fact_7984_bounded__bilinear_Oprod__diff__prod,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Prod: fun(A,fun(B,C)),Xa: A,Y: B,A2: A,B2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( aa(C,C,aa(C,fun(C,C),minus_minus(C),aa(B,C,aa(A,fun(B,C),Prod,Xa),Y)),aa(B,C,aa(A,fun(B,C),Prod,A2),B2)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),A2)),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),B2))),aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),A2)),B2))),aa(B,C,aa(A,fun(B,C),Prod,A2),aa(B,B,aa(B,fun(B,B),minus_minus(B),Y),B2))) ) ) ) ).

% bounded_bilinear.prod_diff_prod
tff(fact_7985_linear__injective__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_Vector_linear(A,B,F3)
         => ( inj_on(A,B,F3,top_top(set(A)))
          <=> ! [X4: A] :
                ( ( aa(A,B,F3,X4) = zero_zero(B) )
               => ( X4 = zero_zero(A) ) ) ) ) ) ).

% linear_injective_0
tff(fact_7986_bounded__bilinear_Otendsto__right__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C)),F3: fun(D,B),F6: filter(D),C2: A] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( filterlim(D,B,F3,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
           => filterlim(D,C,aa(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_aki(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Prod),F3),C2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F6) ) ) ) ).

% bounded_bilinear.tendsto_right_zero
tff(fact_7987_bounded__bilinear_Otendsto__left__zero,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C)),F3: fun(D,A),F6: filter(D),C2: B] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( filterlim(D,A,F3,topolo7230453075368039082e_nhds(A,zero_zero(A)),F6)
           => filterlim(D,C,aa(B,fun(D,C),aa(fun(D,A),fun(B,fun(D,C)),aTP_Lamp_akj(fun(A,fun(B,C)),fun(fun(D,A),fun(B,fun(D,C))),Prod),F3),C2),topolo7230453075368039082e_nhds(C,zero_zero(C)),F6) ) ) ) ).

% bounded_bilinear.tendsto_left_zero
tff(fact_7988_bounded__bilinear_Otendsto__zero,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C)),F3: fun(D,A),F6: filter(D),G: fun(D,B)] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( filterlim(D,A,F3,topolo7230453075368039082e_nhds(A,zero_zero(A)),F6)
           => ( filterlim(D,B,G,topolo7230453075368039082e_nhds(B,zero_zero(B)),F6)
             => filterlim(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_akk(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Prod),F3),G),topolo7230453075368039082e_nhds(C,zero_zero(C)),F6) ) ) ) ) ).

% bounded_bilinear.tendsto_zero
tff(fact_7989_bounded__bilinear_OFDERIV,axiom,
    ! [B: $tType,C: $tType,A: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(B) )
     => ! [Prod: fun(A,fun(B,C)),F3: fun(D,A),F9: fun(D,A),Xa: D,S: set(D),G: fun(D,B),G3: fun(D,B)] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ( has_derivative(D,A,F3,F9,topolo174197925503356063within(D,Xa,S))
           => ( has_derivative(D,B,G,G3,topolo174197925503356063within(D,Xa,S))
             => has_derivative(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_akl(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Prod),F3),G),aa(fun(D,B),fun(D,C),aa(fun(D,B),fun(fun(D,B),fun(D,C)),aa(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))),aa(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))),aa(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))))),aTP_Lamp_akm(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))))),Prod),F3),F9),Xa),G),G3),topolo174197925503356063within(D,Xa,S)) ) ) ) ) ).

% bounded_bilinear.FDERIV
tff(fact_7990_linear__spanning__surjective__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),S2: set(A)] :
          ( real_Vector_linear(A,B,F3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),top_top(set(A))),real_Vector_span(A,S2))
           => ( ( aa(set(A),set(B),image(A,B,F3),top_top(set(A))) = top_top(set(B)) )
             => aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),top_top(set(B))),real_Vector_span(B,aa(set(A),set(B),image(A,B,F3),S2))) ) ) ) ) ).

% linear_spanning_surjective_image
tff(fact_7991_linear__surj__right__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [F3: fun(A,B),T5: set(B),S2: set(A)] :
          ( real_Vector_linear(A,B,F3)
         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),real_Vector_span(B,T5)),aa(set(A),set(B),image(A,B,F3),real_Vector_span(A,S2)))
           => ? [G7: fun(B,A)] :
                ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G7),top_top(set(B)))),real_Vector_span(A,S2))
                & real_Vector_linear(B,A,G7)
                & ! [X3: B] :
                    ( member(B,X3,real_Vector_span(B,T5))
                   => ( aa(A,B,F3,aa(B,A,G7,X3)) = X3 ) ) ) ) ) ) ).

% linear_surj_right_inverse
tff(fact_7992_bounded__bilinear_Ononneg__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),K9)
              & ! [A15: A,B10: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A15),B10))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A15)),real_V7770717601297561774m_norm(B,B10))),K9)) ) ) ) ).

% bounded_bilinear.nonneg_bounded
tff(fact_7993_linear__inj__on__left__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),S2: set(A)] :
          ( real_Vector_linear(A,B,F3)
         => ( inj_on(A,B,F3,real_Vector_span(A,S2))
           => ? [G7: fun(B,A)] :
                ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G7),top_top(set(B)))),real_Vector_span(A,S2))
                & real_Vector_linear(B,A,G7)
                & ! [X3: A] :
                    ( member(A,X3,real_Vector_span(A,S2))
                   => ( aa(B,A,G7,aa(A,B,F3,X3)) = X3 ) ) ) ) ) ) ).

% linear_inj_on_left_inverse
tff(fact_7994_bounded__bilinear_Opos__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( real_V2442710119149674383linear(A,B,C,Prod)
         => ? [K9: real] :
              ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),K9)
              & ! [A15: A,B10: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A15),B10))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A15)),real_V7770717601297561774m_norm(B,B10))),K9)) ) ) ) ).

% bounded_bilinear.pos_bounded
tff(fact_7995_bounded__bilinear_Ointro,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Prod: fun(A,fun(B,C))] :
          ( ! [A4: A,A18: A,B4: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,aa(A,fun(A,A),plus_plus(A),A4),A18)),B4) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)),aa(B,C,aa(A,fun(B,C),Prod,A18),B4)) )
         => ( ! [A4: A,B4: B,B6: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A4),aa(B,B,aa(B,fun(B,B),plus_plus(B),B4),B6)) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)),aa(B,C,aa(A,fun(B,C),Prod,A4),B6)) )
           => ( ! [R4: real,A4: A,B4: B] : ( aa(B,C,aa(A,fun(B,C),Prod,aa(A,A,real_V8093663219630862766scaleR(A,R4),A4)),B4) = aa(C,C,real_V8093663219630862766scaleR(C,R4),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)) )
             => ( ! [A4: A,R4: real,B4: B] : ( aa(B,C,aa(A,fun(B,C),Prod,A4),aa(B,B,real_V8093663219630862766scaleR(B,R4),B4)) = aa(C,C,real_V8093663219630862766scaleR(C,R4),aa(B,C,aa(A,fun(B,C),Prod,A4),B4)) )
               => ( ? [K7: real] :
                    ! [A4: A,B4: B] : aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(B,C,aa(A,fun(B,C),Prod,A4),B4))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,A4)),real_V7770717601297561774m_norm(B,B4))),K7))
                 => real_V2442710119149674383linear(A,B,C,Prod) ) ) ) ) ) ) ).

% bounded_bilinear.intro
tff(fact_7996_finite__basis__to__basis__subspace__isomorphism,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [S2: set(A),T5: set(B),B3: set(A),C5: set(B)] :
          ( real_Vector_subspace(A,S2)
         => ( real_Vector_subspace(B,T5)
           => ( ( real_Vector_dim(A,S2) = real_Vector_dim(B,T5) )
             => ( aa(set(A),$o,finite_finite(A),B3)
               => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),S2)
                 => ( ~ real_V358717886546972837endent(A,B3)
                   => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),real_Vector_span(A,B3))
                     => ( ( aa(set(A),nat,finite_card(A),B3) = real_Vector_dim(A,S2) )
                       => ( aa(set(B),$o,finite_finite(B),C5)
                         => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),C5),T5)
                           => ( ~ real_V358717886546972837endent(B,C5)
                             => ( aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),T5),real_Vector_span(B,C5))
                               => ( ( aa(set(B),nat,finite_card(B),C5) = real_Vector_dim(B,T5) )
                                 => ? [F4: fun(A,B)] :
                                      ( real_Vector_linear(A,B,F4)
                                      & ( aa(set(A),set(B),image(A,B,F4),B3) = C5 )
                                      & ( aa(set(A),set(B),image(A,B,F4),S2) = T5 )
                                      & inj_on(A,B,F4,S2) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% finite_basis_to_basis_subspace_isomorphism
tff(fact_7997_linear__exists__left__inverse__on,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),V2: set(A)] :
          ( real_Vector_linear(A,B,F3)
         => ( real_Vector_subspace(A,V2)
           => ( inj_on(A,B,F3,V2)
             => ? [G7: fun(B,A)] :
                  ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G7),top_top(set(B)))),V2)
                  & real_Vector_linear(B,A,G7)
                  & ! [X3: A] :
                      ( member(A,X3,V2)
                     => ( aa(B,A,G7,aa(A,B,F3,X3)) = X3 ) ) ) ) ) ) ) ).

% linear_exists_left_inverse_on
tff(fact_7998_linear__subspace__kernel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B)] :
          ( real_Vector_linear(A,B,F3)
         => real_Vector_subspace(A,collect(A,aTP_Lamp_akn(fun(A,B),fun(A,$o),F3))) ) ) ).

% linear_subspace_kernel
tff(fact_7999_subspace__sums,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),T5: set(A)] :
          ( real_Vector_subspace(A,S2)
         => ( real_Vector_subspace(A,T5)
           => real_Vector_subspace(A,collect(A,aa(set(A),fun(A,$o),aTP_Lamp_ako(set(A),fun(set(A),fun(A,$o)),S2),T5))) ) ) ) ).

% subspace_sums
tff(fact_8000_subspace__diff,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),Xa: A,Y: A] :
          ( real_Vector_subspace(A,S2)
         => ( member(A,Xa,S2)
           => ( member(A,Y,S2)
             => member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Xa),Y),S2) ) ) ) ) ).

% subspace_diff
tff(fact_8001_subspace__add,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),Xa: A,Y: A] :
          ( real_Vector_subspace(A,S2)
         => ( member(A,Xa,S2)
           => ( member(A,Y,S2)
             => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Xa),Y),S2) ) ) ) ) ).

% subspace_add
tff(fact_8002_subspace__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] :
          ( real_Vector_subspace(A,S2)
         => member(A,zero_zero(A),S2) ) ) ).

% subspace_0
tff(fact_8003_span__subspace,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [A3: set(A),B3: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),real_Vector_span(A,A3))
           => ( real_Vector_subspace(A,B3)
             => ( real_Vector_span(A,A3) = B3 ) ) ) ) ) ).

% span_subspace
tff(fact_8004_span__minimal,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),T5: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( real_Vector_subspace(A,T5)
           => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),real_Vector_span(A,S2)),T5) ) ) ) ).

% span_minimal
tff(fact_8005_span__unique,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A),T5: set(A)] :
          ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T5)
         => ( real_Vector_subspace(A,T5)
           => ( ! [T14: set(A)] :
                  ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),S2),T14)
                 => ( real_Vector_subspace(A,T14)
                   => aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T5),T14) ) )
             => ( real_Vector_span(A,S2) = T5 ) ) ) ) ) ).

% span_unique
tff(fact_8006_subspace__single__0,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => real_Vector_subspace(A,aa(set(A),set(A),insert(A,zero_zero(A)),bot_bot(set(A)))) ) ).

% subspace_single_0
tff(fact_8007_subspace__def,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] :
          ( real_Vector_subspace(A,S2)
        <=> ( member(A,zero_zero(A),S2)
            & ! [X4: A] :
                ( member(A,X4,S2)
               => ! [Xa3: A] :
                    ( member(A,Xa3,S2)
                   => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),Xa3),S2) ) )
            & ! [C3: real,X4: A] :
                ( member(A,X4,S2)
               => member(A,aa(A,A,real_V8093663219630862766scaleR(A,C3),X4),S2) ) ) ) ) ).

% subspace_def
tff(fact_8008_subspaceI,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [S2: set(A)] :
          ( member(A,zero_zero(A),S2)
         => ( ! [X: A,Y3: A] :
                ( member(A,X,S2)
               => ( member(A,Y3,S2)
                 => member(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),X),Y3),S2) ) )
           => ( ! [C4: real,X: A] :
                  ( member(A,X,S2)
                 => member(A,aa(A,A,real_V8093663219630862766scaleR(A,C4),X),S2) )
             => real_Vector_subspace(A,S2) ) ) ) ) ).

% subspaceI
tff(fact_8009_linear__injective__on__subspace__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [F3: fun(A,B),S: set(A)] :
          ( real_Vector_linear(A,B,F3)
         => ( real_Vector_subspace(A,S)
           => ( inj_on(A,B,F3,S)
            <=> ! [X4: A] :
                  ( member(A,X4,S)
                 => ( ( aa(A,B,F3,X4) = zero_zero(B) )
                   => ( X4 = zero_zero(A) ) ) ) ) ) ) ) ).

% linear_injective_on_subspace_0
tff(fact_8010_linear__exists__right__inverse__on,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [F3: fun(A,B),V2: set(A)] :
          ( real_Vector_linear(A,B,F3)
         => ( real_Vector_subspace(A,V2)
           => ? [G7: fun(B,A)] :
                ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(B),set(A),image(B,A,G7),top_top(set(B)))),V2)
                & real_Vector_linear(B,A,G7)
                & ! [X3: B] :
                    ( member(B,X3,aa(set(A),set(B),image(A,B,F3),V2))
                   => ( aa(A,B,F3,aa(B,A,G7,X3)) = X3 ) ) ) ) ) ) ).

% linear_exists_right_inverse_on
tff(fact_8011_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( condit941137186595557371_above(A,aa(set(C),set(A),image(C,A,A3),I5))
           => ( ( I5 != bot_bot(set(C)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_akp(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,A3),I5)))) ) ) ) ) ).

% mono_cSUP
tff(fact_8012_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( condit941137186595557371_above(A,A3)
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(A,B,F3,aa(set(A),A,complete_Sup_Sup(A),A3))) ) ) ) ) ).

% mono_cSup
tff(fact_8013_bdd__above_OI,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A),M7: A] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X),M7) )
         => condit941137186595557371_above(A,A3) ) ) ).

% bdd_above.I
tff(fact_8014_bdd__above_Ounfold,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A)] :
          ( condit941137186595557371_above(A,A3)
        <=> ? [M8: A] :
            ! [X4: A] :
              ( member(A,X4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),M8) ) ) ) ).

% bdd_above.unfold
tff(fact_8015_bdd__above_OE,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A)] :
          ( condit941137186595557371_above(A,A3)
         => ~ ! [M10: A] :
                ~ ! [X3: A] :
                    ( member(A,X3,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),M10) ) ) ) ).

% bdd_above.E
tff(fact_8016_bdd__above__mono,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: set(A),A3: set(A)] :
          ( condit941137186595557371_above(A,B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => condit941137186595557371_above(A,A3) ) ) ) ).

% bdd_above_mono
tff(fact_8017_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A),A2: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,S2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),S2)),A2)
            <=> ! [X4: A] :
                  ( member(A,X4,S2)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),A2) ) ) ) ) ) ).

% cSup_le_iff
tff(fact_8018_cSup__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B3: set(A),A3: set(A)] :
          ( ( B3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A3)
           => ( ! [B4: A] :
                  ( member(A,B4,B3)
                 => ? [X3: A] :
                      ( member(A,X3,A3)
                      & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),B4),X3) ) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),B3)),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ) ) ).

% cSup_mono
tff(fact_8019_cSup__upper2,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Xa: A,X6: set(A),Y: A] :
          ( member(A,Xa,X6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),Xa)
           => ( condit941137186595557371_above(A,X6)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y),aa(set(A),A,complete_Sup_Sup(A),X6)) ) ) ) ) ).

% cSup_upper2
tff(fact_8020_cSup__upper,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Xa: A,X6: set(A)] :
          ( member(A,Xa,X6)
         => ( condit941137186595557371_above(A,X6)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),aa(set(A),A,complete_Sup_Sup(A),X6)) ) ) ) ).

% cSup_upper
tff(fact_8021_cSUP__upper,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [Xa: A,A3: set(A),F3: fun(A,B)] :
          ( member(A,Xa,A3)
         => ( condit941137186595557371_above(B,aa(set(A),set(B),image(A,B,F3),A3))
           => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,Xa)),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ).

% cSUP_upper
tff(fact_8022_cSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F3: fun(B,A),A3: set(B),Xa: B,U: A] :
          ( condit941137186595557371_above(A,aa(set(B),set(A),image(B,A,F3),A3))
         => ( member(B,Xa,A3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(B,A,F3,Xa))
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),U),aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,F3),A3))) ) ) ) ) ).

% cSUP_upper2
tff(fact_8023_bdd__above_OI2,axiom,
    ! [B: $tType,A: $tType] :
      ( preorder(B)
     => ! [A3: set(A),F3: fun(A,B),M7: B] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),M7) )
         => condit941137186595557371_above(B,aa(set(A),set(B),image(A,B,F3),A3)) ) ) ).

% bdd_above.I2
tff(fact_8024_cSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),F3: fun(A,B),U: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(B,aa(set(A),set(B),image(A,B,F3),A3))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),U)
            <=> ! [X4: A] :
                  ( member(A,X4,A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X4)),U) ) ) ) ) ) ).

% cSUP_le_iff
tff(fact_8025_cSUP__mono,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),G: fun(C,B),B3: set(C),F3: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(B,aa(set(C),set(B),image(C,B,G),B3))
           => ( ! [N2: A] :
                  ( member(A,N2,A3)
                 => ? [X3: C] :
                      ( member(C,X3,B3)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,N2)),aa(C,B,G,X3)) ) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(C),set(B),image(C,B,G),B3))) ) ) ) ) ).

% cSUP_mono
tff(fact_8026_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,B3)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3)) ) ) ) ) ).

% cSup_subset_mono
tff(fact_8027_cSUP__subset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A),F3: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(B,aa(set(A),set(B),image(A,B,G),B3))
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
             => ( ! [X: A] :
                    ( member(A,X,A3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,X)),aa(A,B,G,X)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,F3),A3))),aa(set(B),B,complete_Sup_Sup(B),aa(set(A),set(B),image(A,B,G),B3))) ) ) ) ) ) ).

% cSUP_subset_mono
tff(fact_8028_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( condit941137186595557371_above(A,A3)
         => ( condit941137186595557371_above(A,B3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) != bot_bot(set(A)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Sup_Sup(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))),aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(set(A),A,complete_Sup_Sup(A),A3)),aa(set(A),A,complete_Sup_Sup(A),B3))) ) ) ) ) ).

% cSup_inter_less_eq
tff(fact_8029_cSup__cInf,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A)] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,S2)
           => ( aa(set(A),A,complete_Sup_Sup(A),S2) = aa(set(A),A,complete_Inf_Inf(A),collect(A,aTP_Lamp_akq(set(A),fun(A,$o),S2))) ) ) ) ) ).

% cSup_cInf
tff(fact_8030_prod__decode__triangle__add,axiom,
    ! [K: nat,M: nat] : ( aa(nat,product_prod(nat,nat),nat_prod_decode,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(K)),M)) = aa(nat,product_prod(nat,nat),nat_prod_decode_aux(K),M) ) ).

% prod_decode_triangle_add
tff(fact_8031_Max_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => lattic4895041142388067077er_set(A,ord_max(A),aTP_Lamp_zr(A,fun(A,$o)),aTP_Lamp_akr(A,fun(A,$o))) ) ).

% Max.semilattice_order_set_axioms
tff(fact_8032_prod__decode__eq,axiom,
    ! [Xa: nat,Y: nat] :
      ( ( aa(nat,product_prod(nat,nat),nat_prod_decode,Xa) = aa(nat,product_prod(nat,nat),nat_prod_decode,Y) )
    <=> ( Xa = Y ) ) ).

% prod_decode_eq
tff(fact_8033_prod__encode__inverse,axiom,
    ! [Xa: product_prod(nat,nat)] : ( aa(nat,product_prod(nat,nat),nat_prod_decode,aa(product_prod(nat,nat),nat,nat_prod_encode,Xa)) = Xa ) ).

% prod_encode_inverse
tff(fact_8034_prod__decode__inverse,axiom,
    ! [N: nat] : ( aa(product_prod(nat,nat),nat,nat_prod_encode,aa(nat,product_prod(nat,nat),nat_prod_decode,N)) = N ) ).

% prod_decode_inverse
tff(fact_8035_inj__prod__decode,axiom,
    ! [A3: set(nat)] : inj_on(nat,product_prod(nat,nat),nat_prod_decode,A3) ).

% inj_prod_decode
tff(fact_8036_prod__decode__def,axiom,
    nat_prod_decode = nat_prod_decode_aux(zero_zero(nat)) ).

% prod_decode_def
tff(fact_8037_bij__prod__decode,axiom,
    bij_betw(nat,product_prod(nat,nat),nat_prod_decode,top_top(set(nat)),top_top(set(product_prod(nat,nat)))) ).

% bij_prod_decode
tff(fact_8038_surj__prod__decode,axiom,
    aa(set(nat),set(product_prod(nat,nat)),image(nat,product_prod(nat,nat),nat_prod_decode),top_top(set(nat))) = top_top(set(product_prod(nat,nat))) ).

% surj_prod_decode
tff(fact_8039_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_inf(A)
     => lattic4895041142388067077er_set(A,inf_inf(A),ord_less_eq(A),ord_less(A)) ) ).

% Inf_fin.semilattice_order_set_axioms
tff(fact_8040_Min_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => lattic4895041142388067077er_set(A,ord_min(A),ord_less_eq(A),ord_less(A)) ) ).

% Min.semilattice_order_set_axioms
tff(fact_8041_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => lattic4895041142388067077er_set(A,sup_sup(A),aTP_Lamp_aks(A,fun(A,$o)),aTP_Lamp_akt(A,fun(A,$o))) ) ).

% Sup_fin.semilattice_order_set_axioms
tff(fact_8042_list__decode_Oelims,axiom,
    ! [Xa: nat,Y: list(nat)] :
      ( ( aa(nat,list(nat),nat_list_decode,Xa) = Y )
     => ( ( ( Xa = zero_zero(nat) )
         => ( Y != nil(nat) ) )
       => ~ ! [N2: nat] :
              ( ( Xa = aa(nat,nat,suc,N2) )
             => ( Y != aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_aku(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,N2)) ) ) ) ) ).

% list_decode.elims
tff(fact_8043_list__decode_Opinduct,axiom,
    ! [A0: nat,P: fun(nat,$o)] :
      ( aa(nat,$o,accp(nat,nat_list_decode_rel),A0)
     => ( ( aa(nat,$o,accp(nat,nat_list_decode_rel),zero_zero(nat))
         => aa(nat,$o,P,zero_zero(nat)) )
       => ( ! [N2: nat] :
              ( aa(nat,$o,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N2))
             => ( ! [X3: nat,Y4: nat] :
                    ( ( aa(nat,product_prod(nat,nat),product_Pair(nat,nat,X3),Y4) = aa(nat,product_prod(nat,nat),nat_prod_decode,N2) )
                   => aa(nat,$o,P,Y4) )
               => aa(nat,$o,P,aa(nat,nat,suc,N2)) ) )
         => aa(nat,$o,P,A0) ) ) ) ).

% list_decode.pinduct
tff(fact_8044_list__decode__inverse,axiom,
    ! [N: nat] : ( aa(list(nat),nat,nat_list_encode,aa(nat,list(nat),nat_list_decode,N)) = N ) ).

% list_decode_inverse
tff(fact_8045_list__encode__inverse,axiom,
    ! [Xa: list(nat)] : ( aa(nat,list(nat),nat_list_decode,aa(list(nat),nat,nat_list_encode,Xa)) = Xa ) ).

% list_encode_inverse
tff(fact_8046_list__decode_Opsimps_I2_J,axiom,
    ! [N: nat] :
      ( aa(nat,$o,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N))
     => ( aa(nat,list(nat),nat_list_decode,aa(nat,nat,suc,N)) = aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_aku(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,N)) ) ) ).

% list_decode.psimps(2)
tff(fact_8047_list__decode_Opsimps_I1_J,axiom,
    ( aa(nat,$o,accp(nat,nat_list_decode_rel),zero_zero(nat))
   => ( aa(nat,list(nat),nat_list_decode,zero_zero(nat)) = nil(nat) ) ) ).

% list_decode.psimps(1)
tff(fact_8048_list__decode__eq,axiom,
    ! [Xa: nat,Y: nat] :
      ( ( aa(nat,list(nat),nat_list_decode,Xa) = aa(nat,list(nat),nat_list_decode,Y) )
    <=> ( Xa = Y ) ) ).

% list_decode_eq
tff(fact_8049_inj__list__decode,axiom,
    ! [A3: set(nat)] : inj_on(nat,list(nat),nat_list_decode,A3) ).

% inj_list_decode
tff(fact_8050_list__decode_Osimps_I1_J,axiom,
    aa(nat,list(nat),nat_list_decode,zero_zero(nat)) = nil(nat) ).

% list_decode.simps(1)
tff(fact_8051_surj__list__decode,axiom,
    aa(set(nat),set(list(nat)),image(nat,list(nat),nat_list_decode),top_top(set(nat))) = top_top(set(list(nat))) ).

% surj_list_decode
tff(fact_8052_bij__list__decode,axiom,
    bij_betw(nat,list(nat),nat_list_decode,top_top(set(nat)),top_top(set(list(nat)))) ).

% bij_list_decode
tff(fact_8053_list__decode_Opelims,axiom,
    ! [Xa: nat,Y: list(nat)] :
      ( ( aa(nat,list(nat),nat_list_decode,Xa) = Y )
     => ( aa(nat,$o,accp(nat,nat_list_decode_rel),Xa)
       => ( ( ( Xa = zero_zero(nat) )
           => ( ( Y = nil(nat) )
             => ~ aa(nat,$o,accp(nat,nat_list_decode_rel),zero_zero(nat)) ) )
         => ~ ! [N2: nat] :
                ( ( Xa = aa(nat,nat,suc,N2) )
               => ( ( Y = aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_aku(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,N2)) )
                 => ~ aa(nat,$o,accp(nat,nat_list_decode_rel),aa(nat,nat,suc,N2)) ) ) ) ) ) ).

% list_decode.pelims
tff(fact_8054_list__decode_Osimps_I2_J,axiom,
    ! [N: nat] : ( aa(nat,list(nat),nat_list_decode,aa(nat,nat,suc,N)) = aa(product_prod(nat,nat),list(nat),product_case_prod(nat,nat,list(nat),aTP_Lamp_aku(nat,fun(nat,list(nat)))),aa(nat,product_prod(nat,nat),nat_prod_decode,N)) ) ).

% list_decode.simps(2)
tff(fact_8055_mono__cINF,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(B)
        & condit1219197933456340205attice(A) )
     => ! [F3: fun(A,B),A3: fun(C,A),I5: set(C)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( condit1013018076250108175_below(A,aa(set(C),set(A),image(C,A,A3),I5))
           => ( ( I5 != bot_bot(set(C)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,A3),I5)))),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_akp(fun(A,B),fun(fun(C,A),fun(C,B)),F3),A3)),I5))) ) ) ) ) ).

% mono_cINF
tff(fact_8056_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [F3: fun(A,B),A3: set(A)] :
          ( aa(fun(A,B),$o,order_mono(A,B),F3)
         => ( condit1013018076250108175_below(A,A3)
           => ( ( A3 != bot_bot(set(A)) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,F3,aa(set(A),A,complete_Inf_Inf(A),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ) ).

% mono_cInf
tff(fact_8057_bdd__below_OI,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A),M7: A] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M7),X) )
         => condit1013018076250108175_below(A,A3) ) ) ).

% bdd_below.I
tff(fact_8058_bdd__belowI,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A),M: A] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M),X) )
         => condit1013018076250108175_below(A,A3) ) ) ).

% bdd_belowI
tff(fact_8059_cINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F3: fun(B,A),A3: set(B),Xa: B,U: A] :
          ( condit1013018076250108175_below(A,aa(set(B),set(A),image(B,A,F3),A3))
         => ( member(B,Xa,A3)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,F3,Xa)),U)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),U) ) ) ) ) ).

% cINF_lower2
tff(fact_8060_cINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [F3: fun(B,A),A3: set(B),Xa: B] :
          ( condit1013018076250108175_below(A,aa(set(B),set(A),image(B,A,F3),A3))
         => ( member(B,Xa,A3)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,F3),A3))),aa(B,A,F3,Xa)) ) ) ) ).

% cINF_lower
tff(fact_8061_bdd__below_OI2,axiom,
    ! [B: $tType,A: $tType] :
      ( preorder(B)
     => ! [A3: set(A),M7: B,F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M7),aa(A,B,F3,X)) )
         => condit1013018076250108175_below(B,aa(set(A),set(B),image(A,B,F3),A3)) ) ) ).

% bdd_below.I2
tff(fact_8062_bdd__belowI2,axiom,
    ! [B: $tType,A: $tType] :
      ( preorder(B)
     => ! [A3: set(A),M: B,F3: fun(A,B)] :
          ( ! [X: A] :
              ( member(A,X,A3)
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),M),aa(A,B,F3,X)) )
         => condit1013018076250108175_below(B,aa(set(A),set(B),image(A,B,F3),A3)) ) ) ).

% bdd_belowI2
tff(fact_8063_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A),A2: A] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,S2)
           => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),aa(set(A),A,complete_Inf_Inf(A),S2))
            <=> ! [X4: A] :
                  ( member(A,X4,S2)
                 => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),A2),X4) ) ) ) ) ) ).

% le_cInf_iff
tff(fact_8064_cInf__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [B3: set(A),A3: set(A)] :
          ( ( B3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,A3)
           => ( ! [B4: A] :
                  ( member(A,B4,B3)
                 => ? [X3: A] :
                      ( member(A,X3,A3)
                      & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X3),B4) ) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3)) ) ) ) ) ).

% cInf_mono
tff(fact_8065_cInf__lower2,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Xa: A,X6: set(A),Y: A] :
          ( member(A,Xa,X6)
         => ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y)
           => ( condit1013018076250108175_below(A,X6)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),X6)),Y) ) ) ) ) ).

% cInf_lower2
tff(fact_8066_cInf__lower,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Xa: A,X6: set(A)] :
          ( member(A,Xa,X6)
         => ( condit1013018076250108175_below(A,X6)
           => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),X6)),Xa) ) ) ) ).

% cInf_lower
tff(fact_8067_bdd__below__mono,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [B3: set(A),A3: set(A)] :
          ( condit1013018076250108175_below(A,B3)
         => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
           => condit1013018076250108175_below(A,A3) ) ) ) ).

% bdd_below_mono
tff(fact_8068_bdd__below_OE,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A)] :
          ( condit1013018076250108175_below(A,A3)
         => ~ ! [M10: A] :
                ~ ! [X3: A] :
                    ( member(A,X3,A3)
                   => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M10),X3) ) ) ) ).

% bdd_below.E
tff(fact_8069_bdd__below_Ounfold,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [A3: set(A)] :
          ( condit1013018076250108175_below(A,A3)
        <=> ? [M8: A] :
            ! [X4: A] :
              ( member(A,X4,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),M8),X4) ) ) ) ).

% bdd_below.unfold
tff(fact_8070_le__cINF__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),F3: fun(A,B),U: B] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(B,aa(set(A),set(B),image(A,B,F3),A3))
           => ( aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3)))
            <=> ! [X4: A] :
                  ( member(A,X4,A3)
                 => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),U),aa(A,B,F3,X4)) ) ) ) ) ) ).

% le_cINF_iff
tff(fact_8071_cINF__mono,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [B3: set(A),F3: fun(C,B),A3: set(C),G: fun(A,B)] :
          ( ( B3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(B,aa(set(C),set(B),image(C,B,F3),A3))
           => ( ! [M2: A] :
                  ( member(A,M2,B3)
                 => ? [X3: C] :
                      ( member(C,X3,A3)
                      & aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(C,B,F3,X3)),aa(A,B,G,M2)) ) )
             => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(C),set(B),image(C,B,F3),A3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),B3))) ) ) ) ) ).

% cINF_mono
tff(fact_8072_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,B3)
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),B3)),aa(set(A),A,complete_Inf_Inf(A),A3)) ) ) ) ) ).

% cInf_superset_mono
tff(fact_8073_not__in__connected__cases,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [S2: set(A),Xa: A] :
          ( topolo1966860045006549960nected(A,S2)
         => ( ~ member(A,Xa,S2)
           => ( ( S2 != bot_bot(set(A)) )
             => ( ( condit941137186595557371_above(A,S2)
                 => ~ ! [Y4: A] :
                        ( member(A,Y4,S2)
                       => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y4),Xa) ) )
               => ~ ( condit1013018076250108175_below(A,S2)
                   => ~ ! [Y4: A] :
                          ( member(A,Y4,S2)
                         => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Xa),Y4) ) ) ) ) ) ) ) ).

% not_in_connected_cases
tff(fact_8074_cINF__superset__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( condit1219197933456340205attice(B)
     => ! [A3: set(A),G: fun(A,B),B3: set(A),F3: fun(A,B)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(B,aa(set(A),set(B),image(A,B,G),B3))
           => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),B3)
             => ( ! [X: A] :
                    ( member(A,X,B3)
                   => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,G,X)),aa(A,B,F3,X)) )
               => aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,G),B3))),aa(set(B),B,complete_Inf_Inf(B),aa(set(A),set(B),image(A,B,F3),A3))) ) ) ) ) ) ).

% cINF_superset_mono
tff(fact_8075_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A),B3: set(A)] :
          ( condit1013018076250108175_below(A,A3)
         => ( condit1013018076250108175_below(A,B3)
           => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) != bot_bot(set(A)) )
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Inf_Inf(A),B3))),aa(set(A),A,complete_Inf_Inf(A),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3))) ) ) ) ) ).

% less_eq_cInf_inter
tff(fact_8076_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [A3: set(A)] :
          ( ( A3 != bot_bot(set(A)) )
         => ( condit941137186595557371_above(A,A3)
           => ( condit1013018076250108175_below(A,A3)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(set(A),A,complete_Inf_Inf(A),A3)),aa(set(A),A,complete_Sup_Sup(A),A3)) ) ) ) ) ).

% cInf_le_cSup
tff(fact_8077_cInf__cSup,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [S2: set(A)] :
          ( ( S2 != bot_bot(set(A)) )
         => ( condit1013018076250108175_below(A,S2)
           => ( aa(set(A),A,complete_Inf_Inf(A),S2) = aa(set(A),A,complete_Sup_Sup(A),collect(A,aTP_Lamp_akv(set(A),fun(A,$o),S2))) ) ) ) ) ).

% cInf_cSup
tff(fact_8078_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ( semiring_gcd_Gcd_fin(A) = bounde2362111253966948842tice_F(A,gcd_gcd(A),zero_zero(A),one_one(A)) ) ) ).

% Gcd_fin_def
tff(fact_8079_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat,M: A] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(one2))))),N)
         => ( aa(A,char,unique5772411509450598832har_of(A),aa(A,A,bit_se2584673776208193580ke_bit(A,N),M)) = aa(A,char,unique5772411509450598832har_of(A),M) ) ) ) ).

% char_of_take_bit_eq
tff(fact_8080_char__of__nat,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: nat] : ( aa(A,char,unique5772411509450598832har_of(A),aa(nat,A,semiring_1_of_nat(A),N)) = aa(nat,char,unique5772411509450598832har_of(nat),N) ) ) ).

% char_of_nat
tff(fact_8081_bounded__quasi__semilattice__set_OF_Ocong,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A] : ( bounde2362111253966948842tice_F(A,F3,Top,Bot) = bounde2362111253966948842tice_F(A,F3,Top,Bot) ) ).

% bounded_quasi_semilattice_set.F.cong
tff(fact_8082_inj__on__char__of__nat,axiom,
    inj_on(nat,char,unique5772411509450598832har_of(nat),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2))))))))))) ).

% inj_on_char_of_nat
tff(fact_8083_UNIV__char__of__nat,axiom,
    top_top(set(char)) = aa(set(nat),set(char),image(nat,char,unique5772411509450598832har_of(nat)),set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2))))))))))) ).

% UNIV_char_of_nat
tff(fact_8084_char__of__def,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [N: A] : ( aa(A,char,unique5772411509450598832har_of(A),N) = char2(~ aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),aa(num,A,numeral_numeral(A),bit0(one2))),N),aa(nat,$o,bit_se5641148757651400278ts_bit(A,N),one_one(nat)),aa(nat,$o,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit0(one2))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,one2))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit0(bit0(one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,bit0(one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),bit0(aa(num,num,bit1,one2)))),aa(nat,$o,bit_se5641148757651400278ts_bit(A,N),aa(num,nat,numeral_numeral(nat),aa(num,num,bit1,aa(num,num,bit1,one2))))) ) ) ).

% char_of_def
tff(fact_8085_bounded__quasi__semilattice__set_Oremove,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( member(A,A2,A3)
       => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3) = aa(A,A,aa(A,fun(A,A),F3,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ) ).

% bounded_quasi_semilattice_set.remove
tff(fact_8086_char_Osize_I2_J,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] : ( aa(char,nat,size_size(char),char2(X15,X2,X32,X42,X52,X62,X72,X82)) = zero_zero(nat) ) ).

% char.size(2)
tff(fact_8087_bounded__quasi__semilattice__set_Osubset,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),B3: set(A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),A3)
       => ( aa(A,A,aa(A,fun(A,A),F3,aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),B3)),aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3)) = aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3) ) ) ) ).

% bounded_quasi_semilattice_set.subset
tff(fact_8088_bounded__quasi__semilattice__set_Oinfinite,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( ~ aa(set(A),$o,finite_finite(A),A3)
       => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3) = Bot ) ) ) ).

% bounded_quasi_semilattice_set.infinite
tff(fact_8089_bounded__quasi__semilattice__set_Oempty,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),bot_bot(set(A))) = Top ) ) ).

% bounded_quasi_semilattice_set.empty
tff(fact_8090_bounded__quasi__semilattice__set_Onormalize,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(A,A,Normalize,aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3)) = aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3) ) ) ).

% bounded_quasi_semilattice_set.normalize
tff(fact_8091_bounded__quasi__semilattice__set_Oin__idem,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( member(A,A2,A3)
       => ( aa(A,A,aa(A,fun(A,A),F3,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3)) = aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3) ) ) ) ).

% bounded_quasi_semilattice_set.in_idem
tff(fact_8092_bounded__quasi__semilattice__set_Oinsert,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),F3,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3)) ) ) ).

% bounded_quasi_semilattice_set.insert
tff(fact_8093_bounded__quasi__semilattice__set_Ounion,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A),B3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = aa(A,A,aa(A,fun(A,A),F3,aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3)),aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),B3)) ) ) ).

% bounded_quasi_semilattice_set.union
tff(fact_8094_bounded__quasi__semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A2: A,A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),aa(set(A),set(A),insert(A,A2),A3)) = aa(A,A,aa(A,fun(A,A),F3,A2),aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))))) ) ) ).

% bounded_quasi_semilattice_set.insert_remove
tff(fact_8095_integer__of__char__code,axiom,
    ! [B0: $o,B17: $o,B24: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] : ( integer_of_char(char2(B0,B17,B24,B32,B42,B52,B62,B72)) = aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B72)),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B62))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B52))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B42))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B32))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B24))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B17))),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2)))),aa($o,code_integer,zero_neq_one_of_bool(code_integer),B0)) ) ).

% integer_of_char_code
tff(fact_8096_char_Osize__gen,axiom,
    ! [X15: $o,X2: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] : ( size_char(char2(X15,X2,X32,X42,X52,X62,X72,X82)) = zero_zero(nat) ) ).

% char.size_gen
tff(fact_8097_range__nat__of__char,axiom,
    aa(set(char),set(nat),image(char,nat,comm_s6883823935334413003f_char(nat)),top_top(set(char))) = set_or7035219750837199246ssThan(nat,zero_zero(nat),aa(num,nat,numeral_numeral(nat),bit0(bit0(bit0(bit0(bit0(bit0(bit0(bit0(one2)))))))))) ).

% range_nat_of_char
tff(fact_8098_gen__length__def,axiom,
    ! [A: $tType,N: nat,Xs: list(A)] : ( aa(list(A),nat,gen_length(A,N),Xs) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N),aa(list(A),nat,size_size(list(A)),Xs)) ) ).

% gen_length_def
tff(fact_8099_gen__length__code_I2_J,axiom,
    ! [A: $tType,N: nat,Xa: A,Xs: list(A)] : ( aa(list(A),nat,gen_length(A,N),aa(list(A),list(A),cons(A,Xa),Xs)) = aa(list(A),nat,gen_length(A,aa(nat,nat,suc,N)),Xs) ) ).

% gen_length_code(2)
tff(fact_8100_length__code,axiom,
    ! [A: $tType] : ( size_size(list(A)) = gen_length(A,zero_zero(nat)) ) ).

% length_code
tff(fact_8101_compute__powr__real,axiom,
    ! [B2: real,I: real] :
      ( aa(real,real,aa(real,fun(real,real),powr_real,B2),I)
      = $ite(
          aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),B2),zero_zero(real)),
          abort(real,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$false,$true,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$true,$false,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($false,$false,$true,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$true,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($false,$false,$false,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($true,$true,$false,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$true,$true,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$false,$false,$false,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($true,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,zero_zero(literal)))))))))))))))))))))))))))))))),aa(real,fun(product_unit,real),aTP_Lamp_akw(real,fun(real,fun(product_unit,real)),B2),I)),
          $ite(
            aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(real,I)) = I,
            $ite(aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),I),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(int,nat,nat2,archim6421214686448440834_floor(real,I))),divide_divide(real,one_one(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),B2),aa(int,nat,nat2,archim6421214686448440834_floor(real,aa(real,real,uminus_uminus(real),I)))))),
            abort(real,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$false,$true,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$true,$false,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($false,$false,$true,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$true,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($false,$false,$false,$true,$false,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$false,$true,$true,$false,$true,$false,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$true,$true,$false,$false,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$false,$false,$true,$true,$true,$true,literal2($false,$false,$false,$false,$true,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,zero_zero(literal)))))))))))))))))))))))))))))))))))),aa(real,fun(product_unit,real),aTP_Lamp_akw(real,fun(real,fun(product_unit,real)),B2),I)) ) ) ) ).

% compute_powr_real
tff(fact_8102_integer__of__nat_Orep__eq,axiom,
    ! [Xa: nat] : ( code_int_of_integer(aa(nat,code_integer,code_integer_of_nat,Xa)) = aa(nat,int,semiring_1_of_nat(int),Xa) ) ).

% integer_of_nat.rep_eq
tff(fact_8103_int__of__integer__integer__of__nat,axiom,
    ! [N: nat] : ( code_int_of_integer(aa(nat,code_integer,code_integer_of_nat,N)) = aa(nat,int,semiring_1_of_nat(int),N) ) ).

% int_of_integer_integer_of_nat
tff(fact_8104_String_Oempty__neq__Literal,axiom,
    ! [B0: $o,B17: $o,B24: $o,B32: $o,B42: $o,B52: $o,B62: $o,S: literal] : ( zero_zero(literal) != literal2(B0,B17,B24,B32,B42,B52,B62,S) ) ).

% String.empty_neq_Literal
tff(fact_8105_powr__real__def,axiom,
    powr_real = powr(real) ).

% powr_real_def
tff(fact_8106_integer__of__nat__0,axiom,
    aa(nat,code_integer,code_integer_of_nat,zero_zero(nat)) = zero_zero(code_integer) ).

% integer_of_nat_0
tff(fact_8107_integer__of__nat_Oabs__eq,axiom,
    ! [Xa: nat] : ( aa(nat,code_integer,code_integer_of_nat,Xa) = aa(int,code_integer,code_integer_of_int,aa(nat,int,semiring_1_of_nat(int),Xa)) ) ).

% integer_of_nat.abs_eq
tff(fact_8108_integer__of__nat__1,axiom,
    aa(nat,code_integer,code_integer_of_nat,one_one(nat)) = one_one(code_integer) ).

% integer_of_nat_1
tff(fact_8109_divmod__nat__code,axiom,
    ! [M: nat,N: nat] :
      ( divmod_nat(M,N)
      = $let(
          k: code_integer,
          k := aa(nat,code_integer,code_integer_of_nat,M),
          $let(
            l: code_integer,
            l := aa(nat,code_integer,code_integer_of_nat,N),
            product_map_prod(code_integer,nat,code_integer,nat,code_nat_of_integer,code_nat_of_integer,
              $ite(
                k = zero_zero(code_integer),
                aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),zero_zero(code_integer)),
                $ite(l = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,zero_zero(code_integer)),k),code_divmod_abs(k,l)) )) ) ) ) ).

% divmod_nat_code
tff(fact_8110_integer__of__nat__def,axiom,
    code_integer_of_nat = aa(fun(nat,int),fun(nat,code_integer),map_fun(nat,nat,int,code_integer,id(nat),code_integer_of_int),semiring_1_of_nat(int)) ).

% integer_of_nat_def
tff(fact_8111_uniformity__Abort,axiom,
    ! [A: $tType] :
      ( topolo4638772830378233104ormity(A)
     => ( topolo7806501430040627800ormity(A) = abstract_filter(product_prod(A,A),aTP_Lamp_aky(product_unit,filter(product_prod(A,A)))) ) ) ).

% uniformity_Abort
tff(fact_8112_card__def,axiom,
    ! [A: $tType] : ( finite_card(A) = finite_folding_F(A,nat,aTP_Lamp_akz(A,fun(nat,nat)),zero_zero(nat)) ) ).

% card_def
tff(fact_8113_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite_folding_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,finite_folding_F(A,B,F3,Z),aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(A,fun(B,B),F3,Xa),aa(set(A),B,finite_folding_F(A,B,F3,Z),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ) ).

% folding_on.insert_remove
tff(fact_8114_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),A3: set(A),Xa: A,Z: B] :
      ( finite_folding_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( aa(set(A),B,finite_folding_F(A,B,F3,Z),A3) = aa(B,B,aa(A,fun(B,B),F3,Xa),aa(set(A),B,finite_folding_F(A,B,F3,Z),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ) ) ).

% folding_on.remove
tff(fact_8115_card_Ofolding__on__axioms,axiom,
    ! [A: $tType] : finite_folding_on(A,nat,top_top(set(A)),aTP_Lamp_akz(A,fun(nat,nat))) ).

% card.folding_on_axioms
tff(fact_8116_folding__on_Oinsert,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite_folding_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( ~ member(A,Xa,A3)
           => ( aa(set(A),B,finite_folding_F(A,B,F3,Z),aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(A,fun(B,B),F3,Xa),aa(set(A),B,finite_folding_F(A,B,F3,Z),A3)) ) ) ) ) ) ).

% folding_on.insert
tff(fact_8117_folding__idem__on_Oinsert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite1890593828518410140dem_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(set(A),B,finite_folding_F(A,B,F3,Z),aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(A,fun(B,B),F3,Xa),aa(set(A),B,finite_folding_F(A,B,F3,Z),A3)) ) ) ) ) ).

% folding_idem_on.insert_idem
tff(fact_8118_rel__fun__iff__geq__image2p,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R2: fun(A,fun(B,$o)),S2: fun(C,fun(D,$o)),F3: fun(A,C),G: fun(B,D)] :
      ( aa(fun(B,D),$o,aa(fun(A,C),fun(fun(B,D),$o),bNF_rel_fun(A,B,C,D,R2,S2),F3),G)
    <=> aa(fun(C,fun(D,$o)),$o,aa(fun(C,fun(D,$o)),fun(fun(C,fun(D,$o)),$o),ord_less_eq(fun(C,fun(D,$o))),bNF_Greatest_image2p(A,C,B,D,F3,G,R2)),S2) ) ).

% rel_fun_iff_geq_image2p
tff(fact_8119_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [A3: set(A)] :
          ( aa(set(A),A,semiring_gcd_Gcd_fin(A),A3)
          = $ite(aa(set(A),$o,finite_finite(A),A3),finite_fold(A,A,gcd_gcd(A),zero_zero(A),A3),one_one(A)) ) ) ).

% Gcd_fin.eq_fold
tff(fact_8120_tendsto__add__Pair,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [A2: A,B2: A] : filterlim(product_prod(A,A),A,aTP_Lamp_ala(product_prod(A,A),A),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),A2),B2)),prod_filter(A,A,topolo7230453075368039082e_nhds(A,A2),topolo7230453075368039082e_nhds(A,B2))) ) ).

% tendsto_add_Pair
tff(fact_8121_card_Oeq__fold,axiom,
    ! [A: $tType,A3: set(A)] : ( aa(set(A),nat,finite_card(A),A3) = finite_fold(A,nat,aTP_Lamp_akz(A,fun(nat,nat)),zero_zero(nat),A3) ) ).

% card.eq_fold
tff(fact_8122_minus__fold__remove,axiom,
    ! [A: $tType,A3: set(A),B3: set(A)] :
      ( aa(set(A),$o,finite_finite(A),A3)
     => ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),B3),A3) = finite_fold(A,set(A),remove(A),B3,A3) ) ) ).

% minus_fold_remove
tff(fact_8123_filtermap__Pair,axiom,
    ! [A: $tType,B: $tType,C: $tType,F3: fun(C,A),G: fun(C,B),F6: filter(C)] : aa(filter(product_prod(A,B)),$o,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),$o),ord_less_eq(filter(product_prod(A,B))),filtermap(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_alb(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),F3),G),F6)),prod_filter(A,B,filtermap(C,A,F3,F6),filtermap(C,B,G,F6))) ).

% filtermap_Pair
tff(fact_8124_prod__filter__mono__iff,axiom,
    ! [A: $tType,B: $tType,A3: filter(A),B3: filter(B),C5: filter(A),D3: filter(B)] :
      ( ( A3 != bot_bot(filter(A)) )
     => ( ( B3 != bot_bot(filter(B)) )
       => ( aa(filter(product_prod(A,B)),$o,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),$o),ord_less_eq(filter(product_prod(A,B))),prod_filter(A,B,A3,B3)),prod_filter(A,B,C5,D3))
        <=> ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),A3),C5)
            & aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),B3),D3) ) ) ) ) ).

% prod_filter_mono_iff
tff(fact_8125_prod__filter__mono,axiom,
    ! [A: $tType,B: $tType,F6: filter(A),F10: filter(A),G5: filter(B),G6: filter(B)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),F6),F10)
     => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),G5),G6)
       => aa(filter(product_prod(A,B)),$o,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),$o),ord_less_eq(filter(product_prod(A,B))),prod_filter(A,B,F6,G5)),prod_filter(A,B,F10,G6)) ) ) ).

% prod_filter_mono
tff(fact_8126_filtermap__snd__prod__filter,axiom,
    ! [B: $tType,A: $tType,A3: filter(B),B3: filter(A)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),filtermap(product_prod(B,A),A,product_snd(B,A),prod_filter(B,A,A3,B3))),B3) ).

% filtermap_snd_prod_filter
tff(fact_8127_filtermap__fst__prod__filter,axiom,
    ! [B: $tType,A: $tType,A3: filter(A),B3: filter(B)] : aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),filtermap(product_prod(A,B),A,product_fst(A,B),prod_filter(A,B,A3,B3))),A3) ).

% filtermap_fst_prod_filter
tff(fact_8128_cauchy__filter__def,axiom,
    ! [A: $tType] :
      ( topolo7287701948861334536_space(A)
     => ! [F6: filter(A)] :
          ( topolo6773858410816713723filter(A,F6)
        <=> aa(filter(product_prod(A,A)),$o,aa(filter(product_prod(A,A)),fun(filter(product_prod(A,A)),$o),ord_less_eq(filter(product_prod(A,A))),prod_filter(A,A,F6,F6)),topolo7806501430040627800ormity(A)) ) ) ).

% cauchy_filter_def
tff(fact_8129_bounded__quasi__semilattice__set_Oeq__fold,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),A3: set(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),A3)
        = $ite(aa(set(A),$o,finite_finite(A),A3),finite_fold(A,A,F3,Top,A3),Bot) ) ) ).

% bounded_quasi_semilattice_set.eq_fold
tff(fact_8130_eventually__prod__sequentially,axiom,
    ! [P: fun(product_prod(nat,nat),$o)] :
      ( eventually(product_prod(nat,nat),P,prod_filter(nat,nat,at_top(nat),at_top(nat)))
    <=> ? [N7: nat] :
        ! [M6: nat] :
          ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),M6)
         => ! [N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),N7),N5)
             => aa(product_prod(nat,nat),$o,P,aa(nat,product_prod(nat,nat),product_Pair(nat,nat,N5),M6)) ) ) ) ).

% eventually_prod_sequentially
tff(fact_8131_le__prod__filterI,axiom,
    ! [A: $tType,B: $tType,F6: filter(product_prod(A,B)),A3: filter(A),B3: filter(B)] :
      ( aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),filtermap(product_prod(A,B),A,product_fst(A,B),F6)),A3)
     => ( aa(filter(B),$o,aa(filter(B),fun(filter(B),$o),ord_less_eq(filter(B)),filtermap(product_prod(A,B),B,product_snd(A,B),F6)),B3)
       => aa(filter(product_prod(A,B)),$o,aa(filter(product_prod(A,B)),fun(filter(product_prod(A,B)),$o),ord_less_eq(filter(product_prod(A,B))),F6),prod_filter(A,B,A3,B3)) ) ) ).

% le_prod_filterI
tff(fact_8132_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7311177749621191930dd_sum(B,A),G),A3) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,plus_plus(A)),G),zero_zero(A),A3) ) ) ).

% sum.eq_fold
tff(fact_8133_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [G: fun(B,A),A3: set(B)] : ( aa(set(B),A,aa(fun(B,A),fun(set(B),A),groups7121269368397514597t_prod(B,A),G),A3) = finite_fold(B,A,aa(fun(B,A),fun(B,fun(A,A)),comp(A,fun(A,A),B,times_times(A)),G),one_one(A),A3) ) ) ).

% prod.eq_fold
tff(fact_8134_comp__fun__idem__on_Ofold__insert__idem2,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite673082921795544331dem_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( finite_fold(A,B,F3,Z,aa(set(A),set(A),insert(A,Xa),A3)) = finite_fold(A,B,F3,aa(B,B,aa(A,fun(B,B),F3,Xa),Z),A3) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem2
tff(fact_8135_comp__fun__idem__on_Ofold__insert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite673082921795544331dem_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( finite_fold(A,B,F3,Z,aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(A,fun(B,B),F3,Xa),finite_fold(A,B,F3,Z,A3)) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem
tff(fact_8136_tendsto__mult__Pair,axiom,
    ! [A: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [A2: A,B2: A] : filterlim(product_prod(A,A),A,aTP_Lamp_alc(product_prod(A,A),A),topolo7230453075368039082e_nhds(A,aa(A,A,aa(A,fun(A,A),times_times(A),A2),B2)),prod_filter(A,A,topolo7230453075368039082e_nhds(A,A2),topolo7230453075368039082e_nhds(A,B2))) ) ).

% tendsto_mult_Pair
tff(fact_8137_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),A3: set(A),B3: set(A),Z: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),B3),S2)
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( aa(set(A),$o,finite_finite(A),B3)
             => ( ( aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),A3),B3) = bot_bot(set(A)) )
               => ( finite_fold(A,B,F3,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),sup_sup(set(A)),A3),B3)) = finite_fold(A,B,F3,finite_fold(A,B,F3,Z,A3),B3) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
tff(fact_8138_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),A3: set(A),Xa: A,Z: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( member(A,Xa,A3)
           => ( finite_fold(A,B,F3,Z,A3) = aa(B,B,aa(A,fun(B,B),F3,Xa),finite_fold(A,B,F3,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
tff(fact_8139_comp__fun__commute__on_Ocomp__fun__commute__on__funpow,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),G: fun(A,nat)] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => finite4664212375090638736ute_on(A,B,S2,aa(fun(A,nat),fun(A,fun(B,B)),aTP_Lamp_ald(fun(A,fun(B,B)),fun(fun(A,nat),fun(A,fun(B,B))),F3),G)) ) ).

% comp_fun_commute_on.comp_fun_commute_on_funpow
tff(fact_8140_Finite__Set_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),G: fun(A,fun(B,B)),A3: set(A),S: B,T2: B,B3: set(A)] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( finite4664212375090638736ute_on(A,B,S2,G)
       => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
         => ( aa(set(A),$o,finite_finite(A),A3)
           => ( ! [X: A] :
                  ( member(A,X,A3)
                 => ( aa(A,fun(B,B),F3,X) = aa(A,fun(B,B),G,X) ) )
             => ( ( S = T2 )
               => ( ( A3 = B3 )
                 => ( finite_fold(A,B,F3,S,A3) = finite_fold(A,B,G,T2,B3) ) ) ) ) ) ) ) ) ).

% Finite_Set.fold_cong
tff(fact_8141_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set(A),F3: fun(A,fun(B,B)),G: fun(C,A),R2: set(C)] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(C),set(A),image(C,A,G),top_top(set(C)))),S2)
       => finite4664212375090638736ute_on(C,B,R2,aa(fun(C,A),fun(C,fun(B,B)),comp(A,fun(B,B),C,F3),G)) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
tff(fact_8142_comp__fun__commute__on_Ofold__fun__left__comm,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( aa(B,B,aa(A,fun(B,B),F3,Xa),finite_fold(A,B,F3,Z,A3)) = finite_fold(A,B,F3,aa(B,B,aa(A,fun(B,B),F3,Xa),Z),A3) ) ) ) ) ).

% comp_fun_commute_on.fold_fun_left_comm
tff(fact_8143_comp__fun__commute__on_Ofold__insert2,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( ~ member(A,Xa,A3)
           => ( finite_fold(A,B,F3,Z,aa(set(A),set(A),insert(A,Xa),A3)) = finite_fold(A,B,F3,aa(B,B,aa(A,fun(B,B),F3,Xa),Z),A3) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert2
tff(fact_8144_comp__fun__commute__on_Ofold__insert,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( ~ member(A,Xa,A3)
           => ( finite_fold(A,B,F3,Z,aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(A,fun(B,B),F3,Xa),finite_fold(A,B,F3,Z,A3)) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert
tff(fact_8145_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => ( finite_fold(A,B,F3,Z,aa(set(A),set(A),insert(A,Xa),A3)) = aa(B,B,aa(A,fun(B,B),F3,Xa),finite_fold(A,B,F3,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,Xa),bot_bot(set(A)))))) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
tff(fact_8146_comp__fun__commute__on_Ofold__graph__insertE__aux,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F3: fun(A,fun(B,B)),A3: set(A),Z: B,Y: B,A2: A] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
       => ( finite_fold_graph(A,B,F3,Z,A3,Y)
         => ( member(A,A2,A3)
           => ? [Y8: B] :
                ( ( Y = aa(B,B,aa(A,fun(B,B),F3,A2),Y8) )
                & finite_fold_graph(A,B,F3,Z,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),A3),aa(set(A),set(A),insert(A,A2),bot_bot(set(A)))),Y8) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE_aux
tff(fact_8147_comp__fun__commute__on_Ofold__graph__fold,axiom,
    ! [B: $tType,A: $tType,S2: set(A),F3: fun(A,fun(B,B)),A3: set(A),Z: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
       => ( aa(set(A),$o,finite_finite(A),A3)
         => finite_fold_graph(A,B,F3,Z,A3,finite_fold(A,B,F3,Z,A3)) ) ) ) ).

% comp_fun_commute_on.fold_graph_fold
tff(fact_8148_comp__fun__commute__on_Ofold__graph__determ,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F3: fun(A,fun(B,B)),A3: set(A),Z: B,Xa: B,Y: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
       => ( finite_fold_graph(A,B,F3,Z,A3,Xa)
         => ( finite_fold_graph(A,B,F3,Z,A3,Y)
           => ( Y = Xa ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_determ
tff(fact_8149_comp__fun__commute__on_Ofold__graph__insertE,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xa: A,A3: set(A),Z: B,V: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(set(A),set(A),insert(A,Xa),A3)),S2)
       => ( finite_fold_graph(A,B,F3,Z,aa(set(A),set(A),insert(A,Xa),A3),V)
         => ( ~ member(A,Xa,A3)
           => ~ ! [Y3: B] :
                  ( ( V = aa(B,B,aa(A,fun(B,B),F3,Xa),Y3) )
                 => ~ finite_fold_graph(A,B,F3,Z,A3,Y3) ) ) ) ) ) ).

% comp_fun_commute_on.fold_graph_insertE
tff(fact_8150_comp__fun__commute__on_Ofold__equality,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F3: fun(A,fun(B,B)),A3: set(A),Z: B,Y: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),A3),S2)
       => ( finite_fold_graph(A,B,F3,Z,A3,Y)
         => ( finite_fold(A,B,F3,Z,A3) = Y ) ) ) ) ).

% comp_fun_commute_on.fold_equality
tff(fact_8151_Gcd__int__set__eq__fold,axiom,
    ! [Xs: list(int)] : ( gcd_Gcd(int,aa(list(int),set(int),set2(int),Xs)) = aa(int,int,fold(int,int,gcd_gcd(int),Xs),zero_zero(int)) ) ).

% Gcd_int_set_eq_fold
tff(fact_8152_numeral__le__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(num,extended_enat,numeral_numeral(extended_enat),M)),extended_enat2(N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),M)),N) ) ).

% numeral_le_enat_iff
tff(fact_8153_enat__ord__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extended_enat2(M)),extended_enat2(N))
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),M),N) ) ).

% enat_ord_simps(1)
tff(fact_8154_plus__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),extended_enat2(M)),extended_enat2(N)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),M),N)) ) ).

% plus_enat_simps(1)
tff(fact_8155_fold__replicate,axiom,
    ! [A: $tType,B: $tType,F3: fun(B,fun(A,A)),N: nat,Xa: B] : ( fold(B,A,F3,replicate(B,N,Xa)) = aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N),aa(B,fun(A,A),F3,Xa)) ) ).

% fold_replicate
tff(fact_8156_idiff__enat__0__right,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),N),extended_enat2(zero_zero(nat))) = N ) ).

% idiff_enat_0_right
tff(fact_8157_idiff__enat__0,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(zero_zero(nat))),N) = extended_enat2(zero_zero(nat)) ) ).

% idiff_enat_0
tff(fact_8158_idiff__enat__enat,axiom,
    ! [A2: nat,B2: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extended_enat2(A2)),extended_enat2(B2)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),A2),B2)) ) ).

% idiff_enat_enat
tff(fact_8159_times__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(M)),extended_enat2(N)) = extended_enat2(aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),M),N)) ) ).

% times_enat_simps(1)
tff(fact_8160_one__enat__def,axiom,
    one_one(extended_enat) = extended_enat2(one_one(nat)) ).

% one_enat_def
tff(fact_8161_enat__1__iff_I1_J,axiom,
    ! [Xa: nat] :
      ( ( extended_enat2(Xa) = one_one(extended_enat) )
    <=> ( Xa = one_one(nat) ) ) ).

% enat_1_iff(1)
tff(fact_8162_enat__1__iff_I2_J,axiom,
    ! [Xa: nat] :
      ( ( one_one(extended_enat) = extended_enat2(Xa) )
    <=> ( Xa = one_one(nat) ) ) ).

% enat_1_iff(2)
tff(fact_8163_fold__plus__sum__list__rev,axiom,
    ! [A: $tType] :
      ( monoid_add(A)
     => ! [Xs: list(A)] : ( fold(A,A,plus_plus(A),Xs) = aa(A,fun(A,A),plus_plus(A),aa(list(A),A,groups8242544230860333062m_list(A),rev(A,Xs))) ) ) ).

% fold_plus_sum_list_rev
tff(fact_8164_enat__0__iff_I2_J,axiom,
    ! [Xa: nat] :
      ( ( zero_zero(extended_enat) = extended_enat2(Xa) )
    <=> ( Xa = zero_zero(nat) ) ) ).

% enat_0_iff(2)
tff(fact_8165_enat__0__iff_I1_J,axiom,
    ! [Xa: nat] :
      ( ( extended_enat2(Xa) = zero_zero(extended_enat) )
    <=> ( Xa = zero_zero(nat) ) ) ).

% enat_0_iff(1)
tff(fact_8166_zero__enat__def,axiom,
    zero_zero(extended_enat) = extended_enat2(zero_zero(nat)) ).

% zero_enat_def
tff(fact_8167_Suc__ile__eq,axiom,
    ! [M: nat,N: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extended_enat2(aa(nat,nat,suc,M))),N)
    <=> aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less(extended_enat),extended_enat2(M)),N) ) ).

% Suc_ile_eq
tff(fact_8168_finite__enat__bounded,axiom,
    ! [A3: set(extended_enat),N: nat] :
      ( ! [Y3: extended_enat] :
          ( member(extended_enat,Y3,A3)
         => aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Y3),extended_enat2(N)) )
     => aa(set(extended_enat),$o,finite_finite(extended_enat),A3) ) ).

% finite_enat_bounded
tff(fact_8169_enat__ile,axiom,
    ! [N: extended_enat,M: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),N),extended_enat2(M))
     => ? [K3: nat] : ( N = extended_enat2(K3) ) ) ).

% enat_ile
tff(fact_8170_bounded__quasi__semilattice__set_Oset__eq__fold,axiom,
    ! [A: $tType,F3: fun(A,fun(A,A)),Top: A,Bot: A,Normalize: fun(A,A),Xs: list(A)] :
      ( bounde6485984586167503788ce_set(A,F3,Top,Bot,Normalize)
     => ( aa(set(A),A,bounde2362111253966948842tice_F(A,F3,Top,Bot),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,F3,Xs),Top) ) ) ).

% bounded_quasi_semilattice_set.set_eq_fold
tff(fact_8171_iadd__le__enat__iff,axiom,
    ! [Xa: extended_enat,Y: extended_enat,N: nat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),plus_plus(extended_enat),Xa),Y)),extended_enat2(N))
    <=> ? [Y9: nat,X10: nat] :
          ( ( Xa = extended_enat2(X10) )
          & ( Y = extended_enat2(Y9) )
          & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),X10),Y9)),N) ) ) ).

% iadd_le_enat_iff
tff(fact_8172_Gcd__set__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_Gcd(A)
     => ! [Xs: list(A)] : ( gcd_Gcd(A,aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_gcd(A),Xs),zero_zero(A)) ) ) ).

% Gcd_set_eq_fold
tff(fact_8173_Gcd__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( semiring_gcd(A)
     => ! [Xs: list(A)] : ( aa(set(A),A,semiring_gcd_Gcd_fin(A),aa(list(A),set(A),set2(A),Xs)) = aa(A,A,fold(A,A,gcd_gcd(A),Xs),zero_zero(A)) ) ) ).

% Gcd_fin.set_eq_fold
tff(fact_8174_comp__fun__idem__on_Ofold__set__fold,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xs: list(A),Y: B] :
      ( finite673082921795544331dem_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),S2)
       => ( finite_fold(A,B,F3,Y,aa(list(A),set(A),set2(A),Xs)) = aa(B,B,fold(A,B,F3,Xs),Y) ) ) ) ).

% comp_fun_idem_on.fold_set_fold
tff(fact_8175_comp__fun__commute__on_Ofold__set__fold__remdups,axiom,
    ! [A: $tType,B: $tType,S2: set(A),F3: fun(A,fun(B,B)),Xs: list(A),Y: B] :
      ( finite4664212375090638736ute_on(A,B,S2,F3)
     => ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Xs)),S2)
       => ( finite_fold(A,B,F3,Y,aa(list(A),set(A),set2(A),Xs)) = aa(B,B,fold(A,B,F3,remdups(A,Xs)),Y) ) ) ) ).

% comp_fun_commute_on.fold_set_fold_remdups
tff(fact_8176_times__enat__simps_I4_J,axiom,
    ! [M: nat] :
      ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extended_enat2(M)),extend4730790105801354508finity(extended_enat))
      = $ite(M = zero_zero(nat),zero_zero(extended_enat),extend4730790105801354508finity(extended_enat)) ) ).

% times_enat_simps(4)
tff(fact_8177_enat__ord__simps_I5_J,axiom,
    ! [Q2: extended_enat] :
      ( aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),extend4730790105801354508finity(extended_enat)),Q2)
    <=> ( Q2 = extend4730790105801354508finity(extended_enat) ) ) ).

% enat_ord_simps(5)
tff(fact_8178_enat__ord__code_I3_J,axiom,
    ! [Q2: extended_enat] : aa(extended_enat,$o,aa(extended_enat,fun(extended_enat,$o),ord_less_eq(extended_enat),Q2),extend4730790105801354508finity(extended_enat)) ).

% enat_ord_code(3)
tff(fact_8179_idiff__infinity,axiom,
    ! [N: extended_enat] : ( aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),minus_minus(extended_enat),extend4730790105801354508finity(extended_enat)),N) = extend4730790105801354508finity(extended_enat) ) ).

% idiff_infinity
tff(fact_8180_times__enat__simps_I2_J,axiom,
    aa(extended_enat,extended_enat,aa(extended_enat,fun(extended_enat,extended_enat),times_times(extended_enat),extend4730790105801354508finity(extended_enat)),extend4730790105801354508finity(extended_enat)) = extend4730790105801354508finity(extended_enat) ).

% times_enat_simps(2)
tff(fact_8181_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list(A)] : aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),remdups(A,Xs))),aa(list(A),nat,size_size(list(A)),Xs)) ).

% length_remdups_leq
tff(fact_8182_ATP_Olambda__1,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),product_prod(int,int),aTP_Lamp_ahq(product_prod(int,int),product_prod(int,int)),Uu)
      = $ite(aa(product_prod(int,int),int,product_fst(int,int),Uu) = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uu))) ) ).

% ATP.lambda_1
tff(fact_8183_ATP_Olambda__2,axiom,
    ! [Uu: fun(nat,rat)] :
      ( aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afw(fun(nat,rat),fun(nat,rat)),Uu)
      = $ite(vanishes(Uu),aTP_Lamp_afv(nat,rat),aTP_Lamp_aft(fun(nat,rat),fun(nat,rat),Uu)) ) ).

% ATP.lambda_2
tff(fact_8184_ATP_Olambda__3,axiom,
    ! [A: $tType] :
      ( topolo4638772830378233104ormity(A)
     => ! [Uu: product_unit] : ( aa(product_unit,filter(product_prod(A,A)),aTP_Lamp_aky(product_unit,filter(product_prod(A,A))),Uu) = abort(filter(product_prod(A,A)),literal2($true,$false,$true,$false,$true,$true,$true,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$true,$true,$false,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$true,$false,$false,$true,$true,$true,literal2($true,$false,$true,$true,$false,$true,$true,literal2($true,$false,$false,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$false,$true,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$false,$false,$true,$false,$true,$true,literal2($true,$true,$false,$false,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($false,$true,$true,$true,$false,$true,$true,literal2($true,$true,$true,$true,$false,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($false,$false,$false,$false,$false,$true,$false,literal2($true,$false,$true,$false,$false,$true,$true,literal2($false,$false,$false,$true,$true,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,literal2($true,$true,$false,$false,$false,$true,$true,literal2($true,$false,$true,$false,$true,$true,$true,literal2($false,$false,$true,$false,$true,$true,$true,literal2($true,$false,$false,$false,$false,$true,$true,literal2($false,$true,$false,$false,$false,$true,$true,literal2($false,$false,$true,$true,$false,$true,$true,literal2($true,$false,$true,$false,$false,$true,$true,zero_zero(literal))))))))))))))))))))))))))))),aTP_Lamp_akx(product_unit,filter(product_prod(A,A)))) ) ) ).

% ATP.lambda_3
tff(fact_8185_ATP_Olambda__4,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_br(nat,real),Uu) = divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uu)),one_one(real)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat)))) ) ).

% ATP.lambda_4
tff(fact_8186_ATP_Olambda__5,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_wb(A,A),Uu) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,exp(A),Uu)),one_one(A)),Uu) ) ) ).

% ATP.lambda_5
tff(fact_8187_ATP_Olambda__6,axiom,
    ! [A: $tType,Uu: set(set(A))] : ( aa(set(set(A)),int,aTP_Lamp_mp(set(set(A)),int),Uu) = aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(set(set(A)),nat,finite_card(set(A)),Uu)),one_one(nat)))),aa(nat,int,semiring_1_of_nat(int),aa(set(A),nat,finite_card(A),aa(set(set(A)),set(A),complete_Inf_Inf(set(A)),Uu)))) ) ).

% ATP.lambda_6
tff(fact_8188_ATP_Olambda__7,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A] :
          ( aa(A,$o,aTP_Lamp_am(A,$o),Uu)
        <=> ( member(A,Uu,ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),zero_zero(A)),Uu) ) ) ) ).

% ATP.lambda_7
tff(fact_8189_ATP_Olambda__8,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_dm(nat,real),Uu) = aa(nat,real,aa(real,fun(nat,real),power_power(real),divide_divide(real,one_one(real),aa(num,real,numeral_numeral(real),bit0(one2)))),aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_8
tff(fact_8190_ATP_Olambda__9,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_ix(real,$o),Uu)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Uu)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uu),aa(num,real,numeral_numeral(real),bit0(one2)))
        & ( aa(real,real,cos(real),Uu) = zero_zero(real) ) ) ) ).

% ATP.lambda_9
tff(fact_8191_ATP_Olambda__10,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_xn(nat,A),Uu) = divide_divide(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu)),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_10
tff(fact_8192_ATP_Olambda__11,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_gz(nat,real),Uu) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,cos_coeff,Uu)),aa(nat,real,aa(real,fun(nat,real),power_power(real),zero_zero(real)),Uu)) ) ).

% ATP.lambda_11
tff(fact_8193_ATP_Olambda__12,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_xo(nat,A),Uu) = divide_divide(A,aa(nat,A,semiring_1_of_nat(A),Uu),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uu))) ) ) ).

% ATP.lambda_12
tff(fact_8194_ATP_Olambda__13,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_wf(real,real),Uu) = divide_divide(real,aa(real,real,cos(real),Uu),aa(real,real,sin(real),Uu)) ) ).

% ATP.lambda_13
tff(fact_8195_ATP_Olambda__14,axiom,
    ! [A: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [Uu: product_prod(A,A)] : ( aa(product_prod(A,A),A,aTP_Lamp_alc(product_prod(A,A),A),Uu) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(product_prod(A,A),A,product_fst(A,A),Uu)),aa(product_prod(A,A),A,product_snd(A,A),Uu)) ) ) ).

% ATP.lambda_14
tff(fact_8196_ATP_Olambda__15,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [Uu: product_prod(A,A)] : ( aa(product_prod(A,A),A,aTP_Lamp_ala(product_prod(A,A),A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(product_prod(A,A),A,product_fst(A,A),Uu)),aa(product_prod(A,A),A,product_snd(A,A),Uu)) ) ) ).

% ATP.lambda_15
tff(fact_8197_ATP_Olambda__16,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_ze(real,real),Uu) = divide_divide(real,aa(real,real,ln_ln(real),Uu),Uu) ) ).

% ATP.lambda_16
tff(fact_8198_ATP_Olambda__17,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: nat] :
          ( aa(nat,$o,aTP_Lamp_ap(nat,$o),Uu)
        <=> ( aa(nat,A,semiring_1_of_nat(A),Uu) = zero_zero(A) ) ) ) ).

% ATP.lambda_17
tff(fact_8199_ATP_Olambda__18,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_wz(nat,real),Uu) = aa(real,real,root(Uu),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_18
tff(fact_8200_ATP_Olambda__19,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_ms(nat,nat),Uu) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),aa(nat,nat,suc,zero_zero(nat))) ) ).

% ATP.lambda_19
tff(fact_8201_ATP_Olambda__20,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_agu(int,int),Uu) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),Uu) ) ).

% ATP.lambda_20
tff(fact_8202_ATP_Olambda__21,axiom,
    ! [A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ar(A,A),Uu) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),one_one(A)) ) ) ).

% ATP.lambda_21
tff(fact_8203_ATP_Olambda__22,axiom,
    ! [Uu: nat] : ( aa(nat,product_prod(nat,nat),aTP_Lamp_agv(nat,product_prod(nat,nat)),Uu) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Uu),zero_zero(nat)) ) ).

% ATP.lambda_22
tff(fact_8204_ATP_Olambda__23,axiom,
    ! [Uu: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_ahn(product_prod(int,int),$o),Uu)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uu))) ) ).

% ATP.lambda_23
tff(fact_8205_ATP_Olambda__24,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_xh(nat,real),Uu) = divide_divide(real,one_one(real),aa(nat,real,semiring_1_of_nat(real),Uu)) ) ).

% ATP.lambda_24
tff(fact_8206_ATP_Olambda__25,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_xm(nat,A),Uu) = divide_divide(A,one_one(A),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_25
tff(fact_8207_ATP_Olambda__26,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_afj(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(list(B),nat,size_size(list(B)),Uu)),aa(nat,nat,suc,zero_zero(nat)))) ) ).

% ATP.lambda_26
tff(fact_8208_ATP_Olambda__27,axiom,
    ! [B: $tType,Uu: list(B)] :
      ( aa(list(B),$o,aTP_Lamp_afk(list(B),$o),Uu)
    <=> ( Uu != nil(B) ) ) ).

% ATP.lambda_27
tff(fact_8209_ATP_Olambda__28,axiom,
    ! [A: $tType,Uu: list(A)] :
      ( aa(list(A),$o,aTP_Lamp_afh(list(A),$o),Uu)
    <=> ( Uu != nil(A) ) ) ).

% ATP.lambda_28
tff(fact_8210_ATP_Olambda__29,axiom,
    ! [Uu: real] : ( aa(real,real,aTP_Lamp_rf(real,real),Uu) = suminf(real,aTP_Lamp_ay(real,fun(nat,real),Uu)) ) ).

% ATP.lambda_29
tff(fact_8211_ATP_Olambda__30,axiom,
    ! [Uu: nat] : ( aa(nat,set(nat),aTP_Lamp_aem(nat,set(nat)),Uu) = collect(nat,aTP_Lamp_lb(nat,fun(nat,$o),Uu)) ) ).

% ATP.lambda_30
tff(fact_8212_ATP_Olambda__31,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real] : ( aa(real,filter(A),aTP_Lamp_abn(real,filter(A)),Uu) = principal(A,collect(A,aTP_Lamp_abm(real,fun(A,$o),Uu))) ) ) ).

% ATP.lambda_31
tff(fact_8213_ATP_Olambda__32,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(real,real)),aTP_Lamp_adf(real,filter(product_prod(real,real))),Uu) = principal(product_prod(real,real),collect(product_prod(real,real),product_case_prod(real,real,$o,aTP_Lamp_ade(real,fun(real,fun(real,$o)),Uu)))) ) ).

% ATP.lambda_32
tff(fact_8214_ATP_Olambda__33,axiom,
    ! [Uu: real] : ( aa(real,filter(product_prod(complex,complex)),aTP_Lamp_add(real,filter(product_prod(complex,complex))),Uu) = principal(product_prod(complex,complex),collect(product_prod(complex,complex),product_case_prod(complex,complex,$o,aTP_Lamp_adc(real,fun(complex,fun(complex,$o)),Uu)))) ) ).

% ATP.lambda_33
tff(fact_8215_ATP_Olambda__34,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real] : ( aa(real,filter(product_prod(A,A)),aTP_Lamp_adb(real,filter(product_prod(A,A))),Uu) = principal(product_prod(A,A),collect(product_prod(A,A),product_case_prod(A,A,$o,aTP_Lamp_ada(real,fun(A,fun(A,$o)),Uu)))) ) ) ).

% ATP.lambda_34
tff(fact_8216_ATP_Olambda__35,axiom,
    ! [Uu: nat] : ( aa(nat,real,aTP_Lamp_xj(nat,real),Uu) = aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uu))) ) ).

% ATP.lambda_35
tff(fact_8217_ATP_Olambda__36,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_ai(nat,A),Uu) = aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,Uu)) ) ) ).

% ATP.lambda_36
tff(fact_8218_ATP_Olambda__37,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_xb(nat,A),Uu) = aa(A,A,inverse_inverse(A),aa(nat,A,semiring_1_of_nat(A),Uu)) ) ) ).

% ATP.lambda_37
tff(fact_8219_ATP_Olambda__38,axiom,
    ! [B: $tType,Uu: list(B)] : ( aa(list(B),fun(nat,nat),aTP_Lamp_afi(list(B),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(B),nat,size_size(list(B)),Uu)) ) ).

% ATP.lambda_38
tff(fact_8220_ATP_Olambda__39,axiom,
    ! [A: $tType,Uu: list(A)] : ( aa(list(A),fun(nat,nat),aTP_Lamp_afg(list(A),fun(nat,nat)),Uu) = aa(nat,fun(nat,nat),ord_max(nat),aa(list(A),nat,size_size(list(A)),Uu)) ) ).

% ATP.lambda_39
tff(fact_8221_ATP_Olambda__40,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_acy(A,B),Uu) = aa(int,B,ring_1_of_int(B),archim6421214686448440834_floor(A,Uu)) ) ) ).

% ATP.lambda_40
tff(fact_8222_ATP_Olambda__41,axiom,
    ! [B: $tType,A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A)
        & ring_1(B)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_acz(A,B),Uu) = aa(int,B,ring_1_of_int(B),archimedean_ceiling(A,Uu)) ) ) ).

% ATP.lambda_41
tff(fact_8223_ATP_Olambda__42,axiom,
    ! [Uu: num] : ( aa(num,option(num),aTP_Lamp_aiy(num,option(num)),Uu) = some(num,bit0(Uu)) ) ).

% ATP.lambda_42
tff(fact_8224_ATP_Olambda__43,axiom,
    ! [Uu: nat] : ( aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_ja(nat,fun(nat,product_prod(nat,nat))),Uu) = product_Pair(nat,nat,aa(nat,nat,suc,Uu)) ) ).

% ATP.lambda_43
tff(fact_8225_ATP_Olambda__44,axiom,
    ! [Uu: int] : ( aa(int,nat,aTP_Lamp_oq(int,nat),Uu) = aa(int,nat,nat2,aa(int,int,abs_abs(int),Uu)) ) ).

% ATP.lambda_44
tff(fact_8226_ATP_Olambda__45,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: A] :
          ( aa(A,$o,aTP_Lamp_ago(A,$o),Uu)
        <=> ? [N5: int] :
              ( ( Uu = aa(int,A,ring_1_of_int(A),N5) )
              & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),zero_zero(int)),N5) ) ) ) ).

% ATP.lambda_45
tff(fact_8227_ATP_Olambda__46,axiom,
    ! [Uu: fun(nat,rat)] :
      ( aa(fun(nat,rat),$o,aTP_Lamp_agq(fun(nat,rat),$o),Uu)
    <=> ? [R5: rat] :
          ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),zero_zero(rat)),R5)
          & ? [K2: nat] :
            ! [N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),K2),N5)
             => aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),R5),aa(nat,rat,Uu,N5)) ) ) ) ).

% ATP.lambda_46
tff(fact_8228_ATP_Olambda__47,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_agr(real,$o),Uu)
    <=> ? [I3: int,N5: nat] :
          ( ( Uu = divide_divide(real,aa(int,real,ring_1_of_int(real),I3),aa(nat,real,semiring_1_of_nat(real),N5)) )
          & ( N5 != zero_zero(nat) ) ) ) ).

% ATP.lambda_47
tff(fact_8229_ATP_Olambda__48,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_ags(real,$o),Uu)
    <=> ? [I3: int,J3: int] :
          ( ( Uu = divide_divide(real,aa(int,real,ring_1_of_int(real),I3),aa(int,real,ring_1_of_int(real),J3)) )
          & ( J3 != zero_zero(int) ) ) ) ).

% ATP.lambda_48
tff(fact_8230_ATP_Olambda__49,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_afy(product_prod(A,A),$o),Uu)
        <=> ? [X4: A,Y5: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X4),Y5) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Y5) ) ) ) ).

% ATP.lambda_49
tff(fact_8231_ATP_Olambda__50,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: product_prod(A,A)] :
          ( aa(product_prod(A,A),$o,aTP_Lamp_afz(product_prod(A,A),$o),Uu)
        <=> ? [X4: A,Y5: A] :
              ( ( Uu = aa(A,product_prod(A,A),product_Pair(A,A,X4),Y5) )
              & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y5),X4) ) ) ) ).

% ATP.lambda_50
tff(fact_8232_ATP_Olambda__51,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_dp(A,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_51
tff(fact_8233_ATP_Olambda__52,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_gw(nat,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_52
tff(fact_8234_ATP_Olambda__53,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_dq(A,fun(nat,A),Uu),Uua)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),zero_zero(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_53
tff(fact_8235_ATP_Olambda__54,axiom,
    ! [Uu: fun(nat,real),Uua: nat] :
      ( aa(nat,real,aTP_Lamp_dn(fun(nat,real),fun(nat,real),Uu),Uua)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),zero_zero(real),aa(nat,real,Uu,divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% ATP.lambda_54
tff(fact_8236_ATP_Olambda__55,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_iu(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uu = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(int,int,sgn_sgn(int),Uu)),Uua)),aa(int,int,abs_abs(int),Uu))) ) ).

% ATP.lambda_55
tff(fact_8237_ATP_Olambda__56,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_aht(int,fun(int,product_prod(int,int))),Uu),Uua)
      = $ite(Uua = zero_zero(int),aa(int,product_prod(int,int),product_Pair(int,int,zero_zero(int)),one_one(int)),aa(int,product_prod(int,int),product_Pair(int,int,Uu),Uua)) ) ).

% ATP.lambda_56
tff(fact_8238_ATP_Olambda__57,axiom,
    ! [Uu: extended_enat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_ajo(extended_enat,fun(nat,$o),Uu),Uua)
    <=> extended_case_enat($o,aa(nat,fun(nat,$o),aTP_Lamp_aa(nat,fun(nat,$o)),Uua),$false,Uu) ) ).

% ATP.lambda_57
tff(fact_8239_ATP_Olambda__58,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] :
          ( aa(nat,A,aTP_Lamp_gv(nat,fun(nat,A),Uu),Uua)
          = $ite(~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua)),zero_zero(A)) ) ) ).

% ATP.lambda_58
tff(fact_8240_ATP_Olambda__59,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_pm(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),bot_bot(A)) ) ) ).

% ATP.lambda_59
tff(fact_8241_ATP_Olambda__60,axiom,
    ! [A: $tType] :
      ( ( lattice(A)
        & order_bot(A) )
     => ! [Uu: fun(A,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_aha(fun(A,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uua),Uu),bot_bot(A)) ) ) ).

% ATP.lambda_60
tff(fact_8242_ATP_Olambda__61,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,$o)),Uua: product_prod(A,B)] :
      ( aa(product_prod(A,B),$o,aTP_Lamp_ahj(fun(A,fun(B,$o)),fun(product_prod(A,B),$o),Uu),Uua)
    <=> aa(B,$o,aa(A,fun(B,$o),Uu,aa(product_prod(A,B),A,product_fst(A,B),Uua)),aa(product_prod(A,B),B,product_snd(A,B),Uua)) ) ).

% ATP.lambda_61
tff(fact_8243_ATP_Olambda__62,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat] : ( aa(nat,list(A),aTP_Lamp_aey(list(list(A)),fun(nat,list(A)),Uu),Uua) = map(nat,A,aa(nat,fun(nat,A),aTP_Lamp_aex(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua),upt(zero_zero(nat),aa(list(list(A)),nat,size_size(list(list(A))),Uu))) ) ).

% ATP.lambda_62
tff(fact_8244_ATP_Olambda__63,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_jf(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_je(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_63
tff(fact_8245_ATP_Olambda__64,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_jd(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_jc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_64
tff(fact_8246_ATP_Olambda__65,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_ahp(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uu)))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_65
tff(fact_8247_ATP_Olambda__66,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ax(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),divide_divide(real,one_one(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Uu),one_one(real))),aa(nat,nat,suc,Uua))) ) ).

% ATP.lambda_66
tff(fact_8248_ATP_Olambda__67,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_bx(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_67
tff(fact_8249_ATP_Olambda__68,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_dr(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))) ) ).

% ATP.lambda_68
tff(fact_8250_ATP_Olambda__69,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_gr(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),Uua))),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_69
tff(fact_8251_ATP_Olambda__70,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_gs(nat,fun(nat,A),Uu),Uua) = divide_divide(A,aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uua),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)) ) ) ).

% ATP.lambda_70
tff(fact_8252_ATP_Olambda__71,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_iz(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
        & ( aa(real,real,sin(real),Uua) = Uu ) ) ) ).

% ATP.lambda_71
tff(fact_8253_ATP_Olambda__72,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_if(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Uua),divide_divide(real,pi,aa(num,real,numeral_numeral(real),bit0(one2))))
        & ( aa(real,real,tan(real),Uua) = Uu ) ) ) ).

% ATP.lambda_72
tff(fact_8254_ATP_Olambda__73,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,int,aa(code_integer,fun(code_integer,int),aTP_Lamp_mr(code_integer,fun(code_integer,int)),Uu),Uua)
      = $let(
          l2: int,
          l2 := aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),code_int_of_integer(Uu)),
          $ite(Uua = zero_zero(code_integer),l2,aa(int,int,aa(int,fun(int,int),plus_plus(int),l2),one_one(int))) ) ) ).

% ATP.lambda_73
tff(fact_8255_ATP_Olambda__74,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,a,aa(nat,fun(nat,a),aTP_Lamp_jj(nat,fun(nat,a)),Uu),Uua)
      = $let(
          m2: a,
          m2 := aa(a,a,aa(a,fun(a,a),times_times(a),aa(num,a,numeral_numeral(a),bit0(one2))),aa(nat,a,semiring_1_of_nat(a),Uu)),
          $ite(Uua = zero_zero(nat),m2,aa(a,a,aa(a,fun(a,a),plus_plus(a),m2),one_one(a))) ) ) ).

% ATP.lambda_74
tff(fact_8256_ATP_Olambda__75,axiom,
    ! [Uu: complex,Uua: real] :
      ( aa(real,$o,aTP_Lamp_id(complex,fun(real,$o),Uu),Uua)
    <=> ( ( aa(complex,complex,sgn_sgn(complex),Uu) = cis(Uua) )
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(real,real,uminus_uminus(real),pi)),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),pi) ) ) ).

% ATP.lambda_75
tff(fact_8257_ATP_Olambda__76,axiom,
    ! [Uu: product_prod(int,int),Uua: product_prod(int,int)] : ( aa(product_prod(int,int),product_prod(int,int),aa(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int)),aTP_Lamp_ahu(product_prod(int,int),fun(product_prod(int,int),product_prod(int,int))),Uu),Uua) = aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_fst(int,int),Uu)),aa(product_prod(int,int),int,product_fst(int,int),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),aa(product_prod(int,int),int,product_snd(int,int),Uu)),aa(product_prod(int,int),int,product_snd(int,int),Uua))) ) ).

% ATP.lambda_76
tff(fact_8258_ATP_Olambda__77,axiom,
    ! [Uu: real,Uua: int] :
      ( aa(int,$o,aTP_Lamp_ji(real,fun(int,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(int,real,ring_1_of_int(real),Uua)),Uu)
        & aa(real,$o,aa(real,fun(real,$o),ord_less(real),Uu),aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int)))) ) ) ).

% ATP.lambda_77
tff(fact_8259_ATP_Olambda__78,axiom,
    ! [Uu: rat,Uua: int] :
      ( aa(int,$o,aTP_Lamp_jh(rat,fun(int,$o),Uu),Uua)
    <=> ( aa(rat,$o,aa(rat,fun(rat,$o),ord_less_eq(rat),aa(int,rat,ring_1_of_int(rat),Uua)),Uu)
        & aa(rat,$o,aa(rat,fun(rat,$o),ord_less(rat),Uu),aa(int,rat,ring_1_of_int(rat),aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),one_one(int)))) ) ) ).

% ATP.lambda_78
tff(fact_8260_ATP_Olambda__79,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_ay(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat))))) ) ).

% ATP.lambda_79
tff(fact_8261_ATP_Olambda__80,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_rg(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% ATP.lambda_80
tff(fact_8262_ATP_Olambda__81,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_wl(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,uminus_uminus(real),one_one(real))),Uua)),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_81
tff(fact_8263_ATP_Olambda__82,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_gu(nat,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uu),Uua))) ) ) ).

% ATP.lambda_82
tff(fact_8264_ATP_Olambda__83,axiom,
    ! [Uu: rat,Uua: product_prod(int,int)] :
      ( aa(product_prod(int,int),$o,aTP_Lamp_ahm(rat,fun(product_prod(int,int),$o),Uu),Uua)
    <=> ( ( Uu = aa(int,rat,aa(int,fun(int,rat),fract,aa(product_prod(int,int),int,product_fst(int,int),Uua)),aa(product_prod(int,int),int,product_snd(int,int),Uua)) )
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),zero_zero(int)),aa(product_prod(int,int),int,product_snd(int,int),Uua))
        & algebr8660921524188924756oprime(int,aa(product_prod(int,int),int,product_fst(int,int),Uua),aa(product_prod(int,int),int,product_snd(int,int),Uua)) ) ) ).

% ATP.lambda_83
tff(fact_8265_ATP_Olambda__84,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_fs(A,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))),Uua) ) ) ).

% ATP.lambda_84
tff(fact_8266_ATP_Olambda__85,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_eu(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,Uu,aa(num,A,numeral_numeral(A),bit0(one2)))),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_85
tff(fact_8267_ATP_Olambda__86,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_ajy(set(A),fun(set(A),$o),Uu),Uua)
        <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uu),Uua)
            & ~ real_V358717886546972837endent(A,Uua)
            & ( real_Vector_span(A,Uua) = top_top(set(A)) ) ) ) ) ).

% ATP.lambda_86
tff(fact_8268_ATP_Olambda__87,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_gf(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,Uu),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),one_one(A))),Uua)) ) ) ).

% ATP.lambda_87
tff(fact_8269_ATP_Olambda__88,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ahr(nat,fun(nat,$o)),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uu),Uua)
        & ( Uu != Uua ) ) ) ).

% ATP.lambda_88
tff(fact_8270_ATP_Olambda__89,axiom,
    ! [A: $tType,Uu: set(set(A)),Uua: set(set(A))] :
      ( aa(set(set(A)),$o,aTP_Lamp_mq(set(set(A)),fun(set(set(A)),$o),Uu),Uua)
    <=> ( aa(set(set(A)),$o,aa(set(set(A)),fun(set(set(A)),$o),ord_less_eq(set(set(A))),Uua),Uu)
        & ( Uua != bot_bot(set(set(A))) ) ) ) ).

% ATP.lambda_89
tff(fact_8271_ATP_Olambda__90,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_fy(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(nat,nat,binomial(Uu),Uua)),aa(num,nat,numeral_numeral(nat),bit0(one2))) ) ).

% ATP.lambda_90
tff(fact_8272_ATP_Olambda__91,axiom,
    ! [Uu: set(int),Uua: int] :
      ( aa(int,$o,aTP_Lamp_aje(set(int),fun(int,$o),Uu),Uua)
    <=> ( member(int,Uua,Uu)
        & ! [X4: int] :
            ( member(int,X4,Uu)
           => aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),X4),Uua) ) ) ) ).

% ATP.lambda_91
tff(fact_8273_ATP_Olambda__92,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_hu(real,fun(nat,real),Uu),Uua) = divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua),semiring_char_0_fact(real,Uua)) ) ).

% ATP.lambda_92
tff(fact_8274_ATP_Olambda__93,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_zi(nat,fun(real,real),Uu),Uua) = divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uu),aa(real,real,exp(real),Uua)) ) ).

% ATP.lambda_93
tff(fact_8275_ATP_Olambda__94,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( aa(set(A),$o,aTP_Lamp_pj(set(A),fun(set(A),$o),Uu),Uua)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uua),Uu)
        & aa(set(A),$o,finite_finite(A),Uua) ) ) ).

% ATP.lambda_94
tff(fact_8276_ATP_Olambda__95,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_agn(nat,fun(nat,set(nat)),Uu),Uua) = set_or3652927894154168847AtMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua),Uu) ) ).

% ATP.lambda_95
tff(fact_8277_ATP_Olambda__96,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ahe(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_96
tff(fact_8278_ATP_Olambda__97,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_fj(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uu) ) ).

% ATP.lambda_97
tff(fact_8279_ATP_Olambda__98,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_fi(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua)),Uua) ) ).

% ATP.lambda_98
tff(fact_8280_ATP_Olambda__99,axiom,
    ! [Uu: nat,Uua: complex] :
      ( aa(complex,$o,aTP_Lamp_ao(nat,fun(complex,$o),Uu),Uua)
    <=> ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Uua),Uu) = one_one(complex) ) ) ).

% ATP.lambda_99
tff(fact_8281_ATP_Olambda__100,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: nat,Uua: A] :
          ( aa(A,$o,aTP_Lamp_aq(nat,fun(A,$o),Uu),Uua)
        <=> ( aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uu) = one_one(A) ) ) ) ).

% ATP.lambda_100
tff(fact_8282_ATP_Olambda__101,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_lc(A,fun(A,$o),Uu),Uua)
        <=> ( member(A,Uua,ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(A,A,abs_abs(A),Uua)),Uu) ) ) ) ).

% ATP.lambda_101
tff(fact_8283_ATP_Olambda__102,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(B,fun(C,$o)),Uua: fun(A,product_prod(B,C))] :
      ( aa(fun(A,product_prod(B,C)),$o,aTP_Lamp_ahl(fun(B,fun(C,$o)),fun(fun(A,product_prod(B,C)),$o),Uu),Uua)
    <=> aa(set(product_prod(B,C)),$o,aa(set(product_prod(B,C)),fun(set(product_prod(B,C)),$o),ord_less_eq(set(product_prod(B,C))),aa(set(A),set(product_prod(B,C)),image(A,product_prod(B,C),Uua),top_top(set(A)))),collect(product_prod(B,C),product_case_prod(B,C,$o,Uu))) ) ).

% ATP.lambda_102
tff(fact_8284_ATP_Olambda__103,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_xu(real,fun(nat,real),Uu),Uua) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),divide_divide(real,Uu,aa(nat,real,semiring_1_of_nat(real),Uua)))),Uua) ) ).

% ATP.lambda_103
tff(fact_8285_ATP_Olambda__104,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_ys(real,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,aa(real,fun(real,real),times_times(real),Uu),Uua))),divide_divide(real,one_one(real),Uua)) ) ).

% ATP.lambda_104
tff(fact_8286_ATP_Olambda__105,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_zl(real,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),divide_divide(real,Uu,Uua))),Uua) ) ).

% ATP.lambda_105
tff(fact_8287_ATP_Olambda__106,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_av(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,one_one(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat))))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))),one_one(nat)))) ) ).

% ATP.lambda_106
tff(fact_8288_ATP_Olambda__107,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_ip(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),Uua)
        & aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),pi)
        & ( aa(real,real,cos(real),Uua) = Uu ) ) ) ).

% ATP.lambda_107
tff(fact_8289_ATP_Olambda__108,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aei(set(product_prod(A,A)),fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),Uu)) ) ) ).

% ATP.lambda_108
tff(fact_8290_ATP_Olambda__109,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aef(nat,fun(nat,$o),Uu),Uua)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),zero_zero(nat)),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(nat,nat,suc,Uu)) ) ) ).

% ATP.lambda_109
tff(fact_8291_ATP_Olambda__110,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bn(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)))) ) ) ).

% ATP.lambda_110
tff(fact_8292_ATP_Olambda__111,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ep(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))),aa(nat,A,Uu,aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)))) ) ) ).

% ATP.lambda_111
tff(fact_8293_ATP_Olambda__112,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_xd(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_112
tff(fact_8294_ATP_Olambda__113,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ej(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,aa(nat,nat,suc,Uua))),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_113
tff(fact_8295_ATP_Olambda__114,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_jt(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_114
tff(fact_8296_ATP_Olambda__115,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_jr(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_115
tff(fact_8297_ATP_Olambda__116,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cd(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_116
tff(fact_8298_ATP_Olambda__117,axiom,
    ! [A: $tType] :
      ( real_V2822296259951069270ebra_1(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bb(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_117
tff(fact_8299_ATP_Olambda__118,axiom,
    ! [A: $tType] :
      ( division_ring(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_kp(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_118
tff(fact_8300_ATP_Olambda__119,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uua)) ) ) ).

% ATP.lambda_119
tff(fact_8301_ATP_Olambda__120,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_en(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_120
tff(fact_8302_ATP_Olambda__121,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_em(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),one_one(nat)))) ) ) ).

% ATP.lambda_121
tff(fact_8303_ATP_Olambda__122,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_xe(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_122
tff(fact_8304_ATP_Olambda__123,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_fk(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uua)),aa(nat,A,Uu,aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_123
tff(fact_8305_ATP_Olambda__124,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,$o),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aig(fun(A,$o),fun(A,$o),Uu),Uua)
        <=> ( aa(A,$o,Uu,Uua)
            & ! [Y5: A] :
                ( aa(A,$o,Uu,Y5)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Y5) ) ) ) ) ).

% ATP.lambda_124
tff(fact_8306_ATP_Olambda__125,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: fun(A,$o),Uua: A] :
          ( aa(A,$o,aTP_Lamp_abs(fun(A,$o),fun(A,$o),Uu),Uua)
        <=> ( aa(A,$o,Uu,Uua)
            & ! [Y5: A] :
                ( aa(A,$o,Uu,Y5)
               => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Y5),Uua) ) ) ) ) ).

% ATP.lambda_125
tff(fact_8307_ATP_Olambda__126,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_hh(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_ord_lessThan(nat,Uua)) ) ) ).

% ATP.lambda_126
tff(fact_8308_ATP_Olambda__127,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat] : ( aa(nat,A,aTP_Lamp_he(fun(nat,fun(nat,A)),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),Uu,Uua)),set_ord_lessThan(nat,Uua)) ) ) ).

% ATP.lambda_127
tff(fact_8309_ATP_Olambda__128,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,A,aTP_Lamp_aia(fun(A,real),fun(A,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(A,real,Uu,Uua)),Uua) ) ) ).

% ATP.lambda_128
tff(fact_8310_ATP_Olambda__129,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_aas(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),aa(A,real,Uu,Uua)),zero_zero(real)) ) ).

% ATP.lambda_129
tff(fact_8311_ATP_Olambda__130,axiom,
    ! [B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(B,real),Uua: B] : ( aa(B,real,aTP_Lamp_th(fun(B,real),fun(B,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(B,real,Uu,Uua)),zero_zero(real)) ) ) ).

% ATP.lambda_130
tff(fact_8312_ATP_Olambda__131,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,complex,aTP_Lamp_fb(fun(A,real),fun(A,complex),Uu),Uua) = complex2(aa(A,real,Uu,Uua),zero_zero(real)) ) ).

% ATP.lambda_131
tff(fact_8313_ATP_Olambda__132,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [Uu: fun(A,B),Uua: A] :
          ( aa(A,$o,aTP_Lamp_akn(fun(A,B),fun(A,$o),Uu),Uua)
        <=> ( aa(A,B,Uu,Uua) = zero_zero(B) ) ) ) ).

% ATP.lambda_132
tff(fact_8314_ATP_Olambda__133,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: A] :
          ( aa(A,$o,aTP_Lamp_kz(fun(A,B),fun(A,$o),Uu),Uua)
        <=> ( aa(A,B,Uu,Uua) = zero_zero(B) ) ) ) ).

% ATP.lambda_133
tff(fact_8315_ATP_Olambda__134,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: A] :
          ( aa(A,$o,aTP_Lamp_la(fun(A,B),fun(A,$o),Uu),Uua)
        <=> ( aa(A,B,Uu,Uua) = one_one(B) ) ) ) ).

% ATP.lambda_134
tff(fact_8316_ATP_Olambda__135,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_wm(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),Uu)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat)))) ) ).

% ATP.lambda_135
tff(fact_8317_ATP_Olambda__136,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_yd(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aTP_Lamp_wl(fun(nat,real),fun(nat,real),Uu)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))) ) ).

% ATP.lambda_136
tff(fact_8318_ATP_Olambda__137,axiom,
    ! [A: $tType,Uu: list(A),Uua: list(A)] : ( aa(list(A),list(list(A)),aTP_Lamp_aeu(list(A),fun(list(A),list(list(A))),Uu),Uua) = map(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_aet(list(A),fun(A,list(A))),Uua),Uu) ) ).

% ATP.lambda_137
tff(fact_8319_ATP_Olambda__138,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_jm(nat,fun(nat,nat)),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),nat_triangle(aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uua))),Uu) ) ).

% ATP.lambda_138
tff(fact_8320_ATP_Olambda__139,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_yl(fun(A,B),fun(A,real),Uu),Uua) = divide_divide(real,real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)),real_V7770717601297561774m_norm(A,Uua)) ) ) ).

% ATP.lambda_139
tff(fact_8321_ATP_Olambda__140,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bq(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2)))))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% ATP.lambda_140
tff(fact_8322_ATP_Olambda__141,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bo(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,suc,Uua)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,suc,Uua))) ) ) ).

% ATP.lambda_141
tff(fact_8323_ATP_Olambda__142,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_akd(set(A),fun(set(A),$o),Uu),Uua)
        <=> ( ~ real_V358717886546972837endent(A,Uua)
            & ( real_Vector_span(A,Uua) = real_Vector_span(A,Uu) ) ) ) ) ).

% ATP.lambda_142
tff(fact_8324_ATP_Olambda__143,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bk(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_143
tff(fact_8325_ATP_Olambda__144,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dc(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),semiring_char_0_fact(A,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_144
tff(fact_8326_ATP_Olambda__145,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ds(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,suc,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_145
tff(fact_8327_ATP_Olambda__146,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aTP_Lamp_adu(num,fun(num,int),Uu),Uua) = aa(int,int,bit_se2584673776208193580ke_bit(int,aa(num,nat,numeral_numeral(nat),Uu)),aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(num,int,numeral_numeral(int),bit0(one2))),aa(num,nat,numeral_numeral(nat),Uu))),aa(num,int,numeral_numeral(int),Uua))) ) ).

% ATP.lambda_146
tff(fact_8328_ATP_Olambda__147,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_di(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,cos_coeff,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uu)),Uua)) ) ) ).

% ATP.lambda_147
tff(fact_8329_ATP_Olambda__148,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_pn(nat,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,sgn_sgn(real),Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,abs_abs(real),Uua)),Uu)) ) ).

% ATP.lambda_148
tff(fact_8330_ATP_Olambda__149,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bh(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,sin_coeff,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_149
tff(fact_8331_ATP_Olambda__150,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bi(A,fun(nat,A),Uu),Uua) = aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,cos_coeff,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_150
tff(fact_8332_ATP_Olambda__151,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_xz(A,fun(nat,A),Uu),Uua) = divide_divide(A,aa(nat,A,semiring_1_of_nat(A),Uua),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_151
tff(fact_8333_ATP_Olambda__152,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_xy(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua)) ) ) ).

% ATP.lambda_152
tff(fact_8334_ATP_Olambda__153,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_gy(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,sin_coeff,Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua)) ) ).

% ATP.lambda_153
tff(fact_8335_ATP_Olambda__154,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_gx(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,cos_coeff,Uua)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua)) ) ).

% ATP.lambda_154
tff(fact_8336_ATP_Olambda__155,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A,Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_zn(A,fun(set(A),$o),Uu),Uua)
        <=> ( topolo1002775350975398744n_open(A,Uua)
            & member(A,Uu,Uua) ) ) ) ).

% ATP.lambda_155
tff(fact_8337_ATP_Olambda__156,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( aa(set(A),$o,aTP_Lamp_aed(set(A),fun(set(A),$o),Uu),Uua)
    <=> ( aa(set(A),$o,finite_finite(A),Uua)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uua),Uu) ) ) ).

% ATP.lambda_156
tff(fact_8338_ATP_Olambda__157,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,$o)),Uua: list(product_prod(A,B))] :
      ( aa(list(product_prod(A,B)),$o,aTP_Lamp_ahz(fun(A,fun(B,$o)),fun(list(product_prod(A,B)),$o),Uu),Uua)
    <=> aa(set(product_prod(A,B)),$o,aa(set(product_prod(A,B)),fun(set(product_prod(A,B)),$o),ord_less_eq(set(product_prod(A,B))),aa(list(product_prod(A,B)),set(product_prod(A,B)),set2(product_prod(A,B)),Uua)),collect(product_prod(A,B),product_case_prod(A,B,$o,Uu))) ) ).

% ATP.lambda_157
tff(fact_8339_ATP_Olambda__158,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ng(nat,fun(nat,A)),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_158
tff(fact_8340_ATP_Olambda__159,axiom,
    ! [Uu: num,Uua: num] : ( aa(num,int,aa(num,fun(num,int),aTP_Lamp_agt(num,fun(num,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(num,int,numeral_numeral(int),Uu)),aa(num,int,numeral_numeral(int),Uua)) ) ).

% ATP.lambda_159
tff(fact_8341_ATP_Olambda__160,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,num,aa(code_integer,fun(code_integer,num),aTP_Lamp_ady(code_integer,fun(code_integer,num)),Uu),Uua)
      = $let(
          l2: num,
          l2 := code_num_of_integer(Uu),
          $let(
            l3: num,
            l3 := aa(num,num,aa(num,fun(num,num),plus_plus(num),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(num,num,aa(num,fun(num,num),plus_plus(num),l3),one2)) ) ) ) ).

% ATP.lambda_160
tff(fact_8342_ATP_Olambda__161,axiom,
    ! [Uu: code_integer,Uua: code_integer] :
      ( aa(code_integer,nat,aa(code_integer,fun(code_integer,nat),aTP_Lamp_mn(code_integer,fun(code_integer,nat)),Uu),Uua)
      = $let(
          l2: nat,
          l2 := aa(code_integer,nat,code_nat_of_integer,Uu),
          $let(
            l3: nat,
            l3 := aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l2),l2),
            $ite(Uua = zero_zero(code_integer),l3,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),l3),one_one(nat))) ) ) ) ).

% ATP.lambda_161
tff(fact_8343_ATP_Olambda__162,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] :
      ( aa(list(A),$o,aTP_Lamp_ajt(set(A),fun(list(A),$o),Uu),Uua)
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uua)),Uu) ) ).

% ATP.lambda_162
tff(fact_8344_ATP_Olambda__163,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat] : ( aa(nat,A,aTP_Lamp_eq(nat,fun(nat,A),Uu),Uua) = aa(nat,A,gbinomial(A,aa(nat,A,semiring_1_of_nat(A),Uua)),Uu) ) ) ).

% ATP.lambda_163
tff(fact_8345_ATP_Olambda__164,axiom,
    ! [A: $tType,Uu: set(nat),Uua: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aTP_Lamp_ahv(set(nat),fun(product_prod(A,nat),$o),Uu),Uua)
    <=> member(nat,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua),Uu) ) ).

% ATP.lambda_164
tff(fact_8346_ATP_Olambda__165,axiom,
    ! [Uu: set(nat),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_afn(set(nat),fun(nat,$o),Uu),Uua)
    <=> member(nat,aa(nat,nat,suc,Uua),Uu) ) ).

% ATP.lambda_165
tff(fact_8347_ATP_Olambda__166,axiom,
    ! [Uu: real,Uua: real] :
      ( aa(real,$o,aTP_Lamp_ij(real,fun(real,$o),Uu),Uua)
    <=> ( aa(real,real,exp(real),Uua) = Uu ) ) ).

% ATP.lambda_166
tff(fact_8348_ATP_Olambda__167,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_ie(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),product_Pair(A,A,Uu),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)),one_one(A))) ) ) ).

% ATP.lambda_167
tff(fact_8349_ATP_Olambda__168,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: A,Uua: A] : ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_ih(A,fun(A,product_prod(A,A))),Uu),Uua) = aa(A,product_prod(A,A),product_Pair(A,A,Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)) ) ) ).

% ATP.lambda_168
tff(fact_8350_ATP_Olambda__169,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_aw(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),divide_divide(A,aa(nat,A,semiring_1_of_nat(A),Uua),aa(num,A,numeral_numeral(A),bit0(one2)))) ) ) ).

% ATP.lambda_169
tff(fact_8351_ATP_Olambda__170,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_go(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),aa(nat,nat,binomial(Uu),Uua)) ) ).

% ATP.lambda_170
tff(fact_8352_ATP_Olambda__171,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_xw(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),times_times(real),Uu),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua)))))) ) ).

% ATP.lambda_171
tff(fact_8353_ATP_Olambda__172,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_xr(fun(nat,A),fun(nat,A),Uu),Uua) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or1337092689740270186AtMost(nat,zero_zero(nat),Uua)) ) ) ).

% ATP.lambda_172
tff(fact_8354_ATP_Olambda__173,axiom,
    ! [A: $tType] :
      ( bit_un5681908812861735899ations(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_jz(A,fun(nat,A),Uu),Uua) = aa(A,A,bit_se4730199178511100633sh_bit(A,Uua),aa($o,A,zero_neq_one_of_bool(A),aa(nat,$o,bit_se5641148757651400278ts_bit(A,Uu),Uua))) ) ) ).

% ATP.lambda_173
tff(fact_8355_ATP_Olambda__174,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_xs(fun(nat,A),fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua))) ) ) ).

% ATP.lambda_174
tff(fact_8356_ATP_Olambda__175,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aa(int,fun(int,int),aTP_Lamp_agp(int,fun(int,int)),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uu),aa($o,int,zero_neq_one_of_bool(int),( Uua != zero_zero(int) ))) ) ).

% ATP.lambda_175
tff(fact_8357_ATP_Olambda__176,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_xt(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uu),aa(real,real,uminus_uminus(real),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua))))) ) ).

% ATP.lambda_176
tff(fact_8358_ATP_Olambda__177,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_xk(real,fun(nat,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uu),aa(real,real,inverse_inverse(real),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uua)))) ) ).

% ATP.lambda_177
tff(fact_8359_ATP_Olambda__178,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_pc(fun(nat,real),fun(nat,real),Uu),Uua) = aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),Uu),set_ord_lessThan(nat,Uua)) ) ).

% ATP.lambda_178
tff(fact_8360_ATP_Olambda__179,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: A] :
          ( aa(A,$o,aTP_Lamp_abm(real,fun(A,$o),Uu),Uua)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uu),real_V7770717601297561774m_norm(A,Uua)) ) ) ).

% ATP.lambda_179
tff(fact_8361_ATP_Olambda__180,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aeg(set(product_prod(A,A)),fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),aa(set(product_prod(A,A)),nat,finite_card(product_prod(A,A)),Uu)) ) ).

% ATP.lambda_180
tff(fact_8362_ATP_Olambda__181,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_xa(A,fun(nat,A),Uu),Uua) = divide_divide(A,Uu,aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_181
tff(fact_8363_ATP_Olambda__182,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] :
      ( aa(list(A),$o,aTP_Lamp_afe(nat,fun(list(A),$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uu),aa(list(A),nat,size_size(list(A)),Uua)) ) ).

% ATP.lambda_182
tff(fact_8364_ATP_Olambda__183,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Uu: A,Uua: real] : ( aa(real,A,aTP_Lamp_akg(A,fun(real,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),real_Vector_of_real(A,Uua)) ) ) ).

% ATP.lambda_183
tff(fact_8365_ATP_Olambda__184,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0(A)
        & semidom_divide(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bp(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_184
tff(fact_8366_ATP_Olambda__185,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_kc(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_185
tff(fact_8367_ATP_Olambda__186,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_bl(A,fun(nat,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua)) ) ) ).

% ATP.lambda_186
tff(fact_8368_ATP_Olambda__187,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,list(nat),aa(nat,fun(nat,list(nat)),aTP_Lamp_aku(nat,fun(nat,list(nat))),Uu),Uua) = aa(list(nat),list(nat),cons(nat,Uu),aa(nat,list(nat),nat_list_decode,Uua)) ) ).

% ATP.lambda_187
tff(fact_8369_ATP_Olambda__188,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_nr(nat,fun(nat,$o)),Uu),Uua)
    <=> ( Uua = aa(nat,nat,suc,Uu) ) ) ).

% ATP.lambda_188
tff(fact_8370_ATP_Olambda__189,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: nat,Uua: A] : ( aa(A,A,aTP_Lamp_vz(nat,fun(A,A),Uu),Uua) = comm_s3205402744901411588hammer(A,Uua,Uu) ) ) ).

% ATP.lambda_189
tff(fact_8371_ATP_Olambda__190,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] :
      ( aa(set(A),$o,aTP_Lamp_ki(set(A),fun(set(A),$o),Uu),Uua)
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uua),Uu) ) ).

% ATP.lambda_190
tff(fact_8372_ATP_Olambda__191,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_aa(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uua),Uu) ) ).

% ATP.lambda_191
tff(fact_8373_ATP_Olambda__192,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_adr(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_192
tff(fact_8374_ATP_Olambda__193,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aks(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_193
tff(fact_8375_ATP_Olambda__194,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aiw(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_194
tff(fact_8376_ATP_Olambda__195,axiom,
    ! [A: $tType] :
      ( preorder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ajp(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_195
tff(fact_8377_ATP_Olambda__196,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_zr(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_196
tff(fact_8378_ATP_Olambda__197,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_fc(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Uu) ) ) ).

% ATP.lambda_197
tff(fact_8379_ATP_Olambda__198,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_pl(nat,fun(nat,nat),Uu),Uua) = modulo_modulo(nat,Uua,Uu) ) ).

% ATP.lambda_198
tff(fact_8380_ATP_Olambda__199,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_nz(A,fun(A,A),Uu),Uua) = divide_divide(A,Uua,Uu) ) ) ).

% ATP.lambda_199
tff(fact_8381_ATP_Olambda__200,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_adg(A,fun(A,A),Uu),Uua) = divide_divide(A,Uua,Uu) ) ) ).

% ATP.lambda_200
tff(fact_8382_ATP_Olambda__201,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_eo(nat,fun(nat,$o)),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uua),Uu) ) ).

% ATP.lambda_201
tff(fact_8383_ATP_Olambda__202,axiom,
    ! [A: $tType] :
      ( bounde4967611905675639751up_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ads(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_202
tff(fact_8384_ATP_Olambda__203,axiom,
    ! [A: $tType] :
      ( semilattice_sup(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_akt(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_203
tff(fact_8385_ATP_Olambda__204,axiom,
    ! [A: $tType] :
      ( order_bot(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aix(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_204
tff(fact_8386_ATP_Olambda__205,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_akr(A,fun(A,$o)),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),Uu) ) ) ).

% ATP.lambda_205
tff(fact_8387_ATP_Olambda__206,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_wy(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uu) ) ).

% ATP.lambda_206
tff(fact_8388_ATP_Olambda__207,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_yg(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_207
tff(fact_8389_ATP_Olambda__208,axiom,
    ! [A: $tType] :
      ( ab_semigroup_mult(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ag(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_208
tff(fact_8390_ATP_Olambda__209,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_oi(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uu) ) ) ).

% ATP.lambda_209
tff(fact_8391_ATP_Olambda__210,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_ais(real,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),minus_minus(real),Uua),Uu) ) ).

% ATP.lambda_210
tff(fact_8392_ATP_Olambda__211,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_nw(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uu) ) ).

% ATP.lambda_211
tff(fact_8393_ATP_Olambda__212,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_air(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_212
tff(fact_8394_ATP_Olambda__213,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ny(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_213
tff(fact_8395_ATP_Olambda__214,axiom,
    ! [A: $tType] :
      ( ab_group_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ox(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),minus_minus(A),Uua),Uu) ) ) ).

% ATP.lambda_214
tff(fact_8396_ATP_Olambda__215,axiom,
    ! [Uu: nat,Uua: real] : ( aa(real,real,aTP_Lamp_qm(nat,fun(real,real),Uu),Uua) = aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uu) ) ).

% ATP.lambda_215
tff(fact_8397_ATP_Olambda__216,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_adp(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uua),Uu) ) ) ).

% ATP.lambda_216
tff(fact_8398_ATP_Olambda__217,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_ob(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uua),Uu) ) ) ).

% ATP.lambda_217
tff(fact_8399_ATP_Olambda__218,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_aiv(real,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),plus_plus(real),Uua),Uu) ) ).

% ATP.lambda_218
tff(fact_8400_ATP_Olambda__219,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_aew(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uu) ) ).

% ATP.lambda_219
tff(fact_8401_ATP_Olambda__220,axiom,
    ! [Uu: int,Uua: int] : ( aa(int,int,aTP_Lamp_ov(int,fun(int,int),Uu),Uua) = aa(int,int,aa(int,fun(int,int),plus_plus(int),Uua),Uu) ) ).

% ATP.lambda_220
tff(fact_8402_ATP_Olambda__221,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_aiu(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_221
tff(fact_8403_ATP_Olambda__222,axiom,
    ! [A: $tType] :
      ( cancel_semigroup_add(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_adh(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_222
tff(fact_8404_ATP_Olambda__223,axiom,
    ! [A: $tType] :
      ( linordered_semidom(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_nx(A,fun(A,A),Uu),Uua) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu) ) ) ).

% ATP.lambda_223
tff(fact_8405_ATP_Olambda__224,axiom,
    ! [Uu: real,Uua: real] : ( aa(real,real,aTP_Lamp_qo(real,fun(real,real),Uu),Uua) = aa(real,real,aa(real,fun(real,real),powr(real),Uua),Uu) ) ).

% ATP.lambda_224
tff(fact_8406_ATP_Olambda__225,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_lb(nat,fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uua),Uu) ) ).

% ATP.lambda_225
tff(fact_8407_ATP_Olambda__226,axiom,
    ! [Uu: int,Uua: int] :
      ( aa(int,$o,aTP_Lamp_lu(int,fun(int,$o),Uu),Uua)
    <=> aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uua),Uu) ) ).

% ATP.lambda_226
tff(fact_8408_ATP_Olambda__227,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: A,Uua: A] :
          ( aa(A,$o,aTP_Lamp_ab(A,fun(A,$o),Uu),Uua)
        <=> aa(A,$o,aa(A,fun(A,$o),dvd_dvd(A),Uua),Uu) ) ) ).

% ATP.lambda_227
tff(fact_8409_ATP_Olambda__228,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_nc(nat,fun(nat,product_prod(nat,nat))),Uu),Uua) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,Uua),Uu) ) ).

% ATP.lambda_228
tff(fact_8410_ATP_Olambda__229,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,product_prod(nat,A),aTP_Lamp_ahi(A,fun(nat,product_prod(nat,A)),Uu),Uua) = aa(A,product_prod(nat,A),product_Pair(nat,A,Uua),Uu) ) ).

% ATP.lambda_229
tff(fact_8411_ATP_Olambda__230,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_ff(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,binomial(Uua),Uu) ) ).

% ATP.lambda_230
tff(fact_8412_ATP_Olambda__231,axiom,
    ! [A: $tType,Uu: list(A),Uua: A] : ( aa(A,list(A),aa(list(A),fun(A,list(A)),aTP_Lamp_aet(list(A),fun(A,list(A))),Uu),Uua) = aa(list(A),list(A),cons(A,Uua),Uu) ) ).

% ATP.lambda_231
tff(fact_8413_ATP_Olambda__232,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: int,Uua: A] : ( aa(A,A,aTP_Lamp_sy(int,fun(A,A),Uu),Uua) = power_int(A,Uua,Uu) ) ) ).

% ATP.lambda_232
tff(fact_8414_ATP_Olambda__233,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_xi(real,fun(nat,real),Uu),Uua) = aa(real,real,root(Uua),Uu) ) ).

% ATP.lambda_233
tff(fact_8415_ATP_Olambda__234,axiom,
    ! [B: $tType,Uu: set(B),Uua: B] :
      ( aa(B,$o,aTP_Lamp_abp(set(B),fun(B,$o),Uu),Uua)
    <=> member(B,Uua,Uu) ) ).

% ATP.lambda_234
tff(fact_8416_ATP_Olambda__235,axiom,
    ! [A: $tType] :
      ( topological_t3_space(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_adk(set(A),fun(A,$o),Uu),Uua)
        <=> member(A,Uua,Uu) ) ) ).

% ATP.lambda_235
tff(fact_8417_ATP_Olambda__236,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aid(set(A),fun(A,$o),Uu),Uua)
        <=> member(A,Uua,Uu) ) ) ).

% ATP.lambda_236
tff(fact_8418_ATP_Olambda__237,axiom,
    ! [A: $tType] :
      ( order(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aif(set(A),fun(A,$o),Uu),Uua)
        <=> member(A,Uua,Uu) ) ) ).

% ATP.lambda_237
tff(fact_8419_ATP_Olambda__238,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] :
      ( aa(A,$o,aTP_Lamp_a(set(A),fun(A,$o),Uu),Uua)
    <=> member(A,Uua,Uu) ) ).

% ATP.lambda_238
tff(fact_8420_ATP_Olambda__239,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: nat] : ( aa(nat,set(product_prod(A,A)),aTP_Lamp_aee(set(product_prod(A,A)),fun(nat,set(product_prod(A,A))),Uu),Uua) = aa(set(product_prod(A,A)),set(product_prod(A,A)),aa(nat,fun(set(product_prod(A,A)),set(product_prod(A,A))),compow(set(product_prod(A,A))),Uua),Uu) ) ).

% ATP.lambda_239
tff(fact_8421_ATP_Olambda__240,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A)] : ( aa(list(A),A,aTP_Lamp_aff(nat,fun(list(A),A),Uu),Uua) = aa(nat,A,nth(A,Uua),Uu) ) ).

% ATP.lambda_240
tff(fact_8422_ATP_Olambda__241,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( aa(A,$o,aTP_Lamp_ig(A,fun(A,$o),Uu),Uua)
    <=> ( Uua = Uu ) ) ).

% ATP.lambda_241
tff(fact_8423_ATP_Olambda__242,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_aaq(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),zero_zero(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_242
tff(fact_8424_ATP_Olambda__243,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aak(fun(A,real),fun(A,$o),Uu),Uua)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_243
tff(fact_8425_ATP_Olambda__244,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_aan(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),one_one(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_244
tff(fact_8426_ATP_Olambda__245,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] :
      ( aa(A,$o,aTP_Lamp_aar(fun(A,real),fun(A,$o),Uu),Uua)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_245
tff(fact_8427_ATP_Olambda__246,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A] : ( aa(A,set(B),aTP_Lamp_ahk(set(product_prod(A,B)),fun(A,set(B)),Uu),Uua) = aa(set(product_prod(A,B)),set(B),image(product_prod(A,B),B,product_snd(A,B)),Uu) ) ).

% ATP.lambda_246
tff(fact_8428_ATP_Olambda__247,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_ht(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat))) ) ).

% ATP.lambda_247
tff(fact_8429_ATP_Olambda__248,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_hs(fun(nat,real),fun(nat,real),Uu),Uua) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)) ) ).

% ATP.lambda_248
tff(fact_8430_ATP_Olambda__249,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_abl(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,Uu,divide_divide(A,one_one(A),Uua)) ) ) ).

% ATP.lambda_249
tff(fact_8431_ATP_Olambda__250,axiom,
    ! [A: $tType,Uu: fun(nat,$o),Uua: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aTP_Lamp_ahw(fun(nat,$o),fun(product_prod(A,nat),$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(nat,nat,suc,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua))) ) ).

% ATP.lambda_250
tff(fact_8432_ATP_Olambda__251,axiom,
    ! [Uu: fun(real,$o),Uua: real] :
      ( aa(real,$o,aTP_Lamp_aam(fun(real,$o),fun(real,$o),Uu),Uua)
    <=> aa(real,$o,Uu,aa(real,real,inverse_inverse(real),Uua)) ) ).

% ATP.lambda_251
tff(fact_8433_ATP_Olambda__252,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real] : ( aa(real,A,aTP_Lamp_zf(fun(real,A),fun(real,A),Uu),Uua) = aa(real,A,Uu,aa(real,real,inverse_inverse(real),Uua)) ) ).

% ATP.lambda_252
tff(fact_8434_ATP_Olambda__253,axiom,
    ! [A: $tType,Uu: fun(int,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_abe(fun(int,A),fun(nat,A),Uu),Uua) = aa(int,A,Uu,aa(nat,int,semiring_1_of_nat(int),Uua)) ) ).

% ATP.lambda_253
tff(fact_8435_ATP_Olambda__254,axiom,
    ! [A: $tType,Uu: fun(nat,$o),Uua: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aTP_Lamp_ahx(fun(nat,$o),fun(product_prod(A,nat),$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(product_prod(A,nat),nat,product_snd(A,nat),Uua)) ) ).

% ATP.lambda_254
tff(fact_8436_ATP_Olambda__255,axiom,
    ! [Uu: fun(nat,$o),Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_aaw(fun(nat,$o),fun(nat,$o),Uu),Uua)
    <=> aa(nat,$o,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_255
tff(fact_8437_ATP_Olambda__256,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_cj(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_256
tff(fact_8438_ATP_Olambda__257,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_wt(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_257
tff(fact_8439_ATP_Olambda__258,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_co(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_258
tff(fact_8440_ATP_Olambda__259,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_bd(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_259
tff(fact_8441_ATP_Olambda__260,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ef(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_260
tff(fact_8442_ATP_Olambda__261,axiom,
    ! [A: $tType,Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_wq(fun(nat,A),fun(nat,A),Uu),Uua) = aa(nat,A,Uu,aa(nat,nat,suc,Uua)) ) ).

% ATP.lambda_261
tff(fact_8443_ATP_Olambda__262,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_agz(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_agy(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_262
tff(fact_8444_ATP_Olambda__263,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_no(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_nn(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_263
tff(fact_8445_ATP_Olambda__264,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_nm(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_nl(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_264
tff(fact_8446_ATP_Olambda__265,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_nk(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_nj(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_265
tff(fact_8447_ATP_Olambda__266,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),$o),aa(nat,fun(nat,fun(product_prod(nat,nat),$o)),aTP_Lamp_ni(nat,fun(nat,fun(product_prod(nat,nat),$o))),Uu),Uua) = product_case_prod(nat,nat,$o,aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_nh(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua)) ) ).

% ATP.lambda_266
tff(fact_8448_ATP_Olambda__267,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,fun(product_prod(nat,nat),product_prod(nat,nat)),aa(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat))),aTP_Lamp_mu(nat,fun(nat,fun(product_prod(nat,nat),product_prod(nat,nat)))),Uu),Uua) = product_case_prod(nat,nat,product_prod(nat,nat),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_mt(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua)) ) ).

% ATP.lambda_267
tff(fact_8449_ATP_Olambda__268,axiom,
    ! [Uu: fun(nat,real),Uua: real] : ( aa(real,real,aTP_Lamp_qx(fun(nat,real),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),aTP_Lamp_qw(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua)) ) ).

% ATP.lambda_268
tff(fact_8450_ATP_Olambda__269,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A] : ( aa(A,A,aTP_Lamp_qn(fun(nat,A),fun(A,A),Uu),Uua) = suminf(A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua)) ) ) ).

% ATP.lambda_269
tff(fact_8451_ATP_Olambda__270,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A] : ( aa(A,set(A),aTP_Lamp_oz(real,fun(A,set(A)),Uu),Uua) = collect(A,aa(A,fun(A,$o),aTP_Lamp_oy(real,fun(A,fun(A,$o)),Uu),Uua)) ) ) ).

% ATP.lambda_270
tff(fact_8452_ATP_Olambda__271,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C)] : ( aa(fun(B,C),A,aTP_Lamp_pg(fun(C,fun(B,A)),fun(fun(B,C),A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_pf(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua)),top_top(set(B)))) ) ) ).

% ATP.lambda_271
tff(fact_8453_ATP_Olambda__272,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B] : ( aa(B,A,aTP_Lamp_ph(fun(C,fun(B,A)),fun(B,A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aTP_Lamp_pd(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_272
tff(fact_8454_ATP_Olambda__273,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C)] : ( aa(fun(B,C),A,aTP_Lamp_pi(fun(C,fun(B,A)),fun(fun(B,C),A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_pf(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua)),top_top(set(B)))) ) ) ).

% ATP.lambda_273
tff(fact_8455_ATP_Olambda__274,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B] : ( aa(B,A,aTP_Lamp_pe(fun(C,fun(B,A)),fun(B,A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aTP_Lamp_pd(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua)),top_top(set(C)))) ) ) ).

% ATP.lambda_274
tff(fact_8456_ATP_Olambda__275,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,complex,aTP_Lamp_ia(nat,fun(nat,complex),Uu),Uua) = cis(divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi)),aa(nat,real,semiring_1_of_nat(real),Uua)),aa(nat,real,semiring_1_of_nat(real),Uu))) ) ).

% ATP.lambda_275
tff(fact_8457_ATP_Olambda__276,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_sh(A,fun(A,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),Uu)),Uua)),aa(A,A,inverse_inverse(A),Uu))) ) ) ).

% ATP.lambda_276
tff(fact_8458_ATP_Olambda__277,axiom,
    ! [Uu: fun(real,real),Uua: real] :
      ( aa(real,$o,aTP_Lamp_zo(fun(real,real),fun(real,$o),Uu),Uua)
    <=> ( aa(real,real,Uu,Uua) != zero_zero(real) ) ) ).

% ATP.lambda_277
tff(fact_8459_ATP_Olambda__278,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: fun(A,real),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aib(fun(A,real),fun(A,$o),Uu),Uua)
        <=> ( aa(A,real,Uu,Uua) != zero_zero(real) ) ) ) ).

% ATP.lambda_278
tff(fact_8460_ATP_Olambda__279,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_dj(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_279
tff(fact_8461_ATP_Olambda__280,axiom,
    ! [Uu: nat,Uua: nat] :
      ( aa(nat,$o,aTP_Lamp_as(nat,fun(nat,$o),Uu),Uua)
    <=> ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),divide_divide(nat,Uu,aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua))) ) ).

% ATP.lambda_280
tff(fact_8462_ATP_Olambda__281,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_dh(A,fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,sin_coeff,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uu)),Uua))) ) ) ).

% ATP.lambda_281
tff(fact_8463_ATP_Olambda__282,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_de(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,sin_coeff,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_282
tff(fact_8464_ATP_Olambda__283,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat] : ( aa(nat,real,aTP_Lamp_df(A,fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(A,A,real_V8093663219630862766scaleR(A,aa(nat,real,cos_coeff,Uua)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uua))) ) ) ).

% ATP.lambda_283
tff(fact_8465_ATP_Olambda__284,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat] : ( aa(nat,set(A),aTP_Lamp_pk(fun(nat,set(A)),fun(nat,set(A)),Uu),Uua) = aa(set(set(A)),set(A),complete_Sup_Sup(set(A)),aa(set(nat),set(set(A)),image(nat,set(A),Uu),set_or7035219750837199246ssThan(nat,zero_zero(nat),Uua))) ) ).

% ATP.lambda_284
tff(fact_8466_ATP_Olambda__285,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_au(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_285
tff(fact_8467_ATP_Olambda__286,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_at(A,fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uua))) ) ) ).

% ATP.lambda_286
tff(fact_8468_ATP_Olambda__287,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: set(B)] : ( aa(set(B),A,aTP_Lamp_ajj(fun(B,A),fun(set(B),A),Uu),Uua) = aa(set(A),A,complete_Sup_Sup(A),aa(set(B),set(A),image(B,A,Uu),Uua)) ) ) ).

% ATP.lambda_287
tff(fact_8469_ATP_Olambda__288,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: set(B)] : ( aa(set(B),A,aTP_Lamp_aji(fun(B,A),fun(set(B),A),Uu),Uua) = aa(set(A),A,complete_Inf_Inf(A),aa(set(B),set(A),image(B,A,Uu),Uua)) ) ) ).

% ATP.lambda_288
tff(fact_8470_ATP_Olambda__289,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_agm(nat,fun(nat,set(nat)),Uu),Uua) = set_ord_atMost(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uua)) ) ).

% ATP.lambda_289
tff(fact_8471_ATP_Olambda__290,axiom,
    ! [Uu: real,Uua: nat] : ( aa(nat,real,aTP_Lamp_xq(real,fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uua)) ) ).

% ATP.lambda_290
tff(fact_8472_ATP_Olambda__291,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_qh(A,fun(A,A),Uu),Uua) = aa(A,A,cos(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)) ) ) ).

% ATP.lambda_291
tff(fact_8473_ATP_Olambda__292,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_mf(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uu),Uua)) ) ).

% ATP.lambda_292
tff(fact_8474_ATP_Olambda__293,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_mg(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_min(nat),Uua),Uu)) ) ).

% ATP.lambda_293
tff(fact_8475_ATP_Olambda__294,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_me(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uu),Uua)) ) ).

% ATP.lambda_294
tff(fact_8476_ATP_Olambda__295,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,nat,aTP_Lamp_md(nat,fun(nat,nat),Uu),Uua) = aa(nat,nat,suc,aa(nat,nat,aa(nat,fun(nat,nat),ord_max(nat),Uua),Uu)) ) ).

% ATP.lambda_295
tff(fact_8477_ATP_Olambda__296,axiom,
    ! [A: $tType,Uu: A,Uua: A] :
      ( aa(A,$o,aTP_Lamp_afd(A,fun(A,$o),Uu),Uua)
    <=> ( Uua != Uu ) ) ).

% ATP.lambda_296
tff(fact_8478_ATP_Olambda__297,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_cv(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_297
tff(fact_8479_ATP_Olambda__298,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_fz(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_298
tff(fact_8480_ATP_Olambda__299,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,real,aTP_Lamp_dd(fun(nat,A),fun(nat,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_299
tff(fact_8481_ATP_Olambda__300,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,real,aTP_Lamp_ee(fun(B,A),fun(B,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_300
tff(fact_8482_ATP_Olambda__301,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,real,aTP_Lamp_bc(fun(B,A),fun(B,real),Uu),Uua) = real_V7770717601297561774m_norm(A,aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_301
tff(fact_8483_ATP_Olambda__302,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,real,aTP_Lamp_up(fun(A,B),fun(A,real),Uu),Uua) = real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_302
tff(fact_8484_ATP_Olambda__303,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [Uu: fun(A,$o),Uua: A] : ( aa(A,B,aTP_Lamp_mx(fun(A,$o),fun(A,B),Uu),Uua) = aa($o,B,zero_neq_one_of_bool(B),aa(A,$o,Uu,Uua)) ) ) ).

% ATP.lambda_303
tff(fact_8485_ATP_Olambda__304,axiom,
    ! [B: $tType,A: $tType] :
      ( order(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,set(B),aTP_Lamp_agj(fun(A,B),fun(A,set(B)),Uu),Uua) = set_ord_atMost(B,aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_304
tff(fact_8486_ATP_Olambda__305,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_xg(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_305
tff(fact_8487_ATP_Olambda__306,axiom,
    ! [Uu: fun(nat,rat),Uua: nat] : ( aa(nat,rat,aTP_Lamp_aft(fun(nat,rat),fun(nat,rat),Uu),Uua) = aa(rat,rat,inverse_inverse(rat),aa(nat,rat,Uu,Uua)) ) ).

% ATP.lambda_306
tff(fact_8488_ATP_Olambda__307,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_sf(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_307
tff(fact_8489_ATP_Olambda__308,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_abv(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_308
tff(fact_8490_ATP_Olambda__309,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acn(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_309
tff(fact_8491_ATP_Olambda__310,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_pu(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,inverse_inverse(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_310
tff(fact_8492_ATP_Olambda__311,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_vw(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_311
tff(fact_8493_ATP_Olambda__312,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_zb(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_312
tff(fact_8494_ATP_Olambda__313,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ul(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,inverse_inverse(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_313
tff(fact_8495_ATP_Olambda__314,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_az(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_314
tff(fact_8496_ATP_Olambda__315,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_1(A)
     => ! [Uu: fun(B,nat),Uua: B] : ( aa(B,A,aTP_Lamp_du(fun(B,nat),fun(B,A),Uu),Uua) = aa(nat,A,semiring_1_of_nat(A),aa(B,nat,Uu,Uua)) ) ) ).

% ATP.lambda_315
tff(fact_8497_ATP_Olambda__316,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,int,aTP_Lamp_bu(fun(A,nat),fun(A,int),Uu),Uua) = aa(nat,int,semiring_1_of_nat(int),aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_316
tff(fact_8498_ATP_Olambda__317,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_so(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_317
tff(fact_8499_ATP_Olambda__318,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_abx(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_318
tff(fact_8500_ATP_Olambda__319,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_wx(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_319
tff(fact_8501_ATP_Olambda__320,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_lo(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,ln_ln(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_320
tff(fact_8502_ATP_Olambda__321,axiom,
    ! [A: $tType] :
      ( real_V2191834092415804123ebra_1(A)
     => ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,A,aTP_Lamp_aj(fun(nat,real),fun(nat,A),Uu),Uua) = real_Vector_of_real(A,aa(nat,real,Uu,Uua)) ) ) ).

% ATP.lambda_321
tff(fact_8503_ATP_Olambda__322,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,A,aTP_Lamp_ah(fun(nat,A),fun(nat,A),Uu),Uua) = aa(A,A,uminus_uminus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_322
tff(fact_8504_ATP_Olambda__323,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_bj(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_323
tff(fact_8505_ATP_Olambda__324,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_ba(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_324
tff(fact_8506_ATP_Olambda__325,axiom,
    ! [A: $tType,B: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(B,int),Uua: B] : ( aa(B,A,aTP_Lamp_dv(fun(B,int),fun(B,A),Uu),Uua) = aa(int,A,ring_1_of_int(A),aa(B,int,Uu,Uua)) ) ) ).

% ATP.lambda_325
tff(fact_8507_ATP_Olambda__326,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat] : ( aa(nat,fun(A,A),aTP_Lamp_ek(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua) = aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uua)) ) ) ).

% ATP.lambda_326
tff(fact_8508_ATP_Olambda__327,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_acx(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,artanh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_327
tff(fact_8509_ATP_Olambda__328,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_yr(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,artanh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_328
tff(fact_8510_ATP_Olambda__329,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_vq(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,artanh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_329
tff(fact_8511_ATP_Olambda__330,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_acg(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,arsinh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_330
tff(fact_8512_ATP_Olambda__331,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ws(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arsinh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_331
tff(fact_8513_ATP_Olambda__332,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_uz(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arsinh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_332
tff(fact_8514_ATP_Olambda__333,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_te(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_333
tff(fact_8515_ATP_Olambda__334,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_ace(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_334
tff(fact_8516_ATP_Olambda__335,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_wr(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_335
tff(fact_8517_ATP_Olambda__336,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_va(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arctan,aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_336
tff(fact_8518_ATP_Olambda__337,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_rh(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_337
tff(fact_8519_ATP_Olambda__338,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_acw(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcsin,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_338
tff(fact_8520_ATP_Olambda__339,axiom,
    ! [Uu: fun(real,real),Uua: real] : ( aa(real,real,aTP_Lamp_acs(fun(real,real),fun(real,real),Uu),Uua) = aa(real,real,arcosh(real),aa(real,real,Uu,Uua)) ) ).

% ATP.lambda_339
tff(fact_8521_ATP_Olambda__340,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_yq(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcosh(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_340
tff(fact_8522_ATP_Olambda__341,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_tu(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arcosh(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_341
tff(fact_8523_ATP_Olambda__342,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_rj(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_342
tff(fact_8524_ATP_Olambda__343,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_acv(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,arccos,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_343
tff(fact_8525_ATP_Olambda__344,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_aby(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_344
tff(fact_8526_ATP_Olambda__345,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_vx(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_345
tff(fact_8527_ATP_Olambda__346,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_uq(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sgn_sgn(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_346
tff(fact_8528_ATP_Olambda__347,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_cw(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_347
tff(fact_8529_ATP_Olambda__348,axiom,
    ! [A: $tType,B: $tType] :
      ( ordere166539214618696060dd_abs(A)
     => ! [Uu: fun(B,A),Uua: B] : ( aa(B,A,aTP_Lamp_dw(fun(B,A),fun(B,A),Uu),Uua) = aa(A,A,abs_abs(A),aa(B,A,Uu,Uua)) ) ) ).

% ATP.lambda_348
tff(fact_8530_ATP_Olambda__349,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_vp(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,abs_abs(real),aa(A,real,Uu,Uua)) ) ).

% ATP.lambda_349
tff(fact_8531_ATP_Olambda__350,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acr(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_350
tff(fact_8532_ATP_Olambda__351,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_wd(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_351
tff(fact_8533_ATP_Olambda__352,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_qu(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,tanh(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_352
tff(fact_8534_ATP_Olambda__353,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_uj(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,tanh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_353
tff(fact_8535_ATP_Olambda__354,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acb(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sinh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_354
tff(fact_8536_ATP_Olambda__355,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ut(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sinh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_355
tff(fact_8537_ATP_Olambda__356,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_qc(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,sinh(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_356
tff(fact_8538_ATP_Olambda__357,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_uu(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sinh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_357
tff(fact_8539_ATP_Olambda__358,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acf(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,cosh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_358
tff(fact_8540_ATP_Olambda__359,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_vb(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,cosh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_359
tff(fact_8541_ATP_Olambda__360,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_qd(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,cosh(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_360
tff(fact_8542_ATP_Olambda__361,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_vc(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,cosh(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_361
tff(fact_8543_ATP_Olambda__362,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_rl(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,tan(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_362
tff(fact_8544_ATP_Olambda__363,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_us(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,tan(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_363
tff(fact_8545_ATP_Olambda__364,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_sb(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sin(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_364
tff(fact_8546_ATP_Olambda__365,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ux(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,sin(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_365
tff(fact_8547_ATP_Olambda__366,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_pq(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,sin(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_366
tff(fact_8548_ATP_Olambda__367,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_rz(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,exp(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_367
tff(fact_8549_ATP_Olambda__368,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_acc(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_368
tff(fact_8550_ATP_Olambda__369,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_uw(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_369
tff(fact_8551_ATP_Olambda__370,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_pt(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,exp(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_370
tff(fact_8552_ATP_Olambda__371,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_uv(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_371
tff(fact_8553_ATP_Olambda__372,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_Vector_banach(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_ld(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,exp(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_372
tff(fact_8554_ATP_Olambda__373,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_ui(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,cot(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_373
tff(fact_8555_ATP_Olambda__374,axiom,
    ! [Uu: fun(nat,real),Uua: nat] : ( aa(nat,real,aTP_Lamp_yc(fun(nat,real),fun(nat,real),Uu),Uua) = aa(real,real,cos(real),aa(nat,real,Uu,Uua)) ) ).

% ATP.lambda_374
tff(fact_8556_ATP_Olambda__375,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_sk(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,cos(real),aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_375
tff(fact_8557_ATP_Olambda__376,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: A] : ( aa(A,B,aTP_Lamp_uy(fun(A,B),fun(A,B),Uu),Uua) = aa(B,B,cos(B),aa(A,B,Uu,Uua)) ) ) ).

% ATP.lambda_376
tff(fact_8558_ATP_Olambda__377,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(A,A),Uua: A] : ( aa(A,A,aTP_Lamp_qg(fun(A,A),fun(A,A),Uu),Uua) = aa(A,A,cos(A),aa(A,A,Uu,Uua)) ) ) ).

% ATP.lambda_377
tff(fact_8559_ATP_Olambda__378,axiom,
    ! [C: $tType,D: $tType,Uu: fun(D,set(C)),Uua: D] : ( aa(D,filter(C),aTP_Lamp_zg(fun(D,set(C)),fun(D,filter(C)),Uu),Uua) = principal(C,aa(D,set(C),Uu,Uua)) ) ).

% ATP.lambda_378
tff(fact_8560_ATP_Olambda__379,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,filter(B),aTP_Lamp_zh(fun(A,set(B)),fun(A,filter(B)),Uu),Uua) = principal(B,aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_379
tff(fact_8561_ATP_Olambda__380,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: A] : ( aa(A,nat,aTP_Lamp_ow(fun(A,set(B)),fun(A,nat),Uu),Uua) = aa(set(B),nat,finite_card(B),aa(A,set(B),Uu,Uua)) ) ).

% ATP.lambda_380
tff(fact_8562_ATP_Olambda__381,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: real] : ( aa(real,real,aTP_Lamp_qs(fun(real,fun(nat,real)),fun(real,real),Uu),Uua) = suminf(real,aa(real,fun(nat,real),Uu,Uua)) ) ).

% ATP.lambda_381
tff(fact_8563_ATP_Olambda__382,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_Vector_banach(B) )
     => ! [Uu: fun(A,fun(nat,B)),Uua: A] : ( aa(A,B,aTP_Lamp_we(fun(A,fun(nat,B)),fun(A,B),Uu),Uua) = suminf(B,aa(A,fun(nat,B),Uu,Uua)) ) ) ).

% ATP.lambda_382
tff(fact_8564_ATP_Olambda__383,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A] : ( aa(A,real,aTP_Lamp_tc(fun(A,real),fun(A,real),Uu),Uua) = aa(real,real,sqrt,aa(A,real,Uu,Uua)) ) ) ).

% ATP.lambda_383
tff(fact_8565_ATP_Olambda__384,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,set(A)),Uua: B] : ( aa(B,set(set(A)),aTP_Lamp_or(fun(B,set(A)),fun(B,set(set(A))),Uu),Uua) = pow2(A,aa(B,set(A),Uu,Uua)) ) ).

% ATP.lambda_384
tff(fact_8566_ATP_Olambda__385,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: A] : ( aa(A,nat,aTP_Lamp_fg(fun(A,nat),fun(A,nat),Uu),Uua) = aa(nat,nat,suc,aa(A,nat,Uu,Uua)) ) ).

% ATP.lambda_385
tff(fact_8567_ATP_Olambda__386,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: A] :
      ( aa(A,$o,aTP_Lamp_ii(fun(A,$o),fun(A,$o),Uu),Uua)
    <=> ~ aa(A,$o,Uu,Uua) ) ).

% ATP.lambda_386
tff(fact_8568_ATP_Olambda__387,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A)] : ( aa(set(A),filter(set(A)),aTP_Lamp_aec(set(A),fun(set(A),filter(set(A))),Uu),Uua) = principal(set(A),collect(set(A),aa(set(A),fun(set(A),$o),aTP_Lamp_aeb(set(A),fun(set(A),fun(set(A),$o)),Uu),Uua))) ) ).

% ATP.lambda_387
tff(fact_8569_ATP_Olambda__388,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real] : ( aa(real,filter(A),aTP_Lamp_zk(A,fun(real,filter(A)),Uu),Uua) = principal(A,collect(A,aa(real,fun(A,$o),aTP_Lamp_zj(A,fun(real,fun(A,$o)),Uu),Uua))) ) ) ).

% ATP.lambda_388
tff(fact_8570_ATP_Olambda__389,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Uu: fun(real,A),Uua: real] : ( aa(real,real,aTP_Lamp_wh(fun(real,A),fun(real,real),Uu),Uua) = aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(A,aa(real,A,Uu,Uua))) ) ) ).

% ATP.lambda_389
tff(fact_8571_ATP_Olambda__390,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_ajv(set(A),fun(A,$o),Uu),Uua)
        <=> ? [F5: fun(A,real)] :
              ( ( Uua = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),F5)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F5))) )
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F5))),Uu)
              & aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F5))) ) ) ) ).

% ATP.lambda_390
tff(fact_8572_ATP_Olambda__391,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_ajq(set(A),fun(A,$o),Uu),Uua)
        <=> ? [F5: fun(A,real)] :
              ( ( Uua = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),F5)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F5))) )
              & aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),F5)))
              & ! [V6: A] :
                  ( ( aa(A,real,F5,V6) != zero_zero(real) )
                 => member(A,V6,Uu) ) ) ) ) ).

% ATP.lambda_391
tff(fact_8573_ATP_Olambda__392,axiom,
    ! [B: $tType,Uu: set(set(B)),Uua: set(B)] :
      ( aa(set(B),$o,aTP_Lamp_ajk(set(set(B)),fun(set(B),$o),Uu),Uua)
    <=> ? [F5: fun(set(B),B)] :
          ( ( Uua = aa(set(set(B)),set(B),image(set(B),B,F5),Uu) )
          & ! [X4: set(B)] :
              ( member(set(B),X4,Uu)
             => member(B,aa(set(B),B,F5,X4),X4) ) ) ) ).

% ATP.lambda_392
tff(fact_8574_ATP_Olambda__393,axiom,
    ! [A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_ajf(set(set(A)),fun(set(A),$o),Uu),Uua)
        <=> ? [F5: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F5),Uu) )
              & ! [X4: set(A)] :
                  ( member(set(A),X4,Uu)
                 => member(A,aa(set(A),A,F5,X4),X4) ) ) ) ) ).

% ATP.lambda_393
tff(fact_8575_ATP_Olambda__394,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_ajh(set(set(A)),fun(set(A),$o),Uu),Uua)
        <=> ? [F5: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F5),Uu) )
              & ! [X4: set(A)] :
                  ( member(set(A),X4,Uu)
                 => member(A,aa(set(A),A,F5,X4),X4) ) ) ) ) ).

% ATP.lambda_394
tff(fact_8576_ATP_Olambda__395,axiom,
    ! [A: $tType] :
      ( finite8700451911770168679attice(A)
     => ! [Uu: set(set(A)),Uua: set(A)] :
          ( aa(set(A),$o,aTP_Lamp_ajl(set(set(A)),fun(set(A),$o),Uu),Uua)
        <=> ? [F5: fun(set(A),A)] :
              ( ( Uua = aa(set(set(A)),set(A),image(set(A),A,F5),Uu) )
              & ! [X4: set(A)] :
                  ( member(set(A),X4,Uu)
                 => member(A,aa(set(A),A,F5,X4),X4) ) ) ) ) ).

% ATP.lambda_395
tff(fact_8577_ATP_Olambda__396,axiom,
    ! [A: $tType,Uu: set(filter(A)),Uua: filter(A)] :
      ( aa(filter(A),$o,aTP_Lamp_ajg(set(filter(A)),fun(filter(A),$o),Uu),Uua)
    <=> ! [X4: filter(A)] :
          ( member(filter(A),X4,Uu)
         => aa(filter(A),$o,aa(filter(A),fun(filter(A),$o),ord_less_eq(filter(A)),Uua),X4) ) ) ).

% ATP.lambda_396
tff(fact_8578_ATP_Olambda__397,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_akv(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X4: A] :
              ( member(A,X4,Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),X4) ) ) ) ).

% ATP.lambda_397
tff(fact_8579_ATP_Olambda__398,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_ajb(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X4: A] :
              ( member(A,X4,Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),X4) ) ) ) ).

% ATP.lambda_398
tff(fact_8580_ATP_Olambda__399,axiom,
    ! [Uu: set(real),Uua: real] :
      ( aa(real,$o,aTP_Lamp_ajd(set(real),fun(real,$o),Uu),Uua)
    <=> ! [X4: real] :
          ( member(real,X4,Uu)
         => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),X4),Uua) ) ) ).

% ATP.lambda_399
tff(fact_8581_ATP_Olambda__400,axiom,
    ! [A: $tType] :
      ( condit1219197933456340205attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_akq(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X4: A] :
              ( member(A,X4,Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Uua) ) ) ) ).

% ATP.lambda_400
tff(fact_8582_ATP_Olambda__401,axiom,
    ! [A: $tType] :
      ( comple6319245703460814977attice(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_ajc(set(A),fun(A,$o),Uu),Uua)
        <=> ! [X4: A] :
              ( member(A,X4,Uu)
             => aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),X4),Uua) ) ) ) ).

% ATP.lambda_401
tff(fact_8583_ATP_Olambda__402,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(A,$o),Uua: A] :
          ( aa(A,$o,aTP_Lamp_abq(fun(A,$o),fun(A,$o),Uu),Uua)
        <=> ! [Y5: A] :
              ( aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uua),Y5)
             => aa(A,$o,Uu,Y5) ) ) ) ).

% ATP.lambda_402
tff(fact_8584_ATP_Olambda__403,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A] :
          ( aa(A,$o,aTP_Lamp_aju(set(A),fun(A,$o),Uu),Uua)
        <=> ? [T3: set(A),R5: fun(A,real)] :
              ( ( Uua = aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),R5)),T3) )
              & aa(set(A),$o,finite_finite(A),T3)
              & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),T3),Uu) ) ) ) ).

% ATP.lambda_403
tff(fact_8585_ATP_Olambda__404,axiom,
    ! [Uu: nat,Uua: nat] : ( aa(nat,set(nat),aTP_Lamp_agl(nat,fun(nat,set(nat)),Uu),Uua) = set_ord_atMost(nat,Uu) ) ).

% ATP.lambda_404
tff(fact_8586_ATP_Olambda__405,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] :
      ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_do(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(nat,real,Uua,divide_divide(nat,Uub,aa(num,nat,numeral_numeral(nat),bit0(one2)))),aa(nat,real,Uu,divide_divide(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),one_one(nat)),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ).

% ATP.lambda_405
tff(fact_8587_ATP_Olambda__406,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] :
      ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_hr(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(nat,real,Uu,Uub),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_406
tff(fact_8588_ATP_Olambda__407,axiom,
    ! [Uu: num,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_kh(num,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less_eq(code_integer),aa(num,code_integer,numeral_numeral(code_integer),Uu)),Uub),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),plus_plus(code_integer),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uub),aa(num,code_integer,numeral_numeral(code_integer),Uu))),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),times_times(code_integer),aa(num,code_integer,numeral_numeral(code_integer),bit0(one2))),Uua)),Uub)) ) ).

% ATP.lambda_407
tff(fact_8589_ATP_Olambda__408,axiom,
    ! [Uu: num,Uua: nat,Uub: nat] :
      ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aTP_Lamp_iv(num,fun(nat,fun(nat,product_prod(nat,nat))),Uu),Uua),Uub)
      = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(num,nat,numeral_numeral(nat),Uu)),Uub),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),one_one(nat))),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),Uu))),aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uua)),Uub)) ) ).

% ATP.lambda_408
tff(fact_8590_ATP_Olambda__409,axiom,
    ! [Uu: num,Uua: int,Uub: int] :
      ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_iw(num,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub)
      = $ite(aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(num,int,numeral_numeral(int),Uu)),Uub),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),Uua)),one_one(int))),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uub),aa(num,int,numeral_numeral(int),Uu))),aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),aa(num,int,numeral_numeral(int),bit0(one2))),Uua)),Uub)) ) ).

% ATP.lambda_409
tff(fact_8591_ATP_Olambda__410,axiom,
    ! [A: $tType] :
      ( unique1627219031080169319umeral(A)
     => ! [Uu: num,Uua: A,Uub: A] :
          ( aa(A,product_prod(A,A),aa(A,fun(A,product_prod(A,A)),aTP_Lamp_iy(num,fun(A,fun(A,product_prod(A,A))),Uu),Uua),Uub)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(num,A,numeral_numeral(A),Uu)),Uub),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)),one_one(A))),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(num,A,numeral_numeral(A),Uu))),aa(A,product_prod(A,A),product_Pair(A,A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(num,A,numeral_numeral(A),bit0(one2))),Uua)),Uub)) ) ) ).

% ATP.lambda_410
tff(fact_8592_ATP_Olambda__411,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: set(nat),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kn(set(nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(member(nat,Uub,Uu),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_411
tff(fact_8593_ATP_Olambda__412,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: set(A),Uub: A] :
          ( aa(A,B,aa(set(A),fun(A,B),aTP_Lamp_my(fun(A,B),fun(set(A),fun(A,B)),Uu),Uua),Uub)
          = $ite(member(A,Uub,Uua),aa(A,B,Uu,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_412
tff(fact_8594_ATP_Olambda__413,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: set(A),Uub: A] :
          ( aa(A,B,aa(set(A),fun(A,B),aTP_Lamp_mz(fun(A,B),fun(set(A),fun(A,B)),Uu),Uua),Uub)
          = $ite(member(A,Uub,Uua),aa(A,B,Uu,Uub),one_one(B)) ) ) ).

% ATP.lambda_413
tff(fact_8595_ATP_Olambda__414,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_kj(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(A,B,Uua,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_414
tff(fact_8596_ATP_Olambda__415,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_kl(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uu = Uub,aa(A,B,Uua,Uub),one_one(B)) ) ) ).

% ATP.lambda_415
tff(fact_8597_ATP_Olambda__416,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_bz(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_416
tff(fact_8598_ATP_Olambda__417,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_kk(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(A,B,Uua,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_417
tff(fact_8599_ATP_Olambda__418,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_km(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub)
          = $ite(Uub = Uu,aa(A,B,Uua,Uub),one_one(B)) ) ) ).

% ATP.lambda_418
tff(fact_8600_ATP_Olambda__419,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_mm(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_419
tff(fact_8601_ATP_Olambda__420,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_mo(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,abs_abs(code_integer),Uu)),Uub))) ) ).

% ATP.lambda_420
tff(fact_8602_ATP_Olambda__421,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,code_integer),aa(code_integer,fun(code_integer,product_prod(code_integer,code_integer)),aTP_Lamp_ml(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,code_integer))),Uu),Uua),Uub)
      = $ite(Uub = zero_zero(code_integer),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),zero_zero(code_integer)),aa(code_integer,product_prod(code_integer,code_integer),product_Pair(code_integer,code_integer,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),one_one(code_integer))),aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),Uu),Uub))) ) ).

% ATP.lambda_421
tff(fact_8603_ATP_Olambda__422,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,$o),Uua: fun(nat,A),Uub: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ko(fun(nat,$o),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub)
          = $ite(aa(nat,$o,Uu,Uub),aa(nat,A,Uua,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_422
tff(fact_8604_ATP_Olambda__423,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,$o),Uub: B] :
          ( aa(B,A,aa(fun(B,$o),fun(B,A),aTP_Lamp_afc(fun(B,A),fun(fun(B,$o),fun(B,A)),Uu),Uua),Uub)
          = $ite(aa(B,$o,Uua,Uub),aa(B,A,Uu,Uub),zero_zero(A)) ) ) ).

% ATP.lambda_423
tff(fact_8605_ATP_Olambda__424,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] :
          ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_kw(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(A,$o,Uua,Uub),aa(A,B,Uu,Uub),zero_zero(B)) ) ) ).

% ATP.lambda_424
tff(fact_8606_ATP_Olambda__425,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] :
          ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_kx(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub)
          = $ite(aa(A,$o,Uua,Uub),aa(A,B,Uu,Uub),one_one(B)) ) ) ).

% ATP.lambda_425
tff(fact_8607_ATP_Olambda__426,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] :
      ( aa(real,$o,aa(fun(real,real),fun(real,$o),aTP_Lamp_zp(fun(real,real),fun(fun(real,real),fun(real,$o)),Uu),Uua),Uub)
    <=> has_field_derivative(real,Uu,aa(real,real,Uua,Uub),topolo174197925503356063within(real,Uub,top_top(set(real)))) ) ).

% ATP.lambda_426
tff(fact_8608_ATP_Olambda__427,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_adl(fun(A,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uub),Uu),Uua) ) ).

% ATP.lambda_427
tff(fact_8609_ATP_Olambda__428,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: fun(B,C),Uub: B] : ( aa(B,A,aa(fun(B,C),fun(B,A),aTP_Lamp_pf(fun(C,fun(B,A)),fun(fun(B,C),fun(B,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,aa(B,C,Uua,Uub)),Uub) ) ) ).

% ATP.lambda_428
tff(fact_8610_ATP_Olambda__429,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_je(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_429
tff(fact_8611_ATP_Olambda__430,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jc(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_430
tff(fact_8612_ATP_Olambda__431,axiom,
    ! [Uu: fun(real,fun(nat,real)),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_qr(fun(real,fun(nat,real)),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),Uu,Uub),Uua) ) ).

% ATP.lambda_431
tff(fact_8613_ATP_Olambda__432,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hi(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_432
tff(fact_8614_ATP_Olambda__433,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hf(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(nat,fun(nat,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_433
tff(fact_8615_ATP_Olambda__434,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(C,fun(B,A)),Uua: B,Uub: C] : ( aa(C,A,aa(B,fun(C,A),aTP_Lamp_pd(fun(C,fun(B,A)),fun(B,fun(C,A)),Uu),Uua),Uub) = aa(B,A,aa(C,fun(B,A),Uu,Uub),Uua) ) ) ).

% ATP.lambda_434
tff(fact_8616_ATP_Olambda__435,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: fun(B,fun(A,C)),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_tz(fun(B,fun(A,C)),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,aa(B,fun(A,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_435
tff(fact_8617_ATP_Olambda__436,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: fun(B,fun(A,C)),Uua: A,Uub: B] : ( aa(B,C,aa(A,fun(B,C),aTP_Lamp_tx(fun(B,fun(A,C)),fun(A,fun(B,C)),Uu),Uua),Uub) = aa(A,C,aa(B,fun(A,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_436
tff(fact_8618_ATP_Olambda__437,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V3459762299906320749_field(C) )
     => ! [Uu: fun(A,fun(B,C)),Uua: B,Uub: A] : ( aa(A,C,aa(B,fun(A,C),aTP_Lamp_ss(fun(A,fun(B,C)),fun(B,fun(A,C)),Uu),Uua),Uub) = aa(B,C,aa(A,fun(B,C),Uu,Uub),Uua) ) ) ).

% ATP.lambda_437
tff(fact_8619_ATP_Olambda__438,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_gb(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_ga(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_438
tff(fact_8620_ATP_Olambda__439,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fa(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ez(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_439
tff(fact_8621_ATP_Olambda__440,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ey(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ex(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_440
tff(fact_8622_ATP_Olambda__441,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ew(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ev(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_atMost(nat,Uub)) ) ) ).

% ATP.lambda_441
tff(fact_8623_ATP_Olambda__442,axiom,
    ! [A: $tType] :
      ( ( ring_1(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat,Uua: A,Uub: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_db(nat,fun(A,fun(nat,A)),Uu),Uua),Uub)
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),$ite(Uub = Uu,one_one(A),zero_zero(A))),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_442
tff(fact_8624_ATP_Olambda__443,axiom,
    ! [Uu: code_integer,Uua: code_integer,Uub: code_integer] :
      ( aa(code_integer,product_prod(code_integer,$o),aa(code_integer,fun(code_integer,product_prod(code_integer,$o)),aTP_Lamp_mk(code_integer,fun(code_integer,fun(code_integer,product_prod(code_integer,$o))),Uu),Uua),Uub)
      = aa($o,product_prod(code_integer,$o),
          product_Pair(code_integer,$o,$ite(aa(code_integer,$o,aa(code_integer,fun(code_integer,$o),ord_less(code_integer),zero_zero(code_integer)),Uu),Uua,aa(code_integer,code_integer,aa(code_integer,fun(code_integer,code_integer),minus_minus(code_integer),aa(code_integer,code_integer,uminus_uminus(code_integer),Uua)),Uub))),
          ( Uub = one_one(code_integer) )) ) ).

% ATP.lambda_443
tff(fact_8625_ATP_Olambda__444,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_aka(set(A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(A,real,real_V7696804695334737415tation(A,Uu,Uua),Uub)),Uub) ) ) ).

% ATP.lambda_444
tff(fact_8626_ATP_Olambda__445,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hj(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hi(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_445
tff(fact_8627_ATP_Olambda__446,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,fun(nat,A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hg(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aTP_Lamp_hf(fun(nat,fun(nat,A)),fun(nat,fun(nat,A)),Uu),Uub)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uub),Uua)) ) ) ).

% ATP.lambda_446
tff(fact_8628_ATP_Olambda__447,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_wg(fun(nat,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ck(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),set_ord_atMost(nat,Uua)) ) ) ).

% ATP.lambda_447
tff(fact_8629_ATP_Olambda__448,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_jx(rat,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(int,int),$o,product_case_prod(int,int,$o,aa(int,fun(int,fun(int,$o)),aTP_Lamp_jw(int,fun(int,fun(int,fun(int,$o))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_448
tff(fact_8630_ATP_Olambda__449,axiom,
    ! [Uu: rat,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_jq(rat,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(int,int),$o,product_case_prod(int,int,$o,aa(int,fun(int,fun(int,$o)),aTP_Lamp_jp(int,fun(int,fun(int,fun(int,$o))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_449
tff(fact_8631_ATP_Olambda__450,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_it(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_is(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_450
tff(fact_8632_ATP_Olambda__451,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_ir(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_iq(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_451
tff(fact_8633_ATP_Olambda__452,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_io(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_in(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_452
tff(fact_8634_ATP_Olambda__453,axiom,
    ! [Uu: rat,Uua: int,Uub: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aTP_Lamp_im(rat,fun(int,fun(int,product_prod(int,int))),Uu),Uua),Uub) = aa(product_prod(int,int),product_prod(int,int),product_case_prod(int,int,product_prod(int,int),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_il(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uua),Uub)),quotient_of(Uu)) ) ).

% ATP.lambda_453
tff(fact_8635_ATP_Olambda__454,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: B] : ( aa(B,C,aa(fun(A,fun(B,C)),fun(B,C),aTP_Lamp_st(set(A),fun(fun(A,fun(B,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(B,fun(A,C),aTP_Lamp_ss(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uub)),Uu) ) ) ).

% ATP.lambda_454
tff(fact_8636_ATP_Olambda__455,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_qy(fun(nat,fun(real,real)),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Uu,Uub),zero_zero(real)),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uub)) ) ).

% ATP.lambda_455
tff(fact_8637_ATP_Olambda__456,axiom,
    ! [Uu: real,Uua: fun(nat,fun(real,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(real,real)),fun(nat,real),aTP_Lamp_qz(real,fun(fun(nat,fun(real,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Uua,Uub),zero_zero(real)),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ).

% ATP.lambda_456
tff(fact_8638_ATP_Olambda__457,axiom,
    ! [A: $tType] :
      ( zero(A)
     => ! [Uu: real,Uua: fun(nat,fun(A,real)),Uub: nat] : ( aa(nat,real,aa(fun(nat,fun(A,real)),fun(nat,real),aTP_Lamp_hp(real,fun(fun(nat,fun(A,real)),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(A,real,aa(nat,fun(A,real),Uua,Uub),zero_zero(A)),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ) ).

% ATP.lambda_457
tff(fact_8639_ATP_Olambda__458,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A] :
          ( aa(A,$o,aa(nat,fun(A,$o),aTP_Lamp_fu(fun(nat,A),fun(nat,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_fl(fun(nat,A),fun(A,fun(nat,A)),Uu),Uub)),set_ord_atMost(nat,Uua)) = zero_zero(A) ) ) ) ).

% ATP.lambda_458
tff(fact_8640_ATP_Olambda__459,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_wa(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua)),Uub) ) ) ).

% ATP.lambda_459
tff(fact_8641_ATP_Olambda__460,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_vs(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub))),aa(A,A,Uu,Uua)),Uub) ) ) ).

% ATP.lambda_460
tff(fact_8642_ATP_Olambda__461,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kq(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),zero_zero(A)),Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_461
tff(fact_8643_ATP_Olambda__462,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_tt(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_462
tff(fact_8644_ATP_Olambda__463,axiom,
    ! [A: $tType] :
      ( ( inverse(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_vt(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uu,Uua)),aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),Uua)) ) ) ).

% ATP.lambda_463
tff(fact_8645_ATP_Olambda__464,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_qv(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,semiring_1_of_nat(real),aa(nat,nat,suc,Uub)))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uub)) ) ).

% ATP.lambda_464
tff(fact_8646_ATP_Olambda__465,axiom,
    ! [Uu: real,Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_hq(real,fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(nat,real,Uua,Uub),semiring_char_0_fact(real,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ).

% ATP.lambda_465
tff(fact_8647_ATP_Olambda__466,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_aeo(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),one_one(nat)) )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_466
tff(fact_8648_ATP_Olambda__467,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_da(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),aa(nat,A,Uu,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat))))) ) ) ).

% ATP.lambda_467
tff(fact_8649_ATP_Olambda__468,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_aep(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub)),one_one(nat)) = Uua ) ) ) ).

% ATP.lambda_468
tff(fact_8650_ATP_Olambda__469,axiom,
    ! [A: $tType,Uu: nat,Uua: set(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(set(A),fun(list(A),$o),aTP_Lamp_mj(nat,fun(set(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & distinct(A,Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uua) ) ) ).

% ATP.lambda_469
tff(fact_8651_ATP_Olambda__470,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_mi(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uua )
        & distinct(A,Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu) ) ) ).

% ATP.lambda_470
tff(fact_8652_ATP_Olambda__471,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_agd(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & ( aa(list(A),nat,size_size(list(A)),Uub) = aa(nat,nat,suc,Uua) ) ) ) ).

% ATP.lambda_471
tff(fact_8653_ATP_Olambda__472,axiom,
    ! [A: $tType,Uu: nat,Uua: list(A),Uub: list(A)] :
      ( aa(list(A),$o,aa(list(A),fun(list(A),$o),aTP_Lamp_ns(nat,fun(list(A),fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(A),nat,size_size(list(A)),Uub) = Uu )
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),aa(list(A),set(A),set2(A),Uua)) ) ) ).

% ATP.lambda_472
tff(fact_8654_ATP_Olambda__473,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_ly(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(list(A),nat,size_size(list(A)),Uub)),Uua) ) ) ).

% ATP.lambda_473
tff(fact_8655_ATP_Olambda__474,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: list(A)] :
      ( aa(list(A),$o,aa(nat,fun(list(A),$o),aTP_Lamp_mc(set(A),fun(nat,fun(list(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(list(A),set(A),set2(A),Uub)),Uu)
        & ( aa(list(A),nat,size_size(list(A)),Uub) = Uua ) ) ) ).

% ATP.lambda_474
tff(fact_8656_ATP_Olambda__475,axiom,
    ! [Uu: nat,Uua: nat,Uub: list(nat)] :
      ( aa(list(nat),$o,aa(nat,fun(list(nat),$o),aTP_Lamp_aen(nat,fun(nat,fun(list(nat),$o)),Uu),Uua),Uub)
    <=> ( ( aa(list(nat),nat,size_size(list(nat)),Uub) = Uu )
        & ( aa(list(nat),nat,groups8242544230860333062m_list(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_475
tff(fact_8657_ATP_Olambda__476,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_qt(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,diffs(A,Uu)),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_476
tff(fact_8658_ATP_Olambda__477,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_al(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( member(nat,aa(nat,nat,suc,Uub),Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),Uua) ) ) ).

% ATP.lambda_477
tff(fact_8659_ATP_Olambda__478,axiom,
    ! [A: $tType,Uu: set(nat),Uua: nat,Uub: product_prod(A,nat)] :
      ( aa(product_prod(A,nat),$o,aa(nat,fun(product_prod(A,nat),$o),aTP_Lamp_ahy(set(nat),fun(nat,fun(product_prod(A,nat),$o)),Uu),Uua),Uub)
    <=> member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(product_prod(A,nat),nat,product_snd(A,nat),Uub)),Uua),Uu) ) ).

% ATP.lambda_478
tff(fact_8660_ATP_Olambda__479,axiom,
    ! [Uu: nat,Uua: nat,Uub: set(nat)] :
      ( aa(set(nat),$o,aa(nat,fun(set(nat),$o),aTP_Lamp_mh(nat,fun(nat,fun(set(nat),$o)),Uu),Uua),Uub)
    <=> ( member(set(nat),Uub,pow2(nat,set_or7035219750837199246ssThan(nat,zero_zero(nat),Uu)))
        & ( aa(set(nat),nat,finite_card(nat),Uub) = Uua ) ) ) ).

% ATP.lambda_479
tff(fact_8661_ATP_Olambda__480,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: list(A),Uua: fun(A,$o),Uub: A] :
          ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_aiz(list(A),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,aa(list(A),set(A),set2(A),Uu))
            & aa(A,$o,Uua,Uub) ) ) ) ).

% ATP.lambda_480
tff(fact_8662_ATP_Olambda__481,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_kb(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uu),aa(nat,A,semiring_1_of_nat(A),Uub)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_481
tff(fact_8663_ATP_Olambda__482,axiom,
    ! [A: $tType,Uu: list(A),Uua: set(nat),Uub: nat] :
      ( aa(nat,$o,aa(set(nat),fun(nat,$o),aTP_Lamp_afo(list(A),fun(set(nat),fun(nat,$o)),Uu),Uua),Uub)
    <=> member(nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),aa(list(A),nat,size_size(list(A)),Uu)),Uua) ) ).

% ATP.lambda_482
tff(fact_8664_ATP_Olambda__483,axiom,
    ! [A: $tType] :
      ( wellorder(A)
     => ! [Uu: set(A),Uua: nat,Uub: A] :
          ( aa(A,$o,aa(nat,fun(A,$o),aTP_Lamp_aic(set(A),fun(nat,fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & aa(A,$o,aa(A,fun(A,$o),ord_less(A),infini527867602293511546merate(A,Uu,Uua)),Uub) ) ) ) ).

% ATP.lambda_483
tff(fact_8665_ATP_Olambda__484,axiom,
    ! [A: $tType,Uu: set(A),Uua: nat,Uub: set(A)] :
      ( aa(set(A),$o,aa(nat,fun(set(A),$o),aTP_Lamp_le(set(A),fun(nat,fun(set(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uub),Uu)
        & ( aa(set(A),nat,finite_card(A),Uub) = Uua ) ) ) ).

% ATP.lambda_484
tff(fact_8666_ATP_Olambda__485,axiom,
    ! [Uu: set(nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ak(set(nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( member(nat,Uub,Uu)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uub),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_485
tff(fact_8667_ATP_Olambda__486,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & ring_1(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cz(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_486
tff(fact_8668_ATP_Olambda__487,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cy(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uu),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_487
tff(fact_8669_ATP_Olambda__488,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_dg(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,diffs(A,Uua),Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uub)) ) ) ).

% ATP.lambda_488
tff(fact_8670_ATP_Olambda__489,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_fm(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,binomial(aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub)) ) ).

% ATP.lambda_489
tff(fact_8671_ATP_Olambda__490,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_kg(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uua)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_490
tff(fact_8672_ATP_Olambda__491,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_lq(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_491
tff(fact_8673_ATP_Olambda__492,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_kf(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uua),Uub) ) ) ).

% ATP.lambda_492
tff(fact_8674_ATP_Olambda__493,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_lt(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_493
tff(fact_8675_ATP_Olambda__494,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_ls(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),Uub),Uua) ) ) ).

% ATP.lambda_494
tff(fact_8676_ATP_Olambda__495,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_lr(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uu),Uub)
        & aa(int,$o,aa(int,fun(int,$o),ord_less(int),Uub),Uua) ) ) ).

% ATP.lambda_495
tff(fact_8677_ATP_Olambda__496,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ahs(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uua)
        & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),Uub),Uu) ) ) ).

% ATP.lambda_496
tff(fact_8678_ATP_Olambda__497,axiom,
    ! [Uu: int,Uua: int,Uub: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aTP_Lamp_aho(int,fun(int,fun(int,$o)),Uu),Uua),Uub)
    <=> ( aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uua)
        & aa(int,$o,aa(int,fun(int,$o),dvd_dvd(int),Uub),Uu) ) ) ).

% ATP.lambda_497
tff(fact_8679_ATP_Olambda__498,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: set(A),Uua: fun(A,real),Uub: A] :
          ( aa(A,$o,aa(fun(A,real),fun(A,$o),aTP_Lamp_act(set(A),fun(fun(A,real),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & aa(real,$o,aa(real,fun(real,$o),ord_less(real),zero_zero(real)),aa(A,real,Uua,Uub)) ) ) ) ).

% ATP.lambda_498
tff(fact_8680_ATP_Olambda__499,axiom,
    ! [A: $tType,Uu: list(A),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_aeq(list(A),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,count_list(A,Uu),Uub)),aa(A,nat,Uua,Uub)) ) ).

% ATP.lambda_499
tff(fact_8681_ATP_Olambda__500,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: list(A),Uub: A] : ( aa(A,nat,aa(list(A),fun(A,nat),aTP_Lamp_aes(fun(A,nat),fun(list(A),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,count_list(A,Uua),Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_500
tff(fact_8682_ATP_Olambda__501,axiom,
    ! [A: $tType,Uu: set(A),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_ac(set(A),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( member(A,Uub,Uu)
        & aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_501
tff(fact_8683_ATP_Olambda__502,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_ks(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_502
tff(fact_8684_ATP_Olambda__503,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_lv(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & ( aa(A,B,Uua,Uub) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_503
tff(fact_8685_ATP_Olambda__504,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_ku(set(A),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,Uu)
            & ( aa(A,B,Uua,Uub) != one_one(B) ) ) ) ) ).

% ATP.lambda_504
tff(fact_8686_ATP_Olambda__505,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_lw(fun(B,A),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( member(B,Uub,Uua)
            & ( aa(B,A,Uu,Uub) != zero_zero(A) ) ) ) ) ).

% ATP.lambda_505
tff(fact_8687_ATP_Olambda__506,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: set(B),Uub: B] :
          ( aa(B,$o,aa(set(B),fun(B,$o),aTP_Lamp_nt(fun(B,A),fun(set(B),fun(B,$o)),Uu),Uua),Uub)
        <=> ( member(B,Uub,Uua)
            & ( aa(B,A,Uu,Uub) != one_one(A) ) ) ) ) ).

% ATP.lambda_506
tff(fact_8688_ATP_Olambda__507,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_ae(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> ( member(A,Uub,Uu)
        & ~ member(A,Uub,Uua) ) ) ).

% ATP.lambda_507
tff(fact_8689_ATP_Olambda__508,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_ael(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uu) ) ).

% ATP.lambda_508
tff(fact_8690_ATP_Olambda__509,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_jb(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_509
tff(fact_8691_ATP_Olambda__510,axiom,
    ! [Uu: real,Uua: complex,Uub: complex] :
      ( aa(complex,$o,aa(complex,fun(complex,$o),aTP_Lamp_adc(real,fun(complex,fun(complex,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(complex,Uua,Uub)),Uu) ) ).

% ATP.lambda_510
tff(fact_8692_ATP_Olambda__511,axiom,
    ! [Uu: real,Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_ade(real,fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(real,Uua,Uub)),Uu) ) ).

% ATP.lambda_511
tff(fact_8693_ATP_Olambda__512,axiom,
    ! [A: $tType] :
      ( real_V768167426530841204y_dist(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ada(real,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_512
tff(fact_8694_ATP_Olambda__513,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: real,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_oy(real,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_513
tff(fact_8695_ATP_Olambda__514,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: A,Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_zj(A,fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(A,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_514
tff(fact_8696_ATP_Olambda__515,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_jg(nat,fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)),Uu) ) ).

% ATP.lambda_515
tff(fact_8697_ATP_Olambda__516,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_om(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_516
tff(fact_8698_ATP_Olambda__517,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_ok(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_517
tff(fact_8699_ATP_Olambda__518,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_ol(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),divide_divide(A,Uub,Uu)),Uua) ) ) ).

% ATP.lambda_518
tff(fact_8700_ATP_Olambda__519,axiom,
    ! [A: $tType] :
      ( linordered_field(A)
     => ! [Uu: A,Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_oj(A,fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,aa(A,fun(A,A),times_times(A),Uu),Uub)),Uua) ) ) ).

% ATP.lambda_519
tff(fact_8701_ATP_Olambda__520,axiom,
    ! [B: $tType,A: $tType,Uu: set(product_prod(A,B)),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_jn(set(product_prod(A,B)),fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> member(product_prod(A,B),aa(B,product_prod(A,B),product_Pair(A,B,Uua),Uub),Uu) ) ).

% ATP.lambda_520
tff(fact_8702_ATP_Olambda__521,axiom,
    ! [A: $tType,Uu: set(product_prod(A,A)),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_aeh(set(product_prod(A,A)),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Uua),Uub),Uu) ) ).

% ATP.lambda_521
tff(fact_8703_ATP_Olambda__522,axiom,
    ! [A: $tType,Uu: list(list(A)),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_aex(list(list(A)),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,nth(A,aa(nat,list(A),nth(list(A),Uu),Uub)),Uua) ) ).

% ATP.lambda_522
tff(fact_8704_ATP_Olambda__523,axiom,
    ! [Uu: nat,Uua: complex,Uub: complex] :
      ( aa(complex,$o,aa(complex,fun(complex,$o),aTP_Lamp_fp(nat,fun(complex,fun(complex,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Uub),Uu) = Uua ) ) ).

% ATP.lambda_523
tff(fact_8705_ATP_Olambda__524,axiom,
    ! [Uu: complex,Uua: nat,Uub: complex] :
      ( aa(complex,$o,aa(nat,fun(complex,$o),aTP_Lamp_an(complex,fun(nat,fun(complex,$o)),Uu),Uua),Uub)
    <=> ( aa(nat,complex,aa(complex,fun(nat,complex),power_power(complex),Uub),Uua) = Uu ) ) ).

% ATP.lambda_524
tff(fact_8706_ATP_Olambda__525,axiom,
    ! [A: $tType] :
      ( archim2362893244070406136eiling(A)
     => ! [Uu: A,Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ky(A,fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> ( member(A,Uub,ring_1_Ints(A))
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uu),Uub)
            & aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uub),Uua) ) ) ) ).

% ATP.lambda_525
tff(fact_8707_ATP_Olambda__526,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cr(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_526
tff(fact_8708_ATP_Olambda__527,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ct(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,suc,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_527
tff(fact_8709_ATP_Olambda__528,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,int),Uub: nat] : ( aa(nat,real,aa(fun(nat,int),fun(nat,real),aTP_Lamp_yb(fun(nat,real),fun(fun(nat,int),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(real,real,aa(real,fun(real,real),times_times(real),aa(int,real,ring_1_of_int(real),aa(nat,int,Uua,Uub))),aa(real,real,aa(real,fun(real,real),times_times(real),aa(num,real,numeral_numeral(real),bit0(one2))),pi))) ) ).

% ATP.lambda_528
tff(fact_8710_ATP_Olambda__529,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_qw(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),aa(nat,nat,suc,Uub))) ) ).

% ATP.lambda_529
tff(fact_8711_ATP_Olambda__530,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_dk(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(nat,real,Uu,Uub)),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uua),Uub)) ) ).

% ATP.lambda_530
tff(fact_8712_ATP_Olambda__531,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_fv(fun(nat,nat),fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uua),Uub)) ) ).

% ATP.lambda_531
tff(fact_8713_ATP_Olambda__532,axiom,
    ! [B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(nat,B),Uua: B,Uub: nat] : ( aa(nat,B,aa(B,fun(nat,B),aTP_Lamp_wi(fun(nat,B),fun(B,fun(nat,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uu,Uub)),aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),Uub)) ) ) ).

% ATP.lambda_532
tff(fact_8714_ATP_Olambda__533,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra(A)
        & idom(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fl(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_533
tff(fact_8715_ATP_Olambda__534,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ck(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_534
tff(fact_8716_ATP_Olambda__535,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cs(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_535
tff(fact_8717_ATP_Olambda__536,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cx(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_536
tff(fact_8718_ATP_Olambda__537,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult(A)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_fr(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_537
tff(fact_8719_ATP_Olambda__538,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_gc(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub)) ) ) ).

% ATP.lambda_538
tff(fact_8720_ATP_Olambda__539,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rn(fun(A,real),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_539
tff(fact_8721_ATP_Olambda__540,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_aev(fun(B,A),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),aa(B,A,Uu,Uua)),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_540
tff(fact_8722_ATP_Olambda__541,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_adi(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_541
tff(fact_8723_ATP_Olambda__542,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] :
      ( aa(A,$o,aa(fun(A,real),fun(A,$o),aTP_Lamp_zx(fun(A,real),fun(fun(A,real),fun(A,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_542
tff(fact_8724_ATP_Olambda__543,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_zt(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_543
tff(fact_8725_ATP_Olambda__544,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_zv(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_544
tff(fact_8726_ATP_Olambda__545,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aaf(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_545
tff(fact_8727_ATP_Olambda__546,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_aat(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = divide_divide(real,aa(real,real,Uu,Uub),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_546
tff(fact_8728_ATP_Olambda__547,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sq(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_547
tff(fact_8729_ATP_Olambda__548,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_sd(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_548
tff(fact_8730_ATP_Olambda__549,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_aca(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_549
tff(fact_8731_ATP_Olambda__550,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_qf(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = divide_divide(A,aa(A,A,Uu,Uub),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_550
tff(fact_8732_ATP_Olambda__551,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vu(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_551
tff(fact_8733_ATP_Olambda__552,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_za(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = divide_divide(real,aa(A,real,Uu,Uub),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_552
tff(fact_8734_ATP_Olambda__553,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abh(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_553
tff(fact_8735_ATP_Olambda__554,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_un(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_554
tff(fact_8736_ATP_Olambda__555,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_zq(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = divide_divide(real,aa(real,real,Uua,Uub),aa(real,real,Uu,Uub)) ) ).

% ATP.lambda_555
tff(fact_8737_ATP_Olambda__556,axiom,
    ! [Uu: fun(nat,rat),Uua: fun(nat,rat),Uub: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aa(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),aTP_Lamp_afp(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat))),Uu),Uua),Uub) = aa(rat,rat,aa(rat,fun(rat,rat),times_times(rat),aa(nat,rat,Uu,Uub)),aa(nat,rat,Uua,Uub)) ) ).

% ATP.lambda_556
tff(fact_8738_ATP_Olambda__557,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,nat,aa(fun(nat,nat),fun(nat,nat),aTP_Lamp_ke(fun(nat,nat),fun(fun(nat,nat),fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uub)),aa(nat,nat,Uua,Uub)) ) ).

% ATP.lambda_557
tff(fact_8739_ATP_Olambda__558,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aaz(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_558
tff(fact_8740_ATP_Olambda__559,axiom,
    ! [A: $tType] :
      ( topolo4211221413907600880p_mult(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aio(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_559
tff(fact_8741_ATP_Olambda__560,axiom,
    ! [A: $tType] :
      ( linordered_idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_kd(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_560
tff(fact_8742_ATP_Olambda__561,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_bw(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_561
tff(fact_8743_ATP_Olambda__562,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rv(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_562
tff(fact_8744_ATP_Olambda__563,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acl(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_563
tff(fact_8745_ATP_Olambda__564,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ack(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_564
tff(fact_8746_ATP_Olambda__565,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_py(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_565
tff(fact_8747_ATP_Olambda__566,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vl(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_566
tff(fact_8748_ATP_Olambda__567,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo4211221413907600880p_mult(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vk(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_567
tff(fact_8749_ATP_Olambda__568,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_yv(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_568
tff(fact_8750_ATP_Olambda__569,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_uf(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_569
tff(fact_8751_ATP_Olambda__570,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abg(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_570
tff(fact_8752_ATP_Olambda__571,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vm(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_571
tff(fact_8753_ATP_Olambda__572,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1898628316856586783d_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vf(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_572
tff(fact_8754_ATP_Olambda__573,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_nu(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_573
tff(fact_8755_ATP_Olambda__574,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zc(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uub)),aa(A,real,Uu,Uub)) ) ).

% ATP.lambda_574
tff(fact_8756_ATP_Olambda__575,axiom,
    ! [B: $tType,A: $tType] :
      ( linordered_idom(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_el(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_575
tff(fact_8757_ATP_Olambda__576,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,real),Uub: nat] : ( aa(nat,real,aa(fun(nat,real),fun(nat,real),aTP_Lamp_xf(fun(nat,real),fun(fun(nat,real),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),aa(nat,real,Uua,Uub)) ) ).

% ATP.lambda_576
tff(fact_8758_ATP_Olambda__577,axiom,
    ! [Uu: fun(nat,rat),Uua: fun(nat,rat),Uub: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afr(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),Uu),Uua),Uub) = aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(nat,rat,Uu,Uub)),aa(nat,rat,Uua,Uub)) ) ).

% ATP.lambda_577
tff(fact_8759_ATP_Olambda__578,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cf(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_578
tff(fact_8760_ATP_Olambda__579,axiom,
    ! [A: $tType] :
      ( topolo1633459387980952147up_add(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aiq(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_579
tff(fact_8761_ATP_Olambda__580,axiom,
    ! [A: $tType,B: $tType] :
      ( ab_group_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ec(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_580
tff(fact_8762_ATP_Olambda__581,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rp(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_581
tff(fact_8763_ATP_Olambda__582,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_acm(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_582
tff(fact_8764_ATP_Olambda__583,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_qe(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_583
tff(fact_8765_ATP_Olambda__584,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_akh(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_584
tff(fact_8766_ATP_Olambda__585,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vv(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_585
tff(fact_8767_ATP_Olambda__586,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo1633459387980952147up_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vo(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_586
tff(fact_8768_ATP_Olambda__587,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,set(B)),Uua: fun(A,set(B)),Uub: A] : ( aa(A,set(B),aa(fun(A,set(B)),fun(A,set(B)),aTP_Lamp_agf(fun(A,set(B)),fun(fun(A,set(B)),fun(A,set(B))),Uu),Uua),Uub) = aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),aa(A,set(B),Uu,Uub)),aa(A,set(B),Uua,Uub)) ) ).

% ATP.lambda_587
tff(fact_8769_ATP_Olambda__588,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ud(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_588
tff(fact_8770_ATP_Olambda__589,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vn(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_589
tff(fact_8771_ATP_Olambda__590,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_lj(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uua,Uub)),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_590
tff(fact_8772_ATP_Olambda__591,axiom,
    ! [A: $tType] :
      ( ord(A)
     => ! [Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_hc(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_591
tff(fact_8773_ATP_Olambda__592,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: fun(A,nat),Uub: A] : ( aa(A,nat,aa(fun(A,nat),fun(A,nat),aTP_Lamp_fd(fun(A,nat),fun(fun(A,nat),fun(A,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(A,nat,Uua,Uub)),aa(A,nat,Uu,Uub)) ) ).

% ATP.lambda_592
tff(fact_8774_ATP_Olambda__593,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_uc(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uua,Uub)),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_593
tff(fact_8775_ATP_Olambda__594,axiom,
    ! [A: $tType] :
      ( ( topolo5987344860129210374id_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ce(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_594
tff(fact_8776_ATP_Olambda__595,axiom,
    ! [A: $tType] :
      ( topolo6943815403480290642id_add(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_ail(fun(nat,A),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_595
tff(fact_8777_ATP_Olambda__596,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(B,A),Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ed(fun(B,A),fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_596
tff(fact_8778_ATP_Olambda__597,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_rs(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_597
tff(fact_8779_ATP_Olambda__598,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ach(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_598
tff(fact_8780_ATP_Olambda__599,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_px(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(A,A,Uu,Uub)),aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_599
tff(fact_8781_ATP_Olambda__600,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ake(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_600
tff(fact_8782_ATP_Olambda__601,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & topolo6943815403480290642id_add(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_vd(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_601
tff(fact_8783_ATP_Olambda__602,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abd(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_602
tff(fact_8784_ATP_Olambda__603,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo6943815403480290642id_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ue(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_603
tff(fact_8785_ATP_Olambda__604,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_lx(fun(A,B),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_604
tff(fact_8786_ATP_Olambda__605,axiom,
    ! [Uu: fun(real,real),Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_qq(fun(real,real),fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,Uu,Uub)),aa(real,real,Uua,Uub)) ) ).

% ATP.lambda_605
tff(fact_8787_ATP_Olambda__606,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ta(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_606
tff(fact_8788_ATP_Olambda__607,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_aco(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_607
tff(fact_8789_ATP_Olambda__608,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_ww(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_608
tff(fact_8790_ATP_Olambda__609,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_uo(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr(real),aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_609
tff(fact_8791_ATP_Olambda__610,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_acu(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_610
tff(fact_8792_ATP_Olambda__611,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_xl(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_611
tff(fact_8793_ATP_Olambda__612,axiom,
    ! [A: $tType,Uu: fun(A,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tw(fun(A,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,log(aa(A,real,Uu,Uub)),aa(A,real,Uua,Uub)) ) ).

% ATP.lambda_612
tff(fact_8794_ATP_Olambda__613,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(C,A),Uua: fun(C,B),Uub: C] : ( aa(C,product_prod(A,B),aa(fun(C,B),fun(C,product_prod(A,B)),aTP_Lamp_alb(fun(C,A),fun(fun(C,B),fun(C,product_prod(A,B))),Uu),Uua),Uub) = aa(B,product_prod(A,B),product_Pair(A,B,aa(C,A,Uu,Uub)),aa(C,B,Uua,Uub)) ) ).

% ATP.lambda_613
tff(fact_8795_ATP_Olambda__614,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,fun(B,B)),Uua: fun(A,nat),Uub: A] : ( aa(A,fun(B,B),aa(fun(A,nat),fun(A,fun(B,B)),aTP_Lamp_ald(fun(A,fun(B,B)),fun(fun(A,nat),fun(A,fun(B,B))),Uu),Uua),Uub) = aa(fun(B,B),fun(B,B),aa(nat,fun(fun(B,B),fun(B,B)),compow(fun(B,B)),aa(A,nat,Uua,Uub)),aa(A,fun(B,B),Uu,Uub)) ) ).

% ATP.lambda_614
tff(fact_8796_ATP_Olambda__615,axiom,
    ! [A: $tType,Uu: fun(A,$o),Uua: fun(A,$o),Uub: A] :
      ( aa(A,$o,aa(fun(A,$o),fun(A,$o),aTP_Lamp_pb(fun(A,$o),fun(fun(A,$o),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,$o,Uu,Uub)
        & aa(A,$o,Uua,Uub) ) ) ).

% ATP.lambda_615
tff(fact_8797_ATP_Olambda__616,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: fun(A,B),Uub: A] :
      ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_zs(fun(A,B),fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,B,Uu,Uub) = aa(A,B,Uua,Uub) ) ) ).

% ATP.lambda_616
tff(fact_8798_ATP_Olambda__617,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aez(A,fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,B,Uua,Uu) = aa(A,B,Uua,Uub) ) ) ) ).

% ATP.lambda_617
tff(fact_8799_ATP_Olambda__618,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [Uu: fun(A,B),Uua: fun(A,$o),Uub: A] : ( aa(A,B,aa(fun(A,$o),fun(A,B),aTP_Lamp_mv(fun(A,B),fun(fun(A,$o),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa($o,B,zero_neq_one_of_bool(B),aa(A,$o,Uua,Uub))) ) ) ).

% ATP.lambda_618
tff(fact_8800_ATP_Olambda__619,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_qj(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,Uu,Uub)),aa(nat,nat,suc,Uua)) ) ) ).

% ATP.lambda_619
tff(fact_8801_ATP_Olambda__620,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_acd(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = comm_s3205402744901411588hammer(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_620
tff(fact_8802_ATP_Olambda__621,axiom,
    ! [A: $tType,B: $tType] :
      ( order(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,set(B),aa(B,fun(A,set(B)),aTP_Lamp_agk(fun(A,B),fun(B,fun(A,set(B))),Uu),Uua),Uub) = set_or3652927894154168847AtMost(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_621
tff(fact_8803_ATP_Olambda__622,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo4987421752381908075d_mult(C)
     => ! [Uu: set(A),Uua: fun(B,fun(A,C)),Uub: B] : ( aa(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_ua(set(A),fun(fun(B,fun(A,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(B,fun(A,C),Uua,Uub)),Uu) ) ) ).

% ATP.lambda_622
tff(fact_8804_ATP_Olambda__623,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( topolo5987344860129210374id_add(C)
     => ! [Uu: set(A),Uua: fun(B,fun(A,C)),Uub: B] : ( aa(B,C,aa(fun(B,fun(A,C)),fun(B,C),aTP_Lamp_ty(set(A),fun(fun(B,fun(A,C)),fun(B,C)),Uu),Uua),Uub) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),Uua,Uub)),Uu) ) ) ).

% ATP.lambda_623
tff(fact_8805_ATP_Olambda__624,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,real,aa(B,fun(A,real),aTP_Lamp_uk(fun(A,B),fun(B,fun(A,real)),Uu),Uua),Uub) = real_V557655796197034286t_dist(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_624
tff(fact_8806_ATP_Olambda__625,axiom,
    ! [A: $tType] :
      ( topolo3112930676232923870pology(A)
     => ! [Uu: fun(nat,set(A)),Uua: set(A),Uub: nat] :
          ( aa(nat,$o,aa(set(A),fun(nat,$o),aTP_Lamp_abc(fun(nat,set(A)),fun(set(A),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(nat,set(A),Uu,Uub)),Uua) ) ) ).

% ATP.lambda_625
tff(fact_8807_ATP_Olambda__626,axiom,
    ! [Uu: fun(nat,nat),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_kr(fun(nat,nat),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,Uu,Uub)),Uua) ) ).

% ATP.lambda_626
tff(fact_8808_ATP_Olambda__627,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] :
      ( aa(B,$o,aa(set(A),fun(B,$o),aTP_Lamp_pa(fun(B,set(A)),fun(set(A),fun(B,$o)),Uu),Uua),Uub)
    <=> aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),aa(B,set(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_627
tff(fact_8809_ATP_Olambda__628,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aah(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_628
tff(fact_8810_ATP_Olambda__629,axiom,
    ! [A: $tType,B: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aae(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_629
tff(fact_8811_ATP_Olambda__630,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_zz(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_630
tff(fact_8812_ATP_Olambda__631,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_zw(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_631
tff(fact_8813_ATP_Olambda__632,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_cc(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = divide_divide(A,aa(nat,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_632
tff(fact_8814_ATP_Olambda__633,axiom,
    ! [A: $tType,B: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_nd(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_633
tff(fact_8815_ATP_Olambda__634,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V3459762299906320749_field(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_um(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = divide_divide(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_634
tff(fact_8816_ATP_Olambda__635,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wp(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = divide_divide(A,aa(nat,A,Uua,Uub),Uu) ) ) ).

% ATP.lambda_635
tff(fact_8817_ATP_Olambda__636,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aac(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_636
tff(fact_8818_ATP_Olambda__637,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ci(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_637
tff(fact_8819_ATP_Olambda__638,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_ea(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_638
tff(fact_8820_ATP_Olambda__639,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_rq(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_639
tff(fact_8821_ATP_Olambda__640,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_abt(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_640
tff(fact_8822_ATP_Olambda__641,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_aci(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_641
tff(fact_8823_ATP_Olambda__642,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_qa(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_642
tff(fact_8824_ATP_Olambda__643,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4412858255891104859lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_vg(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_643
tff(fact_8825_ATP_Olambda__644,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_ug(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_644
tff(fact_8826_ATP_Olambda__645,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_vi(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_645
tff(fact_8827_ATP_Olambda__646,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_sj(real,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_646
tff(fact_8828_ATP_Olambda__647,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cm(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_647
tff(fact_8829_ATP_Olambda__648,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wn(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_648
tff(fact_8830_ATP_Olambda__649,axiom,
    ! [B: $tType,A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_tl(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uua,Uub)),Uu) ) ) ).

% ATP.lambda_649
tff(fact_8831_ATP_Olambda__650,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_aip(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_650
tff(fact_8832_ATP_Olambda__651,axiom,
    ! [A: $tType] :
      ( ring_1(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_hd(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_651
tff(fact_8833_ATP_Olambda__652,axiom,
    ! [B: $tType,A: $tType,Uu: fun(B,set(A)),Uua: set(A),Uub: B] : ( aa(B,set(A),aa(set(A),fun(B,set(A)),aTP_Lamp_os(fun(B,set(A)),fun(set(A),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(B,set(A),Uu,Uub)),Uua) ) ).

% ATP.lambda_652
tff(fact_8834_ATP_Olambda__653,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_ub(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_653
tff(fact_8835_ATP_Olambda__654,axiom,
    ! [Uu: fun(real,real),Uua: nat,Uub: real] : ( aa(real,real,aa(nat,fun(real,real),aTP_Lamp_qi(fun(real,real),fun(nat,fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,Uu,Uub)),Uua) ) ).

% ATP.lambda_654
tff(fact_8836_ATP_Olambda__655,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_sm(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_655
tff(fact_8837_ATP_Olambda__656,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: nat,Uub: A] : ( aa(A,A,aa(nat,fun(A,A),aTP_Lamp_qk(fun(A,A),fun(nat,fun(A,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_656
tff(fact_8838_ATP_Olambda__657,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_abi(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_657
tff(fact_8839_ATP_Olambda__658,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [Uu: fun(A,B),Uua: nat,Uub: A] : ( aa(A,B,aa(nat,fun(A,B),aTP_Lamp_tv(fun(A,B),fun(nat,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_658
tff(fact_8840_ATP_Olambda__659,axiom,
    ! [Uu: nat,Uua: fun(real,real),Uub: real] : ( aa(real,real,aa(fun(real,real),fun(real,real),aTP_Lamp_yx(nat,fun(fun(real,real),fun(real,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_659
tff(fact_8841_ATP_Olambda__660,axiom,
    ! [A: $tType,Uu: nat,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_tm(nat,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_660
tff(fact_8842_ATP_Olambda__661,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_adq(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_661
tff(fact_8843_ATP_Olambda__662,axiom,
    ! [B: $tType,A: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] : ( aa(B,A,aa(A,fun(B,A),aTP_Lamp_oa(fun(B,A),fun(A,fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_662
tff(fact_8844_ATP_Olambda__663,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_aba(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_663
tff(fact_8845_ATP_Olambda__664,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ain(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_664
tff(fact_8846_ATP_Olambda__665,axiom,
    ! [A: $tType,B: $tType] :
      ( linord4140545234300271783up_add(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_aea(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),Uua) ) ) ).

% ATP.lambda_665
tff(fact_8847_ATP_Olambda__666,axiom,
    ! [Uu: fun(real,real),Uua: real,Uub: real] : ( aa(real,real,aa(real,fun(real,real),aTP_Lamp_qp(fun(real,real),fun(real,fun(real,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr(real),aa(real,real,Uu,Uub)),Uua) ) ).

% ATP.lambda_666
tff(fact_8848_ATP_Olambda__667,axiom,
    ! [A: $tType,Uu: real,Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_zd(real,fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr(real),aa(A,real,Uua,Uub)),Uu) ) ).

% ATP.lambda_667
tff(fact_8849_ATP_Olambda__668,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(B,A),Uua: int,Uub: B] : ( aa(B,A,aa(int,fun(B,A),aTP_Lamp_sw(fun(B,A),fun(int,fun(B,A)),Uu),Uua),Uub) = power_int(A,aa(B,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_668
tff(fact_8850_ATP_Olambda__669,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_abw(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_669
tff(fact_8851_ATP_Olambda__670,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_abz(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_670
tff(fact_8852_ATP_Olambda__671,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: int,Uub: A] : ( aa(A,A,aa(int,fun(A,A),aTP_Lamp_ql(fun(A,A),fun(int,fun(A,A)),Uu),Uua),Uub) = power_int(A,aa(A,A,Uu,Uub),Uua) ) ) ).

% ATP.lambda_671
tff(fact_8853_ATP_Olambda__672,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_vy(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_672
tff(fact_8854_ATP_Olambda__673,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V8999393235501362500lgebra(B)
     => ! [Uu: fun(A,B),Uua: int,Uub: A] : ( aa(A,B,aa(int,fun(A,B),aTP_Lamp_ur(fun(A,B),fun(int,fun(A,B)),Uu),Uua),Uub) = power_int(B,aa(A,B,Uu,Uub),Uua) ) ) ).

% ATP.lambda_673
tff(fact_8855_ATP_Olambda__674,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: B,Uub: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aij(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
    <=> ( aa(A,B,Uu,Uub) = Uua ) ) ).

% ATP.lambda_674
tff(fact_8856_ATP_Olambda__675,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ka(nat,fun(nat,fun(nat,A)),Uu),Uua),Uub) = divide_divide(A,aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub)),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uub))) ) ) ).

% ATP.lambda_675
tff(fact_8857_ATP_Olambda__676,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: real,Uua: fun(nat,A),Uub: nat] : ( aa(nat,real,aa(fun(nat,A),fun(nat,real),aTP_Lamp_dl(real,fun(fun(nat,A),fun(nat,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uua,Uub))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ) ).

% ATP.lambda_676
tff(fact_8858_ATP_Olambda__677,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_abf(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uub))),aa(nat,real,Uua,Uub)) ) ) ).

% ATP.lambda_677
tff(fact_8859_ATP_Olambda__678,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(B)
     => ! [Uu: fun(A,$o),Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_mw(fun(A,$o),fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),aa($o,B,zero_neq_one_of_bool(B),aa(A,$o,Uu,Uub))),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_678
tff(fact_8860_ATP_Olambda__679,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,B),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,B),fun(nat,$o),aTP_Lamp_aay(fun(nat,A),fun(fun(nat,B),fun(nat,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(nat,A,Uu,Uub))),real_V7770717601297561774m_norm(B,aa(nat,B,Uua,Uub))) ) ) ).

% ATP.lambda_679
tff(fact_8861_ATP_Olambda__680,axiom,
    ! [Uu: fun(nat,rat),Uua: fun(nat,rat),Uub: nat] : ( aa(nat,rat,aa(fun(nat,rat),fun(nat,rat),aTP_Lamp_afs(fun(nat,rat),fun(fun(nat,rat),fun(nat,rat)),Uu),Uua),Uub) = aa(rat,rat,aa(rat,fun(rat,rat),minus_minus(rat),aa(rat,rat,inverse_inverse(rat),aa(nat,rat,Uu,Uub))),aa(rat,rat,inverse_inverse(rat),aa(nat,rat,Uua,Uub))) ) ).

% ATP.lambda_680
tff(fact_8862_ATP_Olambda__681,axiom,
    ! [A: $tType,B: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_abj(fun(A,B),fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))),Uua) ) ) ).

% ATP.lambda_681
tff(fact_8863_ATP_Olambda__682,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hx(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua))) ) ) ).

% ATP.lambda_682
tff(fact_8864_ATP_Olambda__683,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A,Uub: fun(A,real)] :
          ( aa(fun(A,real),$o,aa(A,fun(fun(A,real),$o),aTP_Lamp_ajw(set(A),fun(A,fun(fun(A,real),$o)),Uu),Uua),Uub)
        <=> ( ! [V6: A] :
                ( ( aa(A,real,Uub,V6) != zero_zero(real) )
               => member(A,V6,Uu) )
            & aa(set(A),$o,finite_finite(A),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),Uub)))
            & ( aa(set(A),A,aa(fun(A,A),fun(set(A),A),groups7311177749621191930dd_sum(A,A),aTP_Lamp_aia(fun(A,real),fun(A,A),Uub)),collect(A,aTP_Lamp_aib(fun(A,real),fun(A,$o),Uub))) = Uua ) ) ) ) ).

% ATP.lambda_683
tff(fact_8865_ATP_Olambda__684,axiom,
    ! [A: $tType,Uu: set(A),Uua: set(A),Uub: set(A)] :
      ( aa(set(A),$o,aa(set(A),fun(set(A),$o),aTP_Lamp_aeb(set(A),fun(set(A),fun(set(A),$o)),Uu),Uua),Uub)
    <=> ( aa(set(A),$o,finite_finite(A),Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uua),Uub)
        & aa(set(A),$o,aa(set(A),fun(set(A),$o),ord_less_eq(set(A)),Uub),Uu) ) ) ).

% ATP.lambda_684
tff(fact_8866_ATP_Olambda__685,axiom,
    ! [A: $tType,Uu: fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),Uua: fun($o,fun($o,A)),Uub: vEBT_VEBT] : ( aa(vEBT_VEBT,product_prod(vEBT_VEBT,A),aa(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A)),aTP_Lamp_ajm(fun(option(product_prod(nat,nat)),fun(nat,fun(list(product_prod(vEBT_VEBT,A)),fun(vEBT_VEBT,fun(A,A))))),fun(fun($o,fun($o,A)),fun(vEBT_VEBT,product_prod(vEBT_VEBT,A))),Uu),Uua),Uub) = aa(A,product_prod(vEBT_VEBT,A),product_Pair(vEBT_VEBT,A,Uub),vEBT_rec_VEBT(A,Uu,Uua,Uub)) ) ).

% ATP.lambda_685
tff(fact_8867_ATP_Olambda__686,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jv(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7121269368397514597t_prod(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_686
tff(fact_8868_ATP_Olambda__687,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_jy(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_687
tff(fact_8869_ATP_Olambda__688,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ju(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)),Uua))) ) ) ).

% ATP.lambda_688
tff(fact_8870_ATP_Olambda__689,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: int,Uub: A] : ( aa(A,A,aa(int,fun(A,A),aTP_Lamp_sz(A,fun(int,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uub),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Uua)),power_int(A,Uu,aa(int,int,aa(int,fun(int,int),minus_minus(int),Uua),one_one(int))))) ) ) ).

% ATP.lambda_689
tff(fact_8871_ATP_Olambda__690,axiom,
    ! [A: $tType] :
      ( euclid5411537665997757685th_nat(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_et(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_690
tff(fact_8872_ATP_Olambda__691,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_er(A,fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uub)),Uua)) ) ) ).

% ATP.lambda_691
tff(fact_8873_ATP_Olambda__692,axiom,
    ! [A: $tType,Uu: A,Uua: set(A),Uub: A] :
      ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_aih(A,fun(set(A),fun(A,$o)),Uu),Uua),Uub)
    <=> member(A,Uub,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uua),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ).

% ATP.lambda_692
tff(fact_8874_ATP_Olambda__693,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ho(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_693
tff(fact_8875_ATP_Olambda__694,axiom,
    ! [Uu: real,Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_xp(real,fun(real,fun(nat,real)),Uu),Uua),Uub) = divide_divide(real,Uua,aa(nat,real,aa(real,fun(nat,real),power_power(real),Uu),Uub)) ) ).

% ATP.lambda_694
tff(fact_8876_ATP_Olambda__695,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_eh(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ) ).

% ATP.lambda_695
tff(fact_8877_ATP_Olambda__696,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aTP_Lamp_es(nat,fun(nat,fun(nat,nat)),Uu),Uua),Uub) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ).

% ATP.lambda_696
tff(fact_8878_ATP_Olambda__697,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order(A)
        & order(B) )
     => ! [Uu: fun(A,B),Uua: set(A),Uub: B] :
          ( aa(B,$o,aa(set(A),fun(B,$o),aTP_Lamp_aie(fun(A,B),fun(set(A),fun(B,$o)),Uu),Uua),Uub)
        <=> member(B,Uub,aa(set(A),set(B),image(A,B,Uu),Uua)) ) ) ).

% ATP.lambda_697
tff(fact_8879_ATP_Olambda__698,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: real,Uub: A] : ( aa(A,A,aa(real,fun(A,A),aTP_Lamp_pw(fun(A,A),fun(real,fun(A,A)),Uu),Uua),Uub) = aa(A,A,real_V8093663219630862766scaleR(A,Uua),aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_698
tff(fact_8880_ATP_Olambda__699,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: B,Uua: fun(A,B),Uub: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aTP_Lamp_aab(B,fun(fun(A,B),fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_699
tff(fact_8881_ATP_Olambda__700,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1944317154257567458pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aag(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_700
tff(fact_8882_ATP_Olambda__701,axiom,
    ! [B: $tType,A: $tType] :
      ( unboun7993243217541854897norder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aad(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_701
tff(fact_8883_ATP_Olambda__702,axiom,
    ! [B: $tType,A: $tType] :
      ( linorder(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_zu(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less_eq(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_702
tff(fact_8884_ATP_Olambda__703,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B] :
          ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_afm(fun(B,A),fun(A,fun(B,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,aa(A,fun(A,$o),ord_less(A),Uua),aa(B,A,Uu,Uub)) ) ) ).

% ATP.lambda_703
tff(fact_8885_ATP_Olambda__704,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo2564578578187576103pology(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_aaa(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),ord_less(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_704
tff(fact_8886_ATP_Olambda__705,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: B,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_abu(B,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_705
tff(fact_8887_ATP_Olambda__706,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cb(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_706
tff(fact_8888_ATP_Olambda__707,axiom,
    ! [A: $tType,B: $tType] :
      ( semiring_0(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_eb(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_707
tff(fact_8889_ATP_Olambda__708,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cn(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_708
tff(fact_8890_ATP_Olambda__709,axiom,
    ! [A: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_wo(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_709
tff(fact_8891_ATP_Olambda__710,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field(A)
        & topolo4211221413907600880p_mult(A) )
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_tk(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_710
tff(fact_8892_ATP_Olambda__711,axiom,
    ! [A: $tType] :
      ( real_V4412858255891104859lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,A,aa(A,fun(nat,A),aTP_Lamp_ch(fun(nat,A),fun(A,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(nat,A,Uu,Uub)) ) ) ).

% ATP.lambda_711
tff(fact_8893_ATP_Olambda__712,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_rr(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_712
tff(fact_8894_ATP_Olambda__713,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_acj(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_713
tff(fact_8895_ATP_Olambda__714,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_qb(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),times_times(A),Uua),aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_714
tff(fact_8896_ATP_Olambda__715,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_vh(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_715
tff(fact_8897_ATP_Olambda__716,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V4412858255891104859lgebra(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_uh(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_716
tff(fact_8898_ATP_Olambda__717,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo4211221413907600880p_mult(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_vj(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_717
tff(fact_8899_ATP_Olambda__718,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field(B)
        & topolo1944317154257567458pology(B) )
     => ! [Uu: fun(A,B),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_yu(fun(A,B),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),times_times(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_718
tff(fact_8900_ATP_Olambda__719,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(B,set(A)),Uub: B] : ( aa(B,set(A),aa(fun(B,set(A)),fun(B,set(A)),aTP_Lamp_ot(set(A),fun(fun(B,set(A)),fun(B,set(A))),Uu),Uua),Uub) = aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(B,set(A),Uua,Uub)) ) ).

% ATP.lambda_719
tff(fact_8901_ATP_Olambda__720,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V2822296259951069270ebra_1(B)
     => ! [Uu: fun(A,nat),Uua: B,Uub: A] : ( aa(A,B,aa(B,fun(A,B),aTP_Lamp_xv(fun(A,nat),fun(B,fun(A,B)),Uu),Uua),Uub) = aa(nat,B,aa(B,fun(nat,B),power_power(B),Uua),aa(A,nat,Uu,Uub)) ) ) ).

% ATP.lambda_720
tff(fact_8902_ATP_Olambda__721,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_ado(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),sup_sup(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_721
tff(fact_8903_ATP_Olambda__722,axiom,
    ! [A: $tType,B: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: A,Uua: fun(B,A),Uub: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aTP_Lamp_oc(A,fun(fun(B,A),fun(B,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),inf_inf(A),Uu),aa(B,A,Uua,Uub)) ) ) ).

% ATP.lambda_722
tff(fact_8904_ATP_Olambda__723,axiom,
    ! [B: $tType,A: $tType] :
      ( topolo1633459387980952147up_add(B)
     => ! [Uu: B,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_ve(B,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),aa(A,B,Uua,Uub)) ) ) ).

% ATP.lambda_723
tff(fact_8905_ATP_Olambda__724,axiom,
    ! [A: $tType] :
      ( topolo1287966508704411220up_add(A)
     => ! [Uu: A,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_aim(A,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,Uua,Uub)) ) ) ).

% ATP.lambda_724
tff(fact_8906_ATP_Olambda__725,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_ne(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_725
tff(fact_8907_ATP_Olambda__726,axiom,
    ! [A: $tType,C: $tType,B: $tType,Uu: fun(A,C),Uua: fun(B,filter(C)),Uub: B] : ( aa(B,filter(A),aa(fun(B,filter(C)),fun(B,filter(A)),aTP_Lamp_acq(fun(A,C),fun(fun(B,filter(C)),fun(B,filter(A))),Uu),Uua),Uub) = filtercomap(A,C,Uu,aa(B,filter(C),Uua,Uub)) ) ).

% ATP.lambda_726
tff(fact_8908_ATP_Olambda__727,axiom,
    ! [A: $tType,B: $tType,C: $tType,Uu: fun(B,A),Uua: fun(C,filter(B)),Uub: C] : ( aa(C,filter(A),aa(fun(C,filter(B)),fun(C,filter(A)),aTP_Lamp_ait(fun(B,A),fun(fun(C,filter(B)),fun(C,filter(A))),Uu),Uua),Uub) = filtermap(B,A,Uu,aa(C,filter(B),Uua,Uub)) ) ).

% ATP.lambda_727
tff(fact_8909_ATP_Olambda__728,axiom,
    ! [B: $tType,A: $tType,C: $tType,Uu: fun(A,B),Uua: fun(C,set(A)),Uub: C] : ( aa(C,set(B),aa(fun(C,set(A)),fun(C,set(B)),aTP_Lamp_adj(fun(A,B),fun(fun(C,set(A)),fun(C,set(B))),Uu),Uua),Uub) = aa(set(A),set(B),image(A,B,Uu),aa(C,set(A),Uua,Uub)) ) ).

% ATP.lambda_728
tff(fact_8910_ATP_Olambda__729,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: fun(list(A),A),Uua: list(A),Uub: A] :
          ( aa(A,$o,aa(list(A),fun(A,$o),aTP_Lamp_afa(fun(list(A),A),fun(list(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ( Uub = aa(list(A),A,Uu,Uua) ) ) ) ).

% ATP.lambda_729
tff(fact_8911_ATP_Olambda__730,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_bm(A,fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uub))) ) ) ).

% ATP.lambda_730
tff(fact_8912_ATP_Olambda__731,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(B)
     => ! [Uu: fun(A,B),Uua: real,Uub: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aTP_Lamp_abk(fun(A,B),fun(real,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uua),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uub))) ) ) ).

% ATP.lambda_731
tff(fact_8913_ATP_Olambda__732,axiom,
    ! [Uu: real,Uua: real,Uub: product_unit] : ( aa(product_unit,real,aa(real,fun(product_unit,real),aTP_Lamp_akw(real,fun(real,fun(product_unit,real)),Uu),Uua),Uub) = aa(real,real,aa(real,fun(real,real),powr_real,Uu),Uua) ) ).

% ATP.lambda_732
tff(fact_8914_ATP_Olambda__733,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_hb(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_733
tff(fact_8915_ATP_Olambda__734,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ha(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uub))) ) ) ).

% ATP.lambda_734
tff(fact_8916_ATP_Olambda__735,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_xc(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uub),Uua)) ) ) ).

% ATP.lambda_735
tff(fact_8917_ATP_Olambda__736,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wv(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_736
tff(fact_8918_ATP_Olambda__737,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_to(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_737
tff(fact_8919_ATP_Olambda__738,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_po(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)) ) ) ).

% ATP.lambda_738
tff(fact_8920_ATP_Olambda__739,axiom,
    ! [Uu: fun(real,$o),Uua: real,Uub: real] :
      ( aa(real,$o,aa(real,fun(real,$o),aTP_Lamp_aaj(fun(real,$o),fun(real,fun(real,$o)),Uu),Uua),Uub)
    <=> aa(real,$o,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua)) ) ).

% ATP.lambda_739
tff(fact_8921_ATP_Olambda__740,axiom,
    ! [A: $tType,Uu: fun(real,A),Uua: real,Uub: real] : ( aa(real,A,aa(real,fun(real,A),aTP_Lamp_yt(fun(real,A),fun(real,fun(real,A)),Uu),Uua),Uub) = aa(real,A,Uu,aa(real,real,aa(real,fun(real,real),plus_plus(real),Uub),Uua)) ) ).

% ATP.lambda_740
tff(fact_8922_ATP_Olambda__741,axiom,
    ! [Uu: fun(nat,real),Uua: nat,Uub: nat] : ( aa(nat,real,aa(nat,fun(nat,real),aTP_Lamp_aik(fun(nat,real),fun(nat,fun(nat,real)),Uu),Uua),Uub) = aa(nat,real,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_741
tff(fact_8923_ATP_Olambda__742,axiom,
    ! [Uu: fun(nat,$o),Uua: nat,Uub: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aTP_Lamp_aax(fun(nat,$o),fun(nat,fun(nat,$o)),Uu),Uua),Uub)
    <=> aa(nat,$o,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_742
tff(fact_8924_ATP_Olambda__743,axiom,
    ! [A: $tType,Uu: fun(nat,set(A)),Uua: nat,Uub: nat] : ( aa(nat,set(A),aa(nat,fun(nat,set(A)),aTP_Lamp_ou(fun(nat,set(A)),fun(nat,fun(nat,set(A))),Uu),Uua),Uub) = aa(nat,set(A),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_743
tff(fact_8925_ATP_Olambda__744,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_ca(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_744
tff(fact_8926_ATP_Olambda__745,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_wu(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_745
tff(fact_8927_ATP_Olambda__746,axiom,
    ! [A: $tType] :
      ( real_V7819770556892013058_space(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_abb(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_746
tff(fact_8928_ATP_Olambda__747,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_be(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_747
tff(fact_8929_ATP_Olambda__748,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aTP_Lamp_eg(fun(nat,A),fun(nat,fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ) ).

% ATP.lambda_748
tff(fact_8930_ATP_Olambda__749,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,$o),Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_zy(fun(A,$o),fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> aa(A,$o,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_749
tff(fact_8931_ATP_Olambda__750,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_ts(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_750
tff(fact_8932_ATP_Olambda__751,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,B),Uua: A,Uub: A] : ( aa(A,B,aa(A,fun(A,B),aTP_Lamp_wc(fun(A,B),fun(A,fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_751
tff(fact_8933_ATP_Olambda__752,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_pp(fun(A,A),fun(A,fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uua)) ) ) ).

% ATP.lambda_752
tff(fact_8934_ATP_Olambda__753,axiom,
    ! [A: $tType,B: $tType,Uu: fun(product_prod(A,B),$o),Uua: A,Uub: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aTP_Lamp_jl(fun(product_prod(A,B),$o),fun(A,fun(B,$o)),Uu),Uua),Uub)
    <=> aa(product_prod(A,B),$o,Uu,aa(B,product_prod(A,B),product_Pair(A,B,Uua),Uub)) ) ).

% ATP.lambda_753
tff(fact_8935_ATP_Olambda__754,axiom,
    ! [C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: B,Uua: fun(B,C),Uub: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aTP_Lamp_vr(B,fun(fun(B,C),fun(B,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(B,B,aa(B,fun(B,B),plus_plus(B),Uu),Uub)) ) ) ).

% ATP.lambda_754
tff(fact_8936_ATP_Olambda__755,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A,Uua: fun(A,B),Uub: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aTP_Lamp_tp(A,fun(fun(A,B),fun(A,B)),Uu),Uua),Uub) = aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uub)) ) ) ).

% ATP.lambda_755
tff(fact_8937_ATP_Olambda__756,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_cp(nat,fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uu)) ) ) ).

% ATP.lambda_756
tff(fact_8938_ATP_Olambda__757,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(real,real),Uua: fun(A,real),Uub: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aTP_Lamp_si(fun(real,real),fun(fun(A,real),fun(A,real)),Uu),Uua),Uub) = aa(real,real,Uu,aa(A,real,Uua,Uub)) ) ) ).

% ATP.lambda_757
tff(fact_8939_ATP_Olambda__758,axiom,
    ! [Uu: fun(nat,real),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,real,aa(fun(nat,nat),fun(nat,real),aTP_Lamp_ahd(fun(nat,real),fun(fun(nat,nat),fun(nat,real)),Uu),Uua),Uub) = aa(nat,real,Uu,aa(nat,nat,Uua,Uub)) ) ).

% ATP.lambda_758
tff(fact_8940_ATP_Olambda__759,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,nat),Uub: nat] : ( aa(nat,A,aa(fun(nat,nat),fun(nat,A),aTP_Lamp_adx(fun(nat,A),fun(fun(nat,nat),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uu,aa(nat,nat,Uua,Uub)) ) ) ).

% ATP.lambda_759
tff(fact_8941_ATP_Olambda__760,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(num,B),Uub: num] : ( aa(num,A,aa(fun(num,B),fun(num,A),aTP_Lamp_agw(fun(B,A),fun(fun(num,B),fun(num,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(num,B,Uua,Uub)) ) ).

% ATP.lambda_760
tff(fact_8942_ATP_Olambda__761,axiom,
    ! [A: $tType,B: $tType,Uu: fun(B,A),Uua: fun(nat,B),Uub: nat] : ( aa(nat,A,aa(fun(nat,B),fun(nat,A),aTP_Lamp_lz(fun(B,A),fun(fun(nat,B),fun(nat,A)),Uu),Uua),Uub) = aa(B,A,Uu,aa(nat,B,Uua,Uub)) ) ).

% ATP.lambda_761
tff(fact_8943_ATP_Olambda__762,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta4013691401010221786attice(A)
        & counta3822494911875563373attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ahc(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_762
tff(fact_8944_ATP_Olambda__763,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice(A)
        & condit1219197933456340205attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_akp(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_763
tff(fact_8945_ATP_Olambda__764,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_rx(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_764
tff(fact_8946_ATP_Olambda__765,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_yh(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_765
tff(fact_8947_ATP_Olambda__766,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( topolo4958980785337419405_space(C)
        & topolo4958980785337419405_space(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_acp(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_766
tff(fact_8948_ATP_Olambda__767,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_pr(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uu,aa(A,A,Uua,Uub)) ) ) ).

% ATP.lambda_767
tff(fact_8949_ATP_Olambda__768,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice(A)
        & comple6319245703460814977attice(B) )
     => ! [Uu: fun(A,B),Uua: fun(C,A),Uub: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aTP_Lamp_ahb(fun(A,B),fun(fun(C,A),fun(C,B)),Uu),Uua),Uub) = aa(A,B,Uu,aa(C,A,Uua,Uub)) ) ) ).

% ATP.lambda_768
tff(fact_8950_ATP_Olambda__769,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: fun(nat,nat),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adv(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,Uu,Uub)) ) ) ).

% ATP.lambda_769
tff(fact_8951_ATP_Olambda__770,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,nat),Uua: fun(nat,A),Uub: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aTP_Lamp_adw(fun(nat,nat),fun(fun(nat,A),fun(nat,A)),Uu),Uua),Uub) = aa(nat,A,Uua,aa(nat,nat,Uu,Uub)) ) ) ).

% ATP.lambda_770
tff(fact_8952_ATP_Olambda__771,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tn(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_771
tff(fact_8953_ATP_Olambda__772,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: fun(A,A),Uub: A] : ( aa(A,A,aa(fun(A,A),fun(A,A),aTP_Lamp_ps(fun(A,A),fun(fun(A,A),fun(A,A)),Uu),Uua),Uub) = aa(A,A,Uua,aa(A,A,Uu,Uub)) ) ) ).

% ATP.lambda_772
tff(fact_8954_ATP_Olambda__773,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space(A)
        & topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(C) )
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_tq(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_773
tff(fact_8955_ATP_Olambda__774,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_ll(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_774
tff(fact_8956_ATP_Olambda__775,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_li(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_775
tff(fact_8957_ATP_Olambda__776,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( semiring_1(C)
     => ! [Uu: fun(A,B),Uua: fun(B,C),Uub: A] : ( aa(A,C,aa(fun(B,C),fun(A,C),aTP_Lamp_on(fun(A,B),fun(fun(B,C),fun(A,C)),Uu),Uua),Uub) = aa(B,C,Uua,aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_776
tff(fact_8958_ATP_Olambda__777,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topological_t2_space(A)
        & real_Vector_banach(B)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(nat,B),Uub: A] : ( aa(A,B,aa(fun(nat,B),fun(A,B),aTP_Lamp_wk(fun(A,B),fun(fun(nat,B),fun(A,B)),Uu),Uua),Uub) = suminf(B,aa(A,fun(nat,B),aa(fun(nat,B),fun(A,fun(nat,B)),aTP_Lamp_wj(fun(A,B),fun(fun(nat,B),fun(A,fun(nat,B))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_777
tff(fact_8959_ATP_Olambda__778,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A] : ( aa(A,A,aa(A,fun(A,A),aTP_Lamp_tj(fun(nat,A),fun(A,fun(A,A)),Uu),Uua),Uub) = suminf(A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_ti(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub)) ) ) ).

% ATP.lambda_778
tff(fact_8960_ATP_Olambda__779,axiom,
    ! [B: $tType] :
      ( real_V4867850818363320053vector(B)
     => ! [Uu: set(B),Uua: B,Uub: B] :
          ( aa(B,$o,aa(B,fun(B,$o),aTP_Lamp_akc(set(B),fun(B,fun(B,$o)),Uu),Uua),Uub)
        <=> ( aa(B,real,real_V7696804695334737415tation(B,real_V4986007116245087402_basis(B,Uu),Uua),Uub) != zero_zero(real) ) ) ) ).

% ATP.lambda_779
tff(fact_8961_ATP_Olambda__780,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: A,Uub: A] :
          ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_ajz(set(A),fun(A,fun(A,$o)),Uu),Uua),Uub)
        <=> ( aa(A,real,real_V7696804695334737415tation(A,Uu,Uua),Uub) != zero_zero(real) ) ) ) ).

% ATP.lambda_780
tff(fact_8962_ATP_Olambda__781,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: set(A),Uub: A] : ( aa(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_yz(A,fun(set(A),fun(A,filter(A))),Uu),Uua),Uub) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_greaterThan(A,Uub)),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_781
tff(fact_8963_ATP_Olambda__782,axiom,
    ! [A: $tType] :
      ( topolo1944317154257567458pology(A)
     => ! [Uu: A,Uua: set(A),Uub: A] : ( aa(A,filter(A),aa(set(A),fun(A,filter(A)),aTP_Lamp_yy(A,fun(set(A),fun(A,filter(A))),Uu),Uua),Uub) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),set_ord_lessThan(A,Uub)),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_782
tff(fact_8964_ATP_Olambda__783,axiom,
    ! [A: $tType] :
      ( topolo4958980785337419405_space(A)
     => ! [Uu: A,Uua: set(A),Uub: set(A)] : ( aa(set(A),filter(A),aa(set(A),fun(set(A),filter(A)),aTP_Lamp_zm(A,fun(set(A),fun(set(A),filter(A))),Uu),Uua),Uub) = principal(A,aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),inf_inf(set(A)),Uub),Uua)),aa(set(A),set(A),insert(A,Uu),bot_bot(set(A))))) ) ) ).

% ATP.lambda_783
tff(fact_8965_ATP_Olambda__784,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat] : ( aa(nat,real,aa(A,fun(nat,real),aTP_Lamp_cl(fun(nat,A),fun(A,fun(nat,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uub)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uub))) ) ) ).

% ATP.lambda_784
tff(fact_8966_ATP_Olambda__785,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult(B)
        & real_V2822296259951069270ebra_1(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A] : ( aa(A,real,aa(fun(A,B),fun(A,real),aTP_Lamp_fq(fun(A,B),fun(fun(A,B),fun(A,real)),Uu),Uua),Uub) = real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,Uub))) ) ) ).

% ATP.lambda_785
tff(fact_8967_ATP_Olambda__786,axiom,
    ! [Uu: fun(nat,real),Uua: real,Uub: nat] : ( aa(nat,real,aa(real,fun(nat,real),aTP_Lamp_ya(fun(nat,real),fun(real,fun(nat,real)),Uu),Uua),Uub) = aa(real,real,cos(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(nat,real,Uu,Uub)),Uua)) ) ).

% ATP.lambda_786
tff(fact_8968_ATP_Olambda__787,axiom,
    ! [B: $tType,A: $tType] :
      ( euclid4440199948858584721cancel(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: A] :
          ( aa(A,$o,aa(B,fun(A,$o),aTP_Lamp_nf(fun(A,B),fun(B,fun(A,$o)),Uu),Uua),Uub)
        <=> ~ aa(B,$o,aa(B,fun(B,$o),dvd_dvd(B),Uua),aa(A,B,Uu,Uub)) ) ) ).

% ATP.lambda_787
tff(fact_8969_ATP_Olambda__788,axiom,
    ! [B: $tType,A: $tType,Uu: set(B),Uua: fun(A,fun(B,$o)),Uub: A] : ( aa(A,nat,aa(fun(A,fun(B,$o)),fun(A,nat),aTP_Lamp_lh(set(B),fun(fun(A,fun(B,$o)),fun(A,nat)),Uu),Uua),Uub) = aa(set(B),nat,finite_card(B),collect(B,aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_lg(set(B),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),Uu),Uua),Uub))) ) ).

% ATP.lambda_788
tff(fact_8970_ATP_Olambda__789,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & archim2362893244070406136eiling(A)
        & topolo2564578578187576103pology(A) )
     => ! [Uu: fun(B,real),Uua: fun(real,A),Uub: B] : ( aa(B,real,aa(fun(real,A),fun(B,real),aTP_Lamp_tg(fun(B,real),fun(fun(real,A),fun(B,real)),Uu),Uua),Uub) = aa(int,real,ring_1_of_int(real),archim6421214686448440834_floor(A,aa(real,A,Uua,aa(B,real,Uu,Uub)))) ) ) ).

% ATP.lambda_789
tff(fact_8971_ATP_Olambda__790,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: A,Uua: set(A),Uub: A] :
          ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_ajs(A,fun(set(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ? [K2: real] : member(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uub),aa(A,A,real_V8093663219630862766scaleR(A,K2),Uu)),real_Vector_span(A,Uua)) ) ) ).

% ATP.lambda_790
tff(fact_8972_ATP_Olambda__791,axiom,
    ! [A: $tType] :
      ( real_Vector_banach(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_abo(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> ! [N5: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uub),N5)
             => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or7035219750837199246ssThan(nat,Uub,N5)))),aa(nat,real,Uua,Uub)) ) ) ) ).

% ATP.lambda_791
tff(fact_8973_ATP_Olambda__792,axiom,
    ! [A: $tType] :
      ( ( real_V8037385150606011577_space(A)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,real),Uub: nat] :
          ( aa(nat,$o,aa(fun(nat,real),fun(nat,$o),aTP_Lamp_abr(fun(nat,A),fun(fun(nat,real),fun(nat,$o)),Uu),Uua),Uub)
        <=> ! [A7: nat] :
              ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uub),A7)
             => ! [B7: nat] :
                  ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),A7),B7)
                 => aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),Uu),set_or3652927894154168847AtMost(nat,A7,B7)))),aa(nat,real,Uua,A7)) ) ) ) ) ).

% ATP.lambda_792
tff(fact_8974_ATP_Olambda__793,axiom,
    ! [A: $tType,Uu: fun(A,A),Uua: A,Uub: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aTP_Lamp_afx(fun(A,A),fun(A,fun(A,$o)),Uu),Uua),Uub)
    <=> ? [N5: nat] : ( Uub = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),N5),Uu),Uua) ) ) ).

% ATP.lambda_793
tff(fact_8975_ATP_Olambda__794,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: set(A),Uub: A] :
          ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_ajr(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ? [X4: A,Y5: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),Y5) )
              & member(A,X4,real_Vector_span(A,Uu))
              & member(A,Y5,real_Vector_span(A,Uua)) ) ) ) ).

% ATP.lambda_794
tff(fact_8976_ATP_Olambda__795,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: set(A),Uua: set(A),Uub: A] :
          ( aa(A,$o,aa(set(A),fun(A,$o),aTP_Lamp_ako(set(A),fun(set(A),fun(A,$o)),Uu),Uua),Uub)
        <=> ? [X4: A,Y5: A] :
              ( ( Uub = aa(A,A,aa(A,fun(A,A),plus_plus(A),X4),Y5) )
              & member(A,X4,Uu)
              & member(A,Y5,Uua) ) ) ) ).

% ATP.lambda_795
tff(fact_8977_ATP_Olambda__796,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ez(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub)
              & aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uuc) ),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),divide_divide(nat,Uub,aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc)))),semiring_char_0_fact(real,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),
              zero_zero(A) ) ) ) ).

% ATP.lambda_796
tff(fact_8978_ATP_Olambda__797,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ev(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              ( aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub)
              & ~ aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uuc) ),
              aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,uminus_uminus(real),divide_divide(real,aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),divide_divide(nat,Uub,aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc)))),semiring_char_0_fact(real,Uub)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),
              zero_zero(A) ) ) ) ).

% ATP.lambda_797
tff(fact_8979_ATP_Olambda__798,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] :
          ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ex(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),dvd_dvd(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uub),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,divide_divide(real,aa(int,real,ring_1_of_int(real),aa(int,int,aa(int,fun(int,int),times_times(int),aa(nat,int,aa(int,fun(nat,int),power_power(int),aa(int,int,uminus_uminus(int),one_one(int))),divide_divide(nat,Uub,aa(num,nat,numeral_numeral(nat),bit0(one2))))),aa(nat,int,semiring_1_of_nat(int),aa(nat,nat,binomial(Uub),Uuc)))),semiring_char_0_fact(real,Uub))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),zero_zero(A)) ) ) ).

% ATP.lambda_798
tff(fact_8980_ATP_Olambda__799,axiom,
    ! [B: $tType,A: $tType,Uu: fun(A,B),Uua: set(A),Uub: A,Uuc: B] :
      ( aa(B,A,aa(A,fun(B,A),aa(set(A),fun(A,fun(B,A)),aTP_Lamp_adt(fun(A,B),fun(set(A),fun(A,fun(B,A))),Uu),Uua),Uub),Uuc)
      = $ite(member(B,Uuc,aa(set(A),set(B),image(A,B,Uu),Uua)),the_inv_into(A,B,Uua,Uu,Uuc),Uub) ) ).

% ATP.lambda_799
tff(fact_8981_ATP_Olambda__800,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gi(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,A,Uua,Uuc),
              $ite(Uuc = Uu,zero_zero(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_800
tff(fact_8982_ATP_Olambda__801,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gm(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(
              aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),
              aa(nat,A,Uua,Uuc),
              $ite(Uuc = Uu,one_one(A),aa(nat,A,Uub,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))) ) ) ) ).

% ATP.lambda_801
tff(fact_8983_ATP_Olambda__802,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology(A)
        & topolo4958980785337419405_space(B) )
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_yw(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,aa(A,fun(A,$o),ord_less_eq(A),Uuc),Uu),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_802
tff(fact_8984_ATP_Olambda__803,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gn(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_803
tff(fact_8985_ATP_Olambda__804,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(fun(nat,A),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_gj(nat,fun(fun(nat,A),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuc),Uu),aa(nat,A,Uua,Uuc),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_804
tff(fact_8986_ATP_Olambda__805,axiom,
    ! [A: $tType] :
      ( ( topolo1287966508704411220up_add(A)
        & topological_t2_space(A) )
     => ! [Uu: fun(nat,A),Uua: set(nat),Uub: fun(nat,A),Uuc: nat] :
          ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(set(nat),fun(fun(nat,A),fun(nat,A)),aTP_Lamp_lk(fun(nat,A),fun(set(nat),fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc)
          = $ite(member(nat,Uuc,Uua),aa(nat,A,Uub,Uuc),aa(nat,A,Uu,Uuc)) ) ) ).

% ATP.lambda_805
tff(fact_8987_ATP_Olambda__806,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_ln(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_806
tff(fact_8988_ATP_Olambda__807,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_lm(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_807
tff(fact_8989_ATP_Olambda__808,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: A,Uua: fun(A,B),Uub: B,Uuc: A] :
          ( aa(A,B,aa(B,fun(A,B),aa(fun(A,B),fun(B,fun(A,B)),aTP_Lamp_lp(A,fun(fun(A,B),fun(B,fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(Uuc = Uu,aa(A,B,Uua,Uuc),Uub) ) ) ).

% ATP.lambda_808
tff(fact_8990_ATP_Olambda__809,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: fun(A,$o),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_nb(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,Uu,Uuc),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_809
tff(fact_8991_ATP_Olambda__810,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: fun(A,$o),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aTP_Lamp_na(fun(A,$o),fun(fun(A,B),fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc)
          = $ite(aa(A,$o,Uu,Uuc),aa(A,B,Uua,Uuc),aa(A,B,Uub,Uuc)) ) ) ).

% ATP.lambda_810
tff(fact_8992_ATP_Olambda__811,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_np(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(fun(A,A),fun(A,A),aa(nat,fun(fun(A,A),fun(A,A)),compow(fun(A,A)),Uuc),aa(A,fun(A,A),times_times(A),Uua)),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))) ) ) ).

% ATP.lambda_811
tff(fact_8993_ATP_Olambda__812,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: fun(D,B),Uuc: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_akl(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),aa(D,B,Uub,Uuc)) ) ) ).

% ATP.lambda_812
tff(fact_8994_ATP_Olambda__813,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: fun(D,B),Uuc: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,A),fun(fun(D,B),fun(D,C)),aTP_Lamp_akk(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,B),fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),aa(D,B,Uub,Uuc)) ) ) ).

% ATP.lambda_813
tff(fact_8995_ATP_Olambda__814,axiom,
    ! [D: $tType,A: $tType,C: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: B,Uuc: D] : ( aa(D,C,aa(B,fun(D,C),aa(fun(D,A),fun(B,fun(D,C)),aTP_Lamp_akj(fun(A,fun(B,C)),fun(fun(D,A),fun(B,fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),Uub) ) ) ).

% ATP.lambda_814
tff(fact_8996_ATP_Olambda__815,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,B),Uub: A,Uuc: D] : ( aa(D,C,aa(A,fun(D,C),aa(fun(D,B),fun(A,fun(D,C)),aTP_Lamp_aki(fun(A,fun(B,C)),fun(fun(D,B),fun(A,fun(D,C))),Uu),Uua),Uub),Uuc) = aa(B,C,aa(A,fun(B,C),Uu,Uub),aa(D,B,Uua,Uuc)) ) ) ).

% ATP.lambda_815
tff(fact_8997_ATP_Olambda__816,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ic(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ib(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(nat,nat,suc,zero_zero(nat)))),Uuc))) ) ) ).

% ATP.lambda_816
tff(fact_8998_ATP_Olambda__817,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_dz(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(C),A,aa(fun(C,A),fun(set(C),A),groups7311177749621191930dd_sum(C,A),aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_dy(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub) ) ) ).

% ATP.lambda_817
tff(fact_8999_ATP_Olambda__818,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: nat] :
          ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_gq(nat,fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc)
          = aa(A,A,
              aa(A,fun(A,A),times_times(A),
                $ite(
                  Uuc = zero_zero(nat),
                  aa(A,A,uminus_uminus(A),Uub),
                  $ite(Uuc = Uu,one_one(A),zero_zero(A)) )),
              aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_818
tff(fact_9000_ATP_Olambda__819,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector(A)
        & real_V4867850818363320053vector(B) )
     => ! [Uu: set(B),Uua: fun(B,A),Uub: B,Uuc: B] :
          ( aa(B,A,aa(B,fun(B,A),aa(fun(B,A),fun(B,fun(B,A)),aTP_Lamp_akb(set(B),fun(fun(B,A),fun(B,fun(B,A))),Uu),Uua),Uub),Uuc)
          = aa(A,A,real_V8093663219630862766scaleR(A,aa(B,real,real_V7696804695334737415tation(B,real_V4986007116245087402_basis(B,Uu),Uub),Uuc)),$ite(member(B,Uuc,Uu),aa(B,A,Uua,Uuc),zero_zero(A))) ) ) ).

% ATP.lambda_819
tff(fact_9001_ATP_Olambda__820,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(fun(nat,A),fun(A,fun(nat,A)),aTP_Lamp_ge(fun(nat,A),fun(fun(nat,A),fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_gd(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uuc)),set_ord_atMost(nat,Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uuc)) ) ) ).

% ATP.lambda_820
tff(fact_9002_ATP_Olambda__821,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_fx(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(set(nat),nat,aa(fun(nat,nat),fun(set(nat),nat),groups7311177749621191930dd_sum(nat,nat),aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_fw(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uuc)),set_ord_atMost(nat,Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uub),Uuc)) ) ).

% ATP.lambda_821
tff(fact_9003_ATP_Olambda__822,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_re(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,suc,Uua)),Uuc)),zero_zero(real)),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uub),Uuc)) ) ).

% ATP.lambda_822
tff(fact_9004_ATP_Olambda__823,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: nat,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_rc(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)),zero_zero(real)),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),Uub),Uuc)) ) ).

% ATP.lambda_823
tff(fact_9005_ATP_Olambda__824,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_ra(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uua),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Uub),Uua)),Uuc)) ) ).

% ATP.lambda_824
tff(fact_9006_ATP_Olambda__825,axiom,
    ! [Uu: fun(nat,fun(real,real)),Uua: real,Uub: real,Uuc: nat] : ( aa(nat,real,aa(real,fun(nat,real),aa(real,fun(real,fun(nat,real)),aTP_Lamp_rb(fun(nat,fun(real,real)),fun(real,fun(real,fun(nat,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),divide_divide(real,aa(real,real,aa(nat,fun(real,real),Uu,Uuc),Uub),semiring_char_0_fact(real,Uuc))),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,aa(real,fun(real,real),minus_minus(real),Uua),Uub)),Uuc)) ) ).

% ATP.lambda_825
tff(fact_9007_ATP_Olambda__826,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_hk(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uub)) ) ) ).

% ATP.lambda_826
tff(fact_9008_ATP_Olambda__827,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_mt(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),Uua),Uub))) ) ).

% ATP.lambda_827
tff(fact_9009_ATP_Olambda__828,axiom,
    ! [A: $tType] :
      ( field(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_ib(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uu)),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),aa(num,nat,numeral_numeral(nat),bit0(one2)))),Uuc))) ) ) ).

% ATP.lambda_828
tff(fact_9010_ATP_Olambda__829,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: fun(A,A),Uua: A,Uub: fun(nat,A),Uuc: nat] : ( aa(nat,A,aa(fun(nat,A),fun(nat,A),aa(A,fun(fun(nat,A),fun(nat,A)),aTP_Lamp_xx(fun(A,A),fun(A,fun(fun(nat,A),fun(nat,A))),Uu),Uua),Uub),Uuc) = divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),aa(nat,A,Uub,Uuc)))),aa(A,A,Uu,Uua)),aa(nat,A,Uub,Uuc)) ) ) ).

% ATP.lambda_829
tff(fact_9011_ATP_Olambda__830,axiom,
    ! [A: $tType,Uu: fun(A,nat),Uua: set(product_prod(A,A)),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aTP_Lamp_ajn(fun(A,nat),fun(set(product_prod(A,A)),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc))
        | ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(A,nat,Uu,Uub)),aa(A,nat,Uu,Uuc))
          & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Uub),Uuc),Uua) ) ) ) ).

% ATP.lambda_830
tff(fact_9012_ATP_Olambda__831,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aav(fun(A,B),fun(B,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uuc),Uua)),Uub) ) ) ).

% ATP.lambda_831
tff(fact_9013_ATP_Olambda__832,axiom,
    ! [B: $tType,A: $tType] :
      ( real_V7819770556892013058_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(B,fun(real,fun(A,$o)),aTP_Lamp_aal(fun(A,B),fun(B,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less(real),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uuc),Uua)),Uub) ) ) ).

% ATP.lambda_832
tff(fact_9014_ATP_Olambda__833,axiom,
    ! [A: $tType] :
      ( comm_ring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gh(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),comm_s3205402744901411588hammer(A,Uu,Uuc))),comm_s3205402744901411588hammer(A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_833
tff(fact_9015_ATP_Olambda__834,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_ft(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,semiring_1_of_nat(nat),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uu),Uuc))),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_834
tff(fact_9016_ATP_Olambda__835,axiom,
    ! [A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gg(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),aa(nat,nat,binomial(Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_835
tff(fact_9017_ATP_Olambda__836,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V2822296259951069270ebra_1(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_gp(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc))),aa(A,A,real_V8093663219630862766scaleR(A,aa(real,real,inverse_inverse(real),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_836
tff(fact_9018_ATP_Olambda__837,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_hn(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),aa(nat,nat,suc,Uuc)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)) ) ) ).

% ATP.lambda_837
tff(fact_9019_ATP_Olambda__838,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: fun(A,fun(B,$o)),Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(fun(A,fun(B,$o)),fun(A,fun(B,$o)),aTP_Lamp_lg(set(B),fun(fun(A,fun(B,$o)),fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(B,Uuc,Uu)
        & aa(B,$o,aa(A,fun(B,$o),Uua,Uub),Uuc) ) ) ).

% ATP.lambda_838
tff(fact_9020_ATP_Olambda__839,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,fun(B,$o)),Uub: B,Uuc: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aa(fun(A,fun(B,$o)),fun(B,fun(A,$o)),aTP_Lamp_lf(set(A),fun(fun(A,fun(B,$o)),fun(B,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(A,Uuc,Uu)
        & aa(B,$o,aa(A,fun(B,$o),Uua,Uuc),Uub) ) ) ).

% ATP.lambda_839
tff(fact_9021_ATP_Olambda__840,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_hl(A,fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uu),Uua)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc)))) ) ) ).

% ATP.lambda_840
tff(fact_9022_ATP_Olambda__841,axiom,
    ! [A: $tType,B: $tType,Uu: set(A),Uua: fun(A,B),Uub: B,Uuc: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_of(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(A,Uuc,Uu)
        & ( aa(A,B,Uua,Uuc) = Uub ) ) ) ).

% ATP.lambda_841
tff(fact_9023_ATP_Olambda__842,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,B),Uua: set(A),Uub: B,Uuc: A] :
      ( aa(A,$o,aa(B,fun(A,$o),aa(set(A),fun(B,fun(A,$o)),aTP_Lamp_aii(fun(A,B),fun(set(A),fun(B,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( member(A,Uuc,Uua)
        & ( aa(A,B,Uu,Uuc) = Uub ) ) ) ).

% ATP.lambda_842
tff(fact_9024_ATP_Olambda__843,axiom,
    ! [A: $tType] :
      ( ( monoid_mult(A)
        & comm_ring(A) )
     => ! [Uu: A,Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_hm(A,fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uu),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uua),Uuc))) ) ) ).

% ATP.lambda_843
tff(fact_9025_ATP_Olambda__844,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(nat,fun(nat,fun(nat,nat)),aTP_Lamp_fn(nat,fun(nat,fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,binomial(Uu),Uuc)),aa(nat,nat,binomial(Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_844
tff(fact_9026_ATP_Olambda__845,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_jw(int,fun(int,fun(int,fun(int,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less_eq(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub)) ) ).

% ATP.lambda_845
tff(fact_9027_ATP_Olambda__846,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_nj(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_846
tff(fact_9028_ATP_Olambda__847,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] :
      ( aa(int,$o,aa(int,fun(int,$o),aa(int,fun(int,fun(int,$o)),aTP_Lamp_jp(int,fun(int,fun(int,fun(int,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(int,$o,aa(int,fun(int,$o),ord_less(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub)) ) ).

% ATP.lambda_847
tff(fact_9029_ATP_Olambda__848,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_nh(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)) ) ).

% ATP.lambda_848
tff(fact_9030_ATP_Olambda__849,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_nl(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uub)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uuc)) ) ).

% ATP.lambda_849
tff(fact_9031_ATP_Olambda__850,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,product_prod(nat,nat),aa(nat,fun(nat,product_prod(nat,nat)),aa(nat,fun(nat,fun(nat,product_prod(nat,nat))),aTP_Lamp_nn(nat,fun(nat,fun(nat,fun(nat,product_prod(nat,nat)))),Uu),Uua),Uub),Uuc) = aa(nat,product_prod(nat,nat),product_Pair(nat,nat,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uua),Uub)) ) ).

% ATP.lambda_850
tff(fact_9032_ATP_Olambda__851,axiom,
    ! [A: $tType,B: $tType,Uu: A,Uua: B,Uub: A,Uuc: B] :
      ( aa(B,$o,aa(A,fun(B,$o),aa(B,fun(A,fun(B,$o)),aTP_Lamp_jk(A,fun(B,fun(A,fun(B,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ( Uu = Uub )
        & ( Uua = Uuc ) ) ) ).

% ATP.lambda_851
tff(fact_9033_ATP_Olambda__852,axiom,
    ! [Uu: nat,Uua: nat,Uub: nat,Uuc: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aTP_Lamp_agy(nat,fun(nat,fun(nat,fun(nat,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uu),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua) ) ) ).

% ATP.lambda_852
tff(fact_9034_ATP_Olambda__853,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_mult(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_kv(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( member(A,Uuc,Uu)
            & ( aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uuc)),aa(A,B,Uub,Uuc)) != one_one(B) ) ) ) ) ).

% ATP.lambda_853
tff(fact_9035_ATP_Olambda__854,axiom,
    ! [A: $tType,B: $tType] :
      ( comm_monoid_add(B)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,B),Uuc: A] :
          ( aa(A,$o,aa(fun(A,B),fun(A,$o),aa(fun(A,B),fun(fun(A,B),fun(A,$o)),aTP_Lamp_kt(set(A),fun(fun(A,B),fun(fun(A,B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> ( member(A,Uuc,Uu)
            & ( aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uua,Uuc)),aa(A,B,Uub,Uuc)) != zero_zero(B) ) ) ) ) ).

% ATP.lambda_854
tff(fact_9036_ATP_Olambda__855,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_ye(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,divide_divide(real,one_one(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(A,B,Uu,Uub)),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))))) ) ) ).

% ATP.lambda_855
tff(fact_9037_ATP_Olambda__856,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(nat,fun(A,fun(nat,A)),aTP_Lamp_cu(fun(nat,A),fun(nat,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uua))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uuc)) ) ) ).

% ATP.lambda_856
tff(fact_9038_ATP_Olambda__857,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_1(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: list(B),Uuc: nat] : ( aa(nat,A,aa(list(B),fun(nat,A),aa(A,fun(list(B),fun(nat,A)),aTP_Lamp_nq(fun(B,A),fun(A,fun(list(B),fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,aa(nat,B,nth(B,Uub),Uuc))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_857
tff(fact_9039_ATP_Olambda__858,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aTP_Lamp_ti(fun(nat,A),fun(A,fun(A,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(A,A,aa(A,fun(A,A),minus_minus(A),divide_divide(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uua),Uub)),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)),Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,semiring_1_of_nat(A),Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),aa(nat,nat,suc,zero_zero(nat))))))) ) ) ).

% ATP.lambda_858
tff(fact_9040_ATP_Olambda__859,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_Vector_banach(B)
        & real_V3459762299906320749_field(B)
        & topological_t2_space(A) )
     => ! [Uu: fun(A,B),Uua: fun(nat,B),Uub: A,Uuc: nat] : ( aa(nat,B,aa(A,fun(nat,B),aa(fun(nat,B),fun(A,fun(nat,B)),aTP_Lamp_wj(fun(A,B),fun(fun(nat,B),fun(A,fun(nat,B))),Uu),Uua),Uub),Uuc) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,Uua,Uuc)),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),Uuc)) ) ) ).

% ATP.lambda_859
tff(fact_9041_ATP_Olambda__860,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_td(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),divide_divide(real,aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(A,real,Uu,Uua))),aa(num,real,numeral_numeral(real),bit0(one2)))) ) ) ).

% ATP.lambda_860
tff(fact_9042_ATP_Olambda__861,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_hy(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),Uub)),one_one(nat)))) ) ) ).

% ATP.lambda_861
tff(fact_9043_ATP_Olambda__862,axiom,
    ! [A: $tType,B: $tType] :
      ( topolo4958980785337419405_space(B)
     => ! [Uu: fun(A,B),Uua: B,Uub: set(B),Uuc: A] :
          ( aa(A,$o,aa(set(B),fun(A,$o),aa(B,fun(set(B),fun(A,$o)),aTP_Lamp_aap(fun(A,B),fun(B,fun(set(B),fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> member(B,aa(A,B,Uu,Uuc),aa(set(B),set(B),aa(set(B),fun(set(B),set(B)),minus_minus(set(B)),Uub),aa(set(B),set(B),insert(B,Uua),bot_bot(set(B))))) ) ) ).

% ATP.lambda_862
tff(fact_9044_ATP_Olambda__863,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_semiring_0(A)
     => ! [Uu: fun(B,A),Uua: A,Uub: B,Uuc: A] : ( aa(A,A,aa(B,fun(A,A),aa(A,fun(B,fun(A,A)),aTP_Lamp_afl(fun(B,A),fun(A,fun(B,fun(A,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(B,A,Uu,Uub)),aa(A,A,aa(A,fun(A,A),times_times(A),Uua),Uuc)) ) ) ).

% ATP.lambda_863
tff(fact_9045_ATP_Olambda__864,axiom,
    ! [Uu: fun(nat,nat),Uua: fun(nat,nat),Uub: nat,Uuc: nat] : ( aa(nat,nat,aa(nat,fun(nat,nat),aa(fun(nat,nat),fun(nat,fun(nat,nat)),aTP_Lamp_fw(fun(nat,nat),fun(fun(nat,nat),fun(nat,fun(nat,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(nat,nat,Uu,Uuc)),aa(nat,nat,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ).

% ATP.lambda_864
tff(fact_9046_ATP_Olambda__865,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V4412858255891104859lgebra(A) )
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_ga(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_865
tff(fact_9047_ATP_Olambda__866,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: fun(nat,A),Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(fun(nat,A),fun(nat,fun(nat,A)),aTP_Lamp_gd(fun(nat,A),fun(fun(nat,A),fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,Uuc)),aa(nat,A,Uua,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uub),Uuc))) ) ) ).

% ATP.lambda_866
tff(fact_9048_ATP_Olambda__867,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( semiring_0(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_dy(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_867
tff(fact_9049_ATP_Olambda__868,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,nat),Uua: fun(B,nat),Uub: A,Uuc: B] : ( aa(B,nat,aa(A,fun(B,nat),aa(fun(B,nat),fun(A,fun(B,nat)),aTP_Lamp_agx(fun(A,nat),fun(fun(B,nat),fun(A,fun(B,nat))),Uu),Uua),Uub),Uuc) = aa(nat,nat,aa(nat,fun(nat,nat),times_times(nat),aa(A,nat,Uu,Uub)),aa(B,nat,Uua,Uuc)) ) ).

% ATP.lambda_868
tff(fact_9050_ATP_Olambda__869,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_0(C)
     => ! [Uu: fun(A,C),Uua: fun(B,C),Uub: A,Uuc: B] : ( aa(B,C,aa(A,fun(B,C),aa(fun(B,C),fun(A,fun(B,C)),aTP_Lamp_aga(fun(A,C),fun(fun(B,C),fun(A,fun(B,C))),Uu),Uua),Uub),Uuc) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(A,C,Uu,Uub)),aa(B,C,Uua,Uuc)) ) ) ).

% ATP.lambda_869
tff(fact_9051_ATP_Olambda__870,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_adm(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),sup_sup(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_870
tff(fact_9052_ATP_Olambda__871,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: B,Uuc: C] : ( aa(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_od(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uub),Uuc) = aa(A,A,aa(A,fun(A,A),inf_inf(A),aa(B,A,Uu,Uub)),aa(C,A,Uua,Uuc)) ) ) ).

% ATP.lambda_871
tff(fact_9053_ATP_Olambda__872,axiom,
    ! [A: $tType,B: $tType] :
      ( linorder(A)
     => ! [Uu: fun(B,A),Uua: fun(list(B),A),Uub: list(B),Uuc: B] :
          ( aa(B,$o,aa(list(B),fun(B,$o),aa(fun(list(B),A),fun(list(B),fun(B,$o)),aTP_Lamp_afb(fun(B,A),fun(fun(list(B),A),fun(list(B),fun(B,$o))),Uu),Uua),Uub),Uuc)
        <=> ( aa(B,A,Uu,Uuc) = aa(list(B),A,Uua,Uub) ) ) ) ).

% ATP.lambda_872
tff(fact_9054_ATP_Olambda__873,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_rm(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(real,real,cos(real),aa(A,real,Uu,Uua))),aa(num,nat,numeral_numeral(nat),bit0(one2))))) ) ) ).

% ATP.lambda_873
tff(fact_9055_ATP_Olambda__874,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_tf(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,aa(real,fun(real,real),plus_plus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uu,Uub)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))) ) ) ).

% ATP.lambda_874
tff(fact_9056_ATP_Olambda__875,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_sa(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,exp(real),aa(A,real,Uu,Uub))) ) ) ).

% ATP.lambda_875
tff(fact_9057_ATP_Olambda__876,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_sc(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,cos(real),aa(A,real,Uu,Uub))) ) ) ).

% ATP.lambda_876
tff(fact_9058_ATP_Olambda__877,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_sp(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(A,real,Uu,Uua))) ) ) ).

% ATP.lambda_877
tff(fact_9059_ATP_Olambda__878,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_ri(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),bit0(one2))))))) ) ) ).

% ATP.lambda_878
tff(fact_9060_ATP_Olambda__879,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,real),fun(A,fun(A,real)),aTP_Lamp_sl(fun(A,real),fun(fun(A,real),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uuc)),aa(real,real,uminus_uminus(real),aa(real,real,sin(real),aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_879
tff(fact_9061_ATP_Olambda__880,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: A,Uub: fun(A,real),Uuc: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(A,fun(fun(A,real),fun(A,real)),aTP_Lamp_rk(fun(A,real),fun(A,fun(fun(A,real),fun(A,real))),Uu),Uua),Uub),Uuc) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uub,Uuc)),aa(real,real,inverse_inverse(real),aa(real,real,uminus_uminus(real),aa(real,real,sqrt,aa(real,real,aa(real,fun(real,real),minus_minus(real),one_one(real)),aa(nat,real,aa(real,fun(nat,real),power_power(real),aa(A,real,Uu,Uua)),aa(num,nat,numeral_numeral(nat),bit0(one2)))))))) ) ) ).

% ATP.lambda_880
tff(fact_9062_ATP_Olambda__881,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yf(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = divide_divide(real,real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc))),aa(A,B,Uu,Uub))),aa(A,B,Uua,Uuc))),real_V7770717601297561774m_norm(A,Uuc)) ) ) ).

% ATP.lambda_881
tff(fact_9063_ATP_Olambda__882,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,real,aa(A,fun(A,real),aa(fun(A,B),fun(A,fun(A,real)),aTP_Lamp_yi(fun(A,B),fun(fun(A,B),fun(A,fun(A,real))),Uu),Uua),Uub),Uuc) = divide_divide(real,real_V7770717601297561774m_norm(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub))) ) ) ).

% ATP.lambda_882
tff(fact_9064_ATP_Olambda__883,axiom,
    ! [A: $tType,B: $tType,Uu: fun(A,set(B)),Uua: set(B),Uub: set(B),Uuc: A] :
      ( aa(A,$o,aa(set(B),fun(A,$o),aa(set(B),fun(set(B),fun(A,$o)),aTP_Lamp_adz(fun(A,set(B)),fun(set(B),fun(set(B),fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( aa(set(B),$o,finite_finite(B),aa(A,set(B),Uu,Uuc))
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),Uub),aa(A,set(B),Uu,Uuc))
        & aa(set(B),$o,aa(set(B),fun(set(B),$o),ord_less_eq(set(B)),aa(A,set(B),Uu,Uuc)),Uua) ) ) ).

% ATP.lambda_883
tff(fact_9065_ATP_Olambda__884,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C) )
     => ! [Uu: fun(A,B),Uua: fun(A,C),Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(fun(A,C),fun(real,fun(A,$o)),aTP_Lamp_aao(fun(A,B),fun(fun(A,C),fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V7770717601297561774m_norm(C,aa(A,C,Uua,Uuc))),aa(real,real,aa(real,fun(real,real),times_times(real),real_V7770717601297561774m_norm(B,aa(A,B,Uu,Uuc))),Uub)) ) ) ).

% ATP.lambda_884
tff(fact_9066_ATP_Olambda__885,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: filter(A),Uuc: A] : ( aa(A,B,aa(filter(A),fun(A,B),aa(fun(A,B),fun(filter(A),fun(A,B)),aTP_Lamp_yn(fun(A,B),fun(fun(A,B),fun(filter(A),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_ym(A,A)))))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_ym(A,A))))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),topolo3827282254853284352ce_Lim(A,A,Uub,aTP_Lamp_ym(A,A)))))) ) ) ).

% ATP.lambda_885
tff(fact_9067_ATP_Olambda__886,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: A,Uub: fun(A,B),Uuc: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(A,fun(fun(A,B),fun(A,B)),aTP_Lamp_yj(fun(A,B),fun(A,fun(fun(A,B),fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uub,Uuc)),aa(A,B,Uub,Uua))),aa(A,B,Uu,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uua)))) ) ) ).

% ATP.lambda_886
tff(fact_9068_ATP_Olambda__887,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: A] : ( aa(A,B,aa(A,fun(A,B),aa(fun(A,B),fun(A,fun(A,B)),aTP_Lamp_yk(fun(A,B),fun(fun(A,B),fun(A,fun(A,B))),Uu),Uua),Uub),Uuc) = aa(B,B,real_V8093663219630862766scaleR(B,aa(real,real,inverse_inverse(real),real_V7770717601297561774m_norm(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(A,B,Uu,Uuc)),aa(A,B,Uu,Uub))),aa(A,B,Uua,aa(A,A,aa(A,fun(A,A),minus_minus(A),Uuc),Uub)))) ) ) ).

% ATP.lambda_887
tff(fact_9069_ATP_Olambda__888,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_1(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(B,C),Uuc: B] : ( aa(B,C,aa(fun(B,C),fun(B,C),aa(fun(A,B),fun(fun(B,C),fun(B,C)),aTP_Lamp_oo(set(A),fun(fun(A,B),fun(fun(B,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(nat,C,semiring_1_of_nat(C),aa(set(A),nat,finite_card(A),collect(A,aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_of(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uuc))))),aa(B,C,Uub,Uuc)) ) ) ).

% ATP.lambda_888
tff(fact_9070_ATP_Olambda__889,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: fun(A,fun(A,$o)),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aTP_Lamp_ahf(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [A7: A] :
            ( ( Uub = A7 )
            & ( Uuc = A7 ) )
        | ? [A7: A,B7: A,C3: A] :
            ( ( Uub = A7 )
            & ( Uuc = C3 )
            & aa(A,$o,aa(A,fun(A,$o),Uua,A7),B7)
            & aa(A,$o,aa(A,fun(A,$o),Uu,B7),C3) ) ) ) ).

% ATP.lambda_889
tff(fact_9071_ATP_Olambda__890,axiom,
    ! [A: $tType,Uu: fun(A,fun(A,$o)),Uua: fun(A,fun(A,$o)),Uub: A,Uuc: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(fun(A,fun(A,$o)),fun(A,fun(A,$o)),aTP_Lamp_ahg(fun(A,fun(A,$o)),fun(fun(A,fun(A,$o)),fun(A,fun(A,$o))),Uu),Uua),Uub),Uuc)
    <=> ( ? [A7: A,B7: A] :
            ( ( Uub = A7 )
            & ( Uuc = B7 )
            & aa(A,$o,aa(A,fun(A,$o),Uu,A7),B7) )
        | ? [A7: A,B7: A,C3: A] :
            ( ( Uub = A7 )
            & ( Uuc = C3 )
            & aa(A,$o,aa(A,fun(A,$o),Uua,A7),B7)
            & aa(A,$o,aa(A,fun(A,$o),Uu,B7),C3) ) ) ) ).

% ATP.lambda_890
tff(fact_9072_ATP_Olambda__891,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_mult(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,C),Uuc: B] : ( aa(B,C,aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_oh(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),Uub),collect(A,aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_of(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_891
tff(fact_9073_ATP_Olambda__892,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( comm_monoid_add(C)
     => ! [Uu: set(A),Uua: fun(A,B),Uub: fun(A,C),Uuc: B] : ( aa(B,C,aa(fun(A,C),fun(B,C),aa(fun(A,B),fun(fun(A,C),fun(B,C)),aTP_Lamp_og(set(A),fun(fun(A,B),fun(fun(A,C),fun(B,C))),Uu),Uua),Uub),Uuc) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),Uub),collect(A,aa(B,fun(A,$o),aa(fun(A,B),fun(B,fun(A,$o)),aTP_Lamp_of(set(A),fun(fun(A,B),fun(B,fun(A,$o))),Uu),Uua),Uuc))) ) ) ).

% ATP.lambda_892
tff(fact_9074_ATP_Olambda__893,axiom,
    ! [A: $tType] :
      ( real_V8999393235501362500lgebra(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: real,Uuc: A] :
          ( aa(A,$o,aa(real,fun(A,$o),aa(nat,fun(real,fun(A,$o)),aTP_Lamp_aau(fun(nat,A),fun(nat,fun(real,fun(A,$o))),Uu),Uua),Uub),Uuc)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),Uub),real_V7770717601297561774m_norm(A,aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(A,fun(nat,A),aTP_Lamp_ck(fun(nat,A),fun(A,fun(nat,A)),Uu),Uuc)),set_ord_atMost(nat,Uua)))) ) ) ).

% ATP.lambda_893
tff(fact_9075_ATP_Olambda__894,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_js(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_894
tff(fact_9076_ATP_Olambda__895,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_jo(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),aa(nat,nat,suc,Uuc))) ) ) ).

% ATP.lambda_895
tff(fact_9077_ATP_Olambda__896,axiom,
    ! [A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_bf(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_896
tff(fact_9078_ATP_Olambda__897,axiom,
    ! [A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: fun(nat,A),Uua: nat,Uub: nat,Uuc: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(nat,fun(nat,fun(nat,A)),aTP_Lamp_ei(fun(nat,A),fun(nat,fun(nat,fun(nat,A))),Uu),Uua),Uub),Uuc) = aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uub),Uua)),Uuc)) ) ) ).

% ATP.lambda_897
tff(fact_9079_ATP_Olambda__898,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_oe(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Sup_Sup(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_od(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_898
tff(fact_9080_ATP_Olambda__899,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( comple592849572758109894attice(A)
     => ! [Uu: fun(B,A),Uua: fun(C,A),Uub: set(C),Uuc: B] : ( aa(B,A,aa(set(C),fun(B,A),aa(fun(C,A),fun(set(C),fun(B,A)),aTP_Lamp_adn(fun(B,A),fun(fun(C,A),fun(set(C),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(set(A),A,complete_Inf_Inf(A),aa(set(C),set(A),image(C,A,aa(B,fun(C,A),aa(fun(C,A),fun(B,fun(C,A)),aTP_Lamp_adm(fun(B,A),fun(fun(C,A),fun(B,fun(C,A))),Uu),Uua),Uuc)),Uub)) ) ) ).

% ATP.lambda_899
tff(fact_9081_ATP_Olambda__900,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_is(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),minus_minus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_900
tff(fact_9082_ATP_Olambda__901,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_iq(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),plus_plus(int),aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uub),Uua))),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_901
tff(fact_9083_ATP_Olambda__902,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V8999393235501362500lgebra(A) )
     => ! [Uu: fun(B,A),Uua: B,Uub: fun(B,A),Uuc: B] : ( aa(B,A,aa(fun(B,A),fun(B,A),aa(B,fun(fun(B,A),fun(B,A)),aTP_Lamp_sg(fun(B,A),fun(B,fun(fun(B,A),fun(B,A))),Uu),Uua),Uub),Uuc) = aa(A,A,uminus_uminus(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua))),aa(B,A,Uub,Uuc))),aa(A,A,inverse_inverse(A),aa(B,A,Uu,Uua)))) ) ) ).

% ATP.lambda_902
tff(fact_9084_ATP_Olambda__903,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_il(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uub)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uuc))) ) ).

% ATP.lambda_903
tff(fact_9085_ATP_Olambda__904,axiom,
    ! [Uu: int,Uua: int,Uub: int,Uuc: int] : ( aa(int,product_prod(int,int),aa(int,fun(int,product_prod(int,int)),aa(int,fun(int,fun(int,product_prod(int,int))),aTP_Lamp_in(int,fun(int,fun(int,fun(int,product_prod(int,int)))),Uu),Uua),Uub),Uuc) = normalize(aa(int,product_prod(int,int),product_Pair(int,int,aa(int,int,aa(int,fun(int,int),times_times(int),Uu),Uuc)),aa(int,int,aa(int,fun(int,int),times_times(int),Uua),Uub))) ) ).

% ATP.lambda_904
tff(fact_9086_ATP_Olambda__905,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,fun(A,B)),Uua: fun(C,A),Uub: C,Uuc: fun(C,A),Uud: C] : ( aa(C,B,aa(fun(C,A),fun(C,B),aa(C,fun(fun(C,A),fun(C,B)),aa(fun(C,A),fun(C,fun(fun(C,A),fun(C,B))),aTP_Lamp_ry(fun(A,fun(A,B)),fun(fun(C,A),fun(C,fun(fun(C,A),fun(C,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,B,aa(A,fun(A,B),Uu,aa(C,A,Uua,Uub)),aa(C,A,Uuc,Uud)) ) ) ).

% ATP.lambda_905
tff(fact_9087_ATP_Olambda__906,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,C)),Uuc: B,Uud: B] : ( aa(B,C,aa(B,fun(B,C),aa(fun(A,fun(B,C)),fun(B,fun(B,C)),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C))),aTP_Lamp_sv(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,C)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7311177749621191930dd_sum(A,C),aa(B,fun(A,C),aa(B,fun(B,fun(A,C)),aa(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C)))),aTP_Lamp_su(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))))),Uu),Uua),Uub),Uuc),Uud)),Uu) ) ) ).

% ATP.lambda_906
tff(fact_9088_ATP_Olambda__907,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_hw(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_hv(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uua),Uub),Uuc),Uud)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_907
tff(fact_9089_ATP_Olambda__908,axiom,
    ! [Uu: nat,Uua: fun(nat,fun(real,real)),Uub: real,Uuc: nat,Uud: real] : ( aa(real,real,aa(nat,fun(real,real),aa(real,fun(nat,fun(real,real)),aa(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real))),aTP_Lamp_rd(nat,fun(fun(nat,fun(real,real)),fun(real,fun(nat,fun(real,real)))),Uu),Uua),Uub),Uuc),Uud) = aa(real,real,aa(real,fun(real,real),minus_minus(real),aa(real,real,aa(nat,fun(real,real),Uua,Uuc),Uud)),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(set(nat),real,aa(fun(nat,real),fun(set(nat),real),groups7311177749621191930dd_sum(nat,real),aa(real,fun(nat,real),aa(nat,fun(real,fun(nat,real)),aTP_Lamp_rc(fun(nat,fun(real,real)),fun(nat,fun(real,fun(nat,real))),Uua),Uuc),Uud)),set_ord_lessThan(nat,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))),aa(real,real,aa(real,fun(real,real),times_times(real),Uub),divide_divide(real,aa(nat,real,aa(real,fun(nat,real),power_power(real),Uud),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)),semiring_char_0_fact(real,aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uuc)))))) ) ).

% ATP.lambda_908
tff(fact_9090_ATP_Olambda__909,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: nat,Uua: fun(nat,A),Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(fun(nat,A),fun(A,fun(A,fun(nat,A))),aTP_Lamp_hz(nat,fun(fun(nat,A),fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(set(nat),A,aa(fun(nat,A),fun(set(nat),A),groups7311177749621191930dd_sum(nat,A),aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aTP_Lamp_hy(fun(nat,A),fun(A,fun(nat,fun(nat,A))),Uua),Uuc),Uud)),set_or1337092689740270186AtMost(nat,aa(nat,nat,suc,Uud),Uu))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud)) ) ) ).

% ATP.lambda_909
tff(fact_9091_ATP_Olambda__910,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gt(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),minus_minus(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uud)),Uua)),one_one(A))),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_910
tff(fact_9092_ATP_Olambda__911,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gk(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,aa(A,fun(A,A),plus_plus(A),aa(nat,A,semiring_1_of_nat(A),Uu)),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uuc),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_911
tff(fact_9093_ATP_Olambda__912,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_aej(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Uuc),Uu),transitive_trancl(A,Uub))
          | ( Uuc = Uu ) )
        & ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Uua),Uud),transitive_trancl(A,Uub))
          | ( Uud = Uua ) ) ) ) ).

% ATP.lambda_912
tff(fact_9094_ATP_Olambda__913,axiom,
    ! [A: $tType] :
      ( field_char_0(A)
     => ! [Uu: nat,Uua: A,Uub: A,Uuc: A,Uud: nat] : ( aa(nat,A,aa(A,fun(nat,A),aa(A,fun(A,fun(nat,A)),aa(A,fun(A,fun(A,fun(nat,A))),aTP_Lamp_gl(nat,fun(A,fun(A,fun(A,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,gbinomial(A,aa(A,A,uminus_uminus(A),Uua)),Uud)),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,uminus_uminus(A),Uub)),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),aa(A,A,aa(A,fun(A,A),plus_plus(A),Uub),Uuc)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uu),Uud))) ) ) ).

% ATP.lambda_913
tff(fact_9095_ATP_Olambda__914,axiom,
    ! [A: $tType,Uu: A,Uua: A,Uub: set(product_prod(A,A)),Uuc: A,Uud: A] :
      ( aa(A,$o,aa(A,fun(A,$o),aa(set(product_prod(A,A)),fun(A,fun(A,$o)),aa(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o))),aTP_Lamp_aek(A,fun(A,fun(set(product_prod(A,A)),fun(A,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
    <=> ( member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Uuc),Uu),transitive_rtrancl(A,Uub))
        & member(product_prod(A,A),aa(A,product_prod(A,A),product_Pair(A,A,Uua),Uud),transitive_rtrancl(A,Uub)) ) ) ).

% ATP.lambda_914
tff(fact_9096_ATP_Olambda__915,axiom,
    ! [A: $tType] :
      ( idom(A)
     => ! [Uu: fun(nat,A),Uua: A,Uub: A,Uuc: nat,Uud: nat] : ( aa(nat,A,aa(nat,fun(nat,A),aa(A,fun(nat,fun(nat,A)),aa(A,fun(A,fun(nat,fun(nat,A))),aTP_Lamp_hv(fun(nat,A),fun(A,fun(A,fun(nat,fun(nat,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(A,A,aa(A,fun(A,A),times_times(A),aa(nat,A,Uu,aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),Uuc),Uud)),one_one(nat)))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uub),Uud))),aa(nat,A,aa(A,fun(nat,A),power_power(A),Uua),Uuc)) ) ) ).

% ATP.lambda_915
tff(fact_9097_ATP_Olambda__916,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space(B)
        & real_V7819770556892013058_space(C) )
     => ! [Uu: fun(A,B),Uua: B,Uub: fun(A,C),Uuc: C,Uud: A] :
          ( aa(A,$o,aa(C,fun(A,$o),aa(fun(A,C),fun(C,fun(A,$o)),aa(B,fun(fun(A,C),fun(C,fun(A,$o))),aTP_Lamp_aai(fun(A,B),fun(B,fun(fun(A,C),fun(C,fun(A,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> aa(real,$o,aa(real,fun(real,$o),ord_less_eq(real),real_V557655796197034286t_dist(C,aa(A,C,Uub,Uud),Uuc)),real_V557655796197034286t_dist(B,aa(A,B,Uu,Uud),Uua)) ) ) ).

% ATP.lambda_916
tff(fact_9098_ATP_Olambda__917,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: nat,Uud: A] : ( aa(A,B,aa(nat,fun(A,B),aa(A,fun(nat,fun(A,B)),aa(fun(A,B),fun(A,fun(nat,fun(A,B))),aTP_Lamp_sn(fun(A,B),fun(fun(A,B),fun(A,fun(nat,fun(A,B)))),Uu),Uua),Uub),Uuc),Uud) = aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(nat,B,semiring_1_of_nat(B),Uuc)),aa(A,B,Uua,Uud))),aa(nat,B,aa(B,fun(nat,B),power_power(B),aa(A,B,Uu,Uub)),aa(nat,nat,aa(nat,fun(nat,nat),minus_minus(nat),Uuc),one_one(nat)))) ) ) ).

% ATP.lambda_917
tff(fact_9099_ATP_Olambda__918,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(B,A),Uua: B,Uub: fun(B,A),Uuc: int,Uud: B] : ( aa(B,A,aa(int,fun(B,A),aa(fun(B,A),fun(int,fun(B,A)),aa(B,fun(fun(B,A),fun(int,fun(B,A))),aTP_Lamp_sx(fun(B,A),fun(B,fun(fun(B,A),fun(int,fun(B,A)))),Uu),Uua),Uub),Uuc),Uud) = aa(A,A,aa(A,fun(A,A),times_times(A),aa(B,A,Uub,Uud)),aa(A,A,aa(A,fun(A,A),times_times(A),aa(int,A,ring_1_of_int(A),Uuc)),power_int(A,aa(B,A,Uu,Uua),aa(int,int,aa(int,fun(int,int),minus_minus(int),Uuc),one_one(int))))) ) ) ).

% ATP.lambda_918
tff(fact_9100_ATP_Olambda__919,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( semiring_0(C)
     => ! [Uu: fun(A,C),Uua: fun(B,C),Uub: set(A),Uuc: set(B),Uud: C] :
          ( aa(C,$o,aa(set(B),fun(C,$o),aa(set(A),fun(set(B),fun(C,$o)),aa(fun(B,C),fun(set(A),fun(set(B),fun(C,$o))),aTP_Lamp_agc(fun(A,C),fun(fun(B,C),fun(set(A),fun(set(B),fun(C,$o)))),Uu),Uua),Uub),Uuc),Uud)
        <=> ? [A7: A,B7: B] :
              ( ( Uud = aa(C,C,aa(C,fun(C,C),times_times(C),aa(A,C,Uu,A7)),aa(B,C,Uua,B7)) )
              & member(A,A7,Uub)
              & member(B,B7,Uuc) ) ) ) ).

% ATP.lambda_919
tff(fact_9101_ATP_Olambda__920,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( real_V3459762299906320749_field(C)
        & real_V822414075346904944vector(B) )
     => ! [Uu: set(A),Uua: fun(A,fun(B,C)),Uub: fun(A,fun(B,C)),Uuc: B,Uud: B,Uue: A] : ( aa(A,C,aa(B,fun(A,C),aa(B,fun(B,fun(A,C)),aa(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))),aa(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C)))),aTP_Lamp_su(set(A),fun(fun(A,fun(B,C)),fun(fun(A,fun(B,C)),fun(B,fun(B,fun(A,C))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(C,C,aa(C,fun(C,C),times_times(C),aa(B,C,aa(A,fun(B,C),Uub,Uue),Uud)),aa(set(A),C,aa(fun(A,C),fun(set(A),C),groups7121269368397514597t_prod(A,C),aa(B,fun(A,C),aTP_Lamp_ss(fun(A,fun(B,C)),fun(B,fun(A,C)),Uua),Uuc)),aa(set(A),set(A),aa(set(A),fun(set(A),set(A)),minus_minus(set(A)),Uu),aa(set(A),set(A),insert(A,Uue),bot_bot(set(A)))))) ) ) ).

% ATP.lambda_920
tff(fact_9102_ATP_Olambda__921,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V3459762299906320749_field(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_se(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = divide_divide(B,aa(B,B,aa(B,fun(B,B),minus_minus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uud,Uue))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uuc,Uub)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_921
tff(fact_9103_ATP_Olambda__922,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: fun(A,real),Uud: fun(A,real),Uue: A] : ( aa(A,real,aa(fun(A,real),fun(A,real),aa(fun(A,real),fun(fun(A,real),fun(A,real)),aa(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))),aa(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real)))),aTP_Lamp_tb(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,real),fun(fun(A,real),fun(A,real))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(real,real,aa(real,fun(real,real),times_times(real),aa(real,real,aa(real,fun(real,real),powr(real),aa(A,real,Uu,Uub)),aa(A,real,Uuc,Uub))),aa(real,real,aa(real,fun(real,real),plus_plus(real),aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uud,Uue)),aa(real,real,ln_ln(real),aa(A,real,Uu,Uub)))),divide_divide(real,aa(real,real,aa(real,fun(real,real),times_times(real),aa(A,real,Uua,Uue)),aa(A,real,Uuc,Uub)),aa(A,real,Uu,Uub)))) ) ) ).

% ATP.lambda_922
tff(fact_9104_ATP_Olambda__923,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V822414075346904944vector(B) )
     => ! [Uu: fun(A,real),Uua: fun(A,real),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_ro(fun(A,real),fun(fun(A,real),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uu,Uub)),aa(A,B,Uud,Uue))),aa(B,B,real_V8093663219630862766scaleR(B,aa(A,real,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_923
tff(fact_9105_ATP_Olambda__924,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V4412858255891104859lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_rw(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uu,Uub)),aa(A,B,Uud,Uue))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(A,B,Uua,Uue)),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_924
tff(fact_9106_ATP_Olambda__925,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector(A)
        & real_V8999393235501362500lgebra(B) )
     => ! [Uu: fun(A,B),Uua: fun(A,B),Uub: A,Uuc: fun(A,B),Uud: fun(A,B),Uue: A] : ( aa(A,B,aa(fun(A,B),fun(A,B),aa(fun(A,B),fun(fun(A,B),fun(A,B)),aa(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))),aa(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B)))),aTP_Lamp_sr(fun(A,B),fun(fun(A,B),fun(A,fun(fun(A,B),fun(fun(A,B),fun(A,B))))),Uu),Uua),Uub),Uuc),Uud),Uue) = aa(B,B,aa(B,fun(B,B),plus_plus(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,uminus_uminus(B),aa(A,B,Uu,Uub))),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,aa(B,fun(B,B),times_times(B),aa(B,B,inverse_inverse(B),aa(A,B,Uuc,Uub))),aa(A,B,Uud,Uue))),aa(B,B,inverse_inverse(B),aa(A,B,Uuc,Uub))))),divide_divide(B,aa(A,B,Uua,Uue),aa(A,B,Uuc,Uub))) ) ) ).

% ATP.lambda_925
tff(fact_9107_ATP_Olambda__926,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType] :
      ( ( real_V822414075346904944vector(D)
        & real_V822414075346904944vector(B)
        & real_V822414075346904944vector(C)
        & real_V822414075346904944vector(A) )
     => ! [Uu: fun(A,fun(B,C)),Uua: fun(D,A),Uub: fun(D,A),Uuc: D,Uud: fun(D,B),Uue: fun(D,B),Uuf: D] : ( aa(D,C,aa(fun(D,B),fun(D,C),aa(fun(D,B),fun(fun(D,B),fun(D,C)),aa(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))),aa(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))),aa(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C))))),aTP_Lamp_akm(fun(A,fun(B,C)),fun(fun(D,A),fun(fun(D,A),fun(D,fun(fun(D,B),fun(fun(D,B),fun(D,C)))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf) = aa(C,C,aa(C,fun(C,C),plus_plus(C),aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uua,Uuc)),aa(D,B,Uue,Uuf))),aa(B,C,aa(A,fun(B,C),Uu,aa(D,A,Uub,Uuf)),aa(D,B,Uud,Uuc))) ) ) ).

% ATP.lambda_926
tff(fact_9108_ATP_Olambda__927,axiom,
    ! [Uu: nat,Uua: list(vEBT_VEBT),Uub: vEBT_VEBT,Uuc: nat,Uud: nat,Uue: nat,Uuf: nat] :
      ( aa(nat,$o,aa(nat,fun(nat,$o),aa(nat,fun(nat,fun(nat,$o)),aa(nat,fun(nat,fun(nat,fun(nat,$o))),aa(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))),aa(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o))))),aTP_Lamp_aja(nat,fun(list(vEBT_VEBT),fun(vEBT_VEBT,fun(nat,fun(nat,fun(nat,fun(nat,$o)))))),Uu),Uua),Uub),Uuc),Uud),Uue),Uuf)
    <=> ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),Uue),Uuf)
        & aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uuf),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uu))
        & ! [I3: nat] :
            ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),I3),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uud))
           => ( ? [X_12: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(aa(nat,vEBT_VEBT,nth(vEBT_VEBT,Uua),I3)),X_12)
            <=> aa(nat,$o,vEBT_V8194947554948674370ptions(Uub),I3) ) )
        & $ite(
            Uue = Uuf,
            ! [X4: vEBT_VEBT] :
              ( member(vEBT_VEBT,X4,aa(list(vEBT_VEBT),set(vEBT_VEBT),set2(vEBT_VEBT),Uua))
             => ~ ? [X9: nat] : aa(nat,$o,vEBT_V8194947554948674370ptions(X4),X9) ),
            ( vEBT_V5917875025757280293ildren(Uuc,Uua,Uuf)
            & ! [X4: nat] :
                ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),X4),aa(nat,nat,aa(nat,fun(nat,nat),power_power(nat),aa(num,nat,numeral_numeral(nat),bit0(one2))),Uu))
               => ( vEBT_V5917875025757280293ildren(Uuc,Uua,X4)
                 => ( aa(nat,$o,aa(nat,fun(nat,$o),ord_less(nat),Uue),X4)
                    & aa(nat,$o,aa(nat,fun(nat,$o),ord_less_eq(nat),X4),Uuf) ) ) ) ) ) ) ) ).

% ATP.lambda_927
tff(fact_9109_ATP_Olambda__928,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space(B)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_agh(set(B),fun(A,set(B)),Uu),Uua) = Uu ) ) ).

% ATP.lambda_928
tff(fact_9110_ATP_Olambda__929,axiom,
    ! [A: $tType,B: $tType,Uu: set(B),Uua: A] : ( aa(A,set(B),aTP_Lamp_agb(set(B),fun(A,set(B)),Uu),Uua) = Uu ) ).

% ATP.lambda_929
tff(fact_9111_ATP_Olambda__930,axiom,
    ! [A: $tType,Uu: set(A),Uua: list(A)] : ( aa(list(A),set(A),aTP_Lamp_age(set(A),fun(list(A),set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_930
tff(fact_9112_ATP_Olambda__931,axiom,
    ! [B: $tType,A: $tType,Uu: set(A),Uua: B] : ( aa(B,set(A),aTP_Lamp_agi(set(A),fun(B,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_931
tff(fact_9113_ATP_Olambda__932,axiom,
    ! [A: $tType,Uu: set(A),Uua: A] : ( aa(A,set(A),aTP_Lamp_agg(set(A),fun(A,set(A)),Uu),Uua) = Uu ) ).

% ATP.lambda_932
tff(fact_9114_ATP_Olambda__933,axiom,
    ! [Uu: rat,Uua: nat] : ( aa(nat,rat,aTP_Lamp_afq(rat,fun(nat,rat),Uu),Uua) = Uu ) ).

% ATP.lambda_933
tff(fact_9115_ATP_Olambda__934,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: B,Uua: A] : ( aa(A,B,aTP_Lamp_rt(B,fun(A,B),Uu),Uua) = Uu ) ) ).

% ATP.lambda_934
tff(fact_9116_ATP_Olambda__935,axiom,
    ! [A: $tType] :
      ( counta3822494911875563373attice(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_op(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_935
tff(fact_9117_ATP_Olambda__936,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_cg(A,fun(nat,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_936
tff(fact_9118_ATP_Olambda__937,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A,Uua: A] : ( aa(A,A,aTP_Lamp_pv(A,fun(A,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_937
tff(fact_9119_ATP_Olambda__938,axiom,
    ! [B: $tType,A: $tType] :
      ( semiring_1(A)
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_dx(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_938
tff(fact_9120_ATP_Olambda__939,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zero(A)
        & topological_t2_space(A)
        & topolo8386298272705272623_space(B) )
     => ! [Uu: A,Uua: B] : ( aa(B,A,aTP_Lamp_tr(A,fun(B,A),Uu),Uua) = Uu ) ) ).

% ATP.lambda_939
tff(fact_9121_ATP_Olambda__940,axiom,
    ! [A: $tType,Uu: A,Uua: nat] : ( aa(nat,A,aTP_Lamp_ahh(A,fun(nat,A),Uu),Uua) = Uu ) ).

% ATP.lambda_940
tff(fact_9122_ATP_Olambda__941,axiom,
    ! [Uu: complex] : ( aa(complex,complex,aTP_Lamp_fo(complex,complex),Uu) = Uu ) ).

% ATP.lambda_941
tff(fact_9123_ATP_Olambda__942,axiom,
    ! [Uu: nat] : ( aa(nat,nat,aTP_Lamp_bg(nat,nat),Uu) = Uu ) ).

% ATP.lambda_942
tff(fact_9124_ATP_Olambda__943,axiom,
    ! [Uu: int] : ( aa(int,int,aTP_Lamp_bv(int,int),Uu) = Uu ) ).

% ATP.lambda_943
tff(fact_9125_ATP_Olambda__944,axiom,
    ! [A: $tType] :
      ( real_V822414075346904944vector(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ym(A,A),Uu) = Uu ) ) ).

% ATP.lambda_944
tff(fact_9126_ATP_Olambda__945,axiom,
    ! [A: $tType] :
      ( real_V3459762299906320749_field(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_pz(A,A),Uu) = Uu ) ) ).

% ATP.lambda_945
tff(fact_9127_ATP_Olambda__946,axiom,
    ! [A: $tType] :
      ( topological_t2_space(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_yo(A,A),Uu) = Uu ) ) ).

% ATP.lambda_946
tff(fact_9128_ATP_Olambda__947,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach(A)
        & real_V3459762299906320749_field(A) )
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_yp(A,A),Uu) = Uu ) ) ).

% ATP.lambda_947
tff(fact_9129_ATP_Olambda__948,axiom,
    ! [A: $tType] :
      ( linorder(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_nv(A,A),Uu) = Uu ) ) ).

% ATP.lambda_948
tff(fact_9130_ATP_Olambda__949,axiom,
    ! [A: $tType] :
      ( monoid_mult(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_af(A,A),Uu) = Uu ) ) ).

% ATP.lambda_949
tff(fact_9131_ATP_Olambda__950,axiom,
    ! [A: $tType] :
      ( topolo4638772830378233104ormity(A)
     => ! [Uu: product_unit] : ( aa(product_unit,filter(product_prod(A,A)),aTP_Lamp_akx(product_unit,filter(product_prod(A,A))),Uu) = topolo7806501430040627800ormity(A) ) ) ).

% ATP.lambda_950
tff(fact_9132_ATP_Olambda__951,axiom,
    ! [Uu: nat] : ( aa(nat,rat,aTP_Lamp_afv(nat,rat),Uu) = zero_zero(rat) ) ).

% ATP.lambda_951
tff(fact_9133_ATP_Olambda__952,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topolo4958980785337419405_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_by(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_952
tff(fact_9134_ATP_Olambda__953,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add(A)
        & topological_t2_space(A) )
     => ! [Uu: nat] : ( aa(nat,A,aTP_Lamp_bs(nat,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_953
tff(fact_9135_ATP_Olambda__954,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_dt(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_954
tff(fact_9136_ATP_Olambda__955,axiom,
    ! [B: $tType,A: $tType] :
      ( monoid_add(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_aer(B,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_955
tff(fact_9137_ATP_Olambda__956,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector(B)
        & real_V822414075346904944vector(A) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_ru(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_956
tff(fact_9138_ATP_Olambda__957,axiom,
    ! [A: $tType] :
      ( real_V4867850818363320053vector(A)
     => ! [Uu: A] : ( aa(A,real,aTP_Lamp_ajx(A,real),Uu) = zero_zero(real) ) ) ).

% ATP.lambda_957
tff(fact_9139_ATP_Olambda__958,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V4867850818363320053vector(B)
        & real_V4867850818363320053vector(A) )
     => ! [Uu: A] : ( aa(A,B,aTP_Lamp_akf(A,B),Uu) = zero_zero(B) ) ) ).

% ATP.lambda_958
tff(fact_9140_ATP_Olambda__959,axiom,
    ! [A: $tType] :
      ( mult_zero(A)
     => ! [Uu: A] : ( aa(A,A,aTP_Lamp_ad(A,A),Uu) = zero_zero(A) ) ) ).

% ATP.lambda_959
tff(fact_9141_ATP_Olambda__960,axiom,
    ! [Uu: nat] : ( aa(nat,rat,aTP_Lamp_afu(nat,rat),Uu) = one_one(rat) ) ).

% ATP.lambda_960
tff(fact_9142_ATP_Olambda__961,axiom,
    ! [B: $tType,A: $tType] :
      ( comm_monoid_mult(A)
     => ! [Uu: B] : ( aa(B,A,aTP_Lamp_bt(B,A),Uu) = one_one(A) ) ) ).

% ATP.lambda_961
tff(fact_9143_ATP_Olambda__962,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,real,aTP_Lamp_fh(A,real),Uu) = one_one(real) ) ).

% ATP.lambda_962
tff(fact_9144_ATP_Olambda__963,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,nat,aTP_Lamp_fe(A,nat),Uu) = one_one(nat) ) ).

% ATP.lambda_963
tff(fact_9145_ATP_Olambda__964,axiom,
    ! [Uu: real] :
      ( aa(real,$o,aTP_Lamp_ik(real,$o),Uu)
    <=> $false ) ).

% ATP.lambda_964
tff(fact_9146_ATP_Olambda__965,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_mb(nat,$o),Uu)
    <=> $false ) ).

% ATP.lambda_965
tff(fact_9147_ATP_Olambda__966,axiom,
    ! [Uu: nat] :
      ( aa(nat,$o,aTP_Lamp_ma(nat,$o),Uu)
    <=> $true ) ).

% ATP.lambda_966
tff(fact_9148_ATP_Olambda__967,axiom,
    ! [A: $tType,Uu: A] : ( aa(A,fun(nat,nat),aTP_Lamp_akz(A,fun(nat,nat)),Uu) = suc ) ).

% ATP.lambda_967

% Type constructors (797)
tff(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice(product_unit) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice(extended_enat) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__lattice_2,axiom,
    ! [A20: $tType] : bounded_lattice(filter(A20)) ).

tff(tcon_HOL_Obool___Lattices_Obounded__lattice_3,axiom,
    bounded_lattice($o) ).

tff(tcon_Set_Oset___Lattices_Obounded__lattice_4,axiom,
    ! [A20: $tType] : bounded_lattice(set(A20)) ).

tff(tcon_fun___Lattices_Obounded__lattice_5,axiom,
    ! [A20: $tType,A21: $tType] :
      ( bounded_lattice(A21)
     => bounded_lattice(fun(A20,A21)) ) ).

tff(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( comple592849572758109894attice(A21)
     => counta4013691401010221786attice(fun(A20,A21)) ) ).

tff(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( comple6319245703460814977attice(A21)
     => condit1219197933456340205attice(fun(A20,A21)) ) ).

tff(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( counta3822494911875563373attice(A21)
     => counta3822494911875563373attice(fun(A20,A21)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( comple592849572758109894attice(A21)
     => comple592849572758109894attice(fun(A20,A21)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A20: $tType,A21: $tType] :
      ( bounded_lattice(A21)
     => bounde4967611905675639751up_bot(fun(A20,A21)) ) ).

tff(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A20: $tType,A21: $tType] :
      ( bounded_lattice(A21)
     => bounde4346867609351753570nf_top(fun(A20,A21)) ) ).

tff(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( comple6319245703460814977attice(A21)
     => comple6319245703460814977attice(fun(A20,A21)) ) ).

tff(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A20: $tType,A21: $tType] :
      ( boolea8198339166811842893lgebra(A21)
     => boolea8198339166811842893lgebra(fun(A20,A21)) ) ).

tff(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A20: $tType,A21: $tType] :
      ( semilattice_sup(A21)
     => semilattice_sup(fun(A20,A21)) ) ).

tff(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A20: $tType,A21: $tType] :
      ( semilattice_inf(A21)
     => semilattice_inf(fun(A20,A21)) ) ).

tff(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A20: $tType,A21: $tType] :
      ( order_top(A21)
     => order_top(fun(A20,A21)) ) ).

tff(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A20: $tType,A21: $tType] :
      ( order_bot(A21)
     => order_bot(fun(A20,A21)) ) ).

tff(tcon_fun___Orderings_Opreorder,axiom,
    ! [A20: $tType,A21: $tType] :
      ( preorder(A21)
     => preorder(fun(A20,A21)) ) ).

tff(tcon_fun___Lattices_Olattice,axiom,
    ! [A20: $tType,A21: $tType] :
      ( lattice(A21)
     => lattice(fun(A20,A21)) ) ).

tff(tcon_fun___Orderings_Oorder,axiom,
    ! [A20: $tType,A21: $tType] :
      ( order(A21)
     => order(fun(A20,A21)) ) ).

tff(tcon_fun___Orderings_Oord,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ord(A21)
     => ord(fun(A20,A21)) ) ).

tff(tcon_fun___Groups_Ouminus,axiom,
    ! [A20: $tType,A21: $tType] :
      ( uminus(A21)
     => uminus(fun(A20,A21)) ) ).

tff(tcon_fun___Groups_Ominus,axiom,
    ! [A20: $tType,A21: $tType] :
      ( minus(A21)
     => minus(fun(A20,A21)) ) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder(int) ).

tff(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    condit1219197933456340205attice(int) ).

tff(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations(int) ).

tff(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel(int) ).

tff(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict(int) ).

tff(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology(int) ).

tff(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict(int) ).

tff(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add(int) ).

tff(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring(int) ).

tff(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult(int) ).

tff(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult(int) ).

tff(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add(int) ).

tff(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add(int) ).

tff(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors(int) ).

tff(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel(int) ).

tff(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits(int) ).

tff(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space(int) ).

tff(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1(int) ).

tff(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add(int) ).

tff(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__sup_7,axiom,
    semilattice_sup(int) ).

tff(tcon_Int_Oint___Lattices_Osemilattice__inf_8,axiom,
    semilattice_inf(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel(int) ).

tff(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult(int) ).

tff(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs(int) ).

tff(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity(int) ).

tff(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide(int) ).

tff(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral(int) ).

tff(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring(int) ).

tff(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0(int) ).

tff(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add(int) ).

tff(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one(int) ).

tff(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn(int) ).

tff(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity(int) ).

tff(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder(int) ).

tff(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult(int) ).

tff(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo(int) ).

tff(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1(int) ).

tff(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1(int) ).

tff(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0(int) ).

tff(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top(int) ).

tff(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot(int) ).

tff(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice(int) ).

tff(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd(int) ).

tff(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd(int) ).

tff(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero(int) ).

tff(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring(int) ).

tff(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order(int) ).

tff(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral(int) ).

tff(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0(int) ).

tff(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring(int) ).

tff(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom(int) ).

tff(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord(int) ).

tff(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus(int) ).

tff(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1(int) ).

tff(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if(int) ).

tff(tcon_Int_Oint___Groups_Ominus_14,axiom,
    minus(int) ).

tff(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd(int) ).

tff(tcon_Int_Oint___Power_Opower,axiom,
    power(int) ).

tff(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral(int) ).

tff(tcon_Int_Oint___Groups_Ozero,axiom,
    zero(int) ).

tff(tcon_Int_Oint___Groups_Oplus,axiom,
    plus(int) ).

tff(tcon_Int_Oint___Rings_Oring,axiom,
    ring(int) ).

tff(tcon_Int_Oint___Rings_Oidom,axiom,
    idom(int) ).

tff(tcon_Int_Oint___Groups_Oone,axiom,
    one(int) ).

tff(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd(int) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder(nat) ).

tff(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations(nat) ).

tff(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel(nat) ).

tff(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_23,axiom,
    unique1627219031080169319umeral(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_24,axiom,
    semiri6575147826004484403cancel(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_25,axiom,
    strict9044650504122735259up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_26,axiom,
    ordere580206878836729694up_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_27,axiom,
    ordere2412721322843649153imp_le(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_28,axiom,
    bit_se359711467146920520ations(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_29,axiom,
    linord2810124833399127020strict(nat) ).

tff(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_30,axiom,
    strict7427464778891057005id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_31,axiom,
    ordere8940638589300402666id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add(nat) ).

tff(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_32,axiom,
    euclid3725896446679973847miring(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Otopological__space_33,axiom,
    topolo4958980785337419405_space(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_34,axiom,
    topolo1944317154257567458pology(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_35,axiom,
    topolo4987421752381908075d_mult(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_36,axiom,
    topolo5987344860129210374id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_37,axiom,
    linord4140545234300271783up_add(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_38,axiom,
    topolo2564578578187576103pology(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_39,axiom,
    semiri2026040879449505780visors(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_40,axiom,
    linord181362715937106298miring(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_41,axiom,
    topolo4211221413907600880p_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_42,axiom,
    linord8928482502909563296strict(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_43,axiom,
    semiri3467727345109120633visors(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_44,axiom,
    ordere6658533253407199908up_add(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_45,axiom,
    semiri6843258321239162965malize(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__mult_46,axiom,
    topolo1898628316856586783d_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_47,axiom,
    ordere6911136660526730532id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_48,axiom,
    cancel2418104881723323429up_add(nat) ).

tff(tcon_Nat_Onat___Limits_Otopological__monoid__add_49,axiom,
    topolo6943815403480290642id_add(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_50,axiom,
    cancel1802427076303600483id_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_51,axiom,
    comm_s4317794764714335236cancel(nat) ).

tff(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_52,axiom,
    bit_semiring_bits(nat) ).

tff(tcon_Nat_Onat___Topological__Spaces_Ot2__space_53,axiom,
    topological_t2_space(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__comm__semiring_54,axiom,
    ordere2520102378445227354miring(nat) ).

tff(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_55,axiom,
    cancel_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semiring_56,axiom,
    linordered_semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring__0_57,axiom,
    ordered_semiring_0(nat) ).

tff(tcon_Nat_Onat___Rings_Olinordered__semidom_58,axiom,
    linordered_semidom(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__sup_59,axiom,
    semilattice_sup(nat) ).

tff(tcon_Nat_Onat___Lattices_Osemilattice__inf_60,axiom,
    semilattice_inf(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__mult_61,axiom,
    ab_semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1__cancel_62,axiom,
    semiring_1_cancel(nat) ).

tff(tcon_Nat_Onat___Rings_Oalgebraic__semidom_63,axiom,
    algebraic_semidom(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_64,axiom,
    comm_monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff(nat) ).

tff(tcon_Nat_Onat___Groups_Oab__semigroup__add_65,axiom,
    ab_semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Oordered__semiring_66,axiom,
    ordered_semiring(nat) ).

tff(tcon_Nat_Onat___Parity_Osemiring__parity_67,axiom,
    semiring_parity(nat) ).

tff(tcon_Nat_Onat___Groups_Ocomm__monoid__add_68,axiom,
    comm_monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__modulo_69,axiom,
    semiring_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__1_70,axiom,
    comm_semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring__0_71,axiom,
    comm_semiring_0(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__mult_72,axiom,
    semigroup_mult(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__modulo_73,axiom,
    semidom_modulo(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom__divide_74,axiom,
    semidom_divide(nat) ).

tff(tcon_Nat_Onat___Num_Osemiring__numeral_75,axiom,
    semiring_numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Osemigroup__add_76,axiom,
    semigroup_add(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__less__one_77,axiom,
    zero_less_one(nat) ).

tff(tcon_Nat_Onat___Rings_Ocomm__semiring_78,axiom,
    comm_semiring(nat) ).

tff(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder__bot_79,axiom,
    order_bot(nat) ).

tff(tcon_Nat_Onat___Nat_Osemiring__char__0_80,axiom,
    semiring_char_0(nat) ).

tff(tcon_Nat_Onat___Rings_Ozero__neq__one_81,axiom,
    zero_neq_one(nat) ).

tff(tcon_Nat_Onat___Orderings_Opreorder_82,axiom,
    preorder(nat) ).

tff(tcon_Nat_Onat___Orderings_Olinorder_83,axiom,
    linorder(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__mult_84,axiom,
    monoid_mult(nat) ).

tff(tcon_Nat_Onat___Groups_Omonoid__add_85,axiom,
    monoid_add(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__1_86,axiom,
    semiring_1(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring__0_87,axiom,
    semiring_0(nat) ).

tff(tcon_Nat_Onat___Orderings_Ono__top_88,axiom,
    no_top(nat) ).

tff(tcon_Nat_Onat___Lattices_Olattice_89,axiom,
    lattice(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__gcd_90,axiom,
    semiring_gcd(nat) ).

tff(tcon_Nat_Onat___GCD_Osemiring__Gcd_91,axiom,
    semiring_Gcd(nat) ).

tff(tcon_Nat_Onat___Rings_Omult__zero_92,axiom,
    mult_zero(nat) ).

tff(tcon_Nat_Onat___Orderings_Oorder_93,axiom,
    order(nat) ).

tff(tcon_Nat_Onat___Rings_Osemiring_94,axiom,
    semiring(nat) ).

tff(tcon_Nat_Onat___Rings_Osemidom_95,axiom,
    semidom(nat) ).

tff(tcon_Nat_Onat___Orderings_Oord_96,axiom,
    ord(nat) ).

tff(tcon_Nat_Onat___Groups_Ominus_97,axiom,
    minus(nat) ).

tff(tcon_Nat_Onat___Power_Opower_98,axiom,
    power(nat) ).

tff(tcon_Nat_Onat___Num_Onumeral_99,axiom,
    numeral(nat) ).

tff(tcon_Nat_Onat___Groups_Ozero_100,axiom,
    zero(nat) ).

tff(tcon_Nat_Onat___Groups_Oplus_101,axiom,
    plus(nat) ).

tff(tcon_Nat_Onat___Groups_Oone_102,axiom,
    one(nat) ).

tff(tcon_Nat_Onat___Rings_Odvd_103,axiom,
    dvd(nat) ).

tff(tcon_Nat_Onat___Nat_Osize,axiom,
    size(nat) ).

tff(tcon_Num_Onum___Orderings_Opreorder_104,axiom,
    preorder(num) ).

tff(tcon_Num_Onum___Orderings_Olinorder_105,axiom,
    linorder(num) ).

tff(tcon_Num_Onum___Orderings_Oorder_106,axiom,
    order(num) ).

tff(tcon_Num_Onum___Orderings_Oord_107,axiom,
    ord(num) ).

tff(tcon_Num_Onum___Groups_Oplus_108,axiom,
    plus(num) ).

tff(tcon_Num_Onum___Nat_Osize_109,axiom,
    size(num) ).

tff(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_110,axiom,
    semiri1453513574482234551roduct(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_111,axiom,
    ordere1937475149494474687imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_112,axiom,
    semiri6575147826004484403cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_113,axiom,
    strict9044650504122735259up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_114,axiom,
    ordere580206878836729694up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_115,axiom,
    ordere2412721322843649153imp_le(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_116,axiom,
    linord2810124833399127020strict(rat) ).

tff(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_117,axiom,
    strict7427464778891057005id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_118,axiom,
    ordere8940638589300402666id_add(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_119,axiom,
    linord715952674999750819strict(rat) ).

tff(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_120,axiom,
    linord4140545234300271783up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_121,axiom,
    semiri2026040879449505780visors(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_122,axiom,
    linord181362715937106298miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_123,axiom,
    linord8928482502909563296strict(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_124,axiom,
    semiri3467727345109120633visors(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_125,axiom,
    ordere6658533253407199908up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_126,axiom,
    ordere166539214618696060dd_abs(rat) ).

tff(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_127,axiom,
    ordere6911136660526730532id_add(rat) ).

tff(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_128,axiom,
    linord5086331880401160121up_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_129,axiom,
    cancel2418104881723323429up_add(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_130,axiom,
    ring_15535105094025558882visors(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_131,axiom,
    cancel1802427076303600483id_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring__strict_132,axiom,
    linord4710134922213307826strict(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_133,axiom,
    comm_s4317794764714335236cancel(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__comm__semiring_134,axiom,
    ordere2520102378445227354miring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring__1_135,axiom,
    linord6961819062388156250ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Oordered__ab__group__add_136,axiom,
    ordered_ab_group_add(rat) ).

tff(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_137,axiom,
    cancel_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semiring_138,axiom,
    linordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring__0_139,axiom,
    ordered_semiring_0(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__semidom_140,axiom,
    linordered_semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__sup_141,axiom,
    semilattice_sup(rat) ).

tff(tcon_Rat_Orat___Lattices_Osemilattice__inf_142,axiom,
    semilattice_inf(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__mult_143,axiom,
    ab_semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1__cancel_144,axiom,
    semiring_1_cancel(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_145,axiom,
    comm_monoid_mult(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__semigroup__add_146,axiom,
    ab_semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__semiring_147,axiom,
    ordered_semiring(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring__abs_148,axiom,
    ordered_ring_abs(rat) ).

tff(tcon_Rat_Orat___Groups_Ocomm__monoid__add_149,axiom,
    comm_monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__ring_150,axiom,
    linordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Olinordered__idom_151,axiom,
    linordered_idom(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__1_152,axiom,
    comm_semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring__0_153,axiom,
    comm_semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__mult_154,axiom,
    semigroup_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom__divide_155,axiom,
    semidom_divide(rat) ).

tff(tcon_Rat_Orat___Num_Osemiring__numeral_156,axiom,
    semiring_numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Osemigroup__add_157,axiom,
    semigroup_add(rat) ).

tff(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__less__one_158,axiom,
    zero_less_one(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__semiring_159,axiom,
    comm_semiring(rat) ).

tff(tcon_Rat_Orat___Nat_Osemiring__char__0_160,axiom,
    semiring_char_0(rat) ).

tff(tcon_Rat_Orat___Groups_Oab__group__add_161,axiom,
    ab_group_add(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Ozero__neq__one_162,axiom,
    zero_neq_one(rat) ).

tff(tcon_Rat_Orat___Rings_Oordered__ring_163,axiom,
    ordered_ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__abs__sgn_164,axiom,
    idom_abs_sgn(rat) ).

tff(tcon_Rat_Orat___Orderings_Opreorder_165,axiom,
    preorder(rat) ).

tff(tcon_Rat_Orat___Orderings_Olinorder_166,axiom,
    linorder(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__mult_167,axiom,
    monoid_mult(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom__divide_168,axiom,
    idom_divide(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring__1_169,axiom,
    comm_ring_1(rat) ).

tff(tcon_Rat_Orat___Groups_Omonoid__add_170,axiom,
    monoid_add(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__1_171,axiom,
    semiring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring__0_172,axiom,
    semiring_0(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__top_173,axiom,
    no_top(rat) ).

tff(tcon_Rat_Orat___Orderings_Ono__bot_174,axiom,
    no_bot(rat) ).

tff(tcon_Rat_Orat___Lattices_Olattice_175,axiom,
    lattice(rat) ).

tff(tcon_Rat_Orat___Groups_Ogroup__add_176,axiom,
    group_add(rat) ).

tff(tcon_Rat_Orat___Rings_Omult__zero_177,axiom,
    mult_zero(rat) ).

tff(tcon_Rat_Orat___Rings_Ocomm__ring_178,axiom,
    comm_ring(rat) ).

tff(tcon_Rat_Orat___Orderings_Oorder_179,axiom,
    order(rat) ).

tff(tcon_Rat_Orat___Num_Oneg__numeral_180,axiom,
    neg_numeral(rat) ).

tff(tcon_Rat_Orat___Nat_Oring__char__0_181,axiom,
    ring_char_0(rat) ).

tff(tcon_Rat_Orat___Rings_Osemiring_182,axiom,
    semiring(rat) ).

tff(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse(rat) ).

tff(tcon_Rat_Orat___Rings_Osemidom_183,axiom,
    semidom(rat) ).

tff(tcon_Rat_Orat___Orderings_Oord_184,axiom,
    ord(rat) ).

tff(tcon_Rat_Orat___Groups_Ouminus_185,axiom,
    uminus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring__1_186,axiom,
    ring_1(rat) ).

tff(tcon_Rat_Orat___Rings_Oabs__if_187,axiom,
    abs_if(rat) ).

tff(tcon_Rat_Orat___Groups_Ominus_188,axiom,
    minus(rat) ).

tff(tcon_Rat_Orat___Fields_Ofield,axiom,
    field(rat) ).

tff(tcon_Rat_Orat___Power_Opower_189,axiom,
    power(rat) ).

tff(tcon_Rat_Orat___Num_Onumeral_190,axiom,
    numeral(rat) ).

tff(tcon_Rat_Orat___Groups_Ozero_191,axiom,
    zero(rat) ).

tff(tcon_Rat_Orat___Groups_Oplus_192,axiom,
    plus(rat) ).

tff(tcon_Rat_Orat___Rings_Oring_193,axiom,
    ring(rat) ).

tff(tcon_Rat_Orat___Rings_Oidom_194,axiom,
    idom(rat) ).

tff(tcon_Rat_Orat___Groups_Oone_195,axiom,
    one(rat) ).

tff(tcon_Rat_Orat___Rings_Odvd_196,axiom,
    dvd(rat) ).

tff(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_197,axiom,
    ! [A20: $tType] : counta4013691401010221786attice(set(A20)) ).

tff(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_198,axiom,
    ! [A20: $tType] : condit1219197933456340205attice(set(A20)) ).

tff(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_199,axiom,
    ! [A20: $tType] : counta3822494911875563373attice(set(A20)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_200,axiom,
    ! [A20: $tType] : comple592849572758109894attice(set(A20)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_201,axiom,
    ! [A20: $tType] : bounde4967611905675639751up_bot(set(A20)) ).

tff(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_202,axiom,
    ! [A20: $tType] : bounde4346867609351753570nf_top(set(A20)) ).

tff(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_203,axiom,
    ! [A20: $tType] : comple6319245703460814977attice(set(A20)) ).

tff(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_204,axiom,
    ! [A20: $tType] : boolea8198339166811842893lgebra(set(A20)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__sup_205,axiom,
    ! [A20: $tType] : semilattice_sup(set(A20)) ).

tff(tcon_Set_Oset___Lattices_Osemilattice__inf_206,axiom,
    ! [A20: $tType] : semilattice_inf(set(A20)) ).

tff(tcon_Set_Oset___Orderings_Oorder__top_207,axiom,
    ! [A20: $tType] : order_top(set(A20)) ).

tff(tcon_Set_Oset___Orderings_Oorder__bot_208,axiom,
    ! [A20: $tType] : order_bot(set(A20)) ).

tff(tcon_Set_Oset___Orderings_Opreorder_209,axiom,
    ! [A20: $tType] : preorder(set(A20)) ).

tff(tcon_Set_Oset___Lattices_Olattice_210,axiom,
    ! [A20: $tType] : lattice(set(A20)) ).

tff(tcon_Set_Oset___Orderings_Oorder_211,axiom,
    ! [A20: $tType] : order(set(A20)) ).

tff(tcon_Set_Oset___Orderings_Oord_212,axiom,
    ! [A20: $tType] : ord(set(A20)) ).

tff(tcon_Set_Oset___Groups_Ouminus_213,axiom,
    ! [A20: $tType] : uminus(set(A20)) ).

tff(tcon_Set_Oset___Groups_Ominus_214,axiom,
    ! [A20: $tType] : minus(set(A20)) ).

tff(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_215,axiom,
    counta4013691401010221786attice($o) ).

tff(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_216,axiom,
    condit1219197933456340205attice($o) ).

tff(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_217,axiom,
    counta3822494911875563373attice($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_218,axiom,
    comple592849572758109894attice($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Otopological__space_219,axiom,
    topolo4958980785337419405_space($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_220,axiom,
    topolo1944317154257567458pology($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_221,axiom,
    bounde4967611905675639751up_bot($o) ).

tff(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_222,axiom,
    bounde4346867609351753570nf_top($o) ).

tff(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_223,axiom,
    comple6319245703460814977attice($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_224,axiom,
    topolo2564578578187576103pology($o) ).

tff(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_225,axiom,
    boolea8198339166811842893lgebra($o) ).

tff(tcon_HOL_Obool___Topological__Spaces_Ot2__space_226,axiom,
    topological_t2_space($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__sup_227,axiom,
    semilattice_sup($o) ).

tff(tcon_HOL_Obool___Lattices_Osemilattice__inf_228,axiom,
    semilattice_inf($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__top_229,axiom,
    order_top($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder__bot_230,axiom,
    order_bot($o) ).

tff(tcon_HOL_Obool___Orderings_Opreorder_231,axiom,
    preorder($o) ).

tff(tcon_HOL_Obool___Orderings_Olinorder_232,axiom,
    linorder($o) ).

tff(tcon_HOL_Obool___Lattices_Olattice_233,axiom,
    lattice($o) ).

tff(tcon_HOL_Obool___Orderings_Oorder_234,axiom,
    order($o) ).

tff(tcon_HOL_Obool___Orderings_Oord_235,axiom,
    ord($o) ).

tff(tcon_HOL_Obool___Groups_Ouminus_236,axiom,
    uminus($o) ).

tff(tcon_HOL_Obool___Groups_Ominus_237,axiom,
    minus($o) ).

tff(tcon_List_Olist___Nat_Osize_238,axiom,
    ! [A20: $tType] : size(list(A20)) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_239,axiom,
    condit6923001295902523014norder(real) ).

tff(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_240,axiom,
    condit1219197933456340205attice(real) ).

tff(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_241,axiom,
    semiri1453513574482234551roduct(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_242,axiom,
    ordere1937475149494474687imp_le(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_243,axiom,
    semiri6575147826004484403cancel(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_244,axiom,
    strict9044650504122735259up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_245,axiom,
    ordere580206878836729694up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_246,axiom,
    ordere2412721322843649153imp_le(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_247,axiom,
    linord2810124833399127020strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector(real) ).

tff(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_248,axiom,
    strict7427464778891057005id_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_249,axiom,
    ordere8940638589300402666id_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Otopological__space_250,axiom,
    topolo4958980785337419405_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_251,axiom,
    topolo1944317154257567458pology(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_252,axiom,
    archim462609752435547400_field(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_253,axiom,
    linord715952674999750819strict(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist(real) ).

tff(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_254,axiom,
    unboun7993243217541854897norder(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_255,axiom,
    topolo5987344860129210374id_add(real) ).

tff(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_256,axiom,
    linord4140545234300271783up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_257,axiom,
    topolo2564578578187576103pology(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_258,axiom,
    semiri2026040879449505780visors(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_259,axiom,
    linord181362715937106298miring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_260,axiom,
    topolo4211221413907600880p_mult(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_261,axiom,
    linord8928482502909563296strict(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_262,axiom,
    semiri3467727345109120633visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_263,axiom,
    ordere6658533253407199908up_add(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_264,axiom,
    ordere166539214618696060dd_abs(real) ).

tff(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_265,axiom,
    archim2362893244070406136eiling(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_266,axiom,
    ordere6911136660526730532id_add(real) ).

tff(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_267,axiom,
    linord5086331880401160121up_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_268,axiom,
    cancel2418104881723323429up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ouniformity,axiom,
    topolo4638772830378233104ormity(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_269,axiom,
    ring_15535105094025558882visors(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__monoid__add_270,axiom,
    topolo6943815403480290642id_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_271,axiom,
    cancel1802427076303600483id_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring__strict_272,axiom,
    linord4710134922213307826strict(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_273,axiom,
    comm_s4317794764714335236cancel(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Odist__norm,axiom,
    real_V6936659425649961206t_norm(real) ).

tff(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add(real) ).

tff(tcon_Real_Oreal___Topological__Spaces_Ot2__space_274,axiom,
    topological_t2_space(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__comm__semiring_275,axiom,
    ordere2520102378445227354miring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring__1_276,axiom,
    linord6961819062388156250ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Oordered__ab__group__add_277,axiom,
    ordered_ab_group_add(real) ).

tff(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_278,axiom,
    cancel_semigroup_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semiring_279,axiom,
    linordered_semiring(real) ).

tff(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring__0_280,axiom,
    ordered_semiring_0(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__semidom_281,axiom,
    linordered_semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__linorder_282,axiom,
    dense_linorder(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__sup_283,axiom,
    semilattice_sup(real) ).

tff(tcon_Real_Oreal___Lattices_Osemilattice__inf_284,axiom,
    semilattice_inf(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__mult_285,axiom,
    ab_semigroup_mult(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1__cancel_286,axiom,
    semiring_1_cancel(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_287,axiom,
    comm_monoid_mult(real) ).

tff(tcon_Real_Oreal___Groups_Oab__semigroup__add_288,axiom,
    ab_semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Olinordered__field_289,axiom,
    linordered_field(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__semiring_290,axiom,
    ordered_semiring(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring__abs_291,axiom,
    ordered_ring_abs(real) ).

tff(tcon_Real_Oreal___Groups_Ocomm__monoid__add_292,axiom,
    comm_monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__ring_293,axiom,
    linordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Olinordered__idom_294,axiom,
    linordered_idom(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__1_295,axiom,
    comm_semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring__0_296,axiom,
    comm_semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Odense__order_297,axiom,
    dense_order(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__mult_298,axiom,
    semigroup_mult(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom__divide_299,axiom,
    semidom_divide(real) ).

tff(tcon_Real_Oreal___Num_Osemiring__numeral_300,axiom,
    semiring_numeral(real) ).

tff(tcon_Real_Oreal___Groups_Osemigroup__add_301,axiom,
    semigroup_add(real) ).

tff(tcon_Real_Oreal___Fields_Odivision__ring_302,axiom,
    division_ring(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__less__one_303,axiom,
    zero_less_one(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__semiring_304,axiom,
    comm_semiring(real) ).

tff(tcon_Real_Oreal___Nat_Osemiring__char__0_305,axiom,
    semiring_char_0(real) ).

tff(tcon_Real_Oreal___Groups_Oab__group__add_306,axiom,
    ab_group_add(real) ).

tff(tcon_Real_Oreal___Fields_Ofield__char__0_307,axiom,
    field_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Ozero__neq__one_308,axiom,
    zero_neq_one(real) ).

tff(tcon_Real_Oreal___Rings_Oordered__ring_309,axiom,
    ordered_ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__abs__sgn_310,axiom,
    idom_abs_sgn(real) ).

tff(tcon_Real_Oreal___Orderings_Opreorder_311,axiom,
    preorder(real) ).

tff(tcon_Real_Oreal___Orderings_Olinorder_312,axiom,
    linorder(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__mult_313,axiom,
    monoid_mult(real) ).

tff(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln(real) ).

tff(tcon_Real_Oreal___Rings_Oidom__divide_314,axiom,
    idom_divide(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring__1_315,axiom,
    comm_ring_1(real) ).

tff(tcon_Real_Oreal___Groups_Omonoid__add_316,axiom,
    monoid_add(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__1_317,axiom,
    semiring_1(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring__0_318,axiom,
    semiring_0(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__top_319,axiom,
    no_top(real) ).

tff(tcon_Real_Oreal___Orderings_Ono__bot_320,axiom,
    no_bot(real) ).

tff(tcon_Real_Oreal___Lattices_Olattice_321,axiom,
    lattice(real) ).

tff(tcon_Real_Oreal___Groups_Ogroup__add_322,axiom,
    group_add(real) ).

tff(tcon_Real_Oreal___Rings_Omult__zero_323,axiom,
    mult_zero(real) ).

tff(tcon_Real_Oreal___Rings_Ocomm__ring_324,axiom,
    comm_ring(real) ).

tff(tcon_Real_Oreal___Orderings_Oorder_325,axiom,
    order(real) ).

tff(tcon_Real_Oreal___Num_Oneg__numeral_326,axiom,
    neg_numeral(real) ).

tff(tcon_Real_Oreal___Nat_Oring__char__0_327,axiom,
    ring_char_0(real) ).

tff(tcon_Real_Oreal___Rings_Osemiring_328,axiom,
    semiring(real) ).

tff(tcon_Real_Oreal___Fields_Oinverse_329,axiom,
    inverse(real) ).

tff(tcon_Real_Oreal___Rings_Osemidom_330,axiom,
    semidom(real) ).

tff(tcon_Real_Oreal___Orderings_Oord_331,axiom,
    ord(real) ).

tff(tcon_Real_Oreal___Groups_Ouminus_332,axiom,
    uminus(real) ).

tff(tcon_Real_Oreal___Rings_Oring__1_333,axiom,
    ring_1(real) ).

tff(tcon_Real_Oreal___Rings_Oabs__if_334,axiom,
    abs_if(real) ).

tff(tcon_Real_Oreal___Groups_Ominus_335,axiom,
    minus(real) ).

tff(tcon_Real_Oreal___Fields_Ofield_336,axiom,
    field(real) ).

tff(tcon_Real_Oreal___Power_Opower_337,axiom,
    power(real) ).

tff(tcon_Real_Oreal___Num_Onumeral_338,axiom,
    numeral(real) ).

tff(tcon_Real_Oreal___Groups_Ozero_339,axiom,
    zero(real) ).

tff(tcon_Real_Oreal___Groups_Oplus_340,axiom,
    plus(real) ).

tff(tcon_Real_Oreal___Rings_Oring_341,axiom,
    ring(real) ).

tff(tcon_Real_Oreal___Rings_Oidom_342,axiom,
    idom(real) ).

tff(tcon_Real_Oreal___Groups_Oone_343,axiom,
    one(real) ).

tff(tcon_Real_Oreal___Rings_Odvd_344,axiom,
    dvd(real) ).

tff(tcon_String_Ochar___Nat_Osize_345,axiom,
    size(char) ).

tff(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_346,axiom,
    ! [A20: $tType] : condit1219197933456340205attice(filter(A20)) ).

tff(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_347,axiom,
    ! [A20: $tType] : counta3822494911875563373attice(filter(A20)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_348,axiom,
    ! [A20: $tType] : bounde4967611905675639751up_bot(filter(A20)) ).

tff(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_349,axiom,
    ! [A20: $tType] : bounde4346867609351753570nf_top(filter(A20)) ).

tff(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_350,axiom,
    ! [A20: $tType] : comple6319245703460814977attice(filter(A20)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_351,axiom,
    ! [A20: $tType] : semilattice_sup(filter(A20)) ).

tff(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_352,axiom,
    ! [A20: $tType] : semilattice_inf(filter(A20)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__top_353,axiom,
    ! [A20: $tType] : order_top(filter(A20)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder__bot_354,axiom,
    ! [A20: $tType] : order_bot(filter(A20)) ).

tff(tcon_Filter_Ofilter___Orderings_Opreorder_355,axiom,
    ! [A20: $tType] : preorder(filter(A20)) ).

tff(tcon_Filter_Ofilter___Lattices_Olattice_356,axiom,
    ! [A20: $tType] : lattice(filter(A20)) ).

tff(tcon_Filter_Ofilter___Orderings_Oorder_357,axiom,
    ! [A20: $tType] : order(filter(A20)) ).

tff(tcon_Filter_Ofilter___Orderings_Oord_358,axiom,
    ! [A20: $tType] : ord(filter(A20)) ).

tff(tcon_Option_Ooption___Nat_Osize_359,axiom,
    ! [A20: $tType] : size(option(A20)) ).

tff(tcon_String_Oliteral___Groups_Osemigroup__add_360,axiom,
    semigroup_add(literal) ).

tff(tcon_String_Oliteral___Orderings_Opreorder_361,axiom,
    preorder(literal) ).

tff(tcon_String_Oliteral___Orderings_Olinorder_362,axiom,
    linorder(literal) ).

tff(tcon_String_Oliteral___Groups_Omonoid__add_363,axiom,
    monoid_add(literal) ).

tff(tcon_String_Oliteral___Orderings_Oorder_364,axiom,
    order(literal) ).

tff(tcon_String_Oliteral___Orderings_Oord_365,axiom,
    ord(literal) ).

tff(tcon_String_Oliteral___Groups_Ozero_366,axiom,
    zero(literal) ).

tff(tcon_String_Oliteral___Groups_Oplus_367,axiom,
    plus(literal) ).

tff(tcon_String_Oliteral___Nat_Osize_368,axiom,
    size(literal) ).

tff(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_369,axiom,
    semiri1453513574482234551roduct(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_370,axiom,
    topolo3112930676232923870pology(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_371,axiom,
    real_V8999393235501362500lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_372,axiom,
    real_V2822296259951069270ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_373,axiom,
    semiri6575147826004484403cancel(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_374,axiom,
    real_V4412858255891104859lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_375,axiom,
    real_V822414075346904944vector(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_376,axiom,
    topolo4958980785337419405_space(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_377,axiom,
    real_V3459762299906320749_field(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_378,axiom,
    real_V5047593784448816457lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_379,axiom,
    real_V768167426530841204y_dist(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_380,axiom,
    topolo5987344860129210374id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_381,axiom,
    semiri2026040879449505780visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_382,axiom,
    real_V2191834092415804123ebra_1(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_383,axiom,
    real_V8037385150606011577_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_384,axiom,
    topolo4211221413907600880p_mult(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_385,axiom,
    topolo7287701948861334536_space(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_386,axiom,
    topolo8386298272705272623_space(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_387,axiom,
    semiri3467727345109120633visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_388,axiom,
    real_V6157519004096292374lgebra(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_389,axiom,
    real_V7819770556892013058_space(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_390,axiom,
    topolo1287966508704411220up_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_391,axiom,
    real_V4867850818363320053vector(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_392,axiom,
    cancel2418104881723323429up_add(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ouniformity_393,axiom,
    topolo4638772830378233104ormity(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_394,axiom,
    ring_15535105094025558882visors(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_395,axiom,
    real_V7773925162809079976_field(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_396,axiom,
    topolo6943815403480290642id_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_397,axiom,
    cancel1802427076303600483id_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_398,axiom,
    comm_s4317794764714335236cancel(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Odist__norm_399,axiom,
    real_V6936659425649961206t_norm(complex) ).

tff(tcon_Complex_Ocomplex___Limits_Otopological__group__add_400,axiom,
    topolo1633459387980952147up_add(complex) ).

tff(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_401,axiom,
    topological_t2_space(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_402,axiom,
    cancel_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_403,axiom,
    real_Vector_banach(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_404,axiom,
    ab_semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_405,axiom,
    semiring_1_cancel(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_406,axiom,
    comm_monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_407,axiom,
    ab_semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_408,axiom,
    comm_monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_409,axiom,
    comm_semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_410,axiom,
    comm_semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_411,axiom,
    semigroup_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom__divide_412,axiom,
    semidom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Num_Osemiring__numeral_413,axiom,
    semiring_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Osemigroup__add_414,axiom,
    semigroup_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Odivision__ring_415,axiom,
    division_ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_416,axiom,
    comm_semiring(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_417,axiom,
    semiring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oab__group__add_418,axiom,
    ab_group_add(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield__char__0_419,axiom,
    field_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_420,axiom,
    zero_neq_one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_421,axiom,
    idom_abs_sgn(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__mult_422,axiom,
    monoid_mult(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom__divide_423,axiom,
    idom_divide(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_424,axiom,
    comm_ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Omonoid__add_425,axiom,
    monoid_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__1_426,axiom,
    semiring_1(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring__0_427,axiom,
    semiring_0(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ogroup__add_428,axiom,
    group_add(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Omult__zero_429,axiom,
    mult_zero(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Ocomm__ring_430,axiom,
    comm_ring(complex) ).

tff(tcon_Complex_Ocomplex___Num_Oneg__numeral_431,axiom,
    neg_numeral(complex) ).

tff(tcon_Complex_Ocomplex___Nat_Oring__char__0_432,axiom,
    ring_char_0(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemiring_433,axiom,
    semiring(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Oinverse_434,axiom,
    inverse(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Osemidom_435,axiom,
    semidom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ouminus_436,axiom,
    uminus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring__1_437,axiom,
    ring_1(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ominus_438,axiom,
    minus(complex) ).

tff(tcon_Complex_Ocomplex___Fields_Ofield_439,axiom,
    field(complex) ).

tff(tcon_Complex_Ocomplex___Power_Opower_440,axiom,
    power(complex) ).

tff(tcon_Complex_Ocomplex___Num_Onumeral_441,axiom,
    numeral(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Ozero_442,axiom,
    zero(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oplus_443,axiom,
    plus(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oring_444,axiom,
    ring(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Oidom_445,axiom,
    idom(complex) ).

tff(tcon_Complex_Ocomplex___Groups_Oone_446,axiom,
    one(complex) ).

tff(tcon_Complex_Ocomplex___Rings_Odvd_447,axiom,
    dvd(complex) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_448,axiom,
    condit6923001295902523014norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_449,axiom,
    counta4013691401010221786attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_450,axiom,
    condit1219197933456340205attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_451,axiom,
    counta3822494911875563373attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_452,axiom,
    comple592849572758109894attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_453,axiom,
    strict9044650504122735259up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_454,axiom,
    strict7427464778891057005id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_455,axiom,
    canoni5634975068530333245id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_456,axiom,
    bounde4967611905675639751up_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_457,axiom,
    bounde4346867609351753570nf_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_458,axiom,
    linord4140545234300271783up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_459,axiom,
    comple6319245703460814977attice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_460,axiom,
    linord181362715937106298miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_461,axiom,
    semiri3467727345109120633visors(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_462,axiom,
    ordere6658533253407199908up_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_463,axiom,
    ordere6911136660526730532id_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_464,axiom,
    ordere2520102378445227354miring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_465,axiom,
    semilattice_sup(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_466,axiom,
    semilattice_inf(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_467,axiom,
    ab_semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_468,axiom,
    comm_monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_469,axiom,
    ab_semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_470,axiom,
    ordered_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_471,axiom,
    comm_monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_472,axiom,
    comm_semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_473,axiom,
    comm_semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_474,axiom,
    semigroup_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_475,axiom,
    semiring_numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_476,axiom,
    semigroup_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_477,axiom,
    zero_less_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_478,axiom,
    comm_semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Owellorder_479,axiom,
    wellorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_480,axiom,
    order_top(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_481,axiom,
    order_bot(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_482,axiom,
    semiring_char_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_483,axiom,
    zero_neq_one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Opreorder_484,axiom,
    preorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Olinorder_485,axiom,
    linorder(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_486,axiom,
    monoid_mult(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_487,axiom,
    monoid_add(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_488,axiom,
    semiring_1(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_489,axiom,
    semiring_0(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Lattices_Olattice_490,axiom,
    lattice(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Omult__zero_491,axiom,
    mult_zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oorder_492,axiom,
    order(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Osemiring_493,axiom,
    semiring(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Orderings_Oord_494,axiom,
    ord(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ominus_495,axiom,
    minus(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Power_Opower_496,axiom,
    power(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Num_Onumeral_497,axiom,
    numeral(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Ozero_498,axiom,
    zero(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oplus_499,axiom,
    plus(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Groups_Oone_500,axiom,
    one(extended_enat) ).

tff(tcon_Extended__Nat_Oenat___Rings_Odvd_501,axiom,
    dvd(extended_enat) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_502,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( topolo4958980785337419405_space(A20)
        & topolo4958980785337419405_space(A21) )
     => topolo4958980785337419405_space(product_prod(A20,A21)) ) ).

tff(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_503,axiom,
    ! [A20: $tType,A21: $tType] :
      ( ( topological_t2_space(A20)
        & topological_t2_space(A21) )
     => topological_t2_space(product_prod(A20,A21)) ) ).

tff(tcon_Product__Type_Oprod___Nat_Osize_504,axiom,
    ! [A20: $tType,A21: $tType] : size(product_prod(A20,A21)) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_505,axiom,
    condit6923001295902523014norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_506,axiom,
    counta4013691401010221786attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_507,axiom,
    condit1219197933456340205attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__lattice_508,axiom,
    counta3822494911875563373attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_509,axiom,
    comple592849572758109894attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_510,axiom,
    bounde4967611905675639751up_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_511,axiom,
    bounde4346867609351753570nf_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_512,axiom,
    comple5582772986160207858norder(product_unit) ).

tff(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_513,axiom,
    comple6319245703460814977attice(product_unit) ).

tff(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_514,axiom,
    boolea8198339166811842893lgebra(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_515,axiom,
    semilattice_sup(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_516,axiom,
    semilattice_inf(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Owellorder_517,axiom,
    wellorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__top_518,axiom,
    order_top(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder__bot_519,axiom,
    order_bot(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Opreorder_520,axiom,
    preorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Olinorder_521,axiom,
    linorder(product_unit) ).

tff(tcon_Product__Type_Ounit___Lattices_Olattice_522,axiom,
    lattice(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oorder_523,axiom,
    order(product_unit) ).

tff(tcon_Product__Type_Ounit___Orderings_Oord_524,axiom,
    ord(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ouminus_525,axiom,
    uminus(product_unit) ).

tff(tcon_Product__Type_Ounit___Groups_Ominus_526,axiom,
    minus(product_unit) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_527,axiom,
    bit_un5681908812861735899ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_528,axiom,
    semiri1453513574482234551roduct(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_529,axiom,
    euclid5411537665997757685th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_530,axiom,
    euclid8789492081693882211th_nat(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_531,axiom,
    ordere1937475149494474687imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_532,axiom,
    euclid3128863361964157862miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_533,axiom,
    euclid4440199948858584721cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_534,axiom,
    unique1627219031080169319umeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_535,axiom,
    euclid8851590272496341667cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_536,axiom,
    semiri6575147826004484403cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_537,axiom,
    strict9044650504122735259up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_538,axiom,
    ordere580206878836729694up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_539,axiom,
    ordere2412721322843649153imp_le(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_540,axiom,
    bit_se359711467146920520ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_541,axiom,
    linord2810124833399127020strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_542,axiom,
    strict7427464778891057005id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_543,axiom,
    ordere8940638589300402666id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_544,axiom,
    euclid3725896446679973847miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_545,axiom,
    linord715952674999750819strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_546,axiom,
    linord4140545234300271783up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_547,axiom,
    bit_ri3973907225187159222ations(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_548,axiom,
    semiri2026040879449505780visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_549,axiom,
    linord181362715937106298miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_550,axiom,
    euclid5891614535332579305n_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_551,axiom,
    linord8928482502909563296strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_552,axiom,
    semiri3467727345109120633visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_553,axiom,
    ordere6658533253407199908up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_554,axiom,
    ordere166539214618696060dd_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_555,axiom,
    ordere6911136660526730532id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_556,axiom,
    linord5086331880401160121up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_557,axiom,
    cancel2418104881723323429up_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_558,axiom,
    ring_15535105094025558882visors(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_559,axiom,
    cancel1802427076303600483id_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_560,axiom,
    linord4710134922213307826strict(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_561,axiom,
    comm_s4317794764714335236cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_562,axiom,
    bit_semiring_bits(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_563,axiom,
    ordere2520102378445227354miring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_564,axiom,
    linord6961819062388156250ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_565,axiom,
    ordered_ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_566,axiom,
    cancel_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_567,axiom,
    linordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_568,axiom,
    ordered_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_569,axiom,
    linordered_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_570,axiom,
    ab_semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_571,axiom,
    semiring_1_cancel(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_572,axiom,
    algebraic_semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_573,axiom,
    comm_monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_574,axiom,
    ab_semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_575,axiom,
    ordered_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_576,axiom,
    ordered_ring_abs(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_577,axiom,
    semiring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_578,axiom,
    comm_monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_579,axiom,
    semiring_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_580,axiom,
    linordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_581,axiom,
    linordered_idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_582,axiom,
    comm_semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_583,axiom,
    comm_semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_584,axiom,
    semigroup_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_585,axiom,
    semidom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_586,axiom,
    semidom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_587,axiom,
    semiring_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_588,axiom,
    semigroup_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_589,axiom,
    zero_less_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_590,axiom,
    comm_semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_591,axiom,
    semiring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_592,axiom,
    ab_group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_593,axiom,
    zero_neq_one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_594,axiom,
    ordered_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_595,axiom,
    idom_abs_sgn(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_596,axiom,
    ring_parity(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_597,axiom,
    preorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_598,axiom,
    linorder(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_599,axiom,
    monoid_mult(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_600,axiom,
    idom_modulo(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_601,axiom,
    idom_divide(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_602,axiom,
    comm_ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_603,axiom,
    monoid_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_604,axiom,
    semiring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_605,axiom,
    semiring_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_606,axiom,
    group_add(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_607,axiom,
    mult_zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_608,axiom,
    comm_ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oorder_609,axiom,
    order(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_610,axiom,
    neg_numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_611,axiom,
    ring_char_0(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemiring_612,axiom,
    semiring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Osemidom_613,axiom,
    semidom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Orderings_Oord_614,axiom,
    ord(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ouminus_615,axiom,
    uminus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring__1_616,axiom,
    ring_1(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_617,axiom,
    abs_if(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ominus_618,axiom,
    minus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Power_Opower_619,axiom,
    power(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Num_Onumeral_620,axiom,
    numeral(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Ozero_621,axiom,
    zero(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oplus_622,axiom,
    plus(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oring_623,axiom,
    ring(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Oidom_624,axiom,
    idom(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Groups_Oone_625,axiom,
    one(code_integer) ).

tff(tcon_Code__Numeral_Ointeger___Rings_Odvd_626,axiom,
    dvd(code_integer) ).

tff(tcon_VEBT__Definitions_OVEBT___Nat_Osize_627,axiom,
    size(vEBT_VEBT) ).

% Helper facts (3)
tff(help_fequal_2_1_T,axiom,
    ! [A: $tType,X16: A,Y: A] :
      ( ( X16 != Y )
      | aa(A,$o,aa(A,fun(A,$o),fequal(A),X16),Y) ) ).

tff(help_fequal_1_1_T,axiom,
    ! [A: $tType,X16: A,Y: A] :
      ( ~ aa(A,$o,aa(A,fun(A,$o),fequal(A),X16),Y)
      | ( X16 = Y ) ) ).

tff(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: fun(A,$o)] :
      ( aa(A,$o,P,fChoice(A,P))
      = ( ? [X9: A] : aa(A,$o,P,X9) ) ) ).

% Free types (2)
tff(tfree_0,hypothesis,
    real_V4867850818363320053vector(a) ).

tff(tfree_1,hypothesis,
    semiring_1(a) ).

% Conjectures (3)
tff(conj_0,hypothesis,
    ! [N3: nat] :
      ( ( x = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),N3) )
     => thesis ) ).

tff(conj_1,hypothesis,
    ! [N3: nat] :
      ( ( x = aa(nat,nat,aa(nat,fun(nat,nat),plus_plus(nat),N3),aa(nat,nat,suc,N3)) )
     => thesis ) ).

tff(conj_2,conjecture,
    thesis ).

%------------------------------------------------------------------------------
